!-----------------------------------------------------------------------------!
! This file is part of the official HFODD v2.XX release and lists all options !
! available in HFODD (sequential data), together with their preset values     !
!-----------------------------------------------------------------------------!

                      ----  General data and iterations ---
NUCLIDE      IN_FIX  IZ_FIX
               8      0
ITERATIONS   NOITER
              20
ITERAT_EPS   EPSITE
              1.D-5
MAXANTIOSC   NULAST
               3
SLOW_DOWN    SLOWEV  SLOWOD
              0.4     0.5
PING-PONG    EPSPNG  NUPING
              0.0      10
CHAOTIC      NUCHAO
               10

                      --------  Specific features  --------
INSERT-HO    IPOTHO
               1

                      -----------  Interaction  -----------
SKYRME-STD   ISTAND  KETA_J  KETA_W  KETACM  KETA_M
               1       1       0       0       0
SKYRME-SET   SKYRME
            MINN
GOGNY        I_GOGA
               2
GOGNY_SET    GOGNAM
            MINN
COULOMB      NUMCOU  NUMETA  FURMAX
               80      79     0.25
COULOMBPAR   ICOTYP  ICOUDI  ICOUEX
               7       0       0

                     -----------  Symmetries  -------------
SPHERICAL    ISPHER
               0
ROTATION     IROTAT
               0
SIMPLEXY     ISIMPY
               1
SIGNATUREY   ISIGNY
               1
PARITY       IPARTY
               -1
TSIMPLEX3D   ISIMTX  ISIMTY  ISIMTZ
               1       -1       1
TSIMPLEX_Y   ISIMTY
               -1
TSIMPLEXES   ISIMTX  ISIMTZ
               1       1
TIMEREPAIR   ITIREP
               0

                      -----  HF Vacuum Configurations  ----
VACSIG_NEU  KVASIG: PPSP, PPSM, PMSP, PMSM
                      1     1     3     3
VACSIG_PRO  KVASIG: PPSP, PPSM, PMSP, PMSM
                      0     0     0     0

                     ----  Parameters of the HO basis  ----
BASIS_SIZE   NOSCIL  NLIMIT  ENECUT
              6       84    800.0
HOMEGAZERO   FCHOM0
              0.2439024390243902439
              0.4878048780487804878
SURFAC_PAR   INNUMB  IZNUMB  R0PARM
                8      0     1.23
SURFAC_DEF   LAMBDA   MIU    ALPHAR
               -2      0      0.0
                4      0      0.0
OPTI-GAUSS   IOPTGS
               1

                     -------- Multipole moments  ----------
MAX_MULTIP   NMUCON  NMUCOU  NMUPRI
                2      2       2
MULTCONSTR   LAMBDA   MIU    STIFFQ  QASKED  IFLAGQ
                2      0      2.0     0.00     0

                     --------  Angular Momentum  ----------
OMEGAY       OMEGAY
              0.00

                     ------  Output-file  parameters  -----
ONE_LINE     I1LINE
               1
EALLMINMAX   EMINAL  EMAXAL
              -50.0   20.0
EQUASI_MAX   EMAXQU
              +50.0
NILSSONLAB   NILXYZ
               3

                     ------------  I/O Flags  -------------
RECORDSAVE   IWRIRE
               1
REVIEW       IREVIE
               2
COULOMSAVE   ICOULI  ICOULO
               0      0

                     ------------  I/O Files  -------------
RECORDFILE   FILREC
            HFODD.REC
REPLAYFILE   FILREP
            HFODD.REP
RECGOGFILE   FILGOC
            HFODD.GOC
REPGOGFILE   FILGOP
            HFODD.GOP
REVIEWFILE   FILREV
            HFODD.REV
COULOMFILE   FILCOU
            HFODD.COU

                     ------  Starting the iteration  ------
RESTART      ICONTI
               0
CONTGOGNY    IGCONT
               0

                     ------------  Calculate  -------------
EXECUTE
                     ------------  Terminate  -------------
ALL_DONE
