C FILE NAME = wsu01_main_06.f   ! Keep this symbol here: $ident@string$
C
C=======================================================================
C
C       PROGRAM 'FIND_DEFORMS' FINDS THE DEFORMATION OF THE NUCLEAR
C       SURFACE SUCH THAT THE  MULTIPOLE MOMENTS  COMPUTED FROM THE
C       SOLUTION TO THE  SCHROEDINGER  EQUATION WITH A  WOODS-SAXON
C       POTENTIAL MATCHES THE REQUESTED VALUES.
C
C=======================================================================
C
      PROGRAM FIND_DEFORMS
C=======================================================================
      USE params
C=======================================================================
      CHARACTER
     *          FILE_P*256,FILE_N*256,FILEDF*256,SELPAR*20
      CHARACTER
     *          FILWOO*68
      CHARACTER
     *          N_ONLY*3,P_ONLY*3,VERSIO*5
C
      COMPLEX
     *          ALSTRT,ALSTEP,ALMINI,ALMAXI
      COMPLEX
     *          ALPHAC(0:NDLAMB,-NDLAMB:+NDLAMB),
     *          ALINI0(0:NDLAMB,-NDLAMB:+NDLAMB)
C
      DIMENSION
     *          QMOMUL(0:NDMULT,-NDMULT:NDMULT),
     *          ASKMUL(0:NDMULT,-NDMULT:NDMULT)
      DIMENSION
     *          APPBET(1:NDMULT,-NDMULT:NDMULT)
C
      DIMENSION
     *          OMEGAX(0:NDOMEG),OMEGAY(0:NDOMEG),
     *          OMEGAZ(0:NDOMEG)
      DIMENSION
     *          ARGPAR(1:NDSEAR)
C
C      Same common block as Standard WSODD (wsu01_main05.f)
C
      COMMON
     *       /NUCLEONIC_NUM/ IZ_ACT,IN_ACT
      COMMON
     *       /MULTIPOLE_LMU/ IFMULT,MAXMUL,NOFLEV,IINDIV,LAMIND,MIUIND
      COMMON
     *       /NUCLEONIC_YES/ P_ONLY,N_ONLY
     *       /NUCLEONIC_PAR/ SELPAR
      COMMON
     *       /SIGNATURE_FIX/ ISIGNY,IAUTOM
      COMMON
     *       /ALPHACMUL_DEF/ ALPHAC
     *       /REALALMUL_DEF/ IREALA
      COMMON
     *       /DEFORMATN_INP/ FILEDF
     *       /CHOOSEFIL_OUT/ NAMEFI
      COMMON
     *       /READDF_LAMMAX/ LAMMAX,LMXBAS,LMXDEF,LMXMUL
      COMMON
     *       /READWRITE_PAR/ NOUTPT,IWRITE,ISCREN
      COMMON
     *       /INITWS_NUMBRS/ PINUMB,PIOVE2
      COMMON
     *       /PARAMS_R0PARM/ R0PARM
C
C      Deformations
C
      COMMON
     *       /DEFUNI_OURUNI/ QUNITS(0:NDMULT,0:NDMULT)
      COMMON
     *       /DEFMIN_QCNSTR/ STIFFQ(0:NDMULT,-NDMULT:NDMULT),
     *                       QASKED(0:NDMULT,-NDMULT:NDMULT),
     *                       IFLAGQ(0:NDMULT,-NDMULT:NDMULT)
      COMMON
     *       /DEFMIN_STARTS/ ALSTRT(0:NDLAMB,-NDLAMB:+NDLAMB),
     *                       ALSTEP(0:NDLAMB,-NDLAMB:+NDLAMB),
     *                       ALMINI(0:NDLAMB,-NDLAMB:+NDLAMB),
     *                       ALMAXI(0:NDLAMB,-NDLAMB:+NDLAMB)
      COMMON
     *       /DEFMIN_VARIAB/ I_STEP(0:NDLAMB,-NDLAMB:+NDLAMB)
C
C      Filling in common blocks of inputs to WSEXEC (which is called
C      within function TOTENE, itself called within the minimization
C      block
C
      COMMON
     *       /HFBASE_BASE_2/ BASEX2,BASEY2,BASEZ2
      COMMON
     *       /SETBAS_DIMENS/ LDBASE
      COMMON
     *       /PARAMS_RADVOL/ RADIUS,CVOLFC,RCVOLM
      COMMON
     *       /NOSCILCUT_ENE/ ENECUT,FCHOM0
     *       /NOSCILCUT_NOS/ NOSCIL,NLIMIT,ISOTRO
      COMMON
     *       /GAUSSINTG_HER/ NXHERM,NYHERM,NZHERM,IOPTGS
     *       /GAUSSINTG_EPS/ EPSHER
      COMMON
     *       /MAINPR_NUCLEU/ IZ_FIX,IN_FIX
     *       /MAINPR_FILENS/ FILE_P,FILE_N
     *       /MAINPR_OMEGAS/ OMEGAT(0:NDOMEG),OMEGA3(0:NDOMEG)
     *       /MAINPR_NOFOME/ NOFOME
     *       /MAINPR_VERSIO/ VERSIO
C
C      Various common blocks used here and there in the program
C
      COMMON
     *       /MINIMI_TYPMIN/ I_MODE
     *       /MINIMI_ABORTG/ IABORT
     *       /MINIMI_MINITE/ IDEFCN,ITECHI,IWRIMI
     *       /MINIMI_LOOPIN/ I_LOOP
     *       /MINIMI_OUTPUT/ NFIPRI
      COMMON
     *       /MINIMI_MINIMI/ STEPMX,TOLFUN,TOLDLX,TOLGRD,
     *                       EPSILO,FRACTI,GRADLM,ITRMAX
      COMMON
     *       /EXPECTED_QVAL/ QEXPEC(0:NDSEAR)
     *       /EXPECTED_LMIU/ LEXPEC(0:NDSEAR),MEXPEC(0:NDSEAR)
     *       /EXPECTED_SIZE/ LD_MUL
C
C=======================================================================
C
C     According to principles  of the modular version  of the code
C     the user controls the input from data file(s) and the output
C     from this MAIN program.  All the technicalities of execution
C     are in principle  hidden from the user. Moreover,  all other
C     packages such as shell-correction, plotting, 3D cranking etc
C     can be connected  by merely calling  the corresponding modul
C     head routine within this main program.
C
C=======================================================================
C
      CALL WS_CPUTIM('WSUNIV',1)
C
C======================================================================
C     Initialising default values and reading the user input
C=======================================================================
C
      CALL WS_PREDEF(NOFOME,OMEGAX,OMEGAY,OMEGAZ)
C
      IZ_FIX=IZ_ACT
      IN_FIX=IN_ACT
C
      ND_OMG=NDOMEG
C
      MDGAUS=MAX(NDXHRM,NDYHRM,NDZHRM,2*NDOSGS+3)
C
      CALL WS_SHOWOF(NDGAUS,MDGAUS,NDZHRM,NDOSGS,VERSIO)
C
      PINUMB=4.0000*ATAN(1.0)
      PIOVE2=PINUMB/2.0000000
C
C      Reading the actual data for one single run
C
      CALL WS_NAMELI(IZ_ACT,IN_ACT,NOFOME,OMEGAX,OMEGAY,OMEGAZ,
     *               OMEGA3,P_ONLY,N_ONLY,FILE_P,FILE_N,SELPAR,
     *                                                  LASTDF)
C
C      Setting the numerical factors for calculating Y_(lm). We have 3
C      sources of usage for Ylm:
c        - the WS basis: LMXBAS
C        - the WS nuclear surface: LMXDEF
C        - the multipole moments: LMXMUL
C      LAMMAX is initialized to the maximum of all these 3 integers
C
      LAMAUX=MAX(LMXBAS,LMXDEF)
      LAMAX1=MAX(LAMAUX,LMXMUL)
      MAXYLM=MAX(LAMAX1,MAXMUL)
      LAMMAX=MAXYLM
C
C=======================================================================
C
C      Defining multipole moment units in HFODD
C
      CALL WS_DEFUNI(MAXYLM)
C
C      Q_00 is by definition the number of particles
C
      A_MASS=REAL(IZ_FIX+IN_FIX)
      DATRMS=R0PARM*A_MASS**(1.0/3.0)
C
      QASKED(0,0)=A_MASS
C
C      Adding units because the routine WS_APPDEF will remove them...
C
      DO LAMBDA=0,LMXDEF
         DO MIU=0,LAMBDA
            QMOMUL(LAMBDA,-MIU)=QASKED(LAMBDA,MIU)
            QMOMUL(LAMBDA, MIU)=QASKED(LAMBDA,MIU)
         END DO
      END DO
C
C      Computing first-order approximations APPBET of the multipole
C      moments QMOMUL
C
      CALL WS_APPDEF(LMXDEF,DATRMS,QMOMUL,APPDEN,APPRAD,APPBET)
C
      I_SEAR=0
C
C      Setting the initial values of the nuclear surface deformation
C
      DO LAMBDA=1,LMXDEF
         DO MIU=1,LAMBDA,2
            IF (I_STEP(LAMBDA,MIU).EQ.1) MU_ODD=1
         END DO
      END DO
C
      DO LAMBDA=0,LMXDEF
         DO MIU=0,LAMBDA
C
            IF (I_STEP(LAMBDA,MIU).EQ.1) THEN
C
                IF (ABS(QASKED(LAMBDA,MIU)).GT.1.E-10) THEN
C
                    ALSTRT(LAMBDA,MIU)=APPBET(LAMBDA,MIU)
C
                ELSE

                    ALSTRT(LAMBDA,MIU)=CMPLX(0.01,0.0)
C
                END IF
C
                I_SEAR=I_SEAR+1
                ARGPAR(I_SEAR)=REAL(ALSTRT(LAMBDA,MIU))
C
            END IF
C
         END DO
      END DO
C
C      If odd multipoles are present, we face the c-o-m problem:
C      non-zero alpha_30 induce a shift of the center of mass, which
C      we mus must initialize it with a good guest correct. This implies that alpha_10 has to be non-zero,
C      and wes
C
c      IF (MU_ODD.EQ.1) THEN
C
c          PIARGU=4.0*ATAN(1.0)
c          RHOSHA=0.16
c          SHAFAC=1.0
cC
c          Q10IND =  -2.0**PIARGU*RHOSHA*SHAFAC**4
c     *                     *SQRT(21.0/(64.0*PIARGU**2))
c     *                * ( -8.0/3.0 + 153.0 * REAL(ALSTRT(3,0))**2
c     *                    /(55.0*PIARGU) ) * REAL(ALSTRT(3,0))
cC
c          X1= 50.0
c          X2=100.0
c          X3=150.0
cC
c	  Y1=0.60
c	  Y2=1.00
c	  Y3=0.14
cC
c          CALL INTER2(X1,X2,X3,Y1,Y2,Y3,A,B,C)
cC
c          FACTOR = - ( 5.0*QMOMUL(2,0)/3000.0+1.0/6.0 )
c     *             * (   A*QMOMUL(3,0)**2 + B*QMOMUL(3,0) + C)
c          FACTO2 = 1.0
c          FACTO3 = 1.0
cC
c	  IF (ABS(QMOMUL(3,0)).GT.100.0) THEN
cC
c	      FACTOR = FACTOR*EXP(-((QMOMUL(3,0)-100.0)/200.0)**2)
c	      FACTO2 =        EXP(-((QMOMUL(3,0)-100.0)/20.0)**2)
c	      FACTO3 =        EXP(- ABS(QMOMUL(3,0)-150.0)/10.0)
cC
c          END IF
cC
c          IF (Q10IND.LE.0.0) FACTOR=+ABS(FACTOR)
c          IF (Q10IND.GT.0.0) FACTOR=-ABS(FACTOR)
cC
c      write(6,'(''Q10IND = '',f12.5,'' FACTOR = '',f12.5)')
c     *            Q10IND,FACTOR
cC
c          ALSTRT(1,0) = FACTOR*SQRT(4.0*PIARGU/3.0)*Q10IND
c     *                * CMPLX(1.0,0.0)
cC
cC          Empirical re-adjustment of alpha_20 and alpha_30
cC
c          ALSTRT(2,0) = ALSTRT(2,0) + ALSTRT(1,0)*FACTO2
c          ALSTRT(3,0) = ALSTRT(3,0) + ALSTRT(1,0)*FACTO3
C
c      END IF
C
      DO LAMBDA=0,LMXDEF
         DO MIU=1,LAMBDA
            ALSTRT(LAMBDA,-MIU)=(-1)**MIU*CONJG(ALSTRT(LAMBDA,MIU))
         END DO
      END DO
C
      DO LAMBDA=0,NDLAMB
         DO MIU=-NDLAMB,NDLAMB
            ALPHAC(LAMBDA,MIU)=ALSTRT(LAMBDA,MIU)
         END DO
      END DO
C
C      Setting the numerical factors for calculating Y_(lm). We have 3
C      sources of usage for Ylm:
c        - the WS basis: LMXBAS
C        - the WS nuclear surface: LMXDEF
C        - the multipole moments: LMXMUL
C      LAMMAX is initialized to the maximum of all these 3 integers
C
      CALL WS_LOADIN(MAXYLM)
C
C      Verifying whether the y-signature is conserved
C
      CALL WS_TESIGN(ISIGNY,IAUTOM,ALPHAC,NDLAMB)
C
C      Counting how many multipole moments are used as constraints,
C      and therefore how many terms the chi2 contains. Storing which
C      moments are active constraints, and their value.
C
      LD_MUL=0
C
      DO LAMBDA=0,LMXDEF
         DO MIU=0,LAMBDA
C
            IF (IFLAGQ(LAMBDA,MIU).EQ.1) THEN
C
            	LD_MUL=LD_MUL+1
C
            	QEXPEC(LD_MUL)=QASKED(LAMBDA,MIU)
            	LEXPEC(LD_MUL)=LAMBDA
            	MEXPEC(LD_MUL)=MIU
C
            END IF
C
         END DO
      END DO
C
C      If HF potential is used to construct the actual mean-field,
C      we read the HFODD record file here. The potential is stored
C      in VN_CEN and VP_CEN for neutrons and protons respectively
C
      IHFPOT=0
C
      IF (IHFPOT.EQ.1) CALL WS_SPECIA()
C
C      Actually minimizing the chi2 of the requested multipole vs. the
C      actual GEOMETRICAL multipoles...
C
      ITEOLD=ITECHI
      STPOLD=STEPMX
C
      I_MODE=1
      IABORT=0
      ITECHI=100
      STEPMX=0.075
C
      CALL WS_DEFDEF(IZ_FIX,IN_FIX,ARGPAR)
C
C      ... the deformation of the surface obtained in the previous
C      minimization is used as starting point for the next job:
C      minimizing the deviations to the expectation value of the
C      multipole moments on the WS eigenstates.
C
      ITECHI=ITEOLD
      STEPMX=STPOLD
C
C      Setting the initial values of the nuclear surface deformation
C
      DO LAMBDA=0,LMXDEF
         DO MIU=0,LAMBDA
            IF (I_STEP(LAMBDA,MIU).EQ.1) THEN
                ALSTRT(LAMBDA,MIU)=ALPHAC(LAMBDA,MIU)
            END IF
         END DO
      END DO
C
      I_MODE=2
      IABORT=0
C
      CALL WS_DEFDEF(IZ_FIX,IN_FIX,ARGPAR)
C
C      These quantities are computed properly by the WS code but are not
C      used by HFODD -> it does not matter if they are set to 0 here
C
      CMSXFC=0.0
      CMSYFC=0.0
      CMSZFC=0.0
C
      XMOMFC=0.0
      YMOMFC=0.0
      ZMOMFC=0.0
C
      HOMEGA=0.0
C
C      Printing out the moments at the solution
C
      OMEGAC=0.0
      KRANKI=0
C
      IWRITE=1
C
      CALL WS_DEFPRI(LMXDEF,IZ_FIX,IN_FIX)
C
                            ISOSPI=0
      CALL WS_MOMPRI(MAXMUL,ISOSPI,IFMULT,OMEGAC,KRANKI)
C
                            ISOSPI=1
      CALL WS_MOMPRI(MAXMUL,ISOSPI,IFMULT,OMEGAC,KRANKI)
C
C      Writing binary files on disk
C
      FILWOO='wsodd.bin'
C
      CALL WS_WRIBIN(IZ_FIX,IN_FIX,FCHOM0,R0PARM,HOMEGA,
     *                             EPSHER,ENECUT,CVOLFC,
     *                             CMSXFC,CMSYFC,CMSZFC,
     *                             XMOMFC,YMOMFC,ZMOMFC,
     *                             BASEX2,BASEY2,BASEZ2,
     *                             ALPHAC,IREALA,LDBASE,
     *                                           FILWOO)
C
C=======================================================================
C
      CALL WS_TIMPRI
C
C=======================================================================
C
      STOP 'ALLRIGHT'
      END
C
C=======================================================================
C
      SUBROUTINE WS_APPDEF(NAPBET,DATRMS,QMOMUL,
     *                     APPDEN,APPRAD,APPBET)
C=======================================================================
      USE params
C=======================================================================
      DIMENSION
     *          QMOMUL(0:NDMULT,-NDMULT:NDMULT),
     *          ASKMUL(0:NDMULT,-NDMULT:NDMULT)
      DIMENSION
     *          APPBET(1:NDMULT,-NDMULT:NDMULT)
C
      COMMON
     *       /DEFUNI_OURUNI/ QUNITS(0:NDMULT,0:NDMULT)
C
C=======================================================================
C THIS SUBROUTINE FINDS THE BOHR DEFORMATION PARAMETERS
C WITHIN THE LINEAR APPROXIMATION
C=======================================================================
C
      SQR4PI=SQRT(16.D0*ATAN(1.D0))
C
C=======================================================================
C REMOVING UNITS
C=======================================================================
C
      DO LAM=0,NAPBET
         DO MIU=-LAM,LAM
            ASKMUL(LAM,MIU)=QMOMUL(LAM,MIU)/QUNITS(LAM,IABS(MIU))
         END DO
      END DO
C
      ASKSUR=SQR4PI*ASKMUL(0,0)*DATRMS**2
      ASKRAD=SQRT(5.*ASKSUR/(3.*SQR4PI*ASKMUL(0,0)))
      ASKDEN=3*ASKMUL(0,0)/(SQR4PI*ASKRAD**3)
C
C=======================================================================
C CALCULATING LINEAR APPROXIMATION TO BETAS
C=======================================================================
C
      APPRAD=ASKRAD
      APPDEN=ASKDEN
      FACTOR=APPDEN*APPRAD**4
      DO LAM=1,NAPBET
         DO MIU=-LAM,LAM
            APPBET(LAM,MIU)=ASKMUL(LAM,MIU)/FACTOR
         END DO
         FACTOR=FACTOR*APPRAD
      END DO
C
C=======================================================================
C MULTIPLYING NON-AXIAL BETAS BY SQUARE ROOT OF TWO
C=======================================================================
C
      DO LAM=1,NAPBET
         DO MIU=1,LAM
           APPBET(LAM, MIU)=APPBET(LAM, MIU)*SQRT(2.)
           APPBET(LAM,-MIU)=APPBET(LAM,-MIU)*SQRT(2.)
         END DO
      END DO
C
C=======================================================================
C
      RETURN
      END

