C FILE NAME = wsu01_rout_06.f   ! Keep this symbol here: $ident@string$
C
C=======================================================================
C
C       SUBROUTINE  'WS_UNIVERSAL'  IS CALLED FROM THE  HFODD  PROGRAM
C       IN ORDER TO FIND THE  DEFORMATIONS OF THE NUCLEAR SURFACE SUCH
C       THAT THE  MULTIPOLE  MOMENTS  COMPUTED  FROM  THE  SOLUTION TO
C       THE SCHROEDINGER EQUATION WITH A WOODS-SAXON POTENTIAL MATCHES
C       THE REQUESTED VALUES.
C
C=======================================================================
C
      SUBROUTINE WS_UNIVERSAL(INNEUT,IZPROT,FCH_HF,R0P_HF,NOS_HF,
     *                               NLI_HF,NXH_HF,NYH_HF,NZH_HF,
     *                               ALPHAR,NDLINP,IFLAGQ,QASKED,
     *                               NUMINP,LMXINP,LAMINP,MIUINP,
     *                               ITEINP,STPINP,FILWOO,N_UNIT,
     *                               D3N_WS,D3P_WS,IHFPOT,ISIGHF)
C=======================================================================
      USE params
C=======================================================================
      CHARACTER
     *          FILE_P*256,FILE_N*256,FILEDF*256,SELPAR*20
      CHARACTER
     *          FILWOO*68
      CHARACTER
     *          N_ONLY*3,P_ONLY*3,VERSIO*5
C
      COMPLEX
     *          ALSTRT,ALSTEP,ALMINI,ALMAXI,BETBAS
      COMPLEX
     *          ALPHAC(0:NDLAMB,-NDLAMB:+NDLAMB)
C
C      Input/Output arrays from/to HFODD: deformation of the nuclear
C      surface (ALPHAR), constraints (QASKED, IFLAGQ), list of lambda
C      and miu of the constraints
C
      DIMENSION
     *          ALPHAR(0:NDLINP,0:+NDLINP)
      DIMENSION
     *          QASKED(0:NDMULT,-NDMULT:NDMULT)
      DIMENSION
     *          IFLAGQ(0:NDMULT,-NDMULT:NDMULT)
      DIMENSION
     *          LAMINP(1:NDSEAR),MIUINP(1:NDSEAR)
C
      DIMENSION
     *          QMOMUL(0:NDMULT,-NDMULT:NDMULT)
      DIMENSION
     *          APPBET(1:NDMULT,-NDMULT:NDMULT)
C
      DIMENSION
     *          OMEGAX(0:NDOMEG),OMEGAY(0:NDOMEG),
     *          OMEGAZ(0:NDOMEG)
      DIMENSION
     *          ARGPAR(1:NDSEAR)
C
C      Same common block as Standard WSODD (wsu01_main05.f)
C
      COMMON
     *       /NUCLEONIC_NUM/ IZ_ACT,IN_ACT
      COMMON
     *       /MULTIPOLE_LMU/ IFMULT,MAXMUL,NOFLEV,IINDIV,LAMIND,MIUIND
      COMMON
     *       /NUCLEONIC_YES/ P_ONLY,N_ONLY
     *       /NUCLEONIC_PAR/ SELPAR
      COMMON
     *       /SIGNATURE_FIX/ ISIGNY,IAUTOM
      COMMON
     *       /ALPHACMUL_DEF/ ALPHAC
     *       /REALALMUL_DEF/ IREALA
      COMMON
     *       /DEFORMATN_INP/ FILEDF
     *       /CHOOSEFIL_OUT/ NAMEFI
      COMMON
     *       /READDF_LAMMAX/ LAMMAX,LMXBAS,LMXDEF,LMXMUL
      COMMON
     *       /READWRITE_PAR/ NOUTPT,IWRITE,ISCREN
      COMMON
     *       /INITWS_NUMBRS/ PINUMB,PIOVE2
      COMMON
     *       /PARAMS_R0PARM/ R0PARM
C
C      Deformations
C
      COMMON
     *       /HFBASE_DEFORM/ BETBAS(0:NDLAMB,-NDLAMB:NDLAMB)
      COMMON
     *       /DEFUNI_OURUNI/ QUNITS(0:NDMULT,0:NDMULT)
      COMMON
     *       /DEFMIN_STARTS/ ALSTRT(0:NDLAMB,-NDLAMB:+NDLAMB),
     *                       ALSTEP(0:NDLAMB,-NDLAMB:+NDLAMB),
     *                       ALMINI(0:NDLAMB,-NDLAMB:+NDLAMB),
     *                       ALMAXI(0:NDLAMB,-NDLAMB:+NDLAMB)
      COMMON
     *       /DEFMIN_VARIAB/ I_STEP(0:NDLAMB,-NDLAMB:+NDLAMB)
      COMMON
     *       /MINIMI_MINIMI/ STEPMX,TOLFUN,TOLDLX,TOLGRD,
     *                       EPSILO,FRACTI,GRADLM,ITRMAX
C
C      Filling in common blocks of inputs to WSEXEC (which is called
C      within function TOTENE, itself called within the minimization
C      block
C
      COMMON
     *       /HFBASE_BASE_2/ BASEX2,BASEY2,BASEZ2
      COMMON
     *       /SETBAS_DIMENS/ LDBASE
      COMMON
     *       /PARAMS_RADVOL/ RADIUS,CVOLFC,RCVOLM
      COMMON
     *       /NOSCILCUT_ENE/ ENECUT,FCHOM0
     *       /NOSCILCUT_NOS/ NOSCIL,NLIMIT,ISOTRO
      COMMON
     *       /GAUSSINTG_HER/ NXHERM,NYHERM,NZHERM,IOPTGS
     *       /GAUSSINTG_EPS/ EPSHER
      COMMON
     *       /MAINPR_NUCLEU/ IZ_FIX,IN_FIX
     *       /MAINPR_FILENS/ FILE_P,FILE_N
     *       /MAINPR_OMEGAS/ OMEGAT(0:NDOMEG),OMEGA3(0:NDOMEG)
     *       /MAINPR_NOFOME/ NOFOME
     *       /MAINPR_VERSIO/ VERSIO
C
C      Various common blocks used here and there in the program
C
      COMMON
     *       /MINIMI_TYPMIN/ I_MODE
     *       /MINIMI_ABORTG/ IABORT
     *       /MINIMI_MINITE/ IDEFCN,ITECHI,IWRIMI
     *       /MINIMI_LOOPIN/ I_LOOP
     *       /MINIMI_OUTPUT/ NFIPRI
      COMMON
     *       /EXPECTED_QVAL/ QEXPEC(0:NDSEAR)
     *       /EXPECTED_LMIU/ LEXPEC(0:NDSEAR),MEXPEC(0:NDSEAR)
     *       /EXPECTED_SIZE/ LD_MUL
C
      COMMON
     *       /WAPSTR_EXPDEL/ DELT3N(1:NDPROT,1:NDNEUT),
     *                       DELT3P(1:NDPROT,1:NDNEUT)
      COMMON
     *       /HF_MEAN_FIELD/ KHFPOT
C
C=======================================================================
C
C     According to principles  of the modular version  of the code
C     the user controls the input from data file(s) and the output
C     from this MAIN program.  All the technicalities of execution
C     are in principle  hidden from the user. Moreover,  all other
C     packages such as shell-correction, plotting, 3D cranking etc
C     can be connected  by merely calling  the corresponding modul
C     head routine within this main program.
C
C=======================================================================
C
      CALL WS_CPUTIM('WSUNIV',1)
C
C=======================================================================
C     Initialising default values and reading the user input
C=======================================================================
C
      CALL WS_INIOUT()
C
      CALL WS_PREDEF(NOFOME,OMEGAX,OMEGAY,OMEGAZ)
C
      IZ_FIX=IZ_ACT
      IN_FIX=IN_ACT
C
      ND_OMG=NDOMEG
C
      MDGAUS=MAX(NDXHRM,NDYHRM,NDZHRM,2*NDOSGS+3)
C
      CALL WS_SHOWOF(NDGAUS,MDGAUS,NDZHRM,NDOSGS,VERSIO)
C
      PINUMB=4.0000*ATAN(1.0)
      PIOVE2=PINUMB/2.0000000
C
C      Overwriting default setttings (done in WS_PREDEF) by input from
C      HFODD contained in header variables
C
      IZ_FIX=IZPROT
      IN_FIX=INNEUT
C
      IZ_ACT=IZPROT
      IN_ACT=INNEUT
C
      NOSCIL=NOS_HF
      NLIMIT=NLI_HF
C
      IOPTGS=0
      NXHERM=NXH_HF
      NYHERM=NYH_HF
      NZHERM=NZH_HF
C
      FCHOM0=FCH_HF
      R0PARM=R0P_HF
C
      ISIGNY=ISIGHF
C
      KHFPOT=IHFPOT
C
      NFIPRI=N_UNIT
C
C      Set the deformation of the WS basis to be the same as that of
C      the HF basis
C
      LMXBAS=0
C
      DO LAMBDA=0,NDLAMB
         DO MIU=0,LAMBDA
C
            BETBAS(LAMBDA, MIU) = ALPHAR(LAMBDA,MIU)
     *                           *CMPLX(1.0,0.0)
            BETBAS(LAMBDA,-MIU) = ALPHAR(LAMBDA,MIU)*(-1)**MIU
     *                           *CMPLX(1.0,0.0)
C
	    IF (ABS(BETBAS(LAMBDA,MIU)).GT.1.E-10) LMXBAS=LAMBDA
C
         END DO
      END DO
C
      LAMAX1=MAX(LMXBAS,LMXINP)
      MAXYLM=MAX(LAMAX1,MAXMUL)
      LAMMAX=MAXYLM
C
C      Defining up here how far we go in lambda (maximum multipolarity
C      of the deformation parameter of the physical surface is LMXDEF
C      in WSODD), and what deformations do we include in the minimization.
C
      LMXDEF=LMXINP
C
      DO I_SEAR=1,NUMINP
C
         LAMACT=LAMINP(I_SEAR)
         MIUACT=MIUINP(I_SEAR)
C
         I_STEP(LAMACT,MIUACT)=1
C
      END DO
C
      ITECHI=ITEINP
      STEPMX=STPINP
C
C=======================================================================
C
C      Defining multipole moment units in HFODD
C
      CALL WS_DEFUNI(MAXYLM)
C
C      Q_00 is by definition the number of particles
C
      A_MASS=REAL(IZ_FIX+IN_FIX)
      DATRMS=R0PARM*A_MASS**(1.0/3.0)
C
      QASKED(0,0)=A_MASS
C
C      Adding units because the routine WS_APPDEF will remove them...
C
      DO LAMBDA=0,LMXDEF
         DO MIU=0,LAMBDA
            QMOMUL(LAMBDA,-MIU)=QASKED(LAMBDA,MIU)
            QMOMUL(LAMBDA, MIU)=QASKED(LAMBDA,MIU)
         END DO
      END DO
C
C      Computing first-order approximations APPBET of the multipole
C      moments QMOMUL
C
      CALL WS_APPDEF(LMXDEF,DATRMS,QMOMUL,APPDEN,APPRAD,APPBET)
C
      I_SEAR=0
C
C      Setting the initial values of the nuclear surface deformation
C
      LAMODD=0
C
      DO LAMBDA=1,LMXDEF,2
         DO MIU=0,LAMBDA
            IF (I_STEP(LAMBDA,MIU).EQ.1) LAMODD=1
         END DO
      END DO
C
      DO LAMBDA=0,LMXDEF
         DO MIU=0,LAMBDA
C
            IF (I_STEP(LAMBDA,MIU).EQ.1) THEN
C
                IF (ABS(QASKED(LAMBDA,MIU)).GT.1.E-10) THEN
C
                    ALSTRT(LAMBDA,MIU)=APPBET(LAMBDA,MIU)
C
                ELSE

                    ALSTRT(LAMBDA,MIU)=CMPLX(0.01,0.0)
C
                END IF
C
                I_SEAR=I_SEAR+1
                ARGPAR(I_SEAR)=REAL(ALSTRT(LAMBDA,MIU))
C
            END IF
C
         END DO
      END DO
C
      DO LAMBDA=0,LMXDEF
         DO MIU=1,LAMBDA
            ALSTRT(LAMBDA,-MIU)=(-1)**MIU*CONJG(ALSTRT(LAMBDA,MIU))
         END DO
      END DO
C
      DO LAMBDA=0,NDLAMB
         DO MIU=-NDLAMB,NDLAMB
            ALPHAC(LAMBDA,MIU)=ALSTRT(LAMBDA,MIU)
         END DO
      END DO
C
C      Setting the numerical factors for calculating Y_(lm). We have 3
C      sources of usage for Ylm:
c        - the WS basis: LMXBAS
C        - the WS nuclear surface: LMXDEF
C        - the multipole moments: LMXMUL
C      LAMMAX is initialized to the maximum of all these 3 integers
C
      CALL WS_LOADIN(MAXYLM)
C
C      Verifying whether the y-signature is conserved
C
      CALL WS_TESIGN(ISIGNY,IAUTOM,ALPHAC,NDLAMB)
C
C      Counting how many multipole moments are used as constraints,
C      and therefore how many terms the chi2 contains. Storing which
C      moments are active constraints, and their value.
C
      LD_MUL=0
C
      DO LAMBDA=0,LMXDEF
         DO MIU=0,LAMBDA
C
            IF (IFLAGQ(LAMBDA,MIU).EQ.1) THEN
C
            	LD_MUL=LD_MUL+1
C
            	QEXPEC(LD_MUL)=QASKED(LAMBDA,MIU)
            	LEXPEC(LD_MUL)=LAMBDA
            	MEXPEC(LD_MUL)=MIU
C
            END IF
C
         END DO
      END DO
C
C      Setting the Delta values for protons and neutrons
C
      DELT3N(IZ_FIX,IN_FIX)=D3N_WS
      DELT3P(IZ_FIX,IN_FIX)=D3P_WS
C
C      If HF potential is used to construct the actual mean-field,
C      we read the HFODD record file here. The potential is stored
C      in VN_CEN and VP_CEN for neutrons and protons respectively
C
      IF (KHFPOT.EQ.1) CALL WS_SPECIA()
C
C      Actually minimizing the chi2 of the requested multipole vs. the
C      actual GEOMETRICAL multipoles...
C
      IF (LAMODD.EQ.1) THEN
C
          IF_ODD=1
C
          CALL WS_SETVAR(LDSEAR,LMXDEF,ARGPAR,APPBET,IF_ODD,IFLAGQ,
     *                                                      QASKED)
C
      END IF
C
      ITEOLD=ITECHI
      STPOLD=STEPMX
C
      I_MODE=1
      IABORT=0
      ITECHI=500
      STEPMX=0.05
C
      CALL WS_DEFDEF(IZ_FIX,IN_FIX,ARGPAR)
C
C      Setting the initial values of the nuclear surface deformation
C
      DO LAMBDA=0,LMXDEF
         DO MIU=0,LAMBDA
            IF (I_STEP(LAMBDA,MIU).EQ.1) THEN
                ALSTRT(LAMBDA,MIU)=ALPHAC(LAMBDA,MIU)
            END IF
         END DO
      END DO
C
      IF (LAMODD.EQ.1) THEN
C
          IABORT=0
C
          IF_ODD=2
C
          CALL WS_SETVAR(LDSEAR,LMXDEF,ARGPAR,APPBET,IF_ODD,IFLAGQ,
     *                                                      QASKED)
C
          CALL WS_DEFDEF(IZ_FIX,IN_FIX,ARGPAR)
C
      END IF
C
C      ... the deformation of the surface obtained in the previous
C      minimization is used as starting point for the next job:
C      minimizing the deviations to the expectation value of the
C      multipole moments on the WS eigenstates.
C
      ITECHI=ITEOLD
      STEPMX=STPOLD
C
C      Setting the initial values of the nuclear surface deformation
C
      DO LAMBDA=0,LMXDEF
         DO MIU=0,LAMBDA
            IF (I_STEP(LAMBDA,MIU).EQ.1) THEN
                ALSTRT(LAMBDA,MIU)=ALPHAC(LAMBDA,MIU)
            END IF
         END DO
      END DO
C
      I_MODE=2
      IABORT=0
C
      CALL WS_DEFDEF(IZ_FIX,IN_FIX,ARGPAR)
C
C      These quantities are computed properly by the WS code but are not
C      used by HFODD -> it does not matter if they are set to 0 here
C
      CMSXFC=0.0
      CMSYFC=0.0
      CMSZFC=0.0
C
      XMOMFC=0.0
      YMOMFC=0.0
      ZMOMFC=0.0
C
      HOMEGA=0.0
C
C      Writing binary files on disk
C
      CALL WS_WRIBIN(IZ_FIX,IN_FIX,FCHOM0,R0PARM,HOMEGA,
     *                             EPSHER,ENECUT,CVOLFC,
     *                             CMSXFC,CMSYFC,CMSZFC,
     *                             XMOMFC,YMOMFC,ZMOMFC,
     *                             BASEX2,BASEY2,BASEZ2,
     *                             ALPHAC,IREALA,LDBASE,
     *                                           FILWOO)
C
C=======================================================================
C
      CALL WS_TIMPRI
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE WS_APPDEF(NAPBET,DATRMS,QMOMUL,
     *                     APPDEN,APPRAD,APPBET)
C=======================================================================
      USE params
C=======================================================================
      DIMENSION
     *          QMOMUL(0:NDMULT,-NDMULT:NDMULT),
     *          ASKMUL(0:NDMULT,-NDMULT:NDMULT)
      DIMENSION
     *          APPBET(1:NDMULT,-NDMULT:NDMULT)
C
      COMMON
     *       /DEFUNI_OURUNI/ QUNITS(0:NDMULT,0:NDMULT)
C
C=======================================================================
C THIS SUBROUTINE FINDS THE BOHR DEFORMATION PARAMETERS
C WITHIN THE LINEAR APPROXIMATION
C=======================================================================
C
      SQR4PI=SQRT(16.D0*ATAN(1.D0))
C
C=======================================================================
C REMOVING UNITS
C=======================================================================
C
      DO LAM=0,NAPBET
         DO MIU=-LAM,LAM
            ASKMUL(LAM,MIU)=QMOMUL(LAM,MIU)/QUNITS(LAM,IABS(MIU))
         END DO
      END DO
C
      ASKSUR=SQR4PI*ASKMUL(0,0)*DATRMS**2
      ASKRAD=SQRT(5.*ASKSUR/(3.*SQR4PI*ASKMUL(0,0)))
      ASKDEN=3*ASKMUL(0,0)/(SQR4PI*ASKRAD**3)
C
C=======================================================================
C CALCULATING LINEAR APPROXIMATION TO BETAS
C=======================================================================
C
      APPRAD=ASKRAD
      APPDEN=ASKDEN
      FACTOR=APPDEN*APPRAD**4
      DO LAM=1,NAPBET
         DO MIU=-LAM,LAM
            APPBET(LAM,MIU)=ASKMUL(LAM,MIU)/FACTOR
         END DO
         FACTOR=FACTOR*APPRAD
      END DO
C
C=======================================================================
C MULTIPLYING NON-AXIAL BETAS BY SQUARE ROOT OF TWO
C=======================================================================
C
      DO LAM=1,NAPBET
         DO MIU=1,LAM
           APPBET(LAM, MIU)=APPBET(LAM, MIU)*SQRT(2.)
           APPBET(LAM,-MIU)=APPBET(LAM,-MIU)*SQRT(2.)
         END DO
      END DO
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE WS_SETVAR(LDSEAR,LMXDEF,ARGPAR,APPBET,IF_ODD,IFLAGQ,
     *                                                        QASKED)
C=======================================================================
      USE params
C=======================================================================
      COMPLEX
     *          ALSTRT,ALSTEP,ALMINI,ALMAXI
      COMPLEX
     *          ALPHAC(0:NDLAMB,-NDLAMB:+NDLAMB)
C
      DIMENSION
     *          ARGPAR(1:NDSEAR)
      DIMENSION
     *          QASKED(0:NDMULT,-NDMULT:NDMULT)
      DIMENSION
     *          IFLAGQ(0:NDMULT,-NDMULT:NDMULT)
      DIMENSION
     *          APPBET(1:NDMULT,-NDMULT:NDMULT)
C
C      Deformations
C
      COMMON
     *       /ALPHACMUL_DEF/ ALPHAC
      COMMON
     *       /DEFMIN_STARTS/ ALSTRT(0:NDLAMB,-NDLAMB:+NDLAMB),
     *                       ALSTEP(0:NDLAMB,-NDLAMB:+NDLAMB),
     *                       ALMINI(0:NDLAMB,-NDLAMB:+NDLAMB),
     *                       ALMAXI(0:NDLAMB,-NDLAMB:+NDLAMB)
      COMMON
     *       /DEFMIN_VARIAB/ I_STEP(0:NDLAMB,-NDLAMB:+NDLAMB)
     *       /STORAG_VARIAB/ J_STEP(0:NDLAMB,-NDLAMB:+NDLAMB)
      COMMON
     *       /EXPECTED_QVAL/ QEXPEC(0:NDSEAR)
     *       /EXPECTED_LMIU/ LEXPEC(0:NDSEAR),MEXPEC(0:NDSEAR)
     *       /EXPECTED_SIZE/ LD_MUL
C
C=======================================================================
C
      I_SEAR=0
C
C      First pass: if parity-breaking deformations are included in the
C                  fit, we do a first minimization with only alpha_10
C                  and alpha_30, and only trying to reproduce Q30
C
      IF (IF_ODD.EQ.1) THEN
C
          I_SEAR=0
C
C          Storing the active variables
C
          DO LAMBDA=0,NDLAMB
             DO MIU=-NDLAMB,NDLAMB
                J_STEP(LAMBDA,MIU)=I_STEP(LAMBDA,MIU)
             END DO
          END DO
C
C          Keeping only alpha_10 and alpha_30 as active variables
C
          DO LAMBDA=0,NDLAMB
             DO MIU=-NDLAMB,NDLAMB
                I_STEP(LAMBDA,MIU)=0
             END DO
          END DO
          I_STEP(1,0)=1
          I_STEP(3,0)=1
C
          DO LAMBDA=0,LMXDEF
             DO MIU=0,LAMBDA
C
                IF (I_STEP(LAMBDA,MIU).EQ.1) THEN
C
                    ALSTRT(LAMBDA,MIU)=CMPLX(0.0,0.0) !APPBET(LAMBDA,MIU) / 3.0
C
                    I_SEAR=I_SEAR+1
                    ARGPAR(I_SEAR)=REAL(ALSTRT(LAMBDA,MIU))
C
                END IF
C
             END DO
          END DO
C
          LDSEAR=I_SEAR
C
          DO LAMBDA=0,LMXDEF
             DO MIU=1,LAMBDA
                ALSTRT(LAMBDA,-MIU)=(-1)**MIU*CONJG(ALSTRT(LAMBDA,MIU))
             END DO
          END DO
C
          DO LAMBDA=0,NDLAMB
             DO MIU=-NDLAMB,NDLAMB
                ALPHAC(LAMBDA,MIU)=ALSTRT(LAMBDA,MIU)
             END DO
          END DO
C
C          Counting how many multipole moments are used as constraints,
C          and therefore how many terms the chi2 contains. Storing which
C          moments are active constraints, and their value.
C
          LD_MUL=0
C
          LD_MUL=LD_MUL+1
C
          QEXPEC(LD_MUL)=QASKED(1,0)
          LEXPEC(LD_MUL)=1
          MEXPEC(LD_MUL)=0
C
          LD_MUL=LD_MUL+1
C
          QEXPEC(LD_MUL)=QASKED(3,0)
          LEXPEC(LD_MUL)=3
          MEXPEC(LD_MUL)=0
C
      END IF
C
C      Second pass: after the first pass, we should have a better idea
C                   of the actual deformations, in particular of the
C                   shift of the center of mass. We can then do a full
C                   minimization
C
      IF (IF_ODD.EQ.2) THEN
C
          I_SEAR=0
C
C          Reactivating all variables
C
          DO LAMBDA=0,NDLAMB
             DO MIU=-NDLAMB,NDLAMB
C
                I_STEP(LAMBDA,MIU)=J_STEP(LAMBDA,MIU)
C
                IF (I_STEP(LAMBDA,MIU).EQ.1) THEN
                    ALSTRT(LAMBDA,MIU)=APPBET(LAMBDA,MIU)
                ELSE
                    ALSTRT(LAMBDA,MIU)=CMPLX(0.0,0.0)
                END IF
C
             END DO
          END DO
C
          ALSTRT(1,0)=ALPHAC(1,0)
          ALSTRT(3,0)=ALPHAC(3,0)
C
          DO LAMBDA=0,LMXDEF
             DO MIU=0,LAMBDA
C
                IF (I_STEP(LAMBDA,MIU).EQ.1) THEN
C
                    I_SEAR=I_SEAR+1
                    ARGPAR(I_SEAR)=REAL(ALSTRT(LAMBDA,MIU))
C
                END IF
C
             END DO
          END DO
C
          LDSEAR=I_SEAR
C
          DO LAMBDA=0,LMXDEF
             DO MIU=1,LAMBDA
                ALSTRT(LAMBDA,-MIU)=(-1)**MIU*CONJG(ALSTRT(LAMBDA,MIU))
             END DO
          END DO
C
          DO LAMBDA=0,NDLAMB
             DO MIU=-NDLAMB,NDLAMB
                ALPHAC(LAMBDA,MIU)=ALSTRT(LAMBDA,MIU)
             END DO
          END DO
C
C          Counting how many multipole moments are used as constraints,
C          and therefore how many terms the chi2 contains. Storing which
C          moments are active constraints, and their value.
C
          LD_MUL=0
C
          DO LAMBDA=0,LMXDEF
             DO MIU=0,LAMBDA
C
                IF (IFLAGQ(LAMBDA,MIU).EQ.1) THEN
C
                    LD_MUL=LD_MUL+1
C
                    QEXPEC(LD_MUL)=QASKED(LAMBDA,MIU)
                    LEXPEC(LD_MUL)=LAMBDA
                    MEXPEC(LD_MUL)=MIU
C
                END IF
C
             END DO
          END DO
C
      END IF
C
C=======================================================================
C
      RETURN
      END


