C FILE NAME = wsu03_pots_04.f   ! Keep this symbol here: $ident@string$
C
C=======================================================================
C=======================================================================
C=====                                ==================================
C=====    POTENTIAL-DEFINITION SET    ==================================
C=====                                ==================================
C=======================================================================
C=======================================================================
C
      SUBROUTINE WS_PARAMS(IZ_FIX,IN_FIX,ISOSPI,R0PARM,NOEFFM,SELPAR)
C
      CHARACTER
     *          SELPAR*20
C
      COMMON
     *       /PARAMISOS_NEU/ V0DEPN,R0CENN,A0DIFN,S0LSON,R0SORN,A0DISN,
     *                       X0DEPN,X0CENN,X0DIFN,X0LSON,X0SORN,X0DISN,
     *                       Y0DEPN,Y0CENN,Y0DIFN,Y0LSON,Y0SORN,Y0DISN
     *
     *       /PARAMISOS_PRO/ V0DEPP,R0CENP,A0DIFP,S0LSOP,R0SORP,A0DISP,
     *                       X0DEPP,X0CENP,X0DIFP,X0LSOP,X0SORP,X0DISP,
     *                       Y0DEPP,Y0CENP,Y0DIFP,Y0LSOP,Y0SORP,Y0DISP
      COMMON
     *       /DIRECTPAR_NEU/ VOCENN,ROCENN,AOCENN,S0LAMN,ROSORN,AOSORN
     *
     *       /DIRECTPAR_PRO/ VOCENP,ROCENP,AOCENP,S0LAMP,ROSORP,AOSORP
C
      COMMON
     *       /NCONST_CONSTS/ HBAR_C,XMASSP,XMASSN,HCOVE2,E2OVHC
      COMMON
     *       /PARNAM_POTPAR/ ROCENT,AOCENT,VOCENT,R_CENT,
     *                       ROSORB,AOSORB,VOSORB,R_SORB
      COMMON
     *       /PARAMS_RADVOL/ RADIUS,CVOLFC,RCVOLM
C
      COMMON
     *       /READWRITE_PAR/ NOUTPT,IWRITE,ISCREN
C
      DATA
     *     AMCARB / 938.9059 /
C
C=======================================================================
C     This subroutine defines the Woods-Saxon hamiltonian parameters
C=======================================================================
C
      A_MASS=REAL(IN_FIX+IZ_FIX)
      A_ISOS=REAL(IN_FIX-IZ_FIX)
C
      NOEFFM=-999
C
C=======================================================================
C=======================================================================
C                      PARAMETERS  FOR  NEUTRONS
C=======================================================================
C=======================================================================
C
      IF (ISOSPI.EQ.0) THEN
C
          X_MASS=XMASSN
C
          IF (SELPAR.EQ.'UNIVERSAL_DIRAC') THEN
C
              NOEFFM=0
C
C             CENTRAL Woods-Saxon potential:  Dirac-Universal case
C
              V0DEPT=-106.0    ! Central potential depth parameter
              X0DEPT=-0.480    ! Central potential  isospin   term
              Y0DEPT=-0.430    ! Central potential  m a s s   term
C
              R0RADI=+1.060    ! Central    radius       parameter
              X0RADI=-0.003    ! Central    radius    isospin term
              Y0RADI=-0.200    ! Central    radius    m a s s term
C
              A0DIFF=+1.360    ! Central diffuseness     parameter
              X0DIFF=+0.120    ! Central diffuseness  isospin term
              Y0DIFF=-0.850    ! Central diffuseness  m a s s term
C
C             ...       and the corresponding SPIN-ORBIT potential
C
              S0STSO=+24.80    ! Spin-Orbit strength     parameter
              X0STSO=-0.500    ! Spin-Orbit strength  isospin term
              Y0STSO=-0.520    ! Spin-Orbit strength  m a s s term
C
              R0RASO=+0.830    ! Spin-Orbit    radius    parameter
              X0RASO=+0.040    ! Spin-Orbit    radius   isospin  t.
              Y0RASO=-0.040    ! Spin-Orbit    radius   m a s s  t.
C
              A0DISO=+0.450    ! Spin-Orbit diffuseness  parameter
              X0DISO=+1.000    ! Spin-Orbit diffuseness isospin  t.
              Y0DISO=+0.700    ! Spin-Orbit diffuseness m a s s  t.
C
              SOUNIT=50.000*(0.2500*(HBAR_C/X_MASS)**2)
C
          END IF
C
C         ... still neutrons ...
C
          IF (SELPAR.EQ.'UNIVERS_COMPACT') THEN
C
              NOEFFM=1
C
C             CENTRAL Woods-Saxon potential:  Dirac-Universal case
C
              V0DEPT=-52.00    ! Central potential depth parameter
              X0DEPT=-0.650    ! Central potential  isospin   term
              Y0DEPT= 0.000    ! Central potential  m a s s   term
C
              R0RADI=+1.260    ! Central    radius       parameter
              X0RADI= 0.000    ! Central    radius    isospin term
              Y0RADI= 0.000    ! Central    radius    m a s s term
C
              A0DIFF=+0.640    ! Central diffuseness     parameter
              X0DIFF= 0.000    ! Central diffuseness  isospin term
              Y0DIFF= 0.000    ! Central diffuseness  m a s s term
C
C             ...       and the corresponding SPIN-ORBIT potential
C
              S0STSO=+28.00    ! Spin-Orbit strength     parameter
              X0STSO= 0.000    ! Spin-Orbit strength  isospin term
              Y0STSO= 0.000    ! Spin-Orbit strength  m a s s term
C
              R0RASO=+0.870    ! Spin-Orbit    radius    parameter
              X0RASO= 0.000    ! Spin-Orbit    radius   isospin  t.
              Y0RASO= 0.000    ! Spin-Orbit    radius   m a s s  t.
C
              A0DISO=+0.700    ! Spin-Orbit diffuseness  parameter
              X0DISO=+0.000    ! Spin-Orbit diffuseness isospin  t.
              Y0DISO=+0.000    ! Spin-Orbit diffuseness m a s s  t.
C
              SOUNIT=49.600*(0.2500*(HBAR_C/X_MASS)**2)
C
          END IF
C
C         ... still neutrons ...
C
          IF (SELPAR.EQ.'UNIV_NONCOMPACT') THEN
C
              NOEFFM=1
C
C             CENTRAL Woods-Saxon potential:  Dirac-Universal case
C
              V0DEPT=-52.00    ! Central potential depth parameter
              X0DEPT=-0.650    ! Central potential  isospin   term
              Y0DEPT= 0.000    ! Central potential  m a s s   term
C
              R0RADI=+1.260    ! Central    radius       parameter
              X0RADI= 0.000    ! Central    radius    isospin term
              Y0RADI= 0.000    ! Central    radius    m a s s term
C
              A0DIFF=+0.640    ! Central diffuseness     parameter
              X0DIFF= 0.000    ! Central diffuseness  isospin term
              Y0DIFF= 0.000    ! Central diffuseness  m a s s term
C
C             ...       and the corresponding SPIN-ORBIT potential
C
              S0STSO=+28.00    ! Spin-Orbit strength     parameter
              X0STSO= 0.000    ! Spin-Orbit strength  isospin term
              Y0STSO= 0.000    ! Spin-Orbit strength  m a s s term
C
              R0RASO=+1.250    ! Spin-Orbit    radius    parameter
              X0RASO= 0.000    ! Spin-Orbit    radius   isospin  t.
              Y0RASO= 0.000    ! Spin-Orbit    radius   m a s s  t.
C
              A0DISO=+0.700    ! Spin-Orbit diffuseness  parameter
              X0DISO=+0.000    ! Spin-Orbit diffuseness isospin  t.
              Y0DISO=+0.000    ! Spin-Orbit diffuseness m a s s  t.
C
              SOUNIT=49.600*(0.2500*(HBAR_C/X_MASS)**2)
C
          END IF
C
C         ... still neutrons but more traditional now ...
C
C=======================================================================
C=======================================================================
C=======================================================================
C
          IF (SELPAR.EQ.'WAHLBORN_PARAMS') THEN
C
              NOEFFM=1
C
C             CENTRAL Woods-Saxon potential:  Dirac-Universal case
C
              V0DEPT=-51.00    ! Central potential depth parameter
              X0DEPT=-0.670    ! Central potential  isospin   term
              Y0DEPT= 0.000    ! Central potential  m a s s   term
C
              R0RADI=+1.270    ! Central    radius       parameter
              X0RADI= 0.000    ! Central    radius    isospin term
              Y0RADI= 0.000    ! Central    radius    m a s s term
C
              A0DIFF=+0.670    ! Central diffuseness     parameter
              X0DIFF= 0.000    ! Central diffuseness  isospin term
              Y0DIFF= 0.000    ! Central diffuseness  m a s s term
C
C             ...       and the corresponding SPIN-ORBIT potential
C
              S0STSO=+32.00    ! Spin-Orbit strength     parameter
              X0STSO= 0.000    ! Spin-Orbit strength  isospin term
              Y0STSO= 0.000    ! Spin-Orbit strength  m a s s term
C
              R0RASO=+1.270    ! Spin-Orbit    radius    parameter
              X0RASO= 0.000    ! Spin-Orbit    radius   isospin  t.
              Y0RASO= 0.000    ! Spin-Orbit    radius   m a s s  t.
C
              A0DISO=+0.670    ! Spin-Orbit diffuseness  parameter
              X0DISO=+0.000    ! Spin-Orbit diffuseness isospin  t.
              Y0DISO=+0.000    ! Spin-Orbit diffuseness m a s s  t.
C
              SOUNIT=49.600
C
              SOUNIT=ABS(V0DEPT)*(1+X0DEPT*A_ISOS/A_MASS)
     *              *0.25*(HBAR_C/AMCARB)**2
C
          END IF
C
C=======================================================================
C
          IF (SELPAR.EQ.'ROST_PARAMETERS') THEN
C
              NOEFFM=1
C
C             CENTRAL Woods-Saxon potential:
C
              V0DEPT=-49.60    ! Central potential depth parameter
              X0DEPT=-0.860    ! Central potential  isospin   term
              Y0DEPT= 0.000    ! Central potential  m a s s   term
C
              R0RADI=+1.347    ! Central    radius       parameter
              X0RADI= 0.000    ! Central    radius    isospin term
              Y0RADI= 0.000    ! Central    radius    m a s s term
C
              A0DIFF=+0.700    ! Central diffuseness     parameter
              X0DIFF= 0.000    ! Central diffuseness  isospin term
              Y0DIFF= 0.000    ! Central diffuseness  m a s s term
C
C             ...       and the corresponding SPIN-ORBIT potential
C
              S0STSO=+31.50    ! Spin-Orbit strength     parameter
              X0STSO= 0.000    ! Spin-Orbit strength  isospin term
              Y0STSO= 0.000    ! Spin-Orbit strength  m a s s term
C
              R0RASO=+1.280    ! Spin-Orbit    radius    parameter
              X0RASO= 0.000    ! Spin-Orbit    radius   isospin  t.
              Y0RASO= 0.000    ! Spin-Orbit    radius   m a s s  t.
C
              A0DISO=+0.700    ! Spin-Orbit diffuseness  parameter
              X0DISO=+0.000    ! Spin-Orbit diffuseness isospin  t.
              Y0DISO=+0.000    ! Spin-Orbit diffuseness m a s s  t.
C
              SOUNIT=ABS(V0DEPT)*(1+X0DEPT*A_ISOS/A_MASS)
     *              *0.25*(HBAR_C/AMCARB)**2
C
          END IF
C
C=======================================================================
C
          IF (SELPAR.EQ.'CHEPURNOV_PARAM') THEN
C
              NOEFFM=1
C
C             CENTRAL Woods-Saxon potential:
C
              V0DEPT=-53.30    ! Central potential depth parameter
              X0DEPT=-0.630    ! Central potential  isospin   term
              Y0DEPT= 0.000    ! Central potential  m a s s   term
C
              R0RADI=+1.240    ! Central    radius       parameter
              X0RADI= 0.000    ! Central    radius    isospin term
              Y0RADI= 0.000    ! Central    radius    m a s s term
C
              A0DIFF=+0.630    ! Central diffuseness     parameter
              X0DIFF= 0.000    ! Central diffuseness  isospin term
              Y0DIFF= 0.000    ! Central diffuseness  m a s s term
C
C             ...       and the corresponding SPIN-ORBIT potential
C
              S0STSO=+23.80    ! Spin-Orbit strength     parameter
              X0STSO= 2.000    ! Spin-Orbit strength  isospin term
              Y0STSO= 0.000    ! Spin-Orbit strength  m a s s term
C
              R0RASO=+1.240    ! Spin-Orbit    radius    parameter
              X0RASO= 0.000    ! Spin-Orbit    radius   isospin  t.
              Y0RASO= 0.000    ! Spin-Orbit    radius   m a s s  t.
C
              A0DISO=+0.630    ! Spin-Orbit diffuseness  parameter
              X0DISO=+0.000    ! Spin-Orbit diffuseness isospin  t.
              Y0DISO=+0.000    ! Spin-Orbit diffuseness m a s s  t.
C
              SOUNIT=ABS(V0DEPT)*(1+X0DEPT*A_ISOS/A_MASS)
     *              *0.25*(HBAR_C/AMCARB)**2
C
          END IF
C
C=======================================================================
C
          IF (SELPAR.EQ.'UNIVERSAL_PARAM') THEN
C
              NOEFFM=1
C
C             CENTRAL Woods-Saxon potential:
C
              V0DEPT=-49.60    ! Central potential depth parameter
              X0DEPT=-0.860    ! Central potential  isospin   term
              Y0DEPT= 0.000    ! Central potential  m a s s   term
C
              R0RADI=+1.347    ! Central    radius       parameter
              X0RADI= 0.000    ! Central    radius    isospin term
              Y0RADI= 0.000    ! Central    radius    m a s s term
C
              A0DIFF=+0.700    ! Central diffuseness     parameter
              X0DIFF= 0.000    ! Central diffuseness  isospin term
              Y0DIFF= 0.000    ! Central diffuseness  m a s s term
C
C             ...       and the corresponding SPIN-ORBIT potential
C
              S0STSO=+35.00    ! Spin-Orbit strength     parameter
              X0STSO= 0.000    ! Spin-Orbit strength  isospin term
              Y0STSO= 0.000    ! Spin-Orbit strength  m a s s term
C
              R0RASO=+1.310    ! Spin-Orbit    radius    parameter
              X0RASO= 0.000    ! Spin-Orbit    radius   isospin  t.
              Y0RASO= 0.000    ! Spin-Orbit    radius   m a s s  t.
C
              A0DISO=+0.700    ! Spin-Orbit diffuseness  parameter
              X0DISO=+0.000    ! Spin-Orbit diffuseness isospin  t.
              Y0DISO=+0.000    ! Spin-Orbit diffuseness m a s s  t.
C
              SOUNIT=ABS(V0DEPT)*(1+X0DEPT*A_ISOS/A_MASS)
     *              *0.25*(HBAR_C/AMCARB)**2
C
          END IF
C
C         ... neutrons, user defined paramters with isospin depend.
C
          IF (SELPAR.EQ.'INPUT_WITH_ISOS') THEN
C
              NOEFFM=1
C
C             CENTRAL Woods-Saxon potential:
C
              V0DEPT=V0DEPN    ! Central potential depth parameter
              X0DEPT=X0DEPN    ! Central potential  isospin   term
              Y0DEPT=Y0DEPN    ! Central potential  m a s s   term
C
              R0RADI=R0CENN    ! Central    radius       parameter
              X0RADI=X0CENN    ! Central    radius    isospin term
              Y0RADI=Y0CENN    ! Central    radius    m a s s term
C
              A0DIFF=A0DIFN    ! Central diffuseness     parameter
              X0DIFF=X0DIFN    ! Central diffuseness  isospin term
              Y0DIFF=Y0DIFN    ! Central diffuseness  m a s s term
C
C             ...       and the corresponding SPIN-ORBIT potential
C
              S0STSO=S0LSON    ! Spin-Orbit strength     parameter
              X0STSO=X0LSON    ! Spin-Orbit strength  isospin term
              Y0STSO=Y0LSON    ! Spin-Orbit strength  m a s s term
C
              R0RASO=R0SORN    ! Spin-Orbit    radius    parameter
              X0RASO=X0SORN    ! Spin-Orbit    radius   isospin  t.
              Y0RASO=Y0SORN    ! Spin-Orbit    radius   m a s s  t.
C
              A0DISO=A0DISN    ! Spin-Orbit diffuseness  parameter
              X0DISO=X0DISN    ! Spin-Orbit diffuseness isospin  t.
              Y0DISO=Y0DISN    ! Spin-Orbit diffuseness m a s s  t.
C
              SOUNIT=50.0*(1+X0DEPT*A_ISOS/A_MASS)
     *              *0.25*(HBAR_C/AMCARB)**2
          END IF
C
C         ... neutrons, user 'directly' defined parameters
C
          IF (SELPAR.EQ.'INPUT_PARSFIXED') THEN
C
              VOCENT=-ABS(VOCENN)
              ROCENT=+ABS(ROCENN)
              AOCENT=+ABS(AOCENN)
C
              SOSORB=+ABS(S0LAMN)
              ROSORB=+ABS(ROSORN)
              AOSORB=+ABS(AOSORN)
c
              SOUNIT=50.0*0.25*(HBAR_C/AMCARB)**2
C
          END IF
C
      END IF
C
C=======================================================================
C=======================================================================
C                      PARAMETERS   FOR  PROTONS
C=======================================================================
C=======================================================================
C
      IF (ISOSPI.EQ.1) THEN
C
          X_MASS=XMASSP
C
          IF (SELPAR.EQ.'UNIVERSAL_DIRAC') THEN
C
              NOEFFM=0
C
C             CENTRAL Woods-Saxon potential:  Dirac-Universal case
C
              V0DEPT=-105.5    ! Central potential depth parameter
              X0DEPT=-0.420    ! Central potential  isospin   term
              Y0DEPT=-0.750    ! Central potential  m a s s   term
C
              R0RADI=+0.950    ! Central    radius       parameter
              X0RADI=-0.800    ! Central    radius    isospin term
              Y0RADI=-0.350    ! Central    radius    m a s s term
C
              A0DIFF=+1.270    ! Central diffuseness     parameter
              X0DIFF=+0.800    ! Central diffuseness  isospin term
              Y0DIFF=-0.900    ! Central diffuseness  m a s s term
C
C             ...       and the corresponding SPIN-ORBIT potential
C
              S0STSO=+24.00    ! Spin-Orbit strength     parameter
              X0STSO=-0.800    ! Spin-Orbit strength  isospin term
              Y0STSO=-0.600    ! Spin-Orbit strength  m a s s term
C
              R0RASO=+0.710    ! Spin-Orbit    radius    parameter
              X0RASO=+0.800    ! Spin-Orbit    radius   isospin  t.
              Y0RASO=-0.200    ! Spin-Orbit    radius   m a s s  t.
C
              A0DISO=+0.400    ! Spin-Orbit diffuseness  parameter
              X0DISO=+0.800    ! Spin-Orbit diffuseness isospin  t.
              Y0DISO=+2.000    ! Spin-Orbit diffuseness m a s s  t.
C
              SOUNIT=50.000*(0.2500*(HBAR_C/X_MASS)**2)
C
          END IF
C
C         ... still protons ...
C
          IF (SELPAR.EQ.'UNIVERS_COMPACT') THEN
C
              NOEFFM=1
C
C             CENTRAL Woods-Saxon potential:
C
              V0DEPT=-53.00    ! Central potential depth parameter
              X0DEPT=+0.526    ! Central potential  isospin   term
              Y0DEPT= 0.000    ! Central potential  m a s s   term
C
              R0RADI=+1.270    ! Central    radius       parameter
              X0RADI= 0.000    ! Central    radius    isospin term
              Y0RADI= 0.000    ! Central    radius    m a s s term
C
              A0DIFF=+0.710    ! Central diffuseness     parameter
              X0DIFF= 0.000    ! Central diffuseness  isospin term
              Y0DIFF= 0.000    ! Central diffuseness  m a s s term
C
C             ...       and the corresponding SPIN-ORBIT potential
C
              S0STSO=+23.00    ! Spin-Orbit strength     parameter
              X0STSO= 0.000    ! Spin-Orbit strength  isospin term
              Y0STSO= 0.000    ! Spin-Orbit strength  m a s s term
C
              R0RASO=+0.888    ! Spin-Orbit    radius    parameter
              X0RASO= 0.000    ! Spin-Orbit    radius   isospin  t.
              Y0RASO= 0.000    ! Spin-Orbit    radius   m a s s  t.
C
              A0DISO=+0.860    ! Spin-Orbit diffuseness  parameter
              X0DISO=+0.000    ! Spin-Orbit diffuseness isospin  t.
              Y0DISO=+0.000    ! Spin-Orbit diffuseness m a s s  t.
C
              SOUNIT=49.600*(0.2500*(HBAR_C/X_MASS)**2)
C
          END IF
C
C         ... still protons ...
C
          IF (SELPAR.EQ.'UNIV_NONCOMPACT') THEN
C
              NOEFFM=1
C
C             CENTRAL Woods-Saxon potential:
C
              V0DEPT=-53.00    ! Central potential depth parameter
              X0DEPT=+0.526    ! Central potential  isospin   term
              Y0DEPT= 0.000    ! Central potential  m a s s   term
C
              R0RADI=+1.270    ! Central    radius       parameter
              X0RADI= 0.000    ! Central    radius    isospin term
              Y0RADI= 0.000    ! Central    radius    m a s s term
C
              A0DIFF=+0.710    ! Central diffuseness     parameter
              X0DIFF= 0.000    ! Central diffuseness  isospin term
              Y0DIFF= 0.000    ! Central diffuseness  m a s s term
C
C             ...       and the corresponding SPIN-ORBIT potential
C
              S0STSO=+27.00    ! Spin-Orbit strength     parameter
              X0STSO= 0.000    ! Spin-Orbit strength  isospin term
              Y0STSO= 0.000    ! Spin-Orbit strength  m a s s term
C
              R0RASO=+1.215    ! Spin-Orbit    radius    parameter
              X0RASO= 0.000    ! Spin-Orbit    radius   isospin  t.
              Y0RASO= 0.000    ! Spin-Orbit    radius   m a s s  t.
C
              A0DISO=+0.661    ! Spin-Orbit diffuseness  parameter
              X0DISO=+0.000    ! Spin-Orbit diffuseness isospin  t.
              Y0DISO=+0.000    ! Spin-Orbit diffuseness m a s s  t.
C
              SOUNIT=49.600*(0.2500*(HBAR_C/X_MASS)**2)
C
          END IF
C
C=======================================================================
C=======================================================================
C             ... here the more classical ones ...
C=======================================================================
C=======================================================================
C
          IF (SELPAR.EQ.'WAHLBORN_PARAMS') THEN
C
              NOEFFM=1
C
C             CENTRAL Woods-Saxon potential:
C
              V0DEPT=-51.00    ! Central potential depth parameter
              X0DEPT=+0.670    ! Central potential  isospin   term
              Y0DEPT= 0.000    ! Central potential  m a s s   term
C
              R0RADI=+1.270    ! Central    radius       parameter
              X0RADI= 0.000    ! Central    radius    isospin term
              Y0RADI= 0.000    ! Central    radius    m a s s term
C
              A0DIFF=+0.670    ! Central diffuseness     parameter
              X0DIFF= 0.000    ! Central diffuseness  isospin term
              Y0DIFF= 0.000    ! Central diffuseness  m a s s term
C
C             ...       and the corresponding SPIN-ORBIT potential
C
              S0STSO=+27.00    ! Spin-Orbit strength     parameter
              X0STSO= 0.000    ! Spin-Orbit strength  isospin term
              Y0STSO= 0.000    ! Spin-Orbit strength  m a s s term
C
              R0RASO=+1.270    ! Spin-Orbit    radius    parameter
              X0RASO= 0.000    ! Spin-Orbit    radius   isospin  t.
              Y0RASO= 0.000    ! Spin-Orbit    radius   m a s s  t.
C
              A0DISO=+0.670    ! Spin-Orbit diffuseness  parameter
              X0DISO=+0.000    ! Spin-Orbit diffuseness isospin  t.
              Y0DISO=+0.000    ! Spin-Orbit diffuseness m a s s  t.
C
              SOUNIT=ABS(V0DEPT)*(1+X0DEPT*A_ISOS/A_MASS)
     *              *0.25*(HBAR_C/AMCARB)**2
C
          END IF
C
C=======================================================================
C
          IF (SELPAR.EQ.'ROST_PARAMETERS') THEN
C
              NOEFFM=1
C
C             CENTRAL Woods-Saxon potential:
C
              V0DEPT=-49.60    ! Central potential depth parameter
              X0DEPT=+0.860    ! Central potential  isospin   term
              Y0DEPT= 0.000    ! Central potential  m a s s   term
C
              R0RADI=+1.275    ! Central    radius       parameter
              X0RADI= 0.000    ! Central    radius    isospin term
              Y0RADI= 0.000    ! Central    radius    m a s s term
C
              A0DIFF=+0.700    ! Central diffuseness     parameter
              X0DIFF= 0.000    ! Central diffuseness  isospin term
              Y0DIFF= 0.000    ! Central diffuseness  m a s s term
C
C             ...       and the corresponding SPIN-ORBIT potential
C
              S0STSO=+17.80    ! Spin-Orbit strength     parameter
              X0STSO= 0.000    ! Spin-Orbit strength  isospin term
              Y0STSO= 0.000    ! Spin-Orbit strength  m a s s term
C
              R0RASO=+0.932    ! Spin-Orbit    radius    parameter
              X0RASO= 0.000    ! Spin-Orbit    radius   isospin  t.
              Y0RASO= 0.000    ! Spin-Orbit    radius   m a s s  t.
C
              A0DISO=+0.700    ! Spin-Orbit diffuseness  parameter
              X0DISO=+0.000    ! Spin-Orbit diffuseness isospin  t.
              Y0DISO=+0.000    ! Spin-Orbit diffuseness m a s s  t.
C
              SOUNIT=ABS(V0DEPT)*(1+X0DEPT*A_ISOS/A_MASS)
     *              *0.25*(HBAR_C/AMCARB)**2
C
          END IF
C
C=======================================================================
C
          IF (SELPAR.EQ.'CHEPURNOV_PARAM') THEN
C
              NOEFFM=1
C
C             CENTRAL Woods-Saxon potential:
C
              V0DEPT=-53.30    ! Central potential depth parameter
              X0DEPT=+0.630    ! Central potential  isospin   term
              Y0DEPT= 0.000    ! Central potential  m a s s   term
C
              R0RADI=+1.240    ! Central    radius       parameter
              X0RADI= 0.000    ! Central    radius    isospin term
              Y0RADI= 0.000    ! Central    radius    m a s s term
C
              A0DIFF=+0.630    ! Central diffuseness     parameter
              X0DIFF= 0.000    ! Central diffuseness  isospin term
              Y0DIFF= 0.000    ! Central diffuseness  m a s s term
C
C             ...       and the corresponding SPIN-ORBIT potential
C
              S0STSO=+23.80    ! Spin-Orbit strength     parameter
              X0STSO= 2.000    ! Spin-Orbit strength  isospin term
              Y0STSO= 0.000    ! Spin-Orbit strength  m a s s term
C
              R0RASO=+1.240    ! Spin-Orbit    radius    parameter
              X0RASO= 0.000    ! Spin-Orbit    radius   isospin  t.
              Y0RASO= 0.000    ! Spin-Orbit    radius   m a s s  t.
C
              A0DISO=+0.630    ! Spin-Orbit diffuseness  parameter
              X0DISO=+0.000    ! Spin-Orbit diffuseness isospin  t.
              Y0DISO=+0.000    ! Spin-Orbit diffuseness m a s s  t.
C
              SOUNIT=ABS(V0DEPT)*(1+X0DEPT*A_ISOS/A_MASS)
     *              *0.25*(HBAR_C/AMCARB)**2
C
          END IF
C
C=======================================================================
C
          IF (SELPAR.EQ.'UNIVERSAL_PARAM') THEN
C
              NOEFFM=1
C
C             CENTRAL Woods-Saxon potential:
C
              V0DEPT=-49.60    ! Central potential depth parameter
              X0DEPT=+0.860    ! Central potential  isospin   term
              Y0DEPT= 0.000    ! Central potential  m a s s   term
C
              R0RADI=+1.275    ! Central    radius       parameter
              X0RADI= 0.000    ! Central    radius    isospin term
              Y0RADI= 0.000    ! Central    radius    m a s s term
C
              A0DIFF=+0.700    ! Central diffuseness     parameter
              X0DIFF= 0.000    ! Central diffuseness  isospin term
              Y0DIFF= 0.000    ! Central diffuseness  m a s s term
C
C             ...       and the corresponding SPIN-ORBIT potential
C
              S0STSO=+36.00    ! Spin-Orbit strength     parameter
              X0STSO= 0.000    ! Spin-Orbit strength  isospin term
              Y0STSO= 0.000    ! Spin-Orbit strength  m a s s term
C
              R0RASO=+1.320    ! Spin-Orbit    radius    parameter
              X0RASO= 0.000    ! Spin-Orbit    radius   isospin  t.
              Y0RASO= 0.000    ! Spin-Orbit    radius   m a s s  t.
C
              A0DISO=+0.700    ! Spin-Orbit diffuseness  parameter
              X0DISO=+0.000    ! Spin-Orbit diffuseness isospin  t.
              Y0DISO=+0.000    ! Spin-Orbit diffuseness m a s s  t.
C
              SOUNIT=ABS(V0DEPT)*(1+X0DEPT*A_ISOS/A_MASS)
     *              *0.25*(HBAR_C/AMCARB)**2
C
          END IF
C
C         ... protons, user defined paramters  with isospin depend.
C
          IF (SELPAR.EQ.'INPUT_WITH_ISOS') THEN
C
              NOEFFM=1
C
C             CENTRAL Woods-Saxon potential:
C
              V0DEPT=V0DEPP    ! Central potential depth parameter
              X0DEPT=X0DEPP    ! Central potential  isospin   term
              Y0DEPT=Y0DEPP    ! Central potential  m a s s   term
C
              R0RADI=R0CENP    ! Central    radius       parameter
              X0RADI=X0CENP    ! Central    radius    isospin term
              Y0RADI=Y0CENP    ! Central    radius    m a s s term
C
              A0DIFF=A0DIFP    ! Central diffuseness     parameter
              X0DIFF=X0DIFP    ! Central diffuseness  isospin term
              Y0DIFF=Y0DIFP    ! Central diffuseness  m a s s term
C
C             ...       and the corresponding SPIN-ORBIT potential
C
              S0STSO=S0LSOP    ! Spin-Orbit strength     parameter
              X0STSO=X0LSOP    ! Spin-Orbit strength  isospin term
              Y0STSO=Y0LSOP    ! Spin-Orbit strength  m a s s term
C
              R0RASO=R0SORP    ! Spin-Orbit    radius    parameter
              X0RASO=X0SORP    ! Spin-Orbit    radius   isospin  t.
              Y0RASO=Y0SORP    ! Spin-Orbit    radius   m a s s  t.
C
              A0DISO=A0DISP    ! Spin-Orbit diffuseness  parameter
              X0DISO=X0DISP    ! Spin-Orbit diffuseness isospin  t.
              Y0DISO=Y0DISP    ! Spin-Orbit diffuseness m a s s  t.
C
              SOUNIT=50.0*(1+X0DEPT*A_ISOS/A_MASS)
     *              *0.25*(HBAR_C/AMCARB)**2
          END IF
C
C         ... neutrons, user 'directly' defined parameters
C
          IF (SELPAR.EQ.'INPUT_PARSFIXED') THEN
C
              VOCENT=-ABS(VOCENP)
              ROCENT=+ABS(ROCENP)
              AOCENT=+ABS(AOCENP)
C
              SOSORB=+ABS(S0LAMP)
              ROSORB=+ABS(ROSORP)
              AOSORB=+ABS(AOSORP)
c
              SOUNIT=50.0*0.25*(HBAR_C/AMCARB)**2
C
          END IF
C
      END IF
C
C=======================================================================
C         For all isospin dependent parameters  the corresponding
C         functional dependence must be added, otherwise the user
C         calculated dependence (no explicit one here) is kept...
C=======================================================================
C
      IF (SELPAR.NE.'INPUT_PARSFIXED') THEN
C
          VOCENT=-ABS(V0DEPT)*(1+X0DEPT*A_ISOS/A_MASS+Y0DEPT/A_MASS)
          ROCENT=+ABS(R0RADI)*(1+X0RADI*A_ISOS/A_MASS+Y0RADI/A_MASS)
          AOCENT=+ABS(A0DIFF)*(1+X0DIFF*A_ISOS/A_MASS+Y0DIFF/A_MASS)
C
          SOSORB=+ABS(S0STSO)*(1+X0STSO*A_ISOS/A_MASS+Y0STSO/A_MASS)
          ROSORB=+ABS(R0RASO)*(1+X0RASO*A_ISOS/A_MASS+Y0RASO/A_MASS)
          AOSORB=+ABS(A0DISO)*(1+X0DISO*A_ISOS/A_MASS+Y0DISO/A_MASS)
C
      END IF
C
      VOSORB=SOSORB*SOUNIT
C
      R_CENT=ROCENT*A_MASS**(1./3.)
      R_SORB=ROSORB*A_MASS**(1./3.)
C
C     The parameter below is in principle a 'geometrical' radius
C     parameter;  it does not need to be equar to the  POTENTIAL
C     radius parameter - here we select to define it like that..
C
c      R0PARM=ROCENT
      RADIUS=R_CENT
C
C=======================================================================
C
C=======================================================================
C
C     IF (NOEFFM.NE.0) THEN
C
C         WRITE(NOUTPT,'(//)')
C
C         DO I=1,5
C            WRITE(NOUTPT,'(80(''!''))')
C         END DO
C
C         WRITE(NOUTPT,'(29(''!''),''                     '',
C    *                                           30(''!''))')
C
C         DO I=1,10
C            WRITE(NOUTPT,'(29(''!''),''  NO EFFECTIVE MASS  '',
C    *                                              30(''!''))')
C         END DO
C
C         WRITE(NOUTPT,'(29(''!''),''                     '',
C    *                                           30(''!''))')
C
C         DO I=1,5
C            WRITE(NOUTPT,'(80(''!''))')
C         END DO
C
C         WRITE(NOUTPT,'(//)')
C
C     END IF
C
C=======================================================================
C
      IF (.NOT.(IWRITE.EQ.3)) RETURN
C
C=======================================================================
C
      IF (SELPAR.EQ.'UNIVERSAL_DIRAC') THEN
C
          WRITE(NOUTPT,'(/,80(''#''),/,''#'',T79,''#'',/,
     *                   ''#          DIRAC FORM OF THE NUCLEAR '',
     *                   ''MEAN-FIELD HAMILTONIAN SELECTED'',T79,
     *                   ''#'',/,''#'',T79,''#'')')
C
      ELSE
C
          WRITE(NOUTPT,'(80(''#''),/,''#'',T80,''#'',/,
     *                   ''#         STANDARD FORM OF THE NUCLEAR '',
     *                   ''MEAN-FIELD HAMILTONIAN SELECTED'',T80,''#'',
     *                   /,''#'',T80,''#'')')
C
      END IF
C
      IF (ISOSPI.EQ.0) THEN
C
          WRITE(NOUTPT,'(''#########'',T71,''##########'',/,
     *                   ''#'',T33,''N E U T R O N S'',T80,''#'')')
C
      ELSE
C
          WRITE(NOUTPT,'(''#########'',T71,''##########'',/,
     *                   ''#'',T34,''P R O T O N S'',T80,''#'')')
C
      END IF
C
      WRITE(NOUTPT,'(''#           Central Potential'',T50,
     *               ''Spin-Orbit Potential          #'',/,
     *               ''#'',T80,''#'')')
C
      WRITE(NOUTPT,'(''# V0='',F6.2,'' MeV  R0='',F5.3,
     *               '' fm  A0='',F5.3,'' fm   L0='',F6.3,
     *               ''  R0='',F5.3,'' fm A0='',F5.3,'' fm #'',/,
     *               ''#'',T80,''#'')')
     *
     *               ABS(V0DEPT),R0RADI,A0DIFF,S0STSO,R0RASO,A0DISO
C
      WRITE(NOUTPT,'(''# X0='',F6.4,''      X0='',F5.3,
     *               ''     X0='',F5.3,''      X0='',F6.3,
     *               ''  X0='',F5.3,''    X0='',F5.3,''    #'')')
     *
     *               X0DEPT,X0RADI,X0DIFF,X0STSO,X0RASO,X0DISO
C
      WRITE(NOUTPT,'(''# Y0='',F6.4,''      Y0='',F5.3,
     *               ''     Y0='',F5.3,''      Y0='',F6.3,
     *               ''  Y0='',F5.3,''    Y0='',F5.3,''    #'',/,
     *               ''#'',T80,''#'')')
     *
     *               Y0DEPT,Y0RADI,Y0DIFF,Y0STSO,Y0RASO,Y0DISO
C
      WRITE(NOUTPT,'(80(''#''),/,''#'',T80,''#'',/,
     *               ''#          Implied Parameter Values for the '',
     *               ''Current Nucleus: Z='',I3,'' N='',I3,T80,''#'',/,
     *               ''#'',T80,''#'',/,
     *               ''#    V_CENT='',F7.2,'' MeV          R_CENT='',
     *               F5.3,'' fm            A_CENT='',F5.3,
     *               '' fm    #'',/,''#'',T80,''#'',/,
     *               ''#    V_SORB='',F7.3,'' MeV          R_SORB='',
     *               F5.3,'' fm            A_SORB='',F5.3,
     *               '' fm    #'',/,''#'',T80,''#'',/,80(''#''))')
     *
     *               IZ_FIX,IN_FIX,VOCENT,ROCENT,AOCENT,
     *                             VOSORB,ROSORB,AOSORB
C
      IF (SELPAR.EQ.'UNIVERSAL_DIRAC') THEN
C
          WRITE(NOUTPT,'(''#'',T80,''#'',/,
     *                   ''#    Deformation-Dependent Effective Mass'',
     *                   '' - Geometry of the Spin-Orbit Term    #'',/,
     *                   ''#'',T80,''#'',80(''#''))')
C
          WRITE(NOUTPT,'(''# DIRAC-WS'',T70,''DIRAC-WS #'',/,
     *                   ''#           Calculations run with Dirac-'',
     *                   ''Universal set of parameters            #'',/,
     *                   ''# DIRAC-WS'',T70,''DIRAC-WS #'',/,
     *                   80(''#''))')
      ELSE
C
          IF (SELPAR.EQ.'UNIVERSAL_COMPACT') THEN
C
              WRITE(NOUTPT,'(''#'',T80,''#'')')
              WRITE(NOUTPT,'(''#'',T11,
     *              ''Calculations run with Universal-'',
     *              ''Compact set of parameters           #'')')
              WRITE(NOUTPT,'(''#'',T80,''#'',/,80(''#''))')
C
          END IF
C
          IF (SELPAR.EQ.'UNIVERSAL_PARAMETERS') THEN
C
              WRITE(NOUTPT,'(''#'',T80,''#'')')
              WRITE(NOUTPT,'(''#'',T17,
     *              ''Calculations run with Universal '',
     *              ''set of parameters              #'')')
              WRITE(NOUTPT,'(''#'',T80,''#'',/,80(''#''))')
C
          END IF
C
          IF (SELPAR.EQ.'UNIVERSAL_NONCOMPACT') THEN
C
              WRITE(NOUTPT,'(''#'',T80,''#'')')
              WRITE(NOUTPT,'(''#'',T09,
     *              ''Calculations run with Universal-'',
     *              ''Non-Compact set of parameters         #'')')
              WRITE(NOUTPT,'(''#'',T80,''#'',/,80(''#''))')
C
          END IF
C
          IF (SELPAR.EQ.'WAHLBORN_PARAMETERS') THEN
C
              WRITE(NOUTPT,'(''#'',T80,''#'')')
              WRITE(NOUTPT,'(''#'',T15,
     *              ''Calculations run with Wahlborn '',
     *              ''set of parameters               #'')')
              WRITE(NOUTPT,'(''#'',T80,''#'',/,80(''#''))')
C
          END IF
C
          IF (SELPAR.EQ.'ROST_PARAMETERS') THEN
C
              WRITE(NOUTPT,'(''#'',T80,''#'')')
              WRITE(NOUTPT,'(''#'',T18,
     *              ''Calculations run with ROST '',
     *              ''set of parameters                  #'')')
              WRITE(NOUTPT,'(''#'',T80,''#'',/,80(''#''))')
C
          END IF
C
          IF (SELPAR.EQ.'CHEPURNOV_PARAMETERS') THEN
C
              WRITE(NOUTPT,'(''#'',T80,''#'')')
              WRITE(NOUTPT,'(''#'',T15,
     *              ''Calculations run with Chepurnov '',
     *              ''set of parameters              #'')')
              WRITE(NOUTPT,'(''#'',T80,''#'',/,80(''#''))')
C
          END IF
C
          IF (SELPAR.EQ.'USER_INPUT_PARAMETERS') THEN
C
              WRITE(NOUTPT,'(''#'',T80,''#'')')
              WRITE(NOUTPT,'(''#'',T15,
     *              ''Calculations run with User-Input '',
     *              ''Parameters                   #'')')
              WRITE(NOUTPT,'(''#'',T80,''#'',/,80(''#''))')
C
          END IF
C
      END IF
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C=======================================================================
C
      SUBROUTINE WS_WSDEFN(W_CENT,W_LINM,W_SORB,W_MASS,NOEFFM,
     *                            X_KART,Y_KART,Z_KART,ISOSPI)
      COMMON
     *       /NCONST_CONSTS/ HBAR_C,XMASSP,XMASSN,HCOVE2,
     *                                            E2OVHC
      COMMON
     *       /PARNAM_POTPAR/ ROCENT,AOCENT,VOCENT,R_CENT,
     *                       ROSORB,AOSORB,VOSORB,R_SORB
      COMMON
     *       /HF_MEAN_FIELD/ KHFPOT
C
C=======================================================================
C
C     Subroutine WSDEFN (Woods-Saxon definition) computes the four
C     distance-dependent terms - needed to define  the Hamiltonian.
C     These are: the central, spin-orbit and linear momentum terms
C     as well as the effective mass. The arguments of these fncnts.
C     are dimensionless; there are two transformations involved in
C     this case. Firstly, the dimensionless points, or coordinates
C     that are the zeros of the Hermite polynomials  (Gauss nodes),
C     are transformed to fermis. Secondly, the so obtained results
C     are divided by the radius-proportional object
C
C                      RCVOLM=RADIUS*CVOLFC (in fm)
C
C     and resulting geometrical distances refer  to what is called
C     reduced  shapes. In  reduced coordinates  a spherical object
C     has the radius equal to unity. In other words the reduced co-
C     ordinates are in fact the Cartesian coordinates,  normalized
C     with respect to the unit sphere.
C
C     Remark: Points that will allow to plot  the potentials  (see
C             subroutine PLOTPO) are transformed to fermis.
C
C     Attention:
C     =========    The above manipulation has been introduced only
C                  in order to operate  with the  'DISTANCES'; all
C                  functions are integrated in the non-reduced way
C
C=======================================================================
C
      W_CENT=0.0
      W_LINM=0.0
      W_SORB=0.0
                       X_MASS=XMASSN
      IF (ISOSPI.EQ.1) X_MASS=XMASSP
C
                       EFFMAS=X_MASS
C
      W_MASS=-HBAR_C**2/(2.00*X_MASS)
C
C=======================================================================
C         Woods-Saxon Hamiltonian from relativistic mean field theory
C=======================================================================
C
C                   T  H  E     P  R  I  N  C  I  P  L  E  S
C
C         In addition to the central potential distance, we will need
C         also the distance related to the spin-orbit and the derived
C         terms such as momentum potential and the effective mass all
C         the three having the same common distance function.
C
C         1. First we will calculate the distance of a point given by
C            vec(r)={x,y,z}={P} from the surface = R0ORIG*DISCEN, for
C            the central potential
C
C               R(theta,phi) = Ro c({alpha}) [1+Sum alpha ...]    (1)
C
C         2. Now we proceed to calculate the distance of {P} from yet
C            another surface given by the scaled equation
C
C               R(theta,phi) = Reff c({alpha}) [1+Sum alpha ...]  (2)
C
C         3. In other words: given vec(r), surface R(t,p) and another
C            one, scaled R'(t,p) = f R(t,p). We want to find the dist.
C            between vec(r) and R'.  Suppose that  the touching point
C            for the tangent plane is R'(t',p') - [the touching point
C            related to the original surface has coordinates given by
C            (t,p) that are in general different from (t',p')].
C
C            The scaling factor f is known. Then
C
C              dist[vec(r),R'(t',p')] = dist[vec(r),f R(t',p')]
C
C                                     = f dist[vec(r)/f,R(t',p')]
C            Observe in passing:
C
C            Scaling the surface  by a common factor  does not change
C            the angles - yet t' and p' must be found. What we are to
C            to gain here is to use the same surface definition - but
C            Newton method must be used twice anyway.
C
C         4. Suppose that the SO surface expands in the proportion of
C
C                           SCALEF = f = RoSO/R0CEN
C
C            The coordinates of the point  to which the distance will
C            be calculated transformas in the inverse proportion i.e.
C
C                                 r' = (1/f) r
C                                                J.D. OK - derivation
C=======================================================================
C
                                            I_CASE=1
      DISCEN=WS_DISTAN(X_KART,Y_KART,Z_KART,I_CASE)
C
C=======================================================================
C
C        Attention: DISCEN above is in dimensionless 'units'.  It was
C        =========  multiplied by the volume conservation factor, and
C                   since diffuseness is in fermi so is the numerator
C                                                               below
C
C=======================================================================
C
      IF (KHFPOT.EQ.0) THEN
          W_CENT=VOCENT/(1.0+EXP((R_CENT*DISCEN)/AOCENT))
      ELSE
      	  W_CENT=WS_FIT_HF(DISCEN,ISOSPI)
      END IF
C
C=======================================================================
C     The effective mass case:  the same applies to the momentum and
C     to the spin-orbit potentials.  The functions below  upon which
C     we will apply the gradient, correspond to  Vls(vec{r})  in the
C     notes.  These are NOT  total spin-orbit or momentum potentials
C                                                                yet.
C=======================================================================
C
      SCALEF=ROSORB/ROCENT
C
      X_ACTU=X_KART/SCALEF
      Y_ACTU=Y_KART/SCALEF
      Z_ACTU=Z_KART/SCALEF
                                            I_CASE=2
      DISEFF=WS_DISTAN(X_ACTU,Y_ACTU,Z_ACTU,I_CASE)
C
      WSFACT=VOSORB/(1.0+EXP((R_SORB*DISEFF)/AOSORB))
C
      IF (.NOT.(NOEFFM.EQ.1)) THEN
C
          EFFMAS=X_MASS-0.50*WSFACT
C
          HBMASS=HBAR_C**2/(2.0*EFFMAS)
C
          W_MASS=-HBMASS
C
C=======================================================================
C         Calculating the effective-mass dependent spin-orbit factor
C=======================================================================
C
          W_SORB=VOSORB
     *          /
     *          (1.0000+EXP((R_SORB*DISEFF)/AOSORB))*X_MASS/EFFMAS
C
C=======================================================================
C         Calculating the effective-mass dependent  lin.-mom. factor
C=======================================================================
C
          W_LINM=VOSORB
     *          /
     *          (1.0000+EXP((R_SORB*DISEFF)/AOSORB))*X_MASS/EFFMAS
C
      ELSE ! ... below the case of the traditional Woods-Saxon ...
C
          W_SORB=VOSORB/(1.0+EXP((R_SORB*DISEFF)/AOSORB))
C
      END IF
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C=======================================================================
C
      SUBROUTINE WS_INMESH(MESHTH)
C=======================================================================
      USE params
C=======================================================================
      COMMON
     *       /INMESH_ELDIST/ CTNAUX(1:NDMSHT,1:NDMSHF),
     *                       STNAUX(1:NDMSHT,1:NDMSHF),
     *                       CFNAUX(1:NDMSHT,1:NDMSHF),
     *                       SFNAUX(1:NDMSHT,1:NDMSHF),
     *                       RSCALN(1:NDMSHT,1:NDMSHF),
     *                       DRNTHE(1:NDMSHT,1:NDMSHF),
     *                       DRNPHI(1:NDMSHT,1:NDMSHF)
      COMMON
     *       /INMESH_STEPPH/ STEPPH(1:NDMSHT)
     *       /INMESH_MSHLIM/ MSHLIM(1:NDMSHT)
      COMMON
     *       /INITWS_NUMBRS/ PINUMB,PIOVE2
C
C=======================================================================
C         This subroutine prepares an auxiliary mesh in THETA and PHI
C         variables  used to estimate the starting points for  SYSTEM
C         when calculating the function = dist{}
C
C         IT IS CALLED ONCE PER DEFORMATION <<-- FROM THE MAIN_CALLER
C
C=======================================================================
C
      IF (MESHTH.GT.NDMSHT) STOP 'Increase NDMSHT in INMESH'
C
C=======================================================================
C
      STEPTH=PINUMB/REAL(MESHTH)
C
      MESH_2=MESHTH/2
C
C=======================================================================
C         The THETA-variation in the mesh is fixed   o n c e  per run
C=======================================================================
C
      DO ITHETA=1,MESHTH-1
C
         THETA=REAL(ITHETA)*STEPTH
C
         XCOSTH=COS(THETA)
         XSINTH=SIN(THETA)
C
C=======================================================================
C        The PHI - variation  is   calculated   d y n a m i c a l l y
C        The corresponding  number of PHI-steps first increases, then
C        reaches the maximum for THETA=pi/2 ,and then decreases again
C=======================================================================
C
                               MESHPH=5+ITHETA/2
         IF (ITHETA.GT.MESH_2) MESHPH=5+(MESHTH-ITHETA)/2
C
         IF (ITHETA.LE.4.OR.ITHETA.GE.(MESHTH-4)) THEN
C
             MESHPH=10
C
         END IF
C
         STEPFI=PINUMB/MESHPH
C
         MSHLIM(ITHETA)=MESHPH
         STEPPH(ITHETA)=STEPFI
C
         DO IPHI=1,MESHPH-1
C
            PHI=REAL(IPHI)*STEPFI
C
            NODIMS=0
            LEVELY=1
C
            CALL WS_DRSURF(THETA,PHI,RSCALN(ITHETA,IPHI),
     *                               DRNTHE(ITHETA,IPHI),
     *                               DRNPHI(ITHETA,IPHI),NODIMS,LEVELY)
C
            CTNAUX(ITHETA,IPHI)=XCOSTH
            STNAUX(ITHETA,IPHI)=XSINTH
C
            CFNAUX(ITHETA,IPHI)=COS(PHI)
            SFNAUX(ITHETA,IPHI)=SIN(PHI)
C
         END DO
C
      END DO
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C=======================================================================
C
      FUNCTION WS_DISTAN(X_ACTU,Y_ACTU,Z_ACTU,I_CASE)
C=======================================================================
      USE params
C=======================================================================
      INTEGER
     *          HISITE
      EXTERNAL
     *          WS_FNSYST
      COMMON
     *       /INMESH_ELDIST/ CTNAUX(1:NDMSHT,1:NDMSHF),
     *                       STNAUX(1:NDMSHT,1:NDMSHF),
     *                       CFNAUX(1:NDMSHT,1:NDMSHF),
     *                       SFNAUX(1:NDMSHT,1:NDMSHF),
     *                       RSCALN(1:NDMSHT,1:NDMSHF),
     *                       DRNTHE(1:NDMSHT,1:NDMSHF),
     *                       DRNPHI(1:NDMSHT,1:NDMSHF)
      COMMON
     *       /INMESH_STEPPH/ STEPPH(1:NDMSHT)
     *       /INMESH_MSHLIM/ MSHLIM(1:NDMSHT)
      COMMON
     *       /DISTAN_HISDIS/ ICALLS(1:NDCASE),IFAILS(1:NDCASE)
     *       /DISTAN_HISITR/ HISITE(1:NDCASE)
      COMMON
     *       /PARAMS_RADVOL/ RADIUS,CVOLFC,RCVOLM
      COMMON
     *       /DISTAN_SPACEP/ X_KART,Y_KART,Z_KART
      COMMON
     *       /VERIFS_SYMETS/ ISPHER,ICYLIN,IPCONS
      COMMON
     *       /INITWS_NUMBRS/ PINUMB,PIOVE2
      COMMON
     *       /DISTAN_ANGMIN/ THEMIN,PHIMIN
      COMMON
     *       /PRECISION_EPS/ EPSF_S,EPSG_S,APROAC
     *       /PRECISION_MSH/ MESHTH,ITERNS
C
C=======================================================================
C
      DATA
     *     FRIGHT,GRIGHT / 0.0, 0.0 /
C
C=======================================================================
C=======================================================================
C         Function DISTAN computes distance of a point {x,y,z} from
C         the nuclear surface.  The surface is expressed in reduced,
C         and dimensionless coordinates i.e. e.g. a spherical shape
C         is represented by a sphere of radius equal  to  U N I T Y,
C         but is multiplied here by the 'constant-volume constant'.
C=======================================================================
C=======================================================================
C
      X_KART=X_ACTU
      Y_KART=Y_ACTU
      Z_KART=Z_ACTU
C
C=======================================================================
C         In this variant of the program we still keep the xz-plane
C         as the symmetry plane. When  removing this constraint the
C         instruction below  S H O U L D   BE   E L I M I N A T E D
C         At present  this construction serves only  as a form of a
C         comment since the calling routines assure never using y<0
C=======================================================================
C
      IF (Y_KART.LT.0.0) THEN
          Y_KART=-Y_KART
      END IF
C
C=======================================================================
C         RSQUAR below is in dimensionless (and reduced) coordinates
C=======================================================================
C
      RSQUAR=X_KART*X_KART
     *      +Y_KART*Y_KART
     *      +Z_KART*Z_KART
C
      RADACT=SQRT(RSQUAR)
C
C     ... when the Hamiltonian has spherical symmetry ...
C
      IF (ISPHER.EQ.1) THEN
C
          WS_DISTAN=RADACT-1
          RETURN
C
      END IF
C
C=======================================================================
C
      ICALLS(I_CASE)=ICALLS(I_CASE)+1
C
C=======================================================================
C         Beginning the distance search for the deformed case
C=======================================================================
C
      DISMIN=1000.0
C
      STEPTH=PINUMB/REAL(MESHTH) ! Default: 30; read through NAMELI
C
C=======================================================================
C         The THETA-variation in the mesh is fixed  o n c e  per run
C         The do-loop below finds the starting point for NEWTON.  It
C         selects the coordinate of the mesh-point whose distance to
C         a point in space in question is the shortest.
C=======================================================================
C
      RMINIM=1000.0
C
      IF (I_CASE.EQ.1) THEN
C
          TH0MIN=STEPTH
C
          DO ITHETA=1,MESHTH-1
C
             THANGL=REAL(ITHETA)*STEPTH
C
C=======================================================================
C            The PHI - variation is calculated d y n a m i c a l l y
C            The corresponding number  of PHI-STEPS  first increases,
C            then reaches the maximum for THETA=PI/2, then decreases
C=======================================================================
C
             STEPFI=STEPPH(ITHETA)
C
             FI0MIN=STEPFI
C
             DO IPHIND=1,MSHLIM(ITHETA)-1
C
                PHANGL=REAL(IPHIND)*STEPFI
C
                PROJN1=+X_KART*CFNAUX(ITHETA,IPHIND)
     *                 +Y_KART*SFNAUX(ITHETA,IPHIND)
                PROJN2=-X_KART*SFNAUX(ITHETA,IPHIND)
     *                 +Y_KART*CFNAUX(ITHETA,IPHIND)
C
                XNSCAL=+STNAUX(ITHETA,IPHIND)*PROJN1
     *                 +CTNAUX(ITHETA,IPHIND)*Z_KART
C
                DNORDT=+CTNAUX(ITHETA,IPHIND)*PROJN1
     *                 -Z_KART*STNAUX(ITHETA,IPHIND)
                DNORDF=+STNAUX(ITHETA,IPHIND)*PROJN2
C
                ROVVOL=+RSCALN(ITHETA,IPHIND)/RCVOLM
                DIST_2=+ROVVOL*(ROVVOL-2.*XNSCAL)+RSQUAR
C
                IF (DIST_2.LE.DISMIN) THEN
C
                    DISMIN=DIST_2
C
                    TH0MIN=THANGL
                    FI0MIN=PHANGL
C
                    RMINIM=ROVVOL
C
                END IF
C
             END DO
          END DO
C
          THEMIN=TH0MIN
          PHIMIN=FI0MIN
C
      END IF
C
      LIMITE=ITERNS
C
C=======================================================================
C
      CALL WS_NEWTON(THEMIN,PHIMIN,FRIGHT,GRIGHT,EPSF_S,EPSG_S,
     *                          APROAC,WS_FNSYST,LIMITE,IERDIS)
C
C=======================================================================
C
      IF (IERDIS.NE.0) IFAILS(I_CASE)=IFAILS(I_CASE)+1
C
                       HISITE(I_CASE)=HISITE(I_CASE)+LIMITE
C
C=======================================================================
C
      CT0MIN=COS(THEMIN)
      ST0MIN=SIN(THEMIN)
      CF0MIN=COS(PHIMIN)
      SF0MIN=SIN(PHIMIN)
C
C=======================================================================
C
      PROJN1=+X_KART*CF0MIN+Y_KART*SF0MIN
      PROJN2=-X_KART*SF0MIN+Y_KART*CF0MIN
C
      XNSCAL=+ST0MIN*PROJN1+CT0MIN*Z_KART
C
      DNORDT=+CT0MIN*PROJN1-Z_KART*ST0MIN
      DNORDF=+ST0MIN*PROJN2
C
C=======================================================================
C
      NODIMS=0
      LEVELY=0
C
      CALL WS_RONSUR(THEMIN,PHIMIN,FORMFR,DRDTHE,DRDPHI,
     *                             D2RDTT,D2RDTP,D2RDPP,
     *                                    NODIMS,LEVELY)
C
C=======================================================================
C          RCVOLM=RADIUS*CVOLFC (in fermis, calculated in MAIN)
C          In other words:   RONSUR= c({alpha}) Ro *[1+Sum ...]
C          Below we go back to the dimensionless quantities ...
C=======================================================================
C
      FORMFR=FORMFR/RCVOLM
C
      DIST2S=FORMFR*(FORMFR-2.0*XNSCAL)+RSQUAR
C
      IF (DIST2S.LE.DISMIN) THEN
C
          DISMIN=DIST2S
          RMINIM=FORMFR
C
      END IF
C
      IF (DISMIN.LT.0.00) DISMIN=-DISMIN
C
      DISACT=SQRT(DISMIN)
C
C=======================================================================
C           Calculating  the  PHASE OUTSIDE / PHASE INSIDE  sign
C=======================================================================
C
                            POUTSD=-1.00
      IF (RADACT.GT.RMINIM) POUTSD=+1.00
C
C=======================================================================
C         Distance below is in REDUCED VARIABLES i.e. it depends
C         on the 'constant volume' constant but is divided by Ro
C=======================================================================
C
      WS_DISTAN=DISACT*POUTSD*CVOLFC
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C=======================================================================
C
      FUNCTION WS_WSCENT(X_KART,Y_KART,Z_KART)
      COMMON
     *       /PARNAM_POTPAR/ ROCENT,AOCENT,VOCENT,R_CENT,
     *                       ROSORB,AOSORB,VOSORB,R_SORB
C
C=======================================================================
C      Function WSCENT computes the central part of the total potential
C      We keep it for convenience when tabulating/plotting
C=======================================================================
C
                                            I_CASE=1
      DISCEN=WS_DISTAN(X_KART,Y_KART,Z_KART,I_CASE)
C
      WS_WSCENT=VOCENT/(1.0+EXP((R_CENT*DISCEN)/AOCENT))
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C=======================================================================
C
      FUNCTION WS_COULFY(X,Y,Z)
C=======================================================================
      USE params
C=======================================================================
      COMMON
     *       /NCONST_CONSTS/ HBAR_C,XMASSP,XMASSN,HCOVE2,E2OVHC
      COMMON
     *       /PARAMS_RADVOL/ RADIUS,CVOLFC,RCVOLM
      COMMON
     *       /VERIFS_SYMETS/ ISPHER,ICYLIN,IPCONS
      COMMON
     *       /QGFOLD_BTHBFI/ NN_THE,NN_PHI
C
      COMMON
     *       /DRSURF_THEPHI/ R_OFTP(1:ND_THE,1:ND_PHI),
     *                       DRDTHE(1:ND_THE,1:ND_PHI),
     *                       DRDPHI(1:ND_THE,1:ND_PHI)
      COMMON
     *       /QGFOLD_SINCOS/ SIN_PH(1:NDPHTH),COS_PH(1:NDPHTH),
     *                       SIN_TH(1:NDPHTH),COS_TH(1:NDPHTH)
      COMMON
     *       /Q2GAUS_POINTS/ XPOINT(1:NDPHTH),YPOINT(1:NDPHTH),
     *                       XWEIGH(1:NDPHTH),YWEIGH(1:NDPHTH)
C
      COMMON
     *       /NUCLEONIC_NUM/ IZ_ACT,IN_ACT
     *       /YUKAWAPOT_DIF/ DIFYUK,V0SHRP,V0DIFF
     *       /YUKAWAPOT_MOD/ IF_YUK,MODCOU
C
C=======================================================================
C
C       This subroutine calculates the Coulomb potential  at a single
C       point {x,y,z}. Optionally, the Folded-Yukawa diffuseness term
C       can be included (if MODCOU > 1). The arguments in the head of
C       the declaration are understood as divided by the radius (unit
C       sphere)
C
C=======================================================================
C
      IF (MODCOU.GT.1.AND.ISPHER.EQ.1) THEN
C
          STOP 'MODCOU.GT.1.AND.ISPHER.EQ.1 not implemented YET'
C
      END IF
C
C=======================================================================
C
      IF (ISPHER.EQ.1) THEN
C
          WS_COULFY = WS_COUSPH(X,Y,Z)
          RETURN
C
      END IF
C
C=======================================================================
C     Proceeding to the deformed case (if the nucleus was not sph.)
C=======================================================================
C
      CSHRPT=0.0
      VSHRPT=0.0
      VDIFFT=0.0
C
      DO ITHANG=1,2*NN_THE
C
         CSHRPF=0.0
         VSHRPF=0.0
         VDIFFF=0.0
C
         DO IFIANG=1,2*NN_PHI
C
C=======================================================================
C           Calculating the surface-integration element (R-R')*DS
C=======================================================================
C
            R=R_OFTP(ITHANG,IFIANG)/RCVOLM
C
            P=X*COS_PH(IFIANG)
     *       +Y*SIN_PH(IFIANG)
C
            Q=R*SIN_TH(ITHANG)
C
C=======================================================================
C           Summing up the terms: E.R.**2, E.TH.**2, AND E.PH.**2
C=======================================================================
C
            WR=+P*SIN_TH(ITHANG)+Z*COS_TH(ITHANG)-R
            WT=+P*COS_TH(ITHANG)-Z*SIN_TH(ITHANG)
            WF=-X*SIN_PH(IFIANG)+Y*COS_PH(IFIANG)
C
C=======================================================================
C           DIST  below  is equal to    ABS(R.Vector - R'.Vector)
C=======================================================================
C
            DISTFS=SQRT(WR*WR+WT*WT+WF*WF)
C
            W1=WR*R*Q
            W2=WT*Q*DRDTHE(ITHANG,IFIANG)/RCVOLM
            W3=WF*R*DRDPHI(ITHANG,IFIANG)/RCVOLM
C
            W=W1 - W2- W3
C
            CSHRPF=CSHRPF+YWEIGH(IFIANG)*W*WS_VCSHRP(DISTFS)
C
            IF (MODCOU.GT.1) THEN
                VSHRPF=VSHRPF+YWEIGH(IFIANG)*W*WS_VNSHRP(DISTFS)
                VDIFFF=VDIFFF+YWEIGH(IFIANG)*W*WS_VNDIFF(DISTFS)
            END IF
C
         END DO
C
         CSHRPT=CSHRPT+CSHRPF*XWEIGH(ITHANG)
C
         IF (MODCOU.GT.1) THEN
             VSHRPT=VSHRPT+VSHRPF*XWEIGH(ITHANG)
             VDIFFT=VDIFFT+VDIFFF*XWEIGH(ITHANG)
         END IF
C
      END DO
C
      PINUMB=+4.0000*ATAN(1.0)
C
      RO0CHG=+0.7500*REAL(IZ_ACT-1)/PINUMB*HBAR_C*E2OVHC
C
      WS_COULFY=-0.5000*RO0CHG*CSHRPT*CVOLFC**2/RADIUS
C
C=======================================================================
C
      IF (MODCOU.GT.1) THEN
C
          WS_COULFY=WS_COULFY+V0SHRP*VSHRPT
     *                       +V0DIFF*VDIFFT
C
      END IF
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C=======================================================================
C
      FUNCTION WS_VCSHRP(DISTFS)
C
C=======================================================================
C         Auxiliary function integrated over the surface after applying
C         the  divergence  theorem, s e e:   Davies & Nix,   Eq. (3.11)
C         to calculate the Coulomb-sharp surface potential
C=======================================================================
C
      WS_VCSHRP=1.0/DISTFS
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C=======================================================================
C
      FUNCTION WS_COUFIT(IZ_FIX,IN_FIX,R0CENT,ROCOUL)
      COMMON
     *       /NCONST_CONSTS/ HBAR_C,XMASSP,XMASSN,HCOVE2,E2OVHC
C
C=======================================================================
C
C        This function calculates the spherical Coulomb potential using
C        an analytic expression - for the uniformly charged sphere. The
C        latter is defined by:
C
C              Vc(r) = (Z-1)e^2/r               r>R
C                    = (Z-1)e^2/2R * [3 - r^2]  r<R
C
C        The point  (X,Y,Z)  is normalized to the unit sphere,  that is
C
C                  X = Xreal/RCVOLM etc.
C
C        It is assumed that the geometry of the charge distribution may
C        differ from that of the central potential. In other words, the
C        R above is  NOT  the radius of the sphere, but a radius ROCOUL
C        which can be set to any  (realistic)  value. The formula above
C        is therefore slightly modified to take that into account.
C
C=======================================================================
C
      A_MASS=REAL(IZ_FIX+IN_FIX)
      ROCOUL=R0CENT*A_MASS**(1.0/3.0)
C
      WS_COUFIT=1.5*REAL(IZ_FIX-1)*E2OVHC/ROCOUL*HBAR_C
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C=======================================================================
C
      FUNCTION WS_COUSPH(X,Y,Z)
      COMMON
     *       /NCONST_CONSTS/ HBAR_C,XMASSP,XMASSN,HCOVE2,E2OVHC
      COMMON
     *       /PARAMS_RADVOL/ RADIUS,CVOLFC,RCVOLM
C
      COMMON
     *       /NUCLEONIC_NUM/ IZ_ACT,IN_ACT
     *       /COUFACTOR_PRO/ COUFAC
C
C=======================================================================
C        This function calculates the spherical Coulomb potential using
C        an analytic expression for the uniformly charged sphere
C=======================================================================
C
      RMODIF=RCVOLM*COUFAC
C
      UNIT_R=SQRT(X*X+Y*Y+Z*Z)
C
      IF (UNIT_R.LT.1.0) THEN
C
          COULOM=REAL(IZ_ACT-1)*HBAR_C*E2OVHC*0.5/RMODIF
     *                                *(3.0000-UNIT_R**2)
      ELSE
          COULOM=REAL(IZ_ACT-1)*HBAR_C*E2OVHC/(UNIT_R*RMODIF)
C
      END IF
C
      WS_COUSPH=COULOM
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C=======================================================================
C
      FUNCTION WS_VNSHRP(DISTFS)
      COMMON
     *       /YUKAWAPOT_DIF/ DIFYUK,V0SHRP,V0DIFF
C
C=======================================================================
C         Auxiliary function integrated over the surface after applying
C         the  divergence  theorem, s e e:   Davies & Nix,   EQ. (3.11)
C         to calculate the Coulomb-sharp surface potential
C=======================================================================
C
      DIFFY2=DIFYUK*DIFYUK
      ARUMNT=DISTFS/DIFYUK
C
      FACTOR=(1.0+ARUMNT)*EXP(-ARUMNT)
      FACTOR= 1.0-FACTOR
C
      WS_VNSHRP=DIFFY2/DISTFS**3*FACTOR
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C=======================================================================
C
      FUNCTION WS_VNDIFF(DISTFS)
      COMMON
     *       /YUKAWAPOT_DIF/ DIFYUK,V0SHRP,V0DIFF
C
C=======================================================================
C         Auxiliary function integrated over the surface after applying
C         the  divergence  theorem, s e e:   Davies & Nix,   EQ. (3.12)
C         here - to obtain the diffused part of the folded - Yukawa pot.
C=======================================================================
C
      DIFFY2=DIFYUK*DIFYUK
      ARGUMT=DISTFS/DIFYUK
C
      FACTOR=(1.0+ARGUMT)*EXP(-ARGUMT)
      FACTOR= 1.0-FACTOR
C
      WS_VNDIFF=DIFFY2/DISTFS**3*FACTOR
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C=======================================================================
C
      FUNCTION WS_FIT_HF(DISTAN,ISOSPI)
C=======================================================================
      USE params
C=======================================================================
C
      DIMENSION
     *          XENTRY(1:NDPNTS),YENTRY(1:NDPNTS),Y2A(1:NDPNTS)
C
      COMMON
     *       /HF_POTENTIALS/ X_LARG(1:NDPNTS),VNLARG(1:NDPNTS),
     *                                        VPLARG(1:NDPNTS)
      COMMON
     *       /HF_MESH_SIZES/ NXLARG,NYLARG,NZLARG
      COMMON
     *       /SETBAS_HOMOSC/ HBAROX,HBAROY,HBAROZ,
     *                       SQXFAC,SQYFAC,SQZFAC,
     *                                     HOMOSC
     *
     *       /SETBAS_CENMAS/ XCMPOS,YCMPOS,ZCMPOS
      COMMON
     *       /PARAMS_RADVOL/ RADIUS,CVOLFC,RCVOLM
C
C=======================================================================
C
      NYHALF=NYLARG/2
      NZHALF=NZLARG/2
C
      NPOINT=NXLARG
C
      DISTHF=DISTAN*RCVOLM
C
      IF (ISOSPI.EQ.0) THEN
C
          DO IX=1,NXLARG
             XENTRY(IX)=X_LARG(IX)*SQXFAC+XCMPOS
             YENTRY(IX)=VNLARG(IX)
          END DO
C
          YP1 = (YENTRY(2) - YENTRY(1))/(XENTRY(2) - XENTRY(1))
          YPN = (YENTRY(NXLARG) - YENTRY(NXLARG-1))
     *         /(XENTRY(NXLARG) - XENTRY(NXLARG-1))
C
c      write(6,'(''YP1 = '',f20.14,'' YPN = '',f20.14)') YP1,YPN
c      do i=1,NXLARG
c         write(6,'(''i = '',i4,'' Y2A = '',f20.14)')
c     *               i,Y2A(i)
c      END DO
C
          CALL SPLINE(XENTRY,YENTRY,NPOINT,YP1,YPN,Y2A,IERROR)
C
          WS_FIT_HF = SPLINT(XENTRY,YENTRY,Y2A,NPOINT,DISTHF)
C
      END IF
C
      IF (ISOSPI.EQ.1) THEN
C
          DO IX=1,NXLARG
             XENTRY(IX)=X_LARG(IX)*SQXFAC+XCMPOS
             YENTRY(IX)=VPLARG(IX)
          END DO
C
          YP1 = (YENTRY(2) - YENTRY(1))/(XENTRY(2) - XENTRY(1))
          YPN = (YENTRY(NXLARG) - YENTRY(NXLARG-1))
     *         /(XENTRY(NXLARG) - XENTRY(NXLARG-1))
C
          CALL SPLINE(XENTRY,YENTRY,NPOINT,YP1,YPN,Y2A,IERROR)
C
          WS_FIT_HF = SPLINT(XENTRY,YENTRY,Y2A,NPOINT,DISTHF)
C
      END IF
C
c      write(6,'(''ISOSPI = '',i4,'' x = '',f20.14,
c     *          '' V(x) = '',f20.14)') ISOSPI,DISTAN,
c     *             WS_FIT_HF
C
      RETURN
      END
C
C=======================================================================
C=======================================================================
C
      SUBROUTINE INTER2(X1,X2,X3,Y1,Y2,Y3,A,B,C)
C
C=======================================================================
C         Parabolic interpolation routine. Finds the interpolated
C         value of a function known in the three points X1,X2,X3
C=======================================================================
C
      A=(Y2-Y1)/(X2-X1)-(Y3-Y1)/(X3-X1)
      A=A/(X2-X3)
C
      B=(Y2-Y1)/(X2-X1)-A*(X2+X1)
C
      C=Y1-A*X1*X1-B*X1
C
      RETURN
      END
C
C=======================================================================
C=======================================================================
C
      FUNCTION SPLINT(XENTRY,YENTRY,Y2A,NPOINT,XARGUM)
C
      DIMENSION
     *          XENTRY(1:NPOINT),YENTRY(1:NPOINT),Y2A(1:NPOINT)
C
C=======================================================================
C
C       Cubic spline interpolation. Given the arrays XENTRY and YENTRY of
C       length NPOINT  (of x- and y- values of a function;  XENTRY must be
C       in ascending order).  For the array of second derivatives,
C       Y2A, the routine gives the value of the function in point
C       XARGUM. The vector Y2A can be obtained by using the
C       routine SPLINE given below (SPLINE is called only once)
C
C=======================================================================
C
      KLOWER=1
      KHIGHR=NPOINT
C
   1  IF (KHIGHR-KLOWER.GT.1) THEN
          K=(KHIGHR+KLOWER)/2
          IF (XENTRY(K).GT.XARGUM) THEN
              KHIGHR=K
          ELSE
              KLOWER=K
          END IF
          GO TO 1
      END IF
C
      HLNGTH=XENTRY(KHIGHR)-XENTRY(KLOWER)
C
      IF (HLNGTH.EQ.0) STOP 'SPLINT01'
C
      A=(XENTRY(KHIGHR)-XARGUM)/HLNGTH
      B=(XARGUM-XENTRY(KLOWER))/HLNGTH
C
      SPLINT=A*YENTRY(KLOWER)+B*YENTRY(KHIGHR)
     *                  +((A**3-A)*Y2A(KLOWER)
     *                  + (B**3-B)*Y2A(KHIGHR))*(HLNGTH**2)/6.0D0
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C=======================================================================
C
      SUBROUTINE SPLINE(X,Y,N,YP1,YPN,Y2,IERROR)
C=======================================================================
      USE params
C=======================================================================
C
      DIMENSION
     *           X(N),Y(N),Y2(N),U(NDSPLN)
C
C=======================================================================
C
C     Given X and Y (x's and y's of a function) the routine gives
C     the array Y2 of length N containing the second derivatives of
C     the function. YP1 and YPN are the values of the first deriva-
C     tive at first and last points. The value .GT.1.D+30 means that
C     natural spline is to be used at this point.
C
C=======================================================================
C
                                 IERROR=0
      IF (N.LT.4.OR.N.GT.NDSPLN) IERROR=1
C
C=======================================================================
C
      IF (YP1.GT.0.99D+30) THEN
          Y2(1)=0.0D0
          U(1)=0.0D0
      ELSE
          Y2(1)=-0.5D0
          U(1)=(3.0D0/(X(2)-X(1)))*((Y(2)-Y(1))/(X(2)-X(1))-YP1)
      END IF
C
      DO I=2,N-1
         SIG=(X(I)-X(I-1))/(X(I+1)-X(I-1))
         P=SIG*Y2(I-1)+2.0D0
         Y2(I)=(SIG-1.0D0)/P
         U(I)=(6.0D0*((Y(I+1)-Y(I))/(X(I+1)-X(I))-(Y(I)-Y(I-1))
     *        /(X(I)-X(I-1)))/(X(I+1)-X(I-1))-SIG*U(I-1))/P
      END DO
C
      IF (YPN.GT.0.99D+30) THEN
          QN=0.0D0
          UN=0.0D0
      ELSE
          QN=0.5D0
          UN=(3.0D0/(X(N)-X(N-1)))*(YPN-(Y(N)-Y(N-1))/(X(N)-X(N-1)))
      END IF
C
      Y2(N)=(UN-QN*U(N-1))/(QN*Y2(N-1)+1)
C
      DO K=N-1,1,-1
         Y2(K)=Y2(K)*Y2(K+1)+U(K)
      END DO
C
C=======================================================================
C
      END
C
C=======================================================================
C=======================================================================
C
      SUBROUTINE WS_SPECIA()
C=======================================================================
      USE params
C=======================================================================
C
      CHARACTER
     *          FILEHF*40
C
      DIMENSION
     *          W_NODE(1:NDGAUS,1:NDKART),
     *          X_NODE(1:NDGAUS,1:NDKART)
      DIMENSION
     *          VN_CEN(NDXHRM,NDYHRM,NDZHRM),
     *          VP_CEN(NDXHRM,NDYHRM,NDZHRM)
C
      COMMON
     *       /HF_POTENTIALS/ X_LARG(1:NDPNTS),VNLARG(1:NDPNTS),
     *                                        VPLARG(1:NDPNTS)
      COMMON
     *       /HF_MESH_SIZES/ NXLARG,NYLARG,NZLARG
C
C=======================================================================
C
      NFISPE=54
      FILEHF='hfodd_potential.dat'
C
      OPEN(NFISPE,FILE=FILEHF,STATUS='OLD',FORM='UNFORMATTED')
C
      READ(NFISPE) NXNODE,NYNODE,NZNODE
C
      READ(NFISPE) ((W_NODE(I_NODE,I_KART),X_NODE(I_NODE,I_KART),
     *                      I_NODE=1,NXNODE),
     *                      I_KART=1,NDKART)
C
      READ(NFISPE) (((VN_CEN(IX,IY,IZ),VP_CEN(IX,IY,IZ),
     *                       IX=1,NXNODE),
     *                       IY=1,NYNODE),
     *                       IZ=1,NZNODE)
      DO IZ=1,NZNODE
         DO IY=1,NYNODE
            DO IX=1,NXNODE
               VN_CEN(IX,IY,IZ)=VN_CEN(IX,IY,IZ)
     *                         *EXP(-(X_NODE(IX,1)**2
     *                               +X_NODE(IY,2)**2
     *                               +X_NODE(IZ,3)**2))
               VP_CEN(IX,IY,IZ)=VP_CEN(IX,IY,IZ)
     *                         *EXP(-(X_NODE(IX,1)**2
     *                               +X_NODE(IY,2)**2
     *                               +X_NODE(IZ,3)**2))
            END DO
         END DO
      END DO
C
      DO KARTEZ=1,NDKART
         DO I=1,NXNODE
            X_NODE(I,KARTEZ)=X_NODE(I,KARTEZ)/SQRT(2.0)
         END DO
      END DO
C
      NXHALF =  NXNODE/2
      NYHALF =  NYNODE/2
      NZHALF =  NZNODE/2
C
      NXLARG =2*NXNODE
      NYLARG =2*NYNODE
      NZLARG =2*NZNODE
C
      X0 =  X_NODE(1,1)
      Y0 =  VN_CEN(1,NYHALF,NZHALF)
      S  = (VN_CEN(1,NYHALF,NZHALF) - VN_CEN(2,NYHALF,NZHALF))
     *   / (X_NODE(1,1) - X_NODE(2,1))
C
      B = -S/Y0
      A = Y0*EXP(B*X0)
C
c      write(6,'(''X0 = '',f20.14,'' Y0 = '',f20.14,'' S = '',f20.14)')
c     *            X0,Y0,S
cC
c      write(6,'(''A = '',e20.14,'' B = '',f20.14)')
c     *            A,B
C
      DO IX=1,NXHALF
         X_LARG(IX)=2.0*X_NODE(1,1) - REAL(IX-1)/REAL(NXHALF)
     *                * X_NODE(1,1)
         VNLARG(IX)=A*EXP(-B*X_LARG(IX))
      END DO
C
      DO IX=NXHALF+1,NXHALF+NXNODE
C
         X_LARG(IX)=X_NODE(IX-NXHALF,1)
C
c         X1 = X_NODE(NYHALF-1,2)
c         X2 = X_NODE(NYHALF,  2)
c         X3 = X_NODE(NYHALF+1,2)
cC
c         Y1 = X_NODE(NYHALF-1,3)
c         Y2 = X_NODE(NYHALF,  3)
c         Y3 = X_NODE(NYHALF+1,3)
cC
c         Z1 = VN_CEN(IX-NXHALF,NYHALF-1,NZHALF)
c         Z2 = VN_CEN(IX-NXHALF,NYHALF,  NZHALF)
c         Z3 = VN_CEN(IX-NXHALF,NYHALF+1,NZHALF)
cC
c         CALL INTER2(X1,X2,X3,Y1,Y2,Y3,A,B,C)
cC
c         X1 = X_NODE(NZHALF-1,3)
c         X2 = X_NODE(NZHALF,  3)
c         X3 = X_NODE(NZHALF+1,3)
cC
c         Y1 = VN_CEN(IX-NXHALF,NYHALF,NZHALF-1)
c         Y2 = VN_CEN(IX-NXHALF,NYHALF,NZHALF)
c         Y3 = VN_CEN(IX-NXHALF,NYHALF,NZHALF+1)
cC
c         CALL INTER2(X1,X2,X3,Y1,Y2,Y3,D,E,F)
C
         VNLARG(IX)=VN_CEN(IX-NXHALF,NYHALF,NZHALF)
C
      END DO
C
      DO IX=NXHALF+NXNODE+1,2*NXNODE
         X_LARG(IX)=X_NODE(NXNODE,1) + REAL(IX-NXHALF-NXNODE)
     *                                /REAL(NXHALF)
     *            * X_NODE(NXNODE,1)
         VNLARG(IX)=A*EXP(B*X_LARG(IX))
      END DO
C
      DO IX=1,NXLARG
         write(6,'(''x = '',f20.14,'' V(x) = '',f20.14)')
     *               X_LARG(IX),VNLARG(IX)
      END DO
C
      X0 =  X_NODE(1,1)
      Y0 =  VP_CEN(1,NYHALF,NZHALF)
      S  = (VP_CEN(1,NYHALF,NZHALF) - VP_CEN(2,NYHALF,NZHALF))
     *   / (X_NODE(1,1) - X_NODE(2,1))
C
      B = -S/Y0
      A = Y0*EXP(B*X0)
C
c     write(6,'(''X0 = '',f20.14,'' Y0 = '',f20.14,'' S = '',f20.14)')
c    *            X0,Y0,S
cC
c     write(6,'(''A = '',e20.14,'' B = '',f20.14)')
c    *            A,B
C
      DO IX=1,NXHALF
         X_LARG(IX)=2.0*X_NODE(1,1) - REAL(IX-1)/REAL(NXHALF)
     *                * X_NODE(1,1)
         VPLARG(IX)=A*EXP(-B*X_LARG(IX))
      END DO
C
      DO IX=NXHALF+1,NXHALF+NXNODE
         X_LARG(IX)=X_NODE(IX-NXHALF,1)
         VPLARG(IX)=VN_CEN(IX-NXHALF,NYHALF,NZHALF)
      END DO
C
      DO IX=NXHALF+NXNODE+1,2*NXNODE
         X_LARG(IX)=X_NODE(NXNODE,1) + REAL(IX-NXHALF-NXNODE)
     *                                /REAL(NXHALF)
     *            * X_NODE(NXNODE,1)
         VPLARG(IX)=A*EXP(B*X_LARG(IX))
      END DO
C
      DO IX=1,NXLARG
         X_LARG(IX)=-X_LARG(IX)
      END DO
C
c      DO IX=1,NXLARG
c         write(6,'(''x = '',f20.14,'' V(x) = '',f20.14)')
c     *               X_LARG(IX),VPLARG(IX)
c      END DO
C
      CLOSE(NFISPE)
C
C=======================================================================
C
      RETURN
      END
C
