C FILE NAME = wsu04_hami_06.f   ! Keep this symbol here: $ident@string$
C
C=======================================================================
C=======================================================================
C=====                                ==================================
C=====  HAMILTONIAN-CONSTRUCTION SET  ==================================
C=====                                ==================================
C=======================================================================
C=======================================================================
C
      SUBROUTINE WS_SETBAS(IZ_FIX,IN_FIX,ISOSPI,NOSCIL,NLIMIT,ENECUT,
     *                                   IOPTGS,NXHERM,NYHERM,NZHERM,
     *                                   FCHOM0,BASEX2,BASEY2,BASEZ2,
     *                                   ISOTRO,NXMAXX,NYMAXX,NZMAXX)
C=======================================================================
      USE params
C=======================================================================
C
      CHARACTER
     *          DIGITS(0:99)*2,OPTIMU(0:1)*33
C
      DIMENSION
     *          EBASIS(1:NDBTOT),NBASIS(1:NDBTOT)
      DIMENSION
     *          HOMSHF(1:NDKART)
C
      COMMON
     *       /SETBAS_INDICE/ INDICE(0:NDXMAX,0:NDYMAX,0:NDZMAX)
     *
     *       /SETBAS_BASIS1/ LAXOFY(0:NDYMAX),LAXOFZ(0:NDZMAX),
     *                       LAYOFZ(0:NDZMAX),LAYOFX(0:NDXMAX),
     *                       LAZOFX(0:NDXMAX),LAZOFY(0:NDYMAX)
     *
     *       /SETBAS_BASIS2/ LAXOYZ(0:NDYMAX,0:NDZMAX),
     *                       LAYOZX(0:NDZMAX,0:NDXMAX),
     *                       LAZOXY(0:NDXMAX,0:NDYMAX)
     *
     *       /SETBAS_PARIND/ INDPAR(1:NDBASE,0:NDPARI)
     *       /SETBAS_PARDIM/          LDBASP(0:NDPARI)
     *       /SETBAS_SCALNG/          HOMSCA(1:NDKART)
     *
     *       /SETBAS_HOMOSC/ HBAROX,HBAROY,HBAROZ,
     *                       SQXFAC,SQYFAC,SQZFAC,
     *                                     HOMOSC
     *
     *       /SETBAS_CENMAS/ XCMPOS,YCMPOS,ZCMPOS
     *
     *       /SETBAS_NOSMAX/ MAXBNX,MAXBNY,MAXBNZ,
     *                                     NOSMAX
     *
     *       /SETBAS_NXNYNZ/ NXVECT(1:NDBASE),
     *                       NYVECT(1:NDBASE),
     *                       NZVECT(1:NDBASE)
     *
     *       /SETBAS_BASLAB/ NXVLAB(1:NDBASE),
     *                       NYVLAB(1:NDBASE),
     *                       NZVLAB(1:NDBASE)
     *
     *       /SETBAS_PLANCK/ HBMASS,HBMRPA
     *
     *       /SETBAS_CHARGE/ ECHAR2
     *       /SETBAS_EXCHAN/ COULEX
     *       /SETBAS_DIMENS/ LDBASE
C
      COMMON
     *       /NCONST_CONSTS/ HBAR_C,XMASSP,XMASSN,HCOVE2,E2OVHC
      COMMON
     *       /PARAMS_RADVOL/ RADIUS,CVOLFC,RCVOLM
      COMMON
     *       /READWRITE_PAR/ NOUTPT,IWRITE,ISCREN
C
      DATA
     *      OPTIMU /'                                 ',
     *              'Retained numbers of Gauss points:'/
C
C=======================================================================
C
C     In this program, the definitions of the H_BAR, MASS, and E^2
C     factors can be chosen as follows (if NUNITS='OLD'):
C
C                    H_BAR*C    = 197.32891 MeV*fm
C                    MASS *C^2  = 938.90590 MeV
C                    H_BAR*C/E2 = 137.03602
C
C     These particular values exist,  at present, in  a l l  other
C     Woods-Saxon codes. We can also choose the newer experimental
C     set based on the Review of Particle Physics (1996),  setting
C     the variable NUNITS='NEW'.
C
C     The kinetic energy coefficient is denoted as:
C
C                    HBMASS = HBAR_C^2/(2*XMASSN)
C
C     The kinetic energy coefficient  containing the 'recoil term'
C     is denoted:
C                    HBMRPA = HBAR_C^2/(2*XMASSN)*(1-1/A)
C
C     In the case of the Dirac version of the hamiltonian there is
C     the position dependent  effective mass  which enters through
C
C                    XMASSN -> XMASSN-0.5*W_S_FORM_FACTOR
C
C     The Hartree-Fock codes (coordinate space codes) use:
C
C                    H_BAR = 6.582180 MeV * 10**(-22)  sec
C                    MASS  = 1.044673 MeV * 10**(-22) (sec/fm)^2
C
C     These codes  use only the combination of  HBM = H_BAR^2/MASS
C
C     Older Hartree - Fock codes, using the cylindrical oscillator
C     basis  have directly  HBM=HBAR_C^2/(2*XMASSN).  Numerically:
C
C                      HBM = 20.73 MeV*fm^2
C
C     The e^2 factor  used in the Coulomb potential  is defined as
C
C                      e**2 = HBAR_C/HCOVE2*MeV*fm
C
C=======================================================================
C
C     The user may select to use  either the natural values of the
C     nucleonic masses (NUCAVR='REALVAL') or the average values of
C     the proton and neutron masses (NUCAVR='AVERAGE'). However in
C     the fitting of the potential strengths, usually one of these
C     choices has been predefined - consequently one should use it
C     with some care
C
C=======================================================================
C
C=======================================================================
C     This subroutine defines  the basis parameters  and the basis
C     itself for the numerical integration of the hamiltonian
C=======================================================================
C
C     Meaning of some parameters:
C
C     LAXOFY = the last index in the direction X related to Y, i.e.
C              the maximum value of the  Nx  within the oscillator
C                                               basis for fixed Ny
C
C     LAXOFZ -> ... LAZOFY  -> similar to LAXOFY but for remaining
C                        other combinations of the axis-directions
C
C     LAXOYZ -> similar  to the previous  ones but limited  by the
C                        two other actual  quantum  numbers  fixed
C
C=======================================================================
C
C     NOSCIL = The maximum number of the harmonic oscillator shell
C              that will be used in the BASIS TEST as follows.
C
C              When deforming the HO basis some states coming from
C              the very high shells may come down in energy. We do
C              allow for a very large number of NOSCIL and next we
C              find the  l a r g e s t  HO  shell that contributes
C              to the basis within a prescribed basis cut-off. The
C              parameter  NOSCIL  should not be confused  with the
C              total number of the shells in the three-dimensional
C              oscillator (N_OSCI below); here we consider all the
C              one-dimensional shells from 0 to NOSCIL.
C
C=======================================================================
C
C     The HO basis dimensions that correspond to a use of the full
C     shells are given by the following reference formula:
C
C                   NDIMEN = ((N_MAIN+2)**3-(N_MAIN+2))/6
C
C     When using all the 3-D shells  up to the shell no N_MAIN, we
C     have the following dimensions of the basis:
C
C                   n_main=n    -> (n+1)(n+2)(n+3)/6
C
C                   N_MAIN= 7   ->    NDIMEN = 120
C                   N_MAIN= 8   ->    NDIMEN = 165
C                   N_MAIN= 9   ->    NDIMEN = 220
C                   N_MAIN=10   ->    NDIMEN = 286
C                   N_MAIN=11   ->    NDIMEN = 364
C                   N_MAIN=12   ->    NDIMEN = 455
C                   N_MAIN=13   ->    NDIMEN = 560
C                   N_MAIN=14   ->    NDIMEN = 680
C                   N_MAIN=15   ->    NDIMEN = 816
C                   N_MAIN=16   ->    NDIMEN = 969
C                   N_MAIN=17   ->    NDIMEN =1140
C                   N_MAIN=18   ->    NDIMEN =1330
C                   N_MAIN=19   ->    NDIMEN =1540
C                   N_MAIN=20   ->    NDIMEN =1771
C
C     Repeat: The above information should not be misunderstood
C             NOSCIL and N_MAIN have different meaning.
C
C=======================================================================
C
C     HBARO{} - HBAR-OMEGA O_x, O_y or O_z; oscillator frequencies
C
C     SQ{}FAT - Derivative - stretching factors for O_x, _y, OR _z
C               axis variables.  They are used  to define  all the
C               dimensioned variables
C
C               SQ{}FAT = SQRT( MASS * HBARO{} / H_BAR**2 )
C
C               KSI {}  = SQ{}FAT * (variable)
C
C     N{}MAXX - The maximum  quantum numbers  within  the harmonic
C               oscillator shells in the O_x, O_y or O_z direction
C
C=======================================================================
C
C     NLIMIT  - B A S I S   D E F I N I T I O N  P A R A M E T E R
C
C               either non-positive (ENECUT defines the energy cut)
C               or positive, in which case the total number of the
C               retained basis states will be equal to NLIMIT
C
C=======================================================================
C
C
      IF (NOSCIL.GT.NDOSCI) STOP 'NOSCIL.GT.NDOSCI in SETBAS'
C
C
C=======================================================================
C
C
      HBMASS=HBAR_C**2/(2.000*XMASSN)
C
      HBMRPA=HBMASS*(1.0-1.0/(IZ_FIX+IN_FIX))
C
C     HBMRPA=HBMASS
C     PRINT *,'ATTENTION: NO STANDARD CENTER-OF-MASS CORRECTION'
C
      ECHAR2=HBAR_C/HCOVE2
C
      PINUMB=+ 4.0*ATAN(1.0)
C
      COULEX=-(3.0/4.000000)*(3.0/PINUMB)**(1.0/3.0)*ECHAR2
C
C=======================================================================
C
      HOMOSC=41.0*FCHOM0/REAL(IZ_FIX+IN_FIX)**(1.0/3.0)
C
      RXYRTO=SQRT(BASEX2/BASEY2)
      RYZRTO=SQRT(BASEY2/BASEZ2)
      RXZRTO=SQRT(BASEX2/BASEZ2)
C
      HBAROX=HOMOSC*(RXYRTO*RXZRTO)**(-1.0/3.0)
      HBAROY=HOMOSC*(RXYRTO/RYZRTO)**(+1.0/3.0)
      HBAROZ=HOMOSC*(RXZRTO*RYZRTO)**(+1.0/3.0)
C
C=======================================================================
C     When working with an  isotropic harmonical oscillator
C=======================================================================
C
      IF (ISOTRO.EQ.1) THEN
C
          HAROAV=(HBAROX+HBAROY+HBAROZ)/3
C
          HBAROX=HAROAV
          HBAROY=HAROAV
          HBAROZ=HAROAV
C
      END IF
C
C=======================================================================
C     Attention: if the option  NUCAVR='AVERAGE'  is chosen
C                through NAMELI, then XMASSN=XMASSP=AVERAGE
C                of real masses
C=======================================================================
C
      IF (ISOSPI.EQ.0) THEN
C
          SQXFAC=HBAR_C/SQRT(XMASSN*HBAROX)/RCVOLM
          SQYFAC=HBAR_C/SQRT(XMASSN*HBAROY)/RCVOLM
          SQZFAC=HBAR_C/SQRT(XMASSN*HBAROZ)/RCVOLM
C
      ELSE
C
          SQXFAC=HBAR_C/SQRT(XMASSP*HBAROX)/RCVOLM
          SQYFAC=HBAR_C/SQRT(XMASSP*HBAROY)/RCVOLM
          SQZFAC=HBAR_C/SQRT(XMASSP*HBAROZ)/RCVOLM
C
      END IF
C
C=======================================================================
C
      IF (ISOSPI.EQ.0) THEN
C
          HOMSHF(1)=SQRT(XMASSN*HBAROX)/HBAR_C
          HOMSHF(2)=SQRT(XMASSN*HBAROY)/HBAR_C
          HOMSHF(3)=SQRT(XMASSN*HBAROZ)/HBAR_C
C
          HOMSCA(1)=SQRT(XMASSN*HBAROX)/HBAR_C
          HOMSCA(2)=SQRT(XMASSN*HBAROY)/HBAR_C
          HOMSCA(3)=SQRT(XMASSN*HBAROZ)/HBAR_C
C
      ELSE
C
          HOMSHF(1)=SQRT(XMASSP*HBAROX)/HBAR_C
          HOMSHF(2)=SQRT(XMASSP*HBAROY)/HBAR_C
          HOMSHF(3)=SQRT(XMASSP*HBAROZ)/HBAR_C
C
          HOMSCA(1)=SQRT(XMASSP*HBAROX)/HBAR_C
          HOMSCA(2)=SQRT(XMASSP*HBAROY)/HBAR_C
          HOMSCA(3)=SQRT(XMASSP*HBAROZ)/HBAR_C
C
      END IF
C
C=======================================================================
C
      IF (IWRITE.GE.3) THEN
C
          WRITE(NOUTPT,'(/,80(''#''),/,''#'',78X,''#'',/,
     *          ''#'', 2X,''Physical Constants:          '',
     *                  ''HBAR_C='',F12.8,6X,''E2ovHC='',F12.8,3X,''#'',
     *                  /,
     *          ''#'',78X,
     *          ''#'',/,
     *          ''#'',31X,''Xmassn='',F12.8,6X,''Xmassp='',F12.8,3X,
     *          ''#'',/,
     *          ''#'',78X,
     *          ''#'',/,
     *          ''#'',31X,''HBmass='',F12.8,6X,''HBmrpa='',F12.8,3X,
     *          ''#'',/,
     *          ''#'',78X,
     *          ''#'',/,
     *          ''#'',31X,''echar2='',F12.8,6X,''Coulex='',F12.8,3X,
     *          ''#'',/,
     *          ''#'',78X,
     *          ''#'',/,80(''#''),/)')
     *
     *           HBAR_C,E2OVHC,XMASSN,XMASSP,HBMASS,HBMRPA,ECHAR2,COULEX
      END IF
C
      IF (IWRITE.GE.3) THEN
C
          WRITE(NOUTPT,'(80(''#''),/,''#'',78X,''#'',/,
     *          ''#'', 2X,''Oscillator Lengths:          '',
     *          ''X='',F10.7,4X,''Y='',F10.7,4X,''Z='',F10.7,3X,
     *          ''#'',/,
     *          ''#'',78X,
     *          ''#'',/,
     *          ''#'', 2X,''Oscillator Constants:        '',
     *          ''X='',F10.7,4X,''Y='',F10.7,4X,''Z='',F10.7,3X,
     *          ''#'',/,
     *          ''#'',78X,
     *          ''#'',/,
     *          ''#'', 2X,''Oscillator Frequencies:      '',
     *          ''X='',F10.7,4X,''Y='',F10.7,4X,''Z='',F10.7,3X,
     *          ''#'',/,
     *          ''#'',78X,''#'',/,80(''#''),/)')
     *
     *        (1.00/HOMSHF(KARTEZ),KARTEZ=1,NDKART),
     *             (HOMSHF(KARTEZ),KARTEZ=1,NDKART),HBAROX,HBAROY,HBAROZ
C
      END IF
C
C=======================================================================
C
      DO NV=1,NDBASE
         NXVLAB(NV)=-1
         NYVLAB(NV)=-1
         NZVLAB(NV)=-1
      END DO
C
C=======================================================================
C     Calculating the number of states in each of the 3 oscillators
C=======================================================================
C
      MCOUNT=0
C
      DO NX=0,NOSCIL
         DO NY=0,NOSCIL
            DO NZ=0,NOSCIL
C
               MCOUNT=MCOUNT+1
C
               IF (MCOUNT.GT.NDBTOT) STOP 'NOSCIL too big in SETBAS'
C
               NBASIS(MCOUNT)=MCOUNT
C
               EBASIS(MCOUNT)=HBAROX*(NX+0.5)
     *                       +HBAROY*(NY+0.5)
     *                       +HBAROZ*(NZ+0.5)
C
            END DO
         END DO
      END DO
C
      NUMCUT=MCOUNT
C
C=======================================================================
C
      CALL WS_ORDER1(EBASIS,NBASIS,MCOUNT,NDBTOT)
C
C=======================================================================
C     If NLIMIT>0 the basis will be defined in such a way that
C     the total number of the lowest basis states  retained is
C     equal to the prescribed value (NLIMIT).  Whenever NLIMIT
C     happens to be inside a degenerate multiplet (a spherical
C     or axial symmetry) the whole multiplet is taken. In such
C     a case the number of states retained  (LDBASE)  may be a
C     little larger than the prescribed value (NLIMIT).
C=======================================================================
C
      IF (NLIMIT.GT.0) THEN
          IF (NLIMIT.LE.MCOUNT) THEN
              ELIMIT=EBASIS(NLIMIT)+1.0E-5
              ELIMIT=EBASIS(NLIMIT)+1.0E-10
          ELSE
              ELIMIT=EBASIS(MCOUNT)+1.0E-5
              ELIMIT=EBASIS(MCOUNT)+1.0E-10
          END IF
      ELSE
          ELIMIT=ENECUT
      END IF
C
C=======================================================================
C     Zeroing the matrix of single-particle indices
C=======================================================================
C
      INDICE(:,:,:)=0
C
C=======================================================================
C     Selecting the states included in the basis
C=======================================================================
C
      NUMCUT=0
      LABCUT=0
C
      NXMAXX=0
      NYMAXX=0
      NZMAXX=0
C
      DO NX=0,NOSCIL
         DO NY=0,NOSCIL
            DO NZ=0,NOSCIL
C
               EBASEX=HBAROX*(NX+0.5)
     *               +HBAROY*(NY+0.5)
     *               +HBAROZ*(NZ+0.5)
C
               IF (EBASEX.LT.ELIMIT) THEN
C
                   NUMCUT=NUMCUT+1
C
                   IF (NUMCUT.GT.NDBASE) THEN
C
                       WRITE(NOUTPT,'(/,''NOSCIL='',I3,3X,
     *                                  ''NUMCUT='',I5,3X,
     *                                  ''NLIMIT='',I5,3X,
     *                                  ''NDBASE='',I5,3X,
     *                                  ''ELIMIT='',F10.5)')
     *
     *                 NOSCIL,NUMCUT,NLIMIT,NDBASE,ELIMIT
C
                       STOP 'NUMCUT>NDBASE in SETBAS'
C
                   END IF
C
C=======================================================================
C                  Storing the quantum numbers of the basis states
C=======================================================================
C
                   NXVECT(NUMCUT)=NX
                   NYVECT(NUMCUT)=NY
                   NZVECT(NUMCUT)=NZ
C
                   NTOTAL=NX+NY+NZ
C
                   IF (NTOTAL.LE.NDCLAB) THEN
C
                       LABCUT=LABCUT+1
C
                       NXVLAB(LABCUT)=NX
                       NYVLAB(LABCUT)=NY
                       NZVLAB(LABCUT)=NZ
C
                   END IF
C
C=======================================================================
C                  Determining the maximum numbers of oscillator quanta
C=======================================================================
C
                   IF (NX.GT.NDXMAX.OR.
     *                 NY.GT.NDYMAX.OR.
     *                 NZ.GT.NDZMAX) THEN
C
                       WRITE(NOUTPT,'(/,1X,20(''!''),
     *                              ''  TOO LARGE BASIS'',
     *                              3X,20(''!''),/,''  NUMCUT='',I3,
     *                              '' NDXMAX='',I2,'' NX='',I2,
     *                              '' NDYMAX='',I2,'' NY='',I2,
     *                              '' NDZMAX='',I2,'' NZ='',I2)')
     *                          NUMCUT,NDXMAX, NX,
     *                                 NDYMAX, NY,
     *                                 NDZMAX, NZ
C
                       STOP 'Too large oscillator numbers in SETBAS'
C
                   END IF
C
                   NXMAXX=MAX(NXMAXX,NX)
                   NYMAXX=MAX(NYMAXX,NY)
                   NZMAXX=MAX(NZMAXX,NZ)
C
                   INDICE(NX,NY,NZ)=NUMCUT
C
               END IF
C
            END DO
         END DO
      END DO
C
C=======================================================================
C
      LDBASE=NUMCUT
C
C=======================================================================
C
      MAXBNX=NXMAXX
      MAXBNY=NYMAXX
      MAXBNZ=NZMAXX
C
C=======================================================================
C         Determining the optimum numbers of Gauss-integration points
C=======================================================================
C
      IF (IOPTGS.EQ.1) THEN
C
          IOPTGX=0
          IOPTGY=0
          IOPTGZ=0
C
          IF (NXHERM.LT.2*NXMAXX+2) THEN
              NXHOLD=NXHERM
              NXHERM=2*NXMAXX+2
              IOPTGX=1
          END IF
          IF (NYHERM.LT.2*NYMAXX+2) THEN
              NYHOLD=NYHERM
              NYHERM=2*NYMAXX+2
              IOPTGY=1
          END IF
          IF (NZHERM.LT.2*NZMAXX+2) THEN
              NZHOLD=NZHERM
              NZHERM=2*NZMAXX+2
              IOPTGZ=1
          END IF
C
          IF (IWRITE.GE.2) THEN
C
              IF (IOPTGX.EQ.1.OR.IOPTGY.EQ.1.OR.IOPTGZ.EQ.1) THEN
                  WRITE(NOUTPT,'(/,80(''!''),/,
     *                      ''!   Gauss optimisation on:'',T80,''!'')')
              END IF
C
              IF (IOPTGX.EQ.1) THEN
                  WRITE(NOUTPT,'(''!                          OLD '',
     *                ''NXHERM='',I2,''   Has been increased to   '',
     *                ''NXHERM='',I2,''   !'')')  NXHOLD,NXHERM
              END IF
C
              IF (IOPTGY.EQ.1) THEN
                  WRITE(NOUTPT,'(''!                          OLD '',
     *                ''NYHERM='',I2,''   Has been increased to   '',
     *                ''NYHERM='',I2,''   !'')')  NYHOLD,NYHERM
              END IF
C
              IF (IOPTGZ.EQ.1) THEN
                  WRITE(NOUTPT,'(''!                          OLD '',
     *                ''NZHERM='',I2,''   Has been increased to   '',
     *                ''NZHERM='',I2,''   !'')')  NZHOLD,NZHERM
              END IF
C
              IF (IOPTGX.EQ.1.OR.IOPTGY.EQ.1.OR.IOPTGZ.EQ.1) THEN
                  WRITE(NOUTPT,'(''!'',T80,''!'',/,80(''!''))')
              END IF
C
          END IF
C
      ELSE
C
          IF (NXHERM.LT.2*NXMAXX+2) THEN
              WRITE(NOUTPT,'(''NXHERM='',I3)')  NXHERM
              STOP 'Too low integration precision in x, increase NXHERM'
          END IF
C
          IF (NYHERM.LT.2*NYMAXX+2) THEN
              WRITE(NOUTPT,'(''NYHERM='',I3)')  NYHERM
              STOP 'Too low integration precision in y, increase NYHERM'
          END IF
C
          IF (NZHERM.LT.2*NZMAXX+2) THEN
              WRITE(NOUTPT,'(''NZHERM='',I3)')  NZHERM
              STOP 'Too low integration precision in z, increase NZHERM'
          END IF
C
      END IF
C
C=======================================================================
C     Determining parities of the basis states
C=======================================================================
C
      LDBASP(0)=0
      LDBASP(1)=0
C
      DO I_BASE=1,LDBASE
C
         IPARIT=MOD(NXVECT(I_BASE)+NYVECT(I_BASE)+NZVECT(I_BASE),2)
C
             LDBASP(IPARIT)=LDBASP(IPARIT)+1
         IF (LDBASP(IPARIT).GT.NDBASE) STOP 'LDBASP(IPARIT) in SETBAS'
C
         INDPAR(LDBASP(IPARIT),IPARIT)=I_BASE
C
      END DO
C
      IF (LDBASP(0)+LDBASP(1).NE.LDBASE) STOP 'PARITY SUM in SETBAS'
C
C=======================================================================
C     Determining the limits of the basis in the NX-NY-NZ space
C=======================================================================
C                                                   X-Direction
C=======================================================================
C
      DO NX=0,NXMAXX
         MAXIMY=0
         MAXIMZ=0
         DO NY=0,NYMAXX
            MAXIXY=0
            DO NZ=0,NZMAXX
               IF (INDICE(NX,NY,NZ).NE.0) THEN
                   MAXIMY=MAX(MAXIMY,NY)
                   MAXIMZ=MAX(MAXIMZ,NZ)
                   MAXIXY=MAX(MAXIXY,NZ)
               END IF
            END DO
            LAZOXY(NX,NY)=MAXIXY
         END DO
         LAYOFX(NX)=MAXIMY
         LAZOFX(NX)=MAXIMZ
      END DO
C
C=======================================================================
C                                                   Y-Direction
C=======================================================================
C
      DO NY=0,NYMAXX
         MAXIMZ=0
         MAXIMX=0
         DO NZ=0,NZMAXX
            MAXIYZ=0
            DO NX=0,NXMAXX
               IF (INDICE(NX,NY,NZ).NE.0) THEN
                   MAXIMZ=MAX(MAXIMZ,NZ)
                   MAXIMX=MAX(MAXIMX,NX)
                   MAXIYZ=MAX(MAXIYZ,NX)
               END IF
            END DO
            LAXOYZ(NY,NZ)=MAXIYZ
         END DO
         LAZOFY(NY)=MAXIMZ
         LAXOFY(NY)=MAXIMX
      END DO
C
C=======================================================================
C                                                   Z-Direction
C=======================================================================
C
      DO NZ=0,NZMAXX
         MAXIMX=0
         MAXIMY=0
         DO NX=0,NXMAXX
            MAXIZX=0
            DO NY=0,NYMAXX
               IF (INDICE(NX,NY,NZ).NE.0) THEN
                   MAXIMX=MAX(MAXIMX,NX)
                   MAXIMY=MAX(MAXIMY,NY)
                   MAXIZX=MAX(MAXIZX,NY)
               END IF
            END DO
            LAYOZX(NZ,NX)=MAXIZX
         END DO
         LAXOFZ(NZ)=MAXIMX
         LAYOFZ(NZ)=MAXIMY
      END DO
C
C=======================================================================
C
      IF (IWRITE.GE.3) THEN
C
          WRITE(NOUTPT,'(80(''#''),/,''#'',78X,''#'',/,
     *            ''#'', 2X,''Basis cut-off control parameters:'',
     *                      ''  NXMAXX ='',I3,''  NYMAXX ='',I3,
     *                      ''  NZMAXX ='',I4,                 3X,
     *            ''#'',/,
     *            ''#'',78X,
     *            ''#'',/,
     *            ''#'', 2X,A33,
     *                    ''  NXHERM ='',I3,''  NYHERM ='',  I3,
     *                    ''  NZHERM ='',I4,                 3X,
     *            ''#'',/,
     *            ''#'',78X,
     *            ''#'',/,
     *            ''#'',35X,''  NLIMIT ='',I4,'' LDBASE ='',I4,
     *                      '' MCOUNT='',I5,                3X,
     *            ''#'',/,
     *            ''#'',78X,
     *            ''#'',/,
     *            ''#'',35X,''  ENECUT ='',F8.3,             4X,
     *                      ''  ELIMIT ='',F8.3,             3X,
     *            ''#'',/,
     *            ''#'',78X,
     *            ''#'',/,
     *            80(''#''),/)')
     *
     *                      NXMAXX,NYMAXX,NZMAXX,
     *       OPTIMU(IOPTGS),NXHERM,NYHERM,NZHERM,
     *                      NLIMIT,LDBASE,MCOUNT,
     *                             ENECUT,ELIMIT
      END IF
C
C=======================================================================
C         Printing the basis shape diagrams (the "diamonds")
C=======================================================================
C
      DO IDIGIT=0,99
         WRITE(DIGITS(IDIGIT),'(I2)') IDIGIT
      END DO
C
      IF (IWRITE.GE.3) THEN
C
          WRITE(NOUTPT,'(80(''#''),/,''#'',78X,''#'',/,
     *             ''#'',2X,''Shape of the Oscillator-Basis Diamond'',
     *                                                    39X,''#'',/,
     *             ''#'',78X,                                 ''#'',/,
     *                                  80(''#''),/,''#'',78X,''#'')')
C
C=======================================================================
C         NX - NY  p l a n e    NX - NY  p l a n e   NX - NY  p l a n e
C=======================================================================
C
          WRITE(NOUTPT,'(''#'',7X,''NX ===>>>'',19(1X,A2),5X,''#'')')
     *                         (DIGITS(NX),NX=0,MIN(NXMAXX,18)),
     *                          ('  ',NX=  MIN(NXMAXX,18)+1,18)
C
C=======================================================================
C
          WRITE(NOUTPT,'(''#'',7X,''MAX.NY =>'',19(1X,A2),5X,''#'')')
     *                 (DIGITS(LAYOFX(NX)),NX=0,MIN(NXMAXX,18)),
     *                               ('  ',NX=  MIN(NXMAXX,18)+1,18)
C
C=======================================================================
C
          WRITE(NOUTPT,'(''#'',7X,''         '',19A3,5X,''#'')')
     *                           ('---',NX=0,MIN(NXMAXX,18)),
     *                           ('   ',NX=  MIN(NXMAXX,18)+1,18)
C
C=======================================================================
C
          DO NY=0,NYMAXX
C
          WRITE(NOUTPT,'(''#'',2X,''NY='',I2,2X,''('',I2,'')'',2X,''|'',
     *                   19(1X,A2),5X,''#'')')
     *                   NY,LAXOFY(NY),
     *              (DIGITS(LAZOXY(NX,NY)),NX=0,MIN(LAXOFY(NY),18)),
     *                               ('  ',NX=  MIN(LAXOFY(NY),18)+1,18)
C
          END DO
C
C=======================================================================
C
          WRITE(NOUTPT,'(''#'',78X,''#'',/,''#'',78X,''#'')')
C
C=======================================================================
C         NZ - NY  P L A N E    NZ - NY  P L A N E   NZ - NY  P L A N E
C=======================================================================
C
          WRITE(NOUTPT,'(''#'',7X,''NZ ===>>>'',19(1X,A2),5X,''#'')')
     *                               (DIGITS(NZ),NZ=0,MIN(NZMAXX,18)),
     *                               ('  ',NZ=  MIN(NZMAXX,18)+1,18)
C
C=======================================================================
C
          WRITE(NOUTPT,'(''#'',7X,''MAX.NY =>'',19(1X,A2),5X,''#'')')
     *                       (DIGITS(LAYOFZ(NZ)),NZ=0,MIN(NZMAXX,18)),
     *                               ('  ',NZ=  MIN(NZMAXX,18)+1,18)
C
C=======================================================================
C
          WRITE(NOUTPT,'(''#'',7X,''         '',19A3,5X,''#'')')
     *                               ('---',NZ=0,MIN(NZMAXX,18)),
     *                               ('   ',NZ=  MIN(NZMAXX,18)+1,18)
C
C=======================================================================
C
          DO NY=0,NYMAXX
C
          WRITE(NOUTPT,'(''#'',2X,''NY='',I2,2X,''('',I2,'')'',2X,''|'',
     *                   19(1X,A2),5X,''#'')')
     *                   NY,LAZOFY(NY),
     *              (DIGITS(LAXOYZ(NY,NZ)),NZ=0,MIN(LAZOFY(NY),18)),
     *                               ('  ',NZ=  MIN(LAZOFY(NY),18)+1,18)
C
          END DO
C
C=======================================================================
C
          WRITE(NOUTPT,'(''#'',78X,''#'',/,''#'',78X,''#'')')
C
C=======================================================================
C         NZ - NX  P L A N E    NZ - NX  P L A N E   NZ - NX  P L A N E
C=======================================================================
C
          WRITE(NOUTPT,'(''#'',7X,''NZ ===>>>'',19(1X,A2),5X,''#'')')
     *                             (DIGITS(NZ),NZ=0,MIN(NZMAXX,18)),
     *                             ('  ',NZ=  MIN(NZMAXX,18)+1,18)
C
C=======================================================================
C
          WRITE(NOUTPT,'(''#'',7X,''MAX.NX =>'',19(1X,A2),5X,''#'')')
     *                     (DIGITS(LAXOFZ(NZ)),NZ=0,MIN(NZMAXX,18)),
     *                             ('  ',NZ=  MIN(NZMAXX,18)+1,18)
C
C=======================================================================
C
          WRITE(NOUTPT,'(''#'',7X,''         '',19A3,5X,''#'')')
     *                               ('---',NZ=0,MIN(NZMAXX,18)),
     *                         ('   ',NZ=  MIN(NZMAXX,18)+1,18)
C
C=======================================================================
C
          DO NX=0,NXMAXX
C
          WRITE(NOUTPT,'(''#'',2X,''NX='',I2,2X,''('',I2,'')'',2X,''|'',
     *                  19(1X,A2),5X,''#'')')
     *                  NX,LAZOFX(NX),
     *              (DIGITS(LAYOZX(NZ,NX)),NZ=0,MIN(LAZOFX(NX),18)),
     *                               ('  ',NZ=  MIN(LAZOFX(NX),18)+1,18)
C
          END DO
C
C=======================================================================
C
          WRITE(NOUTPT,'(''#'',78X,''#'',/,80(''#''),/)')
C
C=======================================================================
C
      END IF
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C=======================================================================
C
      SUBROUTINE WS_SPECTR(ISOSPI,NOSCIL,ISIGNY,IREVER,IPAORD,NOEFFM,
     *                     NXHERM,NYHERM,NZHERM,NXMAXX,NYMAXX,NZMAXX,
     *                     VCENTR,VEFMAS,VSORBT,VLIMOM,ENECUT,EPSHER,
     *                                          LDBASE,MU_ODD,KRANKG)
C=======================================================================
      USE params
C=======================================================================
C
      COMPLEX
     *          EWAVEF,WAVEWS,H_STAT
C
      DIMENSION
     *          VCENTR(1:NDXHRM,1:NDYHRM,1:NDZHRM),
     *          VEFMAS(1:NDXHRM,1:NDYHRM,1:NDZHRM),
     *          VSORBT(1:NDXHRM,1:NDYHRM,1:NDZHRM),
     *          VLIMOM(1:NDXHRM,1:NDYHRM,1:NDZHRM)
      DIMENSION
     *          IPAORD(1:NDBASE)
C=======================================================================
      ALLOCATABLE RAUXIL(:,:)
C=======================================================================
C
      COMMON
     *       /SPECTR_PRONEU/ ESINPP(1:NDBASE),ESINPN(1:NDBASE)
      COMMON
     *       /SPECTR_ESINGP/ ESINGP(1:NDBASE),PARITY(1:NDBASE)
     *
     *       /SPECTR_H_STAT/ H_STAT(1:NDBASE,1:NDBASE)
     *       /SPECTR_H_STRE/ H_STRE(1:NDBASE,1:NDBASE)
     *       /SPECTR_SPINOR/ EWAVEF(1:NDBASE,1:NDBASE)
     *
     *       /SPECTR_ALL_WF/ WAVEWS(1:NDBASE,1:NDBASE,0:NDISOS)
     *
     *       /SPECTR_ISPFAC/ ISPFAC(1:NDBASE)

      COMMON
     *       /MULTIP_SPLEVS/ SPENER(1:NDBASE,0:NDREVE),
     *                       SPALIG(1:NDBASE,0:NDREVE),
     *                       SPSPAL(1:NDBASE,0:NDREVE),
     *                       SPPARI(1:NDBASE,0:NDREVE),
     *                       QUOKAR(1:NDBASE,0:NDREVE),
     *                       QUONIL(1:NDBASE,0:NDREVE)
      COMMON
     *       /SETBAS_HOMOSC/ HBAROX,HBAROY,HBAROZ,
     *                       SQXFAC,SQYFAC,SQZFAC,
     *                                     HOMOSC
     *
     *       /SETBAS_CENMAS/ XCMPOS,YCMPOS,ZCMPOS
     *
     *       /SETBAS_NOSMAX/ MAXBNX,MAXBNY,MAXBNZ,
     *                                     NOSMAX
     *
     *       /SETBAS_NXNYNZ/ NXVECT(1:NDBASE),
     *                       NYVECT(1:NDBASE),
     *                       NZVECT(1:NDBASE)
      COMMON
     *       /CRANKG_SIGDIM/ LDSTAT(0:NDREVE)
      COMMON
     *       /PRECISION_EPS/ EPSF_S,EPSG_S,APROAC
      COMMON
     *       /READWRITE_PAR/ NOUTPT,IWRITE,ISCREN
C
C      Needed to exit before diagonalization in pure 1D-cranking case
C
      COMMON
     *       /MINIMI_OMEGAS/ OMEGAC
      COMMON
     *       /PAIRIN_SWITCH/ IFPAIR,IFPROJ,IF_HFB,IF_LIP
C
C=======================================================================
C=======================================================================
C
C     This subroutine performs the linear algebra manipulations
C     related  to the effective construction of the hamiltonian
C     matrix, in particular 't-basis'  vs. 'b-basis' operations
C     as well as calling the diagonalization routines
C
C=======================================================================
C
      CALL WS_CPUTIM('SPECTR',1)
C
C=======================================================================
C
C     The call below  performs integrations of  matrix elements
C     for the Schrodinger or Dirac equation with Woods-Saxon or
C     folded Yukawa average field nuclear potentials:  here the
C     nonrotating case. For cranking operations: see subroutine
C                                                      CRANKG
C
C     Matrix elements of kinetic energy operator of the central
C     Woods-Saxon, Coulomb  as well as  the three terms  of the
C     spin-orbit interaction will be calculated. In case of the
C     Dirac equation the position-dependent effective mass term
C     will be taken into account.
C
C=======================================================================
C
      CALL WS_CELMAT(NXHERM,NYHERM,NZHERM,NXMAXX,NYMAXX,NZMAXX,
     *               VCENTR,VEFMAS,VSORBT,VLIMOM,EPSHER,ISOSPI,
     *                                                  NOEFFM)
C
C=======================================================================
C         The fourth auxiliary table: ''ACTUAL RUN CONDITIONS''
C=======================================================================
C
      IF (IWRITE.GE.3) THEN
C
          WRITE(NOUTPT,'(//,80(''#''),/,''#'',78X,''#'',/,
     *          ''#  Oscillator:      HWo ='',F6.3,
     *          ''     HWx='',F6.3,
     *          ''     HWy='',F6.3,
     *          ''     HWz='',F6.3,
     *          ''   #'',/,
     *          ''#  Shell lmts:                      Nmax.X.='',I2,
     *          ''     Nmax.Y.='',I2,''     Nmax.Z.='',I2,''   #'',/,
     *          ''#  Gauss lmts:                      Intg.X.='',I2,
     *          ''     Intg.Y.='',I2,''     Intg.Z.='',I2,''   #'',/,
     *          ''#'',78X,''#'',/,
     *          ''#  Total  Dimension ='',I5,''*'',I5,
     *          ''    Basis Cut-Off: ='',F9.4,''     EPS='',E6.1,
     *          ''   #'',/,''#'',78X,''#'',/,80(''#''))')
     *
     *          HOMOSC,HBAROX,HBAROY,HBAROZ,NXMAXX,NYMAXX,NZMAXX,
     *                                      NXHERM,NYHERM,NZHERM,
     *                                      LDBASE,LDBASE,ENECUT,
     *                                                    EPSF_S
      END IF
C
C=======================================================================
C
C         Diagonalizing the mean field hamiltonian matrix
C
C                 There are generally two cases:
C                 ==============================
C
C   A. MU_ODD=1, what means that there  a r e  odd-mu deformations.
C      Then  the hamiltonian is  n o t  S_x symmetric and there is
C      no point in transforming everything to the "s"-basis.Things
C      go as they used to go, and the output is:
C
C      EWAVEF - complex matrix containing the wave function of the
C               solutions with positive y-simplex (i.e. eigenvalue
C               of S_y is +i) in the "t" representation. This goes
C               to a common to be used by CRANKG
C
C      H_STAT - only if y-cranking will be performed afterwards, a
C               complex matrix, containing the  (+,+) block of the
C               hamiltonian in the "t" representation
C
C      Note that only y-cranking can be performed in this case!
C
C   B. MU_ODD=0,  what means  that the hamiltonian  h a s  the S_x
C      symmetry, and therefore it is beneficial to transform every-
C      thing to "s" basis, so as to get real matrices. However, to
C      avoid total chaos and not to be forced to change many other
C      routines (which expect EWAVEF to exist and to store complex
C      wave function in "t" representation), after diagonalization
C      we reconstruct EWAVEF so that it takes the standard form as
C      if we had used the "t" representation (as in A.) right from
C      the beginning. The output is as follows:
C
C      EWAVEF - as in A above
C
C      H_STAT - as in A (if y-cranking is to be performed)
C
C      RAUXIL - real matrix  containing wave function of the solut-
C               with the positive S_x-Simplex  (i.e. eigenvalue of
C               S_x is +i) in the "s" representation.  This is not
C               needed out of this routine
C
C      H_STRE - only if S_x-cranking is to be run afterwards:  the
C               r e a l  matrix  which contains the (+,+) block of
C               the hamiltonian in the "s" representation. This is
C               put into a common to be used by CRANKG
C
C      Note that in this option both x-cranking and y-cranking can
C      be invoked afterwards - we benefit from reality of matrices
C      in both cases.
C
C=======================================================================
C
      NOSMAX=NOSCIL
C
      LDSTAT(0)=LDBASE
      LDSTAT(1)=LDBASE
C
      ESINGP(:)=0.0D0
C
C      Below: we will store a copy of the hamiltonian matrix, more
C      precisely - its (+,+) block in "t" representation - for the
C      future use in conjunction with the y-cranking
C
      H_STAT(:,:)=EWAVEF(:,:)
C
C      ISPFAC - is an auxiliary vector, used here  and in cranking
C               routine. Its values are equal  (+1) for Nx+Ny even
C                                       while  (-1) for Nx+Ny  odd
C
      DO I=1,LDBASE
          ISPFAC(I)= 1-2*MOD(NXVECT(I)+NYVECT(I),2)
      END DO
C
C=======================================================================
C
      IF (MU_ODD.EQ.1) THEN
C
C          For the time being...
C
          IF (KRANKG.EQ.1.OR.KRANKG.EQ.3) STOP 'Nie sovsiem gotov...'
C
C          Complex matrices;  no S_x symmetry  of the hamiltonian
C
          IF (ISIGNY.EQ.1) THEN
              CALL WS_DIASIG(ESINGP,IREVER,IPAORD)
          ELSE
              CALL WS_DIAGCM(EWAVEF,ESINGP,LDBASE)
          END IF
C
      ELSE
C
C=======================================================================
C
C         Here we have no odd-mu case, and therefore a real matrix
C                                      representation  is possible
C
C         In this case the  "t"-basis hamiltonian matrix  contains
C         purely imaginary and purely real numbers i.e. no element
C         is really complex
C
C         We transform hamiltonian matrix to the "s"-basis so that
C         it becomes real and we make a copy of it,  for later use
C         if x-cranking is to be performed
C
C         Below we use Eq.(35) from notes PA
C
C=======================================================================
C
          ALLOCATE(RAUXIL(1:NDBASE,1:NDBASE))
C
          DO IBRAHO=1,LDBASE
C
              IFACII=ISPFAC(IBRAHO)
C
              DO IKETHO=1,LDBASE
C
                  IF (IFACII.EQ.ISPFAC(IKETHO)) THEN
                      RAUXIL(IBRAHO,IKETHO)=REAL(EWAVEF(IBRAHO,IKETHO))
                  ELSE
                      RAUXIL(IBRAHO,IKETHO)=-IFACII
     *                                     *IMAG(EWAVEF(IBRAHO,IKETHO))
                  END IF
C
              END DO
C
          END DO
C
C         ... we just copy ...
C
          IF (KRANKG.EQ.1) THEN
              H_STRE(:,:)=RAUXIL(:,:)
          END IF
C
C         ... and we diagonalise the  r e a l   matrix  RAUXIL
C
          IF (ISIGNY.EQ.1) THEN
              CALL WS_DIASIR(RAUXIL,ESINGP,IREVER,IPAORD,LDBASE)
          ELSE
              CALL WS_DIAGRM(RAUXIL,ESINGP,LDBASE)
          END IF
C
C=======================================================================
C
C         Now we recalculate complex matrix EWAVEF, in its old i.e.
C         "t" representation, from the real matrix RAUXIL i.e. "s"
C         representation.  This would not be needed, if we were to
C         perform the cranking right here. The purpose of doing it
C         in this way is to prepare calculation of such quantities
C         as multipole moments,  calculate labels etc.,  since all
C         the corresponding routines expect matrix EWAVEF to store
C         the wave functions in their "t"-representation
C
C         Below: we use Eq.(56) from notes PA
C
C=======================================================================
C
          RECSQ2=1/SQRT(2.)
C
          DO ISOLUT=1,LDBASE
             DO ISTATE=1,LDBASE
                RFACTO=RECSQ2*RAUXIL(ISTATE,ISOLUT)
                EWAVEF(ISTATE,ISOLUT)=CMPLX(RFACTO,
     *                      -ISPFAC(ISTATE)*RFACTO)
             END DO
          END DO
C
          DEALLOCATE(RAUXIL)
C
      END IF
C
      DO ISTATE=1,LDBASE
         SPENER(ISTATE,0)=ESINGP(ISTATE)
         SPENER(ISTATE,1)=ESINGP(ISTATE)
      END DO
C
C      Making separate copies of proton and neutron s.p. energies for
C      future use (in particular in HFB block)
C
      IF (ISOSPI.EQ.0) THEN
          DO ISTATE=1,LDBASE
             ESINPN(ISTATE)=ESINGP(ISTATE)
             DO I_BASE=1,LDBASE
                WAVEWS(I_BASE,ISTATE,ISOSPI)=EWAVEF(I_BASE,ISTATE)
             END DO
          END DO
      END IF
C
      IF (ISOSPI.EQ.1) THEN
          DO ISTATE=1,LDBASE
             ESINPP(ISTATE)=ESINGP(ISTATE)
             DO I_BASE=1,LDBASE
                WAVEWS(I_BASE,ISTATE,ISOSPI)=EWAVEF(I_BASE,ISTATE)
             END DO
          END DO
      END IF
C
C=======================================================================
C
      CALL WS_CPUTIM('SPECTR',0)
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C=======================================================================
C
      SUBROUTINE WS_DENMAC()
#if(USE_OPENMP==1)
      USE omp_lib
#endif
C=======================================================================
      USE params
C=======================================================================
C
      COMPLEX
     *          C_ZERO,C_UNIT
      COMPLEX
     *          EWAVEF,E_TEMP,BIG_PP
C
C=======================================================================
      ALLOCATABLE E_TEMP(:,:)
C=======================================================================
      COMMON
     *       /SPECTR_SPINOR/ EWAVEF(1:NDBASE,1:NDBASE)
      COMMON
     *       /WSEXEC_V2OCCU/ V2OCCU(1:NDBASE)
      COMMON
     *       /CRAN3D_MAT_PP/ BIG_PP(1:NDBASE,1:NDBASE,0:NDREVE)
      COMMON
     *       /SETBAS_DIMENS/ LDBASE
C
C=======================================================================
C
      CALL WS_CPUTIM('DENMAC',1)
C
C=======================================================================
C     THIS SUBROUTINE CALCULATES THE TRANSITION DENSITY MATRIX
C=======================================================================
C
      C_ZERO=CMPLX(0.0D0,0.0D0)
      C_UNIT=CMPLX(1.0D0,0.0D0)
C
      BIG_PP(:,:,:)=C_ZERO
C
C      OpenMP and (threaded) BLAS acceleration
C
      ALLOCATE(E_TEMP(1:NDBASE,1:NDBASE))
C
      DO ISTATE=1,LDBASE
C
         CALL ZCOPY(LDBASE,EWAVEF(1,ISTATE),1,
     *                     E_TEMP(1,ISTATE),1)
C
         CORECT=V2OCCU(ISTATE)
         CALL ZDSCAL(LDBASE,CORECT,E_TEMP(1,ISTATE),1)
C
      END DO
C
      CALL ZGEMM('N','C',LDBASE,LDBASE,LDBASE,
     *                   C_UNIT,EWAVEF,NDBASE,
     *                          E_TEMP,NDBASE,
     *            C_ZERO,BIG_PP(1,1,0),NDBASE)
C
      DEALLOCATE(E_TEMP)
C
C      Defining the time-reversed transition density matrix
C      in case of no rotation
C
#if(USE_OPENMP==1)
!$OMP PARALLEL DEFAULT(SHARED) PRIVATE(IBRA,IKET)
!$OMP DO
      DO IKET=1,LDBASE
         DO IBRA=1,LDBASE
            BIG_PP(IBRA,IKET,1)=CONJG(BIG_PP(IBRA,IKET,0))
         END DO
      END DO
!$OMP END DO
!$OMP END PARALLEL
#else
      DO IKET=1,LDBASE
         DO IBRA=1,LDBASE
            BIG_PP(IBRA,IKET,1)=CONJG(BIG_PP(IBRA,IKET,0))
         END DO
      END DO
#endif
C
C=======================================================================
C
      CALL WS_CPUTIM('DENMAC',0)
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE WS_POTSET(XHERMI,YHERMI,ZHERMI,NXHERM,NYHERM,NZHERM,
     *                     VEFMAS,VSORBT,VLIMOM,VCENTR,NOEFFM,ISOSPI)
C=======================================================================
      USE params
C=======================================================================
      DIMENSION
     *          XHERMI(1:NDXHRM),YHERMI(1:NDYHRM),ZHERMI(1:NDZHRM)
      DIMENSION
     *          X_HERM(1:NDXHRM),Y_HERM(1:NDYHRM),Z_HERM(1:NDZHRM)
      DIMENSION
     *          VCENTR(1:NDXHRM,1:NDYHRM,1:NDZHRM),
     *          VEFMAS(1:NDXHRM,1:NDYHRM,1:NDZHRM),
     *          VSORBT(1:NDXHRM,1:NDYHRM,1:NDZHRM),
     *          VLIMOM(1:NDXHRM,1:NDYHRM,1:NDZHRM)
C
      LOGICAL
     *          SYM_XY,SYM_YZ,SYM_ZX
C
      COMMON
     *       /SETBAS_HOMOSC/ HBAROX,HBAROY,HBAROZ,
     *                       SQXFAC,SQYFAC,SQZFAC,
     *                                     HOMOSC
     *
     *       /SETBAS_CENMAS/ XCMPOS,YCMPOS,ZCMPOS
      COMMON
     *       /TSSYM1_SYMME1/ SYM_XY,SYM_YZ,SYM_ZX
C
C=======================================================================
C
C     This subroutine defines the set of four mean field functions
C     i.e.:  the central potential, the effective mass, the linear
C     momentum and and the spin-orbit terms, stored in the vectors
C
C     VCENTR(IX,IY,IZ)   VEFMAS(IX,IY,IZ)  VLIMOM(IX,IY,IZ)    and
C                        VSORBT(IX,IY,IZ)
C
C=======================================================================
C
      CALL WS_CPUTIM('POTSET',1)
C
C=======================================================================
C     This subroutine  defines  the points  on the nuclear surface
C     for a given set of the  THETA  and  PHI angles, according to
C     the Gauss-Legendre  quadrature  formulae.  They will be used
C     to integrate the Coulomb potential.
C=======================================================================
C
      CALL WS_QGFOLD
C
C=======================================================================
C
C     The vectors below  (XHERMI, YHERMI and ZHERMI) represent the
c     3-D integration nodes, that are dimensionless. Coefficients:
C
C        SQXFAC=(H_BARC/SQRT(XMASSN*HBAROX))/RCVOLM -> (no dim.)
C        SQYFAC=(H_BARC/SQRT(XMASSN*HBAROY))/RCVOLM -> (no dim.)
C        SQZFAC=(H_BARC/SQRT(XMASSN*HBAROZ))/RCVOLM -> (no dim.)
C
C     transform the latter into the dimensionned variables.  Below
C     SQ{}FAC corresponds in fact to [1/bu] {Eq.(I.73,C.P.C.)}. We
C     have then the following relations:
C
C                   x[fm] = XSI[no dimension] * 1/bu
C     and
C                   XSI [no dimension] = x[fm] * bu.
C
C     The variables  XSI  are shifted by an increment equal to the
C     position of the center of mass,  the latter calculated using
C     the dimensionless variables. Therefore the above coeffs must
C     also be dimensionless.
C
C     {}HERMI(I)  are calculated by the Gauss routines and related
C     position-variables in Fermis are
C
C      {}_HERM(I)*RADIUS*CVOLFC = SQXFAC*{}HERMI(I)*RADIUS*CVOLFC
C
C     In other words:  {}_HERM(I)  corresponds to x[fm] normalised
C                                  i.e. divided by RADIUS * CVOLFC
C
C=======================================================================
C
      DO IX=1,NXHERM
         X_HERM(IX)=SQXFAC*XHERMI(IX)+XCMPOS
      END DO
C
      DO IY=1,NYHERM
         Y_HERM(IY)=SQYFAC*YHERMI(IY)+YCMPOS
      END DO
C
      DO IZ=1,NZHERM
         Z_HERM(IZ)=SQZFAC*ZHERMI(IZ)+ZCMPOS
      END DO
C
C=======================================================================
C
      VCENTR(:,:,:)=0.0
      VEFMAS(:,:,:)=0.0
      VSORBT(:,:,:)=0.0
      VLIMOM(:,:,:)=0.0
C
C=======================================================================
C     Automatic test of the symmetry of the potential: Establishing
C     the  existence  of the symmetry planes and of their character
C=======================================================================
C
C     CALL WS_TSSYM1 ==>>> ( SYM_XY, SYM_YZ, SYM_ZX) in TESSYM
C
C=======================================================================
C
      IF (.NOT.SYM_XY.AND..NOT.SYM_YZ.AND..NOT.SYM_ZX) THEN
C
C=======================================================================
C         No symmetry plane. The program in its actual version must
C         have the  Z_X  symmetry plane ("t-basis") ==>>> STOP here
C=======================================================================
C
          IF (.NOT.SYM_ZX) STOP 'No z_x symmetry plane (= y-reflection)'
C
          DO IZ=1,NZHERM
             DO IY=1,NYHERM
                DO IX=1,NXHERM
C
                   X_NODE=X_HERM(IX)
                   Y_NODE=Y_HERM(IY)
                   Z_NODE=Z_HERM(IZ)
C
                   CALL WS_WSDEFN(W_CENT,W_LINM,W_SORB,W_MASS,NOEFFM,
     *                                   X_NODE,Y_NODE,Z_NODE,ISOSPI)
C
                   VCENTR(IX,IY,IZ)=W_CENT
                   VEFMAS(IX,IY,IZ)=W_MASS
                   VLIMOM(IX,IY,IZ)=W_LINM
                   VSORBT(IX,IY,IZ)=W_SORB
C
                   IF (ISOSPI.EQ.1)
     *
     *             VCENTR(IX,IY,IZ)=VCENTR(IX,IY,IZ)
     *                             +WS_COULFY(X_NODE,Y_NODE,Z_NODE)
C
                END DO
             END DO
          END DO
C
      END IF
C
C=======================================================================
C=======================================================================
C        O  N  E    S Y M M E T R Y    P L A N E     S E R I E S
C=======================================================================
C=======================================================================
C
      IF (SYM_XY.AND..NOT.SYM_YZ.AND..NOT.SYM_ZX) THEN
C
C=======================================================================
C         XY symmetry plane. The program in its actual version must
C         have the  Z_X  symmetry plane ("t-basis") ==>>> STOP here
C=======================================================================
C
          IF (.NOT.SYM_ZX) STOP 'No z_x symmetry plane (= y-reflection)'
C
          DO IZ=1,NZHERM/2
             DO IY=1,NYHERM
                DO IX=1,NXHERM
C
                   X_NODE=X_HERM(IX)
                   Y_NODE=Y_HERM(IY)
                   Z_NODE=Z_HERM(IZ)
C
                   CALL WS_WSDEFN(W_CENT,W_LINM,W_SORB,W_MASS,NOEFFM,
     *                                   X_NODE,Y_NODE,Z_NODE,ISOSPI)
C
                   VCENTR(IX,IY,IZ)=W_CENT
                   VEFMAS(IX,IY,IZ)=W_MASS
                   VLIMOM(IX,IY,IZ)=W_LINM
                   VSORBT(IX,IY,IZ)=W_SORB
C
                   IF (ISOSPI.EQ.1)
     *
     *             VCENTR(IX,IY,IZ)=VCENTR(IX,IY,IZ)
     *                             +WS_COULFY(X_NODE,Y_NODE,Z_NODE)
C
                   VCENTR(IX,IY,NZHERM+1-IZ)=VCENTR(IX,IY,IZ)
                   VEFMAS(IX,IY,NZHERM+1-IZ)=VEFMAS(IX,IY,IZ)
                   VSORBT(IX,IY,NZHERM+1-IZ)=VSORBT(IX,IY,IZ)
                   VLIMOM(IX,IY,NZHERM+1-IZ)=VLIMOM(IX,IY,IZ)
C
                END DO
             END DO
          END DO
C
      END IF
C
C=======================================================================
C
      IF (.NOT.SYM_XY.AND.SYM_YZ.AND..NOT.SYM_ZX) THEN
C
C=======================================================================
C         YZ symmetry plane. The program in its actual version must
C         have the  Z_X  symmetry plane ("t-basis") ==>>> STOP here
C=======================================================================
C
          IF (.NOT.SYM_ZX) STOP 'No z_x symmetry plane (= y-reflection)'
C
           DO IZ=1,NZHERM
              DO IY=1,NYHERM
                 DO IX=1,NXHERM/2
C
                   X_NODE=X_HERM(IX)
                   Y_NODE=Y_HERM(IY)
                   Z_NODE=Z_HERM(IZ)
C
                   CALL WS_WSDEFN(W_CENT,W_LINM,W_SORB,W_MASS,NOEFFM,
     *                                   X_NODE,Y_NODE,Z_NODE,ISOSPI)
C
                   VCENTR(IX,IY,IZ)=W_CENT
                   VEFMAS(IX,IY,IZ)=W_MASS
                   VLIMOM(IX,IY,IZ)=W_LINM
                   VSORBT(IX,IY,IZ)=W_SORB
C
                   IF (ISOSPI.EQ.1)
     *
     *             VCENTR(IX,IY,IZ)=VCENTR(IX,IY,IZ)
     *                             +WS_COULFY(X_NODE,Y_NODE,Z_NODE)
C
                   VCENTR(NXHERM+1-IX,IY,IZ)=VCENTR(IX,IY,IZ)
                   VEFMAS(NXHERM+1-IX,IY,IZ)=VEFMAS(IX,IY,IZ)
                   VSORBT(NXHERM+1-IX,IY,IZ)=VSORBT(IX,IY,IZ)
                   VLIMOM(NXHERM+1-IX,IY,IZ)=VLIMOM(IX,IY,IZ)
C
                END DO
             END DO
          END DO
C
      END IF
C
C=======================================================================
C
      IF (.NOT.SYM_XY.AND..NOT.SYM_YZ.AND.SYM_ZX) THEN
C
C=======================================================================
C         ZX symmetry plane. The program in its actual version must
C         have the  Z_X  symmetry plane ("t-basis") ==>>> Calculate
C=======================================================================
C
          DO IZ=1,NZHERM
             DO IY=1,NYHERM/2
                DO IX=1,NXHERM
C
                   X_NODE=X_HERM(IX)
                   Y_NODE=Y_HERM(IY)
                   Z_NODE=Z_HERM(IZ)
C
                   CALL WS_WSDEFN(W_CENT,W_LINM,W_SORB,W_MASS,NOEFFM,
     *                                   X_NODE,Y_NODE,Z_NODE,ISOSPI)
C
                   VCENTR(IX,IY,IZ)=W_CENT
                   VEFMAS(IX,IY,IZ)=W_MASS
                   VLIMOM(IX,IY,IZ)=W_LINM
                   VSORBT(IX,IY,IZ)=W_SORB
C
                   IF (ISOSPI.EQ.1)
     *
     *             VCENTR(IX,IY,IZ)=VCENTR(IX,IY,IZ)
     *                             +WS_COULFY(X_NODE,Y_NODE,Z_NODE)
C
                   VCENTR(IX,NYHERM+1-IY,IZ)=VCENTR(IX,IY,IZ)
                   VEFMAS(IX,NYHERM+1-IY,IZ)=VEFMAS(IX,IY,IZ)
                   VSORBT(IX,NYHERM+1-IY,IZ)=VSORBT(IX,IY,IZ)
                   VLIMOM(IX,NYHERM+1-IY,IZ)=VLIMOM(IX,IY,IZ)
C
                END DO
             END DO
          END DO
C
      END IF
C
C=======================================================================
C=======================================================================
C     T  W  O    S Y M M E T R Y   P L A N E S   S E R I E S
C=======================================================================
C=======================================================================
C
      IF (SYM_XY.AND.SYM_YZ.AND..NOT.SYM_ZX) THEN
C
C=======================================================================
C         No  Z_X  symmetry. The program in its actual version must
C         have the  Z_X  symmetry plane ("t-basis") ==>>> STOP here
C=======================================================================
C
          IF (.NOT.SYM_ZX) STOP 'No z_x symmetry plane (= y-reflection)'
C
          DO IZ=1,NZHERM/2
             DO IY=1,NYHERM
                DO IX=1,NXHERM/2
C
                   X_NODE=X_HERM(IX)
                   Y_NODE=Y_HERM(IY)
                   Z_NODE=Z_HERM(IZ)
C
                   CALL WS_WSDEFN(W_CENT,W_LINM,W_SORB,W_MASS,NOEFFM,
     *                                   X_NODE,Y_NODE,Z_NODE,ISOSPI)
C
                   VCENTR(IX,IY,IZ)=W_CENT
                   VEFMAS(IX,IY,IZ)=W_MASS
                   VLIMOM(IX,IY,IZ)=W_LINM
                   VSORBT(IX,IY,IZ)=W_SORB
C
                   IF (ISOSPI.EQ.1)
     *
     *             VCENTR(IX,IY,IZ)=VCENTR(IX,IY,IZ)
     *                             +WS_COULFY(X_NODE,Y_NODE,Z_NODE)
C
                   VCENTR(IX,IY,NZHERM+1-IZ)=VCENTR(IX,IY,IZ)
                   VEFMAS(IX,IY,NZHERM+1-IZ)=VEFMAS(IX,IY,IZ)
                   VSORBT(IX,IY,NZHERM+1-IZ)=VSORBT(IX,IY,IZ)
                   VLIMOM(IX,IY,NZHERM+1-IZ)=VLIMOM(IX,IY,IZ)
C
                   VCENTR(NXHERM+1-IX,IY,IZ)=VCENTR(IX,IY,IZ)
                   VEFMAS(NXHERM+1-IX,IY,IZ)=VEFMAS(IX,IY,IZ)
                   VSORBT(NXHERM+1-IX,IY,IZ)=VSORBT(IX,IY,IZ)
                   VLIMOM(NXHERM+1-IX,IY,IZ)=VLIMOM(IX,IY,IZ)
C
                   VCENTR(NXHERM+1-IX,IY,NZHERM+1-IZ)=VCENTR(IX,IY,IZ)
                   VEFMAS(NXHERM+1-IX,IY,NZHERM+1-IZ)=VEFMAS(IX,IY,IZ)
                   VSORBT(NXHERM+1-IX,IY,NZHERM+1-IZ)=VSORBT(IX,IY,IZ)
                   VLIMOM(NXHERM+1-IX,IY,NZHERM+1-IZ)=VLIMOM(IX,IY,IZ)
C
                END DO
             END DO
          END DO
C
      END IF
C
C=======================================================================
C
      IF (SYM_XY.AND..NOT.SYM_YZ.AND.SYM_ZX) THEN
C
C=======================================================================
C         Symmetry ZX exist. The program in its present version must
C         have the  Z_X  symmetry plane ("t-basis") ===>>> Calculate
C=======================================================================
C
          DO IZ=1,NZHERM/2
             DO IY=1,NYHERM/2
                DO IX=1,NXHERM
C
                   X_NODE=X_HERM(IX)
                   Y_NODE=Y_HERM(IY)
                   Z_NODE=Z_HERM(IZ)
C
                   CALL WS_WSDEFN(W_CENT,W_LINM,W_SORB,W_MASS,NOEFFM,
     *                                   X_NODE,Y_NODE,Z_NODE,ISOSPI)
C
                   VCENTR(IX,IY,IZ)=W_CENT
                   VEFMAS(IX,IY,IZ)=W_MASS
                   VLIMOM(IX,IY,IZ)=W_LINM
                   VSORBT(IX,IY,IZ)=W_SORB
C
                   IF (ISOSPI.EQ.1)
     *
     *             VCENTR(IX,IY,IZ)=VCENTR(IX,IY,IZ)
     *                             +WS_COULFY(X_NODE,Y_NODE,Z_NODE)
C
                   VCENTR(IX,IY,NZHERM+1-IZ)=VCENTR(IX,IY,IZ)
                   VEFMAS(IX,IY,NZHERM+1-IZ)=VEFMAS(IX,IY,IZ)
                   VSORBT(IX,IY,NZHERM+1-IZ)=VSORBT(IX,IY,IZ)
                   VLIMOM(IX,IY,NZHERM+1-IZ)=VLIMOM(IX,IY,IZ)
C
                   VCENTR(IX,NYHERM+1-IY,IZ)=VCENTR(IX,IY,IZ)
                   VEFMAS(IX,NYHERM+1-IY,IZ)=VEFMAS(IX,IY,IZ)
                   VSORBT(IX,NYHERM+1-IY,IZ)=VSORBT(IX,IY,IZ)
                   VLIMOM(IX,NYHERM+1-IY,IZ)=VLIMOM(IX,IY,IZ)
C
                   VCENTR(IX,NYHERM+1-IY,NZHERM+1-IZ)=VCENTR(IX,IY,IZ)
                   VEFMAS(IX,NYHERM+1-IY,NZHERM+1-IZ)=VEFMAS(IX,IY,IZ)
                   VSORBT(IX,NYHERM+1-IY,NZHERM+1-IZ)=VSORBT(IX,IY,IZ)
                   VLIMOM(IX,NYHERM+1-IY,NZHERM+1-IZ)=VLIMOM(IX,IY,IZ)
C
                END DO
             END DO
          END DO
C
      END IF
C
C=======================================================================
C
      IF (.NOT.SYM_XY.AND.SYM_YZ.AND.SYM_ZX) THEN
C
C=======================================================================
C         Symmetry ZX exist. The program in its present version must
C         have the  Z_X  symmetry plane ("t-basis") ===>>> Calculate
C=======================================================================
C
          DO IZ=1,NZHERM
             DO IY=1,NYHERM/2
                DO IX=1,NXHERM/2
C
                   X_NODE=X_HERM(IX)
                   Y_NODE=Y_HERM(IY)
                   Z_NODE=Z_HERM(IZ)
C
                   CALL WS_WSDEFN(W_CENT,W_LINM,W_SORB,W_MASS,NOEFFM,
     *                                   X_NODE,Y_NODE,Z_NODE,ISOSPI)
C
                   VCENTR(IX,IY,IZ)=W_CENT
                   VEFMAS(IX,IY,IZ)=W_MASS
                   VLIMOM(IX,IY,IZ)=W_LINM
                   VSORBT(IX,IY,IZ)=W_SORB
C
                   IF (ISOSPI.EQ.1)
     *
     *             VCENTR(IX,IY,IZ)=VCENTR(IX,IY,IZ)
     *                             +WS_COULFY(X_NODE,Y_NODE,Z_NODE)
C
                   VCENTR(IX,NYHERM+1-IY,IZ)=VCENTR(IX,IY,IZ)
                   VEFMAS(IX,NYHERM+1-IY,IZ)=VEFMAS(IX,IY,IZ)
                   VSORBT(IX,NYHERM+1-IY,IZ)=VSORBT(IX,IY,IZ)
                   VLIMOM(IX,NYHERM+1-IY,IZ)=VLIMOM(IX,IY,IZ)
C
                   VCENTR(NXHERM+1-IX,IY,IZ)=VCENTR(IX,IY,IZ)
                   VEFMAS(NXHERM+1-IX,IY,IZ)=VEFMAS(IX,IY,IZ)
                   VSORBT(NXHERM+1-IX,IY,IZ)=VSORBT(IX,IY,IZ)
                   VLIMOM(NXHERM+1-IX,IY,IZ)=VLIMOM(IX,IY,IZ)
C
                   VCENTR(NXHERM+1-IX,NYHERM+1-IY,IZ)=VCENTR(IX,IY,IZ)
                   VEFMAS(NXHERM+1-IX,NYHERM+1-IY,IZ)=VEFMAS(IX,IY,IZ)
                   VSORBT(NXHERM+1-IX,NYHERM+1-IY,IZ)=VSORBT(IX,IY,IZ)
                   VLIMOM(NXHERM+1-IX,NYHERM+1-IY,IZ)=VLIMOM(IX,IY,IZ)
C
                END DO
             END DO
          END DO
C
      END IF
C
C=======================================================================
C=======================================================================
C     A L L    T H E    T H R E E    S Y M M E T R Y   P L A N E S
C=======================================================================
C=======================================================================
C
      IF (SYM_XY.AND.SYM_YZ.AND.SYM_ZX) THEN
C
C=======================================================================
C         All symmetry planes present. What a beautiful case. Also:
C         the Z_X symmetry plane is here ("t-basis") =>> Calculate
C=======================================================================
C
          DO IZ=1,NZHERM/2
             DO IY=1,NYHERM/2
                DO IX=1,NXHERM/2
C
                   X_NODE=X_HERM(IX)
                   Y_NODE=Y_HERM(IY)
                   Z_NODE=Z_HERM(IZ)
C
                   CALL WS_WSDEFN(W_CENT,W_LINM,W_SORB,W_MASS,NOEFFM,
     *                                   X_NODE,Y_NODE,Z_NODE,ISOSPI)
C
                   VCENTR(IX,IY,IZ)=W_CENT
                   VEFMAS(IX,IY,IZ)=W_MASS
                   VLIMOM(IX,IY,IZ)=W_LINM
                   VSORBT(IX,IY,IZ)=W_SORB
C
                   IF (ISOSPI.EQ.1)
     *
     *             VCENTR(IX,IY,IZ)=VCENTR(IX,IY,IZ)
     *                             +WS_COULFY(X_NODE,Y_NODE,Z_NODE)
C
                   VCENTR(NXHERM+1-IX,IY,IZ)=VCENTR(IX,IY,IZ)
                   VEFMAS(NXHERM+1-IX,IY,IZ)=VEFMAS(IX,IY,IZ)
                   VSORBT(NXHERM+1-IX,IY,IZ)=VSORBT(IX,IY,IZ)
                   VLIMOM(NXHERM+1-IX,IY,IZ)=VLIMOM(IX,IY,IZ)
C
                   VCENTR(IX,NYHERM+1-IY,IZ)=VCENTR(IX,IY,IZ)
                   VEFMAS(IX,NYHERM+1-IY,IZ)=VEFMAS(IX,IY,IZ)
                   VSORBT(IX,NYHERM+1-IY,IZ)=VSORBT(IX,IY,IZ)
                   VLIMOM(IX,NYHERM+1-IY,IZ)=VLIMOM(IX,IY,IZ)
C
                   VCENTR(IX,IY,NZHERM+1-IZ)=VCENTR(IX,IY,IZ)
                   VEFMAS(IX,IY,NZHERM+1-IZ)=VEFMAS(IX,IY,IZ)
                   VSORBT(IX,IY,NZHERM+1-IZ)=VSORBT(IX,IY,IZ)
                   VLIMOM(IX,IY,NZHERM+1-IZ)=VLIMOM(IX,IY,IZ)
C
                   VCENTR(IX,NYHERM+1-IY,NZHERM+1-IZ)=VCENTR(IX,IY,IZ)
                   VEFMAS(IX,NYHERM+1-IY,NZHERM+1-IZ)=VEFMAS(IX,IY,IZ)
                   VSORBT(IX,NYHERM+1-IY,NZHERM+1-IZ)=VSORBT(IX,IY,IZ)
                   VLIMOM(IX,NYHERM+1-IY,NZHERM+1-IZ)=VLIMOM(IX,IY,IZ)
C
                   VCENTR(NXHERM+1-IX,IY,NZHERM+1-IZ)=VCENTR(IX,IY,IZ)
                   VEFMAS(NXHERM+1-IX,IY,NZHERM+1-IZ)=VEFMAS(IX,IY,IZ)
                   VSORBT(NXHERM+1-IX,IY,NZHERM+1-IZ)=VSORBT(IX,IY,IZ)
                   VLIMOM(NXHERM+1-IX,IY,NZHERM+1-IZ)=VLIMOM(IX,IY,IZ)
C
                   VCENTR(NXHERM+1-IX,NYHERM+1-IY,IZ)=VCENTR(IX,IY,IZ)
                   VEFMAS(NXHERM+1-IX,NYHERM+1-IY,IZ)=VEFMAS(IX,IY,IZ)
                   VSORBT(NXHERM+1-IX,NYHERM+1-IY,IZ)=VSORBT(IX,IY,IZ)
                   VLIMOM(NXHERM+1-IX,NYHERM+1-IY,IZ)=VLIMOM(IX,IY,IZ)
C
                   VCENTR(NXHERM+1-IX,NYHERM+1-IY,NZHERM+1-IZ)
     *
     *                                               =VCENTR(IX,IY,IZ)
C
                   VEFMAS(NXHERM+1-IX,NYHERM+1-IY,NZHERM+1-IZ)
     *
     *                                               =VEFMAS(IX,IY,IZ)
C
                   VSORBT(NXHERM+1-IX,NYHERM+1-IY,NZHERM+1-IZ)
     *
     *                                               =VSORBT(IX,IY,IZ)
C
                   VLIMOM(NXHERM+1-IX,NYHERM+1-IY,NZHERM+1-IZ)
     *
     *                                               =VLIMOM(IX,IY,IZ)
C
                END DO
             END DO
          END DO
C
      END IF
C
C=======================================================================
C
      CALL WS_CPUTIM('POTSET',0)
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C=======================================================================
C
      SUBROUTINE WS_CELMAT(NXHERM,NYHERM,NZHERM,NXMAXX,NYMAXX,NZMAXX,
     *                     VCENTR,VEFMAS,VSORBT,VLIMOM,EPSHER,ISOSPI,
     *                                                        NOEFFM)
C=======================================================================
      USE params
C=======================================================================
      COMPLEX
     *          EWAVEF
C
      DIMENSION
     *          VCENTR(1:NDXHRM,1:NDYHRM,1:NDZHRM),
     *          VEFMAS(1:NDXHRM,1:NDYHRM,1:NDZHRM),
     *          VSORBT(1:NDXHRM,1:NDYHRM,1:NDZHRM),
     *          VLIMOM(1:NDXHRM,1:NDYHRM,1:NDZHRM)
      DIMENSION
     *          XHERMI(1:NDXHRM),YHERMI(1:NDYHRM),ZHERMI(1:NDZHRM),
     *          WXHERM(1:NDXHRM),WYHERM(1:NDYHRM),WZHERM(1:NDZHRM)
C
      COMMON
     *       /SPECTR_SPINOR/ EWAVEF(1:NDBASE,1:NDBASE)
      COMMON
     *       /SETBAS_DIMENS/ LDBASE
      COMMON
     *       /NAMELI_NOSORB/ NOSORB
C
C=======================================================================
C     This subroutine performs the integration  of matrix elements
C     for the Schrodinger  or Dirac equations  with Woods-Saxon or
C     folded Yukawa average field nuclear potentials
C=======================================================================
C
C     Meaning of some parameters:
C
C=======================================================================
C
C     ND{}HRM - The maximum order of the Gauss-Hermite formula for
C               the numerical integrations;
C
C     N{}HERM - Declared actual value  of the order parameter  for
C               the Gauss-Hermite formula;
C
C     ND{}MAX - Maximum number of HO shells separately for each of
C               the axes of the harmonic oscillator basis
C
C=======================================================================
C
      CALL WS_CPUTIM('CELMAT',1)
C
C=======================================================================
C
C      Below:  Defining phases.  The corresponding phases are those
C      of the "t"-basis. The phases related to sigma-z matrices are
C      additionally multiplied by i (imaginary unit).
C
      CALL WS_TPHASE(NYMAXX)
C
C      Calculating  zeros of the Hermite polynomials and the weight
C      coefficients of the Gauss-Hermite integration (dimensionless)
C      The zeros are used directly below,  to define the potentials
C      in the corresponding integration points that form a 3-D mesh.
C
      CALL WS_GAUHER(XHERMI,WXHERM,NXHERM,NDXHRM,EPSHER)
      CALL WS_GAUHER(YHERMI,WYHERM,NYHERM,NDYHRM,EPSHER)
      CALL WS_GAUHER(ZHERMI,WZHERM,NZHERM,NDZHRM,EPSHER)
C
C      Defining the central, the effective mass, the spin-orbit and
C      the linear momentum mean field potentials on the mesh
C
      CALL WS_POTSET(XHERMI,YHERMI,ZHERMI,NXHERM,NYHERM,NZHERM,
     *               VEFMAS,VSORBT,VLIMOM,VCENTR,NOEFFM,ISOSPI)
C
C
C      Calculating the matrix elements of the central potential and
C      also  auxiliary integrals  for the spin-orbit  and remaining
C      terms
C
      CALL WS_BEGINT(VCENTR,VEFMAS,VSORBT,VLIMOM,
     *                      NXHERM,NYHERM,NZHERM,
     *                      NXMAXX,NYMAXX,NZMAXX)
C
C      Setting to zero the going-to-be hamiltonian matrix  elements
C
      EWAVEF(:,:)=CMPLX(0.0D0,0.0D0)
C
C      Calculating the matrix elements  of the kinetic energy  term
C      within  the deformed harmonic oscillator basis.  This is the
C      non-relativistic kinetic energy term, without effective mass
C
C     CALL WS_INTKIN
C
C      Calculating  matrix elements  of the central potential  term
C      within the deformed harmonic oscillator basis
C
      CALL WS_INTCEN(NXMAXX,NYMAXX,NZMAXX)
C
C      Calculating matrix elements  of position dependent effective
C      mass kinetic-energy term  and next, the linear-momentum term.
C      Both terms must have  strictly the same parameters,  because
C      they originate from the common operator
C
C          P (1/2m*) P   ==>>>  (1/2m*) P**2 + V_linm
C
C      Sometimes it is practical to calculate them separately
C
C     CALL WS_INTEFF(NXMAXX,NYMAXX,NZMAXX)
C     CALL WS_INTLNM(NXMAXX,NYMAXX,NZMAXX)
C
C      Calculating  matrix elements  of the combined  i.e. "p-m*-p"
C      term equivalent to the sums of the two previous ones
C
      CALL WS_INTPMP(NXMAXX,NYMAXX,NZMAXX)
C
C      Calculating  matrix  elements  of  the spin-orbit  potential
C      within the deformed harmonic oscillator basis
C
      IF (NOSORB.EQ.0) THEN
          CALL WS_INTSOX(NXMAXX,NYMAXX,NZMAXX)
          CALL WS_INTSOY(NXMAXX,NYMAXX,NZMAXX)
          CALL WS_INTSOZ(NXMAXX,NYMAXX,NZMAXX)
      END IF
C
C=======================================================================
C
      CALL WS_CPUTIM('CELMAT',0)
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C=======================================================================
C
      SUBROUTINE WS_TPHASE(NYMAXX)
C=======================================================================
      USE params
C=======================================================================
C
      COMMON
     *       /TPHASE_PHASES/ TPHAPP(0:NDYMAX,0:NDYMAX,0:NDKART),
     *                       TPHAPM(0:NDYMAX,0:NDYMAX,0:NDKART),
     *                       TPHAMP(0:NDYMAX,0:NDYMAX,0:NDKART),
     *                       TPHAMM(0:NDYMAX,0:NDYMAX,0:NDKART)
C
C=======================================================================
C
      I_FAZA(N)=((1+(-1)**N)/2)*(-1)**(N/2)
C
C=======================================================================
C
C     This subroutine,  by defining the phases,  controls from one
C     single place  the basis-version used.  Here the phase choice
C     corresponds to the "t_basis".  The corresponding expressions
C     are obtained  assuming the deformed HO Cartesian basis  with
C     the overall phase factor:
C
C                             (0,1) ** N_y
C
C     Consequently:
C
C     |t+> = Norm. * ((0,1)**( Ny ) |Up> - (0,1) ** (1-Ny) |Down>)
C     |t-> = Norm. * ((0,1)**(Ny-1) |Up> + (0,1) ** (-Ny ) |Down>)
C
C     The third index represents Pauli  matrices  with  zero value
C     for the identity matrix.
C
C     W A R N I N G:     The phases for  KARTEZ=3 should have been
C                        multiplied by imaginary unit. However, it
C                        is  easier to keep phases real. Therefore,
C                        we  d o  n o t  multiply  KARTEZ=3 phases
C                        by i, and have to  r e m e m b e r  about
C                        it now and always to the end of the world,
C                        but in particular  when setting the final
C                        Hamiltonian matrix
C
C     This subroutine  calculates  the phases  for all the 4 blocs
C     in the basis "t" (good simplex basis for Ry)
C
C                        Bloc "t+,t+"  (PP)
C                        Bloc "t+,t-"  (PM)
C                        Bloc "t-,t+"  (MP)
C                        Bloc "t-,t-"  (MM)
C
C=======================================================================
C
      IF (NYMAXX.GT.NDYMAX) STOP 'NYMAXX.GT.NDYMAX in TPHASE'
C
C=======================================================================
C
      DO MY=0,NYMAXX
         DO NY=0,NYMAXX
C
C                        KARTEZ
C
            TPHAPP(NY,MY,   0  )=I_FAZA(NY-MY  )
            TPHAPM(NY,MY,   0  )=I_FAZA(NY-MY+1)
            TPHAMP(NY,MY,   0  )=I_FAZA(NY-MY-1)
            TPHAMM(NY,MY,   0  )=I_FAZA(NY-MY  )
C
            TPHAPP(NY,MY,   1  )=I_FAZA(NY+MY+1)
            TPHAPM(NY,MY,   1  )=I_FAZA(NY+MY  )
            TPHAMP(NY,MY,   1  )=I_FAZA(NY+MY  )
            TPHAMM(NY,MY,   1  )=I_FAZA(NY+MY-1)
C
            TPHAPP(NY,MY,   2  )=I_FAZA(NY+MY+2)
            TPHAPM(NY,MY,   2  )=I_FAZA(NY+MY+1)
            TPHAMP(NY,MY,   2  )=I_FAZA(NY+MY+1)
            TPHAMM(NY,MY,   2  )=I_FAZA(NY+MY  )
C
            TPHAPP(NY,MY,   3  )=I_FAZA(NY-MY+1)
            TPHAPM(NY,MY,   3  )=I_FAZA(NY-MY+2)
            TPHAMP(NY,MY,   3  )=I_FAZA(NY-MY  )
            TPHAMM(NY,MY,   3  )=I_FAZA(NY-MY+1)
C
         END DO
      END DO
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C=======================================================================
C
      SUBROUTINE WS_PHASES(CPHASE,NYMAXX)
C=======================================================================
      USE params
C=======================================================================
C
      COMPLEX
     *          PHASPI,UNIT_I
C
      DIMENSION
     *          CPHASE(0:NDYMAX,0:NDYMAX,0:NDKART)
C
      COMMON
     *       /PHASES_SPIPHA/ PHASPI(NDBASE,0:NDREVE,0:NDSPIN)
      COMMON
     *       /SETBAS_NXNYNZ/ NXVECT(1:NDBASE),
     *                       NYVECT(1:NDBASE),
     *                       NZVECT(1:NDBASE)
     *
     *       /SETBAS_DIMENS/ LDBASE
C
C=======================================================================
C
C     HF_ODD compatibility routine - verify consistency with  TPHASE
C                                    and the new derivation document
C
C=======================================================================
C
      DO NY=0,NYMAXX
         DO MY=0,NYMAXX
C
                         KARTEZ=0
            CPHASE(NY,MY,KARTEZ)=(-1)**(IABS((NY-MY  )/2))
C
                         KARTEZ=1
            CPHASE(NY,MY,KARTEZ)=(-1)**(IABS((NY+MY+1)/2))
C
                         KARTEZ=2
            CPHASE(NY,MY,KARTEZ)=(-1)**(IABS((NY+MY+2)/2))
C
                         KARTEZ=3
            CPHASE(NY,MY,KARTEZ)=(-1)**(IABS((NY-MY+1)/2))
C
         END DO
      END DO
C
C=======================================================================
C
      DSQRT2=SQRT(2.000000)
C
      UNIT_I=CMPLX(0.0,1.0)
C
C=======================================================================
C
C     PHASPI(IBASE,ISPIN)  is a phase factor which multiplies the
C     Ispin-th  component of the {|nx,ny,nz,Ispin>} spinor in the
C     the basis;  Current choice corresponds to the {|t_+>} basis
C
C=======================================================================
C
      DO IBASE=1,LDBASE
C
         NY=NYVECT(IBASE)
C
         PHASPI(IBASE,0,1)=+UNIT_I**( NY )/DSQRT2
         PHASPI(IBASE,0,0)=-UNIT_I**(1-NY)/DSQRT2
C
      END DO
C
      DO IBASE=1,LDBASE
C
         NY=NYVECT(IBASE)
C
         PHASPI(IBASE,1,1)=-UNIT_I**(1+NY)/DSQRT2
         PHASPI(IBASE,1,0)=+UNIT_I**( -NY)/DSQRT2
C
      END DO
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C=======================================================================
C
      SUBROUTINE WS_BEGINT(VCENTR,VEFMAS,VSORBT,VLIMOM,
     *                            NXHERM,NYHERM,NZHERM,
     *                            NXMAXX,NYMAXX,NZMAXX)
C=======================================================================
      USE params
C=======================================================================
C
C=======================================================================
      ALLOCATABLE XCENTR(:,:,:),XEFMAS(:,:,:),
     *            XSORBT(:,:,:),XLIMOM(:,:,:)
      ALLOCATABLE YCENTR(:,:,:),YEFMAS(:,:,:),
     *            YSORBT(:,:,:),YLIMOM(:,:,:)
      ALLOCATABLE UCENTR(:,:,:),UEFMAS(:,:,:),
     *            USORBT(:,:,:),ULIMOM(:,:,:)
C=======================================================================
      DIMENSION
     *          VCENTR(1:NDXHRM,1:NDYHRM,1:NDZHRM),
     *          VEFMAS(1:NDXHRM,1:NDYHRM,1:NDZHRM),
     *          VSORBT(1:NDXHRM,1:NDYHRM,1:NDZHRM),
     *          VLIMOM(1:NDXHRM,1:NDYHRM,1:NDZHRM)
C
      COMMON
     *       /WSEXEC_HERSTO/ HERMTS(0:ND2MAX,1:NDGAUS,1:NDKART)
      COMMON
     *       /BEGINT_POTENS/ WCENTR(0:ND2MAX,0:ND2MAX,0:ND2MAX),
     *                       WEFMAS(0:ND2MAX,0:ND2MAX,0:ND2MAX),
     *                       WSORBT(0:ND2MAX,0:ND2MAX,0:ND2MAX),
     *                       WLIMOM(0:ND2MAX,0:ND2MAX,0:ND2MAX)
      COMMON
     *       /WSEXEC_INTSTO/ HERWGT(1:NDGAUS,1:NDKART),
     *                       HERPNT(1:NDGAUS,1:NDKART)
C
C=======================================================================
C     This subroutine performs the introductory operations for the
C     calculation of the three-dimensional integrals
C=======================================================================
C
      ALLOCATE(UCENTR(1:NXHERM,1:NYHERM,1:NZHERM))
      ALLOCATE(UEFMAS(1:NXHERM,1:NYHERM,1:NZHERM))
      ALLOCATE(USORBT(1:NXHERM,1:NYHERM,1:NZHERM))
      ALLOCATE(ULIMOM(1:NXHERM,1:NYHERM,1:NZHERM))
C
      ALLOCATE(XCENTR(0:ND2MAX,1:NYHERM,1:NZHERM))
      ALLOCATE(XEFMAS(0:ND2MAX,1:NYHERM,1:NZHERM))
      ALLOCATE(XSORBT(0:ND2MAX,1:NYHERM,1:NZHERM))
      ALLOCATE(XLIMOM(0:ND2MAX,1:NYHERM,1:NZHERM))
C
      ALLOCATE(YCENTR(0:ND2MAX,0:ND2MAX,1:NZHERM))
      ALLOCATE(YEFMAS(0:ND2MAX,0:ND2MAX,1:NZHERM))
      ALLOCATE(YSORBT(0:ND2MAX,0:ND2MAX,1:NZHERM))
      ALLOCATE(YLIMOM(0:ND2MAX,0:ND2MAX,1:NZHERM))
C
C=======================================================================
C     Defining   t h e   auxiliary    w e i g h t    f a c t o r s
C=======================================================================
C
      DO IZ=1,NZHERM
         DO IY=1,NYHERM
            DO IX=1,NXHERM
C
               W_HERM=HERWGT(IX,1)*HERWGT(IY,2)*HERWGT(IZ,3)
C
               UCENTR(IX,IY,IZ)=VCENTR(IX,IY,IZ)*W_HERM
               UEFMAS(IX,IY,IZ)=VEFMAS(IX,IY,IZ)*W_HERM
               USORBT(IX,IY,IZ)=VSORBT(IX,IY,IZ)*W_HERM
               ULIMOM(IX,IY,IZ)=VLIMOM(IX,IY,IZ)*W_HERM
C
            END DO
         END DO
      END DO
C
      DO IZ=1,NZHERM
         DO IY=1,NYHERM
            DO KX=0,2*NXMAXX+2
C
               RESUCE=0.00000
               REFMAS=0.00000
               RESUSO=0.00000
               RELINM=0.00000
C
               DO IX=1,NXHERM
                  RESUCE=RESUCE+HERMTS(KX,IX,1)*UCENTR(IX,IY,IZ)
                  REFMAS=REFMAS+HERMTS(KX,IX,1)*UEFMAS(IX,IY,IZ)
                  RESUSO=RESUSO+HERMTS(KX,IX,1)*USORBT(IX,IY,IZ)
                  RELINM=RELINM+HERMTS(KX,IX,1)*ULIMOM(IX,IY,IZ)
               END DO
C
               XCENTR(KX,IY,IZ)=RESUCE
               XEFMAS(KX,IY,IZ)=REFMAS
               XSORBT(KX,IY,IZ)=RESUSO
               XLIMOM(KX,IY,IZ)=RELINM
C
            END DO
         END DO
      END DO
C
C=======================================================================
C
      DO IZ=1,NZHERM
         DO KY=0,2*NYMAXX+2
            DO KX=0,2*NXMAXX+2
C
               RESUCE=0.00000
               REFMAS=0.00000
               RESUSO=0.00000
               RELINM=0.00000
C
               DO IY=1,NYHERM
                  RESUCE=RESUCE+HERMTS(KY,IY,2)*XCENTR(KX,IY,IZ)
                  REFMAS=REFMAS+HERMTS(KY,IY,2)*XEFMAS(KX,IY,IZ)
                  RESUSO=RESUSO+HERMTS(KY,IY,2)*XSORBT(KX,IY,IZ)
                  RELINM=RELINM+HERMTS(KY,IY,2)*XLIMOM(KX,IY,IZ)
               END DO
C
               YCENTR(KX,KY,IZ)=RESUCE
               YEFMAS(KX,KY,IZ)=REFMAS
               YSORBT(KX,KY,IZ)=RESUSO
               YLIMOM(KX,KY,IZ)=RELINM
C
            END DO
         END DO
      END DO
C
C=======================================================================
C
      DO KZ=0,2*NZMAXX+2
         DO KY=0,2*NYMAXX+2
            DO KX=0,2*NXMAXX+2
C
               RESUCE=0.00000
               REFMAS=0.00000
               RESUSO=0.00000
               RELINM=0.00000
C
               DO IZ=1,NZHERM
                  RESUCE=RESUCE+HERMTS(KZ,IZ,3)*YCENTR(KX,KY,IZ)
                  REFMAS=REFMAS+HERMTS(KZ,IZ,3)*YEFMAS(KX,KY,IZ)
                  RESUSO=RESUSO+HERMTS(KZ,IZ,3)*YSORBT(KX,KY,IZ)
                  RELINM=RELINM+HERMTS(KZ,IZ,3)*YLIMOM(KX,KY,IZ)
               END DO
C
               WCENTR(KX,KY,KZ)=RESUCE
               WEFMAS(KX,KY,KZ)=REFMAS
               WSORBT(KX,KY,KZ)=RESUSO
               WLIMOM(KX,KY,KZ)=RELINM
C
            END DO
         END DO
      END DO
C
      DEALLOCATE(UCENTR,UEFMAS,USORBT,ULIMOM)
      DEALLOCATE(XCENTR,XEFMAS,XSORBT,XLIMOM)
      DEALLOCATE(YCENTR,YEFMAS,YSORBT,YLIMOM)
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C=======================================================================
C
      SUBROUTINE WS_INTKIN
C=======================================================================
      USE params
C=======================================================================
C
      COMPLEX
     *          EWAVEF
C
      COMMON
     *       /TPHASE_PHASES/ TPHAPP(0:NDYMAX,0:NDYMAX,0:NDKART),
     *                       TPHAPM(0:NDYMAX,0:NDYMAX,0:NDKART),
     *                       TPHAMP(0:NDYMAX,0:NDYMAX,0:NDKART),
     *                       TPHAMM(0:NDYMAX,0:NDYMAX,0:NDKART)
      COMMON
     *       /SPECTR_SPINOR/ EWAVEF(1:NDBASE,1:NDBASE)
      COMMON
     *       /SETBAS_NXNYNZ/ NXVECT(1:NDBASE),
     *                       NYVECT(1:NDBASE),
     *                       NZVECT(1:NDBASE)
     *
     *       /SETBAS_SCALNG/ HOMSCA(1:NDKART)
     *       /SETBAS_PLANCK/ HBMASS,HBMRPA
     *       /SETBAS_DIMENS/ LDBASE
C
C=======================================================================
C     This subroutine calculates the kinetic energy matrix elements
C=======================================================================
C
      KARTEZ=0
C
C=======================================================================
C
      R_ZERO=0.00
C
      DO IKETHO=1,LDBASE
         DO IBRAHO=1,LDBASE
C
            NXBRA=NXVECT(IBRAHO)
            NYBRA=NYVECT(IBRAHO)
            NZBRA=NZVECT(IBRAHO)
C
            NXKET=NXVECT(IKETHO)
            NYKET=NYVECT(IKETHO)
            NZKET=NZVECT(IKETHO)
C
            NY=NYBRA
            MY=NYKET
C
C=======================================================================
C
            TTTZ=0.00
C
            IF (NXBRA.EQ.NXKET) THEN
C
                IF (NYBRA.EQ.NYKET) THEN
C
                    IF (NZBRA.EQ.NZKET) THEN
                        TTTZ=+(2*NZBRA+1)
                    END IF
C
                    IF (NZBRA.EQ.(NZKET+2)) THEN
                        TTTZ=-SQRT(REAL(NZBRA*(NZKET+1)))
                    END IF
C
                    IF (NZBRA.EQ.(NZKET-2)) THEN
                        TTTZ=-SQRT(REAL(NZKET*(NZBRA+1)))
                    END IF
C
                    TTTZ=TTTZ*HOMSCA(3)**2
C
                END IF
C
            END IF
C
C=======================================================================
C
            TTTY=0.00
C
            IF (NXBRA.EQ.NXKET) THEN
C
                IF (NZBRA.EQ.NZKET) THEN
C
                    IF (NYBRA.EQ.NYKET) THEN
                        TTTY=+(2*NYBRA+1)
                    END IF
C
                    IF (NYBRA.EQ.(NYKET+2)) THEN
                        TTTY=-SQRT(REAL(NYBRA*(NYKET+1)))
                    END IF
C
                    IF (NYBRA.EQ.(NYKET-2)) THEN
                        TTTY=-SQRT(REAL(NYKET*(NYBRA+1)))
                    END IF
C
                    TTTY=TTTY*HOMSCA(2)**2
C
                END IF
C
            END IF
C
C=======================================================================
C
            TTTX=0.00
C
            IF (NYBRA.EQ.NYKET) THEN
C
                IF (NZBRA.EQ.NZKET) THEN
C
                    IF (NXBRA.EQ.NXKET) THEN
                        TTTX=+(2*NXBRA+1)
                    END IF
C
                    IF (NXBRA.EQ.(NXKET+2)) THEN
                        TTTX=-SQRT(REAL(NXBRA*(NXKET+1)))
                    END IF
C
                    IF (NXBRA.EQ.(NXKET-2)) THEN
                        TTTX=-SQRT(REAL(NXKET*(NXBRA+1)))
                    END IF
C
                    TTTX=TTTX*HOMSCA(1)**2
C
                END IF
C
            END IF
C
            TAUKIN=0.50*HBMASS*(TTTX+TTTY+TTTZ)
C
C=======================================================================
C           Phases below were defined in TPHASE
C=======================================================================
C
            TAUKIN=TAUKIN*TPHAPP(NY,MY,KARTEZ)
C
            EWAVEF(IBRAHO,IKETHO)=EWAVEF(IBRAHO,IKETHO)
     *                           +CMPLX (TAUKIN,R_ZERO)
C
         END DO
      END DO
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C=======================================================================
C
      SUBROUTINE WS_INTCEN(NXMAXX,NYMAXX,NZMAXX)
C=======================================================================
      USE params
C=======================================================================
C
      COMPLEX
     *          EWAVEF
C
      DIMENSION
     *          X_HELP(0:ND2MAX,0:ND2MAX),Y_HELP(0:ND2MAX)
C
      COMMON
     *       /DEVHER_COEXYZ/ COEF00(0:ND2MAX,0:NDOSGS,0:NDOSGS,NDKART),
     *                       COEF01(0:ND2MAX,0:NDOSGS,0:NDOSGS,NDKART),
     *                       COEF11(0:ND2MAX,0:NDOSGS,0:NDOSGS,NDKART),
     *                       COEF02(0:ND2MAX,0:NDOSGS,0:NDOSGS,NDKART)
      COMMON
     *       /TPHASE_PHASES/ TPHAPP(0:NDYMAX,0:NDYMAX,0:NDKART),
     *                       TPHAPM(0:NDYMAX,0:NDYMAX,0:NDKART),
     *                       TPHAMP(0:NDYMAX,0:NDYMAX,0:NDKART),
     *                       TPHAMM(0:NDYMAX,0:NDYMAX,0:NDKART)
      COMMON
     *       /BEGINT_POTENS/ WCENTR(0:ND2MAX,0:ND2MAX,0:ND2MAX),
     *                       WEFMAS(0:ND2MAX,0:ND2MAX,0:ND2MAX),
     *                       WSORBT(0:ND2MAX,0:ND2MAX,0:ND2MAX),
     *                       WLIMOM(0:ND2MAX,0:ND2MAX,0:ND2MAX)
      COMMON
     *       /SETBAS_INDICE/ INDICE(0:NDXMAX,0:NDYMAX,0:NDZMAX)
     *
     *       /SETBAS_BASIS1/ LAXOFY(0:NDYMAX),LAXOFZ(0:NDZMAX),
     *                       LAYOFZ(0:NDZMAX),LAYOFX(0:NDXMAX),
     *                       LAZOFX(0:NDXMAX),LAZOFY(0:NDYMAX)
     *
     *       /SETBAS_BASIS2/ LAXOYZ(0:NDYMAX,0:NDZMAX),
     *                       LAYOZX(0:NDZMAX,0:NDXMAX),
     *                       LAZOXY(0:NDXMAX,0:NDYMAX)
      COMMON
     *       /SPECTR_SPINOR/ EWAVEF(1:NDBASE,1:NDBASE)
C
C=======================================================================
C     This subroutine  performs  the  Gauss-Hermite  integrations
C     of the central Hamiltonian (Woods-Saxon deformed potential)
C=======================================================================
C
      CALL WS_CPUTIM('INTCEN',1)
C
C=======================================================================
C
      KARTEZ=0
C
C=======================================================================
C
      R_ZERO=0.0
C
      DO NX=0,NXMAXX
         DO MX=0,NXMAXX
C
            DO KY=0,2*NYMAXX
               DO KZ=0,2*NZMAXX
                  RESULT=0.0000
                  DO KX=NX+MX,0,-2
                     RESULT=RESULT+COEF00(KX,MX,NX,1)*WCENTR(KX,KY,KZ)
                  END DO
                  X_HELP(KY,KZ)=RESULT
               END DO
            END DO
C
            DO NY=0,LAYOFX(NX)
               DO MY=0,LAYOFX(MX)
C
                  DO KZ=0,2*NZMAXX
                     RESULT=0.0000
                     DO KY=NY+MY,0,-2
                        RESULT=RESULT+COEF00(KY,MY,NY,2)
     *                               *X_HELP(KY,KZ)
                     END DO
                     Y_HELP(KZ)=RESULT
                  END DO
C
                  DO NZ=0,LAZOXY(NX,NY)
                     DO MZ=0,LAZOXY(MX,MY)
                        RESULT=0.0
                        DO KZ=NZ+MZ,0,-2
                           RESULT=RESULT+COEF00(KZ,MZ,NZ, 3)
     *                                  *Y_HELP(KZ)
                        END DO
C
C=======================================================================
C                       Phases below were defined by "TPHASE"
C=======================================================================
C
                        RESULT=RESULT*TPHAPP(NY,MY,KARTEZ)
C
                        IBRAHO=INDICE(NX,NY,NZ)
                        IKETHO=INDICE(MX,MY,MZ)
C
                        EWAVEF(IBRAHO,IKETHO)=EWAVEF(IBRAHO,IKETHO)
     *                                       +CMPLX (RESULT,R_ZERO)
C
                     END DO
                  END DO
C
               END DO
            END DO
C
         END DO
      END DO
C
C=======================================================================
C
      CALL WS_CPUTIM('INTCEN',0)
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C=======================================================================
C
      SUBROUTINE WS_INTEFF(NXMAXX,NYMAXX,NZMAXX)
C=======================================================================
      USE params
C=======================================================================
C
      COMPLEX
     *          EWAVEF
C
      DIMENSION
     *          X_HELP(0:ND2MAX,0:ND2MAX),Y_HELP(0:ND2MAX)
C
      COMMON
     *       /DEVHER_COEXYZ/ COEF00(0:ND2MAX,0:NDOSGS,0:NDOSGS,NDKART),
     *                       COEF01(0:ND2MAX,0:NDOSGS,0:NDOSGS,NDKART),
     *                       COEF11(0:ND2MAX,0:NDOSGS,0:NDOSGS,NDKART),
     *                       COEF02(0:ND2MAX,0:NDOSGS,0:NDOSGS,NDKART)
      COMMON
     *       /TPHASE_PHASES/ TPHAPP(0:NDYMAX,0:NDYMAX,0:NDKART),
     *                       TPHAPM(0:NDYMAX,0:NDYMAX,0:NDKART),
     *                       TPHAMP(0:NDYMAX,0:NDYMAX,0:NDKART),
     *                       TPHAMM(0:NDYMAX,0:NDYMAX,0:NDKART)
      COMMON
     *       /BEGINT_POTENS/ WCENTR(0:ND2MAX,0:ND2MAX,0:ND2MAX),
     *                       WEFMAS(0:ND2MAX,0:ND2MAX,0:ND2MAX),
     *                       WSORBT(0:ND2MAX,0:ND2MAX,0:ND2MAX),
     *                       WLIMOM(0:ND2MAX,0:ND2MAX,0:ND2MAX)
      COMMON
     *       /SETBAS_INDICE/ INDICE(0:NDXMAX,0:NDYMAX,0:NDZMAX)
     *
     *       /SETBAS_BASIS1/ LAXOFY(0:NDYMAX),LAXOFZ(0:NDZMAX),
     *                       LAYOFZ(0:NDZMAX),LAYOFX(0:NDXMAX),
     *                       LAZOFX(0:NDXMAX),LAZOFY(0:NDYMAX)
     *
     *       /SETBAS_BASIS2/ LAXOYZ(0:NDYMAX,0:NDZMAX),
     *                       LAYOZX(0:NDZMAX,0:NDXMAX),
     *                       LAZOXY(0:NDXMAX,0:NDYMAX)
      COMMON
     *       /SPECTR_SPINOR/ EWAVEF(1:NDBASE,1:NDBASE)
C
C=======================================================================
C
C     This subroutine  performs  the  Gauss-Hermite  integrations
C     of the kinetic energy term with the effective mass. Here we
C     define the kinetic energy operator as:
C
C               T = - hbarc**2/(2m_star*c**2) * Laplacean
C
C=======================================================================
C
      CALL WS_CPUTIM('INTEFF',1)
C
C=======================================================================
C
      KARTEZ=0
C
C=======================================================================
C     Kinetic-energy term  related to the  Cartesian  x-direction
C=======================================================================
C
      R_ZERO=0.0
C
      DO NX=0,NXMAXX
         DO MX=0,NXMAXX
C
            DO KY=0,2*NYMAXX+2
               DO KZ=0,2*NZMAXX+2
                  RESULT=0.0000
                  DO KX=NX+MX+2,0,-2
                     RESULT=RESULT+COEF02(KX,MX,NX,1)*WEFMAS(KX,KY,KZ)
                  END DO
                  X_HELP(KY,KZ)=RESULT
               END DO
            END DO
C
            DO NY=0,LAYOFX(NX)
               DO MY=0,LAYOFX(MX)
C
                  DO KZ=0,2*NZMAXX+2
                     RESULT=0.0000
                     DO KY=NY+MY,0,-2
                        RESULT=RESULT+COEF00(KY,MY,NY,2)
     *                               *X_HELP(KY,KZ)
                     END DO
                     Y_HELP(KZ)=RESULT
                  END DO
C
                  DO NZ=0,LAZOXY(NX,NY)
                     DO MZ=0,LAZOXY(MX,MY)
                        RESULT=0.0
                        DO KZ=NZ+MZ,0,-2
                           RESULT=RESULT+COEF00(KZ,MZ,NZ,3)
     *                                  *Y_HELP(KZ)
                        END DO
C
C=======================================================================
C                       Phases below were defined in PHASE
C=======================================================================
C
                        RESULT=RESULT*TPHAPP(NY,MY,KARTEZ)
C
                        IBRAHO=INDICE(NX,NY,NZ)
                        IKETHO=INDICE(MX,MY,MZ)
C
                        EWAVEF(IBRAHO,IKETHO)=EWAVEF(IBRAHO,IKETHO)
     *                                       +CMPLX (RESULT,R_ZERO)
C
                     END DO
                  END DO
C
               END DO
            END DO
C
         END DO
      END DO
C
C=======================================================================
C     Kinetic-energy term  related to the  Cartesian  y-direction
C=======================================================================
C
      R_ZERO=0.0
C
      DO NX=0,NXMAXX
         DO MX=0,NXMAXX
C
            DO KY=0,2*NYMAXX+2
               DO KZ=0,2*NZMAXX+2
                  RESULT=0.0000
                  DO KX=NX+MX,0,-2
                     RESULT=RESULT+COEF00(KX,MX,NX,1)*WEFMAS(KX,KY,KZ)
                  END DO
                  X_HELP(KY,KZ)=RESULT
               END DO
            END DO
C
            DO NY=0,LAYOFX(NX)
               DO MY=0,LAYOFX(MX)
C
                  DO KZ=0,2*NZMAXX+2
                     RESULT=0.0000
                     DO KY=NY+MY+2,0,-2
                        RESULT=RESULT+COEF02(KY,MY,NY,2)
     *                               *X_HELP(KY,KZ)
                     END DO
                     Y_HELP(KZ)=RESULT
                  END DO
C
                  DO NZ=0,LAZOXY(NX,NY)
                     DO MZ=0,LAZOXY(MX,MY)
                        RESULT=0.0
                        DO KZ=NZ+MZ,0,-2
                           RESULT=RESULT+COEF00(KZ,MZ,NZ,3)
     *                                  *Y_HELP(KZ)
                        END DO
C
C=======================================================================
C                       Phases below were defined in TPHASE
C=======================================================================
C
                        RESULT=RESULT*TPHAPP(NY,MY,KARTEZ)
C
                        IBRAHO=INDICE(NX,NY,NZ)
                        IKETHO=INDICE(MX,MY,MZ)
C
                        EWAVEF(IBRAHO,IKETHO)=EWAVEF(IBRAHO,IKETHO)
     *                                       +CMPLX (RESULT,R_ZERO)
C
                     END DO
                  END DO
C
               END DO
            END DO
C
         END DO
      END DO
C
C=======================================================================
C     Kinetic-energy term  related to  the Cartesian  z-direction
C=======================================================================
C
      R_ZERO=0.0
C
      DO NX=0,NXMAXX
         DO MX=0,NXMAXX
C
            DO KY=0,2*NYMAXX+2
               DO KZ=0,2*NZMAXX+2
                  RESULT=0.0000
                  DO KX=NX+MX,0,-2
                     RESULT=RESULT+COEF00(KX,MX,NX,1)*WEFMAS(KX,KY,KZ)
                  END DO
                  X_HELP(KY,KZ)=RESULT
               END DO
            END DO
C
            DO NY=0,LAYOFX(NX)
               DO MY=0,LAYOFX(MX)
C
                  DO KZ=0,2*NZMAXX+2
                     RESULT=0.0000
                     DO KY=NY+MY,0,-2
                        RESULT=RESULT+COEF00(KY,MY,NY,2)
     *                               *X_HELP(KY,KZ)
                     END DO
                     Y_HELP(KZ)=RESULT
                  END DO
C
                  DO NZ=0,LAZOXY(NX,NY)
                     DO MZ=0,LAZOXY(MX,MY)
                        RESULT=0.0
                        DO KZ=NZ+MZ+2,0,-2
                           RESULT=RESULT+COEF02(KZ,MZ,NZ,3)
     *                                  *Y_HELP(KZ)
                        END DO
C
C=======================================================================
C                       Phases below were defined in TPHASE
C=======================================================================
C
                        RESULT=RESULT*TPHAPP(NY,MY,KARTEZ)
C
                        IBRAHO=INDICE(NX,NY,NZ)
                        IKETHO=INDICE(MX,MY,MZ)
C
                        EWAVEF(IBRAHO,IKETHO)=EWAVEF(IBRAHO,IKETHO)
     *                                       +CMPLX (RESULT,R_ZERO)
C
                     END DO
                  END DO
C
               END DO
            END DO
C
         END DO
      END DO
C
C=======================================================================
C
      CALL WS_CPUTIM('INTEFF',0)
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C=======================================================================
C
      SUBROUTINE WS_INTPMP(NXMAXX,NYMAXX,NZMAXX)
C=======================================================================
      USE params
C=======================================================================
C
      COMPLEX
     *          EWAVEF
C
      DIMENSION
     *          X_HELP(0:ND2MAX,0:ND2MAX),Y_HELP(0:ND2MAX)
C
      COMMON
     *       /DEVHER_COEXYZ/ COEF00(0:ND2MAX,0:NDOSGS,0:NDOSGS,NDKART),
     *                       COEF01(0:ND2MAX,0:NDOSGS,0:NDOSGS,NDKART),
     *                       COEF11(0:ND2MAX,0:NDOSGS,0:NDOSGS,NDKART),
     *                       COEF02(0:ND2MAX,0:NDOSGS,0:NDOSGS,NDKART)
      COMMON
     *       /BEGINT_POTENS/ WCENTR(0:ND2MAX,0:ND2MAX,0:ND2MAX),
     *                       WEFMAS(0:ND2MAX,0:ND2MAX,0:ND2MAX),
     *                       WSORBT(0:ND2MAX,0:ND2MAX,0:ND2MAX),
     *                       WLIMOM(0:ND2MAX,0:ND2MAX,0:ND2MAX)
      COMMON
     *       /TPHASE_PHASES/ TPHAPP(0:NDYMAX,0:NDYMAX,0:NDKART),
     *                       TPHAPM(0:NDYMAX,0:NDYMAX,0:NDKART),
     *                       TPHAMP(0:NDYMAX,0:NDYMAX,0:NDKART),
     *                       TPHAMM(0:NDYMAX,0:NDYMAX,0:NDKART)
      COMMON
     *       /SETBAS_INDICE/ INDICE(0:NDXMAX,0:NDYMAX,0:NDZMAX)
     *
     *       /SETBAS_BASIS1/ LAXOFY(0:NDYMAX),LAXOFZ(0:NDZMAX),
     *                       LAYOFZ(0:NDZMAX),LAYOFX(0:NDXMAX),
     *                       LAZOFX(0:NDXMAX),LAZOFY(0:NDYMAX)
     *
     *       /SETBAS_BASIS2/ LAXOYZ(0:NDYMAX,0:NDZMAX),
     *                       LAYOZX(0:NDZMAX,0:NDXMAX),
     *                       LAZOXY(0:NDXMAX,0:NDYMAX)
      COMMON
     *       /SPECTR_SPINOR/ EWAVEF(1:NDBASE,1:NDBASE)
C
C=======================================================================
C
C     This subroutine  performs  the  Gauss-Hermite  integrations
C     of the 'kinetic energy term'  with the effective mass. Here
C     we define the kinetic energy operator as:
C
C         T = (<<== Op. p) hbarc**2/(2m_star*c**2) (Op. p ==>>)
C
C     Observe a difference  in the definition of this operator as
C     compared to the previous subroutine.
C
C=======================================================================
C
      CALL WS_CPUTIM('INTPMP',1)
C
C=======================================================================
C
      KARTEZ=0
C
C=======================================================================
C     "Kinetic-energy" term  related to the Cartesian x-direction
C=======================================================================
C
      R_ZERO=0.0
C
      DO NX=0,NXMAXX
         DO MX=0,NXMAXX
C
            DO KY=0,2*NYMAXX
               DO KZ=0,2*NZMAXX
                  RESULT=0.0000
                  DO KX=NX+MX+2,0,-2
                     RESULT=RESULT+COEF11(KX,MX,NX,1)*WEFMAS(KX,KY,KZ)
                  END DO
                  X_HELP(KY,KZ)=RESULT
               END DO
            END DO
C
            DO NY=0,LAYOFX(NX)
               DO MY=0,LAYOFX(MX)
C
                  DO KZ=0,2*NZMAXX
                     RESULT=0.0000
                     DO KY=NY+MY,0,-2
                        RESULT=RESULT+COEF00(KY,MY,NY,2)
     *                               *X_HELP(KY,KZ)
                     END DO
                     Y_HELP(KZ)=RESULT
                  END DO
C
                  DO NZ=0,LAZOXY(NX,NY)
                     DO MZ=0,LAZOXY(MX,MY)
                        RESULT=0.0
                        DO KZ=NZ+MZ,0,-2
                           RESULT=RESULT+COEF00(KZ,MZ,NZ,3)
     *                                  *Y_HELP(KZ)
                        END DO
C
C=======================================================================
C                       Phases below were defined in PHASE
C=======================================================================
C
                        RESULT=RESULT*TPHAPP(NY,MY,KARTEZ)
C
                        IBRAHO=INDICE(NX,NY,NZ)
                        IKETHO=INDICE(MX,MY,MZ)
C
C=======================================================================
C                       In the case of the "p*m*p" term there is an
C                       extra minus sign coming from the "p" acting
C                       on the "bra"  [Complex conjug. of ih*Nabla];
C                       therefore we are adding here the minus sign
C=======================================================================
C
                        EWAVEF(IBRAHO,IKETHO)=EWAVEF(IBRAHO,IKETHO)
     *                                       -CMPLX (RESULT,R_ZERO)
C
                     END DO
                  END DO
C
               END DO
            END DO
C
         END DO
      END DO
C
C=======================================================================
C     "Kinetic-energy" term  related to the Cartesian y-direction
C=======================================================================
C
      R_ZERO=0.0
C
      DO NX=0,NXMAXX
         DO MX=0,NXMAXX
C
            DO KY=0,2*NYMAXX+2
               DO KZ=0,2*NZMAXX
                  RESULT=0.0000
                  DO KX=NX+MX,0,-2
                     RESULT=RESULT+COEF00(KX,MX,NX,1)*WEFMAS(KX,KY,KZ)
                  END DO
                  X_HELP(KY,KZ)=RESULT
               END DO
            END DO
C
            DO NY=0,LAYOFX(NX)
               DO MY=0,LAYOFX(MX)
C
                  DO KZ=0,2*NZMAXX
                     RESULT=0.0000
                     DO KY=NY+MY+2,0,-2
                        RESULT=RESULT+COEF11(KY,MY,NY,2)
     *                               *X_HELP(KY,KZ)
                     END DO
                     Y_HELP(KZ)=RESULT
                  END DO
C
                  DO NZ=0,LAZOXY(NX,NY)
                     DO MZ=0,LAZOXY(MX,MY)
                        RESULT=0.0
                        DO KZ=NZ+MZ,0,-2
                           RESULT=RESULT+COEF00(KZ,MZ,NZ,3)
     *                                  *Y_HELP(KZ)
                        END DO
C
C=======================================================================
C                       Phases below were defined in TPHASE
C=======================================================================
C
                        RESULT=RESULT*TPHAPP(NY,MY,KARTEZ)
C
                        IBRAHO=INDICE(NX,NY,NZ)
                        IKETHO=INDICE(MX,MY,MZ)
C
C=======================================================================
C                       In the case of the "p*m*p" term there is an
C                       extra minus sign coming from the "p" acting
C                       on the "bra"  [Complex conjug. of ih*Nabla];
C                       therefore we are adding here the minus sign
C=======================================================================
C
                        EWAVEF(IBRAHO,IKETHO)=EWAVEF(IBRAHO,IKETHO)
     *                                       -CMPLX (RESULT,R_ZERO)
C
                     END DO
                  END DO
C
               END DO
            END DO
C
         END DO
      END DO
C
C=======================================================================
C     "Kinetic-energy" term  related to the Cartesian z-direction
C=======================================================================
C
      R_ZERO=0.0
C
      DO NX=0,NXMAXX
         DO MX=0,NXMAXX
C
            DO KY=0,2*NYMAXX
               DO KZ=0,2*NZMAXX+2
                  RESULT=0.0000
                  DO KX=NX+MX,0,-2
                     RESULT=RESULT+COEF00(KX,MX,NX,1)*WEFMAS(KX,KY,KZ)
                  END DO
                  X_HELP(KY,KZ)=RESULT
               END DO
            END DO
C
            DO NY=0,LAYOFX(NX)
               DO MY=0,LAYOFX(MX)
C
                  DO KZ=0,2*NZMAXX+2
                     RESULT=0.0000
                     DO KY=NY+MY,0,-2
                        RESULT=RESULT+COEF00(KY,MY,NY,2)
     *                               *X_HELP(KY,KZ)
                     END DO
                     Y_HELP(KZ)=RESULT
                  END DO
C
                  DO NZ=0,LAZOXY(NX,NY)
                     DO MZ=0,LAZOXY(MX,MY)
                        RESULT=0.0
                        DO KZ=NZ+MZ+2,0,-2
                           RESULT=RESULT+COEF11(KZ,MZ,NZ,3)
     *                                  *Y_HELP(KZ)
                        END DO
C
C=======================================================================
C                       Phases below were defined in TPHASE
C=======================================================================
C
                        RESULT=RESULT*TPHAPP(NY,MY,KARTEZ)
C
                        IBRAHO=INDICE(NX,NY,NZ)
                        IKETHO=INDICE(MX,MY,MZ)
C
C=======================================================================
C                       In the case of the "p*m*p" term there is an
C                       extra minus sign coming from the "p" acting
C                       on the "bra"  [COmplex conjug. of ih*Nabla];
C                       therefore we are adding here the minus sign.
C=======================================================================
C
                        EWAVEF(IBRAHO,IKETHO)=EWAVEF(IBRAHO,IKETHO)
     *                                       -CMPLX (RESULT,R_ZERO)
C
                     END DO
                  END DO
C
               END DO
            END DO
C
         END DO
      END DO
C
C=======================================================================
C
      CALL WS_CPUTIM('INTPMP',0)
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C=======================================================================
C
      SUBROUTINE WS_INTLNM(NXMAXX,NYMAXX,NZMAXX)
C=======================================================================
      USE params
C=======================================================================
C
      COMPLEX
     *          EWAVEF
C
      DIMENSION
     *          X_HELP(0:ND2MAX,0:ND2MAX),Y_HELP(0:ND2MAX)
C
      COMMON
     *       /DEVHER_COEXYZ/ COEF00(0:ND2MAX,0:NDOSGS,0:NDOSGS,NDKART),
     *                       COEF01(0:ND2MAX,0:NDOSGS,0:NDOSGS,NDKART),
     *                       COEF11(0:ND2MAX,0:NDOSGS,0:NDOSGS,NDKART),
     *                       COEF02(0:ND2MAX,0:NDOSGS,0:NDOSGS,NDKART)
      COMMON
     *       /TPHASE_PHASES/ TPHAPP(0:NDYMAX,0:NDYMAX,0:NDKART),
     *                       TPHAPM(0:NDYMAX,0:NDYMAX,0:NDKART),
     *                       TPHAMP(0:NDYMAX,0:NDYMAX,0:NDKART),
     *                       TPHAMM(0:NDYMAX,0:NDYMAX,0:NDKART)
      COMMON
     *       /BEGINT_POTENS/ WCENTR(0:ND2MAX,0:ND2MAX,0:ND2MAX),
     *                       WEFMAS(0:ND2MAX,0:ND2MAX,0:ND2MAX),
     *                       WSORBT(0:ND2MAX,0:ND2MAX,0:ND2MAX),
     *                       WLIMOM(0:ND2MAX,0:ND2MAX,0:ND2MAX)
      COMMON
     *       /SETBAS_INDICE/ INDICE(0:NDXMAX,0:NDYMAX,0:NDZMAX)
     *
     *       /SETBAS_BASIS1/ LAXOFY(0:NDYMAX),LAXOFZ(0:NDZMAX),
     *                       LAYOFZ(0:NDZMAX),LAYOFX(0:NDXMAX),
     *                       LAZOFX(0:NDXMAX),LAZOFY(0:NDYMAX)
     *
     *       /SETBAS_BASIS2/ LAXOYZ(0:NDYMAX,0:NDZMAX),
     *                       LAYOZX(0:NDZMAX,0:NDXMAX),
     *                       LAZOXY(0:NDXMAX,0:NDYMAX)
      COMMON
     *       /SPECTR_SPINOR/ EWAVEF(1:NDBASE,1:NDBASE)
C
C=======================================================================
C
C     This subroutine  performs  the  Gauss-Hermite  integrations
C     of the 'linear momentum term' with the effective mass. Here
C     we define the 'linear momentum' operator as:
C
C        V_p = [grad(U) . p]   where   U ={m_0*C**2/m(*)[V-S]}
C
C=======================================================================
C
      CALL WS_CPUTIM('INTLNM',1)
C
C=======================================================================
C=======================================================================
C     Integrands proportional to the "gradient x gradient"  terms
C=======================================================================
C=======================================================================
C
      KARTEZ=0
C
C=======================================================================
C     Linear momentum term related to Cartesian the x-direction '11'
C=======================================================================
C
      R_ZERO=0.0
C
      DO NX=0,NXMAXX
         DO MX=0,NXMAXX
C
            DO KY=0,2*NYMAXX+2
               DO KZ=0,2*NZMAXX+2
                  RESULT=0.0000
                  DO KX=NX+MX+2,0,-2
                     RESULT=RESULT+COEF11(KX,MX,NX,1)*WLIMOM(KX,KY,KZ)
                  END DO
                  X_HELP(KY,KZ)=RESULT
               END DO
            END DO
C
            DO NY=0,LAYOFX(NX)
               DO MY=0,LAYOFX(MX)
C
                  DO KZ=0,2*NZMAXX+2
                     RESULT=0.0000
                     DO KY=NY+MY,0,-2
                        RESULT=RESULT+COEF00(KY,MY,NY,2)
     *                               *X_HELP(KY,KZ)
                     END DO
                     Y_HELP(KZ)=RESULT
                  END DO
C
                  DO NZ=0,LAZOXY(NX,NY)
                     DO MZ=0,LAZOXY(MX,MY)
                        RESULT=0.0
                        DO KZ=NZ+MZ,0,-2
                           RESULT=RESULT+COEF00(KZ,MZ,NZ,3)
     *                                  *Y_HELP(KZ)
                        END DO
C
C=======================================================================
C                       Phases below were defined IN PHASE
C=======================================================================
C
                        RESULT=RESULT*TPHAPP(NY,MY,KARTEZ)
C
                        IBRAHO=INDICE(NX,NY,NZ)
                        IKETHO=INDICE(MX,MY,MZ)
C
                        EWAVEF(IBRAHO,IKETHO)=EWAVEF(IBRAHO,IKETHO)
     *                                       +CMPLX (RESULT,R_ZERO)
C
                     END DO
                  END DO
C
               END DO
            END DO
C
         END DO
      END DO
C
C=======================================================================
C     Linear momentum term related to the Cartesian y-direction '11'
C=======================================================================
C
      R_ZERO=0.0
C
      DO NX=0,NXMAXX
         DO MX=0,NXMAXX
C
            DO KY=0,2*NYMAXX+2
               DO KZ=0,2*NZMAXX+2
                  RESULT=0.0000
                  DO KX=NX+MX,0,-2
                     RESULT=RESULT+COEF00(KX,MX,NX,1)*WLIMOM(KX,KY,KZ)
                  END DO
                  X_HELP(KY,KZ)=RESULT
               END DO
            END DO
C
            DO NY=0,LAYOFX(NX)
               DO MY=0,LAYOFX(MX)
C
                  DO KZ=0,2*NZMAXX+2
                     RESULT=0.0000
                     DO KY=NY+MY+2,0,-2
                        RESULT=RESULT+COEF11(KY,MY,NY,2)
     *                               *X_HELP(KY,KZ)
                     END DO
                     Y_HELP(KZ)=RESULT
                  END DO
C
                  DO NZ=0,LAZOXY(NX,NY)
                     DO MZ=0,LAZOXY(MX,MY)
                        RESULT=0.0
                        DO KZ=NZ+MZ,0,-2
                           RESULT=RESULT+COEF00(KZ,MZ,NZ,3)
     *                                  *Y_HELP(KZ)
                        END DO
C
C=======================================================================
C                       Phases below were defined in TPHASE
C=======================================================================
C
                        RESULT=RESULT*TPHAPP(NY,MY,KARTEZ)
C
                        IBRAHO=INDICE(NX,NY,NZ)
                        IKETHO=INDICE(MX,MY,MZ)
C
                        EWAVEF(IBRAHO,IKETHO)=EWAVEF(IBRAHO,IKETHO)
     *                                       +CMPLX (RESULT,R_ZERO)
C
                     END DO
                  END DO
C
               END DO
            END DO
C
         END DO
      END DO
C
C=======================================================================
C     Linear momentum term related to the Cartesian z-direction '11'
C=======================================================================
C
      R_ZERO=0.0
C
      DO NX=0,NXMAXX
         DO MX=0,NXMAXX
C
            DO KY=0,2*NYMAXX+2
               DO KZ=0,2*NZMAXX+2
                  RESULT=0.0000
                  DO KX=NX+MX,0,-2
                     RESULT=RESULT+COEF00(KX,MX,NX,1)*WLIMOM(KX,KY,KZ)
                  END DO
                  X_HELP(KY,KZ)=RESULT
               END DO
            END DO
C
            DO NY=0,LAYOFX(NX)
               DO MY=0,LAYOFX(MX)
C
                  DO KZ=0,2*NZMAXX+2
                     RESULT=0.0000
                     DO KY=NY+MY,0,-2
                        RESULT=RESULT+COEF00(KY,MY,NY,2)
     *                               *X_HELP(KY,KZ)
                     END DO
                     Y_HELP(KZ)=RESULT
                  END DO
C
                  DO NZ=0,LAZOXY(NX,NY)
                     DO MZ=0,LAZOXY(MX,MY)
                        RESULT=0.0
                        DO KZ=NZ+MZ+2,0,-2
                           RESULT=RESULT+COEF11(KZ,MZ,NZ,3)
     *                                  *Y_HELP(KZ)
                        END DO
C
C=======================================================================
C                       Phases below were defined in TPHASE
C=======================================================================
C
                        RESULT=RESULT*TPHAPP(NY,MY,KARTEZ)
C
                        IBRAHO=INDICE(NX,NY,NZ)
                        IKETHO=INDICE(MX,MY,MZ)
C
                        EWAVEF(IBRAHO,IKETHO)=EWAVEF(IBRAHO,IKETHO)
     *                                       +CMPLX (RESULT,R_ZERO)
C
                     END DO
                  END DO
C
               END DO
            END DO
C
         END DO
      END DO
C
C=======================================================================
C=======================================================================
C     Integrands proportional to the second derivatives times functs
C=======================================================================
C=======================================================================
C
      KARTEZ=0
C
C=======================================================================
C     Linear momentum term related to the Cartesian x-direction '02'
C=======================================================================
C
      R_ZERO=0.0
C
      DO NX=0,NXMAXX
         DO MX=0,NXMAXX
C
            DO KY=0,2*NYMAXX+2
               DO KZ=0,2*NZMAXX+2
                  RESULT=0.0000
                  DO KX=NX+MX+2,0,-2
                     RESULT=RESULT+COEF02(KX,MX,NX,1)*WLIMOM(KX,KY,KZ)
                  END DO
                  X_HELP(KY,KZ)=RESULT
               END DO
            END DO
C
            DO NY=0,LAYOFX(NX)
               DO MY=0,LAYOFX(MX)
C
                  DO KZ=0,2*NZMAXX+2
                     RESULT=0.0000
                     DO KY=NY+MY,0,-2
                        RESULT=RESULT+COEF00(KY,MY,NY,2)
     *                               *X_HELP(KY,KZ)
                     END DO
                     Y_HELP(KZ)=RESULT
                  END DO
C
                  DO NZ=0,LAZOXY(NX,NY)
                     DO MZ=0,LAZOXY(MX,MY)
                        RESULT=0.0
                        DO KZ=NZ+MZ,0,-2
                           RESULT=RESULT+COEF00(KZ,MZ,NZ,3)
     *                                  *Y_HELP(KZ)
                        END DO
C
C=======================================================================
C                       Phases below were defined in TPHASE
C=======================================================================
C
                        RESULT=RESULT*TPHAPP(NY,MY,KARTEZ)
C
                        IBRAHO=INDICE(NX,NY,NZ)
                        IKETHO=INDICE(MX,MY,MZ)
C
                        EWAVEF(IBRAHO,IKETHO)=EWAVEF(IBRAHO,IKETHO)
     *                                       +CMPLX (RESULT,R_ZERO)
C
                     END DO
                  END DO
C
               END DO
            END DO
C
         END DO
      END DO
C
C=======================================================================
C     Linear momentum term related to the Cartesian y-direction '02'
C=======================================================================
C
      R_ZERO=0.0
C
      DO NX=0,NXMAXX
         DO MX=0,NXMAXX
C
            DO KY=0,2*NYMAXX+2
               DO KZ=0,2*NZMAXX+2
                  RESULT=0.0000
                  DO KX=NX+MX,0,-2
                     RESULT=RESULT+COEF00(KX,MX,NX,1)*WLIMOM(KX,KY,KZ)
                  END DO
                  X_HELP(KY,KZ)=RESULT
               END DO
            END DO
C
            DO NY=0,LAYOFX(NX)
               DO MY=0,LAYOFX(MX)
C
                  DO KZ=0,2*NZMAXX+2
                     RESULT=0.0000
                     DO KY=NY+MY+2,0,-2
                        RESULT=RESULT+COEF02(KY,MY,NY,2)
     *                               *X_HELP(KY,KZ)
                     END DO
                     Y_HELP(KZ)=RESULT
                  END DO
C
                  DO NZ=0,LAZOXY(NX,NY)
                     DO MZ=0,LAZOXY(MX,MY)
                        RESULT=0.0
                        DO KZ=NZ+MZ,0,-2
                           RESULT=RESULT+COEF00(KZ,MZ,NZ,3)
     *                                  *Y_HELP(KZ)
                        END DO
C
C=======================================================================
C                       Phases below were defined in TPHASE
C=======================================================================
C
                        RESULT=RESULT*TPHAPP(NY,MY,KARTEZ)
C
                        IBRAHO=INDICE(NX,NY,NZ)
                        IKETHO=INDICE(MX,MY,MZ)
C
                        EWAVEF(IBRAHO,IKETHO)=EWAVEF(IBRAHO,IKETHO)
     *                                       +CMPLX (RESULT,R_ZERO)
C
                     END DO
                  END DO
C
               END DO
            END DO
C
         END DO
      END DO
C
C=======================================================================
C     Linear momentum term related to the Cartesian z-direction '02'
C=======================================================================
C
      R_ZERO=0.0
C
      DO NX=0,NXMAXX
         DO MX=0,NXMAXX
C
            DO KY=0,2*NYMAXX+2
               DO KZ=0,2*NZMAXX+2
                  RESULT=0.0000
                  DO KX=NX+MX,0,-2
                     RESULT=RESULT+COEF00(KX,MX,NX,1)*WLIMOM(KX,KY,KZ)
                  END DO
                  X_HELP(KY,KZ)=RESULT
               END DO
            END DO
C
            DO NY=0,LAYOFX(NX)
               DO MY=0,LAYOFX(MX)
C
                  DO KZ=0,2*NZMAXX+2
                     RESULT=0.0000
                     DO KY=NY+MY,0,-2
                        RESULT=RESULT+COEF00(KY,MY,NY,2)
     *                               *X_HELP(KY,KZ)
                     END DO
                     Y_HELP(KZ)=RESULT
                  END DO
C
                  DO NZ=0,LAZOXY(NX,NY)
                     DO MZ=0,LAZOXY(MX,MY)
                        RESULT=0.0
                        DO KZ=NZ+MZ+2,0,-2
                           RESULT=RESULT+COEF02(KZ,MZ,NZ,3)
     *                                  *Y_HELP(KZ)
                        END DO
C
C=======================================================================
C                       Phases below were defined in TPHASE
C=======================================================================
C
                        RESULT=RESULT*TPHAPP(NY,MY,KARTEZ)
C
                        IBRAHO=INDICE(NX,NY,NZ)
                        IKETHO=INDICE(MX,MY,MZ)
C
                        EWAVEF(IBRAHO,IKETHO)=EWAVEF(IBRAHO,IKETHO)
     *                                       +CMPLX (RESULT,R_ZERO)
C
                     END DO
                  END DO
C
               END DO
            END DO
C
         END DO
      END DO
C
C=======================================================================
C
      CALL WS_CPUTIM('INTLNM',0)
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C=======================================================================
C
      SUBROUTINE WS_INTSOX(NXMAXX,NYMAXX,NZMAXX)
C=======================================================================
      USE params
C=======================================================================
C
      COMPLEX
     *          EWAVEF
C
      DIMENSION
     *          Y_LEFT(0:ND2MAX),Y_RIGH(0:ND2MAX)
      DIMENSION
     *          X_HELP(0:ND2MAX,0:ND2MAX)
C
      COMMON
     *       /DEVHER_COEXYZ/ COEF00(0:ND2MAX,0:NDOSGS,0:NDOSGS,NDKART),
     *                       COEF01(0:ND2MAX,0:NDOSGS,0:NDOSGS,NDKART),
     *                       COEF11(0:ND2MAX,0:NDOSGS,0:NDOSGS,NDKART),
     *                       COEF02(0:ND2MAX,0:NDOSGS,0:NDOSGS,NDKART)
      COMMON
     *       /BEGINT_POTENS/ WCENTR(0:ND2MAX,0:ND2MAX,0:ND2MAX),
     *                       WEFMAS(0:ND2MAX,0:ND2MAX,0:ND2MAX),
     *                       WSORBT(0:ND2MAX,0:ND2MAX,0:ND2MAX),
     *                       WLIMOM(0:ND2MAX,0:ND2MAX,0:ND2MAX)
      COMMON
     *       /TPHASE_PHASES/ TPHAPP(0:NDYMAX,0:NDYMAX,0:NDKART),
     *                       TPHAPM(0:NDYMAX,0:NDYMAX,0:NDKART),
     *                       TPHAMP(0:NDYMAX,0:NDYMAX,0:NDKART),
     *                       TPHAMM(0:NDYMAX,0:NDYMAX,0:NDKART)
      COMMON
     *       /SETBAS_INDICE/ INDICE(0:NDXMAX,0:NDYMAX,0:NDZMAX)
     *
     *       /SETBAS_BASIS1/ LAXOFY(0:NDYMAX),LAXOFZ(0:NDZMAX),
     *                       LAYOFZ(0:NDZMAX),LAYOFX(0:NDXMAX),
     *                       LAZOFX(0:NDXMAX),LAZOFY(0:NDYMAX)
     *
     *       /SETBAS_BASIS2/ LAXOYZ(0:NDYMAX,0:NDZMAX),
     *                       LAYOZX(0:NDZMAX,0:NDXMAX),
     *                       LAZOXY(0:NDXMAX,0:NDYMAX)
      COMMON
     *       /SPECTR_SPINOR/ EWAVEF(1:NDBASE,1:NDBASE)
C
C=======================================================================
C     This  subroutine  performs  the  Gauss-Hermite  integrations
C     of the spin-orbit interaction hamiltonian (x-type component)
C                                               ------------------
C=======================================================================
C
      CALL WS_CPUTIM('INTSOX',1)
C
C=======================================================================
C     The following factors correspond to the normalization of the
C     wave functions such that they are dimensionless   (not used)
C=======================================================================
C                    SQXFAT = 1.0/(SQXFAC*RCVOLM)
C                    SQYFAT = 1.0/(SQYFAC*RCVOLM)
C                    SQZFAT = 1.0/(SQZFAC*RCVOLM)
C=======================================================================
C
      KARTEZ=1
C
      R_ZERO=0.0
C
      DO NX=0,NXMAXX
         DO MX=0,NXMAXX
C
            DO KY=0,2*NYMAXX+1
               DO KZ=0,2*NZMAXX+1
                  RESULT=0.0000
                  DO KX=NX+MX,0,-2
                     RESULT=RESULT+COEF00(KX,MX,NX,1)*WSORBT(KX,KY,KZ)
                  END DO
                  X_HELP(KY,KZ)=RESULT
               END DO
            END DO
C
            DO NY=0,LAYOFX(NX)
               DO MY=0,LAYOFX(MX)
C
                  DO KZ=0,2*NZMAXX+1
C
                     RESULL=0.0
                     RESULR=0.0
C
                     DO KY=NY+MY+1,0,-2
C
                        RESULL=RESULL+COEF01(KY,MY,NY,2)
     *                               *X_HELP(KY,KZ)
                        RESULR=RESULR+COEF01(KY,NY,MY,2)
     *                               *X_HELP(KY,KZ)
                     END DO
C
                     Y_LEFT(KZ)=RESULL
                     Y_RIGH(KZ)=RESULR
C
                  END DO
C
                  DO NZ=0,LAZOXY(NX,NY)
                     DO MZ=0,LAZOXY(MX,MY)
                        RESULT=0.0
                        DO KZ=NZ+MZ+1,0,-2
                           RESULT=RESULT+COEF01(KZ,NZ,MZ,3)*Y_LEFT(KZ)
                           RESULT=RESULT-COEF01(KZ,MZ,NZ,3)*Y_RIGH(KZ)
                        END DO
C
C=======================================================================
C
C                       Phases below were defined in  TPHASE  while
C                       additional "i" factor  comes from  the spin-
C                       orbit potential ==>>>   +CMPLX(ZERO,RESULT)
C
C=======================================================================
C
C=======================================================================
C                       The factors below should be activated if the
C                       dimensionless wave functions are used
C=======================================================================
C
C                       RESULT = RESULT*SQYFAT*SQZFAT
C    *                         * TPHAPP(NY,MY,KARTEZ)
C
C=======================================================================
C
                        RESULT = RESULT
     *                         * TPHAPP(NY,MY,KARTEZ)
C
                        IBRAHO=INDICE(NX,NY,NZ)
                        IKETHO=INDICE(MX,MY,MZ)
C
                        EWAVEF(IBRAHO,IKETHO)=EWAVEF(IBRAHO,IKETHO)
     *                                       +CMPLX (R_ZERO,RESULT)
C
                     END DO
                  END DO
C
               END DO
            END DO
C
         END DO
      END DO
C
C=======================================================================
C
      CALL WS_CPUTIM('INTSOX',0)
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C=======================================================================
C
      SUBROUTINE WS_INTSOY(NXMAXX,NYMAXX,NZMAXX)
C=======================================================================
      USE params
C=======================================================================
C
      COMPLEX
     *          EWAVEF
C
      DIMENSION
     *          Z_LEFT(0:ND2MAX),Z_RIGH(0:ND2MAX)
      DIMENSION
     *          Y_HELP(0:ND2MAX,0:ND2MAX)
C
      COMMON
     *       /DEVHER_COEXYZ/ COEF00(0:ND2MAX,0:NDOSGS,0:NDOSGS,NDKART),
     *                       COEF01(0:ND2MAX,0:NDOSGS,0:NDOSGS,NDKART),
     *                       COEF11(0:ND2MAX,0:NDOSGS,0:NDOSGS,NDKART),
     *                       COEF02(0:ND2MAX,0:NDOSGS,0:NDOSGS,NDKART)
      COMMON
     *       /BEGINT_POTENS/ WCENTR(0:ND2MAX,0:ND2MAX,0:ND2MAX),
     *                       WEFMAS(0:ND2MAX,0:ND2MAX,0:ND2MAX),
     *                       WSORBT(0:ND2MAX,0:ND2MAX,0:ND2MAX),
     *                       WLIMOM(0:ND2MAX,0:ND2MAX,0:ND2MAX)
      COMMON
     *       /TPHASE_PHASES/ TPHAPP(0:NDYMAX,0:NDYMAX,0:NDKART),
     *                       TPHAPM(0:NDYMAX,0:NDYMAX,0:NDKART),
     *                       TPHAMP(0:NDYMAX,0:NDYMAX,0:NDKART),
     *                       TPHAMM(0:NDYMAX,0:NDYMAX,0:NDKART)
      COMMON
     *       /SETBAS_INDICE/ INDICE(0:NDXMAX,0:NDYMAX,0:NDZMAX)
     *
     *       /SETBAS_BASIS1/ LAXOFY(0:NDYMAX),LAXOFZ(0:NDZMAX),
     *                       LAYOFZ(0:NDZMAX),LAYOFX(0:NDXMAX),
     *                       LAZOFX(0:NDXMAX),LAZOFY(0:NDYMAX)
     *
     *       /SETBAS_BASIS2/ LAXOYZ(0:NDYMAX,0:NDZMAX),
     *                       LAYOZX(0:NDZMAX,0:NDXMAX),
     *                       LAZOXY(0:NDXMAX,0:NDYMAX)
      COMMON
     *       /SPECTR_SPINOR/ EWAVEF(1:NDBASE,1:NDBASE)
C
C=======================================================================
C     This  subroutine  performs  the  Gauss-Hermite  integrations
C     of the spin-orbit interaction hamiltonian (y-type component)
C                                               ------------------
C=======================================================================
C
      CALL WS_CPUTIM('INTSOY',1)
C
C=======================================================================
C     The following factors correspond to the normalization of the
C     wave functions such that they are dimensionless   (not used)
C=======================================================================
C                    SQXFAT = 1.0/(SQXFAC*RCVOLM)
C                    SQYFAT = 1.0/(SQYFAC*RCVOLM)
C                    SQZFAT = 1.0/(SQZFAC*RCVOLM)
C=======================================================================
C
      KARTEZ=2
C
      R_ZERO=0.0
C
      DO NY=0,NYMAXX
         DO MY=0,NYMAXX
C
            DO KZ=0,2*NZMAXX+1
               DO KX=0,2*NXMAXX+1
                  RESULT=0.0000
                  DO KY=NY+MY,0,-2
                     RESULT=RESULT+COEF00(KY,MY,NY,2)*WSORBT(KX,KY,KZ)
                  END DO
                  Y_HELP(KZ,KX)=RESULT
               END DO
            END DO
C
            DO NZ=0,LAZOFY(NY)
               DO MZ=0,LAZOFY(MY)
C
                  DO KX=0,2*NXMAXX+1
C
                     RESULL=0.0
                     RESULR=0.0
C
                     DO KZ=NZ+MZ+1,0,-2
C
                        RESULL=RESULL+COEF01(KZ,MZ,NZ,3)
     *                               *Y_HELP(KZ,KX)
                        RESULR=RESULR+COEF01(KZ,NZ,MZ,3)
     *                               *Y_HELP(KZ,KX)
                     END DO
C
                     Z_LEFT(KX)=RESULL
                     Z_RIGH(KX)=RESULR
C
                  END DO
C
                  DO NX=0,LAXOYZ(NY,NZ)
                     DO MX=0,LAXOYZ(MY,MZ)
                        RESULT=0.0
                        DO KX=NX+MX+1,0,-2
                           RESULT=RESULT+COEF01(KX,NX,MX, 1)*Z_LEFT(KX)
                           RESULT=RESULT-COEF01(KX,MX,NX, 1)*Z_RIGH(KX)
                        END DO
C
C=======================================================================
C                       Phases below were defined in  TPHASE  while
C                       additional "i" factor  comes from  the spin-
C                       orbit potential =>>>    +CMPLX(ZERO,RESULT)
C=======================================================================
C
C=======================================================================
C                       THe factors below should be activated if the
C                       dimensionless wave functions are used
C=======================================================================
C
C                       RESULT = RESULT*SQZFAT*SQXFAT
C    *                         * TPHAPP(NY,MY,KARTEZ)
C
C=======================================================================
C
                        RESULT = RESULT
     *                         * TPHAPP(NY,MY,KARTEZ)
C
                        IBRAHO=INDICE(NX,NY,NZ)
                        IKETHO=INDICE(MX,MY,MZ)
C
                        EWAVEF(IBRAHO,IKETHO)=EWAVEF(IBRAHO,IKETHO)
     *                                       +CMPLX (R_ZERO,RESULT)
C
                     END DO
                  END DO
C
               END DO
            END DO
C
         END DO
      END DO
C
C=======================================================================
C
      CALL WS_CPUTIM('INTSOY',0)
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C=======================================================================
C
      SUBROUTINE WS_INTSOZ(NXMAXX,NYMAXX,NZMAXX)
C=======================================================================
      USE params
C=======================================================================
C
      COMPLEX
     *          EWAVEF
C
      DIMENSION
     *          X_LEFT(0:ND2MAX),X_RIGH(0:ND2MAX)
      DIMENSION
     *          Z_HELP(0:ND2MAX,0:ND2MAX)
C
      COMMON
     *       /DEVHER_COEXYZ/ COEF00(0:ND2MAX,0:NDOSGS,0:NDOSGS,NDKART),
     *                       COEF01(0:ND2MAX,0:NDOSGS,0:NDOSGS,NDKART),
     *                       COEF11(0:ND2MAX,0:NDOSGS,0:NDOSGS,NDKART),
     *                       COEF02(0:ND2MAX,0:NDOSGS,0:NDOSGS,NDKART)
      COMMON
     *       /BEGINT_POTENS/ WCENTR(0:ND2MAX,0:ND2MAX,0:ND2MAX),
     *                       WEFMAS(0:ND2MAX,0:ND2MAX,0:ND2MAX),
     *                       WSORBT(0:ND2MAX,0:ND2MAX,0:ND2MAX),
     *                       WLIMOM(0:ND2MAX,0:ND2MAX,0:ND2MAX)
      COMMON
     *       /TPHASE_PHASES/ TPHAPP(0:NDYMAX,0:NDYMAX,0:NDKART),
     *                       TPHAPM(0:NDYMAX,0:NDYMAX,0:NDKART),
     *                       TPHAMP(0:NDYMAX,0:NDYMAX,0:NDKART),
     *                       TPHAMM(0:NDYMAX,0:NDYMAX,0:NDKART)
      COMMON
     *       /SETBAS_INDICE/ INDICE(0:NDXMAX,0:NDYMAX,0:NDZMAX)
     *
     *       /SETBAS_BASIS1/ LAXOFY(0:NDYMAX),LAXOFZ(0:NDZMAX),
     *                       LAYOFZ(0:NDZMAX),LAYOFX(0:NDXMAX),
     *                       LAZOFX(0:NDXMAX),LAZOFY(0:NDYMAX)
     *
     *       /SETBAS_BASIS2/ LAXOYZ(0:NDYMAX,0:NDZMAX),
     *                       LAYOZX(0:NDZMAX,0:NDXMAX),
     *                       LAZOXY(0:NDXMAX,0:NDYMAX)
      COMMON
     *       /SPECTR_SPINOR/ EWAVEF(1:NDBASE,1:NDBASE)
C
C=======================================================================
C     This  subroutine  performs  the  Gauss-Hermite  integrations
C     of the spin-orbit interaction hamiltonian (z-type component)
C                                               ------------------
C=======================================================================
C
      CALL WS_CPUTIM('INTSOZ',1)
C
C=======================================================================
C     The following factors correspond to the normalization of the
C     wave functions such that they are dimensionless   (not used)
C=======================================================================
C                    SQXFAT = 1.0/(SQXFAC*RCVOLM)
C                    SQYFAT = 1.0/(SQYFAC*RCVOLM)
C                    SQZFAT = 1.0/(SQZFAC*RCVOLM)
C=======================================================================
C
      KARTEZ=3
C
      R_ZERO=0.0
C
      DO NZ=0,NZMAXX
         DO MZ=0,NZMAXX
C
            DO KX=0,2*NXMAXX+1
               DO KY=0,2*NYMAXX+1
                  RESULT=0.0000
                  DO KZ=NZ+MZ,0,-2
                     RESULT=RESULT+COEF00(KZ,MZ,NZ,3)*WSORBT(KX,KY,KZ)
                  END DO
                  Z_HELP(KX,KY)=RESULT
               END DO
            END DO
C
            DO NX=0,LAXOFZ(NZ)
               DO MX=0,LAXOFZ(MZ)
C
                  DO KY=0,2*NYMAXX+1
C
                     RESULL=0.0
                     RESULR=0.0
C
                     DO KX=NX+MX+1,0,-2
C
                        RESULL=RESULL+COEF01(KX,MX,NX,1)
     *                               *Z_HELP(KX,KY)
                        RESULR=RESULR+COEF01(KX,NX,MX,1)
     *                               *Z_HELP(KX,KY)
                     END DO
C
                     X_LEFT(KY)=RESULL
                     X_RIGH(KY)=RESULR
C
                  END DO
C
                  DO NY=0,LAYOZX(NZ,NX)
                     DO MY=0,LAYOZX(MZ,MX)
                        RESULT=0.0
                        DO KY=NY+MY+1,0,-2
                           RESULT=RESULT+COEF01(KY,NY,MY,2)*X_LEFT(KY)
                           RESULT=RESULT-COEF01(KY,MY,NY,2)*X_RIGH(KY)
                        END DO
C
C=======================================================================
C                       Phases below were defined in  TPHASE  while
C                       additional "i" factor  comes from  the spin-
C                       orbit potential.  Here i.e. for z-component,
C                       TPHASE   routine supplies the phase divided
C                       by the i factor. Both these factors combine
C                       to the minus sign below
C=======================================================================
C
C=======================================================================
C                       Factors below should be activated  when the
C                       dimensionless wave functions are used
C=======================================================================
C
C                       RESULT =-RESULT*SQXFAT*SQYFAT
C    *                         * TPHAPP(NY,MY,KARTEZ)
C
C=======================================================================
C
                        RESULT =-RESULT
     *                         * TPHAPP(NY,MY,KARTEZ)
C
                        IBRAHO=INDICE(NX,NY,NZ)
                        IKETHO=INDICE(MX,MY,MZ)
C
                        EWAVEF(IBRAHO,IKETHO)=EWAVEF(IBRAHO,IKETHO)
     *                                       +CMPLX (RESULT,R_ZERO)
C
                     END DO
                  END DO
C
               END DO
            END DO
C
         END DO
      END DO
C
C=======================================================================
C
      CALL WS_CPUTIM('INTSOZ',0)
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C=======================================================================
C
      SUBROUTINE WS_DEVHER(NOSACT,EPSHER,KARTEZ,NGAUSS)
C=======================================================================
      USE params
C=======================================================================
C
      DIMENSION
     *          PHERMI(0:ND2MAX),DHERMI(0:ND2MAX)
      DIMENSION
     *          XHERMI(1:NDGAUS),WHERMI(1:NDGAUS)
      DIMENSION
     *          HERPLN(0:ND2MAX,1:NDGAUS),
     *          DH1PLN(0:ND2MAX,1:NDGAUS),
     *          DH2PLN(0:ND2MAX,1:NDGAUS)
      DIMENSION
     *          HERSQ2(0:ND2MAX,1:NDGAUS)
      DIMENSION
     *          SQFACT(0:ND2MAX)
C
      COMMON
     *       /DEVHER_COEXYZ/ COEF00(0:ND2MAX,0:NDOSGS,0:NDOSGS,NDKART),
     *                       COEF01(0:ND2MAX,0:NDOSGS,0:NDOSGS,NDKART),
     *                       COEF11(0:ND2MAX,0:NDOSGS,0:NDOSGS,NDKART),
     *                       COEF02(0:ND2MAX,0:NDOSGS,0:NDOSGS,NDKART)
     *
     *       /DEVHER_COUL00/ COUL00(0:ND2MAX,0:NDOSGS,0:NDOSGS,NDKART)
      COMMON
     *       /SETBAS_SCALNG/ HOMSCA(1:NDKART)
C
      COMMON
     *       /READWRITE_PAR/ NOUTPT,IWRITE,ISCREN
C
C=======================================================================
C
C     This routine performs integration of the Hermite polynomials
C     to find the expansion coefficients in the formulae:
C
C           H (m,x) * H  (n,x) = Sum_k Coef00(k,m,n) * H(k,x)
C           H (m,x) * H' (n,x) = Sum_k Coef01(k,m,n) * H(k,x)
C           H'(m,x) * H' (n,x) = Sum_k Coef11(k,m,n) * H(k,x)
C           H (m,x) * H''(n,x) = Sum_k Coef02(k,m,n) * H(k,x)
C
C     and for sq2=sqrt(2):
C
C        H(m,x) * H(n,x) = Sum_k Coul00(k,m,n) * H(k,sq2*x) * sq2
C
C     where:
C
C     H (m,x) is the Hermite polynomial of the order m  at point x
C             assumed to be normalized to   o n e  when its square
C             is integrated with exp(-x**2);
C
C     H'(n,x) is the derivative of  H(n,x)*exp(-x**2/2) multiplied
C             by exp(x**2/2)
C
C     H"(n,x) is the second derivative of H(n,x)*exp(-x**2/2) also
C             multiplied by exp(x**2/2)
C
C     NOSACT - the maximum order  of the Hermite polynomials  used
C              in the code. Therefore:
C
C     H (m,x)  has the maximum order  m = NOSACT(=N{}MAXX)
C     H'(m,x)  has the maximum order  m = NOSACT(=N{}MAXX) + 1
C     H"(m,x)  has the maximum order  m = NOSACT(=N{}MAXX) + 2
C
C     The maximum order of products on the  left-hand-sides of the
C     above formulae is therefore: 4 * NOSACT(=N{}MAXX) + 4
C
C=======================================================================
C
      NMAIN2=2*NOSACT+2
C
      IF (NMAIN2.GT.ND2MAX) THEN
C
          WRITE(NOUTPT,'(//,1X,''NMAIN2='',I2,'' .GT. ND2MAX='',I2,
     *                    ''   STOP in DEVHER'',//)') NMAIN2,ND2MAX
C
          STOP 'NMAIN2.GT.ND2MAX  in  DEVHER'
C
      END IF
C
C=======================================================================
C     Zeroing the COEF__ and COUL00 matrices
C=======================================================================
C
      DO N=0,NOSACT
         DO M=0,NOSACT
            DO K=0,NMAIN2
C
               COEF00(K,M,N,KARTEZ)=0.0
               COEF01(K,M,N,KARTEZ)=0.0
               COEF11(K,M,N,KARTEZ)=0.0
               COEF02(K,M,N,KARTEZ)=0.0
               COUL00(K,M,N,KARTEZ)=0.0
C
            END DO
         END DO
      END DO
C
C=======================================================================
C
C     Coefficients COEF{} and COUL00 are found by explicit numerical
C                         G A U S S - H E R M I T E
C     integration of products appearing on the above left-hand-sides
C     with Hermite  polynomials.  The maximum order of integrands is
C     then equal to   4*NOSACT+4,   and therefore one has to use the
C     number of Gauss-Hermite integration points equal to:
C
C                            NGAUSS=2*NOSACT+3
C
C=======================================================================
C
C     NGAUSS=2*NOSACT+3  <<==  This has been defined outside of this
C                                                         subroutine
C
      IF (KARTEZ.EQ.1.AND.NGAUSS.GT.NDXHRM) THEN
C
          WRITE(NOUTPT,'(//,1X,''NGAUSS='',I2,'' > NDXHRM='',I2,2X,
     *                    ''STOP in DEVHER'',//)') NGAUSS,NDXHRM
C
          STOP 'NGAUSS.GT.NDXHRM  in  DEVHER - '
C
      END IF
C
      IF (KARTEZ.EQ.2.AND.NGAUSS.GT.NDYHRM) THEN
C
          WRITE(NOUTPT,'(//,1X,''NGAUSS='',I2,'' > NDYHRM='',I2,2X,
     *                    ''STOP in DEVHER'',//)') NGAUSS,NDYHRM
C
          STOP 'NGAUSS.GT.NDYHRM  in  DEVHER - '
C
      END IF
C
      IF (KARTEZ.EQ.3.AND.NGAUSS.GT.NDZHRM) THEN
C
          WRITE(NOUTPT,'(//,1X,''NGAUSS='',I2,'' > NDZHRM='',I2,2X,
     *                    ''STOP in DEVHER'',//)') NGAUSS,NDZHRM
C
          STOP 'NGAUSS.GT.NDZHRM  in  DEVHER'
C
      END IF

C=======================================================================
C     Defining zeros and weights for Gauss-Hermite integrations
C=======================================================================
C
      CALL WS_GAUHER(XHERMI,WHERMI,NGAUSS,NDGAUS,EPSHER)
C
C=======================================================================
C     Defining Hermite polynomial normalization constants; these
C     constants (SQFACT) contain sqrt(pi) but no parameter rela-
C     ted to the harmonic oscillator geometry
C=======================================================================
C
      CALL WS_NORFAC(SQFACT,ND2MAX)
C
C=======================================================================
C
      SQ2=SQRT(2.0)
C
      DO IZEROS=1,NGAUSS
C
         X_ZERO=XHERMI(IZEROS)
C
         CALL WS_DFHERM(X_ZERO,NMAIN2,PHERMI,DHERMI,ND2MAX)
C
         DO N_OSCI=0,NMAIN2
C
            HERPLN(N_OSCI,IZEROS)= PHERMI(N_OSCI)/SQFACT(N_OSCI)
C
            DH1PLN(N_OSCI,IZEROS)=(DHERMI(N_OSCI)
     *                           - X_ZERO*PHERMI(N_OSCI))
     *                                   /SQFACT(N_OSCI)
C
            DH2PLN(N_OSCI,IZEROS)=(X_ZERO*X_ZERO-2*N_OSCI-1)
     *                           * PHERMI(N_OSCI)
     *                           / SQFACT(N_OSCI)
C
         END DO
C
         X_ZERO=XHERMI(IZEROS)/SQ2
C
         CALL WS_DFHERM(X_ZERO,NMAIN2,PHERMI,DHERMI,ND2MAX)
C
         DO N_OSCI=0,NMAIN2
C
            HERSQ2(N_OSCI,IZEROS)=PHERMI(N_OSCI)/SQFACT(N_OSCI)
C
         END DO
C
      END DO
C
C=======================================================================
C     Calculating the expansion coefficients for the polynomials
C=======================================================================
C
      DO N=0,NOSACT
         DO M=0,NOSACT
            DO K=M+N,0,-2
C
               RESULT=0.0
               RESCOU=0.0
C
               DO IGAUSS=1,NGAUSS
C
                  RESULT=RESULT+WHERMI(IGAUSS)*HERPLN(N,IGAUSS)
     *                                        *HERPLN(M,IGAUSS)
     *                                        *HERPLN(K,IGAUSS)
C
                  RESCOU=RESCOU+WHERMI(IGAUSS)*HERSQ2(N,IGAUSS)
     *                                        *HERSQ2(M,IGAUSS)
     *                                        *HERPLN(K,IGAUSS)
               END DO
C
               COEF00(K,M,N,KARTEZ)=RESULT
               COUL00(K,M,N,KARTEZ)=RESCOU/SQ2
C
            END DO
         END DO
      END DO
C
C=======================================================================
C     Calculating the expansion coefficients for the products
C     derivative (EXP * HERMIT) * HERMIT * HERMIT
C=======================================================================
C
      DO N=0,NOSACT
         DO M=0,NOSACT
            DO K=M+N+1,0,-2
C
               RESULT=0.0
C
               DO IGAUSS=1,NGAUSS
                  RESULT=RESULT+WHERMI(IGAUSS)*DH1PLN(N,IGAUSS)
     *                                        *HERPLN(M,IGAUSS)
     *                                        *HERPLN(K,IGAUSS)
               END DO
C
               COEF01(K,M,N,KARTEZ)=RESULT
C
            END DO
         END DO
      END DO
C
C=======================================================================
C     Calculating the expansion coefficients for the products
C     DERIVATIVE  (EXP*HERMIT)*DERIVATIVE (EXP*HERMIT)*HERMIT
C=======================================================================
C
      DO N=0,NOSACT
         DO M=0,NOSACT
            DO K=M+N+2,0,-2
C
               RESULT=0.0
C
               DO IGAUSS=1,NGAUSS
                  RESULT=RESULT+WHERMI(IGAUSS)*DH1PLN(N,IGAUSS)
     *                                        *DH1PLN(M,IGAUSS)
     *                                        *HERPLN(K,IGAUSS)
               END DO
C
               COEF11(K,M,N,KARTEZ)=RESULT
C
            END DO
         END DO
      END DO
C
C=======================================================================
C     Calculating the expansion coefficients for the products:
C     second derivative (EXP * HERMIT) * HERMIT * HERMIT
C=======================================================================
C
      DO N=0,NOSACT
         DO M=0,NOSACT
            DO K=M+N+2,0,-2
C
               RESULT=0.0
C
               DO IGAUSS=1,NGAUSS
                  RESULT=RESULT+WHERMI(IGAUSS)*DH2PLN(N,IGAUSS)
     *                                        *HERPLN(M,IGAUSS)
     *                                        *HERPLN(K,IGAUSS)
               END DO
C
               COEF02(K,M,N,KARTEZ)=RESULT
C
            END DO
         END DO
      END DO
C
C=======================================================================
C     The code uses dimensioned wave functions and their derivatives;
C     therefore, the coefficients  COEF{} are here scaled by related
C     factors which take into account these dimensions
C=======================================================================
C
      DO N=0,NOSACT
         DO M=0,NOSACT
C
            DO K=M+N,0,-2
               COEF00(K,M,N,KARTEZ)=COEF00(K,M,N,KARTEZ)
     *                             *SQRT(HOMSCA(KARTEZ))
               COUL00(K,M,N,KARTEZ)=COUL00(K,M,N,KARTEZ)
     *                             *SQRT(HOMSCA(KARTEZ))
            END DO
C
            DO K=M+N+1,0,-2
               COEF01(K,M,N,KARTEZ)=COEF01(K,M,N,KARTEZ)
     *                             *SQRT(HOMSCA(KARTEZ))
     *                             *     HOMSCA(KARTEZ)
            END DO
C
            DO K=M+N+2,0,-2
C
               COEF02(K,M,N,KARTEZ)=COEF02(K,M,N,KARTEZ)
     *                             *SQRT(HOMSCA(KARTEZ))
     *                             *     HOMSCA(KARTEZ)
     *                             *     HOMSCA(KARTEZ)
C
               COEF11(K,M,N,KARTEZ)=COEF11(K,M,N,KARTEZ)
     *                             *SQRT(HOMSCA(KARTEZ))
     *                             *     HOMSCA(KARTEZ)
     *                             *     HOMSCA(KARTEZ)
            END DO
C
         END DO
      END DO
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C=======================================================================
C
      SUBROUTINE WS_DEVMUL(NOSACT,NGAUSS,KARTEZ,MULMAX,LEVELD,IFMULT)
C=======================================================================
      USE params
C=======================================================================
C
      COMMON
     *       /DEVMUL_COEMUL/ COMULT(0:NDMULT,0:NDOSGS,0:NDOSGS,1:NDKART)
      COMMON
     *       /DEVMUL_COEMAG/ COGRAD(0:NDMULT,0:NDOSGS,0:NDOSGS,1:NDKART)
      COMMON
     *       /DEVMUL_COEDER/ CODERI(1:NDDERI,0:NDOSGS,0:NDOSGS,1:NDKART)
      COMMON
     *       /DEVMUL_COESCA/ COSCAL(1:NDSCHR,0:NDOSGS,0:NDOSGS,1:NDKART)
      COMMON
     *       /WSEXEC_HERSTO/ HERMTS(0:ND2MAX,1:NDGAUS,1:NDKART)
      COMMON
     *       /WSEXEC_DIVSTO/ DHRMTS(0:ND2MAX,1:NDGAUS,1:NDKART),
     *                       DDHRMT(0:ND2MAX,1:NDGAUS,1:NDKART)
      COMMON
     *       /WSEXEC_INTSTO/ HERWGT(1:NDGAUS,1:NDKART),
     *                       HERPNT(1:NDGAUS,1:NDKART)
      COMMON
     *       /SETBAS_SCALNG/ HOMSCA(NDKART)
C
C=======================================================================
C
C         This routine performs integration of the matrix elements
C         of powers of position variables with Hermite polynomials
C
C              Int dx  H(n,x) * x**k * H(m,x) = COMULT(k,n,m)
C
C         It also  performs integration  of the matrix elements of
C         powers of gradient operators with Hermite polynomials
C
C              Int dx  H(n,x) * D**k * H(m,x) = CODERI(k,n,m)
C
C         Integration of the matrix elements  of powers of scaling
C         operators with Hermite polynomials will also be done
C
C              Int dx H(n,x) *(x*D)**k*H(m,x) = COSCAL(k,n,m)
C
C         It also  performs integration  of the matrix elements of
c         powers of positions*gradient with Hermite polynomials
C
C              Int dx H(n,x) *(x**K)*D*H(m,x) = COGRAD(k,n,m)
C
C
C         Above:
C
C         H(n,x): the Hermite polynomial, of the order n, at point
C                 x assumed to be normalized to 1, when its square
C                 is integrated with exp(-x**2).
C
C         NOSACT: the maximum order  of the Hermite polynomials in
C                 the code
C
C         H(n,x) has the maximum order NOSACT <==> [n(max)=NOSACT]
C
C         The coefficients COMULT are found  by explicit numerical
C                        G a u s s - H e r m i t e
C         integration of products appearing in the above functions.
C         The one-body integration weights and points are used.
C
C=======================================================================
C
      IF (IFMULT.NE.1) RETURN
C
C=======================================================================
C
      DO M=0,NOSACT
         DO N=0,NOSACT
            DO K=0,MULMAX
	       COMULT(K,N,M,KARTEZ)=0.0
	       COGRAD(K,N,M,KARTEZ)=0.0
            END DO
         END DO
      END DO
C
C=======================================================================
C      Integration of powers of positions
C=======================================================================
C
      DO M=0,NOSACT
         DO N=0,NOSACT
            DO K=0,MULMAX
C
               RESULT=0.0
C
               DO IGAUSS=1,NGAUSS
C
                  RESULT=RESULT+HERWGT(IGAUSS,KARTEZ)
     *                         *HERMTS(N,IGAUSS,KARTEZ)
     *                         *HERMTS(M,IGAUSS,KARTEZ)
     *                         *HERPNT(IGAUSS,KARTEZ)**K
C
               END DO
C
               COMULT(K,N,M,KARTEZ)=RESULT
C
            END DO
         END DO
      END DO
C
C      The code uses undimensioned position variables.  Therefore,
C      the coefficients COMULT are here scaled by the appropriate
C      factors which take into account these dimensions.  It then
C      follows that these coefficients contain dimensioned matrix
C      elements of position variables. Similarly the coefficients
C      CODERI  contain dimensioned  matrix elements of gradients,
C      because in DEFINT the DHRMTS and DDHRMT matrices have been
C      multiplied by the appropriate factors
C
      DO M=0,NOSACT
         DO N=0,NOSACT
            DO K=0,MULMAX
C
               COMULT(K,N,M,KARTEZ)=COMULT(K,N,M,KARTEZ)
     *                                   /HOMSCA(KARTEZ)**K
            END DO
C
         END DO
      END DO
C
C=======================================================================
C
      IF (LEVELD.EQ.1) RETURN
C
C=======================================================================
C      Integration of powers of gradients
C=======================================================================
C
      DO M=0,NOSACT
         DO N=0,NOSACT
C
            RESULT=0.0
C
            DO IGAUSS=1,NGAUSS
C
               RESULT=RESULT+HERWGT(IGAUSS,KARTEZ)
     *                      *HERMTS(N,IGAUSS,KARTEZ)
     *                      *DHRMTS(M,IGAUSS,KARTEZ)
C
            END DO
C
            CODERI(1,N,M,KARTEZ)=RESULT
C
            RESULT=0.0
C
            DO IGAUSS=1,NGAUSS
C
               RESULT=RESULT+HERWGT(IGAUSS,KARTEZ)
     *                      *HERMTS(N,IGAUSS,KARTEZ)
     *                      *DDHRMT(M,IGAUSS,KARTEZ)
C
            END DO
C
            CODERI(2,N,M,KARTEZ)=RESULT
C
         END DO
      END DO
C
C=======================================================================
C
      IF (LEVELD.EQ.2) RETURN
C
C=======================================================================
C           Integration of powers of scaling operators
C=======================================================================
C
      DO M=0,NOSACT
         DO N=0,NOSACT
C
            RESULT=0.0
C
            DO IGAUSS=1,NGAUSS
C
               RESULT=RESULT+HERWGT(IGAUSS,KARTEZ)
     *                      *HERMTS(N,IGAUSS,KARTEZ)
     *                      *DHRMTS(M,IGAUSS,KARTEZ)
     *                      *HERPNT(IGAUSS,KARTEZ)
C
            END DO
C
            COSCAL(1,N,M,KARTEZ)=RESULT
C
         END DO
      END DO
C
      DO M=0,NOSACT
         DO N=0,NOSACT
C
            COSCAL(1,N,M,KARTEZ)=COSCAL(1,N,M,KARTEZ)
     *                                /HOMSCA(KARTEZ)
C
         END DO
      END DO
C
C=======================================================================
C        Integration of powers of positions times gradient
C=======================================================================
C
      DO M=0,NOSACT
         DO N=0,NOSACT
C
            DO K=0,MULMAX
C
               RESULT=0.0
C
               DO IGAUSS=1,NGAUSS
C
                  RESULT=RESULT+HERWGT(IGAUSS,KARTEZ)
     *                         *HERMTS(N,IGAUSS,KARTEZ)
     *                         *DHRMTS(M,IGAUSS,KARTEZ)
     *                         *HERPNT(IGAUSS,KARTEZ)**K
C
               END DO
C
               COGRAD(K,N,M,KARTEZ)=RESULT
C
            END DO
C
         END DO
      END DO
C
C      Renormalization of dimensioned variables into dimensionless ones
C
      DO M=0,NOSACT
         DO N=0,NOSACT
            DO K=0,MULMAX
C
               COGRAD(K,N,M,KARTEZ)=COGRAD(K,N,M,KARTEZ)
     *                                   /HOMSCA(KARTEZ)**K
C
            END DO
         END DO
      END DO
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C=======================================================================
C
      SUBROUTINE WS_DEFINT(NOSACT,EPSHER,KARTEZ,NGAUSS,NOBODY,IDERIV,
     *                            HERACT,DHRACT,DDHACT,WGTACT,PNTACT)
C=======================================================================
      USE params
C=======================================================================
C
      DIMENSION
     *          PHERMI(0:ND2MAX),DHERMI(0:ND2MAX)
      DIMENSION
     *          XHERMI(1:NDGAUS),WHERMI(1:NDGAUS)
      DIMENSION
     *          SQFACT(0:ND2MAX)
C
      DIMENSION
     *          HERACT(0:ND2MAX,1:NDGAUS,1:NDKART)
      DIMENSION
     *          DHRACT(0:ND2MAX,1:NDGAUS,1:NDKART),
     *          DDHACT(0:ND2MAX,1:NDGAUS,1:NDKART)
      DIMENSION
     *          WGTACT(1:NDGAUS,1:NDKART),
     *          PNTACT(1:NDGAUS,1:NDKART)
C
      COMMON
     *       /READWRITE_PAR/ NOUTPT,IWRITE,ISCREN
      COMMON
     *       /SETBAS_SCALNG/ HOMSCA(NDKART)
C
C=======================================================================
C
C        This subroutine calculates harmonic oscillator wave functions
C        and their first and second derivatives;  it also prepares the
C        nodes and weights for the Gauss-Hermite integration.
C
C        If IDERIV=2, then the routine will calculate the function and
C                     its first and second derivatives;
C        if IDERIV=1, only the function, and its first derivative will
C                     be calculated  (array DDHACT will not be used so
C                     that one can put a dummy variable intead;
C        if IDERIV=0, only the function will be calculated  and arrays
C                     DHRACT and DDHACT will not be referenced at all.
C
C        Exponential factors are not included neither in the functions
C        nor in the derivatives.
C
C=======================================================================
C
      IF (KARTEZ.EQ.1.AND.NGAUSS.GT.NDXHRM) THEN
C
          WRITE(NOUTPT,'(//,1X,''NGAUSS='',I2,'' > NDXHRM='',I2,2X,
     *                    ''STOP in DEFINT'',//)') NGAUSS,NDXHRM
C
          STOP 'NGAUSS.GT.NDXHRM  in  DEFINT - '
C
      END IF
C
      IF (KARTEZ.EQ.2.AND.NGAUSS.GT.NDYHRM) THEN
C
          WRITE(NOUTPT,'(//,1X,''NGAUSS='',I2,'' > NDYHRM='',I2,2X,
     *                    ''STOP in DEFINT'',//)') NGAUSS,NDYHRM
C
          STOP 'NGAUSS.GT.NDYHRM  in  DEFINT - '
C
      END IF
C
      IF (KARTEZ.EQ.3.AND.NGAUSS.GT.NDZHRM) THEN
C
          WRITE(NOUTPT,'(//,1X,''NGAUSS='',I2,'' > NDZHRM='',I2,2X,
     *                    ''STOP in DEFINT'',//)') NGAUSS,NDZHRM
C
          STOP 'NGAUSS.GT.NDZHRM  in  DEFINT'
C
      END IF
C
C=======================================================================
C
C        Even if the basis contains the wave functions  only up to the
C        number of oscillator quanta equal to "NOSACT", the code needs
C        the wave functions up to the maximum number of quanta equal:
C
      NMAIN2=2*NOSACT+2
C
C=======================================================================
C        Defining zeros and weights for the Gauss-Hermite integration
C=======================================================================
C
      CALL WS_GAUHER(XHERMI,WHERMI,NGAUSS,NDGAUS,EPSHER)
C
C=======================================================================
C        Defining Hermite polynomial normalization constants
C=======================================================================
C
      CALL WS_NORFAC(SQFACT,ND2MAX)
C
C=======================================================================
C
C        If NOBODY=2, we scale the weights and the zeros by 1/sqrt(2);
C        this scaling corresponds to integrating the products of four
C        harmonic-oscillator wave functions.  In the Woods-Saxon code
C        we have analytical expressions for the mean fields, and most
C        of the operators are of one - body character. In those cases
C        and unlike the HF case,  the matrix elements of the one-body
C        operators contain products of two  (in the HF four)  Hermite
C        polynomials. Exceptionally here, the two-body delta-like in-
C        teraction option will require  NOBODY=2.  The scaled weights
C        and zeros will be used to integrate these quantities in that
C        case.
C
C=======================================================================
C
C        If NOBODY=1 no sqrt(2) scaling; in this case the weights and
C        zeros can be used directly  to integrate the products of two
C        harmonic oscillator wave functions.
C
C=======================================================================
C
      IF (NOBODY.GT.2) STOP 'NOBODY too  big  in DEFINT'
      IF (NOBODY.LT.1) STOP 'NOBODY too small in DEFINT'
C
      IF (NOBODY.EQ.2) SCBODY=SQRT(2.0)
      IF (NOBODY.EQ.1) SCBODY=(1.00000)
C
      DO IZEROS=1,NGAUSS
C
         WGTACT(IZEROS,KARTEZ)=WHERMI(IZEROS)/SCBODY/HOMSCA(KARTEZ)
C
C=======================================================================
C
C        In the above instruction we have divided the Gauss weights by:
C
C                    HOMSCA{} = SQRT(MASS*HOMEG{}/H_BAR**2)
C
C        This corresponds to expressing the one-dimensional integration
C        measure  in fermis.  Integrals over the volume  have therefore
C        fermi**3 as their dimension.   (HOMSCA{} = b_mu  in the notes)
C
C=======================================================================
C
         PNTACT(IZEROS,KARTEZ)=XHERMI(IZEROS)/SCBODY
C
C=======================================================================
C
         X_ZERO=PNTACT(IZEROS,KARTEZ)
C
         CALL WS_DFHERM(X_ZERO,NMAIN2,PHERMI,DHERMI,ND2MAX)
C
C=======================================================================
C
C        Hermite polynomials are multiplied by normalization  constant:
C
C                     (MASS*HOMEG{}/H_BAR**2)**(1/4)
C
C        This corresponds to introducing one-dimensional wave functions
C        in units of fm**(-1/2).  The orresponding densities,  in three
C        dimensions are then in units of fm**(-3)
C
C                              additionally
C
C        Derivatives of the "Hermite * exponent" products (see comments
C        in DEVHER)  are  multiplied  by the appropriate powers  of the
C        dimensioned stretching factors "HOMSCA". In this way the first
C        derivative has a correct dimension of Fermi**(-3/2).  Also the
C        second derivative has the correct dimension of Fermi**(-5/2).
C
C=======================================================================
C
         HOMACT=HOMSCA(KARTEZ)
         HOMAC2=HOMACT**2
C
         DO N_OSCI=0,NMAIN2
C
            COMFAC=SQRT(HOMSCA(KARTEZ))/SQFACT(N_OSCI)
C
            HERACT(N_OSCI,IZEROS,KARTEZ)=PHERMI(N_OSCI)*COMFAC
C
            IF (IDERIV.LT.1) GO TO 1
C
                DHRACT(N_OSCI,IZEROS,KARTEZ)=(DHERMI(N_OSCI)
     *                                  - X_ZERO*PHERMI(N_OSCI))
     *                                  * COMFAC*HOMACT
C
            IF (IDERIV.LT.2) GO TO 1
C
            DDHACT(N_OSCI,IZEROS,KARTEZ)=(X_ZERO*X_ZERO-2*N_OSCI-1)
     *                                  * PHERMI(N_OSCI)*COMFAC
     *                                  * HOMAC2
C
    1    END DO
C
      END DO
C
C=======================================================================
C
      RETURN
      END
