C FILE NAME = wsu06_diag_05.f   ! Keep this symbol here: $ident@string$
C
C=======================================================================
C=======================================================================
C=====                                ==================================
C=====    DIAGONALISATION ROUTINES    ==================================
C=====                                ==================================
C=======================================================================
C=======================================================================
C
      SUBROUTINE WS_DIASIG(ESPECT,IREVER,IPAORD)
C=======================================================================
      USE params
C=======================================================================
C
      COMPLEX
     *          EWAVEF
C
C=======================================================================
      COMPLEX, ALLOCATABLE, DIMENSION(:,:,:) :: PWAVEF
C=======================================================================
C
      DIMENSION
     *          ESPECT(1:NDBASE),ESINGP(1:NDBASE),
     *          NPARIT(1:NDBASE),NSTATE(1:NDBASE)
      DIMENSION
     *          IPAORD(1:NDBASE)
C
      COMMON
     *       /SPECTR_SPINOR/ EWAVEF(1:NDBASE,1:NDBASE)
      COMMON
     *       /MULTIP_SPLEVS/ SPENER(1:NDBASE,0:NDREVE),
     *                       SPALIG(1:NDBASE,0:NDREVE),
     *                       SPSPAL(1:NDBASE,0:NDREVE),
     *                       SPPARI(1:NDBASE,0:NDREVE),
     *                       QUOKAR(1:NDBASE,0:NDREVE),
     *                       QUONIL(1:NDBASE,0:NDREVE)
      COMMON
     *       /SETBAS_PARIND/ INDPAR(1:NDBASE,0:NDPARI)
     *       /SETBAS_PARDIM/ LDBASP(0:NDPARI)
     *       /SETBAS_DIMENS/ LDBASE
      COMMON
     *       /CRANKG_SIGDIM/ LDSTAT(0:NDREVE)
C
      COMMON
     *       /READWRITE_PAR/ NOUTPT,IWRITE,ISCREN
C
C=======================================================================
C
C     This is an auxiliary routine preparing the diagonalizations
C     for the PARITY/SIGNATURE case
C
C=======================================================================
C
      CALL WS_CPUTIM('DIASIG',1)
C
C=======================================================================
C
      ALLOCATE(PWAVEF(1:NDBASE,1:NDBASE,0:NDPARI))
C
      NCOUNT=0
C
      DO IPARIT=0,NDPARI
C
C         Here we collect the matrix elements connecting the basis
C         states of the same parity
C
         DO IKETPA=1,LDBASP(IPARIT)
            DO IBRAPA=1,LDBASP(IPARIT)
C
               PWAVEF(IBRAPA,IKETPA,IPARIT)=
     *
     *         EWAVEF(INDPAR(IBRAPA,IPARIT),
     *                INDPAR(IKETPA,IPARIT))
C
            END DO
         END DO
C
C         Here we diagonalize the hamiltonian  in the fixed parity
C
         CALL WS_DIAGCM(PWAVEF(1,1,IPARIT),ESINGP,LDBASP(IPARIT))
C
C         ...  and we collect the energies obtained in both parity
C              blocks in the vector ESINGP
C
         DO ISTATE=1,LDBASP(IPARIT)
            NCOUNT=NCOUNT+1
            IF (NCOUNT.GT.NDBASE) STOP 'NCOUNT.GT.NDBASE'
            NPARIT(NCOUNT)=IPARIT
            NSTATE(NCOUNT)=NCOUNT
            ESPECT(NCOUNT)=ESINGP(ISTATE)
         END DO
C
      END DO
C
      IF (IWRITE.GE.3) THEN
C
          WRITE(NOUTPT,'(/,80(''#''),/,''#'',78X,''#'',/,
     *            ''#  Following the parity conservation two blocks'',
     *            '' were defined:   (+) '',I3,'' *'',I3,''   #'',/,
     *            ''#                                              '',
     *            ''       a n d :   (-) '',I3,'' *'',I3,''   #'',/,
     *            ''#'',78X,''#'',/,80(''#''))')
     *                                            LDBASP(0),LDBASP(0),
     *                                            LDBASP(1),LDBASP(1)
      END IF
C
C      Here we order the single-particle energies
C
      CALL WS_ORDER1(ESPECT,NSTATE,LDBASE,NDBASE)
C
      DO ISTATE=1,LDBASE
         SPENER(ISTATE,IREVER)=ESPECT(ISTATE)
         IPAORD(ISTATE)=NPARIT(NSTATE(ISTATE))
         SPPARI(ISTATE,IREVER)=IPAORD(ISTATE)
      END DO
C
      IF (LDSTAT(IREVER).GT.LDBASE) STOP ' LDSTAT > LDBASE in DIASIG'
C
C      Below we reconstruct the matrix of the eigenvectors by:
C      - Rearranging the columns of the fixed-parity eigenvectors
C        according to the increasing order of energies
C      - Reordering the indices of the basis according to their
C        original ordering scheme
C
      ISHIFT=0
C
      DO IPARIT=0,NDPARI
C
         DO ISTATE=1,LDSTAT(IREVER)
C
	    KPARIT=NPARIT(NSTATE(ISTATE))
C
            IF (KPARIT.EQ.IPARIT) THEN
C
                DO IBASPA=1,LDBASP(IPARIT)
                   EWAVEF(INDPAR(IBASPA,IPARIT),ISTATE)
     *            =PWAVEF(IBASPA,NSTATE(ISTATE)-ISHIFT,KPARIT)
                END DO
C
            ELSE
C
                DO IBASPA=1,LDBASP(IPARIT)
                   EWAVEF(INDPAR(IBASPA,IPARIT),ISTATE)=CMPLX(0.0,0.0)
                END DO
C
            END IF
C
         END DO
C
         ISHIFT=LDBASP(0)
C
      END DO
C
      DEALLOCATE(PWAVEF)
C
C=======================================================================
C
      CALL WS_CPUTIM('DIASIG',0)
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C=======================================================================
C
      SUBROUTINE WS_DIASIR(RAUXIL,ESPECT,IREVER,IPAORD,LDBASE)
C=======================================================================
      USE params
C=======================================================================
C
C=======================================================================
      DOUBLE PRECISION, ALLOCATABLE, DIMENSION(:,:,:) :: PWAVEF
C=======================================================================
C
      DIMENSION
     *          RAUXIL(1:NDBASE,1:NDBASE)
      DIMENSION
     *          ESPECT(1:NDBASE),ESINGP(1:NDBASE),
     *          NPARIT(1:NDBASE),NSTATE(1:NDBASE),
     *                           IPAORD(1:NDBASE)
C
      COMMON
     *       /MULTIP_SPLEVS/ SPENER(1:NDBASE,0:NDREVE),
     *                       SPALIG(1:NDBASE,0:NDREVE),
     *                       SPSPAL(1:NDBASE,0:NDREVE),
     *                       SPPARI(1:NDBASE,0:NDREVE),
     *                       QUOKAR(1:NDBASE,0:NDREVE),
     *                       QUONIL(1:NDBASE,0:NDREVE)
      COMMON
     *       /SETBAS_PARIND/ INDPAR(1:NDBASE,0:NDPARI)
     *       /SETBAS_PARDIM/ LDBASP(0:NDPARI)
      COMMON
     *       /CRANKG_SIGDIM/ LDSTAT(0:NDREVE)
      COMMON
     *       /READWRITE_PAR/ NOUTPT,IWRITE,ISCREN
C
C=======================================================================
C     This is an auxiliary routine preparing the diagonalizations
C     for the PARITY/SIGNATURE case in MU_ODD=1 (not Lambda) case
C=======================================================================
C
      CALL WS_CPUTIM('DIASIR',1)
C
C=======================================================================
C
      ALLOCATE(PWAVEF(1:NDBASE,1:NDBASE,0:NDPARI))
C
      NCOUNT=0
C
      DO IPARIT=0,NDPARI
C
C         Here we collect  the matrix elements  of the hamiltonian
C         connecting the basis states of the same parity
C
         DO IBRAPA=1,LDBASP(IPARIT)
            DO IKETPA=1,LDBASP(IPARIT)
C
               PWAVEF(IBRAPA,IKETPA,IPARIT)=
     *
     *         RAUXIL(INDPAR(IBRAPA,IPARIT),
     *                INDPAR(IKETPA,IPARIT))
C
            END DO
         END DO
C
C         Here we diagonalize the hamiltonian for the fixed parity
C
        CALL WS_DIAGRM(PWAVEF(1,1,IPARIT),ESINGP,LDBASP(IPARIT))
C
C        ...  and we collect the energies obtained in both parity
C             blocks in the vector ESINGP
C
         DO ISTATE=1,LDBASP(IPARIT)
            NCOUNT=NCOUNT+1
            IF (NCOUNT.GT.NDBASE) STOP 'NCOUNT.GT.NDBASE'
            NPARIT(NCOUNT)=IPARIT
            NSTATE(NCOUNT)=NCOUNT
            ESPECT(NCOUNT)=ESINGP(ISTATE)
         END DO
C
      END DO
C
      IF (IWRITE.GE.3) THEN
C
          WRITE(NOUTPT,'(/,80(''#''),/,''#'',78X,''#'',/,
     *            ''#  Following the parity conservation two blocks'',
     *            '' were defined:   (+) '',I3,'' *'',I3,''   #'',/,
     *            ''#                                              '',
     *            ''       a n d :   (-) '',I3,'' *'',I3,''   #'',/,
     *            ''#'',78X,''#'',/,80(''#''))')
     *                                            LDBASP(0),LDBASP(0),
     *                                            LDBASP(1),LDBASP(1)
      END IF
C
C     Below we order the single-particle energies
C
      CALL WS_ORDER1(ESPECT,NSTATE,LDBASE,NDBASE)
C
      DO ISTATE=1,LDBASE
         SPENER(ISTATE,IREVER)=ESPECT(ISTATE)
         IPAORD(ISTATE)=NPARIT(NSTATE(ISTATE))
         SPPARI(ISTATE,IREVER)=IPAORD(ISTATE)
      END DO
C
      IF (LDSTAT(IREVER).GT.LDBASE) STOP ' LDSTAT > LDBASE in DIASIR'
C
C     Here  we reconstruct the matrix of all the eigenvectors by:
C     - Rearranging the columns of the fixed-parity eigenvectors
C       according to the increasing order of energies
C     - Reordering the indices of the basis according to their
C       original ordering scheme
C
      ISHIFT=0
C
      DO IPARIT=0,NDPARI
C
         DO ISTATE=1,LDSTAT(IREVER)
C
	    KPARIT=NPARIT(NSTATE(ISTATE))
C
            IF (KPARIT.EQ.IPARIT) THEN
C
                DO IBASPA=1,LDBASP(IPARIT)
                   RAUXIL(INDPAR(IBASPA,IPARIT),ISTATE)
     *            =PWAVEF(IBASPA,NSTATE(ISTATE)-ISHIFT,KPARIT)
                END DO
C
	    ELSE
C
                DO IBASPA=1,LDBASP(IPARIT)
                   RAUXIL(INDPAR(IBASPA,IPARIT),ISTATE)=0
                END DO
C
            END IF
C
         END DO
C
         ISHIFT=LDBASP(0)
C
      END DO
C
      DEALLOCATE(PWAVEF)
C
C=======================================================================
C
      CALL WS_CPUTIM('DIASIR',0)
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C=======================================================================
C
      SUBROUTINE WS_DPARI3(ICHARG,LDOUBL)
C=======================================================================
      USE params
C=======================================================================
C
      INTERFACE
         SUBROUTINE WS_DIAG3D(CMATRX,NDACTU,EIGVAL,LDACTU)
            INTEGER :: NDACTU
            COMPLEX, POINTER, DIMENSION(:,:) :: CMATRX
            DOUBLE PRECISION, DIMENSION(1:NDACTU) :: EIGVAL
            INTEGER :: LDACTU
         END SUBROUTINE WS_DIAG3D
      END INTERFACE
C
C=======================================================================
      COMPLEX, POINTER, DIMENSION(:,:) :: CELMTS
C=======================================================================
      COMPLEX, ALLOCATABLE, DIMENSION(:,:,:) :: PWAVEF
C=======================================================================
      COMPLEX
     *          WAVOCC,BIG_PP,BIG_PM
C
      DIMENSION
     *          ESPECT(1:NDOUBL),ESINGP(1:NDOUBL)
      DIMENSION
     *          NPARIT(1:NDOUBL),NSTATE(1:NDOUBL)
      DIMENSION
     *          LDPSIZ(0:NDPARI)
C
      COMMON
     *       /CRAN3D_MAT_PP/ BIG_PP(1:NDBASE,1:NDBASE,0:NDREVE)
     *       /CRAN3D_MAT_PM/ BIG_PM(1:NDBASE,1:NDBASE,0:NDREVE)
      COMMON
     *       /CRAN3D_ALLWAV/ WAVOCC(1:NDBASE,1:2*NDBASE,0:NDREVE)
      COMMON
     *       /CRAN3D_SPLV3D/ SPENER(1:2*NDBASE,0:NDISOS),
     *                       SPOCCU(1:2*NDBASE,0:NDISOS),
     *                       SPALIG(1:2*NDBASE,0:NDISOS),
     *                       SPSPAL(1:2*NDBASE,0:NDISOS),
     *                       SPPARI(1:2*NDBASE,0:NDISOS),
     *                       SPSIMP(1:2*NDBASE,0:NDISOS)
      COMMON
     *       /SETBAS_PARIND/ INDPAR(1:NDBASE,0:NDPARI)
     *       /SETBAS_PARDIM/ LDBASP(0:NDPARI)
C
      COMMON
     *       /READWRITE_PAR/ NOUTPT,IWRITE,ISCREN
C
C=======================================================================
C     This is an auxiliary routine preparing the diagonalizations
C     for the PARITY/SIGNATURE case
C=======================================================================
C
      CALL WS_CPUTIM('DPARI3',1)
C
C=======================================================================
C
C      Here we collect the matrix elements connecting the basis
C      states of the same parity. The two final matrices have size
C      {2*LDBASP(IPARIT), 2*LDBASP(IPARIT)}
C
      ALLOCATE(PWAVEF(1:NDOUBL,1:NDOUBL,0:NDPARI))
      ALLOCATE(CELMTS(1:NDOUBL,1:NDOUBL))
C
      NCOUNT=0
C
      DO IPARIT=0,NDPARI
C
         DO J=1,NDOUBL
            DO I=1,NDOUBL
	       CELMTS(I,J)=CMPLX(0.0,0.0)
	       PWAVEF(I,J,IPARIT)=CMPLX(0.0,0.0)
	    END DO
         END DO
C
         LDPSIZ(IPARIT)=2*LDBASP(IPARIT)
C
C         Diagonal blocks
C
         DO IKETPA=1,LDBASP(IPARIT)
            DO IBRAPA=1,LDBASP(IPARIT)
C
               CELMTS(IBRAPA,IKETPA)=
     *
     *         BIG_PP(INDPAR(IBRAPA,IPARIT),
     *                INDPAR(IKETPA,IPARIT),0)
C
            END DO
         END DO
C
         DO IKETPA=LDBASP(IPARIT)+1,2*LDBASP(IPARIT)
            DO IBRAPA=LDBASP(IPARIT)+1,2*LDBASP(IPARIT)
C
               I_REAL=IBRAPA-LDBASP(IPARIT)
	       J_REAL=IKETPA-LDBASP(IPARIT)
C
               CELMTS(IBRAPA,IKETPA)=
     *
     *         BIG_PP(INDPAR(I_REAL,IPARIT),
     *                INDPAR(J_REAL,IPARIT),1)
C
            END DO
         END DO
C
C         Anti-diagonal blocks
C
         DO IKETPA=LDBASP(IPARIT)+1,2*LDBASP(IPARIT)
            DO IBRAPA=1,LDBASP(IPARIT)
C
	       J_REAL=IKETPA-LDBASP(IPARIT)
C
               CELMTS(IBRAPA,IKETPA)=
     *
     *         BIG_PM(INDPAR(IBRAPA,IPARIT),
     *                INDPAR(J_REAL,IPARIT),1)
C
            END DO
         END DO
C
         DO IKETPA=1,LDBASP(IPARIT)
            DO IBRAPA=LDBASP(IPARIT)+1,2*LDBASP(IPARIT)
C
               I_REAL=IBRAPA-LDBASP(IPARIT)
C
               CELMTS(IBRAPA,IKETPA)=
     *
     *         CONJG(BIG_PM(INDPAR(I_REAL,IPARIT),
     *                      INDPAR(IKETPA,IPARIT),1))
C
            END DO
         END DO
C
C         Here we diagonalize the hamiltonian in the fixed parity block
C
         LDACTU=LDPSIZ(IPARIT)
C
         CALL WS_DIAG3D(CELMTS,NDOUBL,ESINGP,LDACTU)
C
C         We simultaneously collect the energies obtained in both parity
C         blocks in the vector ESPECT
C
         DO ISTATE=1,LDACTU
            NCOUNT=NCOUNT+1
            IF (NCOUNT.GT.NDOUBL) STOP 'NCOUNT.GT.NDOUBL IN DPARI3'
            NPARIT(NCOUNT)=IPARIT
            NSTATE(NCOUNT)=NCOUNT
            ESPECT(NCOUNT)=ESINGP(ISTATE)
         END DO
C
         DO J=1,NDOUBL
            DO I=1,NDOUBL
	       PWAVEF(I,J,IPARIT)=CELMTS(I,J)
	    END DO
         END DO
C
      END DO ! END OF PARITY LOOP
C
      DEALLOCATE(CELMTS)
C
      LDTOTL=LDPSIZ(0)+LDPSIZ(1)
C
      IF (LDTOTL.NE.LDOUBL) THEN
          WRITE(6,'(''LDOUBL = '',I6,'' LDTOTL = '',I6,
     *              '' LDPSIZ(0) = '',I6,'' LDPSIZ(1) = '',I6)')
     *                 LDOUBL,LDTOTL,LDPSIZ(0),LDPSIZ(1)
      END IF
C
C      Here we order the whole single-particle energies vector
C      (containing results for both parities)
C
      CALL WS_ORDER1(ESPECT,NSTATE,LDOUBL,NDOUBL)
C
      DO ISTATE=1,LDOUBL
         SPENER(ISTATE,ICHARG)=ESPECT(ISTATE)
         SPPARI(ISTATE,ICHARG)=NPARIT(NSTATE(ISTATE))
      END DO
C
      IF (IWRITE.GE.3) THEN
C
          WRITE(NOUTPT,'(/,80(''#''),/,''#'',78X,''#'',/,
     *            ''#  Following the parity conservation two blocks'',
     *            '' were defined:   (+) '',I3,'' *'',I3,''   #'',/,
     *            ''#                                              '',
     *            ''       a n d :   (-) '',I3,'' *'',I3,''   #'',/,
     *            ''#'',78X,''#'',/,80(''#''))')
     *                                            LDPSIZ(0),LDPSIZ(0),
     *                                            LDPSIZ(1),LDPSIZ(1)
      END IF
C
C      Below we reconstruct the matrix of the eigenvectors by:
C      - Rearranging the columns of the fixed-parity eigenvectors
C        according to the increasing order of energies
C      - Reordering the indices  of the basis  according to their
C        original ordering scheme
C
      ISHIFT=0
C
      DO IPARIT=0,NDPARI
C
         DO ISTATE=1,LDPSIZ(IPARIT)
C
	    KPARIT=NPARIT(NSTATE(ISTATE))
C
            IF (KPARIT.EQ.IPARIT) THEN
C
                DO IBASPA=1,LDBASP(IPARIT)
C
                   WAVOCC(INDPAR(IBASPA,IPARIT),ISTATE,0)
     *
     *            =PWAVEF(IBASPA,NSTATE(ISTATE)-ISHIFT,KPARIT)
C
                   WAVOCC(INDPAR(IBASPA,IPARIT),ISTATE,1)
     *
     *            =PWAVEF(IBASPA+LDBASP(IPARIT),
     *                           NSTATE(ISTATE)-ISHIFT,KPARIT)
C
                END DO
C
            ELSE
C
                DO IBASPA=1,LDBASP(IPARIT)
                   WAVOCC(INDPAR(IBASPA,IPARIT),ISTATE,0)=CMPLX(0,0)
                   WAVOCC(INDPAR(IBASPA,IPARIT),ISTATE,1)=CMPLX(0,0)
                END DO
C
            END IF
C
         END DO
C
         ISHIFT=LDPSIZ(0)
C
      END DO
C
      DEALLOCATE(PWAVEF)
C
C=======================================================================
C
      CALL WS_CPUTIM('DPARI3',0)
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C=======================================================================
C
      SUBROUTINE WS_DIASIZ(ICHARG,LDBASE)
C=======================================================================
      USE params
C=======================================================================
C
      INTERFACE
         SUBROUTINE WS_DIAG3D(CMATRX,NDACTU,EIGVAL,LDACTU)
            INTEGER :: NDACTU
            COMPLEX, POINTER, DIMENSION(:,:) :: CMATRX
            DOUBLE PRECISION, DIMENSION(1:NDACTU) :: EIGVAL
            INTEGER :: LDACTU
         END SUBROUTINE WS_DIAG3D
      END INTERFACE
C
      CHARACTER
     *          IRRLB1*2,IRRLB2*2
      CHARACTER
     *          STRNP1*5,STRNP2*5
C
      COMPLEX
     *          WAVOCC,BIG_PP,BIG_PM
C
C=======================================================================
      COMPLEX, POINTER, DIMENSION(:,:) :: CELMTS
C=======================================================================
C
      DIMENSION
     *          SPESIZ(1:NDOUBL)
C
      COMMON
     *       /SETBAS_NXNYNZ/ NXVECT(1:NDBASE),
     *                       NYVECT(1:NDBASE),
     *                       NZVECT(1:NDBASE)
      COMMON
     *       /CRAN3D_MAT_PP/ BIG_PP(1:NDBASE,1:NDBASE,0:NDREVE)
     *       /CRAN3D_MAT_PM/ BIG_PM(1:NDBASE,1:NDBASE,0:NDREVE)
      COMMON
     *       /CRAN3D_ALLWAV/ WAVOCC(1:NDBASE,1:2*NDSTAT,0:NDREVE)
      COMMON
     *       /CRAN3D_SPLV3D/ SPENER(1:2*NDSTAT,0:NDISOS),
     *                       SPOCCU(1:2*NDSTAT,0:NDISOS),
     *                       SPALIG(1:2*NDSTAT,0:NDISOS),
     *                       SPSPAL(1:2*NDSTAT,0:NDISOS),
     *                       SPPARI(1:2*NDSTAT,0:NDISOS),
     *                       SPSIMP(1:2*NDSTAT,0:NDISOS)
C
C=======================================================================
C
C         This subroutine performs the diagonalization of the cranked
C         mean-field in the general case of a 3-dimensional cranking
C         (for which the simplex is broken).
C
C         Single-particle levels are printed.
C
C=======================================================================
C
      CALL WS_CPUTIM('DIASIZ',1)
C
C=======================================================================
C
      ALLOCATE(CELMTS(1:NDOUBL,1:NDOUBL))
C
      DO J=1,NDOUBL
         DO I=1,NDOUBL
	    CELMTS(I,J)=CMPLX(0,0)
	 END DO
      END DO
C
C      Constructing the hamiltonian matrix in the full t-basis
C
      DO IBRAHO=1,2*LDBASE
         DO IKETHO=1,2*LDBASE
C
C            Diagonal blocks
C
            IF (IBRAHO.LE.LDBASE.AND.IKETHO.LE.LDBASE)
     *
     *          CELMTS(IBRAHO,IKETHO)
     *         =BIG_PP(IBRAHO,IKETHO,0)
C
            IF (IBRAHO.GT.LDBASE.AND.IKETHO.GT.LDBASE)
     *
     *          CELMTS(IBRAHO,IKETHO)
     *         =BIG_PP(IBRAHO-LDBASE,IKETHO-LDBASE,1)
C
C            Anti-diagonal blocks
C
            IF (IBRAHO.LE.LDBASE.AND.IKETHO.GT.LDBASE)
     *
     *          CELMTS(IBRAHO,IKETHO)
     *         =BIG_PM(IBRAHO,IKETHO-LDBASE,1)
C
            IF (IBRAHO.GT.LDBASE.AND.IKETHO.LE.LDBASE)
     *
     *          CELMTS(IBRAHO,IKETHO)
     *         =CONJG(BIG_PM(IBRAHO-LDBASE,IKETHO,1))
C
         END DO
      END DO
C
C      Diagonalizing the "big" (2*LDBASE,2*LDBASE) matrix of the
C      3D-cranked mean-field
C
      LDOUBL=2*LDBASE
C
      CALL WS_DIAG3D(CELMTS,NDOUBL,SPESIZ,LDOUBL)
C
C       Storing the s.p. energies
C
      DO ISTATE=1,LDOUBL
         SPENER(ISTATE,ICHARG)=SPESIZ(ISTATE)
      END DO
C
C      Storing the expansion of the wave functions for in time-up and
C      time-down blocks. For state IALLST, the expansion is made of the
C      sum of the two blocks IREVER=0 and 1 (index I_BASE)
C
      DO I_BASE=1,LDBASE
         DO IALLST=1,LDOUBL
            WAVOCC(I_BASE,IALLST,0)=CELMTS(I_BASE       ,IALLST)
            WAVOCC(I_BASE,IALLST,1)=CELMTS(I_BASE+LDBASE,IALLST)
         END DO
      END DO
C
      DEALLOCATE(CELMTS)
C
C=======================================================================
C
      CALL WS_CPUTIM('DIASIZ',0)
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C=======================================================================
C
      SUBROUTINE WS_DIAG3D(CMATRX,NDACTU,EIGVAL,LDACTU)
C=======================================================================
      USE params
C=======================================================================
C
C=======================================================================
      COMPLEX, POINTER, DIMENSION(:,:) :: CMATRX
C=======================================================================
C
      COMPLEX
     *          CTRIAN(1:NDTRIA),WORKRK(NDAUX1)
C
      DIMENSION
     *          EIGVAL(1:NDOUBL)
      DIMENSION
     *          RWORKR(NDAUX2)
C
      COMMON
     *       /READWRITE_PAR/ NOUTPT,IWRITE,ISCREN
C
C=======================================================================
C         This is the interface diagonalization routine; it connects
C         the user-friendly way of refering to the algebra  with the
C         ell known impossibilities of NAG and other-like-that codes
C
C         This routine does the diagonalization only -> there are no
C         WS_ODD specific actions here
C=======================================================================
C
      CALL WS_CPUTIM('DIAG3D',1)
C
C=======================================================================
C
      IF (LDACTU.GT.NDOUBL) STOP ' WRONG NDBASE DIMENSION in DIAG3D'
C
C=======================================================================
C
      I_FAIL=1
C
      DO IKETHO=1,LDACTU
         DO IBRAHO=IKETHO,LDACTU
            KINDEX=IBRAHO+((2*LDACTU-IKETHO)*(IKETHO-1))/2
            CTRIAN(KINDEX)=CMATRX(IBRAHO,IKETHO)
        END DO
      END DO
C
      CALL ZHPEV('V','L',LDACTU,CTRIAN,EIGVAL,CMATRX,NDOUBL,
     *                                 WORKRK,RWORKR,I_FAIL)
C
      IF (I_FAIL.NE.0) THEN
C
          WRITE(NOUTPT,'(//,3(1X,20(1H=),''  ERROR IN DIAGON'',
     *                 '' , I_FAIL='',I4,2X,20(1H=),/),//)') I_FAIL
C
          STOP 'Error in DIAG3D '
C
      END IF
C
C=======================================================================
C
      CALL WS_CPUTIM('DIAG3D',0)
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C=======================================================================
C
      SUBROUTINE WS_DIAGCM(CMATRX,EIGVAL,LDACTU)
C=======================================================================
      USE params
C=======================================================================
      COMPLEX
     *          EWAVEF,CMATRX
      COMPLEX
     *          WORK
      COMPLEX
     *          AUXDIC
      COMPLEX
     *          UNPMAT,AUXZHC
C=======================================================================
      CHARACTER
     *          SWI*1
C=======================================================================
      ALLOCATABLE UNPMAT(:,:)
      ALLOCATABLE AUXZHC(:)
      ALLOCATABLE AUXZHR(:)
      ALLOCATABLE IAUXZH(:)
      ALLOCATABLE ISUPPZ(:)
      ALLOCATABLE AUXDIA(:)
      ALLOCATABLE AUXDIC(:)
      ALLOCATABLE AUXDID(:)
      ALLOCATABLE IAUXDI(:)
      ALLOCATABLE I_FAIL(:)
      ALLOCATABLE WORK(:)
      ALLOCATABLE RWORK(:)
      ALLOCATABLE IWORK(:)
      ALLOCATABLE EWAVEF(:,:)
C=======================================================================
      DIMENSION
     *          CMATRX(1:NDBASE,1:NDBASE)
      DIMENSION
     *          EIGVAL(1:NDBASE)
C
      COMMON
     *       /READWRITE_PAR/ NOUTPT,IWRITE,ISCREN
C
C=======================================================================
C
C         This subroutine replaces the library subroutine of
C         the same name and diagonalizes a complex hermitian
C         matrix by calling the LAPACK routine ZHEEVR.
C
C=======================================================================
C
      IF (LDACTU.GT.NDBASE) STOP ' WRONG NDBASE DIMENSION in DIAGCM'
C
C=======================================================================
C
      CALL WS_CPUTIM('DIAGCM',1)
C
C=======================================================================
C               EXPERT DRIVER IN PACKED STORAGE
C=======================================================================
C
#if(SWITCH_DIAG==2)
C
      NUMFOU=0
      NUMVEC=0
      INFORM=1
C
      EIGMIN=-200.0
      EIGMAX=+200.0
C
      ALLOCATE (AUXDIC(1:2*LDACTU),STAT=IALLOC)
      ALLOCATE (AUXDID(1:7*LDACTU),STAT=IALLOC)
      ALLOCATE (IAUXDI(1:5*LDACTU),STAT=IALLOC)
      ALLOCATE (I_FAIL(1:LDACTU),STAT=IALLOC)
C
      DO I=1,LDACTU
         I_FAIL(I)=0
      END DO
C
      ABSTOL=2*DLAMCH('S')
C
      CALL ZHPEVX('V','V','L',LDACTU,CMATRX,EIGMIN,EIGMAX,1,NUMVEC,
     *                        ABSTOL,NUMFOU,EIGVAL,EWAVEF,NDACTU,
     *                        AUXDIC,AUXDID,IAUXDI,I_FAIL,INFORM)
C
      IF (NUMVEC.EQ.0) NUMVEC=NUMFOU
C
      IF (INFORM.NE.0.OR.NUMVEC.NE.NUMFOU) THEN
C
          WRITE(NOUTPT,'(//,1X,20(1H/),
     *                      '' ERROR IN ZHPEVX, INFORM='',
     *                   I4,1X,20(1H/),/,1X,20(1H/),
     *                      '' ERROR IN ZHPEVX, NUMVEC='',
     *                   I4,1X,20(1H/),/,1X,20(1H/),
     *                      '' ERROR IN ZHPEVX, NUMFOU='',
     *                   I4,1X,20(1H/),/)')
     *
     *          INFORM,NUMVEC,NUMFOU
C
          DO I=1,LDACTU
             IF (I_FAIL(I).GT.0) THEN
                 WRITE(NOUTPT,'(''I = '',i4,'' I_FAIL = '',i4)')
     *                       I,I_FAIL(I)
             END IF
          END DO
C
          STOP ' ERROR IN ZHPEVX'
C
      END IF
C
      DO J=1,LDACTU
         DO I=1,LDACTU
            CMATRX(I,J)=EWAVEF(I,J)
         END DO
      END DO
C
      DEALLOCATE (AUXDIC,AUXDID,IAUXDI,I_FAIL)
C
#endif
C
C=======================================================================
C      RELATIVELY ROBUST REPRESENTATION (RRR) DRIVER IN UNPACKED
C      STORAGE
C=======================================================================
C
#if(SWITCH_DIAG==3)
C
      LWORK  =  2*LDACTU
      LRWORK = 24*LDACTU
      LIWORK = 10*LDACTU
C
      ALLOCATE (WORK(1:LWORK),STAT=IALLOC)
      ALLOCATE (RWORK(1:LRWORK),STAT=IALLOC)
      ALLOCATE (IWORK(1:LIWORK),STAT=IALLOC)
      ALLOCATE (ISUPPZ(1:2*NDBASE),STAT=IALLOC)
      ALLOCATE (EWAVEF(1:LDACTU,1:LDACTU),STAT=IALLOC)
C
      NUMFOU=0
      NUMVEC=0
      INFORM=1
C
      EIGMIN=-200.0
      EIGMAX=+200.0
C
      ABSTOL=2*DLAMCH('S')
C
      CALL ZHEEVR('V','A','L',LDACTU,CMATRX,NDBASE,EIGMIN,EIGMAX,
     *               1,NUMVEC,ABSTOL,NUMFOU,EIGVAL,EWAVEF,LDACTU,
     *               ISUPPZ,WORK,LWORK,RWORK,LRWORK,IWORK,LIWORK,
     *                                                    INFORM)
C
      IF (NUMVEC.EQ.0) NUMVEC=NUMFOU
C
      IF (INFORM.NE.0.OR.NUMVEC.NE.NUMFOU) THEN
C
          WRITE(NOUTPT,'(//,1X,20(1H/),
     *                      '' ERROR IN ZHEEVR, INFORM='',
     *                   I4,1X,20(1H/),/,1X,20(1H/),
     *                      '' ERROR IN ZHEEVR, NUMVEC='',
     *                   I4,1X,20(1H/),/,1X,20(1H/),
     *                      '' ERROR IN ZHEEVR, NUMFOU='',
     *                   I4,1X,20(1H/),/)')
     *
     *          INFORM,NUMVEC,NUMFOU
C
          STOP ' ERROR IN ZHEEVR'
C
      END IF
C
      DO J=1,LDACTU
         DO I=1,LDACTU
            CMATRX(I,J)=EWAVEF(I,J)
         END DO
      END DO
C
      DEALLOCATE (ISUPPZ,IWORK,WORK,RWORK,EWAVEF)
C
#endif
C
C=======================================================================
C      DIVIDE AND CONQUER DRIVER IN UNPACKED STORAGE
C=======================================================================
C
#if(SWITCH_DIAG==4)
C
      INFORM=1
C
      LDWORK=LDACTU*LDACTU+2*LDACTU
      LRWORK=1+5*LDACTU+2*LDACTU**2
      LIWORK=3+5*LDACTU
C
      ALLOCATE (AUXDIC(1:LDWORK),STAT=IALLOC)
      ALLOCATE (AUXZHC(1:LRWORK),STAT=IALLOC)
      ALLOCATE (IAUXZH(1:LIWORK),STAT=IALLOC)
C
      CALL ZHEEVD('V','L',LDACTU,CMATRX,NDACTU,EIGVAL,
     *                    AUXDIC,LDWORK,AUXZHC,LRWORK,
     *                    IAUXZH,LIWORK,INFORM)
C
      IF (INFORM.NE.0) THEN
C
          WRITE(NOUTPT,'(//,1X,20(1H=),
     *                   ''  ERROR IN ZHPEV, INFORM='',
     *                   I4,1X,20(1H=),/,
     *                      1X,79(1H=))')
     *
     *          INFORM
C
          STOP ' ERROR IN ZHEEVD'
C
      END IF
C
      DEALLOCATE (IAUXZH,AUXDIC,AUXZHC)
C
#endif
C=======================================================================
C
      CALL WS_CPUTIM('DIAGCM',0)
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE WS_DIAGRM(RMATRX,EIGVAL,LDACTU)
C=======================================================================
      USE params
C=======================================================================
      DIMENSION
     *          RMATRX(1:NDBASE,1:NDBASE)
C=======================================================================
      ALLOCATABLE WORK(:)
      ALLOCATABLE IWORK(:)
      ALLOCATABLE ISUPPZ(:)
      ALLOCATABLE EWAVEF(:,:)
C=======================================================================
      DIMENSION
     *          EIGVAL(1:NDBASE)
C
      COMMON
     *       /READWRITE_PAR/ NOUTPT,IWRITE,ISCREN
C
C=======================================================================
C
C         This subroutine replaces the library subroutine of
C         the same name and diagonalizes a real symmetric
C         matrix by calling the LAPACK routine DHEEVR.
C
C=======================================================================
C
      IF (LDACTU.GT.NDBASE) STOP ' WRONG NDBASE DIMENSION in DIAGRM'
C
C=======================================================================
C
      CALL WS_CPUTIM('DIAGRM',1)
C
C=======================================================================
C      RELATIVELY ROBUST REPRESENTATION (RRR) DRIVER IN UNPACKED
C      STORAGE
C=======================================================================
C
#if(SWITCH_DIAG==3)
C
      LWORK  = 26*LDACTU
      LIWORK = 10*LDACTU
C
      ALLOCATE (WORK(1:LWORK),STAT=IALLOC)
      ALLOCATE (IWORK(1:LIWORK),STAT=IALLOC)
      ALLOCATE (ISUPPZ(1:2*NDBASE),STAT=IALLOC)
      ALLOCATE (EWAVEF(1:LDACTU,1:LDACTU),STAT=IALLOC)
C
      NUMFOU=0
      NUMVEC=0
      INFORM=1
C
      EIGMIN=-200.0
      EIGMAX=+200.0
C
      ABSTOL=2*DLAMCH('S')
C
      CALL DSYEVR('V','A','L',LDACTU,RMATRX,NDBASE,EIGMIN,EIGMAX,
     *               1,NUMVEC,ABSTOL,NUMFOU,EIGVAL,EWAVEF,LDACTU,
     *                     ISUPPZ,WORK,LWORK,IWORK,LIWORK,INFORM)

C
      IF (NUMVEC.EQ.0) NUMVEC=NUMFOU
C
      IF (INFORM.NE.0.OR.NUMVEC.NE.NUMFOU) THEN
C
          WRITE(NOUTPT,'(//,1X,20(1H/),
     *                      '' ERROR IN DSYEVR, INFORM='',
     *                   I4,1X,20(1H/),/,1X,20(1H/),
     *                      '' ERROR IN DSYEVR, NUMVEC='',
     *                   I4,1X,20(1H/),/,1X,20(1H/),
     *                      '' ERROR IN DSYEVR, NUMFOU='',
     *                   I4,1X,20(1H/),/)')
     *
     *          INFORM,NUMVEC,NUMFOU
C
          STOP ' ERROR IN DSYEVR'
C
      END IF
C
      DO J=1,LDACTU
         DO I=1,LDACTU
            RMATRX(I,J)=EWAVEF(I,J)
         END DO
      END DO
C
      DEALLOCATE (IWORK,ISUPPZ,WORK,EWAVEF)
C
#endif
C
C=======================================================================
C      DIVIDE AND CONQUER DRIVER IN UNPACKED STORAGE
C=======================================================================
C
#if(SWITCH_DIAG==4)
C
C     UNPACK MATRIX. ONLY THE LOWER TRIANGLE NEEDS TO BE FILLED
C
      LWORK=1 + 6*LDACTU + 2*LDACTU**2
      LIWORK=3 + 5*LDACTU
C
      ALLOCATE (WORK(1:LWORK),STAT=IALLOC)
      ALLOCATE (IWORK(1:LIWORK),STAT=IALLOC)
C
      CALL DSYEVD('V','L',LDACTU,RMATRX,NDACTU,EIGVAL,
     *                    WORK, LWORK, IWORK, LIWORK, INFO)
C
      IF (INFO.NE.0) THEN
C
          WRITE(NOUTPT,'(//,1X,20(1H=),
     *                   ''  ERROR IN DSYEVD, INFORM='',
     *                   I4,1X,20(1H=),/,
     *                      1X,79(1H=))')
     *
     *          INFORM
C
          STOP ' ERROR IN DSYEVD'
C
      END IF
C
      DEALLOCATE (IWORK,WORK)
C
#endif
C
C=======================================================================
C
      CALL WS_CPUTIM('DIAGRM',0)
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C=======================================================================
C
      FUNCTION WS_pythag(a,b)
*
*     THE ROUTINE CALCULATES SQRT(A**2+B**2) ACCURATELY
*
      absa=abs(a)
      absb=abs(b)
      if(absa.gt.absb)then
         WS_pythag=absa*sqrt(1+(absb/absa)**2)
      else
         if(absb.eq.0)then
            WS_pythag=0
         else
            WS_pythag=absb*sqrt(1+(absa/absb)**2)
         endif
      endif
*
      end

