C FILE NAME = wsu07_iout_05.f   ! Keep this symbol here: $ident@string$
C
C=======================================================================
C=======================================================================
C=====                                ==================================
C=====    INPUT-OUTPUT ROUTINE SET    ==================================
C=====                                ==================================
C=======================================================================
C=======================================================================
C
      SUBROUTINE WS_NAMELI(IZ_FIX,IN_FIX,NOFOME,OMEGAX,OMEGAY,OMEGAZ,
     *                     OMEGA3,P_ONLY,N_ONLY,FILE_P,FILE_N,SELPAR,
     *                                                        LASTDF)
C=======================================================================
      USE params
C=======================================================================
C
      LOGICAL
     *          WS_DATGUT
C
      COMPLEX
     *          ALSTRT,ALSTEP,ALMINI,ALMAXI,BETBAS
C
      CHARACTER
     *          FILE_P*256,FILE_N*256,FILEDF*256,STRING*256
      CHARACTER
     *          KEYWOR*13,SELPAR*20,SEPARA*80,SEPARB*80
      CHARACTER
     *          NUNITS*3,NUCAVR*7,
     *          N_ONLY*3,P_ONLY*3
C
      COMPLEX
     *          ALPHAC(0:NDLAMB,-NDLAMB:+NDLAMB)
      DIMENSION
     *          DEFTET(1:NDTETR),DEFOKT(1:NDOKTR),
     *          LAMTET(0:NDTETR),LAMOKT(0:NDOKTR)
C
      DIMENSION
     *          OMEGAX(0:NDOMEG),OMEGAY(0:NDOMEG),
     *          OMEGAZ(0:NDOMEG),OMEGA3(0:NDOMEG)
C
C                  Standard Woods-Saxon Parameter Set
C
      COMMON
     *       /NUCLEONIC_NUM/ IZ_ACT,IN_ACT
     *       /NUCLEONIC_UNI/ NUNITS,NUCAVR
      COMMON
     *       /GAUSSINTG_HER/ NXHERM,NYHERM,NZHERM,IOPTGS
     *       /GAUSSINTG_EPS/ EPSHER
     *       /GAUSSINTG_ANG/ NTHPNT,NFIPNT
      COMMON
     *       /PRECISION_EPS/ EPSF_S,EPSG_S,APROAC
     *       /PRECISION_MSH/ MESHTH,ITERNS
      COMMON
     *       /LABELLING_ONN/ LBATES
      COMMON
     *       /WIGNERROT_ANG/ ALFAWG,BETAWG,GAMAWG
     *       /WIGNERROT_IFW/ IFWIGN
     *       /SIGNATURE_FIX/ ISIGNY,IAUTOM
      COMMON
     *       /NOSCILCUT_ENE/ ENECUT,FCHOM0
     *       /NOSCILCUT_NOS/ NOSCIL,NLIMIT,ISOTRO
      COMMON
     *       /PARAMISOS_NEU/ V0DEPN,R0CENN,A0DIFN,S0LSON,R0SORN,A0DISN,
     *                       X0DEPN,X0CENN,X0DIFN,X0LSON,X0SORN,X0DISN,
     *                       Y0DEPN,Y0CENN,Y0DIFN,Y0LSON,Y0SORN,Y0DISN
     *
     *       /PARAMISOS_PRO/ V0DEPP,R0CENP,A0DIFP,S0LSOP,R0SORP,A0DISP,
     *                       X0DEPP,X0CENP,X0DIFP,X0LSOP,X0SORP,X0DISP,
     *                       Y0DEPP,Y0CENP,Y0DIFP,Y0LSOP,Y0SORP,Y0DISP
      COMMON
     *       /COUFACTOR_PRO/ COUFAC
      COMMON
     *       /NAMELI_NOSORB/ NOSORB
      COMMON
     *       /DIRECTPAR_NEU/ VOCENN,ROCENN,AOCENN,XLAMBN,ROSORN,AOSORN
     *       /DIRECTPAR_PRO/ VOCENP,ROCENP,AOCENP,XLAMBP,ROSORP,AOSORP
      COMMON
     *       /YUKAWAPOT_DIF/ DIFYUK,V0SHRP,V0DIFF
     *       /YUKAWAPOT_MOD/ IF_YUK,MODCOU
C
C=======================================================================
C         INPUT-OUTPUT          INPUT-OUTPUT           INPUT-OUTPUT
C=======================================================================
C
      COMMON
     *       /REVIEWING_PAR/ INDCAR,INDNIL,INDSPL,INDSPE,INDDEN,INDDEP,
     *                                                          INDSPI
     *       /REVIEWING_STY/ IOPARS,IODEFS,IOROTS
      COMMON
     *       /LABELLING_WAV/ KARWAV,MAXWAV,NILWAV,IWAVSP
     *       /LABELLING_CNT/ KARTLB,MAXXYZ,NILSLB
     *       /LABELLING_SPH/ LABSPH,LABSPE
      COMMON
     *       /ENERGYCUT_DSK/ INDENE ! Important for long calculations!
      COMMON
     *       /CONTROLIN_ENE/ EMINST,EMAXST,EMINWF,EMAXWF,SPHMAX,EMINCH,
     *                                                          EMAXCH
     *       /CONTROLIN_ARG/ XCUT_P,YCUT_P,ZCUT_P,ARGMIN,ARGMAX
     *       /CONTROLIN_MOD/ MODE_X,MODE_Y,MODE_Z
     *       /CONTROLIN_LIN/ NOFLIN
      COMMON
     *       /PLOSHAPES_IPL/ IPLOP1,IPLOP2,IPLOTH
     *       /PLOSHAPES_PHI/ PHIPL1,PHIPL2
      COMMON
     *       /READWRITE_PAR/ NOUTPT,IWRITE,ISCREN
C
C=======================================================================
C         EXTRA FEATURES       EXTRA FEATURES       EXTRA FEATURES
C=======================================================================
C
      COMMON
     *       /HF_MEAN_FIELD/ KHFPOT
      COMMON
     *       /NUCLEONIC_DEN/ IFDENI,IFDENS,IF_XYZ
     *       /NUCLEONIC_RMX/ R_MAXI
      COMMON
     *       /DELTAFRCE_INT/ IFDELT,LIMLOW,LIMUPP
      COMMON
     *       /MULTIPOLE_LMU/ IFMULT,MAXMUL,NOFLEV,IINDIV,LAMIND,MIUIND
      COMMON
     *       /SPHERICAL_WAV/ IFWAVE
C
C                           Pairing
C
      COMMON
     *       /PAIRIN_SWITCH/ IFPAIR,IFPROJ,IF_HFB,IF_LIP
      COMMON
     *       /PAIRIN_QPNEUT/ NNPPPS(1:NDKONF),NNPPNS(1:NDKONF),
     *                       NNNPPS(1:NDKONF),NNNPNS(1:NDKONF)
      COMMON
     *       /PAIRIN_QPPROT/ NPPPPS(1:NDKONF),NPPPNS(1:NDKONF),
     *                       NPNPPS(1:NDKONF),NPNPNS(1:NDKONF)
      COMMON
     *       /PAIRIN_STRENG/ GFACTN,GFACTP
     *       /PAIRIN_WINDOW/ LEVPUP,LEVPDW,LEVNUP,LEVNDW
     *       /PAIRIN_ITRATI/ ITRNEW
     *       /PAIRIN_ITINNO/ DLZERO,BISTEP,SYSLIM
      COMMON
     *       /PAIRIN_FORPRO/ IFMINV,IFLAMD
      COMMON
     *       /PAIRIN_AVRGDE/ WINDEN,ENSTEP,ISMOTH
      COMMON
     *       /EXTRAS_CHOOSD/ IDELSM,IDELTA
C
C                  Deformations and minimization
C
      COMMON
     *       /MINIMI_RANRAN/ I_RAND,NSTART,LDRAND,I_SEED,IRANDO
     *       /MINIMI_METHOD/ IMETRI,IMTALK
     *       /MINIMI_MINITE/ IDEFCN,ITECHI,IWRIMI
     *       /MINIMI_LOOPIN/ I_LOOP
     *       /MINIMI_TOLENE/ ENECRI
      COMMON
     *       /MINIMI_MINIMI/ STEPMX,TOLFUN,TOLDLX,TOLGRD,
     *                       EPSILO,FRACTI,GRADLM,ITRMAX
      COMMON
     *       /READDF_LAMMAX/ LAMMAX,LMXBAS,LMXDEF,LMXMUL
      COMMON
     *       /HFBASE_DEFORM/ BETBAS(0:NDLAMB,-NDLAMB:NDLAMB)
      COMMON
     *       /DEFMIN_QCNSTR/ STIFFQ(0:NDMULT,-NDMULT:NDMULT),
     *                       QASKED(0:NDMULT,-NDMULT:NDMULT),
     *                       IFLAGQ(0:NDMULT,-NDMULT:NDMULT)
      COMMON
     *       /DEFMIN_STARTS/ ALSTRT(0:NDLAMB,-NDLAMB:+NDLAMB),
     *                       ALSTEP(0:NDLAMB,-NDLAMB:+NDLAMB),
     *                       ALMINI(0:NDLAMB,-NDLAMB:+NDLAMB),
     *                       ALMAXI(0:NDLAMB,-NDLAMB:+NDLAMB)
      COMMON
     *       /DEFMIN_VARIAB/ I_STEP(0:NDLAMB,-NDLAMB:+NDLAMB)
      COMMON
     *       /TETANDOKT_DEF/ IFTETR,IFOKTR
C
C         Cranking Control Paramss    Cranking Control Params
C
      COMMON
     *       /CRANKINGX_NOF/ KRANKX,NOFOMX,ISPINX
     *       /CRANKINGX_OME/ OMEGX0,STEPOX,SPIN_X
      COMMON
     *       /CRANKINGY_NOF/ KRANKY,NOFOMY,ISPINY
     *       /CRANKINGY_OME/ OMEGY0,STEPOY,SPIN_Y
      COMMON
     *       /CRANKINGZ_NOF/ KRANKZ,NOFOMZ,ISPINZ
     *       /CRANKINGZ_OME/ OMEGZ0,STEPOZ,SPIN_Z
      COMMON
     *       /CRANKING3_ANG/ THEANG,PHIANG,KRANK3
C
C                            Deformations
C
      COMMON
     *       /ALPHACMUL_DEF/ ALPHAC
     *       /REALALMUL_DEF/ IREALA
      COMMON
     *       /TETRAHEDR_DEF/ DEFTET
     *       /OKTAHEDRL_DEF/ DEFOKT
C
C         Some filenames & other string contained information
C
      COMMON
     *       /CHOOSEFIL_OUT/ NAMEFI
C
      DATA
     *      N_UNIT / 5 /
C
C=======================================================================
C
C     This is the Series 4 standard input subroutine. It differs
C     from the similar purpose routines  of the preceding series
C     in that the monster-type heading has been replaced by sets
C     of parameters placed in the corresponding common blocks.
C
C     This routine does not read the deformations but rather all
C     the default values of parameters instead.
C
C=======================================================================
C=======================================================================
C=======================================================================
C         M E A N I N G   O F   S O M E   P A R A M E T E R S
C=======================================================================
C=======================================================================
C=======================================================================
C
C         Control of internal accuracies introduced in NAMELI
C
C=======================================================================
C
C            A.  G E O M E T R I C A L  P R O P E R T I E S
C
C=======================================================================
C
C      NTHPNT - The number of integration points for Gauss quadratures
C                         (the first angular variable is called THETA)
C
C      NFIPNT - The number of integration points for Gauss quadratures
C                         (the second angular variable is called  PHI)
C
C               Both these variables have been used to parametrize the
C               geometrical properties of the nucleus, such as surface
C               volume, moments of inertia, mass centres etc.
C
C               All geometrical quantities  requiring integration over
C               the volume or surface  will be obtained by integrating
C               over (at least) theta and phi.
C
C      NTHPNT - The number of the Gauss-Legendre integration points in
C                                                  the theta direction
C
C      NFIPNT - The number of the Gauss-Legendre integration points in
C                                                  the  phi  direction
C
C      MESHTH - In order  to obtain  distances of {x,y,z}-points  from
C               the nuclear surface the relevant routine will look for
C               the starting point. All the starting points are distri-
C               buted on the {theta,phi} sphere.  The THETA steps  are
C               equidistant and there is MESHTH-1 of them. A variation
C               in PHI  is predefined  in a certain dynamical way  and
C               user has no need to influence that
C
C      EPS{F} - The relative accuracy in THETA (for dist. calculation)
C
C      EPS{G} - The relative accuracy in PHI   (for dist. calculation)
C
C      APROAC - If in the dist calculation  the angles approach the PI
C               or 0 ends  of the intervals in which the functions are
C               defined, we force these angles to be
C
C                      'the-end-value  plus or minus  APROAC'
C
C               to avoid singularities when integrating/NEWTON solving
C
C=======================================================================
C
C               B. INTEGRATION ACCURACY IN CARTESIAN SPACE OF (X,Y,Z)
C
C=======================================================================
C
C      NXMAXX - The maximum order of Hermite polynomials in x variable
C
C      NYMAXX - The maximum order of Hermite polynomials in y variable
C
C      NZMAXX - The maximum order of Hermite polynomials in z variable
C
C
C      NXHERM - The number of the Gauss integration points - along the
C                                                          x-direction
C
C      NYHERM - The number of the Gauss integration points - along the
C                                                          y-direction
C
C      NZHERM - The number of the Gauss integration points - along the
C                                                          z-direction
C
C      IOPTGS - An integer; if IOPTGS=1, the program will look for the
C               maximum number  of the shells used, to get the maximum
C               order of  the integrated polynomials. If the values of
C               the parameters  NXHERM, NYHERM and NZHERM  are too low,
C               as compared to 2*N{}MAXX+1,  the program will increase
C               the  N{}HERM parameters according to the Gauss theorem.
C               The program will set:
C
C                         NXHERM = MAX(NXHERM,2*NXMAXX+2)
C                         NYHERM = MAX(NYHERM,2*NYMAXX+2)
C                         NZHERM = MAX(NZHERM,2*NZMAXX+2)
C
C               For the meaning of NXMAXX, NXMAXY and NXMAXZ see above
C
C      EPSHER - Precision parameter  in the calculations  of the Gauss-
C               Hermite weights and nodes. If a difference between the
C               n'th  and the (n+1)'st iterated value of the node will
C               be smaller than EPSHER then the iterations will stop
C
C=======================================================================
C
C               C. The Basis Cut-off and Basis Control Parameters
C
C=======================================================================
C
C      NLIMIT - The number of the harmonic oscillator states taken for
C               the basis. These will be  the lowest states of the har-
C               monic oscillator basis, whose triaxiality  is adjusted
C               to the actual deformation of the potential
C
C      NOSCIL - The number of the harmonic oscillator shells that will
C               be used  when searching for the final basis. The final
C               number of states will either be nearly exactly  NLIMIT
C               or  it will be equal  to the number  of all the states
C               whose energies lie below ENECUT. Here  NOSCIL  denotes
C               the number  of the harmonic oscillator shells  in each
C               of the three directions separately!!!!!!
C
C               If the number of states given by NOSCIL i.e.
C
C               LDOSCI = (NOSCIL+1)*(NOSCIL+2)*(NOSCIL+3)/6
C
C               is smaller than NLIMIT, the program will set
C
C                               NLIMIT = LDOSCI
C
C               NOSCIL must be smaller or equal NDOSCI, whose standard
C               value is 30 (NDOSCI=30). If NOSCIL is given a negative
C               value,  then the basis cut-off  is determined  through
C               the energy limitation, by parameter ENECUT (below).
C
C               A practical advice: KEEP NOSCIL LARGE < 31;  This will
C                                                           never harm
C
C      ENECUT - All  deformed harmonic oscillator levels below  ENECUT
C               will be retained in the basis
C
C      ISOTRO - If equal ISOTRO=1, then the basis will be forced to be
C               isotropic (spherically symmetric oscillator);
C
C=======================================================================
C=======================================================================
C
C      Specification for this particular run:
C
C=======================================================================
C
C      IZ_FIX - definition of the Z-number, for which this calculation
C                                                    will be performed
C      IN_FIX - definition of the N-number, for which this calculation
C                                                    will be performed
C
C      IF_YUK - if equal 1, the potential generated will correspond to
C               the Yukawa folding with the diffuseness constant equal
C                                                            to DIFYUK
C
C      DIFYUK - user-defined diffuseness constant  for optional Yukawa
C                                                              folding
C
C      MODE{} - mode parameters  used  for the auxiliary plots  of the
C               potential  along a straight line  parallel to either X
C               or Y or the Z - axes
C
C      {}CUT0 - Cartesian coordinates  of the point  through which the
C               straight lines mentioned above should pass
C
C      NOFLIN - Number of lines per page in the energy level tables
C
C      IFWIGN - IF EQUAL 1 the frame will be rotated with Euler angles
C                                               ALFAWG, BETAWG, GAMAWG
C
C      LASTDF - IF = 1 continue reading the input for next deformation
C      LASTDF - IF = 0 STOP the program;  the last deformation is done
C
C      LBATES - IF = 1  The harmonic oscillator basis will be transfor-
C                       med  using not only Cartezian, but also cylind-
C                       rical and optionally spherical bases.  In this
C                       case the corresponding labels are also calcula-
C                       ted and the parameter
C
C                                            'IBATES'
C
C                       in dimension declarations  must be set equal 1,
C                       otherwise zero, to save a lot of memory.
C
C=======================================================================
C=======================================================================
C
C      THIS PROGRAM  IS LOGICALLY DIVIDED INTO THE FOLLOWING  SEGMENTS:
C
C                    =================================================
C
C      WS_RUN => MAIN PROGRAM: initiating and calling all other subpgs.
C
C      HAMILT => Defining auxiliary functions necessary to compute the
C                hamiltonian
C
C      INTEGS => Preparing the auxiliary  expressions  and calculating
C                an integral form (matrix elements) of the hamiltonian
C
C      GAUSSI => Subroutine block that prepares the weights  and nodes
C                for the numerical integrations
C
C      LABELS => Subroutine block calculating  all the single particle
C                labels  of the eigenstates  and, optionally, the wave
C                function decompositions in terms of the Cartesian, cy-
C                lindrical and spherical bases
C
C      SYMMTS => Block of subroutines  analysing the symmetries of the
C                nuclear shape and thus those of the mean-field hamiltn.
C
C      MINIMS => Multidimensional minimisation subroutines (pairing)
C
C      DENSIT => Nucleonic density in the space representation
C
C      Qlm    => Block calculating the multipole moments with cranking
C
C      IN-OUT => Input-output subroutine block
C
C      PLOTS  => Auxiliary section the nuclear surface and the related
C                potenials
C
C      TIME   => C.P.U. time routines
C
C=======================================================================
C
      NO_RUN=0
   1  CONTINUE
C
C=======================================================================
C
      READ (N_UNIT,'(A13)',END=3) KEYWOR
c      write(6,'(a)') KEYWOR
C
  10  CONTINUE
C
C=======================================================================
C         Defining the Nucleus and Selecting some Parameters
C=======================================================================
C
      IF (KEYWOR.EQ.'NUCLEONIC-SET') THEN
C
          READ(N_UNIT,*) IZ_FIX,IN_FIX,
     *                   P_ONLY,N_ONLY, ! {}ONLY: YES or  NO
     *                          NUNITS, ! NUNITS: NEW or OLD
     *                          NUCAVR, ! REALVAL or AVERAGE
     *                          SELPAR  ! see: list on input
C
          IZ_ACT=IZ_FIX
          IN_ACT=IN_FIX
C
      END IF
C
C=======================================================================
C         Precision  Conditions  for  the Gauss Integrations
C=======================================================================
C
      IF (KEYWOR.EQ.'GAUSSINTG-HER') THEN  ! Hermite  (x, y, z)
C
          READ(N_UNIT,*) NXHERM,NYHERM,NZHERM,IOPTGS,EPSHER
C
      END IF
C_______________________________________________________________________
C
      IF (KEYWOR.EQ.'GAUSSINTG-ANG') THEN  ! Coulomb: theta&phi
C
          READ(N_UNIT,*) NTHPNT,NFIPNT
C
      END IF
C
C=======================================================================
C         Reading precision parameters of distance equation
C         solving and MESHTH-parameter (THSTEP = PI/MESHTH)
C         The PHI direction  will fixed scanned dynamically
C         (the maximum number of mesh-poinf on the equator).
C         The singularities  at theta/phi=0, pi are avoided
C         by defining the approach limit APROAC.  Iteration
C         limit for the Newton method is ITERNS.
C=======================================================================
C
      IF (KEYWOR.EQ.'PRECISION-MSH') THEN
C
          READ(N_UNIT,*) EPSF_S,EPSG_S,MESHTH,ITERNS,APROAC
C
      END IF
C
C=======================================================================
C         Reading signature-symmetry index (sign. conserved => 1)
C=======================================================================
C
      IF (KEYWOR.EQ.'SIGNATURE-FIX') THEN
C
          READ(N_UNIT,*) ISIGNY,IAUTOM
C
      END IF
C
C=======================================================================
C
C         The harmonic oscillator basis will be transformed
C         using  not only Cartezian,  but also  cylindrical
C         and spherical bases. The corresponding labels are
C         also calculated. In this case the parameter
C
C                          " IBATES "
C
C         in dimension declarations  must be set  equal one
C                 - otherwise zero, to save a lot of memory
C=======================================================================
C
      IF (KEYWOR.EQ.'LABELS-ONN') THEN
C
          READ(N_UNIT,*) LBATES ! It helps controlling the
C                                 use of memory & matrices
      END IF
C
C=======================================================================
C         Reading  the Wigner-Rotation  control  parameters
C=======================================================================
C
      IF (KEYWOR.EQ.'WIGNERROT-ANG') THEN
C
          READ(N_UNIT,*) IFWIGN,ALFAWG,BETAWG,GAMAWG
C
      END IF
C
C=======================================================================
C
C         Oscillator's NOSCIL: hamiltonian matrix dimension
C         using full number of shells is given in principle
C         by
C             LDOSCI = [(NOSCIL+1)*(NOSCIL+2)*(NOSCIL+3)/6]
C
C         NLIMIT - B A S I S   CUT-OFF    P A R A M E T E R
C
C         If NLIMIT is negative then ENECUT defines the cut
C         of the basis; if positive,  total number of basis
C         states will be equal to NLIMIT (if NLIMIT<LDOSCI)
C
C         SUGGESTION: keep NOSCIL large; ~30, will not harm
C
C=======================================================================
C
      IF (KEYWOR.EQ.'NOSCILATO-CUT') THEN
C
          READ(N_UNIT,*) NOSCIL,FCHOM0,NLIMIT,ISOTRO,ENECUT
C
      END IF
C
C=======================================================================
C=======================================================================
C         Reading the Woods-Saxon <=> Dirac-type parameters
C=======================================================================
C=======================================================================
C
C         General:   In the case of the nuclear  mean-field
C         approach there is no reason to define the kinetic
C         potentials like spin-orbit,  linear-momentum  and
C         effective mass  to the central potential geometry.
C         since the latter  originate  from the common term
C         "S-V", while the central potential from "S+V".
C
C         For comparison:  In a traditional parametrisation
C         of the spin-orbit interaction, effective strength
C         is often  proportional  to the central  potential
C         depth - the argument  that is today understood as
C         not quite correct without being totally wrong.
C
C         In this program we define  hamiltonian parameters
C         in the following ways:
C
C         1. Use preselected parameter sets by defining the
C            variable SELPAR*20. It accepts the following:
C
C            UNIVERSAL_DIRAC   <<- new Dirac set = know-how
C
C            UNIVERS_COMPACT   <<- traditional WS - new set
C            UNIV_NONCOMPACT   <<- traditional WS - new set
C
C            UNIVERSAL_PARAM   <<- traditional WS - old set
C
C            CHEPURNOV_PARAM   <<- Chepurnovs - comparisons
C            WAHLBORN_PARAMS   <<- Wahlborn's - comparisons
C            ROST_PARAMETERS   <<- Similar for Rost old set
C
C            INPUT_WITH_ISOS   <<- User defined (see below)
C            INPUT_PARSFIXED   <<- User defined (see below)
C
C
C         2. The general way of defining the parameters is:
C
C            Par = Par0 * [1 + x0 (N-Z)/(N+Z) + y0 / (N+Z)]
C
C            The user defines Par0, x0 and y0; defaults are
C            provided by the default routine.
C
C            To set the option fix:  SELPAR=INPUT_WITH_ISOS
C
C
C         3. The user may provide directly parameter values
C            without using the above expansion.
C
C            To set the option fix:  SELPAR=INPUT_PARSFIXED
C
C         4. Parameters are defined for neutrons  & protons
C            separately (separate read-lines in the program)
C
C=======================================================================
C
      IF (KEYWOR.EQ.'PARAMISOS-NEU') THEN
C
          READ(N_UNIT,*) V0DEPN,R0CENN,A0DIFN,S0LSON,R0SORN,A0DISN
          READ(N_UNIT,*) X0DEPN,X0CENN,X0DIFN,X0LSON,X0SORN,X0DISN
          READ(N_UNIT,*) Y0DEPN,Y0CENN,Y0DIFN,Y0LSON,Y0SORN,Y0DISN
C
      END IF
C
      IF (KEYWOR.EQ.'PARAMISOS-PRO') THEN
C
          READ(N_UNIT,*) V0DEPP,R0CENP,A0DIFP,S0LSOP,R0SORP,A0DISP,
     *                                                      COUFAC
          READ(N_UNIT,*) X0DEPP,X0CENP,X0DIFP,X0LSOP,X0SORP,X0DISP
          READ(N_UNIT,*) Y0DEPP,Y0CENP,Y0DIFP,Y0LSOP,Y0SORP,Y0DISP
C
      END IF
C
      IF (KEYWOR.EQ.'DIRECTPAR-NEU') THEN
C
          READ(N_UNIT,*) VOCENN,ROCENN,AOCENN,XLAMBN,ROSORN,AOSORN
C
      END IF
C
      IF (KEYWOR.EQ.'DIRECTPAR-PRO') THEN
C
          READ(N_UNIT,*) VOCENP,ROCENP,AOCENP,XLAMBP,ROSORP,AOSORP,
     *                                                      COUFAC
      END IF
C
      IF (KEYWOR.EQ.'VANISHSPINORB') THEN
          READ(N_UNIT,*) NOSORB
      END IF
C
      IF (KEYWOR.EQ.'HF_MEAN-FIELD') THEN
          READ(N_UNIT,*) KHFPOT
      END IF
C
C         Reading the Yukawa-Folded and Coulomb-Diffuseness
C
C         The code allows to use the Yukawa-folded shape of
C         the nuclear mean-field potential. To activate set
C         IF_YUK=1 and provide diffuseness and depth params.
C
      IF (KEYWOR.EQ.'YUKAWAPOT-FLD') THEN
C
          READ(N_UNIT,*)   IF_YUK,DIFYUK,V0SHRP,V0DIFF
C
                           MODCOU=1
          IF (IF_YUK.EQ.1) MODCOU=2 ! Sharp + diffusenes
C
      END IF
C
C=======================================================================
C=======================================================================
C         INPUT-OUTPUT        INPUT-OUTPUT         INPUT-OUTPUT
C=======================================================================
C=======================================================================
C
C
C=======================================================================
C          Reading the label/wave-function probing control
C=======================================================================
C
C      KARTLB - IF .EQ.1 => Energies  with the |Nx,Ny,Nz> labels
C                                              will be tabulated
C
C      KARWAV - IF .EQ.1 => A table  of the wave functions  will
C                           be produced with the first 10 states
C                                                     |Nx,Ny,Nz>
C
C      MAXXYZ - IF .EQ.1 => Energies with the maximum content of
C                           the N_x, N_y and N_z quanta  will be
C                                                      tabulated
C
C      MAXWAV - IF .EQ.1 => Table of the wave functions labelled
C                           analogously  to the MAXXYZ-case will
C                                                     be printed
C
      IF (KEYWOR.EQ.'LABELLING-WAV') THEN
C
          READ(N_UNIT,*) KARWAV,MAXWAV,NILWAV,IWAVSP
C
      END IF
C
      IF (KEYWOR.EQ.'LABELLING-CNT') THEN
C
          READ(N_UNIT,*) KARTLB,MAXXYZ,NILSLB
C
      END IF
C
      IF (KEYWOR.EQ.'LABELLING-SPH') THEN
C
          READ(N_UNIT,*) LABSPH,LABSPE
C
      END IF
C
C=======================================================================
C         Choice of the review-type output
C=======================================================================
C
      IF (KEYWOR.EQ.'REVIEWING-STY') THEN
C
          READ(N_UNIT,*) IOPARS,IODEFS,IOROTS
C
      END IF
C
      IF (KEYWOR.EQ.'REVIEWING-PAR') THEN
C
          READ(N_UNIT,*) INDCAR,INDNIL,INDSPL,INDSPE,INDDEN,INDDEP,
     *                                                      INDSPI
C
      END IF
C
C=======================================================================
C         Reading the control parameters for  REVIEW type routines
C=======================================================================
C
C         INDENE - the number  of single-particle eigenvalues, that
C                  will be stored on disc  (more precisely, this no.
C                  is of course equal to MIN(INDENE,LDBASE)
C
C         INDDEP - if .eq. 1, the density is calculated on the user
C                                                      defined mesh
C
C         INDDEN - if .eq. 1, similar to the above but at the Gauss
C                                                       mesh points
C
C         INDSPE - if .eq. 1, spectroscopic spherical labels writen
C                                                           on disc
C
C         INDNIL - if .eq. 1, Nilsson spherical labels kept on disc
C
C         INDCAR - if .eq. 1, Cartesian type labels  stored on disc
C
C=======================================================================
C
      IF (KEYWOR.EQ.'ENERGYCUT-DSK') THEN
C
          READ(N_UNIT,*) INDENE
C
      END IF
C
C=======================================================================
C         Reading the printout control parameters
C=======================================================================
C
      IF (KEYWOR.EQ.'CONTROLIN-PRI') THEN
C
          READ(N_UNIT,*) NOFLIN,EMINST,EMAXST,EMINWF,EMAXWF,SPHMAX,
     *                                               EMINCH,EMAXCH
      END IF
C
C=======================================================================
C         Reading the Woods-Saxon potential-plot parameters
C=======================================================================
C
      IF (KEYWOR.EQ.'CONTROLIN-PLO') THEN
C
          READ(N_UNIT,*) MODE_X,MODE_Y,MODE_Z,XCUT_P,YCUT_P,ZCUT_P
C
      END IF
C
C=======================================================================
C         The argument boundaries for the potential plots
C=======================================================================
C
      IF (KEYWOR.EQ.'CONTROLIN-ARG') THEN
          READ(N_UNIT,*) ARGMIN,ARGMAX
      END IF
C
C=======================================================================
C         The phi-values for plots of the nuclear surface
C=======================================================================
C
      IF (KEYWOR.EQ.'PLOSHAPES-OUT') THEN
C
          READ(N_UNIT,*) IPLOP1,PHIPL1,IPLOP2,PHIPL2,IPLOTH
C
          PINUMB=4.0*ATAN(1.0)
C
          PHIPL1=PINUMB/180.0*PHIPL1
          PHIPL2=PINUMB/180.0*PHIPL2
C
      END IF
C
C=======================================================================
C         READ/WRITE unit
C=======================================================================
C
      IF (KEYWOR.EQ.'READWRITE-PAR') THEN
C
          READ(N_UNIT,*) IWRITE,ISCREN
C
      END IF
C
C=======================================================================
C=======================================================================
C     EXTRA FEATURES      EXTRA FEATURES      EXTRA FEATURES
C=======================================================================
C=======================================================================
C
      IF (KEYWOR.EQ.'NUCLEONIC-DEN') THEN
C
          READ(N_UNIT,*) IFDENI,IFDENS,IF_XYZ,R_MAXI
C
      END IF
C
C=======================================================================
C         Reading the  Woods-Saxon wave-function calc. cntrl.
C=======================================================================
C
      IF (KEYWOR.EQ.'SPHERICAL-WAV') THEN
C
          READ(N_UNIT,*) IFWAVE
C
      END IF
C
C=======================================================================
C         The delta-force directives  (option for new pairng)
C         LIMLOW - the number of levels below the Fermi level
C         LIMUPP - the number of levels above the Fermi level
C=======================================================================
C
      IF (KEYWOR.EQ.'DELTAFRCE-INT') THEN
C
          READ(N_UNIT,*) IFDELT,LIMLOW,LIMUPP   ! The limits
C                                                  positive
      END IF
C
C=======================================================================
C         Special option:   Calculating the multipole moments
C=======================================================================
C
      IF (KEYWOR.EQ.'MULTIPOLE-LMU') THEN
C
          READ(N_UNIT,*) IFMULT,MAXMUL,NOFLEV,IINDIV,LAMIND,MIUIND
C
      END IF
C
C=======================================================================
C      Pairing - Pairing - Pairing - Pairing - Pairing - Pairing
C=======================================================================
C
C               A few numerical control parameter
C
      IF (KEYWOR.EQ.'SWITCH_PAI_ON') THEN
          READ (*,*) IFPAIR,IFPROJ,IF_HFB,IF_LIP
      END IF
C
      IF (KEYWOR.EQ.'CHOOSE_DELTAS') THEN
          READ(*,*) IDELSM,IDELTA
      END IF
C
      IF (KEYWOR.EQ.'PAIRINGPNPVAR') THEN
          READ (*,*) IFMINV,IFLAMD
      END IF
C
      IF (KEYWOR.EQ.'AVERAGEDENSIT') THEN
          READ (*,*) WINDEN,ENSTEP,ISMOTH
      END IF
C
      IF (KEYWOR.EQ.'NUMERICALITER') THEN
          READ(*,*) ITRNEW,BISTEP,SYSLIM
      END IF
C
      IF (KEYWOR.EQ.'PAIRINWINDOWS') THEN
          READ(*,*) GFACTN,GFACTP,LEVPUP,LEVPDW,LEVNUP,LEVNDW
      END IF
C
      IF (KEYWOR.EQ.'QUASIPARTICLE') THEN
          READ(*,*) NPPPPS(1),NPPPNS(1),NNPPPS(1),NNPPNS(1)
      END IF
C
C=======================================================================
C=======================================================================
C         Some filenames & other string contained information
C=======================================================================
C=======================================================================
C
C
C=======================================================================
C         Write or not to write: that is the question.  Also:
C         defining  the deformation file  (can be the same as
C         the one for the routine NAMELI)
C=======================================================================
C
      IF (KEYWOR.EQ.'DEFORMATN-INP') THEN
C
          READ(N_UNIT,*) FILEDF
C
      END IF
C
C=======================================================================
C         Selecting the   n a m e  generated by the program if
C         NAMEFI=1. In such a case the filename of the results
C         will automatically contain the information about the
C         nucleus  and the first values  of the quadrupole and
C         hexadecapole deformations
C=======================================================================
C
      IF (KEYWOR.EQ.'CHOOSEFIL-OUT') THEN
C
          READ(N_UNIT,*) NAMEFI
          READ(N_UNIT,*) STRING
          READ(N_UNIT,*) FILE_P
          READ(N_UNIT,*) STRING
          READ(N_UNIT,*) FILE_N
C
      END IF
C
C=======================================================================
C=======================================================================
C         Cranking Control Parameters  Cranking Control Parameters
C=======================================================================
C=======================================================================
C
C=======================================================================
C         Reading the cranking parameters => x-axis cranking
C=======================================================================
C
      IF (KEYWOR.EQ.'CRANKINGX-PAR') THEN
C
          READ(N_UNIT,*) KRANKX,OMEGX0,STEPOX,NOFOMX,SPIN_X,ISPINX
C
          IF (KRANKX.EQ.1) THEN
C
              IF (IOROTS.EQ.0) THEN
C
                  WRITE(NOUTPT,'(/,80(''!''),/,''!'',T80,''!'',/,
     *                  ''!   For x-cranking applications you should'',
     *                  '' set IOROTS=1; it has been cleared   !'',/,
     *                  ''!'',T80,''!'',/,80(''!''),/)')
C
                  IOROTS=1
                  IODEFS=0
                  IOPARS=0
C
              END IF
C
              NOFOME=NOFOMX
C
              DO I=1,NOFOMX
                 OMEGAX(I)=OMEGX0+(I-1)*STEPOX
              END DO
C
          END IF
C
      END IF
C
C=======================================================================
C         Reading the cranking parameters => y-axis cranking
C=======================================================================
C
      IF (KEYWOR.EQ.'CRANKINGY-PAR') THEN
C
          READ(N_UNIT,*) KRANKY,OMEGY0,STEPOY,NOFOMY,SPIN_Y,ISPINY
C
          IF (KRANKY.EQ.1) THEN
C
              IF (IOROTS.EQ.0) THEN
C
                  WRITE(NOUTPT,'(/,80(''!''),/,''!'',T80,''!'',/,
     *                  ''!   For y-cranking applications you should'',
     *                  '' set IOROTS=1; it has been cleared   !'',/,
     *                  ''!'',T80,''!'',/,80(''!''),/)')
C
                  IOROTS=1
                  IODEFS=0
                  IOPARS=0
C
              END IF
C
              NOFOME=NOFOMY
C
              DO I=1,NOFOMY
                 OMEGAY(I)=OMEGY0+(I-1)*STEPOY
              END DO
C
          END IF
C
      END IF
C
C=======================================================================
C         Reading the cranking parameters => z-axis cranking
C=======================================================================
C
      IF (KEYWOR.EQ.'CRANKINGZ-PAR') THEN
C
          READ(N_UNIT,*) KRANKZ,OMEGZ0,STEPOZ,NOFOMZ,SPIN_Z,ISPINZ
C
          IF (KRANKZ.EQ.1) THEN
C
              IF (IOROTS.EQ.0) THEN
C
                  WRITE(NOUTPT,'(/,80(''!''),/,''!'',T80,''!'',/,
     *                  ''!   For z-cranking applications you should'',
     *                  '' set IOROTS=1; it has been cleared   !'',/,
     *                  ''!'',T80,''!'',/,80(''!''),/)')
C
                  IOROTS=1
                  IODEFS=0
                  IOPARS=0
C
              END IF
C
              NOFOME=NOFOMZ
C
              DO I=1,NOFOMZ
                 OMEGAZ(I)=OMEGZ0+(I-1)*STEPOZ
              END DO
C
          END IF
C
      END IF
C
C=======================================================================
C         Reading the cranking parameters => 3D-axis cranking
C=======================================================================
C
      IF (KEYWOR.EQ.'CRANKING3-PAR') THEN
C
C         Reading the cranking parameters => z-axis cranking
C
          READ (N_UNIT,*) KRANK3,THEANG,PHIANG,OMEMIN,STEP3D,NOFOM3
C         WRITE(6,*) KRANK3,THEANG,PHIANG,OMEMIN,OMESTP,NOFOME
C
          JRANK3=KRANK3
C
          IF (KRANK3.EQ.1) THEN
C
              NOFOME=NOFOM3
C
              DO I=1,NOFOM3
                 OMEGA3(I)=OMEMIN+(I-1)*STEP3D
              END DO
C
          END IF
C
      END IF
C
C=======================================================================
C             MINIMISATION    MINIMISATION    MINIMISATION
C=======================================================================
C
C      Reading the general control parameters of minimsation
C
      IF (KEYWOR.EQ.'MINIM_PREDEFS') THEN
          READ (*,*) IMETRI,IMTALK,GRADLM,I_RAND,NSTART,LDRAND,
     *                                           I_SEED,I_LOOP

      END IF
C
C      Reading the tolerance parameters for the minimisation
C
      IF (KEYWOR.EQ.'MINIM_CONTROL') THEN
          READ (*,*) ITECHI,ITRMAX,STEPMX,TOLFUN,TOLDLX,TOLGRD,
     *                                           EPSILO,FRACTI
      END IF
C
C      Reading the tolerance parameters for the minimisation
C
      IF (KEYWOR.EQ.'MINIM_ENECONT') THEN
          READ (*,*) ENECRI
      END IF
C
C=======================================================================
C         Reading the deformation section of the input
C=======================================================================
C
      IF (KEYWOR.EQ.'READ_MULTCONS') THEN
C
 1002     READ(*,*) LAMBDA,MIU,STIFFQ(ABS(LAMBDA),MIU),
     *                         QASKED(ABS(LAMBDA),MIU),
     *                         IFLAGQ(ABS(LAMBDA),MIU)
C
          IF (ABS(LAMBDA).GT.NDMULT.OR.LAMBDA.EQ.0.OR.
     *                        ABS(MIU).GT.ABS(LAMBDA))
     *
     *        STOP ' STIFFQ INDICES OUT OF RANGE IN NAMELI'
C
          IF (LAMBDA.LT.0) GO TO 1002
C
          LMXMUL=0
C
          DO LAMBDA=0,NDMULT
             DO MIU=0,LAMBDA
                IF (IFLAGQ(LAMBDA,MIU).EQ.1) LMXMUL=LAMBDA
             END DO
          END DO
C
      END IF
C
C=======================================================================
C
C       READING DEFORMATIONS:
C          - DEFORMATIONS OF THE NUCLEAR SURFACE USED IN THE
C            MINIMIZATION ('READ_DEFORMAT')
C          - DEFORMATION OF THE BASIS ('READ_DEFBASIS')
C          - DEFORMATION OF THE NUCLEAR SURFACE FOR BASIC WSODD
C            CALCULATIONS ('READINGDF-MUL')
C
C=======================================================================
C
C      Reading the deformation section of the input
C
      IF (KEYWOR.EQ.'READ_DEFORMAT') THEN
C
C         We loop looking for the first data card with deformation.
C         We skip empty lines and anything what is not a valid
C         deformation data card.
C
   24     CONTINUE
          READ (N_UNIT,'(A)',END=3) SEPARB
C
          CALL WS_STRIPS(SEPARB,LENGTH)
C
          IF (LENGTH.EQ.0) GO TO 24
C
          IF (.NOT.WS_DATGUT(SEPARB(1:LENGTH))) GO TO 24
C
   25     CONTINUE
C
          READ (SEPARB,*) LAMBDA,MIU,ALSTRT(LAMBDA,MIU),
     *                               ALSTEP(LAMBDA,MIU),
     *                               I_STEP(LAMBDA,MIU)
C
C         We loop reading next cards. As before, we skip empty
C         lines. If a line is not empty and is  n o t  a valid
C         deformation data card, then we assume it belongs to the
C         next section. Therefore, afterwards we will have
C         read the first card from the next section, so we
C         go to 10 with KEYWOR already read in. We avoid
C         BACKSPACE'ing because the data is read from stdin
C         which normally does not support push-back operation!
C
   26     CONTINUE
C
          READ (N_UNIT,'(A)',END=3) SEPARB
C
          CALL WS_STRIPS(SEPARB,LENGTH)
C
          IF (LENGTH.EQ.0) GO TO 26
C
          IF (WS_DATGUT(SEPARB(1:LENGTH))) GO TO 25
C
          READ (SEPARB,'(A13)') KEYWOR
C
          LMXDEF=0
          LAMAX1=0
          LAMAX2=0
C
          DO LAMBDA=0,NDLAMB
             DO MIU=0,LAMBDA
                IF (I_STEP(LAMBDA,MIU).EQ.1) LAMAX1=LAMBDA
             END DO
          END DO
C
          DO LAMBDA=0,NDLAMB
             DO MIU=0,LAMBDA
                IF (ABS(ALSTRT(LAMBDA,MIU)).GT.1.E-10) LAMAX2=LAMBDA
             END DO
          END DO
C
	  LMXDEF=MAX(LAMAX1,LAMAX2)
C
          IF (LMXDEF.GT.NDLAMB) STOP 'LMXDEF.GT.NDLAMB in NAMELI (1) '
C
	  DO LAMBDA=0,LMXDEF
	     DO MIU=1,LAMBDA
	        I_STEP(LAMBDA,-MIU)=I_STEP(LAMBDA,MIU)
		ALSTEP(LAMBDA,-MIU)=ALSTEP(LAMBDA,MIU)
	     END DO
	  END DO
C
          GO TO 10
C
      END IF
C
C=======================================================================
C         Reading the deformation section of the input
C=======================================================================
C
      IF (KEYWOR.EQ.'READ_DEFBASIS') THEN
C
	  DO LAMBDA=0,NDLAMB
	     DO MIU=-NDLAMB,NDLAMB
	        BETBAS(LAMBDA,MIU)=CMPLX(0.0,0.0)
	     END DO
	  END DO
C
  14      CONTINUE
C
C          We read the next row in the data
C
          READ(N_UNIT,'(A)',END=3) STRING
C
C          ... get rid if the blanks
C
          CALL WS_STRIPS(STRING,LENGTH)
C
C          ... reloop if there is nothing at all
C
          IF (LENGTH.EQ.0) GO TO 14
C
C          ... or if the row does not correspond to proper data
C
          IF (.NOT.WS_DATGUT(STRING(1:LENGTH))) GO TO 14
C
C          In case we have proper data, we read them
C
   15     CONTINUE
C
          READ (STRING,*) LAMBDA,MIU,BETBAS(LAMBDA,MIU)
C
C          ... and the whole procedure starts again
C
   16     CONTINUE
C
          READ (*,'(A)',END=3) STRING
C
          CALL WS_STRIPS(STRING,LENGTH)
C
          IF (LENGTH.EQ.0) GO TO 16
C
          IF (WS_DATGUT(STRING(1:LENGTH))) GO TO 15
C
C          Right here, we have exhausted the possible deformations as
C          well as any blank space, so we should read the next keyword
C
          READ (STRING,'(A13)') KEYWOR
C
	  LMXBAS=0
C
	  DO LAMBDA=0,NDLAMB
	     DO MIU=-NDLAMB,NDLAMB
	        IF (ABS(BETBAS(LAMBDA,MIU)).GE.1.E-10) LMXBAS=LAMBDA
	     END DO
	  END DO
C
          GO TO 10
C
      END IF
C
C=======================================================================
C         Reading the deformation section of the input
C=======================================================================
C
      IF (KEYWOR.EQ.'READINGDF-MUL') THEN
C
	  DO LAMBDA=0,NDLAMB
	     DO MIU=-NDLAMB,NDLAMB
	        ALPHAC(LAMBDA,MIU)=CMPLX(0.0,0.0)
	     END DO
	  END DO
C
   4      CONTINUE
C
C          We read the next row in the data
C
          READ(N_UNIT,'(A)',END=3) STRING
C
C          ... get rid if the blanks
C
          CALL WS_STRIPS(STRING,LENGTH)
C
C          ... reloop if there is nothing at all
C
          IF (LENGTH.EQ.0) GO TO 4
C
C          ... or if the row does not correspond to proper data
C
          IF (.NOT.WS_DATGUT(STRING(1:LENGTH))) GO TO 4
C
C          In case we have proper data, we read them
C
    5     CONTINUE
C
          READ (STRING,*) LAMBDA,MIU,ALPHAC(LAMBDA,MIU)
C
C          ... and the whole procedure starts again
C
    6     CONTINUE
C
          READ (*,'(A)',END=3) STRING
C
          CALL WS_STRIPS(STRING,LENGTH)
C
          IF (LENGTH.EQ.0) GO TO 6
C
          IF (WS_DATGUT(STRING(1:LENGTH))) GO TO 5
C
C          Right here, we have exhausted the possible deformations as
C          well as any blank space, so we should read the next keyword
C
          READ (STRING,'(A13)') KEYWOR
C
          LMXDEF=0
C
          DO LAMBDA=0,NDLAMB
             DO MIU=0,LAMBDA
                IF (ABS(ALPHAC(LAMBDA,MIU)).GT.1.E-10) LMXDEF=LAMBDA
             END DO
          END DO
C
          IF (LMXDEF.GT.NDLAMB) STOP 'LMXDEF > NDLAMB in READDF - '
C
          GO TO 10
C
      END IF
C
C=======================================================================
C         Beta/Gamma  variant  of the quadrupole  deformation
C=======================================================================
C
      IF (KEYWOR.EQ.'BETAGAMMA-INP') THEN
C
          PINUMB=4.0*ATAN(1.0)
C
          READ(N_UNIT,'(A)',END=3) STRING
          READ(STRING,*) BETADF,GAMADF
C
          GAMARD=GAMADF/180.*PINUMB
          ALFA20=BETADF*COS(GAMARD)
          ALFA22=BETADF*SIN(GAMARD)/SQRT(2.)
          ALPHAC(2,0)=CMPLX(ALFA20,0.0)
          ALPHAC(2,2)=CMPLX(ALFA22,0.0)
C
          IF (LAMMAX.LT.2) LAMMAX=2
C
      END IF
C
C=======================================================================
C         Optional reading of the tetrahedral deformations
C=======================================================================
C
      IF (KEYWOR.EQ.'READINGDF-TET') THEN
C
          READ(N_UNIT,*) IFTETR
C
          IF (IFTETR.LT.0.OR.IFTETR.GT.4) THEN
              WRITE(NOUTPT,'(''IFTETR='',I2,'' is incorrect'')')
     *                         IFTETR
              STOP 'IFTETR < 1 or IFTETR > 4 in NAMELI - '
          END IF
C
          READ(N_UNIT,*) STRING
C
          DO I=1,IFTETR
             READ(N_UNIT,*) LAMTET(I),DEFTET(I)
             IF (LAMTET(I).GT.NDLAMB)
     *           STOP 'LAMTET(I).GT.NDLAMB <<= '
          END DO
C
          CALL WS_TETINV(ALPHAC,NDLAMB,DEFTET,NDTETR,IFTETR)
C
      END IF
C
C=======================================================================
C         Optional reading of the octahedral deformations
C=======================================================================
C
      IF (KEYWOR.EQ.'READINGDF-OCT') THEN
C
          READ(N_UNIT,*) IFOKTR
C
          IF (IFOKTR.LT.0.OR.IFOKTR.GT.4) THEN
              WRITE(NOUTPT,'(''IFOKTR='',I2,'' is incorrect'')')
     *                         IFOKTR
              STOP 'IFOKTR < 1 or IFOKTR > 4 in NAMELI - '
          END IF
C
          READ(N_UNIT,*) STRING
C
          DO I=1,IFOKTR
             READ(N_UNIT,*) LAMOKT(I),DEFOKT(I)
             IF (LAMOKT(I).GT.NDLAMB)
     *           STOP 'LAMOKT(I).GT.NDLAMB <<= '
          END DO
C
          CALL WS_OKTINV(ALPHAC,NDLAMB,DEFOKT,NDOKTR,IFOKTR)
C
      END IF
C
C=======================================================================
C         Optional reading of the octahedral deformations
C=======================================================================
C
      IF (KEYWOR.EQ.'LAST-DEFORMAT') THEN
          READ(N_UNIT,*) LASTDF
      END IF
C
C=======================================================================
C         READY TO RUN ?
C=======================================================================
C
      IF (KEYWOR.EQ.'EXECUTESET-GO') THEN
C
          NO_RUN=NO_RUN+1
C
          RETURN
C
      ELSE
C
          GO TO 1  !  Scanning continues ...
C
      END IF
C
C=======================================================================
C     Forgotten 'EXECUTESET' statement ? ? ?
C=======================================================================
C
      WRITE(NOUTPT,'(//,''Something wrong with the structure '',
     *                  ''of the input '',
     *                  ''file - perhaps forgotten <EXECUTESET> ?'')')
C
      STOP 'No "EXECUTESET" in the input data stream in NAMELI <<= '
C
C=======================================================================
C
   3  CONTINUE
C
C=======================================================================
C
      STOP
     *
     *'Wrong input structure, <EOF> not allowed here; from NAMELI <<= '
C
      END
C
C=======================================================================
C=======================================================================
C
      SUBROUTINE WS_DEFPRI(MAXLAM,IZ_FIX,IN_FIX)
C=======================================================================
      USE params
C=======================================================================
C
      CHARACTER
     *          PRIMOM(0:NDLAMB)*15
      COMPLEX
     *          ALPHAC(0:NDLAMB,-NDLAMB:+NDLAMB)
C
      DIMENSION
     *          ALPHAR(0:NDLAMB,0:NDLAMB)
C
      COMMON
     *       /TETRAHEDR_DEF/ TETDEF(1:NDTETR)
     *       /OKTAHEDRL_DEF/ DEFOKT(1:NDOKTR)
      COMMON
     *       /ALPHACMUL_DEF/ ALPHAC
     *       /REALALMUL_DEF/ IREALA
      COMMON
     *       /TETANDOKT_DEF/ IFTETR,
     *                       IFOKTR
C
      COMMON
     *       /READWRITE_PAR/ NOUTPT,IWRITE,ISCREN
C
C=======================================================================
C     This subroutine prints the deformation parameters in the
C     nuclear surface formula, as defined  in terms of  ALPHAC
C     through READDF routine
C=======================================================================
C
      IF (IWRITE.EQ.0) RETURN
C
C=======================================================================
C
      IF (IREALA.EQ.1) THEN
C
          DO LAMBDA=0,MAXLAM
             DO MIU=0,LAMBDA
                ALPHAR(LAMBDA,MIU)=REAL(ALPHAC(LAMBDA,MIU))
             END DO
          END DO
C
      ELSE
C
          WRITE(NOUTPT,'(/,''Subroutine DEFPRI is not prepared '',
     *                '' to display complex ALPHA deformations'')')
C
          STOP 'IREALA.NE.1 in DEFPRI <<= '
C
      END IF
C
C=======================================================================
C
      WRITE(NOUTPT,'(//,80(''#''),/,                 ''#'',78X,''#'',/,
     *             ''#'',2X,''Classical Nuclear Surface defined for:'',
     *             20X,''N ='',I3,3X,''Z ='',I3,            3X,''#'',/,
     *                                   ''#'',78X,''#'',/,80(''#''))')
     *
     *                                                    IN_FIX,IZ_FIX
C
      DO MIU=0,NDLAMB
         PRIMOM(MIU)='  .............'
      END DO
C
      DO LAMBDA=1,MIN(MAXLAM,NDLAMB)
C
         DO MIU=0,LAMBDA
C
            IF (ABS(ALPHAR(LAMBDA,MIU)).LT.1.0E-10) THEN
C
                WRITE(PRIMOM(MIU),'(''  AL'',2I1,'' ='',3X,''ZERO'')')
     *                                                     LAMBDA,MIU
            ELSE
C
               IF (ABS(ALPHAR(LAMBDA,MIU)).LT.1.0E-3) THEN
C
                   WRITE(PRIMOM(MIU),'(''  AL'',2I1,'' ='',1PE7.0)')
     *                          LAMBDA,MIU,ALPHAR(LAMBDA,MIU)
               ELSE
C
                   WRITE(PRIMOM(MIU),'(''  AL'',2I1,'' ='',F7.3)')
     *                          LAMBDA,MIU,ALPHAR(LAMBDA,MIU)
               END IF
C
            END IF
C
            IF (PRIMOM(MIU)(11:12).EQ.' .') PRIMOM(MIU)(11:12)='0.'
C
         END DO
C
         IF (IFTETR.EQ.0.AND.IFOKTR.EQ.0)
     *
     *   WRITE(NOUTPT,'(''#'',78X,''#'',/,''#'',5A15,3X,''#'')')
     *                                             (PRIMOM(MIU),MIU=0,4)
C
         IF (IFTETR.GE.1.AND.LAMBDA.EQ.3) THEN
C
             WRITE(NOUTPT,'(''#'',78X,''#'',/,
     *                      ''#  TETR ='',F7.4,63X,''#'',/,
     *                      ''#'',5A15,3X,''#'',/,''#'',78X,''#'')')
     *                                              TETDEF(1),
     *                                             (PRIMOM(MIU),MIU=0,4)
C
         END IF
C
         IF (IFTETR.GE.2.AND.LAMBDA.EQ.7) THEN
C
             WRITE(NOUTPT,'(''#  TETR ='',F7.4,63X,''#'',/,
     *                      ''#'',5A15,3X,''#'')')  TETDEF(2),
     *                                             (PRIMOM(MIU),MIU=0,4)
             WRITE(NOUTPT,'(''#'',        30X,3A15,3X,''#'')')
     *                                             (PRIMOM(MIU),MIU=5,7)
C
         END IF
C
         IF (IFTETR.GE.3.AND.LAMBDA.EQ.9) THEN
C
             WRITE(NOUTPT,'(''#  TETR ='',F7.4,63X,''#'',/,
     *                      ''#'',5A15,3X,''#'')')  TETDEF(3),
     *                                             (PRIMOM(MIU),MIU=0,4)
             WRITE(NOUTPT,'(''#'',          5A15,3X,''#'')')
     *                                             (PRIMOM(MIU),MIU=5,9)
C
         END IF
C
C        IF (IFTETR.EQ.4.AND.LAMBDA.EQ.11) THEN
C
C            WRITE(NOUTPT,'(''#  TETR ='',F7.4,63X,''#'',/,
C    *                      ''#'',5A15,3X,''#'')')  TETDEF(4),
C    *                                             (PRIMOM(MIU),MIU=0,4)
C
C        END IF
C
         IF (IFOKTR.GE.1.AND.LAMBDA.EQ.4) THEN
C
             WRITE(NOUTPT,'(''#'',78X,''#'',/,
     *                      ''#  OKTR ='',F7.4,63X,''#'',/,
     *                      ''#'',5A15,3X,''#'',/,''#'',78X,''#'')')
     *                                              DEFOKT(1),
     *                                             (PRIMOM(MIU),MIU=0,4)
C
         END IF
C
         IF (IFOKTR.GE.2.AND.LAMBDA.EQ.6) THEN
C
             WRITE(NOUTPT,'(''#  OKTR ='',F7.4,63X,''#'',/,
     *                      ''#'',5A15,3X,''#'')')  DEFOKT(2),
     *                                             (PRIMOM(MIU),MIU=0,4)
             WRITE(NOUTPT,'(''#'',        45X,2A15,3X,''#'')')
     *                                             (PRIMOM(MIU),MIU=5,6)
C
         END IF
C
         IF (IFOKTR.GE.3.AND.LAMBDA.EQ.8) THEN
C
             WRITE(NOUTPT,'(''#  OKTR ='',F7.4,63X,''#'',/,
     *                      ''#'',5A15,3X,''#'')')  DEFOKT(3),
     *                                             (PRIMOM(MIU),MIU=0,4)
             WRITE(NOUTPT,'(''#'',       15X,4A15,3X,''#'')')
     *                                             (PRIMOM(MIU),MIU=5,8)
C
         END IF
C
C        IF (IFOKTR.EQ.4.AND.LAMBDA.EQ.10) THEN
C
C            WRITE(NOUTPT,'(''#  OKTR ='',F7.4,63X,''#'',/,
C    *                      ''#'',5A15,3X,''#'')')  DEFOKT(4),
C    *                                             (PRIMOM(MIU),MIU=0,4)
C
C        END IF
C
         IF (LAMBDA.EQ.5.AND.IFOKTR.EQ.0.AND.IFTETR.EQ.0)
     *   WRITE(NOUTPT,'(''#'',           60X,A15,3X,''#'')')
     *                                             (PRIMOM(MIU),MIU=5,5)
C
         IF (LAMBDA.EQ.6.AND.IFOKTR.EQ.0.AND.IFTETR.EQ.0)
     *   WRITE(NOUTPT,'(''#'',           45X,2A15,3X,''#'')')
     *                                             (PRIMOM(MIU),MIU=5,6)
C
         IF (LAMBDA.EQ.7.AND.IFOKTR.EQ.0.AND.IFTETR.EQ.0)
     *   WRITE(NOUTPT,'(''#'',           30X,3A15,3X,''#'')')
     *                                             (PRIMOM(MIU),MIU=5,7)
C
         IF (LAMBDA.EQ.8.AND.IFOKTR.EQ.0.AND.IFTETR.EQ.0)
     *   WRITE(NOUTPT,'(''#'',           15X,4A15,3X,''#'')')
     *                                             (PRIMOM(MIU),MIU=5,8)
C
         IF (LAMBDA.EQ.9.AND.IFOKTR.EQ.0.AND.IFTETR.EQ.0)
     *   WRITE(NOUTPT,'(''#'',               5A15,3X,''#'')')
     *                                             (PRIMOM(MIU),MIU=5,9)
C
      END DO
C
C=======================================================================
C
      IF (MAXLAM.EQ.0) THEN
C
          WRITE(NOUTPT,'(''#'',78X,''#'',/,
     *              ''#'',2X,''Spherical Shape requested for '',
     *                     ''the surface'',35X,''#'')')
C
      END IF
C
      WRITE(NOUTPT,'(''#'',78X,''#'',/,80(''#''))')
C
C=======================================================================
C
      IF (ABS(ALPHAR(2,0)).GT.1.0E-14) THEN
C
          BETA_D=SQRT(ALPHAR(2,0)**2+2.0*ALPHAR(2,2)**2)
          GAMA_D=ATAN(SQRT(2.)*ALPHAR(2,+2)/ALPHAR(2,0))
C
          PINUMB=4.0*ATAN(1.0)
C
          GAMA_D=GAMA_D/PINUMB*180.
C
          WRITE(NOUTPT,'(''#                                        '',
     *                   ''                                  o   #'',/,
     *                   ''#  The quadrupole deformation in terms '',
     *                   ''of Bohr: BETA_D='',F7.4,''  GAMA_D ='',I4,
     *                   ''   #'',/,''#'',78X,''#'',/,80(''#''))')
     *
     *                                            BETA_D,INT(GAMA_D)
C
      END IF
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C=======================================================================
C
      SUBROUTINE WS_NAMFIL(NAMEFI,IZ_FIX,IN_FIX,FILE_P,FILE_N,ALPHAC,
     *                                                        NDLAMB)
      CHARACTER
     *          FILE_P*256,FILE_N*256,TDEFO2*5,TDEFO4*4,AUXTXT*5
      COMPLEX
     *          ALPHAC(0:NDLAMB,-NDLAMB:+NDLAMB)
C
      COMMON
     *       /REVIEWING_STY/ IOPARS,IODEFS,IOROTS
C
C=======================================================================
C
C       This subroutine defines the standard result file names for
C       the binary version of the output  (where possibly the wave
C       functions are recorded)  and the two review files  for the
C       proton and neutron routhians, one file name per isospin.
C
C       A. NAMEFI .NE.1 => No modification of the file names which
C                          are supposed  to be read from the input
C
C       B. NAMEFI .EQ.1 => File names  will be defined,  as in the
C                          first  deformation of the input  stream,
C                          the names having the following form:
C
C          BINARY OUTPUT:  WSO_Z066_N086_Q1.225_HP.08.DAT,  and/or
C                          WSO_Z066_N086_Q0.711_HM.01.DAT,
C
C                          Q stands for quadrupole  (ALPHA20)  and
C                          H stands for hexadecapole (ALPHA40) def.
C
C          ROUTHIANS:      WSP_Z066_N086_Q1.225_HP.08.DAT,  and/or
C                          WSN_Z066_N086_Q0.711_HM.01.DAT,     for,
C                          proton and neutron result files.
C
C=======================================================================
C
                       AUXTXT='.xxxx'
      IF (IOPARS.EQ.1) AUXTXT='.pars'
      IF (IODEFS.EQ.1) AUXTXT='.defs'
      IF (IOROTS.EQ.1) AUXTXT='.rots'
C
      IF (NAMEFI.EQ.1) THEN
C
          DEFOR2=REAL(ALPHAC(2,0))
          DEFOR4=REAL(ALPHAC(4,0))
C
          IF (DEFOR2.LT.1.0) THEN
              WRITE(TDEFO2,'(''0'',F4.3)') DEFOR2
          ELSE
              WRITE(TDEFO2,'(      F5.3)') DEFOR2
          END IF
C
          IF (DEFOR4.LE.0.0) THEN
              WRITE(TDEFO4,'(''m'',F3.2)') ABS(DEFOR4)
          ELSE
              WRITE(TDEFO4,'(''p'',F3.2)') ABS(DEFOR4)
          END IF
C
          WRITE(FILE_P,'(''wsp_z'',I3.3,''_n'',I3.3,''_q'',A5,
     *                                          ''_h'',A4,A5)')
     *
     *                      IZ_FIX,IN_FIX,TDEFO2,TDEFO4,AUXTXT
C
          WRITE(FILE_N,'(''wsn_z'',I3.3,''_n'',I3.3,''_q'',A5,
     *                                          ''_h'',A4,A5)')
     *
     *                      IZ_FIX,IN_FIX,TDEFO2,TDEFO4,AUXTXT
C
      END IF
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C=======================================================================
C
      SUBROUTINE WS_OPENFI(IZ_FIX,IN_FIX,ISOSPI,FILE_P,FILE_N)
      CHARACTER
     *          FILE_P*256,FILE_N*256,FIOPEN*256,STRAUX*256
C
      COMMON
     *       /OPENFI_UNITSN/ NUPROT,NUNEUT,NUTABP,NUTABN
      COMMON
     *       /READWRITE_PAR/ NOUTPT,IWRITE,ISCREN
C
C=======================================================================
C
C     This routine opens the necessary output files according to
C     the following principles:
C
C     1. There is only one generic name for all the output files
C        associated with this run;
C
C     2. Various output files have names composed of the  prefix
C        that defines the nucleus (see an example below) and the
C        extension created explicitly by the present routine:
C
C                WS_Z066_N110.p.extension{i}
C        or
C
C                WS_Z066_N110.n.extension{i}
C
C        for protons and neutrons respectively.
C
C     3. This subroutine provides extensions according to actual
C        content of the file.
C
C     4. WSUNIV program  may provide files  that belong to three
C        cathegories:
C
C        a Result files  associated  with the parameters  of the
C          hamiltonian. In this case  deformation  is considered
C          fixed as for e.g. the spherical shapes
C
C        b Result files associated to static deformation effects
C
C        c Result files  corresponding to  cranking applications
C          of the code
C
C        d Result files with the tabulated potentials
C
C     5. Extensions used: Case a -> .pars
C                         Case b -> .defs
C                         Case c -> .rots
C                         Case d -> .tabs
C
C     6. For the extensive calculation   s e r i e s  it is more
C        convenient to run a project if the program knows how to
C        distinguish  among consecutive-run files  automatically.
C        A corresponing option is also provided.
C
C     7. Consecutive runs, corresponding to modifications of the
C        potential parameters, generate one result-file  per run
C        per kind of particles.
C
C     8. Consecutive runs of various deformations will similarly
C        produce one file per job per kind of particles.
C
C     9. Convention for the unit numbers:
C
C        UNIT=21  protons (.pars, .defs, .rots)
C        UNIT=22 neutrons (.pars, .defs, .rots)
C
C        UNIT=15 =>> scratch  file  for the 'usual' output
C        UNIT=16 =>> permanent file for the error messages
C
C        UNIT=25  protons (tables of the potentials, .tabs)
C        UNIT=26 neutrons (tables of the potentials, .tabs)
C
C=======================================================================
C     Defining the unit numbers:
C=======================================================================
C
      NUPROT=21      ! Protons  => .pars, .defs, .rots
      NUNEUT=22      ! Neutrons => .pars, .defs, .rots
C
      NUTABP=25      ! Tables, potentials for the  protons
      NUTABN=26      ! Tables, potentials for the neutrons
C
C=======================================================================
C
      DO I=1,256
         FIOPEN(I:I)=' '
      END DO
C
      IF (ISOSPI.EQ.0) THEN
C
          CALL WS_STRLNG(FILE_N,LENGTH,STRAUX)
C
          N_UNIT=NUNEUT
          FIOPEN(1:LENGTH)=FILE_N(1:LENGTH)
C
      END IF
C
      IF (ISOSPI.EQ.1) THEN
C
          CALL WS_STRLNG(FILE_P,LENGTH,STRAUX)
C
          N_UNIT=NUPROT
          FIOPEN(1:LENGTH)=FILE_P(1:LENGTH)
C
      END IF
C
      CALL WS_NAMEIT(FIOPEN)
C
      IF (IWRITE.GE.1) THEN
C
          OPEN(N_UNIT,FILE=FIOPEN(1:8+LENGTH),STATUS='UNKNOWN',
     *                                        FORM='FORMATTED',ERR=10)
C
          RETURN
C
   10     CONTINUE
C
          STOP 'Error in opening file - wsu07_iout_05.f/WS_OPENFI'
C
      END IF
C
      END
C
C=======================================================================
C=======================================================================
C
      SUBROUTINE WS_NAMEIT(STRING)
      CHARACTER
     *          DIRECT*256,FILENM*256,STRING*256
C
      COMMON
     *       /READWRITE_PAR/ NOUTPT,IWRITE,ISCREN
C
      DATA
     *     LENGTH / 256 /
C
C=======================================================================
C
      DO I=1,LENGTH
         DIRECT(I:I)=' '
         FILENM(I:I)=' '
      END DO
C
C      Determining the length of the name of the directory
C
      NSLASH=0
      NPOSIT=0
C
      DO I=1,LENGTH
         IF (STRING(I:I).EQ.'/') THEN
             NSLASH=NSLASH+1
             NPOSIT=I
         END IF
      END DO
C
C      Determining the actual length of the file-name
C
      LENACT=0
                            LOWERL=1
      IF (NSLASH.GT.LOWERL) LOWERL=NSLASH
C
      DO I=LOWERL,LENGTH
         IF (STRING(I:I).EQ.' ') THEN
             LENACT=I-1
             GO TO 1
         END IF
      END DO
C
   1  CONTINUE
C
      IF (LENACT.EQ.0) THEN
C
          WRITE(NOUTPT,'(/,80(''!''),/,''!'',78X,''!'',/,
     *                 ''! ATTEMPT TO OPEN A PERMANENT FILE WITH '',
     *                 ''NO NAME GIVEN =>> STOP BY THE PROGRAM  !'',/,
     *                 ''!'',78X,''!'',/,80(''!''))')
C
          STOP 'NULL NAME in NAMEIT <<= '
C
      END IF
C
C=======================================================================
C
C=======================================================================
C
      IF (IWRITE.GT.2) THEN
C
          WRITE(NOUTPT,'(//,80(''!''),/,''!'',78X,''!'')')
C
          IF (NSLASH.EQ.0) THEN
C
              WRITE(NOUTPT,'(''! The output file of the name given '',
     *              ''below will be put in the current directory  !'',/,
     *              ''!'',78X,''!'')')
C
              K=0
              DO I=1,LENACT
                 K=K+1
                 FILENM(K:K)=STRING(I:I)
              END DO
C
              CALL WS_SECTNG(FILENM)
C
              WRITE(NOUTPT,'(''!'',78X,''!'',/,80(''!''),/)')
C
          ELSE
C
              WRITE(NOUTPT,'(''! The output file with the name '',
     *              ''defined below will be put in the directory:'',
     *                                                  T80,''!'')')
              DO I=NPOSIT+1,75
                 DIRECT(I:I)='.'
              END DO
              DO I=1,NPOSIT
                 DIRECT(I:I)=STRING(I:I)
              END DO
C
              CALL WS_SECTNG(DIRECT)
C
              K=0
              DO I=NPOSIT+1,LENACT
                 K=K+1
                 FILENM(K:K)=STRING(I:I)
              END DO
C
              WRITE(NOUTPT,'(''!'',78X,''!'',/,
     *             ''! The file-name used is:              '',
     *             ''                                         !'')')
C
              CALL WS_SECTNG(FILENM)
C
              WRITE(NOUTPT,'(''!'',78X,''!'',/,80(''!''),/)')
C
          END IF
C
      END IF
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C=======================================================================
C
      SUBROUTINE WS_SECTNG(STRING)
      CHARACTER
     *          STRING*(*)
      CHARACTER
     *          S_LINE*75
C
      COMMON
     *       /READWRITE_PAR/ NOUTPT,IWRITE,ISCREN
C
      DATA
     *     LENGTH / 256 /
      DATA
     *     LINLEN /  75 /
C
C=======================================================================
C     This is an auxiliary output routine that prints a string cut
C     into pieces of the length  LINLEN,  adapted to the 80 column
C                                                           output
C=======================================================================
C
      LENACT=0
      DO I=1,LENGTH
         IF (STRING(I:I).EQ.' ') THEN
             LENACT=I-1
             GO TO 1
         END IF
      END DO
C
C=======================================================================
C
   1  CONTINUE
C
                                   NO_ADD=0
      IF (MOD(LENACT,LINLEN).NE.0) NO_ADD=1
C
      NOLINE=LENACT/LINLEN+NO_ADD
C
      WRITE(NOUTPT,'(''!'',78X,''!'')')
C
      DO I=1,NOLINE
C
         DO J=1,LINLEN
            S_LINE(J:J)=' '
         END DO
C
         DO J=1,LINLEN
            K=J+(I-1)*LINLEN
            S_LINE(J:J)=STRING(K:K)
         END DO
C
         WRITE(NOUTPT,'(''!'',1X,A75,2X,''!'')') S_LINE
C
      END DO
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C=======================================================================
C
      SUBROUTINE WS_STRLNG(STRING,LENGTH,STRAUX)
C=======================================================================
      USE params
C=======================================================================
      CHARACTER
     *          STRING*256,BLANCK*1
      CHARACTER
     *          STRAUX*256
      DATA
     *     BLANCK / ' ' /
C
C=======================================================================
C     This subroutine gives the length of a string "STRING"
C     counting all non-blank characters
C=======================================================================
C
      LENGTH=0
C
      DO I=1,NDLNGT
         IF (STRING(I:I).NE.BLANCK) THEN
             LENGTH=LENGTH+1
         END IF
      END DO
C
      DO I=1,NDX256
         STRAUX(I:I)='.'
      END DO
C
      DO I=1,MIN(LENGTH,NDX256)
         STRAUX(I:I)=STRING(I:I)
      END DO
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C=======================================================================
C
      SUBROUTINE WS_SUMARY
      COMMON
     *       /NOSCILCUT_NOS/ NOSCIL,NLIMIT,ISOTRO
     *       /SIGNATURE_FIX/ ISIGNY,IAUTOM
     *       /WIGNERROT_IFW/ IFWIGN
     *       /YUKAWAPOT_MOD/ IF_YUK,MODCOU
      COMMON
     *       /LABELLING_WAV/ KARWAV,MAXWAV,NILWAV,IWAVSP
     *       /LABELLING_CNT/ KARTLB,MAXXYZ,NILSLB
     *       /LABELLING_SPH/ LABSPH,LABSPE
      COMMON
     *       /CRANKINGX_NOF/ KRANKX,NOFOMX,ISPINX
     *       /CRANKINGY_NOF/ KRANKY,NOFOMY,ISPINY
     *       /CRANKINGZ_NOF/ KRANKZ,NOFOMZ,ISPINZ
      COMMON
     *       /MULTIPOLE_LMU/ IFMULT,MAXMUL,NOFLEV,IINDIV,LAMIND,MIUIND
      COMMON
     *       /GAUSSINTG_HER/ NXHERM,NYHERM,NZHERM,IOPTGS
     *       /GAUSSINTG_ANG/ NTHPNT,NFIPNT
     *       /LABELLING_ONN/ LBATES
     *       /READDF_LAMMAX/ LAMMAX,LMXBAS,LMXDEF,LMXMUL
      COMMON
     *       /CONTROLIN_ENE/ EMINST,EMAXST,EMINWF,EMAXWF,SPHMAX,EMINCH,
     *                                                          EMAXCH
     *       /CONTROLIN_LIN/ NOFLIN
C
      COMMON
     *       /READWRITE_PAR/ NOUTPT,IWRITE,ISCREN
C
C=======================================================================
C
      IF (IWRITE.LT.2) RETURN
C
C=======================================================================
C
      WRITE(NOUTPT,'(/,80(''#''),/,''#'',78X,''#'',/,
     *                 ''#  Summary Table of the WSUNIV Options  '',
     *                 ''  (0 - option OFF) / (1 - option ON)   #'',/,
     *                 ''#'',78X,''#'',/,80(''#''),/,''#'',78X,''#'',/,
     *                 ''#  ISOTRO='',I1,''     ISIGNY='',I1,
     *                 ''     IAUTOM='',I1,''     IFWIGN='',I1,
     *                 ''     IF_YUK='',I1,''     MODCOU='',I1,
     *                 ''   #'',/,
     *                 ''#  KARTLB='',I1,''     NILSLB='',I1,
     *                 ''     LABSPH='',I1,''     KARWAV='',I1,
     *                 ''     NILWAV='',I1,''     IWAVSP='',I1,
     *                 ''   #'',/,
     *                 ''#  KRANKX='',I1,''     KRANKY='',I1,
     *                 ''     KRANKZ='',I1,''     IFMULT='',I1,
     *                 ''     MAXXYZ='',I1,''     MAXWAV='',I1,
     *                 ''   #'',/,''#'',78X,''#'',/,80(''#''))')
     *
     *                 ISOTRO,ISIGNY,IAUTOM,IFWIGN,IF_YUK,MODCOU,
     *                 KARTLB,NILSLB,LABSPH,KARWAV,NILWAV,IWAVSP,
     *                 KRANKX,KRANKY,KRANKZ,IFMULT,MAXXYZ,MAXWAV
C
C=======================================================================
C
      WRITE(NOUTPT,'(/,80(''#''),/,''#'',78X,''#'',/,
     *                 ''#            Summary Table of the WSUNIV '',
     *                 ''Precision Defining Parameters         #'',/,
     *                 ''#'',78X,''#'',/,80(''#''),/,''#'',78X,''#'',/,
     *                 ''#  LBATES='',I2,''    NOSCIL='',I2,
     *                 ''   NLIMIT='',I5,''  IOPTGS='',I1,
     *                 ''     NTHPNT='',I2,''    NFIPNT='',I2,
     *                 ''  #'',/,
     *                 ''#  LAMMAX='',I2,
     *                 ''                              NXHERM='',I2,
     *                 ''    NYHERM='',I2,''    NZHERM='',I2,''  #'',/,
     *                 ''#'',78X,''#'',/,80(''#''))')
     *
     *                 LBATES,NOSCIL,NLIMIT,IOPTGS,NTHPNT,NFIPNT,
     *                               LAMMAX,NXHERM,NYHERM,NZHERM
C
C=======================================================================
C
      WRITE(NOUTPT,'(/,80(''#''),/,''#'',78X,''#'',/,
     *                 ''#              Summary Table of the WSUNIV '',
     *                 ''Output Defining Parameters          #'',/,
     *                 ''#'',78X,''#'',/,80(''#''),/,''#'',78X,''#'',/,
     *                 ''#  NOFLIN='',I2,
     *                 ''    EMINST   EMAXST    EMINWF   EMAXWF'',
     *                 ''   SPHMAX   EMINCH   EMAXCH  #'',/,
     *                 ''#            '',2F9.3,3X,F7.3,2X,F7.3,F9.2,
     *                 2F9.3,''  #'',/,''#'',78X,''#'',/,80(''#''))')
     *
     *                 NOFLIN,EMINST,EMAXST,EMINWF,EMAXWF,SPHMAX,
     *                                                    EMINCH,
     *                                                    EMAXCH
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C=======================================================================
C
      SUBROUTINE WS_WRIBIN(IZ_FIX,IN_FIX,FCHOM0,R0PARM,HOMEGA,
     *                                   EPSHER,ENECUT,CVOLFC,
     *                                   CMSXFC,CMSYFC,CMSZFC,
     *                                   XMOMFC,YMOMFC,ZMOMFC,
     *                                   BASEX2,BASEY2,BASEZ2,
     *                                   ALPHAC,IREALA,LDBASE,
     *                                                 FILWOO)
C=======================================================================
      USE params
C=======================================================================
C
      COMPLEX
     *          WAVEWS
C
      CHARACTER
     *          NAMEPN(0:NDISOS)*8
      CHARACTER
     *          FILWOO*68
C
      COMPLEX
     *          BETBAS
      COMPLEX
     *          ALPHAC(0:NDLAMB,-NDLAMB:+NDLAMB)
C
      COMMON
     *       /HFBASE_DEFORM/ BETBAS(0:NDLAMB,-NDLAMB:NDLAMB)
      COMMON
     *       /READDF_LAMMAX/ LAMMAX,LMXBAS,LMXDEF,LMXMUL
      COMMON
     *       /NOSCILCUT_NOS/ NOSCIL,NLIMIT,ISOTRO
      COMMON
     *       /GAUSSINTG_HER/ NXHERM,NYHERM,NZHERM,IOPTGS
     *       /GAUSSINTG_ANG/ NTHPNT,NFIPNT
      COMMON
     *       /SETBAS_NXNYNZ/ NXVECT(1:NDBASE),
     *                       NYVECT(1:NDBASE),
     *                       NZVECT(1:NDBASE)
      COMMON
     *       /SETBAS_HOMOSC/ HBAROX,HBAROY,HBAROZ,
     *                       SQXFAC,SQYFAC,SQZFAC,
     *                                     HOMOSC
     *
     *       /SETBAS_CENMAS/ XCMPOS,YCMPOS,ZCMPOS
      COMMON
     *       /SPECTR_PRONEU/ ESINPP(1:NDBASE),ESINPN(1:NDBASE)
     *
     *       /SPECTR_ALL_WF/ WAVEWS(1:NDBASE,1:NDBASE,0:NDISOS)
      COMMON
     *       /EXTRAS_FERMIS/ EFERMN,EFERMP
     *       /EXTRAS_PSTRNG/ GPAIRN,GPAIRP
      COMMON
     *       /PAIRIN_ALLGAP/ DELTAN,DELTAP
C
      DATA
     *     NAMEPN /'NEUTRONS',' PROTONS'/
C
C=======================================================================
C
      NFIWOO=89
C
      OPEN(NFIWOO,FILE=FILWOO,STATUS='UNKNOWN',FORM='UNFORMATTED')
C
      IPARAM=0
      NROTAT=0
      IARRAY=1
C
      WRITE(NFIWOO)IZ_FIX,IN_FIX,LAMMAX,
     *          ((BETBAS(L,M),M=-L,+L),L=0,LAMMAX),
     *          ((ALPHAC(L,M),M=-L,+L),L=0,LAMMAX),
     *            NOSCIL,IPARAM,NROTAT,
     *            NXHERM,NYHERM,NZHERM,NTHPNT,NFIPNT,
     *            NLIMIT,HBAROX,HBAROY,HBAROZ,HOMEGA,FCHOM0,
     *            CMSXFC,CMSYFC,CMSZFC,XMOMFC,YMOMFC,ZMOMFC,
     *            BASEX2,BASEY2,BASEZ2,CVOLFC,R0PARM,ENECUT,
     *            IARRAY,LDBASE,ISOTRO,EPSHER,
     *            EFERMN,EFERMP,GPAIRN,GPAIRP,DELTAN,DELTAP

C
      IF (LDBASE.GT.NDBASE) THEN
          WRITE(6,'(//,''LDBASE='',I6,'' EXCEEEDS NDBASE='',I6)')
     *                   LDBASE,NDBASE
          STOP 'LDBASE.GT.NDBASE'
      END IF
C
      DO L=0,LAMMAX
         DO M=-L,L
            IF (ABS(AIMAG(ALPHAC(L,M))).GT.1.0D-10) THEN
                STOP 'COMPLEX DEFORMATION IN WRIBIN'
            END IF
         END DO
      END DO
C
      IREALA=1
C
      WRITE(NFIWOO)(ESINPN(I),I=1,LDBASE)
      WRITE(NFIWOO)(ESINPP(I),I=1,LDBASE)
C
      IF (IARRAY.EQ.1) THEN
          WRITE(NFIWOO) (((WAVEWS(I,J,ISOSPI),I=1,LDBASE),
     *                                        J=1,LDBASE),
     *                                   ISOSPI=0,NDISOS)
          WRITE(NFIWOO)(NXVECT(I),NYVECT(I),NZVECT(I),I=1,LDBASE)
      END IF
C
      CLOSE(NFIWOO)
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C=======================================================================
C
      SUBROUTINE WS_REVIDN(ALPHAC,IREALA,EPSHER,EPSF_S,EPSG_S,HOMEGA,
     *                     NXMAXX,NYMAXX,NZMAXX,CMSXFC,CMSYFC,CMSZFC,
     *                     XMOMFC,YMOMFC,ZMOMFC,BASEX2,BASEY2,BASEZ2,
     *                     CVOLFC,R0PARM,LDBASE,IZ_FIX,IN_FIX,ENECUT,
     *                            SELPAR,FCHOM0,VERSIO,ISOSPI,IFWAVE)
C=======================================================================
      USE params
C=======================================================================
C
      COMPLEX
     *          ALPHAC(0:NDLAMB,-NDLAMB:+NDLAMB)
C
      CHARACTER
     *          VERSIO*5,SELPAR*20
C
      COMMON
     *       /OPENFI_UNITSN/ NUPROT,NUNEUT,NUTABP,NUTABN
      COMMON
     *       /REVIEWING_PAR/ INDCAR,INDNIL,INDSPL,INDSPE,INDDEN,INDDEP,
     *                                                          INDSPI
      COMMON
     *       /ENERGYCUT_DSK/ INDENE
      COMMON
     *       /PARNAM_POTPAR/ ROCENT,AOCENT,VOCENT,R_CENT,
     *                       ROSORB,AOSORB,VOSORB,R_SORB
      COMMON
     *       /SETBAS_HOMOSC/ HBAROX,HBAROY,HBAROZ,
     *                       SQXFAC,SQYFAC,SQZFAC,
     *                                     HOMOSC
     *
     *       /SETBAS_CENMAS/ XCMPOS,YCMPOS,ZCMPOS
     *
     *       /SETBAS_NOSMAX/ MAXBNX,MAXBNY,MAXBNZ,
     *                                     NOSMAX
     *
     *       /SETBAS_SCALNG/ HOMSCA(1:NDKART)
      COMMON
     *       /PUT_MM_SPNUMS/ NUMBSP(0:NDREVE)
      COMMON
     *       /READDF_LAMMAX/ LAMMAX,LMXBAS,LMXDEF,LMXMUL
      COMMON
     *       /TETRAHEDR_DEF/ DEFTET(1:NDTETR)
     *       /OKTAHEDRL_DEF/ DEFOKT(1:NDOKTR)
      COMMON
     *       /TETANDOKT_DEF/ IFTETR,IFOKTR
C
      COMMON
     *       /NOSCILCUT_NOS/ NOSCIL,NLIMIT,ISOTRO
     *       /SIGNATURE_FIX/ ISIGNY,IAUTOM
     *       /WIGNERROT_IFW/ IFWIGN
     *       /YUKAWAPOT_MOD/ IF_YUK,MODCOU
      COMMON
     *       /LABELLING_WAV/ KARWAV,MAXWAV,NILWAV,IWAVSP
     *       /LABELLING_CNT/ KARTLB,MAXXYZ,NILSLB
     *       /LABELLING_SPH/ LABSPH,LABSPE
      COMMON
     *       /CRANKINGX_NOF/ KRANKX,NOFOMX,ISPINX
     *       /CRANKINGY_NOF/ KRANKY,NOFOMY,ISPINY
     *       /CRANKINGZ_NOF/ KRANKZ,NOFOMZ,ISPINZ
      COMMON
     *       /MULTIPOLE_LMU/ IFMULT,MAXMUL,NOFLEV,IINDIV,LAMIND,MIUIND
      COMMON
     *       /GAUSSINTG_HER/ NXHERM,NYHERM,NZHERM,IOPTGS
     *       /GAUSSINTG_ANG/ NTHPNT,NFIPNT
     *       /LABELLING_ONN/ LBATES
      COMMON
     *       /CONTROLIN_ENE/ EMINST,EMAXST,EMINWF,EMAXWF,SPHMAX,EMINCH,
     *                                                          EMAXCH
     *       /CONTROLIN_LIN/ NOFLIN
      COMMON
     *       /NUCLEONIC_DEN/ IFDENI,IFDENS,IF_XYZ
      COMMON
     *       /DELTAFRCE_INT/ IFDELT,LIMLOW,LIMUPP
C
      COMMON
     *       /READWRITE_PAR/ NOUTPT,IWRITE,ISCREN
C
      DATA
     *     IVEREV  / 4 /
C
C=======================================================================
C     REVIDN  (Review Identification ->> Series 's2' & follow-up)
C=======================================================================
C
C     Starting from this version we are introducing a possibility
C     of a modular construction of the disk output.  The user has
C     the means of controlling a completeness and/or compacteness
C     of the output by properly defining a few output control in-
C     dices. These are:
C
C     INDNIL =>>> If 1,  Nilsson type cylindrical labels are kept
C     INDSPL =>>> If 1,  Nilsson-type  spherical  labels are kept
C     INDSPE =>>> If 1,  spectroscopic spherical  labels are kept
C     INDSPI =>>> If 1,  cranking spin alignements  (s=1/2)  kept
C     INDDEN =>>> If 1,  the density total spatial representation
C                        is recorded (the three dimensional mesh)
C
C=======================================================================
C
C     This subroutine  writes on disk  the ensemble of parameters
C     that characterize  either the hamiltonian or the conditions
C     for running the algorithm: precision parameters, those that
C     define the basis etc.  By calling this routine once per run
C     the user will identify uniquely such a run.
C
C     When running a series of data sets  it is advisable to call
C     this routine   e a c h   t i m e  in the  s t a t i c  mode
C     since then  either the parameters of the hamiltonian or the
C     deformations vary.  In the case of cranking it is more prac-
C     tical to call this routine once per omega series.
C
C=======================================================================
C
      HOMEGA=41.0*FCHOM0/REAL(IZ_FIX+IN_FIX)**(1.0/3.0)
C
      LAMLIM=MAX(2,LAMMAX)
C
                       N_UNIT=NUPROT
      IF (ISOSPI.EQ.0) N_UNIT=NUNEUT
C
C=======================================================================
C     Writing the results into the REVIEW file
C=======================================================================
C
      WRITE(N_UNIT,'(26(1H>),''                    '',3X,5X,26(1H<))')
C
      WRITE(N_UNIT,'(26(1H>),''   REVIEW VERSION = '',I3,5X,26(1H<))')
     *
     *      IVEREV
C
      WRITE(N_UNIT,'(26(1H>),''   CODE   VERSION = '',A5,3X,26(1H<))')
     *
     *      VERSIO
C
      WRITE(N_UNIT,'(26(1H>),''                    '',3X,5X,26(1H<))')
C
      WRITE(N_UNIT,'('' '')')
C
C=======================================================================
C     Identifying the nucleus and its hamiltonian size(s)
C=======================================================================
C
C     IFWAVE - if .eq. 1,  calculating the space representation
C                                         of the wave-functions
C
C     INDENE - the number  of single-particle eigenvalues, that
C              will be stroed on disc  (more precisely, this no.
C              is of course equal to MIN(INDENE, LDBASE)
C
C     INDDEP - if .eq. 1, the density is calculated on the user
C                                                  defined mesh
C
C     INDDEN - if .eq. 1, similar to the above but at the Gauss
C                                                   mesh points
C
C     INDSPE - if .eq. 1, spectroscopic spherical labels writen
C                                                       on disc
C
C     INDNIL - if .eq. 1, Nilsson spherical labels kept on disc
C
C     INDCAR - if .eq. 1, Cartesian type labels  stored on disc
C
C     NUMBSP - gives  the splitting of LDBASE  into two 'IREVER'
C                                                        blocks
C
C=======================================================================
C
      WRITE(N_UNIT,'(''WHO_IS: IZ_FIX IN_FIX ISOSPI LDBASE '',
     *                       ''NUMBS0 NUMBS1 INDCAR INDNIL INDSPL '',
     *                       ''INDSPE INDDEN INDDEP INDENE INDSPI'')')
C
      WRITE(N_UNIT,'(5X,16I7)') IZ_FIX,IN_FIX,ISOSPI,LDBASE,
     *                                               NUMBSP(0),
     *                                               NUMBSP(1),
     *                          INDCAR,INDNIL,INDSPL,INDSPE,
     *                          INDDEN,INDDEP,INDENE,INDSPI
C
C=======================================================================
C     Stretching factors needed always as pepper and salt
C=======================================================================
C
      WRITE(N_UNIT,'(''HOMSCA:'')')
C
      WRITE(N_UNIT,'(5X,3(1PE18.10))') (HOMSCA(KARTEZ),KARTEZ=1,NDKART)
C
C=======================================================================
C
      WRITE(N_UNIT,'(''SELPAR:'')')
C
      WRITE(N_UNIT,'(8X,A20)') SELPAR
C
C=======================================================================
C
      WRITE(N_UNIT,'(''WSPARS:     Ro         ADIFF       Vo'',
     *                                        T44,''c/so    '')')
C
      WRITE(N_UNIT,'(2(5X,3F12.6,/))') ROCENT,AOCENT,VOCENT,
     *                                 ROSORB,AOSORB,VOSORB
C
C=======================================================================
C     Identifying the deformation (or sphericity)
C=======================================================================
C
      WRITE(N_UNIT,'(''ALPHAC: LAMLIM LAMMAX IREALA'')')
C
      WRITE(N_UNIT,'(5X,3I7)') LAMLIM,LAMMAX,IREALA
C
      IF (IREALA.EQ.1) THEN
C
          WRITE(N_UNIT,'(''        LAMBDA   MIU   ALPHA'')')
C
          DO L=0,LAMLIM
             DO M=-L,+L
                IF (ABS(ALPHAC(L,M)).LT.1.0E-10) THEN
                    WRITE(N_UNIT,'(6X,2I6,F10.6)') L,M,REAL(ALPHAC(L,M))
                ELSE
                    WRITE(N_UNIT,'(6X,2I6,F10.6,''  <<=='')')
     *                                             L,M,REAL(ALPHAC(L,M))
                END IF
             END DO
          END DO
C
      ELSE
C
          WRITE(N_UNIT,'(''     LAMBDA MIU  ReALPHA  ImALPHA'')')
C
          DO L=0,LAMLIM
             DO M=-L,+L
                WRITE(N_UNIT,'(6X,2I6,2F10.6)') L,M,REAL(ALPHAC(L,M)),
     *                                              IMAG(ALPHAC(L,M))
             END DO
          END DO
C
      END IF
C
C=======================================================================
C     Identifying the special symmetry deformations: tetrahedral
C                                                  or oktahedral
C=======================================================================
C
      WRITE(N_UNIT,'(''DEFTET: IFTETR'')')
C
      WRITE(N_UNIT,'(5X,I7)') IFTETR
C
      IF (IFTETR.GT.0) THEN
C
          WRITE(N_UNIT,'(''        ORDTET        DEFORM'')')
C
          DO LDTETR=1,IFTETR
             WRITE(N_UNIT,'(6X,I6,6X,F10.6)') LDTETR,DEFTET(LDTETR)
          END DO
C
      END IF
C
      WRITE(N_UNIT,'(''DEFOKT: IFOKTR'')')
C
      WRITE(N_UNIT,'(5X,I7)') IFOKTR
C
      IF (IFOKTR.GT.0) THEN
C
          WRITE(N_UNIT,'(''        ORDOKT        DEFORM'')')
C
          DO LDOKTR=1,IFOKTR
             WRITE(N_UNIT,'(6X,I6,6X,F10.6)') LDTETR,DEFOKT(LDOKTR)
          END DO
C
      END IF
C
C=======================================================================
C
      IKL=0
      IREVIE=0
      IPARAM=0
C
      WRITE(N_UNIT,'(''HOW_IS'')')
      WRITE(N_UNIT,'(3(5X,15I5,/))')
     *
     *               ISOTRO,ISIGNY,IAUTOM,IFWIGN,IF_YUK,IREVIE,
     *               KARTLB,NILSLB,LABSPH,KARWAV,NILWAV,IWAVSP,
     *               IFDENI,IKL   ,IFDENS,IFDELT,IF_XYZ,
     *               KRANKX,KRANKY,KRANKZ,IFMULT,MAXXYZ,MAXWAV,
     *               IPARAM,NOSCIL,NLIMIT,IOPTGS,NTHPNT,NFIPNT,
     *               LAMMAX,NXHERM,NYHERM,NZHERM,NOFLIN,
     *                      NXMAXX,NYMAXX,NZMAXX,LDBASE,IREALA
C
      WRITE(N_UNIT,'(''PRECIS'')')
      WRITE(N_UNIT,'(3(5X,6F14.8,/),5X,3E14.6)')
     *
     *               HBAROX,HBAROY,HBAROZ,HOMEGA,FCHOM0,R0PARM,
     *               CMSXFC,CMSYFC,CMSZFC,XMOMFC,YMOMFC,ZMOMFC,
     *               BASEX2,BASEY2,BASEZ2,CVOLFC,ENECUT,HOMOSC,
     *                                    EPSHER,EPSF_S,EPSG_S
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C=======================================================================
C
      SUBROUTINE WS_REVPAR(IFWIGN,IZ_FIX,IN_FIX,KRANKX,KRANKY,KRANKZ,
     *                     ENECUT,NXHERM,NYHERM,NZHERM,ISOSPI,MAXMUL,
     *                            IF_XYZ,IFMULT,IREVER,IFDELT,IFWAVE)
C=======================================================================
      USE params
C=======================================================================
C
      CHARACTER
     *          LBSPHE*6
C
      COMMON
     *       /OPENFI_UNITSN/ NUPROT,NUNEUT,NUTABP,NUTABN
      COMMON
     *       /REVIEWING_PAR/ INDCAR,INDNIL,INDSPL,INDSPE,INDDEN,INDDEP,
     *                                                          INDSPI
      COMMON
     *       /ENERGYCUT_DSK/ INDENE
C
      COMMON
     *       /MOMETS_MULMOM/ QMOMUL(0:NDMULT,-NDMULT:NDMULT,0:NDISOS)
      COMMON
     *       /DENSSP_DENFIN/ DENSIT(1:NDXDEN,1:NDYDEN,1:NDZDEN),
     *                       DENNOD(1:NDXHRM,1:NDYHRM,1:NDZHRM)
     *       /DENSSP_FERMIS/ XYZPNS(1:NDDENS,1:NDKART)
      COMMON
     *       /WAVEFU_RADPRO/ DISPRO(1:NDBASE,1:NDMESH),RADPRO(1:NDMESH)
     *       /WAVEFU_LDRADI/ LDRADI
      COMMON
     *       /WSEXEC_INTSTO/ HERWGT(1:NDGAUS,1:NDKART),
     *                       HERPNT(1:NDGAUS,1:NDKART)
C
C=======================================================================
C             Densities at cuts from DENINT and the rms radii
C=======================================================================
C
      COMMON
     *       /DENINT_RADINT/ RMSINT,R2XINT,R2YINT,R2ZINT
     *       /DENINT_RADRAD/ RMSTRU,RMSPHE
      COMMON
     *       /RMSCUT_RADCUT/ RMLIKE,R2XCUT,R2YCUT,R2ZCUT
     *
     *       /RMSCUT_DENXYZ/ DENSIX(1:NDXDEN),
     *                       DENSIY(1:NDYDEN),
     *                       DENSIZ(1:NDZDEN)
C
C=======================================================================
C             Matrix elements of the delta-type-interactions
C=======================================================================
C
      COMMON
     *       /DELTJK_DELTME/ BRAKET(1:NDELEM,1:NDELEM)
     *
     *       /DELTJK_DELTDA/ IDELIL,IDELFI,IDELLA
C
C=======================================================================
C             Numerical values composing  labels: Cartesian,
C             spherical-Nilsson   and   cylindrical-Nilsson
C=======================================================================
C
      COMMON
     *       /SPECTR_ESINGP/ ESINGP(1:NDBASE),PARITY(1:NDBASE)
      COMMON
     *       /LBKARR_BASCAR/ NXCART(1:NDBASE,0:NDREVE),
     *                       NYCART(1:NDBASE,0:NDREVE),
     *                       NZCART(1:NDBASE,0:NDREVE)
     *       /LBKARR_QUOCAR/ QUOTCA(1:NDBASE,0:NDREVE)
      COMMON
     *       /SPHONL_SPHERE/ MAIN0S(1:NDBASE,0:NDREVE),
     *                       JMOM0S(1:NDBASE,0:NDREVE),
     *                       LSPH0S(1:NDBASE,0:NDREVE),
     *                       MMOM0S(1:NDBASE,0:NDREVE)
     *       /SPHONL_QUOSPH/ QUOTSP(1:NDBASE,0:NDREVE)
      COMMON
     *       /CYLONL_CYLIND/ MAINNL(1:NDBASE,0:NDREVE),
     *                       NZNILS(1:NDBASE,0:NDREVE),
     *                       L_NILS(1:NDBASE,0:NDREVE),
     *                       IOMEGA(1:NDBASE,0:NDREVE)
     *       /CYLONL_QUOCYL/ QUOTCY(1:NDBASE,0:NDREVE)
      COMMON
     *       /SPHLAB_ENEPAR/ ESPHER(1:NDBASE),
     *                       PSPHER(1:NDBASE)
     *       /SPHLAB_DEGENR/ IDEGEN(1:NDBASE)
     *       /SPHLAB_LBSPHE/ LBSPHE(1:NDBASE)
     *       /SPHLAB_DIMSPH/ LDSPHE
      COMMON
     *       /GRUPTD_REPREZ/ NREPRE(1:NDBASE)
      COMMON
     *       /SETBAS_DIMENS/ LDBASE
      COMMON
     *       /TETANDOKT_DEF/ IFTETR,IFOKTR
C
      COMMON
     *       /REVIEWING_STY/ IOPARS,IODEFS,IOROTS
C
C=======================================================================
C        REVPAR (Review concerning the parameter studies ('s2' & up)
C=======================================================================
C
C        Starting from this version we are introducing a possibility
C        of a modular construction of the disk output.  The user has
C        the means of controlling a completeness and/or compacteness
C        of the output  by properly defining a few output control in-
C        dices. These are:
C
C        INDNIL =>>> If 1,  Nilsson type cylindrical labels are kept
C        INDSPL =>>> If 1,  Nilsson-type  spherical  labels are kept
C        INDSPE =>>> If 1,  spectroscopic spherical  labels are kept
C        INDDEP =>>> If 1,  the total density spatial representation
C                           is recorded (the three dimensional mesh)
C                           on the user defined mesh [(P)oints]
C        INDDEN =>>> If 1,  similarly to the above but for the Gauss
C                           mesh points [(N)odes]
C
C=======================================================================
C=======================================================================
C
C=======================================================================
C        Return in case of the cranking version of the code
C=======================================================================
C
      IF (.NOT.(IOPARS.EQ.1.OR.IODEFS.EQ.1)) RETURN
C
C     IF (KRANKX.EQ.1.OR.KRANKY.EQ.1.OR.KRANKZ.EQ.1) THEN
C
C         STOP 'You are running a  s t a t i c  version with KRANK{}=1'
C
C     END IF
C
C=======================================================================
C
c      IF (IFWIGN.EQ.1) THEN
C
c          STOP 'You wanted to study parameters of H: set IFWIGN=0 <<= '
C
c      END IF
C
C=======================================================================
C
                       N_UNIT=NUPROT
      IF (ISOSPI.EQ.0) N_UNIT=NUNEUT
C
C=======================================================================
C           We write the eigen-energies on disk  -  always
C=======================================================================
C
      INDACT=MIN(INDENE,LDBASE)
C
      WRITE(N_UNIT,'(''EIGENE  How many?'')')
C
      WRITE(N_UNIT,'(3X,I10)') INDACT
C
      WRITE(N_UNIT,'(3X,10F10.5)') (ESINGP(I),I=1,INDACT)
C
C=======================================================================
C
      WRITE(N_UNIT,'(''PARITY  How many?'')')
C
      WRITE(N_UNIT,'(3X,I10)') INDACT
C
      WRITE(N_UNIT,'(3X,10F10.5)') (PARITY(I),I=1,INDACT)
C
C=======================================================================
C     Here we write the Cartesian labels (optionally)
C=======================================================================
C
      WRITE(N_UNIT,'(''LABCAR  How many?'')')
C
      IF (INDCAR.NE.0) THEN
C
          WRITE(N_UNIT,'(3X,I10)') INDACT
C
          WRITE(N_UNIT,'(5(1X,F5.2,3I3))')
     *
     *         (QUOTCA(I,IREVER),NXCART(I,IREVER),
     *                           NYCART(I,IREVER),
     *                           NZCART(I,IREVER),I=1,INDACT)
C
      ELSE
C
          WRITE(N_UNIT,'(3X,I10)') INDCAR
C
      END IF
C
C=======================================================================
C         ... as well as the Nilsson type spherical labels...
C=======================================================================
C
      WRITE(N_UNIT,'(''LABSPH  How many?'')')
C
      IF (INDSPL.NE.0) THEN
C
          WRITE(N_UNIT,'(3X,I10)') INDACT
C
          WRITE(N_UNIT,'(5(1X,F5.2,4I3))')
     *
     *         (QUOTSP(I,IREVER),MAIN0S(I,IREVER),
     *                           JMOM0S(I,IREVER),
     *                           LSPH0S(I,IREVER),
     *                           MMOM0S(I,IREVER),I=1,INDACT)
C
      ELSE
C
          WRITE(N_UNIT,'(3X,I10)') INDSPL
C
      END IF
C
C=======================================================================
C         ... and Nilsson type cylindrical labels
C=======================================================================
C
      WRITE(N_UNIT,'(''LABCYL  How many?'')')
C
      IF (INDNIL.NE.0) THEN
C
          WRITE(N_UNIT,'(3X,I10)') INDACT
C
          WRITE(N_UNIT,'(5(1X,F5.2,2I3,2I4))')
     *
     *         (QUOTCY(I,IREVER),MAINNL(I,IREVER),
     *                           NZNILS(I,IREVER),
     *                           L_NILS(I,IREVER),
     *                           IOMEGA(I,IREVER),I=1,INDACT)
C
      ELSE
C
          WRITE(N_UNIT,'(3X,I10)') INDNIL
C
      END IF
C
C=======================================================================
C         Finally the spectroscopic labels ...
C=======================================================================
C
      WRITE(N_UNIT,'(''LABSPE  How many?'')')
C
      IF (INDSPE.NE.0) THEN
C
          WRITE(N_UNIT,'(3X,I10)') LDSPHE
C
          WRITE(N_UNIT,'(5(1X,F10.6,1X,A6,1X,F5.2,1X,I3))')
     *
     *         (ESPHER(I),LBSPHE(I),PSPHER(I),IDEGEN(I),I=1,LDSPHE)
C
      ELSE
C
          WRITE(N_UNIT,'(3X,I10)') INDSPE
C
      END IF
C
C=======================================================================
C         ... and the irreducible representation labels for
C             tetrahedral or octahedral groups ...
C=======================================================================
C
      WRITE(N_UNIT,'(''TETRAH  How many?'')')
C
      IF (IFTETR.NE.0) THEN
C
          WRITE(N_UNIT,'(3X,I10)') INDACT
C
          WRITE(N_UNIT,'(3X,10I3)')
     *
     *         (NREPRE(I),I=1,INDACT)
C
      ELSE
C
          WRITE(N_UNIT,'(3X,I10)') IFTETR
C
      END IF
C_______________________________________________________________________
C
      WRITE(N_UNIT,'(''OKTAHR  How many?'')')
C
      IF (IFOKTR.NE.0) THEN
C
          WRITE(N_UNIT,'(3X,I10)') INDACT
C
          WRITE(N_UNIT,'(3X,10I3)')
     *
     *         (NREPRE(I),I=1,INDACT)
C
      ELSE
C
          WRITE(N_UNIT,'(3X,I10)') IFOKTR
C
      END IF
C
C=======================================================================
C=======================================================================
C              C H A N G I N G   T H E   S U B J E C T
C=======================================================================
C=======================================================================
C
      IDUMMY=0
C              ...     beginning with the r.m.s. radii
C
C=======================================================================
C
      WRITE(N_UNIT,'(''R.M.S.  Radii'')')
C
      WRITE(N_UNIT,'(3X,2F16.10)') RMSTRU,RMSPHE
C
C=======================================================================
C         Three-dimensional density case (user mesh points)
C=======================================================================
C
      WRITE(N_UNIT,'(''DENUSE  How many 3D?'')')
C
      IF (INDDEP.EQ.1) THEN
C
          WRITE(N_UNIT,'(3X,3I10)') NXHERM,NYHERM,NZHERM
C
C         Here the density values ...
C
          DO IX=1,NXHERM
             DO IY=1,NYHERM
C
               WRITE(N_UNIT,'(10(1X,E12.5))')
     *
     *                       (DENSIT(IX,IY,IZ),IZ=1,NZHERM)
             END DO
          END DO
C
C         ... and here at which points ...
C
          WRITE(N_UNIT,'(''DNPNTX'')')
          WRITE(N_UNIT,'(10(1X,F12.6))')
     *
     *         (XYZPNS(IX,1),IX=1,NXHERM)
C
          WRITE(N_UNIT,'(''DNPNTY'')')
          WRITE(N_UNIT,'(10(1X,F12.6))')
     *
     *         (XYZPNS(IY,2),IY=1,NYHERM)
C
          WRITE(N_UNIT,'(''DNPNTZ'')')
          WRITE(N_UNIT,'(10(1X,F12.6))')
     *
     *         (XYZPNS(IZ,3),IZ=1,NZHERM)
C
      ELSE
C
          WRITE(N_UNIT,'(3X,3I10)') IDUMMY,IDUMMY,IDUMMY
C
      END IF
C
C=======================================================================
C         Three-dimensional probability amplitudes (user mesh points)
C=======================================================================
C
      WRITE(N_UNIT,'(''Wavfunc How many 3D?'')')
C
      IF (IFWAVE.EQ.1) THEN
C
          NMAXWA=LDBASE
C
C         Here the probability amplitude values ...
C
          WRITE(N_UNIT,'(3X,2I10)') LDRADI,NMAXWA
C
          DO ISTATE=1,NMAXWA
             WRITE(N_UNIT,'(10(1X,E12.5))')
     *            (DISPRO(ISTATE,IRADIU),IRADIU=1,LDRADI)
          END DO
C
C         ... and here at which points ...
C
          WRITE(N_UNIT,'(''RADIUS'')')
          WRITE(N_UNIT,'(10(1X,F12.6))')
     *
     *         (RADPRO(IRADIU),IRADIU=1,LDRADI)
C
      ELSE
C
          WRITE(N_UNIT,'(3X,I10)') IDUMMY
C
      END IF
C
C=======================================================================
C         Three-dimensional density case (Gauss nodes)
C=======================================================================
C
      WRITE(N_UNIT,'(''DENGAU  How many 3D?'')')
C
      IF (INDDEN.EQ.1) THEN
C
          WRITE(N_UNIT,'(3X,3I10,3X,2I10)') NXHERM,NYHERM,NZHERM
C
C         Here the density values ...
C
          DO IX=1,NXHERM
             DO IY=1,NYHERM
C
               WRITE(N_UNIT,'(10(1X,E12.5))')
     *
     *                       (DENNOD(IX,IY,IZ),IZ=1,NZHERM)
             END DO
          END DO
C
C         ... and here at which points ...
C
          WRITE(N_UNIT,'(''DNGAUX'')')
          WRITE(N_UNIT,'(10(1X,1PE12.6))')
     *
     *         (HERPNT(IX,1),IX=1,NXHERM)
C
          WRITE(N_UNIT,'(''DNGAUY'')')
          WRITE(N_UNIT,'(10(1X,1PE12.6))')
     *
     *         (HERPNT(IY,2),IY=1,NYHERM)
C
          WRITE(N_UNIT,'(''DNGAUZ'')')
          WRITE(N_UNIT,'(10(1X,1PE12.6))')
     *
     *         (HERPNT(IZ,3),IZ=1,NZHERM)
C
          WRITE(N_UNIT,'(''RMSINT'')')
          WRITE(N_UNIT,'(3X,4F12.6)')    RMSINT,R2XINT,R2YINT,R2ZINT
C
      ELSE
C
          WRITE(N_UNIT,'(3X,3I10)') IDUMMY,IDUMMY,IDUMMY
C
      END IF
C
C=======================================================================
C         Density projections from the RMSCUT routine
C=======================================================================
C
      WRITE(N_UNIT,'(''RMSXYZ  NXHERM    NYHERM    NZHERM'')')
C
      IF (IF_XYZ.EQ.1) THEN
C
          WRITE(N_UNIT,'(3X,3I10)') NXHERM,NYHERM,NZHERM
C
          WRITE(N_UNIT,'(''DNCUTX'')')
          WRITE(N_UNIT,'(10(1X,1PE12.6))')
     *
     *         (DENSIX(IX),IX=1,NXHERM)
C
          WRITE(N_UNIT,'(''DNCUTY'')')
          WRITE(N_UNIT,'(10(1X,1PE12.6))')
     *
     *         (DENSIY(IY),IY=1,NYHERM)
C
          WRITE(N_UNIT,'(''DNCUTZ'')')
          WRITE(N_UNIT,'(10(1X,1PE12.6))')
     *
     *         (DENSIZ(IZ),IZ=1,NZHERM)
C
          WRITE(N_UNIT,'(''RMSCUT'')')
          WRITE(N_UNIT,'(3X,4F12.6)') RMLIKE,R2XCUT,R2YCUT,R2ZCUT
C
      ELSE
C
          WRITE(N_UNIT,'(3X,3I10)') IDUMMY,IDUMMY,IDUMMY
C
      END IF
C
C=======================================================================
C         Matrix elements of the delta-like force within the WS states
C=======================================================================
C
      WRITE(N_UNIT,'(''DELTIJ   IDELIL    IDELFI    IDELLA'')')
C
      IF (IFDELT.EQ.1) THEN
C
          WRITE(N_UNIT,'(3X,3I10)') IDELIL,IDELFI,IDELLA
C
          DO INDBRA=1,IDELIL
C
              WRITE(N_UNIT,'(3X,10(F12.6))') (BRAKET(INDBRA,INDKET),
     *                                               INDKET=1,IDELIL)
          END DO
C
      ELSE
C
          WRITE(N_UNIT,'(3X,3I10)') IDUMMY,IDUMMY,IDUMMY
C
      END IF
C
C=======================================================================
C         Multipole moments at the actual rotational frequency
C=======================================================================
C
      WRITE(N_UNIT,'(''MULTIP  How many?'')')
C
      IF (IFMULT.EQ.1) THEN
C
          NOLAMB=MIN(MAXMUL,NDMULT)
C
          WRITE(N_UNIT,'(3X,I10)') NOLAMB
C
          DO LAMBDA=0,NOLAMB
C
             WRITE(N_UNIT,'(3X,10(1PE12.5))')
     *            (QMOMUL(LAMBDA,MIUACT,ISOSPI),MIUACT=-LAMBDA,LAMBDA)
C
          END DO
C
      ELSE
C
          WRITE(N_UNIT,'(3X,I10)') IDUMMY
C
      END IF
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C=======================================================================
C
      SUBROUTINE WS_REVOME(IFWIGN,IZ_FIX,IN_FIX,KRANKX,KRANKY,KRANKZ,
     *                     ISIGNY,ISOSPI,IFMULT,NMOMUL,OMEGAC,NOFOME)
C=======================================================================
      USE params
C=======================================================================
      CHARACTER
     *          LBOKAR*10,LBONIL*15,LBORDE*13,LBSPHE*6
C
      COMMON
     *       /REVIEWING_PAR/ INDCAR,INDNIL,INDSPL,INDSPE,INDDEN,INDDEP,
     *                                                          INDSPI
      COMMON
     *       /OPENFI_UNITSN/ NUPROT,NUNEUT,NUTABP,NUTABN
      COMMON
     *       /ENERGYCUT_DSK/ INDENE
C
C             Multipole moments  at the actual  frequencies
C
      COMMON
     *       /MOMETS_MULMOM/ QMOMUL(0:NDMULT,-NDMULT:NDMULT,0:NDISOS)
     *       /MAGMOM_AMOMUL/ AMOMUL(0:NDMULT,-NDMULT:NDMULT,0:NDISOS)
C
C             Alignments 'j' and 's' sorted out in function
C             of rotational frequency, signature and parity
C
C             Below, similar for the dynamical moments  and
C                    for the corresponding sing.part.labels
      COMMON
     *       /SPTALL_ROUALI/ ROUTHS(1:NDBASE,0:NDREVE,0:NDPARI,NDOMEG),
     *                       ALIGOJ(1:NDBASE,0:NDREVE,0:NDPARI,NDOMEG),
     *                       ALIGOS(1:NDBASE,0:NDREVE,0:NDPARI,NDOMEG)
      COMMON
     *       /SPTALL_DYNAMC/ ALIGJ2(1:NDBASE,0:NDREVE,0:NDPARI,NDOMEG),
     *                       ALIGS2(1:NDBASE,0:NDREVE,0:NDPARI,NDOMEG)
      COMMON
     *       /SPTALL_LABOME/ LBOKAR(1:NDBASE,0:NDREVE,0:NDPARI,NDOMEG),
     *                       LBONIL(1:NDBASE,0:NDREVE,0:NDPARI,NDOMEG),
     *                       LBORDE(1:NDBASE,0:NDREVE,0:NDPARI,NDOMEG)
      COMMON
     *       /SPTALL_DIMSYM/ LDIMSP(0:NDPARI,0:NDREVE)
      COMMON
     *       /SETBAS_DIMENS/ LDBASE
C
C=======================================================================
C             Numerical values composing  labels: Cartesian,
C             spherical-Nilsson   and   cylindrical-Nilsson
C=======================================================================
C
      COMMON
     *       /LBKARR_BASCAR/ NXCART(1:NDBASE,0:NDREVE),
     *                       NYCART(1:NDBASE,0:NDREVE),
     *                       NZCART(1:NDBASE,0:NDREVE)
      COMMON
     *       /SPHONL_SPHERE/ MAIN0S(1:NDBASE,0:NDREVE),
     *                       JMOM0S(1:NDBASE,0:NDREVE),
     *                       LSPH0S(1:NDBASE,0:NDREVE),
     *                       MMOM0S(1:NDBASE,0:NDREVE)
      COMMON
     *       /CYLONL_CYLIND/ MAINNL(1:NDBASE,0:NDREVE),
     *                       NZNILS(1:NDBASE,0:NDREVE),
     *                       L_NILS(1:NDBASE,0:NDREVE),
     *                       IOMEGA(1:NDBASE,0:NDREVE)
C
      COMMON
     *       /MULTIP_SPLEVS/ SPENER(1:NDBASE,0:NDREVE),
     *                       SPALIG(1:NDBASE,0:NDREVE),
     *                       SPSPAL(1:NDBASE,0:NDREVE),
     *                       SPPARI(1:NDBASE,0:NDREVE),
     *                       QUOKAR(1:NDBASE,0:NDREVE),
     *                       QUONIL(1:NDBASE,0:NDREVE)
      COMMON
     *       /LBKARR_QUOCAR/ QUOTCA(1:NDBASE,0:NDREVE)
     *       /SPHONL_QUOSPH/ QUOTSP(1:NDBASE,0:NDREVE)
     *       /CYLONL_QUOCYL/ QUOTCY(1:NDBASE,0:NDREVE)
      COMMON
     *       /SPHLAB_ENEPAR/ ESPHER(1:NDBASE),
     *                       PSPHER(1:NDBASE)
     *       /SPHLAB_DEGENR/ IDEGEN(1:NDBASE)
     *       /SPHLAB_LBSPHE/ LBSPHE(1:NDBASE)
      COMMON
     *       /PUT_MM_SPNUMS/ NUMBSP(0:NDREVE)
      COMMON
     *       /SPHLAB_DIMSPH/ LDSPHE
C
      COMMON
     *       /REVIEWING_STY/ IOPARS,IODEFS,IOROTS
      COMMON
     *       /READWRITE_PAR/ NOUTPT,IWRITE,ISCREN
C
C=======================================================================
C        REVOME (Review concerning the cranking studies ('s2' and up)
C=======================================================================
C
C        Starting from this version we are introducing a possibility
C        of a modular construction of the disk output.  The user has
C        the means of controlling a completeness and/or compacteness
C        of the output by properly defining a few output control in-
C        dices. These are:
C
C        INDNIL =>>> If 1,  Nilsson type cylindrical labels are kept
C        INDSPL =>>> If 1,  Nilsson-type  spherical  labels are kept
C        INDSPE =>>> If 1,  spectroscopic spherical  labels are kept
C        INDSPI =>>> If 1,  expectation values of spin  (s=1/2) kept
C        INDDEP =>>> If 1,  the total density spatial representation
C                           is recorded (the three dimensional mesh)
C                           on the user defined mesh [(P)oints]
C        INDDEN =>>> If 1,  similarly to the above but for the Gauss
C                           mesh points [(N)odes]
C
C=======================================================================
C        This subroutine  writes on disc  (optionally)   information
C        related to the output  of the cranking segment of this code
C=======================================================================
C
      IF (IOROTS.NE.1) RETURN
      IF (NOFOME.EQ.0) RETURN
C
C=======================================================================
C
c      IF (IFWIGN.EQ.1) THEN
C
c          STOP 'You wanted to study cranking - set IFWIGN=0 <<= '
C
c      END IF
C
C=======================================================================
C
                       N_UNIT=NUPROT
      IF (ISOSPI.EQ.0) N_UNIT=NUNEUT
C
C=======================================================================
C         We write the eigen-energies on disk  -  always
C=======================================================================
C
      WRITE(N_UNIT,'(''OMEGAC             NOFOME'')')
C
      WRITE(N_UNIT,'(3X,F10.6,I10)') OMEGAC,NOFOME
C
C=======================================================================
C
      WRITE(N_UNIT,'(''EIGROU  How many?'',2X,''IREVER'')')
C
      DO IREVER=0,NDREVE
C
         INDACT=MIN(INDENE,NUMBSP(IREVER))
C
         WRITE(N_UNIT,'(3X,2I10)') INDACT,IREVER
C
         WRITE(N_UNIT,'(3X,10F10.5)') (SPENER(I,IREVER),I=1,INDACT)
C
      END DO
C
C=======================================================================
C
      WRITE(N_UNIT,'(''SPPARI  How many?'',2X,''IREVER'')')
C
      DO IREVER=0,NDREVE
C
         INDACT=MIN(INDENE,NUMBSP(IREVER))
C
         WRITE(N_UNIT,'(3X,2I10)') INDACT,IREVER
C
         WRITE(N_UNIT,'(3X,10F10.5)') (SPPARI(I,IREVER),I=1,INDACT)
C
      END DO
C
C=======================================================================
C
      WRITE(N_UNIT,'(''EIGALI  How many?'',2X,''IREVER'')')
C
      DO IREVER=0,NDREVE
C
         INDACT=MIN(INDENE,NUMBSP(IREVER))
C
         WRITE(N_UNIT,'(3X,2I10)') INDACT,IREVER
C
         WRITE(N_UNIT,'(3X,10F10.5)') (SPALIG(I,IREVER),I=1,INDACT)
C
      END DO
C
C=======================================================================
C
      WRITE(N_UNIT,'(''SPIALI  How many?'',2X,''IREVER'')')
C
      DO IREVER=0,NDREVE
C
         INDACT=MIN(INDENE,NUMBSP(IREVER))
C
         IF (INDSPI.NE.0) THEN
C
             WRITE(N_UNIT,'(3X,2I10)') INDACT,IREVER
C
             WRITE(N_UNIT,'(3X,10F10.5)') (SPSPAL(I,IREVER),I=1,INDACT)
C
         ELSE
C
             WRITE(N_UNIT,'(3X,2I10)') INDSPI,IREVER
C
         END IF
C
      END DO
C
C=======================================================================
C
      IDUMMY=0
C
C=======================================================================
C         Here we write the Cartesian labels (optionally)
C=======================================================================
C
      WRITE(N_UNIT,'(''LBRCAR'')')
C
      DO IREVER=0,NDREVE
C
         IF (INDCAR.EQ.1) THEN
C
             INDACT=MIN(INDENE,NUMBSP(IREVER))
C
             WRITE(N_UNIT,'(3X,2I10)') INDACT,IREVER
C
             WRITE(N_UNIT,'(5(1X,F5.2,3I3))')
     *
     *            (QUOTCA(I,IREVER),NXCART(I,IREVER),
     *                              NYCART(I,IREVER),
     *                              NZCART(I,IREVER),I=1,INDACT)
         ELSE
C
             WRITE(N_UNIT,'(3X,2I10)') IDUMMY,IREVER
C
         END IF
C
      END DO
C
C=======================================================================
C         ... as well as the Nilsson type spherical labels...
C=======================================================================
C
      WRITE(N_UNIT,'(''LBRSPH'')')
C
      DO IREVER=0,NDREVE
C
         IF (INDSPL.EQ.1) THEN
C
             INDACT=MIN(INDENE,NUMBSP(IREVER))
C
             WRITE(N_UNIT,'(3X,2I10)') INDACT,IREVER
C
             WRITE(N_UNIT,'(5(1X,F5.2,2I3,2I4))')
     *
     *            (QUOTSP(I,IREVER),MAIN0S(I,IREVER),
     *                              JMOM0S(I,IREVER),
     *                              LSPH0S(I,IREVER),
     *                              MMOM0S(I,IREVER),I=1,INDACT)
         ELSE
C
             WRITE(N_UNIT,'(3X,2I10)') IDUMMY,IREVER
C
         END IF
C
      END DO
C
C=======================================================================
C         ... and Nilsson type cylindrical labels
C=======================================================================
C
      WRITE(N_UNIT,'(''LABCYL'')')
C
      DO IREVER=0,NDREVE
C
         IF (INDNIL.EQ.1) THEN
C
             INDACT=MIN(INDENE,NUMBSP(IREVER))
C
             WRITE(N_UNIT,'(3X,2I10)') INDACT,IREVER
C
             WRITE(N_UNIT,'(5(1X,F5.2,2I3,2I4))')
     *
     *            (QUOTCY(I,IREVER),MAINNL(I,IREVER),
     *                              NZNILS(I,IREVER),
     *                              L_NILS(I,IREVER),
     *                              IOMEGA(I,IREVER),I=1,INDACT)
         ELSE
C
             WRITE(N_UNIT,'(3X,2I10)') IDUMMY,IREVER
C
         END IF
C
      END DO
C
C=======================================================================
C         Electric multipole moments at the actual rotational frequency
C=======================================================================
C
      WRITE(N_UNIT,'(''QMOMUL  How many?'')')
C
      IF (IFMULT.EQ.1) THEN
C
          NOLAMB=MIN(NMOMUL,NDMULT)
C
          WRITE(N_UNIT,'(3X,I10)') NOLAMB
C
          DO LAMBDA=0,NOLAMB
C
             WRITE(N_UNIT,'(3X,10(1PE12.4))')
     *            (QMOMUL(LAMBDA,MIUACT,ISOSPI),MIUACT=-LAMBDA,LAMBDA)
C
          END DO
C
      ELSE
C
          WRITE(N_UNIT,'(3X,I10)') IDUMMY
C
      END IF
C
C=======================================================================
C         Magnetic multipole moments at the actual rotational frequency
C=======================================================================
C
      WRITE(N_UNIT,'(''AMOMUL  How many?'')')
C
      IF (IFMULT.EQ.1) THEN
C
          NOLAMB=MIN(NMOMUL,NDMULT)
C
          WRITE(N_UNIT,'(3X,I10)') NOLAMB
C
          DO LAMBDA=0,NOLAMB
C
             WRITE(N_UNIT,'(3X,10(1PE12.4))')
     *            (AMOMUL(LAMBDA,MIUACT,ISOSPI),MIUACT=-LAMBDA,LAMBDA)
C
          END DO
C
      ELSE
C
          WRITE(N_UNIT,'(3X,I10)') IDUMMY
C
      END IF
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C=======================================================================
C
      SUBROUTINE WS_COMP3D(ICHARG,LDBASE)
C=======================================================================
      USE params
C=======================================================================
C
      COMMON
     *       /MULTIP_SPLEVS/ SPENE1(1:NDBASE,0:NDREVE),
     *                       SPALI1(1:NDBASE,0:NDREVE),
     *                       SPSPA1(1:NDBASE,0:NDREVE),
     *                       SPPAR1(1:NDBASE,0:NDREVE),
     *                       QUOKA1(1:NDBASE,0:NDREVE),
     *                       QUONI1(1:NDBASE,0:NDREVE)
      COMMON
     *       /LBKARR_BASCAR/ NXCAR1(1:NDBASE,0:NDREVE),
     *                       NYCAR1(1:NDBASE,0:NDREVE),
     *                       NZCAR1(1:NDBASE,0:NDREVE)
      COMMON
     *       /CYLONL_CYLIND/ MAINN1(1:NDBASE,0:NDREVE),
     *                       NZNIL1(1:NDBASE,0:NDREVE),
     *                       L_NIL1(1:NDBASE,0:NDREVE),
     *                       IOMEG1(1:NDBASE,0:NDREVE)
C
      COMMON
     *       /CRAN3D_SPLV3D/ SPENER(1:2*NDSTAT,0:NDISOS),
     *                       SPOCCU(1:2*NDSTAT,0:NDISOS),
     *                       SPALIG(1:2*NDSTAT,0:NDISOS),
     *                       SPSPAL(1:2*NDSTAT,0:NDISOS),
     *                       SPPARI(1:2*NDSTAT,0:NDISOS),
     *                       SPSIMP(1:2*NDSTAT,0:NDISOS)
      COMMON
     *       /CRAN3D_BCAR3D/ NXCART(1:2*NDSTAT),
     *                       NYCART(1:2*NDSTAT),
     *                       NZCART(1:2*NDSTAT)
      COMMON
     *       /CRAN3D_CYLO3D/ MAINNL(1:2*NDSTAT),
     *                       NZNILS(1:2*NDSTAT),
     *                       L_NILS(1:2*NDSTAT),
     *                       IOMEGA(1:2*NDSTAT)
C
C=======================================================================
C      Subroutine which fills in the common block /CRAN3D_SPLV3D/
C      at omega=0
C=======================================================================
C
      IINDEX=0
      DO I=1,LDBASE
C
         IINDEX=IINDEX+1
C
         SPENER(IINDEX,ICHARG)=SPENE1(I,0)
         SPOCCU(IINDEX,ICHARG)=SPALI1(I,0)
         SPALIG(IINDEX,ICHARG)=SPSPA1(I,0)
         SPSPAL(IINDEX,ICHARG)=SPPAR1(I,0)
         SPPARI(IINDEX,ICHARG)=QUOKA1(I,0)
         SPSIMP(IINDEX,ICHARG)=QUONI1(I,0)
C
	 NXCART(IINDEX)=NXCAR1(I,0)
	 NYCART(IINDEX)=NYCAR1(I,0)
	 NZCART(IINDEX)=NZCAR1(I,0)
C
	 MAINNL(IINDEX)=MAINN1(I,0)
	 NZNILS(IINDEX)=NZNIL1(I,0)
	 L_NILS(IINDEX)=L_NIL1(I,0)
	 IOMEGA(IINDEX)=IOMEG1(I,0)
C
         IINDEX=IINDEX+1
         SPENER(IINDEX,ICHARG)=SPENE1(I,1)
         SPOCCU(IINDEX,ICHARG)=SPALI1(I,1)
         SPALIG(IINDEX,ICHARG)=SPSPA1(I,1)
         SPSPAL(IINDEX,ICHARG)=SPPAR1(I,1)
         SPPARI(IINDEX,ICHARG)=QUOKA1(I,1)
         SPSIMP(IINDEX,ICHARG)=QUONI1(I,1)
C
	 MAINNL(IINDEX)=MAINN1(I,1)
	 NZNILS(IINDEX)=NZNIL1(I,1)
	 L_NILS(IINDEX)=L_NIL1(I,1)
	 IOMEGA(IINDEX)=IOMEG1(I,1)
C
      END DO
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C=======================================================================
C
      SUBROUTINE WS_REVO3D(ICHARG,IZ_FIX,IN_FIX,OMEG_X,OMEG_Y,OMEG_Z,
     *                     THEANG,PHIANG,NOFOME,LDBASE,IFMULT,NMOMUL)
C=======================================================================
      USE params
C=======================================================================
C
      COMMON
     *       /REVIEWING_PAR/ INDCAR,INDNIL,INDSPL,INDSPE,INDDEN,INDDEP,
     *                                                          INDSPI
      COMMON
     *       /ENERGYCUT_DSK/ INDENE
      COMMON
     *       /OPENFI_UNITSN/ NUPROT,NUNEUT,NUTABP,NUTABN
C
C             Multipole moments  at the actual  frequencies
C
      COMMON
     *       /MOMETS_MULMOM/ QMOMUL(0:NDMULT,-NDMULT:NDMULT,0:NDISOS)
     *       /MAGMOM_AMOMUL/ AMOMUL(0:NDMULT,-NDMULT:NDMULT,0:NDISOS)
      COMMON
     *       /CRAN3D_BCAR3D/ NXCART(1:2*NDSTAT),
     *                       NYCART(1:2*NDSTAT),
     *                       NZCART(1:2*NDSTAT)
      COMMON
     *       /CRAN3D_CYLO3D/ MAINNL(1:2*NDSTAT),
     *                       NZNILS(1:2*NDSTAT),
     *                       L_NILS(1:2*NDSTAT),
     *                       IOMEGA(1:2*NDSTAT)
      COMMON
     *       /CRAN3D_SPLV3D/ SPENER(1:2*NDSTAT,0:NDISOS),
     *                       SPOCCU(1:2*NDSTAT,0:NDISOS),
     *                       SPALIG(1:2*NDSTAT,0:NDISOS),
     *                       SPSPAL(1:2*NDSTAT,0:NDISOS),
     *                       SPPARI(1:2*NDSTAT,0:NDISOS),
     *                       SPSIMP(1:2*NDSTAT,0:NDISOS)
      COMMON
     *       /CRAN3D_SPXZ3D/ SPXALI(1:2*NDSTAT,0:NDISOS),
     *                       SPZALI(1:2*NDSTAT,0:NDISOS),
     *                       SPXSPI(1:2*NDSTAT,0:NDISOS),
     *                       SPZSPI(1:2*NDSTAT,0:NDISOS)
      COMMON
     *       /CRAN3D_QUANUM/ ISIGNZ(1:2*NDSTAT,0:NDISOS),
     *                       IDOUBZ(1:2*NDSTAT,0:NDISOS)
      COMMON
     *       /PUT_MM_SPNUMS/ NUMBSP(0:NDREVE)
C
C=======================================================================
C
C             REVO3D (Review concerning the 3D-cranking studies)
C
C        Starting from this version we are introducing a possibility
C        of a modular construction of the disk output.  The user has
C        the means of controlling a completeness and/or compacteness
C        of the output by properly defining a few output control in-
C        dices. These are:
C
C        This subroutine  writes on disc  (optionally)   information
C        related to the output  of the cranking segment of this code
C
C=======================================================================
C
      CALL WS_CPUTIM('REVO3D',1)
C
C=======================================================================
C
      IF (NOFOME.EQ.0) RETURN
C
                       N_UNIT=NUPROT
      IF (ICHARG.EQ.0) N_UNIT=NUNEUT
C
      LDOUBL=NUMBSP(0)+NUMBSP(1)
C
      INDACT=MIN(INDENE,LDOUBL)
C
C      Rotational frequencies
C
      WRITE(N_UNIT,'(''ANGLES   THEANG   PHIANG'')')
C
      WRITE(N_UNIT,'(6X,2F9.2)') THEANG,PHIANG
C
C      Rotational frequencies
C
      WRITE(N_UNIT,'(''OMEGAS   OMEGAX   OMEGAY   OMEGAZ   NOFOME'')')
C
      WRITE(N_UNIT,'(6X,3F9.3,I7)') OMEG_X,OMEG_Y,OMEG_Z,NOFOME
C
C      Eigen-energies
C
      WRITE(N_UNIT,'(''EIGROU  How many?'',2X,''IREVER'')')
C
      WRITE(N_UNIT,'(3X,I10)') INDACT
C
      WRITE(N_UNIT,'(3X,10F10.5)') (SPENER(I,ICHARG),I=1,INDACT)
C
C      Expectation values of single-particle parity
C
      WRITE(N_UNIT,'(''SPPARI  How many?'')')
C
      WRITE(N_UNIT,'(3X,I10)') INDACT
C
      WRITE(N_UNIT,'(3X,10F10.5)') (SPPARI(I,ICHARG),I=1,INDACT)
C
C=======================================================================
C
C                    Alignments and Spins
C
C=======================================================================
C
C      Recording Lx (X-alignment) and Sx
C
      WRITE(N_UNIT,'(''EIGALX  How many?'')')
C
      WRITE(N_UNIT,'(3X,I10)') INDACT
C
      WRITE(N_UNIT,'(3X,10F10.5)') (SPXALI(I,ICHARG),I=1,INDACT)
C
      WRITE(N_UNIT,'(''SPIALX  How many?'')')
C
      WRITE(N_UNIT,'(3X,2I10)') INDACT
C
      WRITE(N_UNIT,'(3X,10F10.5)') (SPXSPI(I,ICHARG),I=1,INDACT)
C
C      Recording Ly (Y-alignment) and Sy
C
      WRITE(N_UNIT,'(''EIGALY  How many?'')')
C
      WRITE(N_UNIT,'(3X,I10)') INDACT
C
      WRITE(N_UNIT,'(3X,10F10.5)') (SPALIG(I,ICHARG),I=1,INDACT)
C
      WRITE(N_UNIT,'(''SPIALY  How many?'')')
C
      WRITE(N_UNIT,'(3X,2I10)') INDACT
C
      WRITE(N_UNIT,'(3X,10F10.5)') (SPSPAL(I,ICHARG),I=1,INDACT)
C
C      Recording Lz (Z-alignment) and Sz
C
      WRITE(N_UNIT,'(''EIGALZ  How many?'')')
C
      WRITE(N_UNIT,'(3X,I10)') INDACT
C
      WRITE(N_UNIT,'(3X,10F10.5)') (SPZALI(I,ICHARG),I=1,INDACT)
C
      WRITE(N_UNIT,'(''SPIALZ  How many?'')')
C
      WRITE(N_UNIT,'(3X,2I10)') INDACT
C
      WRITE(N_UNIT,'(3X,10F10.5)') (SPZSPI(I,ICHARG),I=1,INDACT)
C
C=======================================================================
C
C                     Cartesian and Nilsson Labels
C
C=======================================================================
C
      IDUMMY=0
C
C      Here we write the Cartesian labels (optionally)
C
      WRITE(N_UNIT,'(''LBRCAR'')')
C
      IF (INDCAR.EQ.1) THEN
C
          WRITE(N_UNIT,'(3X,I10)') INDACT
C
          WRITE(N_UNIT,'(5(3I3))')
     *
     *         (NXCART(I),NYCART(I),NZCART(I),I=1,INDACT)
      ELSE
C
          WRITE(N_UNIT,'(3X,I10)') IDUMMY
C
      END IF
C
C      ... and Nilsson type cylindrical labels
C
      WRITE(N_UNIT,'(''LABCYL'')')
C
      IF (INDNIL.EQ.1) THEN
C
          WRITE(N_UNIT,'(3X,I10)') INDACT
C
          WRITE(N_UNIT,'(5(1X,2I3,2I4))')
     *
     *         (MAINNL(I),NZNILS(I),L_NILS(I),IOMEGA(I),I=1,INDACT)
      ELSE
C
          WRITE(N_UNIT,'(3X,I10)') IDUMMY
C
      END IF
C
C      Signature and Doublex
C
      WRITE(N_UNIT,'(''SIGNAZ'')')
C
      WRITE(N_UNIT,'(3X,2I10)') INDACT
C
      WRITE(N_UNIT,'(3X,10I3)') (ISIGNZ(I,ICHARG),I=1,INDACT)
C
C      Signature and Doublex
C
      WRITE(N_UNIT,'(''DOUBLZ'')')
C
      WRITE(N_UNIT,'(3X,2I10)') INDACT
C
      WRITE(N_UNIT,'(3X,10I3)') (IDOUBZ(I,ICHARG),I=1,INDACT)
C
C=======================================================================
C         Electric multipole moments at the actual rotational frequency
C=======================================================================
C
      WRITE(N_UNIT,'(''QMOMUL  How many?'')')
C
      IF (IFMULT.EQ.1) THEN
C
          NOLAMB=MIN(NMOMUL,NDMULT)
C
          WRITE(N_UNIT,'(3X,I10)') NOLAMB
C
          DO LAMBDA=0,NOLAMB
C
             WRITE(N_UNIT,'(3X,10(1PE12.4))')
     *            (QMOMUL(LAMBDA,MIUACT,ICHARG),MIUACT=-LAMBDA,LAMBDA)
C
          END DO
C
      ELSE
C
          WRITE(N_UNIT,'(3X,I10)') IDUMMY
C
      END IF
C
C=======================================================================
C         Magnetic multipole moments at the actual rotational frequency
C=======================================================================
C
      WRITE(N_UNIT,'(''AMOMUL  How many?'')')
C
      IF (IFMULT.EQ.1) THEN
C
          NOLAMB=MIN(NMOMUL,NDMULT)
C
          WRITE(N_UNIT,'(3X,I10)') NOLAMB
C
          DO LAMBDA=0,NOLAMB
C
             WRITE(N_UNIT,'(3X,10(1PE12.4))')
     *            (AMOMUL(LAMBDA,MIUACT,ICHARG),MIUACT=-LAMBDA,LAMBDA)
C
          END DO
C
      ELSE
C
          WRITE(N_UNIT,'(3X,I10)') IDUMMY
C
      END IF
C
C=======================================================================
C
      CALL WS_CPUTIM('REVO3D',0)
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C=======================================================================
C
      SUBROUTINE WS_ITEPRI
C=======================================================================
      USE params
C=======================================================================
      INTEGER
     *          HISITE
C
      COMMON
     *       /DISTAN_HISDIS/ ICALLS(1:NDCASE),IFAILS(1:NDCASE)
     *       /DISTAN_HISITR/ HISITE(1:NDCASE)
      COMMON
     *       /VERIFS_SYMETS/ ISPHER,ICYLIN,IPCONS
C
      COMMON
     *       /PRECISION_EPS/ EPSF_S,EPSG_S,APROAC
      COMMON
     *       /READWRITE_PAR/ NOUTPT,IWRITE,ISCREN
C
C=======================================================================
C     Distan-iteration  failure-printing  routine
C=======================================================================
C
      WRITE(NOUTPT,'(//,80(''#''),/,''#'',78X,''#'',/,
     *          ''#  The total number of calls to the '',
     *          ''DISTAN-ROUTINE: I_C1 => '',I17,''  #'',/,
     *          ''#                                   '',
     *          ''                I_C2 => '',I17,''  #'',/,
     *          ''#'',78X,''#'')')
     *
     *           (ICALLS(I_CASE),I_CASE=1,NDCASE)
C
C=======================================================================
C
      WRITE(NOUTPT,'(''#  The total number of '',
     *          ''failed (or appr.) solutions: '',
     *                          ''I_C1 => '',I17,''  #'',/,
     *          ''#                                   '',
     *          ''                I_C2 => '',I17,''  #'',/,
     *          ''#'',78X,''#'')')
     *
     *           (IFAILS(I_CASE),I_CASE=1,NDCASE)
C
C=======================================================================
C
      WRITE(NOUTPT,'(''#  The total number of calls to the '',
     *          ''FNSYST-ITERN.R. I_C1 => '',I17,''  #'',/,
     *          ''#                                   '',
     *          ''                I_C2 => '',I17,''  #'',/,
     *          ''#'',78X,''#'',/,80(''#''))')
     *
     *           (HISITE(I_CASE),I_CASE=1,NDCASE)
C
C=======================================================================
C
      IF (ISPHER.EQ.1) THEN
C
          WRITE(NOUTPT,'(''#'',78X,''#'',/,
     *          ''#  The accuracies requested have been '',
     *          ''satisfied exactly      (Spherical Case)  #'',/,
     *          ''#'',78X,''#'',/,80(''#''))')
C
          RETURN
C
      END IF
C
C=======================================================================
C
      WRITE(NOUTPT,'(''#'',78X,''#'',/,
     *          ''#  The accuracies requested have been '',
     *          ''defined by    ======>     EPSF_S='',E6.1,''  #'',/,
     *          ''#                                     '',
     *          ''                          EPSG_S='',E6.1,''  #'',/,
     *          ''#'',78X,''#'',/,80(''#''))')
     *
     *                                      EPSF_S,EPSG_S
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C=======================================================================
C
      SUBROUTINE WS_TIMPRI
C=======================================================================
      USE params
C=======================================================================
      REAL*4
     *          ITIALL,ITIACT
      CHARACTER
     *          NAMALL*6,OUITEM(NDCOLU)*17
C
      COMMON
     *       /TIMPRI_TIMEXE/ ITIALL(NDSUBR),ITIACT(NDSUBR),
     *                       KONOFF(NDSUBR),NAMALL(NDSUBR)
     *       /CPUDAT_TIMNOW/ NUSUBR
      COMMON
     *       /READWRITE_PAR/ NOUTPT,IWRITE,ISCREN
C
C=======================================================================
C         This subroutine prints execution times for predefined
C         subroutines
C=======================================================================
C
      CALL WS_CPUTIM('WSUNIV',0)
C
C=======================================================================
C
      IF (NUSUBR.GT.0.AND.IWRITE.GE.1) THEN
C
          WRITE(NOUTPT,'(//,80(''#''),/,         ''#'',78X,''#'',/,
     *                   ''#  CPU and system times  for the routines'',
     *                   ''  and their down-calling trees        #'',/,
     *                    ''#'',78X,''#'',/,               80(''#''),/,
     *                                               ''#'',78X,''#'')')
C
          DO ITSUBR=1,NUSUBR,NDCOLU
C
             DO NUITEM=1,NDCOLU
                OUITEM(NUITEM)='                 '
             END DO
C
             MXITEM=MIN(NUSUBR-ITSUBR+1,NDCOLU)
C
             DO NUITEM=1,MXITEM
C
                MUSUBR=ITSUBR+NUITEM-1
C
                IF (KONOFF(MUSUBR).EQ.1) THEN
C
                    WRITE(NOUTPT,'(/,1X,19(1H/),
     *                    '' In TIMPRI time is still on for '',
     *                                       A6,3X,19(1H/),/)')
     *                                           NAMALL(MUSUBR)
C
                    STOP 'In TIMPRI time is still on <<= '
C
                END IF
C
                WRITE(OUITEM(NUITEM),'(F7.2,'' => '',A6)')
     *                       ITIALL(MUSUBR),NAMALL(MUSUBR)
C
             END DO
C
             WRITE(NOUTPT,'(''#'',2X,4A17,8X,''#'',/,''#'',78X,''#'')')
     *                                 (OUITEM(NUITEM),NUITEM=1,NDCOLU)
C
          END DO
C
          WRITE(NOUTPT,'(80(''#''),/)')
C
      END IF
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C=======================================================================
C
      BLOCK DATA WS_CPUDAT
C
      COMMON
     *       /CPUDAT_TIMNOW/ NUSUBR
C
      DATA
     *       NUSUBR /0/
C
      END
C
C=======================================================================
C=======================================================================
C
      SUBROUTINE WS_CPUTIM(NAMSUB,IONOFF)
C=======================================================================
      USE params
C=======================================================================
      CHARACTER
     *          NAMSUB*6,NAMALL*6
      REAL*4
     *          ITIALL,ITIACT,ISCNDS,ETIME,DUMMY(2)
C
      COMMON
     *       /TIMPRI_TIMEXE/ ITIALL(NDSUBR),ITIACT(NDSUBR),
     *                       KONOFF(NDSUBR),NAMALL(NDSUBR)
      COMMON
     *       /CPUDAT_TIMNOW/ NUSUBR
C
C=======================================================================
C         This subroutine collects execution times for different
C         subroutines
C=======================================================================
C
      DUMMY(1)=0
      DUMMY(2)=0
C
      I_SUBR=0
C
C=======================================================================
C         The subroutine is identified by its name. Consecutive
C         numbers are attributed to subroutines in the sequence
C         of consecutive calls to CPUTIM
C=======================================================================
C
      IF (NUSUBR.GT.0) THEN
C
          DO MUSUBR=1,NUSUBR
             IF (NAMALL(MUSUBR).EQ.NAMSUB) I_SUBR=MUSUBR
          END DO
C
      ELSE
C
          DO MUSUBR=1,NDSUBR
             KONOFF(MUSUBR)=0
             ITIACT(MUSUBR)=0
          END DO
C
      END IF
C
      IF (I_SUBR.EQ.0) THEN
C
          IF (NUSUBR.GE.NDSUBR) STOP 'Too large NUSUBR in CPUTIM <<= '
C
          NUSUBR=NUSUBR+1
          I_SUBR=NUSUBR
          NAMALL(I_SUBR)=NAMSUB
          ITIALL(I_SUBR)=0
C
      END IF
C
C=======================================================================
C         Here a call is made to REAL*4 FUNCTION ETIME which returns
C         the sum of the cpu and system time
C=======================================================================
C
c      ISCNDS=ETIME(DUMMY)
      CALL CPU_TIME(ATIME)
      ISCNDS=ATIME
C
C=======================================================================
C
      IF (IONOFF.NE.0.AND.IONOFF.NE.1)
     *    STOP 'Wrong IONOFF in CPUTIM <<= '
C
      IF (IONOFF.EQ.1) THEN
C
C=======================================================================
C         Here the time is set
C=======================================================================
C
          IF (KONOFF(I_SUBR).EQ.1)
     *        STOP 'ETIME is already on in CPUTIM <<= '
C
          ITIACT(I_SUBR)=ISCNDS
          KONOFF(I_SUBR)=1
C
      ELSE
C
C=======================================================================
C         Here the time is collected
C=======================================================================
C
          IF (KONOFF(I_SUBR).EQ.0)
     *        STOP 'ETIME is already off in CPUTIM <<= '
C
          ITIALL(I_SUBR)=ITIALL(I_SUBR)+ISCNDS-ITIACT(I_SUBR)
          KONOFF(I_SUBR)=0
C
      END IF
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
*
*>>>> STRIPS
      SUBROUTINE WS_STRIPS(STRING,LENGTH)
*
*=======================================================================
*
*     This  subroutine takes a string "STRING" and returns the  same
*     string with  stripped leading  and trailing spaces. In "LENGTH"
*     the  length of  resuling string is returned (it can be zero).
*
*     For example: '  dupa  jas ' gives 'dupa  jas' and LENGTH=9
*
*=======================================================================
*============================================ T.R.Werner, September 1998
*============================================    Last modified: Jan 2000
*=======================================================================
*
      CHARACTER STRING*(*)
*
      L=-1
      J= 0
      K= 0
*
      DO I=1,LEN(STRING)
         IF (STRING(I:I).NE.' ') THEN
            L=I
            IF (J.EQ.0) THEN
               K=I
               J=1
            END IF
         END IF
      END DO
*
      LENGTH=L-K+1
*
      IF (LENGTH.EQ.0) THEN
          STRING=' '
      ELSE
          STRING=STRING(K:L)
      END IF
*
      END ! <<<< STRIPS
*_______________________________________________________________________
*_______________________________________________________________________
*
*>>>> WS_LOCATI
      INTEGER FUNCTION WS_LOCATI(STRIN1,STRIN2)
*
*=======================================================================
*
*      This function searches for the first occurence of  string
*      STRIN2 in string STRIN1. Note, that STRIN2 must be given
*      as literal string (e.g., 'si') or as a substring of a string
*      variable with explicitely given length (e.g., patt(1:2)).
*      Otherwise, the full string STRIN2 up to its declared length
*      will be taken, what most probably is not what you want.
*      If STRIN2 has been found in STRIN1, the function returns
*      location of STRIN2(1:1) in STRIN1. Otherwise, zero is returned.
*
*      For example: STRIN1='  dupa jasio ' STRIN2='si'
*                   then  LOCATI(STRIN1,STRIN2) returns 10
*
*=======================================================================
*============================================= T.R.Werner, November 1999
*=============================================   Last modified: Jan 2000
*=======================================================================
*
      CHARACTER STRIN1*(*),STRIN2*(*)
*
      WS_LOCATI=0
*
      LDSTR1=LEN(STRIN1)
      LDSTR2=LEN(STRIN2)
*
      IF (LDSTR2.GT.LDSTR1) RETURN
*
      DO I=1,LDSTR1-LDSTR2+1
         IF (STRIN2(1:LDSTR2).EQ.STRIN1(I:I+LDSTR2-1)) THEN
            WS_LOCATI=I
            RETURN
         END IF
      END DO
*
      END ! <<<< WS_LOCATI
*_______________________________________________________________________
*_______________________________________________________________________
*
*
*>>>> WS_DATGUT
      LOGICAL FUNCTION WS_DATGUT(STRING)
      INTERFACE
         INTEGER FUNCTION WS_LOCATI(STRIN1,STRIN2)
            CHARACTER STRIN1*(*),STRIN2*(*)
         END FUNCTION WS_LOCATI
      END INTERFACE
*
*=======================================================================
*
*    This function searches STRING for an occurence of a  substring
*    consisting of '(', then a number, comma, a number, and finally
*    the ')'. If such a substring is found, .TRUE. will be returned.
*    WARNING: the function will  work if such a  substring is found
*    right after the very  f i r s t  opening parenthesis.
*
*                  Uses locati from the same package.
*
*=======================================================================
*================================================= T.R.Werner, June 2002
*=======================================================================
*
      CHARACTER STRING*(*)
      CHARACTER NUMBRS*18
      DATA
     *    NUMBRS /'0123456789eEdD+-. '/
*
      WS_DATGUT=.FALSE.
*
*     --- looking for opening parethesis
      LOCINO=SCAN('(', STRING, .FALSE.)
      IF (LOCINO.EQ.0) RETURN
*
*     --- looking for the matching closing parethesis
      LOCINC=SCAN(')', STRING(LOCINO:), .TRUE.)
      IF (LOCINC.EQ.0) RETURN
      LOCINC=LOCINO+LOCINC-1
*
*     --- looking for a comma somewhere in-between
      LOCINP=SCAN(',', STRING(LOCINO:LOCINC), .FALSE.)
      IF (LOCINP.EQ.0) RETURN
      LOCINP=LOCINO+LOCINP-1
*
*     --- checking if only allowed characters are present
*     --- between '(' and comma, and between comma and ')'
      DO I=LOCINO+1,LOCINP-1
          IF ( WS_LOCATI(NUMBRS,STRING(I:I)).EQ.0 ) RETURN
      END DO
      DO I=LOCINP+1,LOCINC-1
          IF ( WS_LOCATI(NUMBRS,STRING(I:I)).EQ.0 ) RETURN
      END DO
*
      WS_DATGUT=.TRUE.
*
      END
C
C=======================================================================
