C FILE NAME = wsu09_syms_04.f   ! Keep this symbol here: $ident@string$
C
C=======================================================================
C=======================================================================
C=====                                ==================================
C=====    SYMMETRY-TESTING ROUTINES   ==================================
C=====                                ==================================
C=======================================================================
C=======================================================================
C
C
      SUBROUTINE WS_TESSYM
C
      CALL WS_TSSYM1
C
C=======================================================================
C        Testing symmetries  (P A R I T Y   P A R I T Y   P A R I T Y)
C=======================================================================
C
      CALL WS_TSSYM2
C
C=======================================================================
C        Testing symmetries  (ROTATIONS ABOUT THE  X-, Y-, AND Z-AXES)
C=======================================================================
C
      CALL WS_TSSYM3
C
C=======================================================================
C        Testing symmetries (REFLECTION IN X=+Y AND X=-Y  P L A N E S)
C=======================================================================
C
      CALL WS_TSSYM4
C
C=======================================================================
C        Testing symmetries  (FOUR-FOLD ROTARY AXES; HERE Z-AXIS ONLY)
C=======================================================================
C
      CALL WS_TSSYM5
C
C=======================================================================
C        Testing symmetries  (THREE-FOLD  AXIS;  HERE =>> Z-AXIS ONLY)
C=======================================================================
C
      CALL WS_TSSYM6
C
C=======================================================================
C        Testing symmetries  (AXIAL SYMMETRY => ABOUT THE Z-AXIS ONLY)
C=======================================================================
C
      CALL WS_TSSYMZ
C
C=======================================================================
C        Testing symmetries  (AXIAL SYMMETRY => ABOUT THE Y-AXIS ONLY)
C=======================================================================
C
      CALL WS_TSSYMY
C
C=======================================================================
C        Testing symmetries  (AXIAL SYMMETRY => ABOUT THE X-AXIS ONLY)
C=======================================================================
C
      CALL WS_TSSYMX
C
C=======================================================================
C        Testing symmetries  (3-FOLD ROTATION:  INTERCHANGE X,Y AND Z)
C=======================================================================
C
      CALL WS_TSSYM8
C
C=======================================================================
C        Testing symmetries  (2-FOLD ROTATION ABOUT THE LINE X=+Y,Z=0)
C                       AND  (2-FOLD ROTATION ABOUT THE LINE X=-Y,Z=0)
C=======================================================================
C
      CALL WS_TSSYM9
C
C=======================================================================
C        Testing symmetries  (3-FOLD ROTATION AXES => (SELECTED CASE))
C=======================================================================
C
      CALL WS_TSSY10
C
C=======================================================================
C        Indicating the point group symmetry following tssxxx results
C=======================================================================
C
      CALL WS_TGROUP
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C=======================================================================
C
      SUBROUTINE WS_GRUPTD(IFTETR)
C=======================================================================
      USE params
C=======================================================================
      COMPLEX
     *          EWAVEF,C_TERM,CTERM1,CTERM2,CHARCT,CPHASE,
     *                                             UNIT_I
      DIMENSION
     *          CPHASE(0:NDMAIN,0:NDMAIN)
      DIMENSION
     *          RPHASE(0:(NDMAIN+NDMAIN))
C
      COMMON
     *       /SETBAS_NXNYNZ/ NXVECT(1:NDBASE),
     *                       NYVECT(1:NDBASE),
     *                       NZVECT(1:NDBASE)
      COMMON
     *       /SETBAS_INDICE/ INDICE(0:NDXMAX,0:NDYMAX,0:NDZMAX)
      COMMON
     *       /SPECTR_ESINGP/ ESINGP(1:NDBASE),PARITY(1:NDBASE)
      COMMON
     *       /SPECTR_SPINOR/ EWAVEF(1:NDBASE,1:NDBASE)
      COMMON
     *       /GRUPTD_REPREZ/ NREPRE(1:NDBASE)
      COMMON
     *       /SETBAS_DIMENS/ LDBASE
C
      DATA
     *        UNIT_I / (0.0D0,1.0D0) /,
     *        ZERO_C / (0.0D0,0.0D0) /
      DATA
     *        EPSPAR / 0.1D-1 /,
     *        EPSENE / 0.02D0 /
      DATA
     *        PRECIS / 2.D-1 /
C
C=======================================================================
C
C         This subroutine  analyses the single particle spectrum with
C         the tetrahedral symmetry attributing to each level an index
C         of the irreducible representation  of the double T_d  group
C
C=======================================================================
C
      IF (IFTETR.EQ.0) RETURN
C
C=======================================================================
C         NOTATION: States belonging to 4-dimensional reprezentations
C         have NREPRE=3, states belonging to two-dimensional represnt
C         have NREPRE=1 or 2.
C=======================================================================
C
      SQRT_2=SQRT(2.0)
C
      EXACP2=+SQRT_2
      EXACM2=-SQRT_2
C
      RPHASE(0)=1
C
      DO INDACT=1,NDMAIN+NDMAIN
         RPHASE(INDACT)=-RPHASE(INDACT-1)
      END DO
C
      DO NXNUMB=0,NDMAIN
         DO NYNUMB=0,NDMAIN
            CPHASE(NXNUMB,NYNUMB)=UNIT_I**(NYNUMB-NXNUMB)*CMPLX(1,-1)
     *                           +UNIT_I**(NXNUMB-NYNUMB)*CMPLX(1,+1)
         END DO
      END DO
C
      DO LSTATE=1,NDBASE
         NREPRE(LSTATE)=-1
      END DO
C
C=======================================================================
C
      DO INDNIU=1,LDBASE-1
C
         DO INDPRM=INDNIU+1,LDBASE
C
            IF (ABS(PARITY(INDNIU)-PARITY(INDPRM)).LT.EPSPAR) THEN
C
                IF (ABS(ESINGP(INDNIU)-ESINGP(INDPRM)).LT.EPSENE) THEN
C
                    IF (NREPRE(INDNIU).EQ.-1.AND.NREPRE(INDPRM).EQ.-1)
     *
     *                                                            THEN
C                   Calculating the character of 'I * C_4z' within
C                                    a 4-fold degenerate multiplet
                    CTERM1=ZERO_C
                    CTERM2=ZERO_C
C
                    DO INDBAS=1,LDBASE
C
                       NXNUMB=NXVECT(INDBAS)
                       NYNUMB=NYVECT(INDBAS)
                       NZNUMB=NZVECT(INDBAS)
C
                       INDEX1=INDICE(NYNUMB,NXNUMB,NZNUMB)
                       INDEX2=INDICE(NXNUMB,NYNUMB,NZNUMB)
C
                       CTERM1=CTERM1+CONJG(EWAVEF(INDEX1,INDNIU))
     *                              *      EWAVEF(INDEX2,INDNIU)
     *                              *      CPHASE(NXNUMB,NYNUMB)
     *                              *      RPHASE(NXNUMB+NZNUMB)
C
                       CTERM2=CTERM2+CONJG(EWAVEF(INDEX1,INDPRM))
     *                              *      EWAVEF(INDEX2,INDPRM)
     *                              *      CPHASE(NXNUMB,NYNUMB)
     *                              *      RPHASE(NXNUMB+NZNUMB)
C
                    END DO
C
                    CHARCT=CTERM1+CTERM2
                    CHARCT=CHARCT/SQRT_2
C
                    IF (ABS(CHARCT).LT.PRECIS) THEN
                        NREPRE(INDNIU)=+3
                        NREPRE(INDPRM)=+3
                    END IF
C
                END IF
C
                END IF
C
            END IF
C
         END DO
C
      END DO
C
C=======================================================================
C        The last, 'security' passage: the characters for the protons
C        are actually calculated with the lesser precision, if we use
C        the same number of Gauss integration points in all the three
C        directions. On the one hand to keep this symmetry  is useful
C        in order to achieve  the highest possible precision in terms
C        of the degeneracies; on the other hand it influences Coulomb
C        denominators ...
C=======================================================================
C
      DO INDNIU=1,LDBASE-1
C
         DO INDPRM=INDNIU+1,LDBASE
C
            IF (NREPRE(INDNIU).EQ.-1.AND.NREPRE(INDPRM).EQ.-1) THEN
C
                IF (ABS(PARITY(INDNIU)-PARITY(INDPRM)).LT.0.1*EPSPAR)
     *                                                         THEN
C
                    IF (ABS(ESINGP(INDNIU)-ESINGP(INDPRM)).LT.EPSENE)
     *                                                         THEN
C                       Here:  only the degeneracy criterion
C                       including a stronger limit on parity...
C
                        NREPRE(INDNIU)=3
                        NREPRE(INDPRM)=3
C
                    END IF
C
                END IF
C
            END IF
C
         END DO
C
      END DO
C
C=======================================================================
C        Below proceeding with the two-dimensional reprezentations
C=======================================================================
C
      DO INDNIU=1,LDBASE
C
         IF (NREPRE(INDNIU).NE.3) THEN
C
             C_TERM=ZERO_C
C
             DO INDBAS=1,LDBASE
C
                NXNUMB=NXVECT(INDBAS)
                NYNUMB=NYVECT(INDBAS)
                NZNUMB=NZVECT(INDBAS)
C
                INDEX1=INDICE(NYNUMB,NXNUMB,NZNUMB)
                INDEX2=INDICE(NXNUMB,NYNUMB,NZNUMB)
C
                C_TERM=C_TERM+CONJG(EWAVEF(INDEX1,INDNIU))
     *                       *      EWAVEF(INDEX2,INDNIU)
     *                       *      CPHASE(NXNUMB,NYNUMB)
     *                       *      RPHASE(NXNUMB+NZNUMB)
C
             END DO
C
             CHARCT=C_TERM/SQRT_2
C
             IF (ABS(CHARCT-EXACP2).LT.PRECIS) THEN
                 NREPRE(INDNIU)=1
             END IF
C
             IF (ABS(CHARCT-EXACM2).LT.PRECIS) THEN
                 NREPRE(INDNIU)=2
             END IF
C
         END IF
C
      END DO
C
C=======================================================================
C        The last, 'security' passage: the characters for the protons
C        are actually calculated with the lesser precision, if we use
C        the same number of Gauss integration points in all the three
C        directions. On the one hand to keep this symmetry  is useful
C        in order to achieve  the highest possible precision in terms
C        of the degeneracies; on the other hand it influences Coulomb
C        denominators ...
C=======================================================================
C
      DO INDNIU=1,LDBASE-1
C
         DO INDPRM=INDNIU+1,LDBASE
C
            IF (NREPRE(INDNIU).EQ.-1.AND.NREPRE(INDPRM).EQ.-1) THEN
C
                IF (ABS(PARITY(INDNIU)-PARITY(INDPRM)).LT.EPSPAR)
     *                                                        THEN
C
                IF (ABS(ESINGP(INDNIU)-ESINGP(INDPRM)).LT.EPSENE)
     *                                                        THEN
C                   Here: only the degeneracy criterion ...
C
                    NREPRE(INDNIU)=3
                    NREPRE(INDPRM)=3
C
                END IF
C
                END IF
C
            END IF
C
         END DO
C
      END DO
C
C=======================================================================
C        Below proceeding with the two-dimensional reprezentations:
C        again the last resort scanning ...
C=======================================================================
C
      DO INDNIU=1,LDBASE
C
         IF (NREPRE(INDNIU).LT.0) THEN
C
             C_TERM=ZERO_C
C
             DO INDBAS=1,LDBASE
C
                NXNUMB=NXVECT(INDBAS)
                NYNUMB=NYVECT(INDBAS)
                NZNUMB=NZVECT(INDBAS)
C
                INDEX1=INDICE(NYNUMB,NXNUMB,NZNUMB)
                INDEX2=INDICE(NXNUMB,NYNUMB,NZNUMB)
C
                C_TERM=C_TERM+CONJG(EWAVEF(INDEX1,INDNIU))
     *                       *      EWAVEF(INDEX2,INDNIU)
     *                       *      CPHASE(NXNUMB,NYNUMB)
     *                       *      RPHASE(NXNUMB+NZNUMB)
C
             END DO
C
             CHARCT=C_TERM/SQRT_2
C
C            ... here only the sign criterion ...
C
             IF (REAL(CHARCT).GT.0.0) THEN
                 NREPRE(INDNIU)=1
             ELSE
                 NREPRE(INDNIU)=2
             END IF
C
         END IF
C
      END DO
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C=======================================================================
C
      SUBROUTINE WS_GRUPOH(IFOKTR)
C=======================================================================
      USE params
C=======================================================================
      COMPLEX
     *          EWAVEF,C_TERM,CTERM1,CTERM2,CHARCT,CPHASE,
     *                                             UNIT_I
      DIMENSION
     *          CPHASE(0:NDMAIN,0:NDMAIN)
      DIMENSION
     *          RPHASE(0:(NDMAIN+NDMAIN))
C
      COMMON
     *       /SETBAS_NXNYNZ/ NXVECT(1:NDBASE),
     *                       NYVECT(1:NDBASE),
     *                       NZVECT(1:NDBASE)
      COMMON
     *       /SETBAS_INDICE/ INDICE(0:NDXMAX,0:NDYMAX,0:NDZMAX)
      COMMON
     *       /SPECTR_ESINGP/ ESINGP(1:NDBASE),PARITY(1:NDBASE)
     *       /SPECTR_SPINOR/ EWAVEF(1:NDBASE,1:NDBASE)
      COMMON
     *       /GRUPTD_REPREZ/ NREPRE(1:NDBASE)
      COMMON
     *       /SETBAS_DIMENS/ LDBASE
C
      DATA
     *        UNIT_I / (0,1) /,
     *        ZERO_C / (0,0) /
      DATA
     *        EPSPAR / 0.001 /,
     *        EPSENE / .2E-3 /
      DATA
     *        PRECIS / .2000 /
C
C=======================================================================
C
C         This subroutine  analyses the single particle spectrum with
C         the oktahedral symmetry  attributing to each level an index
C         of the irreducible representation  of the double O_h  group
C
C=======================================================================
C
      IF (IFOKTR.EQ.0) RETURN
C
C=======================================================================
C         NOTATION: States belonging to 4-dimensional reprezentations
C         have NREPRE=3 and NREPRE=6, for parities equal to +1 and -1,
C         respectively, and states belonging to two-dimensional repre-
C         sentations have NREPRE=1, 2, 4 or 5
C=======================================================================
C
      SQRT_2=SQRT(2.0)
C
      EXACP2=+SQRT_2
      EXACM2=-SQRT_2
C
      RPHASE(0)=1
C
      DO INDACT=1,NDMAIN+NDMAIN
         RPHASE(INDACT)=-RPHASE(INDACT-1)
      END DO
C
      DO NXNUMB=0,NDMAIN
         DO NYNUMB=0,NDMAIN
            CPHASE(NXNUMB,NYNUMB)=UNIT_I**(NYNUMB-NXNUMB)*CMPLX(1,-1)
     *                           +UNIT_I**(NXNUMB-NYNUMB)*CMPLX(1,+1)
         END DO
      END DO
C
      DO LSTATE=1,NDBASE
         NREPRE(LSTATE)=-1
      END DO
C
C=======================================================================
C
      DO INDNIU=1,LDBASE-1
C
         DO INDPRM=INDNIU+1,LDBASE
C
            IF (ABS(PARITY(INDNIU)-PARITY(INDPRM)).LT.EPSPAR) THEN
C
                IF (ABS(ESINGP(INDNIU)-ESINGP(INDPRM)).LT.EPSENE) THEN
C
                    IF (NREPRE(INDNIU).EQ.-1.AND.NREPRE(INDPRM).EQ.-1)
     *
     *                                                              THEN
C                   Calculating the character of 'C_4z' within a
C                                    4-fold degenerate multiplet
                    CTERM1=ZERO_C
                    CTERM2=ZERO_C
C
                    DO INDBAS=1,LDBASE
C
                       NXNUMB=NXVECT(INDBAS)
                       NYNUMB=NYVECT(INDBAS)
                       NZNUMB=NZVECT(INDBAS)
C
                       INDEX1=INDICE(NYNUMB,NXNUMB,NZNUMB)
                       INDEX2=INDICE(NXNUMB,NYNUMB,NZNUMB)
C
                       CTERM1=CTERM1+CONJG(EWAVEF(INDEX1,INDNIU))
     *                              *      EWAVEF(INDEX2,INDNIU)
     *                              *      CPHASE(NXNUMB,NYNUMB)
     *                              *      RPHASE(NYNUMB)
C
                       CTERM2=CTERM2+CONJG(EWAVEF(INDEX1,INDPRM))
     *                              *      EWAVEF(INDEX2,INDPRM)
     *                              *      CPHASE(NXNUMB,NYNUMB)
     *                              *      RPHASE(NYNUMB)
                    END DO
C
                    CHARCT=CTERM1+CTERM2
                    CHARCT=CHARCT/SQRT_2
C
                    IF (ABS(CHARCT).LT.PRECIS) THEN
                        IF (PARITY(INDNIU).GT.0.0) THEN
                            NREPRE(INDNIU)=3
                        ELSE
                            NREPRE(INDNIU)=6
                        END IF
                        IF (PARITY(INDPRM).GT.0.0) THEN
                            NREPRE(INDPRM)=3
                        ELSE
                            NREPRE(INDPRM)=6
                        END IF
                    END IF
C
                END IF
C
                END IF
C
            END IF
C
         END DO
C
      END DO
C
C=======================================================================
C        ...below trivially copied second scanning with 100 * EPSENE
C=======================================================================
C
      DO INDNIU=1,LDBASE-1
C
         DO INDPRM=INDNIU+1,LDBASE
C
            IF (ABS(PARITY(INDNIU)-PARITY(INDPRM)).LT.EPSPAR) THEN
C
                IF (ABS(ESINGP(INDNIU)-ESINGP(INDPRM)).LT.100*EPSENE)
     *                                                         THEN
C
                    IF (NREPRE(INDNIU).EQ.-1.AND.NREPRE(INDPRM).EQ.-1)
     *
     *                                                          THEN
C                   Calculating the character of 'C_4z' within a
C                                    4-fold degenerate multiplet
                    CTERM1=ZERO_C
                    CTERM2=ZERO_C
C
                    DO INDBAS=1,LDBASE
C
                       NXNUMB=NXVECT(INDBAS)
                       NYNUMB=NYVECT(INDBAS)
                       NZNUMB=NZVECT(INDBAS)
C
                       INDEX1=INDICE(NYNUMB,NXNUMB,NZNUMB)
                       INDEX2=INDICE(NXNUMB,NYNUMB,NZNUMB)
C
                       CTERM1=CTERM1+CONJG(EWAVEF(INDEX1,INDNIU))
     *                              *      EWAVEF(INDEX2,INDNIU)
     *                              *      CPHASE(NXNUMB,NYNUMB)
     *                              *      RPHASE(NYNUMB)
C
                       CTERM2=CTERM2+CONJG(EWAVEF(INDEX1,INDPRM))
     *                              *      EWAVEF(INDEX2,INDPRM)
     *                              *      CPHASE(NXNUMB,NYNUMB)
     *                              *      RPHASE(NYNUMB)
                    END DO
C
                    CHARCT=CTERM1+CTERM2
                    CHARCT=CHARCT/SQRT_2
C
                    IF (ABS(CHARCT).LT.PRECIS) THEN
                        IF (PARITY(INDNIU).GT.0.0) THEN
                            NREPRE(INDNIU)=3
                        ELSE
                            NREPRE(INDNIU)=6
                        END IF
                        IF (PARITY(INDPRM).GT.0.0) THEN
                            NREPRE(INDPRM)=3
                        ELSE
                            NREPRE(INDPRM)=6
                        END IF
                    END IF
C
                END IF
C
                END IF
C
            END IF
C
         END DO
C
      END DO
C
C=======================================================================
C        ... while below, proceeding to identify two-dimensional
C            irreducible representations of the oktahedral group
C=======================================================================
C
      DO INDNIU=1,LDBASE
C
         IF (NREPRE(INDNIU).EQ.-1) THEN
C
             C_TERM=ZERO_C
C
             DO INDBAS=1,LDBASE
C
                NXNUMB=NXVECT(INDBAS)
                NYNUMB=NYVECT(INDBAS)
                NZNUMB=NZVECT(INDBAS)
C
                INDEX1=INDICE(NYNUMB,NXNUMB,NZNUMB)
                INDEX2=INDICE(NXNUMB,NYNUMB,NZNUMB)
C
                C_TERM=C_TERM+CONJG(EWAVEF(INDEX1,INDNIU))
     *                       *      EWAVEF(INDEX2,INDNIU)
     *                       *      CPHASE(NXNUMB,NYNUMB)
     *                       *      RPHASE(NYNUMB)
C
             END DO
C
             CHARCT=C_TERM/SQRT_2
C
             IF (ABS(CHARCT-EXACP2).LT.PRECIS) THEN
C
                 IF (PARITY(INDNIU).GT.0.0) THEN
                     NREPRE(INDNIU)=1
                 ELSE
                     NREPRE(INDNIU)=4
                 END IF
C
             END IF
C
             IF (ABS(CHARCT-EXACM2).LT.PRECIS) THEN
C
                 IF (PARITY(INDNIU).GT.0.0) THEN
                     NREPRE(INDNIU)=2
                 ELSE
                     NREPRE(INDNIU)=5
                 END IF
C
             END IF
C
         END IF
C
      END DO
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C=======================================================================
C
      SUBROUTINE WS_VERIFS(LAMMAX,ALPHAC,NDLAMB)
      COMPLEX
     *        ALPHAC(0:NDLAMB,-NDLAMB:+NDLAMB)
C
      COMMON
     *       /VERIFS_SYMETS/ ISPHER,ICYLIN,IPCONS
C
      COMMON
     *       /READWRITE_PAR/ NOUTPT,IWRITE,ISCREN
C
      DATA
     *     EPSDEF / 0.0000001 /
C
C=======================================================================
C         This subroutine tests the ensemble of defomation parameters
C         in order to verify, whether or not,  the spherical symmetry,
C         the axial symmetry and  the parity are preserved symmetries
C=======================================================================
C
      ISPHER=1
      ICYLIN=1
      IPCONS=1
C
C=======================================================================
C         Verifying the presence sphericity
C=======================================================================
C
      DO LAMBDA=1,LAMMAX
         DO MIUACT=0,LAMBDA
            IF (CABS(ALPHAC(LAMBDA,MIUACT)).GT.EPSDEF) THEN
                ISPHER=0
            END IF
         END DO
      END DO
C
C=======================================================================
C         Verifying the presence of an axial symmetry (Oz)
C=======================================================================
C
      DO LAMBDA=1,LAMMAX
         DO MIUACT=1,LAMBDA
            IF (CABS(ALPHAC(LAMBDA,MIUACT)).GT.EPSDEF) THEN
                ICYLIN=0
            END IF
         END DO
      END DO
C
C=======================================================================
C         Verifying the presence of parity as a symmetry;
C
C         IPCONS=0 (parity not-conserved <=> ISIGNY=0 i.e.
C                   signature not conserved since in this
C                   version of the program SIMPLEX_Y must
C                   always be conserved)
C=======================================================================
C
      DO LAMBDA=1,LAMMAX,2
         DO MIUACT=0,LAMBDA
            IF (CABS(ALPHAC(LAMBDA,MIUACT)).GT.EPSDEF) THEN
                IPCONS=0
            END IF
         END DO
      END DO
C
C=======================================================================
C
      IF (IWRITE.GT.1) THEN
C
          IF (ISPHER.EQ.1) THEN
C
              WRITE(NOUTPT,'(/,80(''#''),/,''#'',78X,''#'',/,
     *                ''#  Automatic symmetry verification:   '',
     *                ''    Hamiltonian has spherical symmetry   #'',/,
     *                ''#'',78X,''#'',/,80(''#''))')
              RETURN
C
          END IF
C
C=======================================================================
C
          IF (ICYLIN.EQ.1) THEN
C
              IF (IPCONS.EQ.1) THEN
C
                  WRITE(NOUTPT,'(/,80(''#''),/,''#'',78X,''#'',/,
     *                    ''#  Automatic symmetry verification:     '',
     *                    ''Hamiltonian has cylindrical symmetry   #'',
     *                    /,
     *                    ''#                                       '',
     *                    ''and  a l s o   a reflection symmetry   #'',
     *                    /,''#'',78X,''#'',/,80(''#''))')
                  RETURN
C
              ELSE
C
                  WRITE(NOUTPT,'(/,80(''#''),/,''#'',78X,''#'',/,
     *                    ''#  Automatic symmetry verification:     '',
     *                    ''Hamiltonian has cylindrical symmetry   #'',
     *                    /,''#'',78X,''#'',/,80(''#''))')
                  RETURN
C
              END IF
C
          END IF
C
C=======================================================================
C
          IF (IPCONS.EQ.1) THEN
C
              WRITE(NOUTPT,'(/,80(''#''),/,''#'',78X,''#'',/,
     *                ''#  Automatic symmetry verification:   '',
     *                ''   Hamiltonian has reflection symmetry   #'',/,
     *                ''#                                     '',
     *                ''   and thus also a signature  symmetry   #'',/,
     *                ''#'',78X,''#'',/,80(''#''))')
C
          END IF
C
      END IF
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C=======================================================================
C
      SUBROUTINE WS_TESIGN(ISIGNY,IAUTOM,ALPHAC,NDLAMB)
      COMPLEX
     *          ALPHAC(0:NDLAMB,-NDLAMB:+NDLAMB)
C
      COMMON
     *       /READWRITE_PAR/ NOUTPT,IWRITE,ISCREN
C
C=======================================================================
C
C     This subroutine verifies whether the y-signature is a conserved
C     quantity. If this is the case and IAUTOM=1 the routine will set
C     ISIGNY=1 (y-signature conserved).  The user may enforce working
C     without formally conserving  the signature by setting  IAUTOM=0
C     and defining ISIGNY=0 OR 1 through the routine NAMELI.  When it
C     happens  that the actual deformation does not allow to preserve
C     the y-signature, this routine will set ISIGNY=0.

C
C=======================================================================
C
C     In the present version  it is sufficient to verify conservation
C     (or not) of parity of the hamiltonian. In such a case signature
C     is conserved  if the parity is conserved  since the hamiltonian
C     must always conserve the y-simplex and we have the relation:
C
C                          Y_SIMPLEX=PARITY*Y_SIGNATURE
C
C     We define ISIGNY=1 if the signature is conserved -->> otherwise
C     ISIGNY=0;  by default we set ISIGNY=0.
C
C=======================================================================
C
      IVERIF=1
C
      DO LAMBDA=1,NDLAMB,2
         DO MIU=0,LAMBDA
            IF (ABS(ALPHAC(LAMBDA,MIU)).GT.1.0E-6) IVERIF=0
         END DO
      END DO
C
C=======================================================================
C
      IF (IVERIF.EQ.1) THEN ! Signature is conserved
C
          IF (IAUTOM.EQ.1) THEN
C
              ISIGNY=1
C
              IF (IWRITE.GE.3) THEN
C
                  WRITE(NOUTPT,'(/,80(''!''),/,''!'',78X,''!'',/,
     *                  ''!  Following the option of automatic '',
     *                  ''selection ( IAUTOM=1 ) the program sets   !'',
     *                                                               /,
     *                  ''!  ISIGNY=1  since this deformation does'',
     *                  '' not contain odd - lambda multipoles   !'',/,
     *                  ''!  This means that the diagonalisations '',
     *                  ''will be done in four indepnt. blocks   !'',/,
     *                  ''!'',78X,''!'',/,80(''!''),/)')
C
              END IF
              RETURN
          ELSE
C
              IF (IWRITE.GE.3) THEN
C
                  WRITE(NOUTPT,'(/,80(''!''),/,''!'',78X,''!'',/,
     *               ''!  Suggestion:       This data set allows for'',
     *                  '' parity conservation to be used   !'',/,
     *                  ''!                    CPU time will be saved'',
     *                  '' if you use ISIGNY=1 or  IAUTOM=1   !'',/,
     *                  ''!'',78X,''!'',/,80(''!''),/)')
C
              END IF
              RETURN
C
          END IF
C
      ELSE
C
          IF (ISIGNY.EQ.1) THEN
C
              IF (IWRITE.GE.3) THEN
C
                  WRITE(NOUTPT,'(//,80(''!''),/,''!'',78X,''!'',/,
     *                  ''!   Warning! This deformation does not '',
     *                  ''allow for SIGNATURE_X/Y conservation    !'',/,
     *                  ''!            nevertheless the parameter'',
     *                  ''  ISIGNY  was equal to 1 ==>> ERRORS    !'',/,
     *                  ''!            The program enforces  '',
     *              ''ISIGNY=0  to avoid producing meaningless    !'',/,
     *                  ''!                                      '',
     *                  ''                       r e s u l t s    !'',/,
     *                  ''!'',78X,''!'',/,80(''!''))')
C
              END IF
C
              ISIGNY=0
C
          END IF
C
      END IF
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C=======================================================================
C
      SUBROUTINE WS_TSSYM1
C
      EXTERNAL
     *          WS_XPOSIT,WS_YPOSIT,WS_ZPOSIT,
     *          WS_XMINUS,WS_YMINUS,WS_ZMINUS
      LOGICAL
     *          SYM_XY,SYM_YZ,SYM_ZX
      CHARACTER
     *          STRING*132
C
      COMMON
     *       /TSSYM1_SYMME1/ SYM_XY,SYM_YZ,SYM_ZX
C
      COMMON
     *       /READWRITE_PAR/ NOUTPT,IWRITE,ISCREN
C
C=======================================================================
C
C         This routine tests the existence (or not)  of  the three
C         symmetry planes indicated in the nuclear surface defined
C         in terms of the routine RONSUR. The  auxiliary points in
C         the Cartesian space are chosen arbitrarily
C
C=======================================================================
C
      SYM_XY=.TRUE.
      SYM_YZ=.TRUE.
      SYM_ZX=.TRUE.
C
C=======================================================================
C        T E S T I N G   T H E  X-Y  P L A N E   S Y M M E T R Y
C=======================================================================
C
      CALL WS_SYMTRS(WS_XPOSIT,WS_YPOSIT,WS_ZMINUS,SYM_XY)
C
C=======================================================================
C        T e s t i n g   t h e  y-z  p l a n e   s y m m e t r y
C=======================================================================
C
      CALL WS_SYMTRS(WS_XMINUS,WS_YPOSIT,WS_ZPOSIT,SYM_YZ)
C
C=======================================================================
C        T e s t i n g   t h e  z-x  p l a n e   s y m m e t r y
C=======================================================================
C
      CALL WS_SYMTRS(WS_XPOSIT,WS_YMINUS,WS_ZPOSIT,SYM_ZX)
C
C=======================================================================
C        Printing information  about  symmetries  of the surface
C=======================================================================
C
      IF (IWRITE.GT.2) THEN
C
          WRITE(NOUTPT,'(//,80(''#''),/,''#'',78X,''#'',/,
     *             ''#  S y m m e t r i e s  o f  t h e  '',
     *             ''N u c l e a r  S h a p e :        Planes   #'')')
C
          IF (SYM_XY) THEN
              WRITE(STRING(1:39),'(''#  X-Y PL =>> '',''! SYMMETRY !'',
     *                             ''  Y-Z PL =>> '')')
          ELSE
              WRITE(STRING(1:39),'(''#  X-Y PL =>> '',''NO SYMMETRY '',
     *                             ''  Y-Z PL =>> '')')
          END IF
C
          IF (SYM_YZ) THEN
              WRITE(STRING(40:63),'(''! SYMMETRY !'','' Z-X PL =>> '')')
          ELSE
              WRITE(STRING(40:63),'(''NO SYMMETRY '','' Z-X PL =>> '')')
          END IF
C
          IF (SYM_ZX) THEN
              WRITE(STRING(64:80),'('' ! SYMMETRY !   #'')')
          ELSE
              WRITE(STRING(64:80),'('' NO SYMMETRY    #'')')
          END IF
C
          WRITE(NOUTPT,'(''#'',78X,''#'',/,A80,/,''#'',78X,''#'',
     *                                         /,80(''#''))') STRING
C
      END IF
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C=======================================================================
C
      SUBROUTINE WS_TSSYM2
      EXTERNAL
     *          WS_XMINUS,WS_YMINUS,WS_ZMINUS
      LOGICAL
     *          PARITE
      CHARACTER
     *          STRING*132
C
      COMMON
     *       /TSSYM2_SYMME3/ PARITE
      COMMON
     *       /READWRITE_PAR/ NOUTPT,IWRITE,ISCREN
C
C=======================================================================
C
C        This subroutine tests the existence (or not) of the parity
C        symmetry  h i d d e n  in the  nuclear surface  defined in
C        terms of the routine RONSUR. Auxiliary points in Cartesian
C        space are chosen arbitrarily.
C
C=======================================================================
C
      PARITE=.TRUE.
C
C=======================================================================
C        T e s t i n g     t h e     p a r i t y    s y m m e t r y
C=======================================================================
C
      CALL WS_SYMTRS(WS_XMINUS,WS_YMINUS,WS_ZMINUS,PARITE)
C
C=======================================================================
C        Printing the information about the symmetries of the shape
C=======================================================================
C
      IF (IWRITE.GT.2) THEN
C
          IF (PARITE) THEN
              WRITE(STRING(1:80),
     *        '(''#  Parity  !!CONSERVED!!     Parity  '',
     *          ''!!CONSERVED!!     Parity  !!CONSERVED!!   #'')')
          ELSE
              WRITE(STRING(1:80),
     *        '(''#  Parity  NOT CONSERVED     Parity  NOT CONSERVED'',
     *          ''     Parity  NOT CONSERVED   #'')')
          END IF
C
          WRITE(NOUTPT,'(''#'',78X,''#'',/,A80,/,''#'',78X,''#'',
     *                                         /,80(''#''))') STRING
C
      END IF
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C=======================================================================
C
      SUBROUTINE WS_TSSYM3
      EXTERNAL
     *          WS_XPOSIT,WS_YPOSIT,WS_ZPOSIT,
     *          WS_XMINUS,WS_YMINUS,WS_ZMINUS
      LOGICAL
     *          ROT_AX,ROT_AY,ROT_AZ
C
      CHARACTER
     *          STRING*132
C
      COMMON
     *       /TSSYM3_SYMME2/ ROT_AX,ROT_AY,ROT_AZ
      COMMON
     *       /READWRITE_PAR/ NOUTPT,IWRITE,ISCREN
C
C=======================================================================
C
C        This routine tests the existence  (or not)  of  the three
C        symmetry axes (rotation angles 180 around x,y and z axes)
C        contained in the  nuclear  s u r f a c e  that is defined
C        in routine RONSUR. The auxiliary points  in the Cartesian
C        space are chosen arbitrarily.
C
C=======================================================================
C
      ROT_AX=.TRUE.
      ROT_AY=.TRUE.
      ROT_AZ=.TRUE.
C
C=======================================================================
C        T e s t i n g    t h e    x  -  a x i s   s y m m e t r y
C=======================================================================
C
      CALL WS_SYMTRS(WS_XPOSIT,WS_YMINUS,WS_ZMINUS,ROT_AX)
C
C=======================================================================
C        T e s t i n g    t h e    y  -  a x i s   s y m m e t r y
C=======================================================================
C
      CALL WS_SYMTRS(WS_XMINUS,WS_YPOSIT,WS_ZMINUS,ROT_AY)
C
C=======================================================================
C        T e s t i n g    t h e    z  -  a x i s   s y m m e t r y
C=======================================================================
C
      CALL WS_SYMTRS(WS_XMINUS,WS_YMINUS,WS_ZPOSIT,ROT_AZ)
C
C=======================================================================
C        Printing information  about the symmetries of the surface
C=======================================================================
C
      IF (IWRITE.GT.2) THEN
C
          WRITE(NOUTPT,'(//,80(''#''),/,''#'',78X,''#'',/,
     *               ''#  N u c l e a r  S h a p e :              '',
     *               ''R o t a t i o n  A x e s (pi=180)   #'')')
C
          IF (ROT_AX) THEN
              WRITE(STRING(1:39),'(''#  X-axis =>> '',''! SYMMETRY !'',
     *                                             ''  Y-axis =>> '')')
          ELSE
              WRITE(STRING(1:39),'(''#  X-axis =>> '',''NO SYMMETRY '',
     *                                             ''  Y-axis =>> '')')
          END IF
C
          IF (ROT_AY) THEN
             WRITE(STRING(40:64),'(''! SYMMETRY !'',''  Z-axis =>> '')')
          ELSE
             WRITE(STRING(40:64),'(''NO SYMMETRY '',''  Z-axis =>> '')')
          END IF
C
          IF (ROT_AZ) THEN
              WRITE(STRING(65:80),'(''! SYMMETRY !   #'')')
          ELSE
              WRITE(STRING(65:80),'(''NO SYMMETRY    #'')')
          END IF
C
          WRITE(NOUTPT,'(''#'',78X,''#'',/,A80,/,''#'',78X,''#'',
     *                                         /,80(''#''))') STRING
C
      END IF
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C=======================================================================
C
      SUBROUTINE WS_TSSYM4
      EXTERNAL
     *          WS_XPOSIT,WS_YPOSIT,WS_ZPOSIT,WS_XMINUS,WS_YMINUS
      CHARACTER
     *          STRING*132
      LOGICAL
     *          SIGMA1,SIGMA2
C
      COMMON
     *       /TSSYM4_SYMME4/ SIGMA1,SIGMA2
      COMMON
     *       /READWRITE_PAR/ NOUTPT,IWRITE,ISCREN
C
C=======================================================================
C
C        This subroutine tests the existence  (or not)  of the two
C        symmetry planes indicated, in the nuclear surface defined
C        by the routine RONSUR.  Auxiliary points in the Cartesian
C        space are chosen arbitrarily.
C
C=======================================================================
C
      SIGMA1=.TRUE.
      SIGMA2=.TRUE.
C
C=======================================================================
C        Testing   the   plane 1 (x=y)  symmetry
C=======================================================================
C
      CALL WS_SYMTRS(WS_YPOSIT,WS_XPOSIT,WS_ZPOSIT,SIGMA1)
C
C=======================================================================
C        Testing   the   plane 2 (x=-y)  symmetry
C=======================================================================
C
      CALL WS_SYMTRS(WS_YMINUS,WS_XMINUS,WS_ZPOSIT,SIGMA2)
C
C=======================================================================
C        Printing information about the symmetries of the surface
C=======================================================================
C
      IF (IWRITE.GT.2) THEN
C
          WRITE(NOUTPT,'(//,80(''#''),/,''#'',78X,''#'',/,
     *          ''#  S y m m e t r i e s  w i t h  '',
     *          ''r e s p e c t   t o   s p e c i a l  planes   #'')')
C
          IF (SIGMA1) THEN
              WRITE(STRING(1:42),
     *            '(''#  Plane 1 => (x=+y) => ! SYMMETRY !      '')')
          ELSE
              WRITE(STRING(1:42),
     *            '(''#  Plane 1 => (x=+y) => NO SYMMETRY       '')')
          END IF
C
          IF (SIGMA2) THEN
              WRITE(STRING(43:80),
     *                 '('' Plane 2 => (x=-y) => ! SYMMETRY !   #'')')
          ELSE
              WRITE(STRING(43:80),
     *                 '('' Plane 2 => (x=-y) =>> NO SYMMETRY   #'')')
          END IF
C
          WRITE(NOUTPT,'(''#'',78X,''#'',/,A80,/,''#'',78X,''#'',
     *                                         /,80(''#''))') STRING
C
      END IF
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C=======================================================================
C
      SUBROUTINE WS_TSSYM5
      EXTERNAL
     *         WS_XPOSIT,WS_YPOSIT,WS_XMINUS,WS_YMINUS,WS_ZMINUS
C
      CHARACTER
     *          STRING*132
      LOGICAL
     *          REFRO1,REFRO2
C
      COMMON
     *       /TSSYM5_SYMME5/ REFRO1,REFRO2
      COMMON
     *       /READWRITE_PAR/ NOUTPT,IWRITE,ISCREN
C
C=======================================================================
C
C        This subroutine tests the existence (or not) of the two
C        reflection-rotary  axes  of the nuclear surface defined
C        by subroutine RONSUR. Auxiliary points in the Cartesian
C        space are chosen arbitrarily.
C
C=======================================================================
C
      REFRO1=.TRUE.
      REFRO2=.TRUE.
C
C=======================================================================
C        Testing  the first  reflection - rotary  axis  symmetry
C=======================================================================
C
      CALL WS_SYMTRS(WS_YMINUS,WS_XPOSIT,WS_ZMINUS,REFRO1)
C
C=======================================================================
C        Testing  the second  reflection - rotary  axis symmetry
C=======================================================================
C
      CALL WS_SYMTRS(WS_YPOSIT,WS_XMINUS,WS_ZMINUS,REFRO2)
C
C=======================================================================
C        Printing information about the symmetries of the surface
C=======================================================================
C
      IF (IWRITE.GT.2) THEN
C
          WRITE(NOUTPT,'(//,80(''#''),/,''#'',78X,''#'',/,
     *            ''#  S y m m e t r i e s   w i t h   '',
     *            ''r e s p e c t   t o  R o t a r y  A x e s   #'')')
C
          IF (REFRO1) THEN
              WRITE(STRING(1:42),
     *           '(''#  Ref-Rot =>> (S4) =>> ! SYMMETRY !      '')')
          ELSE
              WRITE(STRING(1:42),
     *           '(''#  Ref-Rot =>> (S4) =>>  NO SYMMETRY      '')')
          END IF
C
          IF (REFRO2) THEN
              WRITE(STRING(43:80),
     *                 '('' Ref-Rot =>> (S4p) => ! SYMMETRY !   #'')')
          ELSE
              WRITE(STRING(43:80),
     *                 '('' Ref-Rot =>> (S4p) =>> NO SYMMETRY   #'')')
          END IF
C
          WRITE(NOUTPT,'(''#'',78X,''#'',/,A80,/,''#'',78X,''#'',
     *                                         /,80(''#''))') STRING
C
      END IF
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C=======================================================================
C
      SUBROUTINE WS_TSSYM6
      EXTERNAL
     *          WS_RZ120X,WS_RZ120Y,WS_ZPOSIT
      CHARACTER
     *          STRING*132
      LOGICAL
     *          ROTZ_3
      COMMON
     *       /TSSYM6_SYMME6/ ROTZ_3
      COMMON
     *       /READWRITE_PAR/ NOUTPT,IWRITE,ISCREN
C
C=======================================================================
C
C        This subroutine tests the existence (or not) of the 3-fold
C        rotation rotation axis among the symmetries of the nuclear
C        surface  defined by subroutine RONSUR. Auxiliary points in
C        the Cartesian space are chosen arbitrarily.
C
C=======================================================================
C
      ROTZ_3=.TRUE.
C
C=======================================================================
C        T e s t i n g   t h e   3-fold  rotation   s y m m e t r y
C=======================================================================
C
      CALL WS_SYMTRS(WS_RZ120X,WS_RZ120Y,WS_ZPOSIT,ROTZ_3)
C
C=======================================================================
C        Printing information  about the symmetries  of the surface
C=======================================================================
C
      IF (IWRITE.GT.2) THEN
C
          WRITE(NOUTPT,'(//,80(''#''),/,''#'',78X,''#'',/,
     *            ''#  N u c l e a r  S h a p e :         '',
     *            ''R o t a t i o n  A x i s =>> Oz (pi/3)   #'')')
C
          IF (ROTZ_3) THEN
              WRITE(STRING(1:80),
     *             '(''#  ! SYMMETRY !   ! SYMMETRY !   ! SYMMETRY !'',
     *               ''   ! SYMMETRY !    ! SYMMETRY !   #'')')
          ELSE
              WRITE(STRING(1:80),
     *             '(''#  NO SYMMETRY    NO SYMMETRY    NO SYMMETRY'',
     *               ''    NO SYMMETRY      NO SYMMETRY   #'')')
          END IF
C
          WRITE(NOUTPT,'(''#'',78X,''#'',/,A80,/,''#'',78X,''#'',
     *                                         /,80(''#''))') STRING
C
      END IF
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C=======================================================================
C
      SUBROUTINE WS_TSSYMZ
      EXTERNAL
     *          WS_RZ120X,WS_RZ120Y,WS_RZ075X,WS_RZ075Y,
     *          WS_RZQ47X,WS_RZQ47Y,WS_ZPOSIT
      CHARACTER
     *          STRING*132
      LOGICAL
     *          AXIALS
      COMMON
     *       /TSSYMZ_SYMME7/ AXIALS
      COMMON
     *       /READWRITE_PAR/ NOUTPT,IWRITE,ISCREN
C
C=======================================================================
C
C        This subroutine tests the existence (or not) of the axial
C        symmetry contained in the nuclear surface that is defined
C        by subroutine RONSUR.  Auxiliary points  in the Cartesian
C        space are chosen arbitrarily (Here: z-axis).
C
C=======================================================================
C
      AXIALS=.TRUE.
C
C=======================================================================
C        T e s t i n g     t h e     a x i a l     s y m m e t r y
C=======================================================================
C
      CALL WS_SYMTRS(WS_RZ120X,WS_RZ120Y,WS_ZPOSIT,AXIALS)
C
      IF (.NOT.AXIALS)  GO TO 1
C
      CALL WS_SYMTRS(WS_RZ075X,WS_RZ075Y,WS_ZPOSIT,AXIALS)
C
      IF (.NOT.AXIALS)  GO TO 1
C
      CALL WS_SYMTRS(WS_RZQ47X,WS_RZQ47Y,WS_ZPOSIT,AXIALS)
C
C=======================================================================
C        Printing information about the symmetries of the surface
C=======================================================================
C
   1  CONTINUE
C
      IF (IWRITE.GT.2) THEN
C
          WRITE(NOUTPT,'(//,80(''#''),/,''#'',78X,''#'',/,
     *            ''#  N u c l e a r  S h a p e :       '',
     *            ''A x i a l  S y m m e t r y  A x i s - Oz   #'')')
C
          IF (AXIALS) THEN
              WRITE(STRING(1:80),
     *             '(''#  ! SYMMETRY !   ! SYMMETRY !   ! SYMMETRY !'',
     *               ''   ! SYMMETRY !    ! SYMMETRY !   #'')')
          ELSE
              WRITE(STRING(1:80),
     *             '(''#  NO SYMMETRY     NO SYMMETRY    NO SYMMETRY'',
     *               ''     NO SYMMETRY    NO SYMMETRY   #'')')
          END IF
C
          WRITE(NOUTPT,'(''#'',78X,''#'',/,
     *                   A80,/,''#'',78X,''#'',/,80(''#''))') STRING
C
      END IF
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C=======================================================================
C
      SUBROUTINE WS_TSSYMY
      EXTERNAL
     *          WS_RY120X,WS_RY120Z,WS_RY075X,WS_RY075Z,
     *          WS_RYQ49X,WS_RYQ49Z,WS_YPOSIT
      CHARACTER
     *          STRING*132
      LOGICAL
     *          AXIALS
C
      COMMON
     *       /TSSYMZ_SYMME7/ AXIALS
      COMMON
     *       /READWRITE_PAR/ NOUTPT,IWRITE,ISCREN
C
C=======================================================================
C
C        This subroutine tests the existence (or not) of the axial
C        symmetry contained in the nuclear surface that is defined
C        by subroutine RONSUR.  Auxiliary points  in the Cartesian
C        space are chosen arbitrarily (Here: y-axis).
C
C=======================================================================
C
      AXIALS=.TRUE.
C
C=======================================================================
C        T e s t i n g     t h e     a x i a l     s y m m e t r y
C=======================================================================
C
      CALL WS_SYMTRS(WS_RY120X,WS_YPOSIT,WS_RY120Z,AXIALS)
C
      IF (.NOT.AXIALS)  GO TO 1
C
      CALL WS_SYMTRS(WS_RY075X,WS_YPOSIT,WS_RY075Z,AXIALS)
C
      IF (.NOT.AXIALS)  GO TO 1
C
      CALL WS_SYMTRS(WS_RYQ49X,WS_YPOSIT,WS_RYQ49Z,AXIALS)
C
C=======================================================================
C        Printing information about the symmetries of the surface
C=======================================================================
C
   1  CONTINUE
C
      IF (IWRITE.GT.2) THEN
C
          WRITE(NOUTPT,'(//,80(''#''),/,''#'',78X,''#'',/,
     *            ''#  N u c l e a r  S h a p e :       '',
     *            ''A x i a l  S y m m e t r y  A x i s - Oy   #'')')
C
          IF (AXIALS) THEN
              WRITE(STRING(1:80),
     *             '(''#  ! SYMMETRY !   ! SYMMETRY !   ! SYMMETRY !'',
     *               ''   ! SYMMETRY !    ! SYMMETRY !   #'')')
          ELSE
              WRITE(STRING(1:80),
     *             '(''#  NO SYMMETRY     NO SYMMETRY    NO SYMMETRY'',
     *               ''     NO SYMMETRY    NO SYMMETRY   #'')')
          END IF
C
          WRITE(NOUTPT,'(''#'',78X,''#'',/,
     *                   A80,/,''#'',78X,''#'',/,80(''#''))') STRING
C
      END IF
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C=======================================================================
C
      SUBROUTINE WS_TSSYMX
      EXTERNAL
     *          WS_RX120Y,WS_RX120Z,WS_RX075Y,WS_RX075Z,
     *          WS_RXQ49Y,WS_RXQ49Z,WS_XPOSIT
      CHARACTER
     *          STRING*132
      LOGICAL
     *          AXIALS
C
      COMMON
     *       /TSSYMZ_SYMME7/ AXIALS
      COMMON
     *       /READWRITE_PAR/ NOUTPT,IWRITE,ISCREN
C
C=======================================================================
C
C        This subroutine tests the existence (or not) of the axial
C        symmetry contained in the nuclear surface that is defined
C        by subroutine RONSUR.  Auxiliary points  in the Cartesian
C        space are chosen arbitrarily (Here: x-axis).
C
C=======================================================================
C
      AXIALS=.TRUE.
C
C=======================================================================
C        T e s t i n g     t h e     a x i a l     s y m m e t r y
C=======================================================================
C
      CALL WS_SYMTRS(WS_XPOSIT,WS_RX120Y,WS_RX120Z,AXIALS)
C
      IF (.NOT.AXIALS)  GO TO 1
C
      CALL WS_SYMTRS(WS_XPOSIT,WS_RX075Y,WS_RX075Z,AXIALS)
C
      IF (.NOT.AXIALS)  GO TO 1
C
      CALL WS_SYMTRS(WS_XPOSIT,WS_RXQ49Y,WS_RXQ49Z,AXIALS)
C
C=======================================================================
C        Printing information about the symmetries of the surface
C=======================================================================
C
   1  CONTINUE
C
      IF (IWRITE.GT.2) THEN
C
          WRITE(NOUTPT,'(//,80(''#''),/,''#'',78X,''#'',/,
     *            ''#  N u c l e a r  S h a p e :       '',
     *            ''A x i a l  S y m m e t r y  A x i s - Ox   #'')')
C
          IF (AXIALS) THEN
              WRITE(STRING(1:80),
     *             '(''#  ! SYMMETRY !   ! SYMMETRY !   ! SYMMETRY !'',
     *               ''   ! SYMMETRY !    ! SYMMETRY !   #'')')
          ELSE
              WRITE(STRING(1:80),
     *             '(''#  NO SYMMETRY     NO SYMMETRY    NO SYMMETRY'',
     *               ''     NO SYMMETRY    NO SYMMETRY   #'')')
          END IF
C
          WRITE(NOUTPT,'(''#'',78X,''#'',/,
     *                   A80,/,''#'',78X,''#'',/,80(''#''))') STRING
C
      END IF
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C=======================================================================
C
      SUBROUTINE WS_TSSYM8
      EXTERNAL
     *          WS_XPOSIT,WS_YPOSIT,WS_ZPOSIT
      CHARACTER
     *          STRING*132
      LOGICAL
     *          SYM3_F
C
      COMMON
     *       /TSSYM8_SYMME8/ SYM3_F
      COMMON
     *       /READWRITE_PAR/ NOUTPT,IWRITE,ISCREN
C
C=======================================================================
C
C        This subroutine tests the existence (or not) of a 3-fold
C        s y m m e t r y   axis in the  nuclear  surface  defined
C        by subroutine RONSUR.  Auxiliary points in the Cartesian
C        space are chosen arbitrarily (x => y => z).
C
C=======================================================================
C
      SYM3_F=.TRUE.
C
C=======================================================================
C        Testing  the symmetry  of interchanging x-,y- and z-axes
C=======================================================================
C
      CALL WS_SYMTRS(WS_YPOSIT,WS_ZPOSIT,WS_XPOSIT,SYM3_F)
C
C=======================================================================
C        Printing information about the symmetries of the surface
C=======================================================================
C
      IF (IWRITE.GT.2) THEN
C
          WRITE(NOUTPT,'(//,80(''#''),/,''#'',78X,''#'',/,
     *               ''#  S y m m e t r y   with   r e s p e c t'',
     *               ''  to permutation:   x=> y=> z=> x=>   #'')')
C
          IF (SYM3_F) THEN
              WRITE(STRING(1:80),
     *             '(''#  ! SYMMETRY !   ! SYMMETRY !   ! SYMMETRY !'',
     *               ''   ! SYMMETRY !    ! SYMMETRY !   #'')')
          ELSE
              WRITE(STRING(1:80),
     *             '(''#  NO SYMMETRY    NO SYMMETRY    NO SYMMETRY '',
     *               ''    NO SYMMETRY     NO SYMMETRY   #'')')
          END IF
C
          WRITE(NOUTPT,'(''#'',78X,''#'',/,A80,/,''#'',78X,''#'',
     *                                         /,80(''#''))') STRING
C
      END IF
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C=======================================================================
C
      SUBROUTINE WS_TSSYM9
      EXTERNAL
     *          WS_XPOSIT,WS_YPOSIT,WS_XMINUS,WS_YMINUS,WS_ZMINUS
      CHARACTER
     *          STRING*132
      LOGICAL
     *          UROT_1,UROT_2
C
      COMMON
     *       /TSSYM9_SYMME9/ UROT_1,UROT_2
      COMMON
     *       /READWRITE_PAR/ NOUTPT,IWRITE,ISCREN
C
C=======================================================================
C
C        This subroutine tests the existence (or not) of the two
C        symmetry axes possibly contained in the nuclear surface
C        that is defined by subroutine RONSUR.  Auxiliary points
C        in the Cartesian space are chosen arbitrarily.
C
C=======================================================================
C
      UROT_1=.TRUE.
      UROT_2=.TRUE.
C
C=======================================================================
C        Testing a possible  rotation (about x=+y,z=0) symmetry
C=======================================================================
C
      CALL WS_SYMTRS(WS_YPOSIT,WS_XPOSIT,WS_ZMINUS,UROT_1)
C
C=======================================================================
C        Testing a possible  rotation (about x=-y,z=0) symmetry
C=======================================================================
C
      CALL WS_SYMTRS(WS_YMINUS,WS_XMINUS,WS_ZMINUS,UROT_2)
C
C=======================================================================
C        Printing information about   symmetries of the surface
C=======================================================================
C
      IF (IWRITE.GT.2) THEN
C
          WRITE(NOUTPT,'(//,80(''#''),/,''#'',78X,''#'',/,
     *             ''#  S y m m e t r i e s   w i t h   '',
     *             ''r e s p e c t   t o   ( z = 0 )   a x e s   #'')')
C
          IF (UROT_1) THEN
              WRITE(STRING(1:42),
     *             '(''#  U_rot.1 => (x=+y) => ! SYMMETRY !      '')')
          ELSE
              WRITE(STRING(1:42),
     *             '(''#  U_rot.1 => (x=+y) => NO SYMMETRY       '')')
          END IF
C
          IF (UROT_2) THEN
              WRITE(STRING(43:80),
     *             '('' U_rot.2 => (X=-Y) => ! SYMMETRY !   #'')')
          ELSE
              WRITE(STRING(43:80),
     *             '('' U_rot.2 =>> (X=-Y) => NO SYMMETRY   #'')')
          END IF
C
          WRITE(NOUTPT,'(''#'',78X,''#'',/,A80,/,''#'',78X,''#'',
     *                                         /,80(''#''))') STRING
C
      END IF
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C=======================================================================
C
      SUBROUTINE WS_TSSY10
      EXTERNAL
     *          WS_UROT3X,WS_UROT3Y,WS_UROT3Z
      CHARACTER
     *          STRING*132
      LOGICAL
     *          UROT_3
C
      COMMON
     *       /TSSY10_SYMM10/ UROT_3
      COMMON
     *       /READWRITE_PAR/ NOUTPT,IWRITE,ISCREN
C
C=======================================================================
C
C        This routine tests the existence (or not) of the 3-fold
C        symmetry axis contained among symmetries of the nuclear
C        surface  defined by subroutine RONSUR. auxiliary points
C        in the Cartesian space are chosen arbitrarily (T_d = ?)
C
C=======================================================================
C
      UROT_3=.TRUE.
C
C=======================================================================
C        T e s t i n g  t h e  3-fold  s y m m e t r y  a x i s
C=======================================================================
C
      CALL WS_SYMTRS(WS_UROT3X,WS_UROT3Y,WS_UROT3Z,UROT_3)
C
C=======================================================================
C        Printing information  about  symmetries of the surface
C=======================================================================
C
      IF (IWRITE.GT.2) THEN
C
          WRITE(NOUTPT,'(//,80(''#''),/,''#'',78X,''#'',/,
     *             ''#  Towards Td symmetry -> Testing the '',
     *             ''existence of  a   3 - f o l d  a x i s   #'')')
C
          IF (UROT_3) THEN
              WRITE(STRING(1:80),
     *             '(''#  ! SYMMETRY !   ! SYMMETRY !   ! SYMMETRY !'',
     *               ''   ! SYMMETRY !    ! SYMMETRY !   #'')')
          ELSE
              WRITE(STRING(1:80),
     *             '(''#  NO SYMMETRY     NO SYMMETRY    NO SYMMETRY'',
     *               ''    NO SYMMETRY     NO SYMMETRY   #'')')
          END IF
C
          WRITE(NOUTPT,'(''#'',78X,''#'',/,A80,/,''#'',78X,''#'',
     *                                         /,80(''#''))') STRING
C
      END IF
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C=======================================================================
C
      SUBROUTINE WS_SYMTRS(FUNCTX,FUNCTY,FUNCTZ,YESONO)
C=======================================================================
      USE params
C=======================================================================
      DIMENSION
     *          X_AUXI(NDAUXI),Y_AUXI(NDAUXI),Z_AUXI(NDAUXI)
C
      LOGICAL
     *          YESONO
C
      EXTERNAL
     *         FUNCTX,FUNCTY,FUNCTZ
C
      DATA
     *     X_AUXI / -5.481, -2.518, -0.386, +2.001, +4.387 /
      DATA
     *     Y_AUXI / -5.814, -2.333, +0.495, +1.593, +4.894 /
      DATA
     *     Z_AUXI / -5.285, -2.683, -0.995, +2.327, +4.555 /
C
      DATA
     *     COMPAR / 1.0E-8 /
C
C=======================================================================
C
C        This routine tests the existence (or nonexistence) of the
C        given symmetry, possibly existing among symmetries of the
C        nuclear surface that is defined by subroutine RONSUR. The
C        auxiliary points in the Cartesian space are chosen in an
C        arbitrary way (cf. X_AUXI, Y_AUXI and Z_AUXI above).
C
C=======================================================================
C
      PINUMB=4.0*ATAN(1.0)
C
      YESONO=.TRUE.
C
      DO IX=1,NDAUXI
C
         X1=X_AUXI(IX)
C
         DO IY=1,NDAUXI
C
            Y1=Y_AUXI(IY)
C
            DO IZ=1,NDAUXI
C
               Z1=Z_AUXI(IZ)
C
               RADIST=SQRT(X1*X1+Y1*Y1+Z1*Z1)
C
               THETA1=ACOS(ABS(Z1/RADIST))
C
               IF (Z1.LT.0.0) THEN
                   THETA1=PINUMB-THETA1
               END IF
C
               FITEST=ATAN(ABS(Y1/X1))
C
               IF (X1.GT.0.0.AND.Y1.GT.0.0) FIANG1=FITEST
               IF (X1.LT.0.0.AND.Y1.GT.0.0) FIANG1=PINUMB-FITEST
               IF (X1.LT.0.0.AND.Y1.LT.0.0) FIANG1=PINUMB+FITEST
               IF (X1.GT.0.0.AND.Y1.LT.0.0) FIANG1=2.0000*PINUMB
     *                                                   -FITEST
C
               X2=FUNCTX(X1,Y1,Z1)
               Y2=FUNCTY(X1,Y1,Z1)
               Z2=FUNCTZ(X1,Y1,Z1)
C
               THETA2=ACOS(ABS(Z2/RADIST))
C
               IF (Z2.LT.0.0) THEN
                   THETA2=PINUMB-THETA2
               END IF
C
               FITEST=ATAN(ABS(Y2/X2))
C
               IF (X2.GT.0.0.AND.Y2.GT.0.0) FIANG2=FITEST
               IF (X2.LT.0.0.AND.Y2.GT.0.0) FIANG2=PINUMB-FITEST
               IF (X2.LT.0.0.AND.Y2.LT.0.0) FIANG2=PINUMB+FITEST
               IF (X2.GT.0.0.AND.Y2.LT.0.0) FIANG2=2.0000*PINUMB
     *                                                   -FITEST
C
               NODIMS=0
               LEVELY=0
C
               CALL WS_RONSUR(THETA1,FIANG1,R_INTI,DRDTHE,DRDPHI,
     *                                      D2RDTT,D2RDTF,D2RDFF,
     *                                             NODIMS,LEVELY)
C
               CALL WS_RONSUR(THETA2,FIANG2,R_FINL,DRDTHE,DRDPHI,
     *                                      D2RDTT,D2RDTF,D2RDFF,
     *                                             NODIMS,LEVELY)
C
               IF (ABS(R_INTI-R_FINL).GT.COMPAR) YESONO=.FALSE.
C
            END DO
         END DO
C
      END DO
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C=======================================================================
C        E L E M E N T A R Y   S Y M M E T R Y   O P E R A T I O N S
C=======================================================================
C=======================================================================
C
      FUNCTION WS_XPOSIT(X,Y,Z)
      WS_XPOSIT=X
      RETURN
      END
C
      FUNCTION WS_YPOSIT(X,Y,Z)
      WS_YPOSIT=Y
      RETURN
      END
C
      FUNCTION WS_ZPOSIT(X,Y,Z)
      WS_ZPOSIT=Z
      RETURN
      END
C
      FUNCTION WS_XMINUS(X,Y,Z)
      WS_XMINUS=-X
      RETURN
      END
C
      FUNCTION WS_YMINUS(X,Y,Z)
      WS_YMINUS=-Y
      RETURN
      END
C
      FUNCTION WS_ZMINUS(X,Y,Z)
      WS_ZMINUS=-Z
      RETURN
      END
C
C=======================================================================
C=======================================================================
C
      FUNCTION WS_RZ120X(X,Y,Z)
      COMMON
     *       /INITWS_NUMBRS/ PINUMB,PIOVE2
C
C=======================================================================
C        This function gives an x-value after 120 rotation around z-axis
C=======================================================================
C
      WS_RZ120X=COS(2.0*PINUMB/3.0)*X-SIN(2.0*PINUMB/3.0)*Y
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C=======================================================================
C
      FUNCTION WS_RZ120Y(X,Y,Z)
      COMMON
     *       /INITWS_NUMBRS/ PINUMB,PIOVE2
C
C=======================================================================
C        This function gives an y-value after 120 rotation around z-axis
C=======================================================================
C
      WS_RZ120Y=SIN(2.0*PINUMB/3.0)*X+COS(2.0*PINUMB/3.0)*Y
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C=======================================================================
C
      FUNCTION WS_RZ075X(X,Y,Z)
      COMMON
     *       /INITWS_NUMBRS/ PINUMB,PIOVE2
C
C=======================================================================
C        This function gives an x-value after 2*pi/5 rotat. around z-axs
C=======================================================================
C
      WS_RZ075X=COS(2.0*PINUMB/5.0)*X-SIN(2.0*PINUMB/5.0)*Y
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C=======================================================================
C
      FUNCTION WS_RZ075Y(X,Y,Z)
      COMMON
     *       /INITWS_NUMBRS/ PINUMB,PIOVE2
C
C=======================================================================
C        THis function gives an y-value after 2*pi/5 rotat. around z-axs
C=======================================================================
C
      WS_RZ075Y=SIN(2.0*PINUMB/5.0)*X+COS(2.0*PINUMB/5.0)*Y
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C=======================================================================
C        S o m e     f u r t h e r      p r i m i t i v e s
C=======================================================================
C=======================================================================
C
      FUNCTION WS_RZQ47X(X,Y,Z)
      COMMON
     *       /INITWS_NUMBRS/ PINUMB,PIOVE2
C
C=======================================================================
C        This function gives the x-value after turning a point
C        P(x,y)  through an angle  2*pi/47  around  the z-axis
C        Coding the name: R(otation) aoround(Z) Q(uotient)47 X
C=======================================================================
C
      WS_RZQ47X=COS(2.0*PINUMB/47.0)*X-SIN(2.0*PINUMB/47.0)*Y
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      FUNCTION WS_RZQ47Y(X,Y,Z)
      COMMON
     *       /INITWS_NUMBRS/ PINUMB,PIOVE2
C
C=======================================================================
C        This function gives the y-value after turning a point
C        P(x,y)  through an angle  2*pi/47  around  the z-axis
C        Coding the name: R(otation) aoround(Z) Q(uotient)47 Y
C=======================================================================
C
      WS_RZQ47Y=SIN(2.0*PINUMB/47.0)*X+COS(2.0*PINUMB/47.0)*Y
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      FUNCTION WS_RY120X(X,Y,Z)
      COMMON
     *       /INITWS_NUMBRS/ PINUMB,PIOVE2
C
      WS_RY120X=COS(2.0*PINUMB/5.0)*X+SIN(2.0*PINUMB/5.0)*Z
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      FUNCTION WS_RY120Z(X,Y,Z)
      COMMON
     *       /INITWS_NUMBRS/ PINUMB,PIOVE2
C
      WS_RY120Z=-SIN(2.0*PINUMB/5.0)*X+COS(2.0*PINUMB/5.0)*Z
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      FUNCTION WS_RY075X(X,Y,Z)
      COMMON
     *       /INITWS_NUMBRS/ PINUMB,PIOVE2
C
      WS_RY075X=COS(2.0*PINUMB/5.0)*X+SIN(2.0*PINUMB/5.0)*Z
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      FUNCTION WS_RY075Z(X,Y,Z)
      COMMON
     *       /INITWS_NUMBRS/ PINUMB,PIOVE2
C
      WS_RY075Z=-SIN(2.0*PINUMB/5.0)*X+COS(2.0*PINUMB/5.0)*Z
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      FUNCTION WS_RYQ49X(X,Y,Z)
      COMMON
     *       /INITWS_NUMBRS/ PINUMB,PIOVE2
C
      WS_RYQ49X=COS(PINUMB/49.0)*X+SIN(PINUMB/49.0)*Z
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      FUNCTION WS_RYQ49Z(X,Y,Z)
      COMMON
     *       /INITWS_NUMBRS/ PINUMB,PIOVE2
C
      WS_RYQ49Z=-SIN(PINUMB/49.0)*X+COS(PINUMB/49.0)*Z
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      FUNCTION WS_RX120Y(X,Y,Z)
      COMMON
     *       /INITWS_NUMBRS/ PINUMB,PIOVE2
C
      WS_RX120Y=COS(2.0*PINUMB/5.0)*Y+SIN(2.0*PINUMB/5.0)*Z
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      FUNCTION WS_RX120Z(X,Y,Z)
      COMMON
     *       /INITWS_NUMBRS/ PINUMB,PIOVE2
C
      WS_RX120Z=-SIN(2.0*PINUMB/5.0)*Y+COS(2.0*PINUMB/5.0)*Z
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      FUNCTION WS_RX075Y(X,Y,Z)
      COMMON
     *       /INITWS_NUMBRS/ PINUMB,PIOVE2
C
      WS_RX075Y=COS(2.0*PINUMB/5.0)*Y+SIN(2.0*PINUMB/5.0)*Z
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      FUNCTION WS_RX075Z(X,Y,Z)
      COMMON
     *       /INITWS_NUMBRS/ PINUMB,PIOVE2
C
      WS_RX075Z=-SIN(2.0*PINUMB/5.0)*Y+COS(2.0*PINUMB/5.0)*Z
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      FUNCTION WS_RXQ49Y(X,Y,Z)
      COMMON
     *       /INITWS_NUMBRS/ PINUMB,PIOVE2
C
      WS_RXQ49Y=COS(PINUMB/49.0)*Y+SIN(PINUMB/49.0)*Z
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      FUNCTION WS_RXQ49Z(X,Y,Z)
      COMMON
     *       /INITWS_NUMBRS/ PINUMB,PIOVE2
C
      WS_RXQ49Z=-SIN(PINUMB/49.0)*Y+COS(PINUMB/49.0)*Z
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      FUNCTION WS_UROT3X(X,Y,Z)
C
      WS_UROT3X=0.5*(X+Y)+Z/SQRT(2.0)
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      FUNCTION WS_UROT3Y(X,Y,Z)
C
      WS_UROT3Y=-0.5*(X+Y)+Z/SQRT(2.0)
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      FUNCTION WS_UROT3Z(X,Y,Z)
C
      WS_UROT3Z=(X-Y)/SQRT(2.0)
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE WS_TGROUP
C
      LOGICAL
     *          SYM_XY,SYM_YZ,SYM_ZX,ROT_AX,ROT_AY,ROT_AZ,
     *                                             ROTZ_3
      LOGICAL
     *          UROT_1,UROT_2,UROT_3
      LOGICAL
     *          SIGMA1,SIGMA2
      LOGICAL
     *          REFRO1,REFRO2
      LOGICAL
     *          SYM3_F,AXIALS
      LOGICAL
     *          PARITE
      LOGICAL
     *          D_2DGR,T_D_GR,C_2VGR,D_2HGR,D_3HGR,C_IVGR,
     *                                             D_IHGR
C
      COMMON
     *       /TSSYM1_SYMME1/ SYM_XY,SYM_YZ,SYM_ZX
      COMMON
     *       /TSSYM3_SYMME2/ ROT_AX,ROT_AY,ROT_AZ
      COMMON
     *       /TSSYM2_SYMME3/ PARITE
      COMMON
     *       /TSSYM4_SYMME4/ SIGMA1,SIGMA2
      COMMON
     *       /TSSYM5_SYMME5/ REFRO1,REFRO2
      COMMON
     *       /TSSYM6_SYMME6/ ROTZ_3
      COMMON
     *       /TSSYMZ_SYMME7/ AXIALS
      COMMON
     *       /TSSYM8_SYMME8/ SYM3_F
      COMMON
     *       /TSSYM9_SYMME9/ UROT_1,UROT_2
      COMMON
     *       /TSSY10_SYMM10/ UROT_3
C
      COMMON
     *       /READWRITE_PAR/ NOUTPT,IWRITE,ISCREN
C
C=======================================================================
C
      C_2VGR =.FALSE.
      D_2HGR =.FALSE.
      D_3HGR =.FALSE.
      C_IVGR =.FALSE.
      D_IHGR =.FALSE.
      D_2DGR =.FALSE.
      T_D_GR =.FALSE.
C
C=======================================================================
C        Testing   the   existence   of  the   g r o u p  == C(2V) ==
C=======================================================================
C
      IF (ROT_AX.AND.SYM_ZX.AND.SYM_XY) THEN
C
          C_2VGR=.TRUE.
C
      END IF
C
C=======================================================================
C        Testing   the   existence   of  the   g r o u p  == D(2H) ==
C=======================================================================
C
      IF (SYM_XY.AND.SYM_YZ.AND.SYM_ZX.AND.PARITE) THEN
C
          D_2HGR=.TRUE.
C
      END IF
C
C=======================================================================
C        Testing   the   existence   of  the  g r o u p  ==  D(3H) ==
C=======================================================================
C
      IF (SYM_XY.AND.SYM_ZX.AND.ROT_AX.AND.ROTZ_3) THEN
C
          D_3HGR=.TRUE.
C
      END IF
C
C=======================================================================
C        Testing   the   existence   of  the  g r o u p  ==  D(2D) ==
C=======================================================================
C
      IF (ROT_AX.AND.ROT_AY.AND.ROT_AZ.AND.SIGMA1.AND.REFRO1) THEN
C
          D_2DGR=.TRUE.
C
      END IF
C
C=======================================================================
C        Testing   the   existence   of  the  g r o u p   == D(2D) ==
C=======================================================================
C
      IF (UROT_1.AND.UROT_2.AND.ROT_AZ.AND.SYM_ZX.AND.REFRO1) THEN
C
          D_2DGR=.TRUE.
C
      END IF
C
C=======================================================================
C        Testing   the   existence   of  the  g r o u p    == T(D) ==
C=======================================================================
C
      IF (D_2DGR.AND.SYM3_F) THEN
C
          T_D_GR=.TRUE.
C
      END IF
C
C=======================================================================
C        Testing   the   existence  of  the   g r o u p   ==  T(D) ==
C=======================================================================
C
      IF (D_2DGR.AND.UROT_3) THEN
C
          T_D_GR=.TRUE.
C
      END IF
C
C=======================================================================
C        Testing   the   existence  of  the  g r o u p   C(INFINITY V)
C=======================================================================
C
      IF (AXIALS.AND.SYM_ZX.AND.SYM_YZ) THEN
C
          C_IVGR=.TRUE.
C
      END IF
C
C=======================================================================
C        Testing   the   existence   of  the  g r o u p   D(INFINITY H)
C=======================================================================
C
      IF (AXIALS.AND.SYM_ZX.AND.PARITE) THEN
C
          D_IHGR=.TRUE.
C
      END IF
C
C=======================================================================
C        Printing  information  about  the  symmetry  groups
C=======================================================================
C
      IF (IWRITE.GT.2) THEN
C
          IF (D_IHGR) THEN
C
              WRITE(NOUTPT,'(/,80(''#''),/,''#'',78X,''#'',/,
     *                    ''#  SYMMETRY   GROUPS:  =>      D(IH)     '',
     *                    ''D(IH)     D(IH)     D(IH)     D(IH)   #'')')
          END IF
C
C=======================================================================
C
          IF (C_IVGR) THEN
C
              WRITE(NOUTPT,'(''#'',78X,''#'',/,
     *                    ''#                      =>      C{iv}     '',
     *                    ''C{iv}     C{iv}     C{iv}     C{iv}   #'')')
          END IF
C
C=======================================================================
C
          IF (D_3HGR)  THEN
C
              WRITE(NOUTPT,'(''#'',78X,''#'',/,
     *                    ''#                      =>      D{3h}     '',
     *                    ''D{3h}     D{3h}     D{3h}     D{3h}   #'')')
          END IF
C
C=======================================================================
C
          IF (T_D_GR) THEN
C
             WRITE(NOUTPT,'(''#'',78X,''#'',/,
     *                    ''#                      =>       T{d}     '',
     *                    '' T{d}      T{d}      T{d}      T{d}   #'')')
          END IF
C
C=======================================================================
C
          IF (D_2DGR) THEN
C
              WRITE(NOUTPT,'(''#'',78X,''#'',/,
     *                    ''#                      =>      D{2d}     '',
     *                    ''D{2d}     D{2d}     D{2d}     D{2d}   #'')')
          END IF
C
C=======================================================================
C
          IF (D_2HGR) THEN
C
              WRITE(NOUTPT,'(''#'',78X,''#'',/,
     *                    ''#                      =>      D{2h}     '',
     *                    ''D{2h}     D{2h}     D{2h}     D{2h}   #'')')
          END IF
C
C=======================================================================
C
          IF (C_2VGR) THEN
C
              WRITE(NOUTPT,'(''#'',78X,''#'',/,
     *                    ''#                      =>      C{2v}     '',
     *                    ''C{2v}     C{2v}     C{2v}     C{2v}   #'')')
          END IF
C
C=======================================================================
C
          WRITE(NOUTPT,'(''#'',78X,''#'',/,80(''#''))')
C
      END IF
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C=======================================================================
C
      SUBROUTINE WS_TETINV(ALPHAC,NDLAMB,DEFTET,NDTETR,IFTETR)
      COMPLEX
     *          ALPHAC(0:NDLAMB,-NDLAMB:+NDLAMB)
      DIMENSION
     *          DEFTET(1:NDTETR)
      DATA
     *     EPSTET / 1.0E-10 /
C
C=======================================================================
C        Defining tetrahedral deformation
C=======================================================================
C
      IF (IFTETR.EQ.0) RETURN
C
C=======================================================================
C
      IF (ABS(DEFTET(1)).GT.EPSTET) THEN
C
          ALPHAC(3,+2)=CMPLX(DEFTET(1),0.0)
          ALPHAC(3,-2)=CMPLX(DEFTET(1),0.0)
C
      END IF
C
      IF (ABS(DEFTET(2)).GT.EPSTET) THEN
C
          ALPHAC(7,+6)=+CMPLX(DEFTET(2),0.0)/SQRT(13./11)
          ALPHAC(7,+2)=-CMPLX(DEFTET(2),0.0)
          ALPHAC(7,-2)=-CMPLX(DEFTET(2),0.0)
          ALPHAC(7,-6)=+CMPLX(DEFTET(2),0.0)/SQRT(13./11)
C
      END IF
C
      IF (ABS(DEFTET(3)).GT.EPSTET) THEN
C
          ALPHAC(9,+6)=+CMPLX(DEFTET(3),0.0)/SQRT(3./13)
          ALPHAC(9,+2)=+CMPLX(DEFTET(3),0.0)
          ALPHAC(9,-2)=+CMPLX(DEFTET(3),0.0)
          ALPHAC(9,-6)=+CMPLX(DEFTET(3),0.0)/SQRT(3./13)

      END IF
C
      IF (ABS(DEFTET(4)).GT.EPSTET) THEN
C
          ALPHAC(11,+10)=+CMPLX(DEFTET(4),0.0)/SQRT(170./133)
          ALPHAC(11,+06)=-CMPLX(DEFTET(4),0.0)*SQRT(081./133)
     *                                        /SQRT(170./133)
          ALPHAC(11,+02)=+CMPLX(DEFTET(4),0.0)
          ALPHAC(11,-02)=+CMPLX(DEFTET(4),0.0)

          ALPHAC(11,-06)=-CMPLX(DEFTET(4),0.0)*SQRT(081./133)
     *                                        /SQRT(170./133)
          ALPHAC(11,-10)=+CMPLX(DEFTET(4),0.0)/SQRT(170./133)

      END IF
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C=======================================================================
C
      SUBROUTINE WS_OKTINV(ALPHAC,NDLAMB,DEFOKT,NDOKTR,IFOKTR)
      COMPLEX
     *          ALPHAC(0:NDLAMB,-NDLAMB:+NDLAMB)
      DIMENSION
     *          DEFOKT(1:NDOKTR)
      DATA
     *     EPSOKT / 1.0E-10 /
C
C=======================================================================
C        Defining tetrahedral deformation
C=======================================================================
C
      IF (IFOKTR.EQ.0) RETURN
C
C=======================================================================
C
      IF (ABS(DEFOKT(1)).GT.EPSOKT) THEN
C
          ALPHAC(4,+4)=CMPLX(DEFOKT(1),0.0)/SQRT(14./5)
          ALPHAC(4, 0)=CMPLX(DEFOKT(1),0.0)
          ALPHAC(4,-4)=CMPLX(DEFOKT(1),0.0)/SQRT(14./5)
C
      END IF
C
      IF (ABS(DEFOKT(2)).GT.EPSOKT) THEN
C
          ALPHAC(6,+4)=+CMPLX(DEFOKT(2),0.0)/SQRT(2./7)
          ALPHAC(6, 0)=-CMPLX(DEFOKT(2),0.0)
          ALPHAC(6,-4)=+CMPLX(DEFOKT(2),0.0)/SQRT(2./7)
C
      END IF
C
      IF (ABS(DEFOKT(3)).GT.EPSOKT) THEN
C
          ALPHAC(8,+8)=+CMPLX(DEFOKT(3),0.0)/SQRT(198./65)
          ALPHAC(8,+4)=+CMPLX(DEFOKT(3),0.0)*SQRT(028./65)/SQRT(198./65)
          ALPHAC(8, 0)=+CMPLX(DEFOKT(3),0.0)
          ALPHAC(8,-4)=+CMPLX(DEFOKT(3),0.0)*SQRT(028./65)/SQRT(198./65)
          ALPHAC(8,-8)=+CMPLX(DEFOKT(3),0.0)/SQRT(198./65)

      END IF
C
      IF (ABS(DEFOKT(4)).GT.EPSOKT) THEN
C
          ALPHAC(10,+8)=+CMPLX(DEFOKT(4),0.0)/SQRT(130./187)
          ALPHAC(10,+4)=+CMPLX(DEFOKT(4),0.0)*SQRT(012./17)
     *                                       /SQRT(130./187)
          ALPHAC(10, 0)=-CMPLX(DEFOKT(4),0.0)
          ALPHAC(10,-4)=+CMPLX(DEFOKT(4),0.0)*SQRT(012./17)
     *                                       /SQRT(130./187)
          ALPHAC(10,-8)=+CMPLX(DEFOKT(4),0.0)/SQRT(130./187)

      END IF
C
C=======================================================================
C
      RETURN
      END
