C FILE NAME = wsu10_crkg_04.f   ! Keep this symbol here: $ident@string$
C
C=======================================================================
C=======================================================================
C=====                                ==================================
C=====   2-D CRANKING ROUTINE SET     ==================================
C=====                                ==================================
C=======================================================================
C=======================================================================
C
      SUBROUTINE WS_CRANKG(IZ_FIX,IN_FIX,NOSCIL,NXMAXX,NYMAXX,NZMAXX,
     *                     LDBASE,NAMREV,ISOSPI,ISIGNY,IFMULT,MAXMUL,
     *                     KARTLB,KARWAV,NILSLB,LABSPH,ISOTRO,IFWIGN,
     *                     KRANKX,KRANKY,KRANKZ,KRANKG,NOFOME,MU_ODD,
     *                     MAXXYZ,MAXWAV,NILWAV,IWAVSP,NOFLIN,NOFLEV,
     *                     OMEGAX,OMEGAY,OMEGAZ,EMINWF,EMAXWF,SPHMAX,
     *                     CPHASE,RYTEXT,EMINST,EMAXST,IINDIV,LAMIND,
     *                                                        MIUIND)
C=======================================================================
      USE params
C=======================================================================
C
      CHARACTER
     *          RYTEXT(0:NDREVE)*5
      CHARACTER
     *          NAMREV*4
C
      COMPLEX
     *          HAMISP(1:NDBASE,1:NDBASE,0:NDREVE)
      COMPLEX
     *          EWAVEF,EWAVCR,H_STAT,BIG_PP,BIG_PM
C
      DIMENSION
     *          OMEGAX(0:NDOMEG),OMEGAY(0:NDOMEG),
     *          OMEGAZ(0:NDOMEG),OMEGAT(0:NDOMEG)
      DIMENSION
     *          CPHASE(0:NDYMAX,0:NDYMAX,0:NDKART)
      DIMENSION
     *          WORKMX(1:NDBASE)
      DIMENSION
     *          IPAORD(1:NDBASE)
      DIMENSION
     *          ESPECT(1:NDBASE)
C=======================================================================
      ALLOCATABLE RAUXIL(:,:,:)
      ALLOCATABLE ELM_LL(:,:),ELM_SS(:,:),RWAVEF(:,:)
C=======================================================================
C
      COMMON
     *       /MULTIP_SPLEVS/ SPENER(1:NDBASE,0:NDREVE),
     *                       SPALIG(1:NDBASE,0:NDREVE),
     *                       SPSPAL(1:NDBASE,0:NDREVE),
     *                       SPPARI(1:NDBASE,0:NDREVE),
     *                       QUOKAR(1:NDBASE,0:NDREVE),
     *                       QUONIL(1:NDBASE,0:NDREVE)
      COMMON
     *       /SPECTR_ESINGP/ ESINGP(1:NDBASE),PARITY(1:NDBASE)
     *       /SPECTR_SPINOR/ EWAVEF(1:NDBASE,1:NDBASE)
     *       /SPECTR_H_STAT/ H_STAT(1:NDBASE,1:NDBASE)
     *       /SPECTR_H_STRE/ H_STRE(1:NDBASE,1:NDBASE)
     *       /SPECTR_ISPFAC/ ISPFAC(1:NDBASE)
      COMMON
     *       /LBKARR_ALIGNS/ ALIGNJ(1:NDBASE),
     *                       ALIGNL(1:NDBASE),
     *                       ALIGNS(1:NDBASE)
      COMMON
     *       /CRAN3D_MAT_PP/ BIG_PP(1:NDBASE,1:NDBASE,0:NDREVE)
     *       /CRAN3D_MAT_PM/ BIG_PM(1:NDBASE,1:NDBASE,0:NDREVE)
      COMMON
     *       /CRANKG_EWAVCR/ EWAVCR(1:NDBASE,1:NDBASE,0:NDREVE)
     *       /CRANKG_SIGDIM/ LDSTAT(0:NDREVE)
      COMMON
     *       /PUT_MM_SPNUMS/ NUMBSP(0:NDREVE)
      COMMON
     *       /CONSER_SIMPLY/ ISIMPY
     *       /NUCLEONIC_RMX/ R_MAXI
     *       /SPHERICAL_WAV/ IFWAVE
C
      COMMON
     *       /READWRITE_PAR/ NOUTPT,IWRITE,ISCREN
C
C=======================================================================
C        This subroutine diagonalises the Woods-Saxon cranking model
C        hamiltonian
C=======================================================================
C
C        SPHMAX - Single particle states with E<SPHMAX  go to review
C
C        EMINST - The states with E > EMINST will be printed on outp.
C        EMAXST - The states with E < EMAXST will be printed on outp.
C
C        EMINWF - Wave-functions are printed when energies E >EMINWF
C        EMAXWF - Wave-functions are printed when energies E <EMAXWF
C
C=======================================================================
C
      CALL WS_CPUTIM('CRANKG',1)
C
C=======================================================================
C
c      IF (IFWIGN.EQ.1) THEN
C
c          WRITE(NOUTPT,'(/,''Please do NOT use Wigner rotation '',
c     *                     ''simultaneously with CRANKING'')')
C
c          STOP 'IFWIGN=1 and cranking not optimal here (WARNING)'
C
c      END IF
C
      IF (KRANKG.EQ.0) STOP 'No cranking from CRANKG'
C
      IF (KRANKG.LT.0.OR.KRANKG.GT.3) THEN
C
          STOP 'Illegal KRANKG parameter value in CRANKG - '
C
      END IF
C
C=======================================================================
C
      ISIMPY=1
C
                       NPARTI=IZ_FIX
      IF (ISOSPI.EQ.0) NPARTI=IN_FIX
C
C=======================================================================
C         Calculating matrix elements of the total angular momentum
C=======================================================================
C
      ALLOCATE(RAUXIL(1:NDBASE,1:NDBASE,0:NDREVE))
      ALLOCATE(ELM_LL(1:NDBASE,1:NDBASE))
      ALLOCATE(ELM_SS(1:NDBASE,1:NDBASE))
C
      IF (KRANKG.EQ.1) THEN
C
C          X-cranking is not supported for odd-miu deformations
C
          IF (MU_ODD.EQ.1) STOP 'This option not supported'
C
          DO I=1,NOFOME
              OMEGAT(I)=OMEGAX(I)
          END DO
C
          FACTOR=1.0
C
          CALL WS_JXJXJX(NXMAXX,NYMAXX,NZMAXX,ELM_LL,ELM_SS,
     *                   HAMISP(1,1,0),HAMISP(1,1,1),FACTOR,LDBASE)
C
C          Below we will introduce the "s"-basis, if MU_ODD is not 1
C          In this case we already have, in  H_STRE  the transformed
C          hamiltonian originating from  (+,+)  block.  What we need
C          is J_x matrix, transformed to the "s"-basis; we need both
C          blocks
C
C          Below Eqs.(42) and (44) from notes PA
C
          DO IBRAHO=1,LDBASE
             IFACII=ISPFAC(IBRAHO)
             DO IKETHO=1,LDBASE
C
                IF (IFACII.EQ.ISPFAC(IKETHO)) THEN
C
                    RAUXIL(IBRAHO,IKETHO,0)
     *             =
     *             -IFACII*REAL(HAMISP(IBRAHO,IKETHO,0))
C
                    RAUXIL(IBRAHO,IKETHO,1)
     *             =
     *             -RAUXIL(IBRAHO,IKETHO,0)
C
                ELSE
C
                    RAUXIL(IBRAHO,IKETHO,0)
     *             =
     *             -IMAG(HAMISP(IBRAHO,IKETHO,0))
C
                    RAUXIL(IBRAHO,IKETHO,1)
     *             =
     *             +RAUXIL(IBRAHO,IKETHO,0)
C
                END IF
C
             END DO
          END DO
C
      END IF
C
C=======================================================================
C
      IF (KRANKG.EQ.2) THEN
C
C         Here the Oy-cranking...
C
          DO I=1,NOFOME
              OMEGAT(I)=OMEGAY(I)
          END DO
C
          FACTOR=1.0
C
          CALL WS_JYJYJY(NXMAXX,NYMAXX,NZMAXX,ELM_LL,ELM_SS,
     *                   HAMISP(1,1,0),HAMISP(1,1,1),FACTOR,LDBASE)
C
      END IF
C
C=======================================================================
C
      IF (KRANKG.EQ.3) THEN
C
C         ... and here the Oz-cranking
C
          DO I=1,NOFOME
             OMEGAT(I)=OMEGAZ(I)
          END DO
C
          FACTOR=1.0
C
          CALL WS_JZJZJZ(NXMAXX,NYMAXX,NZMAXX,ELM_LL,ELM_SS,
     *                   HAMISP(1,1,0),HAMISP(1,1,1),FACTOR,LDBASE)
C
      END IF
C
C=======================================================================
C
      DO IOMEGA=1,NOFOME
C
         OMEGAC=OMEGAT(IOMEGA)
C
         IF (ISCREN.EQ.1) THEN
C
             IF (ISOSPI.EQ.1.AND.ISCREN.EQ.1)
     *
     *       WRITE(0,'(''Diagonalizing Cranking Hamiltonian: Omega='',
     *                                       F5.3,'' =>  Protons'')')
     *                                                  OMEGAT(IOMEGA)
             IF (ISOSPI.EQ.0.AND.ISCREN.EQ.1)
     *
     *       WRITE(0,'(''Diagonalizing Cranking Hamiltonian: Omega='',
     *                                       F5.3,'' => Neutrons'')')
     *                                                  OMEGAT(IOMEGA)
         END IF
C
         DO IREVER=0,NDREVE
C
            LDSTAT(IREVER)=LDBASE
C
            NUMBSP(IREVER)=LDBASE
C
            IF (IREVER.EQ.0) NAMREV='UP  '
            IF (IREVER.EQ.1) NAMREV='DOWN'
C
            IF (IREVER.EQ.0) THEN
C
                IF (KRANKG.EQ.2) THEN
C                                                        Oy-cranking
                    DO IKETHO=1,LDBASE
                       DO IBRAHO=1,LDBASE
                          EWAVEF(IBRAHO,IKETHO)=H_STAT(IBRAHO,IKETHO)
     *                           -OMEGAC*HAMISP(IBRAHO,IKETHO,IREVER)
                       END DO
                    END DO
C
                ELSE
C                                                        Ox-cranking
                    DO IKETHO=1,LDBASE
                       DO IBRAHO=1,LDBASE
                          RWAVEF(IBRAHO,IKETHO)=H_STRE(IBRAHO,IKETHO)
     *                           -OMEGAC*RAUXIL(IBRAHO,IKETHO,IREVER)
                       END DO
                    END DO
C
                END IF
C
            ELSE
C
                IF (KRANKG.EQ.2) THEN
C                                                        Oy-cranking
                    DO IKETHO=1,LDBASE
                       DO IBRAHO=1,LDBASE
                          EWAVEF(IBRAHO,IKETHO)
     *                    =CONJG(H_STAT(IBRAHO,IKETHO))
     *                    -OMEGAC*HAMISP(IBRAHO,IKETHO,IREVER)
                       END DO
                    END DO
C
                ELSE
C                         Ox-cranking. This is Eq.(37) from notes PA;
C                         Note: RAUXIL will be also needed by LBKARR
C
                    DO IKETHO=1,LDBASE
                       IFACII=ISPFAC(IKETHO)
                       DO IBRAHO=1,LDBASE
                          IF (IFACII.EQ.ISPFAC(IBRAHO)) THEN
                              RWAVEF(IBRAHO,IKETHO)=
     *                                            H_STRE(IBRAHO,IKETHO)
     *                             -OMEGAC*RAUXIL(IBRAHO,IKETHO,IREVER)
                          ELSE
                              RWAVEF(IBRAHO,IKETHO)=
     *                                           -H_STRE(IBRAHO,IKETHO)
     *                             -OMEGAC*RAUXIL(IBRAHO,IKETHO,IREVER)
                          END IF
                       END DO
                    END DO
C
                END IF
C
            END IF
C
C=======================================================================
C           Diagonalizing the matrix of the mean field
C=======================================================================
C
            IF (ISIGNY.EQ.1) THEN
C
C               Diagonalization for two parities separately, with
C               complex hamiltonian in DIASIG,  real hamiltomnian
C               in DIASIR
C
                IF (KRANKG.EQ.2) THEN
C                                        Oy-cranking
                    CALL WS_DIASIG(ESPECT,IREVER,IPAORD)
                ELSE
C                                                      Ox-cranking
                    CALL WS_DIASIR(RWAVEF,ESPECT,IREVER,IPAORD,LDBASE)
                END IF
C
            ELSE
C
C               Diagonalization with no parity conservation: here
C               complex hamiltonian treated by DIAGCM, while real
C               hamiltonian in DIAGON
C
                IF (KRANKG.EQ.2) THEN
C                                        Oy-cranking
                    CALL WS_DIAGCM(EWAVEF,ESPECT,LDBASE)
                ELSE
C                                        Ox-cranking
                    CALL WS_DIAGRM(RWAVEF,ESPECT,LDBASE)
                END IF
C
                IF (IWRITE.GE.1) THEN
C
                    WRITE(NOUTPT,'(/,80(''#''),/,''#'',78X,''#'',/,
     *                           ''#  Following the simplex '',
     *                           ''conservation we have two '',
     *                           ''routhian-blocks of '',
     *                           I3,''x'',I3,''   #'',/,
     *                           ''#'',78X,''#'',/,   80(''#''))')
     *
     *                                               LDBASE,LDBASE
C
                END IF
C
            END IF
C
C=======================================================================
C
C           If no moments requested, EWAVCR will not be needed
C
            IF (IFMULT.NE.0) THEN
C
                DO ISTATE=1,LDBASE
                   DO I_BASE=1,LDBASE
                      EWAVCR(I_BASE,ISTATE,IREVER)=EWAVEF(I_BASE,ISTATE)
                      BIG_PP(I_BASE,ISTATE,IREVER)=EWAVEF(I_BASE,ISTATE)
                      BIG_PM(I_BASE,ISTATE,IREVER)=0.0
                   END DO
                END DO
C
            END IF
C
            DO ISTATE=1,LDBASE
                SPENER(ISTATE,IREVER)=ESPECT(ISTATE)
                ESINGP(ISTATE       )=ESPECT(ISTATE)
            END DO
C
C           For the Ox-cranking we calculate <j_x>, <s_x>, Cartesian
C           labels etc., we store/print it all, and skip the rest of
C           this loop as it is not prepared to handle this case.
C
C           RAUXIL is the matrix of J_x in the "s"-basis (two blocks)
C
            IF (KRANKG.EQ.1) THEN
C
                CALL WS_LBKARR(ISOSPI,EMINST,EMAXST,RAUXIL(1,1,IREVER),
     *                                                  RWAVEF,OMEGAC,
     *                                                  IREVER,RYTEXT)
C               and skipping the rest of the loop, as promised .....
C
            ELSE
C
                CALL WS_AVPARI(IREVER)
C
                ITIPAR=-1
                IMAREA=-1
C
                CALL WS_AVRONE(ALIGNL,ELM_LL,ITIPAR,IMAREA,IREVER)
C
                ITIPAR=-1
                IMAREA=+1
C
                CALL WS_AVRONE(ALIGNS,ELM_SS,ITIPAR,IMAREA,IREVER)
C
                DO ISTATE=1,LDBASE
                   ALIGNJ(ISTATE)=ALIGNL(ISTATE)+ALIGNS(ISTATE)
                END DO
C
C                Analyzing the structure of the neutron wave functions
C
                CALL WS_LBKART(IZ_FIX,IN_FIX,ISOSPI,EMINST,EMAXST,
     *                         KARTLB,KARWAV,MAXXYZ,MAXWAV,EMINWF,
     *                                EMAXWF,OMEGAC,IREVER,RYTEXT)
C
C                Spherical basis transformations: labelling the states
C                and wave functions
C
                CALL WS_SPHONL(ISOSPI,NOFLIN,LABSPH,IWAVSP,EMINST,
     *                         EMAXST,OMEGAC,ISIGNY,IPAORD,IREVER,
     *                         EMINWF,EMAXWF,NOSCIL,ISOTRO,SPHMAX,
     *                                       RYTEXT,R_MAXI,IFWAVE)
C
C                Cylindrical basis transformations:  labelling  states
C                and wave functions
C
                CALL WS_CYLONL(ISOSPI,NILWAV,EMINST,EMAXST,OMEGAC,
     *                         ISIGNY,NILSLB,IPAORD,IREVER,EMINWF,
     *                                              EMAXWF,RYTEXT)
C
            END IF
C
         END DO ! end of irever loop
C
C        As far as the GOTO below goes: we do not need it for the
C        Ox-cranking and of course it is not prepared anyway ....
C
         IF (KRANKG.EQ.1) GO TO 2
C
C=======================================================================
C        Calculating and printing the multipole moments
C=======================================================================
C
C         Electric moments
C
         CALL WS_MOMETS(ISOSPI,IZ_FIX,IN_FIX,IFMULT,MAXMUL,NOFLEV,
     *                         KRANKG,ISIGNY,IINDIV,LAMIND,MIUIND)
C
         CALL WS_MOMPRI(MAXMUL,ISOSPI,IFMULT,OMEGAC,KRANKG)
C
C         Magnetic moments
C
         CALL WS_MAGMOM(ISOSPI,IZ_FIX,IN_FIX,IFMULT,MAXMUL,KRANKG,
     *                                       IINDIV,LAMIND,MIUIND)
C
         CALL WS_MAGPRI(MAXMUL,ISOSPI,IFMULT,OMEGAC,KRANKG)
C
C=======================================================================
C
         CALL WS_SPTALL(EMINST,EMAXST,ISOSPI,ISIGNY,OMEGAT,IOMEGA,
     *                                                     NPARTI)
C
C=======================================================================
C        Recording the results on disk
C=======================================================================
C
    2    CONTINUE
C
         CALL WS_REVOME(IFWIGN,IZ_FIX,IN_FIX,KRANKX,KRANKY,KRANKZ,
     *                  ISIGNY,ISOSPI,IFMULT,MAXMUL,OMEGAC,NOFOME)
C
      END DO ! end of omega loop
C
      DEALLOCATE(RAUXIL,ELM_LL,ELM_SS)
C
C=======================================================================
C
      CALL WS_CPUTIM('CRANKG',0)
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C=======================================================================
C
      SUBROUTINE WS_AVRONE(AVRVAL,OPROSC,ITIPAR,IMAREA,IREVER)
C=======================================================================
      USE params
C=======================================================================
      CHARACTER
     *          FORM_A*1,FORM_B*1
      COMPLEX
     *          EWAVEF,RESULT,AUXILI
C
      DIMENSION
     *          OPROSC(1:NDBASE,1:NDBASE),AVRVAL(1:NDBASE)
      DIMENSION
     *          AUXILI(1:NDBASE,1:NDBASE)
C
      COMMON
     *         /SPECTR_SPINOR/ EWAVEF(1:NDBASE,1:NDBASE)
      COMMON
     *         /SETBAS_DIMENS/ LDBASE
C
      DATA
     *         EPSMUL / 1.E-14 /
C
C=======================================================================
C
C       This subroutine calculates the single-particle average values
C       of the operator 'OPROSC' (operator O in the oscillator basis)
C       within the WS single-particle states.  Matrix elements of the
C       operator 'OPROSC'  are assumed either real (IMAREA=1), or ima-
C       ginary (IMAREA=-1).  The operator is assumed either time-even,
C       ITIPAR=1, or time-odd, ITIPAR=-1.  Calculations are performed
C       formed in a given time-reversal block specified by IREVER
C
C=======================================================================
C
      CALL WS_CPUTIM('AVRONE',1)
C
C=======================================================================
C
      DO ISTATE=1,LDBASE
         DO IKETHO=1,LDBASE
C
            AUXILI(ISTATE,IKETHO)=CMPLX (0.0000,0.0000)
C
         END DO
      END DO
C
      FORM_A='C'
      FORM_B='N'
C
      NDAROW=NDBASE
      NDACOL=NDBASE
      LDAROW=LDBASE
      LDACOL=LDBASE
C
      NDBROW=NDBASE
      NDBCOL=NDBASE
      LDBROW=LDBASE
      LDBCOL=LDBASE
C
      NDCROW=NDBASE
      NDCCOL=NDBASE
      LDCROW=LDBASE
      LDCCOL=LDBASE
C
      CALL WS_CRSPRS(EWAVEF,NDAROW,NDACOL,LDAROW,LDACOL,FORM_A,
     *               OPROSC,NDBROW,NDBCOL,LDBROW,LDBCOL,FORM_B,
     *               AUXILI,NDCROW,NDCCOL,LDCROW,LDCCOL,EPSMUL)
C
C=======================================================================
C
      DO ISTATE=1,LDBASE
C
         RESULT=CMPLX(0.0,0.0)
C
         DO IKETHO=1,LDBASE
            RESULT=RESULT+AUXILI(ISTATE,IKETHO)*EWAVEF(IKETHO,ISTATE)
         END DO
C
         IF (IMAREA.EQ.-1) RESULT=RESULT*CMPLX(0.0,1.0)
C
         IF (IREVER.EQ.0) THEN
             AVRVAL(ISTATE)=REAL(RESULT)
         ELSE
             AVRVAL(ISTATE)=REAL(RESULT*ITIPAR*IMAREA)
         END IF
C
      END DO
C
C=======================================================================
C
      CALL WS_CPUTIM('AVRONE',0)
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C=======================================================================
C
      SUBROUTINE WS_SPTALL(EMINAL,EMAXAL,ICHARG,ISIGNY,OMEGAY,IOMEGA,
     *                                                        NPARTI)
C=======================================================================
      USE params
C=======================================================================
C
      CHARACTER
     *          SPKART*10,SPNILS*15,SPORDE*13,SPORDR*17
      CHARACTER
     *          LBOKAR*10,LBONIL*15,LBORDE*13
      CHARACTER
     *          LBACTK*10,LBACTN*15,LBACTO*13
      CHARACTER
     *          NAMEPN(0:NDISOS)*8,NAMSYM(0:NDSYMM)*13
      CHARACTER
     *          GFACTO*7,REVIND*1,PARIND*1,SIMIND*1
C
      DIMENSION
     *          EORDER(1:NDDOUB),NORDER(1:NDDOUB),
     *          NSTATE(1:NDDOUB),NREVER(1:NDDOUB)
      DIMENSION
     *          N_PPRP(1:NDDOUB),N_PPRM(1:NDDOUB),
     *          N_PMRP(1:NDDOUB),N_PMRM(1:NDDOUB)
      DIMENSION
     *          N_SIMP(1:NDDOUB),N_SIMM(1:NDDOUB)
      DIMENSION
     *          OMEGAY(0:NDOMEG)
C
      COMMON
     *       /SPTALL_ALSLOP/ XJ1NEG(1:NDOMEG,0:NDISOS),
     *                       XJ1POS(1:NDOMEG,0:NDISOS),
     *                       XJ2NEG(1:NDOMEG,0:NDISOS),
     *                       XJ2POS(1:NDOMEG,0:NDISOS)
     *
     *       /SPTALL_NTSLOP/ NTOTMI(1:NDOMEG,0:NDISOS),
     *                       NTOTPL(1:NDOMEG,0:NDISOS)
      COMMON
     *       /SPTALL_ROUALI/ ROUTHS(1:NDBASE,0:NDREVE,0:NDPARI,NDOMEG),
     *                       ALIGOJ(1:NDBASE,0:NDREVE,0:NDPARI,NDOMEG),
     *                       ALIGOS(1:NDBASE,0:NDREVE,0:NDPARI,NDOMEG)
      COMMON
     *       /SPTALL_DYNAMC/ ALIGJ2(1:NDBASE,0:NDREVE,0:NDPARI,NDOMEG),
     *                       ALIGS2(1:NDBASE,0:NDREVE,0:NDPARI,NDOMEG)
      COMMON
     *       /SPTALL_LABOME/ LBOKAR(1:NDBASE,0:NDREVE,0:NDPARI,NDOMEG),
     *                       LBONIL(1:NDBASE,0:NDREVE,0:NDPARI,NDOMEG),
     *                       LBORDE(1:NDBASE,0:NDREVE,0:NDPARI,NDOMEG)
      COMMON
     *       /MULTIP_SPLEVS/ SPENER(1:NDBASE,0:NDREVE),
     *                       SPALIG(1:NDBASE,0:NDREVE),
     *                       SPSPAL(1:NDBASE,0:NDREVE),
     *                       SPPARI(1:NDBASE,0:NDREVE),
     *                       QUOKAR(1:NDBASE,0:NDREVE),
     *                       QUONIL(1:NDBASE,0:NDREVE)
      COMMON
     *       /LBKARR_SPLABS/ SPKART(1:NDBASE,0:NDREVE),
     *                       SPNILS(1:NDBASE,0:NDREVE),
     *                       SPORDE(1:NDBASE,0:NDREVE),
     *                       SPORDR(1:NDBASE,0:NDREVE)
      COMMON
     *       /SPTALL_DIMSYM/ LDIMSP(0:NDPARI,0:NDREVE)
      COMMON
     *       /SETBAS_HOMOSC/ HBAROX,HBAROY,HBAROZ,
     *                       SQXFAC,SQYFAC,SQZFAC,
     *                                     HOMOSC
     *
     *       /SETBAS_CENMAS/ XCMPOS,YCMPOS,ZCMPOS
     *
     *       /SETBAS_DIMENS/ LDBASE
      COMMON
     *       /VERIFS_SYMETS/ ISPHER,ICYLIN,IPCONS
      COMMON
     *       /READWRITE_PAR/ NOUTPT,IWRITE,ISCREN
C
      DATA
     *      NAMSYM / '  ( + , - )  ' , '(++,+-,-+,--)' /
      DATA
     *      NAMEPN(0) / 'NEUTRONS' /
      DATA
     *      NAMEPN(1) / ' PROTONS' /
      DATA
     *      EPSYMY    / 0.00100000 / ! Axial symmetry about the crankg
C                                      axis ===>> J_y(2)=0 identically
C=======================================================================
C         This routine  calculates  single-particle rotational moments
C         Jy(1) and Jy(2) and prepares the storage arrays for the -REV
C         type routines
C=======================================================================
C
      IF (IOMEGA.GT.1) THEN
          DELOME=OMEGAY(IOMEGA)-OMEGAY(IOMEGA-1)
      END IF
C
      OMEGAC=OMEGAY(IOMEGA)
C
C=======================================================================
C            Determining the ordered single-particle spectrum
C=======================================================================
C
      IORDER=0
C
      DO IREVER=0,NDREVE
C
         DO ISTATE=1,LDBASE
C
            IORDER=IORDER+1
            NORDER(IORDER)=IORDER
            EORDER(IORDER)=SPENER(ISTATE,IREVER)
            NSTATE(IORDER)=ISTATE
            NREVER(IORDER)=IREVER
C
         END DO
C
      END DO
C
C=======================================================================
C
      CALL WS_ORDER1(EORDER,NORDER,IORDER,NDDOUB)
C
C=======================================================================
C         Calculating the numbers of occupied states:  in every
C         parity/time-reversal block and in every simplex block
C=======================================================================
C
      NUPPRP=0
      NUPPRM=0
      NUPMRP=0
      NUPMRM=0
C
      NUSIMP=0
      NUSIMM=0
C
      IPARPL=0
      IPARMI=1
C
      DO IALLST=1,2*LDBASE
C
         ISTATE=NSTATE(NORDER(IALLST))
         IREVER=NREVER(NORDER(IALLST))
C
         LBACTK=SPKART(ISTATE,IREVER)
         LBACTN=SPNILS(ISTATE,IREVER)
         LBACTO=SPORDE(ISTATE,IREVER)
         ROUOME=SPENER(ISTATE,IREVER)
C
C=======================================================================
C           Here the parity/time-reversal blocks are considered
C=======================================================================
C
         IF (ISIGNY.EQ.1) THEN
C
             N_PPRP(IALLST)=0
             N_PPRM(IALLST)=0
             N_PMRP(IALLST)=0
             N_PMRM(IALLST)=0
C
             IF (SPPARI(ISTATE,IREVER).GT.0.0) THEN
C
                 IF (IREVER.EQ.0) THEN
C
                     NUPPRP=NUPPRP+1
                     N_PPRP(IALLST)=NUPPRP
                     LDIMSP(IPARPL,IREVER)=NUPPRP
C
                     ALIGOJ(NUPPRP,IREVER,IPARPL,IOMEGA)
     *                            =SPALIG(ISTATE,IREVER)
                     ALIGOS(NUPPRP,IREVER,IPARPL,IOMEGA)
     *                            =SPSPAL(ISTATE,IREVER)
C
                     LBOKAR(NUPPRP,IREVER,IPARPL,IOMEGA)=LBACTK
                     LBONIL(NUPPRP,IREVER,IPARPL,IOMEGA)=LBACTN
                     LBORDE(NUPPRP,IREVER,IPARPL,IOMEGA)=LBACTO
C
                     ROUTHS(NUPPRP,IREVER,IPARPL,IOMEGA)=ROUOME
C
                     IF (IOMEGA.GT.1) THEN
C
                         ALIGJ2(NUPPRP,IREVER,IPARPL,IOMEGA)=
     *                  (ALIGOJ(NUPPRP,IREVER,IPARPL,IOMEGA)-
     *                   ALIGOJ(NUPPRP,IREVER,IPARPL,IOMEGA-1))/DELOME
C
                         ALIGS2(NUPPRP,IREVER,IPARPL,IOMEGA)=
     *                  (ALIGOS(NUPPRP,IREVER,IPARPL,IOMEGA)-
     *                   ALIGOS(NUPPRP,IREVER,IPARPL,IOMEGA-1))/DELOME
C
                     END IF
C
                 ELSE
C
                     NUPPRM=NUPPRM+1
                     N_PPRM(IALLST)=NUPPRM
                     LDIMSP(IPARPL,IREVER)=NUPPRM
C
                     ALIGOJ(NUPPRM,IREVER,IPARPL,IOMEGA)
     *                            =SPALIG(ISTATE,IREVER)
                     ALIGOS(NUPPRM,IREVER,IPARPL,IOMEGA)
     *                            =SPSPAL(ISTATE,IREVER)
C
                     LBOKAR(NUPPRM,IREVER,IPARPL,IOMEGA)=LBACTK
                     LBONIL(NUPPRM,IREVER,IPARPL,IOMEGA)=LBACTN
                     LBORDE(NUPPRM,IREVER,IPARPL,IOMEGA)=LBACTO
C
                     ROUTHS(NUPPRM,IREVER,IPARPL,IOMEGA)=ROUOME
C
                     IF (IOMEGA.GT.1) THEN
C
                         ALIGJ2(NUPPRM,IREVER,IPARPL,IOMEGA)=
     *                  (ALIGOJ(NUPPRM,IREVER,IPARPL,IOMEGA)-
     *                   ALIGOJ(NUPPRM,IREVER,IPARPL,IOMEGA-1))/DELOME
C
                         ALIGS2(NUPPRM,IREVER,IPARPL,IOMEGA)=
     *                  (ALIGOS(NUPPRM,IREVER,IPARPL,IOMEGA)-
     *                   ALIGOS(NUPPRM,IREVER,IPARPL,IOMEGA-1))/DELOME
C
                     END IF
C
                 END IF
C
             ELSE
C
                 IF (IREVER.EQ.0) THEN
C
                     NUPMRP=NUPMRP+1
                     N_PMRP(IALLST)=NUPMRP
                     LDIMSP(IPARMI,IREVER)=NUPMRP
C
                     ALIGOJ(NUPMRP,IREVER,IPARMI,IOMEGA)
     *                            =SPALIG(ISTATE,IREVER)
                     ALIGOS(NUPMRP,IREVER,IPARMI,IOMEGA)
     *                            =SPSPAL(ISTATE,IREVER)
C
                     LBOKAR(NUPMRP,IREVER,IPARMI,IOMEGA)=LBACTK
                     LBONIL(NUPMRP,IREVER,IPARMI,IOMEGA)=LBACTN
                     LBORDE(NUPMRP,IREVER,IPARMI,IOMEGA)=LBACTO
C
                     ROUTHS(NUPMRP,IREVER,IPARMI,IOMEGA)=ROUOME
C
                     IF (IOMEGA.GT.1) THEN
C
                         ALIGJ2(NUPMRP,IREVER,IPARMI,IOMEGA)=
     *                  (ALIGOJ(NUPMRP,IREVER,IPARMI,IOMEGA)-
     *                   ALIGOJ(NUPMRP,IREVER,IPARMI,IOMEGA-1))/DELOME
C
                         ALIGS2(NUPMRP,IREVER,IPARMI,IOMEGA)=
     *                  (ALIGOS(NUPMRP,IREVER,IPARMI,IOMEGA)-
     *                   ALIGOS(NUPMRP,IREVER,IPARMI,IOMEGA-1))/DELOME
C
                     END IF
C
                 ELSE
C
                     NUPMRM=NUPMRM+1
                     N_PMRM(IALLST)=NUPMRM
                     LDIMSP(IPARMI,IREVER)=NUPMRM
C
                     ALIGOJ(NUPMRM,IREVER,IPARMI,IOMEGA)
     *                            =SPALIG(ISTATE,IREVER)
                     ALIGOS(NUPMRM,IREVER,IPARMI,IOMEGA)
     *                            =SPSPAL(ISTATE,IREVER)
C
                     LBOKAR(NUPMRM,IREVER,IPARMI,IOMEGA)=LBACTK
                     LBONIL(NUPMRM,IREVER,IPARMI,IOMEGA)=LBACTN
                     LBORDE(NUPMRM,IREVER,IPARMI,IOMEGA)=LBACTO
C
                     ROUTHS(NUPMRM,IREVER,IPARMI,IOMEGA)=ROUOME
C
                     IF (IOMEGA.GT.1) THEN
C
                         ALIGJ2(NUPMRM,IREVER,IPARMI,IOMEGA)=
     *                  (ALIGOJ(NUPMRM,IREVER,IPARMI,IOMEGA)-
     *                   ALIGOJ(NUPMRM,IREVER,IPARMI,IOMEGA-1))/DELOME
C
                         ALIGS2(NUPMRM,IREVER,IPARMI,IOMEGA)=
     *                  (ALIGOS(NUPMRM,IREVER,IPARMI,IOMEGA)-
     *                   ALIGOS(NUPMRM,IREVER,IPARMI,IOMEGA-1))/DELOME
C
                     END IF
C
                 END IF
C
             END IF
C
         ELSE
C
             IPARDM=0 ! Dummy parity index to store the alignments etc.
C                       in the same matrices  that were used above for
C                       the parity/signature symmetric runs
C
C=======================================================================
C            Here the simplex blocks are considered
C=======================================================================
C
             N_SIMP(IALLST)=0
             N_SIMM(IALLST)=0
C
             IF (IREVER.EQ.0) THEN
C
                 NUSIMP=NUSIMP+1
                 N_SIMP(IALLST)=NUSIMP
C
                 ALIGOJ(NUSIMP,IREVER,IPARDM,IOMEGA)
     *                        =SPALIG(ISTATE,IREVER)
                 ALIGOS(NUSIMP,IREVER,IPARDM,IOMEGA)
     *                        =SPSPAL(ISTATE,IREVER)
C
                 LBOKAR(NUSIMP,IREVER,IPARDM,IOMEGA)=LBACTK
                 LBONIL(NUSIMP,IREVER,IPARDM,IOMEGA)=LBACTN
                 LBORDE(NUSIMP,IREVER,IPARDM,IOMEGA)=LBACTO
C
                 ROUTHS(NUSIMP,IREVER,IPARDM,IOMEGA)=ROUOME
C
                 IF (IOMEGA.GT.1) THEN
C
                     ALIGJ2(NUSIMP,IREVER,IPARDM,IOMEGA)=
     *              (ALIGOJ(NUSIMP,IREVER,IPARDM,IOMEGA)-
     *               ALIGOJ(NUSIMP,IREVER,IPARDM,IOMEGA-1))/DELOME
C
                     ALIGS2(NUSIMP,IREVER,IPARDM,IOMEGA)=
     *              (ALIGOS(NUSIMP,IREVER,IPARDM,IOMEGA)-
     *               ALIGOS(NUSIMP,IREVER,IPARDM,IOMEGA-1))/DELOME
C
                 END IF
C
             ELSE
C
                 NUSIMM=NUSIMM+1
                 N_SIMM(IALLST)=NUSIMM
C
                 ALIGOJ(NUSIMM,IREVER,IPARDM,IOMEGA)
     *                        =SPALIG(ISTATE,IREVER)
                 ALIGOS(NUSIMM,IREVER,IPARDM,IOMEGA)
     *                        =SPSPAL(ISTATE,IREVER)
C
                 LBOKAR(NUSIMM,IREVER,IPARDM,IOMEGA)=LBACTK
                 LBONIL(NUSIMM,IREVER,IPARDM,IOMEGA)=LBACTN
                 LBORDE(NUSIMM,IREVER,IPARDM,IOMEGA)=LBACTO
C
                 ROUTHS(NUSIMM,IREVER,IPARDM,IOMEGA)=ROUOME
C
                 IF (IOMEGA.GT.1) THEN
C
                     ALIGJ2(NUSIMM,IREVER,IPARDM,IOMEGA)=
     *              (ALIGOJ(NUSIMM,IREVER,IPARDM,IOMEGA)-
     *               ALIGOJ(NUSIMM,IREVER,IPARDM,IOMEGA-1))/DELOME
C
                     ALIGS2(NUSIMM,IREVER,IPARDM,IOMEGA)=
     *              (ALIGOS(NUSIMM,IREVER,IPARDM,IOMEGA)-
     *               ALIGOS(NUSIMM,IREVER,IPARDM,IOMEGA-1))/DELOME
C
                 END IF
C
             END IF
C
         END IF
C
         IF (ISIGNY.EQ.1) THEN
C
C=======================================================================
C            Parity/time-reversal case:
C
C                   The matrices with configurations are put into
C                   the "SPORDE" labels with the  (parity,irever)
C                   blocks ordered as: (+,+)  (+,-)  (-,-)  (-,+)
C=======================================================================
C
             WRITE(SPORDE(ISTATE,IREVER),'(''('',I2,3('','',I2),'')'')')
     *
     *                                    N_PPRP(IALLST),N_PPRM(IALLST),
     *                                    N_PMRM(IALLST),N_PMRP(IALLST)
C
             WRITE(SPORDR(ISTATE,IREVER),'(''('',I3,3('','',I3),'')'')')
     *
     *                                    N_PPRP(IALLST),N_PPRM(IALLST),
     *                                    N_PMRM(IALLST),N_PMRP(IALLST)
         ELSE
C
C=======================================================================
C
C            Simplex case:  The matrices with configuration symbols are
C            put into the SPORDE labels with the simplex blocks ordered
C            as: (+) (-)
C=======================================================================
C
             WRITE(SPORDE(ISTATE,IREVER),
     *                                  '(''  ('',I3,'','',I3,'')  '')')
     *
     *                                     N_SIMP(IALLST),N_SIMM(IALLST)
C
             WRITE(SPORDR(ISTATE,IREVER),
     *                              '(''    ('',I3,'','',I3,'')    '')')
     *
     *                                     N_SIMP(IALLST),N_SIMM(IALLST)
         END IF
C
      END DO
C
C=======================================================================
C                Printing the table for both reversal blocks
C=======================================================================
C
      IF (IWRITE.GE.1) THEN
C
          IF (EMINAL.LT.EMAXAL) THEN
C
          WRITE(NOUTPT,'(//,80(''#''),/,            ''#'',78X,''#'',/,
     *              ''#   Nucleon-Routhian Properties:  OMEGAY='',F5.3,
     *              ''   (Both Simplexes)    '',A8,2X,''#'',/,
     *              ''#'',78X,''#'',/,80(''#''),/,''#'',78X,''#'',/,
     *                              ''#'',3X,''No)   Energy  '',A13,
     *                                  '' | N,nz,lz, |K|>   <P> '',
     *                        3X,''I_y     s_y    Gfact'',2X,''#'',/,
     *                                            ''#'',78X,''#'')')
     *
     *                            OMEGAC,NAMEPN(ICHARG),NAMSYM(ISIGNY)
C
          END IF
C
      END IF
C
C=======================================================================
C
      DO IALLST=1,2*LDBASE
C
         ISTATE=NSTATE(NORDER(IALLST))
         IREVER=NREVER(NORDER(IALLST))
C
         IF (SPENER(ISTATE,IREVER).GT.EMINAL.AND.
     *       SPENER(ISTATE,IREVER).LT.EMAXAL    ) THEN
C
             ALIAUX=SPALIG(ISTATE,IREVER)
             PARITY=SPPARI(ISTATE,IREVER)
C
             IF (ABS(ALIAUX).GE.1.0E-10) THEN
C
                 FACTOR=SPSPAL(ISTATE,IREVER)/ALIAUX
C
                 IF (ABS(FACTOR).GE.10.00000)    THEN
                     WRITE (GFACTO,'(1PE7.0)') FACTOR
                 ELSE
                     WRITE (GFACTO,'(  F7.3)') FACTOR
                 END IF
C
             ELSE
                 GFACTO='  XXXXX'
             END IF
C
             IF (SPORDE(ISTATE,IREVER)(02:03).EQ.'**' .OR.
     *           SPORDE(ISTATE,IREVER)(05:06).EQ.'**' .OR.
     *           SPORDE(ISTATE,IREVER)(08:09).EQ.'**' .OR.
     *           SPORDE(ISTATE,IREVER)(11:12).EQ.'**') GO TO 10
C
             IF (IWRITE.GE.1) THEN
C
                 WRITE(NOUTPT,'(''#'',2X,I3,'')'',1X,F8.3,2X,A13,
     *                           1X,A15,I6,2F8.3,1X,A7,2X,''#'')')
     *
     *                 IALLST,SPENER(ISTATE,IREVER),
     *                 SPORDE(ISTATE,IREVER),
     *                 SPNILS(ISTATE,IREVER),
     *                 INT(SIGN(ABS(PARITY)*100+0.1,PARITY)),
     *                 SPALIG(ISTATE,IREVER),
     *                 SPSPAL(ISTATE,IREVER),
     *                 GFACTO
C
             END IF
C
   10        CONTINUE
C
         END IF
C
      END DO
C
C=======================================================================
C
      IF (EMINAL.LT.EMAXAL) THEN
C
          IF (IWRITE.GE.1) THEN
              WRITE(NOUTPT,'(''#'',78X,''#'',/,80(''#''),/)')
          END IF
C
      END IF
C
C=======================================================================
C=======================================================================
C         Printing the table of the individual alignments & related
C=======================================================================
C=======================================================================
C
      IF (IOMEGA.GE.1) THEN
C
C=======================================================================
C
          IF (ICYLIN.EQ.1) GO TO 1 ! Here ICYLIN=1 means Oz-symmetry
C                                    ==>> therefore cannot be Oy sym.
C
          IF (ICYLIN.EQ.0.AND.ISPHER.EQ.0) GO TO 1  ! Nonaxial shape
C
          IF (ABS(HBAROX-HBAROZ).LT.1000*EPSYMY) THEN
C
              IF (IWRITE.GE.1) THEN
C
                  WRITE(NOUTPT,'(//,80(''!''),/,80(''!''),/,
     *                       ''!!'',76X,''!!'',/,
     *              ''!!  WARNING !!!  According to the shape-testing'',
     *              '' routine you request cranking  !!'',/,
     *              ''!!               around the symmetry (Oy)-axis.'',
     *              '' In such a case all the Jy(2)  !!'',/,
     *              ''!!               are identically zero. '',
     *              ''Here you have  Wz-Wx='',E9.2,''; CLOSE  !!'',/,
     *              ''!!               Calculated Jy(2) contributions'',
     *              '' can be  poorly  approximated  !!'',/,
     *              ''!!'',76X,''!!'',/,80(''!''),/,80(''!''))')
     *
     *                                        ABS(HBAROX-HBAROZ)
              END IF
C
          END IF
C
   1      CONTINUE
C
C=======================================================================
C
          IF (ABS(DELOME/OMEGAY(IOMEGA)).GT.0.49) THEN
C
              IF (IWRITE.GE.1) THEN
C
                  WRITE(NOUTPT,'(//,80(''!''),/,80(''!''),/,
     *                       ''!!'',76X,''!!'',/,
     *              ''!!  WARNING !!!  You are calculating the '',
     *              ''derivatives  of the alignments with  !!'',/,
     *              ''!!'',76X,''!!'',/,
     *              ''!!               OmegaStep ='',F5.3,
     *              ''    at  OmegaValue ='',F5.3,
     *              '' ~>> probably poor  !!'',/,
     *              ''!!                                       '',
     *              ''                      approximation  !!'',/,
     *              ''!!'',76X,''!!'',/,80(''!''),/,80(''!''))')
     *
     *                                       DELOME,OMEGAY(IOMEGA)
              END IF
C
          END IF
C
C=======================================================================
C
          IF (ISIGNY.EQ.1) THEN
C
              IF (IWRITE.GE.1) THEN
C
                  WRITE(NOUTPT,'(//,80(''#''),/,    ''#'',78X,''#'',/,
     *              ''#  Single-Particle Rotational Moments:  '',
     *              ''OMEGAY='',F5.3,''                  '',A8,1X,
     *              ''#'',/,''#'',78X,''#'',/,80(''#''),/,
     *                      ''#'',78X,''#'',/,
     *              ''#'',2X,''No)  Energy '',''| N,nz,lz, |K|>  PS  '',
     *              ''  Jy(1)   Jy(2) Sy(1) Sy(2)  Totl.1 Totl.2 #'',/,
     *                                            ''#'',78X,''#'')')
     *
     *                                            OMEGAC,NAMEPN(ICHARG)
              END IF
          ELSE
C
              IF (IWRITE.GE.1) THEN
C
                  WRITE(NOUTPT,'(//,80(''#''),/,    ''#'',78X,''#'',/,
     *              ''#  Single-Particle Rotational Moments:  '',
     *              ''OMEGAY='',F5.3,''                  '',A8,1X,
     *              ''#'',/,''#'',78X,''#'',/,80(''#''),/,
     *                      ''#'',78X,''#'',/,
     *              ''#'',2X,''No)  Energy '',''| N,nz,lz, |K|>  P%S '',
     *              ''  Jy(1)   Jy(2) Sy(1) Sy(2)  Totl.1 Totl.2 #'',/,
     *                                            ''#'',78X,''#'')')
     *
     *                                            OMEGAC,NAMEPN(ICHARG)
              END IF
C
          END IF
C
          TOTAL1=0.0
          TOTAL2=0.0
C
C          Parity-signature and simplex blocks
C
          NUPPRP=0
          NUPPRM=0
          NUPMRP=0
          NUPMRM=0
C
          NUSIMP=0
          NUSIMM=0
C
          IPARPL=0
          IPARMI=1
C
C          Also calculating for the up-sloping and down-sloping levels
C          separately
C
          NNEGAL=0
          NPOSAL=0
C
          XNEGJ1=0.0
          XPOSJ1=0.0
C
          XNEGJ2=0.0
          XPOSJ2=0.0
C
          DO IALLST=1,2*LDBASE
C
             ISTATE=NSTATE(NORDER(IALLST))
             IREVER=NREVER(NORDER(IALLST))
             PARITY=SPPARI(ISTATE,IREVER)
C
C=======================================================================
C            Here the parity/time-reversal blocks are considered
C=======================================================================
C
             XMOM_1=0.0
             SMOM_1=0.0
             XMOM_2=0.0
             SMOM_2=0.0
C
             IF (ISIGNY.EQ.1) THEN
C
                 N_PPRP(IALLST)=0
                 N_PPRM(IALLST)=0
                 N_PMRP(IALLST)=0
                 N_PMRM(IALLST)=0
C
                 IF (SPPARI(ISTATE,IREVER).GT.0.0) THEN
C
                     IF (IREVER.EQ.0) THEN
C
                         REVIND='+'
                         PARIND='+'
C
                         NUPPRP=NUPPRP+1
                         N_PPRP(IALLST)=NUPPRP
C
                         XMOM_1=ALIGOJ(NUPPRP,IREVER,IPARPL,IOMEGA)
     *                                          /OMEGAY(IOMEGA)
                         SMOM_1=ALIGOS(NUPPRP,IREVER,IPARPL,IOMEGA)
     *                                          /OMEGAY(IOMEGA)
                         XMOM_2=ALIGJ2(NUPPRP,IREVER,IPARPL,IOMEGA)
                         SMOM_2=ALIGS2(NUPPRP,IREVER,IPARPL,IOMEGA)
C
                         IF (XMOM_1.LE.0.0.AND.IALLST.LE.NPARTI) THEN
                             NNEGAL=NNEGAL+1
                             XNEGJ1=XNEGJ1+XMOM_1
                             XNEGJ2=XNEGJ2+XMOM_2
                         END IF
C
                         IF (XMOM_1.GT.0.0.AND.IALLST.LE.NPARTI) THEN
                             NPOSAL=NPOSAL+1
                             XPOSJ1=XPOSJ1+XMOM_1
                             XPOSJ2=XPOSJ2+XMOM_2
                         END IF
C
                     ELSE
C
                         REVIND='-'
                         PARIND='+'
C
                         NUPPRM=NUPPRM+1
                         N_PPRM(IALLST)=NUPPRM
C
                         XMOM_1=ALIGOJ(NUPPRM,IREVER,IPARPL,IOMEGA)
     *                                              /OMEGAY(IOMEGA)
                         SMOM_1=ALIGOS(NUPPRM,IREVER,IPARPL,IOMEGA)
     *                                              /OMEGAY(IOMEGA)
                         XMOM_2=ALIGJ2(NUPPRM,IREVER,IPARPL,IOMEGA)
                         SMOM_2=ALIGS2(NUPPRM,IREVER,IPARPL,IOMEGA)
C
                         IF (XMOM_1.LE.0.0.AND.IALLST.LE.NPARTI) THEN
                             NNEGAL=NNEGAL+1
                             XNEGJ1=XNEGJ1+XMOM_1
                             XNEGJ2=XNEGJ2+XMOM_2
                         END IF
C
                         IF (XMOM_1.GT.0.0.AND.IALLST.LE.NPARTI) THEN
                             NPOSAL=NPOSAL+1
                             XPOSJ1=XPOSJ1+XMOM_1
                             XPOSJ2=XPOSJ2+XMOM_2
                         END IF
C
                     END IF
C
                 ELSE
C
                     IF (IREVER.EQ.0) THEN
C
                         REVIND='+'
                         PARIND='-'
C
                         NUPMRP=NUPMRP+1
                         N_PMRP(IALLST)=NUPMRP
C
                         XMOM_1=ALIGOJ(NUPMRP,IREVER,IPARMI,IOMEGA)
     *                                              /OMEGAY(IOMEGA)
                         SMOM_1=ALIGOS(NUPMRP,IREVER,IPARMI,IOMEGA)
     *                                              /OMEGAY(IOMEGA)
                         XMOM_2=ALIGJ2(NUPMRP,IREVER,IPARMI,IOMEGA)
                         SMOM_2=ALIGS2(NUPMRP,IREVER,IPARMI,IOMEGA)
C
                         IF (XMOM_1.LE.0.0.AND.IALLST.LE.NPARTI) THEN
                             NNEGAL=NNEGAL+1
                             XNEGJ1=XNEGJ1+XMOM_1
                             XNEGJ2=XNEGJ2+XMOM_2
                         END IF
C
                         IF (XMOM_1.GT.0.0.AND.IALLST.LE.NPARTI) THEN
                             NPOSAL=NPOSAL+1
                             XPOSJ1=XPOSJ1+XMOM_1
                             XPOSJ2=XPOSJ2+XMOM_2
                         END IF
C
                     ELSE
C
                         REVIND='-'
                         PARIND='-'
C
                         NUPMRM=NUPMRM+1
                         N_PMRM(IALLST)=NUPMRM
C
                         XMOM_1=ALIGOJ(NUPMRM,IREVER,IPARMI,IOMEGA)
     *                                              /OMEGAY(IOMEGA)
                         SMOM_1=ALIGOS(NUPMRM,IREVER,IPARMI,IOMEGA)
     *                                              /OMEGAY(IOMEGA)
                         XMOM_2=ALIGJ2(NUPMRM,IREVER,IPARMI,IOMEGA)
                         SMOM_2=ALIGS2(NUPMRM,IREVER,IPARMI,IOMEGA)
C
                         IF (XMOM_1.LE.0.0.AND.IALLST.LE.NPARTI) THEN
                             NNEGAL=NNEGAL+1
                             XNEGJ1=XNEGJ1+XMOM_1
                             XNEGJ2=XNEGJ2+XMOM_2
                         END IF
C
                         IF (XMOM_1.GT.0.0.AND.IALLST.LE.NPARTI) THEN
                             NPOSAL=NPOSAL+1
                             XPOSJ1=XPOSJ1+XMOM_1
                             XPOSJ2=XPOSJ2+XMOM_2
                         END IF
C
                     END IF
C
                 END IF
C
             ELSE
C
                 IPARDM=0 ! Dummy parity index to store the alignments
C                           in the same matrices  that were used above
C                           for the parity/signature symmetric runs
C
C=======================================================================
C                Here the simplex blocks are considered
C=======================================================================
C
                 N_SIMP(IALLST)=0
                 N_SIMM(IALLST)=0
C
                 IF (IREVER.EQ.0) THEN
C
                     SIMIND='+'
C
                     NUSIMP=NUSIMP+1
                     N_SIMP(IALLST)=NUSIMP
C
                     XMOM_1=ALIGOJ(NUSIMP,IREVER,IPARDM,IOMEGA)
     *                                          /OMEGAY(IOMEGA)
                     SMOM_1=ALIGOS(NUSIMP,IREVER,IPARDM,IOMEGA)
     *                                          /OMEGAY(IOMEGA)
                     XMOM_2=ALIGJ2(NUSIMP,IREVER,IPARDM,IOMEGA)
                     SMOM_2=ALIGS2(NUSIMP,IREVER,IPARDM,IOMEGA)
C
                 ELSE
C
                     SIMIND='-'
C
                     NUSIMM=NUSIMM+1
                     N_SIMM(IALLST)=NUSIMM
C
                     XMOM_1=ALIGOJ(NUSIMM,IREVER,IPARDM,IOMEGA)
     *                                          /OMEGAY(IOMEGA)
                     SMOM_1=ALIGOS(NUSIMM,IREVER,IPARDM,IOMEGA)
     *                                          /OMEGAY(IOMEGA)
                     XMOM_2=ALIGJ2(NUSIMM,IREVER,IPARDM,IOMEGA)
                     SMOM_2=ALIGS2(NUSIMM,IREVER,IPARDM,IOMEGA)
C
                 END IF
C
             END IF
C
             IPRCON=INT(SIGN(ABS(PARITY)*100+0.1,PARITY))
C
             IF (ABS(HBAROX-HBAROZ).LT.EPSYMY) THEN
                 XMOM_2=0.0
             END IF
C
             NTOTMI(IOMEGA,ICHARG)=NNEGAL
             NTOTPL(IOMEGA,ICHARG)=NPOSAL
C
             XJ1NEG(IOMEGA,ICHARG)=XNEGJ1
             XJ1POS(IOMEGA,ICHARG)=XPOSJ1
C
             XJ2NEG(IOMEGA,ICHARG)=XNEGJ2
             XJ2POS(IOMEGA,ICHARG)=XPOSJ2
C
             IF (SPENER(ISTATE,IREVER).GE.EMINAL.AND.
     *           SPENER(ISTATE,IREVER).LE.EMAXAL) THEN
C
                 IF (ISIGNY.EQ.1) THEN
C
                     IF (IWRITE.GE.1)
     *
     *               WRITE(NOUTPT,'(''#'',1X,I3,'')'',F8.3,1X,A15,
     *                          '' ['',2A1,'']'',F8.3,F8.3,2F6.2,
     *                                       F8.3,F7.2,1X,''#'')')
     *
     *                              IALLST,SPENER(ISTATE,IREVER),
     *                                     SPNILS(ISTATE,IREVER),
     *                                            PARIND,REVIND,
     *                                            XMOM_1,XMOM_2,
     *                                            SMOM_1,SMOM_2,
     *                                            TOTAL1,TOTAL2
                 ELSE
C
                     IF (IWRITE.GE.1)
     *
     *               WRITE(NOUTPT,'(''#'',1X,I3,'')'',F8.3,1X,A15,
     *                                     I4,A1,F8.3,F8.3,2F6.2,
     *                                       F8.3,F7.2,1X,''#'')')
     *
     *                              IALLST,SPENER(ISTATE,IREVER),
     *                                     SPNILS(ISTATE,IREVER),
     *                                            IPRCON,SIMIND,
     *                                            XMOM_1,XMOM_2,
     *                                            SMOM_1,SMOM_2,
     *                                            TOTAL1,TOTAL2
C
                 END IF
C
             END IF
C
          END DO
C
C=======================================================================
C
          IF (EMINAL.LT.EMAXAL) THEN
C
              IF (IWRITE.GE.1)
     *
     *        WRITE(NOUTPT,'(''#'',78X,''#'',/,80(''#''),/)')
C
          END IF
C
      END IF
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C=======================================================================
C
      SUBROUTINE WS_PUT_MM(ISIGNY)
C=======================================================================
      USE params
C=======================================================================
C
      CHARACTER
     *          SPKART*10,SPNILS*15,SPORDE*13,SPORDR*17
C
      DIMENSION
     *          EORDER(1:NDDOUB),NORDER(1:NDDOUB),NSTATE(1:NDDOUB)
      DIMENSION
     *          N_PPRP(1:NDDOUB),N_PPRM(1:NDDOUB),
     *          N_PMRP(1:NDDOUB),N_PMRM(1:NDDOUB)
      DIMENSION
     *          N_SIMP(1:NDDOUB),N_SIMM(1:NDDOUB)
C
      COMMON
     *       /MULTIP_SPLEVS/ SPENER(1:NDBASE,0:NDREVE),
     *                       SPALIG(1:NDBASE,0:NDREVE),
     *                       SPSPAL(1:NDBASE,0:NDREVE),
     *                       SPPARI(1:NDBASE,0:NDREVE),
     *                       QUOKAR(1:NDBASE,0:NDREVE),
     *                       QUONIL(1:NDBASE,0:NDREVE)
      COMMON
     *       /LBKARR_SPLABS/ SPKART(1:NDBASE,0:NDREVE),
     *                       SPNILS(1:NDBASE,0:NDREVE),
     *                       SPORDE(1:NDBASE,0:NDREVE),
     *                       SPORDR(1:NDBASE,0:NDREVE)
      COMMON
     *       /PUT_MM_SPNUMS/ NUMBSP(0:NDREVE)
      COMMON
     *       /SETBAS_DIMENS/ LDBASE
C
C=======================================================================
C         This routine puts the (+,+) block of the omega=0 hamiltonian
C         into the (-,-) block of the omega=0 hamiltonian, if cranking
C         option will be used. This is to have uniform output files
C         for both time-reversal symmetries.
C=======================================================================
C
C=======================================================================
C           Determining the ordered single-particle spectrum first ...
C=======================================================================
C
      IORDER=0
C
      IREVER=0
C
      NUMBSP(IREVER)=LDBASE
C
      DO ISTATE=1,LDBASE
C
         IORDER=IORDER+1
C
         NORDER(ISTATE)=ISTATE
         EORDER(ISTATE)=SPENER(ISTATE,IREVER)
         NSTATE(ISTATE)=ISTATE
C
      END DO
C
C=======================================================================
C
      CALL WS_ORDER1(EORDER,NORDER,IORDER,NDDOUB)
C
C=======================================================================
C         Calculating the numbers of the lowest  (occupied)  states
C         in every parity/time-reversal block, and in every simplex
C         block.
C=======================================================================
C
      NUPPRP=0
      NUPPRM=0
      NUPMRP=0
      NUPMRM=0
C
      DO ISTATE=1,2*LDBASE
C
         N_PPRP(ISTATE)=0
         N_PPRM(ISTATE)=0
         N_PMRP(ISTATE)=0
         N_PMRM(ISTATE)=0
C
         N_SIMP(ISTATE)=0
         N_SIMM(ISTATE)=0
C
      END DO
C
C=======================================================================
C
      INDEXP=0
      INDEXM=0
C
      DO IALLST=1,LDBASE
C
         ISTATE=NSTATE(NORDER(IALLST))
C
C=======================================================================
C        Here the parity/time-reversal blocks are considered
C=======================================================================
C
         IF (ISIGNY.EQ.1) THEN
C
             IF (SPPARI(ISTATE,0).GT.0.0) THEN
C
                 INDEXP=INDEXP+1
C
                 NUPPRP=NUPPRP+1
                 N_PPRP(INDEXP)=NUPPRP
C
C=======================================================================
C                Parity/time-reversal case:
C                       The matrices with configurations are put into
C                       the "SPORDE" labels with the (PARITY,IREVER)
C                       blocks ordered as: (+,+) (+,-) (-,-) (-,+)
C=======================================================================
C
                 WRITE(SPORDE(INDEXP,0),'(''('',I2,3('','',I2),'')'')')
     *
     *                                    N_PPRP(INDEXP),N_PPRM(INDEXP),
     *                                    N_PMRM(INDEXP),N_PMRP(INDEXP)
C
                 WRITE(SPORDR(INDEXP,0),'(''('',I3,3('','',I3),'')'')')
     *
     *                                    N_PPRP(INDEXP),N_PPRM(INDEXP),
     *                                    N_PMRM(INDEXP),N_PMRP(INDEXP)
C
                 INDEXM=INDEXM+1
C
                 NUPPRM=NUPPRM+1
                 N_PPRM(INDEXM)=NUPPRM
C
                 WRITE(SPORDE(INDEXM,1),'(''('',I2,3('','',I2),'')'')')
     *
     *                                    N_PPRP(INDEXM),N_PPRM(INDEXM),
     *                                    N_PMRM(INDEXM),N_PMRP(INDEXM)
C
                 WRITE(SPORDR(INDEXM,1),'(''('',I3,3('','',I3),'')'')')
     *
     *                                    N_PPRP(INDEXM),N_PPRM(INDEXM),
     *                                    N_PMRM(INDEXM),N_PMRP(INDEXM)
C
             ELSE
C
                 INDEXP=INDEXP+1
C
                 NUPMRP=NUPMRP+1
                 N_PMRP(INDEXP)=NUPMRP
C
                 WRITE(SPORDE(INDEXP,0),'(''('',I2,3('','',I2),'')'')')
     *
     *                                    N_PPRP(INDEXP),N_PPRM(INDEXP),
     *                                    N_PMRM(INDEXP),N_PMRP(INDEXP)
C
                 WRITE(SPORDR(INDEXP,0),'(''('',I3,3('','',I3),'')'')')
     *
     *                                    N_PPRP(INDEXP),N_PPRM(INDEXP),
     *                                    N_PMRM(INDEXP),N_PMRP(INDEXP)
C
                 INDEXM=INDEXM+1
C
                 NUPMRM=NUPMRM+1
                 N_PMRM(INDEXM)=NUPMRM
C
                 WRITE(SPORDE(INDEXM,1),'(''('',I2,3('','',I2),'')'')')
     *
     *                                    N_PPRP(INDEXM),N_PPRM(INDEXM),
     *                                    N_PMRM(INDEXM),N_PMRP(INDEXM)
C
                 WRITE(SPORDR(INDEXM,1),'(''('',I3,3('','',I3),'')'')')
     *
     *                                    N_PPRP(INDEXM),N_PPRM(INDEXM),
     *                                    N_PMRM(INDEXM),N_PMRP(INDEXM)
C
             END IF
C
         ELSE
C
C=======================================================================
C                Here the simplex blocks are considered
C=======================================================================
C
C=======================================================================
C            Simplex case:
C                       The matrices with configurations are put into
C                       the "sporde" labels with the  (simplex)
C                       blocks ordered as: (+) (-)
C=======================================================================
C
             WRITE(SPORDE(ISTATE,0),'(''  ('',I3,'','',I3,'')  '')')
     *
     *                                 N_SIMP(IALLST),N_SIMM(IALLST)
C
             WRITE(SPORDR(ISTATE,0),'(''    ('',I3,'','',I3,'')    '')')
     *
     *                                 N_SIMP(IALLST),N_SIMM(IALLST)
C
             WRITE(SPORDE(ISTATE,1),'(''  ('',I3,'','',I3,'')  '')')
     *
     *                                 N_SIMP(IALLST),N_SIMM(IALLST)
C
             WRITE(SPORDR(ISTATE,1),'(''    ('',I3,'','',I3,'')    '')')
     *
     *                                 N_SIMP(IALLST),N_SIMM(IALLST)
C
         END IF
C
      END DO
C
C=======================================================================
C
      IREVER=1
C
      NUMBSP(IREVER)=LDBASE
C
C=======================================================================
C
      DO ISTATE=1,LDBASE
C
         SPENER(ISTATE,IREVER)=SPENER(ISTATE,IREVER-1)
         SPPARI(ISTATE,IREVER)=SPPARI(ISTATE,IREVER-1)
         SPNILS(ISTATE,IREVER)=SPNILS(ISTATE,IREVER-1)
         SPKART(ISTATE,IREVER)=SPKART(ISTATE,IREVER-1)
         SPALIG(ISTATE,IREVER)=SPALIG(ISTATE,IREVER-1)
         SPSPAL(ISTATE,IREVER)=SPSPAL(ISTATE,IREVER-1)
C
      END DO
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C=======================================================================
C
      SUBROUTINE WS_AVPARI(IREVER)
C=======================================================================
      USE params
C=======================================================================
      COMPLEX
     *          EWAVEF
C
      COMMON
     *       /SPECTR_ESINGP/ ESINGP(1:NDBASE),PARITY(1:NDBASE)
     *       /SPECTR_SPINOR/ EWAVEF(1:NDBASE,1:NDBASE)
      COMMON
     *       /MULTIP_SPLEVS/ SPENER(1:NDBASE,0:NDREVE),
     *                       SPALIG(1:NDBASE,0:NDREVE),
     *                       SPSPAL(1:NDBASE,0:NDREVE),
     *                       SPPARI(1:NDBASE,0:NDREVE),
     *                       QUOKAR(1:NDBASE,0:NDREVE),
     *                       QUONIL(1:NDBASE,0:NDREVE)
      COMMON
     *       /SETBAS_NXNYNZ/ NXVECT(1:NDBASE),
     *                       NYVECT(1:NDBASE),
     *                       NZVECT(1:NDBASE)
      COMMON
     *       /SETBAS_DIMENS/ LDBASE
C
C=======================================================================
C       This routine calculates average parity of single particle states
C=======================================================================
C
      DO ISTATE=1,LDBASE
         PARITY(ISTATE)=0
      END DO
C
C=======================================================================
C
      DO IBASE=1,LDBASE
C
         IPARI=1-2*MOD(NXVECT(IBASE)+NYVECT(IBASE)+NZVECT(IBASE),2)
C
         DO ISTATE=1,LDBASE
C
            PARITY(ISTATE)=PARITY(ISTATE)
     *                    +IPARI*EWAVEF(IBASE,ISTATE)
     *                    *CONJG(EWAVEF(IBASE,ISTATE))
C
         END DO
C
      END DO
C
C=======================================================================
C         Storing single-particle parities
C=======================================================================
C
      DO ISTATE=1,LDBASE
         SPPARI(ISTATE,IREVER)=PARITY(ISTATE)
      END DO
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C=======================================================================
C
      SUBROUTINE WS_SETREV
C=======================================================================
      USE params
C=======================================================================
      CHARACTER
     *          SPKART*10,SPNILS*15,SPORDE*13,SPORDR*17
C
      COMMON
     *       /MULTIP_SPLEVS/ SPENER(1:NDBASE,0:NDREVE),
     *                       SPALIG(1:NDBASE,0:NDREVE),
     *                       SPSPAL(1:NDBASE,0:NDREVE),
     *                       SPPARI(1:NDBASE,0:NDREVE),
     *                       QUOKAR(1:NDBASE,0:NDREVE),
     *                       QUONIL(1:NDBASE,0:NDREVE)
      COMMON
     *       /LBKARR_SPLABS/ SPKART(1:NDBASE,0:NDREVE),
     *                       SPNILS(1:NDBASE,0:NDREVE),
     *                       SPORDE(1:NDBASE,0:NDREVE),
     *                       SPORDR(1:NDBASE,0:NDREVE)
      COMMON
     *       /LBKARR_QUOCAR/ QUOTCA(1:NDBASE,0:NDREVE)
     *       /SPHONL_QUOSPH/ QUOTSP(1:NDBASE,0:NDREVE)
     *       /CYLONL_QUOCYL/ QUOTCY(1:NDBASE,0:NDREVE)
C
      COMMON
     *       /LBKARR_BASCAR/ NXCART(1:NDBASE,0:NDREVE),
     *                       NYCART(1:NDBASE,0:NDREVE),
     *                       NZCART(1:NDBASE,0:NDREVE)
      COMMON
     *       /SPHONL_SPHERE/ MAIN0S(1:NDBASE,0:NDREVE),
     *                       JMOM0S(1:NDBASE,0:NDREVE),
     *                       LSPH0S(1:NDBASE,0:NDREVE),
     *                       MMOM0S(1:NDBASE,0:NDREVE)
      COMMON
     *       /CYLONL_CYLIND/ MAINNL(1:NDBASE,0:NDREVE),
     *                       NZNILS(1:NDBASE,0:NDREVE),
     *                       L_NILS(1:NDBASE,0:NDREVE),
     *                       IOMEGA(1:NDBASE,0:NDREVE)
C
      COMMON
     *       /PUT_MM_SPNUMS/ NUMBSP(0:NDREVE)
      COMMON
     *       /SETBAS_DIMENS/ LDBASE
C
C=======================================================================
C         Auxiliary routine used for the no-rotation case
C                     (setting rever1=rever0)
C=======================================================================
C
      NUMBSP(0)=LDBASE
      NUMBSP(1)=LDBASE
C
      DO LEVELS=1,LDBASE
C
         SPKART(LEVELS,1)=SPKART(LEVELS,0)
         SPNILS(LEVELS,1)=SPNILS(LEVELS,0)
         SPPARI(LEVELS,1)=SPPARI(LEVELS,0)
         QUOKAR(LEVELS,1)=QUOKAR(LEVELS,0)
         QUONIL(LEVELS,1)=QUONIL(LEVELS,0)
C
         SPALIG(LEVELS,1)=-SPALIG(LEVELS,0)
         SPSPAL(LEVELS,1)=-SPSPAL(LEVELS,0)
C
         NXCART(LEVELS,1)=NXCART(LEVELS,0)
         NYCART(LEVELS,1)=NYCART(LEVELS,0)
         NZCART(LEVELS,1)=NZCART(LEVELS,0)
C
         MAIN0S(LEVELS,1)=MAIN0S(LEVELS,0)
         JMOM0S(LEVELS,1)=JMOM0S(LEVELS,0)
         LSPH0S(LEVELS,1)=LSPH0S(LEVELS,0)
         MMOM0S(LEVELS,1)=MMOM0S(LEVELS,0)
C
         MAINNL(LEVELS,1)=MAINNL(LEVELS,0)
         NZNILS(LEVELS,1)=NZNILS(LEVELS,0)
         L_NILS(LEVELS,1)=L_NILS(LEVELS,0)
         IOMEGA(LEVELS,1)=IOMEGA(LEVELS,0)
C
         QUOTCA(LEVELS,1)=QUOTCA(LEVELS,0)
         QUOTSP(LEVELS,1)=QUOTSP(LEVELS,0)
         QUOTCY(LEVELS,1)=QUOTCY(LEVELS,0)
C
      END DO
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C=======================================================================
C
      SUBROUTINE WS_OMSPIN(OMEGAX,OMEGAY,OMEGAZ,NOFOMX,NOFOMY,NOFOMZ,
     *                     XMOMFC,YMOMFC,ZMOMFC,SPIN_X,SPIN_Y,SPIN_Z,
     *                                          ISPINX,ISPINY,ISPINZ)
C=======================================================================
      USE params
C=======================================================================
      DIMENSION
     *          OMEGAX(0:NDOMEG),OMEGAY(0:NDOMEG),OMEGAZ(0:NDOMEG)
C
      COMMON
     *       /READWRITE_PAR/ NOUTPT,IWRITE,ISCREN
C
C=======================================================================
C
C         This subroutine calculates the omega values for cranking
C         runs assuming, that the maximum classical spin  SPIN_(*)
C         is given. The cranking frequencies are defined using the
C         classical relation:
C                                  FREQUENCY = SPIN / INERTIA
C
C         where INERTIA = XMOMFC or YMOMFC or ZMOMFC  are macrosco-
C         pic moments of inertia.
C
C=======================================================================
C
      IF (ISPINX.NE.0) THEN              ! Ox - cranking requested
C
          OMEMAX=SPIN_X/XMOMFC
C
          STEP_X=OMEMAX/(NOFOMX-1)
C
          DO IOMEGA=1,NOFOMX
             OMEGAX(IOMEGA)=(IOMEGA-1)*STEP_X
          END DO
C
          IF (IWRITE.GE.1)
     *    WRITE(NOUTPT,'(/,80(''#''),/,''#'',78X,''#'',/,
     *                 ''#  Cranking Calculations ("x"-direction)'',
     *                 ''       the number of omega values='',I2,
     *                                                   ''   #'',/,
     *                 ''#'',78X,''#'',/,
     *                 ''#  Maximum Spin ='',F6.1,
     *                 ''  <<==>> Moment of Inertia ='',F6.1,
     *                 '' -->> OMEMAX='',F6.4,''   #'',/,
     *                 ''#'',78X,''#'',/,80(''#''))')
     *
     *                  NOFOMX,SPIN_X,XMOMFC,OMEMAX
C
      END IF
C
C=======================================================================
C
      IF (ISPINY.NE.0) THEN              ! Oy - cranking requested
C
          OMEMAX=SPIN_Y/YMOMFC
C
          STEP_Y=OMEMAX/(NOFOMY-1)
C
          DO IOMEGA=1,NOFOMY
             OMEGAY(IOMEGA)=(IOMEGA-1)*STEP_Y
          END DO
C
          IF (IWRITE.GE.1)
     1    WRITE(NOUTPT,'(/,80(''#''),/,''#'',78X,''#'',/,
     *                 ''#  Cranking Calculations ("y"-direction)'',
     *                 ''       the Number of Omega Values='',I2,
     *                                                   ''   #'',/,
     *                 ''#'',78X,''#'',/,
     *                 ''#  Maximum Spin ='',F6.1,
     *                 ''  <<==>> Moment of Inertia ='',F6.1,
     *                 '' -->> OMEMAX='',F6.4,''   #'',/,
     *                 ''#'',78X,''#'',/,80(''#''))')
     *
     *                 NOFOMY,SPIN_Y,YMOMFC,OMEMAX
C
      END IF
C
C=======================================================================
C
      IF (ISPINZ.NE.0) THEN             ! Oy - cranking requested
C
          OMEMAX=SPIN_Z/ZMOMFC
C
          STEP_Z=OMEMAX/(NOFOMZ-1)
C
          DO IOMEGA=1,NOFOMZ
             OMEGAZ(IOMEGA)=(IOMEGA-1)*STEP_Z
          END DO
C
          IF (IWRITE.GE.1)
     *    WRITE(NOUTPT,'(/,80(''#''),/,''#'',78X,''#'',/,
     *                 ''#  Cranking Calculations ("z"-direction)'',
     *                 ''       the Number of Omega Values='',I2,
     *                                                   ''   #'',/,
     *                 ''#'',78X,''#'',/,
     *                 ''#  Maximum Spin ='',F6.1,
     *                 ''  <<==>> Moment of Inertia ='',F6.1,
     *                 '' -->> OMEMAX='',F6.4,''   #'',/,
     *                 ''#'',78X,''#'',/,80(''#''))')
     *
     *                 NOFOMZ,SPIN_Z,ZMOMFC,OMEMAX
C
      END IF
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C=======================================================================
C
      SUBROUTINE WS_INT_LX(NXMAXX,NYMAXX,NZMAXX,ELM_LX,OMEGAC,LDBASE)
C=======================================================================
      USE params
C=======================================================================
C
      DIMENSION
     *          ELM_LX(1:NDBASE,1:NDBASE)
C
      COMMON
     *       /DEVHER_COEXYZ/ COEF00(0:ND2MAX,0:NDOSGS,0:NDOSGS,NDKART),
     *                       COEF01(0:ND2MAX,0:NDOSGS,0:NDOSGS,NDKART),
     *                       COEF11(0:ND2MAX,0:NDOSGS,0:NDOSGS,NDKART),
     *                       COEF02(0:ND2MAX,0:NDOSGS,0:NDOSGS,NDKART)
      COMMON
     *       /TPHASE_PHASES/ TPHAPP(0:NDYMAX,0:NDYMAX,0:NDKART),
     *                       TPHAPM(0:NDYMAX,0:NDYMAX,0:NDKART),
     *                       TPHAMP(0:NDYMAX,0:NDYMAX,0:NDKART),
     *                       TPHAMM(0:NDYMAX,0:NDYMAX,0:NDKART)
      COMMON
     *       /SETBAS_INDICE/ INDICE(0:NDXMAX,0:NDYMAX,0:NDZMAX)
      COMMON
     *       /SETBAS_BASIS1/ LAXOFY(0:NDYMAX),LAXOFZ(0:NDZMAX),
     *                       LAYOFZ(0:NDZMAX),LAYOFX(0:NDXMAX),
     *                       LAZOFX(0:NDXMAX),LAZOFY(0:NDYMAX)
      COMMON
     *       /SETBAS_BASIS2/ LAXOYZ(0:NDYMAX,0:NDZMAX),
     *                       LAYOZX(0:NDZMAX,0:NDXMAX),
     *                       LAZOXY(0:NDXMAX,0:NDYMAX)
      COMMON
     *       /SETBAS_SCALNG/ HOMSCA(NDKART)
C
C=======================================================================
C     This subroutine calculates the matrix elements of Lx in units
C     of hbar. For the cranking application the (+,-) block will be
C     needed while (-,+) = Conjg (+,-). In the t-basis representatn.
C     these elements are purely imaginary, here,  however stored as
C                                                              real
C=======================================================================
C
      CALL WS_CPUTIM('INT_LX',1)
C
C=======================================================================
C
      PI=4.0*ATAN(1.00)
      SQRTP2=SQRT(PI/2)
C
      KARTEZ=0
C
      FACACT=-SQRTP2/SQRT(HOMSCA(2)*HOMSCA(3))*OMEGAC
C
C=======================================================================
C
      DO IBRAHO=1,LDBASE
         DO IKETHO=1,LDBASE
            ELM_LX(IBRAHO,IKETHO)=0.0
         END DO
      END DO
C
C=======================================================================
C
      DO NX=0,NXMAXX
         MX=NX
C
         DO NY=0,LAYOFX(NX)
            DO MY=MAX(0,NY-1),MIN(LAYOFX(MX),NY+1)
C
               DO NZ=0,LAZOXY(NX,NY)
                  DO MZ=MAX(0,NZ-1),MIN(LAZOXY(MX,MY),NZ+1)
C
                     WORK_X=FACACT
     *                     *((COEF00(1,NY,MY,2)/HOMSCA(2))
     *                       *COEF01(0,NZ,MZ,3)
     *                     - (COEF00(1,NZ,MZ,3)/HOMSCA(3))
     *                       *COEF01(0,NY,MY,2))
     *
     *                       *TPHAPM(NY,MY,KARTEZ)
C
                     ELM_LX(INDICE(NX,NY,NZ),INDICE(MX,MY,MZ))=WORK_X
C
                  END DO
               END DO
C
            END DO
         END DO
C
      END DO
C
C=======================================================================
C
      CALL WS_CPUTIM('INT_LX',0)
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C=======================================================================
C
      SUBROUTINE WS_INT_SX(NXMAXX,NYMAXX,NZMAXX,ELM_SX,OMEGAC,LDBASE)
C=======================================================================
      USE params
C=======================================================================
C
      DIMENSION
     *          ELM_SX(1:NDBASE,1:NDBASE)
C
      COMMON
     *       /TPHASE_PHASES/ TPHAPP(0:NDYMAX,0:NDYMAX,0:NDKART),
     *                       TPHAPM(0:NDYMAX,0:NDYMAX,0:NDKART),
     *                       TPHAMP(0:NDYMAX,0:NDYMAX,0:NDKART),
     *                       TPHAMM(0:NDYMAX,0:NDYMAX,0:NDKART)
      COMMON
     *       /SETBAS_INDICE/ INDICE(0:NDXMAX,0:NDYMAX,0:NDZMAX)
      COMMON
     *       /SETBAS_BASIS1/ LAXOFY(0:NDYMAX),LAXOFZ(0:NDZMAX),
     *                       LAYOFZ(0:NDZMAX),LAYOFX(0:NDXMAX),
     *                       LAZOFX(0:NDXMAX),LAZOFY(0:NDYMAX)
      COMMON
     *       /SETBAS_BASIS2/ LAXOYZ(0:NDYMAX,0:NDZMAX),
     *                       LAYOZX(0:NDZMAX,0:NDXMAX),
     *                       LAZOXY(0:NDXMAX,0:NDYMAX)
C
C=======================================================================
C
C     This subroutine calculates the matrix elements of Sx in hbar
C     units. For the cranking model application it is neccesary to
C     define the blocks (+,-) and (-,+)
C
C                        |   0   | (+,-) |
C                        -----------------
C                        | (-,+) |   0   |
C
C     Here we calculate only (+,-) because (-,+) = conjg (+,-). In
C     this block the Sx matrix-elements are purely real.
C
C=======================================================================
C
      SPIN05=0.5
      KARTEZ=001
C
C=======================================================================
C
      DO IBRAHO=1,LDBASE
         DO IKETHO=1,LDBASE
            ELM_SX(IBRAHO,IKETHO)=0.0
         END DO
      END DO
C
C=======================================================================
C
      DO NX=0,NXMAXX
         DO NY=0,LAYOFX(NX)
            DO NZ=0,LAZOXY(NX,NY)
C
               IBRAHO=INDICE(NX,NY,NZ)
               IKETHO=INDICE(NX,NY,NZ)
C
               ELM_SX(IBRAHO,IKETHO)=SPIN05*TPHAPM(NY,NY,KARTEZ)
     *                                                  *OMEGAC
C
            END DO
         END DO
      END DO
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C=======================================================================
C
      SUBROUTINE WS_INT_LY(NXMAXX,NYMAXX,NZMAXX,ELM_LY,OMEGAC,LDBASE)
C=======================================================================
      USE params
C=======================================================================
C
      DIMENSION
     *          ELM_LY(1:NDBASE,1:NDBASE)
C
      COMMON
     *       /DEVHER_COEXYZ/ COEF00(0:ND2MAX,0:NDOSGS,0:NDOSGS,NDKART),
     *                       COEF01(0:ND2MAX,0:NDOSGS,0:NDOSGS,NDKART),
     *                       COEF11(0:ND2MAX,0:NDOSGS,0:NDOSGS,NDKART),
     *                       COEF02(0:ND2MAX,0:NDOSGS,0:NDOSGS,NDKART)
      COMMON
     *       /TPHASE_PHASES/ TPHAPP(0:NDYMAX,0:NDYMAX,0:NDKART),
     *                       TPHAPM(0:NDYMAX,0:NDYMAX,0:NDKART),
     *                       TPHAMP(0:NDYMAX,0:NDYMAX,0:NDKART),
     *                       TPHAMM(0:NDYMAX,0:NDYMAX,0:NDKART)
      COMMON
     *       /SETBAS_INDICE/ INDICE(0:NDXMAX,0:NDYMAX,0:NDZMAX)
     *
     *       /SETBAS_BASIS1/ LAXOFY(0:NDYMAX),LAXOFZ(0:NDZMAX),
     *                       LAYOFZ(0:NDZMAX),LAYOFX(0:NDXMAX),
     *                       LAZOFX(0:NDXMAX),LAZOFY(0:NDYMAX)
     *
     *       /SETBAS_BASIS2/ LAXOYZ(0:NDYMAX,0:NDZMAX),
     *                       LAYOZX(0:NDZMAX,0:NDXMAX),
     *                       LAZOXY(0:NDXMAX,0:NDYMAX)
     *
     *       /SETBAS_SCALNG/ HOMSCA(NDKART)
C
C=======================================================================
C     This subroutine calculates the matrix elements of Ly in hbar
C     units.  For the cranking application the (+,+) block will be
C     needed while (-,-) = - conjg (+,+). The Ly operator is block
C     diagonal. In the "t-basis" representation,  its elements are
C     purely imaginary.
C=======================================================================
C
      PI=4.0*ATAN(1.00)
      SQRTP2=SQRT(PI/2)
C
      KARTEZ=0
C
      FACACT=-SQRTP2/SQRT(HOMSCA(1)*HOMSCA(3))*OMEGAC
C
C=======================================================================
C
      DO IBRAHO=1,LDBASE
         DO IKETHO=1,LDBASE
            ELM_LY(IBRAHO,IKETHO)=0.0
         END DO
      END DO
C
C=======================================================================
C
      DO NY=0,NYMAXX
         MY=NY
C
         DO NZ=0,LAZOFY(NY)
            DO MZ=MAX(0,NZ-1),MIN(LAZOFY(MY),NZ+1)
C
               DO NX=0,LAXOYZ(NY,NZ)
                  DO MX=MAX(0,NX-1),MIN(LAXOYZ(MY,MZ),NX+1)
C
                     WORK_Y=FACACT
     *                     *((COEF00(1,NZ,MZ,3)/HOMSCA(3))
     *                       *COEF01(0,NX,MX,1)
     *                     - (COEF00(1,NX,MX,1)/HOMSCA(1))
     *                       *COEF01(0,NZ,MZ,3))
     *
     *                       *TPHAPP(NY,MY,KARTEZ)
C
                     ELM_LY(INDICE(NX,NY,NZ),INDICE(MX,MY,MZ))=WORK_Y
C
                  END DO
               END DO
C
            END DO
         END DO
C
      END DO
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C=======================================================================
C
      SUBROUTINE WS_INT_SY(NXMAXX,NYMAXX,NZMAXX,ELM_SY,OMEGAC,LDBASE)
C=======================================================================
      USE params
C=======================================================================

      DIMENSION
     *          ELM_SY(1:NDBASE,1:NDBASE)
C
      COMMON
     *       /TPHASE_PHASES/ TPHAPP(0:NDYMAX,0:NDYMAX,0:NDKART),
     *                       TPHAPM(0:NDYMAX,0:NDYMAX,0:NDKART),
     *                       TPHAMP(0:NDYMAX,0:NDYMAX,0:NDKART),
     *                       TPHAMM(0:NDYMAX,0:NDYMAX,0:NDKART)
      COMMON
     *       /SETBAS_INDICE/ INDICE(0:NDXMAX,0:NDYMAX,0:NDZMAX)
     *
     *       /SETBAS_BASIS1/ LAXOFY(0:NDYMAX),LAXOFZ(0:NDZMAX),
     *                       LAYOFZ(0:NDZMAX),LAYOFX(0:NDXMAX),
     *                       LAZOFX(0:NDXMAX),LAZOFY(0:NDYMAX)
     *
     *       /SETBAS_BASIS2/ LAXOYZ(0:NDYMAX,0:NDZMAX),
     *                       LAYOZX(0:NDZMAX,0:NDXMAX),
     *                       LAZOXY(0:NDXMAX,0:NDYMAX)
C
C=======================================================================
C
C     This subroutine calculates the matrix elements of Sy in hbar
C     units. For the cranking model application it is necessary to
C     define the blocks (+,+) and (-,-)
C
C                         | (+,+) |   0   |
C                         -----------------
C                         |   0   | (-,-) |
C
C     Here we calculate only  (+,+)  because  (-,-) = -Conjg (+,+).
C     In this block the Sy matrix-elements are purely real  in the
C     representation used.  As usual conjugation will be needed to
C     obtain one block from another.
C
C=======================================================================
C
      SPIN05=0.5
      KARTEZ=002
C
      DO IBRAHO=1,LDBASE
         DO IKETHO=1,LDBASE
            ELM_SY(IBRAHO,IKETHO)=0.0
         END DO
      END DO
C
C=======================================================================
C
      DO NY=0,NYMAXX
         DO NZ=0,LAZOFY(NY)
            DO NX=0,LAXOYZ(NY,NZ)
C
               IBRAHO=INDICE(NX,NY,NZ)
               IKETHO=INDICE(NX,NY,NZ)
C
               ELM_SY(IBRAHO,IKETHO)=SPIN05*TPHAPP(NY,NY,KARTEZ)
     *                                                  *OMEGAC
C
            END DO
         END DO
      END DO
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C=======================================================================
C
      SUBROUTINE WS_INT_LZ(NXMAXX,NYMAXX,NZMAXX,ELM_LZ,OMEGAC,LDBASE)
C=======================================================================
      USE params
C=======================================================================
C
      DIMENSION
     *          ELM_LZ(1:NDBASE,1:NDBASE)
C
      COMMON
     *       /DEVHER_COEXYZ/ COEF00(0:ND2MAX,0:NDOSGS,0:NDOSGS,NDKART),
     *                       COEF01(0:ND2MAX,0:NDOSGS,0:NDOSGS,NDKART),
     *                       COEF11(0:ND2MAX,0:NDOSGS,0:NDOSGS,NDKART),
     *                       COEF02(0:ND2MAX,0:NDOSGS,0:NDOSGS,NDKART)
      COMMON
     *       /TPHASE_PHASES/ TPHAPP(0:NDYMAX,0:NDYMAX,0:NDKART),
     *                       TPHAPM(0:NDYMAX,0:NDYMAX,0:NDKART),
     *                       TPHAMP(0:NDYMAX,0:NDYMAX,0:NDKART),
     *                       TPHAMM(0:NDYMAX,0:NDYMAX,0:NDKART)
      COMMON
     *       /SETBAS_INDICE/ INDICE(0:NDXMAX,0:NDYMAX,0:NDZMAX)
     *
     *       /SETBAS_BASIS1/ LAXOFY(0:NDYMAX),LAXOFZ(0:NDZMAX),
     *                       LAYOFZ(0:NDZMAX),LAYOFX(0:NDXMAX),
     *                       LAZOFX(0:NDXMAX),LAZOFY(0:NDYMAX)
     *
     *       /SETBAS_BASIS2/ LAXOYZ(0:NDYMAX,0:NDZMAX),
     *                       LAYOZX(0:NDZMAX,0:NDXMAX),
     *                       LAZOXY(0:NDXMAX,0:NDYMAX)
     *
     *       /SETBAS_SCALNG/ HOMSCA(NDKART)
C
C=======================================================================
C
C     This subroutine calculates the matrix elements of Lz in hbar
C     units.  For the cranking application the (+,-) block will be
C     needed, while (-,+) = Conjg (+,+).  The Lz operator is block-
C     anti-diagonal.  In the "t-basis" representation its elements
C     are purely imaginary.  Here they will be stored as pure-real.
C
C=======================================================================
C
      PI=4.0*ATAN(1.00)
      SQRTP2=SQRT(PI/2)
C
      KARTEZ=0
C
      FACACT=-SQRTP2/SQRT(HOMSCA(1)*HOMSCA(2))*OMEGAC
C
C=======================================================================
C
      DO IBRAHO=1,LDBASE
         DO IKETHO=1,LDBASE
            ELM_LZ(IBRAHO,IKETHO)=0.0
         END DO
      END DO
C
C=======================================================================
C
      DO NZ=0,NZMAXX
         MZ=NZ
C
         DO NX=0,LAXOFZ(NZ)
            DO MX=MAX(0,NX-1),MIN(LAXOFZ(MZ),NX+1)
C
               DO NY=0,LAYOZX(NZ,NX)
                  DO MY=MAX(0,NY-1),MIN(LAYOZX(MZ,MX),NY+1)
C
                     WORK_Z=FACACT
     *                     *((COEF00(1,NX,MX,1)/HOMSCA(1))
     *                       *COEF01(0,NY,MY,2)
     *                     - (COEF00(1,NY,MY,2)/HOMSCA(2))
     *                       *COEF01(0,NX,MX,1))
     *
     *                       *TPHAPM(NY,MY,KARTEZ)
C
                     ELM_LZ(INDICE(NX,NY,NZ),INDICE(MX,MY,MZ))=WORK_Z
C
                  END DO
               END DO
C
            END DO
         END DO
C
      END DO
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C=======================================================================
C
      SUBROUTINE WS_INT_SZ(NXMAXX,NYMAXX,NZMAXX,ELM_SZ,OMEGAC,LDBASE)
C=======================================================================
      USE params
C=======================================================================
C
      DIMENSION
     *          ELM_SZ(1:NDBASE,1:NDBASE)
C
      COMMON
     *       /TPHASE_PHASES/ TPHAPP(0:NDYMAX,0:NDYMAX,0:NDKART),
     *                       TPHAPM(0:NDYMAX,0:NDYMAX,0:NDKART),
     *                       TPHAMP(0:NDYMAX,0:NDYMAX,0:NDKART),
     *                       TPHAMM(0:NDYMAX,0:NDYMAX,0:NDKART)
      COMMON
     *       /SETBAS_INDICE/ INDICE(0:NDXMAX,0:NDYMAX,0:NDZMAX)
     *
     *       /SETBAS_BASIS1/ LAXOFY(0:NDYMAX),LAXOFZ(0:NDZMAX),
     *                       LAYOFZ(0:NDZMAX),LAYOFX(0:NDXMAX),
     *                       LAZOFX(0:NDXMAX),LAZOFY(0:NDYMAX)
     *
     *       /SETBAS_BASIS2/ LAXOYZ(0:NDYMAX,0:NDZMAX),
     *                       LAYOZX(0:NDZMAX,0:NDXMAX),
     *                       LAZOXY(0:NDXMAX,0:NDYMAX)
C
C=======================================================================
C
C     This subroutine calculates the matrix elements of Sz in hbar
C     units. For the cranking model application it is neccesary to
C     define the blocks (+,-) and (-,+)
C
C                            |   0   | (+,-) |
C                            -----------------
C                            | (-,+) |   0   |
C
C     Here we calculate only (+,-) because (-,+) = Conjg(+,-).  In
C     this block the Sz matrix-elements are purely imaginary.
C
C=======================================================================
C
      SPIN05=0.5
      KARTEZ=003
C
C=======================================================================
C
      DO IBRAHO=1,LDBASE
         DO IKETHO=1,LDBASE
            ELM_SZ(IBRAHO,IKETHO)=0.0
         END DO
      END DO
C
C=======================================================================
C
      DO NZ=0,NZMAXX
         DO NX=0,LAXOFZ(NZ)
            DO NY=0,LAYOZX(NZ,NX)
C
               IBRAHO=INDICE(NX,NY,NZ)
               IKETHO=INDICE(NX,NY,NZ)
C
               ELM_SZ(IBRAHO,IKETHO)=SPIN05*TPHAPM(NY,NY,KARTEZ)
     *                                     *OMEGAC
C
            END DO
         END DO
      END DO
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C=======================================================================
C
      SUBROUTINE WS_JXJXJX(NXMAXX,NYMAXX,NZMAXX,ELM_LL,ELM_SS,
     *                            PM_EJX,MP_EJX,OMEGAC,LDBASE)
C=======================================================================
      USE params
C=======================================================================
      COMPLEX
     *          PM_EJX(1:NDBASE,1:NDBASE),
     *          MP_EJX(1:NDBASE,1:NDBASE)
C
      DIMENSION
     *          ELM_LL(1:NDBASE,1:NDBASE),
     *          ELM_SS(1:NDBASE,1:NDBASE)
C
C=======================================================================
C
C     This subroutine adds up  L_x and S_x  into complex matrices.
C
C     The Jx-elements are non-zero for the (+,-) and (-,+) blocks
C     only. The  (+,-)  matrix elements will be stored in  PM_EJX
C     while the  (-,+)  matrix elements will be stored in  MP_EJX.
C
C     In basis "t": Lx is imaginary while Sx is real, and we have
C
C     <t1+|Jx|t2->=<t1-|Jx|t2+>*;     <t1+|Jx|t2+>=<t1-|Jx|t2->=0
C
C=======================================================================
C
      DO J=1,LDBASE
         DO I=1,LDBASE
            PM_EJX(I,J)=(0.0,0.0)
            MP_EJX(I,J)=(0.0,0.0)
         END DO
      END DO
C
C=======================================================================
C
      CALL WS_INT_LX(NXMAXX,NYMAXX,NZMAXX,ELM_LL,OMEGAC,LDBASE)
C
C=======================================================================
C
      CALL WS_ADDIMA(+1,ELM_LL,PM_EJX,LDBASE)
      CALL WS_ADDIMA(-1,ELM_LL,MP_EJX,LDBASE)
C
C=======================================================================
C
      CALL WS_INT_SX(NXMAXX,NYMAXX,NZMAXX,ELM_SS,OMEGAC,LDBASE)
C
C=======================================================================
C
      CALL WS_ADDREA(+1,ELM_SS,PM_EJX,LDBASE)
      CALL WS_ADDREA(+1,ELM_SS,MP_EJX,LDBASE)
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C=======================================================================
C
      SUBROUTINE WS_JYJYJY(NXMAXX,NYMAXX,NZMAXX,ELM_LL,ELM_SS,
     *                            PP_EJY,MM_EJY,OMEGAC,LDBASE)
C=======================================================================
      USE params
C=======================================================================
      COMPLEX
     *          PP_EJY(1:NDBASE,1:NDBASE),
     *          MM_EJY(1:NDBASE,1:NDBASE)
      DIMENSION
     *          ELM_LL(1:NDBASE,1:NDBASE),
     *          ELM_SS(1:NDBASE,1:NDBASE)
C
C=======================================================================
C
C     This subroutine adds up  L_y and S_y  into complex matrices.
C
C     The Jy-elements are non-zero for the (+,+) and (-,-) blocks
C     only. The  (+,+)  matrix elements will be stored in  PP_EJY
C     while the  (-,-)  matrix elements will be stored in  MM_EJY
C
C     In the "t"-basis Ly is imaginary while Sy is real;  we have
C
C     <t1-|Jy|t2->=-<t1+|Jy|t2+>*=0;  <t1+|Jy|t2->=<t1-|Jy|t2+>=0
C
C=======================================================================
C
      DO J=1,LDBASE
         DO I=1,LDBASE
            PP_EJY(I,J)=(0.0,0.0)
            MM_EJY(I,J)=(0.0,0.0)
         END DO
      END DO
C
C=======================================================================
C
      CALL WS_INT_LY(NXMAXX,NYMAXX,NZMAXX,ELM_LL,OMEGAC,LDBASE)
C
C=======================================================================
C
      CALL WS_ADDIMA(+1,ELM_LL,PP_EJY,LDBASE)
      CALL WS_ADDIMA(+1,ELM_LL,MM_EJY,LDBASE)
C
C=======================================================================
C
      CALL WS_INT_SY(NXMAXX,NYMAXX,NZMAXX,ELM_SS,OMEGAC,LDBASE)
C
C=======================================================================
C
      CALL WS_ADDREA(+1,ELM_SS,PP_EJY,LDBASE)
      CALL WS_ADDREA(-1,ELM_SS,MM_EJY,LDBASE)
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C=======================================================================
C
      SUBROUTINE WS_JZJZJZ(NXMAXX,NYMAXX,NZMAXX,ELM_LL,ELM_SS,
     *                            PM_EJZ,MP_EJZ,OMEGAC,LDBASE)
C=======================================================================
      USE params
C=======================================================================
      COMPLEX
     *          PM_EJZ(1:NDBASE,1:NDBASE),
     *          MP_EJZ(1:NDBASE,1:NDBASE)
      DIMENSION
     *          ELM_LL(1:NDBASE,1:NDBASE),
     *          ELM_SS(1:NDBASE,1:NDBASE)
C
C=======================================================================
C
C     This subroutine adds up  L_z and S_z  into complex matrices.
C
C     The Jz-elements are non-zero for the (+,-) and (-,+) blocks
C     only. The  (+,-)  matrix elements will be stored in  PM_EJZ
C     while the  (-,+)  matrix elements will be stored in  MP_EJZ.
C
C     In the "t" basis, both Lz and Sz are imaginary, and we have
C
C     <t1+|Jz|t2->=<t1-|Jz|t2+>*;     <t1+|Jz|t2+>=<t1-|Jz|t2->=0
C
C=======================================================================
C
      DO J=1,LDBASE
         DO I=1,LDBASE
            PM_EJZ(I,J)=(0.0,0.0)
            MP_EJZ(I,J)=(0.0,0.0)
         END DO
      END DO
C
C=======================================================================
C
      CALL WS_INT_LZ(NXMAXX,NYMAXX,NZMAXX,ELM_LL,OMEGAC,LDBASE)
C
C=======================================================================
C
      CALL WS_ADDIMA(+1,ELM_LL,PM_EJZ,LDBASE)
      CALL WS_ADDIMA(-1,ELM_LL,MP_EJZ,LDBASE)
C
C=======================================================================
C
      CALL WS_INT_SZ(NXMAXX,NYMAXX,NZMAXX,ELM_SS,OMEGAC,LDBASE)
C
C=======================================================================
C
      CALL WS_ADDIMA(+1,ELM_SS,PM_EJZ,LDBASE)
      CALL WS_ADDIMA(-1,ELM_SS,MP_EJZ,LDBASE)
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C=======================================================================
C
      SUBROUTINE WS_PRIALG(NOFOME,OMEGAY)
C=======================================================================
      USE params
C=======================================================================
C
      DIMENSION
     *          OMEGAY(0:NDOMEG)
C
      COMMON
     *       /SPTALL_ALSLOP/ XJ1NEG(1:NDOMEG,0:NDISOS),
     *                       XJ1POS(1:NDOMEG,0:NDISOS),
     *                       XJ2NEG(1:NDOMEG,0:NDISOS),
     *                       XJ2POS(1:NDOMEG,0:NDISOS)
     *
     *       /SPTALL_NTSLOP/ NTOTMI(1:NDOMEG,0:NDISOS),
     *                       NTOTPL(1:NDOMEG,0:NDISOS)
C
C=======================================================================
C
      WRITE(6,'(//,80(''*''),/,''*'',78X,''*'',/,
     *        ''*  Omega     N(-)     N(+)     J1(-)    J1(+)'',
     *        ''      J2(-)    J2(+)              *'',/,
     *        ''*'',78X,''*'')')
C
      DO IOMEGA=2,NOFOME
C
         XJ1TOT=XJ1NEG(IOMEGA,0)+XJ1NEG(IOMEGA,1)
     *         +XJ1POS(IOMEGA,0)+XJ1POS(IOMEGA,1)
         XJ2TOT=XJ2NEG(IOMEGA,0)+XJ2NEG(IOMEGA,1)
     *         +XJ2POS(IOMEGA,0)+XJ2POS(IOMEGA,1)
C
         WRITE(6,'(''* '',f5.2,2I6,1x,
     *                  2(2x,f8.2,2x,f8.2,2x,f8.2),2x,''*'')')
     *
     *                    OMEGAY(IOMEGA),
     *                    NTOTMI(IOMEGA,0)+NTOTMI(IOMEGA,1),
     *                    NTOTPL(IOMEGA,0)+NTOTPL(IOMEGA,1),
     *                    XJ1NEG(IOMEGA,0)+XJ1NEG(IOMEGA,1),
     *                    XJ1POS(IOMEGA,0)+XJ1POS(IOMEGA,1),
     *                    XJ1TOT,
     *                    XJ2NEG(IOMEGA,0)+XJ2NEG(IOMEGA,1),
     *                    XJ2POS(IOMEGA,0)+XJ2POS(IOMEGA,1),
     *                    XJ2TOT
C
      END DO
C
      WRITE(6,'(''*'',78X,''*'',/,80(''*''))')
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
