C FILE NAME = wsu15_plot_03.f   ! Keep this symbol here: $ident@string$
C
C=======================================================================
C=======================================================================
C=====                                ==================================
C=====     PRIMITIVE-PLOTTING SET     ==================================
C=====                                ==================================
C=======================================================================
C=======================================================================
C
      SUBROUTINE WS_PLOTTH(LAMMAX,PHIANG,IZ_FIX,IN_FIX)
C=======================================================================
      USE params
C=======================================================================
      CHARACTER
     *          LINEPR(0:NDRNGE)*1
      CHARACTER
     *          STRING*80
      DIMENSION
     *          VTHLOW(0:NTHMAX),ZTHLOW(0:NTHMAX),
     *          VTHUPP(0:NTHMAX),ZTHUPP(0:NTHMAX)
      DIMENSION
     *          ARGMNT(0:NDPRNT),FRANGE(0:NDRNGE)
      DIMENSION
     *          YSCALE(1:NDSCAL)
C
      COMMON
     *       /READWRITE_PAR/ NOUTPT,IWRITE,ISCREN
C
      DATA
     *        SCALEY / 1.33 /
      DATA
     *        SCALEZ / 1.20 /
C
C=======================================================================
C     The perpendicular  (with respect  to the running  axis of
C     the prinout)  variable direction  must be scaled in order
C     to take into account the properties of the character font;
C     the value of PERPSC is chosen in such a way that a circle
C     appears on the plot as a circle
C=======================================================================
C
      IF (IWRITE.LT.2) RETURN
C
C=======================================================================
C
      PINUMB=4.0*ATAN(1.0)
C
C=======================================================================
C
      CALL WS_DEFPRI(LAMMAX,IZ_FIX,IN_FIX)
C
C=======================================================================
C
      DO ISCALE=1,NDSCAL
         YSCALE(ISCALE)=-1.0+(ISCALE-1)*0.2
      END DO
C
      WRITE(STRING,'(''#   z[Ro] #     '',11F5.1,''        #'')')
     *                                     (YSCALE(I),I=1,NDSCAL)
C
C=======================================================================
C
      IF (IWRITE.GE.1)
     *    WRITE(NOUTPT,'(//,80(''#''),/,''#'',78X,''#'',/,
     *          ''#  Cross-Sections of the Nuclear Surface'',
     *          '' for an angle Phi='',F4.2,
     *          '' RDS ('',F3.0,'' dgs)   #'')')
     *             PHIANG,180.000*PHIANG/PINUMB
C
      IF (ABS(PHIANG).LT.0.001) THEN
C
          IF (IWRITE.GE.1)
     *    WRITE(NOUTPT,'(
     *          ''#                    (This is the cross-'',
     *          ''section in the {x-z}-plane)            #'',/,
     *          ''########################################'',
     *          ''########################################'',/,
     *          ''#'',78X,''#'')')
      END IF
C
      IF (ABS(PHIANG-PINUMB/2.0).LT.0.001.OR.
     *    ABS(PHIANG+PINUMB/2.0).LT.0.001) THEN
C
          IF (IWRITE.GE.1)
     *    WRITE(NOUTPT,'(
     *          ''#                    (This is the cross-'',
     *          ''section in the {y-z}-plane)            #'',/,
     *          ''########################################'',
     *          ''########################################'',/,
     *          ''#'',78X,''#'')')
      END IF
C
      IF (.NOT.(ABS(PHIANG).LT.0.001.OR.
     *         (ABS(PHIANG-PINUMB/2.0).LT.0.001.OR.
     *          ABS(PHIANG+PINUMB/2.0).LT.0.001))) THEN
C
          IF (IWRITE.GE.1)
     *    WRITE(NOUTPT,'(
     *          ''#                                       '',
     *          ''                                       #'',/,
     *          ''########################################'',
     *          ''########################################'',/,
     *          ''#'',78X,''#'')')
      END IF
C
      IF (IWRITE.GE.1)
     *    WRITE(NOUTPT,'(A80,/,
     *             ''#         #                              '',
     *             ''                                      #'')') STRING
C
C=======================================================================
C         Plotting the x-z plane section of the surface
C=======================================================================
C
      THSTEP=PINUMB/NTHMAX
C
      DO INDTHE=0,NTHMAX
C
         ANGTHE=INDTHE*THSTEP
C
C=======================================================================
C           Lower part of the curve
C=======================================================================
C
         PHILOW=PHIANG
C
         CALL WS_FORMFN(ANGTHE,PHILOW,LAMMAX,RESULT)
C
         ZTHLOW(INDTHE)=+RESULT*COS(ANGTHE)
         VTHLOW(INDTHE)=-RESULT*SIN(ANGTHE)
C
C=======================================================================
C           Upper part of the curve
C=======================================================================
C
         PHIUPP=PHIANG+PINUMB
C
         CALL WS_FORMFN(ANGTHE,PHIUPP,LAMMAX,RESULT)
C
         ZTHUPP(INDTHE)=+RESULT*COS(ANGTHE)
         VTHUPP(INDTHE)=+RESULT*SIN(ANGTHE)
C
      END DO
C
C=======================================================================
C        Constructing the cross-points for multivalued functions
C=======================================================================
C
      ZMAXIM=-1.000
      ZMINIM=+1.000
C
      DO I=0,NTHMAX
C
         IF (ZTHLOW(I).GT.ZMAXIM) ZMAXIM=ZTHLOW(I)
         IF (ZTHUPP(I).GT.ZMAXIM) ZMAXIM=ZTHUPP(I)
C
         IF (ZTHLOW(I).LT.ZMINIM) ZMINIM=ZTHLOW(I)
         IF (ZTHUPP(I).LT.ZMINIM) ZMINIM=ZTHUPP(I)
C
      END DO
C
      FMAXIM=-1.000
      FMINIM=+1.000
C
      DO I=0,NTHMAX
C
         IF (VTHLOW(I).GT.FMAXIM) FMAXIM=VTHLOW(I)
         IF (VTHUPP(I).GT.FMAXIM) FMAXIM=VTHUPP(I)
C
         IF (VTHLOW(I).LT.FMINIM) FMINIM=VTHLOW(I)
         IF (VTHUPP(I).LT.FMINIM) FMINIM=VTHUPP(I)
C
      END DO
C
C=======================================================================
C        Estimating the interval for the arguments
C=======================================================================
C
      ZMAXAC=SCALEZ*ZMAXIM
      ZMINAC=SCALEZ*ZMINIM
C
      Z_STEP=(ZMAXAC-ZMINAC)/NDPRNT
C
C=======================================================================
C        Estimating the interval for the functions
C=======================================================================
C
      RATIFZ=FMAXIM/ZMAXIM
C
      FMAXAC=FMAXIM*SCALEY/RATIFZ
      FMINAC=FMINIM*SCALEY/RATIFZ
C
      RANGEF=FMAXAC-FMINAC
      R_STEP=RANGEF/NDRNGE
C
      DO INDEXR=0,NDRNGE
         FRANGE(INDEXR)=FMINAC+INDEXR*R_STEP
      END DO
C
      DO INDEXZ=0,NDPRNT
         ARGMNT(INDEXZ)=ZMINAC+INDEXZ*Z_STEP
      END DO
C
      DO I=0,NDPRNT-1
C
         ZMINAC=ARGMNT( I )
         ZMAXAC=ARGMNT(I+1)
C
         DO K=0,NDRNGE
            LINEPR(K)=' '
         END DO
C
         DO INDTHE=0,NTHMAX
C
            ZTHACT=ZTHUPP(INDTHE)
C
            IF (ZTHACT.GE.ZMINAC.AND.ZTHACT.LE.ZMAXAC) THEN
C
                VALUEV=VTHUPP(INDTHE)
C
                DO J=0,NDRNGE-1
C
                   IF (VALUEV.GE.FRANGE(J).AND.VALUEV.LE.FRANGE(J+1))
     *
     *                 LINEPR(J)='#'
C
                END DO
C
            END IF
C
            ZTHACT=ZTHLOW(INDTHE)
C
            IF (ZTHACT.GE.ZMINAC.AND.ZTHACT.LE.ZMAXAC) THEN
C
                VALUEV=VTHLOW(INDTHE)
C
                DO J=0,NDRNGE-1
C
                   IF (VALUEV.GE.FRANGE(J).AND.VALUEV.LE.FRANGE(J+1))
     *
     *                 LINEPR(J)='#'
C
                END DO
C
            END IF
C
         END DO
C
         IF (IWRITE.GE.1)
     *   WRITE(NOUTPT,'(''#'',1X,F7.4,1X,''#'',68A1,''#'')')
     *                        ARGMNT(I),(LINEPR(J),J=0,NDRNGE)
C
      END DO
C
      IF (IWRITE.GE.1)
     *    WRITE(NOUTPT,'(A80)') STRING
C
      IF (IWRITE.GE.1)
     *    WRITE(NOUTPT,'(''#'',78X,''#'',/,80(''#''))')
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C=======================================================================
C
      SUBROUTINE WS_PLOTPH(LAMMAX,ANGTHE,IZ_FIX,IN_FIX)
C=======================================================================
      USE params
C=======================================================================
      CHARACTER
     *          LINEPR(0:NDRNGE)*1
      CHARACTER
     *          STRING*80
      DIMENSION
     *          VPHLOW(0:NPHMAX),XPHLOW(0:NPHMAX),
     *          VPHUPP(0:NPHMAX),XPHUPP(0:NPHMAX)
      DIMENSION
     *          ARGMNT(0:NDPRNT),FRANGE(0:NDRNGE)
      DIMENSION
     *          YSCALE(1:NDSCAL)
C_______________________________________________________________________
C
      COMMON
     *       /READWRITE_PAR/ NOUTPT,IWRITE,ISCREN
C
      DATA
     *        SCALEY / 1.33 /
      DATA
     *        SCALEX / 1.28 /
C
C=======================================================================
C         The perpendicular  (with respect  to the running  axis of
C         the prinout)  variable direction  must be scaled in order
C         to take into account the properties of the character font;
C         the value of PERPSC is chosen in such a way that a circle
C         appears on the plot as a circle
C=======================================================================
C
      IF (IWRITE.LT.2) RETURN
C
C=======================================================================
C
      PINUMB=4.0*ATAN(1.0)
C
C=======================================================================
C
      CALL WS_DEFPRI(LAMMAX,IZ_FIX,IN_FIX)
C
C=======================================================================
C
      DO ISCALE=1,NDSCAL
         YSCALE(ISCALE)=-1.0+(ISCALE-1)*0.2
      END DO
C
      WRITE(STRING,'(''#   x[Ro] #     '',11F5.1,''        #'')')
     *                                     (YSCALE(I),I=1,NDSCAL)
C
C=======================================================================
C
      IF (IWRITE.GE.1)
     *    WRITE(NOUTPT,'(//,80(''#''),/,''#'',78X,''#'',/,
     *          ''#  Cross-Sections of the Nuclear Surface'',
     *          '' for  angle THETA='',F4.2,
     *          '' RDS ('',F3.0,'' dgs)   #'')')
     *             ANGTHE,180.000*ANGTHE/PINUMB
C
      IF (ABS(ANGTHE-PINUMB/2.0).LT.0.001) THEN
C
          IF (IWRITE.GE.1)
     *    WRITE(NOUTPT,'(
     *          ''#                    (This is the cross-'',
     *          ''section in the {x-y}-plane)            #'',/,
     *          ''########################################'',
     *          ''########################################'',/,
     *          ''#'',78X,''#'')')
C
          ELSE
C
          IF (IWRITE.GE.1)
     *    WRITE(NOUTPT,'(
     *          ''#                                       '',
     *          ''                                       #'',/,
     *          ''########################################'',
     *          ''########################################'',/,
     *          ''#'',78X,''#'')')
      END IF
C
      IF (IWRITE.GE.1)
     *    WRITE(NOUTPT,'(A80,/,
     *             ''#         #                              '',
     *             ''                                      #'')') STRING
C
C=======================================================================
C         Plotting the x-y plane section of the surface (if THETA=PI/2)
C=======================================================================
C
      PHSTEP=PINUMB/NPHMAX
C
      DO INDPHI=0,NPHMAX
C
         PHIANG=INDPHI*PHSTEP
C
C=======================================================================
C           Lower part of the curve
C=======================================================================
C
         PHILOW=PINUMB+PINUMB-PHIANG
C
         CALL WS_FORMFN(ANGTHE,PHILOW,LAMMAX,RESULT)
C
         XPHLOW(INDPHI)=+RESULT*COS(PHILOW)
         VPHLOW(INDPHI)=+RESULT*SIN(PHILOW)
C
C=======================================================================
C           Upper part of the curve
C=======================================================================
C
         PHIUPP=PHIANG
C
         CALL WS_FORMFN(ANGTHE,PHIUPP,LAMMAX,RESULT)
C
         XPHUPP(INDPHI)=+RESULT*COS(PHIUPP)
         VPHUPP(INDPHI)=+RESULT*SIN(PHIUPP)
C
      END DO
C
C=======================================================================
C        Constructing the cross-points for multivalued functions
C=======================================================================
C
      XMAXIM=-1.0e10
      XMINIM=+1.0e10
C
      DO I=0,NPHMAX
C
         IF (XPHLOW(I).GT.XMAXIM) XMAXIM=XPHLOW(I)
         IF (XPHUPP(I).GT.XMAXIM) XMAXIM=XPHUPP(I)
C
         IF (XPHLOW(I).LT.XMINIM) XMINIM=XPHLOW(I)
         IF (XPHUPP(I).LT.XMINIM) XMINIM=XPHUPP(I)
C
      END DO
C
      FMAXIM=-1.e10
      FMINIM=+1.e10
C
      DO I=0,NPHMAX
C
         IF (VPHLOW(I).GT.FMAXIM) FMAXIM=VPHLOW(I)
         IF (VPHUPP(I).GT.FMAXIM) FMAXIM=VPHUPP(I)
C
         IF (VPHLOW(I).LT.FMINIM) FMINIM=VPHLOW(I)
         IF (VPHUPP(I).LT.FMINIM) FMINIM=VPHUPP(I)
C
      END DO
C
C=======================================================================
C        Estimating the interval for the arguments
C=======================================================================
C
      XMAXAC=XMAXIM*SCALEX
      XMINAC=XMINIM*SCALEX
C
      X_STEP=(XMAXAC-XMINAC)/NDPRNT
C
C=======================================================================
C        Estimating the interval for the functions
C=======================================================================
C
      RATIFX=FMAXIM/XMAXIM
C
      FMAXAC=FMAXIM*SCALEY*RATIFX
      FMINAC=FMINIM*SCALEY*RATIFX
C
      RANGEF=FMAXAC-FMINAC
      R_STEP=RANGEF/NDRNGE
C
      DO INDEXR=0,NDRNGE
         FRANGE(INDEXR)=FMINAC+INDEXR*R_STEP
      END DO
C
      DO INDEXX=0,NDPRNT
         ARGMNT(INDEXX)=XMINAC+INDEXX*X_STEP
      END DO
C
      DO I=0,NDPRNT-1
C
         XMINAC=ARGMNT( I )
         XMAXAC=ARGMNT(I+1)
C
         DO K=0,NDRNGE
            LINEPR(K)=' '
         END DO
C
C        IF (XMINAC.LT.XMINIM) GO TO 2
C
         DO INDPHI=0,NPHMAX
C
            XPHACT=XPHUPP(INDPHI)
C
            IF (XPHACT.GE.XMINAC.AND.XPHACT.LE.XMAXAC) THEN
C
                VALUEV=VPHUPP(INDPHI)
C
                DO J=0,NDRNGE-1
C
                   IF (VALUEV.GE.FRANGE(J).AND.VALUEV.LE.FRANGE(J+1))
     *
     *                 LINEPR(J)='#'
C
                END DO
C
            END IF
C
            XPHACT=XPHLOW(INDPHI)
C
            IF (XPHACT.GE.XMINAC.AND.XPHACT.LE.XMAXAC) THEN
C
                VALUEV=VPHLOW(INDPHI)
C
                DO J=0,NDRNGE-1
C
                   IF (VALUEV.GE.FRANGE(J).AND.VALUEV.LE.FRANGE(J+1))
     *
     *                 LINEPR(J)='#'
C
                END DO
C
            END IF
C
         END DO
C
   2     CONTINUE
C
         IF (IWRITE.GE.1)
     *   WRITE(NOUTPT,'(''#'',1X,F7.4,1X,''#'',68A1,''#'')')
     *                        ARGMNT(I),(LINEPR(J),J=0,NDRNGE)
C
      END DO
C
      IF (IWRITE.GE.1)
     *    WRITE(NOUTPT,'(A80)') STRING
C
      IF (IWRITE.GE.1)
     *    WRITE(NOUTPT,'(''#'',78X,''#'',/,80(''#''))')
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C=======================================================================
C
      SUBROUTINE WS_CUTPOT(ISOSPI,X0,MODE_X,Y0,MODE_Y,Z0,MODE_Z,
     *                                     ARGMIN,ARGMAX,SELPAR)
C=======================================================================
      USE params
C=======================================================================
      CHARACTER
     *          SELPAR*20
      DIMENSION
     *          F_CENT(1:NDFNCT,1:ND_ARG),F_SORB(1:NDFNCT,1:ND_ARG)
      DIMENSION
     *          ARGMNT(1:ND_ARG)
C
      COMMON
     *       /READWRITE_PAR/ NOUTPT,IWRITE,ISCREN
C
      DATA
     *     NOSTEP / 50 /, NFUNCT / 3 /, R_ZERO / 0.0 /, A0 / 0.6 /
C
C=======================================================================
C
C     This subroutine  illustrates the cuts  of the potential along
C     the straight lines  which can be parallel  to either of the 3
C     axes of the coordinate system
C
C=======================================================================
C
C     Meaning of some parameters:
C
C     MODE_{X,Y,Z} => If one among the three parameters is =1, then
C                     the cut along the corresponding axis  will be
C                     produced. Also: the relevant pair among the 3
C                     variables {x0,y0,z0} will define the position
C                     of the straight line (see below);
C
C     X0,Y0, OR Z0 => will be taken to define the position  of  the
C                     straight line. For instance the line parallel
C                     to the z-axis  will pass through the point de-
C                     fined by X0 and Y0
C
C=======================================================================
C
      IF (IWRITE.LT.2) RETURN
C
C=======================================================================
C
      IF (MODE_X.EQ.0.AND.MODE_Y.EQ.0.AND.MODE_Z.EQ.0) RETURN
C
C=======================================================================
C
      IF ((MODE_X*MODE_Y).NE.0.OR.
     *    (MODE_Y*MODE_Z).NE.0.OR.
     *    (MODE_X*MODE_Z).NE.0) THEN
C
           MODE_Z=1
           MODE_Y=0
           MODE_X=0
C
      END IF
C
      STEP=(ARGMAX-ARGMIN)/NOSTEP
C
C=======================================================================
C
      IF (MODE_X.NE.0)
     *
     *    WRITE(NOUTPT,'(//,80(''#''),/,''#'',78X,''#'',/,
     *              ''#  Potential along x-axis: The related '',
     *              ''auxiliary straight lines cut yz-plane   #'',/,
     *              ''#   Vcent:   Section points are {y,z}='',
     *              ''('',F4.1,'','',F4.1,''), '',
     *              ''('',F4.1,'','',F4.1,'') &'',
     *              '' ('',F4.1,'','',F4.1,'')   #'',/,
     *              ''#'',78X,''#'',/,80(''#''))')
     *
     *                                        Y0,-A0,Y0,R_ZERO,Y0,A0
C
      IF (MODE_Y.NE.0)
     *
     *    WRITE(NOUTPT,'(//,80(''#''),/,''#'',78X,''#'',/,
     *              ''#  Potential along y-axis: The related '',
     *              ''auxiliary straight lines cut xz-plane   #'',/,
     *              ''#   Vcent:   Section points are {x,z}='',
     *              ''('',F4.1,'','',F4.1,''), '',
     *              ''('',F4.1,'','',F4.1,'') &'',
     *              '' ('',F4.1,'','',F4.1,'')   #'',/,
     *              ''#'',78X,''#'',/,80(''#''))')
     *
     *                                        X0,-A0,X0,R_ZERO,X0,A0
C
      IF (MODE_Z.NE.0)
     *
     *    WRITE(NOUTPT,'(//,80(''#''),/,''#'',78X,''#'',/,
     *              ''#  Potential along z-axis: the related '',
     *              ''auxiliary straight lines cut xy-plane   #'',/,
     *              ''#   Vcent:   Section points are {x,y}='',
     *              ''('',F4.1,'','',F4.1,''), '',
     *              ''('',F4.1,'','',F4.1,'') &'',
     *              '' ('',F4.1,'','',F4.1,'')   #'',/,
     *              ''#'',78X,''#'',/,80(''#''))')
     *
     *                                        X0,-A0,X0,R_ZERO,X0,A0
C
C=======================================================================
C
      NOEFFM=0
C
      IF (SELPAR.NE.'UNIVERSAL_DIRAC') THEN
          NOEFFM=1
      END IF
C
      DO IFUNCT=1,NFUNCT
C
         IF (MODE_X.NE.0) THEN
C
             Z00=-(2-IFUNCT)*A0
             Y00=Y0
C
             DO ISTEP=1,NOSTEP
C
                X=ARGMIN+(ISTEP-1)*STEP
                Y=Y00
                Z=Z00
C
                ARGMNT(ISTEP)=X
C
                CALL WS_WSDEFN(W_CENT,W_LINM,W_SORB,W_MASS,NOEFFM,
     *                                               X,Y,Z,ISOSPI)
C
                F_CENT(IFUNCT,ISTEP)=W_CENT
                F_SORB(IFUNCT,ISTEP)=W_SORB
C
             END DO
C
         END IF
C
C=======================================================================
C
         IF (MODE_Y.NE.0) THEN
C
             X00=X0
             Z00=-(2-IFUNCT)*A0
C
             DO ISTEP=1,NOSTEP
C
                X=X00
                Y=ARGMIN+(ISTEP-1)*STEP
                Z=Z00
C
                ARGMNT(ISTEP)=Y
C
                CALL WS_WSDEFN(W_CENT,W_LINM,W_SORB,W_MASS,NOEFFM,
     *                                               X,Y,Z,ISOSPI)
C
                F_CENT(IFUNCT,ISTEP)=W_CENT
                F_SORB(IFUNCT,ISTEP)=W_SORB
C
             END DO
C
         END IF
C
C=======================================================================
C
         IF (MODE_Z.NE.0) THEN
C
             X00=X0
             Y00=-(2-IFUNCT)*A0
C
             DO ISTEP=1,NOSTEP
C
                X=X00
                Y=Y00
                Z=ARGMIN+(ISTEP-1)*STEP
C
                ARGMNT(ISTEP)=Z
C
                CALL WS_WSDEFN(W_CENT,W_LINM,W_SORB,W_MASS,NOEFFM,
     *                                               X,Y,Z,ISOSPI)
C
                F_CENT(IFUNCT,ISTEP)=W_CENT
                F_SORB(IFUNCT,ISTEP)=W_SORB
C
             END DO
C
         END IF
C
      END DO
C
C=======================================================================
C
      FMINIM=-60.0
      FMAXIM=+00.0
C
      N_SECT=6
C
      NARGMN=NOSTEP
C
      CALL WS_PLOTFX(F_CENT,NFUNCT,ARGMNT,NARGMN,FMINIM,FMAXIM,
     *                                                  N_SECT)
C
C=======================================================================
C=======================================================================
C
      IF (MODE_X.NE.0)
     *
     *    WRITE(NOUTPT,'(//,80(''#''),/,''#'',78X,''#'',/,
     *              ''#  Potential along x-axis: The related '',
     *              ''auxiliary straight lines cut yz-plane   #'',/,
     *              ''#   Vsorb:   Section points are {y,z}='',
     *              ''('',F4.1,'','',F4.1,''), '',
     *              ''('',F4.1,'','',F4.1,'') &'',
     *              '' ('',F4.1,'','',F4.1,'')   #'',/,
     *              ''#'',78X,''#'',/,80(''#''))')
     *
     *                                        Y0,-A0,Y0,R_ZERO,Y0,A0
C
      IF (MODE_Y.NE.0)
     *
     *    WRITE(NOUTPT,'(//,80(''#''),/,''#'',78X,''#'',/,
     *              ''#  Potential along y-axis: The related '',
     *              ''auxiliary straight lines cut xz-plane   #'',/,
     *              ''#   Vsorb:   Section points are {x,z}='',
     *              ''('',F4.1,'','',F4.1,''), '',
     *              ''('',F4.1,'','',F4.1,'') &'',
     *              '' ('',F4.1,'','',F4.1,'')   #'',/,
     *              ''#'',78X,''#'',/,80(''#''))')
     *
     *                                        X0,-A0,X0,R_ZERO,X0,A0
C
      IF (MODE_Z.NE.0)
     *
     *    WRITE(NOUTPT,'(//,80(''#''),/,''#'',78X,''#'',/,
     *              ''#  Potential along z-axis: the related '',
     *              ''auxiliary straight lines cut xy-plane   #'',/,
     *              ''#   Vsorb:   Section points are {x,y}='',
     *              ''('',F4.1,'','',F4.1,''), '',
     *              ''('',F4.1,'','',F4.1,'') &'',
     *              '' ('',F4.1,'','',F4.1,'')   #'',/,
     *              ''#'',78X,''#'',/,80(''#''))')
     *
     *                                        X0,-A0,X0,R_ZERO,X0,A0
C
C=======================================================================
C
      FMINIM= 00.0
      FMAXIM=+20.0
C
      N_SECT=6
C
      NARGMN=NOSTEP
C
      CALL WS_PLOTFX(F_SORB,NFUNCT,ARGMNT,NARGMN,FMINIM,FMAXIM,
     *                                                  N_SECT)
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C=======================================================================
C
      SUBROUTINE WS_PLOTFX(FUNCTN,NFUNCT,ARGMNT,NARGMN,FMINIM,FMAXIM,
     *                                                        N_SECT)
C=======================================================================
      USE params
C=======================================================================
      CHARACTER
     *          NCHARPL(1:NDFNCT)*1,LINE(0:NDLINE)*1,BLANCK*1
      DIMENSION
     *          FUNCTN(1:NDFNCT,1:ND_ARG),ARGMNT(1:ND_ARG)
      DIMENSION
     *          Y(0:10),ZLINE(0:100)
C
      COMMON
     *       /READWRITE_PAR/ NOUTPT,IWRITE,ISCREN
C
      DATA
     *     BLANCK / ' ' /
C
C=======================================================================
C
      IF (IWRITE.LT.2) RETURN
C
C=======================================================================
C
      IF (NARGMN.GT.ND_ARG) NARGMN=ND_ARG
      IF (NFUNCT.GT.NDFNCT) NARGMN=NDFNCT
C
C=======================================================================
C
      NCHARPL( 1)='#'
      NCHARPL( 2)='@'
      NCHARPL( 3)='&'
      NCHARPL( 4)='$'
      NCHARPL( 5)='x'
      NCHARPL( 6)=':'
      NCHARPL( 7)='%'
      NCHARPL( 8)='I'
      NCHARPL( 9)='|'
      NCHARPL(10)='"'
C
C=======================================================================
C
      FUNMAX=-1.0E20
      FUNMIN=+1.0E20
C
      DO IFUNCT=1,NFUNCT
         DO IARGMT=1,NARGMN
C
          IF (FUNMAX.LT.FUNCTN(IFUNCT,IARGMT))
     *        FUNMAX=FUNCTN(IFUNCT,IARGMT)
C
          IF (FUNMIN.GT.FUNCTN(IFUNCT,IARGMT))
     *        FUNMIN=FUNCTN(IFUNCT,IARGMT)
C
         END DO
      END DO
C
      IF (FUNMAX.GT.FMAXIM) FMAXIM=FUNMAX
      IF (FUNMIN.LT.FMINIM) FMINIM=FUNMIN
C
      FMINIM=10*NINT(FMINIM/10.0)-10.0
C
      STEP_F=(FMAXIM-FMINIM)/N_SECT
C
      DO IFUNCT=1,NFUNCT
         DO IARGMT=1,NARGMN
            FUNCTN(IFUNCT,IARGMT)=FUNCTN(IFUNCT,IARGMT)+0.4*STEP_F
         END DO
      END DO
C
      DO I=0,6
         Y(I)=REAL(I)*STEP_F+FMINIM
      END DO
C
      STEP_F=STEP_F/10.0
C
      DO I=0,NDLINE
         ZLINE(I)=FMINIM+REAL(I)*STEP_F
      END DO
C
      WRITE(NOUTPT,'(''#'',''   Fct=> '',6(F5.1,5X),F5.1,''    #'')')
     *
     *                                                   (Y(I),I=0,6)
C
      WRITE(NOUTPT,'(''#'',''   Argm. '',''###'',6(1X,9(''#'')),
     *                                             '' ######'')')
C
C=======================================================================
C
      DO IARG=1,NARGMN
C
         DO ILINE=0,NDLINE
            LINE(ILINE)=' '
         END DO
C
         DO IFUNCT=1,NFUNCT
C
            DO ILINE=0,NDLINE-1
C
               IF (FUNCTN(IFUNCT,IARG).GT.ZLINE(ILINE).AND.
     *             FUNCTN(IFUNCT,IARG).LE.ZLINE(ILINE+1)) THEN
C
                   IF (LINE(ILINE).NE.BLANCK) THEN
                       LINE(ILINE)='X'
                   ELSE
                       LINE(ILINE)=NCHARPL(IFUNCT)
                   END IF
C
               END IF
C
            END DO
C
         END DO
C
         WRITE(NOUTPT,'(''#'',1X,F7.4,1X,''#'',68A1,''#'')')
     *                         ARGMNT(IARG),(LINE(I),I=0,67)
C
      END DO
C
C=======================================================================
C
      WRITE(NOUTPT,'(''#'',9X,''####'',6(1X,9(''#'')),'' #####'')')
C
      WRITE(NOUTPT,'(''#'',''   Fct=>  '',6(F5.1,5X),F5.1,''   #'')')
     *
     *                                                   (Y(I),I=0,6)
C
      WRITE(NOUTPT,'(''#'',78X,''#'',/,80(''#''))')
C
C=======================================================================
C
      RETURN
      END
