C FILE NAME = wsu19_extr_01.f   ! Keep this symbol here: $ident@string$
C
C=======================================================================
C=======================================================================
C=====                                ==================================
C=====  PAIRING GAPS AND MASSES       ==================================
C=====                                ==================================
C=======================================================================
C=======================================================================
C
      SUBROUTINE WS_LECMOL
C=======================================================================
      USE params
C=======================================================================
C
      CHARACTER
     *          FILREA*80
C
      COMMON
     *       /EXTRAS_MOL_ZN/ IZMOLL(1:NDMOLL),INMOLL(1:NDMOLL)
     *
     *       /EXTRAS_MOLDEF/ B2MOLL(1:NDMOLL),B3MOLL(1:NDMOLL),
     *                       B4MOLL(1:NDMOLL),B6MOLL(1:NDMOLL)
     *
     *       /EXTRAS_MOLENE/ XMASSM(1:NDMOLL),EMICMO(1:NDMOLL)
      COMMON
     *       /EXTRAS_SIZMOL/ LDMOLL
      COMMON
     *       /EXTRAS_CORMOL/ IGIVMO(1:NDPROT,1:NDNEUT)
C
C=======================================================================
C         This short subroutine simply reads the table of elements
C         stored in file "table.dat" and all the informations going
C         with it, in particular the deformation parameters.
C
C         Source : Moller & Nix, Atomic Data and Nuclear Data Tables,
C=======================================================================
C
      FILREA='Service/table.dat'
C
      NFILRD=28
      OPEN (NFILRD,FILE=FILREA,STATUS='OLD',FORM='FORMATTED')
C
      ISTATE=1
      ICURRE=8
C
   1  CONTINUE
C
C=======================================================================
C
      IF (ICURRE.NE.136) THEN
C
          READ(NFILRD,'(3I5,9F10.3,6F10.2)')
     *    IZMOLL(ISTATE),INMOLL(ISTATE),
     *
     *    IAMOLL,EPSIL2,EPSIL3,EPSIL4,EPSIL5,EPSIL6,
     *
     *    B2MOLL(ISTATE),B3MOLL(ISTATE),
     *    B4MOLL(ISTATE),B6MOLL(ISTATE),
     *
     *    EMICMO(ISTATE),XMASSM(ISTATE),
     *
     *    EXPMAS,SIGMEX,EMICFL,FLMICM
C
          ICURRE=IZMOLL(ISTATE)
C
	  IZ_MOL=IZMOLL(ISTATE)
	  IN_MOL=INMOLL(ISTATE)
C
	  IGIVMO(IZ_MOL,IN_MOL)=ISTATE
C
          ISTATE=ISTATE+1
C
          GO TO 1
C
      END IF
C
      LDMOLL=ISTATE-2
C
      CLOSE(NFILRD)
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C=======================================================================
C
      SUBROUTINE WS_LECWER()
C=======================================================================
      USE params
C=======================================================================
C
      CHARACTER
     *          FILREA*80,STRING*80
C
      COMMON
     *       /EXTRAS_WER_ZN/ IZWERN(1:NDWERN),INWERN(1:NDWERN)
     *
     *       /EXTRAS_WERDEF/ B2WERN(1:NDWERN),B4WERN(1:NDWERN),
     *                       B6WERN(1:NDWERN)
     *
     *       /EXTRAS_WERPAI/ DNWERN(1:NDWERN),DPWERN(1:NDWERN),
     *                       GNWERN(1:NDWERN),GPWERN(1:NDWERN),
     *                       XLNWER(1:NDWERN),XLPWER(1:NDWERN),
     *                       EPNWER(1:NDWERN),EPPWER(1:NDWERN)
     *
     *       /EXTRAS_WERENE/ ETOTLW(1:NDWERN),XMASSW(1:NDWERN),
     *                       SHELLW(1:NDWERN)
      COMMON
     *       /EXTRAS_SIZWER/ LDWERN
      COMMON
     *       /CEXTRAS_ORWER/ IGIVWE(1:NDPROT,1:NDNEUT)
C
C=======================================================================
C         This short subroutine simply reads the table of elements
C         stored in file "table.dat" and all the informations going
C         with it, in particular the deformation parameters.
C
C         Source : T. Werner calculations
C=======================================================================
C
      FILREA='Service/werner.dat'
C
      NFILRD=78
      OPEN (NFILRD,FILE=FILREA,STATUS='OLD',FORM='FORMATTED')
C
      READ(NFILRD,*) STRING
      READ(NFILRD,*) STRING
      READ(NFILRD,*) STRING
      READ(NFILRD,*) STRING
      READ(NFILRD,*) STRING
C
      ISTATE=1
      ICURRE=20
C
   1  CONTINUE
C
C=======================================================================
C
      IF (ICURRE.NE.101) THEN
C
          READ(NFILRD,*,END=2)
     *
     *         ITAMPO,
     *
     *         IZWERN(ISTATE),INWERN(ISTATE),
     *         DNWERN(ISTATE),DPWERN(ISTATE),
     *
     *         B2WERN(ISTATE),B4WERN(ISTATE),B6WERN(ISTATE),
     *
     *         GNWERN(ISTATE),GPWERN(ISTATE),
     *         EPNWER(ISTATE),EPPWER(ISTATE),
     *         XLNWER(ISTATE),XLPWER(ISTATE),
     *
     *         ETOTLW(ISTATE),XMASSW(ISTATE),SHELLW(ISTATE),
     *
     *         EPSILO,XL2N,DPLN,DPLP
C
C          write(6,*)
C     *         ISTATE,IZWERN(ISTATE),INWERN(ISTATE),DELTAN,DELTAP,
C     *         B2WERN(ISTATE),B4WERN(ISTATE),B6WERN(ISTATE),
C     *         GN,GP,EPAN,EPAP,XLAMN,XLAMP,
C     *         ENERGY,BINDIN,SHELLC,EPSILO,XL2N,DPLN,DPLP
C
          ICURRE=IZWERN(ISTATE)
C
	  IZ_WER=IZWERN(ISTATE)
	  IN_WER=INWERN(ISTATE)
C
	  IGIVWE(IZ_WER,IN_WER)=ISTATE
C
          ISTATE=ISTATE+1
C
          GO TO 1
C
      END IF
C
   2  CONTINUE
C
      LDWERN=ISTATE-2
C
      CLOSE(NFILRD)
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C=======================================================================
C
      SUBROUTINE WS_SETDEF(IZ_FIX,IN_FIX,LAMMAX)
C=======================================================================
      USE params
C=======================================================================
C
      COMPLEX
     *          ALSTRT,ALSTEP,ALMINI,ALMAXI
C
      COMMON
     *       /DEFMIN_STARTS/ ALSTRT(0:NDLAMB,-NDLAMB:+NDLAMB),
     *                       ALSTEP(0:NDLAMB,-NDLAMB:+NDLAMB),
     *                       ALMINI(0:NDLAMB,-NDLAMB:+NDLAMB),
     *                       ALMAXI(0:NDLAMB,-NDLAMB:+NDLAMB)
      COMMON
     *       /DEFMIN_VARIAB/ I_STEP(0:NDLAMB,-NDLAMB:+NDLAMB)
C
      COMMON
     *       /EXTRAS_WERDEF/ B2WERN(1:NDWERN),B4WERN(1:NDWERN),
     *                       B6WERN(1:NDWERN)
      COMMON
     *       /EXTRAS_CORWER/ IGIVWE(1:NDPROT,1:NDNEUT)
C
      COMMON
     *       /EXTRAS_MOLDEF/ B2MOLL(1:NDMOLL),B3MOLL(1:NDMOLL),
     *                       B4MOLL(1:NDMOLL),B6MOLL(1:NDMOLL)
      COMMON
     *       /EXTRAS_CORMOL/ IGIVMO(1:NDPROT,1:NDNEUT)
      COMMON
     *       /EXTRAS_CHOOSD/ IDELSM,IDELTA
      COMMON
     *       /MASSES_SELDEF/ ICHOOS,ISETDF
C
C=======================================================================
C
      I_WERN=IGIVWE(IZ_FIX,IN_FIX)
      I_MOLL=IGIVMO(IZ_FIX,IN_FIX)
C
      IF (I_WERN.EQ.0.AND.I_MOLL.EQ.0) THEN
          WRITE(6,'(''Nucleus Z = '',i3,'' N = '',i3)') IZ_FIX,IN_FIX
	  WRITE(6,'(''Not found !!'')')
          RETURN
      END IF
C
      IF (ICHOOS.EQ.1) THEN
c
          ALSTRT(2,0)=B2WERN(I_WERN)*CMPLX(1,0)
          ALSTRT(4,0)=B4WERN(I_WERN)*CMPLX(1,0)
          ALSTRT(6,0)=B6WERN(I_WERN)*CMPLX(1,0)
C
          ALSTEP(2,0)=0.0001*CMPLX(1,0)
          ALSTEP(4,0)=0.0001*CMPLX(1,0)
          ALSTEP(6,0)=0.0001*CMPLX(1,0)
C
          I_STEP(2,0)=1
          I_STEP(4,0)=1
          I_STEP(6,0)=1
C
          LAMMAX=6
C
      END IF
C
      IF (ICHOOS.EQ.2) THEN
c
          ALSTRT(2,0)=B2MOLL(I_MOLL)*CMPLX(1,0)
          ALSTRT(3,0)=B3MOLL(I_MOLL)*CMPLX(1,0)
          ALSTRT(4,0)=B4MOLL(I_MOLL)*CMPLX(1,0)
          ALSTRT(6,0)=B6MOLL(I_MOLL)*CMPLX(1,0)
C
          ALSTEP(2,0)=0.0001*CMPLX(1,0)
          ALSTEP(4,0)=0.0001*CMPLX(1,0)
          ALSTEP(6,0)=0.0001*CMPLX(1,0)
C
          I_STEP(2,0)=1
          I_STEP(4,0)=1
          I_STEP(6,0)=1
C
	  IF (ABS(B3MOLL(I_MOLL)).GT.1.E-8) THEN
              I_STEP(3,0)=1
              ALSTEP(3,0)=0.0001*CMPLX(1,0)
	  END IF
C
          LAMMAX=6
C
      END IF
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C=======================================================================
C
      SUBROUTINE WS_SETDEL(IZ_FIX,IN_FIX,ISOSPI,I_FAIL,LDBASE,FCHOM0)
C=======================================================================
      USE params
C=======================================================================
C
      COMMON
     *       /SPECTR_ESINGP/ ESINGP(1:NDBASE),PARITY(1:NDBASE)
      COMMON
     *       /EXTRAS_STRUTG/ GAMMAS,COEFFM(1:NDSMTH)
     *       /EXTRAS_INTSTR/ LIMCUT,N_PART
      COMMON
     *       /STRUTI_PARAMS/ GSTRUT,HOMFAC,EPSRTN
     *       /STRUTI_POLYNO/ NPOLYN
      COMMON
     *       /WAPSTR_EXPDEL/ DELT3N(1:NDPROT,1:NDNEUT),
     *                       DELT3P(1:NDPROT,1:NDNEUT)
      COMMON
     *       /EXTRAS_CURDEL/ DELNEU(1:NDPROT,1:NDNEUT),
     *                       DELPRO(1:NDPROT,1:NDNEUT)
      COMMON
     *       /EXTRAS_PAIRCO/ EPNBAR,EPPBAR
     *       /EXTRAS_LIPKCO/ RLNOGN,RLNOGP
     *       /EXTRAS_FERMIS/ EFERMN,EFERMP
     *       /EXTRAS_DELTAS/ DLININ,DLINIP
     *       /EXTRAS_PSTRNG/ GPAIRN,GPAIRP
      COMMON
     *       /EXTRAS_CHOOSD/ IDELSM,IDELTA
C
C=======================================================================
C
C      This subroutine defines the pairing strengths from the formula
C      by bolsterli et al. It is also used to define the "average"
C      pairing terms that are substracted to the pairing correlation
C
C=======================================================================
C
      IR0SCA=0
      ISPSCA=0
      INESCA=0
      IDEFOR=1
C
      GSTRUT=1.2
      NPOLYN=6
      HOMFAC=4.5
C
      IF (ISOSPI.EQ.0) THEN
          N_PART=IN_FIX
          EFERMN=0.5*(ESINGP(N_PART/2)+ESINGP(N_PART/2+1))
          EFERMI=EFERMN
      ELSE
          N_PART=IZ_FIX
          EFERMP=0.5*(ESINGP(N_PART/2)+ESINGP(N_PART/2+1))
          EFERMI=EFERMP
      END IF
C
C=======================================================================
C      We need to define the coefficients CEOFFM that are used in
C      the smooth density function to calculate the pairing stengths.
C      Such quantities are not yet defined when this subroutine is
C      called.
C=======================================================================
C
      A_MASS=REAL(IZ_FIX+IN_FIX)
      HBAR_0=41.0/A_MASS**(1.0/3.0)
C
      GAMMAS=GSTRUT*HBAR_0 ! Here GSTRUT is od the order of 1.2
C
      INUPOL=N_PART/2
c
      E_CUTS=ESINGP(INUPOL)+HOMFAC*HBAR_0   ! HOMFAC is ~ 3.5
C
      DO I=INUPOL,LDBASE
         LIMCUT=I
         IF (ESINGP(I).GT.E_CUTS) GO TO 1
      END DO
C
   1  CONTINUE
C
      NBCUTS=LIMCUT
C
      PINUMB=4.*ATAN(1.0)
      SQRTPI=SQRT(PINUMB)
C
      FACTOR=1.0
C
      DO KFACTO=2,NPOLYN,2
         FACTOR=FACTOR*KFACTO/2
         COEFFM(KFACTO)=(-1)**(KFACTO/2)/(2.0**KFACTO)/FACTOR
      END DO
C
C=======================================================================
C      Calculating the smooth pairing term to be substracted. Input
C      deltas come from a fit since we want an average term over the
C      nuclear chart.
C=======================================================================
C
C      Fit of deltas by Mazurek
      IF (IDELSM.EQ.1) THEN
          DELTAN=DELNEU(IZ_FIX,IN_FIX)
          DELTAP=DELPRO(IZ_FIX,IN_FIX)
      END IF
C
C      Deltas from 3-points mass formula
      IF (IDELSM.EQ.2) THEN
          DELTAN=DELT3N(IZ_FIX,IN_FIX)
          DELTAP=DELT3P(IZ_FIX,IN_FIX)
      END IF
C
C      Standard fit of deltas
      IF (IDELSM.EQ.3) THEN
          DELTAN=12.0/SQRT(A_MASS)
          DELTAP=12.0/SQRT(A_MASS)
      END IF
C
C      Below the choice by Moller and Nix in the case Lipkin-Nogami
      IF (IDELSM.EQ.4) THEN
          DELTAN=8.6/SQRT(A_MASS)
          DELTAP=9.9/SQRT(A_MASS)
      END IF
C
      IF (ISOSPI.EQ.0) THEN
          EPNBAR=WS_SMOPAI(N_PART,EFERMI,DELTAN)
          RLNOGN=WS_ELNBAR(N_PART,EFERMI,DELTAN)
      ELSE
	  EPPBAR=WS_SMOPAI(N_PART,EFERMI,DELTAP)
          RLNOGP=WS_ELNBAR(N_PART,EFERMI,DELTAP)
      END IF
C
C=======================================================================
C      Calculating the average pairing strength for this nucleus by
C      using as input delta from the 3 points formula: we want the
C      pairing strength for this particular nucleus
C=======================================================================
C
C      Fit of deltas by Mazurek
      IF (IDELTA.EQ.1) THEN
          DELTAN=DELNEU(IZ_FIX,IN_FIX)
          DELTAP=DELPRO(IZ_FIX,IN_FIX)
      END IF
C
C      Deltas from 3-points mass formula
      IF (IDELTA.EQ.2) THEN
          DELTAN=DELT3N(IZ_FIX,IN_FIX)
          DELTAP=DELT3P(IZ_FIX,IN_FIX)
      END IF
C
C      Standard fit of deltas
      IF (IDELTA.EQ.3) THEN
          DELTAN=12.0/SQRT(A_MASS)
          DELTAP=12.0/SQRT(A_MASS)
      END IF
C
C      Below the choice by Moller and Nix in the case Lipkin-Nogami
      IF (IDELTA.EQ.4) THEN
          DELTAN=8.6/SQRT(A_MASS)
          DELTAP=9.9/SQRT(A_MASS)
      END IF
C
      IF (ISOSPI.EQ.0) THEN
          GPAIRN=WS_GDELTA(N_PART,EFERMI,DELTAN)
      ELSE
	  GPAIRP=WS_GDELTA(N_PART,EFERMI,DELTAP)
      END IF
C
      DLININ=DELTAN
      DLINIP=DELTAP
C
c      write(6,'(''IDELSM = '',i1,'' IDELTA = '',i1,
c     *          '' D3N = '',f12.5,'' D3P = '',f12.5,
c     *          '' GN = '',f12.5,'' GP = '',f12.5)')
c     *             IDELSM,IDELTA,DELT3N(IZ_FIX,IN_FIX),
c     *                           DELT3P(IZ_FIX,IN_FIX),
c     *                           GPAIRN,GPAIRP
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C=======================================================================
C
      FUNCTION WS_GDELTA(N_PART,XLSTRT,DELTRY)
C
C      Function GDELTA calculates the pairing strength out of an
C      'average' distribution of levels.
C
C      XLSTRT - Strutinskys Fermi energy denoted LAMBDA_BAR C5/1050
C      NOLEVT - The number of pairs equal to the number of particls
C               (the same as in the BCS equations => see below)
C      DELTRY - The input delta
C
      RHOBAR=0.500*WS_DENS_E(XLSTRT)
      DELBAR=DELTRY
C
      NOLEVT=2*(N_PART/2)
C
      GAPAIR=1./RHOBAR/ALOG(SQRT(1.+(0.5*NOLEVT/RHOBAR/DELBAR)**2)
     *                              +0.5*NOLEVT/RHOBAR/DELBAR)
C
      WS_GDELTA=GAPAIR
C
      RETURN
      END
C
C=======================================================================
C=======================================================================
C
      FUNCTION WS_SMOPAI(N_PART,XLSTRT,DELTRY)
C
C      Function SMOPAI calculates the smoothed value of "CORREL"
C      "pairing energy correlation smoothed"
C
C      XLSTRT - Strutinskys Fermi energy denoted LAMBDA_BAR C5/1050
C      NOLEVT - The number of pairs equal to the number of particls
C               (the same as in the BCS equations => see below)
C      DELTRY - The input delta
C
      RHOBAR=0.500*WS_DENS_E(XLSTRT)
      DELBAR=DELTRY
C
      NOLEVT=2*(N_PART/2)
C
      GAPAIR=1./RHOBAR/ALOG(SQRT(1.+(0.5*NOLEVT/RHOBAR/DELBAR)**2)
     *                              +0.5*NOLEVT/RHOBAR/DELBAR)
C
      XPRINC=-0.25*NOLEVT**2/RHOBAR
     *
     *      *(SQRT(1.+(2.*RHOBAR*DELBAR/NOLEVT)**2)-1)
     *      + 0.50*RHOBAR*DELBAR*GAPAIR
     *      * ATAN(0.5*NOLEVT/RHOBAR/DELBAR)
C
      WS_SMOPAI=XPRINC
C
      RETURN
      END
C
C=======================================================================
C=======================================================================
C
      FUNCTION WS_ELNBAR(N_PART,XLSTRT,DELBAR)
C
C=======================================================================
C
C         FUNCTION EPCBAR calculates the smoothed Lipkin-Nogami energy
C
C         XLSTRT - Strutinskys Fermi energy denoted LAMBDA_BAR C5/1050
C         GAPAIR - "AVERAGED" pairing force strength  to be calculated
C         NOLEVT - The number of pairs equal to the number of particls
C                  (the same as in the BCS equations => see below)
C
C=======================================================================
C
      RHOBAR=0.500*WS_DENS_E(XLSTRT)
C
      NOLEVT=2*(N_PART/2)
C
      GAPAIR=1./RHOBAR/ALOG(SQRT(1.+(0.5*NOLEVT/RHOBAR/DELBAR)**2)
     *                              +0.5*NOLEVT/RHOBAR/DELBAR)
C
C=======================================================================
C
      Y2DELT=REAL(NOLEVT)/2.0/RHOBAR/DELBAR
      ATANGE=ATAN(Y2DELT)
      DELRHO=DELBAR*RHOBAR
C
      A_TERM=(DELBAR/2.0/GAPAIR)**2
      B_TERM=(DELRHO*ATANGE/2.0)**2
      C_TERM= DELRHO/16.0*(Y2DELT/(1.0+Y2DELT**2)+ATANGE)
C
C=======================================================================
C
      XL2BAR=GAPAIR*(A_TERM-C_TERM)/(B_TERM-C_TERM)/4.0
C
C=======================================================================
C
      WS_ELNBAR=Y2DELT*DELBAR*DELRHO*(Y2DELT-SQRT(Y2DELT**2+1.0))
     *      +0.5*(GAPAIR-4.0*XL2BAR)*DELRHO*ATANGE
C
C=======================================================================
C
      RETURN
      END
C
C========================================================================
C========================================================================
C
      FUNCTION WS_DENS_E(E)
C=======================================================================
      USE params
C=======================================================================
C
      DIMENSION
     *          HERPOL(0:NDSMTH),DHRPOL(0:NDSMTH)
C
      COMMON
     *       /SPECTR_ESINGP/ ESINGP(1:NDBASE),PARITY(1:NDBASE)
      COMMON
     *       /EXTRAS_STRUTG/ GAMMAS,COEFFM(1:NDSMTH)
     *       /EXTRAS_INTSTR/ LIMCUT,N_PART
      COMMON
     *       /STRUTI_POLYNO/ NPOLYN
C
      DATA
     *        EXPLIM / 30.0 /
C
C========================================================================
C         Function DENS_E calculates Strutinsky smoothing function
C========================================================================
C
      PINUMB=4.0*ATAN(1.0)
C
      SUMING=0.0
C
      DO N=1,LIMCUT
C
         UNSTRT=(E-ESINGP(N))/GAMMAS
         EXPUN2=0.
         SUMPOL=1.
C
         IF (ABS(UNSTRT).LE.EXPLIM) THEN
C
             EXPUN2=EXP(-UNSTRT*UNSTRT)
C
             CALL WS_DFHERM(UNSTRT,NPOLYN,HERPOL,DHRPOL,NDSMTH)
C
             DO I=2,NPOLYN,2
                SUMPOL=SUMPOL+COEFFM(I)*HERPOL(I)
             END DO
C
             SUMING=SUMING+EXPUN2*SUMPOL
C
         END IF
C
      END DO
C
C========================================================================
C      In case no cranking, there is an extra factor 2
C
      WS_DENS_E=2.0*SUMING/GAMMAS/SQRT(PINUMB)
C
C========================================================================
C
      RETURN
      END
C
C=======================================================================
C=======================================================================
C
      SUBROUTINE WS_SHOMAS(N_UNIT,IZ_FIX,IN_FIX,E_MASS)
C=======================================================================
      USE params
C=======================================================================
      CHARACTER
     *          EWERNE*12,EMOLLE*12
C
      COMMON
     *       /WAPSTR_WAPDAT/ BINDNG(1:NDPROT,1:NDNEUT),
     *                       ERRORB(1:NDPROT,1:NDNEUT)
     *
     *       /WAPSTR_WAPFLA/ IVALID(1:NDPROT,1:NDNEUT)
      COMMON
     *       /EXTRAS_WER_ZN/ IZWERN(1:NDWERN),INWERN(1:NDWERN)
     *
     *       /EXTRAS_WERDEF/ B2WERN(1:NDWERN),B4WERN(1:NDWERN),
     *                       B6WERN(1:NDWERN)
     *
     *       /EXTRAS_WERPAI/ DNWERN(1:NDWERN),DPWERN(1:NDWERN),
     *                       GNWERN(1:NDWERN),GPWERN(1:NDWERN),
     *                       XLNWER(1:NDWERN),XLPWER(1:NDWERN),
     *                       EPNWER(1:NDWERN),EPPWER(1:NDWERN)
     *
     *       /EXTRAS_WERENE/ ETOTLW(1:NDWERN),XMASSW(1:NDWERN),
     *                       SHELLW(1:NDWERN)
      COMMON
     *       /EXTRAS_MOL_ZN/ IZMOLL(1:NDMOLL),INMOLL(1:NDMOLL)
     *       /EXTRAS_MOLENE/ XMASSM(1:NDMOLL),EMICMO(1:NDMOLL)
C
      COMMON
     *       /EXTRAS_CORWER/ IGIVWE(1:NDPROT,1:NDNEUT)
     *       /EXTRAS_CORMOL/ IGIVMO(1:NDPROT,1:NDNEUT)
C
C          Outputs
C
      COMMON
     *       /MASSES_ALLMAS/ EBIMOL,EBIWER,EBIEXP,EBITHE
C
C=======================================================================
C                     !      Coulomb exchange energy correction
      BELECT=0.1433E-4! MeV, related to the binding energy  of  the
C
      XMNEXC=8.0714310
      XMHEXC=7.2890340
C
C      Mass excess of Z hydrogen atoms and N neutrons + energy of the
C      bound electrons. By definition, the mass excesses in Moller and
C      Nix DO contain these two terms, so that we must substract them
C      in order to compare with our calculations.
C
      EEXCES=IZ_FIX*XMHEXC
     *      +IN_FIX*XMNEXC
     *      -BELECT*IZ_FIX**(2.39)
C
C=======================================================================
C
      I_WERN=IGIVWE(IZ_FIX,IN_FIX)
      I_MOLL=IGIVMO(IZ_FIX,IN_FIX)
C
                       WRITE(EWERNE,'(F12.3)') XMASSW(I_WERN)
      IF (I_WERN.EQ.0) WRITE(EWERNE,'(''    0000.000'')')
C
      EMONIX=XMASSM(I_MOLL)-EEXCES
C
                       WRITE(EMOLLE,'(F12.3)') EMONIX
      IF (I_MOLL.EQ.0) WRITE(EMOLLE,'(''    0000.000'')')
C
      WRITE(6,'(80(''$''),/,80(''$''),//,
     *      '' Mtheo ='',F9.2,
     *      '' M(Moller) ='',A10,
     *      '' M(Werner) ='',A10,
     *      '' M(exp) ='',F9.2,'' +/-'',F6.2,//,
     *          80(''$''),/,80(''$''))')
     *
     *         E_MASS,EMOLLE(1:10),EWERNE(1:10),
     *                             BINDNG(IZ_FIX,IN_FIX),
     *                             ERRORB(IZ_FIX,IN_FIX)
C
      WRITE(N_UNIT,'(1X,2I4,F12.3,2A10,2F12.3)')
     *      IZ_FIX,IN_FIX,E_MASS,EMOLLE(1:10),EWERNE(1:10),
     *                           BINDNG(IZ_FIX,IN_FIX),
     *                           ERRORB(IZ_FIX,IN_FIX)
C
      EBIMOL=EMONIX
      EBIWER=XMASSW(I_WERN)
      EBIEXP=BINDNG(IZ_FIX,IN_FIX)
      EBITHE=E_MASS
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C=======================================================================
C
      SUBROUTINE WS_GIVMAS(NREAD1,NREAD2,NOFNUC,MAXI_Z,MAXI_N)
C=======================================================================
      USE params
C=======================================================================
      CHARACTER
     *          STRING*80,ADUMMY*1
      CHARACTER
     *          FILE_1*80,
     *          FILE_2*80
      CHARACTER
     *          VALIDT*8,ELEMNT*3,INFORM*4,BMINUS*2
      DIMENSION
     *          EXCMAS(1:NDVALS),EXCERR(1:NDVALS),
     *          BINDEN(1:NDVALS),BINERR(1:NDVALS),
     *          BETDEC(1:NDVALS),BETERR(1:NDVALS),
     *          ATOMAS(1:NDVALS),ATOERR(1:NDVALS)
      DIMENSION
     *          ELEMNT(1:NDVALS),
     *          INFORM(1:NDVALS),
     *          BMINUS(1:NDVALS),
     *          VALIDT(1:NDVALS)
C
      COMMON
     *       /WAPSTR_MASSNZ/ NUCL_N(1:NDVALS),NUCL_Z(1:NDVALS),
     *                                        NUCL_A(1:NDVALS)
      COMMON
     *       /WAPSTR_WAPDAT/ BINDNG(1:NDPROT,1:NDNEUT),
     *                       ERRORB(1:NDPROT,1:NDNEUT)
     *
     *       /WAPSTR_WAPFLA/ IVALID(1:NDPROT,1:NDNEUT)
C
C=======================================================================
C
C         This subroutine reads the Wapstra mass-data file (VERSION '95)
C
C=======================================================================
C
      FILE_1='./mass_exp.mas95_0'
      FILE_2='./mass_exp.mas95_1'
C
C=======================================================================
C
      DO I_PROT=1,NDPROT
         DO I_NEUT=1,NDNEUT
            BINDNG(I_PROT,I_NEUT)=999999.9
            ERRORB(I_PROT,I_NEUT)=999999.9
            IVALID(I_PROT,I_NEUT)=999999.9
         END DO
      END DO
C
C=======================================================================
C
C        Reading: MASS EXCESS, BINDING ENERGY, BETA DECAY AND ATOMIC
C                 MASS" WITH THE CORRESPONDING ERRORS
C
C=======================================================================
C
      OPEN(NREAD1,FILE=FILE_1,FORM='FORMATTED',STATUS='OLD')
C
      OPEN(NREAD2,FILE=FILE_2,FORM='FORMATTED',STATUS='OLD')
C
C=======================================================================
C
      MAXI_Z=0
      MAXI_N=0
C
   1  CONTINUE
C
C=======================================================================
C
      READ (NREAD1,'(A80)',END=7) STRING
C
      IF (STRING.EQ.'B E G I N') THEN
C
          READ (NREAD1,'(A80)',END=8) STRING
C
          ICOUNT=0
C
          GO TO 2
C
      END IF
C
C=======================================================================
C
      GO TO 1
C
C=======================================================================
C
   2  CONTINUE
C
      ICOUNT=ICOUNT+1
C
      READ (NREAD1,'(A80)',END=3) STRING
C
                                VALIDT(ICOUNT)='MEASURED'
      IF (STRING(36:36).EQ.'#') VALIDT(ICOUNT)='EXTRAPOL'
C
      GO TO 2
C
C=======================================================================
C
   3  CONTINUE
C
C=======================================================================
C
   4  CONTINUE
C
      READ (NREAD2,'(A80)',END=9) STRING
C
      IF (STRING.EQ.'B E G I N') THEN
C
          READ (NREAD2,'(A80)',END=10) STRING
C
          ICOUNT=0
C
          GO TO 5
C
      END IF
C
      GO TO 4
C
C=======================================================================
C
   5  CONTINUE
C
      ICOUNT=ICOUNT+1
C
      READ (NREAD2,'(A1,I3,I5,I5,I5,1X,A3,A4,1X,F11.3,F9.3,
     *               F11.3,F9.3,4X,A2,F11.3,F9.3,2X,I3,1X,
     *                                F10.3,F9.3)',END=6)
     *
     *               ADUMMY,NMINUZ,NUCL_N(ICOUNT),NUCL_Z(ICOUNT),
     *                                            NUCL_A(ICOUNT),
     *                                            ELEMNT(ICOUNT),
     *                                            INFORM(ICOUNT),
     *                                            EXCMAS(ICOUNT),
     *                                            EXCERR(ICOUNT),
     *                                            BINDEN(ICOUNT),
     *                                            BINERR(ICOUNT),
     *                                            BMINUS(ICOUNT),
     *                                            BETDEC(ICOUNT),
     *                                            BETERR(ICOUNT),
     *                                            IDUMMY,
     *                                            ATOMAS(ICOUNT),
     *                                            ATOERR(ICOUNT)
C
      IF (MAXI_Z.LT.NUCL_Z(ICOUNT)) THEN
          MAXI_Z = NUCL_Z(ICOUNT)
      END IF
C
      IF (MAXI_N.LT.NUCL_N(ICOUNT)) THEN
          MAXI_N = NUCL_N(ICOUNT)
      END IF
C
C=======================================================================
C        Binding energies and corresponding errors expressed in MeV
C=======================================================================
C
      IF (NUCL_Z(ICOUNT).NE.0.AND.NUCL_N(ICOUNT).NE.0) THEN
C
          BINDNG(NUCL_Z(ICOUNT),NUCL_N(ICOUNT))=-BINDEN(ICOUNT)/1000.0
          ERRORB(NUCL_Z(ICOUNT),NUCL_N(ICOUNT))=+BINERR(ICOUNT)/1000.0
C
          IF (VALIDT(ICOUNT).EQ.'MEASURED') THEN
              IVALID(NUCL_Z(ICOUNT),NUCL_N(ICOUNT))=1
          END IF
C
          IF (VALIDT(ICOUNT).EQ.'EXTRAPOL') THEN
              IVALID(NUCL_Z(ICOUNT),NUCL_N(ICOUNT))=0
          END IF
C
      END IF
C
      GO TO 5
C
C=======================================================================
C
   6  CONTINUE
C
      NOFNUC=ICOUNT-1
C
      RETURN
C
C=======================================================================
C
   7  CONTINUE
C
      WRITE(6,'(//,''YOUR MASS-DATA FILE SHOULD NOT TERMINATE HERE'',
     *             '' - CHECK FOR THE WORD  B E G I N (POSITION 7)'')')
C
      STOP 'WAPSTRA FILE INCORRECT 7'
C
C=======================================================================
C
   8  CONTINUE
C
      WRITE(6,'(//,''YOUR MASS-DATA FILE SHOULD NOT TERMINATE HERE'',
     *             '' - CHECK FOR THE WORD  B E G I N (POSITION 8)'')')
C
      STOP 'WAPSTRA FILE INCORRECT 8'
C
C=======================================================================
C
   9  CONTINUE
C
      WRITE(6,'(//,''YOUR MASS-DATA FILE SHOULD NOT TERMINATE HERE'',
     *             '' - CHECK FOR THE WORD  B E G I N (POSITION 9)'')')
C
      STOP 'WAPSTRA FILE INCORRECT 9'
C
C=======================================================================
C
  10  CONTINUE
C
      WRITE(6,'(//,''YOUR MASS-DATA FILE SHOULD NOT TERMINATE HERE'',
     *             '' - CHECK FOR THE WORD  B E G I N (POSITION 10)'')')
C
      STOP 'WAPSTRA FILE INCORRECT 10'
C
C=======================================================================
C
      END
C
C=======================================================================
C=======================================================================
C
      SUBROUTINE WS_GIVPRO(NUMB_N,IMINIM,IMAXIM)
C=======================================================================
      USE params
C=======================================================================
      CHARACTER
     *          CHECKV*1
C
      DIMENSION
     *          B_PROT(1:NDNEUT),SENE2P(1:NDNEUT),
     *          ERRE2P(1:NDNEUT),SENE1P(1:NDNEUT),
     *                           ERRE1P(1:NDNEUT)
C
      COMMON
     *       /WAPSTR_EXPDEL/ DELT3N(1:NDPROT,1:NDNEUT),
     *                       DELT3P(1:NDPROT,1:NDNEUT)
      COMMON
     *       /WAPSTR_WAPDAT/ BINDNG(1:NDPROT,1:NDNEUT),
     *                       ERRORB(1:NDPROT,1:NDNEUT)
     *
     *       /WAPSTR_WAPFLA/ IVALID(1:NDPROT,1:NDNEUT)
C
      COMMON
     *       /WAPSTR_UNIVER/ DELTA3(1:NDNEUT),ESINGP(1:NDNEUT),
     *                       DL3ERR(1:NDNEUT),ERSING(1:NDNEUT),
     *                       DEPLUS(1:NDNEUT),DEMINU(1:NDNEUT),
     *                       ERRPLU(1:NDNEUT),ERRMIN(1:NDNEUT),
     *                       B_ERRO(1:NDNEUT),DEMIDD(1:NDNEUT),
     *                                        ERRMID(1:NDNEUT)
      COMMON
     *       /WAPSTR_CHEKNG/ CHECKV(1:NDNEUT)
C
C=======================================================================
C
C         This subroutine calculates the estimated "PAIRING DELTA" from
C         the three-point mass formula, a related approximation to what
C         we call the "BCS-EQUIVALENT" DELTA and it estimates the value
C         of the difference between the two neighboring levels close to
C         the fermi level.
C
C=======================================================================
C
C=======================================================================
C         We calculate the DELTA for the neutrons for the fixed "NUMB_N"
C=======================================================================
C
          DO I=1,NDNEUT
             B_PROT(I)=999999.9
             SENE2P(I)=0.0
             SENE1P(I)=0.0
             ERRE2P(I)=0.0
             ERRE1P(I)=0.0
          END DO
C
          DO I=1,NDNEUT
             DELTA3(I)=0.0
             ESINGP(I)=0.0
             DL3ERR(I)=0.0
             ERSING(I)=0.0
             DEPLUS(I)=0.0
             DEMINU(I)=0.0
             ERRPLU(I)=0.0
             ERRMIN(I)=0.0
             B_ERRO(I)=0.0
             DEMIDD(I)=0.0
             ERRMID(I)=0.0
          END DO
C
C=======================================================================
C
          IF (NUMB_N.LT.1.OR.NUMB_N.GT.NDNEUT) STOP 'NUMB_N in GIVPRO'
C
          IMINIM=0
          IMAXIM=0
C
          DO I_PROT=1,NDPROT-2
C
             IF (BINDNG(I_PROT,NUMB_N).LT.999999.9) THEN
C
                 IF (IMINIM.EQ.0) THEN
                     IMINIM=I_PROT
                 END IF
C
                 B_PROT(I_PROT)=BINDNG(I_PROT,NUMB_N)
                 B_ERRO(I_PROT)=ERRORB(I_PROT,NUMB_N)
C
                 IF (IVALID(I_PROT,NUMB_N).EQ.1) CHECKV(I_PROT)=' '
                 IF (IVALID(I_PROT,NUMB_N).EQ.0) CHECKV(I_PROT)='?'
                 IF (IVALID(I_PROT,NUMB_N).GT.1) CHECKV(I_PROT)='!'
C
                 IMAXIM=I_PROT
C
             END IF
C
          END DO
C
C=======================================================================
C
          DO I_PROT=1,NDPROT-2
C
             IF (BINDNG(I_PROT,NUMB_N).LT.999999.9) THEN
C
                 SENE2P(I_PROT+2)=.5*(B_PROT(I_PROT+2)-B_PROT(I_PROT))
                 SENE1P(I_PROT+1)=   (B_PROT(I_PROT+1)-B_PROT(I_PROT))
C
                 ERRE2P(I_PROT+2)=.5*(B_ERRO(I_PROT+2)+B_ERRO(I_PROT))
                 ERRE1P(I_PROT+1)=   (B_ERRO(I_PROT+1)+B_ERRO(I_PROT))
C
             END IF
C
          END DO
C
C=======================================================================
C
          I_CASE=0
C
          IF ((IMAXIM-IMINIM).GE.3) THEN
C
              I_CASE=IMAXIM-IMINIM-2
C
              DO I_PROT=IMINIM+1,IMAXIM-1
C
                 DELTA3(I_PROT)=(-1)**(I_PROT)*.5*(B_PROT(I_PROT-1)
     *                                        -2.* B_PROT( I_PROT )
     *                                           + B_PROT(I_PROT+1))
C
                 DL3ERR(I_PROT)=.5*(B_ERRO(I_PROT-1)
     *                         +2.* B_ERRO( I_PROT )
     *                            + B_ERRO(I_PROT+1))
C
              END DO
C
              DO I_PROT=IMINIM+1,IMAXIM-1
	         IMODUL=MOD(I_PROT,2)
		                  DELT3P(I_PROT,NUMB_N)=DELTA3(I_PROT+1)
                 IF (IMODUL.EQ.1) DELT3P(I_PROT,NUMB_N)=DELTA3(I_PROT)
              END DO
C
C=======================================================================
C             Here calculating the level differences
C=======================================================================
C
              DO I_PROT=IMINIM+1,IMAXIM-1
C
                 IF (MOD(I_PROT,2).EQ.0) THEN
C
                     DEPLUS(I_PROT)=(DELTA3(I_PROT)-DELTA3(I_PROT+1))*2
                     DEMINU(I_PROT)=(DELTA3(I_PROT)-DELTA3(I_PROT-1))*2
C
                     ERRPLU(I_PROT)=(DL3ERR(I_PROT)+DL3ERR(I_PROT+1))*2
                     ERRMIN(I_PROT)=(DL3ERR(I_PROT)+DL3ERR(I_PROT-1))*2
C
                     DEMIDD(I_PROT)=DELTA3(I_PROT)+DELTA3(I_PROT)
     *                                            -DELTA3(I_PROT-1)
     *                                            -DELTA3(I_PROT+1)
                     ERRMID(I_PROT)=DL3ERR(I_PROT)+DL3ERR(I_PROT)
     *                                            +DL3ERR(I_PROT-1)
     *                                            +DL3ERR(I_PROT+1)
C
                     IF (I_PROT.GT.2) THEN
                         ESINGP(I_PROT)=DEMIDD(I_PROT)+ESINGP(I_PROT-2)
                         ERSING(I_PROT)=ERRMID(I_PROT)+ERSING(I_PROT-2)
	             END IF
C
                 END IF
C
              END DO
C
          ELSE
C
              WRITE(6,'(80(''|''),/,''|'',78X,''|'',/,
     *                  ''|  NO DATA POINTS FOUND FOR THE NEUTRON'',
     *                  '' NUMBER Z ='',I3,
     *                  '' WHEN SCANNING NEUTRONS   |'',/,
     *                  ''|'',78X,''|'',/,80(''|''))')     NUMB_N
C
          END IF
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C=======================================================================
C
      SUBROUTINE WS_GIVNEU(NUMB_Z,IMINIM,IMAXIM)
C=======================================================================
      USE params
C=======================================================================
C
      CHARACTER
     *          CHECKV*1
C
      DIMENSION
     *          B_NEUT(1:NDNEUT),SENE2N(1:NDNEUT),
     *          ERRE2N(1:NDNEUT),SENE1N(1:NDNEUT),
     *                           ERRE1N(1:NDNEUT)
C
      COMMON
     *       /WAPSTR_EXPDEL/ DELT3N(1:NDPROT,1:NDNEUT),
     *                       DELT3P(1:NDPROT,1:NDNEUT)
      COMMON
     *       /WAPSTR_WAPDAT/ BINDNG(1:NDPROT,1:NDNEUT),
     *                       ERRORB(1:NDPROT,1:NDNEUT)
     *
     *       /WAPSTR_WAPFLA/ IVALID(1:NDPROT,1:NDNEUT)
C
      COMMON
     *       /WAPSTR_UNIVER/ DELTA3(1:NDNEUT),ESINGP(1:NDNEUT),
     *                       DL3ERR(1:NDNEUT),ERSING(1:NDNEUT),
     *                       DEPLUS(1:NDNEUT),DEMINU(1:NDNEUT),
     *                       ERRPLU(1:NDNEUT),ERRMIN(1:NDNEUT),
     *                       B_ERRO(1:NDNEUT),DEMIDD(1:NDNEUT),
     *                                        ERRMID(1:NDNEUT)
      COMMON
     *       /WAPSTR_CHEKNG/ CHECKV(1:NDNEUT)
C
C=======================================================================
C         This subroutine calculates the estimated "pairing delta" from
C         the three-point mass formula, a related approximation to what
C         we call the "BCS-EQUIVALENT" delta and it estimates the value
C         of the difference between the two neighboring levels close to
C         the Fermi level.          Here: Calculations for the neutrons
C=======================================================================
C
C=======================================================================
C         We calculate the DELTA for the neutrons for the fixed "NUMB_Z"
C=======================================================================
C
          DO I=1,NDNEUT
             B_NEUT(I)=999999.9
             SENE2N(I)=0.0
             SENE1N(I)=0.0
             ERRE2N(I)=0.0
             ERRE1N(I)=0.0
          END DO
C
          DO I=1,NDNEUT
             DELTA3(I)=0.0
             ESINGP(I)=0.0
             DL3ERR(I)=0.0
             ERSING(I)=0.0
             DEPLUS(I)=0.0
             DEMINU(I)=0.0
             ERRPLU(I)=0.0
             ERRMIN(I)=0.0
             B_ERRO(I)=0.0
             DEMIDD(I)=0.0
             ERRMID(I)=0.0
          END DO
C
C=======================================================================
C
          IF (NUMB_Z.LT.1.OR.NUMB_Z.GT.NDPROT) STOP 'NUMB_Z in GIVNEU'
C
          IMINIM=0
          IMAXIM=0
C
          DO I_NEUT=1,NDNEUT-2
C
             IF (BINDNG(NUMB_Z,I_NEUT).LT.999999.9) THEN
C
                 IF (IMINIM.EQ.0) THEN
                     IMINIM=I_NEUT
                 END IF
C
                 B_NEUT(I_NEUT)=BINDNG(NUMB_Z,I_NEUT)
                 B_ERRO(I_NEUT)=ERRORB(NUMB_Z,I_NEUT)
C
                 IF (IVALID(NUMB_Z,I_NEUT).EQ.1) CHECKV(I_NEUT)=' '
                 IF (IVALID(NUMB_Z,I_NEUT).EQ.0) CHECKV(I_NEUT)='?'
                 IF (IVALID(NUMB_Z,I_NEUT).GT.1) CHECKV(I_NEUT)='!'
C
                 IMAXIM=I_NEUT
C
             END IF
C
          END DO
C
C=======================================================================
C
          DO I_NEUT=1,NDNEUT-2
C
             IF (BINDNG(NUMB_Z,I_NEUT).LT.999999.9) THEN
C
                 SENE2N(I_NEUT+2)=.5*(B_NEUT(I_NEUT+2)-B_NEUT(I_NEUT))
                 SENE1N(I_NEUT+1)=   (B_NEUT(I_NEUT+1)-B_NEUT(I_NEUT))
C
                 ERRE2N(I_NEUT+2)=.5*(B_ERRO(I_NEUT+2)+B_ERRO(I_NEUT))
                 ERRE1N(I_NEUT+1)=   (B_ERRO(I_NEUT+1)+B_ERRO(I_NEUT))
C
             END IF
C
          END DO
C
C=======================================================================
C
          I_CASE=0
C
          IF ((IMAXIM-IMINIM).GE.3) THEN
C
              I_CASE=IMAXIM-IMINIM-2
C
              DO I_NEUT=IMINIM+1,IMAXIM-1
C
                 DELTA3(I_NEUT)=(-1)**I_NEUT*0.5*(B_NEUT(I_NEUT-1)
     *                                      -2.0* B_NEUT(I_NEUT)
     *                                          + B_NEUT(I_NEUT+1))
C
                 DL3ERR(I_NEUT)=0.5*(B_ERRO(I_NEUT-1)
     *                         +2.0* B_ERRO(I_NEUT)
     *                             + B_ERRO(I_NEUT+1))
C
              END DO
C
              DO I_NEUT=IMINIM+1,IMAXIM-1
	         IMODUL=MOD(I_NEUT,2)
		                  DELT3N(NUMB_Z,I_NEUT)=DELTA3(I_NEUT+1)
                 IF (IMODUL.EQ.1) DELT3N(NUMB_Z,I_NEUT)=DELTA3(I_NEUT)
              END DO
C
C=======================================================================
C             Here calculating the level differences
C=======================================================================
C
              DO I_NEUT=IMINIM+1,IMAXIM-1
C
                 IF (MOD(I_NEUT,2).EQ.0) THEN
C
                     DEPLUS(I_NEUT)=(DELTA3(I_NEUT)-DELTA3(I_NEUT+1))*2
                     DEMINU(I_NEUT)=(DELTA3(I_NEUT)-DELTA3(I_NEUT-1))*2
C
                     ERRPLU(I_NEUT)=(DL3ERR(I_NEUT)+DL3ERR(I_NEUT+1))*2
                     ERRMIN(I_NEUT)=(DL3ERR(I_NEUT)+DL3ERR(I_NEUT-1))*2
C
                     DEMIDD(I_NEUT)=DELTA3(I_NEUT)+DELTA3(I_NEUT)
     *                                            -DELTA3(I_NEUT-1)
     *                                            -DELTA3(I_NEUT+1)
                     ERRMID(I_NEUT)=DL3ERR(I_NEUT)+DL3ERR(I_NEUT)
     *                                            +DL3ERR(I_NEUT-1)
     *                                            +DL3ERR(I_NEUT+1)
C
                     IF (I_NEUT.GT.2) THEN
                         ESINGP(I_NEUT)=DEMIDD(I_NEUT)+ESINGP(I_NEUT-2)
                         ERSING(I_NEUT)=ERRMID(I_NEUT)+ERSING(I_NEUT-2)
                     END IF
C
                 END IF
C
              END DO
C
          ELSE
C
              WRITE(6,'(80(''*''),/,''*'',78X,''*'',/,
     *                  ''*   NO DATA POINTS FOUND FOR THE PROTON'',
     *                  '' NUMBER Z ='',I3,
     *                  '' WHEN SCANNING NEUTRONS   *'',/,
     *                  ''*'',78X,''*'',/,80(''*''))')     NUMB_Z
C
          END IF
C
C=======================================================================
C
      RETURN
      END
C
