C FILE NAME = wsu22_mini_01.f   ! Keep this symbol here: $ident@string$
C
C=======================================================================
C=======================================================================
C=====                                ==================================
C=====  MINIMIZATION PACKAGE          ==================================
C=====                                ==================================
C=======================================================================
C=======================================================================
C
      SUBROUTINE WS_DEFDEF(IZ_FIX,IN_FIX,ARGPAR)
C=======================================================================
      USE params
C=======================================================================
C
      EXTERNAL
     *          WS_FUNCWS,WS_DFUNWS
C
      COMPLEX
     *          ALPHAC(0:NDLAMB,-NDLAMB:+NDLAMB)
      COMPLEX
     *          ALSTRT,ALSTEP,ALMINI,ALMAXI
C
      DIMENSION
     *          ARGPAR(1:NDSEAR)
      DIMENSION
     *          HESSIN(1:NDSIZE,1:NDSIZE),HESGRA(1:NDSIZE)
      DIMENSION
     *          DIRECT(1:NDSIZE),GRAOLD(1:NDSIZE)
      DIMENSION
     *          XMINIM(1:NDMINI),GRADIE(1:NDMINI)
      DIMENSION
     *          XP_NEW(1:NDSIZE)
      DIMENSION
     *          FUNTST(1:NDTEST),I_TYPE(1:NDTEST)
C
      COMMON
     *       /MULTIPOLE_LMU/ IFMULT,MAXMUL,NOFLEV,IINDIV,LAMIND,MIUIND
      COMMON
     *       /READWRITE_PAR/ NOUTPT,IWRIT2,ISCREN
C
C                  Deformations
C
      COMMON
     *       /MINIMI_SIZMIN/ LDSEAR
      COMMON
     *       /ALPHACMUL_DEF/ ALPHAC
      COMMON
     *       /READDF_LAMMAX/ LAMMAX,LMXBAS,LMXDEF,LMXMUL
      COMMON
     *       /DEFMIN_STARTS/ ALSTRT(0:NDLAMB,-NDLAMB:+NDLAMB),
     *                       ALSTEP(0:NDLAMB,-NDLAMB:+NDLAMB),
     *                       ALMINI(0:NDLAMB,-NDLAMB:+NDLAMB),
     *                       ALMAXI(0:NDLAMB,-NDLAMB:+NDLAMB)
      COMMON
     *       /DEFMIN_VARIAB/ I_STEP(0:NDLAMB,-NDLAMB:+NDLAMB)
C
C                  Minimization itself
C
      COMMON
     *       /MINIMI_RANRAN/ I_RAND,NSTART,LDRAND,I_SEED,IRANDO
     *       /MINIMI_RANDSR/ ARANDO(1:NRANDO)
      COMMON
     *       /MINIMI_MINITE/ IDEFCN,ITECHI,IWRIMI
      COMMON
     *       /MINIMI_MINIMI/ STEPMX,TOLFUN,TOLDLX,TOLGRD,
     *                       EPSILO,FRACTI,GRADLM,ITRMAX
C
      COMMON
     *       /MINIMI_TYPMIN/ I_MODE
     *       /MINIMI_ABORTG/ IABORT
     *       /MINIMI_PINPON/ FUNPER,I_TEST
     *       /MINIMI_OUTPUT/ NFIPRI
C
C=======================================================================
C
C      This subroutine performs the minimization of the total energy
C      at a given deformation and a given rotational frequency.
C
C=======================================================================
C
      CALL WS_CPUTIM('DEFDEF',1)
C
C=======================================================================
C
C      Initialization
C
      DO I=1,NDSEAR
         ARGPAR(I)=0.0
      END DO
C
C      Calculating the number of active deformations
C
      LDSEAR=0
      DO LAMBDA=0,NDMULT
         DO MIU=0,LAMBDA
	    IF (I_STEP(LAMBDA,MIU).EQ.1) LDSEAR=LDSEAR+1
	 END DO
      END DO
C
      IWRIMI=1
C
C      IRANDO: for random calculations only. It is the actual number of
C              minimisations one had performed =>> one minimisation <=>
C              one generation of the random input. To allow for storing
C              on disc  results for a series  composed of several  runs
C              the initial IRANDO number is input through NAMELI (there
C              it is called NSTART)
C
      IRANDO=NSTART
C
C      We start the new "run" with the newly chosen set of deformation
C      parameters, that have been expressed in terms of random numbers.
C      Consequently, IRUNMI and IDEFCN are reset to 0
C
   1  CONTINUE
C
      IDEFCN=0
C
      IRUNMI=0
C
C      Initializing the random number generator, and generating a
C      set f NRANDO random numbers, uniformly distributed between
C      0 and 1
C
      IF (I_RAND.EQ.1) CALL WS_RANDIN(I_SEED)
C
      IF (I_RAND.EQ.1) CALL WS_ZUFALL(NRANDO,ARANDO)
C
C      Defining a new random set of the deformation parameters...
C
      CALL WS_NEWRAN(NEWSED,ARGPAR)
C
C=======================================================================
C
      EPSGRA=1E-4
C
                       MAXRUN=1
      IF (I_MODE.EQ.1) MAXRUN=1
C
      GRADNM=1.0E+10
C
      IRUNMI=0
      FMINIM=0.0
C
C=======================================================================
C
C     Here starts the minimisation. Some explanations:
C
C     IRUNMI is increased by 1  (since one performs a new minimisation)
C
C     IDEFCN is reset to 0,  since the latter counts the number of the
C            function evaluations in ONE single minimisation
C
C     ARGPAR - on entry,  it contains the vector  of randomly selected
C            deformation points; on exit it will contain the vector of
C            the "best" deformations
C
C     FMINIM - on entry, nothing special  except that it should be ini-
C            tialized properly; on exit, the value of the total energy
C            corresponding to deformations ARGPAR
C
C=======================================================================
C
   2  CONTINUE
C
C=======================================================================
C
      IABORT=0
      I_TEST=0
      FUNPER=0.0
C
      IDEFCN=0
C
          IRUNMI=IRUNMI+1
C
      IF (IRUNMI.GT.1) STEPMX=STEPMX/5.0
C
      IF (IRUNMI.GT.MAXRUN) GO TO 3 ! Stop when too many iterations
C
      GRDOLD=GRADNM
C
C      This subroutine performs the actual minimisation,  with the
C      gradient method ...
C
      ETOTAL=FMINIM
C
      NOUTPT=6
      EPSMIN=1.e-10
C
      CALL WS_ENEMIN(ARGPAR,LDSEAR,TOLGRD,ITRMAX,FMINIM,NDMINI,
     *               NDSIZE,STEPMX,TOLFUN,EPSMIN,GRADNM,FRACTI,
     *         GRADLM,WS_FUNCWS,WS_DFUNWS,IABORT,NOUTPT,NDTEST,
     *               HESSIN,HESGRA,DIRECT,GRAOLD,GRADIE,XP_NEW,
     *                                           FUNTST,I_TYPE)
C
      ETOTAL=FMINIM
C
      IF (IABORT.EQ.1) GO TO 2
C
C      For one minimisation, one allows a maximum number (=ITECHI)
C      of iterations. If this number is reached and the minimum is
C      still not found, one restarts the minimisation algorithm by
C      inserting the actually obtained set of deformations  as the
C      initial set of parameters
C
      IF (IDEFCN.GT.ITECHI) THEN
C
          WRITE(NFIPRI,'(/,80(''!''),/,''!Main'',74X,''!''/,
     *              ''!   The allowed maximum number of function'',
     *              '' evaluations ITECHI='',I4,''  exceeded   !'',/,
     *              ''!'',78x,''!''/,80(''!''))')
     *                                                        ITECHI
          GO TO 2
C
      END IF
C
C      This subroutine prints information, among others, about the
C      gradient behaviour; it also controls  the maximum number of
C      the minimisation restarts (this number is preset here to 10)
C
      CALL WS_CNTRLR(LAMMAX,IZ_FIX,IN_FIX,GRADNM,GRADLM,GRDOLD,
     *               EPSGRA,IRUNMI,IDEFCN,IABORT,MAXRUN,ETOTAL)
C
      IF (IABORT.EQ.1) GO TO 2
C
C      We test whether the gradient fulfills the (vanishing) condi-
C      tions). If yes, the algorithm performed for this set of the
C      randomly selected deformations will be stoped, and we go to
C      the next such set.
C
C      If not, we perform a new minimisation, by starting from the
C      last set of parameters obtained,  unless the gradient seems
C      not  to change anymore.
C
      IF (ABS(GRADNM).GE.GRADLM) THEN
C
          IF (ABS(GRADNM-GRDOLD).GE.EPSGRA) THEN
C
              GO TO 2
C
          END IF
C
      END IF
C
C      Continuing the program : the optimal (or hoped so) deforma-
C      tion has been found for a given set of random parameters: one
C      record the minimum's deformation and energy, and make the step
C      after.
C
   3  CONTINUE
C
C      There is a run for many random points, one has just been
C      finished, one makes a new one and restarts.
C
      IF (I_RAND.EQ.1) THEN
C
          IRANDO=IRANDO+1
C
          I_SEED=NEWSED
C
          CALL WS_DEFPRI(LAMMAX,IZ_FIX,IN_FIX)
C
          IF (IRANDO.LE.LDRAND) GO TO 1
C
      ELSE
C
C          We have finished the search for the given starting
C          deformations, one can proceed.
C          ATTENTION: the order of the loop is CRUCIAL
C
          I_AUXI=0
C
          DO LAMBDA=1,LAMMAX
             DO MIU=0,LAMBDA
C
	        IF (I_STEP(LAMBDA,MIU).EQ.1) THEN
	            I_AUXI=I_AUXI+1
		    ALPHAC(LAMBDA,MIU)=ARGPAR(I_AUXI)
	        END IF
C
	     END DO
          END DO
C
c          IWRIOL=IWRIT2
c          IWRIT2=1
C
          CALL WS_DEFPRI(LAMMAX,IZ_FIX,IN_FIX)
C
c          IWRIT2=IWRIOL
C
c          IWRIOL=IWRIMI
c          IWRIMI=1
cC
c          KRANKI=0
c          OMEGAC=0.0
cC
c          ISOSPI=0
cC
c          CALL WS_MOMPRI(MAXMUL,ISOSPI,IFMULT,OMEGAC,KRANKI)
cC
c          ISOSPI=1
cC
c          CALL WS_MOMPRI(MAXMUL,ISOSPI,IFMULT,OMEGAC,KRANKI)
C
c          IWRIMI=IWRIOL
C
      END IF
C
C=======================================================================
C
      CALL WS_CPUTIM('DEFDEF',0)
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C=======================================================================
C=======================================================================
C=======================================================================
C=======================================================================
C
C      V A R I A B L E    M E T R I C    M E T H O D    P A C K A G E
C
C=======================================================================
C=======================================================================
C=======================================================================
C=======================================================================
C=======================================================================
C
      FUNCTION WS_FUNCWS(ARGMNT,NDIMEN,IABORT)
      DIMENSION
     *          ARGMNT(1:NDIMEN)
C
      COMMON
     *       /MINIMI_MINITE/ IDEFCN,ITECHI,IWRIMI
     *       /MINIMI_DERIVD/ IDERID
     *       /MINIMI_OUTPUT/ NFIPRI
     *       /MINIMI_ENERGY/ chi2Value
      COMMON
     *       /MINIMI_DISPLA/ IPRINT
C
C=======================================================================
C
C                 Used by variable-metric-routine
C
C        NDIMEN - maximum number of parameters
C
C=======================================================================
C
      IDERID=0
C
      CALL WS_chi2Routine(ARGMNT,chi2Value)
C
      WS_FUNCWS=chi2Value
C
      IF (IDEFCN.GE.ITECHI) THEN
C
          WRITE(NFIPRI,'(/,80(''!''),/,''!VarMet'',72X,''!''/,
     *             ''!   The allowed maximum number of function'',
     *             '' evaluations ITECHI='',I4,''  exceeded   !'',/,
     *             ''!'',78x,''!''/,80(''!''))')
     *                                                  ITECHI
          IABORT=1
          RETURN
C
      END IF
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C=======================================================================
C
      SUBROUTINE WS_DFUNWS(ARGPAR,NDIMEN,DERIVF,GRADNM)
C=======================================================================
      USE params
C=======================================================================
      DIMENSION
     *          ARGPAR(1:NDIMEN),DERIVF(1:NDIMEN)
C
      COMMON
     *       /MINIMI_CNTROL/ PARAMT(1:NDSEAR),DPARAM(1:NDSEAR)
      COMMON
     *       /MINIMI_MINITE/ IDEFCN,ITECHI,IWRIMI
     *       /MINIMI_SIZMIN/ LDSEAR
     *       /MINIMI_DERIVD/ IDERID
     *       /MINIMI_ENERGY/ chi2Value
      COMMON
     *       /MINIMI_DISPLA/ IPRINT
C
C=======================================================================
C
C        This subroutine defines the function to be minimized with
C        the help of the Variable Metric Method.  Some parameters:
C
C
C        NDSEAR - maximum number of varying parameters
C
C        LDSEAR - current number of varying parameters
C
C        PARAMT - vector containing all the parameters
C                 both the varied and the fixed ones
C
C        ARGPAR - vector containing only the starting values
C                 of all the varied parameters
C
C=======================================================================
C
C        Initialization of the parameters. By default, the parameters
C        are set equal to the starting values given by the user.
C
      DO IPARAM=1,NDSEAR
         PARAMT(IPARAM)=ARGPAR(IPARAM)
      END DO
C
C        Transfering the function value at the current point
C
      FUNCT0=chi2Value
C
C      Calculating the partial derivatives (DERIVF) of the function
C      to be minimized.  These derivatives are calculated by taking
C      the finite differences, between a current point and the next
C      one.  The 'next' points are defined with the help of a small
C      step;  only one step at the time can be non-zero.  After all
C      the derivatives have been obtained, we re-set all the parame-
C      ters to their initial (current) value.
C
      DO IPARAM=1,NDSEAR
         DERIVF(IPARAM)=0.0
      END DO
C
      IDERID=1
C
      DO IPARAM=1,LDSEAR
C
         PARAMT(IPARAM)=PARAMT(IPARAM)+DPARAM(IPARAM)
C
         IPRINT=0
C
         CALL WS_chi2Routine(PARAMT,chi2Value)
C
         FUNCT1=chi2Value
C
         PARAMT(IPARAM)=PARAMT(IPARAM)-DPARAM(IPARAM)
         DERIVF(IPARAM)=(FUNCT1-FUNCT0)/DPARAM(IPARAM)
C
      END DO
C
C      Displaying the partial derivatives related to each of the
C      Dirac parameters. The first LDSEAR values can be non-zero,
C      the others are necessarily 0.
C
      GRADNM=0.0
      DO I=1,LDSEAR
         GRADNM=GRADNM+DERIVF(I)**2
      END DO
C
      GRADNM=SQRT(GRADNM)
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C=======================================================================
C
      SUBROUTINE WS_CNTRLR(LAMMAX,IZ_FIX,IN_FIX,GRADNM,GRADLM,GRDOLD,
     *                     EPSGRA,IRUNMI,IDEFCN,IABORT,MAXRUN,ETOTAL)
C=======================================================================
      USE params
C=======================================================================
      DIMENSION
     *          ENEMIN(1:NDREST)
      COMMON
     *       /MINIMI_OUTPUT/ NFIPRI
C
C=======================================================================
C          This is a gradient-behavior control-subroutine
C=======================================================================
C
      IF (IRUNMI.GT.NDREST) STOP 'IRUNMI.GT.NDREST in CNTRLR'
C
      IABORT=0
C
C=======================================================================
C         Collecting the maxima of the 'criterion' functions
C=======================================================================
C
      ENEMIN(IRUNMI)=ETOTAL
C
C=======================================================================
C
                            GRAPRI=9999.0
      IF (GRADNM.LE.GRAPRI) GRAPRI=GRADNM
C
      WRITE(NFIPRI,'(/,80(''$''),/,80(''$''),/,
     *          ''$'',78X,''$'',/,               ''$  |G|='',F7.2,
     *          '';  Exit condition: |G|<'',F5.2,
     *          ''  |Gnew-Gold|='',E8.2,''  EPS='',E7.1,''  $'',/,
     *                                          ''$'',78X,''$'',/,
     *          ''$  After'',I3,'' restarts and IDEFCN='',I4,
     *          '' function evaluations                      $'',/,
     *          ''$'',78X,''$'',/,80(''$''),/,80(''$''))')
     *
     *      GRAPRI,GRADLM,ABS(GRADNM-GRDOLD),EPSGRA,IRUNMI,IDEFCN
C
C=======================================================================
C
C=======================================================================
C
      IF (IRUNMI.GE.MAXRUN) THEN
C
          IABORT=1
C
          WRITE(NFIPRI,'(/,80(''!''),/,''!'',78X,''!'',/,
     *          ''!     The program restarted '',I2,'' times in order'',
     *          '' to make the gradient vanish.     !'',/,
     *          ''!     Even if the result  is  not satisfying yet'',
     *          ''   it is time to stop now      !'',/,
     *          ''!     since there is a large  probability  '',
     *          ''the program  turns  around and      !'',/,
     *          ''!     around...'',64x,''!'',/,''!'',78X,''!'',/,
     *          80(''!''))') MAXRUN
C
      ELSE
C
          IF (GRADNM.GT.GRADLM) THEN
C
              IF (ABS(GRADNM-GRDOLD).GE.EPSGRA) THEN
C
                  WRITE(NFIPRI,'(/,80(''#''),/,''#'',78X,''#'',/,
     *             ''#   STARTING A NEW MINIMIZATION PROCEDURE'',
     *             '' BY USING THE FOLLOWING  PARAMETERS   #'',/,
     *          ''#'',78X,''#'',/,80(''#''))')
C
              ELSE
C
                  IABORT=1
C
                  WRITE(NFIPRI,'(/,80(''*''),/,80(''*''),/,
     *          ''*'',78X,''*'',/,
     *          ''*   The difference between the old value of '',
     *          ''the gradient and the new one is:   *'',/,
     *          ''*'',78X,''*'',/,
     *          ''*'',18X,''|Gnew-Gold|='',E7.1,'' < EPS='',E7.1,28X,/,
     *          ''*'',78X,''*'',/,
     *          ''*   The programs seems to turn around so one '',
     *          ''stops there.                      *'',/,
     *          ''*'',78X,''*'',/,80(''*''),/,80(''*''))')
     *
     *              ABS(GRADNM-GRDOLD),EPSGRA
C
	      END IF
C
	  ELSE
C
              IABORT=1
C
              WRITE(NFIPRI,'(/,80(''#''),/,''#'',78X,''#'',/,
     *             ''#             THE EXIT CONDITION ON THE'',
     *             '' GRADIENT IS FULFILLED                  #'',/,
     *             ''#'',78X,''#'',/,
     *             ''#                    END OF THE RUN FOR'',
     *             '' THIS RANDOM SET                        #'',/,
     *             ''#'',78X,''#'',/,80(''#''))')
C
          END IF
C
      END IF
C
C=======================================================================
C
      IF (IRUNMI.GE.4) THEN
C
          IF (ENEMIN(IRUNMI).GT.ENEMIN(IRUNMI-1)) THEN
              IF (ENEMIN(IRUNMI-1).GT.ENEMIN(IRUNMI-2)) THEN
                  IF (ENEMIN(IRUNMI-2).GT.ENEMIN(IRUNMI-3)) THEN
C
                  IABORT=1
C
                  WRITE(NFIPRI,'(//,80(''#''),/,''#'',78X,''#'',/,
     *                  ''#   The energy value increases within'',
     *                  '' three consecutive iterations. Thus:   #'',/,
     *                  ''#    ===>>>>  We set   IABORT=1   '',
     *                  ''and finish'',35X,''#'',/,
     *                  ''#'',78X,''#'',/,80(''#''),/)')
C
                  END IF
              END IF
          END IF
C
      END IF
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C=======================================================================
C
      SUBROUTINE WS_NEWRAN(NEWSED,ARGPAR)
C=======================================================================
      USE params
C=======================================================================
C
      COMPLEX
     *          ALSTRT,ALSTEP,ALMINI,ALMAXI
C
      DIMENSION
     *          ARGPAR(1:NDSEAR)
C
      COMMON
     *       /MINIMI_RANRAN/ I_RAND,NSTART,LDRAND,I_SEED,IRANDO
     *       /MINIMI_RANDSR/ ARANDO(1:NRANDO)
      COMMON
     *       /MINIMI_CNTROL/ PARAMT(1:NDSEAR),DPARAM(1:NDSEAR)
C
      COMMON
     *       /READDF_LAMMAX/ LAMMAX,LMXBAS,LMXDEF,LMXMUL
      COMMON
     *       /DEFMIN_STARTS/ ALSTRT(0:NDLAMB,-NDLAMB:+NDLAMB),
     *                       ALSTEP(0:NDLAMB,-NDLAMB:+NDLAMB),
     *                       ALMINI(0:NDLAMB,-NDLAMB:+NDLAMB),
     *                       ALMAXI(0:NDLAMB,-NDLAMB:+NDLAMB)
      COMMON
     *       /DEFMIN_VARIAB/ I_STEP(0:NDLAMB,-NDLAMB:+NDLAMB)
C
C=======================================================================
C        This subroutine defines a complete set of random parameters.
C        Therefore:
C          - if I_RAND non equal to 1, nothing is done;
C          - this subroutine should be called at the beginning of one
C            minimisation run process.
C=======================================================================
C
      DO I=1,NDSEAR
         PARAMT(I)=0.0
         DPARAM(I)=0.0
      END DO
C
C         First, determine the range of variation of each of the
C         parameters - then, select at RANDOM the starting point
C         variable. Each variable must be selected independently
C         of the other.                            =============
C
      I_AUXI=0
C
      DO LAMBDA=0,NDMULT
         DO MIU=0,LAMBDA
C
	    PARMIN=REAL(ALMINI(LAMBDA,MIU))
	    PARMAX=REAL(ALMAXI(LAMBDA,MIU))
C
            IF (I_STEP(LAMBDA,MIU).EQ.1) THEN
C
	        I_AUXI=I_AUXI+1
C
                IF (I_RAND.EQ.1) THEN
		    PARAMT(I_AUXI)=PARMIN+ARANDO(I_AUXI)*(PARMAX-PARMIN)
		ELSE
		    PARAMT(I_AUXI)=REAL(ALSTRT(LAMBDA,MIU))
		END IF
C
                DPARAM(I_AUXI)=REAL(ALSTEP(LAMBDA,MIU))
                ARGPAR(I_AUXI)=PARAMT(I_AUXI)
C
	    END IF
C
	 END DO
      END DO
C
C=======================================================================
C        Reinitializing the random number generator to a new value.
C=======================================================================
C
      PIOVE2=2.0*ATAN(1.0)
C
      NEWSED=NINT(10000.*ABS(COS(PIOVE2*ARANDO(1))))
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C=======================================================================
C
      SUBROUTINE WS_VERIFY(FUNTST,I_TYPE,ITERAT,I_TEST,FUNPER,IABORT)
C=======================================================================
      USE params
C=======================================================================
C
      DIMENSION
     *          FUNTST(1:NDTEST),I_TYPE(1:NDTEST)
      DIMENSION
     *          FUNFOR(1:NDTEST),FUNBAK(1:NDTEST)
C
      COMMON
     *       /MINIMI_SIZMIN/ LDSEAR
     *       /MINIMI_TOLENE/ ENECRI
     *       /MINIMI_OUTPUT/ NFIPRI
C
C=======================================================================
C
C       Verifying that the variation in energy is large enough: we take
C       into account the last 3 points calculated, either normal points
C       or backtracking points
C
C=======================================================================
C
      IF (ITERAT.GT.3) THEN
C
          FUNCT0=FUNTST(ITERAT)
	  FUNCT1=FUNTST(ITERAT-1)
	  FUNCT2=FUNTST(ITERAT-2)
	  FUNCT3=FUNTST(ITERAT-3)
C
          IABORT=0
C
          CALL WS_COMPFC(FUNCT0,FUNCT1,FUNCT2,FUNCT3,ENECRI,IABORT)
C
          IF (IABORT.EQ.1) RETURN
C
      END IF
C
C=======================================================================
C
C      We verify there's no ping-pong effect. If this happens, the
C      first test above will be passed, unfortunately.
C
C      A simple ping-pong effect can only occur while backtracking:
C      in that case, 3 consecutive points may be different because one
C      of them would be a normal step forward, wile the 2 others back-
C      tracking points (or vice-versa).
C
C      I_TYPE stores where the function has been calculated: normal
C      step forward or backtracking point. In each case, one verifies
C      separately that the last 3 iterations are not too close.
C
C      Another possibility, NO HANDLED HERE, is a 'pseudo-periodic'
C      ping-pong: the current point is equal to number N, and at the
C      next iteration, it will be equal to number N+1, etc. That kind
C      of game becomes bloody complex, and it's likely to play only
C      a minor role, so we forget it...
C
C=======================================================================
C
      N_TEST=10
      EPSPPG=1.0E-3
C
C      One requires that at least 10 iterations have been made
C
      IF (ITERAT.GT.N_TEST) THEN
C
C      In the latest iteration a possibility of ping-pong has been
C      detected: one verifies now that it is one indeed. See below
C      for how ping-pong is defined and detected.
C
          IF (I_TEST.EQ.1) THEN
C
              DIFFEX=FUNTST(ITERAT)-FUNPER
C
              IF (ABS(DIFFEX).LT.EPSPPG) THEN
C
	          FUNPER=0.0
	          I_TEST=0
C
                  WRITE(NFIPRI,'(/,80(''!''),/,''!!!'',74X,''!!!'',/,
     *           ''!!!  In VERIFY: Ping-pong effect DETECTED '',
     *           ''=> Exiting...'',22X,''!!!'',/,
     *           ''!!!'',74X,''!!!'',/,80(''!''))')
C
	          IABORT=1
	          RETURN
C
	      END IF
C
          END IF
C
          INCREM=0
C
C      One checks over the last 10 iterations that there's no ping-pong.
C      Example: suppose the current iteration is equal to (or very very
C      close to) iteration number 7 over the last 10 ones. That means
C      the period of the pin-pong is 7. Then the next iteration should
C      be very very close to the number 6 of the current 10 ones. We
C      thus store that value, and we're going to check that in the next
C      iteration (see above).
C
          DO I=1,N_TEST
C
             DIFFEX=FUNTST(ITERAT-I)-FUNTST(ITERAT)
C
             IF (ABS(DIFFEX).LT.EPSPPG) THEN
c
	         INCREM=INCREM+1
C
	         FUNPER=FUNTST(ITERAT-I+1)
	         I_TEST=1
C
		 GO TO 2
C
	     END IF
C
          END DO
c
  2       CONTINUE
C
C      If a potential ping-pong has been detected, one tells the user
C
          IF (INCREM.GT.0) THEN
C
              WRITE(NFIPRI,'(/,80(''!''),/,''!!!'',74X,''!!!'',/,
     *           ''!!!  In VERIFY: Ping-pong effect POSSIBLE '',
     *           ''- Next test at next interation     !!!'',/,
     *           ''!!!'',74X,''!!!'',/,80(''!''))')
C
          END IF
C
      END IF
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C=======================================================================
C
      SUBROUTINE WS_COMPFC(FUNCT0,FUNCT1,FUNCT2,FUNCT3,ENECRI,IABORT)
      COMMON
     *       /MINIMI_OUTPUT/ NFIPRI
C
      IF (ABS(FUNCT1-FUNCT0).LE.ENECRI) THEN
          IF (ABS(FUNCT2-FUNCT0).LE.ENECRI) THEN
              IF (ABS(FUNCT3-FUNCT0).LE.ENECRI) THEN
C
                  WRITE(NFIPRI,'(/,80(''!''),/,''!!!'',74X,''!!!'',/,
     *           ''!!!  In VERIFY: The fluctuations of the '',
     *           ''total energy are neglegible => exit  !!!'',/,
     *           ''!!!'',74X,''!!!'',/,80(''!''))')
C
                  IABORT=1
	          RETURN
C
              END IF
          END IF
      END IF
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C=======================================================================
C
      SUBROUTINE WS_ENEMIN(XMINIM,LDIMEN,TOLGRD,ITRMAX,FMINIM,NDMINI,
     *                     NDSIZE,STEPMX,TOLFUN,EPSMIN,GRADNM,FRACTI,
     *               GRADLM,WS_FONCTI,WS_DFONCT,IABORT,NOUTPT,NDTEST,
     *                     HESSIN,HESGRA,DIRECT,GRAOLD,GRADIE,XP_NEW,
     *                                                 FUNTST,I_TYPE)
      EXTERNAL
     *          WS_FONCTI,WS_DFONCT
C
      LOGICAL
     *          CHEKNG
C
      DIMENSION
     *          HESSIN(1:NDSIZE,1:NDSIZE),HESGRA(1:NDSIZE)
      DIMENSION
     *          DIRECT(1:NDSIZE),GRAOLD(1:NDSIZE)
      DIMENSION
     *          XMINIM(1:NDMINI),GRADIE(1:NDMINI)
      DIMENSION
     *          XP_NEW(1:NDSIZE)
C
C         These next arrays and commons are used to prevent (rather
C         empirically) a ping-pong effect in the search of the mini-
C         mum. Although it's not part of the standard method, it
C         may be conserved.
      DIMENSION
     *          FUNTST(1:NDTEST),I_TYPE(1:NDTEST)
      COMMON
     *       /MINIMI_CRITER/ ICRITE
     *       /MINIMI_PINPON/ FUNPER,I_TEST
     *       /MINIMI_OUTPUT/ NFIPRI
C
C         This is a common just used in the energy-minimisation
C         version: it is not part of the standard method
      COMMON
     *       /MINIMI_DISPLA/ IPRINT
C
C=======================================================================
C
C       This subroutine minimizes the function FUNC according to the
C       Broyden-Fletcher-Goldfarb-Shanno (BFGS) method.
C
C     Meaning of some parameters:
C
C       XMINIM - On entry the starting point of the procedure; it is
C                a vector of length N;
C
C                On exit: the location of the minimum
C
C       TOLGRD - Parameter that measures a distance from the minimum;
C                At the the minimum, the gradient vanishes, and this
C                property is used to stop the iterations if
C
C                            gradient_length < TOLGRD
C
C       FMINIM - the minimum value of the function
C
C       IABORT - a parameter that is used to force exiting the code in
C                some selected cases. This parameter is set up when
C                calcualting the function (or its derivative). Therefore
C                if is not, the procedure will go as in the textbooks.
C
C     Precision control parameters
C
C       ITRMAX - The maximum number of iterations allowed;
C
C       STPMAX - The maximum length of steps step allowed
C                when performing the line searches
C
C=======================================================================
C
      ICRITE=0
C
      IF (NDMINI.NE.NDSIZE) THEN
          WRITE(NFIPRI,'(/,''NDMINI='',I3,
     *                     '' must be equal NDSIZE='',I3)')
     *                       NDMINI,NDSIZE
          STOP 'Inconsistent matrix declaration in DFPMIN - '
      END IF
C
      IF (LDIMEN.GT.NDSIZE) THEN
          WRITE(NFIPRI,'(/,''LDIMEN='',I3,
     *                     ''  greater than NDSIZE='',I3)')
     *                       LDIMEN,NDSIZE
          STOP 'Inconsistent use of LDIMEN in DFPMIN'
      END IF
C
      TOLERX=4.0*EPSMIN
C
C=======================================================================
C      Calculating the initial value FUNCVA of the function at
C      point XMINIM.
C=======================================================================
C
      IPRINT=1
C
      FUNCVA=WS_FONCTI(XMINIM,NDMINI,IABORT)
C
      IF (IABORT.EQ.1) RETURN
C
C=======================================================================
C      Storing the value of the function (=total energy) for a future
C      use. Checking the pin-pong condition.
C=======================================================================
C
      ICRITE=ICRITE+1
      FUNTST(ICRITE)=FUNCVA
      I_TYPE(ICRITE)=1
C
      CALL WS_VERIFY(FUNTST,I_TYPE,ICRITE,I_TEST,FUNPER,IABORT)
C
      IF (IABORT.EQ.1) RETURN
C
C=======================================================================
C      The next instruction allows to write something in the output
C      if one exits before the normal end of the subroutine
C=======================================================================
C
      FMINIM=0.0
      FUNOLD=0.0
C
      FMINIM=FUNCVA
      FUNOLD=FUNCVA
C
C=======================================================================
C       Calculating the initial gradient GRADIE at point XMINIM
C=======================================================================
C
      IPRINT=0
C
      CALL WS_DFONCT(XMINIM,NDMINI,GRADIE,GRADNM)
C
C=======================================================================
C       If the number of iterations exceeded...
C=======================================================================
C
      IF (IABORT.EQ.1) THEN
C
          WRITE(NFIPRI,'(/,80(''!''),/,''!'',78X,''!'',/,
     *         ''!  The number of [out of range] values '',
     *         ''exceeded in WS_DFONCT, called in DFPMIN !'',/,
     *         ''!'',78X,''!'',/,80(''!''))')
C
          RETURN
C
      END IF
C
C=======================================================================
C         Initializing the inverse Hessian to the unit matrix
C=======================================================================
C
      SUMMAT=0.0
C
      DO J=1,LDIMEN
         DO I=1,LDIMEN
            HESSIN(I,J)=0.0
         END DO
      END DO
C
      SUMGRD=0.0
      DO J=1,LDIMEN
         HESSIN(J,J)=1.0
         DIRECT(J)=-GRADIE(J)
         SUMGRD=SUMGRD+ABS(DIRECT(J))
         SUMMAT=SUMMAT+XMINIM(J)**2
      END DO
C
C=======================================================================
C
      STPMAX=STEPMX*MAX(SQRT(SUMMAT),REAL(LDIMEN))
C
C=======================================================================
C
      DO ITERAT=1,ITRMAX
C
         CALL WS_ENESRC(LDIMEN,NDSIZE,XMINIM,FUNCVA,GRADIE,DIRECT,
     *                  XP_NEW,FMINIM,STPMAX,CHEKNG,TOLFUN,TOLERX,
     *            FRACTI,IABORT,NOUTPT,NDTEST,WS_FONCTI,WS_DFONCT,
     *                                              FUNTST,I_TYPE)
C
         IF (IABORT.EQ.1) RETURN
C
C=======================================================================
C          Updating the line direction and the current point
C=======================================================================
C
         FUNCVA=FMINIM
C
         DO I=1,LDIMEN
            DIRECT(I)=XP_NEW(I)-XMINIM(I)
            XMINIM(I)=XP_NEW(I)
         END DO
C
C=======================================================================
C              Test for convergence on Delta X
C=======================================================================
C
         TESTDX=0.0
         DO I=1,LDIMEN
            TEMP=ABS(DIRECT(I))/MAX(ABS(XMINIM(I)),1.0)
            IF (TEMP.GT.TESTDX) TESTDX=TEMP
         END DO
C
         IF (TESTDX.LT.TOLERX) THEN
C
             CALL WS_DFONCT(XMINIM,NDMINI,GRADIE,GRADNM)
C
             IF (IABORT.EQ.1) THEN
C
	         NABORT=1
C
                 WRITE(NFIPRI,'(/,80(''!''),/,''!'',78X,''!'',/,
     *             ''!  After WS_DFONCT1- the number of [out '',
     *             ''of range] values exceeded, from DFPMIN !'',/,
     *             ''!'',78X,''!'',/,80(''!''))')
             END IF
C
             WRITE(NFIPRI,'(/,80(''!''),/,
     *         ''!     Convergence criterion on Delta X is '',
     *         ''satisfied - dX = '',E10.4,''          !'',/,
     *         ''!                                         '',
     *         ''           tol = '',E10.4,''          !'',/,
     *         80(''!''))') TESTDX,TOLERX
C
             RETURN
C
         END IF
C
C=======================================================================
C           Saving the old value of the gradient in GRAOLD()
C=======================================================================
C
         DO I=1,LDIMEN
            GRAOLD(I)=GRADIE(I)
         END DO
C
C=======================================================================
C           Calculating the new value of the gradient GRADIE
C=======================================================================
C
         IPRINT=0
C
         CALL WS_DFONCT(XMINIM,NDMINI,GRADIE,GRADNM)
C
C    ... the number of iterations exceeded
C
         IF (IABORT.EQ.1) THEN
C
             WRITE(NFIPRI,'(/,80(''!''),/,''!'',78X,''!'',/,
     *             ''!  After WS_DFONCT2- the number of [out '',
     *             ''of range] values exceeded, from DFPMIN !'',/,
     *             ''!'',78X,''!'',/,80(''!''))')
C
             RETURN
C
         END IF
C
C=======================================================================
C
         DEN=MAX(FMINIM,1.)
C
         TESTDF=0.0
         DO I=1,LDIMEN
            TEMP=ABS(GRADIE(I))*MAX(ABS(XMINIM(I)),1.0)/DEN
            IF (TEMP.GT.TESTDF) TESTDF=TEMP
         END DO
C
         IF (TESTDF.LT.TOLGRD) THEN
C
             WRITE(NFIPRI,'(/,80(''!''),/,
     *         ''!     Convergence criterion on Delta F is '',
     *         ''satisfied - dF = '',E10.4,''          !'',/,
     *         ''!                                         '',
     *         ''           tol = '',E10.4,''          !'',/,
     *         80(''!''))') TESTDF,TOLGRD
C
             RETURN
C
         END IF
C
C=======================================================================
C
         DO I=1,LDIMEN
            GRAOLD(I)=GRADIE(I)-GRAOLD(I)
         END DO
C
         DO I=1,LDIMEN
            HESGRA(I)=0.
            DO J=1,LDIMEN
               HESGRA(I)=HESGRA(I)+HESSIN(I,J)*GRAOLD(J)
            END DO
         END DO
C
         FAC=0.0
         FAE=0.0
         SUMDG=0.0
         SUMXI=0.0
C
         DO I=1,LDIMEN
            FAC=FAC+GRAOLD(I)*DIRECT(I)
            FAE=FAE+GRAOLD(I)*HESGRA(I)
            SUMDG=SUMDG+GRAOLD(I)**2
            SUMXI=SUMXI+DIRECT(I)**2
         END DO
C
C=======================================================================
C
         IF ((FAC**2).GT.EPSMIN*SUMDG*SUMXI) THEN
C
             FAC=1.0/FAC
             FAD=1.0/FAE
C
             DO I=1,LDIMEN
                GRAOLD(I)=FAC*DIRECT(I)-FAD*HESGRA(I)
             END DO
C
C=======================================================================
C                     BFGS updating formula
C=======================================================================
C
             DO I=1,LDIMEN
                DO J=1,LDIMEN
                   HESSIN(I,J)=HESSIN(I,J)+FAC*DIRECT(I)*DIRECT(J)-
     *                                     FAD*HESGRA(I)*HESGRA(J)+
     *                                     FAE*GRAOLD(I)*GRAOLD(J)
                END DO
             END DO
C
         END IF
C
C=======================================================================
C          One calculates here the new direction to go
C=======================================================================
C
         DO I=1,LDIMEN
            DIRECT(I)=0.
            DO J=1,LDIMEN
               DIRECT(I)=DIRECT(I)-HESSIN(I,J)*GRADIE(J)
            END DO
         END DO
C
      END DO
C
C=======================================================================
C
      IF (ITERAT.GE.ITRMAX) THEN
C
          WRITE(NFIPRI,'(/,80(''!''),''!'',78X,''!'',/,
     *          ''!   The number of internal iterations in '',
     *          ''DFPMIN, ITERAT='',I2,'' reached ITRMAX='',I2,
     *          ''   !'',/,''!'',78X,''!'',/,80(''!''))') ITERAT,
     *                                                    ITRMAX
C
      END IF
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C=======================================================================
C
      SUBROUTINE WS_ENESRC(LDIMEN,NDIMEN,XP_OLD,FUNOLD,GRADIE,DIRNWT,
     *                     XP_NEW,FUNNEW,STPMAX,CHEKNG,TOLFUN,TOLDLX,
     *               FRACTI,IABORT,NOUTPT,NDTEST,WS_FONCTI,WS_DFONCT,
     *                                                 FUNTST,I_TYPE)
C
      LOGICAL
     *          CHEKNG
C
      EXTERNAL
     *          WS_FONCTI,WS_DFONCT
C
      DIMENSION
     *          GRADIE(1:NDIMEN),DIRNWT(1:NDIMEN),XP_NEW(1:NDIMEN),
     *                                            XP_OLD(1:NDIMEN)
C
C         These next arrays and commons are used to prevent (rather
C         empirically) a ping-pong effect in the search of the mini-
C         mum. Although it's not part of the standard method, it
C         may be conserved.
      DIMENSION
     *          FUNTST(1:NDTEST),I_TYPE(1:NDTEST)
      COMMON
     *       /MINIMI_CRITER/ ICRITE
     *       /MINIMI_PINPON/ FUNPER,I_TEST
C
C         This is a common just used in the energy-minimisation
C         version: it is not part of the standard method
      COMMON
     *       /MINIMI_DISPLA/ IPRINT
C
C=======================================================================
C
C        In this subroutine, one moves along a line towards the minimum
C        that is given by the Newton (gradient) direction; next an opti-
C        mum point is sought to define a new iteration point.
C
C        Meaning of some parameters:
C
C        XP_OLD - this is the N-dimensional starting point (a vector of
C                 length N)
C
C        FUNOLD - the value of the function  at point XP_OLD (a scalar)
C
C        GRADIE - a vector  containing the N partial derivatives of the
C                 function at point XP_XOLD - (the gradient of the mini-
C                 mised function)
C
C        DIRNWT - a storage containing the coordinates of a vector that
C                 gives the new direction in the next step
C
C        XP_NEW - a new current point, given by:
C
C                       X = Xold + lambda * P;
C
C                 the difficulty is to find the "good" lambda
C
C        FUNNEW - the new value of the function at point XP_NEW
C
C        STPMAX - this parameter limits the length of the step searches
C                 so that one does not try to evaluate the functions in
C                 regions where they are ill-defined in the present con-
C                 text
C
C        CHEKNG - logical variable that should have value  FALSE on the
C                 normal exit.  If the new point XP_NEW is too close to
C                 XP_OLD then CHEKNG=.TRUE.
C
C=======================================================================
C
C        TOLFUN - This parameter controlls the conditions of a decrease
C                 in function the values.  The highest TOLFUN, the more
C                 drastic is the criterion on a decrease.  If it is too
C                 large,  one runs the risk to fail to passing over the
C                 very first step.
C
C        TOLDLX - convergence criterion on Delta.X
C
C=======================================================================
C
      CHEKNG=.FALSE.
C
      ALAM2=0.0
      F2=0.0
      FOLD2=0.0
C
C=======================================================================
C       One scales the step if it is too large (at least greater than
C       STPMAX)
C=======================================================================
C
      SUMNWT=0.0
      DO I=1,LDIMEN
        SUMNWT=SUMNWT+DIRNWT(I)*DIRNWT(I)
      END DO
C
                              SUMNWT=SQRT(SUMNWT)
      IF (ABS(SUMNWT).EQ.0.0) SUMNWT=1.0E-9
C
      IF (SUMNWT.GT.STPMAX) THEN
          DO I=1,LDIMEN
             DIRNWT(I)=DIRNWT(I)*STPMAX/SUMNWT
          END DO
      END IF
C
      SLOPE=0.0
      DO I=1,LDIMEN
         SLOPE=SLOPE+GRADIE(I)*DIRNWT(I)
      END DO
C
      TEST=0.0
      DO I=1,LDIMEN
         TEMP=ABS(DIRNWT(I))/MAX(ABS(XP_OLD(I)),1.)
         IF (TEMP.GT.TEST) TEST=TEMP
      END DO
C
      ALAMIN=TOLDLX/TEST
      ALAMBD=1.0000
C
C        As a first step, one always tries to make a full Newton step,
C        so lambda = 1 (ALAMBD = 1)
C
      IPRINT=1
C
C=======================================================================
C
   1  CONTINUE
C
C=======================================================================
C        Calculating the new point X such that X = Xold+lambda*P
C        and the function value at this point: F = func(X)
C=======================================================================
C
      DO I=1,LDIMEN
         XP_NEW(I)=XP_OLD(I)+ALAMBD*DIRNWT(I)
      END DO
C
      FUNNEW=WS_FONCTI(XP_NEW,NDIMEN,IABORT)
C
      IF (IABORT.EQ.1) RETURN
C
C        Storing the value of the function (=total energy) for a
C        future use.
C
      ICRITE=ICRITE+1
      FUNTST(ICRITE)=FUNNEW
      I_TYPE(ICRITE)=0
C
      CALL WS_VERIFY(FUNTST,I_TYPE,ICRITE,I_TEST,FUNPER,IABORT)
C
      IF (IABORT.EQ.1) RETURN
C
C=======================================================================
C      First case: lambda < lambda_min. This is one condition to return.
C=======================================================================
C
      IF (ALAMBD.LT.ALAMIN) THEN
C
          DO I=1,LDIMEN
             XP_NEW(I)=XP_OLD(I)
          END DO
C
          CHEKNG=.TRUE.
C
          RETURN
C
C        The decrease of the function is sufficient, one returns.
C
      ELSE IF (FUNNEW.LE.(FUNOLD+TOLFUN*ALAMBD*SLOPE)) THEN
C
          RETURN
C
      ELSE
C
          IPRINT=2
C
C        If a decrease of the function is NOT suffiently fast, one will
C        try to find another point on the Newton line (=> backtracking).
C        The first step is to calculate:
C
C                                       g'(0)
C                  lambda = -  ----------------------
C                              2[g(1) - g(0) - g'(0)]
C
          IF (ALAMBD.EQ.1.0) THEN
C
              DIFAUX=FUNNEW-FUNOLD-SLOPE
C
              IF (ABS(DIFAUX).EQ.0.0) THEN
                  DIFAUX=1.0e-9
              END IF
C
              TMPLAM=-SLOPE/(2.0*DIFAUX)
C
          ELSE
C
C             If the new  LAMBDA  obtained just above is not sufficient
C             to make the function decrease as required, then one tries
C             another expression (see the notes):
C
              RHS1=FUNNEW-FUNOLD-ALAMBD*SLOPE
              RHS2=F2-FOLD2-ALAM2*SLOPE
C
              A=(RHS1/ALAMBD**2-RHS2/ALAM2**2)/(ALAMBD-ALAM2)
C
              B=(-ALAM2*RHS1/ALAMBD**2+ALAMBD*RHS2/ALAM2**2)/
     *          (ALAMBD-ALAM2)
C
              IF (A.EQ.0.0) THEN
                  TMPLAM=-SLOPE/(2.0*B)
              ELSE
C
                  DISCRI=B*B-3.0*A*SLOPE
C
                  IF (DISCRI.LT.0.0) THEN
                      DISCRI=-DISCRI
                  END IF
C
                  TMPLAM=(-B+SQRT(DISCRI))/(3.0*A)
C
              END IF
C
C              IF (TMPLAM.GT.0.5*ALAMBD) TMPLAM=0.5*ALAMBD
C
          END IF
C
          IF (TMPLAM.GT.0.5*ALAMBD) TMPLAM=0.5*ALAMBD
C
      END IF
C
      ALAM2=ALAMBD
      F2=FUNNEW
      FOLD2=FUNOLD
      ALAMMN=FRACTI*ALAMBD
      ALAMBD=MAX(TMPLAM,ALAMMN)
C
      GO TO 1
C
      END
C
C=======================================================================
C=======================================================================
C
      SUBROUTINE WS_chi2Routine(ARGMNT,chi2Value)
C=======================================================================
      USE params
C=======================================================================
C
      CHARACTER
     *          FILE_P*256,FILE_N*256,SELPAR*20
      CHARACTER
     *          N_ONLY*3,P_ONLY*3,VERSIO*5
      COMPLEX
     *          ALSTRT,ALSTEP,ALMINI,ALMAXI
      COMPLEX
     *          ALPHAC(0:NDLAMB,-NDLAMB:+NDLAMB)
C
      DIMENSION
     *          ARGMNT(1:NDSEAR)
      DIMENSION
     *          LAMVEC(1:NDSEAR),MIUVEC(1:NDSEAR)
      DIMENSION
     *          OMEGAX(0:NDOMEG),OMEGAY(0:NDOMEG),
     *          OMEGAZ(0:NDOMEG)
      DIMENSION
     *          QLMGEO(0:NDLAMB,0:NDLAMB)
C
C      Outputs of WSNUIV
C
      COMMON
     *       /MOMETS_MULMOM/ QMOMUL(0:NDMULT,-NDMULT:NDMULT,0:NDISOS)
C
C      Required inputs for WSEXEC
C
      COMMON
     *       /NUCLEONIC_YES/ P_ONLY,N_ONLY
      COMMON
     *       /MAINPR_NUCLEU/ IZ_FIX,IN_FIX
      COMMON
     *       /MAINPR_FILENS/ FILE_P,FILE_N
      COMMON
     *       /CRANKI_OMEGAS/ OMEGAT(0:NDOMEG),OMEGA3(0:NDOMEG)
     *       /CRANKI_NOFOME/ NOFOME
      COMMON
     *       /NUCLEONIC_PAR/ SELPAR
     *       /MAINPR_VERSIO/ VERSIO
C
C      Required inputs for WSHELL and HFBCRN
C
      COMMON
     *       /SPECTR_ESINGP/ ESINGP(1:NDBASE),PARITY(1:NDBASE)
     *       /SPECTR_PRONEU/ ESINPP(1:NDBASE),ESINPN(1:NDBASE)
     *       /SETBAS_DIMENS/ LDBASE
      COMMON
     *       /CRANKG_ROUTHI/ ROUPWS(1:2*NDBASE),
     *                       ROUNWS(1:2*NDBASE)
C
C      Required inputs for this very subroutine chi2Routine
C
      COMMON
     *       /PARAMS_RADVOL/ RADIUS,CVOLFC,RCVOLM
      COMMON
     *       /MINIMI_TYPMIN/ I_MODE
     *       /MINIMI_SIZMIN/ LDSEAR
     *       /MINIMI_MINITE/ IDEFCN,ITECHI,IWRIMI
     *       /MINIMI_DISPLA/ IPRINT
     *       /MINIMI_OUTPUT/ NFIPRI
      COMMON
     *       /DEFMIN_STARTS/ ALSTRT(0:NDLAMB,-NDLAMB:+NDLAMB),
     *                       ALSTEP(0:NDLAMB,-NDLAMB:+NDLAMB),
     *                       ALMINI(0:NDLAMB,-NDLAMB:+NDLAMB),
     *                       ALMAXI(0:NDLAMB,-NDLAMB:+NDLAMB)
      COMMON
     *       /DEFMIN_VARIAB/ I_STEP(0:NDLAMB,-NDLAMB:+NDLAMB)
      COMMON
     *       /READDF_LAMMAX/ LAMMAX,LMXBAS,LMXDEF,LMXMUL
      COMMON
     *       /ALPHACMUL_DEF/ ALPHAC
      COMMON
     *       /EXPECTED_QVAL/ QEXPEC(0:NDSEAR)
     *       /EXPECTED_LMIU/ LEXPEC(0:NDSEAR),MEXPEC(0:NDSEAR)
     *       /EXPECTED_SIZE/ LD_MUL
C
C=======================================================================
C
      IDEFCN=IDEFCN+1
C
C      Preparing the deformation for the calculation of the total
C      energy: the values of the different deformations changes
C      from one iteration to another. The vector ARGMNT stores the
C      def.s used as variables. The special cases of tetrahedral
C      and octahedral deformations, as well as beta/gamma, must be
C      treated separately.
C
      OMEGAT(1)=0.0
      OMEGAC=0.0
      STEPOM=0.0
      NOFOME=1
      IOMEGA=1
C
      ETOHFB=0.0
      RTOHFB=0.0
C
      I_AUXI=0
C
      DO LAMBDA=0,LMXDEF
         DO MIU=0,LAMBDA
C
            ALPHAC(LAMBDA,MIU)=ALSTRT(LAMBDA,MIU)
C
	    IF (I_STEP(LAMBDA,MIU).EQ.1) THEN
C
	        I_AUXI=I_AUXI+1
		ALPHAC(LAMBDA,MIU)=ARGMNT(I_AUXI)*CMPLX(1.0,0.0)
C
                LAMVEC(I_AUXI)=LAMBDA
                MIUVEC(I_AUXI)=MIU
C
	    END IF
C
	 END DO
      END DO
C
C=======================================================================
C      I_MODE = 1: finding the deformations such that the geometrical
C                  multipole moments are the same as the requested
C                  ones.
C=======================================================================
C
      IF (I_MODE.EQ.1) THEN
C
          CALL WS_QLMGEO(LMXDEF,IZ_FIX,IN_FIX,QLMGEO)
C
          DO LAMBDA=0,LMXDEF
             DO MIU=0,LAMBDA
                QMOMUL(LAMBDA,MIU,0)=QLMGEO(LAMBDA,MIU)
                QMOMUL(LAMBDA,MIU,1)=0.0
             END DO
          END DO
C
      END IF
C
C=======================================================================
C      I_MODE = 2: finding the deformations such that the expectation
C                  values of the multipole moments on the WS eigenstates
C                  are the same as the requested ones.
C=======================================================================
C
      IF (I_MODE.EQ.2) THEN
C
C          Proceeding with the calculation of the total energy at the
C          current deformation point
C
          GPAIRN=1.0
          GPAIRP=1.0
C
          NAMEFI=0
C
C          Diagonalisation of the neutron mean-field hamiltonian
C
                                                            ISOSPI=0
          CALL WS_WSEXEC(IZ_FIX,IN_FIX,FILE_P,FILE_N,NAMEFI,ISOSPI,
     *                   P_ONLY,N_ONLY,OMEGAX,OMEGAY,OMEGAZ,OMEGA3,
     *                                 NOFOME,VERSIO,I_CALL,SELPAR)
C
C          Setting the pairing strengths and average pairing terms
C          for the neutrons
C
c          CALL WS_SETDEL(IZ_FIX,IN_FIX,ISOSPI,I_FAIL,LDBASE,FCHOM0)
C
C          Diagonalisation of the proton mean-field hamiltonian
C
                                                            ISOSPI=1
          CALL WS_WSEXEC(IZ_FIX,IN_FIX,FILE_P,FILE_N,NAMEFI,ISOSPI,
     *                   P_ONLY,N_ONLY,OMEGAX,OMEGAY,OMEGAZ,OMEGA3,
     *                                 NOFOME,VERSIO,I_CALL,SELPAR)
C
C          Setting the pairing strengths and average pairing terms
C          for the protons
C
c          CALL WS_SETDEL(IZ_FIX,IN_FIX,ISOSPI,I_FAIL,LDBASE,FCHOM0)
C
C          Calculating the pairing correction
C
c          CALL WS_HFBCRN(IZ_FIX,IN_FIX,OMEGAT,STEPOM,NOFOME,ETOHFB,
c         *                                 RTOHFB,SPIHFB,IOMEGA)
C
C          chi2Value = RETURN VALUE FOR THIS ROUTINE
C
      END IF
C
C=======================================================================
C
      chi2Value = 0.0
C
      DO ID_MUL=1,LD_MUL
C
         L_ACTU=LEXPEC(ID_MUL)
         M_ACTU=MEXPEC(ID_MUL)
         Q_ACTU=QEXPEC(ID_MUL)
C
         WEIGHT=1.0
C
c         IF (L_ACTU.EQ.1.AND.M_ACTU.EQ.0) WEIGHT=50.0
c         IF (L_ACTU.EQ.2.AND.M_ACTU.EQ.0) WEIGHT=3.0
C
         Q_REAL=QMOMUL(L_ACTU,M_ACTU,0)+QMOMUL(L_ACTU,M_ACTU,1)
C
         chi2Value = chi2Value + WEIGHT*(Q_REAL - Q_ACTU)**2
C
      END DO
C
c      chi2Value = chi2Value + 1.E4 *( 1.0 - (1.0/CVOLFC)**2 )**2
c      chi2Value = chi2Value +  (EXP( 10*(1.0/CVOLFC - 1.0 ) ) - 1.0)
C
      IF (IPRINT.EQ.1) THEN
          WRITE(NFIPRI,'(''#'',I5,''s'',F12.3,F13.10,10F8.4)')
     *          IDEFCN,chi2Value,CVOLFC,
     *         (ARGMNT(I),I=1,LDSEAR)
      ELSE IF (IPRINT.EQ.2) THEN
          WRITE(NFIPRI,'(''#'',I5,''b'',F12.3,F13.10,10F8.4)')
     *          IDEFCN,chi2Value,CVOLFC,
     *         (ARGMNT(I),I=1,LDSEAR)
      ELSE IF (IPRINT.EQ.0) THEN
          WRITE(NFIPRI,'(''#'',I5,1X,F12.3,F13.10,10F8.4)')
     *          IDEFCN,chi2Value,CVOLFC,
     *         (ARGMNT(I),I=1,LDSEAR)
      END IF
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
