C FILE NAME = wsu23_proj_01.f   ! Keep this symbol here: $ident@string$
C
C=======================================================================
C=======================================================================
C=====                                ==================================
C=====  PARTICLE NUMBER PROJECTION    ==================================
C=====                                ==================================
C=======================================================================
C=======================================================================
C
      SUBROUTINE WS_PNPROJ(IZ_VAR,IN_VAR,ISOSPI,LD_BAS,GPAIRT,DELTAT,
     *                     XLAMBT,PPROJT,PAICOT,PAICLT,V2OCCU,IPRINT)
C=======================================================================
      USE params
C=======================================================================
      PARAMETER
     *         (TOLFUN=1.e-2,EPSMIN=1.e-10,TOLGRD=1.0e-6)
C
      EXTERNAL
     *          WS_PROMIN,WS_DPROMI
C
      DIMENSION
     *          V2OCCU(1:NDLEVS),V2AVRG(1:NDLEVS)
      DIMENSION
     *          N_BLOK(1:NDLEVS)
      DIMENSION
     *          GPAIRT(0:NDISOS),DELTAT(0:NDISOS),
     *          XLAMBT(0:NDISOS),PPROJT(0:NDISOS),
     *          PAICOT(0:NDISOS),PAICLT(0:NDISOS)
      DIMENSION
     *          HESSIN(1:NDPAIR,1:NDPAIR),HESGRA(1:NDPAIR)
      DIMENSION
     *          DIRECT(1:NDPAIR),GRAOLD(1:NDPAIR)
      DIMENSION
     *          XMINIM(1:NDPAIR),GRADIE(1:NDPAIR)
      DIMENSION
     *          XP_NEW(1:NDPAIR)
      DIMENSION
     *          ESINGP(1:NDBASE)
C
      COMMON
     *       /PNPROJ_PROJEN/ V2PROJ(1:NDPAIR),U2PROJ(1:NDPAIR),
     *                       SQRTV2(1:NDPAIR),SQRTU2(1:NDPAIR)
      COMMON
     *       /SPECTR_PRONEU/ ESINPP(1:NDBASE),ESINPN(1:NDBASE)
      COMMON
     *       /STRUTI_PARAMS/ GSTRUT,HOMFAC,EPSRTN
      COMMON
     *       /EXTRAS_PAIRCO/ EPNBAR,EPPBAR
     *       /EXTRAS_FERMIS/ EFERMN,EFERMP
     *       /EXTRAS_PSTRNG/ GPAIRN,GPAIRP
      COMMON
     *       /EXTRAS_INTSTR/ LIMCUT,M_PART
      COMMON
     *       /PAIRIN_STRENG/ GFACTN,GFACTP
      COMMON
     *       /PAIRIN_FORPRO/ IFMINV,IFLAMD
      COMMON
     *       /PAIRIN_AVRGDE/ WINDEN,ENSTEP,ISMOTH
C
      COMMON
     *       /PNPROJ_DIMENS/ LDBASE
      COMMON
     *       /PNPROJ_CNTRLS/ LDANGL,LDPAIR,N_PART
      COMMON
     *       /HFBHFB_DELTAS/ DELT_P,DELT_N
C
C=======================================================================
C
C         This subroutine calculates the Particle-Number-Projection
C         by the direct minimization of the pairing functional.
C
C=======================================================================
C
      LDBASE=LD_BAS
c
      NBCUTS=LIMCUT
C
C=======================================================================
C
      NLPAIR=LDBASE
C
      IFSUMG=0
      IFPROJ=1
C
      GPPROT=GPAIRP
      GPNEUT=GPAIRN
C
      IABORT=0
      STEPMX=5.5
      ITRMAX=100
      NOUTPT=6
C
      FRACTI=0.01
C
      IF (ISOSPI.EQ.0) THEN
C
	  N_PART=IN_VAR
	  BCSBAR=EPNBAR
C
          DO I=1,LDBASE
             ESINGP(I)=ESINPN(I)
          END DO
C
      END IF
C
      IF (ISOSPI.EQ.1) THEN
C
	  N_PART=IZ_VAR
	  BCSBAR=EPPBAR
C
          DO I=1,LDBASE
             ESINGP(I)=ESINPP(I)
          END DO
C
      END IF
C
C          If Npart is odd, then one level is blocked
C
      IF (MOD(N_PART,2).EQ.1) THEN
C
          LFERMI=N_PART/2
C
	  NOFBLK=1
	  N_BLOK(1)=LFERMI+1
C
      ELSE
C
	  NOFBLK=0
C
      END IF
C
C         Setting up the compatibility with the projection part
C
      CALL WS_CMPPRO(ESINGP,IFMINV,IFLAMD)
C
C         Preparing the projection part
C
      LDWIND=N_PART/2
C
      PRJLAM=0.0
      PRJDEL=1.0
C
      IFGAVR=0
      IFGFIT=0
      IFQUAS=0
C
      NDMPNP=NDPAIR
      NDSPNP=NDPAIR
C
      CALL WS_DEFPRJ(IFMINV,IFLAMD,PRJLAM,PRJDEL,XMINIM,NDMPNP,
     *               LDWIND,ESINGP,NDBASE,LDIMEN,ISOSPI,ENSTEP,
     *               GPPROT,GPNEUT,G_PAIR,FACTOG,GFACTP,GFACTN,
     *               DELBAR,IZ_VAR,IN_VAR,ISMOTH,WINDEN,GSTRUT,
     *                                                  NBCUTS)
C
C      Resetting the pairing factor to 1: the pairing strength has
C      already been scaled in DEFPRJ, and would risk to be again in
C      BCSPAI
      GFACTO=1.0
C
C      Calculating the traditional BCS pairing + projectio
C
      CALL WS_BCSPAI(IZ_VAR,IN_VAR,ISOSPI,NLPAIR,NOFBLK,N_BLOK,
     *               GFACTO,G_PAIR,XLAMBD,PDELTA,PCOREL,PCOREC,
     *               IFPROJ,IFSUMG,PROJ_E,ESINGP,BCSBAR,PAIREN,
     *                             PROJCR,SUMSNG,SUMGPA,V2OCCU)
C
      BCSLAM=XLAMBD
      BCSDEL=PDELTA
C
C      Calculating the starting V2 conditions for the P.N.P.
C
      STARTL=XLAMBD
      STARTD=PDELTA
C
      CALL WS_STARTV(STARTL,STARTD,XMINIM,NDMPNP,IFLAMD,IFMINV)
C
C      Minimisation within the framework of the PNP formalism
C
      CALL WS_DFPMIN(XMINIM,LDIMEN,TOLGRD,ITRMAX,FMINIM,NDMPNP,
     *               NDSPNP,STEPMX,TOLFUN,EPSMIN,GRADNM,GRADLM,
     *         WS_PROMIN,WS_DPROMI,IABORT,NOUTPT,HESSIN,HESGRA,
     *                      DIRECT,GRAOLD,GRADIE,XP_NEW,FRACTI)
C
      IF (IFLAMD.EQ.1) THEN
          PRJLAM=XMINIM(1)
          PRJDEL=ABS(XMINIM(2))
      END IF
C
C      Printing (optionally) the microscopic PNP contributions
C
      CALL WS_GIVE_H(LDPAIR,N_PART,PRJDEL,PRJLAM,PROJ1B,PROJ2B,
     *                                    PROJ_0,PROJ_H,IPRINT)
C
C      Calculating the 'average pairing' energy contributions
C      In the present implementation we first define a smooth
C      spectrum, based on the smoothed original level density
C
      CALL WS_DEFAVR
C
      CALL WS_BCSPAI(IZ_VAR,IN_VAR,ISOSPI,NLPAIR,NOFBLK,N_BLOK,
     *               GFACTO,G_PAIR,XLAMBD,PDELTA,AVRCOR,PCOREC,
     *               IFPROJ,IFSUMG,PROJ_E,ESINGP,BCSBAR,AVRPAI,
     *                             AVRPRJ,AVRSNG,AVRGPA,V2AVRG)
C
      AVRLAM=XLAMBD
      AVRDEL=PDELTA
C
C      Calculating the starting V2 conditions for the P.N.P.
C
      STARTL=XLAMBD
      STARTD=PDELTA
C
      CALL WS_STARTV(STARTL,STARTD,XMINIM,NDMPNP,IFLAMD,IFMINV)
C
C      Minimisation within the framework of the PNP formalism
C
      CALL WS_DFPMIN(XMINIM,LDIMEN,TOLGRD,ITRMAX,FMINIM,NDMPNP,
     *               NDSPNP,STEPMX,TOLFUN,EPSMIN,GRADNM,GRADLM,
     *         WS_PROMIN,WS_DPROMI,IABORT,NOUTPT,HESSIN,HESGRA,
     *                      DIRECT,GRAOLD,GRADIE,XP_NEW,FRACTI)
C
      IF (IFLAMD.EQ.1) THEN
          AVPLAM=XMINIM(1)
          AVPDEL=ABS(XMINIM(2))
      END IF
C
C          Printing (optionally) the microscopic PNP contributions
C
      CALL WS_GIVE_H(LDPAIR,N_PART,AVPDEL,AVPLAM,AVER1B,AVER2B,
     *                                    AVER_0,AVER_H,IPRINT)
C
      GACTIV=G_PAIR
C
C          Storing the pairing quantities in small isospin arrays
C
      GPAIRT(ISOSPI)=G_PAIR
      DELTAT(ISOSPI)=PRJDEL
      XLAMBT(ISOSPI)=PRJLAM
      PPROJT(ISOSPI)=PROJ_E-PROJ_0
      PAICOT(ISOSPI)=PROJ_H-PROJ_0-BCSBAR
      PAICLT(ISOSPI)=PCOREL
C
      DELT_P=DELTAT(1)
      DELT_N=DELTAT(0)
C
      IMINEN=1
C
      IF (IPRINT.EQ.1) THEN
C
         CALL WS_GIVOUT(IZ_VAR,IN_VAR,IFGAVR,IFGFIT,IFQUAS,ISOSPI,
     *                         FACTOG,GACTIV,G_PAIR,LDWIND,N_PART,
     *                  PAIREN,PROJCR,SUMSNG,SUMGPA,BCSLAM,BCSDEL,
     *                  AVRPAI,AVRPRJ,AVRSNG,AVRGPA,AVRLAM,AVRDEL,
     *                  IFLAMD,IFMINV,EPCBAR,D_SHEL,CORREL,AVRCOR,
     *                  PROJ1B,PROJ2B,PROJ_0,PROJ_H,PRJLAM,PRJDEL,
     *                  AVER1B,AVER2B,AVER_0,AVER_H,AVPLAM,AVPDEL)
C
      END IF
C
      DO I=1,NDPAIR
         V2OCCU(I)=V2PROJ(I)
      END DO
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C=======================================================================
C
      SUBROUTINE WS_CMPPRO(ESPECT,IFMINI,IFLAMB)
C=======================================================================
      USE params
C=======================================================================
C
      DIMENSION
     *          ESPECT(1:NDBASE)
C
C                            Inputs
C
      COMMON
     *       /SPECTR_PRONEU/ ESINPP(1:NDBASE),ESINPN(1:NDBASE)
      COMMON
     *       /PNPROJ_DIMENS/ LDBASE
C
C                            Outputs
C
      COMMON
     *       /PNPROJ_EWSODD/ ESINGP(1:NDWSOD)
      COMMON
     *       /PNPROJ_EXTREM/ ESPLOW,ESPUPP
     *       /PNPROJ_NOFNOD/ NOFNOD
      COMMON
     *       /PNPROJ_CUTSTR/ LIMCUT
      COMMON
     *       /PNPROJ_WHATMI/ IFMINV,IFLAMD
C
C=======================================================================
C
      IFMINV=IFMINI
      IFLAMD=IFLAMB
C
      NDCOMM=MIN(NDBASE,NDWSOD)
C
      DO I=1,NDCOMM
         ESINGP(I)=ESPECT(I)
      END DO
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C=======================================================================
C
      SUBROUTINE WS_GIVOUT(IZCALC,INCALC,IFGAVR,IFGFIT,IFQUAS,ISOSPI,
     *                            FACTOG,GACTIV,G_PAIR,LDWIND,N_PART,
     *                     PAIREN,PROJCR,SUMSNG,SUMGPA,BCSLAM,BCSDEL,
     *                     AVRPAI,AVRPRJ,AVRSNG,AVRGPA,AVRLAM,AVRDEL,
     *                     IFLAMD,IFMINV,EPCBAR,D_SHEL,CORREL,AVRCOR,
     *                     PROJ1B,PROJ2B,PROJ_0,PROJ_H,PRJLAM,PRJDEL,
     *                     AVER1B,AVER2B,AVER_0,AVER_H,AVPLAM,AVPDEL)
      CHARACTER
     *          NUCLEO(0:1)*9,COMENT(0:2)*10
C
      COMMON
     *       /PNPROJ_WINDOE/ EN_LOW,EN_FER,EN_UPP
     *       /PNPROJ_WINDOI/ IN_LOW,IN_FER,IN_UPP
C
      DATA
     *     NUCLEO(0) / 'NEUTRONS:' /,
     *     NUCLEO(1) / 'PROTONS: ' /
      DATA
     *     COMENT(0) / 'G-fitted: ' /,
     *     COMENT(1) / 'G-average:' /,
     *     COMENT(2) / 'G-userdef:' /
C
C=======================================================================
C         This is essentially output-printing routine, HOWEVER ...
C=======================================================================
C
                       ICOMEN=2
      IF (IFGFIT.EQ.1) ICOMEN=0
      IF (IFGAVR.EQ.1) ICOMEN=1
C
C         ... the objects below must be defined somewhere in the
C                                                        program
      PNPCRL=PROJ_H-PROJ_0
      BCSCRL=PAIREN-SUMSNG-SUMGPA
C
      PNPCOR=PROJ_H-AVER_H
      BCSCOR=PAIREN-AVRPAI
C
      IF (IFMINV.EQ.1) THEN
          PRJLAM=-1.0E+9
          AVPLAM=-1.0E+9
          PRJDEL=-1.0E+9
          AVPDEL=-1.0E+9
      END IF
C
C=======================================================================
C
      WRITE(6,'(/,80(''#''),/,''#'',78X,''#'',/,
     *            ''#     Particle-Number Projection and the '',
     *            ''Standard BCS Pairing Calculations     #'',/,
     *            ''#'',78X,''#'',/,
     *            ''#     '',A9,''   Z ='',I3,''   N ='',I3,4X,A10,
     *            '' G_PAIR='',F5.3,''  GFACTO='',F5.3,''     #'',/,
     *            ''#'',T63,''GACTIV='',F5.3,''     #'')')
     *
     *            NUCLEO(ISOSPI),IZCALC,INCALC,COMENT(ICOMEN),G_PAIR,
     *                                                        FACTOG,
     *                                                        GACTIV
C
      WRITE(6,'(  ''#     Window:     LD_LOW='',I2,'' ['',F8.4,'']'',
     *            ''  LD_UPP='',I3,''['',F8.4,'']'',T80,''#'',/,
     *            ''#                 LDWIND='',I2,'' N_PART='',I3,
     *            ''  LFERMI='',I3,''['',F8.4,'']'',T80,''#'',/,
     *            ''#'',78X,''#'',/,80(''#''),/,''#'',78X,''#'')')
     *
     *            IN_LOW,EN_LOW,IN_UPP,EN_UPP,LDWIND,N_PART,IN_FER,
     *                                                      EN_FER
C
      WRITE(6,'(  ''#     Total      1-body      2-body     '',
     *            ''  Lambda    Delta        P. N. P.      #'',/,
     *            ''#'',78X,''#'',/,
     *            ''#'',2F12.5,F11.5,5X,F7.3,4X,F5.3,
     *            ''      <<== actual     #'',/,
     *            ''#'',2F12.5,F11.5,5X,F7.3,4X,F5.3,
     *            ''      <<== smooth     #'',/,
     *            ''#'',F12.5,T64,''<<== Sum_sp     #'',/,
     *            ''#'',78X,''#'')')
     *                               PROJ_H,PROJ1B,PROJ2B,PRJLAM,PRJDEL,
     *                               AVER_H,AVER1B,AVER2B,AVPLAM,AVPDEL,
     *                                                           PROJ_0
C
      WRITE(6,'(''#     Total      PROJCR      SUMGPA     '',
     *            ''  Lambda    Delta        B. C. S.      #'',/,
     *            ''#'',78X,''#'',/,
     *
     *            ''#'',F12.5,F11.5,1X,F11.5,3X,2F9.3,
     *            ''      <<== actual     #'',/,
     *            ''#'',F12.5,F11.5,1X,F11.5,3X,2F9.3,
     *            ''      <<== smooth     #'',/,
     *            ''#'',F12.5,T64,''<<== Sum_sp     #'')')
     *
     *                               PAIREN,PROJCR,SUMGPA,BCSLAM,BCSDEL,
     *                               AVRPAI,AVRPRJ,AVRGPA,AVRLAM,AVRDEL,
     *                                                    SUMSNG+SUMGPA
C
      WRITE(6,'(  ''#                       FINAL RESULTS FOR'',
     *            '' ENERGIES                             #'',/,
     *            ''#        Correlation                     '',
     *            ''              Correction              #'',/,
     *            ''#                              #'',T80,''#'',/,
     *            ''#    P.N.P.   B.C.S.   EPCBAR  #   Shell  #'',
     *            ''  P.N.P.   B.C.S.     Comments      #'',/,
     *            ''#'',1X,F9.4,F9.4,F9.4,''  #'',F9.4,'' #'',
     *              F8.4,1X,F8.4,'' <-Smooth Spectr.  #'',/,
     *            ''#                              #          #'',
     *            F8.4,1X,F8.4,'' <-using  EPCBAR   #'',/,
     *            ''#'',T80,''#'',/,80(''#''),/)')
     *                                          PNPCRL,BCSCRL,EPCBAR,
     *                                                        D_SHEL,
     *                                                 PNPCOR,BCSCOR,
     *                                   PNPCRL-EPCBAR,BCSCRL-EPCBAR
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C=======================================================================
C
      SUBROUTINE WS_DEFAVR
C=======================================================================
      USE params
C=======================================================================
      COMMON
     *       /PNPROJ_SINGLP/ ESPAIR(1:NDPAIR),STDDEL(1:NDPAIR)
     *       /PNPROJ_AVERAG/                  ESPAVR(1:NDPAIR)
      COMMON
     *       /PNPROJ_CNTRLS/ LDANGL,LDPAIR,N_PART
C
C=======================================================================
C        This subroutine overwrites the realistic single particle
C        spectrum of the user-selected energy window by using the
C        predefined earlier smoothed energy spectrum. A smoothing
C        procedure selected is not based on the Strutinsky tricks
C        since the latter generate some undesired fluctuations eg
C        the density function may become negative.
C=======================================================================
C
      DO I=1,LDPAIR
         ESPAIR(I)=ESPAVR(I)
      END DO
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C=======================================================================
C
      SUBROUTINE WS_DEFPRJ(IFMINV,IFLAMD,PRJLAM,PRJDEL,XMINIM,NDMPNP,
     *                     LDWIND,EWSODD,NDIMEN,LDIMEN,ISOSPI,ENSTEP,
     *                     GPPROT,GPNEUT,G_PAIR,FACTOG,GFACTP,GFACTN,
     *                     DELBAR,IZ_FIX,IN_FIX,ISMOTH,WINDEN,GSTRUT,
     *                                                        LCUTSH)
C=======================================================================
      USE params
C=======================================================================
C
      COMPLEX
     *          SUMEXP,CMPEXP
C
      DIMENSION
     *          XMINIM(1:NDMPNP),EWSODD(1:NDIMEN)
C
      COMMON
     *       /PNPROJ_PROJEN/ V2PROJ(1:NDPAIR),U2PROJ(1:NDPAIR),
     *                       SQRTV2(1:NDPAIR),SQRTU2(1:NDPAIR)
      COMMON
     *       /PNPROJ_SINGLP/ ESPAIR(1:NDPAIR),STDDEL(1:NDPAIR)
     *       /PNPROJ_BLOCKG/                  NBLOCK(1:NDPAIR)
     *       /PNPROJ_AVERAG/                  ESPAVR(1:NDPAIR)
      COMMON
     *       /PNPROJ_PAIRIG/ G_MATR(1:NDPAIR,1:NDPAIR),GACTIV
      COMMON
     *       /PNPROJ_CNTRLS/ LDANGL,LDPAIR,N_PART
      COMMON
     *       /PNPROJ_WINDOE/ EN_LOW,EN_FER,EN_UPP
     *       /PNPROJ_WINDOI/ IN_LOW,IN_FER,IN_UPP
      COMMON
     *       /PNPROJ_ITEITE/ ITERSF,ITERSD
      COMMON
     *       /PNPROJ_HOWINT/ IFDEFS
C
      COMMON
     *       /PNPROJ_CUTSTR/ LIMCUT
      COMMON
     *       /PNPROJ_GAMSTR/ GAMMAS
      COMMON
     *       /SHE_PARTIC/ NP_STR
C
      COMMON
     *       /PNPROJ_DIMENS/ LDBASE
C
      DATA
     *        XXDELT / 1.0000 /,
     *        DDELTA / 0.0001 /
C
      DATA
     *        EPSILO / 1.0E-5 /,
     *        EPSDEG / 1.0E-8 /
C
C=======================================================================
C
C        This subroutine defines several variables and vectors that
C        will be used  by several pairing routines  including those
C        with the PNP, BCS etc.  The PNP minimisations are possible
C        according to any one of the two modes implemented:  Lambda-
C        Delta minimisation or direct V2-minimization.
C
C        Detailed explanations are given below where they apply ...
C
C=======================================================================
C
      ITERSF=0 ! Starting values of the iteration counters: functns.
      ITERSD=0 ! ... and their derivatives ...
C
      LIMCUT=LCUTSH
      GAMMAS=GSTRUT
C
C=======================================================================
C
C     Below - we define  the energy window for pairing calculations:
C             In the actual implementation the window-size is given
C             in terms of the  n u m b e r s  of levels rather than
C             the energies. The size of the window is defined using
C             parameter LDWIND:
C                                 lower bound -> LFERMI-LDWIND+1
C                                 upper bound -> LFERMI+LDWIND
C
C             N_PART is the actual particle number corresponding to
C             pairing-window chosen ...
C
C=======================================================================
C
      IF (ISOSPI.EQ.0) THEN
          LFERMI=IN_FIX/2
          G_PAIR=GPNEUT*GFACTN
          FACTOG=GFACTN
          NP_STR=2*(IN_FIX/2)
      END IF
C
      IF (ISOSPI.EQ.1) THEN
          LFERMI=IZ_FIX/2
          G_PAIR=GPPROT*GFACTP
          FACTOG=GFACTP
          NP_STR=2*(IZ_FIX/2)
      END IF
C
C=======================================================================
C
      LD_LOW=LFERMI-LDWIND+1
      LD_UPP=LFERMI+LDWIND
C
      N_PART=2*LDWIND
C
      IF (LD_LOW.LE.0) THEN
C
          LD_LOW=1
          LD_UPP=LFERMI+LFERMI
          N_PART=LD_UPP
C
      END IF
C
      EN_LOW=EWSODD(LD_LOW)
      EN_UPP=EWSODD(LD_UPP)
      EN_FER=EWSODD(LFERMI+1)+EWSODD(LFERMI)
      EN_FER=EN_FER/2
C
      IN_LOW=LD_LOW
      IN_FER=LFERMI
      IN_UPP=LD_UPP
C
C=======================================================================
C     Reducing the original full single-particle spectrum to the
C     smaller pairing energy window: {EWSODD_i} ==>>> {ESPAIR_j}
C=======================================================================
C
      IWINDO=0
C
      DO I=LD_LOW,LD_UPP
         IWINDO=IWINDO+1
         ESPAIR(IWINDO)=EWSODD(I)
         NBLOCK(IWINDO)=0
      END DO
C
      LDPAIR=IWINDO
C
C	Removing the multiplet degeneracies. This causes the algorithm to
C       crash. Each member of the multiplet is slightly shifted up so as
C       have non-degenerate levels (up to the precision EPSILO << 1 eV)
C
      EINITI=ESPAIR(1)
C
      DO I=2,LDPAIR
C
         DEGTST=ABS(ESPAIR(I)-EINITI)
C
C       Two levels (at least) are degenerate
C
         IF (DEGTST.LT.EPSDEG) THEN
C
             NCOUNT=2
C
C       Looking out if they are member of a 2j+1 multiplet
C
             DO J=I+1,LDPAIR
C
                DEGTST=ABS(ESPAIR(J)-EINITI)
C
		IF (DEGTST.LT.EPSDEG) THEN
	            NCOUNT=NCOUNT+1
		ELSE
                    GO TO 2
		END IF
C
  	     END DO
C
  2          CONTINUE
C
C       The total number of degenerate levels is NCOUNT: shifting them up
C
             DO ICOUNT=1,NCOUNT
	        I_REAL=I-1+ICOUNT-1
	        ESPAIR(I_REAL)=ESPAIR(I_REAL)+REAL(ICOUNT)
     *                                *EPSILO/REAL(NCOUNT)
             END DO
C
	 END IF
C
	 EINITI=ESPAIR(I)
C
      END DO
C
      IF (LDPAIR.NE.N_PART) THEN
          WRITE(6,'(/,''In the actual approach LDPAIR='',I5,
     *                ''must be equal N_PART='',I5)') LDPAIR,
     *                                                N_PART
          STOP 'LDPAIR.NE.N_PART in STARTI'
      END IF
C
C=======================================================================
C     Definition of the starting value of the 'projected-Lambda'
C=======================================================================
C
      PRJLAM=EN_FER
C
C=======================================================================
C
C     Choice related to Delta - either given by the user or else
C                                          preset by the program
      IF (PRJDEL.LT.DDELTA) THEN
          PRJDEL=XXDELT
      END IF
C
C=======================================================================
C
C     Important! Wichtig! Wazne!      Important! Wichtig! Wazne!
C
C     Defining the number of the integration points  in the case
C     of the residuum integrals.  In the present version of this
C     program the window is selected as symmetric and the number
C     of twice-degenerate levels  is exactly equal to the number
C     to the number of particles considered. In the more general
C     cases the expression below can also be used.
C
      LDANGL=MAX(N_PART,2*LDPAIR+2-N_PART)
      LDANGL=LDANGL/2                     ! when [0,pi] interval
C
C     When the above expression is incorrectly used/modified the
C     integration results are very good (for nothing) ...
C
C=======================================================================
C
      PINUMB=4.0*ATAN(1.0)
      DELPHI=PINUMB/REAL(LDANGL)    ! The interval is only [0,pi] here
C
      SUMEXP=CMPLX(0.,0.0)
C
C=======================================================================
C     Integrating the 'worst' exponential, testing the precision
C=======================================================================
C
      DO LANGLE=1,LDANGL
C
         PHIANG=LANGLE*DELPHI
C
         CMPEXP=CEXP(CMPLX(0.,PHIANG*(2*LDPAIR+2-N_PART)))
C
         SUMEXP=SUMEXP+CMPEXP
C
      END DO
C
      RESTES=REAL(SUMEXP)/REAL(LDANGL)
C
      IF (ABS(RESTES).GT.1.0E-14) THEN
C
          IF (ABS(RESTES-1).GT.1.0E-14) THEN
C
              WRITE(6,'(/,''Accuracy test RESTES='',F20.14)') RESTES
C
              STOP 'Increase the number of the integration points -'
C
          END IF
C
      END IF
C
C=======================================================================
C
      IFDEFS=0 ! Requesting to calculate residuum integrals through
C                recurrence relations rather then by definition; as
C                the consequence, the gain in time is close  to the
C                factor of ten.
C
C     Attention! Recurrences should NOT be used when the full "v_n"
C                minimisation is requested. This is because in such
C                a case v_n and v_m could be nearly equal while the
C                corresponding differences appear in the denominats.
C                in the recurrences and precision cannot in general
C                be satisfied. However, with a few tricks we obtain
C                effectively the same precision with recurrences!!!
C
      IF (IFMINV.EQ.1) IFDEFS=1 ! The costs of activating this line:
C                                          ~10x c.p.u. time
C
C=======================================================================
C
      IF (IFLAMD.EQ.IFMINV) THEN
C
          IFLAMD=1
          IFMINV=0
C
          WRITE(6,'(/,''Conflicting minimization choice definition.'',/,
     *                ''Program selected Lambda/Delta version !!!!!'')')
C
      END IF
C
      IF (IFLAMD.NE.1.AND.IFMINV.NE.1) THEN
C
          WRITE(6,'(''You seem to have forgottent what you wanted.'',/,
     *              ''Select: either IFLAMD=1 or IFMINV=1'')')
C
          STOP 'IFLAMD.NE.1.AND.IFMINV.NE.1 before calling DFPMIN- '
C
      END IF
C
      IF (IFLAMD.EQ.1) THEN
          LDIMEN=2
          XMINIM(1)=PRJLAM
          XMINIM(2)=PRJDEL
      END IF

      IF (IFMINV.EQ.1) THEN
          LDIMEN=LDPAIR
          DO IENERG=1,LDPAIR
             V2PROJ(IENERG)=0.5*(1-(ESPAIR(IENERG)-PRJLAM)
     *                     /SQRT((ESPAIR(IENERG)-PRJLAM)**2+PRJDEL**2))
             XMINIM(IENERG)=SQRT(V2PROJ(IENERG))
          END DO
      END IF
C
C=======================================================================
C     Preparing: the average level density and the average spectrum;
C=======================================================================
C
      LDWSOD=LDBASE
C      WRITE(6,'(''LDBASE = '',I4)') LDBASE
C
      CALL WS_DENDEF(WINDEN,ENSTEP,LDWSOD,ISMOTH)
C
      ESPAVR(1)=ESPAIR(1)
C
      DO IENERG=2,LDPAIR
         ENERGY=ESPAVR(IENERG-1)
         DLOCAL=WS_DNSINT(ENERGY,ENSTEP)
         ESPAVR(IENERG)=ESPAVR(IENERG-1)+1/DLOCAL
C         WRITE(6,'(''I='',I3,'' ESPAIR,ESPAVR='',2F12.6,
C     *         '' DENS='',F12.6)')
C     *               IENERG,ESPAIR(IENERG),ESPAVR(IENERG),DLOCAL
      END DO
C
      DE_REN=ESPAIR(LFERMI)-ESPAVR(LFERMI)
C
      SUMPAI=0
      SUMAVR=0
      DO IENERG=1,LDPAIR
         ESPAVR(IENERG)=ESPAVR(IENERG)+DE_REN
         SUMPAI=SUMPAI+ESPAIR(IENERG)
         SUMAVR=SUMAVR+ESPAVR(IENERG)
C         WRITE(6,'(''I='',I3,'' ESPAIR,ESPAVR='',2F12.6)')
C     *               IENERG,ESPAIR(IENERG),ESPAVR(IENERG)
      END DO
C      WRITE(6,'(''SUMPAI='',F20.14,'' SUMAVR='',F20.14)') SUMPAI,SUMAVR
C
C=======================================================================
C     Below: Preparing the pairing constant and / or possibly the
C     state-dependent pairing matrix elements ...
C=======================================================================
C
      GACTIV=G_PAIR
C
      DO IENER1=1,LDPAIR
         DO IENER2=1,LDPAIR
            G_MATR(IENER1,IENER2)=-GACTIV
         END DO
      END DO
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C=======================================================================
C
      FUNCTION WS_DNSINT(ENERGY,ENSTEP)
C=======================================================================
      USE params
C=======================================================================
      DIMENSION
     *          DAUXIL(1:NDWAUX)
C
      COMMON
     *       /PNPROJ_ENODES/ DNODES(1:NDWAUX),
     *                       ENODES(1:NDWAUX)
      COMMON
     *       /PNPROJ_EXTREM/ ESPLOW,ESPUPP
     *       /PNPROJ_NOFNOD/ NOFNOD
C
C=======================================================================
C        Function DNSINT gives the interpolated value of the density
C        of single particle spectrum at the argument ENERGY by using
C        the precalculated and smoothed density 'nodes' (DNODES)
C=======================================================================
C
      INDEXE=NINT((ENERGY-ESPLOW)/ENSTEP)+1
C
      IF (INDEXE.LE.0) THEN
C
          INDEXE=1
C
          Y1=DNODES(INDEXE)
          X1=ENSTEP*(INDEXE-1)+ESPLOW
C
          Y2=DNODES(INDEXE+2)
          X2=X1+ENSTEP*3
C
          Y3=DNODES(INDEXE+4)
          X3=X1+ENSTEP*5
C
          DENSI1=WS_FLININ(X1,X2,ENERGY,Y1,Y2)
          DENSI2=WS_FLININ(X1,X3,ENERGY,Y1,Y3)
C
          DENAUX=(DENSI1+DENSI2)/2
C
          GO TO 1
C
      END IF
C
      IF (INDEXE.GT.NOFNOD-2) INDEXE=NOFNOD-2
C
      Y1=DNODES(INDEXE)
      X1=ENSTEP*(INDEXE-1)+ESPLOW
C
      X2=X1+ENSTEP
      X3=X2+ENSTEP
C
      Y2=DNODES(INDEXE+1)
      Y3=DNODES(INDEXE+2)
C
      CALL WS_INTER2(X1,X2,X3,Y1,Y2,Y3,A,B,C)
C
      DENAUX=A*ENERGY**2+B*ENERGY+C
C
C=======================================================================
C
   1  CONTINUE
C
C=======================================================================
C
      IF (DENAUX.GE.0.0) THEN
          WS_DNSINT=DENAUX
      ELSE
          WS_DNSINT=0
      END IF
C
      IF (ENERGY.LT.ESPLOW) WS_DNSINT=0
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C=======================================================================
C
      SUBROUTINE WS_DENDEF(WINDEN,ENSTEP,LDWSOD,ISMOTH)
C=======================================================================
      USE params
C=======================================================================
      DIMENSION
     *          DAUXIL(1:NDWAUX)
C
      COMMON
     *       /PNPROJ_EWSODD/ ESINGP(1:NDWSOD)
      COMMON
     *       /PNPROJ_ENODES/ DNODES(1:NDWAUX),
     *                       ENODES(1:NDWAUX)
      COMMON
     *       /PNPROJ_EXTREM/ ESPLOW,ESPUPP
     *       /PNPROJ_NOFNOD/ NOFNOD
C
C=======================================================================
C
C        This is an auxiliary routine preparing the ''density nodes''
C        DNODES i.e. the values of the single-particle level density,
C        calculated from the definition, (dN/dE), at the equidistant
C        argument values, spacing equal to ENSTEP.
C
C        The node-values will be used by other subroutines to smooth,
C        further elaborate etc.
C
C=======================================================================
C
      IF (LDWSOD.GT.NDWSOD) STOP 'LDWSOD>NDWSOD in DENDEF'
      IF (ENSTEP.LE.0.0000) STOP 'ENSTEP<0.0000 in DENDEF'
C
C=======================================================================
C
      ESPLOW=ESINGP(1)
      ESPUPP=ESINGP(LDWSOD)
C
      NOFNOD=INT((ESPUPP-ESPLOW)/ENSTEP)
C
      IF (NOFNOD.GT.NDWAUX) STOP 'NOFNOD>NDWAUX in DENDEF'
C
C=======================================================================
C
      DO IENERG=1,NOFNOD
C
         ENERGY=ESPLOW+(IENERG-1)*ENSTEP
C
         ENELOW=ENERGY-WINDEN/2
         ENEUPP=ENERGY+WINDEN/2
C
         NCOUNT=0
C
         DO I=1,LDWSOD
            ENEACT=ESINGP(I)
            IF (ENEACT.GE.ENELOW.AND.ENEACT.LE.ENEUPP) THEN
                NCOUNT=NCOUNT+1
            END IF
            IF (ENEACT.GT.ENEUPP) GO TO 1
         END DO
C
   1     CONTINUE
C
         DNODES(IENERG)=NCOUNT/WINDEN
         ENODES(IENERG)=ENERGY
C
      END DO
C
C=======================================================================
C          Smoothing the raw density function by arithmetic average
C          The averaging will pass ISMOTH times  through the vector
C          values stored in DNODES;  DAUXIL is an auxiliary storage.
C=======================================================================
C
      CALL WS_SMOOTH(DNODES,DAUXIL,NOFNOD,NDWAUX,ISMOTH)
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C=======================================================================
C
      SUBROUTINE WS_SMOOTH(FUNCTN,FAUXIL,LDPOIN,NDPOIN,ISMOTH)
      DIMENSION
     *          FUNCTN(1:NDPOIN),FAUXIL(1:NDPOIN)
C
C=======================================================================
C         SMOOTH will smooth out a curve by arithmetical averaging
C         over the neighboring points
C=======================================================================
C
      IF (LDPOIN.GT.NDPOIN) THEN
          WRITE(0,'(''Smoothing routine SMOOTH: LDPOIN='',I4,
     *              '' exceeds NDPOIN ='',I4)') LDPOIN,
     *                                          NDPOIN
          STOP 'LDPOIN.GT.NDPNT6 in CGLADZ'
      END IF
C
C=======================================================================
C
      DO K=1,LDPOIN
         FAUXIL(K)=FUNCTN(K)
      END DO
C
      DO I=1,ISMOTH
C
         DO K=2,LDPOIN-1
            FAUXIL(K)=0.5*(FAUXIL(K+1)+FAUXIL(K-1))
         END DO
C
      END DO
C
      DO K=1,LDPOIN
         FUNCTN(K)=FAUXIL(K)
      END DO
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C=======================================================================
C
      FUNCTION WS_FLININ(ARGUM1,ARGUM2,ARGUMX,FUNCT1,FUNCT2)
C
      IF (ARGUM1.EQ.ARGUM2) THEN
          WRITE(6,'(''ARGUM1,ARGUM2='',2F20.14)') ARGUM1,ARGUM2
          STOP 'ARGUM1.EQ.ARGUM2 in WS_FLININ'
      END IF
C
      WS_FLININ=FUNCT1+(FUNCT2-FUNCT1)/(ARGUM2-ARGUM1)*(ARGUMX-ARGUM1)
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C=======================================================================
C
      SUBROUTINE WS_STARTV(STARTL,STARTD,XMINIM,NDMPNP,IFLAMD,IFMINV)
C=======================================================================
      USE params
C=======================================================================
      DIMENSION
     *          XMINIM(1:NDMPNP)
      COMMON
     *       /PNPROJ_PROJEN/ V2PROJ(1:NDPAIR),U2PROJ(1:NDPAIR),
     *                       SQRTV2(1:NDPAIR),SQRTU2(1:NDPAIR)
      COMMON
     *       /PNPROJ_SINGLP/ ESPAIR(1:NDPAIR),STDDEL(1:NDPAIR)
      COMMON
     *       /PNPROJ_CNTRLS/ LDANGL,LDPAIR,N_PART
C
      DATA
     *     DELMIN / 0.25 /
C
C=======================================================================
C
C         This subroutine uses the BCS solutions found earlier to
C         prepare an optimised starting conditions for the P.N.P.
C         algorithm; those BCS solutions enter as STARTL & STARTD
C
C=======================================================================
C
      PRJLAM=STARTL
      PRJDEL=MAX(STARTD,DELMIN)
C
      IF (IFLAMD.EQ.1) THEN
          LDIMEN=2
          XMINIM(1)=PRJLAM
          XMINIM(2)=PRJDEL
      END IF

      IF (IFMINV.EQ.1) THEN
          LDIMEN=LDPAIR
          DO IENERG=1,LDPAIR
             V2PROJ(IENERG)=0.5*(1-(ESPAIR(IENERG)-PRJLAM)
     *                     /SQRT((ESPAIR(IENERG)-PRJLAM)**2+PRJDEL**2))
             XMINIM(IENERG)=SQRT(V2PROJ(IENERG))
          END DO
      END IF
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C=======================================================================
C
      SUBROUTINE WS_INTEGS(LDPAIR,N_PART,LDANGL)
C=======================================================================
      USE params
C=======================================================================
      COMPLEX
     *          PRODCT,PRODUC,PROFIN,EXPFI0,EXPFI2,EXPFI4,
     *                                             CMPEXP
      COMPLEX
     *          FACTOR,FACTO1,FACTO2,CMPSUM,CMPR10,CMPR11,
     *                               CMPR20,CMPR21,CMPR22
C
      DIMENSION
     *          PHIANG(1:ND_ANG),PROFIN(1:ND_ANG),PRODCT(1:ND_ANG)
      DIMENSION
     *          EXPFI0(1:ND_ANG),EXPFI2(1:ND_ANG),EXPFI4(1:ND_ANG),
     *                                            CMPEXP(1:ND_ANG)
      DIMENSION
     *          R10SUM(1:NDPAIR),R20SUM(1:NDPAIR,1:NDPAIR),
     *          R11SUM(1:NDPAIR),R21SUM(1:NDPAIR,1:NDPAIR),
     *                           R22SUM(1:NDPAIR,1:NDPAIR)
C
      COMMON
     *       /PNPROJ_RESIDU/ R22SUM,R21SUM,R20SUM,R11SUM,R10SUM,R00SUM
      COMMON
     *       /PNPROJ_PROJEN/ V2PROJ(1:NDPAIR),U2PROJ(1:NDPAIR),
     *                       SQRTV2(1:NDPAIR),SQRTU2(1:NDPAIR)
      COMMON
     *       /PNPROJ_HOWINT/ IFDEFS
C
C=======================================================================
C        Calculating the integrals used with the particle-number
C                                                  projection
C=======================================================================
C
      PINUMB=4.0*ATAN(1.0)
      DELPHI=PINUMB/REAL(LDANGL) ! The interval is only [0,pi] here
C
C=======================================================================
C
      DO LANGLE=1,LDANGL
         PHIANG(LANGLE)=LANGLE*DELPHI
      END DO
C
C=======================================================================
C
      DO LANGLE=1,LDANGL
C
         CMPEXP(LANGLE)=CEXP(CMPLX(0.,2*PHIANG(LANGLE)))
C
         PRODUC=CMPLX(1.,0.)
C
         DO LEVELS=1,LDPAIR
            FACTOR=U2PROJ(LEVELS)+V2PROJ(LEVELS)*CMPEXP(LANGLE)
            PRODUC=PRODUC*FACTOR
         END DO
C
         PROFIN(LANGLE)=PRODUC
C
         EXPFI0(LANGLE)=CEXP(CMPLX(0.,-PHIANG(LANGLE)* N_PART  ))
         EXPFI2(LANGLE)=CEXP(CMPLX(0.,-PHIANG(LANGLE)*(N_PART-2)))
         EXPFI4(LANGLE)=CEXP(CMPLX(0.,-PHIANG(LANGLE)*(N_PART-4)))
C
      END DO
C
C=======================================================================
C
C     Attention: In the case of the trapezoidal integration the step
C                in terms of the angle is 2*pi/LDANGL. At the end of
C                the integration, we have to multiply the result  by
C                STEP*LDANGL = 2 pi.  However, the integrals must be
C                normalized with the normalisation constant  N=1/2pi
C                and consequently the FORTRAN does not see the  2 pi.
C
C                In our case we are using the fact that the function
C                to be integrated depends on 2*phi;  consequently we
C                effectively integrate from 0 to pi and multiply the
C                result by two -> step = pi / LDANGL;
C                                 step*LDANGL*2=2*pi
C
C                Because of the normalisation mentioned above, there
C                will be no 2*pi in the programming of the integrals
C
C=======================================================================
C     Integrating R00
C=======================================================================
C
      CMPSUM=CMPLX(0.,0.)
C
      DO LANGLE=1,LDANGL
         PRODCT(LANGLE)=EXPFI0(LANGLE)*PROFIN(LANGLE)
         CMPSUM=CMPSUM+PRODCT(LANGLE)
      END DO
C
      R00SUM=REAL(CMPSUM)/REAL(LDANGL)
C
C=======================================================================
C     Integrating R11 and R10
C=======================================================================
C
      DO LEVELS=1,LDPAIR
         CMPR11=CMPLX(0.,0.)
         CMPR10=CMPLX(0.,0.)
         DO LANGLE=1,LDANGL
            FACTOR=U2PROJ(LEVELS)+V2PROJ(LEVELS)*CMPEXP(LANGLE)
            CMPR11=CMPR11+EXPFI2(LANGLE)*PROFIN(LANGLE)/FACTOR
            CMPR10=CMPR10+EXPFI0(LANGLE)*PROFIN(LANGLE)/FACTOR
         END DO
         R11SUM(LEVELS)=REAL(CMPR11)/REAL(LDANGL)
         R10SUM(LEVELS)=REAL(CMPR10)/REAL(LDANGL)
      END DO
C
C=======================================================================
C
C     COMMENT: Beginning with R2{x}, all the higher rang residuum
C              integrals should be calculated from the recurrence
C              relations and NOT using the costly definition. But
C              in order  to keep  the possibility of cross-checks
C              we introduce  an option, that enables  calculating
C              by definition the higher rang integrals as well.
C
C=======================================================================
C     Integrating R20, R21 and R22
C=======================================================================
C
      IF (IFDEFS.EQ.1) THEN ! We calculate the higher order resid.
C                                         integrals by definition
          DO LEVEL1=1,LDPAIR
             DO LEVEL2=1,LDPAIR
C
                CMPR20=CMPLX(0.,0.)
                CMPR21=CMPLX(0.,0.)
                CMPR22=CMPLX(0.,0.)
C
                IF (LEVEL1.NE.LEVEL2) THEN
C
                    DO LANGLE=1,LDANGL
C
                       FACTO1=U2PROJ(LEVEL1)+V2PROJ(LEVEL1)
     *                                      *CMPEXP(LANGLE)
                       FACTO2=U2PROJ(LEVEL2)+V2PROJ(LEVEL2)
     *                                      *CMPEXP(LANGLE)
C
                       CMPR20=CMPR20+EXPFI0(LANGLE)*PROFIN(LANGLE)
     *                                             /FACTO1/FACTO2
                       CMPR21=CMPR21+EXPFI2(LANGLE)*PROFIN(LANGLE)
     *                                             /FACTO1/FACTO2
                       CMPR22=CMPR22+EXPFI4(LANGLE)*PROFIN(LANGLE)
     *                                             /FACTO1/FACTO2
                    END DO
C
                    R20SUM(LEVEL1,LEVEL2)=REAL(CMPR20)/REAL(LDANGL)
                    R21SUM(LEVEL1,LEVEL2)=REAL(CMPR21)/REAL(LDANGL)
                    R22SUM(LEVEL1,LEVEL2)=REAL(CMPR22)/REAL(LDANGL)
C
                END IF
C
             END DO
          END DO
C
      ELSE ! Here calculating the higher order residuum integrals
C                                        via recurrence relations
          DO LEVEL1=1,LDPAIR
             DO LEVEL2=1,LDPAIR
C
                IF (LEVEL1.NE.LEVEL2) THEN
C
                    ELEMNT=U2PROJ(LEVEL1)*R11SUM(LEVEL1)
     *                    -U2PROJ(LEVEL2)*R11SUM(LEVEL2)
C
                    DIFFER=U2PROJ(LEVEL1)-U2PROJ(LEVEL2)
C
                    R22SUM(LEVEL1,LEVEL2)=ELEMNT/DIFFER ! R22
C
                    ELEMNT=U2PROJ(LEVEL1)*R10SUM(LEVEL1)
     *                    -U2PROJ(LEVEL2)*R10SUM(LEVEL2)
C
                    R21SUM(LEVEL1,LEVEL2)=ELEMNT/DIFFER ! R21
C
                    ELEMNT=V2PROJ(LEVEL1)*R10SUM(LEVEL1)
     *                    -V2PROJ(LEVEL2)*R10SUM(LEVEL2)
C
                    DIFFER=V2PROJ(LEVEL1)-V2PROJ(LEVEL2)
C
                    R20SUM(LEVEL1,LEVEL2)=ELEMNT/DIFFER ! R20
C
                ELSE
C
                    R22SUM(LEVEL1,LEVEL2)=0
                    R21SUM(LEVEL1,LEVEL2)=0
                    R20SUM(LEVEL1,LEVEL2)=0
C
                END IF
C
             END DO
          END DO
C
      END IF
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C=======================================================================
C
      FUNCTION WS_PROMIN(ARGMNS,NDACTV,IABORT)
C=======================================================================
      USE params
C=======================================================================
C
      DIMENSION
     *          ARGMNS(1:NDACTV)
C
      COMMON
     *       /PNPROJ_PROJEN/ V2PROJ(1:NDPAIR),U2PROJ(1:NDPAIR),
     *                       SQRTV2(1:NDPAIR),SQRTU2(1:NDPAIR)
      COMMON
     *       /PNPROJ_SINGLP/ ESPAIR(1:NDPAIR),STDDEL(1:NDPAIR)
      COMMON
     *       /PNPROJ_CNTRLS/ LDANGL,LDPAIR,N_PART
      COMMON
     *       /PNPROJ_ECONTR/ ENERG0,ENERG1,ENERG2
      COMMON
     *       /PNPROJ_ITEITE/ ITERSF,ITERSD
      COMMON
     *       /PAIRIN_FORPRO/ IFMINV,IFLAMD
C
C=======================================================================
C
C     WS_PROMIN defines the function to be minimised - when calculating
C     the particle-number projected pairing energy.
C
C     There are two variants implemented at present. One corresponds
C     to minimisation over Lambda and Delta, that in turn define the
C     coefficients V2 and U2. In this case we must choose IFLAMD = 1;
C     The second variant  corresponds to the minimisation  performed
C     directly in terms of the V-coefficients. Then we set IFMINV =1.
C
C=======================================================================
C
      IF (LDPAIR.GT.NDPAIR) THEN
          WRITE(6,'(''LDPAIR='',I5,'' exceeds NDPAIR='',I3)')
     *                LDPAIR,                 NDPAIR
          STOP 'LDPAIR.GT.NDPAIR in WS_PROMIN'
      END IF
C
      ITERSF=ITERSF+1
C
      IF (IFLAMD.EQ.1) THEN
          PRJLAM=ARGMNS(1)
          PRJDEL=ABS(ARGMNS(2))
          DO IENERG=1,LDPAIR
             V2PROJ(IENERG)=0.5*(1-(ESPAIR(IENERG)-PRJLAM)
     *                     /SQRT((ESPAIR(IENERG)-PRJLAM)**2+PRJDEL**2))
             U2PROJ(IENERG)=1.00-V2PROJ(IENERG)
             SQRTV2(IENERG)=SQRT(V2PROJ(IENERG))
             SQRTU2(IENERG)=SQRT(U2PROJ(IENERG))
          END DO
      END IF
C
      IF (IFMINV.EQ.1) THEN
          X_NORM=0
          DO IENERG=1,LDPAIR
             SQRTV2(IENERG)=ARGMNS(IENERG)
             V2PROJ(IENERG)=SQRTV2(IENERG)**2
             X_NORM=X_NORM+V2PROJ(IENERG)
          END DO
          CHECKN=0
          DO IENERG=1,LDPAIR
             V2PROJ(IENERG)=V2PROJ(IENERG)/X_NORM*N_PART*.5
C
C            Attention: The dirty trick below is related to residuum
C                       integral calculations using the recurrences:
C                       some denominators contain u2(i)-u2(j) ......
C
             IF (V2PROJ(IENERG).GT.1.0) V2PROJ(IENERG)=0.999
     *                                                +IENERG*0.00001
             CHECKN=CHECKN+V2PROJ(IENERG)
             SQRTV2(IENERG)=SQRT(V2PROJ(IENERG))
             U2PROJ(IENERG)=1-V2PROJ(IENERG)
             SQRTU2(IENERG)=SQRT(U2PROJ(IENERG))
          END DO
      END IF
C
C=======================================================================
C
      CALL WS_INTEGS(LDPAIR,N_PART,LDANGL)
C
C=======================================================================
C
      CALL WS_PROJCH(LDPAIR,PROJ_E,N_PART)
C
C=======================================================================
C
      WS_PROMIN=PROJ_E
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C=======================================================================
C
      SUBROUTINE WS_DPROMI(ARGMNS,NDACTV,GRADIE,GRADNM)
C=======================================================================
      USE params
C=======================================================================
      DIMENSION
     *          ARGMNS(1:NDPAIR),DERIVS(1:NDPAIR)
      DIMENSION
     *          GRADIE(1:NDACTV)
C
      COMMON
     *       /PNPROJ_PROJEN/ V2PROJ(1:NDPAIR),U2PROJ(1:NDPAIR),
     *                       SQRTV2(1:NDPAIR),SQRTU2(1:NDPAIR)
      COMMON
     *       /PNPROJ_SINGLP/ ESPAIR(1:NDPAIR),STDDEL(1:NDPAIR)
      COMMON
     *       /PNPROJ_CNTRLS/ LDANGL,LDPAIR,N_PART
      COMMON
     *       /PNPROJ_ECONTR/ ENERG0,ENERG1,ENERG2
      COMMON
     *       /PNPROJ_ITEITE/ ITERSF,ITERSD
      COMMON
     *       /PAIRIN_FORPRO/ IFMINV,IFLAMD
C
C=======================================================================
C
C     There are two variants implemented at present. One corresponds
C     to minimisation over Lambda and Delta, that in turn define the
C     coefficients V2 and U2. In this case we must choose IFLAMD = 1;
C     The second variant  corresponds to the minimisation  performed
C     directly in terms of the V-coefficients. Then we set IFMINV =1.
C
C=======================================================================
C
      ITERSD=ITERSD+1
C
      IF (IFLAMD.EQ.1) THEN
          PRJLAM=ARGMNS(1)
          PRJDEL=ABS(ARGMNS(2))
          DO IENERG=1,LDPAIR
             V2PROJ(IENERG)=0.5*(1-(ESPAIR(IENERG)-PRJLAM)
     *                     /SQRT((ESPAIR(IENERG)-PRJLAM)**2+PRJDEL**2))
             U2PROJ(IENERG)=1-V2PROJ(IENERG)
             SQRTV2(IENERG)=SQRT(V2PROJ(IENERG))
             SQRTU2(IENERG)=SQRT(U2PROJ(IENERG))
          END DO
      END IF
C
      IF (IFMINV.EQ.1) THEN
          X_NORM=0
          DO IENERG=1,LDPAIR
             SQRTV2(IENERG)=ARGMNS(IENERG)
             V2PROJ(IENERG)=SQRTV2(IENERG)**2
             X_NORM=X_NORM+V2PROJ(IENERG)
          END DO
          CHECKN=0
          DO IENERG=1,LDPAIR
             V2PROJ(IENERG)=V2PROJ(IENERG)/X_NORM*N_PART*.5
             IF (V2PROJ(IENERG).GT.1.0) V2PROJ(IENERG)=0.999
     *                                                +IENERG*0.00001
             CHECKN=CHECKN+V2PROJ(IENERG)
             SQRTV2(IENERG)=SQRT(V2PROJ(IENERG))
             U2PROJ(IENERG)=1-V2PROJ(IENERG)
             SQRTU2(IENERG)=SQRT(U2PROJ(IENERG))
          END DO
      END IF
C
C=======================================================================
C
      CALL WS_INTEGS(LDPAIR,N_PART,LDANGL)
C
C=======================================================================
C
      CALL WS_DERIVH(LDPAIR,PROJ_E,DERIVS)
C
C=======================================================================
C
      IF (IFLAMD.EQ.1) THEN
C
         GRADIE(1)=0
         GRADIE(2)=0
C
         DO IENERG=1,LDPAIR
C
            EQUASP=SQRT((ESPAIR(IENERG)-PRJLAM)**2+PRJDEL**2)
            SQRDEN=SQRT(2*(1-(ESPAIR(IENERG)-PRJLAM)/EQUASP))
C
            VDELAM=PRJDEL**2/EQUASP**3/SQRDEN/2
C
            VDEDEL=(ESPAIR(IENERG)-PRJLAM)*PRJDEL/EQUASP**3/SQRDEN/2
C
            GRADIE(1)=GRADIE(1)+VDELAM*DERIVS(IENERG)
            GRADIE(2)=GRADIE(2)+VDEDEL*DERIVS(IENERG)
C
         END DO
C
      END IF
C
C=======================================================================
C
      IF (IFMINV.EQ.1) THEN
C
         DO IENERG=1,LDPAIR
            GRADIE(IENERG)=DERIVS(IENERG)
         END DO
C
      END IF
C
      GRADNM=0.0
      DO I=1,LDPAIR
         GRADNM=GRADNM+DERIVS(I)**2
      END DO
C
      GRADNM=SQRT(GRADNM)
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C=======================================================================
C
      SUBROUTINE WS_PROJCH(LDPAIR,PROJ_E,N_PART)
C=======================================================================
      USE params
C=======================================================================
      DIMENSION
     *          R10SUM(1:NDPAIR),R20SUM(1:NDPAIR,1:NDPAIR),
     *          R11SUM(1:NDPAIR),R21SUM(1:NDPAIR,1:NDPAIR),
     *                           R22SUM(1:NDPAIR,1:NDPAIR)
      DIMENSION
     *          AUXVEC(1:NDPAIR)
C
      COMMON
     *       /PNPROJ_RESIDU/ R22SUM,R21SUM,R20SUM,R11SUM,R10SUM,R00SUM
      COMMON
     *       /PNPROJ_PROJEN/ V2PROJ(1:NDPAIR),U2PROJ(1:NDPAIR),
     *                       SQRTV2(1:NDPAIR),SQRTU2(1:NDPAIR)
      COMMON
     *       /PNPROJ_SINGLP/ ESPAIR(1:NDPAIR),STDDEL(1:NDPAIR)
      COMMON
     *       /PNPROJ_PAIRIG/ G_MATR(1:NDPAIR,1:NDPAIR),GACTIV
      COMMON
     *       /PNPROJ_ECONTR/ ENERG0,ENERG1,ENERG2
C
C=======================================================================
C
C        This subroutine  calculates the expectation value of the PN
C        projected hamiltonian composed of the static mean field and
C        the state-dependent pairing hamiltonian
C
C=======================================================================
C
      DO IENERG=1,LDPAIR
         AUXVEC(IENERG)=SQRT(V2PROJ(IENERG)*U2PROJ(IENERG))
      END DO
C
C=======================================================================
C     Calculating the single-particle energy contribution (nopairing)
C=======================================================================
C
      LAMBDA=N_PART/2
C
      EFERMI=0.5*(ESPAIR(LAMBDA)+ESPAIR(LAMBDA+1))
C
      ENERG0=0
C
      DO IENERG=1,LDPAIR
         IF (ESPAIR(IENERG).LT.EFERMI) THEN
             ENERG0=ENERG0+ESPAIR(IENERG)
         END IF
      END DO
C
      ENERG0=ENERG0+ENERG0
C
      SUMGPA=-REAL(N_PART/2)*GACTIV
C
      ENERG0=ENERG0+SUMGPA
C
C=======================================================================
C     Calculating the one-body term and the diagonal term originating
C                                                    from the pairing
C=======================================================================
C
      ENERG1=0
      PDIAG1=0
C
      DO MINDEX=1,LDPAIR
C
         ONECON=2*R11SUM(MINDEX)*V2PROJ(MINDEX)*ESPAIR(MINDEX)
         ONEPAI=  R11SUM(MINDEX)*V2PROJ(MINDEX)*G_MATR(MINDEX,MINDEX)
C
         ENERG1=ENERG1+ONECON
         PDIAG1=PDIAG1+ONEPAI
C
      END DO
C
      ENERG1=ENERG1/R00SUM
      PDIAG1=PDIAG1/R00SUM
C
C=======================================================================
C     Calculating the vector of the PN projected Pairing-Delta
C=======================================================================
C
      DO MINDEX=1,LDPAIR
C
         STATDL=0
         DO NINDEX=1,LDPAIR
            DLTERM=G_MATR(MINDEX,NINDEX)*AUXVEC(NINDEX)
     *            *R21SUM(MINDEX,NINDEX)
            STATDL=STATDL+DLTERM
         END DO
         STDDEL(MINDEX)=STATDL
C
      END DO
C
C=======================================================================
C     Calculating the PN projected two-body term
C=======================================================================
C
      ENERG2=0
C
      DO MINDEX=1,LDPAIR
         ENERG2=ENERG2+AUXVEC(MINDEX)*STDDEL(MINDEX)
      END DO
C
      ENERG2=ENERG2/R00SUM+PDIAG1  ! Adding the diagonal part
C
C=======================================================================
C
      PROJ_E=ENERG1+ENERG2
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C=======================================================================
C
      SUBROUTINE WS_GIVE_H(LDPAIR,N_PART,PRJDEL,PRJLAM,PROJ1B,PROJ2B,
     *                                          PROJ_0,PROJ_H,IPRINT)
C=======================================================================
      USE params
C=======================================================================
      DIMENSION
     *          R10SUM(1:NDPAIR),R20SUM(1:NDPAIR,1:NDPAIR),
     *          R11SUM(1:NDPAIR),R21SUM(1:NDPAIR,1:NDPAIR),
     *                           R22SUM(1:NDPAIR,1:NDPAIR)
C
      DIMENSION
     *          V2CLAS(1:NDPAIR)
C
      COMMON
     *       /PNPROJ_RESIDU/ R22SUM,R21SUM,R20SUM,R11SUM,R10SUM,R00SUM
      COMMON
     *       /PNPROJ_PROJEN/ V2PROJ(1:NDPAIR),U2PROJ(1:NDPAIR),
     *                       SQRTV2(1:NDPAIR),SQRTU2(1:NDPAIR)
      COMMON
     *       /PNPROJ_SINGLP/ ESPAIR(1:NDPAIR),STDDEL(1:NDPAIR)
      COMMON
     *       /PNPROJ_PAIRIG/ G_MATR(1:NDPAIR,1:NDPAIR),GACTIV
      COMMON
     *       /PNPROJ_ECONTR/ ENERG0,ENERG1,ENERG2
      COMMON
     *       /PAIRIN_FORPRO/ IFMINV,IFLAMD
C
C=======================================================================
C
C        This subroutine prints the microscopic quantities associated
C        with the Particle-Number Projection algorithm.
C
C=======================================================================
C
      IF (IFLAMD.EQ.1) THEN  ! Minimisation with respect to modelised
C                              v2 - functions of PRJLAM and PRJDEL
C
C     Below: DELTAE denotes an auxiliary parameter giving the differs.
C            between 'classical' summation of 2*v2*e and an analogous
C            expression  containing ratios  of the residuum integrals.
C
C            Similarly, DELTAV is an auxiliary measure of the differs.
C            between the total occupation - with and without residuum
C                                                    integral  ratios
C
          IF (IPRINT.EQ.1) THEN
              WRITE(6,'(/,'' LEV   ESPAIR   V2clas   V2proj   '',
     *             ''R11/R00   DeltaV2   DeltaEC   DeltaEP'',/)')
          END IF
C
          DO IENERG=1,LDPAIR
             V2CLAS(IENERG)=0.5*(1-(ESPAIR(IENERG)-PRJLAM)
     *                       /SQRT((ESPAIR(IENERG)-PRJLAM)**2
     *                                            +PRJDEL**2))
          END DO
C
          SUMDEL=0
          SUMCLS=0
          DO IENERG=1,LDPAIR
             DELCLS=2*V2CLAS(IENERG)*ESPAIR(IENERG)
     *             -2*V2PROJ(IENERG)*ESPAIR(IENERG)*R11SUM(IENERG)
     *                                                    /R00SUM
             DELTAE=2*V2PROJ(IENERG)*ESPAIR(IENERG)
     *             -2*V2PROJ(IENERG)*ESPAIR(IENERG)*R11SUM(IENERG)
     *                                                    /R00SUM
             DELTAV=V2CLAS(IENERG)-V2PROJ(IENERG)*R11SUM(IENERG)
     *                                                  /R00SUM
             SUMCLS=SUMCLS+DELCLS
             SUMDEL=SUMDEL+DELTAE
C
	     IF (IPRINT.EQ.1) THEN
C
                 WRITE(6,'(I3,f10.5,2f9.5,4f10.5)')
     *             IENERG,ESPAIR(IENERG),
     *                    V2CLAS(IENERG),
     *                    V2PROJ(IENERG)*R11SUM(IENERG)/R00SUM,
     *                                   R11SUM(IENERG)/R00SUM,
     *                                          DELTAV, DELCLS,DELTAE
C
             END IF
C
          END DO
C
	  IF (IPRINT.EQ.1)
     *        WRITE(6,'(51X,2F10.5,'' [Cl-Pr]'')') SUMCLS,SUMDEL
C
          PROJ_0=ENERG0
          PROJ1B=ENERG1
          PROJ2B=ENERG2
          PROJ_H=ENERG1+ENERG2
C
          RETURN
C
      END IF
C
C=======================================================================
C
      IF (IPRINT.EQ.1) THEN
C
          WRITE(6,'(/,9X,''Minimisation over all '',
     *                   ''the v2-coefficients'')')
C
          WRITE(6,'(/,'' LEV   ESPAIR   V2pure   V2proj   R11/R00  '',
     *            '' DeltaV2    DeltaE'',/)')
C
      END IF
C
C     Below: DELTAE denotes an auxiliary parameter giving the differs.
C            between 'classical' summation of 2*v2*e and an analogous
C            expression  containing ratios  of the residuum integrals.
C
C            Similarly, DELTAV is an auxiliary measure of the differs.
C            between the total occupation - with and without residuum
C                                                    integral  ratios
      SUMDEL=0
      SUM_V2=0
      DO IENERG=1,LDPAIR
         DELTAE=2*V2PROJ(IENERG)*ESPAIR(IENERG)
     *         -2*V2PROJ(IENERG)*ESPAIR(IENERG)*R11SUM(IENERG)/R00SUM
         DELTAV=V2PROJ(IENERG)-V2PROJ(IENERG)*R11SUM(IENERG)/R00SUM
         SUMDEL=SUMDEL+DELTAE
         SUM_V2=SUM_V2+DELTAV
C
	 IF (IPRINT.EQ.1) THEN
C
             WRITE(6,'(I3,f10.5,2f9.5,3f10.5)')
     *             IENERG,ESPAIR(IENERG),
     *                    V2PROJ(IENERG),
     *                    V2PROJ(IENERG)*R11SUM(IENERG)/R00SUM,
     *                                   R11SUM(IENERG)/R00SUM,
     *                                          DELTAV, DELTAE
C
         END IF
C
      END DO
C
      IF (IPRINT.EQ.1) THEN
C
          WRITE(6,'(41X,20(''-''))')
          WRITE(6,'(41X,F10.5,F10.5)') SUM_V2,SUMDEL
C
      END IF
C
      PROJ_0=ENERG0
      PROJ1B=ENERG1
      PROJ2B=ENERG2
      PROJ_H=ENERG1+ENERG2
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C=======================================================================
C
      SUBROUTINE WS_DERIVH(LDPAIR,PROJ_E,DERIVS)
C=======================================================================
      USE params
C=======================================================================
      DIMENSION
     *          R10SUM(1:NDPAIR),R20SUM(1:NDPAIR,1:NDPAIR),
     *          R11SUM(1:NDPAIR),R21SUM(1:NDPAIR,1:NDPAIR),
     *                           R22SUM(1:NDPAIR,1:NDPAIR)
      DIMENSION
     *          TOTAL1(1:NDPAIR),TOTAL2(1:NDPAIR),
     *          DENER1(1:NDPAIR),DENER2(1:NDPAIR),
     *          DERIVS(1:NDPAIR),DERR00(1:NDPAIR)
      DIMENSION
     *          AUXMAT(1:NDPAIR,1:NDPAIR)
      DIMENSION
     *          AUXVEC(1:NDPAIR)
C
      COMMON
     *       /PNPROJ_RESIDU/ R22SUM,R21SUM,R20SUM,R11SUM,R10SUM,R00SUM
      COMMON
     *       /PNPROJ_PROJEN/ V2PROJ(1:NDPAIR),U2PROJ(1:NDPAIR),
     *                       SQRTV2(1:NDPAIR),SQRTU2(1:NDPAIR)
      COMMON
     *       /PNPROJ_SINGLP/ ESPAIR(1:NDPAIR),STDDEL(1:NDPAIR)
      COMMON
     *       /PNPROJ_PAIRIG/ G_MATR(1:NDPAIR,1:NDPAIR),GACTIV
      COMMON
     *       /PNPROJ_ECONTR/ ENERG0,ENERG1,ENERG2
C
C=======================================================================
C
C        This subroutine calculates the derivatives of the expectation
C        value of the mean-field plus state-dependent pairing Hamiltnn
C        with respect to the occupation coefficients v_nu
C
C=======================================================================
C
      DO IENERG=1,LDPAIR
         AUXVEC(IENERG)=SQRT(V2PROJ(IENERG)*U2PROJ(IENERG))
      END DO
C
C=======================================================================
C        DERIVATIVES OF THE ONE-BODY HAMILTONIANC over v_nu
C=======================================================================
C
      DO NUINDX=1,LDPAIR
         SUMDER=0
         DO MINDEX=1,LDPAIR
            DERENE=ESPAIR(MINDEX)*(R11SUM(NUINDX)-R21SUM(NUINDX,MINDEX))
            SUMDER=SUMDER+DERENE
         END DO
         DENER1(NUINDX)=4*SUMDER*SQRTV2(NUINDX)
      END DO
C
C=======================================================================
C        Calculating the derivative of the R00 term over v_nu
C=======================================================================
C
      DO NUINDX=1,LDPAIR
         DERR00(NUINDX)=2*SQRTV2(NUINDX)*(R11SUM(NUINDX)-R10SUM(NUINDX))
      END DO
C
C=======================================================================
C
      DO NUINDX=1,LDPAIR
         TOTAL1(NUINDX)=(DENER1(NUINDX)*R00SUM
     *                  -DERR00(NUINDX)*ENERG1*R00SUM)/R00SUM**2
      END DO
C
C=======================================================================
C        DERIVATIVES OF THE TWO-BODY HAMILTONIAN over v_nu
C=======================================================================
C
      DO MINDEX=1,LDPAIR
         DO NUINDX=1,LDPAIR
            AUXMAT(MINDEX,NUINDX)=0
         END DO
      END DO
C
C
      DO MINDEX=1,LDPAIR
         DO NUINDX=1,LDPAIR
            IF (MINDEX.EQ.NUINDX) GO TO 1
            SUMRES=0
            DO NINDEX=1,LDPAIR
               IF (MINDEX.NE.NINDEX) THEN
                   R32R31=(R21SUM(NINDEX,NUINDX)-R21SUM(MINDEX,NUINDX))
     *                   /(U2PROJ(NINDEX)-U2PROJ(MINDEX))
               ELSE
                   R32R31=0
               END IF
               IF (MINDEX.EQ.NUINDX.OR.NINDEX.EQ.NUINDX) THEN
                   R32R31=0
               END IF
               SUMMAN=G_MATR(MINDEX,NINDEX)*AUXVEC(NINDEX)*R32R31
               SUMRES=SUMRES+SUMMAN
            END DO
            AUXMAT(MINDEX,NUINDX)=SUMRES
   1        CONTINUE
         END DO
      END DO
C
      DO NUINDX=1,LDPAIR
C
         TERM_1=(U2PROJ(NUINDX)-V2PROJ(NUINDX))/SQRTU2(NUINDX)
     *                                         *STDDEL(NUINDX)*2
C
C        Below, we calculate the contribution from the diagonal
C        matrix elements of the pairing matrix G_{m,m}; for the
C        monopole pairing, the corresponding contribution turns
C        out to be constant, and thus the related derivative is
C                                                          zero.
         TERM_2=0
         DO MINDEX=1,LDPAIR
            TERM_2=TERM_2+G_MATR(MINDEX,MINDEX)*(R11SUM(NUINDX)
     *                                          -R21SUM(MINDEX,NUINDX))
         END DO
         TERM_2=2*TERM_2*SQRTV2(NUINDX)
C
         TERM_3=0
         DO MINDEX=1,LDPAIR
            SUMMAN=AUXVEC(MINDEX)*AUXMAT(MINDEX,NUINDX)
            SUMMAN=AUXVEC(MINDEX)*AUXMAT(NUINDX,MINDEX)
            IF (NUINDX.NE.MINDEX) THEN
                TERM_3=TERM_3+SUMMAN
            END IF
         END DO
         TERM_3=2*TERM_3*SQRTV2(NUINDX)
C
         DENER2(NUINDX)=TERM_1+TERM_2+TERM_3
         TOTAL2(NUINDX)=(DENER2(NUINDX)*R00SUM
     *                  -DERR00(NUINDX)*ENERG2*R00SUM)/R00SUM**2
      END DO
C
      DO NUINDX=1,LDPAIR
         DERIVS(NUINDX)=TOTAL1(NUINDX)+TOTAL2(NUINDX)
      END DO
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C=======================================================================
C
      SUBROUTINE WS_DFPMIN(XMINIM,LDIMEN,TOLGRD,ITRMAX,FMINIM,NDMPNP,
     *                     NDSPNP,STEPMX,TOLFUN,EPSMIN,GRADNM,GRADLM,
     *               WS_FONCTI,WS_DFONCT,IABORT,NOUTPT,HESSIN,HESGRA,
     *                            DIRECT,GRAOLD,GRADIE,XP_NEW,FRACTI)
      EXTERNAL
     *          WS_FONCTI,WS_DFONCT
C
      LOGICAL
     *          CHEKNG
C
      DIMENSION
     *          HESSIN(1:NDSPNP,1:NDSPNP),HESGRA(1:NDSPNP)
      DIMENSION
     *          DIRECT(1:NDSPNP),GRAOLD(1:NDSPNP)
      DIMENSION
     *          XMINIM(1:NDMPNP),GRADIE(1:NDMPNP)
      DIMENSION
     *          XP_NEW(1:NDSPNP)
C
C=======================================================================
C
C       This subroutine minimizes the function FUNC according to the
C       Broyden-Fletcher-Goldfarb-Shanno (BFGS) method.
C
C     Meaning of some parameters:
C
C       XMINIM - On entry the starting point of the procedure; it is
C                a vector of length N;
C
C                On exit: the location of the minimum
C
C       TOLGRD - Parameter that measures a distance from the minimum;
C                At the the minimum, the gradient vanishes, and this
C                property is used to stop the iterations if
C
C                            gradient_length < TOLGRD
C
C       FMINIM - the minimum value of the function
C
C       IABORT - a parameter that is used to force exiting the code in
C                some selected cases. This parameter is set up when
C                calcualting the function (or its derivative). Therefore
C                if is not, the procedure will go as in the textbooks.
C
C     Precision control parameters
C
C       ITRMAX - The maximum number of iterations allowed;
C
C       STPMAX - The maximum length of steps step allowed
C                when performing the line searches
C
C=======================================================================
C
      IABORT=0
C
      IF (NDMPNP.NE.NDSPNP) THEN
          WRITE(6,'(/,''NDMPNP='',I3,'' must be equal NDSPNP='',I3)')
     *                  NDMPNP,                       NDSPNP
          STOP 'Inconsistent matrix declaration in DFPMIN - '
      END IF
C
      IF (LDIMEN.GT.NDSPNP) THEN
          WRITE(6,'(/,''LDIMEN='',I3,''  greater than NDSPNP='',I3)')
     *                  LDIMEN,                       NDSPNP
          STOP 'Inconsistent use of LDIMEN in DFPMIN - '
      END IF
C
      TOLERX=4.0*EPSMIN
C
C=======================================================================
C      Calculating the initial value FUNCVA of the function at
C      point XMINIM.
C=======================================================================
C
      FUNCVA=WS_FONCTI(XMINIM,NDMPNP,IABORT)
C
      IF (IABORT.EQ.1) RETURN
C
C=======================================================================
C      The next instruction allows to write something in the output
C      if one exits before the normal end of the subroutine
C=======================================================================
C
      FMINIM=FUNCVA
      FUNOLD=FUNCVA
C
C=======================================================================
C       Calculating the initial gradient GRADIE at point XMINIM
C=======================================================================
C
      CALL WS_DFONCT(XMINIM,NDMPNP,GRADIE,GRADNM)
C
C=======================================================================
C       If the number of iterations exceeded...
C=======================================================================
C
      IF (IABORT.EQ.1) THEN
C
          WRITE(NOUTPT,'(/,80(''!''),/,''!'',78X,''!'',/,
     *         ''!  The number of [out of range] values '',
     *         ''exceeded in WS_DFONCT, called in DFPMIN !'',/,
     *         ''!'',78X,''!'',/,80(''!''))')
C
          RETURN
C
      END IF
C
C=======================================================================
C         Initializing the inverse Hessian to the unit matrix
C=======================================================================
C
      DO J=1,LDIMEN
         DO I=1,LDIMEN
            HESSIN(I,J)=0.0
         END DO
      END DO
C
      SUMMAT=0.0
      SUMGRD=0.0
      DO J=1,LDIMEN
         HESSIN(J,J)=1.0
         DIRECT(J)=-GRADIE(J)
         SUMGRD=SUMGRD+ABS(DIRECT(J))
         SUMMAT=SUMMAT+XMINIM(J)**2
      END DO
C
C=======================================================================
C
      STPMAX=STEPMX*MAX(SQRT(SUMMAT),REAL(LDIMEN))
C
C=======================================================================
C
      DO ITERAT=1,ITRMAX
C
         CALL WS_LNSRCH(LDIMEN,NDSPNP,XMINIM,FUNCVA,GRADIE,DIRECT,
     *                  XP_NEW,FMINIM,STPMAX,CHEKNG,TOLFUN,TOLERX,
     *                   IABORT,NOUTPT,WS_FONCTI,WS_DFONCT,FRACTI)
C
         IF (IABORT.EQ.1) RETURN
C
C         Updating the line direction and the current point
C
         FUNCVA=FMINIM
C
         DO I=1,LDIMEN
            DIRECT(I)=XP_NEW(I)-XMINIM(I)
            XMINIM(I)=XP_NEW(I)
         END DO
C
C         Test for convergence on Delta X
C
         TEST=0.0
         DO I=1,LDIMEN
            TEMP=ABS(DIRECT(I))/MAX(ABS(XMINIM(I)),1.0)
            IF (TEMP.GT.TEST) TEST=TEMP
         END DO
C
         IF (TEST.LT.TOLERX) THEN
C
             CALL WS_DFONCT(XMINIM,NDMPNP,GRADIE,GRADNM)
C
             IF (IABORT.EQ.1) THEN
C
                 WRITE(NOUTPT,'(/,80(''!''),/,''!'',78X,''!'',/,
     *             ''!  After WS_DFONCT1- the number of [out '',
     *             ''of range] values exceeded, from DFPMIN !'',/,
     *             ''!'',78X,''!'',/,80(''!''))')
             END IF
C
             RETURN
C
         END IF
C
C         Saving the old value of the gradient in GRAOLD()
C
         DO I=1,LDIMEN
            GRAOLD(I)=GRADIE(I)
         END DO
C
C         Calculating the new value of the gradient GRADIE
C
         CALL WS_DFONCT(XMINIM,NDMPNP,GRADIE,GRADNM)
C
C         ... the number of iterations exceeded
C
         IF (IABORT.EQ.1) THEN
C
             WRITE(NOUTPT,'(/,80(''!''),/,''!'',78X,''!'',/,
     *             ''!  After WS_DFONCT2- the number of [out '',
     *             ''of range] values exceeded, from DFPMIN !'',/,
     *             ''!'',78X,''!'',/,80(''!''))')
C
             RETURN
C
         END IF
C
C=======================================================================
C
         TEST=0.0
C
         DEN=MAX(FMINIM,1.)
C
         DO I=1,LDIMEN
            TEMP=ABS(GRADIE(I))*MAX(ABS(XMINIM(I)),1.0)/DEN
            IF (TEMP.GT.TEST) TEST=TEMP
         END DO
C
         IF (TEST.LT.TOLGRD)  RETURN
C
C=======================================================================
C
         DO I=1,LDIMEN
            GRAOLD(I)=GRADIE(I)-GRAOLD(I)
         END DO
C
         DO I=1,LDIMEN
            HESGRA(I)=0.
            DO J=1,LDIMEN
               HESGRA(I)=HESGRA(I)+HESSIN(I,J)*GRAOLD(J)
            END DO
         END DO
C
         FAC=0.0
         FAE=0.0
         SUMDG=0.0
         SUMXI=0.0
C
         DO I=1,LDIMEN
            FAC=FAC+GRAOLD(I)*DIRECT(I)
            FAE=FAE+GRAOLD(I)*HESGRA(I)
            SUMDG=SUMDG+GRAOLD(I)**2
            SUMXI=SUMXI+DIRECT(I)**2
         END DO
C
C=======================================================================
C
         IF ((FAC**2).GT.EPSMIN*SUMDG*SUMXI) THEN
C
             FAC=1.0/FAC
             FAD=1.0/FAE
C
             DO I=1,LDIMEN
                GRAOLD(I)=FAC*DIRECT(I)-FAD*HESGRA(I)
             END DO
C
C             BFGS updating formula
C
             DO I=1,LDIMEN
                DO J=1,LDIMEN
                   HESSIN(I,J)=HESSIN(I,J)+FAC*DIRECT(I)*DIRECT(J)-
     *                                     FAD*HESGRA(I)*HESGRA(J)+
     *                                     FAE*GRAOLD(I)*GRAOLD(J)
                END DO
             END DO
C
         END IF
C
C         One calculates here the new direction to go
C
         DO I=1,LDIMEN
            DIRECT(I)=0.
            DO J=1,LDIMEN
               DIRECT(I)=DIRECT(I)-HESSIN(I,J)*GRADIE(J)
            END DO
         END DO
C
      END DO
C
C=======================================================================
C
      IF (ITERAT.GE.ITRMAX) THEN
C
          WRITE(NOUTPT,'(/,80(''!''),''!'',78X,''!'',/,
     *          ''!   The number of internal iterations in '',
     *          ''DFPMIN, ITERAT='',I2,'' reached ITRMAX='',I2,
     *          ''   !'',/,''!'',78X,''!'',/,80(''!''))') ITERAT,
     *                                                    ITRMAX
C
      END IF
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C=======================================================================
C
      SUBROUTINE WS_LNSRCH(LDIMEN,NDIMEN,XP_OLD,FUNOLD,GRADIE,DIRNWT,
     *                     XP_NEW,FUNNEW,STPMAX,CHEKNG,TOLFUN,TOLDLX,
     *                      IABORT,NOUTPT,WS_FONCTI,WS_DFONCT,FRACTI)
C
      LOGICAL
     *          CHEKNG
C
      EXTERNAL
     *          WS_FONCTI,WS_DFONCT
C
      DIMENSION
     *          GRADIE(1:NDIMEN),DIRNWT(1:NDIMEN),XP_NEW(1:NDIMEN),
     *                                            XP_OLD(1:NDIMEN)
C
C=======================================================================
C
C        In this subroutine, one moves along a line towards the minimum
C        that is given by the Newton (gradient) direction; next an opti-
C        mum point is sought to define a new iteration point.
C
C        Meaning of some parameters:
C
C        XP_OLD - this is the N-dimensional starting point (a vector of
C                 length N)
C
C        FUNOLD - the value of the function  at point XP_OLD (a scalar)
C
C        GRADIE - a vector  containing the N partial derivatives of the
C                 function at point XP_XOLD - (the gradient of the mini-
C                 mised function)
C
C        DIRNWT - a storage containing the coordinates of a vector that
C                 gives the new direction in the next step
C
C        XP_NEW - a new current point, given by:
C
C                       X = Xold + lambda * P;
C
C                 the difficulty is to find the "good" lambda
C
C        FUNNEW - the new value of the function at point XP_NEW
C
C        STPMAX - this parameter limits the length of the step searches
C                 so that one does not try to evaluate the functions in
C                 regions where they are ill-defined in the present con-
C                 text
C
C        CHEKNG - logical variable that should have value  FALSE on the
C                 normal exit.  If the new point XP_NEW is too close to
C                 XP_OLD then CHEKNG=.TRUE.
C
C=======================================================================
C
C        TOLFUN - This parameter controlls the conditions of a decrease
C                 in function the values.  The highest TOLFUN, the more
C                 drastic is the criterion on a decrease.  If it is too
C                 large,  one runs the risk to fail to passing over the
C                 very first step.
C
C        TOLDLX - convergence criterion on Delta.X
C
C=======================================================================
C
      CHEKNG=.FALSE.
C
      ALAM2=0.0
      F2=0.0
      FOLD2=0.0
C
      TMPLAM=1.0
      ALAMMN=1.0
C
C=======================================================================
C       One scales the step if it is too large (at least greater than
C       STPMAX)
C=======================================================================
C
      SUMNWT=0.0
      DO I=1,LDIMEN
        SUMNWT=SUMNWT+DIRNWT(I)*DIRNWT(I)
      END DO
C
                              SUMNWT=SQRT(SUMNWT)
      IF (ABS(SUMNWT).EQ.0.0) SUMNWT=1.0E-9
C
      IF (SUMNWT.GT.STPMAX) THEN
          DO I=1,LDIMEN
             DIRNWT(I)=DIRNWT(I)*STPMAX/SUMNWT
          END DO
      END IF
C
      SLOPE=0.0
      DO I=1,LDIMEN
         SLOPE=SLOPE+GRADIE(I)*DIRNWT(I)
      END DO
C
      TEST=0.0
      DO I=1,LDIMEN
         TEMP=ABS(DIRNWT(I))/MAX(ABS(XP_OLD(I)),1.)
         IF (TEMP.GT.TEST) TEST=TEMP
      END DO
C
      ALAMIN=TOLDLX/TEST
      ALAMBD=1.0000
C
C        As a first step, one always tries to make a full Newton step,
C        so lambda = 1 (ALAMBD = 1)
C
   1  CONTINUE
C
C=======================================================================
C        Calculating the new point X such that X = Xold+lambda*P
C        and the function value at this point: F = func(X)
C=======================================================================
C
      DO I=1,LDIMEN
         XP_NEW(I)=XP_OLD(I)+ALAMBD*DIRNWT(I)
      END DO
C
      FUNNEW=WS_FONCTI(XP_NEW,NDIMEN,IABORT)
C
      IF (IABORT.EQ.1) RETURN
C
C=======================================================================
C      First case: lambda < lambda_min. This is one condition to return.
C=======================================================================
C
      IF (ALAMBD.LT.ALAMIN) THEN
C
          DO I=1,LDIMEN
             XP_NEW(I)=XP_OLD(I)
          END DO
C
          CHEKNG=.TRUE.
C
          RETURN
C
C        The decrease of the function is sufficient, one returns.
C
      ELSE IF (FUNNEW.LE.(FUNOLD+TOLFUN*ALAMBD*SLOPE)) THEN
C
          RETURN
C
      ELSE
C
C        If a decrease of the function is NOT suffiently fast, one will
C        try to find another point on the Newton line (=> backtracking).
C        The first step is to calculate:
C
C                                       g'(0)
C                  lambda = -  ----------------------
C                              2[g(1) - g(0) - g'(0)]
C
          IF (ABS(ALAMBD-1.0).LT.1.0E-12) THEN
C
              DIFAUX=FUNNEW-FUNOLD-SLOPE
C
              IF (ABS(DIFAUX).EQ.0.0) THEN
                  DIFAUX=1.0e-9
              END IF
C
              TMPLAM=-SLOPE/(2.0*DIFAUX)
C
          ELSE
C
C             If the new  LAMBDA  obtained just above is not sufficient
C             to make the function decrease as required, then one tries
C             another expression (see the notes):
C
              RHS1=FUNNEW-FUNOLD-ALAMBD*SLOPE
              RHS2=F2-FOLD2-ALAM2*SLOPE
C
              A=(RHS1/ALAMBD**2-RHS2/ALAM2**2)/(ALAMBD-ALAM2)
C
              B=(-ALAM2*RHS1/ALAMBD**2+ALAMBD*RHS2/ALAM2**2)/
     *          (ALAMBD-ALAM2)
C
              IF (ABS(A).LT.1.E-12) THEN
                  TMPLAM=-SLOPE/(2.0*B)
              ELSE
C
                  DISCRI=B*B-3.0*A*SLOPE
C
                  IF (DISCRI.LT.0.0) THEN
                      DISCRI=-DISCRI
                  END IF
C
                  TMPLAM=(-B+SQRT(DISCRI))/(3.0*A)
C
              END IF
C
              IF (TMPLAM.GT.0.5*ALAMBD) TMPLAM=0.5*ALAMBD
C
          END IF
C
      END IF
C
      ALAM2=ALAMBD
      F2=FUNNEW
      FOLD2=FUNOLD
      ALAMMN=FRACTI*ALAMBD
      ALAMBD=MAX(TMPLAM,ALAMMN)
C
      GO TO 1
C
      END
C
