C FILE NAME = wsu05_labs_04.f   ! Keep this symbol here: $ident@string$
C
C=======================================================================
C=======================================================================
C=====                                ==================================
C=====   LABELS AND BASES TRANSFORM   ==================================
C=====                                ==================================
C=======================================================================
C=======================================================================
C
      SUBROUTINE WS_LBKARR(ISOSPI,EMINST,EMAXST,RAUXIL,RWAVEF,OMEGAC,
     *                                                 IREVER,RYTEXT)
C=======================================================================
      USE params
C=======================================================================
C
      CHARACTER
     *          SPKART*10,SPNILS*15,SPORDE*13,SPORDR*17
      CHARACTER
     *          CARTLB*10,NILLAB*15,IRRLB1*2,IRRLB2*2
      CHARACTER
     *          RYTEXT(0:NDREVE)*5
      CHARACTER
     *          STRNP1*5,STRNP2*5
C
      DIMENSION
     *          RWAVEF(1:NDBASE,1:NDBASE),
     *          RAUXIL(1:NDBASE,1:NDBASE),
     *          HELPER(1:NDBASE,1:NDBASE)
C
      COMMON
     *       /SPECTR_ESINGP/ ESINGP(1:NDBASE),PARITY(1:NDBASE)
      COMMON
     *       /LBKART_CARTLB/ CARTLB(1:NDBASE),NILLAB(1:NDBASE)
      COMMON
     *       /LBKARR_SPLABS/ SPKART(1:NDBASE,0:NDREVE),
     *                       SPNILS(1:NDBASE,0:NDREVE),
     *                       SPORDE(1:NDBASE,0:NDREVE),
     *                       SPORDR(1:NDBASE,0:NDREVE)
     *       /LBKARR_BASCAR/ NXCART(1:NDBASE,0:NDREVE),
     *                       NYCART(1:NDBASE,0:NDREVE),
     *                       NZCART(1:NDBASE,0:NDREVE)
     *
     *       /LBKARR_QUOCAR/ QUOTCA(1:NDBASE,0:NDREVE)
     *
     *       /LBKARR_ALIGNS/ ALIGNJ(1:NDBASE),
     *                       ALIGNL(1:NDBASE),
     *                       ALIGNS(1:NDBASE)
      COMMON
     *       /MULTIP_SPLEVS/ SPENER(1:NDBASE,0:NDREVE),
     *                       SPALIG(1:NDBASE,0:NDREVE),
     *                       SPSPAL(1:NDBASE,0:NDREVE),
     *                       SPPARI(1:NDBASE,0:NDREVE),
     *                       QUOKAR(1:NDBASE,0:NDREVE),
     *                       QUONIL(1:NDBASE,0:NDREVE)
      COMMON
     *       /SETBAS_NXNYNZ/ NXVECT(1:NDBASE),
     *                       NYVECT(1:NDBASE),
     *                       NZVECT(1:NDBASE)
     *
     *       /SETBAS_DIMENS/ LDBASE
      COMMON
     *       /GRUPTD_REPREZ/ NREPRE(1:NDBASE)
      COMMON
     *       /TETANDOKT_DEF/ IFTETR,IFOKTR
C
      COMMON
     *       /READWRITE_PAR/ NOUTPT,IWRITE,ISCREN
C
C=======================================================================
C
C        This subroutine plays the same role as LBKART, but in the
C        case of the Sx-symmetry; it also calculates and prints the
C        expectation values of <j_x>, <s_x>, etc.
C
C        RAUXIL is a matrix of J_x in the "s"-basis
C
C=======================================================================
C
      CALL WS_CPUTIM('LBKARR',1)
C
C=======================================================================
C
C     We begin by calculating the J_x expectation values.
C     We use Eq.(61) from notes PA
C
C     Below: transposing RWAVEF ...
C
      DO J=1,LDBASE
         DO I=J+1,LDBASE
            R=RWAVEF(I,J)
            C=RWAVEF(J,I)
            RWAVEF(I,J)=C
            RWAVEF(J,I)=R
         END DO
      END DO
C
C     ... and calculating the matrix product
C
      DO L=1,LDBASE
         DO K=1,LDBASE
            HELPER(K,L)=0
         END DO
         DO M=1,LDBASE
            T=RAUXIL(M,L)
            IF (ABS(T).GT.1E-14) THEN
                DO K=1,LDBASE
                   HELPER(K,L)=HELPER(K,L)+T*RWAVEF(K,M)
                END DO
            END IF
         END DO
      END DO
C
C     Now untransposing RWAVEF ...
C
      DO J=1,LDBASE
         DO I=J+1,LDBASE
            R=RWAVEF(I,J)
            C=RWAVEF(J,I)
            RWAVEF(I,J)=C
            RWAVEF(J,I)=R
         END DO
      END DO
C
C     ...and contracting
C
      DO ISTATE=1,LDBASE
         R=0
         DO I=1,LDBASE
            R=R+HELPER(ISTATE,I)*RWAVEF(I,ISTATE)
         END DO
         ALIGNJ(ISTATE)=R
      END DO
C
C     The rest - are expectation values ...
C
      DO ISTATE=1,LDBASE
C
         PARITY(ISTATE)=0
         ALIGNS(ISTATE)=0
C
         AMPMAX=-100
C
C=======================================================================
C        Expectation values of the parity,
C        expectation values of the spin_x
C=======================================================================
C
         DO I_BASE=1,LDBASE
C
            NX=NXVECT(I_BASE)
            NY=NYVECT(I_BASE)
            NZ=NZVECT(I_BASE)
C
            IPARI=1-2*MOD(NX+NY+NZ,2)
            IPARS=1-2*MOD(NX+1,2)
C
            IF (IREVER.EQ.1) IPARS=-IPARS
C
            SQUARE=RWAVEF(I_BASE,ISTATE)**2
C
C           ... and the maximum amplitude among the basis
C           states  I_BASE  for the fixed state  ISTATE
C
            IF (AMPMAX.LT.SQUARE) THEN
C
                AMPMAX=SQUARE
                INDMAX=I_BASE
C
            END IF
C
            PARITY(ISTATE)=PARITY(ISTATE)+IPARI*SQUARE
C
C           Here Eqs.(59) and (60) from notes PA
C
            ALIGNS(ISTATE)=ALIGNS(ISTATE)+IPARS*SQUARE
C
         END DO
C
         ALIGNS(ISTATE)=0.5*ALIGNS(ISTATE)
C
C=======================================================================
C        Calculating the standard Cartesian labels
C=======================================================================
C
         NXDOMI=NXVECT(INDMAX)
         NYDOMI=NYVECT(INDMAX)
         NZDOMI=NZVECT(INDMAX)
C
         NXCART(ISTATE,IREVER)=NXDOMI
         NYCART(ISTATE,IREVER)=NYDOMI
         NZCART(ISTATE,IREVER)=NZDOMI
C
         WRITE(CARTLB(ISTATE),'(''|'',I2,'','',I2,'','',I2,''>'')')
     *                                NXDOMI  ,NYDOMI  ,NZDOMI
C
         QUOTCA(ISTATE,IREVER)=AMPMAX
C
      END DO
C
C=======================================================================
C     Storing the single-particle results (expectation values)
C=======================================================================
C
      DO ISTATE=1,LDBASE
         SPALIG(ISTATE,IREVER)=ALIGNJ(ISTATE)
         SPSPAL(ISTATE,IREVER)=ALIGNS(ISTATE)
         SPPARI(ISTATE,IREVER)=PARITY(ISTATE)
         SPKART(ISTATE,IREVER)=CARTLB(ISTATE)
         QUOKAR(ISTATE,IREVER)=QUOTCA(ISTATE,IREVER)
      END DO
C
C=======================================================================
C     The amplitudes correspond to maximising in the expansion
C     into the  basis  | nx(i),ny(i),nz(i); spin(i) > as whole
C     or simply "standard label"    (Cartesian wave-functions)
C=======================================================================
C
      IF (IWRITE.GE.1) THEN
C
          IF (ISOSPI.EQ.0) THEN
C
              IF (IWRITE.GE.1)
     *            WRITE(NOUTPT,'(//,80(''#''),/,''#'',78X,''#'',/,
     *            ''#    NEUTRONS:       Single Particle -'',
     *            '' Cartesian Labelling      OMEGA='',  F5.3,
     *                                            ''    #'',/,
     *            ''#                                      '',
     *            ''                       (Ry,Ry'''')='',A5,
     *                                                ''   #'',/,
     *                            80(''#''),/,''#'',78X,''#'',/,
     *            ''#   No)   Energy  (Nx,Ny,Nz) Ir < P%>      '',
     *            ''No)   Energy  (Nx,Ny,Nz)    < P%>   #'',/,
     *            ''#'',78X,''#'')')  OMEGAC,RYTEXT(IREVER)
C
          ELSE
C
              IF (IWRITE.GE.1)
     *            WRITE(NOUTPT,'(//,80(''#''),/,''#'',78X,''#'',/,
     *            ''#    PROTONS:        Single Particle -'',
     *            '' Cartesian Labelling      OMEGA='',F5.3,
     *                                            ''    #'',/,
     *            ''#                                      '',
     *            ''                       (Ry,Ry'''')='',A5,
     *                                             ''   #'',/,
     *                            80(''#''),/,''#'',78X,''#'',/,
     *            ''#   No)   Energy  (Nx,Ny,Nz) Ir < P%>      '',
     *            ''No)   Energy  (Nx,Ny,Nz)    < P%>   #'',/,
     *            ''#'',78X,''#'')')  OMEGAC,RYTEXT(IREVER)
C
          END IF
C
      END IF
C
C=======================================================================
C
      KIKOFF=0
      ISTART=1
C
      DO ISTATE=1,LDBASE
         IF (ESINGP(ISTATE).GE.EMINST.AND.
     *       ESINGP(ISTATE).LE.EMAXST) THEN
             KIKOFF=KIKOFF+1
             IF (KIKOFF.EQ.1) ISTART=ISTATE
         END IF
      END DO
C
      KIKOFF=KIKOFF/2-1
C
      IF (ISTART+KIKOFF.GT.LDBASE) THEN
C
          STOP 'ISTART+KIKOFF.GT.LDBASE - IN SPECTR (2) <<= '
C
      END IF
C
      DO L=ISTART,ISTART+KIKOFF
C
         L1=L
         L2=KIKOFF+L+1
C
C=======================================================================
C
c        IPTES1=INT(SIGN(ABS(PARITY(L1))*100+0.49999,PARITY(L1)))
C
         IF (PARITY(L1).GT.0.0) THEN
             IPTES1=INT(PARITY(L1)*100+0.49999)
         ELSE
             IPTES1=INT(PARITY(L1)*100-0.49999)
         END IF
C
C=======================================================================
C
         IF (ABS(IPTES1).NE.100) THEN
C
             WRITE(STRNP1,'(''('',SP,I3,SS,'')'')') IPTES1
C
         END IF
C
         IF (IPTES1.EQ.+100) THEN
C
             WRITE(STRNP1,'(''( + )'')')
C
         END IF
C
         IF (IPTES1.EQ.-100) THEN
C
             WRITE(STRNP1,'(''( - )'')')
C
         END IF
C
C=======================================================================
C
         IF (PARITY(L2).GT.0.0) THEN
             IPTES2=INT(PARITY(L2)*100+0.49999)
         ELSE
             IPTES2=INT(PARITY(L2)*100-0.49999)
         END IF
C
C=======================================================================
C
         IF (ABS(IPTES2).NE.100) THEN
C
             WRITE(STRNP2,'(''('',SP,I3,SS,'')'')') IPTES2
C
         END IF
C
         IF (IPTES2.EQ.+100) THEN
C
             WRITE(STRNP2,'(''( + )'')')
C
         END IF
C
         IF (IPTES2.EQ.-100) THEN
C
             WRITE(STRNP2,'(''( - )'')')
C
         END IF
                                        IRRLB1='--'
                                        IRRLB2='--'
         IF (IFOKTR.GT.0) THEN
             WRITE(IRRLB1,'(''O'',I1)') NREPRE(L1)
             WRITE(IRRLB2,'(''O'',I1)') NREPRE(L2)
         END IF
         IF (IFTETR.GT.0) THEN
             WRITE(IRRLB1,'(''T'',I1)') NREPRE(L1)
             WRITE(IRRLB2,'(''T'',I1)') NREPRE(L2)
         END IF
C
         IF (IWRITE.GE.1)
     *
     *       WRITE(NOUTPT,'(''#  '',I3,'')'',F10.5,'' '',A10,
     *                                 1X,A2,1X,A5,''     '',
     *                              I3,'')'',F10.5,'' '',A10,
     *                                 1X,A2,1X,A5,''   #'')')
     *
     *                 L1,ESINGP(L1),CARTLB(L1),IRRLB1,STRNP1,
     *                 L2,ESINGP(L2),CARTLB(L2),IRRLB2,STRNP2
C
      END DO
C
      IF (IWRITE.GE.1)
     *    WRITE(NOUTPT,'(''#'',78X,''#'',/,80(''#''))')
C
C=======================================================================
C
      CALL WS_CPUTIM('LBKARR',0)
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C=======================================================================
C
      SUBROUTINE WS_LBKART(IZ_FIX,IN_FIX,ISOSPI,EMINST,EMAXST,KARTLB,
     *                     KARWAV,MAXXYZ,MAXWAV,EMINWF,EMAXWF,OMEGAC,
     *                                                 IREVER,RYTEXT)
C=======================================================================
      USE params
C=======================================================================
C
      CHARACTER
     *          LABXYZ*10,CARTLB*10,NILLAB*15
      CHARACTER
     *          SPKART*10,SPNILS*15,SPORDE*13,SPORDR*17
      CHARACTER
     *          RYTEXT(0:NDREVE)*5
      CHARACTER
     *          STRNP1*5,STRNP2*5
      CHARACTER
     *          IRRLB1*2,IRRLB2*2
C
      COMPLEX
     *          EWAVEF
C
      DIMENSION
     *          AMPLT2(1:NDDOUB),NSTATE(1:NDDOUB)
      DIMENSION
     *          AMPAUX(0:NDMAIN),PRIVEC(0:NDPR14)
      DIMENSION
     *          AMPLX2(1:NDBASE,0:NDMAIN),
     *          AMPLY2(1:NDBASE,0:NDMAIN),
     *          AMPLZ2(1:NDBASE,0:NDMAIN)
      DIMENSION
     *          NCHACT(0:NDBASE)
      DIMENSION
     *          LABXYZ(1:NDBASE)
C
      COMMON
     *       /SPECTR_ESINGP/ ESINGP(1:NDBASE),PARITY(1:NDBASE)
     *       /SPECTR_SPINOR/ EWAVEF(1:NDBASE,1:NDBASE)
      COMMON
     *       /LBKART_CARTLB/ CARTLB(1:NDBASE),NILLAB(1:NDBASE)
      COMMON
     *       /LBKARR_BASCAR/ NXCART(1:NDBASE,0:NDREVE),
     *                       NYCART(1:NDBASE,0:NDREVE),
     *                       NZCART(1:NDBASE,0:NDREVE)
     *
     *       /LBKARR_QUOCAR/ QUOTCA(1:NDBASE,0:NDREVE)
     *
     *       /LBKARR_SPLABS/ SPKART(1:NDBASE,0:NDREVE),
     *                       SPNILS(1:NDBASE,0:NDREVE),
     *                       SPORDE(1:NDBASE,0:NDREVE),
     *                       SPORDR(1:NDBASE,0:NDREVE)
     *
     *       /LBKARR_ALIGNS/ ALIGNJ(1:NDBASE),
     *                       ALIGNL(1:NDBASE),
     *                       ALIGNS(1:NDBASE)
      COMMON
     *       /MULTIP_SPLEVS/ SPENER(1:NDBASE,0:NDREVE),
     *                       SPALIG(1:NDBASE,0:NDREVE),
     *                       SPSPAL(1:NDBASE,0:NDREVE),
     *                       SPPARI(1:NDBASE,0:NDREVE),
     *                       QUOKAR(1:NDBASE,0:NDREVE),
     *                       QUONIL(1:NDBASE,0:NDREVE)
      COMMON
     *       /SETBAS_NOSMAX/ MAXBNX,MAXBNY,MAXBNZ,
     *                                     NOSMAX
     *
     *       /SETBAS_NXNYNZ/ NXVECT(1:NDBASE),
     *                       NYVECT(1:NDBASE),
     *                       NZVECT(1:NDBASE)
     *
     *       /SETBAS_DIMENS/ LDBASE
      COMMON
     *       /GRUPTD_REPREZ/ NREPRE(1:NDBASE)
      COMMON
     *       /TETANDOKT_DEF/ IFTETR,IFOKTR
C
      COMMON
     *       /READWRITE_PAR/ NOUTPT,IWRITE,ISCREN
C
C=======================================================================
C
C     This subroutine  calculates the Cartesian labels of the W.S.
C     eigenstates as well as the Cartesian basis decomposition of
C     the corresponding eigenfunctions (optionally) for both  the
C     static and the rotational cases
C
C=======================================================================
C
C     KARTLB - IF .EQ.1 =>> Energies with  the |Nx,Ny,Nz>  labels
C                                               will be tabulated
C
C     KARWAV - IF .EQ.1 =>> A table of the wave functions will be
C                           produced with the first 10 |Nx,Ny,Nz>
C
C     MAXXYZ - IF .EQ.1 =>> Energies with the maximum content  of
C                           the N_x, N_y and N_z quanta are tabtd.
C
C     MAXWAV - IF .EQ.1 =>> A table of the wave functions labeled
C                           analogously to the "MAXXYZ" case will
C                           be printed
C
C=======================================================================
C
      CALL WS_CPUTIM('LBKART',1)
C
C=======================================================================
C
      DO ISTATE=1,LDBASE
C
         DO NX=0,NDMAIN
            AMPLX2(ISTATE,NX)=0.0
         END DO
C
         DO NY=0,NDMAIN
            AMPLY2(ISTATE,NY)=0.0
         END DO
C
         DO NZ=0,NDMAIN
            AMPLZ2(ISTATE,NZ)=0.0
         END DO
C
         DO I_BASE=1,LDBASE
            AMPLT2(I_BASE)=0.0000
            NSTATE(I_BASE)=I_BASE
         END DO
C
         PARITY(ISTATE)=0.0
C
         AMPMAX=-100.
C
C=======================================================================
C        Expectation value of the parity operator: ISTATE=1,LDBASE
C=======================================================================
C
         DO I_BASE=1,LDBASE
C
            NX=NXVECT(I_BASE)
            NY=NYVECT(I_BASE)
            NZ=NZVECT(I_BASE)
C
            SQUARE=EWAVEF(I_BASE,ISTATE)*CONJG(EWAVEF(I_BASE,ISTATE))
C
            AMPLX2(ISTATE,NX)=AMPLX2(ISTATE,NX)+SQUARE
            AMPLY2(ISTATE,NY)=AMPLY2(ISTATE,NY)+SQUARE
            AMPLZ2(ISTATE,NZ)=AMPLZ2(ISTATE,NZ)+SQUARE
C
            AMPLT2(I_BASE)   =SQUARE
C
C           ... and the maximum amplitude over the basis states I_BASE
C           for the fixed state ISTATE
C
            IF (AMPMAX.LT.SQUARE) THEN
C
                AMPMAX=SQUARE
                INDMAX=I_BASE
C
            END IF
C
            NMACT=NX + NY + NZ
            IPARI=(-1.)**NMACT
C
            PARITY(ISTATE)=PARITY(ISTATE)+IPARI*SQUARE
C
         END DO
C
C=======================================================================
C
C        Calculating the maximum content of the quanta in directions
C        x, y, z.  The labels correspond to the amplitude-square=max,
C        but for each component independently.  This  information is
C        not equivalent to that contained in the a s y m p t o t i c
C        Cartesian label, where by definition, the label is given by
C        that |nx,ny,nx> basis-vector, which has the maximum  of the
C        amplitude-square among all I_BASE=1, 2, 3 ... LDBASE states.
C
C=======================================================================
C
         IF (MAXXYZ.EQ.1) THEN
C
             DO NX=0,MAXBNX
                AMPAUX(NX)=AMPLX2(ISTATE,NX)
                NCHACT(NX)=NX
             END DO
C
             CALL WS_ORDER1(AMPAUX,NCHACT,MAXBNX+1,NDMAIN)
C
             NXLABL=NCHACT(MAXBNX)
C
C=======================================================================
C
             DO NY=0,MAXBNY
                AMPAUX(NY)=AMPLY2(ISTATE,NY)
                NCHACT(NY)=NY
             END DO
C
             CALL WS_ORDER1(AMPAUX,NCHACT,MAXBNY+1,NDMAIN)
C
             NYLABL=NCHACT(MAXBNY)
C
C=======================================================================
C
             DO NZ=0,MAXBNZ
                AMPAUX(NZ)=AMPLZ2(ISTATE,NZ)
                NCHACT(NZ)=NZ
             END DO
C
             CALL WS_ORDER1(AMPAUX,NCHACT,MAXBNZ+1,NDMAIN)
C
             NZLABL=NCHACT(MAXBNZ)
C
C=======================================================================
C            Defining the maximium content of quanta - maximising
C            in all the three directions separately
C=======================================================================
C
             WRITE(LABXYZ(ISTATE),'(''|'',I2,'','',I2,'','',I2,''>'')')
     *                                    NXLABL  ,NYLABL  ,NZLABL
C
         END IF
C
C=======================================================================
C        Calculating the standard Cartesian label
C=======================================================================
C
         NXDOMI=NXVECT(INDMAX)
         NYDOMI=NYVECT(INDMAX)
         NZDOMI=NZVECT(INDMAX)
C
         NXCART(ISTATE,IREVER)=NXDOMI
         NYCART(ISTATE,IREVER)=NYDOMI
         NZCART(ISTATE,IREVER)=NZDOMI
C
         WRITE(CARTLB(ISTATE),'(''|'',I2,'','',I2,'','',I2,''>'')')
     *                                NXDOMI  ,NYDOMI  ,NZDOMI
C
         QUOTCA(ISTATE,IREVER)=AMPMAX
C
C        Terminating the do-loop over the WS-states (ISTATE-LOOP) where
C        parity, maximum content labels & standard labels were computed
C
      END DO
C
C=======================================================================
C     Tetrahedral symmetry case: defining the irrep indices
C=======================================================================
C
      CALL WS_GRUPTD(IFTETR)
C
C=======================================================================
C     Oktahedral symmetry case:  defining the irrep indices
C=======================================================================
C
      CALL WS_GRUPOH(IFOKTR)
C
C=======================================================================
C         Storing the single-particle results (expectation values)
C=======================================================================
C
      DO ISTATE=1,LDBASE
         SPALIG(ISTATE,IREVER)=ALIGNJ(ISTATE)
         SPSPAL(ISTATE,IREVER)=ALIGNS(ISTATE)
         SPPARI(ISTATE,IREVER)=PARITY(ISTATE)
         SPKART(ISTATE,IREVER)=CARTLB(ISTATE)
         QUOKAR(ISTATE,IREVER)=QUOTCA(ISTATE,IREVER)
      END DO
C
C=======================================================================
C     Preparing the tables of the spectra and of the wave functions
C=======================================================================
C
      IF (MAXXYZ.EQ.1) THEN
C
C=======================================================================
C         The labelling and structure based on the max. Nx, Ny, and
C         Nz defined individually for each quantum number
C=======================================================================
C
          IF (ISOSPI.EQ.0) THEN
C
              IF (IWRITE.GE.1)
     *
     *            WRITE(NOUTPT,'(//,80(''#''),/,''#'',78X,''#'',/,
     *              ''#    NEUTRONS:  (Maximum Nx, Ny, Nz content)'',
     *              '' - representation;  Omega='',F5.3, ''    #'',/,
     *              ''#                                           '',
     *              ''   H_block =>>> (Ry,Ry'''')='',A5,''     #'',/,
     *                                80(''#''),/,''#'',78X,''#'',/,
     *              ''#    No)  Energy  (Nx,Ny,Nz)   < P%>       '',
     *              ''No)  Energy  (Nx,Ny,Nz)   < P%>     #'',/,
     *              ''#'',78X,''#'')') OMEGAC,RYTEXT(IREVER)
C
          ELSE
C
              IF (IWRITE.GE.1)
     *
     *            WRITE(NOUTPT,'(//,80(''#''),/,''#'',78X,''#'',/,
     *              ''#    PROTONS:   (Maximum Nx, Ny, Nz content)'',
     *              '' - representation;  Omega='',F5.3,''    #'',/,
     *              ''#                                           '',
     *              ''   H_block =>>> (Ry,Ry'''')='',A5,''     #'',/,
     *                                80(''#''),/,''#'',78X,''#'',/,
     *              ''#    No)  Energy  (NX,NY,NZ)   < P%>       '',
     *              ''No)  Energy  (Nx,Ny,Nz)   < P%>     #'',/,
     *              ''#'',78X,''#'')') OMEGAC,RYTEXT(IREVER)
C
          END IF
C
          KIKOFF=0
          ISTART=1
C
          DO ISTATE=1,LDBASE
             IF (ESINGP(ISTATE).GE.EMINST.AND.
     *           ESINGP(ISTATE).LE.EMAXST) THEN
                 KIKOFF=KIKOFF+1
                 IF (KIKOFF.EQ.1) ISTART=ISTATE
             END IF
          END DO
C
          KIKOFF=KIKOFF/2-1
C
          IF (ISTART+KIKOFF.GT.LDBASE) THEN
C
              STOP 'ISTART+KIKOFF.GT.LDBASE - in SPECTR (1) <<= '
C
          END IF
C
          DO L=ISTART,ISTART+KIKOFF
C
             L1=L
             L2=KIKOFF+L+1
C
C=======================================================================
C
             IPTES1=INT(SIGN(ABS(PARITY(L1))*100+0.1,PARITY(L1)))
C
C=======================================================================
C
             IF (ABS(IPTES1).NE.100) THEN
C
                 WRITE(STRNP1,'(''('',SP,I3,SS,'')'')') IPTES1
C
             END IF
C
             IF (IPTES1.EQ.+100) THEN
C
                 WRITE(STRNP1,'(''( + )'')')
C
             END IF
C
             IF (IPTES1.EQ.-100) THEN
C
                 WRITE(STRNP1,'(''( - )'')')
C
             END IF
C
C=======================================================================
C
             IPTES2=INT(SIGN(ABS(PARITY(L2))*100+0.1,PARITY(L2)))
C
C=======================================================================
C
             IF (ABS(IPTES2).NE.100) THEN
C
                 WRITE(STRNP2,'(''('',SP,I3,SS,'')'')') IPTES2
C
             END IF
C
             IF (IPTES2.EQ.+100) THEN
C
                 WRITE(STRNP2,'(''( + )'')')
C
             END IF
C
             IF (IPTES2.EQ.-100) THEN
C
                 WRITE(STRNP2,'(''( - )'')')
C
             END IF
C
C=======================================================================
C
             IF (IWRITE.GE.1)
     *
     *           WRITE(NOUTPT,'(''#   '',I3,'')'',F8.3,''  '',A10,
     *                  ''   '',A5,''      '',
     *                          I3,'')'',F8.3,''  '',A10,
     *                  ''   '',A5,''     #'')')
     *
     *                   L1,ESINGP(L1),LABXYZ(L1),STRNP1,
     *                   L2,ESINGP(L2),LABXYZ(L2),STRNP2
C
          END DO
C
          IF (IWRITE.GE.1)
     *
     *        WRITE(NOUTPT,'(''#'',78X,''#'',/,80(''#''))')
C
      END IF
C
C=======================================================================
C     Printing the tables of the structure of the wave functions
C=======================================================================
C
      IF (MAXWAV.EQ.1.AND.MAXXYZ.EQ.1) THEN
C
C=======================================================================
C         Tables for the wave-functions with the max-xyz convention
C=======================================================================
C
          ICOUNT=0
C
          DO ISTATE=1,LDBASE
C
             IF (ESINGP(ISTATE).GT.EMINWF.AND.
     *           ESINGP(ISTATE).LT.EMAXWF    ) THEN
C
                 ICOUNT=ICOUNT+1
C
                 IF (MOD(ICOUNT+9,10).EQ.0) THEN
C
                     IF (ISOSPI.EQ.0) THEN
C
                         IF (IWRITE.GE.1)
     *
     *                   WRITE(NOUTPT,'(/,80(''#''),/,''#'',78X,''#'',/,
     *                           ''#  NEUTRONS:  Z ='',I3,
     *                           ''  N ='',I3,
     *                           '';   (Nx, Ny, Nz) - Distribution;'',
     *                           ''    Omega='',F4.2,''     #'',/,
     *                           ''#                      '',
     *                           ''                     '',
     *                           ''   H_block =>>> (Ry,Ry'''')='',
     *                           A5,''     #'',/,
     *                           80(''#''),/,''#'',78X,''#'',/,
     *                           80(''#''),/,''#'',78X,''#'')')
     *
     *                           IZ_FIX,IN_FIX,OMEGAC,RYTEXT(IREVER)
C
                     ELSE
C
                         IF (IWRITE.GE.1)
     *
     *                   WRITE(NOUTPT,'(/,80(''#''),/,''#'',78X,''#'',/,
     *                           ''#  PROTONS:   Z ='',I3,
     *                           ''  N ='',I3,
     *                           '';   (Nx, Ny, Nz) - Distribution;'',
     *                           ''    Omega='',F4.2,''     #'',/,
     *                           ''#                      '',
     *                           ''                     '',
     *                           ''   H_block =>>> (Ry,Ry'''')='',
     *                           A5,''     #'',/,
     *                           80(''#''),/,''#'',78X,''#'',/,
     *                           80(''#''),/,''#'',78X,''#'')')
     *
     *                           IZ_FIX,IN_FIX,OMEGAC,RYTEXT(IREVER)
C
                     END IF
C
                 END IF
C
                 IF (IWRITE.GE.1)
     *
     *               WRITE(NOUTPT,'(''#  Energy ='',F8.4,
     *                     ''                             '',
     *                     ''                               #'',/,
     *                     ''#         '',10('' N='',I1,2X),
     *                     '' N ='',I2,1X,''  #'')')
     *
     *                     ESINGP(ISTATE),(J,J=0,10)
C
                 DO I=0,14
                    PRIVEC(I)=0.0
                 END DO
C
                 DO NX=0,MAXBNX
                    PRIVEC(NX)=AMPLX2(ISTATE,NX)
                 END DO
C
                 IF (IWRITE.GE.1)
     *           WRITE(NOUTPT,'(''#'',2X,''|Nx> '',10(F6.3),1X,F6.3,4X,
     *                                                         ''#'')')
     *
     *                                             (PRIVEC(NX),NX=0,10)
C
                 DO NY=0,MAXBNY
                    PRIVEC(NY)=AMPLY2(ISTATE,NY)
                 END DO
C
                 IF (IWRITE.GE.1)
     *           WRITE(NOUTPT,'(''#'',2X,''|Ny> '',10(F6.3),1X,F6.3,4X,
     *                                                         ''#'')')
     *
     *                                             (PRIVEC(NY),NY=0,10)
                 DO NZ=0,MAXBNZ
                    PRIVEC(NZ)=AMPLZ2(ISTATE,NZ)
                 END DO
C
                 IF (IWRITE.GE.1)
     *           WRITE(NOUTPT,'(''#'',2X,''|Nz> '',10(F6.3),1X,F6.3,4X,
     *                                                         ''#'')')
     *
     *                                             (PRIVEC(NZ),NZ=0,10)
                 IF (IWRITE.GE.1)
     *           WRITE(NOUTPT,'(''#'',78X,''#'')')
C
             END IF
C
          END DO
C
          IF (IWRITE.GE.1)
     *        WRITE(NOUTPT,'(''#'',78X,''#'',/,80(''#''))')
C
      END IF
C
C=======================================================================
C
      IF (KARTLB.EQ.1) THEN
C
C=======================================================================
C          The amplitudes correspond to maximising in the expansion
C          into the  basis  | nx(i),ny(i),nz(i); spin(i) > as whole
C          or simply "standard label"    (Cartesian wave-functions)
C=======================================================================
C
           IF (ISOSPI.EQ.0) THEN
C
               IF (IWRITE.GE.1)
     *
     *         WRITE(NOUTPT,'(//,80(''#''),/,''#'',78X,''#'',/,
     *                  ''#    NEUTRONS:       Single Particle -'',
     *                  '' Cartesian Labelling      OMEGA='',  F5.3,
     *                                                  ''    #'',/,
     *                  ''#                                      '',
     *                  ''                       (Ry,Ry'''')='',A5,
     *                                                      ''   #'',/,
     *                                  80(''#''),/,''#'',78X,''#'',/,
     *                  ''#   No)   Energy  (Nx,Ny,Nz) Ir < P%>      '',
     *                  ''No)   Energy  (Nx,Ny,Nz) Ir < P%>   #'',/,
     *                  ''#'',78X,''#'')')  OMEGAC,RYTEXT(IREVER)
C
           ELSE
C
               IF (IWRITE.GE.1)
     *
     *         WRITE(NOUTPT,'(//,80(''#''),/,''#'',78X,''#'',/,
     *                  ''#    PROTONS:        Single Particle -'',
     *                  '' Cartesian Labelling      OMEGA='',F5.3,
     *                                                  ''    #'',/,
     *                  ''#                                      '',
     *                  ''                       (Ry,Ry'''')='',A5,
     *                                                   ''   #'',/,
     *                                  80(''#''),/,''#'',78X,''#'',/,
     *                  ''#   No)   Energy  (Nx,Ny,Nz) Ir < P%>      '',
     *                  ''No)   Energy  (Nx,Ny,Nz) Ir < P%>   #'',/,
     *                  ''#'',78X,''#'')')  OMEGAC,RYTEXT(IREVER)
C
          END IF
C
C=======================================================================
C
          KIKOFF=0
          ISTART=1
C
          DO ISTATE=1,LDBASE
             IF (ESINGP(ISTATE).GE.EMINST.AND.
     *           ESINGP(ISTATE).LE.EMAXST) THEN
                 KIKOFF=KIKOFF+1
                 IF (KIKOFF.EQ.1) ISTART=ISTATE
             END IF
          END DO
C
          KIKOFF=KIKOFF/2-1
C
          IF (ISTART+KIKOFF.GT.LDBASE) THEN
C
              STOP 'ISTART+KIKOFF.GT.LDBASE - in SPECTR (2) <<= '
C
          END IF
C
          DO L=ISTART,ISTART+KIKOFF
C
             L1=L
             L2=KIKOFF+L+1
C
C=======================================================================
C
c            IPTES1=INT(SIGN(ABS(PARITY(L1))*100+0.49999,PARITY(L1)))
C
             IF (PARITY(L1).GT.0.0) THEN
                 IPTES1=INT(PARITY(L1)*100+0.49999)
             ELSE
                 IPTES1=INT(PARITY(L1)*100-0.49999)
             END IF
C
C=======================================================================
C
             IF (ABS(IPTES1).NE.100) THEN
C
                 WRITE(STRNP1,'(''('',SP,I3,SS,'')'')') IPTES1
C
             END IF
C
             IF (IPTES1.EQ.+100) THEN
C
                 WRITE(STRNP1,'(''( + )'')')
C
             END IF
C
             IF (IPTES1.EQ.-100) THEN
C
                 WRITE(STRNP1,'(''( - )'')')
C
             END IF
C
C=======================================================================
C
             IF (PARITY(L2).GT.0.0) THEN
                 IPTES2=INT(PARITY(L2)*100+0.49999)
             ELSE
                 IPTES2=INT(PARITY(L2)*100-0.49999)
             END IF
C
C=======================================================================
C
             IF (ABS(IPTES2).NE.100) THEN
C
                 WRITE(STRNP2,'(''('',SP,I3,SS,'')'')') IPTES2
C
             END IF
C
             IF (IPTES2.EQ.+100) THEN
C
                 WRITE(STRNP2,'(''( + )'')')
C
             END IF
C
             IF (IPTES2.EQ.-100) THEN
C
                 WRITE(STRNP2,'(''( - )'')')
C
             END IF
                                            IRRLB1='--'
                                            IRRLB2='--'
             IF (IFOKTR.GT.0) THEN
                 WRITE(IRRLB1,'(''O'',I1)') NREPRE(L1)
                 WRITE(IRRLB2,'(''O'',I1)') NREPRE(L2)
             END IF
             IF (IFTETR.GT.0) THEN
                 WRITE(IRRLB1,'(''T'',I1)') NREPRE(L1)
                 WRITE(IRRLB2,'(''T'',I1)') NREPRE(L2)
             END IF
C
             IF (IWRITE.GE.1) THEN

                 WRITE(NOUTPT,'(''#  '',I3,'')'',F10.5,'' '',A10,
     *                                     1X,A2,1X,A5,''     '',
     *                                  I3,'')'',F10.5,'' '',A10,
     *                                     1X,A2,1X,A5,''   #'')')
     *
     *                     L1,ESINGP(L1),CARTLB(L1),IRRLB1,STRNP1,
     *                     L2,ESINGP(L2),CARTLB(L2),IRRLB2,STRNP2
C
             END IF
C
          END DO
C
          IF (IWRITE.GE.1)
     *        WRITE(NOUTPT,'(''#'',78X,''#'',/,80(''#''))')
C
      END IF
C
C=======================================================================
C
      IF (KARWAV.EQ.1) THEN
C
C=======================================================================
C         Printing the tables of the structure of the wave functions
C=======================================================================
C
          ICOUNT=0
C
          DO ISTATE=1,LDBASE
C
             IF (ESINGP(ISTATE).GT.EMINWF.AND.
     *           ESINGP(ISTATE).LT.EMAXWF    ) THEN
C
                 DO I_BASE=1,LDBASE
C
                    AMPLT2(I_BASE)=EWAVEF(I_BASE,ISTATE)*
     *                       CONJG(EWAVEF(I_BASE,ISTATE))
C
                    NSTATE(I_BASE)=I_BASE
C
                 END DO
C
                 CALL WS_ORDER1(AMPLT2,NSTATE,LDBASE,NDDOUB)
C
                 PROBAB=0.0
                 DO I_BASE=LDBASE,1,-1
                    PROBAB=PROBAB+AMPLT2(I_BASE)
                 END DO
C
                 NXDOMI=NXVECT(NSTATE(LDBASE))
                 NYDOMI=NYVECT(NSTATE(LDBASE))
                 NZDOMI=NZVECT(NSTATE(LDBASE))
C
                 ICOUNT=ICOUNT+1
C
                 IF (MOD(ICOUNT+9,10).EQ.0) THEN
C
                     IF (ISOSPI.EQ.0) THEN
C
                         IF (IWRITE.GE.1)
     *
     *                   WRITE(NOUTPT,'(/,80(''#''),/,''#'',78X,''#'',/,
     *                        ''#   Neutron Eigenfunctions: Cartesian'',
     *                       '' LABELS                    Omega='',F4.2,
     *                                                     ''     #'',/,
     *                      ''#                                      '',
     *                       ''                       (Ry,Ry'''')='',A5,
     *                                                       ''   #'',/,
     *                                80(''#''))') OMEGAC,RYTEXT(IREVER)
C
                     ELSE
C
                         IF (IWRITE.GE.1)
     *
     *                   WRITE(NOUTPT,'(/,80(''#''),/,''#'',78X,''#'',/,
     *                   ''#   Neutron Eigenfunctions: Cartesian'',
     *                   '' LABELS                    Omega='',F4.2,
     *                                                 ''     #'',/,
     *                   ''#                                      '',
     *                   ''                       (Ry,Ry'''')='',A5,
     *                                                    ''   #'',/,
     *                   80(''#''))') OMEGAC,RYTEXT(IREVER)
C
                     END IF
C
                 END IF
C
                 IF (IWRITE.GE.1) THEN

                     WRITE(NOUTPT,'(''#'',78X,''#'',/,
     *                     ''#   Energy='',F8.4,''  Asq.='',I2,
     *                     ''%; Sum.='',I3,
     *                     ''% |Nx='',I2,'',Ny='',I2,'',Nz='',I2,
     *                     ''>  Parity:<'',SP,I4,SS,''%>   #'',/,
     *                                          ''#'',78X,''#'')')
     *                     ESINGP(ISTATE),
     *                     INT(100*AMPLT2(LDBASE)),
     *                     INT(100*PROBAB),NXDOMI,NYDOMI,NZDOMI,
     *                     INT(100*PARITY(ISTATE))
C
                     WRITE(NOUTPT,'(''#   AMPL. => '',10(I2,''%'',3X),
     *                                         (I2,''%'',2X),'' #'',/,
     *                                              ''#'',78X,''#'')')
     *
     *                             (INT(100*AMPLT2(LDBASE-J)),J=0,10)
C
                     WRITE(NOUTPT,'(''#   |Nx> '',11(I6),4X,''#'')')
     *
     *                             (NXVECT(NSTATE(LDBASE-J)),J=0,10)
C
                     WRITE(NOUTPT,'(''#   |Ny> '',11(I6),4X,''#'')')
     *
     *                             (NYVECT(NSTATE(LDBASE-J)),J=0,10)
C
                     WRITE(NOUTPT,'(''#   |Nz> '',11(I6),4X,''#'')')
     *
     *                             (NZVECT(NSTATE(LDBASE-J)),J=0,10)
                 END IF
C
             END IF
C
          END DO
C
          IF (IWRITE.GE.1)
     *        WRITE(NOUTPT,'(''#'',78X,''#'',/,80(''#''))')
C
      END IF
C
C=======================================================================
C
      CALL WS_CPUTIM('LBKART',0)
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C=======================================================================
C
      SUBROUTINE WS_CYLONL(ISOSPI,NILWAV,EMINST,EMAXST,OMEGAC,ISIGNY,
     *                     NILSLB,IPAORD,IREVER,EMINWF,EMAXWF,RYTEXT)
C=======================================================================
      USE params
C=======================================================================
C
      CHARACTER
     *          SPKART*10,SPNILS*15,SPORDE*13,SPORDR*17
      CHARACTER
     *          CARTLB*10,NILLAB*15
      CHARACTER
     *          RYTEXT(0:NDREVE)*5
      CHARACTER
     *          STRNP1*5,STRNP2*5
      CHARACTER
     *          FORM_A*1,FORM_B*1
C
      COMPLEX
     *          EWAVEF,UNIT_I
      COMPLEX
     *          RES_DW,AUXCYL,WVTRAN
C
C=======================================================================
      ALLOCATABLE RES_DW(:,:,:),AUXCYL(:,:,:),WVTRAN(:,:)
C=======================================================================
C
      DIMENSION
     *          MAINCL(1:NDTVE2),LAMBCL(1:NDTVE2),
     *          IOMECL(1:NDTVE2),NZCLND(1:NDTVE2)
      DIMENSION
     *          AMPLT2(1:NDTVE2),AUXVEC(1:NDTVE2),
     *                           NSTATE(1:NDTVE2)
      DIMENSION
     *          MINDEX(1:NDTVE2),LINDEX(1:NDTVE2)
      DIMENSION
     *          IPAORD(1:NDBASE)
C
      COMMON
     *       /SPECTR_ESINGP/ ESINGP(1:NDBASE),PARITY(1:NDBASE)
     *
     *       /SPECTR_SPINOR/ EWAVEF(1:NDBASE,1:NDBASE)
      COMMON
     *       /LBKART_CARTLB/ CARTLB(1:NDBASE),NILLAB(1:NDBASE)
      COMMON
     *       /LBKARR_SPLABS/ SPKART(1:NDBASE,0:NDREVE),
     *                       SPNILS(1:NDBASE,0:NDREVE),
     *                       SPORDE(1:NDBASE,0:NDREVE),
     *                       SPORDR(1:NDBASE,0:NDREVE)
      COMMON
     *       /TRANSC_BASCLJ/ NBASER(1:NDTRAN,0:NDPARI),
     *                       NBASZP(1:NDTRAN,0:NDPARI),
     *                       NBASEM(1:NDTRAN,0:NDPARI)
      COMMON
     *       /MULTIP_SPLEVS/ SPENER(1:NDBASE,0:NDREVE),
     *                       SPALIG(1:NDBASE,0:NDREVE),
     *                       SPSPAL(1:NDBASE,0:NDREVE),
     *                       SPPARI(1:NDBASE,0:NDREVE),
     *                       QUOKAR(1:NDBASE,0:NDREVE),
     *                       QUONIL(1:NDBASE,0:NDREVE)
      COMMON
     *       /CYLONL_CYLIND/ MAINNL(1:NDBASE,0:NDREVE),
     *                       NZNILS(1:NDBASE,0:NDREVE),
     *                       L_NILS(1:NDBASE,0:NDREVE),
     *                       IOMEGA(1:NDBASE,0:NDREVE)
     *
     *       /CYLONL_QUOCYL/ QUOTCY(1:NDBASE,0:NDREVE)
      COMMON
     *       /SETBAS_PARIND/ INDPAR(1:NDBASE,0:NDPARI)
     *
     *       /SETBAS_PARDIM/ LDBASP(0:NDPARI)
     *
     *       /SETBAS_NXNYNZ/ NXVECT(1:NDBASE),
     *                       NYVECT(1:NDBASE),
     *                       NZVECT(1:NDBASE)
     *
     *       /SETBAS_DIMENS/ LDBASE
      COMMON
     *       /KARSPH_CYLDIM/ LDCYLP(0:NDPARI)
C
      COMMON
     *       /READWRITE_PAR/ NOUTPT,IWRITE,ISCREN
C
      DATA
     *        EPSMUL / 1.E-14 /
C
C=======================================================================
C
      DO ISTATE=1,LDBASE
         DO LDREVE=0,NDREVE
            SPNILS(ISTATE,LDREVE)='you did not ask'
         END DO
      END DO
C
C=======================================================================
C
      IF (NILSLB.NE.1) RETURN
C
C=======================================================================
C
      CALL WS_CPUTIM('CYLONL',1)
C
C=======================================================================
C
      ALLOCATE(RES_DW(1:MDBASE,1:MDTRAN,0:NDPARI))
      ALLOCATE(AUXCYL(1:MDBASE,1:MDTRAN,0:NDPARI))
      ALLOCATE(WVTRAN(1:MDBASE,1:MDTRAN))
C
      IF (MOD(NDCLAB,2).EQ.0) THEN
C
          LDMEVE=((NDCLAB+2)*(NDCLAB+4)*(NDCLAB+NDCLAB+3))/24
C
          IF (NDTRAN.NE.LDMEVE) THEN
C
              WRITE(NOUTPT,'(//,''LDMEVE='',I4,
     *                       '' SHOULD BE EQUAL NDTRAN='',
     *                       I4)') LDMEVE,NDTRAN
C
              STOP 'NDTRAN.NE.LDMEVE <<= '
C
          END IF
C
          LDLABS=LDMEVE
C
      ELSE
C
          LDMODD=((NDCLAB+1)*(NDCLAB+3)*(NDCLAB+NDCLAB+7))/24
C
          IF (NDTRAN.NE.LDMODD) THEN
C
              WRITE(NOUTPT,'(//,''LDMODD='',I4,
     *                       '' SHOULD BE EQUAL NDTRAN='',
     *                       I4)') LDMODD,NDTRAN
C
              STOP 'NDTRAN.NE.LDMODD <<= '
C
          END IF
C
          LDLABS=LDMODD
C
      END IF
C
C=======================================================================
C     Analysing the single particle HO structure of the wave
C     functions
C=======================================================================
C
      CALL WS_CYLXYZ(NDCLAB)
C
C=======================================================================
C
C     This subroutine  defines  the two-dimensional matrices
C      < Nx,Ny,Nz | Nro,Nz,m >  of  the  HO  b r a c k e t s
C
C=======================================================================
C
      CALL WS_TRANSC(NDCLAB,AUXCYL)
C
C=======================================================================
C=======================================================================
C     CALCULATING  THE NILSSON - LABELS  FOR THE EIGENSTATES
C=======================================================================
C=======================================================================
C
      UNIT_I=CMPLX(0.0,1.0)
C
      DO IPARIT=0,NDPARI
C
C        The doloop below should never be activated; we keep
C        it here in order to compare  with the corresponding
C        do-loop below and understand the comments contained
C        there (-->> search NYPARI)
C
C        DO IKARTE=1,LDBASP(IPARIT)
C
C           NY=NYPARI(IKARTE,IPARIT)
C
C           DO JCYLIN=1,LDCYLP(IPARIT)
C
C              AUXCYL(IKARTE,JCYLIN,IPARIT)
C    *        =AUXCYL(IKARTE,JCYLIN,IPARIT)
C    *        *(+UNIT_I)**( NY )/SQRT(2.00)
C
C           END DO
C
C        END DO
C
C=======================================================================
C        Below the HO states - components, of the W.S. wave-
C        functions are analysed separately for the positive
C        and negative parity, independently  of whether the
C        corresponding  W.S. states preserve the parity, or
C        not.  This is because  the basis  preserves parity
C        always
C=======================================================================
C
         DO INDKET=1,LDBASE
            INDLAB=0
            DO IBRAPA=1,LDBASP(IPARIT)
C
               INDACT=INDPAR(IBRAPA,IPARIT)
C
               NX=NXVECT(INDACT)
               NY=NYVECT(INDACT)
               NZ=NZVECT(INDACT)
C
               N0MAIN=NX+NY+NZ
C
               IF (N0MAIN.LE.NDCLAB) THEN
C
                   INDLAB=INDLAB+1
C
                   WVTRAN(INDKET,INDLAB)
     *            =EWAVEF(INDPAR(IBRAPA,IPARIT),INDKET)
C
               END IF
C
            END DO
         END DO
C
         FORM_A='N'
         FORM_B='N'
C
         NDAROW=MDBASE
         NDACOL=MDTRAN
         LDAROW=LDBASE
         LDACOL=LDBASP(IPARIT)
         LDACOL=LDLABS
C
         NDBROW=MDBASE
         NDBCOL=MDTRAN
         LDBROW=LDBASP(IPARIT)
         LDBCOL=LDBASP(IPARIT)
         LDBROW=LDLABS
         LDBCOL=LDLABS
C
         NDCROW=MDBASE
         NDCCOL=MDTRAN
         LDCROW=LDBASE
         LDCCOL=LDBASP(IPARIT)
         LDCCOL=LDLABS
C
         DO I=1,MDBASE
            DO J=1,MDTRAN
               RES_DW(I,J,IPARIT)=CMPLX(0.0,0.0)
C              RES_UP(I,J,IPARIT)=CMPLX(0.0,0.0)
            END DO
         END DO
C
C=======================================================================
C
C        Multiplying complex matrices  by making use of the sub-
C        routines coming from the math-science libraries. Below:
C
C        A. WVTRAN(INDKET,IBRAPA) ->> an auxiliary wave function
C                                     matrix t r a n s p o s e d
C
C           INDKET = running index denumerating W.S. - solutions
C           IBRAPA = the index of the h.o. basis states  used to
C                    distinguish between  the two parities, (see
C                    common PARIND, in subroutine SETBAS)
C
C        B. SPINDW(IKARTE,JCYLIN,IPARIT) ==>> the transformation
C           matrix  from the Cartesian  to the cylidrical coordi-
C           nate frames. However:  1- taking into account parity
C           i.e.  only positive parity  to  positive parity, and
C           correspondingly, negative parity  to negative parity
C           and also 2- projecting from the good signature basis
C           in the case the cartesian coordinates to the spin-up
C           or spin-down bases in the cylidrical case the latter
C           bringing in the "NY" dependent phase
C
C        C. The resulting matrix  gives the decomposition of the
C           WS states into a cylindrical  state with the spin up
C           or spin down components. This matrix has also parity
C           dependence explicitly in with the indexing:
C
C                        RES_DW(ISTATE,JCYLIN,IPARIT)
C
C=======================================================================
C
         CALL WS_CCSPRS(WVTRAN,NDAROW,NDACOL,LDAROW,LDACOL,FORM_A,
     *                  AUXCYL(1,1,IPARIT),
     *                         NDBROW,NDBCOL,LDBROW,LDBCOL,FORM_B,
     *                  RES_DW(1,1,IPARIT),
     *                         NDCROW,NDCCOL,LDCROW,LDCCOL,EPSMUL)
C
C=======================================================================
C        The call below must be activated when both projections
C        i.e. spin-up and spin-down are explicitly needed. When
C        activating - remember that in the mean time the phases
C        are already contained in matrix AUXCYL and the only mo-
C        dification will consist in changing the sign
C=======================================================================
c!
c!       DO IKARTE=1,LDBASP(IPARIT)
c!          NY=NYPARI(IKARTE,IPARIT)
c!          DO JCYLIN=1,LDCYLP(IPARIT)
c!
c!             AUXCYL(IKARTE,JCYLIN,IPARIT)
c!   *        =AUXCYL(IKARTE,JCYLIN,IPARIT)
c!   *        *(-1)**(NY+1)*UNIT_I
c!
c!          END DO
c!
c!       END DO
c!
c!       CALL WS_CCSPRS(WVTRAN,NDAROW,NDACOL,LDAROW,LDACOL,FORM_A,
c!   *               AUXCYL(1,1,IPARIT),
c!   *                      NDBROW,NDBCOL,LDBROW,LDBCOL,FORM_B,
c!   *               RES_UP(1,1,IPARIT),
c!   *                      NDCROW,NDCCOL,LDCROW,LDCCOL,EPSMUL)
c!
C=======================================================================
C
      END DO
C
C=======================================================================
C
      ICOUNT=0
C
      DO ISTATE=1,LDBASE
C
         N_BASE=0
C
         INDMAX=0
C
         AMPMAX=-100.
C
C=======================================================================
C
         DO IPARIT=0,NDPARI
C
            IF (ISIGNY.EQ.1.AND.IPARIT.NE.IPAORD(ISTATE)) GO TO 1
C
            DO JCYLIN=1,LDCYLP(IPARIT)
C
               MRNILS=NBASER(JCYLIN,IPARIT)
               MZNILS=NBASZP(JCYLIN,IPARIT)
               M_NILS=NBASEM(JCYLIN,IPARIT)
C
C=======================================================================
C
C              Each Cartesian state of a good simplex or signature
C              must have the cylindrical decomposition of the type
C
C                     |SIMPLEX> = ALFA * |N,nz,+LAMBDA,+OMEGA>
C                               + BETA * |N,nz,-LAMBDA,-OMEGA>
C
C              where
C                     ABS(ALFA) = ABS(BETA)
C
C              Consequently, there is no need to calculate spin-up
C              and spin-down projections separately as long as the
C              Nilsson labels, or the wave function decompositions,
C              are concerned. Therefore, we take only one sign (UP)
C              below.
C
C              However, for calculations involving the possibility
C              of the interference effects, both amplitudes should
C              be treated on the same level;  we leave the related
C              instructions commented out for easy re-introduction
C
C=======================================================================
C              DO N_SPIN=-1,1,2
C=======================================================================
C
                  N_SPIN=+1
C
                  N_BASE=N_BASE+1
C
C=======================================================================
C                 The multiplication below should be activated should
C                 the N_SPIN=-1 term be explicitely needed
C=======================================================================
C
C                 PROML=RES_UP(ISTATE,JCYLIN,IPARIT)*
C    *            CONJG(RES_UP(ISTATE,JCYLIN,IPARIT))
C
                  IF (N_SPIN.EQ.1)
     *
     *            PROML=RES_DW(ISTATE,JCYLIN,IPARIT)*
     *            CONJG(RES_DW(ISTATE,JCYLIN,IPARIT))
C
                  IF (AMPMAX.LT.PROML) THEN
C
                      AMPMAX=PROML
                      INDMAX=N_BASE
C
                  END IF
C
C=======================================================================
C                 If only the amplitude-squared is needed, calculate
C                 only one projection,  e.g. "UP",  and multiply the
C                 related projection by the factor of 2
C=======================================================================
C
C                 AMPLT2(N_BASE)=PROML
C
                  AMPLT2(N_BASE)=PROML+PROML
                  NSTATE(N_BASE)=N_BASE
C
                  MAINCL(N_BASE)=M_NILS+2*MRNILS+MZNILS
                  LAMBCL(N_BASE)=M_NILS
                  NZCLND(N_BASE)=MZNILS
                  IOMECL(N_BASE)=N_SPIN+2*LAMBCL(N_BASE)
C
C                 The END DO below should be activated if the time-up
C                 and the time-down blocks will be explicitely needed
C
C              END DO
C
            END DO
C
C=======================================================================
C           Optionally skipping "false" parity if (ISIGNY=1)
C=======================================================================
C
   1        CONTINUE
C
         END DO
C
C=======================================================================
C
         IF (N_BASE.GT.MDTVEC) THEN
C
             WRITE(NOUTPT,'(''N_BASE='',I5,'' exceeds MDTVEC='',I5)')
     *                                                  N_BASE,MDTVEC
             STOP 'Cylindrical basis - Dimensions <<= '
C
         END IF
C
C=======================================================================
C
         IF (NILWAV.EQ.1) THEN
C
             LCOLUM=10
C
             CALL WS_ORDLOW(AMPLT2,NSTATE,N_BASE,LCOLUM,AUXVEC,NDTVE2,
     *                                                  MINDEX,LINDEX)
C
             MAINNL(ISTATE,IREVER)=MAINCL(NSTATE(1))
             NZNILS(ISTATE,IREVER)=NZCLND(NSTATE(1))
             L_NILS(ISTATE,IREVER)=LAMBCL(NSTATE(1))
             IOMEGA(ISTATE,IREVER)=IOMECL(NSTATE(1))
C
             QUOTCY(ISTATE,IREVER)=AMPLT2(1)
C
         ELSE
C
             MAINNL(ISTATE,IREVER)=MAINCL(INDMAX)
             NZNILS(ISTATE,IREVER)=NZCLND(INDMAX)
             L_NILS(ISTATE,IREVER)=LAMBCL(INDMAX)
             IOMEGA(ISTATE,IREVER)=IOMECL(INDMAX)
C
             QUOTCY(ISTATE,IREVER)=AMPMAX
C
         END IF
C
C=======================================================================
C
         WRITE(NILLAB(ISTATE),'(''|'',I2,'','',I2,'','',I2,'','',I2,
     *                                                    ''/2>'')')
     *                                       MAINNL(ISTATE,IREVER),
     *                                       NZNILS(ISTATE,IREVER),
     *                                  ABS(L_NILS(ISTATE,IREVER)),
     *                                  ABS(IOMEGA(ISTATE,IREVER))
C
         SPNILS(ISTATE,IREVER)=NILLAB(ISTATE)
         QUONIL(ISTATE,IREVER)=QUOTCY(ISTATE,IREVER)
C
C=======================================================================
C
C=======================================================================
C
         IF (NILWAV.EQ.1.AND.IWRITE.GE.1) THEN
C
             IF (ESINGP(ISTATE).GT.EMINWF.AND.
     *           ESINGP(ISTATE).LT.EMAXWF    ) THEN
C
                 PTOTAL=0.0
                 DO I=1,LCOLUM
                    PTOTAL=PTOTAL+AMPLT2(I)
                 END DO
C
                 ICOUNT=ICOUNT+1
C
                 IF (MOD(ICOUNT+7,8).EQ.0) THEN
C
                     IF (ISOSPI.EQ.0) THEN
C
                         WRITE(NOUTPT,'(//,80(''#''),/,
     *                                  ''#'',78X,''#'',/,
     *                         ''#  Neutron Eigenfunctions:  Nilsson'',
     *                         ''  Labels                     Omega='',
     *                         F5.3,''    #'',/,
     *                         ''#                   '',
     *                         ''                    '',
     *                         ''                    '',
     *                         ''  (Ry,Ry'''')='',A5,''   #'',/,
     *                         80(''#''),/,''#'',78X,''#'')')
     *
     *                         OMEGAC,RYTEXT(IREVER)
                     ELSE
C
                         WRITE(NOUTPT,'(//,80(''#''),/,
     *                                  ''#'',78X,''#'',/,
     *                         ''#  Proton Eigenfunctions:  Nilsson'',
     *                         ''  Labels                      Omega='',
     *                         F5.3,''    #'',/,
     *                         ''#                   '',
     *                         ''                    '',
     *                         ''                    '',
     *                         ''  (Ry,Ry'''')='',A5,''   #'',/,
     *                         ''#'',78X,''#'',/,  80(''#''),/,
     *                                        ''#'',78X,''#'')')
     *
     *                         OMEGAC,RYTEXT(IREVER)
C
                     END IF
C
                 END IF
C
                 PROBAB=AMPLT2(1)
C
                 IF (PARITY(ISTATE).GT.0.0) THEN
                     IPAUXI=INT(100*PARITY(ISTATE)+0.49999)
                 ELSE
                     IPAUXI=INT(100*PARITY(ISTATE)-0.49999)
                 END IF
C
                 WRITE(NOUTPT,'(''#  Energy='',F8.4,'' (Asq.='',I3,
     *                     ''%) |N='',I2,'',nz='',I2,'',|lz|='',I2,
     *                     '',|K|='',I2,''/2>  Parity:<'',
     *                     SP,I4,SS,''%>   #'',/,
     *                     ''#                  (Sum.='',I3,
     *                     ''%)                              '',
     *                     ''                   #'')')
     *
     *                                  ESINGP(ISTATE),INT(100*PROBAB),
     *                                  MAINNL(ISTATE,IREVER),
     *                                  NZNILS(ISTATE,IREVER),
     *                              ABS(L_NILS(ISTATE,IREVER)),
     *                              ABS(IOMEGA(ISTATE,IREVER)),
     *                                         IPAUXI,INT(100*PTOTAL)
C
                 WRITE(NOUTPT,'(''#         A(%) =>'',
     *                          10(2X,I2,''%'',1X),
     *                                 2X,''#'',/,''#'',78X,''#'')')
     *
     *                                  (INT(100*AMPLT2(J)),J=1,10)
C
                 WRITE(NOUTPT,'(''#         |N >   '',5(2X,I2,4X,I2,2X),
     *                                                   2X,''#'')')
     *
     *                                    (MAINCL(NSTATE(J)),J=1,10)
C
                 WRITE(NOUTPT,'(''#         |nz>   '',5(2X,I2,4X,I2,2X),
     *                                                   2X,''#'')')
     *
     *                                    (NZCLND(NSTATE(J)),J=1,10)
C
                 WRITE(NOUTPT,'(''#         |lz>   '',
     *                           5(2X,SP,I2,4X,I2,SS,2X),2X,''#'')')
     *
     *                                    (LAMBCL(NSTATE(J)),J=1,10)
C
                 WRITE(NOUTPT,'(''#         |K >   '',
     *                        5(SP,I3,''/2'',1X,I3,''/2'',1X,SS),2X,
     *                                                      ''#'')')
     *
     *                                    (IOMECL(NSTATE(J)),J=1,10)
C
                 WRITE(NOUTPT,'(''#'',78X,''#'')')
C
             END IF
C
         END IF
C
      END DO
C
C=======================================================================
C     Printing the tables of the structure of the wave functions
C     using  the  | N, Nz, LAMBDA >  r e p r e s e n t a t i o n
C=======================================================================
C
C
C=======================================================================
C     The labelling  and  structure based on the (N, NZ, LAMBDA)
C     defined  i n d i v i d u a l l y  for  each  quantum state
C=======================================================================
C
      IF (ISOSPI.EQ.0) THEN
C
          IF (IWRITE.GE.1)
     *
     *    WRITE(NOUTPT,'(//,80(''#''),/,''#'',78X,''#'',/,
     *              ''#  NEUTRONS            N i l s s o n'',
     *               ''   L a b e l l i n g         Omega='',
     *                                       F5.3,''   #'',/,
     *                ''#                      Hamiltonian'',
     *                           '' Block  (Ry,Ry'''')='',A5,
     *                        ''                       #'',/,
     *                         80(''#''),/,''#'',78X,''#'',/,
     *        ''#  No)  Energy | N,nz,lz,  K >  < P%>     '',
     *          ''No)  Energy | N,nz,lz,  K >  < P%>   #'',/,
     *              ''#'',78X,''#'')')  OMEGAC,RYTEXT(IREVER)
C
      ELSE
C
          IF (IWRITE.GE.1)
     *
     *    WRITE(NOUTPT,'(//,80(''#''),/,''#'',78X,''#'',/,
     *              ''#  PROTONS             N i l s s o n'',
     *               ''   L A B E L L I N G         Omega='',
     *                                       F5.3,''   #'',/,
     *                ''#                      Hamiltonian'',
     *                           '' Block  (Ry,Ry'''')='',A5,
     *                        ''                       #'',/,
     *                         80(''#''),/,''#'',78X,''#'',/,
     *        ''#  No)  Energy | N,nz,lz,  K >  < P%>     '',
     *          ''No)  Energy | N,nz,lz,  K >  < P%>   #'',/,
     *              ''#'',78X,''#'')')  OMEGAC,RYTEXT(IREVER)
C
      END IF
C
C=======================================================================
C
      KIKOFF=0
      ISTART=1
C
      DO ISTATE=1,LDBASE
         IF (ESINGP(ISTATE).GE.EMINST.AND.
     *       ESINGP(ISTATE).LE.EMAXST) THEN
             KIKOFF=KIKOFF+1
             IF (KIKOFF.EQ.1) ISTART=ISTATE
         END IF
      END DO
C
      KIKOFF=KIKOFF/2-1
C
      IF (ISTART+KIKOFF.GT.LDBASE) THEN
C
          STOP 'ISTART+KIKOFF.GT.LDBASE - IN SPECTR (2) <<= '
C
      END IF
C
C=======================================================================
C
      DO L=ISTART,ISTART+KIKOFF
C
         L1=L
         L2=KIKOFF+L+1
C
C=======================================================================
C
         IPTES1=INT(SIGN(ABS(PARITY(L1))*100+0.1,PARITY(L1)))
C
C=======================================================================
C
         IF (ABS(IPTES1).NE.100) THEN
C
             WRITE(STRNP1,'(''('',SP,I3,SS,'')'')') IPTES1
C
         END IF
C
         IF (IPTES1.EQ.+100) THEN
C
             WRITE(STRNP1,'(''( + )'')')
C
         END IF
C
         IF (IPTES1.EQ.-100) THEN
C
             WRITE(STRNP1,'(''( - )'')')
C
         END IF
C
C=======================================================================
C
         IPTES2=INT(SIGN(ABS(PARITY(L2))*100+0.1,PARITY(L2)))
C
C=======================================================================
C
         IF (ABS(IPTES2).NE.100) THEN
C
             WRITE(STRNP2,'(''('',SP,I3,SS,'')'')') IPTES2
C
         END IF
C
         IF (IPTES2.EQ.+100) THEN
C
             WRITE(STRNP2,'(''( + )'')')
C
         END IF
C
         IF (IPTES2.EQ.-100) THEN
C
             WRITE(STRNP2,'(''( - )'')')
C
         END IF
C
         IF (IWRITE.GE.1)
     *   WRITE(NOUTPT,'(''# '', I3,'')'',F8.3,1X,A15,2X,A5,1X,
     *                  ''   '',I3,'')'',F8.3,1X,A15,2X,A5,3X,''#'')')
     *
     *                               L1,ESINGP(L1),NILLAB(L1),STRNP1,
     *                               L2,ESINGP(L2),NILLAB(L2),STRNP2
C
      END DO
C
      IF (IWRITE.GE.1)
     *    WRITE(NOUTPT,'(''#'',78X,''#'',/,80(''#''))')
C
      DEALLOCATE(RES_DW,AUXCYL,WVTRAN)
C
C=======================================================================
C
      CALL WS_CPUTIM('CYLONL',0)
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C=======================================================================
C
      SUBROUTINE WS_TRANSC(N_MAIN,AUXCYL)
C=======================================================================
      USE params
C=======================================================================
C
C=======================================================================
C         In order to save the memory and knowing that parity
C         is conserved, we split the programming into two con-
C         sequtively run sequences, that use  the same memory
C         one after the other. For a given N_MAIN, the two pa-
C         rity blocks  have always uneven sizes; if NDCLAB is
C         an even number then  NDMEVE > NDMODD  and we should
C         use NDMEVE as a size declaration. Consequently:
C=======================================================================
C
      COMPLEX
     *          COEFFC,UNIT_I,AUXCYL(1:MDBASE,1:MDTRAN,0:NDPARI)
C
      COMMON
     *       /CYLXYZ_CARCYL/ COEFFC(0:NDPERP,0:NDPERP,0:NDPERP)
      COMMON
     *       /TRANSC_NYPARI/ NYPARI(1:NDTRAN,0:NDPARI)
     *
     *       /TRANSC_BASCLJ/ NBASER(1:NDTRAN,0:NDPARI),
     *                       NBASZP(1:NDTRAN,0:NDPARI),
     *                       NBASEM(1:NDTRAN,0:NDPARI)
     *
     *       /TRANSC_LDTRAN/ LDTRAN
      COMMON
     *       /SETBAS_BASLAB/ NXVLAB(1:NDBASE),
     *                       NYVLAB(1:NDBASE),
     *                       NZVLAB(1:NDBASE)
      COMMON
     *       /KARSPH_CYLDIM/ LDCYLP(0:NDPARI)
C
      COMMON
     *       /READWRITE_PAR/ NOUTPT,IWRITE,ISCREN
C
C=======================================================================
C
C     The maximum dimension  of the single  particle hamiltonian
C     depends on the parity and is given by one of the following
C     expressions:
C
C     IF (MOD(NMAX,2).EQ.1) ((NMAX+1)*(NMAX+3)*(NMAX+NMAX+7))/24
C     IF (MOD(NMAX,2).EQ.0) ((NMAX+2)*(NMAX+4)*(NMAX+NMAX+3))/24
C
C=======================================================================
C
C     This subroutine will place the transformation coefficients
C
C                      < NX,NY,NZ | NRO,NZ,M >
C
C     into 2-dimensional matrices taking explicitly into account
C     the parities  of the "BRA"  and of the "KET" states of the
C     oscillator
C
C=======================================================================
C
      IF (N_MAIN.GT.NDCLAB) THEN
C
          WRITE(NOUTPT,'(''N_MAIN='',I2,
     *                   '' must not exceed NDCLAB='',I2)')
     *
     *                                       N_MAIN,NDCLAB
C
          STOP 'N_MAIN.GT.NDCLAB in TRANSC <<= '
C
      END IF
C
C=======================================================================
C
      UNIT_I=CMPLX(0.0,1.0)
C
      NPARIP=0
      NPARIN=0
C
C=======================================================================
C
C     Calculation for the cylindrical-coordinate BRA-KET variant;
C     here we limit ourselves to the first NDCLAB h.o. shells so
C     that we may look for the labels  of the low (limited) part
C     of the energy spectrum
C
C=======================================================================
C
      DO NTOTAL=0,N_MAIN
C
         DO NZQNUM=0,NTOTAL
C
            NPERPE=NTOTAL-NZQNUM
C
            DO NROQNB=0,NPERPE
C
               LAMBDA=NPERPE-2*NROQNB
C
               N0MAIN=2*NROQNB+LAMBDA+NZQNUM
C
               IPARIT=MOD(N0MAIN,2)
C
               IF (IPARIT.EQ.0) THEN
C
C=======================================================================
C                  Positive parity
C=======================================================================
C
                   NPARIP=NPARIP+1
C
                   NBASER(NPARIP,IPARIT)=NROQNB
                   NBASZP(NPARIP,IPARIT)=NZQNUM
                   NBASEM(NPARIP,IPARIT)=LAMBDA
C
               ELSE
C
C=======================================================================
C                  Negative parity
C=======================================================================
C
                   NPARIN=NPARIN+1
C
                   NBASER(NPARIN,IPARIT)=NROQNB
                   NBASZP(NPARIN,IPARIT)=NZQNUM
                   NBASEM(NPARIN,IPARIT)=LAMBDA
C
               END IF
C
            END DO
         END DO
      END DO
C
C=======================================================================
C
      LDCYLP(0)=NPARIP
      LDCYLP(1)=NPARIN
C
      LDTRAN=NPARIN+NPARIP
C
      DO I=1,MDBASE
         DO J=1,MDTRAN
            DO IPARIT=0,NDPARI
               AUXCYL(I,J,IPARIT)=CMPLX(0.0,0.0)
            END DO
         END DO
      END DO
C
C=======================================================================
C     Defining the Ny-quantum number in relation to the parity
C     of the states. This will be used to define phase factors
C=======================================================================
C
      NPARIP=0
      NPARIN=0
C
      DO IKARTE=1,LDTRAN
C
         NX=NXVLAB(IKARTE)
         NY=NYVLAB(IKARTE)
         NZ=NZVLAB(IKARTE)
C
         IF ((NX.EQ.(-1)).OR.(NY.EQ.(-1)).OR.(NZ.EQ.(-1))) GO TO 1
C
C        In the present version NYPARI is unused - can be useful later
C
         NMKART=NX+NY+NZ
C
         IPARIT=MOD(NMKART,2)
C
         IF (IPARIT.EQ.0) THEN
C
C            Positive parity
C
             NPARIP=NPARIP+1
             INDEXK=NPARIP
C
             NYPARI(NPARIP,IPARIT)=NY
C
         ELSE
C
C            Negative parity
C
             NPARIN=NPARIN+1
             INDEXK=NPARIN
C
             NYPARI(NPARIN,IPARIT)=NY
C
         END IF
C
C=======================================================================
C
         DO JCYLIN=1,LDCYLP(IPARIT)
C
            NRO=NBASER(JCYLIN,IPARIT)
            NZP=NBASZP(JCYLIN,IPARIT)
            LAM=NBASEM(JCYLIN,IPARIT)
C
            AUXCYL(INDEXK,JCYLIN,IPARIT)=CMPLX(0.0,0.0)
C
C=======================================================================
C
C           COEFFC(NX,NRO,NPERP) = <NX,NY|NRO,LAMBDA>
C
C           where:   NX+NY=2*NRO+LAMBDA=NPERPE;
C
C           i.e.     NY=NPERPE-NX and LAMBDA=NPERP-2*NRO
C
C           with     NX and NRO varying from 0 to NPERPE
C
C=======================================================================
C
            IF (NZ.EQ.NZP.AND.(NX+NY).EQ.(2*NRO+LAM)) THEN
C
                AUXCYL(INDEXK,JCYLIN,IPARIT)=CONJG(COEFFC(NX,NRO,NX+NY))
     *                                      *(+UNIT_I)**(NY)/SQRT(2.00)
C
            END IF
C
         END DO
C
   1     CONTINUE
C
      END DO
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C=======================================================================
C
      SUBROUTINE WS_CYLXYZ(NPERPE)
C=======================================================================
      USE params
C=======================================================================
      COMPLEX
     *          COEFFC,PHASFC,ANTIPH
      DIMENSION
     *          FACTRL(0:NDPERP),XNEWTN(0:NDPERP,0:NDPERP),
     *          SQFCTL(0:NDPERP),SQ2PWR(0:NDPERP)
C
      COMMON
     *       /CYLXYZ_CARCYL/ COEFFC(0:NDPERP,0:NDPERP,0:NDPERP)
      COMMON
     *       /READWRITE_PAR/ NOUTPT,IWRITE,ISCREN
C
      SAVE
     *        INTIAL, FACTRL, XNEWTN, SQFCTL, SQ2PWR, SQRT_2
      DATA
     *     INTIAL  / -1 /
C
C=======================================================================
C
C     This subroutine calculates the transformation brackets between
C     the Cartesian  and  cylindrical bases of the two - dimensional
C     harmonic oscillator.
C
C     Calculations are performed for all values of N - perpendicular
C     up to NPERPE. Subroutine does  n o t  recalculate the elements
C     already calculated. If called more times only the new elements
C     will be added to the storage array.
C
C     The results are stored in the complex matrix COEFFC  in common
C     CFNXNY.  The indices  of  the storage array have the following
C     meaning:
C
C      COEFFC(NXQNMR,NROQNR,NPERPE) = <NXQNMR,NYQNMR|NROQNR,LAMBDA>
C
C     where:         NXQNMR+NYQNMR = 2*NROQNR+LAMBDA = NPERPE
C     i.e.           NYQNMR=NPERPE - NXQNMR;
C                    LAMBDA=NPERPE - NROQNR-NROQNR;
C                    NXQNMR,NROQNR = 0,1,...NPERPE;
C
C=======================================================================
C     See notes "CO" for the derivation of formulae  and symmetries
C                                                           used
C=======================================================================
C=============================================== T.R.WERNER, AUGUST 1992
C=======================================================================
C
      IF (NPERPE.LT.     0) STOP 'NPERPE < 0 in CYLXYZ <<= '
C
      IF (NPERPE.GT.NDPERP) THEN
C
          WRITE(NOUTPT,'(''NPERPE='',I3,'' exceeds NDPERP='',I3)')
     *                                             NPERPE,NDPERP
          STOP 'NPERPE > NDPERP in CYLXYZ <<= '
C
      END IF
C
C=======================================================================
C
      IF (INTIAL.EQ.-1) THEN
C
          FACTRL(0)=1.0
          SQFCTL(0)=1.0
          SQ2PWR(0)=1.0
C
          XNEWTN(0,0)=1.0
C
          COEFFC(0,0,0)=CMPLX(1.,0.)
C
          SQRT_2=SQRT(2.000)
C
          INTIAL=0
C
      END IF
C
      INTIAL=INTIAL+1
C
      IF (NPERPE.LT.INTIAL) THEN
C
          INTIAL=INTIAL-1
          RETURN
C
      END IF
C
C=======================================================================
C
      DO NACPER=INTIAL,NPERPE
         DO NROQNR=INTIAL,NPERPE
            DO NXQNMR=INTIAL,NPERPE
               COEFFC(NXQNMR,NROQNR,NACPER)=CMPLX(0.,0.)
            END DO
         END DO
      END DO
C
C=======================================================================
C
C     FACTRL(N)   -> the factorial of N
C     SQFCTL(N)   -> the square root of the factorial  of N
C     SQ2PWR(N)   -> the square root of the n-th power of 2
C     XNEWTN(N,K) -> Newton's symbol "N over K"
C
C=======================================================================
C
      DO I=INTIAL,NPERPE
C
         FACTRL(I)=FACTRL(I-1)*REAL(I)
         SQFCTL(I)=SQRT  (FACTRL(I))
         SQ2PWR(I)=SQ2PWR(I-1)*SQRT_2
C
         DO K=0,I
            XNEWTN(I,K)=(FACTRL(I)/FACTRL(K))/FACTRL(I-K)
         END DO
C
      END DO
C
C=======================================================================
C            M A I N   L O O P
C=======================================================================
C
      IPLUSM=2*MOD(INTIAL,2)-1
C
      DO NACPER=INTIAL,NPERPE
C
         IPXPLM=-1
         IPYPLM=+IPLUSM
         IPLUSM=-IPLUSM
C
         DO NXQNMR=0,NACPER/2
C
            NYQNMR=NACPER-NXQNMR
C
            IPXPLM=-IPXPLM
            IPYPLM=-IPYPLM
C
            DO NROQNR=0,NACPER/2
C
               NROPRI=NACPER-NROQNR
               LAMBDA=NACPER-NROQNR-NROQNR
C
               NRONRO=(NACPER-LAMBDA)/2
C
               K_MINI=MAX(0,(NXQNMR-LAMBDA+1)/2)
               K_MAXI=MIN(NRONRO,NXQNMR/2)
C
               IF (K_MAXI.GE.K_MINI) THEN
C
                   AUXFCT=0.0
                   IFACTR=1-2*MOD(K_MINI,2)
C
                   DO K=K_MINI,K_MAXI
                      AUXFCT=AUXFCT
     *                      +IFACTR
     *                      *XNEWTN(NRONRO,K)*XNEWTN(LAMBDA,NXQNMR-2*K)
                      IFACTR=-IFACTR
                   END DO
C
                   AUXFCT=AUXFCT*
     *                   (SQFCTL(NXQNMR)/SQFCTL(NACPER-NROQNR))
     *                   *SQFCTL(NYQNMR)
     *                   /SQFCTL(NROQNR)
     *                   /SQ2PWR(NACPER)
C
                   PHASFC=(CMPLX(0.,1.)**(LAMBDA-NXQNMR))*AUXFCT
C
                   COEFFC(NXQNMR,NROQNR,NACPER)=PHASFC
C
                   IF (NROQNR.NE.NROPRI) THEN
                       COEFFC(NXQNMR,NROPRI,NACPER)=PHASFC*IPYPLM
                   END IF
C
                   IF (NXQNMR.NE.NYQNMR) THEN
C
                      ANTIPH=CMPLX(0.0,-1.0)**LAMBDA
C
                      COEFFC(NYQNMR,NROQNR,NACPER)=PHASFC*IPXPLM*ANTIPH
C
                      IF (NROQNR.NE.NROPRI) THEN
                          COEFFC(NYQNMR,NROPRI,NACPER)=PHASFC*ANTIPH
                      END IF
C
                   END IF
C
               END IF
C
            END DO
         END DO
      END DO
C
      INTIAL=NPERPE
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C=======================================================================
C
      SUBROUTINE WS_SPHLAB(LAMMAX,LABSPE,NOSMAX,SPHMAX,EMINCH,EMAXCH,
     *                                                 IZ_FIX,IN_FIX)
C=======================================================================
      USE params
C=======================================================================
C
      CHARACTER
     *          LBSPHE*6,LBSHEL*6
      CHARACTER
     *          PATSPH(0:NDSPHE)*1
C
      COMPLEX
     *          ALPHAC(0:NDLAMB,-NDLAMB:+NDLAMB)
C
      DIMENSION
     *          LBSHEL(1:NDSH12),INDLAB(1:NDSH12),NBMAIN(1:NDSH12),
     *          IABSNT(1:NDSH12)
      DIMENSION
     *          ITAKEN(1:NDBASE),INDEXS(1:NDBASE)
C
      COMMON
     *       /SPHONL_SPHERE/ MAIN0S(1:NDBASE,0:NDREVE),
     *                       JMOM0S(1:NDBASE,0:NDREVE),
     *                       LSPH0S(1:NDBASE,0:NDREVE),
     *                       MMOM0S(1:NDBASE,0:NDREVE)
     *
     *       /SPHONL_SPHSPH/ ISWITH
      COMMON
     *       /VERIFS_SYMETS/ ISPHER,ICYLIN,IPCONS
      COMMON
     *       /SPHLAB_ENEPAR/ ESPHER(1:NDBASE),
     *                       PSPHER(1:NDBASE)
     *       /SPHLAB_DEGENR/ IDEGEN(1:NDBASE)
     *       /SPHLAB_LBSPHE/ LBSPHE(1:NDBASE)
     *
     *       /SPHLAB_SPHRQN/ LWSSPH(1:NDBASE),
     *                       JWSSPH(1:NDBASE),
     *                       NWSSPH(1:NDBASE),
     *                       IPWSPH(1:NDBASE)
     *
     *       /SPHLAB_DIMSPH/ LDSPHE
      COMMON
     *       /SPECTR_ESINGP/ ESINGP(1:NDBASE),
     *                       PARITY(1:NDBASE)
      COMMON
     *       /ALPHACMUL_DEF/ ALPHAC
      COMMON
     *       /SETBAS_DIMENS/ LDBASE
C
      COMMON
     *       /READWRITE_PAR/ NOUTPT,IWRITE,ISCREN
C
      DATA
     *     PATSPH(0) / 's' /,
     *     PATSPH(1) / 'p' /,
     *     PATSPH(2) / 'd' /,
     *     PATSPH(3) / 'f' /,
     *     PATSPH(4) / 'g' /,
     *     PATSPH(5) / 'h' /,
     *     PATSPH(6) / 'i' /,
     *     PATSPH(7) / 'j' /,
     *     PATSPH(8) / 'k' /,
     *     PATSPH(9) / 'l' /,PATSPH(10) / 'm' /,PATSPH(11) / 'n' /,
     *                                          PATSPH(12) / 'o' /,
     *                                          PATSPH(13) / 'q' /,
     *                                          PATSPH(14) / 'r' /,
     *                                          PATSPH(15) / 't' /,
     *                                          PATSPH(16) / 'u' /,
     *                                          PATSPH(17) / 'v' /,
     *                                          PATSPH(18) / 'w' /,
     *                                          PATSPH(19) / 'x' /,
     *                                          PATSPH(20) / 'y' /
      DATA
     *     LBSHEL(01) / '1s1/2 ' /, NBMAIN(01) /  0 /  ! Shell no. 0
      DATA
     *     LBSHEL(02) / '1p3/2 ' /, NBMAIN(02) /  1 /,
     *     LBSHEL(03) / '1p1/2 ' /, NBMAIN(03) /  1 /  ! Shell no. 1
      DATA
     *     LBSHEL(04) / '2s1/2 ' /, NBMAIN(04) /  2 /,
     *     LBSHEL(05) / '1d5/2 ' /, NBMAIN(05) /  2 /,
     *     LBSHEL(06) / '1d3/2 ' /, NBMAIN(06) /  2 /  ! Shell no. 2
      DATA
     *     LBSHEL(07) / '2p3/2 ' /, NBMAIN(07) /  3 /,
     *     LBSHEL(08) / '2p1/2 ' /, NBMAIN(08) /  3 /,
     *     LBSHEL(09) / '1f7/2 ' /, NBMAIN(09) /  3 /,
     *     LBSHEL(10) / '1f5/2 ' /, NBMAIN(10) /  3 /  ! Shell no. 3
      DATA
     *     LBSHEL(11) / '3s1/2 ' /, NBMAIN(11) /  4 /,
     *     LBSHEL(12) / '2d5/2 ' /, NBMAIN(12) /  4 /,
     *     LBSHEL(13) / '2d3/2 ' /, NBMAIN(13) /  4 /,
     *     LBSHEL(14) / '1g9/2 ' /, NBMAIN(14) /  4 /,
     *     LBSHEL(15) / '1g7/2 ' /, NBMAIN(15) /  4 /  ! Shell no. 4
      DATA
     *     LBSHEL(16) / '3p3/2 ' /, NBMAIN(16) /  5 /,
     *     LBSHEL(17) / '3p1/2 ' /, NBMAIN(17) /  5 /,
     *     LBSHEL(18) / '2f7/2 ' /, NBMAIN(18) /  5 /,
     *     LBSHEL(19) / '1f5/2 ' /, NBMAIN(19) /  5 /,
     *     LBSHEL(20) / '1h11/2' /, NBMAIN(20) /  5 /,
     *     LBSHEL(21) / '1h9/2 ' /, NBMAIN(21) /  5 /  ! Shell no. 5
      DATA
     *     LBSHEL(22) / '4s1/2 ' /, NBMAIN(22) /  6 /,
     *     LBSHEL(23) / '3d5/2 ' /, NBMAIN(23) /  6 /,
     *     LBSHEL(24) / '3d3/2 ' /, NBMAIN(24) /  6 /,
     *     LBSHEL(25) / '2g9/2 ' /, NBMAIN(25) /  6 /,
     *     LBSHEL(26) / '2g7/2 ' /, NBMAIN(26) /  6 /,
     *     LBSHEL(27) / '1i13/2' /, NBMAIN(27) /  6 /,
     *     LBSHEL(28) / '1i11/2' /, NBMAIN(28) /  6 /  ! Shell no. 6
      DATA
     *     LBSHEL(29) / '4p3/2 ' /, NBMAIN(29) /  7 /,
     *     LBSHEL(30) / '4p1/2 ' /, NBMAIN(30) /  7 /,
     *     LBSHEL(31) / '3f7/2 ' /, NBMAIN(31) /  7 /,
     *     LBSHEL(32) / '3f5/2 ' /, NBMAIN(32) /  7 /,
     *     LBSHEL(33) / '2h11/2' /, NBMAIN(33) /  7 /,
     *     LBSHEL(34) / '2h9/2 ' /, NBMAIN(34) /  7 /,
     *     LBSHEL(35) / '1j15/2' /, NBMAIN(35) /  7 /,
     *     LBSHEL(36) / '1j13/2' /, NBMAIN(36) /  7 /  ! Shell no. 7
      DATA
     *     LBSHEL(37) / '5s1/2 ' /, NBMAIN(37) /  8 /,
     *     LBSHEL(38) / '4d5/2 ' /, NBMAIN(38) /  8 /,
     *     LBSHEL(39) / '4d3/2 ' /, NBMAIN(39) /  8 /,
     *     LBSHEL(40) / '3g9/2 ' /, NBMAIN(40) /  8 /,
     *     LBSHEL(41) / '3g7/2 ' /, NBMAIN(41) /  8 /,
     *     LBSHEL(42) / '2i13/2' /, NBMAIN(42) /  8 /,
     *     LBSHEL(43) / '2i11/2' /, NBMAIN(43) /  8 /,
     *     LBSHEL(44) / '1k17/2' /, NBMAIN(44) /  8 /,
     *     LBSHEL(45) / '1k15/2' /, NBMAIN(45) /  8 /  ! Shell no. 8
      DATA
     *     LBSHEL(46) / '5p3/2 ' /, NBMAIN(46) /  9 /,
     *     LBSHEL(47) / '5p1/2 ' /, NBMAIN(47) /  9 /,
     *     LBSHEL(48) / '4f7/2 ' /, NBMAIN(48) /  9 /,
     *     LBSHEL(49) / '4f5/2 ' /, NBMAIN(49) /  9 /,
     *     LBSHEL(50) / '3h11/2' /, NBMAIN(50) /  9 /,
     *     LBSHEL(51) / '3h9/2 ' /, NBMAIN(51) /  9 /,
     *     LBSHEL(52) / '2j15/2' /, NBMAIN(52) /  9 /,
     *     LBSHEL(53) / '2j13/2' /, NBMAIN(53) /  9 /,
     *     LBSHEL(54) / '1l19/2' /, NBMAIN(54) /  9 /,
     *     LBSHEL(55) / '1l17/2' /, NBMAIN(55) /  9 /  ! Shell no. 9
      DATA
     *     LBSHEL(56) / '6s1/2 ' /, NBMAIN(56) / 10 /,
     *     LBSHEL(57) / '5d5/2 ' /, NBMAIN(57) / 10 /,
     *     LBSHEL(58) / '5d3/2 ' /, NBMAIN(58) / 10 /,
     *     LBSHEL(59) / '4g9/2 ' /, NBMAIN(59) / 10 /,
     *     LBSHEL(60) / '4g7/2 ' /, NBMAIN(60) / 10 /,
     *     LBSHEL(61) / '3i13/2' /, NBMAIN(61) / 10 /,
     *     LBSHEL(62) / '3i11/2' /, NBMAIN(62) / 10 /,
     *     LBSHEL(63) / '2k17/2' /, NBMAIN(63) / 10 /,
     *     LBSHEL(64) / '2k15/2' /, NBMAIN(64) / 10 /,
     *     LBSHEL(65) / '1m21/2' /, NBMAIN(65) / 10 /,
     *     LBSHEL(66) / '1m19/2' /, NBMAIN(66) / 10 /  ! Shell no.10
      DATA
     *     LBSHEL(67) / '6p3/2 ' /, NBMAIN(67) / 11 /,
     *     LBSHEL(68) / '6p1/2 ' /, NBMAIN(68) / 11 /,
     *     LBSHEL(69) / '5f7/2 ' /, NBMAIN(69) / 11 /,
     *     LBSHEL(70) / '5f5/2 ' /, NBMAIN(70) / 11 /,
     *     LBSHEL(71) / '4h11/2' /, NBMAIN(71) / 11 /,
     *     LBSHEL(72) / '4h9/2 ' /, NBMAIN(72) / 11 /,
     *     LBSHEL(73) / '3j15/2' /, NBMAIN(73) / 11 /,
     *     LBSHEL(74) / '3j13/2' /, NBMAIN(74) / 11 /,
     *     LBSHEL(75) / '2l19/2' /, NBMAIN(75) / 11 /,
     *     LBSHEL(76) / '2l17/2' /, NBMAIN(76) / 11 /,
     *     LBSHEL(77) / '1n23/2' /, NBMAIN(77) / 11 /,
     *     LBSHEL(78) / '1n21/2' /, NBMAIN(78) / 11 /  ! Shell no.11
      DATA
     *     LBSHEL(79) / '7s1/2 ' /, NBMAIN(79) / 12 /,
     *     LBSHEL(80) / '6d5/2 ' /, NBMAIN(80) / 12 /,
     *     LBSHEL(81) / '6d3/2 ' /, NBMAIN(81) / 12 /,
     *     LBSHEL(82) / '5g9/2 ' /, NBMAIN(82) / 12 /,
     *     LBSHEL(83) / '5g7/2 ' /, NBMAIN(83) / 12 /,
     *     LBSHEL(84) / '4i13/2' /, NBMAIN(84) / 12 /,
     *     LBSHEL(85) / '4i11/2' /, NBMAIN(85) / 12 /,
     *     LBSHEL(86) / '3k17/2' /, NBMAIN(86) / 12 /,
     *     LBSHEL(87) / '3k15/2' /, NBMAIN(87) / 12 /,
     *     LBSHEL(88) / '2m21/2' /, NBMAIN(88) / 12 /,
     *     LBSHEL(89) / '2m19/2' /, NBMAIN(89) / 12 /,
     *     LBSHEL(90) / '2o25/2' /, NBMAIN(90) / 12 /,
     *     LBSHEL(91) / '2o23/2' /, NBMAIN(91) / 12 /  ! Shell no.12
     *                                          PATSPH(21) / 'z' /
      DATA
     *     EPSDEF / 0.1500 /
      DATA
     *     SMALLD / 0.5000 /
C
C=======================================================================
C
C      This subroutine prepares the spherical labels e.g. for the
C      plotting system and for the chi^2 minimisations and prints
C      the corresponding table. This routine differs from the one
C      below, SPHCRT, in the following:
C
C      1. Here we identify the 'spherical multiplets'  not by the
C         energetical degeneracy,  but by a direct identification
C         of the L and J quantum numbers. Such a procedure has an
C         advantage of being free from the problems with the sphe-
C         rical level crossings in function of the potential para-
C         meters. For deformations which are not 'enormous', such
C         a subroutine allows to define very reasonably  a center
C         of gravity of a multiplet, its dependence on various de-
C         formation degrees of freedom etc.
C
C      2. This routine can be used for deformed nuclei.  For very
C         large deformations  it may happen  that  leading labels
C         are not unique: some may be totally missing and some re-
C         peated. This routine can recognize such situations  and
C         signals them for a further reaction by the user
C
C=======================================================================
C
C     IF (NOSCIL.GT.NDOLAB) THEN !  This warning is printed also from
C                                                               SPHONL
C         The spherical labels can be calculated for NOSCIL.le.NDOLAB
C
C         WRITE(NOUTPT,'(/,80(''!''),/,''!!'',76X,''!!'',/,
C    *                   ''!! The number of shells used NOSCIL='',I2,
C    *                   '' exceeds the number of shells NDOLAB='',I2,
C    *                   '' !!'',/,
C    *                   ''!! Increase NDOLAB to get correctly the '',
C    *                   ''spherical labels -  '',
C    *                   ''PROGRAM CONTINUES !!'',/,
C    *                   ''!!'',76X,''!!'',/,80(''!''),/)')
C    *
C    *                                                  NOSCIL,NDOLAB
C
C         RETURN
C
C     END IF
C
C=======================================================================
C
      IF (LABSPE.NE.1) RETURN
C
      IF (ISPHER.NE.1) RETURN
C
C=======================================================================
C
      IREVER=0
C
      LDSPHE=0
C
C=======================================================================
C     Below we introduce  a possibility  of working with a
C     slightly deformed field in order to remove the total
C     spherical degeneracy and possibly use a polarisation
C=======================================================================
C
                                                   IDEFOR=0
      DO LAMBDA=2,LAMMAX
         DO MIU=0,LAMBDA
            IF (ABS(ALPHAC(LAMBDA,MIU)).GT.EPSDEF) IDEFOR=1
         END DO
      END DO
C
C=======================================================================
C
      DO JSTATE=1,LDBASE
         ITAKEN(JSTATE)=1
         ESPHER(JSTATE)=1.0e+10+JSTATE
      END DO
C
C=======================================================================
C
      ISPHCN=0
C
      DO JSTATE=1,LDBASE
C
         IF (ESINGP(JSTATE).GT.SPHMAX) GO TO 1
         IF (ITAKEN(JSTATE).EQ.000000) GO TO 1
C
         ITAKEN(JSTATE)=0
C
         EAVERA=ESINGP(JSTATE)
         PAVERA=PARITY(JSTATE)
C
         IAVERA=1
C
         DO ISTATE=JSTATE+1,LDBASE
C
C           The following IF eliminates troubles arising when
C           the ensembles  of three quantum numbers used as a
C           test - repeat themselves
C
            IF (ABS(ESINGP(ISTATE)-ESINGP(JSTATE)).GT.SMALLD) GO TO 2
C
            IF (ESINGP(ISTATE).GT.SPHMAX) GO TO 2
C
            IF (ITAKEN(ISTATE).EQ.000000) GO TO 2
C
            IF ((LSPH0S(ISTATE,IREVER).EQ.LSPH0S(JSTATE,IREVER)).AND.
     *          (JMOM0S(ISTATE,IREVER).EQ.JMOM0S(JSTATE,IREVER)).AND.
     *          (MAIN0S(ISTATE,IREVER).EQ.MAIN0S(JSTATE,IREVER))) THEN
C
                ITAKEN(ISTATE)=0
C
                IAVERA=IAVERA+1
                EAVERA=EAVERA+ESINGP(ISTATE)
                PAVERA=PAVERA+PARITY(ISTATE)
C
            END IF
C
   2        CONTINUE
C
         END DO
C
         ISPHCN=ISPHCN+1
C
         IF (ISPHCN.GT.NDBASE) STOP 'ISPHCN.GT.NDBASE in SPHLAB <<= '
C
C=======================================================================
C        The degeneracy  calculated above does not take into
C        account the Kramers degeneracy. We multiply it by a
C        factor of 2 to get the physical '(2j+1)' degeneracy
C=======================================================================
C
         IDEGEN(ISPHCN)=2*IAVERA
C
         ESPHER(ISPHCN)=EAVERA/REAL(IAVERA)
         PSPHER(ISPHCN)=PAVERA/REAL(IAVERA)
C
         NWSSPH(ISPHCN)=MAIN0S(JSTATE,IREVER)
         LWSSPH(ISPHCN)=LSPH0S(JSTATE,IREVER)
         JWSSPH(ISPHCN)=JMOM0S(JSTATE,IREVER)
C
         IF (LWSSPH(ISPHCN).GT.NDSPHE) THEN
             STOP 'LWSSPH(ISPHCN).GT.NDSPHE in SPHLAB <<= '
         END IF
C
   1     CONTINUE
C
      END DO
C
C=======================================================================
C
      LDSPHE=ISPHCN
C
C=======================================================================
C
      DO LSPHER=1,LDSPHE
         INDEXS(LSPHER)=LSPHER
      END DO
C
C=======================================================================
C
      CALL WS_ORDER1(ESPHER,INDEXS,LDSPHE,NDBASE)
C
C=======================================================================
C
      DO KSPHER=1,LDSPHE
C
         LSPHER=INDEXS(KSPHER)
C
         IF (IDEGEN(LSPHER).EQ.(JWSSPH(LSPHER)+1)) THEN
C
             IF (JWSSPH(LSPHER).GT.10) THEN
                 WRITE(LBSPHE(KSPHER),'(''0'',A1,I2,''/2'')')
     *                  PATSPH(LWSSPH(LSPHER)),JWSSPH(LSPHER)
             ELSE
                 WRITE(LBSPHE(KSPHER),'(''0'',A1,I1,''/2'')')
     *                  PATSPH(LWSSPH(LSPHER)),JWSSPH(LSPHER)
             END IF
C
         ELSE
C
	     IF (IWRITE.GE.1) THEN
C
                 WRITE(NOUTPT,'(''Energy='',F12.6,
     *          ''      Theo. degeneracy : '',I4,'' - Found : '',I4)')
     *                  ESPHER(KSPHER),JWSSPH(LSPHER)+1,IDEGEN(LSPHER)
C
                 WRITE(NOUTPT,'(''LSPHER = '',I4,'' N = '',I4,
     *                 '' L = '',I4,'' J = '',I4,''/2'')')
     *           LSPHER,NWSSPH(LSPHER),LWSSPH(LSPHER),JWSSPH(LSPHER)
C
	     END IF
C
             IF (JWSSPH(LSPHER).GT.10) THEN
                 WRITE(LBSPHE(KSPHER),'(''0'',''?'',I2,''/2'')')
     *                                            JWSSPH(LSPHER)
             ELSE
                 WRITE(LBSPHE(KSPHER),'(''0'',''?'',I1,''/2'')')
     *                                            JWSSPH(LSPHER)
             END IF
C
         END IF
      END DO
C
C=======================================================================
C
      IF (IWRITE.GE.1)
     *    WRITE(NOUTPT,'(/,80(''#''),/,''#'',78X,''#'',/,
     *            ''#   Spherical Labelling of the Woods'',
     *            ''-Saxon Spectrum (Sph.)    Z='',I3,''   N='',I3,
     *            ''    #'',/,''#'',78X,''#'',/,
     *            ''#   Note: For a deformed nucleus the '',
     *            ''energies below are the gravity centers    #'')')
     *                                            IZ_FIX,IN_FIX
C
      IF (IDEFOR.EQ.1) THEN
C
          IF (IWRITE.GE.1)
     *        WRITE(NOUTPT,'(''#'',78X,''#'',/,
     *              ''#      WARNING!  Deformation greater than'',
     *              ''  EPSDEF='',F4.2,''  has been detected      #'')')
     *                  EPSDEF
      END IF
C
      IF (IWRITE.GE.1)
     *    WRITE(NOUTPT,'(''#'',78X,''#'',/,80(''#''),/,
     *            ''#'',78X,''#'',/,
     *            ''#   No)     Energy     State   ( P%)   '',
     *            ''    No)     Energy     State   ( P%)    #'',/,
     *            ''#'',78X,''#'')')
C
C=======================================================================
C
      DO LSPHER=0,NOSMAX
         DO JSPHER=1,NOSMAX+NOSMAX+1,2
            ICOUNT=0
            DO ISPHCN=1,LDSPHE
               IF (LWSSPH(INDEXS(ISPHCN)).EQ.LSPHER.AND.
     *             JWSSPH(INDEXS(ISPHCN)).EQ.JSPHER) THEN
                   ICOUNT=ICOUNT+1
                   WRITE(LBSPHE(ISPHCN)(1:1),'(I1)') ICOUNT
               END IF
            END DO
         END DO
      END DO
C
C=======================================================================
C
      LDKEEP=LDSPHE
      DO I=1,LDSPHE
         IF (ESPHER(I).GT.SPHMAX) THEN
             LDKEEP=I-1
             GO TO 3
         END IF
      END DO
C
   3  CONTINUE
C
C=======================================================================
C
      LDLINE=LDSPHE/2
C
      DO LINE=1,LDLINE
C
         LINE_1=LINE
         LINE_2=LDLINE+LINE
C
         IPAR_1=NINT(100*PSPHER(LINE_1))
C
         IPAR_2=NINT(100*PSPHER(LINE_2))
C
         IF (IWRITE.GE.1)
     *       WRITE(NOUTPT,'(''#   '', I2,'')'',F12.5,4X,A6,I6,''%'',
     *                  ''       '',I2,'')'',F12.5,4X,A6,I6,''%'',
     *                                                 ''    #'')')
     *
     *                LINE_1,ESPHER(LINE_1),LBSPHE(LINE_1),IPAR_1,
     *                LINE_2,ESPHER(LINE_2),LBSPHE(LINE_2),IPAR_2
C
      END DO
c
c
c                TO REMOVE IN FUTURE VERSIONS
c
c      OPEN(21,FILE='ws_odd.dat',STATUS='unknown',FORM='FORMATTED')
c      DO I=1,LDSPHE
c         WRITE(21,'(i4,3x,a8,f15.8)') I,LBSPHE(I),ESPHER(I)
c      END DO
c      CLOSE(21)
c
c                TO REMOVE IN FUTURE VERSIONS
c
C
C=======================================================================
C
      IF (IWRITE.GE.1)
     *    WRITE(NOUTPT,'(''#'',78X,''#'',/,80(''#''))')
C
C=======================================================================
C
C     Here verifying whether there was a single-degenerate spherical
C     level or there are two degenerate spherical levels of the same
C     parity
C
C=======================================================================
C     Checking whether there are more than one label each
C=======================================================================
C
      EEROR1=10000
      IERROR=0
C
      DO I=1,LDSPHE
C
         INDLAB(I)=0
C
         DO J=1,LDSPHE
            IF (I.NE.J) THEN
                IF (LBSPHE(I).EQ.LBSPHE(J)) THEN
                    INDLAB(I)=INDLAB(I)+1
                END IF
            END IF
         END DO
C
C        Below: EERROR denotes the energy above which the labels are
C               not guaranteed certain, because two identical labels
C               appeared
C
         IF (INDLAB(I).GT.1) THEN
             IERROR=IERROR+1
             IF (IERROR.EQ.1) THEN
                 EEROR1=ESPHER(I)
             END IF
         END IF
C
      END DO
C
C=======================================================================
C
      IF (IERROR.GT.0.AND.IWRITE.GE.1) THEN
C
          WRITE(NOUTPT,'(/,80(''!''),/,''!!'',76X,''!!'',/,
     *                ''!!  There were'',I4,
     *                '' labels that are not unique:'',
     *                '' Energy of the first one'',F6.2,''  !!'',/,
     *                ''!!'',76X,''!!'',/,80(''!''))')
     *
     *                                                IERROR,EEROR1
C
      END IF
C
C=======================================================================
C     Checking the consistency - are ther more levels than patterns
C=======================================================================
C
      IF (LDSPHE.GT.NDSH12.AND.IWRITE.GE.1) THEN
C
          WRITE(NOUTPT,'(/,80(''!''),/,''!!'',76X,''!!'',/,
     *                ''!!  You have'',I4,'' levels calculated -- '',
     *                ''more than the number of exact patterns  !!'',/,
     *                ''!!'',76X,''!!'',/,80(''!''))')
     *
     *                                                 LDSPHE
C
      END IF
C
C=======================================================================
C     Checking whether there are some alltogether missing labels
C=======================================================================
C
      EEROR2=+10000
      IERROR=0
C
      DO J=1,NDSH12
C
         N0MAIN=NBMAIN(J)
C
         IF (N0MAIN.GT.NOSMAX) GO TO 4
C
         IABSNT(J)=+1
C
C        Below verifying whether a studied PATTERN LABEL which in
C        principle MUST exist in the spectrum has in reality been
C        found
C
         DO I=1,LDSPHE
C
            K=INDEXS(I)
C
            IF (LBSPHE(K).EQ.LBSHEL(J)) THEN
C
                IABSNT(J)=IABSNT(J)-1
C
            END IF
C
         END DO
C
         IF (IABSNT(J).EQ.1) THEN
             IERROR=IERROR+1
             IF (IERROR.EQ.1) THEN
                 EEROR2=ESPHER(J)
             END IF
         END IF
C
   4     CONTINUE
C
      END DO
C
C=======================================================================
C
      IF (IERROR.GT.0.AND.IWRITE.GE.1) THEN
C
          WRITE(NOUTPT,'(/,80(''!''),/,''!!'',76X,''!!'',/,
     *                ''!!  Above energy of '',F8.3,
     *                '' MeV there are at least'',I3,
     *                '' ill-identified labels  !!'',/,
     *                ''!!'',76X,''!!'',/,80(''!''))')
     *
     *                                   EEROR2,IERROR
C
      END IF
C
C=======================================================================
C
          ISWITH=0
C
      IF (EEROR1.LT.EMAXCH.OR.EEROR2.LT.EMAXCH) THEN
C
          ISWITH=1
                                EERROR=EEROR1
          IF (EERROR.GT.EEROR2) EERROR=EEROR2
C
	  IF (IWRITE.GE.1)
     *        WRITE(NOUTPT,'(/,80(''!''),/,''!!'',76X,''!!'',/,
     *                ''!!  You have requested  the control of '',
     *                ''exactitude  for the  spherical labels  !!'',/,
     *                ''!!  between: EMINCH='',F7.3,
     *                '' MeV and EMAXCH='',F6.3,
     *                '' MeV;   EERROR ='',F7.3,'' MeV  !!'',/,
     *                ''!!'',76X,''!!'',/,80(''!''))')
     *
     *                                      EMINCH,EMAXCH,EERROR
C
      END IF
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C=======================================================================
C
      SUBROUTINE WS_SPHCRT(LAMMAX,LABSPE,NOSMAX,SPHMAX,EMINCH,EMAXCH,
     *                                          IREVER,IZ_FIX,IN_FIX)
C=======================================================================
      USE params
C=======================================================================
C
      CHARACTER
     *          PATSPH(0:NDSPHE)*1
      CHARACTER
     *          LBSPHE*6,LBSHEL*6
C
      COMPLEX
     *          ALPHAC(0:NDLAMB,-NDLAMB:+NDLAMB)
C
      DIMENSION
     *          ESINGP(1:NDBASE),PARITY(1:NDBASE),
     *                           ITAKEN(1:NDBASE),
     *                           INDEXS(1:NDBASE)
      DIMENSION
     *          N_MAIN(1:NDBASE),IPARIT(1:NDBASE)
      DIMENSION
     *          LBSHEL(1:NDSH12),NBMAIN(1:NDSH12),
     *          IABSNT(1:NDSH12)
      DIMENSION
     *          INDLAB(1:NDBASE)
C
      COMMON
     *       /ALPHACMUL_DEF/ ALPHAC
C
      COMMON
     *       /VERIFS_SYMETS/ ISPHER,ICYLIN,IPCONS
      COMMON
     *       /LBKARR_BASCAR/ NXCART(1:NDBASE,0:NDREVE),
     *                       NYCART(1:NDBASE,0:NDREVE),
     *                       NZCART(1:NDBASE,0:NDREVE)
      COMMON
     *       /SPHLAB_ENEPAR/ ESPHER(1:NDBASE),
     *                       PSPHER(1:NDBASE)
     *       /SPHLAB_DEGENR/ IDEGEN(1:NDBASE)
     *       /SPHLAB_LBSPHE/ LBSPHE(1:NDBASE)
     *
     *       /SPHLAB_SPHRQN/ LWSSPH(1:NDBASE),
     *                       JWSSPH(1:NDBASE),
     *                       NWSSPH(1:NDBASE),
     *                       IPWSPH(1:NDBASE)
     *       /SPHLAB_DIMSPH/ LDSPHE
      COMMON
     *       /SPECTR_ESINGP/ ESINGP,PARITY
      COMMON
     *       /SPHONL_SPHSPH/ ISWITH
      COMMON
     *       /SETBAS_DIMENS/ LDBASE
C
      COMMON
     *       /READWRITE_PAR/ NOUTPT,IWRITE,ISCREN
C
      DATA
     *     PATSPH(0) / 's' /,
     *     PATSPH(1) / 'p' /,
     *     PATSPH(2) / 'd' /,
     *     PATSPH(3) / 'f' /,
     *     PATSPH(4) / 'g' /,
     *     PATSPH(5) / 'h' /,
     *     PATSPH(6) / 'i' /,
     *     PATSPH(7) / 'j' /,
     *     PATSPH(8) / 'k' /,
     *     PATSPH(9) / 'l' /,PATSPH(10) / 'm' /,PATSPH(11) / 'n' /,
     *                                          PATSPH(12) / 'o' /,
     *                                          PATSPH(13) / 'q' /,
     *                                          PATSPH(14) / 'r' /,
     *                                          PATSPH(15) / 't' /,
     *                                          PATSPH(16) / 'u' /,
     *                                          PATSPH(17) / 'v' /,
     *                                          PATSPH(18) / 'w' /,
     *                                          PATSPH(19) / 'x' /,
     *                                          PATSPH(20) / 'y' /,
     *                                          PATSPH(21) / 'z' /
      DATA
     *     LBSHEL(01) / '1s1/2 ' /, NBMAIN(01) /  0 /  ! Shell no. 0
      DATA
     *     LBSHEL(02) / '1p3/2 ' /, NBMAIN(02) /  1 /,
     *     LBSHEL(03) / '1p1/2 ' /, NBMAIN(03) /  1 /  ! Shell no. 1
      DATA
     *     LBSHEL(04) / '2s1/2 ' /, NBMAIN(04) /  2 /,
     *     LBSHEL(05) / '1d5/2 ' /, NBMAIN(05) /  2 /,
     *     LBSHEL(06) / '1d3/2 ' /, NBMAIN(06) /  2 /  ! Shell no. 2
      DATA
     *     LBSHEL(07) / '2p3/2 ' /, NBMAIN(07) /  3 /,
     *     LBSHEL(08) / '2p1/2 ' /, NBMAIN(08) /  3 /,
     *     LBSHEL(09) / '1f7/2 ' /, NBMAIN(09) /  3 /,
     *     LBSHEL(10) / '1f5/2 ' /, NBMAIN(10) /  3 /  ! Shell no. 3
      DATA
     *     LBSHEL(11) / '3s1/2 ' /, NBMAIN(11) /  4 /,
     *     LBSHEL(12) / '2d5/2 ' /, NBMAIN(12) /  4 /,
     *     LBSHEL(13) / '2d3/2 ' /, NBMAIN(13) /  4 /,
     *     LBSHEL(14) / '1g9/2 ' /, NBMAIN(14) /  4 /,
     *     LBSHEL(15) / '1g7/2 ' /, NBMAIN(15) /  4 /  ! Shell no. 4
      DATA
     *     LBSHEL(16) / '3p3/2 ' /, NBMAIN(16) /  5 /,
     *     LBSHEL(17) / '3p1/2 ' /, NBMAIN(17) /  5 /,
     *     LBSHEL(18) / '2f7/2 ' /, NBMAIN(18) /  5 /,
     *     LBSHEL(19) / '1f5/2 ' /, NBMAIN(19) /  5 /,
     *     LBSHEL(20) / '1h11/2' /, NBMAIN(20) /  5 /,
     *     LBSHEL(21) / '1h9/2 ' /, NBMAIN(21) /  5 /  ! Shell no. 5
      DATA
     *     LBSHEL(22) / '4s1/2 ' /, NBMAIN(22) /  6 /,
     *     LBSHEL(23) / '3d5/2 ' /, NBMAIN(23) /  6 /,
     *     LBSHEL(24) / '3d3/2 ' /, NBMAIN(24) /  6 /,
     *     LBSHEL(25) / '2g9/2 ' /, NBMAIN(25) /  6 /,
     *     LBSHEL(26) / '2g7/2 ' /, NBMAIN(26) /  6 /,
     *     LBSHEL(27) / '1i13/2' /, NBMAIN(27) /  6 /,
     *     LBSHEL(28) / '1i11/2' /, NBMAIN(28) /  6 /  ! Shell no. 6
      DATA
     *     LBSHEL(29) / '4p3/2 ' /, NBMAIN(29) /  7 /,
     *     LBSHEL(30) / '4p1/2 ' /, NBMAIN(30) /  7 /,
     *     LBSHEL(31) / '3f7/2 ' /, NBMAIN(31) /  7 /,
     *     LBSHEL(32) / '3f5/2 ' /, NBMAIN(32) /  7 /,
     *     LBSHEL(33) / '2h11/2' /, NBMAIN(33) /  7 /,
     *     LBSHEL(34) / '2h9/2 ' /, NBMAIN(34) /  7 /,
     *     LBSHEL(35) / '1j15/2' /, NBMAIN(35) /  7 /,
     *     LBSHEL(36) / '1j13/2' /, NBMAIN(36) /  7 /  ! Shell no. 7
      DATA
     *     LBSHEL(37) / '5s1/2 ' /, NBMAIN(37) /  8 /,
     *     LBSHEL(38) / '4d5/2 ' /, NBMAIN(38) /  8 /,
     *     LBSHEL(39) / '4d3/2 ' /, NBMAIN(39) /  8 /,
     *     LBSHEL(40) / '3g9/2 ' /, NBMAIN(40) /  8 /,
     *     LBSHEL(41) / '3g7/2 ' /, NBMAIN(41) /  8 /,
     *     LBSHEL(42) / '2i13/2' /, NBMAIN(42) /  8 /,
     *     LBSHEL(43) / '2i11/2' /, NBMAIN(43) /  8 /,
     *     LBSHEL(44) / '1k17/2' /, NBMAIN(44) /  8 /,
     *     LBSHEL(45) / '1k15/2' /, NBMAIN(45) /  8 /  ! Shell no. 8
      DATA
     *     LBSHEL(46) / '5p3/2 ' /, NBMAIN(46) /  9 /,
     *     LBSHEL(47) / '5p1/2 ' /, NBMAIN(47) /  9 /,
     *     LBSHEL(48) / '4f7/2 ' /, NBMAIN(48) /  9 /,
     *     LBSHEL(49) / '4f5/2 ' /, NBMAIN(49) /  9 /,
     *     LBSHEL(50) / '3h11/2' /, NBMAIN(50) /  9 /,
     *     LBSHEL(51) / '3h9/2 ' /, NBMAIN(51) /  9 /,
     *     LBSHEL(52) / '2j15/2' /, NBMAIN(52) /  9 /,
     *     LBSHEL(53) / '2j13/2' /, NBMAIN(53) /  9 /,
     *     LBSHEL(54) / '1l19/2' /, NBMAIN(54) /  9 /,
     *     LBSHEL(55) / '1l17/2' /, NBMAIN(55) /  9 /  ! Shell no. 9
      DATA
     *     LBSHEL(56) / '6s1/2 ' /, NBMAIN(56) / 10 /,
     *     LBSHEL(57) / '5d5/2 ' /, NBMAIN(57) / 10 /,
     *     LBSHEL(58) / '5d3/2 ' /, NBMAIN(58) / 10 /,
     *     LBSHEL(59) / '4g9/2 ' /, NBMAIN(59) / 10 /,
     *     LBSHEL(60) / '4g7/2 ' /, NBMAIN(60) / 10 /,
     *     LBSHEL(61) / '3i13/2' /, NBMAIN(61) / 10 /,
     *     LBSHEL(62) / '3i11/2' /, NBMAIN(62) / 10 /,
     *     LBSHEL(63) / '2k17/2' /, NBMAIN(63) / 10 /,
     *     LBSHEL(64) / '2k15/2' /, NBMAIN(64) / 10 /,
     *     LBSHEL(65) / '1m21/2' /, NBMAIN(65) / 10 /,
     *     LBSHEL(66) / '1m19/2' /, NBMAIN(66) / 10 /  ! Shell no.10
      DATA
     *     LBSHEL(67) / '6p3/2 ' /, NBMAIN(67) / 11 /,
     *     LBSHEL(68) / '6p1/2 ' /, NBMAIN(68) / 11 /,
     *     LBSHEL(69) / '5f7/2 ' /, NBMAIN(69) / 11 /,
     *     LBSHEL(70) / '5f5/2 ' /, NBMAIN(70) / 11 /,
     *     LBSHEL(71) / '4h11/2' /, NBMAIN(71) / 11 /,
     *     LBSHEL(72) / '4h9/2 ' /, NBMAIN(72) / 11 /,
     *     LBSHEL(73) / '3j15/2' /, NBMAIN(73) / 11 /,
     *     LBSHEL(74) / '3j13/2' /, NBMAIN(74) / 11 /,
     *     LBSHEL(75) / '2l19/2' /, NBMAIN(75) / 11 /,
     *     LBSHEL(76) / '2l17/2' /, NBMAIN(76) / 11 /,
     *     LBSHEL(77) / '1n23/2' /, NBMAIN(77) / 11 /,
     *     LBSHEL(78) / '1n21/2' /, NBMAIN(78) / 11 /  ! Shell no.11
      DATA
     *     LBSHEL(79) / '7s1/2 ' /, NBMAIN(79) / 12 /,
     *     LBSHEL(80) / '6d5/2 ' /, NBMAIN(80) / 12 /,
     *     LBSHEL(81) / '6d3/2 ' /, NBMAIN(81) / 12 /,
     *     LBSHEL(82) / '5g9/2 ' /, NBMAIN(82) / 12 /,
     *     LBSHEL(83) / '5g7/2 ' /, NBMAIN(83) / 12 /,
     *     LBSHEL(84) / '4i13/2' /, NBMAIN(84) / 12 /,
     *     LBSHEL(85) / '4i11/2' /, NBMAIN(85) / 12 /,
     *     LBSHEL(86) / '3k17/2' /, NBMAIN(86) / 12 /,
     *     LBSHEL(87) / '3k15/2' /, NBMAIN(87) / 12 /,
     *     LBSHEL(88) / '2m21/2' /, NBMAIN(88) / 12 /,
     *     LBSHEL(89) / '2m19/2' /, NBMAIN(89) / 12 /,
     *     LBSHEL(90) / '2o25/2' /, NBMAIN(90) / 12 /,
     *     LBSHEL(91) / '2o23/2' /, NBMAIN(91) / 12 /  ! Shell no.12
C
      DATA
     *     EPSDEF / 0.1500 /
      DATA
     *     EPSDEG / 0.0500 /
C
C=======================================================================
C
C     This subroutine  prepares  spherical labels  for the plotting
C     system and other applications - and prints  the corresponding
C     table.  The method used avoids the matrix multiplication  and
C     uses the Cartesian labels and the degeneracy arguments.
C
C     An advantage of this routine as compared to subroutine SPHLAB
C     is  that it can work for very big shells  without limitations
C     related to quickly growing sizes of the h.o. related matrices.
C     A disadvantage is  that it is not protected agains degeneracy
C     of two or more spherical orbitals  -  although in such a case
C     it recognizes faults and issues a message that can be used to
C     activate the other routine.
C
C=======================================================================
C
C     For all the subroutines dealing with spherical labels, namely
C    (SPHONL, SPHCRT and SPHLAB) we use the convention of notation
C     ->> the "j" quantum number stored is in fact 2*j
C
C=======================================================================
C
C     Some parameters:
C
C     SPHMAX - The energies  p r i n t e d  must not exceed SPHMAX
C
C     EMINCH - The lower energy limit  for which the correctnes of
C              the labels is controlled.  This control is going to
C              be principally needed  for the unabigous definition
C              of the chi^2 test (comparison with experiment)
C
C     EMAXCH - The corresponding uper energy limit (see above);
C
C=======================================================================
C
          LDSPHE=0
C
      IF (LABSPE.NE.1) RETURN
C
C=======================================================================
C     Below we introduce a possibility  of working with a slightly
C     deformed nuclear field in order to remove the spherical dege-
C     neracy and possibly use a polarisation
C=======================================================================
C
                                                   IDEFOR=0
      DO LAMBDA=2,LAMMAX
         DO MIU=0,LAMBDA
            IF (ABS(ALPHAC(LAMBDA,MIU)).GT.EPSDEF) IDEFOR=1
         END DO
      END DO
C
C=======================================================================
C
      IF (ISPHER.NE.1.AND.IWRITE.GE.1) THEN
C
          WRITE(NOUTPT,'(/,80(''!''),/,''!!'',76X,''!!'',/,
     *                        ''!!  Subroutine SPHCRT '',
     *                        ''(Spherical-from-Cartesian) '',
     *                        ''cannot be used for nonzero   !!'',/,
     *                        ''!!                    deformations - '',
     *                       ''use SPHLAB instead =>> option ISOTRO=1'',
     *                      ''   !!'',/,''!!'',76X,''!!'',/,80(''!''))')
C
          RETURN
C
      END IF
C
C=======================================================================
C
      DO JSTATE=1,LDBASE
C
         ITAKEN(JSTATE)=1
         N_MAIN(JSTATE)=NXCART(JSTATE,IREVER)
     *                 +NYCART(JSTATE,IREVER)
     *                 +NZCART(JSTATE,IREVER)
C
                                         IPARIT(JSTATE)=+1
         IF (MOD(N_MAIN(JSTATE),2).NE.0) IPARIT(JSTATE)=-1
C
      END DO
C
C=======================================================================
C
C=======================================================================
C
      JSPHER=0
C
      DO JSTATE=1,LDBASE
C
C        IF (ESINGP(JSTATE).GT.SPHMAX) GO TO 1
         IF (ITAKEN(JSTATE).EQ.000000) GO TO 1
C
         ITAKEN(JSTATE)=0
C
         EAVERA=ESINGP(JSTATE)
         IPARAC=IPARIT(JSTATE)
         MAINAC=N_MAIN(JSTATE)
C
         IAVERA=1
C
         DO ISTATE=JSTATE+1,LDBASE
C
            IF (ITAKEN(ISTATE).EQ.000000) GO TO 2
C
            IF (IPARIT(ISTATE).NE.IPARAC) GO TO 2
C
            IF (N_MAIN(ISTATE).NE.MAINAC) GO TO 2
C
            IF (ABS(ESINGP(JSTATE)-ESINGP(ISTATE)).LT.EPSDEG) THEN
C
                ITAKEN(ISTATE)=0
C
                IAVERA=IAVERA+1
                EAVERA=EAVERA+ESINGP(ISTATE)
C
            END IF
C
   2        CONTINUE
C
         END DO
C
         JSPHER=JSPHER+1
C
         IF (JSPHER.GT.NDBASE) STOP 'JSPHER.GT.NDBASE in SPHCRT <<= '
C
C=======================================================================
C        The degeneracy, as calculated above does not take into
C        account the Kramers degeneracy and thus we multiply it
C        by a factor of 2 - to get the full physical degeneracy
C=======================================================================
C
         IDEGEN(JSPHER)=2*IAVERA
C
         ESPHER(JSPHER)=EAVERA/REAL(IAVERA)
C
         IPWSPH(JSPHER)=IPARAC
C
         NWSSPH(JSPHER)=MAINAC
         JWSSPH(JSPHER)=2*IAVERA-1
         LWSSPH(JSPHER)=(JWSSPH(JSPHER)+1)/2
C
         IF (MOD(LWSSPH(JSPHER),2).EQ.1.AND.IPARAC.EQ.+1.OR.
     *       MOD(LWSSPH(JSPHER),2).EQ.0.AND.IPARAC.EQ.-1) THEN
C
             LWSSPH(JSPHER)=(JWSSPH(JSPHER)-1)/2
C
         END IF
C
         IF (LWSSPH(JSPHER).GT.NDSPHE) THEN
             WRITE(NOUTPT,'(/,''LWSSPH='',I4,'' exceeds NDSPHE='',I3)')
     *                     LWSSPH(JSPHER),         NDSPHE
             WRITE(NOUTPT,'(  ''ESPHER='',F8.4)')       ESPHER(JSPHER)
             STOP 'LWSSPH(JSPHER).GT.NDSPHE in SPHCRT <<= '
         END IF
C
   1     CONTINUE
C
      END DO
C
C=======================================================================
C
      LDSPHE=JSPHER
C
C=======================================================================
C     Checking consistency - are there more labels than patterns?
C=======================================================================
C
      IF (LDSPHE.GT.NDSH12.AND.IWRITE.GE.1) THEN
C
          WRITE(NOUTPT,'(/,80(''!''),/,''!!'',76X,''!!'',/,
     *                ''!!  You have'',I4,'' levels calculated -- '',
     *                ''more than the number of exact patterns  !!'',/,
     *                ''!!'',76X,''!!'',/,80(''!''))')
     *
     *                                                 LDSPHE
C
      END IF
C
C=======================================================================
C
      DO LSPHER=1,LDSPHE
         INDEXS(LSPHER)=LSPHER
      END DO
C
C=======================================================================
C
      CALL WS_ORDER1(ESPHER,INDEXS,LDSPHE,NDBASE)
C
C=======================================================================
C     Constructing all the 'in principle' possible symbols  (labels)
C     that can be constructed on the basis of the degeneracies found
C=======================================================================
C
      DO KSPHER=1,LDSPHE
C
         LSPHER=INDEXS(KSPHER)
C
         IF (IDEGEN(LSPHER).EQ.(JWSSPH(LSPHER)+1)) THEN
C
             IF (JWSSPH(LSPHER).GT.10) THEN
                 WRITE(LBSPHE(KSPHER),'(''0'',A1,I2,''/2'')')
     *                  PATSPH(LWSSPH(LSPHER)),JWSSPH(LSPHER)
             ELSE
                 WRITE(LBSPHE(KSPHER),'(''0'',A1,I1,''/2'')')
     *                  PATSPH(LWSSPH(LSPHER)),JWSSPH(LSPHER)
             END IF
C
         ELSE
C
             IF (JWSSPH(LSPHER).GT.10) THEN
                 WRITE(LBSPHE(KSPHER),'(''0'',''?'',I2,''/2'')')
     *                                            JWSSPH(LSPHER)
             ELSE
                 WRITE(LBSPHE(KSPHER),'(''0'',''?'',I1,''/2'')')
     *                                            JWSSPH(LSPHER)
             END IF
C
         END IF
      END DO
C
C=======================================================================
C     Printing the labels
C=======================================================================
C
      IF (IWRITE.GE.1)
     *    WRITE(NOUTPT,'(/,80(''#''),/,''#'',78X,''#'',/,
     *            ''#   Spherical Labelling of the Woods'',
     *            ''-Saxon Spectrum (Crt.)    Z='',I3,''   N='',I3,
     *            ''    #'')')
     *                                            IZ_FIX,IN_FIX
C
      IF (IDEFOR.EQ.1.AND.IWRITE.GE.1) THEN
C
          WRITE(NOUTPT,'(''#'',78X,''#'',/,
     *              ''#      WARNING!  Deformation greater than'',
     *              ''  EPSDEF='',F4.2,''  has been detected      #'')')
     *                  EPSDEF
      END IF
C
      IF (IWRITE.GE.1)
     *    WRITE(NOUTPT,'(''#'',78X,''#'',/,80(''#''),/,
     *            ''#'',78X,''#'',/,
     *            ''#   No)     Energy     State   ( P )   '',
     *            ''    No)     Energy     State   ( P )    #'',/,
     *            ''#'',78X,''#'')')
C
C=======================================================================
C
      DO LSPHER=0,NOSMAX
         DO JSPHER=1,NOSMAX+NOSMAX+1,2
            ICOUNT=0
            DO KSPHER=1,LDSPHE
               IF (LWSSPH(INDEXS(KSPHER)).EQ.LSPHER.AND.
     *             JWSSPH(INDEXS(KSPHER)).EQ.JSPHER) THEN
                   ICOUNT=ICOUNT+1
                   WRITE(LBSPHE(KSPHER)(1:1),'(I1)') ICOUNT
               END IF
            END DO
         END DO
      END DO
C
C=======================================================================
C     Limiting the number of states that will apear on the print
C=======================================================================
C
      LDKEEP=LDSPHE
      DO I=1,LDSPHE
         IF (ESPHER(I).GT.SPHMAX) THEN
             LDKEEP=I-1
             GO TO 3
         END IF
      END DO
C
   3  CONTINUE
C
C=======================================================================
C
      LDLINE=LDKEEP/2
C
      DO LINE=1,LDLINE
C
         LINE_1=LINE
         LINE_2=LDLINE+LINE
C
         IF (IWRITE.GE.1)
     *       WRITE(NOUTPT,'(''#  '', I3,'')'',F12.5,4X,A6,
     *                  ''   ('',I2,'')'',
     *                  ''      '',I3,'')'',F12.5,4X,A6,
     *                  ''   ('',I2,'')'',
     *                                       ''    #'')')
     *
     *   LINE_1,ESPHER(LINE_1),LBSPHE(LINE_1),IPWSPH(LINE_1),
     *   LINE_2,ESPHER(LINE_2),LBSPHE(LINE_2),IPWSPH(LINE_2)
C
      END DO
C
C=======================================================================
C
      IF (IWRITE.GE.1)
     *    WRITE(NOUTPT,'(''#'',78X,''#'',/,80(''#''))')
C
C=======================================================================
C
C     Here verifying whether there was a single-degenerate spherical
C     level or there are two degenerate spherical levels of the same
C     parity
C
C=======================================================================
C
C     Checking whether there are more than one label each - or short
C     theory of dealing with the basis cut-off and the labels:
C
C     One of the byproducts of the basis cut off is that towards the
C     high energy limit, some couplings are missing and the obtained
C     solutions resemble less and less  the real solutions of the WS
C     problem. As a consequence there may be levels which accidental-
C     ly coincide thus producing less states than in reality, or the
C     states that have their degeneracy split  by more than  EPSILON
C     used will be qualified as separate orbitals while they are NOT;
C     All that may lead  to artificially increased numbers of the de-
C     generate (real, correct) levels.  With the method used here we
C     cannot guarantee the truth (hue, hue ...), but at least we may
C     check how far from it we are (not bad this, huemm?)
C
C=======================================================================
C
      EEROR1=10000
      IERROR=0
C
      DO I=1,LDSPHE
C
         INDLAB(I)=0
C
         DO J=1,LDSPHE
            IF (I.NE.J) THEN
                IF (LBSPHE(I).EQ.LBSPHE(J)) THEN
                    INDLAB(I)=INDLAB(I)+1
                END IF
            END IF
         END DO
C
C        Below: EERROR denotes the energy above which the labels are
C               not guaranteed certain, because two identical labels
C               appeared
C
         IF (INDLAB(I).GT.1) THEN
             IERROR=IERROR+1
             IF (IERROR.EQ.1) THEN
                 EEROR1=ESPHER(I)
             END IF
         END IF
C
      END DO
C
C=======================================================================
C
      IF (IERROR.GT.0.AND.IWRITE.GE.1) THEN
C
          WRITE(NOUTPT,'(/,80(''!''),/,''!!'',76X,''!!'',/,
     *                ''!!  There were'',I4,
     *                '' labels that are not unique:'',
     *                '' Energy of the first one'',F6.2,''  !!'',/,
     *                ''!!'',76X,''!!'',/,80(''!''))')
     *
     *                                                IERROR,EEROR1
C
      END IF
C
C=======================================================================
C     Checking whether there are some alltogether missing labels
C=======================================================================
C
      EEROR2=10000
      IERROR=0
C
      DO J=1,NDSH12
C
         N0MAIN=NBMAIN(J)
C
         IF (N0MAIN.GT.NOSMAX) GO TO 4
C
         IABSNT(J)=+1
C
C        Below verifying whether a studied PATTERN LABEL which in
C        principle MUST exist in the spectrum has in reality been
C        found
C
         DO I=1,LDSPHE
C
            K=INDEXS(I)
C
            IF (LBSPHE(K).EQ.LBSHEL(J)) THEN
C
                IABSNT(J)=IABSNT(J)-1
C
            END IF
C
         END DO
C
         IF (IABSNT(J).EQ.1) THEN
             IERROR=IERROR+1
             IF (IERROR.EQ.1) THEN
                 EEROR2=ESPHER(J)
             END IF
         END IF
C
   4     CONTINUE
C
      END DO
C
C=======================================================================
C
      IF (IERROR.GT.0.AND.IWRITE.GE.1) THEN
C
          WRITE(NOUTPT,'(/,80(''!''),/,''!!'',76X,''!!'',/,
     *                ''!!  Above energy of '',F7.4,
     *                '' MeV, there are at least'',I3,
     *                '' ill-identified labels  !!'',/,
     *                ''!!'',76X,''!!'',/,80(''!''))')
     *
     *                                   EEROR2,IERROR
C
      END IF
C
C=======================================================================
C
          ISWITH=0
C
      IF (EEROR1.LT.EMAXCH.OR.EEROR2.LT.EMAXCH) THEN
C
          ISWITH=1
C
                                EERROR=EEROR1
          IF (EERROR.GT.EEROR2) EERROR=EEROR2
C
	  IF (IWRITE.GE.1)
     *        WRITE(NOUTPT,'(/,80(''!''),/,''!!'',76X,''!!'',/,
     *                ''!!  You have requested  the control of '',
     *                ''exactitude  for the  spherical labels  !!'',/,
     *                ''!!  between: EMINCH='',F7.3,
     *                '' MeV and EMAXCH='',F6.3,
     *                '' MeV;   EERROR ='',F7.3,'' MeV  !!'',/,
     *                ''!!'',76X,''!!'',/,80(''!''))')
     *
     *                                      EMINCH,EMAXCH,EERROR
C
      END IF
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C=======================================================================
C
      SUBROUTINE WS_WAVEFU(ISTATE,N_BASE,MAIN_S,LSPH_S,JMOM_S,MMOM_S,
     *                                                 ZLAGUE,R_MAXI)
C=======================================================================
      USE params
C=======================================================================
C
      COMPLEX
     *          WAVCOE
C
      DIMENSION
     *          ZLAGUE(1:NDMESH,0:NDLAGE,0:NDLAGE)
      DIMENSION
     *          MAIN_S(1:MDTVE2),LSPH_S(1:MDTVE2),
     *          MMOM_S(1:MDTVE2),JMOM_S(1:MDTVE2)
      DIMENSION
     *          RFACTO(1:NDMESH),R_AUXI(1:NDMESH)
C
      COMMON
     *       /SPHONL_SPWAVE/ WAVCOE(1:MDTVE2)
      COMMON
     *       /WAVEFU_RADPRO/ DISPRO(1:NDBASE,1:NDMESH),RADPRO(1:NDMESH)
     *       /WAVEFU_LDRADI/ LDRADI
      COMMON
     *       /SETBAS_HOMOSC/ HBAROX,HBAROY,HBAROZ,
     *                       SQXFAC,SQYFAC,SQZFAC,
     *                                     HOMOSC
     *
     *       /SETBAS_CENMAS/ XCMPOS,YCMPOS,ZCMPOS
     *
     *       /SETBAS_DIMENS/ LDBASE
      COMMON
     *       /PARAMS_RADVOL/ RADIUS,CVOLFC,RCVOLM
C
      COMMON
     *       /READWRITE_PAR/ NOUTPT,IWRITE,ISCREN
C
C=======================================================================
C
C        This subroutine calculates the space representation of the
C        nucleonic density from the Woods-Saxon  deformed potential
C        a t  t h e  u s e r  d e f i n e d   m e s h   p o i n t s
C
C        To make enemies life more difficult numbers of the user de-
C        fined points are limited by parameters called N{x,y,z}HERM
C        although these  have nothing in common with  Gauss-Hermite
C        integration formulae.
C
C=======================================================================
C
      IF (ISTATE.GT.LDBASE) RETURN
C
C=======================================================================
C
      CALL WS_CPUTIM('WAVEFU',1)
C
C=======================================================================
C
      LDRADI=NDMESH
C
      DO IRADIU=1,LDRADI
         RFACTO(IRADIU)=0.0
      END DO
C
C=======================================================================
C
      DO I_BASE=1,N_BASE
C
         NSPHRI=MAIN_S(I_BASE)
         LSPHRI=LSPH_S(I_BASE)
         JSPHRI=JMOM_S(I_BASE)
         MSPHRI=MMOM_S(I_BASE)
C
         NSMALI=(NSPHRI-LSPHRI)/2
C
         DO J_BASE=1,N_BASE
C
            NSPHRJ=MAIN_S(J_BASE)
            LSPHRJ=LSPH_S(J_BASE)
            JSPHRJ=JMOM_S(J_BASE)
            MSPHRJ=MMOM_S(J_BASE)
C
            NSMALJ=(NSPHRJ-LSPHRJ)/2
C
            IF ((LSPHRI.EQ.LSPHRJ).AND.
     *          (JSPHRI.EQ.JSPHRJ).AND.
     *          (MSPHRI.EQ.MSPHRJ)) THEN
C
                 LSPHER=LSPHRI
C
                 DO IRADIU=1,LDRADI
C
                    BFACTO=1.0/SQXFAC/RCVOLM
                    XHIVAR=BFACTO*RADPRO(IRADIU)
C
                    POLBRA=ZLAGUE(IRADIU,NSMALI,LSPHER)
                    POLKET=ZLAGUE(IRADIU,NSMALJ,LSPHER)
C
                    RFUNCI=EXP(-XHIVAR**2/2.0)*XHIVAR**LSPHER
     *                    *POLBRA
                    RFUNCJ=EXP(-XHIVAR**2/2.0)*XHIVAR**LSPHER
     *                    *POLKET
C
                    R_AUXI(IRADIU)=RFUNCI*RFUNCJ
C
                    RFACTO(IRADIU)=RFACTO(IRADIU)+RFUNCI*RFUNCJ
     *                 *REAL(CONJG(WAVCOE(I_BASE))*WAVCOE(J_BASE))
C
                 END DO
C
                 H_STEP=1.0/REAL(LDRADI)*R_MAXI
C
                 SUMAUX=0.5*(R_AUXI(1)*RADPRO(1)**2
     *                      +R_AUXI(LDRADI)*RADPRO(LDRADI)**2)
                 DO IRADIU=2,LDRADI-1
                    SUMAUX=SUMAUX+R_AUXI(IRADIU)*RADPRO(IRADIU)**2
                 END DO
                 SUMRAD=SUMAUX*H_STEP
C
            END IF
C
         END DO
      END DO
C
      DO IRADIU=1,LDRADI
         DISPRO(ISTATE,IRADIU)=RFACTO(IRADIU)
      END DO
C
      H_STEP=1.0/REAL(LDRADI)*R_MAXI
C
      SUMAUX=0.5*(DISPRO(ISTATE,1)*RADPRO(1)**2
     *           +DISPRO(ISTATE,LDRADI)*RADPRO(LDRADI)**2)
C
      DO IRADIU=2,LDRADI-1
         SUMAUX=SUMAUX+DISPRO(ISTATE,IRADIU)*RADPRO(IRADIU)**2
      END DO
C
      SUMRAD=SUMAUX*H_STEP
C
      IF (IWRITE.GE.1)
     *WRITE(NOUTPT,'(''NORMALIZATION OF THE RADIAL PART OF THE WAVE '',
     *               ''FUNCTION : '',F30.20)') SUMRAD
C
C=======================================================================
C
      CALL WS_CPUTIM('WAVEFU',0)
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C=======================================================================
C
      SUBROUTINE WS_SPHONL(ISOSPI,NOFLIN,LABSPH,IWAVSP,EMINST,EMAXST,
     *                     OMEGAC,ISIGNY,IPAORD,IREVER,EMINWF,EMAXWF,
     *                     NOSCIL,ISOTRO,SPHMAX,RYTEXT,R_MAXI,IFWAVE)
C=======================================================================
      USE params
C=======================================================================
C
      CHARACTER
     *          NILSPH*17,FORM_A*1,FORM_B*1
      CHARACTER
     *          RYTEXT(0:NDREVE)*5
C
      COMPLEX
     *          RES_UP(1:MDBASE,1:MDTRAN,0:NDPARI),
     *          RES_DW(1:MDBASE,1:MDTRAN,0:NDPARI)
      COMPLEX
     *          AUXSPH(1:MDTRAN,1:MDTRAN,0:NDPARI)
      COMPLEX
     *          EWAVEF,UNIT_I,WAVESP,WAVCOE
      COMPLEX
     *          WVTRAN(1:MDBASE,1:MDTRAN)
C
      INTEGER*2
     *          KDEFIN(0:MDMAIN,2,0:MDMAIN,-MDJSPH:MDJSPH)
C
      DIMENSION
     *          WAVESP(0:MDMAIN,2,0:MDMAIN,0:MDJSPH)
      DIMENSION
     *          MAIN_S(1:MDTVE2),LSPH_S(1:MDTVE2),
     *          MMOM_S(1:MDTVE2),JMOM_S(1:MDTVE2)
      DIMENSION
     *          AMPLT2(1:MDBAS2),NSTATE(1:MDBAS2),
     *          AUXVEC(1:MDBAS2),PTOTAL(1:MDBAS2)
      DIMENSION
     *          MINDEX(1:MDBAS2),LINDEX(1:MDBAS2)
      DIMENSION
     *          CONST1(0:MDMAIN,-MDMAIN:MDMAIN),
     *          CONST2(0:MDMAIN,-MDMAIN:MDMAIN),
     *          CONST3(0:MDMAIN,-MDMAIN:MDMAIN),
     *          CONST4(0:MDMAIN,-MDMAIN:MDMAIN)
      DIMENSION
     *          ZLAGUE(1:NDMESH,0:NDLAGE,0:NDLAGE)
      DIMENSION
     *          XLAGUE(-1:NDLAGE)
      DIMENSION
     *          FACTOR(0:NDFACT)
      DIMENSION
     *          IPAORD(1:NDBASE)
C
      COMMON
     *       /REVIEWING_PAR/ INDCAR,INDNIL,INDSPL,INDSPE,INDDEN,INDDEP,
     *                                                          INDSPI
      COMMON
     *       /WAVEFU_RADPRO/ DISPRO(1:NDBASE,1:NDMESH),RADPRO(1:NDMESH)
     *
     *       /WAVEFU_LDRADI/ LDRADI
      COMMON
     *       /KARSPH_NBASER/ NBASER(1:MDTRAN,0:NDPARI),
     *                       NBASZP(1:MDTRAN,0:NDPARI),
     *                       NBASEM(1:MDTRAN,0:NDPARI),
     *                       LDTRAN
     *
     *       /KARSPH_NXNYNZ/ NX_VEC(1:MDTRAN,0:NDPARI),
     *                       NY_VEC(1:MDTRAN,0:NDPARI),
     *                       NZ_VEC(1:MDTRAN,0:NDPARI)
     *
     *       /KARSPH_PARITY/ IDPARI(1:MDTRAN,0:NDPARI)
     *
     *       /KARSPH_DIMPAR/ LDKARP(0:NDPARI)
     *
     *       /KARSPH_CYLDIM/ LDCYLP(0:NDPARI)
      COMMON
     *       /SPHONL_SPHERE/ MAIN0S(1:NDBASE,0:NDREVE),
     *                       JMOM0S(1:NDBASE,0:NDREVE),
     *                       LSPH0S(1:NDBASE,0:NDREVE),
     *                       MMOM0S(1:NDBASE,0:NDREVE)
     *
     *       /SPHONL_QUOSPH/ QUOTSP(1:NDBASE,0:NDREVE)
     *
     *       /SPHONL_SPWAVE/ WAVCOE(1:MDTVE2)
     *
     *       /SPHONL_NILSPH/ NILSPH(1:NDBASE)
     *
     *       /SPHONL_SPHSPH/ ISWITH
     *       /SPHONL_L0STAT/ L_STAT
      COMMON
     *       /SPECTR_ESINGP/ ESINGP(1:NDBASE),PARITY(1:NDBASE)
     *
     *       /SPECTR_SPINOR/ EWAVEF(1:NDBASE,1:NDBASE)
      COMMON
     *       /SETBAS_HOMOSC/ HBAROX,HBAROY,HBAROZ,
     *                       SQXFAC,SQYFAC,SQZFAC,
     *                                     HOMOSC
     *
     *       /SETBAS_CENMAS/ XCMPOS,YCMPOS,ZCMPOS
     *
     *       /SETBAS_NOSMAX/ MAXBNX,MAXBNY,MAXBNZ,
     *                                     NOSMAX
     *       /SETBAS_DIMENS/ LDBASE
      COMMON
     *       /PARAMS_RADVOL/ RADIUS,CVOLFC,RCVOLM
C
      COMMON
     *       /READWRITE_PAR/ NOUTPT,IWRITE,ISCREN
C
      DATA
     *       EPSPHR  / 0.000001 /
      DATA
     *       EPSMUL  / 1.00D-14 /
C
C=======================================================================
C
C     In this subroutine, we calculate the spherical labels of the
C     Woods-Saxon eigenstates, as well as their expansion onto the
C     spherical states
C
C=======================================================================
C
      INDTOT=LABSPH+IWAVSP+INDSPL
C
      IF (INDTOT.EQ.0) RETURN
C
C=======================================================================
C
      IF (ISOTRO.NE.1.AND.IWRITE.GE.1) THEN
C
          WRITE(NOUTPT,'(/,80(''!''),/,''!!'',76X,''!!'',/,
     *                   ''!! ISOTRO must be equal to 1'',
     *                   '' in order the spherical labels to be '',
     *                   '' calculated  !!'',/,''!!'',76X,''!!'',/,
     *                   ''!!       Subroutine SPHONL is beeing '',
     *                   ''skipped  -  PROGRAM CONTINUES'',
     *                   ''            !!'',/,
     *                   ''!!'',76X,''!!'',/,80(''!''),/)')
          RETURN
C
      END IF
C
C=======================================================================
C
C     SPHMAX - Single particle states with E < SPHMAX go to review
C
C     EMINST - The states with E > EMINST will be printed on outpt.
C     EMAXST - The states with E < EMAXST will be printed on outpt.
C
C     EMINWF - Wave-functions are printed when energies E > EMINWF
C     EMAXWF - Wave-functions are printed when energies E < EMAXWF
C
C=======================================================================
C
      IF (NOSCIL.GT.NDOLAB.AND.IWRITE.GE.1) THEN
C
C         The spherical labels can be calculated for NOSCIL.le.NDOLAB
C
          WRITE(NOUTPT,'(/,80(''!''),/,''!!'',76X,''!!'',/,
     *                   ''!! The number of shells used NOSCIL='',I2,
     *                   '' exceeds the number of shells NDOLAB='',I2,
     *                   '' !!'',/,
     *                   ''!! Increase NDOLAB to get correctly the '',
     *                   ''spherical labels -  '',
     *                   ''PROGRAM CONTINUES !!'',/,
     *                   ''!!'',76X,''!!'',/,80(''!''),/)')
     *
     *                                                  NOSCIL,NDOLAB

          RETURN
C
      END IF
C
C=======================================================================
C
      IF (.NOT.(ABS(HBAROX-HBAROY).LT.EPSPHR.AND.
     *          ABS(HBAROX-HBAROZ).LT.EPSPHR)) THEN
C
          IF ((LABSPH.EQ.1.OR.IWAVSP.EQ.1).AND.IWRITE.GE.1) THEN
C
              WRITE(NOUTPT,'(//,''Commands: LABSPH='',I1,
     *                          '' or IWAVSP='',I1,
     *                       '' impossible here'')') LABSPH,IWAVSP
C
              WRITE(NOUTPT,'(//,''The basis is not spherical: HBAROX='',
     *                                                   F20.12,2X,
     *                                                 ''HBAROY='',
     *                                                   F20.12,2X,
     *                                                 ''HBAROZ='',
     *                                                   F20.12,2X)')
     *                                           HBAROX,HBAROY,HBAROZ
C
              WRITE(NOUTPT,'(//,''Set ISOTRO=1'',
     *                          '' or deformations to zero'')')
C
              STOP 'Should ISOTRO be 1? <<= '
C
          END IF
      END IF
C
C=======================================================================
C
      IF (MOD(MDMAIN,2).EQ.0) THEN
C
          LDMEVE=((MDMAIN+2)*(MDMAIN+4)*(MDMAIN+MDMAIN+3))/24
C
          IF (NDTRAN.NE.LDMEVE) THEN
C
              WRITE(NOUTPT,'(//,''LDMEVE='',I4,
     *                          '' should be equal NDTRAN='',I4)')
     *                                             LDMEVE,NDTRAN
              STOP 'NDTRAN.NE.LDMEVE <<= '
C
          END IF
C
      ELSE
C
          LDMODD=((MDMAIN+1)*(MDMAIN+3)*(MDMAIN+MDMAIN+7))/24
C
          IF (NDTRAN.NE.LDMODD) THEN
C
              WRITE(NOUTPT,'(//,''LDMODD='',I4,
     *                          '' should be equal NDTRAN='',I4)')
     *                                             LDMODD,NDTRAN
              STOP 'NDTRAN.NE.LDMODD <<='
C
          END IF
C
      END IF
C
C=======================================================================
C
      CALL WS_CPUTIM('SPHONL',1)
C
C=======================================================================
C     Calculating the factorial
C=======================================================================
C
      FACTOR(0)=1.0D0
      FACTOR(1)=1.0D0
C
      DO I=2,NDFACT
         FACTOR(I)=REAL(I,KIND=8)*FACTOR(I-1)
      END DO
C
C=======================================================================
C
C     We calculate the generalized Laguerre polynomials at points
C     RADPRO(IRADIU). The generalized Laguerre polynomials are of
C                 l+1/2
C     the form:  L     (x)
C                  n
C=======================================================================
C
      NPOINT=NDMESH
C
      PIARGU=4.0D0*ATAN(1.0D0)
      GAMM12=SQRT(PIARGU)
C
      IF (IFWAVE.EQ.1) THEN
C
          DO IRADIU=1,NPOINT
             RADPRO(IRADIU)=REAL(IRADIU,KIND=8)
     *                     /REAL(NPOINT,KIND=8)*R_MAXI
          END DO
C
          DO N=0,NDMAIN
             DO L=0,NDMAIN
C
                DO IRADIU=1,NPOINT
C
C=======================================================================
C                  We work in the spherical basis: SQXFAC=SQYFAC=SQZFAC
C=======================================================================
C
                   BFACTO=1.0/SQXFAC/RCVOLM
C
                   XHIVAR=BFACTO*RADPRO(IRADIU)
                   ARGUME=XHIVAR**2
C
                   CALL WS_DLAGUE(ARGUME,XLAGUE,FACTOR,N,L)
C
                   NGAMMA=N+L+1
C
                   XNORME=BFACTO*
     *               2.0**NGAMMA*SQRT(FACTOR(N)*2.0*BFACTO*
     *                 FACTOR(NGAMMA)/FACTOR(2*NGAMMA)/GAMM12)
C
                   ZLAGUE(IRADIU,N,L)=XNORME*XLAGUE(L)
C
                END DO
C
             END DO
          END DO
C
      END IF
C
C=======================================================================
C     Subroutine SPHXYZ performs transformation from the Cartesian
C     basis to the spherical basis "without spin",  i.e. the basis
C     assumed has the form |N, l, m_l >
C=======================================================================
C
      NOSMAX=MIN(NOSCIL,NDOLAB)
C
      CALL WS_SPHXYZ(NOSMAX,AUXSPH)
C
C=======================================================================
C     Here, we define the Clebsch-Gordan coefficients as functions
C     of L and Ml. They will be used in the L and S coupling
C=======================================================================
C
      DO LSPHER=0,NOSMAX
         DO MLSPHR=-LSPHER,+LSPHER
C
            XXX1=REAL(LSPHER+MLSPHR+1)
            XXX2=REAL(LSPHER-MLSPHR  )
            XXX3=REAL(LSPHER-MLSPHR+1)
            XXX4=REAL(LSPHER+MLSPHR  )
C
            XXX5=REAL(LSPHER+LSPHER+1)
C
            CONST1(LSPHER,MLSPHR)=SQRT(XXX1/XXX5)
            CONST2(LSPHER,MLSPHR)=SQRT(XXX2/XXX5)
            CONST3(LSPHER,MLSPHR)=SQRT(XXX3/XXX5)
            CONST4(LSPHER,MLSPHR)=SQRT(XXX4/XXX5)
C
         END DO
      END DO
C
C=======================================================================
C
C     Here, we do historically justified (of course) a manipulation,
C     which consists in:
C
C     1. Splitting the future final matrix into two parts, that are
C        related to the two projections of the nucleonic spin;
C
C     2. Multiplying AUXSPH <<==>> {nx,ny,nz|n,l,ml}, by a suitable
C        factor in order to make the link with the t-basis  but the
C        word  'suitable'  appears in the most mysterious context);
C
C     3. Multiplying  wave functions-transposed  by AUXSPH  so that
C        we get them in terms of representation |nl,ml>
C
C     It seems that the 't' vector considered below could be
C
C                       |t+> = 1/sqrt(2)*( i|b> - |b~>)
C
C     provided one uses the convention of Condon-Shortley
C
C=======================================================================
C
      UNIT_I=CMPLX(0.0,1.0)
C
      DO IPARIT=0,NDPARI
C
         DO IBRAPA=1,LDKARP(IPARIT)
            DO INDKET=1,LDBASE
               WVTRAN(INDKET,IBRAPA)
     *        =EWAVEF(IDPARI(IBRAPA,IPARIT),INDKET)
            END DO
         END DO
C
         NDAROW=MDBASE
         NDACOL=MDTRAN
         LDAROW=LDBASE
         LDACOL=LDKARP(IPARIT)
C
         NDBROW=MDTRAN
         NDBCOL=MDTRAN
         LDBROW=LDKARP(IPARIT)
         LDBCOL=LDCYLP(IPARIT)
C
         NDCROW=MDBASE
         NDCCOL=MDTRAN
         LDCROW=LDBASE
         LDCCOL=LDCYLP(IPARIT)
C
C=======================================================================
C
         DO J=1,MDTRAN
            DO I=1,MDBASE
               RES_DW(I,J,IPARIT)=CMPLX(0.0,0.0)
               RES_UP(I,J,IPARIT)=CMPLX(0.0,0.0)
            END DO
         END DO
C
C=======================================================================
C        Below, the first operation is performed, which gives us the
C        spin-down projection.
C=======================================================================
C
         DO JSPHER=1,LDCYLP(IPARIT)
            DO IKARTE=1,LDKARP(IPARIT)
C
               NY=NY_VEC(IKARTE,IPARIT)
C
               AUXSPH(IKARTE,JSPHER,IPARIT)
     *        =AUXSPH(IKARTE,JSPHER,IPARIT)*(+UNIT_I)**(NY)/SQRT(2.00)
C
            END DO
         END DO
C
         FORM_A='N'
         FORM_B='N'
C
         CALL WS_CCSPRS(WVTRAN,NDAROW,NDACOL,LDAROW,LDACOL,FORM_A,
     *                  AUXSPH(1,1,IPARIT),
     *                         NDBROW,NDBCOL,LDBROW,LDBCOL,FORM_B,
     *                  RES_DW(1,1,IPARIT),
     *                         NDCROW,NDCCOL,LDCROW,LDCCOL,EPSMUL)
C
C=======================================================================
C        Now, we perform the second operation in order to get the
C        spin-up projections
C=======================================================================
C
         DO JSPHER=1,LDCYLP(IPARIT)
            DO IKARTE=1,LDKARP(IPARIT)
C
               NY=NY_VEC(IKARTE,IPARIT)
C
               AUXSPH(IKARTE,JSPHER,IPARIT)
     *        =AUXSPH(IKARTE,JSPHER,IPARIT)*(-1)**(NY+1)*UNIT_I
C
            END DO
         END DO
C
         FORM_A='N'
         FORM_B='N'
C
         CALL WS_CCSPRS(WVTRAN,NDAROW,NDACOL,LDAROW,LDACOL,FORM_A,
     *                  AUXSPH(1,1,IPARIT),
     *                         NDBROW,NDBCOL,LDBROW,LDBCOL,FORM_B,
     *                  RES_UP(1,1,IPARIT),
     *                         NDCROW,NDCCOL,LDCROW,LDCCOL,EPSMUL)
C
      END DO
C
C=======================================================================
C
      ICOUNT=0
C
      DO ISTATE=1,LDBASE
C
         IF (ESINGP(ISTATE).GT.SPHMAX) GO TO 2
C
C=======================================================================
C
         N_BASE=0
C
         PTOTAL(ISTATE)=0.000
C
C=======================================================================
C
C        In the do-loop below, we construct auxiliary arrays that will
C        be used later. The parameters used below are the following:
C
C        NTOTAL - the number of major shells 'N';
C
C        LSPHER - the l quantum number.  One has of course: N = 2*nr+l
C
C        KSPHER = 1 corresponds to the case: j = l - 1/2
C        KSPHER = 2 corresponds to the case: j = l + 1/2
C
C        KJSPHR - the index corresponding to m_j quantum number. It is
C                 used to avoid arrays having indices ranging from  -j
C                 to j, one of those brilliant ideas that make us love
C                 Ch...
C
C=======================================================================
C
         DO NTOTAL=0,NOSMAX
            NRM1MX=(NTOTAL-MOD(NTOTAL,2))/2
C
            DO NRMIN1=0,NRM1MX
               LSPHER=NTOTAL-2*NRMIN1
C
                  KSPHER=0
               DO JSPHER=2*LSPHER-1,2*LSPHER+1,2
                  KSPHER=KSPHER+1
C
                  IF (JSPHER.GE.0) THEN
C
                      DO MJSPHR=-JSPHER,+JSPHER,2
C
                         KDEFIN(NTOTAL,KSPHER,LSPHER,MJSPHR)
     *                 =(MJSPHR+JSPHER)/2
C
                         KJSPHR=(MJSPHR+JSPHER)/2
C
                         WAVESP(NTOTAL,KSPHER,LSPHER,KJSPHR)
     *                  =CMPLX(0.0,0.0)
C
                      END DO
C
                  END IF
C
               END DO
            END DO
         END DO
C
C=======================================================================
C        Calculations are performed for each block of parity separately
C=======================================================================
C
         DO IPARIT=0,NDPARI
C
            IF (ISIGNY.EQ.1.AND.IPARIT.NE.IPAORD(ISTATE)) GO TO 1
C
            DO JSPHER=1,LDCYLP(IPARIT)
C
               NRMIN1=NBASER(JSPHER,IPARIT)
               LSPHER=NBASZP(JSPHER,IPARIT)
               MLSPHR=NBASEM(JSPHER,IPARIT)
C
C=======================================================================
C
C              Each Cartesian state of a good simplex, or of a good
C              signature  must have the spherical decomposition  of
C              the type
C
C                       |SIMPLEX> = ALFA * |N,nr,j,+OMEGA>
C                                 + BETA * |N,nr,j,-OMEGA>
C
C              where
C                       ABS(ALFA) = ABS(BETA)
C
C              Consequently, there is no need to calculate the spin-
C              up  and spin-down projections separately, as long as
C              the  Nilsson labels,  or the solution  wave-function
C              decompositions in terms of the WS ones are concerned.
C              Therefore below we take only one sign: ("up")
C
C              However,  for the calculations involving the possibi-
C              lities of the interference effects,  both amplitudes
C              should be treated on the same footing,  and we leave
C              corresponding instructions commented out - for  easy
C              re-introduction
C
C=======================================================================
C
C              Below we calculate  the spherical labels  |N,l,j,m>,
C              with spin included starting with |N,l,ml> (no spin).
C              This implies some gymnastics, to obtain the quantum
C              numbers in the coupled representation from the ones
C              in the non-coupled representation:
C
C              N, l, mr    ->    N, l, j = l +/- 1/2, mj = ml + ms
C
C=======================================================================
C
               IF (LSPHER.NE.0)  THEN
C
                   NTOTAL=2*NRMIN1+LSPHER
C
                   IF (MOD(NTOTAL,2).EQ.IPARIT) THEN
C
                       KSPHE1=2
                       KSPHE2=1
C
                       DO N_SPIN=-1,1,2
C
C=======================================================================
C
C                         Case N_SPIN=1 which corresponds to m_s=+1/2
C
C                         As "usual":
C
C                         KSPHE1 represents j=l+1/2 (projection   up)
C                                             and
C                         KSPHE2 represents j=l-1/2 (projection down)
C
C=======================================================================
C
                          IF (N_SPIN.EQ.1)  THEN
C
                              MJSPHR=2*MLSPHR+1
C
                              KJSPHR=KDEFIN(NTOTAL,KSPHE1,LSPHER,MJSPHR)
C
                              WAVESP(NTOTAL,KSPHE1,LSPHER,KJSPHR)
     *                       =WAVESP(NTOTAL,KSPHE1,LSPHER,KJSPHR)
     *                       +RES_DW(ISTATE,JSPHER,IPARIT)
     *                       *CONST1(LSPHER,MLSPHR)
C
                              KJSPHR=KDEFIN(NTOTAL,KSPHE2,LSPHER,MJSPHR)
C
                              WAVESP(NTOTAL,KSPHE2,LSPHER,KJSPHR)
     *                       =WAVESP(NTOTAL,KSPHE2,LSPHER,KJSPHR)
     *                       -RES_DW(ISTATE,JSPHER,IPARIT)
     *                       *CONST2(LSPHER,MLSPHR)
C
                          ELSE
C
C=======================================================================
C                         Case N_SPIN=-1 which corresponds to ms = -1/2
C=======================================================================
C
                              MJSPHR=2*MLSPHR-1
C
                              KJSPHR=KDEFIN(NTOTAL,KSPHE1,LSPHER,MJSPHR)
C
                              WAVESP(NTOTAL,KSPHE1,LSPHER,KJSPHR)
     *                       =WAVESP(NTOTAL,KSPHE1,LSPHER,KJSPHR)
     *                       +RES_UP(ISTATE,JSPHER,IPARIT)
     *                       *CONST3(LSPHER,MLSPHR)
C
                              KJSPHR=KDEFIN(NTOTAL,KSPHE2,LSPHER,MJSPHR)
C
                              WAVESP(NTOTAL,KSPHE2,LSPHER,KJSPHR)
     *                       =WAVESP(NTOTAL,KSPHE2,LSPHER,KJSPHR)
     *                       +RES_UP(ISTATE,JSPHER,IPARIT)
     *                       *CONST4(LSPHER,MLSPHR)
C
                          END IF
C
                      END DO
C
                   END IF
C
               ELSE
C
C=======================================================================
C              Case of the orbital angular momentum quantum number l=0:
C              In this case, j = +1/2 only, and thus mj = -1/2 or +1/2
C              Here the case KSPHE1=1, projection down,  is impossible
C=======================================================================
C
                   NTOTAL=2*NRMIN1
                   KSPHE1=2
C
                   IF (MOD(NTOTAL,2).EQ.IPARIT) THEN
C
                       DO N_SPIN=-1,1,2
C
                          IF (N_SPIN.EQ.1) THEN
C
                              MJSPHR=+1
                              KJSPHR=KDEFIN(NTOTAL,KSPHE1,LSPHER,MJSPHR)
C
                              WAVESP(NTOTAL,KSPHE1,LSPHER,KJSPHR)
     *                       =WAVESP(NTOTAL,KSPHE1,LSPHER,KJSPHR)
     *                       +RES_DW(ISTATE,JSPHER,IPARIT)
     *                       *CONST1(LSPHER,MLSPHR)
C
                          ELSE
C
                              MJSPHR=-1
                              KJSPHR=KDEFIN(NTOTAL,KSPHE1,LSPHER,MJSPHR)
C
                              WAVESP(NTOTAL,KSPHE1,LSPHER,KJSPHR)
     *                       =WAVESP(NTOTAL,KSPHE1,LSPHER,KJSPHR)
     *                       +RES_UP(ISTATE,JSPHER,IPARIT)
     *                       *CONST3(LSPHER,MLSPHR)
C
                          END IF
C
                      END DO
C
                   END IF
C
               END IF      ! OF LSPHER.NE.0 / LSPHER.EQ.0
C
            END DO         ! end of JSPHER
C
C=======================================================================
C           Optionally skipping "false" parity if (ISIGNY=1)
C=======================================================================
C
   1        CONTINUE
C
         END DO            ! end of the parity DO-LOOP
C
C=======================================================================
C        In the following loop, the amplitudes of the wave functions
C        are ordered, and the correspondence between quantum numbers
C        and the current indices of the matrices is found
C=======================================================================
C
         N_BASE=0
                                  NLOWER=0
         IF (IPAORD(ISTATE).EQ.1) NLOWER=1
C
                          N_STEP=1
         IF (ISIGNY.EQ.1) N_STEP=2
C
         DO NTOTAL=NLOWER,NOSMAX,N_STEP
C
                                    K_PARI=+1
            IF (MOD(NTOTAL,2).EQ.1) K_PARI=-1
C
            NRM1MX=(NTOTAL-MOD(NTOTAL,2))/2
C
            DO NRMIN1=0,NRM1MX
C
               LSPHER=NTOTAL-2*NRMIN1
C
                  KSPHER=0
               DO JSPHER=2*LSPHER-1,2*LSPHER+1,2
                  KSPHER=KSPHER+1
C
                  IF (JSPHER.GE.0)  THEN
C
                         KJSPHR=-1
                      DO MJSPHR=-JSPHER,+JSPHER,2
                         KJSPHR=KJSPHR+1
C
                         N_BASE=N_BASE+1
C
                         PROML=WAVESP(NTOTAL,KSPHER,LSPHER,KJSPHR)
     *                  *CONJG(WAVESP(NTOTAL,KSPHER,LSPHER,KJSPHR))
C
                         AMPLT2(N_BASE)=PROML
                         NSTATE(N_BASE)=N_BASE
C
                         WAVCOE(N_BASE)=
     *                   WAVESP(NTOTAL,KSPHER,LSPHER,KJSPHR)
C
                         MAIN_S(N_BASE)=NTOTAL
                         LSPH_S(N_BASE)=LSPHER
                         JMOM_S(N_BASE)=JSPHER
                         MMOM_S(N_BASE)=MJSPHR
C
                         PTOTAL(ISTATE)=PTOTAL(ISTATE)+PROML*K_PARI
C
                      END DO
C
                  END IF
C
               END DO
            END DO
         END DO
C
C=======================================================================
C        Calculating the single-particle wave-functions in their
C        spatial representation {n,l,j,m_j}
C=======================================================================
C
         IF (IFWAVE.EQ.1) THEN
C
             CALL WS_WAVEFU(ISTATE,N_BASE,MAIN_S,LSPH_S,JMOM_S,MMOM_S,
     *                                                  ZLAGUE,R_MAXI)
         END IF
C
C=======================================================================
C
                          LCOLUM=8
         IF (IWAVSP.EQ.0) LCOLUM=1
C
         CALL WS_ORDLOW(AMPLT2,NSTATE,N_BASE,LCOLUM,AUXVEC,MDTVE2,
     *                                              MINDEX,LINDEX)
C
         MAIN0S(ISTATE,IREVER)=MAIN_S(NSTATE(1))
         JMOM0S(ISTATE,IREVER)=JMOM_S(NSTATE(1))
         LSPH0S(ISTATE,IREVER)=LSPH_S(NSTATE(1))
         MMOM0S(ISTATE,IREVER)=MMOM_S(NSTATE(1))
C
         QUOTSP(ISTATE,IREVER)=AMPLT2(1)
C
C=======================================================================
C
         WRITE(NILSPH(ISTATE),'(''|'',I2,'','',I2,'','',I2,''/2,'',I2,
     *                                                     ''/2>'')')
     *                                          MAIN0S(ISTATE,IREVER),
     *                                          LSPH0S(ISTATE,IREVER),
     *                                          JMOM0S(ISTATE,IREVER),
     *                                     ABS(MMOM0S(ISTATE,IREVER))
C
C=======================================================================
C
         IF (IWAVSP.NE.0) THEN
C
             IF (ESINGP(ISTATE).GT.EMINWF.AND.
     *           ESINGP(ISTATE).LT.EMAXWF    ) THEN
C
                 ICOUNT=ICOUNT+1
C
                 IF (MOD(ICOUNT+7,8).EQ.0) THEN
C
                     IF (ISOSPI.EQ.0) THEN
C
                         IF (IWRITE.GE.1)
     *                   WRITE(NOUTPT,'(/,80(''#''),/,''#'',78X,''#'',/,
     *                       ''#   Neutron Eigenfunctions  - '',
     *                       ''(Spherical Representation)'',
     *                       ''        OMEGA='',F5.3,''    #'',/,
     *                       ''#                                     '',
     *                       ''                        (Ry,Ry'''')='',
     *                       A5,''   #'',/,
     *                       80(''#''),/,''#'',78X,''#'')')
     *
     *                                             OMEGAC,RYTEXT(IREVER)
C
                     ELSE
C
                         IF (IWRITE.GE.1)
     *                   WRITE(NOUTPT,'(/,80(''#''),/,''#'',78X,''#'',/,
     *                       ''#   Proton  Eigenfunctions  - '',
     *                       ''(Spherical Representation)'',
     *                       ''        OMEGA='',F5.3,''    #'',/,
     *                       ''#                                     '',
     *                       ''                        (Ry,Ry'''')='',
     *                       A5,''   #'',/,
     *                       80(''#''),/,''#'',78X,''#'')')
     *
     *                                             OMEGAC,RYTEXT(IREVER)
C
                     END IF
C
                 END IF
C
                 IF (IWRITE.GE.1) THEN
C
                     WRITE(NOUTPT,'(''#'',3X,''Energy ='',F8.4,
     *                                        '' A(%)=>'',2X,
     *                             8(2X,I2,''%'',1X),2X,''#'')')
     *
     *                ESINGP(ISTATE),(INT(100*AMPLT2(J)),J=1,8)
C
                     WRITE(NOUTPT,'(''#'',21X,''|N > '',
     *                                    8(I6),4X,''#'')')
     *
     *                            (MAIN_S(NSTATE(J)),J=1,8)
C
                     WRITE(NOUTPT,'(''#'',21X,''|L > '',
     *                                    8(I6),4X,''#'')')
     *
     *                            (LSPH_S(NSTATE(J)),J=1,8)
C
                     WRITE(NOUTPT,'(''#'',21X,''|j > '',2X,
     *                          8(I3,''/2'',1X),2X,''#'')')
     *
     *                            (JMOM_S(NSTATE(J)),J=1,8)
C
                     WRITE(NOUTPT,'(''#'',21X,''|mj> '',2X,
     *                          8(I3,''/2'',1X),2X,''#'')')
     *
     *                            (MMOM_S(NSTATE(J)),J=1,8)
C
                     WRITE(NOUTPT,'(''#'',78X,''#'')')
C
                 END IF
C
             END IF
C
         END IF
C
   2     CONTINUE
C
      END DO
C
C=======================================================================
C     Printing the tables of the structure of the wave functions
C     using  the  | N, J , L, MJ > representation
C=======================================================================
C
C
C=======================================================================
C     The labelling and structure based on the (N, J, L, M)
C     defined individually for each quantum number
C=======================================================================
C
      IF (ISOSPI.EQ.0) THEN
C
          IF (IWRITE.GE.1)
     *    WRITE(NOUTPT,'(/,80(''#''),/,''#'',78X,''#'',/,
     *                ''#    NEUTRONS:       Single Particle - '',
     *                ''Spherical Labelling      OMEGA='',F5.3,
     *                ''    #'',/,
     *                ''#                                      '',
     *                ''                       (Ry,Ry'''')='',A5,
     *                ''   #'',/,
     *                80(''#''),/,''#'',78X,''#'',/,
     *                ''#  No)  Energy  | N, l, j >  |mj|  (P%)'',
     *                 ''  No)  Energy  | N, l, j >  |mj|  (P%)  #'',/,
     *                ''#'',78X,''#'')')
     *
     *                                            OMEGAC,RYTEXT(IREVER)
C
      ELSE
C
          IF (IWRITE.GE.1)
     *    WRITE(NOUTPT,'(/,80(''#''),/,''#'',78X,''#'',/,
     *                ''#     PROTONS:       Single Particle - '',
     *                ''Spherical Labelling      OMEGA='',F5.3,
     *                ''    #'',/,
     *                ''#                                      '',
     *                ''                       (Ry,Ry'''')='',A5,
     *                ''   #'',/,
     *                80(''#''),/,''#'',78X,''#'',/,
     *                ''#  No)  Energy  | N, l, j >  |mj|  (P%)'',
     *                 ''  No)  Energy  | N, l, j >  |mj|  (P%)  #'',/,
     *                ''#'',78X,''#'')')
     *
     *                                            OMEGAC,RYTEXT(IREVER)
C
      END IF
C
C=======================================================================
C
      DO ISTATE=1,LDBASE
         IF (ESINGP(ISTATE).GT.EMAXST) GO TO 3
      END DO
C
   3  L_STAT=ISTATE-1
                         KIK=L_STAT/2
      IF (KIK.GT.NOFLIN) KIK=NOFLIN
C
      DO L=1,KIK
C
         L1=L
         L2=KIK+L
C
         IF (PTOTAL(L1).GT.0.0) THEN
             IPTOT1=INT(100*PTOTAL(L1)+0.49999)
         ELSE
             IPTOT1=INT(100*PTOTAL(L1)-0.49999)
         END IF
C
         IF (PTOTAL(L2).GT.0.0) THEN
             IPTOT2=INT(100*PTOTAL(L2)+0.49999)
         ELSE
             IPTOT2=INT(100*PTOTAL(L2)-0.49999)
         END IF
C
         IF (IWRITE.GE.1)
     *   WRITE(NOUTPT,'(''# '',I3,'')'',F8.3,2X,A17,I6,1X,
     *                         I3,'')'',F8.3,2X,A17,I6,''  #'')')
     *
     *                          L1,ESINGP(L1),NILSPH(L1),IPTOT1,
     *                          L2,ESINGP(L2),NILSPH(L2),IPTOT2
C
      END DO
C
      IF (IWRITE.GE.1)
     *    WRITE(NOUTPT,'(''#'',78X,''#'',/,80(''#''))')
C
      L_STAT=LDBASE
C
C=======================================================================
C
      CALL WS_CPUTIM('SPHONL',0)
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C=======================================================================
C
      SUBROUTINE WS_KARSPH(NOSCIL)
C=======================================================================
      USE params
C=======================================================================
C
      COMMON
     *       /KARSPH_INDKAR/ INDKAR(0:MDMAIN,0:MDMAIN,0:MDMAIN,0:NDPARI)
     *
     *       /KARSPH_INDSPH/ INDSPH(0:MDMAIN,0:MDMAIN,0:MDMAIN,
     *                                 -MDMAIN:MDMAIN,0:NDPARI)
     *
     *       /KARSPH_NXNYNZ/ NX_VEC(1:MDTRAN,0:NDPARI),
     *                       NY_VEC(1:MDTRAN,0:NDPARI),
     *                       NZ_VEC(1:MDTRAN,0:NDPARI)
     *
     *       /KARSPH_NBASER/ NBASER(1:MDTRAN,0:NDPARI),
     *                       NBASZP(1:MDTRAN,0:NDPARI),
     *                       NBASEM(1:MDTRAN,0:NDPARI),
     *                       LDTRAN
     *
     *       /KARSPH_PARITY/ IDPARI(1:MDTRAN,0:NDPARI)
     *
     *       /KARSPH_CYLDIM/ LDCYLP(0:NDPARI)
     *
     *       /KARSPH_DIMPAR/ LDKARP(0:NDPARI)
      COMMON
     *       /SETBAS_NXNYNZ/ NXVECT(1:NDBASE),
     *                       NYVECT(1:NDBASE),
     *                       NZVECT(1:NDBASE)
     *
     *       /SETBAS_DIMENS/ LDBASE
C
C=======================================================================
C
C     In this subroutine we define the size of each block of parity
C     in order to calculate the transformation brackets between the
C     Cartesian  and the spherical harmonic oscillators.  We choose
C     the sizes that are not the same  as in other subroutines - in
C     order to save non-trivial amounts of memory.
C
C                         Nilsson spherical labels
C
C=======================================================================
C
      NPARIP=0
      NPARIN=0
C
      NEFFEC=MIN(NOSCIL,NDOLAB)
C
      DO I_BASE=1,LDBASE
C
         NX=NXVECT(I_BASE)
         NY=NYVECT(I_BASE)
         NZ=NZVECT(I_BASE)
C
         NTOTAL=NX+NY+NZ
C
         IF (NTOTAL.LE.NEFFEC) THEN
C
             IF (MOD(NTOTAL,2).EQ.0) THEN
C
                 NPARIP=NPARIP+1
C
                 IDPARI(NPARIP,0)=I_BASE
C
                 INDKAR(NX,NY,NZ,0)=NPARIP
C
                 NX_VEC(NPARIP,0)=NX
                 NY_VEC(NPARIP,0)=NY
                 NZ_VEC(NPARIP,0)=NZ
C
             END IF
C
             IF (MOD(NTOTAL,2).EQ.1) THEN
C
                 NPARIN=NPARIN+1
C
                 IDPARI(NPARIN,1)=I_BASE
C
                 INDKAR(NX,NY,NZ,1)=NPARIN
C
                 NX_VEC(NPARIN,1)=NX
                 NY_VEC(NPARIN,1)=NY
                 NZ_VEC(NPARIN,1)=NZ
C
             END IF
C
         END IF
C
      END DO
C
C=======================================================================
C
      LDKARP(0)=NPARIP
      LDKARP(1)=NPARIN
C
C=======================================================================
C     Calculations e.g. for the spherical labelling variant
C=======================================================================
C
      NPARIP=0
      NPARIN=0
C
C=======================================================================
C
      DO NTOTAL=0,NEFFEC
         NRM1MX=(NTOTAL-MOD(NTOTAL,2))/2
C
         DO NRMIN1=0,NRM1MX
            LSPHER=NTOTAL-2*NRMIN1
C
            DO MLSPHR=-LSPHER,LSPHER
C
               LDMAIN=2*NRMIN1+LSPHER
               IPARIT=MOD(LDMAIN,2)
C
               IF (IPARIT.EQ.0) THEN
C
C=======================================================================
C                  Positive parity
C=======================================================================
C
                   NPARIP=NPARIP+1
C
                   INDSPH(NTOTAL,NRMIN1,LSPHER,MLSPHR,0)=NPARIP
C
                   NBASER(NPARIP,IPARIT)=NRMIN1
                   NBASZP(NPARIP,IPARIT)=LSPHER
                   NBASEM(NPARIP,IPARIT)=MLSPHR
C
               ELSE
C
C=======================================================================
C                  Negative parity
C=======================================================================
C
                   NPARIN=NPARIN+1
C
                   INDSPH(NTOTAL,NRMIN1,LSPHER,MLSPHR,1)=NPARIN
C
                   NBASER(NPARIN,IPARIT)=NRMIN1
                   NBASZP(NPARIN,IPARIT)=LSPHER
                   NBASEM(NPARIN,IPARIT)=MLSPHR
C
               END IF
C
            END DO
         END DO
      END DO
C
C=======================================================================
C
      LDCYLP(0)=NPARIP
      LDCYLP(1)=NPARIN
C
      LDTRAN=NPARIN+NPARIP
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C=======================================================================
C
      SUBROUTINE WS_SPHXYZ(NMAIN,AUXSPH)
C=======================================================================
      USE params
C=======================================================================
C
      COMPLEX
     *          AUXSPH(1:MDTRAN,1:MDTRAN,0:NDPARI)
      COMPLEX
     *          CONST2,UNIT_I,POWERI(0:6*MDMAIN)
      COMPLEX
     *          SUMCOF,AUXILI
C
      DIMENSION
     *          FACTRL(0:6*MDMAIN),MINUS1(-3*MDMAIN:3*MDMAIN),
     *          POWER2(0:6*MDMAIN)
C
      COMMON
     *       /KARSPH_INDKAR/ INDKAR(0:MDMAIN,0:MDMAIN,0:MDMAIN,0:NDPARI)
     *
     *       /KARSPH_INDSPH/ INDSPH(0:MDMAIN,0:MDMAIN,0:MDMAIN,
     *                                 -MDMAIN:MDMAIN,0:NDPARI)
C
C=======================================================================
C
C     This subroutine calculates the transformation brackets for
C     the 3-d harmonic oscillator basis between {|NX,NY,NZ>} and
C     the spherical basis {|N,L,M>}.
C
C     We introduce the matrix of the transformation coefficients
C
C           COEFCS(NX,NY,NZ,nr-1,m) = < nr-1,l,m | NX,NY,NZ >
C
C     where:    NX+NY+NZ = 2*(nr-1)+l
C
C     Defining  NTOTAL=NX+NY+NZ  we have
C
C     l = 0,2, ... NTOTAL;   m = -l,-l+1,...,+l, for NTOTAL even
C     l = 1,3, ... NTOTAL;   m = -l,-l+1,...,+l, for NTOTAL  odd
C
C     We use the symmetry property:
C
C     <nr-1,l,-m|NX,NY,NZ>=(-1)**m *CONJG(<nr-1,l,m|NX,NY,NZ>)
C
C=======================================================================
C
      IF (NMAIN.LT.0) STOP 'NMAIN < 0 in SPHXYZ <<= '
C
      IF (NMAIN.EQ.0) STOP 'NMAIN = 0 in SPHXYZ <<= '
C
C=======================================================================
C
      DO IPARIT=0,NDPARI
         DO JSPHER=1,MDTRAN
            DO IKARTE=1,MDTRAN
               AUXSPH(IKARTE,JSPHER,IPARIT)=CMPLX(0.0,0.0)
            END DO
         END DO
      END DO
C
      UNIT_I=CMPLX(0.0,1.0)
C
      FACTRL(0)=1.0
      MINUS1(0)=1
      POWERI(0)=1.0
      POWER2(0)=1.0
C
C=======================================================================
C
C     FACTRL(N)  => is the function  N!=N(N-1)(N-2)...1
C     MINUS1(N)  => is the function  (-1)**N
C     POWERI(N)  => is the function  (+I)**N
C     POWER2(N)  => is the function  (+2)**N
C
C=======================================================================
C
      DO I=1,5*NMAIN
C
         FACTRL(I)=I*FACTRL(I-1)
C
         POWER2(I)=POWER2(I-1)*2
         POWERI(I)=POWERI(I-1)*UNIT_I
C
      END DO
C
      DO I=1,3*NMAIN
C
         MINUS1(+I)=-MINUS1(I-1)
         MINUS1(-I)=+MINUS1( I )
C
      END DO
C
C=======================================================================
C     M A I N   L O O P
C=======================================================================
C
      DO NX=0,NMAIN
         DO NY=0,NMAIN-NX
C
            CONST2=POWERI(NY)
            CONST0=SQRT(FACTRL(NX)*FACTRL(NY))
C
            DO NZ=0,NMAIN-NX-NY
C
               CONST6=CONST0*SQRT(FACTRL(NZ))
C
               NKARTE=NX+NY+NZ
C
               IPARIT=MOD(NKARTE,2)
C
               NRM1MX=(NKARTE-IPARIT)/2
C
               DO NRMIN1=0,NRM1MX
C
                  LSPHER=NKARTE-2*NRMIN1
C
                  DO MLSPHR=0,+LSPHER
C
                      CONST1=MINUS1((2*NRMIN1+NX+NY-MLSPHR)/2)
C
                      CONST4=FACTRL((NX+NY+MLSPHR)/2)
C
                      CONST5=(1+MINUS1(NX+NY+MLSPHR))/2
C
                      CONST3=SQRT((2*LSPHER+1)
     *               /POWER2(LSPHER)*FACTRL(LSPHER-MLSPHR)
     *               /FACTRL(LSPHER+MLSPHR)*FACTRL(NRMIN1+LSPHER)
     *               /FACTRL(NRMIN1)
     *               /FACTRL(NRMIN1+NRMIN1+LSPHER+LSPHER+1))
C
                      ISSMIN=0
                      ISSMAX=(LSPHER-MLSPHR)/2
C
                      IPPMIN=0
                      IPPMAX=NX
C
                      IF (NRMIN1.LE.(NX+NY-MLSPHR)/2)
     *
     *                    ISSMIN=(NX+NY-MLSPHR)/2-NRMIN1
C
                      IF (MOD(LSPHER-MLSPHR,2).NE.0)
     *
     *                    ISSMAX=(LSPHER-MLSPHR-1)/2
C
                      IF (NY.LE.(NX+MLSPHR)) IPPMIN=(NX-NY+MLSPHR)/2
                      IF (NX.GE.(NY+MLSPHR)) IPPMAX=(NX+NY+MLSPHR)/2
C
                      SUMCOF=CMPLX(0.0,0.0)
C
                      DO I_SPIN=ISSMIN,ISSMAX
C
                          CONST7=MINUS1(I_SPIN)
     *                   *FACTRL(LSPHER+LSPHER-I_SPIN-I_SPIN)
     *                   /FACTRL(I_SPIN)*FACTRL(NRMIN1+I_SPIN)
     *                   /FACTRL(LSPHER-I_SPIN)
     *                   /FACTRL(LSPHER-I_SPIN-I_SPIN-MLSPHR)
     *                   /FACTRL(NRMIN1+I_SPIN-(NX+NY-MLSPHR)/2)
C
                          DO IPAUXI=IPPMIN,IPPMAX
C
                             CONST8=MINUS1(IPAUXI)
     *                      /FACTRL(IPAUXI)
     *                      /FACTRL(NX-IPAUXI)
     *                      /FACTRL(IPAUXI+(NY-NX-MLSPHR)/2)
     *                      /FACTRL((NX+NY+MLSPHR)/2-IPAUXI)
C
                             SUMCOF=SUMCOF+CONST7*CONST8
C
                          END DO
C
                      END DO
C
                      I_KART=INDKAR(NX,NY,NZ,IPARIT)
                      J_SPHE=INDSPH(NKARTE,NRMIN1,LSPHER,MLSPHR,IPARIT)
C
                      AUXILI=CONST1*CONST2*CONST3*CONST4
     *                             *CONST5*CONST6*SUMCOF
C
                      AUXSPH(I_KART,J_SPHE,IPARIT)=AUXILI
C
                      J_SPHE=INDSPH(NKARTE,NRMIN1,LSPHER,-MLSPHR,IPARIT)
C
                      AUXSPH(I_KART,J_SPHE,IPARIT)=(-1)**MLSPHR*
     *                                             CONJG(AUXILI)
C
                  END DO
C
               END DO
C
            END DO
C
         END DO
      END DO
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C=======================================================================
C
      SUBROUTINE WS_CART3D(ICHARG,EMINST,EMAXST,OMEGAC,LDBASE)
C=======================================================================
      USE params
C=======================================================================
C
      CHARACTER
     *          CARTLB*10,IRRLB1*2,IRRLB2*2
      CHARACTER
     *          STRNP1*5,STRNP2*5
C
      COMPLEX
     *          WAVOCC
C
      COMMON
     *       /SETBAS_NXNYNZ/ NXVECT(1:NDBASE),
     *                       NYVECT(1:NDBASE),
     *                       NZVECT(1:NDBASE)
      COMMON
     *       /CRAN3D_ALLWAV/ WAVOCC(1:NDBASE,1:2*NDSTAT,0:NDREVE)
      COMMON
     *       /CRAN3D_SPLV3D/ SPENER(1:2*NDSTAT,0:NDISOS),
     *                       SPOCCU(1:2*NDSTAT,0:NDISOS),
     *                       SPALIG(1:2*NDSTAT,0:NDISOS),
     *                       SPSPAL(1:2*NDSTAT,0:NDISOS),
     *                       SPPARI(1:2*NDSTAT,0:NDISOS),
     *                       SPSIMP(1:2*NDSTAT,0:NDISOS)
      COMMON
     *       /CRAN3D_BCAR3D/ NXCART(1:2*NDSTAT),
     *                       NYCART(1:2*NDSTAT),
     *                       NZCART(1:2*NDSTAT)
      COMMON
     *       /CRAN3D_KLAB3D/ CARTLB(1:NDOUBL)
     *       /CRAN3D_PARI3D/ PARITY(1:NDOUBL)
      COMMON
     *       /READWRITE_PAR/ NOUTPT,IWRITE,ISCREN
C
C=======================================================================
C
C       This subroutine calculates and displays on screen cartesian
C       labels of the WS wave-functions in the case of 3D-cranking
C
C=======================================================================
C
      CALL WS_CPUTIM('CART3D',1)
C
C=======================================================================
C
C      Preparing the printing of sigle-particle levels to the output
C
      IF (IWRITE.GE.1) THEN
C
          IF (ICHARG.EQ.0) THEN
C
              WRITE(6,'(//,80(''#''),/,''#'',78X,''#'',/,
     *        ''#    NEUTRONS:       Single Particle -'',
     *        '' Cartesian Labelling      OMEGA='',  F5.3,
     *                                        ''    #'',/,
     *        ''#'',78X,''#'',/,
     *                        80(''#''),/,''#'',78X,''#'',/,
     *        ''#   No)   Energy  (Nx,Ny,Nz) Ir < P%>      '',
     *        ''No)   Energy  (Nx,Ny,Nz)    < P%>   #'',/,
     *        ''#'',78X,''#'')')  OMEGAC
C
          ELSE
C
              WRITE(6,'(//,80(''#''),/,''#'',78X,''#'',/,
     *        ''#    PROTONS:        Single Particle -'',
     *        '' Cartesian Labelling      OMEGA='',F5.3,
     *                                        ''    #'',/,
     *        ''#'',78X,''#'',/,
     *                        80(''#''),/,''#'',78X,''#'',/,
     *        ''#   No)   Energy  (Nx,Ny,Nz) Ir < P%>      '',
     *        ''No)   Energy  (Nx,Ny,Nz)    < P%>   #'',/,
     *        ''#'',78X,''#'')')  OMEGAC
C
          END IF
C
      END IF
C
C=======================================================================
C
      LDOUBL=2*LDBASE
C
      DO ISTATE=1,LDOUBL
C
C         Calculating the parity of the state
C
         PARITY(ISTATE)=0
	 SQAMAX=-1000.0
C
C         Calculating the parity of the single-particle states and
C         obtaining the cartesian labels corresponding to the leading
C         term in the expansion of the wave function upon the harmonic
C         oscillator basis.
C
         DO I_BASE=1,LDBASE
C
            NX=NXVECT(I_BASE)
            NY=NYVECT(I_BASE)
            NZ=NZVECT(I_BASE)
C
            I_PARI=1-2*MOD(NX+NY+NZ,2)
C
C            Sum over the two blocks |t+> and |t-> of the basis decomposition
C
            DO IREVER=0,NDREVE
C
               SQUARE=ABS(WAVOCC(I_BASE,ISTATE,IREVER))**2
C
	       IF (SQUARE.GT.SQAMAX) THEN
	           SQAMAX=SQUARE
		   NXLABL=NX
		   NYLABL=NY
		   NZLABL=NZ
	       END IF
C
               PARITY(ISTATE)=PARITY(ISTATE)+I_PARI*SQUARE
C
            END DO
C
	 END DO
C
         WRITE(CARTLB(ISTATE),'(''|'',I2,'','',I2,'','',I2,''>'')')
     *                                NXLABL,NYLABL,NZLABL
C
         NXCART(ISTATE)=NXLABL
	 NYCART(ISTATE)=NYLABL
	 NZCART(ISTATE)=NZLABL
C
      END DO
C
C=======================================================================
C
C      Defining the window range for displaying the single-particle
C      energies
C
      KIKOFF=0
      ISTART=1
C
      DO ISTATE=1,LDOUBL
         IF (SPENER(ISTATE,ICHARG).GE.EMINST.AND.
     *       SPENER(ISTATE,ICHARG).LE.EMAXST) THEN
             KIKOFF=KIKOFF+1
             IF (KIKOFF.EQ.1) ISTART=ISTATE
         END IF
      END DO
C
      KIKOFF=KIKOFF/2-1
C
      IF (ISTART+KIKOFF.GT.2*LDBASE)
     *              STOP 'ISTART+KIKOFF.GT.LDBASE - IN DIASIZ (2)'
C
C=======================================================================
C
C      Printing the ordered single-particle energies with their
C      cartesian labels
C
      DO L=ISTART,ISTART+KIKOFF
C
         L1=L
         L2=KIKOFF+L+1
C
C         Getting parity corresponding to the first column
C
         IF (PARITY(L1).GT.0.0) THEN
             IPTES1=INT(PARITY(L1)*100+0.49999)
         ELSE
             IPTES1=INT(PARITY(L1)*100-0.49999)
         END IF
C
C         Making special label for parity of the first column
C
         IF (ABS(IPTES1).NE.100) THEN
             WRITE(STRNP1,'(''('',SP,I3,SS,'')'')') IPTES1
         END IF
C
         IF (IPTES1.EQ.+100) THEN
             WRITE(STRNP1,'(''( + )'')')
         END IF
C
         IF (IPTES1.EQ.-100) THEN
             WRITE(STRNP1,'(''( - )'')')
         END IF
C
C         Getting parity corresponding to the second column
C
         IF (PARITY(L2).GT.0.0) THEN
             IPTES2=INT(PARITY(L2)*100+0.49999)
         ELSE
             IPTES2=INT(PARITY(L2)*100-0.49999)
         END IF
C
C         Making special label for parity of the second column
C
         IF (ABS(IPTES2).NE.100) THEN
             WRITE(STRNP2,'(''('',SP,I3,SS,'')'')') IPTES2
         END IF
C
         IF (IPTES2.EQ.+100) THEN
             WRITE(STRNP2,'(''( + )'')')
         END IF
C
         IF (IPTES2.EQ.-100) THEN
             WRITE(STRNP2,'(''( - )'')')
         END IF
C
C         Printing the single-particle energies with the cartesian
C         labels
C
         IRRLB1='--'
         IRRLB2='--'
C
	 IF (IWRITE.GE.1)
     *
     *      WRITE(NOUTPT,'(''#  '',I3,'')'',F10.5,'' '',A10,
     *                             1X,A2,1X,A5,''     '',
     *                          I3,'')'',F10.5,'' '',A10,
     *                             1X,A2,1X,A5,''   #'')')
     *
     *             L1,SPENER(L1,ICHARG),CARTLB(L1),IRRLB1,STRNP1,
     *             L2,SPENER(L2,ICHARG),CARTLB(L2),IRRLB2,STRNP2
C
      END DO
C
      IF (IWRITE.GE.1)
     *    WRITE(NOUTPT,'(''#'',78X,''#'',/,80(''#''))')
C
C=======================================================================
C
      CALL WS_CPUTIM('CART3D',0)
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C=======================================================================
C
      SUBROUTINE WS_NILS3D(ICHARG,EMINST,EMAXST,EMINWF,EMAXWF,OMEGAC,
     *                                          NILWAV,NILSLB,LDBASE)
C=======================================================================
      USE params
C=======================================================================
C
      CHARACTER
     *          RYTEXT(0:NDREVE)*5
      CHARACTER
     *          CARTLB*10,NILLAB*15,IRRLB1*2,IRRLB2*2
      CHARACTER
     *          STRNP1*5,STRNP2*5
      CHARACTER
     *          FORM_A*1,FORM_B*1
      COMPLEX
     *          UNIT_I,WAVOCC
      COMPLEX
     *          RES_UP,RES_DW,AUXCYL,WVTRAN
C
C=======================================================================
      ALLOCATABLE RES_UP(:,:,:),RES_DW(:,:,:),
     *            AUXCYL(:,:,:),WVTRAN(:,:)
C=======================================================================
      DIMENSION
     *          MAINCL(1:2*NDTVE2),LAMBCL(1:2*NDTVE2),
     *          IOMECL(1:2*NDTVE2),NZCLND(1:2*NDTVE2)
      DIMENSION
     *          AMPLT2(1:2*NDTVE2),AUXVEC(1:2*NDTVE2),
     *                             NSTATE(1:2*NDTVE2)
      DIMENSION
     *          MINDEX(1:NDTVE2),LINDEX(1:NDTVE2)
      DIMENSION
     *          QUOTCY(1:NDOUBL)
      DIMENSION
     *          NILLAB(1:NDOUBL)
C
      COMMON
     *       /CRAN3D_ALLWAV/ WAVOCC(1:NDBASE,1:2*NDSTAT,0:NDREVE)
      COMMON
     *       /CRAN3D_SPLV3D/ SPENER(1:2*NDSTAT,0:NDISOS),
     *                       SPOCCU(1:2*NDSTAT,0:NDISOS),
     *                       SPALIG(1:2*NDSTAT,0:NDISOS),
     *                       SPSPAL(1:2*NDSTAT,0:NDISOS),
     *                       SPPARI(1:2*NDSTAT,0:NDISOS),
     *                       SPSIMP(1:2*NDSTAT,0:NDISOS)
      COMMON
     *       /CRAN3D_KLAB3D/ CARTLB(1:NDOUBL)
     *       /CRAN3D_PARI3D/ PARITY(1:NDOUBL)
      COMMON
     *       /CRAN3D_CYLO3D/ MAINNL(1:2*NDSTAT),
     *                       NZNILS(1:2*NDSTAT),
     *                       L_NILS(1:2*NDSTAT),
     *                       IOMEGA(1:2*NDSTAT)
C
      COMMON
     *       /SETBAS_NXNYNZ/ NXVECT(1:NDBASE),
     *                       NYVECT(1:NDBASE),
     *                       NZVECT(1:NDBASE)
     *
     *       /SETBAS_PARIND/ INDPAR(1:NDBASE,0:NDPARI)
     *       /SETBAS_PARDIM/          LDBASP(0:NDPARI)
      COMMON
     *       /TRANSC_NYPARI/ NYPARI(1:NDTRAN,0:NDPARI)
      COMMON
     *       /TRANSC_BASCLJ/ NBASER(1:NDTRAN,0:NDPARI),
     *                       NBASZP(1:NDTRAN,0:NDPARI),
     *                       NBASEM(1:NDTRAN,0:NDPARI)
      COMMON
     *       /KARSPH_CYLDIM/ LDCYLP(0:NDPARI)
      COMMON
     *       /READWRITE_PAR/ NOUTPT,IWRITE,ISCREN
C
      DATA
     *     EPSMUL / 1.E-14 /
      DATA
     *     RYTEXT /  '(+,+)' ,  '(-,-)' /
C
C=======================================================================
C
C       This subroutine calculates and displays on screen Nilsson
C       labels of the WS wave-functions in the case of 3D-cranking
C
C=======================================================================
C
      IF (NILSLB.EQ.0) RETURN
C
C=======================================================================
C
      CALL WS_CPUTIM('NILS3D',1)
C
C=======================================================================
C
      ALLOCATE(RES_UP(1:2*MDBASE,1:MDTRAN,0:NDPARI))
      ALLOCATE(RES_DW(1:2*MDBASE,1:MDTRAN,0:NDPARI))
      ALLOCATE(AUXCYL(1:MDBASE,1:MDTRAN,0:NDPARI))
      ALLOCATE(WVTRAN(1:2*MDBASE,1:MDTRAN))
C
      IF (MOD(NDCLAB,2).EQ.0) THEN
C
          LDMEVE=((NDCLAB+2)*(NDCLAB+4)*(NDCLAB+NDCLAB+3))/24
C
          IF (NDTRAN.NE.LDMEVE) THEN
C
              WRITE(NOUTPT,'(//,''LDMEVE='',I4,
     *                       '' SHOULD BE EQUAL NDTRAN='',
     *                       I4)') LDMEVE,NDTRAN
C
              STOP 'NDTRAN.NE.LDMEVE'
C
          END IF
C
          LDLABS=LDMEVE
C
      ELSE
C
          LDMODD=((NDCLAB+1)*(NDCLAB+3)*(NDCLAB+NDCLAB+7))/24
C
          IF (NDTRAN.NE.LDMODD) THEN
C
              WRITE(NOUTPT,'(//,''LDMODD='',I4,
     *                       '' SHOULD BE EQUAL NDTRAN='',
     *                       I4)') LDMODD,NDTRAN
C
              STOP 'NDTRAN.NE.LDMODD'
C
          END IF
C
          LDLABS=LDMODD
C
      END IF
C
C=======================================================================
C         Analysing the single particle harmonic - oscillator
C         structure of the wave functions
C=======================================================================
C
      CALL WS_CYLXYZ(NDCLAB)
C
C=======================================================================
C
      CALL WS_TRANSC(NDCLAB,AUXCYL)
C
C=======================================================================
C
C         CALCULATING THE NILSSON - LABELS FOR THE EIGENSTATES
C
C=======================================================================
C
      LDOUBL=2*LDBASE
C
      UNIT_I=CMPLX(0.0,1.0)
C
C      Below the h.o. states - components of the W.S. wave-functions
C      are analysed separately  for the positive and negative parity
C      irrespectively of whether the W.S. states preserve the parity
C      or not. This is because the basis preserves the parity always
C
      DO IPARIT=0,NDPARI
C
C         Loop over the WS-states (there are 2*LDBASE of them)
C
         DO INDKET=1,LDOUBL
C
            INDLAB=0
C
            DO IBRAPA=1,LDBASP(IPARIT)
C
               INDACT=INDPAR(IBRAPA,IPARIT)
C
               NX=NXVECT(INDACT)
               NY=NYVECT(INDACT)
               NZ=NZVECT(INDACT)
C
               N0MAIN=NX+NY+NZ
C
               IF (N0MAIN.LE.NDCLAB) THEN
C
                   INDLAB=INDLAB+1
C
                   WVTRAN(INDKET,INDLAB)
     *            =WAVOCC(INDPAR(IBRAPA,IPARIT),INDKET,0)
C
               END IF
C
            END DO
C
         END DO
C
         FORM_A='N'
         FORM_B='N'
C
         NDAROW=2*MDBASE
         NDACOL=MDTRAN
         LDAROW=2*LDBASE
         LDACOL=LDBASP(IPARIT)
         LDACOL=LDLABS
C
         NDBROW=MDBASE
         NDBCOL=MDTRAN
         LDBROW=LDBASP(IPARIT)
         LDBCOL=LDBASP(IPARIT)
         LDBROW=LDLABS
         LDBCOL=LDLABS
C
         NDCROW=2*MDBASE
         NDCCOL=MDTRAN
         LDCROW=2*LDBASE
         LDCCOL=LDBASP(IPARIT)
         LDCCOL=LDLABS
C
         DO I=1,2*MDBASE
            DO J=1,MDTRAN
               RES_DW(I,J,IPARIT)=CMPLX(0.0,0.0)
               RES_UP(I,J,IPARIT)=CMPLX(0.0,0.0)
            END DO
         END DO
C
         CALL WS_CCSPRS(WVTRAN,NDAROW,NDACOL,LDAROW,LDACOL,FORM_A,
     *                  AUXCYL(1,1,IPARIT),
     *                         NDBROW,NDBCOL,LDBROW,LDBCOL,FORM_B,
     *                  RES_DW(1,1,IPARIT),
     *                         NDCROW,NDCCOL,LDCROW,LDCCOL,EPSMUL)
C
C         Loop over the WS-states (there are 2*LDBASE of them)
C
         DO INDKET=1,LDOUBL
C
            INDLAB=0
C
            DO IBRAPA=1,LDBASP(IPARIT)
C
               INDACT=INDPAR(IBRAPA,IPARIT)
C
               NX=NXVECT(INDACT)
               NY=NYVECT(INDACT)
               NZ=NZVECT(INDACT)
C
               N0MAIN=NX+NY+NZ
C
               IF (N0MAIN.LE.NDCLAB) THEN
C
                   INDLAB=INDLAB+1
C
                   WVTRAN(INDKET,INDLAB)
     *            =WAVOCC(INDPAR(IBRAPA,IPARIT),INDKET,1)
C
                  END IF
C
            END DO
C
         END DO
C
C        The call below must be activated when both projections
C        i.e. spin-up and spin-down are explicitly needed. When
C        activating - remember that in the mean time the phases
C        are already contained in matrix AUXCYL and the only mo-
C        dification will consist in changing the sign
C
         DO IKARTE=1,LDLABS
            NY=NYPARI(IKARTE,IPARIT)
            DO JCYLIN=1,LDLABS

               AUXCYL(IKARTE,JCYLIN,IPARIT)
     *        =AUXCYL(IKARTE,JCYLIN,IPARIT)
     *        *(-1)**(NY+1)*UNIT_I

            END DO

         END DO

         CALL WS_CCSPRS(WVTRAN,NDAROW,NDACOL,LDAROW,LDACOL,FORM_A,
     *                  AUXCYL(1,1,IPARIT),
     *                         NDBROW,NDBCOL,LDBROW,LDBCOL,FORM_B,
     *                  RES_UP(1,1,IPARIT),
     *                         NDCROW,NDCCOL,LDCROW,LDCCOL,EPSMUL)

C
      END DO
C
C=======================================================================
C
      ICOUNT=0
C
      DO ISTATE=1,LDOUBL
C
         N_BASE=0
C
         INDMAX=0
C
         AMPMAX=-100.
C
C=======================================================================
C
         DO IPARIT=0,NDPARI
C
            DO JCYLIN=1,LDCYLP(IPARIT)
C
               MRNILS=NBASER(JCYLIN,IPARIT)
               MZNILS=NBASZP(JCYLIN,IPARIT)
               M_NILS=NBASEM(JCYLIN,IPARIT)
C
C               Each Cartesian state of a good simplex or signature
C               must have the cylindrical decomposition of the type
C
C                   |SIMPLEX> = ALFA * |N,nz,+LAMBDA,+OMEGA>
C                             + BETA * |N,nz,-LAMBDA,-OMEGA>
C
C               where
C                        ABS(ALFA) = ABS(BETA)
C
C               Consequently, there is no need  to calculate the
C               spin-up and spin-down projections separately as long
C               as only the Nilsson labels, or the wave function
C               decompositions, are concerned. Therefore, we take only
C               one sign (UP) below
C
               DO N_SPIN=-1,1,2
C
                  N_BASE=N_BASE+1
C
C                  The multiplication below should be activated should
C                  the N_SPIN=-1 term be explicitely needed
C
                  PROML=RES_UP(ISTATE,JCYLIN,IPARIT)*
     *            CONJG(RES_UP(ISTATE,JCYLIN,IPARIT))
C
                  IF (N_SPIN.EQ.1)
     *
     *                PROML=RES_DW(ISTATE,JCYLIN,IPARIT)*
     *                CONJG(RES_DW(ISTATE,JCYLIN,IPARIT))
C
                  IF (AMPMAX.LT.PROML) THEN
C
                      AMPMAX=PROML
                      INDMAX=N_BASE
C
                  END IF
C
C                  If only the amplitude-squared is needed, we calculate
C                  only one projection, e.g. "UP", and multiply the rela-
C                  ted projection by a factor of 2
C
                  AMPLT2(N_BASE)=PROML
C
                  NSTATE(N_BASE)=N_BASE
C
                  MAINCL(N_BASE)=M_NILS+2*MRNILS+MZNILS
                  LAMBCL(N_BASE)=M_NILS
                  NZCLND(N_BASE)=MZNILS
                  IOMECL(N_BASE)=N_SPIN+2*LAMBCL(N_BASE)
C
C                  The END DO below should be activated if the time-up
C                  and the time-down blocks will be explicitely needed
C
               END DO
C
            END DO
C
         END DO
C
C=======================================================================
C
         IF (N_BASE.GT.2*MDTVEC) THEN
C
             WRITE(NOUTPT,'(''N_BASE='',I5,'' exceeds MDTVEC='',I5)')
     *                                                  N_BASE,MDTVEC
             STOP 'Cylindrical basis - Dimensions'
C
         END IF
C
C=======================================================================
C
         IF (NILWAV.EQ.1) THEN
C
             LCOLUM=10
C
             CALL WS_ORDLOW(AMPLT2,NSTATE,N_BASE,LCOLUM,AUXVEC,
     *                                  2*NDTVE2,MINDEX,LINDEX)
C
             MAINNL(ISTATE)=MAINCL(NSTATE(1))
             NZNILS(ISTATE)=NZCLND(NSTATE(1))
             L_NILS(ISTATE)=LAMBCL(NSTATE(1))
             IOMEGA(ISTATE)=IOMECL(NSTATE(1))
C
             QUOTCY(ISTATE)=AMPLT2(1)
C
         ELSE
C
             MAINNL(ISTATE)=MAINCL(INDMAX)
             NZNILS(ISTATE)=NZCLND(INDMAX)
             L_NILS(ISTATE)=LAMBCL(INDMAX)
             IOMEGA(ISTATE)=IOMECL(INDMAX)
C
             QUOTCY(ISTATE)=AMPMAX
C
         END IF
C
         WRITE(NILLAB(ISTATE),'(''|'',I2,'','',I2,'','',I2,'','',I2,
     *                                                    ''/2>'')')
     *                                    MAINNL(ISTATE),
     *                                    NZNILS(ISTATE),
     *                               ABS(L_NILS(ISTATE)),
     *                               ABS(IOMEGA(ISTATE))
C
C=======================================================================
C
C         Printing the tables of the structure of the wave functions
C         using  the  | N, Nz, LAMBDA >  r e p r e s e n t a t i o n
C
C=======================================================================
C
         IREVER=0
C
         IF (NILWAV.EQ.1) THEN
C
             IF (SPENER(ISTATE,ICHARG).GT.EMINWF.AND.
     *           SPENER(ISTATE,ICHARG).LT.EMAXWF    ) THEN
C
                 PTOTAL=0.0
                 DO I=1,LCOLUM
                    PTOTAL=PTOTAL+AMPLT2(I)
                 END DO
C
                 ICOUNT=ICOUNT+1
C
                 IF (MOD(ICOUNT+7,8).EQ.0.AND.IWRITE.GE.1) THEN
C
                     IF (ICHARG.EQ.0) THEN
C
                         WRITE(NOUTPT,'(//,80(''#''),/,
     *                                  ''#'',78X,''#'',/,
     *                         ''#  Neutron Eigenfunctions:  Nilsson'',
     *                         ''  Labels                     Omega='',
     *                         F5.3,''    #'',/,
     *                         ''#                   '',
     *                         ''                    '',
     *                         ''                    '',
     *                         ''  (Ry,Ry'''')='',A5,''   #'',/,
     *                         80(''#''),/,''#'',78X,''#'')')
     *
     *                         OMEGAC,RYTEXT(IREVER)
                     ELSE
C
                         WRITE(NOUTPT,'(//,80(''#''),/,
     *                                  ''#'',78X,''#'',/,
     *                         ''#  Proton Eigenfunctions:  Nilsson'',
     *                         ''  Labels                      Omega='',
     *                         F5.3,''    #'',/,
     *                         ''#                   '',
     *                         ''                    '',
     *                         ''                    '',
     *                         ''  (Ry,Ry'''')='',A5,''   #'',/,
     *                         ''#'',78X,''#'',/,  80(''#''),/,
     *                                        ''#'',78X,''#'')')
     *
     *                         OMEGAC,RYTEXT(IREVER)
C
                     END IF
C
                 END IF
C
                 PROBAB=AMPLT2(1)
C
                 IF (PARITY(ISTATE).GT.0.0) THEN
                     IPAUXI=INT(100*PARITY(ISTATE)+0.49999)
                 ELSE
                     IPAUXI=INT(100*PARITY(ISTATE)-0.49999)
                 END IF
C
	         IF (IWRITE.GE.1) THEN
C
                     WRITE(NOUTPT,'(''#  Energy='',F8.4,
     *                     '' (Asq.='',I3,
     *                     ''%) |N='',I2,'',nz='',I2,'',|lz|='',I2,
     *                     '',|K|='',I2,''/2>  Parity:<'',
     *                     SP,I4,SS,''%>   #'',/,
     *                     ''#                  (Sum.='',I3,
     *                     ''%)                              '',
     *                     ''                   #'')')
     *
     *                     SPENER(ISTATE,ICHARG),INT(100*PROBAB),
     *                     MAINNL(ISTATE),
     *                     NZNILS(ISTATE),
     *                ABS(L_NILS(ISTATE)),
     *                ABS(IOMEGA(ISTATE)),IPAUXI,INT(100*PTOTAL)
C
                     WRITE(NOUTPT,'(''#         A(%) =>'',
     *                      10(2X,I2,''%'',1X),
     *                             2X,''#'',/,''#'',78X,''#'')')
     *
     *                              (INT(100*AMPLT2(J)),J=1,10)
C
                     WRITE(NOUTPT,'(''#         |N >   '',
     *                       5(2X,I2,4X,I2,2X),2X,''#'')')
     *
     *                          (MAINCL(NSTATE(J)),J=1,10)
C
                     WRITE(NOUTPT,'(''#         |nz>   '',
     *                      5(2X,I2,4X,I2,2X),2X,''#'')')
     *
     *                         (NZCLND(NSTATE(J)),J=1,10)
C
                     WRITE(NOUTPT,'(''#         |lz>   '',
     *                     5(2X,SP,I2,4X,I2,SS,2X),2X,''#'')')
     *
     *                              (LAMBCL(NSTATE(J)),J=1,10)
C
                     WRITE(NOUTPT,'(''#         |K >   '',
     *                     5(SP,I3,''/2'',1X,I3,''/2'',1X,SS),2X,
     *                                                   ''#'')')
     *
     *                                 (IOMECL(NSTATE(J)),J=1,10)
C
                     WRITE(NOUTPT,'(''#'',78X,''#'')')
C
	         END IF
C
             END IF
C
         END IF
C
      END DO
C
C=======================================================================
C
C         The labelling  and  structure based on the (N, NZ, LAMBDA)
C         defined  i n d i v i d u a l l y  for  each  quantum state
C
C=======================================================================
C
      IREVER=0
C
      IF (IWRITE.GE.1) THEN
C
          IF (ICHARG.EQ.0) THEN
C
              WRITE(NOUTPT,'(//,80(''#''),/,''#'',78X,''#'',/,
     *                  ''#  NEUTRONS            N i l s s o n'',
     *                   ''   L a b e l l i n g         Omega='',
     *                                           F5.3,''   #'',/,
     *                    ''#                      Hamiltonian'',
     *                               '' Block  (Ry,Ry'''')='',A5,
     *                            ''                       #'',/,
     *                             80(''#''),/,''#'',78X,''#'',/,
     *            ''#  No)  Energy | N,nz,lz,  K >  < P%>     '',
     *              ''No)  Energy | N,nz,lz,  K >  < P%>   #'',/,
     *                  ''#'',78X,''#'')')  OMEGAC,RYTEXT(IREVER)
C
          ELSE
C
              WRITE(NOUTPT,'(//,80(''#''),/,''#'',78X,''#'',/,
     *                  ''#  PROTONS             N i l s s o n'',
     *                   ''   L A B E L L I N G         Omega='',
     *                                           F5.3,''   #'',/,
     *                    ''#                      Hamiltonian'',
     *                               '' Block  (Ry,Ry'''')='',A5,
     *                            ''                       #'',/,
     *                             80(''#''),/,''#'',78X,''#'',/,
     *            ''#  No)  Energy | N,nz,lz,  K >  < P%>     '',
     *              ''No)  Energy | N,nz,lz,  K >  < P%>   #'',/,
     *                  ''#'',78X,''#'')')  OMEGAC,RYTEXT(IREVER)
C
          END IF
C
      END IF
C
C      Printing the "Nilsson Label" associated to each WS eigenstate
C      This corresponds in fact to the Nilsson label of the HO wave-
C      function with the largest wweight in the basis decomposition.
C
      KIKOFF=0
      ISTART=1
C
      DO ISTATE=1,LDOUBL
         IF (SPENER(ISTATE,ICHARG).GE.EMINST.AND.
     *       SPENER(ISTATE,ICHARG).LE.EMAXST) THEN
             KIKOFF=KIKOFF+1
             IF (KIKOFF.EQ.1) ISTART=ISTATE
         END IF
      END DO
C
      KIKOFF=KIKOFF/2-1
C
      IF (ISTART+KIKOFF.GT.LDBASE) THEN
C
          STOP 'ISTART+KIKOFF.GT.LDBASE - IN SPECTR (2)'
C
      END IF
C
C=======================================================================
C
      DO L=ISTART,ISTART+KIKOFF
C
         L1=L
         L2=KIKOFF+L+1
C
C         Dealing with the first column
C
         IPTES1=INT(SIGN(ABS(PARITY(L1))*100+0.1,PARITY(L1)))
C
         IF (ABS(IPTES1).NE.100) THEN
             WRITE(STRNP1,'(''('',SP,I3,SS,'')'')') IPTES1
         END IF
C
         IF (IPTES1.EQ.+100) THEN
             WRITE(STRNP1,'(''( + )'')')
         END IF
C
         IF (IPTES1.EQ.-100) THEN
             WRITE(STRNP1,'(''( - )'')')
         END IF
C
C         Dealing with the second column
C
         IPTES2=INT(SIGN(ABS(PARITY(L2))*100+0.1,PARITY(L2)))
C
         IF (ABS(IPTES2).NE.100) THEN
             WRITE(STRNP2,'(''('',SP,I3,SS,'')'')') IPTES2
         END IF
C
         IF (IPTES2.EQ.+100) THEN
             WRITE(STRNP2,'(''( + )'')')
C
         END IF
C
         IF (IPTES2.EQ.-100) THEN
             WRITE(STRNP2,'(''( - )'')')
         END IF
C
	 IF (IWRITE.GE.1)
     *       WRITE(NOUTPT,'(''# '', I3,'')'',F8.3,1X,A15,2X,A5,1X,
     *                  ''   '',I3,'')'',F8.3,1X,A15,2X,A5,3X,''#'')')
     *
     *                     L1,SPENER(L1,ICHARG),NILLAB(L1),STRNP1,
     *                     L2,SPENER(L2,ICHARG),NILLAB(L2),STRNP2
C
      END DO
C
      IF (IWRITE.GE.1)
     *    WRITE(NOUTPT,'(''#'',78X,''#'',/,80(''#''))')
C
      DEALLOCATE(RES_UP,RES_DW,AUXCYL,WVTRAN)
C
C=======================================================================
C
      CALL WS_CPUTIM('NILS3D',0)
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
