C$AUTODBL DBLPAD
C***********************************************************************
C
C    Copyright (c) 2013, Lawrence Livermore National Security, LLC.
C                        Produced at the Lawrence Livermore National
C                        Laboratory.
C                        Written by Nicolas Schunck, schunck1@llnl.gov
C
C    LLNL-CODE-470611 All rights reserved.
C
C    Copyright 2011, N. Schunck, J. Dobaczewski, J. McDonnell,
C                    W. Satula, J.A. Sheikh, A. Staszczak,
C                    M. Stoitsov, P. Toivanen
C    Copyright 2009, J. Dobaczewski, W. Satula, B.G. Carlsson, J. Engel,
C                    P. Olbratowski, P. Powalowski, M. Sadziak,
C                    J. Sarich, N. Schunck, A. Staszczak, M. Stoitsov,
C                    M. Zalewski, H. Zdunczuk
C    Copyright 2004, 2005, J. Dobaczewski, P. Olbratowski
C    Copyright 1997, 2000, J. Dobaczewski, J. Dudek
C
C    This file is part of HFODD.
C
C    HFODD is free software: you can redistribute it and/or modify it
C    under the terms of the GNU General Public License as published by
C    the Free Software Foundation, either version 3 of the License, or
C    (at your option) any later version.
C
C    HFODD is distributed in the hope that it will be useful, but
C    WITHOUT ANY WARRANTY; without even the implied warranty of
C    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
C    GNU General Public License for more details.
C
C    You should have received a copy of the GNU General Public License
C    along with HFODD. If not, see <http://www.gnu.org/licenses/>.
C
C    OUR NOTICE AND TERMS AND CONDITIONS OF THE GNU GENERAL PUBLIC
C    LICENSE
C
C    Our Preamble Notice
C
C      A. This notice is required to be provided under our contract
C         with the U.S. Department of Energy (DOE). This work was
C         produced at the Lawrence Livermore National Laboratory under
C         Contract No. DE-AC52-07NA27344 with the DOE.
C      B. Neither the United States Government nor Lawrence Livermore
C         National Security, LLC nor any of their employees, makes any
C         warranty, express or implied, or assumes any liability or
C         responsibility for the accuracy, completeness, or usefulness
C         of any information, apparatus, product, or process disclosed,
C         or represents that its use would not infringe privately-owned
C         rights.
C      C. Also, reference herein to any specific commercial products,
C         process, or services by trade name, trademark, manufacturer
C         or otherwise does not necessarily constitute or imply its
C         endorsement, recommendation, or favoring by the United States
C         Government or Lawrence Livermore National Security, LLC. The
C         views and opinions of authors expressed herein do not
C         necessarily state or reflect those of the United States
C         Government or Lawrence Livermore National Security, LLC, and
C         shall not be used for advertising or product endorsement
C         purposes.
C
C    The precise terms and conditions for copying, distribution and
C    modification are contained in the file COPYING.
C
C***********************************************************************
C
C    VERSION 256d
C      - updated the shell correction module
C    VERSION 256c
C      -
C    VERSION 256b
C      - trying to debug THC module
C      - trying to debug Gogny pairing
C      - added center of mass correction for fission fragments and rotation
C        of q.p wave-functions
C    VERSION 256a
C      - added computation of a few observables in module hfodd_fission
C      - added option to constrain on fractional particle numbers
C      - adopted Fortran 90 standard for initialization of large arrays
C    VERSION 256
C      - X-THC module for Coulomb by Rob Parrish (untested yet)
C    VERSION 255g
C      - added option in hfodd_mpimanager to compute irregular meshes
C        (by restarting from irregular meshes)
C      - fixed bugs in module hfodd_fission in subroutines DEFMAS and
C        interaction_energy_Skyrme
C      - rewritten the calculation of Coulomb and Skyrme interaction energy
C    VERSION 255f
C      - fixed the bug in the calculation of the deformation of the
C        fragments (module hfodd_fission)
C    VERSION 255e
C      - bug fixes and cosmetic changes in the main code and fission modules
C      - full rewrite of the hfodd_mpimanager module to enable restarts from
C        irregular meshes
C    VERSION 255d
C      - added routines to compute interaction energy in hfodd_fission
C        (requires SWITCH_COMPATIBILITY=1 to work properly)
C      - updated HFBTHO module with version 200b
C    VERSION 255c
C      - moved routines related to fission (QN, neck constraint) into a
C        separate module 'hfodd_fission' to facilitate futher developments
C      - added option to compute and record s.p. and q.p. wave-functions
C    VERSION 255b
C      - fixed bug on calculation of the entropy
C      - added te, to so that tensor *forces* can be included (UNEDF2)
C      - experimentations with GPU libraries
C    VERSION 255a
C      - updated HFBTHO module with version 142
C    VERSION 255
C      - updated HFBTHO module with version 141 that includes THO module
C      - added option to restart with HFBTHO from HFODD record file
C    VERSION 254b
C      - Gogny mean-field is debugged (Jacek)
C      - first (bugged) implementation of Gogny pairing
C    VERSION 254a
C      - accelerated subroutine DENSHF by use of OpenMP threading. Note
C        that this option can only work if the implementation of OpenMP
C        supports nested parallelism
C    VERSION 254
C      - updated HFBTHO module with version 139, including (i) the
C        support of finite-temperature HFB (ii) redirection of output
C        in parallel mode (iii) deeper integration HFODD/HFBTHO (cut
C        off energy for basis states, deformation of basis)
C    VERSION 253
C      - updated HFBTHO module with version 137 including (i) constraints
C        on axial multipole moments up to lambda=8, (ii) RPA method to
C        handle constraints (iii) parity-breaking mode
C    VERSION 252b
C      - changed the restart mode to find the shortest distance between
C        new and old point
C    VERSION 252a
C      - fixed bugs in NUMCON (related to push options), to QMULCM
C        (slowing factors in restart modes)
C      - added batch mode for parallel calculations
C      - added slowing down of the neck position in QNFIND
C      - cleaned up file I/O operations. In batch mode, the review
C        file is written only at the end, while it is re-closed and
C        re-opened in sequential mode (thus with the possibility of
C        changing the filename)
C    VERSION 252
C      - added a few process-independent input data in parallel mode
C      - the collective space can be pre-set in the input file
C      - the program can now restart from a grid that included QN as
C        a constraint
C    VERSION 251
C      - add module to compute collective inertia with pre-processor
C        flag USE_INERTIA (no input data)
C      - fixed 2 bugs when using a constraint over Q_N (compatibility
C        with restart and subroutine DEF_QN)
C      - moved 'hfodd_sizes.h' into Fortran 90 module
C      - reverted changes in subroutine DENSHF for IPABCS=3 and IFTEMP=1
C    VERSION 250i
C      - add option to compute a number of different temperatures in
C        parallel
C      - clean-up of parallel modules hfodD_mpiio.f90 and
C        hfodd_mpimanager.f90
C    VERSION 250h
C      - computes deformations (multipole moment expectation values)
C        of the fragments assuming a sharp scission point
C      - closes all opened files properly
C    VERSION 250g
C      - generalizes LN at finite temperature (not functional yet!)
C      - displays fission fragments and temperature quantities
C      - Anderson mixing available for IBROYD=2
C      - error handling in RECORD()
C    VERSION 250f
C      - option to compute the expectation values of total and charge
C        density in the fission fragments
C    VERSION 250e
C      - cosmetic changes to output
C      - option to switch to Broyden if N iterations below a certain
C        precision (instead of 1 until now)
C      - set up general scheme for restarts in parallel mode with
C        pre-defined directories and variable optimizePath)
C      - pre-set dependence of the basis on multipole moments
C    VERSION 250d
C      - bug fixed for IREAWS=1 in parallel mode, added condition in
C        TESDAT, removed SWITCH_PORT from COPPAI/SYMPAI
C      - modifed DENMAC to use BLAS routines
C    VERSION 250c
C      - no update of generalized density matrix (reverted to statu
C        quo antes by removing everything related to this update)
C      - HFODD standard treatment of Fermi level
C      - option IVACUM to get HF vaccum configuration automatically
C      - option IHFPOT to get HF mean-field for WS code
C
C----------------------------------------------------------------------!
C                                                                      !
C                     HFODD Main Source                                !
C                                                                      !
C Authors (by alphabetical order):                                     !
C                                                                      !
C   B.G. Carlsson, J. Dobaczewski, J. Dudek, J. Engel, J. McDonnell,   !
C   P. Olbratowski, P. Powalowski, M. Sadziak, J. Sarich, W. Satula,   !
C   N. Schunck, J.A. Sheikh, A. Staszczak, M. Stoitsov, P. Toivanen,   !
C   M. Zalewski, H. Zdunczuk                                           !
C                                                                      !
C Publications (by chronological order)                                !
C                                                                      !
C  [1] J. Dobaczewski and J. Dudek,                                    !
C      Comput. Phys. Commun. 102, 166  (1997); 102, 183 (1997).        !
C  [2] J. Dobaczewski and J. Dudek,                                    !
C      Comput. Phys. Commun. 131, 164 (2000).                          !
C  [3] J. Dobaczewski and P. Olbratowski,                              !
C      Comput. Phys. Commun. 158, 158 (2004).                          !
C  [4] J. Dobaczewski and P. Olbratowski,                              !
C      Comput. Phys. Commun. 167, 214 (2005).                          !
C  [5] J. Dobaczewski, W. Satula, B.G. Carlsson, J. Engel,             !
C      P. Olbratowski, P. Powalowski, M. Sadziak, J. Sarich,           !
C      N. Schunck, A. Staszczak, M. Stoitsov, M. Zalewski,             !
C      and H. Zdunczuk,                                                !
C      Comput. Phys. Commun. 180, 2361 (2009).                         !
C  [6] N. Schunck, J. Dobaczewski, J. McDonnell, W. Satula,            !
C      J.A. Sheikh, A. Staszczak, M. Stoitsov, and P. Toivanen,        !
C      Comput. Phys. Commun. 183, 166 (2012).                          !
C                                                                      !
C User's Guide (v.240h)                                                !
C                                                                      !
C      J. Dobaczewski, W. Satula, B.G. Carlsson, J. Engel,             !
C      P. Olbratowski, P. Powalowski, M. Sadziak, J. Sarich,           !
C      N. Schunck, A. Staszczak, M. Stoitsov, M. Zalewski, and         !
C      H. Zdunczuk,                                                    !
C      HFODD (v2.40h) User's Guide: arXiv:0909.3626 (2009).            !
C                                                                      !
C=======================================================================
C      HFODD     HFODD     HFODD     HFODD     HFODD     HFODD     HFODD
C=======================================================================
C
C      HFODD  SOLVES THE NUCLEAR HARTREE-FOCK OR HARTREE-FOCK-BOGOLYUBOV
C             PROBLEM WITHOUT ASSUMING PLANE-REFLECTION OR TIME-REVERSAL
C             SYMMETRIES
C
C=======================================================================
      PROGRAM HF_ODD
C=======================================================================
#if(USE_OPENMP==1)
      USE omp_lib
#endif
C=======================================================================
#if(USE_MPI==1)
      USE hfodd_mpiio
      USE hfodd_mpiManager
#endif
C=======================================================================
      USE hfodd_sizes
      USE HE_DEN
      USE FRAGFL
      USE WAVR_L
      USE hfodd_interface
      USE hfodd_hfbtho
      USE hfodd_fission
      USE hfodd_inertia
C=======================================================================
#if(USE_SCALAPACK==1)
      USE hfodd_SLsiz
#endif
C=======================================================================
C
      CHARACTER
     *          SKYRME*4,GOGNAM*4,VERSIO*5,NUMSTR*6
      CHARACTER
     *          FILREP*68,FILREC*68,FILWOO*68,
     *          FILREV*68,FILCOU*68,FILISO*68,FILWAV*68,FILKER*68,
     *          FILYUP*68,FILYUC*68,
     *          FILGOP*68,FILGOC*68,
     *          FILGPP*68,FILGPC*68,
     *          FILLIP*68,FILLIC*68,
     *          FILFIP*68,FILFIC*68
      CHARACTER
     *          NAMMUL*45,NAMSIF*45,NAMSUR*45,NAMSCH*45,
     *          NAMPLM*45,NAMMAG*45
      CHARACTER
     *          NAMHAR*17,NAMSHI*17,NAMROT*17
      CHARACTER
     *          NAMEPN*8
      CHARACTER
     *          SPMODL*14,ANGLEC*8,ESTABC*12
      CHARACTER
     *          MYDATE*8,MYTIME*10,MYZONE*5
C@@@ HFBTHO - HFBTHO - HFBTHO - HFBTHO - HFBTHO - HFBTHO - HFBTHO
      CHARACTER
     *          FILTHO*30
C@@@ HFBTHO - HFBTHO - HFBTHO - HFBTHO - HFBTHO - HFBTHO - HFBTHO
C
      LOGICAL
     *          PRINIT,PRIYUK,PRIBET
      LOGICAL
     *          TERMNT,COR_CM,CORROT
      LOGICAL
     *          DOPUSH,do_debug,name_file
C
      COMPLEX
     *          ALPHAC(0:NDLAMB,-NDLAMB:+NDLAMB)
      COMPLEX
     *          EKEKIN,EKESKY,EKECOD,EKECOE,EKESCA,EKEVEC
      COMPLEX
     *          QMUT_N,QMUT_P,QMUT_T
      COMPLEX
     *          AMUT_N,AMUT_P,AMUT_T
      COMPLEX
     *          SMUT_N,SMUT_P,SMUT_T
      COMPLEX
     *          CERMTS,CHRMTS,CDHRMT
      COMPLEX
     *          DKINSN,DKINSP,DKINST,
     *          EKINSN,EKINSP,EKINST,
     *          PKINSN,PKINSP,PKINST,
     *          TKINSN,TKINSP,TKINST,
     *          AKINLN,AKINLP,AKINLT,
     *          PKINLN,PKINLP,PKINLT,
     *          PKINKN,PKINKP,PKINKT
      COMPLEX
     *          DKOTSN,DKOTSP,DKOTST,
     *          EKOTSN,EKOTSP,EKOTST,
     *          PKOTSN,PKOTSP,PKOTST,
     *          TKOTSN,TKOTSP,TKOTST,
     *          AKOTLN,AKOTLP,AKOTLT,
     *          PKOTLN,PKOTLP,PKOTLT,
     *          PKOTKN,PKOTKP,PKOTKT
C
      COMPLEX
     *          C_ZERO
C
      DIMENSION
     *          MYVALU(8)
      DIMENSION
     *          LAMVOD(1:NDCONS)
      DIMENSION
     *          I_COPY(0:NDMULT,-NDMULT:NDMULT)
      DIMENSION
     *          Q_COPY(0:NDMULT,-NDMULT:NDMULT)
      DIMENSION
     *          QACTUA(0:NDMULT,-NDMULT:NDMULT),
     *          QORIGI(0:NDMULT,-NDMULT:NDMULT),
     *	        QINCRE(0:NDMULT,-NDMULT:NDMULT)
C=======================================================================
      allocatable x_t(:),w_t(:),y_t(:,:)
C=======================================================================
C@@@ SHELL - SHELL - SHELL - SHELL - SHELL - SHELL - SHELL - SHELL
      DIMENSION
     *          IZNUCL(1:NDNUCL),INNUCL(1:NDNUCL)
      DIMENSION
     *          DSHELP(1:NDNUCL),DSHELN(1:NDNUCL)
C@@@ SHELL - SHELL - SHELL - SHELL - SHELL - SHELL - SHELL - SHELL
C@@@ HFBTHO - HFBTHO - HFBTHO - HFBTHO - HFBTHO - HFBTHO - HFBTHO
      Logical :: initial_pair_THO, set_temper_THO, force_parity_THO,
     *           HFODD_to_HFBTHO
C
      Integer :: Nshell_THO, neutron_THO, proton_THO, type_THO,
     *           niter_THO, restart_THO, coulomb_THO, useTHO_THO,
     *           gauge_THO, projection_THO, dN_THO, dZ_THO, output_THO,
     *           numGauss_THO, numLaguerre_THO, numLegendre_THO,
     *           nstate_THO, unit_tho
      Integer :: n_blocking_THO(1:5), p_blocking_THO(1:5),
     *           lambda_THO(1:8), active_THO(1:8)
C
      Double Precision :: b0_THO, bz_THO, bp_THO, beta0_THO,
     *                    accuracy_THO, VpairN_THO, VpairP_THO,
     *                    temper_THO, b2_THO, b4_THO, Ecut_THO,
     *                    V1_THO
      Double Precision :: expect_THO(1:8), multLag_tho(1:8)
C
      Character(Len=30) :: functional_THO
C
      Character(Len=30) :: file_THO
C@@@ HFBTHO - HFBTHO - HFBTHO - HFBTHO - HFBTHO - HFBTHO - HFBTHO
C@@@ OPENMP - OPENMP - OPENMP - OPENMP - OPENMP - OPENMP - OPENMP
#if(USE_OPENMP==1)
      integer :: numThreads
#endif
C@@@ OPENMP - OPENMP - OPENMP - OPENMP - OPENMP - OPENMP - OPENMP
C=======================================================================
C@@@ MPI - MPI - MPI - MPI - MPI - MPI - MPI - MPI - MPI - MPI - MPI
C
      integer, dimension(:), pointer :: LAMPUS, MIUPUS
C
      double precision, dimension(:), pointer :: QMOPUS
C
      integer, dimension(:), pointer :: LAM_WS, MIU_WS
      integer, dimension(:), pointer :: L_COLL, M_COLL
C
      integer, dimension(:), allocatable :: LBCOLL, MBCOLL
C
#if(USE_MPI==1)
      integer :: mpi_err, n_proc, mpi_activ
      integer :: color, intkey, printTopology
      integer :: escapeSignal
      integer :: batch_init
C
      integer :: worldGroup, groupMasters, mastersCOMM,
     *                       groupSlaves, slavesCOMM, tribeCOMM
      integer :: tribeRank, slaveRank, masterRank, worldRank
      integer :: tribeSize, slaveSize, masterSize, worldSize
      integer :: counter_eval, syst_cnt, syst_rate
C
      integer, dimension(:), pointer :: LAMBAS, MIUBAS
C
      integer, dimension(:), allocatable :: my_evals, all_evals
      integer, dimension(:), allocatable :: rankMasters
#if(USE_SCALAPACK==1)
      integer :: n_tribe, n_color
      integer, dimension(:), allocatable :: all_tribeRank, all_color,
     *                                      all_worldRank
#endif
C
      double precision :: cput_start, cput_end, syst_start, syst_end
      double precision, dimension(:), allocatable ::
     *                  my_cputime, all_cputimes
      double precision, dimension(1:2) :: valuesDelta
C
      double precision, dimension(:), pointer :: BETBAS
C
      character(len=16) :: FILOUT
      character(len=18) :: filsum
      character(len=68) :: optimal, courant
      character(len=150) :: commande
C
      COMMON
     *       /MPICOM/ worldGroup, groupMasters, groupSlaves,
     *                mastersCOMM, slavesCOMM, tribeCOMM
      COMMON
     *       /MPIPRO/ numberMasters, numberHFODDproc, color,
     *                tribeRank, slaveRank, masterRank, worldRank,
     *                tribeSize, slaveSize, masterSize, worldSize
#endif
C@@@  - MPI - MPI - MPI - MPI - MPI - MPI - MPI - MPI - MPI - MPI
C=======================================================================
C
      COMMON
     *       /BASISO/ NXVECT(1:NDBASE),NYVECT(1:NDBASE),NZVECT(1:NDBASE)
      COMMON
     *       /BINDEX/ INDICE(0:NDXMAX,0:NDYMAX,0:NDZMAX)
     *
     *       /BLIMS1/ LAXOFY(0:NDYMAX),LAXOFZ(0:NDZMAX),
     *                LAYOFZ(0:NDZMAX),LAYOFX(0:NDXMAX),
     *                LAZOFX(0:NDXMAX),LAZOFY(0:NDYMAX)
     *
     *       /BLIMS2/ LAXOYZ(0:NDYMAX,0:NDZMAX),
     *                LAYOZX(0:NDZMAX,0:NDXMAX),
     *                LAZOXY(0:NDXMAX,0:NDYMAX)
      COMMON
     *       /FLOPAR/ XIZFIX,XINFIX
      COMMON
     *       /HERSTO/ HERMTS(0:ND2MAX,1:NDGAUS,1:NDKART)
      COMMON
     *       /HERMEM/ HERONE(0:ND2MAX,1:NDGAUS,1:NDKART)
      COMMON
     *       /DIVSTO/ DHRMTS(0:ND2MAX,1:NDGAUS,1:NDKART),
     *                DDHRMT(0:ND2MAX,1:NDGAUS,1:NDKART)
      COMMON
     *       /DIVMEM/ DHRONE(0:ND2MAX,1:NDGAUS,1:NDKART),
     *                DDHONE(0:ND2MAX,1:NDGAUS,1:NDKART)
      COMMON
     *       /HERCOM/ CERMTS(0:ND2MAX,1:NDGAUS,1:NDKART),
     *                CHRMTS(0:ND2MAX,1:NDGAUS,1:NDKART),
     *                CDHRMT(0:ND2MAX,1:NDGAUS,1:NDKART)
      COMMON
     *       /INTSTO/ FOURWG(1:NDGAUS,1:NDKART),
     *                FOURPT(1:NDGAUS,1:NDKART)
      COMMON
     *       /INTMEM/ TWOWGT(1:NDGAUS,1:NDKART),
     *                TWOPNT(1:NDGAUS,1:NDKART)
      COMMON
     *       /RMSRAD/ RADI_N(0:NDKART),
     *                RADI_P(0:NDKART),
     *                RADI_T(0:NDKART)
      COMMON
     *       /RMSSHI/ RSHI_N(0:NDKART),
     *                RSHI_P(0:NDKART),
     *                RSHI_T(0:NDKART)
      COMMON
     *       /COEMUL/ COMULT(0:NDMULT,0:NDOSCI,0:NDOSCI,1:NDKART)
      COMMON
     *       /FRAMUL/ QLMNEU(0:NDMULT,-NDMULT:NDMULT,0:1),
     *                QLMPRO(0:NDMULT,-NDMULT:NDMULT,0:1),
     *                QLMTOT(0:NDMULT,-NDMULT:NDMULT,0:1)
      COMMON
     *       /FRAORI/ QORNEU(0:NDMULT,-NDMULT:NDMULT,0:1),
     *                QORPRO(0:NDMULT,-NDMULT:NDMULT,0:1),
     *                QORTOT(0:NDMULT,-NDMULT:NDMULT,0:1)
      COMMON
     *       /QMUTTI/ QMUT_N(0:NDMULT,-NDMULT:NDMULT),
     *                QMUT_P(0:NDMULT,-NDMULT:NDMULT),
     *                QMUT_T(0:NDMULT,-NDMULT:NDMULT)
      COMMON
     *       /QMULTI/ QMUL_N(0:NDMULT,-NDMULT:NDMULT),
     *                QMUL_P(0:NDMULT,-NDMULT:NDMULT),
     *                QMUL_T(0:NDMULT,-NDMULT:NDMULT)
      COMMON
     *       /SMUTTI/ SMUT_N(0:NDMULT,-NDMULT:NDMULT),
     *                SMUT_P(0:NDMULT,-NDMULT:NDMULT),
     *                SMUT_T(0:NDMULT,-NDMULT:NDMULT)
      COMMON
     *       /SMULTI/ SMUL_N(0:NDMULT,-NDMULT:NDMULT),
     *                SMUL_P(0:NDMULT,-NDMULT:NDMULT),
     *                SMUL_T(0:NDMULT,-NDMULT:NDMULT)
      COMMON
     *       /PMULTI/ PMUL_N(0:NDMULT,-NDMULT:NDMULT),
     *                PMUL_P(0:NDMULT,-NDMULT:NDMULT),
     *                PMUL_T(0:NDMULT,-NDMULT:NDMULT)
      COMMON
     *       /VMULTI/ VMUL_N(0:NDMULT,-NDMULT:NDMULT,1:NDKART),
     *                VMUL_P(0:NDMULT,-NDMULT:NDMULT,1:NDKART),
     *                VMUL_T(0:NDMULT,-NDMULT:NDMULT,1:NDKART)
      COMMON
     *       /QSHIFT/ QSHI_N(0:NDMULT,-NDMULT:NDMULT),
     *                QSHI_P(0:NDMULT,-NDMULT:NDMULT),
     *                QSHI_T(0:NDMULT,-NDMULT:NDMULT)
      COMMON
     *       /SSHIFT/ SSHI_N(0:NDMULT,-NDMULT:NDMULT),
     *                SSHI_P(0:NDMULT,-NDMULT:NDMULT),
     *                SSHI_T(0:NDMULT,-NDMULT:NDMULT)
      COMMON
     *       /QROTAT/ QROT_N(0:NDMULT,-NDMULT:NDMULT),
     *                QROT_P(0:NDMULT,-NDMULT:NDMULT),
     *                QROT_T(0:NDMULT,-NDMULT:NDMULT)
      COMMON
     *       /SROTAT/ SROTNN(0:NDMULT,-NDMULT:NDMULT),
     *                SROTNP(0:NDMULT,-NDMULT:NDMULT),
     *                SROTNT(0:NDMULT,-NDMULT:NDMULT)
      COMMON
     *       /AROTAT/ AROTNN(0:NDMULT,-NDMULT:NDMULT),
     *                AROTNP(0:NDMULT,-NDMULT:NDMULT),
     *                AROTNT(0:NDMULT,-NDMULT:NDMULT)
      COMMON
     *       /AMUTTI/ AMUT_N(0:NDMULT,-NDMULT:NDMULT),
     *                AMUT_P(0:NDMULT,-NDMULT:NDMULT),
     *                AMUT_T(0:NDMULT,-NDMULT:NDMULT)
      COMMON
     *       /AMULTI/ AMUL_N(0:NDMULT,-NDMULT:NDMULT),
     *                AMUL_P(0:NDMULT,-NDMULT:NDMULT),
     *                AMUL_T(0:NDMULT,-NDMULT:NDMULT)
      COMMON
     *       /ASHIFT/ ASHI_N(0:NDMULT,-NDMULT:NDMULT),
     *                ASHI_P(0:NDMULT,-NDMULT:NDMULT),
     *                ASHI_T(0:NDMULT,-NDMULT:NDMULT)
      COMMON
     *       /QLASTR/ GALMUQ(0:NDMULT,-NDMULT:NDMULT),
     *                QLINEA(0:NDMULT,-NDMULT:NDMULT),
     *                IFLALQ(0:NDMULT,-NDMULT:NDMULT)
      COMMON
     *       /SLASTR/ GALMUS(0:NDMULT,-NDMULT:NDMULT),
     *                SLINEA(0:NDMULT,-NDMULT:NDMULT),
     *                IFLALS(0:NDMULT,-NDMULT:NDMULT)
      COMMON
     *       /RLASTR/ RALMUQ(0:NDMULT,-NDMULT:NDMULT),
     *                RALMUS(0:NDMULT,-NDMULT:NDMULT)
      COMMON
     *       /OURUNI/ QUNITS(0:NDMULT,0:NDMULT)
      COMMON
     *       /SIFUNI/ SUNITS(0:NDMULT,0:NDMULT)
      COMMON
     *       /MAGUNI/ AUNITS(0:NDMULT,0:NDMULT)
      COMMON
     *       /CONVER/ ETOTFI(0:NDITER),ETOTSI(0:NDITER),
     *                                 ESTABI(0:NDITER),
     *                QUA20I(0:NDITER),QUA22I(0:NDITER),
     *                ANGUTI(0:NDITER)
      COMMON
     *       /SPNUMS/ NUMBSP(0:NDREVE,0:NDISOS)
      COMMON
     *       /ANGANG/ ANGU_N(1:NDKART),ANGU_P(1:NDKART),ANGU_T(1:NDKART)
      COMMON
     *       /ANGSPI/ SPIN_N(1:NDKART),SPIN_P(1:NDKART),SPIN_T(1:NDKART)
      COMMON
     *       /LINMOM/ DLINSN(0:NDKART),DLINSP(0:NDKART),DLINST(0:NDKART)
     *               ,ELINSN(0:NDKART),ELINSP(0:NDKART),ELINST(0:NDKART)
     *               ,TLINSN(0:NDKART),TLINSP(0:NDKART),TLINST(0:NDKART)
     *               ,ALINLN(0:NDKART),ALINLP(0:NDKART),ALINLT(0:NDKART)
      COMMON
     *       /KINMOM/ DKINSN(0:NDKART),DKINSP(0:NDKART),DKINST(0:NDKART)
     *               ,EKINSN(0:NDKART),EKINSP(0:NDKART),EKINST(0:NDKART)
     *               ,TKINSN(0:NDKART),TKINSP(0:NDKART),TKINST(0:NDKART)
     *               ,AKINLN(0:NDKART),AKINLP(0:NDKART),AKINLT(0:NDKART)
      COMMON
     *       /LINPAI/ PLINSN(0:NDKART),PLINSP(0:NDKART),PLINST(0:NDKART)
     *               ,PLINLN(0:NDKART),PLINLP(0:NDKART),PLINLT(0:NDKART)
     *               ,PLINKN(0:NDKART),PLINKP(0:NDKART),PLINKT(0:NDKART)
      COMMON
     *       /KINPAI/ PKINSN(0:NDKART),PKINSP(0:NDKART),PKINST(0:NDKART)
     *               ,PKINLN(0:NDKART),PKINLP(0:NDKART),PKINLT(0:NDKART)
     *               ,PKINKN(0:NDKART),PKINKP(0:NDKART),PKINKT(0:NDKART)
      COMMON
     *       /ROTMOM/ DROTSN(0:NDKART),DROTSP(0:NDKART),DROTST(0:NDKART)
     *               ,EROTSN(0:NDKART),EROTSP(0:NDKART),EROTST(0:NDKART)
     *               ,TROTSN(0:NDKART),TROTSP(0:NDKART),TROTST(0:NDKART)
     *               ,AROTLN(0:NDKART),AROTLP(0:NDKART),AROTLT(0:NDKART)
      COMMON
     *       /KOTMOM/ DKOTSN(0:NDKART),DKOTSP(0:NDKART),DKOTST(0:NDKART)
     *               ,EKOTSN(0:NDKART),EKOTSP(0:NDKART),EKOTST(0:NDKART)
     *               ,TKOTSN(0:NDKART),TKOTSP(0:NDKART),TKOTST(0:NDKART)
     *               ,AKOTLN(0:NDKART),AKOTLP(0:NDKART),AKOTLT(0:NDKART)
      COMMON
     *       /ROTPAI/ PROTSN(0:NDKART),PROTSP(0:NDKART),PROTST(0:NDKART)
     *               ,PROTLN(0:NDKART),PROTLP(0:NDKART),PROTLT(0:NDKART)
     *               ,PROTKN(0:NDKART),PROTKP(0:NDKART),PROTKT(0:NDKART)
      COMMON
     *       /KOTPAI/ PKOTSN(0:NDKART),PKOTSP(0:NDKART),PKOTST(0:NDKART)
     *               ,PKOTLN(0:NDKART),PKOTLP(0:NDKART),PKOTLT(0:NDKART)
     *               ,PKOTKN(0:NDKART),PKOTKP(0:NDKART),PKOTKT(0:NDKART)
      COMMON
     *       /SHIANG/ ANGS_N(1:NDKART),ANGS_P(1:NDKART),ANGS_T(1:NDKART)
      COMMON
     *       /ROTANG/ ANGR_N(1:NDKART),ANGR_P(1:NDKART),ANGR_T(1:NDKART)
      COMMON
     *       /ROTSPI/ SPIR_N(1:NDKART),SPIR_P(1:NDKART),SPIR_T(1:NDKART)
      COMMON
     *       /DATPAN/ GPAIRN,FACTGN,EFERMN,DELTAN,EFER2N
     *       /DATPAP/ GPAIRP,FACTGP,EFERMP,DELTAP,EFER2P
      COMMON
     *       /CCPPAI/ PRHO_N,PRHODN,PRHOSN,POWERN,
     *                PRHO_P,PRHODP,PRHOSP,POWERP
      COMMON
     *       /PAIINI/ FERINI(0:NDISOS),DELINI(0:NDISOS),FE2INI(0:NDISOS)
      COMMON
     *       /ALLENE/ EKIN_N,EKIN_P,EKIN_T,
     *                EPOT_N,EPOT_P,EPOT_T,
     *                ESUM_N,ESUM_P,ESUM_T,
     *                EPAI_N,EPAI_P,EPAI_T,
     *                EREA_N,EREA_P,EREA_T,
     *                ELIP_N,ELIP_P,ELIP_T,
     *
     *                ECOULD,ECOULE,ECOULT,
     *                       ECOULS,ECOULV,
     *
     *                EMULCO,EMUSLO,EMUREA,
     *                ESIFCO,ESISLO,ESIREA,
     *                ESPICO,ESPSLO,ESPREA,
     *
     *                ENREAR,ECORCM,ECOR_R,
     *
     *                EEVEW0,EODDW0,ENE_W0,
     *                ENEVEN,ENEODD,ENESKY,
     *                ESTABN,ETOTSP,ETOTFU
      COMMON
     *       /EYUKTT/ EYUKDT,EYUKD0,EYUKD1,EYUKD2,
     *                EYUKET,EYUKE0,EYUKE1,EYUKE2
      COMMON
     *       /EGOGTT/ EGOGDT,EGOGET
     *       /PGOGTT/ PGOGDT
      COMMON
     *       /ITERTS/ ITESTA,ITESTO,NOITER,NUMITE
      COMMON
     *       /SIZNVA/ NVASIZ(0:NDISOS)
      COMMON
     *       /N_FLIG/ NPFLIG(0:NDPARI,0:NDREVE,0:NDISOS),
     *                NHFLIG(0:NDPARI,0:NDREVE,0:NDISOS),
     *                NOFLIG(0:NDPARI,0:NDREVE,0:NDISOS)
      COMMON
     *       /N_FLIM/ NPFLIM(         0:NDREVE,0:NDISOS),
     *                NHFLIM(         0:NDREVE,0:NDISOS),
     *                NOFLIM(         0:NDREVE,0:NDISOS)
      COMMON
     *       /N_FLIQ/ NPFLIQ(0:NDPARI,         0:NDISOS),
     *                NHFLIQ(0:NDPARI,         0:NDISOS),
     *                NOFLIQ(0:NDPARI,         0:NDISOS)
      COMMON
     *       /N_FLIZ/ NPFLIZ(                  0:NDISOS),
     *                NHFLIZ(                  0:NDISOS),
     *                NOFLIZ(                  0:NDISOS)
      COMMON
     *       /OMEGAS/ OMEGAX,OMEGAY,OMEGAZ
      COMMON
     *       /OMOVAS/ OMOVAX,OMOVAY,OMOVAZ
      COMMON
     *       /EANGLE/ ALPEUL,BETEUL,GAMEUL
      COMMON
     *       /PHYCON/ H_BARC,XMASSP,XMASSN,HBCOE2
     *       /CHARGE/ ECHAR2
      COMMON
     *       /SCALNG/ HOMSCA(NDKART)
      COMMON
     *       /PLANCK/ HBMASS,HBMRPA,HBMINP
      COMMON
     *       /RENORM/ HBMREN(NDKART)
      COMMON
     *       /RENROT/ ROTREN(NDKART)
      COMMON
     *       /RINORM/ HBMRIN(NDKART)
      COMMON
     *       /RINROT/ ROTRIN(NDKART)
      COMMON
     *       /BROINI/ IBROYD,N_ITER
     *       /BROMIX/ ALPHAM,BROTRI
     *       /BROMAT/ NOIINP,MIXMAT
      COMMON
     *       /HEREPS/ EPSHER
      COMMON
     *       /CFIREA/ NFIREA
      COMMON
     *       /CFIPRI/ NFIPRI
C@@@ MULTIPOLE - MULTIPOLE - MULTIPOLE - MULTIPOLE
      COMMON
     *       /CNSOLD/ VECOLD(1:NDCONS)
      COMMON
     *       /CNSCOR/ LAMCNS(1:NDCONS),MIUCNS(1:NDCONS)
     *       /CNSNUM/ NOFCNS
      COMMON
     *       /REALPH/ ALPHAR(0:NDLAMB,0:NDLAMB)
      COMMON
     *       /QCNSTR/ STIFFQ(0:NDMULT,-NDMULT:NDMULT),
     *                QASKED(0:NDMULT,-NDMULT:NDMULT),
     *                IFLAGQ(0:NDMULT,-NDMULT:NDMULT)
C@@@ MULTIPOLE - MULTIPOLE - MULTIPOLE - MULTIPOLE
C SL - SL - SL - SL - SL - SL - SL - SL - SL - SL - SL - SL - SL - SL
      COMMON
     *       /SCALAPACK_INP/ NBLOCK,MBLOCK,NPGRID,MPGRID,KZHPEV
C SL - SL - SL - SL - SL - SL - SL - SL - SL - SL - SL - SL - SL - SL
C@@@ SHELL - SHELL - SHELL - SHELL - SHELL - SHELL - SHELL - SHELL
      COMMON
     *       /DIMENS/ LDBASE
      COMMON
     *       /STRUTI_PARAMS/ GSTRUN,GSTRUP,HOMFAC,EPSRTN
     *       /STRUTI_POLYNO/ NPOLYN
C@@@ SHELL - SHELL - SHELL - SHELL - SHELL - SHELL - SHELL - SHELL
C@@@ TEMP -TEMP - TEMP - TEMP - TEMP - TEMP - TEMP - TEMP - TEMP
      COMMON
     *       /FERFUN/ FER_FN(1:NDBASE)
      COMMON
     *       /T_FLAG/ IFTEMP
      COMMON
     *       /GCTEMP/ TEMP_T
      COMMON
     *       /SENTRO/ ENTRPY(0:NDISOS)
C@@@ TEMP -TEMP - TEMP - TEMP - TEMP - TEMP - TEMP - TEMP - TEMP
C@@@ NECK - NECK - NECK - NECK - NECK - NECK - NECK - NECK - NECK
      COMMON
     *       /NCKVAL/ Q0NECK,G_NECK
     *       /NCKFLA/ IFNECK
C@@@ NECK - NECK - NECK - NECK - NECK - NECK - NECK - NECK - NECK
      COMMON
     *       /DEFORM/ ALPHAC,IREALA
      COMMON
     *       /AUTOBA/ IBASIS
      COMMON
     *       /EDFINP/ IF_EDF
     *       /EDFPAR/ V0NEFF,V0PEFF,COUSCA
      COMMON
     *       /MINDEF/ LAMINP(1:NDSEAR),MIUINP(1:NDSEAR)
     *       /MINLIM/ NUMINP,LMXINP,ITEINP
     *       /MINSTP/ STPINP
      COMMON
     *       /HFMEAN/ IHFPOT
      COMMON
     *       /WAPSTR_EXPDEL/ DELT3N(1:ND_PRO,1:ND_NEU),
     *                       DELT3P(1:ND_PRO,1:ND_NEU)
#if(USE_MPI==1)
      COMMON
     *       /SIGNAL/ escapeSignal
      COMMON
     *       /OUTPUT/ nfisum
#endif
C
      DATA
     *       NAMMUL /'MULTIPOLE MOMENTS [UNITS:  (10 FERMI)^LAMBDA]'/,
     *       NAMSUR /'SURFACE MOMENTS, UNITS: (10 FERMI)^(LAMBDA+2)'/,
     *       NAMSCH /'SCHIFF  MOMENTS, UNITS: (10 FERMI)^(LAMBDA+2)'/,
     *       NAMPLM /'PENSURFACE MOMENTS, IN: (10 FERMI)^(LAMBDA+4)'/,
     *       NAMMAG /'MAGNETIC MOMENTS  [MAGNETON*FERMI^(LAMBDA-1)]'/
      DATA
     *       NAMHAR /'                 '/,
     *       NAMSHI /'[CENT-MASS FRAME]'/,
     *       NAMROT /'[INTRINSIC FRAME]'/
C
      INTERFACE
         SUBROUTINE NUMCON(LAMPUS,MIUPUS,QMOPUS,NUMPUS,IF_RPA,IFPUSH,
     *                                                        DOPUSH)
            USE hfodd_sizes
            integer, dimension(:), pointer :: LAMPUS, MIUPUS
            double precision, dimension(:), pointer :: QMOPUS
            INTEGER :: NUMPUS,IF_RPA,IFPUSH
            LOGICAL :: DOPUSH
         END SUBROUTINE NUMCON
      END INTERFACE
C
      INTERFACE
         SUBROUTINE NAMELI(IN_FIX,IZ_FIX,SKYRME,GOGNAM,ISTAND,
     *                            KETA_J,KETA_W,KETACM,KETA_M,
     *                                                 KETA_R,
     *                     LANODD,LANSCA,HBMSAT,RHOSAT,EFFSAT,
     *                            INNUMB,IZNUMB,FCHOM0,R0PARM,
     *                            IOPTGS,NXHERM,NYHERM,NZHERM,
     *                     IPAIRI,IPAHFB,ITWOBA,IPABCS,IMFHFB,
     *                                          LIPKIN,LIPKIP,
     *                                          IROTAT,IREVIE,
     *                            DELFIN,DELFIP,IDEFIN,IDEFIP,
     *                            FERFIN,FERFIP,IFEFIN,IFEFIP,
     *                            FE2FIN,FE2FIP,IF2FIN,IF2FIP,
     *                            INSIGN,IPSIGN,ISSIGN,IDSIGN,
     *                            INSIGP,IPSIGP,ISSIGP,IDSIGP,
     *                                   INSIMN,IRSIMN,IDSIMN,
     *                                   INSIMP,IRSIMP,IDSIMP,
     *                                   INSIQN,IPSIQN,IDSIQN,
     *                                   INSIQP,IPSIQP,IDSIQP,
     *                                          INSIZN,IDSIZN,
     *                                          INSIZP,IDSIZP,
     *                                          IFIBLN,INIBLN,
     *                                          IFIBLP,INIBLP,
     *                                                 IREAWS,
     *                                   ICONTI,IPCONT,IOCONT,
     *                            IACONT,IYCONT,IGCONT,IGPCON,
     *                            ILCONT,IFCONT,IMCONT,IRCONT,
     *                            NUCHAO,NUPING,EPSPNG,EPSITE,
     *                            ISPHER,ISIMPY,ISIGNY,IPARTY,
     *                                   ISIMTX,ISIMTY,ISIMTZ,
     *                            IMOVAX,ITILAX,ITISAX,NO_ORB,
     *                                          NOITER,NULAST,
     *                            ISYMDE,INIROT,INIINV,INIKAR,
     *                                   IRENMA,IRENIN,IDOGOA,
     *                                   IFRWAV,ITOWAV,IWRWAV,
     *                                          ISAKER,ICHKER,
     *                                   IPRGCM,IPROMI,IPROMA,
     *                                   NUAKNO,NUBKNO,KPROJE,
     *                                                 NBTKNO,
     *                                   ISOSAD,EPSISO,ICSKIP,
     *                                                 IFERME,
     *                                   IPAKER,IPAALL,KFIKER,
     *                            NUASTA,NUASTO,NUGSTA,NUGSTO,
     *                            NUBSTA,NUBSTO,NUTSTA,NUTSTO,
     *                                   ICUTOV,CUTOVE,CUTOVF,
     *                                          ISLPRI,ISUPRI,
     *                                   IENPRI,ISRPRI,IMIPRI,
     *                                          IKEPRI,IRMPRI,
     *                                   QMUCUT,QMACUT,QSICUT,
     *                                   NOSCIL,NLIMIT,ENECUT,
     *                                   NUMCOU,NUMETA,FURMAX,
     *                            ICOTYP,ICOUDI,ICOUEX,E_EFFE,
     *                            PIMASS,PNMASS,IYUTYP,I_YUKA,
     *                            YUKAGT,YUKAG0,YUKAG1,YUKAG2,
     *                                          I_GOGA,IGOGPA,
     *                            I1LINE,IPRSTA,IPRMID,IPRSTO,
     *                            IDESTA,IDEMID,IDESTO,IDEDIS,
     *                                          INTRIP,IVIPRI,
     *                                   IPRI_N,IPRI_P,IPRI_T,
     *                                   NMUCON,NMUCOU,NMUPRI,
     *                                   ISCHIF,NSICON,NSIPRI,
     *                                          NMACON,NMAPRI,
     *                                   NMURED,NMARED,NSIRED,
     *                                   NEXBET,IPRIBE,IPRIBL,
     *                                   IWRIOL,IWRISO,IWRIRE,
     *                                          IWRIYU,IWRIGO,
     *                                          IWRILI,IWRIFI,
     *                                   FILISO,FILREP,FILREC,
     *                                   FILWOO,FILREV,FILCOU,
     *                                          FILWAV,FILKER,
     *                                          FILYUP,FILYUC,
     *                                          FILGOP,FILGOC,
     *                                          FILGPP,FILGPC,
     *                                          FILLIP,FILLIC,
     *                                          FILFIP,FILFIC,
     *                                   ICHFLI,IPAFLI,IREFLI,
     *                                   ISPFLI,ISHFLI,IFLIPI,
     *                            SLOWEV,SLOWOD,SLOWPA,SLOWLI,
     *                                          ICOULI,ICOULO,
     *                                          FACTGN,FACTGP,
     *                                          EMINAL,EMAXAL,
     *                                   EMAXQU,ECUTOF,LIMQUA,
     *                                                 NILXYZ,
     *                                                 IAVRGG,
     *                                                 IPOTHO,
     *                                                 EPSHER,
     *                            IFSHEL,IF_RPA,IF_THO,CBETHO,
     *                                                 IFRAGM,
     *                     LAMPUS,MIUPUS,NUMPUS,QMOPUS,IFPUSH,
     *                                                 NITPUS,
     *                                   L_COLL,M_COLL,N_COLL,
     *                     DELTAE,XLOCMX,V2_MIN,ITRMAX,NTHETA,
     *                            MIN_QP,IDEALL,IDELOC,IDECON)
C
            INTEGER :: IN_FIX,IZ_FIX,ISTAND,KETA_J,KETA_W,KETACM,
     *                 KETA_M,KETA_R,LANODD,LANSCA,INNUMB,IZNUMB,
     *                 IOPTGS,NXHERM,NYHERM,NZHERM,IPAIRI,IPAHFB,
     *                 ITWOBA,IPABCS,IMFHFB,LIPKIN,LIPKIP,IROTAT,
     *                 IREVIE,IDEFIN,IDEFIP,IFEFIN,IFEFIP,IF2FIN,
     *                 IF2FIP,INSIGN,IPSIGN,ISSIGN,IDSIGN,INSIGP,
     *                 IPSIGP,ISSIGP,IDSIGP,INSIMN,IRSIMN,IDSIMN,
     *                 INSIMP,IRSIMP,IDSIMP,INSIQN,IPSIQN,IDSIQN,
     *                 INSIQP,IPSIQP,IDSIQP,INSIZN,IDSIZN,INSIZP,
     *                 IDSIZP,IFIBLN,INIBLN,IFIBLP,INIBLP,IREAWS,
     *                 ICONTI,IPCONT,IOCONT,IACONT,IYCONT,IGCONT,
     *                 IGPCON,ILCONT,IFCONT,IMCONT,IRCONT,NUCHAO,
     *                 NUPING,ISPHER,ISIMPY,ISIGNY,IPARTY,ISIMTX,
     *                 ISIMTY,ISIMTZ,IMOVAX,ITILAX,ITISAX,NO_ORB,
     *                 NOITER,NULAST,ISYMDE,INIROT,INIINV,INIKAR,
     *                 IRENMA,IRENIN,IDOGOA,IFRWAV,ITOWAV,IWRWAV,
     *                 ISAKER,ICHKER,IPRGCM,IPROMI,IPROMA,NUAKNO,
     *                 NUBKNO,KPROJE,NBTKNO,ISOSAD,ICSKIP,IFERME,
     *                 IPAKER,IPAALL,KFIKER,NUASTA,NUASTO,NUGSTA,
     *                 NUGSTO,NUBSTA,NUBSTO,NUTSTA,NUTSTO,ICUTOV,
     *                 ISLPRI,ISUPRI,IENPRI,ISRPRI,IMIPRI,IKEPRI,
     *                 IRMPRI,NOSCIL,NLIMIT,NUMCOU,NUMETA,ICOTYP,
     *                 ICOUDI,ICOUEX,IYUTYP,I_YUKA,I_GOGA,IGOGPA,
     *                 I1LINE,IPRSTA,IPRMID,IPRSTO,IDESTA,IDEMID,
     *                 IDESTO,IDEDIS,INTRIP,IVIPRI,IPRI_N,IPRI_P,
     *                 IPRI_T,NMUCON,NMUCOU,NMUPRI,ISCHIF,NSICON,
     *                 NSIPRI,NMACON,NMAPRI,NMURED,NMARED,NSIRED,
     *                 NEXBET,IPRIBE,IPRIBL,IWRIOL,IWRISO,IWRIRE,
     *                 IWRIYU,IWRIGO,IWRILI,IWRIFI,ICHFLI,IPAFLI,
     *                 IREFLI,ISPFLI,ISHFLI,IFLIPI,ICOULI,ICOULO,
     *                 LIMQUA,NILXYZ,IAVRGG,IPOTHO,IFSHEL,IF_RPA,
     *                 IF_THO,IFRAGM,IFPUSH,NITPUS,N_COLL,ITRMAX,
     *                 NTHETA,MIN_QP,IDEALL,IDELOC,IDECON
C
            INTEGER, DIMENSION(:), POINTER :: LAMPUS, MIUPUS
            INTEGER, DIMENSION(:), POINTER :: L_COLL, M_COLL
C
            DOUBLE PRECISION :: HBMSAT,RHOSAT,EFFSAT,FCHOM0,R0PARM,
     *                          DELFIN,DELFIP,FERFIN,FERFIP,FE2FIN,
     *                          FE2FIP,EPSPNG,EPSITE,EPSISO,CUTOVE,
     *                          CUTOVF,QMUCUT,QMACUT,QSICUT,ENECUT,
     *                          FURMAX,E_EFFE,PIMASS,PNMASS,YUKAGT,
     *                          YUKAG0,YUKAG1,YUKAG2,SLOWEV,SLOWOD,
     *                          SLOWPA,SLOWLI,FACTGN,FACTGP,EMINAL,
     *                          EMAXAL,EMAXQU,ECUTOF,EPSHER,CBETHO,
     *                          DELTAE,XLOCMX,V2_MIN
C
            DOUBLE PRECISION, DIMENSION(:), POINTER :: QMOPUS
C
            CHARACTER (LEN=4) :: SKYRME,GOGNAM
C
            CHARACTER (LEN=68) :: FILISO,FILREP,FILREC,FILWOO,FILREV,
     *                            FILCOU,FILWAV,FILKER,FILYUP,FILYUC,
     *                            FILGOP,FILGOC,FILGPP,FILGPC,FILLIP,
     *                            FILLIC,FILFIP,FILFIC
C
         END SUBROUTINE NAMELI
      END INTERFACE
C
      INTERFACE
         SUBROUTINE INFPRI(IN_FIX,IZ_FIX,NUMCOU,NUMETA,FURMAX,ICOTYP,
     *                     ICOUDI,ICOUEX,PIMASS,PNMASS,IYUTYP,I_YUKA,
     *                     YUKAGT,YUKAG0,YUKAG1,YUKAG2,I_GOGA,IGOGPA,
     *                     NUCHAO,NUPING,EPSPNG,EPSITE,NOITER,NULAST,
     *                     DELFIN,DELFIP,IDEFIN,IDEFIP,FERFIN,FERFIP,
     *                     IFEFIN,IFEFIP,FE2FIN,FE2FIP,IF2FIN,IF2FIP,
     *                     INSIGN,IPSIGN,ISSIGN,IDSIGN,INSIGP,IPSIGP,
     *                     ISSIGP,IDSIGP,INSIMN,IRSIMN,IDSIMN,INSIMP,
     *                     IRSIMP,IDSIMP,INSIQN,IPSIQN,IDSIQN,INSIQP,
     *                     IPSIQP,IDSIQP,INSIZN,IDSIZN,INSIZP,IDSIZP,
     *                     IFIBLN,INIBLN,IFIBLP,INIBLP,ECUTOF,LIMQUA,
     *                     ISPHER,ISIMPY,ISIGNY,ISIQTY,ISIMTX,JSIMTY,
     *                     ISIMTZ,ISYMDE,INIROT,INIINV,INIKAR,IRENMA,
     *                     IRENIN,IDOGOA,JETACM,KETA_R,IFRWAV,ITOWAV,
     *                     IWRWAV,ISAKER,ICHKER,IPRGCM,IPROMI,IPROMA,
     *                     NUAKNO,NUBKNO,KPROJE,NBTKNO,ISOSMI,ISOSMA,
     *                     EPSISO,ICSKIP,IFERME,IPAKER,IPAALL,KFIKER,
     *                     NUASTA,NUASTO,NUGSTA,NUGSTO,NUBSTA,NUBSTO,
     *                     NUTSTA,NUTSTO,ISLPRI,ISUPRI,IENPRI,ISRPRI,
     *                     IMIPRI,IKEPRI,IRMPRI,QMUCUT,QMACUT,QSICUT,
     *                     IMOVAX,ITILAX,ITISAX,NO_ORB,IPRSTA,IPRMID,
     *                     IPRSTO,IDESTA,IDEMID,IDESTO,IDEDIS,INTRIP,
     *                     IVIPRI,IPRI_N,IPRI_P,IPRI_T,IPAIRI,IPAHFB,
     *                     ITWOBA,JPABCS,IMFHFB,LIPKIN,LIPKIP,NILXYZ,
     *                     IROTAT,NMUCON,NMUCOU,NMUPRI,ISCHIF,NSIMAX,
     *                     NSICON,NSIPRI,IDOPLM,NMAMAX,NMACON,NMAPRI,
     *                     NMURED,NMARED,NSIRED,SLOWEV,SLOWOD,SLOWPA,
     *                     SLOWLI,ICONTI,IPCONT,IOCONT,IACONT,IYCONT,
     *                     IGCONT,IGPCON,ILCONT,IFCONT,IMCONT,IRCONT,
     *                     IPOTHO,BOUCOU,IFSHEL,IF_RPA,L_COLL,M_COLL,
     *                                                        N_COLL)
C
            INTEGER :: IN_FIX,IZ_FIX,NUMCOU,NUMETA,ICOTYP,ICOUDI,
     *                 ICOUEX,IYUTYP,I_YUKA,I_GOGA,IGOGPA,NUCHAO,
     *                 NUPING,NOITER,NULAST,IDEFIN,IDEFIP,IFEFIN,
     *                 IFEFIP,IF2FIN,IF2FIP,INSIGN,IPSIGN,ISSIGN,
     *                 IDSIGN,INSIGP,IPSIGP,ISSIGP,IDSIGP,INSIMN,
     *                 IRSIMN,IDSIMN,INSIMP,IRSIMP,IDSIMP,INSIQN,
     *                 IPSIQN,IDSIQN,INSIQP,IPSIQP,IDSIQP,INSIZN,
     *                 IDSIZN,INSIZP,IDSIZP,IFIBLN,INIBLN,IFIBLP,
     *                 INIBLP,LIMQUA,ISPHER,ISIMPY,ISIGNY,ISIQTY,
     *                 ISIMTX,JSIMTY,ISIMTZ,ISYMDE,INIROT,INIINV,
     *                 INIKAR,IRENMA,IRENIN,IDOGOA,JETACM,KETA_R,
     *                 IFRWAV,ITOWAV,IWRWAV,ISAKER,ICHKER,IPRGCM,
     *                 IPROMI,IPROMA,NUAKNO,NUBKNO,KPROJE,NBTKNO,
     *                 ISOSMI,ISOSMA,ICSKIP,IFERME,IPAKER,IPAALL,
     *                 KFIKER,NUASTA,NUASTO,NUGSTA,NUGSTO,NUBSTA,
     *                 NUBSTO,NUTSTA,NUTSTO,ISLPRI,ISUPRI,IENPRI,
     *                 ISRPRI,IMIPRI,IKEPRI,IRMPRI,IMOVAX,ITILAX,
     *                 ITISAX,NO_ORB,IPRSTA,IPRMID,IPRSTO,IDESTA,
     *                 IDEMID,IDESTO,IDEDIS,INTRIP,IVIPRI,IPRI_N,
     *                 IPRI_P,IPRI_T,IPAIRI,IPAHFB,ITWOBA,JPABCS,
     *                 IMFHFB,LIPKIN,LIPKIP,NILXYZ,IROTAT,NMUCON,
     *                 NMUCOU,NMUPRI,ISCHIF,NSIMAX,NSICON,NSIPRI,
     *                 IDOPLM,NMAMAX,NMACON,NMAPRI,NMURED,NMARED,
     *                 NSIRED,ICONTI,IPCONT,IOCONT,IACONT,IYCONT,
     *                 IGCONT,IGPCON,ILCONT,IFCONT,IMCONT,IRCONT,
     *                 IPOTHO,IFSHEL,IF_RPA,N_COLL
C
            INTEGER, DIMENSION(:), POINTER :: L_COLL, M_COLL
C
            DOUBLE PRECISION ::FURMAX,PIMASS,PNMASS,YUKAGT,YUKAG0,
     *                         YUKAG1,YUKAG2,EPSPNG,EPSITE,DELFIN,
     *                         DELFIP,FERFIN,FERFIP,FE2FIN,FE2FIP,
     *                         ECUTOF,EPSISO,QMUCUT,QMACUT,QSICUT,
     *                         SLOWEV,SLOWOD,SLOWPA,SLOWLI,BOUCOU
C
         END SUBROUTINE INFPRI
      END INTERFACE
C
C=======================================================================
C      UPON REQUEST, INITIALIZING THE MPI ENVIRONMENT AND SETTING UP
C      MPI GROUP STRUCTURE
C=======================================================================
C
      do_debug = .False.
C
#if(USE_MPI==1)
      call mpi_init(mpi_err)
      call mpi_comm_size(MPI_COMM_WORLD, worldSize, mpi_err)
      call mpi_comm_rank(MPI_COMM_WORLD, worldRank, mpi_err)
C
      nofpro = worldSize
C
      allocate(my_cputime(0:0), my_evals(0:0))
      if (worldRank == 0 ) then
          allocate(all_cputimes(0:worldSize-1),
     *                all_evals(0:worldSize-1))
C
          nfisum=89
          write(filsum,'(''hf256a_summary.txt'')')
C
          open(nfisum,file=filsum,status='unknown',form='formatted')
C
      else
          allocate(all_cputimes(0:0), all_evals(0:0))
      end if
C
      ! Record system and CPU starting times
      call system_clock(syst_cnt, syst_rate)
C
      syst_start = real(syst_cnt,KIND=8) / real(syst_rate,KIND=8)
C
      call cpu_time(cput_start)
C
      printTopology = 0
      counter_eval = 0
      iprint = 1
C
      numberHFODDproc = 1
C
      ! Attention: M_GRID and N_GRID below are passed through pre-processor
      !            not by standard NAMELI routine. This is because we need
      !            them even before we call NAMELI (or its likes)
#if(USE_SCALAPACK==1)
      numberHFODDproc = M_GRID * N_GRID
      NPGRID = N_GRID
      MPGRID = M_GRID
#endif
C
      n_proc = worldRank
      numberMasters = worldSize / numberHFODDproc
C
      ! Get handle on world group
      call mpi_comm_group(MPI_COMM_WORLD, worldGroup, mpi_err)
C
      ! Define the rank of the masters
      allocate(rankMasters(0:(numberMasters-1)))
C
      do ii = 0, numberMasters - 1
         rankMasters(ii) = ii
      end do
C
      ! Define new group of masters: the oligarchy
      call mpi_group_incl(worldGroup, numberMasters, rankMasters,
     *                                     groupMasters, mpi_err)
      call mpi_comm_create(MPI_COMM_WORLD, groupMasters,
     *                             mastersCOMM, mpi_err)
C
      ! Everybody else is a stupid slave
      if (numberHFODDproc > 1) then
          call mpi_group_excl(worldGroup, numberMasters, rankMasters,
     *                                          groupSlaves, mpi_err)
          call mpi_comm_create(MPI_COMM_WORLD, groupSlaves,
     *                                 slavesCOMM, mpi_err)
      end if
C
      ! Second grouping: define tribes of slaves associated with every
      ! oligarch. Since they are many such groups (as many as masters),
      ! and they all have the same size, it is simpler to just split
      ! the communicator into many sub-communicators
C
      color = mod(worldRank, numberMasters)
      intkey = worldRank
C
      call mpi_comm_split(MPI_COMM_WORLD, color, intkey, tribeCOMM,
     *                                                     mpi_err)
C
      call mpi_comm_rank(tribeCOMM, tribeRank, mpi_err)
C
#if(USE_SCALAPACK==1)
C
      allocate(all_tribeRank(0:(worldSize-1)))
      allocate(all_color(0:(worldSize-1)))
      allocate(all_worldRank(0:(worldSize-1)))
C
      call MPI_Allgather(tribeRank, 1, MPI_INTEGER, all_tribeRank, 1,
     *                                 MPI_INTEGER,
     *                                 MPI_COMM_WORLD, mpi_err)
C
      call MPI_Allgather(color, 1, MPI_INTEGER, all_color, 1,
     *                             MPI_INTEGER,
     *                             MPI_COMM_WORLD, mpi_err)
C
      call MPI_Allgather(worldRank, 1, MPI_INTEGER, all_worldRank, 1,
     *                                 MPI_INTEGER,
     *                                 MPI_COMM_WORLD, mpi_err)
C
      allocate(rankTribe(0:(numberHFODDproc-1),
     *                     0:(numberMasters-1)))
C
      do n_proc = 0, worldSize - 1
         n_tribe = all_tribeRank(n_proc)
         n_color = all_color(n_proc)
         rankTribe(n_tribe, n_color) = all_worldRank(n_proc)
      end do
C
      deallocate(all_tribeRank,all_color,all_worldRank)
C
      if ( worldRank == 0) then
          do n_color = 0, numberMasters-1
             do n_tribe = 0, numberHFODDproc-1
                write(nfisum,'("n_tribe = ",i4," n_color = ",i4,
     *                    " my_rank = ",i4)')
     *                      n_tribe, n_color,
     *                      rankTribe(n_tribe, n_color)
             end do
          end do
      end if
C
#endif
C
      if ( printTopology == 1 ) then
C
          if ( worldRank < numberMasters ) then
               write(nfisum,'(''AFTER GROUPS - Processor: '',i7,
     *                   '' of color = '',i7,'' is master = '',i7,
     *                   '' Communicator handle: '',i12)')
     *                      worldRank, color, masterRank, mastersCOMM
          end if
C
          if (worldRank >= numberMasters) then
               write(nfisum,'(''AFTER GROUPS - Processor: '',i7,
     *                   '' of color = '',i7,'' is slave = '',i7,
     *                   '' Communicator handle: '',i12)')
     *                      worldRank, color, slaveRank, slavesCOMM
          end if
C
          write(nfisum,'(''AFTER GROUPS - Processor: '',i7,
     *              '' of color = '',i7,'' has rank = '',i7,
     *              '' in its tribe'')')
     *              worldRank, color, tribeRank
C
      end if
C
#endif
C
C=======================================================================
C
      CALL CPUTIM('HFODD ',1)
C
C=======================================================================
C
      C_ZERO=CMPLX(0.0D0,0.0D0)
C
      ESTABN=1000.0
C
C      Flag that triggers the clean exit from this process (QUABCS)
C
#if(USE_MPI==1)
      escapeSignal = 0
#endif
C
C=======================================================================
C         DEFINING  THE   V E R S I O N   N U M B E R   OF THE CODE
C=======================================================================
C
C                           ------------------
C                          |                  |
                              VERSIO='2.56a'
C                          |                  |
C                           ------------------
C
C=======================================================================
C         DEFINING  THE   I N P U T   A N D   O U T P U T   FILE NUMBERS
C=======================================================================
C
#if(USE_MPI==1)
C
      NFIPRI=88
      WRITE(FILOUT,'(''hfodd_'',i6.6,''.out'')') worldRank+1
      OPEN(NFIPRI,FILE=FILOUT,STATUS='UNKNOWN',FORM='FORMATTED')
C
#else
C
      NFIREA=05
      NFIPRI=06
C
#endif
C
C=======================================================================
C      DISPLAYING THE CHARACTERISTICS OF THE PARALLEL MODEL:
C       - SIMPLE MPI STRUCTURE WITH/WITHOUT OPENMP
C       - ADVANCED MPI STRUCTURE WITH/WITHOUT OPENMP
C=======================================================================
C
#if( USE_MPI==1 || USE_OPENMP==1)
      WRITE(NFIPRI,'(79(''*''),/,''*'',77X,''*'',/,
     *      ''*                     P A R A L L E L    '',
     *      ''M O D E L                            *'',/,
     *      ''*'',77X,''*'')')
#else
      WRITE(NFIPRI,'(79(''*''),/,''*'',77X,''*'',/,
     *      ''*                S I N G L E - C O R E    '',
     *      ''V E R S I O N                       *'')')
#endif
C
#if(USE_MPI==1)
#if(USE_SCALAPACK==0)
      WRITE(NFIPRI,'(''*  SIMPLE MPI FRAMEWORK (1 COMMUNICATOR)'',
     *      ''    :  1 CORE per HFODD TASK          *'')')
#else
      WRITE(NFIPRI,'(''*  ADVANCED MPI FRAMEWORK (3 COMMUNICATORS)'',
     *      '' : '',I2,'' CORES per HFODD TASK         *'')')
     *      numberHFODDproc
#endif
#endif
C
#if(USE_OPENMP==1)
!$OMP PARALLEL
!$OMP& SHARED(NFIPRI)
!$OMP& PRIVATE(numThreads,idThread)
      numThreads = omp_get_num_threads()
      idThread = omp_get_thread_num()
      IF (idThread .EQ. 0) THEN
          WRITE(NFIPRI,'(''*  MULTI-THREADING FRAMEWORK WITH '',
     *    ''OPENMP    : '',I2,'' THREADS per HFODD TASK       *'')')
     *                numThreads
      END IF
!$OMP END PARALLEL
#endif
C
      WRITE(NFIPRI,'(''*'',77X,''*'')')
C
C=======================================================================
C         PRINTING THE OUTPUT HEADER
C=======================================================================
C
      WRITE(NFIPRI,'(79(1H*),/,               1H*,77X,1H*,/,
     * 1H*, 19X, "     __  __ _____  ___   ____   ____   ",   19X,1H*,/,
     * 1H*, 19X, "    / / / // ___/.'' _ \ / __ \ / __ \  ",  19X,1H*,/,
     * 1H*, 19X, "   / /_/ // /_  / / / // / / // / / /  ",   19X,1H*,/,
     * 1H*, 19X, "  / __  // __/ / / / // / / // / / /   ",   19X,1H*,/,
     * 1H*, 19X, " / / / // /   / /_/ // /_/ // /_/ /    ",   19X,1H*,/,
     * 1H*, 19X, "/_/ /_//_/    \___.''/____.''/____.''     ",19X,1H*,/,
     * 1H*, 77X, 1H*,/,
     *                              1H*,77X,1H*,/,
     *                              79(1H*),/,1H*,77X,1H*,/,1H*,13X,
     *      ''SKYRME-HARTREE-FOCK-BOGOLYUBOV CODE VERSION: '',   A5,
     *                              14X,1H*,/,1H*,77X,1H*,/,1H*,13X,
     *      '' NO SYMMETRY-PLANES AND NO TIME-REVERSAL SYMMETRY  '',
     *                              13X,1H*,/,1H*,77X,1H*,/,1H*,13X,
     *      ''   DEFORMED CARTESIAN HARMONIC-OSCILLATOR BASIS    '',
     *                              13X,1H*,/,1H*,77X,1H*,/,
     *                              79(1H*),/,1H*,77X,1H*,/,1H*,13X,
     *      '' J. DOBACZEWSKI, B.G. CARLSSON, J. DUDEK, J. ENGEL '',
     *                              13X,1H*,/,              1H*,13X,
     *      '' Y. GAO, T. LESINSKI, J. MCDONNELL, P. OLBRATOWSKI '',
     *                              13X,1H*,/,              1H*,13X,
     *      ''   P. POWALOWSKI, M. SADZIAK, J. SARICH, K. SATO   '',
     *                              13X,1H*,/,              1H*,13X,
     *      ''  W. SATULA, N. SCHUNCK, J.A. SHEIKH, A. STASZCZAK '',
     *                              13X,1H*,/,              1H*,11X,
     *    '' M. STOITSOV, P. TOIVANEN, M. ZALEWSKI, AND H. ZDUNCZUK'',
     *                              11X,1H*,/,1H*,77X,1H*,/,1H*,13X,
     *      ''      INSTYTUT FIZYKI TEORETYCZNEJ, WARSZAWA       '',
     *                                            13X,1H*,/,1H*,13X,
     *      ''    LAWRENCE LIVERMORE NATIONAL LABORATORY, USA    '',
     *                              13X,1H*,/,1H*,77X,1H*,/,1H*,13X,
     *      ''                     1993-2013                     '',
     *                              13X,1H*,/,1H*,77X,1H*,/,79(1H*)
     *                                                           )')
     *
     *       VERSIO
C
C=======================================================================
C         PRINTING THE ARRAY DIMENSIONS
C=======================================================================
C
      WRITE(NFIPRI,'(/,79(1H*),/,             1H*,77X,1H*,/,1H*,2X,
     *      ''CODE COMPILED WITH THE FOLLOWING ARRAY DIMENSIONS '',
     *      ''AND SWITCHES:'',
     *                              12X,1H*,/,1H*,77X,1H*,/
     *                              79(1H*),/,1H*,77X,1H*,/,1H*,2X,
     *      ''NDBASE ='',I5,2X,''NDSTAT ='',I5,2X,
     *      ''NDXHRM ='',I5,2X,''NDYHRM ='',I5,2X,''NDZHRM ='',I5,2X,
     *                                  1H*,/,1H*,77X,1H*,/,1H*,2X,
     *      ''NDMAIN ='',I5,2X,''NDMULT ='',I5,2X,
     *      ''NDMULR ='',I5,2X,''NDLAMB ='',I5,2X,''NDITER ='',I5,2X,
     *                                  1H*,/,1H*,77X,1H*,/,1H*,2X,
     *      ''NDAKNO ='',I5,2X,''NDBKNO ='',I5,2X,
     *      ''NDPROI ='',I5,2X,''NDCOUL ='',I5,2X,''NDPOLS ='',I5,2X,
     *                                  1H*,/,1H*,77X,1H*,/,1H*,2X,
     *      ''NDPROT ='',I5,2X,''NDBTKN ='',I5,47X,
     *                                  1H*,/,1H*,77X,1H*,/,1H*,2X,
     *      ''IPARAL ='',I5,2X,''I_CRAY ='',I5,47X,
     *                                  1H*,/,1H*,77X,1H*)')
     *
     *      NDBASE,NDSTAT,NDXHRM,NDYHRM,NDZHRM,
     *      NDMAIN,NDMULT,NDMULR,NDLAMB,NDITER,
     *      NDAKNO,NDBKNO,NDPROI,NDCOUL,NDPOLS,
     *      NDPROT,NDBTKN,
     *      IPARAL,I_CRAY
C
C=======================================================================
C      DISPLAYING VARIOUS PREPROCESSOR OPTIONS
C=======================================================================
C
      I_SWITCH_PORT=0
      I_SWITCH_DIAG=0
      I_SWITCH_ESSL=0
      I_SWITCH_QUAD=0
      I_SWITCH_VECT=0
#if(SWITCH_PORT==1)
      I_SWITCH_PORT=1
#endif
#if(SWITCH_DIAG==1)
      I_SWITCH_DIAG=1
#endif
#if(SWITCH_DIAG==2)
      I_SWITCH_DIAG=2
#endif
#if(SWITCH_DIAG==3)
      I_SWITCH_DIAG=3
#endif
#if(SWITCH_DIAG==4)
      I_SWITCH_DIAG=4
#endif
#if(SWITCH_ESSL==1)
      I_SWITCH_ESSL=1
#endif
#if(SWITCH_QUAD==1)
      I_SWITCH_QUAD=1
#endif
#if(SWITCH_VECT==1)
      I_SWITCH_VECT=1
#endif
C
      WRITE(NFIPRI,'(''*'',77X,''*'',/,''*  PRE-PROCESSOR OPTIONS:'',
     *             53X,''*'',/,''*'',77X,''*'',/,
     *             ''*       switch_port = '',I1,
     *             ''     switch_diag = '',I1,
     *             ''     switch_essl = '',I1,15X,''*'',/,
     *             ''*'',77X,''*'',/,
     *             ''*       '',15X,
     *             ''     switch_quad = '',I1,
     *             ''     switch_vect = '',I1,15X,''*'',/,
     *             ''*'',77X,''*'',/,79(''*''))')
     *             I_SWITCH_PORT,I_SWITCH_DIAG,I_SWITCH_ESSL,
     *                           I_SWITCH_QUAD,I_SWITCH_VECT
C
C=======================================================================
C         PRINTING THE DATE AND TIME
C=======================================================================
C
      CALL DATE_AND_TIME(MYDATE,MYTIME,MYZONE,MYVALU)
C
      WRITE(NFIPRI,'(                         1H*,77X,1H*,/,1H*,2X,
     *      ''EXECUTION BEGINS ON '',A4,''.'',A2,''.'',A2,'' AT '',
     *                               A2,'':'',A2,'':'',A6,
     *                              29X,1H*,/,1H*,77X,1H*,/,79(1H*))')
     *
     *      MYDATE(1:4),MYDATE(5:6),MYDATE(7:8),
     *      MYTIME(1:2),MYTIME(3:4),MYTIME(5:10)
C
      WRITE(NFIPRI,*)
C
C=======================================================================
C         P R E S E T T I N G   T H E   D E F A U L T   V A L U E S
C=======================================================================
C
      CALL PREDEF(IN_FIX,IZ_FIX,SKYRME,GOGNAM,ISTAND,
     *            KETA_J,KETA_W,KETACM,KETA_M,
     *                                 KETA_R,
     *     LANODD,LANSCA,HBMSAT,RHOSAT,EFFSAT,
     *            INNUMB,IZNUMB,FCHOM0,R0PARM,
     *            IOPTGS,NXHERM,NYHERM,NZHERM,
     *     IPAIRI,IPAHFB,ITWOBA,IPABCS,IMFHFB,
     *                                 IPNMIX,
     *                          LIPKIN,LIPKIP,
     *                   IROTAT,ITIREP,IREVIE,
     *            DELFIN,DELFIP,IDEFIN,IDEFIP,
     *            FERFIN,FERFIP,IFEFIN,IFEFIP,
     *            FE2FIN,FE2FIP,IF2FIN,IF2FIP,
     *            INSIGN,IPSIGN,ISSIGN,IDSIGN,
     *            INSIGP,IPSIGP,ISSIGP,IDSIGP,
     *                   INSIMN,IRSIMN,IDSIMN,
     *                   INSIMP,IRSIMP,IDSIMP,
     *                   INSIQN,IPSIQN,IDSIQN,
     *                   INSIQP,IPSIQP,IDSIQP,
     *                          INSIZN,IDSIZN,
     *                          INSIZP,IDSIZP,
     *                          IFIBLN,INIBLN,
     *                          IFIBLP,INIBLP,
     *                                 IREAWS,
     *                   ICONTI,IPCONT,IOCONT,
     *            IACONT,IYCONT,IGCONT,IGPCON,
     *            ILCONT,IFCONT,IMCONT,IRCONT,
     *            NUCHAO,NUPING,EPSPNG,EPSITE,
     *            ISPHER,ISIMPY,ISIGNY,IPARTY,
     *                   ISIMTX,ISIMTY,ISIMTZ,
     *            IMOVAX,ITILAX,ITISAX,NO_ORB,
     *                          NOITER,NULAST,
     *            ISYMDE,INIROT,INIINV,INIKAR,
     *                   IRENMA,IRENIN,IDOGOA,
     *                   IFRWAV,ITOWAV,IWRWAV,
     *                          ISAKER,ICHKER,
     *                   IPRGCM,IPROMI,IPROMA,
     *                   NUAKNO,NUBKNO,KPROJE,
     *                                 NBTKNO,
     *                   ISOSAD,EPSISO,ICSKIP,
     *                                 IFERME,
     *                   IPAKER,IPAALL,KFIKER,
     *            NUASTA,NUASTO,NUGSTA,NUGSTO,
     *            NUBSTA,NUBSTO,NUTSTA,NUTSTO,
     *                   ICUTOV,CUTOVE,CUTOVF,
     *                          ISLPRI,ISUPRI,
     *                   IENPRI,ISRPRI,IMIPRI,
     *                          IKEPRI,IRMPRI,
     *                   QMUCUT,QMACUT,QSICUT,
     *                   NOSCIL,NLIMIT,ENECUT,
     *                   NUMCOU,NUMETA,FURMAX,
     *            ICOTYP,ICOUDI,ICOUEX,E_EFFE,
     *            PIMASS,PNMASS,IYUTYP,I_YUKA,
     *            YUKAGT,YUKAG0,YUKAG1,YUKAG2,
     *                          I_GOGA,IGOGPA,
     *            I1LINE,IPRSTA,IPRMID,IPRSTO,
     *            IDESTA,IDEMID,IDESTO,IDEDIS,
     *                          INTRIP,IVIPRI,
     *                   IPRI_N,IPRI_P,IPRI_T,
     *                   NMUCON,NMUCOU,NMUPRI,
     *                   ISCHIF,NSICON,NSIPRI,
     *                          NMACON,NMAPRI,
     *                   NMURED,NMARED,NSIRED,
     *                   NEXBET,IPRIBE,IPRIBL,
     *                   IWRIOL,IWRISO,IWRIRE,
     *                          IWRIYU,IWRIGO,
     *                          IWRILI,IWRIFI,
     *                   FILISO,FILREP,FILREC,
     *                   FILWOO,FILREV,FILCOU,
     *                          FILWAV,FILKER,
     *                          FILYUP,FILYUC,
     *                          FILGOP,FILGOC,
     *                          FILGPP,FILGPC,
     *                          FILLIP,FILLIC,
     *                          FILFIP,FILFIC,
     *                   ICHFLI,IPAFLI,IREFLI,
     *                   ISPFLI,ISHFLI,IFLIPI,
     *            SLOWEV,SLOWOD,SLOWPA,SLOWLI,
     *                          ICOULI,ICOULO,
     *                          FACTGN,FACTGP,
     *                          EMINAL,EMAXAL,
     *                   EMAXQU,ECUTOF,LIMQUA,
     *                                 NILXYZ,
     *                                 IAVRGG,
     *                                 IPOTHO,
     *                                 EPSHER,
     *                   IFSHEL,IF_RPA,IF_THO,
     *            PRHO_T,PRHODT,PRHOST,POWERT,
     *            IFRAGM,NUMPUS,IFPUSH,N_COLL,
     *     DELTAE,XLOCMX,V2_MIN,ITRMAX,NTHETA,
     *            MIN_QP,IDEALL,IDELOC,IDECON)
C
C=======================================================================
C         I N I T I A L I Z I N G   O U T P U T   T O   Z E R O
C=======================================================================
C
      CALL ZEROUT(NMUCON,NMUMAX,NMAMAX,NSIMAX)
C
C=======================================================================
C   (OPTIONAL)  I N I T I A L I Z I N G   I N E R T I A   T O   Z E R O
C=======================================================================
C
#if(USE_INERTIA==1)
      CALL INIMAS
#endif
#if(USE_INERTIA==2)
      CALL INIMAS
#endif
C
C=======================================================================
C         DEFINING THE NEWTON BINOMIAL COEFFICIENTS, FACTORIALS, SIMPLE
C         GAUSS  INTEGRALS,  AND  ORTHOGONAL  POLYNOMIAL  NORMALIZATION
C         FACTORS
C=======================================================================
C
      CALL DEFBIN
      CALL DEFBIR
      CALL DEFGAU
      CALL DEFFAC
      CALL NORHER
C
C=======================================================================
C         HERE STARTS CALCULATION FOR ONE INPUT-DATA SET
C=======================================================================
C
      batch_init=1
C
#if(USE_MPI==0)
C
      NUDATA=0
C
    3 CONTINUE
C
      NUDATA=NUDATA+1
C
#endif
C
C=======================================================================
C         READING THE INPUT DATA
C=======================================================================
#if(USE_MPI==1)
C
C     - master processor reads the common input and broadcasts the
C       data, which are then passed to local HFODD variables
C     - master processor reads the parallel input and broadcasts
C       the data which are then used by all processors to construct
C       list of jobs
C
      CALL mpi_getSequentialData()
C
      ! Get sequential data
C
      CALL mpi_setSequentialData(IOPTGS,NXHERM,NYHERM,NZHERM,
     *                           IPAIRI,IPAHFB,IPABCS,IMFHFB,
     *                                         LIPKIN,LIPKIP,
     *                           FE2FIN,IF2FIN,FE2FIP,IF2FIP,
     *                                         IROTAT,IREVIE,
     *                           ICONTI,IPCONT,IGCONT,IGPCON,
     *                                  ILCONT,IFCONT,IACONT,
     *                           NUCHAO,NUPING,EPSPNG,EPSITE,
     *                                  ISIMPY,ISIGNY,IPARTY,
     *                                  ISIMTX,ISIMTY,ISIMTZ,
     *                                         NOITER,NULAST,
     *                                  NOSCIL,NLIMIT,ENECUT,
     *                                  ICOTYP,ICOUDI,ICOUEX,
     *                                         I_GOGA,IGOGPA,
     *                                                I1LINE,
     *                           SLOWEV,SLOWOD,SLOWPA,SLOWLI,
     *                                                ECUTOF,
     *                                                NILXYZ,
     *                           IBROYD,N_ITER,BROTRI,ALPHAM,
     *                                  PRHO_T,PRHOST,POWERT,
     *                                                OMEGAY,
     *                    IFSHEL,MPOLYN,G_STUN,G_STUP,H_OMFA,
     *                           LAMBAS,MIUBAS,BETBAS,NUMDEF,
     *                    LAM_WS,MIU_WS,NUM_WS,ITE_WS,STP_WS,
     *                    LAMPUS,MIUPUS,NUMPUS,QMOPUS,IFPUSH,
     *                                         NITPUS,IREAWS,
     *                    ISTAND,KETA_J,KETA_W,KETACM,KETA_M,
     *                           IF_RPA,IF_EDF,IF_THO,CBETHO,
     *                                  IBASIS,IHFPOT,IFRAGM,
     *                                  NMUCON,NMUCOU,NMUPRI,
     *                                  NEXBET,IPRIBE,IPRIBL,
     *                                                FCHOM0,
     *                                  L_COLL,M_COLL,N_COLL,
     *                                                IWRIFI,
     *                                  INNUMB,IZNUMB,R0PARM,
     *                    DELTAE,XLOCMX,V2_MIN,ITRMAX,NTHETA,
     *                           MIN_QP,IDEALL,IDELOC,IDECON)
C
      ! Deformation of the basis: fixed or automatically
      ! adjusted on requested value of Q2
C
      IF (ASSOCIATED(LAMBAS)) THEN
C
          DO I=1,NUMDEF
             LAMACT=ABS(LAMBAS(I))
             MIUACT=MIUBAS(I)
             ALPHAR(LAMACT,MIUACT)=BETBAS(I)
          END DO
C
      END IF
C
      ! data for shell correction
C
      NPOLYN=MPOLYN
      GSTRUN=G_STUN
      GSTRUP=G_STUP
      HOMFAC=H_OMFA
C
      ! By default, computing pairing properties separately
      ! for neutrons and protons
C
      CALL RHODEP(2,PRHO_N,PRHODN,PRHOSN,POWERN)
C
      CALL RHODEP(2,PRHO_P,PRHODP,PRHOSP,POWERP)
C
      ! If the user set the keyword PAIR_INTER in the input file
      ! neutron and proton pairing properties are the same and
      ! overwritten here (same mechanism as NAMELI)
C
      IF (ABS(PRHO_T).GT.1.E-10) THEN
C
          PRHO_N=PRHO_T
          PRHOSN=PRHOST
          POWERN=POWERT
C
          CALL RHODEP(2,PRHO_N,PRHODN,PRHOSN,POWERN)
C
          PRHO_P=PRHO_T
          PRHOSP=PRHOST
          POWERP=POWERT
C
          CALL RHODEP(2,PRHO_P,PRHODP,PRHOSP,POWERP)
C
      END IF
C
      ! Getting the experimental binding energy for this
      ! nucleus => also used to determinate the experimental
      ! delta
C
      if (IREAWS.EQ.1) then
C
          if (worldRank .EQ. 0) then
C
              NREAD1=80
              NREAD2=81
C
              CALL WS_GIVMAS(NREAD1,NREAD2,NOFNUC,
     *                              MAXI_Z,MAXI_N)
C
              DO I_NEUT=IN_FIX-2,IN_FIX+2
                 NUMB_N=I_NEUT
                 CALL WS_GIVPRO(NUMB_N,IMINIM,IMAXIM)
              END DO
C
              DO I_PROT=IZ_FIX-2,IZ_FIX+2
                 NUMB_P=I_PROT
                 CALL WS_GIVNEU(NUMB_P,IMINIM,IMAXIM)
              END DO
C
              valuesDelta(1) = DELT3N(IZ_FIX,IN_FIX)
              valuesDelta(2) = DELT3P(IZ_FIX,IN_FIX)
C
          end if
C
          ! Broadcasting the value of the current experimental
          ! delta for neutrons and protons
C
          call MPI_Bcast(valuesDelta, 2,MPI_DOUBLE_PRECISION,
     *                   0, MPI_COMM_WORLD, mpi_err)
C
          D3N_WS=valuesDelta(1)
          D3P_WS=valuesDelta(2)
C
      end if ! IREAWS
C
      ! Get parallel data (I/O done only by root processor)
C
      CALL mpi_initializeParallelData()
C
      CALL mpi_getParallelData()
C
      CALL mpi_setParallelData()
C
      CALL mpi_printParallelData()
C
      ! Construct job list based on parallel data (all processors)
C
      IERROR=0
      CALL mpi_constructJobList(NUMITE,NXHERM,NYHERM,NZHERM,
     *                          IPCONT,ILCONT,IACONT,IMCONT,IRCONT,
     *                                               IRENMA,IRENIN,
     *                                               LIPKIN,LIPKIP,
     *                                        REFERN,REFERP,REDELN,
     *                                        REDELP,REFE2N,REFE2P,
     *                                 IFIBLN,INIBLN,IFIBLP,INIBLP,
     *                                 NMUMAX,NSIMAX,NMUCON,ISHIFT,
     *                                                      IF_THO,
     *                                                      IERROR)
C
      ! Construct job list based on parallel data (all processors)
C
      procLoop: DO INDJOB=1,NOFJOB
C
          ! Execute only if
          IF (color .EQ. MOD(INDJOB-1, numberMasters)) THEN
C
             CALL mpi_getCurrentData(INDJOB,IN_FIX,IZ_FIX,
     *                                             SKYRME,GOGNAM,
     *                                      INSIQN,IPSIQN,IDSIQN,
     *                                      INSIQP,IPSIQP,IDSIQP,
     *                               INSIGN,IPSIGN,ISSIGN,IDSIGN,
     *                               INSIGP,IPSIGP,ISSIGP,IDSIGP,
     *                               ICONTI,IPCONT,ILCONT,IFCONT,
     *                                                    I_GOGA,
     *                               SLOWEV,SLOWOD,SLOWPA,SLOWLI,
     *                                                    IROTAT,
     *                                                    NILXYZ,
     *                                                    N_EXIT,
     *                                                    NOITER,
     *                                      FCHOM0,NOSCIL,NLIMIT,
     *                                             LIPKIN,LIPKIP,
     *                               NXHERM,NYHERM,NZHERM,IOPTGS,
     *                                      IPAIRI,IPAHFB,IMFHFB,
     *                                                    IWRILI,
     *                                                    EPSITE,
     *                                                    INIROT,
     *                                                    IGAMMA,
     *                                                    LANODD,
     *                               IFIBLN,INIBLN,IFIBLP,INIBLP,
     *                                                    NMUCON,
     *                                                    IFSHEL,
     *                                                    IF_RPA,
     *                                                    INDFIL,
     *                                                    TEMP_T)
C
             IF (ABS(TEMP_T).GT.1.D-12) IFTEMP=1
C
             ! Minimization of deformations of WS potential
C
             NUMINP=NUM_WS
             ITEINP=ITE_WS
C
             LMXINP=0
             STPINP=STP_WS
C
             IF (ASSOCIATED(LAM_WS).AND.IREAWS.EQ.1) THEN
C
                 IF (NUMINP+NUMPUS.GT.NDSEAR) THEN
                     WRITE(NFISUM,'(''NUMINP = '',I4,
     *                     '' NUMPUS = '',I4,'' NDSEAR = '',I4)')
     *                        NUMINP,NUMPUS,NDSEAR
                     WRITE(NFISUM,'(''NUMINP + NUMPUS > '',
     *                              ''NDSEAR !'')')
                     WRITE(NFISUM,'(''INCREASE NDSEAR AND '',
     *                              ''RECOMPILE'')')
                     STOP 'NUMINP+NUMPUS>NDSEAR - MAIN'
                 END IF
C
                 ! Empirical scaling to avoid approaching a
                 ! solution "from the right", i.e. with decreasing Q2
                 SCAFAC = 1.0 - ABS(QASKED(2,0))/1400.0
C
                 DO LAMBDA=0,NDMULT
                    DO MIU=-NDMULT,NDMULT
                       Q_COPY(LAMBDA,MIU)=SCAFAC
     *                *QASKED(LAMBDA,MIU)
                    END DO
                 END DO
C
                 IORDER=0
C
                 ! Main set of deformation to minimize over
                 DO I=1,NUMINP
C
                    IORDER=IORDER+1
C
                    LAMINP(IORDER)=LAM_WS(I)
                    MIUINP(IORDER)=MIU_WS(I)
                    IF (LAMINP(IORDER).GE.LMXINP)
     *                  LMXINP=LAMINP(IORDER)
C
                 END DO
C
                 ! Additional extra constraints
                 IF (IFPUSH.EQ.1) THEN
C
                     DO I=1,NUMPUS
C
                        IORDER=IORDER+1
C
                        LAMINP(IORDER)=ABS(LAMPUS(I))
                        MIUINP(IORDER)=MIUPUS(I)
                        IF (LAMINP(IORDER).GE.LMXINP)
     *                      LMXINP=LAMINP(IORDER)
C
                        LAMBDA=ABS(LAMPUS(I))
                        MIU   =MIUPUS(I)
                        Q_COPY(LAMBDA,MIU)=SCAFAC*QMOPUS(I)
C
                     END DO
C
                 END IF
C
             END IF
C
             CALL mpi_printSequentialData(IOPTGS,NXHERM,NYHERM,NZHERM,
     *                                    IPAIRI,IPAHFB,IPABCS,IMFHFB,
     *                                                  LIPKIN,LIPKIP,
     *                                    FE2FIN,IF2FIN,FE2FIP,IF2FIP,
     *                                                  IROTAT,IREVIE,
     *                                    ICONTI,IPCONT,IGCONT,IGPCON,
     *                                           ILCONT,IFCONT,IACONT,
     *                                    NUCHAO,NUPING,EPSPNG,EPSITE,
     *                                           ISIMPY,ISIGNY,IPARTY,
     *                                           ISIMTX,ISIMTY,ISIMTZ,
     *                                                  NOITER,NULAST,
     *                                           NOSCIL,NLIMIT,ENECUT,
     *                                           ICOTYP,ICOUDI,ICOUEX,
     *                                                  I_GOGA,IGOGPA,
     *                                                         I1LINE,
     *                                    SLOWEV,SLOWOD,SLOWPA,SLOWLI,
     *                                                         ECUTOF,
     *                                                         NILXYZ,
     *                                    IBROYD,N_ITER,BROTRI,ALPHAM,
     *                                           PRHO_T,PRHOST,POWERT,
     *                                    PRHO_N,PRHOSN,PRHODN,POWERN,
     *                                    PRHO_P,PRHOSP,PRHODP,POWERP,
     *                                                         OMEGAY,
     *                             IFSHEL,NPOLYN,GSTRUN,GSTRUP,HOMFAC,
     *                                    LAMBAS,MIUBAS,BETBAS,NUMDEF,
     *                             LAM_WS,MIU_WS,NUM_WS,ITE_WS,STP_WS,
     *                                           LMXINP,IFPUSH,IREAWS,
     *                             ISTAND,KETA_J,KETA_W,KETACM,KETA_M,
     *                                    IF_RPA,IF_EDF,IF_THO,CBETHO,
     *                                                  IBASIS,IFRAGM,
     *                                           NMUCON,NMUCOU,NMUPRI,
     *                                           NEXBET,IPRIBE,IPRIBL,
     *                                                         FCHOM0,
     *                                           IWRIFI,IFTEMP,IFNECK,
     *                                           INNUMB,IZNUMB,R0PARM,
     *                             DELTAE,XLOCMX,V2_MIN,NTHETA,MIN_QP,
     *                                           IDEALL,IDELOC,IDECON,
     *                                                     batch_init)
C
                                                     NUCFLO=0
             IF ((ABS(XINFIX-REAL(IN_FIX,KIND=8)).GT.1.D-12.OR.
     *            ABS(XIZFIX-REAL(IZ_FIX,KIND=8)).GT.1.D-12).AND.
     *            (XIZFIX.GT.0.0.AND.XINFIX.GT.0.0)) NUCFLO=1
C
             IF (NUCFLO.EQ.0) THEN
                 XINFIX=REAL(IN_FIX,KIND=8)
                 XIZFIX=REAL(IZ_FIX,KIND=8)
             END IF
C
#else
C
      ALLOCATE(LAM_WS(1:NDMULT))
      ALLOCATE(MIU_WS(1:NDMULT))
C
      ALLOCATE(LAMPUS(1:NDMULT))
      ALLOCATE(MIUPUS(1:NDMULT))
      ALLOCATE(QMOPUS(1:NDMULT))
C
      CALL NAMELI(IN_FIX,IZ_FIX,SKYRME,GOGNAM,ISTAND,
     *            KETA_J,KETA_W,KETACM,KETA_M,
     *                                 KETA_R,
     *     LANODD,LANSCA,HBMSAT,RHOSAT,EFFSAT,
     *            INNUMB,IZNUMB,FCHOM0,R0PARM,
     *            IOPTGS,NXHERM,NYHERM,NZHERM,
     *     IPAIRI,IPAHFB,ITWOBA,IPABCS,IMFHFB,
     *                          LIPKIN,LIPKIP,
     *                          IROTAT,IREVIE,
     *            DELFIN,DELFIP,IDEFIN,IDEFIP,
     *            FERFIN,FERFIP,IFEFIN,IFEFIP,
     *            FE2FIN,FE2FIP,IF2FIN,IF2FIP,
     *            INSIGN,IPSIGN,ISSIGN,IDSIGN,
     *            INSIGP,IPSIGP,ISSIGP,IDSIGP,
     *                   INSIMN,IRSIMN,IDSIMN,
     *                   INSIMP,IRSIMP,IDSIMP,
     *                   INSIQN,IPSIQN,IDSIQN,
     *                   INSIQP,IPSIQP,IDSIQP,
     *                          INSIZN,IDSIZN,
     *                          INSIZP,IDSIZP,
     *                          IFIBLN,INIBLN,
     *                          IFIBLP,INIBLP,
     *                                 IREAWS,
     *                   ICONTI,IPCONT,IOCONT,
     *            IACONT,IYCONT,IGCONT,IGPCON,
     *            ILCONT,IFCONT,IMCONT,IRCONT,
     *            NUCHAO,NUPING,EPSPNG,EPSITE,
     *            ISPHER,ISIMPY,ISIGNY,IPARTY,
     *                   ISIMTX,ISIMTY,ISIMTZ,
     *            IMOVAX,ITILAX,ITISAX,NO_ORB,
     *                          NOITER,NULAST,
     *            ISYMDE,INIROT,INIINV,INIKAR,
     *                   IRENMA,IRENIN,IDOGOA,
     *                   IFRWAV,ITOWAV,IWRWAV,
     *                          ISAKER,ICHKER,
     *                   IPRGCM,IPROMI,IPROMA,
     *                   NUAKNO,NUBKNO,KPROJE,
     *                                 NBTKNO,
     *                   ISOSAD,EPSISO,ICSKIP,
     *                                 IFERME,
     *                   IPAKER,IPAALL,KFIKER,
     *            NUASTA,NUASTO,NUGSTA,NUGSTO,
     *            NUBSTA,NUBSTO,NUTSTA,NUTSTO,
     *                   ICUTOV,CUTOVE,CUTOVF,
     *                          ISLPRI,ISUPRI,
     *                   IENPRI,ISRPRI,IMIPRI,
     *                          IKEPRI,IRMPRI,
     *                   QMUCUT,QMACUT,QSICUT,
     *                   NOSCIL,NLIMIT,ENECUT,
     *                   NUMCOU,NUMETA,FURMAX,
     *            ICOTYP,ICOUDI,ICOUEX,E_EFFE,
     *            PIMASS,PNMASS,IYUTYP,I_YUKA,
     *            YUKAGT,YUKAG0,YUKAG1,YUKAG2,
     *                          I_GOGA,IGOGPA,
     *            I1LINE,IPRSTA,IPRMID,IPRSTO,
     *            IDESTA,IDEMID,IDESTO,IDEDIS,
     *                          INTRIP,IVIPRI,
     *                   IPRI_N,IPRI_P,IPRI_T,
     *                   NMUCON,NMUCOU,NMUPRI,
     *                   ISCHIF,NSICON,NSIPRI,
     *                          NMACON,NMAPRI,
     *                   NMURED,NMARED,NSIRED,
     *                   NEXBET,IPRIBE,IPRIBL,
     *                   IWRIOL,IWRISO,IWRIRE,
     *                          IWRIYU,IWRIGO,
     *                          IWRILI,IWRIFI,
     *                   FILISO,FILREP,FILREC,
     *                   FILWOO,FILREV,FILCOU,
     *                          FILWAV,FILKER,
     *                          FILYUP,FILYUC,
     *                          FILGOP,FILGOC,
     *                          FILGPP,FILGPC,
     *                          FILLIP,FILLIC,
     *                          FILFIP,FILFIC,
     *                   ICHFLI,IPAFLI,IREFLI,
     *                   ISPFLI,ISHFLI,IFLIPI,
     *            SLOWEV,SLOWOD,SLOWPA,SLOWLI,
     *                          ICOULI,ICOULO,
     *                          FACTGN,FACTGP,
     *                          EMINAL,EMAXAL,
     *                   EMAXQU,ECUTOF,LIMQUA,
     *                                 NILXYZ,
     *                                 IAVRGG,
     *                                 IPOTHO,
     *                                 EPSHER,
     *            IFSHEL,IF_RPA,IF_THO,CBETHO,
     *                                 IFRAGM,
     *     LAMPUS,MIUPUS,NUMPUS,QMOPUS,IFPUSH,
     *                                 NITPUS,
     *                   L_COLL,M_COLL,N_COLL,
     *     DELTAE,XLOCMX,V2_MIN,ITRMAX,NTHETA,
     *            MIN_QP,IDEALL,IDELOC,IDECON)
C
C=======================================================================
C         SETTING FRACTIONAL PARTICLE NUMBERS FOR HFB CALCULATIONS
C=======================================================================
C
                                              NUCFLO=0
      IF ((ABS(XINFIX-REAL(IN_FIX,KIND=8)).GT.1.D-12.OR.
     *     ABS(XIZFIX-REAL(IZ_FIX,KIND=8)).GT.1.D-12).AND.
     *     (XIZFIX.GT.0.0.AND.XINFIX.GT.0.0)) NUCFLO=1
C
      IF (NUCFLO.EQ.0) THEN
          XINFIX=REAL(IN_FIX,KIND=8)
          XIZFIX=REAL(IZ_FIX,KIND=8)
      END IF
C
C=======================================================================
C      Getting the experimental binding energy for this nucleus
C      => also used to determinate the experimental delta
C      Also, preparing the minimization over WS deformations
C=======================================================================
C
      IF (IREAWS.EQ.1) THEN
C
          NREAD1=80
          NREAD2=81
C
          CALL WS_GIVMAS(NREAD1,NREAD2,NOFNUC,MAXI_Z,MAXI_N)
C
          DO I_NEUT=IN_FIX-2,IN_FIX+2
             NUMB_N=I_NEUT
             CALL WS_GIVPRO(NUMB_N,IMINIM,IMAXIM)
          END DO
C
          DO I_PROT=IZ_FIX-2,IZ_FIX+2
             NUMB_P=I_PROT
             CALL WS_GIVNEU(NUMB_P,IMINIM,IMAXIM)
          END DO
C
          D3N_WS = DELT3N(IZ_FIX,IN_FIX)
          D3P_WS = DELT3P(IZ_FIX,IN_FIX)
C
C          Copying the requested multipole moments in the array Q_COPY
C
          IF (NUMINP+NUMPUS.GT.NDSEAR) THEN
              WRITE(NFIPRI,'(''NUMINP = '',I4,
     *              '' NUMPUS = '',I4,'' NDSEAR = '',I4)')
     *                 NUMINP,NUMPUS,NDSEAR
              WRITE(NFIPRI,'(''NUMINP + NUMPUS > '',
     *                       ''NDSEAR !'')')
              WRITE(NFIPRI,'(''INCREASE NDSEAR AND '',
     *                       ''RECOMPILE'')')
              STOP 'NUMINP+NUMPUS>NDSEAR - MAIN'
          END IF
C
C          Multiplying the actual constrain by an artificial scaling:
C          results of the minimization tend to overestimate the actual
c          moments
C
          SCAFAC = 1.0 - ABS(QASKED(2,0))/1400.0
C
          DO LAMBDA=0,NDMULT
             DO MIU=-NDMULT,NDMULT
                Q_COPY(LAMBDA,MIU)=SCAFAC*QASKED(LAMBDA,MIU)
             END DO
          END DO
C
          IORDER=0
c
          ! Additional extra constraints
          IF (IFPUSH.EQ.1) THEN
C
              DO I=1,NUMPUS
C
                 IORDER=IORDER+1
C
                 LAMINP(IORDER)=ABS(LAMPUS(I))
                 MIUINP(IORDER)=MIUPUS(I)
                 IF (LAMINP(IORDER).GE.LMXINP)
     *               LMXINP=LAMINP(IORDER)
C
                 LAMBDA=ABS(LAMPUS(I))
                 MIU   =MIUPUS(I)
                 Q_COPY(LAMBDA,MIU)=SCAFAC*QMOPUS(I)
C
              END DO
C
	  END IF
C
      END IF
C
      INDFIL=0
      INDJOB=1
C
#endif
C
      IF (NUCFLO.EQ.1) THEN
          WRITE(NFIPRI,'(79(''*''),/,''*'',77X,''*'',/,
     *               ''*  CONSTRAINTS ON (FRACTIONAL) PARTICLE'',
     *               '' NUMBERS Z='',F7.3,'' AND N='',F7.3,6X,'' *'',
     *                  /,''*'',77X,''*'')') XIZFIX,XINFIX
      END IF
C
C=======================================================================
C         HERE STARTS THE LOOP OVER BATCH NUMBER (PARALLEL MODE ONLY)
C=======================================================================
#if(USE_MPI==1)
C
      NUDATA=1
C
      DO
C
#endif
C
      TERMNT=.FALSE.
      IS_YES=0
      IS_PIN=0
      IS_CHA=0
      ITERUN=0
      ISHIFT=0
C
      ISGOGA=0 ! Gogny mean-field
      ISGOGP=0 ! Gogny pairing field
      ISEXAC=0 ! Coulomb exact mean-field
C
      LDPNMX=1 ! default proton-neutron mixing
C
C      Mixing of matrix elements (p and n separated)
      NOFBRN=0
      NOFBRP=0
      NSWBRN=1000000
      NSWBRP=1000000
      ITAK_N=0
      ITAK_P=0
      NOICAN=NOIINP
C
C      Mixing of fields (p and n combined)
      NOFBRO=0
      NSWBRO=1000
      ITAKEN=0
      KEPTES=0
C
C      Counting and defining the active constraints
C
	               DOPUSH=.FALSE.
      IF (IFPUSH.EQ.1) DOPUSH=.TRUE.
C
      CALL NUMCON(LAMPUS,MIUPUS,QMOPUS,NUMPUS,IF_RPA,IFPUSH,DOPUSH)
C
C=======================================================================
C      AUTOMATIC ADJUSTMENT OF THE BASIS DEFORMATION AND FREQUENCIES
C      BASED ON REQUESTED VALUE OF THE QUADRUPOLE MOMENT.  FCHOM0 IS
C      A MULTIPLICATIVE  FACTOR OF  BASIC FREQUENCY  41/A^(1/3). THE
C      DEFORMATION OF THE BASIS PASSED THROUGH COMMON BLOCK.
C=======================================================================
C
      IF (IBASIS.EQ.1) CALL ADJBAS(FCHOM0,IN_FIX,IZ_FIX)
C
C=======================================================================
C
      IDOPLM=0
C
C=======================================================================
C      OPENING ALL RELEVANT FILES FOR I/O
C=======================================================================
C
      IF (batch_init.EQ.1) THEN
          CALL IOFILE(IREAWS,ICONTI,IFCONT,IYCONT,ILCONT,IGCONT,
     *                IGPCON,IWRIRE,IWRILI,IWRIYU,IWRIGO,IWRIFI,
     *                IWRISO,
     *
     *                LIPKIN,LIPKIP,I_YUKA,I_GOGA,IGOGPA,INDFIL,
     *                INDJOB,IREVIE,IF_THO,
     *
     *                NFIWOO,NFIREP,NFIREC,NFIREV,NFICOU,NFIWAV,
     *                NFIKER,NFIYUP,NFIYUC,NFIGOP,NFIGOC,NFIGPC,
     *                NFIGPP,NFILIP,NFILIC,NFIFIP,NFIFIC,NFIISO,
     *
     *                FILWOO,FILREP,FILREC,FILREV,FILCOU,FILWAV,
     *                FILKER,FILYUP,FILYUC,FILGOP,FILGOC,FILGPC,
     *                FILGPP,FILLIP,FILLIC,FILFIP,FILFIC,FILISO)
      END IF
C
C=======================================================================
C         READING THE INPUT DATA FROM THE WOODS-SAXON FILE
C=======================================================================
C
      IF (IREAWS.EQ.1.AND.batch_init.EQ.1) THEN
C
#if(USE_MPI==1)
          WRITE(FILWOO,'(''wsodd'',I6.6,''.bin'')') INDJOB
#endif
C
          CALL WS_UNIVERSAL(IN_FIX,IZ_FIX,FCHOM0,R0PARM,
     *                      NOSCIL,NLIMIT,NXHERM,NYHERM,
     *                      NZHERM,ALPHAR,NDLAMB,IFLAGQ,
     *                                           Q_COPY,
     *                      NUMINP,LMXINP,LAMINP,MIUINP,
     *                      ITEINP,STPINP,FILWOO,NFIPRI,
     *                      D3N_WS,D3P_WS,IHFPOT,ISIGNY)
C
          OPEN(NFIWOO,FILE=FILWOO,STATUS='OLD',IOSTAT=IERROR,
     *                                         FORM='UNFORMATTED')
C
          CALL READWS(INNUMB,IZNUMB,FCHOM0,R0PARM,HOMEGA,
     *                       NFIWOO,NXHERM,NYHERM,NZHERM,
     *                       EPSHER,NOSCIL,NLIMIT,ENECUT,
     *                              LAMMAX,ISOTRO,CVOLFC,
     *                              CMSXFC,CMSYFC,CMSZFC,
     *                              XMOMFC,YMOMFC,ZMOMFC,
     *                                     GPAIRN,GPAIRP)
C
          CLOSE(NFIWOO)
C
          CALL DEFPRI(LAMMAX,INNUMB,IZNUMB)
C
      ELSE
C
C=======================================================================
C         DETERMINATION OF BASIS PARAMETERS FROM THE GEOMETRICAL SHAPE
C=======================================================================
C
          CALL GEOMFC(INNUMB,IZNUMB,FCHOM0,R0PARM,HOMEGA,
     *                              LAMMAX,ISOTRO,CVOLFC,
     *                              CMSXFC,CMSYFC,CMSZFC,
     *                              XMOMFC,YMOMFC,ZMOMFC)
C
      END IF
C
C=======================================================================
C         INPUT-RELATED PREDEFINITIONS
C=======================================================================
C
      NVASIZ(0)=IN_FIX
      NVASIZ(1)=IZ_FIX
C
C=======================================================================
C         SETTING "ISIQTY" ACCORDING TO THE ADOPTED COMPATIBILITY MODE
C=======================================================================
C
      IF (IPARTY.NE.-1) THEN
C
          ISIQTY=IPARTY
C
      ELSE
C
          IF (ISIGNY.EQ.1.AND.ISIMPY.EQ.1) THEN
C
              ISIQTY=1
          ELSE
              ISIQTY=0
C
          END IF
C
      END IF
C
C=======================================================================
C         SETTING "JSIMTY" ACCORDING TO THE ADOPTED COMPATIBILITY MODE
C=======================================================================
C
      IF (ISIMTY.NE.-1) THEN
C
          JSIMTY=ISIMTY
C
      ELSE
C
          IF (IROTAT.EQ.1) THEN
              JSIMTY=0
          ELSE
              JSIMTY=1
          END IF
C
      END IF
C
C=======================================================================
C         SETTING "JPABCS" ACCORDING TO THE ADOPTED COMPATIBILITY MODE
C=======================================================================
C
      IF (IPABCS.NE.-1) THEN
C
          JPABCS=IPABCS
C
      ELSE
C
          IF (IPAHFB.EQ.1) THEN
              JPABCS=0
          ELSE
              JPABCS=IPAIRI
          END IF
C
      END IF
C
C=======================================================================
C         SETTING THE ANGULAR FREQUENCY COMPONENTS TO THE INITIAL VALUES
C=======================================================================
C
      OMOVAX=OMEGAX
      OMOVAY=OMEGAY
      OMOVAZ=OMEGAZ
C
C=======================================================================
C         CHANGING THE PARITY/SIGNATURE NOTATION INTO THE
C         PARITY/TIME-REVERSAL NOTATION
C=======================================================================
C
      CALL SIGREV
C
C=======================================================================
C         SETTING THE ABSOLUTE CONFIGURATIONS
C=======================================================================
C
      IF (ISIMPY.EQ.1) THEN
C
          IF (ISIGNY.EQ.1) THEN
C
              CALL SETSIG(IPAIRI)
          ELSE
              CALL SETSIM(IPAIRI)
C
          END IF
C
      ELSE
C
          IF (ISIQTY.EQ.1) THEN
C
              CALL SETSIQ(IPAIRI)
          ELSE
              CALL SETSIZ(IPAIRI)
C
          END IF
C
      END IF
C
C=======================================================================
C         SETTING THE COULOMB, PHASE SPACE, AND PAIRING DATA
C=======================================================================
C
      BOUCOU=FURMAX*NUMCOU
C
      IF (NUMBSP(0,0).EQ.0) NUMBSP(0,0)=IN_FIX
      IF (NUMBSP(1,0).EQ.0) NUMBSP(1,0)=IN_FIX
C
      IF (NUMBSP(0,1).EQ.0) NUMBSP(0,1)=IZ_FIX
      IF (NUMBSP(1,1).EQ.0) NUMBSP(1,1)=IZ_FIX
C
      IF (IF_THO.EQ.0) THEN
C
          EFERMN=FERINI(0)
          DELTAN=DELINI(0)
          EFER2N=FE2INI(0)
C
          EFENIN=0.0D0
          EFENOU=EFERMN
          EF2NIN=0.0D0
          EF2NOU=EFER2N
C
          EFERMP=FERINI(1)
          DELTAP=DELINI(1)
          EFER2P=FE2INI(1)
C
          EFEPIN=0.0D0
          EFEPOU=EFERMP
          EF2PIN=0.0D0
          EF2POU=EFER2P
C
      END IF
C
C=======================================================================
C         SETTING SWITCH "NOSHIM" THAT BLOCKS PRINTING OF SHIFTED
C         MAGNETIC MOMENTS UNTIL THEIR CALCULATION IS  DEVELOPED.
C         WHEN THE PARITY IS BROKEN, THE ROTATED MAGNETIC MOMENTS
C         CANNOT BE PRINTED EITHER BECAUSE THEY SHOULD CORRESPOND
C         TO A ROTATION OF SHIFTED MOMENTS.
C=======================================================================
C
      NOSHIM=0
      IF (ISIQTY.NE.1) NOSHIM=1
C
C=======================================================================
C         WITHOUT ROTATION (IROTAT=0) AND WITHOUT BREAKING THE Y-SIMPLEX
C         SYMMETRY (ISIMPY=1), THE TIME-REVERSED BLOCK IS NOT EXPLICITLY
C         CALCULATED. THIS IS DONE BY USING MREVER=0, I.E. BY PERFORMING
C         THE LOOPS OVER IREVER ONLY FOR IREVER=0.  IN SUCH A CASE,  THE
C         ARRAYS FOR IREVER=1 REMAIN UNDEFINED.
C=======================================================================
C
      MREVER=1
      IF (ISIMPY.EQ.1.AND.IROTAT.NE.1) MREVER=0
C
C=======================================================================
C         SETTING THE PARAMETERS THAT HANDLE THE ANGULAR-MOMENTUM
C         PROJECTION AND CALCULATION OF THE GCM KERNELS
C=======================================================================
C
      ISAWAV=0
      IF (IPRGCM.GE.1.OR.IRENMA.GE.1.OR.IRENIN.GE.1) ISAWAV=1
      IKERNE=0
C
C=======================================================================
C         SETTING THE NAMES OF SURFACE OR SCHIFF MOMENTS
C=======================================================================
C
                       NAMSIF=NAMSUR
      IF (ISCHIF.EQ.1) NAMSIF=NAMSCH
C
C=======================================================================
C         SETTING THE VALUES OF LINEAR LAGRANGE PARAMETERS
C=======================================================================
C
      DO LAMBDA=0,NDMULT
         DO MIU=-LAMBDA,LAMBDA
C
            GALMUQ(LAMBDA,MIU)=QLINEA(LAMBDA,MIU)
            GALMUS(LAMBDA,MIU)=SLINEA(LAMBDA,MIU)
C
         END DO
      END DO
C
C=======================================================================
C         SETTING THE VALUES OF LIMITS FOR ISOSPIN PROJECTION
C=======================================================================
C
      ISOSTZ=IN_FIX-IZ_FIX
      ISOSMI=ABS(ISOSTZ)
      ISOSMA=ISOSMI+ISOSAD
C
C=======================================================================
C         HERE BEGINS THE INITIALIZATION PHASE OF THE PROGRAM
C=======================================================================
C
C=======================================================================
C         ALLOCATING SPACE FOR SKYRME DENSITIES AND FIELDS
C=======================================================================
C
      CALL ALLODE()
C
      CALL ALLOVF()
C
C=======================================================================
C         CHOICE OF THE SKYRME FORCE PARAMETERS
C=======================================================================
C
      CALL PARAMS(SKYRME,LANODD,LANSCA,HBMSAT,RHOSAT,EFFSAT,
     *                   ISTAND,KETA_J,KETA_W,KETACM,KETA_M,
     *                          JETA_J,JETA_W,JETACM,JETA_M)
C
C=======================================================================
C         CHOICE OF THE GOGNY FORCE PARAMETERS
C=======================================================================
C
                                I_REGA=0
      CALL PARGOG(I_GOGA,IGOGPA,I_REGA,GOGNAM)
C
C=======================================================================
C         TESTING INTEGRITY OF THE INPUT DATA
C=======================================================================
C
      CALL TESDAT(IOPTGS,NOSCIL,NLIMIT,ISTAND,
     *            KETA_J,KETA_W,KETACM,KETA_M,
     *                                 KETA_R,
     *                   ISIMPY,ISIGNY,ISIQTY,
     *                   ISIMTX,JSIMTY,ISIMTZ,
     *                   NMUCON,NMUCOU,NMUPRI,
     *            ISCHIF,NSICON,NSIPRI,IDOPLM,
     *                          NMACON,NMAPRI,
     *                   NMURED,NMARED,NSIRED,
     *                          NEXBET,IPRIBE,
     *                   NUPING,EPSPNG,EPSITE,
     *                                 NULAST,
     *            ISYMDE,INIROT,INIINV,INIKAR,
     *                                 IWRIOL,
     *                          IRENMA,IRENIN,
     *                   IFRWAV,ITOWAV,IWRWAV,
     *                                 ISAKER,
     *                   IPRGCM,IPROMI,IPROMA,
     *                   NUAKNO,NUBKNO,KPROJE,
     *                                 NBTKNO,
     *            ISOSMI,ISOSMA,EPSISO,ICSKIP,
     *                                 IFERME,
     *                   IPAKER,IPAALL,KFIKER,
     *            NUASTA,NUASTO,NUGSTA,NUGSTO,
     *            NUBSTA,NUBSTO,NUTSTA,NUTSTO,
     *                   ICHFLI,IPAFLI,IREFLI,
     *                   ISPFLI,ISHFLI,IFLIPI,
     *                          NOITER,IREAWS,
     *                          IN_FIX,IZ_FIX,
     *            IDESTA,IDEMID,IDESTO,IDEDIS,
     *            IMOVAX,ITILAX,ITISAX,NO_ORB,
     *                                 NILXYZ,
     *                                 IROTAT,
     *                   IPAIRI,IPAHFB,JPABCS,
     *                   LIMQUA,ITWOBA,IMFHFB,
     *                          LIPKIN,LIPKIP,
     *                   SLOWEV,SLOWOD,SLOWPA,
     *                          IFEFIN,IFEFIP,
     *                          IF2FIN,IF2FIP,
     *                          IDEFIN,IDEFIP,
     *            INSIGN,IPSIGN,ISSIGN,IDSIGN,
     *            INSIGP,IPSIGP,ISSIGP,IDSIGP,
     *                   INSIMN,IRSIMN,IDSIMN,
     *                   INSIMP,IRSIMP,IDSIMP,
     *                   INSIQN,IPSIQN,IDSIQN,
     *                   INSIQP,IPSIQP,IDSIQP,
     *                          INSIZN,IDSIZN,
     *                          INSIZP,IDSIZP,
     *                          IFIBLN,INIBLN,
     *                          IFIBLP,INIBLP,
     *                   ICOTYP,ICOUDI,ICOUEX,
     *                          IYUTYP,I_YUKA,
     *                          I_GOGA,IGOGPA,
     *                   ICONTI,IPCONT,IOCONT,
     *            IACONT,IYCONT,IGCONT,IGPCON,
     *            ILCONT,IFCONT,IMCONT,IRCONT,
     *            JETACM,IFSHEL,IF_RPA,IF_THO,
     *                          SKYRME,GOGNAM,
     *                                 IFRAGM)
C
C=======================================================================
C         CALCULATING  THE  HARMONIC - OSCILLATOR  BASIS  PARAMETERS
C=======================================================================
C
      CALL SETBAS(IN_FIX,IZ_FIX,IREAWS,NOSCIL,NLIMIT,ENECUT,
     *                          IOPTGS,NXHERM,NYHERM,NZHERM,
     *                          JETACM,NXMAXX,NYMAXX,NZMAXX,
     *            ISPHER,INIROT,IPRGCM,ICOUDI,ICOUEX,E_EFFE,
     *                                        ELIMIT,IF_THO)
C
C@@@ HFBTHO - HFBTHO - HFBTHO - HFBTHO - HFBTHO - HFBTHO - HFBTHO
C=======================================================================
C      RUNNING HFBTHO
C=======================================================================
C
      IF (IF_THO.GE.1) THEN
C
          I_FAIL=0
C
#if(USE_MPI==1)
          WRITE(FILTHO,'(''t'',I6.6,''.hel'')') INDJOB
#else
          WRITE(FILTHO,'(''t'',I3.3,''_'',I3.3,''.hel'')')
     *                             IZ_FIX,IN_FIX
#endif
C
C          Read HFODD field file and transform the matrix of the mean-field
C          and pairing field into HFBTHO basis convention
C
          IF (IF_THO.EQ.2) THEN
C
C              First read traditional record file, which contains many
C              useful quantities at convergence
C
              WRITE(NFIPRI,'(79(''*''),/,''*'',77X,''*'',/,
     *           ''*  CALLING SUBROUTINE "RECORD" TO READ'',
     *           '' THE REPLAY FILE OBTAINED PREVIOUSLY    *'',/,
     *           ''*'',2X,A68,7X,''*'')') FILREP
C
              INPFLD=1
              IERROR=0
              ICCONT=1
C
              CALL RECORD(NFIREP,NFIREC,INPFLD,NUMITE,
     *                           NXHERM,NYHERM,NZHERM,
     *                                  IPCONT,ILCONT,
     *                           IACONT,IMCONT,IRCONT,
     *                                  IRENMA,IRENIN,
     *                                  LIPKIN,LIPKIP,
     *                                  REFERN,REFERP,
     *                                  REDELN,REDELP,
     *                                  REFE2N,REFE2P,
     *                                  IFIBLN,INIBLN,
     *                                  IFIBLP,INIBLP,
     *                                  NMUMAX,NSIMAX,
     *                                  NMUCON,ISHIFT,
     *                                         IERROR)
C
              IF (IERROR.NE.0) THEN
C
                  WRITE(NFIPRI,'(
     *              '' ////////////////////////////////////////'',
     *              ''/////////////////////////////////////'',/,
     *              '' ////       WARNING: RECORD FILE IS CORRUPTED'',
     *              '' !                          /////'',/,
     *              '' ////                 - RESTART IS CANCELLED '',
     *              ''                            /////'',/,
     *              '' ////                 - CALCULATIONS WILL RES'',
     *              ''TART FROM SCRATCH           /////'',/,
     *              '' ////////////////////////////////////////'',
     *              ''/////////////////////////////////////'')')
C
              END IF
C
#if(USE_MPI==1)
              CALL mpi_pathExploration(IERROR,NMUCON)
#endif
C
              WRITE(NFIPRI,'(''*'',77X,''*'',/,
     *            ''*  CALLING SUBROUTINE "RECFIL" TO READ'',
     *            '' THE FIELDS FILE OBTAINED PREVIOUSLY    *'',/,
     *            ''*'',2X,A68,7X,''*'',/,''*'',77X,''*'')')
     *              FILFIP
C
              INPFIL=1
              IFNTHO=0
C
              CALL RECFIL(NFIFIP,NFIFIC,INPFIL,ISIMPY,IPAHFB,
     *                                         NOSCIL,NUMITE,
     *                           EFERMN,EFERMP,EFER2N,EFER2P,
     *                           DELTAN,DELTAP,FCHOM0,IFNTHO,
     *                                         NLIMIT,FILTHO)
C
              WRITE(NFIPRI,'(79(''*''),/,''*'',77X,''*'',/,
     *           ''*  CALLING SUBROUTINE  CARCYL  TO TRANSFORM '',
     *           ''THE HFB MATRIX READ  FROM HFODD   *'',/,
     *           ''*  INTO THE CYLINDRICAL BASIS USED IN HFBTHO.'',
     *                33X,''*'')')
C
C              Strip the phase from the matrix and move into cylindrical
C              coordinates
C
              bz_THO = 1.0/HOMSCA(3)
              bp_THO = 1.0/SQRT(HOMSCA(1)*HOMSCA(2))
C
                                    force_parity_THO = .False.
              IF (ABS(ISIGNY).EQ.1) force_parity_THO = .True.
C
              CALL CARCYL(NOSCIL,ISIMPY,IF_THO,bz_THO,bp_THO,
     *                        force_parity_THO,ELIMIT,NYMAXX)
C
C              Change ordering of basis states
              CALL ToHFBTHO(NDTRAN,NDSPIN,NOSCIL,LDBASE,NOFCNS)
C
C              Write results in HFBTHO format
              unit_tho  = 92
              beta0_THO = ALPHAR(2,0)
C              Lagrange parameters
              DO L=1,8
                 multLag_tho(L) = RALMUQ(L,0)
              END DO
              CALL WriteHFBTHO(unit_tho,FILTHO,IN_FIX,IZ_FIX,NOSCIL,
     *                           REFERN,REFERP,REDELN,REDELP,REFE2N,
     *                           REFE2P,PRHO_N,PRHO_P,BZ_THO,BP_THO,
     *                           beta0_THO,multLag_tho)
C
              ITESTA=NUMITE+1
C
          END IF
C
C@@@ HFBTHO -HFBTHO - HFBTHO - HFBTHO - HFBTHO - HFBTHO - HFBTHO
#if(USE_MPI==1)
          IF (batch_mode.EQ.1) THEN
              CALL batch(NFIREP,NFIREC,NUDATA,FILREP,FILREC,IF_THO,
     *                          NXHERM,NYHERM,NZHERM,IRENMA,IRENIN,
     *                   REFERN,REFERP,REDELN,REDELP,REFE2N,REFE2P,
     *                   IFIBLN,INIBLN,IFIBLP,INIBLP,NMUMAX,NSIMAX,
     *                                               NMUCON,ISHIFT,
     *                   ICONTI,IPCONT,ILCONT,IACONT,IGCONT,IGPCON,
     *                                               IMCONT,IRCONT,
     *                   IPAIRI,LIPKIN,LIPKIP,I_GOGA,IGOGPA,I_YUKA,
     *                                               JETACM,KETA_R,
     *                   Q_NECK,QACTUA,QORIGI,QINCRE,INDJOB,
     *                                               batch_init)
          END IF
#endif
C
C          Input parameters for HFBTHO
C
          file_THO    = FILTHO
          output_THO  = NFIPRI
C
          Nshell_THO  = NOSCIL
          b0_THO      = (HOMSCA(1)*HOMSCA(2)*HOMSCA(3))**(-1.0D0/3.0D0)
          bz_THO      = 1.0D0/HOMSCA(3)
          bp_THO      = 1.0D0/SQRT(HOMSCA(1)*HOMSCA(2))
          beta0_THO   = ALPHAR(2,0)
          b2_THO      = REAL(ALPHAC(2,0)) ! Deformation of the WS potential
          b4_THO      = REAL(ALPHAC(4,0)) ! Deformation of the WS potential
          neutron_THO = IN_FIX
          proton_THO  = IZ_FIX
          type_THO    = 1
          IF (LIPKIN.EQ.1.OR.LIPKIP.EQ.1) type_THO=-1
C
          niter_THO    = 200
          accuracy_THO = 1.D-5
          restart_THO  = -1
C
          functional_THO   = TRIM(SKYRME)
          initial_pair_THO = .False.
                                           coulomb_THO = 2
          IF (ICOUDI.EQ.0.AND.ICOUEX.EQ.0) coulomb_THO = 0
          IF (ICOUDI.EQ.1.AND.ICOUEX.EQ.0) coulomb_THO = 1
          IF (ICOUDI.EQ.1.AND.ICOUEX.EQ.1) coulomb_THO = 2
C
          VpairN_THO = PRHO_N
          VpairP_THO = PRHO_P
          Ecut_THO   = ECUTOF
          V1_THO     = 0.5D0
C
	  n_blocking_THO = (/ 0, 0, 0, 0, 0 /)
          p_blocking_THO = (/ 0, 0, 0, 0, 0 /)
C
	  DO L=1,8
             lambda_THO(L) = L
             active_THO(L) = IFLAGQ(L,0)
             expect_THO(L) = QASKED(L,0)
          END DO
C
	  useTHO_THO     = 0
          gauge_THO      = 1
          projection_THO = 0
          dN_THO         = 0
          dZ_THO         = 0
C
	                   set_temper_THO = .False.
	  IF (IFTEMP.EQ.1) set_temper_THO = .True.
          temper_THO=TEMP_T
C
          numGauss_THO    = 40
          numLaguerre_THO = 40
          numLegendre_THO = 80
          HFODD_to_HFBTHO = .True.
          nstate_THO      = NLIMIT
                                force_parity_THO = .False.
          IF (ABS(ISIGNY).EQ.1) force_parity_THO = .True.
C
          WRITE(NFIPRI,'(79(''*''),/,''*'',77X,''*'',/,
     *      ''*          SMOOTH CONTINUATION FROM HFBTHO'',
     *      '' RUN HAS BEEN REQUESTED             *'',/,
     *      ''*'',77X,''*'',/,
     *      ''*  WARNING: THE RESTART WILL BE SMOOTH '',
     *      ''IF AND ONLY IF:                        *'',/,
     *      ''*            - AXIAL-, REFLECTION, AND '',
     *      ''TIME_REVERSAL SYMMETRIES ARE CONSERVED *'',/,
     *      ''*            - CALCULATIONS ARE UNCONSTRAINED'',
     *      ''                                 *'',/,
     *      ''*            - BASIS IS SPHERICAL OR DEFORMED'',
     *      '' ONLY ALONG BETA_2               *'',/,
     *      ''*            - HFB SOLUTION AT THE G.S. IS '',
     *      ''REQUESTED (NO HF CRANKING  ETC.)   *'',/,
     *      ''*           ANY OTHER CASE WILL RESULT IN '',
     *      ''THE STABILITY CONDITION AT FIRST    *'',/,
     *      ''*           ITERATION TO BE SIGNIFICANTLY '',
     *      ''GREATER THAN PERHAPS ANTICIPATED    *'',/,
     *      ''*'',77X,''*'',/,79(''*''))')
C
          CALL Main_Program(Nshell_THO, b0_THO, bz_THO, bp_THO,
     *                      beta0_THO, b2_THO, b4_THO, neutron_THO,
     *                      proton_THO, type_THO, niter_THO,
     *                      accuracy_THO, restart_THO,
     *                      functional_THO, initial_pair_THO,
     *                      coulomb_THO, VpairN_THO, VpairP_THO,
     *                      Ecut_THO, V1_THO, n_blocking_THO,
     *                      p_blocking_THO, lambda_THO, active_THO,
     *                      expect_THO, useTHO_THO, gauge_THO,
     *                      projection_THO, dN_THO, dZ_THO,
     *                      set_temper_THO, temper_THO, numGauss_THO,
     *                      numLaguerre_THO, numLegendre_THO,
     *                      HFODD_to_HFBTHO, nstate_THO,
     *                      force_parity_THO, file_THO, output_THO)
C
          IF (I_FAIL.EQ.1) THEN
              IF_THO=0
              WRITE(NFIPRI,'(79(''!''),/,
     *              ''!!   PROGRAM HFBTHO FAILED... LIKELY REASON: '',
     *              ''UNKNOWN INTERACTION             !!'',/,
     *              ''!!   HFODD WILL RESUME FROM SCRATCH - '',
     *              ''FORECAST MORE ITERATIONS NEEDED        !!'',/,
     *                       79(''!''))')
          END IF
C
          WRITE(NFIPRI,'(79(''*''),/,''*'',77X,''*'',/,
     *          ''*  CALLING SUBROUTINE "RECFIL" TO READ'',
     *          '' THE FIELDS FILE GENERATED BY HFBTHO    *'',/,
     *          ''*'',77X,''*'',/,79(''*''),/)')
C
          DO ICHARG=0,NDISOS
             CALL ZEDENS(ICHARG)
          END DO
C
          NUMITE=-1
C
          INPFIL=1
C
          CALL RECFIL(NFIFIP,NFIFIC,INPFIL,ISIMPY,IPAHFB,
     *                                     NOSCIL,NUMITE,
     *                       EFERMN,EFERMP,EFER2N,EFER2P,
     *                       DELTAN,DELTAP,FCHOM0,IF_THO,
     *                                     NLIMIT,FILTHO)
C
          REFERN=EFERMN
          REDELN=DELTAN
          REFE2N=EFER2N
C
          REFERP=EFERMP
          REDELP=DELTAP
          REFE2P=EFER2P
C
          ITESTA=NUMITE+1
C
      END IF
C
C@@@ HFBTHO - HFBTHO - HFBTHO - HFBTHO - HFBTHO - HFBTHO - HFBTHO
C=======================================================================
C         COMPUTING THE SIZE OF THE BROYDEN VECTOR DEPENDING ON
C         THE USER'S CHOICE OF HFODD OPTIONS
C=======================================================================
C
      IF (MIXMAT.EQ.0) THEN
          CALL CALBRO_FIELDS(IROTAT,ISIMPY,IPAHFB,LIPKIN,LIPKIP,
     *                       NXHERM,NYHERM,NZHERM,IBROYD,NOFBRO)
      END IF
C
      IF (MIXMAT.EQ.1) THEN
          CALL CALBRO_MATRIX(MREVER,IROTAT,ISIMPY,IPAHFB,NOFBRN,
     *                              NOFBRP,LIPKIN,LIPKIP,IBROYD)
      END IF
C
C@@@ SHELL -SHELL - SHELL - SHELL - SHELL - SHELL - SHELL - SHELL
C=======================================================================
C         ENFORCING THE SIZE OF PHASE SPACE SO THAT THERE ARE ENOUGH
C         SINGLE - PARTICLE STATES FOR THE  COMPUTATION OF THE SHELL
C         CORRECTION
C=======================================================================
C
      IF (IFSHEL.GE.1) THEN
C
              LDPHAS=LDBASE
          IF (LDPHAS.GT.NDSTAT .OR. LDPHAS.EQ.0) LDPHAS=NDSTAT
C
          DO IREVER=0,NDREVE
             DO ICHARG=0,NDISOS
                NUMBSP(IREVER,ICHARG)=LDPHAS
             END DO
          END DO
C
      END IF
C
C@@@ SHELL -SHELL - SHELL - SHELL - SHELL - SHELL - SHELL - SHELL
C@@@ HFBTHO - HFBTHO - HFBTHO - HFBTHO - HFBTHO - HFBTHO - HFBTHO
C=======================================================================
C         REORDERING THE MATRICES OF THE MEAN-FIELD AND THE PAIRING
C         FIELD OBTAINED FROM  HFBTHO  TO COMPLY WITH  HFODD LABELS
C         CONVENTIONS. RESULTS HAVE BEEN READ PREVIOUSLY IN RECFIL.
C=======================================================================
C
      IF (IF_THO.GE.1) CALL FromHFBTHO(NDTRAN,NDSPIN)
C
C@@@ HFBTHO - HFBTHO - HFBTHO - HFBTHO - HFBTHO - HFBTHO - HFBTHO
C=======================================================================
C         SETTING THE INITIAL VALUES OF THE RENORMALIZED MASSES
C=======================================================================
C
      TRAMAS=HBMASS/REAL(IN_FIX+IZ_FIX,KIND=8)
C
      HBMREN(1)=-TRAMAS*HBMRIN(1)
      HBMREN(2)=-TRAMAS*HBMRIN(2)
      HBMREN(3)=-TRAMAS*HBMRIN(3)
C
C=======================================================================
C         SETTING THE INITIAL VALUES OF THE RENORMALIZED INERTIA
C=======================================================================
C
      ROTMAS=1 ! TEMPORARY !
C
      ROTREN(1)=-ROTMAS*ROTRIN(1)
      ROTREN(2)=-ROTMAS*ROTRIN(2)
      ROTREN(3)=-ROTMAS*ROTRIN(3)
C
C=======================================================================
C         DEFINITION (IN DEVHER) OF THE AUXILIARY EXPANSION COEFFICIENTS
C         TO EXPRESS  THE  PRODUCTS OF  T W O  HERMITE POLYNOMIALS, OR A
C         PRODUCT OF ONE POLYNOMIAL AND A DERIVATIVE ETC.  BY  A  SERIES
C         OF SINGLE HERMITE POLYNOMIALS
C=======================================================================
C         DEFINITION ( IN DEFINT ) OF HARMONIC OSCILLATOR WAVE FUNCTIONS
C         AND GAUSS-HERMITE INTEGRATION POINTS AND WEIGHTS
C=======================================================================
C         DEFINITION ( IN DEFYLM ) OF SOLID      HARMONICS
C         DEFINITION ( IN DEFSLM ) OF SURFACE    HARMONICS
C         DEFINITION ( IN DEFPLM ) OF PENSURFACE HARMONICS
C=======================================================================
C         THE PENSURFACE MOMENTS ARE CALCULATED ONLY IF "IDOPLM" IS  SET
C         ABOVE TO 1. THE CALCULATION OF  THE  PENSURFACE  MOMENTS  THEN
C         STRICTLY FOLLOWS THAT OF THE SURFACE MOMENTS, ALTHOUGH NOT ALL
C         OPTIONS AND TESTS ARE IMPEMENTED YET; YOU SHOULD PROCEED  WITH
C         EXTREME CAUTION!
C=======================================================================
C
      NOBODY=2
      NBDONE=1
C
      NMUMAX=1
      NMUMAX=MAX(NMUMAX,NMUCON,NMUCOU,NMUPRI)
C
      NMAMAX=0
      NMAMAX=MAX(NMAMAX,NMACON,NMAPRI)
C
      NSIMAX=0
      NSIMAX=MAX(NSIMAX,NSICON,NSIPRI)
C
      NMUPOW=NMUMAX
      IF (NSIMAX.GT.0)                 NMUPOW=MAX(NMUMAX,NSIMAX+2)
      IF (NSIMAX.GT.0.AND.IDOPLM.EQ.1) NMUPOW=MAX(NMUMAX,NSIMAX+4)
C
C=======================================================================
C
      NGAUSS=NXHERM
      NOSACT=NOSCIL
      KARTEZ=1
C
      CALL SCAHER(NOSACT,KARTEZ)
C
      CALL DEVHER(NOSACT,KARTEZ)
C
      CALL DEFINT(NOSACT,KARTEZ,NGAUSS,NOBODY,
     *            HERMTS,DHRMTS,DDHRMT,FOURWG,FOURPT)
C
      CALL COPHER(NOSACT,KARTEZ,NGAUSS,HERMTS,DHRMTS,DDHRMT,
     *                                 CERMTS,CHRMTS,CDHRMT)
C
      CALL DEFINT(NOSACT,KARTEZ,NGAUSS,NBDONE,
     *            HERONE,DHRONE,DDHONE,TWOWGT,TWOPNT)
C
      CALL DEVMUL(NOSACT,NGAUSS,KARTEZ,NMUPOW)
C
      CALL DEFMOS(NXMAXX,NDXMAX,KARTEZ)
C
C=======================================================================
C
      NGAUSS=NYHERM
      NOSACT=NOSCIL
      KARTEZ=2
C
      CALL DEVHER(NOSACT,KARTEZ)
C
      CALL DEFINT(NOSACT,KARTEZ,NGAUSS,NOBODY,
     *            HERMTS,DHRMTS,DDHRMT,FOURWG,FOURPT)
C
      CALL COPHER(NOSACT,KARTEZ,NGAUSS,HERMTS,DHRMTS,DDHRMT,
     *                                 CERMTS,CHRMTS,CDHRMT)
C
      CALL DEFINT(NOSACT,KARTEZ,NGAUSS,NBDONE,
     *            HERONE,DHRONE,DDHONE,TWOWGT,TWOPNT)
C
      CALL DEVMUL(NOSACT,NGAUSS,KARTEZ,NMUPOW)
C
      CALL DEFMOS(NYMAXX,NDYMAX,KARTEZ)
C
C=======================================================================
C
      NGAUSS=NZHERM
      NOSACT=NOSCIL
      KARTEZ=3
C
      CALL DEVHER(NOSACT,KARTEZ)
C
      CALL DEFINT(NOSACT,KARTEZ,NGAUSS,NOBODY,
     *            HERMTS,DHRMTS,DDHRMT,FOURWG,FOURPT)
C
      CALL COPHER(NOSACT,KARTEZ,NGAUSS,HERMTS,DHRMTS,DDHRMT,
     *                                 CERMTS,CHRMTS,CDHRMT)
C
      CALL DEFINT(NOSACT,KARTEZ,NGAUSS,NBDONE,
     *            HERONE,DHRONE,DDHONE,TWOWGT,TWOPNT)
C
      CALL DEVMUL(NOSACT,NGAUSS,KARTEZ,NMUPOW)
C
      CALL DEFMOS(NZMAXX,NDZMAX,KARTEZ)
C
C=======================================================================
C
      CALL DEFEXP(NXHERM,NYHERM,NZHERM)
C
C=======================================================================
C
      CALL DEFYLM
      CALL DEFSLM
      CALL DEFVLM
      IF (IDOPLM.EQ.1)
     *CALL DEFPLM
C
      CALL DEFUNI(NMUMAX,NSIMAX,NMAMAX)
C
C=======================================================================
C         BUILDING ARRAYS PERTAINING TO THE SPHERICAL HO BASIS
C=======================================================================
C
      IF (ISPHER.EQ.1) THEN
C
C         CALL DOSPHE(NOSACT,NGAUSS,NXHERM,NYHERM,NZHERM)
C
      END IF
C
C=======================================================================
C         DEFINING THE SPHERICAL HARMONICS REQUIRED FOR A CALCULATION OF
C         EXACT BOHR DEFORMATION PARAMETERS
C=======================================================================
C
      IF (NEXBET.GT.0.AND.IPRIBE.EQ.1) CALL LOADIN(NEXBET)
C
C=======================================================================
C         DEFINING THE MULTIPOLES TO BE USED IN THE COULOMB POTENTIAL
C=======================================================================
C
      CALL MULCOU(ISIMPY,ISIGNY,ISIQTY,NMUCOU)
C
C=======================================================================
C         DEFINING THE FOURIER INTEGRALS  FOR  THE  COULOMB POTENTIAL
C=======================================================================
C
      CALL PRECOU(NOSCIL,NUMCOU,NUMETA,BOUCOU,
     *            NFICOU,FILCOU,ICOULI,ICOULO)
C
C=======================================================================
C         CALCULATING THE PHASES ACCORDING TO SOME INGENIOUS CONVENTION
C=======================================================================
C
      CALL PHASES(NYMAXX)
C
C=======================================================================
C         PRINTING THE INFORMATION CONCERNING THE CURRENT RUN
C=======================================================================
C
      CALL INFPRI(IN_FIX,IZ_FIX,
     *                   NUMCOU,NUMETA,FURMAX,
     *                   ICOTYP,ICOUDI,ICOUEX,
     *            PIMASS,PNMASS,IYUTYP,I_YUKA,
     *            YUKAGT,YUKAG0,YUKAG1,YUKAG2,
     *                          I_GOGA,IGOGPA,
     *            NUCHAO,NUPING,EPSPNG,EPSITE,
     *                          NOITER,NULAST,
     *            DELFIN,DELFIP,IDEFIN,IDEFIP,
     *            FERFIN,FERFIP,IFEFIN,IFEFIP,
     *            FE2FIN,FE2FIP,IF2FIN,IF2FIP,
     *            INSIGN,IPSIGN,ISSIGN,IDSIGN,
     *            INSIGP,IPSIGP,ISSIGP,IDSIGP,
     *                   INSIMN,IRSIMN,IDSIMN,
     *                   INSIMP,IRSIMP,IDSIMP,
     *                   INSIQN,IPSIQN,IDSIQN,
     *                   INSIQP,IPSIQP,IDSIQP,
     *                          INSIZN,IDSIZN,
     *                          INSIZP,IDSIZP,
     *                          IFIBLN,INIBLN,
     *                          IFIBLP,INIBLP,
     *                          ECUTOF,LIMQUA,
     *            ISPHER,ISIMPY,ISIGNY,ISIQTY,
     *                   ISIMTX,JSIMTY,ISIMTZ,
     *            ISYMDE,INIROT,INIINV,INIKAR,
     *                   IRENMA,IRENIN,IDOGOA,
     *                          JETACM,KETA_R,
     *                   IFRWAV,ITOWAV,IWRWAV,
     *                          ISAKER,ICHKER,
     *                   IPRGCM,IPROMI,IPROMA,
     *                   NUAKNO,NUBKNO,KPROJE,
     *                                 NBTKNO,
     *            ISOSMI,ISOSMA,EPSISO,ICSKIP,
     *                                 IFERME,
     *                   IPAKER,IPAALL,KFIKER,
     *            NUASTA,NUASTO,NUGSTA,NUGSTO,
     *            NUBSTA,NUBSTO,NUTSTA,NUTSTO,
     *                          ISLPRI,ISUPRI,
     *                   IENPRI,ISRPRI,IMIPRI,
     *                          IKEPRI,IRMPRI,
     *                   QMUCUT,QMACUT,QSICUT,
     *            IMOVAX,ITILAX,ITISAX,NO_ORB,
     *                   IPRSTA,IPRMID,IPRSTO,
     *            IDESTA,IDEMID,IDESTO,IDEDIS,
     *                          INTRIP,IVIPRI,
     *                   IPRI_N,IPRI_P,IPRI_T,
     *     IPAIRI,IPAHFB,ITWOBA,JPABCS,IMFHFB,
     *                          LIPKIN,LIPKIP,
     *                                 NILXYZ,
     *                                 IROTAT,
     *                   NMUCON,NMUCOU,NMUPRI,
     *            ISCHIF,NSIMAX,NSICON,NSIPRI,
     *                                 IDOPLM,
     *                   NMAMAX,NMACON,NMAPRI,
     *                   NMURED,NMARED,NSIRED,
     *            SLOWEV,SLOWOD,SLOWPA,SLOWLI,
     *                   ICONTI,IPCONT,IOCONT,
     *            IACONT,IYCONT,IGCONT,IGPCON,
     *            ILCONT,IFCONT,IMCONT,IRCONT,
     *                                 IPOTHO,
     *                   BOUCOU,IFSHEL,IF_RPA,
     *                   L_COLL,M_COLL,N_COLL)
C
C=======================================================================
C         PRINTING THE INFORMATION CONCERNING THE CONFIGURATIONS
C=======================================================================
C
      IF (IPAIRI.NE.1) THEN
C
          IF (ISIMPY.EQ.1) THEN
C
              IF (ISIGNY.EQ.1) THEN
C
                  CALL SIGPRI(ICHFLI,IPAFLI,IREFLI,
     *                        ISPFLI,ISHFLI,IFLIPI)
              ELSE
C
                  CALL SIMPRI(ICHFLI,       IREFLI,
     *                        ISPFLI,ISHFLI,IFLIPI)
              END IF
C
          ELSE
C
              IF (ISIQTY.EQ.1) THEN
C
                  CALL SIQPRI(ICHFLI,IPAFLI,
     *                        ISPFLI,ISHFLI,IFLIPI)
              ELSE
C
                  CALL SIZPRI(ICHFLI,
     *                        ISPFLI,ISHFLI,IFLIPI)
              END IF
C
          END IF
C
      END IF
C
C=======================================================================
C         ZEROING THE HARTREE-FOCK FIELDS
C=======================================================================
C
      DO ITPNMX=0,LDPNMX
         CALL ZEFILD(ITPNMX)
      END DO
C
C=======================================================================
C
C         HERE STARTS THE    H A R T R E E - F O C K   I T E R A T I O N
C
C         T H R E E  DIFFERENT VARIABLES KEEP TRACK  OF  THE  NUMBER  OF
C         ITERATIONS:
C
C         NOITER = THE REQUESTED NUMBER OF THE HARTREE-FOCK  ITERATIONS.
C                  IT CAN BE EQUAL TO ZERO WHEN THE STARTING POINT  IS A
C                  NILSSON OR WOODS-SAXON POTENTIAL. IT CANNOT BE  EQUAL
C                  TO ZERO WHEN THE  CODE  STARTS  FROM  THE  PREVIOUSLY
C                  RECORDED HARTREE-FOCK SOLUTION.
C         NUMITE = THE EFFECTUATED NUMBER OF THE HARTREE-FOCK ITERATIONS
C                  THAT TAKES INTO ACCOUNT ALL THE  PREVIOUSLY  RECORDED
C                  HARTREE-FOCK SOLUTIONS.
C         ITERUN = THE NUMBER OF THE HARTREE-FOCK  ITERATIONS  PERFORMED
C                  IN THE CURRENT RUN.
C
C=======================================================================
C
      ITESTA=0
      ITESTO=NOITER
      IF (NOITER.EQ.0) TERMNT=.TRUE.
C
      IF (ITESTO.LT.ITESTA) STOP 'NO ITERATIONS 1'
C
C=======================================================================
C
      IF (IF_THO.EQ.0) NUMITE=-1
C
C=======================================================================
C      PRINTING OUT INFORMATION ON INFORMATION RECORDED ON DISK
C=======================================================================
C
      CALL RESPRI(IWRIRE,IWRIYU,IWRIFI,IWRIGO,IWRILI,I_YUKA,
     *            I_GOGA,JETACM,KETA_R,LIPKIN,LIPKIP,ICOUDI,
     *                                               ICOUEX)
C
C=======================================================================
C      ALLOCATING  AND ZEROING THE MATRICES OF THE COULOMB, YUKAWA
C      AND GOGNY FIELDS,  AS WELL AS THE DENSITY MATRICES PRIOR TO
C      EXECUTION. RESTART OPTIONS WILL SIMPLY OVERWRITE THESE ZERO
C      MATRICES WITH ACTUAL VALUES READ FROM FILES.
C=======================================================================
C
      CALL ZERCOU(ISIMPY,ICOUDI,ICOUEX)
C
      IF (I_YUKA.GE.2) CALL ZERYUK
C
      IF (LIPKIN.EQ.1.OR.LIPKIP.EQ.1) CALL ZERLIP(ISIMPY)
C
      IF (I_GOGA.GE.2) CALL ZERGOG
C
      IF (IGOGPA.GE.2) CALL ZERGPA
C
C=======================================================================
C     ZEROING THE AVERAGE VALUES AND MEAN FIELDS OF  LINEAR  MOMENTA
C     WHEN THE CALCULATION OF CM CORRECTION BEFORE VARIATION IS  NOT
C     RESTARTED FROM THE DISK
C=======================================================================
C
      IF (JETACM.EQ.2.AND.IMCONT.NE.1) THEN
C
          DO KARTEZ=0,NDKART
             ALINLT(KARTEZ)=0.0D0
          END DO
C
          CALL ZERLIN(IPAIRI,ISIMPY)
C
      END IF
C
C=======================================================================
C               C O N T I N U A T I O N   M O D E S
C=======================================================================
C
      IF (ICONTI.EQ.1) THEN
C
C         INPFLD=1 => THE FILE WITH THE UNIT NUMBER  NFIREP WILL BE
C                     USED TO  R E A D  THE RESULTS OF THE PREVIOUS
C                                                               RUN
          WRITE(NFIPRI,'(79(1H*),/,1H*,77X,1H*,/,
     *            1H*,''  CALLING SUBROUTINE "RECORD" TO READ'',
     *                '' THE REPLAY FILE OBTAINED PREVIOUSLY'',4X,1H*,/,
     *            1H*,2X,A68,                                  7X,1H*)')
     *
     *            FILREP
C
          INPFLD=1
          IERROR=0
          ICCONT=1
C
          CALL RECORD(NFIREP,NFIREC,INPFLD,NUMITE,
     *                       NXHERM,NYHERM,NZHERM,
     *                              IPCONT,ILCONT,
     *                       IACONT,IMCONT,IRCONT,
     *                              IRENMA,IRENIN,
     *                              LIPKIN,LIPKIP,
     *                              REFERN,REFERP,
     *                              REDELN,REDELP,
     *                              REFE2N,REFE2P,
     *                              IFIBLN,INIBLN,
     *                              IFIBLP,INIBLP,
     *                              NMUMAX,NSIMAX,
     *                              NMUCON,ISHIFT,
     *                                     IERROR)
C
          IF (IERROR.NE.0) THEN
C
#if(USE_MPI==1)
C
              IPCONT=0
              IFCONT=0
              IACONT=0
              IYCONT=0
              IGCONT=0
              IGPCON=0
              ILCONT=0
              ICCONT=0
C
              WRITE(NFIPRI,'(
     *              '' ////////////////////////////////////////'',
     *              ''/////////////////////////////////////'',/,
     *              '' ////       WARNING: RECORD FILE IS CORRUPTED'',
     *              '' !                          /////'',/,
     *              '' ////                 - RESTART IS CANCELLED '',
     *              ''                            /////'',/,
     *              '' ////                 - CALCULATIONS WILL RES'',
     *              ''TART FROM SCRATCH           /////'',/,
     *              '' ////////////////////////////////////////'',
     *              ''/////////////////////////////////////'')')
C
#else
              STOP 'RECORD FILE CORRUPTED - STOP HERE'
#endif
C
          END IF
C
C@@@ NECK - NECK - NECK - NECK - NECK - NECK - NECK - NECK - NECK
          IF (IFNECK.GE.1) THEN
C
C              Computing the total density
              CALL TRUTOD(NXHERM,NYHERM,NZHERM)
C
C              We find the position of the neck
              ITEBIS=0
              CALL QNFIND(NXHERM,NYHERM,NZHERM,SLOWOD,ITEBIS,ISIMPY,
     *                                                ISIGNY,IPARTY)
C
          END IF
C@@@ NECK - NECK - NECK - NECK - NECK - NECK - NECK - NECK - NECK
C
#if(USE_MPI==1)
          CALL mpi_pathExploration(IERROR,NMUCON)
#endif
C
          IF (NOITER.EQ.1) TERMNT=.TRUE.
C
          ITESTA=NUMITE + 1
          ITESTO=NUMITE + NOITER
          ITERUN=0
C
          IF (ITESTO.LT.ITESTA) STOP 'NO ITERATIONS 2'
C
C=======================================================================
C         RECALCULATING THE COULOMB MATRIX ELEMENTS FROM THE PROTON
C         DENSITY THAT HAS JUST BEEN  READ  FROM  THE  REPLAY  FILE
C=======================================================================
C
          IF (ICOUDI.EQ.1.AND.ICCONT.EQ.1) THEN
C
              CALL COUMAT(NXHERM,NYHERM,NZHERM,NXMAXX,NYMAXX,NZMAXX,
     *                                  NUMCOU,BOUCOU,ISIMPY,IKERNE)
C
          END IF
C
C=======================================================================
C         RECALCULATING THE TOTAL DENSITY AND  THE  CHARGE  DENSITY
C         FROM NEUTRON AND PROTON DENSITIES  THAT  HAVE  JUST  BEEN
C         READ FROM THE REPLAY FILE
C
C         ATTENTION: IN THE VERSIONS OF THE CODE EARLIER THAN 1.98J,
C                    THE TOTAL DENSITY WAS NOT  RECALCULATED,  WHICH
C                    RESULTED IN INCORRECT  VALUES  OF  THE  PAIRING
C                    ENERGY AND PAIRING REARRANGEMENT ENERGY  (FOR A
C                    DENSITY-DEPENDENT HFB PAIRING ONLY, AND IN  THE
C                    FIRST ITERATION AFTER A RESTART ONLY). THIS BUG
C                    HAD NO EFFECT ON THE CONVERGENCE,  BECAUSE  THE
C                    CORRESPONDING  PAIRING  FIELDS  ARE  CALCULATED
C                    AFTER THE REGULAR CALL TO THE "TRUTOD" ROUTINE.
C=======================================================================
C
          CALL TRUTOD(NXHERM,NYHERM,NZHERM)
C
C=======================================================================
C         RESETTING THE HFB PAIRING PROPERTIES TO THOSE FOUND ON  REPLAY
C         FILE PROVIDED SUCH COURSE OF ACTION IS ALLOWED BY THE RELEVANT
C         DATA PARAMETER "IPCONT". THUS:
C            FOR IPCONT=0 PAIRING PROPERTIES ARE  TAKEN  FROM  THE  DATA
C                         (FROM THE FERINI, DELINI, AND  FE2INI  ARRAYS)
C            FOR IPCONT=1 PAIRING PROPERTIES ARE TAKEN FROM  THE  REPLAY
C                         FILE.
C=======================================================================
C
          IF (IPCONT.EQ.1) THEN
C
              EFERMN=REFERN
              DELTAN=REDELN
              IF (ILCONT.EQ.1) EFER2N=REFE2N
C
              EFENIN=EFERMN
              EFENOU=0.0D0
C
              EFERMP=REFERP
              DELTAP=REDELP
              IF (ILCONT.EQ.1) EFER2P=REFE2P
C
              EFEPIN=EFERMP
              EFEPOU=0.0D0
C
          ELSE
C
              CALL INIPAI(NXHERM,NYHERM,NZHERM,0)
              CALL INIPAI(NXHERM,NYHERM,NZHERM,1)
C
          END IF
C
C=======================================================================
C         RESETTING THE LINEAR CONSTRAINTS  OF  THE  AUGMENTED  LAGRANGE
C         METHOD TO THOSE READ FROM THE RECORD FILE PROVIDED SUCH COURSE
C         OF ACTION IS ALLOWED BY THE RELEVANT DATA PARAMETER "IACONT".
C=======================================================================
C
          IF (IACONT.EQ.1) THEN
C
              DO LAMBDA=0,NDMULT
                 DO MIU=-LAMBDA,LAMBDA
C
                    GALMUQ(LAMBDA,MIU)=RALMUQ(LAMBDA,MIU)
                    GALMUS(LAMBDA,MIU)=RALMUS(LAMBDA,MIU)
C
                 END DO
              END DO
C
C
          END IF
C
C=======================================================================
C         RESETTING THE YUKAWA MEAN FIELDS  TO  THOSE  FOUND  ON  YUKAWA
C         FILE PROVIDED SUCH COURSE OF ACTION IS ALLOWED BY THE RELEVANT
C         DATA PARAMETER "IYCONT". THUS:
C           FOR IYCONT=0 THE YUKAWA MEAN FIELDS ARE SET TO ZERO,
C           FOR IYCONT=1 THE YUKAWA MEAN FIELDS ARE READ FROM THE YUKAWA
C                        FILE.
C=======================================================================
C
          IF (IYCONT.EQ.1) THEN
C
              WRITE(NFIPRI,'(1H*,77X,1H*,/,
     *            1H*,''  CALLING SUBROUTINE "RECYUK" TO READ'',
     *                '' THE YUKAWA FILE OBTAINED PREVIOUSLY'',4X,1H*,/,
     *            1H*,2X,A68,                                  7X,1H*)')
     *
     *            FILYUP
C
              INPYUK=1
C
              CALL RECYUK(NFIYUP,NFIYUC,INPYUK)
C
          END IF
C
C=======================================================================
C         RESETTING THE GOGNY MEAN FIELDS TO THOSE FOUND  ON  THE  GOGNY
C         FILE PROVIDED SUCH COURSE OF ACTION IS ALLOWED BY THE RELEVANT
C         DATA PARAMETER "IGCONT". THUS:
C           FOR IGCONT=0 THE GOGNY MEAN FIELDS ARE SET TO ZERO,
C           FOR IGCONT=1 THE GOGNY MEAN FIELDS ARE READ FROM THE YGOGNY
C                        FILE.
C=======================================================================
C
          IF (IGCONT.EQ.1) THEN
C
              WRITE(NFIPRI,'(1H*,77X,1H*,/,
     *            1H*,''  CALLING SUBROUTINE "RECGOG" TO READ'',
     *                '' THE GOGNY FILE OBTAINED PREVIOUSLY '',4X,1H*,/,
     *            1H*,2X,A68,                                  7X,1H*)')
     *
     *            FILGOP
C
              INPGOG=1
C
              CALL RECGOG(NFIGOP,NFIGOC,INPGOG)
C
              ISGOGA=1
C
          ELSE
C
              ISGOGA=0
C
          END IF
C
C=======================================================================
C         RESETTING THE GOGNY PAIRING FIELD TO THOSE FOUND ON  THE GOGNY
C         FILE PROVIDED SUCH COURSE OF ACTION IS ALLOWED BY THE RELEVANT
C         DATA PARAMETER "IGPCON". THUS:
C           FOR IGPCON=0 THE GOGNY PAIRING FIELDS ARE SET TO ZERO,
C           FOR IGPCON=1 THE GOGNY PAIRING FIELDS ARE READ FROM THE
C                        GOGNY FILE.
C=======================================================================
C
          IF (IGPCON.EQ.1) THEN
C
              WRITE(NFIPRI,'(1H*,77X,1H*,/,
     *            1H*,''  CALLING SUBROUTINE "RECGPA" TO READ'',
     *                '' THE GOGNY FILE OBTAINED PREVIOUSLY '',4X,1H*,/,
     *            1H*,2X,A68,                                  7X,1H*)')
     *
     *            FILGPA
C
              INPGPA=1
C
              CALL RECGPA(NFIGPP,NFIGPC,INPGPA)
C
              ISGOGP=1
C
          ELSE
C
              ISGOGP=0
C
          END IF
C
C=======================================================================
C         RESETTING THE DENSITY MATRICES TO THOSE FOUND ON  THE  LIPKIN
C         FILE PROVIDED SUCH COURSE OF ACTION IS ALLOWED BY THE RELEVANT
C         DATA PARAMETER "ILCONT". THUS:
C           FOR ILCONT=0 THE DENSITY MATRICES ARE SET TO ZERO,
C           FOR ILCONT=1 THE DENSITY MATRICES ARE READ FROM  THE  LIPKIN
C                        FILE.
C=======================================================================
C
          IF (ILCONT.EQ.1) THEN
C
              WRITE(NFIPRI,'(1H*,77X,1H*,/,
     *            1H*,''  CALLING SUBROUTINE "RECLIP" TO READ'',
     *                '' THE LIPKIN FILE OBTAINED PREVIOUSLY'',4X,1H*,/,
     *            1H*,2X,A68,                                  7X,1H*)')
     *
     *            FILLIP
C
              INPLIP=1
C
              CALL RECLIP(NFILIP,NFILIC,INPLIP,ISIMPY)
C
          END IF
C
C=======================================================================
C         ZEROING THE AVERAGE VALUES AND MEAN FIELDS OF  LINEAR  MOMENTA
C         WHEN THE CALCULATION OF CM CORRECTION BEFORE VARIATION IS  NOT
C         RESTARTED FROM THE DISK
C=======================================================================
C
          IF (JETACM.EQ.2.AND.IMCONT.NE.1) THEN
C
              DO KARTEZ=0,NDKART
C
                 ALINLT(KARTEZ)=0.0D0
C
              END DO
C
              CALL ZERLIN(ISIMPY,IPAIRI)
C
          END IF
C
C=======================================================================
C         ZEROING THE AVERAGE VALUES AND MEAN FIELDS OF ANGULAR  MOMENTA
C         WHEN THE CALCULATION OF ROT CORRECTION BEFORE VARIATION IS NOT
C         RESTARTED FROM THE DISK
C=======================================================================
C
          IF (KETA_R.EQ.2.AND.IRCONT.NE.1) THEN
C
              DO KARTEZ=0,NDKART
C
                 AROTLT(KARTEZ)=0.0D0
C
              END DO
C
              CALL ZERROT(ISIMPY,IPAIRI)
C
          END IF
C
C=======================================================================
C         READING THE FIELDS FROM THE FIELD FILE
C=======================================================================
C
          IF (IFCONT.EQ.1.AND.IF_THO.EQ.0) THEN
C
              WRITE(NFIPRI,'(1H*,77X,1H*,/,
     *            1H*,''  CALLING SUBROUTINE "RECFIL" TO READ'',
     *                '' THE FIELDS FILE OBTAINED PREVIOUSLY'',4X,1H*,/,
     *            1H*,2X,A68,                                  7X,1H*)')
     *
     *            FILFIP
C
              INPFIL=1
C
              CALL RECFIL(NFIFIP,NFIFIC,INPFIL,ISIMPY,IPAHFB,
     *                                         NOSCIL,NUMITE,
     *                           EFERMN,EFERMP,EFER2N,EFER2P,
     *                           DELTAN,DELTAP,FCHOM0,IF_THO,
     *                                         NLIMIT,FILTHO)
C
          ELSE
C
              ISGOGA=0
C
          END IF
C
          WRITE(NFIPRI,'(1H*,77X,1H*,/,79(1H*),/)')
C
      END IF
C
C@@@ HFBTHO -HFBTHO - HFBTHO - HFBTHO - HFBTHO - HFBTHO - HFBTHO
C=======================================================================
C         READING THE FIELDS FROM THE FIELD FILE
C=======================================================================
C
      IF (IF_THO.GE.1) THEN
C
          WRITE(NFIPRI,'(79(''*''),/,''*'',77X,''*'',/,
     *          ''*  CALLING SUBROUTINE  CYLCAR  TO TRANSFORM '',
     *          ''THE HFB MATRIX READ FROM HFBTHO   *'',/,
     *          ''*  INTO THE CARTESIAN BASIS USED IN HFODD.'',
     *          36X,''*'')')
C
          CALL CYLCAR(NOSCIL,ISIMPY,IF_THO)
C
          ITESTA=NUMITE+1
C
          WRITE(NFIPRI,'(''*'',77X,''*'',/,79(''*''),/)')
C
      END IF
C
C@@@ HFBTHO -HFBTHO - HFBTHO - HFBTHO - HFBTHO - HFBTHO - HFBTHO
C=======================================================================
#if(USE_MPI==1)
      IF (IF_THO.EQ.0.AND.batch_mode.EQ.1) THEN
          CALL batch(NFIREP,NFIREC,NUDATA,FILREP,FILREC,IF_THO,
     *                      NXHERM,NYHERM,NZHERM,IRENMA,IRENIN,
     *               REFERN,REFERP,REDELN,REDELP,REFE2N,REFE2P,
     *               IFIBLN,INIBLN,IFIBLP,INIBLP,NMUMAX,NSIMAX,
     *                                           NMUCON,ISHIFT,
     *               ICONTI,IPCONT,ILCONT,IACONT,IGCONT,IGPCON,
     *                                           IMCONT,IRCONT,
     *               IPAIRI,LIPKIN,LIPKIP,I_GOGA,IGOGPA,I_YUKA,
     *                                           JETACM,KETA_R,
     *               Q_NECK,QACTUA,QORIGI,QINCRE,INDJOB,batch_init)
      END IF
#endif
C
      EF2NIN=EFER2N
      EF2NOU=EFER2N
C
      EF2PIN=EFER2P
      EF2POU=EFER2P
C
C=======================================================================
C=======================================================================
C=======================================================================
C
C         HERE WE ENTER ANY NEW ITERATION OF THE HARTREE-FOCK:
C
C=======================================================================
C=======================================================================
C=======================================================================
C
   1  NUMITE=NUMITE+1
      ITERUN=ITERUN+1
C
C      If extra constraints are used to push the iterations in a
C      certain direction, thee constraints are released after NITPUS
C      iterations. We set the corresponding flag to 0 and re-define
C      the actual constraints
C
      IF (IFPUSH.EQ.1.AND.IREAWS.EQ.0.AND.ITERUN.GT.NITPUS) THEN
C
          DOPUSH = .FALSE.
          CALL NUMCON(LAMPUS,MIUPUS,QMOPUS,NUMPUS,IF_RPA,IFPUSH,
     *                                                   DOPUSH)
C
      END IF
C
      IF (ITERUN.GT.NDITER) THEN
C
          WRITE(NFIPRI,'(/,1X,20(1H/),
     *                '' ALLOWED NUMBER OF ITERATIONS '',5X,20(1H/),/,
     *                1X,20(1H/),'' NDITER='',I5,'' EXCEEDED'',
     *                                 15X,20(1H/),/)') NDITER
C
          STOP 'ITERUN.GT.NDITER IN MAIN'
C
      END IF
C
C=======================================================================
C         RESETTING  THE PARAMETERS THAT  HANDLE  THE  ANGULAR-MOMENTUM
C         PROJECTION AND CALCULATION OF THE GCM KERNELS FOR THE CURRENT
C         ITERATION
C=======================================================================
C
      ISAWAV=0
      IF (IPRGCM.GE.1.OR.IRENMA.GE.1.OR.IRENIN.GE.1) ISAWAV=1
      IKERNE=0
C
C=======================================================================
C         HERE WE DEFINE THE LOGICAL SWITCH "PRINIT" THAT DECIDES  ON
C         WHETHER OR NOT THE RESULTS OF THE CURRENT ITERATION WILL BE
C         PRINTED
C=======================================================================
C
      IF ((NUMITE.EQ.ITESTA                     .AND.IPRSTA.EQ.1).OR.
     *    (NUMITE.GT.ITESTA.AND.NUMITE.LT.ITESTO.AND.IPRMID.EQ.1).OR.
     *   ((NUMITE.EQ.ITESTO.OR.TERMNT)          .AND.IPRSTO.EQ.1)) THEN
C
           PRINIT=.TRUE.
      ELSE
           PRINIT=.FALSE.
      END IF
C
C=======================================================================
C         HERE WE DEFINE SWITCHES "ISABLN" AND "ISABLP"  THAT  DECIDE
C         ON WHETHER OR NOT THE SINGLE-PARTICLE STATES  USED  IN  THE
C         QUASIPARTICLE BLOCKING WILL BE SAVED IN THE FIRST ITERATION
C=======================================================================
C
                                                       ISABLN=0
      IF (IFIBLN.EQ.1.AND.INIBLN.EQ.1.AND.ITERUN.EQ.1) ISABLN=1
                                                       ISABLP=0
      IF (IFIBLP.EQ.1.AND.INIBLP.EQ.1.AND.ITERUN.EQ.1) ISABLP=1
C
C=======================================================================
C         HERE WE DEFINE THE LOGICAL SWITCH "PRIYUK" THAT DECIDES  ON
C         WHETHER OR NOT THE TIME-REVERSAL-VIOLATING MATRIX  ELEMENTS
C         OF THE YUKAWA POTENTIAL WILL BE PRINTED.  NOTE  THAT  THESE
C         MATRIX ELEMENTS CAN ONLY BE CALCULATED ONCE THE YUKAWA MEAN
C         FIELD IS KNOWN FOR THE "DIV S" SOURCE DENSITY.  SINCE  THIS
C         DENSITY IS CALCULATED IN THE PREVIOUS ITERATION, THE MATRIX
C         ELEMENTS IN  QUESTION  C A N N O T  BE  CALCULATED  IN  THE
C         F I R S T  ITERATION OF THE CURRENT RUN.
C=======================================================================
C
      PRIYUK=PRINIT.AND.I_YUKA.GE.1.AND.ITERUN.GT.1
C
C=======================================================================
C         HERE WE DEFINE THE LOGICAL SWITCH  "PRIBET"  THAT  DECIDES  ON
C         WHETHER OR NOT THE BOHR DEFORMATION PARAMETERS WILL BE PRINTED
C=======================================================================
C
      PRIBET=PRINIT.AND.(IPRIBE.EQ.1.OR.IPRIBL.EQ.1)
C
C=======================================================================
C         HERE WE DEFINE THE INTEGER VARIABLES THAT DECIDE ON HOW  MANY
C         MULTIPOLE, SURFACE OR SCHIFF, AND MAGNETIC MOMENTS IN ONE  OF
C         THE REFERENCE FRAMES HAVE TO BE  CALCULATED  IN  THE  CURRENT
C         ITERATION. THE NAMING CONVENTION IS AS FOLLOWS:
C
C         KXXXYY DENOTES THE NUMBER OF "YY" MOMENTS IN THE "XXX" FRAME,
C                WHERE YY AND XXX READ:
C
C         XXX = MUL  -->  LABORATORY FRAME
C         XXX = SHI  -->  C-O-M FRAME
C         XXX = ROT  -->  INTRINSIC FRAME
C
C         YY  = MO   -->  MULTIPOLE MOMENTS
C         YY  = SI   -->  SURFACE OR SCHIFF MOMENTS
C         YY  = MA   -->  MAGNETIC MOMENTS
C
C         THE NUMBERS OF MULTIPOLE, SURFACE  OR  SCHIFF,  AND  MAGNETIC
C         MOMENTS ARE SET  INDEPENDENTLY  FROM  ONE  ANOTHER,  HOWEVER,
C         FOR ISCHIF=1 THE NUMBER OF SCHIFF MOMENTS MUST NOT BE SMALLER
C         THAN THAT OF THE MULTIPOLE MOMENTS, THAT IS, KMULMO >= KMULSI
C
C         SINCE ALL THE MOMENTS IN THE INTRINSIC FRAME  ARE  CALCULATED
C         IN THE C-O-M FRAME, THE NUMBERS THEREOF MUST OBEY:
C         KMULMO >= KSHIMO >= KROTMO
C         KMULSI >= KSHISI >= KROTSI
C         KMULMA >= KSHIMA >= KROTMA
C=======================================================================
C
                  KROTMO=2
      IF (PRINIT) KROTMO=MAX(KROTMO,NMUPRI)
      IF (TERMNT) KROTMO=MAX(KROTMO,NMUMAX)
C
                  KSHIMO=KROTMO
C
                  KMULMO=KSHIMO
                  KMULMO=MAX(KMULMO,NMUCON)
                  KMULMO=MAX(KMULMO,NMUCOU)
C
                  KROTSI=0
      IF (PRINIT) KROTSI=MAX(KROTSI,NSIPRI)
      IF (TERMNT) KROTSI=MAX(KROTSI,NSIMAX)
C
                  KSHISI=KROTSI
C
                  KMULSI=KSHISI
                  KMULSI=MAX(KMULSI,NSICON)
C
      IF (ISCHIF.EQ.1) KMULMO=MAX(KMULMO,KMULSI)
C
                  KROTMA=0
      IF (PRINIT) KROTMA=MAX(KROTMA,NMAPRI)
      IF (TERMNT) KROTMA=MAX(KROTMA,NMAMAX)
C
                  KSHIMA=KROTMA
C
                  KMULMA=KSHIMA
                  KMULMA=MAX(KMULMA,NMACON)
C
C=======================================================================
C         HERE WE DEFINE THE LOGICAL SWITCH "COR_CM" THAT DECIDES ON
C         WHETHER OR NOT THE QUADRATIC CORRECTION FOR THE CENTER  OF
C         MASS MOTION WILL BE CALCULATED IN THE  CURRENT  ITERATION.
C         SINCE SUCH A CALCULATION IS FAIRLY TIME CONSUMING,  IT  IS
C         PERFORMED ONLY WHEN NECESSARY. FOR EXAMPLE, WHEN THE C-O-M
C         CORRECTION NEEDS TO BE ADDED ONLY AFTER THE VARIATION,  IT
C         IS CALCULATED ONLY IN THE LAST ITERATION. ATTENTION:  SUCH
C         A PROCEDURE RESULTS IN THE TOTAL ENERGY BEING DIFFERENT IN
C         THE LAST BUT ONE AND LAST ITERATIONS.
C=======================================================================
C
      COR_CM=(JETACM.EQ.1.AND.(PRINIT.OR.TERMNT)).OR.
     *        JETACM.EQ.2
C
C=======================================================================
C         SAME AS ABOVE FOR THE LOGICAL SWITCH "CORROT" THAT DECIDES
C         ON THE QUADRATIC CORRECTION FOR THE ROTATIONAL MOTION.
C=======================================================================
C
      CORROT=(KETA_R.EQ.1.AND.(PRINIT.OR.TERMNT)).OR.
     *        KETA_R.EQ.2
C
C=======================================================================
C         HERE WE SET PARAMETER  "IDEVAR"  WHICH REQUESTS CALCULATION OF
C         THE PAIRING MATRIX ELEMENTS IN THE CURRENT ITERATION.
C         THE TRICK WITH IDEAUX IS USED ONLY FOR THE PURPOSE OF AVOIDING
C         DIVISION BY 0 WITHIN MOD(NUMITE,IDEAUX) FOR IDEDIS=0
C=======================================================================
C
      IDEAUX=IDEDIS
      IF (IDEDIS.LT.1) IDEAUX=1
C
      IF (JPABCS.EQ.3.AND.
     *   ((NUMITE.EQ.ITESTA.AND.                     IDESTA.EQ.1).OR.
     *    (NUMITE.GT.ITESTA.AND.NUMITE.LT.ITESTO.AND.IDEMID.EQ.1).OR.
     *   ((NUMITE.EQ.ITESTO.OR.TERMNT)          .AND.IDESTO.EQ.1).OR.
     *    (MOD(NUMITE,IDEAUX).EQ.0              .AND.IDEDIS.GE.1))) THEN
C
           IDEVAR=1
      ELSE
           IDEVAR=0
C
      END IF
C
C=======================================================================
C        SAVING THE SINGLE-PARTICLE DATA THAT HAVE BEEN OBTAINED
C        IN THE PREVIOUS ITERATION
C=======================================================================
C
      IF (ITERUN.GT.1) CALL OLSTOR
C
C=======================================================================
C         ZEROING THE SINGLE-PARTICLE MATRICES
C=======================================================================
C
      CALL SPZERO
C
C=======================================================================
C         FOR IN_FIX=0 WE DO NOT PERFORM ANY CALCULATIONS FOR NEUTRONS
C=======================================================================
C
      IF (IN_FIX.EQ.0) GO TO 8970
C
C=======================================================================
C         HERE STARTS THE BLOCK FOR  N E U T R O N S
C=======================================================================
C
      NAMEPN='NEUTRONS'
C
      ICHARG=0
      ITPNMX=0
C
C=======================================================================
C        CALCULATING THE MATRIX ELEMENTS OF THE NEUTRON MEAN FIELD
C=======================================================================
C
      IF (NUMITE.GT.0) THEN
C
          IF (NUMITE.GT.ITESTA.OR.(IFCONT.NE.1.AND.IF_THO.EQ.0)) THEN
C
              CALL INTEGH(NXHERM,NYHERM,NZHERM,NXMAXX,NYMAXX,NZMAXX,
     *                                  IMOVAX,ITILAX,ITISAX,NO_ORB,
     *                           IPNMIX,ITPNMX,IROTAT,ICHARG,ISIMPY,
     *                                         IPOTHO,ISCHIF,IOCONT,
     *                                                NMUCON,NSICON,
     *                                                I_YUKA,I_GOGA,
     *                                                JETACM,ALINLT,
     *                                                KETA_R,AROTLT,
     *                                                ICOUDI,ICOUEX,
     *                                                LIPKIN,LIPKIP,
     *                                                EFER2N,EFER2P,
     *                                                       IF_RPA)
C
          ELSE
C
              CALL GETFIL(ISIMPY,ICHARG)
C
          END IF
C
          SPMODL='HARTREE-FOCK  '
C
C=======================================================================
C        CALCULATING THE MATRIX ELEMENTS OF THE NEUTRON PAIRING FIELD
C=======================================================================
C
          IF (IPAHFB.EQ.1) THEN
C
              IF (NUMITE.GT.ITESTA.OR.(IFCONT.NE.1.AND.IF_THO.EQ.0))
     *        THEN
C
                  CALL INTEGD(NXHERM,NYHERM,NZHERM,NXMAXX,NYMAXX,NZMAXX,
     *                                      ITPNMX,IROTAT,ISIMPY,ICHARG,
     *                                      DELFIN,DELFIP,IDEFIN,IDEFIP,
     *                                      JETACM,KETA_R,IGOGPA,ITERUN)
C
              ELSE
C
                  CALL GETPAI(ICHARG)
C
              END IF
C
              IF (IMFHFB.EQ.1) THEN
C
                  SPMODL='HFB MEAN FIELD'
              ELSE
                  SPMODL='CANONICAL     '
C
              END IF
C
          END IF
C
      ELSE
C
C=======================================================================
C        INITIALIZING THE MATRIX ELEMENTS OF THE NEUTRON MEAN FIELD
C=======================================================================
C
          IF (IREAWS.EQ.1) THEN
C
              CALL WSHAMI(NXMAXX,NYMAXX,NZMAXX,ITILAX,ITISAX,NO_ORB,
     *                                                ICHARG,ISIMPY)
C
              SPMODL='WOODS-SAXON   '
C
          ELSE
C
              CALL NILSON(NXMAXX,NYMAXX,NZMAXX,ITILAX,ITISAX,NO_ORB,
     *                                                INNUMB,IZNUMB,
     *                                                ICHARG,NAMEPN,
     *                                                HOMEGA,ISIMPY)
C
              SPMODL='NILSSON       '
C
          END IF
C
C=======================================================================
C        INITIALIZING THE MATRIX ELEMENTS OF THE NEUTRON PAIRING FIELD
C=======================================================================
C
          IF (IPAHFB.EQ.1) THEN
C
              CALL INIPAI(NXHERM,NYHERM,NZHERM,ITPNMX)
C
              IF (JETACM.EQ.2) CALL ZERLIN(ISIMPY,IPAIRI)
              IF (KETA_R.EQ.2) CALL ZERROT(ISIMPY,IPAIRI)
C
              CALL INTEGD(NXHERM,NYHERM,NZHERM,NXMAXX,NYMAXX,NZMAXX,
     *                                  ITPNMX,IROTAT,ISIMPY,ICHARG,
     *                                  DELFIN,DELFIP,IDEFIN,IDEFIP,
     *                                  JETACM,KETA_R,IGOGPA,ITERUN)
C
          END IF
C
      END IF
C
C=======================================================================
C        MIXING OF THE MATRIX ELEMENTS OF THE HFB MATRIX. USUAL LINEAR
C        MIXING IS HANDLED BY THE ROUTINE DOBROY_MATRIX(), THE BROYDEN
C        CORRECTION BEING SIMPLY NOT ADDED
C=======================================================================
C
      IF (MIXMAT.EQ.1) THEN
C
          IF (ITERUN.GT.1) THEN
C
              CALL HPH_IN(ISIMPY,MREVER,ICHARG,NUMITE,INDJOB)
              IF (IPAHFB.EQ.1) CALL DEL_IN(MREVER,IROTAT,ICHARG,
     *                                            NUMITE,INDJOB)
C
C              Evolving the Broyden and affecting the ouput
C
              CALL DOBROY_MATRIX(ITERUN,NSWBRN,ITAK_N,
     *                           NOICAN,SLOWEV,ESTABN,
     *                           EFERMN,EFENIN,EFENOU,
     *                           EFER2N,EF2NIN,EF2NOU,
     *                           LIPKIN,NOFBRN,ICHARG,
     *                                         IPAHFB)
C
              CALL HPH_OU(ISIMPY,MREVER,ICHARG)
              CALL GETFIL(ISIMPY,ICHARG)
C
              IF (IPAHFB.EQ.1) THEN
                  CALL DEL_OU(MREVER,IROTAT,ICHARG)
                  CALL GETPAI(ICHARG)
              END IF
C
          ELSE
              CALL SAVFIL(ISIMPY,IPAHFB,ICHARG)
          END IF
C
      END IF
C
C=======================================================================
C        SAVING  THE   N E U T R O N   MEAN FIELDS
C=======================================================================
C
      IF (IWRIFI.NE.-1.AND.MIXMAT.EQ.0)
     *    CALL SAVFIL(ISIMPY,IPAHFB,ICHARG)
C
C=======================================================================
C        DIAGONALIZING THE MATRIX OF THE NEUTRON   H F B   HAMILTONIAN
C=======================================================================
C
      IF (IPAHFB.EQ.1) THEN
C
          IF (ISIMPY.EQ.1) THEN
C
              IF (ISIGNY.EQ.1) THEN
C
                  IF (ITWOBA.EQ.1) STOP ' TWO BASIS NOT IMPLEMENTED YET'
C
                  CALL HFBSIG(EFERMN,ECUTOF,LIMQUA,ICHARG,IMFHFB,
     *                               INSIGN,IPSIGN,ISSIGN,IDSIGN,
     *                                             IFIBLN,ISABLN,
     *                               IREQPB,INUQPB,JNUQPB,IF_RPA)
C
              ELSE
C
                  IF (ITWOBA.EQ.1) STOP ' TWO BASIS NOT IMPLEMENTED YET'
C
                  CALL HFBSIM(EFERMN,ECUTOF,LIMQUA,ICHARG,IMFHFB,
     *                                      INSIMN,IRSIMN,IDSIMN,
     *                                             IFIBLN,ISABLN,
     *                               IREQPB,INUQPB,JNUQPB,IF_RPA)
C
              END IF
C
          ELSE
C
              IF (ISIQTY.EQ.1) THEN
C
                  IF (ITWOBA.EQ.1) STOP ' TWO BASIS NOT IMPLEMENTED YET'
C
                  CALL HFBSIQ(EFERMN,ECUTOF,LIMQUA,ICHARG,IMFHFB,
     *                                      INSIQN,IPSIQN,IDSIQN,
     *                                             IFIBLN,ISABLN,
     *                                      IREQPB,INUQPB,JNUQPB)
C
              ELSE
C
#if(USE_SCALAPACK==1)
		  CALL HFBSIZ_sl(EFERMN,ECUTOF,LIMQUA,ITWOBA,ICHARG,
     *                                         IMFHFB,INSIZN,IDSIZN,
     *                                                IFIBLN,ISABLN,
     *                                         IREQPB,INUQPB,JNUQPB)
#else
                  CALL HFBSIZ(EFERMN,ECUTOF,LIMQUA,ITWOBA,ICHARG,
     *                                      IMFHFB,INSIZN,IDSIZN,
     *                                             IFIBLN,ISABLN,
     *                                      IREQPB,INUQPB,JNUQPB)
#endif
C
              END IF
C
          END IF
#if(USE_MPI==1)
          IF (escapeSignal.Eq.1) THEN
C
              WRITE(6,'(''Process '',i6,
     *                  '' - HFBSIM failed for neutrons. '',
     *                  ''Closing all files and exiting...'')')
     *                    WorldRank
C
              ! Properly close all files that could have been left
              ! opened (with the exclusion of the output unit NFIPRI)
              CALL IOCLOS(NFIWOO,NFIREP,NFIREV,NFIREC,NFICOU,NFIWAV,
     *                    NFIKER,NFIYUP,NFIYUC,NFIGOC,NFIGOP,NFIGPC,
     *                    NFIGPP,NFILIP,NFILIC,NFIFIP,NFIFIC,NFIISO)
C
              EXIT procLoop
C
          END IF
#endif
C
          EFENIN=EFERMN
          IF (do_debug) Write(NFIPRI,'(''(in) EFERMN = '',f20.14)')
     *                                EFERMN
C
          CALL QUABCS(EFERMN,XINFIX,FERFIN,IFEFIN,ICHARG,
     *                       IDSIGN,IDSIMN,IDSIQN,IDSIZN,
     *                              IREQPB,INUQPB,JNUQPB)
          IF (do_debug) Write(NFIPRI,'(''(out) EFERMN = '',f20.14)')
     *                                EFERMN
C
#if(USE_MPI==1)
          IF (escapeSignal.Eq.1) THEN
C
              WRITE(6,'(''Process '',i6,
     *                  '' - QUABCS failed for neutrons. '',
     *                  ''Closing all files and exiting...'')')
     *                    WorldRank
C
              ! Properly close all files that could have been left
              ! opened (with the exclusion of the output unit NFIPRI)
              CALL IOCLOS(NFIWOO,NFIREP,NFIREV,NFIREC,NFICOU,NFIWAV,
     *                    NFIKER,NFIYUP,NFIYUC,NFIGOC,NFIGOP,NFIGPC,
     *                    NFIGPP,NFILIP,NFILIC,NFIFIP,NFIFIC,NFIISO)
C
              EXIT procLoop
C
          END IF
#endif
C
          EFENOU=EFERMN
C
          IF (PRINIT) CALL SPTQUA(EMAXQU,ICHARG,NAMEPN,
     *                            ISIGNY,ISIMPY,ISIQTY,
     *                     IDSIGN,IDSIMN,IDSIQN,IDSIZN,
     *                            IREQPB,INUQPB,JNUQPB)
C
      END IF
C
C=======================================================================
C        DIAGONALIZING THE MATRIX OF THE   N E U T R O N   MEAN FIELD
C=======================================================================
C
      IF (IPAHFB.EQ.1) THEN
C
          IF (ISIMPY.EQ.1) THEN
C
              CALL CANQUA(MREVER,ICHARG,IMFHFB,ESUM_N)
C
          ELSE
C
              CALL CANQUZ(ICHARG,IMFHFB,ESUM_N)
C
          END IF
C
      ELSE
C
          IF (ISIMPY.EQ.1) THEN
C
              IF (ISIGNY.EQ.1) THEN
C
                  CALL DIASIG(MREVER,ICHARG)
C
              ELSE
C
                  CALL DIASIM(MREVER,ICHARG)
C
              END IF
C
          ELSE
C
              IF (ISIQTY.EQ.1) THEN
C
                  CALL DIASIQ(ICHARG)
C
              ELSE
C
                  LIMPAR=0
C
                  CALL DIASIZ(ICHARG,LIMPAR,ECUTOF,LDMEFI)
C
              END IF
C
          END IF
C
      END IF
C
C=======================================================================
C        CALCULATING VARIOUS SINGLE-PARTICLE AVERAGES FOR NEUTRONS
C=======================================================================
C=======================================================================
C        THESE CALLS TO SUBROUTINES CALCULATING VARIOUS SINGLE-PARTICLE
C        AVERAGES ARE PERFORMED ONLY WHEN IT IS  ABSOLUTELY  NECESSARY:
C                              1. FOR THE DIABATIC BLOCKING CALCULATION
C                              2. WHEN THE PING-PONG  HAS BEEN DETECTED
C                              3. WHEN THE DIVERGENCE HAS BEEN DETECTED
C                              4. IN THE LAST ITERATION (TERMNT=.TRUE.)
C                              5. TO PRINT THE RESULTS  (PRINIT=.TRUE.)
C=======================================================================
C
      IF((ISIMPY.EQ.1.AND.IFLIPI.NE.0.AND.ICHFLI.EQ.ICHARG)         .OR.
     *
     *   (ISIMPY.EQ.1.AND.ISIGNY.EQ.1.AND.(NOFLIG(0,0,ICHARG).NE.0  .OR.
     *                                     NOFLIG(0,1,ICHARG).NE.0  .OR.
     *                                     NOFLIG(1,0,ICHARG).NE.0  .OR.
     *                                     NOFLIG(1,1,ICHARG).NE.0)).OR.
     *
     *   (ISIMPY.EQ.1.AND.ISIGNY.NE.1.AND.(NOFLIM(  0,ICHARG).NE.0  .OR.
     *                                     NOFLIM(  1,ICHARG).NE.0)).OR.
     *
     *   (ISIMPY.NE.1.AND.ISIQTY.EQ.1.AND.(NOFLIQ(  0,ICHARG).NE.0  .OR.
     *                                     NOFLIQ(  1,ICHARG).NE.0)).OR.
     *
     *   (ISIMPY.NE.1.AND.ISIQTY.NE.1.AND.(NOFLIZ(    ICHARG).NE.0)).OR.
     *
     *    IS_PIN.EQ.1                                               .OR.
     *
     *    IS_CHA.EQ.1                                               .OR.
     *
     *    TERMNT                                                    .OR.
     *
     *    PRINIT)                                                   THEN
C
          CALL AVANGY(NXMAXX,NYMAXX,NZMAXX,MREVER,ICHARG,ISIMPY)
C
          CALL AVOBSE(MREVER,ICHARG)
C
      END IF
C
C=======================================================================
C        CALCULATING AND PRINTING SINGLE-PARTICLE AVERAGES FOR NEUTRONS
C=======================================================================
C
      CALL AVPARI(MREVER,ICHARG)
C
      IF (TERMNT.OR.PRINIT) THEN
C
          CALL AVSIMP(MREVER,ICHARG)
C
          CALL NILABS(NOSCIL,MREVER,ICHARG,ISIMPY,NILXYZ)
C
      END IF
C
      IF (PRINIT) THEN
C
          CALL SPTALL(EMINAL,EMAXAL,SPMODL,NAMEPN,
     *                       ISIGNY,ISIMPY,ISIQTY,
     *                       MREVER,ICHARG,NILXYZ)
C
      END IF
C
C=======================================================================
C        CALCULATING THE NEUTRON PAIRING AND DEFINING OCCUPATION FACTORS
C=======================================================================
C
      EPAI_N=0.0
      EREA_N=0.0
C
      IF (IPAIRI.EQ.1) THEN
C
          IF (JPABCS.GT.0) THEN
C
              IF (JPABCS.EQ.1.OR.
     *           (JPABCS.EQ.3.AND.ITERUN.EQ.1))  THEN
C
                  IF (IAVRGG.NE.1) THEN
C
                      CALL SETPAI(IN_FIX,IZ_FIX,FACTGN,ICHARG,GPAIRN)
C
                  ELSE
C
                      CALL GAVRAG(IN_FIX,IZ_FIX,FACTGN,ICHARG,GPAIRN)
C
                  END IF
C
              END IF
C
              EFENIN=EFERMN
              CALL DELPAI (ICHARG,MREVER,JPABCS,IN_FIX,ITERUN,
     *                     DELFIN,GPAIRN,EPAI_N,EFERMN,DELTAN)
              EFENOU=EFERMN
C
              IF (PRINIT)
     *
     *            CALL PAIPRI(NAMEPN,GPAIRN,EPAI_N,EFERMN,DELTAN,
     *                                      LIPKIN,EFER2N,ELIP_N,
     *                                      IPAHFB,JPABCS,IAVRGG)
C
          END IF
C
      ELSE
C
          IF (ISIMPY.EQ.1) THEN
C
              IF (ISIGNY.EQ.1) THEN
C
                  CALL CONSIG(MREVER,ICHARG,IN_FIX,EFERMN,
     *                               ICHFLI,IPAFLI,IREFLI,
     *                               ISPFLI,ISHFLI,IFLIPI)
              ELSE
C
                  CALL CONSIM(MREVER,ICHARG,IN_FIX,EFERMN,
     *                               ICHFLI,       IREFLI,
     *                               ISPFLI,ISHFLI,IFLIPI)
C
              END IF
C
          ELSE
C
              IF (ISIQTY.EQ.1) THEN
C
                  CALL CONSIQ(ICHARG,IN_FIX,EFERMN,
     *                        ICHFLI,IPAFLI,
     *                        ISPFLI,ISHFLI,IFLIPI)
              ELSE
C
                  CALL CONSIZ(ICHARG,IN_FIX,EFERMN,
     *                        ICHFLI,
     *                        ISPFLI,ISHFLI,IFLIPI)
C
              END IF
C
          END IF
C
          DELTAN=0.0D0
C
      END IF
C
C=======================================================================
C        CALCULATING THE SUM OF NEUTRON SINGLE-PARTICLE ENERGIES
C=======================================================================
C
      IF (IPAHFB.NE.1)
     *
     *    CALL SPENSU(MREVER,ESUM_N,ICHARG,ISIMPY)
C
C=======================================================================
C        ZEROING THE NEUTRON DENSITIES
C=======================================================================
C
      CALL ZEDENS(ICHARG)
C
C=======================================================================
C        CALCULATING THE NEUTRON DENSITIES AND CURRENTS
C=======================================================================
C
      CALL DENSHF(NXHERM,NYHERM,NZHERM,ISIMTX,JSIMTY,ISIMTZ,
     *            ISIGNY,ISIMPY,ISIQTY,IPAHFB,MREVER,ICHARG,
     *            ICOUDI,ICOUEX,I_YUKA,I_GOGA,IGOGPA,
     *                                        IPNMIX,ITPNMX,
     *            ITIREP,NXMAXX,NAMEPN,PRINIT,IDEVAR,ITERUN,
     *            ISYMDE,INIROT,INIINV,INIKAR,ISAWAV,IKERNE)
C
C=======================================================================
C        DOUBLING THE SINGLE-PARTICLE RESULTS IN CASE OF NO ROTATION
C=======================================================================
C
      IF (MREVER.EQ.0) THEN

          CALL DBLING(ITPNMX,NXHERM,NYHERM,NZHERM,ESUM_N)
C
      END IF
C
C@@@ HFBTHO -HFBTHO - HFBTHO - HFBTHO - HFBTHO - HFBTHO - HFBTHO
C=======================================================================
C        BY DEFAULT,  HFODD  INITIALIZES THE  MATRIX OF THE  MEAN-FIELD
C        BY  COMPUTING THE  MATRIX ELEMENTS  OF THE  NILSON  POTENTIAL.
C        IN  HFB  MODE IT  INITIALIZES  THE MATRIX OF THE PAIRING FIELD
C        BY COMPUTING THE MATRIX ELEMENTS OF THE  DELTA-PAIRING  INTER-
C        ACTION, WHICH DEPENDS ON THE ISO-SCALAR DENSITY, AND THEREFORE
C        ON BOTH PROTON AND NEUTRON DENSITIES ON THE GAUSS-HERMITE MESH.
C        WHEN RESTARTING FROM HFBTHO, THESE DENSITIES ARE NOT AVAILABLE:
C        THE COMPUTATION OF  ALL  PAIRING OBSERVABLES MUST THEREFORE BE
C        SHIFTED TO  AFTER  THE NEW ISOSCALAR DENSITY HAS BEEN COMPUTED.
C        THIS ONLY AFFECTS THE  FIRST ITERATION, SEE ALSO COMMENT ABOUT
C        NUMITE BELOW.
C=======================================================================
C
      IF (IF_THO.EQ.0.OR.ITERUN.NE.1) THEN
C
C=======================================================================
C        CALCULATING THE NEUTRON HFB PAIRING ENERGY AND AVERAGE DELTA
C=======================================================================
C
          IF (IPAHFB.EQ.1)
     *
     *        CALL EPAIRI(NXHERM,NYHERM,NZHERM,IN_FIX,IZ_FIX,ITPNMX,
     *                                                       XINFIX)
C
C=======================================================================
C        CALCULATING THE NEUTRON LIPKIN-NOGAMI CORRECTION
C=======================================================================
C        WHEN STARTING FROM SCRATCH, THE CODE INITALIZES THE PH AND PP
C        CHANNELS  AT  NUMITE = 0. WHEN  RESTARTING FROM  HFBTHO, THIS
C        INITIALIZATION  MUST BE  SKIPPED,  WHICH IS  DONE BY  SETTING
C        NUMITE = 1. HOWEVER, TO  ENSURE  A  SMOOTH  RESTART OF THE LN
C        LAMBDA_2 PARAMETER,  ONE MUST DO 'AS IF' WE WERE AT THE FIRST
C        ITERATION, HENCE THE TRICK BELOW.
C=======================================================================
C
                           NACTIT=NUMITE
          IF (IF_THO.GE.1) NACTIT=NUMITE-2
C
          IF (LIPKIN.EQ.1) THEN
              EF2NIN=EFER2N
              CALL LIPCOR(GPAIRN,FACTGN,FE2FIN,IF2FIN,SLOWLI,
     *                                  EFER2N,ELIP_N,NACTIT,
     *                                  EFERMN,DELTAN,ICHARG)
              EF2NOU=EFER2N
          END IF
C
C=======================================================================
C        CALCULATING THE NEUTRON PAIRING MATRIX ELEMENTS
C=======================================================================
C
          IF (IDEVAR.EQ.1)
     *
     *        CALL GINTER(NXHERM,NYHERM,NZHERM,ICHARG,MREVER,
     *                                  PRHO_N,PRHODN,POWERN)
C
C=======================================================================
C        PRINTING THE PAIRING RESULTS
C=======================================================================
C
          IF (PRINIT.AND.IPAHFB.EQ.1)
     *
     *        CALL PAIPRI(NAMEPN,GPAIRN,EPAI_N,EFERMN,DELTAN,
     *                                  LIPKIN,EFER2N,ELIP_N,
     *                                  IPAHFB,JPABCS,IAVRGG)
C
      END IF
C
C@@@ HFBTHO -HFBTHO - HFBTHO - HFBTHO - HFBTHO - HFBTHO - HFBTHO
C=======================================================================
C        CALCULATING THE   N E U T R O N   D E N S I T Y   M A T R I X
C=======================================================================
C
      CALL DENMAC(MREVER,ICHARG,ISIMPY,IPAHFB,WARIGH,WARIGH)
C
C=======================================================================
C        CALCULATING THE   N E U T R O N   P A I R I N G   T E N S O R
C=======================================================================
C
      IF (IPAIRI.EQ.1.AND.((COR_CM.OR.CORROT).OR.IFRAGM.EQ.1.OR.
     *    IGOGPA.GE.1))
     *
     *    CALL PAIMAC(MREVER,ICHARG,ISIMPY,WARIGH,WARIGH,IKERNE)
C
      IF (IGOGPA.GE.1) CALL SAVPAI(ICHARG)
C
C=======================================================================
C        ADDING THE NEUTRON DENSITY MATRIX TO THE BROYDEN VECTOR
C=======================================================================
C@@@ HFBTHO -HFBTHO - HFBTHO - HFBTHO - HFBTHO - HFBTHO - HFBTHO
                       NACTIT=NUMITE
      IF (IF_THO.GE.1) NACTIT=NUMITE-2
C@@@ HFBTHO -HFBTHO - HFBTHO - HFBTHO - HFBTHO - HFBTHO - HFBTHO
C
      IF (LIPKIN.EQ.1.AND.IBROYD.GE.1.AND.MIXMAT.EQ.0)
     *    CALL LIP_IN(ISIMPY,ICHARG,LIPKIN,LIPKIP,EF2NIN,EF2NOU,
     *                                                   NACTIT)
C
C=======================================================================
C        SAVING  THE   N E U T R O N   D E N S I T Y   M A T R I X
C=======================================================================
C
      IF (I_YUKA.GE.1.OR.I_GOGA.GE.1.OR.LIPKIN.EQ.1.OR.IFRAGM.EQ.1)
     *THEN
                                                           MIXDEN=0
          IF (LIPKIN.EQ.1.AND.IBROYD.LT.1.AND.NACTIT.GT.0) MIXDEN=1
C
          CALL SAVDEN(ISIMPY,ICHARG,SLOWLI,MIXDEN)
C
      END IF
C
C=======================================================================
C         CALCULATING   D I R E C T   YUKAWA ENERGIES FOR NEUTRONS
C=======================================================================
C
      IF (PRIYUK)
     *
     *    CALL YUKAWD(ISIMPY,ICHARG)
C
C=======================================================================
C        CALCULATING THE   N E U T R O N    K I N E T I C    E N E R G Y
C=======================================================================
C
      CALL EKINET(EKIN_N,DLINSN(0),EKEKIN,DKINSN(0))
C
C=======================================================================
C        CALCULATING THE   N E U T R O N    POTENTIAL   HO   E N E R G Y
C=======================================================================
C
      EPOT_N =0.0D0
C
      IF (IPOTHO.EQ.1) CALL EPOTHO(EPOT_N)
C
C=======================================================================
C        CALCULATING THE   N E U T R O N    M U L T I P O L E    MOMENTS
C=======================================================================
C
      ISHIFY=0
C
      CALL MOMETS(ISIMPY,ISIGNY,ISIQTY,QMUL_N,QMUT_N,
     *                          COMULT,KMULMO,ISHIFY)
      CALL MOMSIF(ISIMPY,ISIGNY,ISIQTY,SMUL_N,SMUT_N,
     *                                 COMULT,KMULSI)
      IF (ISCHIF.EQ.1)
     *CALL MOMSCH(SMUL_N,SMUT_N,KMULSI,QMUL_N,QMUT_N,KMULMO)
      CALL MOMVMU(ISIMPY,VMUL_N,COMULT,KMULSI)
      IF (IDOPLM.EQ.1)
     *CALL MOMPLM(ISIMPY,ISIGNY,ISIQTY,PMUL_N,COMULT,KSIFMO)
C
      IF (PRINIT.AND.IPRI_N.EQ.1) THEN
C
          CALL MOMPRI(ISIMPY,NAMMUL,NAMHAR,NAMEPN,QMUL_N,KMULMO)
          IF (KMULSI.GT.0)
     *    CALL MOMPRI(ISIMPY,NAMSIF,NAMHAR,NAMEPN,SMUL_N,KMULSI)
          IF (KMULSI.GT.0.AND.IDOPLM.EQ.1)
     *    CALL MOMPRI(ISIMPY,NAMPLM,NAMHAR,NAMEPN,PMUL_N,KMULSI)
C
      END IF
C
C=======================================================================
C        CALCULATING THE    N E U T R O N     M A G N E T I C    MOMENTS
C=======================================================================
C
      CALL MAGMOM(ISIMPY,IROTAT,ICHARG,AMUL_N,AMUT_N,KMULMA)
C
      IF (PRINIT.AND.IPRI_N.EQ.1) THEN
C
          CALL MAGPRI(ISIMPY,IROTAT,NAMMAG,NAMHAR,NAMEPN,AMUL_N,KMULMA)
C
      END IF
C
C=======================================================================
C        CALCULATING THE   N E U T R O N    R M S    R A D I I
C=======================================================================
C
      CALL RMSQUA(RADI_N,XINFIX)
C
      IF (PRINIT.AND.IPRI_N.EQ.1)
     *
     *    CALL RADPRI(NAMEPN,RADI_N)
C
C=======================================================================
C        CALCULATING THE   N E U T R O N    D E F O R M A T I O N S
C=======================================================================
C
      IF (PRIBET.AND.IPRI_N.EQ.1)
     *
     *    CALL BOHDEF(ISIMPY,NEXBET,IPRIBE,IPRIBL,NAMHAR,NAMEPN,
     *                                     RADI_N,QMUL_N,KMULMO)
C
C=======================================================================
C        CALCULATING THE   N E U T R O N   S P I N
C=======================================================================
C
      CALL SPIMOM(NXMAXX,NYMAXX,NZMAXX,ISIMPY,IROTAT,ANGU_N,SPIN_N)
C
C=======================================================================
C        CALCULATING THE   N E U T R O N   L I N E A R   M O M E N T A
C=======================================================================
C
      CALL LINAVR(NXMAXX,NYMAXX,NZMAXX,ISIMPY,ISIGNY,ISIQTY,
     *            IPAIRI,ICHARG,JETACM,IROTAT,MREVER,COR_CM,
     *            DLINSN,ELINSN,PLINSN,TLINSN,ALINLN,PLINLN,PLINKN,
     *            DKINSN,EKINSN,PKINSN,TKINSN,AKINLN,PKINLN,PKINKN)
C
C=======================================================================
C        CALCULATING THE   N E U T R O N   A N G U L A R   M O M E N T A
C=======================================================================
C
      CALL ROTAVR(NXMAXX,NYMAXX,NZMAXX,ISIMPY,ISIGNY,ISIQTY,
     *            IPAIRI,ICHARG,KETA_R,IROTAT,MREVER,CORROT,
     *            DROTSN,EROTSN,PROTSN,TROTSN,AROTLN,PROTLN,PROTKN,
     *            DKOTSN,EKOTSN,PKOTSN,TKOTSN,AKOTLN,PKOTLN,PKOTKN)
C
C=======================================================================
C         (OPTIONAL) CALCULATION OF MASS PARAMETERS FOR NEUTRONS
C=======================================================================
C
#if(USE_INERTIA==1)
      CALL MASPAR(TERMNT,ICHARG,MREVER,L_COLL,M_COLL,N_COLL)
#endif
#if(USE_INERTIA==2)
      CALL MAS_PR(TERMNT,ICHARG,MREVER,IF2FIN,IF2FIP,L_COLL,M_COLL,
     *                                               N_COLL,E0CORR)
      IF (TERMNT)THEN
          ENERG1=ETOTFU-ELIP_T
          name_file=.False.
          CALL WRITQP(TERMNT,ICHARG,MREVER,NUDATA,IF2FIN,IF2FIP,
     *                                            FE2FIN,FE2FIP,
     *                                            ENERG1,E0CORR,
     *                                            INDJOB,name_file)
      END IF
#endif
C
C=======================================================================
C         HERE ENDS THE BLOCK FOR   N E U T R O N S
C=======================================================================
C
 8970 CONTINUE
C
C=======================================================================
C         FOR IZ_FIX=0 WE DO NOT PERFORM ANY CALCULATIONS FOR PROTONS
C=======================================================================
C
      IF (IZ_FIX.EQ.0) GO TO 8971
C
C=======================================================================
C         HERE STARTS THE BLOCK FOR  P R O T O N S
C=======================================================================
C
      NAMEPN=' PROTONS'
C
      ICHARG=1
      ITPNMX=1
C
C=======================================================================
C         CALCULATING THE MATRIX ELEMENTS OF THE PROTON MEAN FIELD
C=======================================================================
C
      IF (NUMITE.GT.0) THEN
C
          IF (NUMITE.GT.ITESTA.OR.(IFCONT.NE.1.AND.IF_THO.EQ.0)) THEN
C
              CALL INTEGH(NXHERM,NYHERM,NZHERM,NXMAXX,NYMAXX,NZMAXX,
     *                                  IMOVAX,ITILAX,ITISAX,NO_ORB,
     *                           IPNMIX,ITPNMX,IROTAT,ICHARG,ISIMPY,
     *                                         IPOTHO,ISCHIF,IOCONT,
     *                                                NMUCON,NSICON,
     *                                                I_YUKA,I_GOGA,
     *                                                JETACM,ALINLT,
     *                                                KETA_R,AROTLT,
     *                                                ICOUDI,ICOUEX,
     *                                                LIPKIN,LIPKIP,
     *                                                EFER2N,EFER2P,
     *                                                       IF_RPA)
C
          ELSE
C
              CALL GETFIL(ISIMPY,ICHARG)
C
          END IF
C
          SPMODL='HARTREE-FOCK  '
C
C=======================================================================
C        CALCULATING THE MATRIX ELEMENTS OF THE PROTON PAIRING FIELD
C=======================================================================
C
          IF (IPAHFB.EQ.1) THEN
C
              IF (NUMITE.GT.ITESTA.OR.(IFCONT.NE.1.AND.IF_THO.EQ.0))
     *        THEN
C
                  CALL INTEGD(NXHERM,NYHERM,NZHERM,NXMAXX,NYMAXX,NZMAXX,
     *                                      ITPNMX,IROTAT,ISIMPY,ICHARG,
     *                                      DELFIN,DELFIP,IDEFIN,IDEFIP,
     *                                      JETACM,KETA_R,IGOGPA,ITERUN)
C
              ELSE
C
                  CALL GETPAI(ICHARG)
C
              END IF
C
              IF (IMFHFB.EQ.1) THEN
C
                  SPMODL='HFB MEAN FIELD'
              ELSE
                  SPMODL='CANONICAL     '
C
              END IF
C
          END IF
C
      ELSE
C
C=======================================================================
C        INITIALIZING THE MATRIX ELEMENTS OF THE NEUTRON MEAN FIELD
C=======================================================================
C
          IF (IREAWS.EQ.1) THEN
C
              CALL WSHAMI(NXMAXX,NYMAXX,NZMAXX,ITILAX,ITISAX,NO_ORB,
     *                                                ICHARG,ISIMPY)
C
              SPMODL='WOODS-SAXON   '
C
          ELSE
C
              CALL NILSON(NXMAXX,NYMAXX,NZMAXX,ITILAX,ITISAX,NO_ORB,
     *                                                INNUMB,IZNUMB,
     *                                                ICHARG,NAMEPN,
     *                                                HOMEGA,ISIMPY)
C
              SPMODL='NILSSON       '
C
          END IF
C
C=======================================================================
C        INITIALIZING THE MATRIX ELEMENTS OF THE PROTON PAIRING FIELD
C=======================================================================
C
          IF (IPAHFB.EQ.1) THEN
C
              CALL INIPAI(NXHERM,NYHERM,NZHERM,ITPNMX)
C
              IF (JETACM.EQ.2) CALL ZERLIN(ISIMPY,IPAIRI)
              IF (KETA_R.EQ.2) CALL ZERROT(ISIMPY,IPAIRI)
C
              CALL INTEGD(NXHERM,NYHERM,NZHERM,NXMAXX,NYMAXX,NZMAXX,
     *                                  ITPNMX,IROTAT,ISIMPY,ICHARG,
     *                                  DELFIN,DELFIP,IDEFIN,IDEFIP,
     *                                  JETACM,KETA_R,IGOGPA,ITERUN)
C
          END IF
C
      END IF
C
C=======================================================================
C        MIXING OF THE MATRIX ELEMENTS OF THE HFB MATRIX. USUAL LINEAR
C        MIXING IS HANDLED BY THE ROUTINE DOBROY_MATRIX(), THE BROYDEN
C        CORRECTION BEING SIMPLY NOT ADDED
C=======================================================================
C
      IF (MIXMAT.EQ.1) THEN
C
          IF (ITERUN.GT.1) THEN
C
              CALL HPH_IN(ISIMPY,MREVER,ICHARG,NUMITE,INDJOB)
              IF (IPAHFB.EQ.1) CALL DEL_IN(MREVER,IROTAT,ICHARG,
     *                                            NUMITE,INDJOB)
C
C              Evolving the Broyden and affecting the ouput
C
              CALL DOBROY_MATRIX(ITERUN,NSWBRP,ITAK_P,
     *                           NOICAN,SLOWEV,ESTABN,
     *                           EFERMP,EFEPIN,EFEPOU,
     *                           EFER2P,EF2PIN,EF2POU,
     *                           LIPKIP,NOFBRP,ICHARG,
     *                                         IPAHFB)
C
              CALL HPH_OU(ISIMPY,MREVER,ICHARG)
              CALL GETFIL(ISIMPY,ICHARG)
C
              IF (IPAHFB.EQ.1) THEN
                  CALL DEL_OU(MREVER,IROTAT,ICHARG)
                  CALL GETPAI(ICHARG)
              END IF
C
          ELSE
              CALL SAVFIL(ISIMPY,IPAHFB,ICHARG)
          END IF
C
      END IF
C
C=======================================================================
C        SAVING  THE   P R O T O N   MEAN FIELDS
C=======================================================================
C
      IF (IWRIFI.NE.-1.AND.MIXMAT.EQ.0)
     *    CALL SAVFIL(ISIMPY,IPAHFB,ICHARG)
C
C=======================================================================
C        DIAGONALIZING THE MATRIX OF THE  PROTON   H F B   HAMILTONIAN
C=======================================================================
C
      IF (IPAHFB.EQ.1) THEN
C
          IF (ISIMPY.EQ.1) THEN
C
              IF (ISIGNY.EQ.1) THEN
C
                  IF (ITWOBA.EQ.1) STOP ' TWO BASIS NOT IMPLEMENTED YET'
C
                  CALL HFBSIG(EFERMP,ECUTOF,LIMQUA,ICHARG,IMFHFB,
     *                               INSIGP,IPSIGP,ISSIGP,IDSIGP,
     *                                             IFIBLP,ISABLP,
     *                               IREQPB,INUQPB,JNUQPB,IF_RPA)
C
              ELSE
C
                  IF (ITWOBA.EQ.1) STOP ' TWO BASIS NOT IMPLEMENTED YET'
C
                  CALL HFBSIM(EFERMP,ECUTOF,LIMQUA,ICHARG,IMFHFB,
     *                                      INSIMP,IRSIMP,IDSIMP,
     *                                             IFIBLP,ISABLP,
     *                               IREQPB,INUQPB,JNUQPB,IF_RPA)
C
              END IF
C
          ELSE
C
              IF (ISIQTY.EQ.1) THEN
C
                  IF (ITWOBA.EQ.1) STOP ' TWO BASIS NOT IMPLEMENTED YET'
C
                  CALL HFBSIQ(EFERMP,ECUTOF,LIMQUA,ICHARG,IMFHFB,
     *                                      INSIQP,IPSIQP,IDSIQP,
     *                                             IFIBLP,ISABLP,
     *                                      IREQPB,INUQPB,JNUQPB)
C
              ELSE
C
#if(USE_SCALAPACK==1)
		  CALL HFBSIZ_sl(EFERMP,ECUTOF,LIMQUA,ITWOBA,ICHARG,
     *                                         IMFHFB,INSIZP,IDSIZP,
     *                                                IFIBLP,ISABLP,
     *                                         IREQPB,INUQPB,JNUQPB)
#else
                  CALL HFBSIZ(EFERMP,ECUTOF,LIMQUA,ITWOBA,ICHARG,
     *                                      IMFHFB,INSIZP,IDSIZP,
     *                                             IFIBLP,ISABLP,
     *                                      IREQPB,INUQPB,JNUQPB)
#endif
C
              END IF
C
          END IF
C
#if(USE_MPI==1)
          IF (escapeSignal.Eq.1) THEN

              WRITE(6,'(''Process '',i6,
     *                  '' - HFBSIM failed for protons. '',
     *                  ''Closing all files and exiting...'')')
     *                    WorldRank
C
              ! Properly close all files that could have been left
              ! opened (with the exclusion of the output unit NFIPRI)
              CALL IOCLOS(NFIWOO,NFIREP,NFIREV,NFIREC,NFICOU,NFIWAV,
     *                    NFIKER,NFIYUP,NFIYUC,NFIGOC,NFIGOP,NFIGPC,
     *                    NFIGPP,NFILIP,NFILIC,NFIFIP,NFIFIC,NFIISO)
C
              EXIT procLoop
C
          END IF
#endif
C
          EFEPIN=EFERMP
          IF (do_debug) Write(NFIPRI,'(''(in) EFERMP = '',f20.14)')
     *                                EFERMP
C
          CALL QUABCS(EFERMP,XIZFIX,FERFIP,IFEFIP,ICHARG,
     *                       IDSIGP,IDSIMP,IDSIQP,IDSIZP,
     *                              IREQPB,INUQPB,JNUQPB)
          IF (do_debug) Write(NFIPRI,'(''(out) EFERMP = '',f20.14)')
     *                                EFERMP
C
#if(USE_MPI==1)
          IF (escapeSignal.Eq.1) THEN
C
              WRITE(6,'(''Process '',i6,
     *                  '' - QUABCS failed for protons. '',
     *                  ''Closing all files and exiting...'')')
     *                    WorldRank
C
              ! Properly close all files that could have been left
              ! opened (with the exclusion of the output unit NFIPRI)
              CALL IOCLOS(NFIWOO,NFIREP,NFIREV,NFIREC,NFICOU,NFIWAV,
     *                    NFIKER,NFIYUP,NFIYUC,NFIGOC,NFIGOP,NFIGPC,
     *                    NFIGPP,NFILIP,NFILIC,NFIFIP,NFIFIC,NFIISO)
C
              EXIT procLoop
C
          END IF
#endif
C
          EFEPOU=EFERMP
C
          IF (PRINIT) CALL SPTQUA(EMAXQU,ICHARG,NAMEPN,
     *                            ISIGNY,ISIMPY,ISIQTY,
     *                     IDSIGP,IDSIMP,IDSIQP,IDSIZP,
     *                            IREQPB,INUQPB,JNUQPB)
C
      END IF
C
C=======================================================================
C        DIAGONALIZING THE MATRIX OF THE   P R O T O N   MEAN FIELD
C=======================================================================
C
      IF (IPAHFB.EQ.1) THEN
C
          IF (ISIMPY.EQ.1) THEN
C
              CALL CANQUA(MREVER,ICHARG,IMFHFB,ESUM_P)
C
          ELSE
C
              CALL CANQUZ(ICHARG,IMFHFB,ESUM_P)
C
          END IF
C
      ELSE
C
          IF (ISIMPY.EQ.1) THEN
C
              IF (ISIGNY.EQ.1) THEN
C
                  CALL DIASIG(MREVER,ICHARG)
C
              ELSE
C
                  CALL DIASIM(MREVER,ICHARG)
C
              END IF
C
          ELSE
C
              IF (ISIQTY.EQ.1) THEN
C
                  CALL DIASIQ(ICHARG)
C
              ELSE
C
                  LIMPAR=0
C
                  CALL DIASIZ(ICHARG,LIMPAR,ECUTOF,LDMEFI)
C
              END IF
C
          END IF
C
      END IF
C
C=======================================================================
C        CALCULATING VARIOUS SINGLE-PARTICLE AVERAGES FOR PROTONS
C=======================================================================
C=======================================================================
C        SEE COMMENTS TO THE PREVIOUS CALL TO AVANGY
C=======================================================================
C
      IF((ISIMPY.EQ.1.AND.IFLIPI.NE.0.AND.ICHFLI.EQ.ICHARG)         .OR.
     *
     *   (ISIMPY.EQ.1.AND.ISIGNY.EQ.1.AND.(NOFLIG(0,0,ICHARG).NE.0  .OR.
     *                                     NOFLIG(0,1,ICHARG).NE.0  .OR.
     *                                     NOFLIG(1,0,ICHARG).NE.0  .OR.
     *                                     NOFLIG(1,1,ICHARG).NE.0)).OR.
     *
     *   (ISIMPY.EQ.1.AND.ISIGNY.NE.1.AND.(NOFLIM(  0,ICHARG).NE.0  .OR.
     *                                     NOFLIM(  1,ICHARG).NE.0)).OR.
     *
     *   (ISIMPY.NE.1.AND.ISIQTY.EQ.1.AND.(NOFLIQ(  0,ICHARG).NE.0  .OR.
     *                                     NOFLIQ(  1,ICHARG).NE.0)).OR.
     *
     *   (ISIMPY.NE.1.AND.ISIQTY.NE.1.AND.(NOFLIZ(    ICHARG).NE.0)).OR.
     *
     *    IS_PIN.EQ.1                                               .OR.
     *
     *    IS_CHA.EQ.1                                               .OR.
     *
     *    TERMNT                                                    .OR.
     *
     *    PRINIT)                                                   THEN
C
          CALL AVANGY(NXMAXX,NYMAXX,NZMAXX,MREVER,ICHARG,ISIMPY)
C
          CALL AVOBSE(MREVER,ICHARG)
C
      END IF
C
C=======================================================================
C        CALCULATING AND PRINTING SINGLE-PARTICLE AVERAGES FOR PROTONS
C=======================================================================
C
      CALL AVPARI(MREVER,ICHARG)
C
      IF (TERMNT.OR.PRINIT) THEN
C
          CALL AVSIMP(MREVER,ICHARG)
C
          CALL NILABS(NOSCIL,MREVER,ICHARG,ISIMPY,NILXYZ)
C
      END IF
C
      IF (PRINIT) THEN
C
          CALL SPTALL(EMINAL,EMAXAL,SPMODL,NAMEPN,
     *                       ISIGNY,ISIMPY,ISIQTY,
     *                       MREVER,ICHARG,NILXYZ)
C
      END IF
C
C=======================================================================
C        CALCULATING THE PROTON  PAIRING AND DEFINING OCCUPATION FACTORS
C=======================================================================
C
      EPAI_P=0.0
      EREA_P=0.0
C
      IF (IPAIRI.EQ.1) THEN
C
          IF (JPABCS.GT.0) THEN
C
              IF (JPABCS.EQ.1.OR.
     *           (JPABCS.EQ.3.AND.ITERUN.EQ.1))  THEN
C
                  IF (IAVRGG.NE.1) THEN
C
                      CALL SETPAI(IN_FIX,IZ_FIX,FACTGP,ICHARG,GPAIRP)
C
                  ELSE
C
                      CALL GAVRAG(IN_FIX,IZ_FIX,FACTGP,ICHARG,GPAIRP)
C
                  END IF
C
              END IF
C
              EFEPIN=EFERMP
              CALL DELPAI (ICHARG,MREVER,JPABCS,IZ_FIX,ITERUN,
     *                     DELFIP,GPAIRP,EPAI_P,EFERMP,DELTAP)
              EFEPOU=EFERMP
C
              IF (PRINIT)
     *
     *            CALL PAIPRI(NAMEPN,GPAIRP,EPAI_P,EFERMP,DELTAP,
     *                                      LIPKIP,EFER2P,ELIP_P,
     *                                      IPAHFB,JPABCS,IAVRGG)
C
          END IF
C
      ELSE
C
          IF (ISIMPY.EQ.1) THEN
C
              IF (ISIGNY.EQ.1) THEN
C
                  CALL CONSIG(MREVER,ICHARG,IZ_FIX,EFERMP,
     *                               ICHFLI,IPAFLI,IREFLI,
     *                               ISPFLI,ISHFLI,IFLIPI)
              ELSE
C
                  CALL CONSIM(MREVER,ICHARG,IZ_FIX,EFERMP,
     *                               ICHFLI,       IREFLI,
     *                               ISPFLI,ISHFLI,IFLIPI)
C
              END IF
C
          ELSE
C
              IF (ISIQTY.EQ.1) THEN
C
                  CALL CONSIQ(ICHARG,IZ_FIX,EFERMP,
     *                        ICHFLI,IPAFLI,
     *                        ISPFLI,ISHFLI,IFLIPI)
              ELSE
C
                  CALL CONSIZ(ICHARG,IZ_FIX,EFERMP,
     *                        ICHFLI,
     *                        ISPFLI,ISHFLI,IFLIPI)
C
              END IF
C
          END IF
C
          DELTAP=0.0D0
C
      END IF
C
C=======================================================================
C        CALCULATING THE SUM OF  PROTON SINGLE-PARTICLE ENERGIES
C=======================================================================
C
      IF (IPAHFB.NE.1)
     *
     *    CALL SPENSU(MREVER,ESUM_P,ICHARG,ISIMPY)
C
C=======================================================================
C         ZEROING THE PROTON DENSITIES
C=======================================================================
C
      CALL ZEDENS(ICHARG)
C
C=======================================================================
C        CALCULATING THE PROTON DENSITIES AND CURRENTS
C=======================================================================
C
      CALL DENSHF(NXHERM,NYHERM,NZHERM,ISIMTX,JSIMTY,ISIMTZ,
     *            ISIGNY,ISIMPY,ISIQTY,IPAHFB,MREVER,ICHARG,
     *            ICOUDI,ICOUEX,I_YUKA,I_GOGA,IGOGPA,
     *                                        IPNMIX,ITPNMX,
     *            ITIREP,NXMAXX,NAMEPN,PRINIT,IDEVAR,ITERUN,
     *            ISYMDE,INIROT,INIINV,INIKAR,ISAWAV,IKERNE)
C
C=======================================================================
C         DOUBLING SINGLE-PARTICLE RESULTS IN CASE OF NO ROTATION
C=======================================================================
C
      IF (MREVER.EQ.0) THEN
C
          CALL DBLING(ITPNMX,NXHERM,NYHERM,NZHERM,ESUM_P)
C
      END IF
C
C@@@ HFBTHO - HFBTHO - HFBTHO - HFBTHO - HFBTHO - HFBTHO - HFBTHO
C=======================================================================
C        BY DEFAULT,  HFODD  INITIALIZES THE  MATRIX OF THE  MEAN-FIELD
C        BY  COMPUTING THE  MATRIX ELEMENTS  OF THE  NILSON  POTENTIAL.
C        IN  HFB  MODE IT  INITIALIZES  THE MATRIX OF THE PAIRING FIELD
C        BY COMPUTING THE MATRIX ELEMENTS OF THE  DELTA-PAIRING  INTER-
C        ACTION, WHICH DEPENDS ON THE ISO-SCALAR DENSITY, AND THEREFORE
C        ON BOTH PROTON AND NEUTRON DENSITIES ON THE GAUSS-HERMITE MESH.
C        WHEN RESTARTING FROM HFBTHO, THESE DENSITIES ARE NOT AVAILABLE:
C        THE COMPUTATION OF  ALL  PAIRING OBSERVABLES MUST THEREFORE BE
C        SHIFTED TO  AFTER  THE NEW ISOSCALAR DENSITY HAS BEEN COMPUTED.
C        THIS ONLY AFFECTS THE  FIRST ITERATION, SEE ALSO COMMENT ABOUT
C        NUMITE BELOW.
C=======================================================================
C
      IF (IF_THO.EQ.0.OR.ITERUN.NE.1) THEN
C
C=======================================================================
C        CALCULATING THE  PROTON HFB PAIRING ENERGY AND AVERAGE DELTA
C=======================================================================
C
          IF (IPAHFB.EQ.1)
     *
     *        CALL EPAIRI(NXHERM,NYHERM,NZHERM,IN_FIX,IZ_FIX,ITPNMX,
     *                                                       XIZFIX)
C
C=======================================================================
C        CALCULATING THE PROTON LIPKIN-NOGAMI CORRECTION
C=======================================================================
C        WHEN STARTING FROM SCRATCH, THE CODE INITALIZES THE PH AND PP
C        CHANNELS  AT  NUMITE = 0. WHEN  RESTARTING FROM  HFBTHO, THIS
C        INITIALIZATION  MUST BE  SKIPPED,  WHICH IS  DONE BY  SETTING
C        NUMITE = 1. HOWEVER, TO  ENSURE  A  SMOOTH  RESTART OF THE LN
C        LAMBDA_2 PARAMETER,  ONE MUST DO 'AS IF' WE WERE AT THE FIRST
C        ITERATION, HENCE THE TRICK BELOW.
C=======================================================================
C
                           NACTIT=NUMITE
          IF (IF_THO.GE.1) NACTIT=NUMITE-2
C
          IF (LIPKIP.EQ.1) THEN
              EF2PIN=EFER2P
              CALL LIPCOR(GPAIRP,FACTGP,FE2FIP,IF2FIP,SLOWLI,
     *                                  EFER2P,ELIP_P,NACTIT,
     *                                  EFERMP,DELTAP,ICHARG)
              EF2POU=EFER2P
          END IF
C
C=======================================================================
C        CALCULATING THE PROTON PAIRING MATRIX ELEMENTS
C=======================================================================
C
          IF (IDEVAR.EQ.1)
     *
     *        CALL GINTER(NXHERM,NYHERM,NZHERM,ICHARG,MREVER,
     *                                  PRHO_P,PRHODP,POWERP)
C
C=======================================================================
C        PRINTING THE PAIRING RESULTS
C=======================================================================
C
          IF (PRINIT.AND.IPAHFB.EQ.1)
     *
     *        CALL PAIPRI(NAMEPN,GPAIRP,EPAI_P,EFERMP,DELTAP,
     *                                  LIPKIP,EFER2P,ELIP_P,
     *                                  IPAHFB,JPABCS,IAVRGG)
C
      END IF
C
C@@@ HFBTHO - HFBTHO - HFBTHO - HFBTHO - HFBTHO - HFBTHO - HFBTHO
C=======================================================================
C        CALCULATING THE   P R O T O N   D E N S I T Y   M A T R I X
C=======================================================================
C
      CALL DENMAC(MREVER,ICHARG,ISIMPY,IPAHFB,WARIGH,WARIGH)
C
C=======================================================================
C        CALCULATING THE   P R O T O N   P A I R I N G   T E N S O R
C=======================================================================
C
      IF (IPAIRI.EQ.1.AND.((COR_CM.OR.CORROT).OR.IFRAGM.EQ.1.OR.
     *    IGOGPA.GE.1))
     *
     *    CALL PAIMAC(MREVER,ICHARG,ISIMPY,WARIGH,WARIGH,IKERNE)
C
      IF (IGOGPA.GE.1) CALL SAVPAI(ICHARG)
C
C=======================================================================
C        ADDING THE PROTON DENSITY MATRIX TO THE BROYDEN VECTOR
C=======================================================================
C@@@ HFBTHO - HFBTHO - HFBTHO - HFBTHO - HFBTHO - HFBTHO - HFBTHO
                       NACTIT=NUMITE
      IF (IF_THO.GE.1) NACTIT=NUMITE-2
C@@@ HFBTHO - HFBTHO - HFBTHO - HFBTHO - HFBTHO - HFBTHO - HFBTHO
C
      IF (LIPKIP.EQ.1.AND.IBROYD.GE.1.AND.MIXMAT.EQ.0)
     *    CALL LIP_IN(ISIMPY,ICHARG,LIPKIN,LIPKIP,EF2PIN,EF2POU,
     *                                                   NACTIT)
C
C=======================================================================
C        SAVING  THE   P R O T O N   D E N S I T Y   M A T R I X
C=======================================================================
C
      IF (ICOUDI.EQ.2.OR.ICOUEX.EQ.2.OR.
     *    I_YUKA.GE.1.OR.I_GOGA.GE.1.OR.LIPKIP.EQ.1.OR.IFRAGM.EQ.1)
     *THEN
                                                           MIXDEN=0
          IF (LIPKIP.EQ.1.AND.IBROYD.LT.1.AND.NACTIT.GT.0) MIXDEN=1
C
          CALL SAVDEN(ISIMPY,ICHARG,SLOWLI,MIXDEN)
C
      END IF
C
C=======================================================================
C         CALCULATING   D I R E C T   YUKAWA ENERGIES FOR PROTONS
C=======================================================================
C
      IF (PRIYUK)
     *
     *    CALL YUKAWD(ISIMPY,ICHARG)
C
C=======================================================================
C        CALCULATING THE   P R O T O N     K I N E T I C     E N E R G Y
C=======================================================================
C
      CALL EKINET(EKIN_P,DLINSP(0),EKEKIN,DKINSP(0))
C
C=======================================================================
C        CALCULATING THE   P R O T O N      POTENTIAL   HO   E N E R G Y
C=======================================================================
C
      EPOT_P =0.0D0
C
      IF (IPOTHO.EQ.1) CALL EPOTHO(EPOT_P)
C
C=======================================================================
C        CALCULATING THE   P R O T O N     M U L T I P O L E     MOMENTS
C=======================================================================
C
      ISHIFY=0
C
      CALL MOMETS(ISIMPY,ISIGNY,ISIQTY,QMUL_P,QMUT_P,
     *                          COMULT,KMULMO,ISHIFY)
      CALL MOMSIF(ISIMPY,ISIGNY,ISIQTY,SMUL_P,SMUT_P,
     *                                 COMULT,KMULSI)
      IF (ISCHIF.EQ.1)
     *CALL MOMSCH(SMUL_P,SMUT_P,KMULSI,QMUL_P,QMUT_P,KMULMO)
      CALL MOMVMU(ISIMPY,VMUL_P,COMULT,KMULSI)
      IF (IDOPLM.EQ.1)
     *CALL MOMPLM(ISIMPY,ISIGNY,ISIQTY,PMUL_P,COMULT,KMULSI)
C
      IF (PRINIT.AND.IPRI_P.EQ.1) THEN
C
          CALL MOMPRI(ISIMPY,NAMMUL,NAMHAR,NAMEPN,QMUL_P,KMULMO)
          IF (KMULSI.GT.0)
     *    CALL MOMPRI(ISIMPY,NAMSIF,NAMHAR,NAMEPN,SMUL_P,KMULSI)
          IF (KMULSI.GT.0.AND.IDOPLM.EQ.1)
     *    CALL MOMPRI(ISIMPY,NAMPLM,NAMHAR,NAMEPN,PMUL_P,KMULSI)
C
      END IF
C
C=======================================================================
C        CALCULATING THE   P R O T O N   M A G N E T I C   M O M E N T S
C=======================================================================
C
      CALL MAGMOM(ISIMPY,IROTAT,ICHARG,AMUL_P,AMUT_P,KMULMA)
C
      IF (PRINIT.AND.IPRI_P.EQ.1) THEN
C
          CALL MAGPRI(ISIMPY,IROTAT,NAMMAG,NAMHAR,NAMEPN,AMUL_P,KMULMA)
C
      END IF
C
C=======================================================================
C         CALCULATING   P R O T O N    R M S    R A D I I
C=======================================================================
C
      CALL RMSQUA(RADI_P,XIZFIX)
C
      IF (PRINIT.AND.IPRI_P.EQ.1)
     *
     *    CALL RADPRI(NAMEPN,RADI_P)
C
C=======================================================================
C        CALCULATING THE   P R O T O N    D E F O R M A T I O N S
C=======================================================================
C
      IF (PRIBET.AND.IPRI_P.EQ.1)
     *
     *    CALL BOHDEF(ISIMPY,NEXBET,IPRIBE,IPRIBL,NAMHAR,NAMEPN,
     *                                     RADI_P,QMUL_P,KMULMO)
C
C=======================================================================
C         CALCULATING   P R O T O N   S P I N
C=======================================================================
C
      CALL SPIMOM(NXMAXX,NYMAXX,NZMAXX,ISIMPY,IROTAT,ANGU_P,SPIN_P)
C
C=======================================================================
C        CALCULATING THE   P R O T O N   L I N E A R   M O M E N T A
C=======================================================================
C
      CALL LINAVR(NXMAXX,NYMAXX,NZMAXX,ISIMPY,ISIGNY,ISIQTY,
     *            IPAIRI,ICHARG,JETACM,IROTAT,MREVER,COR_CM,
     *            DLINSP,ELINSP,PLINSP,TLINSP,ALINLP,PLINLP,PLINKP,
     *            DKINSP,EKINSP,PKINSP,TKINSP,AKINLP,PKINLP,PKINKP)
C
C=======================================================================
C        CALCULATING THE   P R O T O N   A N G U L A R   M O M E N T A
C=======================================================================
C
      CALL ROTAVR(NXMAXX,NYMAXX,NZMAXX,ISIMPY,ISIGNY,ISIQTY,
     *            IPAIRI,ICHARG,KETA_R,IROTAT,MREVER,CORROT,
     *            DROTSP,EROTSP,PROTSP,TROTSP,AROTLP,PROTLP,PROTKP,
     *            DKOTSP,EKOTSP,PKOTSP,TKOTSP,AKOTLP,PKOTLP,PKOTKP)
C
C=======================================================================
C          CALCULATING   T R U E   CHARGE DENSITY
C=======================================================================
C
      CALL TRUCHD(NXHERM,NYHERM,NZHERM)
C
C=======================================================================
C          ZEROING COULOMB ENERGIES
C=======================================================================
C
      EKECOD=C_ZERO
      EKECOE=C_ZERO
      EKESCA=C_ZERO
      EKEVEC=C_ZERO
C
C=======================================================================
C          CALCULATING THE DIRECT COULOMB ENERGIES AND FIELDS BY THE
C          GREEN-FUNCTION METHOD
C=======================================================================
C
      IF (ICOUDI.EQ.1) THEN
C
          CALL COUMAT(NXHERM,NYHERM,NZHERM,NXMAXX,NYMAXX,NZMAXX,
     *                              NUMCOU,BOUCOU,ISIMPY,IKERNE)
C
          CALL COULOD(ISIMPY,EKECOD)
C
      END IF
C
C=======================================================================
C          CALCULATING SLATER EXCHANGE COULOMB ENERGY
C=======================================================================
C
      IF (ICOUEX.EQ.1) THEN
C
          CALL COULOE(NXHERM,NYHERM,NZHERM,EKECOE)
C
      END IF
C
C=======================================================================
C          CALCULATING THE DIRECT AND EXCHANGE COULOMB ENERGIES AND
C          FIELDS BY THE METHOD OF EXPANDING IN GAUSSIANS
C=======================================================================
C
      IF (ICOUDI.EQ.2.OR.ICOUEX.EQ.2) THEN
C
          CALL COUENE(NXHERM,NYHERM,NZHERM,NXMAXX,NYMAXX,NZMAXX,
     *                                                   ISIMPY,
     *                                     ICOTYP,ICOUDI,ICOUEX,
     *                                     EKECOD,EKESCA,EKEVEC,
     *                                            SLOWEV,ISEXAC)
C
          IF (ICOUEX.EQ.2) EKECOE=EKESCA+EKEVEC
C
      END IF
C
      ECOULD=REAL(EKECOD)
      ECOULE=REAL(EKECOE)*COUSCA
      ECOULS=REAL(EKESCA)
      ECOULV=REAL(EKEVEC)
C
C=======================================================================
C         (OPTIONAL) CALCULATION OF MASS PARAMETERS FOR PROTONS
C=======================================================================
C
#if(USE_INERTIA==1)
      CALL MASPAR(TERMNT,ICHARG,MREVER,L_COLL,M_COLL,N_COLL)
#endif
C
#if(USE_INERTIA==2)
      CALL MAS_PR(TERMNT,ICHARG,MREVER,IF2FIN,IF2FIP,L_COLL,M_COLL,
     *                                               N_COLL,E0CORR)
      IF (TERMNT)THEN
          ENERG1=ETOTFU-ELIP_T
          name_file=.False.
          CALL WRITQP(TERMNT,ICHARG,MREVER,NUDATA,IF2FIN,IF2FIP,
     *                                            FE2FIN,FE2FIP,
     *                                            ENERG1,E0CORR,
     *                                            INDJOB,name_file)
      END IF
#endif
C
C=======================================================================
C         HERE ENDS THE BLOCK FOR  P R O T O N S
C=======================================================================
C
 8971 CONTINUE
C
C=======================================================================
C          CALCULATING THE "DIV S" DENSITIES FOR NEUTRONS AND PROTONS
C=======================================================================
C
      CALL SAVDIS(NXHERM,NYHERM,NZHERM)
C
C=======================================================================
C          CALCULATING THE  D I R E C T  YUKAWA POTENTIALS
C=======================================================================
C
      IF (I_YUKA.GE.1) THEN
C
          CALL YUKMAT(NXHERM,NYHERM,NZHERM,NXMAXX,NYMAXX,NZMAXX,
     *                              PIMASS,NUMCOU,BOUCOU,ISIMPY)
C
      END IF
C
C=======================================================================
C          CALCULATING THE DIRECT AND EXCHANGE YUKAWA ENERGIES AND
C          FIELDS
C=======================================================================
C
      IF (I_YUKA.GE.1) THEN
C
          CALL YUKENE(NXHERM,NYHERM,NZHERM,NXMAXX,NYMAXX,NZMAXX,
     *                              PIMASS,PNMASS,IYUTYP,I_YUKA,
     *                              YUKAGT,YUKAG0,YUKAG1,YUKAG2,
     *                                                   ISIMPY)
C
      END IF
C
C=======================================================================
C          CALCULATING   T R U E   TOTAL DENSITY
C=======================================================================
C
      CALL TRUTOD(NXHERM,NYHERM,NZHERM)
C
C=======================================================================
C          CALCULATING  T H E   G O G N Y   E N E R G Y
C=======================================================================
C
      IF (I_GOGA.GE.1) THEN
C
          CALL GOGENE(NXHERM,NYHERM,NZHERM,NXMAXX,NYMAXX,NZMAXX,
     *                       SLOWEV,ISGOGA,I_GOGA,ISIMPY,GOGNAM)
C
      END IF
C
C=======================================================================
C          CALCULATING  T H E   G O G N Y   P A I R I N G   E N E R G Y
C=======================================================================
C
      IF (IGOGPA.GE.1) THEN
C
          CALL GOGPAI(NXHERM,NYHERM,NZHERM,NXMAXX,NYMAXX,NZMAXX,
     *                       SLOWPA,ISGOGP,IGOGPA,ISIMPY,GOGNAM)
C
      END IF
C
C@@@ HFBTHO - HFBTHO - HFBTHO - HFBTHO - HFBTHO - HFBTHO - HFBTHO
C=======================================================================
C        BY DEFAULT,  HFODD  INITIALIZES THE  MATRIX OF THE  MEAN-FIELD
C        BY  COMPUTING THE  MATRIX ELEMENTS  OF THE  NILSON  POTENTIAL.
C        IN  HFB  MODE IT  INITIALIZES  THE MATRIX OF THE PAIRING FIELD
C        BY COMPUTING THE MATRIX ELEMENTS OF THE  DELTA-PAIRING  INTER-
C        ACTION, WHICH DEPENDS ON THE ISO-SCALAR DENSITY, AND THEREFORE
C        ON BOTH PROTON AND NEUTRON DENSITIES ON THE GAUSS-HERMITE MESH.
C        WHEN RESTARTING FROM HFBTHO, THESE DENSITIES ARE NOT AVAILABLE:
C        THE COMPUTATION OF  ALL  PAIRING OBSERVABLES MUST THEREFORE BE
C        SHIFTED TO  AFTER  THE NEW ISOSCALAR DENSITY HAS BEEN COMPUTED.
C        THIS ONLY AFFECTS THE  FIRST ITERATION, SEE ALSO COMMENT ABOUT
C        NUMITE EARLIER.
C=======================================================================
C
      IF (IF_THO.GE.1.AND.ITERUN.EQ.1) THEN
C
          CALL THOPAI(NXHERM,NYHERM,NZHERM)
C
          NACTIT=NUMITE-2
C
C          Pairing energy and Lipkin-Nogami correction for neutrons
C
          NAMEPN='NEUTRONS'
C
          ICHARG=0
C
          IF (IPAHFB.EQ.1) THEN
C
              CALL EPAIRI(NXHERM,NYHERM,NZHERM,IN_FIX,IZ_FIX,ITPNMX,
     *                                                       XINFIX)
C
          END IF
C
          IF (LIPKIN.EQ.1) THEN
              EF2NIN=EFER2N
              CALL LIPCOR(GPAIRN,FACTGN,FE2FIN,IF2FIN,SLOWLI,EFER2N,
     *                                                ELIP_N,NACTIT,
     *                                         EFERMN,DELTAN,ICHARG)
              EF2NOU=EFER2N
          END IF
C
          IF (IDEVAR.EQ.1)
     *        CALL GINTER(NXHERM,NYHERM,NZHERM,ICHARG,MREVER,
     *                                  PRHO_N,PRHODN,POWERN)
C
          IF (PRINIT.AND.IPAHFB.EQ.1)
     *
     *        CALL PAIPRI(NAMEPN,GPAIRN,EPAI_N,EFERMN,DELTAN,
     *                                  LIPKIN,EFER2N,ELIP_N,
     *                                  IPAHFB,JPABCS,IAVRGG)
C
C          Pairing energy and Lipkin-Nogami correction for protons
C
          NAMEPN='PROTONS '
C
          ICHARG=1
C
          IF (IPAHFB.EQ.1) THEN
C
              CALL EPAIRI(NXHERM,NYHERM,NZHERM,IN_FIX,IZ_FIX,ITPNMX,
     *                                                       XIZFIX)
C
          END IF
C
          IF (LIPKIP.EQ.1) THEN
              EF2PIN=EFER2P
              CALL LIPCOR(GPAIRP,FACTGP,FE2FIP,IF2FIP,SLOWLI,EFER2P,
     *                                                ELIP_P,NACTIT,
     *                                         EFERMP,DELTAP,ICHARG)
              EF2POU=EFER2P
          END IF
C
          IF (IDEVAR.EQ.1)
     *        CALL GINTER(NXHERM,NYHERM,NZHERM,ICHARG,MREVER,
     *                                  PRHO_P,PRHODP,POWERP)
C
          IF (PRINIT.AND.IPAHFB.EQ.1)
     *
     *        CALL PAIPRI(NAMEPN,GPAIRP,EPAI_P,EFERMP,DELTAP,
     *                                  LIPKIP,EFER2P,ELIP_P,
     *                                  IPAHFB,JPABCS,IAVRGG)
C
      END IF
C
C@@@ HFBTHO - HFBTHO - HFBTHO - HFBTHO - HFBTHO - HFBTHO - HFBTHO
C=======================================================================
C          CALCULATING  T H E   S K Y R M E   E N E R G Y
C=======================================================================
C
      CALL ESKYRM(NXHERM,NYHERM,NZHERM,ENESKY,ENEVEN,ENEODD,
     *                          ENREAR,ENE_W0,EEVEW0,EODDW0,
     *                                               EKESKY)
C
      IF (PRINIT)
     *
     *    CALL PRIFUN(IROTAT,PRIYUK,I_GOGA,IGOGPA,IVIPRI)
C
C@@@ NECK - NECK - NECK - NECK - NECK - NECK - NECK - NECK - NECK
C=======================================================================
C          CALCULATING THE NUMBER OF PARTICLES IN THE NECK
C=======================================================================
C
      IF (IFNECK.GE.1) THEN
C
C          We find the position of the neck
          CALL QNFIND(NXHERM,NYHERM,NZHERM,SLOWOD,ITERUN,ISIMPY,
     *                                            ISIGNY,IPARTY)
C
      END IF
C
C@@@ NECK - NECK - NECK - NECK - NECK - NECK - NECK - NECK - NECK
C=======================================================================
C         CALCULATING THE LINEAR CONSTRAINT CORRELATION MATRIX
C=======================================================================
C
      IF (IPAIRI.EQ.1.AND.IPAHFB.EQ.1.AND.
     *    ISIMPY.EQ.1.AND.IF_RPA.EQ.1) THEN
C
          CALL QMULCM(MREVER,KMULMO,COMULT,IBROYD,MIXMAT,SLOWEV,
     *                                     SLOWOD,NUMITE,NZMAXX)
C
      END IF
C
C=======================================================================
C         DETERMINING THE LINEAR MIXING FACTORS
C=======================================================================
C
      CALL LINMIX(ITERUN,NUMITE,IPCONT,IWRIOL,TERMNT,IF_THO,
     *                                 SLOWEV,SLOWOD,SLOWPA,
     *                                 XOLDEV,XOLDOD,XOLDPA)
C
C=======================================================================
C         CALCULATING THE FIELDS CORRESPONDING TO SKYRME HAMILTONIAN
C=======================================================================
C
      IF (IBROYD.GE.1.AND.MIXMAT.EQ.0)
     *
     *    CALL SKF_IN(NXHERM,NYHERM,NZHERM,IROTAT)
C
      CALL SKFILD(NXHERM,NYHERM,NZHERM,XOLDEV,XOLDOD,IPNMIX)
C
      IF (IBROYD.GE.1.AND.MIXMAT.EQ.0)
     *
     *    CALL SKF_OU(NXHERM,NYHERM,NZHERM,IROTAT)
C
C=======================================================================
C         CALCULATING THE PAIRING FIELDS
C=======================================================================
C
      IF (IPAHFB.EQ.1) THEN
C
          IF (IBROYD.GE.1.AND.MIXMAT.EQ.0)
     *
     *        CALL SKP_IN(NXHERM,NYHERM,NZHERM)
C
          CALL SKPAIR(NXHERM,NYHERM,NZHERM,XOLDPA)
C
          IF (IBROYD.GE.1.AND.MIXMAT.EQ.0)
     *
     *        CALL SKP_OU(NXHERM,NYHERM,NZHERM)
C
      END IF
C
      IF (IBROYD.GE.1.AND.MIXMAT.EQ.0.AND.
     *  ((NUMITE.GT.2.AND.IF_THO.GE.1).OR.
     *   (NUMITE.GT.0.AND.IF_THO.EQ.0)))
     *
     *    CALL DOBROY_FIELDS(NXHERM,NYHERM,NZHERM,
     *                              ITERUN,NOFBRO,
     *                              NSWBRO,ITAKEN,
     *                       IROTAT,IPAHFB,SLOWEV,
     *                       ESTABN,IF_RPA,KEPTES)
C
C=======================================================================
C        READING THE NEW DENSITY MATRICES AFTER THE BROYDEN PROCEDURE
C=======================================================================
C
      IF (LIPKIN.EQ.1.AND.IBROYD.LT.1) EFER2N=SLOWLI *EF2NIN
     *                                  +(1.0-SLOWLI)*EF2NOU
      IF (LIPKIP.EQ.1.AND.IBROYD.LT.1) EFER2P=SLOWLI *EF2PIN
     *                                  +(1.0-SLOWLI)*EF2POU
C
      IF ((LIPKIN.EQ.1.OR.LIPKIP.EQ.1).AND.IBROYD.GE.1
     *                                .AND.MIXMAT.EQ.0)
     *    CALL LIP_OU(ISIMPY,LIPKIN,LIPKIP,EFER2N,EFER2P)
C
C=======================================================================
C          A D D I N G   THE  PROTON   AND   NEUTRON   CONTRIBUTIONS
C=======================================================================
C
      NAMEPN='   TOTAL'
C
      CALL NPLUSP(XINFIX,XIZFIX,KMULMO,KMULSI,KMULMA,IDOPLM)
C
C=======================================================================
C          PRINTING THE MULTIPOLE CONSTRAINTS FOR THE AUGMENTED
C          LAGRANGE METHOD
C=======================================================================
C
      IF (PRINIT) CALL FINPRI(NMUCON,NSICON,ISCHIF)
C
C=======================================================================
C          CALCULATING THE CENTER-OF-MASS COORDINATES. SWITCH "ISHIFT"
C          IS SET TO ISHIFT=1 IF THE SYMMETRY CONDITIONS ALLOW  FOR  A
C          SHIFT BETWEEN THE C-O-M AND LABORATORY FRAMES.
C=======================================================================
C
      CALL COMASS(ISIMPY,ISIGNY,ISIQTY,QMUL_T,KMULMO,ISHIFT)
C
      IF (PRINIT.AND.ISHIFT.EQ.1)
     *
     *    CALL CMSPRI(NAMEPN)
C
C=======================================================================
C          CALCULATING MOMENTS AND RADII IN THE CENTER-OF-MASS FRAME
C=======================================================================
C          ATTENTION!  CALCULATION OF  THE  SCHIFF  MOMENTS  IN  THE
C                      CENTER-OF-MASS FRAME IS  NOT  YET  PROGRAMMED
C                      AND THEREFORE THEY WILL NOT BE LATER PRINTED.
C=======================================================================
C
      CALL SHICOE(KMULMO,KSHIMO,ISHIFT)
      CALL SHIMOM(KMULMO,KSHIMO,ISHIFT)
C
      CALL SHICOE(KMULSI,KSHISI,ISHIFT)
      CALL SHISIF(KMULSI,KSHISI,ISHIFT)
C
      CALL SHIRMS(KMULMO,ISHIFT)
      CALL SHIMAG(KMULMA,KSHIMA,ISHIFT,NOSHIM)
C
C=======================================================================
C          PRINTING THE RESULTS IN THE CENTER-OF-MASS FRAME FOR NEUTRONS
C=======================================================================
C
      IF (PRINIT.AND.IPRI_N.EQ.1) THEN
C
          NAMEPN='NEUTRONS'
C
          IF (ISHIFT.EQ.1.AND.KSHIMO.GT.0) THEN
C
              CALL MOMPRI(ISIMPY,NAMMUL,NAMSHI,NAMEPN,QSHI_N,KSHIMO)
C
              IF (KMULSI.GT.0.AND.ISCHIF.NE.1)
     *        CALL MOMPRI(ISIMPY,NAMSIF,NAMSHI,NAMEPN,SSHI_N,KMULSI)
C
              IF (PRIBET)
     *        CALL BOHDEF(ISIMPY,NEXBET,IPRIBE,IPRIBL,NAMSHI,NAMEPN,
     *                                         RSHI_N,QSHI_N,KSHIMO)
          END IF
C
          IF (ISHIFT.EQ.1.AND.NOSHIM.NE.1)
     *
     *        CALL MAGPRI(ISIMPY,IROTAT,NAMMAG,NAMSHI,NAMEPN,
     *                                         ASHI_N,KMULMA)
C
          NAMEPN='   TOTAL'
C
      END IF
C
C=======================================================================
C          PRINTING THE RESULTS IN THE CENTER-OF-MASS FRAME FOR PROTONS
C=======================================================================
C
      IF (PRINIT.AND.IPRI_P.EQ.1) THEN
C
          NAMEPN=' PROTONS'
C
          IF (ISHIFT.EQ.1.AND.KSHIMO.GT.0) THEN
C
              NAMEPN=' PROTONS'
              CALL MOMPRI(ISIMPY,NAMMUL,NAMSHI,NAMEPN,QSHI_P,KSHIMO)
C
              IF (KMULSI.GT.0.AND.ISCHIF.NE.1)
     *        CALL MOMPRI(ISIMPY,NAMSIF,NAMSHI,NAMEPN,SSHI_P,KMULSI)
C
              IF (PRIBET)
     *        CALL BOHDEF(ISIMPY,NEXBET,IPRIBE,IPRIBL,NAMSHI,NAMEPN,
     *                                         RSHI_P,QSHI_P,KSHIMO)
          END IF
C
          IF (ISHIFT.EQ.1.AND.NOSHIM.NE.1)
     *
     *        CALL MAGPRI(ISIMPY,IROTAT,NAMMAG,NAMSHI,NAMEPN,
     *                                         ASHI_P,KMULMA)
C
          NAMEPN='   TOTAL'
C
      END IF
C
C=======================================================================
C     CALCULATING THE EULER ANGLES OF THE PRINCIPAL-AXES FRAME. THEY ARE
C     DETERMINED IRRESPECTIVE OF ANY SYMMETRY CONDITIONS,  BECAUSE  EVEN
C     IN THE SIGNATURE/PARITY CASE, THE INTRINSIC FRAME CAN DIFFER  FROM
C     THE LABORATORY FRAME DUE TO THE BRINGING OF THE INTRINSIC FRAME TO
C     THE FIRST SECTOR OF BOHR'S VARIABLE 0<=GAMMA<=60. BECAUSE  OF  THE
C     SAME REASON, ALL MOMENTS IN THE INTRINSIC FRAME ARE ALWAYS PRINTED
C     UNLESS THE INPUT DATA SWITCH INTRIP=0 IS SET.
C=======================================================================
C
      CALL EULROT(KSHIMO,KROTMO)
C
      IF (PRINIT) CALL EULPRI(NAMEPN)
C
C=======================================================================
C          CALCULATING MULTIPOLE MOMENTS IN THE PRINCIPAL-AXES FRAME
C=======================================================================
C
      CALL PAXMOM(KSHIMO,KROTMO,QUNITS,QSHI_N,QSHI_P,QSHI_T,
     *            ALPEUL,BETEUL,GAMEUL,QROT_N,QROT_P,QROT_T)
      CALL PAXMOM(KSHISI,KROTSI,SUNITS,SSHI_N,SSHI_P,SSHI_T,
     *            ALPEUL,BETEUL,GAMEUL,SROTNN,SROTNP,SROTNT)
      CALL PAXMOM(KSHIMA,KROTMA,AUNITS,ASHI_N,ASHI_P,ASHI_T,
     *            ALPEUL,BETEUL,GAMEUL,AROTNN,AROTNP,AROTNT)
C
C=======================================================================
C          PRINTING THE RESULTS FOR NUCLEONS
C=======================================================================
C
      IF (PRINIT.AND.IPRI_T.EQ.1) THEN
C
          CALL RADPRI(NAMEPN,RADI_T)
C
          CALL MOMPRI(ISIMPY,NAMMUL,NAMHAR,NAMEPN,QMUL_T,KMULMO)
C
          IF (KMULSI.GT.0)
     *    CALL MOMPRI(ISIMPY,NAMSIF,NAMHAR,NAMEPN,SMUL_T,KMULSI)
          IF (KMULSI.GT.0.AND.IDOPLM.EQ.1)
     *    CALL MOMPRI(ISIMPY,NAMPLM,NAMHAR,NAMEPN,PMUL_T,KMULSI)
C
          CALL MAGPRI(ISIMPY,IROTAT,NAMMAG,NAMHAR,NAMEPN,AMUL_T,KMULMA)
C
          IF (PRIBET)
     *    CALL BOHDEF(ISIMPY,NEXBET,IPRIBE,IPRIBL,NAMHAR,NAMEPN,
     *                                     RADI_T,QMUL_T,KMULMO)
C
          IF (ISHIFT.EQ.1.AND.KSHIMO.GT.0) THEN
C
              CALL MOMPRI(ISIMPY,NAMMUL,NAMSHI,NAMEPN,QSHI_T,KSHIMO)
C
              IF (KMULSI.GT.0.AND.ISCHIF.NE.1)
     *        CALL MOMPRI(ISIMPY,NAMSIF,NAMSHI,NAMEPN,SSHI_T,KMULSI)
C
              IF (PRIBET)
     *        CALL BOHDEF(ISIMPY,NEXBET,IPRIBE,IPRIBL,NAMSHI,NAMEPN,
     *                                         RSHI_T,QSHI_T,KSHIMO)
          END IF
C
          IF (ISHIFT.EQ.1.AND.NOSHIM.NE.1)
     *
     *        CALL MAGPRI(ISIMPY,IROTAT,NAMMAG,NAMSHI,NAMEPN,
     *                                         ASHI_T,KMULMA)
C
          IF (KROTMO.GT.0.AND.INTRIP.NE.0) THEN
C
C=======================================================================
C         HERE WE ENFORCE PRINTING ALL COMPONENTS OF THE ROTATED MOMENTS
C=======================================================================
C
              ISIMPP=0
C
              CALL MOMPRI(ISIMPP,NAMMUL,NAMROT,NAMEPN,QROT_T,KROTMO)
C
              IF (KMULSI.GT.0.AND.ISCHIF.NE.1)
     *        CALL MOMPRI(ISIMPP,NAMSIF,NAMROT,NAMEPN,SROTNT,KMULSI)
C
              IF (PRIBET)
     *        CALL BOHDEF(ISIMPP,NEXBET,IPRIBE,IPRIBL,NAMROT,NAMEPN,
     *                                         RSHI_T,QROT_T,KROTMO)
          END IF
C
          IF (NOSHIM.NE.1.AND.INTRIP.NE.0)
     *    CALL MAGPRI(ISIMPY,IROTAT,NAMMAG,NAMROT,NAMEPN,AROTNT,KMULMA)
C
          IF (COR_CM.OR.
     *       (IROTAT.EQ.1.AND.((ISIMPY.EQ.1.AND.ISIGNY.NE.1).OR.
     *                         (ISIMPY.NE.1.AND.ISIQTY.NE.1)))) THEN
C
              CALL LINPRI(NAMEPN,COR_CM,ALINLT,TLINST(0))
C
          END IF
C
          IF (CORROT) THEN
C
              CALL ROTPRI(NAMEPN,CORROT,AROTLT,TROTST(0))
C
          END IF
C
      END IF
C
      IF (PRINIT) THEN
C
          IF (IROTAT.EQ.1) THEN
C
C=======================================================================
C           CALCULATING ALL ANGULAR MOMENTA IN THE C-O-M AND INTRINSIC
C           FRAMES.
C=======================================================================
C
              CALL ANGSHI(ALINLN,ANGU_N,ANGS_N)
              CALL ANGSHI(ALINLP,ANGU_P,ANGS_P)
              CALL ANGSHI(ALINLT,ANGU_T,ANGS_T)
C
              CALL ANGROT(ALPEUL,BETEUL,GAMEUL,ANGS_N,ANGS_P,ANGS_T,
     *                                         ANGR_N,ANGR_P,ANGR_T)
              CALL ANGROT(ALPEUL,BETEUL,GAMEUL,SPIN_N,SPIN_P,SPIN_T,
     *                                         SPIR_N,SPIR_P,SPIR_T)
C
              CALL ANGPRI(IMOVAX,ISIMPY,ISHIFT,INTRIP)
C
          END IF
C
          IF (IPAIRI.NE.1) THEN
C
              IF (ISIMPY.EQ.1) THEN
C
                  IF (ISIGNY.EQ.1) THEN
C
                      CALL SIGTAB(MREVER,ICHFLI,IPAFLI,IREFLI,
     *                                   ISPFLI,ISHFLI,IFLIPI)
                  ELSE
C
                      CALL SIMTAB(MREVER,ICHFLI,       IREFLI,
     *                                   ISPFLI,ISHFLI,IFLIPI)
                  END IF
C
              ELSE
C
                  IF (ISIQTY.EQ.1) THEN
C
                      CALL SIQTAB(ICHFLI,IPAFLI,
     *                            ISPFLI,ISHFLI,IFLIPI)
                  ELSE
C
                      CALL SIZTAB(ICHFLI,
     *                            ISPFLI,ISHFLI,IFLIPI)
                  END IF
C
              END IF
C
          END IF
C
      END IF
C
C=======================================================================
C          C A L C U L A T I N G  MULTIPOLE-CONSTRAINT   E N E R G I E S
C=======================================================================
C
      IF (KMULMO.LT.NMUCON) STOP 'KMULMO.LT.NMUCON IN MAIN HFODD'
C
      CALL QCNTRS(NMUCON,EMULCO,EMUSLO,EMUREA,IF_RPA)
C
C=======================================================================
C          C A L C U L A T I N G    SURFACE-CONSTRAINT   E N E R G I E S
C=======================================================================
C
      IF (KMULSI.LT.NSICON) STOP 'KMULSI.LT.NSICON IN MAIN HFODD'
C
      CALL SCNTRS(NSICON,ESIFCO,ESISLO,ESIREA)
C
C=======================================================================
C          C A L C U L A T I N G     SPIN-CONSTRAINT     E N E R G I E S
C=======================================================================
C
      CALL ICNTRS(ITILAX,ITISAX,ESPICO,ESPSLO,ESPREA)
C
C=======================================================================
C          C A L C U L A T I N G   T O T A L   E N E R G I E S
C=======================================================================
C
      ESIN_N=0.5D0*(ESUM_N+EKIN_N+EPOT_N)
C
      ESIN_P=0.5D0*(ESUM_P+EKIN_P+EPOT_P)
C
      IF (LIPKIN.EQ.1) ESIN_N=ESIN_N-EFER2N*XINFIX
      IF (LIPKIP.EQ.1) ESIN_P=ESIN_P-EFER2P*XIZFIX
C
      ESIN_T=ESIN_N+ESIN_P
C
      IF (JETACM.EQ.2) THEN
C
          DO KARTEZ=1,NDKART
C
             ESIN_T=ESIN_T+0.5D0*HBMREN(KARTEZ)*DLINST(KARTEZ)
C
             IF (IPAHFB.EQ.1)
     *           ESIN_T=ESIN_T+HBMREN(KARTEZ)*PLINST(KARTEZ)
C
          END DO
C
      END IF
C
      IF (KETA_R.EQ.2) THEN
C
          DO KARTEZ=1,NDKART
C
             ESIN_T=ESIN_T+0.5D0*ROTREN(KARTEZ)*DROTST(KARTEZ)
C
             IF (IPAHFB.EQ.1)
     *           ESIN_T=ESIN_T+ROTREN(KARTEZ)*PROTST(KARTEZ)
C
          END DO
C
      END IF
C
      EKIN_T=EKIN_N+EKIN_P
C
      EPOT_T=EPOT_N+EPOT_P
C
      ESUM_T=ESUM_N+ESUM_P
C
      ECOULT=ECOULD+ECOULE
C
      EPAI_T=EPAI_N+EPAI_P
      EREA_T=EREA_N+EREA_P
      IF (IGOGPA.GE.1) EPAI_T=EPAI_T+PGOGDT
C
      ELIP_T=ELIP_N+ELIP_P
C
      ECOREA=0.0D0
      IF (ICOUEX.EQ.1) ECOREA=-ECOULE/3
C
      ETOTSP=ESIN_T-ENREAR-ECOREA-EMUREA-ESIREA-ESPREA-EREA_T+EPAI_T
C
      ETOTFU=ENESKY+EKIN_T+EPOT_T+ECOULT+EPAI_T
C
      IF (I_YUKA.EQ.2.OR.I_YUKA.EQ.3) ETOTFU=ETOTFU+EYUKDT
      IF (I_YUKA.EQ.2.OR.I_YUKA.EQ.4) ETOTFU=ETOTFU+EYUKET
C
      IF (I_GOGA.EQ.2.OR.I_GOGA.EQ.3) ETOTFU=ETOTFU+EGOGDT
      IF (I_GOGA.EQ.2.OR.I_GOGA.EQ.4) ETOTFU=ETOTFU+EGOGET
C
      IF (LIPKIN.EQ.1) ETOTFU=ETOTFU+ELIP_N
      IF (LIPKIP.EQ.1) ETOTFU=ETOTFU+ELIP_P
C
      ECORCM=0.0D0
C
      IF (COR_CM) THEN
C
          DO KARTEZ=1,NDKART
C
             ECORCM=ECORCM+HBMREN(KARTEZ)*TLINST(KARTEZ)
C
          END DO
C
      END IF
C
      ECOR_R=0.0D0
C
      IF (CORROT) THEN
C
          DO KARTEZ=1,NDKART
C
             ECOR_R=ECOR_R+ROTREN(KARTEZ)*TROTST(KARTEZ)
C
          END DO
C
      END IF
C
      ETOTFU=ETOTFU+ECORCM+ECOR_R
C
      ESTABN=ETOTSP-ETOTFU
C
      IF (JETACM.EQ.1) ESTABN=ESTABN+ECORCM
      IF (KETA_R.EQ.1) ESTABN=ESTABN+ECOR_R
C
C@@@ FISSION - FISSION - FISSION - FISSION - FISSION - FISSION - FISSION
C=======================================================================
C         CALCULATING THE MASSES OF THE LEFT AND RIGHT FRAGMENTS
C         ASSUMING THE NECK IS AT ZPOINT
C=======================================================================
C
      IF (IFRAGM.EQ.1 .AND. TERMNT) THEN
C
#if(USE_MPI==1)
          IF ( NUDATA.EQ.number_batch ) THEN
#endif
C          Finding the position of the neck
          CALL QNFIND(NXHERM,NYHERM,NZHERM,SLOWOD,ITERUN,ISIMPY,
     *                                            ISIGNY,IPARTY)
C
C          Passing some inout variables to fission module
          IF (MIN_QP.EQ.1) THEN
              CALL fission_wrapper(DELTAE,XLOCMX,V2_MIN,ITRMAX,NTHETA)
          END IF
C
C          Computing the mass and charge of the fragments
          CALL RFRAGM(NZHERM,NZMAXX,Z_NECK,RIGMAS,RIGCHA)
C
          ICHARG=0
C
C          Defining the localization of the q.p. (neutrons)
          CALL wave_localization(NZHERM,NZMAXX,Z_NECK,ICHARG)
          CALL print_localization(EFERMN,ICHARG)
C
C          Minimizing the tails of the wave-functions (neutrons)
          IF (MIN_QP.EQ.1) THEN
              CALL minimize_tails(EFERMN,NZHERM,NZMAXX,Z_NECK,ICHARG)
              CALL print_rotation(EFERMN,ICHARG)
          END IF
C
          ICHARG=1
C
C          Defining the localization of the q.p. (protons)
          CALL wave_localization(NZHERM,NZMAXX,Z_NECK,ICHARG)
          CALL print_localization(EFERMP,ICHARG)
C
C          Minimizing the tails of the wave-functions (protons)
          IF (MIN_QP.EQ.1) THEN
              CALL minimize_tails(EFERMP,NZHERM,NZMAXX,Z_NECK,ICHARG)
              CALL print_rotation(EFERMP,ICHARG)
          END IF
C
C          Computes the positions of the centers of mass of the
C          left and right fragments
          CALL center_of_mass(NXHERM,NYHERM,NZHERM,Z_NECK,
     *                                      CENLEF,CENRIG)
C
C          Computing the multipole moments of the fragments
          QLMTOT(:,:,:) = 0.0D0
          QLMPRO(:,:,:) = 0.0D0
          QLMNEU(:,:,:) = 0.0D0
C
          DO LAMBDA=0,NMUPRI
             DO MIU=0,LAMBDA
C
	        IF (MIU.EQ.0.OR.(LAMBDA.EQ.2.AND.MIU.EQ.2)) THEN
C
C                    Calculating multipole moments in the intrinsic
C                    frame of each fragment
C
                    I_TYPE=1
C
                    CALL QLMFRA(NXHERM,NYHERM,NZHERM,Z_NECK,LAMBDA,
     *                                           MIU,QLMLEF,QLMRIG,
     *                                               CENLEF,CENRIG,
     *                                                      I_TYPE)
C
	            QLMTOT(LAMBDA,MIU,0) = QLMLEF
	            QLMTOT(LAMBDA,MIU,1) = QLMRIG
C
                    I_TYPE=2
C
                    CALL QLMFRA(NXHERM,NYHERM,NZHERM,Z_NECK,LAMBDA,
     *                                           MIU,QLMLEF,QLMRIG,
     *                                               CENLEF,CENRIG,
     *                                                      I_TYPE)
C
	            QLMPRO(LAMBDA,MIU,0) = QLMLEF
	            QLMPRO(LAMBDA,MIU,1) = QLMRIG
C
C                    Calculating multipole moments in the intrinsic
C                    frame of the compound nucleus (= the original
C                    reference frame)
C
                    I_TYPE=1
                    CEFLEF=0.0D0
C
                    CALL QLMFRA(NXHERM,NYHERM,NZHERM,Z_NECK,LAMBDA,
     *                                           MIU,QLMLEF,QLMRIG,
     *                                               CEFLEF,CEFLEF,
     *                                                      I_TYPE)
C
	            QORTOT(LAMBDA,MIU,0) = QLMLEF
	            QORTOT(LAMBDA,MIU,1) = QLMRIG
C
                    I_TYPE=2
C
                    CALL QLMFRA(NXHERM,NYHERM,NZHERM,Z_NECK,LAMBDA,
     *                                           MIU,QLMLEF,QLMRIG,
     *                                               CEFLEF,CEFLEF,
     *                                                      I_TYPE)
C
	            QORPRO(LAMBDA,MIU,0) = QLMLEF
	            QORPRO(LAMBDA,MIU,1) = QLMRIG
C
	        END IF
C
             END DO
          END DO
C
          ! Artificially enforces the calculation of the density in
          ! full space because densities for the fragments may have
          ! arbitrary symmetries (or lack thereof)
          IGOGNY=2
C
C          Computes the nuclear and Coulomb energies of the fragments,
C          and the interaction energy between the fragments
C          Note: proton multipole moments for the fragments are necessary
C                to evaluate the Coulomb energy and interaction energy.
C
          CALL interaction_energy_total(ICOUDI,ICOUEX,I_YUKA,NXHERM,
     *                                  NYHERM,NZHERM,ISIMTX,JSIMTY,
     *                                  ISIMTZ,ISIGNY,ISIMPY,ISIQTY,
     *                                  IPAHFB,MREVER,IGOGNY,IGOGPA,
     *                                  NXMAXX,NYMAXX,NZMAXX,NAMEPN,
     *                                  PRINIT,IDEVAR,ITERUN,ISYMDE,
     *                                  INIROT,INIINV,INIKAR,ISAWAV,
     *                                  IKERNE,NUMCOU,BOUCOU,IN_FIX,
     *                                  IZ_FIX,IPAIRI,JETACM,IROTAT,
     *                                  EFERMN,EFERMP,INDJOB,IDEALL,
     *                                  IDELOC,IDECON,IPNMIX,ITIREP)
C
          CALL TESTDI(IN_FIX,IZ_FIX,NXHERM,NYHERM,NZHERM,
     *                              NXMAXX,NYMAXX,NZMAXX,
     *                       ITERUN,ISIMPY,ISIGNY,IPARTY,
     *                                            SLOWOD)
C
C          Computing the distance between the 2 fragments (rather, their
C          respective centers of mass)
          DISFRA = ABS(CENRIG - CENLEF)
C
C          Printing out the mass, charge and deformations of the
C          fragments
          CALL PRIFRA(IN_FIX,IZ_FIX,Z_NECK,Q_NECK,RIGMAS,RIGCHA,
     *                              QLMTOT,QORTOT,DISFRA,NMUPRI)
C
C          Restoring the localization flag so as to take all q.p.
          F_FLAG(:,:,:)=1.0D0
C
#if(USE_MPI==1)
      END IF
#endif
      END IF
C
C@@@ FISSION - FISSION - FISSION - FISSION - FISSION - FISSION - FISSION
C@@@ SHELL - SHELL - SHELL - SHELL - SHELL - SHELL - SHELL
C=======================================================================
C         CALCULATING THE SHELL CORRECTIONS FROM THE EQUIVALENT
C         SIGNLE-PARTICLE SPECTRUM
C=======================================================================
C
      IF (IFSHEL.EQ.1 .AND. TERMNT) THEN
C
          DO I=1,NDNUCL
             DSHELN(I)=0.0D0
             DSHELP(I)=0.0D0
          END DO
C
          IN_LOW=IN_FIX
          NOSTPN=1
          INSTEP=2
C
          IZ_LOW=IZ_FIX
          NOSTPZ=1
          IZSTEP=2
C
          LD_BAS=LDBASE
C
          CALL WSHELL(IN_FIX,IZ_FIX,IFSHEL,MREVER,IPAHFB,IMFHFB,
     *                IZ_LOW,NOSTPZ,IZSTEP,IN_LOW,NOSTPN,INSTEP,
     *                LD_BAS,IZNUCL,INNUCL,LDNUCL,DSHELP,DSHELN,
     *                                     EFERMP,EFERMN,NDBASE)
C
          IF (IPAHFB.EQ.0) THEN
              WRITE(NFIPRI,'(79(''*''),/,''*'',77X,''*'',/,
     *          ''*      SHELL CORRECTION (BASED ON HARTREE-FOCK'',
     *          '' SINGLE-PARTICLE ENERGIES)      *'')')
          END IF
          IF (IPAHFB.EQ.1) THEN
              IF (IMFHFB.EQ.0) THEN
                  WRITE(NFIPRI,'(79(''*''),/,''*'',77X,''*'',/,
     *          ''*           SHELL CORRECTION (BASED ON HFB'',
     *          '' EQUIVALENT SPECTRUM)               *'')')
              END IF
              IF (IMFHFB.EQ.1) THEN
                  WRITE(NFIPRI,'(79(''*''),/,''*'',77X,''*'',/,
     *          ''*           SHELL CORRECTION (BASED ON HFB'',
     *          '' CANONICAL SPECTRUM)                *'')')
              END IF
          END IF
C
          WRITE(NFIPRI,'(''*'',77X,''*'',/,
     *          ''*  SHELL CORR. - NEUTRONS:  '',F9.4,41X,
     *          ''*'',/,''*  SHELL CORR. - PROTONS :  '',
     *                F9.4,41X,''*'',/,''*'',77X,''*'')')
     *
     *              DSHELN(1),DSHELP(1)
C
      END IF
C
C=======================================================================
C   NIKOLA: CALCULATION OF THE KINETIC ENERGY EIGENVALUES
C=======================================================================
C
      IF (IFSHEL.EQ.2.AND.TERMNT) THEN
C
          ISHELL=2
C
          DO I=1,NDNUCL
             DSHELN(I)=0.0D0
             DSHELP(I)=0.0D0
          END DO
C
          IN_LOW=IN_FIX
          NOSTPN=1
          INSTEP=2
C
          IZ_LOW=IZ_FIX
          NOSTPZ=1
          IZSTEP=2
C
          LD_BAS=LDBASE
C
	  IF (ISIMPY.EQ.1) THEN
C
              CALL KINSIG(NXHERM,NYHERM,NZHERM,NXMAXX,NYMAXX,NZMAXX,
     *                    NUMCOU,BOUCOU,ISURFA,IKERNE,ISIMPY,0,
     *                                                MREVER)
C
              CALL KINSIG(NXHERM,NYHERM,NZHERM,NXMAXX,NYMAXX,NZMAXX,
     *                    NUMCOU,BOUCOU,ISURFA,IKERNE,ISIMPY,1,
     *                                                MREVER)
C
          ELSE
C
              CALL KINSIZ(NXHERM,NYHERM,NZHERM,NXMAXX,NYMAXX,NZMAXX,
     *                    NUMCOU,BOUCOU,ISURFA,IKERNE,ISIMPY,0)
C
              CALL KINSIZ(NXHERM,NYHERM,NZHERM,NXMAXX,NYMAXX,NZMAXX,
     *                    NUMCOU,BOUCOU,ISURFA,IKERNE,ISIMPY,1)
C
          END IF
C
          CALL WSHELL(IN_FIX,IZ_FIX,IFSHEL,MREVER,IPAHFB,IMFHFB,
     *                IZ_LOW,NOSTPZ,IZSTEP,IN_LOW,NOSTPN,INSTEP,
     *                LD_BAS,IZNUCL,INNUCL,LDNUCL,DSHELP,DSHELN,
     *                                     EFERMP,EFERMN,NDBASE)
C
          IF (IPAHFB.EQ.0) THEN
              WRITE(NFIPRI,'(79(''*''),/,
     *          ''*      SHELL CORRECTION (BASED ON HARTREE-FOCK'',
     *          '' SINGLE-PARTICLE ENERGIES)     *'')')
          END IF
          IF (IPAHFB.EQ.1) THEN
              IF (IMFHFB.EQ.0) THEN
                  WRITE(NFIPRI,'(79(''*''),/,''*'',77X,''*'',/,
     *          ''*           SHELL CORRECTION (BASED ON HFB'',
     *          '' EQUIVALENT SPECTRUM)               *'')')
              END IF
              IF (IMFHFB.EQ.1) THEN
                  WRITE(NFIPRI,'(79(''*''),/,''*'',77X,''*'',/,
     *          ''*           SHELL CORRECTION (BASED ON HFB'',
     *          '' CANONICAL SPECTRUM)                *'')')
              END IF
          END IF
C
          WRITE(NFIPRI,'(''*'',77X,''*'',/,
     *          ''*  SHELL CORR. - NEUTRONS:  '',F9.4,41X,
     *          ''*'',/,''*  SHELL CORR. - PROTONS :  '',
     *                F9.4,41X,''*'')')
     *
     *              DSHELN(1),DSHELP(1)
C
      END IF
C
C@@@ SHELL -SHELL - SHELL - SHELL - SHELL - SHELL - SHELL
C=======================================================================
C         P R I N T I N G   T H E    E N E R G I E S
C=======================================================================
C
      IF (PRINIT) THEN
C
          CALL PRIENE(JETACM,KETA_R,IPOTHO,I_YUKA,I_GOGA,IGOGPA,
     *                                     LIPKIN,LIPKIP,ICOUEX)
C
          IF (TERMNT.AND.IFTEMP.EQ.1) CALL PRI_FT(COMULT,NZMAXX)
C
      END IF
C
C=======================================================================
C         S T O R I N G   T H E   C O N V E R G E N C E   R E P O R T
C=======================================================================
C
      IF (ITERUN.LE.NDITER) THEN
C
          ETOTFI(ITERUN)=ETOTFU
          ETOTSI(ITERUN)=ETOTSP
          ESTABI(ITERUN)=ESTABN
          QUA20I(ITERUN)=QMUL_T(2,0)
          QUA22I(ITERUN)=QMUL_T(2,2)
          ANGUTI(ITERUN)=ANGU_T(2)
C
      ELSE
C
          WRITE(NFIPRI,'(/,1X,19(1H/),
     *          ''  NO PLACE TO STORE ITERATION NO.='',
     *              I5,2X,19(1H/),/)') ITERUN
C
      END IF
C
C=======================================================================
C         SAVING THE WAVE FUNCTIONS FOR CALCULATION OF THE GCM KERNELS
C=======================================================================
C
      IF (TERMNT.AND.IWRWAV.EQ.1)
     *
     *    CALL SAVEWF(NFIWAV,ITOWAV,FILWAV)
C
C=======================================================================
C         PROJECTING THE ANGULAR MOMENTUM
C=======================================================================
C
      IF (TERMNT.AND.IPRGCM.EQ.1) THEN
C
          IDIAGO=1
          ISAWAV=0
          IKERNE=1
C
          INUWAV=ITOWAV
C
          CALL PROANG(NXHERM,NYHERM,NZHERM,
     *                NXMAXX,NYMAXX,NZMAXX,
     *                ISIMTX,JSIMTY,ISIMTZ,
     *                ISIGNY,ISIMPY,ISIQTY,
     *                IPAHFB,IROTAT,MREVER,
     *                       IDEVAR,ITERUN,
     *                       NMUCOU,ISHIFY,
     *                       INUWAV,ITOWAV,
     *                IDIAGO,IPROMI,IPROMA,
     *                              NBTKNO,
     *  ISOSTZ,ISOSMI,ISOSMA,EPSISO,ICSKIP,
     *                NUAKNO,NUBKNO,KPROJE,
     *         ISAKER,ICHKER,NFIKER,FILKER,
     *                IPAKER,IPAALL,KFIKER,
     *         NUASTA,NUASTO,NUGSTA,NUGSTO,
     *         NUBSTA,NUBSTO,NUTSTA,NUTSTO,
     *                NMUMAX,NMAMAX,NSIMAX,
     *         ISCHIF,NMURED,NMARED,NSIRED,
     *                ICUTOV,CUTOVE,CUTOVF,
     *                       ISLPRI,ISUPRI,
     *                IENPRI,ISRPRI,IMIPRI,
     *                       IKEPRI,IRMPRI,
     *                QMUCUT,QMACUT,QSICUT,
     *                       NUMCOU,BOUCOU,
     *                ICOTYP,ICOUDI,ICOUEX,
     *         ISYMDE,INIROT,INIINV,INIKAR,
     *                       ISAWAV,IKERNE,
     *                IFERME,NFIWAV,FILWAV,
     *                I_GOGA,IGOGPA,I_YUKA,
     *                       SLOWEV,ISEXAC)
C
      END IF
C
C=======================================================================
C         CALCULATING THE GCM KERNELS
C=======================================================================
C
      IF (TERMNT.AND.IPRGCM.EQ.2) THEN
C
          IDIAGO=0
          ISAWAV=0
          IKERNE=1
C
          DO INUWAV=IFRWAV,ITOWAV
C
             CALL READWF(NFIWAV,INUWAV,FILWAV)
C
             CALL PROANG(NXHERM,NYHERM,NZHERM,
     *                   NXMAXX,NYMAXX,NZMAXX,
     *                   ISIMTX,JSIMTY,ISIMTZ,
     *                   ISIGNY,ISIMPY,ISIQTY,
     *                   IPAHFB,IROTAT,MREVER,
     *                          IDEVAR,ITERUN,
     *                          NMUCOU,ISHIFY,
     *                          INUWAV,ITOWAV,
     *                   IDIAGO,IPROMI,IPROMA,
     *                                 NBTKNO,
     *     ISOSTZ,ISOSMI,ISOSMA,EPSISO,ICSKIP,
     *                   NUAKNO,NUBKNO,KPROJE,
     *            ISAKER,ICHKER,NFIKER,FILKER,
     *                   IPAKER,IPAALL,KFIKER,
     *            NUASTA,NUASTO,NUGSTA,NUGSTO,
     *            NUBSTA,NUBSTO,NUTSTA,NUTSTO,
     *                   NMUMAX,NMAMAX,NSIMAX,
     *            ISCHIF,NMURED,NMARED,NSIRED,
     *                   ICUTOV,CUTOVE,CUTOVF,
     *                          ISLPRI,ISUPRI,
     *                   IENPRI,ISRPRI,IMIPRI,
     *                          IKEPRI,IRMPRI,
     *                   QMUCUT,QMACUT,QSICUT,
     *                          NUMCOU,BOUCOU,
     *                   ICOTYP,ICOUDI,ICOUEX,
     *            ISYMDE,INIROT,INIINV,INIKAR,
     *                          ISAWAV,IKERNE,
     *                   IFERME,NFIWAV,FILWAV,
     *                   I_GOGA,IGOGPA,I_YUKA,
     *                          SLOWEV,ISEXAC)
C
          END DO
C
      END IF
C
C=======================================================================
C         RENORMALIZING THE MASS
C=======================================================================
C
      IF (IRENMA.GE.1.OR.IRENIN.GE.1) THEN
C
          IF (IRENIN.GE.1)
     *        STOP ' INERTIA RENORMALIZATION NOT YET IMPLEMENTED'
C
          ISAWAV=0
          IKERNE=1
C
          CALL RENMAS(IRENMA,IDOGOA,I_GOGA,IGOGPA,
     *                       NXHERM,NYHERM,NZHERM,
     *                       NXMAXX,NYMAXX,NZMAXX,
     *                       ISIMTX,JSIMTY,ISIMTZ,
     *                       ISIGNY,ISIMPY,ISIQTY,
     *                IPAIRI,IPAHFB,IROTAT,MREVER,
     *                              IDEVAR,ITERUN,
     *                              NMUCOU,ISHIFY,
     *                       ICUTOV,CUTOVE,CUTOVF,
     *                              NUMCOU,BOUCOU,
     *                ISYMDE,INIROT,INIINV,INIKAR,
     *                              ISAWAV,IKERNE)
C
      END IF
C
      IF (PRINIT.AND.IPRI_T.EQ.1.AND.IRENMA.GE.1) THEN
C
          CALL RENPRI(NAMEPN,TRAMAS,IDOGOA)
C
      END IF
C
C=======================================================================
C
      IF (IWRISO.EQ.1)  CALL ISOPRI(NFIISO)
C
C=======================================================================
C=======================================================================
C          P R I N T I N G   T H E   C O N V E R G E N C E   R E P O R T
C=======================================================================
C=======================================================================
C
      IF (NUMITE.EQ.ITESTA.AND..NOT.TERMNT) THEN
C
          IF (ICONTI.EQ.1) THEN
C
              WRITE(NFIPRI,'(79(1H*),/,1H*,77X,1H*,/,
     *            1H*,1X,'' ITERATION RESTARTED FROM THE DISC,'',
     *                   '' THE FOLLOWING FILE(S) READ:'',  13X,1H*,/,
     *            1H*,2X,A68,                                7X,1H*)')
     *
     *        FILREP
C
              IF (IYCONT.EQ.1)
     *
     *            WRITE(NFIPRI,'(1H*,2X,A68,7X,1H*)') FILYUP
C
              IF (IGCONT.EQ.1)
     *
     *            WRITE(NFIPRI,'(1H*,2X,A68,7X,1H*)') FILGOP
C
              IF (IGPCON.EQ.1)
     *
     *            WRITE(NFIPRI,'(1H*,2X,A68,7X,1H*)') FILGPP
C
              IF (ILCONT.EQ.1)
     *
     *            WRITE(NFIPRI,'(1H*,2X,A68,7X,1H*)') FILLIP
C
              IF (IFCONT.EQ.1)
     *
     *            WRITE(NFIPRI,'(1H*,2X,A68,7X,1H*)') FILFIP
C
              WRITE(NFIPRI,'(1H*,77X,1H*)')
C
          END IF
C
      END IF
C
C=======================================================================
C
      IF (.NOT.TERMNT) THEN
C
C=======================================================================
C         PRINTING THE HEADER
C=======================================================================
C
          IF (I1LINE.EQ.1.AND.(NUMITE.EQ.ITESTA.OR.IPRMID.EQ.1))
     *
     *        WRITE(NFIPRI,'(79(1H*),/,1H*,77X,1H*,/,
     *             1H*,1X,''CONVERGENCE REPORT'',       37X,
     *                    ''                     '',        1H*,/,
     *             1H*,77X,1H*,/,79(1H*),/,         1H*,77X,1H*,/,
     *             1H*,1X,''ITER     ENERGY     STABILITY    Q_2    '',
     *                    ''GAMMA   SPIN  OMEGA   ANGLE   EPAIR'',
     *                                 1X,1H*,/,    1H*,77X,1H*)')
C
          IF (I1LINE.EQ.2.AND.(NUMITE.EQ.ITESTA.OR.IPRMID.EQ.1))
     *
     *        WRITE(NFIPRI,'(79(1H*),/,1H*,77X,1H*,/,
     *             1H*,1X,''CONVERGENCE REPORT'',       37X,
     *                    ''                     '',        1H*,/,
     *             1H*,77X,1H*,/,79(1H*),/,         1H*,77X,1H*,/,
     *             1H*,1X,''ITER     ENERGY     STABILITY    Q_2  '',
     *                    ''DELTAN DELTAP  LAMBD2N LAMBD2P  EPAIR'',
     *                                 1X,1H*,/,    1H*,77X,1H*)')
C
          IF (I1LINE.EQ.3.AND.(NUMITE.EQ.ITESTA.OR.IPRMID.EQ.1))
     *
     *        WRITE(NFIPRI,'(79(1H*),/,1H*,77X,1H*,/,
     *             1H*,1X,''CONVERGENCE REPORT'',       37X,
     *                    ''                     '',        1H*,/,
     *             1H*,77X,1H*,/,79(1H*),/,         1H*,77X,1H*,/,
     *             1H*,1X,''ITER     ENERGY   STABILITY    Q_2  '',
     *                  '' GAMMA   S   lam_n  lamb_p  EpN    EpP '',
     *                                 1X,1H*,/,    1H*,77X,1H*)')
C
          IF (I1LINE.EQ.4.AND.(NUMITE.EQ.ITESTA.OR.IPRMID.EQ.1))
     *
     *        WRITE(NFIPRI,'(79(1H*),/,1H*,77X,1H*,/,
     *             1H*,1X,''CONVERGENCE REPORT'',       37X,
     *                    ''                     '',        1H*,/,
     *             1H*,77X,1H*,/,79(1H*),/,         1H*,77X,1H*,/,
     *             1H*,1X,''ITER     ENERGY   STABILITY    Q10 '',
     *               ''   Q_20     Q22    Q30     Q40    Epai  '',
     *                                 1X,1H*,/,    1H*,77X,1H*)')
C
C=======================================================================
C         CALCULATING THE SCALAR TOTAL QUADRUPOLE MOMENT
C=======================================================================
C
          QROT2T=SQRT(QROT_T(2,0)**2+QROT_T(2,2)**2)
C
C=======================================================================
C         CALCULATING THE BOHR GAMMA ANGLE IN THE INTRINSIC FRAME
C=======================================================================
C
          IF (ABS(QROT_T(2,0)).GT.1.0D-30) THEN
C
              GAMMMA=ATAN(QROT_T(2,2)/QROT_T(2,0))*45.0/ATAN(1.0D0)
C
              IF (QROT_T(2,0).LT.0) GAMMMA=GAMMMA+180.0
C
          ELSE
C
              IF (QROT_T(2,2).GE.0.0) THEN
                  GAMMMA= 90.0
              ELSE
                  GAMMMA=-90.0
              END IF
C
          END IF
C
C=======================================================================
C         CALCULATING THE LENGTHS OF THE ANGULAR MOMENTUM AND ROTATIONAL
C         FREQUENCY VECTORS AND THE ANGLE BETWEEN THEM
C=======================================================================
C
          IF (ISIMPY.EQ.1) THEN
C
              OMETOT=OMOVAY
              ANGTOT=ANGU_T(2)
              ANGLET=0.0
C
          ELSE
C
              OMETOT=OMOVAX   **2+OMOVAY   **2+OMOVAZ   **2
              ANGTOT=ANGU_T(1)**2+ANGU_T(2)**2+ANGU_T(3)**2
              ANGLET=0.0
C
              IF (OMETOT.GT.0.0.AND.ANGTOT.GT.0.0) THEN
C
                  SINANG=1-( OMOVAX*ANGU_T(1)
     *                      +OMOVAY*ANGU_T(2)
     *                      +OMOVAZ*ANGU_T(3))**2/OMETOT/ANGTOT
C
                  IF (ABS(SINANG).LE.1.0D0)
     *
     *                ANGLET=ASIN(SINANG)*45.0D0/ATAN(1.0D0)
C
              END IF
C
              OMETOT=SQRT(OMETOT)
              ANGTOT=SQRT(ANGTOT)
C
          END IF
C
C=======================================================================
C
          IF (ABS(ANGLET).GE.1E-2.OR.ANGLET.EQ.0.0) THEN
C
              WRITE(ANGLEC,'(F8.3)')     ANGLET
          ELSE
              WRITE(ANGLEC,'((1PE8.1))') ANGLET
C
          END IF
C
C=======================================================================
C
          IF (ABS(ESTABN).GE.1E-5.AND.ABS(ESTABN).LT.1E+3) THEN
C
              WRITE(ESTABC,'(F12.6)')     ESTABN
          ELSE
              WRITE(ESTABC,'((1PE12.2))') ESTABN
C
          END IF
C
C=======================================================================
C         PRINTING THE ONE-LINE REPORT FOR THE CURRENT ITERATION
C=======================================================================
C
          IF (NUMITE.LT.100) THEN
              IF (IFPUSH.EQ.1.AND.ITERUN.LE.NITPUS) THEN
                  WRITE(NUMSTR,'(1X,I4,"c")') NUMITE
              ELSE
                  WRITE(NUMSTR,'(1X,I4,1X)') NUMITE
              END IF
	  ELSE
              IF (IFPUSH.EQ.1.AND.ITERUN.LE.NITPUS) THEN
                  WRITE(NUMSTR,'(I5,"c")') NUMITE
              ELSE
                  WRITE(NUMSTR,'(I5,1X)') NUMITE
              END IF
	  END IF
C
          IF (I1LINE.EQ.1)
     *        WRITE(NFIPRI,'(1H*,A6,F12.6,A12,F8.3,
     *                           F8.2,F7.2,F7.3,A8,F8.2,1X,1H*)')
     *        NUMSTR,ETOTFU,ESTABC,QROT2T,
     *        GAMMMA,ANGTOT,OMETOT,ANGLEC,EPAI_T
C
          IF (I1LINE.EQ.2)
     *        WRITE(NFIPRI,'(1H*,A6,F12.6,A12,F8.3,
     *                           F7.3,F7.3,F8.3,F8.3,F8.2,1X,1H*)')
     *        NUMSTR,ETOTFU,ESTABC,QROT2T,
     *        DELTAN,DELTAP,EFER2N,EFER2P,EPAI_T
C
          IF (I1LINE.EQ.3)
     *        WRITE(NFIPRI,'(1H*,A6,F10.4,A12,F8.3,
     *                  F6.1,F6.2,1X,F6.2,1X,F6.2,2F7.2,1X,1H*)')
     *        NUMSTR,ETOTFU,ESTABC,QROT2T,
     *        GAMMMA,ENTRPY(0)+ENTRPY(1),
     *              EFERMN,EFERMP,EPAI_N,EPAI_P
C
          IF (I1LINE.EQ.4)
     *        WRITE(NFIPRI,'(''*'',A6,F10.4,A12,F8.3,5F8.2,'' *'')')
     *        NUMSTR,ETOTFU,ESTABC,
     *               QMUL_T(1,0),QMUL_T(2,0),QMUL_T(2,2),
     *               QMUL_T(3,0),QMUL_T(4,0),EPAI_T
C
          IF (IPRMID.EQ.1)
     *
     *        WRITE(NFIPRI,'(1H*,77X,1H*,/,79(1H*),/)')
C
      END IF
C
C=======================================================================
C         RECORDING THE    F I E L D S   AFTER THIS  I T E R A T I O N
C=======================================================================
C
      IENDPR=0
C
      IF ((TERMNT.OR.IWRIRE.EQ.1).AND.IWRIRE.NE.-1) THEN
C
          IENDPR=1
C
          IF (TERMNT)
     *        WRITE(NFIPRI,'(79(1H*),/,1H*,77X,1H*,/,
     *         1H*,''  CALLING SUBROUTINE "RECORD" TO SAVE'',
     *             '' THE RECORD FILE CONTAINING THE RESULTS'',1X,1H*,/,
     *         1H*,2X,A68,                                     7X,1H*)')
     *
     *         FILREC
C
          IF (TERMNT) THEN
              IF (IWRIOL.EQ.1) THEN
                  WRITE(NFIPRI,'(
     *            1H*,''  THE MEAN FIELDS IN SPACE FROM THE'',
     *                ''  LAST-BUT-ONE ITERATION HAVE BEEN STORED'',
     *                                                         1X,1H*)')
              ELSE
                  WRITE(NFIPRI,'(
     *            1H*,''  THE MEAN FIELDS IN SPACE FROM THE'',
     *                ''  L  A  S  T   ITERATION HAVE BEEN STORED'',
     *                                                         1X,1H*)')
              END IF
          END IF
C
          INPFLD=0
          IERROR=0
C
          CALL RECORD(NFIREP,NFIREC,INPFLD,NUMITE,
     *                       NXHERM,NYHERM,NZHERM,
     *                              IPCONT,ILCONT,
     *                       IACONT,IMCONT,IRCONT,
     *                              IRENMA,IRENIN,
     *                              LIPKIN,LIPKIP,
     *                              REFERN,REFERP,
     *                              REDELN,REDELP,
     *                              REFE2N,REFE2P,
     *                              IFIBLN,INIBLN,
     *                              IFIBLP,INIBLP,
     *                              NMUMAX,NSIMAX,
     *                              NMUCON,ISHIFT,
     *                                     IERROR)
C
c          CLOSE (NFIREC)
C
c          OPEN(NFIREC,FILE=FILREC,STATUS='OLD',FORM='UNFORMATTED')
C
      END IF
C
C=======================================================================
C
      IF ((TERMNT.OR.IWRIYU.EQ.1).AND.IWRIYU.NE.-1.AND.I_YUKA.GE.2) THEN
C
          IF (TERMNT.AND.IENDPR.EQ.0) WRITE(NFIPRI,'(79(1H*))')
C
          IENDPR=1
C
          IF (TERMNT)
     *        WRITE(NFIPRI,'(1H*,77X,1H*,/,
     *         1H*,''  CALLING SUBROUTINE "RECYUK" TO SAVE'',
     *             '' THE YUKAWA FILE CONTAINING THE RESULTS'',1X,1H*,/,
     *         1H*,2X,A68,                                     7X,1H*)')
     *
     *         FILYUC
C
          INPYUK=0
C
          CALL RECYUK(NFIYUP,NFIYUC,INPYUK)
C
          CLOSE(NFIYUC)
C
          OPEN(NFIYUC,FILE=FILYUC,STATUS='OLD',FORM='UNFORMATTED')
C
      END IF
C
C=======================================================================
C
      IF ((TERMNT.OR.IWRIGO.EQ.1).AND.IWRIGO.NE.-1.AND.I_GOGA.GE.2) THEN
C
          IF (TERMNT.AND.IENDPR.EQ.0) WRITE(NFIPRI,'(79(1H*))')
C
          IENDPR=1
C
          IF (TERMNT)
     *        WRITE(NFIPRI,'(1H*,77X,1H*,/,
     *         1H*,''  CALLING SUBROUTINE "RECGOG" TO SAVE'',
     *             '' THE GOGNY  FILE CONTAINING THE RESULTS'',1X,1H*,/,
     *         1H*,2X,A68,                                     7X,1H*)')
     *
     *         FILGOC
C
          INPGOG=0
C
          CALL RECGOG(NFIGOP,NFIGOC,INPGOG)
C
          CLOSE(NFIGOC)
C
          OPEN(NFIGOC,FILE=FILGOC,STATUS='OLD',FORM='UNFORMATTED')
C
      END IF
C
C=======================================================================
C
      IF ((TERMNT.OR.IWRIGO.EQ.1).AND.IWRIGO.NE.-1.AND.IGOGPA.GE.2) THEN
C
          IF (TERMNT.AND.IENDPR.EQ.0) WRITE(NFIPRI,'(79(1H*))')
C
          IENDPR=1
C
          IF (TERMNT)
     *        WRITE(NFIPRI,'(1H*,77X,1H*,/,
     *         1H*,''  CALLING SUBROUTINE "RECGPA" TO SAVE'',
     *             '' THE GOGNY  FILE CONTAINING THE RESULTS'',1X,1H*,/,
     *         1H*,2X,A68,                                     7X,1H*)')
     *
     *         FILGPC
C
          INPGPA=0
C
          CALL RECGPA(NFIGPP,NFIGPC,INPGPA)
C
          CLOSE(NFIGPC)
C
          OPEN(NFIGPC,FILE=FILGPC,STATUS='OLD',FORM='UNFORMATTED')
C
      END IF
C
C=======================================================================
C
      IF ((TERMNT.OR.IWRILI.EQ.1).AND.IWRILI.NE.-1.AND.
     *    (LIPKIN.EQ.1.OR.LIPKIP.EQ.1)) THEN
C
          IF (TERMNT.AND.IENDPR.EQ.0) WRITE(NFIPRI,'(79(1H*))')
C
          IENDPR=1
C
          IF (TERMNT)
     *        WRITE(NFIPRI,'(1H*,77X,1H*,/,
     *        1H*,''  CALLING SUBROUTINE "RECLIP" TO SAVE'',
     *            '' THE LIPKIN FILE CONTAINING RESULTS '',4X,1H*,/,
     *        1H*,2X,A68,                                  7X,1H*)')
     *
     *        FILLIC
C
          INPLIP=0
C
          CALL RECLIP(NFILIP,NFILIC,INPLIP,ISIMPY)
C
          CLOSE(NFILIC)
C
          OPEN(NFILIC,FILE=FILLIC,STATUS='OLD',FORM='UNFORMATTED')
C
      END IF
C
C=======================================================================
C
      IF ((TERMNT.OR.IWRIFI.EQ.1).AND.IWRIFI.NE.-1) THEN
C
          IF (TERMNT.AND.IENDPR.EQ.0) WRITE(NFIPRI,'(79(1H*))')
C
          IENDPR=1
C
          IF (TERMNT)
     *        WRITE(NFIPRI,'(1H*,77X,1H*,/,
     *         1H*,''  CALLING SUBROUTINE "RECFIL" TO SAVE'',
     *             '' THE FIELDS FILE CONTAINING THE RESULTS'',1X,1H*,/,
     *         1H*,2X,A68,                                     7X,1H*)')
     *
     *         FILFIC
C
          INPFIL=0
          IFWTHO=0
C
          CALL RECFIL(NFIFIP,NFIFIC,INPFIL,ISIMPY,IPAHFB,
     *                                     NOSCIL,NUMITE,
     *                       EFERMN,EFERMP,EFER2N,EFER2P,
     *                       DELTAN,DELTAP,FCHOM0,IFWTHO,
     *                                     NLIMIT,FILTHO)
C
          CLOSE(NFIFIC)
C
          OPEN(NFIFIC,FILE=FILFIC,STATUS='OLD',FORM='UNFORMATTED')
C
      END IF
C
      IF (TERMNT.AND.IENDPR.EQ.1)WRITE(NFIPRI,'(1H*,77X,1H*,/,79(1H*))')
C
C=======================================================================
C
      IF (.NOT.TERMNT) THEN
C
          CALL CNVRGE(ESTABN,EPSITE,IS_YES,ITERUN,NULAST)
C
          IF (IS_YES.EQ.1.OR.NUMITE+1.GE.ITESTO) THEN
C
C=======================================================================
C             HERE WE DEAL WITH THE SITUATION WHEN EITHER THE
C             CONVERGENCE HAS BEEN ACHIEVED, OR THE LIMIT  OF
C             ALLOWED ITERATIONS IS ABOUT TO BE EXCEEDED. THE
C             NEXT INTERATION WILL BE THE TERMINAL ONE.
C=======================================================================
C
              WRITE(NFIPRI,'(1H*,77X,1H*,/,79(1H*),/)')
C
              TERMNT=.TRUE.
C
          ELSE
C
              IF (IS_PIN.EQ.1) THEN
C
C=======================================================================
C             HERE WE DEAL WITH THE SITUATION  WHEN  THE  PING-PONG
C             CONDITION HAS BEEN DETECTED IN THE PREVIOUS ITARATION.
C             THE NEXT INTERATION WILL BE THE TERMINAL ONE.
C=======================================================================
C
                  WRITE(NFIPRI,'(1H*,77X,1H*,/,79(1H*),/)')
C
                  WRITE(NFIPRI,'(79(1H*),/,1H*,77X,1H*,/,
     *                  1H*,1X,''PING-PONG CONDITION'',
     *                         '' DETECTED, ITERATIO'',
     *                         ''N FOR THIS DATA SET'',
     *                         '' IS BEING  ABORTED '',1H*,/,
     *                  1H*,77X,1H*,/,79(1H*),/)')
C
                  TERMNT=.TRUE.
C
              ELSE
C
C=======================================================================
C             HERE WE DEAL WITH THE  SITUATION  WHEN  THE  PING-PONG
C             CONDITION HAS NOT YET BEEN DETECTED. IF IT IS DETECTED
C             NOW, WE SHOULD CONTINUE AS IF NOTHING HAPPENED BECAUSE
C             IN THE THE NEXT ITERATION WE  HAVE  TO  CALCULATE  THE
C             SINGLE-PARTICLE PROPERTIES REQUIRED BY FLISIG, FLISIM,
C             FLISIQ, OR FLISIZ
C=======================================================================
C
                  CALL PINGPO(EPSPNG,IS_PIN,ITERUN,NUPING)
C
              END IF
C
              IF (IS_CHA.EQ.1) THEN
C
C=======================================================================
C             HERE WE DEAL WITH  THE  SITUATION  PERTAINING  TO  THE
C             CHAOTIC-DIVERGENCE CONDITION DETECTED IN THE  PREVIOUS
C             ITARATION. THE NEXT INTERATION WILL BE TERMINAL.
C=======================================================================
C
                  WRITE(NFIPRI,'(1H*,77X,1H*,/,79(1H*),/)')
C
                  WRITE(NFIPRI,'(79(1H*),/,1H*,77X,1H*,/,
     *                  1H*,1X,''CHAOTIC  DIVERGENCE'',
     *                         '' DETECTED, ITERATIO'',
     *                         ''N FOR THIS DATA SET'',
     *                         '' IS BEING  ABORTED '',1H*,/,
     *                  1H*,77X,1H*,/,79(1H*),/)')
C
                  TERMNT=.TRUE.
C
              ELSE
C
C=======================================================================
C             HERE WE DEAL WITH  THE  SITUATION  PERTAINING  TO  THE
C             CHAOTIC-DIVERGENCE CONDITION NOT YET DETECTED  IN  THE
C             PREVIOUS ITARATION. IF IT IS DETECTED NOW,  WE  SHOULD
C             CONTINUE AS IF NOTHING HAPPENED  BECAUSE  IN  THE  THE
C             NEXT INTERATION WE HAVE TO CALCULATE THE
C             S I N G L E - P A R T I C L E      P R O P E R T I E S
C=======================================================================
C
                  CALL CHAODI(IS_CHA,ITERUN,NUCHAO)
C
              END IF
C
          END IF
C
          GO TO 1
C
      ELSE
C
          IF (IS_PIN.EQ.1) THEN
C
              WRITE(NFIPRI,'(//,79(1H*),/,1H*,77X,1H*,/,
     *          ''*  WARNING! ITERATION WAS ABORTED BECAUSE '',
     *          ''OF THE "PING-PONG"-TYPE DIVERGENCE  *'',/,
     *          ''*  WARNING! ITERATION WAS ABORTED BECAUSE '',
     *          ''OF THE "PING-PONG"-TYPE DIVERGENCE  *'',/,
     *            1H*,77X,1H*,/,79(1H*),/,1H*,77X,1H*)')
C
              IF (ISIMPY.EQ.1) THEN
C
                  IF (ISIGNY.EQ.1) THEN
C
                      CALL FLISIG(MREVER)
                  ELSE
                      CALL FLISIM(MREVER)
C
                  END IF
C
              ELSE
C
                  IF (ISIQTY.EQ.1) THEN
C
                      CALL FLISIQ
                  ELSE
                      CALL FLISIZ
C
                  END IF
C
              END IF
C
          END IF
C
          IF (IS_CHA.EQ.1) THEN
C
              WRITE(NFIPRI,'(//,79(1H*),/,1H*,77X,1H*,/,
     *          ''*   WARNING! ITERATION WAS ABORTED BECAUSE'',
     *          '' OF THE "C H A O T I C" DIVERGENCE  *'',/,
     *          ''*   WARNING! ITERATION WAS ABORTED BECAUSE'',
     *          '' OF THE "C H A O T I C" DIVERGENCE  *'',/,
     *            1H*,77X,1H*,/,79(1H*),/,1H*,77X,1H*)')
C
          END IF
C
          CALL CNVRGE(ESTABN,EPSITE,IS_YES,ITERUN,NULAST)
C
          IF (IS_YES.NE.1.AND.EPSITE.GT.0.0.AND.
     *                        NUMITE.GE.ITESTO) THEN
C
              WRITE(NFIPRI,'(//,79(1H*),/,1H*,77X,1H*,/,
     *              ''* WARNING! THE STABILITY REQUIRED WAS NOT '',
     *              ''ACHIEVED. NO-OF-ITERATIONS EXCEEDED *'',/,
     *              ''* WARNING! THE STABILITY REQUIRED WAS NOT '',
     *              ''ACHIEVED. NO-OF-ITERATIONS EXCEEDED *'',/,
     *                1H*,77X,1H*,/,79(1H*),/,1H*,77X,1H*)')
C
          END IF
C
C=======================================================================
C         STORING THE REVIEW OF RESULTS FOR THIS DATA SET
C=======================================================================
C
          IF (IREVIE.NE.0)
     *
     *        CALL REVIEW(NFIREV,VERSIO,IN_FIX,IZ_FIX,
     *                                  SKYRME,GOGNAM,
     *             ISTAND,KETA_J,KETA_W,KETACM,KETA_M,
     *                    JETA_J,JETA_W,JETACM,JETA_M,
     *                                         KETA_R,
     *             LANODD,LANSCA,HBMSAT,RHOSAT,EFFSAT,
     *                    NMUMAX,NMUCON,NMUCOU,NMUPRI,
     *                    ISCHIF,NSIMAX,NSICON,NSIPRI,
     *                           NMAMAX,NMACON,NMAPRI,
     *                           NMURED,NMARED,NSIRED,
     *                           LAMMAX,NOSCIL,NLIMIT,
     *                    DELFIN,DELFIP,IDEFIN,IDEFIP,
     *                    FERFIN,FERFIP,IFEFIN,IFEFIP,
     *                    FE2FIN,FE2FIP,IF2FIN,IF2FIP,
     *                    INSIGN,IPSIGN,ISSIGN,IDSIGN,
     *                    INSIGP,IPSIGP,ISSIGP,IDSIGP,
     *                           INSIMN,IRSIMN,IDSIMN,
     *                           INSIMP,IRSIMP,IDSIMP,
     *                           INSIQN,IPSIQN,IDSIQN,
     *                           INSIQP,IPSIQP,IDSIQP,
     *                                  INSIZN,IDSIZN,
     *                                  INSIZP,IDSIZP,
     *                                  IFIBLN,INIBLN,
     *                                  IFIBLP,INIBLP,
     *                                         NILXYZ,
     *                                  ECUTOF,LIMQUA,
     *                                         IPOTHO,
     *             IPAIRI,IPAHFB,ITWOBA,JPABCS,IMFHFB,
     *                                  LIPKIN,LIPKIP,
     *                    IROTAT,IREVIE,MREVER,
     *                    FILREP,FILREC,FILWOO,
     *                    FILREV,FILCOU,FILWAV,FILKER,
     *                    FILYUP,FILYUC,
     *                    FILGOP,FILGOC,
     *                    FILGPP,FILGPC,
     *                    FILLIP,FILLIC,
     *                    FILFIP,FILFIC,
     *                    CMSXFC,CMSYFC,CMSZFC,
     *                    XMOMFC,YMOMFC,ZMOMFC,
     *                    NXHERM,NYHERM,NZHERM,
     *                    NXMAXX,NYMAXX,NZMAXX,
     *                    EPSHER,
     *                    HOMEGA,FCHOM0,ENECUT,
     *                    CVOLFC,R0PARM,
     *                                  ISOTRO,
     *                    NUMCOU,NUMETA,FURMAX,
     *                    ICOTYP,ICOUDI,ICOUEX,
     *             PIMASS,PNMASS,IYUTYP,I_YUKA,
     *             YUKAGT,YUKAG0,YUKAG1,YUKAG2,
     *                           I_GOGA,IGOGPA,
     *                    ISPHER,ISIMPY,ISIGNY,
     *                           IPARTY,ISIQTY,
     *                    ISIMTX,JSIMTY,ISIMTZ,
     *                           NULAST,EPSITE,
     *                    INIROT,INIINV,INIKAR,
     *                    NUCHAO,NUPING,EPSPNG,
     *                    ICHFLI,IPAFLI,IREFLI,
     *                    ISPFLI,ISHFLI,IFLIPI,
     *             SLOWEV,SLOWOD,SLOWPA,SLOWLI,
     *             IMOVAX,ITILAX,ITISAX,NO_ORB,
     *                    IS_YES,IS_PIN,IS_CHA)
C
C=======================================================================
C         DEALLOCATING BIG ARRAYS ALLOCATED IN ALLODE() AND ALLOVF()
C=======================================================================
C
          CALL DEALDE()
          CALL DEALVF()
C
C=======================================================================
C         HERE ENDS THE SUCCESSFUL CALCULATION STEP
C=======================================================================
C
          WRITE(NFIPRI,'(79(1H*),/,             1H*,77X,1H*,/,
     *             1H*,2X,''CALCULATION OF THE DATA SET NO.'',
     *                 I3,'' HAS BEEN SUCCESSFULLY COMPLETED'',
     *                                           9X,1H*,/,
     *                                      1H*,77X,1H*,/,
     *                                          79(1H*),/)')
     *
     *                                           NUDATA
C
C=======================================================================
C         THE FOLLOWING "GO TO 3" CORRESPONDS TO A NEW READ "NAMELI"
C=======================================================================
C
#if(USE_MPI==0)
          GO TO 3
#endif
C
      END IF ! end of TERMNT.EQ.TRUE
C
C=======================================================================
C         GATHERING EXECUTION TIMES FROM ALL PROCESSORS AND
C         CLOSING MPI ENVIRONMENT
C=======================================================================
C
#if(USE_MPI==1)
C
               NUDATA=NUDATA+1
C
               IF (NUDATA.GT.number_batch) EXIT
C
            END DO ! end DO (NUDATA<=number_batch)
C
            ! Properly close all files that could have been left
            ! opened (with the exclusion of the output unit NFIPRI)
            CALL IOCLOS(NFIWOO,NFIREP,NFIREV,NFIREC,NFICOU,NFIWAV,
     *                  NFIKER,NFIYUP,NFIYUC,NFIGOC,NFIGOP,NFIGPC,
     *                  NFIGPP,NFILIP,NFILIC,NFIFIP,NFIFIC,NFIISO)
C
            ! In batch mode, copy all common restart/rec files in from
            ! the ./restart/ directory to the ./rec/ directory
            IF (batch_mode.EQ.1) THEN
                Write(optimal,'("./restart/HFODD_",I8.8,".REC")')
     *                INDFIL
                Write(courant,'("./rec/HFODD_",I8.8,".REC")')
     *                INDFIL
                commande = 'cp '//Trim(optimal)//' '//Trim(courant)
                Call system(commande)
            END IF
C
         END IF ! end of 'if (worldRank.eq.mod(...))'
C
      END DO procLoop ! end of job loop (name: procLoop)
C
      ! Switching off the time counters
      CALL CPUTIM('HFODD ',0)
C
      ! Printing all times by local routines
      CALL TIMPRI
C
      CALL DATE_AND_TIME(MYDATE,MYTIME,MYZONE,MYVALU)
C
      WRITE(NFIPRI,'(1H*,77X,1H*,/,1H*,2X,
     *      ''EXECUTION ENDS ON '',A4,''.'',A2,''.'',A2,'' AT '',
     *                               A2,'':'',A2,'':'',A6,
     *                              31X,1H*,/,1H*,77X,1H*,/,79(1H*))')
     *
     *      MYDATE(1:4),MYDATE(5:6),MYDATE(7:8),
     *      MYTIME(1:2),MYTIME(3:4),MYTIME(5:10)
C
      ! closing the unit containing the output file
      CLOSE(NFIPRI)
C
      ! In batch mode, we remove the restart directory, the content of
      ! which has been copied to rec/, and rename our backup directory
      ! At the end, we thus have the following structure:
      !  - ./rec/ contains all record files
      !  - ./restart/ contains the restart files associated with each of
      !    the record files in rec/
      !  - ./restart_old/ contains the original set of restart files.
      IF (batch_mode.EQ.1) THEN
          commande = 'rm -rf restart'
          Call system(commande)
          commande = 'mv restart_tmp restart'
          Call system(commande)
      END IF
C
      ! Record system and CPU starting times
      call cpu_time(cput_end)
      call system_clock(syst_cnt, syst_rate)
      syst_end = real(syst_cnt,KIND=8) / real(syst_rate,KIND=8)
C
      my_evals(0) = counter_eval
      my_cputime(0) = cput_end  - cput_start
C
      call mpi_gather(my_evals, 1, MPI_INTEGER, all_evals, 1,
     *                MPI_INTEGER, 0, MPI_COMM_WORLD, mpi_err)
C
      if (mpi_err .NE. 0) then
          if ( worldRank == 0 ) then
              write(nfisum,'(''Error when gathering evaluations '',
     *                       ''counters'')')
              write(nfisum,'(''Error code: mpi_err = '',i12)') mpi_err
          end if
      end if
C
      call mpi_gather(my_cputime, 1, MPI_DOUBLE_PRECISION, all_cputimes,
     *                            1, MPI_DOUBLE_PRECISION,
     *                            0, MPI_COMM_WORLD, mpi_err)
C
      if (mpi_err .NE. 0) then
          if ( worldRank == 0 ) then
              write(nfisum,'(''Error when gathering CPU times'')')
              write(nfisum,'(''Error code: mpi_err = '',i12)') mpi_err
          end if
      end if
C
      deallocate(my_cputime, my_evals)
C
      if ( worldRank == 0 ) then
C
          write(nfisum,'(''  Rank     Evals  CPU time'')')
          write(nfisum,'(28(''-''))')
C
          do mpi_rank = 0, worldSize-1
             write(nfisum,'(1x,i7,i10,f10.3)')
     *             mpi_rank, all_evals(mpi_rank),
     *                       all_cputimes(mpi_rank)
          end do
          write(nfisum,'(''System time = '',F20.14)')
     *                     syst_end - syst_start
C
          close(nfisum)
C
      end if
C
C=======================================================================
C         CLOSING MPI ENVIRONMENT
C=======================================================================
C
      CALL mpi_barrier(MPI_COMM_WORLD, mpi_err)
C
#if(USE_SCALAPACK==1)
      CALL BLACS_EXIT(1)
#endif
C
      ! Close MPI environment
      CALL mpi_finalize(mpi_err)
C
#endif
C
      END
C
C=======================================================================
C
      SUBROUTINE PROANG(NXHERM,NYHERM,NZHERM,
     *                  NXMAXX,NYMAXX,NZMAXX,
     *                  ISIMTX,JSIMTY,ISIMTZ,
     *                  ISIGNY,ISIMPY,ISIQTY,
     *                  IPAHFB,IROTAT,MREVER,
     *                         IDEVAR,ITERUN,
     *                         NMUCOU,ISHIFY,
     *                         INUWAV,ITOWAV,
     *                  IDIAGO,IPROMI,IPROMA,
     *                                NBTKNO,
     *    ISOSTZ,ISOSMI,ISOSMA,EPSISO,ICSKIP,
     *                  NUAKNO,NUBKNO,KPROJE,
     *           ISAKER,ICHKER,NFIKER,FILKER,
     *                  IPAKER,IPAALL,KFIKER,
     *           NUASTA,NUASTO,NUGSTA,NUGSTO,
     *           NUBSTA,NUBSTO,NUTSTA,NUTSTO,
     *                  NMUMAX,NMAMAX,NSIMAX,
     *           ISCHIF,NMURED,NMARED,NSIRED,
     *                  ICUTOV,CUTOVE,CUTOVF,
     *                         ISLPRI,ISUPRI,
     *                  IENPRI,ISRPRI,IMIPRI,
     *                         IKEPRI,IRMPRI,
     *                  QMUCUT,QMACUT,QSICUT,
     *                         NUMCOU,BOUCOU,
     *                  ICOTYP,ICOUDI,ICOUEX,
     *           ISYMDE,INIROT,INIINV,INIKAR,
     *                         ISAWAV,IKERNE,
     *                  IFERME,NFIWAV,FILWAV,
     *                  I_GOGA,IGOGPA,I_YUKA,
     *                         SLOWEV,ISEXAC)
C
C=======================================================================
      USE SAVLEF
      USE SAVRIG
      USE WAVR_L
      USE REDMOM
C=======================================================================
      USE MAT_PP
      USE MAT_PM
C=======================================================================
      USE hfodd_sizes
C=======================================================================
C
      CHARACTER
     *          FILKER*68,FILWAV*68,FILACT*83,FILINP*83
      CHARACTER
     *          NAMEPN*8
      CHARACTER
     *          CHALFI*2
      CHARACTER
     *          NAMMUL*45,NAMSUR*45,NAMSCH*45,NAMMAG*45
      CHARACTER
     *          NAMWRK*45
      CHARACTER
     *          HAFLIN*38
      CHARACTER
     *          LINE_0*1,LINE_1*1,LINE_2*1,LINE_3*1
C
      LOGICAL
     *          PRINIT
C
      COMPLEX
     *          DNPRHO,DNPTAU,DNPLPR,DNPDIV,DNPSPI,DNPKIS,
     *          DNPGRR,DNPLPS,DNPROS,DNPROC,DNPCUR,DNPSCU,DNPDES
      COMPLEX
     *          DPNRHO,DPNTAU,DPNLPR,DPNDIV,DPNSPI,DPNKIS,
     *          DPNGRR,DPNLPS,DPNROS,DPNROC,DPNCUR,DPNSCU,DPNDES
      COMPLEX
     *          PNPRHO,PPNRHO,SOURCE
      COMPLEX
     *          Q00T,Q10T,Q1PT,Q1MT
      COMPLEX
     *          EKESKY,EKEKIN,EKECOD,EKECOE,EKESCA,EKEVEC
      COMPLEX
     *          OVRLAP
      COMPLEX
     *          AUXDIA,C_ZERO,C_UNIT,UNIT_I
      COMPLEX
     *          DETWRK
      COMPLEX
     *          WARAUX,TARIGH
      COMPLEX
     *          OVKERN,SKKERN,EKKERN,
     *          CDKERN,CDKE10,CDKE1P,
     *          CXKERN,CXKE10,CXKE1P,
     *          CDKE1M,CDKE20,CDK21P,CDK21M,CDK22P,CDK22M,
     *          CXKE1M,CXKE20,CXK21P,CXK21M,CXK22P,CXK22M,
     *                               QPKERN,APKERN,SPKERN,
     *          CD0000,CD0010,CD001P,CD001M,CD1010,CD101P,
     *                        CD101M,CD1P1M,CD1P1P,CD1M1M,
     *          CX0000,CX0010,CX001P,CX001M,CX1010,CX101P,
     *                        CX101M,CX1P1M,CX1P1P,CX1M1M,
     *                        PNKE00,PNKE10,PNKE1P,PNKE1M
      COMPLEX
     *          FACINT,FACI1P,FACI1M,FACI2P,FACI2M,
     *          FACMOM
      COMPLEX
     *          QMUT_N,QMUT_P,QMUT_T
      COMPLEX
     *          AMUT_N,AMUT_P,AMUT_T
      COMPLEX
     *          SMUT_N,SMUT_P,SMUT_T
      COMPLEX
     *          EPROJE,OPROJE
      COMPLEX
     *          ZKER_T,ZSKY_T,ZKIN_N,ZKIN_P,ZCOU_D,ZCOU_X,ZMUL_P,ZMAG_P,
     *                        ZSIF_P,ZC10_D,ZC1P_D,ZC1M_D,
     *                               ZC10_X,ZC1P_X,ZC1M_X,
     *                               ZC20_D,ZC21PD,ZC21MD,ZC22PD,ZC22MD,
     *                               ZC20_X,ZC21PX,ZC21MX,ZC22PX,ZC22MX,
     *                               ZPNU00,ZPNU10,ZPNU1P,ZPNU1M
      COMPLEX
     *          CKER_T,CSKY_T,CKIN_N,CKIN_P,CCOU_D,CCOU_X,CMUL_P,CMAG_P,
     *                        CSIF_P,CC10_D,CC1P_D,CC1M_D,
     *                               CC10_X,CC1P_X,CC1M_X,
     *                               CC20_D,CC21PD,CC21MD,CC22PD,CC22MD,
     *                               CC20_X,CC21PX,CC21MX,CC22PX,CC22MX,
     *                               CPNU00,CPNU10,CPNU1P,CPNU1M
      COMPLEX
     *          TKER_T,TSKY_T,TKIN_N,TKIN_P,TCOU_D,TCOU_X,TMUL_P,TMAG_P,
     *                        TSIF_P,TC10_D,TC1P_D,TC1M_D,
     *                               TC10_X,TC1P_X,TC1M_X,
     *                               TC20_D,TC21PD,TC21MD,TC22PD,TC22MD,
     *                               TC20_X,TC21PX,TC21MX,TC22PX,TC22MX,
     *                               TPNU00,TPNU10,TPNU1P,TPNU1M
      COMPLEX
     *          TKE_TT,TSK_TT,TKI_NT,TKI_PT,TCO_DT,TCO_XT,
     *                               TC1_D0,TC1_DP,TC1_DM,
     *                               TC1_X0,TC1_XP,TC1_XM,
     *                               TC2_D0,TC21DP,TC21DM,TC22DP,TC22DM,
     *                               TC2_X0,TC21XP,TC21XM,TC22XP,TC22XM,
     *                               TPN_00,TPN_10,TPN_1P,TPN_1M
      COMPLEX
     *          RKER_T,RSKY_T,RKIN_T,RCOU_D,RCOU_X,
     *          RMUL_P,RMAG_P,RSIF_P,RCOU_1,RCOU_2,
     *          RPARTN,RISOSP
      COMPLEX
     *          CELMTS,HAMMAT,HAMWAV,WFI0T1,WPROI0
      COMPLEX
     *          BNN_PP,BNN_PM,BNP_PP,BNP_PM,
     *          BPP_PP,BPP_PM,BPN_PP,BPN_PM
      COMPLEX
     *          DKINSQ
C
      DIMENSION
     *          CELMTS(1:((NDPROT+1)*NDPROT)/2)
      DIMENSION
     *          HAMWAV(1:NDPROT,1:NDPROT),HAMEIG(1:NDPROT)
      DIMENSION
     *          HAMMAT(1:NDPROT,1:NDPROT)
      COMMON
     *       /TMX0RA/ WPROI0(NDPROT),WFI0T1(NDPROT),E_I0T1
      COMMON
     *       /TMX0RB/ NPROI0(NDPROT),I_I0T1
C
      DIMENSION
     *                LINE_0(NUMCOL+1),LINE_1(NUMCOL+1),
     *                LINE_2(NUMCOL+1),LINE_3(NUMCOL+1)
C=======================================================================
      ALLOCATABLE BNN_PP(:,:,:)
      ALLOCATABLE BNN_PM(:,:,:)
      ALLOCATABLE BNP_PP(:,:,:)
      ALLOCATABLE BNP_PM(:,:,:)
      ALLOCATABLE BPP_PP(:,:,:)
      ALLOCATABLE BPP_PM(:,:,:)
      ALLOCATABLE BPN_PP(:,:,:)
      ALLOCATABLE BPN_PM(:,:,:)
C=======================================================================
      ALLOCATABLE OVRLAP(:,:)
      ALLOCATABLE WARAUX(:,:)
      ALLOCATABLE TARIGH(:,:,:)
C=======================================================================
      DIMENSION
     *          AUXDIA(1:4*NDSTAT),IAUXDI(1:4*NDSTAT)
      DIMENSION
     *          DETWRK(2)
      COMMON /KNOTS/
     *          XA_PNT(1:NDAKNO),XA_WGT(1:NDAKNO),
     *          XB_PNT(1:NDBKNO),XB_WGT(1:NDBKNO),
     *          XBT_PN(1:NDBTKN),XBT_WG(1:NDBTKN)
      DIMENSION
     *          ISALGA(1:NDAKNO,1:NDAKNO),
     *          ISAALL(1:NDAKNO,1:NDBKNO,1:NDAKNO,1:NDBTKN)
      DIMENSION
     *          HAFLIN(2)
C
C --> OVERLAP, SKYRME, AND KINETIC ENRGY KERNELS:
C
C=======================================================================
      ALLOCATABLE OVKERN(:,:,:,:)
      ALLOCATABLE SKKERN(:,:,:,:)
      ALLOCATABLE EKKERN(:,:,:,:)
      ALLOCATABLE QPKERN(:,:,:,:)
      ALLOCATABLE APKERN(:,:,:,:)
      ALLOCATABLE CDKERN(:,:,:,:)
      ALLOCATABLE CDKE10(:,:,:,:)
      ALLOCATABLE CDKE1P(:,:,:,:)
      ALLOCATABLE CDKE1M(:,:,:,:)
      ALLOCATABLE CDKE20(:,:,:,:)
      ALLOCATABLE CDK21P(:,:,:,:)
      ALLOCATABLE CDK21M(:,:,:,:)
      ALLOCATABLE CDK22P(:,:,:,:)
      ALLOCATABLE CDK22M(:,:,:,:)
      ALLOCATABLE CXKERN(:,:,:,:)
      ALLOCATABLE CXKE10(:,:,:,:)
      ALLOCATABLE CXKE1P(:,:,:,:)
      ALLOCATABLE CXKE1M(:,:,:,:)
      ALLOCATABLE CXKE20(:,:,:,:)
      ALLOCATABLE CXK21P(:,:,:,:)
      ALLOCATABLE CXK21M(:,:,:,:)
      ALLOCATABLE CXK22P(:,:,:,:)
      ALLOCATABLE CXK22M(:,:,:,:)
      ALLOCATABLE PNKE00(:,:,:,:)
      ALLOCATABLE PNKE10(:,:,:,:)
      ALLOCATABLE PNKE1P(:,:,:,:)
      ALLOCATABLE PNKE1M(:,:,:,:)
      ALLOCATABLE SPKERN(:,:,:,:)
      ALLOCATABLE TMUL_P(:,:)
      ALLOCATABLE TMAG_P(:,:)
      ALLOCATABLE TSIF_P(:,:)
C=======================================================================
      ALLOCATABLE CKER_T(:,:,:)
      ALLOCATABLE CSKY_T(:,:,:)
      ALLOCATABLE CKIN_N(:,:,:)
      ALLOCATABLE CKIN_P(:,:,:)
      ALLOCATABLE CCOU_D(:,:,:)
      ALLOCATABLE CC10_D(:,:,:)
      ALLOCATABLE CC1P_D(:,:,:)
      ALLOCATABLE CC1M_D(:,:,:)
      ALLOCATABLE CC20_D(:,:,:)
      ALLOCATABLE CC21PD(:,:,:)
      ALLOCATABLE CC21MD(:,:,:)
      ALLOCATABLE CC22PD(:,:,:)
      ALLOCATABLE CC22MD(:,:,:)
      ALLOCATABLE CCOU_X(:,:,:)
      ALLOCATABLE CC10_X(:,:,:)
      ALLOCATABLE CC1P_X(:,:,:)
      ALLOCATABLE CC1M_X(:,:,:)
      ALLOCATABLE CC20_X(:,:,:)
      ALLOCATABLE CC21PX(:,:,:)
      ALLOCATABLE CC21MX(:,:,:)
      ALLOCATABLE CC22PX(:,:,:)
      ALLOCATABLE CC22MX(:,:,:)
      ALLOCATABLE CPNU00(:,:,:)
      ALLOCATABLE CPNU10(:,:,:)
      ALLOCATABLE CPNU1P(:,:,:)
      ALLOCATABLE CPNU1M(:,:,:)
      ALLOCATABLE CMUL_P(:,:,:)
      ALLOCATABLE CMAG_P(:,:,:)
      ALLOCATABLE CSIF_P(:,:,:)
C=======================================================================
      DIMENSION
     *          QMULDU(0:NDMULT,-NDMULT:NDMULT)
      DIMENSION
     *          RMUL_P(0:NDMULR,-NDMULR:NDMULR),
     *          RMAG_P(0:NDMULR,-NDMULR:NDMULR),
     *          RSIF_P(0:NDMULR,-NDMULR:NDMULR)
      DIMENSION
     *          ZKER_T(1:NDAKNO,-NDPROI:NDPROI,NDPROT),
     *          ZSKY_T(1:NDAKNO,-NDPROI:NDPROI,NDPROT),
     *          ZKIN_N(1:NDAKNO,-NDPROI:NDPROI,NDPROT),
     *          ZKIN_P(1:NDAKNO,-NDPROI:NDPROI,NDPROT),
     *          ZCOU_D(1:NDAKNO,-NDPROI:NDPROI,NDPROT),
     *          ZC10_D(1:NDAKNO,-NDPROI:NDPROI,NDPROT),
     *          ZC1P_D(1:NDAKNO,-NDPROI:NDPROI,NDPROT),
     *          ZC1M_D(1:NDAKNO,-NDPROI:NDPROI,NDPROT),
     *          ZC20_D(1:NDAKNO,-NDPROI:NDPROI,NDPROT),
     *          ZC21PD(1:NDAKNO,-NDPROI:NDPROI,NDPROT),
     *          ZC21MD(1:NDAKNO,-NDPROI:NDPROI,NDPROT),
     *          ZC22PD(1:NDAKNO,-NDPROI:NDPROI,NDPROT),
     *          ZC22MD(1:NDAKNO,-NDPROI:NDPROI,NDPROT),
     *          ZCOU_X(1:NDAKNO,-NDPROI:NDPROI,NDPROT),
     *          ZC10_X(1:NDAKNO,-NDPROI:NDPROI,NDPROT),
     *          ZC1P_X(1:NDAKNO,-NDPROI:NDPROI,NDPROT),
     *          ZC1M_X(1:NDAKNO,-NDPROI:NDPROI,NDPROT),
     *          ZC20_X(1:NDAKNO,-NDPROI:NDPROI,NDPROT),
     *          ZC21PX(1:NDAKNO,-NDPROI:NDPROI,NDPROT),
     *          ZC21MX(1:NDAKNO,-NDPROI:NDPROI,NDPROT),
     *          ZC22PX(1:NDAKNO,-NDPROI:NDPROI,NDPROT),
     *          ZC22MX(1:NDAKNO,-NDPROI:NDPROI,NDPROT),
     *          ZPNU00(1:NDAKNO,-NDPROI:NDPROI,NDPROT),
     *          ZPNU10(1:NDAKNO,-NDPROI:NDPROI,NDPROT),
     *          ZPNU1P(1:NDAKNO,-NDPROI:NDPROI,NDPROT),
     *          ZPNU1M(1:NDAKNO,-NDPROI:NDPROI,NDPROT),
     *          ZMUL_P(1:NDAKNO,-NDPROI:NDPROI,NDMULM),
     *          ZMAG_P(1:NDAKNO,-NDPROI:NDPROI,NDMULM),
     *          ZSIF_P(1:NDAKNO,-NDPROI:NDPROI,NDMULM)
      DIMENSION
     *          TKER_T(NDPROT),
     *                                 TKE_TT(NDPROM,NDPROT),
     *          TSKY_T(NDPROT),
     *                                 TSK_TT(NDPROM,NDPROT),
     *          TKIN_N(NDPROT),
     *                                 TKI_NT(NDPROM,NDPROT),
     *          TKIN_P(NDPROT),
     *                                 TKI_PT(NDPROM,NDPROT),
     *          TCOU_D(NDPROT),
     *                                 TCO_DT(NDPROM,NDPROT),
     *          TCOU_X(NDPROT),
     *                                 TCO_XT(NDPROM,NDPROT),
     *          TPNU00(NDPROT),
     *                                 TPN_00(NDPROM,NDPROT),
     *          TPNU10(NDPROT),
     *                                 TPN_10(NDPROM,NDPROT),
     *          TPNU1P(NDPROT),
     *                                 TPN_1P(NDPROM,NDPROT),
     *          TPNU1M(NDPROT),
     *                                 TPN_1M(NDPROM,NDPROT)
C
      DIMENSION
     *          TC10_D(NDPROT),
     *          TC1P_D(NDPROT),
     *          TC1M_D(NDPROT),
     *          TC20_D(NDPROT),
     *          TC21PD(NDPROT),
     *          TC21MD(NDPROT),
     *          TC22PD(NDPROT),
     *          TC22MD(NDPROT),
     *          TC10_X(NDPROT),
     *          TC1P_X(NDPROT),
     *          TC1M_X(NDPROT),
     *          TC20_X(NDPROT),
     *          TC21PX(NDPROT),
     *          TC21MX(NDPROT),
     *          TC22PX(NDPROT),
     *          TC22MX(NDPROT)
C
      COMMON /COUMIX/
     *          TC1_D0(NDPROM,NDPROT),TC1_DP(NDPROM,NDPROT),
     *          TC1_DM(NDPROM,NDPROT),TC2_D0(NDPROM,NDPROT),
     *          TC21DP(NDPROM,NDPROT),TC21DM(NDPROM,NDPROT),
     *          TC22DP(NDPROM,NDPROT),TC22DM(NDPROM,NDPROT),
     *          TC1_X0(NDPROM,NDPROT),TC1_XP(NDPROM,NDPROT),
     *          TC1_XM(NDPROM,NDPROT),TC2_X0(NDPROM,NDPROT),
     *          TC21XP(NDPROM,NDPROT),TC21XM(NDPROM,NDPROT),
     *          TC22XP(NDPROM,NDPROT),TC22XM(NDPROM,NDPROT)
C
      COMMON
     *       /ALLENE/ EKIN_N,EKIN_P,EKIN_T,
     *                EPOT_N,EPOT_P,EPOT_T,
     *                ESUM_N,ESUM_P,ESUM_T,
     *                EPAI_N,EPAI_P,EPAI_T,
     *                EREA_N,EREA_P,EREA_T,
     *                ELIP_N,ELIP_P,ELIP_T,
     *
     *                ECOULD,ECOULE,ECOULT,
     *                       ECOULS,ECOULV,
     *
     *                EMULCO,EMUSLO,EMUREA,
     *                ESIFCO,ESISLO,ESIREA,
     *                ESPICO,ESPSLO,ESPREA,
     *
     *                ENREAR,ECORCM,ECOR_R,
     *
     *                EEVEW0,EODDW0,ENE_W0,
     *                ENEVEN,ENEODD,ENESKY,
     *                ESTABN,ETOTSP,ETOTFU
      COMMON
     *       /C_SOUR/ SOURCE(NDXHRM,NDYHRM,NDZHRM)
C
      COMMON
     *       /PNPDEN/ PNPRHO(NDXHRM,NDYHRM,NDZHRM)
      COMMON
     *       /HNPDEN/ DNPRHO(NDXHRM,NDYHRM,NDZHRM),
     *                DNPTAU(NDXHRM,NDYHRM,NDZHRM),
     *
     *                DNPLPR(NDXHRM,NDYHRM,NDZHRM),
     *                DNPDIV(NDXHRM,NDYHRM,NDZHRM),
     *
     *                DNPSPI(NDXHRM,NDYHRM,NDZHRM,NDKART),
     *                DNPKIS(NDXHRM,NDYHRM,NDZHRM,NDKART),
     *
     *                DNPGRR(NDXHRM,NDYHRM,NDZHRM,NDKART),
     *                DNPLPS(NDXHRM,NDYHRM,NDZHRM,NDKART),
     *                DNPROS(NDXHRM,NDYHRM,NDZHRM,NDKART),
     *                DNPROC(NDXHRM,NDYHRM,NDZHRM,NDKART),
     *
     *                DNPCUR(NDXHRM,NDYHRM,NDZHRM,NDKART),
     *                DNPSCU(NDXHRM,NDYHRM,NDZHRM,NDKART,NDKART),
     *                DNPDES(NDXHRM,NDYHRM,NDZHRM,NDKART,NDKART)
      COMMON
     *       /PPNDEN/ PPNRHO(NDXHRM,NDYHRM,NDZHRM)
      COMMON
     *       /HPNDEN/ DPNRHO(NDXHRM,NDYHRM,NDZHRM),
     *                DPNTAU(NDXHRM,NDYHRM,NDZHRM),
     *
     *                DPNLPR(NDXHRM,NDYHRM,NDZHRM),
     *                DPNDIV(NDXHRM,NDYHRM,NDZHRM),
     *
     *                DPNSPI(NDXHRM,NDYHRM,NDZHRM,NDKART),
     *                DPNKIS(NDXHRM,NDYHRM,NDZHRM,NDKART),
     *
     *                DPNGRR(NDXHRM,NDYHRM,NDZHRM,NDKART),
     *                DPNLPS(NDXHRM,NDYHRM,NDZHRM,NDKART),
     *                DPNROS(NDXHRM,NDYHRM,NDZHRM,NDKART),
     *                DPNROC(NDXHRM,NDYHRM,NDZHRM,NDKART),
     *
     *                DPNCUR(NDXHRM,NDYHRM,NDZHRM,NDKART),
     *                DPNSCU(NDXHRM,NDYHRM,NDZHRM,NDKART,NDKART),
     *                DPNDES(NDXHRM,NDYHRM,NDZHRM,NDKART,NDKART)
C
      COMMON
     *       /QMUTTI/ QMUT_N(0:NDMULT,-NDMULT:NDMULT),
     *                QMUT_P(0:NDMULT,-NDMULT:NDMULT),
     *                QMUT_T(0:NDMULT,-NDMULT:NDMULT)
      COMMON
     *       /QMULTI/ QMUL_N(0:NDMULT,-NDMULT:NDMULT),
     *                QMUL_P(0:NDMULT,-NDMULT:NDMULT),
     *                QMUL_T(0:NDMULT,-NDMULT:NDMULT)
      COMMON
     *       /AMUTTI/ AMUT_N(0:NDMULT,-NDMULT:NDMULT),
     *                AMUT_P(0:NDMULT,-NDMULT:NDMULT),
     *                AMUT_T(0:NDMULT,-NDMULT:NDMULT)
      COMMON
     *       /AMULTI/ AMUL_N(0:NDMULT,-NDMULT:NDMULT),
     *                AMUL_P(0:NDMULT,-NDMULT:NDMULT),
     *                AMUL_T(0:NDMULT,-NDMULT:NDMULT)
      COMMON
     *       /SMUTTI/ SMUT_N(0:NDMULT,-NDMULT:NDMULT),
     *                SMUT_P(0:NDMULT,-NDMULT:NDMULT),
     *                SMUT_T(0:NDMULT,-NDMULT:NDMULT)
      COMMON
     *       /SMULTI/ SMUL_N(0:NDMULT,-NDMULT:NDMULT),
     *                SMUL_P(0:NDMULT,-NDMULT:NDMULT),
     *                SMUL_T(0:NDMULT,-NDMULT:NDMULT)
      COMMON
     *       /OURUNI/ QUNITS(0:NDMULT,0:NDMULT)
      COMMON
     *       /SIFUNI/ SUNITS(0:NDMULT,0:NDMULT)
      COMMON
     *       /MAGUNI/ AUNITS(0:NDMULT,0:NDMULT)
      COMMON
     *       /COEMUL/ COMULT(0:NDMULT,0:NDOSCI,0:NDOSCI,1:NDKART)
      COMMON
     *       /RANGLE/ ALPROT,BETROT,GAMROT
      COMMON
     *       /DIMENS/ LDBASE
      COMMON
     *       /DIMSTA/ LDTOTS(0:NDISOS),LDSTAT(0:NDISOS),
     *                LDUPPE(0:NDISOS),LDTIMU(0:NDISOS)
      COMMON
     *       /APROJE/ EPROJE(NDPROM,NDPROT),OPROJE(NDPROM,NDPROT)
      COMMON
     *       /CFIPRI/ NFIPRI
C
      COMMON
     *       /CHARGE/ ECHAR2
      COMMON
     *       /EXCHAN/ COULEX
      COMMON
     *       /LDUNKI/ ECH2_O,COEX_O
C
      DATA
     *       NAMMUL /'MULTIPOLE MOMENTS [UNITS:  (10 FERMI)^LAMBDA]'/,
     *       NAMSUR /'SURFACE MOMENTS, UNITS: (10 FERMI)^(LAMBDA+2)'/,
     *       NAMSCH /'SCHIFF  MOMENTS, UNITS: (10 FERMI)^(LAMBDA+2)'/,
     *       NAMMAG /'MAGNETIC MOMENTS  [MAGNETON*FERMI^(LAMBDA-1)]'/
      DATA
     *      IVERKE/8/
C
      KPRSTA(IPRDUM)=IAXIAL*KPROJE-(1-IAXIAL)*IPRDUM
      KPRSTO(IPRDUM)=IAXIAL*KPROJE+(1-IAXIAL)*IPRDUM
C
      IND_LM(LAMDUM,MIUDUM)=LAMDUM**2+LAMDUM+MIUDUM+1
      IND_IK(IPRDUM,KPRDUM)=(IPRDUM**2-IHALFI)/4+(IPRDUM+KPRDUM)/2+1
      INDIMK(IPRDUM,MPRDUM,KPRDUM)=(IPRDUM*(IPRDUM-1)*(IPRDUM+1))/6
     *      +(IPRDUM+1)*((IPRDUM+MPRDUM)/2)+(IPRDUM+KPRDUM)/2+1
C
      CALL CPUTIM('PROANG',1)
C
C=======================================================================
C
      IALLOC=0
C
C=======================================================================
      IF (.NOT.ALLOCATED(WARIGH)) THEN
          ALLOCATE (WARIGH(1:NDBASE,1:4*NDSTAT,0:NDSPIN),STAT=IALLOC)
          IF (IALLOC.NE.0) CALL NOALLO('WARIGH','PROANG')
      END IF
C=======================================================================
      IF (.NOT.ALLOCATED(WALEFT)) THEN
          ALLOCATE (WALEFT(1:NDBASE,1:4*NDSTAT,0:NDSPIN),STAT=IALLOC)
          IF (IALLOC.NE.0) CALL NOALLO('WALEFT','PROANG')
      END IF
C=======================================================================
      IF (.NOT.ALLOCATED(REDQ_P)) THEN
          ALLOCATE (REDQ_P(0:NDREDU),STAT=IALLOC)
          IF (IALLOC.NE.0) CALL NOALLO('REDQ_P','PROANG')
      END IF
C=======================================================================
      IF (.NOT.ALLOCATED(REDM_P)) THEN
          ALLOCATE (REDM_P(0:NDREDU),STAT=IALLOC)
          IF (IALLOC.NE.0) CALL NOALLO('REDM_P','PROANG')
      END IF
C=======================================================================
      IF (.NOT.ALLOCATED(REDS_P)) THEN
          ALLOCATE (REDS_P(0:NDREDU),STAT=IALLOC)
          IF (IALLOC.NE.0) CALL NOALLO('REDS_P','PROANG')
      END IF
C=======================================================================
      IF (.NOT.ALLOCATED(INDRED)) THEN
          ALLOCATE (INDRED(NDPROK,0:NDMULR,NDPROK),STAT=IALLOC)
          IF (IALLOC.NE.0) CALL NOALLO('INDRED','PROANG')
      END IF
C=======================================================================
      ALLOCATE (OVRLAP(1:4*NDSTAT,1:4*NDSTAT),STAT=IALLOC)
      IF (IALLOC.NE.0) CALL NOALLO('OVRLAP','PROANG')
C=======================================================================
      ALLOCATE (WARAUX(1:4*NDSTAT,0:NDSPIN),STAT=IALLOC)
      IF (IALLOC.NE.0) CALL NOALLO('WARAUX','PROANG')
C=======================================================================
      ALLOCATE (TARIGH(1:2*NDBASE,1:8*NDSTAT,0:NDSPIN),STAT=IALLOC)
      IF (IALLOC.NE.0) CALL NOALLO('TARIGH','PROANG')
C=======================================================================
      ALLOCATE (OVKERN(1:NDASAV,1:NDBKNO,1:NDASAV,0:NDBTKN),STAT=IALLOC)
      IF (IALLOC.NE.0) CALL NOALLO('OVKERN','PROANG')
C=======================================================================
      ALLOCATE (SKKERN(1:NDASAV,1:NDBKNO,1:NDASAV,1:NDBTKN),STAT=IALLOC)
      IF (IALLOC.NE.0) CALL NOALLO('SKKERN','PROANG')
C=======================================================================
      ALLOCATE (EKKERN(1:NDASAV,1:NDBKNO,1:NDASAV,0:NDBTKN),STAT=IALLOC)
      IF (IALLOC.NE.0) CALL NOALLO('EKKERN','PROANG')
C=======================================================================
      ALLOCATE (QPKERN(1:NDASAV,1:NDBKNO,1:NDASAV,NDMULM),STAT=IALLOC)
      IF (IALLOC.NE.0) CALL NOALLO('QPKERN','PROANG')
C=======================================================================
      ALLOCATE (APKERN(1:NDASAV,1:NDBKNO,1:NDASAV,NDMULM),STAT=IALLOC)
      IF (IALLOC.NE.0) CALL NOALLO('APKERN','PROANG')
C=======================================================================
      ALLOCATE (SPKERN(1:NDASAV,1:NDBKNO,1:NDASAV,NDMULM),STAT=IALLOC)
      IF (IALLOC.NE.0) CALL NOALLO('SPKERN','PROANG')
C=======================================================================
      ALLOCATE (CDKERN(1:NDASAV,1:NDBKNO,1:NDASAV,1:NDBTKN),STAT=IALLOC)
      IF (IALLOC.NE.0) CALL NOALLO('CDKERN','PROANG')
C=======================================================================
      ALLOCATE (CDKE10(1:NDASAV,1:NDBKNO,1:NDASAV,1:NDBTKN),STAT=IALLOC)
      IF (IALLOC.NE.0) CALL NOALLO('CDKE10','PROANG')
C=======================================================================
      ALLOCATE (CDKE1P(1:NDASAV,1:NDBKNO,1:NDASAV,1:NDBTKN),STAT=IALLOC)
      IF (IALLOC.NE.0) CALL NOALLO('CDKE1P','PROANG')
C=======================================================================
      ALLOCATE (CDKE1M(1:NDASAV,1:NDBKNO,1:NDASAV,1:NDBTKN),STAT=IALLOC)
      IF (IALLOC.NE.0) CALL NOALLO('CDKE1M','PROANG')
C=======================================================================
      ALLOCATE (CDKE20(1:NDASAV,1:NDBKNO,1:NDASAV,1:NDBTKN),STAT=IALLOC)
      IF (IALLOC.NE.0) CALL NOALLO('CDKE20','PROANG')
C=======================================================================
      ALLOCATE (CDK21P(1:NDASAV,1:NDBKNO,1:NDASAV,1:NDBTKN),STAT=IALLOC)
      IF (IALLOC.NE.0) CALL NOALLO('CDK21P','PROANG')
C=======================================================================
      ALLOCATE (CDK21M(1:NDASAV,1:NDBKNO,1:NDASAV,1:NDBTKN),STAT=IALLOC)
      IF (IALLOC.NE.0) CALL NOALLO('CDK21M','PROANG')
C=======================================================================
      ALLOCATE (CDK22P(1:NDASAV,1:NDBKNO,1:NDASAV,1:NDBTKN),STAT=IALLOC)
      IF (IALLOC.NE.0) CALL NOALLO('CDK22P','PROANG')
C=======================================================================
      ALLOCATE (CDK22M(1:NDASAV,1:NDBKNO,1:NDASAV,1:NDBTKN),STAT=IALLOC)
      IF (IALLOC.NE.0) CALL NOALLO('CDK22M','PROANG')
C=======================================================================
      ALLOCATE (CXKERN(1:NDASAV,1:NDBKNO,1:NDASAV,1:NDBTKN),STAT=IALLOC)
      IF (IALLOC.NE.0) CALL NOALLO('CXKERN','PROANG')
C=======================================================================
      ALLOCATE (CXKE10(1:NDASAV,1:NDBKNO,1:NDASAV,1:NDBTKN),STAT=IALLOC)
      IF (IALLOC.NE.0) CALL NOALLO('CXKE10','PROANG')
C=======================================================================
      ALLOCATE (CXKE1P(1:NDASAV,1:NDBKNO,1:NDASAV,1:NDBTKN),STAT=IALLOC)
      IF (IALLOC.NE.0) CALL NOALLO('CXKE1P','PROANG')
C=======================================================================
      ALLOCATE (CXKE1M(1:NDASAV,1:NDBKNO,1:NDASAV,1:NDBTKN),STAT=IALLOC)
      IF (IALLOC.NE.0) CALL NOALLO('CXKE1M','PROANG')
C=======================================================================
      ALLOCATE (CXKE20(1:NDASAV,1:NDBKNO,1:NDASAV,1:NDBTKN),STAT=IALLOC)
      IF (IALLOC.NE.0) CALL NOALLO('CXKE20','PROANG')
C=======================================================================
      ALLOCATE (CXK21P(1:NDASAV,1:NDBKNO,1:NDASAV,1:NDBTKN),STAT=IALLOC)
      IF (IALLOC.NE.0) CALL NOALLO('CXK21P','PROANG')
C=======================================================================
      ALLOCATE (CXK21M(1:NDASAV,1:NDBKNO,1:NDASAV,1:NDBTKN),STAT=IALLOC)
      IF (IALLOC.NE.0) CALL NOALLO('CXK21M','PROANG')
C=======================================================================
      ALLOCATE (CXK22P(1:NDASAV,1:NDBKNO,1:NDASAV,1:NDBTKN),STAT=IALLOC)
      IF (IALLOC.NE.0) CALL NOALLO('CXK22P','PROANG')
C=======================================================================
      ALLOCATE (CXK22M(1:NDASAV,1:NDBKNO,1:NDASAV,1:NDBTKN),STAT=IALLOC)
      IF (IALLOC.NE.0) CALL NOALLO('CXK22M','PROANG')
C=======================================================================
      ALLOCATE (PNKE00(1:NDASAV,1:NDBKNO,1:NDASAV,1:NDBTKN),STAT=IALLOC)
      IF (IALLOC.NE.0) CALL NOALLO('PNKE00','PROANG')
C=======================================================================
      ALLOCATE (PNKE10(1:NDASAV,1:NDBKNO,1:NDASAV,1:NDBTKN),STAT=IALLOC)
      IF (IALLOC.NE.0) CALL NOALLO('PNKE10','PROANG')
C=======================================================================
      ALLOCATE (PNKE1P(1:NDASAV,1:NDBKNO,1:NDASAV,1:NDBTKN),STAT=IALLOC)
      IF (IALLOC.NE.0) CALL NOALLO('PNKE1P','PROANG')
C=======================================================================
      ALLOCATE (PNKE1M(1:NDASAV,1:NDBKNO,1:NDASAV,1:NDBTKN),STAT=IALLOC)
      IF (IALLOC.NE.0) CALL NOALLO('PNKE1M','PROANG')
C=======================================================================
      ALLOCATE (TMUL_P(NDMULM,NDPROM),STAT=IALLOC)
      IF (IALLOC.NE.0) CALL NOALLO('TMUL_P','PROANG')
C=======================================================================
      ALLOCATE (TMAG_P(NDMULM,NDPROM),STAT=IALLOC)
      IF (IALLOC.NE.0) CALL NOALLO('TMAG_P','PROANG')
C=======================================================================
      ALLOCATE (TSIF_P(NDMULM,NDPROM),STAT=IALLOC)
      IF (IALLOC.NE.0) CALL NOALLO('TSIF_P','PROANG')
C=======================================================================
      ALLOCATE (BNN_PP(1:NDBASE,1:NDBASE,0:NDREVE),STAT=IALLOC)
      IF (IALLOC.NE.0) CALL NOALLO('BNN_PP','PROANG')
      ALLOCATE (BNN_PM(1:NDBASE,1:NDBASE,0:NDREVE),STAT=IALLOC)
      IF (IALLOC.NE.0) CALL NOALLO('BNN_PM','PROANG')
      ALLOCATE (BNP_PP(1:NDBASE,1:NDBASE,0:NDREVE),STAT=IALLOC)
      IF (IALLOC.NE.0) CALL NOALLO('BNP_PP','PROANG')
      ALLOCATE (BNP_PM(1:NDBASE,1:NDBASE,0:NDREVE),STAT=IALLOC)
      IF (IALLOC.NE.0) CALL NOALLO('BNP_PM','PROANG')
      ALLOCATE (BPP_PP(1:NDBASE,1:NDBASE,0:NDREVE),STAT=IALLOC)
      IF (IALLOC.NE.0) CALL NOALLO('BPP_PP','PROANG')
      ALLOCATE (BPP_PM(1:NDBASE,1:NDBASE,0:NDREVE),STAT=IALLOC)
      IF (IALLOC.NE.0) CALL NOALLO('BPP_PM','PROANG')
      ALLOCATE (BPN_PP(1:NDBASE,1:NDBASE,0:NDREVE),STAT=IALLOC)
      IF (IALLOC.NE.0) CALL NOALLO('BPN_PP','PROANG')
      ALLOCATE (BPN_PM(1:NDBASE,1:NDBASE,0:NDREVE),STAT=IALLOC)
      IF (IALLOC.NE.0) CALL NOALLO('BPN_PM','PROANG')
C=======================================================================
      ALLOCATE (CKER_T(-NDPROI:NDPROI,-NDPROI:NDPROI,NDPROT),
     *                                          STAT=IALLOC)
      IF (IALLOC.NE.0) CALL NOALLO('CKER_T','PROANG')
      ALLOCATE (CSKY_T(-NDPROI:NDPROI,-NDPROI:NDPROI,NDPROT),
     *                                          STAT=IALLOC)
      IF (IALLOC.NE.0) CALL NOALLO('CSKY_T','PROANG')
      ALLOCATE (CKIN_N(-NDPROI:NDPROI,-NDPROI:NDPROI,NDPROT),
     *                                          STAT=IALLOC)
      IF (IALLOC.NE.0) CALL NOALLO('CKIN_N','PROANG')
      ALLOCATE (CKIN_P(-NDPROI:NDPROI,-NDPROI:NDPROI,NDPROT),
     *                                          STAT=IALLOC)
      IF (IALLOC.NE.0) CALL NOALLO('CKIN_P','PROANG')
      ALLOCATE (CCOU_D(-NDPROI:NDPROI,-NDPROI:NDPROI,NDPROT),
     *                                          STAT=IALLOC)
      IF (IALLOC.NE.0) CALL NOALLO('CCOU_D','PROANG')
      ALLOCATE (CC10_D(-NDPROI:NDPROI,-NDPROI:NDPROI,NDPROT),
     *                                          STAT=IALLOC)
      IF (IALLOC.NE.0) CALL NOALLO('CC10_D','PROANG')
      ALLOCATE (CC1P_D(-NDPROI:NDPROI,-NDPROI:NDPROI,NDPROT),
     *                                          STAT=IALLOC)
      IF (IALLOC.NE.0) CALL NOALLO('CC1P_D','PROANG')
      ALLOCATE (CC1M_D(-NDPROI:NDPROI,-NDPROI:NDPROI,NDPROT),
     *                                          STAT=IALLOC)
      IF (IALLOC.NE.0) CALL NOALLO('CC1M_D','PROANG')
      ALLOCATE (CC20_D(-NDPROI:NDPROI,-NDPROI:NDPROI,NDPROT),
     *                                          STAT=IALLOC)
      IF (IALLOC.NE.0) CALL NOALLO('CC20_D','PROANG')
      ALLOCATE (CC21PD(-NDPROI:NDPROI,-NDPROI:NDPROI,NDPROT),
     *                                          STAT=IALLOC)
      IF (IALLOC.NE.0) CALL NOALLO('CC21PD','PROANG')
      ALLOCATE (CC21MD(-NDPROI:NDPROI,-NDPROI:NDPROI,NDPROT),
     *                                          STAT=IALLOC)
      IF (IALLOC.NE.0) CALL NOALLO('CC21MD','PROANG')
      ALLOCATE (CC22PD(-NDPROI:NDPROI,-NDPROI:NDPROI,NDPROT),
     *                                          STAT=IALLOC)
      IF (IALLOC.NE.0) CALL NOALLO('CC22PD','PROANG')
      ALLOCATE (CC22MD(-NDPROI:NDPROI,-NDPROI:NDPROI,NDPROT),
     *                                          STAT=IALLOC)
      IF (IALLOC.NE.0) CALL NOALLO('CC22MD','PROANG')
      ALLOCATE (CCOU_X(-NDPROI:NDPROI,-NDPROI:NDPROI,NDPROT),
     *                                          STAT=IALLOC)
      IF (IALLOC.NE.0) CALL NOALLO('CCOU_X','PROANG')
      ALLOCATE (CC10_X(-NDPROI:NDPROI,-NDPROI:NDPROI,NDPROT),
     *                                          STAT=IALLOC)
      IF (IALLOC.NE.0) CALL NOALLO('CC10_X','PROANG')
      ALLOCATE (CC1P_X(-NDPROI:NDPROI,-NDPROI:NDPROI,NDPROT),
     *                                          STAT=IALLOC)
      IF (IALLOC.NE.0) CALL NOALLO('CC1P_X','PROANG')
      ALLOCATE (CC1M_X(-NDPROI:NDPROI,-NDPROI:NDPROI,NDPROT),
     *                                          STAT=IALLOC)
      IF (IALLOC.NE.0) CALL NOALLO('CC1M_X','PROANG')
      ALLOCATE (CC20_X(-NDPROI:NDPROI,-NDPROI:NDPROI,NDPROT),
     *                                          STAT=IALLOC)
      IF (IALLOC.NE.0) CALL NOALLO('CC20_X','PROANG')
      ALLOCATE (CC21PX(-NDPROI:NDPROI,-NDPROI:NDPROI,NDPROT),
     *                                          STAT=IALLOC)
      IF (IALLOC.NE.0) CALL NOALLO('CC21PX','PROANG')
      ALLOCATE (CC21MX(-NDPROI:NDPROI,-NDPROI:NDPROI,NDPROT),
     *                                          STAT=IALLOC)
      IF (IALLOC.NE.0) CALL NOALLO('CC21MX','PROANG')
      ALLOCATE (CC22PX(-NDPROI:NDPROI,-NDPROI:NDPROI,NDPROT),
     *                                          STAT=IALLOC)
      IF (IALLOC.NE.0) CALL NOALLO('CC22PX','PROANG')
      ALLOCATE (CC22MX(-NDPROI:NDPROI,-NDPROI:NDPROI,NDPROT),
     *                                          STAT=IALLOC)
      IF (IALLOC.NE.0) CALL NOALLO('CC22MX','PROANG')
      ALLOCATE (CPNU00(-NDPROI:NDPROI,-NDPROI:NDPROI,NDPROT),
     *                                          STAT=IALLOC)
      IF (IALLOC.NE.0) CALL NOALLO('CPNU00','PROANG')
      ALLOCATE (CPNU10(-NDPROI:NDPROI,-NDPROI:NDPROI,NDPROT),
     *                                          STAT=IALLOC)
      IF (IALLOC.NE.0) CALL NOALLO('CPNU10','PROANG')
      ALLOCATE (CPNU1P(-NDPROI:NDPROI,-NDPROI:NDPROI,NDPROT),
     *                                          STAT=IALLOC)
      IF (IALLOC.NE.0) CALL NOALLO('CPNU1P','PROANG')
      ALLOCATE (CPNU1M(-NDPROI:NDPROI,-NDPROI:NDPROI,NDPROT),
     *                                          STAT=IALLOC)
      IF (IALLOC.NE.0) CALL NOALLO('CPNU1M','PROANG')
      ALLOCATE (CMUL_P(-NDPROI:NDPROI,-NDPROI:NDPROI,NDMULM),
     *                                          STAT=IALLOC)
      IF (IALLOC.NE.0) CALL NOALLO('CMUL_P','PROANG')
      ALLOCATE (CMAG_P(-NDPROI:NDPROI,-NDPROI:NDPROI,NDMULM),
     *                                          STAT=IALLOC)
      IF (IALLOC.NE.0) CALL NOALLO('CMAG_P','PROANG')
      ALLOCATE (CSIF_P(-NDPROI:NDPROI,-NDPROI:NDPROI,NDMULM),
     *                                          STAT=IALLOC)
      IF (IALLOC.NE.0) CALL NOALLO('CSIF_P','PROANG')
C=======================================================================
C         THIS SUBROUTINE CALCULATES THE OVERLAPS AND KERNELS OF
C         OPERATORS FOR STATES PROJECTED ON THE ANGULAR MOMENTUM
C                           AND THE ISOSPIN
C=======================================================================
C
C          VERIFY COULOMB CALCULATION VARIANT
C
C=======================================================================
C
      ICOUVE=0
      IF (ICOUDI.EQ.1.AND.ICOUEX.EQ.1) ICOUVE=1
      IF (ICOUDI.EQ.2.AND.ICOUEX.EQ.2) ICOUVE=1
      IF (ICOUVE.EQ.0) THEN
      WRITE (*,467) ICOUDI, ICOUEX
 467  FORMAT (2X,'COULOMB VERSION ICOUDI=',I2,' ICOUEX=',I2,
     *             ' IS NOT SUPPORTED IN PROANG')
      STOP
      ENDIF
C
CWS      ECHAR2=1.43986
      ECHAR2 = ECH2_O
      COULEX = COEX_O
C
      PI=4.0D0*ATAN(1.0D0)
C
      C_ZERO=CMPLX(0.0D0,0.0D0)
      C_UNIT=CMPLX(1.0D0,0.0D0)
      UNIT_I=CMPLX(0.0D0,1.0D0)
C
      NAMEPN='DUMMY   '
      PRINIT=.FALSE.
C
      EDUMMY=0.0D0
C
      IF (NDMULR.GT.4) STOP ' RECALCULATE NDREDU IN PROANG'
C
      JMULMO=MAX(NMUCOU,NMURED)
      JSIFMO=NSIRED
C
C=======================================================================
C     ATTENTION!  STARTING FROM VERSION 2.49T, THE CODE  CAN  CALCULATE
C                 THE TRANSITION MATRIX ELEMENTS OF THE SURFACE MOMENTS
C                 FOR LAMBDA=0. THIS MEANS THAT NSIRED=0 DOES  NOT  ANY
C                 MORE SWITCHES THE CALCULATION OF THE SURFACE  MOMENTS
C                 OFF. TO SWITCH THEM OFF, ONE MUST SET NSIRED=-1.  FOR
C                 COMPATIBILITY  REASONS,  THE  SURFACE   MOMENTS   ARE
C                 CALCULATED STARTING FROM LAMBDA=NSIMIN, WHERE  NSIMIN
C                 IS SET TO 1 IF THE OLD (FOR IVERKE<8) KERNEL FILE  IS
C                 READ.
C=======================================================================
C
      NSIMIN=0
C
C=======================================================================
C
      IHALFI=MOD(IPROMA,2)
C
                       CHALFI='  '
      IF (IHALFI.EQ.1) CHALFI='/2'
C
      IEVENI=2/(IHALFI+1)
C
      WRITE(NFIPRI,'(79(1H*),/,1H*,77X,1H*)')
C
      LPROJT=1
      LPROJJ=1
      IF (NUAKNO*NUBKNO.EQ.1.AND.NBTKNO.GT.1) LPROJJ=0
      IF (                       NBTKNO.EQ.1) LPROJT=0
      IF (LPROJJ.EQ.0) WRITE (*,66) NBTKNO
 66   FORMAT(1H*,18X,'ONLY THE ISOSPIN PROJECTION IS PERFORMED',
     *       19X,1H*,/,1H*,22X,I3,' GAUSS-LEGENDRE KNOTS IS USED',
     *       23X,1H*)
      IF (LPROJT.EQ.0) WRITE (*,67)
 67   FORMAT(1H*,14X,
     *      'ONLY THE ANGULAR MOMENTUM PROJECTION IS PERFORMED',
     *       14X,1H*)
      IF (LPROJJ.EQ.1.AND.LPROJT.EQ.1) WRITE (*,68)
 68   FORMAT(1H*,6X,
     * 'BOTH THE ISOSPIN & THE ANGULAR MOMENTUM PROJECTIONS ARE ',
     * 'PERFORMED',6X,1H*)
      IF (ICSKIP.NE.0) WRITE (*,69)
 69   FORMAT(1H*,9X,
     * 'TEST RUN WITH THE COULOMB INTERACTION SET TO ZERO IN PROANG',
     *  9X,1H*)
C
      WRITE(NFIPRI,'(1H*,77X,1H*,/,79(1H*))')
C
C=======================================================================
C         HERE WE SET LIMITS ON THE ALPHA AND GAMMA KNOTS IN CASE OF THE
C         PARALLEL CALCULATION
C=======================================================================
C
      IF (IPAKER.EQ.1) THEN
C
          NUABEG=NUASTA
          NUAEND=NUASTO
          NUGBEG=NUGSTA
          NUGEND=NUGSTO
C
          IF (IPAALL.EQ.1) THEN
C
              NUBBEG=NUBSTA
              NUBEND=NUBSTO
              NUTBEG=NUTSTA
              NUTEND=NUTSTO
C
          ELSE
C
              NUBBEG=1
              NUBEND=NUBKNO
              NUTBEG=1
              NUTEND=NBTKNO
C
          END IF
C
      ELSE
C
          NUABEG=1
          NUAEND=NUAKNO
          NUGBEG=1
          NUGEND=NUAKNO
C
          NUBBEG=1
          NUBEND=NUBKNO
          NUTBEG=1
          NUTEND=NBTKNO
C
      END IF
C
C=======================================================================
C         HERE WE SET LIMITS ON THE BETA AND GAUGE KNOTS IN CASE OF THE
C         PARALLEL CALCULATION
C=======================================================================
C
C=======================================================================
C         CALCULATION OF KNOTS AND WEIGHTS  FOR  THE  GAUSS-LEGENDRE
C         QUADRATURE TO BE USED FOR THE INTEGRATION OVER  THE  EULER
C         ANGLE BETA
C
C         THE INTEGRAL OVER BETA WITHIN [0,PI] LIMITS IS REPLACED BY
C                      I = INTEGRAL[-1,1] dx W_n (x)
C         WHERE  x=COS(BETA) AND W_n IS A POLYNOMIAL.
C
C         HENCE, THE GAUSS-LEGENDRE FORMULA TO BE USED IS
C                      I = SUM_J XB_WGT(J)*d^I_MK(XB_PNT(J))
C                        * KERNEL{XA_PNT(I),XB_PNT(J),XA_PNT(K)}
C=======================================================================
C
      IF (NUBKNO.EQ.1) THEN
C
         XB_WGT(1)=1.0D0
         XB_PNT(1)=0.0D0
C
      ELSE
C
          CALL GAULEG(-1.D0,1.D0,XB_PNT,XB_WGT,NUBKNO)
C
          DO I=1,NUBKNO
C
             XB_PNT(I)=ACOS(XB_PNT(I))
C
          END DO
C
      END IF
C
C=======================================================================
C         CALCULATION OF KNOTS AND WEIGHTS  FOR  THE  GAUSS-TCHEBYSCHEV
C         QUADRATURE TO BE USED FOR  THE  INTEGRATION  OVER  THE  EULER
C         ANGLES ALPHA AND GAMMA
C
C         THE INTEGRAL OVER ALPHA OVER [0,2PI] IS TRANSFORMED INTO  THE
C         INTEGRAL OVER  X=COS(ALPHA/2) OVER [-1,1], I.E.,
C                 I = INT[0,2PI] dALPHA W_n(SIN(ALPHA),COS(ALPHA))
C                   = 2*INT[-1,1] dx (1-x^2)^(-1/2) W_n (x)
C
C         HENCE, THE GAUSS-TCHEBYSCHEV FORMULA TO BE USED IS
C          I =SUM_I XA_WGT(I) * EXP(-iM*XA_PNT(I))
C                             * KERNEL{XA_PNT(I),XB_PNT(J),XA_PNT(K)}
C
C         FOR NUAKNO=1, THE INTEGRATIONS OVER ALPHA AND GAMMA  ARE  NOT
C         PERFORMED AND THE STATE IS ASSUMED AXIAL WITH THE  PROJECTION
C         ON THE Z AXIS EQUAL KPROJE/2.
C=======================================================================
C
      IF (NUAKNO.EQ.1) THEN
C
          IAXIAL=1
          IF (LPROJJ.EQ.0) IAXIAL=0
C
          XA_WGT(1)=2*PI
          XA_PNT(1)=0.0D0
C
      ELSE
C
          IAXIAL=0
C
          DO I=1,NUAKNO
C
             XA_WGT(I)=2*PI/NUAKNO
             XA_PNT(I)=(2*I-1)*PI/NUAKNO
C
          END DO
C
      END IF
C
C=======================================================================
C         CALCULATION OF KNOTS AND WEIGHTS  FOR  THE  GAUSS-LEGENDRE
C         QUADRATURE TO BE USED FOR THE INTEGRATION OVER  THE  EULER
C         ANGLE BETA_T IN CASE OF ISOSPIN PROJECTION
C
C         THE INTEGRAL OVER BETA WITHIN [0,PI] LIMITS IS REPLACED BY
C                      I = INTEGRAL[-1,1] dx W_n (x)
C         WHERE  x=COS(BETA_T) AND W_n IS A POLYNOMIAL.
C
C         HENCE, THE GAUSS-LEGENDRE FORMULA TO BE USED IS
C                      I = SUM_J XBT_WG(J)*d^T_TzTz(XBT_PN(J))
C                        * KERNEL{XBT_PN(J)}
C         IN ANALOGY TO THE AMP
C=======================================================================
C
        IF (NBTKNO.EQ.1) THEN
C
           XBT_WG(1)=1.0D0
           XBT_PN(1)=0.0D0
C
        ELSE
C
            CALL GAULEG(-1.D0,1.D0,XBT_PN,XBT_WG,NBTKNO)
C
            DO I=1,NBTKNO
C
               XBT_PN(I)=ACOS(XBT_PN(I))
C
            END DO
C
        END IF
C
C=======================================================================
C         ZEROING THE ARRAY  "ISALGA" WHICH CONTAINS FLAGS 0(1) DENOTING
C         THE KNOTS IN ALPHA AND GAMMA THAT HAVE NOT YET BEEN CALCULATED
C         (HAVE ALREADY BEEN CALCULATED)
C=======================================================================
C
      DO I=1,NUAKNO
         DO K=1,NUAKNO
C
            ISALGA(I,K)=0
C
         END DO
      END DO
C
C=======================================================================
C         ZEROING THE ARRAY  "ISAALL" WHICH CONTAINS FLAGS 0(1) DENOTING
C         ALL KNOTS THAT HAVE NOT YET BEEN CALCULATED
C         (HAVE ALREADY BEEN CALCULATED)
C=======================================================================
C
      DO I=1,NUAKNO
         DO J=1,NUBKNO
            DO K=1,NUAKNO
               DO L=1,NBTKNO
C
                  ISAALL(I,J,K,L)=0
C
               END DO
            END DO
         END DO
      END DO
C
C=======================================================================
C         READING THE FILES WITH KERNELS
C=======================================================================
C
      IF (ISAKER.EQ.1) THEN
C
          IFIKER=0
C
    8     IFIKER=IFIKER+1
C
C=======================================================================
C         OPENING THE FILE
C=======================================================================
C
          WRITE(FILACT(01:05),'(''N'',I3,''-'')') IFIKER
          WRITE(FILACT(06:10),'(''L'',I3,''-'')') INUWAV
          WRITE(FILACT(11:15),'(''R'',I3,''-'')') ITOWAV
C
          DO NUCHAR=1,15
C
             IF (FILACT(NUCHAR:NUCHAR).EQ.' ') FILACT(NUCHAR:NUCHAR)='0'
C
          END DO
C
          FILACT(16:83)=FILKER
C
          OPEN(NFIKER,FILE=FILACT,STATUS='OLD',ERR=7,FORM='UNFORMATTED')
C
          IF (IFIKER.EQ.1)
     *        WRITE(NFIPRI,'(79(1H*),/,1H*,77X,1H*,/,
     *        1H*,1X,'' THE GCM KERNELS IN FUNCTION OF THE EULER'',
     *               '' ANGLES ARE READ - FILE (FILKER):'',   2X,1H*,/,
     *        1H*,2X,A68,                                     7X,1H*,/,
     *                                                   1H*,77X,1H*,/,
     *                                         79(1H*),/,1H*,77X,1H*)')
     *
     *    FILKER
C
          NUAALL=0
          NUALGA=0
          I_MINI=NUAKNO
          I_MAXI=1
          K_MINI=NUAKNO
          K_MAXI=1
C
C=======================================================================
C         READING THE FILE
C=======================================================================
C
   6      READ (NFIKER,END=5,ERR=15) I,K,MVERKE
C
          INEWFI=1
C
          GO TO 16
C
  15      INEWFI=0
C
          MVERKE=1
C
  16      CONTINUE
C
          IF (MVERKE.GT.IVERKE) THEN
C
              WRITE(NFIPRI,'(/,1X,10(1H/),
     *                  ''  CANNOT READ THE KERNEL FILE VERSION:'',
     *                  I3,2X,10(1H/),/)') MVERKE
C
              STOP '  WRONG MVERKE IN PROANG'
C
          END IF
C
          IF (I.LT.1.OR.I.GT.NUAKNO) STOP ' WRONG I READ IN PROANG'
          IF (K.LT.1.OR.K.GT.NUAKNO) STOP ' WRONG K READ IN PROANG'
C
          IF (MVERKE.LE.7) NSIMIN=1
C
          IF (MVERKE.GE.3) THEN
C
              IF (MVERKE.GE.7) THEN
C
                  READ (NFIKER,END=5,ERR=8915) MPAALL,J,L
C
                  IF (MPAALL.NE.IPAALL)
     *                               STOP ' WRONG IPAALL READ IN PROANG'
                  IF ((J.LT.1.OR.J.GT.NUBKNO).AND.IPAALL.EQ.1)
     *                               STOP ' WRONG J READ IN PROANG'
                  IF ((L.LT.1.OR.L.GT.NBTKNO).AND.IPAALL.EQ.1)
     *                               STOP ' WRONG L READ IN PROANG'
C
                  GO TO 8916
C
 8915             STOP ' ERROR READING IVERKE.GE.7 FILE IN PROANG'
C
 8916             CONTINUE
C
              END IF
C
              READ (NFIKER,END=5,ERR=5) FILINP
C
              IF (FILINP.NE.FILACT.AND.ICHKER.EQ.1) THEN
C
                  WRITE(NFIPRI,'(//,87(1H/),/,1H/,85X,1H/,/,
     *
     *                1H/,'' THE NAME OF THE KERNEL FILE: '',55X,1H/,/,
     *                                                   1H/,85X,1H/,/,
     *                1H/,1X,A83,                             1X,1H/,/,
     *                                                   1H/,85X,1H/,/,
     *                1H/,'' IS DIFFERENT THAN THE NAME RECORDED'',
     *                    '' IN THE KERNEL FILE:    '',      25X,1H/,/,
     *                                                   1H/,85X,1H/,/,
     *                1H/,1X,A83,                             1X,1H/,/,
     *                                                   1H/,85X,1H/,/,
     *                1H/,'' CORRECT THE DATABASE OF YOUR KERNEL'',
     *                    '' FILES AND START AGAIN  '',      25X,1H/,/,
     *                                                   1H/,85X,1H/,/,
     *                                                        87(1H/))')
     *
     *            FILACT,FILINP
C
              STOP ' NAME OF THE KERNEL FILE IS DIFFERENT THAN RECORDED'
C
              END IF
C
          END IF
C
          I_MINI=MIN(I_MINI,I)
          I_MAXI=MAX(I_MAXI,I)
          K_MINI=MIN(K_MINI,K)
          K_MAXI=MAX(K_MAXI,K)
C
C=======================================================================
C         THE TRICK BELOW IS INTRODUCED IN ORDER TO SAVE MEMORY WHEN
C         A PARALLEL CALCULATION IS  PERFORMED  (IPAKER=1)  AND  THE
C         CALCULATED KERNELS WILL NOT BE INTEGRATED. IN SUCH A  CASE
C         WE DO NOT HAVE TO KEEP THEM IN MEMORY, AND ALL ARE  STORED
C         IN THE LOCATION NORMALLY USED FOR THE FIRST KNOT IN  ALPHA
C         AND GAMMA, AND THE CODE CAN BE COMPILED WITH IPARAL=1.
C=======================================================================
C
                           M=I
          IF (IPAKER.EQ.1) M=1
                           N=K
          IF (IPAKER.EQ.1) N=1
C
C=======================================================================
C
          IF (INEWFI.EQ.1) THEN
C
              IF (MVERKE.LE.3) THEN
C
                  READ (NFIKER,END=5,ERR=5) MUBKNO,MMURED,MMARED
                  MSIRED=0
C
              ELSE
C
                  IF (MVERKE.LE.5) THEN
C
                      READ (NFIKER,END=5,ERR=5) MUBKNO,MMURED,MMARED,
     *                                                        MSIRED
                      MBTKNO=1
C
                  ELSE
C
                      READ (NFIKER,END=5,ERR=5) MUBKNO,MBTKNO,
     *                                          MMURED,MMARED,MSIRED
C
                  END IF
C
              END IF
C
              IF (MUBKNO.NE.NUBKNO) STOP ' WRONG NUBKNO READ IN PROANG'
              IF (MBTKNO.NE.NBTKNO) STOP ' WRONG NBTKNO READ IN PROANG'
              IF (MMURED.NE.NMURED) STOP ' WRONG NMURED READ IN PROANG'
              IF (MMARED.NE.NMARED) STOP ' WRONG NMARED READ IN PROANG'
              IF (MSIRED.NE.NSIRED) STOP ' WRONG NSIRED READ IN PROANG'
C
              IF (IPAALL.EQ.1) THEN
C
                     READ (NFIKER,END=5,ERR=5) JJ,
     *                OVKERN(M,J,N,0),OVKERN(M,J,N,L),
     *                EKKERN(M,J,N,0),EKKERN(M,J,N,L),
     *                CDKERN(M,J,N,L),
     *                CXKERN(M,J,N,L),
     *                SKKERN(M,J,N,L),
     *               ((QPKERN(M,J,N,IND_LM(LAMBDA,MIU)),
     *                             MIU=-LAMBDA,LAMBDA),LAMBDA=0,NMURED),
     *               ((APKERN(M,J,N,IND_LM(LAMBDA,MIU)),
     *                             MIU=-LAMBDA,LAMBDA),LAMBDA=1,NMARED),
     *               ((SPKERN(M,J,N,IND_LM(LAMBDA,MIU)),
     *                             MIU=-LAMBDA,LAMBDA),
     *                                            LAMBDA=NSIMIN,NSIRED)
C
                     IF (J.NE.JJ)
     *                         STOP ' WRONG J READ IN PROANG (IPAALL=1)'
C
                     IF (NBTKNO.GT.1)
     *
     *                   READ (NFIKER,END=5,ERR=5)
     *                      CDKE10(M,J,N,L),
     *                      CDKE1P(M,J,N,L),
     *                      CXKE10(M,J,N,L),
     *                      CXKE1P(M,J,N,L),
     *                      CDKE1M(M,J,N,L),
     *                      CDKE20(M,J,N,L),
     *                      CDK21P(M,J,N,L),
     *                      CDK21M(M,J,N,L),
     *                      CDK22P(M,J,N,L),
     *                      CDK22M(M,J,N,L),
     *                      CXKE1M(M,J,N,L),
     *                      CXKE20(M,J,N,L),
     *                      CXK21P(M,J,N,L),
     *                      CXK21M(M,J,N,L),
     *                      CXK22P(M,J,N,L),
     *                      CXK22M(M,J,N,L),
     *                      PNKE00(M,J,N,L),
     *                      PNKE10(M,J,N,L),
     *                      PNKE1P(M,J,N,L),
     *                      PNKE1M(M,J,N,L)
C
                  ISAALL(I,J,K,L)=ISAALL(I,J,K,L)+1
                  NUAALL=NUAALL+1
C
              ELSE
C
                  DO J=1,NUBKNO
C
                     READ (NFIKER,END=5,ERR=5) JJ,
     *                (OVKERN(M,J,N,L),L=0,NBTKNO),
     *                (EKKERN(M,J,N,L),L=0,NBTKNO),
     *                (CDKERN(M,J,N,L),L=1,NBTKNO),
     *                (CXKERN(M,J,N,L),L=1,NBTKNO),
     *                (SKKERN(M,J,N,L),L=1,NBTKNO),
     *               ((QPKERN(M,J,N,IND_LM(LAMBDA,MIU)),
     *                             MIU=-LAMBDA,LAMBDA),LAMBDA=0,NMURED),
     *               ((APKERN(M,J,N,IND_LM(LAMBDA,MIU)),
     *                             MIU=-LAMBDA,LAMBDA),LAMBDA=1,NMARED),
     *               ((SPKERN(M,J,N,IND_LM(LAMBDA,MIU)),
     *                             MIU=-LAMBDA,LAMBDA),
     *                                            LAMBDA=NSIMIN,NSIRED)
C
                     IF (J.NE.JJ)
     *                         STOP ' WRONG J READ IN PROANG (IPAALL=0)'
C
                     IF (NBTKNO.GT.1)
     *
     *                   READ (NFIKER,END=5,ERR=5)
     *                      (CDKE10(M,J,N,L),L=1,NBTKNO),
     *                      (CDKE1P(M,J,N,L),L=1,NBTKNO),
     *                      (CXKE10(M,J,N,L),L=1,NBTKNO),
     *                      (CXKE1P(M,J,N,L),L=1,NBTKNO),
     *                      (CDKE1M(M,J,N,L),L=1,NBTKNO),
     *                      (CDKE20(M,J,N,L),L=1,NBTKNO),
     *                      (CDK21P(M,J,N,L),L=1,NBTKNO),
     *                      (CDK21M(M,J,N,L),L=1,NBTKNO),
     *                      (CDK22P(M,J,N,L),L=1,NBTKNO),
     *                      (CDK22M(M,J,N,L),L=1,NBTKNO),
     *                      (CXKE1M(M,J,N,L),L=1,NBTKNO),
     *                      (CXKE20(M,J,N,L),L=1,NBTKNO),
     *                      (CXK21P(M,J,N,L),L=1,NBTKNO),
     *                      (CXK21M(M,J,N,L),L=1,NBTKNO),
     *                      (CXK22P(M,J,N,L),L=1,NBTKNO),
     *                      (CXK22M(M,J,N,L),L=1,NBTKNO),
     *                      (PNKE00(M,J,N,L),L=1,NBTKNO),
     *                      (PNKE10(M,J,N,L),L=1,NBTKNO),
     *                      (PNKE1P(M,J,N,L),L=1,NBTKNO),
     *                      (PNKE1M(M,J,N,L),L=1,NBTKNO)
C
                  END DO
C
                  ISALGA(I,K)=ISALGA(I,K)+1
                  NUALGA=NUALGA+1
C
              END IF
C
          ELSE
C
C=======================================================================
C         READING OF FILES IN THE OLD FORMAT IS KEPT FOR SOME TIME
C=======================================================================
C
              READ (NFIKER,END=5,ERR=5) MUBKNO,MMURED,MMARED,MDCOUP
C
              IF (MUBKNO.NE.NUBKNO) STOP ' WRONG NUBKNO READ IN PROANG'
              IF (MMURED.NE.NMURED) STOP ' WRONG NMURED READ IN PROANG'
              IF (MMARED.NE.NMARED) STOP ' WRONG NMARED READ IN PROANG'
              IF (MDCOUP.NE.NDCOUP) STOP ' WRONG NDCOUP READ IN PROANG'
C
              DO J=1,NUBKNO
C
                 READ (NFIKER,END=5,ERR=5) JJ,
     *             OVKERN(M,J,N,0),OVKERN(M,J,N,1),
     *             EKKERN(M,J,N,0),EKKERN(M,J,N,1),
     *             CDKERN(M,J,N,1),CXKERN(M,J,N,1),SKKERN(M,J,N,1),
     *           ((QPKERN(M,J,N,IND_LM(LAMBDA,MIU)),MIU=-LAMBDA,LAMBDA),
     *                                                 LAMBDA=0,NMURED),
     *           ((APKERN(M,J,N,IND_LM(LAMBDA,MIU)),MIU=-LAMBDA,LAMBDA),
     *                                                 LAMBDA=0,NMARED),
     *            (FACINT,NUCOUP=1,NDCOUP)
C
C
                 IF (J.NE.JJ) STOP ' WRONG J READ IN PROANG'
C
              END DO
C
              ISALGA(I,K)=ISALGA(I,K)+1
              NUALGA=NUALGA+1
C
          END IF
C
          IF (MVERKE.LT.5) THEN
C
              DO J=1,NUBKNO
C
                 DO LAMBDA=0,NMURED
                    DO MIU=-LAMBDA,LAMBDA
C
                       NIU=ABS(MIU)
C
                       QPKERN(M,J,N,IND_LM(LAMBDA,MIU))=
     *                 QPKERN(M,J,N,IND_LM(LAMBDA,MIU))
     *                             *QUNITS(LAMBDA,NIU)
C
                    END DO
                 END DO
C
                 DO LAMBDA=1,NMARED
                    DO MIU=-LAMBDA,LAMBDA
C
                       NIU=ABS(MIU)
C
                       APKERN(M,J,N,IND_LM(LAMBDA,MIU))=
     *                 APKERN(M,J,N,IND_LM(LAMBDA,MIU))
     *                             *AUNITS(LAMBDA,NIU)
C
                    END DO
                 END DO
C
                 DO LAMBDA=NSIMIN,NSIRED
                    DO MIU=-LAMBDA,LAMBDA
C
                       NIU=ABS(MIU)
C
                       SPKERN(M,J,N,IND_LM(LAMBDA,MIU))=
     *                 SPKERN(M,J,N,IND_LM(LAMBDA,MIU))
     *                             *SUNITS(LAMBDA,NIU)
C
                    END DO
                 END DO
C
              END DO
C
          END IF
C
C=======================================================================
C         HERE JUMP TO READING THE NEXT SET OF BETA KNOTS
C=======================================================================
C
          GO TO 6
C
    5     CLOSE (NFIKER)
C
          MUALGA=(I_MAXI-I_MINI+1)*(K_MAXI-K_MINI+1)
C
          WRITE(NFIPRI,'(1H*,2X,A14,     I4,'' <= I <='',I3,
     *                         ''  AND'',I4,'' <= K <='',I3,
     *                         ''; TOT'',I6,'' PNTS OF'',I6,
     *                   1X,1H*)')
     *
     *    FILACT(01:14),I_MINI,I_MAXI,K_MINI,K_MAXI,NUALGA,MUALGA
C
C=======================================================================
C         HERE JUMP TO READING THE NEXT FILE
C=======================================================================
C
          GO TO 8
C
    7     CONTINUE
C
          IF (IFIKER.GT.1) WRITE(NFIPRI,'(1H*,77X,1H*)')
C
      END IF
C
C=======================================================================
C         HERE WE PRINT THE TABLE OF KNOTS THAT HAVE ALREADY BEEN
C         CALCULATED.
C=======================================================================
C
      WRITE(NFIPRI,'(79(1H*),/,1H*,77X,1H*,/,
     *        1H*,1X,'' THE MATRIX OF KERNELS THAT HAVE ALREADY'',
     *               '' BEEN CALCULATED IS AS FOLLOWS:   '',  2X,1H*,/,
     *                                                   1H*,77X,1H*)')
C
      NUABLO=(NUAKNO-MOD(NUAKNO-1,NUMCOL)-1)/NUMCOL+1
C
C     DO IBLOCK=1,NUABLO
C        IOFSET=(IBLOCK-1)*NUMCOL
C        ISTART=IOFSET+1
C        ISTOPP=IOFSET+MIN(NUAKNO,IOFSET+NUMCOL)
         IOFSET=0
         ISTART=IOFSET+1
         ISTOPP=NUAKNO
         DO KBLOCK=1,NUABLO
            KOFSET=(KBLOCK-1)*NUMCOL
            KSTART=KOFSET+1
            KSTOPP=KOFSET+MIN(NUAKNO,KOFSET+NUMCOL)
C
            WRITE(NFIPRI,'(79(1H*),/,1H*,77X,1H*)')
C
            DO K=KSTART,KSTOPP
C
               KCOLUM=K-KOFSET
C
               LINE_0(KCOLUM)='-'
C
               WRITE(LINE_1(KCOLUM),'(I1)') (K-MOD(K,100))/100
               WRITE(LINE_2(KCOLUM),'(I1)') (K-MOD(K,10))/10
               WRITE(LINE_3(KCOLUM),'(I1)')    MOD(K,10)
C
            END DO
C
            KCOLUM=KSTOPP+1
C
            LINE_0(KCOLUM)=' '
            LINE_1(KCOLUM)='|'
            LINE_2(KCOLUM)='|'
            LINE_3(KCOLUM)='|'
C
            DO K=KSTOPP+2,KOFSET+NUMCOL+1
C
               KCOLUM=K-KOFSET
C
               LINE_0(KCOLUM)=' '
               LINE_1(KCOLUM)=' '
               LINE_2(KCOLUM)=' '
               LINE_3(KCOLUM)=' '
C
            END DO
C
            WRITE(NFIPRI,'(
     *        1H*,1X,''   '',   1X,''GAMMA'',66X,1X,1H*,/,
     *        1H*,1X,'' A '','' '',         71A1,1X,1H*,/,
     *        1H*,1X,'' L '',''|'',         71A1,1X,1H*,/,
     *        1H*,1X,'' P '',''|'',         71A1,1X,1H*,/,
     *        1H*,1X,'' H '',''|'',         71A1,1X,1H*,/,
     *        1H*,1X,'' A '','' '',         71A1,1X,1H*)')
     *
     *        LINE_0,LINE_1,LINE_2,LINE_3,LINE_0
C
            DO I=ISTART,ISTOPP
C
               DO K=KSTART,KSTOPP
C
                  KCOLUM=K-KOFSET
C
                  WRITE(LINE_1(KCOLUM),'(I1)') ISALGA(I,K)
C
               END DO
C
               KCOLUM=KSTOPP+1
C
               LINE_1(KCOLUM)='|'
C
               DO K=KSTOPP+2,KOFSET+NUMCOL+1
C
                  KCOLUM=K-KOFSET
C
                  LINE_1(KCOLUM)=' '
C
               END DO
C
               WRITE(NFIPRI,'(1H*,1X,I3,''|'',71A1,1X,1H*)') I,LINE_1
C
            END DO
C
            WRITE(NFIPRI,'(1H*,1X,3X, 1X,71A1,1X,1H*)') LINE_0
            WRITE(NFIPRI,'(1H*,77X,1H*)')
C
         END DO
C     END DO
C
C=======================================================================
C         HERE BEGIN THE LOOPS (NO. 1) OVER THE ALPHA AND GAMMA GAUSS
C         KNOTS.
C=======================================================================
C
      NUALGA=0
      NUAALL=0
      IOPEND=0
C
      DO I=NUABEG,NUAEND
         DO K=NUGBEG,NUGEND
C
            IF (ISALGA(I,K).GE.1.AND.IPAALL.NE.1) GO TO 9
C
            NUALGA=NUALGA+1
C
C=======================================================================
C         THE TRICK BELOW IS INTRODUCED IN ORDER TO SAVE MEMORY,
C         SEE COMMENTS ABOVE
C=======================================================================
C
                             M=I
            IF (IPAKER.EQ.1) M=1
                             N=K
            IF (IPAKER.EQ.1) N=1
C
C=======================================================================
C         HERE BEGINS THE LOOP (NO. 1) OVER THE BETA GAUSS KNOTS.
C=======================================================================
C
            DO J=NUBBEG,NUBEND
C
               ALPROT=XA_PNT(I)
               BETROT=XB_PNT(J)
               GAMROT=XA_PNT(K)
C
C=======================================================================
C         HERE BEGINS THE LOOP (NO. 1) OVER THE BETISO GAUSS KNOTS.
C=======================================================================
C
              DO L=NUTBEG,NUTEND
                 BETISO=XBT_PN(L)
C
                 IF (ISAALL(I,J,K,L).GE.1.AND.IPAALL.EQ.1) GO TO 89
C
                 NUAALL=NUAALL+1
C
C    ----->  BEGINNING OF INTERNAL CHARGE LOOP (N0. 1):
C
                 DO ICHARG=0,NDISOS
C
                    LSTATE=LDSTAT(ICHARG)
C
C=======================================================================
C         FETCHING THE RIGHT WAVE FUNCTIONS FOR THE GIVEN CHARGE
C=======================================================================
C
                    DO ISTATE=1,LSTATE
                       DO IBASE=1,LDBASE
                          DO ISPIN=0,NDSPIN
C
                             WARIGH(IBASE,ISTATE,ISPIN)=
     *                       SARIGH(IBASE,ISTATE,ISPIN,ICHARG)
C
                          END DO
                       END DO
                    END DO
C
C=======================================================================
C  ROTATING THE RIGHT WAVE FUNCTIONS IN SPACE BY THE GIVEN EULER ANGLES
C  AND STORING BOTH NEUTRON AND PROTON SPACE - ROTATED STATES IN TARIGH
C
C          TARIGH CONTAINS RIGHT EIGENVECTOR ROTATED IN SPACE
C                  IN DOUBLE-DIMENSION REPRESENTATION
C
C               |       V_n        |       V_p        |
C               | -----------------| -----------------|
C               |       V_n        |       V_p        |
C
C        SUBSEQUENT ROTATION IN THE ISOSPACE WILL RESULT IN THE
C                  FOLLOWING BETISO ANGLE DEPENDENCE
C
C               | COS(BETISO/2) V_n| -SIN(BETISO/2) V_p|
C               | -----------------| ------------------|
C               | SIN(BETISO/2) V_n|  COS(BETISO/2) V_p|
C
C                      !!!I M P O R T A N T!!!
C        THE BETISO DEPENDENCE WILL BE TAKEN CARE OF EXPLICITELY
C            BOTH IN THE OVERLAP AND THE HAMILTONIAN KERNELS
C=======================================================================
C
                    IF (NUAKNO.GT.1.OR.NUBKNO.GT.1)
     *
     *                  CALL ROTWAV(LSTATE,WARIGH)
C
                    DO ISTATE=1,LSTATE
                       DO IBASE=1,LDBASE
                          JBASE=  LDBASE+IBASE
                          DO ISPIN=0,NDSPIN
C
                            IF (ICHARG.EQ.0) THEN
                            TARIGH(IBASE,ISTATE,ISPIN)=
     *                      WARIGH(IBASE,ISTATE,ISPIN)
C
                            TARIGH(JBASE,ISTATE,ISPIN)=
     *                      WARIGH(IBASE,ISTATE,ISPIN)
                            ELSE
                            JSTATE=LDSTAT(0)+ISTATE
                            TARIGH(IBASE,JSTATE,ISPIN)=
     *                      WARIGH(IBASE,ISTATE,ISPIN)
C
                            TARIGH(JBASE,JSTATE,ISPIN)=
     *                      WARIGH(IBASE,ISTATE,ISPIN)
C
                            ENDIF
C
                          END DO
                       END DO
                    END DO
C
C    ----->  END OF INTERNAL CHARGE LOOP (N0. 1):
                 END DO
C
C=======================================================================
C       THE FOLLOWING PART OF THE PROGRAM WORKS ONLY IF ISOSPIN
C       PROJECTION IS OFF (NBTKNO=1). IN THIS CASE NEUTRONS AND
C                       PROTONS SEPARATE OUT.
C=======================================================================
C
         IF (NBTKNO.EQ.1) THEN
C
              DO ICHARG=0,NDISOS
                  LSTATE=LDSTAT(ICHARG)
C
                  IF (LSTATE.GT.2*NDSTAT)
     *                STOP ' LSTATE.GT.2*NDSTAT IN PROANG'
C
                  DO ISTATE=1,LSTATE
                     DO JSTATE=1,LSTATE
C
                          OVRLAP(ISTATE,JSTATE)=C_ZERO
C
                     END DO
                  END DO
C
C=======================================================================
C         FETCHING THE LEFT WAVE FUNCTIONS FOR THE GIVEN CHARGE
C=======================================================================
C
                  DO ISTATE=1,LSTATE
                     DO IBASE=1,LDBASE
                        DO ISPIN=0,NDSPIN
C
                           IF (IDIAGO.EQ.1) THEN
C
                               WALEFT(IBASE,ISTATE,ISPIN)=
     *                         SARIGH(IBASE,ISTATE,ISPIN,ICHARG)
C
                           ELSE
C
                               WALEFT(IBASE,ISTATE,ISPIN)=
     *                         SALEFT(IBASE,ISTATE,ISPIN,ICHARG)
C
                           END IF
C
                        END DO
                     END DO
                  END DO
C
C=======================================================================
C FETCHING THE RIGHT (SPACE ROTATED) WAVE FUNCTIONS FOR THE GIVEN CHARGE
C=======================================================================
C
                  DO ISTATE=1,LSTATE
                     DO IBASE=1,LDBASE
                        DO ISPIN=0,NDSPIN
C
                              IF (ICHARG.EQ.0) THEN
                              WARIGH(IBASE,ISTATE,ISPIN)=
     *                        TARIGH(IBASE,ISTATE,ISPIN)
                              ELSE
                              JSTATE=LDSTAT(0)+ISTATE
                              WARIGH(IBASE,ISTATE,ISPIN)=
     *                        TARIGH(IBASE,JSTATE,ISPIN)
                              ENDIF
C
                        END DO
                     END DO
                  END DO
C
C=======================================================================
C         CALCULATING THE OVERLAPS BETWEEN THE LEFT AND RIGHT STATES
C=======================================================================
C
                  DO ISTATE=1,LSTATE
                     DO JSTATE=1,LSTATE
                        DO IBASE=1,LDBASE
                           DO ISPIN=0,NDSPIN
C
                              OVRLAP(ISTATE,JSTATE)=
     *                        OVRLAP(ISTATE,JSTATE)
     *                        +CONJG(WALEFT(IBASE,ISTATE,ISPIN))
     *                              *WARIGH(IBASE,JSTATE,ISPIN)
C
                           END DO
                        END DO
                     END DO
                  END DO
C
C=======================================================================
C         INVERTING THE OVERLAP MATRIX
C=======================================================================
C
C         WRITE (*,773) M,J,N,ICHARG
C 773     FORMAT(1X,'OVERLAP PREPARED FOR:',4I4)
C
                  CALL ZGECO(OVRLAP,4*NDSTAT,LSTATE,IAUXDI,
     *                                       RICOND,AUXDIA)
                  CALL ZGEDI(OVRLAP,4*NDSTAT,LSTATE,IAUXDI,
     *                                       DETWRK,AUXDIA,11)
C
                  OVKERN(M,J,N,ICHARG)=DETWRK(1)*10.0D0**DETWRK(2)
C
                  IF (ABS(RICOND).LT.1.0D-12) THEN
C
                      WRITE(NFIPRI,*) 'BE CAREFULL - OVERLAP MATRIX ',
     *                                'MAY BE SINGULAR FOR:'
                      WRITE(NFIPRI,*) M,J,N,RICOND
C
                  END IF
C
C         WRITE (*,772) M,J,N,ICHARG
C 772     FORMAT(1X,'OVERLAP INVERTED FOR:',4I4)
C
C=======================================================================
C         MULTIPLYING THE RIGHT WAVE FUNCTIONS BY THE INVERTED OVERLAP
C         MATRIX
C=======================================================================
C
                  DO IBASE=1,LDBASE
                     JBASE=  LDBASE+IBASE
C
                     DO ISTATE=1,LSTATE
                        DO ISPIN=0,NDSPIN
C
                           WARAUX(ISTATE,ISPIN)=C_ZERO
C
                           DO KSTATE=1,LSTATE
C
                              WARAUX(ISTATE,ISPIN)=WARAUX(ISTATE,ISPIN)
     *                                      +WARIGH(IBASE,KSTATE,ISPIN)
     *                                           *OVRLAP(KSTATE,ISTATE)
                           END DO
C
                        END DO
                     END DO
C
                     DO ISTATE=1,LSTATE
                        DO ISPIN=0,NDSPIN
C
C  ------> STORING RIGHT VECTORS MULTIPLIED BY THE INVERTED OVERLAP MATRIX
C          IN TARIGH.
C
                           IF(ICHARG.EQ.0) THEN
                           TARIGH(IBASE,ISTATE,ISPIN)=
     *                           WARAUX(ISTATE,ISPIN)
                           TARIGH(JBASE,ISTATE,ISPIN)=
     *                           WARAUX(ISTATE,ISPIN)
                           ELSE
                           KSTATE=LDSTAT(0)+ISTATE
                           TARIGH(IBASE,KSTATE,ISPIN)=
     *                           WARAUX(ISTATE,ISPIN)
                           TARIGH(JBASE,KSTATE,ISPIN)=
     *                           WARAUX(ISTATE,ISPIN)
                           ENDIF
C
                        END DO
                     END DO
C
                  END DO
              END DO
C
         ENDIF
C
C=======================================================================
C        THE  FOLLOWING  PART OF  THE PROGRAM  CALCULATES OVERLAP,
C        INVERETED  OVERLAP,  AND MULTIPLIES RIGHT VECTORS BY THE
C        INVERTED OVERLAP MATRIX IN THE CASE OF ISOSPIN PROJECTION
C=======================================================================
C
         IF (NBTKNO.GT.1) THEN
C
             LSTAT2=LDSTAT(0)+LDSTAT(1)
C
             IF (LSTAT2.GT.4*NDSTAT)
     *           STOP ' LSTAT2.GT.4*NDSTAT IN PROANG'
C
             DO ISTATE=1,LSTAT2
                DO JSTATE=1,LSTAT2
C
                     OVRLAP(ISTATE,JSTATE)=C_ZERO
C
                END DO
             END DO
C
C-----------------------------------------------------------------------
C           HERE STARTS INTERNAL LOOP OVER CHARGE (NO. 2):
C-----------------------------------------------------------------------
C
             DO ICHARG=0,NDISOS
                LSTATE=LDSTAT(ICHARG)
C
C=======================================================================
C         FETCHING THE LEFT WAVE FUNCTIONS FOR THE GIVEN CHARGE
C=======================================================================
C
                DO ISTATE=1,LSTATE
                   DO IBASE=1,LDBASE
                      DO ISPIN=0,NDSPIN
C
                         IF (IDIAGO.EQ.1) THEN
C
                             WALEFT(IBASE,ISTATE,ISPIN)=
     *                       SARIGH(IBASE,ISTATE,ISPIN,ICHARG)
C
                         ELSE
C
                             WALEFT(IBASE,ISTATE,ISPIN)=
     *                       SALEFT(IBASE,ISTATE,ISPIN,ICHARG)
C
                         END IF
C
                      END DO
                   END DO
                END DO
C
C=======================================================================
C         CALCULATING THE OVERLAPS BETWEEN THE LEFT AND RIGHT STATES
C            THE RIGHT STATES ARE ROTATED IN SPACE AND ISOSPACE
C                               N                 P
C         N        |     O_nn COS(B/2)  |  O_np SIN(B/2)  |
C                  ----------------------------------------
C         P        |    -O_pn SIN(B/2)  |  O_pp COS(B/2)  |
C
C=======================================================================
C
                IF (ICHARG.EQ.0) THEN
C-----------------------------------------------------------------------
C                LOADING NN BLOCK OF THE OVERLAP MATRIX:
C-----------------------------------------------------------------------
                    DO ISTATE=1,LDSTAT(0)
                       DO JSTATE=1,LDSTAT(0)
                          DO IBASE=1,LDBASE
                             DO ISPIN=0,NDSPIN
C
                                OVRLAP(ISTATE,JSTATE)=
     *                          OVRLAP(ISTATE,JSTATE)
     *                          +CONJG(WALEFT(IBASE,ISTATE,ISPIN))
     *                                *TARIGH(IBASE,JSTATE,ISPIN)
     *                                            *COS(BETISO/2.)
C
                             END DO
                          END DO
                       END DO
                    END DO
C-----------------------------------------------------------------------
C                LOADING NP BLOCK OF THE OVERLAP MATRIX:
C-----------------------------------------------------------------------
                    DO ISTATE=1,LDSTAT(0)
                       DO JSTATE=LDSTAT(0)+1,LSTAT2
                          DO IBASE=1,LDBASE
                             DO ISPIN=0,NDSPIN
C
                                OVRLAP(ISTATE,JSTATE)=
     *                          OVRLAP(ISTATE,JSTATE)
     *                          -CONJG(WALEFT(IBASE,ISTATE,ISPIN))
     *                                *TARIGH(IBASE,JSTATE,ISPIN)
     *                                            *SIN(BETISO/2.)
C
                             END DO
                          END DO
                       END DO
                    END DO
C
                ELSE
C
C-----------------------------------------------------------------------
C                LOADING PN BLOCK OF THE OVERLAP MATRIX:
C-----------------------------------------------------------------------
                    DO ISTATE=1,LDSTAT(1)
                       DO JSTATE=1,LDSTAT(0)
                          DO IBASE=1,LDBASE
                             DO ISPIN=0,NDSPIN
C
                                KSTATE=LDSTAT(0)+ISTATE
                                OVRLAP(KSTATE,JSTATE)=
     *                          OVRLAP(KSTATE,JSTATE)
     *                          +CONJG(WALEFT(IBASE,ISTATE,ISPIN))
     *                                *TARIGH(IBASE,JSTATE,ISPIN)
     *                                            *SIN(BETISO/2.)
C
                             END DO
                          END DO
                       END DO
                    END DO
C-----------------------------------------------------------------------
C                LOADING PP BLOCK OF THE OVERLAP MATRIX:
C-----------------------------------------------------------------------
                    DO ISTATE=1,LDSTAT(1)
                       DO JSTATE=LDSTAT(0)+1,LSTAT2
                          DO IBASE=1,LDBASE
                             DO ISPIN=0,NDSPIN
C
                                KSTATE=LDSTAT(0)+ISTATE
                                OVRLAP(KSTATE,JSTATE)=
     *                          OVRLAP(KSTATE,JSTATE)
     *                          +CONJG(WALEFT(IBASE,ISTATE,ISPIN))
     *                                *TARIGH(IBASE,JSTATE,ISPIN)
     *                                            *COS(BETISO/2.)
C
                             END DO
                          END DO
                       END DO
                    END DO
C
                ENDIF
C
C-----------------------------------------------------------------------
C     END OF INTERNAL CHARGE LOOP (NO. 2)- THE OVERLAP MATRIX IS LOADED
C-----------------------------------------------------------------------
C
             END DO
C
C=======================================================================
C                    INVERTING THE OVERLAP MATRIX
C=======================================================================
C
                  CALL ZGECO(OVRLAP,4*NDSTAT,LSTAT2,IAUXDI,
     *                                       RICOND,AUXDIA)
                  CALL ZGEDI(OVRLAP,4*NDSTAT,LSTAT2,IAUXDI,
     *                                       DETWRK,AUXDIA,11)
C
                  OVKERN(M,J,N,L)=DETWRK(1)*10.0D0**DETWRK(2)
C
                  IF (ABS(RICOND).LT.1.0D-12) THEN
C
                      WRITE(NFIPRI,*) 'BE CAREFULL - OVERLAP MATRIX ',
     *                                'MAY BE SINGULAR FOR:'
                      WRITE(NFIPRI,*) M,J,N,L,RICOND
C
                  END IF
C
C=======================================================================
C    TARIGH MODIFIED BELOW WILL CONTAIN RIGHT EIGENVECTORS ROTATED
C        IN SPACE AND SUMMED PARTIALLY WITH THE INVERSE OF THE
C           OVERLAP MATRIX ACCORDING TO THE FOLLOWING SCHEME:
C
C                    N - STATES          Z - STATES
C
C              |  V_n (O^-1)_nn     |   V_n (O^-1)_np    |
C              | -----------------  | -----------------  |
C              |  V_p (O^-1)_pn     |   V_p (O^-1)_pp    |
C
C                        !!! I M P O R T A N T !!!
C    TRIGONOMETRIC FUNCTIONS OF THE  BETISO  ANGLE ASSOCIATED WITH
C     ROTATION IN THE ISOSPACE WILL BE TAKEN CARE OF EXPLICITELY
C
C                    COS(BETISO/2)   |  -SIN(BETISO/2)
C                    ---------------------------------
C                    SIN(BETISO/2)   |   COS(BETISO/2)
C
C=======================================================================
C
                  DO I_BASE=1,LDBASE
                     J_BASE=  LDBASE+I_BASE
C
C ====================================================================
C               CALCULATING  V_p (O^-1)_pn  "NEUTRON" VECTORS
C ====================================================================
C
                     DO ISTATE=1,LDSTAT(0)
C
                        DO ISPIN=0,NDSPIN
C
                           WARAUX(ISTATE,ISPIN)=C_ZERO
C
                           DO KSTATE=1,LDSTAT(1)
                              K_STAT=  LDSTAT(0)+KSTATE
C
                              WARAUX(ISTATE,ISPIN)=WARAUX(ISTATE,ISPIN)
     *                                     +TARIGH(I_BASE,K_STAT,ISPIN)
     *                                     *OVRLAP(K_STAT,ISTATE)
                           END DO
C
                        END DO
                     END DO
C
                     DO ISTATE=1,LDSTAT(0)
                        DO ISPIN=0,NDSPIN
C
                           TARIGH(J_BASE,ISTATE,ISPIN)=
     *                            WARAUX(ISTATE,ISPIN)
C
                        END DO
                     END DO
C
C ====================================================================
C               CALCULATING  V_p (O^-1)_pp  "PROTON" VECTORS
C ====================================================================
C
                     DO ISTATE=1,LDSTAT(1)
                        I_STAT=  LDSTAT(0)+ISTATE
                        DO ISPIN=0,NDSPIN
C
                           WARAUX(ISTATE,ISPIN)=C_ZERO
C
                           DO KSTATE=1,LDSTAT(1)
                              K_STAT=  LDSTAT(0)+KSTATE
C
                              WARAUX(ISTATE,ISPIN)=WARAUX(ISTATE,ISPIN)
     *                                     +TARIGH(I_BASE,K_STAT,ISPIN)
     *                                     *OVRLAP(K_STAT,I_STAT)
C
                           END DO
C
                        END DO
                     END DO
C
                     DO ISTATE=1,LDSTAT(1)
                        I_STAT=  LDSTAT(0)+ISTATE
                        DO ISPIN=0,NDSPIN
C
                           TARIGH(J_BASE,I_STAT,ISPIN)=
     *                            WARAUX(ISTATE,ISPIN)
C
                        END DO
                     END DO
C
C ====================================================================
C               CALCULATING  V_n (O^-1)_np  "PROTON" VECTORS
C ====================================================================
C
                     DO ISTATE=1,LDSTAT(1)
                        I_STAT=  LDSTAT(0)+ISTATE
C
                        DO ISPIN=0,NDSPIN
C
                           WARAUX(ISTATE,ISPIN)=C_ZERO
C
                           DO KSTATE=1,LDSTAT(0)
C
                              WARAUX(ISTATE,ISPIN)=WARAUX(ISTATE,ISPIN)
     *                                     +TARIGH(I_BASE,KSTATE,ISPIN)
     *                                     *OVRLAP(KSTATE,I_STAT)
                           END DO
C
                        END DO
                     END DO
C
                     DO ISTATE=1,LDSTAT(1)
                        I_STAT=  LDSTAT(0)+ISTATE
                        DO ISPIN=0,NDSPIN
C
                           TARIGH(I_BASE,I_STAT,ISPIN)=
     *                            WARAUX(ISTATE,ISPIN)
C
                        END DO
                     END DO
C
C ====================================================================
C               CALCULATING  V_n (O^-1)_nn  "NEUTRON" VECTORS
C ====================================================================
C
                     DO ISTATE=1,LDSTAT(0)
                        DO ISPIN=0,NDSPIN
C
                           WARAUX(ISTATE,ISPIN)=C_ZERO
C
                           DO KSTATE=1,LDSTAT(0)
C
                              WARAUX(ISTATE,ISPIN)=WARAUX(ISTATE,ISPIN)
     *                                     +TARIGH(I_BASE,KSTATE,ISPIN)
     *                                     *OVRLAP(KSTATE,ISTATE)
                           END DO
C
                        END DO
                     END DO
C
                     DO ISTATE=1,LDSTAT(0)
                        DO ISPIN=0,NDSPIN
C
                           TARIGH(I_BASE,ISTATE,ISPIN)=
     *                            WARAUX(ISTATE,ISPIN)
C
                        END DO
                     END DO
C
C           ===============================================
C                  RIGHT VECTORS ARE LOADED IN TARIGH
C           ===============================================
C
                  END DO
C
         ENDIF
C
C=======================================================================
C
C              HERE STARTS "DENSITIES AND CURRENTS" BLOCK
C
C=======================================================================
C
C=======================================================================
C    NEW "EXTERNAL" CHARGE LOOP (NO. 3) FOR DENSITIS AND CURRENTS BLOCK
C=======================================================================
C
        DO ICHARG=0,NDISOS
                  LSTATE=LDSTAT(ICHARG)
C
C=======================================================================
C          FETCHING THE LEFT WAVE FUNCTIONS FOR THE GIVEN CHARGE
C=======================================================================
C
                  DO ISTATE=1,LSTATE
                     DO IBASE=1,LDBASE
                        DO ISPIN=0,NDSPIN
C
                           IF (IDIAGO.EQ.1) THEN
C
                               WALEFT(IBASE,ISTATE,ISPIN)=
     *                         SARIGH(IBASE,ISTATE,ISPIN,ICHARG)
C
                           ELSE
C
                               WALEFT(IBASE,ISTATE,ISPIN)=
     *                         SALEFT(IBASE,ISTATE,ISPIN,ICHARG)
C
                           END IF
C
                        END DO
                     END DO
                  END DO
C
C=======================================================================
C          HERE BEGIN CALCULATIONS OF NEUTRON AND NEUTRON-PROTON
C                     DENSITIES AND OBSERVABLES
C=======================================================================
C
                  IF (ICHARG.EQ.0) THEN
C
C=======================================================================
C                 ZEROING THE NEUTRON AND NEUTRON-PROTON DENSITIES
C=======================================================================
C
                  CALL ZEDENS(ICHARG)
c                  CALL ZEDENS(neutron-proton???)
C
C=======================================================================
C            FETCHING THE RIGHT WAVE FUNCTIONS TO BE USED TO
C              CALCULATE THE NEUTRON DENSITIES AND CURRENTS
C=======================================================================
C
                  DO JSTATE=1,LDBASE
                     DO ISTATE=1,LDSTAT(0)
                        DO ISPIN=0,NDSPIN
                          WARIGH(JSTATE,ISTATE,ISPIN)
     *                   =TARIGH(JSTATE,ISTATE,ISPIN)
                        END DO
                     END DO
                  END DO
C
                  CALL DENSHF(NXHERM,NYHERM,NZHERM,ISIMTX,JSIMTY,ISIMTZ,
     *                        ISIGNY,ISIMPY,ISIQTY,IPAHFB,MREVER,ICHARG,
     *                        ICOUDI,ICOUEX,I_YUKA,I_GOGA,IGOGPA,
     *                                                    IPNMIX,ITPNMX,
     *                        ITIREP,NXMAXX,NAMEPN,PRINIT,IDEVAR,ITERUN,
     *                        ISYMDE,INIROT,INIINV,INIKAR,ISAWAV,IKERNE)
C
C=======================================================================
C                 DOUBLING THE SINGLE-PARTICLE RESULTS IN CASE OF NO
C                 ROTATION
C=======================================================================
C
                  IF (MREVER.EQ.0)
     *
     *            CALL DBLING(ITPNMX,NXHERM,NYHERM,NZHERM,EDUMMY)
C
C=======================================================================
C                 CALCULATING THE NEUTRON TRANSITION DENSITY MATRIX
C                 AND TRANSITION  MATRIX  ELEMENTS  OF  OBSERVABLES
C=======================================================================
C
                  CALL DENMAC(MREVER,ICHARG,ISIMPY,IPAHFB,WALEFT,WARIGH)
C
                  CALL EKINET(ENEKIN,DLINSQ,EKEKIN,DKINSQ)
C
                  IF (NBTKNO.EQ.1) THEN
                  EKKERN(M,J,N,ICHARG)=               EKEKIN
                  ELSE
                  EKKERN(M,J,N,L     )=COS(BETISO/2.)*EKEKIN
C
C=======================================================================
C      SAVE BIG_PP AND BIG_PM REPRESENTING DN_RHO ON THE BASIS
C       IN BNN_PP AND BNN_PM FOR FURTHER COULOMB CALCULATIONS
C=======================================================================
C
                  BNN_PP(:,:,:)=BIG_PP(:,:,:)
                  BNN_PM(:,:,:)=BIG_PM(:,:,:)
C
                  ENDIF
C
                  IF (NBTKNO.EQ.1) GOTO 77
C
C=======================================================================
C            FETCHING THE RIGHT WAVE FUNCTIONS TO BE USED TO
C           CALCULATE THE NEUTRON-PROTON DENSITIES AND CURRENTS
C=======================================================================
C
                  DO JSTATE=1,LDBASE
                   J_STAT=JSTATE+LDBASE
                     DO ISTATE=1,LDSTAT(0)
                        DO ISPIN=0,NDSPIN
                          WARIGH(JSTATE,ISTATE,ISPIN)
     *                   =TARIGH(J_STAT,ISTATE,ISPIN)
                        END DO
                     END DO
                  END DO
C
                  CALL DENSHF(NXHERM,NYHERM,NZHERM,ISIMTX,JSIMTY,ISIMTZ,
     *                        ISIGNY,ISIMPY,ISIQTY,IPAHFB,MREVER,ICHARG,
     *                        ICOUDI,ICOUEX,I_YUKA,I_GOGA,IGOGPA,
     *                                                    IPNMIX,ITPNMX,
     *                        ITIREP,NXMAXX,NAMEPN,PRINIT,IDEVAR,ITERUN,
     *                        ISYMDE,INIROT,INIINV,INIKAR,ISAWAV,IKERNE)
C
C=======================================================================
C                 DOUBLING THE SINGLE-PARTICLE RESULTS IN CASE OF NO
C                 ROTATION
C=======================================================================
C
                  IF (MREVER.EQ.0)
     *
     *            CALL DBLING(ITPNMX,NXHERM,NYHERM,NZHERM,EDUMMY)
C
C=======================================================================
C                 CALCULATING THE NEUTRON TRANSITION DENSITY MATRIX
C                 AND TRANSITION MATRIX ELEMENTS OF THE KINETIC ENE.
C=======================================================================
C
                  CALL DENMAC(MREVER,ICHARG,ISIMPY,IPAHFB,WALEFT,WARIGH)
C
                  CALL EKINET(ENEKIN,DLINSQ,EKEKIN,DKINSQ)
C
                  EKKERN(M,J,N,L)=EKKERN(M,J,N,L)-SIN(BETISO/2.)*EKEKIN
C
C=======================================================================
C      SAVE BIG_PP AND BIG_PM REPRESENTING DNPRHO ON THE BASIS
C       IN BNP_PP AND BNP_PM FOR FURTHER COULOMB CALCULATIONS
C=======================================================================
C
                  BNP_PP(:,:,:)=BIG_PP(:,:,:)
                  BNP_PM(:,:,:)=BIG_PM(:,:,:)
C
  77     CONTINUE
C
         END IF
C
C=======================================================================
C           HERE BEGIN CALCULATIONS OF PROTON AND PROTON-NEUTRON
C                      DENSITIES AND OBSERVABLES
C=======================================================================
C
                  IF (ICHARG.EQ.1) THEN
C
C=======================================================================
C                 ZEROING THE PROTON AND PROTON-NEUTRON DENSITIES
C=======================================================================
C
                  CALL ZEDENS(ICHARG)
c                  CALL ZEDENS(DPNRHO,DPNTAU,DPNLPR,DPNDIV,DPNSPI,DPNKIS,
c     *                        DPNGRR,DPNLPS,DPNROS,DPNROC,DPNCUR,DPNSCU,
c     *                        DPNDES,
c     *                        PPNRHO,
c     *                                             NXHERM,NYHERM,NZHERM)
C
C=======================================================================
C            FETCHING THE RIGHT WAVE FUNCTIONS TO BE USED TO
C          CALCULATE THE PROTON DENSITIES AND CURRENTS IN DENSHF
C=======================================================================
C
                  DO JSTATE=1,LDBASE
                     J_STAT=  LDBASE+JSTATE
                     DO ISTATE=1,LDSTAT(1)
                        I_STAT=  LDSTAT(0)+ISTATE
                        DO ISPIN=0,NDSPIN
                          WARIGH(JSTATE,ISTATE,ISPIN)
     *                   =TARIGH(J_STAT,I_STAT,ISPIN)
                        END DO
                     END DO
                  END DO
C
C=======================================================================
C                 CALCULATING THE PROTON DENSITIES AND CURRENTS
C=======================================================================
C
                  CALL DENSHF(NXHERM,NYHERM,NZHERM,ISIMTX,JSIMTY,ISIMTZ,
     *                        ISIGNY,ISIMPY,ISIQTY,IPAHFB,MREVER,ICHARG,
     *                        ICOUDI,ICOUEX,I_YUKA,I_GOGA,IGOGPA,
     *                                                    IPNMIX,ITPNMX,
     *                        ITIREP,NXMAXX,NAMEPN,PRINIT,IDEVAR,ITERUN,
     *                        ISYMDE,INIROT,INIINV,INIKAR,ISAWAV,IKERNE)
C
C=======================================================================
C                 DOUBLING SINGLE-PARTICLE RESULTS IN CASE OF NO
C                 ROTATION
C=======================================================================
C
                  IF (MREVER.EQ.0)
     *
     *            CALL DBLING(ITPNMX,NXHERM,NYHERM,NZHERM,EDUMMY)
C
C=======================================================================
C                 CALCULATING THE PROTON TRANSITION DENSITY MATRIX
C               AND THE TRANSITION MATRIX ELEMENTS OF THE KINETIC ENE.
C=======================================================================
C
                  CALL DENMAC(MREVER,ICHARG,ISIMPY,IPAHFB,WALEFT,WARIGH)
C
                  CALL EKINET(ENEKIN,DLINSQ,EKEKIN,DKINSQ)
C
                  IF (NBTKNO.EQ.1) THEN
C
C=======================================================================
C     CALCULATING THE PROTON KINETIC ENERGY AND COULOMB TRANSITION
C          MATRIX ELEMENTS IN A RUN WITHOUT ISOSPIN PROJECTION
C=======================================================================
C
                  EKKERN(M,J,N,ICHARG)=EKEKIN
C
C=======================================================================
C            ATTENTION: BETWEEN VERSIONS (2.22N) AND (2.32) THE CALL  TO
C                       "COUMAT" BELOW WAS PERFORMED WITH  AN  UNDEFINED
C                       VALUE OF  "IKERNE"  INSTEAD  OF  IKERNE=1.  THIS
C                       RESULTED (IN "INTCOU") IN CALCULATIONS PERFORMED
C                       FOR REAL PARTS OF TRANSITION MULTIPOLE  MOMENTS.
C                       THIS BUG WAS CORRECTED ON 23/11/2007 IN  VERSION
C                       (2.32A).
C=======================================================================
C
                  IF (ICOUDI.EQ.1.AND.ICOUEX.EQ.1) THEN
C
C  =====================================================================
C  ---> GREEN FUNCTION METHOD IS USED FOR THE DIRECT TERM WHILE SLATER
C       IS APPLIED TO CALCULATE EXCHANGE COULOMB IN THE AMP RUN:
C  =====================================================================
C
                  CALL COUMAT(NXHERM,NYHERM,NZHERM,NXMAXX,NYMAXX,NZMAXX,
     *                                      NUMCOU,BOUCOU,ISIMPY,IKERNE)
C
                  CALL COULOD(ISIMPY,EKECOD)
C
                  CDKERN(M,J,N,1)=EKECOD
C
                  CALL TRUCHD(NXHERM,NYHERM,NZHERM)
C
                  CALL COULOE(NXHERM,NYHERM,NZHERM,EKECOE)
C
                  CXKERN(M,J,N,1)=EKECOE
C
                  ENDIF

                  IF (ICOUDI.EQ.2.AND.ICOUEX.EQ.2) THEN
C
C  =====================================================================
C  ---> GAUSSIAN EXPANSION METHOD IS USED FOR BOTH THE DIRECT
C       AND EXCHANGE COULOMB IN THE AMP RUN:
C  =====================================================================
C
                  CALL SAVDEN(ISIMPY,1,0.,0)
C
                  CALL COUENE(NXHERM,NYHERM,NZHERM,NXMAXX,
     *                                      NYMAXX,NZMAXX,
     *                                             ISIMPY,
     *                               ICOTYP,ICOUDI,ICOUEX,
     *                               EKECOD,EKESCA,EKEVEC,
     *                                      SLOWEV,ISEXAC)
C
                  EKECOE = EKESCA+EKEVEC
                  CDKERN(M,J,N,1)=EKECOD
                  CXKERN(M,J,N,1)=EKECOE
C
                  ENDIF
C
                  ELSE
C
                  EKKERN(M,J,N,L)=EKKERN(M,J,N,L)+COS(BETISO/2.)*EKEKIN
C
C=======================================================================
C      SAVE BIG_PP AND BIG_PM REPRESENTING DP_RHO ON THE BASIS
C       IN BPP_PP AND BPP_PM FOR FURTHER COULOMB CALCULATIONS
C=======================================================================
C
                  BPP_PP(:,:,:)=BIG_PP(:,:,:)
                  BPP_PM(:,:,:)=BIG_PM(:,:,:)
C
                  ENDIF
C
                  IF (NBTKNO.EQ.1) GO TO 78
C
C=======================================================================
C            FETCHING THE RIGHT WAVE FUNCTIONS TO BE USED TO
C      CALCULATE THE PROTON-NEUTRON DENSITIES AND CURRENTS IN DENSHF
C=======================================================================
C
                  DO JSTATE=1,LDBASE
                     DO ISTATE=1,LDSTAT(1)
                        I_STAT=  LDSTAT(0)+ISTATE
                        DO ISPIN=0,NDSPIN
                          WARIGH(JSTATE,ISTATE,ISPIN)
     *                   =TARIGH(JSTATE,I_STAT,ISPIN)
                        END DO
                     END DO
                  END DO
C
C=======================================================================
C         CALCULATING THE PROTON-NEUTRON DENSITIES AND CURRENTS
C=======================================================================
C
                  CALL DENSHF(NXHERM,NYHERM,NZHERM,ISIMTX,JSIMTY,ISIMTZ,
     *                        ISIGNY,ISIMPY,ISIQTY,IPAHFB,MREVER,ICHARG,
     *                        ICOUDI,ICOUEX,I_YUKA,I_GOGA,IGOGPA,
     *                                                    IPNMIX,ITPNMX,
     *                        ITIREP,NXMAXX,NAMEPN,PRINIT,IDEVAR,ITERUN,
     *                        ISYMDE,INIROT,INIINV,INIKAR,ISAWAV,IKERNE)
C
C=======================================================================
C                 DOUBLING SINGLE-PARTICLE RESULTS IN CASE OF NO
C                 ROTATION
C=======================================================================
C
                  IF (MREVER.EQ.0)
     *
     *            CALL DBLING(ITPNMX,NXHERM,NYHERM,NZHERM,EDUMMY)
C
C=======================================================================
C                 CALCULATING THE PROTON TRANSITION DENSITY MATRIX
C                 AND TRANSITION MATRIX  ELEMENTS  OF  OBSERVABLES
C=======================================================================
C
                  CALL DENMAC(MREVER,ICHARG,ISIMPY,IPAHFB,WALEFT,WARIGH)
C
                  CALL EKINET(ENEKIN,DLINSQ,EKEKIN,DKINSQ)
C
                  EKKERN(M,J,N,L)=EKKERN(M,J,N,L)+SIN(BETISO/2.)*EKEKIN
C
C=======================================================================
C      SAVE BIG_PP AND BIG_PM REPRESENTING DPNRHO ON THE BASIS
C       IN BPN_PP AND BPN_PM FOR FURTHER COULOMB CALCULATIONS
C=======================================================================
C
                  BPN_PP(:,:,:)=BIG_PP(:,:,:)
                  BPN_PM(:,:,:)=BIG_PM(:,:,:)
C
  78              CONTINUE
C
                  IF (NBTKNO.GT.1) GOTO 81
C
C=======================================================================
C                 CALCULATING TRANSITION MATRIX  ELEMENTS  OF  MULTIPOLE
C                 OPERATORS (CALCULATED ONLY FOR LPROJT=0).
C=======================================================================
C                 ATTENTION!
C                 ARRAY  "QPKERN" FOR INDICES (LAMBDA,MIU) CONTAINS  THE
C                 MATRIX ELEMENTS OF THE  COMPLETE  (COMPLEX)  MULTIPOLE
C                 OPERATOR WITHOUT PUTTING ITS REAL AND IMAGINARY  PARTS
C                 INTO THE MAGNETIC COMPONENTS WITH  MIU>=0  AND  MIU<0,
C                 RESPECTIVELY, AS IS THE CASE ELSEWHERE IN THE CODE.
C=======================================================================
C
                  CALL MOMETS(ISIMPY,ISIGNY,ISIQTY,QMULDU,QMUT_P,
     *                                      COMULT,JMULMO,ISHIFY)
C
                  DO LAMBDA=0,NMURED
                     DO MIU=-LAMBDA,LAMBDA
C
                        IF (MIU.GT.0)
     *                      QPKERN(M,J,N,IND_LM(LAMBDA,MIU))=
     *                                               QMUT_P(LAMBDA, MIU)
     *                             -UNIT_I*(-1)**MIU*QMUT_P(LAMBDA,-MIU)
C
                        IF (MIU.EQ.0)
     *                      QPKERN(M,J,N,IND_LM(LAMBDA,MIU))=
     *                                               QMUT_P(LAMBDA, MIU)
C
                        IF (MIU.LT.0)
     *                      QPKERN(M,J,N,IND_LM(LAMBDA,MIU))=
     *                                     (-1)**MIU*QMUT_P(LAMBDA,-MIU)
     *                                       +UNIT_I*QMUT_P(LAMBDA, MIU)
C
                     END DO
                  END DO
C
C=======================================================================
C                 CALCULATING TRANSITION  MATRIX  ELEMENTS  OF  MAGNETIC
C                 OPERATORS.
C=======================================================================
C                 ATTENTION! ARRAY  "APKERN" ORGANISED AS "QPKERN" ABOVE
C=======================================================================
C
                  CALL MAGMOM(ISIMPY,IROTAT,ICHARG,QMULDU,AMUT_P,NMARED)
C
                  DO LAMBDA=1,NMARED
                     DO MIU=-LAMBDA,LAMBDA
C
                        IF (MIU.GT.0)
     *                      APKERN(M,J,N,IND_LM(LAMBDA,MIU))=
     *                                               AMUT_P(LAMBDA, MIU)
     *                             -UNIT_I*(-1)**MIU*AMUT_P(LAMBDA,-MIU)
C
                        IF (MIU.EQ.0)
     *                      APKERN(M,J,N,IND_LM(LAMBDA,MIU))=
     *                                               AMUT_P(LAMBDA, MIU)
C
                        IF (MIU.LT.0)
     *                      APKERN(M,J,N,IND_LM(LAMBDA,MIU))=
     *                                     (-1)**MIU*AMUT_P(LAMBDA,-MIU)
     *                                       +UNIT_I*AMUT_P(LAMBDA, MIU)
C
                     END DO
                  END DO
C
C=======================================================================
C                 CALCULATING TRANSITION MATRIX  ELEMENTS  OF  MULTIPOLE
C                 SURFACE OR SCHIFF OPERATORS.
C=======================================================================
C
                  CALL MOMSIF(ISIMPY,ISIGNY,ISIQTY,QMULDU,SMUT_P,
     *                                             COMULT,JSIFMO)
C
C=======================================================================
C                 ATTENTION! THE PRESENT DEFINITION OF THE SCHIFF MOMETS
C                            IN MOMSCH IS INCOMPATIBLE  WITH  PROJECTION
C                            AND CANNOT BE USED
C=======================================================================
C
                  IF (ISCHIF.EQ.1)
     *            CALL MOMSCH(QMULDU,SMUT_P,JSIFMO,QMULDU,QMUT_P,JMULMO)
C
C=======================================================================
C                 ATTENTION! ARRAY  "SPKERN" ORGANISED AS "QPKERN" ABOVE
C=======================================================================
C
                  DO LAMBDA=NSIMIN,NSIRED
                     DO MIU=-LAMBDA,LAMBDA
C
                        IF (MIU.GT.0)
     *                      SPKERN(M,J,N,IND_LM(LAMBDA,MIU))=
     *                                               SMUT_P(LAMBDA, MIU)
     *                             -UNIT_I*(-1)**MIU*SMUT_P(LAMBDA,-MIU)
C
                        IF (MIU.EQ.0)
     *                      SPKERN(M,J,N,IND_LM(LAMBDA,MIU))=
     *                                               SMUT_P(LAMBDA, MIU)
C
                        IF (MIU.LT.0)
     *                      SPKERN(M,J,N,IND_LM(LAMBDA,MIU))=
     *                                     (-1)**MIU*SMUT_P(LAMBDA,-MIU)
     *                                       +UNIT_I*SMUT_P(LAMBDA, MIU)
C
                     END DO
                  END DO
C
  81              CONTINUE
C
                  END IF
C
C=======================================================================
C                 HERE END CALCULATIONS FOR NEUTRONS AND PROTONS
C                     END OF "EXTERNAL" CHARGE LOOP (N0. 3)
C=======================================================================
C
         END DO
C
C=======================================================================
C        CALCULATING  T H E   C O U L O M B  TRANSITION  KERNELS
C                     FOR THE I S O S P I N PROJECTION
C=======================================================================
C
         PNKE00(M,J,N,L)=C_ZERO
         PNKE10(M,J,N,L)=C_ZERO
         PNKE1P(M,J,N,L)=C_ZERO
         PNKE1M(M,J,N,L)=C_ZERO
C
         CDKE10(M,J,N,L)=C_ZERO
         CDKE1P(M,J,N,L)=C_ZERO
         CDKE1M(M,J,N,L)=C_ZERO
         CDKE20(M,J,N,L)=C_ZERO
         CDK21P(M,J,N,L)=C_ZERO
         CDK21M(M,J,N,L)=C_ZERO
         CDK22P(M,J,N,L)=C_ZERO
         CDK22M(M,J,N,L)=C_ZERO
C
         CXKE10(M,J,N,L)=C_ZERO
         CXKE1P(M,J,N,L)=C_ZERO
         CXKE1M(M,J,N,L)=C_ZERO
         CXKE20(M,J,N,L)=C_ZERO
         CXK21P(M,J,N,L)=C_ZERO
         CXK21M(M,J,N,L)=C_ZERO
         CXK22P(M,J,N,L)=C_ZERO
         CXK22M(M,J,N,L)=C_ZERO
C
         IF (NBTKNO.EQ.1) GOTO 820
C
         CDKERN(M,J,N,L)=C_ZERO
         CXKERN(M,J,N,L)=C_ZERO
C
 820     CONTINUE
C
         Q00T=C_ZERO
         Q10T=C_ZERO
         Q1PT=C_ZERO
         Q1MT=C_ZERO
C
C=======================================================================
C            MONOPOLE '00' SOURCE <--> MONOPOLE '00' TRACE
C=======================================================================
C
         DO IREVER=0,MREVER
            DO IBRA=1,LDBASE
               DO IKET=1,LDBASE
                  BIG_PP(IBRA,IKET,IREVER)=
     *            COS(BETISO/2.D0)*(BNN_PP(IBRA,IKET,IREVER)
     *                              +BPP_PP(IBRA,IKET,IREVER))
     *           -SIN(BETISO/2.D0)*(BNP_PP(IBRA,IKET,IREVER)
     *                              -BPN_PP(IBRA,IKET,IREVER))
                  BIG_PM(IBRA,IKET,IREVER)=
     *            COS(BETISO/2.D0)*(BNN_PM(IBRA,IKET,IREVER)
     *                              +BPP_PM(IBRA,IKET,IREVER))
     *           -SIN(BETISO/2.D0)*(BNP_PM(IBRA,IKET,IREVER)
     *                              -BPN_PM(IBRA,IKET,IREVER))
               END DO
            END DO
         END DO
C
         DO IBRA=1,LDBASE
            Q00T=Q00T+(BIG_PP(IBRA,IBRA,0)
     *                +BIG_PP(IBRA,IBRA,1))
         END DO
C
         PNKE00(M,J,N,L)= Q00T
C
         IF (NBTKNO.EQ.1.OR.ICSKIP.NE.0) GOTO 821
C
         CALL SAVDEN(ISIMPY,1,0.,0)
C
         CALL COUENE(NXHERM,NYHERM,NZHERM,NXMAXX,NYMAXX,NZMAXX,
     *                                                  ISIMPY,
     *                                    ICOTYP,ICOUDI,ICOUEX,
     *                                    EKECOD,EKESCA,EKEVEC,
     *                                           SLOWEV,ISEXAC)
C
         EKECOE=EKESCA+EKEVEC
         CD0000=EKECOD
         CX0000=EKECOE
C
 821     CONTINUE
C
C=======================================================================
C             DIPOLE '10' SOURCE   <-->   DIPOLE '10' TRACE
C=======================================================================
C
         DO IREVER=0,MREVER
            DO IBRA=1,LDBASE
               DO IKET=1,LDBASE
                  BIG_PP(IBRA,IKET,IREVER)=
     *            COS(BETISO/2.D0)*(BNN_PP(IBRA,IKET,IREVER)
     *                              -BPP_PP(IBRA,IKET,IREVER))
     *           -SIN(BETISO/2.D0)*(BNP_PP(IBRA,IKET,IREVER)
     *                              +BPN_PP(IBRA,IKET,IREVER))
                  BIG_PM(IBRA,IKET,IREVER)=
     *            COS(BETISO/2.D0)*(BNN_PM(IBRA,IKET,IREVER)
     *                              -BPP_PM(IBRA,IKET,IREVER))
     *           -SIN(BETISO/2.D0)*(BNP_PM(IBRA,IKET,IREVER)
     *                              +BPN_PM(IBRA,IKET,IREVER))
               END DO
            END DO
         END DO
C
         DO IBRA=1,LDBASE
            Q10T=Q10T+(BIG_PP(IBRA,IBRA,0)
     *                +BIG_PP(IBRA,IBRA,1))
         END DO
C
         PNKE10(M,J,N,L)= Q10T
C
         IF (NBTKNO.EQ.1.OR.ICSKIP.NE.0) GOTO 822
C
         CALL SAVDEN(ISIMPY,1,0.,0)
C
         CALL COUENE(NXHERM,NYHERM,NZHERM,NXMAXX,NYMAXX,NZMAXX,
     *                                                  ISIMPY,
     *                                    ICOTYP,ICOUDI,ICOUEX,
     *                                    EKECOD,EKESCA,EKEVEC,
     *                                           SLOWEV,ISEXAC)
C
         EKECOE=EKESCA+EKEVEC
         CD1010=EKECOD
         CX1010=EKECOE
C
 822     CONTINUE
C
C=======================================================================
C           DIPOLE '1+1' SOURCE <--> DIPOLE '1+1' TRACE
C=======================================================================
C
         DO IREVER=0,MREVER
            DO IBRA=1,LDBASE
               DO IKET=1,LDBASE
                  BIG_PP(IBRA,IKET,IREVER)=
     *           -SQRT(2.D0)*(COS(BETISO/2.D0)*
     *                               BPN_PP(IBRA,IKET,IREVER)
     *                       -SIN(BETISO/2.D0)*
     *                               BPP_PP(IBRA,IKET,IREVER))
                  BIG_PM(IBRA,IKET,IREVER)=
     *           -SQRT(2.D0)*(COS(BETISO/2.D0)*
     *                               BPN_PM(IBRA,IKET,IREVER)
     *                       -SIN(BETISO/2.D0)*
     *                               BPP_PM(IBRA,IKET,IREVER))
               END DO
            END DO
         END DO
C
         DO IBRA=1,LDBASE
            Q1PT=Q1PT+(BIG_PP(IBRA,IBRA,0)
     *                +BIG_PP(IBRA,IBRA,1))
         END DO
C
         PNKE1M(M,J,N,L)=-Q1PT
C
         IF (NBTKNO.EQ.1.OR.ICSKIP.NE.0) GOTO 823
C
         CALL SAVDEN(ISIMPY,1,0.,0)
C
         CALL COUENE(NXHERM,NYHERM,NZHERM,NXMAXX,NYMAXX,NZMAXX,
     *                                                  ISIMPY,
     *                                    ICOTYP,ICOUDI,ICOUEX,
     *                                    EKECOD,EKESCA,EKEVEC,
     *                                           SLOWEV,ISEXAC)
C
         EKECOE=EKESCA+EKEVEC
         CD1P1P=EKECOD
         CX1P1P=EKECOE
C
 823     CONTINUE
C
C=======================================================================
C          DIPOLE '1-1' SOURCE   <-->   DIPOLE '1-1' TRACE
C=======================================================================
C
         DO IREVER=0,MREVER
            DO IBRA=1,LDBASE
               DO IKET=1,LDBASE
                  BIG_PP(IBRA,IKET,IREVER)=
     *            SQRT(2.D0)*(COS(BETISO/2.D0)*
     *                               BNP_PP(IBRA,IKET,IREVER)
     *                       +SIN(BETISO/2.D0)*
     *                               BNN_PP(IBRA,IKET,IREVER))
                  BIG_PM(IBRA,IKET,IREVER)=
     *            SQRT(2.D0)*(COS(BETISO/2.D0)*
     *                               BNP_PM(IBRA,IKET,IREVER)
     *                       +SIN(BETISO/2.D0)*
     *                               BNN_PM(IBRA,IKET,IREVER))
               END DO
            END DO
         END DO
C
         DO IBRA=1,LDBASE
            Q1MT=Q1MT+(BIG_PP(IBRA,IBRA,0)
     *                +BIG_PP(IBRA,IBRA,1))
         ENDDO
C
         PNKE1P(M,J,N,L)=-Q1MT
C
         IF (NBTKNO.EQ.1.OR.ICSKIP.NE.0) GOTO 82
C
         CALL SAVDEN(ISIMPY,1,0.,0)
C
         CALL COUENE(NXHERM,NYHERM,NZHERM,NXMAXX,NYMAXX,NZMAXX,
     *                                                  ISIMPY,
     *                                    ICOTYP,ICOUDI,ICOUEX,
     *                                    EKECOD,EKESCA,EKEVEC,
     *                                           SLOWEV,ISEXAC)
C
         EKECOE=EKESCA+EKEVEC
         CD1M1M=EKECOD
         CX1M1M=EKECOE
C
C=======================================================================
C      MIXED '[00 + 10]/2' SOURCE  <--> MIXED '[00 + 10]/2' TRACE
C=======================================================================
C
         DO IREVER=0,MREVER
            DO IBRA=1,LDBASE
               DO IKET=1,LDBASE
                  BIG_PP(IBRA,IKET,IREVER)=
     *            COS(BETISO/2.D0)*BNN_PP(IBRA,IKET,IREVER)
     *           -SIN(BETISO/2.D0)*BNP_PP(IBRA,IKET,IREVER)
                  BIG_PM(IBRA,IKET,IREVER)=
     *            COS(BETISO/2.D0)*BNN_PM(IBRA,IKET,IREVER)
     *           -SIN(BETISO/2.D0)*BNP_PM(IBRA,IKET,IREVER)
               END DO
            END DO
         END DO
C
         CALL SAVDEN(ISIMPY,1,0.,0)
C
         CALL COUENE(NXHERM,NYHERM,NZHERM,NXMAXX,NYMAXX,NZMAXX,
     *                                                  ISIMPY,
     *                                    ICOTYP,ICOUDI,ICOUEX,
     *                                    EKECOD,EKESCA,EKEVEC,
     *                                           SLOWEV,ISEXAC)
C
         EKECOE=EKESCA+EKEVEC
         CD0010=(4.0D0*EKECOD-CD0000-CD1010)/2.0D0
         CX0010=(4.0D0*EKECOE-CX0000-CX1010)/2.0D0
C
C=======================================================================
C        MIXED '00 + 1+1' SOURCE  <--> MIXED '00 + 1+1' TRACE
C=======================================================================
C
         DO IREVER=0,MREVER
            DO IBRA=1,LDBASE
               DO IKET=1,LDBASE
                  BIG_PP(IBRA,IKET,IREVER)=
     *            COS(BETISO/2.D0)*(BNN_PP(IBRA,IKET,IREVER)
     *                              +BPP_PP(IBRA,IKET,IREVER))
     *           -SIN(BETISO/2.D0)*(BNP_PP(IBRA,IKET,IREVER)
     *                              -BPN_PP(IBRA,IKET,IREVER))
                  BIG_PM(IBRA,IKET,IREVER)=
     *            COS(BETISO/2.D0)*(BNN_PM(IBRA,IKET,IREVER)
     *                              +BPP_PM(IBRA,IKET,IREVER))
     *           -SIN(BETISO/2.D0)*(BNP_PM(IBRA,IKET,IREVER)
     *                              -BPN_PM(IBRA,IKET,IREVER))
               END DO
            END DO
         END DO
C
         DO IREVER=0,MREVER
            DO IBRA=1,LDBASE
               DO IKET=1,LDBASE
                  BIG_PP(IBRA,IKET,IREVER)=
     *            BIG_PP(IBRA,IKET,IREVER)
     *           -SQRT(2.D0)*(COS(BETISO/2.D0)*
     *                               BPN_PP(IBRA,IKET,IREVER)
     *                       -SIN(BETISO/2.D0)*
     *                               BPP_PP(IBRA,IKET,IREVER))
                  BIG_PM(IBRA,IKET,IREVER)=
     *            BIG_PM(IBRA,IKET,IREVER)
     *           -SQRT(2.D0)*(COS(BETISO/2.D0)*
     *                               BPN_PM(IBRA,IKET,IREVER)
     *                       -SIN(BETISO/2.D0)*
     *                               BPP_PM(IBRA,IKET,IREVER))
               END DO
            END DO
         END DO
C
         CALL SAVDEN(ISIMPY,1,0.,0)
C
         CALL COUENE(NXHERM,NYHERM,NZHERM,NXMAXX,NYMAXX,NZMAXX,
     *                                                  ISIMPY,
     *                                    ICOTYP,ICOUDI,ICOUEX,
     *                                    EKECOD,EKESCA,EKEVEC,
     *                                           SLOWEV,ISEXAC)
C
         EKECOE=EKESCA+EKEVEC
         CD001P=(EKECOD-CD0000-CD1P1P)/2.0D0
         CX001P=(EKECOE-CX0000-CX1P1P)/2.0D0
C
C=======================================================================
C        MIXED '00 + 1-1' SOURCE  <--> MIXED '00 + 1-1' TRACE
C=======================================================================
C
         DO IREVER=0,MREVER
            DO IBRA=1,LDBASE
               DO IKET=1,LDBASE
                  BIG_PP(IBRA,IKET,IREVER)=
     *            COS(BETISO/2.D0)*(BNN_PP(IBRA,IKET,IREVER)
     *                              +BPP_PP(IBRA,IKET,IREVER))
     *           -SIN(BETISO/2.D0)*(BNP_PP(IBRA,IKET,IREVER)
     *                              -BPN_PP(IBRA,IKET,IREVER))
                  BIG_PM(IBRA,IKET,IREVER)=
     *            COS(BETISO/2.D0)*(BNN_PM(IBRA,IKET,IREVER)
     *                              +BPP_PM(IBRA,IKET,IREVER))
     *           -SIN(BETISO/2.D0)*(BNP_PM(IBRA,IKET,IREVER)
     *                              -BPN_PM(IBRA,IKET,IREVER))
               END DO
            END DO
         END DO
C
         DO IREVER=0,MREVER
            DO IBRA=1,LDBASE
               DO IKET=1,LDBASE
                  BIG_PP(IBRA,IKET,IREVER)=
     *            BIG_PP(IBRA,IKET,IREVER)+
     *            SQRT(2.D0)*(COS(BETISO/2.D0)*
     *                               BNP_PP(IBRA,IKET,IREVER)
     *                       +SIN(BETISO/2.D0)*
     *                               BNN_PP(IBRA,IKET,IREVER))
                  BIG_PM(IBRA,IKET,IREVER)=
     *            BIG_PM(IBRA,IKET,IREVER)+
     *            SQRT(2.D0)*(COS(BETISO/2.D0)*
     *                               BNP_PM(IBRA,IKET,IREVER)
     *                       +SIN(BETISO/2.D0)*
     *                               BNN_PM(IBRA,IKET,IREVER))
               END DO
            END DO
         END DO
C
         CALL SAVDEN(ISIMPY,1,0.,0)
C
         CALL COUENE(NXHERM,NYHERM,NZHERM,NXMAXX,NYMAXX,NZMAXX,
     *                                                  ISIMPY,
     *                                    ICOTYP,ICOUDI,ICOUEX,
     *                                    EKECOD,EKESCA,EKEVEC,
     *                                           SLOWEV,ISEXAC)
C
         EKECOE=EKESCA+EKEVEC
         CD001M=(EKECOD-CD0000-CD1M1M)/2.0D0
         CX001M=(EKECOE-CX0000-CX1M1M)/2.0D0
C
C=======================================================================
C        MIXED '10 + 1+1' SOURCE  <--> MIXED '10 + 1+1' TRACE
C=======================================================================
C
         DO IREVER=0,MREVER
            DO IBRA=1,LDBASE
               DO IKET=1,LDBASE
                  BIG_PP(IBRA,IKET,IREVER)=
     *            COS(BETISO/2.D0)*(BNN_PP(IBRA,IKET,IREVER)
     *                              -BPP_PP(IBRA,IKET,IREVER))
     *           -SIN(BETISO/2.D0)*(BPN_PP(IBRA,IKET,IREVER)
     *                              +BNP_PP(IBRA,IKET,IREVER))
                  BIG_PM(IBRA,IKET,IREVER)=
     *            COS(BETISO/2.D0)*(BNN_PM(IBRA,IKET,IREVER)
     *                              -BPP_PM(IBRA,IKET,IREVER))
     *           -SIN(BETISO/2.D0)*(BPN_PM(IBRA,IKET,IREVER)
     *                              +BNP_PM(IBRA,IKET,IREVER))
               END DO
            END DO
         END DO
C
         DO IREVER=0,MREVER
            DO IBRA=1,LDBASE
               DO IKET=1,LDBASE
                  BIG_PP(IBRA,IKET,IREVER)=
     *            BIG_PP(IBRA,IKET,IREVER)
     *           -SQRT(2.D0)*(COS(BETISO/2.D0)*
     *                               BPN_PP(IBRA,IKET,IREVER)
     *                       -SIN(BETISO/2.D0)*
     *                               BPP_PP(IBRA,IKET,IREVER))
                  BIG_PM(IBRA,IKET,IREVER)=
     *            BIG_PM(IBRA,IKET,IREVER)
     *           -SQRT(2.D0)*(COS(BETISO/2.D0)*
     *                               BPN_PM(IBRA,IKET,IREVER)
     *                       -SIN(BETISO/2.D0)*
     *                               BPP_PM(IBRA,IKET,IREVER))
               END DO
            END DO
         END DO
C
         CALL SAVDEN(ISIMPY,1,0.,0)
C
         CALL COUENE(NXHERM,NYHERM,NZHERM,NXMAXX,NYMAXX,NZMAXX,
     *                                                  ISIMPY,
     *                                    ICOTYP,ICOUDI,ICOUEX,
     *                                    EKECOD,EKESCA,EKEVEC,
     *                                           SLOWEV,ISEXAC)
C
         EKECOE=EKESCA+EKEVEC
         CD101P=(EKECOD-CD1010-CD1P1P)/2.0D0
         CX101P=(EKECOE-CX1010-CX1P1P)/2.0D0
C
C=======================================================================
C        MIXED '10 + 1-1' SOURCE  <--> MIXED '10 + 1-1' TRACE
C=======================================================================
C
         DO IREVER=0,MREVER
            DO IBRA=1,LDBASE
               DO IKET=1,LDBASE
                  BIG_PP(IBRA,IKET,IREVER)=
     *            COS(BETISO/2.D0)*(BNN_PP(IBRA,IKET,IREVER)
     *                              -BPP_PP(IBRA,IKET,IREVER))
     *           -SIN(BETISO/2.D0)*(BPN_PP(IBRA,IKET,IREVER)
     *                              +BNP_PP(IBRA,IKET,IREVER))
                  BIG_PM(IBRA,IKET,IREVER)=
     *            COS(BETISO/2.D0)*(BNN_PM(IBRA,IKET,IREVER)
     *                              -BPP_PM(IBRA,IKET,IREVER))
     *           -SIN(BETISO/2.D0)*(BPN_PM(IBRA,IKET,IREVER)
     *                              +BNP_PM(IBRA,IKET,IREVER))
               END DO
            END DO
         END DO
C
         DO IREVER=0,MREVER
            DO IBRA=1,LDBASE
               DO IKET=1,LDBASE
                  BIG_PP(IBRA,IKET,IREVER)=
     *            BIG_PP(IBRA,IKET,IREVER)+
     *            SQRT(2.D0)*(COS(BETISO/2.D0)*
     *                               BNP_PP(IBRA,IKET,IREVER)
     *                       +SIN(BETISO/2.D0)*
     *                               BNN_PP(IBRA,IKET,IREVER))
                  BIG_PM(IBRA,IKET,IREVER)=
     *            BIG_PM(IBRA,IKET,IREVER)+
     *            SQRT(2.D0)*(COS(BETISO/2.D0)*
     *                               BNP_PM(IBRA,IKET,IREVER)
     *                       +SIN(BETISO/2.D0)*
     *                               BNN_PM(IBRA,IKET,IREVER))
               END DO
            END DO
         END DO
C
         CALL SAVDEN(ISIMPY,1,0.,0)
C
         CALL COUENE(NXHERM,NYHERM,NZHERM,NXMAXX,NYMAXX,NZMAXX,
     *                                                  ISIMPY,
     *                                    ICOTYP,ICOUDI,ICOUEX,
     *                                    EKECOD,EKESCA,EKEVEC,
     *                                           SLOWEV,ISEXAC)
C
         EKECOE=EKESCA+EKEVEC
         CD101M=(EKECOD-CD1010-CD1M1M)/2.0D0
         CX101M=(EKECOE-CX1010-CX1M1M)/2.0D0
C
C=======================================================================
C      MIXED '1+1 + 1-1' SOURCE  <--> MIXED '1+1 + 1-1' TRACE
C=======================================================================
C
         DO IREVER=0,MREVER
            DO IBRA=1,LDBASE
               DO IKET=1,LDBASE
                  BIG_PP(IBRA,IKET,IREVER)=
     *           -SQRT(2.D0)*(COS(BETISO/2.D0)*
     *                               BPN_PP(IBRA,IKET,IREVER)
     *                       -SIN(BETISO/2.D0)*
     *                               BPP_PP(IBRA,IKET,IREVER))
                  BIG_PM(IBRA,IKET,IREVER)=
     *           -SQRT(2.D0)*(COS(BETISO/2.D0)*
     *                               BPN_PM(IBRA,IKET,IREVER)
     *                       -SIN(BETISO/2.D0)*
     *                               BPP_PM(IBRA,IKET,IREVER))
               END DO
            END DO
         END DO
C
         DO IREVER=0,MREVER
            DO IBRA=1,LDBASE
               DO IKET=1,LDBASE
                  BIG_PP(IBRA,IKET,IREVER)=
     *            BIG_PP(IBRA,IKET,IREVER)+
     *            SQRT(2.D0)*(COS(BETISO/2.D0)*
     *                               BNP_PP(IBRA,IKET,IREVER)
     *                       +SIN(BETISO/2.D0)*
     *                               BNN_PP(IBRA,IKET,IREVER))
                  BIG_PM(IBRA,IKET,IREVER)=
     *            BIG_PM(IBRA,IKET,IREVER)+
     *            SQRT(2.D0)*(COS(BETISO/2.D0)*
     *                               BNP_PM(IBRA,IKET,IREVER)
     *                       +SIN(BETISO/2.D0)*
     *                               BNN_PM(IBRA,IKET,IREVER))
               END DO
            END DO
         END DO
C
         CALL SAVDEN(ISIMPY,1,0.,0)
C
         CALL COUENE(NXHERM,NYHERM,NZHERM,NXMAXX,NYMAXX,NZMAXX,
     *                                                  ISIMPY,
     *                                    ICOTYP,ICOUDI,ICOUEX,
     *                                    EKECOD,EKESCA,EKEVEC,
     *                                           SLOWEV,ISEXAC)
C
         EKECOE=EKESCA+EKEVEC
         CD1P1M=(EKECOD-CD1P1P-CD1M1M)/2.0D0
         CX1P1M=(EKECOE-CX1P1P-CX1M1M)/2.0D0
C
C======================================================================
C
C    ONE AND TWO BODY (COVARIANT) TENSORS USED HERE ARE DEFINED AS
C    FOLLOWS (STANDARD TEXTBOOK DEFINITION):
C
C                 T_10  =  \tau_z;
C                 T_11  =-[\tau_x + i\tau_y]/sqrt2
C                 T_1-1 =+[\tau_x - i\tau_y]/sqrt2
C
C======================================================================
C    MISSING FACTORS 1/2 AND -1/4 IN FRONT OF DIRECT AND EXCHANGE TERMS
C    ARE EXPLICITLY INCLUDED IN COUENE
C======================================================================
C
                  CDKERN(M,J,N,L)=
     *                 (CD0000+CD1010/3.D0-2.D0*CD1P1M/3.D0)/4.D0
                  CDKE10(M,J,N,L)=
     *                 -CD0010/2.D0
                  CDKE1P(M,J,N,L)=
     *                  CD001M/2.D0
                  CDKE1M(M,J,N,L)=
     *                  CD001P/2.D0
                  CDKE20(M,J,N,L)=
     *                 (CD1010+CD1P1M)/6.D0
                  CDK21P(M,J,N,L)=
     *                 -CD101M/SQRT(3.D0)/2.D0
                  CDK21M(M,J,N,L)=
     *                 -CD101P/SQRT(3.D0)/2.D0
                  CDK22P(M,J,N,L)=
     *                  CD1M1M/SQRT(6.D0)/2.D0
                  CDK22M(M,J,N,L)=
     *                  CD1P1P/SQRT(6.D0)/2.D0
C
                  CXKERN(M,J,N,L)=
     *                 (CX0000+CX1010/3.D0-2.D0*CX1P1M/3.D0)/4.D0
                  CXKE10(M,J,N,L)=
     *                 -CX0010/2.D0
                  CXKE1P(M,J,N,L)=
     *                  CX001M/2.D0
                  CXKE1M(M,J,N,L)=
     *                  CX001P/2.D0
                  CXKE20(M,J,N,L)=
     *                 (CX1010+CX1P1M)/6.D0
                  CXK21P(M,J,N,L)=
     *                 -CX101M/SQRT(3.D0)/2.D0
                  CXK21M(M,J,N,L)=
     *                 -CX101P/SQRT(3.D0)/2.D0
                  CXK22P(M,J,N,L)=
     *                  CX1M1M/SQRT(6.D0)/2.D0
                  CXK22M(M,J,N,L)=
     *                  CX1P1P/SQRT(6.D0)/2.D0
C
  82   CONTINUE
C
C=======================================================================
C      CALCULATING  T H E   S K Y R M E   TRANSITION  E N E R G Y
C=======================================================================
C
       IF (NBTKNO.EQ.1) THEN
C
           CALL TRUTOD(NXHERM,NYHERM,NZHERM)
C
           CALL ESKYRM(NXHERM,NYHERM,NZHERM,ENDUMM,ENDUMM,ENDUMM,
     *                               ENDUMM,ENDUMM,ENDUMM,ENDUMM,
     *                                                    EKESKY)
C
           SKKERN(M,J,N,1)=EKESKY
       ELSE
C
           CALL ESKYNP(NXHERM,NYHERM,NZHERM,ENDUMM,ENDUMM,ENDUMM,
     *                               ENDUMM,ENDUMM,ENDUMM,ENDUMM,
     *                                             EKESKY,LDPNMX)
C
           SKKERN(M,J,N,L)=EKESKY
C
       ENDIF
C
            ISAALL(I,J,K,L)=ISAALL(I,J,K,L)+1
C
C=======================================================================
C         HERE WE HANDLE THE SAVING OF IPAALL=1 KERNELS ON DISK
C=======================================================================
C
            IF (ISAKER.EQ.1.AND.IPAALL.EQ.1) THEN
C
C=======================================================================
C         SEARCHING FOR THE NEXT AVAILABLE KERNEL FILE
C=======================================================================
C
                IF (IOPEND.NE.1) THEN
C
                    IF (KFIKER.LE.0) THEN
C
                       IFIBEG=001
                       IFIEND=999
                    ELSE
                       IFIBEG=KFIKER
                       IFIEND=KFIKER
C
                    END IF
C
                    DO IFIKER=IFIBEG,IFIEND
C
                       WRITE(FILACT(01:05),'(''N'',I3,''-'')') IFIKER
C
                       DO NUCHAR=02,04
C
                          IF (FILACT(NUCHAR:NUCHAR).EQ.' ')
     *                        FILACT(NUCHAR:NUCHAR)='0'
C
                       END DO
C
                       OPEN(NFIKER,FILE=FILACT,STATUS='NEW',ERR=8919,
     *                             FORM='UNFORMATTED')
C
                       CLOSE (NFIKER)
C
C=======================================================================
C         THE NEXT AVAILABLE KERNEL FILE FILE FOUND
C=======================================================================
C
                       IOPEND=1
C
                       GO TO 8918
C
 8919                  CONTINUE
C
                    END DO
C
C                   STOP' ALL KERNEL FILES N001-N999 ARE ALREADY IN USE'
C
                    FILACT(02:04)='000'
C
                    OPEN(NFIKER,FILE=FILACT,STATUS='NEW',
     *                          FORM='UNFORMATTED')
C
                    CLOSE (NFIKER)
C
 8918               CONTINUE
C
                END IF
C
C=======================================================================
C         OPENING THE FILE
C=======================================================================
C
                OPEN(NFIKER,FILE=FILACT,STATUS='OLD',
     *                      POSITION='APPEND',FORM='UNFORMATTED')
C
C=======================================================================
C         WRITING THE FILE
C=======================================================================
C
                WRITE(NFIKER) I,K,IVERKE
C
                WRITE(NFIKER) IPAALL,J,L
C
                WRITE(NFIKER) FILACT
C
                WRITE(NFIKER) NUBKNO,NBTKNO,NMURED,NMARED,NSIRED
C
                   WRITE(NFIKER) J,
     *                OVKERN(M,J,N,0),OVKERN(M,J,N,L),
     *                EKKERN(M,J,N,0),EKKERN(M,J,N,L),
     *                CDKERN(M,J,N,L),
     *                CXKERN(M,J,N,L),
     *                SKKERN(M,J,N,L),
     *               ((QPKERN(M,J,N,IND_LM(LAMBDA,MIU)),
     *                                            MIU=-LAMBDA,LAMBDA),
     *                                               LAMBDA=0,NMURED),
     *               ((APKERN(M,J,N,IND_LM(LAMBDA,MIU)),
     *                                            MIU=-LAMBDA,LAMBDA),
     *                                               LAMBDA=1,NMARED),
     *               ((SPKERN(M,J,N,IND_LM(LAMBDA,MIU)),
     *                                            MIU=-LAMBDA,LAMBDA),
     *                                          LAMBDA=NSIMIN,NSIRED)
C
                   IF (NBTKNO.GT.1)
     *
     *                 WRITE(NFIKER)
     *                    CDKE10(M,J,N,L),
     *                    CDKE1P(M,J,N,L),
     *                    CXKE10(M,J,N,L),
     *                    CXKE1P(M,J,N,L),
     *                    CDKE1M(M,J,N,L),
     *                    CDKE20(M,J,N,L),
     *                    CDK21P(M,J,N,L),
     *                    CDK21M(M,J,N,L),
     *                    CDK22P(M,J,N,L),
     *                    CDK22M(M,J,N,L),
     *                    CXKE1M(M,J,N,L),
     *                    CXKE20(M,J,N,L),
     *                    CXK21P(M,J,N,L),
     *                    CXK21M(M,J,N,L),
     *                    CXK22P(M,J,N,L),
     *                    CXK22M(M,J,N,L),
     *                    PNKE00(M,J,N,L),
     *                    PNKE10(M,J,N,L),
     *                    PNKE1P(M,J,N,L),
     *                    PNKE1M(M,J,N,L)
C
                CLOSE (NFIKER)
C
            END IF
C
 89         CONTINUE
C
C=======================================================================
C         HERE ENDS THE LOOP (NO. 1) OVER THE BETISO GAUSS KNOTS.
C=======================================================================
C
              END DO
C
C=======================================================================
C         HERE ENDS THE LOOP (NO. 1) OVER THE BETA GAUSS KNOTS
C=======================================================================
C
            END DO
C
            ISALGA(I,K)=ISALGA(I,K)+1
C
C=======================================================================
C         HERE WE HANDLE THE SAVING OF IPAALL=0 KERNELS ON DISK
C=======================================================================
C
            IF (ISAKER.EQ.1.AND.IPAALL.NE.1) THEN
C
C=======================================================================
C         SEARCHING FOR THE NEXT AVAILABLE KERNEL FILE
C=======================================================================
C
                IF (IOPEND.NE.1) THEN
C
                    IF (KFIKER.LE.0) THEN
C
                       IFIBEG=001
                       IFIEND=999
                    ELSE
                       IFIBEG=KFIKER
                       IFIEND=KFIKER
C
                    END IF
C
                    DO IFIKER=IFIBEG,IFIEND
C
                       WRITE(FILACT(01:05),'(''N'',I3,''-'')') IFIKER
C
                       DO NUCHAR=02,04
C
                          IF (FILACT(NUCHAR:NUCHAR).EQ.' ')
     *                        FILACT(NUCHAR:NUCHAR)='0'
C
                       END DO
C
                       OPEN(NFIKER,FILE=FILACT,STATUS='NEW',ERR=19,
     *                             FORM='UNFORMATTED')
C
                       CLOSE (NFIKER)
C
C=======================================================================
C         THE NEXT AVAILABLE KERNEL FILE FOUND
C=======================================================================
C
                       IOPEND=1
C
                       GO TO 18
C
   19                  CONTINUE
C
                    END DO
C
C                   STOP' ALL KERNEL FILES N001-N999 ARE ALREADY IN USE'
C
                    FILACT(02:04)='000'
C
                    OPEN(NFIKER,FILE=FILACT,STATUS='NEW',
     *                          FORM='UNFORMATTED')
C
                    CLOSE (NFIKER)
C
   18               CONTINUE
C
                END IF
C
C=======================================================================
C         OPENING THE FILE
C=======================================================================
C
                OPEN(NFIKER,FILE=FILACT,STATUS='OLD',
     *                      POSITION='APPEND',FORM='UNFORMATTED')
C
C=======================================================================
C         WRITING THE FILE
C=======================================================================
C
                WRITE(NFIKER) I,K,IVERKE
C
                WRITE(NFIKER) IPAALL,0,0
C
                WRITE(NFIKER) FILACT
C
                WRITE(NFIKER) NUBKNO,NBTKNO,NMURED,NMARED,NSIRED
C
                DO J=1,NUBKNO
C
                   WRITE(NFIKER) J,
     *                (OVKERN(M,J,N,L),L=0,NBTKNO),
     *                (EKKERN(M,J,N,L),L=0,NBTKNO),
     *                (CDKERN(M,J,N,L),L=1,NBTKNO),
     *                (CXKERN(M,J,N,L),L=1,NBTKNO),
     *                (SKKERN(M,J,N,L),L=1,NBTKNO),
     *               ((QPKERN(M,J,N,IND_LM(LAMBDA,MIU)),
     *                                            MIU=-LAMBDA,LAMBDA),
     *                                               LAMBDA=0,NMURED),
     *               ((APKERN(M,J,N,IND_LM(LAMBDA,MIU)),
     *                                            MIU=-LAMBDA,LAMBDA),
     *                                               LAMBDA=1,NMARED),
     *               ((SPKERN(M,J,N,IND_LM(LAMBDA,MIU)),
     *                                            MIU=-LAMBDA,LAMBDA),
     *                                          LAMBDA=NSIMIN,NSIRED)
C
                   IF (NBTKNO.GT.1)
     *
     *                 WRITE(NFIKER)
     *                    (CDKE10(M,J,N,L),L=1,NBTKNO),
     *                    (CDKE1P(M,J,N,L),L=1,NBTKNO),
     *                    (CXKE10(M,J,N,L),L=1,NBTKNO),
     *                    (CXKE1P(M,J,N,L),L=1,NBTKNO),
     *                    (CDKE1M(M,J,N,L),L=1,NBTKNO),
     *                    (CDKE20(M,J,N,L),L=1,NBTKNO),
     *                    (CDK21P(M,J,N,L),L=1,NBTKNO),
     *                    (CDK21M(M,J,N,L),L=1,NBTKNO),
     *                    (CDK22P(M,J,N,L),L=1,NBTKNO),
     *                    (CDK22M(M,J,N,L),L=1,NBTKNO),
     *                    (CXKE1M(M,J,N,L),L=1,NBTKNO),
     *                    (CXKE20(M,J,N,L),L=1,NBTKNO),
     *                    (CXK21P(M,J,N,L),L=1,NBTKNO),
     *                    (CXK21M(M,J,N,L),L=1,NBTKNO),
     *                    (CXK22P(M,J,N,L),L=1,NBTKNO),
     *                    (CXK22M(M,J,N,L),L=1,NBTKNO),
     *                    (PNKE00(M,J,N,L),L=1,NBTKNO),
     *                    (PNKE10(M,J,N,L),L=1,NBTKNO),
     *                    (PNKE1P(M,J,N,L),L=1,NBTKNO),
     *                    (PNKE1M(M,J,N,L),L=1,NBTKNO)
C
                END DO
C
                CLOSE (NFIKER)
C
            END IF
C
C=======================================================================
C         HERE END THE LOOPS (NO.1) OVER THE ALPHA AND GAMMA GAUSS KNOTS
C=======================================================================
C
    9       CONTINUE
C
         END DO
      END DO
C
      IF (ISAKER.EQ.1) THEN
C
          IF (IOPEND.EQ.1) THEN
C
              WRITE(NFIPRI,'(79(1H*),/,1H*,77X,1H*,/,
     *        1H*,1X,'' THE GCM KERNELS IN FUNCTION OF THE EULER'',
     *               '' ANGLES ARE SAVED; FILE (FILKER):'',   2X,1H*,/,
     *        1H*,2X,A68,                                     7X,1H*,/,
     *                                                   1H*,77X,1H*,/,
     *                                         79(1H*),/,1H*,77X,1H*,/,
     *              1H*,2X,A14,     I4,'' <= I <='',   I3,
     *                    ''  AND'',I4,'' <= K <='',   I3,
     *                    ''; TOT'',I6,'' PNTS ARE SAVD'',    1X,1H*,/,
     *                                                   1H*,77X,1H*,/,
     *                                                        79(1H*))')
     *
     *        FILKER,
     *        FILACT(01:14),NUABEG,NUAEND,NUGBEG,NUGEND,NUALGA
C
          ELSE
C
              WRITE(NFIPRI,'(79(1H*))')
C
          END IF
C
      END IF
C
C=======================================================================
C
      IPRKER=0
C
      IF (IPRKER.EQ.1) THEN
C
          AKKMAX=0.0D0
          JKKMAX=0
          IKKMAX=0
          KKKMAX=0
          LKKMAX=0
C
          DO I=1,NUAKNO
             DO J=1,NUBKNO
                DO K=1,NUAKNO
C
                   IF (NBTKNO.EQ.1) THEN
C
                       WRITE(NFIPRI,1001) I,J,K,1,ISALGA(I,K),
     *                                          ISAALL(I,J,K,1),
     *                        'ON',OVKERN(I,J,K,0),'OP',OVKERN(I,J,K,1),
     *                        'KN',EKKERN(I,J,K,0),'KP',EKKERN(I,J,K,1),
     *                        'CD',CDKERN(I,J,K,1),
C    *                        'CD',CDKERN(I,J,K,1),'CX',CXKERN(I,J,K,1),
     *                        'SK',SKKERN(I,J,K,1)
 1001                  FORMAT(6I3,6(1X,A2,1PE9.2,1PE9.2))
C
                   ELSE
C
                       DO L=1,NBTKNO
C
                          WRITE(NFIPRI,2001) I,J,K,L,ISALGA(I,K),
     *                                               ISAALL(I,J,K,L),
     *                           'OV',OVKERN(I,J,K,L),
     *                           'EN',EKKERN(I,J,K,L)+CDKERN(I,J,K,L)
     *                               +CXKERN(I,J,K,L)+SKKERN(I,J,K,L),
     *                           'KI',EKKERN(I,J,K,L),
     *                           'CD',CDKERN(I,J,K,L),
     *                           'CX',CXKERN(I,J,K,L),
     *                           'SK',SKKERN(I,J,K,L)
 2001                     FORMAT(6I3,6(1X,A2,1PE9.2,1PE9.2))
C
                          IF (AKKMAX.LT.
     *                        ABS(EKKERN(I,J,K,L)+CDKERN(I,J,K,L)
     *                           +CXKERN(I,J,K,L)+SKKERN(I,J,K,L))) THEN
C
                             AKKMAX=ABS(EKKERN(I,J,K,L)+CDKERN(I,J,K,L)
     *                                 +CXKERN(I,J,K,L)+SKKERN(I,J,K,L))
                             JKKMAX=J
                             IKKMAX=I
                             KKKMAX=K
                             LKKMAX=L
C
                          END IF
C
                       END DO
C
                   END IF
C
                END DO
             END DO
          END DO
C
          IF (NBTKNO.NE.1) THEN
C
              WRITE(NFIPRI,'(/,1X,4I3,1PE13.6,/)')
     *              IKKMAX,JKKMAX,KKKMAX,LKKMAX,AKKMAX
C
          END IF
C
      END IF
C
C=======================================================================
C         ZEROING VARIABLES THAT ARE USED FOR CALCULATION OF SUM RULES
C=======================================================================
C
      RKER_T=C_ZERO
      RSKY_T=C_ZERO
      RKIN_T=C_ZERO
      RCOU_D=C_ZERO
      RCOU_X=C_ZERO
      RPARTN=C_ZERO
      RISOSP=C_ZERO
C
      DO LAMBDA=0,NDMULR
         DO MIU=-LAMBDA,LAMBDA
C
            RMUL_P(LAMBDA,MIU)=C_ZERO
            RMAG_P(LAMBDA,MIU)=C_ZERO
            RSIF_P(LAMBDA,MIU)=C_ZERO
C
         END DO
      END DO
C
C=======================================================================
C         HERE WE SET THE LIMITS OF ANGULAR MOMENTA  FOR  WHICH  THE
C         PROJECTION IS PERFORMED. FOR AXIAL INTEGRATION, THE  LOWER
C         LIMIT CANNOT BE LOWER THAN THE PROJECTION ON THE INTRINSIC
C         AXIS "KPROJE".
C
C         THE LIMITS FOR ISOSPIN PROJECTION ARE DEFINED BY ISOSMI AND
C         ISOSMA. ISOSMI IS SET (SEE SUBROUTINE NAMELI) TO:   |N-Z|/2.
C
C=======================================================================
C
      IF (IAXIAL.EQ.1) THEN
C
          JPROMI=MAX(ABS(KPROJE),IPROMI)
          JPROMA=IPROMA
      ELSE
          JPROMI=IPROMI
          JPROMA=IPROMA
C
      END IF
C
C
C=======================================================================
C         THIS JUMP SUSPENDS INTEGRATION OF KERNELS FOR A PARALLEL RUN
C=======================================================================
C
      IF (IPAKER.EQ.1) GO TO 10
C
C=======================================================================
C                          KERNELS ARE LOADED
C                   HERE STARTS THE "INTEGRATION" BLOCK
C=======================================================================
C
C=======================================================================
C         ZEROING VARIABLES FOR THE INTEGRATION OVER THE EULER ANGLES
C=======================================================================
C
      DO IPROAC=JPROMI,JPROMA,2
C
         DO LPROAC=KPRSTA(IPROAC),KPRSTO(IPROAC),2
C
            DO KPROAC=KPRSTA(IPROAC),KPRSTO(IPROAC),2
C
               IT=0
C
               DO ISOSAC=ISOSMI,ISOSMA,2
C
               IT=IT+1
C
               TKE_TT(INDIMK(IPROAC,LPROAC,KPROAC),IT)=C_ZERO
C
               TSK_TT(INDIMK(IPROAC,LPROAC,KPROAC),IT)=C_ZERO
               TKI_NT(INDIMK(IPROAC,LPROAC,KPROAC),IT)=C_ZERO
               TKI_PT(INDIMK(IPROAC,LPROAC,KPROAC),IT)=C_ZERO
C
               TCO_DT(INDIMK(IPROAC,LPROAC,KPROAC),IT)=C_ZERO
               TC1_D0(INDIMK(IPROAC,LPROAC,KPROAC),IT)=C_ZERO
               TC1_DP(INDIMK(IPROAC,LPROAC,KPROAC),IT)=C_ZERO
               TC1_DM(INDIMK(IPROAC,LPROAC,KPROAC),IT)=C_ZERO
               TC2_D0(INDIMK(IPROAC,LPROAC,KPROAC),IT)=C_ZERO
               TC21DP(INDIMK(IPROAC,LPROAC,KPROAC),IT)=C_ZERO
               TC21DM(INDIMK(IPROAC,LPROAC,KPROAC),IT)=C_ZERO
               TC22DP(INDIMK(IPROAC,LPROAC,KPROAC),IT)=C_ZERO
               TC22DM(INDIMK(IPROAC,LPROAC,KPROAC),IT)=C_ZERO
C
               TCO_XT(INDIMK(IPROAC,LPROAC,KPROAC),IT)=C_ZERO
               TC1_X0(INDIMK(IPROAC,LPROAC,KPROAC),IT)=C_ZERO
               TC1_XP(INDIMK(IPROAC,LPROAC,KPROAC),IT)=C_ZERO
               TC1_XM(INDIMK(IPROAC,LPROAC,KPROAC),IT)=C_ZERO
               TC2_X0(INDIMK(IPROAC,LPROAC,KPROAC),IT)=C_ZERO
               TC21XP(INDIMK(IPROAC,LPROAC,KPROAC),IT)=C_ZERO
               TC21XM(INDIMK(IPROAC,LPROAC,KPROAC),IT)=C_ZERO
               TC22XP(INDIMK(IPROAC,LPROAC,KPROAC),IT)=C_ZERO
               TC22XM(INDIMK(IPROAC,LPROAC,KPROAC),IT)=C_ZERO
C
               TPN_00(INDIMK(IPROAC,LPROAC,KPROAC),IT)=C_ZERO
               TPN_10(INDIMK(IPROAC,LPROAC,KPROAC),IT)=C_ZERO
               TPN_1P(INDIMK(IPROAC,LPROAC,KPROAC),IT)=C_ZERO
               TPN_1M(INDIMK(IPROAC,LPROAC,KPROAC),IT)=C_ZERO
C
               OPROJE(INDIMK(IPROAC,LPROAC,KPROAC),IT)=C_ZERO
               EPROJE(INDIMK(IPROAC,LPROAC,KPROAC),IT)=C_ZERO
C
               ENDDO
C
C=======================================================================
C         ZEROING ARRAYS OF MULTIPOLE AND MAGNETIC MOMENTS
C=======================================================================
C
               DO LAMBDA=0,NDMULR
                  DO MIU=-LAMBDA,LAMBDA
C
                     TMUL_P(IND_LM(LAMBDA,MIU),
     *                              INDIMK(IPROAC,LPROAC,KPROAC))=C_ZERO
                     TMAG_P(IND_LM(LAMBDA,MIU),
     *                              INDIMK(IPROAC,LPROAC,KPROAC))=C_ZERO
                     TSIF_P(IND_LM(LAMBDA,MIU),
     *                              INDIMK(IPROAC,LPROAC,KPROAC))=C_ZERO
C
                  END DO
               END DO
C
            END DO
         END DO
      END DO
C
C=======================================================================
C    HERE START THE LOOPS OVER THE BETA (J), ALPHA (I), GAMMA (K), AND
C                        BETISO (L) GAUSS KNOTS
C                 INTEGRATION OVER BETISO (L) COMES FIRST
C             IT IS FOLLOWED BY INTEGRATION OVER GAMMA AND ALPHA.
C                   FINAL INTEGRATION GOES OVER BETA
C=======================================================================
C
      DO J=1,NUBKNO
        DO I=1,NUAKNO
          DO K=1,NUAKNO
C
            IT = 0
            DO ISOSAC=ISOSMI,ISOSMA,2
            IT = IT+1
C
            TKER_T(IT)=C_ZERO
            TSKY_T(IT)=C_ZERO
            TKIN_N(IT)=C_ZERO
            TKIN_P(IT)=C_ZERO
C
            TCOU_D(IT)=C_ZERO
            TC10_D(IT)=C_ZERO
            TC1P_D(IT)=C_ZERO
            TC1M_D(IT)=C_ZERO
            TC20_D(IT)=C_ZERO
            TC21PD(IT)=C_ZERO
            TC21MD(IT)=C_ZERO
            TC22PD(IT)=C_ZERO
            TC22MD(IT)=C_ZERO
C
            TCOU_X(IT)=C_ZERO
            TC10_X(IT)=C_ZERO
            TC1P_X(IT)=C_ZERO
            TC1M_X(IT)=C_ZERO
            TC20_X(IT)=C_ZERO
            TC21PX(IT)=C_ZERO
            TC21MX(IT)=C_ZERO
            TC22PX(IT)=C_ZERO
            TC22MX(IT)=C_ZERO
C
            TPNU00(IT)=C_ZERO
            TPNU10(IT)=C_ZERO
            TPNU1P(IT)=C_ZERO
            TPNU1M(IT)=C_ZERO
C
               DO L=1,NBTKNO
C
               FACINT=C_UNIT
               FACI1M=C_ZERO
               FACI1P=C_ZERO
               FACI2M=C_ZERO
               FACI2P=C_ZERO
C
               IF (NBTKNO.GT.1) THEN
               FACINT=DSMALG(ISOSAC,ISOSTZ  ,ISOSTZ,XBT_PN(L))
               IF(ISOSTZ-2.GE.-ISOSAC)
     *         FACI1P=DSMALG(ISOSAC,ISOSTZ-2,ISOSTZ,XBT_PN(L))
               IF(ISOSTZ+2.LE. ISOSAC)
     *         FACI1M=DSMALG(ISOSAC,ISOSTZ+2,ISOSTZ,XBT_PN(L))
               IF(ISOSTZ-4.GE.-ISOSAC)
     *         FACI2P=DSMALG(ISOSAC,ISOSTZ-4,ISOSTZ,XBT_PN(L))
               IF(ISOSTZ+4.LE. ISOSAC)
     *         FACI2M=DSMALG(ISOSAC,ISOSTZ+4,ISOSTZ,XBT_PN(L))
               ENDIF
C
               IF (NBTKNO.EQ.1) THEN
               FACINT=FACINT*XBT_WG(L)*OVKERN(I,J,K,0)
     *                                *OVKERN(I,J,K,1)
               ELSE
               FACINT=FACINT*XBT_WG(L)*OVKERN(I,J,K,L)
               FACI1M=FACI1M*XBT_WG(L)*OVKERN(I,J,K,L)
               FACI1P=FACI1P*XBT_WG(L)*OVKERN(I,J,K,L)
               FACI2M=FACI2M*XBT_WG(L)*OVKERN(I,J,K,L)
               FACI2P=FACI2P*XBT_WG(L)*OVKERN(I,J,K,L)
               ENDIF
C
C=======================================================================
C            INTEGRATING THE NORM, ENERGY AND COULOMB KERNELS
C=======================================================================
C
               TKER_T(IT)=TKER_T(IT)+FACINT
C
               IF (NBTKNO.EQ.1) THEN
C
               TSKY_T(IT)=TSKY_T(IT)+FACINT*SKKERN(I,J,K,L)
               TKIN_N(IT)=TKIN_N(IT)+FACINT*EKKERN(I,J,K,0)
               TKIN_P(IT)=TKIN_P(IT)+FACINT*EKKERN(I,J,K,1)
C
               ELSE
C
               TSKY_T(IT)=TSKY_T(IT)+FACINT*SKKERN(I,J,K,L)
               TKIN_N(IT)=TKIN_N(IT)+FACINT*EKKERN(I,J,K,L)
               TKIN_P(IT)=C_ZERO
               ENDIF
C
               TCOU_D(IT)=TCOU_D(IT)+FACINT*CDKERN(I,J,K,L)
               TC10_D(IT)=TC10_D(IT)+FACINT*CDKE10(I,J,K,L)
               TC1P_D(IT)=TC1P_D(IT)+FACI1P*CDKE1P(I,J,K,L)
               TC1M_D(IT)=TC1M_D(IT)+FACI1M*CDKE1M(I,J,K,L)
               TC20_D(IT)=TC20_D(IT)+FACINT*CDKE20(I,J,K,L)
               TC21PD(IT)=TC21PD(IT)+FACI1P*CDK21P(I,J,K,L)
               TC21MD(IT)=TC21MD(IT)+FACI1M*CDK21M(I,J,K,L)
               TC22PD(IT)=TC22PD(IT)+FACI2P*CDK22P(I,J,K,L)
               TC22MD(IT)=TC22MD(IT)+FACI2M*CDK22M(I,J,K,L)
C
               TCOU_X(IT)=TCOU_X(IT)+FACINT*CXKERN(I,J,K,L)
               TC10_X(IT)=TC10_X(IT)+FACINT*CXKE10(I,J,K,L)
               TC1P_X(IT)=TC1P_X(IT)+FACI1P*CXKE1P(I,J,K,L)
               TC1M_X(IT)=TC1M_X(IT)+FACI1M*CXKE1M(I,J,K,L)
               TC20_X(IT)=TC20_X(IT)+FACINT*CXKE20(I,J,K,L)
               TC21PX(IT)=TC21PX(IT)+FACI1P*CXK21P(I,J,K,L)
               TC21MX(IT)=TC21MX(IT)+FACI1M*CXK21M(I,J,K,L)
               TC22PX(IT)=TC22PX(IT)+FACI2P*CXK22P(I,J,K,L)
               TC22MX(IT)=TC22MX(IT)+FACI2M*CXK22M(I,J,K,L)
C
               TPNU00(IT)=TPNU00(IT)+FACINT*PNKE00(I,J,K,L)
               TPNU10(IT)=TPNU10(IT)+FACINT*PNKE10(I,J,K,L)
               TPNU1P(IT)=TPNU1P(IT)+FACI1P*PNKE1P(I,J,K,L)
               TPNU1M(IT)=TPNU1M(IT)+FACI1M*PNKE1M(I,J,K,L)
C
C=======================================================================
C        HERE END THE LOOPS OVER L (BETISO) GAUSS KNOTS & ISOSPIN
C=======================================================================
C
               END DO
            END DO
C
            IT = 0
            DO ISOSAC=ISOSMI,ISOSMA,2
            IT = IT+1
C
               OVKERN(I,J,K,IT)=TKER_T(IT)
               SKKERN(I,J,K,IT)=TSKY_T(IT)
C
               IF (NBTKNO.EQ.1) THEN
               EKKERN(I,J,K, 0)=TKIN_N(IT)
               EKKERN(I,J,K, 1)=TKIN_P(IT)
               ELSE
               EKKERN(I,J,K,IT)=TKIN_N(IT)
               ENDIF
C
               CDKERN(I,J,K,IT)=TCOU_D(IT)
               CDKE10(I,J,K,IT)=TC10_D(IT)
               CDKE1P(I,J,K,IT)=TC1P_D(IT)
               CDKE1M(I,J,K,IT)=TC1M_D(IT)
               CDKE20(I,J,K,IT)=TC20_D(IT)
               CDK21P(I,J,K,IT)=TC21PD(IT)
               CDK21M(I,J,K,IT)=TC21MD(IT)
               CDK22P(I,J,K,IT)=TC22PD(IT)
               CDK22M(I,J,K,IT)=TC22MD(IT)
C
               CXKERN(I,J,K,IT)=TCOU_X(IT)
               CXKE10(I,J,K,IT)=TC10_X(IT)
               CXKE1P(I,J,K,IT)=TC1P_X(IT)
               CXKE1M(I,J,K,IT)=TC1M_X(IT)
               CXKE20(I,J,K,IT)=TC20_X(IT)
               CXK21P(I,J,K,IT)=TC21PX(IT)
               CXK21M(I,J,K,IT)=TC21MX(IT)
               CXK22P(I,J,K,IT)=TC22PX(IT)
               CXK22M(I,J,K,IT)=TC22MX(IT)
C
               PNKE00(I,J,K,IT)=TPNU00(IT)
               PNKE10(I,J,K,IT)=TPNU10(IT)
               PNKE1P(I,J,K,IT)=TPNU1P(IT)
               PNKE1M(I,J,K,IT)=TPNU1M(IT)
C
            END DO
C
          END DO
        END DO
      END DO
C
      DO J=1,NUBKNO
C
      IT = 0
      DO ISOSAC=ISOSMI,ISOSMA,2
      IT = IT+1
C
        DO I=1,NUAKNO
C
          DO KPROAC=-IPROMA,IPROMA,2
C
C=======================================================================
C         ZEROING AUXILIARY ARRAYS OF OVERLAP AND ENERGY KERNELS
C=======================================================================
C
          ZKER_T(I,KPROAC,IT)=C_ZERO
C
          ZSKY_T(I,KPROAC,IT)=C_ZERO
          ZKIN_N(I,KPROAC,IT)=C_ZERO
          ZKIN_P(I,KPROAC,IT)=C_ZERO
C
          ZCOU_D(I,KPROAC,IT)=C_ZERO
          ZC10_D(I,KPROAC,IT)=C_ZERO
          ZC1P_D(I,KPROAC,IT)=C_ZERO
          ZC1M_D(I,KPROAC,IT)=C_ZERO
          ZC20_D(I,KPROAC,IT)=C_ZERO
          ZC21PD(I,KPROAC,IT)=C_ZERO
          ZC21MD(I,KPROAC,IT)=C_ZERO
          ZC22PD(I,KPROAC,IT)=C_ZERO
          ZC22MD(I,KPROAC,IT)=C_ZERO
C
          ZCOU_X(I,KPROAC,IT)=C_ZERO
          ZC10_X(I,KPROAC,IT)=C_ZERO
          ZC1P_X(I,KPROAC,IT)=C_ZERO
          ZC1M_X(I,KPROAC,IT)=C_ZERO
          ZC20_X(I,KPROAC,IT)=C_ZERO
          ZC21PX(I,KPROAC,IT)=C_ZERO
          ZC21MX(I,KPROAC,IT)=C_ZERO
          ZC22PX(I,KPROAC,IT)=C_ZERO
          ZC22MX(I,KPROAC,IT)=C_ZERO
C
          ZPNU00(I,KPROAC,IT)=C_ZERO
          ZPNU10(I,KPROAC,IT)=C_ZERO
          ZPNU1P(I,KPROAC,IT)=C_ZERO
          ZPNU1M(I,KPROAC,IT)=C_ZERO
C
C=======================================================================
C         ZEROING AUXILIARY ARRAYS OF MULTIPOLE, MAGNETIC, AND SURFACE
C         OR SCHIFF MOMENTS
C=======================================================================
C
          DO LAMBDA=0,NDMULR
             DO MIU=-LAMBDA,LAMBDA
C
               ZMUL_P(I,KPROAC,IND_LM(LAMBDA,MIU))=C_ZERO
               ZMAG_P(I,KPROAC,IND_LM(LAMBDA,MIU))=C_ZERO
               ZSIF_P(I,KPROAC,IND_LM(LAMBDA,MIU))=C_ZERO
C
             END DO
          END DO
C
C=======================================================================
C         BELOW WE INTEGRATE KERNELS OVER THE GAMMA EULER ANGLE AND
C         AT THE SAME TIME WE MULTIPLY THEM BY THE  GAUSS  WEIGHTS
C=======================================================================
C
              DO K=1,NUAKNO
C
              GAMM_K=XA_PNT(K)*0.5D0*KPROAC
C
              FACINT=XA_WGT(K)*(COS(GAMM_K)+UNIT_I*SIN(GAMM_K))
C
              IF (NBTKNO.EQ.1) FACMOM=OVKERN(I,J,K,1)
C
C=======================================================================
C                    INTEGRATING THE NORM KERNEL
C=======================================================================
C
                  ZKER_T(I,KPROAC,IT)=ZKER_T(I,KPROAC,IT)
     *                           +FACINT*OVKERN(I,J,K,IT)
C
C=======================================================================
C                    INTEGRATING THE ENERGY KERNELS
C=======================================================================
C
                  ZSKY_T(I,KPROAC,IT)=ZSKY_T(I,KPROAC,IT)
     *                           +FACINT*SKKERN(I,J,K,IT)

                  IF (NBTKNO.EQ.1) THEN
                  ZKIN_N(I,KPROAC,IT)=ZKIN_N(I,KPROAC,IT)
     *                            +FACINT*EKKERN(I,J,K,0)
                  ZKIN_P(I,KPROAC,IT)=ZKIN_P(I,KPROAC,IT)
     *                            +FACINT*EKKERN(I,J,K,1)
                  ELSE
                  ZKIN_N(I,KPROAC,IT)=ZKIN_N(I,KPROAC,IT)
     *                           +FACINT*EKKERN(I,J,K,IT)
                  ZKIN_P(I,KPROAC,IT)=C_ZERO
                  ENDIF
C
                  ZCOU_D(I,KPROAC,IT)=ZCOU_D(I,KPROAC,IT)
     *                           +FACINT*CDKERN(I,J,K,IT)
                  ZC10_D(I,KPROAC,IT)=ZC10_D(I,KPROAC,IT)
     *                           +FACINT*CDKE10(I,J,K,IT)
                  ZC1P_D(I,KPROAC,IT)=ZC1P_D(I,KPROAC,IT)
     *                           +FACINT*CDKE1P(I,J,K,IT)
                  ZC1M_D(I,KPROAC,IT)=ZC1M_D(I,KPROAC,IT)
     *                           +FACINT*CDKE1M(I,J,K,IT)
                  ZC20_D(I,KPROAC,IT)=ZC20_D(I,KPROAC,IT)
     *                           +FACINT*CDKE20(I,J,K,IT)
                  ZC21PD(I,KPROAC,IT)=ZC21PD(I,KPROAC,IT)
     *                           +FACINT*CDK21P(I,J,K,IT)
                  ZC21MD(I,KPROAC,IT)=ZC21MD(I,KPROAC,IT)
     *                           +FACINT*CDK21M(I,J,K,IT)
                  ZC22PD(I,KPROAC,IT)=ZC22PD(I,KPROAC,IT)
     *                           +FACINT*CDK22P(I,J,K,IT)
                  ZC22MD(I,KPROAC,IT)=ZC22MD(I,KPROAC,IT)
     *                           +FACINT*CDK22M(I,J,K,IT)
C
                  ZCOU_X(I,KPROAC,IT)=ZCOU_X(I,KPROAC,IT)
     *                           +FACINT*CXKERN(I,J,K,IT)
                  ZC10_X(I,KPROAC,IT)=ZC10_X(I,KPROAC,IT)
     *                           +FACINT*CXKE10(I,J,K,IT)
                  ZC1P_X(I,KPROAC,IT)=ZC1P_X(I,KPROAC,IT)
     *                           +FACINT*CXKE1P(I,J,K,IT)
                  ZC1M_X(I,KPROAC,IT)=ZC1M_X(I,KPROAC,IT)
     *                           +FACINT*CXKE1M(I,J,K,IT)
                  ZC20_X(I,KPROAC,IT)=ZC20_X(I,KPROAC,IT)
     *                           +FACINT*CXKE20(I,J,K,IT)
                  ZC21PX(I,KPROAC,IT)=ZC21PX(I,KPROAC,IT)
     *                           +FACINT*CXK21P(I,J,K,IT)
                  ZC21MX(I,KPROAC,IT)=ZC21MX(I,KPROAC,IT)
     *                           +FACINT*CXK21M(I,J,K,IT)
                  ZC22PX(I,KPROAC,IT)=ZC22PX(I,KPROAC,IT)
     *                           +FACINT*CXK22P(I,J,K,IT)
                  ZC22MX(I,KPROAC,IT)=ZC22MX(I,KPROAC,IT)
     *                           +FACINT*CXK22M(I,J,K,IT)
C
                  ZPNU00(I,KPROAC,IT)=ZPNU00(I,KPROAC,IT)
     *                           +FACINT*PNKE00(I,J,K,IT)
                  ZPNU10(I,KPROAC,IT)=ZPNU10(I,KPROAC,IT)
     *                           +FACINT*PNKE10(I,J,K,IT)
                  ZPNU1P(I,KPROAC,IT)=ZPNU1P(I,KPROAC,IT)
     *                           +FACINT*PNKE1P(I,J,K,IT)
                  ZPNU1M(I,KPROAC,IT)=ZPNU1M(I,KPROAC,IT)
     *                           +FACINT*PNKE1M(I,J,K,IT)
C
                  IF (NBTKNO.EQ.1) THEN
C
C=======================================================================
C             INTEGRATING THE KERNELS OF THE MULTIPOLE MOMENTS
C=======================================================================
C
                  DO LAMBDA=0,NMURED
                     DO MIU=-LAMBDA,LAMBDA
C
                     ZMUL_P(I,KPROAC,IND_LM(LAMBDA,MIU))=
     *               ZMUL_P(I,KPROAC,IND_LM(LAMBDA,MIU))
     *                                                  +FACINT*FACMOM
     *                                *QPKERN(I,J,K,IND_LM(LAMBDA,MIU))
C
                     END DO
                  END DO
C
C=======================================================================
C                    INTEGRATING THE KERNELS OF THE MAGNETIC MOMENTS
C=======================================================================
C
                  DO LAMBDA=1,NMARED
                     DO MIU=-LAMBDA,LAMBDA
C
                     ZMAG_P(I,KPROAC,IND_LM(LAMBDA,MIU))=
     *               ZMAG_P(I,KPROAC,IND_LM(LAMBDA,MIU))
     *                                                  +FACINT*FACMOM
     *                                *APKERN(I,J,K,IND_LM(LAMBDA,MIU))
C
                     END DO
                  END DO
C
C=======================================================================
C                    INTEGRATING THE KERNELS OF THE SURFACE OR SCHIFF
C                    MOMENTS
C=======================================================================
C
                  DO LAMBDA=NSIMIN,NSIRED
                     DO MIU=-LAMBDA,LAMBDA
C
                     ZSIF_P(I,KPROAC,IND_LM(LAMBDA,MIU))=
     *               ZSIF_P(I,KPROAC,IND_LM(LAMBDA,MIU))
     *                                                  +FACINT*FACMOM
     *                                *SPKERN(I,J,K,IND_LM(LAMBDA,MIU))
C
                     END DO
                  END DO
C
                  ENDIF
C
C=======================================================================
C           HERE END THE LOOPS  OVER THE  GAMMA  GAUSS  KNOTS
C         AND THE LOOP OVER THE K PROJECTION ON THE INTRINSIC AXIS
C=======================================================================
C
              END DO
          END DO
C
C=======================================================================
C           HERE END THE LOOPS  OVER THE  ALPHA  GAUSS  KNOTS
C=======================================================================
C
        END DO
C
C=======================================================================
C         HERE STARTS THE LOOP OVER THE K' PROJECTION ON THE INTRINSIC
C         AXIS; INDEX "LPROAC", AND OVER THE K PROJECTION ON THE
C         INTRINSIC AXIS; INDEX "KPROAC".
C=======================================================================
C
          DO LPROAC=-IPROMA,IPROMA,2
C
             DO KPROAC=-IPROMA,IPROMA,2
C
C=======================================================================
C         ZEROING AUXILIARY ARRAYS OF OVERLAP AND ENERGY KERNELS
C=======================================================================
C
               CKER_T(LPROAC,KPROAC,IT)=C_ZERO
C
               CSKY_T(LPROAC,KPROAC,IT)=C_ZERO
               CKIN_N(LPROAC,KPROAC,IT)=C_ZERO
               CKIN_P(LPROAC,KPROAC,IT)=C_ZERO
C
               CCOU_D(LPROAC,KPROAC,IT)=C_ZERO
               CC10_D(LPROAC,KPROAC,IT)=C_ZERO
               CC1P_D(LPROAC,KPROAC,IT)=C_ZERO
               CC1M_D(LPROAC,KPROAC,IT)=C_ZERO
               CC20_D(LPROAC,KPROAC,IT)=C_ZERO
               CC21PD(LPROAC,KPROAC,IT)=C_ZERO
               CC21MD(LPROAC,KPROAC,IT)=C_ZERO
               CC22PD(LPROAC,KPROAC,IT)=C_ZERO
               CC22MD(LPROAC,KPROAC,IT)=C_ZERO
C
               CCOU_X(LPROAC,KPROAC,IT)=C_ZERO
               CC10_X(LPROAC,KPROAC,IT)=C_ZERO
               CC1P_X(LPROAC,KPROAC,IT)=C_ZERO
               CC1M_X(LPROAC,KPROAC,IT)=C_ZERO
               CC20_X(LPROAC,KPROAC,IT)=C_ZERO
               CC21PX(LPROAC,KPROAC,IT)=C_ZERO
               CC21MX(LPROAC,KPROAC,IT)=C_ZERO
               CC22PX(LPROAC,KPROAC,IT)=C_ZERO
               CC22MX(LPROAC,KPROAC,IT)=C_ZERO
C
               CPNU00(LPROAC,KPROAC,IT)=C_ZERO
               CPNU10(LPROAC,KPROAC,IT)=C_ZERO
               CPNU1P(LPROAC,KPROAC,IT)=C_ZERO
               CPNU1M(LPROAC,KPROAC,IT)=C_ZERO
C
C=======================================================================
C         ZEROING AUXILIARY ARRAYS OF MULTIPOLE AND MAGNETIC MOMENTS
C=======================================================================
C
               DO LAMBDA=0,NDMULR
                  DO MIU=-LAMBDA,LAMBDA
C
                     CMUL_P(LPROAC,KPROAC,IND_LM(LAMBDA,MIU))=C_ZERO
                     CMAG_P(LPROAC,KPROAC,IND_LM(LAMBDA,MIU))=C_ZERO
                     CSIF_P(LPROAC,KPROAC,IND_LM(LAMBDA,MIU))=C_ZERO
C
                  END DO
               END DO
C
C=======================================================================
C         HERE WE INTEGRATE THE KERNELS OVER THE ALPHA EULER ANGLE
C=======================================================================
C
                  DO I=1,NUAKNO
C
                  ALPH_L=XA_PNT(I)*0.5D0*LPROAC
                  FACINT=XA_WGT(I)*(COS(ALPH_L)+UNIT_I*SIN(ALPH_L))
C
                  CKER_T(LPROAC,KPROAC,IT)=CKER_T(LPROAC,KPROAC,IT)
     *                                  +FACINT*ZKER_T(I,KPROAC,IT)
C
                  CSKY_T(LPROAC,KPROAC,IT)=CSKY_T(LPROAC,KPROAC,IT)
     *                                  +FACINT*ZSKY_T(I,KPROAC,IT)
                  CKIN_N(LPROAC,KPROAC,IT)=CKIN_N(LPROAC,KPROAC,IT)
     *                                  +FACINT*ZKIN_N(I,KPROAC,IT)
                  CKIN_P(LPROAC,KPROAC,IT)=CKIN_P(LPROAC,KPROAC,IT)
     *                                  +FACINT*ZKIN_P(I,KPROAC,IT)
C
                  CCOU_D(LPROAC,KPROAC,IT)=CCOU_D(LPROAC,KPROAC,IT)
     *                                  +FACINT*ZCOU_D(I,KPROAC,IT)
                  CC10_D(LPROAC,KPROAC,IT)=CC10_D(LPROAC,KPROAC,IT)
     *                                  +FACINT*ZC10_D(I,KPROAC,IT)
                  CC1P_D(LPROAC,KPROAC,IT)=CC1P_D(LPROAC,KPROAC,IT)
     *                                  +FACINT*ZC1P_D(I,KPROAC,IT)
                  CC1M_D(LPROAC,KPROAC,IT)=CC1M_D(LPROAC,KPROAC,IT)
     *                                  +FACINT*ZC1M_D(I,KPROAC,IT)
                  CC20_D(LPROAC,KPROAC,IT)=CC20_D(LPROAC,KPROAC,IT)
     *                                  +FACINT*ZC20_D(I,KPROAC,IT)
                  CC21PD(LPROAC,KPROAC,IT)=CC21PD(LPROAC,KPROAC,IT)
     *                                  +FACINT*ZC21PD(I,KPROAC,IT)
                  CC21MD(LPROAC,KPROAC,IT)=CC21MD(LPROAC,KPROAC,IT)
     *                                  +FACINT*ZC21MD(I,KPROAC,IT)
                  CC22PD(LPROAC,KPROAC,IT)=CC22PD(LPROAC,KPROAC,IT)
     *                                  +FACINT*ZC22PD(I,KPROAC,IT)
                  CC22MD(LPROAC,KPROAC,IT)=CC22MD(LPROAC,KPROAC,IT)
     *                                  +FACINT*ZC22MD(I,KPROAC,IT)
C
                  CCOU_X(LPROAC,KPROAC,IT)=CCOU_X(LPROAC,KPROAC,IT)
     *                                  +FACINT*ZCOU_X(I,KPROAC,IT)
                  CC10_X(LPROAC,KPROAC,IT)=CC10_X(LPROAC,KPROAC,IT)
     *                                  +FACINT*ZC10_X(I,KPROAC,IT)
                  CC1P_X(LPROAC,KPROAC,IT)=CC1P_X(LPROAC,KPROAC,IT)
     *                                  +FACINT*ZC1P_X(I,KPROAC,IT)
                  CC1M_X(LPROAC,KPROAC,IT)=CC1M_X(LPROAC,KPROAC,IT)
     *                                  +FACINT*ZC1M_X(I,KPROAC,IT)
                  CC20_X(LPROAC,KPROAC,IT)=CC20_X(LPROAC,KPROAC,IT)
     *                                  +FACINT*ZC20_X(I,KPROAC,IT)
                  CC21PX(LPROAC,KPROAC,IT)=CC21PX(LPROAC,KPROAC,IT)
     *                                  +FACINT*ZC21PX(I,KPROAC,IT)
                  CC21MX(LPROAC,KPROAC,IT)=CC21MX(LPROAC,KPROAC,IT)
     *                                  +FACINT*ZC21MX(I,KPROAC,IT)
                  CC22PX(LPROAC,KPROAC,IT)=CC22PX(LPROAC,KPROAC,IT)
     *                                  +FACINT*ZC22PX(I,KPROAC,IT)
                  CC22MX(LPROAC,KPROAC,IT)=CC22MX(LPROAC,KPROAC,IT)
     *                                  +FACINT*ZC22MX(I,KPROAC,IT)
C
                  CPNU00(LPROAC,KPROAC,IT)=CPNU00(LPROAC,KPROAC,IT)
     *                                  +FACINT*ZPNU00(I,KPROAC,IT)
                  CPNU10(LPROAC,KPROAC,IT)=CPNU10(LPROAC,KPROAC,IT)
     *                                  +FACINT*ZPNU10(I,KPROAC,IT)
                  CPNU1P(LPROAC,KPROAC,IT)=CPNU1P(LPROAC,KPROAC,IT)
     *                                  +FACINT*ZPNU1P(I,KPROAC,IT)
                  CPNU1M(LPROAC,KPROAC,IT)=CPNU1M(LPROAC,KPROAC,IT)
     *                                  +FACINT*ZPNU1M(I,KPROAC,IT)
C
                  IF (NBTKNO.EQ.1) THEN
C
C=======================================================================
C                    INTEGRATING KERNELS OF THE MULTIPOLE MOMENTS
C=======================================================================
C
                  DO LAMBDA=0,NMURED
                     DO MIU=-LAMBDA,LAMBDA
C
                     CMUL_P(LPROAC,KPROAC,IND_LM(LAMBDA,MIU))=
     *               CMUL_P(LPROAC,KPROAC,IND_LM(LAMBDA,MIU))
     *                       +FACINT*ZMUL_P(I,KPROAC,IND_LM(LAMBDA,MIU))
C
                     END DO
                  END DO
C
C=======================================================================
C                    INTEGRATING KERNELS OF THE MAGNETIC MOMENTS
C=======================================================================
C
                  DO LAMBDA=1,NMARED
                     DO MIU=-LAMBDA,LAMBDA
C
                     CMAG_P(LPROAC,KPROAC,IND_LM(LAMBDA,MIU))=
     *               CMAG_P(LPROAC,KPROAC,IND_LM(LAMBDA,MIU))
     *                       +FACINT*ZMAG_P(I,KPROAC,IND_LM(LAMBDA,MIU))
C
                     END DO
                  END DO
C
C=======================================================================
C                    INTEGRATING KERNELS OF THE SURFACE OR SCHIFF
C                    MOMENTS
C=======================================================================
C
                  DO LAMBDA=NSIMIN,NSIRED
                     DO MIU=-LAMBDA,LAMBDA
C
                     CSIF_P(LPROAC,KPROAC,IND_LM(LAMBDA,MIU))=
     *               CSIF_P(LPROAC,KPROAC,IND_LM(LAMBDA,MIU))
     *                       +FACINT*ZSIF_P(I,KPROAC,IND_LM(LAMBDA,MIU))
C
                     END DO
                  END DO
C
                  ENDIF
C
C=======================================================================
C         HERE ENDS THE LOOP OVER THE ALPHA GAUSS KNOTS (I), THE
C         LOOPS OVER THE L AND K PROJECTIONS ON THE INTRINSIC AXIS,
C         AND THE LOOP OVER THE ISOSPIN
C=======================================================================
C
                  END DO
C
             END DO
          END DO
C
       END DO
C
C======================================================================
C              HERE STARTS THE LOOP OVER THE ANGULAR MOMENTA
C                 AND FINAL INTEGRATION OVER BETA (J)
C=======================================================================
C
         DO IPROAC=JPROMI,JPROMA,2
C
            DO LPROAC=KPRSTA(IPROAC),KPRSTO(IPROAC),2
C
               DO KPROAC=KPRSTA(IPROAC),KPRSTO(IPROAC),2
C
                  FACINT=XB_WGT(J)*
     *                   DSMALG(IPROAC,LPROAC,KPROAC,XB_PNT(J))
C
                  IT = 0
                  DO ISOSAC=ISOSMI,ISOSMA,2
                  IT = IT+1
C
                  TKE_TT(INDIMK(IPROAC,LPROAC,KPROAC),IT)=
     *            TKE_TT(INDIMK(IPROAC,LPROAC,KPROAC),IT)
     *                   +FACINT*CKER_T(LPROAC,KPROAC,IT)
C
                  TSK_TT(INDIMK(IPROAC,LPROAC,KPROAC),IT)=
     *            TSK_TT(INDIMK(IPROAC,LPROAC,KPROAC),IT)
     *                   +FACINT*CSKY_T(LPROAC,KPROAC,IT)
                  TKI_NT(INDIMK(IPROAC,LPROAC,KPROAC),IT)=
     *            TKI_NT(INDIMK(IPROAC,LPROAC,KPROAC),IT)
     *                   +FACINT*CKIN_N(LPROAC,KPROAC,IT)
                  TKI_PT(INDIMK(IPROAC,LPROAC,KPROAC),IT)=
     *            TKI_PT(INDIMK(IPROAC,LPROAC,KPROAC),IT)
     *                   +FACINT*CKIN_P(LPROAC,KPROAC,IT)
C
                  TCO_DT(INDIMK(IPROAC,LPROAC,KPROAC),IT)=
     *            TCO_DT(INDIMK(IPROAC,LPROAC,KPROAC),IT)
     *                   +FACINT*CCOU_D(LPROAC,KPROAC,IT)
                  TC1_D0(INDIMK(IPROAC,LPROAC,KPROAC),IT)=
     *            TC1_D0(INDIMK(IPROAC,LPROAC,KPROAC),IT)
     *                   +FACINT*CC10_D(LPROAC,KPROAC,IT)
                  TC1_DP(INDIMK(IPROAC,LPROAC,KPROAC),IT)=
     *            TC1_DP(INDIMK(IPROAC,LPROAC,KPROAC),IT)
     *                   +FACINT*CC1P_D(LPROAC,KPROAC,IT)
                  TC1_DM(INDIMK(IPROAC,LPROAC,KPROAC),IT)=
     *            TC1_DM(INDIMK(IPROAC,LPROAC,KPROAC),IT)
     *                   +FACINT*CC1M_D(LPROAC,KPROAC,IT)
                  TC2_D0(INDIMK(IPROAC,LPROAC,KPROAC),IT)=
     *            TC2_D0(INDIMK(IPROAC,LPROAC,KPROAC),IT)
     *                   +FACINT*CC20_D(LPROAC,KPROAC,IT)
                  TC21DP(INDIMK(IPROAC,LPROAC,KPROAC),IT)=
     *            TC21DP(INDIMK(IPROAC,LPROAC,KPROAC),IT)
     *                   +FACINT*CC21PD(LPROAC,KPROAC,IT)
                  TC21DM(INDIMK(IPROAC,LPROAC,KPROAC),IT)=
     *            TC21DM(INDIMK(IPROAC,LPROAC,KPROAC),IT)
     *                   +FACINT*CC21MD(LPROAC,KPROAC,IT)
                  TC22DP(INDIMK(IPROAC,LPROAC,KPROAC),IT)=
     *            TC22DP(INDIMK(IPROAC,LPROAC,KPROAC),IT)
     *                   +FACINT*CC22PD(LPROAC,KPROAC,IT)
                  TC22DM(INDIMK(IPROAC,LPROAC,KPROAC),IT)=
     *            TC22DM(INDIMK(IPROAC,LPROAC,KPROAC),IT)
     *                   +FACINT*CC22MD(LPROAC,KPROAC,IT)
C
                  TCO_XT(INDIMK(IPROAC,LPROAC,KPROAC),IT)=
     *            TCO_XT(INDIMK(IPROAC,LPROAC,KPROAC),IT)
     *                   +FACINT*CCOU_X(LPROAC,KPROAC,IT)
                  TC1_X0(INDIMK(IPROAC,LPROAC,KPROAC),IT)=
     *            TC1_X0(INDIMK(IPROAC,LPROAC,KPROAC),IT)
     *                   +FACINT*CC10_X(LPROAC,KPROAC,IT)
                  TC1_XP(INDIMK(IPROAC,LPROAC,KPROAC),IT)=
     *            TC1_XP(INDIMK(IPROAC,LPROAC,KPROAC),IT)
     *                   +FACINT*CC1P_X(LPROAC,KPROAC,IT)
                  TC1_XM(INDIMK(IPROAC,LPROAC,KPROAC),IT)=
     *            TC1_XM(INDIMK(IPROAC,LPROAC,KPROAC),IT)
     *                   +FACINT*CC1M_X(LPROAC,KPROAC,IT)
                  TC2_X0(INDIMK(IPROAC,LPROAC,KPROAC),IT)=
     *            TC2_X0(INDIMK(IPROAC,LPROAC,KPROAC),IT)
     *                   +FACINT*CC20_X(LPROAC,KPROAC,IT)
                  TC21XP(INDIMK(IPROAC,LPROAC,KPROAC),IT)=
     *            TC21XP(INDIMK(IPROAC,LPROAC,KPROAC),IT)
     *                   +FACINT*CC21PX(LPROAC,KPROAC,IT)
                  TC21XM(INDIMK(IPROAC,LPROAC,KPROAC),IT)=
     *            TC21XM(INDIMK(IPROAC,LPROAC,KPROAC),IT)
     *                   +FACINT*CC21MX(LPROAC,KPROAC,IT)
                  TC22XP(INDIMK(IPROAC,LPROAC,KPROAC),IT)=
     *            TC22XP(INDIMK(IPROAC,LPROAC,KPROAC),IT)
     *                   +FACINT*CC22PX(LPROAC,KPROAC,IT)
                  TC22XM(INDIMK(IPROAC,LPROAC,KPROAC),IT)=
     *            TC22XM(INDIMK(IPROAC,LPROAC,KPROAC),IT)
     *                   +FACINT*CC22MX(LPROAC,KPROAC,IT)
C
                  TPN_00(INDIMK(IPROAC,LPROAC,KPROAC),IT)=
     *            TPN_00(INDIMK(IPROAC,LPROAC,KPROAC),IT)
     *                   +FACINT*CPNU00(LPROAC,KPROAC,IT)
                  TPN_10(INDIMK(IPROAC,LPROAC,KPROAC),IT)=
     *            TPN_10(INDIMK(IPROAC,LPROAC,KPROAC),IT)
     *                   +FACINT*CPNU10(LPROAC,KPROAC,IT)
                  TPN_1P(INDIMK(IPROAC,LPROAC,KPROAC),IT)=
     *            TPN_1P(INDIMK(IPROAC,LPROAC,KPROAC),IT)
     *                   +FACINT*CPNU1P(LPROAC,KPROAC,IT)
                  TPN_1M(INDIMK(IPROAC,LPROAC,KPROAC),IT)=
     *            TPN_1M(INDIMK(IPROAC,LPROAC,KPROAC),IT)
     *                   +FACINT*CPNU1M(LPROAC,KPROAC,IT)
C
C
C=======================================================================
C                  HERE ENDS THE INTERNAL LOOP OVER THE ISOSPIN
C=======================================================================
                   END DO
C
                  IF (NBTKNO.EQ.1) THEN
C
C=======================================================================
C                    INTEGRATING KERNELS OF THE MULTIPOLE MOMENTS
C=======================================================================
C
                  DO LAMBDA=0,NMURED
                     DO MIU=-LAMBDA,LAMBDA
C
                        TMUL_P(IND_LM(LAMBDA,MIU),
     *                              INDIMK(IPROAC,LPROAC,KPROAC))=
     *                  TMUL_P(IND_LM(LAMBDA,MIU),
     *                              INDIMK(IPROAC,LPROAC,KPROAC))
     *                  +FACINT*CMUL_P(LPROAC,KPROAC,IND_LM(LAMBDA,MIU))
C
                     END DO
                  END DO
C
C=======================================================================
C                    INTEGRATING KERNELS OF THE MAGNETIC MOMENTS
C=======================================================================
C
                  DO LAMBDA=1,NMARED
                     DO MIU=-LAMBDA,LAMBDA
C
                        TMAG_P(IND_LM(LAMBDA,MIU),
     *                              INDIMK(IPROAC,LPROAC,KPROAC))=
     *                  TMAG_P(IND_LM(LAMBDA,MIU),
     *                              INDIMK(IPROAC,LPROAC,KPROAC))
     *                  +FACINT*CMAG_P(LPROAC,KPROAC,IND_LM(LAMBDA,MIU))
C
                     END DO
                  END DO
C
C=======================================================================
C                    INTEGRATING KERNELS OF THE SURFACE OR SCHIFF
C                    MOMENTS
C=======================================================================
C
                  DO LAMBDA=NSIMIN,NSIRED
                     DO MIU=-LAMBDA,LAMBDA
C
                        TSIF_P(IND_LM(LAMBDA,MIU),
     *                              INDIMK(IPROAC,LPROAC,KPROAC))=
     *                  TSIF_P(IND_LM(LAMBDA,MIU),
     *                              INDIMK(IPROAC,LPROAC,KPROAC))
     *                  +FACINT*CSIF_P(LPROAC,KPROAC,IND_LM(LAMBDA,MIU))
C
                     END DO
                  END DO
C
                  ENDIF
C
C=======================================================================
C    HERE END THE LOOPS OVER THE ANGULAR MOMENTA AND PROJECTIONS
C=======================================================================
C
               END DO
            END DO
         END DO
C
C=======================================================================
C             HERE ENDS THE LOOP OVER THE BETA GAUSS KNOTS
C=======================================================================
C
      END DO
C
C=======================================================================
C         MULTIPLYING THE INTEGRATED KERNELS BY OVERALL FACTORS
C=======================================================================
C
      I_HEAD=0
C
      DO IPROAC=JPROMI,JPROMA,2
C
         DO LPROAC=KPRSTA(IPROAC),KPRSTO(IPROAC),2
C
            DO KPROAC=KPRSTA(IPROAC),KPRSTO(IPROAC),2
C
               IF (NUBKNO.EQ.1) THEN
                   FACNOI=             1/( 4.0D0*PI*PI)
               ELSE
                   FACNOI=(IPROAC+1.0D0)/( 8.0D0*PI*PI)
               ENDIF
C
               IT=0
C
C==================================================================
C                  INTERNAL LOOP OVER THE ISOSPIN
C==================================================================
C
               DO ISOSAC=ISOSMI,ISOSMA,2
C
               E_10=CGCOEF(ISOSAC,ISOSTZ  ,2, 0,ISOSAC,ISOSTZ)
               E11P=CGCOEF(ISOSAC,ISOSTZ-2,2, 2,ISOSAC,ISOSTZ)
               E11M=CGCOEF(ISOSAC,ISOSTZ+2,2,-2,ISOSAC,ISOSTZ)
               E_20=CGCOEF(ISOSAC,ISOSTZ  ,4, 0,ISOSAC,ISOSTZ)
               E21P=CGCOEF(ISOSAC,ISOSTZ-2,4, 2,ISOSAC,ISOSTZ)
               E21M=CGCOEF(ISOSAC,ISOSTZ+2,4,-2,ISOSAC,ISOSTZ)
               E22P=CGCOEF(ISOSAC,ISOSTZ-4,4, 4,ISOSAC,ISOSTZ)
               E22M=CGCOEF(ISOSAC,ISOSTZ+4,4,-4,ISOSAC,ISOSTZ)
C
               E211P=E_10*E11P
               E211M=E_10*E11M
C
               E221P=E_20*E21P
               E221M=E_20*E21M
               E222P=E_20*E22P
               E222M=E_20*E22M
C
               E2_10=E_10*E_10
               E2_20=E_20*E_20
C
               IT=IT+1
C
               IF (NBTKNO.EQ.1) THEN
                   FACNOR=FACNOI
               ELSE
                   FACNOR=FACNOI*(ISOSAC+1.0D0)/(2.D0)
               ENDIF
C
               TKE_TT(INDIMK(IPROAC,LPROAC,KPROAC),IT)=
     *         TKE_TT(INDIMK(IPROAC,LPROAC,KPROAC),IT)*FACNOR
C
               TSK_TT(INDIMK(IPROAC,LPROAC,KPROAC),IT)=
     *         TSK_TT(INDIMK(IPROAC,LPROAC,KPROAC),IT)*FACNOR
               TKI_NT(INDIMK(IPROAC,LPROAC,KPROAC),IT)=
     *         TKI_NT(INDIMK(IPROAC,LPROAC,KPROAC),IT)*FACNOR
               TKI_PT(INDIMK(IPROAC,LPROAC,KPROAC),IT)=
     *         TKI_PT(INDIMK(IPROAC,LPROAC,KPROAC),IT)*FACNOR
C
               TCO_DT(INDIMK(IPROAC,LPROAC,KPROAC),IT)=
     *         TCO_DT(INDIMK(IPROAC,LPROAC,KPROAC),IT)*FACNOR
               TC1_D0(INDIMK(IPROAC,LPROAC,KPROAC),IT)=
     *         TC1_D0(INDIMK(IPROAC,LPROAC,KPROAC),IT)*FACNOR
               TC1_DP(INDIMK(IPROAC,LPROAC,KPROAC),IT)=
     *         TC1_DP(INDIMK(IPROAC,LPROAC,KPROAC),IT)*FACNOR
               TC1_DM(INDIMK(IPROAC,LPROAC,KPROAC),IT)=
     *         TC1_DM(INDIMK(IPROAC,LPROAC,KPROAC),IT)*FACNOR
               TC2_D0(INDIMK(IPROAC,LPROAC,KPROAC),IT)=
     *         TC2_D0(INDIMK(IPROAC,LPROAC,KPROAC),IT)*FACNOR
               TC21DP(INDIMK(IPROAC,LPROAC,KPROAC),IT)=
     *         TC21DP(INDIMK(IPROAC,LPROAC,KPROAC),IT)*FACNOR
               TC21DM(INDIMK(IPROAC,LPROAC,KPROAC),IT)=
     *         TC21DM(INDIMK(IPROAC,LPROAC,KPROAC),IT)*FACNOR
               TC22DP(INDIMK(IPROAC,LPROAC,KPROAC),IT)=
     *         TC22DP(INDIMK(IPROAC,LPROAC,KPROAC),IT)*FACNOR
               TC22DM(INDIMK(IPROAC,LPROAC,KPROAC),IT)=
     *         TC22DM(INDIMK(IPROAC,LPROAC,KPROAC),IT)*FACNOR
C
               TCO_XT(INDIMK(IPROAC,LPROAC,KPROAC),IT)=
     *         TCO_XT(INDIMK(IPROAC,LPROAC,KPROAC),IT)*FACNOR
               TC1_X0(INDIMK(IPROAC,LPROAC,KPROAC),IT)=
     *         TC1_X0(INDIMK(IPROAC,LPROAC,KPROAC),IT)*FACNOR
               TC1_XP(INDIMK(IPROAC,LPROAC,KPROAC),IT)=
     *         TC1_XP(INDIMK(IPROAC,LPROAC,KPROAC),IT)*FACNOR
               TC1_XM(INDIMK(IPROAC,LPROAC,KPROAC),IT)=
     *         TC1_XM(INDIMK(IPROAC,LPROAC,KPROAC),IT)*FACNOR
               TC2_X0(INDIMK(IPROAC,LPROAC,KPROAC),IT)=
     *         TC2_X0(INDIMK(IPROAC,LPROAC,KPROAC),IT)*FACNOR
               TC21XP(INDIMK(IPROAC,LPROAC,KPROAC),IT)=
     *         TC21XP(INDIMK(IPROAC,LPROAC,KPROAC),IT)*FACNOR
               TC21XM(INDIMK(IPROAC,LPROAC,KPROAC),IT)=
     *         TC21XM(INDIMK(IPROAC,LPROAC,KPROAC),IT)*FACNOR
               TC22XP(INDIMK(IPROAC,LPROAC,KPROAC),IT)=
     *         TC22XP(INDIMK(IPROAC,LPROAC,KPROAC),IT)*FACNOR
               TC22XM(INDIMK(IPROAC,LPROAC,KPROAC),IT)=
     *         TC22XM(INDIMK(IPROAC,LPROAC,KPROAC),IT)*FACNOR
C
               TPN_00(INDIMK(IPROAC,LPROAC,KPROAC),IT)=
     *         TPN_00(INDIMK(IPROAC,LPROAC,KPROAC),IT)*FACNOR
               TPN_10(INDIMK(IPROAC,LPROAC,KPROAC),IT)=
     *         TPN_10(INDIMK(IPROAC,LPROAC,KPROAC),IT)*FACNOR
               TPN_1P(INDIMK(IPROAC,LPROAC,KPROAC),IT)=
     *         TPN_1P(INDIMK(IPROAC,LPROAC,KPROAC),IT)*FACNOR
               TPN_1M(INDIMK(IPROAC,LPROAC,KPROAC),IT)=
     *         TPN_1M(INDIMK(IPROAC,LPROAC,KPROAC),IT)*FACNOR
C
               OPROJE(INDIMK(IPROAC,LPROAC,KPROAC),IT)=
     *         TKE_TT(INDIMK(IPROAC,LPROAC,KPROAC),IT)
C
               EPROJE(INDIMK(IPROAC,LPROAC,KPROAC),IT)=
     *         TSK_TT(INDIMK(IPROAC,LPROAC,KPROAC),IT)
     *        +TKI_NT(INDIMK(IPROAC,LPROAC,KPROAC),IT)
     *        +TKI_PT(INDIMK(IPROAC,LPROAC,KPROAC),IT)
     *        +TCO_DT(INDIMK(IPROAC,LPROAC,KPROAC),IT)
     *        +TC1_D0(INDIMK(IPROAC,LPROAC,KPROAC),IT)*E2_10
     *        +TC1_DP(INDIMK(IPROAC,LPROAC,KPROAC),IT)*E211P
     *        +TC1_DM(INDIMK(IPROAC,LPROAC,KPROAC),IT)*E211M
     *        +TC2_D0(INDIMK(IPROAC,LPROAC,KPROAC),IT)*E2_20
     *        +TC21DP(INDIMK(IPROAC,LPROAC,KPROAC),IT)*E221P
     *        +TC21DM(INDIMK(IPROAC,LPROAC,KPROAC),IT)*E221M
     *        +TC22DP(INDIMK(IPROAC,LPROAC,KPROAC),IT)*E222P
     *        +TC22DM(INDIMK(IPROAC,LPROAC,KPROAC),IT)*E222M
     *        +TCO_XT(INDIMK(IPROAC,LPROAC,KPROAC),IT)
     *        +TC1_X0(INDIMK(IPROAC,LPROAC,KPROAC),IT)*E2_10
     *        +TC1_XP(INDIMK(IPROAC,LPROAC,KPROAC),IT)*E211P
     *        +TC1_XM(INDIMK(IPROAC,LPROAC,KPROAC),IT)*E211M
     *        +TC2_X0(INDIMK(IPROAC,LPROAC,KPROAC),IT)*E2_20
     *        +TC21XP(INDIMK(IPROAC,LPROAC,KPROAC),IT)*E221P
     *        +TC21XM(INDIMK(IPROAC,LPROAC,KPROAC),IT)*E221M
     *        +TC22XP(INDIMK(IPROAC,LPROAC,KPROAC),IT)*E222P
     *        +TC22XM(INDIMK(IPROAC,LPROAC,KPROAC),IT)*E222M
C
               IF (NBTKNO.GT.1) GOTO 160
C
               DO LAMBDA=0,NMURED
                  DO MIU=-LAMBDA,LAMBDA
C
                     TMUL_P(IND_LM(LAMBDA,MIU),
     *                              INDIMK(IPROAC,LPROAC,KPROAC))=
     *               TMUL_P(IND_LM(LAMBDA,MIU),
     *                              INDIMK(IPROAC,LPROAC,KPROAC))*FACNOR
                  END DO
               END DO
C
               DO LAMBDA=1,NMARED
                  DO MIU=-LAMBDA,LAMBDA
C
                     TMAG_P(IND_LM(LAMBDA,MIU),
     *                              INDIMK(IPROAC,LPROAC,KPROAC))=
     *               TMAG_P(IND_LM(LAMBDA,MIU),
     *                              INDIMK(IPROAC,LPROAC,KPROAC))*FACNOR
C
                  END DO
               END DO
C
               DO LAMBDA=NSIMIN,NSIRED
                  DO MIU=-LAMBDA,LAMBDA
C
                     TSIF_P(IND_LM(LAMBDA,MIU),
     *                              INDIMK(IPROAC,LPROAC,KPROAC))=
     *               TSIF_P(IND_LM(LAMBDA,MIU),
     *                              INDIMK(IPROAC,LPROAC,KPROAC))*FACNOR
C
                  END DO
               END DO
C
 160           CONTINUE
C
C=======================================================================
C         CALCULATING THE SUM RULES FOR DIAGONAL TERMS LPROAC=KPROAC
C=======================================================================
C
               IF (LPROAC.EQ.KPROAC) THEN
C
C=======================================================================
C                  PRINTING KERNELS AND AVERAGE VALUES
C=======================================================================
C
                   IF (I_HEAD.EQ.0.AND.IENPRI.GT.0) THEN
C
                       WRITE(NFIPRI,'(1H*,77X,1H*,/,
     *                       1H*,1X,'' KERNELS AND AVERAGE VALUES'',
     *                              '' OBTAINED FOR ANGULAR-MOMENTUM'',
     *                              '' PROJECTED STATES'',  2X,1H*,/,
     *                                                 1H*,77X,1H*,/,
     *                                       79(1H*),/,1H*,77X,1H*)')
C
                       IF (IENPRI.EQ.1) THEN
C
                           WRITE(NFIPRI,'(
     *                       1H*,1X,''                             '',
     *                              '' REAL(KERNEL)    IMAG(KERNEL) '',
     *                              '' AVERAGE ENERGY'',     2X,1H*,/,
     *                                                  1H*,77X,1H*)')
                       ELSE
                           WRITE(NFIPRI,'(
     *                       1H*,1X,''                             '',
     *                              '' REAL(KERNEL)    IMAG(KERNEL)  '',
     *                              '' AVERAGE VALUE'',      2X,1H*,/,
     *                                                  1H*,77X,1H*)')
C
                       END IF
C
                       I_HEAD=1
C
                   END IF
C
                   IF (IENPRI.EQ.1.AND.IPROAC.GE.ISLPRI
     *                            .AND.IPROAC.LE.ISUPRI
     *                            .AND.LPROJT.EQ.0)
     *
     *                 WRITE(NFIPRI,'(
     *                   1H*, 1X,'' I,K= '',2(I4,A2),
     *                           ''  NORM = '',F15.12,F16.12,F16.6,
     *                                                         2X,1H*)')
     *
     *                   IPROAC/IEVENI,CHALFI,
     *                   LPROAC/IEVENI,CHALFI,
     *                         TKE_TT(INDIMK(IPROAC,LPROAC,KPROAC),IT),
     *                    REAL(EPROJE(INDIMK(IPROAC,KPROAC,KPROAC),IT))
     *                   /REAL(TKE_TT(INDIMK(IPROAC,KPROAC,KPROAC),IT))
C
                   IF (IENPRI.EQ.1.AND.IPROAC.GE.ISLPRI
     *                            .AND.IPROAC.LE.ISUPRI
     *                            .AND.LPROJT.EQ.1
     *                            .AND.LPROJJ.EQ.1)
     *
     *                 WRITE(NFIPRI,'(
     *                   1H*, 1X,''I,K,T='',3(I3,A2),
     *                           '' NORM= '',F15.12,F16.12,F16.6,
     *                                                         1X,1H*)')
     *
     *                   IPROAC/IEVENI,CHALFI,
     *                   LPROAC/IEVENI,CHALFI,
     *                   ISOSAC/IEVENI,CHALFI,
     *                         TKE_TT(INDIMK(IPROAC,LPROAC,KPROAC),IT),
     *                    REAL(EPROJE(INDIMK(IPROAC,KPROAC,KPROAC),IT))
     *                   /REAL(TKE_TT(INDIMK(IPROAC,KPROAC,KPROAC),IT))
C
                   IF (IENPRI.EQ.1
     *                            .AND.LPROJT.EQ.1
     *                            .AND.LPROJJ.EQ.0)
     *
     *                 WRITE(NFIPRI,'(
     *                   1H*, 3X,''T=    '',I3,A2,5X,
     *                           '' NORM = '',F15.12,F16.12,F16.6,
     *                                                         3X,1H*)')
     *
     *                   ISOSAC/IEVENI,CHALFI,
     *                         TKE_TT(INDIMK(IPROAC,LPROAC,KPROAC),IT),
     *                    REAL(EPROJE(INDIMK(IPROAC,KPROAC,KPROAC),IT))
     *                   /REAL(TKE_TT(INDIMK(IPROAC,KPROAC,KPROAC),IT))
C
                   IF (IENPRI.EQ.2.AND.IPROAC.GE.ISLPRI
     *                            .AND.IPROAC.LE.ISUPRI)
     *
     *                 WRITE(NFIPRI,'(
     *                   1H*, 1X,''T,I,K='',3(I4,A2),
     *                              '' NORM='',F15.12, F15.12,16X,1H*,/,
     *                   1H*,22X,''SKYRME  ='',F15.6 ,2F15.6 , 1X,1H*,/,
     *                   1H*,22X,''EKIN_N  ='',F15.6 ,2F15.6 , 1X,1H*,/,
     *                   1H*,22X,''EKIN_P  ='',F15.6 ,2F15.6 , 1X,1H*,/,
     *                   1H*,22X,''COUD_00 ='',F15.6 ,1F15.6 ,16X,1H*,/,
     *                   1H*,22X,''COUE_00 ='',F15.6 ,1F15.6 ,16X,1H*,/,
     *                   1H*,22X,''COUT_00 ='',F15.6 ,2F15.6 , 1X,1H*,/,
     *                   1H*,22X,''COUD_10 ='',F15.6 ,1F15.6 ,16X,1H*,/,
     *                   1H*,22X,''COUE_10 ='',F15.6 ,1F15.6 ,16X,1H*,/,
     *                   1H*,22X,''COUT_10 ='',F15.6 ,2F15.6 , 1X,1H*,/,
     *                   1H*,22X,''COUD_1-1='',F15.6 ,1F15.6 ,16X,1H*,/,
     *                   1H*,22X,''COUE_1-1='',F15.6 ,1F15.6 ,16X,1H*,/,
     *                   1H*,22X,''COUT_1-1='',F15.6 ,2F15.6 , 1X,1H*,/,
     *                   1H*,22X,''COUD_1+1='',F15.6 ,1F15.6 ,16X,1H*,/,
     *                   1H*,22X,''COUE_1+1='',F15.6 ,1F15.6 ,16X,1H*,/,
     *                   1H*,22X,''COUT_1+1='',F15.6 ,2F15.6 , 1X,1H*,/,
     *                   1H*,22X,''COUD_20 ='',F15.6 ,1F15.6 ,16X,1H*,/,
     *                   1H*,22X,''COUE_20 ='',F15.6 ,1F15.6 ,16X,1H*,/,
     *                   1H*,22X,''COUT_20 ='',F15.6 ,2F15.6 , 1X,1H*,/,
     *                   1H*,22X,''COUD_2-1='',F15.6 ,1F15.6 ,16X,1H*,/,
     *                   1H*,22X,''COUE_2-1='',F15.6 ,1F15.6 ,16X,1H*,/,
     *                   1H*,22X,''COUT_2-1='',F15.6 ,2F15.6 , 1X,1H*,/,
     *                   1H*,22X,''COUD_2+1='',F15.6 ,1F15.6 ,16X,1H*,/,
     *                   1H*,22X,''COUE_2+1='',F15.6 ,1F15.6 ,16X,1H*,/,
     *                   1H*,22X,''COUT_2+1='',F15.6 ,2F15.6 , 1X,1H*,/,
     *                   1H*,22X,''COUD_2-2='',F15.6 ,1F15.6 ,16X,1H*,/,
     *                   1H*,22X,''COUE_2-2='',F15.6 ,1F15.6 ,16X,1H*,/,
     *                   1H*,22X,''COUT_2-2='',F15.6 ,2F15.6 , 1X,1H*,/,
     *                   1H*,22X,''COUD_2+2='',F15.6 ,1F15.6 ,16X,1H*,/,
     *                   1H*,22X,''COUE_2+2='',F15.6 ,1F15.6 ,16X,1H*,/,
     *                   1H*,22X,''COUT_2+2='',F15.6 ,2F15.6 , 1X,1H*,/,
     *                   1H*,22X,''E_TOTAL ='',30X,    F15.6 , 1X,1H*,/,
     *                   1H*,22X,''PNUMB_00='',F15.6 ,2F15.6 , 1X,1H*,/,
     *                   1H*,22X,''PNUMB_10='',F15.6 ,2F15.6 , 1X,1H*,/,
     *                   1H*,22X,''PNUMB_1M='',F15.6 ,2F15.6 , 1X,1H*,/,
     *                   1H*,22X,''PNUMB_1P='',F15.6 ,2F15.6 , 1X,1H*,/,
     *                   1H*,22X,''N-Z     ='',30X,    F15.6 , 1X,1H*,/,
     *                                                    1H*,77X,1H*)')
     *
     *                   ISOSAC/IEVENI,CHALFI,
     *                   IPROAC/IEVENI,CHALFI,
     *                   LPROAC/IEVENI,CHALFI,
     *                       TKE_TT(INDIMK(IPROAC,LPROAC,KPROAC),IT),
     *                       TSK_TT(INDIMK(IPROAC,LPROAC,KPROAC),IT),
     *                  REAL(TSK_TT(INDIMK(IPROAC,LPROAC,KPROAC),IT))
     *                 /REAL(TKE_TT(INDIMK(IPROAC,KPROAC,KPROAC),IT)),
     *                       TKI_NT(INDIMK(IPROAC,LPROAC,KPROAC),IT),
     *                  REAL(TKI_NT(INDIMK(IPROAC,LPROAC,KPROAC),IT))
     *                 /REAL(TKE_TT(INDIMK(IPROAC,KPROAC,KPROAC),IT)),
     *                       TKI_PT(INDIMK(IPROAC,LPROAC,KPROAC),IT),
     *                  REAL(TKI_PT(INDIMK(IPROAC,LPROAC,KPROAC),IT))
     *                 /REAL(TKE_TT(INDIMK(IPROAC,KPROAC,KPROAC),IT)),
     *                       TCO_DT(INDIMK(IPROAC,LPROAC,KPROAC),IT),
     *                       TCO_XT(INDIMK(IPROAC,LPROAC,KPROAC),IT),
     *                       TCO_DT(INDIMK(IPROAC,LPROAC,KPROAC),IT)+
     *                       TCO_XT(INDIMK(IPROAC,LPROAC,KPROAC),IT),
     *                  REAL(TCO_DT(INDIMK(IPROAC,LPROAC,KPROAC),IT)+
     *                       TCO_XT(INDIMK(IPROAC,LPROAC,KPROAC),IT))
     *                 /REAL(TKE_TT(INDIMK(IPROAC,KPROAC,KPROAC),IT)),
     *                       TC1_D0(INDIMK(IPROAC,LPROAC,KPROAC),IT),
     *                       TC1_X0(INDIMK(IPROAC,LPROAC,KPROAC),IT),
     *                       TC1_D0(INDIMK(IPROAC,LPROAC,KPROAC),IT)+
     *                       TC1_X0(INDIMK(IPROAC,LPROAC,KPROAC),IT),
     *            E2_10*REAL(TC1_D0(INDIMK(IPROAC,LPROAC,KPROAC),IT)+
     *                       TC1_X0(INDIMK(IPROAC,LPROAC,KPROAC),IT))
     *                 /REAL(TKE_TT(INDIMK(IPROAC,KPROAC,KPROAC),IT)),
     *                       TC1_DP(INDIMK(IPROAC,LPROAC,KPROAC),IT),
     *                       TC1_XP(INDIMK(IPROAC,LPROAC,KPROAC),IT),
     *                       TC1_DP(INDIMK(IPROAC,LPROAC,KPROAC),IT)+
     *                       TC1_XP(INDIMK(IPROAC,LPROAC,KPROAC),IT),
     *            E211P*REAL(TC1_DP(INDIMK(IPROAC,LPROAC,KPROAC),IT)+
     *                       TC1_XP(INDIMK(IPROAC,LPROAC,KPROAC),IT))
     *                 /REAL(TKE_TT(INDIMK(IPROAC,KPROAC,KPROAC),IT)),
     *                       TC1_DM(INDIMK(IPROAC,LPROAC,KPROAC),IT),
     *                       TC1_XM(INDIMK(IPROAC,LPROAC,KPROAC),IT),
     *                       TC1_DM(INDIMK(IPROAC,LPROAC,KPROAC),IT)+
     *                       TC1_XM(INDIMK(IPROAC,LPROAC,KPROAC),IT),
     *            E211M*REAL(TC1_DM(INDIMK(IPROAC,LPROAC,KPROAC),IT)+
     *                       TC1_XM(INDIMK(IPROAC,LPROAC,KPROAC),IT))
     *                 /REAL(TKE_TT(INDIMK(IPROAC,KPROAC,KPROAC),IT)),
     *                       TC2_D0(INDIMK(IPROAC,LPROAC,KPROAC),IT),
     *                       TC2_X0(INDIMK(IPROAC,LPROAC,KPROAC),IT),
     *                       TC2_D0(INDIMK(IPROAC,LPROAC,KPROAC),IT)+
     *                       TC2_X0(INDIMK(IPROAC,LPROAC,KPROAC),IT),
     *            E2_20*REAL(TC2_D0(INDIMK(IPROAC,LPROAC,KPROAC),IT)+
     *                       TC2_X0(INDIMK(IPROAC,LPROAC,KPROAC),IT))
     *                 /REAL(TKE_TT(INDIMK(IPROAC,KPROAC,KPROAC),IT)),
     *                       TC21DP(INDIMK(IPROAC,LPROAC,KPROAC),IT),
     *                       TC21XP(INDIMK(IPROAC,LPROAC,KPROAC),IT),
     *                       TC21DP(INDIMK(IPROAC,LPROAC,KPROAC),IT)+
     *                       TC21XP(INDIMK(IPROAC,LPROAC,KPROAC),IT),
     *            E221P*REAL(TC21DP(INDIMK(IPROAC,LPROAC,KPROAC),IT)+
     *                       TC21XP(INDIMK(IPROAC,LPROAC,KPROAC),IT))
     *                 /REAL(TKE_TT(INDIMK(IPROAC,KPROAC,KPROAC),IT)),
     *                       TC21DM(INDIMK(IPROAC,LPROAC,KPROAC),IT),
     *                       TC21XM(INDIMK(IPROAC,LPROAC,KPROAC),IT),
     *                       TC21DM(INDIMK(IPROAC,LPROAC,KPROAC),IT)+
     *                       TC21XM(INDIMK(IPROAC,LPROAC,KPROAC),IT),
     *            E221M*REAL(TC21DM(INDIMK(IPROAC,LPROAC,KPROAC),IT)+
     *                       TC21XM(INDIMK(IPROAC,LPROAC,KPROAC),IT))
     *                 /REAL(TKE_TT(INDIMK(IPROAC,KPROAC,KPROAC),IT)),
     *                       TC22DP(INDIMK(IPROAC,LPROAC,KPROAC),IT),
     *                       TC22XP(INDIMK(IPROAC,LPROAC,KPROAC),IT),
     *                       TC22DP(INDIMK(IPROAC,LPROAC,KPROAC),IT)+
     *                       TC22XP(INDIMK(IPROAC,LPROAC,KPROAC),IT),
     *            E222P*REAL(TC22DP(INDIMK(IPROAC,LPROAC,KPROAC),IT)+
     *                       TC22XP(INDIMK(IPROAC,LPROAC,KPROAC),IT))
     *                 /REAL(TKE_TT(INDIMK(IPROAC,KPROAC,KPROAC),IT)),
     *                       TC22DM(INDIMK(IPROAC,LPROAC,KPROAC),IT),
     *                       TC22XM(INDIMK(IPROAC,LPROAC,KPROAC),IT),
     *                       TC22DM(INDIMK(IPROAC,LPROAC,KPROAC),IT)+
     *                       TC22XM(INDIMK(IPROAC,LPROAC,KPROAC),IT),
     *            E222M*REAL(TC22DM(INDIMK(IPROAC,LPROAC,KPROAC),IT)+
     *                       TC22XM(INDIMK(IPROAC,LPROAC,KPROAC),IT))
     *                 /REAL(TKE_TT(INDIMK(IPROAC,KPROAC,KPROAC),IT)),
     *                  REAL(EPROJE(INDIMK(IPROAC,KPROAC,KPROAC),IT))
     *                 /REAL(TKE_TT(INDIMK(IPROAC,KPROAC,KPROAC),IT)),
     *                       TPN_00(INDIMK(IPROAC,LPROAC,KPROAC),IT),
     *                  REAL(TPN_00(INDIMK(IPROAC,LPROAC,KPROAC),IT))
     *                 /REAL(TKE_TT(INDIMK(IPROAC,KPROAC,KPROAC),IT)),
     *                       TPN_10(INDIMK(IPROAC,LPROAC,KPROAC),IT),
     *            E2_10*REAL(TPN_10(INDIMK(IPROAC,LPROAC,KPROAC),IT))
     *                 /REAL(TKE_TT(INDIMK(IPROAC,KPROAC,KPROAC),IT)),
     *                       TPN_1P(INDIMK(IPROAC,LPROAC,KPROAC),IT),
     *            E211P*REAL(TPN_1P(INDIMK(IPROAC,LPROAC,KPROAC),IT))
     *                 /REAL(TKE_TT(INDIMK(IPROAC,KPROAC,KPROAC),IT)),
     *                       TPN_1M(INDIMK(IPROAC,LPROAC,KPROAC),IT),
     *            E211M*REAL(TPN_1M(INDIMK(IPROAC,LPROAC,KPROAC),IT))
     *                 /REAL(TKE_TT(INDIMK(IPROAC,KPROAC,KPROAC),IT)),
     *           (E2_10*REAL(TPN_10(INDIMK(IPROAC,LPROAC,KPROAC),IT))
     *           +E211P*REAL(TPN_1P(INDIMK(IPROAC,LPROAC,KPROAC),IT))
     *           +E211M*REAL(TPN_1M(INDIMK(IPROAC,LPROAC,KPROAC),IT)))
     *                 /REAL(TKE_TT(INDIMK(IPROAC,KPROAC,KPROAC),IT))
C
C=======================================================================
C         CALCULATING THE SUM RULES FOR DIAGONAL TERMS LPROAC=KPROAC
C=======================================================================
C
                   RKER_T=RKER_T+TKE_TT(INDIMK(IPROAC,LPROAC,KPROAC),IT)
C
                   RSKY_T=RSKY_T+TSK_TT(INDIMK(IPROAC,LPROAC,KPROAC),IT)
                   RKIN_T=RKIN_T+TKI_NT(INDIMK(IPROAC,LPROAC,KPROAC),IT)
     *                          +TKI_PT(INDIMK(IPROAC,LPROAC,KPROAC),IT)
C
                   RCOU_D=RCOU_D
     *                   +TCO_DT(INDIMK(IPROAC,LPROAC,KPROAC),IT)
     *                   +TC1_D0(INDIMK(IPROAC,LPROAC,KPROAC),IT)
     *                   +TC2_D0(INDIMK(IPROAC,LPROAC,KPROAC),IT)
C
                   RCOU_X=RCOU_X
     *                   +TCO_XT(INDIMK(IPROAC,LPROAC,KPROAC),IT)
     *                   +TC1_X0(INDIMK(IPROAC,LPROAC,KPROAC),IT)
     *                   +TC2_X0(INDIMK(IPROAC,LPROAC,KPROAC),IT)
C
                   RPARTN=RPARTN
     *                   +TPN_00(INDIMK(IPROAC,LPROAC,KPROAC),IT)
                   RISOSP=RISOSP
     *                   +TPN_10(INDIMK(IPROAC,LPROAC,KPROAC),IT)
C
               IF (NBTKNO.GT.1) GOTO 161
C
                   DO LAMBDA=0,NMURED
                      DO MIU=-LAMBDA,LAMBDA
C
                         RMUL_P(LAMBDA,MIU)=RMUL_P(LAMBDA,MIU)
     *                                     +TMUL_P(IND_LM(LAMBDA,MIU),
     *                                     INDIMK(IPROAC,KPROAC,KPROAC))
C
                      END DO
                   END DO
C
                   DO LAMBDA=1,NMARED
                      DO MIU=-LAMBDA,LAMBDA
C
                         RMAG_P(LAMBDA,MIU)=RMAG_P(LAMBDA,MIU)
     *                                     +TMAG_P(IND_LM(LAMBDA,MIU),
     *                                     INDIMK(IPROAC,KPROAC,KPROAC))
C
                      END DO
                   END DO
C
                   DO LAMBDA=NSIMIN,NSIRED
                      DO MIU=-LAMBDA,LAMBDA
C
                         RSIF_P(LAMBDA,MIU)=RSIF_P(LAMBDA,MIU)
     *                                     +TSIF_P(IND_LM(LAMBDA,MIU),
     *                                     INDIMK(IPROAC,KPROAC,KPROAC))
C
                      END DO
                   END DO
C
 161           CONTINUE
C
               END IF
C
C=======================================================================
C              HERE ENDS THE INTERNAL LOOP OVER THE ISOSPIN
C=======================================================================
C
               END DO
C
               IF (LPROJJ.EQ.0) THEN
C
C=======================================================================
C                 REDIAGONALIZATION OF THE COULOMB FIELD
C                    IN A RUN WITHOUT SPIN PROJECTION
C=======================================================================
C
               IT=0
               DO ISOSAC=ISOSMI,ISOSMA,2
               IT=IT+1
               IF (ABS(OPROJE(INDIMK(IPROAC,LPROAC,KPROAC),IT))
     *                                             .GT.EPSISO) THEN
               ITTDIM=ISOSAC
               ENDIF
               ENDDO
C
               ITTD=(ITTDIM-ISOSMI)/2+1
               IF (IENPRI.EQ.3)
     *         WRITE(*,233) EPSISO,ITTD
 233           FORMAT(1H*,77X,1H*,/,1H*,
     *                6X,'CUT-OFF "EPSISO" =  ',F16.14,
     *                1X,'==> GOOD-T BASIS OF DIM = ',I2,6X,1H*,/,
     *                1H*,77X,1H*)
C
               IBRA=0
               DO ISOBRA=ISOSMI,ITTDIM,2
               IBRA=IBRA+1
               IKET=0
               DO ISOKET=ISOSMI,ITTDIM,2
               IKET=IKET+1
C
               E_10=CGCOEF(ISOKET,ISOSTZ  ,2, 0,ISOBRA,ISOSTZ)
               E11P=CGCOEF(ISOKET,ISOSTZ-2,2, 2,ISOBRA,ISOSTZ)
               E11M=CGCOEF(ISOKET,ISOSTZ+2,2,-2,ISOBRA,ISOSTZ)
               E_20=CGCOEF(ISOKET,ISOSTZ  ,4, 0,ISOBRA,ISOSTZ)
               E21P=CGCOEF(ISOKET,ISOSTZ-2,4, 2,ISOBRA,ISOSTZ)
               E21M=CGCOEF(ISOKET,ISOSTZ+2,4,-2,ISOBRA,ISOSTZ)
               E22P=CGCOEF(ISOKET,ISOSTZ-4,4, 4,ISOBRA,ISOSTZ)
               E22M=CGCOEF(ISOKET,ISOSTZ+4,4,-4,ISOBRA,ISOSTZ)
C
               E211P=E_10*E11P
               E211M=E_10*E11M
C
               E221P=E_20*E21P
               E221M=E_20*E21M
               E222P=E_20*E22P
               E222M=E_20*E22M
C
               E2_10=E_10*E_10
               E2_20=E_20*E_20
C
               IF (IBRA.EQ.IKET) THEN
               HAMMAT(IBRA,IKET)=
     *                  EPROJE(INDIMK(IPROAC,LPROAC,KPROAC),IBRA)
     *            /REAL(OPROJE(INDIMK(IPROAC,LPROAC,KPROAC),IBRA))
C
               IF (IENPRI.EQ.3)
     *         WRITE(*,234) ISOBRA/IEVENI,CHALFI,ISOKET/IEVENI,CHALFI,
     *              HAMMAT(IBRA,IKET),
     *         REAL(OPROJE(INDIMK(IPROAC,LPROAC,KPROAC),IBRA)),
     *              EPROJE(INDIMK(IPROAC,LPROAC,KPROAC),IBRA)
C
               ENDIF
C
               IF (IBRA.NE.IKET) THEN
               HAMMAT(IBRA,IKET)=
     *             (E2_10*(TC1_D0(INDIMK(IPROAC,LPROAC,KPROAC),IKET)+
     *                     TC1_X0(INDIMK(IPROAC,LPROAC,KPROAC),IKET))
     *             +E211P*(TC1_DP(INDIMK(IPROAC,LPROAC,KPROAC),IKET)+
     *                     TC1_XP(INDIMK(IPROAC,LPROAC,KPROAC),IKET))
     *             +E211M*(TC1_DM(INDIMK(IPROAC,LPROAC,KPROAC),IKET)+
     *                     TC1_XM(INDIMK(IPROAC,LPROAC,KPROAC),IKET))
     *             +E2_20*(TC2_D0(INDIMK(IPROAC,LPROAC,KPROAC),IKET)+
     *                     TC2_X0(INDIMK(IPROAC,LPROAC,KPROAC),IKET))
     *             +E221P*(TC21DP(INDIMK(IPROAC,LPROAC,KPROAC),IKET)+
     *                     TC21XP(INDIMK(IPROAC,LPROAC,KPROAC),IKET))
     *             +E221M*(TC21DM(INDIMK(IPROAC,LPROAC,KPROAC),IKET)+
     *                     TC21XM(INDIMK(IPROAC,LPROAC,KPROAC),IKET))
     *             +E222P*(TC22DP(INDIMK(IPROAC,LPROAC,KPROAC),IKET)+
     *                     TC22XP(INDIMK(IPROAC,LPROAC,KPROAC),IKET))
     *             +E222M*(TC22DM(INDIMK(IPROAC,LPROAC,KPROAC),IKET)+
     *                     TC22XM(INDIMK(IPROAC,LPROAC,KPROAC),IKET)))
     *           /SQRT(REAL(OPROJE(INDIMK(IPROAC,LPROAC,KPROAC),IBRA)))
     *           /SQRT(REAL(OPROJE(INDIMK(IPROAC,LPROAC,KPROAC),IKET)))
C
             IF (IENPRI.EQ.3)
     *       WRITE(*,234) ISOBRA/IEVENI,CHALFI,ISOKET/IEVENI,CHALFI,
     *                 HAMMAT(IBRA,IKET),
     *       SQRT(REAL(OPROJE(INDIMK(IPROAC,LPROAC,KPROAC),IBRA)))
     *      *SQRT(REAL(OPROJE(INDIMK(IPROAC,LPROAC,KPROAC),IKET))),
     *           E2_10*(TC1_D0(INDIMK(IPROAC,LPROAC,KPROAC),IKET)+
     *                  TC1_X0(INDIMK(IPROAC,LPROAC,KPROAC),IKET))
     *          +E211P*(TC1_DP(INDIMK(IPROAC,LPROAC,KPROAC),IKET)+
     *                  TC1_XP(INDIMK(IPROAC,LPROAC,KPROAC),IKET))
     *          +E211M*(TC1_DM(INDIMK(IPROAC,LPROAC,KPROAC),IKET)+
     *                  TC1_XM(INDIMK(IPROAC,LPROAC,KPROAC),IKET))
     *          +E2_20*(TC2_D0(INDIMK(IPROAC,LPROAC,KPROAC),IKET)+
     *                  TC2_X0(INDIMK(IPROAC,LPROAC,KPROAC),IKET))
     *          +E221P*(TC21DP(INDIMK(IPROAC,LPROAC,KPROAC),IKET)+
     *                  TC21XP(INDIMK(IPROAC,LPROAC,KPROAC),IKET))
     *          +E221M*(TC21DM(INDIMK(IPROAC,LPROAC,KPROAC),IKET)+
     *                  TC21XM(INDIMK(IPROAC,LPROAC,KPROAC),IKET))
     *          +E222P*(TC22DP(INDIMK(IPROAC,LPROAC,KPROAC),IKET)+
     *                  TC22XP(INDIMK(IPROAC,LPROAC,KPROAC),IKET))
     *          +E222M*(TC22DM(INDIMK(IPROAC,LPROAC,KPROAC),IKET)+
     *                  TC22XM(INDIMK(IPROAC,LPROAC,KPROAC),IKET))
 234       FORMAT(1H*,1X,2(I4,A2),(F12.6,F10.6),3X,F12.10,
     *           3X,(F12.6,F10.6),2X,1H*)
               ENDIF
C
               IF (IBRA.GE.IKET) THEN
C
               NCOUNT=IBRA+((2*ITTD-IKET)*(IKET-1))/2
C
               CELMTS(NCOUNT)=HAMMAT(IBRA,IKET)
C
               END IF
C
               ENDDO
               ENDDO
C
               CALL DIAMAT(CELMTS,HAMEIG,HAMWAV,ITTD,NDPROT,ITTD)
C
               IF (IENPRI.EQ.3) THEN
               WRITE(*,665)
 665           FORMAT(1H*,77X,1H*)
               DO II=1,ITTD
               WRITE(*,666) II, HAMEIG(II)
 666           FORMAT(1H*,2X,I2,'  EIGENENERGY IS:',F16.6,40X,1H*)
               WRITE(*,667)(  ABS(HAMWAV(JJ,II))**2,JJ=1,
     *                       MIN(5,ITTD))
               WRITE(*,667)( REAL(HAMWAV(JJ,II))   ,JJ=1,
     *                       MIN(5,ITTD))
               WRITE(*,667)(AIMAG(HAMWAV(JJ,II))   ,JJ=1,
     *                       MIN(5,ITTD))
 667           FORMAT(1H*,5(4X,F10.6))
               ENDDO
               WRITE(*,665)
               ENDIF
C
               ENDIF
C
C=======================================================================
C                HERE END THE LOOPS OVER THE PROJECTIONS
C=======================================================================
C
            END DO
         END DO
C
         IF (LPROJJ.NE.0)
     *   WRITE(*,991) IPROAC/IEVENI,CHALFI,RKER_T,RSKY_T,RKIN_T,
     *                RCOU_D+RCOU_X,RPARTN,RISOSP
C
 991  FORMAT(
     *    1H*,77X,1H*,/,1H*,77('-'),1H*,/,
     *    1H*,1X,'PARTIAL SUM RULES FOR I<=',I3,A2,46X,1H*,/,
     *    1H*,1X,'FOR OVERLAP          ',6X,2F16.12,17X,1H*,/,
     *    1H*,1X,'FOR SKYRME ENERGY    ',6X,2F16.6,17X,1H*,/,
     *    1H*,1X,'FOR KINETIC ENERGY   ',6X,2F16.6,17X,1H*,/,
     *    1H*,1X,'FOR COULOMB ENERGY   ',6X,2F16.6,17X,1H*,/,
     *    1H*,1X,'FOR PARTICLE NUMBER  ',6X,2F16.6,17X,1H*,/,
     *    1H*,1X,'FOR Tz               ',6X,2F16.6,17X,1H*,/,
     *    1H*,77('-'),1H*,/,1H*,77X,1H*)
C
C=======================================================================
C              HERE ENDS THE LOOP OVER THE ANGULAR MOMENTUM
C=======================================================================
C
      END DO
C
      IF (IENPRI.EQ.1) WRITE(NFIPRI,'(1H*,77X,1H*)')
C
C=======================================================================
C         PRINTING THE ENERGY SUM RULES
C=======================================================================
C
      IF (ISRPRI.GE.0)
     *    WRITE(NFIPRI,'(79(1H*),/,1H*,77X,1H*,/,
     *      1H*,1X,'' SUM RULES OBTAINED FOR ANGULAR-MOMENTUM'',
     *             '' PROJECTED STATES VS THE HF VALUES'',2X,1H*,/,
     *                                1H*,77X,1H*,/,
     *                      79(1H*),/,1H*,77X,1H*)')
C
      IF (ISRPRI.GE.0)
     *    WRITE(NFIPRI,'(
     *      1H*,1X,''                           '',
     *             '' REAL(SUM RULE)  IMAG(SUM RULE)  '',
     *             ''      HF VALUE'',      2X,1H*,/,
     *                                 1H*,77X,1H*)')
C
      IF (ISRPRI.GE.0)
     *    WRITE(NFIPRI,'(
     *      1H*,19X,''    NORM='',F15.12, F16.12,18X,1H*,/,
     *      1H*,19X,''  SKYRME='',F15.6 ,2F16.6 , 2X,1H*,/,
     *      1H*,19X,''  EKIN_T='',F15.6 ,2F16.6 , 2X,1H*,/,
     *      1H*,19X,''  COUL_D='',F15.6 ,2F16.6 , 2X,1H*,/,
     *      1H*,19X,''  COUL_E='',F15.6 ,2F16.6 , 2X,1H*,/,
     *      1H*,19X,''  COUL_T='',F15.6 ,2F16.6 , 2X,1H*,/,
     *                                       1H*,77X,1H*)')
     *
     *      RKER_T,RSKY_T,ENESKY,RKIN_T,EKIN_T,
     *             RCOU_D,ECOULD,RCOU_X,ECOULE,
     *             RCOU_D+RCOU_X,ECOULD+ECOULE
C
C=======================================================================
C
                       MAXMIU=LAMBDA
      IF (IAXIAL.EQ.1) MAXMIU=0
C
C=======================================================================
C         PRINTING THE MULTIPOLE-MOMENT SUM RULES
C=======================================================================
C
      IF (NMURED.GT.0.AND.NMUMAX.GT.0.AND.ISRPRI.GE.0) THEN
C
          NAMWRK='MULTIPOLE'
C
          DO LAMBDA=0,MIN(NMURED,NMUMAX)
             DO MIU=-MAXMIU,MAXMIU
C
                NIU=ABS(MIU)
C
                WRITE(NFIPRI,'(
     *                1H*,1X,A9,'' L='',I2,'' M='',I2,
     *                    '' QMUL_P='',F15.6 ,2F16.6 , 2X,1H*)')
     *
     *                NAMWRK,LAMBDA,MIU,
     *                RMUL_P(LAMBDA,MIU),
     *                QMUL_P(LAMBDA,MIU)
C
                NAMWRK='         '
C
             END DO
          END DO
C
          WRITE(NFIPRI,'(1H*,77X,1H*)')
C
      END IF
C
C=======================================================================
C         PRINTING THE MAGNETIC-MOMENT SUM RULES
C=======================================================================
C
      IF (NMARED.GT.0.AND.NMAMAX.GT.0.AND.ISRPRI.GE.0) THEN
C
          NAMWRK='MAGNETIC '
C
          DO LAMBDA=1,MIN(NMARED,NMAMAX)
             DO MIU=-MAXMIU,MAXMIU
C
                NIU=ABS(MIU)
C
                WRITE(NFIPRI,'(
     *                1H*,1X,A9,'' L='',I2,'' M='',I2,
     *                    '' AMUL_P='',F15.6 ,2F16.6 , 2X,1H*)')
     *
     *                NAMWRK,LAMBDA,MIU,
     *                RMAG_P(LAMBDA,MIU),
     *                AMUL_P(LAMBDA,MIU)
C
                NAMWRK='         '
C
             END DO
          END DO
C
          WRITE(NFIPRI,'(1H*,77X,1H*)')
C
      END IF
C
C=======================================================================
C         PRINTING THE SURFACE OR SCHIFF MOMENT SUM RULES
C=======================================================================
C
      IF (NSIRED.GT.0.AND.NSIMAX.GT.0.AND.ISRPRI.GE.0) THEN
C
                           NAMWRK='SURFACE  '
          IF (ISCHIF.EQ.1) NAMWRK='SCHIFF   '
C
          DO LAMBDA=NSIMIN,MIN(NSIRED,NSIMAX)
             DO MIU=-MAXMIU,MAXMIU
C
                NIU=ABS(MIU)
C
                WRITE(NFIPRI,'(
     *                1H*,1X,A9,'' L='',I2,'' M='',I2,
     *                    '' SMUL_P='',F15.6 ,2F16.6 , 2X,1H*)')
     *
     *                NAMWRK,LAMBDA,MIU,
     *                RSIF_P(LAMBDA,MIU),
     *                SMUL_P(LAMBDA,MIU)
C
                NAMWRK='         '
C
             END DO
          END DO
C
          WRITE(NFIPRI,'(1H*,77X,1H*)')
C
      END IF
C
      IF (ISRPRI.GE.0) WRITE(NFIPRI,'(79(1H*))')
C
   10 CONTINUE
C
C=======================================================================
C        HERE WE BEGIN CALCULATION OF THE REDUCED KERNELS OF
C        THE MULTIPOLE (IN "REDQ_P"), MAGNETIC (IN "REDM_P")
C        AND SURFACE OR SCHIFF (IN "REDS_P") MOMENTS
C=======================================================================
C
C=======================================================================
C        ZEROING THE ARRAY  "INDRED" CONTAINING THE INDICES OF ARRAYS
C        "REDQ_P", "REDM_P", AND "REDS_P"
C=======================================================================
C
      DO NPRLEF=1,NDPROK
         DO LAMBDA=0,NMURED
            DO NPRRIG=1,NDPROK
C
               INDRED(NPRLEF,LAMBDA,NPRRIG)=0
C
            END DO
         END DO
      END DO
C
C=======================================================================
C        INITIALIZING THE ARRAYS "REDQ_P", "REDM_P", AND "REDS_P"
C=======================================================================
C
      NUREDU=0
C
      REDQ_P(NUREDU)=C_ZERO
      REDM_P(NUREDU)=C_ZERO
      REDS_P(NUREDU)=C_ZERO
C
C=======================================================================
C         THIS JUMP SUSPENDS CALCULATION OF RESULTS FOR A PARALLEL RUN
C=======================================================================
C
      IF (IPAKER.EQ.1) GO TO 11
C
C=======================================================================
C         CALCULATING THE REDUCED  K E R N E L S  OF MULTIPOLE OPERATORS
C=======================================================================
C         ATTENTION!
C         WE CALCULATE THE REDUCED  K E R N E L S  OF COMPLEX-CONJUGATED
C         MULTIPOLE AND MAGNETIC MOMENTS, WHICH ARE  TRUE  CONTRAVARIANT
C         SPHERICAL TENSORS. THIS IS SO BECAUSE ALL MOMENTS USED IN  THE
C         CODE ARE DEFINED IN TERMS OF THE COMPLEX CONJUGATED  SPHERICAL
C         HARMONICS, SEE COMMENTS IN SUBROUTINES "MOMETS" AND  "MAGMOM".
C         AS A RESULT, BELOW WE HAVE THE PHASE FACTOR (-1)**MIU AND  THE
C         NEGATIVE INDEX "-MIU".
C=======================================================================
C         ATTENTION!
C         THE REDUCED  K E R N E L S  FOR INDICES THAT  DO  NOT  FULFILL
C         THE ANGULAR-MOMENTUM SELECTION RULES ARE PUT INTO THE LOCATION
C         NUREDU=0 OF ARRAYS "REDQ_P", "REDM_P", AND "REDS_P"
C=======================================================================
C         ATTENTION!
C         ONLY THE REDUCED  K E R N E L S  FOR THE "LEFT" (FINAL) SPIN
C         NOT LARGER THAN THE "RIGHT" (INITIAL) SPIN ARE CALCULATED.
C=======================================================================
C
      DO IPRRIG=JPROMI,JPROMA,2
C
         DO KPRRIG=KPRSTA(IPRRIG),KPRSTO(IPRRIG),2
C
            DO LAMBDA=0,NMURED
C
               DO IPRLEF=MAX(JPROMI,IPRRIG-2*LAMBDA),IPRRIG,2
C
                  DO KPRLEF=KPRSTA(IPRLEF),KPRSTO(IPRLEF),2
C
C=======================================================================
C                    CHECKING IF THE LIST OF THE REDUCED KERNELS
C                    IS NOT TOO LONG
C=======================================================================
C
                     IF (NUREDU.LT.NDREDU) THEN
C
                         NUREDU=NUREDU+1
                     ELSE
                         STOP ' INCREASE NDREDU IN PROANG'
C
                     END IF
C
C=======================================================================
C
                     REDQ_P(NUREDU)=C_ZERO
                     REDM_P(NUREDU)=C_ZERO
                     REDS_P(NUREDU)=C_ZERO
C
                     INDRED(IND_IK(IPRLEF,KPRLEF),LAMBDA,
     *                      IND_IK(IPRRIG,KPRRIG))=NUREDU
C
                     DO MIU=-LAMBDA,LAMBDA
C
                        NIU=ABS(MIU)
C
                        MPRRIG=KPRLEF-2*MIU
C
                        IF (ABS(MPRRIG).LE.IPRRIG) THEN
C
                            REDQ_P(NUREDU)=REDQ_P(NUREDU)
     *                           +SQRT(IPRLEF+1.0D0)*(-1)**MIU
     *                           *CGCOEF(IPRRIG,MPRRIG,2*LAMBDA,2*MIU,
     *                                   IPRLEF,KPRLEF)
     *                           *TMUL_P(IND_LM(LAMBDA,-MIU),
     *                                   INDIMK(IPRRIG,MPRRIG,KPRRIG))
     *                           *QUNITS(LAMBDA,0)/QUNITS(LAMBDA,NIU)
C
                            IF (LAMBDA.GT.0.AND.LAMBDA.LE.NMARED)
     *
     *                      REDM_P(NUREDU)=REDM_P(NUREDU)
     *                           +SQRT(IPRLEF+1.0D0)*(-1)**MIU
     *                           *CGCOEF(IPRRIG,MPRRIG,2*LAMBDA,2*MIU,
     *                                   IPRLEF,KPRLEF)
     *                           *TMAG_P(IND_LM(LAMBDA,-MIU),
     *                                   INDIMK(IPRRIG,MPRRIG,KPRRIG))
     *                           *AUNITS(LAMBDA,0)/AUNITS(LAMBDA,NIU)
C
                            IF (LAMBDA.GE.NSIMIN.AND.LAMBDA.LE.NSIRED)
     *
     *                      REDS_P(NUREDU)=REDS_P(NUREDU)
     *                           +SQRT(IPRLEF+1.0D0)*(-1)**MIU
     *                           *CGCOEF(IPRRIG,MPRRIG,2*LAMBDA,2*MIU,
     *                                   IPRLEF,KPRLEF)
     *                           *TSIF_P(IND_LM(LAMBDA,-MIU),
     *                                   INDIMK(IPRRIG,MPRRIG,KPRRIG))
     *                           *SUNITS(LAMBDA,0)/SUNITS(LAMBDA,NIU)
C
                        END IF
C
                     END DO
C
                  END DO
               END DO
C
            END DO
         END DO
      END DO
C
C=======================================================================
C         PRINTING THE REDUCED KERNELS OF MULTIPOLE OPERATORS
C=======================================================================
C
      NAMWRK=NAMMUL
C
      I_HEAD=0
      I_HALF=0
C
      DO LAMBDA=0,NMURED
C
         DO IPRRIG=JPROMI,JPROMA,2
C
            DO KPRRIG=KPRSTA(IPRRIG),KPRSTO(IPRRIG),2
C
               DO IPRLEF=MAX(JPROMI,IPRRIG-2*LAMBDA),IPRRIG,2
C
                  DO KPRLEF=KPRSTA(IPRLEF),KPRSTO(IPRLEF),2
C
                     IF (I_HEAD.EQ.0.AND.IKEPRI.GT.0.AND.
     *                   IPRRIG.GE.ISLPRI.AND.IPRRIG.LE.ISUPRI.AND.
     *                   IPRLEF.GE.ISLPRI.AND.IPRLEF.LE.ISUPRI) THEN
C
                         IF (IEVENI.EQ.1) THEN
C
                     HAFLIN(1)='    IL    KL  L    IR    KR  <||Q||>  '
C
                         ELSE
C
                     HAFLIN(1)='  IL    KL    L  IR    KR    <||Q||>  '
C
                         ENDIF
C
                         WRITE(NFIPRI,'(1H*,77X,1H*,/,
     *                      1H*,1X,'' REDUCED  K E R N E L S  OF  '',
     *                                                 A45,2X,1H*,/,
     *                      1H*,1X,'' ONLY THE RESULTS WITH ABSOLUTE'',
     *                             '' VALUES LARGER THAN'',F6.3,
     *                             '' ARE BELOW PRINTED'', 2X,1H*,/,
     *                                                1H*,77X,1H*,/,
     *                              79(1H*),/,1H*,38X,1H*,38X,1H*,/,
     *                                        1H*,A38,1H*,A38,1H*,/,
     *                                        1H*,38X,1H*,38X,1H*)')
     *                      NAMWRK,QMUCUT,HAFLIN(1),HAFLIN(1)
C
                         I_HEAD=1
C
                     END IF
C
                     NUREDU=INDRED(IND_IK(IPRLEF,KPRLEF),LAMBDA,
     *                             IND_IK(IPRRIG,KPRRIG))
C
                     IF (IKEPRI.GT.0.AND.
     *                   IPRRIG.GE.ISLPRI.AND.IPRRIG.LE.ISUPRI.AND.
     *                   IPRLEF.GE.ISLPRI.AND.IPRLEF.LE.ISUPRI.AND.
     *                   ABS(REAL(REDQ_P(NUREDU))).GT.QMUCUT) THEN
C
                         I_HALF=I_HALF+1
C
                         WRITE(HAFLIN(I_HALF),
     *                         '(2(I4,A2),I3,2(I4,A2),F9.3,2X)')
     *                      IPRLEF/IEVENI,CHALFI,
     *                      KPRLEF/IEVENI,CHALFI,LAMBDA,
     *                      IPRRIG/IEVENI,CHALFI,
     *                      KPRRIG/IEVENI,CHALFI,
     *                      REAL(REDQ_P(NUREDU))
C
                         IF (I_HALF.EQ.2) THEN
C
                             I_HALF=0
C
                             WRITE(NFIPRI,'(1H*,A38,1H*,A38,1H*)')
     *                                                          HAFLIN
C
                         END IF
C
                     END IF
C
                  END DO
               END DO
C
            END DO
         END DO
C
         IF (LAMBDA.EQ.NMURED) THEN
C
             IF (I_HALF.EQ.1) WRITE(NFIPRI,'(1H*,A38,1H*,38X,1H*)')
     *                                                         HAFLIN(1)
C
             IF (IKEPRI.GT.0) WRITE(NFIPRI,'(1H*,77X,1H*,/,79(1H*))')
C
         END IF
C
      END DO
C
C=======================================================================
C         PRINTING THE REDUCED KERNELS OF MAGNETIC OPERATORS
C=======================================================================
C
      NAMWRK=NAMMAG
C
      I_HEAD=0
      I_HALF=0
C
      DO LAMBDA=1,NMARED
C
         DO IPRRIG=JPROMI,JPROMA,2
C
            DO KPRRIG=KPRSTA(IPRRIG),KPRSTO(IPRRIG),2
C
               DO IPRLEF=MAX(JPROMI,IPRRIG-2*LAMBDA),IPRRIG,2
C
                  DO KPRLEF=KPRSTA(IPRLEF),KPRSTO(IPRLEF),2
C
                     IF (I_HEAD.EQ.0.AND.IKEPRI.GT.0.AND.
     *                   IPRRIG.GE.ISLPRI.AND.IPRRIG.LE.ISUPRI.AND.
     *                   IPRLEF.GE.ISLPRI.AND.IPRLEF.LE.ISUPRI) THEN
C
                         IF (IEVENI.EQ.1) THEN
C
                     HAFLIN(1)='    IL    KL  L    IR    KR  <||M||>  '
C
                         ELSE
C
                     HAFLIN(1)='  IL    KL    L  IR    KR    <||M||>  '
C
                         ENDIF
C
                         WRITE(NFIPRI,'(1H*,77X,1H*,/,
     *                      1H*,1X,'' REDUCED  K E R N E L S  OF  '',
     *                                                 A45,2X,1H*,/,
     *                      1H*,1X,'' ONLY THE RESULTS WITH ABSOLUTE'',
     *                             '' VALUES LARGER THAN'',F6.3,
     *                             '' ARE BELOW PRINTED'', 2X,1H*,/,
     *                                                1H*,77X,1H*,/,
     *                              79(1H*),/,1H*,38X,1H*,38X,1H*,/,
     *                                        1H*,A38,1H*,A38,1H*,/,
     *                                        1H*,38X,1H*,38X,1H*)')
     *                      NAMWRK,QMACUT,HAFLIN(1),HAFLIN(1)
C
                         I_HEAD=1
C
                     END IF
C
                     NUREDU=INDRED(IND_IK(IPRLEF,KPRLEF),LAMBDA,
     *                             IND_IK(IPRRIG,KPRRIG))
C
                     IF (IKEPRI.GT.0.AND.
     *                   IPRRIG.GE.ISLPRI.AND.IPRRIG.LE.ISUPRI.AND.
     *                   IPRLEF.GE.ISLPRI.AND.IPRLEF.LE.ISUPRI.AND.
     *                   ABS(REAL(REDM_P(NUREDU))).GT.QMACUT) THEN
C
                         I_HALF=I_HALF+1
C
                         WRITE(HAFLIN(I_HALF),
     *                         '(2(I4,A2),I3,2(I4,A2),F9.3,2X)')
     *                      IPRLEF/IEVENI,CHALFI,
     *                      KPRLEF/IEVENI,CHALFI,LAMBDA,
     *                      IPRRIG/IEVENI,CHALFI,
     *                      KPRRIG/IEVENI,CHALFI,
     *                      REAL(REDM_P(NUREDU))
C
                         IF (I_HALF.EQ.2) THEN
C
                             I_HALF=0
C
                             WRITE(NFIPRI,'(1H*,A38,1H*,A38,1H*)')
     *                                                          HAFLIN
C
                         END IF
C
                     END IF
C
                  END DO
               END DO
C
            END DO
         END DO
C
         IF (LAMBDA.EQ.NMARED) THEN
C
             IF (I_HALF.EQ.1) WRITE(NFIPRI,'(1H*,A38,1H*,38X,1H*)')
     *                                                         HAFLIN(1)
C
             IF (IKEPRI.GT.0) WRITE(NFIPRI,'(1H*,77X,1H*,/,79(1H*))')
C
         END IF
C
      END DO
C
C=======================================================================
C         PRINTING THE REDUCED KERNELS OF SURFACE OR SCHIFF
C         OPERATORS
C=======================================================================
C
                       NAMWRK=NAMSUR
      IF (ISCHIF.EQ.1) NAMWRK=NAMSCH
C
      I_HEAD=0
      I_HALF=0
C
      DO LAMBDA=NSIMIN,NSIRED
C
         DO IPRRIG=JPROMI,JPROMA,2
C
            DO KPRRIG=KPRSTA(IPRRIG),KPRSTO(IPRRIG),2
C
               DO IPRLEF=MAX(JPROMI,IPRRIG-2*LAMBDA),IPRRIG,2
C
                  DO KPRLEF=KPRSTA(IPRLEF),KPRSTO(IPRLEF),2
C
                     IF (I_HEAD.EQ.0.AND.IKEPRI.GT.0.AND.
     *                   IPRRIG.GE.ISLPRI.AND.IPRRIG.LE.ISUPRI.AND.
     *                   IPRLEF.GE.ISLPRI.AND.IPRLEF.LE.ISUPRI) THEN
C
                         IF (IEVENI.EQ.1) THEN
C
                     HAFLIN(1)='    IL    KL  L    IR    KR  <||S||>  '
C
                         ELSE
C
                     HAFLIN(1)='  IL    KL    L  IR    KR    <||S||>  '
C
                         ENDIF
C
                         WRITE(NFIPRI,'(1H*,77X,1H*,/,
     *                      1H*,1X,'' REDUCED  K E R N E L S  OF  '',
     *                                                 A45,2X,1H*,/,
     *                      1H*,1X,'' ONLY THE RESULTS WITH ABSOLUTE'',
     *                             '' VALUES LARGER THAN'',F6.3,
     *                             '' ARE BELOW PRINTED'', 2X,1H*,/,
     *                                                1H*,77X,1H*,/,
     *                              79(1H*),/,1H*,38X,1H*,38X,1H*,/,
     *                                        1H*,A38,1H*,A38,1H*,/,
     *                                        1H*,38X,1H*,38X,1H*)')
     *                      NAMWRK,QSICUT,HAFLIN(1),HAFLIN(1)
C
                         I_HEAD=1
C
                     END IF
C
                     NUREDU=INDRED(IND_IK(IPRLEF,KPRLEF),LAMBDA,
     *                             IND_IK(IPRRIG,KPRRIG))
C
                     IF (IKEPRI.GT.0.AND.
     *                   IPRRIG.GE.ISLPRI.AND.IPRRIG.LE.ISUPRI.AND.
     *                   IPRLEF.GE.ISLPRI.AND.IPRLEF.LE.ISUPRI.AND.
     *                   ABS(REAL(REDS_P(NUREDU))).GT.QSICUT) THEN
C
                         I_HALF=I_HALF+1
C
                         WRITE(HAFLIN(I_HALF),
     *                         '(2(I4,A2),I3,2(I4,A2),F9.3,2X)')
     *                      IPRLEF/IEVENI,CHALFI,
     *                      KPRLEF/IEVENI,CHALFI,LAMBDA,
     *                      IPRRIG/IEVENI,CHALFI,
     *                      KPRRIG/IEVENI,CHALFI,
     *                      REAL(REDS_P(NUREDU))
C
                         IF (I_HALF.EQ.2) THEN
C
                             I_HALF=0
C
                             WRITE(NFIPRI,'(1H*,A38,1H*,A38,1H*)')
     *                                                          HAFLIN
C
                         END IF
C
                     END IF
C
                  END DO
               END DO
C
            END DO
         END DO
C
         IF (LAMBDA.EQ.NSIRED) THEN
C
             IF (I_HALF.EQ.1) WRITE(NFIPRI,'(1H*,A38,1H*,38X,1H*)')
     *                                                         HAFLIN(1)
C
             IF (IKEPRI.GT.0) WRITE(NFIPRI,'(1H*,77X,1H*,/,79(1H*))')
C
         END IF
C
      END DO
C
C=======================================================================
C                    PRINTING THE SUM RULES
C=======================================================================
C
      IF (MOD(IPRKER/10,10).EQ.1) THEN
C
          WRITE(NFIPRI,892) RKER_T,RSKY_T,RKIN_T,RCOU_D,RCOU_X
 892      FORMAT(/,
     *    'ORTHOGONALITY FOR OVERLAP DECOMPOSITION:',2F16.12,/,
     *    'ORTHOGONALITY FOR SKYRME  DECOMPOSITION:',2F16.6,/,
     *    'ORTHOGONALITY FOR EKINET  DECOMPOSITION:',2F16.6,/,
     *    'ORTHOGONALITY FOR COUL_D  DECOMPOSITION:',2F16.6,/,
     *    'ORTHOGONALITY FOR COUL_X  DECOMPOSITION:',2F16.6,/,
     *       2X,'----------------------------------')
C
          DO LAMBDA=0,NMURED
             DO MIU=-LAMBDA,LAMBDA
C
                NIU=ABS(MIU)
C
                WRITE(NFIPRI,'(2I4,2E22.14,2X,2E22.14)') LAMBDA,MIU,
     *                         RMUL_P(LAMBDA,MIU)*QUNITS(LAMBDA,NIU),
     *                         RMAG_P(LAMBDA,MIU)*AUNITS(LAMBDA,NIU)
C
             END DO
          END DO
C
      END IF
C
C=======================================================================
C                     CALCULATING THE K-MIXING
C=======================================================================
C
      IF (LPROJJ.EQ.0) THEN
          CUTOVE=EPSISO
          CUTOVF=0
          WRITE(*,233) EPSISO,ITTD
      ENDIF
      CALL DIAPRO(IPROMI,IPROMA,KPROJE,IAXIAL,IHALFI,
     *            ISOSMI,ISOSMA,ISOSTZ,LPROJJ,LPROJT,
     *                          ICUTOV,CUTOVE,CUTOVF,
     *                          IMIPRI,ISLPRI,ISUPRI,
     *                                        IENPRI)
C
C=======================================================================
C            SAVE WAVE FUNCTION FOR FURTHER CALCULATION OF
C               THE FERMI SUPERALLOWED MATRIX ELEMENT
C=======================================================================
C
      IF (IFERME.EQ.-1) THEN
         IF (ABS(ISOSTZ).NE.2) THEN
            WRITE (*,776) ISOSTZ
 776        FORMAT (2X,' STOP N-Z.NE.+/-2  -  N-Z=',I2)
            STOP
         ENDIF
C
      CALL SAVE_F(NFIWAV,   999,FILWAV,
     *            ISOSMI,ISOSMA,ISOSTZ)
C
      ENDIF
C
C=======================================================================
C         CALCULATING THE REDUCED MATRIX ELEMENTS FOR THE K-MIXED STATES
C=======================================================================
C
      IF (LPROJJ.EQ.1.AND.LPROJT.EQ.0) THEN
      CALL REDPRO(IPROMI,IPROMA,KPROJE,IAXIAL,IHALFI,
     *            ISCHIF,NMURED,NMARED,NSIRED,NSIMIN,
     *                          IRMPRI,ISLPRI,ISUPRI,
     *                          QMUCUT,QMACUT,QSICUT)
      ENDIF
C
C=======================================================================
C
      IF (IFERME.EQ.1) THEN
          CALL FERMME(ISOSTZ,ISOSMI,ISOSMA,
     *                       ISIMPY,MREVER,
     *                       NFIWAV,FILWAV,
     *                NUBKNO,NUAKNO,NBTKNO)
      ENDIF
C
   11 CONTINUE
C
C=======================================================================
      DEALLOCATE (OVRLAP)
      DEALLOCATE (WARAUX)
      DEALLOCATE (TARIGH)
      DEALLOCATE (OVKERN,SKKERN,EKKERN,QPKERN,APKERN)
      DEALLOCATE (CDKERN,CXKERN)
      DEALLOCATE (CDKE10,CDKE1P,CDKE1M)
      DEALLOCATE (CDKE20,CDK21P,CDK21M,CDK22P,CDK22M)
      DEALLOCATE (TMUL_P,TMAG_P,TSIF_P)
      DEALLOCATE (BNN_PP,BNN_PM,BNP_PP,BNP_PM)
      DEALLOCATE (BPP_PP,BPP_PM,BPN_PP,BPN_PM)
      DEALLOCATE (CKER_T,CSKY_T,CKIN_N,CKIN_P,CCOU_D,CC10_D,CC1P_D)
      DEALLOCATE (CC1M_D,CC20_D,CC21PD,CC21MD,CC22PD,CC22MD,CCOU_X)
      DEALLOCATE (CC10_X,CC1P_X,CC1M_X,CC20_X,CC21PX,CC21MX,CC22PX)
      DEALLOCATE (CC22MX,CPNU00,CPNU10,CPNU1P,CPNU1M,CMUL_P,CMAG_P)
      DEALLOCATE (CSIF_P)
C=======================================================================
C
      CALL CPUTIM('PROANG',0)
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE FERMME(ISOTZR,ISOMIR,ISOMAR,
     *                         ISIMPY,MREVER,
     *                         NFIWAV,FILWAV,
     *                  NUBKNO,NUAKNO,NBTKNO)
C
C=======================================================================
      USE SAVLEF
      USE SAVRIG
      USE WAVR_L
C=======================================================================
      USE MAT_PP
      USE MAT_PM
C=======================================================================
      USE hfodd_sizes
C=======================================================================
C
      CHARACTER
     *        FILWAV*68
      COMPLEX
     *        WARAUX,TARIGH,TALEFT,OVRLAP,OVKERN,
     *        PNKE10,PNKE1P,PNKE1M,
     *        CPNU10,CPNU1P,CPNU1M,
     *        ZPNU10,ZPNU1P,ZPNU1M
      COMPLEX
     *        FACINT,FACI10,FACI1M,FACI1P,
     *        TRNN,TRPP,TRNP,TRPN
      COMPLEX
     *        CMIX_L,CMIX_R,FER_ME,FERCON,
     *        FERDIA,FEROFF,
     *        WPRO_L,WPRO_R
      COMPLEX
     *        TPNU10,TPNU1P,TPNU1M,
     *        TPN_10,TPN_1P,TPN_1M
      COMPLEX
     *        AUXDIA,C_ZERO,C_UNIT,UNIT_I
      COMPLEX
     *        DETWRK
C
      COMMON
     *       /RANGLE/ ALPROT,BETROT,GAMROT
      COMMON
     *       /TMX0RA/ WPRO_R(NDPROT),CMIX_R(NDPROT),EIGE_R
      COMMON
     *       /TMX0RB/ NPRO_R(NDPROT),IDIM_R
      COMMON
     *       /TMX0LA/ WPRO_L(NDPROT),CMIX_L(NDPROT),EIGE_L
      COMMON
     *       /TMX0LB/ NPRO_L(NDPROT),IDIM_L
C
      COMMON
     *       /DIMSTA/ LDTOTS(0:NDISOS),LDSTAT(0:NDISOS),
     *                LDUPPE(0:NDISOS),LDTIMU(0:NDISOS)
      COMMON
     *       /DIMENS/ LDBASE
      DIMENSION
     *       LDSTAR(0:NDISOS),LDSTAL(0:NDISOS)
      COMMON
     *       /CFIPRI/ NFIPRI
C=======================================================================
      ALLOCATABLE OVRLAP(:,:)
      ALLOCATABLE WARAUX(:,:)
      ALLOCATABLE OVKERN(:,:,:,:)
      ALLOCATABLE TARIGH(:,:,:)
      ALLOCATABLE TALEFT(:,:,:)
      ALLOCATABLE PNKE10(:,:,:,:)
      ALLOCATABLE PNKE1P(:,:,:,:)
      ALLOCATABLE PNKE1M(:,:,:,:)
C=======================================================================
C
      DIMENSION
     *        CPNU10(NDPROT),CPNU1P(NDPROT),CPNU1M(NDPROT),
     *        TPNU10(NDPROT),TPNU1P(NDPROT),TPNU1M(NDPROT),
     *        TPN_10(NDPROT),TPN_1P(NDPROT),TPN_1M(NDPROT)
      DIMENSION
     *        ZPNU10(NDAKNO,NDPROT),ZPNU1P(NDAKNO,NDPROT),
     *                              ZPNU1M(NDAKNO,NDPROT)
C
      DIMENSION
     *        AUXDIA(1:4*NDSTAT),IAUXDI(1:4*NDSTAT)
      DIMENSION
     *        DETWRK(2)
      COMMON /KNOTS/
     *        XA_PNT(1:NDAKNO),XA_WGT(1:NDAKNO),
     *        XB_PNT(1:NDBKNO),XB_WGT(1:NDBKNO),
     *        XBT_PN(1:NDBTKN),XBT_WG(1:NDBTKN)
C
C=======================================================================
C                     A L L O C A T I O N S
C=======================================================================
C
      IALLOC=0
C
C=======================================================================
      IF (.NOT.ALLOCATED(WARIGH)) THEN
          ALLOCATE (WARIGH(1:NDBASE,1:4*NDSTAT,0:NDSPIN),STAT=IALLOC)
          IF (IALLOC.NE.0) CALL NOALLO('WARIGH','FERMME')
      END IF
C=======================================================================
      IF (.NOT.ALLOCATED(WALEFT)) THEN
          ALLOCATE (WALEFT(1:NDBASE,1:4*NDSTAT,0:NDSPIN),STAT=IALLOC)
          IF (IALLOC.NE.0) CALL NOALLO('WALEFT','FERMME')
      END IF
C=======================================================================
      ALLOCATE (WARAUX(1:4*NDSTAT,0:NDSPIN),STAT=IALLOC)
      IF (IALLOC.NE.0) CALL NOALLO('WARAUX','FERMME')
C=======================================================================
      ALLOCATE (TARIGH(1:2*NDBASE,1:8*NDSTAT,0:NDSPIN),STAT=IALLOC)
      IF (IALLOC.NE.0) CALL NOALLO('TARIGH','FERMME')
C=======================================================================
      ALLOCATE (TALEFT(1:2*NDBASE,1:8*NDSTAT,0:NDSPIN),STAT=IALLOC)
      IF (IALLOC.NE.0) CALL NOALLO('TALEFT','FERMME')
C=======================================================================
C
C=======================================================================
      ALLOCATE (OVRLAP(1:4*NDSTAT,1:4*NDSTAT),STAT=IALLOC)
      IF (IALLOC.NE.0) CALL NOALLO('OVRLAP','FERMME')
C=======================================================================
      ALLOCATE (OVKERN(1:NDASAV,1:NDBKNO,1:NDASAV,0:NDBTKN),STAT=IALLOC)
      IF (IALLOC.NE.0) CALL NOALLO('OVKERN','FERMME')
C=======================================================================
      ALLOCATE (PNKE10(1:NDASAV,1:NDBKNO,1:NDASAV,1:NDBTKN),STAT=IALLOC)
      IF (IALLOC.NE.0) CALL NOALLO('PNKE10','FERMME')
C=======================================================================
      ALLOCATE (PNKE1P(1:NDASAV,1:NDBKNO,1:NDASAV,1:NDBTKN),STAT=IALLOC)
      IF (IALLOC.NE.0) CALL NOALLO('PNKE1P','FERMME')
C=======================================================================
      ALLOCATE (PNKE1M(1:NDASAV,1:NDBKNO,1:NDASAV,1:NDBTKN),STAT=IALLOC)
      IF (IALLOC.NE.0) CALL NOALLO('PNKE1M','FERMME')
C=======================================================================
C
      PI=4.0D0*ATAN(1.0D0)
C
      C_ZERO=CMPLX(0.0D0,0.0D0)
      C_UNIT=CMPLX(1.0D0,0.0D0)
      UNIT_I=CMPLX(0.0D0,1.0D0)
C
      IF (ISOTZR.NE.0) THEN
      STOP 10
      ENDIF
C
      DO ISOS=0,NDISOS
      LDSTAR(ISOS)=LDSTAT(ISOS)
      ENDDO
C
C=======================================================================
C      READING WAVE FUNCTION OF THE DAUGHTER (LEFT STATE) NUCLEUS
C          IN THE CODE IT IS ASSUMED THAT IT HAS Tz=+/-1
C=======================================================================
C
      CALL READ_F(NFIWAV,   999,FILWAV,
     *            ISOMIL,ISOMAL,ISOTZL)
C
      IF (ABS(ISOTZL).NE.2) THEN
      STOP '  STOP: Tz OF THE LEFT STATE IS NOT EQUAL TO +/-1 '
      ENDIF
C
      DO ISOS=0,NDISOS
      LDSTAL(ISOS)=LDSTAT(ISOS)
      ENDDO
C
C=======================================================================
C         CONTROL PRINTOUT AFTER READING DATA FOR THE LEFT STATE
C=======================================================================
C
      WRITE(*,116)
 116  FORMAT(1H*,77X,1H*)
C
      WRITE(*,117)
 117  FORMAT(1H*,32X,'LEFT STATE',20X,'RIGHT STATE',4X,1H*)
      WRITE(*,116)
C
      WRITE(*,118) ISOMIL/2,ISOMAL/2,ISOTZL,
     *             ISOMIR/2,ISOMAR/2,ISOTZR
 118  FORMAT(1H*,2X,'Tmin/Tmax/N-Z',
     *           15X,3I4,19X,3I4,4X,1H*)
      WRITE(*,116)
C
      WRITE(*,119) EIGE_L,EIGE_R
 119  FORMAT(1H*,2X,'       ENERGY',
     *           15X,F12.6,19X,F12.6,4X,1H*)
C
      WRITE(*,116)
C
      ISOACL=ISOMIL/2
      ISOACR=ISOMIR/2
      DO II=1,(ISOMAL-ISOMIL)/2+1
      WRITE(*,120) ISOACL,CMIX_L(II),ISOACR,CMIX_R(II)
      ISOACL=ISOACL+1
      ISOACR=ISOACR+1
      ENDDO
 120  FORMAT(1H*,17X,I3,2F11.6,6X,I3,2F11.6,4X,1H*)
C
      WRITE(*,116)
C
      ISOACL=1
      ISOACR=0
      DO II=1,(ISOMAL-ISOMIL)/2+1
      WRITE(*,120) ISOACL,WPRO_L(II),ISOACR,WPRO_R(II)
      ISOACL=ISOACL+1
      ISOACR=ISOACR+1
      ENDDO
C
      WRITE(*,116)
C
      WRITE(*,121) LDSTAL(0),LDSTAL(1),LDSTAR(0),LDSTAR(1)
 121  FORMAT(1H*,30X,2I6,19X,2I6,4X,1H*)
C
      WRITE(*,116)
C
C=======================================================================
C                 END OF CONTROL PRINTOUT BLOCK
C=======================================================================
C
C=======================================================================
C             HERE BEGIN THE LOOPS OVER THE GAUSS KNOTS.
C=======================================================================
C
      DO I=1,NUAKNO
         DO K=1,NUAKNO
            DO J=1,NUBKNO
C
               ALPROT=XA_PNT(I)
               BETROT=XB_PNT(J)
               GAMROT=XA_PNT(K)
C
               DO L=1,NBTKNO
                 BETISO=XBT_PN(L)
C
                 DO ICHARG=0,NDISOS
C
C=======================================================================
C         FETCHING THE RIGHT WAVE FUNCTIONS FOR THE GIVEN CHARGE
C=======================================================================
C
                  LSTATR=LDSTAR(ICHARG)
C
                  DO ISTATE=1,LSTATR
                     DO IBASE=1,LDBASE
                        DO ISPIN=0,NDSPIN
C
                             WARIGH(IBASE,ISTATE,ISPIN)=
     *                       SARIGH(IBASE,ISTATE,ISPIN,ICHARG)
C
                        END DO
                     END DO
                  END DO
C
                  IF (NUAKNO.GT.1.OR.NUBKNO.GT.1)
     *
     *            CALL ROTWAV(LSTATR,WARIGH)
C
                  DO ISTATE=1,LSTATR
                     DO IBASE=1,LDBASE
                        JBASE=  LDBASE+IBASE
                        DO ISPIN=0,NDSPIN
C
                          IF (ICHARG.EQ.0) THEN
                             TARIGH(IBASE,ISTATE,ISPIN)=
     *                       COS(BETISO/2)*WARIGH(IBASE,ISTATE,ISPIN)
C
                             TARIGH(JBASE,ISTATE,ISPIN)=
     *                       SIN(BETISO/2)*WARIGH(IBASE,ISTATE,ISPIN)
C
                          ELSE
C
                             JSTATE=LDSTAR(0)+ISTATE
                             TARIGH(IBASE,JSTATE,ISPIN)=
     *                      -SIN(BETISO/2)*WARIGH(IBASE,ISTATE,ISPIN)
C
                             TARIGH(JBASE,JSTATE,ISPIN)=
     *                       COS(BETISO/2)*WARIGH(IBASE,ISTATE,ISPIN)
C
                          ENDIF
C
                        END DO
                     END DO
                  END DO
C
C=======================================================================
C         FETCHING THE LEFT WAVE FUNCTIONS FOR THE GIVEN CHARGE
C=======================================================================
C
                  LSTATL=LDSTAL(ICHARG)
C
                  DO ISTATE=1,LSTATL
                     DO IBASE=1,LDBASE
                        DO ISPIN=0,NDSPIN
C
                             WALEFT(IBASE,ISTATE,ISPIN)=
     *                       SALEFT(IBASE,ISTATE,ISPIN,ICHARG)
C
                        END DO
                     END DO
                  END DO
C
                  DO ISTATE=1,LSTATL
                     DO IBASE=1,LDBASE
                        JBASE=  LDBASE+IBASE
                        DO ISPIN=0,NDSPIN
C
                          IF (ICHARG.EQ.0) THEN
                             TALEFT(IBASE,ISTATE,ISPIN)=
     *                       WALEFT(IBASE,ISTATE,ISPIN)
C
                             TALEFT(JBASE,ISTATE,ISPIN)=C_ZERO
C
                          ELSE
C
                             JSTATE=LDSTAL(0)+ISTATE
                             TALEFT(IBASE,JSTATE,ISPIN)=C_ZERO
C
                             TALEFT(JBASE,JSTATE,ISPIN)=
     *                       WALEFT(IBASE,ISTATE,ISPIN)
C
                          ENDIF
C
                        END DO
                     END DO
                  END DO
C=======================================================================
C                    ----> END OF CHARGE LOOP <----
C=======================================================================
                 END DO
C
C=======================================================================
C                     CALCULATING THE OVERLAP MATRIX
C=======================================================================
C
                  LSTAT2=LDSTAR(0)+LDSTAR(1)
                  LBASE2=LDBASE   +LDBASE
C
                  IF (LSTAT2.GT.4*NDSTAT)
     *                STOP ' LSTAT2.GT.4*NDSTAT IN PROANG'
C
                  DO ISTATE=1,LSTAT2
                     DO JSTATE=1,LSTAT2
C
                          OVRLAP(ISTATE,JSTATE)=C_ZERO
C
                     END DO
                  END DO
C
                  DO ISTATE=1,LSTAT2
                     DO JSTATE=1,LSTAT2
                        DO IBASE=1,LBASE2
                           DO ISPIN=0,NDSPIN
C
                              OVRLAP(ISTATE,JSTATE)=
     *                        OVRLAP(ISTATE,JSTATE)
     *                        +CONJG(TALEFT(IBASE,ISTATE,ISPIN))
     *                              *TARIGH(IBASE,JSTATE,ISPIN)
C
                           END DO
                        END DO
                     END DO
                  END DO
C
C=======================================================================
C                     INVERTING THE OVERLAP MATRIX
C=======================================================================
C
                  CALL ZGECO(OVRLAP,4*NDSTAT,LSTAT2,IAUXDI,
     *                                       RICOND,AUXDIA)
                  CALL ZGEDI(OVRLAP,4*NDSTAT,LSTAT2,IAUXDI,
     *                                       DETWRK,AUXDIA,11)
C
                  OVKERN(I,J,K,L)=DETWRK(1)*10.0D0**DETWRK(2)
C
                  IF (ABS(RICOND).LT.1.0D-12) THEN
C
                      WRITE(NFIPRI,*) 'BE CAREFULL - OVERLAP MATRIX ',
     *                                'MAY BE SINGULAR FOR:'
                      WRITE(NFIPRI,*) I,J,K,L,RICOND
C
                  END IF
C
C=======================================================================
C     SUMMING UP RIGHT VECTORS WITH THE INVERSE OF THE OVERLAP MATRIX
C=======================================================================
C
                  DO I_BASE=1,2*LDBASE
C
                     DO ISTATE=1,LSTAT2
C
                        DO ISPIN=0,NDSPIN
C
                           WARAUX(ISTATE,ISPIN)=C_ZERO
C
                           DO KSTATE=1,LSTAT2
C
                              WARAUX(ISTATE,ISPIN)=WARAUX(ISTATE,ISPIN)
     *                                     +TARIGH(I_BASE,KSTATE,ISPIN)
     *                                     *OVRLAP(KSTATE,ISTATE)
                           END DO
C
                        END DO
                     END DO
C
                     DO ISTATE=1,LSTAT2
                        DO ISPIN=0,NDSPIN
C
                           TARIGH(I_BASE,ISTATE,ISPIN)=
     *                            WARAUX(ISTATE,ISPIN)
C
                        END DO
                     END DO
C
                  END DO
C
C=======================================================================
C                      HERE STARTS "KERNEL" BLOCK
C=======================================================================
C
               TRNN=C_ZERO
               TRPP=C_ZERO
               TRNP=C_ZERO
               TRPN=C_ZERO
C
               DO ICHARG=0,NDISOS
                  LSTATE=LDSTAT(ICHARG)
C
C=======================================================================
C          FETCHING THE LEFT WAVE FUNCTIONS FOR THE GIVEN CHARGE
C=======================================================================
C
                  DO ISTATE=1,LSTATE
                     DO IBASE=1,LDBASE
                        DO ISPIN=0,NDSPIN
C
                               WALEFT(IBASE,ISTATE,ISPIN)=
     *                         SALEFT(IBASE,ISTATE,ISPIN,ICHARG)
C
                        END DO
                     END DO
                  END DO
C
                  IF (ICHARG.EQ.0) THEN
C
C=======================================================================
C            FETCHING THE RIGHT WAVE FUNCTIONS TO BE USED TO
C               CALCULATE THE NEUTRON-NEUTRON DENSITY
C=======================================================================
C
                    DO IBASE=1,LDBASE
                       DO ISTATE=1,LSTATE
                          DO ISPIN=0,NDSPIN
C
                               WARIGH(IBASE,ISTATE,ISPIN)=
     *                         TARIGH(IBASE,ISTATE,ISPIN)
C
                          END DO
                       END DO
                    END DO
C
C=======================================================================
C   CALCULATING TRACE OVER THE NEUTRON-NEUTRON TRANSITION DENSITY MATRIX
C=======================================================================
C
                    CALL DENMAC(MREVER,ICHARG,ISIMPY,IPAHFB,
     *                                        WALEFT,WARIGH)
C
                    DO IBRA=1,LDBASE
                       TRNN=TRNN+(BIG_PP(IBRA,IBRA,0)
     *                           +BIG_PP(IBRA,IBRA,1))
                    END DO
C
C=======================================================================
C            FETCHING THE RIGHT WAVE FUNCTIONS TO BE USED TO
C                 CALCULATE THE NEUTRON-PROTON DENSITY
C=======================================================================
C
                    DO IBASE=1,LDBASE
                       JBASE=  LDBASE+IBASE
                       DO ISTATE=1,LSTATE
                          DO ISPIN=0,NDSPIN
C
                               WARIGH(IBASE,ISTATE,ISPIN)=
     *                         TARIGH(JBASE,ISTATE,ISPIN)
C
                          END DO
                       END DO
                    END DO
C
C=======================================================================
C   CALCULATING TRACE OVER THE NEUTRON-PROTON TRANSITION DENSITY MATRIX
C=======================================================================
C
                    CALL DENMAC(MREVER,ICHARG,ISIMPY,IPAHFB,
     *                                        WALEFT,WARIGH)
C
                    DO IBRA=1,LDBASE
                       TRNP=TRNP+(BIG_PP(IBRA,IBRA,0)
     *                           +BIG_PP(IBRA,IBRA,1))
                    END DO
C
                  ELSE
C
C=======================================================================
C             FETCHING THE RIGHT WAVE FUNCTIONS TO BE USED
C               TO CALCULATE THE PROTON-PROTON DENSITIES
C=======================================================================
C
                    DO IBASE=1,LDBASE
                       JBASE=  LDBASE+IBASE
                       DO ISTATE=1,LDSTAT(1)
                          KSTATE=  LDSTAT(0)+ISTATE
                          DO ISPIN=0,NDSPIN
                            WARIGH(IBASE,ISTATE,ISPIN)
     *                     =TARIGH(JBASE,KSTATE,ISPIN)
                          END DO
                       END DO
                    END DO
C
C=======================================================================
C   CALCULATING TRACE OVER THE PROTON-PROTON TRANSITION DENSITY MATRIX
C=======================================================================
C
                    CALL DENMAC(MREVER,ICHARG,ISIMPY,IPAHFB,
     *                                        WALEFT,WARIGH)
C
                    DO IBRA=1,LDBASE
                       TRPP=TRPP+(BIG_PP(IBRA,IBRA,0)
     *                           +BIG_PP(IBRA,IBRA,1))
                    END DO
C
C=======================================================================
C             FETCHING THE RIGHT WAVE FUNCTIONS TO BE USED
C               TO CALCULATE THE PROTON-NEUTRON DENSITIES
C=======================================================================
C
                    DO IBASE=1,LDBASE
                       DO ISTATE=1,LDSTAT(1)
                          KSTATE=  LDSTAT(0)+ISTATE
                          DO ISPIN=0,NDSPIN
                            WARIGH(IBASE,ISTATE,ISPIN)
     *                     =TARIGH(IBASE,KSTATE,ISPIN)
                          END DO
                       END DO
                    END DO
C
C=======================================================================
C   CALCULATING TRACE OVER THE PROTON-NEUTRON TRANSITION DENSITY MATRIX
C=======================================================================
C
                    CALL DENMAC(MREVER,ICHARG,ISIMPY,IPAHFB,
     *                                        WALEFT,WARIGH)
C
                    DO IBRA=1,LDBASE
                       TRPN=TRPN+(BIG_PP(IBRA,IBRA,0)
     *                           +BIG_PP(IBRA,IBRA,1))
                    END DO
C
               END IF
C
               END DO
C
               PNKE10(I,J,K,L)= TRNN-TRPP
               PNKE1M(I,J,K,L)=+SQRT(2.)*TRPN
               PNKE1P(I,J,K,L)=-SQRT(2.)*TRNP
C
CWS        IF(I.EQ.1.AND.J.EQ.1.AND.K.EQ.1) THEN
CWS        WRITE(*,201) I,J,K,L,TRNN,TRPP,TRPN,TRNP
CWS  201   FORMAT(4I2,8F10.5)
CWS        ENDIF
C
C=======================================================================
C            HERE END THE LOOPS OVER THE EULER ANGLES
C=======================================================================
C
               END DO
            END DO
         END DO
      END DO
C
C=======================================================================
C                          KERNELS ARE LOADED
C                   HERE STARTS THE "INTEGRATION" BLOCK
C=======================================================================
C
      IT = 0
      DO ISOSAC=ISOMIR,ISOMAR,2
      IT = IT+1
C
      TPN_10(IT)=C_ZERO
      TPN_1P(IT)=C_ZERO
      TPN_1M(IT)=C_ZERO
C
      END DO
C
C=======================================================================
C
      DO J=1,NUBKNO
        DO I=1,NUAKNO
          DO K=1,NUAKNO
C
            IT = 0
            DO ISOSAC=ISOMIR,ISOMAR,2
            IT = IT+1
C
            TPNU10(IT)=C_ZERO
            TPNU1P(IT)=C_ZERO
            TPNU1M(IT)=C_ZERO
C
               DO L=1,NBTKNO
C
                  FACI10=C_ZERO
                  FACI1M=C_ZERO
                  FACI1P=C_ZERO
C
                  IF (ISOTZL.EQ. 2) THEN
                    IF (ISOSAC.GE.2)
     *              FACI10=DSMALG(ISOSAC, 2, 0, XBT_PN(L))
                    FACI1P=DSMALG(ISOSAC, 0, 0, XBT_PN(L))
                    IF (ISOSAC.GE.4)
     *              FACI1M=DSMALG(ISOSAC, 4, 0, XBT_PN(L))
                  ENDIF
C
                  IF (ISOTZL.EQ.-2) THEN
                    IF (ISOSAC.GE.2)
     *              FACI10=DSMALG(ISOSAC,-2, 0, XBT_PN(L))
                    IF (ISOSAC.GE.4)
     *              FACI1P=DSMALG(ISOSAC,-4, 0, XBT_PN(L))
                    FACI1M=DSMALG(ISOSAC, 0, 0, XBT_PN(L))
                  ENDIF
C
                  FACI10=FACI10*XBT_WG(L)*OVKERN(I,J,K,L)
                  FACI1M=FACI1M*XBT_WG(L)*OVKERN(I,J,K,L)
                  FACI1P=FACI1P*XBT_WG(L)*OVKERN(I,J,K,L)
C
                  TPNU10(IT)=TPNU10(IT)+FACI10*PNKE10(I,J,K,L)
                  TPNU1P(IT)=TPNU1P(IT)+FACI1P*PNKE1P(I,J,K,L)
                  TPNU1M(IT)=TPNU1M(IT)+FACI1M*PNKE1M(I,J,K,L)
C
C=======================================================================
C        HERE END THE LOOPS OVER L (BETISO) GAUSS KNOTS & ISOSPIN
C=======================================================================
C
               END DO
            END DO
C
            IT = 0
            DO ISOSAC=ISOMIR,ISOMAR,2
            IT = IT+1
               PNKE10(I,J,K,IT)=TPNU10(IT)
               PNKE1P(I,J,K,IT)=TPNU1P(IT)
               PNKE1M(I,J,K,IT)=TPNU1M(IT)
            END DO
C
          END DO
        END DO
      END DO
C=======================================================================
C   ----> HERE STARTS INTEGRATION OVER THE ALPHA,BETA,GAMMA ANGLES <----
C=======================================================================
      DO J=1,NUBKNO
C
      IT = 0
      DO ISOSAC=ISOMIR,ISOMAR,2
      IT = IT+1
C
          DO I=1,NUAKNO
C
C=======================================================================
C         ZEROING AUXILIARY ARRAYS OF OVERLAP AND ENERGY KERNELS
C=======================================================================
C
          ZPNU10(I,IT)=C_ZERO
          ZPNU1P(I,IT)=C_ZERO
          ZPNU1M(I,IT)=C_ZERO
C
C=======================================================================
C         BELOW WE INTEGRATE KERNELS OVER THE GAMMA EULER ANGLE AND
C         AT THE SAME TIME WE MULTIPLY THEM BY THE  GAUSS  WEIGHTS
C=======================================================================
C
              DO K=1,NUAKNO
C
              FACINT=XA_WGT(K)
C
                  ZPNU10(I,IT)=ZPNU10(I,IT)
     *                        +FACINT*PNKE10(I,J,K,IT)
                  ZPNU1P(I,IT)=ZPNU1P(I,IT)
     *                        +FACINT*PNKE1P(I,J,K,IT)
                  ZPNU1M(I,IT)=ZPNU1M(I,IT)
     *                        +FACINT*PNKE1M(I,J,K,IT)
C
              END DO
C
C=======================================================================
C          HERE END THE LOOPS  OVER THE  ALPHA (I) GAUSS  KNOTS
C=======================================================================
C
          END DO
C
      CPNU10(IT)=C_ZERO
      CPNU1P(IT)=C_ZERO
      CPNU1M(IT)=C_ZERO
C
C=======================================================================
C         HERE WE INTEGRATE THE KERNELS OVER THE ALPHA EULER ANGLE
C=======================================================================
C
              DO I=1,NUAKNO
C
              FACINT=XA_WGT(I)
C
              CPNU10(IT)=CPNU10(IT)
     *                              +FACINT*ZPNU10(I,IT)
              CPNU1P(IT)=CPNU1P(IT)
     *                              +FACINT*ZPNU1P(I,IT)
              CPNU1M(IT)=CPNU1M(IT)
     *                              +FACINT*ZPNU1M(I,IT)
C
C=======================================================================
C         HERE ENDS THE LOOP OVER THE ALPHA GAUSS KNOTS (I)
C                   AND THE LOOP OVER THE ISOSPIN
C=======================================================================
C
              END DO
       END DO
C
C======================================================================
C               HERE STARTS FINAL INTEGRATION OVER BETA (J)
C=======================================================================
C
              FACINT=XB_WGT(J)*DSMALG(0,0,0,XB_PNT(J))
C
              IT = 0
              DO ISOSAC=ISOMIR,ISOMAR,2
              IT = IT+1
C
              TPN_10(IT)=TPN_10(IT)+FACINT*CPNU10(IT)
              TPN_1P(IT)=TPN_1P(IT)+FACINT*CPNU1P(IT)
              TPN_1M(IT)=TPN_1M(IT)+FACINT*CPNU1M(IT)
C
C=======================================================================
C                  HERE ENDS THE INTERNAL LOOP OVER THE ISOSPIN
C                     AND THE LOOP OVER THE BETA GAUSS KNOTS
C=======================================================================
C
              END DO
      END DO
C
C=======================================================================
C         MULTIPLYING THE INTEGRATED KERNELS BY OVERALL FACTORS
C=======================================================================
C
               IF (NUBKNO.EQ.1) THEN
                   FACNOI=1/( 4.0D0*PI*PI)
               ELSE
                   FACNOI=1/( 8.0D0*PI*PI)
               ENDIF
C
               IT=0
C
               DO ISOSAC=ISOMIR,ISOMAR,2
C
                  IT=IT+1
C
                  IF (NBTKNO.EQ.1) THEN
                      FACNOR=FACNOI
                  ELSE
                      FACNOR=FACNOI*(ISOSAC+1.0D0)/2.D0
                  ENDIF
C
                  TPN_10(IT)=TPN_10(IT)*FACNOR
                  TPN_1P(IT)=TPN_1P(IT)*FACNOR
                  TPN_1M(IT)=TPN_1M(IT)*FACNOR
C
CWS               WRITE(*,77) IT,ISOSAC,TPN_10(IT),TPN_1P(IT),TPN_1M(IT)
CWS   77          FORMAT(1X,2I3,6F10.4)
C
               END DO
C
C=======================================================================
C
C     CALCULATE MATRIX ELEMENT OF THE FERMI SUPER-ALLOWED TRANSITION
C
C=======================================================================
C
         FER_ME=C_ZERO
         FERDIA=C_ZERO
         FEROFF=C_ZERO
C
         ITL=0
         DO ISOACL=ISOMIL,ISOMAL,2
         ITL=ITL+1
C
             ITR=0
             DO ISOACR=ISOMIR,ISOMAR,2
             ITR=ITR+1
C
               IF (ISOTZL.EQ. 2) THEN
               CGALL=CGCOEF(ISOACR, 0, 2, 2,ISOACL, 2)
               CG_10=CGCOEF(ISOACR, 2, 2, 0,ISOACL, 2)
               CG_1P=CGCOEF(ISOACR, 0, 2, 2,ISOACL, 2)
               CG_1M=CGCOEF(ISOACR, 4, 2,-2,ISOACL, 2)
               ENDIF
C
               IF (ISOTZL.EQ.-2) THEN
               CGALL=CGCOEF(ISOACR, 0, 2,-2,ISOACL,-2)
               CG_10=CGCOEF(ISOACR,-2, 2, 0,ISOACL,-2)
               CG_1P=CGCOEF(ISOACR,-4, 2, 2,ISOACL,-2)
               CG_1M=CGCOEF(ISOACR, 0, 2,-2,ISOACL,-2)
               ENDIF
C
               FERCON =
     *                  CONJG(CMIX_L(ITL))*CMIX_R(ITR)*
     *                  CONJG(WPRO_L(ITL))*WPRO_R(ITR)*CGALL*(
     *                                      CG_10*TPN_10(ITR)+
     *                                      CG_1P*TPN_1P(ITR)+
     *                                      CG_1M*TPN_1M(ITR))
C
               FER_ME = FER_ME + FERCON
C
               IF (ISOACL.EQ.ISOACR) FERDIA=FERDIA+FERCON
               IF (ISOACL.NE.ISOACR) FEROFF=FEROFF+FERCON
C
C       WRITE(*,301) ISOACL,ISOACR,FERCON
C 301   FORMAT(2X,2I4,2F16.10)
C
             ENDDO
         ENDDO
C
C=======================================================================
C           FER_ME CALCULATED ABOVE CORRESPONDS TO
C           <I=0, N-Z=+/-2| T_{1+/-1} |I=0, N-Z=0>
C                HENCE, THE FERMI M.E. IS
C      <I=0, N-Z=+/-2| T_{+/-) |I=0, N-Z=0>  =
C                   -/+ <I=0, N-Z=+/-2| T_{1+/-1} |I=0, N-Z=0> / SQRT(2)
C=======================================================================
C
      IF (ISOTZL.EQ. 2) THEN
                        FER_ME=-FER_ME/SQRT(2.0D0)
                        FERDIA=-FERDIA/SQRT(2.0D0)
                        FEROFF=-FEROFF/SQRT(2.0D0)
      ENDIF
      IF (ISOTZL.EQ.-2) THEN
                        FER_ME= FER_ME/SQRT(2.0D0)
                        FERDIA= FERDIA/SQRT(2.0D0)
                        FEROFF= FEROFF/SQRT(2.0D0)
      ENDIF
C
      WRITE(*,116)
      WRITE(*,112) FER_ME, ABS(FER_ME)**2
 112  FORMAT(1H*,3X,'FERMI MATRIX ELEMENT:',2F14.10,
     *              ' |MF|^2=',F14.10,3X,1H*)
CWS      WRITE(*,111) FERDIA, ABS(FERDIA)**2
CWS      WRITE(*,110) FEROFF, ABS(FEROFF)**2
CWS 111  FORMAT(1H*,3X,'    DIAGONAL CONTRIB:',2F14.10,8X,F14.10,3X,1H*)
CWS 110  FORMAT(1H*,3X,'OFF-DIAGONAL CONTRIB:',2F14.10,8X,F14.10,3X,1H*)
      WRITE(*,116)
C
C          see HARDY & TOWNER arXiv:0812.1202  Eq. (6)
C         ---------------------------------------------
      DELTA_C=1-ABS(FER_ME)**2/2
C
      WRITE(*,109) DELTA_C*100
 109  FORMAT(1H*,15X,'THE CALCULATED ISOSPIN MIXING IS =',
     *                                F10.6,'[%]',15X,1H*)
      WRITE(*,116)
C
      WRITE(*,115)
 115  FORMAT(79(1H*))
C
C=======================================================================
      DEALLOCATE (OVRLAP)
      DEALLOCATE (WARAUX)
      DEALLOCATE (TARIGH)
      DEALLOCATE (TALEFT)
      DEALLOCATE (OVKERN,PNKE10,PNKE1P,PNKE1M)
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE DIAPRO(IPROMI,IPROMA,KPROJE,IAXIAL,IHALFI,
     *                  ISOSMI,ISOSMA,ISOSTZ,LPROJJ,LPROJT,
     *                                ICUTOV,CUTOVE,CUTOVF,
     *                                IMIPRI,ISLPRI,ISUPRI,
     *                                              IENPRI)
C=======================================================================
      USE hfodd_sizes
C=======================================================================
C
      CHARACTER
     *          CHALFI*2
      CHARACTER
     *          HAFLIN*38,HAFLIM*38
C
      COMPLEX
     *          EPROJE,OPROJE
      COMPLEX
     *          CELMTS,HAMMAT,OVEWAV,HAMWAV,WAVPRO,
     *          WFI0T1,WPROI0
      COMPLEX
     *          C_ZERO,FPROJE,HAMCUT
C
      COMPLEX
     *          TC1_D0,TC1_DP,TC1_DM,
     *          TC1_X0,TC1_XP,TC1_XM,
     *          TC2_D0,TC21DP,TC21DM,TC22DP,TC22DM,
     *          TC2_X0,TC21XP,TC21XM,TC22XP,TC22XM
C
      COMMON /COUMIX/
     *          TC1_D0(NDPROM,NDPROT),TC1_DP(NDPROM,NDPROT),
     *          TC1_DM(NDPROM,NDPROT),TC2_D0(NDPROM,NDPROT),
     *          TC21DP(NDPROM,NDPROT),TC21DM(NDPROM,NDPROT),
     *          TC22DP(NDPROM,NDPROT),TC22DM(NDPROM,NDPROT),
     *          TC1_X0(NDPROM,NDPROT),TC1_XP(NDPROM,NDPROT),
     *          TC1_XM(NDPROM,NDPROT),TC2_X0(NDPROM,NDPROT),
     *          TC21XP(NDPROM,NDPROT),TC21XM(NDPROM,NDPROT),
     *          TC22XP(NDPROM,NDPROT),TC22XM(NDPROM,NDPROT)
C
      DIMENSION
     *          CELMTS(1:((NDPROD+1)*NDPROD)/2)
      DIMENSION
     *          OVEWAV(1:NDPROD,1:NDPROD),OVEEIG(1:NDPROD),
     *          HAMWAV(1:NDPROD,1:NDPROD),HAMEIG(1:NDPROD)
      DIMENSION
     *          HAMMAT(1:NDPROD,1:NDPROD)
      DIMENSION
     *          AVRG_K(0:NDPROI,1:NDPROD,1:NDPROT),
     *          OVEPRO(0:NDPROI,1:NDPROD,1:NDPROT)
      DIMENSION
     *          LINDIM(2),HAFLIN(1:NDPROD,2)
C
      COMMON
     *       /TMX0RA/ WPROI0(NDPROT),WFI0T1(NDPROT),E_I0T1
      COMMON
     *       /TMX0RB/ NPROI0(NDPROT),I_I0T1
      COMMON
     *       /APROJE/ EPROJE(NDPROM,NDPROT),OPROJE(NDPROM,NDPROT)
      COMMON
     *       /ALLPRO/ WAVPRO(1:NDPROK,1:NDPROD,1:NDPROT),
     *                ENEPRO(0:NDPROI,1:NDPROD,1:NDPROT),
     *                NUMPRO(0:NDPROI,0:NDPROT)
      COMMON
     *       /CFIPRI/ NFIPRI
C
C     IND_LM(LAMDUM,MIUDUM)=LAMDUM**2+LAMDUM+MIUDUM+1
      IND_IK(IPRDUM,KPRDUM)=(IPRDUM**2-IHALFI)/4+(IPRDUM+KPRDUM)/2+1
      INDIMK(IPRDUM,MPRDUM,KPRDUM)=(IPRDUM*(IPRDUM-1)*(IPRDUM+1))/6
     *      +(IPRDUM+1)*((IPRDUM+MPRDUM)/2)+(IPRDUM+KPRDUM)/2+1
C
      CALL CPUTIM('DIAPRO',1)
C
C=======================================================================
C         THIS SUBROUTINE DIAGONALIZES THE HAMILTONIAN MATRIX FOR
C         ANGULAR-MOMENTUM AND ISOSPIN  PROJECTED STATES
C=======================================================================
C         THE SUBROUTINE GIVES THE K-MIXED EIGENVECTORS IN THE  ARRAY
C         "WAVPRO", THEIR EIGEN-ENERGIES IN THE  ARRAY  "ENEPRO"  AND
C         THE NUMBER THEREOF IN THE  ARRAY "NUMPRO". VALUES OF "0" IN
C         NUMPRO  ARRAY MEAN THE ABSENCE OF THE GIVEN SPIN  COMPONENT
C         IN THE HF WAVE FUNCTION; IN THIS CASE "WAVPRO" AND "ENEPRO"
C         ARRAYS ARE NOT DEFINED.
C=======================================================================
C
                       CHALFI='  '
      IF (IHALFI.EQ.1) CHALFI='/2'
C
      IEVENI=2/(IHALFI+1)
C
      C_ZERO=CMPLX(0.0D0,0.0D0)
C
      IF (IAXIAL.EQ.1) THEN
C
          JPROMI=MAX(ABS(KPROJE),IPROMI)
          JPROMA=IPROMA
      ELSE
          JPROMI=IPROMI
          JPROMA=IPROMA
C
      END IF
C
C
C=======================================================================
C            HERE STARTS THE LOOP OVER THE ISOSPIN
C=======================================================================
C
      IT=0
C
      DO ISOSAC=ISOSMI,ISOSMA,2
C
      IT=IT+1
C
C=======================================================================
C         HERE STARTS THE LOOP OVER THE ANGULAR MOMENTA
C=======================================================================
C
      DO IPROAC=JPROMI,JPROMA,2
C
         IPRDIM=IPROAC+1
C
C=======================================================================
C         HERE WE CONSIDER THE CASE OF AN AXIAL NUCLEUS WHEN ONLY ONE
C         VALUE OF THE Z-COMPONENT  OF ANGULAR MOMENTUM  "KPROJE"  IS
C         TAKEN INTO ACCOUNT
C=======================================================================
C
         IF (IAXIAL.EQ.1) THEN
C
C=======================================================================
C           HERE WE TREAT THE SITUATION WHEN THE EIGENVECTOR  CANNOT
C           BE ACCEPTED IN TO THE GCM SPACE, I.E., THE SPIN=IPROAC/2
C           DOES NOT APPEAR IN THE HF WAVE FUNCTION
C=======================================================================
C
            IF (REAL(OPROJE(INDIMK(IPROAC,KPROJE,KPROJE),IT)).LT.CUTOVE)
     *                                                              THEN
C
                 NUMPRO(IPROAC,IT)=0
C
             ELSE
C
C=======================================================================
C           HERE WE TREAT THE SITUATION WHEN THE EIGENVECTOR CAN BE
C           ACCEPTED IN TO THE GCM SPACE
C=======================================================================
C
                 KPRDIM=1
C
                 DO KBRA=1,KPRDIM
                    DO KPROAC=-IPROAC,IPROAC,2
C
                       IF (KPROAC.EQ.KPROJE) THEN
C
                           FPROJE=1.0D0/SQRT(ABS(REAL(OPROJE(
     *                            INDIMK(IPROAC,KPROJE,KPROJE),IT))))
                       ELSE
                           FPROJE=C_ZERO
C
                       END IF
C
                       WAVPRO(IND_IK(IPROAC,KPROAC),KBRA,IT)=FPROJE
C
                    END DO
C
                    ENEPRO(IPROAC,KBRA,IT)=
     *                     REAL(EPROJE(INDIMK(IPROAC,KPROJE,KPROJE),IT))
     *                    /REAL(OPROJE(INDIMK(IPROAC,KPROJE,KPROJE),IT))
C
                 END DO
C
                 NUMPRO(IPROAC,IT)=KPRDIM
C
             END IF
C
         ELSE
C
C=======================================================================
C                     BELOW WE TREAT 3D AMP CASE IAXIAL.EQ.0
C                     --------------------------------------
C           DIAGONALIZATION THE OVERLAP MATRIX FOR A GIVEN SPIN=IPROAC/2
C                                                   AND ISOSPIN=ISOSAC/2
C=======================================================================
C
             DO LPROAC=-IPROAC,IPROAC,2
                DO KPROAC=-IPROAC,IPROAC,2
C
                   IBRA=(LPROAC+IPROAC)/2+1
                   IKET=(KPROAC+IPROAC)/2+1
C
                   HAMMAT(IBRA,IKET)=
     *                           EPROJE(INDIMK(IPROAC,LPROAC,KPROAC),IT)
C
                   IF (IBRA.GE.IKET) THEN
C
                       NCOUNT=IBRA+((2*IPRDIM-IKET)*(IKET-1))/2
C
                       CELMTS(NCOUNT)=
     *                           OPROJE(INDIMK(IPROAC,LPROAC,KPROAC),IT)
C
                   END IF
C
                END DO
             END DO
C
CWS             WRITE(*,122) IPROAC,ISOSAC,IPRDIM,NDPROD
CWS  122        FORMAT(2X,4I5)
C
             CALL DIAMAT(CELMTS,OVEEIG,OVEWAV,IPRDIM,NDPROD,IPRDIM)
C
C=======================================================================
C           DEFINING THE HAMILTONIAN MATRIX FOR A GIVEN SPIN=IPROAC/2
C                                                AND ISOSPIN=ISOSAC/2
C=======================================================================
C
C=======================================================================
C           DEFINING THE OVERLAP CUT-OFF PARAMETER OVEMIN BASED ON THE
C           SMALLEST (NEGATIVE) EIGENVALUE OF THE OVERLAP MATRIX  (SEE
C           THE ANALYSIS BY BURZYNSKI & DOBACZEWSKI, PRC ....
C=======================================================================
C
             OVEMIN=-OVEEIG(1)
C
             IF (ICUTOV.EQ.1) OVEMIN=CUTOVE+CUTOVF*OVEMIN
C
C=======================================================================
C           CUTTING-OFF THE SMALL EIGENVALUES
C=======================================================================
C
             IPRMIN=0
C
             DO IBAS=IPRDIM,1,-1
C
                IF(OVEEIG(IBAS).GT.OVEMIN) IPRMIN=IBAS
C
             END DO
C
C=======================================================================
C           HERE WE TREAT THE SITUATION WHEN NO EIGENVECTORS WERE
C           ACCEPTED IN TO THE GCM SPACE, I.E., SPECIFIC VALUES
C           OF THE SPIN=IPROAC/2 AND ISOSPIN=ISOSAC/2 DO NOT APPEAR
C           IN THE HF WAVE FUNCTION
C=======================================================================
C
             IF (IPRMIN.EQ.0) THEN
C
                 NUMPRO(IPROAC,IT)=0
C
             ELSE
C
C=======================================================================
C           HERE WE TREAT THE SITUATION WHEN SOME EIGENVECTORS WERE
C           ACCEPTED IN TO THE GCM SPACE
C=======================================================================
C
                 KPRDIM=IPRDIM-IPRMIN+1
C
                 DO JBRA=IPRMIN,IPRDIM
                    DO JKET=IPRMIN,IPRDIM
C
                       HAMCUT=C_ZERO
C
                       DO IBRA=1,IPRDIM
                          DO IKET=1,IPRDIM
C
                             HAMCUT=HAMCUT+CONJG(OVEWAV(IBRA,JBRA))
     *                                          *HAMMAT(IBRA,IKET)
     *                                          *OVEWAV(IKET,JKET)
C
                          END DO
                       END DO
C
                       HAMCUT=HAMCUT/SQRT(OVEEIG(JBRA)*OVEEIG(JKET))
C
                       KBRA=JBRA-IPRMIN+1
                       KKET=JKET-IPRMIN+1
C
                       IF (KBRA.GE.KKET) THEN
C
                           NCOUNT=KBRA+((2*KPRDIM-KKET)*(KKET-1))/2
C
                           CELMTS(NCOUNT)=HAMCUT
C
                       END IF
C
                    END DO
                 END DO
C
                 CALL DIAMAT(CELMTS,HAMEIG,HAMWAV,KPRDIM,NDPROD,KPRDIM)
C
C=======================================================================
C           CALCULATING THE WAVE FUNCTIONS
C=======================================================================
C
                 DO KBRA=1,KPRDIM
C
                    AVRG_K(IPROAC,KBRA,IT)=0.0D0
C
                    DO KPROAC=-IPROAC,IPROAC,2
C
                       IKET=(KPROAC+IPROAC)/2+1
C
                       FPROJE=C_ZERO
C
                       DO JBAS=IPRMIN,IPRDIM
                          KBAS=JBAS-IPRMIN+1
C
                          FPROJE=FPROJE+OVEWAV(IKET,JBAS)
     *                                 /SQRT(OVEEIG(JBAS))
     *                                 *HAMWAV(KBAS,KBRA)
C
                       END DO
C
                       AVRG_K(IPROAC,KBRA,IT)=AVRG_K(IPROAC,KBRA,IT)
     *                                    +ABS(FPROJE)**2
C    *                                    +ABS(KPROAC)*ABS(FPROJE)**2/2
C
                       WAVPRO(IND_IK(IPROAC,KPROAC),KBRA,IT)=FPROJE
C
                    END DO
C
                    ENEPRO(IPROAC,KBRA,IT)=HAMEIG(KBRA)
                    OVEPRO(IPROAC,KBRA,IT)=OVEEIG(IPRDIM-KBRA+1)
C
                 END DO
C
                 NUMPRO(IPROAC,IT)=KPRDIM
C
             END IF
C
         END IF
C
C=======================================================================
C       HERE END THE LOOPS OVER THE ANGULAR MOMENTUM AND THE ISOSPIN
C=======================================================================
C
      END DO
      END DO
C
C=======================================================================
C        PRINTING THE RESULTS OF THE K-MIXING FOR DIFFERENT ISOSPIN
C        COMPONENTS:
C=======================================================================
C
      IF (LPROJJ.EQ.0) GOTO 110
C
      WRITE(NFIPRI,'(1H*,77(1H*),1H*)')
C
      IT=0
C
      DO ISOSAC=ISOSMI,ISOSMA,2
C
      IF (IAXIAL.NE.1) THEN
               WRITE(NFIPRI,'(1H*,77X,1H*,/,
     *         1H*,17X,'' RESULTS OF K-MIXING CALCULATION'',
     *                 '' FOR T = '',           I2,A2,15X,1H*,/,
     *                                            1H*,77X,1H*,/,
     *                                        1H*,77(1H-),1H*)')
     *
     *                  ISOSAC/IEVENI,CHALFI
      ENDIF
C
      IT=IT+1
C
      I_HALF=0
      I_HEAD=0
C
      DO KBRA=1,JPROMA+1
C
         HAFLIN(KBRA,1)='                                      '
         HAFLIN(KBRA,2)='                                      '
C
      END DO
C
      DO IPROAC=JPROMI,JPROMA,2
C
         IPRDIM=IPROAC+1
C
         KPRDIM=NUMPRO(IPROAC,IT)
C
         IF (KPRDIM.GT.0.AND.IMIPRI.GT.0.AND.IAXIAL.NE.1.AND.
     *                   IPROAC.GE.ISLPRI.AND.IPROAC.LE.ISUPRI) THEN
C
             I_HALF=I_HALF+1
C
             LINDIM(I_HALF)=KPRDIM
C
             DO KBRA=1,KPRDIM
C
                WRITE(HAFLIN(KBRA,I_HALF),
     *                '(1X,I4,1X,A2,I4,(1PE11.2),0PF13.6,2X)')
     *             IPROAC/IEVENI,CHALFI,KBRA,
     *             OVEPRO(IPROAC,KBRA,IT),
     *             ENEPRO(IPROAC,KBRA,IT)
C
             END DO
C
             IF (I_HALF.EQ.2) THEN
C
                 I_HALF=0
C
                 IF (I_HEAD.EQ.0) THEN
C
                     IF (IEVENI.EQ.1) THEN
C
                         HAFLIM='      I    N    OVERLAP       ENERGY  '
C
                     ELSE
C
                         HAFLIM='    I      N    OVERLAP       ENERGY  '
C
                     ENDIF
C
                     WRITE(NFIPRI,'(1H*,77X,1H*,/,
     *                  1H*,1X,'' RESULTS OF THE K-MIXING CALCULATION'',
     *                         '' FOR THE FOLLOWING OVERLAP'',
     *                         '' CUTOFF DATA'',    2X,1H*,/,
     *                  1H*,1X,'' ICUTOV='',I1,'', CUTOVE='',1PE8.1,
     *                                         '', CUTOVF='',1PE8.1,
     *                                                33X,1H*,/,
     *                                            1H*,77X,1H*,/,
     *                          79(1H*),/,1H*,38X,1H|,38X,1H*,/,
     *                                    1H*,A38,1H|,A38,1H*,/,
     *                                    1H*,38X,1H|,38X,1H*,/,
     *                            1H*,38(1H-),1H|,38(1H-),1H*)')
     *
     *                  ICUTOV,CUTOVE,CUTOVF,HAFLIM,HAFLIM
C
                     I_HEAD=1
C
                 END IF
C
                 DO KBRA=1,MAX(LINDIM(1),LINDIM(2))
C
                    WRITE(NFIPRI,'(1H*,A38,1H|,A38,1H*)')
     *                                     HAFLIN(KBRA,1),HAFLIN(KBRA,2)
C
                 END DO
C
                 WRITE(NFIPRI,'(1H*,38(1H-),1H|,38(1H-),1H*)')
C
                 DO KBRA=1,JPROMA+1
C
                 HAFLIN(KBRA,1)='                                      '
                 HAFLIN(KBRA,2)='                                      '
C
                 END DO
C
             END IF
C
         END IF
C
      END DO
C
      IF (I_HALF.EQ.1) THEN
C
          DO KBRA=1,LINDIM(1)
C
             WRITE(NFIPRI,'(1H*,A38,1H|,38X,1H*)') HAFLIN(KBRA,1)
C
          END DO
C
      END IF
C
      IF (IMIPRI.GT.0.AND.IAXIAL.NE.1) WRITE(NFIPRI,'(79(1H*))')
C
C=======================================================================
C       HERE ENDS THE LOOP OVER THE ISOSPIN IN THE PRINTING BLOCK
C=======================================================================
C
      END DO
C
  110 CONTINUE
C
      IF (LPROJT.EQ.0) GOTO 111
C
C=======================================================================
C          HERE STARTS THE COULOMB REDIAGONALIZATION BLOCK
C=======================================================================
C
      DO IPROAC=JPROMI,JPROMA,2
C
C=======================================================================
C      CALCULATE DIMENSION "IDIM" FOR A GIVEN SPIN VALUE IPROAC
C=======================================================================
C
       IT=0
       II=0
       DO ISOSAC=ISOSMI,ISOSMA,2
        IT=IT+1
        II=II+NUMPRO(IPROAC,IT)
C
           IF (IPROAC.EQ.0) THEN
              NPROI0(IT)=NUMPRO(0,IT)
              IF (NUMPRO(0,IT).EQ.1)
     *            WPROI0(  IT)=WAVPRO(IND_IK(0,0),1,IT)
              IF (NUMPRO(0,IT).EQ.0)
     *            WPROI0(  IT)=C_ZERO
           END IF
C
       END DO
C
       NUMPRO(IPROAC,0)=II
C
       IF (NUMPRO(IPROAC,0).EQ.0) THEN
         WRITE(*,112) IPROAC/IEVENI,CHALFI
 112     FORMAT(1H*,77X,1H*,/,
     *          1H*,11X,'THERE IS NO SPIN I=',I3,A2,
     *             ' COMPONENT IN THE WAVE FUNCTION',11X,1H*,/,
     *          1H*,77X,1H*)
         GOTO 113
       ENDIF
C
C=======================================================================
C     LOAD HAMILTONIAN MATRIX ELEMENTS FOR COULOMB REDIAGONALIZATION
C=======================================================================
C
          IL=0
          ITBRA=0
            DO ISOBRA=ISOSMI,ISOSMA,2
            ITBRA=ITBRA+1
C
            DO II=1,NUMPRO(IPROAC,ITBRA)
            IL=IL+1
C
            IR=0
            ITKET=0
              DO ISOKET=ISOSMI,ISOSMA,2
              ITKET=ITKET+1
C
              DO JJ=1,NUMPRO(IPROAC,ITKET)
              IR=IR+1
C
              HAMMAT(IL,IR)=C_ZERO
C
              E_10=CGCOEF(ISOKET,ISOSTZ  ,2, 0,ISOBRA,ISOSTZ)
              E11P=CGCOEF(ISOKET,ISOSTZ-2,2, 2,ISOBRA,ISOSTZ)
              E11M=CGCOEF(ISOKET,ISOSTZ+2,2,-2,ISOBRA,ISOSTZ)
              E_20=CGCOEF(ISOKET,ISOSTZ  ,4, 0,ISOBRA,ISOSTZ)
              E21P=CGCOEF(ISOKET,ISOSTZ-2,4, 2,ISOBRA,ISOSTZ)
              E21M=CGCOEF(ISOKET,ISOSTZ+2,4,-2,ISOBRA,ISOSTZ)
              E22P=CGCOEF(ISOKET,ISOSTZ-4,4, 4,ISOBRA,ISOSTZ)
              E22M=CGCOEF(ISOKET,ISOSTZ+4,4,-4,ISOBRA,ISOSTZ)
C
              E211P=E_10*E11P
              E211M=E_10*E11M
C
              E221P=E_20*E21P
              E221M=E_20*E21M
              E222P=E_20*E22P
              E222M=E_20*E22M
C
              E2_10=E_10*E_10
              E2_20=E_20*E_20
C
                IF (IL.EQ.IR) THEN
C
                   HAMMAT(IL,IL)=ENEPRO(IPROAC,II,ITBRA)
C
                ELSE
C
                IF (ITKET.NE.ITBRA) THEN
C
                DO LPROAC=-IPROAC,IPROAC,2
                  DO KPROAC=-IPROAC,IPROAC,2
C
                   HAMMAT(IL,IR)=HAMMAT(IL,IR)+
     *             (E2_10*(TC1_D0(INDIMK(IPROAC,LPROAC,KPROAC),ITKET)+
     *                     TC1_X0(INDIMK(IPROAC,LPROAC,KPROAC),ITKET))
     *             +E211P*(TC1_DP(INDIMK(IPROAC,LPROAC,KPROAC),ITKET)+
     *                     TC1_XP(INDIMK(IPROAC,LPROAC,KPROAC),ITKET))
     *             +E211M*(TC1_DM(INDIMK(IPROAC,LPROAC,KPROAC),ITKET)+
     *                     TC1_XM(INDIMK(IPROAC,LPROAC,KPROAC),ITKET))
     *             +E2_20*(TC2_D0(INDIMK(IPROAC,LPROAC,KPROAC),ITKET)+
     *                     TC2_X0(INDIMK(IPROAC,LPROAC,KPROAC),ITKET))
     *             +E221P*(TC21DP(INDIMK(IPROAC,LPROAC,KPROAC),ITKET)+
     *                     TC21XP(INDIMK(IPROAC,LPROAC,KPROAC),ITKET))
     *             +E221M*(TC21DM(INDIMK(IPROAC,LPROAC,KPROAC),ITKET)+
     *                     TC21XM(INDIMK(IPROAC,LPROAC,KPROAC),ITKET))
     *             +E222P*(TC22DP(INDIMK(IPROAC,LPROAC,KPROAC),ITKET)+
     *                     TC22XP(INDIMK(IPROAC,LPROAC,KPROAC),ITKET))
     *             +E222M*(TC22DM(INDIMK(IPROAC,LPROAC,KPROAC),ITKET)+
     *                     TC22XM(INDIMK(IPROAC,LPROAC,KPROAC),ITKET)))
     *                  *CONJG(WAVPRO(IND_IK(IPROAC,LPROAC),II,ITBRA))
     *                  *      WAVPRO(IND_IK(IPROAC,KPROAC),JJ,ITKET)
C
CWS        WRITE(*,789) IL,IR,IPROAC,LPROAC,KPROAC,ISOBRA,II,ISOKET,JJ,
C     *                    (TC1_D0(INDIMK(IPROAC,LPROAC,KPROAC),ITKET)+
C     *                     TC1_X0(INDIMK(IPROAC,LPROAC,KPROAC),ITKET)),
C     *                    (TC1_DP(INDIMK(IPROAC,LPROAC,KPROAC),ITKET)+
C     *                     TC1_XP(INDIMK(IPROAC,LPROAC,KPROAC),ITKET)),
C     *                    (TC1_DM(INDIMK(IPROAC,LPROAC,KPROAC),ITKET)+
C     *                     TC1_XM(INDIMK(IPROAC,LPROAC,KPROAC),ITKET)),
C     *                    (TC2_D0(INDIMK(IPROAC,LPROAC,KPROAC),ITKET)+
C     *                     TC2_X0(INDIMK(IPROAC,LPROAC,KPROAC),ITKET)),
C     *                    (TC21DP(INDIMK(IPROAC,LPROAC,KPROAC),ITKET)+
C     *                     TC21XP(INDIMK(IPROAC,LPROAC,KPROAC),ITKET)),
C     *                    (TC21DM(INDIMK(IPROAC,LPROAC,KPROAC),ITKET)+
C     *                     TC21XM(INDIMK(IPROAC,LPROAC,KPROAC),ITKET)),
C     *                    (TC22DP(INDIMK(IPROAC,LPROAC,KPROAC),ITKET)+
C     *                     TC22XP(INDIMK(IPROAC,LPROAC,KPROAC),ITKET)),
C     *                    (TC22DM(INDIMK(IPROAC,LPROAC,KPROAC),ITKET)+
C     *                     TC22XM(INDIMK(IPROAC,LPROAC,KPROAC),ITKET)),
C     *              E2_10*(TC1_D0(INDIMK(IPROAC,LPROAC,KPROAC),ITKET)+
C     *                     TC1_X0(INDIMK(IPROAC,LPROAC,KPROAC),ITKET)),
C     *              E211P*(TC1_DP(INDIMK(IPROAC,LPROAC,KPROAC),ITKET)+
C     *                     TC1_XP(INDIMK(IPROAC,LPROAC,KPROAC),ITKET)),
C     *              E211M*(TC1_DM(INDIMK(IPROAC,LPROAC,KPROAC),ITKET)+
C     *                     TC1_XM(INDIMK(IPROAC,LPROAC,KPROAC),ITKET)),
C     *              E2_20*(TC2_D0(INDIMK(IPROAC,LPROAC,KPROAC),ITKET)+
C     *                     TC2_X0(INDIMK(IPROAC,LPROAC,KPROAC),ITKET)),
C     *              E221P*(TC21DP(INDIMK(IPROAC,LPROAC,KPROAC),ITKET)+
C     *                     TC21XP(INDIMK(IPROAC,LPROAC,KPROAC),ITKET)),
C     *              E221M*(TC21DM(INDIMK(IPROAC,LPROAC,KPROAC),ITKET)+
C     *                     TC21XM(INDIMK(IPROAC,LPROAC,KPROAC),ITKET)),
C     *              E222P*(TC22DP(INDIMK(IPROAC,LPROAC,KPROAC),ITKET)+
C     *                     TC22XP(INDIMK(IPROAC,LPROAC,KPROAC),ITKET)),
C     *              E222M*(TC22DM(INDIMK(IPROAC,LPROAC,KPROAC),ITKET)+
C     *                     TC22XM(INDIMK(IPROAC,LPROAC,KPROAC),ITKET)),
C     *                         WAVPRO(IND_IK(IPROAC,LPROAC),II,ITBRA),
C     *                         WAVPRO(IND_IK(IPROAC,KPROAC),JJ,ITKET)
C
C 789   FORMAT(2X,2I3,'  I,K,L=',3I3,'  TBRA,II=',2I3,'  TKET,JJ=',2I3,/,
C     *        2X,'1m: ',3(F10.6,F6.3),/,2X,'2m: ',5(F10.6,F6.3),/,
C     *        2X,'1m: ',3(F10.6,F6.3),/,2X,'2m: ',5(F10.6,F6.3),/,
C     *        2X,'WF: ',2(F16.6,1X,F6.3))
CWS
                  END DO
                END DO
C
                END IF
C
                END IF
C
                END DO
                END DO
C
            END DO
            END DO
C
            IF (IENPRI.EQ.2)
     *      WRITE(*,212)
 212        FORMAT(1H*,77X,1H*,/,
     *             1H*,21X,'MATRIX ELEMENTS OF THE HAMILTONIAN',22X,
     *             1H*,/,1H*,77X,1H*)
C
            IDIM= NUMPRO(IPROAC,0)
            DO IL=1,IDIM
              DO IR=1,IL
C
             IF (IENPRI.EQ.2)
     *       WRITE(*,213) IL,IR,HAMMAT(IL,IR),IR,IL,HAMMAT(IR,IL)
 213         FORMAT(1H*,2(2I3,2F16.10),1X,1H*)
C
                NCOUNT=IL+((2*IDIM-IR)*(IR-1))/2
                CELMTS(NCOUNT)=HAMMAT(IL,IR)
C
              END DO
            END DO
C
            CALL DIAMAT(CELMTS,HAMEIG,HAMWAV,IDIM,NDPROD,IDIM)
C
            IF (LPROJJ.EQ.0)
     *      WRITE(*,664)
 664        FORMAT(79(1H*),/,1H*,77X,1H*,/,
     *      1H*,26X,'ISOSPIN-MIXED EIGENSTATES',
     *      26X,1H*,/,1H*,26X,25(1H-),26X,1H*,/,1H*,77X,1H*)
C
            IF (LPROJJ.EQ.1)
     *      WRITE(*,665) IPROAC/IEVENI,CHALFI
 665        FORMAT(79(1H*),/,1H*,77X,1H*,/,
     *      1H*,17X,'ISOSPIN- AND K-MIXED EIGENSTATES FOR I=',I2,A2,
     *      17X,1H*,/,1H*,17X,43(1H-),17X,1H*,/,1H*,77X,1H*)
C
            WRITE(*,666)
 666        FORMAT(1H*,3X,'  N',2X,'     EIGENENERGY',4X,' i',2X,
     *              '  T  ',2X,
     *              '   |C_i|^2',2X,'   Re[C_i]',2X,'   Im[C_i]',4X,
     *              1H*,/,1H*,77X,1H*)
C
            DO MM=1,IDIM
C
            IT=0
            LL=0
            DO ISOSPI=ISOSMI,ISOSMA,2
            IT=IT+1
              DO LI=1,NUMPRO(IPROAC,IT)
                 LL=LL+1
C
              IF (LL.EQ.1)
     *        WRITE(*,667) MM,HAMEIG(MM),LL,ISOSPI/IEVENI,CHALFI,
     *              ABS(HAMWAV(LL,MM))**2, REAL(HAMWAV(LL,MM)),
     *                                    AIMAG(HAMWAV(LL,MM))
 667          FORMAT(1H*,3X,I3,2X,F16.6,4X,I2,2X,I3,A2,3(2X,F10.6),
     *                   4X,1H*)
              IF (LL.GT.1)
     *        WRITE(*,668)                LL,ISOSPI/IEVENI,CHALFI,
     *              ABS(HAMWAV(LL,MM))**2, REAL(HAMWAV(LL,MM)),
     *                                    AIMAG(HAMWAV(LL,MM))
 668          FORMAT(1H*,28X,I2,2X,I3,A2,3(2X,F10.6),4X,1H*)
C
              ENDDO
C
            ENDDO
C
            WAVMAX=0
            COUMIX=1-WAVMAX
C
            IT=0
            NN=0
            DO ISOSAC=ISOSMI,ISOSMA,2
            IT=IT+1
               DO LL=1,NUMPRO(IPROAC,IT)
                  NN=NN+1
                  IF (ABS(HAMWAV(NN,MM))**2.GE.WAVMAX) THEN
                  WAVMAX=ABS(HAMWAV(NN,MM))**2
                  COUMIX=1-WAVMAX
                  ISOMAX=ISOSAC
                  END IF
               END DO
            END DO
C
            COUMAX=0
            IT=0
            NN=0
            DO ISOSAC=ISOSMI,ISOSMA,2
            IT=IT+1
               DO LL=1,NUMPRO(IPROAC,IT)
                  NN=NN+1
                  IF (ISOSAC.EQ.ISOMAX) THEN
                  C_WAVE=ABS(HAMWAV(NN,MM))**2
                  COUMAX=COUMAX+C_WAVE
                  END IF
               END DO
            END DO
C
            COUMIX=1-COUMAX
C
      WRITE(*,669) WAVMAX,ISOMAX/IEVENI,CHALFI,COUMIX,COUMIX*100
 669  FORMAT(1H*,1X,'DOMINANT AMPLITUDE SQUARED EQUALS:',F14.10,
     *              ' AND CORRESPONDS TO T =',I2,A2,1X,1H*,/,
     *       1H*,1X,'COULOMB MIXING IN  THIS  STATE IS:',F14.10,
     *       ' [',F10.6,'%]',14X,1H*,/,1H*,77X,1H*,/,1H*,77X,1H*)
C
            IF (IPROAC.EQ.0.AND.ISOMAX.EQ.2) THEN
              E_I0T1=HAMEIG(MM)
              I_I0T1=(ISOSMA-ISOSMI)/2+1
                KK=0
                IT=0
                DO ISOSAC=ISOSMI,ISOSMA,2
                  IT=IT+1
                  IF (NUMPRO(0,IT).EQ.0)
     *                WFI0T1(  IT)=C_ZERO
                  IF (NUMPRO(0,IT).EQ.1) THEN
                      KK=KK+1
                      WFI0T1(  IT)=HAMWAV(KK,MM)
                  END IF
CWS                  WRITE(*,*) IT,ISOSAC,WFI0T1(  IT)
               END DO
            END IF
C
            END DO
C
 113  CONTINUE
C
C=======================================================================
C               HERE ENDS THE "IPROAC" BLOCK
C=======================================================================
C
      WRITE(*,670)
 670  FORMAT(79(1H*))
C
      END DO
C
 111  CONTINUE
C
C=======================================================================
C
      CALL CPUTIM('DIAPRO',0)
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE REDPRO(IPROMI,IPROMA,KPROJE,IAXIAL,IHALFI,
     *                  ISCHIF,NMURED,NMARED,NSIRED,NSIMIN,
     *                                IRMPRI,ISLPRI,ISUPRI,
     *                                QMUCUT,QMACUT,QSICUT)
C
C=======================================================================
C       >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
C                        !!!  W A R N I N G !!!
C       THIS SUBROUTINE DOES NOT WORK FOR ISOSPIN PROJECTION YET
C             ALL ISOSPIN INDICES ARE TEMPORARLY SET TO 1
C       >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
C
C=======================================================================
      USE REDMOM
      USE REEMOM
C=======================================================================
      USE hfodd_sizes
C=======================================================================
C
      CHARACTER
     *          CHALFI*2
      CHARACTER
     *          NAMMUL*45,NAMSUR*45,NAMSCH*45,NAMMAG*45
      CHARACTER
     *          NAMWRK*45
      CHARACTER
     *          HAFLIN*38
C
C=======================================================================
      COMPLEX
     *          WAVPRO
      COMPLEX
     *          C_ZERO
C
      DIMENSION
     *          HAFLIN(2)
C
C=======================================================================
      COMMON
     *       /ALLPRO/ WAVPRO(1:NDPROK,1:NDPROD,1:NDPROT),
     *                ENEPRO(0:NDPROI,1:NDPROD,1:NDPROT),
     *                NUMPRO(0:NDPROI,0:NDPROT)
      COMMON
     *       /CFIPRI/ NFIPRI
C
      DATA
     *       NAMMUL /'MULTIPOLE MOMENTS [UNITS:  (10 FERMI)^LAMBDA]'/,
     *       NAMSUR /'SURFACE MOMENTS, UNITS: (10 FERMI)^(LAMBDA+2)'/,
     *       NAMSCH /'SCHIFF  MOMENTS, UNITS: (10 FERMI)^(LAMBDA+2)'/,
     *       NAMMAG /'MAGNETIC MOMENTS  [MAGNETON*FERMI^(LAMBDA-1)]'/
C
C=======================================================================
C
      KPRSTA(IPRDUM)=IAXIAL*KPROJE-(1-IAXIAL)*IPRDUM
      KPRSTO(IPRDUM)=IAXIAL*KPROJE+(1-IAXIAL)*IPRDUM
C
C     IND_LM(LAMDUM,MIUDUM)=LAMDUM**2+LAMDUM+MIUDUM+1
      IND_IK(IPRDUM,KPRDUM)=(IPRDUM**2-IHALFI)/4+(IPRDUM+KPRDUM)/2+1
C     INDIMK(IPRDUM,MPRDUM,KPRDUM)=(IPRDUM*(IPRDUM-1)*(IPRDUM+1))/6
C    *      +(IPRDUM+1)*((IPRDUM+MPRDUM)/2)+(IPRDUM+KPRDUM)/2+1
      IND_IN(IPRDUM,KLEDUM)=(IPRDUM**2-IHALFI)/4+KLEDUM
C
C=======================================================================
C
      CALL CPUTIM('REDPRO',1)
C
C=======================================================================
C
      IALLOC=0
C
C=======================================================================
      IF (.NOT.ALLOCATED(REEQ_P)) THEN
          ALLOCATE (REEQ_P(0:NDREDU),STAT=IALLOC)
          IF (IALLOC.NE.0) CALL NOALLO('REEQ_P','REDPRO')
      END IF
C=======================================================================
      IF (.NOT.ALLOCATED(REEM_P)) THEN
          ALLOCATE (REEM_P(0:NDREDU),STAT=IALLOC)
          IF (IALLOC.NE.0) CALL NOALLO('REEM_P','REDPRO')
      END IF
C=======================================================================
      IF (.NOT.ALLOCATED(REES_P)) THEN
          ALLOCATE (REES_P(0:NDREDU),STAT=IALLOC)
          IF (IALLOC.NE.0) CALL NOALLO('REES_P','REDPRO')
      END IF
C=======================================================================
      IF (.NOT.ALLOCATED(INDREE)) THEN
          ALLOCATE (INDREE(NDPROK,0:NDMULR,NDPROK),STAT=IALLOC)
          IF (IALLOC.NE.0) CALL NOALLO('INDREE','REDPRO')
      END IF
C=======================================================================
C
C=======================================================================
C         THIS SUBROUTINE CALCULATES THE REDUCED MATRIX ELEMENTS BETWEEN
C         THE K-MIXED STATES
C=======================================================================
C
                       CHALFI='  '
      IF (IHALFI.EQ.1) CHALFI='/2'
C
      IEVENI=2/(IHALFI+1)
C
      C_ZERO=CMPLX(0.0D0,0.0D0)
C
      IF (IAXIAL.EQ.1) THEN
C
          JPROMI=MAX(ABS(KPROJE),IPROMI)
          JPROMA=IPROMA
      ELSE
          JPROMI=IPROMI
          JPROMA=IPROMA
C
      END IF
C
C=======================================================================
C
      NUREEU=0
C
      REEQ_P(NUREEU)=C_ZERO
      REEM_P(NUREEU)=C_ZERO
      REES_P(NUREEU)=C_ZERO
C
C=======================================================================
C
      DO IPRRIG=JPROMI,JPROMA,2
C
         DO KRIG=1,NUMPRO(IPRRIG,1)
C
            DO LAMBDA=0,NMURED
C
               DO IPRLEF=MAX(JPROMI,IPRRIG-2*LAMBDA),IPRRIG,2
C
                  DO KLEF=1,NUMPRO(IPRLEF,1)
C
C=======================================================================
C                    CHECKING IF THE LIST OF THE REDUCED MATRIX ELEMENTS
C                    IS NOT TOO LONG
C=======================================================================
C
                     IF (NUREEU.LT.NDREDU) THEN
C
                         NUREEU=NUREEU+1
                     ELSE
                         STOP ' INCREASE NDREDU IN REDPRO'
C
                     END IF
C
C=======================================================================
C
                     REEQ_P(NUREEU)=C_ZERO
                     REEM_P(NUREEU)=C_ZERO
                     REES_P(NUREEU)=C_ZERO
C
                     INDREE(IND_IN(IPRLEF,KLEF),LAMBDA,
     *                      IND_IN(IPRRIG,KRIG))=NUREEU
C
                     DO KPRRIG=KPRSTA(IPRRIG),KPRSTO(IPRRIG),2
                        DO KPRLEF=KPRSTA(IPRLEF),KPRSTO(IPRLEF),2
C
                           NUREDU=INDRED(IND_IK(IPRLEF,KPRLEF),LAMBDA,
     *                                   IND_IK(IPRRIG,KPRRIG))
C
                           REEQ_P(NUREEU)=REEQ_P(NUREEU)
     *                      +CONJG(WAVPRO(IND_IK(IPRLEF,KPRLEF),KLEF,1))
     *                                                   *REDQ_P(NUREDU)
     *                            *WAVPRO(IND_IK(IPRRIG,KPRRIG),KRIG,1)
C
                           IF (LAMBDA.GT.0.AND.LAMBDA.LE.NMARED)
     *
     *                     REEM_P(NUREEU)=REEM_P(NUREEU)
     *                      +CONJG(WAVPRO(IND_IK(IPRLEF,KPRLEF),KLEF,1))
     *                                                   *REDM_P(NUREDU)
     *                            *WAVPRO(IND_IK(IPRRIG,KPRRIG),KRIG,1)
C
                           IF (LAMBDA.GE.NSIMIN.AND.LAMBDA.LE.NSIRED)
     *
     *                     REES_P(NUREEU)=REES_P(NUREEU)
     *                      +CONJG(WAVPRO(IND_IK(IPRLEF,KPRLEF),KLEF,1))
     *                                                   *REDS_P(NUREDU)
     *                            *WAVPRO(IND_IK(IPRRIG,KPRRIG),KRIG,1)
C
                        END DO
                     END DO
C
                  END DO
               END DO
C
            END DO
         END DO
      END DO
C
C=======================================================================
C         PRINTING THE REDUCED MATRIX ELEMENTS OF MULTIPOLE OPERATORS
C=======================================================================
C
      NAMWRK=NAMMUL
C
      I_HEAD=0
      I_HALF=0
C
      DO LAMBDA=1,NMURED
C
         DO IPRRIG=JPROMI,JPROMA,2
C
             DO KRIG=1,NUMPRO(IPRRIG,1)
C
               DO IPRLEF=MAX(JPROMI,IPRRIG-2*LAMBDA),IPRRIG,2
C
                  DO KLEF=1,NUMPRO(IPRLEF,1)
C
                     IF (I_HEAD.EQ.0.AND.IRMPRI.GT.0.AND.
     *                   IPRRIG.GE.ISLPRI.AND.IPRRIG.LE.ISUPRI.AND.
     *                   IPRLEF.GE.ISLPRI.AND.IPRLEF.LE.ISUPRI) THEN
C
                         IF (IEVENI.EQ.1) THEN
C
                     HAFLIN(1)='    IL  NL    L    IR  NR    <||Q||>  '
C
                         ELSE
C
                     HAFLIN(1)='  IL    NL    L  IR    NR    <||Q||>  '
C
                         ENDIF
C
                         WRITE(NFIPRI,'(1H*,77X,1H*,/,
     *                      1H*,1X,'' REDUCED MAT.ELEMS OF PROTON '',
     *                                                 A45,2X,1H*,/,
     *                      1H*,1X,'' ONLY THE RESULTS WITH ABSOLUTE'',
     *                             '' VALUES LARGER THAN'',F6.3,
     *                             '' ARE BELOW PRINTED'', 2X,1H*,/,
     *                                                1H*,77X,1H*,/,
     *                              79(1H*),/,1H*,38X,1H*,38X,1H*,/,
     *                                        1H*,A38,1H*,A38,1H*,/,
     *                                        1H*,38X,1H*,38X,1H*)')
     *                      NAMWRK,QMUCUT,HAFLIN(1),HAFLIN(1)
C
                         I_HEAD=1
C
                     END IF
C
                     NUREEU=INDREE(IND_IN(IPRLEF,KLEF),LAMBDA,
     *                             IND_IN(IPRRIG,KRIG))
C
                     IF (IRMPRI.GT.0.AND.
     *                   IPRRIG.GE.ISLPRI.AND.IPRRIG.LE.ISUPRI.AND.
     *                   IPRLEF.GE.ISLPRI.AND.IPRLEF.LE.ISUPRI.AND.
     *                   ABS(REAL(REEQ_P(NUREEU))).GT.QMUCUT) THEN
C
                         I_HALF=I_HALF+1
C
                         WRITE(HAFLIN(I_HALF),
     *                         '(I4,A2,I4,2X,I3,I4,A2,I4,F11.5,2X)')
     *                      IPRLEF/IEVENI,CHALFI,
     *                      KLEF,LAMBDA,
     *                      IPRRIG/IEVENI,CHALFI,
     *                      KRIG,
     *                      REAL(REEQ_P(NUREEU))
C
                         IF (I_HALF.EQ.2) THEN
C
                             I_HALF=0
C
                             WRITE(NFIPRI,'(1H*,A38,1H*,A38,1H*)')
     *                                                          HAFLIN
C
                         END IF
C
                     END IF
C
                  END DO
               END DO
C
            END DO
         END DO
C
         IF (LAMBDA.EQ.NMURED) THEN
C
             IF (I_HALF.EQ.1)
     *           WRITE(NFIPRI,'(1H*,A38,1H*,38X,1H*)') HAFLIN(1)
C
             IF (IRMPRI.GT.0)
     *           WRITE(NFIPRI,'(1H*,77X,1H*,/,79(1H*))')
C
         END IF
C
      END DO
C
C=======================================================================
C         PRINTING THE REDUCED MATRIX ELEMENTS OF MAGNETIC OPERATORS
C=======================================================================
C
      NAMWRK=NAMMAG
C
      I_HEAD=0
      I_HALF=0
C
      DO LAMBDA=1,NMARED
C
         DO IPRRIG=JPROMI,JPROMA,2
C
             DO KRIG=1,NUMPRO(IPRRIG,1)
C
               DO IPRLEF=MAX(JPROMI,IPRRIG-2*LAMBDA),IPRRIG,2
C
                  DO KLEF=1,NUMPRO(IPRLEF,1)
C
                     IF (I_HEAD.EQ.0.AND.IRMPRI.GT.0.AND.
     *                   IPRRIG.GE.ISLPRI.AND.IPRRIG.LE.ISUPRI.AND.
     *                   IPRLEF.GE.ISLPRI.AND.IPRLEF.LE.ISUPRI)
     *                                                              THEN
C
                         IF (IEVENI.EQ.1) THEN
C
                     HAFLIN(1)='    IL  NL    L    IR  NR    <||M||>  '
C
                         ELSE
C
                     HAFLIN(1)='  IL    NL    L  IR    NR    <||M||>  '
C
                         ENDIF
C
                         WRITE(NFIPRI,'(1H*,77X,1H*,/,
     *                      1H*,1X,'' REDUCED MAT.ELEMS OF PROTON '',
     *                                                 A45,2X,1H*,/,
     *                      1H*,1X,'' ONLY THE RESULTS WITH ABSOLUTE'',
     *                             '' VALUES LARGER THAN'',F6.3,
     *                             '' ARE BELOW PRINTED'', 2X,1H*,/,
     *                                                1H*,77X,1H*,/,
     *                              79(1H*),/,1H*,38X,1H*,38X,1H*,/,
     *                                        1H*,A38,1H*,A38,1H*,/,
     *                                        1H*,38X,1H*,38X,1H*)')
     *                      NAMWRK,QMACUT,HAFLIN(1),HAFLIN(1)
C
                         I_HEAD=1
C
                     END IF
C
                     NUREEU=INDREE(IND_IN(IPRLEF,KLEF),LAMBDA,
     *                             IND_IN(IPRRIG,KRIG))
C
                     IF (IRMPRI.GT.0.AND.
     *                   IPRRIG.GE.ISLPRI.AND.IPRRIG.LE.ISUPRI.AND.
     *                   IPRLEF.GE.ISLPRI.AND.IPRLEF.LE.ISUPRI.AND.
     *                   ABS(REAL(REEM_P(NUREEU))).GT.QMACUT) THEN
C
                         I_HALF=I_HALF+1
C
                         WRITE(HAFLIN(I_HALF),
     *                         '(I4,A2,I4,2X,I3,I4,A2,I4,F11.5,2X)')
     *                      IPRLEF/IEVENI,CHALFI,
     *                      KLEF,LAMBDA,
     *                      IPRRIG/IEVENI,CHALFI,
     *                      KRIG,
     *                      REAL(REEM_P(NUREEU))
C
                         IF (I_HALF.EQ.2) THEN
C
                             I_HALF=0
C
                             WRITE(NFIPRI,'(1H*,A38,1H*,A38,1H*)')
     *                                                          HAFLIN
C
                         END IF
C
                     END IF
C
                  END DO
               END DO
C
            END DO
         END DO
C
         IF (LAMBDA.EQ.NMARED) THEN
C
             IF (I_HALF.EQ.1)
     *           WRITE(NFIPRI,'(1H*,A38,1H*,38X,1H*)') HAFLIN(1)
C
             IF (IRMPRI.GT.0)
     *           WRITE(NFIPRI,'(1H*,77X,1H*,/,79(1H*))')
C
         END IF
C
      END DO
C
C=======================================================================
C         PRINTING THE REDUCED MATRIX ELEMENTS OF SURFACE OR SCHIFF
C         OPERATORS
C=======================================================================
C
                       NAMWRK=NAMSUR
      IF (ISCHIF.EQ.1) NAMWRK=NAMSCH
C
      I_HEAD=0
      I_HALF=0
C
      DO LAMBDA=NSIMIN,NSIRED
C
         DO IPRRIG=JPROMI,JPROMA,2
C
             DO KRIG=1,NUMPRO(IPRRIG,1)
C
               DO IPRLEF=MAX(JPROMI,IPRRIG-2*LAMBDA),IPRRIG,2
C
                  DO KLEF=1,NUMPRO(IPRLEF,1)
C
                     IF (I_HEAD.EQ.0.AND.IRMPRI.GT.0.AND.
     *                   IPRRIG.GE.ISLPRI.AND.IPRRIG.LE.ISUPRI.AND.
     *                   IPRLEF.GE.ISLPRI.AND.IPRLEF.LE.ISUPRI)
     *                                                              THEN
C
                         IF (IEVENI.EQ.1) THEN
C
                     HAFLIN(1)='    IL  NL    L    IR  NR    <||S||>  '
C
                         ELSE
C
                     HAFLIN(1)='  IL    NL    L  IR    NR    <||S||>  '
C
                         ENDIF
C
                         WRITE(NFIPRI,'(1H*,77X,1H*,/,
     *                      1H*,1X,'' REDUCED MAT.ELEMS OF PROTON '',
     *                                                 A45,2X,1H*,/,
     *                      1H*,1X,'' ONLY THE RESULTS WITH ABSOLUTE'',
     *                             '' VALUES LARGER THAN'',F6.3,
     *                             '' ARE BELOW PRINTED'', 2X,1H*,/,
     *                                                1H*,77X,1H*,/,
     *                              79(1H*),/,1H*,38X,1H*,38X,1H*,/,
     *                                        1H*,A38,1H*,A38,1H*,/,
     *                                        1H*,38X,1H*,38X,1H*)')
     *                      NAMWRK,QSICUT,HAFLIN(1),HAFLIN(1)
C
                         I_HEAD=1
C
                     END IF
C
                     NUREEU=INDREE(IND_IN(IPRLEF,KLEF),LAMBDA,
     *                             IND_IN(IPRRIG,KRIG))
C
                     IF (IRMPRI.GT.0.AND.
     *                   IPRRIG.GE.ISLPRI.AND.IPRRIG.LE.ISUPRI.AND.
     *                   IPRLEF.GE.ISLPRI.AND.IPRLEF.LE.ISUPRI.AND.
     *                   ABS(REAL(REES_P(NUREEU))).GT.QSICUT) THEN
C
                         I_HALF=I_HALF+1
C
                         WRITE(HAFLIN(I_HALF),
     *                         '(I4,A2,I4,2X,I3,I4,A2,I4,F11.5,2X)')
     *                      IPRLEF/IEVENI,CHALFI,
     *                      KLEF,LAMBDA,
     *                      IPRRIG/IEVENI,CHALFI,
     *                      KRIG,
     *                      REAL(REES_P(NUREEU))
C
                         IF (I_HALF.EQ.2) THEN
C
                             I_HALF=0
C
                             WRITE(NFIPRI,'(1H*,A38,1H*,A38,1H*)')
     *                                                          HAFLIN
C
                         END IF
C
                     END IF
C
                  END DO
               END DO
C
            END DO
         END DO
C
         IF (LAMBDA.EQ.NSIRED) THEN
C
             IF (I_HALF.EQ.1)
     *           WRITE(NFIPRI,'(1H*,A38,1H*,38X,1H*)') HAFLIN(1)
C
             IF (IRMPRI.GT.0)
     *           WRITE(NFIPRI,'(1H*,77X,1H*,/,79(1H*))')
C
         END IF
C
      END DO
C
C=======================================================================
C
      CALL CPUTIM('REDPRO',0)
C
      RETURN
C
      END
C
C=======================================================================
C
      SUBROUTINE RENMAS(IRENMA,IDOGOA,I_GOGA,IGOGPA,
     *                         NXHERM,NYHERM,NZHERM,
     *                         NXMAXX,NYMAXX,NZMAXX,
     *                         ISIMTX,JSIMTY,ISIMTZ,
     *                         ISIGNY,ISIMPY,ISIQTY,
     *                  IPAIRI,IPAHFB,IROTAT,MREVER,
     *                                IDEVAR,ITERUN,
     *                                NMUCOU,ISHIFY,
     *                         ICUTOV,CUTOVE,CUTOVF,
     *                                NUMCOU,BOUCOU,
     *                  ISYMDE,INIROT,INIINV,INIKAR,
     *                                ISAWAV,IKERNE)
C
C=======================================================================
      USE SAVLEF
      USE SAVRIG
      USE PD_DEN
      USE WAVR_L
C=======================================================================
      USE hfodd_sizes
C=======================================================================
C
      CHARACTER
     *          FILKER*68,FILACT*83,FILINP*83
      CHARACTER
     *          NAMEPN*8
C
      LOGICAL
     *          PRINIT
      LOGICAL
     *          COR_CM
C
      COMPLEX
     *          EKESKY,EKEKIN,EKECOD,EKECOX
      COMPLEX
     *          OVRLAP
      COMPLEX
     *          AUXDIA,C_ZERO,UNIT_I
      COMPLEX
     *          DETWRK
      COMPLEX
     *          WARAUX
      COMPLEX
     *          OVKERN,SKKERN,EKKERN,DKKERN,AKKERN,CDKERN,CXKERN,ETKERN
      COMPLEX
     *          FACINT
      COMPLEX
     *          QMUT_N,QMUT_P,QMUT_T
      COMPLEX
     *          AMUT_N,AMUT_P,AMUT_T
      COMPLEX
     *          EPROJE,OPROJE
      COMPLEX
     *          ZKER_T,ZSKY_T,ZKIN_N,ZKIN_P,ZCOU_D,ZCOU_X,ZMUL_P,ZMAG_P
      COMPLEX
     *          CKER_T,CSKY_T,CKIN_N,CKIN_P,CCOU_D,CCOU_X,CMUL_P,CMAG_P
      COMPLEX
     *          TKER_T,TSKY_T,TKIN_N,TKIN_P,TCOU_D,TCOU_X,TMUL_P,TMAG_P
      COMPLEX
     *          RKER_T,RSKY_T,RKIN_T,       RCOU_D,RCOU_X,RMUL_P,RMAG_P
      COMPLEX
     *          DKINSQ,EKINSQ,PKINSQ,TKINSQ,AKINLI,PKINLI,PKINKI
C
C=======================================================================
      ALLOCATABLE OVRLAP(:,:)
      ALLOCATABLE WARAUX(:,:)
C=======================================================================
      DIMENSION
     *          AUXDIA(1:2*NDSTAT),IAUXDI(1:2*NDSTAT)
      DIMENSION
     *          DETWRK(2)
C
C --> OVERLAP, SKYRME, AND KINETIC ENRGY KERNELS:
C
      DIMENSION
     *          AKKERN(0:NDSHIF,1:NDKART,0:NDISOS)
      DIMENSION
     *          OVKERN(0:NDSHIF,0:NDISOS),EKKERN(0:NDSHIF,0:NDISOS),
     *          EPKERN(0:NDSHIF,0:NDISOS),DKKERN(0:NDSHIF,0:NDISOS)
      DIMENSION
     *          SKKERN(0:NDSHIF),CDKERN(0:NDSHIF),
     *          CXKERN(0:NDSHIF),ETKERN(0:NDSHIF)
      DIMENSION
     *          DLINSQ(0:NDKART),ELINSQ(0:NDKART),PLINSQ(0:NDKART),
     *          TLINSQ(0:NDKART),ALINLI(0:NDKART),PLINLI(0:NDKART),
     *          PLINKI(0:NDKART)
      DIMENSION
     *          DKINSQ(0:NDKART),EKINSQ(0:NDKART),PKINSQ(0:NDKART),
     *          TKINSQ(0:NDKART),AKINLI(0:NDKART),PKINLI(0:NDKART),
     *          PKINKI(0:NDKART)
C
      COMMON
     *       /QMUTTI/ QMUT_N(0:NDMULT,-NDMULT:NDMULT),
     *                QMUT_P(0:NDMULT,-NDMULT:NDMULT),
     *                QMUT_T(0:NDMULT,-NDMULT:NDMULT)
      COMMON
     *       /QMULTI/ QMUL_N(0:NDMULT,-NDMULT:NDMULT),
     *                QMUL_P(0:NDMULT,-NDMULT:NDMULT),
     *                QMUL_T(0:NDMULT,-NDMULT:NDMULT)
      COMMON
     *       /AMUTTI/ AMUT_N(0:NDMULT,-NDMULT:NDMULT),
     *                AMUT_P(0:NDMULT,-NDMULT:NDMULT),
     *                AMUT_T(0:NDMULT,-NDMULT:NDMULT)
      COMMON
     *       /AMULTI/ AMUL_N(0:NDMULT,-NDMULT:NDMULT),
     *                AMUL_P(0:NDMULT,-NDMULT:NDMULT),
     *                AMUL_T(0:NDMULT,-NDMULT:NDMULT)
      COMMON
     *       /OURUNI/ QUNITS(0:NDMULT,0:NDMULT)
      COMMON
     *       /MAGUNI/ AUNITS(0:NDMULT,0:NDMULT)
      COMMON
     *       /COEMUL/ COMULT(0:NDMULT,0:NDOSCI,0:NDOSCI,1:NDKART)
      COMMON
     *       /SVECTO/ BSHIFT(NDKART)
      COMMON
     *       /DIMENS/ LDBASE
      COMMON
     *       /DIMSTA/ LDTOTS(0:NDISOS),LDSTAT(0:NDISOS),
     *                LDUPPE(0:NDISOS),LDTIMU(0:NDISOS)
      COMMON
     *       /DISTAN/ DISTAX,DISTAY,DISTAZ
      COMMON
     *       /PLANCK/ HBMASS,HBMRPA,HBMINP
      COMMON
     *       /RENORM/ HBMREN(NDKART)
      COMMON
     *       /RENGOA/ GOAREN(NDKART)
      COMMON
     *       /CFIPRI/ NFIPRI
C
C=======================================================================
C
      CALL CPUTIM('RENMAS',1)
C
C=======================================================================
C
      IALLOC=0
C
C=======================================================================
      IF (.NOT.ALLOCATED(WARIGH)) THEN
          ALLOCATE (WARIGH(1:NDBASE,1:4*NDSTAT,0:NDSPIN),STAT=IALLOC)
          IF (IALLOC.NE.0) CALL NOALLO('WARIGH','RENMAS')
      END IF
C=======================================================================
      IF (.NOT.ALLOCATED(WALEFT)) THEN
          ALLOCATE (WALEFT(1:NDBASE,1:4*NDSTAT,0:NDSPIN),STAT=IALLOC)
          IF (IALLOC.NE.0) CALL NOALLO('WALEFT','RENMAS')
      END IF
C=======================================================================
      ALLOCATE (OVRLAP(1:2*NDSTAT,1:2*NDSTAT),STAT=IALLOC)
      IF (IALLOC.NE.0) CALL NOALLO('OVRLAP','RENMAS')
C=======================================================================
      ALLOCATE (WARAUX(1:2*NDSTAT,0:NDSPIN),STAT=IALLOC)
      IF (IALLOC.NE.0) CALL NOALLO('WARAUX','RENMAS')
C=======================================================================
C
C=======================================================================
C         THIS SUBROUTINE CALCULATES THE MASS RENORMALIZATION FACTORS
C=======================================================================
C
      PI=4.0D0*ATAN(1.0D0)
C
      C_ZERO=CMPLX(0.0D0,0.0D0)
C
      UNIT_I=CMPLX(0.0D0,1.0D0)
C
      NAMEPN='DUMMY   '
      PRINIT=.FALSE.
C
      EDUMMY=0.0D0
C
      JMULMO=NMUCOU
C
      COR_CM=.TRUE.
      JETACM=0
C
C=======================================================================
C         HERE BEGIN THE LOOP THE SHIFT VECTORS.
C=======================================================================
C
      IF (IRENMA.GT.NDSHIF) STOP ' IRENMA.GT.NDSHIF IN RENMAS'
C
      DO INSHIF=IRENMA,0,-1
C
         BSHIFT(1)=INSHIF*DISTAX
         BSHIFT(2)=INSHIF*DISTAY
         BSHIFT(3)=INSHIF*DISTAZ
C
         DO ICHARG=0,NDISOS
C
            LSTATE=LDSTAT(ICHARG)
C
C=======================================================================
C         FETCHING THE LEFT WAVE FUNCTIONS FOR THE GIVEN CHARGE
C=======================================================================
C
            DO ISTATE=1,LSTATE
               DO IBASE=1,LDBASE
                  DO ISPIN=0,NDSPIN
C
                     WALEFT(IBASE,ISTATE,ISPIN)=
     *               SARIGH(IBASE,ISTATE,ISPIN,ICHARG)
C
                  END DO
               END DO
            END DO
C
C=======================================================================
C         FETCHING THE RIGHT WAVE FUNCTIONS FOR THE GIVEN CHARGE
C=======================================================================
C
            DO ISTATE=1,LSTATE
               DO IBASE=1,LDBASE
                  DO ISPIN=0,NDSPIN
C
                     WARIGH(IBASE,ISTATE,ISPIN)=
     *               SARIGH(IBASE,ISTATE,ISPIN,ICHARG)
C
                  END DO
               END DO
            END DO
C
C=======================================================================
C         ZEROING THE OVERLAP MATRICES
C=======================================================================
C
            IF (LSTATE.GT.2*NDSTAT)
     *
     *          STOP ' LSTATE.GT.2*NDSTAT IN RENMAS'
C
            DO ISTATE=1,LSTATE
               DO JSTATE=1,LSTATE
C
                    OVRLAP(ISTATE,JSTATE)=C_ZERO
C
               END DO
            END DO
C
C=======================================================================
C         SHIFTING THE RIGHT WAVE FUNCTIONS BY THE DISTANCE
C=======================================================================
C
            CALL SHIWAV(LSTATE,WARIGH)
C
C=======================================================================
C         CALCULATING THE OVERLAPS BETWEEN THE LEFT AND RIGHT STATES
C=======================================================================
C
            DO ISTATE=1,LSTATE
               DO JSTATE=1,LSTATE
                  DO IBASE=1,LDBASE
                     DO ISPIN=0,NDSPIN
C
                        OVRLAP(ISTATE,JSTATE)=
     *                  OVRLAP(ISTATE,JSTATE)
     *                  +CONJG(WALEFT(IBASE,ISTATE,ISPIN))
     *                        *WARIGH(IBASE,JSTATE,ISPIN)
C
                     END DO
                  END DO
               END DO
            END DO
C
C=======================================================================
C         INVERTING THE OVERLAP MATRIX
C=======================================================================
C
            CALL ZGECO(OVRLAP,2*NDSTAT,LSTATE,IAUXDI,
     *                                 RICOND,AUXDIA)
            CALL ZGEDI(OVRLAP,2*NDSTAT,LSTATE,IAUXDI,
     *                                 DETWRK,AUXDIA,11)
C
            OVKERN(INSHIF,ICHARG)=DETWRK(1)*10.0D0**DETWRK(2)
C
            IF (ABS(RICOND).LT.1.0D-12) THEN
C
                WRITE(NFIPRI,*) 'BE CAREFULL - OVERLAP MATRIX ',
     *                          'MAY BE SINGULAR IN RENMAS FOR:'
                WRITE(NFIPRI,*) 'INSHIF=',INSHIF,' RICOND=',RICOND
C
            END IF
C
C=======================================================================
C         MULTIPLYING THE RIGHT WAVE FUNCTIONS BY THE INVERTED OVERLAP
C         MATRIX
C=======================================================================
C
            DO JSTATE=1,LDBASE
C
               DO ISTATE=1,LSTATE
                  DO ISPIN=0,NDSPIN
C
                     WARAUX(ISTATE,ISPIN)=C_ZERO
C
                     DO KSTATE=1,LSTATE
C
                        WARAUX(ISTATE,ISPIN)=WARAUX(ISTATE,ISPIN)
     *
     *                               +WARIGH(JSTATE,KSTATE,ISPIN)
     *                                      *OVRLAP(KSTATE,ISTATE)
                     END DO
C
                  END DO
               END DO
C
               DO ISTATE=1,LSTATE
                  DO ISPIN=0,NDSPIN
C
                     WARIGH(JSTATE,ISTATE,ISPIN)=
     *                      WARAUX(ISTATE,ISPIN)
C
                  END DO
               END DO
C
            END DO
C
C=======================================================================
C                 HERE BEGIN CALCULATIONS OF NEUTRON DENSITIES AND
C                 OBSERVABLES
C=======================================================================
C
            IF (ICHARG.EQ.0) THEN
C
C=======================================================================
C                 ZEROING THE NEUTRON DENSITIES
C=======================================================================
C
                CALL ZEDENS(ICHARG)
C
C=======================================================================
C                 CALCULATING THE NEUTRON DENSITIES AND CURRENTS
C=======================================================================
C
                CALL DENSHF(NXHERM,NYHERM,NZHERM,ISIMTX,JSIMTY,ISIMTZ,
     *                      ISIGNY,ISIMPY,ISIQTY,IPAHFB,MREVER,ICHARG,
     *                      ICOUDI,ICOUEX,I_YUKA,I_GOGA,IGOGPA,
     *                                                  IPNMIX,ITPNMX,
     *                      ITIREP,NXMAXX,NAMEPN,PRINIT,IDEVAR,ITERUN,
     *                      ISYMDE,INIROT,INIINV,INIKAR,ISAWAV,IKERNE)
C
C=======================================================================
C                 DOUBLING THE SINGLE-PARTICLE RESULTS IN CASE OF NO
C                 ROTATION
C=======================================================================
C
                IF (MREVER.EQ.0)
     *
     *          CALL DBLING(ITPNMX,NXHERM,NYHERM,NZHERM,EDUMMY)
C
C=======================================================================
C                 CALCULATING THE NEUTRON TRANSITION DENSITY MATRIX
C                 AND TRANSITION  MATRIX  ELEMENTS  OF  OBSERVABLES
C=======================================================================
C
                CALL DENMAC(MREVER,ICHARG,ISIMPY,IPAHFB,WALEFT,WARIGH)
C
                CALL EKINET(ENEKIN,DLINSQ(0),EKEKIN,DKINSQ(0))
C
                EKKERN(INSHIF,ICHARG)=EKEKIN
C
C=======================================================================
C                 ATTENTION: CALCULATION OF KERNELS OF <P^2> IS NOT
C                            NEEDED FOR THE   GOE  METHOD AND IT IS
C                            SWITCHED OFF BY SETTING IDOGOA=1. THIS
C                            CALCULATION IS SWITCHED ON BY IDOGOA=0
C                            THAT IS FOR THE LIPKIN METHOD.
C=======================================================================
C
                IF (IDOGOA.EQ.0) THEN
C
                    IF (IPAIRI.EQ.1.AND.COR_CM)
     *
     *                  CALL PAIMAC(MREVER,ICHARG,ISIMPY,
     *                              WALEFT,WARIGH,IKERNE)
C
                    CALL LINAVR(
     *                 NXMAXX,NYMAXX,NZMAXX,ISIMPY,ISIGNY,ISIQTY,
     *                 IPAIRI,ICHARG,JETACM,IROTAT,MREVER,COR_CM,
     *                 DLINSQ,ELINSQ,PLINSQ,TLINSQ,ALINLI,PLINLI,PLINKI,
     *                 DKINSQ,EKINSQ,PKINSQ,TKINSQ,AKINLI,PKINLI,PKINKI)
C
                    DKKERN(INSHIF,ICHARG)=TKINSQ(0)
C
                    AKKERN(INSHIF,1,ICHARG)=AKINLI(1)
                    AKKERN(INSHIF,2,ICHARG)=AKINLI(2)
                    AKKERN(INSHIF,3,ICHARG)=AKINLI(3)
C
                ELSE
C
                    DKKERN(INSHIF,ICHARG)=C_ZERO
C
                    AKKERN(INSHIF,1,ICHARG)=C_ZERO
                    AKKERN(INSHIF,2,ICHARG)=C_ZERO
                    AKKERN(INSHIF,3,ICHARG)=C_ZERO
C
                END IF
C
            END IF
C
C=======================================================================
C                 HERE BEGIN CALCULATIONS OF PROTON DENSITIES AND
C                 OBSERVABLES
C=======================================================================
C
            IF (ICHARG.EQ.1) THEN
C
C=======================================================================
C                 ZEROING THE PROTON DENSITIES
C=======================================================================
C
                CALL ZEDENS(ICHARG)
C
C=======================================================================
C                 CALCULATING THE PROTON DENSITIES AND CURRENTS
C=======================================================================
C
                CALL DENSHF(NXHERM,NYHERM,NZHERM,ISIMTX,JSIMTY,ISIMTZ,
     *                      ISIGNY,ISIMPY,ISIQTY,IPAHFB,MREVER,ICHARG,
     *                      ICOUDI,ICOUEX,I_YUKA,I_GOGA,IGOGPA,
     *                                                  IPNMIX,ITPNMX,
     *                      ITIREP,NXMAXX,NAMEPN,PRINIT,IDEVAR,ITERUN,
     *                      ISYMDE,INIROT,INIINV,INIKAR,ISAWAV,IKERNE)
C
C=======================================================================
C                 DOUBLING SINGLE-PARTICLE RESULTS IN CASE OF NO
C                 ROTATION
C=======================================================================
C
                IF (MREVER.EQ.0)
     *
     *          CALL DBLING(ITPNMX,NXHERM,NYHERM,NZHERM,EDUMMY)
C
C=======================================================================
C                 CALCULATING THE PROTON TRANSITION DENSITY MATRIX
C                 AND TRANSITION MATRIX  ELEMENTS  OF  OBSERVABLES
C=======================================================================
C
                CALL DENMAC(MREVER,ICHARG,ISIMPY,IPAHFB,WALEFT,WARIGH)
C
                CALL EKINET(ENEKIN,DLINSQ(0),EKEKIN,DKINSQ(0))
C
                EKKERN(INSHIF,ICHARG)=EKEKIN
C
                IF (IDOGOA.EQ.0) THEN
C
                    IF (IPAIRI.EQ.1.AND.COR_CM)
     *
     *                  CALL PAIMAC(MREVER,ICHARG,ISIMPY,
     *                              WALEFT,WARIGH,IKERNE)
C
                    CALL LINAVR(
     *                 NXMAXX,NYMAXX,NZMAXX,ISIMPY,ISIGNY,ISIQTY,
     *                 IPAIRI,ICHARG,JETACM,IROTAT,MREVER,COR_CM,
     *                 DLINSQ,ELINSQ,PLINSQ,TLINSQ,ALINLI,PLINLI,PLINKI,
     *                 DKINSQ,EKINSQ,PKINSQ,TKINSQ,AKINLI,PKINLI,PKINKI)
C
                    DKKERN(INSHIF,ICHARG)=TKINSQ(0)
C
                    AKKERN(INSHIF,1,ICHARG)=AKINLI(1)
                    AKKERN(INSHIF,2,ICHARG)=AKINLI(2)
                    AKKERN(INSHIF,3,ICHARG)=AKINLI(3)
C
                ELSE
C
                    DKKERN(INSHIF,ICHARG)=C_ZERO
C
                    AKKERN(INSHIF,1,ICHARG)=C_ZERO
                    AKKERN(INSHIF,2,ICHARG)=C_ZERO
                    AKKERN(INSHIF,3,ICHARG)=C_ZERO
C
                END IF
C
C=======================================================================
C                 CALCULATING TRANSITION MATRIX  ELEMENTS  OF  MULTIPOLE
C                 OPERATORS.
C=======================================================================
C
                CALL MOMETS(ISIMPY,ISIGNY,ISIQTY,QMUL_P,QMUT_P,
     *                                    COMULT,JMULMO,ISHIFY)
C
C=======================================================================
C                 CALCULATING THE COULOMB TRANSITION MATRIX ELEMENTS
C=======================================================================
C
                CALL COUMAT(NXHERM,NYHERM,NZHERM,NXMAXX,NYMAXX,NZMAXX,
     *                                    NUMCOU,BOUCOU,ISIMPY,IKERNE)
C
                CALL COULOD(ISIMPY,EKECOD)
C
                CDKERN(INSHIF)=EKECOD
C
                CALL TRUCHD(NXHERM,NYHERM,NZHERM)
C
                CALL COULOE(NXHERM,NYHERM,NZHERM,EKECOX)
C
                CXKERN(INSHIF)=EKECOX
C
            END IF
C
C=======================================================================
C                 HERE END CALCULATIONS FOR NEUTRONS AND PROTONS
C=======================================================================
C
         END DO
C
C=======================================================================
C             CALCULATING  T H E   S K Y R M E   TRANSITION  E N E R G Y
C=======================================================================
C
         CALL TRUTOD(NXHERM,NYHERM,NZHERM)
C
         CALL ESKYRM(NXHERM,NYHERM,NZHERM,ENESKY,ENEVEN,ENEODD,
     *                             ENREAR,ENE_W0,EEVEW0,EODDW0,
     *                                                  EKESKY)
C
         SKKERN(INSHIF)=EKESKY
C
         ETKERN(INSHIF)=EKKERN(INSHIF,0)
     *                 +EKKERN(INSHIF,1)
     *                 +CDKERN(INSHIF)
     *                 +CXKERN(INSHIF)
     *                 +SKKERN(INSHIF)
C
         IPRIKE=0
C
         IF (IPRIKE.EQ.1) THEN
C
             WRITE(NFIPRI,1001) INSHIF,BSHIFT,
     *        'ET',ETKERN(INSHIF),
     *        'OT',OVKERN(INSHIF,0)*OVKERN(INSHIF,1),
     *        'KT',EKKERN(INSHIF,0)+EKKERN(INSHIF,1),
     *        'PT',DKKERN(INSHIF,0)+DKKERN(INSHIF,1)
     *          +2*AKKERN(INSHIF,1,0)*AKKERN(INSHIF,1,1)
     *          +2*AKKERN(INSHIF,2,0)*AKKERN(INSHIF,2,1)
     *          +2*AKKERN(INSHIF,3,0)*AKKERN(INSHIF,3,1),
     *        'ON',OVKERN(INSHIF,0),'OP',OVKERN(INSHIF,1),
     *        'KN',EKKERN(INSHIF,0),'KP',EKKERN(INSHIF,1),
     *        'CD',CDKERN(INSHIF),  'CX',CXKERN(INSHIF),
     *        'SK',SKKERN(INSHIF)
 1001        FORMAT(I3,3F7.3,11(1X,A2,1PE12.4,1PE12.4))
C
         END IF
C
         IPRIKE=0
C
         IF (IPRIKE.EQ.1) THEN
C
             IF (INSHIF.EQ.0) WRITE(NFIPRI,1002)
     *        'ET',
     *        'OT',
     *        'LT',
     *        'KT',
     *        'PT'
 1002        FORMAT(50X,11(1X,A2,32X))
             WRITE(NFIPRI,1003) INSHIF,BSHIFT,
     *        'ET',ETKERN(INSHIF),
     *        'OT',OVKERN(INSHIF,0)*OVKERN(INSHIF,1),
     *        'LT',LOG(OVKERN(INSHIF,0)*OVKERN(INSHIF,1)),
     *        'KT',EKKERN(INSHIF,0)+EKKERN(INSHIF,1),
     *        'PT',DKKERN(INSHIF,0)+DKKERN(INSHIF,1)
     *          +2*AKKERN(INSHIF,1,0)*AKKERN(INSHIF,1,1)
     *          +2*AKKERN(INSHIF,2,0)*AKKERN(INSHIF,2,1)
     *          +2*AKKERN(INSHIF,3,0)*AKKERN(INSHIF,3,1)
 1003        FORMAT(I3,3F14.10,11(1X,A2,1PE16.8,1PE16.8))
C
         END IF
C
      END DO
C
C=======================================================================
C        BELOW WE DEFINE THE LIPKIN PARAMETERS, WHICH ARE POSITIVE
C=======================================================================
C
      TSHIFT=IRENMA**2*(DISTAX**2+DISTAY**2+DISTAZ**2)
C
      H2PARA=-2*REAL(   (ETKERN(IRENMA)  -ETKERN(0)       )/TSHIFT)
      A_PARA=-2*REAL(LOG(OVKERN(IRENMA,0)*OVKERN(IRENMA,1))/TSHIFT)
C
      GOAMAS=H2PARA/(2*A_PARA**2)
C
      IF (IDOGOA.EQ.0) THEN
C
          REMASS=REAL((ETKERN(IRENMA)  -ETKERN(0))/
     *                (DKKERN(IRENMA,0)  +DKKERN(IRENMA,1)
     *              +2*AKKERN(IRENMA,1,0)*AKKERN(IRENMA,1,1)
     *              +2*AKKERN(IRENMA,2,0)*AKKERN(IRENMA,2,1)
     *              +2*AKKERN(IRENMA,3,0)*AKKERN(IRENMA,3,1)
     *                -DKKERN(0,0)  -DKKERN(0,1)
     *              -2*AKKERN(0,1,0)*AKKERN(0,1,1)
     *              -2*AKKERN(0,2,0)*AKKERN(0,2,1)
     *              -2*AKKERN(0,3,0)*AKKERN(0,3,1)))
C
      ELSE
C
          REMASS=GOAMAS
C
      END IF
C
      IPRIKE=0
C
      IF (IPRIKE.EQ.1)
     *    WRITE (NFIPRI,'('' TSHIFT='',F10.6,
     *                    '' H2PARA='',F10.6,
     *                    '' A_PARA='',F10.6,
     *                    '' REMASS='',F10.6)')
     *    TSHIFT,H2PARA,A_PARA,REMASS
C
C=======================================================================
C        BELOW WE DEFINE THE COEFFICIENTS OF <P^2>, WHICH ARE NEGATIVE
C=======================================================================
C
      HBMREN(1)=-REMASS
      HBMREN(2)=-REMASS
      HBMREN(3)=-REMASS
C
      GOAREN(1)=-GOAMAS
      GOAREN(2)=-GOAMAS
      GOAREN(3)=-GOAMAS
C
C=======================================================================
      DEALLOCATE (OVRLAP)
      DEALLOCATE (WARAUX)
C=======================================================================
C
      CALL CPUTIM('RENMAS',0)
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE SAVEWF(NFIWAV,IACWAV,FILWAV)
C=======================================================================
      USE SAVRIG
C=======================================================================
      USE hfodd_sizes
C=======================================================================
C
      CHARACTER
     *          FILWAV*68,FILACT*72
C
C=======================================================================
C
      COMMON
     *       /DIMENS/ LDBASE
      COMMON
     *       /DIMSTA/ LDTOTS(0:NDISOS),LDSTAT(0:NDISOS),
     *                LDUPPE(0:NDISOS),LDTIMU(0:NDISOS)
      COMMON
     *       /CFIPRI/ NFIPRI
C
C=======================================================================
C         THIS SUBROUTINE SAVES ON DISC THE WAVE FUNCTIONS
C         FOR CALCULATION OF THE GCM KERNELS
C=======================================================================
C
      WRITE(FILACT(1:3),'(I3)') IACWAV
C
      IF (FILACT(1:1).EQ.' ') FILACT(1:1)='0'
      IF (FILACT(2:2).EQ.' ') FILACT(2:2)='0'
C
      FILACT(4:4)='-'
      FILACT(5:72)=FILWAV
C
      OPEN(NFIWAV,FILE=FILACT,STATUS='UNKNOWN',FORM='UNFORMATTED')
C
      IVERWF=2
C
      WRITE(NFIWAV) IVERWF
C
      DO ICHARG=0,NDISOS
C
         LSTATE=LDSTAT(ICHARG)
         LUPPER=LDUPPE(ICHARG)
         LTIMUP=LDTIMU(ICHARG)
C
         WRITE(NFIWAV) LSTATE,LUPPER,LTIMUP
C
         WRITE(NFIWAV) (((SARIGH(IBASE,ISTATE,ISPIN,ICHARG),
     *                  ISPIN=0,NDSPIN),IBASE=1,LDBASE),ISTATE=1,LSTATE)
C
      END DO
C
      CLOSE(NFIWAV)
C
      WRITE(NFIPRI,'(79(1H*),/,1H*,77X,1H*,/,
     *        1H*,1X,'' THE FILE WITH WAVE FUNCTION THAT HAS BEEN'',
     *               '' SAVED:                         '',    2X,1H*,/,
     *        1H*,2X,A72,                                     3X,1H*,/,
     *                                                   1H*,77X,1H*,/,
     *                                                      79(1H*),/)')
     *
     *    FILACT
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE READWF(NFIWAV,IACWAV,FILWAV)
C=======================================================================
      USE SAVLEF
C=======================================================================
      USE hfodd_sizes
C=======================================================================
C
      CHARACTER
     *          FILWAV*68,FILACT*72
C
C=======================================================================
C
      COMMON
     *       /DIMENS/ LDBASE
      COMMON
     *       /DIMSTA/ LDTOTS(0:NDISOS),LDSTAT(0:NDISOS),
     *                LDUPPE(0:NDISOS),LDTIMU(0:NDISOS)
      COMMON
     *       /CFIPRI/ NFIPRI
C
C=======================================================================
C
      IALLOC=0
C
C=======================================================================
      IF (.NOT.ALLOCATED(SALEFT)) THEN
          ALLOCATE (SALEFT(1:NDBASE,1:4*NDSTAT,0:NDSPIN,0:NDISOS),
     *              STAT=IALLOC)
          IF (IALLOC.NE.0) CALL NOALLO('SALEFT','READWF')
      END IF
C=======================================================================
C         THIS SUBROUTINE READS FROM DISC THE WAVE FUNCTIONS
C         FOR CALCULATION OF THE GCM KERNELS
C=======================================================================
C
      WRITE(FILACT(1:3),'(I3)') IACWAV
C
      IF (FILACT(1:1).EQ.' ') FILACT(1:1)='0'
      IF (FILACT(2:2).EQ.' ') FILACT(2:2)='0'
C
      FILACT(4:4)='-'
      FILACT(5:72)=FILWAV
C
      OPEN(NFIWAV,FILE=FILACT,STATUS='OLD',ERR=9,FORM='UNFORMATTED')
C
      GO TO 1009
C
    9 WRITE(NFIPRI,'(/,1X,26(1H/),2X,''FILE NOT FOUND ON DISC'',
     *                                                 2X,26(1H/),/,
     *                 1X, 3(1H/),2X,68X,                  2X, 3(1H/),/,
     *                 1X, 1(1H/),2X,A72,                  2X, 1(1H/),/,
     *                 1X, 3(1H/),2X,68X,                  2X, 3(1H/),/,
     *                 1X,26(1H/),2X,''FILE NOT FOUND ON DISC'',
     *                                                 2X,26(1H/))')
     *             FILACT
C
      STOP ' FILE FILWAV NOT FOUND ON DISC'
C
 1009 CONTINUE
C
      READ (NFIWAV) IVERWF
C
      IF (IVERWF.NE.2) THEN
C
          WRITE(NFIPRI,'(/,1X,10(1H/),
     *              ''  CANNOT READ THE WAVE-FUNCTION FILE VERSION:'',
     *              I3,2X,10(1H/),/)') IVERWF
C
          STOP '  WRONG IVERWF IN READWF'
C
      END IF
C
      DO ICHARG=0,NDISOS
C
         READ (NFIWAV) LSTATE,LUPPER,LTIMUP
C
         LDSTAT(ICHARG)=LSTATE
         LDUPPE(ICHARG)=LUPPER
         LDTIMU(ICHARG)=LTIMUP
C
         READ  (NFIWAV) (((SALEFT(IBASE,ISTATE,ISPIN,ICHARG),
     *                  ISPIN=0,NDSPIN),IBASE=1,LDBASE),ISTATE=1,LSTATE)
C
      END DO
C
      CLOSE(NFIWAV)
C
      WRITE(NFIPRI,'(79(1H*),/,1H*,77X,1H*,/,
     *        1H*,1X,'' THE FILE WITH WAVE FUNCTION THAT HAS BEEN'',
     *               '' READ:                          '',    2X,1H*,/,
     *        1H*,2X,A72,                                     3X,1H*,/,
     *                                                   1H*,77X,1H*,/,
     *                                                        79(1H*))')
     *
     *    FILACT
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE SAVE_F(NFIWAV,IACWAV,FILWAV,
     *                  ISOMIR,ISOMAR,ISOTZR)
C=======================================================================
      USE SAVRIG
C=======================================================================
      USE hfodd_sizes
C=======================================================================
C
      CHARACTER
     *          FILWAV*68,FILACT*72
C
      COMPLEX
     *          WAVE_R,WPRO_R
C
      COMMON
     *       /TMX0RA/ WPRO_R(NDPROT),WAVE_R(NDPROT),EIGE_R
      COMMON
     *       /TMX0RB/ NPRO_R(NDPROT),IDIM_R
C
      COMMON
     *       /DIMENS/ LDBASE
      COMMON
     *       /DIMSTA/ LDTOTS(0:NDISOS),LDSTAT(0:NDISOS),
     *                LDUPPE(0:NDISOS),LDTIMU(0:NDISOS)
      COMMON
     *       /CFIPRI/ NFIPRI
C
C=======================================================================
C         THIS SUBROUTINE SAVES ON DISC THE WAVE FUNCTIONS
C         FOR CALCULATION OF THE GCM KERNELS
C=======================================================================
C
      WRITE(FILACT(1:3),'(I3)') IACWAV
C
      IF (FILACT(1:1).EQ.' ') FILACT(1:1)='0'
      IF (FILACT(2:2).EQ.' ') FILACT(2:2)='0'
C
      FILACT(4:4)='-'
      FILACT(5:72)=FILWAV
C
      OPEN(NFIWAV,FILE=FILACT,STATUS='UNKNOWN',FORM='UNFORMATTED')
C
      IVERWF=2
C
      WRITE(NFIWAV) IVERWF
C
      DO ICHARG=0,NDISOS
C
         LSTATE=LDSTAT(ICHARG)
         LUPPER=LDUPPE(ICHARG)
         LTIMUP=LDTIMU(ICHARG)
C
         WRITE(NFIWAV) LSTATE,LUPPER,LTIMUP
C
         WRITE(NFIWAV) (((SARIGH(IBASE,ISTATE,ISPIN,ICHARG),
     *                  ISPIN=0,NDSPIN),IBASE=1,LDBASE),ISTATE=1,LSTATE)
C
      END DO
C
         WRITE(NFIWAV)    ISOMIR,ISOMAR,ISOTZR,IDIM_R
C
         WRITE(NFIWAV)  (NPRO_R(ISOSP),ISOSP=1,IDIM_R)
C
         WRITE(NFIWAV)  (WPRO_R(ISOSP),ISOSP=1,IDIM_R)
C
         WRITE(NFIWAV)   EIGE_R
C
         WRITE(NFIWAV)  (WAVE_R(IMIXT),IMIXT=1,IDIM_R)
C
      CLOSE (NFIWAV)
C
      WRITE(NFIPRI,'(79(1H*),/,1H*,77X,1H*,/,
     *        1H*,1X,'' THE FILE WITH WAVE FUNCTION THAT HAS BEEN'',
     *               '' SAVED:                         '',    2X,1H*,/,
     *        1H*,2X,A72,                                     3X,1H*,/,
     *                                                   1H*,77X,1H*,/,
     *                                                      79(1H*),/)')
     *
     *    FILACT
C
      RETURN
      END
C
      SUBROUTINE READ_F(NFIWAV,IACWAV,FILWAV,
     *                  ISOMIL,ISOMAL,ISOTZL)
C=======================================================================
      USE SAVLEF
C=======================================================================
      USE hfodd_sizes
C=======================================================================
C
      CHARACTER
     *          FILWAV*68,FILACT*72
C
      COMPLEX
     *          WAVE_L,WPRO_L
      COMMON
     *    /TMX0LA/ WPRO_L(NDPROT),WAVE_L(NDPROT),EIGE_L
      COMMON
     *    /TMX0LB/ NPRO_L(NDPROT),IDIM_L
C
      COMMON
     *       /DIMENS/ LDBASE
      COMMON
     *       /DIMSTA/ LDTOTS(0:NDISOS),LDSTAT(0:NDISOS),
     *                LDUPPE(0:NDISOS),LDTIMU(0:NDISOS)
      COMMON
     *       /CFIPRI/ NFIPRI
C
C=======================================================================
C
      IALLOC=0
C
C=======================================================================
      IF (.NOT.ALLOCATED(SALEFT)) THEN
          ALLOCATE (SALEFT(1:NDBASE,1:4*NDSTAT,0:NDSPIN,0:NDISOS),
     *              STAT=IALLOC)
          IF (IALLOC.NE.0) CALL NOALLO('SALEFT','READ_F')
      END IF
C=======================================================================
C         THIS SUBROUTINE READS FROM DISC THE WAVE FUNCTIONS
C           FOR CALCULATION OF THE FERMI SUPERALLOWED M.E.
C=======================================================================
C
      WRITE(FILACT(1:3),'(I3)') IACWAV
C
      IF (FILACT(1:1).EQ.' ') FILACT(1:1)='0'
      IF (FILACT(2:2).EQ.' ') FILACT(2:2)='0'
C
      FILACT(4:4)='-'
      FILACT(5:72)=FILWAV
C
      OPEN(NFIWAV,FILE=FILACT,STATUS='OLD',ERR=9,FORM='UNFORMATTED')
C
      GO TO 1009
C
    9 WRITE(NFIPRI,'(/,1X,26(1H/),2X,''FILE NOT FOUND ON DISC'',
     *                                                 2X,26(1H/),/,
     *                 1X, 3(1H/),2X,68X,                  2X, 3(1H/),/,
     *                 1X, 1(1H/),2X,A72,                  2X, 1(1H/),/,
     *                 1X, 3(1H/),2X,68X,                  2X, 3(1H/),/,
     *                 1X,26(1H/),2X,''FILE NOT FOUND ON DISC'',
     *                                                 2X,26(1H/))')
     *             FILACT
C
      STOP ' FILE FILWAV NOT FOUND ON DISC'
C
 1009 CONTINUE
C
      READ (NFIWAV) IVERWF
C
      IF (IVERWF.NE.2) THEN
C
          WRITE(NFIPRI,'(/,1X,10(1H/),
     *              ''  CANNOT READ THE WAVE-FUNCTION FILE VERSION:'',
     *              I3,2X,10(1H/),/)') IVERWF
C
          STOP '  WRONG IVERWF IN READWF'
C
      END IF
C
      DO ICHARG=0,NDISOS
C
         READ (NFIWAV) LSTATE,LUPPER,LTIMUP
C
         LDSTAT(ICHARG)=LSTATE
         LDUPPE(ICHARG)=LUPPER
         LDTIMU(ICHARG)=LTIMUP
C
         READ  (NFIWAV) (((SALEFT(IBASE,ISTATE,ISPIN,ICHARG),
     *                  ISPIN=0,NDSPIN),IBASE=1,LDBASE),ISTATE=1,LSTATE)
C
      END DO
C
         READ(NFIWAV)    ISOMIL,ISOMAL,ISOTZL,IDIM_L
C
         READ(NFIWAV)  (NPRO_L(ISOSP),ISOSP=1,IDIM_L)
C
         READ(NFIWAV)  (WPRO_L(ISOSP),ISOSP=1,IDIM_L)
C
         READ(NFIWAV)   EIGE_L
C
         READ(NFIWAV)  (WAVE_L(IMIXT),IMIXT=1,IDIM_L)
C
      CLOSE (NFIWAV)
C
      WRITE(NFIPRI,'(79(1H*),/,1H*,77X,1H*,/,
     *        1H*,1X,'' THE FILE WITH WAVE FUNCTION THAT HAS BEEN'',
     *               '' READ:                          '',    2X,1H*,/,
     *        1H*,2X,A72,                                     3X,1H*,/,
     *                                                   1H*,77X,1H*,/,
     *                                                        79(1H*))')
     *
     *    FILACT
C
C=======================================================================
C
CWS      WRITE(*,110) EIGE_L
CWS 110  FORMAT(1H*,2X,'FROM READ_F',F12.6)
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE DEFBIN
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      COMMON
     *       /NEWBIN/ IBINOM(0:NDMULT,0:NDMULT)
      COMMON
     *       /CFIPRI/ NFIPRI
C
C=======================================================================
C     THIS SUBROUTINE DEFINES THE NEWTON BINOMIAL INTEGER COEFFICIENTS:
C     IBINOM(N,K)=N!/(K!(N-K)!)
C     COEFFICIENTS ARE SYMMETRIZED IN ORDER TO FILL IN ALL  THE MEMORY
C     LOCATIONS
C=======================================================================
C
      IBINOM(0,0)=1
      IBINOM(1,0)=1
      IBINOM(0,1)=1
      IBINOM(1,1)=1
C
      DO N=2,NDMULT
C
         IBINOM(N,0)=1
         IBINOM(0,N)=1
C
         DO K=1,N-1
C
            IBINOM(N,K)=IBINOM(N-1,K-1)+IBINOM(N-1,K)
            IBINOM(K,N)=IBINOM(N,K)
C
            IF (IBINOM(N,K).LT.0) THEN
C
                WRITE(NFIPRI,'(/,
     *                     1X,24(1H/),2X,''INTEGER OVERFLOW IN DEFBIN'',
     *                                                     2X,24(1H/),/,
     *                     1X,24(1H/),2X,''IBINOM MATRIX HAS NOT BEEN'',
     *                                                     2X,24(1H/),/,
     *                     1X,24(1H/),2X,''CALCULATED FOR N='',I3,
     *                                                 '' K='',I3,
     *                                                     2X,24(1H/),/,
     *                     1X,24(1H/),2X,''DECREASE  NDMULT PARAMETER'',
     *                                                     2X,24(1H/))')
     *          N,K
C
                STOP ' INTEGER OVERFLOW IN DEFBIN, NDMULT TOO LARGE'
C
            END IF
C
C           PRINT *,N,K,IBINOM(N,K)
C
         END DO
C
         IBINOM(N,N)=1
C
      END DO
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE DEFBIR
C=======================================================================
      USE hfodd_sizes
C=======================================================================
#if(SWITCH_QUAD==1)
        REAL*16
     *          RBINOM
#endif
C
      COMMON
     *       /NEWBIR/ RBINOM(0:NDBINO,0:NDBINO)
      COMMON
     *       /CFIPRI/ NFIPRI
C
C=======================================================================
C     THIS SUBROUTINE DEFINES THE NEWTON BINOMIAL REAL  COEFFICIENTS:
C     RBINOM(N,K)=N!/(K!(N-K)!)
C     COEFFICIENTS ARE SYMMETRIZED IN ORDER TO FILL IN ALL THE MEMORY
C     LOCATIONS
C=======================================================================
C
      RBINOM(0,0)=1
      RBINOM(1,0)=1
      RBINOM(0,1)=1
      RBINOM(1,1)=1
C
      DO N=2,NDBINO
C
         RBINOM(N,0)=1
         RBINOM(0,N)=1
C
         DO K=1,N-1
C
            RBINOM(N,K)=RBINOM(N-1,K-1)+RBINOM(N-1,K)
            RBINOM(K,N)=RBINOM(N,K)
C
            IF (RBINOM(N,K).LT.0) THEN
C
                WRITE(NFIPRI,'(/,
     *                     1X,24(1H/),2X,''REAL  OVERFLOW  IN  DEFBIR'',
     *                                                     2X,24(1H/),/,
     *                     1X,24(1H/),2X,''RBINOM MATRIX HAS NOT BEEN'',
     *                                                     2X,24(1H/),/,
     *                     1X,24(1H/),2X,''CALCULATED FOR N='',I3,
     *                                                 '' K='',I3,
     *                                                     2X,24(1H/),/,
     *                     1X,24(1H/),2X,''DECREASE  NDMAIN PARAMETER'',
     *                                                     2X,24(1H/))')
     *          N,K
C
                STOP ' REAL OVERFLOW IN DEFBIR, NDMAIN TOO LARGE'
C
            END IF
C
C           PRINT *,N,K,RBINOM(N,K)
C
         END DO
C
         RBINOM(N,N)=1
C
      END DO
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE DEFFAC
C=======================================================================
      USE hfodd_sizes
C=======================================================================
#if(SWITCH_QUAD==1)
      REAL*16
     *          FACTOR,FACTOE,FACTOO
#endif
C
      COMMON
     *       /RFACTO/ FACTOR(0:NDFACR)
      COMMON
     *       /EFACTO/ FACTOE(0:NDFACR),FACTOO(0:NDFACR)
      COMMON
     *       /CFIPRI/ NFIPRI
C
C=======================================================================
C     THIS SUBROUTINE DEFINES FACTORIALS
C=======================================================================
C
C=======================================================================
C            ATTENTION: IN VERSIONS FROM 2.31L TO 2.32E,  THE  PARAMETER
C                       "NDFACR" ABOVE DID NOT DEPEND ON THE  PARAMETERS
C                       "NDXHRM,NDYHRM,NDZHRM". THIS BUG  WAS  CORRECTED
C                       ON  31/01/2008 IN VERSION (2.32F).
C=======================================================================
C
      FACTOR(0)=1.0D0
      FACTOE(0)=1.0D0
      FACTOO(0)=1.0D0
C
      DO I=1,NDFACR
C
         FACTOR(I)=FACTOR(I-1)*REAL(I,KIND=8)
         FACTOE(I)=FACTOE(I-1)*REAL(2*I,KIND=8)
         FACTOO(I)=FACTOO(I-1)*REAL(2*I-1,KIND=8)
C
         IF (FACTOR(I).LT.0.OR.FACTOE(I).LT.0.OR.FACTOO(I).LT.0) THEN
C
             WRITE(NFIPRI,'(/,
     *                  1X,24(1H/),2X,''REAL  OVERFLOW  IN  DEFFAC'',
     *                                                  2X,24(1H/),/,
     *                  1X,24(1H/),2X,''FACTORIALS MATRIX HAVE NOT'',
     *                                                  2X,24(1H/),/,
     *                  1X,24(1H/),2X,''BEEN CALCULATED FOR I ='',I3,
     *                                                  2X,24(1H/),/,
     *                  1X,24(1H/),2X,''FACTOR(I) = '',E14.7,
     *                                                  2X,24(1H/),/,
     *                  1X,24(1H/),2X,''FACTOE(I) = '',E14.7,
     *                                                  2X,24(1H/),/,
     *                  1X,24(1H/),2X,''FACTOO(I) = '',E14.7,
     *                                                  2X,24(1H/),/,
     *                  1X,24(1H/),2X,''DECREASE NDXHRM, OR NDYHRM'',
     *                                                  2X,24(1H/),/,
     *                  1X,24(1H/),2X,''NDZHRM OR NDMAIN PARAMETER'',
     *                                                  2X,24(1H/))')
     *       I,FACTOR(I),FACTOE(I),FACTOO(I)
C
             STOP ' REAL OVERFLOW IN DEFFAC, NDMAIN TOO LARGE'
C
         END IF
C
C        PRINT *,I,FACTOR(I),FACTOE(I),FACTOO(I)
C
      END DO
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE DEFGAU
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      COMMON
     *       /INTGAU/ GAUINT(0:2*NDMULT),
     *                GAUMUL(0:NDMULT)
C
C=======================================================================
C     THIS ROUTINE CALCULATES THE INTEGRALS  X**I * EXP(-X**2)
C     IN THE RANGE (-INF,INF) AND  STORES  THEM  IN  GAUINT(I)
C     IT ALSO CALCULATES THE INTEGRALS R**(2*L+2) * EXP(-R**2)
C     IN THE  RANGE  (0,INF)  AND  STORES  THEM  IN  GAUMUL(L)
C=======================================================================
C
      GAUINT(0)=SQRT(4.0D0*ATAN(1.0D0))
      GAUINT(1)=0.0D0
C
      DO I=2,2*NDMULT
C
         GAUINT(I)=0.5D0*(I-1)*GAUINT(I-2)
C
      END DO
C
C=======================================================================
C
      GAUMUL(0)=SQRT(4.0D0*ATAN(1.0D0))/4.0D0
C
      DO L=1,NDMULT
C
         GAUMUL(L)=0.5D0*(2*L+1)*GAUMUL(L-1)
C
      END DO
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE CNVRGE(ESTABN,EPSITE,IS_YES,ITERUN,NULAST)
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      COMMON
     *       /KOUNTG/ STABIT(1:NDITER)
C
C=======================================================================
C        THIS ROUTINE IS HELPING TO ACHIEVE  THE  PRESCRIBED ACCURACY
C        IN TERMS OF THE "FUNCTIONAL-S.P.SUMM" CRITERION.
C
C        THE PRINCIPLE: IF THE ABSOLUTE VALUE OF THE ABOVE DIFFERENCE
C        IS SMALLER THAN THE PRESCRIBED VALUE (EPSITE), THEN THE NEXT
C        ITERATION IS IN PRINCIPLE UNNECESSARY. IN "PRACTICE" HOWEVER
C        THE ABOVE DIFERENCE  MAY FLUCTUATE AS A FUNCTION OF THE ITE-
C        RATION NUMBER,  AND THUS  THE SIMPLE CUTTING  THE ITERATIONS
C        WOULD BE PREMATURE.  THIS ROUTINE SHOULD THEREFORE CHECK, IF
C        THE ABOVE DIFFERENCE IS SMALLER  THAN "EPSITE" OVER "NULAST"
C        CONSECUTIVE ITERATIONS. "NULAST" IS READ FROM THE INPUT.
C=======================================================================
C
      STABIT(ITERUN)=ESTABN
C
      IF (ITERUN.GE.NULAST.AND.EPSITE.GT.0.0) THEN
C
          IS_YES=1
C
          DO I=ITERUN,ITERUN-NULAST+1,-1
C
             IF (ABS(STABIT(I)).GT.EPSITE) IS_YES=0
C
          END DO
C
      ELSE
C
          IS_YES=0
C
      END IF
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE PINGPO(EPSPNG,IS_PIN,ITERUN,NUPING)
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      COMMON
     *       /KOUNTG/ STABIT(1:NDITER)
C
C=======================================================================
C        THIS ROUTINE IS CHECKING WHETHER THE ITERATION JUMPS BACK
C        AND FORTH BETWEEN TWO SOLUTIONS (PING-PONG CONDITION).
C=======================================================================
C
      IF (ITERUN.GE.2*NUPING.AND.EPSPNG.GT.0.0) THEN
C
          IS_PIN=0
C
          AVREVE=0.0D0
          AVRODD=0.0D0
          DISEVE=0.0D0
          DISODD=0.0D0
C
          DO I=ITERUN,ITERUN-2*NUPING+1,-2
C
             AVREVE=AVREVE+STABIT(I)
             AVRODD=AVRODD+STABIT(I-1)
C
          END DO
C
          AVREVE=AVREVE/NUPING
          AVRODD=AVRODD/NUPING
C
          DO I=ITERUN,ITERUN-2*NUPING+1,-2
C
             DISEVE=DISEVE+(STABIT(I)  -AVREVE)**2
             DISODD=DISODD+(STABIT(I-1)-AVRODD)**2
C
          END DO
C
          DISEVE=SQRT(DISEVE/NUPING)
          DISODD=SQRT(DISODD/NUPING)
C
          IF (DISEVE.LT.EPSPNG*ABS(AVREVE-AVRODD).AND.
     *        DISODD.LT.EPSPNG*ABS(AVREVE-AVRODD)     ) IS_PIN=1
C
      ELSE
C
          IS_PIN=0
C
      END IF
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE CHAODI(IS_CHA,ITERUN,NUCHAO)
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      COMMON
     *       /KOUNTG/ STABIT(1:NDITER)
C
C=======================================================================
C        THIS ROUTINE IS CHECKING WHETHER THE ITERATION DIVERGES
C        BY JUMPING CHAOTICALLY.
C=======================================================================
C
      IF (ITERUN.GE.2.AND.NUCHAO.GT.0) THEN
C
          IS_CHA=0
          I_INCR=0
          NUMAXI=-1
          STAMAX=0.0
C
          DO I=2,ITERUN
C
             IF (I_INCR.EQ.0) THEN
C
                 IF (ABS(STABIT(I)).GT.ABS(STABIT(I-1))) I_INCR=1
C
             ELSE
C
                 IF (ABS(STABIT(I)).LT.ABS(STABIT(I-1))) THEN
C
                     IF (ABS(STABIT(I-1)).GT.STAMAX) NUMAXI=NUMAXI+1
C
                     IF (NUMAXI.GE.NUCHAO) IS_CHA=1
C
                     STAMAX=ABS(STABIT(I-1))
C
                     I_INCR=0
C
                 END IF
C
             END IF
C
         END DO
C
      ELSE
C
          IS_CHA=0
C
      END IF
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE INFPRI(IN_FIX,IZ_FIX,
     *                         NUMCOU,NUMETA,FURMAX,
     *                         ICOTYP,ICOUDI,ICOUEX,
     *                  PIMASS,PNMASS,IYUTYP,I_YUKA,
     *                  YUKAGT,YUKAG0,YUKAG1,YUKAG2,
     *                                I_GOGA,IGOGPA,
     *                  NUCHAO,NUPING,EPSPNG,EPSITE,
     *                                NOITER,NULAST,
     *                  DELFIN,DELFIP,IDEFIN,IDEFIP,
     *                  FERFIN,FERFIP,IFEFIN,IFEFIP,
     *                  FE2FIN,FE2FIP,IF2FIN,IF2FIP,
     *                  INSIGN,IPSIGN,ISSIGN,IDSIGN,
     *                  INSIGP,IPSIGP,ISSIGP,IDSIGP,
     *                         INSIMN,IRSIMN,IDSIMN,
     *                         INSIMP,IRSIMP,IDSIMP,
     *                         INSIQN,IPSIQN,IDSIQN,
     *                         INSIQP,IPSIQP,IDSIQP,
     *                                INSIZN,IDSIZN,
     *                                INSIZP,IDSIZP,
     *                                IFIBLN,INIBLN,
     *                                IFIBLP,INIBLP,
     *                                ECUTOF,LIMQUA,
     *                  ISPHER,ISIMPY,ISIGNY,ISIQTY,
     *                         ISIMTX,JSIMTY,ISIMTZ,
     *                  ISYMDE,INIROT,INIINV,INIKAR,
     *                         IRENMA,IRENIN,IDOGOA,
     *                                JETACM,KETA_R,
     *                         IFRWAV,ITOWAV,IWRWAV,
     *                                ISAKER,ICHKER,
     *                         IPRGCM,IPROMI,IPROMA,
     *                         NUAKNO,NUBKNO,KPROJE,
     *                                       NBTKNO,
     *                  ISOSMI,ISOSMA,EPSISO,ICSKIP,
     *                                       IFERME,
     *                         IPAKER,IPAALL,KFIKER,
     *                  NUASTA,NUASTO,NUGSTA,NUGSTO,
     *                  NUBSTA,NUBSTO,NUTSTA,NUTSTO,
     *                                ISLPRI,ISUPRI,
     *                         IENPRI,ISRPRI,IMIPRI,
     *                                IKEPRI,IRMPRI,
     *                         QMUCUT,QMACUT,QSICUT,
     *                  IMOVAX,ITILAX,ITISAX,NO_ORB,
     *                         IPRSTA,IPRMID,IPRSTO,
     *                  IDESTA,IDEMID,IDESTO,IDEDIS,
     *                                INTRIP,IVIPRI,
     *                         IPRI_N,IPRI_P,IPRI_T,
     *           IPAIRI,IPAHFB,ITWOBA,JPABCS,IMFHFB,
     *                                LIPKIN,LIPKIP,
     *                                       NILXYZ,
     *                                       IROTAT,
     *                         NMUCON,NMUCOU,NMUPRI,
     *                  ISCHIF,NSIMAX,NSICON,NSIPRI,
     *                                       IDOPLM,
     *                         NMAMAX,NMACON,NMAPRI,
     *                         NMURED,NMARED,NSIRED,
     *                  SLOWEV,SLOWOD,SLOWPA,SLOWLI,
     *                         ICONTI,IPCONT,IOCONT,
     *                  IACONT,IYCONT,IGCONT,IGPCON,
     *                  ILCONT,IFCONT,IMCONT,IRCONT,
     *                                       IPOTHO,
     *                         BOUCOU,IFSHEL,IF_RPA,
     *                         L_COLL,M_COLL,N_COLL)
C=======================================================================
      USE hfodd_sizes
C=======================================================================
C
      CHARACTER
     *          NONYES(0:1)*3,NO_YES(0:1)*3,EPSITC*8,KARDIR(3)*1
      CHARACTER
     *          IFTIMR(-1:1)*26
      CHARACTER
     *          LPROMI*5,LPROMA*5,LPROJE*5,CURCOL*5,COLMUL*5
      CHARACTER
     *          NAMINV(0:3,0:3)*43
      CHARACTER
     *          FFRGCM*3,FTOGCM*3
      CHARACTER
     *          YUKACT*7,YUKAC0*7,YUKAC1*7,YUKAC2*7
C
      DIMENSION
     *          COLMUL(1:9)
C
C=======================================================================
      INTEGER, DIMENSION(:), POINTER :: L_COLL, M_COLL
C=======================================================================
      COMMON
     *       /QCNSTR/ STIFFQ(0:NDMULT,-NDMULT:NDMULT),
     *                QASKED(0:NDMULT,-NDMULT:NDMULT),
     *                IFLAGQ(0:NDMULT,-NDMULT:NDMULT)
      COMMON
     *       /SCNSTR/ STIFFS(0:NDMULT,-NDMULT:NDMULT),
     *                SASKED(0:NDMULT,-NDMULT:NDMULT),
     *                IFLAGS(0:NDMULT,-NDMULT:NDMULT)
      COMMON
     *       /GCNSTR/ STIFFG(0:NDMULT),
     *                GASKED(0:NDMULT),
     *                IFLAGG(0:NDMULT)
      COMMON
     *       /QLASTR/ GALMUQ(0:NDMULT,-NDMULT:NDMULT),
     *                QLINEA(0:NDMULT,-NDMULT:NDMULT),
     *                IFLALQ(0:NDMULT,-NDMULT:NDMULT)
      COMMON
     *       /SLASTR/ GALMUS(0:NDMULT,-NDMULT:NDMULT),
     *                SLINEA(0:NDMULT,-NDMULT:NDMULT),
     *                IFLALS(0:NDMULT,-NDMULT:NDMULT)
      COMMON
     *       /SPNUMS/ NUMBSP(0:NDREVE,0:NDISOS)
      COMMON
     *       /ICNSTR/ STIFFI(1:NDKART),
     *                ASKEDI(1:NDKART),
     *                IFLAGI(1:NDKART)
      COMMON
     *       /ACNSTR/ STIFFA,ASKEDA,IFLAGA
      COMMON
     *       /PAIINI/ FERINI(0:NDISOS),DELINI(0:NDISOS),FE2INI(0:NDISOS)
      COMMON
     *       /CCPPAI/ PRHO_N,PRHODN,PRHOSN,POWERN,
     *                PRHO_P,PRHODP,PRHOSP,POWERP
      COMMON
     *       /OMEGAS/ OMEGAX,OMEGAY,OMEGAZ
      COMMON
     *       /OMISOS/ OMISOX,OMISOY,OMISOZ
      COMMON
     *       /IANGLE/ ALPINI,BETINI,GAMINI
      COMMON
     *       /DATPAN/ GPAIRN,FACTGN,EFERMN,DELTAN,EFER2N
     *       /DATPAP/ GPAIRP,FACTGP,EFERMP,DELTAP,EFER2P
      COMMON
     *       /DISTAN/ DISTAX,DISTAY,DISTAZ
      COMMON
     *       /ROTATT/ ROTATX,ROTATY,ROTATZ
      COMMON
     *       /RINORM/ HBMRIN(NDKART)
      COMMON
     *       /RINROT/ ROTRIN(NDKART)
      COMMON
     *       /CFIPRI/ NFIPRI
C@@@ SHELL - SHELL - SHELL - SHELL - SHELL - SHELL - SHELL - SHELL
      COMMON
     *       /STRUTI_PARAMS/ GSTRUN,GSTRUP,HOMFAC,EPSRTN
     *       /STRUTI_POLYNO/ NPOLYN
C@@@ SHELL - SHELL - SHELL - SHELL - SHELL - SHELL - SHELL - SHELL
C
      COMMON
     *       /BROINI/ IBROYD,N_ITER
     *       /BROMIX/ ALPHAM,BROTRI
     *       /BROMAT/ NOIINP,MIXMAT
C
C@@@ TEMP -TEMP - TEMP - TEMP - TEMP - TEMP - TEMP - TEMP - TEMP - TEMP
      COMMON
     *       /GCTEMP/ TEMP_T
C@@@ TEMP -TEMP - TEMP - TEMP - TEMP - TEMP - TEMP - TEMP - TEMP - TEMP
C@@@ NECK - NECK - NECK - NECK - NECK - NECK - NECK - NECK - NECK
      COMMON
     *       /NCKVAL/ Q0NECK,G_NECK
     *       /NCKFLA/ IFNECK
C@@@ NECK - NECK - NECK - NECK - NECK - NECK - NECK - NECK - NECK
      DATA
     *       NONYES /'NON','   '/,
     *       NO_YES /' NO','YES'/
      DATA
     *       IFTIMR /'(TIME-REVERSED STATE USED)',
     *               '                          ',
     *               '                          '/
      DATA
     *       KARDIR /'X','Y','Z'/
      DATA
     *       NAMINV /'                                           ',
     *               ' SPATIAL INVERSION OF ALL 3 COORDINATE AXES',
     *               ' TIME-REVERSAL (CC. PLUS INVERSION OF SPIN)',
     *               ' TIME-REVERSAL TIMES  THE SPATIAL INVERSION',
     *
     *               ' ROTATION BY PI ABOUT X AXIS  (X-SIGNATURE)',
     *               ' REFLECTION WRT THE  Y-Z  PLANE (X-SIMPLEX)',
     *               ' TIME-REVERSAL TIMES RX(PI) (X-SIGNATURE-T)',
     *               ' TIME-REVERSAL TIMES Y-Z REFL (X-SIMPLEX-T)',
     *
     *               ' ROTATION BY PI ABOUT Y AXIS  (Y-SIGNATURE)',
     *               ' REFLECTION WRT THE  X-Z  PLANE (Y-SIMPLEX)',
     *               ' TIME-REVERSAL TIMES RY(PI) (Y-SIGNATURE-T)',
     *               ' TIME-REVERSAL TIMES X-Z REFL (Y-SIMPLEX-T)',
     *
     *               ' ROTATION BY PI ABOUT Z AXIS  (Z-SIGNATURE)',
     *               ' REFLECTION WRT THE  X-Y  PLANE (Z-SIMPLEX)',
     *               ' TIME-REVERSAL TIMES RZ(PI) (Z-SIGNATURE-T)',
     *               ' TIME-REVERSAL TIMES X-Y REFL (Z-SIMPLEX-T)'/
C
C=======================================================================
C
      WRITE(NFIPRI,'(79(1H*),/,                         1H*,77X,1H*,/,
     *                 1H*,1X,''NUCLIDE: N ='',I4,2X,''Z ='',I4,2X,
     *                        ''NUMBER OF ITERATIONS ='',I5,3X,
     *                        ''CONTINUATION? ='',I2,        2X,1H*,/,
     *                                                  1H*,77X,1H*)')
     *
     *    IN_FIX,IZ_FIX,NOITER,ICONTI
C
C=======================================================================
C
      IF (IN_FIX.EQ.0) THEN
C
          WRITE(NFIPRI,'(79(1H*),/,                     1H*,77X,1H*,/,
     *                 1H*,1X,''ATTENTION! THIS RUN IS PERFORMED '',
     *                        ''WITHOUT ANY CALCULATIONS FOR '',
     *                        ''**NEUTRONS**'',2X,1H*,/,
     *                                                  1H*,77X,1H*)')
C
      END IF
C
C=======================================================================
C
      IF (IZ_FIX.EQ.0) THEN
C
          WRITE(NFIPRI,'(79(1H*),/,                     1H*,77X,1H*,/,
     *                 1H*,1X,''ATTENTION!! THIS RUN IS PERFORMED '',
     *                        ''WITHOUT ANY CALCULATIONS FOR '',
     *                        ''**PROTONS**'',2X,1H*,/,
     *                                                  1H*,77X,1H*)')
C
      END IF
C
C=======================================================================
C
      IF (IPOTHO.EQ.1) THEN
C
          WRITE(NFIPRI,'(79(1H*),/,                     1H*,77X,1H*,/,
     *                 1H*,1X,''HARMONIC-OSCILLATOR POTENTIAL IS '',
     *                        ''INCLUDED AS AN EXTERNAL FIELD '',
     *                        ''IN THIS RUN'',2X,1H*,/,
     *                                                  1H*,77X,1H*)')
C
      END IF
C
C=======================================================================
C
      IF (EPSITE.GT.0.0) THEN
C
          IF (EPSITE.GE.1E-6.AND.EPSITE.LT.10) THEN
C
              WRITE(EPSITC,'(F8.6)')     EPSITE
          ELSE
              WRITE(EPSITC,'((1PE8.1))') EPSITE
C
          END IF
C
          WRITE(NFIPRI,'(79(1H*),/,                     1H*,77X,1H*,/,
     *                 1H*,1X,''ITERATIONS WILL STOP WHEN THE '',
     *                        ''STABILITY BECOMES LOWER THAN EPSITE='',
     *                                                    A8,2X,1H*,/,
     *                 1H*,1X,''                              '',
     *                        ''             FOR'',I5,
     *                        '' CONSECUTIVE ITERATIONS'',   2X,1H*,/,
     *                                                  1H*,77X,1H*)')
     *
     *    EPSITC,NULAST
C
      END IF
C
C=======================================================================
C
      IF (EPSPNG.GT.0.0) THEN
C
          WRITE(NFIPRI,'(79(1H*),/,                     1H*,77X,1H*,/,
     *                 1H*,1X,''ITERATIONS WILL STOP WHEN THE '',
     *                        ''PING-PONG DIVERGENCE OCCURS FOR '',
     *                        ''EPSPNG='',F5.3,2X,1H*,/,
     *                 1H*,1X,''                              '',
     *                        '' DURING'',I5,'' PAIRS OF'',
     *                        '' CONSECUTIVE ITERATIONS'',   2X,1H*,/,
     *                                                  1H*,77X,1H*)')
     *
     *    EPSPNG,NUPING
C
      END IF
C
C=======================================================================
C
      IF (NUCHAO.GT.0) THEN
C
          WRITE(NFIPRI,'(79(1H*),/,                     1H*,77X,1H*,/,
     *                 1H*,1X,''ITERATIONS WILL STOP WHEN THE '',
     *                        ''CHAOTIC-DIVERGENCE CONDITION OCCURS'',
     *                                         I4,'' TIMES'',1X,1H*,/,
     *                                                  1H*,77X,1H*)')
     *
     *    NUCHAO
C
      END IF
C
C=======================================================================
C
      WRITE(NFIPRI,'(79(1H*),/,                      1H*,77X,1H*,/,
     *                 1H*,1X,''SLOW-DOWN PARAMETERS: '',54X,1H*,/,
     *                 1H*,1X,''TIME-EVEN ='',    F5.2,3X,
     *                        ''TIME-ODD ='',     F5.2,3X,
     *                        ''PAIRING ='',      F5.2,3X,
     *                        ''LIPKIN-NOGAMI ='',F5.2,2X,   1H*,/,
     *                                               1H*,77X,1H*)')
     *
     *    SLOWEV,SLOWOD,SLOWPA,SLOWLI
C
C=======================================================================
C
      IF (IBROYD.LT.1) THEN
C
          WRITE(NFIPRI,'(79(''*''),/,''*'',77X,''*'',/,
     *             ''* BROYDEN METHOD IS:  OFF'',53X,''*'',/,
     *             ''*'',77X,''*'',/,
     *             ''*    ITERATIONS WILL PROCEED BY STANDARD '',
     *             ''LINEAR MIXING WITH SLOWING FACTORS   *'',/,
     *             ''*    DISPLAYED EARLIER                         '',
     *             ''                               *'',/,
     *             ''*'',77X,''*'')')
C
      END IF
C
      IF (IBROYD.EQ.1) THEN
C
          WRITE(NFIPRI,'(79(''*''),/,''*'',77X,''*'',/,
     *             ''* ACCELERATION IS:   ON  - METHOD:    BROYDEN'',
     *             34X,''*'',/,
     *             ''*'',77X,''*'',/,''*    TRIGGERED ONLY WHEN '',
     *             ''STABILITY IS LOWER THAN : '',F9.3,
     *             '' MEV              *'',/,
     *             ''*    INITIAL SLOWING FACTOR (BEFORE TRIGGER)'',
     *             ''     :   '',F6.2,'' (=SLOWEV)         *'',/,
     *             ''*    BROYDEN SLOWING FACTOR (AFTER  TRIGGER)'',
     *             ''     :   '',F6.2,'' (=1-ALPHAM)       *'',/,
     *             ''*    NUMBER OF ITERATIONS RETAINED IN MEMORY'',
     *             ''     :    '',I2,''                      *'',/
     *             ''*'',77X,''*'')')
     *
     *               BROTRI,SLOWEV,1.0-ALPHAM,N_ITER
C
      END IF
C
      IF (IBROYD.EQ.2) THEN
C
          WRITE(NFIPRI,'(79(''*''),/,''*'',77X,''*'',/,
     *             '' ACCELERATION IS:   ON  - METHOD:   ANDERSON'',
     *             34X,''*'',/,
     *             ''*'',77X,''*'',/,''*    TRIGGERED ONLY WHEN '',
     *             ''STABILITY IS LOWER THAN : '',F9.3,
     *             '' MEV              *'',/,
     *             ''*    NUMBER OF ITERATIONS RETAINED IN MEMORY'',
     *             ''     :    '',I2,''                      *'',/
     *             ''*'',77X,''*'')')
     *
     *               BROTRI,N_ITER
C
      END IF
C
      IF (MIXMAT.EQ.1)
     *    WRITE(NFIPRI,'(79(1H*),/,                 1H*,77X,1H*,/,
     *          1H*,'' MIXING OF MATRIX ELEMENTS OF HFB MATRIX'',
     *                                                  37X,1H*,/,
     *                                              1H*,77X,1H*)')
C
C=======================================================================
C
      IF (TEMP_T.GT.0.0)
     *    WRITE(NFIPRI,'(79(''*''),/,''*'',77X,''*'',/,
     *          1H*,'' CALCULATIONS WILL BE PERFORMED AT FINITE '',
     *              ''TEMPERATURE T = '',F6.3,'' MEV'',9X,''*'',/,
     *                                          ''*'',77X,''*'')')
     *                TEMP_T
C
C=======================================================================
C
      IF (IFNECK.EQ.2)
     *    WRITE(NFIPRI,'(79(''*''),/,''*'',77X,''*'',/,
     *              ''* CALCULATIONS WILL BE PERFORMED WITH A '',
     *              ''CONSTRAINT ON THE SIZE OF THE NECK    *'',/,
     *              ''* THE NUMBER OF PARTICLES IN THE NECK '',
     *              ''IS SET TO: '',F8.4,21X,''*'',/,
     *                                          ''*'',77X,''*'')')
     *                Q0NECK
C
C=======================================================================
C
      IF (ICOUDI.EQ.0)
     *    WRITE(NFIPRI,'(79(1H*),/,                 1H*,77X,1H*,/,
     *          1H*,'' DIRECT COULOMB TERMS NEGLECTED IN THIS RUN'',
     *                                                  34X,1H*,/,
     *                                              1H*,77X,1H*)')
C
C=======================================================================
C
      IF (ICOUDI.EQ.1)
     *    WRITE(NFIPRI,'(79(1H*),/,                 1H*,77X,1H*,/,
     *          1H*,'' DIRECT COULOMB TERMS SOLVED BY GREEN FUNCTION'',
     *              '' AND FOURIER TRANSFORM METHOD'',2X,1H*,/,
     *          1H*,'' COULOMB PARAMETERS:'',
     *          ''  NUMCOU ='',I3,  ''  NUMETA ='',I3,
     *          ''  BOUCOU ='',F5.1,''  FURMAX ='',F4.2, 2X,1H*,/,
     *                                              1H*,77X,1H*)')
     *
     *          NUMCOU,NUMETA,BOUCOU,FURMAX
C
C=======================================================================
C
      IF (ICOUDI.EQ.2) THEN
C
          WRITE(NFIPRI,'(79(1H*),/,                   1H*,77X,1H*,/,
     *          1H*,'' DIRECT   COULOMB TERMS SOLVED BY EXPANDING'',
     *              '' POTENTIAL 1/R INTO'',I3,'' GAUSSIANS'',2X,1H*)')
     *
     *          ABS(ICOTYP)
C
          IF (ICOTYP.GT.0) THEN
C
              WRITE(NFIPRI,'(
     *          1H*,'' EXPANSION PARAMETERS CALCULATED BY USING '',
     *              '' THE  GAUSS-LEGENDRE  INTEGRATION'',2X,1H*,/,
     *                                               1H*,77X,1H*)')
          ELSE
              WRITE(NFIPRI,'(
     *          1H*,'' EXPLICIT EXPANSION PARAMETERS USED       '',
     *              ''                                 '',2X,1H*,/,
     *                                            1H*,77X,1H*)')
C
          END IF
C
      END IF
C
C=======================================================================
C
      IF (ICOUEX.EQ.0)
     *    WRITE(NFIPRI,'(79(1H*),/,                 1H*,77X,1H*,/,
     *          1H*,'' EXCHANGE COULOMB TERMS NEGLECTED IN THIS RUN'',
     *                                                  32X,1H*,/,
     *                                              1H*,77X,1H*)')
C
C=======================================================================
C
      IF (ICOUEX.EQ.1)
     *    WRITE(NFIPRI,'(79(1H*),/,                 1H*,77X,1H*,/,
     *          1H*,'' EXCHANGE COULOMB TERMS TREATED BY THE'',
     *              '' SLATER APPROXIMATION'',          18X,1H*,/,
     *                                              1H*,77X,1H*)')
C
C=======================================================================
C
      IF (ICOUEX.EQ.2) THEN
C
          WRITE(NFIPRI,'(79(1H*),/,                   1H*,77X,1H*,/,
     *          1H*,'' EXCHANGE COULOMB TERMS SOLVED BY EXPANDING'',
     *              '' POTENTIAL 1/R INTO'',I3,'' GAUSSIANS'',2X,1H*)')
     *
     *          ABS(ICOTYP)
C
          IF (ICOTYP.GT.0) THEN
C
              WRITE(NFIPRI,'(
     *          1H*,'' EXPANSION PARAMETERS CALCULATED BY USING '',
     *              '' THE  GAUSS-LEGENDRE  INTEGRATION'',2X,1H*,/,
     *                                               1H*,77X,1H*)')
          ELSE
              WRITE(NFIPRI,'(
     *          1H*,'' EXPLICIT EXPANSION PARAMETERS USED       '',
     *              ''                                 '',2X,1H*,/,
     *                                            1H*,77X,1H*)')
C
          END IF
C
      END IF
C
C=======================================================================
C
      IF (I_YUKA.GE.1)
     *    WRITE(NFIPRI,'(79(1H*),/,                       1H*,77X,1H*,/,
     *        1H*, 1X,''AVERAGE VALUES OF THE TIME-REVERSAL-VIOLATING'',
     *             1X,'' YUKAWA  INTERACTION WILL BE'',        2X,1H*,/,
     *        1H*,13X,''CALCULATED USING THE PION MASS OF'',F8.4,
     *             1X,''FM^(-1),'',
     *             1X,''AND TYPE ='',I1,                       2X,1H*,/,
     *                                                    1H*,77X,1H*)')
     *
     *          PIMASS,IYUTYP
C
C=======================================================================
C
      IF (I_YUKA.GE.2) THEN
C
          IF (ABS(YUKAGT).GE.1E-4.OR.YUKAGT.EQ.0.0) THEN
              WRITE(YUKACT,'(''='',F6.4)') YUKAGT
          ELSE
              WRITE(YUKACT,'(A7)')        '<0.0001'
          END IF
C
          IF (ABS(YUKAG0).GE.1E-4.OR.YUKAG0.EQ.0.0) THEN
              WRITE(YUKAC0,'(''='',F6.4)') YUKAG0
          ELSE
              WRITE(YUKAC0,'(A7)')        '<0.0001'
          END IF
C
          IF (ABS(YUKAG1).GE.1E-4.OR.YUKAG1.EQ.0.0) THEN
              WRITE(YUKAC1,'(''='',F6.4)') YUKAG1
          ELSE
              WRITE(YUKAC1,'(A7)')        '<0.0001'
          END IF
C
          IF (ABS(YUKAG2).GE.1E-4.OR.YUKAG2.EQ.0.0) THEN
              WRITE(YUKAC2,'(''='',F6.4)') YUKAG2
          ELSE
              WRITE(YUKAC2,'(A7)')        '<0.0001'
          END IF
C
          WRITE(NFIPRI,'(79(1H*),/,                       1H*,77X,1H*,/,
     *         1H*,1X,''TIME-REVERSAL-VIOLATING YUKAWA  INTERACTION'',
     *             1X,''WILL BE ADDED BEFORE VARIATION'',      2X,1H*,/,
     *         1H*,1X,''FOR THE PION MASS OF'',F8.4,'','',
     *             1X,''NUCLEON MASS OF'',F8.4,'' FM^(-1),'',
     *             1X,''AND TYPE ='',I1,                       2X,1H*,/,
     *         1H*,1X,''TOGETHER WITH COUPLING CONSTANTS OF G'',A7,
     *                                                  '' G0'',A7,
     *                                                  '' G1'',A7,
     *                                                  '' G2'',A7,
     *                                                         2X,1H*,/,
     *                                                    1H*,77X,1H*)')
     *
     *          PIMASS,PNMASS,IYUTYP,YUKACT,YUKAC0,YUKAC1,YUKAC2
C
          IF (I_YUKA.EQ.3)
     *
     *    WRITE(NFIPRI,'(
     *         1H*,1X,''ONLY THE DIRECT TERMS OF THE YUKAWA'',
     *             1X,''INTERACTION WILL BE CONSIDERED'',     10X,1H*,/,
     *                                                    1H*,77X,1H*)')
C
          IF (I_YUKA.EQ.4)
     *
     *    WRITE(NFIPRI,'(
     *         1H*,1X,''ONLY THE EXCHANGE TERMS OF THE YUKAWA'',
     *             1X,''INTERACTION WILL BE CONSIDERED'',      8X,1H*,/,
     *                                                    1H*,77X,1H*)')
C
      END IF
C
C=======================================================================
C
      IF (IYCONT.EQ.1.AND.I_YUKA.GE.2)
     *    WRITE(NFIPRI,'(79(1H*),/,                       1H*,77X,1H*,/,
     *         1H*,1X,''YUKAWA MEAN FIELDS WILL BE READ FROM DISC '',
     *             1X,''IN ORDER TO CONTINUE ITERATIONS'',    2X,1H*,/,
     *                                                    1H*,77X,1H*)')
C
C=======================================================================
C
      IF (IYCONT.EQ.0.AND.I_YUKA.GE.2)
     *    WRITE(NFIPRI,'(79(1H*),/,                       1H*,77X,1H*,/,
     *         1H*,1X,''YUKAWA MEAN FIELDS WILL BE ZEROED BEFORE '',
     *             1X,''STARTING ITERATIONS FOR THIS RUN'',    2X,1H*,/,
     *                                                    1H*,77X,1H*)')
C
C=======================================================================
C
      IF (IGCONT.EQ.1.AND.I_GOGA.GE.2)
     *    WRITE(NFIPRI,'(79(1H*),/,                       1H*,77X,1H*,/,
     *         1H*,1X,''GOGNY  MEAN FIELDS WILL BE READ FROM DISC '',
     *             1X,''IN ORDER TO CONTINUE ITERATIONS'',    2X,1H*,/,
     *                                                    1H*,77X,1H*)')
C
C=======================================================================
C
      IF (IGCONT.EQ.0.AND.I_GOGA.GE.2)
     *    WRITE(NFIPRI,'(79(1H*),/,                       1H*,77X,1H*,/,
     *         1H*,1X,''GOGNY  MEAN FIELDS WILL BE ZEROED BEFORE '',
     *             1X,''STARTING ITERATIONS FOR THIS RUN'',    2X,1H*,/,
     *                                                    1H*,77X,1H*)')
C
C=======================================================================
C
      IF (IGPCON.EQ.1.AND.IGOGPA.GE.2)
     *    WRITE(NFIPRI,'(79(1H*),/,                       1H*,77X,1H*,/,
     *         1H*,1X,''GOGNY PAIRING FIELD WILL BE READ FROM DISC '',
     *                ''IN ORDER TO CONTINUE ITERATIONS'',    1X,1H*,/,
     *                                                    1H*,77X,1H*)')
C
C=======================================================================
C
      IF (IGPCON.EQ.0.AND.IGOGPA.GE.2)
     *    WRITE(NFIPRI,'(79(1H*),/,                       1H*,77X,1H*,/,
     *         1H*,1X,''GOGNY PAIRING FIELD WILL BE ZEROED BEFORE '',
     *             1X,''STARTING ITERATIONS FOR THIS RUN'',    1X,1H*,/,
     *                                                    1H*,77X,1H*)')
C
C=======================================================================
C
      IF (IFCONT.EQ.1)
     *    WRITE(NFIPRI,'(79(1H*),/,                       1H*,77X,1H*,/,
     *         1H*,1X,''MEAN-FIELD MATRIX ELEMENTS WILL BE  READ '',
     *             1X,''FROM DISC TO CONTINUE ITERATIONS'',   2X,1H*,/,
     *                                                    1H*,77X,1H*)')
C
C=======================================================================
C
      IF (IMCONT.EQ.1)
     *    WRITE(NFIPRI,'(79(1H*),/,                       1H*,77X,1H*,/,
     *         1H*,1X,''THE AVERAGE LINEAR MOMENTA WILL BE  READ '',
     *             1X,''FROM DISC TO CONTINUE ITERATIONS'',   2X,1H*,/,
     *                                                    1H*,77X,1H*)')
C
C=======================================================================
C
      IF (IRCONT.EQ.1)
     *    WRITE(NFIPRI,'(79(1H*),/,                       1H*,77X,1H*,/,
     *         1H*,1X,''THE AVERAGE ANGULAR MOMENTA WILL BE READ '',
     *             1X,''FROM DISC TO CONTINUE ITERATIONS'',   2X,1H*,/,
     *                                                    1H*,77X,1H*)')
C
C=======================================================================
C
      IF (I_GOGA.GE.1)
     *    WRITE(NFIPRI,'(79(1H*),/,                       1H*,77X,1H*,/,
     *        1H*, 1X,''AVERAGE VALUES OF THE FINITE-RANGE GOGNY'',
     *             1X,''INTERACTION WILL BE CALCULATED'',      5X,1H*,/,
     *                                                    1H*,77X,1H*)')
C
C=======================================================================
C
      IF (IGOGPA.GE.1)
     *    WRITE(NFIPRI,'(79(1H*),/,                       1H*,77X,1H*,/,
     *        1H*, 1X,''PAIRING ENERGY OF THE FINITE-RANGE GOGNY'',
     *             1X,''INTERACTION WILL BE CALCULATED'',      5X,1H*,/,
     *                                                    1H*,77X,1H*)')
C
C=======================================================================
C
      IF (I_GOGA.GE.2.OR.IGOGPA.GE.2) THEN
C
          WRITE(NFIPRI,'(79(1H*),/,                       1H*,77X,1H*,/,
     *         1H*,1X,''FINITE-RANGE GOGNY INTERACTION WILL BE'',
     *             1X,''TREATED SELF-CONSISTENTLY'',          12X,1H*,/,
     *                                                    1H*,77X,1H*)')
C
          IF (I_GOGA.EQ.3)
     *
     *    WRITE(NFIPRI,'(
     *         1H*,1X,''ONLY THE DIRECT TERMS OF THE GOGNY'',
     *             1X,''INTERACTION WILL BE CONSIDERED'',     11X,1H*,/,
     *                                                    1H*,77X,1H*)')
C
          IF (I_GOGA.EQ.4)
     *
     *    WRITE(NFIPRI,'(
     *         1H*,1X,''ONLY THE EXCHANGE TERMS OF THE GOGNY'',
     *             1X,''INTERACTION WILL BE CONSIDERED'',      9X,1H*,/,
     *                                                    1H*,77X,1H*)')
C
      END IF
C
C=======================================================================
C
      WRITE(NFIPRI,'(79(1H*),/,                           1H*,77X,1H*,/,
     *          1H*, 1X,''MAXIMUM NUMBERS OF MULTIPOLE MOMENTS USED'',
     *               1X,''FOR THE CONSTRAINTS,    NMUCON='',I1,2X,1H*,/,
     *          1H*,43X,''FOR THE COULOMB FIELD,  NMUCOU='',I1,2X,1H*,/,
     *          1H*,43X,''FOR THE OUTPUT INFO,    NMUPRI='',I1,2X,1H*,/,
     *                                                    1H*,77X,1H*)')
     *
     *          NMUCON,NMUCOU,NMUPRI
C
C=======================================================================
C
      ITITLE=0
C
      DO LAMBDA=1,NMUCON
         DO MIU=-LAMBDA,LAMBDA
C
            IF (IFLAGQ(LAMBDA,MIU).EQ.1) THEN
C
                IF (ITITLE.EQ.0) THEN
C
                    WRITE(NFIPRI,'(79(1H*),/,1H*,77X,1H*,/,
     *                    1H*,1X,''MULTIPOLE CONSTRAINTS: '',
     *                           ''LAMBDA='',I2,''  MIU='',I2,2X,
     *                           ''MOMENT='',F7.3,2X,
     *                           ''STIFFNESS='',F6.3,     2X,1H*)')
     *
     *              LAMBDA,MIU,QASKED(LAMBDA,MIU),STIFFQ(LAMBDA,MIU)
C
                    ITITLE=1
C
                ELSE
C
                    WRITE(NFIPRI,'(1H*,1X,''                       '',
     *                           ''LAMBDA='',I2,''  MIU='',I2,2X,
     *                           ''MOMENT='',F7.3,2X,
     *                           ''STIFFNESS='',F6.3,     2X,1H*)')
     *
     *              LAMBDA,MIU,QASKED(LAMBDA,MIU),STIFFQ(LAMBDA,MIU)
C
                END IF
C
            END IF
C
         END DO
      END DO
C
      IF (ITITLE.EQ.1) WRITE(NFIPRI,'(1H*,77X,1H*)')
C
C=======================================================================
C
      ITITLE=0
C
      DO LAMBDA=1,NMUCON
         DO MIU=-LAMBDA,LAMBDA
C
            IF (IFLALQ(LAMBDA,MIU).EQ.-1) THEN
C
                IF (ITITLE.EQ.0) THEN
C
                    WRITE(NFIPRI,'(79(1H*),/,1H*,77X,1H*,/,
     *                    1H*,1X,''LINEAR MULTIPOLE CONSTRAINTS: '',
     *                           ''LAMBDA='',I2,''  MIU='',I2,2X,
     *                           ''PARAMETERS '',
     *                           ''USED= '',F8.3,     2X,1H*)')
     *
     *              LAMBDA,MIU,QLINEA(LAMBDA,MIU)
C
                    ITITLE=1
C
                ELSE
C
                    WRITE(NFIPRI,'(
     *                    1H*,1X,''                              '',
     *                           ''LAMBDA='',I2,''  MIU='',I2,2X,
     *                           ''PARAMETERS '',
     *                           ''USED ='',F8.3,     2X,1H*)')
     *
     *              LAMBDA,MIU,QLINEA(LAMBDA,MIU)
C
                END IF
C
            END IF
C
         END DO
      END DO
C
      IF (ITITLE.EQ.1) WRITE(NFIPRI,'(1H*,77X,1H*)')
C
C=======================================================================
C
      ITITLE=0
C
      DO LAMBDA=1,NMUCON
         DO MIU=-LAMBDA,LAMBDA
C
C=======================================================================
C            ATTENTION: IN VERSIONS FROM 2.49N TO 2.66A,  THE  CONDITION
C                       BELOW WAS DEPENDING  ON  "ICONTI"  AND  NOT   ON
C                       "IACONT" AND THUS FOR ICONTI=1 AND IACONT=0  THE
C                       INITIALIZED LAGRANGE PARAMETERS WERE NOT PRINTED
C                       THIS BUG WAS CORRECTED ON 30/07/2013 IN  VERSION
C                       (2.66B).
C=======================================================================
C
            IF (IFLALQ(LAMBDA,MIU).EQ.1.AND.IACONT.NE.1) THEN
C
                IF (ITITLE.EQ.0) THEN
C
                    WRITE(NFIPRI,'(79(1H*),/,1H*,77X,1H*,/,
     *                    1H*,1X,''AUGMENTED MULTIPOLE CONSTRAINTS: '',
     *                           ''LAMBDA='',I2,''  MIU='',I2,2X,
     *                           ''INIT. LAGR. '',
     *                           ''PAR='',F6.3,     2X,1H*)')
     *
     *              LAMBDA,MIU,QLINEA(LAMBDA,MIU)
C
                    ITITLE=1
C
                ELSE
C
                    WRITE(NFIPRI,'(
     *                    1H*,1X,''                                 '',
     *                           ''LAMBDA='',I2,''  MIU='',I2,2X,
     *                           ''INIT. LAGR. '',
     *                           ''PAR='',F6.3,     2X,1H*)')
     *
     *              LAMBDA,MIU,QLINEA(LAMBDA,MIU)
C
                END IF
C
            END IF
C
         END DO
      END DO
C
      IF (ITITLE.EQ.1) WRITE(NFIPRI,'(1H*,77X,1H*)')
C
C=======================================================================
C
      IF (IF_RPA.EQ.1) THEN
          WRITE(NFIPRI,'(79(''*''),/,''*'',77X,''*'',/,
     *            ''* THE LAGRANGE PARAMETERS OF THE LINEAR '',
     *            ''CONSTRAINTS ARE RE-ADJUSTED AT EACH   *'',/,
     *            ''* ITERATION BY USING THE CRANKING APPROXIMATION'',
     *            '' OF THE RPA MATRIX             *'',/,
     *            ''*'',77X,''*'')')
      END IF
C
C=======================================================================
C
      IF (IACONT.EQ.1)
     *    WRITE(NFIPRI,'(79(1H*),/,                       1H*,77X,1H*,/,
     *         1H*,1X,''THE LAG. LINEAR CONSTRAINTS WILL BE READ '',
     *             1X,''FROM DISC TO CONTINUE ITERATIONS'',   2X,1H*,/,
     *                                                    1H*,77X,1H*)')
C
C=======================================================================
C
      IF (NSIMAX.GT.0) THEN
C
          IF (ISCHIF.EQ.1) THEN
C
              WRITE(NFIPRI,'(79(1H*),/,                   1H*,77X,1H*,/,
     *          1H*, 1X,''MAXIMUM NUMBERS OF SCHIFF MOMENTS USED:  '',
     *               1X,''FOR THE CONSTRAINTS,    NSICON='',I1,2X,1H*,/,
     *          1H*,43X,''FOR THE OUTPUT INFO,    NSIPRI='',I1,2X,1H*,/,
     *                                                    1H*,77X,1H*)')
     *
     *          NSICON,NSIPRI
C
          ELSE
C
              WRITE(NFIPRI,'(79(1H*),/,                   1H*,77X,1H*,/,
     *          1H*, 1X,''MAXIMUM NUMBERS OF SURFACE MOMENTS USED: '',
     *               1X,''FOR THE CONSTRAINTS,    NSICON='',I1,2X,1H*,/,
     *          1H*,43X,''FOR THE OUTPUT INFO,    NSIPRI='',I1,2X,1H*,/,
     *                                                    1H*,77X,1H*)')
     *
     *          NSICON,NSIPRI
C
          END IF
C
      END IF
C
C=======================================================================
C
      IF (NSIMAX.GT.0.AND.IDOPLM.EQ.1)
     *    WRITE(NFIPRI,'(79(1H*),/,                       1H*,77X,1H*,/,
     *          1H*, 1X,''MAXIMUM NUMBERS OF PENSURFACE MOMENTS USED:'',
     *               1X,''FOR THE OUTPUT INFO,  NSIPRI='',I1,2X,1H*,/,
     *                                                    1H*,77X,1H*)')
     *
     *          NSIPRI
C
C=======================================================================
C
      ITITLE=0
C
      DO LAMBDA=1,NSICON
         DO MIU=-LAMBDA,LAMBDA
C
            IF (IFLAGS(LAMBDA,MIU).GT.0) THEN
C
                IF (ITITLE.EQ.0) THEN
C
                    WRITE(NFIPRI,'(79(1H*),/,1H*,77X,1H*)')
C
                    IF (IFLAGS(LAMBDA,MIU).EQ.2)
     *                  WRITE(NFIPRI,'(1H*,1X,
     *                           ''FOR NEUTRONS WE USE:'')')
C
                    IF (IFLAGS(LAMBDA,MIU).EQ.3)
     *                  WRITE(NFIPRI,'(1H*,1X,
     *                           ''FOR PROTONS WE USE:'')')
C
                    IF (ISCHIF.EQ.1) THEN
C
                        WRITE(NFIPRI,'(1H*,1X,
     *                           ''SCHIFF  CONSTRAINTS:   '',
     *                           ''LAMBDA='',I2,''  MIU='',I2,2X,
     *                           ''MOMENT='',F7.3,2X,
     *                           ''STIFFNESS='',F6.3,     2X,1H*)')
     *
     *                  LAMBDA,MIU,SASKED(LAMBDA,MIU),STIFFS(LAMBDA,MIU)
C
                    ELSE
C
                        WRITE(NFIPRI,'(1H*,1X,
     *                           ''SURFACE CONSTRAINTS:   '',
     *                           ''LAMBDA='',I2,''  MIU='',I2,2X,
     *                           ''MOMENT='',F7.3,2X,
     *                           ''STIFFNESS='',F6.3,     2X,1H*)')
     *
     *                  LAMBDA,MIU,SASKED(LAMBDA,MIU),STIFFS(LAMBDA,MIU)
C
                    END IF
C
                    ITITLE=1
C
                ELSE
C
                    WRITE(NFIPRI,'(1H*,1X,''                       '',
     *                           ''LAMBDA='',I2,''  MIU='',I2,2X,
     *                           ''MOMENT='',F7.3,2X,
     *                           ''STIFFNESS='',F6.3,     2X,1H*)')
     *
     *              LAMBDA,MIU,SASKED(LAMBDA,MIU),STIFFS(LAMBDA,MIU)
C
                END IF
C
            END IF
C
         END DO
      END DO
C
      IF (ITITLE.EQ.1) WRITE(NFIPRI,'(1H*,77X,1H*)')
C
C=======================================================================
C
      ITITLE=0
C
      DO LAMBDA=1,NSICON
         DO MIU=-LAMBDA,LAMBDA
C
            IF (IFLALS(LAMBDA,MIU).LT.0) THEN
C
                IF (ITITLE.EQ.0) THEN
C
                    WRITE(NFIPRI,'(79(1H*),/,1H*,77X,1H*)')
C
                    IF (IFLALS(LAMBDA,MIU).EQ.-2)
     *                  WRITE(NFIPRI,'(1H*,1X,
     *                           ''FOR NEUTRONS WE USE:'')')
C
                    IF (IFLALS(LAMBDA,MIU).EQ.-3)
     *                  WRITE(NFIPRI,'(1H*,1X,
     *                           ''FOR PROTONS WE USE:'')')
C
                    IF (ISCHIF.EQ.1) THEN
C
                        WRITE(NFIPRI,'(1H*,1X,
     *                           ''LINEAR SCHIFF  CONSTRAINTS:   '',
     *                           ''LAMBDA='',I2,''  MIU='',I2,2X,
     *                           ''LAGRANGE PAR. '',
     *                           ''USED='',F6.3,     2X,1H*)')
     *
     *                  LAMBDA,MIU,SLINEA(LAMBDA,MIU)
C
                    ELSE
C
                        WRITE(NFIPRI,'(1H*,1X,
     *                           ''LINEAR SURFACE CONSTRAINTS:   '',
     *                           ''LAMBDA='',I2,''  MIU='',I2,2X,
     *                           ''LAGRANGE PAR. '',
     *                           ''USED='',F6.3,     2X,1H*)')
     *
     *                  LAMBDA,MIU,SLINEA(LAMBDA,MIU)
C
                    END IF
C
                    ITITLE=1
C
                ELSE
C
                    WRITE(NFIPRI,'(1H*,1X,
     *                       ''                              '',
     *                       ''LAMBDA='',I2,''  MIU='',I2,2X,
     *                       ''LAGRANGE PAR. '',
     *                       ''USED='',F6.3,     2X,1H*)')
     *
     *              LAMBDA,MIU,SLINEA(LAMBDA,MIU)
C
                END IF
C
            END IF
C
         END DO
      END DO
C
      IF (ITITLE.EQ.1) WRITE(NFIPRI,'(1H*,77X,1H*)')
C
C=======================================================================
C
      ITITLE=0
C
      DO LAMBDA=1,NSICON
         DO MIU=-LAMBDA,LAMBDA
C
            IF (IFLALS(LAMBDA,MIU).GT.0) THEN
C
                IF (ITITLE.EQ.0) THEN
C
                    WRITE(NFIPRI,'(79(1H*),/,1H*,77X,1H*)')
C
                    IF (IFLALS(LAMBDA,MIU).EQ.2)
     *                  WRITE(NFIPRI,'(1H*,1X,
     *                           ''FOR NEUTRONS WE USE:'')')
C
                    IF (IFLALS(LAMBDA,MIU).EQ.3)
     *                  WRITE(NFIPRI,'(1H*,1X,
     *                           ''FOR PROTONS WE USE:'')')
C
                    IF (ISCHIF.EQ.1) THEN
C
                        WRITE(NFIPRI,'(1H*,1X,
     *                           ''AUGMENTED SCHIFF  CONSTRAINTS:   '',
     *                           ''LAMBDA='',I2,''  MIU='',I2,2X,
     *                           ''INIT. LAGR. '',
     *                           ''PAR='',F6.3,     2X,1H*)')
     *
     *                  LAMBDA,MIU,SLINEA(LAMBDA,MIU)
C
                    ELSE
C
                        WRITE(NFIPRI,'(1H*,1X,
     *                           ''AUGMENTED SURFACE CONSTRAINTS:   '',
     *                           ''LAMBDA='',I2,''  MIU='',I2,2X,
     *                           ''INIT. LAGR. '',
     *                           ''PAR='',F6.3,     2X,1H*)')
     *
     *                  LAMBDA,MIU,SLINEA(LAMBDA,MIU)
C
                    END IF
C
                    ITITLE=1
C
                ELSE
C
                    WRITE(NFIPRI,'(1H*,1X,
     *                       ''                                 '',
     *                       ''LAMBDA='',I2,''  MIU='',I2,2X,
     *                       ''INIT. LAGR. '',
     *                       ''PAR='',F6.3,     2X,1H*)')
     *
     *              LAMBDA,MIU,SLINEA(LAMBDA,MIU)
C
                END IF
C
            END IF
C
         END DO
      END DO
C
      IF (ITITLE.EQ.1) WRITE(NFIPRI,'(1H*,77X,1H*)')
C
C=======================================================================
C
      ITITLE=0
C
      DO LAMBDA=1,NMUCON
C
         IF (IFLAGG(LAMBDA).EQ.1) THEN
C
             IF (ITITLE.EQ.0) THEN
C
                 WRITE(NFIPRI,'(79(1H*),/,1H*,77X,1H*,/,
     *                 1H*,1X,''SCALAR MULTIPOLE CONSTRAINTS:  '',
     *                        ''LAMBDA='',I2,2X,
     *                        ''MOMENT='',F7.3,2X,
     *                        ''STIFFNESS='',F6.3,     2X,1H*)')
     *
     *           LAMBDA,GASKED(LAMBDA),STIFFG(LAMBDA)
C
                 ITITLE=1
C
             ELSE
C
                 WRITE(NFIPRI,'(
     *                 1H*,1X,''                               '',
     *                        ''LAMBDA='',I2,2X,
     *                        ''MOMENT='',F7.3,2X,
     *                        ''STIFFNESS='',F6.3,     2X,1H*)')
     *
     *           LAMBDA,GASKED(LAMBDA),STIFFG(LAMBDA)
C
             END IF
C
         END IF
C
      END DO
C
      IF (ITITLE.EQ.1) WRITE(NFIPRI,'(1H*,77X,1H*)')
C
C=======================================================================
C
      IF (NMAMAX.GT.0)
     *    WRITE(NFIPRI,'(79(1H*),/,                       1H*,77X,1H*,/,
     *          1H*, 1X,''MAXIMUM NUMBER OF MAGNETIC MOMENTS USED: '',
     *               1X,''FOR THE CONSTRAINTS,    NMACON='',I1,2X,1H*,/,
     *          1H*,43X,''FOR THE OUTPUT INFO,    NMAPRI='',I1,2X,1H*,/,
     *                                                    1H*,77X,1H*)')
     *
     *          NMACON,NMAPRI
C
C=======================================================================
C
      IF (IRENMA.GE.1)
     *    WRITE(NFIPRI,'(79(1H*),/,                      1H*,77X,1H*,/,
     *          1H*, 1X,''NUCLEON MASS RENORMALIZED IRENMA='',I2,
     *                  ''  DISTAX='',F4.2,
     *                  ''  DISTAY='',F4.2,
     *                  ''  DISTAZ='',F4.2,                   2X,1H*,/,
     *                                                   1H*,77X,1H*)')
     *          IRENMA,DISTAX,DISTAY,DISTAZ
C
C=======================================================================
C
      IF (IRENIN.GE.1)
     *    WRITE(NFIPRI,'(79(1H*),/,                      1H*,77X,1H*,/,
     *          1H*, 1X,''NUCLEAR INERTIA RENORMLZD IRENIN='',I2,
     *                  ''  ROTATX='',F4.2,
     *                  ''  ROTATY='',F4.2,
     *                  ''  ROTATZ='',F4.2,                   2X,1H*,/,
     *                                                   1H*,77X,1H*)')
     *          IRENIN,ROTATX,ROTATY,ROTATZ
C
C=======================================================================
C
      IF (JETACM.EQ.2) THEN
C
          IF (IMCONT.EQ.1.AND.IRENMA.GE.1) THEN
C
              WRITE(NFIPRI,'(79(1H*),/,                   1H*,77X,1H*,/,
     *         1H*,1X,''RENORMALIZED NUCLEON MASS WILL BE  READ  '',
     *             1X,''FROM DISC TO CONTINUE ITERATIONS'',   2X,1H*,/,
     *                                                    1H*,77X,1H*)')
C
          ELSE
C
              WRITE(NFIPRI,'(79(1H*),/,                   1H*,77X,1H*,/,
     *          1H*,'' NUCLEON MASS RENORMALIZATION'',
     *              '' INITIALIZED WITH FACTORS'',
     *              '' X='',F4.2,
     *              '' Y='',F4.2,
     *              '' Z='',F4.2,                             2X,1H*,/,
     *                                                   1H*,77X,1H*)')
     *          (HBMRIN(KARTEZ),KARTEZ=1,NDKART)
C
          END IF
C
      END IF
C=======================================================================
C
      IF ((IRENMA.GE.1.OR.IRENIN.GE.1).AND.IDOGOA.EQ.1)
     *    WRITE(NFIPRI,'(79(1H*),/,                      1H*,77X,1H*,/,
     *          1H*,'' THE GAUSSIAN-OVERLAP APPROXIMATION'',
     *              '' WILL BE USED                 '',
     *                                                       12X,1H*,/,
     *                                                   1H*,77X,1H*)')
C
C=======================================================================
C
      IF (KETA_R.EQ.1)
     *    WRITE(NFIPRI,'(79(1H*),/,                      1H*,77X,1H*,/,
     *          1H*,'' TWO--BODY ROTATIONAL CORRECTION'',
     *              '' WILL BE INCLUDED AFTER VARIATION'',
     *                                                       12X,1H*,/,
     *                                                   1H*,77X,1H*)')
C
      IF (KETA_R.EQ.2)
     *    WRITE(NFIPRI,'(79(1H*),/,                      1H*,77X,1H*,/,
     *          1H*,'' TWO--BODY ROTATIONAL CORRECTION'',
     *              '' WILL BE INCLUDED BEFORE VARIATION'',
     *                                                       11X,1H*,/,
     *                                                   1H*,77X,1H*)')
C
C=======================================================================
C
      IF (KETA_R.EQ.2) THEN
C
          IF (IRCONT.EQ.1.AND.IRENIN.GE.1) THEN
C
              WRITE(NFIPRI,'(79(1H*),/,                   1H*,77X,1H*,/,
     *         1H*,1X,''RENORMALIZED NUCLEAR INERT. WILL BE READ '',
     *             1X,''FROM DISC TO CONTINUE ITERATIONS'',   2X,1H*,/,
     *                                                    1H*,77X,1H*)')
C
          ELSE
C
              WRITE(NFIPRI,'(79(1H*),/,                   1H*,77X,1H*,/,
     *          1H*,'' NUCLEAR INERTIA RENORMALIZATION'',
     *              '' INITLZED WITH FACTORS'',
     *              '' X='',F4.2,
     *              '' Y='',F4.2,
     *              '' Z='',F4.2,                             2X,1H*,/,
     *                                                   1H*,77X,1H*)')
     *          (ROTRIN(KARTEZ),KARTEZ=1,NDKART)
C
          END IF
C
      END IF
C=======================================================================
C
      WRITE(NFIPRI,'(79(1H*),/,                       1H*,77X,1H*,/,
     *            1H*, 1X,''PRINTING THE RESULTS FOR THE FOLLOWING '',
     *                    ''ITERATIONS:'',9X,
     *                           ''THE  FIRST: '',A3,      2X,1H*,/,
     *            1H*,60X,       ''THE MIDDLE: '',A3,      2X,1H*,/,
     *            1H*,53X,''AND/OR THE   LAST: '',A3,      2X,1H*,/,
     *                                                1H*,77X,1H*)')
     *
     *    NO_YES(IPRSTA),NO_YES(IPRMID),NO_YES(IPRSTO)
C
C=======================================================================
C
      WRITE(NFIPRI,'(79(1H*),/,                       1H*,77X,1H*,/,
     *            1H*, 1X,''PRINTING THE MOMENTS, RADII, AND DEFORM'',
     *                    ''ATIONS FOR:'',11X,
     *                             ''NEUTRONS: '',A3,      2X,1H*,/,
     *            1H*,62X,         ''PROTONS : '',A3,      2X,1H*,/,
     *            1H*,62X,         ''MASS    : '',A3,      2X,1H*,/,
     *                                                1H*,77X,1H*)')
     *
     *    NO_YES(IPRI_N),NO_YES(IPRI_P),NO_YES(IPRI_T)
C
C=======================================================================
C
      WRITE(NFIPRI,'(79(1H*),/,                       1H*,77X,1H*,/,
     *            1H*, 1X,''PRINTING THE MOMENTS, MOMENTA AND DEFORM'',
     *                    ''ATIONS IN THE INTRINSIC FRAME: '',A3,
     *                                                     2X,1H*,/,
     *                                                1H*,77X,1H*)')
     *
     *    NO_YES(INTRIP)
C
C=======================================================================
C
      IF (IVIPRI.EQ.1) WRITE(NFIPRI,'(79(1H*),/,      1H*,77X,1H*,/,
     *            1H*, 1X,''PRINTING THE INTEGRALS OF THE SYMMETRY-V'',
     *                    ''IOLATING TERMS:                '',A3,
     *                                                     2X,1H*,/,
     *                                                1H*,77X,1H*)')
     *
     *    NO_YES(IVIPRI)
C
C=======================================================================
C
      WRITE(NFIPRI,'(79(1H*),/,                           1H*,77X,1H*,/,
     *      1H*,1X,''NILSSON LABELS OF SINGLE-PARTICLE STATES '',
     *             ''SHOWN WITH RESPECT TO THE: '',A1,''-AXIS'',
     *                                                         2X,1H*,/,
     *                                                    1H*,77X,1H*)')
     *      KARDIR(NILXYZ)
C
C=======================================================================
C
      IF (IPAHFB.NE.1.OR.ITWOBA.EQ.1.OR.IMFHFB.EQ.1)
     *    WRITE(NFIPRI,'(79(1H*),/,                   1H*,77X,1H*,/,
     *            1H*, 1X,''NUMBERS OF LEVELS IN TIME-REVERSAL/CH'',
     *                    ''ARGE  BLOCKS:     TIME-UP   TIME-DOWN'',
     *                                                     2X,1H*,/,
     *            1H*,42X,       ''NEUTRONS:'',5X,I5,6X,I5,5X,1H*,/,
     *            1H*,42X,       '' PROTONS:'',5X,I5,6X,I5,5X,1H*,/,
     *                                                1H*,77X,1H*)')
     *
     *    ((NUMBSP(IREVER,ICHARG),IREVER=0,NDREVE),
     *                            ICHARG=0,NDISOS)
C
C=======================================================================
C
      IF (IPAIRI.EQ.1) THEN
C
          IF (IPAHFB.EQ.1) THEN
C
              WRITE(NFIPRI,'(79(1H*),/,               1H*,77X,1H*,/,
     *                 1H*,1X,''CALCULATIONS WITH THE HFB PAIRING'',
     *                        '' CORRELATIONS'',          30X,1H*,/,
     *                                                1H*,77X,1H*)')
C
              IF (ITWOBA.EQ.1) THEN
C
                  WRITE(NFIPRI,'(79(1H*),/,           1H*,77X,1H*,/,
     *                 1H*,1X,''THE HFB EQUATIONS WILL BE SOLVED '',
     *                        ''ON THE BASIS OF THE MF '',
     *                        ''EIGENSTATES'',             9X,1H*,/,
     *                                                1H*,77X,1H*)')
C
              END IF
C
              IF (ICONTI.NE.1.OR.(ICONTI.EQ.1.AND.IPCONT.NE.1)) THEN
C
                  WRITE(NFIPRI,'(79(1H*),/,               1H*,77X,1H*,/,
     *                1H*, 1X,''INITIAL VALUES OF PAIRING PROPERTIES:'',
     *                        ''         FERMI ENERGY    PAIRING GAP '',
     *                                                         2X,1H*,/,
     *                1H*,29X, ''NEUTRONS:'',        3X,2F15.4,6X,1H*,/,
     *                1H*,29X, '' PROTONS:'',        3X,2F15.4,6X,1H*,/,
     *                                                    1H*,77X,1H*)')
     *
     *            (FERINI(ICHARG),DELINI(ICHARG),ICHARG=0,NDISOS)
C
              END IF
C
              IF (IFEFIN.EQ.1.OR.IFEFIP.EQ.1) THEN
C
                  WRITE(NFIPRI,'(79(1H*),/,           1H*,77X,1H*,/,
     *            1H*, 1X,''CALCULATIONS WITH FIXED VALUES OF THE'',
     *                    '' FERMI ENERGY:      VALUE       FIXED'',
     *                                                     2X,1H*,/,
     *            1H*,42X,       ''NEUTRONS:'',F13.5,7X,A3,3X,1H*,/,
     *            1H*,42X,       '' PROTONS:'',F13.5,7X,A3,3X,1H*,/,
     *                                                1H*,77X,1H*)')
     *
     *            FERFIN,NO_YES(IFEFIN),
     *            FERFIP,NO_YES(IFEFIP)
C
              END IF
C
              IF (IDEFIN.EQ.1.OR.IDEFIP.EQ.1) THEN
C
                  WRITE(NFIPRI,'(79(1H*),/,           1H*,77X,1H*,/,
     *            1H*, 1X,''CALCULATIONS WITH FIXED VALUES OF THE'',
     *                    '' PAIRING GAP:       VALUE       FIXED'',
     *                                                     2X,1H*,/,
     *            1H*,42X,       ''NEUTRONS:'',F13.5,7X,A3,3X,1H*,/,
     *            1H*,42X,       '' PROTONS:'',F13.5,7X,A3,3X,1H*,/,
     *                                                1H*,77X,1H*)')
     *
     *            DELFIN,NO_YES(IDEFIN),
     *            DELFIP,NO_YES(IDEFIP)
C
              END IF
C
              IF (LIPKIN.EQ.1.OR.LIPKIP.EQ.1) THEN
C
                  WRITE(NFIPRI,'(79(1H*),/,           1H*,77X,1H*,/,
     *            1H*, 1X,''CALCULATIONS WITH THE LIPKIN-NOGAMI '',
     *                    ''CORRECTIONS INCLUDED FOR '',
     *                                 ''NEUTRONS:'',1X,A3,2X,1H*,/,
     *            1H*,62X,             '' PROTONS:'',1X,A3,2X,1H*,/,
     *                                                1H*,77X,1H*)')
     *
     *            NO_YES(LIPKIN),
     *            NO_YES(LIPKIP)
C
                  WRITE(NFIPRI,'(79(1H*),/,             1H*,77X,1H*,/,
     *                     1H*, 1X,''THE LIPKIN-NOGAMI PAIRING-'',
     *                             ''STRENGTHS SCALING FACTORS: '',3X,
     *                             ''NEUTRONS='',F9.6,       2X,1H*,/,
     *                     1H*,57X,'' PROTONS='',F9.6,       2X,1H*,/,
     *                                                  1H*,77X,1H*)')
     *            FACTGN,FACTGP
C
                  IF (IPCONT.NE.1.OR.(IPCONT.EQ.1.AND.ILCONT.NE.1)) THEN
C
                      WRITE(NFIPRI,'(79(1H*),/,           1H*,77X,1H*,/,
     *                1H*, 1X,''INITIAL VALUES OF THE LIPKIN-NOGAMI '',
     *                        ''LAMBDA2 FOR NEUTRONS: '',F12.4,6X,1H*,/,
     *                1H*,49X,            '' PROTONS: '',F12.4,6X,1H*,/,
     *                                                    1H*,77X,1H*)')
     *
     *                (FE2INI(ICHARG),ICHARG=0,NDISOS)
C
                  END IF
C
                  IF (IF2FIN.EQ.1.OR.IF2FIP.EQ.1) THEN
C
                      WRITE(NFIPRI,'(79(1H*),/,           1H*,77X,1H*,/,
     *                1H*, 1X,''CALCULATIONS WITH FIXED VALUES OF THE'',
     *                        '' LIPKIN LAMBDA2:    VALUE       FIXED'',
     *                                                         2X,1H*,/,
     *                1H*,45X,       ''NEUTRONS:'',F10.5,7X,A3,3X,1H*,/,
     *                1H*,45X,       '' PROTONS:'',F10.5,7X,A3,3X,1H*,/,
     *                                                    1H*,77X,1H*)')
     *
     *                FE2FIN,NO_YES(IF2FIN),
     *                FE2FIP,NO_YES(IF2FIP)
C
                  END IF
C
                  IF (ILCONT.EQ.1) THEN
C
                      WRITE(NFIPRI,'(79(1H*),/,           1H*,77X,1H*,/,
     *                   1H*,1X,''DENSITY MATRICES WILL BE  READ  '',
     *                          ''FROM DISC  IN ORDER TO CONTINUE '',
     *                          ''LIPKIN RUN'',                2X,1H*,/,
     *                                                    1H*,77X,1H*)')
C
                  ELSE
C
                      WRITE(NFIPRI,'(79(1H*),/,           1H*,77X,1H*,/,
     *                   1H*,1X,''DENSITY MATRICES WILL BE ZEROED '',
     *                          ''BEFORE  SOLVING LIPKIN-NOGAMI '',
     *                          ''FOR THIS RUN'',              2X,1H*,/,
     *                                                    1H*,77X,1H*)')
                  END IF
C
              END IF
C
              IF (IDEFIN.EQ.0.OR.IDEFIP.EQ.0) THEN
C
                  WRITE(NFIPRI,'(79(1H*),/,           1H*,77X,1H*,/,
     *            1H*, 1X,''CONTACT PAIRING INTERACTION:     V0  '',
     *                    ''      V1       RHO-SAT      POWER    '',
     *                                                     2X,1H*,/,
     *            1H*,20X, ''NEUTRONS:'',3F10.3,F14.7,     4X,1H*,/,
     *            1H*,20X, '' PROTONS:'',3F10.3,F14.7,     4X,1H*,/,
     *                                                1H*,77X,1H*)')
     *
     *            PRHO_N,PRHODN,PRHOSN,POWERN,
     *            PRHO_P,PRHODP,PRHOSP,POWERP
C
              END IF
C
              IF (ABS(IDSIGN).EQ.1.OR.ABS(IDSIGP).EQ.1) THEN
C
                  WRITE(NFIPRI,'(79(1H*),/,           1H*,77X,1H*,/,
     *            1H*, 1X,''BLOCKING OF QUASIPARTICLES THAT HAVE '',
     *                    ''LARGEST OVERLAP WITH PARTICLE STATES:'',
     *                                                     2X,1H*,/,
     *            1H*, 1X,''                                     '',
     *                    ''        NUMBER PARITY SIGNATURE      '',
     *                                                     2X,1H*,/,
     *            1H*,9X,A26,1X,''NEUTRONS:'',I6,2I7,7X,A3,2X,1H*,/,
     *            1H*,9X,A26,1X,'' PROTONS:'',I6,2I7,7X,A3,2X,1H*,/,
     *                                                1H*,77X,1H*)')
     *
     *            IFTIMR(IDSIGN),
     *            INSIGN,IPSIGN,ISSIGN,NO_YES(ABS(IDSIGN)),
     *            IFTIMR(IDSIGP),
     *            INSIGP,IPSIGP,ISSIGP,NO_YES(ABS(IDSIGP))
C
              END IF
C
              IF (ABS(IDSIMN).EQ.1.OR.ABS(IDSIMP).EQ.1) THEN
C
                  WRITE(NFIPRI,'(79(1H*),/,           1H*,77X,1H*,/,
     *            1H*, 1X,''BLOCKING OF QUASIPARTICLES THAT HAVE '',
     *                    ''LARGEST OVERLAP WITH PARTICLE STATES:'',
     *                                                     2X,1H*,/,
     *            1H*, 1X,''                                     '',
     *                    ''               NUMBER SIMPLEX        '',
     *                                                     2X,1H*,/,
     *            1H*,16X,A26,1X,''NEUTRONS:'',I6,I7,7X,A3,2X,1H*,/,
     *            1H*,16X,A26,1X,'' PROTONS:'',I6,I7,7X,A3,2X,1H*,/,
     *                                                1H*,77X,1H*)')
     *
     *            IFTIMR(IDSIMN),
     *            INSIMN,IRSIMN,NO_YES(ABS(IDSIMN)),
     *            IFTIMR(IDSIMP),
     *            INSIMP,IRSIMP,NO_YES(ABS(IDSIMP))
C
              END IF
C
              IF (ABS(IDSIQN).EQ.1.OR.ABS(IDSIQP).EQ.1) THEN
C
                  WRITE(NFIPRI,'(79(1H*),/,           1H*,77X,1H*,/,
     *            1H*, 1X,''BLOCKING OF QUASIPARTICLES THAT HAVE '',
     *                    ''LARGEST OVERLAP WITH PARTICLE STATES:'',
     *                                                     2X,1H*,/,
     *            1H*, 1X,''                                     '',
     *                    ''               NUMBER  PARITY        '',
     *                                                     2X,1H*,/,
     *            1H*,16X,A26,1X,''NEUTRONS:'',I6,I7,7X,A3,2X,1H*,/,
     *            1H*,16X,A26,1X,'' PROTONS:'',I6,I7,7X,A3,2X,1H*,/,
     *                                                1H*,77X,1H*)')
     *
     *            IFTIMR(IDSIQN),
     *            INSIQN,IPSIQN,NO_YES(ABS(IDSIQN)),
     *            IFTIMR(IDSIQP),
     *            INSIQP,IPSIQP,NO_YES(ABS(IDSIQP))
C
              END IF
C
              IF (ABS(IDSIZN).EQ.1.OR.ABS(IDSIZP).EQ.1) THEN
C
                  WRITE(NFIPRI,'(79(1H*),/,           1H*,77X,1H*,/,
     *            1H*, 1X,''BLOCKING OF QUASIPARTICLES THAT HAVE '',
     *                    ''LARGEST OVERLAP WITH PARTICLE STATES:'',
     *                                                     2X,1H*,/,
     *            1H*, 1X,''                                     '',
     *                    ''                      NUMBER         '',
     *                                                     2X,1H*,/,
     *            1H*,23X,A26,1X,   ''NEUTRONS:'',I6,7X,A3,2X,1H*,/,
     *            1H*,23X,A26,1X,   '' PROTONS:'',I6,7X,A3,2X,1H*,/,
     *                                                1H*,77X,1H*)')
     *
     *            IFTIMR(IDSIZN),
     *            INSIZN,NO_YES(ABS(IDSIZN)),
     *            IFTIMR(IDSIZP),
     *            INSIZP,NO_YES(ABS(IDSIZP))
C
              END IF
C
              IF (IFIBLN.EQ.1.OR.IFIBLP.EQ.1) THEN
C
                  WRITE(NFIPRI,'(79(1H*),/,           1H*,77X,1H*,/,
     *            1H*, 1X,''PARTICLE STATES THAT ARE USED FOR BLO'',
     *                    ''CKING WILL BE FIXED DURING ITERATION:'',
     *                                                     2X,1H*,/,
     *                     1H*,58X,''FOR NEUTRONS:'',1X,A3,2X,1H*,/,
     *                     1H*,58X,''FOR  PROTONS:'',1X,A3,2X,1H*,/,
     *                                                1H*,77X,1H*)')
     *
     *            NO_YES(IFIBLN),NO_YES(IFIBLP)
C
              END IF
C
              IF (INIBLN.EQ.1.OR.INIBLP.EQ.1) THEN
C
                  WRITE(NFIPRI,'(79(1H*),/,           1H*,77X,1H*,/,
     *            1H*, 1X,''PARTICLE STATES THAT ARE USED FOR BLO'',
     *                    ''CKING WILL BE INITIALIZED AT 1ST ITER'',
     *                                                     2X,1H*,/,
     *                     1H*,58X,''FOR NEUTRONS:'',1X,A3,2X,1H*,/,
     *                     1H*,58X,''FOR  PROTONS:'',1X,A3,2X,1H*,/,
     *                                                1H*,77X,1H*)')
     *
     *            NO_YES(INIBLN),NO_YES(INIBLP)
C
              END IF
C
              IF (IFIBLN.EQ.1.AND.INIBLN.EQ.0) THEN
C
                  WRITE(NFIPRI,'(79(1H*),/,           1H*,77X,1H*,/,
     *            1H*, 1X,''NEUTRON PARTICLE STATE USED FOR BLOCK'',
     *                    ''ING WILL BE READ FROM THE RECORD FILE'',
     *                                                     2X,1H*,/,
     *                                                1H*,77X,1H*)')
C
              END IF
C
              IF (IFIBLP.EQ.1.AND.INIBLP.EQ.0) THEN
C
                  WRITE(NFIPRI,'(79(1H*),/,           1H*,77X,1H*,/,
     *            1H*, 1X,''PROTON  PARTICLE STATE USED FOR BLOCK'',
     *                    ''ING WILL BE READ FROM THE RECORD FILE'',
     *                                                     2X,1H*,/,
     *                                                1H*,77X,1H*)')
C
              END IF
C
              IF (IMFHFB.EQ.1) THEN
C
                  WRITE(NFIPRI,'(79(1H*),/,           1H*,77X,1H*,/,
     *            1H*, 1X,''THE HFB-MEAN-FIELD SPECTRA AND SINGLE'',
     *                    ''-PARTICLE PROPERTIES  WILL BE PRINTED'',
     *                                                     2X,1H*,/,
     *                                                1H*,77X,1H*)')
C
              END IF
C
              WRITE(NFIPRI,'(79(1H*),/,               1H*,77X,1H*,/,
     *                 1H*,1X,''CUTOFF ENERGY DEFINING THE ACTIVE'',
     *                        '' HFB PAIRING SPACE='',F12.3,12X,1H*,/,
     *                                                1H*,77X,1H*)')
     *        ECUTOF
C
              IF (LIMQUA.EQ.1) THEN
C
                  WRITE(NFIPRI,'(79(1H*),/,           1H*,77X,1H*,/,
     *            1H*, 1X,''ONLY THE QUASIPARTICLES WITH ENERGIES '',
     *                    ''BELOW THE CUTOFF ENERGY WILL BE USED'',
     *                                                     2X,1H*,/,
     *            1H*, 1X,''ATTENTION: THE CUTOFF ENERGY MUST NOT '',
     *                    ''BE BELOW THE QP ENERGY OF THE 1S_1/2'',
     *                                                     2X,1H*,/,
     *                                                1H*,77X,1H*)')
C
              END IF
C
C=======================================================================
C
          END IF
C
          IF (JPABCS.GT.0) THEN
C
              WRITE(NFIPRI,'(79(1H*),/,               1H*,77X,1H*,/,
     *                 1H*,1X,''CALCULATIONS WITH THE BCS PAIRING'',
     *                        '' CORRELATIONS'',          30X,1H*,/,
     *                                                1H*,77X,1H*)')
C
              IF (JPABCS.EQ.1) THEN
C
                  WRITE(NFIPRI,'(79(1H*),/,             1H*,77X,1H*,/,
     *                     1H*, 1X,''CALCULATIONS WITH PAIRING-'',
     *                             ''STRENGTHS SCALING FACTORS: '',7X,
     *                             ''NEUTRONS='',F5.3,       2X,1H*,/,
     *                     1H*,61X,'' PROTONS='',F5.3,       2X,1H*,/,
     *                                                  1H*,77X,1H*)')
     *            FACTGN,FACTGP
C
              END IF
C
              IF (JPABCS.EQ.2) THEN
C
                  WRITE(NFIPRI,'(79(1H*),/,           1H*,77X,1H*,/,
     *            1H*, 1X,''CALCULATIONS WITH FIXED VALUES OF THE'',
     *                    '' PAIRING GAP:       VALUE       FIXED'',
     *                                                     2X,1H*,/,
     *            1H*,42X,       ''NEUTRONS:'',F12.3,8X,A3,3X,1H*,/,
     *            1H*,42X,       '' PROTONS:'',F12.3,8X,A3,3X,1H*,/,
     *                                                1H*,77X,1H*)')
     *
     *            DELFIN,NO_YES(IDEFIN),
     *            DELFIP,NO_YES(IDEFIP)
C
              END IF
C
              IF (JPABCS.EQ.3) THEN
C
                  WRITE(NFIPRI,'(79(1H*),/,           1H*,77X,1H*,/,
     *            1H*, 1X,''CALCULATIONS WITH THE STATE-DEPENDENT'',
     *                    '' PAIRING GAPS -- CORRESPONDING TO THE'',
     *                                                     2X,1H*,/,
     *            1H*, 1X,''CONTACT PAIRING INTERACTION:     V0  '',
     *                    ''      V1       RHO-SAT      POWER    '',
     *                                                     2X,1H*,/,
     *            1H*,20X, ''NEUTRONS:'',3F10.3,F14.7,     4X,1H*,/,
     *            1H*,20X, '' PROTONS:'',3F10.3,F14.7,     4X,1H*,/,
     *                                                1H*,77X,1H*)')
     *
     *            PRHO_N,PRHODN,PRHOSN,POWERN,
     *            PRHO_P,PRHODP,PRHOSP,POWERP
C
                  WRITE(NFIPRI,'(79(1H*),/,               1H*,77X,1H*,/,
     *                1H*, 1X,''CALCULATING PAIRING M.E. FOR THE '',
     *                        ''FOLLOWING ITERATIONS:'',4X,
     *                               ''THE  FIRST:'',2X,A3,    2X,1H*,/,
     *                1H*,59X,       ''THE MIDDLE:'',2X,A3,    2X,1H*,/,
     *                1H*,59X,       ''THE   LAST:'',2X,A3,    2X,1H*,/,
     *                1H*,57X,     ''AND/OR EVERY:'',I3,''TH'',2X,1H*,/,
     *                                                    1H*,77X,1H*)')
     *
     *               NO_YES(IDESTA),NO_YES(IDEMID),NO_YES(IDESTO),IDEDIS
C
              END IF
C
          END IF
C
      END IF
C
C=======================================================================
C
      IF (INIINV.GE.1.OR.INIKAR.GE.1)
     *
     *    WRITE(NFIPRI,'(79(1H*),/,                       1H*,77X,1H*,/,
     *              1H*,'' AFTER THE FIRST ITERATION OF THIS RUN'',
     *                  '' THE WAVE FUNCTION WILL BE MODIFIED BY'',
     *                                                         1X,1H*,/,
     *              1H*,'' ONE OF THE D2H TRANSFORMATIONS: '',A43,
     *                                                         1X,1H*,/,
     *              1H*,77X,1H*)')
     *
     *    NAMINV(INIINV,INIKAR)
C
C=======================================================================
C
      PI=4.0D0*ATAN(1.0D0)
      DEGRAD=180/PI
C
      IF (INIROT.EQ.1)
     *
     *    WRITE(NFIPRI,'(79(1H*),/,                       1H*,77X,1H*,/,
     *              1H*,'' AFTER THE FIRST ITERATION OF THIS RUN'',
     *                  '' THE WAVE FUNCTIONS WILL BE ROTATED BY'',
     *                                                         1X,1H*,/,
     *              1H*,'' THE FOLLOWING STANDARD EULER ANGLES (IN'',
     *                  '' DEGREES)'',                        28X,1H*,/,
     *              1H*,77X,1H*,/,
     *              1H*,'' ALPHA ='',F7.2,2X,
     *                  ''  BETA ='',F7.2,2X,
     *                  '' GAMMA ='',F7.2,28X,1H*,/,
     *              1H*,77X,1H*)')
     *
     *    ALPINI*DEGRAD,BETINI*DEGRAD,GAMINI*DEGRAD
C
C=======================================================================
C
      IF (IPRGCM.GE.1) THEN
C
          IF (IPAKER.NE.1) THEN
C
              IF (MOD(IPROMI,2).EQ.0) THEN
C
                  WRITE(LPROMI,'(I4,1X)') IPROMI/2
                  WRITE(LPROMA,'(I4,1X)') IPROMA/2
                  WRITE(LPROJE,'(I4,1X)') KPROJE/2
C
              ELSE
C
                  WRITE(LPROMI,'(I3,''/2'')') IPROMI
                  WRITE(LPROMA,'(I3,''/2'')') IPROMA
                  WRITE(LPROJE,'(I3,''/2'')') KPROJE
C
              END IF
C
              IF (NUBKNO.GT.1) THEN
C
                  WRITE(NFIPRI,'(79(1H*),/,               1H*,77X,1H*,/,
     *                 1H*,'' THE ANGULAR MOMENTUM PROJECTION IS'',
     *                     '' PERFORMED AFTER THE ITERATIONS ARE DONE'',
     *                                           2X,1H*,/,1H*,77X,1H*,/,
     *                 1H*,'' PROJECTION ON VALUES OF ANGULAR MOMENTA'',
     *                     '' BETWEEN J ='',A5,'' AND J ='',A5,
     *                     '' HBAR'',            2X,1H*,/,1H*,77X,1H*,/,
     *                 1H*,'' NUMBERS OF INTEGRATION POINTS IN EULER'',
     *                     '' ANGLES:'',I3,'' (ALPHA/GAMMA),'',I3,
     *                     '' (BETA)'',                        2X,1H*)')
     *
     *                 LPROMI,LPROMA,NUAKNO,NUBKNO
C
                  IF (NUAKNO.EQ.1) THEN
C
                      WRITE(NFIPRI,'(                     1H*,77X,1H*,/,
     *                   1H*,'' AXIAL SYMMETRY IS ASSUMED: THE'',
     *                       '' PROJECTIONS ARE PERFORMED FOR K ='',A5,
     *                       '' ONLY'',                        2X,1H*,/,
     *                                                    1H*,77X,1H*)')
     *                    LPROJE
C
                  ELSE
C
                      WRITE(NFIPRI,'(1H*,77X,1H*)')
C
                  END IF
C
              ELSE
C
C=======================================================================
C             THE OPTION BELOW NOT PROGRAMMED YET (22/02/06)
C=======================================================================
C
                  IF (NUAKNO.GT.1) THEN
C
                      WRITE(NFIPRI,'(79(1H*),/,           1H*,77X,1H*,/,
     *                 1H*,'' PROJECTION ON GOOD JZ COMPONENT IS'',
     *                     '' PERFORMED AFTER THE ITERATIONS ARE DONE'',
     *                                           2X,1H*,/,1H*,77X,1H*,/,
     *                 1H*,'' PROJECTION ON VALUES OF  JZ  COMPONENTS'',
     *                     '' BETWEEN K ='',A5,'' AND K ='',A5,
     *                     '' HBAR'',            2X,1H*,/,1H*,77X,1H*,/,
     *                 1H*,'' NUMBERS OF INTEGRATION POINTS IN EULER'',
     *                     '' ANGLES:'',I3,'' (ALPHA/GAMMA),'',I3,
     *                     '' (BETA)'',                        2X,1H*,/,
     *                                                    1H*,77X,1H*)')
     *
     *                 LPROMI,LPROMA,NUAKNO,NUBKNO
C
                  END IF
C
              END IF
C
          ELSE
C
              WRITE(NFIPRI,'(79(1H*),/,                   1H*,77X,1H*,/,
     *             1H*,'' THE GCM KERNELS IN FUNCTION OF THE'',
     *                 '' EULER ANGLES WILL BE CALCULATED & SAVED'',
     *                                           2X,1H*,/,1H*,77X,1H*,/,
     *             1H*,'' ON THE DISK FOR THE GAUSS KNOTS '',I3,
     *                 '' -- '',I3,'' (ALPHA),'','' AND '',I3,
     *                 '' -- '',I3,'' (GAMMA)'',               2X,1H*,/,
     *                                                    1H*,77X,1H*)')
     *
     *             NUASTA,NUASTO,NUGSTA,NUGSTO
C
              IF (IPAALL.EQ.1)
     *        WRITE(NFIPRI,'(
     *             1H*,'' AND FOR THE GAUSS + GAUGE KNOTS '',I3,
     *                 '' -- '',I3,'' (BETA), '','' AND '',I3,
     *                 '' -- '',I3,'' (GAUGE)'',               2X,1H*,/,
     *                                                    1H*,77X,1H*)')
     *
     *             NUBSTA,NUBSTO,NUTSTA,NUTSTO
C
              IF (KFIKER.GE.1)
     *        WRITE(NFIPRI,'(79(1H*),/,                   1H*,77X,1H*,/,
     *             1H*,'' THE GCM KERNELS WILL BE SAVED IN'',
     *                 '' THE KERNEL FILE NUMBER: '',I3,
     *                                          16X,1H*,/,1H*,77X,1H*)')
     *
     *             KFIKER
C
          END IF
C
      END IF
C
C=======================================================================
C
      IF (IPRGCM.GE.1) THEN
C
          IF (ISCHIF.EQ.1) THEN
C
              WRITE(NFIPRI,'(79(1H*),/,                  1H*,77X,1H*,/,
     *          1H*, 1X,''REDUCED KERNELS AND MATRIX ELEMENTS:'',
     *                                                       40X,1H*,/,
     *          1H*, 1X,''FOR ELECTRIC MULTIPOLES CALCULATED UP TO ='',
     *               I2,'', PRINTED IF LARGER THAN'',F6.3,    2X,1H*,/,
     *          1H*, 1X,''FOR MAGNETIC MULTIPOLES CALCULATED UP TO ='',
     *               I2,'', PRINTED IF LARGER THAN'',F6.3,    2X,1H*,/,
     *          1H*, 1X,''FOR SCHIFF   MULTIPOLES CALCULATED UP TO ='',
     *               I2,'', PRINTED IF LARGER THAN'',F6.3,    2X,1H*,/,
     *                                                   1H*,77X,1H*)')
     *
     *          NMURED,QMUCUT,NMARED,QMACUT,NSIRED,QSICUT
C
          ELSE
C
              WRITE(NFIPRI,'(79(1H*),/,                  1H*,77X,1H*,/,
     *          1H*, 1X,''REDUCED KERNELS AND MATRIX ELEMENTS:'',
     *                                                       40X,1H*,/,
     *          1H*, 1X,''FOR ELECTRIC MULTIPOLES CALCULATED UP TO ='',
     *               I2,'', PRINTED IF LARGER THAN'',F6.3,    2X,1H*,/,
     *          1H*, 1X,''FOR MAGNETIC MULTIPOLES CALCULATED UP TO ='',
     *               I2,'', PRINTED IF LARGER THAN'',F6.3,    2X,1H*,/,
     *          1H*, 1X,''FOR SURFACE  MULTIPOLES CALCULATED UP TO ='',
     *               I2,'', PRINTED IF LARGER THAN'',F6.3,    2X,1H*,/,
     *                                                   1H*,77X,1H*)')
     *
     *          NMURED,QMUCUT,NMARED,QMACUT,NSIRED,QSICUT
C
          END IF
C
          WRITE(NFIPRI,'(79(1H*),/,                   1H*,77X,1H*,/,
     *            1H*, 1X,''PRINTING THE RESULTS FOR '',
     *                    ''ANGULAR-MOMENTUM-PROJECTED STATES:'',
     *                                  I3,'' < 2*I <'',I4,2X,1H*,/,
     *            1H*,34X,''AVERAGE ENERGIES OF PROJECTED STATES: '',
     *                                                  A3,2X,1H*,/,
     *            1H*,34X,''KERNELS BETWEEN THE PROJECTED STATES: '',
     *                                                  A3,2X,1H*,/,
     *            1H*,34X,''SUM RULES COMPARED TO THE H-F VALUES: '',
     *                                                  A3,2X,1H*,/,
     *            1H*,34X,''K-MIXED ENERGIES OF PROJECTED STATES: '',
     *                                                  A3,2X,1H*,/,
     *            1H*,18X,''REDUCED  K E R N E L S  BETWEEN THE '',
     *                    ''PROJECTED STATES: '',       A3,2X,1H*,/,
     *            1H*,18X,''REDUCED MATRIX ELEMENTS BETWEEN THE '',
     *                    '' K-MIXED  STATES: '',       A3,2X,1H*,/,
     *                                                1H*,77X,1H*)')
     *          ISLPRI,ISUPRI,
     *          NO_YES((IENPRI*(3-IENPRI))/2),
     *          NO_YES((IENPRI*(IENPRI-1))/2),
     *          NO_YES(ISRPRI),NO_YES(IMIPRI),
     *          NO_YES(IKEPRI),NO_YES(IRMPRI)
C
C=======================================================================
C
      END IF
C
C=======================================================================
C
      IF (IWRWAV.EQ.1)
     *
     *    WRITE(NFIPRI,'(79(1H*),/,                       1H*,77X,1H*,/,
     *              1H*,'' THE WAVE FUNCTIONS FOR THE GCM KERNELS'',
     *                  '' WILL BE STORED AFTER THE ITERATIONS'',
     *                                                         2X,1H*,/,
     *              1H*,77X,1H*)')
C
C=======================================================================
C
      IF (ISAKER.EQ.1.AND.IPAKER.NE.1)
     *
     *    WRITE(NFIPRI,'(79(1H*),/,                       1H*,77X,1H*,/,
     *              1H*,'' THE GCM KERNELS IN FUNCTION OF THE EULER'',
     *                  '' ANGLES WILL BE READ AND/OR STORED'',
     *                                                         2X,1H*,/,
     *              1H*,77X,1H*)')
C
C=======================================================================
C
      IF (ISAKER.EQ.1.AND.ICHKER.NE.1)
     *
     *    WRITE(NFIPRI,'(79(1H*),/,                       1H*,77X,1H*,/,
     *              1H*,'' THE NAMES OF KERNEL FILES WILL  N O T  BE'',
     *                  '' COMPARED WITH THE RECORDED NAMES'',
     *                                                         2X,1H*,/,
     *              1H*,77X,1H*)')
C
C=======================================================================
C
      IF (IPRGCM.EQ.2) THEN
C
          WRITE(FFRGCM,'(I3)') IFRWAV
            IF (FFRGCM(1:1).EQ.' ') FFRGCM(1:1)='0'
            IF (FFRGCM(2:2).EQ.' ') FFRGCM(2:2)='0'
C
          WRITE(FTOGCM,'(I3)') ITOWAV
            IF (FTOGCM(1:1).EQ.' ') FTOGCM(1:1)='0'
            IF (FTOGCM(2:2).EQ.' ') FTOGCM(2:2)='0'
C
          WRITE(NFIPRI,'(79(1H*),/,                       1H*,77X,1H*,/,
     *              1H*,'' THE GENERATOR COORDINATE KERNELS  WILL BE'',
     *                  '' CALCULATED BETWEEN "LEFT" STATES'', 2X,1H*,/,
     *              1H*,'' THAT ARE NUMBERED BETWEEN '',A3,'' AND '',A3,
     *                  '' AND THE "RIGHT" STATE WITH NUMBER '',A3,
     *                                                         2X,1H*,/,
     *              1H*,77X,1H*)')
     *
     *          FFRGCM,FTOGCM,FTOGCM
C
      END IF
C
C=======================================================================
C
      IF (IPAIRI.NE.1) THEN
C
          WRITE(NFIPRI,'(79(1H*),/,                   1H*,77X,1H*,/,
     *                 1H*,1X,''CALCULATIONS WITHOUT PAIRING'',
     *                                                    48X,1H*,/,
     *                                                1H*,77X,1H*)')
C
      END IF
C
C=======================================================================
C
      IF (ISPHER.EQ.1) THEN
C
          WRITE(NFIPRI,'(79(1H*),/,               1H*,77X,1H*,/,
     *             1H*,1X,''CALCULATIONS WITH THE SPHERICAL'',
     *                                          '' SYMMETRY'',
     *                                                36X,1H*,/,
     *                                            1H*,77X,1H*)')
C
      ELSE
C
          IF (ISIMPY.EQ.1) THEN
C
              IF (ISIGNY.EQ.1) THEN
C
                  WRITE(NFIPRI,'(79(1H*),/,           1H*,77X,1H*,/,
     *                     1H*,1X,''CALCULATIONS WITH'',
     *                               '' PARITY/SIGNATURE SYMMETRY'',
     *                                                    33X,1H*,/,
     *                                                1H*,77X,1H*)')
C
              ELSE
C
                  WRITE(NFIPRI,'(79(1H*),/,           1H*,77X,1H*,/,
     *                     1H*,1X,''CALCULATIONS WITH SIMPLEX'',
     *                                                '' SYMMETRY'',
     *                                                    42X,1H*,/,
     *                                                1H*,77X,1H*)')
C
              END IF
C
C=======================================================================
C
          ELSE
C
              IF (ISIQTY.EQ.1) THEN
C
                  WRITE(NFIPRI,'(79(1H*),/,           1H*,77X,1H*,/,
     *                         1H*,1X,''CALCULATIONS WITH PARITY'',
     *                                                '' SYMMETRY'',
     *                                                    43X,1H*,/,
     *                                                1H*,77X,1H*)')
C
              ELSE
C
                  IF (ISIGNY.EQ.1) THEN
C
                      WRITE(NFIPRI,'(79(1H*),/,           1H*,77X,1H*,/,
     *                             1H*,1X,''CALCULATIONS WITH'',
     *                                          '' SIGNATURE SYMMETRY'',
     *                                                        40X,1H*,/,
     *                                                    1H*,77X,1H*)')
C
                  ELSE
C
                      WRITE(NFIPRI,'(79(1H*),/,         1H*,77X,1H*,/,
     *                           1H*,1X,''CALCULATIONS WITHOUT '',
     *                                  ''SIMPLEX, SIGNATURE, OR '',
     *                                  ''PARITY SYMMETRIES'',
     *                                                      15X,1H*,/,
     *                                                  1H*,77X,1H*)')
C
                  END IF
C
              END IF
C
          END IF
C
      END IF
C
C=======================================================================
C
      WRITE(NFIPRI,'(79(1H*),/,           1H*,77X,1H*,/,
     *     1H*,1X,''CALCULATIONS WITH TIME-ODD SYMMETRIES:'',
     *         8X,''T*SIMPLEX_X => '',A3,'' CONSERVED'',
     *                                         2X,1H*,/,
     *     1H*,1X,''                                      '',
     *         8X,''T*SIMPLEX_Y => '',A3,'' CONSERVED'',
     *                                         2X,1H*,/,
     *     1H*,1X,''                                      '',
     *         8X,''T*SIMPLEX_Z => '',A3,'' CONSERVED'',
     *                                         2X,1H*,/,
     *                                    1H*,77X,1H*)')
     *
     *    NONYES(ISIMTX),NONYES(JSIMTY),NONYES(ISIMTZ)
C
C=======================================================================
C
      IF (ISYMDE.NE.0) THEN
C
          IF (ISIMPY.NE.1.AND.ISIQTY.NE.1.AND.
     *        ISIMTX.NE.1.AND.JSIMTY.NE.1.AND.ISIMTZ.NE.1) THEN
C
              WRITE(NFIPRI,'(79(1H*),/,                   1H*,77X,1H*,/,
     *                 1H*,1X,''THE ISYMDE=1 PARAMETER HAS BEEN SET I'',
     *                        ''N THE INPUT DATA. HENCE THE DENSITIES'',
     *                                                         2X,1H*,/,
     *                 1H*,1X,''WILL BE TESTED FOR PRESENCE OF ANY OF'',
     *                        '' THE THREE PLANE SYMMETRIES.         '',
     *                                                         2X,1H*,/,
     *                                                    1H*,77X,1H*)')
C
          ELSE
C
              WRITE(NFIPRI,'(79(1H*),/,                   1H*,77X,1H*,/,
     *                 1H*,1X,''ATTENTION:  THE  ISYMDE=1  PARAMETER '',
     *                        ''HAS BEEN SET IN THE INPUT DATA. HENCE'',
     *                                                         2X,1H*,/,
     *                 1H*,1X,''FOR ITERATIONS WHEN RESULTS ARE PRINT'',
     *                        ''ED, THE DENSITIES WILL BE  CALCULATED'',
     *                                                         2X,1H*,/,
     *                 1H*,1X,''WITHOUT ASSUMING ANY SPACE SYMMETRIES'',
     *                        '' AND SUBSEQUENTLY TESTED FOR PRESENCE'',
     *                                                         2X,1H*,/,
     *                 1H*,1X,''OF ANY OF THE THREE PLANE SYMMETRIES.'',
     *                        ''                                     '',
     *                                                         2X,1H*,/,
     *                                                    1H*,77X,1H*)')
C
          END IF
C
      END IF
C
C=======================================================================
C
      IF (IROTAT.EQ.1) THEN
C
          WRITE(NFIPRI,'(79(1H*),/,                     1H*,77X,1H*,/,
     *                 1H*,1X,''CALCULATIONS WITH BROKEN TIME-'',
     *                        ''REVERSAL SYMMETRY'',        29X,1H*,/,
     *                                                  1H*,77X,1H*)')
C
          IF (ITILAX.EQ.0.AND.ITISAX.EQ.0) THEN
C
              WRITE(NFIPRI,'(79(1H*),/,
     *                  1H*,77X,1H*,/,
     *                  1H*,1X,''CALCULATIONS WITH ONE-DIMENSIONAL '',
     *                         ''CRANKING '',
     *                         ''FOR THE ROTATIONAL FREQUENCIES:'',
     *                       2X,1H*,/,
     *                  1H*,77X,1H*,/,
     *                  1H*,1X,''OMEGAY ='',F9.6,'' (ISOSCALAR)'',
     *                         ''      AND       '',
     *                         ''OMISOY ='',F9.6,'' (ISOVECTOR)'',
     *                       2X,1H*,/,
     *                  1H*,77X,1H*)')
     *
     *        OMEGAY,OMISOY
C
          ELSE
C
              IF (IMOVAX.GT.0)
     *
     *            WRITE(NFIPRI,'(79(1H*),/,
     *                  1H*,77X,1H*,/,
     *                  1H*,1X,''CALCULATIONS WITH ADJUSTABLE '',
     *                         ''ISOSCALAR ROTATIONAL FREQUENCY '',
     *                         ''VECTOR,  WHICH'',2X,1H*,/,
     *                  1H*,1X,''IN EACH ITERATION IS TURNED '',
     *                         ''TO BE PARALLEL TO THE ANGULAR '',
     *                         ''MOMENTUM  VECTOR'',2X,1H*,/,
     *                  1H*,77X,1H*)')
C
              IF (IMOVAX.LT.0)
     *
     *            WRITE(NFIPRI,'(79(1H*),/,
     *                  1H*,77X,1H*,/,
     *                  1H*,1X,''CALCULATIONS WITH ADJUSTABLE '',
     *                         ''ISOSCALAR ROTATIONAL FREQUENCY '',
     *                         ''VECTOR,  WHICH'',2X,1H*,/,
     *                  1H*,1X,''IN EACH ITERATION IS TURNED '',
     *                         ''ANTI-PARALLELLY TO THE ANGULAR '',
     *                         ''MOMENTUM VECTOR'',2X,1H*,/,
     *                  1H*,77X,1H*)')
C
              IF (IMOVAX.NE.0.AND.IOCONT.EQ.0)
     *
     *            WRITE(NFIPRI,'(
     *                  1H*,1X,''DIRECTION OF THE ROTATIONAL '',
     *                         ''FREQUENCY VECTOR THAT IS GIVEN '',
     *                         ''BELOW  WILL  BE'',2X,1H*,/,
     *                  1H*,1X,''USED ONLY IN THE FIRST ITERATION, '',
     *                         ''AND LATER WILL BE IGNORED'',17X,1H*,/,
     *                  1H*,77X,1H*)')
C
              IF (IMOVAX.NE.0.AND.IOCONT.NE.0)
     *
     *            WRITE(NFIPRI,'(
     *                  1H*,1X,''DIRECTION OF THE ROTATIONAL '',
     *                         ''FREQUENCY VECTOR THAT IS GIVEN '',
     *                         ''BELOW  WILL  BE'',2X,1H*,/,
     *                  1H*,1X,''IGNORED, AND ONLY ITS LENGTH WILL '',
     *                         ''BE USED DURING THE ITERATION'',
     *                      14X,1H*,/,
     *                  1H*,77X,1H*)')
C
              IF (ITILAX.NE.0)
     *
     *            WRITE(NFIPRI,'(79(1H*),/,
     *                  1H*,77X,1H*,/,
     *                  1H*,1X,''CALCULATIONS WITH THE TILTED-AXIS '',
     *                         ''CRANKING'',34X,1H*,/,
     *                  1H*,77X,1H*,/,
     *                  1H*,1X,''FOR THE ISOSCALAR ROTATIONAL '',
     *                         ''FREQUENCIES OF:'',32X,1H*,/,
     *                  1H*,77X,1H*,/
     *                  1H*,1X,''OMEGAX ='',F9.6,2X,''OMEGAY ='',F9.6,
     *                         2X,''OMEGAZ ='',F9.6,3X,
     *                         ''OMEGA ='',F9.6,
     *                         2X,1H*,/,
     *                  1H*,77X,1H*)')
     *
     *        OMEGAX,OMEGAY,OMEGAZ,
     *        SQRT(OMEGAX**2+OMEGAY**2+OMEGAZ**2)
C
              IF (ITISAX.NE.0)
     *
     *            WRITE(NFIPRI,'(79(1H*),/,
     *                  1H*,77X,1H*,/,
     *                  1H*,1X,''CALCULATIONS WITH THE TILTED-AXIS '',
     *                         ''CRANKING'',34X,1H*,/,
     *                  1H*,77X,1H*,/,
     *                  1H*,1X,''FOR THE ISOVECTOR ROTATIONAL '',
     *                         ''FREQUENCIES OF:'',32X,1H*,/,
     *                  1H*,77X,1H*,/
     *                  1H*,1X,''OMISOX ='',F9.6,2X,''OMISOY ='',F9.6,
     *                         2X,''OMISOZ ='',F9.6,3X,
     *                         ''OMISO ='',F9.6,
     *                         2X,1H*,/,
     *                  1H*,77X,1H*)')
     *
     *        OMISOX,OMISOY,OMISOZ,
     *        SQRT(OMISOX**2+OMISOY**2+OMISOZ**2)
C
          END IF
C
          IF (IFLAGI(1).NE.0.OR.IFLAGI(2).NE.0.OR.IFLAGI(3).NE.0) THEN
C
              WRITE(NFIPRI,'(79(1H*),/,               1H*,77X,1H*,/,
     *                1H*,1X,''CALCULATIONS WITH QUADRATIC '',
     *                       ''CONSTRAINT ON SPIN:'',     29X,1H*,/,
     *                                                1H*,77X,1H*)')
              IF (IFLAGI(1).NE.0)
     *            WRITE(NFIPRI,'(
     *                1H*,1X,''X-DIRECTION: SPIN PROJECTION '',
     *                       ''CONSTRAINED TO'',F8.3,1X,
     *                       ''WITH STIFFNESS'',F8.4,       2X,1H*)')
     *            ASKEDI(1),STIFFI(1)
C
              IF (IFLAGI(2).NE.0)
     *            WRITE(NFIPRI,'(
     *                1H*,1X,''Y-DIRECTION: SPIN PROJECTION '',
     *                       ''CONSTRAINED TO'',F8.3,1X,
     *                       ''WITH STIFFNESS'',F8.4,       2X,1H*)')
     *            ASKEDI(2),STIFFI(2)
C
              IF (IFLAGI(3).NE.0)
     *            WRITE(NFIPRI,'(
     *                1H*,1X,''Z-DIRECTION: SPIN PROJECTION '',
     *                       ''CONSTRAINED TO'',F8.3,1X,
     *                       ''WITH STIFFNESS'',F8.4,       2X,1H*)')
     *            ASKEDI(3),STIFFI(3)
C
              WRITE(NFIPRI,'(                         1H*,77X,1H*,/,
     *                                                     79(1H*))')
C
          END IF
C
          IF (IFLAGA.NE.0) THEN
C
              WRITE(NFIPRI,'(79(1H*),/,               1H*,77X,1H*,/,
     *                1H*,1X,''CALCULATIONS WITH QUADRATIC '',
     *                       ''CONSTRAINT ON VECTOR PRODUCT '',
     *                       ''OMEGA TIMES SPIN:'',        2X,1H*,/,
     *                                                1H*,77X,1H*,/,
     *                1H*,1X,''                             '',
     *                       ''CONSTRAINED TO'',F8.3,1X,
     *                       ''WITH STIFFNESS'',F8.4,       2X,1H*,/,
     *                                                 1H*,77X,1H*,/,
     *                                                     79(1H*))')
     *        ASKEDA,STIFFA
C
          END IF
C
          IF (NO_ORB.EQ.1) THEN
C
              WRITE(NFIPRI,'(79(1H*),/,               1H*,77X,1H*,/,
     *                1H*,1X,''CALCULATIONS WITH CONSTRAINTS '',
     *                       ''ON THE ITRINSIC SPIN ONLY -- '',
     *                       ''NO ORBITAL PART'',          2X,1H*,/,
     *                                                 1H*,77X,1H*,/,
     *                                                     79(1H*))')
C
          END IF
C
      ELSE
C
          WRITE(NFIPRI,'(79(1H*),/,                   1H*,77X,1H*,/,
     *                 1H*,1X,''CALCULATIONS WITHOUT ROTATION'',
     *                                                    47X,1H*,/,
     *                                                1H*,77X,1H*,/,
     *                                                     79(1H*))')
C
      END IF
C
      IF (IFSHEL.GE.1) THEN
C
          WRITE(NFIPRI,'(''*'',77X,''*'',/,
     *              ''* THE SHELL CORRECTION WILL BE COMPUTED '',
     *              ''AT THE LAST ITERATION                 *'')')
C
      	  IF (IPAHFB.EQ.0) THEN
              WRITE(NFIPRI,'(''*  - BASED ON HARTREE-FOCK '',
     *              ''SINGLE-PARTICLE ENERGIES (IPAHFB=0)'',16X,''*'')')
      	  ELSE
              IF (IMFHFB.EQ.0) THEN
                  WRITE(NFIPRI,'(''*  - BASED ON HFB EQUIVALENT '',
     *                         ''SPECTRUM (IPAHFB=1 AND IMFHFB=0)'',
     *                           17X,''*'')')
              END IF
              IF (IMFHFB.EQ.1) THEN
                  WRITE(NFIPRI,'(''*  - BASED ON HFB CANONICAL '',
     *                         ''SPECTRUM (IPAHFB=1 AND IMFHFB=1)'',
     *                           18X,''*'')')
              END IF
      	  END IF
C
          IF (IFSHEL.EQ.1) THEN
              WRITE(NFIPRI,'(''*  - NOT CORRECTED FOR THE '',
     *              ''CONTRIBUTION OF CONTINUUM STATES '',
     *              ''(IFSHEL=1)'',8X,''*'')')
          ENDIF
C
          IF (IFSHEL.EQ.2) THEN
              WRITE(NFIPRI,'(''*  - CORRECTED FOR THE '',
     *              ''CONTRIBUTION OF CONTINUUM STATES '',
     *              ''(IFSHEL=2)'',12X,''*'')')
          ENDIF
C
          WRITE(NFIPRI,'(''*  - WITH: GSTRUN = '',F4.2,''  GSTRUP = '',
     *                   F4.2,''  HOMFAC = '',F8.2,''  NPOLYN = '',I2,
     *                   7X,''*'',/,''*'',77X,''*'',/,79(''*''))')
     *                  GSTRUN,GSTRUP,HOMFAC,NPOLYN
C
      END IF
C
      IF (N_COLL.GT.0) THEN
C
          DO I=1,9
             COLMUL(I)='     '
          END DO
C
          DO I_COLL=1,N_COLL
             WRITE(CURCOL,'(''('',I1,'' '',I1,'')'')')
     *                   L_COLL(I_COLL),M_COLL(I_COLL)
             COLMUL(I_COLL) = CURCOL
          END DO
C
          WRITE(NFIPRI,'(''*'',77X,''*'',/,
     *              ''* THE COLLECTIVE SPACE HAS DIMENSION '',I2,
     *              '' AND THE FOLLOWING MULTIPOLE MOMENTS   *'',/,
     *              ''* ARE INCLUDED: (L M) ='',9(1X,A5),'' *'',/,
     *              ''*'',77X,''*'',/,79(''*''),/)')
     *                  N_COLL,(COLMUL(I),I=1,9)
C
      END IF
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE ZEROUT(NMUCON,NMUMAX,NMAMAX,NSIMAX)
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      COMPLEX
     *          C_ZERO
      COMPLEX
     *          EGOGSD,EGOGSE,EGOGVD,EGOGVE,
     *          EGOTSD,EGOTSE,EGOTVD,EGOTVE,
     *          EGOSSD,EGOSSE,EGOSVD,EGOSVE,
     *          EGOPSD,EGOPSE,EGOPVD,EGOPVE,
     *          EGOMSD,EGOMSE,EGOMVD,EGOMVE
      COMPLEX
     *          PGOGSD,PGOGVD,PGOTSD,PGOTVD,
     *          PGOSSD,PGOSVD,PGOPSD,PGOPVD,
     *          PGOMSD,PGOMVD
C
      COMMON
     *       /SIGOCC/ N_OCCU(1:NDSTAT,0:NDPARI,0:NDREVE,0:NDISOS),
     *                N_VACC(1:NDSTAT,0:NDPARI,0:NDREVE,0:NDISOS)
      COMMON
     *       /SIMOCC/ L_OCCU(1:NDSTAT,0:NDREVE,0:NDISOS),
     *                L_VACC(1:NDSTAT,0:NDREVE,0:NDISOS)
      COMMON
     *       /SIQOCC/ K_OCCU(1:2*NDSTAT,0:NDPARI,0:NDISOS),
     *                K_VACC(1:2*NDSTAT,0:NDPARI,0:NDISOS)
      COMMON
     *       /SIZOCC/ M_OCCU(1:2*NDSTAT,0:NDISOS),
     *                M_VACC(1:2*NDSTAT,0:NDISOS)
      COMMON
     *       /BLODEF/ IDEBLO(0:NDISOS)
      COMMON
     *       /ANGANG/ ANGU_N(1:NDKART),ANGU_P(1:NDKART),ANGU_T(1:NDKART)
      COMMON
     *       /LINMOM/ DLINSN(0:NDKART),DLINSP(0:NDKART),DLINST(0:NDKART)
     *               ,ELINSN(0:NDKART),ELINSP(0:NDKART),ELINST(0:NDKART)
     *               ,TLINSN(0:NDKART),TLINSP(0:NDKART),TLINST(0:NDKART)
     *               ,ALINLN(0:NDKART),ALINLP(0:NDKART),ALINLT(0:NDKART)
      COMMON
     *       /SHIANG/ ANGS_N(1:NDKART),ANGS_P(1:NDKART),ANGS_T(1:NDKART)
      COMMON
     *       /QMULTI/ QMUL_N(0:NDMULT,-NDMULT:NDMULT),
     *                QMUL_P(0:NDMULT,-NDMULT:NDMULT),
     *                QMUL_T(0:NDMULT,-NDMULT:NDMULT)
      COMMON
     *       /SMULTI/ SMUL_N(0:NDMULT,-NDMULT:NDMULT),
     *                SMUL_P(0:NDMULT,-NDMULT:NDMULT),
     *                SMUL_T(0:NDMULT,-NDMULT:NDMULT)
      COMMON
     *       /AMULTI/ AMUL_N(0:NDMULT,-NDMULT:NDMULT),
     *                AMUL_P(0:NDMULT,-NDMULT:NDMULT),
     *                AMUL_T(0:NDMULT,-NDMULT:NDMULT)
      COMMON
     *       /QSHIFT/ QSHI_N(0:NDMULT,-NDMULT:NDMULT),
     *                QSHI_P(0:NDMULT,-NDMULT:NDMULT),
     *                QSHI_T(0:NDMULT,-NDMULT:NDMULT)
      COMMON
     *       /SSHIFT/ SSHI_N(0:NDMULT,-NDMULT:NDMULT),
     *                SSHI_P(0:NDMULT,-NDMULT:NDMULT),
     *                SSHI_T(0:NDMULT,-NDMULT:NDMULT)
      COMMON
     *       /ASHIFT/ ASHI_N(0:NDMULT,-NDMULT:NDMULT),
     *                ASHI_P(0:NDMULT,-NDMULT:NDMULT),
     *                ASHI_T(0:NDMULT,-NDMULT:NDMULT)
      COMMON
     *       /QROTAT/ QROT_N(0:NDMULT,-NDMULT:NDMULT),
     *                QROT_P(0:NDMULT,-NDMULT:NDMULT),
     *                QROT_T(0:NDMULT,-NDMULT:NDMULT)
      COMMON
     *       /SROTAT/ SROTNN(0:NDMULT,-NDMULT:NDMULT),
     *                SROTPP(0:NDMULT,-NDMULT:NDMULT),
     *                SROTTT(0:NDMULT,-NDMULT:NDMULT)
      COMMON
     *       /AROTAT/ AROTNN(0:NDMULT,-NDMULT:NDMULT),
     *                AROTPP(0:NDMULT,-NDMULT:NDMULT),
     *                AROTTT(0:NDMULT,-NDMULT:NDMULT)
      COMMON
     *       /QLASTR/ GALMUQ(0:NDMULT,-NDMULT:NDMULT),
     *                QLINEA(0:NDMULT,-NDMULT:NDMULT),
     *                IFLALQ(0:NDMULT,-NDMULT:NDMULT)
      COMMON
     *       /DATPAN/ GPAIRN,FACTGN,EFERMN,DELTAN,EFER2N
     *       /DATPAP/ GPAIRP,FACTGP,EFERMP,DELTAP,EFER2P
C@@@ TEMP -TEMP - TEMP - TEMP - TEMP - TEMP - TEMP - TEMP - TEMP - TEMP
      COMMON
     *       /FERFUN/ FER_FN(1:NDBASE)
     *       /FER_IS/ FERMFN(1:NDBASE,0:NDISOS)
      COMMON
     *       /SENTRO/ ENTRPY(0:NDISOS)
C@@@ TEMP -TEMP - TEMP - TEMP - TEMP - TEMP - TEMP - TEMP - TEMP - TEMP
      COMMON
     *       /EN_GOG/ EGOGSD(0:NDISOS,0:NDISOS),
     *                EGOGSE(0:NDISOS,0:NDISOS),
     *                EGOGVD(0:NDISOS,0:NDISOS),
     *                EGOGVE(0:NDISOS,0:NDISOS)
     *
     *       /EN_GTS/ EGOTSD,EGOTSE,EGOTVD,EGOTVE,
     *                EGOSSD,EGOSSE,EGOSVD,EGOSVE
     *
     *       /EN_GPM/ EGOPSD,EGOPSE,EGOPVD,EGOPVE,
     *                EGOMSD,EGOMSE,EGOMVD,EGOMVE
      COMMON
     *       /PN_GOG/ PGOGSD(0:NDISOS),PGOGVD(0:NDISOS)
     *
     *       /PN_GTS/ PGOTSD,PGOTVD,PGOSSD,PGOSVD
     *
     *       /PN_GPM/ PGOPSD,PGOPVD,PGOMSD,PGOMVD
     *
     *       /PGOGTT/ PGOGDT
C
C=======================================================================
C      THIS SUBROUTINE INITIALIZES SOME OF THE  *OUTPUT* VARIABLES
C      GENERATED BY THE CODE, WHILE THE ROUTINE PREDEF INITIALIZES
C      *INPUT* DATA.
C=======================================================================
C
      C_ZERO=CMPLX(0.0D0,0.0D0)
C
      NMUCON=0
      NMUMAX=0
      NMAMAX=0
      NSIMAX=0
C
C      Gogny force
C
      EGOGSD(:,:)=C_ZERO
      EGOGSE(:,:)=C_ZERO
      EGOGVD(:,:)=C_ZERO
      EGOGVE(:,:)=C_ZERO
C
      EGOTSD=C_ZERO
      EGOTSE=C_ZERO
      EGOTVD=C_ZERO
      EGOTVE=C_ZERO
      EGOSSD=C_ZERO
      EGOSSE=C_ZERO
      EGOSVD=C_ZERO
      EGOSVE=C_ZERO
C
      EGOPSD=C_ZERO
      EGOPSE=C_ZERO
      EGOPVD=C_ZERO
      EGOPVE=C_ZERO
      EGOMSD=C_ZERO
      EGOMSE=C_ZERO
      EGOMVD=C_ZERO
      EGOMVE=C_ZERO
C
C      Gogny pairing
C
      PGOGSD(:)=C_ZERO
      PGOGVD(:)=C_ZERO
C
      PGOTSD=C_ZERO
      PGOTVD=C_ZERO
C
      PGOSSD=C_ZERO
      PGOSVD=C_ZERO
C
      PGOPSD=C_ZERO
      PGOPVD=C_ZERO
C
      PGOMSD=C_ZERO
      PGOMVD=C_ZERO
C
C      Pairing
C
      GPAIRN=0.0D0
      GPAIRP=0.0D0
C
      EFERMN=-8.0D0
      EFERMP=-8.0D0
C
      DELTAN=1.0D0
      DELTAP=1.0D0
C
      EFER2N=0.1D0
      EFER2P=0.1D0
C
C      Temperature
C
      ENTRPY(:)=0.0D0
      FER_FN(:)=0.0D0
      FERMFN(:,:)=0.0D0
C
      IDEBLO(:)=0
C
C      Configurations
C
      N_OCCU(:,:,:,:)=0
      N_VACC(:,:,:,:)=0
C
      L_OCCU(:,:,:)=0
      L_VACC(:,:,:)=0
C
      K_OCCU(:,:,:)=0
      K_VACC(:,:,:)=0
C
      M_OCCU(:,:)=0
      M_VACC(:,:)=0
C
C      Observables related to angular and linear momentum
C
      ANGU_N(:)=0.0D0
      ANGU_P(:)=0.0D0
      ANGU_T(:)=0.0D0
C
      ANGS_N(:)=0.0D0
      ANGS_P(:)=0.0D0
      ANGS_T(:)=0.0D0
C
      DLINSN(:)=0.0D0
      DLINSP(:)=0.0D0
      DLINST(:)=0.0D0
      ELINSN(:)=0.0D0
      ELINSP(:)=0.0D0
      ELINST(:)=0.0D0
      TLINSN(:)=0.0D0
      TLINSP(:)=0.0D0
      TLINST(:)=0.0D0
      ALINLN(:)=0.0D0
      ALINLP(:)=0.0D0
      ALINLT(:)=0.0D0
C
C      Observables related to multipole moments
C
      QMUL_N(:,:)=0.0D0
      QMUL_P(:,:)=0.0D0
      QMUL_T(:,:)=0.0D0
C
      SMUL_N(:,:)=0.0D0
      SMUL_P(:,:)=0.0D0
      SMUL_T(:,:)=0.0D0
C
      AMUL_N(:,:)=0.0D0
      AMUL_P(:,:)=0.0D0
      AMUL_T(:,:)=0.0D0
C
      QSHI_N(:,:)=0.0D0
      QSHI_P(:,:)=0.0D0
      QSHI_T(:,:)=0.0D0
C
      SSHI_N(:,:)=0.0D0
      SSHI_P(:,:)=0.0D0
      SSHI_T(:,:)=0.0D0
C
      ASHI_N(:,:)=0.0D0
      ASHI_P(:,:)=0.0D0
      ASHI_T(:,:)=0.0D0
C
      QROT_N(:,:)=0.0D0
      QROT_P(:,:)=0.0D0
      QROT_T(:,:)=0.0D0
C
      SROTNN(:,:)=0.0D0
      SROTPP(:,:)=0.0D0
      SROTTT(:,:)=0.0D0
C
      AROTNN(:,:)=0.0D0
      AROTPP(:,:)=0.0D0
      AROTTT(:,:)=0.0D0
C
C      Linear constraint parameter
C
      GALMUQ(:,:)=0.0D0
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE FINPRI(NMUCON,NSICON,ISCHIF)
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      COMMON
     *       /QLASTR/ GALMUQ(0:NDMULT,-NDMULT:NDMULT),
     *                QLINEA(0:NDMULT,-NDMULT:NDMULT),
     *                IFLALQ(0:NDMULT,-NDMULT:NDMULT)
      COMMON
     *       /SLASTR/ GALMUS(0:NDMULT,-NDMULT:NDMULT),
     *                SLINEA(0:NDMULT,-NDMULT:NDMULT),
     *                IFLALS(0:NDMULT,-NDMULT:NDMULT)
      COMMON
     *       /CFIPRI/ NFIPRI
C
C=======================================================================
C
      IANYBL=0
      ITITLE=0
C
      DO LAMBDA=1,NMUCON
         DO MIU=-LAMBDA,LAMBDA
C
            IF (IFLALQ(LAMBDA,MIU).EQ.1) THEN
C
                IF (ITITLE.EQ.0) THEN
C
                    WRITE(NFIPRI,'(79(1H*),/,1H*,77X,1H*,/,
     *                    1H*,1X,''AUGMENTED MULTIPOLE CONSTRAINTS: '',
     *                           ''LAMBDA='',I2,''  MIU='',I2,2X,
     *                           ''FINAL LAGR. '',
     *                           ''PAR='',F6.3,     2X,1H*)')
     *
     *              LAMBDA,MIU,GALMUQ(LAMBDA,MIU)
C
                    IANYBL=1
                    ITITLE=1
C
                ELSE
C
                    WRITE(NFIPRI,'(
     *                    1H*,1X,''                                 '',
     *                           ''LAMBDA='',I2,''  MIU='',I2,2X,
     *                           ''FINAL LAGR. '',
     *                           ''PAR='',F6.3,     2X,1H*)')
     *
     *              LAMBDA,MIU,GALMUQ(LAMBDA,MIU)
C
                END IF
C
            END IF
C
         END DO
      END DO
C
      IF (ITITLE.EQ.1) WRITE(NFIPRI,'(1H*,77X,1H*)')
C
C=======================================================================
C
      ITITLE=0
C
      DO LAMBDA=1,NSICON
         DO MIU=-LAMBDA,LAMBDA
C
            IF (IFLALS(LAMBDA,MIU).GT.0) THEN
C
                IF (ITITLE.EQ.0) THEN
C
                    WRITE(NFIPRI,'(79(1H*),/,1H*,77X,1H*)')
C
                    IF (IFLALS(LAMBDA,MIU).EQ.2)
     *                  WRITE(NFIPRI,'(1H*,1X,
     *                           ''FOR NEUTRONS WE USE:'')')
C
                    IF (IFLALS(LAMBDA,MIU).EQ.3)
     *                  WRITE(NFIPRI,'(1H*,1X,
     *                           ''FOR PROTONS WE USE:'')')
C
                    IF (ISCHIF.EQ.1) THEN
C
                        WRITE(NFIPRI,'(1H*,1X,
     *                           ''AUGMENTED SCHIFF  CONSTRAINTS:   '',
     *                           ''LAMBDA='',I2,''  MIU='',I2,2X,
     *                           ''FINAL LAGR. '',
     *                           ''PAR='',F6.3,     2X,1H*)')
     *
     *                  LAMBDA,MIU,GALMUS(LAMBDA,MIU)
C
                    ELSE
C
                        WRITE(NFIPRI,'(1H*,1X,
     *                           ''AUGMENTED SURFACE CONSTRAINTS:   '',
     *                           ''LAMBDA='',I2,''  MIU='',I2,2X,
     *                           ''FINAL LAGR. '',
     *                           ''PAR='',F6.3,     2X,1H*)')
     *
     *                  LAMBDA,MIU,GALMUS(LAMBDA,MIU)
C
                    END IF
C
                    IANYBL=1
                    ITITLE=1
C
                ELSE
C
                    WRITE(NFIPRI,'(1H*,1X,
     *                       ''                                 '',
     *                       ''LAMBDA='',I2,''  MIU='',I2,2X,
     *                       ''FINAL LAGR. '',
     *                       ''PAR='',F6.3,     2X,1H*)')
     *
     *              LAMBDA,MIU,GALMUS(LAMBDA,MIU)
C
                END IF
C
            END IF
C
         END DO
      END DO
C
      IF (ITITLE.EQ.1) WRITE(NFIPRI,'(1H*,77X,1H*)')
      IF (IANYBL.EQ.1) WRITE(NFIPRI,'(79(1H*),/)')
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE PREDEF(IN_FIX,IZ_FIX,SKYRME,GOGNAM,ISTAND,
     *                  KETA_J,KETA_W,KETACM,KETA_M,
     *                                       KETA_R,
     *           LANODD,LANSCA,HBMSAT,RHOSAT,EFFSAT,
     *                  INNUMB,IZNUMB,FCHOM0,R0PARM,
     *                  IOPTGS,NXHERM,NYHERM,NZHERM,
     *           IPAIRI,IPAHFB,ITWOBA,IPABCS,IMFHFB,
     *                                       IPNMIX,
     *                                LIPKIN,LIPKIP,
     *                         IROTAT,ITIREP,IREVIE,
     *                  DELFIN,DELFIP,IDEFIN,IDEFIP,
     *                  FERFIN,FERFIP,IFEFIN,IFEFIP,
     *                  FE2FIN,FE2FIP,IF2FIN,IF2FIP,
     *                  INSIGN,IPSIGN,ISSIGN,IDSIGN,
     *                  INSIGP,IPSIGP,ISSIGP,IDSIGP,
     *                         INSIMN,IRSIMN,IDSIMN,
     *                         INSIMP,IRSIMP,IDSIMP,
     *                         INSIQN,IPSIQN,IDSIQN,
     *                         INSIQP,IPSIQP,IDSIQP,
     *                                INSIZN,IDSIZN,
     *                                INSIZP,IDSIZP,
     *                                IFIBLN,INIBLN,
     *                                IFIBLP,INIBLP,
     *                                       IREAWS,
     *                         ICONTI,IPCONT,IOCONT,
     *                  IACONT,IYCONT,IGCONT,IGPCON,
     *                  ILCONT,IFCONT,IMCONT,IRCONT,
     *                  NUCHAO,NUPING,EPSPNG,EPSITE,
     *                  ISPHER,ISIMPY,ISIGNY,IPARTY,
     *                         ISIMTX,ISIMTY,ISIMTZ,
     *                  IMOVAX,ITILAX,ITISAX,NO_ORB,
     *                                NOITER,NULAST,
     *                  ISYMDE,INIROT,INIINV,INIKAR,
     *                         IRENMA,IRENIN,IDOGOA,
     *                         IFRWAV,ITOWAV,IWRWAV,
     *                                ISAKER,ICHKER,
     *                         IPRGCM,IPROMI,IPROMA,
     *                         NUAKNO,NUBKNO,KPROJE,
     *                                       NBTKNO,
     *                         ISOSAD,EPSISO,ICSKIP,
     *                                       IFERME,
     *                         IPAKER,IPAALL,KFIKER,
     *                  NUASTA,NUASTO,NUGSTA,NUGSTO,
     *                  NUBSTA,NUBSTO,NUTSTA,NUTSTO,
     *                         ICUTOV,CUTOVE,CUTOVF,
     *                                ISLPRI,ISUPRI,
     *                         IENPRI,ISRPRI,IMIPRI,
     *                                IKEPRI,IRMPRI,
     *                         QMUCUT,QMACUT,QSICUT,
     *                         NOSCIL,NLIMIT,ENECUT,
     *                         NUMCOU,NUMETA,FURMAX,
     *                  ICOTYP,ICOUDI,ICOUEX,E_EFFE,
     *                  PIMASS,PNMASS,IYUTYP,I_YUKA,
     *                  YUKAGT,YUKAG0,YUKAG1,YUKAG2,
     *                                I_GOGA,IGOGPA,
     *                  I1LINE,IPRSTA,IPRMID,IPRSTO,
     *                  IDESTA,IDEMID,IDESTO,IDEDIS,
     *                                INTRIP,IVIPRI,
     *                         IPRI_N,IPRI_P,IPRI_T,
     *                         NMUCON,NMUCOU,NMUPRI,
     *                         ISCHIF,NSICON,NSIPRI,
     *                                NMACON,NMAPRI,
     *                         NMURED,NMARED,NSIRED,
     *                         NEXBET,IPRIBE,IPRIBL,
     *                         IWRIOL,IWRISO,IWRIRE,
     *                                IWRIYU,IWRIGO,
     *                                IWRILI,IWRIFI,
     *                         FILISO,FILREP,FILREC,
     *                         FILWOO,FILREV,FILCOU,
     *                                FILWAV,FILKER,
     *                                FILYUP,FILYUC,
     *                                FILGOP,FILGOC,
     *                                FILGPP,FILGPC,
     *                                FILLIP,FILLIC,
     *                                FILFIP,FILFIC,
     *                         ICHFLI,IPAFLI,IREFLI,
     *                         ISPFLI,ISHFLI,IFLIPI,
     *                  SLOWEV,SLOWOD,SLOWPA,SLOWLI,
     *                                ICOULI,ICOULO,
     *                                FACTGN,FACTGP,
     *                                EMINAL,EMAXAL,
     *                         EMAXQU,ECUTOF,LIMQUA,
     *                                       NILXYZ,
     *                                       IAVRGG,
     *                                       IPOTHO,
     *                                       EPSHER,
     *                         IFSHEL,IF_RPA,IF_THO,
     *                  PRHO_T,PRHODT,PRHOST,POWERT,
     *                  IFRAGM,NUMPUS,IFPUSH,N_COLL,
     *           DELTAE,XLOCMX,V2_MIN,ITRMAX,NTHETA,
     *                  MIN_QP,IDEALL,IDELOC,IDECON)
C
C=======================================================================
      USE hfodd_functional
      USE FRAGFL
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      CHARACTER
     *          SKYRME*4,GOGNAM*4
      CHARACTER
     *          FILREP*68,FILREC*68,FILWOO*68,
     *          FILREV*68,FILCOU*68,FILISO*68,FILWAV*68,FILKER*68,
     *          FILYUP*68,FILYUC*68,
     *          FILGOP*68,FILGOC*68,
     *          FILGPP*68,FILGPC*68,
     *          FILLIP*68,FILLIC*68,
     *          FILFIP*68,FILFIC*68
C
      DIMENSION
     *             STSALL(NDCOUP), SPMALL(NDCOUP)
      DIMENSION
     *             ATSALL(NDCOUP), APMALL(NDCOUP)
      EQUIVALENCE
     *            (STSALL,SRHO_T),(SPMALL,SRHO_P)
      EQUIVALENCE
     *            (ATSALL,ARHO_T),(APMALL,ARHO_P)
C
      COMMON
     *       /FLOPAR/ XIZFIX,XINFIX
      COMMON
     *       /EIGLIM/ EIGMIN,EIGMAX
      COMMON
     *       /SIMKPH/ KPSIMP(NDPAHO,0:NDISOS),KPSIMM(NDPAHO,0:NDISOS),
     *                KHSIMP(NDPAHO,0:NDISOS),KHSIMM(NDPAHO,0:NDISOS)
      COMMON
     *       /SIGKPH/ KPPPSP(NDPAHO,0:NDISOS),KPPPSM(NDPAHO,0:NDISOS),
     *                KPPMSP(NDPAHO,0:NDISOS),KPPMSM(NDPAHO,0:NDISOS),
     *                KHPPSP(NDPAHO,0:NDISOS),KHPPSM(NDPAHO,0:NDISOS),
     *                KHPMSP(NDPAHO,0:NDISOS),KHPMSM(NDPAHO,0:NDISOS)
      COMMON
     *       /SIQKPH/ KPSIQP(NDPAHO,0:NDISOS),KPSIQM(NDPAHO,0:NDISOS),
     *                KHSIQP(NDPAHO,0:NDISOS),KHSIQM(NDPAHO,0:NDISOS)
      COMMON
     *       /SIZKPH/ KPNONE(NDPAHO,0:NDISOS),
     *                KHNONE(NDPAHO,0:NDISOS)
      COMMON
     *       /SIMKVA/ KVASIM(         0:NDSIMP,0:NDISOS)
      COMMON
     *       /SIGKVA/ KVASIG(0:NDPARI,0:NDSIGN,0:NDISOS)
      COMMON
     *       /SIQKVA/ KVASIQ(0:NDPARI,         0:NDISOS)
      COMMON
     *       /K_FLIG/ KPFLIG(0:NDPARI,0:NDSIGN,0:NDISOS),
     *                KHFLIG(0:NDPARI,0:NDSIGN,0:NDISOS),
     *                KOFLIG(0:NDPARI,0:NDSIGN,0:NDISOS)
      COMMON
     *       /K_FLIM/ KPFLIM(         0:NDSIMP,0:NDISOS),
     *                KHFLIM(         0:NDSIMP,0:NDISOS),
     *                KOFLIM(         0:NDSIMP,0:NDISOS)
      COMMON
     *       /K_FLIQ/ KPFLIQ(0:NDPARI,         0:NDISOS),
     *                KHFLIQ(0:NDPARI,         0:NDISOS),
     *                KOFLIQ(0:NDPARI,         0:NDISOS)
      COMMON
     *       /K_FLIZ/ KPFLIZ(                  0:NDISOS),
     *                KHFLIZ(                  0:NDISOS),
     *                KOFLIZ(                  0:NDISOS)
      COMMON
     *       /K_FILG/ KPFILG(0:NDPARI,0:NDSIGN,0:NDISOS),
     *                KHFILG(0:NDPARI,0:NDSIGN,0:NDISOS),
     *                KOFILG(0:NDPARI,0:NDSIGN,0:NDISOS)
      COMMON
     *       /K_FILZ/ KPFILZ(                  0:NDISOS),
     *                KHFILZ(                  0:NDISOS),
     *                KOFILZ(                  0:NDISOS)
      COMMON
     *       /REALPH/ ALPHAR(0:NDLAMB,0:NDLAMB)
      COMMON
     *       /STSSKY/ SRHO_T,SRHO_S,SRHODT,SRHODS,
     *                SLPR_T,SLPR_S,
     *                STAU_T,STAU_S,
     *                SSCU_T,SSCU_S,
     *                SDIV_T,SDIV_S,
     *                SSPI_T,SSPI_S,SSPIDT,SSPIDS,
     *                SLPS_T,SLPS_S,
     *                SCUR_T,SCUR_S,
     *                SKIS_T,SKIS_S,
     *                SROT_T,SROT_S
      COMMON
     *       /SPMSKY/ SRHO_P,SRHO_M,SRHODP,SRHODM,
     *                SLPR_P,SLPR_M,
     *                STAU_P,STAU_M,
     *                SSCU_P,SSCU_M,
     *                SDIV_P,SDIV_M,
     *                SSPI_P,SSPI_M,SSPIDP,SSPIDM,
     *                SLPS_P,SLPS_M,
     *                SCUR_P,SCUR_M,
     *                SKIS_P,SKIS_M,
     *                SROT_P,SROT_M
      COMMON
     *       /ATSSKY/ ARHO_T,ARHO_S,ARHODT,ARHODS,
     *                ALPR_T,ALPR_S,
     *                ATAU_T,ATAU_S,
     *                ASCU_T,ASCU_S,
     *                ADIV_T,ADIV_S,
     *                ASPI_T,ASPI_S,ASPIDT,ASPIDS,
     *                ALPS_T,ALPS_S,
     *                ACUR_T,ACUR_S,
     *                AKIS_T,AKIS_S,
     *                AROT_T,AROT_S
      COMMON
     *       /APMSKY/ ARHO_P,ARHO_M,ARHODP,ARHODM,
     *                ALPR_P,ALPR_M,
     *                ATAU_P,ATAU_M,
     *                ASCU_P,ASCU_M,
     *                ADIV_P,ADIV_M,
     *                ASPI_P,ASPI_M,ASPIDP,ASPIDM,
     *                ALPS_P,ALPS_M,
     *                ACUR_P,ACUR_M,
     *                AKIS_P,AKIS_M,
     *                AROT_P,AROT_M
      COMMON
     *       /NILPAR/ CNILSN,DNILSN,CNILSP,DNILSP,
     *                HBANIX,HBANIY,HBANIZ,NILDAT
      COMMON
     *       /OMEGAS/ OMEGAX,OMEGAY,OMEGAZ
      COMMON
     *       /OMOVAS/ OMOVAX,OMOVAY,OMOVAZ
      COMMON
     *       /OMISOS/ OMISOX,OMISOY,OMISOZ
      COMMON
     *       /IANGLE/ ALPINI,BETINI,GAMINI
      COMMON
     *       /ICNSTR/ STIFFI(1:NDKART),
     *                ASKEDI(1:NDKART),
     *                IFLAGI(1:NDKART)
      COMMON
     *       /ACNSTR/ STIFFA,ASKEDA,IFLAGA
      COMMON
     *       /CCPPAI/ PRHO_N,PRHODN,PRHOSN,POWERN,
     *                PRHO_P,PRHODP,PRHOSP,POWERP
      COMMON
     *       /QCNSTR/ STIFFQ(0:NDMULT,-NDMULT:NDMULT),
     *                QASKED(0:NDMULT,-NDMULT:NDMULT),
     *                IFLAGQ(0:NDMULT,-NDMULT:NDMULT)
      COMMON
     *       /SCNSTR/ STIFFS(0:NDMULT,-NDMULT:NDMULT),
     *                SASKED(0:NDMULT,-NDMULT:NDMULT),
     *                IFLAGS(0:NDMULT,-NDMULT:NDMULT)
      COMMON
     *       /GCNSTR/ STIFFG(0:NDMULT),
     *                GASKED(0:NDMULT),
     *                IFLAGG(0:NDMULT)
      COMMON
     *       /QLASTR/ GALMUQ(0:NDMULT,-NDMULT:NDMULT),
     *                QLINEA(0:NDMULT,-NDMULT:NDMULT),
     *                IFLALQ(0:NDMULT,-NDMULT:NDMULT)
      COMMON
     *       /SLASTR/ GALMUS(0:NDMULT,-NDMULT:NDMULT),
     *                SLINEA(0:NDMULT,-NDMULT:NDMULT),
     *                IFLALS(0:NDMULT,-NDMULT:NDMULT)
      COMMON
     *       /VACCNF/ IVACUM
      COMMON
     *       /SPNUMS/ NUMBSP(0:NDREVE,0:NDISOS)
      COMMON
     *       /PAIINI/ FERINI(0:NDISOS),DELINI(0:NDISOS),FE2INI(0:NDISOS)
      COMMON
     *       /LAND_G/ X0_LAN,X1_LAN,G0_LAN,G0PLAN,G1_LAN,G1PLAN
      COMMON
     *       /PLANCK/ HBMASS,HBMRPA,HBMINP
      COMMON
     *       /SO_PAR/ W0_INP,W0PINP
      COMMON
     *       /DISTAN/ DISTAX,DISTAY,DISTAZ
      COMMON
     *       /ROTATT/ ROTATX,ROTATY,ROTATZ
      COMMON
     *       /RINORM/ HBMRIN(NDKART)
      COMMON
     *       /RINROT/ ROTRIN(NDKART)
      COMMON
     *       /BROINI/ IBROYD,N_ITER
     *       /BROMIX/ ALPHAM,BROTRI
     *       /BROMAT/ NOIINP,MIXMAT
C@@@ SHELL - SHELL - SHELL - SHELL - SHELL - SHELL - SHELL - SHELL
      COMMON
     *       /STRUTI_PARAMS/ GSTRUN,GSTRUP,HOMFAC,EPSRTN
     *       /STRUTI_POLYNO/ NPOLYN
C@@@ SHELL - SHELL - SHELL - SHELL - SHELL - SHELL - SHELL - SHELL
C SL - SL - SL - SL - SL - SL - SL - SL - SL - SL - SL - SL - SL - SL
      COMMON
     *       /SCALAPACK_INP/ NBLOCK,MBLOCK,NPGRID,MPGRID,KZHPEV
C SL - SL - SL - SL - SL - SL - SL - SL - SL - SL - SL - SL - SL - SL
C@@@ TEMP -TEMP - TEMP - TEMP - TEMP - TEMP - TEMP - TEMP - TEMP - TEMP
      COMMON
     *       /T_FLAG/ IFTEMP
      COMMON
     *       /GCTEMP/ TEMP_T
C@@@ TEMP -TEMP - TEMP - TEMP - TEMP - TEMP - TEMP - TEMP - TEMP - TEMP
      COMMON
     *       /AUTOBA/ IBASIS
      COMMON
     *       /EDFINP/ IF_EDF
     *       /EDFPAR/ V0NEFF,V0PEFF,COUSCA
      COMMON
     *       /MINDEF/ LAMINP(1:NDSEAR),MIUINP(1:NDSEAR)
     *       /MINLIM/ NUMINP,LMXINP,ITEINP
     *       /MINSTP/ STPINP
      COMMON
     *       /HFMEAN/ IHFPOT
C@@@ NECK - NECK - NECK - NECK - NECK - NECK - NECK - NECK - NECK
      COMMON
     *       /NCKVAL/ Q0NECK,G_NECK
     *       /NCKFLA/ IFNECK
C@@@ NECK - NECK - NECK - NECK - NECK - NECK - NECK - NECK - NECK
C
C=======================================================================
C         THIS SUBROUTINE SETS THE DEFAULT VALUES FOR THE INPUT DATA
C=======================================================================
C
C      Initialization of public variables of module hfodd_functional.
C      These variables are *only* used in hfodd_functional, so the
C      initialization below (to unrealistic values) should not affect
C      the rest of the code.
C
      HB00     =  20.0D0
C
      RHO_NM   =   0.1D0
      E_NM     =  10.0D0
      K_NM     = 200.0D0
      P_NM     =   0.0D0
      ASS_NM   =  50.0D0
      LASS_NM  =  50.0D0
      SMASS_NM =   1.0D0
      VMASS_NM =   1.0D0
C
      crho00   = 100.0D0
      crho0D   = 100.0D0
      crho10   = 100.0D0
      crho1D   = 100.0D0
      ctau0    = 100.0D0
      ctau1    = 100.0D0
      cdrho0   = 100.0D0
      cdrho1   = 100.0D0
      cdJ0     = 100.0D0
      cdJ1     = 100.0D0
      CJ0      = 100.0D0
      CJ1      = 100.0D0
C
      V0N      =   0.0D0
      V0P      =   0.0D0
      CExPar   =   1.0D0
C
      T0_PAR   = 100.0D0
      T1_PAR   = 100.0D0
      T2_PAR   = 100.0D0
      T3_PAR   = 100.0D0
      X0_PAR   =   1.0D0
      X1_PAR   =   1.0D0
      X2_PAR   =   1.0D0
      X3_PAR   =   1.0D0
C
      B4_PAR   =   0.0D0
      B4PPAR   =   0.0D0
      te       =   0.0D0
      to       =   0.0D0
      ALPHA    =   1.0D0
C
C=======================================================================
C
C      Minimization over deformations of the WS potential
C
      NUMPUS=1
      IFPUSH=0
C
      NUMINP=0
      LMXINP=0
      ITEINP=1
C
      STPINP=0.01
C
      LAMINP(:)=2
      MIUINP(:)=0
C
      IHFPOT=0
C
C@@@ NECK - NECK - NECK - NECK - NECK - NECK - NECK - NECK - NECK
      IFNECK=0
      G_NECK=0.0
      Q0NECK=0.0
C@@@ NECK - NECK - NECK - NECK - NECK - NECK - NECK - NECK - NECK
C
      IFRAGM = 0
C
C      Recording densities for whole nucleus, left and right fragments
C      including all/discrete/continuum q.p. states
      IDEALL = 0
      IDELOC = 0
      IDECON = 0
C
C      Rotation of q.p. wave-functions for fission fragments
      MIN_QP=0
C
      DELTAE=2.5D0
      XLOCMX=0.75D0
      V2_MIN=0.005D0
      ITRMAX=31
      NTHETA=181
C
      EIGMIN= -200.0D0
      EIGMAX=+1000.0D0
C
C      Energy functional flag, pairing strength and Coulomb exchange
C      scaling
C
      IF_EDF=0
      V0NEFF=-200.0D0
      V0PEFF=-200.0D0
      COUSCA=   1.0D0
C
C      Temperature
C
      IFTEMP=0
      TEMP_T=0.0D0
C
C      Shell correction
C
      IFSHEL=0
C
      GSTRUN=1.2D0
      GSTRUP=1.2D0
      HOMFAC=4.5D0
      EPSRTN=0.0001D0
      NPOLYN=6
C
C      Processor grid and block structure for ScaLAPACK
C
      MBLOCK=64
      NBLOCK=64
      KZHPEV=1
C
      IBROYD=0
      N_ITER=7
C
      ALPHAM=0.8D0
      BROTRI=1000.0D0
C
      MIXMAT=0
      NOIINP=4
C
C      Multi-dimensional constraints "a la Gogny"
      IF_RPA=0
C
C      Defining the size of the collective space for
C      the calculation of collective inertia
C
      N_COLL=0
C
      IF(ALLOCATED(F_FLAG)) DEALLOCATE (F_FLAG)
      ALLOCATE(F_FLAG(1:NDSTAT,0:NDREVE,0:NDISOS))
      F_FLAG(:,:,:)=1.0D0
C
C=======================================================================
C         HFBTHO INPUTS
C=======================================================================
C
      IF_THO=0
C
C=======================================================================
C         GENERAL DATA
C=======================================================================
C
      IN_FIX=86
      IZ_FIX=66
C
      XINFIX=-1.0D0
      XIZFIX=-1.0D0
C
      NOITER=50
      EPSITE=0.
      NULAST=1
C
      EPSPNG=0.
      NUPING=3
C
      NUCHAO=0
C
      IPOTHO=0
C
      IPNMIX=0
C
C=======================================================================
C         PHASE SPACE
C=======================================================================
C
      NUMBSP(:,:)=0
C
C=======================================================================
C         INTERACTION OF THE SKYRME TYPE
C=======================================================================
C
      SKYRME='SKM*'
C
      ISTAND=0
      KETA_J=1
      KETA_W=0
      KETACM=0
      KETA_M=0
C
      KETA_R=3
C
      HBMINP=20.73620941D0
C
      W0_INP=120.0
      W0PINP=120.0
C
      LANODD=0
      LANSCA=0
C
      X0_LAN=0.0
      X1_LAN=0.0
      G0_LAN=0.0
      G0PLAN=0.0
      G1_LAN=0.0
      G1PLAN=0.0
C
      HBMSAT=-1.0
      RHOSAT=-1.0
      EFFSAT=-1.0
C
      STSALL(:)=1.0D0
      SPMALL(:)=1.0D0
      ATSALL(:)=0.0D0
      APMALL(:)=0.0D0
C
C=======================================================================
C         INTERACTION OF THE GOGNY TYPE
C=======================================================================
C
      GOGNAM='D1S '
C
C=======================================================================
C         PAIRING INTERACTION
C=======================================================================
C
      FACTGN=1.0
      FACTGP=1.0
C
      IAVRGG=0
C
      PRHO_N=-200.0
      PRHODN=0.0
      PRHOSN=0.16
      POWERN=1.0
C
      PRHO_P=-200.0
      PRHODP=0.0
      PRHOSP=0.16
      POWERP=1.0
C
      PRHO_T=0.0
      PRHODT=0.0
      PRHOST=0.16
      POWERT=1.0
C
      INSIGN=1
      IPSIGN=0
      ISSIGN=0
      IDSIGN=0
C
      INSIGP=1
      IPSIGP=0
      ISSIGP=0
      IDSIGP=0
C
      INSIMN=1
      IRSIMN=0
      IDSIMN=0
C
      INSIMP=1
      IRSIMP=0
      IDSIMP=0
C
      INSIQN=1
      IPSIQN=0
      IDSIQN=0
C
      INSIQP=1
      IPSIQP=0
      IDSIQP=0
C
      INSIZN=1
      IDSIZN=0
C
      INSIZP=1
      IDSIZP=0
C
      IFIBLN=0
      INIBLN=0
C
      IFIBLP=0
      INIBLP=0
C
      FERFIN=-8.0
      FERFIP=-8.0
C
      IFEFIN=0
      IFEFIP=0
C
      FE2FIN=0.1
      FE2FIP=0.1
C
      IF2FIN=0
      IF2FIP=0
C
      DELFIN=1.0
      DELFIP=1.0
C
      IDEFIN=0
      IDEFIP=0
C
      ECUTOF=60.
      LIMQUA=0
C
      IDESTA=1
      IDEMID=0
      IDESTO=0
      IDEDIS=0
C
C=======================================================================
C         INITIAL FERMI ENERGIES AND PAIRING GAPS
C=======================================================================
C
      FERINI(0)=-8.0
      FERINI(1)=-8.0
C
      DELINI(0)= 1.0
      DELINI(1)= 1.0
C
      FE2INI(0)= 0.1
      FE2INI(1)= 0.1
C
C=======================================================================
C         EULER ANGLES OF THE INITIAL ROTATION OF THE WAVE FUNCTION
C=======================================================================
C
      ALPINI=0.0D0
      BETINI=0.0D0
      GAMINI=0.0D0
C
      INIROT=0
C
C=======================================================================
C         INDEXES OF THE INITIAL D2H TRANSFORMATION OF THE WAVE FUNCTION
C=======================================================================
C
      INIINV=0
      INIKAR=0
C
C=======================================================================
C         NUCLEON MASS RENORMALIZATION
C=======================================================================
C
      IRENMA=0
C
      DISTAX=0.0D0
      DISTAY=0.0D0
      DISTAZ=0.0D0
C
      HBMRIN(1)=1.0D0
      HBMRIN(2)=1.0D0
      HBMRIN(3)=1.0D0
C
C=======================================================================
C         NUCLEAR INERTIA RENORMALIZATION
C=======================================================================
C
      IRENIN=0
C
      ROTATX=0.0D0
      ROTATY=0.0D0
      ROTATZ=0.0D0
C
      ROTRIN(1)=1.0D0
      ROTRIN(2)=1.0D0
      ROTRIN(3)=1.0D0
C
C=======================================================================
C         GAUSSIAN OVERLAP APPROXIMATION
C=======================================================================
C
      IDOGOA=1
C
C=======================================================================
C         ANGULAR MOMENTUM/ISOSPIN PROJECTION AND THE GCM KERNELS
C=======================================================================
C
      IPRGCM=0
      IPROMI=0
      IPROMA=0
C
      NUAKNO=1
      NUBKNO=1
      KPROJE=0
C
      ISOSAD=0
      NBTKNO=1
      EPSISO=1.0D-6
      ICSKIP=0
      IFERME=0
C
      IFRWAV=1
      ITOWAV=1
      IWRWAV=0
C
      ICUTOV=0
      CUTOVE=1.0D-10
      CUTOVF=1.0D0
C
      ISLPRI=0
      ISUPRI=999
      IENPRI=1
      ISRPRI=1
      IMIPRI=1
      IKEPRI=0
      IRMPRI=0
C
      QMUCUT=0.0D0
      QMACUT=0.0D0
      QSICUT=0.0D0
C
      ISAKER=0
      ICHKER=1
C
      IPAKER=0
      IPAALL=0
      KFIKER=0
C
      NUASTA=1
      NUASTO=1
      NUGSTA=1
      NUGSTO=1
C
      NUBSTA=1
      NUBSTO=1
      NUTSTA=1
      NUTSTO=1
C
C=======================================================================
C         SYMMETRIES
C=======================================================================
C
      IROTAT=1
C
      ITIREP=0
C
      ISPHER= 0
C
      ISIMPY= 1
      ISIGNY= 1
      IPARTY=-1
C
      ISIMTX=1
      ISIMTY=-1
      ISIMTZ=1
C
      IPAIRI=0
      IPAHFB=0
      ITWOBA=0
      IPABCS=-1
C
      IMFHFB=0
C
      LIPKIN=0
      LIPKIP=0
C
C=======================================================================
C         CONFIGURATIONS
C=======================================================================
C
      IVACUM=0
C
C=======================================================================
C         CONSERVED SIGNATURE
C=======================================================================
C
      KVASIG(0,0,0)=22
      KVASIG(0,1,0)=22
      KVASIG(1,0,0)=21
      KVASIG(1,1,0)=21
C
      KVASIG(0,0,1)=16
      KVASIG(0,1,1)=16
      KVASIG(1,0,1)=17
      KVASIG(1,1,1)=17
C
      KPPPSP(:,:)=0
      KPPPSM(:,:)=0
      KPPMSP(:,:)=0
      KPPMSM(:,:)=0
C
      KHPPSP(:,:)=0
      KHPPSM(:,:)=0
      KHPMSP(:,:)=0
      KHPMSM(:,:)=0
C
C=======================================================================
C         CONSERVED SIMPLEX
C=======================================================================
C
      KVASIM(0,0)=43
      KVASIM(1,0)=43
C
      KVASIM(0,1)=33
      KVASIM(1,1)=33
C
      KPSIMP(:,:)=0
      KPSIMM(:,:)=0
C
      KHSIMP(:,:)=0
      KHSIMM(:,:)=0
C
C=======================================================================
C         CONSERVED PARITY
C=======================================================================
C
      KVASIQ(0,0)=44
      KVASIQ(1,0)=42
C
      KVASIQ(0,1)=32
      KVASIQ(1,1)=34
C
      KPSIQP(:,:)=0
      KPSIQM(:,:)=0
C
      KHSIQP(:,:)=0
      KHSIQM(:,:)=0
C
C=======================================================================
C         NON-CONSERVED SIMPLEX
C=======================================================================
C
      KPNONE(:,:)=0
      KHNONE(:,:)=0
C
C=======================================================================
C         DIABATIC BLOCKING
C=======================================================================
C
      ICHFLI=0
      IPAFLI=0
      IREFLI=0
      ISPFLI=2
      ISHFLI=1
      IFLIPI=0
C
      KPFLIG(:,:,:)=2
      KHFLIG(:,:,:)=1
      KOFLIG(:,:,:)=0
C
      KPFLIM(:,:)=2
      KHFLIM(:,:)=1
      KOFLIM(:,:)=0
C
      KPFLIQ(:,:)=2
      KHFLIQ(:,:)=1
      KOFLIQ(:,:)=0
C
      KPFLIZ(:)=2
      KHFLIZ(:)=1
      KOFLIZ(:)=0
C
C=======================================================================
C         FILLING
C=======================================================================
C
      KPFILG(:,:,:)=2
      KHFILG(:,:,:)=1
      KOFILG(:,:,:)=0
C
      KPFILZ(:)=2
      KHFILZ(:)=1
      KOFILZ(:)=0
C
C=======================================================================
C         NUMERICAL DATA
C=======================================================================
C
      NMUCON=4
      NMUCOU=4
      NMUPRI=8
C
      NSICON=0
      NSIPRI=0
C
      ISCHIF=0
C
      NMACON=0
      NMAPRI=0
C
      NMURED=2
      NMARED=1
      NSIRED=0
C
      NEXBET=4
      IPRIBE=0
      IPRIBL=1
C
      NUMCOU=80
      NUMETA=79
      FURMAX=0.25
C
      ICOTYP=7
      ICOUDI=1
      ICOUEX=1
      E_EFFE=1.0D0
C
      PIMASS=0.7045
      PNMASS=4.7565
      YUKAGT=1.0D0
      YUKAG0=0.0D0
      YUKAG1=0.0D0
      YUKAG2=0.0D0
      IYUTYP=1
      I_YUKA=0
      I_GOGA=0
      IGOGPA=0
C
      SLOWEV=0.500
      SLOWOD=0.500
      SLOWPA=0.500
      SLOWLI=0.500
C
      EPSHER=1.0D-14
C
      IOPTGS=1
C
      NXHERM=18
      NYHERM=18
      NZHERM=32
C
C=======================================================================
C         PARAMETERS OF THE HARMONIC OSCILLATOR BASIS
C=======================================================================
C
      IBASIS=0
C
      NOSCIL=15
      NLIMIT=301
      ENECUT=800.
C
      FCHOM0=1.20
C
      INNUMB=86
      IZNUMB=66
      R0PARM=1.23
C
      ALPHAR(:,:)=0.0D0
C
C      Attention: preset nuclear surface is deformed as follows
      ALPHAR(2,0)=0.61
      ALPHAR(4,0)=0.10
C
C=======================================================================
C         CONSTRAINTS
C=======================================================================
C
      IMOVAX=0
      ITILAX=0
      ITISAX=0
C
      NO_ORB=0
C
      OMOVAX=0.0D0
      OMOVAY=0.0D0
      OMOVAZ=0.0D0
C
      OMEGAX=0.00D0
      OMEGAY=0.50D0
      OMEGAZ=0.00D0
C
      OMISOX=0.00D0
      OMISOY=0.00D0
      OMISOZ=0.00D0
C
      STIFFQ(:,:)=0.0D0
      QASKED(:,:)=0.0D0
      QLINEA(:,:)=0.0D0
C
      IFLAGQ(:,:)=0
      IFLALQ(:,:)=0
C
C      Attention: there is a preset constraint on Q20 as follows
      STIFFQ(2,0)=00.01D0
      QASKED(2,0)=42.00D0
      IFLAGQ(2,0)=1
C
      STIFFS(:,:)=0.0D0
      SASKED(:,:)=0.0D0
      SLINEA(:,:)=0.0D0
C
      GALMUS(:,:)=0.0D0
C
      STIFFG(:)=0.0D0
      GASKED(:)=0.0D0
C
      IFLAGG(:)=0
C
      STIFFI(:)=0.0
      ASKEDI(:)=0.0
      IFLAGI(:)=0
C
      STIFFA=0.00D0
      ASKEDA=0.00D0
      IFLAGA=0
C
C=======================================================================
C         OUTPUT-FILE PARAMETERS
C=======================================================================
C
      I1LINE=1
      IPRSTA=1
      IPRMID=0
      IPRSTO=1
C
      INTRIP=1
      IVIPRI=0
C
      IPRI_N=1
      IPRI_P=1
      IPRI_T=1
C
      EMINAL=-12.
      EMAXAL=  0.
C
      EMAXQU=10.
C
      ISYMDE=0
C
      NILXYZ=3
C
C=======================================================================
C         FILES
C=======================================================================
C
      FILREV='HFODD.REV'
      FILREC='HFODD.REC'
      FILREP='HFODD.REP'
      FILWOO='WOODS.WFN'
      FILCOU='HFODD.COU'
      FILWAV='HFODD.WFN'
      FILKER='HFODD.KER'
      FILYUC='HFODD.YUC'
      FILYUP='HFODD.YUP'
      FILGOC='HFODD.GOC'
      FILGOP='HFODD.GOP'
      FILGPC='HFODD.GOC'
      FILGPP='HFODD.GOP'
      FILLIC='HFODD.LIC'
      FILLIP='HFODD.LIP'
      FILFIC='HFODD.FIC'
      FILFIP='HFODD.FIP'
C
      FILISO='HFODD.ISO'
C
      IWRIOL=0
      IWRISO=0
C
      IWRIRE=1
      IWRIYU=-1
      IWRIGO=-1
      IWRILI=1
      IWRIFI=-1
C
      IREVIE=2
C
      ICOULI=0
      ICOULO=0
C
C=======================================================================
C         STARTING THE ITERATION
C=======================================================================
C
      ICONTI=0
      IPCONT=0
      IOCONT=0
      IYCONT=0
      IGCONT=0
      IGPCON=0
      ILCONT=0
      IFCONT=0
      IMCONT=0
      IACONT=0
      IRCONT=0
      IREAWS=0
C
      NILDAT=0
C
      CNILSN=-1.175
      DNILSN=-0.247
C
      CNILSP=-1.175
      DNILSP=-0.352
C
      HBANIX=11.170
      HBANIY=11.170
      HBANIZ= 6.280
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE NOALLO(NAMMAT,NAMSUB)
C
      CHARACTER
     *          NAMMAT*6,NAMSUB*6
C
      COMMON
     *       /CFIPRI/ NFIPRI
C
      WRITE(NFIPRI,'(/,
     *           1X,19(1H/),'' ALLOCATION OF MEMORY FOR ARRAY: '',A6,
     *                                                   1X,19(1H/),/,
     *           1X,19(1H/),'' WAS UNSUCCESSFUL IN SUBROUTINE: '',A6,
     *                                                   1X,19(1H/),/,
     *           1X,19(1H/),'' PLEASE RERUN THE CODE USING A COMPUTER'',
     *                                                   1X,19(1H/),/,
     *           1X,19(1H/),'' THAT HAS A LARGER MEMORY. YOU MAY ALSO'',
     *                                                   1X,19(1H/),/,
     *           1X,19(1H/),'' NEED TO USE A 64-BIT FORTRAN COMPILER.'',
     *                                                   1X,19(1H/),/)')
     *          NAMMAT,NAMSUB
C
      IDUMMY=1
C
      IF (IDUMMY.EQ.1)
     *    STOP ' ALLOCATION OF MEMORY FAILED'
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE NILABS(NOSCIL,MREVER,ICHARG,ISIMPY,NILXYZ)
C=======================================================================
      USE ALLWAV
C=======================================================================
      USE hfodd_sizes
C=======================================================================
C
      CHARACTER
     *          FORMA*1,FORMB*1
      CHARACTER
     *          SPKART*10,SPNILS*15,SPORDE*13
C
      COMPLEX
     *          SPINUP,SPINDW,AUXCYL
      COMPLEX
     *          WASPUP,WASPDW,UNIT_I
      COMPLEX
     *          WASPIN,PHASPI
      COMPLEX
     *          C_ZERO,C_UNIT
C=======================================================================
      ALLOCATABLE SPINUP(:,:)
      ALLOCATABLE SPINDW(:,:)
      ALLOCATABLE AUXCYL(:,:)
C=======================================================================
      DIMENSION
     *          NSTATE(2*NDTRAN)
      DIMENSION
     *          MAINCL(2*NDTRAN),LAMBCL(2*NDTRAN),NRO_CL(2*NDTRAN),
     *          NSPICL(2*NDTRAN),IOMECL(2*NDTRAN),NZ__CL(2*NDTRAN)
C=======================================================================
      ALLOCATABLE WASPIN(:,:,:)
C=======================================================================
      COMMON
     *       /SPLABS/ SPKART(1:2*NDSTAT,0:NDISOS),
     *                SPNILS(1:2*NDSTAT,0:NDISOS),
     *                SPORDE(1:2*NDSTAT,0:NDISOS)
      COMMON
     *       /BASCLI/ NBASER(NDTRAN),
     *                NBASEP(NDTRAN),
     *                NBASEM(NDTRAN)
      COMMON
     *       /SIZCYL/ LDTRAN
      COMMON
     *       /SPIPHA/ PHASPI(1:NDBASE,0:NDREVE,0:NDSPIN)
C=======================================================================
      COMMON
     *       /SPNUMS/ NUMBSP(0:NDREVE,0:NDISOS)
      COMMON
     *       /DIMENS/ LDBASE
C
C=======================================================================
C
      CALL CPUTIM('NILABS',1)
C
C=======================================================================
C
      IALLOC=0
C
C=======================================================================
      ALLOCATE (SPINUP(1:2*NDSTAT,NDTRAN),STAT=IALLOC)
      IF (IALLOC.NE.0) CALL NOALLO('SPINUP','NILABS')
      ALLOCATE (SPINDW(1:2*NDSTAT,NDTRAN),STAT=IALLOC)
      IF (IALLOC.NE.0) CALL NOALLO('SPINDW','NILABS')
      ALLOCATE (AUXCYL(NDBASE,NDTRAN),STAT=IALLOC)
      IF (IALLOC.NE.0) CALL NOALLO('AUXCYL','NILABS')
      ALLOCATE (WASPIN(1:NDBASE,1:2*NDSTAT,0:NDSPIN),STAT=IALLOC)
      IF (IALLOC.NE.0) CALL NOALLO('WASPIN','NILABS')
C=======================================================================
C
C=======================================================================
C        THIS SUBROUTINE CALCULATES THE NILSSON LABELS
C=======================================================================
C
      UNIT_I=CMPLX(0.0D0,1.0D0)
C
      SQ2=SQRT(2.0D0)
C
C=======================================================================
C
C         DEFINING THE TWO-DIMENSIONAL MATRICES
C         < NX,NY,NZ | NRO,NZ,M >  OF THE H.O. B R A C K E T S
C
C=======================================================================
C
      CALL CYLXYZ(NOSCIL)
C
      CALL TRANSC(NOSCIL,AUXCYL,NILXYZ)
C
C=======================================================================
C        CALCULATING THE SPIN WAVE FUNCTIONS
C=======================================================================
C
      DO IREVER=0,MREVER
!$OMP PARALLEL DO
!$OMP& DEFAULT(NONE)
!$OMP& SCHEDULE(DYNAMIC)
!$OMP& SHARED(NUMBSP,IREVER,ICHARG,ISIMPY,LDBASE,
!$OMP&        WASPIN,WAVOCC,PHASPI,NILXYZ,SQ2,UNIT_I)
!$OMP& PRIVATE(ISTATE,LSTATE,IBASE,ISPIN,WASPUP,WASPDW)
         DO ISTATE=1,NUMBSP(IREVER,ICHARG)
C
            LSTATE=ISTATE+IREVER*NUMBSP(0,ICHARG)
C
            IF (LSTATE.GT.2*NDSTAT)
     *
     *          STOP ' LSTATE > 2*NDSTAT IN NILABS'
C
C=======================================================================
C           DEFINING THE WASPIN ARRAY FOR THE CONSERVED SIMPLEX
C=======================================================================
C
            IF (ISIMPY.EQ.1) THEN
C
                DO IBASE=1,LDBASE
                   DO ISPIN=0,NDSPIN
C
                      WASPIN(IBASE,LSTATE,ISPIN)=
     *                WAVOCC(IBASE,LSTATE,IREVER)
     *               *PHASPI(IBASE,IREVER,ISPIN)
C
                   END DO
                END DO
C
            ELSE
C
C=======================================================================
C           DEFINING THE WASPIN ARRAY FOR THE NON-CONSERVED SIMPLEX
C=======================================================================
C
                DO IBASE=1,LDBASE
                   DO ISPIN=0,NDSPIN
C
                      WASPIN(IBASE,LSTATE,ISPIN)=
     *
     *               (WAVOCC(IBASE,LSTATE,0)*PHASPI(IBASE,0,ISPIN)
     *               +WAVOCC(IBASE,LSTATE,1)*PHASPI(IBASE,1,ISPIN))
C
                   END DO
                END DO
C
            END IF
C
C=======================================================================
C           DEFINING THE WASPIN ARRAY FOR THE SPIN QUANTIZED ALONG THE
C           X-AXIS
C=======================================================================
C
            IF (NILXYZ.EQ.1) THEN
C
                DO IBASE=1,LDBASE
C
                   WASPUP=(WASPIN(IBASE,LSTATE,1)
     *                    +WASPIN(IBASE,LSTATE,0))/SQ2
C
                   WASPDW=(WASPIN(IBASE,LSTATE,1)
     *                    -WASPIN(IBASE,LSTATE,0))/SQ2
C
                   WASPIN(IBASE,LSTATE,1)=WASPUP
                   WASPIN(IBASE,LSTATE,0)=WASPDW
C
                END DO
C
            END IF
C
C=======================================================================
C           DEFINING THE WASPIN ARRAY FOR THE SPIN QUANTIZED ALONG THE
C           Y-AXIS
C=======================================================================
C
            IF (NILXYZ.EQ.2) THEN
C
                DO IBASE=1,LDBASE
C
                   WASPUP=(WASPIN(IBASE,LSTATE,1)
     *                    -WASPIN(IBASE,LSTATE,0)*UNIT_I)/SQ2
C
                   WASPDW=(WASPIN(IBASE,LSTATE,1)
     *                    +WASPIN(IBASE,LSTATE,0)*UNIT_I)/SQ2
C
                   WASPIN(IBASE,LSTATE,1)=WASPUP
                   WASPIN(IBASE,LSTATE,0)=WASPDW
C
                END DO
C
            END IF
C
         END DO
!$OMP END PARALLEL DO
      END DO
C
#if(USE_OPENMP==0)
      IF (LSTATE.NE.NUMBSP(0,ICHARG)+MREVER*NUMBSP(1,ICHARG))
     *
     *    STOP ' INCORRECT LSTATE IN NILABS'
#endif
C
C=======================================================================
C            J U S T   M U L T I P L Y I N G   M A T R I C E S
C=======================================================================
C            ATTENTION: THE CALL TO "ZGEMM" BELOW BECAME INCORRECT  WHEN
C                       THE NUMBER OF SINGLE-PARTICLE  STATES  HAS  BEEN
C                       IN  VERSION  (1.84)  REDUCED  FROM  "NDBASE"  TO
C                       "NDSTAT". THIS BUG WAS CORRECTED  ON  09/02/2004
C                       IN VERSION (2.08F).
C=======================================================================
C            ATTENTION: THE CALL TO "ZGEMUL" BELOW BECAME INCORRECT WHEN
C                       THE NUMBER OF  TESTED  AMPLITUDES  HAS  BEEN  IN
C                       VERSION (1.60) REDUCED FROM "NDTRAN" TO "NDBASE"
C                       THIS BUG DID NOT AFFECT  RESULTS  OF  THE  CALL;
C                       ONLY THE INDICES IN "ZGEMUL" WERE RUNNING BEYOND
C                       DIMENSIONS  TRANSFERRED  TO  "ZGEMUL".  HOWEVER,
C                       WHEN THE NUMBER OF  SINGLE-PARTICLE  STATES  HAS
C                       BEEN IN VERSION  (1.84)  REDUCED  FROM  "NDBASE"
C                       TO "NDSTAT", THIS BECAME A REAL BUG IN CASE  THE
C                       DIMENSIONS WERE SUCH THAT 2*NDSTAT > NDBASE, AND
C                       THE TIME-REVERSAL  WAS  BROKEN  (IROTAT=1). THIS
C                       BUG WAS CORRECTED ON 09/02/04 IN VERSION (2.08F)
C=======================================================================
C
      C_ZERO=CMPLX(0.0D0,0.0D0)
      C_UNIT=CMPLX(1.0D0,0.0D0)
C
      FORMA='T'
      FORMB='N'
C
      LSTATE=NUMBSP(0,ICHARG)+MREVER*NUMBSP(1,ICHARG)
C
      NDACTU=2*NDSTAT
C
      CALL ZGEMM(FORMA,FORMB,LSTATE,LDTRAN,LDBASE,
     *                C_UNIT,WASPIN(1,1,0),NDBASE,
     *                              AUXCYL,NDBASE,
     *                       C_ZERO,SPINDW,NDACTU)
C
      CALL ZGEMM(FORMA,FORMB,LSTATE,LDTRAN,LDBASE,
     *                C_UNIT,WASPIN(1,1,1),NDBASE,
     *                              AUXCYL,NDBASE,
     *                       C_ZERO,SPINUP,NDACTU)
C
C=======================================================================
C         COLLECTING THE QUANTUM NUMBERS OF THE CYLINDRICAL BASIS
C=======================================================================
C
      NBASE=0
C
      DO JCYLIN=1,LDTRAN
C
         NRO=NBASER(JCYLIN)
         NZ =NBASEP(JCYLIN)
         M  =NBASEM(JCYLIN)
C
         DO NSPIN=-1,1,2
C
            NBASE=NBASE+1
C
            IF (NBASE.GT.2*NDTRAN) STOP 'INCORRECT NDTRAN IN NILABS'
C
            MAINCL(NBASE)=2*NRO+NZ+M
            LAMBCL(NBASE)=M
            NRO_CL(NBASE)=NRO
            NZ__CL(NBASE)=NZ
            NSPICL(NBASE)=NSPIN
            IOMECL(NBASE)=2*LAMBCL(NBASE)+NSPIN
            NSTATE(NBASE)=JCYLIN
C
         END DO
      END DO
C
C=======================================================================
C         FINDING THE COMPONENTS WITH MAXIMUM AMPLITUDES
C=======================================================================
C
      DO ISTATE=1,LSTATE
C
         INDMAX=0
         ELEMAX=-1.0
C
         DO IBASE=1,NBASE
C
            IF (NSPICL(IBASE).EQ.1) THEN
C
                AMPLIT=ABS(SPINUP(ISTATE,NSTATE(IBASE)))
            ELSE
                AMPLIT=ABS(SPINDW(ISTATE,NSTATE(IBASE)))
C
            END IF
C
            IF (ELEMAX.LT.AMPLIT) THEN
C
                INDMAX=IBASE
                ELEMAX=AMPLIT
C
            END IF
C
         END DO
C
         IF (INDMAX.LE.0.OR.INDMAX.GT.2*LDTRAN)
     *
     *       STOP '  WRONG INDMAX INDEX IN NILABS'
C
         MAIN=MAINCL(INDMAX)
         NZ  =NZ__CL(INDMAX)
         LAMB=LAMBCL(INDMAX)
         IOME=IOMECL(INDMAX)
C
         WRITE(SPNILS(ISTATE,ICHARG),
     *                  '(''|'',I2,'','',I2,'','',I2,'','',I2,''/2>'')')
     *                                     MAIN,NZ,ABS(LAMB),ABS(IOME)
C
      END DO
C
C=======================================================================
      DEALLOCATE (SPINUP,SPINDW,AUXCYL)
      DEALLOCATE (WASPIN)
C=======================================================================
C
      CALL CPUTIM('NILABS',0)
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE CYLXYZ(NPERPE)
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      COMPLEX
     *          COEFFC(0:NDPERP,0:NDPERP,0:NDPERP),COF,WSP
      DIMENSION
     *          FACTRL(0:NDPERP),XNEWTN(0:NDPERP,0:NDPERP),
     *          SQFCTL(0:NDPERP),SQ2PWR(0:NDPERP)
      COMMON
     *       /CNXNY / COEFFC
      SAVE
     *     INIT,FACTRL,XNEWTN,SQFCTL,SQ2PWR,SQ2
      DATA
     *     INIT  / -1 /
C
C=======================================================================
C
C        THIS SUBROUTINE CALCULATES THE TRANSFORMATION BRACKETS BETWEEN
C        THE CARTESIAN AND CYLINDRICAL BASES OF THE TWO-DIMENSIONAL HAR-
C        MONIC OSCILLATOR.
C
C        THE CALCULATIONS ARE PERFORMED FOR ALL VALUES OF N-PERPENDICU-
C        LAR UP TO NPERPE. ROUTINE DOES N O T  RECALCULATE THE ELEMENTS
C        ALREADY CALCULATED. IF CALLED MORE TIMES ONLY THE NEW ELEMENTS
C        WILL BE ADDED TO THE STORAGE ARRAY.
C
C        THE RESULTS ARE STORED IN THE COMPLEX ARRAY  'COEFFC' IN COMMON
C        "CNXNY". THE INDICES  OF  THE STORAGE ARRAY HAVE THE FOLLOWING
C        MEANING:
C
C                COEFFC(NX,NRO,NPERP) = <NX,NY|NRO,LAMBDA>
C
C        WHERE:       NX+NY = 2*NRO+LAMBDA = NPERP
C        I.E.         NY=NPERP-NX;  LAMBDA=NPERP-2*NRO
C                     (NX,NRO = 0,1,2,...,NPERP)
C
C=======================================================================
C        SEE  NOTES  "CO" FOR THE DERIVATION OF FORMULAE  AND SYMMETRIES
C        USED.
C=======================================================================
C=============================================== T.R.WERNER, AUGUST 1992
C=======================================================================
C
      IF (NPERPE.LT.     0) STOP 'NPER/ZER'
      IF (NPERPE.GT.NDPERP) STOP 'NPER/DIM'
C
      IF (INIT.EQ.-1) THEN
C
          FACTRL(0)    =1.D0
          SQFCTL(0)    =1.D0
          SQ2PWR(0)    =1.D0
          XNEWTN(0,0)  =1.D0
C
          COEFFC(0,0,0)=CMPLX(1.0D0,0.0D0)
          SQ2          = SQRT(2.D0)
C
          INIT=0
C
      END IF
C
      INIT=INIT+1
C
      IF (NPERPE.LT.INIT) THEN
C
          INIT=INIT-1
          RETURN
C
      END IF
C
      DO NPER=INIT,NPERPE
         DO NRO=INIT,NPERPE
            DO NX=INIT,NPERPE
               COEFFC(NX,NRO,NPER)=CMPLX(0.0D0,0.0D0)
            END DO
         END DO
      END DO
C
C=======================================================================
C         FACTRL(N)   IS THE FACTORIAL OF N
C         SQFCTL(N)   IS THE SQUARE ROOT OF THE FACTORIAL OF N
C         SQ2PWR(N)   IS THE SQUARE ROOT OF THE N-TH POWER OF 2
C         XNEWTN(N,K) IS NEWTON'S SYMBOL "N OVER K"
C=======================================================================
C
      DO I=INIT,NPERPE
C
         FACTRL(I)=FACTRL(I-1)*REAL(I,KIND=8)
         SQFCTL(I)=SQRT(FACTRL(I))
         SQ2PWR(I)=SQ2PWR(I-1)*SQ2
C
         DO K=0,I
            XNEWTN(I,K)=(FACTRL(I)/FACTRL(K))/FACTRL(I-K)
         END DO
C
      END DO
C
C=======================================================================
C                       M A I N   L O O P
C=======================================================================
C
      IPE=2*MOD(INIT,2)-1
C
      DO NPER=INIT,NPERPE
C
         IPX=  -1
         IPY= IPE
         IPE=-IPE
C
         DO NX=0,NPER/2
C
            NY=NPER-NX
            IPX=-IPX
            IPY=-IPY
C
            DO NRO=0,NPER/2
C
               NROPRI=NPER-NRO
               LAMBDA=NPER-2*NRO
               NNNN  =(NPER-LAMBDA)/2
C
               KMIN  =MAX(0,(NX-LAMBDA+1)/2)
               KMAX  =MIN(NNNN,NX/2)
C
               IF (KMAX.GE.KMIN) THEN
C
                   FCT=0.0D0
                   IFA=1-2*MOD(KMIN,2)
C
                   DO K=KMIN,KMAX
                      FCT=FCT+IFA*XNEWTN(NNNN,K)*XNEWTN(LAMBDA,NX-2*K)
                      IFA=-IFA
                   END DO
C
                   FCT=FCT*(SQFCTL(NX)/SQFCTL(NPER-NRO))*SQFCTL(NY)
     *                                    /SQFCTL(NRO)/SQ2PWR(NPER)
C
                   COF=(CMPLX(0.0D0,1.0D0)**(LAMBDA-NX))*FCT
                   COEFFC(NX,NRO,NPER)=COF
C
                   IF (NRO.NE.NROPRI) COEFFC(NX,NROPRI,NPER)=COF*IPY
C
                   IF (NX.NE.NY) THEN
C
                      WSP=CMPLX(0.0D0,-1.0D0)**LAMBDA
                      COEFFC(NY,NRO,NPER)=COF*IPX*WSP
                      IF (NRO.NE.NROPRI) COEFFC(NY,NROPRI,NPER)=COF*WSP
C
                   END IF
C
               END IF
C
            END DO
         END DO
      END DO
C
      INIT=NPERPE
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE TRANSC(NMAIN,AUXCYL,NILXYZ)
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      DIMENSION
     *          AUXCYL(NDBASE,NDTRAN)
C
      COMPLEX
     *          COEFFC(0:NDPERP,0:NDPERP,0:NDPERP)
      COMPLEX
     *          AUXCYL
C
      COMMON
     *       /BASISO/ NXVECT(1:NDBASE),NYVECT(1:NDBASE),NZVECT(1:NDBASE)
      COMMON
     *       /BASCLI/ NBASER(NDTRAN),
     *                NBASEP(NDTRAN),
     *                NBASEM(NDTRAN)
      COMMON
     *       /SIZCYL/ LDTRAN
      COMMON
     *       /CNXNY / COEFFC
      COMMON
     *       /DIMENS/ LDBASE
C
C=======================================================================
C
C         THIS SUBROUTINE PUTS THE TRANSFORMATION COEFFICIENTS
C         < NX,NY,NZ | NRHOX,NX,MX >  (FOR NILXYZ=1)
C         < NX,NY,NZ | NRHOY,NY,MY >  (FOR NILXYZ=2)
C         < NX,NY,NZ | NRHOZ,NZ,MZ >  (FOR NILXYZ=3)
C         INTO A 2-DIMENSIONAL ARRAY.
C
C=======================================================================
C
      ICOUNT=0
C
C=======================================================================
C         CALCULATION FOR THE CYLINDRICAL COORDINATE VARIANT
C=======================================================================
C
      DO NTOT=0,NMAIN
         DO NPAR=0,NTOT
            NPER=NTOT-NPAR
            DO NRHO=0,NPER
               MPAR=NPER-2*NRHO
C
               ICOUNT=ICOUNT+1
C
               NBASER(ICOUNT) = NRHO
               NBASEP(ICOUNT) = NPAR
               NBASEM(ICOUNT) = MPAR
C
            END DO
         END DO
      END DO
C
C=======================================================================
C
      LDTRAN=ICOUNT
C
      IF (LDTRAN.GT.NDTRAN) STOP ' LDTRAN.GT.NDTRAN IN TRANSC'
C
      DO I=1,LDBASE
C
         NX=NXVECT(I)
         NY=NYVECT(I)
         NZ=NZVECT(I)
C
         DO J=1,LDTRAN
C
            NRHO=NBASER(J)
            NPAR=NBASEP(J)
            MPAR=NBASEM(J)
C
            AUXCYL(I,J)=CMPLX(0.0D0,0.0D0)
C
            IF (NX.EQ.NPAR.AND.(NY+NZ).EQ.(2*NRHO+MPAR).AND.NILXYZ.EQ.1)
     *
     *          AUXCYL(I,J)=CONJG(COEFFC(NY,NRHO,NY+NZ))
C
            IF (NY.EQ.NPAR.AND.(NZ+NX).EQ.(2*NRHO+MPAR).AND.NILXYZ.EQ.2)
     *
     *          AUXCYL(I,J)=CONJG(COEFFC(NZ,NRHO,NZ+NX))
C
            IF (NZ.EQ.NPAR.AND.(NX+NY).EQ.(2*NRHO+MPAR).AND.NILXYZ.EQ.3)
     *
     *          AUXCYL(I,J)=CONJG(COEFFC(NX,NRHO,NX+NY))
C
         END DO
      END DO
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
C=======================================================================
C
      SUBROUTINE THOXYZ(NPERPE)
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      COMPLEX
     *          COF,UNIT_I
      COMPLEX
     *          COEFFC,FACTOR
C
      DIMENSION
     *          FACTRL(0:NDPERP),XNEWTN(0:NDPERP,0:NDPERP),
     *          SQFCTL(0:NDPERP),SQ2PWR(0:NDPERP)
      COMMON
     *       /THOCOF/ COEFFC(0:NDPERP,0:NDPERP,0:NDPERP)
C
C=======================================================================
C
C        THIS SUBROUTINE CALCULATES THE TRANSFORMATION BRACKETS BETWEEN
C        THE CARTESIAN AND CYLINDRICAL BASES OF THE TWO-DIMENSIONAL HAR-
C        MONIC OSCILLATOR.
C
C        THE CALCULATIONS ARE PERFORMED FOR ALL VALUES OF N-PERPENDICU-
C        LAR UP TO NPERPE. ROUTINE DOES N O T  RECALCULATE THE ELEMENTS
C        ALREADY CALCULATED. IF CALLED MORE TIMES ONLY THE NEW ELEMENTS
C        WILL BE ADDED TO THE STORAGE ARRAY.
C
C        THE RESULTS ARE STORED IN THE COMPLEX ARRAY  'COEFFC' IN COMMON
C        "CNXNY". THE INDICES  OF  THE STORAGE ARRAY HAVE THE FOLLOWING
C        MEANING:
C
C                COEFFC(NX,NRO,NPERP) = <NX,NY|NRO,LAMBDA>
C
C        WHERE:       NX+NY = 2*NRO+LAMBDA = NPERP
C        I.E.         NY=NPERP-NX;  LAMBDA=NPERP-2*NRO
C                     (NX,NRO = 0,1,2,...,NPERP)
C
C=======================================================================
C
      CALL CPUTIM('THOXYZ',1)
C
C=======================================================================
C
      IF (NPERPE.LT.     0) STOP 'NPER/ZER'
      IF (NPERPE.GT.NDPERP) STOP 'NPER/DIM'
C
      SQ2=SQRT(2.0D0)
      UNIT_I=CMPLX(0.0D0,1.0D0)
C
      FACTRL(0)=1.0D0
      SQFCTL(0)=1.0D0
      SQ2PWR(0)=1.0D0
C
      XNEWTN(0,0)=1.0D0
C
      COEFFC(0,0,0)=CMPLX(1.0D0,0.0D0)
C
      DO NPER=0,NPERPE
         DO NRO=0,NPERPE
            DO NX=0,NPERPE
               COEFFC(NX,NRO,NPER)=CMPLX(0.0D0,0.0D0)
            END DO
         END DO
      END DO
C
C=======================================================================
C         FACTRL(N)   IS THE FACTORIAL OF N
C         SQFCTL(N)   IS THE SQUARE ROOT OF THE FACTORIAL OF N
C         SQ2PWR(N)   IS THE SQUARE ROOT OF THE N-TH POWER OF 2
C         XNEWTN(N,K) IS NEWTON'S SYMBOL "N OVER K"
C=======================================================================
C
      DO I=1,NPERPE
C
         FACTRL(I)=FACTRL(I-1)*REAL(I,KIND=8)
         SQFCTL(I)=SQRT(FACTRL(I))
         SQ2PWR(I)=SQ2PWR(I-1)*SQ2
C
         DO K=0,I
            XNEWTN(I,K)=(FACTRL(I)/FACTRL(K))/FACTRL(I-K)
         END DO
C
      END DO
C
C=======================================================================
C                       M A I N   L O O P
C=======================================================================
C
      DO NPER=0,NPERPE
C
         DO NX=0,NPER
C
            NY=NPER-NX
C
            DO NRO=0,NPER/2
C
               NROPRI=NPER-NRO
               LAMBDA=NPER-2*NRO
C
               KMIN  = MAX(0,NX-NRO)
               KMAX  = MIN(NX,NPER-NRO)
C
               IF (KMAX .GE. KMIN) THEN
C
                   FCT=0.0
C
                   DO K=KMIN,KMAX
                      FCT=FCT+XNEWTN(NX,K)/(FACTRL(K+NRO-NX)
     *                                     *FACTRL(NRO+LAMBDA-K))
     *                                     *(-1)**K
                   END DO
C
                   FCT=FCT*(SQFCTL(NRO)*SQFCTL(NPER-NRO)*SQFCTL(NY))
     *                                 /SQFCTL(NX)/SQ2PWR(NPER)
C
                   COF=FCT*(-UNIT_I)**NY*(-1)**LAMBDA
C
                   COEFFC(NX,NRO,NPER)=COF
C
                   IF (NROPRI.NE.NRO)
     *                 COEFFC(NX,NROPRI,NPER)
     *                =CONJG(COF)*(-1)**LAMBDA
C
               END IF
C
            END DO
         END DO
      END DO
C
C=======================================================================
C
      CALL CPUTIM('THOXYZ',0)
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE THOMAT(NMAIN,NILXYZ,IF_THO,NMAX)
C=======================================================================
      USE hfodd_interface
      USE CYLTRA
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      COMPLEX
     *          COEFFC
C
      COMMON
     *       /BASISO/ NXVECT(1:NDBASE),NYVECT(1:NDBASE),NZVECT(1:NDBASE)
      COMMON
     *       /BASCLI/ NBASER(NDTRAN),
     *                NBASEP(NDTRAN),
     *                NBASEM(NDTRAN)
      COMMON
     *       /SIZCYL/ LDTRAN
      COMMON
     *       /THOCOF/ COEFFC(0:NDPERP,0:NDPERP,0:NDPERP)
      COMMON
     *       /DIMENS/ LDBASE
C
C=======================================================================
C
C     THIS SUBROUTINE PUTS THE TRANSFORMATION COEFFICIENTS
C           < NX,NY,NZ | NRHOX,NX,MX >  (FOR NILXYZ=1)
C           < NX,NY,NZ | NRHOY,NY,MY >  (FOR NILXYZ=2)
C           < NX,NY,NZ | NRHOZ,NZ,MZ >  (FOR NILXYZ=3)
C     INTO A 2-DIMENSIONAL ARRAY.
C      - IF_THO=0: USED FOR THE CALCULATION OF THE NILSSON LABELS
C                  IN STANDARD HFODD CALCULATIONS. PRNCIPAL OSCILLATOR
C             	   NUMBER IS 'NMAIN' (=NOSCIL)
C      - IF_THO=1: USED BOTH IN THE BASIS TRANSFORMATION FROM HFBTHO
C                  TO HFODD (SUBROUTINE CYLCAR) AND FOR THE CALCULATION
C                  OF NILSSON LABELS. PRINCIPAL OSCILLATOR NUMBER IS
C                  'NMAX'.
C                  SEE SUBROUTINE CYLCAR FOR MORE COMMENTS
C
C=======================================================================
C
      CALL CPUTIM('THOMAT',1)
C
C=======================================================================
C
      ICOUNT=0
C
C=======================================================================
C         CALCULATION FOR THE CYLINDRICAL COORDINATE VARIANT
C=======================================================================
C
      IF (IF_THO.EQ.0) THEN
C
          DO NTOT=0,NMAIN
             DO MZ=0,NTOT
                NPER=NTOT-MZ
                DO NRHO=0,NPER
                   MPAR=NPER-2*NRHO
C
                   ICOUNT=ICOUNT+1
C
                   NBASER(ICOUNT) = NRHO
                   NBASEP(ICOUNT) = MZ
                   NBASEM(ICOUNT) = MPAR
C
                END DO
             END DO
          END DO
C
      ELSE
C
          DO NTOT=0,NMAX
             DO MZ=0,NMAX
                NPER=NTOT-MZ
                DO NRHO=0,NPER
                   MPAR=NPER-2*NRHO
C
                                       NR=NRHO
                   IF (NRHO.GT.NPER/2) NR=NPER-NRHO
C
                   M=ABS(MPAR)
C
                   IF (validate_HFBTHO(NTOT,MZ,NR,M).EQ.1) THEN
C
                       ICOUNT=ICOUNT+1
C
                       NBASER(ICOUNT) = NRHO
                       NBASEP(ICOUNT) = MZ
                       NBASEM(ICOUNT) = MPAR
C
                   END IF
C
                END DO
             END DO
          END DO
C
      END IF
C
C=======================================================================
C
      IF (IF_THO.EQ.1) THEN
          IF (LDTRAN.NE.NsizeHFBTHO) STOP 'ERROR LDTRAN'
          IF (LDBASE.NE.NsizeHFODD) THEN
              WRITE(6,'(''LDBASE = '',i6,'' NsizeHFODD = '',i6)')
     *                    LDBASE,NsizeHFODD
              STOP 'ERROR LDBASE'
          END IF
      END IF
C
      IF (LDTRAN.GT.NDTRAN) STOP ' LDTRAN.GT.NDTRAN IN THOMAT'
C
      IF (.NOT.ALLOCATED(AUXCYL)) ALLOCATE(AUXCYL(1:LDBASE,1:LDTRAN))
C
      DO J=1,LDTRAN
C
         NRHO=NBASER(J)
         NPAR=NBASEP(J)
         MPAR=NBASEM(J)
C
         DO I=1,LDBASE
C
            MX=NXVECT(I)
            MY=NYVECT(I)
            MZ=NZVECT(I)
C
            AUXCYL(I,J)=CMPLX(0.0D0,0.0D0)
C
            IF (MX.EQ.NPAR.AND.(MY+MZ).EQ.(2*NRHO+MPAR).AND.NILXYZ.EQ.1)
     *
     *          AUXCYL(I,J)=COEFFC(MY,NRHO,MY+MZ)
C
            IF (MY.EQ.NPAR.AND.(MZ+MX).EQ.(2*NRHO+MPAR).AND.NILXYZ.EQ.2)
     *
     *          AUXCYL(I,J)=COEFFC(MZ,NRHO,MZ+MX)
C
            IF (MZ.EQ.NPAR.AND.(MX+MY).EQ.(2*NRHO+MPAR).AND.NILXYZ.EQ.3)
     *
     *          AUXCYL(I,J)=COEFFC(MX,NRHO,MX+MY)
C
         END DO
      END DO
C
C=======================================================================
C
      CALL CPUTIM('THOMAT',0)
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE CYLCAR(NOSCIL,ISIMPY,IF_THO)
C=======================================================================
      USE hfodd_interface
      USE CYLTRA
      USE MAF_PP
      USE MAF_PM
      USE MAP_PP
C=======================================================================
      USE hfodd_sizes
C=======================================================================
C
      COMPLEX
     *          C_UNIT,C_ZERO,PHASPI
C
C=======================================================================
      COMPLEX, DIMENSION(:,:), ALLOCATABLE ::
     *                         TRANSM,TRAINV,SPINDW,AUXMAT
C=======================================================================
      COMMON
     *       /SPIPHA/ PHASPI(1:NDBASE,0:NDREVE,0:NDSPIN)
      COMMON
     *       /SIZCYL/ LDTRAN
      COMMON
     *       /DIMENS/ LDBASE
C
C=======================================================================
C
C     THIS SUBROUTINE PERFORMS THE  'HFBTHO'  TO  'HFODD'  BASIS
C     TRANSFORMATION BY INVOKING FIRST A STANDARD CYLINDRICAL TO
C     CARTESIAN BASIS TRANSFORMATION FOLLOWED BY A UNITARY PHASE
C     TRANSFORMATION.
C
C     THE REQUIRED INPUTS FROM HFBTHO  ARE PASSED THROUGH MODULE
C     hfodd_interface AND ARE:
C      - NmxTHO         : PRINCIPAL QUANTUM NUMBER N.
C      - NsizeHFBTHO    : ACTUAL NUMBER OF STATES IN HFBTHO BASIS.
C      - validate_HFBTHO: 4D-ARRAY FLAGGING IF THE STATE CHARACTE-
C                         RIZED BY QUANTUM NUMBERS N,  nz, nr AND
C                         Lambda IS PART OF HFBTHO BASIS.
C      - HF_PHN,HF_PHP  : THE MATRICES OF THE HF MEAN-FIELD 'h' IN
C                         HFBTHO (NEUTRONS AND PROTONS).
C      - HF_PPN,HF_PPP  : THE MATRICES OF THE PAIRING FIELD 'delta'
C                         IN HFBTHO (NEUTRONS AND PROTONS).
C
C NOTA BENE: HFBTHO BASIS STATE COUNTING CONVENTIONS ARE DIFFERENT
C            FROM HFODD. IN HFODD ALL LOOPS OVER  NX, NY AND NZ GO
C            FROM 0 TO NOSCIL. IN  HFBTHO, ALL LOOPS CORRESPOND TO
C            A MAXIMUM QUANTUM NUMBER N = 50, EXCEPT NZ, WHICH CAN
C            NOT EXCEED NOSCIL. IN BOTH CODES THE BASIS CUT-OFF IS
C            ENERGY BASED, I.E., E(NX,NY,NZ) < ENECUT (HFODD)  AND
C            E(NR,NZ,LAMBDA) < ENECUT (HFBTHO).  THESE   DIFFERENT
C            CONVENTIONS DO NOT MATTER FOR   SPHERICAL  BASES. FOR
C            DEFORMED  BASES, THEY WOULD LEAD TO  DIFFERENT  STATE
C            COMPOSITION IF  SPECIAL  MEASURES WERE NOT TAKEN.  IN
C            THE CURRENT IMPLEMENTATION, THE 4D-ARRAY  indexHFBTHO
C            INDICATES IF A STATE WITH  GIVEN  CYLINDRICAL QUANTUM
C            NUMBERS IS PART OF HFBTHO BASIS.
C
C=======================================================================
C
      CALL CPUTIM('CYLCAR',1)
C
C=======================================================================
C      COMPUTING THE SIZE OF MATRICES FOR ARRAY ALLOCATIONS
C=======================================================================
C
      ICOUNT=0
C
      IF (IF_THO.EQ.0) THEN
C
          DO NTOT=0,NOSCIL
             DO MZ=0,NTOT
                NPER=NTOT-MZ
                DO NRHO=0,NPER
                   ICOUNT=ICOUNT+1
                END DO
             END DO
          END DO
C
      ELSE
C
          DO NTOT=0,NmxTHO
             DO MZ=0,NOSCIL
                NPER=NTOT-MZ
                DO NRHO=0,NPER
                   MPAR=NPER-2*NRHO
C
                                       NR=NRHO
                   IF (NRHO.GT.NPER/2) NR=NPER-NRHO
C
                   M=ABS(MPAR)
C
                   IF (validate_HFBTHO(NTOT,MZ,NR,M).EQ.1)
     *                 ICOUNT=ICOUNT+1
C
                END DO
             END DO
          END DO
C
      END IF
C
      LDTRAN=ICOUNT
C
C=======================================================================
C      CYLINDRICAL TO CARTESIAN  BASIS  TRANFORMATION. MATRIX OF THE
C      TRANSFORMATION IS STORED IN TRANSM, THE MATRIX OF THE INVERSE
C      TRANFORMATION (HERMITIAN CONJUGATE) IN TRAINV.
C=======================================================================
C
      IALLOC=0
C
      ALLOCATE (AUXCYL(LDBASE,LDTRAN),STAT=IALLOC)
      IF (IALLOC.NE.0) CALL NOALLO('AUXCYL','CYLCAR')
C
      CALL THOXYZ(NmxTHO)
C
      NILXYZ=3
      CALL THOMAT(NOSCIL,NILXYZ,IF_THO,NmxTHO)
C
      ALLOCATE (TRANSM(1:LDBASE,1:LDTRAN),STAT=IALLOC)
      IF (IALLOC.NE.0) CALL NOALLO('SPINUP','CYLCAR')
      ALLOCATE (TRAINV(1:LDTRAN,1:LDBASE),STAT=IALLOC)
      IF (IALLOC.NE.0) CALL NOALLO('WASPIN','CYLCAR')
C
      TRANSM(:,:)=AUXCYL(:,:)        ! cartesian -> cylindrical
C
      DO J=1,LDBASE
         DO I=1,LDTRAN
            TRAINV(I,J)=CONJG(AUXCYL(J,I)) ! cylindrical -> cartesian
         END DO
      END DO
C
      DEALLOCATE(AUXCYL)
C
C=======================================================================
C
      IF (.NOT. ALLOCATED(HF_PHN)) STOP 'Error in CYLCAR (1)'
      IF (.NOT. ALLOCATED(HF_PHP)) STOP 'Error in CYLCAR (2)'
      IF (.NOT. ALLOCATED(HF_PPN)) STOP 'Error in CYLCAR (3)'
      IF (.NOT. ALLOCATED(HF_PPP)) STOP 'Error in CYLCAR (4)'
C
C=======================================================================
C      TRANSFORMING THE MEAN-FIELD AND PAIRING FIELD MATRICES FROM
C      HFBTHO INTO CARTESIAN COORDINATES FOR EACH SPIN PROJECTION.
C=======================================================================
C
      ALLOCATE (SPINDW(1:LDTRAN,1:LDTRAN),STAT=IALLOC)
      IF (IALLOC.NE.0) CALL NOALLO('SPINDW','CYLCAR')
      ALLOCATE (AUXMAT(1:LDTRAN,1:LDTRAN),STAT=IALLOC)
      IF (IALLOC.NE.0) CALL NOALLO('AUXCYL','CYLCAR')
C
      C_UNIT=CMPLX(1.0D0,0.0D0)
      C_ZERO=CMPLX(0.0D0,0.0D0)
C
      DO MS_KET=0,NDSPIN
         DO MS_BRA=0,NDSPIN
C
C            Mean-field for neutrons
C
            AUXMAT = HF_PHN(1:LDTRAN,1:LDTRAN,MS_BRA,MS_KET)
C
            CALL ZGEMM('N','N',LDTRAN,LDTRAN,LDTRAN,
     *                         C_UNIT,AUXMAT,LDTRAN,
     *                         TRAINV,LDTRAN,C_ZERO,SPINDW,LDTRAN)
C
            CALL ZGEMM('N','N',LDTRAN,LDTRAN,LDTRAN,
     *                         C_UNIT,TRANSM,LDTRAN,
     *                         SPINDW,LDTRAN,C_ZERO,AUXMAT,LDTRAN)
C
            HF_PHN(1:LDTRAN,1:LDTRAN,MS_BRA,MS_KET) = AUXMAT
C
C            Mean-field for protons
C
            AUXMAT = HF_PHP(1:LDTRAN,1:LDTRAN,MS_BRA,MS_KET)
C
            CALL ZGEMM('N','N',LDTRAN,LDTRAN,LDTRAN,
     *                         C_UNIT,AUXMAT,LDTRAN,
     *                         TRAINV,LDTRAN,C_ZERO,SPINDW,LDTRAN)
C
            CALL ZGEMM('N','N',LDTRAN,LDTRAN,LDTRAN,
     *                         C_UNIT,TRANSM,LDTRAN,
     *                         SPINDW,LDTRAN,C_ZERO,AUXMAT,LDTRAN)
C
            HF_PHP(1:LDTRAN,1:LDTRAN,MS_BRA,MS_KET) = AUXMAT
C
C            Pairing field for neutrons
C
            AUXMAT = HF_PPN(1:LDTRAN,1:LDTRAN,MS_BRA,MS_KET)
C
            CALL ZGEMM('N','N',LDTRAN,LDTRAN,LDTRAN,
     *                         C_UNIT,AUXMAT,LDTRAN,
     *                         TRAINV,LDTRAN,C_ZERO,SPINDW,LDTRAN)
C
            CALL ZGEMM('N','N',LDTRAN,LDTRAN,LDTRAN,
     *                         C_UNIT,TRANSM,LDTRAN,
     *                         SPINDW,LDTRAN,C_ZERO,AUXMAT,LDTRAN)
C
            HF_PPN(1:LDTRAN,1:LDTRAN,MS_BRA,MS_KET) = AUXMAT
C
C            Pairing field for protons
C
            AUXMAT = HF_PPP(1:LDTRAN,1:LDTRAN,MS_BRA,MS_KET)
C
            CALL ZGEMM('N','N',LDTRAN,LDTRAN,LDTRAN,
     *                         C_UNIT,AUXMAT,LDTRAN,
     *                         TRAINV,LDTRAN,C_ZERO,SPINDW,LDTRAN)
C
            CALL ZGEMM('N','N',LDTRAN,LDTRAN,LDTRAN,
     *                         C_UNIT,TRANSM,LDTRAN,
     *                         SPINDW,LDTRAN,C_ZERO,AUXMAT,LDTRAN)
C
            HF_PPP(1:LDTRAN,1:LDTRAN,MS_BRA,MS_KET) = AUXMAT
C
         END DO
      END DO
C
      DEALLOCATE(TRANSM,TRAINV,SPINDW,AUXMAT)
C
C=======================================================================
C      COMBINING  SPIN-UP AND  SPIN-DOWN COMPONENTS OF THE MATRIX
C      ELEMENTS OF THE  MEAN-FIELD AND  PAIRING FIELD TO OBEY THE
C      PHASE CONVENTION OF HFODD (T-BASIS, SEE SUBROUTINE PHASES)
C=======================================================================
C
      IF (.NOT.ALLOCATED(FIL_PP)) THEN
          ALLOCATE (FIL_PP(1:NDBASE,1:NDBASE,0:NDREVE,0:NDISOS),
     *                                             STAT=IALLOC)
          IF (IALLOC.NE.0) CALL NOALLO('FIL_PP','CYLCAR')
      END IF
      IF (.NOT.ALLOCATED(FIL_PM).AND.ISIMPY.NE.1) THEN
          ALLOCATE (FIL_PM(1:NDBASE,1:NDBASE,0:NDREVE,0:NDISOS),
     *                                             STAT=IALLOC)
          IF (IALLOC.NE.0) CALL NOALLO('FIL_PM','CYLCAR')
      END IF
      IF (.NOT.ALLOCATED(FIP_PP)) THEN
          ALLOCATE (FIP_PP(1:NDBASE,1:NDBASE,0:NDREVE,0:NDISOS),
     *                                             STAT=IALLOC)
          IF (IALLOC.NE.0) CALL NOALLO('FIP_PP','CYLCAR')
      END IF
C
      DO J_BASE=1,LDBASE
         DO I_BASE=1,LDBASE
C
C            Mean-field for neutrons and protons (t+ block)
C
            FIL_PP(I_BASE,J_BASE,0,0)=
     *
     *             CONJG(PHASPI(I_BASE,0,1))
     *                  *HF_PHN(I_BASE,J_BASE,1,1)
     *                         *PHASPI(J_BASE,0,1)
     *     +
     *             CONJG(PHASPI(I_BASE,0,0))
     *                  *HF_PHN(I_BASE,J_BASE,0,0)
     *                         *PHASPI(J_BASE,0,0)
     *     +
     *             CONJG(PHASPI(I_BASE,0,1))
     *                  *HF_PHN(I_BASE,J_BASE,1,0)
     *                         *PHASPI(J_BASE,0,0)
     *     +
     *             CONJG(PHASPI(I_BASE,0,0))
     *                  *HF_PHN(I_BASE,J_BASE,0,1)
     *                         *PHASPI(J_BASE,0,1)
C
            FIL_PP(I_BASE,J_BASE,0,1)=
     *
     *             CONJG(PHASPI(I_BASE,0,1))
     *                  *HF_PHP(I_BASE,J_BASE,1,1)
     *                         *PHASPI(J_BASE,0,1)
     *     +
     *             CONJG(PHASPI(I_BASE,0,0))
     *                  *HF_PHP(I_BASE,J_BASE,0,0)
     *                         *PHASPI(J_BASE,0,0)
     *     +
     *             CONJG(PHASPI(I_BASE,0,1))
     *                  *HF_PHP(I_BASE,J_BASE,1,0)
     *                         *PHASPI(J_BASE,0,0)
     *     +
     *             CONJG(PHASPI(I_BASE,0,0))
     *                  *HF_PHP(I_BASE,J_BASE,0,1)
     *                         *PHASPI(J_BASE,0,1)
C
C            Pairing field for neutrons and protons (t+ block)
C
            FIP_PP(I_BASE,J_BASE,0,0)=
     *
     *     -       CONJG(PHASPI(I_BASE,0,1))
     *                  *HF_PPN(I_BASE,J_BASE,1,1)
     *                         *PHASPI(J_BASE,0,1)
     *     -
     *             CONJG(PHASPI(I_BASE,0,0))
     *                  *HF_PPN(I_BASE,J_BASE,0,0)
     *                         *PHASPI(J_BASE,0,0)
     *     -
     *             CONJG(PHASPI(I_BASE,0,1))
     *                  *HF_PPN(I_BASE,J_BASE,1,0)
     *                         *PHASPI(J_BASE,0,0)
     *     -
     *             CONJG(PHASPI(I_BASE,0,0))
     *                  *HF_PPN(I_BASE,J_BASE,0,1)
     *                         *PHASPI(J_BASE,0,1)
C
            FIP_PP(I_BASE,J_BASE,0,1)=
     *
     *     -       CONJG(PHASPI(I_BASE,0,1))
     *                  *HF_PPP(I_BASE,J_BASE,1,1)
     *                         *PHASPI(J_BASE,0,1)
     *     -
     *             CONJG(PHASPI(I_BASE,0,0))
     *                  *HF_PPP(I_BASE,J_BASE,0,0)
     *                         *PHASPI(J_BASE,0,0)
     *     -
     *             CONJG(PHASPI(I_BASE,0,1))
     *                  *HF_PPP(I_BASE,J_BASE,1,0)
     *                         *PHASPI(J_BASE,0,0)
     *     -
     *             CONJG(PHASPI(I_BASE,0,0))
     *                  *HF_PPP(I_BASE,J_BASE,0,1)
     *                         *PHASPI(J_BASE,0,1)
C
         END DO
      END DO
C
      IF (ALLOCATED(HF_PHN)) DEALLOCATE(HF_PHN)
      IF (ALLOCATED(HF_PHP)) DEALLOCATE(HF_PHP)
      IF (ALLOCATED(HF_PPN)) DEALLOCATE(HF_PPN)
      IF (ALLOCATED(HF_PPP)) DEALLOCATE(HF_PPP)
C
C      Time-reversal symmetry is conserved by construction in HFBTHO
C
      DO J_BASE=1,LDBASE
         DO I_BASE=1,LDBASE
C
            FIL_PP(I_BASE,J_BASE,1,0)=CONJG(FIL_PP(I_BASE,J_BASE,0,0))
            FIL_PP(I_BASE,J_BASE,1,1)=CONJG(FIL_PP(I_BASE,J_BASE,0,1))
C
            FIP_PP(I_BASE,J_BASE,1,0)=CONJG(FIP_PP(I_BASE,J_BASE,0,0))
            FIP_PP(I_BASE,J_BASE,1,1)=CONJG(FIP_PP(I_BASE,J_BASE,0,1))
C
            IF (ISIMPY .NE. 1) THEN
C
                FIL_PM(I_BASE,J_BASE,1,0)=CMPLX(0.0D0,0.0D0)
                FIL_PM(I_BASE,J_BASE,0,0)=CMPLX(0.0D0,0.0D0)
C
                FIL_PM(I_BASE,J_BASE,1,1)=CMPLX(0.0D0,0.0D0)
                FIL_PM(I_BASE,J_BASE,0,1)=CMPLX(0.0D0,0.0D0)
C
            END IF
C
         END DO
      END DO
C
C=======================================================================
C
      CALL CPUTIM('CYLCAR',0)
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE CARCYL(NOSCIL,ISIMPY,IF_THO,BZ_THO,BP_THO,Parity,
     *                                              ELIMIT,NYMAXX)
C=======================================================================
      USE hfodd_interface
      USE CYLTRA
      USE MAF_PP
      USE MAP_PP
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      LOGICAL
     *          Parity
      COMPLEX
     *          C_UNIT,C_ZERO,PHASPI
C
C=======================================================================
      COMPLEX, DIMENSION(:,:), ALLOCATABLE ::
     *                         TRANSM,TRAINV,SPINDW,AUXMAT
C=======================================================================
      COMMON
     *       /PLANCK/ HBMASS,HBMRPA,HBMINP
      COMMON
     *       /BASPAR/ HBAROX,HBAROY,HBAROZ
      COMMON
     *       /SPIPHA/ PHASPI(1:NDBASE,0:NDREVE,0:NDSPIN)
      COMMON
     *       /SIZCYL/ LDTRAN
      COMMON
     *       /DIMENS/ LDBASE
      COMMON
     *       /CFIPRI/ NFIPRI
C
C=======================================================================
C
C     THIS SUBROUTINE PERFORMS THE  'HFODD'  TO  'HFBTHO'  BASIS
C     TRANSFORMATION BY INVOKING A PHASE TRANSFORMATION FOLLOWED
C     BY THE CARTESIAN TO CYLINDRICAL COORDINATE TRANSFORMATION.
C
C     THE ONLY REQUIRED INPUTS ARE THE MATRICES OF THE MEAN- AND
C     PAIRING FIELDS FOR PROTONS  AND NEUTRONS, WHICH ARE STORED
C     IN ARRAYS FIL_PP, FIL_PM  AND FIP_PP. UPON EXITING, ARRAYS
C     HF_PHN,  HF_PHP,  HF_PPN,  HF_PPP  CONTAIN  ALL  FIELDS IN
C     CYLINDRICAL COORDINATES (WITH HFODD CONVENTION, SEE BELOW),
C     STRIPPED OF ALL SUPERFLUOUS PHASES.
C
C NOTA BENE: HFBTHO BASIS STATE COUNTING CONVENTIONS ARE DIFFERENT
C            FROM HFODD. IN HFODD ALL LOOPS OVER  NX, NY AND NZ GO
C            FROM 0 TO NOSCIL. IN  HFBTHO, ALL LOOPS CORRESPOND TO
C            A MAXIMUM QUANTUM NUMBER N = 50, EXCEPT NZ, WHICH CAN
C            NOT EXCEED NOSCIL. IN BOTH CODES THE BASIS CUT-OFF IS
C            ENERGY BASED, I.E., E(NX,NY,NZ) < ENECUT (HFODD)  AND
C            E(NR,NZ,LAMBDA) < ENECUT (HFBTHO).  THESE   DIFFERENT
C            CONVENTIONS DO NOT MATTER FOR   SPHERICAL  BASES. FOR
C            DEFORMED  BASES, THEY WOULD LEAD TO  DIFFERENT  STATE
C            COMPOSITION IF  SPECIAL  MEASURES WERE NOT TAKEN.  IN
C            THE CURRENT IMPLEMENTATION, THE 4D-ARRAY  indexHFBTHO
C            INDICATES IF A STATE WITH  GIVEN  CYLINDRICAL QUANTUM
C            NUMBERS IS PART OF HFBTHO BASIS.
C
C=======================================================================
C
      CALL CPUTIM('CARCYL',1)
C
C=======================================================================
C
      IF (.NOT.ALLOCATED(FIL_PP)) STOP 'Error in CARCYL (1)'
      IF (.NOT.ALLOCATED(FIP_PP)) STOP 'Error in CARCYL (2)'
C
C=======================================================================
C      COMBINING SIMPLEX COMPONENTS OF THE MATRIX ELEMENTS OF THE
C      MEAN-FIELD AND PAIRING FIELD TO EXTRACT MATRIX ELEMENTS IN
C      VARIOUS SPIN BLOCKS (ms, ms')
C=======================================================================
C
      IALLOC=0
C
C=======================================================================
C
      IF (.NOT.ALLOCATED(HF_PHN)) THEN
          ALLOCATE(HF_PHN(1:LDBASE,1:LDBASE,0:NDSPIN,0:NDSPIN),
     *                                            STAT=IALLOC)
          IF (IALLOC.NE.0) CALL NOALLO('HF_PHN','CARCYL')
      END IF
      IF (.NOT.ALLOCATED(HF_PHP)) THEN
          ALLOCATE(HF_PHP(1:LDBASE,1:LDBASE,0:NDSPIN,0:NDSPIN),
     *                                            STAT=IALLOC)
          IF (IALLOC.NE.0) CALL NOALLO('HF_PHP','CARCYL')
      END IF
      IF (.NOT.ALLOCATED(HF_PPN)) THEN
          ALLOCATE(HF_PPN(1:LDBASE,1:LDBASE,0:NDSPIN,0:NDSPIN),
     *                                            STAT=IALLOC)
          IF (IALLOC.NE.0) CALL NOALLO('HF_PPN','CARCYL')
      END IF
      IF (.NOT.ALLOCATED(HF_PPP)) THEN
          ALLOCATE(HF_PPP(1:LDBASE,1:LDBASE,0:NDSPIN,0:NDSPIN),
     *                                            STAT=IALLOC)
          IF (IALLOC.NE.0) CALL NOALLO('HF_PPP','CARCYL')
      END IF
C
C=======================================================================
C         CALCULATING THE PHASES ACCORDING TO SOME INGENIOUS CONVENTION
C=======================================================================
C
      CALL PHASES(NYMAXX)
C
C=======================================================================
C
      DO J_BASE=1,LDBASE
         DO I_BASE=1,LDBASE
C
C                             MEAN-FIELD
C
C            Mean-field for neutrons and protons (spin-up/spin-up block)
C
            HF_PHN(I_BASE,J_BASE,1,1)=
     *
     *             CONJG(PHASPI(I_BASE,0,1))
     *                  *FIL_PP(I_BASE,J_BASE,0,0)
     *                         *PHASPI(J_BASE,0,1)
     *     +
     *             CONJG(PHASPI(I_BASE,1,1))
     *                  *FIL_PP(I_BASE,J_BASE,1,0)
     *                         *PHASPI(J_BASE,1,1)
C
            HF_PHP(I_BASE,J_BASE,1,1)=
     *
     *             CONJG(PHASPI(I_BASE,0,1))
     *                  *FIL_PP(I_BASE,J_BASE,0,1)
     *                         *PHASPI(J_BASE,0,1)
     *     +
     *             CONJG(PHASPI(I_BASE,1,1))
     *                  *FIL_PP(I_BASE,J_BASE,1,1)
     *                         *PHASPI(J_BASE,1,1)
C
C            Mean-field for neutrons and protons (spin-down/spin-down block)
C
            HF_PHN(I_BASE,J_BASE,0,0)=
     *
     *             CONJG(PHASPI(I_BASE,0,0))
     *                  *FIL_PP(I_BASE,J_BASE,0,0)
     *                         *PHASPI(J_BASE,0,0)
     *     +
     *             CONJG(PHASPI(I_BASE,1,0))
     *                  *FIL_PP(I_BASE,J_BASE,1,0)
     *                         *PHASPI(J_BASE,1,0)
C
            HF_PHP(I_BASE,J_BASE,0,0)=
     *
     *             CONJG(PHASPI(I_BASE,0,0))
     *                  *FIL_PP(I_BASE,J_BASE,0,1)
     *                         *PHASPI(J_BASE,0,0)
     *     +
     *             CONJG(PHASPI(I_BASE,1,0))
     *                  *FIL_PP(I_BASE,J_BASE,1,1)
     *                         *PHASPI(J_BASE,1,0)
C
C            Mean-field for neutrons and protons (spin-up/spin-down block)
C
            HF_PHN(I_BASE,J_BASE,1,0)=
     *
     *             CONJG(PHASPI(I_BASE,0,1))
     *                  *FIL_PP(I_BASE,J_BASE,0,0)
     *                         *PHASPI(J_BASE,0,0)
     *     +
     *             CONJG(PHASPI(I_BASE,1,1))
     *                  *FIL_PP(I_BASE,J_BASE,1,0)
     *                         *PHASPI(J_BASE,1,0)
C
            HF_PHP(I_BASE,J_BASE,1,0)=
     *
     *             CONJG(PHASPI(I_BASE,0,1))
     *                  *FIL_PP(I_BASE,J_BASE,0,1)
     *                         *PHASPI(J_BASE,0,0)
     *     +
     *             CONJG(PHASPI(I_BASE,1,1))
     *                  *FIL_PP(I_BASE,J_BASE,1,1)
     *                         *PHASPI(J_BASE,1,0)
C
C            Mean-field for neutrons and protons (spin-down/spin-up block)
C
            HF_PHN(I_BASE,J_BASE,0,1)=
     *
     *             CONJG(PHASPI(I_BASE,0,0))
     *                  *FIL_PP(I_BASE,J_BASE,0,0)
     *                         *PHASPI(J_BASE,0,1)
     *     +
     *             CONJG(PHASPI(I_BASE,1,0))
     *                  *FIL_PP(I_BASE,J_BASE,1,0)
     *                         *PHASPI(J_BASE,1,1)
C
            HF_PHP(I_BASE,J_BASE,0,1)=
     *
     *             CONJG(PHASPI(I_BASE,0,0))
     *                  *FIL_PP(I_BASE,J_BASE,0,1)
     *                         *PHASPI(J_BASE,0,1)
     *     +
     *             CONJG(PHASPI(I_BASE,1,0))
     *                  *FIL_PP(I_BASE,J_BASE,1,1)
     *                         *PHASPI(J_BASE,1,1)
C
C                             PAIRING-FIELD
C
C            Pairing field for neutrons and protons (spin-up/spin-up block)
C
            HF_PPN(I_BASE,J_BASE,1,1)=
     *
     *             CONJG(PHASPI(I_BASE,0,1))
     *                  *FIP_PP(I_BASE,J_BASE,0,0)
     *                         *PHASPI(J_BASE,0,1)
     *     +
     *             CONJG(PHASPI(I_BASE,1,1))
     *                  *FIP_PP(I_BASE,J_BASE,1,0)
     *                         *PHASPI(J_BASE,1,1)
C
            HF_PPP(I_BASE,J_BASE,1,1)=
     *
     *             CONJG(PHASPI(I_BASE,0,1))
     *                  *FIP_PP(I_BASE,J_BASE,0,1)
     *                         *PHASPI(J_BASE,0,1)
     *     +
     *             CONJG(PHASPI(I_BASE,1,1))
     *                  *FIP_PP(I_BASE,J_BASE,1,1)
     *                         *PHASPI(J_BASE,1,1)
C
C            Pairing field for neutrons and protons (spin-down/spin-down block)
C
            HF_PPN(I_BASE,J_BASE,0,0)=
     *
     *             CONJG(PHASPI(I_BASE,0,0))
     *                  *FIP_PP(I_BASE,J_BASE,0,0)
     *                         *PHASPI(J_BASE,0,0)
     *     +
     *             CONJG(PHASPI(I_BASE,1,0))
     *                  *FIP_PP(I_BASE,J_BASE,1,0)
     *                         *PHASPI(J_BASE,1,0)
C
            HF_PPP(I_BASE,J_BASE,0,0)=
     *
     *             CONJG(PHASPI(I_BASE,0,0))
     *                  *FIP_PP(I_BASE,J_BASE,0,1)
     *                         *PHASPI(J_BASE,0,0)
     *     +
     *             CONJG(PHASPI(I_BASE,1,0))
     *                  *FIP_PP(I_BASE,J_BASE,1,1)
     *                         *PHASPI(J_BASE,1,0)
C
C            Pairing field for neutrons and protons (spin-up/spin-down block)
C
            HF_PPN(I_BASE,J_BASE,1,0)=
     *
     *             CONJG(PHASPI(I_BASE,0,1))
     *                  *FIP_PP(I_BASE,J_BASE,0,0)
     *                         *PHASPI(J_BASE,0,0)
     *     +
     *             CONJG(PHASPI(I_BASE,1,1))
     *                  *FIP_PP(I_BASE,J_BASE,1,0)
     *                         *PHASPI(J_BASE,1,0)
C
            HF_PPP(I_BASE,J_BASE,1,0)=
     *
     *             CONJG(PHASPI(I_BASE,0,1))
     *                  *FIP_PP(I_BASE,J_BASE,0,1)
     *                         *PHASPI(J_BASE,0,0)
     *     +
     *             CONJG(PHASPI(I_BASE,1,1))
     *                  *FIP_PP(I_BASE,J_BASE,1,1)
     *                         *PHASPI(J_BASE,1,0)
C
C            Pairing field for neutrons and protons (spin-down/spin-up block)
C
            HF_PPN(I_BASE,J_BASE,0,1)=
     *
     *             CONJG(PHASPI(I_BASE,0,0))
     *                  *FIP_PP(I_BASE,J_BASE,0,0)
     *                         *PHASPI(J_BASE,0,1)
     *     +
     *             CONJG(PHASPI(I_BASE,1,0))
     *                  *FIP_PP(I_BASE,J_BASE,1,0)
     *                         *PHASPI(J_BASE,1,1)
C
            HF_PPP(I_BASE,J_BASE,0,1)=
     *
     *             CONJG(PHASPI(I_BASE,0,0))
     *                  *FIP_PP(I_BASE,J_BASE,0,1)
     *                         *PHASPI(J_BASE,0,1)
     *     +
     *             CONJG(PHASPI(I_BASE,1,0))
     *                  *FIP_PP(I_BASE,J_BASE,1,1)
     *                         *PHASPI(J_BASE,1,1)
C
         END DO
      END DO
C
C      Saving memory
      DEALLOCATE(FIL_PP,FIP_PP)
C
C=======================================================================
C      DEFINING THE HFBTHO BASIS BASED ON CURRENT INPUTS FROM HFODD:
C      NUMBER OF SHELLS, FREQUENCIES OF THE HO, CONSERVATION/BREAKING
C      OF PARITY, ENERGY CUT-OFF OF THE BASIS
C=======================================================================
C
      hbzero=HBMASS
      N_UNIT=NFIPRI
      HPERPE=HBAROX
      HPARAL=HBAROZ
C
      Call Basis_THO(N_UNIT,NDTRAN,NDSPIN,NOSCIL,BP_THO,BZ_THO,HPERPE,
     *                                    HPARAL,Parity,ELIMIT,hbzero)
C
      NsizeHFBTHO=nt_tho
C
      IF (.NOT.ALLOCATED(validate_HFBTHO))
     *         ALLOCATE(validate_HFBTHO(0:nnm_tho,0:nnm_tho,0:nnm_tho,
     *                                                      0:nnm_tho))
C
      Do i = 1, NsizeHFBTHO
         N  = Nm_tho(i)
         nz = nz_tho(i)
         nr = nr_tho(i)
         ml = nl_tho(i)
         validate_HFBTHO(N, nz, nr, ml) = 1
      End Do
C
      LDTRAN=NsizeHFBTHO
C
C=======================================================================
C      CYLINDRICAL TO CARTESIAN  BASIS  TRANFORMATION. MATRIX OF THE
C      TRANSFORMATION IS STORED IN TRANSM, THE MATRIX OF THE INVERSE
C      TRANFORMATION (HERMITIAN CONJUGATE) IN TRAINV.
C=======================================================================
C
      IALLOC=0
C
      ALLOCATE (AUXCYL(LDBASE,LDTRAN),STAT=IALLOC)
      IF (IALLOC.NE.0) CALL NOALLO('AUXCYL','CARCYL')
C
      CALL THOXYZ(NOSCIL)
C
      NILXYZ=3
      CALL THOMAT(NOSCIL,NILXYZ,IF_THO,nnm_tho)
C
      ALLOCATE (TRANSM(1:LDBASE,1:LDTRAN),STAT=IALLOC)
      IF (IALLOC.NE.0) CALL NOALLO('SPINUP','CARCYL')
      ALLOCATE (TRAINV(1:LDTRAN,1:LDBASE),STAT=IALLOC)
      IF (IALLOC.NE.0) CALL NOALLO('WASPIN','CARCYL')
C
      TRANSM(:,:)=AUXCYL(:,:)        ! cartesian -> cylindrical
C
      DO J=1,LDBASE
         DO I=1,LDTRAN
            TRAINV(I,J)=CONJG(AUXCYL(J,I)) ! cylindrical -> cartesian
         END DO
      END DO
C
      DEALLOCATE(AUXCYL)
C
C=======================================================================
C      TRANSFORMING THE MEAN-FIELD AND PAIRING FIELD MATRICES FROM
C      HFODD INTO CYLINDRICAL COORDINATES FOR EACH SPIN PROJECTION.
C=======================================================================
C
      ALLOCATE (SPINDW(1:LDBASE,1:LDTRAN),STAT=IALLOC)
      IF (IALLOC.NE.0) CALL NOALLO('SPINDW','CYLCAR')
      ALLOCATE (AUXMAT(1:LDBASE,1:LDBASE),STAT=IALLOC)
      IF (IALLOC.NE.0) CALL NOALLO('AUXCYL','CYLCAR')
C
      C_UNIT=CMPLX(1.0D0,0.0D0)
      C_ZERO=CMPLX(0.0D0,0.0D0)
C
      DO MS_KET=0,NDSPIN
         DO MS_BRA=0,NDSPIN
C
C            Mean-field for neutrons
C
            AUXMAT = HF_PHN(1:LDBASE,1:LDBASE,MS_BRA,MS_KET)
C
            CALL ZGEMM('N','N',LDBASE,LDTRAN,LDBASE,
     *                         C_UNIT,AUXMAT,LDBASE,
     *                         TRANSM,LDBASE,C_ZERO,SPINDW,LDBASE)
C
            CALL ZGEMM('N','N',LDTRAN,LDTRAN,LDBASE,
     *                         C_UNIT,TRAINV,LDTRAN,
     *                         SPINDW,LDBASE,C_ZERO,AUXMAT,LDBASE)
C
            HF_PHN(1:LDBASE,1:LDBASE,MS_BRA,MS_KET) = AUXMAT
C
C            Mean-field for protons
C
            AUXMAT = HF_PHP(1:LDBASE,1:LDBASE,MS_BRA,MS_KET)
C
            CALL ZGEMM('N','N',LDBASE,LDTRAN,LDBASE,
     *                         C_UNIT,AUXMAT,LDBASE,
     *                         TRANSM,LDBASE,C_ZERO,SPINDW,LDBASE)
C
            CALL ZGEMM('N','N',LDTRAN,LDTRAN,LDBASE,
     *                         C_UNIT,TRAINV,LDTRAN,
     *                         SPINDW,LDBASE,C_ZERO,AUXMAT,LDBASE)
C
            HF_PHP(1:LDBASE,1:LDBASE,MS_BRA,MS_KET) = AUXMAT
C
C            Pairing field for neutrons
C
            AUXMAT = HF_PPN(1:LDBASE,1:LDBASE,MS_BRA,MS_KET)
C
            CALL ZGEMM('N','N',LDBASE,LDTRAN,LDBASE,
     *                         C_UNIT,AUXMAT,LDBASE,
     *                         TRANSM,LDBASE,C_ZERO,SPINDW,LDBASE)
C
            CALL ZGEMM('N','N',LDTRAN,LDTRAN,LDBASE,
     *                         C_UNIT,TRAINV,LDTRAN,
     *                         SPINDW,LDBASE,C_ZERO,AUXMAT,LDBASE)
C
            HF_PPN(1:LDBASE,1:LDBASE,MS_BRA,MS_KET) = AUXMAT
C
C            Pairing field for protons
C
            AUXMAT = HF_PPP(1:LDBASE,1:LDBASE,MS_BRA,MS_KET)
C
            CALL ZGEMM('N','N',LDBASE,LDTRAN,LDBASE,
     *                         C_UNIT,AUXMAT,LDBASE,
     *                         TRANSM,LDBASE,C_ZERO,SPINDW,LDBASE)
C
            CALL ZGEMM('N','N',LDTRAN,LDTRAN,LDBASE,
     *                         C_UNIT,TRAINV,LDTRAN,
     *                         SPINDW,LDBASE,C_ZERO,AUXMAT,LDBASE)
C
            HF_PPP(1:LDBASE,1:LDBASE,MS_BRA,MS_KET) = AUXMAT
C
         END DO
      END DO
C
      DEALLOCATE(TRANSM,TRAINV,SPINDW,AUXMAT)
C
C=======================================================================
C
      CALL CPUTIM('CARCYL',0)
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE THOPAI(NXHERM,NYHERM,NZHERM)
C=======================================================================
      USE PD_DEN
      USE WD_FLD
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      COMPLEX
     *          PNEUTR,PPROTO,
     *          XNEUTR,XPROTO
C
      COMMON
     *       /DENTOT/ DENSIT(NDXHRM,NDYHRM,NDZHRM),
     *                DENCHA(NDXHRM,NDYHRM,NDZHRM)
      COMMON
     *       /CCPPAI/ PRHO_N,PRHODN,PRHOSN,POWERN,
     *                PRHO_P,PRHODP,PRHOSP,POWERP
C
C=======================================================================
C
      CALL CPUTIM('THOPAI',1)
C
C=======================================================================
C        THIS SUBROUTINE CALCULATES THE PAIRING FIELDS BASED ON THE REF.
C        DOBACZEWSKI ET AL. NP422 (1984) 103 REFERRED TO AS DFT.
C=======================================================================
C        ATTENTION: AT PRESENT, ONLY THE CENTRAL FIELDS COMING FROM  THE
C                   T0 AND T3 TERMS ARE PROGRAMED.
C=======================================================================
C
C        THE EFFECTIVE COUPLING CONSTANTS ARE CODED AS:
C                      'P'//'XXX'//'N'//'TYP'
C
C        WHERE THE SYMBOLS:  'P', 'XXX', 'N', AND 'TYP'
C        ARE EXPLAINED IN THE SUBROUTINE "ESKYRM"
C
C=======================================================================
C
      XOLDPA=0.0D0
C
      XNEWPA=1.0D0-XOLDPA
C
      DO IZ=1,NZHERM
         DO IY=1,NYHERM
            DO IX=1,NXHERM
C
C=======================================================================
C              S  C  A  L  A  R     F I E L D S     F O L L O W
C=======================================================================
C=======================================================================
C              CENTRAL TERM (<= T0) - (SEE: DFT EQ.(A5.B))
C=======================================================================
C
               XNEUTR = PRHO_N * PD_RHO(IX,IY,IZ,0) / 2.0D0
               XPROTO = PRHO_P * PD_RHO(IX,IY,IZ,1) / 2.0D0
C
               PNEUTR = XNEUTR
               PPROTO = XPROTO
C
C=======================================================================
C              CENTRAL TERM (<= T3)
C=======================================================================
C
               XNEUTR = PRHODN * PD_RHO(IX,IY,IZ,0) / 2.0D0
     *                         * DENSIT(IX,IY,IZ)**POWERN
               XPROTO = PRHODP * PD_RHO(IX,IY,IZ,1) / 2.0D0
     *                         * DENSIT(IX,IY,IZ)**POWERP
C
               PNEUTR = PNEUTR+XNEUTR
               PPROTO = PPROTO+XPROTO
C
               WD_CEN(IX,IY,IZ,0) = WD_CEN(IX,IY,IZ,0)*XOLDPA
     *                            + XNEWPA*PNEUTR
               WD_CEN(IX,IY,IZ,1) = WD_CEN(IX,IY,IZ,1)*XOLDPA
     *                            + XNEWPA*PPROTO
C
            END DO
         END DO
      END DO
C
C=======================================================================
C
      CALL CPUTIM('THOPAI',0)
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE REVIEW(NFIREV,VERSIO,IN_FIX,IZ_FIX,
     *                                SKYRME,GOGNAM,
     *           ISTAND,KETA_J,KETA_W,KETACM,KETA_M,
     *                  JETA_J,JETA_W,JETACM,JETA_M,
     *                                       KETA_R,
     *           LANODD,LANSCA,HBMSAT,RHOSAT,EFFSAT,
     *                  NMUMAX,NMUCON,NMUCOU,NMUPRI,
     *                  ISCHIF,NSIMAX,NSICON,NSIPRI,
     *                         NMAMAX,NMACON,NMAPRI,
     *                         NMURED,NMARED,NSIRED,
     *                         LAMMAX,NOSCIL,NLIMIT,
     *                  DELFIN,DELFIP,IDEFIN,IDEFIP,
     *                  FERFIN,FERFIP,IFEFIN,IFEFIP,
     *                  FE2FIN,FE2FIP,IF2FIN,IF2FIP,
     *                  INSIGN,IPSIGN,ISSIGN,IDSIGN,
     *                  INSIGP,IPSIGP,ISSIGP,IDSIGP,
     *                         INSIMN,IRSIMN,IDSIMN,
     *                         INSIMP,IRSIMP,IDSIMP,
     *                         INSIQN,IPSIQN,IDSIQN,
     *                         INSIQP,IPSIQP,IDSIQP,
     *                                INSIZN,IDSIZN,
     *                                INSIZP,IDSIZP,
     *                                IFIBLN,INIBLN,
     *                                IFIBLP,INIBLP,
     *                                       NILXYZ,
     *                                ECUTOF,LIMQUA,
     *                                       IPOTHO,
     *           IPAIRI,IPAHFB,ITWOBA,JPABCS,IMFHFB,
     *                                LIPKIN,LIPKIP,
     *                  IROTAT,IREVIE,MREVER,
     *                  FILREP,FILREC,FILWOO,
     *                  FILREV,FILCOU,FILWAV,FILKER,
     *                  FILYUP,FILYUC,
     *                  FILGOP,FILGOC,
     *                  FILGPP,FILGPC,
     *                  FILLIP,FILLIC,
     *                  FILFIP,FILFIC,
     *                  CMSXFC,CMSYFC,CMSZFC,
     *                  XMOMFC,YMOMFC,ZMOMFC,
     *                  NXHERM,NYHERM,NZHERM,
     *                  NXMAXX,NYMAXX,NZMAXX,
     *                  EPSHER,
     *                  HOMEGA,FCHOM0,ENECUT,
     *                  CVOLFC,R0PARM,
     *                                ISOTRO,
     *                  NUMCOU,NUMETA,FURMAX,
     *                  ICOTYP,ICOUDI,ICOUEX,
     *           PIMASS,PNMASS,IYUTYP,I_YUKA,
     *           YUKAGT,YUKAG0,YUKAG1,YUKAG2,
     *                         I_GOGA,IGOGPA,
     *                  ISPHER,ISIMPY,ISIGNY,
     *                         IPARTY,ISIQTY,
     *                  ISIMTX,JSIMTY,ISIMTZ,
     *                         NULAST,EPSITE,
     *                  INIROT,INIINV,INIKAR,
     *                  NUCHAO,NUPING,EPSPNG,
     *                  ICHFLI,IPAFLI,IREFLI,
     *                  ISPFLI,ISHFLI,IFLIPI,
     *           SLOWEV,SLOWOD,SLOWPA,SLOWLI,
     *           IMOVAX,ITILAX,ITISAX,NO_ORB,
     *                  IS_YES,IS_PIN,IS_CHA)
C=======================================================================
      USE HE_DEN
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      CHARACTER
     *          FILREP*68,FILREC*68,FILWOO*68,
     *          FILREV*68,FILCOU*68,FILWAV*68,FILKER*68,
     *          FILYUP*68,FILYUC*68,
     *          FILGOP*68,FILGOC*68,
     *          FILGPP*68,FILGPC*68,
     *          FILLIP*68,FILLIC*68,
     *          FILFIP*68,FILFIC*68
      CHARACTER
     *          FILOLD*68
      CHARACTER
     *          SPKART*10,SPNILS*15,SPORDE*13
      CHARACTER
     *          SKYRME*4,GOGNAM*4,VERSIO*5
C
      COMPLEX
     *          ALPHAC(0:NDLAMB,-NDLAMB:+NDLAMB)
C
      DIMENSION
     *             CCPALL(NDCOUP), DCPALL(NDCOUP), ECPALL(NDCOUP)
      EQUIVALENCE
     *            (CCPALL,CRHO_T),(DCPALL,DRHO_T),(ECPALL,ERHO_T)
C
      COMMON
     *       /HERSTO/ HERMTS(0:ND2MAX,1:NDGAUS,1:NDKART)
      COMMON
     *       /INTSTO/ FOURWG(1:NDGAUS,1:NDKART),
     *                FOURPT(1:NDGAUS,1:NDKART)
      COMMON
     *       /DENEXP/ EXPAUX(NDXHRM,NDYHRM,NDZHRM)
      COMMON
     *       /SIGOCC/ N_OCCU(1:NDSTAT,0:NDPARI,0:NDREVE,0:NDISOS),
     *                N_VACC(1:NDSTAT,0:NDPARI,0:NDREVE,0:NDISOS)
      COMMON
     *       /SIMOCC/ L_OCCU(1:NDSTAT,0:NDREVE,0:NDISOS),
     *                L_VACC(1:NDSTAT,0:NDREVE,0:NDISOS)
      COMMON
     *       /SIQOCC/ K_OCCU(1:2*NDSTAT,0:NDPARI,0:NDISOS),
     *                K_VACC(1:2*NDSTAT,0:NDPARI,0:NDISOS)
      COMMON
     *       /SIZOCC/ M_OCCU(1:2*NDSTAT,0:NDISOS),
     *                M_VACC(1:2*NDSTAT,0:NDISOS)
      COMMON
     *       /SPRADI/ SPSIZE(1:2*NDSTAT,0:NDISOS,0:NDKART)
      COMMON
     *       /SPMOME/ SPMO20(1:2*NDSTAT,0:NDISOS),
     *                SPMO22(1:2*NDSTAT,0:NDISOS)
      COMMON
     *       /SPLEVS/ SPENER(1:2*NDSTAT,0:NDISOS),
     *                SPOCCU(1:2*NDSTAT,0:NDISOS),
     *                SPALIG(1:2*NDSTAT,0:NDISOS),
     *                SPSPAL(1:2*NDSTAT,0:NDISOS),
     *                SPPARI(1:2*NDSTAT,0:NDISOS),
     *                SPSIMP(1:2*NDSTAT,0:NDISOS)
      COMMON
     *       /SPSTAT/ SPXALI(1:2*NDSTAT,0:NDISOS),
     *                SPZALI(1:2*NDSTAT,0:NDISOS),
     *                SPXSPI(1:2*NDSTAT,0:NDISOS),
     *                SPZSPI(1:2*NDSTAT,0:NDISOS)
      COMMON
     *       /SPLABS/ SPKART(1:2*NDSTAT,0:NDISOS),
     *                SPNILS(1:2*NDSTAT,0:NDISOS),
     *                SPORDE(1:2*NDSTAT,0:NDISOS)
      COMMON
     *       /SPNUMS/ NUMBSP(         0:NDREVE,0:NDISOS)
      COMMON
     *       /N_FLIG/ NPFLIG(0:NDPARI,0:NDREVE,0:NDISOS),
     *                NHFLIG(0:NDPARI,0:NDREVE,0:NDISOS),
     *                NOFLIG(0:NDPARI,0:NDREVE,0:NDISOS)
      COMMON
     *       /N_FLIM/ NPFLIM(0:NDREVE,         0:NDISOS),
     *                NHFLIM(0:NDREVE,         0:NDISOS),
     *                NOFLIM(0:NDREVE,         0:NDISOS)
      COMMON
     *       /N_FLIQ/ NPFLIQ(0:NDPARI,         0:NDISOS),
     *                NHFLIQ(0:NDPARI,         0:NDISOS),
     *                NOFLIQ(0:NDPARI,         0:NDISOS)
      COMMON
     *       /N_FLIZ/ NPFLIZ(                  0:NDISOS),
     *                NHFLIZ(                  0:NDISOS),
     *                NOFLIZ(                  0:NDISOS)
      COMMON
     *       /N_FILG/ NPFILG(0:NDPARI,0:NDREVE,0:NDISOS),
     *                NHFILG(0:NDPARI,0:NDREVE,0:NDISOS),
     *                NOFILG(0:NDPARI,0:NDREVE,0:NDISOS)
      COMMON
     *       /N_FILZ/ NPFILZ(                  0:NDISOS),
     *                NHFILZ(                  0:NDISOS),
     *                NOFILZ(                  0:NDISOS)
      COMMON
     *       /CONVER/ ETOTFI(0:NDITER),ETOTSI(0:NDITER),
     *                                 ESTABI(0:NDITER),
     *                QUA20I(0:NDITER),QUA22I(0:NDITER),
     *                ANGUTI(0:NDITER)
      COMMON
     *       /RMSRAD/ RADI_N(0:NDKART),
     *                RADI_P(0:NDKART),
     *                RADI_T(0:NDKART)
      COMMON
     *       /RMSSHI/ RSHI_N(0:NDKART),
     *                RSHI_P(0:NDKART),
     *                RSHI_T(0:NDKART)
      COMMON
     *       /SHIFTR/ RSHIFT(1:NDKART)
      COMMON
     *       /EANGLE/ ALPEUL,BETEUL,GAMEUL
      COMMON
     *       /IANGLE/ ALPINI,BETINI,GAMINI
      COMMON
     *       /QMULTI/ QMUL_N(0:NDMULT,-NDMULT:NDMULT),
     *                QMUL_P(0:NDMULT,-NDMULT:NDMULT),
     *                QMUL_T(0:NDMULT,-NDMULT:NDMULT)
      COMMON
     *       /SMULTI/ SMUL_N(0:NDMULT,-NDMULT:NDMULT),
     *                SMUL_P(0:NDMULT,-NDMULT:NDMULT),
     *                SMUL_T(0:NDMULT,-NDMULT:NDMULT)
      COMMON
     *       /AMULTI/ AMUL_N(0:NDMULT,-NDMULT:NDMULT),
     *                AMUL_P(0:NDMULT,-NDMULT:NDMULT),
     *                AMUL_T(0:NDMULT,-NDMULT:NDMULT)
      COMMON
     *       /QSHIFT/ QSHI_N(0:NDMULT,-NDMULT:NDMULT),
     *                QSHI_P(0:NDMULT,-NDMULT:NDMULT),
     *                QSHI_T(0:NDMULT,-NDMULT:NDMULT)
      COMMON
     *       /SSHIFT/ SSHI_N(0:NDMULT,-NDMULT:NDMULT),
     *                SSHI_P(0:NDMULT,-NDMULT:NDMULT),
     *                SSHI_T(0:NDMULT,-NDMULT:NDMULT)
      COMMON
     *       /ASHIFT/ ASHI_N(0:NDMULT,-NDMULT:NDMULT),
     *                ASHI_P(0:NDMULT,-NDMULT:NDMULT),
     *                ASHI_T(0:NDMULT,-NDMULT:NDMULT)
      COMMON
     *       /QROTAT/ QROT_N(0:NDMULT,-NDMULT:NDMULT),
     *                QROT_P(0:NDMULT,-NDMULT:NDMULT),
     *                QROT_T(0:NDMULT,-NDMULT:NDMULT)
      COMMON
     *       /SROTAT/ SROTNN(0:NDMULT,-NDMULT:NDMULT),
     *                SROTNP(0:NDMULT,-NDMULT:NDMULT),
     *                SROTNT(0:NDMULT,-NDMULT:NDMULT)
      COMMON
     *       /AROTAT/ AROTNN(0:NDMULT,-NDMULT:NDMULT),
     *                AROTNP(0:NDMULT,-NDMULT:NDMULT),
     *                AROTNT(0:NDMULT,-NDMULT:NDMULT)
      COMMON
     *       /QCNSTR/ STIFFQ(0:NDMULT,-NDMULT:NDMULT),
     *                QASKED(0:NDMULT,-NDMULT:NDMULT),
     *                IFLAGQ(0:NDMULT,-NDMULT:NDMULT)
      COMMON
     *       /SCNSTR/ STIFFS(0:NDMULT,-NDMULT:NDMULT),
     *                SASKED(0:NDMULT,-NDMULT:NDMULT),
     *                IFLAGS(0:NDMULT,-NDMULT:NDMULT)
      COMMON
     *       /GCNSTR/ STIFFG(0:NDMULT),
     *                GASKED(0:NDMULT),
     *                IFLAGG(0:NDMULT)
      COMMON
     *       /QLASTR/ GALMUQ(0:NDMULT,-NDMULT:NDMULT),
     *                QLINEA(0:NDMULT,-NDMULT:NDMULT),
     *                IFLALQ(0:NDMULT,-NDMULT:NDMULT)
      COMMON
     *       /SLASTR/ GALMUS(0:NDMULT,-NDMULT:NDMULT),
     *                SLINEA(0:NDMULT,-NDMULT:NDMULT),
     *                IFLALS(0:NDMULT,-NDMULT:NDMULT)
      COMMON
     *       /OURUNI/ QUNITS(0:NDMULT,0:NDMULT)
      COMMON
     *       /SIFUNI/ SUNITS(0:NDMULT,0:NDMULT)
      COMMON
     *       /VMUUNI/ VUNITS(0:NDMULT,0:NDMULT)
      COMMON
     *       /MAGUNI/ AUNITS(0:NDMULT,0:NDMULT)
      COMMON
     *       /SCALNG/ HOMSCA(1:NDKART)
C
      COMMON
     *       /DATPAN/ GPAIRN,FACTGN,EFERMN,DELTAN,EFER2N
     *       /DATPAP/ GPAIRP,FACTGP,EFERMP,DELTAP,EFER2P
      COMMON
     *       /PAIINI/ FERINI(0:NDISOS),DELINI(0:NDISOS),FE2INI(0:NDISOS)
      COMMON
     *       /ALLENE/ EKIN_N,EKIN_P,EKIN_T,
     *                EPOT_N,EPOT_P,EPOT_T,
     *                ESUM_N,ESUM_P,ESUM_T,
     *                EPAI_N,EPAI_P,EPAI_T,
     *                EREA_N,EREA_P,EREA_T,
     *                ELIP_N,ELIP_P,ELIP_T,
     *
     *                ECOULD,ECOULE,ECOULT,
     *                       ECOULS,ECOULV,
     *
     *                EMULCO,EMUSLO,EMUREA,
     *                ESIFCO,ESISLO,ESIREA,
     *                ESPICO,ESPSLO,ESPREA,
     *
     *                ENREAR,ECORCM,ECOR_R,
     *
     *                EEVEW0,EODDW0,ENE_W0,
     *                ENEVEN,ENEODD,ENESKY,
     *                ESTABN,ETOTSP,ETOTFU
C
      COMMON
     *       /CCPSKY/ CRHO_T,CRHO_S,CRHODT,CRHODS,
     *                CLPR_T,CLPR_S,
     *                CTAU_T,CTAU_S,
     *                CSCU_T,CSCU_S,
     *                CDIV_T,CDIV_S,
     *                CSPI_T,CSPI_S,CSPIDT,CSPIDS,
     *                CLPS_T,CLPS_S,
     *                CCUR_T,CCUR_S,
     *                CKIS_T,CKIS_S,
     *                CROT_T,CROT_S
      COMMON
     *       /DCPSKY/ DRHO_T,DRHO_S,DRHODT,DRHODS,
     *                DLPR_T,DLPR_S,
     *                DTAU_T,DTAU_S,
     *                DSCU_T,DSCU_S,
     *                DDIV_T,DDIV_S,
     *                DSPI_T,DSPI_S,DSPIDT,DSPIDS,
     *                DLPS_T,DLPS_S,
     *                DCUR_T,DCUR_S,
     *                DKIS_T,DKIS_S,
     *                DROT_T,DROT_S
      COMMON
     *       /ECPSKY/ ERHO_T,ERHO_S,ERHODT,ERHODS,
     *                ELPR_T,ELPR_S,
     *                ETAU_T,ETAU_S,
     *                ESCU_T,ESCU_S,
     *                EDIV_T,EDIV_S,
     *                ESPI_T,ESPI_S,ESPIDT,ESPIDS,
     *                ELPS_T,ELPS_S,
     *                ECUR_T,ECUR_S,
     *                EKIS_T,EKIS_S,
     *                EROT_T,EROT_S
C
      COMMON
     *       /CCPPAI/ PRHO_N,PRHODN,PRHOSN,POWERN,
     *                PRHO_P,PRHODP,PRHOSP,POWERP
      COMMON
     *       /BASPAR/ HBAROX,HBAROY,HBAROZ
      COMMON
     *       /ANGANG/ ANGU_N(1:NDKART),ANGU_P(1:NDKART),ANGU_T(1:NDKART)
      COMMON
     *       /ANGSPI/ SPIN_N(1:NDKART),SPIN_P(1:NDKART),SPIN_T(1:NDKART)
      COMMON
     *       /LINMOM/ DLINSN(0:NDKART),DLINSP(0:NDKART),DLINST(0:NDKART)
     *               ,ELINSN(0:NDKART),ELINSP(0:NDKART),ELINST(0:NDKART)
     *               ,TLINSN(0:NDKART),TLINSP(0:NDKART),TLINST(0:NDKART)
     *               ,ALINLN(0:NDKART),ALINLP(0:NDKART),ALINLT(0:NDKART)
      COMMON
     *       /ROTMOM/ DROTSN(0:NDKART),DROTSP(0:NDKART),DROTST(0:NDKART)
     *               ,EROTSN(0:NDKART),EROTSP(0:NDKART),EROTST(0:NDKART)
     *               ,TROTSN(0:NDKART),TROTSP(0:NDKART),TROTST(0:NDKART)
     *               ,AROTLN(0:NDKART),AROTLP(0:NDKART),AROTLT(0:NDKART)
      COMMON
     *       /SHIANG/ ANGS_N(1:NDKART),ANGS_P(1:NDKART),ANGS_T(1:NDKART)
      COMMON
     *       /ICNSTR/ STIFFI(1:NDKART),
     *                ASKEDI(1:NDKART),
     *                IFLAGI(1:NDKART)
      COMMON
     *       /ACNSTR/ STIFFA,ASKEDA,IFLAGA
      COMMON
     *       /DEFORM/ ALPHAC,IREALA
      COMMON
     *       /ITERTS/ ITESTA,ITESTO,NOITER,NUMITE
      COMMON
     *       /DIMENS/ LDBASE
      COMMON
     *       /PLANCK/ HBMASS,HBMRPA,HBMINP
      COMMON
     *       /SO_PAR/ W0_INP,W0PINP
      COMMON
     *       /CHARGE/ ECHAR2
      COMMON
     *       /EXCHAN/ COULEX
      COMMON
     *       /OMEGAS/ OMEGAX,OMEGAY,OMEGAZ
      COMMON
     *       /OMOVAS/ OMOVAX,OMOVAY,OMOVAZ
      COMMON
     *       /OMISOS/ OMISOX,OMISOY,OMISOZ
      COMMON
     *       /LAND_G/ X0_LAN,X1_LAN,G0_LAN,G0PLAN,G1_LAN,G1PLAN
      COMMON
     *       /CFIPRI/ NFIPRI
C
      DATA
     *     IOPEND /0/, IVEREV /59/
      DATA
     *     FILOLD /'DUMMY FILE NAME'/
C
C=======================================================================
C
C         THIS SUBROUTINE WRITES ON DISC A REVIEW OF DATA  AND  RESULTS
C
C         IREVIE=0  --->  NO REVIEW FILE
C         IREVIE=1  --->  SHORT REVIEW FILE (NO   SINGLE PARTICLE DATA)
C         IREVIE=2  --->  LONG  REVIEW FILE (WITH SINGLE PARTICLE DATA)
C         IREVIE=3  --->  LARGE REVIEW FILE (WITH X & Z SINGLE PARTICLE
C                                                       ALIGNMENT DATA)
C
C=======================================================================
C
      REWIND(UNIT=NFIREV,IOSTAT=IERROR)
      IF (IERROR.NE.0) THEN
          WRITE(NFIPRI,'(''REVIEW() - ERROR IN '',
     *          ''REWINDING FILE '',i4)') NFIREV
          RETURN
      END IF
C
C=======================================================================
C        WRITING RESULTS TO THE REVIEW FILE
C=======================================================================
C
      WRITE(NFIREV,'(24(1H>),''                    '',3X,5X,24(1H<))')
C
      WRITE(NFIREV,'(24(1H>),''   REVIEW VERSION = '',I3,5X,24(1H<))')
     *
     *      IVEREV
C
      WRITE(NFIREV,'(24(1H>),''   CODE   VERSION = '',A5,3X,24(1H<))')
     *
     *      VERSIO
C
      WRITE(NFIREV,'(24(1H>),''                    '',3X,5X,24(1H<))')
C
      WRITE(NFIREV,'(''DIMENS'')')
      WRITE(NFIREV,'(6X,14I5)')
     *
     *      NDMAIN,NDBASE,NDGAUS,NDXHRM,NDYHRM,NDZHRM,
     *      NDSTAT,NDCOUL,NDPOLS,NDITER,NDCOUP,NDLAMB,
     *      NDMULT,NDTERM
C
      WRITE(NFIREV,'(''FILNAM'')')
      WRITE(NFIREV,'(6X,A68)')
     *
     *      FILREP,FILREC,FILWOO,FILREV,FILCOU,FILWAV,FILKER,
     *      FILYUP,FILYUC,FILLIP,FILLIC,FILFIP,FILFIC,
     *      FILGOP,FILGOC,FILGPP,FILGPC
C
      WRITE(NFIREV,'(''SKYRME'')')
      WRITE(NFIREV,'(6X,A4)')
     *
     *      SKYRME
C
      WRITE(NFIREV,'(''ISTAND'')')
      WRITE(NFIREV,'(6X,5I6/12X,4I6)')
     *
     *      ISTAND,KETA_J,KETA_W,KETACM,KETA_M,
     *             JETA_J,JETA_W,JETACM,JETA_M
C
      WRITE(NFIREV,'(''GOGNY'')')
      WRITE(NFIREV,'(6X,A4)')
     *
     *      GOGNAM
C
      WRITE(NFIREV,'(''ROTCOR'')')
      WRITE(NFIREV,'(6X,I6)')
     *
     *      KETA_R
C
      WRITE(NFIREV,'(''LANDAU'')')
      WRITE(NFIREV,'(6X,I6,3(1PE18.10),/,12X,6(1PE18.10),/,6X,I6)')
     *
     *      LANODD,HBMSAT,RHOSAT,EFFSAT,
     *      X0_LAN,X1_LAN,G0_LAN,G0PLAN,G1_LAN,G1PLAN,
     *      LANSCA
C
      WRITE(NFIREV,'(''IN_FIX'')')
      WRITE(NFIREV,'(6X,2I6)')
     *
     *      IN_FIX,IZ_FIX
C
      WRITE(NFIREV,'(''NOSCIL'')')
      WRITE(NFIREV,'(6X,3I6)')
     *
     *      NOSCIL,NLIMIT,LDBASE
C
      WRITE(NFIREV,'(''IPAIRI'')')
      WRITE(NFIREV,'(6X,9I6)')
     *
     *      IPAIRI,IROTAT,IREVIE,
     *      IPAHFB,JPABCS,IMFHFB,
     *      LIPKIN,LIPKIP,ITWOBA
C
      WRITE(NFIREV,'(''HBMASS'')')
      WRITE(NFIREV,'(6X,5(1PE18.10))')
     *
     *      HBMASS,HBMRPA,ECHAR2,COULEX,HBMINP
C
      WRITE(NFIREV,'(''SO_PAR'')')
      WRITE(NFIREV,'(6X,2(1PE18.10))')
     *
     *      W0_INP,W0PINP
C
      WRITE(NFIREV,'(''CMSXFC'')')
      WRITE(NFIREV,'(6X,3(1PE18.10))')
     *
     *      CMSXFC,CMSYFC,CMSZFC
C
      WRITE(NFIREV,'(''XMOMFC'')')
      WRITE(NFIREV,'(6X,3(1PE18.10))')
     *
     *      XMOMFC,YMOMFC,ZMOMFC
C
      WRITE(NFIREV,'(''HBAROX'')')
      WRITE(NFIREV,'(6X,3(1PE18.10))')
     *
     *      HBAROX,HBAROY,HBAROZ
C
      WRITE(NFIREV,'(''HOMSCA'')')
      WRITE(NFIREV,'(6X,3(1PE18.10))')
     *
     *      (HOMSCA(KARTEZ),KARTEZ=1,NDKART)
C
      WRITE(NFIREV,'(''NXHERM'')')
      WRITE(NFIREV,'(6X,3I6)')
     *
     *      NXHERM,NYHERM,NZHERM
C
      WRITE(NFIREV,'(''NXMAXX'')')
      WRITE(NFIREV,'(6X,3I6)')
     *
     *      NXMAXX,NYMAXX,NZMAXX
C
      WRITE(NFIREV,'(''EPSHER'')')
      WRITE(NFIREV,'(6X,3(1PE18.10))')
     *
     *      EPSHER
C
      WRITE(NFIREV,'(''HOMEGA'')')
      WRITE(NFIREV,'(6X,5(1PE18.10))')
     *
     *      HOMEGA,FCHOM0,ENECUT,CVOLFC,R0PARM
C
      WRITE(NFIREV,'(''ISOTRO'')')
      WRITE(NFIREV,'(6X,I6)')
     *
     *      ISOTRO
C
      WRITE(NFIREV,'(''NUMCOU'')')
      WRITE(NFIREV,'(6X,2I6,6X,1PE18.10)')
     *
     *      NUMCOU,NUMETA,FURMAX
C
      WRITE(NFIREV,'(''COULOM'')')
      WRITE(NFIREV,'(6X,3I6)')
     *
     *      ICOTYP,ICOUDI,ICOUEX
C
      WRITE(NFIREV,'(''YUKAWA'')')
      WRITE(NFIREV,'(6X,I6,6X,2(1PE18.10),6X,I6,6X,4(1PE18.10))')
     *
     *      I_YUKA,PIMASS,PNMASS,IYUTYP,
     *      YUKAGT,YUKAG0,YUKAG1,YUKAG2
C
      WRITE(NFIREV,'(''GOGENE'')')
      WRITE(NFIREV,'(6X,I6)')
     *
     *      I_GOGA
C
      WRITE(NFIREV,'(''GOGPAI'')')
      WRITE(NFIREV,'(6X,I6)')
     *
     *      IGOGPA
C
      WRITE(NFIREV,'(''NULAST'')')
      WRITE(NFIREV,'(6X,I6,12X,1PE18.10)')
     *
     *      NULAST,EPSITE
C
      WRITE(NFIREV,'(''NUCHAO'')')
      WRITE(NFIREV,'(6X,I6)')
     *
     *      NUCHAO
C
      WRITE(NFIREV,'(''IPOTHO'')')
      WRITE(NFIREV,'(6X,I6)')
     *
     *      IPOTHO
C
      WRITE(NFIREV,'(''NILXYZ'')')
      WRITE(NFIREV,'(6X,I6)')
     *
     *      NILXYZ
C
      WRITE(NFIREV,'(''NUPING'')')
      WRITE(NFIREV,'(6X,I6,12X,1PE18.10)')
     *
     *      NUPING,EPSPNG
C
      WRITE(NFIREV,'(''IFLIPI'')')
      WRITE(NFIREV,'(6X,6I6)')
     *
     *      ICHFLI,IPAFLI,IREFLI,
     *      ISPFLI,ISHFLI,IFLIPI
C
      WRITE(NFIREV,'(''N_FLIG'')')
      WRITE(NFIREV,'((6X,3(I6,3I4)))')
     *
     *   (((NPFLIG(IPARIT,IREVER,ICHARG),IREVER=0,NDREVE),
     *                                   IPARIT=0,NDPARI),
     *    ((NHFLIG(IPARIT,IREVER,ICHARG),IREVER=0,NDREVE),
     *                                   IPARIT=0,NDPARI),
     *    ((NOFLIG(IPARIT,IREVER,ICHARG),IREVER=0,NDREVE),
     *                                   IPARIT=0,NDPARI),
     *                                   ICHARG=0,NDISOS)
C
      WRITE(NFIREV,'(''N_FLIM'')')
      WRITE(NFIREV,'((6X,3(I6,I4,8X)))')
     *
     *    ((NPFLIM(IREVER,ICHARG),IREVER=0,NDREVE),
     *     (NHFLIM(IREVER,ICHARG),IREVER=0,NDREVE),
     *     (NOFLIM(IREVER,ICHARG),IREVER=0,NDREVE),ICHARG=0,NDISOS)
C
      WRITE(NFIREV,'(''N_FLIQ'')')
      WRITE(NFIREV,'((6X,3(I6,I4,8X)))')
     *
     *    ((NPFLIQ(IPARIT,ICHARG),IPARIT=0,NDPARI),
     *     (NHFLIQ(IPARIT,ICHARG),IPARIT=0,NDPARI),
     *     (NOFLIQ(IPARIT,ICHARG),IPARIT=0,NDPARI),ICHARG=0,NDISOS)
C
      WRITE(NFIREV,'(''N_FLIZ'')')
      WRITE(NFIREV,'((6X,3(I6,8X)))')
     *
     *     (NPFLIZ(ICHARG),
     *      NHFLIZ(ICHARG),
     *      NOFLIZ(ICHARG),ICHARG=0,NDISOS)
C
      WRITE(NFIREV,'(''N_FILG'')')
      WRITE(NFIREV,'((6X,3(I6,3I4)))')
     *
     *   (((NPFILG(IPARIT,IREVER,ICHARG),IREVER=0,NDREVE),
     *                                   IPARIT=0,NDPARI),
     *    ((NHFILG(IPARIT,IREVER,ICHARG),IREVER=0,NDREVE),
     *                                   IPARIT=0,NDPARI),
     *    ((NOFILG(IPARIT,IREVER,ICHARG),IREVER=0,NDREVE),
     *                                   IPARIT=0,NDPARI),
     *                                   ICHARG=0,NDISOS)
C
      WRITE(NFIREV,'(''N_FILZ'')')
      WRITE(NFIREV,'((6X,3(I6,8X)))')
     *
     *     (NPFILZ(ICHARG),
     *      NHFILZ(ICHARG),
     *      NOFILZ(ICHARG),ICHARG=0,NDISOS)
C
      WRITE(NFIREV,'(''SLOWEV'')')
      WRITE(NFIREV,'(6X,4(1PE18.10))')
     *
     *      SLOWEV,SLOWOD,SLOWPA,SLOWLI
C
      WRITE(NFIREV,'(''OMEGAY'')')
      WRITE(NFIREV,'(6X,2(1PE18.10))')
     *
     *      OMEGAY,OMISOY
C
      WRITE(NFIREV,'(''OMEXYZ'')')
      WRITE(NFIREV,'(6X,3(1PE18.10),I6)')
     *
     *      OMEGAX,OMEGAY,OMEGAZ,ITILAX
C
      WRITE(NFIREV,'(''OMOXYZ'')')
      WRITE(NFIREV,'(6X,3(1PE18.10),I6)')
     *
     *      OMOVAX,OMOVAY,OMOVAZ,IMOVAX
C
      WRITE(NFIREV,'(''OMIXYZ'')')
      WRITE(NFIREV,'(6X,3(1PE18.10),I6)')
     *
     *      OMISOX,OMISOY,OMISOZ,ITISAX
C
      WRITE(NFIREV,'(''NO_ORB'')')
      WRITE(NFIREV,'(6X,I6)')
     *
     *      NO_ORB
C
      WRITE(NFIREV,'(''ALPHA'')')
      WRITE(NFIREV,'(6X,I6)')
     *
     *      LAMMAX
      WRITE(NFIREV,'((6X,2('' ('',1PE16.8,'','',1PE16.8,'')'')))')
     *
     *      ((ALPHAC(L,M),M=-L,+L),L=0,LAMMAX)
C
C
      WRITE(NFIREV,'(''CCPALL'')')
      WRITE(NFIREV,'((6X,2(1PE18.10)))')
     *
     *      (CCPALL(I),I=1,NDCOUP)
C
      WRITE(NFIREV,'(''DCPALL'')')
      WRITE(NFIREV,'((6X,2(1PE18.10)))')
     *
     *      (DCPALL(I),I=1,NDCOUP)
C
      WRITE(NFIREV,'(''ECPALL'')')
      WRITE(NFIREV,'((6X,2(1PE18.10)))')
     *
     *      (ECPALL(I),I=1,NDCOUP)
C
      WRITE(NFIREV,'(''CCPPAI'')')
      WRITE(NFIREV,'((6X,4(1PE18.10)))')
     *
     *      PRHO_N,PRHODN,PRHOSN,POWERN,
     *      PRHO_P,PRHODP,PRHOSP,POWERP
C
      WRITE(NFIREV,'(''SYMETR'')')
      WRITE(NFIREV,'(6X,8I6)')
     *
     *      ISIGNY,ISIMTX,ISIMTZ,ISIMPY,IPARTY,ISIQTY,JSIMTY,ISPHER
C
      WRITE(NFIREV,'(''ITESTA'')')
      WRITE(NFIREV,'(6X,4I6)')
     *
     *      ITESTA,ITESTO,NOITER,NUMITE
C
      WRITE(NFIREV,'(''CONFIN'')')
      WRITE(NFIREV,'(6X,3I6)')
     *
     *      IS_YES,IS_PIN,IS_CHA
C
      WRITE(NFIREV,'(''CONVER'')')
      WRITE(NFIREV,'((6X,I6,6(1PE18.10)))')
     *
     *      (ITESTA-1+I,ETOTFI(I),ETOTSI(I),ESTABI(I),
     *                  QUA20I(I),QUA22I(I),
     *                  ANGUTI(I),I=1,NUMITE-ITESTA+1)
C
      WRITE(NFIREV,'(''RMSRAD'')')
      WRITE(NFIREV,'((6X,I6,6X,3(1PE18.10)))')
     *
     *     (KARTEZ,RADI_N(KARTEZ),RADI_P(KARTEZ),RADI_T(KARTEZ),
     *                                                  KARTEZ=0,NDKART)
C
      WRITE(NFIREV,'(''SHIRAD'')')
      WRITE(NFIREV,'((6X,I6,6X,3(1PE18.10)))')
     *
     *     (KARTEZ,RSHI_N(KARTEZ),RSHI_P(KARTEZ),RSHI_T(KARTEZ),
     *                                                  KARTEZ=0,NDKART)
C
      WRITE(NFIREV,'(''SHIFT_'')')
      WRITE(NFIREV,'((6X,3(1PE18.10)))')
     *
     *     (RSHIFT(KARTEZ),KARTEZ=1,NDKART)
C
      WRITE(NFIREV,'(''EULER_'')')
      WRITE(NFIREV,'((6X,3(1PE18.10)))')
     *
     *      ALPEUL,BETEUL,GAMEUL
C
      WRITE(NFIREV,'(''REULER'')')
      WRITE(NFIREV,'((6X,3(1PE18.10),I6))')
     *
     *      ALPINI,BETINI,GAMINI,INIROT
C
      WRITE(NFIREV,'(''INIINV'')')
      WRITE(NFIREV,'((6X,2I6))')
     *
     *      INIINV,INIKAR
C
      WRITE(NFIREV,'(''ISCHIF'')')
      WRITE(NFIREV,'(6X,I6)')
     *
     *      ISCHIF
C
      WRITE(NFIREV,'(''NUMRED'')')
      WRITE(NFIREV,'(6X,3I6)')
     *
     *      NMURED,NMARED,NSIRED
C
      WRITE(NFIREV,'(''QMULTI'')')
      WRITE(NFIREV,'(6X,10I6)')
     *
     *      NMUMAX,NMUCON,NMUCOU,NMUPRI,
     *      NSIMAX,NSICON,       NSIPRI,
     *      NMAMAX,NMACON,       NMAPRI
C
      WRITE(NFIREV,'((6X,2I6,3(1PE18.10)))')
     *
     *      ((L,M,QMUL_N(L,M),QMUL_P(L,M),QMUL_T(L,M),M=0,L),L=0,NMUMAX)
C
      WRITE(NFIREV,'(''QMULT-'')')
      WRITE(NFIREV,'((6X,2I6,3(1PE18.10)))')
     *
     *    ((L,M,QMUL_N(L,M),QMUL_P(L,M),QMUL_T(L,M),M=-L,-1),L=1,NMUMAX)
C
      WRITE(NFIREV,'(''QSHIMO'')')
      WRITE(NFIREV,'((6X,2I6,3(1PE18.10)))')
     *
     *    ((L,M,QSHI_N(L,M),QSHI_P(L,M),QSHI_T(L,M),M=-L,L),L=1,NMUMAX)
C
      WRITE(NFIREV,'(''QROTMO'')')
      WRITE(NFIREV,'((6X,2I6,3(1PE18.10)))')
     *
     *    ((L,M,QROT_N(L,M),QROT_P(L,M),QROT_T(L,M),M=-L,L),L=1,NMUMAX)
C
      WRITE(NFIREV,'(''SMULMO'')')
      WRITE(NFIREV,'((6X,2I6,3(1PE18.10)))')
     *
     *    ((L,M,SMUL_N(L,M),SMUL_P(L,M),SMUL_T(L,M),M=-L,L),L=1,NSIMAX)
C
      WRITE(NFIREV,'(''SSHIMO'')')
      WRITE(NFIREV,'((6X,2I6,3(1PE18.10)))')
     *
     *    ((L,M,SSHI_N(L,M),SSHI_P(L,M),SSHI_T(L,M),M=-L,L),L=1,NSIMAX)
C
      WRITE(NFIREV,'(''SROTMO'')')
      WRITE(NFIREV,'((6X,2I6,3(1PE18.10)))')
     *
     *    ((L,M,SROTNN(L,M),SROTNP(L,M),SROTNT(L,M),M=-L,L),L=1,NSIMAX)
C
      WRITE(NFIREV,'(''AMULMO'')')
      WRITE(NFIREV,'((6X,2I6,3(1PE18.10)))')
     *
     *    ((L,M,AMUL_N(L,M),AMUL_P(L,M),AMUL_T(L,M),M=-L,L),L=1,NMAMAX)
C
      WRITE(NFIREV,'(''ASHIMO'')')
      WRITE(NFIREV,'((6X,2I6,3(1PE18.10)))')
     *
     *    ((L,M,ASHI_N(L,M),ASHI_P(L,M),ASHI_T(L,M),M=-L,L),L=1,NMAMAX)
C
      WRITE(NFIREV,'(''AROTMO'')')
      WRITE(NFIREV,'((6X,2I6,3(1PE18.10)))')
     *
     *    ((L,M,AROTNN(L,M),AROTNP(L,M),AROTNT(L,M),M=-L,L),L=1,NMAMAX)
C
      WRITE(NFIREV,'(''QUNITS'')')
      WRITE(NFIREV,'((6X,2I6,1PE18.10))')
     *
     *      ((L,M,QUNITS(L,M),M=0,L),L=0,NMUMAX)
C
      WRITE(NFIREV,'(''SUNITS'')')
      WRITE(NFIREV,'((6X,2I6,1PE18.10))')
     *
     *      ((L,M,SUNITS(L,M),M=0,L),L=0,NSIMAX)
C
      WRITE(NFIREV,'(''VUNITS'')')
      WRITE(NFIREV,'((6X,2I6,1PE18.10))')
     *
     *      ((L,M,VUNITS(L,M),M=0,L),L=0,NSIMAX)
C
      WRITE(NFIREV,'(''AUNITS'')')
      WRITE(NFIREV,'((6X,2I6,1PE18.10))')
     *
     *      ((L,M,AUNITS(L,M),M=0,L),L=0,NMAMAX)
C
      WRITE(NFIREV,'(''STIFFQ'')')
      WRITE(NFIREV,'((6X,2I6,2(1PE18.10),I6))')
     *
     *      ((L,M,STIFFQ(L,M),QASKED(L,M),IFLAGQ(L,M),M=0,L),L=0,NMUMAX)
C
      WRITE(NFIREV,'(''STIFF-'')')
      WRITE(NFIREV,'((6X,2I6,2(1PE18.10),I6))')
     *
     *    ((L,M,STIFFQ(L,M),QASKED(L,M),IFLAGQ(L,M),M=-L,-1),L=1,NMUMAX)
C
      WRITE(NFIREV,'(''STIFFS'')')
      WRITE(NFIREV,'((6X,2I6,2(1PE18.10),I6))')
     *
     *    ((L,M,STIFFS(L,M),SASKED(L,M),IFLAGS(L,M),M=-L,+L),L=0,NSIMAX)
C
      WRITE(NFIREV,'(''STIFFG'')')
      WRITE(NFIREV,'((6X,I6,2(1PE18.10),I6))')
     *
     *     (L,STIFFG(L),GASKED(L),IFLAGG(L),L=0,NMUMAX)
C
      WRITE(NFIREV,'(''QLINEA'')')
      WRITE(NFIREV,'((6X,2I6,2(1PE18.10),I6))')
     *
     *    ((L,M,GALMUQ(L,M),QLINEA(L,M),IFLALQ(L,M),M=-L,+L),L=1,NMUMAX)
C
      WRITE(NFIREV,'(''SLINEA'')')
      WRITE(NFIREV,'((6X,2I6,2(1PE18.10),I6))')
     *
     *    ((L,M,GALMUS(L,M),SLINEA(L,M),IFLALS(L,M),M=-L,+L),L=0,NSIMAX)
C
      WRITE(NFIREV,'(''PAIRNG'')')
      WRITE(NFIREV,'((6X,5(1PE18.10)))')
     *
     *      GPAIRN,FACTGN,EFERMN,DELTAN,EFER2N,
     *      GPAIRP,FACTGP,EFERMP,DELTAP,EFER2P
C
      WRITE(NFIREV,'(''FERFIX'')')
      WRITE(NFIREV,'((6X,2(1PE18.10),2I6))')
     *
     *      FERFIN,FERFIP,IFEFIN,IFEFIP
C
      WRITE(NFIREV,'(''FE2FIX'')')
      WRITE(NFIREV,'((6X,2(1PE18.10),2I6))')
     *
     *      FE2FIN,FE2FIP,IF2FIN,IF2FIP
C
      WRITE(NFIREV,'(''DELFIX'')')
      WRITE(NFIREV,'((6X,2(1PE18.10),2I6))')
     *
     *      DELFIN,DELFIP,IDEFIN,IDEFIP
C
      WRITE(NFIREV,'(''SIGBLO'')')
      WRITE(NFIREV,'(6X,8I6)')
     *
     *      INSIGN,IPSIGN,ISSIGN,IDSIGN,
     *      INSIGP,IPSIGP,ISSIGP,IDSIGP
C
      WRITE(NFIREV,'(''SIMBLO'')')
      WRITE(NFIREV,'(6X,6I6)')
     *
     *      INSIMN,IRSIMN,IDSIMN,
     *      INSIMP,IRSIMP,IDSIMP
C
      WRITE(NFIREV,'(''SIQBLO'')')
      WRITE(NFIREV,'(6X,6I6)')
     *
     *      INSIQN,IPSIQN,IDSIQN,
     *      INSIQP,IPSIQP,IDSIQP
C
      WRITE(NFIREV,'(''SIZBLO'')')
      WRITE(NFIREV,'(6X,4I6)')
     *
     *      INSIZN,IDSIZN,
     *      INSIZP,IDSIZP
C
      WRITE(NFIREV,'(''INIBLO'')')
      WRITE(NFIREV,'(6X,4I6)')
     *
     *      IFIBLN,INIBLN,
     *      IFIBLP,INIBLP
C
      WRITE(NFIREV,'(''CUTOFF'')')
      WRITE(NFIREV,'(6X,1PE18.10,I6)')
     *
     *      ECUTOF,LIMQUA
C
      WRITE(NFIREV,'(''PAIINI'')')
      WRITE(NFIREV,'((6X,6(1PE18.10)))')
     *
     *      (FERINI(ICHARG),ICHARG=0,NDISOS),
     *      (DELINI(ICHARG),ICHARG=0,NDISOS),
     *      (FE2INI(ICHARG),ICHARG=0,NDISOS)
C
      WRITE(NFIREV,'(''ENERGY'')')
      WRITE(NFIREV,'((6X,3(1PE18.10)))')
     *
     *                EKIN_N,EKIN_P,EKIN_T,
     *                ESUM_N,ESUM_P,ESUM_T,
     *                EPAI_N,EPAI_P,EPAI_T,
     *
     *                ECOULD,ECOULE,ECOULT,
     *
     *                EMULCO,EMUSLO,EMUREA,
     *                ESPICO,ESPSLO,ESPREA,
     *
     *                              ENREAR
C
      WRITE(NFIREV,'(''ECOULE'')')
      WRITE(NFIREV,'((6X,3(1PE18.10)))')
     *
     *                ECOULS,ECOULV,ECOULE
C
      WRITE(NFIREV,'((6X,3(1PE18.10)))')
     *
     *                EEVEW0,EODDW0,ENE_W0,
     *                ENEVEN,ENEODD,ENESKY,
     *                ESTABN,ETOTSP,ETOTFU
C
      WRITE(NFIREV,'(''ECORCM'')')
      WRITE(NFIREV,'((6X,3(1PE18.10)))')
     *
     *                ECORCM
C
      WRITE(NFIREV,'(''ECOR_R'')')
      WRITE(NFIREV,'((6X,3(1PE18.10)))')
     *
     *                ECOR_R
C
      WRITE(NFIREV,'(''ESIFCO'')')
      WRITE(NFIREV,'((6X,3(1PE18.10)))')
     *
     *                ESIFCO,ESISLO,ESIREA
C
      WRITE(NFIREV,'(''P-REAR'')')
      WRITE(NFIREV,'((6X,3(1PE18.10)))')
     *
     *                EREA_N,EREA_P,EREA_T
C
      WRITE(NFIREV,'(''LIPKIN'')')
      WRITE(NFIREV,'((6X,3(1PE18.10)))')
     *
     *                ELIP_N,ELIP_P,ELIP_T
C
      WRITE(NFIREV,'(''POTIAL'')')
      WRITE(NFIREV,'((6X,3(1PE18.10)))')
     *
     *                EPOT_N,EPOT_P,EPOT_T
C
      WRITE(NFIREV,'(''ANGSPI'')')
      WRITE(NFIREV,'(3((6X,1PE18.10)))')
     *
     *      ANGU_N(2),ANGU_P(2),ANGU_T(2),
     *      SPIN_N(2),SPIN_P(2),SPIN_T(2),
     *
     *      ANGU_N(1),ANGU_P(1),ANGU_T(1),
     *      SPIN_N(1),SPIN_P(1),SPIN_T(1),
     *
     *      ANGU_N(3),ANGU_P(3),ANGU_T(3),
     *      SPIN_N(3),SPIN_P(3),SPIN_T(3)
C
      WRITE(NFIREV,'(''SHISPI'')')
      WRITE(NFIREV,'((6X,I6,6X,3(1PE18.10)))')
     *
     *     (KARTEZ,ANGS_N(KARTEZ),ANGS_P(KARTEZ),ANGS_T(KARTEZ),
     *                                                  KARTEZ=1,NDKART)
C
      WRITE(NFIREV,'(''LINEMO'')')
      WRITE(NFIREV,'((6X,I6,6X,3(1PE18.10)))')
     *
     *     (KARTEZ,ALINLN(KARTEZ),ALINLP(KARTEZ),ALINLT(KARTEZ),
     *                                                  KARTEZ=1,NDKART)
     *     ,   0  ,ALINLN(   0  ),ALINLP(   0  ),ALINLT(   0  ),
     *
     *     (KARTEZ,DLINSN(KARTEZ),DLINSP(KARTEZ),DLINST(KARTEZ),
     *                                                  KARTEZ=1,NDKART)
     *     ,   0  ,DLINSN(   0  ),DLINSP(   0  ),DLINST(   0  ),
     *
     *     (KARTEZ,ELINSN(KARTEZ),ELINSP(KARTEZ),ELINST(KARTEZ),
     *                                                  KARTEZ=1,NDKART)
     *     ,   0  ,ELINSN(   0  ),ELINSP(   0  ),ELINST(   0  ),
     *
     *     (KARTEZ,TLINSN(KARTEZ),TLINSP(KARTEZ),TLINST(KARTEZ),
     *                                                  KARTEZ=1,NDKART)
     *     ,   0  ,TLINSN(   0  ),TLINSP(   0  ),TLINST(   0  )
C
      WRITE(NFIREV,'(''ROTAMO'')')
      WRITE(NFIREV,'((6X,I6,6X,3(1PE18.10)))')
     *
     *     (KARTEZ,AROTLN(KARTEZ),AROTLP(KARTEZ),AROTLT(KARTEZ),
     *                                                  KARTEZ=1,NDKART)
     *     ,   0  ,AROTLN(   0  ),AROTLP(   0  ),AROTLT(   0  ),
     *
     *     (KARTEZ,DROTSN(KARTEZ),DROTSP(KARTEZ),DROTST(KARTEZ),
     *                                                  KARTEZ=1,NDKART)
     *     ,   0  ,DROTSN(   0  ),DROTSP(   0  ),DROTST(   0  ),
     *
     *     (KARTEZ,EROTSN(KARTEZ),EROTSP(KARTEZ),EROTST(KARTEZ),
     *                                                  KARTEZ=1,NDKART)
     *     ,   0  ,EROTSN(   0  ),EROTSP(   0  ),EROTST(   0  ),
     *
     *     (KARTEZ,TROTSN(KARTEZ),TROTSP(KARTEZ),TROTST(KARTEZ),
     *                                                  KARTEZ=1,NDKART)
     *     ,   0  ,TROTSN(   0  ),TROTSP(   0  ),TROTST(   0  )
C
      WRITE(NFIREV,'(''STIFFI'')')
      WRITE(NFIREV,'(6X,2(1PE18.10),I6)')
     *
     *      STIFFI(2),ASKEDI(2),IFLAGI(2)
C
      WRITE(NFIREV,'(''STIFFA'')')
      WRITE(NFIREV,'(6X,2(1PE18.10),I6)')
     *
     *      STIFFA,ASKEDA,IFLAGA
C
      WRITE(NFIREV,'(''STIF3D'')')
      WRITE(NFIREV,'((6X,I6,6X,2(1PE18.10),I6))')
     *
     *      (KARTEZ,STIFFI(KARTEZ),ASKEDI(KARTEZ),IFLAGI(KARTEZ),
     *                                                  KARTEZ=1,NDKART)
C
      WRITE(NFIREV,'(''NUMBSP'')')
      WRITE(NFIREV,'(6X,5I6)')
     *
     *      MREVER,((NUMBSP(IREVER,ICHARG),ICHARG=0,NDISOS),
     *                                     IREVER=0,MREVER)
C
      WRITE(NFIREV,'(''CONFIG'')')
C
      DO ICHARG=0,NDISOS
         DO IREVER=0,MREVER
            DO IPARIT=0,NDPARI
C
               WRITE(NFIREV,'((6X,3I6,3X,100(50I2,/,24X)))')
     *
     *         ICHARG,IREVER,IPARIT,(N_OCCU(I,IPARIT,IREVER,ICHARG),
     *                                    I=1,NUMBSP(IREVER,ICHARG))
            END DO
         END DO
      END DO
C
      DO ICHARG=0,NDISOS
         DO IREVER=0,MREVER
            DO IPARIT=0,NDPARI
C
               WRITE(NFIREV,'((6X,3I6,3X,100(50I2,/,24X)))')
     *
     *         ICHARG,IREVER,IPARIT,(N_VACC(I,IPARIT,IREVER,ICHARG),
     *                                    I=1,NUMBSP(IREVER,ICHARG))
            END DO
         END DO
      END DO
C
      WRITE(NFIREV,'(''CONFIM'')')
C
      DO ICHARG=0,NDISOS
         DO IREVER=0,MREVER
C
            WRITE(NFIREV,'((6X,2I6,9X,100(50I2,/,24X)))')
     *
     *            ICHARG,IREVER,(L_OCCU(I,IREVER,ICHARG),
     *                         I=1,NUMBSP(IREVER,ICHARG))
         END DO
      END DO
C
      DO ICHARG=0,NDISOS
         DO IREVER=0,MREVER
C
            WRITE(NFIREV,'((6X,2I6,9X,100(50I2,/,24X)))')
     *
     *            ICHARG,IREVER,(L_VACC(I,IREVER,ICHARG),
     *                         I=1,NUMBSP(IREVER,ICHARG))
         END DO
      END DO
C
      WRITE(NFIREV,'(''CONFIQ'')')
C
      DO ICHARG=0,NDISOS
         DO IPARIT=0,NDPARI
C
            WRITE(NFIREV,'((6X,2I6,9X,100(50I2,/,24X)))')
     *
     *            ICHARG,IPARIT,(K_OCCU(I,IPARIT,ICHARG),
     *                         I=1,NUMBSP(0,ICHARG)+NUMBSP(1,ICHARG))
         END DO
      END DO
C
      DO ICHARG=0,NDISOS
         DO IPARIT=0,NDPARI
C
            WRITE(NFIREV,'((6X,2I6,9X,100(50I2,/,24X)))')
     *
     *            ICHARG,IPARIT,(K_VACC(I,IPARIT,ICHARG),
     *                         I=1,NUMBSP(0,ICHARG)+NUMBSP(1,ICHARG))
         END DO
      END DO
C
      WRITE(NFIREV,'(''CONFIZ'')')
C
      DO ICHARG=0,NDISOS
C
         WRITE(NFIREV,'((6X,2I6,9X,100(50I2,/,24X)))')
     *
     *         ICHARG,(M_OCCU(I,ICHARG),
     *             I=1,NUMBSP(0,ICHARG)+NUMBSP(1,ICHARG))
      END DO
C
      DO ICHARG=0,NDISOS
C
         WRITE(NFIREV,'((6X,2I6,9X,100(50I2,/,24X)))')
     *
     *         ICHARG,(M_VACC(I,ICHARG),
     *             I=1,NUMBSP(0,ICHARG)+NUMBSP(1,ICHARG))
      END DO
C
C=======================================================================
C
      IF (IREVIE.LT.2) RETURN
C
C=======================================================================
C
      WRITE(NFIREV,'(''SPENER'')')
      WRITE(NFIREV,'((6X,3I6,2(1PE18.10),2X,A13,2X,A10,2X,A15,
     *                       3(1PE18.10),
     *                       7(1PE14.6)))')
     *
     *      (((ICHARG,IREVER,I,SPENER(I+IREVER*NUMBSP(0,ICHARG),ICHARG),
     *                         SPOCCU(I+IREVER*NUMBSP(0,ICHARG),ICHARG),
     *                         SPORDE(I+IREVER*NUMBSP(0,ICHARG),ICHARG),
     *                         SPKART(I+IREVER*NUMBSP(0,ICHARG),ICHARG),
     *                         SPNILS(I+IREVER*NUMBSP(0,ICHARG),ICHARG),
     *                         SPPARI(I+IREVER*NUMBSP(0,ICHARG),ICHARG),
     *                         SPALIG(I+IREVER*NUMBSP(0,ICHARG),ICHARG),
     *                         SPSPAL(I+IREVER*NUMBSP(0,ICHARG),ICHARG),
     *                         SPMO20(I+IREVER*NUMBSP(0,ICHARG),ICHARG),
     *                         SPMO22(I+IREVER*NUMBSP(0,ICHARG),ICHARG),
     *                        (SPSIZE(I+IREVER*NUMBSP(0,ICHARG),ICHARG,
     *                                                          KARTEZ),
     *                                KARTEZ=0,NDKART),
     *                         SPSIMP(I+IREVER*NUMBSP(0,ICHARG),ICHARG),
     *                       I=1,NUMBSP(IREVER,ICHARG)),
     *                IREVER=0,MREVER),
     *         ICHARG=0,NDISOS)
C
C=======================================================================
C
      IF (IREVIE.LT.3) RETURN
C
C=======================================================================
C
      WRITE(NFIREV,'(''SPXZAL'')')
      WRITE(NFIREV,'((6X,3I6,4(1PE18.10)))')
     *
     *      (((ICHARG,IREVER,I,SPXALI(I+IREVER*NUMBSP(0,ICHARG),ICHARG),
     *                         SPXSPI(I+IREVER*NUMBSP(0,ICHARG),ICHARG),
     *                         SPZALI(I+IREVER*NUMBSP(0,ICHARG),ICHARG),
     *                         SPZSPI(I+IREVER*NUMBSP(0,ICHARG),ICHARG),
     *                       I=1,NUMBSP(IREVER,ICHARG)),
     *                IREVER=0,MREVER),
     *         ICHARG=0,NDISOS)
C
C=======================================================================
C
      IF (IREVIE.LT.4) RETURN
C
C=======================================================================
C
      WRITE(NFIREV,'(''HRPNTX'')')
      WRITE(NFIREV,'((6X,10(1PE18.10)))')
     *     (FOURPT(IGAUSS,1),IGAUSS=1,NXHERM)
C
      WRITE(NFIREV,'(''HRPNTY'')')
      WRITE(NFIREV,'((6X,10(1PE18.10)))')
     *     (FOURPT(IGAUSS,2),IGAUSS=1,NYHERM)
C
      WRITE(NFIREV,'(''HRPNTZ'')')
      WRITE(NFIREV,'((6X,10(1PE18.10)))')
     *     (FOURPT(IGAUSS,3),IGAUSS=1,NZHERM)
C
C=======================================================================
C
      WRITE(NFIREV,'(''DN_RHO'')')
      WRITE(NFIREV,'((6X,10(1PE18.10)))')
     *
     *     (((REAL(DE_RHO(IX,IY,IZ,0)*EXPAUX(IX,IY,IZ)),
     *                     IX=1,NXHERM),IY=1,NYHERM),IZ=1,NZHERM)
C
      WRITE(NFIREV,'(''DP_RHO'')')
      WRITE(NFIREV,'((6X,10(1PE18.10)))')
     *
     *     (((REAL(DE_RHO(IX,IY,IZ,1)*EXPAUX(IX,IY,IZ)),
     *                     IX=1,NXHERM),IY=1,NYHERM),IZ=1,NZHERM)
C
      WRITE(NFIREV,'(''DNSPIX'')')
      WRITE(NFIREV,'((6X,10(1PE18.10)))')
     *
     *     (((REAL(DE_SPI(IX,IY,IZ,1,0)*EXPAUX(IX,IY,IZ)),
     *                     IX=1,NXHERM),IY=1,NYHERM),IZ=1,NZHERM)
C
      WRITE(NFIREV,'(''DPSPIX'')')
      WRITE(NFIREV,'((6X,10(1PE18.10)))')
     *
     *     (((REAL(DE_SPI(IX,IY,IZ,1,1)*EXPAUX(IX,IY,IZ)),
     *                     IX=1,NXHERM),IY=1,NYHERM),IZ=1,NZHERM)
C
      WRITE(NFIREV,'(''DNSPIY'')')
      WRITE(NFIREV,'((6X,10(1PE18.10)))')
     *
     *     (((REAL(DE_SPI(IX,IY,IZ,2,0)*EXPAUX(IX,IY,IZ)),
     *                     IX=1,NXHERM),IY=1,NYHERM),IZ=1,NZHERM)
C
      WRITE(NFIREV,'(''DPSPIY'')')
      WRITE(NFIREV,'((6X,10(1PE18.10)))')
     *
     *     (((REAL(DE_SPI(IX,IY,IZ,2,1)*EXPAUX(IX,IY,IZ)),
     *                     IX=1,NXHERM),IY=1,NYHERM),IZ=1,NZHERM)
C
      WRITE(NFIREV,'(''DNSPIZ'')')
      WRITE(NFIREV,'((6X,10(1PE18.10)))')
     *
     *     (((REAL(DE_SPI(IX,IY,IZ,3,0)*EXPAUX(IX,IY,IZ)),
     *                     IX=1,NXHERM),IY=1,NYHERM),IZ=1,NZHERM)
C
      WRITE(NFIREV,'(''DPSPIZ'')')
      WRITE(NFIREV,'((6X,10(1PE18.10)))')
     *
     *     (((REAL(DE_SPI(IX,IY,IZ,3,1)*EXPAUX(IX,IY,IZ)),
     *                     IX=1,NXHERM),IY=1,NYHERM),IZ=1,NZHERM)
C
C=======================================================================
C
      IF (IREVIE.LT.5) RETURN
C
      WRITE(NFIREV,'(''HRWETX'')')
      WRITE(NFIREV,'((6X,10(1PE18.10)))')
     *     (FOURWG(IGAUSS,1),IGAUSS=1,NXHERM)
C
      WRITE(NFIREV,'(''HRWETY'')')
      WRITE(NFIREV,'((6X,10(1PE18.10)))')
     *     (FOURWG(IGAUSS,2),IGAUSS=1,NYHERM)
C
      WRITE(NFIREV,'(''HRWETZ'')')
      WRITE(NFIREV,'((6X,10(1PE18.10)))')
     *     (FOURWG(IGAUSS,3),IGAUSS=1,NZHERM)
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE IOCLOS(NFIWOO,NFIREP,NFIREV,NFIREC,NFICOU,NFIWAV,
     *                  NFIKER,NFIYUP,NFIYUC,NFIGOC,NFIGOP,NFIGPC,
     *                  NFIGPP,NFILIP,NFILIC,NFIFIP,NFIFIC,NFIISO)
C
      LOGICAL
     *          INCWOO,INCREP,INCREV,INCREC,INCCOU,INCWAV,INCKER,
     *          INCYUP,INCYUC,INCGOP,INCGOC,INCGPC,INCGPP,INCLIP,
     *          INCLIC,INCFIP,INCFIC,INCISO
C
C=======================================================================
C      CHECK IF FILES ARE ALREADY OPENED. IF YES, CLOSE THEM FIRST
C      TO AVOID POSSIBLE CONFLICTS OF UNIT/FILENAME ALLOCATIONS.
C=======================================================================
C
      INCWOO=.FALSE.
      INCREP=.FALSE.
      INCREV=.FALSE.
      INCREC=.FALSE.
      INCCOU=.FALSE.
      INCWAV=.FALSE.
      INCKER=.FALSE.
      INCYUP=.FALSE.
      INCYUC=.FALSE.
      INCGOP=.FALSE.
      INCGOC=.FALSE.
      INCGPC=.FALSE.
      INCGPP=.FALSE.
      INCLIP=.FALSE.
      INCLIC=.FALSE.
      INCFIP=.FALSE.
      INCFIC=.FALSE.
      INCISO=.FALSE.
C
      inquire(unit=NFIWOO,opened=INCWOO)
                             IF (INCWOO) CLOSE(NFIWOO)
      inquire(unit=NFIREP,opened=INCREP)
                             IF (INCREP) CLOSE(NFIREP)
      inquire(unit=NFIREV,opened=INCREV)
                             IF (INCREV) CLOSE(NFIREV)
      inquire(unit=NFIREC,opened=INCREC)
                             IF (INCREC) CLOSE(NFIREC)
      inquire(unit=NFICOU,opened=INCCOU)
                             IF (INCCOU) CLOSE(NFICOU)
      inquire(unit=NFIWAV,opened=INCWAV)
                             IF (INCWAV) CLOSE(NFIWAV)
      inquire(unit=NFIKER,opened=INCKER)
                             IF (INCKER) CLOSE(NFIKER)
      inquire(unit=NFIYUP,opened=INCYUP)
                             IF (INCYUP) CLOSE(NFIYUP)
      inquire(unit=NFIYUC,opened=INCYUC)
                             IF (INCYUC) CLOSE(NFIYUC)
      inquire(unit=NFIGOP,opened=INCGOP)
                             IF (INCGOP) CLOSE(NFIGOP)
      inquire(unit=NFIGOC,opened=INCGOC)
                             IF (INCGOC) CLOSE(NFIGOC)
      inquire(unit=NFIGPP,opened=INCGPP)
                             IF (INCGPP) CLOSE(NFIGPP)
      inquire(unit=NFIGPC,opened=INCGPC)
                             IF (INCGPC) CLOSE(NFIGPC)
      inquire(unit=NFILIP,opened=INCLIP)
                             IF (INCLIP) CLOSE(NFILIP)
      inquire(unit=NFILIC,opened=INCLIC)
                             IF (INCLIC) CLOSE(NFILIC)
      inquire(unit=NFIFIP,opened=INCFIP)
                             IF (INCFIP) CLOSE(NFIFIP)
      inquire(unit=NFIFIC,opened=INCFIC)
                             IF (INCFIC) CLOSE(NFIFIC)
      inquire(unit=NFIISO,opened=INCISO)
                             IF (INCISO) CLOSE(NFIISO)
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE IOFILE(IREAWS,ICONTI,IFCONT,IYCONT,ILCONT,IGCONT,
     *                  IGPCON,IWRIRE,IWRILI,IWRIYU,IWRIGO,IWRIFI,
     *                  IWRISO,
     *
     *                  LIPKIN,LIPKIP,I_YUKA,I_GOGA,IGOGPA,INDFIL,
     *                  INDJOB,IREVIE,IF_THO,
     *
     *                  NFIWOO,NFIREP,NFIREC,NFIREV,NFICOU,NFIWAV,
     *                  NFIKER,NFIYUP,NFIYUC,NFIGOP,NFIGOC,NFIGPC,
     *                  NFIGPP,NFILIP,NFILIC,NFIFIP,NFIFIC,NFIISO,
     *
     *                  FILWOO,FILREP,FILREC,FILREV,FILCOU,FILWAV,
     *                  FILKER,FILYUP,FILYUC,FILGOP,FILGOC,FILGPC,
     *                  FILGPP,FILLIP,FILLIC,FILFIP,FILFIC,FILISO)
      CHARACTER
     *          FILREP*68,FILREC*68,FILWOO*68,FILREV*68,FILCOU*68,
     *          FILISO*68,FILWAV*68,FILKER*68,FILYUP*68,FILYUC*68,
     *          FILGOP*68,FILGOC*68,FILGPC*68,FILGPP*68,FILLIP*68,
     *          FILLIC*68,FILFIP*68,FILFIC*68
      COMMON
     *      /CFIPRI/ NFIPRI
C
C=======================================================================
C         OPENING FILES
C=======================================================================
C
      NFIWOO=10
      NFIREP=11
      NFIREV=12
      NFIISO=13
C
      NFIREC=91
C
      NFICOU=22
      NFIWAV=23
      NFIKER=24
      NFIYUP=25
      NFIYUC=26
      NFILIP=27
      NFILIC=28
      NFIFIP=29
      NFIGPC=310
      NFIGPP=320
      NFIFIC=30
      NFIGOP=31
      NFIGOC=32
C
C=======================================================================
C      CHECK IF FILES ARE ALREADY OPENED. IF YES, CLOSE THEM FIRST
C      TO AVOID POSSIBLE CONFLICTS OF UNIT/FILENAME ALLOCATIONS.
C=======================================================================
C
      CALL IOCLOS(NFIWOO,NFIREP,NFIREV,NFIREC,NFICOU,NFIWAV,
     *            NFIKER,NFIYUP,NFIYUC,NFIGOC,NFIGOP,NFIGPC,
     *            NFIGPP,NFILIP,NFILIC,NFIFIP,NFIFIC,NFIISO)
C
C=======================================================================
C      In case of parallel MPI environment, overwriting all filenames
C      to avoid all processes trying to access the same files
C      N.B. THIS SHOULD BE MODIFIED IN THE FUTURE WHEN SEVERAL
C           PROCESSORS RUN THE SAME HFB CALCULATIONS: ONLY THE
C           MASTER SHOULD OPEN/READ/WRITE/CLOSE THE FILES
C=======================================================================
C
#if(USE_MPI==1)
C
      WRITE(FILREV,'(''HFODD_'',i8.8,''.REV'')') INDJOB
      WRITE(FILREC,'(''HFODD_'',i8.8,''.REC'')') INDJOB
      WRITE(FILREP,'(''HFODD_'',i8.8,''.REC'')') INDJOB
      WRITE(FILWOO,'(''WOODS_'',i8.8,''.WFN'')') INDJOB
      WRITE(FILCOU,'(''HFODD_'',i8.8,''.COU'')') INDJOB
      WRITE(FILWAV,'(''HFODD_'',i8.8,''.WFN'')') INDJOB
      WRITE(FILKER,'(''HFODD_'',i8.8,''.KER'')') INDJOB
      WRITE(FILYUC,'(''HFODD_'',i8.8,''.YUC'')') INDJOB
      WRITE(FILYUP,'(''HFODD_'',i8.8,''.YUP'')') INDJOB
      WRITE(FILGOC,'(''HFODD_'',i8.8,''.GOC'')') INDJOB
      WRITE(FILGOP,'(''HFODD_'',i8.8,''.GOP'')') INDJOB
      WRITE(FILGPC,'(''HFODD_'',i8.8,''.GPC'')') INDJOB
      WRITE(FILGPP,'(''HFODD_'',i8.8,''.GPP'')') INDJOB
      WRITE(FILLIC,'(''HFODD_'',i8.8,''.LIC'')') INDJOB
      WRITE(FILLIP,'(''HFODD_'',i8.8,''.LIP'')') INDJOB
      WRITE(FILFIC,'(''HFODD_'',i8.8,''.FIC'')') INDJOB
      WRITE(FILFIP,'(''HFODD_'',i8.8,''.FIP'')') INDJOB
C
      IF (ICONTI.EQ.1) THEN
C
          WRITE(FILREC,'(''./rec/HFODD_'',i8.8,''.REC'')') INDJOB
          WRITE(FILREP,'(''./restart/HFODD_'',i8.8,''.REC'')') INDFIL
C
      END IF
C
      IF (ILCONT.EQ.1.AND.(LIPKIN.EQ.1.OR.LIPKIP.EQ.1)) THEN
C
          WRITE(FILLIP,'(''./lic/HFODD_'',i8.8,''.LIC'')') INDFIL
C
      END IF
C
      IF (IF_THO.EQ.2) THEN
C
          WRITE(FILREC,'(''./rec/HFODD_'',i8.8,''.REC'')') INDJOB
          WRITE(FILREP,'(''./restart/HFODD_'',i8.8,''.REC'')') INDFIL
          WRITE(FILFIP,'(''./fip/HFODD_'',i8.8,''.FIC'')') INDFIL
C
      END IF
C
#endif
C
C=======================================================================
C
      IERROR=0
C
C=======================================================================
C         OPENING THE COMMON FILREP AND FILREC FILE
C=======================================================================
C
      IF (FILREP.EQ.FILREC) THEN
C
          NFIREP=NFIREC
C
          IF (ICONTI.EQ.1.OR.IF_THO.EQ.2) THEN
C
              IERROR=0
              OPEN(NFIREP,FILE=FILREP,STATUS='OLD',IOSTAT=IERROR,
     *                    FORM='UNFORMATTED')
C
              IF (IERROR.NE.0) THEN
C
                  WRITE(NFIPRI,'(/,1X,26(1H/),2X,
     *                         ''FILE NOT FOUND ON DISC'',
     *                                                     2X,26(1H/),/,
     *                         1X, 3(1H/),2X,68X,          2X, 3(1H/),/,
     *                         1X, 3(1H/),2X,A68,          2X, 3(1H/),/,
     *                         1X, 3(1H/),2X,68X,          2X, 3(1H/),/,
     *                         1X,26(1H/),2X,''FILE NOT FOUND ON DISC'',
     *                                                     2X,26(1H/))')
     *                 FILREP
C
                   STOP ' FILE FILREP NOT FOUND ON DISC'
C
              END IF
C
          ELSE
C
              IF (IWRIRE.NE.-1) THEN
                 OPEN (NFIREC,FILE=FILREC,STATUS='UNKNOWN',
     *                         FORM='UNFORMATTED')
              END IF
C
          END IF
C
      ELSE
C
C=======================================================================
C         OPENING THE FILREP FILE
C=======================================================================
C
          IF (ICONTI.EQ.1.OR.IF_THO.EQ.2) THEN
C
              IERROR=0
              OPEN(NFIREP,FILE=FILREP,STATUS='OLD',IOSTAT=IERROR,
     *                    FORM='UNFORMATTED')
C
              IF (IERROR.NE.0) THEN
C
                  WRITE(NFIPRI,'(/,1X,26(1H/),2X,
     *                         ''FILE NOT FOUND ON DISC'',
     *                                                     2X,26(1H/),/,
     *                         1X, 3(1H/),2X,68X,          2X, 3(1H/),/,
     *                         1X, 3(1H/),2X,A68,          2X, 3(1H/),/,
     *                         1X, 3(1H/),2X,68X,          2X, 3(1H/),/,
     *                         1X,26(1H/),2X,''FILE NOT FOUND ON DISC'',
     *                                                     2X,26(1H/))')
     *                 FILREP
C
                  STOP ' FILE FILREP NOT FOUND ON DISC'
C
              END IF
C
          END IF
C
C=======================================================================
C         OPENING THE FILREC FILE
C=======================================================================
C
          IF (IWRIRE.NE.-1) THEN
            OPEN (NFIREC,FILE=FILREC,STATUS='UNKNOWN',
     *            FORM='UNFORMATTED')
           END IF
C
      END IF
C
C=======================================================================
C         OPENING THE COMMON FILYUP AND FILYUC FILE
C=======================================================================
C
      IF (FILYUP.EQ.FILYUC) THEN
C
          NFIYUP=NFIYUC
C
          IF (IYCONT.EQ.1.AND.I_YUKA.GE.2) THEN
C
              IERROR=0
              OPEN(NFIYUP,FILE=FILYUP,STATUS='OLD',IOSTAT=IERROR,
     *                    FORM='UNFORMATTED')
C
              IF (IERROR.NE.0) THEN
C
                  WRITE(NFIPRI,'(/,1X,26(1H/),2X,
     *                         ''FILE NOT FOUND ON DISC'',
     *                                                     2X,26(1H/),/,
     *                         1X, 3(1H/),2X,68X,          2X, 3(1H/),/,
     *                         1X, 3(1H/),2X,A68,          2X, 3(1H/),/,
     *                         1X, 3(1H/),2X,68X,          2X, 3(1H/),/,
     *                         1X,26(1H/),2X,''FILE NOT FOUND ON DISC'',
     *                                                     2X,26(1H/))')
     *                 FILYUP
C
                  STOP ' FILE FILYUP NOT FOUND ON DISC'
C
              END IF
C
          ELSE
C
              IF (IWRIYU.NE.-1.AND.I_YUKA.GE.2)
     *
     *            OPEN (NFIYUC,FILE=FILYUC,STATUS='UNKNOWN',
     *                         FORM='UNFORMATTED')
C
          END IF
C
      ELSE
C
C=======================================================================
C         OPENING THE FILYUP FILE
C=======================================================================
C
          IF (IYCONT.EQ.1.AND.I_YUKA.GE.2) THEN
C
              IERROR=0
              OPEN(NFIYUP,FILE=FILYUP,STATUS='OLD',IOSTAT=IERROR,
     *                    FORM='UNFORMATTED')
C
              IF (IERROR.NE.0) THEN
C
                  WRITE(NFIPRI,'(/,1X,26(1H/),2X,
     *                         ''FILE NOT FOUND ON DISC'',
     *                                                     2X,26(1H/),/,
     *                         1X, 3(1H/),2X,68X,          2X, 3(1H/),/,
     *                         1X, 3(1H/),2X,A68,          2X, 3(1H/),/,
     *                         1X, 3(1H/),2X,68X,          2X, 3(1H/),/,
     *                         1X,26(1H/),2X,''FILE NOT FOUND ON DISC'',
     *                                                     2X,26(1H/))')
     *                 FILYUP
C
                  STOP ' FILE FILYUP NOT FOUND ON DISC'
C
              END IF
C
          END IF
C
C=======================================================================
C         OPENING THE FILYUC FILE
C=======================================================================
C
          IF (IWRIYU.NE.-1.AND.I_YUKA.GE.2)
     *
     *    OPEN (NFIYUC,FILE=FILYUC,STATUS='UNKNOWN',FORM='UNFORMATTED')
C
      END IF
C
C=======================================================================
C         OPENING THE COMMON FILGOP AND FILGOC FILE
C=======================================================================
C
      IF (FILGOP.EQ.FILGOC) THEN
C
          NFIGOP=NFIGOC
C
          IF (IGCONT.EQ.1.AND.I_GOGA.GE.2) THEN
C
              IERROR=0
              OPEN(NFIGOP,FILE=FILGOP,STATUS='OLD',IOSTAT=IERROR,
     *                    FORM='UNFORMATTED')
C
              IF (IERROR.NE.0) THEN
C
                 WRITE(NFIPRI,'(/,1X,26(1H/),2X,
     *                        ''FILE NOT FOUND ON DISC'',
     *                                                    2X,26(1H/),/,
     *                        1X, 3(1H/),2X,68X,          2X, 3(1H/),/,
     *                        1X, 3(1H/),2X,A68,          2X, 3(1H/),/,
     *                        1X, 3(1H/),2X,68X,          2X, 3(1H/),/,
     *                        1X,26(1H/),2X,''FILE NOT FOUND ON DISC'',
     *                                                    2X,26(1H/))')
     *                 FILGOP
C
                 STOP ' FILE FILGOP NOT FOUND ON DISC'
C
              END IF
C
          ELSE
C
              IF (IWRIGO.NE.-1.AND.I_GOGA.GE.2)
     *
     *            OPEN (NFIGOC,FILE=FILGOC,STATUS='UNKNOWN',
     *                         FORM='UNFORMATTED')
C
          END IF
C
      ELSE
C
C=======================================================================
C         OPENING THE FILGOP FILE
C=======================================================================
C
          IF (IGCONT.EQ.1.AND.I_GOGA.GE.2) THEN
C
              IERROR=0
              OPEN(NFIGOP,FILE=FILGOP,STATUS='OLD',IOSTAT=IERROR,
     *                    FORM='UNFORMATTED')
C
              IF (IERROR.NE.0) THEN
C
                  WRITE(NFIPRI,'(/,1X,26(1H/),2X,
     *                         ''FILE NOT FOUND ON DISC'',
     *                                                     2X,26(1H/),/,
     *                         1X, 3(1H/),2X,68X,          2X, 3(1H/),/,
     *                         1X, 3(1H/),2X,A68,          2X, 3(1H/),/,
     *                         1X, 3(1H/),2X,68X,          2X, 3(1H/),/,
     *                         1X,26(1H/),2X,''FILE NOT FOUND ON DISC'',
     *                                                     2X,26(1H/))')
     *                 FILGOP
C
              STOP ' FILE FILGOP NOT FOUND ON DISC'
C
              END IF
C
          END IF
C
C=======================================================================
C         OPENING THE FILGOC FILE
C=======================================================================
C
              IF (IWRIGO.NE.-1.AND.I_GOGA.GE.2)
     *
     *    OPEN (NFIGOC,FILE=FILGOC,STATUS='UNKNOWN',FORM='UNFORMATTED')
C
      END IF
C
C=======================================================================
C         OPENING THE COMMON FILGPP AND FILGPC FILE
C=======================================================================
C
      IF (FILGPP.EQ.FILGPC) THEN
C
          NFIGPP=NFIGPC
C
          IF (IGPCON.EQ.1.AND.IGOGPA.GE.2) THEN
C
              IERROR=0
              OPEN(NFIGPP,FILE=FILGPP,STATUS='OLD',IOSTAT=IERROR,
     *                    FORM='UNFORMATTED')
C
              IF (IERROR.NE.0) THEN
C
                  WRITE(NFIPRI,'(/,1X,26(1H/),2X,
     *                         ''FILE NOT FOUND ON DISC'',
     *                                                     2X,26(1H/),/,
     *                         1X, 3(1H/),2X,68X,          2X, 3(1H/),/,
     *                         1X, 3(1H/),2X,A68,          2X, 3(1H/),/,
     *                         1X, 3(1H/),2X,68X,          2X, 3(1H/),/,
     *                         1X,26(1H/),2X,''FILE NOT FOUND ON DISC'',
     *                                                     2X,26(1H/))')
     *                 FILGPP
C
                  STOP ' FILE FILGPP NOT FOUND ON DISC'
C
          END IF
C
      ELSE
C
              IF (IWRIGO.NE.-1.AND.IGOGPA.GE.2)
     *
     *            OPEN (NFIGPC,FILE=FILGPC,STATUS='UNKNOWN',
     *                         FORM='UNFORMATTED')
C
          END IF
C
      ELSE
C
C=======================================================================
C         OPENING THE FILGPP FILE
C=======================================================================
C
          IF (IGPCON.EQ.1.AND.IGOGPA.GE.2) THEN
C
              IERROR=0
              OPEN(NFIGPP,FILE=FILGPP,STATUS='OLD',IOSTAT=IERROR,
     *                    FORM='UNFORMATTED')
C
              IF (IERROR.NE.0) THEN
C
                  WRITE(NFIPRI,'(/,1X,26(1H/),2X,
     *                         ''FILE NOT FOUND ON DISC'',
     *                                                     2X,26(1H/),/,
     *                         1X, 3(1H/),2X,68X,          2X, 3(1H/),/,
     *                         1X, 3(1H/),2X,A68,          2X, 3(1H/),/,
     *                         1X, 3(1H/),2X,68X,          2X, 3(1H/),/,
     *                         1X,26(1H/),2X,''FILE NOT FOUND ON DISC'',
     *                                                     2X,26(1H/))')
     *                 FILGPP
C
                  STOP ' FILE FILGPP NOT FOUND ON DISC'
C
              END IF
C
          END IF
C
C=======================================================================
C         OPENING THE FILGPC FILE
C=======================================================================
C
          IF (IWRIGO.NE.-1.AND.IGOGPA.GE.2)
     *
     *    OPEN (NFIGPC,FILE=FILGPC,STATUS='UNKNOWN',FORM='UNFORMATTED')
C
      END IF
C
C=======================================================================
C         OPENING THE COMMON FILLIP AND FILLIC FILE
C=======================================================================
C
      IF (FILLIP.EQ.FILLIC) THEN
C
          NFILIP=NFILIC
C
          IF ((ILCONT.EQ.1.OR.IF_THO.EQ.2).AND.
     *        (LIPKIN.EQ.1.OR.LIPKIP.EQ.1)) THEN
C
              IERROR=0
              OPEN(NFILIP,FILE=FILLIP,STATUS='OLD',IOSTAT=IERROR,
     *                    FORM='UNFORMATTED')
C
              IF (IERROR.NE.0) THEN
C
                  WRITE(NFIPRI,'(/,1X,26(1H/),2X,
     *                         ''FILE NOT FOUND ON DISC'',
     *                                                     2X,26(1H/),/,
     *                         1X, 3(1H/),2X,68X,          2X, 3(1H/),/,
     *                         1X, 3(1H/),2X,A68,          2X, 3(1H/),/,
     *                         1X, 3(1H/),2X,68X,          2X, 3(1H/),/,
     *                         1X,26(1H/),2X,''FILE NOT FOUND ON DISC'',
     *                                                     2X,26(1H/))')
     *                 FILLIP
C
                  STOP ' FILE FILLIP NOT FOUND ON DISC'
C
              END IF
C
          ELSE
C
              IF (IWRILI.NE.-1.AND.(LIPKIN.EQ.1.OR.LIPKIP.EQ.1))
     *
     *            OPEN (NFILIC,FILE=FILLIC,STATUS='UNKNOWN',
     *                         FORM='UNFORMATTED')
C
          END IF
C
      ELSE
C
C=======================================================================
C         OPENING THE FILLIP FILE
C=======================================================================
C
          IF ((ILCONT.EQ.1.OR.IF_THO.EQ.2).AND.
     *        (LIPKIN.EQ.1.OR.LIPKIP.EQ.1)) THEN
C
              IERROR=0
              OPEN(NFILIP,FILE=FILLIP,STATUS='OLD',IOSTAT=IERROR,
     *                    FORM='UNFORMATTED')
C
              IF (IERROR.NE.0) THEN
C
                  WRITE(NFIPRI,'(/,1X,26(1H/),2X,
     *                         ''FILE NOT FOUND ON DISC'',
     *                                                     2X,26(1H/),/,
     *                         1X, 3(1H/),2X,68X,          2X, 3(1H/),/,
     *                         1X, 3(1H/),2X,A68,          2X, 3(1H/),/,
     *                         1X, 3(1H/),2X,68X,          2X, 3(1H/),/,
     *                         1X,26(1H/),2X,''FILE NOT FOUND ON DISC'',
     *                                                     2X,26(1H/))')
     *                 FILLIP
C
                  STOP ' FILE FILLIP NOT FOUND ON DISC'
C
              END IF
C
          END IF
C
C=======================================================================
C         OPENING THE FILLIC FILE
C=======================================================================
C
          IF (IWRILI.NE.-1.AND.(LIPKIN.EQ.1.OR.LIPKIP.EQ.1))
     *
     *    OPEN (NFILIC,FILE=FILLIC,STATUS='UNKNOWN',FORM='UNFORMATTED')
C
      END IF
C
C=======================================================================
C         OPENING THE COMMON FILFIP AND FILFIC FILE
C=======================================================================
C
      IF (FILFIP.EQ.FILFIC) THEN
C
          NFIFIP=NFIFIC
C
          IF (IFCONT.EQ.1.OR.IF_THO.EQ.2) THEN
C
              IERROR=0
              OPEN(NFIFIP,FILE=FILFIP,STATUS='OLD',IOSTAT=IERROR,
     *                    FORM='UNFORMATTED')
C
              IF (IERROR.NE.0) THEN
C
                  WRITE(NFIPRI,'(/,1X,26(1H/),2X,
     *                         ''FILE NOT FOUND ON DISC'',
     *                                                     2X,26(1H/),/,
     *                         1X, 3(1H/),2X,68X,          2X, 3(1H/),/,
     *                         1X, 3(1H/),2X,A68,          2X, 3(1H/),/,
     *                         1X, 3(1H/),2X,68X,          2X, 3(1H/),/,
     *                         1X,26(1H/),2X,''FILE NOT FOUND ON DISC'',
     *                                                     2X,26(1H/))')
     *                 FILFIP
C
                  STOP ' FILE FILFIP NOT FOUND ON DISC'
C
              END IF
C
          ELSE
C
              IF (IWRIFI.NE.-1)
     *
     *            OPEN (NFIFIC,FILE=FILFIC,STATUS='UNKNOWN',
     *                         FORM='UNFORMATTED')
C
          END IF
C
      ELSE
C
C=======================================================================
C         OPENING THE FILFIP FILE
C=======================================================================
C
          IF (IFCONT.EQ.1.OR.IF_THO.EQ.2) THEN
C
              IERROR=0
              OPEN(NFIFIP,FILE=FILFIP,STATUS='OLD',IOSTAT=IERROR,
     *                    FORM='UNFORMATTED')
C
              IF (IERROR.NE.0) THEN
C
                  WRITE(NFIPRI,'(/,1X,26(1H/),2X,
     *                         ''FILE NOT FOUND ON DISC'',
     *                                                     2X,26(1H/),/,
     *                         1X, 3(1H/),2X,68X,          2X, 3(1H/),/,
     *                         1X, 3(1H/),2X,A68,          2X, 3(1H/),/,
     *                         1X, 3(1H/),2X,68X,          2X, 3(1H/),/,
     *                         1X,26(1H/),2X,''FILE NOT FOUND ON DISC'',
     *                                                     2X,26(1H/))')
     *                 FILFIP
C
                  STOP ' FILE FILFIP NOT FOUND ON DISC'
C
              END IF
C
          END IF
C
C=======================================================================
C         OPENING THE FILFIC FILE
C=======================================================================
C
          IF (IWRIFI.NE.-1)
     *
     *    OPEN (NFIFIC,FILE=FILFIC,STATUS='UNKNOWN',FORM='UNFORMATTED')
C
      END IF
C
C=======================================================================
C         OPENING THE FILISO FILE
C=======================================================================
C
      IF (IWRISO.EQ.1) THEN
C
          OPEN (NFIISO,FILE=FILISO,STATUS='UNKNOWN',FORM='FORMATTED')
C
          WRITE(NFIISO,'(132(1H*),/,
     *                  1H*,/,
     *                  1H*,1X,''ITER'',3X,''EULER ANGLES'',6X,
     *                         ''Q1-1'',5X,''Q10'',5X,''Q11'',5X,
     *                         ''Q2-2'',4X,''Q2-1'',5X,''Q20'',5X,
     *                                      ''Q21'',5X,''Q22'',4X,
     *                         ''J_X'',3X,''J_Y'',3X,''J_Z'',4X,
     *                         ''S_X'',3X,''S_Y'',3X,''S_Z'',3X,
     *                         ''<WJ'',2X,''<ZJ'',2X,''<NP'',/,1H*)')
C
      END IF
C
C=======================================================================
C         OPENING THE FILREV FILE
C=======================================================================
C
      IF (IREVIE.GT.0) THEN
C
          OPEN (NFIREV,FILE=FILREV,STATUS='UNKNOWN',FORM='FORMATTED')
C
      END IF
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE NAMELI(IN_FIX,IZ_FIX,SKYRME,GOGNAM,ISTAND,
     *                  KETA_J,KETA_W,KETACM,KETA_M,
     *                                       KETA_R,
     *           LANODD,LANSCA,HBMSAT,RHOSAT,EFFSAT,
     *                  INNUMB,IZNUMB,FCHOM0,R0PARM,
     *                  IOPTGS,NXHERM,NYHERM,NZHERM,
     *           IPAIRI,IPAHFB,ITWOBA,IPABCS,IMFHFB,
     *                                LIPKIN,LIPKIP,
     *                                IROTAT,IREVIE,
     *                  DELFIN,DELFIP,IDEFIN,IDEFIP,
     *                  FERFIN,FERFIP,IFEFIN,IFEFIP,
     *                  FE2FIN,FE2FIP,IF2FIN,IF2FIP,
     *                  INSIGN,IPSIGN,ISSIGN,IDSIGN,
     *                  INSIGP,IPSIGP,ISSIGP,IDSIGP,
     *                         INSIMN,IRSIMN,IDSIMN,
     *                         INSIMP,IRSIMP,IDSIMP,
     *                         INSIQN,IPSIQN,IDSIQN,
     *                         INSIQP,IPSIQP,IDSIQP,
     *                                INSIZN,IDSIZN,
     *                                INSIZP,IDSIZP,
     *                                IFIBLN,INIBLN,
     *                                IFIBLP,INIBLP,
     *                                       IREAWS,
     *                         ICONTI,IPCONT,IOCONT,
     *                  IACONT,IYCONT,IGCONT,IGPCON,
     *                  ILCONT,IFCONT,IMCONT,IRCONT,
     *                  NUCHAO,NUPING,EPSPNG,EPSITE,
     *                  ISPHER,ISIMPY,ISIGNY,IPARTY,
     *                         ISIMTX,ISIMTY,ISIMTZ,
     *                  IMOVAX,ITILAX,ITISAX,NO_ORB,
     *                                NOITER,NULAST,
     *                  ISYMDE,INIROT,INIINV,INIKAR,
     *                         IRENMA,IRENIN,IDOGOA,
     *                         IFRWAV,ITOWAV,IWRWAV,
     *                                ISAKER,ICHKER,
     *                         IPRGCM,IPROMI,IPROMA,
     *                         NUAKNO,NUBKNO,KPROJE,
     *                                       NBTKNO,
     *                         ISOSAD,EPSISO,ICSKIP,
     *                                       IFERME,
     *                         IPAKER,IPAALL,KFIKER,
     *                  NUASTA,NUASTO,NUGSTA,NUGSTO,
     *                  NUBSTA,NUBSTO,NUTSTA,NUTSTO,
     *                         ICUTOV,CUTOVE,CUTOVF,
     *                                ISLPRI,ISUPRI,
     *                         IENPRI,ISRPRI,IMIPRI,
     *                                IKEPRI,IRMPRI,
     *                         QMUCUT,QMACUT,QSICUT,
     *                         NOSCIL,NLIMIT,ENECUT,
     *                         NUMCOU,NUMETA,FURMAX,
     *                  ICOTYP,ICOUDI,ICOUEX,E_EFFE,
     *                  PIMASS,PNMASS,IYUTYP,I_YUKA,
     *                  YUKAGT,YUKAG0,YUKAG1,YUKAG2,
     *                                I_GOGA,IGOGPA,
     *                  I1LINE,IPRSTA,IPRMID,IPRSTO,
     *                  IDESTA,IDEMID,IDESTO,IDEDIS,
     *                                INTRIP,IVIPRI,
     *                         IPRI_N,IPRI_P,IPRI_T,
     *                         NMUCON,NMUCOU,NMUPRI,
     *                         ISCHIF,NSICON,NSIPRI,
     *                                NMACON,NMAPRI,
     *                         NMURED,NMARED,NSIRED,
     *                         NEXBET,IPRIBE,IPRIBL,
     *                         IWRIOL,IWRISO,IWRIRE,
     *                                IWRIYU,IWRIGO,
     *                                IWRILI,IWRIFI,
     *                         FILISO,FILREP,FILREC,
     *                         FILWOO,FILREV,FILCOU,
     *                                FILWAV,FILKER,
     *                                FILYUP,FILYUC,
     *                                FILGOP,FILGOC,
     *                                FILGPP,FILGPC,
     *                                FILLIP,FILLIC,
     *                                FILFIP,FILFIC,
     *                         ICHFLI,IPAFLI,IREFLI,
     *                         ISPFLI,ISHFLI,IFLIPI,
     *                  SLOWEV,SLOWOD,SLOWPA,SLOWLI,
     *                                ICOULI,ICOULO,
     *                                FACTGN,FACTGP,
     *                                EMINAL,EMAXAL,
     *                         EMAXQU,ECUTOF,LIMQUA,
     *                                       NILXYZ,
     *                                       IAVRGG,
     *                                       IPOTHO,
     *                                       EPSHER,
     *                  IFSHEL,IF_RPA,IF_THO,CBETHO,
     *                                       IFRAGM,
     *           LAMPUS,MIUPUS,NUMPUS,QMOPUS,IFPUSH,
     *                                       NITPUS,
     *                         L_COLL,M_COLL,N_COLL,
     *           DELTAE,XLOCMX,V2_MIN,ITRMAX,NTHETA,
     *                  MIN_QP,IDEALL,IDELOC,IDECON)
C
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      CHARACTER
     *          FILREP*68,FILREC*68,FILWOO*68,
     *          FILREV*68,FILCOU*68,FILISO*68,FILWAV*68,FILKER*68,
     *          FILYUP*68,FILYUC*68,
     *          FILGOP*68,FILGOC*68,
     *          FILGPP*68,FILGPC*68,
     *          FILLIP*68,FILLIC*68,
     *          FILFIP*68,FILFIC*68
      CHARACTER
     *          KEYWOR*10,SKYRME*4,GOGNAM*4
      CHARACTER
     *          MYDATE*8,MYTIME*10,MYZONE*5
C
      DIMENSION
     *          MYVALU(8)
      DIMENSION
     *             STSALL(NDCOUP), SPMALL(NDCOUP)
      DIMENSION
     *             ATSALL(NDCOUP), APMALL(NDCOUP)
      EQUIVALENCE
     *            (STSALL,SRHO_T),(SPMALL,SRHO_P)
      EQUIVALENCE
     *            (ATSALL,ARHO_T),(APMALL,ARHO_P)
C
C=======================================================================
      integer, dimension(:), pointer :: LAMPUS, MIUPUS
      integer, dimension(:), pointer :: L_COLL, M_COLL

      double precision, dimension(:), pointer :: QMOPUS
C=======================================================================
C
      COMMON
     *       /FLOPAR/ XIZFIX,XINFIX
      COMMON
     *       /SIMKPH/ KPSIMP(NDPAHO,0:NDISOS),KPSIMM(NDPAHO,0:NDISOS),
     *                KHSIMP(NDPAHO,0:NDISOS),KHSIMM(NDPAHO,0:NDISOS)
      COMMON
     *       /SIGKPH/ KPPPSP(NDPAHO,0:NDISOS),KPPPSM(NDPAHO,0:NDISOS),
     *                KPPMSP(NDPAHO,0:NDISOS),KPPMSM(NDPAHO,0:NDISOS),
     *                KHPPSP(NDPAHO,0:NDISOS),KHPPSM(NDPAHO,0:NDISOS),
     *                KHPMSP(NDPAHO,0:NDISOS),KHPMSM(NDPAHO,0:NDISOS)
      COMMON
     *       /SIQKPH/ KPSIQP(NDPAHO,0:NDISOS),KPSIQM(NDPAHO,0:NDISOS),
     *                KHSIQP(NDPAHO,0:NDISOS),KHSIQM(NDPAHO,0:NDISOS)
      COMMON
     *       /SIZKPH/ KPNONE(NDPAHO,0:NDISOS),
     *                KHNONE(NDPAHO,0:NDISOS)
      COMMON
     *       /SIMKVA/ KVASIM(         0:NDSIMP,0:NDISOS)
      COMMON
     *       /SIGKVA/ KVASIG(0:NDPARI,0:NDSIGN,0:NDISOS)
      COMMON
     *       /SIQKVA/ KVASIQ(0:NDPARI,         0:NDISOS)
      COMMON
     *       /K_FLIG/ KPFLIG(0:NDPARI,0:NDSIGN,0:NDISOS),
     *                KHFLIG(0:NDPARI,0:NDSIGN,0:NDISOS),
     *                KOFLIG(0:NDPARI,0:NDSIGN,0:NDISOS)
      COMMON
     *       /K_FLIM/ KPFLIM(         0:NDSIMP,0:NDISOS),
     *                KHFLIM(         0:NDSIMP,0:NDISOS),
     *                KOFLIM(         0:NDSIMP,0:NDISOS)
      COMMON
     *       /K_FLIQ/ KPFLIQ(0:NDPARI,         0:NDISOS),
     *                KHFLIQ(0:NDPARI,         0:NDISOS),
     *                KOFLIQ(0:NDPARI,         0:NDISOS)
      COMMON
     *       /K_FLIZ/ KPFLIZ(                  0:NDISOS),
     *                KHFLIZ(                  0:NDISOS),
     *                KOFLIZ(                  0:NDISOS)
      COMMON
     *       /K_FILG/ KPFILG(0:NDPARI,0:NDSIGN,0:NDISOS),
     *                KHFILG(0:NDPARI,0:NDSIGN,0:NDISOS),
     *                KOFILG(0:NDPARI,0:NDSIGN,0:NDISOS)
      COMMON
     *       /K_FILZ/ KPFILZ(                  0:NDISOS),
     *                KHFILZ(                  0:NDISOS),
     *                KOFILZ(                  0:NDISOS)
      COMMON
     *       /VACCNF/ IVACUM
      COMMON
     *       /STSSKY/ SRHO_T,SRHO_S,SRHODT,SRHODS,
     *                SLPR_T,SLPR_S,
     *                STAU_T,STAU_S,
     *                SSCU_T,SSCU_S,
     *                SDIV_T,SDIV_S,
     *                SSPI_T,SSPI_S,SSPIDT,SSPIDS,
     *                SLPS_T,SLPS_S,
     *                SCUR_T,SCUR_S,
     *                SKIS_T,SKIS_S,
     *                SROT_T,SROT_S
      COMMON
     *       /SPMSKY/ SRHO_P,SRHO_M,SRHODP,SRHODM,
     *                SLPR_P,SLPR_M,
     *                STAU_P,STAU_M,
     *                SSCU_P,SSCU_M,
     *                SDIV_P,SDIV_M,
     *                SSPI_P,SSPI_M,SSPIDP,SSPIDM,
     *                SLPS_P,SLPS_M,
     *                SCUR_P,SCUR_M,
     *                SKIS_P,SKIS_M,
     *                SROT_P,SROT_M
      COMMON
     *       /ATSSKY/ ARHO_T,ARHO_S,ARHODT,ARHODS,
     *                ALPR_T,ALPR_S,
     *                ATAU_T,ATAU_S,
     *                ASCU_T,ASCU_S,
     *                ADIV_T,ADIV_S,
     *                ASPI_T,ASPI_S,ASPIDT,ASPIDS,
     *                ALPS_T,ALPS_S,
     *                ACUR_T,ACUR_S,
     *                AKIS_T,AKIS_S,
     *                AROT_T,AROT_S
      COMMON
     *       /APMSKY/ ARHO_P,ARHO_M,ARHODP,ARHODM,
     *                ALPR_P,ALPR_M,
     *                ATAU_P,ATAU_M,
     *                ASCU_P,ASCU_M,
     *                ADIV_P,ADIV_M,
     *                ASPI_P,ASPI_M,ASPIDP,ASPIDM,
     *                ALPS_P,ALPS_M,
     *                ACUR_P,ACUR_M,
     *                AKIS_P,AKIS_M,
     *                AROT_P,AROT_M
      COMMON
     *       /REALPH/ ALPHAR(0:NDLAMB,0:NDLAMB)
      COMMON
     *       /NILPAR/ CNILSN,DNILSN,CNILSP,DNILSP,
     *                HBANIX,HBANIY,HBANIZ,NILDAT
      COMMON
     *       /OMEGAS/ OMEGAX,OMEGAY,OMEGAZ
      COMMON
     *       /OMISOS/ OMISOX,OMISOY,OMISOZ
      COMMON
     *       /IANGLE/ ALPINI,BETINI,GAMINI
      COMMON
     *       /ICNSTR/ STIFFI(1:NDKART),
     *                ASKEDI(1:NDKART),
     *                IFLAGI(1:NDKART)
      COMMON
     *       /ACNSTR/ STIFFA,ASKEDA,IFLAGA
      COMMON
     *       /QCNSTR/ STIFFQ(0:NDMULT,-NDMULT:NDMULT),
     *                QASKED(0:NDMULT,-NDMULT:NDMULT),
     *                IFLAGQ(0:NDMULT,-NDMULT:NDMULT)
      COMMON
     *       /SCNSTR/ STIFFS(0:NDMULT,-NDMULT:NDMULT),
     *                SASKED(0:NDMULT,-NDMULT:NDMULT),
     *                IFLAGS(0:NDMULT,-NDMULT:NDMULT)
      COMMON
     *       /GCNSTR/ STIFFG(0:NDMULT),
     *                GASKED(0:NDMULT),
     *                IFLAGG(0:NDMULT)
      COMMON
     *       /QLASTR/ GALMUQ(0:NDMULT,-NDMULT:NDMULT),
     *                QLINEA(0:NDMULT,-NDMULT:NDMULT),
     *                IFLALQ(0:NDMULT,-NDMULT:NDMULT)
      COMMON
     *       /SLASTR/ GALMUS(0:NDMULT,-NDMULT:NDMULT),
     *                SLINEA(0:NDMULT,-NDMULT:NDMULT),
     *                IFLALS(0:NDMULT,-NDMULT:NDMULT)
      COMMON
     *       /SPNUMS/ NUMBSP(0:NDREVE,0:NDISOS)
      COMMON
     *       /PAIINI/ FERINI(0:NDISOS),DELINI(0:NDISOS),FE2INI(0:NDISOS)
      COMMON
     *       /CCPPAI/ PRHO_N,PRHODN,PRHOSN,POWERN,
     *                PRHO_P,PRHODP,PRHOSP,POWERP
      COMMON
     *       /LAND_G/ X0_LAN,X1_LAN,G0_LAN,G0PLAN,G1_LAN,G1PLAN
      COMMON
     *       /PLANCK/ HBMASS,HBMRPA,HBMINP
      COMMON
     *       /SO_PAR/ W0_INP,W0PINP
      COMMON
     *       /CFIREA/ NFIREA
      COMMON
     *       /DISTAN/ DISTAX,DISTAY,DISTAZ
      COMMON
     *       /ROTATT/ ROTATX,ROTATY,ROTATZ
      COMMON
     *       /RINORM/ HBMRIN(NDKART)
      COMMON
     *       /RINROT/ ROTRIN(NDKART)
      COMMON
     *       /BROINI/ IBROYD,N_ITER
     *       /BROMIX/ ALPHAM,BROTRI
     *       /BROMAT/ NOIINP,MIXMAT
      COMMON
     *       /CFIPRI/ NFIPRI
C@@@ SHELL - SHELL - SHELL - SHELL - SHELL - SHELL - SHELL - SHELL
      COMMON
     *       /STRUTI_PARAMS/ GSTRUN,GSTRUP,HOMFAC,EPSRTN
     *       /STRUTI_POLYNO/ NPOLYN
C@@@ SHELL - SHELL - SHELL - SHELL - SHELL - SHELL - SHELL - SHELL
C@@@ TEMP -TEMP - TEMP - TEMP - TEMP - TEMP - TEMP - TEMP - TEMP - TEMP
      COMMON
     *       /T_FLAG/ IFTEMP
      COMMON
     *       /GCTEMP/ TEMP_T
C@@@ TEMP -TEMP - TEMP - TEMP - TEMP - TEMP - TEMP - TEMP - TEMP - TEMP
C@@@ NECK - NECK - NECK - NECK - NECK - NECK - NECK - NECK - NECK
      COMMON
     *       /NCKVAL/ Q0NECK,G_NECK
     *       /NCKFLA/ IFNECK
C@@@ NECK - NECK - NECK - NECK - NECK - NECK - NECK - NECK - NECK
      COMMON
     *       /AUTOBA/ IBASIS
      COMMON
     *       /EDFINP/ IF_EDF
      COMMON
     *       /MINDEF/ LAMINP(1:NDSEAR),MIUINP(1:NDSEAR)
     *       /MINLIM/ NUMINP,LMXINP,ITEINP
     *       /MINSTP/ STPINP
      COMMON
     *       /HFMEAN/ IHFPOT
C
C=======================================================================
C
      DATA
     *      NO_RUN /0/
C
C=======================================================================
C
      PI=4.0D0*ATAN(1.0D0)
      DEGRAD=180.0D0/PI
C
   1  CONTINUE
C
      READ(NFIREA,'(A10)',END=2) KEYWOR
C
C=======================================================================
C         READING THE NEUTRON AND PROTON NUMBERS
C=======================================================================
C
      IF (trim(KEYWOR).EQ.'NUCLID'.OR.trim(KEYWOR).EQ.'NUCLIDE') THEN
C
          READ(NFIREA,*) IN_FIX,IZ_FIX
C
      END IF
C
      IF (trim(KEYWOR).EQ.'FLOAT_NUC'.OR.
     *    trim(KEYWOR).EQ.'FLOAT-NUC') THEN
C
          READ(NFIREA,*) XINFIX,XIZFIX
C
      END IF
C
C=======================================================================
C         READING THE ITERATION NUMBER
C=======================================================================
C
      IF (trim(KEYWOR).EQ.'ITERATIONS') THEN
C
          READ(NFIREA,*) NOITER
C
          IF (NOITER.GT.NDITER) STOP 'NOITER.GT.NDITER IN NAMELI'
C
      END IF
C
C=======================================================================
C         READING THE BROYDEN DATA (STANDARD BROYDEN ON FIELDS)
C=======================================================================
C
      IF (trim(KEYWOR).EQ.'BROYDEN') THEN
C
          READ(NFIREA,*) IBROYD,N_DUMM,A_DUMM,B_DUMM
C
          IF (IBROYD.GE.1.AND.N_DUMM.GT.0) THEN
C
              N_ITER=N_DUMM
              ALPHAM=A_DUMM
              BROTRI=B_DUMM
C
          END IF
C
      END IF
C
C=======================================================================
C         READING THE BROYDEN DATA (MATRIX ELEMENTS)
C=======================================================================
C
      IF (trim(KEYWOR).EQ.'BROYDENMAT') THEN
C
          READ(NFIREA,*) NOIINP,MIXMAT
C
      END IF
C
C@@@ NECK - NECK - NECK - NECK - NECK - NECK - NECK - NECK - NECK
C=======================================================================
C         READING THE DATA ABOUT THE CONSTRAINT ON THE NECK
C=======================================================================
C
      IF (trim(KEYWOR).EQ.'NECK-CONST'.OR.
     *    trim(KEYWOR).EQ.'NECK_CONST') THEN
C
          READ(NFIREA,*) IFNECK,Q0NECK,G_NECK
C
      END IF
C
C@@@ NECK - NECK - NECK - NECK - NECK - NECK - NECK - NECK - NECK
C=======================================================================
C         READING THE FLAG SWITCHING ON THE UNEDF PARAMETERIZATIONS
C=======================================================================
C
      IF (trim(KEYWOR).EQ.'UNEDF_PROJ'.OR.
     *    trim(KEYWOR).EQ.'UNEDF-PROJ') THEN
C
          READ(NFIREA,*) IF_EDF
C
      END IF
C
C=======================================================================
C         CHOOSING TO ADJUST THE BASIS AUTOMATICALLY BASED ON Q2
C=======================================================================
C
      IF (trim(KEYWOR).EQ.'BASISAUTOM') THEN
C
          READ(NFIREA,*) IBASIS
C
      END IF
C
C=======================================================================
C         CHOOSING TO COMPUTE THE MASS OF THE FISSION FRAGMENTS
C=======================================================================
C
      IF (trim(KEYWOR).EQ.'MASSFRAGME') THEN
C
          READ(NFIREA,*) IFRAGM
C
      END IF
C
C=======================================================================
C         CHOOSING TO COMPUTE AND RECORD DENSITIES OF FISSION FRAGMENTS
C=======================================================================
C
      IF (trim(KEYWOR).EQ.'FRAGDENSIT') THEN
C
          READ(NFIREA,*) IDEALL,IDELOC,IDECON
C
      END IF
C
C=======================================================================
C         CHOOSING TO ROTATE SELECTED PAIRS OF Q.P. WAVE-FUNCTIONS
C=======================================================================
C
      IF (trim(KEYWOR).EQ.'QPROTATION') THEN
C
          READ(NFIREA,*) MIN_QP,DELTAE,XLOCMX,V2_MIN,ITRMAX,NTHETA
C
      END IF
C
C=======================================================================
C         DEFINING THE COLLECTIVE SPACE FOR COLLECTIVE INERTIA
C=======================================================================
C
      IF (trim(KEYWOR).EQ.'COLL_SPACE'.OR.
     *    trim(KEYWOR).EQ.'COLL-SPACE') THEN
C
          N_COLL=0
C
          ALLOCATE(L_COLL(1:NDMULT))
          ALLOCATE(M_COLL(1:NDMULT))
C
 1050     READ(NFIREA,*,END=2040) LAMBDA,MIU
C
	  N_COLL=N_COLL+1
	  L_COLL(N_COLL)=ABS(LAMBDA)
	  M_COLL(N_COLL)=MIU
C
          IF (ABS(LAMBDA).GT.NDMULT.OR.LAMBDA.EQ.0.OR.
     *                 ABS(MIU).GT.ABS(LAMBDA).OR.N_COLL.GT.NDMULT)
     *
     *        STOP ' LAMBDA VALUES OUT OF RANGE IN NAMELI'
C
          IF (LAMBDA.LT.0) GO TO 1050
C
      END IF
C
C@@@ TEMP - TEMP - TEMP - TEMP - TEMP - TEMP - TEMP - TEMP - TEMP
C=======================================================================
C         READING THE TEMPERATURE
C=======================================================================
C
      IF (trim(KEYWOR).EQ.'FINITETEMP') THEN
C
          READ(NFIREA,*) TEMP_T
C
          IF (ABS(TEMP_T).GT.1.D-12) IFTEMP=1
C
      END IF
C
C@@@ TEMP - TEMP - TEMP - TEMP - TEMP - TEMP - TEMP - TEMP - TEMP
C@@@ SHELL - SHELL - SHELL - SHELL - SHELL - SHELL - SHELL - SHELL
C=======================================================================
C         READING THE SWITCH TO SHELL CORRECTION
C=======================================================================
C
      IF (trim(KEYWOR).EQ.'SHELLCORCT') THEN
C
          READ(NFIREA,*) IFSHEL
C
      END IF
C
      IF (trim(KEYWOR).EQ.'SHELLPARAM') THEN
C
          READ(NFIREA,*) GSTRUN,GSTRUP,HOMFAC,NPOLYN
C
      END IF
C
C@@@ SHELL - SHELL - SHELL - SHELL - SHELL - SHELL - SHELL - SHELL
C@@@ HFBTHO - HFBTHO - HFBTHO - HFBTHO - HFBTHO - HFBTHO - HFBTHO
C=======================================================================
C         READING THE SWITCH THAT DECIDES IF ONE RUNS/READS A HFBTHO
C         CALCULATION.
C=======================================================================
C
      IF (trim(KEYWOR).EQ.'HFBTHOISON') THEN
C
          READ(NFIREA,*) IF_THO,CBETHO
C
      END IF
C
C@@@ HFBTHO - HFBTHO - HFBTHO - HFBTHO - HFBTHO - HFBTHO - HFBTHO
C=======================================================================
C         READING THE ITERATION STABILITY PARAMETER
C=======================================================================
C
      IF (trim(KEYWOR).EQ.'ITERAT_EPS'.OR.
     *    trim(KEYWOR).EQ.'ITERAT-EPS') THEN
C
          READ(NFIREA,*) EPSITE
C
      END IF
C
C=======================================================================
C         READING THE MAXIMAL NUMBER OF ITERATIONS FOR STABILITY TEST
C=======================================================================
C
      IF (trim(KEYWOR).EQ.'MAXANTIOSC') THEN
C
          READ(NFIREA,*) NULAST
C
      END IF
C
C=======================================================================
C=======================================================================
C
C         THE CODE IS ABLE TO DETECT THE PING-PONG DIVERGENCE  WHICH
C         OCCURS WHEN THE ITERATION SCHEME GIVES ALTERNATING RESULTS
C         IN EVERY SECOND ITERATION.  UPON CONTINUING THE ITERATION,
C         BOTH SEQUENCES OF RESULTS,  THE EVEN SEQUENCE AND THE  ODD
C         SEQUENCE, BECOME PERFECTLY STABLE AND THE CORRECT SOLUTION
C         IS NEVER ATTAINED.
C
C         THE CODE RECOGNIZES SUCH A DIVERGENCE BY  CALCULATING  THE
C         AVERAGES AND VARIANCES OF THE STABILITY ENERGY, SEPARATELY
C         IN THE EVEN AND IN THE ODD SEQUENCES, OVER "NUPING"  PAIRS
C         OF  ITERATIONS. THE PING-PONG DIVERGENCE IS SIGNALLED WHEN
C         BOTH VARIANCES BECOME A FACTOR  "EPSPNG"  SMALLER THAN THE
C         ABSOLUTE VALUE OF THE DIFFERENCE OF AVERAGES, I.E.,
C
C         DISEVE < EPSPNG * ABS(AVREVE-AVRODD)
C         DISODD < EPSPNG * ABS(AVREVE-AVRODD)
C
C         UPON DISCOVERING THE PING-PONG DIEVERGENCE THE CODE ABORTS
C         THE ITERATION AND PRINTS THE TABLE OF MAXIMUM  DIFFERENCES
C         OF  SINGLE-PARTICLE  OBSERVABLES BETWEEN THE TWO SEQUENCES
C         OF ITERATIONS. THE MAXIMUM DIFFERENCES ARE DETERMINED  FOR
C         STATES IN EVERY   CHARGE - PARITY - SIGNATURE  BLOCK,  AND
C         SEPARATELY FOR PARTICLE AND HOLE STATES.  WHENEVER  SUCH A
C         MAXIMUM DIFFERENCE IS FOUND FOR A PARTICLE AND A HOLE WITH
C         ADJACENT  INDICES,  SUCH A PAIR IS PROPOSED AS A CANDIDATE
C         FOR THE DIABATIC BLOCKING CALCULATION.
C
C=======================================================================
C         READING DATA FOR THE PING-PONG DIVERGENCE TEST
C=======================================================================
C
      IF (trim(KEYWOR).EQ.'PING_PONG'.OR.
     *    trim(KEYWOR).EQ.'PING-PONG') THEN
C
          READ(NFIREA,*) EPSPNG,NUPING
C
      END IF
C
C=======================================================================
C=======================================================================
C
C         THE CODE IS ABLE TO DETECT THE  CHAOTIC  DIVERGENCE  WHICH
C         OCCURS WHEN THE ITERATION SCHEME GIVES CHAOTICALLY VARYING
C         RESULTS.
C
C         THE CODE RECOGNIZES SUCH A DIVERGENCE BY FINDING THE MAXIMA
C         IN THE SEQUENCE OF ABSOLUTE VALUES OF THE STABILITY ENERGY.
C         THE CHAOTIC DIVERGENCE IS SIGNALLED WHEN THERE ARE AT LEAST
C         "NUCHAO" INCRESES IN THE SEQUENCE OF MAXIMA FOUND.
C
C=======================================================================
C         READING DATA FOR THE CHAOTIC DIVERGENCE TEST
C=======================================================================
C
      IF (trim(KEYWOR).EQ.'CHAOTIC') THEN
C
          READ(NFIREA,*) NUCHAO
C
      END IF
C
C=======================================================================
C         READING THE SWITCH DEFINING THE INCLUSION OF THE HO POTENTIAL
C=======================================================================
C
      IF (trim(KEYWOR).EQ.'INSERT_HO'.OR.
     *    trim(KEYWOR).EQ.'INSERT-HO') THEN
C
          READ(NFIREA,*) IPOTHO
C
      END IF
C
C=======================================================================
C         READING THE DEFINITION OF THE PHASE SPACE
C=======================================================================
C
      IF (trim(KEYWOR).EQ.'PHASESPACE') THEN
C
          READ(NFIREA,*) ((NUMBSP(IREVER,ICHARG),IREVER=0,NDREVE),
     *                                           ICHARG=0,NDISOS)
C
      END IF
C
C=======================================================================
C         READING THE SKYRME-SET CODE
C=======================================================================
C
      IF (trim(KEYWOR).EQ.'SKYRME_SET'.OR.
     *    trim(KEYWOR).EQ.'SKYRME-SET') THEN
C
          READ(NFIREA,'(12X,A4)') SKYRME
C
      END IF
C
C=======================================================================
C         READING THE SWITCHES DEFINING THE STANDARD SKYRME-SET
C=======================================================================
C
      IF (trim(KEYWOR).EQ.'SKYRME_STD'.OR.
     *    trim(KEYWOR).EQ.'SKYRME-STD') THEN
C
          READ(NFIREA,*) ISTAND,KETA_J,KETA_W,KETACM,KETA_M
C
      END IF
C
C=======================================================================
C         READING THE GOGNY-SET CODE
C=======================================================================
C
      IF (trim(KEYWOR).EQ.'GOGNY_SET'.OR.
     *    trim(KEYWOR).EQ.'GOGNY-SET') THEN
C
          READ(NFIREA,'(12X,A4)') GOGNAM
C
      END IF
C
C=======================================================================
C         READING THE SWITCH DEFINING THE ROTATIONAL CORRECTION
C=======================================================================
C
      IF (trim(KEYWOR).EQ.'ROTAT_CORR'.OR.
     *    trim(KEYWOR).EQ.'ROTAT-CORR') THEN
C
          READ(NFIREA,*) KETA_R
C
      END IF
C
C=======================================================================
C         READING THE USER DEFINED HBMINP=HBAR^2/2M PARAMETER
C=======================================================================
C
      IF (trim(KEYWOR).EQ.'HBAR2OVR2M') THEN
C
          READ(NFIREA,*) HBMINP
C
      END IF
C
C=======================================================================
C         READING THE USER DEFINED SPIN-ORBIT PARAMETERS
C=======================================================================
C
      IF (trim(KEYWOR).EQ.'SPIN_ORBIT'.OR.
     *    trim(KEYWOR).EQ.'SPIN-ORBIT') THEN
C
          READ(NFIREA,*) W0_INP,W0PINP
C
      END IF
C
C=======================================================================
C         READING THE LANDAU PARAMETERS
C=======================================================================
C
      IF (trim(KEYWOR).EQ.'LANDAU') THEN
C
          READ(NFIREA,*) LANODD,
     *                   X0_LAN,X1_LAN,G0_LAN,G0PLAN,G1_LAN,G1PLAN
C
      END IF
C
C=======================================================================
C         READING THE LANDAU SWITCH FOR USING THE ORIGINAL OR SCALED
C         COUPLING CONSTANTS
C=======================================================================
C
      IF (trim(KEYWOR).EQ.'LAN4SCALED') THEN
C
          READ(NFIREA,*) LANSCA
C
      END IF
C
C=======================================================================
C         READING THE SATURATION VALUES REQUIRED WHEN USING
C         THE LANDAU PARAMETERS
C=======================================================================
C
      IF (trim(KEYWOR).EQ.'LANDAU_SAT'.OR.
     *    trim(KEYWOR).EQ.'LANDAU-SAT') THEN
C
          READ(NFIREA,*) HBMSAT,RHOSAT,EFFSAT
C
      END IF
C
C=======================================================================
C         READING THE TIME-EVEN T-S SKYRME-FUNCTIONAL SCALING FACTORS
C=======================================================================
C
      IF (trim(KEYWOR).EQ.'EVE_SCA_TS'.OR.
     *    trim(KEYWOR).EQ.'EVE-SCA-TS') THEN
C
          READ(NFIREA,*) (STSALL(NUCOUP),NUCOUP=1,NDCOUP/2)
C
      END IF
C
C=======================================================================
C         READING THE TIME-ODD  T-S SKYRME-FUNCTIONAL SCALING FACTORS
C=======================================================================
C
      IF (trim(KEYWOR).EQ.'ODD_SCA_TS'.OR.
     *    trim(KEYWOR).EQ.'ODD-SCA-TS') THEN
C
          READ(NFIREA,*) (STSALL(NUCOUP),NUCOUP=NDCOUP/2+1,NDCOUP)
C
      END IF
C
C=======================================================================
C         READING THE TIME-EVEN P-M SKYRME-FUNCTIONAL SCALING FACTORS
C=======================================================================
C
      IF (trim(KEYWOR).EQ.'EVE_SCA_PM'.OR.
     *    trim(KEYWOR).EQ.'EVE-SCA-PM') THEN
C
          READ(NFIREA,*) (SPMALL(NUCOUP),NUCOUP=1,NDCOUP/2)
C
      END IF
C
C=======================================================================
C         READING THE TIME-ODD  P-M SKYRME-FUNCTIONAL SCALING FACTORS
C=======================================================================
C
      IF (trim(KEYWOR).EQ.'ODD_SCA_PM'.OR.
     *    trim(KEYWOR).EQ.'ODD-SCA-PM') THEN
C
          READ(NFIREA,*) (SPMALL(NUCOUP),NUCOUP=NDCOUP/2+1,NDCOUP)
C
      END IF
C
C=======================================================================
C         READING THE TIME-EVEN T-S SKYRME-FUNCTIONAL ADDITIVE CONSTANTS
C=======================================================================
C
      IF (trim(KEYWOR).EQ.'EVE_ADD_TS'.OR.
     *    trim(KEYWOR).EQ.'EVE-ADD-TS') THEN
C
          READ(NFIREA,*) (ATSALL(NUCOUP),NUCOUP=1,NDCOUP/2)
C
      END IF
C
C=======================================================================
C         READING THE TIME-ODD  T-S SKYRME-FUNCTIONAL ADDITIVE CONSTANTS
C=======================================================================
C
      IF (trim(KEYWOR).EQ.'ODD_ADD_TS'.OR.
     *    trim(KEYWOR).EQ.'ODD-ADD-TS') THEN
C
          READ(NFIREA,*) (ATSALL(NUCOUP),NUCOUP=NDCOUP/2+1,NDCOUP)
C
      END IF
C
C=======================================================================
C         READING THE TIME-EVEN P-M SKYRME-FUNCTIONAL ADDITIVE CONSTANTS
C=======================================================================
C
      IF (trim(KEYWOR).EQ.'EVE_ADD_PM'.OR.
     *    trim(KEYWOR).EQ.'EVE-ADD-PM') THEN
C
          READ(NFIREA,*) (APMALL(NUCOUP),NUCOUP=1,NDCOUP/2)
C
      END IF
C
C=======================================================================
C         READING THE TIME-ODD  P-M SKYRME-FUNCTIONAL ADDITIVE CONSTANTS
C=======================================================================
C
      IF (trim(KEYWOR).EQ.'ODD_ADD_PM'.OR.
     *    trim(KEYWOR).EQ.'ODD-ADD-PM') THEN
C
          READ(NFIREA,*) (APMALL(NUCOUP),NUCOUP=NDCOUP/2+1,NDCOUP)
C
      END IF
C
C=======================================================================
C         READING THE PAIRING-STRENGTHS SCALING FACTORS
C         ATTENTION: IF IAVRGG (AVERAGE - G) IS EQUAL TO 1, THE PAIRING
C         =========  CONSTANTS ARE   C A L C U L A T E D   ACCORDING TO
C                    BOLSTERLI ET AL., PHYS. REV. C5 P.1050;
C         THE SCALING FACTORS ARE APPLIED IN ANY CASE;  SET 1 TO AVOID.
C=======================================================================
C
      IF (trim(KEYWOR).EQ.'G_SCALING'.OR.
     *    trim(KEYWOR).EQ.'G-SCALING') THEN
C
          READ(NFIREA,*) FACTGN,FACTGP
C
      END IF
C
      IF (trim(KEYWOR).EQ.'G_AUTOCALC'.OR.
     *    trim(KEYWOR).EQ.'G-AUTOCALC') THEN
C
          READ(NFIREA,*) IAVRGG
C
      END IF
C
C=======================================================================
C         READING THE INITIAL HFB FERMI ENERGIES AND HFB PAIRING GAPS
C=======================================================================
C
      IF (trim(KEYWOR).EQ.'INI_FERMI'.OR.
     *    trim(KEYWOR).EQ.'INI-FERMI') THEN
C
          READ(NFIREA,*) (FERINI(ICHARG),ICHARG=0,NDISOS)
C
      END IF
C
      IF (trim(KEYWOR).EQ.'INI_DELTA'.OR.
     *    trim(KEYWOR).EQ.'INI-DELTA') THEN
C
          READ(NFIREA,*) (DELINI(ICHARG),ICHARG=0,NDISOS)
C
      END IF
C
      IF (trim(KEYWOR).EQ.'INI_LIPKIN') THEN
C
          READ(NFIREA,*) (FE2INI(ICHARG),ICHARG=0,NDISOS)
C
      END IF
C
C=======================================================================
C         READING THE FIXED HFB FERMI ENERGIES
C=======================================================================
C
      IF (trim(KEYWOR).EQ.'FIXFERMI_N'.OR.
     *    trim(KEYWOR).EQ.'FIXFERMI-N') THEN
C
          READ(NFIREA,*) FERFIN,IFEFIN
C
      END IF
C
      IF (trim(KEYWOR).EQ.'FIXFERMI_P'.OR.
     *    trim(KEYWOR).EQ.'FIXFERMI-P') THEN
C
          READ(NFIREA,*) FERFIP,IFEFIP
C
      END IF
C
C=======================================================================
C         READING THE FIXED LIPKIN-NOGAMI LAMBDA2 PARAMETERS
C=======================================================================
C
      IF (trim(KEYWOR).EQ.'FIXLAMB2_N'.OR.
     *    trim(KEYWOR).EQ.'FIXLAMB2-N') THEN
C
          READ(NFIREA,*) FE2FIN,IF2FIN
C
      END IF
C
      IF (trim(KEYWOR).EQ.'FIXLAMB2_P'.OR.
     *    trim(KEYWOR).EQ.'FIXLAMB2-P') THEN
C
          READ(NFIREA,*) FE2FIP,IF2FIP
C
      END IF
C
C=======================================================================
C         READING THE FIXED HFB PAIRING GAPS
C=======================================================================
C
      IF (trim(KEYWOR).EQ.'FIXDELTA_N'.OR.
     *    trim(KEYWOR).EQ.'FIXDELTA-N') THEN
C
          READ(NFIREA,*) DELFIN,IDEFIN
C
      END IF
C
      IF (trim(KEYWOR).EQ.'FIXDELTA_P'.OR.
     *    trim(KEYWOR).EQ.'FIXDELTA-P') THEN
C
          READ(NFIREA,*) DELFIP,IDEFIP
C
      END IF
C
C=======================================================================
C         ENFORCING VACUUM CONFIGURATIONS FOR HF CALCULATIONS
C=======================================================================
C
      IF (trim(KEYWOR).EQ.'VACUUMCONF') THEN
C
          READ(NFIREA,*) IVACUM
C
      END IF
C
C=======================================================================
C         READING THE PARAMETERS OF QUASIPARTICLE BLOCKING IN  THE  CASE
C         OF THE PARITY/SIGNATURE SYMMETRY CONSERVED
C=======================================================================
C
      IF (trim(KEYWOR).EQ.'BLOCKSIG_N'.OR.
     *    trim(KEYWOR).EQ.'BLOCKSIG-N') THEN
C
          READ(NFIREA,*) INSIGN,IPSIGN,ISSIGN,IDSIGN
C
      END IF
C
      IF (trim(KEYWOR).EQ.'BLOCKSIG_P'.OR.
     *    trim(KEYWOR).EQ.'BLOCKSIG-P') THEN
C
          READ(NFIREA,*) INSIGP,IPSIGP,ISSIGP,IDSIGP
C
      END IF
C
C=======================================================================
C         READING THE PARAMETERS OF QUASIPARTICLE BLOCKING IN  THE  CASE
C         OF THE SIMPLEX SYMMETRY CONSERVED
C=======================================================================
C
      IF (trim(KEYWOR).EQ.'BLOCKSIM_N'.OR.
     *    trim(KEYWOR).EQ.'BLOCKSIM-N') THEN
C
          READ(NFIREA,*) INSIMN,IRSIMN,IDSIMN
C
      END IF
C
      IF (trim(KEYWOR).EQ.'BLOCKSIM_P'.OR.
     *    trim(KEYWOR).EQ.'BLOCKSIM-P') THEN
C
          READ(NFIREA,*) INSIMP,IRSIMP,IDSIMP
C
      END IF
C
C=======================================================================
C         READING THE PARAMETERS OF QUASIPARTICLE BLOCKING IN  THE  CASE
C         OF THE PARITY SYMMETRY CONSERVED
C=======================================================================
C
      IF (trim(KEYWOR).EQ.'BLOCKSIQ_N'.OR.
     *    trim(KEYWOR).EQ.'BLOCKSIQ-N') THEN
C
          READ(NFIREA,*) INSIQN,IPSIQN,IDSIQN
C
      END IF
C
      IF (trim(KEYWOR).EQ.'BLOCKSIQ_P'.OR.
     *    trim(KEYWOR).EQ.'BLOCKSIQ-P') THEN
C
          READ(NFIREA,*) INSIQP,IPSIQP,IDSIQP
C
      END IF
C
C=======================================================================
C         READING THE PARAMETERS OF QUASIPARTICLE BLOCKING IN  THE  CASE
C         OF NO SYMMETRY CONSERVED
C=======================================================================
C
      IF (trim(KEYWOR).EQ.'BLOCKSIZ_N'.OR.
     *    trim(KEYWOR).EQ.'BLOCKSIZ-N') THEN
C
          READ(NFIREA,*) INSIZN,IDSIZN
C
      END IF
C
      IF (trim(KEYWOR).EQ.'BLOCKSIZ_P'.OR.
     *    trim(KEYWOR).EQ.'BLOCKSIZ-P') THEN
C
          READ(NFIREA,*) INSIZP,IDSIZP
C
      END IF
C
C=======================================================================
C         READING THE SWITCHES THAT DECIDE  UPON  THE  QUASIPARTICLE
C         BLOCKING BASED ON THE FIXED SINGLE-PARTICLE WAVE FUNCTIONS
C=======================================================================
C         FOR IFIBLN = 1 THE   FIXED  NEUTRON SINGLE-PARTICLE WAVE
C                        FUNCTION WILL BE USED
C         FOR IFIBLN = 0 THE VARIABLE NEUTRON SINGLE-PARTICLE WAVE
C                        FUNCTION WILL BE USED
C         FOR IFIBLP = 1 THE   FIXED   PROTON SINGLE-PARTICLE WAVE
C                        FUNCTION WILL BE USED
C         FOR IFIBLP = 0 THE VARIABLE  PROTON SINGLE-PARTICLE WAVE
C                        FUNCTION WILL BE USED
C=======================================================================
C         FOR INIBLN = 1 THE NEUTRON SINGLE-PARTICLE WAVE FUNCTION WILL
C                        BE     INITIALIZED AT THE FIRST ITERATION
C         FOR INIBLN = 0 THE NEUTRON SINGLE-PARTICLE WAVE FUNCTION WILL
C                        NOT BE INITIALIZED AT THE FIRST ITERATION
C         FOR INIBLP = 1 THE  PROTON SINGLE-PARTICLE WAVE FUNCTION WILL
C                        BE     INITIALIZED AT THE FIRST ITERATION
C         FOR INIBLP = 0 THE  PROTON SINGLE-PARTICLE WAVE FUNCTION WILL
C                        NOT BE INITIALIZED AT THE FIRST ITERATION
C=======================================================================
C
      IF (trim(KEYWOR).EQ.'BLOCKFIX_N'.OR.
     *    trim(KEYWOR).EQ.'BLOCFIX-N') THEN
C
          READ(NFIREA,*) IFIBLN,INIBLN
C
      END IF
C
      IF (trim(KEYWOR).EQ.'BLOCKFIX_P'.OR.
     *    trim(KEYWOR).EQ.'BLOCKFIX-P') THEN
C
          READ(NFIREA,*) IFIBLP,INIBLP
C
      END IF
C
C=======================================================================
C         READING THE COUPLING CONSTANTS OF THE PAIRING FORCE IN THE
C         V0-V1-POWER REPRESENTATION
C=======================================================================
C
      IF (trim(KEYWOR).EQ.'PAIRNFORCE') THEN
C
          READ(NFIREA,*) PRHO_N,PRHODN,POWERN
C
          CALL RHODEP(1,PRHO_N,PRHODN,PRHOSN,POWERN)
C
      END IF
C
      IF (trim(KEYWOR).EQ.'PAIRPFORCE') THEN
C
          READ(NFIREA,*) PRHO_P,PRHODP,POWERP
C
          CALL RHODEP(1,PRHO_P,PRHODP,PRHOSP,POWERP)
C
      END IF
C
      IF (trim(KEYWOR).EQ.'PAIR_FORCE'.OR.
     *    trim(KEYWOR).EQ.'PAIR-FORCE') THEN
C
          READ(NFIREA,*) PRHO_T,PRHODT,POWERT
C
          PRHO_N=PRHO_T
          PRHODN=PRHODT
          POWERN=POWERT
C
          CALL RHODEP(1,PRHO_N,PRHODN,PRHOSN,POWERN)
C
          PRHO_P=PRHO_T
          PRHODP=PRHODT
          POWERP=POWERT
C
          CALL RHODEP(1,PRHO_P,PRHODP,PRHOSP,POWERP)
C
      END IF
C
C=======================================================================
C         READING THE COUPLING CONSTANTS OF THE PAIRING FORCE IN THE
C         V0-RHO-POWER REPRESENTATION
C=======================================================================
C
      IF (trim(KEYWOR).EQ.'PAIRNINTER') THEN
C
          READ(NFIREA,*) PRHO_N,PRHOSN,POWERN
C
          CALL RHODEP(2,PRHO_N,PRHODN,PRHOSN,POWERN)
C
      END IF
C
      IF (trim(KEYWOR).EQ.'PAIRPINTER') THEN
C
          READ(NFIREA,*) PRHO_P,PRHOSP,POWERP
C
          CALL RHODEP(2,PRHO_P,PRHODP,PRHOSP,POWERP)
C
      END IF
C
      IF (trim(KEYWOR).EQ.'PAIR_INTER'.OR.
     *    trim(KEYWOR).EQ.'PAIR-INTER') THEN
C
          READ(NFIREA,*) PRHO_T,PRHOST,POWERT
C
          PRHO_N=PRHO_T
          PRHOSN=PRHOST
          POWERN=POWERT
C
          CALL RHODEP(2,PRHO_N,PRHODN,PRHOSN,POWERN)
C
          PRHO_P=PRHO_T
          PRHOSP=PRHOST
          POWERP=POWERT
C
          CALL RHODEP(2,PRHO_P,PRHODP,PRHOSP,POWERP)
C
      END IF
C
C=======================================================================
C         READING THE HFB PAIRING CUTOFF ENERGY
C=======================================================================
C
      IF (trim(KEYWOR).EQ.'CUTOFF') THEN
C
          READ(NFIREA,*) ECUTOF
C
      END IF
C
C=======================================================================
C         READING THE SWITCH DECIDING ON WHETHER ONLY THE QUASIPARTICLES
C         WITH ENERGIES BELOW 'ECUTOF' WILL BE TAKEN INTO ACCOUNT
C=======================================================================
C
      IF (trim(KEYWOR).EQ.'CUT_SPECTR'.OR.
     *    trim(KEYWOR).EQ.'CUT-SPECTR') THEN
C
          READ(NFIREA,*) LIMQUA
C
      END IF
C
C=======================================================================
C         READING THE PARAMETERS WHICH CONTROL THE CALCULATION OF THE
C         PAIRING MATRIX ELEMENTS
C=======================================================================
C
      IF (trim(KEYWOR).EQ.'PAIR_MATRI'.OR.
     *    trim(KEYWOR).EQ.'PAIR-MATRI') THEN
C
          READ(NFIREA,*) IDESTA,IDEMID,IDESTO,IDEDIS
C
      END IF
C
C=======================================================================
C=======================================================================
C
C         SYMMETRIES ARE DEFINED IN TERMS OF:
C
C         0. THE SPHERICAL SYMMETRY
C
C         (ISPHER=1 => SPHERICAL SYMMETRY CONSERVED)
C
C         1. THE Y_SIMPLEX
C
C         (ISIMPY=1 => Y_SIMPLEX     CONSERVED)
C         (ISIMPY=0 => Y_SIMPLEX NON CONSERVED)
C
C         2. THE Y_SIGNATURE
C
C         (ISIGNY=1 => Y_SIGNATURE     CONSERVED)
C         (ISIGNY=0 => Y_SIGNATURE NON CONSERVED)
C
C         3. THE PARITY
C
C         (IPARTY=1 => PARITY          CONSERVED)
C         (IPARTY=0 => PARITY          CONSERVED)
C         (IPARTY=-1=> PARITY DETERMINED ACCORDING TO ISIMPY AND ISIGNY)
C
C         4. THE X_SIMPLEX*TIME_REVERSAL
C
C         (ISIMTX=1 => X_SIMPLEX*TIME_REVERSAL     CONSERVED)
C         (ISIMTX=0 => X_SIMPLEX*TIME_REVERSAL NON CONSERVED)
C
C         5. THE Y_SIMPLEX*TIME_REVERSAL
C
C         (JSIMTY=1 => Y_SIMPLEX*TIME_REVERSAL     CONSERVED)
C         (JSIMTY=0 => Y_SIMPLEX*TIME_REVERSAL NON CONSERVED)
C         (JSIMTY=-1=> Y_SIMPLEX*TIME_REVERSAL DETERMINED FROM IROTAT)
C
C         6. THE Z_SIMPLEX*TIME_REVERSAL
C
C         (ISIMTZ=1 => Z_SIMPLEX*TIME_REVERSAL     CONSERVED)
C         (ISIMTZ=0 => Z_SIMPLEX*TIME_REVERSAL NON CONSERVED)
C
C=======================================================================
C         NOT ALL THE COMBINATIONS OF SYMMETRY  SWITCHES  ARE
C         ALLOWED.
C=======================================================================
C         ATTENTION: PARAMETER IPARTY IS PREDEFINED TO -1 AND
C                    READ FROM THE DATA.
C
C                    IF IPARTY IS NOT EQUAL TO  -1  THEN  THE
C                    VALUE OF ISIQTY IS SET EQUAL  TO  IPARTY.
C
C                    IF IPARTY IS EQUAL TO -1 THEN THE  VALUE
C                    OF ISIQTY IS DETERMINED ACCORDING TO THE
C                    FOLLOWING TABLE:
C
C                    ISIMPY=1 AND ISIGNY=1  ==>  ISIQTY=1
C                    ISIMPY=0  OR ISIGNY=0  ==>  ISIQTY=0
C
C                    VALUE OF IPARTY=-1 IS ALLOWED  ONLY  FOR
C                    THE SAKE OF COMPATIBILITY  WITH  EARLIER
C                    VERSIONS (BEFORE 1.96C).
C
C                    "ISIQTY" DECIDES INSIDE THE  PROGRAM  ON
C                    WHETHER OR NOT  THE PARITY IS CONSERVED.
C
C=======================================================================
C         THE PRODUCT OF ANY OF THE TWO SYMMETRY OPERATORS  FROM  THE
C         SET: (Y-SIMPLEX, Y-SIGNATURE, PARITY) IS EQUAL TO THE THIRD
C         ONE. THEREFORE, IF TWO OF THEM ARE CONSERVED, THE THIRD ONE
C         HAS TO BE CONSERVED TOO.
C=======================================================================
C         THE COMPLETE TABLE OF ALL THE VALUES OF THE ABOVE  SYMMETRY
C         SWITCHES IS AS FOLLOWS:
C
C         ISIMPY = 1,  ISIGNY = 1,  ISIQTY = 1  ===>  ALLOWED
C         ISIMPY = 1,  ISIGNY = 1,  ISIQTY = 0  ===>  IMPOSSIBLE
C         ISIMPY = 1,  ISIGNY = 0,  ISIQTY = 1  ===>  IMPOSSIBLE
C         ISIMPY = 1,  ISIGNY = 0,  ISIQTY = 0  ===>  ALLOWED
C         ISIMPY = 0,  ISIGNY = 1,  ISIQTY = 1  ===>  IMPOSSIBLE
C         ISIMPY = 0,  ISIGNY = 1,  ISIQTY = 0  ===>  ALLOWED*
C         ISIMPY = 0,  ISIGNY = 0,  ISIQTY = 1  ===>  ALLOWED
C         ISIMPY = 0,  ISIGNY = 0,  ISIQTY = 0  ===>  ALLOWED
C=======================================================================
C         HOWEVER, IN THE PRESENT VERSIONS, FOUR OF THESE COMBINATIONS
C         OF THE ALLOWED SYMMETRY SWITCHES ARE IMPLEMENTED DYNAMICALLY,
C         I.E., THE SYMMETRIES ARE USED FOR BLOCK-DIAGONALIZATIOTS AND
C         DEFINITIONS OF QUANTUM NUMBERS. THE FIFTH ONE IS IMPLEMENTED
C         STATICALLY, I.E., ONLY THE DENSITIES ARE SYMMETRIEZED, WHILE
C         THE REST OF THE CODE WORKS IN THE MODE CORRESPONDING  TO  NO
C         CONSERVED SYMMETRIES.
C=======================================================================
C         THE COMBINATIONS IMPLEMENTED DYNAMICALLY CORRESPOND  TO  THE
C         FOLLOWING BRANCHING TREE:
C
C                          ISIGNY=1  ====>  (AND ISIQTY=1 IS IMPLIED)
C                         /
C                 ISIMPY=1
C               /         \
C              /           ISIGNY=0  ====>  (AND ISIQTY=0 IS IMPLIED)
C         START
C              \           ISIQTY=1  ====>  (AND ISIGNY=0 IS IMPLIED)
C               \         /
C                 ISIMPY=0
C                         \
C                          ISIQTY=0  ====>  (AND ISIGNY=0 IS IMPLIED)
C
C=======================================================================
C         ATTENTION: PARAMETER ISIMTY IS PREDEFINED TO -1 AND
C                    READ FROM THE DATA.
C
C                    IF ISIMTY IS NOT EQUAL TO  -1  THEN  THE
C                    VALUE OF JSIMTY IS SET EQUAL  TO  ISIMTY.
C
C                    IF ISIMTY IS EQUAL TO -1 THEN THE  VALUE
C                    OF JSIMTY IS SET EQUAL TO 1-IROTAT:
C
C                    VALUE OF ISIMTY=-1 IS ALLOWED  ONLY  FOR
C                    THE SAKE OF COMPATIBILITY  WITH  EARLIER
C                    VERSIONS (BEFORE 2.05J).
C
C                    "JSIMTY" DECIDES INSIDE THE  PROGRAM  ON
C                    WHETHER OR NOT THE Y-SIMPLEX*TIME_REVER.
C                    IS CONSERVED.
C
C=======================================================================
C         THE PRODUCT OF ANY OF THE TWO SYMMETRY OPERATORS  FROM  THE
C         SET (Y-SIMPLEX, Y-SIMPLEX^T, TIME-REVERSAL) IS EQUAL TO THE
C         THIRD ONE. THEREFORE, IF TWO OF  THEM  ARE  CONSERVED,  THE
C         THIRD ONE HAS TO BE CONSERVED TOO.
C=======================================================================
C         THE COMPLETE TABLE OF ALL THE VALUES OF THE ABOVE  SYMMETRY
C         SWITCHES IS AS FOLLOWS:
C
C         ISIMPY = 1,  IROTAT = 0,  JSIMTY = 1  ===>  ALLOWED
C         ISIMPY = 1,  IROTAT = 1,  JSIMTY = 1  ===>  IMPOSSIBLE
C         ISIMPY = 1,  IROTAT = 0,  JSIMTY = 0  ===>  IMPOSSIBLE
C         ISIMPY = 1,  IROTAT = 1,  JSIMTY = 0  ===>  ALLOWED
C         ISIMPY = 0,  IROTAT = 0,  JSIMTY = 1  ===>  IMPOSSIBLE
C         ISIMPY = 0,  IROTAT = 1,  JSIMTY = 1  ===>  ALLOWED
C         ISIMPY = 0,  IROTAT = 0,  JSIMTY = 0  ===>  ALLOWED
C         ISIMPY = 0,  IROTAT = 1,  JSIMTY = 0  ===>  ALLOWED
C
C         THE PATAMETER JSIMTY HAS TO BE CONSISTENT  WITH  THE  OTHER
C         TWO PARAMETERS ISIMPY AND IROTAT ACCORDING TO THE  STANDARD
C         D2H GROUP MULTIPLICATION TABLE.
C
C         ATTENTION: NOTE THAT THE TIME-REVERSAL IS CONSERVED OR  NOT
C                    FOR IROTAT = 0 OR IROTAT = 1, RESPECTIVELY.
C
C=======================================================================
C         THE PRODUCT OF ANY OF THE TWO SYMMETRY OPERATORS  FROM  THE
C         SET (Y-SIGNATURE, X-SIMPLEX^T, Z-SIMPLEX^T) IS EQUAL TO THE
C         THIRD ONE. THEREFORE, IF ANY TWO OF THEM ARE CONSERVED, THE
C         THIRD ONE HAS TO BE CONSERVED TOO.
C=======================================================================
C         THE COMPLETE TABLE OF ALL THE VALUES OF THE ABOVE  SYMMETRY
C         SWITCHES IS AS FOLLOWS:
C
C         ISIGNY = 1,  ISIMTX = 1,  ISIMTZ = 1  ===>  ALLOWED
C         ISIGNY = 1,  ISIMTX = 1,  ISIMTZ = 0  ===>  IMPOSSIBLE
C         ISIGNY = 1,  ISIMTX = 0,  ISIMTZ = 1  ===>  IMPOSSIBLE
C         ISIGNY = 1,  ISIMTX = 0,  ISIMTZ = 0  ===>  ALLOWED
C         ISIGNY = 0,  ISIMTX = 1,  ISIMTZ = 1  ===>  IMPOSSIBLE
C         ISIGNY = 0,  ISIMTX = 1,  ISIMTZ = 0  ===>  ALLOWED
C         ISIGNY = 0,  ISIMTX = 0,  ISIMTZ = 1  ===>  ALLOWED
C         ISIGNY = 0,  ISIMTX = 0,  ISIMTZ = 0  ===>  ALLOWED
C=======================================================================
C
C=======================================================================
C         READING THE PARAMETER SELECTING THE SHERICAL SYMMETRY
C=======================================================================
C
      IF (trim(KEYWOR).EQ.'SPHERICAL') THEN
C
          READ(NFIREA,*) ISPHER
C
      END IF
C
C=======================================================================
C         READING THE PARAMETER SELECTING THE SIMPLEX MODE
C=======================================================================
C
      IF (trim(KEYWOR).EQ.'SIMPLEXY') THEN
C
          READ(NFIREA,*) ISIMPY
C
      END IF
C
C=======================================================================
C         READING THE PARAMETER SELECTING THE SIGNATURE MODE
C=======================================================================
C
      IF (trim(KEYWOR).EQ.'SIGNATUREY') THEN
C
          READ(NFIREA,*) ISIGNY
C
      END IF
C
C=======================================================================
C         READING THE PARAMETER SELECTING THE PARITY MODE
C=======================================================================
C
      IF (trim(KEYWOR).EQ.'PARITY') THEN
C
          READ(NFIREA,*) IPARTY
C
      END IF
C
C=======================================================================
C         READING THE PARAMETER SELECTING  NO-ROTATION  MODE
C=======================================================================
C         KEYWORD "TIMEREVERS" AND SWITCH "ITIREV" ARE  HERE
C         USED AS A CONVENIENT ALTERNATIVE TO READING SWITCH
C         "IROTAT"; SWITCH "ITIREV" IS USED NOWHERE ELSE.
C=======================================================================
C
      IF (trim(KEYWOR).EQ.'ROTATION') THEN
C
          READ(NFIREA,*) IROTAT
C
      END IF
C
      IF (trim(KEYWOR).EQ.'TIMEREVERS') THEN
C
          READ(NFIREA,*) ITIREV
C
          IF (ITIREV.EQ.1) THEN
              IROTAT=0
          ELSE
              IROTAT=1
          END IF
C
      END IF
C
C=======================================================================
C         READING THE PARAMETERS SELECTING THE SIMPLEXES*T
C=======================================================================
C
      IF (trim(KEYWOR).EQ.'TSIMPLEX_Y'.OR.
     *    trim(KEYWOR).EQ.'TSIMPLEX-Y') THEN
C
          READ(NFIREA,*) ISIMTY
C
      END IF
C
      IF (trim(KEYWOR).EQ.'TSIMPLEXES') THEN
C
          READ(NFIREA,*) ISIMTX,ISIMTZ
C
      END IF
C
      IF (trim(KEYWOR).EQ.'TSIMPLEX3D') THEN
C
          READ(NFIREA,*) ISIMTX,ISIMTY,ISIMTZ
C
      END IF
C
C=======================================================================
C         READING THE PARAMETER SELECTING PAIRING MODE
C=======================================================================
C
      IF (trim(KEYWOR).EQ.'PAIRING') THEN
C
          READ(NFIREA,*) IPAIRI
C
      END IF
C
C=======================================================================
C         READING THE PARAMETER SELECTING THE HFB MODE
C=======================================================================
C
      IF (trim(KEYWOR).EQ.'HFB') THEN
C
          READ(NFIREA,*) IPAHFB
C
      END IF
C
C=======================================================================
C         READING THE PARAMETER SELECTING THE TWO-BASIS METHOD
C=======================================================================
C
      IF (trim(KEYWOR).EQ.'TWOBASIS') THEN
C
          READ(NFIREA,*) ITWOBA
C
      END IF
C
C=======================================================================
C         PARAMETER IPABCS DECIDES ON WHETHER OR NOT, AND WHAT KIND OF
C         BCS PAIRING CALCULATIONS ARE PERFORMED:
C         IPABCS=-1 ->  COMPATIBILTY MODE
C         IPABCS=0  ->  NO BCS PAIRING
C         IPABCS=1  ->     BCS PAIRING WITH THE SENIORITY PARING FORCE
C         IPABCS=2  ->     BCS PAIRING WITH FIXED PAIRING GAPS
C         IPABCS=3  ->     BCS PAIRING WITH STATE-DEPENDENT PAIRING GAPS
C=======================================================================
C         ATTENTION: PARAMETER IPABCS IS PREDEFINED TO -1 AND
C                    READ FROM THE DATA.
C
C                    IF IPABCS IS NOT EQUAL TO  -1  THEN  THE
C                    VALUE OF JPABCS IS SET EQUAL  TO  IPABCS.
C
C                    IF IPABCS IS EQUAL TO -1 THEN THE  VALUE
C                    OF JPABCS IS SET IN THE FOLLOWING WAY TO
C                    FULFILL THE COMPATIBILITY CONDITIONS:
C                    JPABCS=0      IS SET FOR IPAHFB=1
C                    JPABCS=IPAIRI IS SET FOR IPAHFB=0
C
C                    VALUE OF IPABCS=-1 IS ALLOWED  ONLY  FOR
C                    THE SAKE OF COMPATIBILITY  WITH  EARLIER
C                    VERSIONS (BEFORE 2.13F).
C
C                    "JPABCS" DECIDES INSIDE THE  PROGRAM  ON
C                    WHETHER OR NOT THE BCS PAIRING IS USED.
C
C=======================================================================
C         READING THE PARAMETER SELECTING THE BCS MODE
C=======================================================================
C
      IF (trim(KEYWOR).EQ.'BCS') THEN
C
          READ(NFIREA,*) IPABCS
C
      END IF
C
C=======================================================================
C         READING THE PARAMETER REQUESTING THE HFB MEAN-FIELD PROPERTIES
C=======================================================================
C
      IF (trim(KEYWOR).EQ.'HFBMEANFLD') THEN
C
          READ(NFIREA,*) IMFHFB
C
      END IF
C
C=======================================================================
C         READING THE PARAMETER REQUESTING THE LIPKIN-NOGAMI CORRECTIONS
C=======================================================================
C
      IF (trim(KEYWOR).EQ.'LIPKIN') THEN
C
          READ(NFIREA,*) LIPKIN,LIPKIP
C
      END IF
C
C=======================================================================
C=======================================================================
C
C         CONFIGURATIONS ARE DEFINED IN TERMS OF EITHER THE SIMPLEX
C         (ISIGNY=0) OR THE SIGNATURE-PARITY (ISIGNY=1) QUANTUM
C         NUMBERS.
C
C         SIMPLEX IS EQUAL TO THE PRODUCT: SIMPLEX=SIGNATURE*PARITY
C
C                                       *********************
C         THE BLOCK IREVER=0 CONTAINS   * (RY=+i,PARITY=+1) * AND
C                                       * (RY=-i,PARITY=-1) *
C                                       *********************
C         THE BLOCK IREVER=1 CONTAINS   * (RY=-i,PARITY=+1) * AND
C                                       * (RY=+i,PARITY=-1) *
C                                       *********************
C
C         FOR THE CASE OF THE SIMPLEX:
C         IN THE INPUT DATA THE BLOCKS ARE RED IN THE ORDER
C                    (SIMPLEX) = (+) , (-)
C         THEREFORE: THE BLOCK IREVER=0 IS DEFINED BY (+)
C                    THE BLOCK IREVER=1 IS DEFINED BY (-)
C
C         FOR THE CASE OF THE SIGNATURE-PARITY:
C         IN THE INPUT DATA THE BLOCKS ARE RED IN THE ORDER
C                    (PARITY,SIGNATURE) = (+,+) (+,-) (-,+) (-,-)
C         THEREFORE: THE BLOCK IREVER=0 IS DEFINED BY (+,+) AND (-,-)
C                    THE BLOCK IREVER=1 IS DEFINED BY (+,-) AND (-,+)
C
C=======================================================================
C         READING THE NEUTRON PARTICLE-HOLE EXCITATION (NO SYMMETRY)
C=======================================================================
C
      IF (trim(KEYWOR).EQ.'PHNONE_NEU'.OR.
     *    trim(KEYWOR).EQ.'PHNONE-NEU') THEN
C
          READ(NFIREA,*) NUPAHO,KPNONE(NUPAHO,0),
     *                          KHNONE(NUPAHO,0)
C
          IF (NUPAHO.LE.0.OR.NUPAHO.GT.NDPAHO)
     *        STOP 'INDEX OUT OF RANGE FOR NONE/NEUTRONS IN NAMELI'
C
      END IF
C
C=======================================================================
C         READING THE  PROTON PARTICLE-HOLE EXCITATION (NO SYMMETRY)
C=======================================================================
C
      IF (trim(KEYWOR).EQ.'PHNONE_PRO'.OR.
     *    trim(KEYWOR).EQ.'PHNONE-PRO') THEN
C
          READ(NFIREA,*) NUPAHO,KPNONE(NUPAHO,1),
     *                          KHNONE(NUPAHO,1)
C
          IF (NUPAHO.LE.0.OR.NUPAHO.GT.NDPAHO)
     *        STOP 'INDEX OUT OF RANGE FOR NONE/PROTONS IN NAMELI'
C
      END IF
C
C=======================================================================
C         READING THE VACUUM OCCUPATIONS FOR NEUTRONS (SIMPLEX)
C=======================================================================
C
      IF (trim(KEYWOR).EQ.'VACSIM_NEU'.OR.
     *    trim(KEYWOR).EQ.'VACSIM-NEU') THEN
C
          READ(NFIREA,*) (KVASIM(ISIMPL,0),ISIMPL=0,NDSIMP)
C
      END IF
C
C=======================================================================
C         READING THE VACUUM OCCUPATIONS FOR PROTONS (SIMPLEX)
C=======================================================================
C
      IF (trim(KEYWOR).EQ.'VACSIM_PRO'.OR.
     *    trim(KEYWOR).EQ.'VACSIM-PRO') THEN
C
          READ(NFIREA,*) (KVASIM(ISIMPL,1),ISIMPL=0,NDSIMP)
C
      END IF
C
C=======================================================================
C         READING THE NEUTRON PARTICLE-HOLE EXCITATION (SIMPLEX)
C=======================================================================
C
      IF (trim(KEYWOR).EQ.'PHSIMP_NEU'.OR.
     *    trim(KEYWOR).EQ.'PHSIMP-NEU') THEN
C
          READ(NFIREA,*) NUPAHO,KPSIMP(NUPAHO,0),KPSIMM(NUPAHO,0),
     *                          KHSIMP(NUPAHO,0),KHSIMM(NUPAHO,0)
C
          IF (NUPAHO.LE.0.OR.NUPAHO.GT.NDPAHO)
     *        STOP 'INDEX OUT OF RANGE FOR SIMPLEX/NEUTRONS IN NAMELI'
C
      END IF
C
C=======================================================================
C         READING THE PROTON PARTICLE-HOLE EXCITATION (SIMPLEX)
C=======================================================================
C
      IF (trim(KEYWOR).EQ.'PHSIMP_PRO'.OR.
     *    trim(KEYWOR).EQ.'PHSIMP-PRO') THEN
C
          READ(NFIREA,*) NUPAHO,KPSIMP(NUPAHO,1),KPSIMM(NUPAHO,1),
     *                          KHSIMP(NUPAHO,1),KHSIMM(NUPAHO,1)
C
          IF (NUPAHO.LE.0.OR.NUPAHO.GT.NDPAHO)
     *        STOP 'INDEX OUT OF RANGE FOR SIMPLEX/PROTONS IN NAMELI'
C
      END IF
C
C=======================================================================
C         READING THE VACUUM OCCUPATIONS FOR NEUTRONS (PARITY)
C=======================================================================
C
      IF (trim(KEYWOR).EQ.'VACPAR_NEU'.OR.
     *    trim(KEYWOR).EQ.'VACPAR-NEU') THEN
C
          READ(NFIREA,*) (KVASIQ(IPARIT,0),IPARIT=0,NDPARI)
C
      END IF
C
C=======================================================================
C         READING THE VACUUM OCCUPATIONS FOR PROTONS (PARITY)
C=======================================================================
C
      IF (trim(KEYWOR).EQ.'VACPAR_PRO'.OR.
     *    trim(KEYWOR).EQ.'VACPAR-PRO') THEN
C
          READ(NFIREA,*) (KVASIQ(IPARIT,1),IPARIT=0,NDPARI)
C
      END IF
C
C=======================================================================
C         READING THE NEUTRON PARTICLE-HOLE EXCITATION (PARITY)
C=======================================================================
C
      IF (trim(KEYWOR).EQ.'PHPARI_NEU'.OR.
     *    trim(KEYWOR).EQ.'PHPARI-NEU') THEN
C
          READ(NFIREA,*) NUPAHO,KPSIQP(NUPAHO,0),KPSIQM(NUPAHO,0),
     *                          KHSIQP(NUPAHO,0),KHSIQM(NUPAHO,0)
C
          IF (NUPAHO.LE.0.OR.NUPAHO.GT.NDPAHO)
     *        STOP 'INDEX OUT OF RANGE FOR PARITY/NEUTRONS IN NAMELI'
C
      END IF
C
C=======================================================================
C         READING THE PROTON PARTICLE-HOLE EXCITATION (PARITY)
C=======================================================================
C
      IF (trim(KEYWOR).EQ.'PHPARI_PRO'.OR.
     *    trim(KEYWOR).EQ.'PHPARI-PRO') THEN
C
          READ(NFIREA,*) NUPAHO,KPSIQP(NUPAHO,1),KPSIQM(NUPAHO,1),
     *                          KHSIQP(NUPAHO,1),KHSIQM(NUPAHO,1)
C
          IF (NUPAHO.LE.0.OR.NUPAHO.GT.NDPAHO)
     *        STOP 'INDEX OUT OF RANGE FOR PARITY/PROTONS IN NAMELI'
C
      END IF
C
C=======================================================================
C         READING THE VACUUM OCCUPATIONS FOR NEUTRONS (SIGNATURE)
C=======================================================================
C
      IF (trim(KEYWOR).EQ.'VACSIG_NEU'.OR.
     *    trim(KEYWOR).EQ.'VACSIG-NEU') THEN
C
          READ(NFIREA,*) ((KVASIG(IPARIT,ISIGNA,0),ISIGNA=0,NDSIGN),
     *                                             IPARIT=0,NDPARI)
C
      END IF
C
C=======================================================================
C         READING THE VACUUM OCCUPATIONS FOR PROTONS (SIGNATURE)
C=======================================================================
C
      IF (trim(KEYWOR).EQ.'VACSIG_PRO'.OR.
     *    trim(KEYWOR).EQ.'VACSIG-PRO') THEN
C
          READ(NFIREA,*) ((KVASIG(IPARIT,ISIGNA,1),ISIGNA=0,NDSIGN),
     *                                             IPARIT=0,NDPARI)
C
      END IF
C
C=======================================================================
C         READING THE NEUTRON PARTICLE-HOLE EXCITATION (SIGNATURE)
C=======================================================================
C
      IF (trim(KEYWOR).EQ.'PHSIGN_NEU'.OR.
     *    trim(KEYWOR).EQ.'PHSIGN-NEU') THEN
C
          READ(NFIREA,*) NUPAHO,KPPPSP(NUPAHO,0),KPPPSM(NUPAHO,0),
     *                          KPPMSP(NUPAHO,0),KPPMSM(NUPAHO,0),
     *                          KHPPSP(NUPAHO,0),KHPPSM(NUPAHO,0),
     *                          KHPMSP(NUPAHO,0),KHPMSM(NUPAHO,0)
C
          IF (NUPAHO.LE.0.OR.NUPAHO.GT.NDPAHO)
     *        STOP 'INDEX OUT OF RANGE FOR SIGNATURE/NEUTRONS IN NAMELI'
C
      END IF
C
C=======================================================================
C         READING THE PROTON PARTICLE-HOLE EXCITATION (SIGNATURE)
C=======================================================================
C
      IF (trim(KEYWOR).EQ.'PHSIGN_PRO'.OR.
     *    trim(KEYWOR).EQ.'PHSIGN-PRO') THEN
C
          READ(NFIREA,*) NUPAHO,KPPPSP(NUPAHO,1),KPPPSM(NUPAHO,1),
     *                          KPPMSP(NUPAHO,1),KPPMSM(NUPAHO,1),
     *                          KHPPSP(NUPAHO,1),KHPPSM(NUPAHO,1),
     *                          KHPMSP(NUPAHO,1),KHPMSM(NUPAHO,1)
C
          IF (NUPAHO.LE.0.OR.NUPAHO.GT.NDPAHO)
     *        STOP 'INDEX OUT OF RANGE FOR SIGNATURE/PROTONS IN NAMELI'
C
      END IF
C
C=======================================================================
C=======================================================================
C
C         FOR A SINGLE PAIR OF STATES, THE DIABATIC BLOCKING OF
C         CONFIGURATIONS IS ORGANISED AS FOLLOWS:
C
C         1A. FOR THE PARITY/SIGNATURE CASE, THE BLOCK IN WHICH THE
C             BLOCKING IS TO BE PERFORMED IS DEFINDED BY THE:
C                                                 CHARGE, ICHFLI=(0,1),
C                                                 PARITY, IPAFLI=(0,1),
C                                          AND SIGNATURE, ISIFLI=(0,1)
C
C         1B. FOR THE     SIMPLEX      CASE, THE BLOCK IN WHICH THE
C             BLOCKING IS TO BE PERFORMED IS DEFINDED BY THE:
C                                                 CHARGE, ICHFLI=(0,1),
C                                            AND SIMPLEX, ISIFLI=(0,1)
C             ATTENTION: AS A SECURITY MEASURE, IN THE  SIMPLEX  CASE
C                        THE USER IS RESPONSIBLE FOR SETTING IPAFLI=0,
C                        ALTHOUGH THIS VARIABLE WILL NOT BE USED.
C
C         1C. FOR THE      PARITY      CASE, THE BLOCK IN WHICH THE
C             BLOCKING IS TO BE PERFORMED IS DEFINDED BY THE:
C                                                 CHARGE, ICHFLI=(0,1),
C                                            AND  PARITY, IPAFLI=(0,1)
C             ATTENTION: AS A SECURITY MEASURE, IN  THE  PARITY  CASE
C                        THE USER IS RESPONSIBLE FOR SETTING ISIFLI=0,
C                        ALTHOUGH THIS VARIABLE WILL NOT BE USED.
C
C         1D. FOR THE    NO-SYMMETRY   CASE, THE BLOCK IN WHICH THE
C             BLOCKING IS TO BE PERFORMED IS DEFINDED BY THE:
C                                                 CHARGE, ICHFLI=(0,1)
C             ATTENTION: AS A SECURITY MEASURE, IN  THE  NO-SYMM  CASE
C                        THE USER IS RESPONSIBLE FOR SETTING  ISIFLI=0
C                        AND IPAFLI=0, ALTHOUGH THESE  VARIABLES  WILL
C                        NOT BE USED.
C
C         2.  THE CODE CONSIDERS TWO STATES:  A PARTICLE STATE, ISPFLI,
C                                         AND A     HOLE STATE, ISHFLI.
C             THESE INDICES REFER TO THE ENERGY ORDERING IN THE CHOSEN
C             BLOCK, AND HENCE DEPEND ON WHETHER THE  PARITY/SIGNATURE
C             OR THE SIMPLEX CASE IS CONSIDERED (ISIGNY VARIABLE).
C
C         3.  THE CODE CONSIDERS THE OBSERVABLE DEFINED BY THE ABSOLUTE
C                                                      VALUE OF IFLIPI:
C             FOR  ABS(IFLIPI)= 1, ANGULAR MOMENTUM Y-ALIGNMENT IS TAKEN
C             FOR  ABS(IFLIPI)= 2, INTRINSIC  SPIN  Y-ALIGNMENT IS TAKEN
C
C             FOR  ABS(IFLIPI)= 3, ANGULAR MOMENTUM X-ALIGNMENT IS TAKEN
C             FOR  ABS(IFLIPI)= 4, INTRINSIC  SPIN  X-ALIGNMENT IS TAKEN
C
C             FOR  ABS(IFLIPI)= 5, ANGULAR MOMENTUM Z-ALIGNMENT IS TAKEN
C             FOR  ABS(IFLIPI)= 6, INTRINSIC  SPIN  Z-ALIGNMENT IS TAKEN
C
C             FOR  ABS(IFLIPI)= 7, ANGULAR MOMENTUM O-ALIGNMENT IS TAKEN
C             FOR  ABS(IFLIPI)= 8, INTRINSIC  SPIN  O-ALIGNMENT IS TAKEN
C
C                                  WHERE THE "O-ALIGNMENTS"  DENOTE  THE
C                                  PROJECTIONS  ON  THE  VECTOR  OF  THE
C                                  ANGULAR FREQUENCY OMEGA
C
C             FOR  ABS(IFLIPI)= 9, QUADRUPOLE MOMENT Q_20 MIU=0 IS TAKEN
C             FOR  ABS(IFLIPI)=10, QUADRUPOLE MOMENT Q_22 MIU=2 IS TAKEN
C
C             FOR      IFLIPI = 0, THERE IS NO DIABATIC BLOCKING.
C
C         4.  AMONG THE TWO STATES, ISPFLI AND ISHFLI, THE ONE WHICH IS
C             KEPT OCCUPIED MUST HAVE THE LARGER, FOR IFLIPI > 0,
C                                     OR SMALLER, FOR IFLIPI < 0,
C             VALUE OF THE CHOSEN OBSERVABLE
C
C         5.  VALUES OF IFLIPI FROM 3 TO 8 ARE ALLOWED ONLY FOR ISIMPY=0
C
C=======================================================================
C         READING THE DIABATIC CONFIGURATION DATA FOR A SINGLE PAIR
C         OF STATES
C=======================================================================
C
      IF (trim(KEYWOR).EQ.'DIABATIC') THEN
C
          READ(NFIREA,*) ICHFLI,IPAFLI,ISIFLI,
     *                   ISPFLI,ISHFLI,IFLIPI
C
          IREFLI=ISIFLI*(1-IPAFLI)+(1-ISIFLI)*IPAFLI
C
      END IF
C
C=======================================================================
C
C         FOR ALL BLOCKS OF STATES, THE DIABATIC BLOCKING OF
C         CONFIGURATIONS IS ORGANISED IN THE SAME WAY AS FOR
C         THE SINGLE PAIR OF STATES (SEE DESCRIPTION ABOVE).
C
C         THE ROLE OF THE SINGLE-PAIR VARIABLES IS  PLAYED BY
C         THE MATRICES ACCORDING TO  THE  FOLLOWING  TABLE OF
C         CORRSPONDENCES:
C
C         SINGLE-PAIR  SIGNATURE   SIMPLEX      PARITY   NO-SYMMETRY
C         -----------  ----------  --------    --------  -----------
C           ISPFLI       KPFLIG     KPFLIM      KPFLIQ     KPFLIZ
C           ISHFLI       KHFLIG     KHFLIM      KHFLIQ     KHFLIZ
C           IFLIPI       KOFLIG     KOFLIM      KOFLIQ     KOFLIZ
C
C         ATTENTION:        THE SINGLE-PAIR DIABATIC BLOCKING
C                       AND THE ALL-BLOCKS  DIABATIC BLOCKING
C                       C A N N O T  BE  USED  SIMULTANEOUSLY
C
C=======================================================================
C         READING THE NEUTRON DIABATIC CONFIGURATION DATA FOR ALL
C         NO-SYMMETRY BLOCKS
C=======================================================================
C
      IF (trim(KEYWOR).EQ.'DIANON_NEU'.OR.
     *    trim(KEYWOR).EQ.'DIANON-NEU') THEN
C
          READ(NFIREA,*) KPFLIZ(0),
     *                   KHFLIZ(0),
     *                   KOFLIZ(0)
C
      END IF
C
C=======================================================================
C         READING THE  PROTON DIABATIC CONFIGURATION DATA FOR ALL
C         NO-SYMMETRY BLOCKS
C=======================================================================
C
      IF (trim(KEYWOR).EQ.'DIANON_PRO'.OR.
     *    trim(KEYWOR).EQ.'DIANON-PRO') THEN
C
          READ(NFIREA,*) KPFLIZ(1),
     *                   KHFLIZ(1),
     *                   KOFLIZ(1)
C
      END IF
C
C=======================================================================
C         READING THE NEUTRON DIABATIC CONFIGURATION DATA FOR ALL
C         SIMPLEX BLOCKS
C=======================================================================
C
      IF (trim(KEYWOR).EQ.'DIASIM_NEU'.OR.
     *    trim(KEYWOR).EQ.'DIASIM-NEU') THEN
C
          READ(NFIREA,*) (KPFLIM(ISIMPL,0),ISIMPL=0,NDSIMP),
     *                   (KHFLIM(ISIMPL,0),ISIMPL=0,NDSIMP),
     *                   (KOFLIM(ISIMPL,0),ISIMPL=0,NDSIMP)
C
      END IF
C
C=======================================================================
C         READING THE  PROTON DIABATIC CONFIGURATION DATA FOR ALL
C         SIMPLEX BLOCKS
C=======================================================================
C
      IF (trim(KEYWOR).EQ.'DIASIM_PRO'.OR.
     *    trim(KEYWOR).EQ.'DIASIM-PRO') THEN
C
          READ(NFIREA,*) (KPFLIM(ISIMPL,1),ISIMPL=0,NDSIMP),
     *                   (KHFLIM(ISIMPL,1),ISIMPL=0,NDSIMP),
     *                   (KOFLIM(ISIMPL,1),ISIMPL=0,NDSIMP)
C
      END IF
C
C=======================================================================
C         READING THE NEUTRON DIABATIC CONFIGURATION DATA FOR ALL
C         PARITY BLOCKS
C=======================================================================
C
      IF (trim(KEYWOR).EQ.'DIAPAR_NEU'.OR.
     *    trim(KEYWOR).EQ.'DIAPAR-NEU') THEN
C
          READ(NFIREA,*) (KPFLIQ(IPARIT,0),IPARIT=0,NDPARI),
     *                   (KHFLIQ(IPARIT,0),IPARIT=0,NDPARI),
     *                   (KOFLIQ(IPARIT,0),IPARIT=0,NDPARI)
C
      END IF
C
C=======================================================================
C         READING THE  PROTON DIABATIC CONFIGURATION DATA FOR ALL
C         PARITY BLOCKS
C=======================================================================
C
      IF (trim(KEYWOR).EQ.'DIAPAR_PRO'.OR.
     *    trim(KEYWOR).EQ.'DIAPAR-PRO') THEN
C
          READ(NFIREA,*) (KPFLIQ(IPARIT,1),IPARIT=0,NDPARI),
     *                   (KHFLIQ(IPARIT,1),IPARIT=0,NDPARI),
     *                   (KOFLIQ(IPARIT,1),IPARIT=0,NDPARI)
C
      END IF
C
C=======================================================================
C         READING THE NEUTRON DIABATIC CONFIGURATION DATA FOR ALL
C         SIGNATURE BLOCKS
C=======================================================================
C
      IF (trim(KEYWOR).EQ.'DIASIG_NEU'.OR.
     *    trim(KEYWOR).EQ.'DIASIG-NEU') THEN
C
          READ(NFIREA,*) ((KPFLIG(IPARIT,ISIGNA,0),ISIGNA=0,NDSIGN),
     *                                             IPARIT=0,NDPARI),
     *                   ((KHFLIG(IPARIT,ISIGNA,0),ISIGNA=0,NDSIGN),
     *                                             IPARIT=0,NDPARI),
     *                   ((KOFLIG(IPARIT,ISIGNA,0),ISIGNA=0,NDSIGN),
     *                                             IPARIT=0,NDPARI)
C
      END IF
C
C=======================================================================
C         READING THE  PROTON DIABATIC CONFIGURATION DATA FOR ALL
C         SIGNATURE BLOCKS
C=======================================================================
C
      IF (trim(KEYWOR).EQ.'DIASIG_PRO'.OR.
     *    trim(KEYWOR).EQ.'DIASIG-PRO') THEN
C
          READ(NFIREA,*) ((KPFLIG(IPARIT,ISIGNA,1),ISIGNA=0,NDSIGN),
     *                                             IPARIT=0,NDPARI),
     *                   ((KHFLIG(IPARIT,ISIGNA,1),ISIGNA=0,NDSIGN),
     *                                             IPARIT=0,NDPARI),
     *                   ((KOFLIG(IPARIT,ISIGNA,1),ISIGNA=0,NDSIGN),
     *                                             IPARIT=0,NDPARI)
C
      END IF
C
C=======================================================================
C         READING THE NEUTRON FILLING CONFIGURATION DATA FOR ALL
C         NO-SYMMETRY BLOCKS
C=======================================================================
C
      IF (trim(KEYWOR).EQ.'FILNON_NEU'.OR.
     *    trim(KEYWOR).EQ.'FILNON-NEU') THEN
C
          READ(NFIREA,*) KPFILZ(0),
     *                   KHFILZ(0),
     *                   KOFILZ(0)
C
      END IF
C
C=======================================================================
C         READING THE  PROTON FILLING CONFIGURATION DATA FOR ALL
C         NO-SYMMETRY BLOCKS
C=======================================================================
C
      IF (trim(KEYWOR).EQ.'FILNON_PRO'.OR.
     *    trim(KEYWOR).EQ.'FILNON-PRO') THEN
C
          READ(NFIREA,*) KPFILZ(1),
     *                   KHFILZ(1),
     *                   KOFILZ(1)
C
      END IF
C
C=======================================================================
C         READING THE NEUTRON FILLING CONFIGURATION DATA FOR ALL
C         SIGNATURE BLOCKS
C=======================================================================
C
      IF (trim(KEYWOR).EQ.'FILSIG_NEU'.OR.
     *    trim(KEYWOR).EQ.'FILSIG-NEU') THEN
C
          READ(NFIREA,*) ((KPFILG(IPARIT,ISIGNA,0),ISIGNA=0,NDSIGN),
     *                                             IPARIT=0,NDPARI),
     *                   ((KHFILG(IPARIT,ISIGNA,0),ISIGNA=0,NDSIGN),
     *                                             IPARIT=0,NDPARI),
     *                   ((KOFILG(IPARIT,ISIGNA,0),ISIGNA=0,NDSIGN),
     *                                             IPARIT=0,NDPARI)
C
      END IF
C
C=======================================================================
C         READING THE PROTON FILLING CONFIGURATION DATA FOR ALL
C         SIGNATURE BLOCKS
C=======================================================================
C
      IF (trim(KEYWOR).EQ.'FILSIG_PRO'.OR.
     *    trim(KEYWOR).EQ.'FILSIG-PRO') THEN
C
          READ(NFIREA,*) ((KPFILG(IPARIT,ISIGNA,1),ISIGNA=0,NDSIGN),
     *                                             IPARIT=0,NDPARI),
     *                   ((KHFILG(IPARIT,ISIGNA,1),ISIGNA=0,NDSIGN),
     *                                             IPARIT=0,NDPARI),
     *                   ((KOFILG(IPARIT,ISIGNA,1),ISIGNA=0,NDSIGN),
     *                                             IPARIT=0,NDPARI)
C
      END IF
C
C=======================================================================
C         READING THE MAXIMUM NUMBERS OF MULTIPOLES
C=======================================================================
C
      IF (trim(KEYWOR).EQ.'MAX_MULTIP'.OR.
     *    trim(KEYWOR).EQ.'MAX-MULTIP') THEN
C
          READ(NFIREA,*) NMUCON,NMUCOU,NMUPRI
C
      END IF
C
C=======================================================================
C         READING THE MAXIMUM NUMBERS OF SURFACE OR SCHIFF MULTIPOLES
C=======================================================================
C
      IF (trim(KEYWOR).EQ.'MAX_SURFAC'.OR.
     *    trim(KEYWOR).EQ.'MAX_SCHIFF'.OR.
     *    trim(KEYWOR).EQ.'MAX-SURFAC'.OR.
     *    trim(KEYWOR).EQ.'MAX-SCHIFF') THEN
C
          READ(NFIREA,*) NSICON,NSIPRI
C
      END IF
C
C=======================================================================
C         READING THE SWITCH REQUESTING THE REPLACEMENT OF THE SURFACE
C         MOMENTS BY THE SCHIFF MOMENTS
C=======================================================================
C         FOR ISCHIF=0 SURFACE MULTIPOLE MOMENTS ARE CALCULATED
C         FOR ISCHIF=1 SCHIFF  MULTIPOLE MOMENTS ARE CALCULATED
C=======================================================================
C
      IF (trim(KEYWOR).EQ.'SCHIFF_MOM'.OR.
     *    trim(KEYWOR).EQ.'SCHIFF-MOM') THEN
C
          READ(NFIREA,*) ISCHIF
C
      END IF
C
C=======================================================================
C         READING THE MAXIMUM NUMBERS OF MAGNETIC MULTIPOLES
C=======================================================================
C
      IF (trim(KEYWOR).EQ.'MAX_MAGNET'.OR.
     *    trim(KEYWOR).EQ.'MAX-MAGNET') THEN
C
          READ(NFIREA,*) NMACON,NMAPRI
C
      END IF
C
C=======================================================================
C         READING THE NUMBERS OF ELECTRIC, MAGNETIC, AND  SURFACE  OR
C         SCHIFF MULTIPOLES, FOR WHICH THE KERNELS AND REDUCED MATRIX
C         ELEMENTS WILL BE CALCULATED
C=======================================================================
C
      IF (trim(KEYWOR).EQ.'TRANSITION') THEN
C
          READ(NFIREA,*) NMURED,NMARED,NSIRED
C
      END IF
C
C=======================================================================
C         READING THE CUT-OFF PARAMETERS FOR PRINTING ELECTRIC,
C         MAGNETIC, AND SURFACE OR SCHIFF KERNELS  AND  REDUCED
C         MATRIX ELEMENTS
C=======================================================================
C
      IF (trim(KEYWOR).EQ.'TRANCUTPRI') THEN
C
          READ(NFIREA,*) QMUCUT,QMACUT,QSICUT
C
      END IF
C
C=======================================================================
C         READING THE PARAMETERS PERTAINING TO THE BOHR DEFORMATIONS
C=======================================================================
C
      IF (trim(KEYWOR).EQ.'BOHR_BETAS'.OR.
     *    trim(KEYWOR).EQ.'BOHR-BETAS') THEN
C
          READ(NFIREA,*) NEXBET,IPRIBE,IPRIBL
C
      END IF
C
C=======================================================================
C         READING THE COULOMB GREEN-FUNCTION CONTROL PARAMETERS
C=======================================================================
C
      IF (trim(KEYWOR).EQ.'COULOMB') THEN
C
          READ(NFIREA,*) NUMCOU,NUMETA,FURMAX
C
      END IF
C
C=======================================================================
C         READING THE COULOMB CONTROL PARAMETERS
C=======================================================================
C         FOR ICOUDI=0 THE  DIRECT  COULOMB TERMS ARE NEGLECTED
C         FOR ICOUDI=1 THE  DIRECT  COULOMB TERMS ARE CALCULATED BY  THE
C                      GREEN FUNCTION METHOD (DEFAULT)
C         FOR ICOUDI=2 THE  DIRECT  COULOMB TERMS ARE CALCULATED BY  THE
C                      METHOD OF EXPANDING INTO GAUSSIANS
C         FOR ICOUEX=0 THE EXCHANGE COULOMB TERMS ARE NEGLECTED
C         FOR ICOUEX=1 THE EXCHANGE COULOMB TERMS ARE CALCULATED BY  THE
C                      SLATER APPROXIMATION (DEFAULT)
C         FOR ICOUEX=2 HE EXCHANGE COULOMB TERMS ARE CALCULATED BY  THE
C                      METHOD OF EXPANDING INTO GAUSSIANS>EXACT EXCHANGE
C=======================================================================
C             ICOUDI ICOUEX         DIRECT COULOMB      EXCHANGE COULOMB
C             ------ ------         --------------      ----------------
C                0      0             NEGLECTED            NEGLECTED
C                1      O           GREEN-FUNCTION         NEGLECTED
C                2      0             GAUSSIANS            NEGLECTED
C                0      1             NEGLECTED             SLATER
C                1      1           GREEN-FUNCTION          SLATER
C                2      1             GAUSSIANS             SLATER
C                0      2             NEGLECTED            GAUSSIANS
C                1      2           GREEN-FUNCTION         GAUSSIANS
C                2      2             GAUSSIANS            GAUSSIANS
C=======================================================================
C
      IF (trim(KEYWOR).EQ.'COULOMBPAR') THEN
C
          READ(NFIREA,*) ICOTYP,ICOUDI,ICOUEX
C
      END IF
C
C=======================================================================
C         READING THE MEAN-FIELD CHARGE VALUE (AS IN THE PRL PAPER)
C=======================================================================
C
      IF (trim(KEYWOR).EQ.'COULOCHARG') THEN
C
          READ(NFIREA,*) E_EFFE
C
      END IF
C
C=======================================================================
C         READING THE YUKAWA CONTROL PARAMETER
C=======================================================================
C
      IF (trim(KEYWOR).EQ.'YUKAWA') THEN
C
          READ(NFIREA,*) PIDUMM,I_YUKA
C
          IF (I_YUKA.GE.1.AND.PIDUMM.GT.0.0) PIMASS=PIDUMM
C
      END IF
C
C=======================================================================
C         READING THE YUKAWA CONTROL PARAMETERS FOR THE HAMILTONIAN TERM
C=======================================================================
C         FOR I_YUKA>0,      THE AVERAGE VALUES OF  THE  FINITE-RANGE
c                            YUKAWA INTERACTION ARE CALCULATED
C         FOR I_YUKA=2 OR 3, THE CORRESPONDING  YUKAWA  DIRECT   MEAN
C                            FIELD IS INCLUDED IN THE SELF-CONSISTENT
C                            MEAN FIELD
C         FOR I_YUKA=2 OR 4, THE CORRESPONDING YUKAWA  EXCHANGE  MEAN
C                            FIELD IS INCLUDED IN THE SELF-CONSISTENT
C                            MEAN FIELD
C=======================================================================
C
      IF (trim(KEYWOR).EQ.'YUKAWATERM') THEN
C
          READ(NFIREA,*) PIDUMM,PNDUMM,
     *                   YUKAGT,YUKAG0,YUKAG1,YUKAG2,IYUTYP,I_YUKA
C
          IF (I_YUKA.GE.1.AND.PIDUMM.GT.0.0) PIMASS=PIDUMM
          IF (I_YUKA.GE.1.AND.PNDUMM.GT.0.0) PNMASS=PNDUMM
C
      END IF
C
C=======================================================================
C         READING THE GOGNY CONTROL PARAMETER
C=======================================================================
C         FOR I_GOGA>0,      THE AVERAGE VALUES OF  THE  FINITE-RANGE
c                            GOGNY INTERACTION ARE CALCULATED
C         FOR I_GOGA=2 OR 3, THE  CORRESPONDING  GOGNY  DIRECT   MEAN
C                            FIELD IS INCLUDED IN THE SELF-CONSISTENT
C                            MEAN FIELD
C         FOR I_GOGA=2 OR 4, THE CORRESPONDING  GOGNY  EXCHANGE  MEAN
C                            FIELD IS INCLUDED IN THE SELF-CONSISTENT
C                            MEAN FIELD
C=======================================================================
C         FOR IGOGPA>0,      THE  PAIRING  ENERGY OF THE FINITE-RANGE
C                            GOGNY INTERACTION ARE CALCULATED
C         FOR IGOGPA=2       THE  CORRESPONDING  GOGNY  PAIRING FIELD
C                            IS ALSO COMPUTED AND INCLUDED IN THE HFB
C                            MATRIX
C=======================================================================
C
      IF (trim(KEYWOR).EQ.'GOGNY') THEN
C
          READ(NFIREA,*) I_GOGA
C
      END IF
C
      IF (trim(KEYWOR).EQ.'GOGNY_PAIR'.OR.
     *    trim(KEYWOR).EQ.'GOGNY-PAIR') THEN
C
          READ(NFIREA,*) IGOGPA
C
      END IF
C
C=======================================================================
C         READING THE MEAN-FIELD SLOW-DOWN PARAMETERS
C=======================================================================
C
      IF (trim(KEYWOR).EQ.'SLOW_DOWN'.OR.
     *    trim(KEYWOR).EQ.'SLOW-DOWN') THEN
C
          READ(NFIREA,*) SLOWEV,SLOWOD
C
      END IF
C
C=======================================================================
C         READING THE PAIRING SLOW-DOWN PARAMETER
C=======================================================================
C
      IF (trim(KEYWOR).EQ.'SLOW_PAIR'.OR.
     *    trim(KEYWOR).EQ.'SLOW-PAIR') THEN
C
          READ(NFIREA,*) SLOWPA
C
      END IF
C
C=======================================================================
C         READING THE LIPKIN-NOGAMI SLOW-DOWN PARAMETER
C=======================================================================
C
      IF (trim(KEYWOR).EQ.'SLOWLIPKIN') THEN
C
          READ(NFIREA,*) SLOWLI
C
      END IF
C
C=======================================================================
C         READING THE PRECISION OF DETERMINING HERMITE POLYNOMIALS
C=======================================================================
C
      IF (trim(KEYWOR).EQ.'EPS_HERMIT'.OR.
     *    trim(KEYWOR).EQ.'EPS-HERMIT') THEN
C
          READ(NFIREA,*) EPSHER
C
      END IF
C
C=======================================================================
C         READING THE OPTIMUM-GAUSS-INTEGRATION PARAMETER
C=======================================================================
C
      IF (trim(KEYWOR).EQ.'OPTI_GAUSS'.OR.
     *    trim(KEYWOR).EQ.'OPTI-GAUSS') THEN
C
          READ(NFIREA,*) IOPTGS
C
      END IF
C
C=======================================================================
C         READING NUMBERS OF POINTS USED FOR THE GAUSS-HERMITE INTEGRALS
C=======================================================================
C
      IF (trim(KEYWOR).EQ.'GAUSHERMIT') THEN
C
          READ(NFIREA,*) NXHERM,NYHERM,NZHERM
C
      END IF
C
C=======================================================================
C         READING PARAMETERS DEFINING THE SIZE OF THE OSCILLATOR BASIS
C=======================================================================
C
      IF (trim(KEYWOR).EQ.'BASIS_SIZE'.OR.
     *    trim(KEYWOR).EQ.'BASIS-SIZE') THEN
C
          READ(NFIREA,*) NOSCIL,NLIMIT,ENECUT
C
          IF (NLIMIT.EQ.0) NLIMIT=((NOSCIL+1)*(NOSCIL+2)*(NOSCIL+3))/6
C
      END IF
C
C=======================================================================
C         READING THE FACTOR WHICH IS USED FOR SCALING THE VALUE OF
C         HBAR*OMEGA_0 =  41 MEV / A**(1/3)
C=======================================================================
C
      IF (trim(KEYWOR).EQ.'HOMEGAZERO') THEN
C
          READ(NFIREA,*) FCHOM0
C
      END IF
C
C=======================================================================
C         READING PARAMETERS OF THE CLASSICAL NUCLEAR SURFACE
C=======================================================================
C
      IF (trim(KEYWOR).EQ.'SURFAC_PAR'.OR.
     *    trim(KEYWOR).EQ.'SURFAC-PAR') THEN
C
          READ(NFIREA,*) INNUMB,IZNUMB,R0PARM
C
      END IF
C
C=======================================================================
C         READING DEFORMATIONS OF THE  CLASSICAL  NUCLEAR SURFACE.
C         DEFORMATIONS FOR SEVERAL VALUES OF LAMBDA AND MIU CAN BE
C         PROVIDED ON  CONSECUTIVE LINES  BY  READING-IN  NEGATIVE
C         FLIPPED-SIGN VALUES OF LAMBDA FOR ALL BUT THE LAST LINE.
C=======================================================================
C
      IF (trim(KEYWOR).EQ.'SURFAC_DEF'.OR.
     *    trim(KEYWOR).EQ.'SURFAC-DEF') THEN
C
 1001     READ(NFIREA,*,END=2001) LAMBDA,MIU,ALPHAR(ABS(LAMBDA),MIU)
C
          IF (ABS(LAMBDA).GT.NDLAMB.OR.LAMBDA.EQ.0.OR.MIU.LT.0.OR.
     *                                         MIU.GT.ABS(LAMBDA))
     *
     *        STOP ' ALPHAR INDICES OUT OF RANGE IN NAMELI'
C
          IF (LAMBDA.LT.0) GO TO 1001
C
      END IF
C
C=======================================================================
C         READING THE NOT-TILTED ISOSCALAR ROTATIONAL FREQUENCY
C=======================================================================
C
      IF (trim(KEYWOR).EQ.'OMEGAY') THEN
C
          READ(NFIREA,*) OMEGAY
C
      END IF
C
C=======================================================================
C         READING THE NOT-TILTED ISOVECTOR ROTATIONAL FREQUENCY
C=======================================================================
C
      IF (trim(KEYWOR).EQ.'OMISOY') THEN
C
          READ(NFIREA,*) OMISOY
C
      END IF
C
C=======================================================================
C         READING THE TILTED CARTESIAN ISOSCALAR ROTATIONAL FREQUENCIES
C=======================================================================
C
      IF (trim(KEYWOR).EQ.'OMEGA_XYZ'.OR.
     *    trim(KEYWOR).EQ.'OMEGA-XYZ') THEN
C
          READ(NFIREA,*) OMEHAX,OMEHAY,OMEHAZ,ITILAX
C
          IF (ITILAX.EQ.1) THEN
C
              OMEGAX=OMEHAX
              OMEGAY=OMEHAY
              OMEGAZ=OMEHAZ
C
          END IF
C
      END IF
C
C=======================================================================
C         READING THE TILTED POLAR ISOSCALAR ROTATIONAL FREQUENCIES
C=======================================================================
C
      IF (trim(KEYWOR).EQ.'OMEGA_RTP'.OR.
     *    trim(KEYWOR).EQ.'OMEGA-RTP') THEN
C
          READ(NFIREA,*) OMERAD,OMETHE,OMEPHI,ITILAX
C
          IF (ITILAX.EQ.1) THEN
C
              OMETHE=OMETHE/DEGRAD
              OMEPHI=OMEPHI/DEGRAD
C
              OMEGAX=OMERAD*SIN(OMETHE)*COS(OMEPHI)
              OMEGAY=OMERAD*SIN(OMETHE)*SIN(OMEPHI)
              OMEGAZ=OMERAD*COS(OMETHE)
C
          END IF
C
      END IF
C
C=======================================================================
C         READING THE TILTED ISOVECTOR ROTATIONAL FREQUENCIES
C=======================================================================
C
      IF (trim(KEYWOR).EQ.'OMISO_XYZ'.OR.
     *    trim(KEYWOR).EQ.'OMISO-XYZ') THEN
C
          READ(NFIREA,*) OMISOX,OMISOY,OMISOZ,ITISAX
C
      END IF
C
C=======================================================================
C         READING REQUEST FOR ADJUSTABLE DIRECTION OF ANGULAR FREQUENCY
C=======================================================================
C
      IF (trim(KEYWOR).EQ.'OMEGA_TURN'.OR.
     *    trim(KEYWOR).EQ.'OMEGA-TURN') THEN
C
          READ(NFIREA,*) IMOVAX
C
      END IF
C
C=======================================================================
C         READING THE SWITCH WHICH CONTROLS THE REMOVAL OF CONSTRAINT ON
C         THE ORBITAL ANGULAR MOMENTUM
C=======================================================================
C
      IF (trim(KEYWOR).EQ.'NORBCONSTR') THEN
C
          READ(NFIREA,*) NO_ORB
C
      END IF
C
C=======================================================================
C         READING INDEXES OF THE INITIAL D2H TRANSFORMATION OF
C         THE WAVE FUNCTION
C=======================================================================
C
      IF (trim(KEYWOR).EQ.'INI_INVERS'.OR.
     *    trim(KEYWOR).EQ.'INI-INVERS') THEN
C
          READ(NFIREA,*) INIINV,INIKAR
C
      END IF
C
C=======================================================================
C         READING THE EULER ANGLES (DEGREES) OF THE INITIAL ROTATION OF
C         THE WAVE FUNCTION
C=======================================================================
C
      IF (trim(KEYWOR).EQ.'EULERANGLS'.OR.
     *    trim(KEYWOR).EQ.'INI_ROTAT'.OR.
     *    trim(KEYWOR).EQ.'INI-ROTAT') THEN
C
          READ(NFIREA,*) ALPAUX,BETAUX,GAMAUX,INIROT
C
          IF (INIROT.EQ.1) THEN
C
              ALPINI=ALPAUX/DEGRAD
              BETINI=BETAUX/DEGRAD
              GAMINI=GAMAUX/DEGRAD
C
          END IF
C
      END IF
C
C=======================================================================
C         READING THE ANGULAR-MOMENTUM-PROJECTION (AMP) AND THE GCM
C         PARAMATERS
C=======================================================================
C         FOR IPRGCM = 0         NO    GCM CALCULATION IS PERFORMED
C         FOR IPRGCM = 1      DIAGONAL GCM CALCULATION IS PERFORMED
C         FOR IPRGCM = 2  NON-DIAGONAL GCM CALCULATION IS PERFORMED
C
C         NUAKNO (NUBKNO) ARE NUMBERS OF GAUSS POINTS THAT ARE USED
C         TO PERFORM INTEGRATIONS OVER ALPHA AND GAMMA (BETA) EULER
C         ANGLES IN ORDER TO REALIZE THE AMP.
C         FOR NUAKNO = 1  AND NUBKNO = 1  NO AMP IS PERFORMED
C         FOR NUAKNO = 1  AND NUBKNO <>1  THE 1D PROJECTION ON GOOD
C                                         ANGULAR    MOMENTUM    IS
C                                         PERFORMED BY ASSUMING THE
C                                         AXIAL SHAPE  AND  A  GOOD
C                                         VALUE  OF  THE   MAGNETIC
C                                         COMPONENT EQUAL TO KPROJE
C         FOR NUAKNO <>1                  THE 3D PROJECTION ON GOOD
C                                         ANGULAR    MOMENTUM    IS
C                                         PERFORMED
C
C         NBTKNO IS A NUMBER OF GAUSS POINTS THAT ARE USED TO PERFORM
C         INTEGRATION OVER  BETA_T  EULER ANGLES  IN ORDER TO REALIZE
C         ISOPIN PROJECTION (IP).
C         FOR NBTKNO = 1  NO ISOSPIN PROJECTION IS PERFORMED
C
C         IPROMI (IPROMA) ARE DOUBLED MINIMUM (MAXIMUM)  VALUES  OF
C         RANGE OF ANGULAR MOMENTA FOR WHICH THE  AMP  CALCULATIONS
C         ARE PERFORMED.
C         FOR NUAKNO = 1  AND NUBKNO = 1 THESE VALUES  ARE  IGNORED
C
C         ISOSMI (ISOSMA) ARE DOUBLED MINIMUM (MAXIMUM)  VALUES  OF
C         ISOSPIN FOR WHICH THE IP IS PERFORMED.   ISOSMI IS SET IN
C         THE FOLLOWING WAY:
C                  ISOSTZ=N-Z   AND    ISOSMI=ISOSTZ+ISOSAD
C         WHERE THE ADDITIVE PARAMETER ISOSAD IS READ IN PROJECTISO.
C
C         IFRWAV (ITOWAV) ARE THE THREE-DIGIT NUMBERS THAT ARE USED
C         TO  NAME  THE  FILES  FOR  WHICH  THE  NON-DIAGONAL   GCM
C         CALCULATION ARE PERFORMED. THE GCM KERNELS ARE CALCULATED
C         BETWEEN ALL WAVE FUNCTIONS FROM "IFRWAV" TO "ITOWAV"  AND
C         THE WAVE FUNCTION "ITOWAV".
C         FOR IPRGCM <2              THE VALUE OF IFRWAV IS IGNORED
C         FOR IPRGCM <2 AND IWRWAV=0
C                       AND ISAKER=0 THE VALUE OF ITOWAV IS IGNORED
C
C         FOR IWRWAV = 0 (1) THE  WAVE FUNCTIONS CALCULATED IN  THE
C                        CURRENT RUN ARE NOT  (ARE)  STORED IN  THE
C                        FILE WHOSE NAME STARTS FROM  "ITOWAV"  AND
C                        IS FOLLOWED BY "FILWAV".
C
C=======================================================================
C
      IF (trim(KEYWOR).EQ.'PROJECTGCM') THEN
C
          READ(NFIREA,*) IPRGCM,IPROMI,IPROMA,NUAKNO,NUBKNO,KPROJE,
     *                                        IFRWAV,ITOWAV,IWRWAV
C
      END IF
C
C=======================================================================
C         READING THE SWITCH "ISAKER" THAT DECIDES WHETHER KERNELS
C         IN FUNCTION OF EULER ANGLES ARE STORED ON DISK.
C=======================================================================
C         FOR ISAKER=1 THE CODE FIRST ATTEMPTS READING  THE  FILES
C         NXXX-LYYY-RZZZ-//FILKER, WHERE THE 3-DIGIT INTEGERS ARE:
C              XXX IS THE NUMBER OF THE "FILKER" FILE
C              YYY IS THE NUMBER OF THE  LEFT WAVE FUNCTION
C              ZZZ IS THE NUMBER OF THE RIGHT WAVE FUNCTION
C         IF A FILE LIKE THAT EXISTS, THEN THE KERNELS  STORED  IN
C         THIS FILE ARE READ AND WILL NOT BE CALCULATED. THE FILES
C         FOR ALL XXX ARE SCANNED. NEXT, THOSE KERNELS, WHICH HAVE
C         NOT BEEN FOUND ON DISK ARE CALCULATED AND STORES IN  THE
C         FILE WITH THE NEXT HIGHER AVAILABLE XXX.
C=======================================================================
C
      IF (trim(KEYWOR).EQ.'SAVEKERNEL') THEN
C
          READ(NFIREA,*) ISAKER
C
      END IF
C
C=======================================================================
C         READING THE SWITCH "ICHKER" THAT SUSPENDS THE COMPARISON
C         OF NAMES OF KERNEL FILES WITH THE RECOREDED NAMES.
C=======================================================================
C
      IF (trim(KEYWOR).EQ.'CHECKERNEL') THEN
C
          READ(NFIREA,*) ICHKER
C
      END IF
C
C=======================================================================
C         READING THE NUBERS OF ALPHA AND GAMMA KNOTS FOR PARALLEL
C         CALCULATIONS
C=======================================================================
C         FOR IPAKER=1 CALCULATIONS OF KERNELS ARE ERFORMED ONLY:
C             FOR ALPHA KNOTS FROM NUASTA TO NUASTO
C             FOR GAMMA KNOTS FROM NUGSTA TO NUGSTO
C         AND THE INTEGRATION OF KERNELS IS SUSPENDED
C=======================================================================
C
      IF (trim(KEYWOR).EQ.'PARAKERNEL') THEN
C
          READ(NFIREA,*) IPAKER,NUASTA,NUASTO,NUGSTA,NUGSTO
C
      END IF
C
C=======================================================================
C         READING THE NUBERS OF BETA AND GAUGE KNOTS FOR PARALLEL
C         CALCULATIONS
C=======================================================================
C         FOR IPAKER=1 AND IPAALL=1 CALCULATIONS OF KERNELS ARE ERFORMED
C         ONLY:
C             FOR BETA  KNOTS FROM NUBSTA TO NUBSTO
C             FOR GAUGE KNOTS FROM NUTSTA TO NUTSTO
C         AND THE INTEGRATION OF KERNELS IS SUSPENDED
C=======================================================================
C
      IF (trim(KEYWOR).EQ.'PARA_ALL') THEN
C
          READ(NFIREA,*) IPAALL,NUBSTA,NUBSTO,NUTSTA,NUTSTO
C
      END IF
C
C=======================================================================
C         READING THE NUBER OF THE KERNEL FILE TO BE USED
C=======================================================================
C
      IF (trim(KEYWOR).EQ.'NUMBKERNEL') THEN
C
          READ(NFIREA,*) KFIKER
C
      END IF
C
C=======================================================================
C         READING THE OVERLAP CUTOFF PARAMATERS
C=======================================================================
C         FOR ICUTOV=0 PARAMETERS CUTOVE AND CUTOVF ARE IGNORED AND THE
C                      COLLECTIVE STATES FOR THE  K-MIXING  CALCULATION
C                      ARE SELECTED BY  THEIR  NORM  EIGENVALUES  BEING
C                      LARGER THAN "OVEMIN",  WHICH  IS  EQUAL  TO  THE
C                      NEGATIVE OF THE SMALLEST NORM EIGENVALUE.
C         FOR ICUTOV=1 THE   COLLECTIVE   STATES   FOR   THE   K-MIXING
C                      CALCULATION  ARE   SELECTED   BY    THEIR   NORM
C                      EIGENVALUES BEING LARGER THAN:
C                                    CUTOVE + CUTOVF * OVEMIN.
C=======================================================================
C
      IF (trim(KEYWOR).EQ.'CUTOVERLAP') THEN
C
          READ(NFIREA,*) ICUTOV,CUTOVE,CUTOVF
C
      END IF
C
C=======================================================================
C               READING THE ISOSPIN-PROJECTION PARAMATERS
C               AND  RECALCULATING  RANGE OF ISOSPIN LOOP
C               AT THE MOMENT LOWER BOUND OF  THE ISOSPIN
C                      LOOP IS SET TO ISOSMI=|N-Z|
C
C               IF IFERME.EQ.+1
C                    CALCULATE THE FERMI SUPERALLOWED M.E.
C                                    <Tz=+/-1|T_+/-|Tz=0>
C               IF IFERME.EQ.-1
C                    STORE  |Tz=+/-1> WAVE FUNCTION
C=======================================================================
C
      IF (trim(KEYWOR).EQ.'PROJECTISO') THEN
C
          READ(NFIREA,*) IPRGCM,ISOSAD,NBTKNO,EPSISO,ICSKIP,IFERME
C
      END IF
C
C=======================================================================
C         READING THE NUCLEON-MASS RENORMALIZATION SWITCH
C=======================================================================
C
      IF (trim(KEYWOR).EQ.'RENORMASS') THEN
C
          READ(NFIREA,*) IRENMA,DISTAX,DISTAY,DISTAZ
C
      END IF
C
C=======================================================================
C         READING THE NUCLEON-MASS RENORMALIZATION FACTORS
C=======================================================================
C
      IF (trim(KEYWOR).EQ.'TRANSLMASS') THEN
C
          READ(NFIREA,*) (HBMRIN(KARTEZ),KARTEZ=1,NDKART)
C
      END IF
C
C=======================================================================
C         READING THE NUCLEAR-INERTIA RENORMALIZATION SWITCH
C=======================================================================
C
      IF (trim(KEYWOR).EQ.'RENORINERT') THEN
C
          READ(NFIREA,*) IRENIN,ROTATX,ROTATY,ROTATZ
C
      END IF
C
C=======================================================================
C         READING THE NUCLEAR-INERTIA RENORMALIZATION FACTORS
C=======================================================================
C
      IF (trim(KEYWOR).EQ.'ROTATINERT') THEN
C
          READ(NFIREA,*) (ROTRIN(KARTEZ),KARTEZ=1,NDKART)
C
      END IF
C
C=======================================================================
C         READING THE SWITCH BETWEEN TRADITIONAL WS OR HF-BASED
C         MEAN-FIELD
C=======================================================================
C
      IF (trim(KEYWOR).EQ.'MEAN-FIELD'.OR.
     *    trim(KEYWOR).EQ.'MEAN_FIELD') THEN
C
          READ(NFIREA,*) IHFPOT
C
      END IF
C
C=======================================================================
C         READING THE GAUSSIAN OVERLAP APPROXIMATION (GOA) SWITCH
C=======================================================================
C
      IF (trim(KEYWOR).EQ.'GAUOVERAPP') THEN
C
          READ(NFIREA,*) IDOGOA
C
      END IF
C
C=======================================================================
C         READING THE INPUT FOR THE MIMIMIZATION OVER WS DEFORMATIONS
C=======================================================================
C
      IF (trim(KEYWOR).EQ.'DEFORMS_WS'.OR.
     *    trim(KEYWOR).EQ.'DEFORMS-WS') THEN
C
 1040     READ(NFIREA,*,END=2040) LAMBDA,MIU
C
	  NUMINP=NUMINP+1
	  LAMINP(NUMINP)=ABS(LAMBDA)
	  MIUINP(NUMINP)=MIU
C
	  IF (ABS(LAMBDA).GE.LMXINP) LMXINP=ABS(LAMBDA)
C
          IF (ABS(LAMBDA).GT.NDMULT.OR.LAMBDA.EQ.0.OR.
     *                        ABS(MIU).GT.ABS(LAMBDA))
     *
     *        STOP ' LAMBDA VALUES OUT OF RANGE IN NAMELI'
C
          IF (LAMBDA.LT.0) GO TO 1040
C
      END IF
C
      IF (KEYWOR.EQ.'STEP_MINIM'.OR.KEYWOR.EQ.'STEP-MINIM') THEN
C
          READ(NFIREA,*) STPINP,ITEINP
C
      END IF
C
C
      ! Additional deformations that will be used to optimize
      ! the WS deformation parameters (extra-push)
      IF (trim(keywor).EQ.'PUSH_DEFOR'.OR.
     *    trim(keywor).EQ.'PUSH-DEFOR') THEN
C
          N_PUSH = 0
          L_PUSH =-1
C
          DO WHILE (L_PUSH.LT.0)
C
             N_PUSH = N_PUSH + 1
C
             READ (NFIREA,*) L_PUSH, M_PUSH, Q_PUSH
C
             LAMPUS(N_PUSH) = L_PUSH
             MIUPUS(N_PUSH) = M_PUSH
             QMOPUS(N_PUSH) = Q_PUSH
C
          END DO
C
          NUMPUS=N_PUSH
C
      END IF
C
      ! Number of iterations to keep the extra constraints on
      IF (trim(KEYWOR).EQ.'PUSH_ITERS'.OR.
     *    trim(KEYWOR).EQ.'PUSH-ITERS') THEN
C
          READ(NFIREA,*) IFPUSH,NITPUS
C
      END IF
C
C=======================================================================
C
C         READING THE MULTIPOLE CONSTRAINTS:
C
C         CONSTRAINTS FOR SEVERAL VALUES OF LAMBDA AND MIU CAN BE
C         PROVIDED ON CONSECUTIVE LINES  BY  READING-IN  NEGATIVE
C         FLIPPED-SIGN VALUES OF LAMBDA FOR ALL BUT THE LAST LINE
C
C=======================================================================
C
      IF (trim(KEYWOR).EQ.'RPA_CONSTR'.OR.
     *    trim(KEYWOR).EQ.'RPA-CONSTR') THEN
C
          READ(NFIREA,*) IF_RPA
C
      END IF
C
      IF (trim(KEYWOR).EQ.'MULTCONSTR') THEN
C
 1002     READ(NFIREA,*,END=2002) LAMBDA,MIU,STIFFQ(ABS(LAMBDA),MIU),
     *                                       QASKED(ABS(LAMBDA),MIU),
     *                                       IFLAGQ(ABS(LAMBDA),MIU)
C
          IF (ABS(LAMBDA).GT.NDMULT.OR.LAMBDA.EQ.0.OR.
     *                        ABS(MIU).GT.ABS(LAMBDA))
     *
     *        STOP ' STIFFQ INDICES OUT OF RANGE IN NAMELI'
C
          IF (LAMBDA.LT.0) GO TO 1002
C
      END IF
C
C=======================================================================
C         READING THE LINEAR MULTIPOLE CONSTRAINTS
C=======================================================================
C
      IF (trim(KEYWOR).EQ.'MULTLAGRAN') THEN
C
 1020     READ(NFIREA,*,END=2020) LAMBDA,MIU,QLINEA(ABS(LAMBDA),MIU),
     *                                       IFLALQ(ABS(LAMBDA),MIU)
C
          IF (ABS(LAMBDA).GT.NDMULT.OR.LAMBDA.EQ.0.OR.
     *                        ABS(MIU).GT.ABS(LAMBDA))
     *
     *        STOP ' QLINEA INDICES OUT OF RANGE IN NAMELI'
C
          IF (LAMBDA.LT.0) GO TO 1020
C
      END IF
C
C=======================================================================
C         READING THE SURFACE-MOMENT OR SCHIFF-MOMENT CONSTRAINTS:
C=======================================================================
C
      IF (trim(KEYWOR).EQ.'SURFCONSTR'.OR.
     *    trim(KEYWOR).EQ.'SCHICONSTR') THEN
C
 1003     READ(NFIREA,*,END=2003) LAMBDA,MIU,STIFFS(ABS(LAMBDA),MIU),
     *                                       SASKED(ABS(LAMBDA),MIU),
     *                                       IFLAGS(ABS(LAMBDA),MIU)
C
          IF (ABS(LAMBDA).GT.NDMULT.OR.ABS(MIU).GT.ABS(LAMBDA))
     *
     *        STOP ' STIFFS INDICES OUT OF RANGE IN NAMELI'
C
          IF (LAMBDA.LT.0) GO TO 1003
C
      END IF
C
C=======================================================================
C         READING THE LINEAR SURFACE-MOMENT OR SCHIFF-MOMENT CONSTRAINTS
C=======================================================================
C
      IF (trim(KEYWOR).EQ.'SURFLAGRAN'.OR.
     *    trim(KEYWOR).EQ.'SCHILAGRAN') THEN
C
 1030     READ(NFIREA,*,END=2030) LAMBDA,MIU,SLINEA(ABS(LAMBDA),MIU),
     *                                       IFLALS(ABS(LAMBDA),MIU)
C
          IF (ABS(LAMBDA).GT.NDMULT.OR.ABS(MIU).GT.ABS(LAMBDA))
     *
     *        STOP ' SLINEA INDICES OUT OF RANGE IN NAMELI'
C
          IF (LAMBDA.LT.0) GO TO 1030
C
      END IF
C
C=======================================================================
C         READING THE SCALAR MULTIPOLE-MOMENT CONSTRAINTS:
C=======================================================================
C
      IF (trim(KEYWOR).EQ.'MULTCONSCA') THEN
C
 1004     READ(NFIREA,*,END=2004) LAMBDA,STIFFG(ABS(LAMBDA)),
     *                                   GASKED(ABS(LAMBDA)),
     *                                   IFLAGG(ABS(LAMBDA))
C
          IF (ABS(LAMBDA).GT.NDMULT.OR.LAMBDA.EQ.0)
     *
     *        STOP ' STIFFG INDICES OUT OF RANGE IN NAMELI'
C
          IF (LAMBDA.LT.0) GO TO 1004
C
      END IF
C
C=======================================================================
C         READING THE  ONE-DIMENSIONAL QUADRATIC SPIN CONSTRAINT
C=======================================================================
C
      IF (trim(KEYWOR).EQ.'SPINCONSTR') THEN
C
          READ(NFIREA,*) STIFFI(2),ASKEDI(2),IFLAGI(2)
C
      END IF
C
C=======================================================================
C         READING THE THREE-DIMENSIONAL QUADRATIC SPIN CONSTRAINT
C=======================================================================
C
      IF (trim(KEYWOR).EQ.'SPICON_XYZ'.OR.
     *    trim(KEYWOR).EQ.'SPICON-XYZ') THEN
C
          DO KARTEZ=1,NDKART
             READ(NFIREA,*) STIFFI(KARTEZ),ASKEDI(KARTEZ),IFLAGI(KARTEZ)
          END DO
C
      END IF
C
C=======================================================================
C         READING THE QUADRATIC CONSTRAINT ON PRODUCT OMEGA TIMES SPIN
C=======================================================================
C
      IF (trim(KEYWOR).EQ.'SPICON_OME'.OR.
     *    trim(KEYWOR).EQ.'SPICON-OME') THEN
C
          READ(NFIREA,*) STIFFA,ASKEDA,IFLAGA
C
      END IF
C
C=======================================================================
C         READING THE PARAMETER WHICH CONTROLS THE ONE-LINE PRINTOUT OF
C         ITERATION
C=======================================================================
C
      IF (trim(KEYWOR).EQ.'ONE_LINE'.OR.
     *    trim(KEYWOR).EQ.'ONE-LINE') THEN
C
          READ(NFIREA,*) I1LINE
C
      END IF
C
C=======================================================================
C         READING THE PARAMETERS WHICH CONTROL THE PRINTING IN ITERATION
C=======================================================================
C
      IF (trim(KEYWOR).EQ.'PRINT_ITER'.OR.
     *    trim(KEYWOR).EQ.'PRINT-ITER') THEN
C
          READ(NFIREA,*) IPRSTA,IPRMID,IPRSTO
C
      END IF
C
C=======================================================================
C         READING THE PARAMETERS WHICH CONTROL THE PRINTING OF NEUTRON,
C         PROTON, AND TOTAL MOMENTS
C=======================================================================
C
      IF (trim(KEYWOR).EQ.'PRINT_MOME'.OR.
     *    trim(KEYWOR).EQ.'PRINT-MOME') THEN
C
          READ(NFIREA,*) IPRI_N,IPRI_P,IPRI_T
C
      END IF
C
C=======================================================================
C         READING THE PARAMETER WHICH CONTROLS THE PRINTING OF MOMENTS
C         IN THE INTRINSIC FRAME
C=======================================================================
C
      IF (trim(KEYWOR).EQ.'PRINT_INTR'.OR.
     *    trim(KEYWOR).EQ.'PRINT-INTR') THEN
C
          READ(NFIREA,*) INTRIP
C
      END IF
C
C=======================================================================
C         READING THE PARAMETER WHICH CONTROLS THE PRINTING OF
C         SYMMETRIES OF DENSITIES
C=======================================================================
C
      IF (trim(KEYWOR).EQ.'PRINT_SYME'.OR.
     *    trim(KEYWOR).EQ.'PRINT-SYME') THEN
C
          READ(NFIREA,*) ISYMDE
C
      END IF
C
C=======================================================================
C         READING THE PARAMATERS WHICH CONTROL THE PRINTING OF
C         ANGULAR-MOMENTUM-PROJECTION RESULTS
C=======================================================================
C         ISLPRI - DOUBLED MINIMUM ANGULAR MOMENTUM, FOR WHICH RESULTS
C                  ARE PRINTED
C         ISUPRI - DOUBLED MAXIMUM ANGULAR MOMENTUM, FOR WHICH RESULTS
C                  ARE PRINTED
C=======================================================================
C         IENPRI=0 NO AVERAGE ENERGIES OR  KERNELS ARE PRINTED
C         IENPRI=1    AVERAGE ENERGIES             ARE PRINTED
C         IENPRI=2    AVERAGE ENERGIES AND KERNELS ARE PRINTED
C=======================================================================
C         ISRPRI=0(1) SUM RULES ARE NOT PRINTED (ARE PRINTED & COMPARED
C                     WITH THE HF DATA)
C         IMIPRI=0(1) K-MIXED ENERGIES ARE NOT  PRINTED  (ARE  PRINTED)
C         IKEPRI=0(1) REDUCED KERNELS BETWEEN THE AMP  STATES  ARE  NOT
C                     PRINTED (ARE PRINTED)
C         IRMPRI=0(1) REDUCED MATRIX ELEMENTS BETWEEN THE K-MIXED STATES
C                     ARE NOT PRINTED (ARE PRINTED)
C=======================================================================
C
      IF (trim(KEYWOR).EQ.'PRINT_AMP'.OR.
     *    trim(KEYWOR).EQ.'PRINT-AMP') THEN
C
          READ(NFIREA,*) ISLPRI,ISUPRI,IENPRI,ISRPRI,IMIPRI,
     *                   IKEPRI,IRMPRI
C
      END IF
C
C=======================================================================
C         READING THE PARAMETER WHICH CONTROLS THE PRINTING OF SYMMETRY
C         VIOLATING TERMS
C=======================================================================
C
      IF (trim(KEYWOR).EQ.'PRINT_VIOL'.OR.
     *    trim(KEYWOR).EQ.'PRINT-VIOL') THEN
C
          READ(NFIREA,*) IVIPRI
C
      END IF
C
C=======================================================================
C         READING THE PARAMETER WHICH CONTROLS THE TYPE OF NILSSON
C         LABELS THAT WILL BE PRINTED FOR  SINGLE-PARTICLE  STATES
C=======================================================================
C
      IF (trim(KEYWOR).EQ.'NILSSONLAB') THEN
C
          READ(NFIREA,*) NILXYZ
C
      END IF
C
C=======================================================================
C         READING THE ENERGY  RANGE FOR ONE COMMON BLOCK OF ALL
C                                      SINGLE-PARTICLE ENERGIES
C=======================================================================
C
      IF (trim(KEYWOR).EQ.'EALLMINMAX') THEN
C
          READ(NFIREA,*) EMINAL,EMAXAL
C
      END IF
C
C=======================================================================
C         READING THE MAXIMUM QUASIPARTICLE ENERGY FOR PRINTING THE LIST
C                                     OF SINGLE-QUASIPARTICLE PROPERTIES
C=======================================================================
C
      IF (trim(KEYWOR).EQ.'EQUASI_MAX'.OR.
     *    trim(KEYWOR).EQ.'EQUASI-MAX') THEN
C
          READ(NFIREA,*) EMAXQU
C
      END IF
C
C=======================================================================
C         READING THE NAME OF FILE CONTAINING THE REVIEW OF RESULTS
C=======================================================================
C
      IF (trim(KEYWOR).EQ.'REVIEWFILE') THEN
C
          READ(NFIREA,'(12X,A68)') FILREV
C
      END IF
C
C=======================================================================
C         READING THE PARAMETER WHICH HANDLES THE REVIEW FILE
C=======================================================================
C
      IF (trim(KEYWOR).EQ.'REVIEW') THEN
C
          READ(NFIREA,*) IREVIE
C
      END IF
C
C=======================================================================
C         READING THE FLAG THAT DECIDES WHETHER OR NOT THE CODE WILL
C         WRITE THE RECORD FILE
C=======================================================================
C
      IF (trim(KEYWOR).EQ.'RECORDSAVE') THEN
C
          READ(NFIREA,*) IWRIRE
C
      END IF
C
C=======================================================================
C         READING THE FLAG THAT DECIDES WHETHER OR NOT THE CODE WILL
C         WRITE THE YUKAWA FILE
C=======================================================================
C
      IF (trim(KEYWOR).EQ.'YUKAWASAVE') THEN
C
          READ(NFIREA,*) IWRIYU
C
      END IF
C
C=======================================================================
C         READING THE FLAG THAT DECIDES WHETHER OR NOT THE CODE WILL
C         WRITE THE GOGNY FILE
C=======================================================================
C
      IF (trim(KEYWOR).EQ.'GOGNYSAVE') THEN
C
          READ(NFIREA,*) IWRIGO
C
      END IF
C
C=======================================================================
C         READING THE FLAG THAT DECIDES WHETHER OR NOT THE CODE WILL
C         WRITE THE LIPKIN FILE
C=======================================================================
C
      IF (trim(KEYWOR).EQ.'LIPKINSAVE') THEN
C
          READ(NFIREA,*) IWRILI
C
      END IF
C
C=======================================================================
C         READING THE FLAG THAT DECIDES WHETHER OR NOT THE CODE WILL
C         WRITE THE FIELDS FILE
C=======================================================================
C
      IF (trim(KEYWOR).EQ.'FIELD_SAVE'.OR.
     *    trim(KEYWOR).EQ.'FIELD-SAVE') THEN
C
          READ(NFIREA,*) IWRIFI
C
      END IF
C
C=======================================================================
C         READING THE FLAG THAT DECIDES WHETHER OR NOT THE CODE WILL
C         STORE OLD FIELDS ON THE RECORD FILE
C=======================================================================
C
      IF (trim(KEYWOR).EQ.'FIELD_OLD'.OR.
     *    trim(KEYWOR).EQ.'FIELD-OLD') THEN
C
          READ(NFIREA,*) IWRIOL
C
      END IF
C
C=======================================================================
C         READING THE NAME OF FILE FOR RECORDING INTERMEDIATE RESULTS
C=======================================================================
C
      IF (trim(KEYWOR).EQ.'RECORDFILE') THEN
C
          READ(NFIREA,'(12X,A68)') FILREC
C
      END IF
C
C=======================================================================
C         READING THE NAME OF FILE FOR RESTARTING THE ITERATION
C=======================================================================
C
      IF (trim(KEYWOR).EQ.'INPUT_FILE'.OR.
     *    trim(KEYWOR).EQ.'REPLAYFILE'.OR.
     *    trim(KEYWOR).EQ.'INPUT-FILE') THEN
C
          READ(NFIREA,'(12X,A68)') FILREP
C
      END IF
C
C=======================================================================
C         READING THE NAME OF FILE FOR RECORDING THE YUKAWA MEAN FIELDS
C=======================================================================
C
      IF (trim(KEYWOR).EQ.'RECYUKFILE') THEN
C
          READ(NFIREA,'(12X,A68)') FILYUC
C
      END IF
C
C=======================================================================
C         READING THE NAME OF FILE FOR READING THE YUKAWA MEAN FIELDS
C=======================================================================
C
      IF (trim(KEYWOR).EQ.'REPYUKFILE') THEN
C
          READ(NFIREA,'(12X,A68)') FILYUP
C
      END IF
C
C=======================================================================
C         READING THE NAME OF FILE FOR RECORDING THE GOGNY MEAN FIELDS
C=======================================================================
C
      IF (trim(KEYWOR).EQ.'RECGOGFILE') THEN
C
          READ(NFIREA,'(12X,A68)') FILGOC
C
      END IF
C
C=======================================================================
C         READING THE NAME OF FILE FOR RECORDING THE GOGNY PAIRING FIELD
C=======================================================================
C
      IF (trim(KEYWOR).EQ.'RECGPAFILE') THEN
C
          READ(NFIREA,'(12X,A68)') FILGPC
C
      END IF
C
C=======================================================================
C         READING THE NAME OF FILE FOR READING THE GOGNY PAIRING FIELD
C=======================================================================
C
      IF (trim(KEYWOR).EQ.'REPGPAFILE') THEN
C
          READ(NFIREA,'(12X,A68)') FILGPP
C
      END IF
C
C=======================================================================
C         READING THE NAME OF FILE FOR READING THE GOGNY MEAN FIELDS
C=======================================================================
C
      IF (trim(KEYWOR).EQ.'REPGOGFILE') THEN
C
          READ(NFIREA,'(12X,A68)') FILGOP
C
      END IF
C
C=======================================================================
C         READING THE NAME OF FILE FOR RECORDING THE DENSITY MATRICES
C         NEEDED FOR THE LIPKIN-NOGAMI CALCULATION
C=======================================================================
C
      IF (trim(KEYWOR).EQ.'RECLIPFILE') THEN
C
          READ(NFIREA,'(12X,A68)') FILLIC
C
      END IF
C
C=======================================================================
C         READING THE NAME OF FILE FOR READING THE DENSITY MATRICES
C         NEEDED FOR THE LIPKIN-NOGAMI CALCULATION
C=======================================================================
C
      IF (trim(KEYWOR).EQ.'REPLIPFILE') THEN
C
          READ(NFIREA,'(12X,A68)') FILLIP
C
      END IF
C
C=======================================================================
C         READING THE NAME OF FILE FOR RECORDING THE MEAN-FIELDS  ON
C         THE HARMONIC-OSCILLATOR BASIS, WHICH ARE NEEDED TO RESTART
C         THE CALCULATION
C=======================================================================
C
      IF (trim(KEYWOR).EQ.'REC_FIELDS'.OR.
     *    trim(KEYWOR).EQ.'REC-FIELDS') THEN
C
          READ(NFIREA,'(12X,A68)') FILFIC
C
      END IF
C
C=======================================================================
C         READING THE NAME OF FILE FOR  READING  THE MEAN-FIELDS  ON
C         THE HARMONIC-OSCILLATOR BASIS, WHICH ARE NEEDED TO RESTART
C         THE CALCULATION
C=======================================================================
C
      IF (trim(KEYWOR).EQ.'REP_FIELDS'.OR.
     *    trim(KEYWOR).EQ.'REP-FIELDS') THEN
C
          READ(NFIREA,'(12X,A68)') FILFIP
C
      END IF
C
C=======================================================================
C         READING THE NAME OF FILE CONTAINING THE WOODS-SAXON RESULTS
C=======================================================================
C
      IF (trim(KEYWOR).EQ.'WOODSAFILE') THEN
C
          READ(NFIREA,'(12X,A68)') FILWOO
C
      END IF
C
C=======================================================================
C         READING THE NAME OF FILE CONTAINING THE COULOMB MATRICES
C=======================================================================
C
      IF (trim(KEYWOR).EQ.'COULOMFILE') THEN
C
          READ(NFIREA,'(12X,A68)') FILCOU
C
      END IF
C
C=======================================================================
C
C         READING THE PARAMETERS WHICH HANDLE THE COULOMB FILE
C         ACCORDING TO THE FOLLOWING TABLE OF ACTIONS:
C         ------ ------  -----------------------------------------------
C         ICOULI ICOULO                       ACTIONS
C         ------ ------  -----------------------------------------------
C           0      0     NEITHER READ  NOR WRITE        THE COULOMB FILE
C           1      0             READ  AND DO NOT WRITE THE COULOMB FILE
C           0      1      DO NOT READ  AND WRITE        THE COULOMB FILE
C           1      1     GIVES AN AUTOMATED MODE AS DESCRIBED IN PRECOU:
C                        |>      READ  COULOMB FILE,  PROVIDED IT EXISTS
C                        |>                    AND CONTAINS CORRECT DATA
C                        |>  AND WRITE COULOMB FILE IF IT DOES NOT EXIST
C                        |>           OR THE DATA HAVE BEEN RECALCULATED
C
C=======================================================================
C
      IF (trim(KEYWOR).EQ.'COULOMSAVE') THEN
C
          READ(NFIREA,*) ICOULI,ICOULO
C
      END IF
C
C=======================================================================
C         READING THE NAME OF THE ISOSPIN FILE
C=======================================================================
C
      IF (trim(KEYWOR).EQ.'ISOSPIFILE') THEN
C
          READ(NFIREA,'(12X,A68)') FILISO
C
      END IF
C
      IF (trim(KEYWOR).EQ.'WRITE_ISO'.OR.
     *    trim(KEYWOR).EQ.'WRITE-ISO') THEN
C
          READ(NFIREA,*) IWRISO
C
      END IF
C
C=======================================================================
C         READING THE NAME OF FILE CONTAINING THE WAVE FUNCTIONS
C=======================================================================
C
      IF (trim(KEYWOR).EQ.'WAVEF_FILE'.OR.
     *    trim(KEYWOR).EQ.'WAVEF-FILE') THEN
C
          READ(NFIREA,'(12X,A68)') FILWAV
C
      END IF
C
C=======================================================================
C         READING THE NAME OF FILE CONTAINING THE GCM KERNELS
C=======================================================================
C
      IF (trim(KEYWOR).EQ.'KERNELFILE') THEN
C
          READ(NFIREA,'(12X,A68)') FILKER
C
      END IF
C
C=======================================================================
C         READING THE RESTART PARAMETER
C=======================================================================
C
      IF (trim(KEYWOR).EQ.'RESTART') THEN
C
          READ(NFIREA,*) ICONTI
C
      END IF
C
C=======================================================================
C         READING THE HFB PAIRING CONTINUATION PARAMETER
C=======================================================================
C
      IF (trim(KEYWOR).EQ.'CONT_PAIRI'.OR.
     *    trim(KEYWOR).EQ.'CONT-PAIRI') THEN
C
          READ(NFIREA,*) IPCONT
C
      END IF
C
C=======================================================================
C         READING THE ADJUSTABLE-ANGULAR-FREQUENCY CONTINUATION
C         PARAMETER
C=======================================================================
C
      IF (trim(KEYWOR).EQ.'CONT_OMEGA'.OR.
     *    trim(KEYWOR).EQ.'CONT-OMEGA') THEN
C
          READ(NFIREA,*) IOCONT
C
      END IF
C
C=======================================================================
C         READING THE YUKAWA-MEAN-FIELDS CONTINUATION PARAMETER
C=======================================================================
C
      IF (trim(KEYWOR).EQ.'CONTYUKAWA') THEN
C
          READ(NFIREA,*) IYCONT
C
      END IF
C
C=======================================================================
C         READING THE GOGNY-MEAN-FIELDS CONTINUATION PARAMETER
C=======================================================================
C
      IF (trim(KEYWOR).EQ.'CONTGOGNY') THEN
C
          READ(NFIREA,*) IGCONT
C
      END IF
C
      IF (trim(KEYWOR).EQ.'CONTGOGPAI') THEN
C
          READ(NFIREA,*) IGPCON
C
      END IF
C
C=======================================================================
C         READING THE LIPKIN-NOGAMI CONTINUATION PARAMETER
C=======================================================================
C
      IF (trim(KEYWOR).EQ.'CONTLIPKIN') THEN
C
          READ(NFIREA,*) ILCONT
C
      END IF
C
C=======================================================================
C         READING THE CM CORRECTION CONTINUATION PARAMETER
C=======================================================================
C
      IF (trim(KEYWOR).EQ.'CONTCMCORR') THEN
C
          READ(NFIREA,*) IMCONT
C
      END IF
C
C=======================================================================
C         READING THE ROTATIONAL CORRECTION CONTINUATION PARAMETER
C=======================================================================
C
      IF (trim(KEYWOR).EQ.'CONTROTCOR') THEN
C
          READ(NFIREA,*) IRCONT
C
      END IF
C
C=======================================================================
C         READING THE LINEAR-CONSTRAINT CONTINUATION PARAMETER FOR
C         THE AUGMENTED LAGRANGE METHOD
C=======================================================================
C
      IF (trim(KEYWOR).EQ.'CONTAUGMEN') THEN
C
          READ(NFIREA,*) IACONT
C
      END IF
C
C=======================================================================
C         READING THE FIELDS CONTINUATION PARAMETER
C=======================================================================
C
      IF (trim(KEYWOR).EQ.'CONTFIELDS') THEN
C
          READ(NFIREA,*) IFCONT
C
      END IF
C
C=======================================================================
C         READING THE WOODS-SAXON-FILE PARAMETER
C=======================================================================
C
      IF (trim(KEYWOR).EQ.'READ_WOODS'.OR.
     *    trim(KEYWOR).EQ.'READ-WOODS') THEN
C
          READ(NFIREA,*) IREAWS
C
      END IF
C
C=======================================================================
C         READING THE NILSSON MODEL PARAMETERS
C=======================================================================
C
      IF (trim(KEYWOR).EQ.'NILSSONPAR') THEN
C
          READ(NFIREA,*) NILDAT,CNILSN,DNILSN,CNILSP,DNILSP,
     *                                 HBANIX,HBANIY,HBANIZ
C
      END IF
C
C=======================================================================
C         READY TO RUN ?
C=======================================================================
C
      IF (trim(KEYWOR).EQ.'EXECUTE') THEN
C
          NO_RUN=NO_RUN+1
C
          RETURN
C
      END IF
C
C=======================================================================
C         ALL DONE ?
C=======================================================================
C
      IF (trim(KEYWOR).EQ.'ALL_DONE'.OR.
     *    trim(KEYWOR).EQ.'ALL-DONE') THEN
C
          GO TO 2
C
      END IF
C
C=======================================================================
C        SCANNING CONTINUES ...
C=======================================================================
C
      GO TO  1
C
C=======================================================================
C        EOF IN THE INPUT DATA STREAM
C=======================================================================
C
    2 IF (NO_RUN.EQ.0) THEN
C
         STOP ' NO "EXECUTE" FOUND IN THE INPUT DATA STREAM (IN NAMELI)'
C
      END IF
C
      CALL CPUTIM('HFODD ',0)
C
      CALL TIMPRI
C
C=======================================================================
C         PRINTING THE DATE AND TIME
C=======================================================================
C
      CALL DATE_AND_TIME(MYDATE,MYTIME,MYZONE,MYVALU)
C
      WRITE(NFIPRI,'(                         1H*,77X,1H*,/,1H*,2X,
     *      ''EXECUTION ENDS ON '',A4,''.'',A2,''.'',A2,'' AT '',
     *                               A2,'':'',A2,'':'',A6,
     *                              31X,1H*,/,1H*,77X,1H*,/,79(1H*))')
     *
     *      MYDATE(1:4),MYDATE(5:6),MYDATE(7:8),
     *      MYTIME(1:2),MYTIME(3:4),MYTIME(5:10)
C
C=======================================================================
C
#if(USE_MPI==1)
      RETURN
#else
      STOP ' ALL DONE'
#endif
C
C=======================================================================
C
 2001 STOP ' UNEXPECTED END OF INPUT DATA AFTER THE SURFAC_DEF KEYWORD'
C
 2002 STOP ' UNEXPECTED END OF INPUT DATA AFTER THE MULTCONSTR KEYWORD'
C
 2020 STOP ' UNEXPECTED END OF INPUT DATA AFTER THE MULTLAGRAN KEYWORD'
C
 2003 STOP ' UNEXPECTED END OF INPUT DATA AFTER THE SURFCONSTR KEYWORD'
C
 2030 STOP ' UNEXPECTED END OF INPUT DATA AFTER THE SURFLAGRAN KEYWORD'
C
 2040 STOP ' UNEXPECTED END OF INPUT DATA AFTER THE DEFORMS_WS KEYWORD'
C
 2004 STOP ' UNEXPECTED END OF INPUT DATA AFTER THE MULTCONSCA KEYWORD'
C
C=======================================================================
C
      END
C
C=======================================================================
C
      SUBROUTINE RHODEP(IRHODE,PRHO_X,PRHODX,PRHOSX,POWERX)
C
C=======================================================================
C         FOR IRHODE=1  THIS SUBROUTINE CALCULATES THE VALUE OF THE
C                       SATURATION DENSITY "PRHOSX"  THAT  REPLACES
C                       STRENGTH "PRHODX" OF THE  DENSITY-DEPENDENT
C                       TERM IN THE PAIRING INTERACTION.
C         FOR IRHODE<>1 THIS SUBROUTINE CALCULATES THE VALUE OF THE
C                       STRENGTH "PRHODX" OF THE  DENSITY-DEPENDENT
C                       TERM THAT REPLACES THE  SATURATION  DENSITY
C                       "PRHOSX" IN THE PAIRING INTERACTION.
C=======================================================================
C
      IF (IRHODE.EQ.1) THEN
C
          IF (POWERX.NE.0) THEN
C
              IF (PRHODX.NE.0) THEN
C
C=======================================================================
C         AS A SECURITY MEASURE, BELOW THE ABSOLUTE VALUE IS USED
C         INSTEAD OF "-PRHO_X/PRHODX". THEREFORE, THE FORMULA  IS
C         CORRECT ONLY FOR VALUES OF PRHO_X AND PRHODX THAT  HAVE
C         OPPOSITE SIGNS.
C=======================================================================
C
                  PRHOSX=ABS(PRHO_X/PRHODX)**(1.0D0/POWERX)
C
              ELSE
C
C=======================================================================
C         AS A SECURITY MEASURE, BELOW PRHOSX IS SET TO 1 IN CASE IT
C         CANNOT BE CALCULATED BECAUSE OF VANISHING PRHODX.
C=======================================================================
C
                  PRHOSX=1.0D0
C
              END IF
C
          ELSE
C
C=======================================================================
C         AS A SECURITY MEASURE, BELOW PRHOSX IS SET TO 1 IN CASE IT
C         CANNOT BE CALCULATED BECAUSE OF VANISHING POWERX.
C=======================================================================
C
              PRHOSX=1.0D0
C
          END IF
C
      ELSE
C
          IF (POWERX.NE.0) THEN
C
              IF (PRHOSX.NE.0) THEN
C
                  PRHODX=-PRHO_X/PRHOSX**POWERX
C
              ELSE
C
C=======================================================================
C         AS A SECURITY MEASURE, BELOW PRHODX IS SET TO  LARGE  NUMBER
C         IN CASE IT CANNOT BE CALCULATED BECAUSE OF VANISHING PRHOSX.
C=======================================================================
C
                  PRHODX=-PRHO_X/1.0D-30
C
              END IF
C
          ELSE
C
C=======================================================================
C         AS A SECURITY MEASURE, BELOW PRHODX IS SET TO "-PRHO_X" IN
C         CASE IT CANNOT BE CALCULATED BECAUSE OF  VANISHING  POWERX.
C=======================================================================
C
              PRHODX=-PRHO_X
C
          END IF
C
      END IF
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE SIGREV
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      COMMON
     *       /SIGKPH/ KPPPSP(NDPAHO,0:NDISOS),KPPPSM(NDPAHO,0:NDISOS),
     *                KPPMSP(NDPAHO,0:NDISOS),KPPMSM(NDPAHO,0:NDISOS),
     *                KHPPSP(NDPAHO,0:NDISOS),KHPPSM(NDPAHO,0:NDISOS),
     *                KHPMSP(NDPAHO,0:NDISOS),KHPMSM(NDPAHO,0:NDISOS)
      COMMON
     *       /SIMKPH/ KPSIMP(NDPAHO,0:NDISOS),KPSIMM(NDPAHO,0:NDISOS),
     *                KHSIMP(NDPAHO,0:NDISOS),KHSIMM(NDPAHO,0:NDISOS)
      COMMON
     *       /SIQKPH/ KPSIQP(NDPAHO,0:NDISOS),KPSIQM(NDPAHO,0:NDISOS),
     *                KHSIQP(NDPAHO,0:NDISOS),KHSIQM(NDPAHO,0:NDISOS)
      COMMON
     *       /SIZKPH/ KPNONE(NDPAHO,0:NDISOS),
     *                KHNONE(NDPAHO,0:NDISOS)
      COMMON
     *       /SIGKVA/ KVASIG(0:NDPARI,0:NDSIGN,0:NDISOS)
      COMMON
     *       /SIMKVA/ KVASIM(         0:NDSIMP,0:NDISOS)
      COMMON
     *       /SIQKVA/ KVASIQ(0:NDPARI,         0:NDISOS)
      COMMON
     *       /K_FLIG/ KPFLIG(0:NDPARI,0:NDSIGN,0:NDISOS),
     *                KHFLIG(0:NDPARI,0:NDSIGN,0:NDISOS),
     *                KOFLIG(0:NDPARI,0:NDSIGN,0:NDISOS)
      COMMON
     *       /K_FLIM/ KPFLIM(         0:NDSIMP,0:NDISOS),
     *                KHFLIM(         0:NDSIMP,0:NDISOS),
     *                KOFLIM(         0:NDSIMP,0:NDISOS)
      COMMON
     *       /K_FLIQ/ KPFLIQ(0:NDPARI,         0:NDISOS),
     *                KHFLIQ(0:NDPARI,         0:NDISOS),
     *                KOFLIQ(0:NDPARI,         0:NDISOS)
      COMMON
     *       /K_FLIZ/ KPFLIZ(                  0:NDISOS),
     *                KHFLIZ(                  0:NDISOS),
     *                KOFLIZ(                  0:NDISOS)
      COMMON
     *       /K_FILG/ KPFILG(0:NDPARI,0:NDSIGN,0:NDISOS),
     *                KHFILG(0:NDPARI,0:NDSIGN,0:NDISOS),
     *                KOFILG(0:NDPARI,0:NDSIGN,0:NDISOS)
      COMMON
     *       /K_FILZ/ KPFILZ(                  0:NDISOS),
     *                KHFILZ(                  0:NDISOS),
     *                KOFILZ(                  0:NDISOS)
C
      COMMON
     *       /SIGNPH/ NPPPRP(NDPAHO,0:NDISOS),NPPPRM(NDPAHO,0:NDISOS),
     *                NPPMRP(NDPAHO,0:NDISOS),NPPMRM(NDPAHO,0:NDISOS),
     *                NHPPRP(NDPAHO,0:NDISOS),NHPPRM(NDPAHO,0:NDISOS),
     *                NHPMRP(NDPAHO,0:NDISOS),NHPMRM(NDPAHO,0:NDISOS)
      COMMON
     *       /SIMNPH/ NPSIMP(NDPAHO,0:NDISOS),NPSIMM(NDPAHO,0:NDISOS),
     *                NHSIMP(NDPAHO,0:NDISOS),NHSIMM(NDPAHO,0:NDISOS)
      COMMON
     *       /SIQNPH/ NPSIQP(NDPAHO,0:NDISOS),NPSIQM(NDPAHO,0:NDISOS),
     *                NHSIQP(NDPAHO,0:NDISOS),NHSIQM(NDPAHO,0:NDISOS)
      COMMON
     *       /SIZNPH/ NPNONE(NDPAHO,0:NDISOS),
     *                NHNONE(NDPAHO,0:NDISOS)
      COMMON
     *       /SIGNVA/ NVASIG(0:NDPARI,0:NDREVE,0:NDISOS)
      COMMON
     *       /SIMNVA/ NVASIM(         0:NDREVE,0:NDISOS)
      COMMON
     *       /SIQNVA/ NVASIQ(0:NDPARI,         0:NDISOS)
      COMMON
     *       /N_FLIG/ NPFLIG(0:NDPARI,0:NDREVE,0:NDISOS),
     *                NHFLIG(0:NDPARI,0:NDREVE,0:NDISOS),
     *                NOFLIG(0:NDPARI,0:NDREVE,0:NDISOS)
      COMMON
     *       /N_FLIM/ NPFLIM(         0:NDREVE,0:NDISOS),
     *                NHFLIM(         0:NDREVE,0:NDISOS),
     *                NOFLIM(         0:NDREVE,0:NDISOS)
      COMMON
     *       /N_FLIQ/ NPFLIQ(0:NDPARI,         0:NDISOS),
     *                NHFLIQ(0:NDPARI,         0:NDISOS),
     *                NOFLIQ(0:NDPARI,         0:NDISOS)
      COMMON
     *       /N_FLIZ/ NPFLIZ(                  0:NDISOS),
     *                NHFLIZ(                  0:NDISOS),
     *                NOFLIZ(                  0:NDISOS)
      COMMON
     *       /N_FILG/ NPFILG(0:NDPARI,0:NDREVE,0:NDISOS),
     *                NHFILG(0:NDPARI,0:NDREVE,0:NDISOS),
     *                NOFILG(0:NDPARI,0:NDREVE,0:NDISOS)
      COMMON
     *       /N_FILZ/ NPFILZ(                  0:NDISOS),
     *                NHFILZ(                  0:NDISOS),
     *                NOFILZ(                  0:NDISOS)
C
C=======================================================================
C
C         FOR CONSERVED PARITY/SIGNATURE:
C         THIS SUBROUTINE PERFORMS ALL NECESSARY OPERATIONS
C         TO CHANGE THE PARITY/SIGNATURE NOTATION INTO  THE
C         PARITY/TIME-REVERSAL NOTATION.
C
C         FOR CONSERVED SIMPLEX, CONSERVED PARITY, OR NO SYMMETRY:
C         THIS SUBROUTINE COPIES THE INPUT DATA INTO ANOTHER
C         ARRAYS. THIS IS DONE ONLY TO  KEEP  A  CONSISTENCY
C         WITH THE CASE OF PARITY/SIGNATURE SYMMETRY.
C
C=======================================================================
C         FOR CONSERVED PARITY/SIGNATURE:
C         THE PROGRAM WORKS BY USING TWO BLOCKS DENOTED  BY  IREVER.
C         THE BLOCK FOR IREVER=1 IS OBTAINED BY THE TIME-REVERSAL OF
C         THE BLOCK FOR IREVER=0.
C=======================================================================
C
C         THE BLOCK IREVER=0 CORRESPONDS TO: TIME-FORWARD  AND
C                                            Y-SIMPLEX=+i
C         THE BLOCK IREVER=1 CORRESPONDS TO: TIME-BACKWARD AND
C                                            Y-SIMPLEX=-i
C
C         THE SIMPLEX IS DEFINED ACCORDING TO THE COPENHAGEN CONVENTION
C                         SY=EXP(-i*PI*JY)*PARITY
C         THE |T+> STATES OF THE T-BASIS HAVE THEN SY=+i
C         THE |T-> STATES OF THE T-BASIS HAVE THEN SY=-i
C
C         CONFIGURATIONS ARE DEFINED IN TERMS OF    PARITY
C                                            AND    SIGNATURE RY
C         SIMPLEX IS EQUAL TO THE PRODUCT SY=RY*PARITY AND THEREFORE:
C
C                                       *********************
C         THE BLOCK IREVER=0 CONTAINS   * (RY=+i,PARITY=+1) * AND
C                                       * (RY=-i,PARITY=-1) *
C                                       *********************
C         THE BLOCK IREVER=1 CONTAINS   * (RY=-i,PARITY=+1) * AND
C                                       * (RY=+i,PARITY=-1) *
C                                       *********************
C
C=======================================================================
C         HERE WE TRANSFORM THE PARITY-SIGNATURE NOTATION INTO
C         THE IREVER CONVENTION. THIS IS REALIZED BY EXCHANGING
C         THE VALUES FOR TWO SIGNATURES IN THE NEGATIVE PARITY.
C=======================================================================
C         ARRAYS KVASIG, K_P_S_, AND K_FLIG CONCERN PARITY-SIGNATURE
C         ARRAYS NVASIG, N_P_R_, AND N_FLIG CONCERN PARITY-IREVER
C=======================================================================
C         VACUUM CONFIGURATION:
C=======================================================================
C
      NVASIG(0,0,0)=KVASIG(0,0,0)
      NVASIG(0,1,0)=KVASIG(0,1,0)
      NVASIG(1,0,0)=KVASIG(1,1,0)
      NVASIG(1,1,0)=KVASIG(1,0,0)
C
      NVASIG(0,0,1)=KVASIG(0,0,1)
      NVASIG(0,1,1)=KVASIG(0,1,1)
      NVASIG(1,0,1)=KVASIG(1,1,1)
      NVASIG(1,1,1)=KVASIG(1,0,1)
C
C=======================================================================
C         PARTICLE-HOLE CONFIGURATIONS:
C=======================================================================
C
      DO NUPAHO=1,NDPAHO
         DO ICHARG=0,NDISOS
C
            NPPPRP(NUPAHO,ICHARG) = KPPPSP(NUPAHO,ICHARG)
            NPPPRM(NUPAHO,ICHARG) = KPPPSM(NUPAHO,ICHARG)
            NPPMRP(NUPAHO,ICHARG) = KPPMSM(NUPAHO,ICHARG)
            NPPMRM(NUPAHO,ICHARG) = KPPMSP(NUPAHO,ICHARG)
C
            NHPPRP(NUPAHO,ICHARG) = KHPPSP(NUPAHO,ICHARG)
            NHPPRM(NUPAHO,ICHARG) = KHPPSM(NUPAHO,ICHARG)
            NHPMRP(NUPAHO,ICHARG) = KHPMSM(NUPAHO,ICHARG)
            NHPMRM(NUPAHO,ICHARG) = KHPMSP(NUPAHO,ICHARG)
C
         END DO
      END DO
C
C=======================================================================
C         DIABATIC BLOCKING CONFIGURATIONS:
C=======================================================================
C
      DO IPARIT=0,NDPARI
         DO ISIGNA=0,NDSIGN
            DO ICHARG=0,NDISOS
C
               IREVER=ISIGNA*(1-IPARIT)+(1-ISIGNA)*IPARIT
C
               NPFLIG(IPARIT,IREVER,ICHARG)=KPFLIG(IPARIT,ISIGNA,ICHARG)
               NHFLIG(IPARIT,IREVER,ICHARG)=KHFLIG(IPARIT,ISIGNA,ICHARG)
               NOFLIG(IPARIT,IREVER,ICHARG)=KOFLIG(IPARIT,ISIGNA,ICHARG)
C
            END DO
         END DO
      END DO
C
C=======================================================================
C         FILLING CONFIGURATIONS:
C=======================================================================
C
      DO IPARIT=0,NDPARI
         DO ISIGNA=0,NDSIGN
            DO ICHARG=0,NDISOS
C
               IREVER=ISIGNA*(1-IPARIT)+(1-ISIGNA)*IPARIT
C
               NPFILG(IPARIT,IREVER,ICHARG)=KPFILG(IPARIT,ISIGNA,ICHARG)
               NHFILG(IPARIT,IREVER,ICHARG)=KHFILG(IPARIT,ISIGNA,ICHARG)
               NOFILG(IPARIT,IREVER,ICHARG)=KOFILG(IPARIT,ISIGNA,ICHARG)
C
            END DO
         END DO
      END DO
C
C=======================================================================
C         HERE WE COPY THE ARRAYS CONCERNING THE SIMPLEX NOTATION
C         INTO THE ARRAYS CONCERNING THE  IREVER  CONVENTION.
C         THIS IS DONE ONLY TO KEEP THE CONSISTENCY WITH THE
C         PARITY/SIGNATURE CASE.
C=======================================================================
C         ARRAYS KVASIM, K_SIM_, AND K_FLIM CONCERN SIMPLEX
C         ARRAYS NVASIM, N_SIM_, AND N_FLIM CONCERN TIME-REVERSAL
C=======================================================================
C         VACUUM CONFIGURATION:
C=======================================================================
C
      NVASIM(0,0)=KVASIM(0,0)
      NVASIM(1,0)=KVASIM(1,0)
C
      NVASIM(0,1)=KVASIM(0,1)
      NVASIM(1,1)=KVASIM(1,1)
C
C=======================================================================
C         PARTICLE-HOLE CONFIGURATIONS:
C=======================================================================
C
      DO NUPAHO=1,NDPAHO
         DO ICHARG=0,NDISOS
C
            NPSIMP(NUPAHO,ICHARG) = KPSIMP(NUPAHO,ICHARG)
            NPSIMM(NUPAHO,ICHARG) = KPSIMM(NUPAHO,ICHARG)
C
            NHSIMP(NUPAHO,ICHARG) = KHSIMP(NUPAHO,ICHARG)
            NHSIMM(NUPAHO,ICHARG) = KHSIMM(NUPAHO,ICHARG)
C
         END DO
      END DO
C
C=======================================================================
C         DIABATIC BLOCKING CONFIGURATIONS:
C=======================================================================
C
      DO ISIMPL=0,NDSIMP
         DO ICHARG=0,NDISOS
C
            IREVER=ISIMPL
C
            NPFLIM(IREVER,ICHARG)=KPFLIM(ISIMPL,ICHARG)
            NHFLIM(IREVER,ICHARG)=KHFLIM(ISIMPL,ICHARG)
            NOFLIM(IREVER,ICHARG)=KOFLIM(ISIMPL,ICHARG)
C
         END DO
      END DO
C
C=======================================================================
C         HERE WE COPY THE ARRAYS CONCERNING THE CASE  OF  NON-CONSERVED
C         SIMPLEX AND CONSERVED PARITY. THIS IS DONE ONLY  TO  KEEP  THE
C         CONSISTENCY WITH THE PARITY/SIGNATURE CASE.
C=======================================================================
C=======================================================================
C         VACUUM CONFIGURATION:
C=======================================================================
C
      NVASIQ(0,0)=KVASIQ(0,0)
      NVASIQ(1,0)=KVASIQ(1,0)
C
      NVASIQ(0,1)=KVASIQ(0,1)
      NVASIQ(1,1)=KVASIQ(1,1)
C
C=======================================================================
C         PARTICLE-HOLE CONFIGURATIONS:
C=======================================================================
C
      DO NUPAHO=1,NDPAHO
         DO ICHARG=0,NDISOS
C
            NPSIQP(NUPAHO,ICHARG) = KPSIQP(NUPAHO,ICHARG)
            NPSIQM(NUPAHO,ICHARG) = KPSIQM(NUPAHO,ICHARG)
C
            NHSIQP(NUPAHO,ICHARG) = KHSIQP(NUPAHO,ICHARG)
            NHSIQM(NUPAHO,ICHARG) = KHSIQM(NUPAHO,ICHARG)
C
         END DO
      END DO
C
C=======================================================================
C         DIABATIC BLOCKING CONFIGURATIONS:
C=======================================================================
C
      DO IPARIT=0,NDPARI
         DO ICHARG=0,NDISOS
C
            NPFLIQ(IPARIT,ICHARG)=KPFLIQ(IPARIT,ICHARG)
            NHFLIQ(IPARIT,ICHARG)=KHFLIQ(IPARIT,ICHARG)
            NOFLIQ(IPARIT,ICHARG)=KOFLIQ(IPARIT,ICHARG)
C
         END DO
      END DO
C
C=======================================================================
C         HERE WE COPY THE ARRAYS CONCERNING THE CASE OF NO SYMMETRY.
C         THIS IS DONE ONLY TO KEEP THE CONSISTENCY WITH THE
C         PARITY/SIGNATURE CASE.
C=======================================================================
C=======================================================================
C         PARTICLE-HOLE CONFIGURATIONS:
C=======================================================================
C
      DO NUPAHO=1,NDPAHO
         DO ICHARG=0,NDISOS
C
            NPNONE(NUPAHO,ICHARG) = KPNONE(NUPAHO,ICHARG)
            NHNONE(NUPAHO,ICHARG) = KHNONE(NUPAHO,ICHARG)
C
         END DO
      END DO
C
C=======================================================================
C         DIABATIC BLOCKING CONFIGURATIONS:
C=======================================================================
C
      DO ICHARG=0,NDISOS
C
         NPFLIZ(ICHARG)=KPFLIZ(ICHARG)
         NHFLIZ(ICHARG)=KHFLIZ(ICHARG)
         NOFLIZ(ICHARG)=KOFLIZ(ICHARG)
C
      END DO
C
C=======================================================================
C         FILLING CONFIGURATIONS:
C=======================================================================
C
      DO ICHARG=0,NDISOS
C
         NPFILZ(ICHARG)=KPFILZ(ICHARG)
         NHFILZ(ICHARG)=KHFILZ(ICHARG)
         NOFILZ(ICHARG)=KOFILZ(ICHARG)
C
      END DO
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE RECORD(NFIREP,NFIREC,INPFLD,NUMITE,
     *                         NXHERM,NYHERM,NZHERM,
     *                                IPCONT,ILCONT,
     *                         IACONT,IMCONT,IRCONT,
     *                                IRENMA,IRENIN,
     *                                LIPKIN,LIPKIP,
     *                                REFERN,REFERP,
     *                                REDELN,REDELP,
     *                                REFE2N,REFE2P,
     *                                IFIBLN,INIBLN,
     *                                IFIBLP,INIBLP,
     *                                NMUMAX,NSIMAX,
     *                                NMUCON,ISHIFT,
     *                                       IERROR)
C=======================================================================
      USE HE_DEN
      USE VE_FLD
      USE WD_FLD
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      integer :: currentVersion, minimalVersion
C
      COMPLEX
     *          WAVBLO,C_ZERO
C
      DIMENSION
     *          DPRRHO(NDXHRM,NDYHRM,NDZHRM),
     *          DNRRHO(NDXHRM,NDYHRM,NDZHRM)
      DIMENSION
     *          VNRMAS(NDXHRM,NDYHRM,NDZHRM),
     *          VNRCEN(NDXHRM,NDYHRM,NDZHRM),
     *          VNRKIS(NDXHRM,NDYHRM,NDZHRM,NDKART),
     *          VNRSPI(NDXHRM,NDYHRM,NDZHRM,NDKART),
     *          VNRCUR(NDXHRM,NDYHRM,NDZHRM,NDKART),
     *          VNRSOR(NDXHRM,NDYHRM,NDZHRM,NDKART,NDKART),
     *          VPRMAS(NDXHRM,NDYHRM,NDZHRM),
     *          VPRCEN(NDXHRM,NDYHRM,NDZHRM),
     *          VPRKIS(NDXHRM,NDYHRM,NDZHRM,NDKART),
     *          VPRSPI(NDXHRM,NDYHRM,NDZHRM,NDKART),
     *          VPRCUR(NDXHRM,NDYHRM,NDZHRM,NDKART),
     *          VPRSOR(NDXHRM,NDYHRM,NDZHRM,NDKART,NDKART)
C
      COMMON
     *       /DATPAN/ GPAIRN,FACTGN,EFERMN,DELTAN,EFER2N
     *       /DATPAP/ GPAIRP,FACTGP,EFERMP,DELTAP,EFER2P
      COMMON
     *       /ANGANG/ ANGU_N(1:NDKART),ANGU_P(1:NDKART),ANGU_T(1:NDKART)
      COMMON
     *       /ANGSPI/ SPIN_N(1:NDKART),SPIN_P(1:NDKART),SPIN_T(1:NDKART)
      COMMON
     *       /QMULTI/ QMUL_N(0:NDMULT,-NDMULT:NDMULT),
     *                QMUL_P(0:NDMULT,-NDMULT:NDMULT),
     *                QMUL_T(0:NDMULT,-NDMULT:NDMULT)
      COMMON
     *       /SMULTI/ SMUL_N(0:NDMULT,-NDMULT:NDMULT),
     *                SMUL_P(0:NDMULT,-NDMULT:NDMULT),
     *                SMUL_T(0:NDMULT,-NDMULT:NDMULT)
      COMMON
     *       /LINMOM/ DLINSN(0:NDKART),DLINSP(0:NDKART),DLINST(0:NDKART)
     *               ,ELINSN(0:NDKART),ELINSP(0:NDKART),ELINST(0:NDKART)
     *               ,TLINSN(0:NDKART),TLINSP(0:NDKART),TLINST(0:NDKART)
     *               ,ALINLN(0:NDKART),ALINLP(0:NDKART),ALINLT(0:NDKART)
      COMMON
     *       /ROTMOM/ DROTSN(0:NDKART),DROTSP(0:NDKART),DROTST(0:NDKART)
     *               ,EROTSN(0:NDKART),EROTSP(0:NDKART),EROTST(0:NDKART)
     *               ,TROTSN(0:NDKART),TROTSP(0:NDKART),TROTST(0:NDKART)
     *               ,AROTLN(0:NDKART),AROTLP(0:NDKART),AROTLT(0:NDKART)
      COMMON
     *       /QLASTR/ GALMUQ(0:NDMULT,-NDMULT:NDMULT),
     *                QLINEA(0:NDMULT,-NDMULT:NDMULT),
     *                IFLALQ(0:NDMULT,-NDMULT:NDMULT)
      COMMON
     *       /SLASTR/ GALMUS(0:NDMULT,-NDMULT:NDMULT),
     *                SLINEA(0:NDMULT,-NDMULT:NDMULT),
     *                IFLALS(0:NDMULT,-NDMULT:NDMULT)
      COMMON
     *       /RLASTR/ RALMUQ(0:NDMULT,-NDMULT:NDMULT),
     *                RALMUS(0:NDMULT,-NDMULT:NDMULT)
      COMMON
     *       /PAIINI/ FERINI(0:NDISOS),DELINI(0:NDISOS),FE2INI(0:NDISOS)
      COMMON
     *       /SHIFTR/ RSHIFT(1:NDKART)
      COMMON
     *       /BLOWAV/ WAVBLO(1:NDBASE,0:NDISOS,0:NDREVE)
      COMMON
     *       /BLODEF/ IDEBLO(0:NDISOS)
      COMMON
     *       /RENORM/ HBMREN(NDKART)
      COMMON
     *       /RENROT/ ROTREN(NDKART)
      COMMON
     *       /REAORM/ HBMREA(NDKART)
      COMMON
     *       /REAROT/ ROTREA(NDKART)
      COMMON
     *       /DIMENS/ LDBASE
      COMMON
     *       /CFIPRI/ NFIPRI
C@@@ NECK - NECK - NECK - NECK - NECK - NECK - NECK - NECK - NECK
      COMMON
     *       /NCKVAL/ Q0NECK,G_NECK
     *       /NCKFLA/ IFNECK
C@@@ NECK - NECK - NECK - NECK - NECK - NECK - NECK - NECK - NECK
C
C=======================================================================
C
      CALL CPUTIM('RECORD',1)
C
C=======================================================================
C
      C_ZERO=CMPLX(0.0D0,0.0D0)
C
      currentVersion = 14
      minimalVersion =  4
C
C=======================================================================
C     INPFLD - IF .NE.0 => THE FILE WITH THE UNIT NUMBER  NFIREP WILL BE
C                          USED TO  R E A D  THE RESULTS OF THE PREVIOUS
C                          CALCULATION            (FROM THE UNIT NFIREP)
C=======================================================================
C
      IF (INPFLD.NE.0) THEN
C
          REWIND(UNIT=NFIREP,IOSTAT=IERROR)
          IF (IERROR.NE.0) THEN
              WRITE(NFIPRI,'(''RECORD() - ERROR IN '',
     *              ''REWINDING FILE '',i4)') NFIREP
              CALL CPUTIM('RECORD',0)
              RETURN
          END IF
C
          IFIRED=0
C
          READ (NFIREP,IOSTAT=IERROR) IVERIN
      Write(6,'(//,''VERSION NUMBER OF RECORD FILE = '',i10,//)')
     *               IVERIN
          IF (IERROR.NE.0) THEN
              WRITE(NFIPRI,'(''RECORD() - ERROR IN '',
     *              ''READING IVERIN'')')
              CALL CPUTIM('RECORD',0)
              RETURN
          END IF
C
          IF (IVERIN.GE.minimalVersion.AND.
     *        IVERIN.LE.currentVersion) THEN
C
              READ (NFIREP,IOSTAT=IERROR) NUMITE
              IF (IERROR.NE.0) THEN
                  WRITE(NFIPRI,'(''RECORD() - ERROR IN '',
     *                  ''READING NUMITE'')')
                  CALL CPUTIM('RECORD',0)
                  RETURN
              END IF
C
              READ (NFIREP,IOSTAT=IERROR) MXHERM,MYHERM,MZHERM
      Write(6,'(''NXHERM,NYHERM,NZHERM = '',3i10)')
     *           MXHERM,MYHERM,MZHERM
              IF (IERROR.NE.0) THEN
                  WRITE(NFIPRI,'(''RECORD() - ERROR IN '',
     *                  ''READING MXHERM'')')
                  CALL CPUTIM('RECORD',0)
                  RETURN
              END IF
C
              IF (MXHERM.NE.NXHERM.OR.
     *            MYHERM.NE.NYHERM.OR.
     *            MZHERM.NE.NZHERM) THEN
C
                  WRITE(NFIPRI,'(/,1X,19(1H/),
     *                          ''  WRONG NXHERM,NYHERM,NZHERM:'',
     *                3I3,2X,19(1H/),/)') MXHERM,MYHERM,MZHERM
C
                  STOP '  WRONG NXHERM,NYHERM,NZHERM IN RECORD'
C
              END IF
C
              IF (IVERIN.LT.14) THEN
C
                  READ (NFIREP,IOSTAT=IERROR)
     *                            (((VNRMAS(IX,IY,IZ),
     *                               VNRCEN(IX,IY,IZ),
     *
     *                               IX=1,NXHERM),IY=1,NYHERM),
     *                                            IZ=1,NZHERM)
                  IF (IERROR.NE.0) THEN
                      WRITE(NFIPRI,'(''RECORD() - ERROR IN '',
     *                      ''READING VNRMAS'')')
                      CALL CPUTIM('RECORD',0)
                      RETURN
                  END IF
C
                  READ (NFIREP,IOSTAT=IERROR)
     *                           ((((VNRKIS(IX,IY,IZ,L),
     *                               VNRSPI(IX,IY,IZ,L),
     *                               VNRCUR(IX,IY,IZ,L),
     *
     *                               IX=1,NXHERM),IY=1,NYHERM),
     *                                            IZ=1,NZHERM),
     *                                             L=1,NDKART)
                  IF (IERROR.NE.0) THEN
                      WRITE(NFIPRI,'(''RECORD() - ERROR IN '',
     *                      ''READING VNRKIS'')')
                      CALL CPUTIM('RECORD',0)
                      RETURN
                  END IF
C
                  READ (NFIREP,IOSTAT=IERROR)
     *                          (((((VNRSOR(IX,IY,IZ,L,K),
     *
     *                               IX=1,NXHERM),IY=1,NYHERM),
     *                                            IZ=1,NZHERM),
     *                                L=1,NDKART), K=1,NDKART)
                  IF (IERROR.NE.0) THEN
                      WRITE(NFIPRI,'(''RECORD() - ERROR IN '',
     *                      ''READING VNRSOR'')')
                      CALL CPUTIM('RECORD',0)
                      RETURN
                  END IF
C
                  READ (NFIREP,IOSTAT=IERROR)
     *                            (((VPRMAS(IX,IY,IZ),
     *                               VPRCEN(IX,IY,IZ),
     *
     *                               IX=1,NXHERM),IY=1,NYHERM),
     *                                            IZ=1,NZHERM)
                  IF (IERROR.NE.0) THEN
                      WRITE(NFIPRI,'(''RECORD() - ERROR IN '',
     *                      ''READING VPRMAS'')')
                      CALL CPUTIM('RECORD',0)
                      RETURN
                  END IF
C
                  READ (NFIREP,IOSTAT=IERROR)
     *                           ((((VPRKIS(IX,IY,IZ,L),
     *                               VPRSPI(IX,IY,IZ,L),
     *                               VPRCUR(IX,IY,IZ,L),
     *
     *                               IX=1,NXHERM),IY=1,NYHERM),
     *                                            IZ=1,NZHERM),
     *                                             L=1,NDKART)
                  IF (IERROR.NE.0) THEN
                      WRITE(NFIPRI,'(''RECORD() - ERROR IN '',
     *                      ''READING VPRKIS'')')
                      CALL CPUTIM('RECORD',0)
                      RETURN
                  END IF
C
                  READ (NFIREP,IOSTAT=IERROR)
     *                          (((((VPRSOR(IX,IY,IZ,L,K),
     *
     *                               IX=1,NXHERM),IY=1,NYHERM),
     *                                            IZ=1,NZHERM),
     *                                L=1,NDKART), K=1,NDKART)
                  IF (IERROR.NE.0) THEN
                      WRITE(NFIPRI,'(''RECORD() - ERROR IN '',
     *                      ''READING VPRSOR'')')
                      CALL CPUTIM('RECORD',0)
                      RETURN
                  END IF
C
                  VE_MAS(:,:,:,0)=VNRMAS(:,:,:)
                  VE_CEN(:,:,:,0)=VNRCEN(:,:,:)
                  VE_MAS(:,:,:,1)=VPRMAS(:,:,:)
                  VE_CEN(:,:,:,1)=VPRCEN(:,:,:)
C
                  VE_KIS(:,:,:,:,0)=VNRKIS(:,:,:,:)
                  VE_SPI(:,:,:,:,0)=VNRSPI(:,:,:,:)
                  VE_CUR(:,:,:,:,0)=VNRCUR(:,:,:,:)
                  VE_KIS(:,:,:,:,1)=VPRKIS(:,:,:,:)
                  VE_SPI(:,:,:,:,1)=VPRSPI(:,:,:,:)
                  VE_CUR(:,:,:,:,1)=VPRCUR(:,:,:,:)
C
                  VE_SOR(:,:,:,:,:,0)=VNRSOR(:,:,:,:,:)
                  VE_SOR(:,:,:,:,:,1)=VPRSOR(:,:,:,:,:)
C
              ELSE
C
                  READ (NFIREP,IOSTAT=IERROR)
     *                            (((VE_MAS(IX,IY,IZ,0),
     *                               VE_CEN(IX,IY,IZ,0),
     *
     *                               IX=1,NXHERM),IY=1,NYHERM),
     *                                            IZ=1,NZHERM)
                  IF (IERROR.NE.0) THEN
                      WRITE(NFIPRI,'(''RECORD() - ERROR IN '',
     *                      ''READING VE_MAS'')')
                      CALL CPUTIM('RECORD',0)
                      RETURN
                  END IF
C
                  READ (NFIREP,IOSTAT=IERROR)
     *                           ((((VE_KIS(IX,IY,IZ,L,0),
     *                               VE_SPI(IX,IY,IZ,L,0),
     *                               VE_CUR(IX,IY,IZ,L,0),
     *
     *                               IX=1,NXHERM),IY=1,NYHERM),
     *                                            IZ=1,NZHERM),
     *                                             L=1,NDKART)
                  IF (IERROR.NE.0) THEN
                      WRITE(NFIPRI,'(''RECORD() - ERROR IN '',
     *                      ''READING VE_KIS'')')
                      CALL CPUTIM('RECORD',0)
                      RETURN
                  END IF
C
                  READ (NFIREP,IOSTAT=IERROR)
     *                          (((((VE_SOR(IX,IY,IZ,L,K,0),
     *
     *                               IX=1,NXHERM),IY=1,NYHERM),
     *                                            IZ=1,NZHERM),
     *                                L=1,NDKART), K=1,NDKART)
                  IF (IERROR.NE.0) THEN
                      WRITE(NFIPRI,'(''RECORD() - ERROR IN '',
     *                      ''READING VE_SOR'')')
                      CALL CPUTIM('RECORD',0)
                      RETURN
                  END IF
C
                  READ (NFIREP,IOSTAT=IERROR)
     *                            (((VE_MAS(IX,IY,IZ,1),
     *                               VE_CEN(IX,IY,IZ,1),
     *
     *                               IX=1,NXHERM),IY=1,NYHERM),
     *                                            IZ=1,NZHERM)
                  IF (IERROR.NE.0) THEN
                      WRITE(NFIPRI,'(''RECORD() - ERROR IN '',
     *                      ''READING VE_MAS'')')
                      CALL CPUTIM('RECORD',0)
                      RETURN
                  END IF
C
                  READ (NFIREP,IOSTAT=IERROR)
     *                           ((((VE_KIS(IX,IY,IZ,L,1),
     *                               VE_SPI(IX,IY,IZ,L,1),
     *                               VE_CUR(IX,IY,IZ,L,1),
     *
     *                               IX=1,NXHERM),IY=1,NYHERM),
     *                                            IZ=1,NZHERM),
     *                                             L=1,NDKART)
                  IF (IERROR.NE.0) THEN
                      WRITE(NFIPRI,'(''RECORD() - ERROR IN '',
     *                      ''READING VE_KIS'')')
                      CALL CPUTIM('RECORD',0)
                      RETURN
                  END IF
C
                  READ (NFIREP,IOSTAT=IERROR)
     *                          (((((VE_SOR(IX,IY,IZ,L,K,1),
     *
     *                               IX=1,NXHERM),IY=1,NYHERM),
     *                                            IZ=1,NZHERM),
     *                                L=1,NDKART), K=1,NDKART)
                  IF (IERROR.NE.0) THEN
                      WRITE(NFIPRI,'(''RECORD() - ERROR IN '',
     *                      ''READING VE_SOR'')')
                      CALL CPUTIM('RECORD',0)
                      RETURN
                  END IF
C
              END IF
C
              IF (IVERIN.LE.6) THEN
C
                  IF (IVERIN.GT.5) THEN
C
                      READ (NFIREP,IOSTAT=IERROR)
     *                         (((DNRRHO(IX,IY,IZ),
     *
     *                                   IX=1,NXHERM),IY=1,NYHERM),
     *                                                IZ=1,NZHERM)
                      IF (IERROR.NE.0) THEN
                          WRITE(NFIPRI,'(''RECORD() - ERROR IN '',
     *                          ''READING DNRRHO'')')
                          CALL CPUTIM('RECORD',0)
                          RETURN
                      END IF
C
                  ELSE
C
                      DO IX=1,NXHERM
                         DO IY=1,NYHERM
                            DO IZ=1,NZHERM
C
                               DNRRHO(IX,IY,IZ)=0.0D0
C
                            END DO
                         END DO
                      END DO
C
                      IF (IPCONT.EQ.1)
     *
     *                    WRITE(NFIPRI,'(/,
     *                        1X,13(1H/),'' WARNING:  THE  NEUTRON '',
     *                                   '' DENSITY HAS NOT BEEN'',
     *                                                   1X,13(1H/),/,
     *                        1X,13(1H/),'' FOUND ON THE OLD REPLAY'',
     *                                   '' FILE VERSION NO. ='',I2,
     *                                                   1X,13(1H/),/,
     *                        1X,13(1H/),'' THE HFB PAIRING CANNOT'',
     *                                   '' BE SMOOTHLY CONTINUED'',
     *                                                   1X,13(1H/),/)')
     *
     *                        IVERIN
C
                  END IF
C
                  READ (NFIREP,IOSTAT=IERROR)
     *                     (((DPRRHO(IX,IY,IZ),
     *
     *                               IX=1,NXHERM),IY=1,NYHERM),
     *                                            IZ=1,NZHERM)
                  IF (IERROR.NE.0) THEN
                      WRITE(NFIPRI,'(''RECORD() - ERROR IN '',
     *                      ''READING DPRRHO'')')
                      CALL CPUTIM('RECORD',0)
                      RETURN
                  END IF
C
                  DO IX=1,NXHERM
                     DO IY=1,NYHERM
                        DO IZ=1,NZHERM
C
                           DE_RHO(IX,IY,IZ,0)=DNRRHO(IX,IY,IZ)
                           DE_RHO(IX,IY,IZ,1)=DPRRHO(IX,IY,IZ)
C
                        END DO
                     END DO
                  END DO
C
              ELSE
C
                  READ (NFIREP,IOSTAT=IERROR)
     *                     (((DE_RHO(IX,IY,IZ,0),
     *
     *                               IX=1,NXHERM),IY=1,NYHERM),
     *                                            IZ=1,NZHERM)
                  IF (IERROR.NE.0) THEN
                      WRITE(NFIPRI,'(''RECORD() - ERROR IN '',
     *                      ''READING DN_RHO'')')
                      CALL CPUTIM('RECORD',0)
                      RETURN
                  END IF
C
                  READ (NFIREP,IOSTAT=IERROR)
     *                     (((DE_RHO(IX,IY,IZ,1),
     *
     *                               IX=1,NXHERM),IY=1,NYHERM),
     *                                            IZ=1,NZHERM)
                  IF (IERROR.NE.0) THEN
                      WRITE(NFIPRI,'(''RECORD() - ERROR IN '',
     *                      ''READING DP_RHO'')')
                      CALL CPUTIM('RECORD',0)
                      RETURN
                  END IF
C
              END IF
C
              READ (NFIREP,IOSTAT=IERROR) MMUMAX
        Write(6,'(''NMUMAX = '',i10)') NMUMAX
              IF (IERROR.NE.0) THEN
                  WRITE(NFIPRI,'(''RECORD() - ERROR IN '',
     *                  ''READING NMUMAX'')')
                  CALL CPUTIM('RECORD',0)
                  RETURN
              END IF
C
              IF (MMUMAX.LT.NMUMAX) THEN
C
                  WRITE(NFIPRI,'(
     *                 1X,20(1H/),''  WARNING:  TOO FEW MULTIPOLE'',
     *                            '' MOMENTS'',         1X,20(1H/),/
     *                 1X,20(1H/),''  FOUND ON THE REPLAY FILE. '',
     *                            ''         '',         1X,20(1H/),/
     *                 1X,20(1H/),''  REQUESTED MAXIMUM '',
     *                            '' MULTIPOLARITY='',I2,1X,20(1H/),/
     *                 1X,20(1H/),''  FOUND     MAXIMUM '',
     *                            '' MULTIPOLARITY='',I2,1X,20(1H/),/
     *                 1X,20(1H/),''  A CONSTRAINT ON A MISSING '',
     *                            ''MULTIPOLE'',         1X,20(1H/),/
     *                 1X,20(1H/),''  WILL BE  INCLUDED  ONLY  A'',
     *                            ''FTER  THE'',         1X,20(1H/),/
     *                 1X,20(1H/),''  FIRST DIAGONALIZATION IS '',
     *                            '' PERFORMED'',        1X,20(1H/),/)')
     *
     *            NMUMAX,MMUMAX
C
                  DO LAMBDA=MMUMAX+1,NMUMAX
                     DO MIU=-LAMBDA,LAMBDA
C
                        QMUL_N(LAMBDA,MIU)=0.0D0
                        QMUL_P(LAMBDA,MIU)=0.0D0
                        QMUL_T(LAMBDA,MIU)=0.0D0
C
                     END DO
                  END DO
C
              END IF
C
              READ (NFIREP,IOSTAT=IERROR) ((QMUL_N(LAMBDA,MIU),
     *                                      QMUL_P(LAMBDA,MIU),
     *                                      QMUL_T(LAMBDA,MIU),
     *
     *                        MIU=-LAMBDA,LAMBDA),LAMBDA=0,MMUMAX)
              IF (IERROR.NE.0) THEN
                  WRITE(NFIPRI,'(''RECORD() - ERROR IN '',
     *                  ''READING QMUL_N'')')
                  CALL CPUTIM('RECORD',0)
                  RETURN
              END IF
C
              DO LAMBDA=0,NSIMAX
                 DO MIU=-LAMBDA,LAMBDA
C
                    SMUL_N(LAMBDA,MIU)=0.0D0
                    SMUL_P(LAMBDA,MIU)=0.0D0
                    SMUL_T(LAMBDA,MIU)=0.0D0
C
                 END DO
              END DO
C
              IF (IVERIN.LE.4) GO TO 4
C
              READ (NFIREP,IOSTAT=IERROR) MSIMAX
              IF (IERROR.NE.0) THEN
                  WRITE(NFIPRI,'(''RECORD() - ERROR IN '',
     *                  ''READING MSIMAX'')')
                  CALL CPUTIM('RECORD',0)
                  RETURN
              END IF
C
              IF (MSIMAX.LT.NSIMAX) THEN
C
                  WRITE(NFIPRI,'(
     *                 1X,20(1H/),''  WARNING:  TOO FEW SURFACE  '',
     *                            '' MOMENTS'',         1X,20(1H/),/
     *                 1X,20(1H/),''  FOUND ON THE REPLAY FILE. '',
     *                            ''         '',         1X,20(1H/),/
     *                 1X,20(1H/),''  REQUESTED MAXIMUM '',
     *                            '' MULTIPOLARITY='',I2,1X,20(1H/),/
     *                 1X,20(1H/),''  FOUND     MAXIMUM '',
     *                            '' MULTIPOLARITY='',I2,1X,20(1H/),/
     *                 1X,20(1H/),''  A CONSTRAINT ON A MISSING '',
     *                            ''MULTIPOLE'',         1X,20(1H/),/
     *                 1X,20(1H/),''  WILL BE  INCLUDED  ONLY  A'',
     *                            ''FTER  THE'',         1X,20(1H/),/
     *                 1X,20(1H/),''  FIRST DIAGONALIZATION IS '',
     *                            '' PERFORMED'',        1X,20(1H/),/)')
     *
     *            NSIMAX,MSIMAX
C
                  DO LAMBDA=MSIMAX+1,NSIMAX
                     DO MIU=-LAMBDA,LAMBDA
C
                        SMUL_N(LAMBDA,MIU)=0.0D0
                        SMUL_P(LAMBDA,MIU)=0.0D0
                        SMUL_T(LAMBDA,MIU)=0.0D0
C
                     END DO
                  END DO
C
              END IF
C
C=======================================================================
C             ATTENTION!
C             THE CODE DOES NOT CHECK WHETHER THE SURFACE OR  SCHIFF
C             MOMENTS HAVE BEEN PREVIOUSLY STORED ON THE RECORD FILE
C             (DEPENDING ON THE PREVIOUS VALUE OF "ISCHIF")
C=======================================================================
C
              READ (NFIREP,IOSTAT=IERROR) ((SMUL_N(LAMBDA,MIU),
     *                                      SMUL_P(LAMBDA,MIU),
     *                                      SMUL_T(LAMBDA,MIU),
     *
     *                        MIU=-LAMBDA,LAMBDA),LAMBDA=0,MSIMAX)
              IF (IERROR.NE.0) THEN
                  WRITE(NFIPRI,'(''RECORD() - ERROR IN '',
     *                  ''READING SMUL_N'')')
                  CALL CPUTIM('RECORD',0)
                  RETURN
              END IF
C
    4         CONTINUE
C
              READ (NFIREP,IOSTAT=IERROR) ISHIFT,
     *                                   (RSHIFT(L),L=1,NDKART)
              IF (IERROR.NE.0) THEN
                  WRITE(NFIPRI,'(''RECORD() - ERROR IN '',
     *                  ''READING ISHIFT'')')
                  CALL CPUTIM('RECORD',0)
                  RETURN
              END IF
C
              READ (NFIREP,IOSTAT=IERROR)
     *                      (ANGU_N(L),ANGU_P(L),ANGU_T(L),
     *                       SPIN_N(L),SPIN_P(L),SPIN_T(L),L=1,NDKART)
              IF (IERROR.NE.0) THEN
                  WRITE(NFIPRI,'(''RECORD() - ERROR IN '',
     *                  ''READING ANGU_N'')')
                  CALL CPUTIM('RECORD',0)
                  RETURN
              END IF
C
              READ (NFIREP,IOSTAT=IERROR)
     *                 (((WD_CEN(IX,IY,IZ,0),
     *
     *                           IX=1,NXHERM),IY=1,NYHERM),
     *                                        IZ=1,NZHERM)
              IF (IERROR.NE.0) THEN
                  WRITE(NFIPRI,'(''RECORD() - ERROR IN '',
     *                  ''READING WN_CEN'')')
                  CALL CPUTIM('RECORD',0)
                  RETURN
              END IF
C
              READ (NFIREP,IOSTAT=IERROR)
     *                 (((WD_CEN(IX,IY,IZ,1),
     *
     *                           IX=1,NXHERM),IY=1,NYHERM),
     *                                        IZ=1,NZHERM)
              IF (IERROR.NE.0) THEN
                  WRITE(NFIPRI,'(''RECORD() - ERROR IN '',
     *                  ''READING WP_CEN'')')
                  CALL CPUTIM('RECORD',0)
                  RETURN
              END IF
C
              READ (NFIREP,IOSTAT=IERROR)
     *
     *              REFERN,REDELN,
     *              REFERP,REDELP
C
              IF (IERROR.NE.0) THEN
                  WRITE(NFIPRI,'(''RECORD() - ERROR IN '',
     *                  ''READING REFERN'')')
                  CALL CPUTIM('RECORD',0)
                  RETURN
              END IF
C
C              LN lambda_2 (IVERIN=8)
C
              IF (IVERIN.GT.7) THEN
C
                  READ (NFIREP,IOSTAT=IERROR) REFE2N,REFE2P
                  IF (IERROR.NE.0) THEN
                      WRITE(NFIPRI,'(''RECORD() - ERROR IN '',
     *                      ''READING REFE2N'')')
                      CALL CPUTIM('RECORD',0)
                      RETURN
                  END IF
C
              ELSE
C
                  REFE2N=FE2INI(0)
                  REFE2P=FE2INI(1)
C
                  IF ((LIPKIN.EQ.1.OR.LIPKIP.EQ.1).AND.ILCONT.EQ.1)
     *
     *                WRITE(NFIPRI,'(/,
     *                    1X,13(1H/),'' WARNING: THE LIPKIN-NOGAMI'',
     *                               '' LAMBDA2S HAVE NOT BEEN'',
     *                                               1X,13(1H/),/,
     *                    1X,13(1H/),'' FOUND ON THE  OLD  REPLAY '',
     *                               '' FILE  VERSION  NO. ='',I2,
     *                                               1X,13(1H/),/,
     *                    1X,13(1H/),'' THE  LN  CORRECTIONS CANNOT'',
     *                               '' BE SMOOTHLY CONTINUED'',
     *                                               1X,13(1H/),/)')
     *
     *                IVERIN
C
              END IF
C
C              Blocked state wave-function (IVERIN=9)
C
              IDEBLO(0)=0
              IDEBLO(1)=0
C
              IF (IVERIN.GT.8) THEN
C
                  READ (NFIREP,IOSTAT=IERROR)
     *
     *                 MDBASE,(IDEBLO(ICHARG),ICHARG=0,NDISOS)
                  IF (IERROR.NE.0) THEN
                      WRITE(NFIPRI,'(''RECORD() - ERROR IN '',
     *                      ''READING MDBASE'')')
                      CALL CPUTIM('RECORD',0)
                      RETURN
                  END IF
C
                  IF (MDBASE.LE.NDBASE) THEN
C
                      READ (NFIREP,IOSTAT=IERROR)
     *
     *                  (((WAVBLO(IBASE,ICHARG,IREVER),IBASE=1,MDBASE),
     *                                                ICHARG=0,NDISOS),
     *                                                IREVER=0,NDREVE)
                      IF (IERROR.NE.0) THEN
                          WRITE(NFIPRI,'(''RECORD() - ERROR IN '',
     *                          ''READING WAVBLO'')')
                          CALL CPUTIM('RECORD',0)
                          RETURN
                      END IF
C
                  ELSE
C
                      READ (NFIREP,IOSTAT=IERROR)
                      IF (IERROR.NE.0) THEN
                          WRITE(NFIPRI,'(''RECORD() - ERROR IN '',
     *                          ''READING ...nothing...'')')
                          CALL CPUTIM('RECORD',0)
                          RETURN
                      END IF
C
                  END IF
C
                  IF (((IFIBLN.EQ.1.AND.INIBLN.EQ.0).OR.
     *                 (IFIBLP.EQ.1.AND.INIBLP.EQ.0)).AND.
     *                 (MDBASE.NE.LDBASE.OR.MDBASE.GT.NDBASE)) THEN
C
                      WRITE(NFIPRI,'(/,1X,10(1H/),
     *                    '' INCOMPATIBLE DIMENSIONS FOUND'',
     *                    '' ON THE RECORD FILE:'',      1X,10(1H/),/,
     *                     1X,10(1H/),'' LDBASE='',I4,'' MDBASE='',I4,
     *                                '' NDBASE='',I4,
     *                                                   1X,10(1H/),/)')
     *                     LDBASE,MDBASE,NDBASE
C
                      STOP 'MDBASE<>LDBASE OR MDBASE>NDBASE IN RECORD'
C
                  END IF
C
              END IF
C
C              Average value <P> (IVERIN=10)
C
              IF (IVERIN.GE.10) THEN
C
                  READ (NFIREP,IOSTAT=IERROR)
     *                 (ALINLT(KARTEZ),KARTEZ=0,NDKART)
                  IF (IERROR.NE.0) THEN
                      WRITE(NFIPRI,'(''RECORD() - ERROR IN '',
     *                      ''READING ALINLT'')')
                      CALL CPUTIM('RECORD',0)
                      RETURN
                  END IF
C
              ELSE
C
                  DO KARTEZ=0,NDKART
C
                     ALINLT(KARTEZ)=0.0D0
C
                  END DO
C
                  IF (IMCONT.EQ.1)
     *
     *                WRITE(NFIPRI,'(/,
     *                    1X,13(1H/),'' WARNING: THE AVERAGE LINEAR'',
     *                               '' MOMENTA HAVE NOT BEEN'',
     *                                               1X,13(1H/),/,
     *                    1X,13(1H/),'' FOUND ON THE  OLD  REPLAY '',
     *                               '' FILE  VERSION  NO. ='',I2,
     *                                               1X,13(1H/),/,
     *                    1X,13(1H/),'' THE EXACT CM CORREC. CANNOT'',
     *                               '' BE SMOOTHLY CONTINUED'',
     *                                               1X,13(1H/),/)')
     *
     *                IVERIN
C
              END IF
C
              IF (IVERIN.GE.11) THEN
C
                  READ (NFIREP,IOSTAT=IERROR)
     *                 (AROTLT(KARTEZ),KARTEZ=0,NDKART)
                  IF (IERROR.NE.0) THEN
                      WRITE(NFIPRI,'(''RECORD() - ERROR IN '',
     *                      ''READING AROTLT'')')
                      CALL CPUTIM('RECORD',0)
                      RETURN
                  END IF
C
              ELSE
C
                  DO KARTEZ=0,NDKART
C
                     AROTLT(KARTEZ)=0.0D0
C
                  END DO
C
                  IF (IRCONT.EQ.1)
     *
     *                WRITE(NFIPRI,'(/,
     *                    1X,13(1H/),'' WARNING: THE AVERAGE ANGULAR'',
     *                               '' MOMENTA HAVE NOT BEEN'',
     *                                               1X,13(1H/),/,
     *                    1X,13(1H/),'' FOUND ON  THE  OLD  REPLAY '',
     *                               '' FILE  VERSION  NO. ='',I2,
     *                                               1X,13(1H/),/,
     *                    1X,13(1H/),'' THE EXACT ROT CORREC. CANNOT'',
     *                               '' BE SMOOTHLY CONTINUED'',
     *                                               1X,13(1H/),/)')
     *
     *                IVERIN
C
              END IF
C
C              Linear Constraints for ALM (IVERIN=12)
C
              IF (IVERIN.GE.12) THEN
C
                  READ (NFIREP,IOSTAT=IERROR) MDMULT
                  IF (IERROR.NE.0) THEN
                      WRITE(NFIPRI,'(''RECORD() - ERROR IN '',
     *                      ''READING MDMULT'')')
                      CALL CPUTIM('RECORD',0)
                      RETURN
                  END IF
C
                  IF (MDMULT.NE.NDMULT) THEN
C
                      WRITE(NFIPRI,'(
     *                 1X,20(1H/),''  WARNING: NOT ALL LINEAR'',
     *                            '' CONSTRAINTS'',      1X,20(1H/),/
     *                 1X,20(1H/),''  FOUND ON THE REPLAY FILE. '',
     *                            ''         '',         1X,20(1H/),/
     *                 1X,20(1H/),''  REQUESTED MAXIMUM '',
     *                            '' MULTIPOLARITY='',I2,1X,20(1H/),/
     *                 1X,20(1H/),''  FOUND     MAXIMUM '',
     *                            '' MULTIPOLARITY='',I2,1X,20(1H/),/
     *                 1X,20(1H/),''  A CONSTRAINT ON A MISSING '',
     *                            ''MULTIPOLE'',         1X,20(1H/),/
     *                 1X,20(1H/),''  WILL BE  INCLUDED  ONLY  A'',
     *                            ''FTER  THE'',         1X,20(1H/),/
     *                 1X,20(1H/),''  FIRST DIAGONALIZATION IS '',
     *                            '' PERFORMED'',        1X,20(1H/),/)')
     *
     *                NDMULT,MDMULT
C
                      DO LAMBDA=0,NDMULT
                         DO MIU=-LAMBDA,LAMBDA
C
                            RALMUQ(LAMBDA,MIU)=QLINEA(LAMBDA,MIU)
                            RALMUS(LAMBDA,MIU)=SLINEA(LAMBDA,MIU)
C
                         END DO
                      END DO
C
                      READ (NFIREP,IOSTAT=IERROR)
     *                              ((DUMMY,
     *                                DUMMY,
     *                                MIU=-LAMBDA,LAMBDA),
     *                                LAMBDA=0,MDMULT)
                      IF (IERROR.NE.0) THEN
                          WRITE(NFIPRI,'(''RECORD() - ERROR IN '',
     *                          ''READING DUMMY'')')
                          CALL CPUTIM('RECORD',0)
                          RETURN
                      END IF
C
                  ELSE
C
                      READ (NFIREP,IOSTAT=IERROR)
     *                              ((RALMUQ(LAMBDA,MIU),
     *                                RALMUS(LAMBDA,MIU),
     *                                MIU=-LAMBDA,LAMBDA),
     *                                LAMBDA=0,MDMULT)
                      IF (IERROR.NE.0) THEN
                          WRITE(NFIPRI,'(''RECORD() - ERROR IN '',
     *                          ''READING RALMUQ'')')
                          CALL CPUTIM('RECORD',0)
                          RETURN
                      END IF
C
                  END IF
C
              ELSE
C
                  DO LAMBDA=0,NDMULT
                     DO MIU=-LAMBDA,LAMBDA
C
                        RALMUQ(LAMBDA,MIU)=QLINEA(LAMBDA,MIU)
                        RALMUS(LAMBDA,MIU)=SLINEA(LAMBDA,MIU)
C
                     END DO
                  END DO
C
                  IF (IACONT.EQ.1)
     *
     *                WRITE(NFIPRI,'(/,
     *                    1X,13(1H/),'' WARNING: THE LINEAR CONSTRAI'',
     *                               ''NTS  H A V E  NOT BEEN'',
     *                                               1X,13(1H/),/,
     *                    1X,13(1H/),'' FOUND ON  THE  OLD  REPLAY '',
     *                               '' FILE  VERSION  NO. ='',I2,
     *                                               1X,13(1H/),/,
     *                    1X,13(1H/),'' THE EXACT AUGM.LAGRA. CANNOT'',
     *                               '' BE SMOOTHLY CONTINUED'',
     *                                               1X,13(1H/),/)')
     *
     *            IVERIN
C
              END IF
C
              IF (IVERIN.GE.13) THEN
C
                  READ (NFIREP,IOSTAT=IERROR)
     *                 (HBMREA(KARTEZ),KARTEZ=1,NDKART)
                  IF (IERROR.NE.0) THEN
                      WRITE(NFIPRI,'(''RECORD() - ERROR IN '',
     *                      ''READING HBMREA'')')
                      CALL CPUTIM('RECORD',0)
                      RETURN
                  END IF
C
C
                  READ (NFIREP,IOSTAT=IERROR)
     *                 (ROTREA(KARTEZ),KARTEZ=1,NDKART)
                  IF (IERROR.NE.0) THEN
                      WRITE(NFIPRI,'(''RECORD() - ERROR IN '',
     *                      ''READING ROTREA'')')
                      CALL CPUTIM('RECORD',0)
                      RETURN
                  END IF
C
                  IF (IMCONT.EQ.1.AND.IRENMA.GE.1) THEN
C
                      DO KARTEZ=1,NDKART
C
                         HBMREN(KARTEZ)=HBMREA(KARTEZ)
C
                      END DO
C
                  END IF
C
                  IF (IRCONT.EQ.1.AND.IRENIN.GE.1) THEN
C
                      DO KARTEZ=1,NDKART
C
                         ROTREN(KARTEZ)=ROTREA(KARTEZ)
C
                      END DO
C
                  END IF
C
              ELSE
C
                  IF (IMCONT.EQ.1.AND.IRENMA.GE.1)
     *
     *                WRITE(NFIPRI,'(/,
     *                    1X,13(1H/),'' WARNING:  THE  RENORMALIZED'',
     *                               '' MASSES  HAVE NOT BEEN'',
     *                                               1X,13(1H/),/,
     *                    1X,13(1H/),'' FOUND ON  THE  OLD  REPLAY'',
     *                               '' FILE  VERSION  NO. ='',I2,
     *                                               1X,13(1H/),/,
     *                    1X,13(1H/),'' THE EXACT CM CORREC. CANNOT'',
     *                               '' BE SMOOTHLY CONTINUED'',
     *                                               1X,13(1H/),/)')
     *
     *                IVERIN
C
                  IF (IRCONT.EQ.1.AND.IRENIN.GE.1)
     *
     *                WRITE(NFIPRI,'(/,
     *                    1X,13(1H/),'' WARNING:  THE   RENORMALIZED'',
     *                               '' INERTIA HAVE NOT BEEN'',
     *                                               1X,13(1H/),/,
     *                    1X,13(1H/),'' FOUND  ON  THE  OLD  REPLAY'',
     *                               '' FILE  VERSION  NO. ='',I2,
     *                                               1X,13(1H/),/,
     *                    1X,13(1H/),'' THE EXACT ROT CORREC. CANNOT'',
     *                               '' BE SMOOTHLY CONTINUED'',
     *                                               1X,13(1H/),/)')
     *
     *                IVERIN
C
              END IF
C
C              Linear Constraints for the neck (IVERIN=14)
C
              IF (IVERIN.GE.14) THEN
C
                  READ (NFIREP,IOSTAT=IERROR) G_NECK
                  IF (IERROR.NE.0) THEN
                      WRITE(NFIPRI,'(''RECORD() - ERROR IN '',
     *                      ''READING MDMULT'')')
                      CALL CPUTIM('RECORD',0)
                      RETURN
                  END IF
C
              ELSE
C
                  G_NECK=0.0
C
                  IF (IFNECK.GE.2)
     *
     *                WRITE(NFIPRI,'(/,
     *                1X,13(1H/),'' WARNING : THE  NECK  CONSTRAI'',
     *                           ''NTS  H A S  NOT  BEEN'',
     *                                           1X,13(1H/),/,
     *                1X,13(1H/),'' FOUND ON  THE  OLD  REPLAY '',
     *                           '' FILE  VERSION  NO. ='',I2,
     *                                           1X,13(1H/),/,
     *                1X,13(1H/),'' THE NECK CONSTRAINT CAN NOT'',
     *                           '' BE  SMOOTHLY CONTINUED'',
     *                                           1X,13(1H/),/)')
     *
     *            IVERIN
C
              END IF
C
              IFIRED=1
C
          END IF
C
          IF (IFIRED.EQ.0) THEN
C
              WRITE(NFIPRI,'(/,1X,10(1H/),
     *                  ''  CANNOT READ THE REPLAY FILE VERSION:'',
     *                  I3,2X,10(1H/),/)') IVERIN
C
              STOP '  WRONG IVERIN IN RECORD'
C
          END IF
C
          IF (IFIBLN.EQ.1.AND.INIBLN.EQ.0.AND.IDEBLO(0).NE.1) THEN
C
              WRITE(NFIPRI,'(/,
     *            1X,10(1H/),'' NEUTRON SINGLE-PARTICLE WF NOT FOUND'',
     *                       '' ON THE RECORD FILE'',   1X,10(1H/),/,
     *
     *            1X,10(1H/),'' RERUN THE BLOCKING CALCULATION WITH'',
     *                       '' INIBLN=1           '',  1X,10(1H/),/)')
C
              STOP ' NEUTRON SINGLE-PARTICLE WF NOT FOUND IN RECORD'
C
          END IF
C
          IF (IFIBLP.EQ.1.AND.INIBLP.EQ.0.AND.IDEBLO(1).NE.1) THEN
C
              WRITE(NFIPRI,'(/,
     *            1X,10(1H/),'' PROTON  SINGLE-PARTICLE WF NOT FOUND'',
     *                       '' ON THE RECORD FILE'',   1X,10(1H/),/,
     *
     *            1X,10(1H/),'' RERUN THE BLOCKING CALCULATION WITH'',
     *                       '' INIBLP=1           '',  1X,10(1H/),/)')
C
              STOP ' PROTON SINGLE-PARTICLE WF NOT FOUND IN RECORD'
C
          END IF
C
      ELSE
C
C=======================================================================
C     INPFLD - IF .EQ.0 => THE FILE WITH THE UNIT NUMBER  NFIREC WILL BE
C                          USED TO RECORD THE RESULTS OF THE CALCULATION
C=======================================================================
C
          REWIND NFIREC
C
          IVEROU=currentVersion
C
          WRITE(NFIREC) IVEROU
C
          IF (IVEROU.EQ.currentVersion) THEN
C
              WRITE(NFIREC) NUMITE
C
              WRITE(NFIREC) NXHERM,NYHERM,NZHERM
C
              WRITE(NFIREC)   (((VE_MAS(IX,IY,IZ,0),
     *                           VE_CEN(IX,IY,IZ,0),
     *
     *                           IX=1,NXHERM),IY=1,NYHERM),
     *                                        IZ=1,NZHERM)
C
              WRITE(NFIREC)  ((((VE_KIS(IX,IY,IZ,L,0),
     *                           VE_SPI(IX,IY,IZ,L,0),
     *                           VE_CUR(IX,IY,IZ,L,0),
     *
     *                           IX=1,NXHERM),IY=1,NYHERM),
     *                                        IZ=1,NZHERM),
     *                                         L=1,NDKART)
C
              WRITE(NFIREC) (((((VE_SOR(IX,IY,IZ,L,K,0),
     *
     *                           IX=1,NXHERM),IY=1,NYHERM),
     *                                        IZ=1,NZHERM),
     *                            L=1,NDKART), K=1,NDKART)
C
              WRITE(NFIREC)   (((VE_MAS(IX,IY,IZ,1),
     *                           VE_CEN(IX,IY,IZ,1),
     *
     *                           IX=1,NXHERM),IY=1,NYHERM),
     *                                        IZ=1,NZHERM)
C
              WRITE(NFIREC)  ((((VE_KIS(IX,IY,IZ,L,1),
     *                           VE_SPI(IX,IY,IZ,L,1),
     *                           VE_CUR(IX,IY,IZ,L,1),
     *
     *                           IX=1,NXHERM),IY=1,NYHERM),
     *                                        IZ=1,NZHERM),
     *                                         L=1,NDKART)
C
              WRITE(NFIREC) (((((VE_SOR(IX,IY,IZ,L,K,1),
     *
     *                           IX=1,NXHERM),IY=1,NYHERM),
     *                                        IZ=1,NZHERM),
     *                            L=1,NDKART), K=1,NDKART)
C
              WRITE(NFIREC)   (((DE_RHO(IX,IY,IZ,0),
     *
     *                           IX=1,NXHERM),IY=1,NYHERM),
     *                                        IZ=1,NZHERM)
C
              WRITE(NFIREC)   (((DE_RHO(IX,IY,IZ,1),
     *
     *                           IX=1,NXHERM),IY=1,NYHERM),
     *                                        IZ=1,NZHERM)
C
              WRITE(NFIREC) NMUMAX
C
              WRITE(NFIREC) ((QMUL_N(LAMBDA,MIU),
     *                        QMUL_P(LAMBDA,MIU),
     *                        QMUL_T(LAMBDA,MIU),
     *
     *                        MIU=-LAMBDA,LAMBDA),LAMBDA=0,NMUMAX)
C
              WRITE(NFIREC) NSIMAX
C
              WRITE(NFIREC) ((SMUL_N(LAMBDA,MIU),
     *                        SMUL_P(LAMBDA,MIU),
     *                        SMUL_T(LAMBDA,MIU),
     *
     *                        MIU=-LAMBDA,LAMBDA),LAMBDA=0,NSIMAX)
C
              WRITE(NFIREC) ISHIFT,(RSHIFT(L),L=1,NDKART)
C
              WRITE(NFIREC) (ANGU_N(L),ANGU_P(L),ANGU_T(L),
     *                       SPIN_N(L),SPIN_P(L),SPIN_T(L),L=1,NDKART)
C
              WRITE(NFIREC)   (((WD_CEN(IX,IY,IZ,0),
     *
     *                           IX=1,NXHERM),IY=1,NYHERM),
     *                                        IZ=1,NZHERM)
C
              WRITE(NFIREC)   (((WD_CEN(IX,IY,IZ,1),
     *
     *                           IX=1,NXHERM),IY=1,NYHERM),
     *                                        IZ=1,NZHERM)
C
              WRITE(NFIREC)
     *
     *              EFERMN,DELTAN,
     *              EFERMP,DELTAP
C
              WRITE(NFIREC)
     *
     *              EFER2N,EFER2P
C
              WRITE(NFIREC)
     *
     *              LDBASE,(IDEBLO(ICHARG),ICHARG=0,NDISOS)
C
              DO ICHARG=0,NDISOS
C
                 IF (IDEBLO(ICHARG).EQ.0) THEN
C
                     DO IREVER=0,NDREVE
                        DO IBASE=1,LDBASE
C
                           WAVBLO(IBASE,ICHARG,IREVER)=C_ZERO
C
                        END DO
                     END DO
C
                 END IF
C
              END DO
C
              WRITE(NFIREC)
     *
     *             (((WAVBLO(IBASE,ICHARG,IREVER),IBASE=1,LDBASE),
     *                                           ICHARG=0,NDISOS),
     *                                           IREVER=0,NDREVE)
C
              WRITE(NFIREC) (ALINLT(KARTEZ),KARTEZ=0,NDKART)
C
              WRITE(NFIREC) (AROTLT(KARTEZ),KARTEZ=0,NDKART)
C
              WRITE(NFIREC) NDMULT
C
              WRITE(NFIREC) ((GALMUQ(LAMBDA,MIU),GALMUS(LAMBDA,MIU),
     *                        MIU=-LAMBDA,LAMBDA),LAMBDA=0,NDMULT)
C
              WRITE(NFIREC) (HBMREN(KARTEZ),KARTEZ=1,NDKART)
C
              WRITE(NFIREC) (ROTREN(KARTEZ),KARTEZ=1,NDKART)
C
              WRITE(NFIREC) G_NECK
C
          END IF
C
      END IF
C
C=======================================================================
C
      CALL CPUTIM('RECORD',0)
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE RECYUK(NFIYUP,NFIYUC,INPYUK)
C=======================================================================
      USE YUKSTO
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      COMMON
     *       /CFIPRI/ NFIPRI
      COMMON
     *       /DIMENS/ LDBASE
C=======================================================================
C     INPYUK - IF .NE.0 => THE FILE WITH THE UNIT NUMBER  NFIYUP WILL BE
C                          USED TO  R E A D  THE  YUKAWA   MEAN   FIELDS
C=======================================================================
C
      IF (INPYUK.NE.0) THEN
C
C=======================================================================
C
      IALLOC=0
C
C=======================================================================
      IF (.NOT.ALLOCATED(YUKASV)) THEN
          ALLOCATE (YUKASV(NDBASE,NDBASE,0:NDKART,0:NDISOS),STAT=IALLOC)
          IF (IALLOC.NE.0) CALL NOALLO('YUKASV','RECYUK')
      END IF
C=======================================================================
C
          REWIND(UNIT=NFIYUP,IOSTAT=IERROR)
C
          IF (IERROR.NE.0) STOP 'ERROR IN REWINDING (9)'
C
          READ (NFIYUP) MDBASE
C
          IF (MDBASE.NE.LDBASE) THEN
C
              WRITE(NFIPRI,'(/,1X,10(1H/),
     *            '' INCOMPATIBLE DIMENSIONS FOUND ON THE YUKAWA FILE'',
     *                                                   1X,10(1H/),/,
     *             1X,10(1H/),'' LDBASE='',I4,'' MDBASE='',I4,
     *                                                  12X,10(1H/),/)')
     *             LDBASE,MDBASE
C
              STOP 'MDBASE.NE.LDBASE IN RECYUK'
C
          END IF
C
          READ (NFIYUP)((((YUKASV(IBRA,IKET,KARTEZ,ICHARG),
     *                                             ICHARG=0,NDISOS),
     *                                      KARTEZ=0,NDKART),
     *                                 IKET=1,LDBASE),
     *                            IBRA=1,LDBASE)
C
      ELSE
C
C=======================================================================
C     INPYUK - IF .EQ.0 => THE FILE WITH THE UNIT NUMBER  NFIYUC WILL BE
C                          USED TO  RECORD  THE   YUKAWA   MEAN   FIELDS
C=======================================================================
C
          REWIND(UNIT=NFIYUC,IOSTAT=IERROR)
C
          IF (IERROR.NE.0) STOP 'ERROR IN REWINDING (10)'
C
          WRITE(NFIYUC) LDBASE
C
          WRITE(NFIYUC)((((YUKASV(IBRA,IKET,KARTEZ,ICHARG),
     *                                             ICHARG=0,NDISOS),
     *                                      KARTEZ=0,NDKART),
     *                                 IKET=1,LDBASE),
     *                            IBRA=1,LDBASE)
C
      END IF
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE RECGOG(NFIGOP,NFIGOC,INPGOG)
C=======================================================================
      USE GOGSTO
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      COMMON
     *       /CFIPRI/ NFIPRI
      COMMON
     *       /DIMENS/ LDBASE
C=======================================================================
C     INPGOG - IF .NE.0 => THE FILE WITH THE UNIT NUMBER  NFIGOP WILL BE
C                          USED TO  R E A D  THE  GOGNY    MEAN   FIELDS
C=======================================================================
C
      IF (INPGOG.NE.0) THEN
C
          IALLOC=0
C
          IF (.NOT.ALLOCATED(GOGASV)) THEN
                  ALLOCATE (GOGASV(NDBASE,NDBASE,0:NDKART,0:NDISOS),
     *                                                 STAT=IALLOC)
              IF (IALLOC.NE.0) CALL NOALLO('GOGASV','RECGOG')
          END IF
C
          REWIND NFIGOP
C
          READ (NFIGOP) MDBASE
C
          IF (MDBASE.NE.LDBASE) THEN
C
              WRITE(NFIPRI,'(/,1X,10(1H/),
     *            '' INCOMPATIBLE DIMENSIONS FOUND ON THE GOGNY  FILE'',
     *                                                   1X,10(1H/),/,
     *             1X,10(1H/),'' LDBASE='',I4,'' MDBASE='',I4,
     *                                                  12X,10(1H/),/)')
     *             LDBASE,MDBASE
C
              STOP 'MDBASE.NE.LDBASE IN RECGOG'
C
          END IF
C
          READ (NFIGOP)((((GOGASV(IBRA,IKET,KARTEZ,ICHARG),
     *                                             ICHARG=0,NDISOS),
     *                                      KARTEZ=0,NDKART),
     *                                 IKET=1,LDBASE),
     *                            IBRA=1,LDBASE)
C
      ELSE
C
C=======================================================================
C     INPGOG - IF .EQ.0 => THE FILE WITH THE UNIT NUMBER  NFIGOC WILL BE
C                          USED TO  RECORD  THE   GOGNY    MEAN   FIELDS
C=======================================================================
C
          REWIND NFIGOC
C
          WRITE(NFIGOC) LDBASE
C
          WRITE(NFIGOC)((((GOGASV(IBRA,IKET,KARTEZ,ICHARG),
     *                                             ICHARG=0,NDISOS),
     *                                      KARTEZ=0,NDKART),
     *                                 IKET=1,LDBASE),
     *                            IBRA=1,LDBASE)
C
      END IF
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE RECGPA(NFIGPP,NFIGPC,INPGPA)
C=======================================================================
      USE GOGKAP
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      COMMON
     *       /CFIPRI/ NFIPRI
      COMMON
     *       /DIMENS/ LDBASE
C=======================================================================
C     INPGOG - IF .NE.0 => THE FILE WITH THE UNIT NUMBER  NFIGOP WILL BE
C                          USED TO  R E A D  THE  GOGNY    MEAN   FIELDS
C=======================================================================
C
      IF (INPGPA.NE.0) THEN
C
          IALLOC=0
C
          IF (.NOT.ALLOCATED(GOGCHI)) THEN
              ALLOCATE (GOGCHI(NDBASE,NDBASE,0:NDKART,0:NDISOS),
     *                                             STAT=IALLOC)
              IF (IALLOC.NE.0) CALL NOALLO('GOGCHI','RECGPA')
          END IF
C
          REWIND NFIGPP
C
          READ (NFIGPP) MDBASE
C
          IF (MDBASE.NE.LDBASE) THEN
C
              WRITE(NFIPRI,'(/,1X,10(1H/),
     *            '' INCOMPATIBLE DIMENSIONS FOUND ON THE GOGNY  FILE'',
     *                                                   1X,10(1H/),/,
     *             1X,10(1H/),'' LDBASE='',I4,'' MDBASE='',I4,
     *                                                  12X,10(1H/),/)')
     *             LDBASE,MDBASE
C
              STOP 'MDBASE.NE.LDBASE IN RECGPA'
C
          END IF
C
          READ (NFIGPP)((((GOGCHI(IBRA,IKET,KARTEZ,ICHARG),
     *                                             ICHARG=0,NDISOS),
     *                                      KARTEZ=0,NDKART),
     *                                 IKET=1,LDBASE),
     *                            IBRA=1,LDBASE)
C
      ELSE
C
C=======================================================================
C     INPGOG - IF .EQ.0 => THE FILE WITH THE UNIT NUMBER  NFIGOC WILL BE
C                          USED TO  RECORD  THE   GOGNY    MEAN   FIELDS
C=======================================================================
C
          REWIND NFIGPC
C
          WRITE(NFIGPC) LDBASE
C
          WRITE(NFIGPC)((((GOGCHI(IBRA,IKET,KARTEZ,ICHARG),
     *                                             ICHARG=0,NDISOS),
     *                                      KARTEZ=0,NDKART),
     *                                 IKET=1,LDBASE),
     *                            IBRA=1,LDBASE)
C
      END IF
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE RECFIL(NFIFIP,NFIFIC,INPFIL,ISIMPY,IPAHFB,
     *                                       NOSCIL,NUMITE,
     *                         EFERMN,EFERMP,EFER2N,EFER2P,
     *                         DELTAN,DELTAP,FCHOM0,IF_THO,
     *                                       NLIMIT,FILTHO)
C=======================================================================
      USE hfodd_interface
      USE MAF_PP
      USE MAF_PM
      USE MAP_PP
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      COMPLEX
     *          C_ZERO,CDUMMY
C
      DIMENSION
     *          ROMSCA(NDKART)
C
      CHARACTER
     *          FILTHO*30
C
      COMMON
     *       /PAIINI/ FERINI(0:NDISOS),DELINI(0:NDISOS),FE2INI(0:NDISOS)
      COMMON
     *       /QCNSTR/ STIFFQ(0:NDMULT,-NDMULT:NDMULT),
     *                QASKED(0:NDMULT,-NDMULT:NDMULT),
     *                IFLAGQ(0:NDMULT,-NDMULT:NDMULT)
      COMMON
     *       /QLASTR/ GALMUQ(0:NDMULT,-NDMULT:NDMULT),
     *                QLINEA(0:NDMULT,-NDMULT:NDMULT),
     *                IFLALQ(0:NDMULT,-NDMULT:NDMULT)
      COMMON
     *       /BASISO/ NXVECT(1:NDBASE),NYVECT(1:NDBASE),NZVECT(1:NDBASE)
      COMMON
     *       /PHYCON/ H_BARC,XMASSP,XMASSN,HBCOE2
     *       /PLANCK/ HBMASS,HBMRPA,HBMINP
      COMMON
     *       /BASPAR/ HBAROX,HBAROY,HBAROZ
      COMMON
     *       /SCALNG/ HOMSCA(NDKART)
      COMMON
     *       /CFIPRI/ NFIPRI
      COMMON
     *       /DIMENS/ LDBASE
C
      DATA
     *     IVEFIL /1/
C
C=======================================================================
C
      IALLOC=0
C
C=======================================================================
      IF (.NOT.ALLOCATED(FIL_PP)) THEN
          ALLOCATE (FIL_PP(1:NDBASE,1:NDBASE,0:NDREVE,0:NDISOS),
     *                                                      STAT=IALLOC)
          IF (IALLOC.NE.0) CALL NOALLO('FIL_PP','RECFIL')
      END IF
      IF (.NOT.ALLOCATED(FIL_PM).AND.ISIMPY.NE.1) THEN
          ALLOCATE (FIL_PM(1:NDBASE,1:NDBASE,0:NDREVE,0:NDISOS),
     *                                                      STAT=IALLOC)
          IF (IALLOC.NE.0) CALL NOALLO('FIL_PM','RECFIL')
      END IF
      IF (.NOT.ALLOCATED(FIP_PP).AND.IPAHFB.EQ.1) THEN
          ALLOCATE (FIP_PP(1:NDBASE,1:NDBASE,0:NDREVE,0:NDISOS),
     *                                                      STAT=IALLOC)
          IF (IALLOC.NE.0) CALL NOALLO('FIP_PP','RECFIL')
      END IF
C=======================================================================
C
      C_ZERO=CMPLX(0.0D0,0.0D0)
C
C=======================================================================
C     INPFIL - IF .NE.0 => THE FILE WITH THE UNIT NUMBER NFIFIP WILL  BE
C                          USED TO  R E A D  THE MEAN FIELDS
C=======================================================================
C
      IF (INPFIL.NE.0) THEN
C
C=======================================================================
C          READING THE FILE GENERATED BY HFBTHO AND UPDATING VARIOUS
C          VARIABLES SUCH AS TO GUARANTEE A SMOOTH RESTART
C=======================================================================
C
          IF (IF_THO.GE.1) THEN
C
              IFSHAP=1
              NUMITE=1
C
C              Fermi levels, LN lambda_2 and pairing gaps are output
C              of HFBTHO, and are used as educated guesses for HFODD
C              restart. BETTHO, NOSCIL have been set as HFODD inputs,
C              passed to HFBTHO, read again here. Only NLIMIT may be
C              different from what HFODD would have produced, as the
C              counting convention in subroutine base() of HFBTHO is
C              different from that of SETBAS() of HFODD.
C
              CALL ReadHFBTHO(EFERMN,EFERMP,EFER2N,EFER2P,
     *                                      DELTAN,DELTAP,
     *                        PRHO_N,PRHODN,PRHOSN,POWERN,
     *                        PRHO_P,PRHODP,PRHOSP,POWERP,
     *                        BETTHO,NOSCIL,NLIMIT,FILTHO,
     *                               B0_THO,BZ_THO,BP_THO)
C
              FERINI(0)=EFERMN
              FERINI(1)=EFERMP
              DELINI(0)=DELTAN
              DELINI(1)=DELTAP
C
              HBAROX_THO=(H_BARC/BP_THO)**2/XMASSN
              HBAROY_THO=(H_BARC/BP_THO)**2/XMASSN
              HBAROZ_THO=(H_BARC/BZ_THO)**2/XMASSN
C
              HOMSCX_THO=1.0D0/BP_THO
              HOMSCY_THO=1.0D0/BP_THO
              HOMSCZ_THO=1.0D0/BZ_THO
C
              DO LAMBDA=1,maxLambda
                 GALMUQ(LAMBDA,0)=xmultLag(LAMBDA)
                 QLINEA(LAMBDA,0)=xmultLag(LAMBDA)
              END DO
C
              DEALLOCATE(xmultLag)
C
C              Overwriting pairing force with convention from HFBTHO
C
              CALL RHODEP(2,PRHO_N,PRHODN,PRHOSN,POWERN)
              CALL RHODEP(2,PRHO_P,PRHODP,PRHOSP,POWERP)
C
              RETURN
C
          END IF
C
C=======================================================================
C         NORMAL COURSE OF RECFIL WHEN USING FIELDS TO RESTART AND
C         NO HFBTHO OPTION
C=======================================================================
C
          REWIND(UNIT=NFIFIP,IOSTAT=IERROR)
C
          IF (IERROR.NE.0) STOP 'ERROR IN REWINDING (3)'
C
          READ (NFIFIP) MVEFIL,MDBASE
C
          IF (MDBASE.NE.LDBASE) THEN
C
              WRITE(NFIPRI,'(/,1X,10(1H/),
     *            '' INCOMPATIBLE DIMENSIONS FOUND ON THE FIELDS FILE'',
     *                                                   1X,10(1H/),/,
     *             1X,10(1H/),'' MDBASE='',I4,'' LDBASE='',I4,
     *                                                  26X,10(1H/),/)')
     *             MDBASE,LDBASE
C
              STOP 'MDBASE.NE.LDBASE IN RECFIL'
C
          END IF
C
C=======================================================================
C         READING THE HARMONIC-OSCILLATOR FREQUENCIES
C=======================================================================
C
          READ (NFIFIP) RBAROX,RBAROY,RBAROZ
C
          IF (RBAROX.NE.HBAROX.OR.RBAROY.NE.HBAROY.OR.RBAROZ.NE.HBAROZ)
     *                                                              THEN
C
              WRITE(NFIPRI,'(
     *            1X,19(1H/),'' WARNING:  INCOMPATIBLE HO FREQUENCIES'',
     *                                                  1X,19(1H/),/,
     *            1X,19(1H/),''       FOUND ON THE FIELDS FILE       '',
     *                                                  1X,19(1H/),/,
     *            1X,19(1H/),''    FREQUENCY  FROM FILE  FROM CODE   '',
     *                                                  1X,19(1H/),/,
     *            1X,19(1H/),''    ---------  ---------  ---------   '',
     *                                                  1X,19(1H/),/,
     *            1X,19(1H/),''    HBAROX = '',2F11.7,  4X,19(1H/),/,
     *            1X,19(1H/),''    HBAROY = '',2F11.7,  4X,19(1H/),/,
     *            1X,19(1H/),''    HBAROZ = '',2F11.7,  4X,19(1H/),/)')
     *
     *            RBAROX,HBAROX,RBAROY,HBAROY,RBAROZ,HBAROZ
C
          END IF
C
C=======================================================================
C         READING THE HARMONIC-OSCILLATOR LENGTHS
C=======================================================================
C
          READ (NFIFIP) ROMSCA(1),ROMSCA(2),ROMSCA(3)
C
          IF (ROMSCA(1).NE.HOMSCA(1).OR.
     *        ROMSCA(2).NE.HOMSCA(2).OR.
     *        ROMSCA(3).NE.HOMSCA(3)) THEN
C
              WRITE(NFIPRI,'(
     *            1X,19(1H/),'' WARNING:  INCOMPATIBLE  H.O.  LENGTHS'',
     *                                                  1X,19(1H/),/,
     *            1X,19(1H/),''       FOUND ON THE FIELDS FILE       '',
     *                                                  1X,19(1H/),/,
     *            1X,19(1H/),''    HO LENGTH  FROM FILE  FROM CODE   '',
     *                                                  1X,19(1H/),/,
     *            1X,19(1H/),''    ---------  ---------  ---------   '',
     *                                                  1X,19(1H/),/,
     *            1X,19(1H/),''    HOMSCA-X='',2F11.7,  4X,19(1H/),/,
     *            1X,19(1H/),''    HOMSCA-Y='',2F11.7,  4X,19(1H/),/,
     *            1X,19(1H/),''    HOMSCA-Z='',2F11.7,  4X,19(1H/),/)')
     *
     *            ROMSCA(1),HOMSCA(1),
     *            ROMSCA(2),HOMSCA(2),
     *            ROMSCA(3),HOMSCA(3)
C
          END IF
C
C=======================================================================
C         READING THE BASIS QUANTUM NUMBERS
C=======================================================================
C
          I_HEAD=0
C
          DO IBASE=1,LDBASE
C
             READ (NFIFIP) MXVECT,MYVECT,MZVECT
C
             IF (MXVECT.NE.NXVECT(IBASE).OR.
     *           MYVECT.NE.NYVECT(IBASE).OR.
     *           MZVECT.NE.NZVECT(IBASE)) THEN
C
                 IF (I_HEAD.NE.1)
     *
     *               WRITE(NFIPRI,'(
     *
     *            1X,19(1H/),'' WARNING: INCOMPATIBLE QUANTUM NUMBERS'',
     *                                                  1X,19(1H/),/,
     *            1X,19(1H/),''       FOUND ON THE FIELDS FILE       '',
     *                                                  1X,19(1H/),/,
     *            1X,19(1H/),''   STATE    FROM  FILE    FROM  CODE  '',
     *                                                  1X,19(1H/),/,
     *            1X,19(1H/),''   -----    ----------    ----------  '',
     *                                                  1X,19(1H/),/,
     *            1X,19(1H/),''   IBASE    NX  NY  NZ    NX  NY  NZ  '',
     *                                                  1X,19(1H/))')
C
                 I_HEAD=1
C
                 WRITE(NFIPRI,'(
     *
     *            1X,19(1H/),I8,I6,I4,I4,I6,I4,I4,      3X,19(1H/))')
     *
     *            MXVECT,       MYVECT,       MZVECT,
     *            NXVECT(IBASE),NYVECT(IBASE),NZVECT(IBASE)
C
             END IF
C
          END DO
C
          IF (I_HEAD.EQ.1) WRITE(NFIPRI)
C
C=======================================================================
C         READING THE SYMMETRY SWITCHES
C=======================================================================
C
          READ (NFIFIP) JSIMPY,JPAHFB
C
C=======================================================================
C         READING THE MEAN FIELDS
C=======================================================================
C
          READ (NFIFIP)((((FIL_PP(IBRA,IKET,IREVER,ICHARG),
     *                                             ICHARG=0,NDISOS),
     *                                      IREVER=0,NDREVE),
     *                                 IKET=1,LDBASE),
     *                            IBRA=1,LDBASE)
C
          IF (JSIMPY.NE.1) THEN
C
              IF (ISIMPY.NE.1) THEN
C
                  READ (NFIFIP)((((FIL_PM(IBRA,IKET,IREVER,ICHARG),
     *                                                 ICHARG=0,NDISOS),
     *                                          IREVER=0,NDREVE),
     *                                     IKET=1,LDBASE),
     *                                IBRA=1,LDBASE)
C
              ELSE
C
                  READ (NFIFIP)((((CDUMMY,
     *                                                 ICHARG=0,NDISOS),
     *                                          IREVER=0,NDREVE),
     *                                     IKET=1,LDBASE),
     *                                IBRA=1,LDBASE)
C
              END IF
C
          ELSE
C
              IF (ISIMPY.NE.1) THEN
C
                  DO IBRA=1,LDBASE
                     DO IKET=1,LDBASE
                        DO IREVER=0,NDREVE
                           DO ICHARG=0,NDISOS
C
                              FIL_PM(IBRA,IKET,IREVER,ICHARG)=C_ZERO
C
                           END DO
                        END DO
                     END DO
                  END DO
C
              END IF
C
          END IF
C
C=======================================================================
C         READING THE PAIRING FIELDS
C=======================================================================
C
          IF (JPAHFB.EQ.1) THEN
C
              IF (IPAHFB.EQ.1) THEN
C
                  READ (NFIFIP)((((FIP_PP(IBRA,IKET,IREVER,ICHARG),
     *                                                 ICHARG=0,NDISOS),
     *                                          IREVER=0,NDREVE),
     *                                     IKET=1,LDBASE),
     *                                IBRA=1,LDBASE)
C
              ELSE
C
                  READ (NFIFIP)((((CDUMMY,
     *                                                 ICHARG=0,NDISOS),
     *                                          IREVER=0,NDREVE),
     *                                     IKET=1,LDBASE),
     *                                IBRA=1,LDBASE)
C
              END IF
C
          ELSE
C
              IF (IPAHFB.EQ.1) THEN
                  FIP_PP(:,:,:,:)=C_ZERO
              END IF
C
          END IF
C
      ELSE
C
C=======================================================================
C     INPFIL - IF .EQ.0 => THE FILE WITH THE UNIT NUMBER NFIFIC WILL  BE
C                          USED TO  R E C O R D  THE MEAN FIELDS
C=======================================================================
C
          REWIND(UNIT=NFIFIC,IOSTAT=IERROR)
C
          IF (IERROR.NE.0) STOP 'ERROR IN REWINDING (4)'
C
          WRITE(NFIFIC) IVEFIL,LDBASE
C
C=======================================================================
C         WRITING THE HARMONIC-OSCILLATOR FREQUENCIES
C=======================================================================
C
          WRITE(NFIFIC) HBAROX,HBAROY,HBAROZ
C
C=======================================================================
C         WRITING THE HARMONIC-OSCILLATOR LEMGTHS
C=======================================================================
C
          WRITE(NFIFIC) HOMSCA(1),HOMSCA(2),HOMSCA(3)
C
C=======================================================================
C         WRITING THE BASIS QUANTUM NUMBERS
C=======================================================================
C
          DO IBASE=1,LDBASE
C
             WRITE(NFIFIC) NXVECT(IBASE),NYVECT(IBASE),NZVECT(IBASE)
C
          END DO
C
C=======================================================================
C         WRITING THE SYMMETRY SWITCHES
C=======================================================================
C
          WRITE(NFIFIC) ISIMPY,IPAHFB
C
C=======================================================================
C         WRITING THE MEAN FIELDS
C=======================================================================
C
          WRITE(NFIFIC)((((FIL_PP(IBRA,IKET,IREVER,ICHARG),
     *                                             ICHARG=0,NDISOS),
     *                                      IREVER=0,NDREVE),
     *                                 IKET=1,LDBASE),
     *                            IBRA=1,LDBASE)
C
          IF (ISIMPY.NE.1) THEN
C
              WRITE(NFIFIC)((((FIL_PM(IBRA,IKET,IREVER,ICHARG),
     *                                                 ICHARG=0,NDISOS),
     *                                          IREVER=0,NDREVE),
     *                                     IKET=1,LDBASE),
     *                                IBRA=1,LDBASE)
C
          END IF
C
C=======================================================================
C         WRITING THE PAIRING FIELDS
C=======================================================================
C
          IF (IPAHFB.EQ.1) THEN
C
              WRITE(NFIFIC)((((FIP_PP(IBRA,IKET,IREVER,ICHARG),
     *                                                 ICHARG=0,NDISOS),
     *                                          IREVER=0,NDREVE),
     *                                     IKET=1,LDBASE),
     *                                IBRA=1,LDBASE)
C
          END IF
C
      END IF
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE ZERCOU(ISIMPY,ICOUDI,ICOUEX)
C=======================================================================
      USE HCOULO
      USE COUSTO
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      COMPLEX
     *          C_ZERO
C
C=======================================================================
C      ALLOCATION AND INITIALIZATION OF COULOMB MEAN-FIELD AND PAIRING
C      FIELD
C=======================================================================
C
      C_ZERO=CMPLX(0.0D0,0.0D0)
C
      IALLOC=0
C
      IF (.NOT.ALLOCATED(HPPCOU)) THEN
          ALLOCATE (HPPCOU(1:NDBASE,1:NDBASE),STAT=IALLOC)
          IF (IALLOC.NE.0) CALL NOALLO('HPPCOU','ZERCOU')
      END IF
C
C      Array HPMCOU must be allocated even if ISIMPY=0, because  an
C      allocatable array can not be passed as a subroutine argument
C      if not allocated (use pointers instead). HPMCOU is passed to
C      routine INTCOU in routine COUMAT.
C
      IF (.NOT.ALLOCATED(HPMCOU)) THEN
          ALLOCATE (HPMCOU(1:NDBASE,1:NDBASE),STAT=IALLOC)
          IF (IALLOC.NE.0) CALL NOALLO('HPMCOU','ZERCOU')
      END IF
C
      HPPCOU(:,:)=C_ZERO
      IF (ISIMPY.NE.1) THEN
          HPMCOU(:,:)=C_ZERO
      END IF
C
C=======================================================================
C
      IF (ICOUDI.EQ.2.OR.ICOUEX.EQ.2) THEN
C
          IALLOC=0
C
          IF (.NOT.ALLOCATED(COULSV)) THEN
              ALLOCATE (COULSV(NDBASE,NDBASE,0:NDKART),STAT=IALLOC)
              IF (IALLOC.NE.0) CALL NOALLO('COULSV','ZERCOU')
          END IF
C
          COULSV(:,:,:)=C_ZERO
C
      END IF
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE ZERYUK
C=======================================================================
      USE YUKSTO
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      COMPLEX
     *          C_ZERO
C
C=======================================================================
C      THIS ROUTINE INITIALIZES THE YUKAWA MEAN-FIELD
C=======================================================================
C
      C_ZERO=CMPLX(0.0D0,0.0D0)
C
      IALLOC=0
C
      IF (.NOT.ALLOCATED(YUKASV)) THEN
          ALLOCATE (YUKASV(1:NDBASE,1:NDBASE,0:NDKART,0:NDISOS),
     *                                             STAT=IALLOC)
          IF (IALLOC.NE.0) CALL NOALLO('YUKASV','ZERYUK')
      END IF
C
      YUKASV(:,:,:,:)=C_ZERO
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE ZERGOG
C=======================================================================
      USE GOGSTO
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      COMPLEX
     *          C_ZERO
C
C=======================================================================
C      THIS ROUTINE INITIALIZES THE GOGNY MEAN-FIELD
C=======================================================================
C
      C_ZERO=CMPLX(0.0D0,0.0D0)
C
      IALLOC=0
C
      IF (.NOT.ALLOCATED(GOGASV)) THEN
          ALLOCATE (GOGASV(NDBASE,NDBASE,0:NDKART,0:NDISOS),STAT=IALLOC)
          IF (IALLOC.NE.0) CALL NOALLO('GOGASV','ZERGOG')
      END IF
C
      GOGASV(:,:,:,:)=C_ZERO
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE ZERGPA
C=======================================================================
      USE GOGKAP
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      COMPLEX
     *          C_ZERO
C
C=======================================================================
C      THIS ROUTINE INITIALIZES THE GOGNY PAIRING FIELD
C=======================================================================
C
      C_ZERO=CMPLX(0.0D0,0.0D0)
C
          IALLOC=0
C
          IF (.NOT.ALLOCATED(GOGCHI)) THEN
              ALLOCATE (GOGCHI(NDBASE,NDBASE,0:NDKART,0:NDISOS),
     *                                         STAT=IALLOC)
          IF (IALLOC.NE.0) CALL NOALLO('GOGCHI','ZERGPA')
          END IF
C
          GOGCHI(:,:,:,:)=C_ZERO
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE RECLIP(NFILIP,NFILIC,INPLIP,ISIMPY)
C=======================================================================
      USE MAD_PP
      USE MAD_PM
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      COMPLEX
     *          C_ZERO
C
C=======================================================================
      COMMON
     *       /CFIPRI/ NFIPRI
      COMMON
     *       /DIMENS/ LDBASE
C
C=======================================================================
C
      IALLOC=0
C
C=======================================================================
      IF (.NOT.ALLOCATED(DEN_PP).AND.INPLIP.EQ.1) THEN
          ALLOCATE (DEN_PP(1:NDBASE,1:NDBASE,0:NDREVE,0:NDISOS),
     *                                                      STAT=IALLOC)
          IF (IALLOC.NE.0) CALL NOALLO('DEN_PP','RECLIP')
      END IF
C=======================================================================
      IF (.NOT.ALLOCATED(DEN_PM).AND.ISIMPY.NE.1.AND.INPLIP.EQ.1) THEN
          ALLOCATE (DEN_PM(1:NDBASE,1:NDBASE,0:NDREVE,0:NDISOS),
     *                                                      STAT=IALLOC)
          IF (IALLOC.NE.0) CALL NOALLO('DEN_PM','RECLIP')
      END IF
C=======================================================================
C
      C_ZERO=CMPLX(0.0D0,0.0D0)
C
C=======================================================================
C     INPLIP - IF .NE.0 => THE FILE WITH THE UNIT NUMBER  NFILIP WILL BE
C                          USED  TO   R E A D   THE   DENSITY   MATRICES
C=======================================================================
C
      IF (INPLIP.NE.0) THEN
C
          REWIND(UNIT=NFILIP,IOSTAT=IERROR)
C
          IF (IERROR.NE.0) STOP 'ERROR IN REWINDING (5)'
C
          READ (NFILIP) MDBASE
C
          IF (MDBASE.NE.LDBASE) THEN
C
              WRITE(NFIPRI,'(/,1X,10(1H/),
     *            '' INCOMPATIBLE DIMENSIONS FOUND ON THE LIPKIN FILE'',
     *                                                   1X,10(1H/),/,
     *             1X,10(1H/),'' LDBASE='',I4,'' MDBASE='',I4,
     *                                                  12X,10(1H/),/)')
     *             LDBASE,MDBASE
C
              STOP 'MDBASE.NE.LDBASE IN RECLIP'
C
          END IF
C
          READ (NFILIP)((((DEN_PP(IBRA,IKET,IREVER,ICHARG),
     *                                             ICHARG=0,NDISOS),
     *                                      IREVER=0,NDREVE),
     *                                 IKET=1,LDBASE),
     *                            IBRA=1,LDBASE)
C
          IF (ISIMPY.NE.1) THEN
C
              READ (NFILIP)((((DEN_PM(IBRA,IKET,IREVER,ICHARG),
     *                                                 ICHARG=0,NDISOS),
     *                                          IREVER=0,NDREVE),
     *                                     IKET=1,LDBASE),
     *                                IBRA=1,LDBASE)
C
          END IF
C
      ELSE
C
C=======================================================================
C     INPLIP - IF .EQ.0 => THE FILE WITH THE UNIT NUMBER  NFILIP WILL BE
C                          USED   TO   RECORD   THE   DENSITY   MATRICES
C=======================================================================
C
          REWIND(UNIT=NFILIC,IOSTAT=IERROR)
C
          IF (IERROR.NE.0) STOP 'ERROR IN REWINDING (6)'
C
          WRITE(NFILIC) LDBASE
C
          WRITE(NFILIC)((((DEN_PP(IBRA,IKET,IREVER,ICHARG),
     *                                             ICHARG=0,NDISOS),
     *                                      IREVER=0,NDREVE),
     *                                 IKET=1,LDBASE),
     *                            IBRA=1,LDBASE)
C
          IF (ISIMPY.NE.1) THEN
C
              WRITE(NFILIC)((((DEN_PM(IBRA,IKET,IREVER,ICHARG),
     *                                                 ICHARG=0,NDISOS),
     *                                          IREVER=0,NDREVE),
     *                                     IKET=1,LDBASE),
     *                                IBRA=1,LDBASE)
C
          ELSE
C
C
              WRITE(NFILIC)((((C_ZERO,
     *                                                 ICHARG=0,NDISOS),
     *                                          IREVER=0,NDREVE),
     *                                     IKET=1,LDBASE),
     *                                IBRA=1,LDBASE)
C
          END IF
C
      END IF
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE ZERLIP(ISIMPY)
C=======================================================================
      USE MAD_PP
      USE MAD_PM
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      COMPLEX
     *          C_ZERO
C
C=======================================================================
C     THIS ROUTINE INITIALIZES THE DENSITY MATRIX TO ZERO
C=======================================================================
C
      C_ZERO=CMPLX(0.0D0,0.0D0)
C
      IALLOC=0
C
      IF (.NOT.ALLOCATED(DEN_PP)) THEN
          ALLOCATE (DEN_PP(1:NDBASE,1:NDBASE,0:NDREVE,0:NDISOS),
     *                                                      STAT=IALLOC)
          IF (IALLOC.NE.0) CALL NOALLO('DEN_PP','ZERLIP')
      END IF
      IF (.NOT.ALLOCATED(DEN_PM).AND.ISIMPY.NE.1) THEN
          ALLOCATE (DEN_PM(1:NDBASE,1:NDBASE,0:NDREVE,0:NDISOS),
     *                                                      STAT=IALLOC)
          IF (IALLOC.NE.0) CALL NOALLO('DEN_PM','ZERLIP')
      END IF
C
      DEN_PP(:,:,:,:)=C_ZERO
      IF (ISIMPY.NE.1) THEN
          DEN_PM(:,:,:,:)=C_ZERO
      END IF
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE ZERLIN(ISIMPY,IPAIRI)
C=======================================================================
      USE ALISTO
      USE PLISTO
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      COMPLEX
     *          C_ZERO
C
C=======================================================================
C
      C_ZERO=CMPLX(0.0D0,0.0D0)
C
      IALLOC=0
C
      IF (.NOT.ALLOCATED(ALINPP)) THEN
          ALLOCATE (ALINPP(NDBASE,NDBASE,1:NDKART,0:NDREVE,0:NDISOS),
     *                                                      STAT=IALLOC)
          IF (IALLOC.NE.0) CALL NOALLO('ALINPP','ZERLIN')
      END IF
      IF (.NOT.ALLOCATED(ALINPM).AND.ISIMPY.NE.1) THEN
          ALLOCATE (ALINPM(NDBASE,NDBASE,1:NDKART,0:NDREVE,0:NDISOS),
     *                                                      STAT=IALLOC)
          IF (IALLOC.NE.0) CALL NOALLO('ALINPM','ZERLIN')
      END IF
C
      ALINPP(:,:,:,:,:)=C_ZERO
C
      IF (ISIMPY.NE.1) THEN
          ALINPM(:,:,:,:,:)=C_ZERO
      END IF
C
      IF (IPAIRI.EQ.1) THEN
C
          IF (.NOT.ALLOCATED(PLINPM)) THEN
              ALLOCATE (PLINPM(NDBASE,NDBASE,1:NDKART,0:NDREVE,
     *                                       0:NDISOS),STAT=IALLOC)
              IF (IALLOC.NE.0) CALL NOALLO('PLINPM','ZERLIN')
          END IF
          IF (.NOT.ALLOCATED(PLINPP).AND.ISIMPY.NE.1) THEN
              ALLOCATE (PLINPP(NDBASE,NDBASE,1:NDKART,0:NDREVE,
     *                                       0:NDISOS),STAT=IALLOC)
              IF (IALLOC.NE.0) CALL NOALLO('PLINPP','ZERLIN')
          END IF
C
          PLINPP(:,:,:,:,:)=C_ZERO
C
          IF (ISIMPY.NE.1) THEN
              PLINPM(:,:,:,:,:)=C_ZERO
          END IF
C
      END IF
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE ZERROT(ISIMPY,IPAIRI)
C=======================================================================
      USE AROSTO
      USE PROSTO
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      COMPLEX
     *          C_ZERO
C
C=======================================================================
C
      C_ZERO=CMPLX(0.0D0,0.0D0)
C
      IALLOC=0
C
      IF (.NOT.ALLOCATED(AROTPP)) THEN
          ALLOCATE (AROTPP(NDBASE,NDBASE,1:NDKART,0:NDREVE,0:NDISOS),
     *                                                      STAT=IALLOC)
          IF (IALLOC.NE.0) CALL NOALLO('AROTPP','ZERROT')
      END IF
      IF (.NOT.ALLOCATED(AROTPM).AND.ISIMPY.NE.1) THEN
          ALLOCATE (AROTPM(NDBASE,NDBASE,1:NDKART,0:NDREVE,0:NDISOS),
     *                                                      STAT=IALLOC)
          IF (IALLOC.NE.0) CALL NOALLO('AROTPM','ZERROT')
      END IF
C
      AROTPP(:,:,:,:,:)=C_ZERO
      IF (ISIMPY.NE.1) THEN
          AROTPM(:,:,:,:,:)=C_ZERO
      END IF
C
      IF (IPAIRI.EQ.1) THEN
C
          IF (.NOT.ALLOCATED(PROTPM)) THEN
              ALLOCATE (PROTPM(NDBASE,NDBASE,1:NDKART,0:NDREVE,
     *                                       0:NDISOS),STAT=IALLOC)
              IF (IALLOC.NE.0) CALL NOALLO('PROTPM','ZERROT')
          END IF
          IF (.NOT.ALLOCATED(PROTPP).AND.ISIMPY.NE.1) THEN
              ALLOCATE (PROTPP(NDBASE,NDBASE,1:NDKART,0:NDREVE,
     *                                       0:NDISOS),STAT=IALLOC)
              IF (IALLOC.NE.0) CALL NOALLO('PROTPP','ZERROT')
          END IF
C
          PROTPM(:,:,:,:,:)=C_ZERO
          IF (ISIMPY.NE.1) THEN
              PROTPP(:,:,:,:,:)=C_ZERO
          END IF
C
      END IF
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE TESDAT(IOPTGS,NOSCIL,NLIMIT,ISTAND,
     *                  KETA_J,KETA_W,KETACM,KETA_M,
     *                                       KETA_R,
     *                         ISIMPY,ISIGNY,ISIQTY,
     *                         ISIMTX,JSIMTY,ISIMTZ,
     *                         NMUCON,NMUCOU,NMUPRI,
     *                  ISCHIF,NSICON,NSIPRI,IDOPLM,
     *                                NMACON,NMAPRI,
     *                         NMURED,NMARED,NSIRED,
     *                                NEXBET,IPRIBE,
     *                         NUPING,EPSPNG,EPSITE,
     *                                       NULAST,
     *                  ISYMDE,INIROT,INIINV,INIKAR,
     *                                       IWRIOL,
     *                                IRENMA,IRENIN,
     *                  IFRWAV,ITOWAV,IWRWAV,ISAKER,
     *                         IPRGCM,IPROMI,IPROMA,
     *                         NUAKNO,NUBKNO,KPROJE,
     *                                       NBTKNO,
     *                  ISOSMI,ISOSMA,EPSISO,ICSKIP,
     *                                       IFERME,
     *                         IPAKER,IPAALL,KFIKER,
     *                  NUASTA,NUASTO,NUGSTA,NUGSTO,
     *                  NUBSTA,NUBSTO,NUTSTA,NUTSTO,
     *                         ICHFLI,IPAFLI,IREFLI,
     *                         ISPFLI,ISHFLI,IFLIPI,
     *                                NOITER,IREAWS,
     *                                IN_FIX,IZ_FIX,
     *                  IDESTA,IDEMID,IDESTO,IDEDIS,
     *                  IMOVAX,ITILAX,ITISAX,NO_ORB,
     *                                       NILXYZ,
     *                                       IROTAT,
     *                         IPAIRI,IPAHFB,JPABCS,
     *                         LIMQUA,ITWOBA,IMFHFB,
     *                                LIPKIN,LIPKIP,
     *                         SLOWEV,SLOWOD,SLOWPA,
     *                                IFEFIN,IFEFIP,
     *                                IF2FIN,IF2FIP,
     *                                IDEFIN,IDEFIP,
     *                  INSIGN,IPSIGN,ISSIGN,IDSIGN,
     *                  INSIGP,IPSIGP,ISSIGP,IDSIGP,
     *                         INSIMN,IRSIMN,IDSIMN,
     *                         INSIMP,IRSIMP,IDSIMP,
     *                         INSIQN,IPSIQN,IDSIQN,
     *                         INSIQP,IPSIQP,IDSIQP,
     *                                INSIZN,IDSIZN,
     *                                INSIZP,IDSIZP,
     *                                IFIBLN,INIBLN,
     *                                IFIBLP,INIBLP,
     *                         ICOTYP,ICOUDI,ICOUEX,
     *                                IYUTYP,I_YUKA,
     *                                I_GOGA,IGOGPA,
     *                         ICONTI,IPCONT,IOCONT,
     *                  IACONT,IYCONT,IGCONT,IGPCON,
     *                  ILCONT,IFCONT,IMCONT,IRCONT,
     *                  JETACM,IFSHEL,IF_RPA,IF_THO,
     *                                SKYRME,GOGNAM,
     *                                       IFRAGM)
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      DIMENSION
     *          NUMPAR(0:NDISOS)
C
      CHARACTER
     *          SKYRME*4,GOGNAM*4
      CHARACTER
     *          ERRSTR*68
C
      COMMON
     *       /FLOPAR/ XIZFIX,XINFIX
      COMMON
     *       /SIGNVA/ NVASIG(0:NDPARI,0:NDREVE,0:NDISOS)
      COMMON
     *       /SIMNVA/ NVASIM(         0:NDREVE,0:NDISOS)
      COMMON
     *       /SIQNVA/ NVASIQ(0:NDPARI,         0:NDISOS)
      COMMON
     *       /N_FLIG/ NPFLIG(0:NDPARI,0:NDREVE,0:NDISOS),
     *                NHFLIG(0:NDPARI,0:NDREVE,0:NDISOS),
     *                NOFLIG(0:NDPARI,0:NDREVE,0:NDISOS)
      COMMON
     *       /N_FLIM/ NPFLIM(         0:NDREVE,0:NDISOS),
     *                NHFLIM(         0:NDREVE,0:NDISOS),
     *                NOFLIM(         0:NDREVE,0:NDISOS)
      COMMON
     *       /N_FLIQ/ NPFLIQ(0:NDPARI,         0:NDISOS),
     *                NHFLIQ(0:NDPARI,         0:NDISOS),
     *                NOFLIQ(0:NDPARI,         0:NDISOS)
      COMMON
     *       /N_FLIZ/ NPFLIZ(                  0:NDISOS),
     *                NHFLIZ(                  0:NDISOS),
     *                NOFLIZ(                  0:NDISOS)
      COMMON
     *       /N_FILG/ NPFILG(0:NDPARI,0:NDREVE,0:NDISOS),
     *                NHFILG(0:NDPARI,0:NDREVE,0:NDISOS),
     *                NOFILG(0:NDPARI,0:NDREVE,0:NDISOS)
      COMMON
     *       /N_FILZ/ NPFILZ(                  0:NDISOS),
     *                NHFILZ(                  0:NDISOS),
     *                NOFILZ(                  0:NDISOS)
      COMMON
     *       /SIGOCC/ N_OCCU(1:NDSTAT,0:NDPARI,0:NDREVE,0:NDISOS),
     *                N_VACC(1:NDSTAT,0:NDPARI,0:NDREVE,0:NDISOS)
      COMMON
     *       /SIMOCC/ L_OCCU(1:NDSTAT,0:NDREVE,0:NDISOS),
     *                L_VACC(1:NDSTAT,0:NDREVE,0:NDISOS)
      COMMON
     *       /SIQOCC/ K_OCCU(1:2*NDSTAT,0:NDPARI,0:NDISOS),
     *                K_VACC(1:2*NDSTAT,0:NDPARI,0:NDISOS)
      COMMON
     *       /SIZOCC/ M_OCCU(1:2*NDSTAT,0:NDISOS),
     *                M_VACC(1:2*NDSTAT,0:NDISOS)
      COMMON
     *       /QCNSTR/ STIFFQ(0:NDMULT,-NDMULT:NDMULT),
     *                QASKED(0:NDMULT,-NDMULT:NDMULT),
     *                IFLAGQ(0:NDMULT,-NDMULT:NDMULT)
      COMMON
     *       /GCNSTR/ STIFFG(0:NDMULT),
     *                GASKED(0:NDMULT),
     *                IFLAGG(0:NDMULT)
      COMMON
     *       /SCNSTR/ STIFFS(0:NDMULT,-NDMULT:NDMULT),
     *                SASKED(0:NDMULT,-NDMULT:NDMULT),
     *                IFLAGS(0:NDMULT,-NDMULT:NDMULT)
      COMMON
     *       /QLASTR/ GALMUQ(0:NDMULT,-NDMULT:NDMULT),
     *                QLINEA(0:NDMULT,-NDMULT:NDMULT),
     *                IFLALQ(0:NDMULT,-NDMULT:NDMULT)
      COMMON
     *       /SLASTR/ GALMUS(0:NDMULT,-NDMULT:NDMULT),
     *                SLINEA(0:NDMULT,-NDMULT:NDMULT),
     *                IFLALS(0:NDMULT,-NDMULT:NDMULT)
      COMMON
     *       /VACCNF/ IVACUM
      COMMON
     *       /SPNUMS/ NUMBSP(0:NDREVE,0:NDISOS)
      COMMON
     *       /OMEGAS/ OMEGAX,OMEGAY,OMEGAZ
      COMMON
     *       /OMISOS/ OMISOX,OMISOY,OMISOZ
      COMMON
     *       /IANGLE/ ALPINI,BETINI,GAMINI
      COMMON
     *       /ICNSTR/ STIFFI(1:NDKART),
     *                ASKEDI(1:NDKART),
     *                IFLAGI(1:NDKART)
      COMMON
     *       /ACNSTR/ STIFFA,ASKEDA,IFLAGA
      COMMON
     *       /PLANCK/ HBMASS,HBMRPA,HBMINP
      COMMON
     *       /CCPPAI/ PRHO_N,PRHODN,PRHOSN,POWERN,
     *                PRHO_P,PRHODP,PRHOSP,POWERP
      COMMON
     *       /CFIPRI/ NFIPRI
      COMMON
     *       /BROINI/ IBROYD,N_ITER
C@@@ TEMP - TEMP - TEMP - TEMP - TEMP - TEMP - TEMP - TEMP - TEMP
      COMMON
     *       /T_FLAG/ IFTEMP
C@@@ TEMP - TEMP - TEMP - TEMP - TEMP - TEMP - TEMP - TEMP - TEMP
C SL - SL - SL - SL - SL - SL - SL - SL - SL - SL - SL - SL - SL - SL
      COMMON
     *       /SCALAPACK_INP/ NBLOCK,MBLOCK,NPGRID,MPGRID,KZHPEV
C SL - SL - SL - SL - SL - SL - SL - SL - SL - SL - SL - SL - SL - SL
      COMMON
     *       /EDFINP/ IF_EDF
C
C=======================================================================
C         THIS SUBROUTINE PERFORMS VARIOUS TESTS ON THE INPUT DATA,
C         CORRECTS THE DATA WHERE POSSIBLE, AND PRINTS THE WARNINGS
C         OR STOPS THE CODE WHEN NECESSARY
C=======================================================================
C
      MAXTER=10
      IERROR=0
      ERRSTR='NO ERROR REPORTED'
C
C=======================================================================
C
      IF (IBROYD.GE.1.AND.N_ITER.GT.MAXTER) THEN
C
          WRITE(NFIPRI,'(/,
     *                 1X,20(1H/),'' INCORRECT VALUE OF N_ITER = '',I3,
     *                            ''     '',      1X,20(1H/),/,
     *                 1X,20(1H/),'' SHOULD NOT EXCEED  MAXTER = '',I3,
     *                            ''  OR '',      1X,20(1H/),/,
     *                 1X,20(1H/),'' OTHERWISE INCREASE MAXTER IN'',
     *                            '' BROYDEN'',   1X,20(1H/),/)')
     *           N_ITER,MAXTER
C
          ERRSTR=' INCORRECT VALUE OF N_ITER IN TESDAT'
          IERROR=1
C
      END IF
C
C=======================================================================
C
      IF (IN_FIX.LT.0.OR. IZ_FIX.LT.0.OR.
     *   (IN_FIX.EQ.0.AND.IZ_FIX.EQ.0)) THEN
C
          WRITE(NFIPRI,'(/,
     *                 1X,20(1H/),'' INCORRECT VALUE OF IN_FIX ='',I4,
     *                            '' OR'',       2X,20(1H/),/,
     *                 1X,20(1H/),'' INCORRECT VALUE OF IZ_FIX ='',I4,
     *                            ''   '',       2X,20(1H/),/)')
     *              IN_FIX,IZ_FIX
C
          ERRSTR=' INCORRECT VALUE OF IN_FIX OR IZ_FIX IN TESDAT'
          IERROR=1
C
      END IF
C
C=======================================================================
C      Sanity check: for the Gogny force, the SKYRME and GOGNAM flags
C      must be consistent
C=======================================================================
C
      IF (I_GOGA.GE.2.AND.(trim(SKYRME).NE.trim(GOGNAM))) THEN
C
          WRITE(NFIPRI,'(/,1X,16(''/''),45X,16(''/''),/,1X,
     *                  16(''/''),''  ERROR: SKYRME='',A4,
     *                  '' AND GOGNAM='',A4,9X,16(''/''),/,1X,
     *                  16(''/''),''         BOTH KEYWORDS SHOULD'',
     *                  '' BE IDENTICAL   '',16(''/''),/,1X,
     *                  16(''/''),45X,16(''/''))') SKYRME,GOGNAM
C
          ERRSTR='SKYRME AND GOGNAM ARE DIFFERENT FOR GOGNY FORCES'
          IERROR=1
C
      END IF
C
C=======================================================================
C      Sanity check: if UNEDF functionals are requested, the Lipkin
C      Nogami prescription must be activated
C=======================================================================
C
      IF ((SKYRME.EQ.'UNE0'.OR.SKYRME.EQ.'UNE1'.OR.SKYRME.EQ.'UNE2')
     *                    .AND.(IF_EDF.EQ.0.OR.ISTAND.EQ.0)) THEN
C
          WRITE(NFIPRI,'(/,1X,16(''/''),45X,16(''/''),/,
     *                  16(''/''),''  ERROR: UNEDF FUNCTIONAL'',
     *                  ''REQUESTED: '',A4,'' '',16(''/''),/,
     *                  16(''/''),''RESET FLAGS ISTAND=1'',
     *                  '' AND IF_EDF=1          '',16(''/''),/,
     *                  16(''/''),45X,16(''/''))')
C
          ERRSTR='UNE0/UNE1/UNE2 PARAMS. NEED IF_EDF=1 AND ISTAND=1'
          IERROR=1
C
      END IF
C
C=======================================================================
C      Sanity check: if UNEDF functionals are requested, the flag
C      IF_EDF must be set to 1
C=======================================================================
C
      IF ((SKYRME.EQ.'UNE0'.OR.SKYRME.EQ.'UNE1'.OR.SKYRME.EQ.'UNE2')
     *                    .AND.(LIPKIN.EQ.0.OR.LIPKIP.EQ.0)) THEN
C
          WRITE(NFIPRI,'(/,1X,16(''/''),45X,16(''/''),/,
     *                  16(''/''),''  ERROR: UNEDF FUNCTIONAL'',
     *                  ''REQUESTED: '',A4,'' '',16(''/''),/,
     *                  16(''/''),''LIPKIN-NOGAMI PRESCRIPTION'',
     *                  '' MUST BE ACTIVE '',16(''/''),/,
     *                  16(''/''),''RESET FLAGS LIPKIN=1'',
     *                  '' AND LIPKIP=1          '',16(''/''),/,
     *                  16(''/''),45X,16(''/''))')
C
          ERRSTR='UNE0/UNE1/UNE2 PARAMS. NEED LIPKIN=1 AND LIPKIP=1'
          IERROR=1
C
      END IF
C
C=======================================================================
C
      IF (ISTAND.EQ.0.AND.((KETA_J.NE.0.AND.KETA_J.NE.1).OR.
     *                     (KETA_W.NE.0.AND.KETA_W.NE.1
     *                                 .AND.KETA_W.NE.2).OR.
     *                     (KETACM.NE.0.AND.KETACM.NE.1.AND.
     *                      KETACM.NE.2.AND.KETACM.NE.3).OR.
     *                     (KETA_M.NE.0.AND.KETA_M.NE.1)
     *                                 .AND.KETA_M.NE.2)) THEN
C
          WRITE(NFIPRI,'(/,
     *                 1X,20(1H/),''  INCORRECT STANDARD-FORCE'',
     *                            '' SWITCHES'',       2X,20(1H/),/,
     *                 1X,20(1H/),''  ISTAND ='',I2,6X,
     *                            ''          '',2X,   7X,20(1H/),/,
     *                 1X,20(1H/),''  KETA_J ='',I2,6X,
     *                            ''  KETA_W ='',I2,   7X,20(1H/),/,
     *                 1X,20(1H/),''  KETACM ='',I2,6X,
     *                            ''  KETA_M ='',I2,   7X,20(1H/),/)')
     *
     *    ISTAND,KETA_J,KETA_W,KETACM,KETA_M
C
          ERRSTR='INCORRECT STANDARD-FORCE SWITCHES IN TESDAT'
          IERROR=1
C
      END IF
C
C=======================================================================
C
      IF (KETA_R.NE.1.AND.KETA_R.NE.2.AND.KETA_R.NE.3) THEN
C
          WRITE(NFIPRI,'(/,
     *                 1X,20(1H/),''  INCORRECT ROTATIONAL CORR.'',
     *                            '' SWITCH'',       2X,20(1H/),/,
     *                 1X,20(1H/),''  KETA_R ='',I2,25X,20(1H/),/)')
     *
     *    KETA_R
C
          ERRSTR='INCORRECT ROTATIONAL CORRECTION SWITCH IN TESDAT'
          IERROR=1
C
      END IF
C
C=======================================================================
C
      IF (HBMINP.LT.20.OR.HBMINP.GT.21) THEN
C
          WRITE(NFIPRI,'(/,
     *                 1X,20(1H/),''  UNUSUAL VALUE ENCOUNTERD'',
     *                            ''         '',       2X,20(1H/),/,
     *                 1X,20(1H/),''  HBMINP ='',F12.8,
     *                            ''          '',      5X,20(1H/),/)')
     *
     *    HBMINP
C
          ERRSTR=' UNUSUAL VALUE OF HBMINP IN TESDAT'
          IERROR=1
C
      END IF
C
C=======================================================================
C
      IF (PRHOSN.LE.0.0D0.OR.POWERN.EQ.0.0D0.OR.
     *    PRHOSP.LE.0.0D0.OR.POWERP.EQ.0.0D0) THEN
C
          WRITE(NFIPRI,'(/,
     *                 1X,20(1H/),''  INCORRECT  CONTACT-PAIRING'',
     *                            ''  FORCE'',       2X,20(1H/),/,
     *                 1X,20(1H/),''  NEUTRONS:'',    26X,20(1H/),/,
     *                 1X,20(1H/),''  PRHO_N='',F9.3,
     *                             '' PRHODN='',F9.3,  2X,20(1H/),/,
     *                 1X,20(1H/),''  PRHOSN='',F9.3,
     *                             '' POWERN='',F9.3,  2X,20(1H/),/,
     *                 1X,20(1H/),''  PROTONS: '',    26X,20(1H/),/,
     *                 1X,20(1H/),''  PRHO_P='',F9.3,
     *                             '' PRHODP='',F9.3,  2X,20(1H/),/,
     *                 1X,20(1H/),''  PRHOSP='',F9.3,
     *                             '' POWERP='',F9.3,  2X,20(1H/),/)')
     *
     *    PRHO_N,PRHODN,PRHOSN,POWERN,
     *    PRHO_P,PRHODP,PRHOSP,POWERP
C
          ERRSTR=' INCORRECT CONTACT-PAIRING FORCE IN TESDAT'
          IERROR=1
C
      END IF
C
C=======================================================================
C
      IF (INIINV.LT.0.OR.INIINV.GT.3) THEN
C
          WRITE(NFIPRI,'(/,
     *                 1X,20(1H/),'' INCORRECT VALUE OF INIINV = '',I3,
     *                            ''   '',       2X,20(1H/),/)')
     *           INIINV
C
          ERRSTR=' INCORRECT VALUE OF INIINV IN TESDAT'
          IERROR=1
C
      END IF
C
C=======================================================================
C
      IF (INIKAR.LT.0.OR.INIKAR.GT.3) THEN
C
          WRITE(NFIPRI,'(/,
     *                 1X,20(1H/),'' INCORRECT VALUE OF INIKAR = '',I3,
     *                            ''   '',       2X,20(1H/),/)')
     *           INIKAR
C
          ERRSTR=' INCORRECT VALUE OF INIKAR IN TESDAT'
          IERROR=1
C
      END IF
C
C=======================================================================
C
      IF (INIINV.GE.1.AND.(SLOWEV.NE.0.0D0.OR.SLOWOD.NE.0.0D0)) THEN
C
          WRITE(NFIPRI,'(/,
     *                 1X,20(1H/),'' INIINV>0 REQUIRES  ALL '',
     *                            '' SLOW-DOWN'',       3X,20(1H/),/,
     *                 1X,20(1H/),'' PARAMETERS EQUAL ZERO, WHILE'',
     *                            '' NOW:'',     3X,20(1H/),/,
     *                 1X,20(1H/),'' SLOWEV='',F9.3,
     *                            '' SLOWOD='',F9.3,  3X,20(1H/),/)')
     *
     *    SLOWEV,SLOWOD
C
          ERRSTR=' INCORRECT SLOW-DOWN PARAMS. FOR INIINV>0 IN TESDAT'
          IERROR=1
C
      END IF
C
C=======================================================================
C
      IF (INIKAR.GE.1.AND.(SLOWEV.NE.0.0D0.OR.SLOWOD.NE.0.0D0)) THEN
C
          WRITE(NFIPRI,'(/,
     *                 1X,20(1H/),'' INIKAR>0 REQUIRES  ALL '',
     *                            '' SLOW-DOWN'',       3X,20(1H/),/,
     *                 1X,20(1H/),'' PARAMETERS EQUAL ZERO, WHILE'',
     *                            '' NOW:'',     3X,20(1H/),/,
     *                 1X,20(1H/),'' SLOWEV='',F9.3,
     *                            '' SLOWOD='',F9.3,  3X,20(1H/),/)')
     *
     *    SLOWEV,SLOWOD
C
          ERRSTR=' INCORRECT SLOW-DOWN PARAMS. FOR INIKAR>0 IN TESDAT'
          IERROR=1
C
      END IF
C
C=======================================================================
C
      IF (INIINV.GE.1.AND.IPAHFB.GE.1.AND.SLOWPA.NE.0.0D0) THEN
C
          WRITE(NFIPRI,'(/,
     *                 1X,20(1H/),'' INIINV>0 REQUIRES  ALL '',
     *                            '' SLOW-DOWN'',       3X,20(1H/),/,
     *                 1X,20(1H/),'' PARAMETERS EQUAL ZERO, WHILE'',
     *                            '' NOW:'',     3X,20(1H/),/,
     *                 1X,20(1H/),'' SLOWPA='',F9.3,
     *                            ''        '',      12X,20(1H/),/)')
     *
     *    SLOWPA
C
          ERRSTR=' INCORRECT PAIRING SLOW-DOWN FOR INIINV>0 IN TESDAT'
          IERROR=1
C
      END IF
C
C=======================================================================
C
      IF (INIKAR.GE.1.AND.IPAHFB.GE.1.AND.SLOWPA.NE.0.0D0) THEN
C
          WRITE(NFIPRI,'(/,
     *                 1X,20(1H/),'' INIKAR>0 REQUIRES  ALL '',
     *                            '' SLOW-DOWN'',       3X,20(1H/),/,
     *                 1X,20(1H/),'' PARAMETERS EQUAL ZERO, WHILE'',
     *                            '' NOW:'',     3X,20(1H/),/,
     *                 1X,20(1H/),'' SLOWPA='',F9.3,
     *                            ''        '',      12X,20(1H/),/)')
     *
     *    SLOWPA
C
          ERRSTR=' INCORRECT PAIRING SLOW-DOWN FOR INIKAR>0 IN TESDAT'
          IERROR=1
C
      END IF
C
C=======================================================================
C
      IF (INIINV.GE.1.AND.NOITER.NE.1) THEN
C
          WRITE(NFIPRI,'(/,
     *                 1X,20(1H/),'' INIINV>0 REQUIRES NOITER=1 '',
     *                            ''       '',       2X,20(1H/),/)')
C
          ERRSTR=' MORE THAN 1 ITER. REQUESTED FOR INIINV>0 IN TESDAT'
          IERROR=1
C
      END IF
C
C=======================================================================
C
      IF (INIKAR.GE.1.AND.NOITER.NE.1) THEN
C
          WRITE(NFIPRI,'(/,
     *                 1X,20(1H/),'' INIKAR>0 REQUIRES NOITER=1 '',
     *                            ''       '',       2X,20(1H/),/)')
C
          ERRSTR=' MORE THAN 1 ITER. REQUESTED FOR INIKAR>0 IN TESDAT'
          IERROR=1
C
      END IF
C
C=======================================================================
C
      IF (INIKAR.EQ.1.AND.ISIGNY.EQ.1) THEN
C
          WRITE(NFIPRI,'(/,
     *                 1X,20(1H/),'' INIKAR=1 REQUIRES ISIGNY=0,'',
     *                            ''       '',         2X,20(1H/),/)')
C
          ERRSTR=' INIKAR=1 IS INCOMPATIBLE WITH ISIGNY=1 IN TESDAT'
          IERROR=1
C
      END IF
C
C=======================================================================
C
      IF (INIKAR.EQ.3.AND.ISIGNY.EQ.1) THEN
C
          WRITE(NFIPRI,'(/,
     *                 1X,20(1H/),'' INIKAR=3 REQUIRES ISIGNY=0,'',
     *                            ''       '',         2X,20(1H/),/)')
C
          ERRSTR=' INIKAR=3 IS INCOMPATIBLE WITH ISIGNY=1 IN TESDAT'
          IERROR=1
C
      END IF
C
C=======================================================================
C
      IF (INIINV.EQ.1.AND.IROTAT.EQ.0) THEN
C
          WRITE(NFIPRI,'(/,
     *                 1X,20(1H/),'' INIINV=1 REQUIRES IROTAT=1,'',
     *                            ''       '',         2X,20(1H/),/)')
C
          ERRSTR=' INIINV=1 IS INCOMPATIBLE WITH IROTAT=0 IN TESDAT'
          IERROR=1
C
      END IF
C
C=======================================================================
C
      IF (INIINV.EQ.3.AND.IROTAT.EQ.0) THEN
C
          WRITE(NFIPRI,'(/,
     *                 1X,20(1H/),'' INIINV=3 REQUIRES IROTAT=1,'',
     *                            ''       '',         2X,20(1H/),/)')
C
          ERRSTR=' INIINV=3 IS INCOMPATIBLE WITH IROTAT=0 IN TESDAT'
          IERROR=1
C
      END IF
C
C=======================================================================
C
      IF (INIINV.EQ.2.AND.ISIQTY.EQ.1) THEN
C
          WRITE(NFIPRI,'(/,
     *                 1X,20(1H/),'' INIINV=2 REQUIRES IPARTY=0,'',
     *                            ''       '',         2X,20(1H/),/)')
C
          ERRSTR=' INIINV=2 IS INCOMPATIBLE WITH IPARTY=1 IN TESDAT'
          IERROR=1
C
      END IF
C
C=======================================================================
C
      IF (INIINV.EQ.3.AND.ISIQTY.EQ.1) THEN
C
          WRITE(NFIPRI,'(/,
     *                 1X,20(1H/),'' INIINV=3 REQUIRES IPARTY=0,'',
     *                            ''       '',         2X,20(1H/),/)')
C
          ERRSTR=' INIINV=3 IS INCOMPATIBLE WITH IPARTY=1 IN TESDAT'
          IERROR=1
C
      END IF
C
C=======================================================================
C
      IF (INIROT.EQ.1.AND.(SLOWEV.NE.0.0D0.OR.SLOWOD.NE.0.0D0)) THEN
C
          WRITE(NFIPRI,'(/,
     *                 1X,20(1H/),'' INIROT=1 REQUIRES  ALL '',
     *                            '' SLOW-DOWN'',       3X,20(1H/),/,
     *                 1X,20(1H/),'' PARAMETERS EQUAL ZERO, WHILE'',
     *                            '' NOW:'',     3X,20(1H/),/,
     *                 1X,20(1H/),'' SLOWEV='',F9.3,
     *                            '' SLOWOD='',F9.3,  3X,20(1H/),/)')
     *
     *    SLOWEV,SLOWOD
C
          ERRSTR=' INCORRECT SLOW-DOWN PARAMS. FOR INIROT=1 IN TESDAT'
          IERROR=1
C
      END IF
C
C=======================================================================
C
      IF (INIROT.EQ.1.AND.IPAHFB.GE.1.AND.SLOWPA.NE.0.0D0) THEN
C
          WRITE(NFIPRI,'(/,
     *                 1X,20(1H/),'' INIROT=1 REQUIRES  ALL '',
     *                            '' SLOW-DOWN'',       3X,20(1H/),/,
     *                 1X,20(1H/),'' PARAMETERS EQUAL ZERO, WHILE'',
     *                            '' NOW:'',     3X,20(1H/),/,
     *                 1X,20(1H/),'' SLOWPA='',F9.3,
     *                            ''        '',      12X,20(1H/),/)')
     *
     *    SLOWPA
C
          ERRSTR=' INCORRECT PAIRING SLOW-DOWN FOR INIROT=1 IN TESDAT'
          IERROR=1
C
      END IF
C
C=======================================================================
C
      IF (INIROT.EQ.1.AND.NOITER.NE.1) THEN
C
          WRITE(NFIPRI,'(/,
     *                 1X,20(1H/),'' INIROT=1 REQUIRES NOITER=1 '',
     *                            ''       '',       2X,20(1H/),/)')
C
          ERRSTR=' MORE THAN 1 ITER. REQUESTED FOR INIROT=1 IN TESDAT'
          IERROR=1
C
      END IF
C
C=======================================================================
C
      IF (INIROT.EQ.1.AND.ISIGNY.EQ.1.AND.
     *   (ALPINI.NE.0.0D0.OR.GAMINI.NE.0.0D0)) THEN
C
          WRITE(NFIPRI,'(/,
     *                 1X,20(1H/),'' INIROT=1 REQUIRES ISIGNY=0,'',
     *                            '' UNLESS'',         2X,20(1H/),/,
     *                 1X,20(1H/),'' ALPINI AND GAMINI ARE EXACTLY'',
     *                            '' ZERO'',           2X,20(1H/),/)')
C
          ERRSTR=' INIROT=1 IS INCOMPATIBLE WITH ISIGNY=1 IN TESDAT'
          IERROR=1
C
      END IF
C
C=======================================================================
C
      IF (INIROT.EQ.1.AND.ISIMPY.EQ.1.AND.
     *   (ALPINI.NE.0.0D0.OR.GAMINI.NE.0.0D0)) THEN
C
          WRITE(NFIPRI,'(/,
     *                 1X,20(1H/),'' INIROT=1 REQUIRES ISIMPY=0,'',
     *                            '' UNLESS'',         2X,20(1H/),/,
     *                 1X,20(1H/),'' ALPINI AND GAMINI ARE EXACTLY'',
     *                            '' ZERO'',           2X,20(1H/),/)')
C
          ERRSTR=' INIROT=1 IS INCOMPATIBLE WITH ISIMPY=1 IN TESDAT'
          IERROR=1
C
      END IF
C
C=======================================================================
C
      IF (INIROT.EQ.1.AND.ISIMTX.EQ.1.AND.
     *   (ALPINI.NE.0.0D0.OR.GAMINI.NE.0.0D0)) THEN
C
          WRITE(NFIPRI,'(/,
     *                 1X,20(1H/),'' INIROT=1 REQUIRES ISIMTX=0,'',
     *                            '' UNLESS'',         2X,20(1H/),/,
     *                 1X,20(1H/),'' ALPINI AND GAMINI ARE EXACTLY'',
     *                            '' ZERO'',           2X,20(1H/),/)')
C
          ERRSTR=' INIROT=1 IS INCOMPATIBLE WITH ISIMTX=1 IN TESDAT'
          IERROR=1
C
      END IF
C
C=======================================================================
C
      IF (INIROT.EQ.1.AND.JSIMTY.EQ.1.AND.
     *   (ALPINI.NE.0.0D0.OR.GAMINI.NE.0.0D0)) THEN
C
          WRITE(NFIPRI,'(/,
     *                 1X,20(1H/),'' INIROT=1 REQUIRES ISIMTY=0,'',
     *                            '' UNLESS'',         2X,20(1H/),/,
     *                 1X,20(1H/),'' ALPINI AND GAMINI ARE EXACTLY'',
     *                            '' ZERO'',           2X,20(1H/),/)')
C
          ERRSTR=' INIROT=1 IS INCOMPATIBLE WITH ISIMTY=1 IN TESDAT'
          IERROR=1
C
      END IF
C
C=======================================================================
C
      IF (IPRGCM.LT.0.OR.IPRGCM.GT.2) THEN
C
          WRITE(NFIPRI,'(/,
     *                 1X,20(1H/),'' INCORRECT VALUE OF IPRGCM = '',I3,
     *                            ''   '',       2X,20(1H/),/)')
     *           IPRGCM
C
          ERRSTR=' INCORRECT VALUE OF IPRGCM IN TESDAT'
          IERROR=1
C
      END IF
C
C=======================================================================
C
      IF (IPRGCM.GE.1.AND.ISCHIF.EQ.1) THEN
C
          WRITE(NFIPRI,'(/,
     *                 1X,20(1H/),'' ISCHIF=1  (CALC. OF SCHIFF'',
     *                            '' MOMENTS)'',         1X,20(1H/),/,
     *                 1X,20(1H/),'' IS  INCOMPATIBLE  WITH  '',
     *                            '' PROJECTION'',       1X,20(1H/),/)')
C
          ERRSTR=' ISCHIF=1 INCOMPATIBLE WITH PROJECTION IN TESDAT'
          IERROR=1
C
      END IF
C
C=======================================================================
C
      IF (NOSCIL.LT.0.OR.NOSCIL.GT.NDMAIN) THEN
C
          WRITE(NFIPRI,'(/,
     *                 1X,20(1H/),'' INCORRECT VALUE OF NOSCIL = '',I3,
     *                            ''   '',       2X,20(1H/),/,
     *                 1X,20(1H/),'' SHOULD NOT EXCEED  NDMAIN = '',I3,
     *                            ''  OR'',      1X,20(1H/),/,
     *                 1X,20(1H/),'' OTHERWISE INCREASE NDMAIN TO'',
     *                            '' NOSCIL'',   1X,20(1H/),/)')
     *           NOSCIL,NDMAIN
C
          ERRSTR=' INCORRECT VALUE OF NOSCIL OR NDMAIN IN TESDAT'
          IERROR=1
C
      END IF
C
C=======================================================================
C
      IF (IPRGCM.GE.1.AND.NUAKNO.GT.NDAKNO) THEN
C
          WRITE(NFIPRI,'(/,
     *                 1X,20(1H/),4X,''NUAKNO.GT.NDAKNO:'',3X,20(1H/),/,
     *                 1X,20(1H/),7X,I3,   ''.GT.''  ,I3,7X,20(1H/),/)')
     *                 NUAKNO,NDAKNO
C
          ERRSTR=' NUAKNO.GT.NDAKNO IN TESDAT'
          IERROR=1
C
      END IF
C
C=======================================================================
C
      IF (IPRGCM.GE.1.AND.NUBKNO.GT.NDBKNO) THEN
C
          WRITE(NFIPRI,'(/,
     *                 1X,20(1H/),4X,''NUBKNO.GT.NDBKNO:'',3X,20(1H/),/,
     *                 1X,20(1H/),7X,I3,   ''.GT.''  ,I3,7X,20(1H/),/)')
     *                 NUBKNO,NDBKNO
C
          ERRSTR=' NUBKNO.GT.NDBKNO IN TESDAT'
          IERROR=1
C
      END IF
C
C=======================================================================
C
      IF (IPRGCM.GE.1.AND.NBTKNO.GT.NDBTKN) THEN
C
          WRITE(NFIPRI,'(/,
     *                 1X,20(1H/),4X,''NBTKNO.GT.NDBTKN:'',3X,20(1H/),/,
     *                 1X,20(1H/),7X,I3,   ''.GT.''  ,I3,7X,20(1H/),/)')
     *                 NBTKNO,NDBTKN
C
          ERRSTR=' NBTKNO.GT.NDBTKN IN TESDAT'
          IERROR=1
C
      END IF
C
C=======================================================================
C
      IF (MOD(NDPROI,2).NE.0) THEN
C
          WRITE(NFIPRI,'(/,1X,20(1H/),'' NDPROI NOT EVEN:'',
     *                                         I3,2X,20(1H/),/)') NDPROI
C
          ERRSTR='NDPROI IS NOT EVEN IN TESDAT'
          IERROR=1
C
      END IF
C
C=======================================================================
C
      IF (IPRGCM.GE.1.AND.IPROMA.GT.NDPROI.AND.
     *   (NUAKNO.GT.1.OR.NUBKNO.GT.1)) THEN
C
          WRITE(NFIPRI,'(/,
     *                 1X,20(1H/),4X,''IPROMA.GT.NDPROI:'',3X,20(1H/),/,
     *                 1X,20(1H/),7X,I3,   ''.GT.''  ,I3,7X,20(1H/),/)')
     *                 IPROMA,NDPROI
C
          ERRSTR=' IPROMA.GT.NDPROI IN TESDAT'
          IERROR=1
C
      END IF
C
C=======================================================================
C
      IF (IPRGCM.GE.1.AND.ISOSMA.GT.NDPROT.AND.NBTKNO.GT.1) THEN
C
          WRITE(NFIPRI,'(/,
     *                 1X,20(1H/),4X,''ISOSMA.GT.NDPROT:'',3X,20(1H/),/,
     *                 1X,20(1H/),7X,I3,   ''.GT.''  ,I3,7X,20(1H/),/)')
     *                 ISOSMA,NDPROT
C
          ERRSTR=' ISOSMA.GT.NDPROT IN TESDAT'
          IERROR=1
C
      END IF
C
C=======================================================================
C
      IF (IPRGCM.GE.1.AND. NBTKNO.GT.1.AND.ICSKIP.EQ.0.
     *               .AND.(ICOUDI.NE.2.OR. ICOUEX.NE.2)) THEN
C
          WRITE(NFIPRI,'(/,1X,6(''/''),1X,
     *          ''REDIAGONALIZATION OF FULL HAMILTONIAN IN ISOSPIN '',
     *          ''PROJECTION /////'',/,'' ////// (ICSKIP=0) '',
     *          ''REQUIRES ICOUDI=2 AND ICOUEX=2 (EXACT COULOMB)'',
     *          ''   /////'',/,1X,6(''/''),61X,5(''/''),/,
     *          '' ////// CURRENT VALUES: ICSKIP='',I2,
     *          ''; ICOUDI='',I2,''; ICOUEX='',I2,13X,5(''/''))')
     *              ICSKIP,ICOUDI,ICOUEX
C
          ERRSTR=' INCORRECT COULOMB PARAMETERS IN TESDAT'
          IERROR=1
C
      END IF
C
C=======================================================================
C
      IF (IPRGCM.GE.1.AND.IPROMA.GT.NDJMXD.AND.
     *   (NUAKNO.GT.1.OR.NUBKNO.GT.1)) THEN
C
          WRITE(NFIPRI,'(/,
     *                1X,19(1H/),5X,''IPROMA/2>NDJMXD=70'',5X,19(1H/),/,
     *                1X,19(1H/),1X,''INCREASE NDJMXD=70 IN DSMALG'',1X,
     *                                                      19(1H/),/)')
C
          ERRSTR=' IPROMA/2>NDJMXD=70, INCREASE NDJMXD=70 IN DSMALG'
          IERROR=1
C
      END IF
C
C=======================================================================
C
      IF (IPRGCM.GE.1.AND.IPROMI.GT.IPROMA.AND.
     *   (NUAKNO.GT.1.OR.NUBKNO.GT.1)) THEN
C
          WRITE(NFIPRI,'(/,
     *                 1X,20(1H/),4X,''IPROMI.GT.IPROMA:'',3X,20(1H/),/,
     *                 1X,20(1H/),7X,I3,   ''.GT.''  ,I3,7X,20(1H/),/)')
     *                 IPROMI,IPROMA
C
          ERRSTR=' IPROMI.GT.IPROMA IN TESDAT'
          IERROR=1
C
      END IF
C
C=======================================================================
C
      IF (IPRGCM.GE.1.AND.IROTAT.NE.1) THEN
C
          WRITE(NFIPRI,'(/,
     *                 1X,20(1H/),'' IPRGCM>0 REQUIRES IROTAT=1,'',
     *                            '' FOR NOW'',       2X,20(1H/),/)')
C
          ERRSTR=' IPRGCM>0 REQUIRES IROTAT=1 IN TESDAT'
          IERROR=1
C
      END IF
C
C=======================================================================
C
      IF (IPRGCM.GE.1.AND.IPAIRI.EQ.1) THEN
C
          WRITE(NFIPRI,'(/,
     *                 1X,20(1H/),'' IPRGCM>0 REQUIRES IPAIRI=0,'',
     *                            '' FOR NOW'',       2X,20(1H/),/)')
C
          ERRSTR=' IPRGCM>0 REQUIRES IPAIRI=0 IN TESDAT'
          IERROR=1
C
      END IF
C
C=======================================================================
C
      IF (IPRGCM.GE.1.AND.(NUAKNO.LT.1.OR.NUBKNO.LT.1)) THEN
C
          WRITE(NFIPRI,'(/,
     *                 1X,20(1H/),'' INCORRECT VALUE OF NUAKNO ='',I4,
     *                            '' OR'',       2X,20(1H/),/,
     *                 1X,20(1H/),'' INCORRECT VALUE OF NUBKNO ='',I4,
     *                            ''   '',       2X,20(1H/),/)')
     *              NUAKNO,NUBKNO
C
          ERRSTR=' INCORRECT VALUE OF NUAKNO OR NUBKNO IN TESDAT'
          IERROR=1
C
      END IF
C
C=======================================================================
C
      IF (IPRGCM.GE.1.AND.
     *   (NUAKNO.GT.1.OR.NUBKNO.GT.1).AND.
     *   (IPROMI.LT.0.OR.IPROMA.LT.0)) THEN
C
          WRITE(NFIPRI,'(/,
     *                 1X,20(1H/),'' INCORRECT VALUE OF IPROMI ='',I4,
     *                            '' OR'',       2X,20(1H/),/,
     *                 1X,20(1H/),'' INCORRECT VALUE OF IPROMA ='',I4,
     *                            ''   '',       2X,20(1H/),/)')
     *              IPROMI,IPROMA
C
          ERRSTR=' INCORRECT VALUE OF IPROMI OR IPROMA IN TESDAT'
          IERROR=1
C
      END IF
C
C=======================================================================
C
      IF (IPRGCM.GE.1.AND.
     *   (NUAKNO.GT.1.OR.NUBKNO.GT.1).AND.
     *   (MOD(IN_FIX+IZ_FIX,2).NE.MOD(IPROMI,2).OR.
     *    MOD(IN_FIX+IZ_FIX,2).NE.MOD(IPROMA,2))) THEN
C
          WRITE(NFIPRI,'(/,
     *                 1X,20(1H/),'' VALUE OF IPROMI='',I3,'' OR'',
     *                            '' IPROMA='',I3,       2X,20(1H/),/,
     *                 1X,20(1H/),'' IS INCOMPATIBLE WITH PARTICLE'',
     *                            '' NOS.'',             2X,20(1H/),/)')
     *              IPROMI,IPROMA
C
          ERRSTR=' IPROMI/IPROMA INCOMPATIBLE WITH PART.NOS. IN TESDAT'
          IERROR=1
C
      END IF
C
C=======================================================================
C
      IF (IPRGCM.GE.1.AND.NUAKNO.EQ.1.AND.NUBKNO.GT.1.AND.
     *    MOD(IN_FIX+IZ_FIX,2).NE.MOD(IABS(KPROJE),2)) THEN
C
          WRITE(NFIPRI,'(/,
     *                 1X,20(1H/),'' VALUE OF KPROJE='',I3,
     *                                                  16X,20(1H/),/,
     *                 1X,20(1H/),'' IS INCOMPATIBLE WITH PARTICLE'',
     *                            '' NOS.'',             2X,20(1H/),/)')
     *              KPROJE
C
          ERRSTR=' KPROJE IS INCOMPATIBLE WITH PARTICLE NOS. IN TESDAT'
          IERROR=1
C
      END IF
C
C=======================================================================
C
      IF (IPRGCM.GE.1.AND.NUAKNO.EQ.1.AND.NUBKNO.GT.1.AND.
     *    ABS(KPROJE).GT.IPROMA) THEN
C
          WRITE(NFIPRI,'(/,
     *                 1X,20(1H/),'' VALUE OF KPROJE='',I3,
     *                                                16X,20(1H/),/,
     *                 1X,20(1H/),'' IS INCOMPATIBLE WITH IPROMA='',I3,
     *                            ''   '',             2X,20(1H/),/)')
     *              KPROJE,IPROMA
C
          ERRSTR=' KPROJE IS INCOMPATIBLE WITH IPROMA IN TESDAT'
          IERROR=1
C
      END IF
C
C=======================================================================
C
      IF (IPRGCM.GE.1.AND.NUAKNO.GT.1.AND.
     *   (ISIMPY.EQ.1.OR.ISIGNY.EQ.1)) THEN
C
          WRITE(NFIPRI,'(/,
     *                 1X,20(1H/),'' NUAKNO>1  (3D ANG. MOM.'',
     *                            '' PROJECTION)'',      1X,20(1H/),/,
     *                 1X,20(1H/),'' IS INCOMPATIBLE  WITH  ISIMPY=1 '',
     *                            '' OR'',               1X,20(1H/),/,
     *                 1X,20(1H/),''             NOR  WITH  ISIGNY=1 '',
     *                            ''   '',               1X,20(1H/),/)')
C
          ERRSTR=' NUAKNO>1 INCOMPATIBLE WITH ISIMPY/ISIGNY=1 IN TESDAT'
          IERROR=1
C
      END IF
C
C=======================================================================
C
      IF (IPAKER.EQ.1.AND.(NUASTA.LT.1.OR.NUASTO.GT.NUAKNO.OR.
     *                                    NUASTA.GT.NUASTO.OR.
     *                     NUGSTA.LT.1.OR.NUGSTO.GT.NUAKNO.OR.
     *                                    NUGSTA.GT.NUGSTO)) THEN
C
          WRITE(NFIPRI,'(/,
     *                 1X,20(1H/),'' INCORRECT VALUE OF NUASTA ='',I4,
     *                            '' OR'',       2X,20(1H/),/,
     *                 1X,20(1H/),'' INCORRECT VALUE OF NUASTO ='',I4,
     *                            '' OR'',       2X,20(1H/),/,
     *                 1X,20(1H/),'' INCORRECT VALUE OF NUGSTA ='',I4,
     *                            '' OR'',       2X,20(1H/),/,
     *                 1X,20(1H/),'' INCORRECT VALUE OF NUGSTO ='',I4,
     *                            ''   '',       2X,20(1H/),/)')
     *
     *              NUASTA,NUASTO,NUGSTA,NUGSTO
C
          ERRSTR=' VALUES OF NUASTA/NUASTO/NUGSTA/NUGSTO IN TESDAT'
          IERROR=1
C
      END IF
C
C=======================================================================
C
      IF (IPAKER.EQ.1.AND.IPRGCM.LT.1) THEN
C
          WRITE(NFIPRI,'(/,
     *                 1X,20(1H/),'' IPAKER=1 REQUIRES IPRGCM>0'',
     *                            ''        '',       2X,20(1H/),/)')
C
          ERRSTR=' IPAKER=1 REQUIRES IPRGCM>0 IN TESDAT'
          IERROR=1
C
      END IF
C
C=======================================================================
C
      IF (IPAALL.EQ.1.AND.IPAKER.NE.1) THEN
C
          WRITE(NFIPRI,'(/,
     *                 1X,20(1H/),'' IPAALL=1 REQUIRES IPAKER=1'',
     *                            ''        '',       2X,20(1H/),/)')
C
          ERRSTR=' IPAALL=1 REQUIRES IPAKER=1 IN TESDAT'
          IERROR=1
C
      END IF
C
C=======================================================================
C
      IF (IPAALL.EQ.1.AND.(NUBSTA.LT.1.OR.NUBSTO.GT.NUBKNO.OR.
     *                                    NUBSTA.GT.NUBSTO.OR.
     *                     NUTSTA.LT.1.OR.NUTSTO.GT.NBTKNO.OR.
     *                                    NUTSTA.GT.NUTSTO)) THEN
C
          WRITE(NFIPRI,'(/,
     *                 1X,20(1H/),'' INCORRECT VALUE OF NUBSTA ='',I4,
     *                            '' OR'',       2X,20(1H/),/,
     *                 1X,20(1H/),'' INCORRECT VALUE OF NUBSTO ='',I4,
     *                            '' OR'',       2X,20(1H/),/,
     *                 1X,20(1H/),'' INCORRECT VALUE OF NUTSTA ='',I4,
     *                            '' OR'',       2X,20(1H/),/,
     *                 1X,20(1H/),'' INCORRECT VALUE OF NUTSTO ='',I4,
     *                            ''   '',       2X,20(1H/),/)')
     *
     *              NUBSTA,NUBSTO,NUTSTA,NUTSTO
C
          ERRSTR=' VALUES OF NUBSTA/NUBSTO/NUTSTA/NUTSTO IN TESDAT'
          IERROR=1
C
      END IF
C
C=======================================================================
C
      IF (ISAKER.GE.1.AND.IPRGCM.LT.1) THEN
C
          WRITE(NFIPRI,'(/,
     *                 1X,20(1H/),'' ISAKER>0 REQUIRES IPRGCM>0'',
     *                            ''        '',       2X,20(1H/),/)')
C
          ERRSTR=' ISAKER>0 REQUIRES IPRGCM>0 IN TESDAT'
          IERROR=1
C
      END IF
C
C=======================================================================
C
      IF (IPAKER.NE.0.AND.ISAKER.LT.1) THEN
C
          WRITE(NFIPRI,'(/,
     *                 1X,20(1H/),'' IPAKER<>0 REQUIRES ISAKER>0'',
     *                            ''       '',       2X,20(1H/),/)')
C
          ERRSTR=' IPAKER<>1 REQUIRES ISAKER>0 IN TESDAT'
          IERROR=1
C
      END IF
C
C=======================================================================
C
      IF (IPARAL.NE.0.AND.IPARAL.NE.1) THEN
C
          WRITE(NFIPRI,'(/,
     *                 1X,20(1H/),'' ONLY IPARAL=0 OR 1 ALLOWED,'',
     *                            '' NOW:'',I3,     2X,20(1H/),/)')
     *    IPARAL
C
          ERRSTR=' IPARAL OTHER THAN 0 OR 1 NOT ALLOWED IN TESDAT'
          IERROR=1
C
      END IF
C
C=======================================================================
C
      IF (IPARAL.EQ.1.AND.IPAKER.NE.1) THEN
C
          WRITE(NFIPRI,'(/,
     *                 1X,20(1H/),'' IPARAL=1 ALLOWED ONLY FOR '',
     *                            '' IPAKER=1'',       2X,20(1H/),/)')
C
          ERRSTR=' IPARAL=1 ALLOWED ONLY FOR IPAKER=1 IN TESDAT'
          IERROR=1
C
      END IF
C
C=======================================================================
C
      IF (KFIKER.GE.1.AND.ISAKER.LT.1) THEN
C
          WRITE(NFIPRI,'(/,
     *                 1X,20(1H/),'' KFIKER>0 ALLOWED ONLY FOR '',
     *                            '' ISAKER>0'',       2X,20(1H/),/)')
C
          ERRSTR=' KFIKER>0 ALLOWED ONLY FOR ISAKER>0 IN TESDAT'
          IERROR=1
C
      END IF
C
C=======================================================================
C
      IF (KFIKER.LT.1.AND.ISAKER.EQ.2) THEN
C
          WRITE(NFIPRI,'(/,
     *                 1X,20(1H/),'' KFIKER=0 NOT ALLOWED FOR '',
     *                            '' ISAKER=2'',       3X,20(1H/),/)')
C
          ERRSTR=' KFIKER=0 NOT ALLOWED FOR ISAKER=2 IN TESDAT'
          IERROR=1
C
      END IF
C
C=======================================================================
C
      IF (ISAKER.EQ.1.AND.(KFIKER.LT.0.OR.KFIKER.GT.999)) THEN
C
          WRITE(NFIPRI,'(/,
     *                 1X,20(1H/),'' ONLY 0=<KFIKER=<999 ALLOWED,'',
     *                            '' NOW:'',I6,     2X,20(1H/),/)')
     *    KFIKER
C
          ERRSTR=' KFIKER<0 OR KFIKER>999 NOT ALLOWED IN TESDAT'
          IERROR=1
C
      END IF
C
C=======================================================================
C
      IF (ISAKER.EQ.2.AND.(KFIKER.LT.0.OR.KFIKER.GT.99999)) THEN
C
          WRITE(NFIPRI,'(/,
     *                 1X,20(1H/),'' ONLY 0=<KFIKER=<99999 ALLOWED,'',
     *                            '' NOW:'',I8,     2X,20(1H/),/)')
     *    KFIKER
C
          ERRSTR=' KFIKER<0 OR KFIKER>99999 NOT ALLOWED IN TESDAT'
          IERROR=1
C
      END IF
C
C=======================================================================
C
      IF (IPRGCM.EQ.2.AND.(NUAKNO.GT.1.OR.NUBKNO.GT.1)) THEN
C
          WRITE(NFIPRI,'(/,
     *                 1X,20(1H/),'' IPRGCM=2 REQUIRES NUAKNO=1'',
     *                            ''         '',      2X,20(1H/),/,
     *                 1X,20(1H/),''               AND NUBKNO=1,'',
     *                            '' FOR NOW'',       2X,20(1H/),/)')
C
          ERRSTR=' IPRGCM=2 REQUIRES NUAKNO=1 AND NUBKNO=1 IN TESDAT'
          IERROR=1
C
      END IF
C
C=======================================================================
C
      IF (IPRGCM.GE.1.AND.(INIROT.GE.1.OR.
     *                     INIINV.GE.1.OR.
     *                     INIKAR.GE.1)) THEN
C
          WRITE(NFIPRI,'(/,
     *                 1X,20(1H/),'' IPRGCM>0 REQUIRES INIROT=0'',
     *                            ''         '',      2X,20(1H/),/,
     *                 1X,20(1H/),'' AND INIINV=0  AND INIKAR=0'',
     *                            ''         '',       2X,20(1H/),/)')
C
          ERRSTR=' IPRGCM>0 REQUIRES INIROT=INIINV=INIKAR=0 IN TESDAT'
          IERROR=1
C
      END IF
C
C=======================================================================
C
      IF (IFCONT.GE.1.AND.(INIROT.GE.1.OR.
     *                     INIINV.GE.1.OR.
     *                     INIKAR.GE.1)) THEN
C
          WRITE(NFIPRI,'(/,
     *                 1X,20(1H/),'' IFCONT=1 REQUIRES INIROT=0'',
     *                            ''         '',      2X,20(1H/),/,
     *                 1X,20(1H/),'' AND INIINV=0  AND INIKAR=0'',
     *                            ''         '',       2X,20(1H/),/)')
C
          ERRSTR=' IFCONT=1 REQUIRES INIROT=INIINV=INIKAR=0 IN TESDAT'
          IERROR=1
C
      END IF
C
C=======================================================================
C
      IF (ILCONT.GE.1.AND.(INIROT.GE.1.OR.
     *                     INIINV.GE.1.OR.
     *                     INIKAR.GE.1)) THEN
C
          WRITE(NFIPRI,'(/,
     *                 1X,20(1H/),'' ILCONT=1 REQUIRES INIROT=0'',
     *                            ''         '',      2X,20(1H/),/,
     *                 1X,20(1H/),'' AND INIINV=0  AND INIKAR=0'',
     *                            ''         '',       2X,20(1H/),/)')
C
          ERRSTR=' ILCONT=1 REQUIRES INIROT=INIINV=INIKAR=0 IN TESDAT'
          IERROR=1
C
      END IF
C
C=======================================================================
C
      IF (IWRIOL.EQ.1.AND.(INIROT.GE.1.OR.
     *                     INIINV.GE.1.OR.
     *                     INIKAR.GE.1)) THEN
C
          WRITE(NFIPRI,'(/,
     *                 1X,20(1H/),'' NONE OF INIROT>0, INIINV>0,'',
     *                            '' INIKAR>0'',      1X,20(1H/),/,
     *                 1X,20(1H/),'' IS COMPATIBLE WITH IWRIOL=1'',
     *                            ''         '',      1X,20(1H/),/)')
C
          ERRSTR=' INIROT/INIINV/INIKAR>0 REQUIRES IWRIOL=0 IN TESDAT'
          IERROR=1
C
      END IF
C
C=======================================================================
C
      IF (IPRGCM.GE.1.AND.ISYMDE.EQ.1) THEN
C
          WRITE(NFIPRI,'(/,
     *                 1X,20(1H/),'' IPRGCM>0 REQUIRES ISYMDE=0'',
     *                            ''         '',       2X,20(1H/),/)')
C
          ERRSTR=' IPRGCM>0 REQUIRES ISYMDE=0 IN TESDAT'
          IERROR=1
C
      END IF
C
C=======================================================================
C
      IF (IPRGCM.EQ.2.AND.(IFRWAV.LT.1.OR.IFRWAV.GT.999)) THEN
C
          WRITE(NFIPRI,'(/,
     *                 1X,20(1H/),'' IPRGCM=2 REQUIRES 0<IFRWAV<1000'',
     *                            ''   '',       2X,20(1H/),/)')
C
          ERRSTR=' INCORRECT IFRWAV FOR IPRGCM=2 IN TESDAT'
          IERROR=1
C
      END IF
C
C=======================================================================
C
      IF (IPRGCM.EQ.2.AND.(ITOWAV.LT.1.OR.ITOWAV.GT.999)) THEN
C
          WRITE(NFIPRI,'(/,
     *                 1X,20(1H/),'' IPRGCM=2 REQUIRES 0<ITOWAV<1000'',
     *                            ''   '',       2X,20(1H/),/)')
C
          ERRSTR=' INCORRECT ITOWAV FOR IPRGCM=2 IN TESDAT'
          IERROR=1
C
      END IF
C
C=======================================================================
C
      IF (IPRGCM.EQ.1.AND.ISAKER.GE.1.AND.
     *   (ITOWAV.LT.1.OR.ITOWAV.GT.999)) THEN
C
          WRITE(NFIPRI,'(/,
     *                 1X,20(1H/),'' IPRGCM=1 AND ISAKER>0 REQUIRES '',
     *                            ''   '',       2X,20(1H/),/,
     *                 1X,20(1H/),'' 0<ITOWAV<1000                  '',
     *                            ''   '',       2X,20(1H/),/)')
C
          ERRSTR=' INCORRECT ITOWAV FOR IPRGCM=1, ISAKER>0 IN TESDAT'
          IERROR=1
C
      END IF
C
C=======================================================================
C
      IF (IWRWAV.EQ.1.AND.(ITOWAV.LT.1.OR.ITOWAV.GT.999)) THEN
C
          WRITE(NFIPRI,'(/,
     *                 1X,20(1H/),'' IWRWAV=1 REQUIRES 0<ITOWAV<1000'',
     *                            ''   '',       2X,20(1H/),/)')
C
          ERRSTR=' INCORRECT ITOWAV FOR IWRWAV=1 IN TESDAT'
          IERROR=1
C
      END IF
C
C=======================================================================
C
      IF (IPRGCM.EQ.2.AND.IFRWAV.GT.ITOWAV) THEN
C
          WRITE(NFIPRI,'(/,
     *                 1X,20(1H/),'' IPRGCM = 2 REQUIRES IFRWAV'',
     *                            '' <= ITOWAV'',       1X,20(1H/),/)')
C
          ERRSTR=' IFRWAV.GT.ITOWAV FOR IPRGCM=2 IN TESDAT'
          IERROR=1
C
      END IF
C
C=======================================================================
C
      DO LAMBDA=1,NDMULT
         DO MIU=-LAMBDA,LAMBDA
C
            IF (IFLAGQ(LAMBDA,MIU).EQ.1) THEN
C
                IF (LAMBDA.GT.NMUCON) THEN
C
                    WRITE(NFIPRI,'(/,
     *                           1X,13(1H/),'' ERROR: THE MULTIPOLE'',
     *                                      '' CONSTRAINT FOR LAMBDA='',
     *                                   I1,'' IS'',       1X,13(1H/),/,
     *                           1X,13(1H/),'' INCOMPATIBLE WITH'',
     *                                      '' NMUCON='',I1,22X,
     *                                                     1X,13(1H/),/
     *
     *                                                )') LAMBDA,NMUCON
C
                    WRITE(ERRSTR,'('' SYMMETRIES AND MULTIPOLE '',
     *                             ''MOMENTS (IFLAGQ) IN TESDAT'')')
                    IERROR=1
C
                END IF
C
                IF (MIU.LT.0.AND.ISIMPY.EQ.1) THEN
C
                    WRITE(NFIPRI,'(/,
     *                           1X,13(1H/),'' ERROR: THE MULTIPOLE'',
     *                                      '' CONSTRAINT FOR LAMBDA='',
     *                                   I2,''   '',       1X,12(1H/),/,
     *                           1X,13(1H/),''                       '',
     *                                      ''               AND MIU='',
     *                                   I2,'' IS'',       1X,12(1H/),/,
     *                           1X,13(1H/),'' INCOMPATIBLE WITH'',
     *                                      '' ISIMPY=1,'',22X,
     *                                                     1X,12(1H/),/
     *
     *                                                )') LAMBDA,MIU
C
                    WRITE(ERRSTR,'('' SYMMETRIES AND MULTIPOLE '',
     *                             ''MOMENTS (IFLAGQ) IN TESDAT'')')
                    IERROR=1
C
                END IF
C
                IF (MOD(LAMBDA,2).NE.0.AND.ISIQTY.EQ.1) THEN
C
                    WRITE(NFIPRI,'(/,
     *                           1X,13(1H/),'' ERROR: THE MULTIPOLE'',
     *                                      '' CONSTRAINT FOR LAMBDA='',
     *                                   I2,''   '',       1X,12(1H/),/,
     *                           1X,13(1H/),''                       '',
     *                                      ''               AND MIU='',
     *                                   I2,'' IS'',       1X,12(1H/),/,
     *                           1X,13(1H/),'' INCOMPATIBLE WITH'',
     *                                      '' IPARTY=1,'',22X,
     *                                                     1X,12(1H/),/
     *
     *                                                )') LAMBDA,MIU
C
                    WRITE(ERRSTR,'('' SYMMETRIES AND MULTIPOLE '',
     *                             ''MOMENTS (IFLAGQ) IN TESDAT'')')
                    IERROR=1
C
                END IF
C
            END IF
C
         END DO
      END DO
C
C=======================================================================
C
      ISLALQ=0
C
      DO LAMBDA=1,NDMULT
         DO MIU=-LAMBDA,LAMBDA
C
            IF (IFLALQ(LAMBDA,MIU).EQ.1) THEN
C
                ISLALQ=1
C
                IF (IFLAGQ(LAMBDA,MIU).NE.1) THEN
C
                    WRITE(NFIPRI,'(/,
     *                           1X,13(1H/),'' WARNING: THE LIN. MULT'',
     *                                      '' CONSTRAINT FOR LAMBDA='',
     *                                   I2,''   '',       1X,12(1H/),/,
     *                           1X,13(1H/),''                       '',
     *                                      ''               AND MIU='',
     *                                   I2,'' IS'',       1X,12(1H/),/,
     *                           1X,13(1H/),'' INCOMPATIBLE WITH'',
     *                                      '' IFLAGQ=0,'',22X,
     *                                                     1X,12(1H/),/
     *
     *                                                )') LAMBDA,MIU
C
                    WRITE(ERRSTR,'('' LINEAR CONSTRAINT AND MULTIPOLE'',
     *                             ''MOMENT (IFLAGQ) IN TESDAT'')')
                    IERROR=1
C
                END IF
C
                IF (LAMBDA.GT.NMUCON) THEN
C
                    WRITE(NFIPRI,'(/,
     *                           1X,13(1H/),'' WARNING: THE LIN. MULT'',
     *                                      '' CONSTRAINT FOR LAMBDA='',
     *                                   I1,'' IS'',       1X,13(1H/),/,
     *                           1X,13(1H/),'' INCOMPATIBLE WITH'',
     *                                      '' NMUCON='',I1,22X,
     *                                                     1X,13(1H/),/
     *
     *                                                )') LAMBDA,NMUCON
C
                    WRITE(ERRSTR,'('' LINEAR CONSTRAINT AND MULTIPOLE'',
     *                             ''ORDER (NMUCON) IN TESDAT'')')
                    IERROR=1
C
                END IF
C
                IF (MIU.LT.0.AND.ISIMPY.EQ.1) THEN
C
                    WRITE(NFIPRI,'(/,
     *                           1X,13(1H/),'' WARNING: THE LIN. MULT'',
     *                                      '' CONSTRAINT FOR LAMBDA='',
     *                                   I2,''   '',       1X,12(1H/),/,
     *                           1X,13(1H/),''                       '',
     *                                      ''               AND MIU='',
     *                                   I2,'' IS'',       1X,12(1H/),/,
     *                           1X,13(1H/),'' INCOMPATIBLE WITH'',
     *                                      '' ISIMPY=1,'',22X,
     *                                                     1X,12(1H/),/
     *
     *                                                )') LAMBDA,MIU
C
                    WRITE(ERRSTR,'('' SYMMETRIES AND LINEAR '',
     *                             ''CONSTRAINTS (IFLALQ) IN TESDAT'')')
                    IERROR=1
C
                END IF
C
                IF (MOD(LAMBDA,2).NE.0.AND.ISIQTY.EQ.1) THEN
C
                    WRITE(NFIPRI,'(/,
     *                           1X,13(1H/),'' WARNING: THE LIN. MULT'',
     *                                      '' CONSTRAINT FOR LAMBDA='',
     *                                   I2,''   '',       1X,12(1H/),/,
     *                           1X,13(1H/),''                       '',
     *                                      ''               AND MIU='',
     *                                   I2,'' IS'',       1X,12(1H/),/,
     *                           1X,13(1H/),'' INCOMPATIBLE WITH'',
     *                                      '' IPARTY=1,'',22X,
     *                                                     1X,12(1H/),/
     *
     *                                                )') LAMBDA,MIU
C
                    WRITE(ERRSTR,'('' SYMMETRIES AND LINEAR '',
     *                             ''CONSTRAINTS (IFLALQ) IN TESDAT'')')
                    IERROR=1
C
                END IF
C
            END IF
C
         END DO
      END DO
C
C=======================================================================
C
      DO LAMBDA=0,NDMULT
         DO MIU=-LAMBDA,LAMBDA
C
            IF (IFLAGS(LAMBDA,MIU).GT.0) THEN
C
                IF (LAMBDA.GT.NSICON) THEN
C
                    WRITE(NFIPRI,'(/,
     *                           1X,13(1H/),'' WARNING: THE SURFACE  '',
     *                                      '' CONSTRAINT FOR LAMBDA='',
     *                                   I1,'' IS'',       1X,13(1H/),/,
     *                           1X,13(1H/),'' INCOMPATIBLE WITH'',
     *                                      '' NSICON='',I1,22X,
     *                                                     1X,13(1H/),/
     *
     *                                                )') LAMBDA,NSICON
C
                    WRITE(ERRSTR,'('' SURFACE MOMENTS AND MULTIPOLE'',
     *                             ''ORDER (NSICON) IN TESDAT'')')
                    IERROR=1
C
                END IF
C
                IF (MIU.LT.0.AND.ISIMPY.EQ.1) THEN
C
                    WRITE(NFIPRI,'(/,
     *                           1X,13(1H/),'' WARNING: THE SURFACE  '',
     *                                      '' CONSTRAINT FOR LAMBDA='',
     *                                   I2,''   '',       1X,12(1H/),/,
     *                           1X,13(1H/),''                       '',
     *                                      ''               AND MIU='',
     *                                   I2,'' IS'',       1X,12(1H/),/,
     *                           1X,13(1H/),'' INCOMPATIBLE WITH'',
     *                                      '' ISIMPY=1,'',22X,
     *                                                     1X,12(1H/),/
     *
     *                                                )') LAMBDA,MIU
C
                    WRITE(ERRSTR,'('' SURFACE MOMENTS AND ISIMPY '',
     *                             ''IN TESDAT'')')
                    IERROR=1
C
                END IF
C
                IF (MOD(LAMBDA,2).NE.0.AND.ISIQTY.EQ.1) THEN
C
                    WRITE(NFIPRI,'(/,
     *                           1X,13(1H/),'' WARNING: THE SURFACE  '',
     *                                      '' CONSTRAINT FOR LAMBDA='',
     *                                   I2,''   '',       1X,12(1H/),/,
     *                           1X,13(1H/),''                       '',
     *                                      ''               AND MIU='',
     *                                   I2,'' IS'',       1X,12(1H/),/,
     *                           1X,13(1H/),'' INCOMPATIBLE WITH'',
     *                                      '' IPARTY=1,'',22X,
     *                                                     1X,12(1H/),/
     *
     *                                                )') LAMBDA,MIU
C
                    WRITE(ERRSTR,'('' SURFACE MOMENTS AND ISIQTY '',
     *                             ''IN TESDAT'')')
                    IERROR=1
C
                END IF
C
            END IF
C
         END DO
      END DO
C
C=======================================================================
C             TESTING CONSISTENCY OF LINEAR CONSTRAINTS
C=======================================================================
C
cC      In this version, the RPA matrix has not been adapted to the
cC      finite-temperature formalism: IF_RPA=1 is incompatible with
cC      IFTEMP=1
cC
c      IF (IF_RPA.EQ.1.AND.IFTEMP.EQ.1) THEN
cC
c          WRITE(NFIPRI,'(/,1X,23(''/''),
c     *         '' IF_RPA = 1 REQUIRES IFTEMP=0 '',1X,23(''/''),/)')
C
c          STOP 'IF_RPA=1 VS. IFTEMP=1 IN TESDAT'
cC
c      END IF
C
C      Multi constraints using the approximation of the RPA matrix are
C      only available in static (omega=0), simplex-conversing HFB case
C
      IF ((IF_RPA.EQ.1.AND.IPAHFB.LT.1).OR.
     *    (IF_RPA.EQ.1.AND.ISIMPY.NE.1).OR.
     *    (IF_RPA.EQ.1.AND.IROTAT.EQ.1)) THEN
C
          WRITE(NFIPRI,'(/,1X,10(''/''),
     *          '' IF_RPA = 1 REQUIRES IPAHFB>0 AND ISIMPY = 1 '',
     *          ''AND IROTAT = 0'',1X,9(''/''),/)')
C
          ERRSTR='IF_RPA=1 VS. IPAHFB/ISIMPY/IROTAT IN TESDAT'
          IERROR=1
C
      END IF
C
C      Values of the constraints are set under the keyword MULTCONSTR
C      and require IFLAGQ flags to be 1 to be activated. For the RPA
C      method of linear constraint to work, all corresponding IFLALQ
C      flags must also be set to -1.
C
      IF (IF_RPA.EQ.1) THEN
C
          NMESSG=0
          NSWITC=0
          NACTIV=0
C
          DO LAMBDA=1,NDMULT
             DO MIU=0,LAMBDA
C
                IF (IFLAGQ(LAMBDA,MIU).EQ. 1) NMESSG=NMESSG+1
                IF (IFLALQ(LAMBDA,MIU).EQ.-1) NSWITC=NSWITC+1
C
             END DO
          END DO
C
          IF (NMESSG.GT.0.AND.NSWITC.NE.NMESSG) THEN
C
              DO LAMBDA=1,NDMULT
                 DO MIU=0,LAMBDA
C
                    IF (IFLAGQ(LAMBDA,MIU).EQ. 1.AND.
     *                  IFLALQ(LAMBDA,MIU).NE.-1) THEN
C
                        NACTIV=NACTIV+1
                        IFLALQ(LAMBDA,MIU)=-1
C
                    END IF
C
                 END DO
              END DO
C
              WRITE(NFIPRI,'(
     *             '' ////////////////////////////////////////'',
     *             ''//////////////////////////////////////'',/,
     *             '' ////       ERROR: IF_RPA = 1 REQUIRES '',
     *             '' ACTIVE * LINEAR * CONSTRAINTS     /////'',/,
     *             '' ////                                    '',
     *             ''                                 /////'',/,
     *             '' ////               '',I2,
     *             '' LINEAR CONSTRAINTS '',
     *             ''MUST BE ACTIVATED               /////'',/,
     *             '' ////////////////////////////////////////'',
     *             ''//////////////////////////////////////'')')
     *               NACTIV
C
              WRITE(ERRSTR,'('' RPA METHOD AND LINEAR CONSTRAINTS '',
     *                       ''(IFLALQ) IN TESDAT'')')
              IERROR=1
C
          END IF
C
      END IF
C
C      Some inconsistencies between the multipolarity of the
C      constraint and the assumed symmetries will stop the
C      program
C
      DO LAMBDA=1,NDMULT
         DO MIU=-LAMBDA,LAMBDA
C
            IF (ABS(IFLALQ(LAMBDA,MIU)).EQ.1) THEN
C
                ISLALQ=1
C
                IF (IFLAGQ(LAMBDA,MIU).NE.1) THEN
C
                    WRITE(NFIPRI,'(/,
     *                           1X,13(1H/),'' WARNING: THE LIN. MULT'',
     *                                      '' CONSTRAINT FOR LAMBDA='',
     *                                   I2,''   '',       1X,12(1H/),/,
     *                           1X,13(1H/),''                       '',
     *                                      ''               AND MIU='',
     *                                   I2,'' IS'',       1X,12(1H/),/,
     *                           1X,13(1H/),'' INCOMPATIBLE WITH'',
     *                                      '' IFLAGQ=0,'',
     *                                      '' AND HAS BEEN REMOVED. '',
     *                                                     1X,12(1H/),/
     *
     *                                                )') LAMBDA,MIU
C
                    WRITE(ERRSTR,'('' RPA METHOD AND CONSTRAINTS '',
     *                             ''(IFLAGQ) IN TESDAT'')')
                    IERROR=1
C
                END IF
C
                IF (LAMBDA.GT.NMUCON) THEN
C
                    WRITE(NFIPRI,'(/,
     *                           1X,13(1H/),'' WARNING: THE LIN. MULT'',
     *                                      '' CONSTRAINT FOR LAMBDA='',
     *                                   I1,'' IS'',       1X,13(1H/),/,
     *                           1X,13(1H/),'' INCOMPATIBLE WITH'',
     *                                      '' NMUCON='',I1,'','',
     *                                      '' AND HAS BEEN REMOVED.'',
     *                                                     1X,13(1H/),/
     *
     *                                                )') LAMBDA,NMUCON
C
                    WRITE(ERRSTR,'('' RPA METHOD AND MOMENTS '',
     *                             ''(NUMCON) IN TESDAT'')')
                    IERROR=1
C
                END IF
C
                IF (MIU.LT.0.AND.ISIMPY.EQ.1) THEN
C
                    WRITE(NFIPRI,'(/,
     *                           1X,13(1H/),'' ! STOP ! THE LIN. MULT'',
     *                                      '' CONSTRAINT FOR LAMBDA='',
     *                                   I2,''   '',       1X,12(1H/),/,
     *                           1X,13(1H/),''                       '',
     *                                      ''               AND MIU='',
     *                                   I2,'' IS'',       1X,12(1H/),/,
     *                           1X,13(1H/),'' INCOMPATIBLE WITH'',
     *                                      '' ISIMPY=1.'',
     *                                      ''                       '',
     *                                                     1X,12(1H/),/
     *
     *                                                )') LAMBDA,MIU
C
                    WRITE(ERRSTR,'('' RPA METHOD AND ISIMPY '',
     *                             ''(IFLALQ) IN TESDAT'')')
                    IERROR=1
C
                END IF
C
                IF (MOD(LAMBDA,2).NE.0.AND.ISIQTY.EQ.1) THEN
C
                    WRITE(NFIPRI,'(/,
     *                           1X,13(1H/),'' ! STOP ! THE LIN. MULT'',
     *                                      '' CONSTRAINT FOR LAMBDA='',
     *                                   I2,''   '',       1X,12(1H/),/,
     *                           1X,13(1H/),''                       '',
     *                                      ''               AND MIU='',
     *                                   I2,'' IS'',       1X,12(1H/),/,
     *                           1X,13(1H/),'' INCOMPATIBLE WITH'',
     *                                      '' ISIQTY=1,'',
     *                                      ''                       '',
     *                                                     1X,12(1H/),/
     *
     *                                                )') LAMBDA,MIU
C
                    WRITE(ERRSTR,'('' RPA METHOD AND ISIQTY '',
     *                             ''(IFLALQ) IN TESDAT'')')
                    IERROR=1
C
                END IF
C
                IF (MOD(LAMBDA,2).NE.0.AND.ISIMTZ.EQ.1) THEN
C
                    WRITE(NFIPRI,'(/,
     *                           1X,13(1H/),'' ! STOP ! THE LIN. MULT'',
     *                                      '' CONSTRAINT FOR LAMBDA='',
     *                                   I2,''   '',       1X,12(1H/),/,
     *                           1X,13(1H/),''                       '',
     *                                      ''               AND MIU='',
     *                                   I2,'' IS'',       1X,12(1H/),/,
     *                           1X,13(1H/),'' INCOMPATIBLE WITH'',
     *                                      '' ISIMTZ=1,'',
     *                                      ''                       '',
     *                                                     1X,12(1H/),/
     *
     *                                                )') LAMBDA,MIU
C
                    WRITE(ERRSTR,'('' RPA METHOD AND ISIMTZ '',
     *                             ''(IFLALQ) IN TESDAT'')')
                    IERROR=1
C
                END IF
C
            END IF
C
         END DO
      END DO
C
C=======================================================================
C
      ISLALS=0
C
      DO LAMBDA=0,NDMULT
         DO MIU=-LAMBDA,LAMBDA
C
            IF (IFLALS(LAMBDA,MIU).NE.0) THEN
C
                ISLALS=1
C
                IF (LAMBDA.GT.NSICON) THEN
C
                    WRITE(NFIPRI,'(/,
     *                           1X,13(1H/),'' WARNING: THE LIN. SURF'',
     *                                      '' CONSTRAINT FOR LAMBDA='',
     *                                   I1,'' IS'',       1X,13(1H/),/,
     *                           1X,13(1H/),'' INCOMPATIBLE WITH'',
     *                                      '' NSICON='',I1,22X,
     *                                                     1X,13(1H/),/
     *
     *                                                )') LAMBDA,NSICON
C
                    WRITE(ERRSTR,'('' LINEAR SURFACE CONSTRAINT AND'',
     *                             ''NSICON IN TESDAT'')')
                    IERROR=1
C
                END IF
C
                IF (MIU.LT.0.AND.ISIMPY.EQ.1) THEN
C
                    WRITE(NFIPRI,'(/,
     *                           1X,13(1H/),'' WARNING: THE LIN. SURF'',
     *                                      '' CONSTRAINT FOR LAMBDA='',
     *                                   I2,''   '',       1X,12(1H/),/,
     *                           1X,13(1H/),''                       '',
     *                                      ''               AND MIU='',
     *                                   I2,'' IS'',       1X,12(1H/),/,
     *                           1X,13(1H/),'' INCOMPATIBLE WITH'',
     *                                      '' ISIMPY=1,'',22X,
     *                                                     1X,12(1H/),/
     *
     *                                                )') LAMBDA,MIU
                    WRITE(ERRSTR,'('' LINEAR SURFACE CONSTRAINTS AND '',
     *                             ''ISIMPY IN TESDAT'')')
                    IERROR=1
C
                END IF
C
                IF (MOD(LAMBDA,2).NE.0.AND.ISIQTY.EQ.1) THEN
C
                    WRITE(NFIPRI,'(/,
     *                           1X,13(1H/),'' WARNING: THE LIN. SURF'',
     *                                      '' CONSTRAINT FOR LAMBDA='',
     *                                   I2,''   '',       1X,12(1H/),/,
     *                           1X,13(1H/),''                       '',
     *                                      ''               AND MIU='',
     *                                   I2,'' IS'',       1X,12(1H/),/,
     *                           1X,13(1H/),'' INCOMPATIBLE WITH'',
     *                                      '' IPARTY=1,'',22X,
     *                                                     1X,12(1H/),/
     *
     *                                                )') LAMBDA,MIU
C
                    WRITE(ERRSTR,'('' LINEAR SURFACE CONSTRAINTS AND '',
     *                             ''ISIQTY IN TESDAT'')')
                    IERROR=1
C
                END IF
C
            END IF
C
         END DO
      END DO
C
C=======================================================================
C
      IF (IACONT.EQ.1.AND.ISLALQ.EQ.0.AND.ISLALS.EQ.0) THEN
C
          WRITE(NFIPRI,'(/,
     *                 1X,19(1H/),'' IACONT=1 IS INCOMPATIBLE WITH'',
     *                            '' NO AUG.LAG'',1X,19(1H/),/)')
C
          ERRSTR='IACONT=1 VS. NO AUG.LAG INCONSISTENCY IN TESDAT'
          IERROR=1
C
      END IF
C
C=======================================================================
C         THE TESTS BELOW ARE NOT REALLY NEEDED BY THE CODE.  THEY
C         ARE INTRODUCED HERE ONLY BECAUSE THE INFORMATION PRINTED
C         BY "INFPRI" HAS A SPECIFIC STRUCTURE. IT  REQUIRES  THAT
C         ALL FLAGS "IFLAGS" AND "IFLALS" HAVE THE SAME VALUES.
C=======================================================================
C
      DO LAMBDA=1,NDMULT
         DO MIU=-LAMBDA,LAMBDA
C
            JFLAGS=0
C
            IF (IFLAGS(LAMBDA,MIU).GT.0) THEN
C
               IF (JFLAGS.EQ.0) THEN
                   JFLAGS=IFLAGS(LAMBDA,MIU)
               ELSE
                   IF (JFLAGS.NE.IFLAGS(LAMBDA,MIU)) THEN
                       WRITE(ERRSTR,'('' ALL VALUES OF IFLAGS MUST '',
     *                                ''BE EQUAL IN TESDAT'')')
                       IERROR=1
                   END IF
               END IF
C
            END IF
C
         END DO
      END DO
C
C=======================================================================
C
      DO LAMBDA=0,NDMULT
         DO MIU=-LAMBDA,LAMBDA
C
            JFLALS=0
C
            IF (IFLALS(LAMBDA,MIU).NE.0) THEN
C
               IF (JFLALS.EQ.0) THEN
                   JFLALS=IFLALS(LAMBDA,MIU)
               ELSE
                   IF (JFLALS.NE.IFLALS(LAMBDA,MIU)) THEN
                       WRITE(ERRSTR,'('' ALL VALUES OF IFLALS MUST '',
     *                                ''BE EQUAL IN TESDAT'')')
                       IERROR=1
                   END IF
               END IF
C
            END IF
C
         END DO
      END DO
C
C=======================================================================
C
      DO LAMBDA=1,NDMULT
C
         IF (IFLAGG(LAMBDA).EQ.1) THEN
C
             IF (LAMBDA.GT.NMUCON) THEN
C
                 WRITE(NFIPRI,'(/,
     *                        1X,13(1H/),'' ERROR: THE  SCALAR  '',
     *                                   '' CONSTRAINT FOR LAMBDA='',
     *                                I1,'' IS  '',1X,13(1H/),/,
     *                        1X,13(1H/),'' INCOMPATIBLE WITH'',
     *                                   '' NMUCON='',I1,22X,
     *                        1X,13(1H/),/)') LAMBDA,NMUCON
C
                 WRITE(ERRSTR,'('' SCALAR CONSTRAINT AND NUMCON '',
     *                          ''IN TESDAT'')')
                 IERROR=1
C
             END IF
C
             IF (MOD(LAMBDA,2).NE.0.AND.ISIQTY.EQ.1) THEN
C
                 WRITE(NFIPRI,'(/,
     *                        1X,13(1H/),'' ERROR: THE  SCALAR  '',
     *                                   '' CONSTRAINT FOR LAMBDA='',
     *                                I2,'' IS  '',1X,12(1H/),/,
     *                        1X,13(1H/),'' INCOMPATIBLE WITH'',
     *                                   '' ISIQTY=1,'',22X,
     *                        1X,12(1H/),/)') LAMBDA
C
                 WRITE(ERRSTR,'('' SCALAR CONSTRAINT AND ISIQTY '',
     *                          ''IN TESDAT'')')
                 IERROR=1
C
             END IF
C
         END IF
C
      END DO
C
C=======================================================================
C
      IF (NMUCON.GT.NDMULT) THEN
C
          WRITE(NFIPRI,'(/,
     *                 1X,20(1H/),'' NMUCON='',I1,'' > NDMULT='',I1,
     *                                     1X,20(1H/),/)') NMUCON,NDMULT
C
          ERRSTR='NMUCON.GT.NDMULT IN TESDAT'
          IERROR=1
C
      END IF
C
C=======================================================================
C
      IF (NMUCOU.GT.NDMULT) THEN
C
          WRITE(NFIPRI,'(/,
     *                 1X,20(1H/),'' NMUCOU='',I1,'' > NDMULT='',I1,
     *                                     1X,20(1H/),/)') NMUCOU,NDMULT
C
          ERRSTR='NMUCOU.GT.NDMULT IN TESDAT'
          IERROR=1
C
      END IF
C
C=======================================================================
C
      IF (NMUPRI.GT.NDMULT) THEN
C
          WRITE(NFIPRI,'(/,
     *                 1X,20(1H/),'' NMUPRI='',I1,'' > NDMULT='',I1,
     *                                     1X,20(1H/),/)') NMUPRI,NDMULT
C
          ERRSTR='NMUPRI.GT.NDMULT IN TESDAT'
          IERROR=1
C
      END IF
C
C=======================================================================
C
      IF (IPRIBE.EQ.1.AND.NEXBET.GT.NMUPRI) THEN
C
          WRITE(NFIPRI,'(/,
     *                 1X,20(1H/),'' NEXBET='',I1,'' > NMUPRI='',I1,
     *                                     1X,20(1H/),/)') NEXBET,NMUPRI
C
          ERRSTR='NEXBET.GT.NMUPRI IN TESDAT'
          IERROR=1
C
      END IF
C
C=======================================================================
C
      IF (NILXYZ.LT.1.OR.NILXYZ.GT.3) THEN
C
          WRITE(NFIPRI,'(/,
     *                 1X,20(1H/),'' INCORRECT VALUE OF NILXYZ='',I3,
     *                            ''       '',1X,20(1H/),/)')
     *    NILXYZ
C
          ERRSTR=' INCORRECT VALUE OF NILXYZ IN TESDAT'
          IERROR=1
C
      END IF
C
C=======================================================================
C
      IF (NSICON.GT.NDMULT-2) THEN
C
          WRITE(NFIPRI,'(/,
     *                 1X,19(1H/),'' NSICON='',I1,'' > NDMULT-2='',I1,
     *                                  1X,19(1H/),/)') NSICON,NDMULT-2
C
          ERRSTR='NSICON.GT.NDMULT-2 IN TESDAT'
          IERROR=1
C
      END IF
C
C=======================================================================
C
      IF (NSIPRI.GT.NDMULT-2) THEN
C
          WRITE(NFIPRI,'(/,
     *                 1X,19(1H/),'' NSIPRI='',I1,'' > NDMULT-2='',I1,
     *                                  1X,19(1H/),/)') NSIPRI,NDMULT-2
C
          ERRSTR='NSIPRI.GT.NDMULT-2 IN TESDAT'
          IERROR=1
C
      END IF
C
C=======================================================================
C
      IF (NSICON.GT.NDMULT-4.AND.IDOPLM.EQ.1) THEN
C
          WRITE(NFIPRI,'(/,
     *                 1X,19(1H/),'' NSICON='',I1,'' > NDMULT-4='',I1,
     *                                  1X,19(1H/),/)') NSICON,NDMULT-4
C
          ERRSTR='NSICON.GT.NDMULT-4 AND IDOPLM=1 IN TESDAT'
          IERROR=1
C
      END IF
C
C=======================================================================
C
      IF (NSIPRI.GT.NDMULT-4.AND.IDOPLM.EQ.1) THEN
C
          WRITE(NFIPRI,'(/,
     *                 1X,19(1H/),'' NSIPRI='',I1,'' > NDMULT-4='',I1,
     *                                  1X,19(1H/),/)') NSIPRI,NDMULT-4
C
          ERRSTR='NSIPRI.GT.NDMULT-4 AND IDOPLM=1 IN TESDAT'
          IERROR=1
C
      END IF
C
C=======================================================================
C
      IF (NMACON.GT.0) THEN
C
          WRITE(NFIPRI,'(/,
     *                 1X,18(1H/),'' NMACON='',I2,'' > 0  WHILE'',3X,
     *                                  2X,18(1H/),/,
     *                 1X,18(1H/),'' CONSTRAINTS ON MAGNETIC'',
     *                                  2X,18(1H/),/,
     *                 1X,18(1H/),'' MOMENTS NOT IMPLEMENTED'',
     *                                  2X,18(1H/),/)') NMACON
C
          ERRSTR='NMACON.GT.0 IN TESDAT'
          IERROR=1
C
      END IF
C
C=======================================================================
C
      IF (NMAPRI.GT.0.AND.ISIQTY.NE.1) THEN
          WRITE(NFIPRI,'(/,
     *                 1X,18(1H/),'' NMAPRI='',I2,''>0 AND  PARITY'',
     *                                  2X,18(1H/),/,
     *                 1X,18(1H/),'' IS NOT CONSERVED. SINCE'',
     *                                  2X,18(1H/),/,
     *                 1X,18(1H/),'' MAGNETIC MOMENTS IN THE'',
     *                                  2X,18(1H/),/,
     *                 1X,18(1H/),'' C--O--M REFERENCE FRAME'',
     *                                  2X,18(1H/),/,
     *                 1X,18(1H/),'' ARE NOT YET IMPLEMENTED'',
     *                                  2X,18(1H/),/,
     *                 1X,18(1H/),'' ONLY LAB VALUES WILL BE'',
     *                                  2X,18(1H/),/,
     *                 1X,18(1H/),'' PRINTED ON  THE  OUTPUT'',
     *                                  2X,18(1H/),/)') NMAPRI
      END IF
C
C=======================================================================
C
      IF (NMAPRI.GT.NDMULT) THEN
C
          WRITE(NFIPRI,'(/,
     *                 1X,20(1H/),'' NMAPRI='',I2,''>NDMULT='',I2,
     *                                     2X,20(1H/),/)') NMAPRI,NDMULT
C
          ERRSTR='NMAPRI.GT.NDMULT IN TESDAT'
          IERROR=1
C
      END IF
C
C=======================================================================
C
      IF (IPRGCM.GE.1.AND.NDMULR.GT.NDMULT) THEN
C
          WRITE(NFIPRI,'(/,
     *                 1X,20(1H/),'' NDMULR='',I2,''>NDMULT='',I2,
     *                                     2X,20(1H/),/)') NDMULR,NDMULT
C
          ERRSTR='NDMULR.GT.NDMULT IN TESDAT'
          IERROR=1
C
      END IF
C
C=======================================================================
C
      IF (IPRGCM.GE.1.AND.NMURED.GT.NDMULR) THEN
C
          WRITE(NFIPRI,'(/,
     *                 1X,20(1H/),'' NMURED='',I2,''>NDMULR='',I2,
     *                                     2X,20(1H/),/)') NMURED,NDMULR
C
          ERRSTR='NMURED.GT.NDMULR IN TESDAT'
          IERROR=1
C
      END IF
C
C=======================================================================
C
      IF (IPRGCM.GE.1.AND.NMARED.GT.NDMULR) THEN
C
          WRITE(NFIPRI,'(/,
     *                 1X,20(1H/),'' NMARED='',I2,''>NDMULR='',I2,
     *                                     2X,20(1H/),/)') NMARED,NDMULR
C
          ERRSTR='NMARED.GT.NDMULR IN TESDAT'
          IERROR=1
C
      END IF
C
C=======================================================================
C
      IF (IPRGCM.GE.1.AND.NMARED.GT.NMURED) THEN
C
          WRITE(NFIPRI,'(/,
     *                 1X,20(1H/),'' NMARED='',I2,''>NMURED='',I2,
     *                                     2X,20(1H/),/)') NMARED,NMURED
C
          ERRSTR='NMARED.GT.NMURED IN TESDAT'
          IERROR=1
C
      END IF
C
C=======================================================================
C
      IF (IPRGCM.GE.1.AND.NSIRED.GT.NDMULR) THEN
C
          WRITE(NFIPRI,'(/,
     *                 1X,20(1H/),'' NSIRED='',I2,''>NDMULR='',I2,
     *                                     2X,20(1H/),/)') NSIRED,NDMULR
C
          ERRSTR='NSIRED.GT.NDMULR IN TESDAT'
          IERROR=1
C
      END IF
C
C=======================================================================
C
      IF (IPRGCM.GE.1.AND.NSIRED.GT.NMURED) THEN
C
          WRITE(NFIPRI,'(/,
     *                 1X,20(1H/),'' NSIRED='',I2,''>NMURED='',I2,
     *                                     2X,20(1H/),/)') NSIRED,NMURED
C
          ERRSTR='NSIRED.GT.NMURED IN TESDAT'
          IERROR=1
C
      END IF
C
C=======================================================================
C
      IF (IROTAT.NE.1.AND.ABS(OMEGAY).GT.0.0D0) THEN
C
          WRITE(NFIPRI,'(/,
     *                 1X,20(1H/),'' IROTAT=0 ENCOUNTERED FOR OMEGAY='',
     *                                       F4.2,1X,20(1H/),/)') OMEGAY
C
          ERRSTR='IROTAT/OMEGAY INCONSISTENCY IN TESDAT'
          IERROR=1
C
      END IF
C
C=======================================================================
C
      IF (IRENMA.GE.1.AND.(I_YUKA.GE.1.OR.I_GOGA.GE.1.OR.
     *                     IGOGPA.GE.1)) THEN
C
          WRITE(NFIPRI,'(/,1X,17(''/''),'' IRENMA>0 CANNOT YET BE'',
     *                 '' USED WITH   '',2X,16(''/''),/,
     *                 17(''/''),'' I_YUKA, I_GOGA, IGOGPA '',
     *                 ''> 0                '',16(''/''),/)')
C
          ERRSTR=' IRENMA>0 AND FINITE-RANGE FORCES IN TESDAT'
          IERROR=1
C
      END IF
C
C=======================================================================
C
      IF (IRENMA.GE.1.AND.IPAIRI.EQ.1) THEN

          WRITE(NFIPRI,'(/,1X,20(1H/),'' IRENMA>0 CANNOT YET BE '',
     *                                '' USED       '',2X,20(1H/),/,
     *                     1X,20(1H/),'' TOGETHER WITH IPAIRI=1    '',
     *                                ''         '',2X,20(1H/),/)')

          STOP ' RENORMLIZD MASS NOT IMPLEMENTED FOR IPAIRI=1 IN TESDAT'

      END IF
C
C=======================================================================
C
      IF (IRENIN.GE.1.AND.(I_YUKA.GE.1.OR.I_GOGA.GE.1.OR.
     *                     IGOGPA.GE.1)) THEN
C
          WRITE(NFIPRI,'(/,1X,17(''/''),'' IRENIN>0 CANNOT YET BE'',
     *                 '' USED WITH   '',2X,16(''/''),/,
     *                 17(''/''),'' I_YUKA, I_GOGA, IGOGPA '',
     *                 ''> 0                '',16(''/''),/)')
C
          ERRSTR=' IRENIN>0 AND FINITE-RANGE FORCES IN TESDAT'
          IERROR=1
C
      END IF
C
C=======================================================================
C
      IF (IRENIN.EQ.1.AND.IPAIRI.EQ.1) THEN

          WRITE(NFIPRI,'(/,1X,20(1H/),'' IRENIN=1 CANNOT YET BE '',
     *                                '' USED       '',2X,20(1H/),/,
     *                     1X,20(1H/),'' TOGETHER WITH IPAIRI=1    '',
     *                                ''         '',2X,20(1H/),/)')

          STOP ' RENORMLIZD INERTIA NOT IMPLMNTD FOR IPAIRI=1 IN TESDAT'

      END IF
C
C=======================================================================
C
      IF (ITWOBA.EQ.1.AND.(ISIMPY.EQ.1.OR.ISIQTY.EQ.1)) THEN
C
          WRITE(NFIPRI,'(/,1X,20(1H/),'' ITWOBA=1 CANNOT YET BE'',
     *                                '' USED        '',2X,20(1H/),/,
     *                     1X,20(1H/),'' UNLESS ISIMPY=0 AND'',
     *                                '' ISIQTY=0'',9X,20(1H/),/)')

          ERRSTR=' TWOBASIS AND FOR ISIMPY=1 OR ISIQTY=1 IN TESDAT'
          IERROR=1
C
      END IF
C
C=======================================================================
C
      IF (JPABCS.NE.0.AND.JPABCS.NE.1.AND.
     *    JPABCS.NE.2.AND.JPABCS.NE.3) THEN
C
          WRITE(NFIPRI,'(/,
     *                 1X,20(1H/),'' VALUE OF IPABCS='',I2,
     *                            '' IS NOT SUPPORTED'',3X,20(1H/),/,
     *                 1X,20(1H/),'' USE ONLY IPABCS='',
     *                            '' 0,1,2, OR 3     '',5X,20(1H/),/)')
     *          JPABCS
C
          ERRSTR=' UNSUPPORTED VALUE OF IPABCS IN TESDAT'
          IERROR=1
C
      END IF
C
C=======================================================================
C
      IF (IPAIRI.EQ.1.AND.IPAHFB.LT.1.AND.JPABCS.EQ.0) THEN
C
          WRITE(NFIPRI,'(/,
     *                 1X,20(1H/),'' IPAIRI=1 REQUIRES EITHER'',
     *                            '' IPAHFB>0'',4X,20(1H/),/,
     *                 1X,20(1H/),'' OR IPABCS>0             '',
     *                            ''         '',4X,20(1H/),/)')
C
          ERRSTR='IPAIRI/IPAHFB/IPABCS INCONSISTENCY IN TESDAT'
          IERROR=1
C
      END IF
C
C=======================================================================
C
      IF (IPAIRI.EQ.1.AND.IPAHFB.GE.1.AND.JPABCS.NE.0) THEN
C
          WRITE(NFIPRI,'(/,
     *                 1X,20(1H/),'' IPABCS>0 IS INCOMPATIBLE WITH'',
     *                            '' IPAHFB>0'',1X,19(1H/),/)')
C
          ERRSTR='IPABCS>0 VS. IPAHFB>0 INCONSISTENCY IN TESDAT'
          IERROR=1
C
      END IF
C
C=======================================================================
C
      IF (IPAIRI.EQ.1.AND.IGOGPA.GE.1.AND.IPAHFB.NE.1) THEN
C
          WRITE(NFIPRI,'(/,
     *                 1X,20(1H/),'' IGOGPA=1 REQUIRES IPAHFB=1,'',
     *                            '' FOR NOW'',       2X,20(1H/),/)')
C
          ERRSTR=' IGOGPA=1 REQUIRES IPAHFB=1 IN TESDAT'
          IERROR=1
C
      END IF
C
C=======================================================================
C
      IF ((IPAIRI.EQ.1.AND.IPAHFB.LT.1).AND.ABS(OMEGAY).GT.0.0D0) THEN
C
          WRITE(NFIPRI,'(/,
     *                 1X,20(1H/),'' IPAIRI=1 AND                    '',
     *                                            5X,20(1H/),/,
     *                 1X,20(1H/),'' IPAHFB=0 ENCOUNTERED FOR OMEGAY='',
     *                                       F4.2,1X,20(1H/),/)') OMEGAY
C
          ERRSTR='IPAIRI/IPAHFB/OMEGAY INCONSISTENCY IN TESDAT'
          IERROR=1
C
      END IF
C
C=======================================================================
C
      IF (IROTAT.NE.1.AND.ABS(OMISOY).GT.0.0D0) THEN
C
          WRITE(NFIPRI,'(/,
     *                 1X,20(1H/),'' IROTAT=0 ENCOUNTERED FOR OMISOY='',
     *                                       F4.2,1X,20(1H/),/)') OMISOY
C
          ERRSTR='IROTAT/OMISOY INCONSISTENCY IN TESDAT'
          IERROR=1
C
      END IF
C
C=======================================================================
C
      IF ((IPAIRI.EQ.1.AND.IPAHFB.LT.1).AND.ABS(OMISOY).GT.0.0D0) THEN
C
          WRITE(NFIPRI,'(/,
     *                 1X,20(1H/),'' IPAIRI=1 AND                    '',
     *                                            5X,20(1H/),/,
     *                 1X,20(1H/),'' IPAHFB=0 ENCOUNTERED FOR OMISOY='',
     *                                       F4.2,1X,20(1H/),/)') OMISOY
C
          ERRSTR='IPAIRI/IPAHFB/OMISOY INCONSISTENCY IN TESDAT'
          IERROR=1
C
      END IF
C
C=======================================================================
C
      IF (ISIMTX.EQ.1.AND.ABS(OMEGAX).GT.0.0D0) THEN
          WRITE(NFIPRI,'(/,
     *                 1X,20(1H/),'' ISIMTX=1 ENCOUNTERED FOR OMEGAX='',
     *                                       F4.2,1X,20(1H/),/)') OMEGAX
          ERRSTR='ISIMTX/OMEGAX INCONSISTENCY IN TESDAT'
          IERROR=1
      END IF
C
C=======================================================================
C
      IF (ISIMTX.EQ.1.AND.ABS(OMISOX).GT.0.0D0) THEN
C
          WRITE(NFIPRI,'(/,
     *                 1X,20(1H/),'' ISIMTX=1 ENCOUNTERED FOR OMISOX='',
     *                                       F4.2,1X,20(1H/),/)') OMISOX
C
          ERRSTR='ISIMTX/OMISOX INCONSISTENCY IN TESDAT'
          IERROR=1
C
      END IF
C
C=======================================================================
C
      IF (ISIMTX.EQ.1.AND.IFLAGI(1).EQ.1) THEN
C
          WRITE(NFIPRI,'(/,
     *                 1X,20(1H/),'' ISIMTX=1 ENCOUNTERED FOR '',
     *                            '' IFLAGI(1)='',
     *                                      I1,1X,20(1H/),/)') IFLAGI(1)
C
          ERRSTR='ISIMTX/IFLAGI(1) INCONSISTENCY IN TESDAT'
          IERROR=1
C
      END IF
C
C=======================================================================
C
      IF (JSIMTY.EQ.1.AND.ABS(OMEGAY).GT.0.0D0) THEN
C
          WRITE(NFIPRI,'(/,
     *                 1X,20(1H/),'' ISIMTY=1 ENCOUNTERED FOR OMEGAY='',
     *                                       F4.2,1X,20(1H/),/)') OMEGAY
C
          ERRSTR='ISIMTY/OMEGAY INCONSISTENCY IN TESDAT'
          IERROR=1
C
      END IF
C
C=======================================================================
C
      IF (JSIMTY.EQ.1.AND.ABS(OMISOY).GT.0.0D0) THEN
          WRITE(NFIPRI,'(/,
     *                 1X,20(1H/),'' ISIMTY=1 ENCOUNTERED FOR OMISOY='',
     *                                       F4.2,1X,20(1H/),/)') OMISOY
C
          ERRSTR='ISIMTY/OMISOY INCONSISTENCY IN TESDAT'
          IERROR=1
C
      END IF
C
C=======================================================================
C
      IF (JSIMTY.EQ.1.AND.IFLAGI(2).EQ.1) THEN
C
          WRITE(NFIPRI,'(/,
     *                 1X,20(1H/),'' ISIMTY=1 ENCOUNTERED FOR '',
     *                            '' IFLAGI(2)='',
     *                                      I1,1X,20(1H/),/)') IFLAGI(2)
C
          ERRSTR='ISIMTY/IFLAGI(2) INCONSISTENCY IN TESDAT'
          IERROR=1
C
      END IF
C
C=======================================================================
C
      IF (ISIMTZ.EQ.1.AND.ABS(OMEGAZ).GT.0.0D0) THEN
C
          WRITE(NFIPRI,'(/,
     *                 1X,20(1H/),'' ISIMTZ=1 ENCOUNTERED FOR OMEGAZ='',
     *                                       F4.2,1X,20(1H/),/)') OMEGAZ
C
          ERRSTR='ISIMTZ/OMEGAZ INCONSISTENCY IN TESDAT'
          IERROR=1
C
      END IF
C
C=======================================================================
C
      IF (ISIMTZ.EQ.1.AND.ABS(OMISOZ).GT.0.0D0) THEN
C
          WRITE(NFIPRI,'(/,
     *                 1X,20(1H/),'' ISIMTZ=1 ENCOUNTERED FOR OMISOZ='',
     *                                       F4.2,1X,20(1H/),/)') OMISOZ
C
          ERRSTR='ISIMTZ/OMISOZ INCONSISTENCY IN TESDAT'
          IERROR=1
C
      END IF
C
C=======================================================================
C
      IF (ISIMTZ.EQ.1.AND.IFLAGI(3).EQ.1) THEN
C
          WRITE(NFIPRI,'(/,
     *                 1X,20(1H/),'' ISIMTZ=1 ENCOUNTERED FOR '',
     *                            '' IFLAGI(3)='',
     *                                      I1,1X,20(1H/),/)') IFLAGI(3)
C
          ERRSTR='ISIMTZ/IFLAGI(3) INCONSISTENCY IN TESDAT'
          IERROR=1
C
      END IF
C
C=======================================================================
C
      IF (NOITER.LT.0) THEN
C
          WRITE(NFIPRI,'(/,
     *                 1X,20(1H/),'' NEGATIVE NUMBER OF ITERATIONS ='',
     *                                         I5,1X,20(1H/),/)') NOITER
C
          ERRSTR='NEGATIVE NUMBER OF ITERATIONS IN TESDAT'
          IERROR=1
C
      END IF
C
C=======================================================================
C
      IF (NOITER.LE.0.AND.ICONTI.EQ.1) THEN
C
          WRITE(NFIPRI,'(/,
     *                 1X,20(1H/),'' ICONTI=1 ENCOUNTERED FOR NOITER='',
     *                                         I4,1X,20(1H/),/)') NOITER
C
          ERRSTR='NON-POSITIVE NOITER AND ICONTI=1 IN TESDAT'
          IERROR=1
C
      END IF
C
C=======================================================================
C         RESTRICTION BELOW HAS BEEN REMOVED IN 2.05K ON 11/12/03 WITH
C         THE ASSMPTION THAT THE CODE AS IS WILL FUNCTION PROPERLY.
C=======================================================================
C
C     IF ((ISIGNY.EQ.1.AND.(ISIMTX.NE.1 .OR.ISIMTZ.NE.1)).OR.
C    *    (ISIGNY.NE.1.AND.(ISIMTX.EQ.1.AND.ISIMTZ.EQ.1))) THEN
C          WRITE(NFIPRI,'(/,
C    *                 1X,20(1H/),                   ''  ISIGNY='',I1,
C    *                            '' ENCOUNTERED FOR'','' ISIMTX='',I1,
C    *                                                   3X,20(1H/),/,
C    *                 1X,20(1H/),                    ''         '',1X,
C    *                            ''                '','' ISIMTZ='',I1,
C    *                                                   3X,20(1H/),/)')
C    *
C    *    ISIGNY,ISIMTX,ISIMTZ
C         ERRSTR='ISIGNY/ISIMTX/ISIMTZ/ INCONSISTENCY IN TESDAT'
C     END IF
C
C=======================================================================
C         RESTRICTION BELOW HAS BEEN REMOVED IN 2.05J ON 10/12/03 WITH
C         THE ASSMPTION THAT THE CODE AS IS WILL FUNCTION PROPERLY.
C=======================================================================
C
C     IF (ISIMPY.NE.1.AND.ISIGNY.EQ.1)
C    *                                                              THEN
C          WRITE(NFIPRI,'(/,
C    *                 1X,20(1H/),                   ''  ISIMPY='',I1,
C    *                            '' ENCOUNTERED FOR'','' ISIGNY='',I1,
C    *                                                   3X,20(1H/),/)')
C    *
C    *    ISIMPY,ISIGNY
C         ERRSTR='ISIMPY VS. ISIGNY INCONSISTENCY IN TESDAT'
C     END IF
C
C=======================================================================
C
      IF ((ISIMPY.EQ.1.AND.IROTAT.EQ.1.AND.JSIMTY.EQ.1).OR.
     *    (ISIMPY.NE.1.AND.IROTAT.NE.1.AND.JSIMTY.EQ.1).OR.
     *    (ISIMPY.EQ.1.AND.IROTAT.NE.1.AND.JSIMTY.NE.1)) THEN
C
           WRITE(NFIPRI,'(/,
     *                 1X,20(1H/),                   ''  ISIMPY='',I1,
     *                            '' ENCOUNTERED FOR'','' ISIMTY='',I1,
     *                                                   3X,20(1H/),/,
     *                 1X,20(1H/),                    ''         '',1X,
     *                            ''                '','' IROTAT='',I1,
     *                                                   3X,20(1H/),/,
     *                 1X,20(1H/),                    ''  THESE SY'',
     *                            ''MMETRIES ARE NOT'',''  ALLOWED'',
     *                                                   3X,20(1H/),/)')
     *
     *    ISIMPY,JSIMTY,IROTAT
C
          ERRSTR='ISIMPY/ISIMTY/IROTAT/ INCONSISTENCY IN TESDAT'
          IERROR=1
C
      END IF
C
C=======================================================================
C
      IF ((ISIGNY.NE.1.AND.ISIMTX.EQ.1.AND.ISIMTZ.EQ.1).OR.
     *    (ISIGNY.EQ.1.AND.ISIMTX.NE.1.AND.ISIMTZ.EQ.1).OR.
     *    (ISIGNY.EQ.1.AND.ISIMTX.EQ.1.AND.ISIMTZ.NE.1)) THEN
C
           WRITE(NFIPRI,'(/,
     *                 1X,20(1H/),                   ''  ISIGNY='',I1,
     *                            '' ENCOUNTERED FOR'','' ISIMTX='',I1,
     *                                                   3X,20(1H/),/,
     *                 1X,20(1H/),                    ''         '',1X,
     *                            ''                '','' ISIMTZ='',I1,
     *                                                   3X,20(1H/),/,
     *                 1X,20(1H/),                    ''  THESE SY'',
     *                            ''MMETRIES ARE NOT'',''  ALLOWED'',
     *                                                   3X,20(1H/),/)')
     *
     *    ISIGNY,ISIMTX,ISIMTZ
C
          ERRSTR='ISIGNY/ISIMTX/ISIMTZ INCONSISTENCY IN TESDAT'
          IERROR=1
C
      END IF
C
C=======================================================================
C
      IF ((ISIMPY.NE.1.AND.ISIGNY.EQ.1.AND.ISIQTY.EQ.1).OR.
     *    (ISIMPY.EQ.1.AND.ISIGNY.NE.1.AND.ISIQTY.EQ.1).OR.
     *    (ISIMPY.EQ.1.AND.ISIGNY.EQ.1.AND.ISIQTY.NE.1)) THEN
C
           WRITE(NFIPRI,'(/,
     *                 1X,20(1H/),                   ''  IPARTY='',I1,
     *                            '' ENCOUNTERED FOR'','' ISIMPY='',I1,
     *                                                   3X,20(1H/),/,
     *                 1X,20(1H/),                    ''         '',1X,
     *                            ''                '','' ISIGNY='',I1,
     *                                                   3X,20(1H/),/,
     *                 1X,20(1H/),                    ''  THESE SY'',
     *                            ''MMETRIES ARE NOT'',''  ALLOWED'',
     *                                                   3X,20(1H/),/)')
     *
     *    ISIQTY,ISIMPY,ISIGNY
C
          ERRSTR='IPARTY VS. ISIMPY/ISIGNY INCONSISTENCY IN TESDAT'
          IERROR=1
C
      END IF
C
C=======================================================================
C
      IF (JPABCS.NE.0.AND.IROTAT.EQ.1) THEN
C
          WRITE(NFIPRI,'(/,
     *                 1X,20(1H/),'' IROTAT=1 IS INCOMPATIBLE WITH'',
     *                            '' THE BCS'',1X,20(1H/),/,
     *                 1X,20(1H/),'' PAIRING, I.E., WITH IPABCS>0'',
     *                                        10X,20(1H/),/)')
C
          ERRSTR='IROTAT=1 VS. IPABCS>0 IN TESDAT'
          IERROR=1
C
      END IF
C
C=======================================================================
C
      IF (JPABCS.NE.0.AND.ISIMPY.NE.1) THEN
C
          WRITE(NFIPRI,'(/,
     *                 1X,20(1H/),'' ISIMPY=0 IS INCOMPATIBLE WITH'',
     *                            '' THE BCS'',  1X,20(1H/),/,
     *                 1X,20(1H/),'' PAIRING, I.E. WITH IPABCS>0'',
     *                            '' (FOR NOW)'',1X,20(1H/),/)')
C
          ERRSTR='ISIMPY=0 VS. IPABCS>0 IN TESDAT'
          IERROR=1
C
      END IF
C
C=======================================================================
C
      IF (JPABCS.EQ.3.AND.IDESTA.NE.1) THEN
C
          WRITE(NFIPRI,'(/,
     *                 1X,20(1H/),'' IPABCS=3 REQUIRES IDESTA=1'',
     *                            '' BECAUSE   '',1X,20(1H/),/,
     *                 1X,20(1H/),'' PAIRING M.E. ARE NOT YET STORED'',
     *                                         7X,20(1H/),/)')
C
          ERRSTR='IPABCS=3 VS. PAIRING MATRIX ELEMENTS IN TESDAT'
          IERROR=1
C
      END IF
C
C=======================================================================
C
C     IF (JPABCS.EQ.3.AND.IDEMID.LE.0.AND.IDESTO.LE.0.AND.IDEDIS.LE.0)
C    *                                                              THEN
C         WRITE(NFIPRI,'(/,
C    *                 1X,20(1H/),'' IPABCS=3 REQUIRES CALCULATION'',
C    *                            ''        '',1X,20(1H/),/,
C    *                 1X,20(1H/),'' OF THE PAIRING MATRIX ELEMENTS'',
C    *                                         8X,20(1H/),/)')
C         ERRSTR='IPABCS=3 VS. PAIRING MATRIX ELEMENTS IN TESDAT'
C     END IF
C
C=======================================================================
C
      IF (IPAHFB.GE.1.AND.IPAIRI.NE.1) THEN
C
          WRITE(NFIPRI,'(/,
     *                 1X,20(1H/),'' IPAHFB>0 IS INCOMPATIBLE WITH'',
     *                            '' IPAIRI=0'',1X,19(1H/),/)')
C
          ERRSTR='IPAHFB>0 VS. IPAIRI=0 INCONSISTENCY IN TESDAT'
          IERROR=1
C
      END IF
C
C=======================================================================
C
      IF (LIPKIN.EQ.1.AND.IPAHFB.LT.1) THEN
C
          WRITE(NFIPRI,'(/,
     *                 1X,20(1H/),'' LIPKIN=1 IS INCOMPATIBLE WITH'',
     *                            '' IPAHFB=0'',1X,19(1H/),/)')
C
          ERRSTR='LIPKIN=1 VS. IPAHFB=0 INCONSISTENCY IN TESDAT'
          IERROR=1
C
      END IF
C
      IF (LIPKIP.EQ.1.AND.IPAHFB.LT.1) THEN
C
          WRITE(NFIPRI,'(/,
     *                 1X,20(1H/),'' LIPKIP=1 IS INCOMPATIBLE WITH'',
     *                            '' IPAHFB=0'',1X,19(1H/),/)')
C
          ERRSTR='LIPKIP=1 VS. IPAHFB=0 INCONSISTENCY IN TESDAT'
          IERROR=1
C
      END IF
C
      IF ((LIPKIN.EQ.1.OR.LIPKIP.EQ.1).AND.IFTEMP.EQ.1) THEN
C
          WRITE(NFIPRI,'(/,
     *                 1X,12(1H/),'' LIPKIN=1 AND/OR LIPKIN=1 '',
     *                            ''IS INCOMPATIBLE WITH'',
     *                            '' IFTEMP=1'',1X,11(1H/),/)')
C
          ERRSTR='LIPKIN-NOGAMI VS. IFTEMP=1 INCONSISTENCY IN TESDAT'
          IERROR=1
C
      END IF
C
C=======================================================================
C
      IF (IFTEMP.NE.0.AND.(IROTAT.EQ.1.OR.ISIMPY.NE.1)) THEN
C
          WRITE(NFIPRI,'(/,
     *                 1X,14(1H/),'' IFTEMP=1 IS INCOMPATIBLE WITH'',
     *                 '' IROTAT=1 OR ISIMPY=1'',1X,13(1H/),/)')
C
          ERRSTR='IFTEMP=1 VS. IROTAT=1 OR ISIMPY=0 IN TESDAT'
          IERROR=1
C
      END IF
C
C=======================================================================
C
      IF (ITWOBA.EQ.1.AND.IPAHFB.LT.1) THEN
C
          WRITE(NFIPRI,'(/,
     *                 1X,20(1H/),'' ITWOBA=1 IS INCOMPATIBLE WITH'',
     *                            '' IPAHFB=0'',1X,19(1H/),/)')
C
          ERRSTR='TWO-BASIS AND IPAHFB=0 INCONSISTENCY IN TESDAT'
          IERROR=1
C
      END IF
C
C=======================================================================
C
      IF (ITWOBA.EQ.1.AND.IPAHFB.EQ.2) THEN
C
          WRITE(NFIPRI,'(/,
     *                 1X,20(1H/),'' ITWOBA=1 IS INCOMPATIBLE WITH'',
     *                            '' IPAHFB=2'',1X,19(1H/),/)')
C
          ERRSTR='TWO-BASIS AND IPAHFB=2 INCONSISTENCY IN TESDAT'
          IERROR=1
C
      END IF
C
C=======================================================================
C
      IF (LIMQUA.EQ.1.AND.IPAHFB.LT.1) THEN
C
          WRITE(NFIPRI,'(/,
     *                 1X,20(1H/),'' LIMQUA=1 IS INCOMPATIBLE WITH'',
     *                            '' IPAHFB=0'',1X,19(1H/),/)')
C
          ERRSTR='LIMQUA=1 VS. IPAHFB=0 INCONSISTENCY IN TESDAT'
          IERROR=1
C
      END IF
C
C=======================================================================
C
      IF (ITWOBA.EQ.1.AND.ISIMPY.NE.1.AND.ISIQTY.EQ.1) THEN
C
          WRITE(NFIPRI,'(/,1X,20(1H/),'' THE TWO-BASIS METHOD IS NOT'',
     *                                '' YET     '',1X,20(1H/),/,
     *                     1X,20(1H/),'' IMPLEMENTED FOR ISIMPY=0 &'',
     *                                '' IPARTY=1'',2X,20(1H/),/)')
C
          ERRSTR=' TWO-BASIS AND ISIMPY=0 AND IPARTY=1 IN TESDAT'
          IERROR=1
C
      END IF
C
C=======================================================================
C
      IF (ITWOBA.EQ.1.AND.ISIMPY.EQ.1.AND.ISIQTY.EQ.1) THEN
C
          WRITE(NFIPRI,'(/,1X,20(1H/),'' THE TWO-BASIS METHOD IS NOT'',
     *                                '' YET     '',1X,20(1H/),/,
     *                     1X,20(1H/),'' IMPLEMENTED FOR ISIMPY=1 &'',
     *                                '' IPARTY=1'',2X,20(1H/),/)')
C
          ERRSTR=' TWO-BASIS AND ISIMPY=1 AND IPARTY=1 IN TESDAT'
          IERROR=1
C
      END IF
C
C=======================================================================
C
      IF (ITWOBA.EQ.1.AND.ISIMPY.EQ.1.AND.ISIQTY.EQ.1) THEN
C
          WRITE(NFIPRI,'(/,1X,20(1H/),'' THE TWO-BASIS METHOD IS NOT'',
     *                                '' YET     '',1X,20(1H/),/,
     *                     1X,20(1H/),'' IMPLEMENTED FOR ISIMPY=1 &'',
     *                                '' IPARTY=1'',2X,20(1H/),/)')
C
          ERRSTR=' TWO-BASIS AND ISIMPY=1 AND IPARTY=1 IN TESDAT'
          IERROR=1
C
      END IF
C
C=======================================================================
C
      IF (ITWOBA.EQ.1.AND.ISIMPY.EQ.1.AND.ISIQTY.EQ.0) THEN
C
          WRITE(NFIPRI,'(/,1X,20(1H/),'' THE TWO-BASIS METHOD IS NOT'',
     *                                '' YET     '',1X,20(1H/),/,
     *                     1X,20(1H/),'' IMPLEMENTED FOR ISIMPY=1 &'',
     *                                '' IPARTY=0'',2X,20(1H/),/)')
C
          ERRSTR=' TWO-BASIS AND ISIMPY=1 AND IPARTY=0 IN TESDAT'
          IERROR=1
C
      END IF
C
C=======================================================================
C
      IF (JPABCS.NE.0.AND.IPAIRI.NE.1) THEN
C
          WRITE(NFIPRI,'(/,
     *                 1X,20(1H/),'' IPABCS>0 IS INCOMPATIBLE WITH'',
     *                            '' IPAIRI=0'',1X,19(1H/),/)')
C
          ERRSTR='IPABCS>0 VS. IPAIRI=0 INCONSISTENCY IN TESDAT'
          IERROR=1
C
      END IF
C
C=======================================================================
C
      IF (IPCONT.EQ.1.AND.(IPAHFB.LT.1.OR.ICONTI.EQ.0)) THEN
C
          WRITE(NFIPRI,'(/,
     *                 1X,20(1H/),'' IPCONT=1 IS INCOMPATIBLE WITH '',
     *                                                  8X,20(1H/),/,
     *                 1X,20(1H/),'' EITHER OF IPAHFB=0 OR ICONTI=0'',
     *                                                  8X,20(1H/),/)')
C
          ERRSTR='IPCONT=1 VS. (IPAHFB=0 OR ICONTI=0) IN TESDAT'
          IERROR=1
C
      END IF
C
C=======================================================================
C
      IF (IROTAT.NE.1.AND.IPAIRI.NE.1.AND.(MOD(IN_FIX,2).EQ.1.OR.
     *                                     MOD(IZ_FIX,2).EQ.1)) THEN
          WRITE(NFIPRI,'(/,
     *                 1X,20(1H/),'' IROTAT=IPAIRI=0 IS NOT'',
     *                            '' COMPATIBLE   '',    1X,20(1H/),/
     *                 1X,20(1H/),'' WITH ODD PARTICLE NUMBERS'',
     *                            '' IN_FIX='',I3,       1X,20(1H/),/
     *                 1X,20(1H/),''                          '',
     *                            '' IZ_FIX='',I3,       1X,20(1H/),/)')
     *                               IN_FIX,IZ_FIX
C
          ERRSTR='IROTAT=IPAIRI=0 AND AN ODD SYSTEM IN TESDAT'
          IERROR=1
C
      END IF
C
C=======================================================================
C
      IF (ICOUDI.LT.0.OR.ICOUDI.GT.2) THEN
C
          WRITE(NFIPRI,'(/,
     *                 1X,20(1H/),'' INCORRECT VALUE OF ICOUDI='',I3,
     *                            ''       '',1X,20(1H/),/)')
     *    ICOUDI
C
          ERRSTR=' INCORRECT VALUE OF ICOUDI IN TESDAT'
          IERROR=1
C
      END IF
C
C=======================================================================
C
      IF (ICOUEX.LT.0.OR.ICOUEX.GT.2) THEN
C
          WRITE(NFIPRI,'(/,
     *                 1X,20(1H/),'' INCORRECT VALUE OF ICOUEX='',I3,
     *                            ''       '',1X,20(1H/),/)')
     *    ICOUEX
C
          ERRSTR=' INCORRECT VALUE OF ICOUEX IN TESDAT'
          IERROR=1
C
      END IF
C
C=======================================================================
C
      IF ((ICOTYP.EQ.0.OR.ICOTYP.EQ.-1.OR.ICOTYP.LT.-7).AND.
     *    (ICOUDI.EQ.2.OR.ICOUEX.EQ.2)) THEN
C
          WRITE(NFIPRI,'(/,
     *                 1X,20(1H/),'' INCORRECT VALUE OF ICOTYP='',I3,
     *                            ''       '',1X,20(1H/),/)')
     *    ICOTYP
C
          ERRSTR=' INCORRECT VALUE OF ICOTYP IN TESDAT'
          IERROR=1
C
      END IF
C
C=======================================================================
C
      IF (I_YUKA.LT.0.OR.I_YUKA.GT.4) THEN
C
          WRITE(NFIPRI,'(/,
     *                 1X,20(1H/),'' INCORRECT VALUE OF I_YUKA='',I3,
     *                            ''       '',1X,20(1H/),/)')
     *    I_YUKA
C
          ERRSTR=' INCORRECT VALUE OF I_YUKA IN TESDAT'
          IERROR=1
C
      END IF
C
C=======================================================================
C
      IF (IYUTYP.LT.1.OR.IYUTYP.GT.2) THEN
C
          WRITE(NFIPRI,'(/,
     *                 1X,20(1H/),'' INCORRECT VALUE OF IYUTYP='',I3,
     *                            ''       '',1X,20(1H/),/)')
     *    IYUTYP
C
          ERRSTR=' INCORRECT VALUE OF IYUTYP IN TESDAT'
          IERROR=1
C
      END IF
C
C=======================================================================
C
      IF (IYCONT.EQ.1.AND.I_YUKA.LT.2) THEN
C
          WRITE(NFIPRI,'(/,
     *                 1X,20(1H/),'' IYCONT=1 IS INCOMPATIBLE WITH'',
     *                            '' I_YUKA<2'',1X,19(1H/),/)')
C
          ERRSTR='IYCONT=1 VS. I_YUKA<2 INCONSISTENCY IN TESDAT'
          IERROR=1
C
      END IF
C
C=======================================================================
C
      IF (IGCONT.EQ.1.AND.I_GOGA.LT.2) THEN
C
          WRITE(NFIPRI,'(/,
     *                 1X,20(1H/),'' IGCONT=1 IS INCOMPATIBLE WITH'',
     *                            '' I_GOGA<2'',1X,19(1H/),/)')
C
          ERRSTR='IGCONT=1 VS. I_GOGA<2 INCONSISTENCY IN TESDAT'
          IERROR=1
C
      END IF
C
C=======================================================================
C
      IF (IGPCON.EQ.1.AND.IGOGPA.LT.2) THEN
C
          WRITE(NFIPRI,'(/,
     *                 1X,20(1H/),'' IGPCON=1 IS INCOMPATIBLE WITH'',
     *                            '' IGOGPA<2'',1X,19(1H/),/)')
C
          ERRSTR='IGPCON=1 VS. IGOGPA<2 INCONSISTENCY IN TESDAT'
          IERROR=1
C
      END IF
C
C=======================================================================
C
      IF (IBROYD.GE.1.AND.I_YUKA.GE.1) THEN
C
          WRITE(NFIPRI,'(/,
     *                 1X,20(1H/),'' IBROYD=1 IS INCOMPATIBLE WITH'',
     *                            '' I_YUKA>0'',1X,19(1H/),/)')
C
          ERRSTR='IBROYD=1 VS. I_YUKA>0 INCONSISTENCY IN TESDAT'
          IERROR=1
C
      END IF
C
C=======================================================================
C
      IF (I_GOGA.LT.0.OR.I_GOGA.GT.4) THEN
          WRITE(NFIPRI,'(/,
     *                 1X,20(1H/),'' INCORRECT VALUE OF I_GOGA='',I3,
     *                            ''       '',1X,20(1H/),/)')
     *    I_GOGA
C
          ERRSTR=' INCORRECT VALUE OF I_GOGA IN TESDAT'
          IERROR=1
C
      END IF
C
C=======================================================================
C
      IF (IGOGPA.LT.0.OR.IGOGPA.GT.2) THEN
          WRITE(NFIPRI,'(/,
     *                 1X,20(1H/),'' INCORRECT VALUE OF IGOGPA='',I3,
     *                            ''       '',1X,20(1H/),/)')
     *    IGOGPA
C
          ERRSTR=' INCORRECT VALUE OF IGOGPA IN TESDAT'
          IERROR=1
C
      END IF
C
C=======================================================================
C
      IF (IBROYD.GE.1.AND.I_GOGA.GE.1) THEN
C
          WRITE(NFIPRI,'(/,
     *                 1X,20(1H/),'' IBROYD=1 IS INCOMPATIBLE WITH'',
     *                            '' I_GOGA>0'',1X,19(1H/),/)')
C
          ERRSTR='IBROYD=1 VS. I_GOGA>0 INCONSISTENCY IN TESDAT'
          IERROR=1
C
      END IF
C
C=======================================================================
C
      IF (IBROYD.GE.1.AND.IGOGPA.GE.1) THEN
C
          WRITE(NFIPRI,'(/,
     *                 1X,20(1H/),'' IBROYD=1 IS INCOMPATIBLE WITH'',
     *                            '' IGOGPA>0'',1X,19(1H/),/)')
C
          ERRSTR='IBROYD=1 VS. IGOGPA>0 INCONSISTENCY IN TESDAT'
          IERROR=1
C
      END IF
C
C=======================================================================
C
      IF (ILCONT.EQ.1.AND.(LIPKIN.NE.1.AND.LIPKIP.NE.1)) THEN
          WRITE(NFIPRI,'(/,
     *                 1X,19(1H/),'' ILCONT=1 IS INCOMPATIBLE WITH'',
     *                            '' NO LIPKIN'',1X,19(1H/),/)')
C
          ERRSTR=' ILCONT=1 VS. NO LIPKIN INCONSISTENCY IN TESDAT'
          IERROR=1
C
      END IF
C
C=======================================================================
C
      IF (JETACM.EQ.2.AND.IROTAT.NE.1) THEN
          WRITE(NFIPRI,'(/,
     *                 1X,20(1H/),'' JETACM=2 REQUIRES IROTAT=1'',
     *                            '' BECAUSE CM'',1X,20(1H/),/,
     *                 1X,20(1H/),'' CORR. BEFORE VARIATION GIVES T-'',
     *                            ''ODD MF'',  1X,20(1H/),/)')
C
          ERRSTR=' JETACM=2 REQUIRES ROTATION IN TESDAT'
          IERROR=1
C
      END IF
C
C=======================================================================
C
      IF (JETACM.EQ.2.AND.ISIQTY.EQ.1) THEN
          WRITE(NFIPRI,'(/,
     *                 1X,20(1H/),'' JETACM=2 REQUIRES IPARTY=0'',
     *                            '' BECAUSE CM'',1X,20(1H/),/,
     *                 1X,20(1H/),'' CORR. BEFORE VARIATION BRAKES '',
     *                            '' PARITY'',  1X,20(1H/),/)')
C
          ERRSTR=' JETACM=2 REQUIRES BROKEN PARITY IN TESDAT'
          IERROR=1
C
      END IF
C
C=======================================================================
C
      IF (JETACM.EQ.2.AND.ISIMPY.EQ.1) THEN
          WRITE(NFIPRI,'(/,
     *                 1X,20(1H/),'' JETACM=2 REQUIRES ISIMPY=0'',
     *                            '' BECAUSE CM'',1X,20(1H/),/,
     *                 1X,20(1H/),'' CORR. BEFORE VARIATION BRAKES'',
     *                            '' SIMPLEX'',  1X,20(1H/),/)')
C
          ERRSTR=' JETACM=2 REQUIRES BROKEN SIMPLEX IN TESDAT'
          IERROR=1
C
      END IF
C
C=======================================================================
C
      IF (IMCONT.EQ.1.AND.JETACM.NE.2) THEN
          WRITE(NFIPRI,'(/,
     *                 1X,19(1H/),'' IMCONT=1 IS INCOMPATIBLE WITH'',
     *                            '' NO CM CORR'',1X,19(1H/),/)')
C
          ERRSTR=' IMCONT=1 VS. NO CM CORR INCONSISTENCY IN TESDAT'
          IERROR=1
C
      END IF
C
C=======================================================================
C
      IF (KETA_R.EQ.2.AND.IROTAT.NE.1) THEN
          WRITE(NFIPRI,'(/,
     *                 1X,20(1H/),'' KETA_R=2 REQUIRES IROTAT=1'',
     *                            '' BECAUSE RM'',1X,20(1H/),/,
     *                 1X,20(1H/),'' CORR. BEFORE VARIATION GIVES T-'',
     *                            ''ODD MF'',  1X,20(1H/),/)')
C
          ERRSTR=' KETA_R=2 REQUIRES ROTATION IN TESDAT'
          IERROR=1
C
      END IF
C
C=======================================================================
C
      IF (KETA_R.EQ.2.AND.ISIMPY.EQ.1) THEN
C
          WRITE(NFIPRI,'(/,
     *                 1X,20(1H/),'' KETA_R=2 REQUIRES ISIMPY=0'',
     *                            '' BECAUSE RM'',1X,20(1H/),/,
     *                 1X,20(1H/),'' CORR. BEFORE VARIATION BRAKES'',
     *                            '' SIMPLEX'',  1X,20(1H/),/)')
C
          ERRSTR=' KETA_R=2 REQUIRES BROKEN SIMPLEX IN TESDAT'
          IERROR=1
C
      END IF
C
C=======================================================================
C
      IF (IRCONT.EQ.1.AND.KETA_R.NE.2) THEN
C
          WRITE(NFIPRI,'(/,
     *                 1X,19(1H/),'' IRCONT=1 IS INCOMPATIBLE WITH'',
     *                            '' NO RM CORR'',1X,19(1H/),/)')
C
          ERRSTR=' IRCONT=1 VS. NO ROT. CORR. INCONSISTENCY IN TESDAT'
          IERROR=1
C
      END IF
C
C=======================================================================
C
      IF (IF2FIN.EQ.1.AND.LIPKIN.NE.1) THEN
C
          WRITE(NFIPRI,'(/,
     *                 1X,19(1H/),'' FIXED NEUTRON LAMBDA2 CAN ONLY'',
     *                            '' BE USED'',    1X,19(1H/),/,
     *                 1X,19(1H/),'' TOGETHER WITH LIPKIN = 1  '',
     *                            ''            '',1X,19(1H/),/)')
C
          ERRSTR=' FIXED NEUTRON LAMBDA2 ONLY FOR LIPKIN=1 IN TESDAT'
          IERROR=1
C
      END IF
C
C=======================================================================
C
      IF (IF2FIP.EQ.1.AND.LIPKIP.NE.1) THEN
C
          WRITE(NFIPRI,'(/,
     *                 1X,19(1H/),'' FIXED PROTON  LAMBDA2 CAN ONLY'',
     *                            '' BE USED'',    1X,19(1H/),/,
     *                 1X,19(1H/),'' TOGETHER WITH LIPKIP = 1  '',
     *                            ''            '',1X,19(1H/),/)')
C
          ERRSTR=' FIXED PROTON LAMBDA2 ONLY FOR LIPKIP=1 IN TESDAT'
          IERROR=1
C
      END IF
C
C=======================================================================
C     SUMMING UP THE PARTICLE NUMBERS IN THE VACUUM CONFIGURATIONS
C=======================================================================
C
      DO ICHARG=0,NDISOS
C
         NUMPAR(ICHARG)=0
C
         IF (ISIMPY.EQ.1) THEN
C
             IF (ISIGNY.EQ.1) THEN
C
C=======================================================================
C                SIGNATURE/PARITY CASE
C=======================================================================
C                FOR IROTAT=0, THE BLOCKS WITH ISIGNA=1  ARE  IGNORED,
C                              AND THE OCCUPATION NUMBERS AT ISIGNA=0
C                              ARE DOUBLED
C=======================================================================
C
                 DO IPARIT=0,NDPARI
C
                    DO IREVER=0,IROTAT
C
                       NUMPAR(ICHARG)=
     *                 NUMPAR(ICHARG)+NVASIG(IPARIT,IREVER,ICHARG)
     *                               *(2-IROTAT)
C
                    END DO
C
                 END DO
C
             ELSE
C
C=======================================================================
C                SIMPLEX CASE
C=======================================================================
C                FOR IROTAT=0, THE BLOCK  WITH ISIMPY=1   IS  IGNORED,
C                              AND THE OCCUPATION NUMBERS AT ISIMPL=0
C                              ARE DOUBLED
C=======================================================================
C
                 DO IREVER=0,IROTAT
C
                    NUMPAR(ICHARG)=
     *              NUMPAR(ICHARG)+NVASIM(IREVER,ICHARG)
     *                            *(2-IROTAT)
C
                 END DO
C
             END IF
C
         ELSE
C
             IF (ISIQTY.EQ.1) THEN
C
C=======================================================================
C                PARITY CASE
C=======================================================================
C
                 DO IPARIT=0,NDPARI
C
                    NUMPAR(ICHARG)=
     *              NUMPAR(ICHARG)+NVASIQ(IPARIT,ICHARG)
C
                 END DO
C
             ELSE
C
C=======================================================================
C            NO-SYMMETRY CASE
C=======================================================================
C
                 IF (ICHARG.EQ.0) NUMPAR(ICHARG)=IN_FIX
                 IF (ICHARG.EQ.1) NUMPAR(ICHARG)=IZ_FIX
C
             END IF
C
         END IF
C
      END DO
C
C=======================================================================
C     CHECKING THE PARTICLE NUMBERS
C=======================================================================
C
      IF (IPAIRI.NE.1.AND.(NUMPAR(0).NE.IN_FIX.OR.NUMPAR(1).NE.IZ_FIX)
     *               .AND.IVACUM.NE.1)
     *    THEN
          WRITE(NFIPRI,'(/,
     *                 1X,20(1H/),''   INCOMPATIBLE PARTICLE '',
     *                            '' NUMBERS:   '',      1X,20(1H/),/
     *                 1X,20(1H/),''              (REQUESTED)'',
     *                            '' (VACUUM)   '',      1X,20(1H/),/
     *                 1X,20(1H/),''   NEUTRONS:      '',I3,''    '',
     *                            ''   '',I3,            7X,20(1H/),/
     *                 1X,20(1H/),''    PROTONS:      '',I3,''    '',
     *                            ''   '',I3,            7X,20(1H/),/)')
     *    IN_FIX,NUMPAR(0),
     *    IZ_FIX,NUMPAR(1)
          ERRSTR='INCOMPATIBLE PARTICLE NUMBERS IN TESDAT'
          IERROR=1
      END IF
C
C=======================================================================
C
      IF (IREAWS.EQ.1.AND.IOPTGS.EQ.1) THEN
C
          WRITE(NFIPRI,'(/,
     *                 1X,20(1H/),'' IREAWS=1 IS INCOMPATIBLE WITH'',
     *                            '' IOPTGS=1'',3X,20(1H/),/)')
C
          ERRSTR='IREAWS=IOPTGS=1 INCONSISTENCY IN TESDAT'
          IERROR=1
C
      END IF
C
C=======================================================================
C
      IF (EPSITE.GT.0..AND.NULAST.LE.0) THEN
          WRITE(NFIPRI,'(/,1X,20(1H/),1X,
     *                   ''NULAST='',I3,'' AND EPSITE>0'',
     *                     1X,20(1H/),/)')
     *    NULAST
C
          ERRSTR='NULAST.LE.0 AND EPSITE.GT.0 INCONSISTENCY IN TESDAT'
          IERROR=1
C
      END IF
C
C=======================================================================
C
      IF (EPSITE.LT.0..OR.NULAST.LT.0) THEN
          WRITE(NFIPRI,'(/,1X,20(1H/),1X,
     *                   ''NULAST='',I3,''  OR EPSITE<0'',
     *                     1X,20(1H/),/,
     *                     1X,20(1H/),1X,''IS NOT AN ALLOWED VALUE'',
     *                                                  1X,20(1H/),/)')
     *    NULAST
C
          ERRSTR='NULAST.LT.0 OR EPSITE.LT.0 IN TESDAT'
          IERROR=1
C
      END IF
C
C=======================================================================
C
      IF (EPSPNG.GT.0..AND.NUPING.LE.1) THEN
          WRITE(NFIPRI,'(/,1X,20(1H/),''NUPING='',I3,'' AND EPSPNG>0'',
     *                                             2X,20(1H/),/)')
     *                                              NUPING
C
          ERRSTR='NUPING.LE.1 AND EPSPNG.GT.0 INCONSISTENCY IN TESDAT'
          IERROR=1
C
      END IF
C
C=======================================================================
C
      IF (IFLIPI.NE.0.AND.ISIMPY.EQ.1.AND.ISIGNY.EQ.1) THEN
C
          IF (ISPFLI.LE.0.OR.ISPFLI.GT.NDSTAT.OR.
     *        N_OCCU(ISPFLI,IPAFLI,IREFLI,ICHFLI).NE.0) THEN
C
              WRITE(NFIPRI,'(/,
     *                     1X,20(1H/),'' INCORRECT SIGNATURE PARTICLE'',
     *                                '' INDEX  '',      1X,20(1H/),/,
     *                     1X,20(1H/),'' IN THE DIABATIC DATA:   '',
     *                                ''            '',  1X,20(1H/),/,
     *                     1X,20(1H/),'' ICHFLI='',I2,
     *                                '' IPAFLI='',I2,
     *                                '' ISIFLI='',I2,   8X,20(1H/),/,
     *                     1X,20(1H/),'' ISPFLI='',I2,
     *                                '' ISHFLI='',I2,
     *                                '' IFLIPI='',I2,   8X,20(1H/),/)')
     *
     *                     ICHFLI,IPAFLI,
     *                            IREFLI*(1-IPAFLI)+(1-IREFLI)*IPAFLI,
     *                     ISPFLI,ISHFLI,IFLIPI
C
              ERRSTR=' INCORRECT SIGNATURE PARTICLE INDEX IN TESDAT'
              IERROR=1
C
          END IF
C
          IF (ISHFLI.LE.0.OR.ISHFLI.GT.NDSTAT.OR.
     *        N_OCCU(ISHFLI,IPAFLI,IREFLI,ICHFLI).NE.1) THEN
C
              WRITE(NFIPRI,'(/,
     *                     1X,20(1H/),'' INCORRECT SIGNATURE   HOLE  '',
     *                                '' INDEX  '',      1X,20(1H/),/,
     *                     1X,20(1H/),'' IN THE DIABATIC DATA:   '',
     *                                ''            '',  1X,20(1H/),/,
     *                     1X,20(1H/),'' ICHFLI='',I2,
     *                                '' IPAFLI='',I2,
     *                                '' ISIFLI='',I2,   8X,20(1H/),/,
     *                     1X,20(1H/),'' ISPFLI='',I2,
     *                                '' ISHFLI='',I2,
     *                                '' IFLIPI='',I2,   8X,20(1H/),/)')
     *
     *                     ICHFLI,IPAFLI,
     *                            IREFLI*(1-IPAFLI)+(1-IREFLI)*IPAFLI,
     *                     ISPFLI,ISHFLI,IFLIPI
C
              ERRSTR=' INCORRECT SIGNATURE HOLE INDEX IN TESDAT'
              IERROR=1
C
          END IF
C
          IF (ABS(IFLIPI).GE.3.AND.ABS(IFLIPI).LE.8) THEN
C
              WRITE(NFIPRI,'(/,
     *                     1X,20(1H/),'' INCORRECT OBSERVABLE INDEX  '',
     *                                '' (SIGN) '',      1X,20(1H/),/,
     *                     1X,20(1H/),'' IN THE DIABATIC DATA:   '',
     *                                ''            '',  1X,20(1H/),/,
     *                     1X,20(1H/),'' IFLIPI='',I2,
     *                                ''        '',2X,
     *                                ''        '',2X,   8X,20(1H/),/)')
     *
     *                     IFLIPI
C
              ERRSTR=' INCORRECT SIGNATURE OBSERVABLE INDEX IN TESDAT'
              IERROR=1
C
          END IF
C
          IF (NOFILG(IPAFLI,IREFLI,ICHFLI).GE.1) THEN
C
              WRITE(NFIPRI,'(/,
     *                     1X,20(1H/),'' FILLING APPROXIMATION'',
     *                                '' INCOMPATIBLE'', 1X,20(1H/),/,
     *                     1X,20(1H/),'' WITH THE DIABATIC DATA:   '',
     *                                ''            '',  1X,20(1H/),/,
     *                     1X,20(1H/),'' ICHFLI='',I2,
     *                                '' IPAFLI='',I2,
     *                                '' ISIFLI='',I2,   8X,20(1H/),/,
     *                     1X,20(1H/),'' ISPFLI='',I2,
     *                                '' ISHFLI='',I2,
     *                                '' IFLIPI='',I2,   8X,20(1H/),/)')
     *
     *                     ICHFLI,IPAFLI,
     *                            IREFLI*(1-IPAFLI)+(1-IREFLI)*IPAFLI,
     *                     ISPFLI,ISHFLI,IFLIPI
C
              ERRSTR=' SIGNATURE FILLING AND DIABATIC IN TESDAT'
              IERROR=1
C
          END IF
C
      END IF
C
C=======================================================================
C
      IF (IFLIPI.NE.0.AND.ISIMPY.EQ.1.AND.ISIGNY.NE.1) THEN
C
          IF (ISPFLI.LE.0.OR.ISPFLI.GT.NDSTAT.OR.
     *        L_OCCU(ISPFLI,IREFLI,ICHFLI).NE.0) THEN
C
              WRITE(NFIPRI,'(/,
     *                     1X,20(1H/),'' INCORRECT  SIMPLEX  PARTICLE'',
     *                                '' INDEX  '',      1X,20(1H/),/,
     *                     1X,20(1H/),'' IN THE DIABATIC DATA:   '',
     *                                ''            '',  1X,20(1H/),/,
     *                     1X,20(1H/),'' ICHFLI='',I2,
     *                                '' ISIFLI='',I2,  18X,20(1H/),/,
     *                     1X,20(1H/),'' ISPFLI='',I2,
     *                                '' ISHFLI='',I2,
     *                                '' IFLIPI='',I2,   8X,20(1H/),/)')
     *
     *                     ICHFLI,IREFLI,
     *                     ISPFLI,ISHFLI,IFLIPI
C
              ERRSTR=' INCORRECT SIMPLEX PARTICLE INDEX IN TESDAT'
              IERROR=1
C
          END IF
C
          IF (ISHFLI.LE.0.OR.ISHFLI.GT.NDSTAT.OR.
     *        L_OCCU(ISHFLI,IREFLI,ICHFLI).NE.1) THEN
C
              WRITE(NFIPRI,'(/,
     *                     1X,20(1H/),'' INCORRECT  SIMPLEX    HOLE  '',
     *                                '' INDEX  '',      1X,20(1H/),/,
     *                     1X,20(1H/),'' IN THE DIABATIC DATA:   '',
     *                                ''            '',  1X,20(1H/),/,
     *                     1X,20(1H/),'' ICHFLI='',I2,
     *                                '' ISIFLI='',I2,  18X,20(1H/),/,
     *                     1X,20(1H/),'' ISPFLI='',I2,
     *                                '' ISHFLI='',I2,
     *                                '' IFLIPI='',I2,   8X,20(1H/),/)')
     *
     *                     ICHFLI,IREFLI,
     *                     ISPFLI,ISHFLI,IFLIPI
C
              ERRSTR=' INCORRECT SIMPLEX HOLE INDEX IN TESDAT'
              IERROR=1
C
          END IF
C
C=======================================================================
C
          IF (IPAFLI.EQ.1) THEN
C
              WRITE(NFIPRI,'(/,
     *                 1X,20(1H/),'' IPAFLI=1 IS FORBIDDEN FOR'',
     *                                '' ISIGNY=0'',7X,20(1H/),/)')
              ERRSTR='IPAFLI=1 AND ISIGNY=0 INCONSISTENCY IN TESDAT'
              IERROR=1
C
          END IF
C
          IF (ABS(IFLIPI).GE.3.AND.ABS(IFLIPI).LE.8) THEN
C
              WRITE(NFIPRI,'(/,
     *                     1X,20(1H/),'' INCORRECT OBSERVABLE INDEX '',
     *                                '' (SIMPL) '',      1X,20(1H/),/,
     *                     1X,20(1H/),'' IN THE DIABATIC DATA:   '',
     *                                ''            '',  1X,20(1H/),/,
     *                     1X,20(1H/),'' IFLIPI='',I2,
     *                                ''        '',2X,
     *                                ''        '',2X,   8X,20(1H/),/)')
     *
     *                     IFLIPI
C
              ERRSTR=' INCORRECT SIMPLEX OBSERVABLE INDEX IN TESDAT'
              IERROR=1
C
          END IF
C
      END IF
C
C=======================================================================
C
      IF (IFLIPI.NE.0.AND.ISIMPY.NE.1.AND.ISIQTY.EQ.1) THEN
C
          IF (ISPFLI.LE.0.OR.ISPFLI.GT.2*NDSTAT.OR.
     *        K_OCCU(ISPFLI,IPAFLI,ICHFLI).NE.0) THEN
C
              WRITE(NFIPRI,'(/,
     *                     1X,20(1H/),'' INCORRECT  PARITY   PARTICLE'',
     *                                '' INDEX  '',      1X,20(1H/),/,
     *                     1X,20(1H/),'' IN THE DIABATIC DATA:   '',
     *                                ''            '',  1X,20(1H/),/,
     *                     1X,20(1H/),'' ICHFLI='',I2,
     *                                '' IPAFLI='',I2,  18X,20(1H/),/,
     *                     1X,20(1H/),'' ISPFLI='',I2,
     *                                '' ISHFLI='',I2,
     *                                '' IFLIPI='',I2,   8X,20(1H/),/)')
     *
     *                     ICHFLI,IPAFLI,
     *                     ISPFLI,ISHFLI,IFLIPI
C
              ERRSTR=' INCORRECT PARITY PARTICLE INDEX IN TESDAT'
              IERROR=1
C
          END IF
C
          IF (ISHFLI.LE.0.OR.ISHFLI.GT.2*NDSTAT.OR.
     *        K_OCCU(ISHFLI,IPAFLI,ICHFLI).NE.1) THEN
C
              WRITE(NFIPRI,'(/,
     *                     1X,20(1H/),'' INCORRECT   PARITY    HOLE  '',
     *                                '' INDEX  '',      1X,20(1H/),/,
     *                     1X,20(1H/),'' IN THE DIABATIC DATA:   '',
     *                                ''            '',  1X,20(1H/),/,
     *                     1X,20(1H/),'' ICHFLI='',I2,
     *                                '' IPAFLI='',I2,  18X,20(1H/),/,
     *                     1X,20(1H/),'' ISPFLI='',I2,
     *                                '' ISHFLI='',I2,
     *                                '' IFLIPI='',I2,   8X,20(1H/),/)')
     *
     *                     ICHFLI,IPAFLI,
     *                     ISPFLI,ISHFLI,IFLIPI
C
              ERRSTR=' INCORRECT PARITY HOLE INDEX IN TESDAT'
              IERROR=1
C
          END IF
C
C=======================================================================
C
          IF (IREFLI.NE.IPAFLI) THEN
C
              WRITE(NFIPRI,'(/,
     *                     1X,20(1H/),'' ISIFLI=1 IS FORBIDDEN FOR'',
     *                                '' IPARTY=1'',7X,20(1H/),/)')
              ERRSTR='ISIFLI=1 AND IPARTY=1 INCONSISTENCY IN TESDAT'
              IERROR=1
C
          END IF
C
          IF (ABS(IFLIPI).GT.10) THEN
C
              WRITE(NFIPRI,'(/,
     *                     1X,20(1H/),'' INCORRECT OBSERVABLE INDEX '',
     *                                '' (PARIT) '',      1X,20(1H/),/,
     *                     1X,20(1H/),'' IN THE DIABATIC DATA:   '',
     *                                ''            '',  1X,20(1H/),/,
     *                     1X,20(1H/),'' IFLIPI='',I2,
     *                                ''        '',2X,
     *                                ''        '',2X,   8X,20(1H/),/)')
     *
     *                     IFLIPI
C
              ERRSTR=' INCORRECT PARITY OBSERVABLE INDEX IN TESDAT'
              IERROR=1
C
          END IF
C
      END IF
C
C=======================================================================
C
      IF (IFLIPI.NE.0.AND.ISIMPY.NE.1.AND.ISIQTY.NE.1) THEN
C
          IF (ISPFLI.LE.0.OR.ISPFLI.GT.2*NDSTAT.OR.
     *        M_OCCU(ISPFLI,ICHFLI).NE.0) THEN
C
              WRITE(NFIPRI,'(/,
     *                     1X,20(1H/),'' INCORRECT NO-SYMMETRY PARTIC'',
     *                                ''LE INDEX'',      1X,20(1H/),/,
     *                     1X,20(1H/),'' IN THE DIABATIC DATA:   '',
     *                                ''            '',  1X,20(1H/),/,
     *                     1X,20(1H/),'' ICHFLI='',I2,
     *                                ''        '',2X,  18X,20(1H/),/,
     *                     1X,20(1H/),'' ISPFLI='',I2,
     *                                '' ISHFLI='',I2,
     *                                '' IFLIPI='',I2,   8X,20(1H/),/)')
     *
     *                     ICHFLI,
     *                     ISPFLI,ISHFLI,IFLIPI
C
              ERRSTR=' INCORRECT NO-SYMMETRY PARTICLE INDEX IN TESDAT'
              IERROR=1
C
          END IF
C
          IF (ISHFLI.LE.0.OR.ISHFLI.GT.2*NDSTAT.OR.
     *        M_OCCU(ISHFLI,ICHFLI).NE.1) THEN
C
              WRITE(NFIPRI,'(/,
     *                     1X,20(1H/),'' INCORRECT NO-SYMMETRY HOLE  '',
     *                                '' INDEX  '',      1X,20(1H/),/,
     *                     1X,20(1H/),'' IN THE DIABATIC DATA:   '',
     *                                ''            '',  1X,20(1H/),/,
     *                     1X,20(1H/),'' ICHFLI='',I2,
     *                                ''        '',2X,  18X,20(1H/),/,
     *                     1X,20(1H/),'' ISPFLI='',I2,
     *                                '' ISHFLI='',I2,
     *                                '' IFLIPI='',I2,   8X,20(1H/),/)')
     *
     *                     ICHFLI,
     *                     ISPFLI,ISHFLI,IFLIPI
C
              ERRSTR=' INCORRECT NO-SYMMETRY HOLE INDEX IN TESDAT'
              IERROR=1
C
          END IF
C
C=======================================================================
C
          IF (IPAFLI.EQ.1) THEN
C
              WRITE(NFIPRI,'(/,
     *                     1X,20(1H/),'' IPAFLI=1 IS FORBIDDEN FOR'',
     *                                '' ISIMPY=0'',7X,20(1H/),/)')
              ERRSTR='IPAFLI=1 AND ISIMPY=0 INCONSISTENCY IN TESDAT'
              IERROR=1
C
          END IF
C
          IF (IREFLI.EQ.1) THEN
C
              WRITE(NFIPRI,'(/,
     *                     1X,20(1H/),'' IREFLI=1 IS FORBIDDEN FOR'',
     *                                '' ISIMPY=0'',7X,20(1H/),/)')
              ERRSTR='IREFLI=1 AND ISIMPY=0 INCONSISTENCY IN TESDAT'
              IERROR=1
C
          END IF
C
          IF (ABS(IFLIPI).GT.10) THEN
C
              WRITE(NFIPRI,'(/,
     *                     1X,20(1H/),'' INCORRECT OBSERVABLE INDEX '',
     *                                '' (NO-SYM)'',      1X,20(1H/),/,
     *                     1X,20(1H/),'' IN THE DIABATIC DATA:   '',
     *                                ''            '',  1X,20(1H/),/,
     *                     1X,20(1H/),'' IFLIPI='',I2,
     *                                ''        '',2X,
     *                                ''        '',2X,   8X,20(1H/),/)')
     *
     *                     IFLIPI
C
              ERRSTR=' INCORRECT NO-SYMMETRY OBSERVABLE INDEX IN TESDAT'
              IERROR=1
C
          END IF
C
          IF (NOFILZ(ICHFLI).GE.1) THEN
C
              WRITE(NFIPRI,'(/,
     *                     1X,20(1H/),'' FILLING APPROXIMATION'',
     *                                '' INCOMPATIBLE'', 1X,20(1H/),/,
     *                     1X,20(1H/),'' WITH THE DIABATIC DATA:   '',
     *                                ''            '',  1X,20(1H/),/,
     *                     1X,20(1H/),'' ICHFLI='',I2,
     *                                '' IPAFLI='',I2,
     *                                '' ISIFLI='',I2,   8X,20(1H/),/,
     *                     1X,20(1H/),'' ISPFLI='',I2,
     *                                '' ISHFLI='',I2,
     *                                '' IFLIPI='',I2,   8X,20(1H/),/)')
     *
     *                     ICHFLI,IPAFLI,
     *                            IREFLI*(1-IPAFLI)+(1-IREFLI)*IPAFLI,
     *                     ISPFLI,ISHFLI,IFLIPI
C
              ERRSTR=' NO-SYMM. FILLING INCOMP. WITH DIABATIC IN TESDAT'
              IERROR=1
C
          END IF
C
      END IF
C
C=======================================================================
C
      IDIABL=0
C
      IF (ISIMPY.EQ.1.AND.ISIGNY.EQ.1) THEN
C
          INCORR=0
C
          DO IPARIT=0,NDPARI
             DO IREVER=0,NDREVE
                DO ICHARG=0,NDISOS
C
                   JSPFLI=NPFLIG(IPARIT,IREVER,ICHARG)
                   JSHFLI=NHFLIG(IPARIT,IREVER,ICHARG)
                   JFLIPI=NOFLIG(IPARIT,IREVER,ICHARG)
C
                   IF (JFLIPI.NE.0) THEN
C
                       IDIABL=1
C
                       IF (JSPFLI.LE.0.OR.JSPFLI.GT.NDSTAT.OR.
     *                     N_OCCU(JSPFLI,IPARIT,IREVER,ICHARG).NE.0)THEN
C
                           WRITE(NFIPRI,'(/,         1X,20(1H/),
     *                            '' INCORRECT SIGNATURE PARTICLE'',
     *                            '' INDEX  '',      1X,20(1H/),/,
     *                                               1X,20(1H/),
     *                            '' IN THE DIABATIC DATA:   '',
     *                            ''     (BLOCK)'',  1X,20(1H/),/,
     *                                               1X,20(1H/),
     *                            '' ICHARG='',I2,
     *                            '' IPARIT='',I2,
     *                            '' IREVER='',I2,   8X,20(1H/),/,
     *                                               1X,20(1H/),
     *                            '' JSPFLI='',I2,
     *                            '' JSHFLI='',I2,
     *                            '' JFLIPI='',I2,   8X,20(1H/),/)')
     *
     *                            ICHARG,IPARIT,IREVER,
     *                            JSPFLI,JSHFLI,JFLIPI
C
                           INCORR=1
C
                       END IF
C
                       IF (JSHFLI.LE.0.OR.JSHFLI.GT.NDSTAT.OR.
     *                     N_OCCU(JSHFLI,IPARIT,IREVER,ICHARG).NE.1)THEN
C
                           WRITE(NFIPRI,'(/,         1X,20(1H/),
     *                            '' INCORRECT SIGNATURE   HOLE  '',
     *                            '' INDEX  '',      1X,20(1H/),/,
     *                                               1X,20(1H/),
     *                            '' IN THE DIABATIC DATA:   '',
     *                            ''     (BLOCK)'',  1X,20(1H/),/,
     *                                               1X,20(1H/),
     *                            '' ICHARG='',I2,
     *                            '' IPARIT='',I2,
     *                            '' IREVER='',I2,   8X,20(1H/),/,
     *                                               1X,20(1H/),
     *                            '' JSPFLI='',I2,
     *                            '' JSHFLI='',I2,
     *                            '' JFLIPI='',I2,   8X,20(1H/),/)')
     *
     *                            ICHARG,IPARIT,IREVER,
     *                            JSPFLI,JSHFLI,JFLIPI
C
                           INCORR=1
C
                       END IF
C
                       IF (ABS(JFLIPI).GT.10.OR.
     *                    (ABS(JFLIPI).GE. 3.AND.ABS(JFLIPI).LE.8)) THEN
C
                           WRITE(NFIPRI,'(/,         1X,20(1H/),
     *                            '' INCORRECT SIGNATURE OBSERVABLE'',
     *                            '' CODE '',        1X,20(1H/),/,
     *                                               1X,20(1H/),
     *                            '' IN THE DIABATIC DATA:   '',
     *                            ''     (BLOCK)'',  1X,20(1H/),/,
     *                                               1X,20(1H/),
     *                            '' ICHARG='',I2,
     *                            '' IPARIT='',I2,
     *                            '' IREVER='',I2,   8X,20(1H/),/,
     *                                               1X,20(1H/),
     *                            '' JSPFLI='',I2,
     *                            '' JSHFLI='',I2,
     *                            '' JFLIPI='',I2,   8X,20(1H/),/)')
     *
     *                            ICHARG,IPARIT,IREVER,
     *                            JSPFLI,JSHFLI,JFLIPI
C
                           INCORR=1
C
                       END IF
C
                       IF (NOFILG(IPARIT,IREVER,ICHARG).GE.1) THEN
C
                           WRITE(NFIPRI,'(/,         1X,20(1H/),
     *                            '' FILLING APPROXIMATION'',
     *                            '' INCOMPATIBLE'', 1X,20(1H/),/,
     *                                               1X,20(1H/),
     *                            '' WITH THE DIABATIC DATA:   '',
     *                            ''     (BLOCK)'',  1X,20(1H/),/,
     *                                               1X,20(1H/),
     *                            '' ICHARG='',I2,
     *                            '' IPARIT='',I2,
     *                            '' IREVER='',I2,   8X,20(1H/),/,
     *                                               1X,20(1H/),
     *                            '' JSPFLI='',I2,
     *                            '' JSHFLI='',I2,
     *                            '' JFLIPI='',I2,   8X,20(1H/),/)')
     *
     *                            ICHARG,IPARIT,IREVER,
     *                            JSPFLI,JSHFLI,JFLIPI
C
                           INCORR=1
C
                       END IF
C
                   END IF
C
                END DO
             END DO
          END DO
C
          IF (INCORR.EQ.1) THEN
              WRITE(ERRSTR,'('' INCORR. SIGNATURE BLOCKING/FILLING '',
     *                       ''DATA IN TESDAT'')')
              IERROR=1
          END IF
C
      END IF
C
C=======================================================================
C
      IF (ISIMPY.EQ.1.AND.ISIGNY.NE.1) THEN
C
          INCORR=0
C
          DO IREVER=0,NDREVE
             DO ICHARG=0,NDISOS
C
                JSPFLI=NPFLIM(IREVER,ICHARG)
                JSHFLI=NHFLIM(IREVER,ICHARG)
                JFLIPI=NOFLIM(IREVER,ICHARG)
C
                IF (JFLIPI.NE.0) THEN
C
                    IDIABL=1
C
                    IF (JSPFLI.LE.0.OR.JSPFLI.GT.NDSTAT.OR.
     *                  L_OCCU(JSPFLI,IREVER,ICHARG).NE.0) THEN
C
                        WRITE(NFIPRI,'(/,         1X,20(1H/),
     *                         '' INCORRECT  SIMPLEX  PARTICLE'',
     *                         '' INDEX  '',      1X,20(1H/),/,
     *                                            1X,20(1H/),
     *                         '' IN THE DIABATIC DATA:   '',
     *                         ''     (BLOCK)'',  1X,20(1H/),/,
     *                                            1X,20(1H/),
     *                         '' ICHARG='',I2,
     *                         '' IREVER='',I2,  18X,20(1H/),/,
     *                                            1X,20(1H/),
     *                         '' JSPFLI='',I2,
     *                         '' JSHFLI='',I2,
     *                         '' JFLIPI='',I2,   8X,20(1H/),/)')
     *
     *                         ICHARG,       IREVER,
     *                         JSPFLI,JSHFLI,JFLIPI
C
                        INCORR=1
C
                    END IF
C
                    IF (JSHFLI.LE.0.OR.JSHFLI.GT.NDSTAT.OR.
     *                  L_OCCU(JSHFLI,IREVER,ICHARG).NE.1) THEN
C
                        WRITE(NFIPRI,'(/,         1X,20(1H/),
     *                         '' INCORRECT  SIMPLEX    HOLE  '',
     *                         '' INDEX  '',      1X,20(1H/),/,
     *                                            1X,20(1H/),
     *                         '' IN THE DIABATIC DATA:   '',
     *                         ''     (BLOCK)'',  1X,20(1H/),/,
     *                                            1X,20(1H/),
     *                         '' ICHARG='',I2,
     *                         '' IREVER='',I2,  18X,20(1H/),/,
     *                                            1X,20(1H/),
     *                         '' JSPFLI='',I2,
     *                         '' JSHFLI='',I2,
     *                         '' JFLIPI='',I2,   8X,20(1H/),/)')
     *
     *                         ICHARG,       IREVER,
     *                         JSPFLI,JSHFLI,JFLIPI
C
                        INCORR=1
C
                    END IF
C
                    IF (ABS(JFLIPI).GT.10.OR.
     *                 (ABS(JFLIPI).GE. 3.AND.ABS(JFLIPI).LE.8)) THEN
C
                        WRITE(NFIPRI,'(/,         1X,20(1H/),
     *                         '' INCORRECT SIMPLEX OBSERVABLE'',
     *                         '' CODE   '',      1X,20(1H/),/,
     *                                            1X,20(1H/),
     *                         '' IN THE DIABATIC DATA:   '',
     *                         ''     (BLOCK)'',  1X,20(1H/),/,
     *                                            1X,20(1H/),
     *                         '' ICHARG='',I2,
     *                         '' IREVER='',I2,  18X,20(1H/),/,
     *                                            1X,20(1H/),
     *                         '' JSPFLI='',I2,
     *                         '' JSHFLI='',I2,
     *                         '' JFLIPI='',I2,   8X,20(1H/),/)')
     *
     *                         ICHARG,       IREVER,
     *                         JSPFLI,JSHFLI,JFLIPI
C
                        INCORR=1
C
                    END IF
                END IF
C
             END DO
          END DO
C
          IF (INCORR.EQ.1) THEN
              WRITE(ERRSTR,'('' INCORRECT SIMPLEX BLOCKING '',
     *                       ''DATA IN TESDAT'')')
              IERROR=1
          END IF
C
      END IF
C
C=======================================================================
C
      IF (ISIMPY.NE.1.AND.ISIQTY.EQ.1) THEN
C
          INCORR=0
C
          DO IPARIT=0,NDPARI
             DO ICHARG=0,NDISOS
C
                JSPFLI=NPFLIQ(IPARIT,ICHARG)
                JSHFLI=NHFLIQ(IPARIT,ICHARG)
                JFLIPI=NOFLIQ(IPARIT,ICHARG)
C
                IF (JFLIPI.NE.0) THEN
C
                    IDIABL=1
C
                    IF (JSPFLI.LE.0.OR.JSPFLI.GT.2*NDSTAT.OR.
     *                  K_OCCU(JSPFLI,IPARIT,ICHARG).NE.0) THEN
C
                        WRITE(NFIPRI,'(/,         1X,20(1H/),
     *                         '' INCORRECT  PARITY   PARTICLE'',
     *                         '' INDEX  '',      1X,20(1H/),/,
     *                                            1X,20(1H/),
     *                         '' IN THE DIABATIC DATA:   '',
     *                         ''     (BLOCK)'',  1X,20(1H/),/,
     *                                            1X,20(1H/),
     *                         '' ICHARG='',I2,
     *                         '' IPARIT='',I2,  18X,20(1H/),/,
     *                                            1X,20(1H/),
     *                         '' JSPFLI='',I2,
     *                         '' JSHFLI='',I2,
     *                         '' JFLIPI='',I2,   8X,20(1H/),/)')
     *
     *                         ICHARG,IPARIT,
     *                         JSPFLI,JSHFLI,JFLIPI
C
                        INCORR=1
C
                    END IF
C
                    IF (JSHFLI.LE.0.OR.JSHFLI.GT.2*NDSTAT.OR.
     *                  K_OCCU(JSHFLI,IPARIT,ICHARG).NE.1) THEN
C
                        WRITE(NFIPRI,'(/,         1X,20(1H/),
     *                         '' INCORRECT   PARITY    HOLE  '',
     *                         '' INDEX  '',      1X,20(1H/),/,
     *                                            1X,20(1H/),
     *                         '' IN THE DIABATIC DATA:   '',
     *                         ''     (BLOCK)'',  1X,20(1H/),/,
     *                                            1X,20(1H/),
     *                         '' ICHARG='',I2,
     *                         '' IPARIT='',I2,  18X,20(1H/),/,
     *                                            1X,20(1H/),
     *                         '' JSPFLI='',I2,
     *                         '' JSHFLI='',I2,
     *                         '' JFLIPI='',I2,   8X,20(1H/),/)')
     *
     *                         ICHARG,IPARIT,
     *                         JSPFLI,JSHFLI,JFLIPI
C
                        INCORR=1
C
                    END IF
C
                    IF (ABS(JFLIPI).GT.10) THEN
C
                        WRITE(NFIPRI,'(/,         1X,20(1H/),
     *                         '' INCORRECT PARITY  OBSERVABLE'',
     *                         '' CODE   '',      1X,20(1H/),/,
     *                                            1X,20(1H/),
     *                         '' IN THE DIABATIC DATA:   '',
     *                         ''     (BLOCK)'',  1X,20(1H/),/,
     *                                            1X,20(1H/),
     *                         '' ICHARG='',I2,
     *                         '' IPARIT='',I2,  18X,20(1H/),/,
     *                                            1X,20(1H/),
     *                         '' JSPFLI='',I2,
     *                         '' JSHFLI='',I2,
     *                         '' JFLIPI='',I2,   8X,20(1H/),/)')
     *
     *                         ICHARG,IPARIT,
     *                         JSPFLI,JSHFLI,JFLIPI
C
                        INCORR=1
C
                    END IF
                END IF
C
             END DO
          END DO
C
          IF (INCORR.EQ.1) THEN
              WRITE(ERRSTR,'('' INCORRECT PARITY BLOCKING '',
     *                       ''DATA IN TESDAT'')')
              IERROR=1
          END IF
C
      END IF
C
C=======================================================================
C
      IF (ISIMPY.NE.1.AND.ISIQTY.NE.1) THEN
C
          INCORR=0
C
          DO ICHARG=0,NDISOS
C
             JSPFLI=NPFLIZ(ICHARG)
             JSHFLI=NHFLIZ(ICHARG)
             JFLIPI=NOFLIZ(ICHARG)
C
             IF (JFLIPI.NE.0) THEN
C
                 IDIABL=1
C
                 IF (JSPFLI.LE.0.OR.JSPFLI.GT.2*NDSTAT.OR.
     *               M_OCCU(JSPFLI,ICHARG).NE.0) THEN
C
                     WRITE(NFIPRI,'(/,         1X,20(1H/),
     *                      '' INCORRECT NO-SYMMETRY PARTICLE'',
     *                      '' INDEX'',        1X,20(1H/),/,
     *                                         1X,20(1H/),
     *                      '' IN THE DIABATIC DATA:   '',
     *                      ''     (BLOCK)'',  1X,20(1H/),/,
     *                                         1X,20(1H/),
     *                      '' ICHARG='',I2,
     *                      ''        '',2X,  18X,20(1H/),/,
     *                                         1X,20(1H/),
     *                      '' JSPFLI='',I2,
     *                      '' JSHFLI='',I2,
     *                      '' JFLIPI='',I2,   8X,20(1H/),/)')
     *
     *                      ICHARG,
     *                      JSPFLI,JSHFLI,JFLIPI
C
                     INCORR=1
C
                 END IF
C
                 IF (JSHFLI.LE.0.OR.JSHFLI.GT.2*NDSTAT.OR.
     *               M_OCCU(JSHFLI,ICHARG).NE.1) THEN
C
                     WRITE(NFIPRI,'(/,         1X,20(1H/),
     *                      '' INCORRECT NO-SYMMETRY HOLE  '',
     *                      '' INDEX  '',      1X,20(1H/),/,
     *                                         1X,20(1H/),
     *                      '' IN THE DIABATIC DATA:   '',
     *                      ''     (BLOCK)'',  1X,20(1H/),/,
     *                                         1X,20(1H/),
     *                      '' ICHARG='',I2,
     *                      ''        '',2X,  18X,20(1H/),/,
     *                                         1X,20(1H/),
     *                      '' JSPFLI='',I2,
     *                      '' JSHFLI='',I2,
     *                      '' JFLIPI='',I2,   8X,20(1H/),/)')
     *
     *                      ICHARG,
     *                      JSPFLI,JSHFLI,JFLIPI
C
                     INCORR=1
C
                 END IF
C
                 IF (ABS(JFLIPI).GT.10) THEN
C
                     WRITE(NFIPRI,'(/,         1X,20(1H/),
     *                      '' INCORRECT NO-SYMMETRY OBSERVABLE'',
     *                      '' CODE'',         1X,19(1H/),/,
     *                            1X,20(1H/),
     *                      '' IN THE DIABATIC DATA:   '',
     *                      ''      (BLOCK)'', 1X,19(1H/),/,
     *                            1X,20(1H/),
     *                      '' ICHARG='',I2,
     *                      ''        '',2X,  19X,19(1H/),/,
     *                            1X,20(1H/),
     *                      '' JSPFLI='',I2,
     *                      '' JSHFLI='',I2,
     *                      '' JFLIPI='',I2,   9X,19(1H/),/)')
     *
     *                      ICHARG,
     *                      JSPFLI,JSHFLI,JFLIPI
C
                     INCORR=1
C
                 END IF
C
                 IF (NOFILZ(ICHARG).GE.1) THEN
C
                     WRITE(NFIPRI,'(/,         1X,20(1H/),
     *                      '' FILLING APPROXIMATION'',
     *                      '' INCOMPATIBLE'', 1X,20(1H/),/,
     *                                         1X,20(1H/),
     *                      '' WITH THE DIABATIC DATA FOR'',
     *                      '' NO SYMMETRY'',  1X,20(1H/),/,
     *                                         1X,20(1H/),
     *                      '' ICHARG='',I2,
     *                      ''        '',2X,
     *                      ''        '',2X,   8X,20(1H/),/,
     *                                         1X,20(1H/),
     *                      '' JSPFLI='',I2,
     *                      '' JSHFLI='',I2,
     *                      '' JFLIPI='',I2,   8X,20(1H/),/)')
     *
     *                      ICHARG,
     *                      JSPFLI,JSHFLI,JFLIPI
C
                     INCORR=1
C
                 END IF
C
             END IF
C
          END DO
C
          IF (INCORR.EQ.1) THEN
              WRITE(ERRSTR,'('' INCORRECT NO-SYMM. BLOCKING/FILLING '',
     *                       ''DATA IN TESDAT'')')
              IERROR=1
          END IF
C
      END IF
C
C=======================================================================
C
      IF (IFLIPI.NE.0.AND.IDIABL.NE.0) THEN
C
          WRITE(NFIPRI,'(/,
     *                 1X,20(1H/),'' SINGLE-PAIR AND ALL-BLOCKS'',
     *                            '' DIABATIC'',2X,20(1H/),/,
     *                 1X,20(1H/),'' BLOCKINGS CANNOT BE USED  '',
     *                            ''         '',2X,20(1H/),/,
     *                 1X,20(1H/),'' S I M U L T A N E O U S L Y'',
     *                            ''        '',2X,20(1H/),/)')
C
          ERRSTR=' SINGLE-PAIR VS. ALL-BLOCKS INCONSISTENCY IN TESDAT'
          IERROR=1
C
      END IF
C
C=======================================================================
C
      IF ((IFLIPI.NE.0.OR.IDIABL.NE.0).AND.IROTAT.NE.1) THEN
C
          WRITE(NFIPRI,'(/,
     *                 1X,20(1H/),'' DIABATIC BLOCKING CANNOT '',
     *                            '' BE USED '',3X,20(1H/),/,
     *                 1X,20(1H/),'' TOGETHER WITH IROTAT=0    '',
     *                            ''         '',2X,20(1H/),/)')
C
          ERRSTR=' DIABATIC BLOCKING AND IROTAT=0 IN TESDAT'
          IERROR=1
C
      END IF
C
C=======================================================================
C
      IF ((IFLIPI.NE.0.OR.IDIABL.NE.0).AND.IPAIRI.EQ.1) THEN
C
          WRITE(NFIPRI,'(/,
     *                 1X,20(1H/),'' DIABATIC BLOCKING CANNOT '',
     *                            '' BE USED '',3X,20(1H/),/,
     *                 1X,20(1H/),'' TOGETHER WITH IPAIRI=1    '',
     *                            ''         '',2X,20(1H/),/)')
C
          ERRSTR=' DIABATIC BLOCKING AND IPAIRI=1 IN TESDAT'
          IERROR=1
C
      END IF
C
C=======================================================================
C
      IF (ISIMPY.EQ.1.AND.ISIGNY.EQ.1) THEN
C
          INCORR=0
C
          DO IPARIT=0,NDPARI
             DO IREVER=0,NDREVE
                DO ICHARG=0,NDISOS
C
                   JSPFIL=NPFILG(IPARIT,IREVER,ICHARG)
                   JSHFIL=NHFILG(IPARIT,IREVER,ICHARG)
                   JFILPI=NOFILG(IPARIT,IREVER,ICHARG)
C
                   IF (JFILPI.GE.1) THEN
C
                       IF (JSPFIL.LE.0.OR.JSPFIL.GT.NDSTAT.OR.
     *                     JSPFIL.LT.JSHFIL) THEN
C
                           WRITE(NFIPRI,'(/,         1X,20(1H/),
     *                            '' INCORRECT SIGNATURE   UPPER '',
     *                            '' INDEX  '',      1X,20(1H/),/,
     *                                               1X,20(1H/),
     *                            '' IN THE FILLING APPROXIMATION'',
     *                            '' DATA:  '',  1X,20(1H/),/,
     *                                               1X,20(1H/),
     *                            '' ICHARG='',I2,
     *                            '' IPARIT='',I2,
     *                            '' IREVER='',I2,   8X,20(1H/),/,
     *                                               1X,20(1H/),
     *                            '' JSPFIL='',I2,
     *                            '' JSHFIL='',I2,
     *                            '' JFILPI='',I2,   8X,20(1H/),/)')
     *
     *                            ICHARG,IPARIT,IREVER,
     *                            JSPFIL,JSHFIL,JFILPI
C
                           INCORR=1
C
                       END IF
C
                       IF (JSHFIL.LE.0.OR.JSHFIL.GT.NDSTAT.OR.
     *                     JSHFIL.GT.JSPFIL) THEN
C
                           WRITE(NFIPRI,'(/,         1X,20(1H/),
     *                            '' INCORRECT SIGNATURE  LOWER  '',
     *                            '' INDEX  '',      1X,20(1H/),/,
     *                                               1X,20(1H/),
     *                            '' IN THE FILLING APPROXIMATION'',
     *                            '' DATA:  '',  1X,20(1H/),/,
     *                                               1X,20(1H/),
     *                            '' ICHARG='',I2,
     *                            '' IPARIT='',I2,
     *                            '' IREVER='',I2,   8X,20(1H/),/,
     *                                               1X,20(1H/),
     *                            '' JSPFIL='',I2,
     *                            '' JSHFIL='',I2,
     *                            '' JFILPI='',I2,   8X,20(1H/),/)')
     *
     *                            ICHARG,IPARIT,IREVER,
     *                            JSPFIL,JSHFIL,JFILPI
C
                           INCORR=1
C
                       END IF
C
                       IF (JFILPI.GT.2*(JSPFIL-JSHFIL+1)) THEN
C
                           WRITE(NFIPRI,'(/,         1X,20(1H/),
     *                            '' INCORRECT SIGNATURE PARTICLE'',
     *                            '' NUMBER '',        1X,20(1H/),/,
     *                                               1X,20(1H/),
     *                            '' IN THE FILLING  DATA:   '',
     *                            ''            '',  1X,20(1H/),/,
     *                                               1X,20(1H/),
     *                            '' ICHARG='',I2,
     *                            '' IPARIT='',I2,
     *                            '' IREVER='',I2,   8X,20(1H/),/,
     *                                               1X,20(1H/),
     *                            '' JSPFIL='',I2,
     *                            '' JSHFIL='',I2,
     *                            '' JFILPI='',I2,   8X,20(1H/),/)')
     *
     *                            ICHARG,IPARIT,IREVER,
     *                            JSPFIL,JSHFIL,JFILPI
C
                           INCORR=1
C
                       END IF
C
                       IF (IPAIRI.EQ.1) THEN
C
                           WRITE(NFIPRI,'(/,         1X,20(1H/),
     *                            '' FILLING  APPROXIMATION '',
     *                            '' INCOMPATIBLE'', 1X,20(1H/),/,
     *                                               1X,20(1H/),
     *                            '' WITH PAIRING CORRELATIONS'',
     *                            '' (IPAIRI=1)'',   1X,20(1H/),/,
     *                                               1X,20(1H/),
     *                            '' ICHARG='',I2,
     *                            '' IPARIT='',I2,
     *                            '' IREVER='',I2,   8X,20(1H/),/,
     *                                               1X,20(1H/),
     *                            '' JSPFIL='',I2,
     *                            '' JSHFIL='',I2,
     *                            '' JFILPI='',I2,   8X,20(1H/),/)')
     *
     *                            ICHARG,IPARIT,IREVER,
     *                            JSPFIL,JSHFIL,JFILPI
C
                           INCORR=1
C
                       END IF
C
                   END IF
C
                END DO
             END DO
          END DO
C
          IF (INCORR.EQ.1) THEN
              WRITE(ERRSTR,'('' INCORRECT SIGNATURE FILLING '',
     *                       ''DATA IN TESDAT'')')
              IERROR=1
          END IF
C
      END IF
C
C=======================================================================
C
      IF (ISIMPY.NE.1.AND.ISIQTY.NE.1) THEN
C
          INCORR=0
C
          DO ICHARG=0,NDISOS
C
             JSPFIL=NPFILZ(ICHARG)
             JSHFIL=NHFILZ(ICHARG)
             JFILPI=NOFILZ(ICHARG)
C
             IF (JFILPI.NE.0) THEN
C
                 IDIABL=1
C
                 IF (JSPFIL.LE.0.OR.JSPFIL.GT.2*NDSTAT.OR.
     *               JSPFIL.LT.JSHFIL) THEN
C
                     WRITE(NFIPRI,'(/,         1X,20(1H/),
     *                      '' INCORRECT NO-SYMMETRY UPPER'',
     *                      '' INDEX   '',     1X,20(1H/),/,
     *                                         1X,20(1H/),
     *                      '' IN THE FILLING  DATA:   '',
     *                      ''            '',  1X,20(1H/),/,
     *                                         1X,20(1H/),
     *                      '' ICHARG='',I2,
     *                      ''        '',2X,  18X,20(1H/),/,
     *                                         1X,20(1H/),
     *                      '' JSPFIL='',I2,
     *                      '' JSHFIL='',I2,
     *                      '' JFILPI='',I2,   8X,20(1H/),/)')
     *
     *                      ICHARG,
     *                      JSPFIL,JSHFIL,JFILPI
C
                     INCORR=1
C
                 END IF
C
                 IF (JSHFIL.LE.0.OR.JSHFIL.GT.2*NDSTAT.OR.
     *               JSHFIL.GT.JSPFIL) THEN
C
                     WRITE(NFIPRI,'(/,         1X,20(1H/),
     *                      '' INCORRECT NO-SYMMETRY LOWER'',
     *                      '' INDEX   '',     1X,20(1H/),/,
     *                                         1X,20(1H/),
     *                      '' IN THE FILLING  DATA:   '',
     *                      ''            '',  1X,20(1H/),/,
     *                                         1X,20(1H/),
     *                      '' ICHARG='',I2,
     *                      ''        '',2X,  18X,20(1H/),/,
     *                                         1X,20(1H/),
     *                      '' JSPFIL='',I2,
     *                      '' JSHFIL='',I2,
     *                      '' JFILPI='',I2,   8X,20(1H/),/)')
     *
     *                      ICHARG,
     *                      JSPFIL,JSHFIL,JFILPI
C
                     INCORR=1
C
                 END IF
C
                 IF (JFILPI.GT.2*(JSPFIL-JSHFIL+1)) THEN
C
                     WRITE(NFIPRI,'(/,         1X,20(1H/),
     *                      '' INCORRECT NO-SYMMETRY PARTICLE'',
     *                      '' NUMBER'',         1X,19(1H/),/,
     *                            1X,20(1H/),
     *                      '' IN THE FILLING  DATA:   '',
     *                      ''             '', 1X,19(1H/),/,
     *                            1X,20(1H/),
     *                      '' ICHARG='',I2,
     *                      ''        '',2X,  19X,19(1H/),/,
     *                            1X,20(1H/),
     *                      '' JSPFIL='',I2,
     *                      '' JSHFIL='',I2,
     *                      '' JFILPI='',I2,   9X,19(1H/),/)')
     *
     *                      ICHARG,
     *                      JSPFIL,JSHFIL,JFILPI
C
                     INCORR=1
C
                 END IF
C
             END IF
C
          END DO
C
          IF (INCORR.EQ.1) THEN
              WRITE(ERRSTR,'('' INCORRECT NO-SYMMETRY FILLING '',
     *                       ''DATA IN TESDAT'')')
              IERROR=1
          END IF
C
      END IF
C
C=======================================================================
C            ATTENTION: BETWEEN VERSIONS (2.35H) AND  (2.52J)  THE  TEST
C                       BELOW INCLUDED ALSO THE FOLLOING CONDITION:
C                               NUMBSP(IREVER,ICHARG).GT.NLIMIT
C                       WHICH WAS STOPPING THE CODE IN CASE OF NLIMIT<0,
C                       THAT IS, WHEN THE BASIS WAS SUPPOSED TO  BE  CUT
C                       BASED ON THE ENERGIES OF THE HO STATES.
C                       THIS BUG WAS CORRECTED ON 13/02/2012 IN  VERSION
C                       (2.52K).
C=======================================================================
C
      INCORR=0
C
      DO IREVER=0,NDREVE
         DO ICHARG=0,NDISOS
C
            IF (NUMBSP(IREVER,ICHARG).LT.0.OR.
     *          NUMBSP(IREVER,ICHARG).GT.NDSTAT) THEN
C
                WRITE(NFIPRI,'(/,         1X,20(1H/),
     *                 '' INCORRECT PHASE SPACE DEFINITION'',
     *                 ''    '',          1X,20(1H/),/,
     *                                    1X,20(1H/),
     *                 '' IREVER='',I4,
     *                 '' ICHARG='',I4,
     *                 '' NUMBSP='',I4,   2X,20(1H/),/,
     *                                    1X,20(1H/),
     *                 '' NLIMIT='',I4,
     *                 '' NDSTAT='',I4,
     *                 ''        '',      6X,20(1H/),/)')
     *
     *                 IREVER,ICHARG,NUMBSP(IREVER,ICHARG),
     *                 NLIMIT,NDSTAT
C
                INCORR=1
C
            END IF
C
         END DO
      END DO
C
      IF (INCORR.EQ.1) THEN
          ERRSTR=' INCORRECT PHASE SPACE DEFINITION IN TESDAT'
          IERROR=1
      END IF
C
C=======================================================================
C
      IF ((ITILAX.NE.0.OR.ITISAX.NE.0).AND.IROTAT.NE.1) THEN
C
          WRITE(NFIPRI,'(/,
     *                 1X,20(1H/),'' TILTED-AXIS CRANKING CANNOT'',
     *                            '' BE USED '',1X,20(1H/),/,
     *                 1X,20(1H/),'' TOGETHER WITH IROTAT=0    '',
     *                            ''         '',2X,20(1H/),/,
     *                 1X,20(1H/),'' (ITILAX='',I1,'', ITISAX='',I1,
     *                            '')        '',9X,20(1H/),/)')
     *
     *    ITILAX,ITISAX
C
          ERRSTR=' TILTED AXIS AND IROTAT=0 IN TESDAT'
          IERROR=1
C
      END IF
C
C=======================================================================
C
      IF ((ITILAX.NE.0.OR.ITISAX.NE.0).AND.ISIMPY.EQ.1) THEN
C
          WRITE(NFIPRI,'(/,
     *                 1X,20(1H/),'' TILTED-AXIS CRANKING CANNOT'',
     *                            '' BE USED '',1X,20(1H/),/,
     *                 1X,20(1H/),'' TOGETHER WITH ISIMPY=1    '',
     *                            ''         '',2X,20(1H/),/,
     *                 1X,20(1H/),'' (ITILAX='',I1,'', ITISAX='',I1,
     *                            '')        '',9X,20(1H/),/)')
     *
     *    ITILAX,ITISAX
C
          ERRSTR=' TILTED AXIS AND ISIMPY=1 IN TESDAT'
          IERROR=1
C
      END IF
C
C=======================================================================
C
      IF ((ITILAX.NE.0.OR.ITISAX.NE.0).AND.ISIGNY.EQ.1) THEN
C
          WRITE(NFIPRI,'(/,
     *                 1X,20(1H/),'' TILTED-AXIS CRANKING CANNOT'',
     *                            '' BE USED '',1X,20(1H/),/,
     *                 1X,20(1H/),'' TOGETHER WITH ISIGNY=1    '',
     *                            ''         '',2X,20(1H/),/,
     *                 1X,20(1H/),'' (ITILAX='',I1,'', ITISAX='',I1,
     *                            '')        '',9X,20(1H/),/)')
     *
     *    ITILAX,ITISAX
C
          ERRSTR=' TILTED AXIS AND ISIGNY=1 IN TESDAT'
          IERROR=1
C
      END IF
C
C=======================================================================
C         RESTRICTION BELOW HAS BEEN REMOVED IN 2.16A ON 28/03/05 AFTER
C         STARTING IMPLEMENTATIONS RELATED TO "HFBSIZ"
C=======================================================================
C
C     IF (IPAHFB.EQ.1.AND.ISIMPY.NE.1) THEN
C
C         WRITE(NFIPRI,'(/,1X,20(1H/),'' HFB PAIRING CANNOT BE USED '',
C    *                                ''         '',1X,20(1H/),/,
C    *                     1X,20(1H/),'' TOGETHER WITH ISIMPY=0    '',
C    *                                ''         '',2X,20(1H/),/)')
C
C         STOP ' HFB PAIRING NOT IMPLEMENTED FOR ISIMPY=0 IN TESDAT'
C
C     END IF
C
C=======================================================================
C         RESTRICTION BELOW HAS BEEN REMOVED IN 2.26O ON 07/03/07 AFTER
C         STARTING IMPLEMENTATIONS RELATED TO "HFBSIQ"
C=======================================================================
C
C     IF (IPAHFB.EQ.1.AND.ISIMPY.NE.1.AND.ISIQTY.EQ.1) THEN
C
C         WRITE(NFIPRI,'(/,1X,20(1H/),'' HFB PAIRING CANNOT BE USED '',
C    *                                ''         '',1X,20(1H/),/,
C    *                     1X,20(1H/),'' TOGETHER WITH ISIMPY=0 AND'',
C    *                                '' IPARTY=1'',2X,20(1H/),/)')
C
C         STOP ' HFB NOT IMPLEMENTED FOR ISIMPY=0 + IPARTY=1 IN TESDAT'
C
C     END IF
C
C=======================================================================
C
      IF ((IABS(IDSIGN).EQ.1.OR.IABS(IDSIGP).EQ.1).AND.
     *    (ISIMPY.NE.1.OR.ISIGNY.NE.1)) THEN
C
          WRITE(NFIPRI,'(/,
     *                 1X,20(1H/),'' PARITY/SIGN. QUASIP.  BLOCKING'',
     *                            ''  ONLY'',1X,20(1H/),/,
     *                 1X,20(1H/),'' ALLOWED  FOR  ISIMPY=1 AND'',
     *                            '' ISIGNY=1'',2X,20(1H/),/)')
C
          WRITE(ERRSTR,'('' PAR./SIG. Q.P. BLOCKING & ISIMPY=0 OR '',
     *                   ''ISIGNY=0 IN TESDAT'')')
          IERROR=1
C
      END IF
C
C=======================================================================
C
      IF ((IABS(IDSIMN).EQ.1.OR.IABS(IDSIMP).EQ.1).AND.
     *    (ISIMPY.NE.1.OR.ISIGNY.EQ.1)) THEN
C
          WRITE(NFIPRI,'(/,
     *                 1X,20(1H/),'' SIMPLEX QUASIPARTICLE BLOCKING'',
     *                            ''  ONLY'',1X,20(1H/),/,
     *                 1X,20(1H/),'' ALLOWED  FOR  ISIMPY=1 AND'',
     *                            '' ISIGNY=0'',2X,20(1H/),/)')
C
          WRITE(ERRSTR,'('' SIMPLEX Q.P. BLOCKING & ISIMPY=0 OR '',
     *                   ''ISIGNY=1 IN TESDAT'')')
          IERROR=1
C
      END IF
C
C=======================================================================
C
      IF ((IABS(IDSIQN).EQ.1.OR.IABS(IDSIQP).EQ.1).AND.
     *    (ISIMPY.EQ.1.OR.ISIQTY.NE.1)) THEN
C
          WRITE(NFIPRI,'(/,
     *                 1X,20(1H/),'' PARITY  QUASIPARTICLE BLOCKING'',
     *                            ''  ONLY'',1X,20(1H/),/,
     *                 1X,20(1H/),'' ALLOWED  FOR  ISIMPY=0 AND'',
     *                            '' ISIQTY=1'',2X,20(1H/),/)')
C
          WRITE(ERRSTR,'('' PARITY Q.P. BLOCKING & ISIMPY=0 OR '',
     *                   ''ISIQTY=0 IN TESDAT'')')
          IERROR=1
C
      END IF
C
C=======================================================================
C
      IF ((IABS(IDSIZN).EQ.1.OR.IABS(IDSIZP).EQ.1).AND.
     *    (ISIMPY.EQ.1.OR.ISIQTY.EQ.1)) THEN
C
          WRITE(NFIPRI,'(/,
     *                 1X,20(1H/),'' NO SYM. QUASIPARTICLE BLOCKING'',
     *                            ''  ONLY'',1X,20(1H/),/,
     *                 1X,20(1H/),'' ALLOWED  FOR  ISIMPY=0 AND'',
     *                            '' ISIQTY=0'',2X,20(1H/),/)')
C
          WRITE(ERRSTR,'('' NO SYM. Q.P. BLOCKING & ISIMPY=1 OR '',
     *                   ''ISIQTY=1 IN TESDAT'')')
          IERROR=1
C
      END IF
C
C=======================================================================
C
      IF ((IFIBLN.EQ.1.OR.INIBLN.EQ.1).AND.IABS(IDSIGN).NE.1.AND.
     *    (ISIMPY.EQ.1.AND.ISIQTY.EQ.1)) THEN
C
          WRITE(NFIPRI,'(/,
     *                 1X,20(1H/),'' BLOCKING  WITH  FIXED  NEUTRON'',
     *                            ''  WAVE'',1X,20(1H/),/,
     *                 1X,20(1H/),'' FUNCTIONS REQUIRES THAT '',
     *                            '' |IDSIGN|=1'',2X,20(1H/),/)')
C
          WRITE(ERRSTR,'('' BLOCKING WITH FIXED NEUTRON WFS AND '',
     *                   ''IDSIGN=0 IN TESDAT'')')
          IERROR=1
C
      END IF
C
C=======================================================================
C
      IF ((IFIBLP.EQ.1.OR.INIBLP.EQ.1).AND.IABS(IDSIGP).NE.1.AND.
     *    (ISIMPY.EQ.1.AND.ISIQTY.EQ.1)) THEN
C
          WRITE(NFIPRI,'(/,
     *                 1X,20(1H/),'' BLOCKING  WITH  FIXED   PROTON'',
     *                            ''  WAVE'',1X,20(1H/),/,
     *                 1X,20(1H/),'' FUNCTIONS REQUIRES THAT '',
     *                            '' |IDSIGP|=1'',2X,20(1H/),/)')
C
          WRITE(ERRSTR,'('' BLOCKING WITH FIXED PROTON WFS AND '',
     *                   ''IDSIGP=0 IN TESDAT'')')
          IERROR=1
C
      END IF
C
C=======================================================================
C
      IF ((IFIBLN.EQ.1.OR.INIBLN.EQ.1).AND.IABS(IDSIMN).NE.1.AND.
     *    (ISIMPY.EQ.1.AND.ISIQTY.NE.1)) THEN
C
          WRITE(NFIPRI,'(/,
     *                 1X,20(1H/),'' BLOCKING  WITH  FIXED  NEUTRON'',
     *                            ''  WAVE'',1X,20(1H/),/,
     *                 1X,20(1H/),'' FUNCTIONS REQUIRES THAT '',
     *                            '' |IDSIMN|=1'',2X,20(1H/),/)')
C
          WRITE(ERRSTR,'('' BLOCKING WITH FIXED NEUTRON WFS AND '',
     *                   ''IDSIMN=0 IN TESDAT'')')
          IERROR=1
C
      END IF
C
C=======================================================================
C
      IF ((IFIBLP.EQ.1.OR.INIBLP.EQ.1).AND.IABS(IDSIMP).NE.1.AND.
     *    (ISIMPY.EQ.1.AND.ISIQTY.NE.1)) THEN
C
          WRITE(NFIPRI,'(/,
     *                 1X,20(1H/),'' BLOCKING  WITH  FIXED   PROTON'',
     *                            ''  WAVE'',1X,20(1H/),/,
     *                 1X,20(1H/),'' FUNCTIONS REQUIRES THAT '',
     *                            '' |IDSIMP|=1'',2X,20(1H/),/)')
C
          WRITE(ERRSTR,'('' BLOCKING WITH FIXED PROTON WFS AND '',
     *                   ''IDSIMP=0 IN TESDAT'')')
          IERROR=1
C
      END IF
C
C=======================================================================
C
      IF ((IFIBLN.EQ.1.OR.INIBLN.EQ.1).AND.IABS(IDSIQN).NE.1.AND.
     *    (ISIMPY.NE.1.AND.ISIQTY.EQ.1)) THEN
C
          WRITE(NFIPRI,'(/,
     *                 1X,20(1H/),'' BLOCKING  WITH  FIXED  NEUTRON'',
     *                            ''  WAVE'',1X,20(1H/),/,
     *                 1X,20(1H/),'' FUNCTIONS REQUIRES THAT '',
     *                            '' |IDSIQN|=1'',2X,20(1H/),/)')
C
          WRITE(ERRSTR,'('' BLOCKING WITH FIXED NEUTRON WFS AND '',
     *                   ''IDSIQN=0 IN TESDAT'')')
          IERROR=1
C
      END IF
C
C=======================================================================
C
      IF ((IFIBLP.EQ.1.OR.INIBLP.EQ.1).AND.IABS(IDSIQP).NE.1.AND.
     *    (ISIMPY.NE.1.AND.ISIQTY.EQ.1)) THEN
C
          WRITE(NFIPRI,'(/,
     *                 1X,20(1H/),'' BLOCKING  WITH  FIXED   PROTON'',
     *                            ''  WAVE'',1X,20(1H/),/,
     *                 1X,20(1H/),'' FUNCTIONS REQUIRES THAT '',
     *                            '' |IDSIQP|=1'',2X,20(1H/),/)')
C
          WRITE(ERRSTR,'('' BLOCKING WITH FIXED PROTON WFS AND '',
     *                   ''IDSIQP=0 IN TESDAT'')')
          IERROR=1
C
      END IF
C
C=======================================================================
C
      IF ((IFIBLN.EQ.1.OR.INIBLN.EQ.1).AND.IABS(IDSIZN).NE.1.AND.
     *    (ISIMPY.NE.1.AND.ISIQTY.NE.1)) THEN
C
          WRITE(NFIPRI,'(/,
     *                 1X,20(1H/),'' BLOCKING  WITH  FIXED  NEUTRON'',
     *                            ''  WAVE'',1X,20(1H/),/,
     *                 1X,20(1H/),'' FUNCTIONS REQUIRES THAT '',
     *                            '' |IDSIZN|=1'',2X,20(1H/),/)')
C
          WRITE(ERRSTR,'('' BLOCKING WITH FIXED NEUTRON WFS AND '',
     *                   ''IDSIZN=0 IN TESDAT'')')
          IERROR=1
C
      END IF
C
C=======================================================================
C
      IF ((IFIBLP.EQ.1.OR.INIBLP.EQ.1).AND.IABS(IDSIZP).NE.1.AND.
     *    (ISIMPY.NE.1.AND.ISIQTY.NE.1)) THEN
C
          WRITE(NFIPRI,'(/,
     *                 1X,20(1H/),'' BLOCKING  WITH  FIXED   PROTON'',
     *                            ''  WAVE'',1X,20(1H/),/,
     *                 1X,20(1H/),'' FUNCTIONS REQUIRES THAT '',
     *                            '' |IDSIZP|=1'',2X,20(1H/),/)')
C
          WRITE(ERRSTR,'('' BLOCKING WITH FIXED PROTON WFS AND '',
     *                   ''IDSIZP=0 IN TESDAT'')')
          IERROR=1
C
      END IF
C
C=======================================================================
C
      IF (((IFIBLN.EQ.1.AND.INIBLN.EQ.0).OR.
     *     (IFIBLP.EQ.1.AND.INIBLP.EQ.0)).AND.ICONTI.NE.1) THEN
C
          WRITE(NFIPRI,'(/,
     *                 1X,20(1H/),'' BLOCKING WITH  NON INITIALIZED'',
     *                            ''  WAVE'',1X,20(1H/),/,
     *                 1X,20(1H/),'' FUNCTIONS  REQUIRES  THAT '',
     *                            '' ICONTI=1'',2X,20(1H/),/)')
C
          WRITE(ERRSTR,'('' BLOCKING WITH NON-INITIALIZED WFS AND '',
     *                   ''ICONTI=0 IN TESDAT'')')
          IERROR=1
C
      END IF
C
C=======================================================================
C
      IF ((IABS(IDSIGN).EQ.1.OR.IABS(IDSIGP).EQ.1.OR.
     *     IABS(IDSIMN).EQ.1.OR.IABS(IDSIMP).EQ.1.OR.
     *     IABS(IDSIQN).EQ.1.OR.IABS(IDSIQP).EQ.1.OR.
     *     IABS(IDSIZN).EQ.1.OR.IABS(IDSIZP).EQ.1).AND.IROTAT.NE.1) THEN
C
          WRITE(NFIPRI,'(/,
     *             1X,20(1H/),'' QUASIPARTICLE BLOCKING REQUIRES THAT'',
     *                                                   1X,20(1H/),/,
     *             1X,20(1H/),'' THE TIME-REVERSAL BE BROKEN IROTAT=1'',
     *                                                   1X,20(1H/),/)')
C
          ERRSTR=' QUASIPARTICLE BLOCKING ONLY FOR IROTAT=1 IN TESDAT'
          IERROR=1
C
      END IF
C
C=======================================================================
C
      IF ((ITILAX.NE.0.OR.ITISAX.NE.0).AND.JPABCS.GT.0) THEN
C
          WRITE(NFIPRI,'(/,
     *                 1X,20(1H/),'' TILTED-AXIS CRANKING CANNOT'',
     *                            '' BE USED '',1X,20(1H/),/,
     *                 1X,20(1H/),'' TOGETHER WITH BCS PAIRING  '',
     *                            ''         '',1X,20(1H/),/,
     *                 1X,20(1H/),'' (ITILAX='',I1,'', ITISAX='',I1,
     *                            '')        '',9X,20(1H/),/)')
     *
     *    ITILAX,ITISAX
C
          ERRSTR=' TILTED AXIS INCONSISTENT WITH IPABCS>0 IN TESDAT'
          IERROR=1
C
      END IF
C
C=======================================================================
C
      IF (IPAHFB.LT.1.AND.(IFEFIN.EQ.1.OR.IFEFIP.EQ.1)) THEN
C
          WRITE(NFIPRI,'(/,
     *                 1X,20(1H/),'' FIXED FERMI ENERGY CAN ONLY'',
     *                            '' BE  USED'',1X,20(1H/),/,
     *                 1X,20(1H/),'' TOGETHER WITH IPAHFB> 0   '',
     *                            ''          '',1X,20(1H/),/)')
C
          ERRSTR=' NO FIXED FERMI ENERGY ALLOWED FOR IPAHFB<1 IN TESDAT'
          IERROR=1
C
      END IF
C
C=======================================================================
C
      IF (JPABCS.EQ.2.AND.(IDEFIN.NE.1.OR.IDEFIP.NE.1)) THEN
          WRITE(NFIPRI,'(/,
     *                 1X,20(1H/),'' IPABCS=2 REQUIRES BOTH'',
     *                            '' IDEFIN=1 AND  '',20(1H/),/,
     *                 1X,20(1H/),'' IDEFIP=1                '',
     *                            ''         '',4X,20(1H/),/)')
          ERRSTR='IPABCS/IDEFIN/IDEFIP INCONSISTENCY IN TESDAT'
          IERROR=1
      END IF
C
C=======================================================================
C
      IF (IPAHFB.LT.1.AND.JPABCS.NE.2.AND.
     *   (IDEFIN.EQ.1.OR.IDEFIP.EQ.1)) THEN
C
          WRITE(NFIPRI,'(/,
     *                 1X,20(1H/),'' FIXED PAIRING GAPS CAN ONLY'',
     *                            '' BE  USED'',1X,20(1H/),/,
     *                 1X,20(1H/),'' TOGETHER WITH IPAHFB> 0 OR'',
     *                            '' IPABCS= 2'',1X,20(1H/),/)')
C
          ERRSTR=' FIXED GAPS AND IPAHFB<1 AND IPABCS<>2 IN TESDAT'
          IERROR=1
C
      END IF
C
C=======================================================================
C
      IF (IMFHFB.EQ.1.AND.IPAHFB.NE.1) THEN
C
          WRITE(NFIPRI,'(/,
     *                 1X,20(1H/),'' HFB MEAN FIELD CAN ONLY'',
     *                            '' BE REQUESTED'',1X,20(1H/),/,
     *                 1X,20(1H/),'' TOGETHER WITH IPAHFB= 1   '',
     *                            ''          '',1X,20(1H/),/)')
C
          ERRSTR=' HFB MEAN FIELD NOT ALLOWED FOR IPAHFB<>1 IN TESDAT'
          IERROR=1
C
      END IF
C
C=======================================================================
C
      IF ((IABS(IDSIGN).EQ.1.OR.IABS(IDSIGP).EQ.1.OR.
     *     IABS(IDSIMN).EQ.1.OR.IABS(IDSIMP).EQ.1.OR.
     *     IABS(IDSIQN).EQ.1.OR.IABS(IDSIQP).EQ.1.OR.
     *     IABS(IDSIZN).EQ.1.OR.IABS(IDSIZP).EQ.1).AND.IPAHFB.LT.1) THEN
C
          WRITE(NFIPRI,'(/,
     *                 1X,20(1H/),'' BLOCKING OF QUASIP. CAN ONLY'',
     *                            '' BE USED'',1X,20(1H/),/,
     *                 1X,20(1H/),'' TOGETHER WITH IPAHFB> 0   '',
     *                            ''          '',1X,20(1H/),/)')
C
          ERRSTR=' BLOCKING OF Q.P. AND IPAHFB=0 IN TESDAT'
          IERROR=1
C
      END IF
C
C=======================================================================
C
      IF (IABS(IDSIGN).EQ.1.AND.(INSIGN.LT.0.OR.INSIGN.GT.NDSTAT)) THEN
C
          WRITE(NFIPRI,'(/,
     *                 1X,20(1H/),'' INCORRECT VALUE OF INSIGN='',I3,
     *                            ''       '',1X,20(1H/),/)')
     *    INSIGN
C
          ERRSTR=' INCORRECT VALUE OF INSIGN IN TESDAT'
          IERROR=1
C
      END IF
C
C=======================================================================
C
      IF (IABS(IDSIGP).EQ.1.AND.(INSIGP.LT.0.OR.INSIGP.GT.NDSTAT)) THEN
C
          WRITE(NFIPRI,'(/,
     *                 1X,20(1H/),'' INCORRECT VALUE OF INSIGP='',I3,
     *                            ''       '',1X,20(1H/),/)')
     *    INSIGP
C
          ERRSTR=' INCORRECT VALUE OF INSIGP IN TESDAT'
          IERROR=1
C
      END IF
C
C=======================================================================
C
      IF (IABS(IDSIMN).EQ.1.AND.(INSIMN.LT.0.OR.INSIMN.GT.NDSTAT)) THEN
C
          WRITE(NFIPRI,'(/,
     *                 1X,20(1H/),'' INCORRECT VALUE OF INSIMN='',I3,
     *                            ''       '',1X,20(1H/),/)')
     *    INSIMN
C
          ERRSTR=' INCORRECT VALUE OF INSIMN IN TESDAT'
          IERROR=1
C
      END IF
C
C=======================================================================
C
      IF (IABS(IDSIMP).EQ.1.AND.(INSIMP.LT.0.OR.INSIMP.GT.NDSTAT)) THEN
C
          WRITE(NFIPRI,'(/,
     *                 1X,20(1H/),'' INCORRECT VALUE OF INSIMP='',I3,
     *                            ''       '',1X,20(1H/),/)')
     *    INSIMP
C
          ERRSTR=' INCORRECT VALUE OF INSIMP IN TESDAT'
          IERROR=1
C
      END IF
C
C=======================================================================
C
      IF (IABS(IDSIQN).EQ.1.AND.(INSIQN.LT.0.OR.INSIQN.GT.NDSTAT)) THEN
C
          WRITE(NFIPRI,'(/,
     *                 1X,20(1H/),'' INCORRECT VALUE OF INSIQN='',I3,
     *                            ''       '',1X,20(1H/),/)')
     *    INSIQN
C
          ERRSTR=' INCORRECT VALUE OF INSIQN IN TESDAT'
          IERROR=1
C
      END IF
C
C=======================================================================
C
      IF (IABS(IDSIQP).EQ.1.AND.(INSIQP.LT.0.OR.INSIQP.GT.NDSTAT)) THEN
C
          WRITE(NFIPRI,'(/,
     *                 1X,20(1H/),'' INCORRECT VALUE OF INSIQP='',I3,
     *                            ''       '',1X,20(1H/),/)')
     *    INSIQP
C
          ERRSTR=' INCORRECT VALUE OF INSIQP IN TESDAT'
          IERROR=1
C
      END IF
C
C=======================================================================
C
      IF (IABS(IDSIZN).EQ.1.AND.(INSIZN.LT.0.OR.INSIZN.GT.NDSTAT)) THEN
C
          WRITE(NFIPRI,'(/,
     *                 1X,20(1H/),'' INCORRECT VALUE OF INSIZN='',I3,
     *                            ''       '',1X,20(1H/),/)')
     *    INSIZN
C
          ERRSTR=' INCORRECT VALUE OF INSIZN IN TESDAT'
          IERROR=1
C
      END IF
C
C=======================================================================
C
      IF (IABS(IDSIZP).EQ.1.AND.(INSIZP.LT.0.OR.INSIZP.GT.NDSTAT)) THEN
C
          WRITE(NFIPRI,'(/,
     *                 1X,20(1H/),'' INCORRECT VALUE OF INSIZP='',I3,
     *                            ''       '',1X,20(1H/),/)')
     *    INSIZP
C
          ERRSTR=' INCORRECT VALUE OF INSIZP IN TESDAT'
          IERROR=1
C
      END IF
C
C=======================================================================
C
      IF (IABS(IDSIGN).EQ.1.AND.IPSIGN.NE.0.AND.IPSIGN.NE.1) THEN
C
          WRITE(NFIPRI,'(/,
     *                 1X,20(1H/),'' INCORRECT VALUE OF IPSIGN='',I3,
     *                            ''       '',1X,20(1H/),/)')
     *    IPSIGN
C
          ERRSTR=' INCORRECT VALUE OF IPSIGN IN TESDAT'
          IERROR=1
C
      END IF
C
C=======================================================================
C
      IF (IABS(IDSIGP).EQ.1.AND.IPSIGP.NE.0.AND.IPSIGP.NE.1) THEN
C
          WRITE(NFIPRI,'(/,
     *                 1X,20(1H/),'' INCORRECT VALUE OF IPSIGP='',I3,
     *                            ''       '',1X,20(1H/),/)')
     *    IPSIGP
C
          ERRSTR=' INCORRECT VALUE OF IPSIGP IN TESDAT'
          IERROR=1
C
      END IF
C
C=======================================================================
C
      IF (IABS(IDSIGN).EQ.1.AND.ISSIGN.NE.0.AND.ISSIGN.NE.1) THEN
C
          WRITE(NFIPRI,'(/,
     *                 1X,20(1H/),'' INCORRECT VALUE OF ISSIGN='',I3,
     *                            ''       '',1X,20(1H/),/)')
     *    ISSIGN
C
          ERRSTR=' INCORRECT VALUE OF ISSIGN IN TESDAT'
          IERROR=1
C
      END IF
C
C=======================================================================
C
      IF (IABS(IDSIGP).EQ.1.AND.ISSIGP.NE.0.AND.ISSIGP.NE.1) THEN
C
          WRITE(NFIPRI,'(/,
     *                 1X,20(1H/),'' INCORRECT VALUE OF ISSIGP='',I3,
     *                            ''       '',1X,20(1H/),/)')
     *    ISSIGP
C
          ERRSTR=' INCORRECT VALUE OF ISSIGP IN TESDAT'
          IERROR=1
C
      END IF
C
C=======================================================================
C
      IF (IABS(IDSIMN).EQ.1.AND.IRSIMN.NE.0.AND.IRSIMN.NE.1) THEN
C
          WRITE(NFIPRI,'(/,
     *                 1X,20(1H/),'' INCORRECT VALUE OF IRSIMN='',I3,
     *                            ''       '',1X,20(1H/),/)')
     *    IRSIMN
C
          ERRSTR=' INCORRECT VALUE OF IRSIMN IN TESDAT'
          IERROR=1
C
      END IF
C
C=======================================================================
C
      IF (IABS(IDSIMP).EQ.1.AND.IRSIMP.NE.0.AND.IRSIMP.NE.1) THEN
C
          WRITE(NFIPRI,'(/,
     *                 1X,20(1H/),'' INCORRECT VALUE OF IRSIMP='',I3,
     *                            ''       '',1X,20(1H/),/)')
     *    IRSIMP
C
          ERRSTR=' INCORRECT VALUE OF IRSIMP IN TESDAT'
          IERROR=1
C
      END IF
C
C=======================================================================
C
      IF (IABS(IDSIQN).EQ.1.AND.IPSIQN.NE.0.AND.IPSIQN.NE.1) THEN
C
          WRITE(NFIPRI,'(/,
     *                 1X,20(1H/),'' INCORRECT VALUE OF IPSIQN='',I3,
     *                            ''       '',1X,20(1H/),/)')
     *    IPSIQN
C
          ERRSTR=' INCORRECT VALUE OF IPSIQN IN TESDAT'
          IERROR=1
C
      END IF
C
C=======================================================================
C
      IF (IABS(IDSIQP).EQ.1.AND.IPSIQP.NE.0.AND.IPSIQP.NE.1) THEN
C
          WRITE(NFIPRI,'(/,
     *                 1X,20(1H/),'' INCORRECT VALUE OF IPSIQP='',I3,
     *                            ''       '',1X,20(1H/),/)')
     *    IPSIQP
C
          ERRSTR=' INCORRECT VALUE OF IPSIQP IN TESDAT'
          IERROR=1
C
      END IF
C
C=======================================================================
C
      IF ((IFLAGI(1).NE.0.OR.IFLAGI(3).NE.0).AND.ISIMPY.EQ.1) THEN
C
          WRITE(NFIPRI,'(/,
     *                 1X,20(1H/),'' QUADRATIC X- OR Z-CONSTRAINT'',
     *                            '' CANNOT '',1X,20(1H/),/,
     *                 1X,20(1H/),'' BE USED TOGETHER WITH ISIMPY=1'',
     *                            ''     '',2X,20(1H/),/,
     *                 1X,20(1H/),'' (IFLAGI(1)='',I1,
     *                            '', IFLAGI(3)='',I1,
     *                            '')        '',3X,20(1H/),/)')
     *
     *    IFLAGI(1),IFLAGI(3)
C
          ERRSTR='X- OR Z-CONSTRAINT AND ISIMPY=1 IN TESDAT'
          IERROR=1
C
      END IF
C
C=======================================================================
C
      IF (IFLAGA.NE.0.AND.ISIMPY.EQ.1) THEN
C
          WRITE(NFIPRI,'(/,
     *                 1X,20(1H/),'' CONSTRAINT ON OMEGA TIMES SPIN'',
     *                            '' CANNOT'',1X,19(1H/),/,
     *                 1X,20(1H/),'' BE USED TOGETHER WITH ISIMPY=1'',
     *                            ''       '',1X,19(1H/),/)')
C
          ERRSTR='CONSTRAINT ON OMEGA x SPIN VS. ISIMPY=1 IN TESDAT'
          IERROR=1
C
      END IF
C
C=======================================================================
C
      IF ((IFLAGI(1).NE.0.OR.IFLAGI(2).NE.0.OR.IFLAGI(3).NE.0).AND.
     *     IROTAT.NE.1) THEN
C
          WRITE(NFIPRI,'(/,
     *                 1X,20(1H/),'' QUADRATIC CONSTRAINT ON SPIN'',
     *                            '' CANNOT '', 1X,20(1H/),/,
     *                 1X,20(1H/),'' BE USED TOGETHER WITH IROTAT=0'',
     *                            ''     '',    2X,20(1H/),/,
     *                 1X,20(1H/),'' (IFLAGI(1)='',I1,
     *                            '', IFLAGI(2)='',I1,
     *                            '')        '',3X,20(1H/),/,
     *                 1X,20(1H/),''  IFLAGI(3)='',I1,
     *                            '')           '',1X,
     *                            ''         '',3X,20(1H/),/)')
     *
     *    IFLAGI(1),IFLAGI(2),IFLAGI(3)
C
          ERRSTR='CONSTRAINT ON SPIN AND IROTAT=0 IN TESDAT'
          IERROR=1
C
      END IF
C
C=======================================================================
C
      IF ((IFLAGI(1).NE.0.OR.IFLAGI(2).NE.0.OR.IFLAGI(3).NE.0).AND.
     *     IFLAGA.NE.0) THEN
C
          WRITE(NFIPRI,'(/,
     *                 1X,20(1H/),'' QUADRATIC CONSTRAINT ON SPIN'',
     *                            '' CANNOT '', 1X,20(1H/),/,
     *                 1X,20(1H/),'' BE USED TOGETHER WITH IFLAGA=1'',
     *                            ''     '',    2X,20(1H/),/,
     *                 1X,20(1H/),'' (IFLAGI(1)='',I1,
     *                            '', IFLAGI(2)='',I1,
     *                            '')        '',3X,20(1H/),/,
     *                 1X,20(1H/),''  IFLAGI(3)='',I1,
     *                            '')           '',1X,
     *                            ''         '',3X,20(1H/),/)')
     *
     *    IFLAGI(1),IFLAGI(2),IFLAGI(3)
C
          ERRSTR='CONSTRAINT ON SPIN AND IFLAGA=1 IN TESDAT'
          IERROR=1
C
      END IF
C
C=======================================================================
C
      IF (IFLAGA.NE.0.AND.IROTAT.NE.1) THEN
C
          WRITE(NFIPRI,'(/,
     *                 1X,20(1H/),'' CONSTRAINT ON OMEGA TIMES SPIN'',
     *                            '' CANNOT'',1X,19(1H/),/,
     *                 1X,20(1H/),'' BE USED TOGETHER WITH IROTAT=0'',
     *                            ''       '',1X,19(1H/),/)')
C
          ERRSTR='CONSTRAINT ON OMEGA x SPIN VS. IROTAT=0 IN TESDAT'
          IERROR=1
C
      END IF
C
C=======================================================================
C
      IF (NO_ORB.EQ.1.AND.IROTAT.NE.1) THEN
C
          WRITE(NFIPRI,'(/,
     *                 1X,20(1H/),'' CONSTRAINT ON INTRINSIC SPIN'',
     *                            '' ONLY  IS'',1X,19(1H/),/,
     *                 1X,20(1H/),'' NOT COMPATIBLE  WITH  IROTAT=0'',
     *                            ''       '',1X,19(1H/),/)')
C
          ERRSTR='CONSTRAINT ON INTRINSIC SPIN VS. IROTAT=0 IN TESDAT'
          IERROR=1
C
      END IF
C
C=======================================================================
C
      IF (IFLAGA.NE.0.AND.ITILAX.EQ.0) THEN
C
          WRITE(NFIPRI,'(/,
     *                 1X,20(1H/),'' CONSTRAINT ON OMEGA TIMES SPIN'',
     *                            '' CANNOT'',1X,19(1H/),/,
     *                 1X,20(1H/),'' BE USED TOGETHER WITH ITILAX=0'',
     *                            ''       '',1X,19(1H/),/)')
C
          ERRSTR='CONSTRAINT ON OMEGA x SPIN VS. ITILAX=0 IN TESDAT'
          IERROR=1
C
      END IF
C
C=======================================================================
C
      IF (IFLAGA.NE.0.AND.ITISAX.EQ.1) THEN
C
          WRITE(NFIPRI,'(/,
     *                 1X,20(1H/),'' CONSTRAINT ON OMEGA TIMES SPIN'',
     *                            '' CANNOT'',1X,19(1H/),/,
     *                 1X,20(1H/),'' BE USED TOGETHER WITH ITISAX=1'',
     *                            ''       '',1X,19(1H/),/)')
C
          ERRSTR='CONSTRAINT ON OMEGA x SPIN VS. ITISAX=1 IN TESDAT'
          IERROR=1
C
      END IF
C
C=======================================================================
C
      IF (IFLAGA.NE.0.AND.ABS(ASKEDA).GT.1.0D-15) THEN
C
          WRITE(NFIPRI,'(/,
     *                 1X,20(1H/),'' WARNING: CONSTRAINT ON NON-ZERO'',
     *                            '' PRODUCT'',    1X,17(1H/),/,
     *                 1X,20(1H/),'' OMEGA TIMES SPIN IS NOT YET'',
     *                            '' IMPLEMENTED'',1X,17(1H/),/,
     *                 1X,20(1H/),'' AND HAS BEEN REMOVED.      '',
     *                            ''            '',1X,17(1H/),/)')
C
          ERRSTR='IFLAGA.NE.0 AND ABS(ASKEDA)>0 IN TESDAT'
          IERROR=1
C
      END IF
C
C=======================================================================
C
      OMEGAT=OMEGAX**2+OMEGAY**2+OMEGAZ**2
C
      IF (IFLAGA.NE.0.AND.OMEGAT.LT.1.0D-20) THEN
C
          WRITE(NFIPRI,'(/,
     *                 1X,20(1H/),'' WARNING: CONSTRAINT ON NON-ZERO'',
     *                            '' PRODUCT'',       1X,17(1H/),/,
     *                 1X,20(1H/),'' OMEGA TIMES SPIN  CANNOT  BE '',
     *                            '' USED  FOR'',     1X,17(1H/),/,
     *                 1X,20(1H/),'' VANISHING OMEGA, AND HAS'',
     *                            '' BEEN  REMOVED.'',1X,17(1H/),/)')
C
          ERRSTR='IFLAGA.NE.0 AND OMEGAT=0 IN TESDAT'
          IERROR=1
C
      END IF
C
C=======================================================================
C         RESTRICTION BELOW HAS BEEN REMOVED IN 2.07D ON 04/01/04 WITH
C         THE ASSMPTION THAT THE CODE AS IS WILL FUNCTION PROPERLY.
C=======================================================================
C
C     IF (IFLAGA.NE.0.AND.
C    *   (ISIMTX.EQ.1.OR.JSIMTY.EQ.1.OR.ISIMTZ.EQ.1)) THEN
C
C         WRITE(NFIPRI,'(/,1X,20(1H/),'' WARNING: CONSTRAINT ON NON'',
C    *                                ''-ZERO PRODUCT'',1X,17(1H/),/,
C    *                     1X,20(1H/),'' OMEGA TIMES SPIN IS NOT'',
C    *                                '' COMPATIBLE WITH'',1X,17(1H/),/,
C    *                     1X,20(1H/),'' ISIMTX=1 OR ISIMTY=1, OR'',
C    *                                '' ISIMTZ=1,  AND'', 1X,17(1H/),/,
C    *                     1X,20(1H/),'' HAS BEEN REMOVED.       '',
C    *                            ''               '', 1X,17(1H/),/)')
C
C         IFLAGA=0
C
C     END IF
C
C=======================================================================
C
      IF (IMOVAX.NE.0.AND.IMOVAX.NE.1.AND.IMOVAX.NE.-1) THEN
C
          WRITE(NFIPRI,'(/,1X,20(1H/),1X,
     *                   ''IMOVAX='',I3,''             '',
     *                                                   1X,20(1H/),/,
     *                     1X,20(1H/),1X,''IS NOT AN ALLOWED VALUE'',
     *                                                   1X,20(1H/),/)')
     *    IMOVAX
C
          ERRSTR='VALUE OF IMOVAX NOT ALLOWED IN TESDAT'
          IERROR=1
C
      END IF
C
C=======================================================================
C
      IF (IMOVAX.NE.0.AND.ITILAX.EQ.0) THEN
C
          WRITE(NFIPRI,'(/,
     *                 1X,20(1H/),'' ADJUSTABLE DIRECTION OF OMEGA '',
     *                            '' CANNOT'',1X,19(1H/),/,
     *                 1X,20(1H/),'' BE USED TOGETHER WITH ITILAX=0'',
     *                            ''       '',1X,19(1H/),/)')
C
          ERRSTR='ADJUSTABLE DIRECTION OF OMEGA VS. ITILAX=0 IN TESDAT'
          IERROR=1
C
      END IF
C
C=======================================================================
C
      IF (IMOVAX.NE.0.AND.ITISAX.NE.0) THEN
C
          WRITE(NFIPRI,'(/,
     *                 1X,20(1H/),'' ADJUSTABLE DIRECTION OF OMEGA '',
     *                            '' CANNOT'',1X,19(1H/),/,
     *                 1X,20(1H/),'' BE USED TOGETHER WITH ITISAX=1'',
     *                            ''       '',1X,19(1H/),/)')
C
          ERRSTR='ADJUSTABLE DIRECTION OF OMEGA VS. ITISAX=1 IN TESDAT'
          IERROR=1
C
      END IF
C
C=======================================================================
C
      IF (IMOVAX.NE.0.AND.IFLAGA.NE.0) THEN
C
          WRITE(NFIPRI,'(/,
     *                 1X,20(1H/),'' ADJUSTABLE DIRECTION OF OMEGA '',
     *                            '' CANNOT'',1X,19(1H/),/,
     *                 1X,20(1H/),'' BE USED TOGETHER WITH IFLAGA=1'',
     *                            ''       '',1X,19(1H/),/)')
C
          ERRSTR='ADJUSTABLE DIRECTION OF OMEGA VS. IFLAGA=1 IN TESDAT'
          IERROR=1
C
      END IF
C
C=======================================================================
C
      IF (IOCONT.EQ.1.AND.IMOVAX.EQ.0) THEN
C
          WRITE(NFIPRI,'(/,
     *                 1X,20(1H/),'' IOCONT=1 IS INCOMPATIBLE WITH'',
     *                            '' IMOVAX=0'',1X,19(1H/),/)')
C
          ERRSTR='IOCONT=1 VS. IMOVAX=0 INCONSISTENCY IN TESDAT'
          IERROR=1
C
      END IF
C
C=======================================================================
C
      IF (IPCONT.EQ.1.AND.ICONTI.NE.1) THEN
C
          WRITE(NFIPRI,'(/,
     *                 1X,20(1H/),'' IPCONT=1 IS INCOMPATIBLE WITH'',
     *                            '' ICONTI=0'',1X,19(1H/),/)')
C
          ERRSTR='IPCONT=1 VS. ICONTI=0 INCONSISTENCY IN TESDAT'
          IERROR=1
C
      END IF
C
C=======================================================================
C
      IF (IYCONT.EQ.1.AND.ICONTI.NE.1) THEN
C
          WRITE(NFIPRI,'(/,
     *                 1X,20(1H/),'' IYCONT=1 IS INCOMPATIBLE WITH'',
     *                            '' ICONTI=0'',1X,19(1H/),/)')
C
          ERRSTR='IYCONT=1 VS. ICONTI=0 INCONSISTENCY IN TESDAT'
          IERROR=1
C
      END IF
C
C=======================================================================
C
      IF (IGCONT.EQ.1.AND.ICONTI.NE.1) THEN
C
          WRITE(NFIPRI,'(/,
     *                 1X,20(1H/),'' IGCONT=1 IS INCOMPATIBLE WITH'',
     *                            '' ICONTI=0'',1X,19(1H/),/)')
C
          ERRSTR='IGCONT=1 VS. ICONTI=0 INCONSISTENCY IN TESDAT'
          IERROR=1
C
      END IF
C
C=======================================================================
C
      IF (IGPCON.EQ.1.AND.ICONTI.NE.1) THEN
C
          WRITE(NFIPRI,'(/,
     *                 1X,20(1H/),'' IGPCON=1 IS INCOMPATIBLE WITH'',
     *                            '' ICONTI=0'',1X,19(1H/),/)')
C
          ERRSTR='IGPCON=1 VS. ICONTI=0 INCONSISTENCY IN TESDAT'
          IERROR=1
C
      END IF
C
C=======================================================================
C
      IF (ILCONT.EQ.1.AND.IPCONT.NE.1) THEN
C
          WRITE(NFIPRI,'(/,
     *                 1X,20(1H/),'' ILCONT=1 IS INCOMPATIBLE WITH'',
     *                            '' IPCONT=0'',1X,19(1H/),/)')
C
          ERRSTR='ILCONT=1 VS. IPCONT=0 INCONSISTENCY IN TESDAT'
          IERROR=1
C
      END IF
C
C=======================================================================
C
      IF (IFCONT.EQ.1.AND.ICONTI.NE.1) THEN
C
          WRITE(NFIPRI,'(/,
     *                 1X,20(1H/),'' IFCONT=1 IS INCOMPATIBLE WITH'',
     *                            '' ICONTI=0'',1X,19(1H/),/)')
C
          ERRSTR='IFCONT=1 VS. ICONTI=0 INCONSISTENCY IN TESDAT'
          IERROR=1
C
      END IF
C
C=======================================================================
C
      IF (IFCONT.EQ.1.AND.IYCONT.EQ.1) THEN
C
          WRITE(NFIPRI,'(/,
     *                 1X,20(1H/),'' IFCONT=1 IS INCOMPATIBLE WITH'',
     *                            '' IYCONT=1'',1X,19(1H/),/)')
C
          ERRSTR='IFCONT=1 VS. IYCONT=1 INCONSISTENCY IN TESDAT'
          IERROR=1
C
      END IF
C
C=======================================================================
C
      IF (IFCONT.EQ.1.AND.IGCONT.EQ.1) THEN
C
          WRITE(NFIPRI,'(/,
     *                 1X,20(1H/),'' IFCONT=1 IS INCOMPATIBLE WITH'',
     *                            '' IGCONT=1'',1X,19(1H/),/)')
C
          ERRSTR='IFCONT=1 VS. IGCONT=1 INCONSISTENCY IN TESDAT'
          IERROR=1
C
      END IF
C
C=======================================================================
C
      IF (IFCONT.EQ.1.AND.IGPCON.EQ.1) THEN
C
          WRITE(NFIPRI,'(/,
     *                 1X,20(1H/),'' IFCONT=1 IS INCOMPATIBLE WITH'',
     *                            '' IGPCON=1'',1X,19(1H/),/)')
C
          ERRSTR='IFCONT=1 VS. IGPCON=1 INCONSISTENCY IN TESDAT'
          IERROR=1
C
      END IF
C
C=======================================================================
C
      IF (IFCONT.EQ.1.AND.IYCONT.EQ.1) THEN
C
          WRITE(NFIPRI,'(/,
     *                 1X,20(1H/),'' IFCONT=1 IS INCOMPATIBLE WITH'',
     *                            '' IYCONT=1'',1X,19(1H/),/)')
C
          ERRSTR='IFCONT=1 VS. IYCONT=1 INCONSISTENCY IN TESDAT'
          IERROR=1
C
      END IF
C
C=======================================================================
C
      IF (IFCONT.EQ.1.AND.IGCONT.EQ.1) THEN
C
          WRITE(NFIPRI,'(/,
     *                 1X,20(1H/),'' IFCONT=1 IS INCOMPATIBLE WITH'',
     *                            '' IGCONT=1'',1X,19(1H/),/)')
C
          ERRSTR='IFCONT=1 VS. IGCONT=1 INCONSISTENCY IN TESDAT'
          IERROR=1
C
      END IF
C
C=======================================================================
C
      IF (IMCONT.EQ.1.AND.ICONTI.NE.1) THEN
C
          WRITE(NFIPRI,'(/,
     *                 1X,20(1H/),'' IMCONT=1 IS INCOMPATIBLE WITH'',
     *                            '' ICONTI=0'',1X,19(1H/),/)')
C
          ERRSTR='IMCONT=1 VS. ICONTI=0 INCONSISTENCY IN TESDAT'
          IERROR=1
C
      END IF
C
C=======================================================================
C
      IF (IMCONT.EQ.1.AND.IFCONT.NE.1) THEN
C
          WRITE(NFIPRI,'(/,
     *                 1X,20(1H/),'' IMCONT=1 IS INCOMPATIBLE WITH'',
     *                            '' IFCONT=0'',1X,19(1H/),/)')
C
          ERRSTR='IMCONT=1 VS. IFCONT=0 INCONSISTENCY IN TESDAT'
          IERROR=1
C
      END IF
C
C=======================================================================
C
      IF (IACONT.EQ.1.AND.ICONTI.NE.1) THEN
C
          WRITE(NFIPRI,'(/,
     *                 1X,20(1H/),'' IACONT=1 IS INCOMPATIBLE WITH'',
     *                            '' ICONTI=0'',1X,19(1H/),/)')
C
          ERRSTR='IACONT=1 VS. ICONTI=0 INCONSISTENCY IN TESDAT'
          IERROR=1
C
      END IF
C
C=======================================================================
C
      IF (IRCONT.EQ.1.AND.ICONTI.NE.1) THEN
C
          WRITE(NFIPRI,'(/,
     *                 1X,20(1H/),'' IRCONT=1 IS INCOMPATIBLE WITH'',
     *                            '' ICONTI=0'',1X,19(1H/),/)')
C
          ERRSTR='IRCONT=1 VS. ICONTI=0 INCONSISTENCY IN TESDAT'
          IERROR=1
C
      END IF
C
C=======================================================================
C
      IF (IRCONT.EQ.1.AND.IFCONT.NE.1) THEN
C
          WRITE(NFIPRI,'(/,
     *                 1X,20(1H/),'' IRCONT=1 IS INCOMPATIBLE WITH'',
     *                            '' IFCONT=0'',1X,19(1H/),/)')
C
          ERRSTR='IRCONT=1 VS. IFCONT=0 INCONSISTENCY IN TESDAT'
          IERROR=1
C
      END IF
C
C=======================================================================
C
      IF ((ICOUDI.EQ.2.OR.ICOUEX.EQ.2).AND.
     *     ICONTI.EQ.1.AND.IFCONT.NE.1) THEN
C
          WRITE(NFIPRI,'(/,
     *                 1X,20(1H/),'' IFCONT=0 IS INCOMPATIBLE WITH'',
     *                            '' ICONTI=1'',1X,19(1H/),/,
     *                 1X,20(1H/),'' AND (ICOUDI=2 OR ICOUEX=2)   '',
     *                            ''         '',1X,19(1H/),/)')
C
          ERRSTR='IFCONT=0 VS. ICONTI=1 AND GAUSSIAN COULOMB IN TESDAT'
          IERROR=1
C
      END IF
C
C=======================================================================
C
      IF ((ICOUDI.EQ.2.OR.ICOUEX.EQ.2).AND.IBROYD.GE.1) THEN
C
          WRITE(NFIPRI,'(/,
     *                 1X,20(1H/),'' IBROYD=1 IS INCOMPATIBLE WITH'',
     *                            '' ICOUDI=2'',1X,19(1H/),/,
     *                 1X,20(1H/),'' OR ICOUEX=2                  '',
     *                            ''         '',1X,19(1H/),/)')
C
          ERRSTR='IBROYD=1 AND GAUSSIAN COULOMB IN TESDAT'
          IERROR=1
C
      END IF
C
C=======================================================================
C      Only two LAPACK routines have been parallelized. If the  user's
C      default choice does not match the available options, we default
C      to a divide-and-conquer algorithm.
C=======================================================================
#if(USE_SCALAPACK==1)
C
      KZHPEV=0
C
#if(SWITCH_DIAG==1)
      KZHPEV = 1
#endif
C
#if(SWITCH_DIAG==4)
      KZHPEV = 4
#endif
C
      IF (KZHPEV.NE.1.AND.KZHPEV.NE.4) THEN
C
          WRITE(NFIPRI,'(79(''/''),/,''///'',73X,''///'')')
          WRITE(NFIPRI,'(''///  KZHPEV = '',i1,'' IS NOT AUTHORIZED '',
     *         ''IN CURRENT IMPLEMENTATION OF SCALAPACK    ///'')')
     *                          KZHPEV
          WRITE(NFIPRI,'(''///  DEFAULTING TO KZPHEV=1 INSTEAD '',
     *         ''(DIVIDE-AND-CONQUER ALGORITHM)          ///'')')
          WRITE(NFIPRI,'(''///'',73X,''///'',/,79(''/''),/)')
C
          ERRSTR='INCORRECT VALUE OF KZHPEV IN TESDAT'
          IERROR=1
C
      END IF
C
#endif
C
C      IFSHEL=0,1,2 (no shell correction, traditional, extended)
C
      IF (IFSHEL.LT.0.OR.IFSHEL.GT.2) THEN
C
          WRITE(NFIPRI,'(/,1X,20(''/''),1X,''IFSHEL='',I3,
     *                      ''             '',1X,20(''/''),/,
     *               1X,20(''/''),1X,''IS NOT AN ALLOWED VALUE'',
     *               1X,20(''/''),/)') IFSHEL
C
          ERRSTR='VALUE OF IFSHEL NOT ALLOWED IN TESDAT'
          IERROR=1
C
      END IF
C
C=======================================================================
C      Compatibility check for fission fragment calculations
C=======================================================================
C      Accepted values for IFRAGM are 0 or 1
C
      IF (IFRAGM.LT.0.OR.IFRAGM.GT.1) THEN
C
          WRITE(NFIPRI,'(/,1X,20(''/''),1X,''IFRAGM='',I3,
     *                      ''             '',1X,20(''/''),/,
     *               1X,20(''/''),1X,''IS NOT AN ALLOWED VALUE'',
     *               1X,20(''/''),/)') IFRAGM
C
          ERRSTR='VALUE OF IFRAGM NOT ALLOWED IN TESDAT'
          IERROR=1
C
      END IF
C
C      IFRAGM=1 requires conserved simplex (for the time being)
C
      IF (IFRAGM.EQ.1.AND.ISIMPY.NE.1) THEN
C
          WRITE(NFIPRI,'(/,
     *                 1X,20(1H/),'' IFRAGM=1 IS INCOMPATIBLE WITH'',
     *                            '' ISIMPY=0'',1X,19(1H/),/)')
C
          ERRSTR='IFRAGM=1 AND ISIMPY=0 INCONSISTENCY IN TESDAT'
          IERROR=1
C
      END IF
C
C      IFRAGM=1 requires time-reversal invariance (for the time being)
C
      IF (IFRAGM.EQ.1.AND.IROTAT.EQ.1) THEN
C
          WRITE(NFIPRI,'(/,
     *                 1X,20(1H/),'' IFRAGM=1 IS INCOMPATIBLE WITH'',
     *                            '' IROTAT=1'',1X,19(1H/),/)')
C
          ERRSTR='IFRAGM=1 AND IROTAT=1 INCONSISTENCY IN TESDAT'
          IERROR=1
C
      END IF
C
C      IFRAGM=1 is only possible in (standard) HFB mode (for the time being)
C
      IF (IFRAGM.EQ.1.AND.IPAHFB.NE.1) THEN
C
          WRITE(NFIPRI,'(/,
     *                 1X,17(1H/),'' IFRAGM=1 IS INCOMPATIBLE WITH'',
     *                            '' VALUE OF IPAHFB'',16(1H/),/)')
C
          ERRSTR='IFRAGM=1 AND IPAHFB INCONSISTENCY IN TESDAT'
          IERROR=1
C
      END IF
C
C=======================================================================
C      Compatibility check for HFBTHO solver
C=======================================================================
C      IF_THO=1 is not compatible with any restart option.
C
      IF (IF_THO.GE.1.AND.(ICONTI.EQ.1.OR.IPCONT.EQ.1.OR.
     *                     ILCONT.EQ.1.OR.IFCONT.EQ.1.OR.
     *                     IYCONT.EQ.1.OR.IGCONT.EQ.1.OR.
     *                     IGPCON.EQ.1.OR.IOCONT.EQ.1.OR.
     *                     IMCONT.EQ.1)) THEN
C
          WRITE(NFIPRI,'(/,1X,9(''/''),59X,9(''/''),/,
     *                  9(''/''),'' USING HFBTHO RESTART OPTION '',
     *                  ''IF_THO=1 IS INCOMPATIBLE WITH '',9(''/''),/,
     *                  9(''/''),23X,''*ANY*'',31X,9(''/''),/,
     *                  9(''/''), 7X,''CONTINUATION OPTION '',
     *                  ''AVAILABLE IN HFODD'',14X,9(''/''),/,
     *                  9(''/''),59X,9(''/''))')
C
          ERRSTR='CONTINUATION AND RESTARTS IN TESDAT'
          IERROR=1
C
      END IF
C
C      Sanity check: if UNEDF functionals are requested, the flag
C      IF_EDF must be set to 1
C
      IF ((SKYRME.EQ.'UNE0'.OR.SKYRME.EQ.'UNE1')
     *                    .AND.IF_EDF.EQ.0) THEN
C
          ERRSTR='IF_EDF=0 AND UNEDF FUNCTIONALS IN TESDAT'
          IERROR=1
C
      END IF
C
C=======================================================================
C      Stopping the program if any inconsistency in the data has been
C      encountered. PRGSTP() is only a wrapper around a STOP statement.
C=======================================================================
C
      CALL PRGSTP(ERRSTR)
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE PRGSTP(ERRSTR)
      CHARACTER
     *          ERRSTR*68
C
      IF (Trim(ERRSTR).NE.'NO ERROR REPORTED') THEN
          WRITE(0,'(A68)') ERRSTR
          STOP
      END IF
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE SETBAS(IN_FIX,IZ_FIX,IREAWS,NOSCIL,NLIMIT,ENECUT,
     *                                IOPTGS,NXHERM,NYHERM,NZHERM,
     *                                JETACM,NXMAXX,NYMAXX,NZMAXX,
     *                  ISPHER,INIROT,IPRGCM,ICOUDI,ICOUEX,E_EFFE,
     *                                              ELIMIT,IF_THO)
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      DIMENSION
     *           EBASIS(NDBTOT),NBASIS(NDBTOT)
      CHARACTER*2
     *           DIGITS(0:99)
      CHARACTER*33
     *           OPTIMU(0:1)
C
      COMMON
     *       /BASISO/ NXVECT(1:NDBASE),NYVECT(1:NDBASE),NZVECT(1:NDBASE)
     *
     *       /BINDEX/ INDICE(0:NDXMAX,0:NDYMAX,0:NDZMAX)
     *
     *       /BLIMS1/ LAXOFY(0:NDYMAX),LAXOFZ(0:NDZMAX),
     *                LAYOFZ(0:NDZMAX),LAYOFX(0:NDXMAX),
     *                LAZOFX(0:NDXMAX),LAZOFY(0:NDYMAX)
     *
     *       /BLIMS2/ LAXOYZ(0:NDYMAX,0:NDZMAX),
     *                LAYOZX(0:NDZMAX,0:NDXMAX),
     *                LAZOXY(0:NDXMAX,0:NDYMAX)
      COMMON
     *       /BASPAR/ HBAROX,HBAROY,HBAROZ
      COMMON
     *       /PARIND/ INDPAR(1:NDBASE,0:NDPARI)
      COMMON
     *       /PARBAS/ IBAPAR(1:NDBASE)
      COMMON
     *       /DIMENP/ LDBASP(0:NDPARI)
      COMMON
     *       /ESHIFT/ EFEBAS(0:NDISOS)
      COMMON
     *       /SCALNG/ HOMSCA(NDKART)
      COMMON
     *       /PLANCK/ HBMASS,HBMRPA,HBMINP
      COMMON
     *       /PHYCON/ H_BARC,XMASSP,XMASSN,HBCOE2
      COMMON
     *       /CHARGE/ ECHAR2
      COMMON
     *       /EXCHAN/ COULEX
      COMMON
     *       /LDUNKI/ ECH2_O,COEX_O
      COMMON
     *       /DIMENS/ LDBASE
      COMMON
     *       /CFIPRI/ NFIPRI
C
      DATA
     *      OPTIMU /'                                 ',
     *              'OPTIMUM NUMBERS OF  GAUSS POINTS:'/
C
C=======================================================================
C         THIS SUBROUTINE DEFINES THE BASIS PARAMETERS AND THE BASIS
C         ITSELF  FOR  THE NUMERICAL INTEGRATION OF THE HAMILTONIAN.
C=======================================================================
C
C         MEANING OF SOME PARAMETERS:
C
C         LAXOFY = 'LAST INDEX IN THE DIRECTION X RELATED TO Y'
C                   MAXIMUM VALUE OF THE 'NX' OSCILLATOR BASIS
C                   FOR FIXED 'NY'
C
C         LAXOFZ => ... LAZOFY  ===> SIMILAR TO LAXOFY BUT FOR
C                   ALL THE OTHER COMBINATIONS OF   DIRECTIONS
C
C         LAXOYZ => SIMILAR TO THE PREVIOUS ONES BUT LIMITED BY
C                   TWO OTHER ACTUAL QUANTUM NUMBERS  F I X E D
C
C=======================================================================
C
C         NOSCIL = MAXIMUM NUMBER OF THE HARMONIC OSCILLATOR SHELLS
C
C         NDIMEN = ((NOSCIL+2)**3-(NOSCIL+2))/6
C                =  (NOSCIL+1)(NOSCIL+2)(NOSCIL+3)/6
C
C         NOSCIL= 7 - NDIMEN=120
C         NOSCIL= 8 - NDIMEN=165
C         NOSCIL= 9 - NDIMEN=220
C         NOSCIL=10 - NDIMEN=286
C         NOSCIL=11 - NDIMEN=364
C         NOSCIL=12 - NDIMEN=455
C         NOSCIL=14 - NDIMEN=680
C         NOSCIL=16 - NDIMEN=969
C         NOSCIL=18 - NDIMEN=1330
C         NOSCIL=20 - NDIMEN=1771
C
C=======================================================================
C
C         HBARO() - HBAR-OMEGA (X) OR (Y) OR (Z); OSCILLATOR FREQUENCIES
C
C         SQ()FAT - DERIVATIVE - STRETCHING FACTORS FOR (X), (Y), OR (Z)
C                   VARIABLES (USED TO DEFINE THE DIMENSIONED VARIABLES)
C
C                   SQ()FAT = SQRT( MASS * HBARO() / H_BAR**2 )
C
C                   KSI ()  = SQ()FAT * (VARIABLE)
C
C         N()MAXX - THE MAXIMUM VALUES OF THE HARMONIC OSCILLATOR SHELLS
C                   IN THE (X), OR (Y), OR (Z)  DIRECTION,  RESPECTIVELY
C
C=======================================================================
C
C         NLIMIT  - B A S I S   D E F I N I T I O N  P A R A M E T E R :
C
C                   EITHER NEGATIVE (ENECUT  DEFINES THE ENERGY CUT),
C                   OR POSITIVE, IN WHICH CASE THE TOTAL NUMBER OF BASIS
C                   STATES WILL BE EQUAL TO NLIMIT, OR ZERO, IN WHICH
C                   CASE NLIMIT IS DETERMINED BY THE NUMBER OF SPHERICAL
C                   HO SHELLS NOSCIL.
C
C=======================================================================
C
      IF (JETACM.EQ.0) THEN
C
          HBMRPA=HBMASS*(1.0D0-1.0D0/REAL(IN_FIX+IZ_FIX,KIND=8))
      ELSE
          HBMRPA=HBMASS
C
      END IF
C
      ECHAR2=H_BARC/HBCOE2
C
      PI    =4.0D0*ATAN(1.0D0)
C
      IF (ICOUDI.EQ.0.AND.ICOUEX.EQ.0) ECHAR2=0.0D0
C
      IF (ICOUEX.EQ.1) THEN
C
          COULEX=-(3.0D0/4.0D0) * (3.0D0/PI)**(1.0D0/3.0D0) * ECHAR2
      ELSE
          COULEX=0.0D0
C
      END IF
C
      ECH2_O = ECHAR2
      COEX_O = COULEX
C
      ECHAR2 = ECHAR2 * E_EFFE * E_EFFE
      COULEX = COULEX * E_EFFE * E_EFFE
C
      HOMSCA(1)=SQRT(XMASSN*HBAROX)/H_BARC
      HOMSCA(2)=SQRT(XMASSN*HBAROY)/H_BARC
      HOMSCA(3)=SQRT(XMASSN*HBAROZ)/H_BARC
C
C=======================================================================
C
      WRITE(NFIPRI,'(79(1H*),/,1H*,77X,1H*,/,
     *         1H*, 2X,''PHYSICAL CONSTANTS:     '',
     *                 ''H_BARC='',F12.8,11X,''HBCOE2='',F12.8,2X,1H*,/,
     *         1H*,77X,                                          1H*,/,
     *         1H*,26X,''XMASSN='',F12.8,11X,''XMASSP='',F12.8,2X,1H*,/,
     *         1H*,77X,                                          1H*,/,
     *         1H*,26X,''HBMASS='',F12.8,11X,''HBMRPA='',F12.8,2X,1H*,/,
     *         1H*,77X,                                          1H*,/,
     *         1H*,26X,''ECHAR2='',F12.8,11X,''COULEX='',F12.8,2X,1H*,/,
     *         1H*,77X,                                          1H*)')
     *
     *          H_BARC,HBCOE2,XMASSN,XMASSP,HBMASS,HBMRPA,ECHAR2,COULEX
C
      WRITE(NFIPRI,'(79(1H*),/,1H*,77X,1H*,/,
     *          1H*, 2X,''OSCILLATOR LENGTHS:     '',
     *            ''X='',F10.7,6X,''Y='',F10.7,7X,''Z='',F10.7,2X,1H*,/,
     *          1H*,77X,                                          1H*,/,
     *          1H*, 2X,''OSCILLATOR CONSTANTS:   '',
     *            ''X='',F10.7,6X,''Y='',F10.7,7X,''Z='',F10.7,2X,1H*,/,
     *          1H*,77X,                                          1H*,/,
     *          1H*, 2X,''OSCILLATOR FREQUENCIES: '',
     *            ''X='',F10.7,6X,''Y='',F10.7,7X,''Z='',F10.7,2X,1H*,/,
     *          1H*,77X,                                          1H*)')
     *
     *        (1.D0/HOMSCA(KARTEZ),KARTEZ=1,NDKART),
     *             (HOMSCA(KARTEZ),KARTEZ=1,NDKART),HBAROX,HBAROY,HBAROZ
C
C=======================================================================
C         CALCULATING THE NUMBER OF STATES IN EACH OF THE 3 OSCILLATORS
C=======================================================================
C
      MCOUNT=0
C
      DO NX=0,NOSCIL
         DO NY=0,NOSCIL
            DO NZ=0,NOSCIL
C
               MCOUNT=MCOUNT+1
C
               IF (MCOUNT.GT.NDBTOT) STOP 'NOSCIL TOO BIG /SETBAS'
C
               NBASIS(MCOUNT)=MCOUNT
               EBASIS(MCOUNT)=HBAROX*(NX+0.5D0)
     *                       +HBAROY*(NY+0.5D0)
     *                       +HBAROZ*(NZ+0.5D0)
C
            END DO
         END DO
      END DO
C
      NUMCUT=MCOUNT
C
      CALL ORDER1(EBASIS,NBASIS,MCOUNT)
C
C=======================================================================
C         IF NLIMIT>0 THE BASIS WILL BE DEFINED IN SUCH A WAY THAT
C         THE TOTAL NUMBER OF THE LOWEST BASIS STATES  RETAINED IS
C         EQUAL TO THE PRESCRIBED VALUE (NLIMIT).  WHENEVER NLIMIT
C         HAPPENS TO BE INSIDE A DEGENERATE MULTIPLET (A SPHERICAL
C         OR AXIAL SYMMETRY) THE WHOLE MULTIPLET IS TAKEN. IN SUCH
C         A CASE THE NUMBER OF STATES RETAINED  (LDBASE)  MAY BE A
C         LITTLE LARGER THAN THE PRESCRIBED VALUE (NLIMIT).
C
C         NOTE: IF INTERFACE WITH HFBTHO IS USED, NLIMIT VALUE HAS
C               ALREADY BEEN OVERWRITTEN. ACTUAL MAXIMUM ENERGY IN
C               THE BASIS IS SIMPLY E(NLIMIT)
C=======================================================================
C
      IF (IF_THO.EQ.0) THEN
C
          IF (NLIMIT.GT.0) THEN
              IF (NLIMIT.LE.MCOUNT) THEN
                  ELIMIT=EBASIS(NLIMIT)+1.0D-5
              ELSE
                  ELIMIT=EBASIS(MCOUNT)+1.0D-5
              END IF
          ELSE
              ELIMIT=ENECUT
          END IF
C
      ELSE
C
          ELIMIT=EBASIS(NLIMIT)+1.0D-5
C
      END IF
C
C=======================================================================
C         CALCULATING ENERGIES OF THE BASIS STATES AT THE FERMI SURFACE
C=======================================================================
C
      EFEBAS(0)=EBASIS(IN_FIX/2)
      EFEBAS(1)=EBASIS(IZ_FIX/2)
C
C=======================================================================
C         ZEROING THE ARRAY OF SINGLE-PARTICLE INDICES
C=======================================================================
C
      DO NX=0,NDXMAX
         DO NY=0,NDYMAX
            DO NZ=0,NDZMAX
               INDICE(NX,NY,NZ)=0
            END DO
         END DO
      END DO
C
C=======================================================================
C         SELECTING THE STATES INCLUDED IN THE BASIS
C=======================================================================
C
      NUMCUT=0
C
      NXMAXX=0
      NYMAXX=0
      NZMAXX=0
C
      DO NX=0,NOSCIL
         DO NY=0,NOSCIL
            DO NZ=0,NOSCIL
C
               EBASEX=HBAROX*(NX+0.5D0)
     *               +HBAROY*(NY+0.5D0)
     *               +HBAROZ*(NZ+0.5D0)
C
               IF (EBASEX.LT.ELIMIT) THEN
C
                   NUMCUT=NUMCUT+1
C
                   IF (NUMCUT.LE.NDBASE) THEN
C
C=======================================================================
C                  IS THE BASIS THE SAME AS THAT READ IN THE "READWS"?
C=======================================================================
C
                       IF (IREAWS.EQ.1) THEN
C
                           IF (NXVECT(NUMCUT).NE.NX.OR.
     *                         NYVECT(NUMCUT).NE.NY.OR.
     *                         NZVECT(NUMCUT).NE.NZ) THEN
C
                               WRITE(NFIPRI,'(/,           1X,20(1H/),
     *                             '' INCOMPATIBLE BASES'',4X,20(1H/),/,
     *                             '' NUMCUT='',I3,
     *                             '' NXVECT='',I2,'' NX='',I2,
     *                             '' NYVECT='',I2,'' NY='',I2,
     *                             '' NZVECT='',I2,'' NZ='',I2)')
     *                         NUMCUT,NXVECT(NUMCUT), NX,
     *                                NYVECT(NUMCUT), NY,
     *                                NZVECT(NUMCUT), NZ
C
                               STOP ' INCOMPATIBLE BASES IN SETBAS'
C
                           END IF
C
                       ELSE
C
C=======================================================================
C                      STORING THE QUANTUM NUMBERS OF THE BASIS STATES
C=======================================================================
C
                          NXVECT(NUMCUT)=NX
                          NYVECT(NUMCUT)=NY
                          NZVECT(NUMCUT)=NZ
C
                       END IF
C
                   END IF
C
C=======================================================================
C                  DETERMINING THE MAXIMUM NUMBERS OF OSCILLATOR QUANTA
C=======================================================================
C
                   IF (NX.GT.NDXMAX.OR.
     *                 NY.GT.NDYMAX.OR.
     *                 NZ.GT.NDZMAX) THEN
C
                       WRITE(NFIPRI,'(/,
     *                              1X,20(1H/),  ''  TOO LARGE BASIS'',
     *                              3X,20(1H/),/,''  NUMCUT='',I3,
     *                              '' NDXMAX='',I2,'' NX='',I2,
     *                              '' NDYMAX='',I2,'' NY='',I2,
     *                              '' NDZMAX='',I2,'' NZ='',I2)')
     *                          NUMCUT,NDXMAX, NX,
     *                                 NDYMAX, NY,
     *                                 NDZMAX, NZ
C
                       STOP ' TOO LARGE OSCILLATOR NUMBERS IN SETBAS'
C
                   END IF
C
                   NXMAXX=MAX(NXMAXX,NX)
                   NYMAXX=MAX(NYMAXX,NY)
                   NZMAXX=MAX(NZMAXX,NZ)
C
                   INDICE(NX,NY,NZ)=NUMCUT
C
               END IF
C
            END DO
         END DO
      END DO
C
      IF (NUMCUT.GT.NDBASE) THEN
C
          WRITE(NFIPRI,'(/,
     *           1X,20(1H/),'' TOO LARGE SP. BASIS: LDBASE ='',I4,
     *                      ''  '',       2X,20(1H/),/,
     *           1X,20(1H/),'' WAS ESTABLISHED FOR  NLIMIT ='',I4,
     *                      ''  '',       2X,20(1H/),/,
     *           1X,20(1H/),'' LDBASE CANNOT EXCEED NDBASE ='',I4,
     *                      ''  '',       2X,20(1H/),/,
     *           1X,20(1H/),'' YOU MAY INCREASE NDBASE TO LDBASE'',
     *                      ''  '',       2X,20(1H/),/,
     *           1X,20(1H/),''   OR DECREASE NLIMIT BELOW NDBASE'',
     *                            ''  '', 2X,20(1H/),/)')
     *           NUMCUT,NLIMIT,NDBASE
C
          STOP ' INCORRECT VALUE OF NLIMIT OR NDBASE IN SETBAS'
C
      END IF
C
C=======================================================================
C         IS THE SIZE OF THE BASIS THE SAME AS THAT READ IN THE "READWS"
C=======================================================================
C
      IF (IREAWS.EQ.1) THEN
C
          IF (NUMCUT.NE.LDBASE) THEN
C
              WRITE(NFIPRI,'(/,
     *                     1X,20(1H/),''  INCOMPATIBLE NO. OF STATES'',
     *                     3X,20(1H/),/,
     *                                ''  NUMCUT='',I3,
     *                                ''  LDBASE='',I3)')
     *
     *                                    NUMCUT,LDBASE
C
              STOP 'INCOMPATIBLE NO. OF STATES IN SETBAS'
C
          END IF
C
      ELSE
C
          LDBASE=NUMCUT
C
      END IF
C
C=======================================================================
C         DETERMINING THE OPTIMUM NUMBERS OF GAUSS-INTEGRATION POINTS
C=======================================================================
C
      IF (IOPTGS.EQ.1.AND.IREAWS.NE.1) THEN
C
          NXHERM=2*NXMAXX+2
          NYHERM=2*NYMAXX+2
          NZHERM=2*NZMAXX+2
C
      END IF
C
C=======================================================================
C         DETERMINING PARITIES OF THE BASIS STATES
C=======================================================================
C
      LDBASP(0)=0
      LDBASP(1)=0
C
      DO IBASE=1,LDBASE
C
         IPARIT=MOD(NXVECT(IBASE)+NYVECT(IBASE)+NZVECT(IBASE),2)
C
         LDBASP(IPARIT)=LDBASP(IPARIT)+1
         IF (LDBASP(IPARIT).GT.NDBASE) STOP ' LDBASP(IPARIT) IN SETBAS'
         INDPAR(LDBASP(IPARIT),IPARIT)=IBASE
C
         IBAPAR(IBASE)=IPARIT
C
      END DO
C
      IF (LDBASP(0)+LDBASP(1).NE.LDBASE) STOP ' PARITY SUM IN SETBAS'
C
C=======================================================================
C         DETERMINING THE LIMITS OF THE BASIS IN THE NX-NY-NZ SPACE
C=======================================================================
C         X-DIRECTION
C=======================================================================
C
      DO NX=0,NXMAXX
         MAXIMY=0
         MAXIMZ=0
         DO NY=0,NYMAXX
            MAXIXY=0
            DO NZ=0,NZMAXX
               IF (INDICE(NX,NY,NZ).NE.0) THEN
                   MAXIMY=MAX(MAXIMY,NY)
                   MAXIMZ=MAX(MAXIMZ,NZ)
                   MAXIXY=MAX(MAXIXY,NZ)
               END IF
            END DO
            LAZOXY(NX,NY)=MAXIXY
         END DO
         LAYOFX(NX)=MAXIMY
         LAZOFX(NX)=MAXIMZ
      END DO
C
C=======================================================================
C         Y-DIRECTION
C=======================================================================
C
      DO NY=0,NYMAXX
         MAXIMZ=0
         MAXIMX=0
         DO NZ=0,NZMAXX
            MAXIYZ=0
            DO NX=0,NXMAXX
               IF (INDICE(NX,NY,NZ).NE.0) THEN
                   MAXIMZ=MAX(MAXIMZ,NZ)
                   MAXIMX=MAX(MAXIMX,NX)
                   MAXIYZ=MAX(MAXIYZ,NX)
               END IF
            END DO
            LAXOYZ(NY,NZ)=MAXIYZ
         END DO
         LAZOFY(NY)=MAXIMZ
         LAXOFY(NY)=MAXIMX
      END DO
C
C=======================================================================
C         Z-DIRECTION
C=======================================================================
C
      DO NZ=0,NZMAXX
         MAXIMX=0
         MAXIMY=0
         DO NX=0,NXMAXX
            MAXIZX=0
            DO NY=0,NYMAXX
               IF (INDICE(NX,NY,NZ).NE.0) THEN
                   MAXIMX=MAX(MAXIMX,NX)
                   MAXIMY=MAX(MAXIMY,NY)
                   MAXIZX=MAX(MAXIZX,NY)
               END IF
            END DO
            LAYOZX(NZ,NX)=MAXIZX
         END DO
         LAXOFZ(NZ)=MAXIMX
         LAYOFZ(NZ)=MAXIMY
      END DO
C
C=======================================================================
C
      WRITE(NFIPRI,'(79(1H*),/,1H*,77X,1H*,/,
     *            1H*, 2X,''BASIS CUT-OFF CONTROL PARAMETERS:'',
     *                    ''  NXMAXX ='',I3,''  NYMAXX ='',I3,
     *                    ''  NZMAXX ='',I4,                 2X,1H*,/,
     *            1H*,77X,                                      1H*,/,
     *            1H*, 2X,A33,
     *                    ''  NXHERM ='',I3,''  NYHERM ='',I3,
     *                    ''  NZHERM ='',I4,                  2X,1H*,/,
     *            1H*,77X,                                      1H*,/,
     *            1H*,35X,''  NLIMIT='',I4,''  LDBASE='',I4,
     *                    ''  MCOUNT='',I5,                  2X,1H*,/,
     *            1H*,77X,                                      1H*,/,
     *            1H*,35X,''  ENECUT='',F9.4,4X,
     *                    ''  ELIMIT='',F9.4,                2X,1H*,/,
     *            1H*,77X,                                      1H*,/,
     *            79(1H*),/)')
     *
     *                      NXMAXX,NYMAXX,NZMAXX,
     *       OPTIMU(IOPTGS),NXHERM,NYHERM,NZHERM,
     *                      NLIMIT,LDBASE,MCOUNT,
     *                             ENECUT,ELIMIT
C
C=======================================================================
C
      IF (NXHERM.LT.2*NXMAXX+2) THEN
         WRITE(NFIPRI,'(/,1X,20(1H/),''  WARNING: NXHERM='',I3,
     *                              ''  IS SMALLER THEN '',I3,
     *                                                     2X,14(1H/),/,
     *                    1X,20(1H/),''  AND DOES NOT ENSURE'',
     *                               ''  EXACT INTEGRATION  '',
     *                                                     2X,14(1H/),/
     *                                             )') NXHERM,2*NXMAXX+2
      END IF
C
      IF (NYHERM.LT.2*NYMAXX+2) THEN
         WRITE(NFIPRI,'(/,1X,20(1H/),''  WARNING: NYHERM='',I3,
     *                               ''  IS SMALLER THEN '',I3,
     *                                                     2X,14(1H/),/,
     *                    1X,20(1H/),''  AND DOES NOT ENSURE'',
     *                               ''  EXACT INTEGRATION  '',
     *                                                     2X,14(1H/),/
     *                                             )') NYHERM,2*NYMAXX+2
      END IF
C
      IF (NZHERM.LT.2*NZMAXX+2) THEN
         WRITE(NFIPRI,'(/,1X,20(1H/),''  WARNING: NZHERM='',I3,
     *                               ''  IS SMALLER THEN '',I3,
     *                                                     2X,14(1H/),/,
     *                    1X,20(1H/),''  AND DOES NOT ENSURE'',
     *                               ''  EXACT INTEGRATION  '',
     *                                                     2X,14(1H/),/
     *                                             )') NZHERM,2*NZMAXX+2
      END IF
C
C=======================================================================
C
      IF (MOD(NXHERM,2).NE.0) THEN
         WRITE(NFIPRI,'(/,1X,20(1H/),''  NXHERM IS ODD:'',
     *                                         I3,2X,20(1H/),/)') NXHERM
         STOP 'NXHERM ODD IN SETBAS'
      END IF
C
      IF (MOD(NYHERM,2).NE.0) THEN
         WRITE(NFIPRI,'(/,1X,20(1H/),''  NYHERM IS ODD:'',
     *                                         I3,2X,20(1H/),/)') NYHERM
         STOP 'NYHERM ODD IN SETBAS'
      END IF
C
      IF (MOD(NZHERM,2).NE.0) THEN
         WRITE(NFIPRI,'(/,1X,20(1H/),''  NZHERM IS ODD:'',
     *                                         I3,2X,20(1H/),/)') NZHERM
         STOP 'NZHERM ODD IN SETBAS'
      END IF
C
C=======================================================================
C
      IF (NXHERM.GT.NDXHRM) THEN
          WRITE(NFIPRI,'(/,
     *                 1X,20(1H/),4X,''NXHERM.GT.NDXHRM:'',3X,20(1H/),/,
     *                 1X,20(1H/),8X,I2,   ''.GT.''  ,I2,8X,20(1H/),/)')
     *                 NXHERM,NDXHRM
         STOP 'NXHERM.GT.NDXHRM IN SETBAS'
      END IF
C
      IF (NYHERM.GT.NDYHRM) THEN
          WRITE(NFIPRI,'(/,
     *                 1X,20(1H/),4X,''NYHERM.GT.NDYHRM:'',3X,20(1H/),/,
     *                 1X,20(1H/),8X,I2,   ''.GT.''  ,I2,8X,20(1H/),/)')
     *                 NYHERM,NDYHRM
         STOP 'NYHERM.GT.NDYHRM IN SETBAS'
      END IF
C
      IF (NZHERM.GT.NDZHRM) THEN
          WRITE(NFIPRI,'(/,
     *                 1X,20(1H/),4X,''NZHERM.GT.NDZHRM:'',3X,20(1H/),/,
     *                 1X,20(1H/),8X,I2,   ''.GT.''  ,I2,8X,20(1H/),/)')
     *                 NZHERM,NDZHRM
         STOP 'NZHERM.GT.NDZHRM IN SETBAS'
      END IF
C
C=======================================================================
C         PRINTING THE BASIS SHAPE DIAGRAMS (THE "DIAMONDS")
C=======================================================================
C
      DO IDIGIT=0,99
         WRITE(DIGITS(IDIGIT),'(I2)') IDIGIT
      END DO
C
      WRITE(NFIPRI,'(79(1H*),/,1H*,77X,1H*,/,
     *            1H*,3X,''SHAPE OF THE OSCILLATOR-BASIS DIAMOND'',
     *                   ''    (THREE CONSECUTIVE PROJECTIONS)'',
     *                                                       2X,1H*,/,
     *            1H*,77X,                                      1H*,/,
     *            79(1H*),/,1H*,77X,1H*)')
C
C=======================================================================
C         NX - NY  P L A N E    NX - NY  P L A N E   NX - NY  P L A N E
C=======================================================================
C
      WRITE(NFIPRI,'(1H*,8X,''NX ===>>>'',19(1X,A2),3X,1H*)')
     *                    (DIGITS(NX),NX=0,MIN(NXMAXX,18)),
     *                          ('  ',NX=  MIN(NXMAXX,18)+1,18)
C
      WRITE(NFIPRI,'(1H*,8X,''MAX.NY =>'',19(1X,A2),3X,1H*)')
     *            (DIGITS(LAYOFX(NX)),NX=0,MIN(NXMAXX,18)),
     *                          ('  ',NX=  MIN(NXMAXX,18)+1,18)
C
      WRITE(NFIPRI,'(1H*,8X,''         '',19A3,3X,1H*)')
     *                                  ('---',NX=0,MIN(NXMAXX,18)),
     *                                  ('   ',NX=  MIN(NXMAXX,18)+1,18)
C
C=======================================================================
C
      DO NY=0,NYMAXX
C
         WRITE(NFIPRI,'(1H*,3X,''NY='',I2,2X,''('',I2,'')'',2X,''|'',
     *                19(1X,A2),3X,1H*)')
     *            NY,LAXOFY(NY),
     *            (DIGITS(LAZOXY(NX,NY)),NX=0,MIN(LAXOFY(NY),18)),
     *                             ('  ',NX=  MIN(LAXOFY(NY),18)+1,18)
C
      END DO
C
      WRITE(NFIPRI,'(1H*,77X,1H*,/,1H*,77X,1H*)')
C
C=======================================================================
C         NZ - NY  P L A N E    NZ - NY  P L A N E   NZ - NY  P L A N E
C=======================================================================
C
      WRITE(NFIPRI,'(1H*,8X,''NZ ===>>>'',19(1X,A2),3X,1H*)')
     *                    (DIGITS(NZ),NZ=0,MIN(NZMAXX,18)),
     *                          ('  ',NZ=  MIN(NZMAXX,18)+1,18)
C
      WRITE(NFIPRI,'(1H*,8X,''MAX.NY =>'',19(1X,A2),3X,1H*)')
     *            (DIGITS(LAYOFZ(NZ)),NZ=0,MIN(NZMAXX,18)),
     *                          ('  ',NZ=  MIN(NZMAXX,18)+1,18)
C
      WRITE(NFIPRI,'(1H*,8X,''         '',19A3,3X,1H*)')
     *                                  ('---',NZ=0,MIN(NZMAXX,18)),
     *                                  ('   ',NZ=  MIN(NZMAXX,18)+1,18)
C
C=======================================================================
C
      DO NY=0,NYMAXX
C
         WRITE(NFIPRI,'(1H*,3X,''NY='',I2,2X,''('',I2,'')'',2X,''|'',
     *                19(1X,A2),3X,1H*)')
     *            NY,LAZOFY(NY),
     *            (DIGITS(LAXOYZ(NY,NZ)),NZ=0,MIN(LAZOFY(NY),18)),
     *                             ('  ',NZ=  MIN(LAZOFY(NY),18)+1,18)
C
      END DO
C
      WRITE(NFIPRI,'(1H*,77X,1H*,/,1H*,77X,1H*)')
C
C=======================================================================
C         NZ - NX  P L A N E    NZ - NX  P L A N E   NZ - NX  P L A N E
C=======================================================================
C
      WRITE(NFIPRI,'(1H*,8X,''NZ ===>>>'',19(1X,A2),3X,1H*)')
     *                    (DIGITS(NZ),NZ=0,MIN(NZMAXX,18)),
     *                          ('  ',NZ=  MIN(NZMAXX,18)+1,18)
C
      WRITE(NFIPRI,'(1H*,8X,''MAX.NX =>'',19(1X,A2),3X,1H*)')
     *            (DIGITS(LAXOFZ(NZ)),NZ=0,MIN(NZMAXX,18)),
     *                          ('  ',NZ=  MIN(NZMAXX,18)+1,18)
C
      WRITE(NFIPRI,'(1H*,8X,''         '',19A3,3X,1H*)')
     *                                  ('---',NZ=0,MIN(NZMAXX,18)),
     *                                  ('   ',NZ=  MIN(NZMAXX,18)+1,18)
C
C=======================================================================
C
      DO NX=0,NXMAXX
C
         WRITE(NFIPRI,'(1H*,3X,''NX='',I2,2X,''('',I2,'')'',2X,''|'',
     *                19(1X,A2),3X,1H*)')
     *            NX,LAZOFX(NX),
     *            (DIGITS(LAYOZX(NZ,NX)),NZ=0,MIN(LAZOFX(NX),18)),
     *                             ('  ',NZ=  MIN(LAZOFX(NX),18)+1,18)
C
      END DO
C
      WRITE(NFIPRI,'(1H*,77X,1H*,/,79(1H*),/)')
C
C=======================================================================
C
      IF (IPRGCM.GE.1.AND.(HOMSCA(1).NE.HOMSCA(2).OR.
     *                     HOMSCA(2).NE.HOMSCA(3).OR.
     *                     HOMSCA(3).NE.HOMSCA(1))) THEN
C
          WRITE(NFIPRI,'(/,
     *                 1X,21(1H/),'' IPRGCM>0 REQUIRES SPHERICAL'',
     *                            '' BASIS'',        1X,21(1H/),/,
     *                 1X,21(1H/),'' HOMSCA(1)-HOMSCA(2)='',E13.6,
     *                                               1X,21(1H/),/,
     *                 1X,21(1H/),'' HOMSCA(2)-HOMSCA(3)='',E13.6,
     *                                               1X,21(1H/),/,
     *                 1X,21(1H/),'' HOMSCA(3)-HOMSCA(1)='',E13.6,
     *                                               1X,21(1H/))')
C
          STOP ' NON-SPHERICAL BASIS FOR IPRGCM>0 IN SETBAS'
C
      END IF
C
C=======================================================================
C
      IF (INIROT.EQ.1.AND.(HOMSCA(1).NE.HOMSCA(2).OR.
     *                     HOMSCA(2).NE.HOMSCA(3).OR.
     *                     HOMSCA(3).NE.HOMSCA(1))) THEN
C
          WRITE(NFIPRI,'(/,
     *                 1X,21(1H/),'' INIROT=1 REQUIRES SPHERICAL'',
     *                            '' BASIS'',        1X,21(1H/),/,
     *                 1X,21(1H/),'' HOMSCA(1)-HOMSCA(2)='',E13.6,
     *                                               1X,21(1H/),/,
     *                 1X,21(1H/),'' HOMSCA(2)-HOMSCA(3)='',E13.6,
     *                                               1X,21(1H/),/,
     *                 1X,21(1H/),'' HOMSCA(3)-HOMSCA(1)='',E13.6,
     *                                               1X,21(1H/))')
     *          HOMSCA(1)-HOMSCA(2),
     *          HOMSCA(2)-HOMSCA(3),
     *          HOMSCA(3)-HOMSCA(1)
C
          STOP ' NON-SPHERICAL BASIS FOR INIROT=1 IN SETBAS'
C
      END IF
C
C=======================================================================
C
      IF (ISPHER.EQ.1.AND.(HOMSCA(1).NE.HOMSCA(2).OR.
     *                     HOMSCA(2).NE.HOMSCA(3).OR.
     *                     HOMSCA(3).NE.HOMSCA(1))) THEN
C
          WRITE(NFIPRI,'(/,
     *                 1X,21(1H/),'' ISPHER=1 REQUIRES SPHERICAL'',
     *                            '' BASIS'',        1X,21(1H/),/,
     *                 1X,21(1H/),'' HOMSCA(1)-HOMSCA(2)='',E13.6,
     *                                               1X,21(1H/),/,
     *                 1X,21(1H/),'' HOMSCA(2)-HOMSCA(3)='',E13.6,
     *                                               1X,21(1H/),/,
     *                 1X,21(1H/),'' HOMSCA(3)-HOMSCA(1)='',E13.6,
     *                                               1X,21(1H/))')
     *          HOMSCA(1)-HOMSCA(2),
     *          HOMSCA(2)-HOMSCA(3),
     *          HOMSCA(3)-HOMSCA(1)
C
          STOP ' NON-SPHERICAL BASIS FOR ISPHER=1 IN SETBAS'
C
      END IF
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE MULCOU(ISIMPY,ISIGNY,ISIQTY,NMUCOU)
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      COMMON
     *       /LISMOM/ LISLAM(1:NDPOLS),LISMIU(1:NDPOLS),NUPOLS
C
C=======================================================================
C         THIS SUBROUTINE SELECTS THE MULTIPOLES WHICH WILL BE USED FOR
C         A CALCULATION OF THE COULOMB POTENTIAL AT THE BOX  BOUNDARIES
C=======================================================================
C         FOR CONSERVED SIMPLEX (ISIMPY=1):
C         ONLY THE REAL PARTS OF MOMENTS ARE USED.
C=======================================================================
C         FOR CONSERVED SIGNATURE (ISIGNY=1):
C         1) THE      REAL PARTS  ARE USED ONLY FOR EVEN MOMENTS.
C         2) THE IMAGINARY PARTS  ARE USED ONLY FOR ODD  MOMENTS.
C=======================================================================
C         FOR CONSERVED PARITY (ISIQTY=1):
C         ONLY THE EVEN MOMENTS ARE USED.
C=======================================================================
C         ISIMPY  ISIGNY  ISIQTY |  REAL PARTS           IMAGINARY PARTS
C         -----------------------|--------------------------------------
C            0       0       0   |  ALL  MULTIPOLES      ALL  MULTIPOLES
C            0       0       1   |  EVEN MULTIPOLES      EVEN MULTIPOLES
C            0       1       0   |  EVEN MULTIPOLES      ODD  MULTIPOLES
C            1       0       0   |  ALL  MULTIPOLES      NONE MULTIPOLES
C            1       1       1   |  EVEN MULTIPOLES      NONE MULTIPOLES
C=======================================================================
C         FOR ISIMPY=0 AND ISIGNY=0 AND ISIQTY=0
C                      AND  FOR  NMUCOU   ==>>  4  (5,  6,  7,  8,  9)
C                      ONE NEEDS NDPOLS   ==>> 25 (36, 49, 64, 81,100)
C         FOR ISIMPY=0 AND ISIGNY=0 AND ISIQTY=1
C                      AND  FOR  NMUCOU   ==>>  4  (5,  6,  7,  8,  9)
C                      ONE NEEDS NDPOLS   ==>> 15 (15, 28, 28, 45, 45)
C         FOR ISIMPY=0 AND ISIGNY=1
C                      AND  FOR  NMUCOU   ==>>  4  (5,  6,  7,  8,  9)
C                      ONE NEEDS NDPOLS   ==>> 13 (18, 25, 32, 41, 50)
C         FOR ISIMPY=1 AND ISIGNY=0
C                      AND  FOR  NMUCOU   ==>>  4  (5,  6,  7,  8,  9)
C                      ONE NEEDS NDPOLS   ==>> 15 (21, 28, 36, 45, 55)
C         FOR ISIMPY=1 AND ISIGNY=1
C                      AND  FOR  NMUCOU   ==>>  4  (5,  6,  7,  8,  9)
C                      ONE NEEDS NDPOLS   ==>>  9 ( 9, 16, 16, 25, 25)
C=======================================================================
C
      MULPOL=0
C
C=======================================================================
C        ADDING REAL PARTS OF MULTIPOLE MOMENTS TO THE LIST
C=======================================================================
C
      DO LAMBDA=0,NMUCOU
         DO MIU=0,LAMBDA
C
            IF (MOD(LAMBDA,2).EQ.0.OR.(ISIGNY.NE.1.AND.ISIQTY.NE.1))THEN
C
               IF (MULPOL.GE.NDPOLS)
     *             STOP ' (1) MULPOL.GT.NDPOLS IN MULCOU'
C
               MULPOL=MULPOL+1
               LISLAM(MULPOL)=LAMBDA
               LISMIU(MULPOL)=MIU
C
            END IF
C
         END DO
      END DO
C
C=======================================================================
C        ADDING IMAGINARY PARTS OF MULTIPOLE MOMENTS TO THE LIST
C=======================================================================
C
      IF (ISIMPY.NE.1.AND.NMUCOU.GE.1) THEN
C
          DO LAMBDA=1,NMUCOU
             DO MIU=-LAMBDA,-1
C
                IF ((MOD(LAMBDA,2).EQ.1.AND.ISIQTY.NE.1).OR.
     *              (MOD(LAMBDA,2).EQ.0.AND.ISIGNY.NE.1)) THEN
C
                   IF (MULPOL.GE.NDPOLS)
     *                 STOP ' (2) MULPOL.GT.NDPOLS IN MULCOU'
C
                   MULPOL=MULPOL+1
                   LISLAM(MULPOL)=LAMBDA
                   LISMIU(MULPOL)=MIU
C
                END IF
C
             END DO
          END DO
C
      END IF
C
      NUPOLS=MULPOL
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE PRECOU(NOSCIL,NUMCOU,NUMETA,BOUCOU,
     *                  NFICOU,FILCOU,ICOULI,ICOULO)
C
      COMMON
     *       /CFIPRI/ NFIPRI
C
      CHARACTER
     *          FILCOU*68
C
C=======================================================================
C          THIS SOUBROUTINE DEFINES THE FOURIER INTEGRALS FOR THE
C          COULOMB POTENTIAL.
C=======================================================================
C
      CALL DEFCOU(NOSCIL,NUMCOU,BOUCOU)
C
C=======================================================================
C         CHECKING WHETHER THE COULOMB FILE EXISTS ON THE DISC
C=======================================================================
C
      ICOULE=0
C
      OPEN(NFICOU,FILE=FILCOU,STATUS='OLD',ERR=1,FORM='UNFORMATTED')
C
      ICOULE=1
      CLOSE(NFICOU)
C
    1 CONTINUE
C
C=======================================================================
C         FOR  ICOULI<>0  AND  ICOULO<>0  ONE ENTERS THE AUTOMATED MODE:
C         1) THE COULOMB FILE IS  READ  PROVIDED  IT EXISTS ON THE DISC,
C         2) THEN IT IS CHECKED IF IT CONTAINS THE CORRECT DATA.
C         3) IF IT DOESN'T EXIST, OR IF IT DOESN'T CONTAIN CORRECT DATA,
C            THE SUBROUTINE  "POWALL" IS CALLED AND THE COULOMB FILE IS
C            STORED ON THE DISC
C=======================================================================
C
      IF (ICOULI.NE.0.AND.ICOULO.NE.0) THEN
C
          WRITE(NFIPRI,'(79(1H*),/,1H*,77X,1H*,/,
     *        1H*,1X,'' AUTOMATED HANDLING OF THE'',
     *               '' COULOMB FILE'',                 37X,1H*,/,
     *                                              1H*,77X,1H*)')
C
      END IF
C
      IREWRI=0
C
C=======================================================================
C         FOR  ICOULI<>0  THE COULOMB FILE IS READ FROM THE DISC
C=======================================================================
C         FOR  ICOULI<>0  AND  ICOULO<>0  ONE ENTERS THE AUTOMATED MODE:
C                                       (SEE THE RULES ENUMERATED ABOVE)
C=======================================================================
C
      IF (ICOULI.EQ.0.OR.
     *   (ICOULI.NE.0.AND.ICOULO.NE.0.AND.ICOULE.EQ.0)) THEN
C
          CALL POWALL(NUMCOU,NUMETA,BOUCOU)
C
      ELSE
C
          WRITE(NFIPRI,'(79(1H*),/,1H*,77X,1H*,/,
     *        1H*,1X,'' THE COULOMB FILE READ FROM THE DISC,'',
     *               '' FILE NAME (FILCOU): '',         18X,1H*,/,
     *        1H*,2X,A68,                                7X,1H*,/,
     *                                              1H*,77X,1H*)')
     *
     *        FILCOU
C
          INPCOU=1
          I_SUCC=1
C
          OPEN(NFICOU,FILE=FILCOU,STATUS='OLD',FORM='UNFORMATTED')
          CALL RECOUL(NFICOU,INPCOU,I_SUCC,NUMCOU,NUMETA,BOUCOU)
          CLOSE(NFICOU)
C
          IF (I_SUCC.NE.1) THEN
              IF (ICOULI.NE.0.AND.ICOULO.NE.0) THEN
C
                  CALL POWALL(NUMCOU,NUMETA,BOUCOU)
                  IREWRI=1
C
                  WRITE(NFIPRI,'(79(1H*),/,1H*,77X,1H*,/,
     *                  1H*,1X,'' THE COULOMB DATA HAVE'',
     *                         '' BEEN RECALCULATED'',36X,1H*,/,
     *                                            1H*,77X,1H*)')
C
              ELSE
C
                  STOP ' INCORRECT DATA ON THE COULOMB FILE IN PRECOU'
C
              END IF
          END IF
C
      END IF
C
C=======================================================================
C         FOR  ICOULO<>0  THE COULOMB FILE IS WRITTEN ON THE DISC
C=======================================================================
C         FOR  ICOULI<>0  AND  ICOULO<>0  ONE ENTERS THE AUTOMATED MODE:
C                                       (SEE THE RULES ENUMERATED ABOVE)
C=======================================================================
C
      IF (ICOULO.NE.0.AND.(ICOULI.EQ.0.OR.(ICOULE.EQ.0.OR.IREWRI.EQ.1)))
     *    THEN
C
          WRITE(NFIPRI,'(79(1H*),/,1H*,77X,1H*,/,
     *        1H*,1X,'' THE COULOMB FILE WRITTEN ON THE DISC,'',
     *               '' FILE NAME (FILCOU): '',         17X,1H*,/,
     *        1H*,2X,A68,                                7X,1H*,/,
     *                                              1H*,77X,1H*)')
     *
     *        FILCOU
C
          INPCOU=0
          I_SUCC=1
C
          OPEN(NFICOU,FILE=FILCOU,STATUS='UNKNOWN',FORM='UNFORMATTED')
          CALL RECOUL(NFICOU,INPCOU,I_SUCC,NUMCOU,NUMETA,BOUCOU)
          CLOSE(NFICOU)
C
      END IF
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE RECOUL(NFICOU,INPCOU,I_SUCC,NUMCOU,NUMETA,BOUCOU)
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      DIMENSION
     *          LIZLAM(1:NDPOLS),LIZMIU(1:NDPOLS)
      DIMENSION
     *          HOMSCB(NDKART)
C
      COMMON
     *       /WFACTO/ WALPOT(0:NDCOUL,0:NDCOUL,1:NDPOLS,1:NDKART,0:1),
     *                WALFAC(0:NDCOUL,                  1:NDKART,0:1)
      COMMON
     *       /LISMOM/ LISLAM(1:NDPOLS),LISMIU(1:NDPOLS),NUPOLS
      COMMON
     *       /SCALNG/ HOMSCA(NDKART)
      COMMON
     *       /CFIPRI/ NFIPRI
C
C=======================================================================
C
      CALL CPUTIM('RECOUL',1)
C
C=======================================================================
C     INPCOU - IF .NE.0 => THE FILE WITH THE UNIT NUMBER  NFICOU WILL BE
C                          USED TO  R E A D   THE COULOMB MATRICES WHICH
C                          HAVE BEEN PREVIOUSLY CALCULATED  BY  "POWALL"
C=======================================================================
C
      IF (INPCOU.NE.0) THEN
C
          REWIND(UNIT=NFICOU,IOSTAT=IERROR)
C
          IF (IERROR.NE.0) STOP 'ERROR IN REWINDING (6)'
C
          IFIRED=0
C
          READ (NFICOU) IVERIN
C
          IF (IVERIN.EQ.3) THEN
C
C=======================================================================
C             READING THE COULOMB ARRAYS' DIMENSIONS
C=======================================================================
C
              READ (NFICOU) MDCOUL,MDKART,MUPOLS
C
              IF (MDCOUL.NE.NDCOUL.OR.MDKART.NE.NDKART) THEN
C
                  WRITE(NFIPRI,'(/,                    1X,20(1H/),
     *                         ''  INCORRECT PARAMETER DIMENSIONS'',
     *                                                 6X,20(1H/),/,
     *                         1X,20(1H/),
     *                         ''  FOUND  ON  THE  COULOMB  FILE:'',
     *                                                 6X,20(1H/),/,
     *                         1X,20(1H/),
     *                         ''            READ   SHOULD BE    '',
     *                                                 6X,20(1H/),/,
     *                         1X,20(1H/),
     *                         ''  NDCOUL='',I6,4X,I6,13X,20(1H/),/,
     *                         1X,20(1H/),
     *                         ''  NDKART='',I6,4X,I6,13X,20(1H/),/)')
     *
     *            MDCOUL,NDCOUL,
     *            MDKART,NDKART
C
                  I_SUCC=-1
                  GO TO 1
C
              END IF
C
C=======================================================================
C
              IF (MUPOLS.NE.NUPOLS) THEN
C
                  WRITE(NFIPRI,'(/,                    1X,20(1H/),
     *                         ''  INCORRECT NUMBER OF MULTIPOLES'',
     *                                                 6X,20(1H/),/,
     *                         1X,20(1H/),
     *                         ''  FOUND  ON  THE  COULOMB  FILE:'',
     *                                                 6X,20(1H/),/,
     *                         1X,20(1H/),
     *                         ''            READ   SHOULD BE    '',
     *                                                 6X,20(1H/),/,
     *                         1X,20(1H/),
     *                         ''  NUPOLS='',I6,4X,I6,13X,20(1H/),/)')
     *
     *            MUPOLS,NUPOLS
C
                  I_SUCC=-1
                  GO TO 1
C
              END IF
C
C=======================================================================
C             READING THE COULOMB MULTIPOLES
C=======================================================================
C
              READ (NFICOU) (LIZLAM(MULPOL),
     *                       LIZMIU(MULPOL),MULPOL=1,NUPOLS)
C
C=======================================================================
C             ATTENTION: THE TEST BELOW WAS ABSENT UP TO  VERSION  2.00,
C                        AND ONLY THE NUMBERS  OF  DIFFERENT  MULTIPOLES
C                        FOUND ON THE  COULOMB  FILE  WERE  TESTED. THIS
C                        COULD HAVE CAUSED  PROBLEMS, IF  FOR  DIFFERENT
C                        SYMMETRIES THE  LISTS  OF  MULTIPOLES  DIFFERED
C                        WHILE THE NUMERS OF MULTIPOLES WERE  THE  SAME.
C                        SUCH A PROBLEM WAS NOT POSSIBLE  FOR  ISIMPY=1,
C                        AND HENCE THE PUBLISHED VERSION 1.75R WAS SAFE.
C                        THIS BUG WAS CORRECTED  ON  11/07/2002  IN  THE
C                        VERSION 2.00A.
C=======================================================================
C
              IEQUAL=1
C
              DO MULPOL=1,NUPOLS
C
                 IF(LIZLAM(MULPOL).NE.LISLAM(MULPOL).OR.
     *              LIZMIU(MULPOL).NE.LISMIU(MULPOL)) IEQUAL=0
C
              END DO
C
C=======================================================================
C
              IF (IEQUAL.NE.1) THEN
C
                  WRITE(NFIPRI,'(/,                    1X,20(1H/),
     *                         ''  INCORRECT LIST OF MULTIPOLES  '',
     *                                                 6X,20(1H/),/,
     *                         1X,20(1H/),
     *                         ''  FOUND  ON  THE  COULOMB  FILE '',
     *                                                 6X,20(1H/),/)')
C
                  I_SUCC=-1
                  GO TO 1
C
              END IF
C
C=======================================================================
C             READING THE OSCILLATOR FREQUENCIES
C=======================================================================
C
              READ (NFICOU) (HOMSCB(KARTEZ),KARTEZ=1,NDKART)
C
              IEQUAL=1
C
              DO KARTEZ=1,NDKART
C
                 IF (ABS(HOMSCB(KARTEZ)-HOMSCA(KARTEZ)).GT.1.0D-10)
     *               IEQUAL=0
C
              END DO
C
C=======================================================================
C
              IF (IEQUAL.NE.1) THEN
C
                  WRITE(NFIPRI,'(/,                    1X,20(1H/),
     *                         ''  INCORRECT OSCILLATOR FREQUENCY'',
     *                                                 6X,20(1H/),/,
     *                         1X,20(1H/),
     *                         ''  FOUND  ON  THE  COULOMB  FILE:'',
     *                                                 6X,20(1H/),/,
     *                         1X,20(1H/),
     *                         ''               READ   SHOULD BE '',
     *                                                 6X,20(1H/),/,
     *                         1X,20(1H/),
     *                         ''  HOMSCA-X='',2F10.6, 7X,20(1H/),/,
     *                         1X,20(1H/),
     *                         ''  HOMSCA-Y='',2F10.6, 7X,20(1H/),/,
     *                         1X,20(1H/),
     *                         ''  HOMSCA-Z='',2F10.6, 7X,20(1H/),/)')
     *
     *            (HOMSCB(KARTEZ),HOMSCA(KARTEZ),KARTEZ=1,NDKART)
C
                  I_SUCC=-1
                  GO TO 1
C
              END IF
C
C=======================================================================
C             READING THE COULOMB PARAMETERS
C=======================================================================
C
              READ (NFICOU)  MUMCOU,MUMETA,AOUCOU
C
              IF (MUMCOU.NE.NUMCOU.OR.MUMETA.NE.NUMETA.OR.
     *            ABS(AOUCOU-BOUCOU).GT.1.0D-10) THEN
C
                  WRITE(NFIPRI,'(/,                    1X,20(1H/),
     *                         ''  INCORRECT  COULOMB  PARAMETERS'',
     *                                                 6X,20(1H/),/,
     *                         1X,20(1H/),
     *                         ''  FOUND  ON  THE  COULOMB  FILE:'',
     *                                                 6X,20(1H/),/,
     *                         1X,20(1H/),
     *                         ''            READ   SHOULD BE    '',
     *                                                 6X,20(1H/),/,
     *                         1X,20(1H/),
     *                         ''  NUMCOU='',I6,4X,I6,13X,20(1H/),/,
     *                         1X,20(1H/),
     *                         ''  NUMETA='',I6,4X,I6,13X,20(1H/),/,
     *                         1X,20(1H/),
     *                         ''  BOUCOU='',F6.2,4X,F6.2,
     *                                                13X,20(1H/),/)')
     *
     *            MUMCOU,NUMCOU,
     *            MUMETA,NUMETA,
     *            AOUCOU,BOUCOU
C
                  I_SUCC=-1
                  GO TO 1
C
              END IF
C
C=======================================================================
C             READING THE COULOMB ARRAYS
C=======================================================================
C
              READ (NFICOU) (((((WALPOT(JX,JY,MULPOL,KARTEZ,IWSIDE),
     *                          JX=0,NDCOUL),JY=0,NDCOUL),
     *                          MULPOL=1,NUPOLS),KARTEZ=1,NDKART),
     *                          IWSIDE=0,1)
C
              READ (NFICOU) (  ((WALFAC(JX,          KARTEZ,IWSIDE),
     *                          JX=0,NDCOUL),KARTEZ=1,NDKART),
     *                          IWSIDE=0,1)
C
              IFIRED=1
C
          END IF
C
          IF (IFIRED.EQ.0) THEN
C
              WRITE(NFIPRI,'(/,                 1X,18(1H/),
     *                  '' CANNOT READ THE COULOMB FILE VERSION:'',
     *                                       I3,1X,18(1H/),/)') IVERIN
C
              I_SUCC=-1
              GO TO 1
C
          END IF
C
      ELSE
C
C=======================================================================
C     INPCOU - IF .EQ.0 => THE FILE WITH THE UNIT NUMBER  NFICOU WILL BE
C                          USED TO  S T O R E THE COULOMB  ARRAYS  WHICH
C                          HAVE BEEN PREVIOUSLY CALCULATED  BY  "POWALL"
C=======================================================================
C
          REWIND(UNIT=NFICOU,IOSTAT=IERROR)
C
          IF (IERROR.NE.0) STOP 'ERROR IN REWINDING (7)'
C
          IVEROU=3
C
          WRITE(NFICOU) IVEROU
C
          IF (IVEROU.EQ.3) THEN
C
              WRITE(NFICOU) NDCOUL,NDKART,NUPOLS
C
              WRITE(NFICOU) (LISLAM(MULPOL),
     *                       LISMIU(MULPOL),MULPOL=1,NUPOLS)
C
              WRITE(NFICOU) (HOMSCA(KARTEZ),KARTEZ=1,NDKART)
C
              WRITE(NFICOU)  NUMCOU,NUMETA,BOUCOU
C
              WRITE(NFICOU) (((((WALPOT(JX,JY,MULPOL,KARTEZ,IWSIDE),
     *                          JX=0,NDCOUL),JY=0,NDCOUL),
     *                          MULPOL=1,NUPOLS),KARTEZ=1,NDKART),
     *                          IWSIDE=0,1)
C
              WRITE(NFICOU) (  ((WALFAC(JX,          KARTEZ,IWSIDE),
     *                          JX=0,NDCOUL),KARTEZ=1,NDKART),
     *                          IWSIDE=0,1)
C
          END IF
C
      END IF
C
C=======================================================================
C
    1 CONTINUE
C
      CALL CPUTIM('RECOUL',0)
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE POWALL(NUMCOU,NUMETA,BOUCOU)
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      DIMENSION
     *          FOURIE(0:NDCOUL,1:NDNETA)
      DIMENSION
     *          POSTIO(NDKART)
      COMMON
     *       /WFACTO/ WALPOT(0:NDCOUL,0:NDCOUL,1:NDPOLS,1:NDKART,0:1),
     *                WALFAC(0:NDCOUL,                  1:NDKART,0:1)
      COMMON
     *       /LISMOM/ LISLAM(1:NDPOLS),LISMIU(1:NDPOLS),NUPOLS
      COMMON
     *       /SCALNG/ HOMSCA(NDKART)
      COMMON
     *       /CFIPRI/ NFIPRI
C
C=======================================================================
C
      CALL CPUTIM('POWALL',1)
C
C=======================================================================
C         THIS SUBROUTINE CALCULATES FOURIER TRANSFORMS OF  THE  COULOMB
C         POTENTIAL ON THE WALLS OF PARALLELEPIPED.
C=======================================================================
C         THE LAST TWO INDICES OF THE "WALPOT" ARRAY  DENOTE ONE OF  THE
C         SIX WALLS ACCORDING TO THE FOLLOWING CONVENTION:
C
C         KARTEZ    IWSIDE       WALL
C         ------    ------     -----------
C            1         1       X =  BOUCOU / HOMSCA(1) / SQRT(2)
C            1         0       X = -BOUCOU / HOMSCA(1) / SQRT(2)
C            2         1       Y =  BOUCOU / HOMSCA(2) / SQRT(2)
C            2         0       Y = -BOUCOU / HOMSCA(2) / SQRT(2)
C            3         1       Z =  BOUCOU / HOMSCA(3) / SQRT(2)
C            3         0       Z = -BOUCOU / HOMSCA(3) / SQRT(2)
C
C        THE FIRST (SECOND) INDEX CORRESPONDS TO  THE FOURIER LABEL IN
C        THE "KARTEZ-2" ("KARTEZ-1") DIRECTION. IN THIS CONVENTION, +3
C        HAS TO BE ADDED TO THE DIRECTION NUMBER WHENEVER IT COMES OUT
C        AS A NON-POSITIVE INTEGER. THIS AMOUNTS TO:
C
C        KARTEZ     FIRST INDEX   SECOND INDEX   WALL
C        ------     -----------   ------------   ----
C           1       Y-DIRECTION    Z-DIRECTION     X
C           2       Z-DIRECTION    X-DIRECTION     Y
C           3       X-DIRECTION    Y-DIRECTION     Z
C
C        THE MIDDLE (THIRD) INDEX CORRESPONDS TO A GIVEN  MULTIPOLE. THE
C        LIST OF MULTIPOLES TAKEN INTO ACCOUNT AT BOUNDARIES IS PREPARED
C        IN THE SUBROUTINE "MULCOU" AND STORED IN ARRAYS:       "LISLAM"
C                                                           AND "LISMIU"
C
C        AT PRESENT, SIMPSON INTEGRATION RULE IS USED BUT WE SHOULD LOOK
C        FOR AN ANALYTICAL EXPRESSION.
C
C=======================================================================
C        CALCULATING THE LAPLACIAN EIGENFUNCTIONS AT INTEGRATION NODES
C=======================================================================
C
      SQ2   =SQRT(2.0000000D0)
      PI    =4.0D0*ATAN(1.0D0)
      STEPOM=PI/(2.0D0*BOUCOU)
C
C     NUMETA=2*(NUMCOU/2)-1
C
      STEPET=2.0D0*BOUCOU/(NUMETA+1)
C
      IF (NUMETA.GT.NDNETA) THEN
C
         WRITE(NFIPRI,'(//,1X,''NUMETA='',I2,'' .GT. NDNETA='',I2,
     *                         ''   STOP IN POWALL'',//)') NUMETA,NDNETA
         STOP ' NUMETA.GT.NDNETA  IN  POWALL'
C
      END IF
C
      IF (MOD(NUMETA,2).NE.1) THEN
C
         WRITE(NFIPRI,'(//,1X,''NUMETA='',I2,''  MUST BE ODD.'',
     *                         ''   STOP IN POWALL'',//)') NUMETA
         STOP ' NUMETA IS EVEN  IN  POWALL'
C
      END IF
C
      DO IFOURI=0,NUMCOU
C
         XFOURI=STEPOM*(IFOURI+1)
C
         IF (MOD(IFOURI,2).EQ.0) THEN
C
            DO INDETA=1,NUMETA
               ETA=-BOUCOU+STEPET*INDETA
               FOURIE(IFOURI,INDETA)=COS(XFOURI*ETA)
            END DO
C
         ELSE
C
            DO INDETA=1,NUMETA
               ETA=-BOUCOU+STEPET*INDETA
               FOURIE(IFOURI,INDETA)=SIN(XFOURI*ETA)
            END DO
C
         END IF
C
      END DO
C
C=======================================================================
C        CALCULATING THE FOURIER INTEGRALS
C=======================================================================
C        LOOP OVER CARTESIAN DIRECTIONS
C=======================================================================
C
      DO KARTEZ=1,NDKART
C
         KARTEX=KARTEZ-2
         IF (KARTEX.LE.0) KARTEX=KARTEX+3
C
         KARTEY=KARTEZ-1
         IF (KARTEY.LE.0) KARTEY=KARTEY+3
C
C=======================================================================
C        LOOP OVER SIDES OF THE PARALLELEPIPED
C=======================================================================
C
         DO IWSIDE=0,1
C
            POSTIO(KARTEZ)=(2*IWSIDE-1) * BOUCOU / HOMSCA(KARTEZ) /SQ2
C
C=======================================================================
C           LOOP OVER MULTIPOLES
C=======================================================================
C
            DO MULPOL=1,NUPOLS
C
               LAMBDA=LISLAM(MULPOL)
               MIU   =LISMIU(MULPOL)
C
C=======================================================================
C             ZEROING MATRICES OF FOURIER TRANSFORMS
C=======================================================================
C
               DO JX = 0,NUMCOU
                  DO JY = 0,NUMCOU
C
                     WALPOT(JX,JY,MULPOL,KARTEZ,IWSIDE) = 0.0D0
C
                  END DO
               END DO
C
C=======================================================================
C              LOOPS OVER TWO-DIMENSIONAL POSITIONS ON THE WALL
C=======================================================================
C
               DO INDETX=1,NUMETA
C
                  SIMPSX=2*(MOD(INDETX,2)+1)/3.0D0
                  ETA=-BOUCOU+STEPET*INDETX
                  POSTIO(KARTEX)=ETA / HOMSCA(KARTEX) / SQ2
C
                  DO INDETY=1,NUMETA
C
                     SIMPSY=2*(MOD(INDETY,2)+1)/3.0D0
                     ETA=-BOUCOU+STEPET*INDETY
                     POSTIO(KARTEY)=ETA / HOMSCA(KARTEY) / SQ2
C
C=======================================================================
C         CALCULATING THE  SOLID HARMONICS  AT THE GIVEN POSITION ON THE
C         GIVEN WALL. FOR  NON-NEGATIVE  (NEGATIVE) VALUES OF  "MIU"  WE
C         CALCULATE THE REAL (IMAGINARY)  PARTS OF THE  SOLID  HARMONICS
C         FOR NIU=ABS(MIU).
C=======================================================================
C
                     IF (MIU.GE.0) THEN
C
                         IMAREA=+1
                         NIU   = MIU
                     ELSE
                         IMAREA=-1
                         NIU   =-MIU
C
                     END IF
C
                     CALL SOLHAR(REHARM,LAMBDA,NIU,POSTIO,IMAREA)
C
C=======================================================================
C         CALCULATING THE COULOMB POTENTIAL AT THE GIVEN POSITION ON THE
C         GIVEN WALL AND CORRESPONDING TO THE GIVEN MULTIPOLE  COMPONENT
C=======================================================================
C
                     DISWAL=SQRT(   POSTIO(1)**2
     *                            + POSTIO(2)**2
     *                            + POSTIO(3)**2 )
C
                     REHARM=REHARM/DISWAL**LAMBDA
C
                     POTWAL = 4.0*PI * REHARM
     *                               / DISWAL**(LAMBDA+1) / (2*LAMBDA+1)
C
                     POTWAL = SIMPSX * SIMPSY * POTWAL
C
C=======================================================================
C                    LOOPS OVER TWO FOURIER INDICES ON THE WALL
C=======================================================================
C
                     DO JX = 0,NUMCOU
                        DO JY = 0,NUMCOU
C
                           WALPOT(JX,JY,MULPOL,KARTEZ,IWSIDE) =
     *                     WALPOT(JX,JY,MULPOL,KARTEZ,IWSIDE)
     *
     *                                    +  POTWAL *  FOURIE(JX,INDETX)
     *                                              *  FOURIE(JY,INDETY)
                        END DO
                     END DO
C
C=======================================================================
C                   END LOOPS OVER TWO-DIMENSIONAL POSITIONS ON THE WALL
C=======================================================================
C
                  END DO
               END DO
C
C=======================================================================
C              NORMALIZING FOURIER INTEGRALS
C=======================================================================
C
               FACTOR = ((2*BOUCOU)/(NUMETA+1))**2 /
     *                  ( 4*BOUCOU *SQRT(HOMSCA(KARTEX)*HOMSCA(KARTEY)))
C
               DO JX = 0,NUMCOU
                  DO JY = 0,NUMCOU
C
                     WALPOT(JX,JY,MULPOL,KARTEZ,IWSIDE) =
     *               WALPOT(JX,JY,MULPOL,KARTEZ,IWSIDE) * FACTOR
C
                  END DO
               END DO
C
C=======================================================================
C              END LOOP OVER MULTIPOLES
C=======================================================================
C
            END DO
C
C=======================================================================
C           CALCULATING FACTORS WHICH DEPEND ON WALLS
C=======================================================================
C
            FACTOR=SQRT(HOMSCA(KARTEZ)**3)
C
            DO JZ = 0,NUMCOU
C
               RESULT = FACTOR * (JZ+1) * (-1)**(JZ/2)
C
               IF (IWSIDE.EQ.0.AND.MOD(JZ,2).EQ.1) RESULT=- RESULT
C
               WALFAC(JZ,KARTEZ,IWSIDE)=RESULT
C
            END DO
C
C=======================================================================
C           END LOOPS OVER DIRECTIONS AND SIDES
C=======================================================================
C
         END DO
      END DO
C
C=======================================================================
C
      CALL CPUTIM('POWALL',0)
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE DEFCOU(NOSCIL,NUMCOU,BOUCOU)
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      DIMENSION
     *          PHERMI(ND2MAX+1),DHERMI(ND2MAX+1)
C
      COMMON
     *       /FACHER/ HERFAC(0:ND2MAX)
      COMMON
     *       /BFACTO/ BFOURI(0:NDCOUL,0:ND2MAX)
      COMMON
     *       /CFIPRI/ NFIPRI
C
C=======================================================================
C         THIS SUBROUTINE CALCULATES THE FOURIER INTEGRATION AUXILIARY
C         B-FACTORS (SEE NOTES)
C=======================================================================
C
      IF (NUMCOU.GT.NDCOUL) THEN
C
         WRITE(NFIPRI,'(//,1X,''NUMCOU='',I2,'' .GT. NDCOUL='',I2,
     *                         ''   STOP IN DEFCOU'',//)') NUMCOU,NDCOUL
         STOP ' NUMCOU.GT.NDCOUL  IN  DEFCOU'
C
      END IF
C
C=======================================================================
C        DEFINING THE VALUES OF THE HERMITE POLYNOMIALS AT FOURIER
C        INTEGRATION POINTS
C=======================================================================
C
      NMAIN2=2*NOSCIL
C
      PI   =4.0D0*ATAN(1.0D0)
      SQ2PI=SQRT(2.0D0*PI)
      STEP =PI/(2.0D0*BOUCOU)
C
      DO IFOURI = 0,NUMCOU
C
         XFOURI = STEP * (IFOURI+1)
C
         CALL D_HERM(XFOURI,NMAIN2,PHERMI,DHERMI,ND2MAX+1)
C
         IPACOU=MOD(IFOURI,2)
C
         DO KOSCIL = 0,NMAIN2
C
            IF (MOD(KOSCIL,2).EQ.IPACOU) THEN
C
               BFOURI(IFOURI,KOSCIL) = PHERMI(KOSCIL+1)/HERFAC(KOSCIL)
     *                               * EXP(-XFOURI*XFOURI/2.0D0)
     *                               * (-1)**(KOSCIL/2)
     *                               * SQ2PI
            ELSE
C
               BFOURI(IFOURI,KOSCIL) = 0.0D0
C
            END IF
C
         END DO
C
      END DO
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE DEVMUL(NOSACT,NGAUSS,KARTEZ,NMUPOW)
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      COMMON
     *       /COEMUL/ COMULT(0:NDMULT,0:NDOSCI,0:NDOSCI,1:NDKART)
      COMMON
     *       /COEDER/ CODERI(1:NDDERI,0:NDOSCI,0:NDOSCI,1:NDKART)
      COMMON
     *       /COESCA/ COSCAL(1:NDSCAL,0:NDOSCI,0:NDOSCI,1:NDKART)
      COMMON
     *       /COEMAG/ COGRAD(0:NDMULT,0:NDOSCI,0:NDOSCI,1:NDKART)
      COMMON
     *       /HERMEM/ HERONE(0:ND2MAX,1:NDGAUS,1:NDKART)
      COMMON
     *       /DIVMEM/ DHRONE(0:ND2MAX,1:NDGAUS,1:NDKART),
     *                DDHONE(0:ND2MAX,1:NDGAUS,1:NDKART)
      COMMON
     *       /INTMEM/ TWOWGT(1:NDGAUS,1:NDKART),
     *                TWOPNT(1:NDGAUS,1:NDKART)
      COMMON
     *       /SCALNG/ HOMSCA(NDKART)
C
C=======================================================================
C
C         THIS ROUTINE PERFORMS INTEGRATION OF THE MATRIX  ELEMENTS
C         OF POWERS OF POSITION VARIABLES WITH  HERMITE POLYNOMIALS
C
C         INT DX  H (N,X)  *  X**K  *  H  (M,X)   =   COMULT(K,N,M)
C
C         IT ALSO      PERFORMS INTEGRATION OF THE MATRIX  ELEMENTS
C         OF POWERS OF GRADIENT OPERATORS WITH  HERMITE POLYNOMIALS
C
C         INT DX  H (N,X)  *  D**K  *  H  (M,X)   =   CODERI(K,N,M)
C
C         IT ALSO      PERFORMS INTEGRATION OF THE MATRIX  ELEMENTS
C         OF POWERS OF SCALING  OPERATORS WITH  HERMITE POLYNOMIALS
C
C         INT DX  H (N,X)  *(X*D)**K*  H  (M,X)   =   COSCAL(K,N,M)
C
C         IT ALSO      PERFORMS INTEGRATION OF THE MATRIX  ELEMENTS
C         OF POWERS OF POSITIONS*GRADIENT WITH  HERMITE POLYNOMIALS
C
C         INT DX  H (N,X)  *(X**K)*D*  H  (M,X)   =   COGRAD(K,N,M)
C
C         WHERE:
C
C         H(N,X) IS THE HERMITE POLYNOMIAL OF THE ORDER  N AT POINT
C                   X ASSUMED TO BE NORMALIZED TO 1 WHEN ITS SQUARE
C                   IS INTEGRATED WITH EXP(-X**2).
C
C         NOSACT IS THE MAXIMUM ORDER OF  THE  HERMITE  POLYNOMIALS
C                   USED IN THE CODE.
C
C         H(N,X) HAS THE MAXIMUM ORDER = NOSACT
C
C         THE COEFFICIENTS  COMULT  ARE FOUND BY EXPLICIT  NUMERICAL
C                        G A U S S - H E R M I T E
C         INTEGRATION OF PRODUCTS APPEARING IN THE ABOVE INTEGRANDS.
C         THE ONE-BODY INTEGRATION WEIGHTS AND POINTS ARE USED.
C
C=======================================================================
C        INTEGRATION OF POWERS OF POSITIONS
C=======================================================================
C
      DO N=0,NOSACT
         DO M=0,NOSACT
            DO K=0,NMUPOW
C
               RESULT=0.0D0
C
               DO IGAUSS=1,NGAUSS
C
                  RESULT=RESULT+  TWOWGT(IGAUSS,KARTEZ)
     *                         *HERONE(N,IGAUSS,KARTEZ)
     *                         *HERONE(M,IGAUSS,KARTEZ)
     *                         *  TWOPNT(IGAUSS,KARTEZ)**K
C
               END DO
C
               COMULT(K,N,M,KARTEZ)=RESULT
C
            END DO
         END DO
      END DO
C
C=======================================================================
C        INTEGRATION OF POWERS OF GRADIENTS
C=======================================================================
C
      DO N=0,NOSACT
         DO M=0,NOSACT
C
            RESULT=0.0D0
C
            DO IGAUSS=1,NGAUSS
C
               RESULT=RESULT+  TWOWGT(IGAUSS,KARTEZ)
     *                      *HERONE(N,IGAUSS,KARTEZ)
     *                      *DHRONE(M,IGAUSS,KARTEZ)
C
            END DO
C
            CODERI(1,N,M,KARTEZ)=RESULT
C
            RESULT=0.0D0
C
            DO IGAUSS=1,NGAUSS
C
               RESULT=RESULT+  TWOWGT(IGAUSS,KARTEZ)
     *                      *HERONE(N,IGAUSS,KARTEZ)
     *                      *DDHONE(M,IGAUSS,KARTEZ)
C
            END DO
C
            CODERI(2,N,M,KARTEZ)=RESULT
C
         END DO
      END DO
C
C=======================================================================
C        INTEGRATION OF POWERS OF SCALING OPERATORS
C=======================================================================
C
      DO N=0,NOSACT
         DO M=0,NOSACT
C
            RESULT=0.0D0
C
            DO IGAUSS=1,NGAUSS
C
               RESULT=RESULT+  TWOWGT(IGAUSS,KARTEZ)
     *                      *HERONE(N,IGAUSS,KARTEZ)
     *                      *DHRONE(M,IGAUSS,KARTEZ)
     *                      *  TWOPNT(IGAUSS,KARTEZ)
C
            END DO
C
            COSCAL(1,N,M,KARTEZ)=RESULT
C
         END DO
      END DO
C
C=======================================================================
C        INTEGRATION OF POWERS OF POSITIONS TIMES GRADIENT
C=======================================================================
C
      DO N=0,NOSACT
         DO M=0,NOSACT
            DO K=0,NMUPOW
C
               RESULT=0.0D0
C
               DO IGAUSS=1,NGAUSS
C
                  RESULT=RESULT+  TWOWGT(IGAUSS,KARTEZ)
     *                         *HERONE(N,IGAUSS,KARTEZ)
     *                         *DHRONE(M,IGAUSS,KARTEZ)
     *                         *  TWOPNT(IGAUSS,KARTEZ)**K
C
               END DO
C
               COGRAD(K,N,M,KARTEZ)=RESULT
C
            END DO
         END DO
      END DO
C
C=======================================================================
C       THE CODE USES  UNDIMENSIONED  POSITION  VARIABLES.
C       THEREFORE, THE COEFFICIENTS COMULT ARE HERE SCALED
C       BY APPROPRIATE  FACTORS WHICH  TAKE  INTO  ACCOUNT
C       THESE  DIMENSIONS.  THEREFORE, THESE  COEFFICIENTS
C       CONTAIN DIMENSIONED MATRIX  ELEMENTS  OF  POSITION
C       VARIABLES.  SIMILARLY,  THE  COEFFICIENTS   CODERI
C       CONTAIN DIMENSIONED MATRIX ELEMENTS OF  GRADIENTS,
C       BECAUSE IN DEFINT THE DHRONE  AND  DDHONE   ARRAYS
C       HAVE BEEN MULTIPLIED BY THE  APPROPRIATE  FACTORS.
C=======================================================================
C
      DO N=0,NOSACT
         DO M=0,NOSACT
            DO K=0,NMUPOW
C
               COMULT(K,N,M,KARTEZ)=COMULT(K,N,M,KARTEZ)
     *                                   /HOMSCA(KARTEZ)**K
            END DO
         END DO
      END DO
C
C=======================================================================
C
      DO N=0,NOSACT
         DO M=0,NOSACT
C
            COSCAL(1,N,M,KARTEZ)=COSCAL(1,N,M,KARTEZ)
     *                                /HOMSCA(KARTEZ)
C
         END DO
      END DO
C
C=======================================================================
C
      DO N=0,NOSACT
         DO M=0,NOSACT
            DO K=0,NMUPOW
C
               COGRAD(K,N,M,KARTEZ)=COGRAD(K,N,M,KARTEZ)
     *                                   /HOMSCA(KARTEZ)**K
            END DO
         END DO
      END DO
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE ADJBAS(FCHOM0,IN_FIX,IZ_FIX)
C=======================================================================
      USE hfodd_sizes
C=======================================================================
C
      COMMON
     *       /QCNSTR/ STIFFQ(0:NDMULT,-NDMULT:NDMULT),
     *                QASKED(0:NDMULT,-NDMULT:NDMULT),
     *                IFLAGQ(0:NDMULT,-NDMULT:NDMULT)
      COMMON
     *       /REALPH/ ALPHAR(0:NDLAMB,0:NDLAMB)
C
      DATA
     *        HBOM00 / 41.0 /
C
C=======================================================================
C
C            AUTOMATIC ADJUSTMENT OF BASIS CHARACTERISTICS
C
C      N.B. CURRENT VALUES ARE VERY PRIMITIVE AND ARE *NOT* BASED ON A
C           RIGOROUS BASIS STUDY BUT INSTEAD OF SOME PRE-COOKED FORMULA
C           WITH ASSUMED CORRECT ASYMPTOTICS... (SCHUNCK, 28/04/2011)
C
C=======================================================================
C
      Q2_VAL=QASKED(2,0)
C
C       This value comes from Javid. Sheikh
c      OMEGA0=0.08177491*EXP(-0.02256042*Q2_VAL)*(Q2_VAL-1.71901348)
c     *      +7.16688268
C
C      Cut-off: if the requested deformation is too weak we keep omega
C               at the value for Q2=30 barns,
c                  omega0 = 8.1464 = 0.1*EXP(-0.02*30)*30+6.5
C
      IF (ABS(Q2_VAL).GT.30.0) THEN
          OMEGA0=0.1*EXP(-0.02*Q2_VAL)*Q2_VAL+6.5
      ELSE
          OMEGA0=8.1464
      END IF
C
      A_MASS=REAL(IN_FIX+IZ_FIX,KIND=8)
      FCHOM0=OMEGA0 / (41.0/(A_MASS**(1.0/3.0)))
C
      DO LAMBDA=0,NDLAMB
         DO MIU=0,NDLAMB
            ALPHAR(LAMBDA,MIU)=0.0
         END DO
      END DO
C
C       This value comes from Javid. Sheikh
c      ALPHAR(2,0)=0.05306369*SQRT(Q2_VAL)
C
      ALPHAR(2,0)=0.05*SQRT(Q2_VAL)
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE GEOMFC(INNUMB,IZNUMB,FCHOM0,R0PARM,HOMEGA,
     *                                LAMMAX,ISOTRO,CVOLFC,
     *                                CMSXFC,CMSYFC,CMSZFC,
     *                                XMOMFC,YMOMFC,ZMOMFC)
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      COMPLEX
     *          ALPHAC(0:NDLAMB,-NDLAMB:+NDLAMB)
C
      COMMON
     *       /REALPH/ ALPHAR(0:NDLAMB,0:NDLAMB)
      COMMON
     *       /BASPAR/ HBAROX,HBAROY,HBAROZ
      COMMON
     *       /BASE_2/ BASEX2,BASEY2,BASEZ2
      COMMON
     *       /DEFORM/ ALPHAC,IREALA
      COMMON
     *       /LIMITL/ LAMAUX
      COMMON
     *       /CFIPRI/ NFIPRI
C
      DATA
     *        HBOM00 / 41.0D0 /
C
C=======================================================================
C
C        THIS SUBROUTINE CALCULATES THE GEOMETRICAL FACTORS RELATED
C        TO THE  DEFINITION OF THE NUCLEAR SURFACE  IN TERMS OF THE
C        SPHERICAL HARMONICS AND DERIVES THE CORRESPONDING HARMONIC
C        OSCILLATOR FREQUENCIES
C
C        A) HBAROX,HBAROY,HBAROZ =>> DERIVED OSCILLATOR FREQUENCIES
C
C        B) CMSXFC,CMSYFC,CMSZFC =>> COORDINATES OF  CENTER OF MASS
C
C        C) XMOMFC,YMOMFC,ZMOMFC =>> CLASSICAL  MOMENTS  OF INERTIA
C
C=======================================================================
C
C        M E A N I N G  O F  S O M E  I N P U T  P A R A M E T E R S
C
C=======================================================================
C
C        A) THE NUCLEUS:
C
C        INNUMB, IZNUMB => THE N- AND THE Z-NUMBERS  OF  THE NUCLEUS
C                          FOR WHICH THE SURFACE IS DEFINED.
C
C        B) ITS DEFORMATION:
C
C        ALPHAR,        => A REAL  ARRAY  SPECIFYING THE NUCLEAR DE-
C                          FORMATIONS IN TERMS OF THE SPHERICAL HAR-
C                          MONICS. THE INTEGER PARAMETER "IREALA" IS
C                          EXPLICITLY SET TO  1  TO SPECIFY THAT THE
C                          DEFORMATIONS ARE REAL.
C
C        LAMMAX   => => => THE MAXIMUM MULTIPOLARITY  OF THE DEFORM.
C                          IN QUESTION (THE HIGHEST ORDER OF Y_LM'S)
C
C
C        C) THE RADIUS  P A R A M E T E R:
C
C        R0PARM   => => => THE RADIUS IS EQUAL TO R0PARM*A**(1/3) FM
C
C
C        D) PRECISION OF THE INTEGRATIONS IN GAUSS-LEGENDRE FORMULAS
C
C        N1POIN, N2POIN => THE NUMBER OF GAUSS INTEGRATION POINTS IN
C                          ONE (E.G.THETA) AND THE SECOND (E.G. PHI)
C                          DIRECTIONS
C
C=======================================================================
C
C        ATTENTION: IN THE WOODS - SAXON CALCULATIONS THE OSCILLATOR
C        FREQUENCIES ARE  CONVENIENTLY  MULTIPLIED  BY AN ADDITIONAL
C        FACTOR DENOTED
C                                 FCHOM0 ~ 1.20
C
C        WHICH ALLOWS TO DECREASE THE NUMBER OF THE  HO BASIS STATES.
C        THIS IS EQUIVALENT TO AN "AD HOC" OPTIMIZATION OF THE BASIS
C        WHICH MAY OR MAY NOT HAVE THE SAME MEANING IN THE H.F. CASE
C
C=======================================================================
C
      ZERO=0.0D0
C
      A_MASS=REAL(INNUMB+IZNUMB,KIND=8)
C
      HOMEGA=HBOM00*FCHOM0/A_MASS**(1.0D0/3.0D0)
C
      IREALA=1
C
      DO L=0,NDLAMB
         DO M=0,L
            ALPHAC(L, M)=        CMPLX(ALPHAR(L,M),ZERO)
            ALPHAC(L,-M)=(-1)**M*CMPLX(ALPHAR(L,M),ZERO)
         END DO
      END DO
C
      N1POIN=14
      N2POIN=14
C
C=======================================================================
C
      CALL LIMITY(ALPHAC,LAMMAX)
C
      IF (LAMMAX.GT.0) ISOTRO=0
      IF (LAMMAX.EQ.0) ISOTRO=1
C
C=======================================================================
C          ATTENTION: IN THIS SUBROUTINE LAMMAX VALUE IS TRANSFERRED
C                     INTO THE  COMMON BLOCK  UNDER THE NAME LAMAUX.
C                     THIS IS TO AVOID THE SAME VARIABLE NAME AS THE
C                     ONE APPEARING IN THE SUBROUTINE HEAD
C=======================================================================
C
      LAMAUX=LAMMAX
C
C=======================================================================
C
      CALL LOADIN(LAMMAX)
C
C=======================================================================
C
      CALL GEOMFR(R0PARM,CMSXFC,CMSYFC,CMSZFC,
     *            CVOLFC,XMOMFC,YMOMFC,ZMOMFC,
     *            HOMEGA,BASEX2,BASEY2,BASEZ2,
     *                          INNUMB,IZNUMB,
     *                          N1POIN,N2POIN,
     *                                 LAMMAX)
C
C=======================================================================
C         THE FOURTH AUXILIARY TABLE: ''ACTUAL RUN CONDITIONS''
C=======================================================================
C
      CALL DEFPRI(LAMMAX,INNUMB,IZNUMB)
C
C=======================================================================
C
      WRITE(NFIPRI,'(1H*,77X,1H*,/,
     *          1H*,43X,''HOMEGA='',F8.4,2X,''FCHOM0='',F8.4,2X,1H*,/,
     *                                                   1H*,77X,1H*,/,
     *          1H*, 2X,''OSCILLATOR FREQUENCIES:'',1X,
     *                                       ''HBAROX='',F8.4,2X,
     *                                       ''HBAROY='',F8.4,2X,
     *                                       ''HBAROZ='',F8.4,2X,1H*)')
     *
     *                               HOMEGA,FCHOM0,HBAROX,HBAROY,HBAROZ
C
      WRITE(NFIPRI,'(1H*,77X,1H*,/,
     *          1H*,2X,''MOMENTS OF INERTIA:   '',2X,
     *                                       ''XMOMFC='',F8.4,2X,
     *                                       ''YMOMFC='',F8.4,2X,
     *                                       ''ZMOMFC='',F8.4,2X,1H*)')
     *
     *                                             XMOMFC,YMOMFC,ZMOMFC
C
      WRITE(NFIPRI,'(1H*,77X,1H*,/,
     *          1H*,2X,''CENTERS OF MASS:   '',5X,
     *                                       ''CMSXFC='',F8.4,2X,
     *                                       ''CMSYFC='',F8.4,2X,
     *                                       ''CMSZFC='',F8.4,2X,1H*,/,
     *                                       1H*,77X,1H*,/,79(1H*),/)')
     *
     *                                             CMSXFC,CMSYFC,CMSZFC
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE GEOMFR(R0PARM,CMSXFC,CMSYFC,CMSZFC,
     *                  CVOLFC,XMOMFC,YMOMFC,ZMOMFC,
     *                  HOMEGA,BASEX2,BASEY2,BASEZ2,
     *                                INNUMB,IZNUMB,
     *                                N1POIN,N2POIN,
     *                                       LAMMAX)
C
      EXTERNAL
     *         CVOLFN,XMASFN,YMASFN,ZMASFN,BASXFN,BASYFN,BASZFN,
     *                                     XMOMFN,YMOMFN,ZMOMFN
      COMMON
     *       /BASPAR/ HBAROX,HBAROY,HBAROZ
      COMMON
     *       /PHYCON/ H_BARC,XMASSP,XMASSN,HBCOE2
C
C=======================================================================
C
C         THIS SUBROUTINE CALCULATES THE GEOMETRICAL AUXILIARY FACTORS
C
C         1. CVOLFC - VOLUME CONSERVATION FACTOR
C
C         2. CMSXFC - POSITION OF THE CENTER OF MASS  (X - PROJECTION)
C         3. CMSYFC - POSITION OF THE CENTER OF MASS  (Y - PROJECTION)
C         4. CMSZFC - POSITION OF THE CENTER OF MASS  (Z - PROJECTION)
C
C         5. XMOMFC - MOMENT OF INERTIA  WITH RESPECT  TO  X - A X I S
C         6. YMOMFC - MOMENT OF INERTIA  WITH RESPECT  TO  Y - A X I S
C         7. ZMOMFC - MOMENT OF INERTIA  WITH RESPECT  TO  Z - A X I S
C
C         8. BASEX2 - THE BASIS S T R E T C H I N G FACTOR X - A X I S
C         9. BASEY2 - THE BASIS S T R E T C H I N G FACTOR Y - A X I S
C        10. BASEZ2 - THE BASIS S T R E T C H I N G FACTOR Z - A X I S
C
C=======================================================================
C
      PI=4.0D0*ATAN(1.0D0)
      A_MASS=REAL(INNUMB+IZNUMB,KIND=8)
C
      VOLUM0=4.0D0/3.0D0*PI*R0PARM**3*A_MASS
C
      XMASS0=REAL(IZNUMB,KIND=8)*XMASSP+REAL(INNUMB,KIND=8)*XMASSN
C
      DENS0 =XMASS0/VOLUM0/H_BARC**2
C
      RADIUS=R0PARM*A_MASS**(1.0D0/3.0D0)
C
C=======================================================================
C
      XLOW=0.0D0
      YLOW=0.0D0
C
      XUPP=PI
      YUPP=2.0D0*PI
C
C=======================================================================
C         C O N S T A N T      V O L U M E      C O N D I T I O N
C=======================================================================
C
      CALL Q2GAUS(N1POIN,N2POIN,XLOW,XUPP,YLOW,YUPP,CVOLFN,RESULT)
C
      F=RESULT/4.0D0/PI
C
      CVOLFC=1.0D0/F**(1.0D0/3.0D0)
C
C=======================================================================
C         C E N T R E   O F   M A S S   ( C O O R D I N A T E   X)
C=======================================================================
C
      CALL Q2GAUS(N1POIN,N2POIN,XLOW,XUPP,YLOW,YUPP,XMASFN,RESCMX)
C
      CMSXFC=0.25D0*(CVOLFC*RADIUS)**4/VOLUM0*RESCMX
C
C=======================================================================
C         C E N T R E   O F   M A S S   ( C O O R D I N A T E   Y)
C=======================================================================
C
      CALL Q2GAUS(N1POIN,N2POIN,XLOW,XUPP,YLOW,YUPP,YMASFN,RESCMY)
C
      CMSYFC=0.25D0*(CVOLFC*RADIUS)**4/VOLUM0*RESCMY
C
C=======================================================================
C         C E N T R E   O F   M A S S   ( C O O R D I N A T E   Z)
C=======================================================================
C
      CALL Q2GAUS(N1POIN,N2POIN,XLOW,XUPP,YLOW,YUPP,ZMASFN,RESCMZ)
C
      CMSZFC=0.25D0*(CVOLFC*RADIUS)**4/VOLUM0*RESCMZ
C
C=======================================================================
C         BASIS:  X - S T R E T C H I N G   C O E F F I C I E N T
C=======================================================================
C
      CALL Q2GAUS(N1POIN,N2POIN,XLOW,XUPP,YLOW,YUPP,BASXFN,RESBX2)
C
      BASEX2=(CVOLFC*RADIUS)**5/VOLUM0/5.0D0*RESBX2
C
C=======================================================================
C         BASIS:  X - S T R E T C H I N G   C O E F F I C I E N T
C=======================================================================
C
      CALL Q2GAUS(N1POIN,N2POIN,XLOW,XUPP,YLOW,YUPP,BASYFN,RESBY2)
C
      BASEY2=(CVOLFC*RADIUS)**5/VOLUM0/5.0D0*RESBY2
C
C=======================================================================
C         BASIS:  X - S T R E T C H I N G   C O E F F I C I E N T
C=======================================================================
C
      CALL Q2GAUS(N1POIN,N2POIN,XLOW,XUPP,YLOW,YUPP,BASZFN,RESBZ2)
C
      BASEZ2=(CVOLFC*RADIUS)**5/VOLUM0/5.0D0*RESBZ2
C
C=======================================================================
C         T H E   M O M E N T   O F   I N E R T I A  (COMPONENT X)
C=======================================================================
C
      CALL Q2GAUS(N1POIN,N2POIN,XLOW,XUPP,YLOW,YUPP,XMOMFN,RESXMT)
C
      XMOMFC=DENS0*(CVOLFC*RADIUS)**5/5.0D0*RESXMT
C
C=======================================================================
C         T H E   M O M E N T   O F   I N E R T I A  (COMPONENT Y)
C=======================================================================
C
      CALL Q2GAUS(N1POIN,N2POIN,XLOW,XUPP,YLOW,YUPP,YMOMFN,RESYMT)
C
      YMOMFC=DENS0*(CVOLFC*RADIUS)**5/5.0D0*RESYMT
C
C=======================================================================
C         T H E   M O M E N T   O F   I N E R T I A  (COMPONENT Z)
C=======================================================================
C
      CALL Q2GAUS(N1POIN,N2POIN,XLOW,XUPP,YLOW,YUPP,ZMOMFN,RESZMT)
C
      ZMOMFC=DENS0*(CVOLFC*RADIUS)**5/5.0D0*RESZMT
C
C=======================================================================
C         CALCULATING THE H_BAR*OMEGA FACTORS FOR THE HO BASIS
C=======================================================================
C
      RXY=SQRT(BASEX2/BASEY2)
      RYZ=SQRT(BASEY2/BASEZ2)
      RXZ=SQRT(BASEX2/BASEZ2)
C
      HBAROX=HOMEGA*(RXY*RXZ)**(-1.0D0/3.0D0)
      HBAROY=HOMEGA*(RXY/RYZ)**(+1.0D0/3.0D0)
      HBAROZ=HOMEGA*(RXZ*RYZ)**(+1.0D0/3.0D0)
C
      IF (LAMMAX.EQ.0) THEN
C
          HBAROY=HBAROX
          HBAROZ=HBAROX
C
      END IF
C
      RETURN
      END
C
      FUNCTION CVOLFN(THETA,PHI)
C
      CALL FORMFN(THETA,PHI,R)
C
      CVOLFN=R**3*SIN(THETA)
C
      RETURN
      END
C
      FUNCTION ZMASFN(THETA,PHI)
C
      CALL FORMFN(THETA,PHI,R)
C
      ZMASFN=R**4*SIN(THETA)*COS(THETA)
C
      RETURN
      END
C
      FUNCTION YMASFN(THETA,PHI)
C
      CALL FORMFN(THETA,PHI,R)
C
      YMASFN=R**4*SIN(THETA)**2*SIN(PHI)
C
      RETURN
      END
C
      FUNCTION XMASFN(THETA,PHI)
C
      CALL FORMFN(THETA,PHI,R)
C
      XMASFN=R**4*SIN(THETA)**2*COS(PHI)
C
      RETURN
      END
C
      FUNCTION BASZFN(THETA,PHI)
C
      CALL FORMFN(THETA,PHI,R)
C
      BASZFN=R**5*COS(THETA)**2*SIN(THETA)
C
      RETURN
      END
C
      FUNCTION BASYFN(THETA,PHI)
C
      CALL FORMFN(THETA,PHI,R)
C
      BASYFN=R**5*SIN(THETA)**3*SIN(PHI)**2
C
      RETURN
      END
C
      FUNCTION BASXFN(THETA,PHI)
C
      CALL FORMFN(THETA,PHI,R)
C
      BASXFN=R**5*SIN(THETA)**3*COS(PHI)**2
C
      RETURN
      END
C
      FUNCTION ZMOMFN(THETA,PHI)
C
      CALL FORMFN(THETA,PHI,R)
C
      ZMOMFN=R**5*SIN(THETA)**3
C
      RETURN
      END
C
      FUNCTION YMOMFN(THETA,PHI)
C
      CALL FORMFN(THETA,PHI,R)
C
      YMOMFN=R**5*(SIN(THETA)**2*COS(PHI)**2+COS(THETA)**2)*SIN(THETA)
C
      RETURN
      END
C
      FUNCTION XMOMFN(THETA,PHI)
C
      CALL FORMFN(THETA,PHI,R)
C
      XMOMFN=R**5*(SIN(THETA)**2*SIN(PHI)**2+COS(THETA)**2)*SIN(THETA)
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE FORMFN(THETA,PHI,RESULT)
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      COMPLEX
     *          ALPHAC(0:NDLAMB,-NDLAMB:+NDLAMB)
      COMPLEX
     *          F
      COMPLEX
     *          YLM  (0:NDLAMB,-NDLAMB:+NDLAMB),
     *          YLMT (0:NDLAMB,-NDLAMB:+NDLAMB),
     *          YLMF (0:NDLAMB,-NDLAMB:+NDLAMB),
     *          YLMTT(0:NDLAMB,-NDLAMB:+NDLAMB),
     *          YLMTF(0:NDLAMB,-NDLAMB:+NDLAMB),
     *          YLMFF(0:NDLAMB,-NDLAMB:+NDLAMB)
C
      COMMON
     *       /ALINFO/ LAMACT(0:NDLAMB),MIUACT(0:NDLAMB,-NDLAMB:+NDLAMB)
      COMMON
     *       /YLDERI/ YLM,YLMT,YLMF,YLMTT,YLMTF,YLMFF
      COMMON
     *       /DEFORM/ ALPHAC,IREALA
      COMMON
     *       /LIMITL/ LAMMAX
C
C=======================================================================
C         THIS SUBROUTINE CALCULATES THE FORM-FUNCTION =(1+SUM ALFA*Y)
C=======================================================================
C
      LEVEL=0
C
      CALL ZEROYL(YLM,YLMT,YLMF,YLMTT,YLMTF,YLMFF,LAMMAX,LEVEL)
C
      DO LAMBDA=0,LAMMAX
C
         IF (LAMACT(LAMBDA).LT.0) GO TO 1
C
         DO MIU=0,LAMBDA
C
            IF (MIUACT(LAMBDA,MIU).LT.-99) GO TO 2
C
            CALL YL_MIU(YLM,YLMT,YLMF,YLMTT,YLMTF,YLMFF,
     *                       LAMBDA,MIU,THETA,PHI,LEVEL)
   2        CONTINUE
C
         END DO
   1     CONTINUE
      END DO
C
      F=CMPLX(0.0D0,0.0D0)
C
C=======================================================================
C         S U M M I N G    U P   T H E   ALPHA* TIMES YLM  T E R M S
C=======================================================================
C
      DO LAMBDA=0,LAMMAX
         DO MIU=-LAMBDA,+LAMBDA
C
            F=F+CONJG(ALPHAC(LAMBDA,MIU))*YLM(LAMBDA,MIU)
C
         END DO
      END DO
C
      RESULT=1.0D0+REAL(F)
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE Q2GAUS(N1POIN,N2POIN,XL,XU,YL,YU,F,RESULT)
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      DIMENSION
     *          XG4 (ND04),WT4 (ND04),
     *          XG8 (ND08),WT8 (ND08),
     *          XG12(ND12),WT12(ND12),
     *          XG16(ND16),WT16(ND16),
     *          XG32(ND32),WT32(ND32),
     *          XG64(ND64),WT64(ND64),INDEX(6)
C
      DIMENSION
     *          XPOINT(NDMAX),YPOINT(NDMAX),XWEIGH(NDMAX),YWEIGH(NDMAX)
C
      EXTERNAL
     *         F
C
      DATA
     *         INDEX / 4, 8, 12, 16, 32, 64 /
C
C=======================================================================
C          POINTS AND WEIGHTS FOR THE '4-POINT' GAUSS QUADRATURES
C=======================================================================
C
      DATA XG4
     *
     *          / .339981043584856D0,  .861136311594053D0/
C
      DATA WT4
     *
     *          / .652145154862546D0,  .347854845137454D0/
C
C=======================================================================
C          POINTS AND WEIGHTS FOR THE '8-POINT' GAUSS QUADRATURES
C=======================================================================
C
      DATA XG8
     *
     *         / .18343464249564981D0, .52553240991632899D0,
     *           .79666647741362674D0, .96028985649753623D0/
C
      DATA WT8
     *
     *         / .36268378337836199D0, .31370664587788729D0,
     *           .22238103445337447D0, .10122853629037627D0/
C
C=======================================================================
C          POINTS AND WEIGHTS FOR THE '12-POINT' GAUSS QUADRATURES
C=======================================================================
C
      DATA XG12
     *
     *        / .12523340851146892D0, .36783149899818019D0,
     *          .58731795428661745D0, .76990267419430469D0,
     *          .90411725637047486D0, .98156063424671925D0/
C
      DATA WT12
     *
     *       / .24914704581340279D0, .23349253653835481D0,
     *         .20316742672306592D0, .16007832854334623D0,
     *         .10693932599531843D0, .04717533638651182D0/
C
C=======================================================================
C          POINTS AND WEIGHTS FOR THE '16-POINT' GAUSS QUADRATURES
C=======================================================================
C
      DATA XG16
     *
     *         / .09501250983763744D0, .28160355077925891D0,
     *           .45801677765722739D0, .61787624440264375D0,
     *           .75540440835500304D0, .86563120238783174D0,
     *           .94457502307323258D0, .98940093499164993D0/
      DATA WT16
     *
     *         / .18945061045506850D0, .18260341504492359D0,
     *           .16915651939500254D0, .14959598881657673D0,
     *           .12462897125553387D0, .09515851168249278D0,
     *           .06225352393864789D0, .02715245941175408D0/
C
C=======================================================================
C          POINTS AND WEIGHTS FOR THE '32-POINT' GAUSS QUADRATURES
C=======================================================================
C
      DATA XG32
     *
     *          / .04830766568773832D0, .14447196158279649D0,
     *            .23928736225213708D0, .33186860228212765D0,
     *            .42135127613063535D0, .50689990893222939D0,
     *            .58771575724076233D0, .66304426693021520D0,
     *            .73218211874028968D0, .79448379596794241D0,
     *            .84936761373256997D0, .89632115576605213D0,
     *            .93490607593773969D0, .96476225558750643D0,
     *            .98561151154526834D0, .99726386184948156D0/
      DATA WT32
     *
     *          / .09654008851472780D0, .09563872007927486D0,
     *            .09384439908080457D0, .09117387869576389D0,
     *            .08765209300440381D0, .08331192422694676D0,
     *            .07819389578707031D0, .07234579410884851D0,
     *            .06582222277636185D0, .05868409347853555D0,
     *            .05099805926237618D0, .04283589802222668D0,
     *            .03427386291302143D0, .02539206530926206D0,
     *            .01627439473090567D0, .00701861000947009D0/
C
C=======================================================================
C          POINTS AND WEIGHTS FOR THE '64-POINT' GAUSS QUADRATURES
C=======================================================================
C
      DATA XG64
     *
     *          / .02435029266342443D0, .07299312178779904D0,
     *            .12146281929612055D0, .16964442042399282D0,
     *            .21742364374000708D0, .26468716220876742D0,
     *            .31132287199021096D0, .35722015833766812D0,
     *            .40227015796399160D0, .44636601725346409D0,
     *            .48940314570705296D0, .53127946401989455D0,
     *            .57189564620263404D0, .61115535517239325D0,
     *            .64896547125465734D0, .68523631305423324D0,
     *            .71988185017161083D0, .75281990726053190D0,
     *            .78397235894334141D0, .81326531512279756D0,
     *            .84062929625258036D0, .86599939815409282D0,
     *            .88931544599511411D0, .91052213707850281D0,
     *            .92956917213193958D0, .94641137485840282D0,
     *            .96100879965205372D0, .97332682778991097D0,
     *            .98333625388462596D0, .99101337147674432D0,
     *            .99634011677195528D0, .99930504173577214D0/
      DATA WT64
     *
     *          / .04869095700913972D0, .04857546744150343D0,
     *            .04834476223480296D0, .04799938859645831D0,
     *            .04754016571483031D0, .04696818281621002D0,
     *            .04628479658131442D0, .04549162792741815D0,
     *            .04459055816375657D0, .04358372452932346D0,
     *            .04247351512365359D0, .04126256324262353D0,
     *            .03995374113272034D0, .03855015317861563D0,
     *            .03705512854024005D0, .03547221325688239D0,
     *            .03380516183714161D0, .03205792835485155D0,
     *            .03023465707240248D0, .02833967261425948D0,
     *            .02637746971505466D0, .02435270256871087D0,
     *            .02227017380838325D0, .02013482315353021D0,
     *            .01795171577569734D0, .01572603047602472D0,
     *            .01346304789671864D0, .01116813946013112D0,
     *            .00884675982636395D0, .00650445796897837D0,
     *            .00414703326056246D0, .00178328072169639D0/
C
      MINX=10000
      MINY=10000
C
      DO I=1,6
C
         M=ABS(INDEX(I)-N1POIN)
C
         IF (M.LE.MINX) THEN
             MINX=M
             NX=I
         END IF
C
      END DO
C
      IF (NX.GT.6) NX=6
C
      DO I=1,6
C
         M=ABS(INDEX(I)-N2POIN)
C
         IF (M.LE.MINY) THEN
             MINY=M
             NY=I
         END IF
C
      END DO
C
      IF (NY.GT.6) NY=6
C
C=======================================================================
C=======================================================================
C     NX = 1,2,3,4,5,6 CORRESPONDS TO 4,8,12,16,32,64 - POINT PROCEDURE
C=======================================================================
C=======================================================================
C
      GO TO  (10,20,30,40,50,60) NX
C
   10 NNX=2
C
      DO I=1,2
         XPOINT( I )=-XG4(3-I)
         XWEIGH( I )=+WT4(3-I)
         XPOINT(2+I)=XG4(I)
         XWEIGH(2+I)=WT4(I)
      END DO
C
      GO TO 100
C
   20 NNX=4
C
      DO I=1,4
         XPOINT(I)=-XG8(5-I)
         XWEIGH(I)=+WT8(5-I)
         XPOINT(4+I)=XG8(I)
         XWEIGH(4+I)=WT8(I)
      END DO
C
      GO TO 100
C
   30 NNX=6
C
      DO I=1,6
         XPOINT(I)=-XG12(7-I)
         XWEIGH(I)=+WT12(7-I)
         XPOINT(6+I)=XG12(I)
         XWEIGH(6+I)=WT12(I)
      END DO
C
      GO TO 100
C
   40 NNX=8
C
      DO I=1,8
         XPOINT(I)=-XG16(9-I)
         XWEIGH(I)=+WT16(9-I)
         XPOINT(8+I)=XG16(I)
         XWEIGH(8+I)=WT16(I)
      END DO
C
      GO TO 100
C
   50 NNX=16
C
      DO I=1,16
         XPOINT(I)=-XG32(17-I)
         XWEIGH(I)=+WT32(17-I)
         XPOINT(16+I)=XG32(I)
         XWEIGH(16+I)=WT32(I)
      END DO
C
      GO TO 100
C
   60 NNX=32
C
      DO I=1,32
         XPOINT(I)=-XG64(33-I)
         XWEIGH(I)=+WT64(33-I)
         XPOINT(32+I)=XG64(I)
         XWEIGH(32+I)=WT64(I)
      END DO
C
C=======================================================================
C=======================================================================
C     NY = 1,2,3,4,5,6 CORRESPONDS TO 4,8,12,16,32,64 - POINT PROCEDURE
C=======================================================================
C=======================================================================
C
  100 GO TO  (110,120,130,140,150,160) NY
C
  110 NNY=2
C
      DO I=1,2
      YPOINT(I)=-XG4(3-I)
      YWEIGH(I)=+WT4(3-I)
      YPOINT(2+I)=XG4(I)
      YWEIGH(2+I)=WT4(I)
      END DO
C
      GO TO 200
C
  120 NNY=4
C
      DO I=1,4
      YPOINT(I)=-XG8(5-I)
      YWEIGH(I)=+WT8(5-I)
      YPOINT(4+I)=XG8(I)
      YWEIGH(4+I)=WT8(I)
      END DO
C
      GO TO 200
C
  130 NNY=6
C
      DO I=1,6
         YPOINT(I)=-XG12(7-I)
         YWEIGH(I)=+WT12(7-I)
         YPOINT(6+I)=XG12(I)
         YWEIGH(6+I)=WT12(I)
      END DO
C
      GO TO 200
C
  140 NNY=8
C
      DO I=1,8
         YPOINT(I)=-XG16(9-I)
         YWEIGH(I)=+WT16(9-I)
         YPOINT(8+I)=XG16(I)
         YWEIGH(8+I)=WT16(I)
      END DO
C
      GO TO 200
C
  150 NNY=16
C
      DO I=1,16
         YPOINT(I)=-XG32(17-I)
         YWEIGH(I)=+WT32(17-I)
         YPOINT(16+I)=XG32(I)
         YWEIGH(16+I)=WT32(I)
      END DO
C
      GO TO 200
C
  160 NNY=32
C
      DO I=1,32
         YPOINT(I)=-XG64(33-I)
         YWEIGH(I)=+WT64(33-I)
         YPOINT(32+I)=XG64(I)
         YWEIGH(32+I)=WT64(I)
      END DO
C
  200 CONTINUE
C
      AX=(XL+XU)/2.0D0
      AY=(YL+YU)/2.0D0
C
      BX=(XU-XL)/2.0D0
      BY=(YU-YL)/2.0D0
C
      SUM=0.0D0
C
      DO IX=1,2*NNX
C
         XX=AX+XPOINT(IX)*BX
C
         S=0.0D0
C
         DO IY=1,2*NNY
C
            YY=AY+YPOINT(IY)*BY
C
            S=S+YWEIGH(IY)*F(XX,YY)
C
         END DO
C
         SUM=SUM+S*XWEIGH(IX)
C
      END DO
C
      RESULT=SUM*BX*BY
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE ZEROYL(YLM,YLMT,YLMF,YLMTT,YLMTF,YLMFF,LAMMAX,LEVEL)
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      COMPLEX
     *          YLM  (0:NDLAMB,-NDLAMB:+NDLAMB),
     *          YLMT (0:NDLAMB,-NDLAMB:+NDLAMB),
     *          YLMF (0:NDLAMB,-NDLAMB:+NDLAMB),
     *          YLMTT(0:NDLAMB,-NDLAMB:+NDLAMB),
     *          YLMTF(0:NDLAMB,-NDLAMB:+NDLAMB),
     *          YLMFF(0:NDLAMB,-NDLAMB:+NDLAMB)
      COMPLEX
     *          C_ZERO
C
      C_ZERO=CMPLX(0.0D0,0.0D0)
C
      DO LAMBDA=0,LAMMAX
         DO MIU=-LAMBDA,+LAMBDA
            YLM(LAMBDA,MIU)=C_ZERO
         END DO
      END DO
C
      IF (LEVEL.EQ.0) RETURN
C
      DO LAMBDA=0,LAMMAX
         DO MIU=-LAMBDA,+LAMBDA
            YLMT(LAMBDA,MIU)=C_ZERO
            YLMF(LAMBDA,MIU)=C_ZERO
         END DO
      END DO
C
      IF (LEVEL.EQ.1) RETURN
C
      DO LAMBDA=0,LAMMAX
         DO MIU=-LAMBDA,+LAMBDA
            YLMTT(LAMBDA,MIU)=C_ZERO
            YLMTF(LAMBDA,MIU)=C_ZERO
            YLMFF(LAMBDA,MIU)=C_ZERO
         END DO
      END DO
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE LIMITY(ALPHAC,LAMMAX)
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      COMPLEX
     *          ALPHAC(0:NDLAMB,-NDLAMB:+NDLAMB)
      COMMON
     *       /ALINFO/ LAMACT(0:NDLAMB),MIUACT(0:NDLAMB,-NDLAMB:+NDLAMB)
C
C=======================================================================
C         THIS SUBROUTINE DETERMINES THE  LAMBDA  AND  MIU VALUES
C         FOR WHICH THE SPHERICAL HARMONICS AND THEIR DERIVATIVES
C         ARE NEEDED IN THE PROGRAM
C=======================================================================
C
      LAMMAX=0
C
      DO LAMBDA=0,NDLAMB
         LAMACT(LAMBDA)=-100
         DO MIU=-LAMBDA,+LAMBDA
            MIUACT(LAMBDA,MIU)=-100
         END DO
      END DO
C
      DO LAMBDA=0,NDLAMB
         DO MIU=-LAMBDA,+LAMBDA
            IF (ABS(ALPHAC(LAMBDA,MIU)).GT.0.0000001) THEN
                LAMMAX=LAMBDA
                LAMACT(LAMBDA)=LAMBDA
                MIUACT(LAMBDA,MIU)=MIU
            END IF
         END DO
      END DO
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE DEFPRI(LAMMAX,INNUMB,IZNUMB)
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      CHARACTER
     *          PRIMOM(0:NDLAMB)*15
C
      COMMON
     *       /REALPH/ ALPHAR(0:NDLAMB,0:NDLAMB)
      COMMON
     *       /CFIPRI/ NFIPRI
C
C=======================================================================
C       THIS SUBROUTINE PRINTS THE DEFORMATION PARAMETERS IN THE NUCLEAR
C       SURFACE FORMULA AS DEFINED TYPICALLY IN THE WOODS-SAXON PROGRAMS
C=======================================================================
C
      WRITE(NFIPRI,'(79(1H*),/,             1H*,77X,1H*,/,
     *             1H*,2X,''CLASSICAL NUCLEAR SURFACE DEFINED FOR:'',
     *             20X,''N ='',I3,3X,''Z ='',I3,2X,1H*,/,
     *                                    1H*,77X,1H*,/,79(1H*))')
     *
     *                                              INNUMB,IZNUMB
C
      DO MIU=0,NDLAMB
         PRIMOM(MIU)='  .............'
      END DO
C
      DO LAMBDA=1,MIN(LAMMAX,NDLAMB)
C
         DO MIU=0,LAMBDA
C
            IF (ABS(ALPHAR(LAMBDA,MIU)).LT.1.0E-10) THEN
C
                WRITE(PRIMOM(MIU),'(''  AL'',2I1,'' ='',3X,''ZERO'')')
     *                                                     LAMBDA,MIU
            ELSE
C
               IF (ABS(ALPHAR(LAMBDA,MIU)).LT.1.0E-3) THEN
C
                   WRITE(PRIMOM(MIU),'(''  AL'',2I1,'' ='',1PE7.0)')
     *                          LAMBDA,MIU,ALPHAR(LAMBDA,MIU)
               ELSE
C
                   WRITE(PRIMOM(MIU),'(''  AL'',2I1,'' ='',F7.3)')
     *                          LAMBDA,MIU,ALPHAR(LAMBDA,MIU)
               END IF
C
            END IF
C
            IF (PRIMOM(MIU)(11:12).EQ.' .') PRIMOM(MIU)(11:12)='0.'
C
         END DO
C
         WRITE(NFIPRI,'(1H*,77X,1H*,/,1H*,5A15,2X,1H*)')
     *                                             (PRIMOM(MIU),MIU=0,4)
C
         IF (LAMBDA.EQ.5)
     *   WRITE(NFIPRI,'(1H*,      60X,A15,2X,1H*)')
     *                                             (PRIMOM(MIU),MIU=5,5)
C
      END DO
C
      IF (LAMMAX.EQ.0) THEN
C
          WRITE(NFIPRI,'(1H*,77X,1H*,/,
     *                   1H*,2X,''SPHERICAL SHAPE REQUESTED FOR '',
     *                     ''THE SURFACE'',34X,1H*)')
C
      END IF
C
      WRITE(NFIPRI,'(1H*,77X,1H*,/,79(1H*))')
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE LOADIN(LAMMAX)
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      COMMON
     *       /COEFAB/ ALMS00(0:NDLAMB,0:NDLAMB,0:NDLAMB),
     *                ALMSS0(0:NDLAMB,0:NDLAMB,0:NDLAMB),
     *                ALMSSS(0:NDLAMB,0:NDLAMB,0:NDLAMB),
     *
     *                BLMS00(0:NDLAMB,0:NDLAMB,0:NDLAMB),
     *                BLMSS0(0:NDLAMB,0:NDLAMB,0:NDLAMB),
     *                BLMSSS(0:NDLAMB,0:NDLAMB,0:NDLAMB)
     *
     *       /FACTRS/ FACTOR(0:NDFACT),FACT_2(0:NDFACT+1)
     *
     *       /NORMNG/ XNORM(0:NDLAMB,-NDLAMB:+NDLAMB),PHASE(0:NDFACT)
C
C=======================================================================
C        C A L C U L A T I N G   T H E   F A C T O R I A L
C=======================================================================
C
      FACTOR(0)=1.0D0
      FACTOR(1)=1.0D0
C
      DO I=2,NDFACT
         FACTOR(I)=I*FACTOR(I-1)
      END DO
C
C=======================================================================
C         CALCULATING THE NORMALIZATION FACTORS FOR THE YLM FUNCTIONS
C=======================================================================
C
      PI_4=16.0D0*ATAN(1.0D0)
C
      DO LAMBDA=0,LAMMAX
         DO MIU=0,LAMBDA
C
            XNORM(LAMBDA,MIU)=(2.0D0*LAMBDA+1.000000D0)
     *                       / FACTOR(LAMBDA-ABS(MIU))
     *                       / FACTOR(LAMBDA+ABS(MIU))/PI_4
C
            XNORM(LAMBDA,MIU)=SQRT(XNORM(LAMBDA,MIU))
C
         END DO
      END DO
C
C=======================================================================
C        CALCULATING THE COEFFICIENTS FOR THE SUMMATIONS IN SPHERICAL
C        HARMONICS
C=======================================================================
C         C A L C U L A T I N G  THE  D O U B L E   F A C T O R I A L S
C=======================================================================
C
      FACT_2(0)=1.0D0
      FACT_2(1)=1.0D0
C
      DO I=2,NDFACT,2
         FACT_2(I)=I*FACT_2(I-2)
      END DO
C
      DO I=3,NDFACT,2
         FACT_2(I)=I*FACT_2(I-2)
      END DO
C
C=======================================================================
C        C A L C U L A T I N G    T H E    P H A S E    F A C T O R S
C=======================================================================
C
      PHASE(0)=1.0D0
      DO I=1,NDFACT
         PHASE(I)=-PHASE(I-1)
      END DO
C
C=======================================================================
C        CALCULATING THE COEFFICIENTS FOR THE YLM SUMMATIONS (L-M)-EVEN
C=======================================================================
C
      DO LAMBDA=0,LAMMAX
         DO MIU=LAMBDA,0,-2
C
            ZNORMA=XNORM(LAMBDA,MIU)
C
            DO IS=MIU,LAMBDA,2
               ALMS00(LAMBDA,MIU,IS)=ZNORMA*PHASE((MIU+IS)/2)
     *                              *FACT_2(LAMBDA+MIU)
     *                              /FACT_2(LAMBDA+ IS)
     *                              *FACT_2(LAMBDA-MIU)
     *                              /FACT_2(LAMBDA- IS)
     *                              *FACTOR(LAMBDA+IS)
     *                              /FACT_2(IS  +  MIU)
     *                              /FACT_2(IS  -  MIU)
            END DO
C
            DO IS=MIU,LAMBDA,2
               ALMSS0(LAMBDA,MIU,IS)=ALMS00(LAMBDA,MIU,IS)*IS
               ALMSSS(LAMBDA,MIU,IS)=ALMS00(LAMBDA,MIU,IS)*IS*(IS-1)
            END DO
C
         END DO
      END DO
C
C=======================================================================
C        CALCULATING THE COEFFICIENTS FOR THE YLM SUMMATIONS (L-M)-ODD
C=======================================================================
C
      DO LAMBDA=0,LAMMAX
         DO MIU=LAMBDA-1,0,-2
C
            ZNORMA=XNORM(LAMBDA,MIU)
C
            DO IS=MIU,LAMBDA-1,2
               BLMS00(LAMBDA,MIU,IS)=ZNORMA*PHASE((MIU+IS)/2)
     *                              *FACT_2(LAMBDA+MIU-1)
     *                              /FACT_2(LAMBDA+ IS-1)
     *                              *FACT_2(LAMBDA-MIU-1)
     *                              /FACT_2(LAMBDA- IS-1)
     *                              *FACTOR(LAMBDA+IS)
     *                              /FACT_2(IS  +  MIU)
     *                              /FACT_2(IS  -  MIU)
            END DO
C
            DO IS=MIU,LAMBDA-1,2
               BLMSS0(LAMBDA,MIU,IS)=BLMS00(LAMBDA,MIU,IS)*IS
               BLMSSS(LAMBDA,MIU,IS)=BLMS00(LAMBDA,MIU,IS)*IS*(IS-1)
            END DO
C
         END DO
      END DO
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE YL_MIU(YLM,YLMT,YLMF,YLMTT,YLMTF,YLMFF,
     *                       LAMBDA,MIU,THETA,PHI,LEVEL)
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      COMPLEX
     *          YLM  (0:NDLAMB,-NDLAMB:+NDLAMB),
     *          YLMT (0:NDLAMB,-NDLAMB:+NDLAMB),
     *          YLMF (0:NDLAMB,-NDLAMB:+NDLAMB),
     *          YLMTT(0:NDLAMB,-NDLAMB:+NDLAMB),
     *          YLMTF(0:NDLAMB,-NDLAMB:+NDLAMB),
     *          YLMFF(0:NDLAMB,-NDLAMB:+NDLAMB)
      COMPLEX
     *          YLMCCC,YLMTCC,YLMFCC,YLMTTC,YLMTFC,YLMFFC,
     *                                      EXPPHI,UNITY
      DIMENSION
     *          SINUS (-2:NDLAMB)
C
      COMMON
     *       /COEFAB/ ALMS00(0:NDLAMB,0:NDLAMB,0:NDLAMB),
     *                ALMSS0(0:NDLAMB,0:NDLAMB,0:NDLAMB),
     *                ALMSSS(0:NDLAMB,0:NDLAMB,0:NDLAMB),
     *
     *                BLMS00(0:NDLAMB,0:NDLAMB,0:NDLAMB),
     *                BLMSS0(0:NDLAMB,0:NDLAMB,0:NDLAMB),
     *                BLMSSS(0:NDLAMB,0:NDLAMB,0:NDLAMB)
     *
     *       /NORMNG/ XNORM(0:NDLAMB,-NDLAMB:+NDLAMB),PHASE(0:NDFACT)
C
      UNITY=CMPLX(0.0D0,1.0D0)
C
C=======================================================================
C        CALCULATING THE SPHERICAL HARMONICS FOR (LAMBDA-MIU)-EVEN
C=======================================================================
C
      SINTHT=SIN(THETA)
      COSTHT=COS(THETA)
C
      COST_2=COSTHT*COSTHT
C
      ANGLE=MIU*PHI
C
      EXPPHI=CMPLX(COS(ANGLE),SIN(ANGLE))
C
      SINUS(-2)=0.0D0
      SINUS(-1)=0.0D0
      SINUS( 0)=1.0D0
C
      SINUS(+1)=SINTHT
      DO I=2,LAMBDA
         SINUS(I)=SINUS(I-1)*SINTHT
      END DO
C
      IF (MOD((LAMBDA-MIU),2).EQ.0) THEN
C
          SUM=0.0D0
C
          DO IS=MIU,LAMBDA,2
             SUM=SUM+ALMS00(LAMBDA,MIU,IS)*SINUS(IS)
          END DO
C
          YLMCCC=SUM*EXPPHI
C
          IF (LEVEL.EQ.0) GO TO 1
C
          YLMFCC=YLMCCC*UNITY*MIU
C
          SUM=0.0D0
          DO IS=MIU,LAMBDA,2
             SUM=SUM+ALMSS0(LAMBDA,MIU,IS)*SINUS(IS-1)
          END DO
C
          YLMTCC=SUM*COSTHT*EXPPHI
C
          IF (LEVEL.EQ.1) GO TO 2
C
          YLMFFC=-MIU*MIU*YLMCCC
          YLMTFC=+MIU*UNITY*YLMTCC
C
          SUM1=0.0D0
          SUM2=0.0D0
C
          DO IS=MIU,LAMBDA,2
             SUM1=SUM1+ALMSS0(LAMBDA,MIU,IS)*SINUS( IS )
             SUM2=SUM2+ALMSSS(LAMBDA,MIU,IS)*SINUS(IS-2)
          END DO
C
          YLMTTC=EXPPHI*(COST_2*SUM2-SUM1)
C
          GO TO 3
C
      ELSE
C
C=======================================================================
C         CALCULATING THE SPHERICAL HARMONICS FOR (LAMBDA-MIU)-ODD
C=======================================================================
C
          SUM=0.0D0
C
          DO IS=MIU,LAMBDA-1,2
             SUM=SUM+BLMS00(LAMBDA,MIU,IS)*SINUS(IS)
          END DO
C
          SUM_TH=SUM*COSTHT
C
          YLMCCC=SUM_TH*EXPPHI
C
          IF (LEVEL.EQ.0) GO TO 1
C
          YLMFCC=YLMCCC*UNITY*MIU
C
          SUM1=0.0D0
          DO IS=MIU,LAMBDA-1,2
             SUM1=SUM1+BLMSS0(LAMBDA,MIU,IS)*SINUS(IS-1)
          END DO
C
          YLMTCC=EXPPHI*(COST_2*SUM1-SINTHT*SUM)
C
          IF (LEVEL.EQ.1) GO TO 2
C
          YLMFFC=-MIU*MIU*YLMCCC
          YLMTFC=+MIU*UNITY*YLMTCC
C
C         SUM1=0.0D0
          SUM2=0.0D0
C
          DO IS=MIU,LAMBDA-1,2
C            SUM1=SUM1+BLMSS0(LAMBDA,MIU,IS)*SINUS(IS-1)
             SUM2=SUM2+BLMSSS(LAMBDA,MIU,IS)*SINUS(IS-2)
          END DO
C
          YLMTTC=EXPPHI*(COST_2*COSTHT*SUM2-SUM_TH
     *              -3.0D0*SINTHT*COSTHT*SUM1)
C
          GO TO 3
C
      END IF
C
   1  CONTINUE
C
      YLM(LAMBDA,+MIU)=YLMCCC
      YLM(LAMBDA,-MIU)=PHASE(MIU)*CONJG(YLMCCC)
C
      RETURN
C
   2  CONTINUE
C
      YLM(LAMBDA,+MIU)=YLMCCC
      YLM(LAMBDA,-MIU)=PHASE(MIU)*CONJG(YLMCCC)
C
      YLMT(LAMBDA,+MIU)=YLMTCC
      YLMF(LAMBDA,+MIU)=YLMFCC
C
      YLMT(LAMBDA,-MIU)=PHASE(MIU)*CONJG(YLMTCC)
      YLMF(LAMBDA,-MIU)=PHASE(MIU)*CONJG(YLMFCC)
C
      RETURN
C
   3  CONTINUE
C
      YLM(LAMBDA,+MIU)=YLMCCC
      YLM(LAMBDA,-MIU)=PHASE(MIU)*CONJG(YLMCCC)
C
      YLMT(LAMBDA,+MIU)=YLMTCC
      YLMF(LAMBDA,+MIU)=YLMFCC
C
      YLMT(LAMBDA,-MIU)=PHASE(MIU)*CONJG(YLMTCC)
      YLMF(LAMBDA,-MIU)=PHASE(MIU)*CONJG(YLMFCC)
C
      YLMTT(LAMBDA,+MIU)=YLMTTC
      YLMTF(LAMBDA,+MIU)=YLMTFC
      YLMFF(LAMBDA,+MIU)=YLMFFC
C
      YLMTT(LAMBDA,-MIU)=PHASE(MIU)*CONJG(YLMTTC)
      YLMTF(LAMBDA,-MIU)=PHASE(MIU)*CONJG(YLMTFC)
      YLMFF(LAMBDA,-MIU)=PHASE(MIU)*CONJG(YLMFFC)
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE SOLHAR(HARMON,LAMBDA,MIU,POSTIO,IMAREA)
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      DIMENSION
     *          POSTIO(NDKART)
C
      COMMON
     *       /DATYLM/ COEYLM(0:NDMULT,0:NDMULT),
     *
     *                NREYLM(0:NDMULT,0:NDMULT),
     *                KREYLM(0:NDMULT,0:NDMULT,1:NDTERM,0:NDKART),
     *
     *                NIMYLM(0:NDMULT,1:NDMULT),
     *                KIMYLM(0:NDMULT,1:NDMULT,1:NDTERM,0:NDKART)
C
C=======================================================================
C
C     CALL CPUTIM('SOLHAR',1)
C
C=======================================================================
C         THIS SUBROUTINE CALCULATES THE   S O L I D   H A R M O N I C S
C                        (SPHERICAL HARMONICS  *  R**LAMBDA).
C=======================================================================
C
      IF (MIU.LT.0)
     *
     *   STOP 'FOR MIU<0 ONE CANNOT CALCULATE SOLID HARMONICS IN SOLHAR'
C
      IF (MIU.EQ.0.AND.IMAREA.EQ.-1)
     *
     *   STOP 'FOR MIU=0 NO IMAGINARY PART OF SOLID HARMONICS IN SOLHAR'
C
C=======================================================================
C
      HARMON=0.0D0
C
      IF (IMAREA.EQ.1) THEN
C
C=======================================================================
C        CALCULATING THE REAL PART OF THE SOLID HARMONIC
C=======================================================================
C
         DO NUTERM=1,NREYLM(LAMBDA,MIU)
C
            RESULT=KREYLM(LAMBDA,MIU,NUTERM,0)
C
            DO KARTEZ=1,NDKART
C
               DO IPOWER=1,KREYLM(LAMBDA,MIU,NUTERM,KARTEZ)
C
                  RESULT=RESULT*POSTIO(KARTEZ)
C
               END DO
C
            END DO
C
            HARMON=HARMON+RESULT
C
         END DO
C
         HARMON=HARMON*COEYLM(LAMBDA,MIU)
C
      ELSE
C
C=======================================================================
C        CALCULATING THE IMAGINARY PART OF THE SOLID HARMONIC
C=======================================================================
C
         DO NUTERM=1,NIMYLM(LAMBDA,MIU)
C
            RESULT=KIMYLM(LAMBDA,MIU,NUTERM,0)
C
            DO KARTEZ=1,NDKART
C
               DO IPOWER=1,KIMYLM(LAMBDA,MIU,NUTERM,KARTEZ)
C
                  RESULT=RESULT*POSTIO(KARTEZ)
C
               END DO
C
            END DO
C
            HARMON=HARMON+RESULT
C
         END DO
C
         HARMON=HARMON*COEYLM(LAMBDA,MIU)
C
      END IF
C
C=======================================================================
C
C     CALL CPUTIM('SOLHAR',0)
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE DEFYLM
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      DIMENSION
     *          KOELOC(0:NDMULT,0:NDMULT,1:3),
     *
     *          NRELOC(0:NDMULT,0:NDMULT),
     *          KRELOC(0:NDMULT,0:NDMULT,1:NDTERM,0:NDKART),
     *
     *          NIMLOC(0:NDMULT,1:NDMULT),
     *          KIMLOC(0:NDMULT,1:NDMULT,1:NDTERM,0:NDKART)
C
      COMMON
     *       /DATYLM/ COEYLM(0:NDMULT,0:NDMULT),
     *
     *                NREYLM(0:NDMULT,0:NDMULT),
     *                KREYLM(0:NDMULT,0:NDMULT,1:NDTERM,0:NDKART),
     *
     *                NIMYLM(0:NDMULT,1:NDMULT),
     *                KIMYLM(0:NDMULT,1:NDMULT,1:NDTERM,0:NDKART)
C
      DATA
     *        MULMAX / 9 /
C
C=======================================================================
C
C         THIS SUBROUTINE DEFINES THE TERMS APPEARING IN THE
C
C                   S O L I D    H A R M O N I C S
C
C         (SPHERICAL HARMONICS  *  R**LAMBDA).  THE NUMBER OF
C         TERMS IS STORED IN  "NREYLM" AND "NIMYLM" FOR  REAL
C         AND IMAGINARY PARTS, RESPECTIVELY.  EVERY  TERM  IS
C         DEFINED BY ITS INTEGER COEFFICIENT  (STORED  IN THE
C         KARTEZ = 0 COMPONENT  OF "KREYLM" AND "KIMYLM") AND
C         BY POWERS OF COORDINATES  (KARTEZ= 1,2,3 COMPONENTS
C         OF THESE SAME ARRAYS),  WHILE  THE  OVERALL  COMMON
C         FACTORS ARE STORED IN "COEYLM".
C
C         KOELOC: INTEGER  ARRAY STORING THE STRUCTURE OF THE
C                 OVERALL COMMON FACTORS  "COEYLM"  ACCORDING
C                 TO THE FOLLOWING CONVENTION:
C
C                 COEYLM = INT1 * SQRT(INT2/INT3) / SQRT(4PI)
C
C                 KOELOC(,,1) = INT1
C                 KOELOC(,,2) = INT2
C                 KOELOC(,,3) = INT3
C
C=======================================================================
C
C         THIS SUBROUTINE DEFINES MULTIPOLES UP TO THE VALUE
C         OF "MULMAX" DEFINED ABOVE. THIS VALUE MUST NOT  BE
C         SMALLER THAN ANY OF THE FOLLOWING INPUT PARAMETERS:
C
C                      NMUCON < OR =  MULMAX
C                      NMUCOU < OR =  MULMAX
C                      NMUPRI < OR =  MULMAX
C                      NMACON < OR =  MULMAX
C                      NMAPRI < OR =  MULMAX
C
C         AS A SAFETY MEASURE,  THE  CODE REQUIRES THAT THE
C         DIMENSION  DECLARATION  "NDMULT"  IS  NECESSARILY
C         EQUAL TO "MULMAX".
C
C         AT THE SAME TIME THE DIMENSION DECLARATIONS "NDPOLS" HAVE
C         TO BE ADJUSTED IN FUNCTION OF "NDMULT"="MULMAX" ACCORDING
C         TO THE TABLE GIVEN IN "MULCOU"
C
C         AND "NDTERM"  HAS  TO  TAKE  THE FOLLOWING VALUES:
C                       MULMAX = NDMULT<=5  ==>>  NDTERM= 6;
C                       MULMAX = NDMULT<=7  ==>>  NDTERM=10;
C                       MULMAX = NDMULT<=9  ==>>  NDTERM=15;
C                       MULMAX = NDMULT =10 ==>>  NDTERM=21;
C
C=======================================================================
C         HERE START DEFINITIONS FOR THE GIVEN LAMBDA AND MIU VALUES:
C=======================================================================
C                        LAMBDA=0  MIU=0  YLM=C
C                               C=1/SQR4PI
C=======================================================================
C
      DATA (KOELOC(  0,  0,      K), K= 1, 3) /  1,  1,  1/
C
C=======================================================================
C          Y00 REAL PART ONLY
C=======================================================================
C
      DATA (KRELOC(  0,  0,  1,  K), K= 0, 3) /  1,  0,  0,  0/
C
      DATA  NRELOC(  0,  0) /1/
C
C=======================================================================
C          LAMBDA=1  MIU=0  YLM=C * Z
C          C=SQRT(3)/SQR4PI
C=======================================================================
C
      DATA (KOELOC(  1,  0,      K), K= 1, 3) /  1,  3,  1/
C
C=======================================================================
C          Y10 REAL PART ONLY
C=======================================================================
C
      DATA (KRELOC(  1,  0,  1,  K), K= 0, 3) /  1,  0,  0,  1/
C
      DATA  NRELOC(  1,  0) /1/
C
C=======================================================================
C          LAMBDA=1  MIU=1  YLM=C * ( X + I*Y )
C          C=-SQRT(3/2)/SQR4PI
C=======================================================================
C
      DATA (KOELOC(  1,  1,      K), K= 1, 3) / -1,  3,  2/
C
C=======================================================================
C          Y11 REAL PART
C=======================================================================
C
      DATA (KRELOC(  1,  1,  1,  K), K= 0, 3) /  1,  1,  0,  0/
C
      DATA  NRELOC(  1,  1) /1/
C
C=======================================================================
C          Y11 IMAGINARY PART
C=======================================================================
C
      DATA (KIMLOC(  1,  1,  1,  K), K= 0, 3) /  1,  0,  1,  0/
C
      DATA  NIMLOC(  1,  1) /1/
C
C=======================================================================
C          LAMBDA=2  MIU=0  YLM=C * (2Z**2 - X**2 - Y**2)
C          C=SQRT(5/4)/SQR4PI
C=======================================================================
C
      DATA (KOELOC(  2,  0,      K), K= 1, 3) /  1,  5,  4/
C
C=======================================================================
C          Y20 REAL PART ONLY
C=======================================================================
C
      DATA (KRELOC(  2,  0,  1,  K), K= 0, 3) /  2,  0,  0,  2/
      DATA (KRELOC(  2,  0,  2,  K), K= 0, 3) / -1,  2,  0,  0/
      DATA (KRELOC(  2,  0,  3,  K), K= 0, 3) / -1,  0,  2,  0/
C
      DATA  NRELOC(  2,  0) /3/
C
C=======================================================================
C          LAMBDA=2  MIU=1  YLM=C * ( X + I*Y ) * Z
C          C=-SQRT(15/2)/SQR4PI
C=======================================================================
C
      DATA (KOELOC(  2,  1,      K), K= 1, 3) / -1, 15,  2/
C
C=======================================================================
C          Y21 REAL PART
C=======================================================================
C
      DATA (KRELOC(  2,  1,  1,  K), K= 0, 3) /  1,  1,  0,  1/
C
      DATA  NRELOC(  2,  1) /1/
C
C=======================================================================
C          Y21 IMAGINARY PART
C=======================================================================
C
      DATA (KIMLOC(  2,  1,  1,  K), K= 0, 3) /  1,  0,  1,  1/
C
      DATA  NIMLOC(  2,  1) /1/
C
C=======================================================================
C          LAMBDA=2  MIU=2  YLM=C * ( X**2 + 2I X*Y - Y**2 )
C          C=SQRT(15/8)/SQR4PI
C=======================================================================
C
      DATA (KOELOC(  2,  2,      K), K= 1, 3) /  1, 15,  8/
C
C=======================================================================
C          Y22 REAL PART
C=======================================================================
C
      DATA (KRELOC(  2,  2,  1,  K), K= 0, 3) /  1,  2,  0,  0/
      DATA (KRELOC(  2,  2,  2,  K), K= 0, 3) / -1,  0,  2,  0/
C
      DATA  NRELOC(  2,  2) /2/
C
C=======================================================================
C          Y22 IMAGINARY PART
C=======================================================================
C
      DATA (KIMLOC(  2,  2,  1,  K), K= 0, 3) /  2,  1,  1,  0/
C
      DATA  NIMLOC(  2,  2) /1/
C
C=======================================================================
C          LAMBDA=3  MIU=0  YLM=C * (2Z**2 - 3X**2 - 3Y**2) * Z
C          C=SQRT(7/4)/SQR4PI
C=======================================================================
C
      DATA (KOELOC(  3,  0,      K), K= 1, 3) /  1,  7,  4/
C
C=======================================================================
C          Y30 REAL PART ONLY
C=======================================================================
C
      DATA (KRELOC(  3,  0,  1,  K), K= 0, 3) /  2,  0,  0,  3/
      DATA (KRELOC(  3,  0,  2,  K), K= 0, 3) / -3,  2,  0,  1/
      DATA (KRELOC(  3,  0,  3,  K), K= 0, 3) / -3,  0,  2,  1/
C
      DATA  NRELOC(  3,  0) /3/
C
C=======================================================================
C          LAMBDA=3  MIU=1  YLM= C * ( X + I*Y )*( 4Z**2 - X**2 - Y**2 )
C          C=-SQRT(21/16)/SQR4PI
C=======================================================================
C
      DATA (KOELOC(  3,  1,      K), K= 1, 3) / -1, 21, 16/
C
C=======================================================================
C          Y31 REAL PART
C=======================================================================
C
      DATA (KRELOC(  3,  1,  1,  K), K= 0, 3) /  4,  1,  0,  2/
      DATA (KRELOC(  3,  1,  2,  K), K= 0, 3) / -1,  3,  0,  0/
      DATA (KRELOC(  3,  1,  3,  K), K= 0, 3) / -1,  1,  2,  0/
C
      DATA  NRELOC(  3,  1) /3/
C
C=======================================================================
C          Y31 IMAGINARY PART
C=======================================================================
C
      DATA (KIMLOC(  3,  1,  1,  K), K= 0, 3) /  4,  0,  1,  2/
      DATA (KIMLOC(  3,  1,  2,  K), K= 0, 3) / -1,  2,  1,  0/
      DATA (KIMLOC(  3,  1,  3,  K), K= 0, 3) / -1,  0,  3,  0/
C
      DATA  NIMLOC(  3,  1) /3/
C
C=======================================================================
C          LAMBDA=3  MIU=2  YLM=C * ( X**2 + 2*I*X*Y - Y**2 ) * Z
C          C=SQRT(105/8)/SQR4PI
C=======================================================================
C
      DATA (KOELOC(  3,  2,      K), K= 1, 3) /  1,105,  8/
C
C=======================================================================
C          Y32 REAL PART
C=======================================================================
C
      DATA (KRELOC(  3,  2,  1,  K), K= 0, 3) /  1,  2,  0,  1/
      DATA (KRELOC(  3,  2,  2,  K), K= 0, 3) / -1,  0,  2,  1/
C
      DATA  NRELOC(  3,  2) /2/
C
C=======================================================================
C          Y32 IMAGINARY PART
C=======================================================================
C
      DATA (KIMLOC(  3,  2,  1,  K), K= 0, 3) /  2,  1,  1,  1/
C
      DATA  NIMLOC(  3,  2) /1/
C
C=======================================================================
C          LAMBDA=3  MIU=3  YLM=C*(X**3 + 3I X**2*Y - 3 X*Y**2 - I Y**3)
C          C=-SQRT(35/16)/SQR4PI
C=======================================================================
C
      DATA (KOELOC(  3,  3,      K), K= 1, 3) / -1, 35, 16/
C
C=======================================================================
C          Y33 REAL PART
C=======================================================================
C
      DATA (KRELOC(  3,  3,  1,  K), K= 0, 3) /  1,  3,  0,  0/
      DATA (KRELOC(  3,  3,  2,  K), K= 0, 3) / -3,  1,  2,  0/
C
      DATA  NRELOC(  3,  3) /2/
C
C=======================================================================
C          Y33 IMAGINARY PART
C=======================================================================
C
      DATA (KIMLOC(  3,  3,  1,  K), K= 0, 3) /  3,  2,  1,  0/
      DATA (KIMLOC(  3,  3,  2,  K), K= 0, 3) / -1,  0,  3,  0/
C
      DATA  NIMLOC(  3,  3) /2/
C
C=======================================================================
C          LAMBDA=4  MIU=0  YLM=C * ( 8Z**4 + 3X**4 + 3Y**4
C                            -24 X**2 Z**2 -24 Y**2 Z**2 + 6 X**2 Y**2 )
C          C=3/8/SQR4PI
C=======================================================================
C
      DATA (KOELOC(  4,  0,      K), K= 1, 3) /  1,  9, 64/
C
C=======================================================================
C          Y40 REAL PART ONLY
C=======================================================================
C
      DATA (KRELOC(  4,  0,  1,  K), K= 0, 3) /  8,  0,  0,  4/
      DATA (KRELOC(  4,  0,  2,  K), K= 0, 3) /  3,  4,  0,  0/
      DATA (KRELOC(  4,  0,  3,  K), K= 0, 3) /  3,  0,  4,  0/
      DATA (KRELOC(  4,  0,  4,  K), K= 0, 3) /-24,  2,  0,  2/
      DATA (KRELOC(  4,  0,  5,  K), K= 0, 3) /-24,  0,  2,  2/
      DATA (KRELOC(  4,  0,  6,  K), K= 0, 3) /  6,  2,  2,  0/
C
      DATA  NRELOC(  4,  0) /6/
C
C=======================================================================
C          LAMBDA=4  MIU=1  YLM=C *(X + I*Y)*(4Z**2 - 3X**2 - 3Y**2) * Z
C          C=-SQRT(45/16)/SQR4PI
C=======================================================================
C
      DATA (KOELOC(  4,  1,      K), K= 1, 3) / -1, 45, 16/
C
C=======================================================================
C          Y41 REAL PART
C=======================================================================
C
      DATA (KRELOC(  4,  1,  1,  K), K= 0, 3) /  4,  1,  0,  3/
      DATA (KRELOC(  4,  1,  2,  K), K= 0, 3) / -3,  3,  0,  1/
      DATA (KRELOC(  4,  1,  3,  K), K= 0, 3) / -3,  1,  2,  1/
C
      DATA  NRELOC(  4,  1) /3/
C
C=======================================================================
C          Y41 IMAGINARY PART
C=======================================================================
C
      DATA (KIMLOC(  4,  1,  1,  K), K= 0, 3) /  4,  0,  1,  3/
      DATA (KIMLOC(  4,  1,  2,  K), K= 0, 3) / -3,  2,  1,  1/
      DATA (KIMLOC(  4,  1,  3,  K), K= 0, 3) / -3,  0,  3,  1/
C
      DATA  NIMLOC(  4,  1) /3/
C
C=======================================================================
C          LAMBDA=4  MIU=2  YLM=C * (   X**2 + 2*I*X*Y - Y**2 ) *
C                                  ( 6*Z**2 -   X**2  - Y**2 )
C          C=SQRT(90/64)/SQR4PI
C=======================================================================
C
      DATA (KOELOC(  4,  2,      K), K= 1, 3) /  1, 90, 64/
C
C=======================================================================
C          Y42 REAL PART
C=======================================================================
C
      DATA (KRELOC(  4,  2,  1,  K), K= 0, 3) /  6,  2,  0,  2/
      DATA (KRELOC(  4,  2,  2,  K), K= 0, 3) / -6,  0,  2,  2/
      DATA (KRELOC(  4,  2,  3,  K), K= 0, 3) / -1,  4,  0,  0/
      DATA (KRELOC(  4,  2,  4,  K), K= 0, 3) /  1,  0,  4,  0/
C
      DATA  NRELOC(  4,  2) /4/
C
C=======================================================================
C          Y42 IMAGINARY PART
C=======================================================================
C
      DATA (KIMLOC(  4,  2,  1,  K), K= 0, 3) / 12,  1,  1,  2/
      DATA (KIMLOC(  4,  2,  2,  K), K= 0, 3) / -2,  3,  1,  0/
      DATA (KIMLOC(  4,  2,  3,  K), K= 0, 3) / -2,  1,  3,  0/
C
      DATA  NIMLOC(  4,  2) /3/
C
C=======================================================================
C          LAMBDA=4  MIU=3  YLM=C*(X**3 + 3I X**2*Y - 3X*Y**2 - IY**3)*Z
C          C=-SQRT(315/16)/SQR4PI
C=======================================================================
C
      DATA (KOELOC(  4,  3,      K), K= 1, 3) / -1,315, 16/
C
C=======================================================================
C          Y43 REAL PART
C=======================================================================
C
      DATA (KRELOC(  4,  3,  1,  K), K= 0, 3) /  1,  3,  0,  1/
      DATA (KRELOC(  4,  3,  2,  K), K= 0, 3) / -3,  1,  2,  1/
C
      DATA  NRELOC(  4,  3) /2/
C
C=======================================================================
C          Y43 IMAGINARY PART
C=======================================================================
C
      DATA (KIMLOC(  4,  3,  1,  K), K= 0, 3) /  3,  2,  1,  1/
      DATA (KIMLOC(  4,  3,  2,  K), K= 0, 3) / -1,  0,  3,  1/
C
      DATA  NIMLOC(  4,  3) /2/
C
C=======================================================================
C          LAMBDA=4  MIU=4  YLM=C * ( X**4 + 4I X**3*Y - 6 X**2*Y**2
C                                          - 4I X*Y**3 + Y**4 )
C          C=SQRT(630/256)/SQR4PI
C=======================================================================
C
      DATA (KOELOC(  4,  4,      K), K= 1, 3) /  1,630,256/
C
C=======================================================================
C          Y44 REAL PART
C=======================================================================
C
      DATA (KRELOC(  4,  4,  1,  K), K= 0, 3) /  1,  4,  0,  0/
      DATA (KRELOC(  4,  4,  2,  K), K= 0, 3) / -6,  2,  2,  0/
      DATA (KRELOC(  4,  4,  3,  K), K= 0, 3) /  1,  0,  4,  0/
C
      DATA  NRELOC(  4,  4) /3/
C
C=======================================================================
C          Y44 IMAGINARY PART
C=======================================================================
C
      DATA (KIMLOC(  4,  4,  1,  K), K= 0, 3) /  4,  3,  1,  0/
      DATA (KIMLOC(  4,  4,  2,  K), K= 0, 3) / -4,  1,  3,  0/
C
      DATA  NIMLOC(  4,  4) /2/
C
C=======================================================================
C          LAMBDA=5  MIU=0  YLM=C * (8Z**5 - 40X**2*Z**3 - 40Y**2*Z**3
C                                +15X**4*Z + 15Y**4*Z + 30X**2*Y**2*Z)
C          C=SQRT(11/64)/SQR4PI
C=======================================================================
C
      DATA (KOELOC(  5,  0,      K), K= 1, 3) /  1,  11, 64/
C
C=======================================================================
C          Y50 REAL PART ONLY
C=======================================================================
C
      DATA (KRELOC(  5,  0,  1,  K), K= 0, 3) /  8,  0,  0,  5/
      DATA (KRELOC(  5,  0,  2,  K), K= 0, 3) /-40,  2,  0,  3/
      DATA (KRELOC(  5,  0,  3,  K), K= 0, 3) /-40,  0,  2,  3/
      DATA (KRELOC(  5,  0,  4,  K), K= 0, 3) / 15,  4,  0,  1/
      DATA (KRELOC(  5,  0,  5,  K), K= 0, 3) / 15,  0,  4,  1/
      DATA (KRELOC(  5,  0,  6,  K), K= 0, 3) / 30,  2,  2,  1/
C
      DATA  NRELOC(  5,  0) /6/
C
C=======================================================================
C          LAMBDA=5  MIU=1  YLM=C * (X + IY)( X**4 + Y**4 + 8Z**4
C                             + 2X**2*Y**2 - 12*X**2*Z**2 - 12Y**2*Z**2)
C          C=-SQRT(165/128)/SQR4PI
C=======================================================================
C
      DATA (KOELOC(  5,  1,      K), K= 1, 3) / -1,165,128/
C
C=======================================================================
C          Y51 REAL PART
C=======================================================================
C
      DATA (KRELOC(  5,  1,  1,  K), K= 0, 3) /  8,  1,  0,  4/
      DATA (KRELOC(  5,  1,  2,  K), K= 0, 3) /  1,  5,  0,  0/
      DATA (KRELOC(  5,  1,  3,  K), K= 0, 3) /  1,  1,  4,  0/
      DATA (KRELOC(  5,  1,  4,  K), K= 0, 3) /  2,  3,  2,  0/
      DATA (KRELOC(  5,  1,  5,  K), K= 0, 3) /-12,  3,  0,  2/
      DATA (KRELOC(  5,  1,  6,  K), K= 0, 3) /-12,  1,  2,  2/
C
      DATA  NRELOC(  5,  1) /6/
C
C=======================================================================
C          Y51 IMAGINARY PART
C=======================================================================
C
      DATA (KIMLOC(  5,  1,  1,  K), K= 0, 3) /  8,  0,  1,  4/
      DATA (KIMLOC(  5,  1,  2,  K), K= 0, 3) /  1,  4,  1,  0/
      DATA (KIMLOC(  5,  1,  3,  K), K= 0, 3) /  1,  0,  5,  0/
      DATA (KIMLOC(  5,  1,  4,  K), K= 0, 3) /  2,  2,  3,  0/
      DATA (KIMLOC(  5,  1,  5,  K), K= 0, 3) /-12,  2,  1,  2/
      DATA (KIMLOC(  5,  1,  6,  K), K= 0, 3) /-12,  0,  3,  2/
C
      DATA  NIMLOC(  5,  1) /6/
C
C=======================================================================
C          LAMBDA=5  MIU=2  YLM=C * (X **2 - Y**2 + I 2*X*Y)
C                                   ( 2Z**2 - X**2 - Y**2)*Z
C          C=SQRT(1155/32)/SQR4PI
C=======================================================================
C
      DATA (KOELOC(  5,  2,      K), K= 1, 3) / 1,1155,32/
C
C=======================================================================
C          Y52 REAL PART
C=======================================================================
C
      DATA (KRELOC(  5,  2,  1,  K), K= 0, 3) /  2,  2,  0,  3/
      DATA (KRELOC(  5,  2,  2,  K), K= 0, 3) / -1,  4,  0,  1/
      DATA (KRELOC(  5,  2,  3,  K), K= 0, 3) / -2,  0,  2,  3/
      DATA (KRELOC(  5,  2,  4,  K), K= 0, 3) /  1,  0,  4,  1/
C
      DATA  NRELOC(  5,  2) /4/
C
C=======================================================================
C          Y52 IMAGINARY PART
C=======================================================================
C
      DATA (KIMLOC(  5,  2,  1,  K), K= 0, 3) /  4,  1,  1,  3/
      DATA (KIMLOC(  5,  2,  2,  K), K= 0, 3) / -2,  3,  1,  1/
      DATA (KIMLOC(  5,  2,  3,  K), K= 0, 3) / -2,  1,  3,  1/
C
      DATA  NIMLOC(  5,  2) /3/
C
C=======================================================================
C          LAMBDA=5  MIU=3  YLM=C *
C          C=-SQRT(385/256)/SQR4PI
C=======================================================================
C
      DATA (KOELOC(  5,  3,      K), K= 1, 3) / -1,385,256/
C
C=======================================================================
C          Y53 REAL PART
C=======================================================================
C
      DATA (KRELOC(  5,  3,  1,  K), K= 0, 3) / -1,  5,  0,  0/
      DATA (KRELOC(  5,  3,  2,  K), K= 0, 3) /  8,  3,  0,  2/
      DATA (KRELOC(  5,  3,  3,  K), K= 0, 3) /  2,  3,  2,  0/
      DATA (KRELOC(  5,  3,  4,  K), K= 0, 3) /-24,  1,  2,  2/
      DATA (KRELOC(  5,  3,  5,  K), K= 0, 3) /  3,  1,  4,  0/
C
      DATA  NRELOC(  5,  3) /5/
C
C=======================================================================
C          Y53 IMAGINARY PART
C=======================================================================
C
      DATA (KIMLOC(  5,  3,  1,  K), K= 0, 3) / -3,  4,  1,  0/
      DATA (KIMLOC(  5,  3,  2,  K), K= 0, 3) / 24,  2,  1,  2/
      DATA (KIMLOC(  5,  3,  3,  K), K= 0, 3) / -8,  0,  3,  2/
      DATA (KIMLOC(  5,  3,  4,  K), K= 0, 3) /  1,  0,  5,  0/
      DATA (KIMLOC(  5,  3,  5,  K), K= 0, 3) / -2,  2,  3,  0/
C
      DATA  NIMLOC(  5,  3) /5/
C
C=======================================================================
C          LAMBDA=5  MIU=4  YLM=C *
C          C=3*SQRT(385/128)/SQR4PI
C=======================================================================
C
      DATA (KOELOC(  5,  4,      K), K= 1, 3) /  3,385,128/
C
C=======================================================================
C          Y54 REAL PART
C=======================================================================
C
      DATA (KRELOC(  5,  4,  1,  K), K= 0, 3) /  1,  4,  0,  1/
      DATA (KRELOC(  5,  4,  2,  K), K= 0, 3) /  1,  0,  4,  1/
      DATA (KRELOC(  5,  4,  3,  K), K= 0, 3) / -6,  2,  2,  1/
C
      DATA  NRELOC(  5,  4) /3/
C
C=======================================================================
C          Y54 IMAGINARY PART
C=======================================================================
C
      DATA (KIMLOC(  5,  4,  1,  K), K= 0, 3) /  4,  3,  1,  1/
      DATA (KIMLOC(  5,  4,  2,  K), K= 0, 3) / -4,  1,  3,  1/
C
      DATA  NIMLOC(  5,  4) /2/
C
C=======================================================================
C          LAMBDA=5  MIU=5  YLM=C *
C          C=-3*SQRT(77/256)/SQR4PI
C=======================================================================
C
      DATA (KOELOC(  5,  5,      K), K= 1, 3) /  -3, 77,256/
C
C=======================================================================
C          Y55 REAL PART
C=======================================================================
C
      DATA (KRELOC(  5,  5,  1,  K), K= 0, 3) /  1,  5,  0,  0/
      DATA (KRELOC(  5,  5,  2,  K), K= 0, 3) /  5,  1,  4,  0/
      DATA (KRELOC(  5,  5,  3,  K), K= 0, 3) /-10,  3,  2,  0/
C
      DATA  NRELOC(  5,  5) /3/
C
C=======================================================================
C          Y55 IMAGINARY PART
C=======================================================================
C
      DATA (KIMLOC(  5,  5,  1,  K), K= 0, 3) /  1,  0,  5,  0/
      DATA (KIMLOC(  5,  5,  2,  K), K= 0, 3) /  5,  4,  1,  0/
      DATA (KIMLOC(  5,  5,  3,  K), K= 0, 3) /-10,  2,  3,  0/
C
      DATA  NIMLOC(  5,  5) /3/
C
C=======================================================================
C          LAMBDA=6  MIU=0  YLM=C *
C          C=SQRT(11/64)/SQR4PI
C=======================================================================
C
      DATA (KOELOC(  6,  0,      K), K= 1, 3) / -1,  13, 256/
C
C=======================================================================
C          Y60 REAL PART ONLY
C=======================================================================
C
      DATA (KRELOC(  6,  0,  1,  K), K= 0, 3) /   5,  6,  0,  0/
      DATA (KRELOC(  6,  0,  2,  K), K= 0, 3) /  15,  4,  2,  0/
      DATA (KRELOC(  6,  0,  3,  K), K= 0, 3) / -90,  4,  0,  2/
      DATA (KRELOC(  6,  0,  4,  K), K= 0, 3) /  15,  2,  4,  0/
      DATA (KRELOC(  6,  0,  5,  K), K= 0, 3) /-180,  2,  2,  2/
      DATA (KRELOC(  6,  0,  6,  K), K= 0, 3) / 120,  2,  0,  4/
      DATA (KRELOC(  6,  0,  7,  K), K= 0, 3) /   5,  0,  6,  0/
      DATA (KRELOC(  6,  0,  8,  K), K= 0, 3) / -90,  0,  4,  2/
      DATA (KRELOC(  6,  0,  9,  K), K= 0, 3) / 120,  0,  2,  4/
      DATA (KRELOC(  6,  0, 10,  K), K= 0, 3) / -16,  0,  0,  6/
C
      DATA  NRELOC(  6,  0) /10/
C
C=======================================================================
C          LAMBDA=6  MIU=1  YLM=C *
C          C=
C=======================================================================
C
      DATA (KOELOC(  6,  1,      K), K= 1, 3) / -1,273,128/
C
C=======================================================================
C          Y61 REAL PART
C=======================================================================
C
      DATA (KRELOC(  6,  1,  1,  K), K= 0, 3) /  5,  5,  0,  1/
      DATA (KRELOC(  6,  1,  2,  K), K= 0, 3) / 10,  3,  2,  1/
      DATA (KRELOC(  6,  1,  3,  K), K= 0, 3) /-20,  3,  0,  3/
      DATA (KRELOC(  6,  1,  4,  K), K= 0, 3) /  5,  1,  4,  1/
      DATA (KRELOC(  6,  1,  5,  K), K= 0, 3) /-20,  1,  2,  3/
      DATA (KRELOC(  6,  1,  6,  K), K= 0, 3) /  8,  1,  0,  5/
C
      DATA  NRELOC(  6,  1) /6/
C
C=======================================================================
C          Y61 IMAGINARY PART
C=======================================================================
C
      DATA (KIMLOC(  6,  1,  1,  K), K= 0, 3) /  5,  4,  1,  1/
      DATA (KIMLOC(  6,  1,  2,  K), K= 0, 3) / 10,  2,  3,  1/
      DATA (KIMLOC(  6,  1,  3,  K), K= 0, 3) /-20,  2,  1,  3/
      DATA (KIMLOC(  6,  1,  4,  K), K= 0, 3) /  5,  0,  5,  1/
      DATA (KIMLOC(  6,  1,  5,  K), K= 0, 3) /-20,  0,  3,  3/
      DATA (KIMLOC(  6,  1,  6,  K), K= 0, 3) /  8,  0,  1,  5/
C
      DATA  NIMLOC(  6,  1) /6/
C
C=======================================================================
C          LAMBDA=6  MIU=2  YLM=C *
C          C=
C=======================================================================
C
      DATA (KOELOC(  6,  2,      K), K= 1, 3) / 1,1365,1024/
C
C=======================================================================
C          Y62 REAL PART
C=======================================================================
C
      DATA (KRELOC(  6,  2,  1,  K), K= 0, 3) /  1,  6,  0,  0/
      DATA (KRELOC(  6,  2,  2,  K), K= 0, 3) /  1,  4,  2,  0/
      DATA (KRELOC(  6,  2,  3,  K), K= 0, 3) /-16,  4,  0,  2/
      DATA (KRELOC(  6,  2,  4,  K), K= 0, 3) / -1,  2,  4,  0/
      DATA (KRELOC(  6,  2,  5,  K), K= 0, 3) / 16,  2,  0,  4/
      DATA (KRELOC(  6,  2,  6,  K), K= 0, 3) / -1,  0,  6,  0/
      DATA (KRELOC(  6,  2,  7,  K), K= 0, 3) / 16,  0,  4,  2/
      DATA (KRELOC(  6,  2,  8,  K), K= 0, 3) /-16,  0,  2,  4/
C
      DATA  NRELOC(  6,  2) /8/
C
C=======================================================================
C          Y62 IMAGINARY PART
C=======================================================================
C
      DATA (KIMLOC(  6,  2,  1,  K), K= 0, 3) /  2,  5,  1,  0/
      DATA (KIMLOC(  6,  2,  2,  K), K= 0, 3) /  4,  3,  3,  0/
      DATA (KIMLOC(  6,  2,  3,  K), K= 0, 3) /-32,  3,  1,  2/
      DATA (KIMLOC(  6,  2,  4,  K), K= 0, 3) /  2,  1,  5,  0/
      DATA (KIMLOC(  6,  2,  5,  K), K= 0, 3) /-32,  1,  3,  2/
      DATA (KIMLOC(  6,  2,  6,  K), K= 0, 3) / 32,  1,  1,  4/
C
      DATA  NIMLOC(  6,  2) /6/
C
C=======================================================================
C          LAMBDA=6  MIU=3  YLM=C *
C          C=
C=======================================================================
C
      DATA (KOELOC(  6,  3,      K), K= 1, 3) /  1,1365,256/
C
C=======================================================================
C          Y63 REAL PART
C=======================================================================
C
      DATA (KRELOC(  6,  3,  1,  K), K= 0, 3) /  3,  5,  0,  1/
      DATA (KRELOC(  6,  3,  2,  K), K= 0, 3) / -6,  3,  2,  1/
      DATA (KRELOC(  6,  3,  3,  K), K= 0, 3) / -8,  3,  0,  3/
      DATA (KRELOC(  6,  3,  4,  K), K= 0, 3) / -9,  1,  4,  1/
      DATA (KRELOC(  6,  3,  5,  K), K= 0, 3) / 24,  1,  2,  3/
C
      DATA  NRELOC(  6,  3) /5/
C
C=======================================================================
C          Y63 IMAGINARY PART
C=======================================================================
C
      DATA (KIMLOC(  6,  3,  1,  K), K= 0, 3) /  9,  4,  1,  1/
      DATA (KIMLOC(  6,  3,  2,  K), K= 0, 3) /  6,  2,  3,  1/
      DATA (KIMLOC(  6,  3,  3,  K), K= 0, 3) /-24,  2,  1,  3/
      DATA (KIMLOC(  6,  3,  4,  K), K= 0, 3) / -3,  0,  5,  1/
      DATA (KIMLOC(  6,  3,  5,  K), K= 0, 3) /  8,  0,  3,  3/
C
      DATA  NIMLOC(  6,  3) /5/
C
C=======================================================================
C          LAMBDA=6  MIU=4  YLM=C *
C          C=
C=======================================================================
C
      DATA (KOELOC(  6,  4,      K), K= 1, 3) /  -1,819,512/
C
C=======================================================================
C          Y64 REAL PART
C=======================================================================
C
      DATA (KRELOC(  6,  4,  1,  K), K= 0, 3) /  1,  6,  0,  0/
      DATA (KRELOC(  6,  4,  2,  K), K= 0, 3) / -5,  4,  2,  0/
      DATA (KRELOC(  6,  4,  3,  K), K= 0, 3) /-10,  4,  0,  2/
      DATA (KRELOC(  6,  4,  4,  K), K= 0, 3) / -5,  2,  4,  0/
      DATA (KRELOC(  6,  4,  5,  K), K= 0, 3) / 60,  2,  2,  2/
      DATA (KRELOC(  6,  4,  6,  K), K= 0, 3) /  1,  0,  6,  0/
      DATA (KRELOC(  6,  4,  7,  K), K= 0, 3) /-10,  0,  4,  2/
C
      DATA  NRELOC(  6,  4) /7/
C
C=======================================================================
C          Y64 IMAGINARY PART
C=======================================================================
C
      DATA (KIMLOC(  6,  4,  1,  K), K= 0, 3) /  4,  5,  1,  0/
      DATA (KIMLOC(  6,  4,  2,  K), K= 0, 3) /-40,  3,  1,  2/
      DATA (KIMLOC(  6,  4,  3,  K), K= 0, 3) / -4,  1,  5,  0/
      DATA (KIMLOC(  6,  4,  4,  K), K= 0, 3) / 40,  1,  3,  2/
C
      DATA  NIMLOC(  6,  4) /4/
C
C=======================================================================
C          LAMBDA=6  MIU=5  YLM=C *
C          C=
C=======================================================================
C
      DATA (KOELOC(  6,  5,      K), K= 1, 3) /  -1, 9009,256/
C
C=======================================================================
C          Y65 REAL PART
C=======================================================================
C
      DATA (KRELOC(  6,  5,  1,  K), K= 0, 3) /  1,  5,  0,  1/
      DATA (KRELOC(  6,  5,  2,  K), K= 0, 3) /-10,  3,  2,  1/
      DATA (KRELOC(  6,  5,  3,  K), K= 0, 3) /  5,  1,  4,  1/
C
      DATA  NRELOC(  6,  5) /3/
C
C=======================================================================
C          Y65 IMAGINARY PART
C=======================================================================
C
      DATA (KIMLOC(  6,  5,  1,  K), K= 0, 3) /  5,  4,  1,  1/
      DATA (KIMLOC(  6,  5,  2,  K), K= 0, 3) /-10,  2,  3,  1/
      DATA (KIMLOC(  6,  5,  3,  K), K= 0, 3) /  1,  0,  5,  1/
C
      DATA  NIMLOC(  6,  5) /3/
C
C=======================================================================
C          LAMBDA=6  MIU=6  YLM=C *
C
C          C=
C=======================================================================
C
      DATA (KOELOC(  6,  6,      K), K= 1, 3) /   1, 3003,1024/
C
C=======================================================================
C          Y66 REAL PART
C=======================================================================
C
      DATA (KRELOC(  6,  6,  1,  K), K= 0, 3) /  1,  6,  0,  0/
      DATA (KRELOC(  6,  6,  2,  K), K= 0, 3) /-15,  4,  2,  0/
      DATA (KRELOC(  6,  6,  3,  K), K= 0, 3) / 15,  2,  4,  0/
      DATA (KRELOC(  6,  6,  4,  K), K= 0, 3) / -1,  0,  6,  0/
C
      DATA  NRELOC(  6,  6) /4/
C
C=======================================================================
C          Y65 IMAGINARY PART
C=======================================================================
C
      DATA (KIMLOC(  6,  6,  1,  K), K= 0, 3) /  6,  5,  1,  0/
      DATA (KIMLOC(  6,  6,  2,  K), K= 0, 3) /-20,  3,  3,  0/
      DATA (KIMLOC(  6,  6,  3,  K), K= 0, 3) /  6,  1,  5,  0/
C
      DATA  NIMLOC(  6,  6) /3/
C
C=======================================================================
C          LAMBDA=7  MIU=0  YLM=C *
C          C=
C=======================================================================
C
      DATA (KOELOC(  7,  0,      K), K= 1, 3) / -1,  15, 256/
C
C=======================================================================
C          Y70 REAL PART ONLY
C=======================================================================
C
      DATA (KRELOC(  7,  0,  1,  K), K= 0, 3) /  35,  6,  0,  1/
      DATA (KRELOC(  7,  0,  2,  K), K= 0, 3) / 105,  4,  2,  1/
      DATA (KRELOC(  7,  0,  3,  K), K= 0, 3) /-210,  4,  0,  3/
      DATA (KRELOC(  7,  0,  4,  K), K= 0, 3) / 105,  2,  4,  1/
      DATA (KRELOC(  7,  0,  5,  K), K= 0, 3) /-420,  2,  2,  3/
      DATA (KRELOC(  7,  0,  6,  K), K= 0, 3) / 168,  2,  0,  5/
      DATA (KRELOC(  7,  0,  7,  K), K= 0, 3) /  35,  0,  6,  1/
      DATA (KRELOC(  7,  0,  8,  K), K= 0, 3) /-210,  0,  4,  3/
      DATA (KRELOC(  7,  0,  9,  K), K= 0, 3) / 168,  0,  2,  5/
      DATA (KRELOC(  7,  0, 10,  K), K= 0, 3) / -16,  0,  0,  7/
C
      DATA  NRELOC(  7,  0) /10/
C
C=======================================================================
C          LAMBDA=7  MIU=1  YLM=C *
C          C=
C=======================================================================
C
      DATA (KOELOC(  7,  1,      K), K= 1, 3) /  1,105,2048/
C
C=======================================================================
C          Y71 REAL PART
C=======================================================================
C
      DATA (KRELOC(  7,  1,  1,  K), K= 0, 3) /   5,  7,  0,  0/
      DATA (KRELOC(  7,  1,  2,  K), K= 0, 3) /  15,  5,  2,  0/
      DATA (KRELOC(  7,  1,  3,  K), K= 0, 3) /-120,  5,  0,  2/
      DATA (KRELOC(  7,  1,  4,  K), K= 0, 3) /  15,  3,  4,  0/
      DATA (KRELOC(  7,  1,  5,  K), K= 0, 3) /-240,  3,  2,  2/
      DATA (KRELOC(  7,  1,  6,  K), K= 0, 3) / 240,  3,  0,  4/
      DATA (KRELOC(  7,  1,  7,  K), K= 0, 3) /   5,  1,  6,  0/
      DATA (KRELOC(  7,  1,  8,  K), K= 0, 3) /-120,  1,  4,  2/
      DATA (KRELOC(  7,  1,  9,  K), K= 0, 3) / 240,  1,  2,  4/
      DATA (KRELOC(  7,  1, 10,  K), K= 0, 3) / -64,  1,  0,  6/
C
      DATA  NRELOC(  7,  1) /10/
C
C=======================================================================
C          Y71 IMAGINARY PART
C=======================================================================
C
      DATA (KIMLOC(  7,  1,  1,  K), K= 0, 3) /   5,  6,  1,  0/
      DATA (KIMLOC(  7,  1,  2,  K), K= 0, 3) /  15,  4,  3,  0/
      DATA (KIMLOC(  7,  1,  3,  K), K= 0, 3) /-120,  4,  1,  2/
      DATA (KIMLOC(  7,  1,  4,  K), K= 0, 3) /  15,  2,  5,  0/
      DATA (KIMLOC(  7,  1,  5,  K), K= 0, 3) /-240,  2,  3,  2/
      DATA (KIMLOC(  7,  1,  6,  K), K= 0, 3) / 240,  2,  1,  4/
      DATA (KIMLOC(  7,  1,  7,  K), K= 0, 3) /   5,  0,  7,  0/
      DATA (KIMLOC(  7,  1,  8,  K), K= 0, 3) /-120,  0,  5,  2/
      DATA (KIMLOC(  7,  1,  9,  K), K= 0, 3) / 240,  0,  3,  4/
      DATA (KIMLOC(  7,  1, 10,  K), K= 0, 3) / -64,  0,  1,  6/
C
      DATA  NIMLOC(  7,  1) /10/
C
C=======================================================================
C          LAMBDA=7  MIU=2  YLM=C *
C          C=
C=======================================================================
C
      DATA (KOELOC(  7,  2,      K), K= 1, 3) / 1, 315, 1024/
C
C=======================================================================
C          Y72 REAL PART
C=======================================================================
C
      DATA (KRELOC(  7,  2,  1,  K), K= 0, 3) / 15,  6,  0,  1/
      DATA (KRELOC(  7,  2,  2,  K), K= 0, 3) / 15,  4,  2,  1/
      DATA (KRELOC(  7,  2,  3,  K), K= 0, 3) /-80,  4,  0,  3/
      DATA (KRELOC(  7,  2,  4,  K), K= 0, 3) /-15,  2,  4,  1/
      DATA (KRELOC(  7,  2,  5,  K), K= 0, 3) / 48,  2,  0,  5/
      DATA (KRELOC(  7,  2,  6,  K), K= 0, 3) /-15,  0,  6,  1/
      DATA (KRELOC(  7,  2,  7,  K), K= 0, 3) / 80,  0,  4,  3/
      DATA (KRELOC(  7,  2,  8,  K), K= 0, 3) /-48,  0,  2,  5/
C
      DATA  NRELOC(  7,  2) /8/
C
C=======================================================================
C          Y72 IMAGINARY PART
C=======================================================================
C
      DATA (KIMLOC(  7,  2,  1,  K), K= 0, 3) /  30,  5,  1,  1/
      DATA (KIMLOC(  7,  2,  2,  K), K= 0, 3) /  60,  3,  3,  1/
      DATA (KIMLOC(  7,  2,  3,  K), K= 0, 3) /-160,  3,  1,  3/
      DATA (KIMLOC(  7,  2,  4,  K), K= 0, 3) /  30,  1,  5,  1/
      DATA (KIMLOC(  7,  2,  5,  K), K= 0, 3) /-160,  1,  3,  3/
      DATA (KIMLOC(  7,  2,  6,  K), K= 0, 3) /  96,  1,  1,  5/
C
      DATA  NIMLOC(  7,  2) /6/
C
C=======================================================================
C          LAMBDA=7  MIU=3  YLM=C *
C          C=
C=======================================================================
C
      DATA (KOELOC(  7,  3,      K), K= 1, 3) /  -1, 315, 2048/
C
C=======================================================================
C          Y73 REAL PART
C=======================================================================
C
      DATA (KRELOC(  7,  3,  1,  K), K= 0, 3) /   3,  7,  0,  0/
      DATA (KRELOC(  7,  3,  2,  K), K= 0, 3) /  -3,  5,  2,  0/
      DATA (KRELOC(  7,  3,  3,  K), K= 0, 3) / -60,  5,  0,  2/
      DATA (KRELOC(  7,  3,  4,  K), K= 0, 3) / -15,  3,  4,  0/
      DATA (KRELOC(  7,  3,  5,  K), K= 0, 3) / 120,  3,  2,  2/
      DATA (KRELOC(  7,  3,  6,  K), K= 0, 3) /  80,  3,  0,  4/
      DATA (KRELOC(  7,  3,  7,  K), K= 0, 3) /  -9,  1,  6,  0/
      DATA (KRELOC(  7,  3,  8,  K), K= 0, 3) / 180,  1,  4,  2/
      DATA (KRELOC(  7,  3,  9,  K), K= 0, 3) /-240,  1,  2,  4/
C
      DATA  NRELOC(  7,  3) /9/
C
C=======================================================================
C          Y73 IMAGINARY PART
C=======================================================================
C
      DATA (KIMLOC(  7,  3,  1,  K), K= 0, 3) /   9,  6,  1,  0/
      DATA (KIMLOC(  7,  3,  2,  K), K= 0, 3) /  15,  4,  3,  0/
      DATA (KIMLOC(  7,  3,  3,  K), K= 0, 3) /-180,  4,  1,  2/
      DATA (KIMLOC(  7,  3,  4,  K), K= 0, 3) /   3,  2,  5,  0/
      DATA (KIMLOC(  7,  3,  5,  K), K= 0, 3) /-120,  2,  3,  2/
      DATA (KIMLOC(  7,  3,  6,  K), K= 0, 3) / 240,  2,  1,  4/
      DATA (KIMLOC(  7,  3,  7,  K), K= 0, 3) /  -3,  0,  7,  0/
      DATA (KIMLOC(  7,  3,  8,  K), K= 0, 3) /  60,  0,  5,  2/
      DATA (KIMLOC(  7,  3,  9,  K), K= 0, 3) / -80,  0,  3,  4/
C
      DATA  NIMLOC(  7,  3) /9/
C
C=======================================================================
C          LAMBDA=7  MIU=4  YLM=C *
C          C=
C=======================================================================
C
      DATA (KOELOC(  7,  4,      K), K= 1, 3) /  -1,3465,512/
C
C=======================================================================
C          Y74 REAL PART
C=======================================================================
C
      DATA (KRELOC(  7,  4,  1,  K), K= 0, 3) /  3,  6,  0,  1/
      DATA (KRELOC(  7,  4,  2,  K), K= 0, 3) /-15,  4,  2,  1/
      DATA (KRELOC(  7,  4,  3,  K), K= 0, 3) /-10,  4,  0,  3/
      DATA (KRELOC(  7,  4,  4,  K), K= 0, 3) /-15,  2,  4,  1/
      DATA (KRELOC(  7,  4,  5,  K), K= 0, 3) / 60,  2,  2,  3/
      DATA (KRELOC(  7,  4,  6,  K), K= 0, 3) /  3,  0,  6,  1/
      DATA (KRELOC(  7,  4,  7,  K), K= 0, 3) /-10,  0,  4,  3/
C
      DATA  NRELOC(  7,  4) /7/
C
C=======================================================================
C          Y74 IMAGINARY PART
C=======================================================================
C
      DATA (KIMLOC(  7,  4,  1,  K), K= 0, 3) / 12,  5,  1,  1/
      DATA (KIMLOC(  7,  4,  2,  K), K= 0, 3) /-40,  3,  1,  3/
      DATA (KIMLOC(  7,  4,  3,  K), K= 0, 3) /-12,  1,  5,  1/
      DATA (KIMLOC(  7,  4,  4,  K), K= 0, 3) / 40,  1,  3,  3/
C
      DATA  NIMLOC(  7,  4) /4/
C
C=======================================================================
C          LAMBDA=7  MIU=5  YLM=C *
C          C=
C=======================================================================
C
      DATA (KOELOC(  7,  5,      K), K= 1, 3) /  1, 3465, 2048/
C
C=======================================================================
C          Y75 REAL PART
C=======================================================================
C
      DATA (KRELOC(  7,  5,  1,  K), K= 0, 3) /  1,  7,  0,  0/
      DATA (KRELOC(  7,  5,  2,  K), K= 0, 3) / -9,  5,  2,  0/
      DATA (KRELOC(  7,  5,  3,  K), K= 0, 3) /-12,  5,  0,  2/
      DATA (KRELOC(  7,  5,  4,  K), K= 0, 3) / -5,  3,  4,  0/
      DATA (KRELOC(  7,  5,  5,  K), K= 0, 3) /120,  3,  2,  2/
      DATA (KRELOC(  7,  5,  6,  K), K= 0, 3) /  5,  1,  6,  0/
      DATA (KRELOC(  7,  5,  7,  K), K= 0, 3) /-60,  1,  4,  2/
C
      DATA  NRELOC(  7,  5) /7/
C
C=======================================================================
C          Y75 IMAGINARY PART
C=======================================================================
C
      DATA (KIMLOC(  7,  5,  1,  K), K= 0, 3) /  5,  6,  1,  0/
      DATA (KIMLOC(  7,  5,  2,  K), K= 0, 3) / -5,  4,  3,  0/
      DATA (KIMLOC(  7,  5,  3,  K), K= 0, 3) /-60,  4,  1,  2/
      DATA (KIMLOC(  7,  5,  4,  K), K= 0, 3) / -9,  2,  5,  0/
      DATA (KIMLOC(  7,  5,  5,  K), K= 0, 3) /120,  2,  3,  2/
      DATA (KIMLOC(  7,  5,  6,  K), K= 0, 3) /  1,  0,  7,  0/
      DATA (KIMLOC(  7,  5,  7,  K), K= 0, 3) /-12,  0,  5,  2/
C
      DATA  NIMLOC(  7,  5) /7/
C
C=======================================================================
C          LAMBDA=7  MIU=6  YLM=C *
C          C=
C=======================================================================
C
      DATA (KOELOC(  7,  6,      K), K= 1, 3) /   1, 45045, 1024/
C
C=======================================================================
C          Y76 REAL PART
C=======================================================================
C
      DATA (KRELOC(  7,  6,  1,  K), K= 0, 3) /  1,  6,  0,  1/
      DATA (KRELOC(  7,  6,  2,  K), K= 0, 3) /-15,  4,  2,  1/
      DATA (KRELOC(  7,  6,  3,  K), K= 0, 3) / 15,  2,  4,  1/
      DATA (KRELOC(  7,  6,  4,  K), K= 0, 3) / -1,  0,  6,  1/
C
      DATA  NRELOC(  7,  6) /4/
C
C=======================================================================
C          Y76 IMAGINARY PART
C=======================================================================
C
      DATA (KIMLOC(  7,  6,  1,  K), K= 0, 3) /  6,  5,  1,  1/
      DATA (KIMLOC(  7,  6,  2,  K), K= 0, 3) /-20,  3,  3,  1/
      DATA (KIMLOC(  7,  6,  3,  K), K= 0, 3) /  6,  1,  5,  1/
C
      DATA  NIMLOC(  7,  6) /3/
C
C=======================================================================
C          LAMBDA=7  MIU=7  YLM=C *
C          C=
C=======================================================================
C
      DATA (KOELOC(  7,  7,      K), K= 1, 3) /  -1, 6435, 2048/
C
C=======================================================================
C          Y77 REAL PART
C=======================================================================
C
      DATA (KRELOC(  7,  7,  1,  K), K= 0, 3) /  1,  7,  0,  0/
      DATA (KRELOC(  7,  7,  2,  K), K= 0, 3) /-21,  5,  2,  0/
      DATA (KRELOC(  7,  7,  3,  K), K= 0, 3) / 35,  3,  4,  0/
      DATA (KRELOC(  7,  7,  4,  K), K= 0, 3) / -7,  1,  6,  0/
C
      DATA  NRELOC(  7,  7) /4/
C
C=======================================================================
C          Y77 IMAGINARY PART
C=======================================================================
C
      DATA (KIMLOC(  7,  7,  1,  K), K= 0, 3) /  7,  6,  1,  0/
      DATA (KIMLOC(  7,  7,  2,  K), K= 0, 3) /-35,  4,  3,  0/
      DATA (KIMLOC(  7,  7,  3,  K), K= 0, 3) / 21,  2,  5,  0/
      DATA (KIMLOC(  7,  7,  4,  K), K= 0, 3) / -1,  0,  7,  0/
C
      DATA  NIMLOC(  7,  7) /4/
C
C
C=======================================================================
C          LAMBDA=8  MIU=0  YLM=C *
C          C=
C=======================================================================
C
      DATA (KOELOC(  8,  0,      K), K= 1, 3) /  1,  17, 16384/
C
C=======================================================================
C          Y80 REAL PART ONLY
C=======================================================================
C
      DATA (KRELOC(  8,  0,  1,  K), K= 0, 3) /   35,  8,  0,  0/
      DATA (KRELOC(  8,  0,  2,  K), K= 0, 3) /  140,  6,  2,  0/
      DATA (KRELOC(  8,  0,  3,  K), K= 0, 3) /-1120,  6,  0,  2/
      DATA (KRELOC(  8,  0,  4,  K), K= 0, 3) /  210,  4,  4,  0/
      DATA (KRELOC(  8,  0,  5,  K), K= 0, 3) /-3360,  4,  2,  2/
      DATA (KRELOC(  8,  0,  6,  K), K= 0, 3) / 3360,  4,  0,  4/
      DATA (KRELOC(  8,  0,  7,  K), K= 0, 3) /  140,  2,  6,  0/
      DATA (KRELOC(  8,  0,  8,  K), K= 0, 3) /-3360,  2,  4,  2/
      DATA (KRELOC(  8,  0,  9,  K), K= 0, 3) / 6720,  2,  2,  4/
      DATA (KRELOC(  8,  0, 10,  K), K= 0, 3) /-1792,  2,  0,  6/
      DATA (KRELOC(  8,  0, 11,  K), K= 0, 3) /   35,  0,  8,  0/
      DATA (KRELOC(  8,  0, 12,  K), K= 0, 3) /-1120,  0,  6,  2/
      DATA (KRELOC(  8,  0, 13,  K), K= 0, 3) / 3360,  0,  4,  4/
      DATA (KRELOC(  8,  0, 14,  K), K= 0, 3) /-1792,  0,  2,  6/
      DATA (KRELOC(  8,  0, 15,  K), K= 0, 3) /  128,  0,  0,  8/
C
      DATA  NRELOC(  8,  0) /15/
C
C=======================================================================
C          LAMBDA=8  MIU=1  YLM=C *
C          C=
C=======================================================================
C
      DATA (KOELOC(  8,  1,      K), K= 1, 3) /  1,153,2048/
C
C=======================================================================
C          Y81 REAL PART
C=======================================================================
C
      DATA (KRELOC(  8,  1,  1,  K), K= 0, 3) /  35,  7,  0,  1/
      DATA (KRELOC(  8,  1,  2,  K), K= 0, 3) / 105,  5,  2,  1/
      DATA (KRELOC(  8,  1,  3,  K), K= 0, 3) /-280,  5,  0,  3/
      DATA (KRELOC(  8,  1,  4,  K), K= 0, 3) / 105,  3,  4,  1/
      DATA (KRELOC(  8,  1,  5,  K), K= 0, 3) /-560,  3,  2,  3/
      DATA (KRELOC(  8,  1,  6,  K), K= 0, 3) / 336,  3,  0,  5/
      DATA (KRELOC(  8,  1,  7,  K), K= 0, 3) /  35,  1,  6,  1/
      DATA (KRELOC(  8,  1,  8,  K), K= 0, 3) /-280,  1,  4,  3/
      DATA (KRELOC(  8,  1,  9,  K), K= 0, 3) / 336,  1,  2,  5/
      DATA (KRELOC(  8,  1, 10,  K), K= 0, 3) / -64,  1,  0,  7/
C
      DATA  NRELOC(  8,  1) /10/
C
C=======================================================================
C          Y81 IMAGINARY PART
C=======================================================================
C
      DATA (KIMLOC(  8,  1,  1,  K), K= 0, 3) /  35,  6,  1,  1/
      DATA (KIMLOC(  8,  1,  2,  K), K= 0, 3) / 105,  4,  3,  1/
      DATA (KIMLOC(  8,  1,  3,  K), K= 0, 3) /-280,  4,  1,  3/
      DATA (KIMLOC(  8,  1,  4,  K), K= 0, 3) / 105,  2,  5,  1/
      DATA (KIMLOC(  8,  1,  5,  K), K= 0, 3) /-560,  2,  3,  3/
      DATA (KIMLOC(  8,  1,  6,  K), K= 0, 3) / 336,  2,  1,  5/
      DATA (KIMLOC(  8,  1,  7,  K), K= 0, 3) /  35,  0,  7,  1/
      DATA (KIMLOC(  8,  1,  8,  K), K= 0, 3) /-280,  0,  5,  3/
      DATA (KIMLOC(  8,  1,  9,  K), K= 0, 3) / 336,  0,  3,  5/
      DATA (KIMLOC(  8,  1, 10,  K), K= 0, 3) / -64,  0,  1,  7/
C
      DATA  NIMLOC(  8,  1) /10/
C
C=======================================================================
C          LAMBDA=8  MIU=2  YLM=C *
C          C=
C=======================================================================
C
      DATA (KOELOC(  8,  2,      K), K= 1, 3) /-1, 5355, 4096/
C
C=======================================================================
C          Y82 REAL PART
C=======================================================================
C
      DATA (KRELOC(  8,  2,  1,  K), K= 0, 3) /  1,  8,  0,  0/
      DATA (KRELOC(  8,  2,  2,  K), K= 0, 3) /  2,  6,  2,  0/
      DATA (KRELOC(  8,  2,  3,  K), K= 0, 3) /-30,  6,  0,  2/
      DATA (KRELOC(  8,  2,  4,  K), K= 0, 3) /-30,  4,  2,  2/
      DATA (KRELOC(  8,  2,  5,  K), K= 0, 3) / 80,  4,  0,  4/
      DATA (KRELOC(  8,  2,  6,  K), K= 0, 3) / -2,  2,  6,  0/
      DATA (KRELOC(  8,  2,  7,  K), K= 0, 3) / 30,  2,  4,  2/
      DATA (KRELOC(  8,  2,  8,  K), K= 0, 3) /-32,  2,  0,  6/
      DATA (KRELOC(  8,  2,  9,  K), K= 0, 3) / -1,  0,  8,  0/
      DATA (KRELOC(  8,  2, 10,  K), K= 0, 3) / 30,  0,  6,  2/
      DATA (KRELOC(  8,  2, 11,  K), K= 0, 3) /-80,  0,  4,  4/
      DATA (KRELOC(  8,  2, 12,  K), K= 0, 3) / 32,  0,  2,  6/
C
      DATA  NRELOC(  8,  2) /12/
C
C=======================================================================
C          Y82 IMAGINARY PART
C=======================================================================
C
      DATA (KIMLOC(  8,  2,  1,  K), K= 0, 3) /   2,  7,  1,  0/
      DATA (KIMLOC(  8,  2,  2,  K), K= 0, 3) /   6,  5,  3,  0/
      DATA (KIMLOC(  8,  2,  3,  K), K= 0, 3) / -60,  5,  1,  2/
      DATA (KIMLOC(  8,  2,  4,  K), K= 0, 3) /   6,  3,  5,  0/
      DATA (KIMLOC(  8,  2,  5,  K), K= 0, 3) /-120,  3,  3,  2/
      DATA (KIMLOC(  8,  2,  6,  K), K= 0, 3) / 160,  3,  1,  4/
      DATA (KIMLOC(  8,  2,  7,  K), K= 0, 3) /   2,  1,  7,  0/
      DATA (KIMLOC(  8,  2,  8,  K), K= 0, 3) / -60,  1,  5,  2/
      DATA (KIMLOC(  8,  2,  9,  K), K= 0, 3) / 160,  1,  3,  4/
      DATA (KIMLOC(  8,  2, 10,  K), K= 0, 3) / -64,  1,  1,  6/
C
      DATA  NIMLOC(  8,  2) /10/
C
C=======================================================================
C          LAMBDA=8  MIU=3  YLM=C *
C          C=
C=======================================================================
C
      DATA (KOELOC(  8,  3,      K), K= 1, 3) /  -1, 19635, 2048/
C
C=======================================================================
C          Y83 REAL PART
C=======================================================================
C
      DATA (KRELOC(  8,  3,  1,  K), K= 0, 3) /   3,  7,  0,  1/
      DATA (KRELOC(  8,  3,  2,  K), K= 0, 3) /  -3,  5,  2,  1/
      DATA (KRELOC(  8,  3,  3,  K), K= 0, 3) / -20,  5,  0,  3/
      DATA (KRELOC(  8,  3,  4,  K), K= 0, 3) / -15,  3,  4,  1/
      DATA (KRELOC(  8,  3,  5,  K), K= 0, 3) /  40,  3,  2,  3/
      DATA (KRELOC(  8,  3,  6,  K), K= 0, 3) /  16,  3,  0,  5/
      DATA (KRELOC(  8,  3,  7,  K), K= 0, 3) /  -9,  1,  6,  1/
      DATA (KRELOC(  8,  3,  8,  K), K= 0, 3) /  60,  1,  4,  3/
      DATA (KRELOC(  8,  3,  9,  K), K= 0, 3) / -48,  1,  2,  5/
C
      DATA  NRELOC(  8,  3) /9/
C
C=======================================================================
C          Y83 IMAGINARY PART
C=======================================================================
C
      DATA (KIMLOC(  8,  3,  1,  K), K= 0, 3) /   9,  6,  1,  1/
      DATA (KIMLOC(  8,  3,  2,  K), K= 0, 3) /  15,  4,  3,  1/
      DATA (KIMLOC(  8,  3,  3,  K), K= 0, 3) / -60,  4,  1,  3/
      DATA (KIMLOC(  8,  3,  4,  K), K= 0, 3) /   3,  2,  5,  1/
      DATA (KIMLOC(  8,  3,  5,  K), K= 0, 3) / -40,  2,  3,  3/
      DATA (KIMLOC(  8,  3,  6,  K), K= 0, 3) /  48,  2,  1,  5/
      DATA (KIMLOC(  8,  3,  7,  K), K= 0, 3) /  -3,  0,  7,  1/
      DATA (KIMLOC(  8,  3,  8,  K), K= 0, 3) /  20,  0,  5,  3/
      DATA (KIMLOC(  8,  3,  9,  K), K= 0, 3) / -16,  0,  3,  5/
C
      DATA  NIMLOC(  8,  3) /9/
C
C=======================================================================
C          LAMBDA=8  MIU=4  YLM=C *
C          C=
C=======================================================================
C
      DATA (KOELOC(  8,  4,      K), K= 1, 3) /   1,11781,8192/
C
C=======================================================================
C          Y84 REAL PART
C=======================================================================
C
      DATA (KRELOC(  8,  4,  1,  K), K= 0, 3) /   1,  8,  0,  0/
      DATA (KRELOC(  8,  4,  2,  K), K= 0, 3) /  -4,  6,  2,  0/
      DATA (KRELOC(  8,  4,  3,  K), K= 0, 3) / -24,  6,  0,  2/
      DATA (KRELOC(  8,  4,  4,  K), K= 0, 3) / -10,  4,  4,  0/
      DATA (KRELOC(  8,  4,  5,  K), K= 0, 3) / 120,  4,  2,  2/
      DATA (KRELOC(  8,  4,  6,  K), K= 0, 3) /  40,  4,  0,  4/
      DATA (KRELOC(  8,  4,  7,  K), K= 0, 3) /  -4,  2,  6,  0/
      DATA (KRELOC(  8,  4,  8,  K), K= 0, 3) / 120,  2,  4,  2/
      DATA (KRELOC(  8,  4,  9,  K), K= 0, 3) /-240,  2,  2,  4/
      DATA (KRELOC(  8,  4, 10,  K), K= 0, 3) /   1,  0,  8,  0/
      DATA (KRELOC(  8,  4, 11,  K), K= 0, 3) / -24,  0,  6,  2/
      DATA (KRELOC(  8,  4, 12,  K), K= 0, 3) /  40,  0,  4,  4/
C
      DATA  NRELOC(  8,  4) /12/
C
C=======================================================================
C          Y84 IMAGINARY PART
C=======================================================================
C
      DATA (KIMLOC(  8,  4,  1,  K), K= 0, 3) /   4,  7,  1,  0/
      DATA (KIMLOC(  8,  4,  2,  K), K= 0, 3) /   4,  5,  3,  0/
      DATA (KIMLOC(  8,  4,  3,  K), K= 0, 3) / -96,  5,  1,  2/
      DATA (KIMLOC(  8,  4,  4,  K), K= 0, 3) /  -4,  3,  5,  0/
      DATA (KIMLOC(  8,  4,  5,  K), K= 0, 3) / 160,  3,  1,  4/
      DATA (KIMLOC(  8,  4,  6,  K), K= 0, 3) /  -4,  1,  7,  0/
      DATA (KIMLOC(  8,  4,  7,  K), K= 0, 3) /  96,  1,  5,  2/
      DATA (KIMLOC(  8,  4,  8,  K), K= 0, 3) /-160,  1,  3,  4/
C
      DATA  NIMLOC(  8,  4) /8/
C
C=======================================================================
C          LAMBDA=8  MIU=5  YLM=C *
C          C=
C=======================================================================
C
      DATA (KOELOC(  8,  5,      K), K= 1, 3) /  1, 153153, 2048/
C
C=======================================================================
C          Y85 REAL PART
C=======================================================================
C
      DATA (KRELOC(  8,  5,  1,  K), K= 0, 3) /  1,  7,  0,  1/
      DATA (KRELOC(  8,  5,  2,  K), K= 0, 3) / -9,  5,  2,  1/
      DATA (KRELOC(  8,  5,  3,  K), K= 0, 3) / -4,  5,  0,  3/
      DATA (KRELOC(  8,  5,  4,  K), K= 0, 3) / -5,  3,  4,  1/
      DATA (KRELOC(  8,  5,  5,  K), K= 0, 3) / 40,  3,  2,  3/
      DATA (KRELOC(  8,  5,  6,  K), K= 0, 3) /  5,  1,  6,  1/
      DATA (KRELOC(  8,  5,  7,  K), K= 0, 3) /-20,  1,  4,  3/
C
      DATA  NRELOC(  8,  5) /7/
C
C=======================================================================
C          Y85 IMAGINARY PART
C=======================================================================
C
      DATA (KIMLOC(  8,  5,  1,  K), K= 0, 3) /  5,  6,  1,  1/
      DATA (KIMLOC(  8,  5,  2,  K), K= 0, 3) / -5,  4,  3,  1/
      DATA (KIMLOC(  8,  5,  3,  K), K= 0, 3) /-20,  4,  1,  3/
      DATA (KIMLOC(  8,  5,  4,  K), K= 0, 3) / -9,  2,  5,  1/
      DATA (KIMLOC(  8,  5,  5,  K), K= 0, 3) / 40,  2,  3,  3/
      DATA (KIMLOC(  8,  5,  6,  K), K= 0, 3) /  1,  0,  7,  1/
      DATA (KIMLOC(  8,  5,  7,  K), K= 0, 3) / -4,  0,  5,  3/
C
      DATA  NIMLOC(  8,  5) /7/
C
C=======================================================================
C          LAMBDA=8  MIU=6  YLM=C *
C          C=
C=======================================================================
C
      DATA (KOELOC(  8,  6,      K), K= 1, 3) /  -1,  7293, 4096/
C
C=======================================================================
C          Y86 REAL PART
C=======================================================================
C
      DATA (KRELOC(  8,  6,  1,  K), K= 0, 3) /   1,  8,  0,  0/
      DATA (KRELOC(  8,  6,  2,  K), K= 0, 3) / -14,  6,  2,  0/
      DATA (KRELOC(  8,  6,  3,  K), K= 0, 3) / -14,  6,  0,  2/
      DATA (KRELOC(  8,  6,  4,  K), K= 0, 3) / 210,  4,  2,  2/
      DATA (KRELOC(  8,  6,  5,  K), K= 0, 3) /  14,  2,  6,  0/
      DATA (KRELOC(  8,  6,  6,  K), K= 0, 3) /-210,  2,  4,  2/
      DATA (KRELOC(  8,  6,  7,  K), K= 0, 3) /  -1,  0,  8,  0/
      DATA (KRELOC(  8,  6,  8,  K), K= 0, 3) /  14,  0,  6,  2/
C
      DATA  NRELOC(  8,  6) /8/
C
C=======================================================================
C          Y86 IMAGINARY PART
C=======================================================================
C
      DATA (KIMLOC(  8,  6,  1,  K), K= 0, 3) /  6,  7,  1,  0/
      DATA (KIMLOC(  8,  6,  2,  K), K= 0, 3) /-14,  5,  3,  0/
      DATA (KIMLOC(  8,  6,  3,  K), K= 0, 3) /-84,  5,  1,  2/
      DATA (KIMLOC(  8,  6,  4,  K), K= 0, 3) /-14,  3,  5,  0/
      DATA (KIMLOC(  8,  6,  5,  K), K= 0, 3) /280,  3,  3,  2/
      DATA (KIMLOC(  8,  6,  6,  K), K= 0, 3) /  6,  1,  7,  0/
      DATA (KIMLOC(  8,  6,  7,  K), K= 0, 3) /-84,  1,  5,  2/
C
      DATA  NIMLOC(  8,  6) /7/
C
C=======================================================================
C          LAMBDA=8  MIU=7  YLM=C *
C          C=
C=======================================================================
C
      DATA (KOELOC(  8,  7,      K), K= 1, 3) /  -1, 109395, 2048/
C
C=======================================================================
C          Y87 REAL PART
C=======================================================================
C
      DATA (KRELOC(  8,  7,  1,  K), K= 0, 3) /  1,  7,  0,  1/
      DATA (KRELOC(  8,  7,  2,  K), K= 0, 3) /-21,  5,  2,  1/
      DATA (KRELOC(  8,  7,  3,  K), K= 0, 3) / 35,  3,  4,  1/
      DATA (KRELOC(  8,  7,  4,  K), K= 0, 3) / -7,  1,  6,  1/
C
      DATA  NRELOC(  8,  7) /4/
C
C=======================================================================
C          Y87 IMAGINARY PART
C=======================================================================
C
      DATA (KIMLOC(  8,  7,  1,  K), K= 0, 3) /  7,  6,  1,  1/
      DATA (KIMLOC(  8,  7,  2,  K), K= 0, 3) /-35,  4,  3,  1/
      DATA (KIMLOC(  8,  7,  3,  K), K= 0, 3) / 21,  2,  5,  1/
      DATA (KIMLOC(  8,  7,  4,  K), K= 0, 3) / -1,  0,  7,  1/
C
      DATA  NIMLOC(  8,  7) /4/
C
C=======================================================================
C          LAMBDA=8  MIU=8  YLM=C *
C          C=
C=======================================================================
C
      DATA (KOELOC(  8,  8,      K), K= 1, 3) /  1, 109395, 32768/
C
C=======================================================================
C          Y88 REAL PART
C=======================================================================
C
      DATA (KRELOC(  8,  8,  1,  K), K= 0, 3) /  1,  8,  0,  0/
      DATA (KRELOC(  8,  8,  2,  K), K= 0, 3) /-28,  6,  2,  0/
      DATA (KRELOC(  8,  8,  3,  K), K= 0, 3) / 70,  4,  4,  0/
      DATA (KRELOC(  8,  8,  4,  K), K= 0, 3) /-28,  2,  6,  0/
      DATA (KRELOC(  8,  8,  5,  K), K= 0, 3) /  1,  0,  8,  0/
C
      DATA  NRELOC(  8,  8) /5/
C
C=======================================================================
C          Y88 IMAGINARY PART
C=======================================================================
C
      DATA (KIMLOC(  8,  8,  1,  K), K= 0, 3) /  8,  7,  1,  0/
      DATA (KIMLOC(  8,  8,  2,  K), K= 0, 3) /-56,  5,  3,  0/
      DATA (KIMLOC(  8,  8,  3,  K), K= 0, 3) / 56,  3,  5,  0/
      DATA (KIMLOC(  8,  8,  4,  K), K= 0, 3) / -8,  1,  7,  0/
C
      DATA  NIMLOC(  8,  8) /4/
C=======================================================================
C          LAMBDA=9  MIU=0  YLM=C *
C          C=
C=======================================================================
C
      DATA (KOELOC(  9,  0,      K), K= 1, 3) /  1,  19, 16384/
C
C=======================================================================
C          Y90 REAL PART ONLY
C=======================================================================
C
      DATA (KRELOC(  9,  0,  1,  K), K= 0, 3) /   315,  8,  0,  1/
      DATA (KRELOC(  9,  0,  2,  K), K= 0, 3) /  1260,  6,  2,  1/
      DATA (KRELOC(  9,  0,  3,  K), K= 0, 3) / -3360,  6,  0,  3/
      DATA (KRELOC(  9,  0,  4,  K), K= 0, 3) /  1890,  4,  4,  1/
      DATA (KRELOC(  9,  0,  5,  K), K= 0, 3) /-10080,  4,  2,  3/
      DATA (KRELOC(  9,  0,  6,  K), K= 0, 3) /  6048,  4,  0,  5/
      DATA (KRELOC(  9,  0,  7,  K), K= 0, 3) /  1260,  2,  6,  1/
      DATA (KRELOC(  9,  0,  8,  K), K= 0, 3) /-10080,  2,  4,  3/
      DATA (KRELOC(  9,  0,  9,  K), K= 0, 3) / 12096,  2,  2,  5/
      DATA (KRELOC(  9,  0, 10,  K), K= 0, 3) / -2304,  2,  0,  7/
      DATA (KRELOC(  9,  0, 11,  K), K= 0, 3) /   315,  0,  8,  1/
      DATA (KRELOC(  9,  0, 12,  K), K= 0, 3) / -3360,  0,  6,  3/
      DATA (KRELOC(  9,  0, 13,  K), K= 0, 3) /  6048,  0,  4,  5/
      DATA (KRELOC(  9,  0, 14,  K), K= 0, 3) / -2304,  0,  2,  7/
      DATA (KRELOC(  9,  0, 15,  K), K= 0, 3) /   128,  0,  0,  9/
C
      DATA  NRELOC(  9,  0) /15/
C
C=======================================================================
C          LAMBDA=9  MIU=1  YLM=C *
C          C=
C=======================================================================
C
      DATA (KOELOC(  9,  1,      K), K= 1, 3) /  -1, 855, 32768/
C
C=======================================================================
C          Y91 REAL PART
C=======================================================================
C
      DATA (KRELOC(  9,  1,  1,  K), K= 0, 3) /   7,  9,  0,  0/
      DATA (KRELOC(  9,  1,  2,  K), K= 0, 3) /  28,  7,  2,  0/
      DATA (KRELOC(  9,  1,  3,  K), K= 0, 3) /-280,  7,  0,  2/
      DATA (KRELOC(  9,  1,  4,  K), K= 0, 3) /  42,  5,  4,  0/
      DATA (KRELOC(  9,  1,  5,  K), K= 0, 3) /-840,  5,  2,  2/
      DATA (KRELOC(  9,  1,  6,  K), K= 0, 3) /1120,  5,  0,  4/
      DATA (KRELOC(  9,  1,  7,  K), K= 0, 3) /  28,  3,  6,  0/
      DATA (KRELOC(  9,  1,  8,  K), K= 0, 3) /-840,  3,  4,  2/
      DATA (KRELOC(  9,  1,  9,  K), K= 0, 3) /2240,  3,  2,  4/
      DATA (KRELOC(  9,  1, 10,  K), K= 0, 3) /-896,  3,  0,  6/
      DATA (KRELOC(  9,  1, 11,  K), K= 0, 3) /   7,  1,  8,  0/
      DATA (KRELOC(  9,  1, 12,  K), K= 0, 3) /-280,  1,  6,  2/
      DATA (KRELOC(  9,  1, 13,  K), K= 0, 3) /1120,  1,  4,  4/
      DATA (KRELOC(  9,  1, 14,  K), K= 0, 3) /-896,  1,  2,  6/
      DATA (KRELOC(  9,  1, 15,  K), K= 0, 3) / 128,  1,  0,  8/
C
      DATA  NRELOC(  9,  1) /15/
C
C=======================================================================
C          Y91 IMAGINARY PART
C=======================================================================
C
      DATA (KIMLOC(  9,  1,  1,  K), K= 0, 3) /   7,  8,  1,  0/
      DATA (KIMLOC(  9,  1,  2,  K), K= 0, 3) /  28,  6,  3,  0/
      DATA (KIMLOC(  9,  1,  3,  K), K= 0, 3) /-280,  6,  1,  2/
      DATA (KIMLOC(  9,  1,  4,  K), K= 0, 3) /  42,  4,  5,  0/
      DATA (KIMLOC(  9,  1,  5,  K), K= 0, 3) /-840,  4,  3,  2/
      DATA (KIMLOC(  9,  1,  6,  K), K= 0, 3) /1120,  4,  1,  4/
      DATA (KIMLOC(  9,  1,  7,  K), K= 0, 3) /  28,  2,  7,  0/
      DATA (KIMLOC(  9,  1,  8,  K), K= 0, 3) /-840,  2,  5,  2/
      DATA (KIMLOC(  9,  1,  9,  K), K= 0, 3) /2240,  2,  3,  4/
      DATA (KIMLOC(  9,  1, 10,  K), K= 0, 3) /-896,  2,  1,  6/
      DATA (KIMLOC(  9,  1, 11,  K), K= 0, 3) /   7,  0,  9,  0/
      DATA (KIMLOC(  9,  1, 12,  K), K= 0, 3) /-280,  0,  7,  2/
      DATA (KIMLOC(  9,  1, 13,  K), K= 0, 3) /1120,  0,  5,  4/
      DATA (KIMLOC(  9,  1, 14,  K), K= 0, 3) /-896,  0,  3,  6/
      DATA (KIMLOC(  9,  1, 15,  K), K= 0, 3) / 128,  0,  1,  8/
C
      DATA  NIMLOC(  9,  1) /15/
C
C=======================================================================
C          LAMBDA=9  MIU=2  YLM=C *
C          C=
C=======================================================================
C
      DATA (KOELOC(  9,  2,      K), K= 1, 3) /-1, 9405, 4096/
C
C=======================================================================
C          Y92 REAL PART
C=======================================================================
C
      DATA (KRELOC(  9,  2,  1,  K), K= 0, 3) /   7,  8,  0,  1/
      DATA (KRELOC(  9,  2,  2,  K), K= 0, 3) /  14,  6,  2,  1/
      DATA (KRELOC(  9,  2,  3,  K), K= 0, 3) / -70,  6,  0,  3/
      DATA (KRELOC(  9,  2,  4,  K), K= 0, 3) / -70,  4,  2,  3/
      DATA (KRELOC(  9,  2,  5,  K), K= 0, 3) / 112,  4,  0,  5/
      DATA (KRELOC(  9,  2,  6,  K), K= 0, 3) / -14,  2,  6,  1/
      DATA (KRELOC(  9,  2,  7,  K), K= 0, 3) /  70,  2,  4,  3/
      DATA (KRELOC(  9,  2,  8,  K), K= 0, 3) / -32,  2,  0,  7/
      DATA (KRELOC(  9,  2,  9,  K), K= 0, 3) /  -7,  0,  8,  1/
      DATA (KRELOC(  9,  2, 10,  K), K= 0, 3) /  70,  0,  6,  3/
      DATA (KRELOC(  9,  2, 11,  K), K= 0, 3) /-112,  0,  4,  5/
      DATA (KRELOC(  9,  2, 12,  K), K= 0, 3) /  32,  0,  2,  7/
C
      DATA  NRELOC(  9,  2) /12/
C
C=======================================================================
C          Y92 IMAGINARY PART
C=======================================================================
C
      DATA (KIMLOC(  9,  2,  1,  K), K= 0, 3) /  14,  7,  1,  1/
      DATA (KIMLOC(  9,  2,  2,  K), K= 0, 3) /  42,  5,  3,  1/
      DATA (KIMLOC(  9,  2,  3,  K), K= 0, 3) /-140,  5,  1,  3/
      DATA (KIMLOC(  9,  2,  4,  K), K= 0, 3) /  42,  3,  5,  1/
      DATA (KIMLOC(  9,  2,  5,  K), K= 0, 3) /-280,  3,  3,  3/
      DATA (KIMLOC(  9,  2,  6,  K), K= 0, 3) / 224,  3,  1,  5/
      DATA (KIMLOC(  9,  2,  7,  K), K= 0, 3) /  14,  1,  7,  1/
      DATA (KIMLOC(  9,  2,  8,  K), K= 0, 3) /-140,  1,  5,  3/
      DATA (KIMLOC(  9,  2,  9,  K), K= 0, 3) / 224,  1,  3,  5/
      DATA (KIMLOC(  9,  2, 10,  K), K= 0, 3) / -64,  1,  1,  7/
C
      DATA  NIMLOC(  9,  2) /10/
C
C=======================================================================
C          LAMBDA=9  MIU=3  YLM=C *
C          C=
C=======================================================================
C
      DATA (KOELOC(  9,  3,      K), K= 1, 3) /  1, 21945, 16384/
C
C=======================================================================
C          Y93 REAL PART
C=======================================================================
C
      DATA (KRELOC(  9,  3,  1,  K), K= 0, 3) /   1,  9,  0,  0/
      DATA (KRELOC(  9,  3,  2,  K), K= 0, 3) / -36,  7,  0,  2/
      DATA (KRELOC(  9,  3,  3,  K), K= 0, 3) /  -6,  5,  4,  0/
      DATA (KRELOC(  9,  3,  4,  K), K= 0, 3) /  36,  5,  2,  2/
      DATA (KRELOC(  9,  3,  5,  K), K= 0, 3) / 120,  5,  0,  4/
      DATA (KRELOC(  9,  3,  6,  K), K= 0, 3) /  -8,  3,  6,  0/
      DATA (KRELOC(  9,  3,  7,  K), K= 0, 3) / 180,  3,  4,  2/
      DATA (KRELOC(  9,  3,  8,  K), K= 0, 3) /-240,  3,  2,  4/
      DATA (KRELOC(  9,  3,  9,  K), K= 0, 3) / -64,  3,  0,  6/
      DATA (KRELOC(  9,  3, 10,  K), K= 0, 3) /  -3,  1,  8,  0/
      DATA (KRELOC(  9,  3, 11,  K), K= 0, 3) / 108,  1,  6,  2/
      DATA (KRELOC(  9,  3, 12,  K), K= 0, 3) /-360,  1,  4,  4/
      DATA (KRELOC(  9,  3, 13,  K), K= 0, 3) / 192,  1,  2,  6/
C
      DATA  NRELOC(  9,  3) /13/
C
C=======================================================================
C          Y93 IMAGINARY PART
C=======================================================================
C
      DATA (KIMLOC(  9,  3,  1,  K), K= 0, 3) /   3,  8,  1,  0/
      DATA (KIMLOC(  9,  3,  2,  K), K= 0, 3) /   8,  6,  3,  0/
      DATA (KIMLOC(  9,  3,  3,  K), K= 0, 3) /-108,  6,  1,  2/
      DATA (KIMLOC(  9,  3,  4,  K), K= 0, 3) /   6,  4,  5,  0/
      DATA (KIMLOC(  9,  3,  5,  K), K= 0, 3) /-180,  4,  3,  2/
      DATA (KIMLOC(  9,  3,  6,  K), K= 0, 3) / 360,  4,  1,  4/
      DATA (KIMLOC(  9,  3,  7,  K), K= 0, 3) / -36,  2,  5,  2/
      DATA (KIMLOC(  9,  3,  8,  K), K= 0, 3) / 240,  2,  3,  4/
      DATA (KIMLOC(  9,  3,  9,  K), K= 0, 3) /-192,  2,  1,  6/
      DATA (KIMLOC(  9,  3, 10,  K), K= 0, 3) /  -1,  0,  9,  0/
      DATA (KIMLOC(  9,  3, 11,  K), K= 0, 3) /  36,  0,  7,  2/
      DATA (KIMLOC(  9,  3, 12,  K), K= 0, 3) /-120,  0,  5,  4/
      DATA (KIMLOC(  9,  3, 13,  K), K= 0, 3) /  64,  0,  3,  6/
C
      DATA  NIMLOC(  9,  3) /13/
C
C=======================================================================
C          LAMBDA=9  MIU=4  YLM=C *
C          C=
C=======================================================================
C
      DATA (KOELOC(  9,  4,      K), K= 1, 3) /   1,855855,8192/
C
C=======================================================================
C          Y94 REAL PART
C=======================================================================
C
      DATA (KRELOC(  9,  4,  1,  K), K= 0, 3) /  1,  8,  0,  1/
      DATA (KRELOC(  9,  4,  2,  K), K= 0, 3) / -4,  6,  2,  1/
      DATA (KRELOC(  9,  4,  3,  K), K= 0, 3) / -8,  6,  0,  3/
      DATA (KRELOC(  9,  4,  4,  K), K= 0, 3) /-10,  4,  4,  1/
      DATA (KRELOC(  9,  4,  5,  K), K= 0, 3) / 40,  4,  2,  3/
      DATA (KRELOC(  9,  4,  6,  K), K= 0, 3) /  8,  4,  0,  5/
      DATA (KRELOC(  9,  4,  7,  K), K= 0, 3) / -4,  2,  6,  1/
      DATA (KRELOC(  9,  4,  8,  K), K= 0, 3) / 40,  2,  4,  3/
      DATA (KRELOC(  9,  4,  9,  K), K= 0, 3) /-48,  2,  2,  5/
      DATA (KRELOC(  9,  4, 10,  K), K= 0, 3) /  1,  0,  8,  1/
      DATA (KRELOC(  9,  4, 11,  K), K= 0, 3) / -8,  0,  6,  3/
      DATA (KRELOC(  9,  4, 12,  K), K= 0, 3) /  8,  0,  4,  5/
C
      DATA  NRELOC(  9,  4) /12/
C
C=======================================================================
C          Y94 IMAGINARY PART
C=======================================================================
C
      DATA (KIMLOC(  9,  4,  1,  K), K= 0, 3) /   4,  7,  1,  1/
      DATA (KIMLOC(  9,  4,  2,  K), K= 0, 3) /   4,  5,  3,  1/
      DATA (KIMLOC(  9,  4,  3,  K), K= 0, 3) / -32,  5,  1,  3/
      DATA (KIMLOC(  9,  4,  4,  K), K= 0, 3) /  -4,  3,  5,  1/
      DATA (KIMLOC(  9,  4,  5,  K), K= 0, 3) /  32,  3,  1,  5/
      DATA (KIMLOC(  9,  4,  6,  K), K= 0, 3) /  -4,  1,  7,  1/
      DATA (KIMLOC(  9,  4,  7,  K), K= 0, 3) /  32,  1,  5,  3/
      DATA (KIMLOC(  9,  4,  8,  K), K= 0, 3) / -32,  1,  3,  5/
C
      DATA  NIMLOC(  9,  4) /8/
C
C=======================================================================
C          LAMBDA=9  MIU=5  YLM=C *
C          C=
C=======================================================================
C
      DATA (KOELOC(  9,  5,      K), K= 1, 3) / -1, 24453, 16384/
C
C=======================================================================
C          Y95 REAL PART
C=======================================================================
C
      DATA (KRELOC(  9,  5,  1,  K), K= 0, 3) /   1,  9,  0,  0/
      DATA (KRELOC(  9,  5,  2,  K), K= 0, 3) /  -8,  7,  2,  0/
      DATA (KRELOC(  9,  5,  3,  K), K= 0, 3) / -28,  7,  0,  2/
      DATA (KRELOC(  9,  5,  4,  K), K= 0, 3) / -14,  5,  4,  0/
      DATA (KRELOC(  9,  5,  5,  K), K= 0, 3) / 252,  5,  2,  2/
      DATA (KRELOC(  9,  5,  6,  K), K= 0, 3) /  56,  5,  0,  4/
      DATA (KRELOC(  9,  5,  7,  K), K= 0, 3) / 140,  3,  4,  2/
      DATA (KRELOC(  9,  5,  8,  K), K= 0, 3) /-560,  3,  2,  4/
      DATA (KRELOC(  9,  5,  9,  K), K= 0, 3) /   5,  1,  8,  0/
      DATA (KRELOC(  9,  5, 10,  K), K= 0, 3) /-140,  1,  6,  2/
      DATA (KRELOC(  9,  5, 11,  K), K= 0, 3) / 280,  1,  4,  4/
C
      DATA  NRELOC(  9,  5) /11/
C
C=======================================================================
C          Y95 IMAGINARY PART
C=======================================================================
C
      DATA (KIMLOC(  9,  5,  1,  K), K= 0, 3) /   5,  8,  1,  0/
      DATA (KIMLOC(  9,  5,  2,  K), K= 0, 3) /-140,  6,  1,  2/
      DATA (KIMLOC(  9,  5,  3,  K), K= 0, 3) / -14,  4,  5,  0/
      DATA (KIMLOC(  9,  5,  4,  K), K= 0, 3) / 140,  4,  3,  2/
      DATA (KIMLOC(  9,  5,  5,  K), K= 0, 3) / 280,  4,  1,  4/
      DATA (KIMLOC(  9,  5,  6,  K), K= 0, 3) /  -8,  2,  7,  0/
      DATA (KIMLOC(  9,  5,  7,  K), K= 0, 3) / 252,  2,  5,  2/
      DATA (KIMLOC(  9,  5,  8,  K), K= 0, 3) /-560,  2,  3,  4/
      DATA (KIMLOC(  9,  5,  9,  K), K= 0, 3) /   1,  0,  9,  0/
      DATA (KIMLOC(  9,  5, 10,  K), K= 0, 3) / -28,  0,  7,  2/
      DATA (KIMLOC(  9,  5, 11,  K), K= 0, 3) /  56,  0,  5,  4/
C
      DATA  NIMLOC(  9,  5) /11/
C
C=======================================================================
C          LAMBDA=9  MIU=6  YLM=C *
C          C=
C=======================================================================
C
      DATA (KOELOC(  9,  6,      K), K= 1, 3) /  -1,  40755, 4096/
C
C=======================================================================
C          Y96 REAL PART
C=======================================================================
C
      DATA (KRELOC(  9,  6,  1,  K), K= 0, 3) /   3,  8,  0,  1/
      DATA (KRELOC(  9,  6,  2,  K), K= 0, 3) / -42,  6,  2,  1/
      DATA (KRELOC(  9,  6,  3,  K), K= 0, 3) / -14,  6,  0,  3/
      DATA (KRELOC(  9,  6,  4,  K), K= 0, 3) / 210,  4,  2,  3/
      DATA (KRELOC(  9,  6,  5,  K), K= 0, 3) /  42,  2,  6,  1/
      DATA (KRELOC(  9,  6,  6,  K), K= 0, 3) /-210,  2,  4,  3/
      DATA (KRELOC(  9,  6,  7,  K), K= 0, 3) /  -3,  0,  8,  1/
      DATA (KRELOC(  9,  6,  8,  K), K= 0, 3) /  14,  0,  6,  3/
C
      DATA  NRELOC(  9,  6) /8/
C
C=======================================================================
C          Y96 IMAGINARY PART
C=======================================================================
C
      DATA (KIMLOC(  9,  6,  1,  K), K= 0, 3) / 18,  7,  1,  1/
      DATA (KIMLOC(  9,  6,  2,  K), K= 0, 3) /-42,  5,  3,  1/
      DATA (KIMLOC(  9,  6,  3,  K), K= 0, 3) /-84,  5,  1,  3/
      DATA (KIMLOC(  9,  6,  4,  K), K= 0, 3) /-42,  3,  5,  1/
      DATA (KIMLOC(  9,  6,  5,  K), K= 0, 3) /280,  3,  3,  3/
      DATA (KIMLOC(  9,  6,  6,  K), K= 0, 3) / 18,  1,  7,  1/
      DATA (KIMLOC(  9,  6,  7,  K), K= 0, 3) /-84,  1,  5,  3/
C
      DATA  NIMLOC(  9,  6) /7/
C
C=======================================================================
C          LAMBDA=9  MIU=7  YLM=C *
C          C=
C=======================================================================
C
      DATA (KOELOC(  9,  7,      K), K= 1, 3) /  1, 122265, 65536/
C
C=======================================================================
C          Y97 REAL PART
C=======================================================================
C
      DATA (KRELOC(  9,  7,  1,  K), K= 0, 3) /   1,  9,  0,  0/
      DATA (KRELOC(  9,  7,  2,  K), K= 0, 3) / -20,  7,  2,  0/
      DATA (KRELOC(  9,  7,  3,  K), K= 0, 3) / -16,  7,  0,  2/
      DATA (KRELOC(  9,  7,  4,  K), K= 0, 3) /  14,  5,  4,  0/
      DATA (KRELOC(  9,  7,  5,  K), K= 0, 3) / 336,  5,  2,  2/
      DATA (KRELOC(  9,  7,  6,  K), K= 0, 3) /  28,  3,  6,  0/
      DATA (KRELOC(  9,  7,  7,  K), K= 0, 3) /-560,  3,  4,  2/
      DATA (KRELOC(  9,  7,  8,  K), K= 0, 3) /  -7,  1,  8,  0/
      DATA (KRELOC(  9,  7,  9,  K), K= 0, 3) / 112,  1,  6,  2/
C
      DATA  NRELOC(  9,  7) /9/
C
C=======================================================================
C          Y97 IMAGINARY PART
C=======================================================================
C
      DATA (KIMLOC(  9,  7,  1,  K), K= 0, 3) /   7,  8,  1,  0/
      DATA (KIMLOC(  9,  7,  2,  K), K= 0, 3) / -28,  6,  3,  0/
      DATA (KIMLOC(  9,  7,  3,  K), K= 0, 3) /-112,  6,  1,  2/
      DATA (KIMLOC(  9,  7,  4,  K), K= 0, 3) / -14,  4,  5,  0/
      DATA (KIMLOC(  9,  7,  5,  K), K= 0, 3) / 560,  4,  3,  2/
      DATA (KIMLOC(  9,  7,  6,  K), K= 0, 3) /  20,  2,  7,  0/
      DATA (KIMLOC(  9,  7,  7,  K), K= 0, 3) /-336,  2,  5,  2/
      DATA (KIMLOC(  9,  7,  8,  K), K= 0, 3) /  -1,  0,  9,  0/
      DATA (KIMLOC(  9,  7,  9,  K), K= 0, 3) /  16,  0,  7,  2/
C
      DATA  NIMLOC(  9,  7) /9/
C
C=======================================================================
C          LAMBDA=9  MIU=8  YLM=C *
C          C=
C=======================================================================
C
      DATA (KOELOC(  9,  8,      K), K= 1, 3) /  1, 2078505, 32768/
C
C=======================================================================
C          Y98 REAL PART
C=======================================================================
C
      DATA (KRELOC(  9,  8,  1,  K), K= 0, 3) /  1,  8,  0,  1/
      DATA (KRELOC(  9,  8,  2,  K), K= 0, 3) /-28,  6,  2,  1/
      DATA (KRELOC(  9,  8,  3,  K), K= 0, 3) / 70,  4,  4,  1/
      DATA (KRELOC(  9,  8,  4,  K), K= 0, 3) /-28,  2,  6,  1/
      DATA (KRELOC(  9,  8,  5,  K), K= 0, 3) /  1,  0,  8,  1/
C
      DATA  NRELOC(  9,  8) /5/
C
C=======================================================================
C          Y98 IMAGINARY PART
C=======================================================================
C
      DATA (KIMLOC(  9,  8,  1,  K), K= 0, 3) /  8,  7,  1,  1/
      DATA (KIMLOC(  9,  8,  2,  K), K= 0, 3) /-56,  5,  3,  1/
      DATA (KIMLOC(  9,  8,  3,  K), K= 0, 3) / 56,  3,  5,  1/
      DATA (KIMLOC(  9,  8,  4,  K), K= 0, 3) / -8,  1,  7,  1/
C
      DATA  NIMLOC(  9,  8) /4/
C
C=======================================================================
C          LAMBDA=9  MIU=9  YLM=C *
C          C=
C=======================================================================
C
      DATA (KOELOC(  9,  9,      K), K= 1, 3) / -1, 230945, 65536/
C
C=======================================================================
C          Y99 REAL PART
C=======================================================================
C
      DATA (KRELOC(  9,  9,  1,  K), K= 0, 3) /  1,  9,  0,  0/
      DATA (KRELOC(  9,  9,  2,  K), K= 0, 3) /-36,  7,  2,  0/
      DATA (KRELOC(  9,  9,  3,  K), K= 0, 3) /126,  5,  4,  0/
      DATA (KRELOC(  9,  9,  4,  K), K= 0, 3) /-84,  3,  6,  0/
      DATA (KRELOC(  9,  9,  5,  K), K= 0, 3) /  9,  1,  8,  0/
C
      DATA  NRELOC(  9,  9) /5/
C
C=======================================================================
C          Y99 IMAGINARY PART
C=======================================================================
C
      DATA (KIMLOC(  9,  9,  1,  K), K= 0, 3) /  9,  8,  1,  0/
      DATA (KIMLOC(  9,  9,  2,  K), K= 0, 3) /-84,  6,  3,  0/
      DATA (KIMLOC(  9,  9,  3,  K), K= 0, 3) /126,  4,  5,  0/
      DATA (KIMLOC(  9,  9,  4,  K), K= 0, 3) /-36,  2,  7,  0/
      DATA (KIMLOC(  9,  9,  5,  K), K= 0, 3) /  1,  0,  9,  0/
C
      DATA  NIMLOC(  9,  9) /5/
C
C=======================================================================
C          DETERMINING THE CONSTANT FACTORS AND REWRITING THE LOCAL
C          VARIABLES DEFINED IN  THE  DATA  STATEMENTS INTO COMMONS
C=======================================================================
C
      IF (MULMAX.NE.NDMULT) STOP 'MULMAX.NE.NDMULT IN DEFYLM'
C
      SQR4PI=SQRT(16.0D0*ATAN(1.0D0))
C
      DO LAMBDA=0,MULMAX
         DO MIU=0,LAMBDA
C
            COEYLM(LAMBDA,MIU) =  KOELOC(LAMBDA,MIU,1)
     *                 *SQRT(REAL(KOELOC(LAMBDA,MIU,2),KIND=8)/
     *                       REAL(KOELOC(LAMBDA,MIU,3),KIND=8))/SQR4PI
C
            NREYLM(LAMBDA,MIU) = NRELOC(LAMBDA,MIU)
C
            DO NUTERM=1,NREYLM(LAMBDA,MIU)
               DO KARTEZ=0,NDKART
C
                  KREYLM(LAMBDA,MIU,NUTERM,KARTEZ)=
     *            KRELOC(LAMBDA,MIU,NUTERM,KARTEZ)
C
               END DO
            END DO
C
            IF (MIU.GT.0) THEN
C
               NIMYLM(LAMBDA,MIU) = NIMLOC(LAMBDA,MIU)
C
               DO NUTERM=1,NIMYLM(LAMBDA,MIU)
                  DO KARTEZ=0,NDKART
C
                     KIMYLM(LAMBDA,MIU,NUTERM,KARTEZ)=
     *               KIMLOC(LAMBDA,MIU,NUTERM,KARTEZ)
C
                  END DO
               END DO
C
            END IF
C
         END DO
      END DO
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE DEFSLM
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      COMMON
     *       /DATYLM/ COEYLM(0:NDMULT,0:NDMULT),
     *
     *                NREYLM(0:NDMULT,0:NDMULT),
     *                KREYLM(0:NDMULT,0:NDMULT,1:NDTERM,0:NDKART),
     *
     *                NIMYLM(0:NDMULT,1:NDMULT),
     *                KIMYLM(0:NDMULT,1:NDMULT,1:NDTERM,0:NDKART)
C
      COMMON
     *       /DATSLM/ COESLM(0:NDMULT,0:NDMULT),
     *
     *                NRESLM(0:NDMULT,0:NDMULT),
     *                KRESLM(0:NDMULT,0:NDMULT,NDTERM*NDKART,0:NDKART),
     *
     *                NIMSLM(0:NDMULT,1:NDMULT),
     *                KIMSLM(0:NDMULT,1:NDMULT,NDTERM*NDKART,0:NDKART)
      DATA
     *        MULMAX / 9 /
C
C=======================================================================
C
C         THIS SUBROUTINE DEFINES THE TERMS APPEARING IN THE
C
C                   S U R F A C E    H A R M O N I C S
C
C         (SPHERICAL HARMONICS  *  R**(LAMBDA+2)).  THE CONVENTIONS USED
C         TO STORE THEM ARE EXACTLY THE SAME AS USED IN "DEFYLM" --- SEE
C         THE COMMENTS THERE. EACH TERM OF THE SOLID HARMONICS  IS  HERE
C         MULTIPLIED BY  R^2=X^2+Y^2+Z^2. HENCE THE NUMBER OF TERMS  NOW
C         BECOMES THREE TIMES LARGER. WE DO NOT CARE ABOUT THE FACT THAT
C         SOME OF THESE TERMS MIGHT HAVE THE SAME POWERS OF COORDINATES.
C
C=======================================================================
C
C         THIS SUBROUTINE DEFINES MULTIPOLES UP TO THE VALUE
C         OF "MULMAX" DEFINED ABOVE. THIS VALUE MUST NOT  BE
C         SMALLER THAN:
C
C                      NSIMAX < OR =  MULMAX
C
C         AS A SAFETY MEASURE,  THE  CODE REQUIRES THAT THE
C         DIMENSION  DECLARATION  "NDMULT"  IS  NECESSARILY
C         EQUAL TO "MULMAX".
C
C=======================================================================
C
      IF (MULMAX.NE.NDMULT) STOP 'MULMAX.NE.NDMULT IN DEFSLM'
C
C=======================================================================
C
      DO LAMBDA=0,MULMAX
         DO MIU=0,LAMBDA
C
            DO NUTERM=1,NREYLM(LAMBDA,MIU)
               DO KARTEZ=0,NDKART
                  DO KARTER=1,NDKART
C
                    KRESLM(LAMBDA,MIU,NDKART*(NUTERM-1)+KARTER,KARTEZ)=
     *              KREYLM(LAMBDA,MIU,NUTERM,                  KARTEZ)
C
                    IF (KARTER.EQ.KARTEZ)
     *
     *              KRESLM(LAMBDA,MIU,NDKART*(NUTERM-1)+KARTER,KARTEZ)=
     *              KRESLM(LAMBDA,MIU,NDKART*(NUTERM-1)+KARTER,KARTEZ)+2
C
                  END DO
               END DO
            END DO
C
            COESLM(LAMBDA,MIU)=       COEYLM(LAMBDA,MIU)
            NRESLM(LAMBDA,MIU)=NDKART*NREYLM(LAMBDA,MIU)
C
            IF (MIU.GT.0) THEN
C
            DO NUTERM=1,NIMYLM(LAMBDA,MIU)
               DO KARTEZ=0,NDKART
                  DO KARTER=1,NDKART
C
                    KIMSLM(LAMBDA,MIU,NDKART*(NUTERM-1)+KARTER,KARTEZ)=
     *              KIMYLM(LAMBDA,MIU,NUTERM,                  KARTEZ)
C
                    IF (KARTER.EQ.KARTEZ)
     *
     *              KIMSLM(LAMBDA,MIU,NDKART*(NUTERM-1)+KARTER,KARTEZ)=
     *              KIMSLM(LAMBDA,MIU,NDKART*(NUTERM-1)+KARTER,KARTEZ)+2
C
                  END DO
               END DO
            END DO
C
            NIMSLM(LAMBDA,MIU)=NDKART*NIMYLM(LAMBDA,MIU)
C
            END IF
C
         END DO
      END DO
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE DEFPLM
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      COMMON
     *       /DATSLM/ COESLM(0:NDMULT,0:NDMULT),
     *
     *                NRESLM(0:NDMULT,0:NDMULT),
     *                KRESLM(0:NDMULT,0:NDMULT,NDTERM*NDKART,0:NDKART),
     *
     *                NIMSLM(0:NDMULT,1:NDMULT),
     *                KIMSLM(0:NDMULT,1:NDMULT,NDTERM*NDKART,0:NDKART)
C
      COMMON
     *       /DATPLM/ COEPLM(0:NDMULT,0:NDMULT),
     *
     *                NREPLM(0:NDMULT,0:NDMULT),
     *                KREPLM(0:NDMULT,0:NDMULT,NDTERM*NDKART*NDKART,
     *                                                     0:NDKART),
     *
     *                NIMPLM(0:NDMULT,1:NDMULT),
     *                KIMPLM(0:NDMULT,1:NDMULT,NDTERM*NDKART*NDKART,
     *                                                     0:NDKART)
      DATA
     *        MULMAX / 9 /
C
C=======================================================================
C
C         THIS SUBROUTINE DEFINES THE TERMS APPEARING IN THE
C
C                   P E N S U R F A C E    H A R M O N I C S
C
C         (SPHERICAL HARMONICS  *  R**(LAMBDA+4)).  THE CONVENTIONS USED
C         TO STORE THEM ARE EXACTLY THE SAME AS USED IN "DEFYLM" --- SEE
C         THE COMMENTS THERE. EACH TERM OF THE SURFACE HARMONICS IS HERE
C         MULTIPLIED BY  R^2=X^2+Y^2+Z^2. HENCE THE NUMBER OF TERMS  NOW
C         BECOMES THREE TIMES LARGER THAN FOR THE SURFACE HARMONICS  AND
C         NINE TIMES LARGER THAN FOR THE SOLID HARMONICS. WE DO NOT CARE
C         ABOUT THE FACT THAT SOME OF THESE TERMS MIGHT  HAVE  THE  SAME
C         POWERS OF COORDINATES.
C
C=======================================================================
C
C         THIS SUBROUTINE DEFINES MULTIPOLES UP TO THE VALUE
C         OF "MULMAX" DEFINED ABOVE. THIS VALUE MUST NOT  BE
C         SMALLER THAN:
C
C                      NSIMAX < OR =  MULMAX
C
C         AS A SAFETY MEASURE,  THE  CODE REQUIRES THAT THE
C         DIMENSION  DECLARATION  "NDMULT"  IS  NECESSARILY
C         EQUAL TO "MULMAX".
C
C=======================================================================
C
      IF (MULMAX.NE.NDMULT) STOP 'MULMAX.NE.NDMULT IN DEFPLM'
C
C=======================================================================
C
      DO LAMBDA=0,MULMAX
         DO MIU=0,LAMBDA
C
            DO NUTERM=1,NRESLM(LAMBDA,MIU)
               DO KARTEZ=0,NDKART
                  DO KARTER=1,NDKART
C
                    KREPLM(LAMBDA,MIU,NDKART*(NUTERM-1)+KARTER,KARTEZ)=
     *              KRESLM(LAMBDA,MIU,NUTERM,                  KARTEZ)
C
                    IF (KARTER.EQ.KARTEZ)
     *
     *              KREPLM(LAMBDA,MIU,NDKART*(NUTERM-1)+KARTER,KARTEZ)=
     *              KREPLM(LAMBDA,MIU,NDKART*(NUTERM-1)+KARTER,KARTEZ)+2
C
                  END DO
               END DO
            END DO
C
            COEPLM(LAMBDA,MIU)=       COESLM(LAMBDA,MIU)
            NREPLM(LAMBDA,MIU)=NDKART*NRESLM(LAMBDA,MIU)
C
            IF (MIU.GT.0) THEN
C
            DO NUTERM=1,NIMSLM(LAMBDA,MIU)
               DO KARTEZ=0,NDKART
                  DO KARTER=1,NDKART
C
                    KIMPLM(LAMBDA,MIU,NDKART*(NUTERM-1)+KARTER,KARTEZ)=
     *              KIMSLM(LAMBDA,MIU,NUTERM,                  KARTEZ)
C
                    IF (KARTER.EQ.KARTEZ)
     *
     *              KIMPLM(LAMBDA,MIU,NDKART*(NUTERM-1)+KARTER,KARTEZ)=
     *              KIMPLM(LAMBDA,MIU,NDKART*(NUTERM-1)+KARTER,KARTEZ)+2
C
                  END DO
               END DO
            END DO
C
            NIMPLM(LAMBDA,MIU)=NDKART*NIMSLM(LAMBDA,MIU)
C
            END IF
C
         END DO
      END DO
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE DEFVLM
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      COMMON
     *       /DATYLM/ COEYLM(0:NDMULT,0:NDMULT),
     *
     *                NREYLM(0:NDMULT,0:NDMULT),
     *                KREYLM(0:NDMULT,0:NDMULT,1:NDTERM,0:NDKART),
     *
     *                NIMYLM(0:NDMULT,1:NDMULT),
     *                KIMYLM(0:NDMULT,1:NDMULT,1:NDTERM,0:NDKART)
C
      COMMON
     *       /DATVLM/ COEVLM(0:NDMULT,0:NDMULT),
     *
     *                NREVLM(0:NDMULT,0:NDMULT),
     *                KREVLM(0:NDMULT,0:NDMULT,NDTERM,NDKART,0:NDKART),
     *
     *                NIMVLM(0:NDMULT,1:NDMULT),
     *                KIMVLM(0:NDMULT,1:NDMULT,NDTERM,NDKART,0:NDKART)
      DATA
     *        MULMAX / 9 /
C
C=======================================================================
C
C         THIS SUBROUTINE DEFINES THE TERMS APPEARING IN THE
C
C                   V E C T O R    H A R M O N I C S
C
C         =SPHERICAL HARMONICS*R**(LAMBDA)*(X,Y,Z). THE CONVENTIONS USED
C         TO STORE THEM ARE EXACTLY THE SAME AS USED IN "DEFYLM" --- SEE
C         THE COMMENTS THERE. EACH TERM OF THE SOLID HARMONICS  IS  HERE
C         MULTIPLIED BY  X  OR  Y  OR  Z. HENCE THE NUMBER OF TERMS  NOW
C         BECOMES THREE TIMES LARGER. THE ADDITIONAL INDEX  IS  USED  TO
C         INDICATE ONE OF THE THREE CARTESIAN COORDINATES.
C
C=======================================================================
C
C         THIS SUBROUTINE DEFINES MULTIPOLES UP TO THE VALUE
C         OF "MULMAX" DEFINED ABOVE. THIS VALUE MUST NOT  BE
C         SMALLER THAN:
C
C                      NSIMAX < OR =  MULMAX
C
C         AS A SAFETY MEASURE,  THE  CODE REQUIRES THAT THE
C         DIMENSION  DECLARATION  "NDMULT"  IS  NECESSARILY
C         EQUAL TO "MULMAX".
C
C=======================================================================
C
      IF (MULMAX.NE.NDMULT) STOP 'MULMAX.NE.NDMULT IN DEFVLM'
C
C=======================================================================
C
      DO LAMBDA=0,MULMAX
         DO MIU=0,LAMBDA
C
            DO NUTERM=1,NREYLM(LAMBDA,MIU)
               DO KARTEZ=0,NDKART
                  DO KARTER=1,NDKART
C
                    KREVLM(LAMBDA,MIU,NUTERM,KARTER,KARTEZ)=
     *              KREYLM(LAMBDA,MIU,NUTERM,       KARTEZ)
C
                    IF (KARTER.EQ.KARTEZ)
     *
     *              KREVLM(LAMBDA,MIU,NUTERM,KARTER,KARTEZ)=
     *              KREVLM(LAMBDA,MIU,NUTERM,KARTER,KARTEZ)+1
C
                  END DO
               END DO
            END DO
C
            COEVLM(LAMBDA,MIU)=COEYLM(LAMBDA,MIU)
            NREVLM(LAMBDA,MIU)=NREYLM(LAMBDA,MIU)
C
            IF (MIU.GT.0) THEN
C
            DO NUTERM=1,NIMYLM(LAMBDA,MIU)
               DO KARTEZ=0,NDKART
                  DO KARTER=1,NDKART
C
                    KIMVLM(LAMBDA,MIU,NUTERM,KARTER,KARTEZ)=
     *              KIMYLM(LAMBDA,MIU,NUTERM,       KARTEZ)
C
                    IF (KARTER.EQ.KARTEZ)
     *
     *              KIMVLM(LAMBDA,MIU,NUTERM,KARTER,KARTEZ)=
     *              KIMVLM(LAMBDA,MIU,NUTERM,KARTER,KARTEZ)+1
C
                  END DO
               END DO
            END DO
C
            NIMVLM(LAMBDA,MIU)=NIMYLM(LAMBDA,MIU)
C
            END IF
C
         END DO
      END DO
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE INTMUL(IPHASE,ELEMUL,COFMUL,LAMBDA,MIU,IMAREA)
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      DIMENSION
     *          IPHASE(0:NDYMAX,0:NDYMAX)
      DIMENSION
     *          ELEMUL(1:NDBASE,1:NDBASE)
      DIMENSION
     *          COFMUL(0:NDMULT,0:NDOSCI,0:NDOSCI,1:NDKART)
C
      COMMON
     *       /BASISO/ NXVECT(1:NDBASE),NYVECT(1:NDBASE),NZVECT(1:NDBASE)
      COMMON
     *       /DIMENS/ LDBASE
      COMMON
     *       /DATYLM/ COEYLM(0:NDMULT,0:NDMULT),
     *
     *                NREYLM(0:NDMULT,0:NDMULT),
     *                KREYLM(0:NDMULT,0:NDMULT,1:NDTERM,0:NDKART),
     *
     *                NIMYLM(0:NDMULT,1:NDMULT),
     *                KIMYLM(0:NDMULT,1:NDMULT,1:NDTERM,0:NDKART)
      COMMON
     *       /OURUNI/ QUNITS(0:NDMULT,0:NDMULT)
C
C=======================================================================
C
      CALL CPUTIM('INTMUL',1)
C
C=======================================================================
C      THIS SUBROUTINE CALCULATES MATRIX ELEMENTS OF MULTIPOLE OPERATORS
C                     R**LAMBDA*CONJG(Y(LAMBDA,MIU))
C
C      SEE J.D. JACKSON, CLASSICAL ELECTRODYNAMICS,  EQ. (4.3)
C
C      IMAREA = 1 (-1) REQUESTS CALCULATION OF THE REAL (IMAGINARY) PART
C=======================================================================
C
      NIU=ABS(MIU)
C
      IF (MIU.GE.0) THEN
          JPHASE=IMAREA
      ELSE
          JPHASE=(-1)**MIU
      END IF
C
C=======================================================================
C      1) FOR NON-NEGATIVE VALUES OF "MIU", THE MATRIX  ELEMENTS
C      OF Y(L,MIU) ( W I T H O U T  THE COMPLEX CONJUGATION) ARE
C      CALCULATED EXPLICITLY USING NIU=ABS(MIU)=+MIU. NEXT, THE
C      REAL PARTS ARE NOT CHANGED, WHILE THE IMAGINARY PARTS ARE
C      MULTIPLIED BY -1. THIS AMOUNTS TO MULTIPLYING THE  RESULT
C      BY JPHASE=IMAREA.
C=======================================================================
C      2) FOR     NEGATIVE VALUES OF "MIU", THE MATRIX  ELEMENTS
C      OF Y(L,MIU) ( W I T H O U T  THE COMPLEX CONJUGATION) ARE
C      CALCULATED EXPLICITLY USING NIU=ABS(MIU)=-MIU. NEXT, THE
C      FORMULA     Y(L,MIU)=(-1)**MIU*CONJG(Y(L,-MIU))  IS USED.
C      THIS AMOUNTS TO MULTIPLYING THE REAL AND IMAGINARY PARTS
C      BY JPHASE=(-1)**MIU
C=======================================================================
C
      ELEMUL(:,:)=0.0D0
C
      IF (IMAREA.EQ.1) THEN
C
C=======================================================================
C         CALCULATING THE REAL PART
C=======================================================================
C
          DO NUTERM=1,NREYLM(LAMBDA,NIU)
C
             DO IKET=1,LDBASE
C
                NX_KET=NXVECT(IKET)
                NY_KET=NYVECT(IKET)
                NZ_KET=NZVECT(IKET)
C
                DO IBRA=1,LDBASE
C
                   NX_BRA=NXVECT(IBRA)
                   NY_BRA=NYVECT(IBRA)
                   NZ_BRA=NZVECT(IBRA)
C
                   ELEMUL(IBRA,IKET) =
     *             ELEMUL(IBRA,IKET) + KREYLM(LAMBDA,NIU,NUTERM,0)
     *
     *           * COFMUL(KREYLM(LAMBDA,NIU,NUTERM,1),NX_BRA,NX_KET,1)
     *           * COFMUL(KREYLM(LAMBDA,NIU,NUTERM,2),NY_BRA,NY_KET,2)
     *           * COFMUL(KREYLM(LAMBDA,NIU,NUTERM,3),NZ_BRA,NZ_KET,3)
     *
     *           * JPHASE
C
                END DO
             END DO
C
          END DO
C
      ELSE
C
          IF (MIU.EQ.0) STOP 'NO IMAGINARY PART FOR MIU=0 IN INTMUL'
C
C=======================================================================
C         CALCULATING THE IMAGINARY PART
C=======================================================================
C
          DO NUTERM=1,NIMYLM(LAMBDA,NIU)
C
             DO IKET=1,LDBASE
C
                NX_KET=NXVECT(IKET)
                NY_KET=NYVECT(IKET)
                NZ_KET=NZVECT(IKET)
C
                DO IBRA=1,LDBASE
C
                   NX_BRA=NXVECT(IBRA)
                   NY_BRA=NYVECT(IBRA)
                   NZ_BRA=NZVECT(IBRA)
C
                   ELEMUL(IBRA,IKET) =
     *             ELEMUL(IBRA,IKET) + KIMYLM(LAMBDA,NIU,NUTERM,0)
     *
     *           * COFMUL(KIMYLM(LAMBDA,NIU,NUTERM,1),NX_BRA,NX_KET,1)
     *           * COFMUL(KIMYLM(LAMBDA,NIU,NUTERM,2),NY_BRA,NY_KET,2)
     *           * COFMUL(KIMYLM(LAMBDA,NIU,NUTERM,3),NZ_BRA,NZ_KET,3)
     *
     *           * JPHASE
C
                END DO
             END DO
C
          END DO
C
      END IF
C
C=======================================================================
C        NORMALIZATION FACTOR AND PHASE
C=======================================================================
C
      DO IKET=1,LDBASE
         NY_KET=NYVECT(IKET)
         DO IBRA=1,LDBASE
            NY_BRA=NYVECT(IBRA)
C
            ELEMUL(IBRA,IKET) = ELEMUL(IBRA,IKET)
     *
     *                        * COEYLM(LAMBDA,NIU)
     *
     *                        * IPHASE(NY_BRA,NY_KET)
C
         END DO
      END DO
C
C=======================================================================
C        FOLLOWS MULTIPLICATION BY THE UNITS DEFINED ONCE FOR ALL IN THE
C        SUBROUTINE "DEFUNI".  THE  SAME  UNITS ARE IMPLIED FOR POSITIVE
C        AND NEGATIVE VALUES OF "MIU".
C=======================================================================
C
      DO IKET=1,LDBASE
         DO IBRA=1,LDBASE
            ELEMUL(IBRA,IKET)=ELEMUL(IBRA,IKET)*QUNITS(LAMBDA,NIU)
         END DO
      END DO
C
C=======================================================================
C
      CALL CPUTIM('INTMUL',0)
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE INTSIF(IPHASE,ELEMUL,COFMUL,LAMBDA,MIU,IMAREA)
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      DIMENSION
     *          IPHASE(0:NDYMAX,0:NDYMAX)
      DIMENSION
     *          ELEMUL(1:NDBASE,1:NDBASE)
      DIMENSION
     *          COFMUL(0:NDMULT,0:NDOSCI,0:NDOSCI,1:NDKART)
C
      COMMON
     *       /BASISO/ NXVECT(1:NDBASE),NYVECT(1:NDBASE),NZVECT(1:NDBASE)
      COMMON
     *       /DIMENS/ LDBASE
      COMMON
     *       /DATSLM/ COESLM(0:NDMULT,0:NDMULT),
     *
     *                NRESLM(0:NDMULT,0:NDMULT),
     *                KRESLM(0:NDMULT,0:NDMULT,NDTERM*NDKART,0:NDKART),
     *
     *                NIMSLM(0:NDMULT,1:NDMULT),
     *                KIMSLM(0:NDMULT,1:NDMULT,NDTERM*NDKART,0:NDKART)
      COMMON
     *       /SIFUNI/ SUNITS(0:NDMULT,0:NDMULT)
C
C=======================================================================
C
      CALL CPUTIM('INTSIF',1)
C
C=======================================================================
C      THIS SUBROUTINE CALCULATES MATRIX ELEMENTS OF SURFACE OPERATORS
C                   R**(LAMBDA+2)*CONJG(Y(LAMBDA,MIU))
C
C      IMAREA = 1 (-1) REQUESTS CALCULATION OF THE REAL (IMAGINARY) PART
C=======================================================================
C       THE STRUCTURE OF THIS SUBROUTINE IS EXACTLY THE SAME  AS
C       THE STRUCTURE OF SUBROUTINE "INTMUL"; SEE COMMENTS THERE
C       FOR MORE DETAILS.
C=======================================================================
C
       NIU=ABS(MIU)
C
       IF (MIU.GE.0) THEN
           JPHASE=IMAREA
       ELSE
           JPHASE=(-1)**MIU
       END IF
C
      ELEMUL(:,:)=0.0D0
C
      IF (IMAREA.EQ.1) THEN
C
C=======================================================================
C         CALCULATING THE REAL PART
C=======================================================================
C
          DO NUTERM=1,NRESLM(LAMBDA,NIU)
C
             DO IKET=1,LDBASE
C
                NX_KET=NXVECT(IKET)
                NY_KET=NYVECT(IKET)
                NZ_KET=NZVECT(IKET)
C
                DO IBRA=1,LDBASE
C
                   NX_BRA=NXVECT(IBRA)
                   NY_BRA=NYVECT(IBRA)
                   NZ_BRA=NZVECT(IBRA)
C
                   ELEMUL(IBRA,IKET) =
     *             ELEMUL(IBRA,IKET) + KRESLM(LAMBDA,NIU,NUTERM,0)
     *
     *           * COFMUL(KRESLM(LAMBDA,NIU,NUTERM,1)
     *                                     ,NX_BRA,NX_KET,1)
     *
     *           * COFMUL(KRESLM(LAMBDA,NIU,NUTERM,2)
     *                                     ,NY_BRA,NY_KET,2)
     *
     *           * COFMUL(KRESLM(LAMBDA,NIU,NUTERM,3)
     *                                     ,NZ_BRA,NZ_KET,3)
     *
     *           * JPHASE
C
                END DO
             END DO
          END DO
C
      ELSE
C
          IF (MIU.EQ.0) STOP 'NO IMAGINARY PART FOR MIU=0 IN INTSIF'
C
C=======================================================================
C         CALCULATING THE IMAGINARY PART
C=======================================================================
C
          DO NUTERM=1,NIMSLM(LAMBDA,NIU)
C
             DO IKET=1,LDBASE
C
                NX_KET=NXVECT(IKET)
                NY_KET=NYVECT(IKET)
                NZ_KET=NZVECT(IKET)
C
                DO IBRA=1,LDBASE
C
                   NX_BRA=NXVECT(IBRA)
                   NY_BRA=NYVECT(IBRA)
                   NZ_BRA=NZVECT(IBRA)
C
                   ELEMUL(IBRA,IKET) =
     *             ELEMUL(IBRA,IKET) + KIMSLM(LAMBDA,NIU,NUTERM,0)
     *
     *           * COFMUL(KIMSLM(LAMBDA,NIU,NUTERM,1)
     *                                     ,NX_BRA,NX_KET,1)
     *
     *           * COFMUL(KIMSLM(LAMBDA,NIU,NUTERM,2)
     *                                     ,NY_BRA,NY_KET,2)
     *
     *           * COFMUL(KIMSLM(LAMBDA,NIU,NUTERM,3)
     *                                     ,NZ_BRA,NZ_KET,3)
     *
     *           * JPHASE
C
                END DO
             END DO
          END DO
C
      END IF
C
C=======================================================================
C        NORMALIZATION FACTOR AND PHASE
C=======================================================================
C
      DO IKET=1,LDBASE
         NY_KET=NYVECT(IKET)
         DO IBRA=1,LDBASE
            NY_BRA=NYVECT(IBRA)
C
            ELEMUL(IBRA,IKET) = ELEMUL(IBRA,IKET)
     *
     *                        * COESLM(LAMBDA,NIU)
     *
     *                        * IPHASE(NY_BRA,NY_KET)
C
         END DO
      END DO
C
C=======================================================================
C        FOLLOWS MULTIPLICATION BY THE UNITS DEFINED ONCE FOR ALL IN THE
C        SUBROUTINE "DEFUNI".  THE  SAME  UNITS ARE IMPLIED FOR POSITIVE
C        AND NEGATIVE VALUES OF "MIU".
C=======================================================================
C
      DO IKET=1,LDBASE
         DO IBRA=1,LDBASE
            ELEMUL(IBRA,IKET)=ELEMUL(IBRA,IKET)*SUNITS(LAMBDA,NIU)
         END DO
      END DO
C
C=======================================================================
C
      CALL CPUTIM('INTSIF',0)
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE INTPLM(IPHASE,ELEMUL,COFMUL,LAMBDA,MIU,IMAREA)
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      DIMENSION
     *          IPHASE(0:NDYMAX,0:NDYMAX)
      DIMENSION
     *          ELEMUL(1:NDBASE,1:NDBASE)
      DIMENSION
     *          COFMUL(0:NDMULT,0:NDOSCI,0:NDOSCI,1:NDKART)
C
      COMMON
     *       /BASISO/ NXVECT(1:NDBASE),NYVECT(1:NDBASE),NZVECT(1:NDBASE)
      COMMON
     *       /DIMENS/ LDBASE
      COMMON
     *       /DATPLM/ COEPLM(0:NDMULT,0:NDMULT),
     *
     *                NREPLM(0:NDMULT,0:NDMULT),
     *                KREPLM(0:NDMULT,0:NDMULT,NDTERM*NDKART*NDKART,
     *                                                     0:NDKART),
     *
     *                NIMPLM(0:NDMULT,1:NDMULT),
     *                KIMPLM(0:NDMULT,1:NDMULT,NDTERM*NDKART*NDKART,
     *                                                     0:NDKART)
      COMMON
     *       /PLMUNI/ PUNITS(0:NDMULT,0:NDMULT)
C
C=======================================================================
C
      CALL CPUTIM('INTPLM',1)
C
C=======================================================================
C      THIS SUBROUTINE CALCULATES MATRIX ELEMENTS OF PENSURFACE OPERATOR
C                   R**(LAMBDA+4)*CONJG(Y(LAMBDA,MIU))
C
C      IMAREA = 1 (-1) REQUESTS CALCULATION OF THE REAL (IMAGINARY) PART
C=======================================================================
C       THE STRUCTURE OF THIS SUBROUTINE IS EXACTLY THE SAME  AS
C       THE STRUCTURE OF SUBROUTINE "INTMUL"; SEE COMMENTS THERE
C       FOR MORE DETAILS.
C=======================================================================
C
       NIU=ABS(MIU)
C
       IF (MIU.GE.0) THEN
           JPHASE=IMAREA
       ELSE
           JPHASE=(-1)**MIU
       END IF
C
      ELEMUL(:,:)=0.0D0
C
      IF (IMAREA.EQ.1) THEN
C
C=======================================================================
C         CALCULATING THE REAL PART
C=======================================================================
C
          DO NUTERM=1,NREPLM(LAMBDA,NIU)
C
             DO IKET=1,LDBASE
C
                NX_KET=NXVECT(IKET)
                NY_KET=NYVECT(IKET)
                NZ_KET=NZVECT(IKET)
C
                DO IBRA=1,LDBASE
C
                   NX_BRA=NXVECT(IBRA)
                   NY_BRA=NYVECT(IBRA)
                   NZ_BRA=NZVECT(IBRA)
C
                   ELEMUL(IBRA,IKET) =
     *             ELEMUL(IBRA,IKET) + KREPLM(LAMBDA,NIU,NUTERM,0)
     *
     *           * COFMUL(KREPLM(LAMBDA,NIU,NUTERM,1)
     *                                     ,NX_BRA,NX_KET,1)
     *
     *           * COFMUL(KREPLM(LAMBDA,NIU,NUTERM,2)
     *                                     ,NY_BRA,NY_KET,2)
     *
     *           * COFMUL(KREPLM(LAMBDA,NIU,NUTERM,3)
     *                                     ,NZ_BRA,NZ_KET,3)
     *
     *           * JPHASE
C
                END DO
             END DO
          END DO
C
      ELSE
C
          IF (MIU.EQ.0) STOP 'NO IMAGINARY PART FOR MIU=0 IN INTPLM'
C
C=======================================================================
C         CALCULATING THE IMAGINARY PART
C=======================================================================
C
          DO NUTERM=1,NIMPLM(LAMBDA,NIU)
C
             DO IKET=1,LDBASE
C
                NX_KET=NXVECT(IKET)
                NY_KET=NYVECT(IKET)
                NZ_KET=NZVECT(IKET)
C
                DO IBRA=1,LDBASE
C
                   NX_BRA=NXVECT(IBRA)
                   NY_BRA=NYVECT(IBRA)
                   NZ_BRA=NZVECT(IBRA)
C
                   ELEMUL(IBRA,IKET) =
     *             ELEMUL(IBRA,IKET) + KIMPLM(LAMBDA,NIU,NUTERM,0)
     *
     *           * COFMUL(KIMPLM(LAMBDA,NIU,NUTERM,1)
     *                                     ,NX_BRA,NX_KET,1)
     *
     *           * COFMUL(KIMPLM(LAMBDA,NIU,NUTERM,2)
     *                                     ,NY_BRA,NY_KET,2)
     *
     *           * COFMUL(KIMPLM(LAMBDA,NIU,NUTERM,3)
     *                                     ,NZ_BRA,NZ_KET,3)
     *
     *           * JPHASE
C
                END DO
             END DO
          END DO
C
      END IF
C
C=======================================================================
C        NORMALIZATION FACTOR AND PHASE
C=======================================================================
C
      DO IKET=1,LDBASE
         NY_KET=NYVECT(IKET)
         DO IBRA=1,LDBASE
            NY_BRA=NYVECT(IBRA)
C
            ELEMUL(IBRA,IKET) = ELEMUL(IBRA,IKET)
     *
     *                        * COEPLM(LAMBDA,NIU)
     *
     *                        * IPHASE(NY_BRA,NY_KET)
C
         END DO
      END DO
C
C=======================================================================
C        FOLLOWS MULTIPLICATION BY THE UNITS DEFINED ONCE FOR ALL IN THE
C        SUBROUTINE "DEFUNI".  THE  SAME  UNITS ARE IMPLIED FOR POSITIVE
C        AND NEGATIVE VALUES OF "MIU".
C=======================================================================
C
      DO IKET=1,LDBASE
         DO IBRA=1,LDBASE
            ELEMUL(IBRA,IKET)=ELEMUL(IBRA,IKET)*PUNITS(LAMBDA,NIU)
         END DO
      END DO
C
C=======================================================================
C
      CALL CPUTIM('INTPLM',0)
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE INTVMU(IPHASE,ELEMUL,COFMUL,LAMBDA,MIU,KARTEZ,IMAREA)
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      DIMENSION
     *          IPHASE(0:NDYMAX,0:NDYMAX)
      DIMENSION
     *          ELEMUL(1:NDBASE,1:NDBASE)
      DIMENSION
     *          COFMUL(0:NDMULT,0:NDOSCI,0:NDOSCI,1:NDKART)
C
      COMMON
     *       /BASISO/ NXVECT(1:NDBASE),NYVECT(1:NDBASE),NZVECT(1:NDBASE)
      COMMON
     *       /DIMENS/ LDBASE
      COMMON
     *       /DATVLM/ COEVLM(0:NDMULT,0:NDMULT),
     *
     *                NREVLM(0:NDMULT,0:NDMULT),
     *                KREVLM(0:NDMULT,0:NDMULT,NDTERM,NDKART,0:NDKART),
     *
     *                NIMVLM(0:NDMULT,1:NDMULT),
     *                KIMVLM(0:NDMULT,1:NDMULT,NDTERM,NDKART,0:NDKART)
      COMMON
     *       /VMUUNI/ VUNITS(0:NDMULT,0:NDMULT)
C
C=======================================================================
C
      CALL CPUTIM('INTVMU',1)
C
C=======================================================================
C      THIS SUBROUTINE CALCULATES MATRIX ELEMENTS OF VECTOR MULTIPOLE
C      OPERATORS:
C                   R**(LAMBDA)*CONJG(Y(LAMBDA,MIU))*(X,Y,Z)
C
C      IMAREA = 1 (-1) REQUESTS CALCULATION OF THE REAL (IMAGINARY) PART
C=======================================================================
C       THE STRUCTURE OF THIS SUBROUTINE IS EXACTLY THE SAME  AS
C       THE STRUCTURE OF SUBROUTINE "INTMUL"; SEE COMMENTS THERE
C       FOR MORE DETAILS.
C=======================================================================
C
       NIU=ABS(MIU)
C
       IF (MIU.GE.0) THEN
           JPHASE=IMAREA
       ELSE
           JPHASE=(-1)**MIU
       END IF
C
      ELEMUL(:,:)=0.0D0
C
      IF (IMAREA.EQ.1) THEN
C
C=======================================================================
C         CALCULATING THE REAL PART
C=======================================================================
C
          DO NUTERM=1,NREVLM(LAMBDA,NIU)
C
             DO IKET=1,LDBASE
C
                NX_KET=NXVECT(IKET)
                NY_KET=NYVECT(IKET)
                NZ_KET=NZVECT(IKET)
C
                DO IBRA=1,LDBASE
C
                   NX_BRA=NXVECT(IBRA)
                   NY_BRA=NYVECT(IBRA)
                   NZ_BRA=NZVECT(IBRA)
C
                   ELEMUL(IBRA,IKET)=
     *             ELEMUL(IBRA,IKET)+ KREVLM(LAMBDA,NIU,NUTERM,KARTEZ,0)
     *
     *           * COFMUL(KREVLM(LAMBDA,NIU,NUTERM,KARTEZ,1)
     *                                     ,NX_BRA,NX_KET,1)
     *
     *           * COFMUL(KREVLM(LAMBDA,NIU,NUTERM,KARTEZ,2)
     *                                     ,NY_BRA,NY_KET,2)
     *
     *           * COFMUL(KREVLM(LAMBDA,NIU,NUTERM,KARTEZ,3)
     *                                     ,NZ_BRA,NZ_KET,3)
     *
     *           * JPHASE
C
                END DO
             END DO
          END DO
C
      ELSE
C
          IF (MIU.EQ.0) STOP 'NO IMAGINARY PART FOR MIU=0 IN INTVMU'
C
C=======================================================================
C         CALCULATING THE IMAGINARY PART
C=======================================================================
C
          DO NUTERM=1,NIMVLM(LAMBDA,NIU)
C
             DO IKET=1,LDBASE
C
                NX_KET=NXVECT(IKET)
                NY_KET=NYVECT(IKET)
                NZ_KET=NZVECT(IKET)
C
                DO IBRA=1,LDBASE
C
                   NX_BRA=NXVECT(IBRA)
                   NY_BRA=NYVECT(IBRA)
                   NZ_BRA=NZVECT(IBRA)
C
                   ELEMUL(IBRA,IKET)=
     *             ELEMUL(IBRA,IKET)+ KIMVLM(LAMBDA,NIU,NUTERM,KARTEZ,0)
     *
     *           * COFMUL(KIMVLM(LAMBDA,NIU,NUTERM,KARTEZ,1)
     *                                     ,NX_BRA,NX_KET,1)
     *
     *           * COFMUL(KIMVLM(LAMBDA,NIU,NUTERM,KARTEZ,2)
     *                                     ,NY_BRA,NY_KET,2)
     *
     *           * COFMUL(KIMVLM(LAMBDA,NIU,NUTERM,KARTEZ,3)
     *                                     ,NZ_BRA,NZ_KET,3)
     *
     *           * JPHASE
C
                END DO
             END DO
          END DO
C
      END IF
C
C=======================================================================
C        NORMALIZATION FACTOR AND PHASE
C=======================================================================
C
      DO IKET=1,LDBASE
         NY_KET=NYVECT(IKET)
         DO IBRA=1,LDBASE
            NY_BRA=NYVECT(IBRA)
C
            ELEMUL(IBRA,IKET) = ELEMUL(IBRA,IKET)
     *
     *                        * COEVLM(LAMBDA,NIU)
     *
     *                        * IPHASE(NY_BRA,NY_KET)
C
         END DO
      END DO
C
C=======================================================================
C        FOLLOWS MULTIPLICATION BY THE UNITS DEFINED ONCE FOR ALL IN THE
C        SUBROUTINE "DEFUNI".  THE  SAME  UNITS ARE IMPLIED FOR POSITIVE
C        AND NEGATIVE VALUES OF "MIU".
C=======================================================================
C
      DO IKET=1,LDBASE
         DO IBRA=1,LDBASE
            ELEMUL(IBRA,IKET)=ELEMUL(IBRA,IKET)*VUNITS(LAMBDA,NIU)
         END DO
      END DO
C
C=======================================================================
C
      CALL CPUTIM('INTVMU',0)
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE INTRAD(HAMRAD,KARTEZ)
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      DIMENSION
     *          HAMRAD(1:NDBASE,1:NDBASE)
      DIMENSION
     *          N_KART(1:NDKART)
C
      COMMON
     *       /T_PHAS/ IPHAPP(0:NDYMAX,0:NDYMAX,0:NDKART),
     *                IPHAPM(0:NDYMAX,0:NDYMAX,0:NDKART),
     *                IPHAMP(0:NDYMAX,0:NDYMAX,0:NDKART),
     *                IPHAMM(0:NDYMAX,0:NDYMAX,0:NDKART)
      COMMON
     *       /COEMUL/ COMULT(0:NDMULT,0:NDOSCI,0:NDOSCI,1:NDKART)
      COMMON
     *       /BASISO/ NXVECT(1:NDBASE),NYVECT(1:NDBASE),NZVECT(1:NDBASE)
      COMMON
     *       /DIMENS/ LDBASE
      COMMON
     *       /RADUNI/ RUNITS
C
C=======================================================================
C      THIS SUBROUTINE CALCULATES MATRIX ELEMENTS OF X**2, Y**2 AND Z**2
C=======================================================================
C
      DO IKET=1,LDBASE
         DO IBRA=1,LDBASE
C
            HAMRAD(IBRA,IKET)=0.0D0
C
         END DO
      END DO
C
      N_KART(1)=0
      N_KART(2)=0
      N_KART(3)=0
      N_KART(KARTEZ)=2
C
C=======================================================================
C        CALCULATING THE MATRIX ELEMENT MULTIPLIED BY THE UNITS DEFINED
C        ONCE FOR ALL IN THE SUBROUTINE "DEFUNI" AND BY THE PHASE.
C=======================================================================
C
      DO IKET=1,LDBASE
         DO IBRA=1,LDBASE
C
            HAMRAD(IBRA,IKET) =
     *
     *         COMULT(N_KART(1),NXVECT(IBRA),NXVECT(IKET),1)
     *       * COMULT(N_KART(2),NYVECT(IBRA),NYVECT(IKET),2)
     *       * COMULT(N_KART(3),NZVECT(IBRA),NZVECT(IKET),3)
     *       * RUNITS
     *       * IPHAPP(NYVECT(IBRA),NYVECT(IKET),0)
C
         END DO
      END DO
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE DEVHER(NOSACT,KARTEZ)
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      DIMENSION
     *          PHERMI(ND2MAX+1),DHERMI(ND2MAX+1)
      DIMENSION
     *          XHERMI(NDINTE),WHERMI(NDINTE)
      DIMENSION
     *          HERPLN(0:ND2MAX,1:NDINTE),
     *          DH1PLN(0:ND2MAX,1:NDINTE),
     *          DH2PLN(0:ND2MAX,1:NDINTE)
      DIMENSION
     *          HERSQ2(0:ND2MAX,1:NDINTE)
C
      COMMON
     *       /FACHER/ HERFAC(0:ND2MAX)
      COMMON
     *       /COEXYZ/ COEF00(0:ND2MAX,0:NDOSCI,0:NDOSCI,1:NDKART),
     *                COEF01(0:ND2MAX,0:NDOSCI,0:NDOSCI,1:NDKART),
     *                COEF11(0:ND2MAX,0:NDOSCI,0:NDOSCI,1:NDKART),
     *                COEF02(0:ND2MAX,0:NDOSCI,0:NDOSCI,1:NDKART)
      COMMON
     *       /COUDEV/ COUL00(0:ND2MAX,0:NDOSCI,0:NDOSCI,1:NDKART)
      COMMON
     *       /SCALNG/ HOMSCA(NDKART)
      COMMON
     *       /CFIPRI/ NFIPRI
C
C=======================================================================
C
C         THIS ROUTINE PERFORMS INTEGRATION OF THE HERMITE POLYNOMIALS
C         TO FIND THE EXPANSION COEFFICIENTS IN THE FORMULAE:
C
C         H (M,X)  *  H  (N,X) = SUM_K COEF00(K,M,N) * H(K,X)
C         H (M,X)  *  H' (N,X) = SUM_K COEF01(K,M,N) * H(K,X)
C         H'(M,X)  *  H' (N,X) = SUM_K COEF11(K,M,N) * H(K,X)
C         H (M,X)  *  H''(N,X) = SUM_K COEF02(K,M,N) * H(K,X)
C
C         AND FOR SQ2=SQRT(2):
C
C         H (M,X)  *  H  (N,X) = SUM_K COUL00(K,M,N) * H(K,SQ2*X) * SQ2
C
C         WHERE:
C
C         H  (N,X) IS THE HERMITE POLYNOMIAL OF THE ORDER  M  AT POINT X
C                  ASSUMED TO BE NORMALIZED TO   O N E   WHEN ITS SQUARE
C                  IS INTEGRATED WITH EXP(-X**2).
C         H' (N,X) IS THE DERIVATIVE OF              H(N,X)*EXP(-X**2/2)
C                  MULTIPLIED BY EXP(X**2/2)
C         H''(N,X) IS THE SECOND DERIVATIVE OF       H(N,X)*EXP(-X**2/2)
C                  MULTIPLIED BY EXP(X**2/2)
C
C         "NOSACT"  IS THE MAXIMUM ORDER OF THE HERMITE POLYNOMIALS USED
C         IN THE CODE. THEREFORE:
C
C         H  (M,X)  HAS THE MAXIMUM ORDER  NOSACT
C         H' (M,X)  HAS THE MAXIMUM ORDER  NOSACT + 1
C         H''(M,X)  HAS THE MAXIMUM ORDER  NOSACT + 2
C
C         THE MAXIMUM ORDER OF PRODUCTS ON THE  LEFT-HAND-SIDES  OF  THE
C         ABOVE FORMULAE IS  THEREFORE:
C
C=======================================================================
C
      NMAIN2=2*NOSACT+2
C
      IF (NMAIN2.GT.ND2MAX) THEN
C
         WRITE(NFIPRI,'(//,1X,''NMAIN2='',I2,'' .GT. ND2MAX='',I2,
     *                         ''   STOP IN DEVHER'',//)') NMAIN2,ND2MAX
         STOP ' NMAIN2.GT.ND2MAX  IN  DEVHER'
C
      END IF
C
C=======================================================================
C         ZEROING THE COEF__ AND COUL00 ARRAYS
C=======================================================================
C
      DO N=0,NOSACT
         DO M=0,NOSACT
            DO K=0,NMAIN2
C
               COEF00(K,M,N,KARTEZ)=0.0
               COEF01(K,M,N,KARTEZ)=0.0
               COEF11(K,M,N,KARTEZ)=0.0
               COEF02(K,M,N,KARTEZ)=0.0
               COUL00(K,M,N,KARTEZ)=0.0
C
            END DO
         END DO
      END DO
C
C=======================================================================
C
C         THE COEFFICIENTS  COEF__   AND   COUL00  ARE FOUND BY EXPLICIT
C         NUMERICAL            G A U S S - H E R M I T E
C         INTEGRATION OF PRODUCTS APPEARING ON THE ABOVE LEFT-HAND-SIDES
C         WITH HERMITE  POLYNOMIALS.  THE MAXIMUM ORDER OF INTEGRANDS IS
C         THEN EQUAL TO   4*NOSACT+4,   AND THEREFORE ONE HAS TO USE THE
C         NUMBER OF GAUSS-HERMITE INTEGRATION POINTS EQUAL TO:
C
C=======================================================================
C
      NGAUSS=2*NOSACT+3
C
      IF (NGAUSS.GT.NDINTE) THEN
C
         WRITE(NFIPRI,'(//,1X,''NGAUSS='',I2,'' .GT. NDINTE='',I2,
     *                         ''   STOP IN DEVHER'',//)') NGAUSS,NDINTE
         STOP ' NGAUSS.GT.NDINTE  IN  DEVHER'
C
      END IF
C
C=======================================================================
C          DEFINING ZEROS AND WEIGHTS FOR THE GAUSS-HERMITE  INTEGRATION
C=======================================================================
C
      CALL HERMIT(NGAUSS,XHERMI,WHERMI,NDINTE)
C
C=======================================================================
C        DEFINING THE VALUES OF THE HERMITE POLYNOMIALS AT GAUSS ZEROS
C=======================================================================
C
      SQ2=SQRT(2.0D0)
C
      DO IZEROS = 1,NGAUSS
C
         XZER = XHERMI(IZEROS)
C
         CALL D_HERM(XZER,NMAIN2,PHERMI,DHERMI,ND2MAX+1)
C
         DO NOSCIL = 0,NMAIN2
C
            HERPLN(NOSCIL,IZEROS)= PHERMI(NOSCIL+1)/HERFAC(NOSCIL)
C
            DH1PLN(NOSCIL,IZEROS)=(DHERMI(NOSCIL+1)
     *                           - XZER*PHERMI(NOSCIL+1))
     *                                             /HERFAC(NOSCIL)
C
            DH2PLN(NOSCIL,IZEROS)=(XZER*XZER-2*NOSCIL-1)
     *                           * PHERMI(NOSCIL+1)/HERFAC(NOSCIL)
C
         END DO
C
         XZER = XHERMI(IZEROS) / SQ2
C
         CALL D_HERM(XZER,NMAIN2,PHERMI,DHERMI,ND2MAX+1)
C
         DO NOSCIL = 0,NMAIN2
C
            HERSQ2(NOSCIL,IZEROS)= PHERMI(NOSCIL+1)/HERFAC(NOSCIL)
C
         END DO
C
      END DO
C
C=======================================================================
C        CALCULATING THE EXPANSION COEFFICIENTS FOR THE POLYNOMIALS
C=======================================================================
C
      DO N=0,NOSACT
         DO M=0,NOSACT
            DO K=M+N,0,-2
C
               RESULT=0.0D0
               RESCOU=0.0D0
C
               DO IGAUSS=1,NGAUSS
C
                  RESULT=RESULT+WHERMI(IGAUSS)*HERPLN(N,IGAUSS)
     *                                        *HERPLN(M,IGAUSS)
     *                                        *HERPLN(K,IGAUSS)
C
                  RESCOU=RESCOU+WHERMI(IGAUSS)*HERSQ2(N,IGAUSS)
     *                                        *HERSQ2(M,IGAUSS)
     *                                        *HERPLN(K,IGAUSS)
               END DO
C
               COEF00(K,M,N,KARTEZ)=RESULT
               COUL00(K,M,N,KARTEZ)=RESCOU / SQ2
C
            END DO
         END DO
      END DO
C
C=======================================================================
C        CALCULATING THE EXPANSION COEFFICIENTS FOR THE PRODUCTS
C        DERIVATIVE (EXP * HERMIT) * HERMIT * HERMIT
C=======================================================================
C
      DO N=0,NOSACT
         DO M=0,NOSACT
            DO K=M+N+1,0,-2
C
               RESULT=0.0D0
C
               DO IGAUSS=1,NGAUSS
                  RESULT=RESULT+WHERMI(IGAUSS)*DH1PLN(N,IGAUSS)
     *                                        *HERPLN(M,IGAUSS)
     *                                        *HERPLN(K,IGAUSS)
               END DO
C
               COEF01(K,M,N,KARTEZ)=RESULT
C
            END DO
         END DO
      END DO
C
C=======================================================================
C        CALCULATING THE EXPANSION COEFFICIENTS FOR THE PRODUCTS
C        DERIVATIVE (EXP * HERMIT) * DERIVATIVE (EXP * HERMIT) * HERMIT
C=======================================================================
C
      DO N=0,NOSACT
         DO M=0,NOSACT
            DO K=M+N+2,0,-2
C
               RESULT=0.0D0
C
               DO IGAUSS=1,NGAUSS
                  RESULT=RESULT+WHERMI(IGAUSS)*DH1PLN(N,IGAUSS)
     *                                        *DH1PLN(M,IGAUSS)
     *                                        *HERPLN(K,IGAUSS)
               END DO
C
               COEF11(K,M,N,KARTEZ)=RESULT
C
            END DO
         END DO
      END DO
C
C=======================================================================
C        CALCULATING THE EXPANSION COEFFICIENTS FOR THE PRODUCTS
C        SECOND DERIVATIVE (EXP * HERMIT) * HERMIT * HERMIT
C=======================================================================
C
      DO N=0,NOSACT
         DO M=0,NOSACT
            DO K=M+N+2,0,-2
C
               RESULT=0.0D0
C
               DO IGAUSS=1,NGAUSS
                  RESULT=RESULT+WHERMI(IGAUSS)*DH2PLN(N,IGAUSS)
     *                                        *HERPLN(M,IGAUSS)
     *                                        *HERPLN(K,IGAUSS)
               END DO
C
               COEF02(K,M,N,KARTEZ)=RESULT
C
            END DO
         END DO
      END DO
C
C=======================================================================
C       THE CODE USES DIMENSIONED WAVE FUNCTIONS AND THEIR DERIVATIVES.
C       THEREFORE, THE COEFFICIENTS       COEF__     ARE HERE SCALED BY
C       APPROPRIATE FACTORS WHICH TAKE INTO ACCOUNT  THESE  DIMENSIONS.
C=======================================================================
C
      DO N=0,NOSACT
         DO M=0,NOSACT
C
            DO K=M+N,0,-2
               COEF00(K,M,N,KARTEZ)=COEF00(K,M,N,KARTEZ)
     *                             *SQRT(HOMSCA(KARTEZ))
               COUL00(K,M,N,KARTEZ)=COUL00(K,M,N,KARTEZ)
     *                             *SQRT(HOMSCA(KARTEZ))
            END DO
C
            DO K=M+N+1,0,-2
               COEF01(K,M,N,KARTEZ)=COEF01(K,M,N,KARTEZ)
     *                             *SQRT(HOMSCA(KARTEZ))
     *                             *     HOMSCA(KARTEZ)
            END DO
C
            DO K=M+N+2,0,-2
C
               COEF02(K,M,N,KARTEZ)=COEF02(K,M,N,KARTEZ)
     *                             *SQRT(HOMSCA(KARTEZ))
     *                             *     HOMSCA(KARTEZ)
     *                             *     HOMSCA(KARTEZ)
C
               COEF11(K,M,N,KARTEZ)=COEF11(K,M,N,KARTEZ)
     *                             *SQRT(HOMSCA(KARTEZ))
     *                             *     HOMSCA(KARTEZ)
     *                             *     HOMSCA(KARTEZ)
            END DO
C
         END DO
      END DO
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE DEFINT(NOSACT,KARTEZ,NGAUSS,NOBODY,
     *                  HERACT,DHRACT,DDHACT,WGTACT,PNTACT)
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      DIMENSION
     *          PHERMI(ND2MAX+1),DHERMI(ND2MAX+1)
      DIMENSION
     *          XHERMI(NDGAUS),WHERMI(NDGAUS)
C
      DIMENSION
     *          HERACT(0:ND2MAX,1:NDGAUS,1:NDKART)
      DIMENSION
     *          DHRACT(0:ND2MAX,1:NDGAUS,1:NDKART),
     *          DDHACT(0:ND2MAX,1:NDGAUS,1:NDKART)
      DIMENSION
     *          WGTACT(1:NDGAUS,1:NDKART),
     *          PNTACT(1:NDGAUS,1:NDKART)
C
      COMMON
     *       /FACHER/ HERFAC(0:ND2MAX)
      COMMON
     *       /SCALNG/ HOMSCA(NDKART)
      COMMON
     *       /CFIPRI/ NFIPRI
C
C=======================================================================
C
C          THIS SUBROUTINE CALCULATES HARMONIC OSCILLATOR WAVE FUNCTIONS
C          AND THEIR FIRST AND SECOND DERIVATIVES, AS WELL  AS  PREPARES
C          POINTS AND WEIGHTS FOR THE GAUSS-HERMITE INTEGRATION.
C
C          EXPONENTIAL FACTORS ARE    N  O  T   INCLUDED  NEITHER IN THE
C          WAVE FUNCTIONS NOR IN THE DERIVATIVES.
C
C=======================================================================
C          EVEN IF THE BASIS CONTAINS THE WAVE FUNCTIONS ONLY UP TO  THE
C          NUMBER OF OSCILLATOR QUANTA EQUAL TO "NOSACT", THE CODE NEEDS
C          THE WAVE FUNCTIONS UP TO THE MAXIMUM NUMBER OF QUANTA  EQUAL:
C=======================================================================
C
      NMAIN2=2*NOSACT+2
C
      IF (NGAUSS.GT.NDGAUS) THEN
C
         WRITE(NFIPRI,'(//,1X,''NGAUSS='',I2,'' .GT. NDGAUS='',I2,
     *                         ''   STOP IN DEFINT'',//)') NGAUSS,NDGAUS
         STOP ' NGAUSS.GT.NDGAUS  IN  DEFINT'
C
      END IF
C
C=======================================================================
C          DEFINING ZEROS AND WEIGHTS FOR THE GAUSS-HERMITE  INTEGRATION
C=======================================================================
C
      CALL HERMIT(NGAUSS,XHERMI,WHERMI,NDGAUS)
C
C=======================================================================
C
C        IF NOBODY=2 WE SCALE THE WEIGHTS AND THE ZEROS BY 1/SQRT(2).
C        THIS  SCALING  CORRESPONDS  TO  INTEGRATING  THE PRODUCTS OF
C        F O U R   HARMONIC - OSCILLATOR  WAVE  FUNCTIONS. EXCEPT FOR
C        THE DENSITY-DEPENDENT TERM OF THE SKYRME INTERACTION AND THE
C        COULOMB-EXCHANGE TERM IN THE MEAN FIELD, TOTAL ENERGIES  AND
C        MATRIX ELEMENTS OF THE ONE-BODY POTENTIAL  CONTAIN  PRODUCTS
C        OF  F O U R  WAVE FUNCTIONS. THE SCALED  WEIGHTS  AND  ZEROS
C        WILL BE USED TO INTEGRATE THESE QUANTITIES.
C
C=======================================================================
C
C        IF NOBODY=1 NO SQRT(2) SCALING; IN THIS CASE THE WEIGHTS AND
C        ZEROS CAN BE USED TO INTEGRATE PRODUCTS OF   T W O  HARMONIC
C        OSCILLATOR WAVE FUNCTIONS.
C
C=======================================================================
C
      IF (NOBODY.GT.2) STOP 'NOBODY TOO  BIG  IN DEFINT'
      IF (NOBODY.LT.1) STOP 'NOBODY TOO SMALL IN DEFINT'
C
      IF (NOBODY.EQ.2) SCBODY=SQRT(2.0D0)
      IF (NOBODY.EQ.1) SCBODY=(1.000000D0)
C
      DO IZEROS = 1,NGAUSS
C
         WGTACT(IZEROS,KARTEZ)=WHERMI(IZEROS)/SCBODY/HOMSCA(KARTEZ)
C
C=======================================================================
C
C        IN THE ABOVE INSTRUCTION WE HAVE DIVIDED THE GAUSS WEIGHTS BY:
C
C                    HOMSCA() = SQRT(MASS*HOMEG()/H_BAR**2)
C
C        THIS CORRESPONDS TO EXPRESSING THE ONE-DIMENSIONAL INTEGRATION
C        MEASURE IN FERMIS.  INTEGRALS  OVER  THE VOLUME HAVE THEREFORE
C        FERMI**3 AS THEIR DIMENSION.
C
C=======================================================================
C
         PNTACT(IZEROS,KARTEZ)=XHERMI(IZEROS)/SCBODY
C
         XZER = PNTACT(IZEROS,KARTEZ)
C
         CALL D_HERM(XZER,NMAIN2,PHERMI,DHERMI,ND2MAX+1)
C
C=======================================================================
C
C        THE HERMITE POLYNOMIALS ARE MULTIPLIED  BY THE DIMENSIONED
C        NORMALIZATION CONSTANT:
C
C                     (MASS*HOMEG()/H_BAR**2)**(1/4)
C
C        THIS CORRESPONDS TO INTRODUCING THE ONE - DIMENSIONAL WAVE
C        FUNCTIONS IN UNITS OF FM**(-1/2). CORRESPONDING  DENSITIES
C        IN THREE DIMENSIONS ARE THEN IN UNITS OF FM**(-3)
C
C=======================================================================
C
         DO NOSCIL = 0,NMAIN2
C
            HERACT(NOSCIL,IZEROS,KARTEZ) = PHERMI(NOSCIL+1)
     *                                   * SQRT(HOMSCA(KARTEZ))
     *                                   / HERFAC( NOSCIL )
C
            DHRACT(NOSCIL,IZEROS,KARTEZ) =(DHERMI(NOSCIL+1)
     *                                   - XZER*PHERMI(NOSCIL+1))
     *                                   * SQRT(HOMSCA(KARTEZ))
     *                                   / HERFAC( NOSCIL )
C
            DDHACT(NOSCIL,IZEROS,KARTEZ) =(XZER*XZER-2*NOSCIL-1)
     *                                   * PHERMI(NOSCIL+1)
     *                                   * SQRT(HOMSCA(KARTEZ))
     *                                   / HERFAC( NOSCIL )
C
         END DO
C
C=======================================================================
C
C        DERIVATIVES OF THE "HERMITE * EXPONENT" PRODUCTS  (SEE COMMENTS
C        IN DEVHER)  ARE  MULTIPLIED  BY  THE  APPROPRIATE POWERS OF THE
C        DIMENSIONED STRETCHING FACTORS "HOMSCA". IN THIS WAY THE  FIRST
C        DERIVATIVE HAS THE CORRECT DIMENSION OF FERMI**(-3/2). ALSO THE
C        SECOND DERIVATIVE HAS THE CORRECT DIMENSION OF FERMI**(-5/2).
C
C=======================================================================
C
         DO NOSCIL = 0,NMAIN2
C
            DHRACT(NOSCIL,IZEROS,KARTEZ) = DHRACT(NOSCIL,IZEROS,KARTEZ)
     *                                   *               HOMSCA(KARTEZ)
C
            DDHACT(NOSCIL,IZEROS,KARTEZ) = DDHACT(NOSCIL,IZEROS,KARTEZ)
     *                                   *               HOMSCA(KARTEZ)
     *                                   *               HOMSCA(KARTEZ)
         END DO
C
      END DO
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE COPHER(NOSACT,KARTEZ,NGAUSS,HERACT,DHRACT,DDHACT,
     *                                       CERACT,CHRACT,CDHACT)
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      COMPLEX
     *          CERACT,CHRACT,CDHACT
C
      DIMENSION
     *          HERACT(0:ND2MAX,1:NDGAUS,1:NDKART),
     *          DHRACT(0:ND2MAX,1:NDGAUS,1:NDKART),
     *          DDHACT(0:ND2MAX,1:NDGAUS,1:NDKART)
      DIMENSION
     *          CERACT(0:ND2MAX,1:NDGAUS,1:NDKART),
     *          CHRACT(0:ND2MAX,1:NDGAUS,1:NDKART),
     *          CDHACT(0:ND2MAX,1:NDGAUS,1:NDKART)
C
C=======================================================================
C
C          THIS SUBROUTINE COPIES THE HARMONIC OSCILLATOR WAVE FUNCTIONS
C          AND THEIR FIRST AND SECOND DERIVATIVES TO COMPLEX ARRAYS.
C
C=======================================================================
C
      NMAIN2=2*NOSACT+2
C
      DO IZEROS = 1,NGAUSS
         DO NOSCIL = 0,NMAIN2
C
            CERACT(NOSCIL,IZEROS,KARTEZ) = HERACT(NOSCIL,IZEROS,KARTEZ)
            CHRACT(NOSCIL,IZEROS,KARTEZ) = DHRACT(NOSCIL,IZEROS,KARTEZ)
            CDHACT(NOSCIL,IZEROS,KARTEZ) = DDHACT(NOSCIL,IZEROS,KARTEZ)
C
         END DO
      END DO
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE DIASIG(MREVER,ICHARG)
C=======================================================================
      USE MAT_PP
      USE ALLWAV
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      COMPLEX
     *          PWAVEF,CELMTS,C_ZERO
C=======================================================================
      ALLOCATABLE PWAVEF(:,:,:)
C=======================================================================
      DIMENSION
     *          PSPECT(1:NDBASP,0:NDPARI)
C=======================================================================
      ALLOCATABLE CELMTS(:)
C=======================================================================
      DIMENSION
     *          NPARIT(1:NDBASE),NPSTAT(1:NDBASE),
     *          NORDER(1:NDBASE),EORDER(1:NDBASE)
      DIMENSION
     *          NUMVEC(0:NDPARI)
C
C=======================================================================
      COMMON
     *       /SPLEVS/ SPENER(1:2*NDSTAT,0:NDISOS),
     *                SPOCCU(1:2*NDSTAT,0:NDISOS),
     *                SPALIG(1:2*NDSTAT,0:NDISOS),
     *                SPSPAL(1:2*NDSTAT,0:NDISOS),
     *                SPPARI(1:2*NDSTAT,0:NDISOS),
     *                SPSIMP(1:2*NDSTAT,0:NDISOS)
      COMMON
     *       /SIMSPE/ SPESIM(1:NDBASE)
      COMMON
     *       /SPNUMS/ NUMBSP(0:NDREVE,0:NDISOS)
      COMMON
     *       /PARIND/ INDPAR(1:NDBASE,0:NDPARI)
      COMMON
     *       /SIGSTA/ ISTSIG(1:NDSTAT,0:NDPARI,0:NDREVE)
      COMMON
     *       /DIMENP/ LDBASP(0:NDPARI)
      COMMON
     *       /CFIPRI/ NFIPRI
C
C=======================================================================
C
      CALL CPUTIM('DIASIG',1)
C
C=======================================================================
C
      IALLOC=0
C
C=======================================================================
      IF (.NOT.ALLOCATED(WAVOCC)) THEN
          ALLOCATE (WAVOCC(1:NDBASE,1:2*NDSTAT,0:NDREVE),STAT=IALLOC)
          IF (IALLOC.NE.0) CALL NOALLO('WAVOCC','DIASIG')
      END IF
C=======================================================================
      ALLOCATE (PWAVEF(1:NDBASP,1:NDBASP,0:NDPARI),STAT=IALLOC)
      IF (IALLOC.NE.0) CALL NOALLO('PWAVEF','DIASIG')
      ALLOCATE (CELMTS(1:((NDBASP+1)*NDBASP)/2),STAT=IALLOC)
      IF (IALLOC.NE.0) CALL NOALLO('CELMTS','DIASIG')
C=======================================================================
C
C=======================================================================
C        THIS SUBROUTINE PERFORMS THE DIAGONALIZATION IN THE CASE OF
C        CONSERVED SIMPLEX AND SIGNATURE SYMMETRIES
C=======================================================================
C
      C_ZERO=CMPLX(0.0D0,0.0D0)
C
C=======================================================================
C        ATTENTION: IN CASE OF THE CONSERVED TIME-REVERSAL  SYMMETRY
C                   THIS SUBROUTINE IS CALLED WITH MREVER=0, AND THE
C                   DIAGONALIZATION IN THE TIME-REVERSED BLOCK  WILL
C                   NOT BE PERFORMED.
C=======================================================================
C     SEE COMMENTS ABOUT NDBASP IN THE DIASIQ SUBROUTINE
C=======================================================================
C
      IF (MAX(LDBASP(0),LDBASP(1)).GT.NDBASP) THEN
C
          WRITE(NFIPRI,'(/,
     *                 1X,20(1H/),'' PARAMETER NDBASP TOO SMALL'',
     *                            '' IN DIASIG'',       1X,19(1H/),/,
     *                 1X,20(1H/),'' NDBASP ='',I3,
     *                            '' INCREASE TO  NDBASP ='',I3,
     *                                                  1X,19(1H/),/)')
     *
     *    NDBASP,MAX(LDBASP(0),LDBASP(1))
C
          STOP 'INCREASE NDBASP IN DIASIG'
C
      END IF
C
C=======================================================================
      DO IREVER=0,MREVER
C
C=======================================================================
C        DIAGONALIZING THE HAMILTONIAN IN EACH PARITY  BLOCK.
C=======================================================================
C        BEFORE THE NUMBERS OF USEFUL STATES IN  EACH  PARITY
C        BLOCK ARE KNOWN, ALL STATES UP TO THE  TOTAL  NUMBER
C        OF THOSE OF GIVEN SIMPLEX AND CHARGE ARE CONSIDERED,
C        BUT NOT MORE THAN THE TOTAL NUMBER OF STATES IN  THE
C        GIVEN PARITY BLOCK
C=======================================================================
C
         DO IPARIT=0,NDPARI
C
            DO IBRAPA = 1,LDBASP(IPARIT)
               DO IKETPA = 1,LDBASP(IPARIT)
C
                  IF (IBRAPA.GE.IKETPA) THEN
C
                      NCOUNT=IBRAPA
     *                         +((2*LDBASP(IPARIT)-IKETPA)*(IKETPA-1))/2
C
                      CELMTS(NCOUNT)=BIG_PP(INDPAR(IBRAPA,IPARIT),
     *                                      INDPAR(IKETPA,IPARIT),
     *                                                    IREVER)
C
                  END IF
C
               END DO
            END DO
C
            NUMVEC(IPARIT)=MIN(NUMBSP(IREVER,ICHARG),LDBASP(IPARIT))
C
            CALL DIAMAT(CELMTS,PSPECT(1,IPARIT),PWAVEF(1,1,IPARIT),
     *                             LDBASP(IPARIT),NDBASP,NUMVEC(IPARIT))
C
         END DO
C
C=======================================================================
C        ORDERING THE SINGLE-PARTICLE ENERGIES
C=======================================================================
C
         IORDER=0
C
         DO IPARIT=0,NDPARI
C
            DO IPSTAT=1,NUMVEC(IPARIT)
C
               IORDER=IORDER+1
               NPARIT(IORDER)=IPARIT
               NPSTAT(IORDER)=IPSTAT
               NORDER(IORDER)=IORDER
               EORDER(IORDER)=PSPECT(IPSTAT,IPARIT)
C
            END DO
C
         END DO
C
         CALL ORDER1(EORDER,NORDER,IORDER)
C
C=======================================================================
C        SECURITY CHECK ON THE NUMBER OF STATES FOUND
C=======================================================================
C
         IF (IORDER.LT.NUMBSP(IREVER,ICHARG))
     *
     *       STOP ' NOT ENOUGH STATES IN DIASIG'
C
C=======================================================================
C        STORING THE SINGLE-PARTICLE ENERGIES
C=======================================================================
C
         DO ISTATE=1,NUMBSP(IREVER,ICHARG)
C
            IPARIT=NPARIT(NORDER(ISTATE))
            IPSTAT=NPSTAT(NORDER(ISTATE))
C
            SPESIM(ISTATE)=PSPECT(IPSTAT,IPARIT)
            SPENER(ISTATE+IREVER*NUMBSP(0,ICHARG),ICHARG)=SPESIM(ISTATE)
C
            ISTSIG(IPSTAT,IPARIT,IREVER)=ISTATE
C
C=======================================================================
C        STORING THE SINGLE-PARTICLE WAVE FUNCTIONS
C=======================================================================
C
            DO IPBASE=1,LDBASP(IPARIT)
C
               WAVOCC(INDPAR(IPBASE,IPARIT),
     *                ISTATE+IREVER*NUMBSP(0,ICHARG),  IREVER)=
     *                                      PWAVEF(IPBASE,IPSTAT,IPARIT)
               WAVOCC(INDPAR(IPBASE,IPARIT),
     *                ISTATE+IREVER*NUMBSP(0,ICHARG),1-IREVER)=
     *                                                C_ZERO
C
            END DO
C
            DO IPBASE=1,LDBASP(1-IPARIT)
C
               WAVOCC(INDPAR(IPBASE,1-IPARIT),
     *                ISTATE+IREVER*NUMBSP(0,ICHARG),  IREVER)=
     *                                                C_ZERO
               WAVOCC(INDPAR(IPBASE,1-IPARIT),
     *                ISTATE+IREVER*NUMBSP(0,ICHARG),1-IREVER)=
     *                                                C_ZERO
C
            END DO
C
         END DO
C
      END DO
C
C=======================================================================
      DEALLOCATE (PWAVEF,CELMTS)
C=======================================================================
C
      CALL CPUTIM('DIASIG',0)
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE DIASIM(MREVER,ICHARG)
C=======================================================================
      USE MAT_PP
      USE ALLWAV
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      COMPLEX
     *          EWAVEF,C_ZERO
      COMPLEX
     *          CELMTS
C=======================================================================
      ALLOCATABLE CELMTS(:)
      ALLOCATABLE EWAVEF(:,:)
C=======================================================================
      COMMON
     *       /SPLEVS/ SPENER(1:2*NDSTAT,0:NDISOS),
     *                SPOCCU(1:2*NDSTAT,0:NDISOS),
     *                SPALIG(1:2*NDSTAT,0:NDISOS),
     *                SPSPAL(1:2*NDSTAT,0:NDISOS),
     *                SPPARI(1:2*NDSTAT,0:NDISOS),
     *                SPSIMP(1:2*NDSTAT,0:NDISOS)
      COMMON
     *       /SIMSPE/ SPESIM(1:NDBASE)
      COMMON
     *       /SPNUMS/ NUMBSP(0:NDREVE,0:NDISOS)
      COMMON
     *       /DIMENS/ LDBASE
C
C=======================================================================
C
      CALL CPUTIM('DIASIM',1)
C
C=======================================================================
C
      IALLOC=0
C
C=======================================================================
      IF (.NOT.ALLOCATED(WAVOCC)) THEN
          ALLOCATE (WAVOCC(1:NDBASE,1:2*NDSTAT,0:NDREVE),STAT=IALLOC)
          IF (IALLOC.NE.0) CALL NOALLO('WAVOCC','DIASIM')
      END IF
C=======================================================================
      ALLOCATE (EWAVEF(1:NDBASE,1:NDBASE),STAT=IALLOC)
      IF (IALLOC.NE.0) CALL NOALLO('EWAVEF','DIASIM')
      ALLOCATE (CELMTS(1:((NDBASE+1)*NDBASE)/2),STAT=IALLOC)
      IF (IALLOC.NE.0) CALL NOALLO('CELMTS','DIASIM')
C=======================================================================
C
C=======================================================================
C        THIS SUBROUTINE PERFORMS THE DIAGONALIZATION IN THE CASE OF
C        CONSERVED SIMPLEX SYMMETRY
C=======================================================================
C
      C_ZERO=CMPLX(0.0D0,0.0D0)
C
C=======================================================================
C        ATTENTION: IN CASE OF THE CONSERVED TIME-REVERSAL  SYMMETRY
C                   THIS SUBROUTINE IS CALLED WITH MREVER=0, AND THE
C                   DIAGONALIZATION IN THE TIME-REVERSED BLOCK  WILL
C                   NOT BE PERFORMED.
C=======================================================================
C
      DO IREVER=0,MREVER
C
         DO IBRA=1,LDBASE
            DO IKET=1,LDBASE
C
               IF (IBRA.GE.IKET) THEN
C
                   NCOUNT=IBRA+((2*LDBASE-IKET)*(IKET-1))/2
C
                   CELMTS(NCOUNT)=BIG_PP(IBRA,IKET,IREVER)
C
               END IF
C
            END DO
         END DO
C
         CALL DIAMAT(CELMTS,SPESIM,EWAVEF,LDBASE,NDBASE,
     *                                           NUMBSP(IREVER,ICHARG))
C
C=======================================================================
C        STORING THE SINGLE-PARTICLE ENERGIES AND WAVE FUNCTIONS
C=======================================================================
C
         DO ISTATE=1,NUMBSP(IREVER,ICHARG)
C
            SPENER(ISTATE+IREVER*NUMBSP(0,ICHARG),ICHARG)=SPESIM(ISTATE)
C
            DO IBASE=1,LDBASE
C
               WAVOCC(IBASE,ISTATE+IREVER*NUMBSP(0,ICHARG),1-IREVER)=
     *                                                            C_ZERO
               WAVOCC(IBASE,ISTATE+IREVER*NUMBSP(0,ICHARG),  IREVER)=
     *                                              EWAVEF(IBASE,ISTATE)
C
            END DO
C
         END DO
C
      END DO
C
C=======================================================================
      DEALLOCATE (EWAVEF,CELMTS)
C=======================================================================
C
      CALL CPUTIM('DIASIM',0)
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE DIASIQ(ICHARG)
C=======================================================================
      USE MAT_PP
      USE MAT_PM
      USE ALLWAV
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      COMPLEX
     *          EWASIQ,CELMTS,C_ZERO
C=======================================================================
      ALLOCATABLE CELMTS(:)
      ALLOCATABLE EWASIQ(:,:,:)
C=======================================================================
      DIMENSION
     *          SPESIQ(1:2*NDBASP,0:NDPARI)
      DIMENSION
     *          NPARIT(1:2*NDBASE),NPSTAT(1:2*NDBASE),
     *          NORDER(1:2*NDBASE),EORDER(1:2*NDBASE)
      DIMENSION
     *          NUMVEC(0:NDPARI)
C
C=======================================================================
      COMMON
     *       /SPLEVS/ SPENER(1:2*NDSTAT,0:NDISOS),
     *                SPOCCU(1:2*NDSTAT,0:NDISOS),
     *                SPALIG(1:2*NDSTAT,0:NDISOS),
     *                SPSPAL(1:2*NDSTAT,0:NDISOS),
     *                SPPARI(1:2*NDSTAT,0:NDISOS),
     *                SPSIMP(1:2*NDSTAT,0:NDISOS)
      COMMON
     *       /SPNUMS/ NUMBSP(0:NDREVE,0:NDISOS)
      COMMON
     *       /PARIND/ INDPAR(1:NDBASE,0:NDPARI)
      COMMON
     *       /SIQSTA/ ISTSIQ(1:2*NDSTAT,0:NDPARI)
      COMMON
     *       /DIMENP/ LDBASP(0:NDPARI)
      COMMON
     *       /CFIPRI/ NFIPRI
C
C=======================================================================
C
      CALL CPUTIM('DIASIQ',1)
C
C=======================================================================
C
      IALLOC=0
C
C=======================================================================
      IF (.NOT.ALLOCATED(WAVOCC)) THEN
          ALLOCATE (WAVOCC(1:NDBASE,1:2*NDSTAT,0:NDREVE),STAT=IALLOC)
          IF (IALLOC.NE.0) CALL NOALLO('WAVOCC','DIASIQ')
      END IF
C=======================================================================
      ALLOCATE (CELMTS(1:(2*NDBASP+1)*NDBASP),STAT=IALLOC)
      IF (IALLOC.NE.0) CALL NOALLO('CELMTS','DIASIQ')
      ALLOCATE (EWASIQ(1:2*NDBASP,1:2*NDBASP,0:NDPARI),STAT=IALLOC)
      IF (IALLOC.NE.0) CALL NOALLO('EWASIQ','DIASIQ')
C=======================================================================
C
C=======================================================================
C        THIS SUBROUTINE PERFORMS THE DIAGONALIZATION IN THE CASE OF
C        BROKEN SIMPLEX AND CONSERVED PARITY
C=======================================================================
C
      C_ZERO=CMPLX(0.0D0,0.0D0)
C
C=======================================================================
C        THE TEST BELOW IS PERFORMED TO CHECK WHETHER THE  DIMENSIONS
C        OF THE  HAMILTONIAN  MATRICES  ARE  SUFFICIENT. THE  FORMULA
C                     NDBASP=NDBASE/2+MAX(10,NDBASE/12)
C        WOULD HAVE ENSURED THAT THE DIMENSIONS ARE CORRECT  FOR  ANY
C        CLOSED-SHELL SPHERICAL BASIS. SINCE FOR THE  DEFORMED  BASIS
C        THE NUMBERS OF POSITIVE AND NEGATIVE-PARITY BASIS STATES ARE
C        DIFFERENT, AN EMPIRICAL SAFE FORMULA
C                     NDBASP=NDBASE/2+MAX(20,NDBASE/12)
C        IS USED IN THE PARAMETER STATEMENT ABOVE. IF THE TEST  BELOW
C        FAILS, THE USER SHOULD SET NDBASP EQUAL TO THE VALUE THAT IS
C        EQUAL TO
C                       MAX(LDBASP(0),LDBASP(1))
C        WHICH IS PRINTED BY THE PROGRAM IN THE MESSAGE  ACCOMPANYING
C        THE STOP STATEMENT BELOW.
C=======================================================================
C
      IF (MAX(LDBASP(0),LDBASP(1)).GT.NDBASP) THEN
C
          WRITE(NFIPRI,'(/,
     *                 1X,20(1H/),'' PARAMETER NDBASP TOO SMALL'',
     *                            '' IN DIASIQ'',       1X,19(1H/),/,
     *                 1X,20(1H/),'' NDBASP ='',I3,
     *                            '' INCREASE TO  NDBASP ='',I3,
     *                                                  1X,19(1H/),/)')
     *
     *    NDBASP,MAX(LDBASP(0),LDBASP(1))
C
          STOP 'INCREASE NDBASP IN DIASIQ'
C
      END IF
C
C=======================================================================
C        DIAGONALIZING THE HAMILTONIAN IN EACH PARITY BLOCK.
C=======================================================================
C        BEFORE THE NUMBERS OF USEFUL STATES IN EACH PARITY
C        BLOCK ARE KNOWN, ALL STATES UP TO THE TOTAL NUMBER
C        OF THOSE OF GIVEN CHARGE ARE  CONSIDERED, BUT  NOT
C        MORE THAN THE TOTAL NUMBER OF STATES IN THE  GIVEN
C        PARITY BLOCK.
C=======================================================================
C
      DO IPARIT=0,NDPARI
C
         LDPARI=LDBASP(IPARIT)
         NCOUNT=0
C
         DO IKETPA=1,2*LDPARI
            DO IBRAPA=IKETPA,2*LDPARI
C
               NCOUNT=NCOUNT+1
C
               IF (IBRAPA.LE.LDPARI.AND.IKETPA.LE.LDPARI)
     *             CELMTS(NCOUNT)=BIG_PP(INDPAR(IBRAPA,       IPARIT),
     *                                   INDPAR(IKETPA,       IPARIT),0)
C
               IF (IBRAPA.GT.LDPARI.AND.IKETPA.LE.LDPARI)
     *             CELMTS(NCOUNT)=BIG_PM(INDPAR(IBRAPA-LDPARI,IPARIT),
     *                                   INDPAR(IKETPA,       IPARIT),1)
C
               IF (IBRAPA.GT.LDPARI.AND.IKETPA.GT.LDPARI)
     *             CELMTS(NCOUNT)=BIG_PP(INDPAR(IBRAPA-LDPARI,IPARIT),
     *                                   INDPAR(IKETPA-LDPARI,IPARIT),1)
C
            END DO
         END DO
C
         NUMVEC(IPARIT)=MIN(NUMBSP(0,ICHARG)+NUMBSP(1,ICHARG),2*LDPARI)
C
         CALL DIAMAT(CELMTS,SPESIQ(1,IPARIT),EWASIQ(1,1,IPARIT),
     *                                 2*LDPARI,2*NDBASP,NUMVEC(IPARIT))
C
      END DO
C
C=======================================================================
C        ORDERING THE SINGLE-PARTICLE ENERGIES
C=======================================================================
C
      IORDER=0
C
      DO IPARIT=0,NDPARI
C
         DO IPSTAT=1,NUMVEC(IPARIT)
C
            IORDER=IORDER+1
            NPARIT(IORDER)=IPARIT
            NPSTAT(IORDER)=IPSTAT
            NORDER(IORDER)=IORDER
            EORDER(IORDER)=SPESIQ(IPSTAT,IPARIT)
C
         END DO
C
      END DO
C
      CALL ORDER1(EORDER,NORDER,IORDER)
C
C=======================================================================
C        SECURITY CHECK ON THE NUMBER OF STATES FOUND
C=======================================================================
C
         IF (IORDER.LT.NUMBSP(0,ICHARG)+NUMBSP(1,ICHARG))
     *
     *       STOP ' NOT ENOUGH STATES IN DIASIQ'
C
C=======================================================================
C        STORING THE SINGLE-PARTICLE ENERGIES
C=======================================================================
C
      DO ISTATE=1,NUMBSP(0,ICHARG)+NUMBSP(1,ICHARG)
C
         IPARIT=NPARIT(NORDER(ISTATE))
         IPSTAT=NPSTAT(NORDER(ISTATE))
C
         ISTSIQ(IPSTAT,IPARIT)=ISTATE
C
         SPENER(ISTATE,ICHARG)=SPESIQ(IPSTAT,IPARIT)
C
C=======================================================================
C        STORING THE SINGLE-PARTICLE WAVE FUNCTIONS
C=======================================================================
C
         DO IREVER=0,NDREVE
C
            DO IPBASE=1,LDBASP(IPARIT)
C
               WAVOCC(INDPAR(IPBASE,IPARIT),ISTATE,IREVER)=
     *                EWASIQ(IPBASE+IREVER*LDBASP(IPARIT),IPSTAT,IPARIT)
C
            END DO
C
            DO IPBASE=1,LDBASP(1-IPARIT)
C
               WAVOCC(INDPAR(IPBASE,1-IPARIT),ISTATE,IREVER)=C_ZERO
C
            END DO
C
         END DO
C
      END DO
C
C=======================================================================
      DEALLOCATE (CELMTS,EWASIQ)
C=======================================================================
C
      CALL CPUTIM('DIASIQ',0)
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE DIASIZ(ICHARG,LIMPAR,ECUTOF,LDMEFI)
C=======================================================================
      USE MAT_PP
      USE MAT_PM
      USE ALLWAV
      USE ALLSIZ
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      COMPLEX
     *          CELMTS
C=======================================================================
      ALLOCATABLE CELMTS(:)
C=======================================================================
      COMMON
     *       /SPLEVS/ SPENER(1:2*NDSTAT,0:NDISOS),
     *                SPOCCU(1:2*NDSTAT,0:NDISOS),
     *                SPALIG(1:2*NDSTAT,0:NDISOS),
     *                SPSPAL(1:2*NDSTAT,0:NDISOS),
     *                SPPARI(1:2*NDSTAT,0:NDISOS),
     *                SPSIMP(1:2*NDSTAT,0:NDISOS)
      COMMON
     *       /SIZSPE/ SPESIZ(1:2*NDBASE)
      COMMON
     *       /EIGLIM/ EIGMIN,EIGMAX
      COMMON
     *       /SPNUMS/ NUMBSP(0:NDREVE,0:NDISOS)
      COMMON
     *       /DIMENS/ LDBASE
      COMMON
     *       /CFIPRI/ NFIPRI
C
C=======================================================================
C
      CALL CPUTIM('DIASIZ',1)
C
C=======================================================================
C
      IALLOC=0
C
C=======================================================================
      IF (.NOT.ALLOCATED(WAVOCC)) THEN
          ALLOCATE (WAVOCC(1:NDBASE,1:2*NDSTAT,0:NDREVE),STAT=IALLOC)
          IF (IALLOC.NE.0) CALL NOALLO('WAVOCC','DIASIZ')
      END IF
C=======================================================================
      IF (.NOT.ALLOCATED(EWASIZ)) THEN
          ALLOCATE (EWASIZ(1:2*NDBASE,1:2*NDBASE),STAT=IALLOC)
          IF (IALLOC.NE.0) CALL NOALLO('EWASIZ','DIASIZ')
      END IF
C=======================================================================
      ALLOCATE (CELMTS(1:(2*NDBASE+1)*NDBASE),STAT=IALLOC)
      IF (IALLOC.NE.0) CALL NOALLO('CELMTS','DIASIZ')
C=======================================================================
C
C=======================================================================
C        THIS SUBROUTINE PERFORMS THE DIAGONALIZATION IN THE CASE OF
C        NO CONSERVED SYMMETRIES
C=======================================================================
C
C=======================================================================
C         CONSTRUCTING THE HAMILTONIAN MATRIX
C=======================================================================
C
      DO IBRA=1,2*LDBASE
         DO IKET=1,2*LDBASE
C
            IF (IBRA.GE.IKET) THEN
C
                NCOUNT=IBRA+((4*LDBASE-IKET)*(IKET-1))/2
C
                IF (IBRA.LE.LDBASE.AND.IKET.LE.LDBASE)
     *
     *              CELMTS(NCOUNT)=BIG_PP(IBRA,IKET,0)
C
                IF (IBRA.GT.LDBASE.AND.IKET.LE.LDBASE)
     *
     *              CELMTS(NCOUNT)=BIG_PM(IBRA-LDBASE,IKET,1)
C
                IF (IBRA.GT.LDBASE.AND.IKET.GT.LDBASE)
     *
     *              CELMTS(NCOUNT)=BIG_PP(IBRA-LDBASE,IKET-LDBASE,1)
C
            END IF
C
         END DO
      END DO
C
C=======================================================================
C
      IF (LIMPAR.NE.1) THEN
C
          LDMEFI=NUMBSP(0,ICHARG)+NUMBSP(1,ICHARG)
C
          CALL DIAMAT(CELMTS,SPESIZ,EWASIZ,2*LDBASE,2*NDBASE,LDMEFI)
C
      ELSE
C
          LDMEFI=0
C
          EIGMIN=-200.0D0
          EIGMAX=ECUTOF
C
          CALL DIAMAT(CELMTS,SPESIZ,EWASIZ,2*LDBASE,2*NDBASE,LDMEFI)
C
          IF (LDMEFI.LT.NUMBSP(0,ICHARG)+NUMBSP(1,ICHARG)) THEN
C
              WRITE(NFIPRI,'(/,
     *                     1X,20(1H/),'' NOT ENOUGH SP STATES FOUND'',
     *                                '' IN DIASIZ'',    1X,19(1H/),/,
     *                     1X,20(1H/),'' LDMEFI='',I4,
     *                                '' SMALLER THAN NUMBSP='',I4,
     *                     1X,20(1H/),'' INCRESE THE CUTOFF ENERGY'',
     *                                '' ECUTOF    '',   1X,19(1H/),/,
     *                                                   1X,19(1H/),/)')
     *
     *        LDMEFI,NUMBSP(0,ICHARG)+NUMBSP(1,ICHARG)
C
              STOP 'INCREASE ECUTOF IN DIASIZ'
C
          END IF
C
      END IF
C
C=======================================================================
C
      DO IALLST=1,NUMBSP(0,ICHARG)+NUMBSP(1,ICHARG)
         SPENER(IALLST,ICHARG)=SPESIZ(IALLST)
      END DO
C
C=======================================================================
C
      DO IALLST=1,NUMBSP(0,ICHARG)+NUMBSP(1,ICHARG)
         DO IBASE=1,LDBASE
            WAVOCC(IBASE,IALLST,0)=EWASIZ(IBASE       ,IALLST)
            WAVOCC(IBASE,IALLST,1)=EWASIZ(IBASE+LDBASE,IALLST)
         END DO
      END DO
C
C=======================================================================
      DEALLOCATE (CELMTS)
C=======================================================================
C
      CALL CPUTIM('DIASIZ',0)
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
#if(USE_SCALAPACK==1)
C
      SUBROUTINE DIASIZ_sl(ICHARG,LIMPAR,ECUTOF,LDMEFI)
C=======================================================================
      USE MAT_PP
      USE MAT_PM
      USE ALLWAV
      USE ALLSIZ
      USE hfodd_SLsiz
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      COMPLEX
     *          CELMTS,C_ZERO
C=======================================================================
      ALLOCATABLE CELMTS(:)
C
      COMPLEX, POINTER, DIMENSION(:,:) :: CANHAM
      INTEGER :: ii,jj
      INTEGER :: numberMasters, numberHFODDproc, color,
     *           tribeRank, slaveRank, masterRank, worldRank,
     *           tribeSize, slaveSize, masterSize, worldSize
C
C=======================================================================
      COMMON
     *       /SPLEVS/ SPENER(1:2*NDSTAT,0:NDISOS),
     *                SPOCCU(1:2*NDSTAT,0:NDISOS),
     *                SPALIG(1:2*NDSTAT,0:NDISOS),
     *                SPSPAL(1:2*NDSTAT,0:NDISOS),
     *                SPPARI(1:2*NDSTAT,0:NDISOS),
     *                SPSIMP(1:2*NDSTAT,0:NDISOS)
      COMMON
     *       /SIZSPE/ SPESIZ(1:2*NDBASE)
      COMMON
     *       /EIGLIM/ EIGMIN,EIGMAX
      COMMON
     *       /SPNUMS/ NUMBSP(0:NDREVE,0:NDISOS)
      COMMON
     *       /DIMENS/ LDBASE
      COMMON
     *       /CFIPRI/ NFIPRI
C
      COMMON
     *       /SCALAPACK_INP/ NBLOCK,MBLOCK,NPGRID,MPGRID,KZHPEV
      COMMON
     *       /MPIPRO/ numberMasters, numberHFODDproc, color,
     *                tribeRank, slaveRank, masterRank, worldRank,
     *                tribeSize, slaveSize, masterSize, worldSize
C
C=======================================================================
C
      CALL SL_INIT(MPGRID,NPGRID,color,tribeRank,numberHFODDproc)
C
      NrINIT = NUMROC(2*LDBASE, MBLOCK, MYROW, 0, NPROW)
      NcINIT = NUMROC(2*LDBASE, NBLOCK, MYCOL, 0, NPCOL)
C
      CALL initSL_siz(2*LDBASE,2*LDBASE,NrINIT,NcINIT,MBLOCK,NBLOCK)
C
C=======================================================================
C
      CALL CPUTIM('DIASIZ',1)
C
C=======================================================================
C
      IALLOC=0
C
C=======================================================================
      IF (.NOT.ALLOCATED(WAVOCC)) THEN
          ALLOCATE (WAVOCC(1:NDBASE,1:2*NDSTAT,0:NDREVE),STAT=IALLOC)
          IF (IALLOC.NE.0) CALL NOALLO('WAVOCC','DIASIZ')
      END IF
C=======================================================================
      IF (.NOT.ALLOCATED(EWASIZ)) THEN
          ALLOCATE (EWASIZ(1:2*NDBASE,1:2*NDBASE),STAT=IALLOC)
          IF (IALLOC.NE.0) CALL NOALLO('EWASIZ','DIASIZ')
      END IF
C=======================================================================
      ALLOCATE (CELMTS(1:(2*NDBASE+1)*NDBASE),STAT=IALLOC)
      IF (IALLOC.NE.0) CALL NOALLO('CELMTS','DIASIZ')
C=======================================================================
      ALLOCATE(CANHAM(larow,lacol))
C=======================================================================
C
C=======================================================================
C        THIS SUBROUTINE PERFORMS THE DIAGONALIZATION IN THE CASE OF
C        NO CONSERVED SYMMETRIES
C=======================================================================
C
      C_ZERO=CMPLX(0.0D0,0.0D0)
C
C=======================================================================
C         CONSTRUCTING THE HAMILTONIAN MATRIX
C=======================================================================
C        SEE COMMENT ON PERFORMANCE IN DIASIM
C=======================================================================
C
      NCOUNT=0
      DO ii=0, larow-1
         IBRA = MB*(NPROW*INT(ii/MB) + MYROW) + MOD(ii,MB) + 1
         if (IBRA .gt. 2*LDBASE) CYCLE
         DO jj=0, lacol-1
            IKET = NB*(NPCOL*INT(jj/NB) + MYCOL) + MOD(jj,NB) + 1
            if (IKET .gt. 2*LDBASE) CYCLE
C
            NCOUNT=NCOUNT+1
C
            IF (IBRA.LE.LDBASE.AND.IKET.LE.LDBASE)
     *
     *           CANHAM(ii+1,jj+1) = BIG_PP(IBRA,IKET,0)
C
            IF (IBRA.GT.LDBASE.AND.IKET.LE.LDBASE)
     *
     *           CANHAM(ii+1,jj+1) = BIG_PM(IBRA-LDBASE,IKET,1)
C
            IF (IBRA.GT.LDBASE.AND.IKET.GT.LDBASE)
     *
     *           CANHAM(ii+1,jj+1) = BIG_PP(IBRA-LDBASE,IKET-LDBASE,1)
C
         END DO
      END DO
C
C=======================================================================
C
      IF (LIMPAR.NE.1) THEN
C
          LDMEFI=NUMBSP(0,ICHARG)+NUMBSP(1,ICHARG)
C
          CALL diaSL_HFB_siz(CANHAM,KZHPEV)
          CALL diaSL_collapse_HFB_siz(EWASIZ,SPESIZ,2*NDBASE)
C
      ELSE
C
          LDMEFI=0
C
          EIGMIN=-200.0D0
          EIGMAX=ECUTOF
C
          CALL DIAMAT(CELMTS,SPESIZ,EWASIZ,2*LDBASE,2*NDBASE,LDMEFI)
C
          IF (LDMEFI.LT.NUMBSP(0,ICHARG)+NUMBSP(1,ICHARG)) THEN
C
              WRITE(NFIPRI,'(/,
     *                     1X,20(1H/),'' NOT ENOUGH SP STATES FOUND'',
     *                                '' IN DIASIZ'',    1X,19(1H/),/,
     *                     1X,20(1H/),'' LDMEFI='',I4,
     *                                '' SMALLER THAN NUMBSP='',I4,
     *                     1X,20(1H/),'' INCRESE THE CUTOFF ENERGY'',
     *                                '' ECUTOF    '',   1X,19(1H/),/,
     *                                                   1X,19(1H/),/)')
     *
     *        LDMEFI,NUMBSP(0,ICHARG)+NUMBSP(1,ICHARG)
C
              STOP 'INCREASE ECUTOF IN DIASIZ'
C
          END IF
C
      END IF
C
      DEALLOCATE(CANHAM)
      CALL BLACS_GRIDEXIT(ICTXT)
C
C=======================================================================
C
      DO IALLST=1,NUMBSP(0,ICHARG)+NUMBSP(1,ICHARG)
         SPENER(IALLST,ICHARG)=SPESIZ(IALLST)
      END DO
C
C=======================================================================
C
      DO IALLST=1,NUMBSP(0,ICHARG)+NUMBSP(1,ICHARG)
         DO IBASE=1,LDBASE
            WAVOCC(IBASE,IALLST,0)=EWASIZ(IBASE       ,IALLST)
            WAVOCC(IBASE,IALLST,1)=EWASIZ(IBASE+LDBASE,IALLST)
         END DO
      END DO
C
C=======================================================================
      DEALLOCATE (CELMTS)
C=======================================================================
C
      CALL CPUTIM('DIASIZ',0)
C
C=======================================================================
C
      RETURN
      END SUBROUTINE DIASIZ_sl
C
#endif
C=======================================================================
C
      SUBROUTINE HFBSIG(EFERMI,ECUTOF,LIMQUA,ICHARG,IMFHFB,
     *                         INSIGB,IPSIGB,ISSIGB,IDSIGB,
     *                                       IFIBLB,ISABLB,
     *                         IREQPB,INUQPB,JNUQPB,IF_RPA)
C=======================================================================
      USE PAIDEL
      USE MAT_PP
      USE ALLQUA
      USE SAVQUA
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      COMPLEX
     *          CELMTS,PWAHFB,C_ZERO
C=======================================================================
      ALLOCATABLE PWAHFB(:,:,:)
      ALLOCATABLE CELMTS(:)
C=======================================================================
      DIMENSION
     *          IDSTAT(0:NDREVE),I_STAT(0:NDREVE)
      DIMENSION
     *          PQUHFB(1:2*NDBASP,0:NDPARI)
      DIMENSION
     *          IALLXX(1:NDSTAT,0:NDREVE)
      DIMENSION
     *          LDQUAP(0:NDPARI),LDHALF(0:NDPARI),LDOFFS(0:NDPARI)
      DIMENSION
     *          EORDER(1:2*NDBASE),NORDER(1:2*NDBASE),
     *          NREVER(1:2*NDBASE),NPSTAT(1:2*NDBASE),
     *          NPARIT(1:2*NDBASE)
C
      COMMON
     *       /XEQUIV/ EEQUIV(1:NDSTAT,0:NDREVE),
     *                DEQUIV(1:NDSTAT,0:NDREVE)
      COMMON
     *       /QUAPAR/ ENQUAP(1:NDSTAT,0:NDREVE),
     *                V2QUAP(1:NDSTAT,0:NDREVE)
      COMMON
     *       /PARIQU/ QPPARI(1:NDSTAT,0:NDREVE)
      COMMON
     *       /QUACNS/ E_QUAP(1:NDBASE,0:NDREVE)
      COMMON
     *       /QUAISO/ EQPISO(1:NDBASE,0:NDREVE,0:NDISOS),
     *                VQPISO(1:NDBASE,0:NDREVE,0:NDISOS)
      COMMON
     *       /EQUISO/ ESPEQU(1:NDBASE,0:NDREVE,0:NDISOS),
     *                DELEQU(1:NDBASE,0:NDREVE,0:NDISOS)
C@@@ TEMP - TEMP - TEMP - TEMP - TEMP - TEMP - TEMP - TEMP - TEMP
      COMMON
     *       /FERFUN/ FER_FN(1:NDBASE)
     *       /FER_IS/ FERMFN(1:NDBASE,0:NDISOS)
      COMMON
     *       /T_FLAG/ IFTEMP
      COMMON
     *       /GCTEMP/ TEMP_T
      COMMON
     *       /SENTRO/ ENTRPY(0:NDISOS)
C@@@ TEMP - TEMP - TEMP - TEMP - TEMP - TEMP - TEMP - TEMP - TEMP
      COMMON
     *       /QPNUMS/ NUMBQP(0:NDREVE,0:NDISOS)
      COMMON
     *       /PARIND/ INDPAR(1:NDBASE,0:NDPARI)
      COMMON
     *       /EIGLIM/ EIGMIN,EIGMAX
      COMMON
     *       /DIMENP/ LDBASP(0:NDPARI)
      COMMON
     *       /DIMENS/ LDBASE
      COMMON
     *       /CFIPRI/ NFIPRI
C
C=======================================================================
C
      CALL CPUTIM('HFBSIG',1)
C
C=======================================================================
C
      IALLOC=0
      C_ZERO=CMPLX(0.0D0,0.0D0)
C
C=======================================================================
      IF (.NOT.ALLOCATED(AWAQUA)) THEN
          ALLOCATE (AWAQUA(1:NDBASE,1:NDSTAT,0:NDREVE),STAT=IALLOC)
          IF (IALLOC.NE.0) CALL NOALLO('AWAQUA','HFBSIG')
          AWAQUA = C_ZERO
      END IF
      IF (.NOT.ALLOCATED(BWAQUA)) THEN
          ALLOCATE (BWAQUA(1:NDBASE,1:NDSTAT,0:NDREVE),STAT=IALLOC)
          IF (IALLOC.NE.0) CALL NOALLO('BWAQUA','HFBSIG')
          BWAQUA = C_ZERO
      END IF
C=======================================================================
C
      IF (IF_RPA.EQ.1.OR.IFTEMP.EQ.1) THEN
C
          IF (.NOT.ALLOCATED(ASVQUA)) THEN
              ALLOCATE (ASVQUA(1:NDBASE,1:NDSTAT,0:NDREVE,0:NDISOS),
     *                  STAT=IALLOC)
              IF (IALLOC.NE.0) CALL NOALLO('ASVQUA','HFBSIG')
              ASVQUA(:,:,:,:) = C_ZERO
          END IF
          IF (.NOT.ALLOCATED(BSVQUA)) THEN
              ALLOCATE (BSVQUA(1:NDBASE,1:NDSTAT,0:NDREVE,0:NDISOS),
     *                  STAT=IALLOC)
              IF (IALLOC.NE.0) CALL NOALLO('BSVQUA','HFBSIG')
              BSVQUA(:,:,:,:) = C_ZERO
          END IF
C
      END IF
C
C=======================================================================
      ALLOCATE (CELMTS(1:(2*NDBASP+1)*NDBASP),STAT=IALLOC)
      IF (IALLOC.NE.0) CALL NOALLO('CELMTS','HFBSIG')
      CELMTS(:) = C_ZERO
      ALLOCATE (PWAHFB(1:2*NDBASP,1:2*NDBASP,0:NDPARI),STAT=IALLOC)
      IF (IALLOC.NE.0) CALL NOALLO('PWAHFB','HFBSIG')
      PWAHFB(:,:,:) = C_ZERO
C=======================================================================
C
C=======================================================================
C         THIS SUBROUTINE PREPARES THE DIAGONALIZATION OF THE HFB MATRIX
C         FOR THE PARITY/SIGNATURE NO-SYMMETRY CASE
C=======================================================================
C
      I_STAT(0)=0
      I_STAT(1)=0
C
C=======================================================================
C     SEE COMMENTS ABOUT NDBASP IN THE DIASIQ SUBROUTINE
C=======================================================================
C
      IF (MAX(LDBASP(0),LDBASP(1)).GT.NDBASP) THEN
C
          WRITE(NFIPRI,'(/,
     *                 1X,20(1H/),'' PARAMETER NDBASP TOO SMALL'',
     *                            '' IN HFBSIG'',       1X,19(1H/),/,
     *                 1X,20(1H/),'' NDBASP ='',I3,
     *                            '' INCREASE TO  NDBASP ='',I3,
     *                                                  1X,19(1H/),/)')
     *
     *    NDBASP,MAX(LDBASP(0),LDBASP(1))
C
          STOP 'INCREASE NDBASP IN HFBSIG'
C
      END IF
C
C=======================================================================
C     CONSTRUCTING THE HFB MATRIX
C=======================================================================
C
      DO IPARIT=0,NDPARI
C
         LDPARI=LDBASP(IPARIT)
C
         NCOUNT=0
C
         DO IKETPA=1,2*LDPARI
            DO IBRAPA=IKETPA,2*LDPARI
C
               NCOUNT=NCOUNT+1
C
               IF (IBRAPA.LE.LDPARI.AND.IKETPA.LE.LDPARI)
     *            CELMTS(NCOUNT)=BIG_PP(INDPAR(IBRAPA,       IPARIT),
     *                                  INDPAR(IKETPA,       IPARIT),0)
C
               IF (IBRAPA.GT.LDPARI.AND.IKETPA.LE.LDPARI)
     *            CELMTS(NCOUNT)=
     *                    -CONJG(HAMIDE(INDPAR(IBRAPA-LDPARI,IPARIT),
     *                                  INDPAR(IKETPA,       IPARIT),0))
C
               IF (IBRAPA.GT.LDPARI.AND.IKETPA.GT.LDPARI)
     *            CELMTS(NCOUNT)=
     *                    -CONJG(BIG_PP(INDPAR(IBRAPA-LDPARI,IPARIT),
     *                                  INDPAR(IKETPA-LDPARI,IPARIT),1))
C
            END DO
         END DO
C
C=======================================================================
C     SUBTRACTING THE FERMI ENERGY TERM FROM THE MEAN FIELD
C=======================================================================
C
         DO IBRAPA=1,2*LDPARI
C
            IKETPA=IBRAPA
C
            NCOUNT=IBRAPA+((4*LDPARI-IKETPA)*(IKETPA-1))/2
C
            IF (IBRAPA.LE.LDPARI)
     *         CELMTS(NCOUNT)=CELMTS(NCOUNT)-EFERMI
C
            IF (IBRAPA.GT.LDPARI)
     *         CELMTS(NCOUNT)=CELMTS(NCOUNT)+EFERMI
C
         END DO
C
C=======================================================================
C
         IF (LIMQUA.EQ.1) THEN
C
             LDQUAP(IPARIT)=0
C
             EIGMIN=EFERMI-ECUTOF
             EIGMAX=ECUTOF-EFERMI
C
         ELSE
C
             LDQUAP(IPARIT)=2*LDPARI
C
         ENDIF
C
C=======================================================================
C        CALLING THE DIAGONALIZATION ROUTINE
C=======================================================================
C
         CALL DIAMAT(CELMTS,PQUHFB(1,IPARIT),PWAHFB(1,1,IPARIT),
     *                                 2*LDPARI,2*NDBASP,LDQUAP(IPARIT))
C
C=======================================================================
C          BELOW WE DEAL WITH A POSSIBLE SITUATION OF AN ODD  NUMBER  OF
C          THE QUASIPARTICLE STATES  FOUND  IN  A  GIVEN  ENERGY  WINDOW
C          (FOR LIMQUA=1). THEN WE DISREGARD  THE  STATE  THAT  HAS  THE
C          LARGEST ABSOLUTE VALUE OF THE QUASIPARTICLE ENERGY.
C=======================================================================
C
         IF (MOD(LDQUAP(IPARIT),2).EQ.0) THEN
C
             LDHALF(IPARIT)=LDQUAP(IPARIT)/2
             LDOFFS(IPARIT)=0
C
         ELSE
C
             LDHALF(IPARIT)=(LDQUAP(IPARIT)-1)/2
C
             IF (ABS(PQUHFB(             1,IPARIT)).LT.
     *           ABS(PQUHFB(LDQUAP(IPARIT),IPARIT))) THEN
C
                 LDOFFS(IPARIT)=0
             ELSE
                 LDOFFS(IPARIT)=1
C
             END IF
C
         END IF
C
      END DO
C
C=======================================================================
C         DETERMINING THE ORDERED QUASIPARTICLE SPECTRUM
C=======================================================================
C
      IORDER=0
C
      DO IPARIT=0,NDPARI
C
         LDPARI=LDBASP(IPARIT)
C
         DO IREVER=0,NDREVE
C
            DO IPSTAT=1,LDHALF(IPARIT)
C
               IORDER=IORDER+1
               IF (IORDER.GT.2*LDBASE) STOP' IORDER TOO LARGE IN HFBSIG'
               NORDER(IORDER)=IORDER
               NPARIT(IORDER)=IPARIT
               EORDER(IORDER)=(2*IREVER-1)
     *              *PQUHFB(IPSTAT+LDOFFS(IPARIT)+IREVER*LDHALF(IPARIT),
     *                                                          IPARIT)
               NPSTAT(IORDER)=IPSTAT+LDOFFS(IPARIT)
               NREVER(IORDER)=IREVER
C
            END DO
C
         END DO
C
      END DO
C
      LDORDE=IORDER
C
      CALL ORDER1(EORDER,NORDER,LDORDE)
C
C=======================================================================
C         LOOP OVER ORDERED QUASIPARTICLE STATES
C=======================================================================
C
      INCORR=0
C
      IDSTAT(0)=0
      IDSTAT(1)=0
C
      DO IALLST=1,LDORDE
C
         IPSTAT=NPSTAT(NORDER(IALLST))
         IREVER=NREVER(NORDER(IALLST))
         IPARIT=NPARIT(NORDER(IALLST))
C
         LDPARI=LDBASP(IPARIT)
C
C=======================================================================
C        CALCULATING THE NORMS OF THE "FIRST" COMPONENTS
C=======================================================================
C
         VORDER=0.0D0
C
         DO IBASE=1,LDPARI
C
            VORDER=VORDER+ABS(PWAHFB( IBASE+IREVER*LDPARI,
     *                IPSTAT+IREVER*LDHALF(IPARIT),IPARIT))**2
C
         END DO
C
C=======================================================================
C        CHECKING VALUES OF VORDER - JUST IN CASE. VALUES WHICH ARE OUT
C        OF BOUNDS UP TO A SMALL MACHINE-PRECISION NUMBER "EMACHI"  ARE
C        REPLACED BY THE VALUES AT BOUNDS.
C=======================================================================
C
         EMACHI=1.0D-10
C
         IF (VORDER.GT.1+EMACHI.OR.VORDER.LT. -EMACHI) THEN
C
             EMAXOL=EMACHI
             EMACHI=1.0D-2
C
             WRITE(NFIPRI,'(/,1X,20(''/''),
     *          '' ERROR IN NORMALIZATION OF'',      9X,20(''/''),/,
     *          1X,20(''/''),
     *          '' QUASIPARTICLES IN HFBSIG.'',      9X,20(''/''),/,
     *          1X,20(''/''),
     *          '' IF THIS IS A ROUND-OFF PROBLEM'', 4X,20(''/''),/,
     *          1X,20(''/''),
     *          '' YOU MAY CHANGE VALUE OF EMACHI.'',3X,20(''/''),/,
     *          1X,20(''/''),'' IPSTAT='',I5,'' IREVER='',I2,
     *                                        12X,20(''/''),/,
     *          1X,20(''/''),'' VORDER='',D25.18,
     *                                         2X,20(''/''),/,
     *          1X,20(''/''),'' EMACHI='',D9.7,'' --->>> '',D9.7,
     *                                            2X,20(''/''),/)')
     *
     *             IPSTAT,IREVER,VORDER,EMAXOL,EMACHI
C
c             STOP 'ERROR IN NORMALIZATION OF QUASIPARTICLES IN HFBSIG'
C
         END IF
C
         IF (VORDER.GT.1) VORDER=1.0D0
         IF (VORDER.LT.0) VORDER=0.0D0
C
C=======================================================================
C
         I_STAT(IREVER)=I_STAT(IREVER)+1
         E_QUAP(I_STAT(IREVER),IREVER)=EORDER(IALLST)
C
C=======================================================================
C        CALCULATING THE EQUIVALENT SPECTRUM AND CUTTING-OFF THE STATES
C        WITH HIGH EQUIVALENT ENERGIES
C=======================================================================
C
         HORDER=EORDER(IALLST)*(1.0D0-2.0D0*VORDER)
C
c         IF (HORDER+EFERMI.GT.ECUTOF) GO TO 1
C
         EPSILO=1.D-6
C
         IF (100.0D0*(HORDER+EFERMI-ECUTOF).LT.LOG(HUGE(1.0D0))) THEN
             E_TEST=1.0D0/(1.0D0+EXP(100.0D0*(HORDER+EFERMI-ECUTOF)))
         ELSE
             E_TEST=0.0D0
         END IF
C
         IF (HORDER+EFERMI.GT.ECUTOF.AND.E_TEST.LT.1.D-6) GO TO 1
C
         IDSTAT(IREVER)=IDSTAT(IREVER)+1
C
         EQPISO(IDSTAT(IREVER),IREVER,ICHARG)=EORDER(IALLST)
C
         IF (IDSTAT(IREVER).GT.NDSTAT) THEN
C
             INCORR=1
             GO TO 1
C
         END IF
C
C=======================================================================
C        SEE COMMENTS IN THE HFBSIM SUBROUTINE ABOUT THE EQUIVALENT
C        SPECTRUM
C=======================================================================
C
         DEQUIV(IDSTAT(IREVER),IREVER)=
     *                            SQRT(ABS(EORDER(IALLST)**2-HORDER**2))
         DELEQU(IDSTAT(IREVER),IREVER,ICHARG)=
     *                            SQRT(ABS(EORDER(IALLST)**2-HORDER**2))
C
         EEQUIV(IDSTAT(IREVER),IREVER)=HORDER+EFERMI
         ESPEQU(IDSTAT(IREVER),IREVER,ICHARG)=HORDER+EFERMI
C
C=======================================================================
C        DEFINING THE QUASIPARTICLE ENERGIES AND OCCUPATIONS
C=======================================================================
C
         ENQUAP(IDSTAT(IREVER),IREVER)=EORDER(IALLST)
C
         V2QUAP(IDSTAT(IREVER),IREVER)=VORDER
         VQPISO(IDSTAT(IREVER),IREVER,ICHARG)=VORDER
C
         QPPARI(IDSTAT(IREVER),IREVER)=1.0D0-2.0D0*IPARIT
C
C=======================================================================
C        SEE COMMENTS IN THE HFBSIM SUBROUTINE ABOUT THE BOGOLIUBOV
C        MATRICES
C=======================================================================
C
         JPARIT=1-IPARIT
         KDPARI=LDBASP(JPARIT)
C
         IF (IREVER.EQ.0) THEN
C
             DO IPBASE=1,LDPARI
C
                BWAQUA(INDPAR(IPBASE,IPARIT),IDSTAT(0),0)=
     *                       PWAHFB(IPBASE       ,IPSTAT,IPARIT)
                AWAQUA(INDPAR(IPBASE,IPARIT),IDSTAT(0),1)=
     *                       PWAHFB(IPBASE+LDPARI,IPSTAT,IPARIT)
C
             END DO
C
             DO IPBASE=1,KDPARI
C
                BWAQUA(INDPAR(IPBASE,JPARIT),IDSTAT(0),0)=C_ZERO
                AWAQUA(INDPAR(IPBASE,JPARIT),IDSTAT(0),1)=C_ZERO
C
             END DO
C
	     IALLXX(IDSTAT(0),0)=IALLST
C
         ELSE
C
             DO IPBASE=1,LDPARI
C
                BWAQUA(INDPAR(IPBASE,IPARIT),IDSTAT(1),1)=
     *           CONJG(PWAHFB(IPBASE+LDPARI,IPSTAT+LDHALF(IPARIT),
     *                                                    IPARIT))
                AWAQUA(INDPAR(IPBASE,IPARIT),IDSTAT(1),0)=
     *           CONJG(PWAHFB(IPBASE       ,IPSTAT+LDHALF(IPARIT),
     *                                                    IPARIT))
C
             END DO
C
             DO IPBASE=1,KDPARI
C
                BWAQUA(INDPAR(IPBASE,JPARIT),IDSTAT(1),1)=C_ZERO
                AWAQUA(INDPAR(IPBASE,JPARIT),IDSTAT(1),0)=C_ZERO
C
             END DO
C
             IALLXX(IDSTAT(1),1)=IALLST
C
         END IF
C
C=======================================================================
C        SEE COMMENTS IN THE HFBSIM SUBROUTINE ABOUT THE BOGOLIUBOV
C        MATRICES
C=======================================================================
C
         IF (IF_RPA.EQ.1.OR.IFTEMP.EQ.1) THEN
C
             IF (IREVER.EQ.0) THEN
C
                 DO IPBASE=1,LDPARI
C
                    BSVQUA(INDPAR(IPBASE,IPARIT),IDSTAT(0),0,ICHARG)=
     *                           PWAHFB(IPBASE       ,IPSTAT,IPARIT)
                    ASVQUA(INDPAR(IPBASE,IPARIT),IDSTAT(0),1,ICHARG)=
     *                           PWAHFB(IPBASE+LDPARI,IPSTAT,IPARIT)
C
                 END DO
C
                 DO IPBASE=1,KDPARI
C
                    BSVQUA(INDPAR(IPBASE,JPARIT),IDSTAT(0),0,ICHARG)
     *             =C_ZERO
                    ASVQUA(INDPAR(IPBASE,JPARIT),IDSTAT(0),1,ICHARG)
     *             =C_ZERO
C
                 END DO
C
             ELSE
C
                 DO IPBASE=1,LDPARI
C
                    BSVQUA(INDPAR(IPBASE,IPARIT),IDSTAT(1),1, ICHARG)=
     *               CONJG(PWAHFB(IPBASE+LDPARI,IPSTAT+LDHALF(IPARIT),
     *                                                        IPARIT))
                    ASVQUA(INDPAR(IPBASE,IPARIT),IDSTAT(1),0, ICHARG)=
     *               CONJG(PWAHFB(IPBASE       ,IPSTAT+LDHALF(IPARIT),
     *                                                        IPARIT))
C
                 END DO
C
                 DO IPBASE=1,KDPARI
C
                    BSVQUA(INDPAR(IPBASE,JPARIT),IDSTAT(1),1,ICHARG)
     *             =C_ZERO
                    ASVQUA(INDPAR(IPBASE,JPARIT),IDSTAT(1),0,ICHARG)
     *             =C_ZERO
C
                 END DO
C
	     END IF
C
         END IF
C
C=======================================================================
C
    1    CONTINUE
C
      END DO
C
C@@@ TEMP - TEMP - TEMP - TEMP - TEMP - TEMP - TEMP - TEMP - TEMP
C=====================================================================
C          CALCULATION OF ENTROPY AT FINITE TEMPERATURE TEMP_T
C=====================================================================
C
      ENTRPY(ICHARG)=0.0D0
      EPSILO=1.0D-13
C
      IF (IFTEMP.EQ.1) THEN
C
          DO ISTATE=1,LDHALF(0)+LDHALF(1)
C
             FERDIR=0.5D0*(1.0D0-TANH(E_QUAP(ISTATE,0)/TEMP_T/2.0D0))
             FER_FN(ISTATE)=FERDIR
             FERMFN(ISTATE,ICHARG)=FERDIR
C
             IF (ABS(FERDIR).GT.EPSILO.AND.(1.0D0-FERDIR).GT.EPSILO)
     *       THEN
                 ENTRPY(ICHARG)=ENTRPY(ICHARG)-FERDIR*LOG(FERDIR)-
     *                           (1.0D0-FERDIR)*LOG(1.0D0-FERDIR)
             END IF
C
          END DO
C
C=======================================================================
C          BUG VERSION 2.49T: SEE COMMENTS IN SUBROUTINE HFBSIM
C=======================================================================
C
          ENTRPY(ICHARG)=2.0D0*ENTRPY(ICHARG)
C
      END IF
C
C@@@ TEMP - TEMP - TEMP - TEMP - TEMP - TEMP - TEMP - TEMP - TEMP
C=======================================================================
C         DEFINING NUMBERS OF QUASIPARTICLES KEPT AFTER THE CUT-OFF
C=======================================================================
C
      DO IREVER=0,NDREVE
C
         NUMBQP(IREVER,ICHARG)=IDSTAT(IREVER)
C
      END DO
C
C=======================================================================
C         DETERMINING THE HFB MEAN-FIELD EIGENSTATES AND SPECTRUM
C=======================================================================
C
      IF (ABS(IDSIGB).EQ.1.OR.IMFHFB.EQ.1) THEN
C
          CALL DIASIG(1,ICHARG)
C
      END IF
C
C=======================================================================
C         HERE QUASIPARTICLE STATES ARE BLOCKED
C=======================================================================
C
      IREQPB=0
      INUQPB=0
      JNUQPB=0
C
      IF (ABS(IDSIGB).EQ.1) THEN
C
          CALL BLOSIG(ICHARG,INSIGB,IPSIGB,ISSIGB,IDSIGB,IREQPB,INUQPB,
     *                                                   IFIBLB,ISABLB)
C
          IPSTAT=NPSTAT(NORDER(IALLXX(INUQPB,IREQPB)))
          IREVER=NREVER(NORDER(IALLXX(INUQPB,IREQPB)))
          IPARIT=NPARIT(NORDER(IALLXX(INUQPB,IREQPB)))
C
          IF (IREVER.NE.IREQPB) STOP ' INCONSISTENT IREVER IN HFBSIG'
C
          LDPARI=LDBASP(IPARIT)
C
          IF (IREQPB.EQ.0) THEN
C
              IDSTAT(1)=IDSTAT(1)+1
C
              IF (IDSTAT(1).GT.NDSTAT) THEN
C
                  INCORR=1
                  GO TO 2
C
              END IF
C
C=======================================================================
C         HERE THE BLOCKED QUASIPARTICLE STATE IS  ZEROED  AND  INVERTED
C         QUASIPARTICLE STATE IS ADDED TO THE OPPOSITE SIMPLEX
C=======================================================================
C
              DO IPBASE=1,LDPARI
C
                 BWAQUA(INDPAR(IPBASE,IPARIT),INUQPB,0)=C_ZERO
                 AWAQUA(INDPAR(IPBASE,IPARIT),INUQPB,1)=C_ZERO
C
                 BWAQUA(INDPAR(IPBASE,IPARIT),IDSTAT(1),1)=
     *                        CONJG(PWAHFB(IPBASE+LDPARI,IPSTAT,IPARIT))
                 AWAQUA(INDPAR(IPBASE,IPARIT),IDSTAT(1),0)=
     *                        CONJG(PWAHFB(IPBASE       ,IPSTAT,IPARIT))
C
              END DO
C
              DEQUIV(IDSTAT(1),1)=      DEQUIV(INUQPB,0)
              EEQUIV(IDSTAT(1),1)=      EEQUIV(INUQPB,0)
              ENQUAP(IDSTAT(1),1)=      ENQUAP(INUQPB,0)
              V2QUAP(IDSTAT(1),1)=1.0D0-V2QUAP(INUQPB,0)
              QPPARI(IDSTAT(1),1)=      QPPARI(INUQPB,0)
C
	      JNUQPB=IDSTAT(1)
C
          ELSE
C
              IDSTAT(0)=IDSTAT(0)+1
C
              IF (IDSTAT(0).GT.NDSTAT) THEN
C
                  INCORR=1
                  GO TO 2
C
              END IF
C
              DO IPBASE=1,LDPARI
C
                 BWAQUA(INDPAR(IPBASE,IPARIT),INUQPB,1)=C_ZERO
                 AWAQUA(INDPAR(IPBASE,IPARIT),INUQPB,0)=C_ZERO
C
                 BWAQUA(INDPAR(IPBASE,IPARIT),IDSTAT(0),0)=
     *                        PWAHFB(IPBASE       ,IPSTAT+LDPARI,IPARIT)
                 AWAQUA(INDPAR(IPBASE,IPARIT),IDSTAT(0),1)=
     *                        PWAHFB(IPBASE+LDPARI,IPSTAT+LDPARI,IPARIT)
C
              END DO
C
              DEQUIV(IDSTAT(0),0)=      DEQUIV(INUQPB,1)
              EEQUIV(IDSTAT(0),0)=      EEQUIV(INUQPB,1)
              ENQUAP(IDSTAT(0),0)=      ENQUAP(INUQPB,1)
              V2QUAP(IDSTAT(0),0)=1.0D0-V2QUAP(INUQPB,1)
              QPPARI(IDSTAT(0),0)=      QPPARI(INUQPB,1)
C
	      JNUQPB=IDSTAT(0)
C
          END IF
C
C=======================================================================
C
    2     CONTINUE
C
C=======================================================================
C
      END IF
C
C=======================================================================
C         DEFINING NUMBERS OF QUASIPARTICLES KEPT AFTER THE BLOCKING
C=======================================================================
C
      DO IREVER=0,NDREVE
C
         NUMBQP(IREVER,ICHARG)=IDSTAT(IREVER)
C
      END DO
C
C=======================================================================
C         STOP IN CASE OF AN INCORRECT PHASE SPACE
C=======================================================================
C
      IF (INCORR.EQ.1) THEN
C
          WRITE(NFIPRI,'(/,                             1X,20(1H/),
     *              '' TOO LARGE PHASE-SPACE SIZE IN HFBSIG'',
     *                                                   1X,20(1H/),/,
     *                 1X,20(1H/),
     *              '' ICHARG='',I2,3X,'' NDSTAT='',I4, 13X,20(1H/),/,
     *                 1X,20(1H/),
     *              '' IREVER='',I2,3X,'' REQUIRES NUMBQP='',I4,
     *                                                   4X,20(1H/),/,
     *                 1X,20(1H/),
     *              '' IREVER='',I2,3X,'' REQUIRES NUMBQP='',I4,
     *                                                   4X,20(1H/),/,
     *                 1X,20(1H/),
     *              '' INCREASE NDSTAT UP TO NUMBQP OR MORE'',
     *                                                   1X,20(1H/),/)')
     *
     *    ICHARG,NDSTAT,(IREVER,NUMBQP(IREVER,ICHARG),IREVER=0,NDREVE)
C
          STOP ' TOO LARGE PHASE-SPACE SIZE IN HFBSIG'
C
      END IF
C
C=======================================================================
      DEALLOCATE (CELMTS,PWAHFB)
      DEALLOCATE (HAMIDE)
C=======================================================================
C
      CALL CPUTIM('HFBSIG',0)
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE HFBSIM(EFERMI,ECUTOF,LIMQUA,ICHARG,IMFHFB,
     *                                INSIMB,IRSIMB,IDSIMB,
     *                                       IFIBLB,ISABLB,
     *                         IREQPB,INUQPB,JNUQPB,IF_RPA)
C=======================================================================
      USE PAIDEL
      USE MAT_PP
      USE ALLQUA
      USE SAVQUA
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      COMPLEX
     *          CELMTS,EWAHFB,C_ZERO
C=======================================================================
      ALLOCATABLE EWAHFB(:,:)
C=======================================================================
#if(USE_MPI==1)
      integer :: escapeSignal,mpi_rank,mpi_err
#endif
      DIMENSION
     *          IDSTAT(0:NDREVE),I_STAT(0:NDREVE)
      DIMENSION
     *          EQUHFB(1:2*NDBASE)
      DIMENSION
     *          IALLXX(1:NDSTAT,0:NDREVE)
C=======================================================================
      ALLOCATABLE CELMTS(:)
C=======================================================================
      DIMENSION
     *          EORDER(1:2*NDBASE),NORDER(1:2*NDBASE),
     *          NREVER(1:2*NDBASE),NSTATE(1:2*NDBASE)
C
      COMMON
     *       /XEQUIV/ EEQUIV(1:NDSTAT,0:NDREVE),
     *                DEQUIV(1:NDSTAT,0:NDREVE)
      COMMON
     *       /QUAPAR/ ENQUAP(1:NDSTAT,0:NDREVE),
     *                V2QUAP(1:NDSTAT,0:NDREVE)
      COMMON
     *       /PARIQU/ QPPARI(1:NDSTAT,0:NDREVE)
      COMMON
     *       /QUACNS/ E_QUAP(1:NDBASE,0:NDREVE)
      COMMON
     *       /QUAISO/ EQPISO(1:NDBASE,0:NDREVE,0:NDISOS),
     *                VQPISO(1:NDBASE,0:NDREVE,0:NDISOS)
      COMMON
     *       /EQUISO/ ESPEQU(1:NDBASE,0:NDREVE,0:NDISOS),
     *                DELEQU(1:NDBASE,0:NDREVE,0:NDISOS)
C@@@ TEMP - TEMP - TEMP - TEMP - TEMP - TEMP - TEMP - TEMP - TEMP
      COMMON
     *       /FERFUN/ FER_FN(1:NDBASE)
     *       /FER_IS/ FERMFN(1:NDBASE,0:NDISOS)
      COMMON
     *       /T_FLAG/ IFTEMP
      COMMON
     *       /GCTEMP/ TEMP_T
      COMMON
     *       /SENTRO/ ENTRPY(0:NDISOS)
C@@@ TEMP - TEMP - TEMP - TEMP - TEMP - TEMP - TEMP - TEMP - TEMP
      COMMON
     *       /PARBAS/ IBAPAR(1:NDBASE)
      COMMON
     *       /QPNUMS/ NUMBQP(0:NDREVE,0:NDISOS)
      COMMON
     *       /EIGLIM/ EIGMIN,EIGMAX
      COMMON
     *       /DIMENS/ LDBASE
      COMMON
     *       /CFIPRI/ NFIPRI
#if(USE_MPI==1)
      COMMON
     *       /SIGNAL/ escapeSignal
#endif
C
C=======================================================================
C
      CALL CPUTIM('HFBSIM',1)
C
C=======================================================================
C
      IALLOC=0
      C_ZERO=CMPLX(0.0D0,0.0D0)
C
C=======================================================================
      IF (.NOT.ALLOCATED(AWAQUA)) THEN
          ALLOCATE (AWAQUA(1:NDBASE,1:NDSTAT,0:NDREVE),STAT=IALLOC)
          IF (IALLOC.NE.0) CALL NOALLO('AWAQUA','HFBSIM')
      END IF
      IF (.NOT.ALLOCATED(BWAQUA)) THEN
          ALLOCATE (BWAQUA(1:NDBASE,1:NDSTAT,0:NDREVE),STAT=IALLOC)
          IF (IALLOC.NE.0) CALL NOALLO('BWAQUA','HFBSIM')
      END IF
C=======================================================================
C
      IF (IF_RPA.EQ.1.OR.IFTEMP.EQ.1) THEN
C
          IF (.NOT.ALLOCATED(ASVQUA)) THEN
              ALLOCATE (ASVQUA(1:NDBASE,1:NDSTAT,0:NDREVE,0:NDISOS),
     *                  STAT=IALLOC)
              IF (IALLOC.NE.0) CALL NOALLO('ASVQUA','HFBSIM')
              ASVQUA(:,:,:,:) = CMPLX(0.0D0,0.0D0)
          END IF
          IF (.NOT.ALLOCATED(BSVQUA)) THEN
              ALLOCATE (BSVQUA(1:NDBASE,1:NDSTAT,0:NDREVE,0:NDISOS),
     *                  STAT=IALLOC)
              IF (IALLOC.NE.0) CALL NOALLO('BSVQUA','HFBSIM')
              BSVQUA(:,:,:,:) = CMPLX(0.0D0,0.0D0)
          END IF
C
      END IF
C
C=======================================================================
      ALLOCATE (CELMTS(1:(2*NDBASE+1)*NDBASE),STAT=IALLOC)
      IF (IALLOC.NE.0) CALL NOALLO('CELMTS','HFBSIM')
      CELMTS(:)=C_ZERO
      ALLOCATE (EWAHFB(1:2*NDBASE,1:2*NDBASE),STAT=IALLOC)
      IF (IALLOC.NE.0) CALL NOALLO('EWAHFB','HFBSIM')
      EWAHFB(:,:)=C_ZERO
C=======================================================================
C
C=======================================================================
C         THIS SUBROUTINE PREPARES THE DIAGONALIZATION OF THE HFB MATRIX
C         FOR THE SIMPLEX CASE
C=======================================================================
C
      I_STAT(0)=0
      I_STAT(1)=0
C
C=======================================================================
C         CONSTRUCTING THE HFB MATRIX
C=======================================================================
C
      DO IBRA=1,2*LDBASE
         DO IKET=1,2*LDBASE
C
            IF (IBRA.GE.IKET) THEN
C
                NCOUNT=IBRA+((4*LDBASE-IKET)*(IKET-1))/2
C
                IF (IBRA.LE.LDBASE.AND.IKET.LE.LDBASE)
     *
     *              CELMTS(NCOUNT)=BIG_PP(IBRA,IKET,0)
C
                IF (IBRA.GT.LDBASE.AND.IKET.LE.LDBASE)
     *
     *              CELMTS(NCOUNT)=
     *                      -CONJG(HAMIDE(IBRA-LDBASE,IKET,0))
C
                IF (IBRA.GT.LDBASE.AND.IKET.GT.LDBASE)
     *
     *              CELMTS(NCOUNT)=
     *                      -CONJG(BIG_PP(IBRA-LDBASE,IKET-LDBASE,1))
C
            END IF
C
         END DO
      END DO
C
C=======================================================================
C         SUBTRACTING THE FERMI ENERGY TERM FROM THE MEAN FIELD
C=======================================================================
C
      DO IBRA=1,2*LDBASE
C
         IKET=IBRA
C
         NCOUNT=IBRA+((4*LDBASE-IKET)*(IKET-1))/2
C
         IF (IBRA.LE.LDBASE)
     *
     *       CELMTS(NCOUNT)=CELMTS(NCOUNT)-EFERMI
C
         IF (IBRA.GT.LDBASE)
     *
     *       CELMTS(NCOUNT)=CELMTS(NCOUNT)+EFERMI
C
      END DO
C
C=======================================================================
C
      IF (LIMQUA.EQ.1) THEN
C
          LDQUAP=0
C
          EIGMIN=EFERMI-ECUTOF
          EIGMAX=ECUTOF-EFERMI
C
      ELSE
C
          LDQUAP=2*LDBASE
C
      ENDIF
C
C=======================================================================
C          CALLING THE DIAGONALIZATION ROUTINE
C=======================================================================
C
      CALL DIAMAT(CELMTS,EQUHFB,EWAHFB,2*LDBASE,2*NDBASE,LDQUAP)
C
C=======================================================================
C          BELOW WE DEAL WITH A POSSIBLE SITUATION OF AN ODD  NUMBER  OF
C          THE QUASIPARTICLE STATES  FOUND  IN  A  GIVEN  ENERGY  WINDOW
C          (FOR LIMQUA=1). THEN WE DISREGARD  THE  STATE  THAT  HAS  THE
C          LARGEST ABSOLUTE VALUE OF THE QUASIPARTICLE ENERGY.
C=======================================================================
C
      IF (MOD(LDQUAP,2).EQ.0) THEN
C
          LDHALF=LDQUAP/2
          LDOFFS=0
C
      ELSE
C
          LDHALF=(LDQUAP-1)/2
C
          IF (ABS(EQUHFB(1)).LT.ABS(EQUHFB(LDQUAP))) THEN
C
              LDOFFS=0
          ELSE
              LDOFFS=1
C
          END IF
C
      END IF
C
C=======================================================================
C         DETERMINING THE ORDERED QUASIPARTICLE SPECTRUM
C=======================================================================
C
      IORDER=0
C
      DO IREVER=0,NDREVE
C
         DO ISTATE=1,LDHALF
C
            IORDER=IORDER+1
            NORDER(IORDER)=IORDER
            EORDER(IORDER)=(2*IREVER-1)
     *                    *EQUHFB(ISTATE+LDOFFS+IREVER*LDHALF)
            NSTATE(IORDER)=ISTATE+LDOFFS
            NREVER(IORDER)=IREVER
C
         END DO
C
      END DO
C
      LDORDE=IORDER
C
      CALL ORDER1(EORDER,NORDER,LDORDE)
C
C=======================================================================
C         LOOP OVER ORDERED QUASIPARTICLE STATES
C=======================================================================
C
      INCORR=0
C
      IDSTAT(0)=0
      IDSTAT(1)=0
C
      DO IALLST=1,LDORDE
C
         ISTATE=NSTATE(NORDER(IALLST))
         IREVER=NREVER(NORDER(IALLST))
C
C=======================================================================
C        CALCULATING THE NORMS AND PARITIES OF THE "FIRST" COMPONENTS
C=======================================================================
C
         VORDER=0.0D0
         PORDER=0.0D0
C
         DO IBASE=1,LDBASE
C
            VORDER=VORDER+ABS(EWAHFB( IBASE+IREVER*LDBASE,
     *                               ISTATE+IREVER*LDHALF))**2
            PORDER=PORDER+ABS(EWAHFB( IBASE+IREVER*LDBASE,
     *                               ISTATE+IREVER*LDHALF))**2
     *                              *(1-2*IBAPAR(IBASE))
C
         END DO
C
C=======================================================================
C        CHECKING VALUES OF VORDER - JUST IN CASE. VALUES WHICH ARE OUT
C        OF BOUNDS UP TO A SMALL MACHINE-PRECISION NUMBER "EMACHI"  ARE
C        REPLACED BY THE VALUES AT BOUNDS.
C=======================================================================
C
         EMACHI=1.0D-10
C
         IF (VORDER.GT.1.0D0+EMACHI.OR.VORDER.LT. -EMACHI) THEN
C
             WRITE(NFIPRI,'(/,1X,20(1H/),
     *             '' ERROR IN NORMALIZATION OF'',      9X,20(1H/),/,
     *             1X,20(1H/),
     *             '' QUASIPARTICLES IN HFBSIM.'',      9X,20(1H/),/,
     *             1X,20(1H/),
     *             '' IF THIS IS A ROUND-OFF PROBLEM'', 4X,20(1H/),/,
     *             1X,20(1H/),
     *             '' YOU MAY CHANGE VALUE OF EMACHI.'',3X,20(1H/),/,
     *             1X,20(1H/),'' ISTATE='',I5,'' IREVER='',I2,
     *                                           12X,20(1H/),/,
     *             1X,20(1H/),'' VORDER='',D25.18,
     *                                            2X,20(1H/),/)')
     *
     *             ISTATE,IREVER,VORDER
#if(USE_MPI==1)
C
             CALL CPUTIM('HFBSIM',0)
C
             CALL mpi_comm_rank(MPI_COMM_WORLD, mpi_rank, mpi_err)
             Write(6,'("Error (1) in HFBSIM - proc ",i10)') mpi_rank
C
             escapeSignal = 1
             RETURN
C
#else
             STOP 'ERROR IN NORMALIZATION OF QUASIPARTICLES IN HFBSIM'
#endif
C
         END IF
C
         IF (VORDER.GT.1.0D0) VORDER=1.0D0
         IF (VORDER.LT.0.0D0) VORDER=0.0D0
C
C=======================================================================
C
         I_STAT(IREVER)=I_STAT(IREVER)+1
         E_QUAP(I_STAT(IREVER),IREVER)=EORDER(IALLST)
C
C=======================================================================
C        CALCULATING THE EQUIVALENT SPECTRUM AND CUTTING-OFF THE STATES
C        WITH HIGH EQUIVALENT ENERGIES
C=======================================================================
C
         HORDER=EORDER(IALLST)*(1.0D0-2.0D0*VORDER)
C
c         IF (HORDER+EFERMI.GT.ECUTOF) GO TO 1
C
         IF (100.0D0*(HORDER+EFERMI-ECUTOF).LT.LOG(HUGE(1.0D0))) THEN
             E_TEST=1.0D0/(1.0+EXP(100.0D0*(HORDER+EFERMI-ECUTOF)))
         ELSE
             E_TEST=0.0D0
         END IF
C
         IF (HORDER+EFERMI.GT.ECUTOF.AND.E_TEST.LT.1.0D-6) GO TO 1
C
         IDSTAT(IREVER)=IDSTAT(IREVER)+1
C
         EQPISO(IDSTAT(IREVER),IREVER,ICHARG)=EORDER(IALLST)
C
         IF (IDSTAT(IREVER).GT.NDSTAT) THEN
C
             INCORR=1
             GO TO 1
C
         END IF
C
C=======================================================================
C        EEQUIV CONTAINS THE EQUIVALENT  SINGLE-PARTICLE  ENERGY
C        DEQUIV CONTAINS THE EQUIVALENT  SINGLE-PARTICLE  PAIRING  GAP.
C=======================================================================
C        THE ABSOLUTE VALUE BELOW IS ADDED ONLY AS A  SECURITY  MEASURE
C        AGAINST VERY SMALL NEGATIVE NUMBERS UNDER THE SQUARE ROOT.  IN
C        PRINCIPLE, THESE NUMBERS HAVE TO BE POSITIVE PROVIDED   VALUES
C        OF VORDER ARE FROM ZERO TO ONE, AS THAY SHOULD BE, SEE ABOVE.
C=======================================================================
C        ATTENTION:   THE QUASIPARTICLE ENERGIES BELOW CAN BE NEGATIVE.
C                     THIS BRINGS THE CORRESPONDING  EQUIVALENT  ENERGY
C                     TO THE OTHER SIDE OF THE FERMI ENERGY. A REACTION
C                     OF THE EQUIVALENT-SPECTRUM METHOD TO  A  PRESENCE
C                     OF SUCH A STATE IS UNKNOWN AS YET.
C=======================================================================
C
         DEQUIV(IDSTAT(IREVER),IREVER)=
     *                            SQRT(ABS(EORDER(IALLST)**2-HORDER**2))
         DELEQU(IDSTAT(IREVER),IREVER,ICHARG)=
     *                            SQRT(ABS(EORDER(IALLST)**2-HORDER**2))
C
         EEQUIV(IDSTAT(IREVER),IREVER)=HORDER+EFERMI
         ESPEQU(IDSTAT(IREVER),IREVER,ICHARG)=HORDER+EFERMI
C
C=======================================================================
C        DEFINING THE QUASIPARTICLE ENERGIES AND OCCUPATIONS
C=======================================================================
C
         ENQUAP(IDSTAT(IREVER),IREVER)=EORDER(IALLST)
C
         V2QUAP(IDSTAT(IREVER),IREVER)=VORDER
         VQPISO(IDSTAT(IREVER),IREVER,ICHARG)=VORDER
C
         IF (VORDER.GT.0) THEN
C
             QPPARI(IDSTAT(IREVER),IREVER)=PORDER/VORDER
         ELSE
             QPPARI(IDSTAT(IREVER),IREVER)=1.0D+10
C
         END IF
C
C=======================================================================
C        CONSTRUCTING THE HFB A* AND B* MATRICES. THE THIRD  INDICES  OF
C        THESE MATRICES CORRESPOND TO "IREVER" (TO THE TIME-REVERSAL  OF
C        THE BASIS STATE). THEREFORE:
C        FOR IREVER=0 ONE STORES MATRICES A+* AND B+*, AND
C        FOR IREVER=1 ONE STORES MATRICES A-* AND B-*, SEE NOTES 7-41.
C
C        ON THE OTHER HAND, THE SECOND  INDICES  OF  MATRICES  A* AND B*
C        CORRESPOND TO THE QUASIPARTICLE STATES, AND HERE THE USE OF THE
C        NAME "IREVER" IS IN PRINCIPLE MISLEADING: THESE INDICES  DENOTE
C        SIMPLY THE FIRST OR THE SECOND SET OF THE QUASIPARTICLE STATES.
C=======================================================================
C
         IF (IREVER.EQ.0) THEN
C
             DO IBASE=1,LDBASE
C
                BWAQUA(IBASE,IDSTAT(0),0)=
     *                               EWAHFB(IBASE       ,ISTATE       )
                AWAQUA(IBASE,IDSTAT(0),1)=
     *                               EWAHFB(IBASE+LDBASE,ISTATE       )
C
             END DO
C
	     IALLXX(IDSTAT(0),0)=IALLST
C
         ELSE
C
             DO IBASE=1,LDBASE
C
                BWAQUA(IBASE,IDSTAT(1),1)=
     *                         CONJG(EWAHFB(IBASE+LDBASE,ISTATE+LDHALF))
                AWAQUA(IBASE,IDSTAT(1),0)=
     *                         CONJG(EWAHFB(IBASE       ,ISTATE+LDHALF))
C
             END DO
C
             IALLXX(IDSTAT(1),1)=IALLST
C
         END IF
C
C=======================================================================
C        SAVING THE MATRICES OF THE BOGOLIUBOV TRANSFORMATION FOR
C        NEUTRONS AND PROTONS FOR USE IN THE ROUTINE QMULCM  THAT
C        IS PLACED AFTER THE NEUTRON / PROTON LOOP AND RE-ADJUSTS
C        THE CONSTRAINTS BASED ON THE RPA MATRIX
C=======================================================================
C
         IF (IF_RPA.EQ.1.OR.IFTEMP.EQ.1) THEN
C
             IF (IREVER.EQ.0) THEN
C
                 DO IBASE=1,LDBASE
C
                    BSVQUA(IBASE,IDSTAT(0),0,ICHARG)=
     *                                   EWAHFB(IBASE       ,ISTATE)
                    ASVQUA(IBASE,IDSTAT(0),1,ICHARG)=
     *                                   EWAHFB(IBASE+LDBASE,ISTATE)
C
                 END DO
C
             ELSE
C
                 DO IBASE=1,LDBASE
C
                    BSVQUA(IBASE,IDSTAT(1),1,ICHARG)=
     *                    CONJG(EWAHFB(IBASE+LDBASE,ISTATE+LDHALF))
                    ASVQUA(IBASE,IDSTAT(1),0,ICHARG)=
     *                    CONJG(EWAHFB(IBASE       ,ISTATE+LDHALF))
C
                 END DO
C
             END IF
C
         END IF
C
C=======================================================================
C
    1    CONTINUE
C
      END DO
C
C@@@ TEMP - TEMP - TEMP - TEMP - TEMP - TEMP - TEMP - TEMP - TEMP
C=====================================================================
C          CALCULATION OF ENTROPY AT FINITE TEMPERATURE TEMP_T
C=====================================================================
C
      ENTRPY(ICHARG)=0.0D0
      EPSILO=1.0D-13
C
      IF (IFTEMP.EQ.1) THEN
C
          DO ISTATE=1,LDHALF
C
             FERDIR=0.5D0*(1.0D0-TANH(E_QUAP(ISTATE,0)/TEMP_T/2.0D0))
             FER_FN(ISTATE)=FERDIR
             FERMFN(ISTATE,ICHARG)=FERDIR
C
             IF (ABS(FERDIR).GT.EPSILO.AND.(1.0D0-FERDIR).GT.EPSILO)
     *       THEN
                 ENTRPY(ICHARG)=ENTRPY(ICHARG)-FERDIR*LOG(FERDIR)-
     *                           (1.0D0-FERDIR)*LOG(1.0D0-FERDIR)
             END IF
C
          END DO
C
C=======================================================================
C          BUG IN VERSION 2.49T: BECAUSE OF SIMPLEX SYMMETRY, Q.P. ARE
C          DEGENERATE AND FOR T>0 HAVE THE SAME FERMI-DIRAC OCCUPATION.
C          THE LOOP  ABOVE USES  THIS PROPERTY  AND ONLY FILLS OUT THE
C          OCCUPATION VECTOR  FER_FN() FROM 1 TO LDHALF. HOWEVER, THIS
C          MEANS THAT ONLY *HALF* OF THE  ENTROPY IS ACTUALLY COMPUTED,
C          HENCE THE CORRECTION BELOW.
C=======================================================================
C
          ENTRPY(ICHARG)=2.0D0*ENTRPY(ICHARG)
C
      END IF
C
C@@@ TEMP - TEMP - TEMP - TEMP - TEMP - TEMP - TEMP - TEMP - TEMP
C=======================================================================
C         DEFINING NUMBERS OF QUASIPARTICLES KEPT AFTER THE CUT-OFF
C=======================================================================
C
      DO IREVER=0,NDREVE
C
         NUMBQP(IREVER,ICHARG)=IDSTAT(IREVER)
C
      END DO
C
C=======================================================================
C         DETERMINING THE HFB MEAN-FIELD EIGENSTATES AND SPECTRUM
C=======================================================================
C
      IF (ABS(IDSIMB).EQ.1.OR.IMFHFB.EQ.1) THEN
C
          CALL DIASIM(1,ICHARG)
C
      END IF
C
C=======================================================================
C         HERE QUASIPARTICLE STATES ARE BLOCKED
C=======================================================================
C
      IREQPB=0
      INUQPB=0
      JNUQPB=0
C
      IF (ABS(IDSIMB).EQ.1) THEN
C
          CALL BLOSIM(ICHARG,INSIMB,IRSIMB,IDSIMB,INUQPB,IREQPB,
     *                                            IFIBLB,ISABLB)
C
          ISTATE=NSTATE(NORDER(IALLXX(INUQPB,IREQPB)))
C
          IF (IREQPB.EQ.0) THEN
C
              IDSTAT(1)=IDSTAT(1)+1
C
              IF (IDSTAT(1).GT.NDSTAT) THEN
C
                  INCORR=1
                  GO TO 2
C
              END IF
C
C=======================================================================
C         HERE THE BLOCKED QUASIPARTICLE STATE IS  ZEROED  AND  INVERTED
C         QUASIPARTICLE STATE IS ADDED TO THE OPPOSITE SIMPLEX
C=======================================================================
C
              DO IBASE=1,LDBASE
C
                 BWAQUA(IBASE,INUQPB   ,0)=C_ZERO
                 AWAQUA(IBASE,INUQPB   ,1)=C_ZERO
C
                 BWAQUA(IBASE,IDSTAT(1),1)=
     *                                CONJG(EWAHFB(IBASE+LDBASE,ISTATE))
                 AWAQUA(IBASE,IDSTAT(1),0)=
     *                                CONJG(EWAHFB(IBASE       ,ISTATE))
C
              END DO
C
              DEQUIV(IDSTAT(1),1)=      DEQUIV(INUQPB,0)
              EEQUIV(IDSTAT(1),1)=      EEQUIV(INUQPB,0)
              ENQUAP(IDSTAT(1),1)=      ENQUAP(INUQPB,0)
              V2QUAP(IDSTAT(1),1)=1.0D0-V2QUAP(INUQPB,0)
              QPPARI(IDSTAT(1),1)=      QPPARI(INUQPB,0)
C
	      JNUQPB=IDSTAT(1)
C
          ELSE
C
              IDSTAT(0)=IDSTAT(0)+1
C
              IF (IDSTAT(0).GT.NDSTAT) THEN
C
                  INCORR=1
                  GO TO 2
C
              END IF
C
              DO IBASE=1,LDBASE
C
                 BWAQUA(IBASE,INUQPB   ,1)=C_ZERO
                 AWAQUA(IBASE,INUQPB   ,0)=C_ZERO
C
                 BWAQUA(IBASE,IDSTAT(0),0)=
     *                                EWAHFB(IBASE       ,ISTATE+LDBASE)
                 AWAQUA(IBASE,IDSTAT(0),1)=
     *                                EWAHFB(IBASE+LDBASE,ISTATE+LDBASE)
C
              END DO
C
              DEQUIV(IDSTAT(0),0)=      DEQUIV(INUQPB,1)
              EEQUIV(IDSTAT(0),0)=      EEQUIV(INUQPB,1)
              ENQUAP(IDSTAT(0),0)=      ENQUAP(INUQPB,1)
              V2QUAP(IDSTAT(0),0)=1.0D0-V2QUAP(INUQPB,1)
              QPPARI(IDSTAT(0),0)=      QPPARI(INUQPB,1)
C
	      JNUQPB=IDSTAT(0)
C
          END IF
C
C=======================================================================
C
    2     CONTINUE
C
C=======================================================================
C
      END IF
C
C=======================================================================
C         DEFINING NUMBERS OF QUASIPARTICLES KEPT AFTER THE BLOCKING
C=======================================================================
C
      DO IREVER=0,NDREVE
C
         NUMBQP(IREVER,ICHARG)=IDSTAT(IREVER)
C
      END DO
C
C=======================================================================
C         STOP IN CASE OF AN INCORRECT PHASE SPACE
C=======================================================================
C
      IF (INCORR.EQ.1) THEN
C
          WRITE(NFIPRI,'(/,                              1X,20(1H/),
     *              '' TOO LARGE PHASE-SPACE SIZE IN HFBSIM'',
     *                                                   1X,20(1H/),/,
     *                 1X,20(1H/),
     *              '' ICHARG='',I2,3X,'' NDSTAT='',I4, 13X,20(1H/),/,
     *                 1X,20(1H/),
     *              '' IREVER='',I2,3X,'' REQUIRES NUMBQP='',I4,
     *                                                   4X,20(1H/),/,
     *                 1X,20(1H/),
     *              '' IREVER='',I2,3X,'' REQUIRES NUMBQP='',I4,
     *                                                   4X,20(1H/),/,
     *                 1X,20(1H/),
     *              '' INCREASE NDSTAT UP TO NUMBQP OR MORE'',
     *                                                   1X,20(1H/),/)')
     *
     *    ICHARG,NDSTAT,(IREVER,NUMBQP(IREVER,ICHARG),IREVER=0,NDREVE)
#if(USE_MPI==1)
C
          CALL CPUTIM('HFBSIM',0)
C
          CALL mpi_comm_rank(MPI_COMM_WORLD, mpi_rank, mpi_err)
          Write(6,'("Error (2) in HFBSIM - proc ",i10)') mpi_rank
C
          escapeSignal = 1
          RETURN
C
#else
          STOP ' TOO LARGE PHASE-SPACE SIZE IN HFBSIM'
#endif
C
      END IF
C
C=======================================================================
      DEALLOCATE (CELMTS,EWAHFB)
c      DEALLOCATE (HAMIDE)
C=======================================================================
C
      CALL CPUTIM('HFBSIM',0)
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE HFBSIQ(EFERMI,ECUTOF,LIMQUA,ICHARG,IMFHFB,
     *                                INSIQB,IPSIQB,IDSIQB,
     *                                       IFIBLB,ISABLB,
     *                                IREQPB,INUQPB,JNUQPB)
C=======================================================================
      USE PAIDEL
      USE MAT_PP
      USE MAT_PM
      USE ALLQUZ
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      COMPLEX
     *          CELMTS,PWAHFB,C_ZERO
C=======================================================================
      ALLOCATABLE PWAHFB(:,:,:)
      ALLOCATABLE CELMTS(:)
C=======================================================================
      DIMENSION
     *          IDSTAT(0:NDREVE)
      DIMENSION
     *          PQUHFB(1:2*NDBASP,0:NDPARI)
      DIMENSION
     *          LDQUAP(0:NDPARI)
      DIMENSION
     *          EORDER(1:2*NDBASE),NORDER(1:2*NDBASE),
     *          NPARIT(1:2*NDBASE),NPSTAT(1:2*NDBASE)
      DIMENSION
     *          KPSTAT(1:NDSTAT,0:NDREVE),
     *          KPARIT(1:NDSTAT,0:NDREVE)
C
      COMMON
     *       /XEQUIV/ EEQUIV(1:NDSTAT,0:NDREVE),
     *                DEQUIV(1:NDSTAT,0:NDREVE)
      COMMON
     *       /QUAPAR/ ENQUAP(1:NDSTAT,0:NDREVE),
     *                V2QUAP(1:NDSTAT,0:NDREVE)
      COMMON
     *       /PARIQU/ QPPARI(1:NDSTAT,0:NDREVE)
      COMMON
     *       /SIMPQU/ QPSIMP(1:NDSTAT,0:NDREVE)
      COMMON
     *       /QPNUMS/ NUMBQP(0:NDREVE,0:NDISOS)
      COMMON
     *       /PARIND/ INDPAR(1:NDBASE,0:NDPARI)
      COMMON
     *       /EIGLIM/ EIGMIN,EIGMAX
      COMMON
     *       /DIMENP/ LDBASP(0:NDPARI)
      COMMON
     *       /CFIPRI/ NFIPRI
C
C=======================================================================
C
      CALL CPUTIM('HFBSIQ',1)
C
C=======================================================================
C
      IALLOC=0
C
C=======================================================================
      IF (.NOT.ALLOCATED(AWAQUZ)) THEN
          ALLOCATE (AWAQUZ(1:NDBASE,1:2*NDSTAT,0:NDREVE),STAT=IALLOC)
          IF (IALLOC.NE.0) CALL NOALLO('AWAQUZ','HFBSIQ')
      END IF
C=======================================================================
      IF (.NOT.ALLOCATED(BWAQUZ)) THEN
          ALLOCATE (BWAQUZ(1:NDBASE,1:2*NDSTAT,0:NDREVE),STAT=IALLOC)
          IF (IALLOC.NE.0) CALL NOALLO('BWAQUZ','HFBSIQ')
      END IF
C=======================================================================
      ALLOCATE (CELMTS(1:(4*NDBASP+1)*2*NDBASP),STAT=IALLOC)
      IF (IALLOC.NE.0) CALL NOALLO('CELMTS','HFBSIQ')
      ALLOCATE (PWAHFB(1:4*NDBASP,1:4*NDBASP,0:NDPARI),STAT=IALLOC)
      IF (IALLOC.NE.0) CALL NOALLO('PWAHFB','HFBSIQ')
C=======================================================================
C
C=======================================================================
C         THIS SUBROUTINE PREPARES THE DIAGONALIZATION OF THE HFB MATRIX
C         FOR THE PARITY CASE
C=======================================================================
C
      C_ZERO=CMPLX(0.0D0,0.0D0)
C
C=======================================================================
C     SEE COMMENTS ABOUT NDBASP IN THE DIASIQ SUBROUTINE
C=======================================================================
C
      IF (MAX(LDBASP(0),LDBASP(1)).GT.NDBASP) THEN
C
          WRITE(NFIPRI,'(/,
     *                 1X,20(1H/),'' PARAMETER NDBASP TOO SMALL'',
     *                            '' IN HFBSIQ'',       1X,19(1H/),/,
     *                 1X,20(1H/),'' NDBASP ='',I3,
     *                            '' INCREASE TO  NDBASP ='',I3,
     *                                                  1X,19(1H/),/)')
     *
     *    NDBASP,MAX(LDBASP(0),LDBASP(1))
C
          STOP 'INCREASE NDBASP IN HFBSIQ'
C
      END IF
C
C=======================================================================
C         CONSTRUCTING THE HFB MATRIX
C=======================================================================
C
      DO IPARIT=0,NDPARI
C
         LDPARI=LDBASP(IPARIT)
C
         DO IBRAPA=1,4*LDPARI
            DO IKETPA=1,4*LDPARI
C
               IF (IBRAPA.GE.IKETPA) THEN
C
                   NCOUNT=IBRAPA+((8*LDPARI-IKETPA)*(IKETPA-1))/2
C
                   IF (IBRAPA.LE.2*LDPARI.AND.IKETPA.LE.2*LDPARI) THEN
C
                       IF (IBRAPA.LE.LDPARI.AND.IKETPA.LE.LDPARI)
     *                     CELMTS(NCOUNT)=
     *                          BIG_PP(INDPAR(IBRAPA         ,IPARIT),
     *                                 INDPAR(IKETPA         ,IPARIT),0)
                       IF (IBRAPA.GT.LDPARI.AND.IKETPA.GT.LDPARI)
     *                     CELMTS(NCOUNT)=
     *                          BIG_PP(INDPAR(IBRAPA-  LDPARI,IPARIT),
     *                                 INDPAR(IKETPA-  LDPARI,IPARIT),1)
                       IF (IBRAPA.GT.LDPARI.AND.IKETPA.LE.LDPARI)
     *                     CELMTS(NCOUNT)=
     *                          BIG_PM(INDPAR(IBRAPA-  LDPARI,IPARIT),
     *                                 INDPAR(IKETPA         ,IPARIT),1)
C
                   END IF
C
                   IF (IBRAPA.GT.2*LDPARI.AND.IKETPA.LE.2*LDPARI) THEN
C
                       IF (IBRAPA.LE.3*LDPARI.AND.IKETPA.LE.LDPARI)
     *                     CELMTS(NCOUNT)=
     *                  -CONJG(HAMIDE(INDPAR(IBRAPA-2*LDPARI,IPARIT),
     *                                INDPAR(IKETPA         ,IPARIT),1))
                       IF (IBRAPA.GT.3*LDPARI.AND.IKETPA.GT.LDPARI)
     *                     CELMTS(NCOUNT)=
     *                  -CONJG(HAMIDE(INDPAR(IBRAPA-3*LDPARI,IPARIT),
     *                                INDPAR(IKETPA-  LDPARI,IPARIT),1))
                       IF (IBRAPA.LE.3*LDPARI.AND.IKETPA.GT.LDPARI)
     *                     CELMTS(NCOUNT)=
     *                  +CONJG(HAMIDE(INDPAR(IBRAPA-2*LDPARI,IPARIT),
     *                                INDPAR(IKETPA-  LDPARI,IPARIT),0))
                       IF (IBRAPA.GT.3*LDPARI.AND.IKETPA.LE.LDPARI)
     *                     CELMTS(NCOUNT)=
     *                  -CONJG(HAMIDE(INDPAR(IBRAPA-3*LDPARI,IPARIT),
     *                                INDPAR(IKETPA         ,IPARIT),0))
C
                   END IF
C
                   IF (IBRAPA.GT.2*LDPARI.AND.IKETPA.GT.2*LDPARI) THEN
C
                       IF (IBRAPA.LE.3*LDPARI.AND.IKETPA.LE.3*LDPARI)
     *                     CELMTS(NCOUNT)=
     *                  -CONJG(BIG_PP(INDPAR(IBRAPA-2*LDPARI,IPARIT),
     *                                INDPAR(IKETPA-2*LDPARI,IPARIT),0))
                       IF (IBRAPA.GT.3*LDPARI.AND.IKETPA.GT.3*LDPARI)
     *                     CELMTS(NCOUNT)=
     *                  -CONJG(BIG_PP(INDPAR(IBRAPA-3*LDPARI,IPARIT),
     *                                INDPAR(IKETPA-3*LDPARI,IPARIT),1))
                       IF (IBRAPA.GT.3*LDPARI.AND.IKETPA.LE.3*LDPARI)
     *                     CELMTS(NCOUNT)=
     *                  -CONJG(BIG_PM(INDPAR(IBRAPA-3*LDPARI,IPARIT),
     *                                INDPAR(IKETPA-2*LDPARI,IPARIT),1))
C
                   END IF
C
               END IF
C
            END DO
         END DO
C
C=======================================================================
C         SUBTRACTING THE FERMI ENERGY TERM FROM THE MEAN FIELD
C=======================================================================
C
         DO IBRAPA=1,4*LDPARI
C
            IKETPA=IBRAPA
C
            NCOUNT=IBRAPA+((8*LDPARI-IKETPA)*(IKETPA-1))/2
C
            IF (IBRAPA.LE.2*LDPARI)
     *
     *          CELMTS(NCOUNT)=CELMTS(NCOUNT)-EFERMI
C
            IF (IBRAPA.GT.2*LDPARI)
     *
     *          CELMTS(NCOUNT)=CELMTS(NCOUNT)+EFERMI
C
         END DO
C
C=======================================================================
C          CALLING THE DIAGONALIZATION ROUTINE. ONLY THE SPECTRUM  BELOW
C          THE ENERGY CUTOF WILL BE USED.
C=======================================================================
C
         IF (LIMQUA.EQ.1) THEN
C
             LDQUAP(IPARIT)=0
C
             EIGMIN=EFERMI-ECUTOF
             EIGMAX=0.0D0
C
             CALL DIAMAT(CELMTS,PQUHFB(1,IPARIT),PWAHFB(1,1,IPARIT),
     *                                 4*LDPARI,4*NDBASP,LDQUAP(IPARIT))
C
         ELSE
C
C=======================================================================
C          CALLING THE DIAGONALIZATION ROUTINE. ONLY THE LOWER  HALF  OF
C          THE SPECTRUM (NEGATIVE QUASIPARTICLE ENERGIES) WILL BE  USED.
C          THEREFORE, BELOW  WE  REQUEST ONLY HALF OF EIGENVECTORS.
C=======================================================================
C
             LDQUAP(IPARIT)=2*LDPARI
C
             CALL DIAMAT(CELMTS,PQUHFB(1,IPARIT),PWAHFB(1,1,IPARIT),
     *                                 4*LDPARI,4*NDBASP,LDQUAP(IPARIT))
C
         END IF
C
      END DO
C
C=======================================================================
C         DETERMINING THE ORDERED QUASIPARTICLE SPECTRUM
C=======================================================================
C
      IORDER=0
C
      DO IPARIT=0,NDPARI
C
         DO IPSTAT=1,LDQUAP(IPARIT)
C
            IORDER=IORDER+1
            IF (IORDER.GT.2*NDBASE) STOP ' TOO LARGE IORDER IN HFBSIQ'
            NORDER(IORDER)=IORDER
            NPARIT(IORDER)=IPARIT
            EORDER(IORDER)=-PQUHFB(IPSTAT,IPARIT)
            NPSTAT(IORDER)=IPSTAT
C
         END DO
C
      END DO
C
      LDORDE=IORDER
C
      CALL ORDER1(EORDER,NORDER,LDORDE)
C
C=======================================================================
C         LOOP OVER ORDERED QUASIPARTICLE STATES
C=======================================================================
C
      INCORR=0
C
      IDSTAT(0)=0
      IDSTAT(1)=0
C
      DO IALLST=1,LDORDE
C
         IPSTAT=NPSTAT(NORDER(IALLST))
         IPARIT=NPARIT(NORDER(IALLST))
C
         LDPARI=LDBASP(IPARIT)
C
C=======================================================================
C        CALCULATING THE NORMS OF THE "FIRST" COMPONENTS
C=======================================================================
C
         VORDE0=0.0D0
         VORDE1=0.0D0
C
         DO IBASE=1,LDPARI
C
            VORDE0=VORDE0+ ABS(PWAHFB(IBASE       ,IPSTAT,IPARIT))**2
            VORDE1=VORDE1+ ABS(PWAHFB(IBASE+LDPARI,IPSTAT,IPARIT))**2
C
         END DO
C
         VORDER=VORDE0+VORDE1
C
C=======================================================================
C        CHECKING VALUES OF VORDER - JUST IN CASE. VALUES WHICH ARE OUT
C        OF BOUNDS UP TO A SMALL MACHINE-PRECISION NUMBER "EMACHI"  ARE
C        REPLACED BY THE VALUES AT BOUNDS.
C=======================================================================
C
         EMACHI=1.0D-10
C
         IF (VORDER.GT.1+EMACHI.OR.VORDER.LT. -EMACHI) THEN
C
             WRITE(NFIPRI,'(/,1X,20(1H/),
     *             '' ERROR IN NORMALIZATION OF'',      9X,20(1H/),/,
     *             1X,20(1H/),
     *             '' QUASIPARTICLES IN HFBSIQ.'',      9X,20(1H/),/,
     *             1X,20(1H/),
     *             '' IF THIS IS A ROUND-OFF PROBLEM'', 4X,20(1H/),/,
     *             1X,20(1H/),
     *             '' YOU MAY CHANGE VALUE OF EMACHI.'',3X,20(1H/),/,
     *             1X,20(1H/),'' IPSTAT='',I5,'' IPARIT='',I2,
     *                                           12X,20(1H/),/,
     *             1X,20(1H/),'' VORDER='',D25.18,
     *                                            2X,20(1H/),/)')
     *
     *             IPSTAT,IPARIT,VORDER
C
             STOP 'ERROR IN NORMALIZATION OF QUASIPARTICLES IN HFBSIQ'
C
         END IF
C
         IF (VORDER.GT.1) VORDER=1
         IF (VORDER.LT.0) VORDER=0
C
C=======================================================================
C        CALCULATING THE EQUIVALENT SPECTRUM AND CUTTING-OFF THE STATES
C        WITH HIGH EQUIVALENT ENERGIES
C=======================================================================
C
         HORDER=EORDER(IALLST)*(1-2*VORDER)
C
         IF (HORDER+EFERMI.GT.ECUTOF) GO TO 1
C
C=======================================================================
C        HERE WE DIVIDE THE SET OF QUASIPARICLE STATES INTO TWO  GROUPS
C        BY CHECKING IF THEY HAVE  DOMINANT  SIMPLEX=+i  OR  SIMPLEX=-i
C        COMPONENTS. THE DIVISION IS ARTIFICIAL; AND IT ONLY SERVES THE
C        PURPOSE OF CONSTRUCTING MATRICES ANALOGUOUS TO THOSE  USED  IN
C        THE CONSERVED-SIMPLEX CASE.
C=======================================================================
C
         IF (VORDE0.GT.VORDE1) THEN
C
             IREVER=0
         ELSE
             IREVER=1
C
         END IF
C
C=======================================================================
C
         IDSTAT(IREVER)=IDSTAT(IREVER)+1
C
         IF (IDSTAT(IREVER).GT.NDSTAT) THEN
C
             INCORR=1
             GO TO 1
C
         END IF
C
         KPSTAT(IDSTAT(IREVER),IREVER)=IPSTAT
         KPARIT(IDSTAT(IREVER),IREVER)=IPARIT
C
C=======================================================================
C        SEE COMMENTS ABOUT ARRAYS "DEQUIV" AND "EEQUIV" IN "HFBSIM"
C=======================================================================
C
         DEQUIV(IDSTAT(IREVER),IREVER)=
     *                            SQRT(ABS(EORDER(IALLST)**2-HORDER**2))
C
         EEQUIV(IDSTAT(IREVER),IREVER)=HORDER+EFERMI
C
C=======================================================================
C        DEFINING THE QUASIPARTICLE ENERGIES AND OCCUPATIONS
C=======================================================================
C
         ENQUAP(IDSTAT(IREVER),IREVER)=EORDER(IALLST)
C
         V2QUAP(IDSTAT(IREVER),IREVER)=VORDER
C
         QPPARI(IDSTAT(IREVER),IREVER)=1-2*IPARIT
C
         IF (VORDER.GT.0) THEN
C
             QPSIMP(IDSTAT(IREVER),IREVER)=(VORDE0-VORDE1)/VORDER
         ELSE
             QPSIMP(IDSTAT(IREVER),IREVER)=1.0D+10
C
         END IF
C
    1    CONTINUE
C
      END DO
C
C=======================================================================
C         DEFINING NUMBERS OF QUASIPARTICLES KEPT AFTER THE CUT-OFF
C=======================================================================
C
      DO IREVER=0,NDREVE
C
         NUMBQP(IREVER,ICHARG)=IDSTAT(IREVER)
C
      END DO
C
C=======================================================================
C        CONSTRUCTING THE HFB A* AND B* MATRICES.
C=======================================================================
C
      DO IREVER=0,NDREVE
         DO ISTATE=1,NUMBQP(IREVER,ICHARG)
C
            IPSTAT=KPSTAT(ISTATE,IREVER)
            IPARIT=KPARIT(ISTATE,IREVER)
C
            LDPARI=LDBASP(IPARIT)
C
            JPARIT=1-IPARIT
            KDPARI=LDBASP(JPARIT)
C
            LSTATE=ISTATE+IREVER*NUMBQP(0,ICHARG)
C
            DO IPBASE=1,LDPARI
C
               BWAQUZ(INDPAR(IPBASE,IPARIT),LSTATE,0)=
     *                             PWAHFB(IPBASE         ,IPSTAT,IPARIT)
               BWAQUZ(INDPAR(IPBASE,IPARIT),LSTATE,1)=
     *                             PWAHFB(IPBASE+  LDPARI,IPSTAT,IPARIT)
C
               AWAQUZ(INDPAR(IPBASE,IPARIT),LSTATE,0)=
     *                             PWAHFB(IPBASE+2*LDPARI,IPSTAT,IPARIT)
               AWAQUZ(INDPAR(IPBASE,IPARIT),LSTATE,1)=
     *                             PWAHFB(IPBASE+3*LDPARI,IPSTAT,IPARIT)
C
            END DO
C
            DO IPBASE=1,KDPARI
C
               BWAQUZ(INDPAR(IPBASE,JPARIT),LSTATE,0)=C_ZERO
               BWAQUZ(INDPAR(IPBASE,JPARIT),LSTATE,1)=C_ZERO
C
               AWAQUZ(INDPAR(IPBASE,JPARIT),LSTATE,0)=C_ZERO
               AWAQUZ(INDPAR(IPBASE,JPARIT),LSTATE,1)=C_ZERO
C
            END DO
C
         END DO
      END DO
C
C=======================================================================
C         DETERMINING THE HFB MEAN-FIELD EIGENSTATES AND SPECTRUM
C=======================================================================
C
      IF (ABS(IDSIQB).EQ.1.OR.IMFHFB.EQ.1) THEN
C
          CALL DIASIQ(ICHARG)
C
      END IF
C
C=======================================================================
C         HERE QUASIPARTICLE STATES ARE BLOCKED
C=======================================================================
C
      IREQPB=0
      INUQPB=0
      JNUQPB=0
C
      IF (ABS(IDSIQB).EQ.1) THEN
C
          CALL BLOSIQ(ICHARG,INSIQB,IPSIQB,IDSIQB,INUQPB,IREQPB,
     *                                            IFIBLB,ISABLB)
C
          IPSTAT=KPSTAT(INUQPB,IREQPB)
          IPARIT=KPARIT(INUQPB,IREQPB)
C
          LDPARI=LDBASP(IPARIT)
C
          LSTATE=INUQPB+IREQPB*NUMBQP(0,ICHARG)
C
C=======================================================================
C         HERE THE INVERTED QUASIPARTICLE REPLACES THE STANDARD ONE
C=======================================================================
C
          DO IPBASE=1,LDPARI
C
             BWAQUZ(INDPAR(IPBASE,IPARIT),LSTATE,0)=
     *                      CONJG(PWAHFB(IPBASE+2*LDPARI,IPSTAT,IPARIT))
             BWAQUZ(INDPAR(IPBASE,IPARIT),LSTATE,1)=
     *                      CONJG(PWAHFB(IPBASE+3*LDPARI,IPSTAT,IPARIT))
C
             AWAQUZ(INDPAR(IPBASE,IPARIT),LSTATE,0)=
     *                      CONJG(PWAHFB(IPBASE         ,IPSTAT,IPARIT))
             AWAQUZ(INDPAR(IPBASE,IPARIT),LSTATE,1)=
     *                      CONJG(PWAHFB(IPBASE+  LDPARI,IPSTAT,IPARIT))
C
          END DO
C
          V2QUAP(INUQPB,IREQPB)=1.0D0-V2QUAP(INUQPB,IREQPB)
C
          JNUQPB=INUQPB
C
      END IF
C
C=======================================================================
C         STOP IN CASE OF AN INCORRECT PHASE SPACE
C=======================================================================
C
      IF (INCORR.EQ.1) THEN
C
          WRITE(NFIPRI,'(/,                              1X,20(1H/),
     *              '' TOO LARGE PHASE-SPACE SIZE IN HFBSIQ'',
     *                                                   1X,20(1H/),/,
     *                 1X,20(1H/),
     *              '' ICHARG='',I2,3X,'' NDSTAT='',I4, 13X,20(1H/),/,
     *                 1X,20(1H/),
     *              '' IREVER='',I2,3X,'' REQUIRES NUMBQP='',I4,
     *                                                   4X,20(1H/),/,
     *                 1X,20(1H/),
     *              '' IREVER='',I2,3X,'' REQUIRES NUMBQP='',I4,
     *                                                   4X,20(1H/),/,
     *                 1X,20(1H/),
     *              '' INCREASE NDSTAT UP TO NUMBQP OR MORE'',
     *                                                   1X,20(1H/),/)')
     *
     *    ICHARG,NDSTAT,(IREVER,NUMBQP(IREVER,ICHARG),IREVER=0,NDREVE)
C
          STOP ' TOO LARGE PHASE-SPACE SIZE IN HFBSIQ'
C
      END IF
C
C=======================================================================
      DEALLOCATE (CELMTS,PWAHFB)
c      DEALLOCATE (HAMIDE)
C=======================================================================
C
      CALL CPUTIM('HFBSIQ',0)
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE HFBSIZ(EFERMI,ECUTOF,LIMQUA,ITWOBA,ICHARG,IMFHFB,
     *                                              INSIZB,IDSIZB,
     *                                              IFIBLB,ISABLB,
     *                                       IREQPB,INUQPB,JNUQPB)
C=======================================================================
      USE PAIDEL
      USE MAT_PP
      USE MAT_PM
      USE ALLQUZ
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      COMPLEX
     *          CELMTS,EWAHFB
C=======================================================================
      ALLOCATABLE CELMTS(:)
      ALLOCATABLE EWAHFB(:,:)
C=======================================================================
      DIMENSION
     *          IDSTAT(0:NDREVE)
      DIMENSION
     *          EQUHFB(1:2*NDBASE)
C=======================================================================
      DIMENSION
     *          EORDER(1:2*NDBASE),NORDER(1:2*NDBASE),
     *          NSTATE(1:2*NDBASE)
      DIMENSION
     *          KSTATE(1:NDSTAT,0:NDREVE)
C
      COMMON
     *       /XEQUIV/ EEQUIV(1:NDSTAT,0:NDREVE),
     *                DEQUIV(1:NDSTAT,0:NDREVE)
      COMMON
     *       /QUAPAR/ ENQUAP(1:NDSTAT,0:NDREVE),
     *                V2QUAP(1:NDSTAT,0:NDREVE)
      COMMON
     *       /PARIQU/ QPPARI(1:NDSTAT,0:NDREVE)
      COMMON
     *       /SIMPQU/ QPSIMP(1:NDSTAT,0:NDREVE)
      COMMON
     *       /PARBAS/ IBAPAR(1:NDBASE)
      COMMON
     *       /QPNUMS/ NUMBQP(0:NDREVE,0:NDISOS)
      COMMON
     *       /EIGLIM/ EIGMIN,EIGMAX
      COMMON
     *       /DIMENS/ LDBASE
      COMMON
     *       /CFIPRI/ NFIPRI
C
      INTERFACE
         SUBROUTINE TWOSIZ(CELMTS,EQUHFB,EWAHFB,LDMEFI,
     *                            ECUTOF,EFERMI,ICHARG)
            USE hfodd_sizes
            COMPLEX, DIMENSION(:), INTENT(INOUT) :: CELMTS
            COMPLEX, DIMENSION(:,:), INTENT(INOUT) :: EWAHFB
            DOUBLE PRECISION, DIMENSION(1:2*NDBASE) :: EQUHFB
            INTEGER :: LDMEFI,ICHARG
            DOUBLE PRECISION :: ECUTOF,EFERMI
         END SUBROUTINE TWOSIZ
      END INTERFACE
C
C=======================================================================
C
      CALL CPUTIM('HFBSIZ',1)
C
C=======================================================================
C
      IALLOC=0
C
C=======================================================================
      IF (.NOT.ALLOCATED(AWAQUZ)) THEN
          ALLOCATE (AWAQUZ(1:NDBASE,1:2*NDSTAT,0:NDREVE),STAT=IALLOC)
          IF (IALLOC.NE.0) CALL NOALLO('AWAQUZ','HFBSIZ')
      END IF
C=======================================================================
      IF (.NOT.ALLOCATED(BWAQUZ)) THEN
          ALLOCATE (BWAQUZ(1:NDBASE,1:2*NDSTAT,0:NDREVE),STAT=IALLOC)
          IF (IALLOC.NE.0) CALL NOALLO('BWAQUZ','HFBSIZ')
      END IF
C=======================================================================
      ALLOCATE (CELMTS(1:(4*NDBASE+1)*2*NDBASE),STAT=IALLOC)
      IF (IALLOC.NE.0) CALL NOALLO('CELMTS','HFBSIZ')
      ALLOCATE (EWAHFB(1:4*NDBASE,1:4*NDBASE),STAT=IALLOC)
      IF (IALLOC.NE.0) CALL NOALLO('EWAHFB','HFBSIZ')
C=======================================================================
C
C=======================================================================
C         THIS SUBROUTINE PREPARES THE DIAGONALIZATION OF THE HFB MATRIX
C         FOR THE NO-SYMMETRY CASE
C=======================================================================
C
C=======================================================================
C         CONSTRUCTING THE HFB MATRIX
C=======================================================================
C
      DO IBRA=1,4*LDBASE
         DO IKET=1,4*LDBASE
C
            IF (IBRA.GE.IKET) THEN
C
                NCOUNT=IBRA+((8*LDBASE-IKET)*(IKET-1))/2
C
                IF (IBRA.LE.2*LDBASE.AND.IKET.LE.2*LDBASE) THEN
C
                    IF (IBRA.LE.LDBASE.AND.IKET.LE.LDBASE)
     *                  CELMTS(NCOUNT)=
     *                            BIG_PP(IBRA         ,IKET         ,0)
                    IF (IBRA.GT.LDBASE.AND.IKET.GT.LDBASE)
     *                  CELMTS(NCOUNT)=
     *                            BIG_PP(IBRA-  LDBASE,IKET-  LDBASE,1)
                    IF (IBRA.GT.LDBASE.AND.IKET.LE.LDBASE)
     *                  CELMTS(NCOUNT)=
     *                            BIG_PM(IBRA-  LDBASE,IKET         ,1)
C
                END IF
C
                IF (IBRA.GT.2*LDBASE.AND.IKET.LE.2*LDBASE) THEN
C
                    IF (IBRA.LE.3*LDBASE.AND.IKET.LE.LDBASE)
     *                  CELMTS(NCOUNT)=
     *                     -CONJG(HAMIDE(IBRA-2*LDBASE,IKET         ,1))
                    IF (IBRA.GT.3*LDBASE.AND.IKET.GT.LDBASE)
     *                  CELMTS(NCOUNT)=
     *                     -CONJG(HAMIDE(IBRA-3*LDBASE,IKET-  LDBASE,1))
                    IF (IBRA.LE.3*LDBASE.AND.IKET.GT.LDBASE)
     *                  CELMTS(NCOUNT)=
     *                     +CONJG(HAMIDE(IBRA-2*LDBASE,IKET-  LDBASE,0))
                    IF (IBRA.GT.3*LDBASE.AND.IKET.LE.LDBASE)
     *                  CELMTS(NCOUNT)=
     *                     -CONJG(HAMIDE(IBRA-3*LDBASE,IKET         ,0))
C
                END IF
C
                IF (IBRA.GT.2*LDBASE.AND.IKET.GT.2*LDBASE) THEN
C
                    IF (IBRA.LE.3*LDBASE.AND.IKET.LE.3*LDBASE)
     *                  CELMTS(NCOUNT)=
     *                     -CONJG(BIG_PP(IBRA-2*LDBASE,IKET-2*LDBASE,0))
                    IF (IBRA.GT.3*LDBASE.AND.IKET.GT.3*LDBASE)
     *                  CELMTS(NCOUNT)=
     *                     -CONJG(BIG_PP(IBRA-3*LDBASE,IKET-3*LDBASE,1))
                    IF (IBRA.GT.3*LDBASE.AND.IKET.LE.3*LDBASE)
     *                  CELMTS(NCOUNT)=
     *                     -CONJG(BIG_PM(IBRA-3*LDBASE,IKET-2*LDBASE,1))
C
                END IF
C
            END IF
C
         END DO
      END DO
C
C=======================================================================
C         SUBTRACTING THE FERMI ENERGY TERM FROM THE MEAN FIELD
C=======================================================================
C
      DO IBRA=1,4*LDBASE
C
         IKET=IBRA
C
         NCOUNT=IBRA+((8*LDBASE-IKET)*(IKET-1))/2
C
         IF (IBRA.LE.2*LDBASE)
     *
     *       CELMTS(NCOUNT)=CELMTS(NCOUNT)-EFERMI
C
         IF (IBRA.GT.2*LDBASE)
     *
     *       CELMTS(NCOUNT)=CELMTS(NCOUNT)+EFERMI
C
      END DO
C
C=======================================================================
C         DETERMINING THE HFB MEAN-FIELD EIGENSTATES AND SPECTRUM
C=======================================================================
C
      IF (ABS(IDSIZB).EQ.1.OR.IMFHFB.EQ.1.OR.ITWOBA.EQ.1) THEN
C
          IF (ITWOBA.EQ.1) THEN
C
              LIMPAR=1
          ELSE
              LIMPAR=0
C
          END IF
C
          CALL DIASIZ(ICHARG,LIMPAR,ECUTOF,LDMEFI)
C
      END IF
C
      IF (ITWOBA.NE.1) THEN
C
          IF (LIMQUA.EQ.1) THEN
C
C=======================================================================
C          CALLING THE DIAGONALIZATION ROUTINE. ONLY THE SPECTRUM  BELOW
C          THE ENERGY CUTOF WILL BE USED.
C=======================================================================
C
              LDQUAP=0
C
              EIGMIN=EFERMI-ECUTOF
              EIGMAX=0.0D0
C
              CALL DIAMAT(CELMTS,EQUHFB,EWAHFB,4*LDBASE,4*NDBASE,LDQUAP)
C
          ELSE
C
C=======================================================================
C          CALLING THE DIAGONALIZATION ROUTINE. ONLY THE LOWER  HALF  OF
C          THE SPECTRUM (NEGATIVE QUASIPARTICLE ENERGIES) WILL BE  USED.
C          THEREFORE, BELOW  WE  REQUEST ONLY HALF OF EIGENVECTORS.
C=======================================================================
C
              LDQUAP=2*LDBASE
C
              CALL DIAMAT(CELMTS,EQUHFB,EWAHFB,4*LDBASE,4*NDBASE,LDQUAP)
C
          END IF
C
      ELSE
C
C=======================================================================
C          CALLING THE TWO-BASIS ROUTINE.
C=======================================================================
C
          CALL TWOSIZ(CELMTS,EQUHFB,EWAHFB,LDMEFI,
     *                       ECUTOF,EFERMI,ICHARG)
C
          LDQUAP=LDMEFI
C
      END IF
C
C=======================================================================
C         DETERMINING THE ORDERED QUASIPARTICLE SPECTRUM
C=======================================================================
C
      IORDER=0
C
      DO ISTATE=1,LDQUAP
C
         IORDER=IORDER+1
         NORDER(IORDER)=IORDER
         EORDER(IORDER)=-EQUHFB(ISTATE)
         NSTATE(IORDER)=ISTATE
C
      END DO
C
      LDORDE=IORDER
C
      CALL ORDER1(EORDER,NORDER,LDORDE)
C
C=======================================================================
C         LOOP OVER ORDERED QUASIPARTICLE STATES
C=======================================================================
C
      INCORR=0
C
      IDSTAT(0)=0
      IDSTAT(1)=0
C
      DO IALLST=1,LDORDE
C
         ISTATE=NSTATE(NORDER(IALLST))
C
C=======================================================================
C        CALCULATING THE NORMS OF THE "FIRST" COMPONENTS
C=======================================================================
C
         VORDE0=0.0D0
         VORDE1=0.0D0
         PORDER=0.0D0
C
         DO IBASE=1,LDBASE
C
            VORDE0=VORDE0+ ABS(EWAHFB(IBASE       ,ISTATE))**2
            VORDE1=VORDE1+ ABS(EWAHFB(IBASE+LDBASE,ISTATE))**2
C
            PORDER=PORDER+(ABS(EWAHFB(IBASE       ,ISTATE))**2
     *                    +ABS(EWAHFB(IBASE+LDBASE,ISTATE))**2)
     *                    *(1-2*IBAPAR(IBASE))
C
         END DO
C
         VORDER=VORDE0+VORDE1
C
C=======================================================================
C        CHECKING VALUES OF VORDER - JUST IN CASE. VALUES WHICH ARE OUT
C        OF BOUNDS UP TO A SMALL MACHINE-PRECISION NUMBER "EMACHI"  ARE
C        REPLACED BY THE VALUES AT BOUNDS.
C=======================================================================
C
         EMACHI=1.0D-10
C
         IF (VORDER.GT.1+EMACHI.OR.VORDER.LT. -EMACHI) THEN
C
             WRITE(NFIPRI,'(/,1X,20(1H/),
     *             '' ERROR IN NORMALIZATION OF'',      9X,20(1H/),/,
     *             1X,20(1H/),
     *             '' QUASIPARTICLES IN HFBSIZ.'',      9X,20(1H/),/,
     *             1X,20(1H/),
     *             '' IF THIS IS A ROUND-OFF PROBLEM'', 4X,20(1H/),/,
     *             1X,20(1H/),
     *             '' YOU MAY CHANGE VALUE OF EMACHI.'',3X,20(1H/),/,
     *             1X,20(1H/),'' ISTATE='',I5,''        '',2X,
     *                                           12X,20(1H/),/,
     *             1X,20(1H/),'' VORDER='',D25.18,
     *                                            2X,20(1H/),/)')
     *
     *             ISTATE,VORDER
C
             STOP 'ERROR IN NORMALIZATION OF QUASIPARTICLES IN HFBSIZ'
C
         END IF
C
         IF (VORDER.GT.1) VORDER=1
         IF (VORDER.LT.0) VORDER=0
C
C=======================================================================
C        CALCULATING THE EQUIVALENT SPECTRUM AND CUTTING-OFF THE STATES
C        WITH HIGH EQUIVALENT ENERGIES. FOR THE T WO-BASIS METHOD,  ALL
C        QUASIPARTICLE STATES ARE TAKEN INTO ACCOUNT (NO CUTOFF).
C=======================================================================
C
         HORDER=EORDER(IALLST)*(1-2*VORDER)
C
         IF (HORDER+EFERMI.GT.ECUTOF.AND.ITWOBA.NE.1) GO TO 1
C
C=======================================================================
C        HERE WE DIVIDE THE SET OF QUASIPARICLE STATES INTO TWO  GROUPS
C        BY CHECKING IF THEY HAVE  DOMINANT  SIMPLEX=+i  OR  SIMPLEX=-i
C        COMPONENTS. THE DIVISION IS ARTIFICIAL; AND IT ONLY SERVES THE
C        PURPOSE OF CONSTRUCTING MATRICES ANALOGUOUS TO THOSE  USED  IN
C        THE CONSERVED-SIMPLEX CASE.
C=======================================================================
C
         IF (VORDE0.GT.VORDE1) THEN
C
             IREVER=0
         ELSE
             IREVER=1
C
         END IF
C
C=======================================================================
C
         IDSTAT(IREVER)=IDSTAT(IREVER)+1
C
         IF (IDSTAT(IREVER).GT.NDSTAT) THEN
C
             INCORR=1
             GO TO 1
C
         END IF
C
         KSTATE(IDSTAT(IREVER),IREVER)=ISTATE
C
C=======================================================================
C        SEE COMMENTS ABOUT ARRAYS "DEQUIV" AND "EEQUIV" IN "HFBSIM"
C=======================================================================
C
         DEQUIV(IDSTAT(IREVER),IREVER)=
     *                            SQRT(ABS(EORDER(IALLST)**2-HORDER**2))
C
         EEQUIV(IDSTAT(IREVER),IREVER)=HORDER+EFERMI
C
C=======================================================================
C        DEFINING THE QUASIPARTICLE ENERGIES AND OCCUPATIONS
C=======================================================================
C
         ENQUAP(IDSTAT(IREVER),IREVER)=EORDER(IALLST)
C
         V2QUAP(IDSTAT(IREVER),IREVER)=VORDER
C
         IF (VORDER.GT.0) THEN
C
             QPPARI(IDSTAT(IREVER),IREVER)=PORDER/VORDER
             QPSIMP(IDSTAT(IREVER),IREVER)=(VORDE0-VORDE1)/VORDER
         ELSE
             QPPARI(IDSTAT(IREVER),IREVER)=1.0D+10
             QPSIMP(IDSTAT(IREVER),IREVER)=1.0D+10
C
         END IF
C
    1    CONTINUE
C
      END DO
C
C=======================================================================
C         DEFINING NUMBERS OF QUASIPARTICLES KEPT AFTER THE CUT-OFF
C=======================================================================
C
      DO IREVER=0,NDREVE
C
         NUMBQP(IREVER,ICHARG)=IDSTAT(IREVER)
C
      END DO
C
C=======================================================================
C        CONSTRUCTING THE HFB A* AND B* MATRICES.
C=======================================================================
C
      DO IREVER=0,NDREVE
         DO ISTATE=1,NUMBQP(IREVER,ICHARG)
C
            JSTATE=KSTATE(ISTATE,IREVER)
C
            LSTATE=ISTATE+IREVER*NUMBQP(0,ICHARG)
C
            DO IBASE=1,LDBASE
C
               BWAQUZ(IBASE,LSTATE,0)=EWAHFB(IBASE         ,JSTATE)
               BWAQUZ(IBASE,LSTATE,1)=EWAHFB(IBASE+  LDBASE,JSTATE)
C
               AWAQUZ(IBASE,LSTATE,0)=EWAHFB(IBASE+2*LDBASE,JSTATE)
               AWAQUZ(IBASE,LSTATE,1)=EWAHFB(IBASE+3*LDBASE,JSTATE)
C
            END DO
C
         END DO
      END DO
C
C=======================================================================
C         HERE QUASIPARTICLE STATES ARE BLOCKED
C=======================================================================
C
      IREQPB=0
      INUQPB=0
      JNUQPB=0
C
      IF (ABS(IDSIZB).EQ.1) THEN
C
          CALL BLOSIZ(ICHARG,INSIZB,IDSIZB,INUQPB,IREQPB,IFIBLB,ISABLB)
C
          JSTATE=KSTATE(INUQPB,IREQPB)
C
          LSTATE=INUQPB+IREQPB*NUMBQP(0,ICHARG)
C
C=======================================================================
C         HERE THE INVERTED QUASIPARTICLE REPLACES THE STANDARD ONE
C=======================================================================
C
          DO IBASE=1,LDBASE
C
             BWAQUZ(IBASE,LSTATE,0)=CONJG(EWAHFB(IBASE+2*LDBASE,JSTATE))
             BWAQUZ(IBASE,LSTATE,1)=CONJG(EWAHFB(IBASE+3*LDBASE,JSTATE))
C
             AWAQUZ(IBASE,LSTATE,0)=CONJG(EWAHFB(IBASE         ,JSTATE))
             AWAQUZ(IBASE,LSTATE,1)=CONJG(EWAHFB(IBASE+  LDBASE,JSTATE))
C
          END DO
C
          V2QUAP(INUQPB,IREQPB)=1.0D0-V2QUAP(INUQPB,IREQPB)
C
          JNUQPB=INUQPB
C
      END IF
C
C=======================================================================
C         STOP IN CASE OF AN INCORRECT PHASE SPACE
C=======================================================================
C
      IF (INCORR.EQ.1) THEN
C
          WRITE(NFIPRI,'(/,                              1X,20(1H/),
     *              '' TOO LARGE PHASE-SPACE SIZE IN HFBSIZ'',
     *                                                   1X,20(1H/),/,
     *                 1X,20(1H/),
     *              '' ICHARG='',I2,3X,'' NDSTAT='',I4, 13X,20(1H/),/,
     *                 1X,20(1H/),
     *              '' IREVER='',I2,3X,'' REQUIRES NUMBQP='',I4,
     *                                                   4X,20(1H/),/,
     *                 1X,20(1H/),
     *              '' IREVER='',I2,3X,'' REQUIRES NUMBQP='',I4,
     *                                                   4X,20(1H/),/,
     *                 1X,20(1H/),
     *              '' INCREASE NDSTAT UP TO NUMBQP OR MORE'',
     *                                                   1X,20(1H/),/)')
     *
     *    ICHARG,NDSTAT,(IREVER,NUMBQP(IREVER,ICHARG),IREVER=0,NDREVE)
C
          STOP ' TOO LARGE PHASE-SPACE SIZE IN HFBSIZ'
C
      END IF
C
C=======================================================================
      DEALLOCATE (CELMTS,EWAHFB)
c      DEALLOCATE (HAMIDE)
C=======================================================================
C
      CALL CPUTIM('HFBSIZ',0)
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
#if(USE_SCALAPACK==1)
C
      SUBROUTINE HFBSIZ_sl(EFERMI,ECUTOF,LIMQUA,ITWOBA,ICHARG,IMFHFB,
     *                                                 INSIZB,IDSIZB,
     *                                                 IFIBLB,ISABLB,
     *                                          IREQPB,INUQPB,JNUQPB)
C=======================================================================
      USE PAIDEL
      USE MAT_PP
      USE MAT_PM
      USE ALLQUZ
      USE hfodd_SLsiz
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      COMPLEX
     *          CELMTS,EWAHFB,C_ZERO
C=======================================================================
      ALLOCATABLE EWAHFB(:,:)
C=======================================================================
      DIMENSION
     *          IDSTAT(0:NDREVE)
      DIMENSION
     *          EQUHFB(1:4*NDBASE)
C=======================================================================
      ALLOCATABLE CELMTS(:)
C=======================================================================
      DIMENSION
     *          EORDER(1:2*NDBASE),NORDER(1:2*NDBASE),
     *          NSTATE(1:2*NDBASE)
      DIMENSION
     *          KSTATE(1:NDSTAT,0:NDREVE)
C
      COMPLEX, POINTER, DIMENSION(:,:) :: CANHAM
C
      INTEGER :: ii, jj
      INTEGER :: numberMasters, numberHFODDproc, color,
     *           tribeRank, slaveRank, masterRank, worldRank,
     *           tribeSize, slaveSize, masterSize, worldSize
C
      COMMON
     *       /XEQUIV/ EEQUIV(1:NDSTAT,0:NDREVE),
     *                DEQUIV(1:NDSTAT,0:NDREVE)
      COMMON
     *       /QUAPAR/ ENQUAP(1:NDSTAT,0:NDREVE),
     *                V2QUAP(1:NDSTAT,0:NDREVE)
      COMMON
     *       /PARIQU/ QPPARI(1:NDSTAT,0:NDREVE)
      COMMON
     *       /SIMPQU/ QPSIMP(1:NDSTAT,0:NDREVE)
      COMMON
     *       /PARBAS/ IBAPAR(1:NDBASE)
      COMMON
     *       /QPNUMS/ NUMBQP(0:NDREVE,0:NDISOS)
      COMMON
     *       /EIGLIM/ EIGMIN,EIGMAX
      COMMON
     *       /DIMENS/ LDBASE
      COMMON
     *       /CFIPRI/ NFIPRI
C
      COMMON
     *       /SCALAPACK_INP/ NBLOCK,MBLOCK,NPGRID,MPGRID,KZHPEV
      COMMON
     *       /MPIPRO/ numberMasters, numberHFODDproc, color,
     *                tribeRank, slaveRank, masterRank, worldRank,
     *                tribeSize, slaveSize, masterSize, worldSize
C
      INTERFACE
         SUBROUTINE TWOSIZ(CELMTS,EQUHFB,EWAHFB,LDMEFI,
     *                            ECUTOF,EFERMI,ICHARG)
            USE hfodd_sizes
            COMPLEX, DIMENSION(:), INTENT(INOUT) :: CELMTS
            COMPLEX, DIMENSION(:,:), INTENT(INOUT) :: EWAHFB
            DOUBLE PRECISION, DIMENSION(1:2*NDBASE) :: EQUHFB
            INTEGER :: LDMEFI,ICHARG
            DOUBLE PRECISION :: ECUTOF,EFERMI
         END SUBROUTINE TWOSIZ
      END INTERFACE
C
C=======================================================================
C
      CALL SL_INIT(MPGRID,NPGRID,color,tribeRank,numberHFODDproc)
C
      NrINIT = NUMROC(4*LDBASE, MBLOCK, MYROW, 0, NPROW)
      NcINIT = NUMROC(4*LDBASE, NBLOCK, MYCOL, 0, NPCOL)
C
      CALL initSL_siz(4*LDBASE,4*LDBASE,NrINIT,NcINIT,MBLOCK,NBLOCK)
C
C=======================================================================
C
      CALL CPUTIM('HFBSIZ',1)
C
C=======================================================================
C
      IALLOC=0
C
C=======================================================================
      IF (.NOT.ALLOCATED(AWAQUZ)) THEN
          ALLOCATE (AWAQUZ(1:NDBASE,1:2*NDSTAT,0:NDREVE),STAT=IALLOC)
          IF (IALLOC.NE.0) CALL NOALLO('AWAQUZ','HFBSIZ')
      END IF
C=======================================================================
      IF (.NOT.ALLOCATED(BWAQUZ)) THEN
          ALLOCATE (BWAQUZ(1:NDBASE,1:2*NDSTAT,0:NDREVE),STAT=IALLOC)
          IF (IALLOC.NE.0) CALL NOALLO('BWAQUZ','HFBSIZ')
      END IF
C=======================================================================
      ALLOCATE (CELMTS(1:(4*NDBASE+1)*2*NDBASE),STAT=IALLOC)
      IF (IALLOC.NE.0) CALL NOALLO('CELMTS','HFBSIZ')
      ALLOCATE (EWAHFB(1:4*NDBASE,1:4*NDBASE),STAT=IALLOC)
      IF (IALLOC.NE.0) CALL NOALLO('EWAHFB','HFBSIZ')
C=======================================================================
      ALLOCATE(CANHAM(larow,lacol))
C=======================================================================
C
C=======================================================================
C         THIS SUBROUTINE PREPARES THE DIAGONALIZATION OF THE HFB MATRIX
C         FOR THE NO-SYMMETRY CASE
C=======================================================================
C
      C_ZERO=CMPLX(0.0D0,0.0D0)
      CANHAM = C_ZERO
C
      AWAQUZ(:,:,:)=C_ZERO
      BWAQUZ(:,:,:)=C_ZERO
C
      DO jj=0, lacol-1
         IKET = NB*(NPCOL*INT(jj/NB) + MYCOL) + MOD(jj,NB) + 1
         if (IKET .gt. 4*LDBASE) CYCLE
         DO ii=0, larow-1
            IBRA = MB*(NPROW*INT(ii/MB) + MYROW) + MOD(ii,MB) + 1
            if (IBRA .gt. 4*LDBASE) CYCLE
C
            IF (IBRA.GE.IKET) THEN
C
                NCOUNT=IBRA+((8*LDBASE-IKET)*(IKET-1))/2
C
                IF (IBRA.LE.2*LDBASE.AND.IKET.LE.2*LDBASE) THEN
C
                    IF (IBRA.LE.LDBASE.AND.IKET.LE.LDBASE)
     *                  CANHAM(ii+1,jj+1)=
     *                            BIG_PP(IBRA         ,IKET         ,0)
                    IF (IBRA.GT.LDBASE.AND.IKET.GT.LDBASE)
     *                  CANHAM(ii+1,jj+1)=
     *                            BIG_PP(IBRA-  LDBASE,IKET-  LDBASE,1)
                    IF (IBRA.GT.LDBASE.AND.IKET.LE.LDBASE)
     *                  CANHAM(ii+1,jj+1)=
     *                            BIG_PM(IBRA-  LDBASE,IKET         ,1)
C
                END IF
C
                IF (IBRA.GT.2*LDBASE.AND.IKET.LE.2*LDBASE) THEN
C
                    IF (IBRA.LE.3*LDBASE.AND.IKET.LE.LDBASE)
     *                  CANHAM(ii+1,jj+1)=
     *                     -CONJG(HAMIDE(IBRA-2*LDBASE,IKET         ,1))
                    IF (IBRA.GT.3*LDBASE.AND.IKET.GT.LDBASE)
     *                  CANHAM(ii+1,jj+1)=
     *                     -CONJG(HAMIDE(IBRA-3*LDBASE,IKET-  LDBASE,1))
                    IF (IBRA.LE.3*LDBASE.AND.IKET.GT.LDBASE)
     *                  CANHAM(ii+1,jj+1)=
     *                     +CONJG(HAMIDE(IBRA-2*LDBASE,IKET-  LDBASE,0))
                    IF (IBRA.GT.3*LDBASE.AND.IKET.LE.LDBASE)
     *                  CANHAM(ii+1,jj+1)=
     *                     -CONJG(HAMIDE(IBRA-3*LDBASE,IKET         ,0))
C
                END IF
C
                IF (IBRA.GT.2*LDBASE.AND.IKET.GT.2*LDBASE) THEN
C
                    IF (IBRA.LE.3*LDBASE.AND.IKET.LE.3*LDBASE)
     *                  CANHAM(ii+1,jj+1)=
     *                     -CONJG(BIG_PP(IBRA-2*LDBASE,IKET-2*LDBASE,0))
                    IF (IBRA.GT.3*LDBASE.AND.IKET.GT.3*LDBASE)
     *                  CANHAM(ii+1,jj+1)=
     *                     -CONJG(BIG_PP(IBRA-3*LDBASE,IKET-3*LDBASE,1))
                    IF (IBRA.GT.3*LDBASE.AND.IKET.LE.3*LDBASE)
     *                  CANHAM(ii+1,jj+1)=
     *                     -CONJG(BIG_PM(IBRA-3*LDBASE,IKET-2*LDBASE,1))
C
                END IF
C
                IF (IKET .eq. IBRA) THEN
                    IF (IBRA .le. 2*LDBASE)
     *                  CANHAM(ii+1,jj+1) = CANHAM(ii+1,jj+1) - EFERMI
                    IF (IBRA .gt. 2*LDBASE)
     *                  CANHAM(ii+1,jj+1) = CANHAM(ii+1,jj+1) + EFERMI
                END IF
C
            END IF
C
         END DO
      END DO
C
C=======================================================================
C         DETERMINING THE HFB MEAN-FIELD EIGENSTATES AND SPECTRUM
C=======================================================================
C
      IF (ABS(IDSIZB).EQ.1.OR.IMFHFB.EQ.1.OR.ITWOBA.EQ.1) THEN
C
          IF (ITWOBA.EQ.1) THEN
C
              LIMPAR=1
          ELSE
              LIMPAR=0
C
          END IF
C
          CALL DIASIZ(ICHARG,LIMPAR,ECUTOF,LDMEFI)
C
      END IF
C
      IF (ITWOBA.NE.1) THEN
C
          IF (LIMQUA.EQ.1) THEN
C
C=======================================================================
C          CALLING THE DIAGONALIZATION ROUTINE. ONLY THE SPECTRUM  BELOW
C          THE ENERGY CUTOF WILL BE USED.
C=======================================================================
C
              LDQUAP=0
C
              EIGMIN=EFERMI-ECUTOF
              EIGMAX=0.0D0
C
              CALL DIAMAT(CELMTS,EQUHFB,EWAHFB,4*LDBASE,4*NDBASE,LDQUAP)
C
          ELSE
C
C=======================================================================
C          CALLING THE DIAGONALIZATION ROUTINE. ONLY THE LOWER  HALF  OF
C          THE SPECTRUM (NEGATIVE QUASIPARTICLE ENERGIES) WILL BE  USED.
C          THEREFORE, BELOW  WE  REQUEST ONLY HALF OF EIGENVECTORS.
C=======================================================================
C
              LDQUAP=2*LDBASE
C
              CALL diaSL_HFB_siz(CANHAM,KZHPEV)
              CALL diaSL_collapse_HFB_siz(EWAHFB,EQUHFB,4*NDBASE)
C
          END IF
C
      ELSE
C
C=======================================================================
C          CALLING THE TWO-BASIS ROUTINE.
C=======================================================================
C
          CALL TWOSIZ(CELMTS,EQUHFB,EWAHFB,LDMEFI,
     *                       ECUTOF,EFERMI,ICHARG)
C
          LDQUAP=LDMEFI
C
      END IF
C
      DEALLOCATE(CANHAM)
C
      CALL BLACS_GRIDEXIT(ICTXT)
C
C=======================================================================
C         DETERMINING THE ORDERED QUASIPARTICLE SPECTRUM
C=======================================================================
C
      IORDER=0
C
      DO ISTATE=1,LDQUAP
C
         IORDER=IORDER+1
         NORDER(IORDER)=IORDER
         EORDER(IORDER)=-EQUHFB(ISTATE)
         NSTATE(IORDER)=ISTATE
C
      END DO
C
      LDORDE=IORDER
C
      CALL ORDER1(EORDER,NORDER,LDORDE)
C
C=======================================================================
C         LOOP OVER ORDERED QUASIPARTICLE STATES
C=======================================================================
C
      INCORR=0
C
      IDSTAT(0)=0
      IDSTAT(1)=0
C
      DO IALLST=1,LDORDE
C
         ISTATE=NSTATE(NORDER(IALLST))
C
C=======================================================================
C        CALCULATING THE NORMS OF THE "FIRST" COMPONENTS
C=======================================================================
C
         VORDE0=0.0D0
         VORDE1=0.0D0
         PORDER=0.0D0
C
         DO IBASE=1,LDBASE
C
            VORDE0=VORDE0+ ABS(EWAHFB(IBASE       ,ISTATE))**2
            VORDE1=VORDE1+ ABS(EWAHFB(IBASE+LDBASE,ISTATE))**2
C
            PORDER=PORDER+(ABS(EWAHFB(IBASE       ,ISTATE))**2
     *                    +ABS(EWAHFB(IBASE+LDBASE,ISTATE))**2)
     *                    *(1-2*IBAPAR(IBASE))
C
         END DO
C
         VORDER=VORDE0+VORDE1
C
C=======================================================================
C        CHECKING VALUES OF VORDER - JUST IN CASE. VALUES WHICH ARE OUT
C        OF BOUNDS UP TO A SMALL MACHINE-PRECISION NUMBER "EMACHI"  ARE
C        REPLACED BY THE VALUES AT BOUNDS.
C=======================================================================
C
         EMACHI=1.0D-10
C
         IF (VORDER.GT.1+EMACHI.OR.VORDER.LT. -EMACHI) THEN
C
             WRITE(NFIPRI,'(/,1X,20(1H/),
     *             '' ERROR IN NORMALIZATION OF'',      9X,20(1H/),/,
     *             1X,20(1H/),
     *             '' QUASIPARTICLES IN HFBSIZ.'',      9X,20(1H/),/,
     *             1X,20(1H/),
     *             '' IF THIS IS A ROUND-OFF PROBLEM'', 4X,20(1H/),/,
     *             1X,20(1H/),
     *             '' YOU MAY CHANGE VALUE OF EMACHI.'',3X,20(1H/),/,
     *             1X,20(1H/),'' ISTATE='',I5,''        '',2X,
     *                                           12X,20(1H/),/,
     *             1X,20(1H/),'' VORDER='',D25.18,
     *                                            2X,20(1H/),/)')
     *
     *             ISTATE,VORDER
C
             STOP 'ERROR IN NORMALIZATION OF QUASIPARTICLES IN HFBSIZ'
C
         END IF
C
         IF (VORDER.GT.1) VORDER=1
         IF (VORDER.LT.0) VORDER=0
C
C=======================================================================
C        CALCULATING THE EQUIVALENT SPECTRUM AND CUTTING-OFF THE STATES
C        WITH HIGH EQUIVALENT ENERGIES. FOR THE T WO-BASIS METHOD,  ALL
C        QUASIPARTICLE STATES ARE TAKEN INTO ACCOUNT (NO CUTOFF).
C=======================================================================
C
         HORDER=EORDER(IALLST)*(1-2*VORDER)
C
         IF (HORDER+EFERMI.GT.ECUTOF.AND.ITWOBA.NE.1) GO TO 1
C
C=======================================================================
C        HERE WE DIVIDE THE SET OF QUASIPARICLE STATES INTO TWO  GROUPS
C        BY CHECKING IF THEY HAVE  DOMINANT  SIMPLEX=+i  OR  SIMPLEX=-i
C        COMPONENTS. THE DIVISION IS ARTIFICIAL; AND IT ONLY SERVES THE
C        PURPOSE OF CONSTRUCTING MATRICES ANALOGUOUS TO THOSE  USED  IN
C        THE CONSERVED-SIMPLEX CASE.
C=======================================================================
C
         IF (VORDE0.GT.VORDE1) THEN
C
             IREVER=0
         ELSE
             IREVER=1
C
         END IF
C
C=======================================================================
C
         IDSTAT(IREVER)=IDSTAT(IREVER)+1
C
         IF (IDSTAT(IREVER).GT.NDSTAT) THEN
C
             INCORR=1
             GO TO 1
C
         END IF
C
         KSTATE(IDSTAT(IREVER),IREVER)=ISTATE
C
C=======================================================================
C        SEE COMMENTS ABOUT ARRAYS "DEQUIV" AND "EEQUIV" IN "HFBSIM"
C=======================================================================
C
         DEQUIV(IDSTAT(IREVER),IREVER)=
     *                            SQRT(ABS(EORDER(IALLST)**2-HORDER**2))
C
         EEQUIV(IDSTAT(IREVER),IREVER)=HORDER+EFERMI
C
C=======================================================================
C        DEFINING THE QUASIPARTICLE ENERGIES AND OCCUPATIONS
C=======================================================================
C
         ENQUAP(IDSTAT(IREVER),IREVER)=EORDER(IALLST)
C
         V2QUAP(IDSTAT(IREVER),IREVER)=VORDER
C
         IF (VORDER.GT.0) THEN
C
             QPPARI(IDSTAT(IREVER),IREVER)=PORDER/VORDER
             QPSIMP(IDSTAT(IREVER),IREVER)=(VORDE0-VORDE1)/VORDER
         ELSE
             QPPARI(IDSTAT(IREVER),IREVER)=1.0D+10
             QPSIMP(IDSTAT(IREVER),IREVER)=1.0D+10
C
         END IF
C
    1    CONTINUE
C
      END DO
C
C=======================================================================
C         DEFINING NUMBERS OF QUASIPARTICLES KEPT AFTER THE CUT-OFF
C=======================================================================
C
      DO IREVER=0,NDREVE
C
         NUMBQP(IREVER,ICHARG)=IDSTAT(IREVER)
C
      END DO
C
C=======================================================================
C        CONSTRUCTING THE HFB A* AND B* MATRICES.
C=======================================================================
C
      DO IREVER=0,NDREVE
         DO ISTATE=1,NUMBQP(IREVER,ICHARG)
C
            JSTATE=KSTATE(ISTATE,IREVER)
C
            LSTATE=ISTATE+IREVER*NUMBQP(0,ICHARG)
C
            DO IBASE=1,LDBASE
C
               BWAQUZ(IBASE,LSTATE,0)=EWAHFB(IBASE         ,JSTATE)
               BWAQUZ(IBASE,LSTATE,1)=EWAHFB(IBASE+  LDBASE,JSTATE)
C
               AWAQUZ(IBASE,LSTATE,0)=EWAHFB(IBASE+2*LDBASE,JSTATE)
               AWAQUZ(IBASE,LSTATE,1)=EWAHFB(IBASE+3*LDBASE,JSTATE)
C
            END DO
C
         END DO
      END DO
C
C=======================================================================
C         HERE QUASIPARTICLE STATES ARE BLOCKED
C=======================================================================
C
      IREQPB=0
      INUQPB=0
      JNUQPB=0
C
      IF (ABS(IDSIZB).EQ.1) THEN
C
          CALL BLOSIZ(ICHARG,INSIZB,IDSIZB,INUQPB,IREQPB,IFIBLB,ISABLB)
C
          JSTATE=KSTATE(INUQPB,IREQPB)
C
          LSTATE=INUQPB+IREQPB*NUMBQP(0,ICHARG)
C
C=======================================================================
C         HERE THE INVERTED QUASIPARTICLE REPLACES THE STANDARD ONE
C=======================================================================
C
          DO IBASE=1,LDBASE
C
             BWAQUZ(IBASE,LSTATE,0)=CONJG(EWAHFB(IBASE+2*LDBASE,JSTATE))
             BWAQUZ(IBASE,LSTATE,1)=CONJG(EWAHFB(IBASE+3*LDBASE,JSTATE))
C
             AWAQUZ(IBASE,LSTATE,0)=CONJG(EWAHFB(IBASE         ,JSTATE))
             AWAQUZ(IBASE,LSTATE,1)=CONJG(EWAHFB(IBASE+  LDBASE,JSTATE))
C
          END DO
C
          V2QUAP(INUQPB,IREQPB)=1.0D0-V2QUAP(INUQPB,IREQPB)
C
          JNUQPB=INUQPB
C
      END IF
C
C=======================================================================
C         STOP IN CASE OF AN INCORRECT PHASE SPACE
C=======================================================================
C
      IF (INCORR.EQ.1) THEN
C
          WRITE(NFIPRI,'(/,                              1X,20(1H/),
     *              '' TOO LARGE PHASE-SPACE SIZE IN HFBSIZ'',
     *                                                   1X,20(1H/),/,
     *                 1X,20(1H/),
     *              '' ICHARG='',I2,3X,'' NDSTAT='',I4, 13X,20(1H/),/,
     *                 1X,20(1H/),
     *              '' IREVER='',I2,3X,'' REQUIRES NUMBQP='',I4,
     *                                                   4X,20(1H/),/,
     *                 1X,20(1H/),
     *              '' IREVER='',I2,3X,'' REQUIRES NUMBQP='',I4,
     *                                                   4X,20(1H/),/,
     *                 1X,20(1H/),
     *              '' INCREASE NDSTAT UP TO NUMBQP OR MORE'',
     *                                                   1X,20(1H/),/)')
     *
     *    ICHARG,NDSTAT,(IREVER,NUMBQP(IREVER,ICHARG),IREVER=0,NDREVE)
C
          STOP ' TOO LARGE PHASE-SPACE SIZE IN HFBSIZ'
C
      END IF
C
C=======================================================================
      DEALLOCATE (CELMTS,EWAHFB)
c      DEALLOCATE (HAMIDE)
C=======================================================================
C
      CALL CPUTIM('HFBSIZ',0)
C
C=======================================================================
C
      RETURN
      END
C
#endif
C=======================================================================
C
      SUBROUTINE TWOSIZ(CELMTS,EQUHFB,EWAHFB,LDMEFI,
     *                         ECUTOF,EFERMI,ICHARG)
C=======================================================================
      USE ALLSIZ
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      COMPLEX
     *          DELMTS,DWAHFB,C_ZERO
C=======================================================================
      ALLOCATABLE DWAHFB(:,:)
      ALLOCATABLE DELMTS(:)
C=======================================================================
      DIMENSION
     *          EQUHFB(1:2*NDBASE)
      DIMENSION
     *          DQUHFB(1:2*NDBASE)
C=======================================================================
      COMPLEX, DIMENSION(:), INTENT(INOUT) :: CELMTS
      COMPLEX, DIMENSION(:,:), INTENT(INOUT) :: EWAHFB
C=======================================================================
      COMMON
     *       /SIZSPE/ SPESIZ(1:2*NDBASE)
      COMMON
     *       /SPNUMS/ NUMBSP(0:NDREVE,0:NDISOS)
      COMMON
     *       /DIMENS/ LDBASE
      COMMON
     *       /CFIPRI/ NFIPRI
C
C=======================================================================
C
      CALL CPUTIM('TWOSIZ',1)
C
C=======================================================================
C
      IALLOC=0
C
C=======================================================================
      ALLOCATE (DELMTS(1:(4*NDBASE+1)*2*NDBASE),STAT=IALLOC)
      IF (IALLOC.NE.0) CALL NOALLO('DELMTS','TWOSIZ')
      ALLOCATE (DWAHFB(1:4*NDBASE,1:4*NDBASE),STAT=IALLOC)
      IF (IALLOC.NE.0) CALL NOALLO('DWAHFB','TWOSIZ')
C=======================================================================
C
C=======================================================================
C         THIS SUBROUTINE DIAGONALIZES THE HFB MATRIX IN THE  MEAN-FIELD
C         BASIS FOR THE NO-SYMMETRY CASE
C=======================================================================
C
      C_ZERO=CMPLX(0.0D0,0.0D0)
C
C=======================================================================
C         UNPACKING THE PAIRING PART OF THE HFB MATRIX
C=======================================================================
C
      DO IKET=1,2*LDBASE
         DO IBRA=2*LDBASE+1,4*LDBASE
C
            NCOUNT=IBRA+((8*LDBASE-IKET)*(IKET-1))/2
C
            DWAHFB(IBRA,IKET)=CELMTS(NCOUNT)
            DWAHFB(IKET,IBRA)=CONJG(DWAHFB(IBRA,IKET))
C
         END DO
      END DO
C
C=======================================================================
C         CONSTRUCTING THE HFB MATRIX IN THE MEAN-FIELD BASIS
C=======================================================================
C         FIRST WE CALCULATE    DELTA * U^*
C         THE RESULTS ARE STORED IN THE LOWER ROWS OF THE HFB MATRIX
C=======================================================================
C
      DO IBRA=1,2*LDBASE
         DO ISTATE=1,LDMEFI
C
            DWAHFB(IBRA+2*LDBASE,ISTATE+LDMEFI)=C_ZERO
C
            DO IMID=1,2*LDBASE
C
               DWAHFB(IBRA+2*LDBASE,ISTATE+LDMEFI)
     *        =DWAHFB(IBRA+2*LDBASE,ISTATE+LDMEFI)
     *        +DWAHFB(IBRA,IMID+2*LDBASE)
     *        *CONJG(EWASIZ(IMID,ISTATE))
C
            END DO
C
         END DO
      END DO
C
C=======================================================================
C         NEXT WE CALCULATE  U^+ * DELTA * U^*
C         THE RESULTS ARE STORED IN THE UPPER ROWS OF THE HFB MATRIX
C=======================================================================
C
      DO JSTATE=1,LDMEFI
         DO ISTATE=1,LDMEFI
C
            DWAHFB(JSTATE,ISTATE       )=C_ZERO
            DWAHFB(JSTATE,ISTATE+LDMEFI)=C_ZERO
C
            DO IMID=1,2*LDBASE
C
               DWAHFB(JSTATE,ISTATE+LDMEFI)
     *        =DWAHFB(JSTATE,ISTATE+LDMEFI)
     *        +CONJG(EWASIZ(IMID,JSTATE))
     *        *DWAHFB(IMID+2*LDBASE,ISTATE+LDMEFI)
C
            END DO
C
         END DO
C
         DWAHFB(JSTATE,JSTATE)=SPESIZ(JSTATE)-EFERMI
C
      END DO
C
C=======================================================================
C         THEN WE CALCULATE LOWER ROWS OF THE HFB MATRIX
C=======================================================================
C
      DO JSTATE=1,LDMEFI
         DO ISTATE=1,LDMEFI
C
            DWAHFB(JSTATE+LDMEFI,ISTATE       )
     *                             =-CONJG(DWAHFB(JSTATE,ISTATE+LDMEFI))
C
            DWAHFB(JSTATE+LDMEFI,ISTATE+LDMEFI)
     *                             =-CONJG(DWAHFB(JSTATE,ISTATE       ))
C
         END DO
      END DO
C
C=======================================================================
C         PACKING THE HFB MATRIX IN THE MEAN-FIELD BASIS
C=======================================================================
C
      DO JSTATE=1,2*LDMEFI
         DO ISTATE=1,2*LDMEFI
C
            IF (JSTATE.GE.ISTATE) THEN
C
                NCOUNT=JSTATE+((4*LDMEFI-ISTATE)*(ISTATE-1))/2
C
                DELMTS(NCOUNT)=DWAHFB(JSTATE,ISTATE)
C
            END IF
C
         END DO
      END DO
C
C=======================================================================
C          CALLING THE DIAGONALIZATION ROUTINE. ONLY THE LOWER  HALF  OF
C          THE SPECTRUM (NEGATIVE QUASIPARTICLE ENERGIES) WILL BE  USED.
C          THEREFORE, BELOW  WE  REQUEST ONLY HALF OF EIGENVECTORS.
C=======================================================================
C
      CALL DIAMAT(DELMTS,DQUHFB,DWAHFB,2*LDMEFI,4*NDBASE,LDMEFI)
C
C=======================================================================
C         REBUILDING  THE  HFB  MATRICES  OF  QUASIPARTICLE  STATES  AND
C         QUASIPARTICLE ENERGIES IN THE HO BASIS
C=======================================================================
C
      DO JSTATE=1,LDMEFI
C
         DO IBRA=1,2*LDBASE
C
            EWAHFB(IBRA         ,JSTATE)=C_ZERO
            EWAHFB(IBRA+2*LDBASE,JSTATE)=C_ZERO
C
            DO ISTATE=1,LDMEFI
C
               EWAHFB(IBRA       ,JSTATE)=EWAHFB(IBRA       ,JSTATE)
     *        +      EWASIZ(IBRA,ISTATE) *DWAHFB(ISTATE       ,JSTATE)
C
               EWAHFB(IBRA+2*LDBASE,JSTATE)=EWAHFB(IBRA+2*LDBASE,JSTATE)
     *        +CONJG(EWASIZ(IBRA,ISTATE))*DWAHFB(ISTATE+LDMEFI,JSTATE)
C
            END DO
C
         END DO
C
         EQUHFB(JSTATE)=DQUHFB(JSTATE)
C
      END DO
C
C=======================================================================
      DEALLOCATE (DELMTS,DWAHFB)
C=======================================================================
C
      CALL CPUTIM('TWOSIZ',0)
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE BLOSIG(ICHARG,INSIGB,IPSIGB,ISSIGB,IDSIGB,
     *                                       IREQPB,INUQPB,
     *                                       IFIBLB,ISABLB)
C=======================================================================
      USE ALLWAV
      USE ALLQUA
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      COMPLEX
     *          OVRLAP,QOVERL,WAVACT,WAVBLO,WAVAUX,C_ZERO
C
      DIMENSION
     *          OVRLAP(1:NDSTAT),QOVERL(0:NDRHFB),QNORMA(0:NDRHFB)
      DIMENSION
     *          WAVACT(1:NDBASE,0:NDREVE)
C
C=======================================================================
      COMMON
     *       /SIGSTA/ ISTSIG(1:NDSTAT,0:NDPARI,0:NDREVE)
      COMMON
     *       /BLOWAV/ WAVBLO(1:NDBASE,0:NDISOS,0:NDREVE)
      COMMON
     *       /BLODEF/ IDEBLO(0:NDISOS)
      COMMON
     *       /SPNUMS/ NUMBSP(0:NDREVE,0:NDISOS)
      COMMON
     *       /QPNUMS/ NUMBQP(0:NDREVE,0:NDISOS)
      COMMON
     *       /DIMENS/ LDBASE
C
C=======================================================================
C
      CALL CPUTIM('BLOSIG',1)
C
C=======================================================================
C     THIS SUBROUTINE SELECTS THE QUASIPARTICLE STATE TO BE BLOCKED
C     IN THE CASE OF CONSERVED PARITY/SIGNATURE SYMMETRY
C=======================================================================
C
      C_ZERO=CMPLX(0.0D0,0.0D0)
C
C=======================================================================
C     INSIGB = THE NUMBER OF SINGLE-PARTICLE STATE THAT DEFINES  BLOCKED
C              QUASIPARTICLE STATE THROUGH THE LARGEST OVERLAP
C     IPSIGB = THE PARITY    OF THE ABOVE SINGLE-PARTICLE STATE
C     ISSIGB = THE SIGNATURE OF THE ABOVE SINGLE-PARTICLE STATE
C
C     INUQPB = THE NUMBER OF QUASIPARTICLE STATE TO BE BLOCKED
C
C     IREQPB = THE SIMPLEX OF THE ABOVE QUASIPARTICLE STATE
C     IFIBLB = USE  (1) OR NOT (0) THE SAVED SINGLE-PARTICLE  STATE
C              FOR BLOCKING
C     ISABLB = SAVE (1) OR NOT (0) THE  SINGLE-PARTICLE  STATE  FOR
C              LATER BLOCKING
C=======================================================================
C
C=======================================================================
C        DETERMINING THE SIMPLEX OF THE SINGLE-PARTICLE STATE
C=======================================================================
C
      IF (IPSIGB.EQ.0.AND.ISSIGB.EQ.0.OR.
     *    IPSIGB.EQ.1.AND.ISSIGB.EQ.1) THEN
C
          IRSIGB=0
      ELSE
          IRSIGB=1
C
      END IF
C
      JSTATE=ISTSIG(INSIGB,IPSIGB,IRSIGB)
C
C=======================================================================
C        DETERMINING THE SIMPLEX OF THE QUASIPARTICLE STATE
C=======================================================================
C
      IF (IDSIGB.EQ.1) THEN
C
          IRSIGC=IRSIGB
      ELSE
          IRSIGC=1-IRSIGB
C
      END IF
C
C=======================================================================
C         SAVING THE SINGLE-PARTICLE WAVE FUNCTION. FLAGS IDEBLO ARE
C         USED TO PASS INFORMATION TO  THE  SUBROUTINE  "RECORD"  ON
C         WHETHER THE MATRIX "WAVBLO" HAS BEEN INITIALISED.
C=======================================================================
C
      IF (ISABLB.EQ.1) THEN
C
          IDEBLO(ICHARG)=1
C
          DO IREVER=0,NDREVE
             DO IBASE=1,LDBASE
C
                WAVBLO(IBASE,ICHARG,IREVER)=
     *          WAVOCC(IBASE,JSTATE+IRSIGB*NUMBSP(0,ICHARG),IREVER)
C
             END DO
          END DO
C
      END IF
C
C=======================================================================
C         DEFINING THE SINGLE-PARTICLE WAVE FUNCTION, WHICH WILL BE USED
C         TO CALCULATE THE OVERLAP
C=======================================================================
C
      IF (IFIBLB.EQ.1) THEN
C
          DO IREVER=0,NDREVE
             DO IBASE=1,LDBASE
                WAVACT(IBASE,IREVER)=WAVBLO(IBASE,ICHARG,IREVER)
             END DO
          END DO
      ELSE
          DO IREVER=0,NDREVE
             DO IBASE=1,LDBASE
                WAVACT(IBASE,IREVER)=
     *          WAVOCC(IBASE,JSTATE+IRSIGB*NUMBSP(0,ICHARG),IREVER)
             END DO
          END DO
C
      END IF
C
C=======================================================================
C         REVERSING THE TIME FOR THE SINGLE-PARTICLE WAVE FUNCTION
C=======================================================================
C          ATTENTION: FOR IDSIGB = -1, OPERATIONS BELOW WERE NOT CORRECT
C          NO. 3      THIS BUG WAS  CORRECTED  ON  04/11/10  IN  VERSION
C                     (2.48U).
C=======================================================================
C
      IF (IDSIGB.EQ.-1) THEN
C
         DO IBASE=1,LDBASE
C
             WAVAUX         = CONJG(WAVACT(IBASE,0))
             WAVACT(IBASE,0)=-CONJG(WAVACT(IBASE,1))
             WAVACT(IBASE,1)= WAVAUX
C
         END DO
C
      END IF
C
C=======================================================================
C        CALCULATING OVERLAP OF SINGLE-PARTICLE AND QUASIPARTICLE STATES
C=======================================================================
C        SEE COMMENTS IN SUBROUTINE "BLOSIZ"
C=======================================================================
C
      DO ISTATE=1,NUMBQP(IRSIGC,ICHARG)
C
         DO IREHFB=0,NDRHFB
C
            QOVERL(IREHFB)=C_ZERO
            QNORMA(IREHFB)=0.0D0
C
            IF (IREHFB.EQ.IRSIGC) THEN
C
                DO IBASE=1,LDBASE
C
C=======================================================================
C          ATTENTION: REFERENCES TO NATRICES "BWAQUA" AND "AWAQUA" BELOW
C          NO. 1      WERE INCORECTLY MADE WITH  THE  ARGUMENT  "IRSIGC"
C                     INSTEAD OF "IREHFB". AS A CONSEQUENCE, FOR  QUASI-
C                     PARTICLE STATES OF A PARTICLE TYPE ABOVE THE FERMI
C                     LEVEL, OVERLAPS WITH SINGLE-PARTICLE  STATES  WERE
C                     CALCULATED INCORRECTLY. THIS BUG  HAS  BEEN  FOUND
C                     BY GILLIS CARLSSON AND CORRECTED  ON  20/02/08  IN
C                     VERSION (2.33D).
C=======================================================================
C
                   QOVERL(IREHFB)=QOVERL(IREHFB)
     *                           +CONJG(WAVACT(IBASE,IRSIGB))
     *                           *BWAQUA(IBASE,ISTATE,IREHFB)
C
                   QNORMA(IREHFB)=QNORMA(IREHFB)+
     *                               ABS(BWAQUA(IBASE,ISTATE,IREHFB))**2
C
                END DO
C
            ELSE
C
                DO IBASE=1,LDBASE
C
C=======================================================================
C          ATTENTION: OVERLAPS  BELOW  WERE  CALCULATED  WITH   MATRICES
C          NO. 2      CONJG(AWAQUA) INSTEAD OF AWAQUA. AS A CONSEQUENCE,
C                     FOR QUASI-PARTICLE STATES OF A PARTICLE TYPE ABOVE
C                     THE FERMI LEVEL, INCORRECT  QUASI-PARTICLE  STATES
C                     WERE SELECTED FOR BLOCKING. THE  REASON  FOR  THIS
C                     CORRECTION IS UNKNOWN YET. THIS BUG HAS BEEN FOUND
C                     BY GILLIS CARLSSON AND CORRECTED  ON  20/02/08  IN
C                     VERSION (2.33D).
C=======================================================================
C
                   QOVERL(IREHFB)=QOVERL(IREHFB)
     *                           +CONJG(WAVACT(IBASE,IRSIGB))
     *                           *AWAQUA(IBASE,ISTATE,IREHFB)
C
                   QNORMA(IREHFB)=QNORMA(IREHFB)+
     *                               ABS(AWAQUA(IBASE,ISTATE,IREHFB))**2
C
                END DO
C
            END IF
C
            IF (QNORMA(IREHFB).GT.0.0D0) THEN
C
                QOVERL(IREHFB)=QOVERL(IREHFB)/SQRT(QNORMA(IREHFB))
            ELSE
                QOVERL(IREHFB)=C_ZERO
C
            END IF
C
         END DO
C
         IF (QNORMA(0).GT.QNORMA(1)) THEN
C
             OVRLAP(ISTATE)=QOVERL(0)
         ELSE
             OVRLAP(ISTATE)=QOVERL(1)
C
         END IF
C
      END DO
C
C=======================================================================
C        SELECTING QUASIPARTICLE STATE THAT HAS THE LARGEST OVERLAP WITH
C        THE GIVEN SINGLE-PARTICLE STATE
C=======================================================================
C
      IREQPB=IRSIGC
      INUQPB=1
C
      DO ISTATE=1,NUMBQP(IRSIGC,ICHARG)
C
         IF (ABS(OVRLAP(ISTATE)).GT.
     *       ABS(OVRLAP(INUQPB))) THEN
C
             INUQPB=ISTATE
C
         END IF
C
      END DO
C
C=======================================================================
C
      CALL CPUTIM('BLOSIG',0)
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
      SUBROUTINE BLOSIM(ICHARG,INSIMB,IRSIMB,IDSIMB,INUQPB,IREQPB,
     *                                              IFIBLB,ISABLB)
C=======================================================================
      USE ALLWAV
      USE ALLQUA
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      COMPLEX
     *          OVRLAP,QOVERL,WAVACT,WAVBLO,WAVAUX,C_ZERO
C
      DIMENSION
     *          OVRLAP(1:NDSTAT),QOVERL(0:NDRHFB),QNORMA(0:NDRHFB)
      DIMENSION
     *          WAVACT(1:NDBASE,0:NDREVE)
C
C=======================================================================
      COMMON
     *       /BLOWAV/ WAVBLO(1:NDBASE,0:NDISOS,0:NDREVE)
      COMMON
     *       /BLODEF/ IDEBLO(0:NDISOS)
      COMMON
     *       /SPNUMS/ NUMBSP(0:NDREVE,0:NDISOS)
      COMMON
     *       /QPNUMS/ NUMBQP(0:NDREVE,0:NDISOS)
      COMMON
     *       /DIMENS/ LDBASE
C
C=======================================================================
C
      CALL CPUTIM('BLOSIM',1)
C
C=======================================================================
C     THIS SUBROUTINE SELECTS THE QUASIPARTICLE STATE TO BE BLOCKED
C     IN CASE OF CONSERVED SIMPLEX SYMMETRY
C=======================================================================
C=======================================================================
C     INSIMB = THE NUMBER OF SINGLE-PARTICLE STATE THAT DEFINES  BLOCKED
C              QUASIPARTICLE STATE THROUGH THE LARGEST OVERLAP
C     IRSIMB = THE SIMPLEX OF THE ABOVE SINGLE-PARTICLE STATE
C
C     INUQPB = THE NUMBER OF QUASIPARTICLE STATE TO BE BLOCKED
C
C     IREQPB = THE SIMPLEX OF THE ABOVE QUASIPARTICLE STATE
C     IFIBLB = USE  (1) OR NOT (0) THE SAVED SINGLE-PARTICLE  STATE
C              FOR BLOCKING
C     ISABLB = SAVE (1) OR NOT (0) THE  SINGLE-PARTICLE  STATE  FOR
C              LATER BLOCKING
C=======================================================================
C
C=======================================================================
C
      C_ZERO=CMPLX(0.0D0,0.0D0)
C
C=======================================================================
C        DETERMINING THE SIMPLEX OF THE QUASIPARTICLE STATE
C=======================================================================
C
      IF (IDSIMB.EQ.1) THEN
C
          IRSIMC=IRSIMB
      ELSE
          IRSIMC=1-IRSIMB
C
      END IF
C
C=======================================================================
C         SAVING THE SINGLE-PARTICLE WAVE FUNCTION. FLAGS IDEBLO ARE
C         USED TO PASS INFORMATION TO  THE  SUBROUTINE  "RECORD"  ON
C         WHETHER THE MATRIX "WAVBLO" HAS BEEN INITIALISED.
C=======================================================================
C
      IF (ISABLB.EQ.1) THEN
C
          IDEBLO(ICHARG)=1
C
          DO IREVER=0,NDREVE
             DO IBASE=1,LDBASE
C
                WAVBLO(IBASE,ICHARG,IREVER)=
     *          WAVOCC(IBASE,INSIMB+IRSIMB*NUMBSP(0,ICHARG),IREVER)
C
             END DO
          END DO
C
      END IF
C
C=======================================================================
C         DEFINING THE SINGLE-PARTICLE WAVE FUNCTION, WHICH WILL BE USED
C         TO CALCULATE THE OVERLAP
C=======================================================================
C
      IF (IFIBLB.EQ.1) THEN
C
          DO IREVER=0,NDREVE
             DO IBASE=1,LDBASE
C
                WAVACT(IBASE,IREVER)=WAVBLO(IBASE,ICHARG,IREVER)
C
             END DO
          END DO
      ELSE
          DO IREVER=0,NDREVE
             DO IBASE=1,LDBASE
C
                WAVACT(IBASE,IREVER)=
     *          WAVOCC(IBASE,INSIMB+IRSIMB*NUMBSP(0,ICHARG),IREVER)
C
             END DO
          END DO
C
      END IF
C
C=======================================================================
C         REVERSING THE TIME FOR THE SINGLE-PARTICLE WAVE FUNCTION
C=======================================================================
C          ATTENTION: FOR IDSIMB = -1, OPERATIONS BELOW WERE NOT CORRECT
C          NO. 3      THIS BUG WAS  CORRECTED  ON  04/11/10  IN  VERSION
C                     (2.48U).
C=======================================================================
C
      IF (IDSIMB.EQ.-1) THEN
C
         DO IBASE=1,LDBASE
C
             WAVAUX         = CONJG(WAVACT(IBASE,0))
             WAVACT(IBASE,0)=-CONJG(WAVACT(IBASE,1))
             WAVACT(IBASE,1)= WAVAUX
C
         END DO
C
      END IF
C
C=======================================================================
C        CALCULATING OVERLAP OF SINGLE-PARTICLE AND QUASIPARTICLE STATES
C=======================================================================
C        SEE COMMENTS IN SUBROUTINE "BLOSIZ"
C=======================================================================
C
      DO ISTATE=1,NUMBQP(IRSIMC,ICHARG)
C
         DO IREHFB=0,NDRHFB
C
            QOVERL(IREHFB)=C_ZERO
            QNORMA(IREHFB)=0.0D0
C
            IF (IREHFB.EQ.IRSIMC) THEN
C
                DO IBASE=1,LDBASE
C
C=======================================================================
C          ATTENTION: BUG CORRECTED ON 20/02/08 IN VERSION (2.33D),  SEE
C                     COMMENTS NO. 1 IN BLOSIG
C=======================================================================
C
                   QOVERL(IREHFB)=QOVERL(IREHFB)
     *                           +CONJG(WAVACT(IBASE,IRSIMB))
     *                           *BWAQUA(IBASE,ISTATE,IREHFB)
C
                   QNORMA(IREHFB)=QNORMA(IREHFB)+
     *                               ABS(BWAQUA(IBASE,ISTATE,IREHFB))**2
C
                END DO
C
            ELSE
C
                DO IBASE=1,LDBASE
C
C=======================================================================
C          ATTENTION: BUG CORRECTED ON 20/02/08 IN VERSION (2.33D),  SEE
C                     COMMENTS NO. 2 IN BLOSIG
C=======================================================================
C
                   QOVERL(IREHFB)=QOVERL(IREHFB)
     *                           +CONJG(WAVACT(IBASE,IRSIMB))
     *                           *AWAQUA(IBASE,ISTATE,IREHFB)
C
                   QNORMA(IREHFB)=QNORMA(IREHFB)+
     *                               ABS(AWAQUA(IBASE,ISTATE,IREHFB))**2
C
                END DO
C
            END IF
C
            IF (QNORMA(IREHFB).GT.0.0D0) THEN
C
                QOVERL(IREHFB)=QOVERL(IREHFB)/SQRT(QNORMA(IREHFB))
            ELSE
                QOVERL(IREHFB)=C_ZERO
C
            END IF
C
         END DO
C
         IF (QNORMA(0).GT.QNORMA(1)) THEN
C
             OVRLAP(ISTATE)=QOVERL(0)
         ELSE
             OVRLAP(ISTATE)=QOVERL(1)
C
         END IF
C
      END DO
C
C=======================================================================
C        SELECTING QUASIPARTICLE STATE THAT HAS THE LARGEST OVERLAP WITH
C        THE GIVEN SINGLE-PARTICLE STATE
C=======================================================================
C
      IREQPB=IRSIMC
      INUQPB=1
C
      DO ISTATE=1,NUMBQP(IRSIMC,ICHARG)
C
         IF (ABS(OVRLAP(ISTATE)).GT.
     *       ABS(OVRLAP(INUQPB))) THEN
C
             INUQPB=ISTATE
C
         END IF
C
      END DO
C
C=======================================================================
C
      CALL CPUTIM('BLOSIM',0)
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
      SUBROUTINE BLOSIQ(ICHARG,INSIQB,IPSIQB,IDSIQB,INUQPB,IREQPB,
     *                                              IFIBLB,ISABLB)
C=======================================================================
      USE ALLWAV
      USE ALLQUZ
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      COMPLEX
     *          OVRLAP,QOVERL,WAVACT,WAVBLO,WAVAUX,C_ZERO
C
      DIMENSION
     *          OVRLAP(1:2*NDSTAT),QOVERL(0:NDRHFB),QNORMA(0:NDRHFB)
      DIMENSION
     *          WAVACT(1:NDBASE,0:NDREVE)
C
C=======================================================================
      COMMON
     *       /BLOWAV/ WAVBLO(1:NDBASE,0:NDISOS,0:NDREVE)
      COMMON
     *       /BLODEF/ IDEBLO(0:NDISOS)
      COMMON
     *       /SIQSTA/ ISTSIQ(1:2*NDSTAT,0:NDPARI)
      COMMON
     *       /QPNUMS/ NUMBQP(0:NDREVE,0:NDISOS)
      COMMON
     *       /DIMENS/ LDBASE
C
C=======================================================================
C
      CALL CPUTIM('BLOSIQ',1)
C
C=======================================================================
C     THIS SUBROUTINE SELECTS THE QUASIPARTICLE STATE TO BE BLOCKED
C     IN THE CASE OF NO SYMMETRY CONSERVED
C=======================================================================
C=======================================================================
C     INSIQB = THE NUMBER OF SINGLE-PARTICLE STATE THAT DEFINES  BLOCKED
C              QUASIPARTICLE STATE THROUGH THE LARGEST OVERLAP
C     IPSIQB = THE PARITY    OF THE ABOVE SINGLE-PARTICLE STATE
C
C     INUQPB = THE NUMBER OF QUASIPARTICLE STATE TO BE BLOCKED
C
C     IREQPB = THE SIMPLEX OF THE ABOVE QUASIPARTICLE STATE
C     IFIBLB = USE  (1) OR NOT (0) THE SAVED SINGLE-PARTICLE  STATE
C              FOR BLOCKING
C     ISABLB = SAVE (1) OR NOT (0) THE  SINGLE-PARTICLE  STATE  FOR
C              LATER BLOCKING
C=======================================================================
C
      C_ZERO=CMPLX(0.0D0,0.0D0)
C
      JSTATE=ISTSIQ(INSIQB,IPSIQB)
C
C=======================================================================
C         SAVING THE SINGLE-PARTICLE WAVE FUNCTION. FLAGS IDEBLO ARE
C         USED TO PASS INFORMATION TO  THE  SUBROUTINE  "RECORD"  ON
C         WHETHER THE MATRIX "WAVBLO" HAS BEEN INITIALISED.
C=======================================================================
C
      IF (ISABLB.EQ.1) THEN
C
          IDEBLO(ICHARG)=1
C
          DO IREVER=0,NDREVE
             DO IBASE=1,LDBASE
C
                WAVBLO(IBASE,ICHARG,IREVER)=WAVOCC(IBASE,JSTATE,IREVER)
C
             END DO
          END DO
C
      END IF
C
C=======================================================================
C         DEFINING THE SINGLE-PARTICLE WAVE FUNCTION, WHICH WILL BE USED
C         TO CALCULATE THE OVERLAP
C=======================================================================
C
      IF (IFIBLB.EQ.1) THEN
C
          DO IREVER=0,NDREVE
             DO IBASE=1,LDBASE
C
                WAVACT(IBASE,IREVER)=WAVBLO(IBASE,ICHARG,IREVER)
C
             END DO
          END DO
      ELSE
          DO IREVER=0,NDREVE
             DO IBASE=1,LDBASE
C
                WAVACT(IBASE,IREVER)=WAVOCC(IBASE,JSTATE,IREVER)
C
             END DO
          END DO
C
      END IF
C
C=======================================================================
C         REVERSING THE TIME FOR THE SINGLE-PARTICLE WAVE FUNCTION
C=======================================================================
C          ATTENTION: FOR IDSIQB = -1, OPERATIONS BELOW WERE NOT CORRECT
C          NO. 3      THIS BUG WAS  CORRECTED  ON  04/11/10  IN  VERSION
C                     (2.48U).
C=======================================================================
C
      IF (IDSIQB.EQ.-1) THEN
C
         DO IBASE=1,LDBASE
C
             WAVAUX         = CONJG(WAVACT(IBASE,0))
             WAVACT(IBASE,0)=-CONJG(WAVACT(IBASE,1))
             WAVACT(IBASE,1)= WAVAUX
C
         END DO
C
      END IF
C
C=======================================================================
C        CALCULATING OVERLAP OF SINGLE-PARTICLE AND QUASIPARTICLE STATES
C=======================================================================
C        SEE COMMENTS IN SUBROUTINE "BLOSIZ"
C=======================================================================
C
      DO ISTATE=1,NUMBQP(0,ICHARG)+NUMBQP(1,ICHARG)
C
         DO IREHFB=0,NDRHFB
C
            QOVERL(IREHFB)=C_ZERO
            QNORMA(IREHFB)=0.0D0
C
            IF (IREHFB.EQ.0) THEN
C
                DO IREVER=0,NDREVE
C
                   DO IBASE=1,LDBASE
C
                      QOVERL(IREHFB)=QOVERL(IREHFB)
     *                              +CONJG(WAVACT(IBASE,IREVER))
     *                *(2*IREVER-1)*CONJG(BWAQUZ(IBASE,ISTATE,1-IREVER))
C
                      QNORMA(IREHFB)=QNORMA(IREHFB)+
     *                               ABS(BWAQUZ(IBASE,ISTATE,IREVER))**2
C
                   END DO
C
                END DO
C
            ELSE
C
                DO IREVER=0,NDREVE
C
                   DO IBASE=1,LDBASE
C
                      QOVERL(IREHFB)=QOVERL(IREHFB)
     *                              +CONJG(WAVACT(IBASE,IREVER))
     *                              *CONJG(AWAQUZ(IBASE,ISTATE,IREVER))
C
                      QNORMA(IREHFB)=QNORMA(IREHFB)+
     *                               ABS(AWAQUZ(IBASE,ISTATE,IREVER))**2
C
                   END DO
C
                END DO
C
            END IF
C
            IF (QNORMA(IREHFB).GT.0.0D0) THEN
C
                QOVERL(IREHFB)=QOVERL(IREHFB)/SQRT(QNORMA(IREHFB))
            ELSE
                QOVERL(IREHFB)=C_ZERO
C
            END IF
C
         END DO
C
         IF (QNORMA(0).GT.QNORMA(1)) THEN
C
             OVRLAP(ISTATE)=QOVERL(0)
         ELSE
             OVRLAP(ISTATE)=QOVERL(1)
C
         END IF
C
      END DO
C
C=======================================================================
C        SELECTING QUASIPARTICLE STATE THAT HAS THE LARGEST OVERLAP WITH
C        THE GIVEN SINGLE-PARTICLE STATE
C=======================================================================
C
      IREQPB=0
      INUQPB=1
C
      DO IREVER=0,NDREVE
C
         DO ISTATE=1,NUMBQP(IREVER,ICHARG)
C
            IF(ABS(OVRLAP(ISTATE+IREVER*NUMBQP(0,ICHARG))).GT.
     *         ABS(OVRLAP(INUQPB+IREQPB*NUMBQP(0,ICHARG))))
     *                                                           THEN
C
                INUQPB=ISTATE
                IREQPB=IREVER
C
            END IF
C
         END DO
C
      END DO
C
C=======================================================================
C
      CALL CPUTIM('BLOSIQ',0)
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
      SUBROUTINE BLOSIZ(ICHARG,INSIZB,IDSIZB,INUQPB,IREQPB,
     *                                       IFIBLB,ISABLB)
C=======================================================================
      USE ALLWAV
      USE ALLQUZ
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      COMPLEX
     *          OVRLAP,QOVERL,WAVACT,WAVBLO,WAVAUX,C_ZERO
C
      DIMENSION
     *          OVRLAP(1:2*NDSTAT),QOVERL(0:NDRHFB),QNORMA(0:NDRHFB)
      DIMENSION
     *          WAVACT(1:NDBASE,0:NDREVE)
C
C=======================================================================
      COMMON
     *       /BLOWAV/ WAVBLO(1:NDBASE,0:NDISOS,0:NDREVE)
      COMMON
     *       /BLODEF/ IDEBLO(0:NDISOS)
      COMMON
     *       /QPNUMS/ NUMBQP(0:NDREVE,0:NDISOS)
      COMMON
     *       /DIMENS/ LDBASE
C
C=======================================================================
C
      CALL CPUTIM('BLOSIZ',1)
C
C=======================================================================
C     THIS SUBROUTINE SELECTS THE QUASIPARTICLE STATE TO BE BLOCKED
C     IN THE CASE OF NO SYMMETRY CONSERVED
C=======================================================================
C
      C_ZERO=CMPLX(0.0D0,0.0D0)
C
C=======================================================================
C     INSIZB = THE NUMBER OF SINGLE-PARTICLE STATE THAT DEFINES THE
C              BLOCKED QUASIPARTICLE STATE THROUGH LARGEST  OVERLAP
C     INUQPB = THE NUMBER OF  QUASIPARTICLE  STATE  TO  BE  BLOCKED
C     IREQPB = THE SIMPLEX OF THE ABOVE QUASIPARTICLE STATE
C     IFIBLB = USE  (1) OR NOT (0) THE SAVED SINGLE-PARTICLE  STATE
C              FOR BLOCKING
C     ISABLB = SAVE (1) OR NOT (0) THE  SINGLE-PARTICLE  STATE  FOR
C              LATER BLOCKING
C=======================================================================
C
C=======================================================================
C         SAVING THE SINGLE-PARTICLE WAVE FUNCTION. FLAGS IDEBLO ARE
C         USED TO PASS INFORMATION TO  THE  SUBROUTINE  "RECORD"  ON
C         WHETHER THE MATRIX "WAVBLO" HAS BEEN INITIALISED.
C=======================================================================
C
      IF (ISABLB.EQ.1) THEN
C
          IDEBLO(ICHARG)=1
C
          DO IREVER=0,NDREVE
             DO IBASE=1,LDBASE
C
                WAVBLO(IBASE,ICHARG,IREVER)=WAVOCC(IBASE,INSIZB,IREVER)
C
             END DO
          END DO
C
      END IF
C
C=======================================================================
C         DEFINING THE SINGLE-PARTICLE WAVE FUNCTION, WHICH WILL BE USED
C         TO CALCULATE THE OVERLAP
C=======================================================================
C
      IF (IFIBLB.EQ.1) THEN
C
          DO IREVER=0,NDREVE
             DO IBASE=1,LDBASE
C
                WAVACT(IBASE,IREVER)=WAVBLO(IBASE,ICHARG,IREVER)
C
             END DO
          END DO
      ELSE
          DO IREVER=0,NDREVE
             DO IBASE=1,LDBASE
C
                WAVACT(IBASE,IREVER)=WAVOCC(IBASE,INSIZB,IREVER)
C
             END DO
          END DO
C
      END IF
C
C=======================================================================
C         REVERSING THE TIME FOR THE SINGLE-PARTICLE WAVE FUNCTION
C=======================================================================
C          ATTENTION: FOR IDSIZB = -1, OPERATIONS BELOW WERE NOT CORRECT
C          NO. 3      THIS BUG WAS  CORRECTED  ON  04/11/10  IN  VERSION
C                     (2.48U).
C=======================================================================
C
      IF (IDSIZB.EQ.-1) THEN
C
         DO IBASE=1,LDBASE
C
             WAVAUX         = CONJG(WAVACT(IBASE,0))
             WAVACT(IBASE,0)=-CONJG(WAVACT(IBASE,1))
             WAVACT(IBASE,1)= WAVAUX
C
         END DO
C
      END IF
C
C=======================================================================
C        CALCULATING OVERLAP OF SINGLE-PARTICLE AND QUASIPARTICLE STATES
C=======================================================================
C        THE OVERLAP IS CALCULATED:
C        1.WITH THE  L O W E R  COMPONENT OF  THE  QUASIPARTICLE  STATE.
C          NOTE THAT THE CODE USES  THE  QUASIPARTICLE  STATES  FOR  THE
C          N E G A T I V E    QUASIPARTICLE   ENERGIES.  THEREFORE,  THE
C          LOWER COMPONENT EQUALS TO THE "A*" BOGOLYUBOV  MATRIX,  WHICH
C          FOR BROKEN (CONSERVED) SIMPLEX IS STORED IN AWAQUZ  (AWAQUA).
C          SINCE IN THE BCS APPROXIMATION COLUMNS OF  THE "A" BOGOLYUBOV
C          MATRIX ARE EIGENSTATES OF  THE  MEAN-FIELD  HAMILTONIAN,  THE
C          OVERLAPS MUST BE CALCULATED WITH CONJG(AWAQUZ),CONJG(AWAQUA).
C        2.WITH THE TIME-REVERSED  U P P E R  COMPONENT  OF  THE  QUASI-
C          PARTICLE STATE.
C          NOTE THAT THE CODE USES  THE  QUASIPARTICLE  STATES  FOR  THE
C          N E G A T I V E    QUASIPARTICLE   ENERGIES.  THEREFORE,  THE
C          UPPER COMPONENT EQUALS TO THE "B*" BOGOLYUBOV  MATRIX,  WHICH
C          FOR BROKEN (CONSERVED) SIMPLEX IS STORED IN BWAQUZ  (BWAQUA).
C          SINCE IN THE BCS APPROXIMATION COLUMNS OF THE "B*" BOGOLYUBOV
C          MATRIX ARE EIGENSTATES OF  THE  MEAN-FIELD  HAMILTONIAN,  THE
C          OVERLAPS MUST BE CALCULATED WITH AWAQUZ,AWAQUA. IN  ADDITION,
C          THE TIME REVERSAL REQUIRES THE COMPLEX CONJUGATION,  FLIPPING
C          THE SIMPLEX, AND MULTIPLYING ONE SIMPLEX COMPONENT BY "-1".
C=======================================================================
C
      DO ISTATE=1,NUMBQP(0,ICHARG)+NUMBQP(1,ICHARG)
C
         DO IREHFB=0,NDRHFB
C
            QOVERL(IREHFB)=C_ZERO
            QNORMA(IREHFB)=0.0D0
C
            IF (IREHFB.EQ.0) THEN
C
                DO IREVER=0,NDREVE
C
                   DO IBASE=1,LDBASE
C
C=======================================================================
C          ATTENTION: UP TO VERSION 2.48T, BELOW, THE TIME  REVERSAL  OF
C                     "BWAQUZ" WAS NOT INCLUDED. THIS BUG WAS REMOVED ON
C                     06/11/10 IN VERSION 2.48U.
C=======================================================================
C
                      QOVERL(IREHFB)=QOVERL(IREHFB)
     *                              +CONJG(WAVACT(IBASE,IREVER))
     *                *(2*IREVER-1)*CONJG(BWAQUZ(IBASE,ISTATE,1-IREVER))
C
                      QNORMA(IREHFB)=QNORMA(IREHFB)+
     *                               ABS(BWAQUZ(IBASE,ISTATE,IREVER))**2
C
                   END DO
C
                END DO
C
            ELSE
C
                DO IREVER=0,NDREVE
C
                   DO IBASE=1,LDBASE
C
C=======================================================================
C          ATTENTION: BETWEEN VERSION 2.33D AND 2.48T, BELOW THE COMPLEX
C                     CONJUGATION OF "AWAQUZ" WAS REMOVED TO  COMPENSATE
C                     FOR OTHER BUGS. THIS INCONSISTENCY WAS REMOVED  ON
C                     06/11/10 IN VERSION 2.48U.
C=======================================================================
C
                      QOVERL(IREHFB)=QOVERL(IREHFB)
     *                              +CONJG(WAVACT(IBASE,IREVER))
     *                              *CONJG(AWAQUZ(IBASE,ISTATE,IREVER))
C
                      QNORMA(IREHFB)=QNORMA(IREHFB)+
     *                               ABS(AWAQUZ(IBASE,ISTATE,IREVER))**2
C
                   END DO
C
                END DO
C
            END IF
C
            IF (QNORMA(IREHFB).GT.0.0D0) THEN
C
                QOVERL(IREHFB)=QOVERL(IREHFB)/SQRT(QNORMA(IREHFB))
            ELSE
                QOVERL(IREHFB)=C_ZERO
C
            END IF
C
         END DO
C
         IF (QNORMA(0).GT.QNORMA(1)) THEN
C
             OVRLAP(ISTATE)=QOVERL(0)
         ELSE
             OVRLAP(ISTATE)=QOVERL(1)
C
         END IF
C
      END DO
C
C=======================================================================
C        SELECTING QUASIPARTICLE STATE THAT HAS THE LARGEST OVERLAP WITH
C        THE GIVEN SINGLE-PARTICLE STATE
C=======================================================================
C
      IREQPB=0
      INUQPB=1
C
      DO IREVER=0,NDREVE
C
         DO ISTATE=1,NUMBQP(IREVER,ICHARG)
C
            IF(ABS(OVRLAP(ISTATE+IREVER*NUMBQP(0,ICHARG))).GT.
     *         ABS(OVRLAP(INUQPB+IREQPB*NUMBQP(0,ICHARG)))) THEN
C
                INUQPB=ISTATE
                IREQPB=IREVER
C
            END IF
C
         END DO
C
      END DO
C
C=======================================================================
C
      CALL CPUTIM('BLOSIZ',0)
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE CANQUA(MREVER,ICHARG,IMFHFB,ENESUM)
C=======================================================================
      USE MAT_PP
      USE ALLWAV
      USE ALLQUA
      USE CANONI
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      COMPLEX
     *          CELMTS,EWAVEF,RHO_PP
      COMPLEX
     *          C_ZERO,C_UNIT
C=======================================================================
      ALLOCATABLE RHO_PP(:,:,:)
      ALLOCATABLE CELMTS(:)
      ALLOCATABLE EWAVEF(:,:)
C=======================================================================
      DIMENSION
     *          V2WORK(1:NDBASE)
C=======================================================================
      COMMON
     *       /CORPAR/ V_CORR(1:NDSTAT,0:NDREVE)
      COMMON
     *       /PROCCU/ V_OCCU(1:2*NDSTAT)
      COMMON
     *       /CAOCCU/ V2OCCU(1:2*NDBASE)
     *       /CAOCNP/ V2OCNP(1:2*NDBASE,0:NDISOS)
      COMMON
     *       /SPLEVS/ SPENER(1:2*NDSTAT,0:NDISOS),
     *                SPOCCU(1:2*NDSTAT,0:NDISOS),
     *                SPALIG(1:2*NDSTAT,0:NDISOS),
     *                SPSPAL(1:2*NDSTAT,0:NDISOS),
     *                SPPARI(1:2*NDSTAT,0:NDISOS),
     *                SPSIMP(1:2*NDSTAT,0:NDISOS)
      COMMON
     *       /SIMSPE/ SPESIM(1:NDBASE)
     *       /SIMSNP/ SPESNP(1:NDBASE,0:NDISOS)
      COMMON
     *       /SPNUMS/ NUMBSP(0:NDREVE,0:NDISOS)
      COMMON
     *       /QPNUMS/ NUMBQP(0:NDREVE,0:NDISOS)
      COMMON
     *       /DIMENS/ LDBASE
C@@@ TEMP - TEMP - TEMP - TEMP - TEMP - TEMP - TEMP - TEMP - TEMP
      COMMON
     *       /FERFUN/ FER_FN(1:NDBASE)
      COMMON
     *       /T_FLAG/ IFTEMP
C@@@ TEMP - TEMP - TEMP - TEMP - TEMP - TEMP - TEMP - TEMP - TEMP
      INTERFACE
         SUBROUTINE AVEQUA(AVRVAL,OPCOMP,EWAVEF)
            USE hfodd_sizes
            DOUBLE PRECISION, DIMENSION(1:NDBASE) :: AVRVAL
            COMPLEX, DIMENSION(1:NDBASE,1:NDBASE) :: OPCOMP
            COMPLEX, DIMENSION(:,:), INTENT(INOUT) :: EWAVEF
         END SUBROUTINE AVEQUA
      END INTERFACE
C=======================================================================
C
      CALL CPUTIM('CANQUA',1)
C
C=======================================================================
C
      IWAVFU=1
C
C=======================================================================
C
      IALLOC=0
      IF (.NOT.ALLOCATED(WAVOCC)) THEN
          ALLOCATE (WAVOCC(1:NDBASE,1:2*NDSTAT,0:NDREVE),STAT=IALLOC)
          IF (IALLOC.NE.0) CALL NOALLO('WAVOCC','CANQUA')
      END IF
      IALLOC=0
      IF (.NOT.ALLOCATED(WAVCAN).AND.IWAVFU.EQ.1) THEN
          ALLOCATE (WAVCAN(1:NDBASE,1:NDBASE,0:NDREVE,0:NDISOS),
     *              STAT=IALLOC)
          IF (IALLOC.NE.0) CALL NOALLO('WAVCAN','CANQUA')
      END IF
      IALLOC=0
      ALLOCATE (CELMTS(1:((NDBASE+1)*NDBASE)/2),STAT=IALLOC)
      IF (IALLOC.NE.0) CALL NOALLO('CELMTS','CANQUA')
      IALLOC=0
      ALLOCATE (EWAVEF(1:NDBASE,1:NDBASE),STAT=IALLOC)
      IF (IALLOC.NE.0) CALL NOALLO('EWAVEF','CANQUA')
      IALLOC=0
      ALLOCATE (RHO_PP(1:NDBASE,1:NDBASE,0:NDREVE),STAT=IALLOC)
      IF (IALLOC.NE.0) CALL NOALLO('RHO_PP','CANQUA')
C=======================================================================
C
C=======================================================================
C        THIS SUBROUTINE DETERMINES THE CANONICAL BASIS
C        FOR THE CONSERVED SIMPLEX CASE
C=======================================================================
C
      C_ZERO=CMPLX(0.0D0,0.0D0)
      C_UNIT=CMPLX(1.0D0,0.0D0)
C
C=======================================================================
C        ATTENTION: IN CASE OF THE CONSERVED TIME-REVERSAL  SYMMETRY
C                   THIS SUBROUTINE IS CALLED WITH MREVER=0, AND THE
C                   DIAGONALIZATION IN THE TIME-REVERSED BLOCK  WILL
C                   NOT BE PERFORMED.
C=======================================================================
C
      ENESUM=0.0D0
C
      DO IREVER=0,MREVER
C
C=======================================================================
C        CALCULATING THE DENSITY MATRIX
C=======================================================================
C
         DO ISTATE=1,NUMBQP(IREVER,ICHARG)
C
            CALL ZCOPY(LDBASE,BWAQUA(1,ISTATE,IREVER),1,
     *                        EWAVEF(1,ISTATE),1)
C
C@@@ TEMP - TEMP - TEMP - TEMP - TEMP - TEMP - TEMP - TEMP - TEMP
            IF (IFTEMP.EQ.0) THEN
                CORECT=V_CORR(ISTATE,IREVER)
            ELSE
                CORECT=SQRT(1.0D0-FER_FN(ISTATE))
            END IF
C@@@ TEMP - TEMP - TEMP - TEMP - TEMP - TEMP - TEMP - TEMP - TEMP
C
            CALL ZDSCAL(LDBASE,CORECT,EWAVEF(1,ISTATE),1)
C
         END DO
C
         CALL ZGEMM('N','C',LDBASE,LDBASE,NUMBQP(IREVER,ICHARG),
     *                      C_UNIT,EWAVEF,NDBASE,EWAVEF,NDBASE,
     *                      C_ZERO,RHO_PP(1,1,IREVER),NDBASE)
C
C@@@ TEMP - TEMP - TEMP - TEMP - TEMP - TEMP - TEMP - TEMP - TEMP
         IF (IFTEMP.EQ.1) THEN
C
             DO ISTATE=1,NUMBQP(IREVER,ICHARG)
C
                DO IKET=1,LDBASE
                   DO IBRA=1,LDBASE
C
                      RHO_PP(IBRA,IKET,IREVER)=RHO_PP(IBRA,IKET,IREVER)
     *                                +CONJG(AWAQUA(IBRA,ISTATE,IREVER))
     *                                *     (AWAQUA(IKET,ISTATE,IREVER))
     *                                           *FER_FN(ISTATE)
C
                   END DO
                END DO
C
             END DO
C
         END IF
C@@@ TEMP - TEMP - TEMP - TEMP - TEMP - TEMP - TEMP - TEMP - TEMP
C
C=======================================================================
C           PREPARING THE DIAGONALIZATION OF THE DENSITY MATRIX.
C           DIAGONALIZATION OF MINUS DENSITY MATRIX ENSURES THAT
C           THE ORDER OF EIGENSTATES IS THE SAME AS IN THE  CASE
C           WHEN THE MEAN-FIELD HAMILTONIAN IS DIAGONALIZED.
C=======================================================================
C
         DO IBRA=1,LDBASE
            DO IKET=1,IBRA
C
               NCOUNT=IBRA+((2*LDBASE-IKET)*(IKET-1))/2
C
               CELMTS(NCOUNT)=-RHO_PP(IBRA,IKET,IREVER)
C
            END DO
         END DO
C
C=======================================================================
C           CALLING THE DIAGONALIZATION ROUTINE
C=======================================================================
C
         CALL DIAMAT(CELMTS,V2WORK,EWAVEF,LDBASE,NDBASE,LDBASE)
C
C=======================================================================
C           REVERTING TO THE CORRECT SIGNS OF THE OCCUPATION FACTORS.
C=======================================================================
C
         DO ISTATE=1,LDBASE
C
            V2WORK(ISTATE              )       =-V2WORK(ISTATE)
C
            IF ((V2WORK(ISTATE)-1.0).GT.1.E-14)
     *           V2WORK(ISTATE)=1.0
C
            IF ( V2WORK(ISTATE).LT.1.E-14)
     *           V2WORK(ISTATE)=0.0
C
            V2OCCU(ISTATE+IREVER*LDBASE)       = ABS(V2WORK(ISTATE))
            V2OCNP(ISTATE+IREVER*LDBASE,ICHARG)= ABS(V2WORK(ISTATE))
C
         END DO
C
C=======================================================================
C           ATTENTION: SINCE THE DENSITY MATRIX IS DETERMINED FROM  A
C                      LIMITED NUMBER OF  THE  QUASIPARTICLE  STATES,
C                      SMALL OCCUPATION NUMBERS CAN BE SPURIOUS.
C           ATTENTION: THE HFB SIGNS OF THE "V" FACTORS ARE  NOT  YET
C                      IMPLEMENTED.
C           ATTENTION: "ABS" AND "SIGN" BELOW SERVE AS  A  PROTECTION
C                      AGAINST VERY SMALL NEGATIVE NOISE  EIGENVALUES
C                      OF THE DENSITY MATRIX
C=======================================================================
C           ATTENTION: THE SIZE OF THE SINGLE PARTICLE SPACE  DEFINED
C                      BY THE "NUMBSP" ARRAYS IS  IRRELEVANT  IN  THE
C                      HFB METHOD, BECAUSE  THE  SPACE  IS  THEN  CUT
C                      ACCORDING TO THE CUTOFF ENERGY.  NEVERTHELESS,
C                      BELOW WE EXTRACT ONLY THOSE  CANONICAL  STATES
C                      WHICH FALL WITHIN THE WINDOWS DEFINED  BY  THE
C                      "NUMBSP" ARRAYS. THIS IS  DONE  FOR  THE  SOLE
C                      PURPOSE OF  RENDERING  THE  CANONICAL  SPECTRA
C                      ANALOGOUS TO SPECTRA USED BY THE CODE WHEN HFB
C                      IS NOT SOLVED.
C=======================================================================
C
         ONEONE=1.0D0
C
         DO ISTATE=1,NUMBSP(IREVER,ICHARG)
C
            V_OCCU(ISTATE+IREVER*NUMBSP(0,ICHARG))
     *            =SQRT(ABS(V2WORK(ISTATE)))*SIGN(ONEONE,V2WORK(ISTATE))
C
         END DO
C
C=======================================================================
C        STORING THE SINGLE-PARTICLE WAVE FUNCTIONS
C=======================================================================
C
         IF (IMFHFB.NE.1) THEN
C
             DO ISTATE=1,NUMBSP(IREVER,ICHARG)
C
                DO IBASE=1,LDBASE
C
                  WAVOCC(IBASE,ISTATE+IREVER*NUMBSP(0,ICHARG),1-IREVER)=
     *                                                            C_ZERO
                  WAVOCC(IBASE,ISTATE+IREVER*NUMBSP(0,ICHARG),  IREVER)=
     *                                              EWAVEF(IBASE,ISTATE)
C
                END DO
C
             END DO
C
         END IF
C
         IF (IWAVFU.EQ.1) THEN
C
             DO ISTATE=1,LDBASE
                DO I_BASE=1,LDBASE
                  WAVCAN(I_BASE,ISTATE,IREVER,ICHARG)=
     *                                 EWAVEF(I_BASE,ISTATE)
                END DO
             END DO
C
         END IF
C
C=======================================================================
C           CALCULATING THE CANONICAL SINGLE-PARTICLE ENERGIES
C=======================================================================
C
         CALL AVEQUA(SPESIM,BIG_PP(1,1,IREVER),EWAVEF)
C
         DO I=1,LDBASE
            SPESNP(I,ICHARG)=SPESIM(I)
         END DO
C
C=======================================================================
C           CALCULATING THE SUM OF SINGLE-PARTICLE ENERGIES
C=======================================================================
C
         DO ISTATE=1,LDBASE
C
            ENESUM=ENESUM+V2WORK(ISTATE)*SPESIM(ISTATE)
C
         END DO
C
C=======================================================================
C           STORING THE CANONICAL ENERGIES AND OCCUPATION FACTORS
C=======================================================================
C
         DO ISTATE=1,NUMBSP(IREVER,ICHARG)
            IF (IMFHFB.NE.1)
     *      SPENER(ISTATE+IREVER*NUMBSP(0,ICHARG),ICHARG)=SPESIM(ISTATE)
            SPOCCU(ISTATE+IREVER*NUMBSP(0,ICHARG),ICHARG)=
     *      V_OCCU(ISTATE+IREVER*NUMBSP(0,ICHARG))**2
         END DO
C
      END DO
C
C=======================================================================
C        DEFINING THE OCCUPATION NUMBERS FOR TIME-REVERSED STATES
C        IN CASE OF NO ROTATION
C=======================================================================
C
      IF (MREVER.EQ.0) THEN
C
          DO ISTATE=1,LDBASE
C
             V2OCCU(ISTATE+LDBASE)       =V2OCCU(ISTATE)
             V2OCNP(ISTATE+LDBASE,ICHARG)=V2OCCU(ISTATE)
C
          END DO
C
      END IF
C
C=======================================================================
      DEALLOCATE (CELMTS,EWAVEF)
      DEALLOCATE (RHO_PP)
C=======================================================================
C
      CALL CPUTIM('CANQUA',0)
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE CANQUZ(ICHARG,IMFHFB,ENESUM)
C=======================================================================
      USE MAT_PP
      USE MAT_PM
      USE ALLWAV
      USE ALLQUZ
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      COMPLEX
     *          CELMTS,EWAVEF,FWAVEF,RHO_PP,RHO_PM
      COMPLEX
     *          C_ZERO,C_UNIT
C=======================================================================
      ALLOCATABLE RHO_PP(:,:,:)
      ALLOCATABLE RHO_PM(:,:,:)
      ALLOCATABLE CELMTS(:)
      ALLOCATABLE EWAVEF(:,:),FWAVEF(:,:)
C=======================================================================
      COMMON
     *       /CORPAR/ V_CORR(1:NDSTAT,0:NDREVE)
      COMMON
     *       /PROCCU/ V_OCCU(1:2*NDSTAT)
      COMMON
     *       /CAOCCU/ V2OCCU(1:2*NDBASE)
     *       /CAOCNP/ V2OCNP(1:2*NDBASE,0:NDISOS)
      COMMON
     *       /SPLEVS/ SPENER(1:2*NDSTAT,0:NDISOS),
     *                SPOCCU(1:2*NDSTAT,0:NDISOS),
     *                SPALIG(1:2*NDSTAT,0:NDISOS),
     *                SPSPAL(1:2*NDSTAT,0:NDISOS),
     *                SPPARI(1:2*NDSTAT,0:NDISOS),
     *                SPSIMP(1:2*NDSTAT,0:NDISOS)
      COMMON
     *       /SIZSPE/ SPESIZ(1:2*NDBASE)
      COMMON
     *       /SPNUMS/ NUMBSP(0:NDREVE,0:NDISOS)
      COMMON
     *       /QPNUMS/ NUMBQP(0:NDREVE,0:NDISOS)
      COMMON
     *       /DIMENS/ LDBASE
C
      INTERFACE
         SUBROUTINE AVEQUZ(AVRVAL,OPE_PP,OPE_PM,EWAVEF)
            USE hfodd_sizes
            DOUBLE PRECISION, DIMENSION(1:2*NDBASE) :: AVRVAL
            COMPLEX, DIMENSION(1:NDBASE,1:NDBASE,0:NDREVE) :: OPE_PP,
     *                                                        OPE_PM
            COMPLEX, DIMENSION(:,:), INTENT(INOUT) :: EWAVEF
         END SUBROUTINE AVEQUZ
      END INTERFACE
C=======================================================================
C
      CALL CPUTIM('CANQUZ',1)
C
C=======================================================================
C
      IALLOC=0
C
C=======================================================================
      IF (.NOT.ALLOCATED(WAVOCC)) THEN
          ALLOCATE (WAVOCC(1:NDBASE,1:2*NDSTAT,0:NDREVE),STAT=IALLOC)
          IF (IALLOC.NE.0) CALL NOALLO('WAVOCC','CANQUZ')
      END IF
C=======================================================================
      ALLOCATE (CELMTS(1:((2*NDBASE+1)*2*NDBASE)/2),STAT=IALLOC)
      IF (IALLOC.NE.0) CALL NOALLO('CELMTS','CANQUZ')
C=======================================================================
      ALLOCATE (EWAVEF(1:NDBASE,1:2*NDBASE),STAT=IALLOC)
      IF (IALLOC.NE.0) CALL NOALLO('EWAVEF','CANQUZ')
      ALLOCATE (FWAVEF(1:NDBASE,1:2*NDBASE),STAT=IALLOC)
      IF (IALLOC.NE.0) CALL NOALLO('FWAVEF','CANQUZ')
C=======================================================================
      ALLOCATE (RHO_PP(1:NDBASE,1:NDBASE,0:NDREVE),STAT=IALLOC)
      IF (IALLOC.NE.0) CALL NOALLO('RHO_PP','CANQUZ')
      ALLOCATE (RHO_PM(1:NDBASE,1:NDBASE,0:NDREVE),STAT=IALLOC)
      IF (IALLOC.NE.0) CALL NOALLO('RHO_PM','CANQUZ')
C=======================================================================
C
C=======================================================================
C        THIS SUBROUTINE DETERMINES THE CANONICAL BASIS
C        FOR THE NO-SYMMETRY CASE
C=======================================================================
C
      C_ZERO=CMPLX(0.0D0,0.0D0)
      C_UNIT=CMPLX(1.0D0,0.0D0)
C
      ENESUM=0.0D0
C
C=======================================================================
C        CALCULATING THE DENSITY MATRIX
C=======================================================================
C
      ENESUM=0.0D0
C
      DO IREVER=0,NDREVE
C
         RHO_PP(:,:,IREVER)=C_ZERO
         RHO_PM(:,:,IREVER)=C_ZERO
C
         DO JREVER=0,NDREVE
C
            DO ISTATE=1,NUMBQP(JREVER,ICHARG)
C
               JSTATE=ISTATE+JREVER*NUMBQP(0,ICHARG)
C
               CALL ZCOPY(LDBASE,BWAQUZ(1,JSTATE,IREVER),1,
     *                           EWAVEF(1,JSTATE),1)
C
               CALL ZCOPY(LDBASE,BWAQUZ(1,JSTATE,1-IREVER),1,
     *                           FWAVEF(1,JSTATE),1)
C
               CORECT=V_CORR(ISTATE,JREVER)
C
               CALL ZDSCAL(LDBASE,CORECT,EWAVEF(1,JSTATE),1)
C
               CALL ZDSCAL(LDBASE,CORECT,FWAVEF(1,JSTATE),1)
C
            END DO
C
        END DO
C
        N_COLS = NUMBQP(0,ICHARG) + NUMBQP(1,ICHARG)
C
        CALL ZGEMM('N','C',LDBASE,LDBASE,N_COLS,
     *                     C_UNIT,EWAVEF,NDBASE,EWAVEF,NDBASE,
     *                     C_ZERO,RHO_PP(1,1,IREVER),NDBASE)
C
        CALL ZGEMM('N','C',LDBASE,LDBASE,N_COLS,
     *                     C_UNIT,EWAVEF,NDBASE,FWAVEF,NDBASE,
     *                     C_ZERO,RHO_PM(1,1,IREVER),NDBASE)
cC
c         DO JREVER=0,NDREVE
cC
c            DO ISTATE=1,NUMBQP(JREVER,ICHARG)
cC
c               JSTATE=ISTATE+JREVER*NUMBQP(0,ICHARG)
cC
c               DO IKET=1,LDBASE
c                  DO IBRA=1,LDBASE
cC
c                  RHO_PP(IBRA,IKET,IREVER)=RHO_PP(IBRA,IKET    ,IREVER)
c     *
c     *                              +      BWAQUZ(IBRA,JSTATE  ,IREVER)
c     *                              *CONJG(BWAQUZ(IKET,JSTATE  ,IREVER))
c     *                                         *V_CORR(ISTATE  ,JREVER)
c     *                                         *V_CORR(ISTATE  ,JREVER)
cC
c                  RHO_PM(IBRA,IKET,IREVER)=RHO_PM(IBRA,IKET    ,IREVER)
c     *
c     *                              +      BWAQUZ(IBRA,JSTATE  ,IREVER)
c     *                              *CONJG(BWAQUZ(IKET,JSTATE,1-IREVER))
c     *                                         *V_CORR(ISTATE  ,JREVER)
c     *                                         *V_CORR(ISTATE  ,JREVER)
cC
c                  END DO
c               END DO
cC
c            END DO
cC
c         END DO
C
      END DO
C
      DEALLOCATE(EWAVEF,FWAVEF)
C
      ALLOCATE (EWAVEF(1:2*NDBASE,1:2*NDBASE),STAT=IALLOC)
      IF (IALLOC.NE.0) CALL NOALLO('EWAVEF','CANQUZ')
C
C=======================================================================
C           PREPARING THE DIAGONALIZATION OF THE DENSITY MATRIX.
C           DIAGONALIZATION OF MINUS DENSITY MATRIX ENSURES THAT
C           THE ORDER OF EIGENSTATES IS THE SAME AS IN THE  CASE
C           WHEN THE MEAN-FIELD HAMILTONIAN IS DIAGONALIZED.
C=======================================================================
C
      DO IBRA=1,2*LDBASE
         DO IKET=1,2*LDBASE
C
            IF (IBRA.GE.IKET) THEN
C
                NCOUNT=IBRA+((4*LDBASE-IKET)*(IKET-1))/2
C
                IF (IBRA.LE.LDBASE.AND.IKET.LE.LDBASE)
     *                 CELMTS(NCOUNT)=-RHO_PP(IBRA       ,IKET       ,0)
C
                IF (IBRA.GT.LDBASE.AND.IKET.LE.LDBASE)
     *                 CELMTS(NCOUNT)=-RHO_PM(IBRA-LDBASE,IKET       ,1)
C
                IF (IBRA.GT.LDBASE.AND.IKET.GT.LDBASE)
     *                 CELMTS(NCOUNT)=-RHO_PP(IBRA-LDBASE,IKET-LDBASE,1)
C
            END IF
C
         END DO
      END DO
C
C=======================================================================
C           CALLING THE DIAGONALIZATION ROUTINE
C=======================================================================
C
      CALL DIAMAT(CELMTS,V2OCCU,EWAVEF,2*LDBASE,2*NDBASE,2*LDBASE)
C
C=======================================================================
C           REVERTING TO THE CORRECT SIGNS OF THE OCCUPATION FACTORS.
C=======================================================================
C
      DO ISTATE=1,2*LDBASE
C
         V2OCCU(ISTATE       )=-V2OCCU(ISTATE)
         V2OCNP(ISTATE,ICHARG)= V2OCCU(ISTATE)
C
      END DO
C
C=======================================================================
C        SEE COMMENTS IN SUBROUTINE "CANQUA"
C=======================================================================
C
      ONEONE=1.0D0
C
      DO IREVER=0,NDREVE
C
         DO ISTATE=1,NUMBSP(IREVER,ICHARG)
C
            V_OCCU(ISTATE+IREVER*NUMBSP(0,ICHARG))
     *            =SQRT(ABS(V2OCCU(ISTATE+IREVER*NUMBSP(0,ICHARG))))
     *         *SIGN(ONEONE,V2OCCU(ISTATE+IREVER*NUMBSP(0,ICHARG)))
C
         END DO
C
C=======================================================================
C        STORING THE SINGLE-PARTICLE WAVE FUNCTIONS
C=======================================================================
C
         IF (IMFHFB.NE.1) THEN
C
             DO ISTATE=1,NUMBSP(IREVER,ICHARG)
C
                DO IBASE=1,LDBASE
C
                   WAVOCC(IBASE,ISTATE+IREVER*NUMBSP(0,ICHARG),0)=
     *               EWAVEF(IBASE       ,ISTATE+IREVER*NUMBSP(0,ICHARG))
C
                   WAVOCC(IBASE,ISTATE+IREVER*NUMBSP(0,ICHARG),1)=
     *               EWAVEF(IBASE+LDBASE,ISTATE+IREVER*NUMBSP(0,ICHARG))
C
                END DO
C
             END DO
C
         END IF
C
      END DO
C
C=======================================================================
C           CALCULATING THE CANONICAL SINGLE-PARTICLE ENERGIES
C=======================================================================
C
         CALL AVEQUZ(SPESIZ,BIG_PP,BIG_PM,EWAVEF)
C
C=======================================================================
C           CALCULATING THE SUM OF SINGLE-PARTCLE ENERGIES
C=======================================================================
C
      DO ISTATE=1,2*LDBASE
C
         ENESUM=ENESUM+V2OCCU(ISTATE)*SPESIZ(ISTATE)
C
      END DO
C
C=======================================================================
C           STORING THE CANONICAL ENERGIES AND OCCUPATION FACTORS
C=======================================================================
C
      DO IREVER=0,NDREVE
C
         DO ISTATE=1,NUMBSP(IREVER,ICHARG)
C
            IF (IMFHFB.NE.1)
     *      SPENER(ISTATE+IREVER*NUMBSP(0,ICHARG),ICHARG)=
     *      SPESIZ(ISTATE+IREVER*NUMBSP(0,ICHARG))
C
            SPOCCU(ISTATE+IREVER*NUMBSP(0,ICHARG),ICHARG)=
     *      V_OCCU(ISTATE+IREVER*NUMBSP(0,ICHARG))**2
C
         END DO
C
      END DO
C
C=======================================================================
      DEALLOCATE (CELMTS,EWAVEF)
      DEALLOCATE (RHO_PP,RHO_PM)
C=======================================================================
C
      CALL CPUTIM('CANQUZ',0)
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE QUABCS(EFERMI,X_PART,FERFIX,IFEFIX,ICHARG,
     *                         IDSIGB,IDSIMB,IDSIQB,IDSIZB,
     *                                IREQPB,INUQPB,JNUQPB)
C=======================================================================
      USE hfodd_sizes
#if(USE_MPI==1)
      include 'mpif.h'
#endif
C=======================================================================
#if(SWITCH_QUAD==1)
      REAL*16
     *          V2ACTU,ONE_16
#endif
#if(USE_MPI==1)
      INTEGER :: escapeSignal
#endif
C@@@ TEMP - TEMP - TEMP - TEMP - TEMP - TEMP - TEMP - TEMP - TEMP
      COMMON
     *       /FERFUN/ FER_FN(1:NDBASE)
      COMMON
     *       /T_FLAG/ IFTEMP
      COMMON
     *       /GCTEMP/ TEMP_T
C@@@ TEMP - TEMP - TEMP - TEMP - TEMP - TEMP - TEMP - TEMP - TEMP
      COMMON
     *       /XEQUIV/ EEQUIV(1:NDSTAT,0:NDREVE),
     *                DEQUIV(1:NDSTAT,0:NDREVE)
      COMMON
     *       /QUAPAR/ ENQUAP(1:NDSTAT,0:NDREVE),
     *                V2QUAP(1:NDSTAT,0:NDREVE)
      COMMON
     *       /CORPAR/ V_CORR(1:NDSTAT,0:NDREVE)
     *       /CORISO/ VCOISO(1:NDSTAT,0:NDREVE,0:NDISOS)
      COMMON
     *       /LIMOCC/ NOTOCC(1:NDSTAT,0:NDREVE)
     *       /OCCISO/ NOCISO(1:NDSTAT,0:NDREVE,0:NDISOS)
      COMMON
     *       /QPNUMS/ NUMBQP(0:NDREVE,0:NDISOS)
      COMMON
     *       /QUOCCU/ PARACC,CORLIM,DERLIM,OCCLIM,MAXQUA
      COMMON
     *       /CFIPRI/ NFIPRI
#if(USE_MPI==1)
      COMMON
     *       /SIGNAL/ escapeSignal
#endif
C
C=======================================================================
C
      CALL CPUTIM('QUABCS',1)
C
C=======================================================================
C         THIS SUBROUTINE DETERMINES THE NEW VALUE OF THE FERMI ENERGY
C=======================================================================
C
      ONE_16=1.0
C
      IF (IFEFIX.NE.1) THEN
C
C=======================================================================
C         BEGINING THE CONDITIONAL LOOP WHICH ITERATES THE FERMI ENERGY
C=======================================================================
C
          ITEBCS=0
C
          EFEINF=-1000.
          EFESUP=+1000.
C
    1     CONTINUE
C
          PARNUM=0.0D0
          DERFER=0.0D0
          DERAUX=0.0D0
C
          ITEBCS=ITEBCS+1
C
C=======================================================================
C         CHECKING WHETHER THE MAXIMUM NUMBER OF ITERATIONS EXCEEDED.
C=======================================================================
C
          MAXQUA=100
C
          IF (ITEBCS.GT.MAXQUA) THEN
C
              WRITE(NFIPRI,'(/,
     *                     1X,20(1H/),'' MAXIMUM NUMBER OF ITERATIONS ''
     *                                                  ,6X,20(1H/),/,
     *                     1X,20(1H/),'' EXCEEDED IN QUABCS           ''
     *                                                  ,6X,20(1H/),/)')
C
#if(USE_MPI==1)
C
              CALL CPUTIM('QUABCS',0)
C
              escapeSignal = 1
              RETURN
#else
	      GO TO 2
#endif
C
          END IF
C
C=======================================================================
C         CALCULATING THE OCCUPATION FACTORS, PARTICLE NUMBER, AND THE
C         DERIVATIVE OF THE PARTICLE NUMBER OVER THE FERMI ENERGY.
C=======================================================================
C
          DO IREVER=0,NDREVE
             DO ISTATE=1,NUMBQP(IREVER,ICHARG)
C
C                BCS form of the q.p. energy
C
	        EQPEQU=SQRT((EEQUIV(ISTATE,IREVER)-EFERMI)**2
     *                      +DEQUIV(ISTATE,IREVER)**2)
C
C=======================================================================
C                IF T>0, THE VARIATIONS OF THE f_i (FERMI-DIRAC OCCUPA-
C                TION FACTORS)  WITH  RESPECT TO  \LAMBDA  MUST ALSO BE
C                CONSIDERED. BELOW THEY ARE  REDEFINED AT EACH STEP AND
C                AN  ADDITIONAL  TERM IS INCLUDED IN THE  DERIVATIVE OF
C                THE PARTICLE NUMBER WITH RESPECT TO \LAMBDA. IN SUCH A
C                WAY, THE PHASE TRANSITION PAIRED -> UNPAIRED SYSTEM IS
C                REPRODUCED.
C=======================================================================
C
	        IF (IFTEMP.EQ.1) THEN
C
	            FERDIR=0.5D0*(1.0D0-TANH(EQPEQU/TEMP_T/2.0D0))
	            FER_FN(ISTATE)=FERDIR
C
                    DFACTU=(EEQUIV(ISTATE,IREVER)-EFERMI)
     *                     /EQPEQU/TEMP_T*FERDIR*(1.0D0-FERDIR)
C
	        ELSE
C
                    FERDIR=0.0D0
                    DFACTU=0.0D0
C
	        END IF
C
C                Occupation factor based on BCS form of q.p. energy
C
	        V2ACTU=0.5*(ONE_16-(EEQUIV(ISTATE,IREVER)-EFERMI)
     *                             /EQPEQU)
C
                IF( V2ACTU     .LT.1.E-14) V2ACTU=0.0D0
                IF((V2ACTU-1.0).GT.1.E-14) V2ACTU=1.0D0
C
	        U2ACTU=1.0D0-V2ACTU
C
C                Derivative of v_i^2 with respect to \lambda
C
                DEACTU=0.5*DEQUIV(ISTATE,IREVER)**2/(EQPEQU**3.0)
C
                IF (ABS(IDSIGB).NE.1.AND.ABS(IDSIMB).NE.1.AND.
     *              ABS(IDSIQB).NE.1.AND.ABS(IDSIZB).NE.1) THEN
C
                    PARNUM=PARNUM+(1.0D0-FERDIR)*V2ACTU
     *                                  +FERDIR *U2ACTU
C
                    DERFER=DERFER+(1.0D0-2.0D0*FERDIR)*DEACTU
                    DERAUX=DERAUX+(1.0D0-2.0D0*V2ACTU)*DFACTU
C
                ELSE
C
	            IF (IFTEMP.NE.0)
     *                  STOP 'BLOCKING OF QP AT T>0 NOT IMPLEMENTED!'
C
                    IF ((IREVER.EQ.IREQPB.AND. ISTATE.NE.INUQPB).OR.
     *                  (IREVER.NE.IREQPB.AND.(ISTATE.NE.JNUQPB.OR.
     *                   ABS(IDSIQB).EQ.1.OR.ABS(IDSIZB).EQ.1))) THEN
C
                        PARNUM=PARNUM+V2ACTU
C
                        DERFER=DERFER+DEACTU
C
                    ELSE
C
                        IF ((IREVER.EQ.IREQPB.AND.ISTATE.EQ.INUQPB.AND.
     *                     (ABS(IDSIQB).EQ.1.OR.ABS(IDSIZB).EQ.1)).OR.
     *                      (IREVER.NE.IREQPB.AND.ISTATE.EQ.JNUQPB))THEN
C
                            PARNUM=PARNUM+1-V2ACTU
C
                            DERFER=DERFER-DEACTU
C
                        END IF
C
                    END IF
C
                END IF
C
             END DO
          END DO
C
	  DERFER=DERFER+DERAUX
C
C=======================================================================
C         THIS IF PROTECTS AGAINST THE DIVISION BY VANISHING  DERIVATIVE
C=======================================================================
C
          DERLIM=1.0D-20
C
          IF (ABS(DERFER).LT.DERLIM) DERFER=DERLIM
C
C=======================================================================
C         CHECKING WHETHER THE REQUIRED ACCURACY OF THE PARTICLE  NUMBER
C         HAS BEEN REACHED.
C=======================================================================
C
          PARACC=1.0D-10
C
          IF (ABS((PARNUM-X_PART)/X_PART).GT.PARACC) THEN
C
C=======================================================================
C         ADJUSTING THE UPPER AND LOWER BOUNDS ON THE FERMI ENERGY
C=======================================================================
C
              IF ((PARNUM-X_PART).LT.0.0D0) THEN
C
                 EFEINF=MAX(EFEINF,EFERMI)
              ELSE
                 EFESUP=MIN(EFESUP,EFERMI)
C
              END IF
C
C=======================================================================
C         CORRECTING THE FERMI ENERGY ACCORDING TO THE NEWTON METHOD.
C=======================================================================
C
              EFERMI=EFERMI-(PARNUM-X_PART)/DERFER
C
C=======================================================================
C         WHENEVER THE NEWTON METHOD SENDS THE FERMI ENERGY OUTSIDE  THE
C         BOUNDS, THE ARITHMETIC MEAN OF THE BOUNDS IS USED IN THE  NEXT
C         ITERATION.
C=======================================================================
C
              IF (EFERMI.LT.EFEINF.OR.EFERMI.GT.EFESUP) THEN
C
                  EFERMI=(EFEINF+EFESUP)/2
C
              END IF
C
              GO TO 1
C
          END IF
C
      ELSE
C
C=======================================================================
C         HERE THE FERMI ENERGY IS SET TO THE FIXED VALUE
C=======================================================================
C
          EFERMI=FERFIX
C
      END IF
C
C=======================================================================
C         CALCULATING THE CORRECTIVE FACTORS WHICH WILL BE USED WHEN
C         CONSTRUCTING THE DENSITIY MATRICES.
C=======================================================================
C         ATTENTION: NO CORRECTION IS POSSIBLE WHENEVER THE NORM  OF
C                    THE FIRST COMPONENT VANISHES. IT IS ALSO RATHER
C                    DANGEROUS TO USE SUCH CORRECTION METHOD FOR THE
C                    QUSIPARTICLES WITH VERY SMALL NORMS. THEREFORE,
C                    WE HERE ADOPT ARBITRARY CUT-OFF LIMIT  "CORLIM"
C                    BELOW WHICH THE CORRECTION IS   NOT  PERFORMED.
C                    SUCH QUASIPARTICLES ARE BEING KEPT IN THE SPACE
C                    BY SETTING V_CORR=1. THESE REMARKS ARE PARTICU-
C                    LARLY PERTINENT WHEN THIS ROUTINE IS RUN FOR  A
C                    VANISHING PAIRING OR WHEN THE PAIRING GRADUALLY
C                    DECREASES DURING THE HFB ITERATION.
C=======================================================================
C
#if(USE_MPI==0)
  2   CONTINUE
#endif
C
      CORLIM=1.0D-10
C
      DO IREVER=0,NDREVE
         DO ISTATE=1,NUMBQP(IREVER,ICHARG)
C
            V2ACTU=(ONE_16-(EEQUIV(ISTATE,IREVER)-EFERMI)
     *               /SQRT((EEQUIV(ISTATE,IREVER)-EFERMI)**2
     *                     +DEQUIV(ISTATE,IREVER)        **2))/2
C
            IF(V2ACTU.LT.0.0D0) V2ACTU=0.0D0
            IF(V2ACTU.GT.1.0D0) V2ACTU=1.0D0
C
            IF (V2QUAP(ISTATE,IREVER).GT.CORLIM) THEN
C
                IF (ABS(IDSIGB).NE.1.AND.ABS(IDSIMB).NE.1.AND.
     *              ABS(IDSIQB).NE.1.AND.ABS(IDSIZB).NE.1) THEN
C
                    V_CORR(ISTATE,IREVER)=
     *                                SQRT(V2ACTU/V2QUAP(ISTATE,IREVER))
                ELSE
C
                    IF ((IREVER.EQ.IREQPB.AND. ISTATE.NE.INUQPB).OR.
     *                  (IREVER.NE.IREQPB.AND.(ISTATE.NE.JNUQPB.OR.
     *                   ABS(IDSIQB).EQ.1.OR.ABS(IDSIZB).EQ.1))) THEN
C
                        V_CORR(ISTATE,IREVER)=
     *                                SQRT(V2ACTU/V2QUAP(ISTATE,IREVER))
                    ELSE
C
                        IF ((IREVER.EQ.IREQPB.AND.ISTATE.EQ.INUQPB.AND.
     *                     (ABS(IDSIQB).EQ.1.OR.ABS(IDSIZB).EQ.1)).OR.
     *                      (IREVER.NE.IREQPB.AND.ISTATE.EQ.JNUQPB))THEN
C
                            V_CORR(ISTATE,IREVER)=
     *                        SQRT((1.0D0-V2ACTU)/V2QUAP(ISTATE,IREVER))
C
                        ELSE
                            V_CORR(ISTATE,IREVER)=
     *                                SQRT(V2ACTU/V2QUAP(ISTATE,IREVER))
C
                        END IF
C
                    END IF
C
		END IF
C
            ELSE
C
                V_CORR(ISTATE,IREVER)=1.0D0
C
            END IF
C
            VCOISO(ISTATE,IREVER,ICHARG)=V_CORR(ISTATE,IREVER)
C
         END DO
      END DO
C
C=======================================================================
C         DEFINING QUASIPARTICLE STATES WHICH ARE NOT SIGNIFICANTLY
C         OCCUPIED AND ARE NOT TAKEN INTO ACCOUNT WHEN  CALCULATING
C         DENSITIES IN "DENSHF". THIS SAVES A LOT OF TIME WHEN  THE
C         CODE IS RUN IN THE HARTREE-FOCK MODE, OR WHEN THE PAIRING
C         GRADUALLY DECREASES DURING THE HFB ITERATION, OR WHEN THE
C         PAIRING VAHISHES FOR ONE KIND OF PARTICLES.
C         ATTENTION:
C                - THIS MAY HOWEVER LEAD TO UNCONTROLLED CHANGES OF
C                  DENSITIES, AT THE LEVEL DEFIND BY "OCCLIM"
C                - ALL Q.P. MUST BE RETAINED IF TEMPERATURE IS DIF-
C                  FERENT FROM 0.
C=======================================================================
C
      IF (IFTEMP.EQ.0) THEN
C
          OCCLIM=1.0D-8
C
          DO IREVER=0,NDREVE
             DO ISTATE=1,NUMBQP(IREVER,ICHARG)
C
                IF (V2QUAP(ISTATE,IREVER).LT.OCCLIM) THEN
                    NOTOCC(ISTATE,IREVER)=1
                ELSE
                    NOTOCC(ISTATE,IREVER)=0
                END IF
C
                NOCISO(ISTATE,IREVER,ICHARG)=NOTOCC(ISTATE,IREVER)
C
            END DO
          END DO
C
      ELSE
C
          DO IREVER=0,NDREVE
             DO ISTATE=1,NUMBQP(IREVER,ICHARG)
                NOTOCC(ISTATE,IREVER)=0
                NOCISO(ISTATE,IREVER,ICHARG)=NOTOCC(ISTATE,IREVER)
            END DO
          END DO
C
      END IF
C
C=======================================================================
C
      CALL CPUTIM('QUABCS',0)
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE DISP_Q(DQ2Q_Z,DQ2S_Z,DQ2Q_N,DQ2S_N,COFMUL,NZMAXX)
C=======================================================================
      USE SAVQUA
C=======================================================================
      USE hfodd_sizes
      USE hfodd_fission
C=======================================================================
      COMPLEX
     *          C_ZERO,C_UNIT,C_MINU
      COMPLEX
     *          FN12PL,FP12PL,FN11PL,FP11PL,FN11MI,FP11MI
      COMPLEX
     *          CMPLXN,CPLMUL
C=======================================================================
      ALLOCATABLE FN12PL(:,:,:),FP12PL(:,:,:)
      ALLOCATABLE FN11PL(:,:,:),FP11PL(:,:,:)
      ALLOCATABLE FN11MI(:,:,:),FP11MI(:,:,:)
      ALLOCATABLE CMPLXN(:,:),CPLMUL(:,:)
      ALLOCATABLE ELEMUL(:,:)
C=======================================================================
      DIMENSION
     *          COFMUL(0:NDMULT,0:NDOSCI,0:NDOSCI,1:NDKART)
      DIMENSION
     *          DQ2Q_Z(1:NDCONS),DQ2S_Z(1:NDCONS),
     *          DQ2Q_N(1:NDCONS),DQ2S_N(1:NDCONS)
C@@@ TEMP - TEMP - TEMP - TEMP - TEMP - TEMP - TEMP - TEMP - TEMP
      COMMON
     *       /FER_IS/ FERMFN(1:NDBASE,0:NDISOS)
C@@@ TEMP - TEMP - TEMP - TEMP - TEMP - TEMP - TEMP - TEMP - TEMP
      COMMON
     *       /CNSCOR/ LAMCNS(1:NDCONS),MIUCNS(1:NDCONS)
     *       /CNSNUM/ NOFCNS
C@@@ NECK - NECK - NECK - NECK - NECK - NECK - NECK - NECK - NECK
      COMMON
     *       /NCKVAL/ Q0NECK,G_NECK
     *       /NCKFLA/ IFNECK
C@@@ NECK - NECK - NECK - NECK - NECK - NECK - NECK - NECK - NECK
      COMMON
     *       /T_PHAS/ IPHAPP(0:NDYMAX,0:NDYMAX,0:NDKART),
     *                IPHAPM(0:NDYMAX,0:NDYMAX,0:NDKART),
     *                IPHAMP(0:NDYMAX,0:NDYMAX,0:NDKART),
     *                IPHAMM(0:NDYMAX,0:NDYMAX,0:NDKART)
      COMMON
     *       /QPNUMS/ NUMBQP(0:NDREVE,0:NDISOS)
      COMMON
     *       /DIMENS/ LDBASE
C
C=======================================================================
C        THIS SUBROUTINE DETERMINES THE QUANTUM AND STATISTICAL (FOR
C        T>0) COMPONENT OF THE PARTICLE NUMBER DISPERSION.
C        REFERENCE: J. L. Egido, Phys. Rev. Lett. 61, 767 (1988)
C=======================================================================
C
      IMAREA=1
C
      R_ZERO=0.0D0
      R_UNIT=1.0D0
C
      C_UNIT=CMPLX( R_UNIT,R_ZERO)
      C_ZERO=CMPLX( R_ZERO,R_ZERO)
      C_MINU=CMPLX(-R_UNIT,R_ZERO)
C
      IALLOC=0
C
      ALLOCATE(ELEMUL(1:NDBASE,1:NDBASE))
      IF (IALLOC.NE.0) CALL NOALLO('ELEMUL','DISP_Q')
      ALLOCATE(CPLMUL(1:NDBASE,1:NDBASE))
      IF (IALLOC.NE.0) CALL NOALLO('CPLMUL','DISP_Q')
C
      ELEMUL(:,:) = R_ZERO
      CPLMUL(:,:) = C_ZERO
C
      IALLOC=0
C
      ALLOCATE (FN12PL(1:NDSTAT,1:NDSTAT,1:NOFCNS),STAT=IALLOC)
      IF (IALLOC.NE.0) CALL NOALLO('FN12PL','DISP_Q')
      ALLOCATE (FP12PL(1:NDSTAT,1:NDSTAT,1:NOFCNS),STAT=IALLOC)
      IF (IALLOC.NE.0) CALL NOALLO('FP12PL','DISP_Q')
C
      FN12PL(:,:,:) = C_ZERO
      FP12PL(:,:,:) = C_ZERO
C
      IALLOC=0
C
      ALLOCATE (FN11PL(1:NDSTAT,1:NDSTAT,1:NOFCNS),STAT=IALLOC)
      IF (IALLOC.NE.0) CALL NOALLO('FN11PL','DISP_Q')
      ALLOCATE (FP11PL(1:NDSTAT,1:NDSTAT,1:NOFCNS),STAT=IALLOC)
      IF (IALLOC.NE.0) CALL NOALLO('FP11PL','DISP_Q')
      ALLOCATE (FN11MI(1:NDSTAT,1:NDSTAT,1:NOFCNS),STAT=IALLOC)
      IF (IALLOC.NE.0) CALL NOALLO('FN11MI','DISP_Q')
      ALLOCATE (FP11MI(1:NDSTAT,1:NDSTAT,1:NOFCNS),STAT=IALLOC)
      IF (IALLOC.NE.0) CALL NOALLO('FP11MI','DISP_Q')
C
      FN11PL(:,:,:) = C_ZERO
      FP11PL(:,:,:) = C_ZERO
      FN11MI(:,:,:) = C_ZERO
      FP11MI(:,:,:) = C_ZERO
C
      IALLOC=0
C
      ALLOCATE (CMPLXN(1:NDBASE,1:NDSTAT),STAT=IALLOC)
      IF (IALLOC.NE.0) CALL NOALLO('CMPLXN','DISP_Q')
C
      CMPLXN(:,:) = C_ZERO
C
      DO I_CONS=1,NOFCNS
C
C         Matrix of the constraint operator in the HO basis
C
         IF (I_CONS.LT.NOFCNS.OR.IFNECK.LE.1) THEN
C
             LAMACT=LAMCNS(I_CONS)
             MIUACT=MIUCNS(I_CONS)
C
             CALL INTMUL(IPHAPP(0,0,0),ELEMUL,COFMUL,
     *                                 LAMACT,MIUACT,IMAREA)
C
         ELSE
C
             CALL INT_QN(NZMAXX,ELEMUL)
C
         END IF
C
         DO L=1,NDBASE
            DO K=1,NDBASE
               CPLMUL(K,L)=ELEMUL(K,L)*C_UNIT
            END DO
         END DO
C
C         Neutron sector
C
         ICHARG=0
C
C         Computing \tilde{N}^{11}^{T} for positive simplex
C
C         Second term: V_{+}^{+} F_{+}^{*} V_{+}
C                    = B_{+}^{T}(B_{+}^{T} F_{+}^{T})^{+}
C
         CALL ZGEMM('T','T',NUMBQP(0,0),LDBASE,LDBASE,
     *                  C_UNIT,BSVQUA(1,1,0,0),NDBASE,
     *                                  CPLMUL,NDBASE,
     *                           C_ZERO,CMPLXN,NDSTAT)
C
         CALL ZGEMM('T','C',NUMBQP(0,0),NUMBQP(0,0),LDBASE,
     *                       C_UNIT,BSVQUA(1,1,0,0),NDBASE,
     *                                       CMPLXN,NDSTAT,
     *                         C_ZERO,FN11PL(1,1,I_CONS),NDSTAT)
C
C         First term:  U_{-}^{+} F_{-} U_{-}
C                    = A_{-}^{T}(A_{-}^{T} F_{-}^{+})^{+}
C
         CALL ZGEMM('T','C',NUMBQP(1,0),LDBASE,LDBASE,
     *                  C_UNIT,ASVQUA(1,1,1,0),NDBASE,
     *                                  CPLMUL,NDBASE,
     *                           C_ZERO,CMPLXN,NDSTAT)
C
         CALL ZGEMM('T','C',NUMBQP(1,0),NUMBQP(1,0),LDBASE,
     *                       C_UNIT,ASVQUA(1,1,1,0),NDBASE,
     *                                       CMPLXN,NDSTAT,
     *                         C_MINU,FN11PL(1,1,I_CONS),NDSTAT)
C
C         Computing \tilde{N}^{11}^{T} for negative simplex
C
         CALL ZGEMM('T','T',NUMBQP(1,0),LDBASE,LDBASE,
     *                  C_UNIT,BSVQUA(1,1,1,0),NDBASE,
     *                                  CPLMUL,NDBASE,
     *                           C_ZERO,CMPLXN,NDSTAT)
C
         CALL ZGEMM('T','C',NUMBQP(1,0),NUMBQP(1,0),LDBASE,
     *                       C_UNIT,BSVQUA(1,1,1,0),NDBASE,
     *                                       CMPLXN,NDSTAT,
     *                         C_ZERO,FN11MI(1,1,I_CONS),NDSTAT)
C
         CALL ZGEMM('T','C',NUMBQP(0,0),LDBASE,LDBASE,
     *                  C_UNIT,ASVQUA(1,1,0,0),NDBASE,
     *                                  CPLMUL,NDBASE,
     *                           C_ZERO,CMPLXN,NDSTAT)
C
         CALL ZGEMM('T','C',NUMBQP(0,0),NUMBQP(0,0),LDBASE,
     *                       C_UNIT,ASVQUA(1,1,0,0),NDBASE,
     *                                       CMPLXN,NDSTAT,
     *                         C_MINU,FN11MI(1,1,I_CONS),NDSTAT)
C
C
C         Computing \tilde{N}^{20} for positive simplex
C
C         Second term: U_{+}^{+} F_{+}^{+} V_{+}^{*}
C                    = A_{+}^{T} F_{+}     B_{+}
C
         CALL ZGEMM('N','N',LDBASE,NUMBQP(0,0),LDBASE,
     *                           C_UNIT,CPLMUL,NDBASE,
     *                         ASVQUA(1,1,0,0),NDBASE,
     *                           C_ZERO,CMPLXN,NDSTAT)
C
         CALL ZGEMM('T','N',NUMBQP(0,0),NUMBQP(0,0),LDBASE,
     *                       C_UNIT,BSVQUA(1,1,0,0),NDBASE,
     *                                       CMPLXN,NDSTAT,
     *                         C_ZERO,FN12PL(1,1,I_CONS),NDSTAT)
C
C         First term:  U_{-}^{+} F_{-} V_{-}^{*}
C                    = A_{-}^{T} F_{-} B_{-}
C
         CALL ZGEMM('N','N',LDBASE,NUMBQP(1,0),LDBASE,
     *                           C_UNIT,CPLMUL,NDBASE,
     *                         BSVQUA(1,1,1,0),NDBASE,
     *                           C_ZERO,CMPLXN,NDSTAT)
C
         CALL ZGEMM('T','N',NUMBQP(1,0),NUMBQP(1,0),LDBASE,
     *                       C_UNIT,ASVQUA(1,1,1,0),NDBASE,
     *                                       CMPLXN,NDSTAT,
     *                         C_MINU,FN12PL(1,1,I_CONS),NDSTAT)
C
C         Proton sector
C
         ICHARG=1
C
C         Computing \tilde{N}^{11}^{T} for positive simplex
C
C         Second term: V_{+}^{+} F_{+}^{*} V_{+}
C                    = B_{+}^{T}(B_{+}^{T} F_{+}^{T})^{+}
C
         CALL ZGEMM('T','T',NUMBQP(0,1),LDBASE,LDBASE,
     *                  C_UNIT,BSVQUA(1,1,0,1),NDBASE,
     *                                  CPLMUL,NDBASE,
     *                           C_ZERO,CMPLXN,NDSTAT)
C
         CALL ZGEMM('T','C',NUMBQP(0,1),NUMBQP(0,1),LDBASE,
     *                       C_UNIT,BSVQUA(1,1,0,1),NDBASE,
     *                                       CMPLXN,NDSTAT,
     *                         C_ZERO,FP11PL(1,1,I_CONS),NDSTAT)
C
C         First term:  U_{-}^{+} F_{-} U_{-}
C                    = A_{-}^{T}(A_{-}^{T} F_{-}^{+})^{+}
C
         CALL ZGEMM('T','C',NUMBQP(1,1),LDBASE,LDBASE,
     *                  C_UNIT,ASVQUA(1,1,1,1),NDBASE,
     *                                  CPLMUL,NDBASE,
     *                           C_ZERO,CMPLXN,NDSTAT)
C
         CALL ZGEMM('T','C',NUMBQP(1,1),NUMBQP(1,1),LDBASE,
     *                       C_UNIT,ASVQUA(1,1,1,1),NDBASE,
     *                                       CMPLXN,NDSTAT,
     *                         C_MINU,FP11PL(1,1,I_CONS),NDSTAT)
C
C         Computing \tilde{N}^{11}^{T} for negative simplex
C
         CALL ZGEMM('T','T',NUMBQP(1,1),LDBASE,LDBASE,
     *                  C_UNIT,BSVQUA(1,1,1,1),NDBASE,
     *                                  CPLMUL,NDBASE,
     *                           C_ZERO,CMPLXN,NDSTAT)
C
         CALL ZGEMM('T','C',NUMBQP(1,1),NUMBQP(1,1),LDBASE,
     *                       C_UNIT,BSVQUA(1,1,1,1),NDBASE,
     *                                       CMPLXN,NDSTAT,
     *                         C_ZERO,FP11MI(1,1,I_CONS),NDSTAT)
C
         CALL ZGEMM('T','C',NUMBQP(0,1),LDBASE,LDBASE,
     *                  C_UNIT,ASVQUA(1,1,0,1),NDBASE,
     *                                  CPLMUL,NDBASE,
     *                           C_ZERO,CMPLXN,NDSTAT)
C
         CALL ZGEMM('T','C',NUMBQP(0,1),NUMBQP(0,1),LDBASE,
     *                       C_UNIT,ASVQUA(1,1,0,1),NDBASE,
     *                                       CMPLXN,NDSTAT,
     *                         C_MINU,FP11MI(1,1,I_CONS),NDSTAT)
C
C
C         Computing \tilde{N}^{20} for positive simplex
C
C         Second term: U_{+}^{+} F_{+}^{+} V_{+}^{*}
C                    = A_{+}^{T} F_{+}     B_{+}
C
         CALL ZGEMM('N','N',LDBASE,NUMBQP(0,1),LDBASE,
     *                           C_UNIT,CPLMUL,NDBASE,
     *                         ASVQUA(1,1,0,1),NDBASE,
     *                           C_ZERO,CMPLXN,NDSTAT)
C
         CALL ZGEMM('T','N',NUMBQP(0,1),NUMBQP(0,1),LDBASE,
     *                       C_UNIT,BSVQUA(1,1,0,1),NDBASE,
     *                                       CMPLXN,NDSTAT,
     *                         C_ZERO,FP12PL(1,1,I_CONS),NDSTAT)
C
C         First term:  U_{-}^{+} F_{-} V_{-}^{*}
C                    = A_{-}^{T} F_{-} B_{-}
C
         CALL ZGEMM('N','N',LDBASE,NUMBQP(1,1),LDBASE,
     *                           C_UNIT,CPLMUL,NDBASE,
     *                         BSVQUA(1,1,1,1),NDBASE,
     *                           C_ZERO,CMPLXN,NDSTAT)
C
         CALL ZGEMM('T','N',NUMBQP(1,1),NUMBQP(1,1),LDBASE,
     *                       C_UNIT,ASVQUA(1,1,1,1),NDBASE,
     *                                       CMPLXN,NDSTAT,
     *                         C_MINU,FP12PL(1,1,I_CONS),NDSTAT)
C
C      Attention: FN11PL and FN11MI contain the transposed matrix
C                 of N^{11} for the positive and negative simplex
C                 blocks
C      Attention: In the loops below, we assume that
C                 NUMBQP(0,ICHARG)=NUMBQP(1,ICHARG)
C                 This is *not* true in the most general case, in
C                 particular when time-reversal symmetry or simplex
C                 is broken. As of version 250i, these cases can not
C                 be combined with T>0, so it's OK.
C
         DQ2Q_N(I_CONS)=0.0D0
         DQ2S_N(I_CONS)=0.0D0
C
         DO J=1,NUMBQP(0,0)
            DO I=1,NUMBQP(0,0)
C
               DQ2Q_N(I_CONS) = DQ2Q_N(I_CONS)
     *                   + (ABS(FN11PL(J,I,I_CONS))**2
     *                    + ABS(FN11MI(J,I,I_CONS))**2)
     *                       * (FERMFN(I,0) - FERMFN(J,0))
     *                   +  ABS(FN12PL(I,J,I_CONS))**2
     *                  *(1.0D0-FERMFN(I,0) - FERMFN(J,0))
C
               DQ2S_N(I_CONS) = DQ2S_N(I_CONS)
     *             + 2.0D0*(ABS(FN11PL(J,I,I_CONS))**2
     *                    + ABS(FN11MI(J,I,I_CONS))**2)
     *                       * (FERMFN(J,0)*(1.0D0-FERMFN(I,0)))
     *             + 2.0D0* ABS(FN12PL(I,J,I_CONS))**2
     *                         *FERMFN(I,0)*FERMFN(J,0)
C
            END DO
         END DO
C
         DO I=1,NUMBQP(0,0)
            DQ2S_N(I_CONS) = DQ2S_N(I_CONS)
     *                + (ABS(FN11PL(I,I,I_CONS))**2
     *                 + ABS(FN11MI(I,I,I_CONS))**2)
     *                    * (FERMFN(I,0)*(1.0D0-FERMFN(I,0)))
         END DO
C
         DQ2Q_Z(I_CONS)=0.0D0
         DQ2S_Z(I_CONS)=0.0D0
C
         DO J=1,NUMBQP(0,1)
            DO I=1,NUMBQP(0,1)
C
               DQ2Q_Z(I_CONS) = DQ2Q_Z(I_CONS)
     *                   + (ABS(FP11PL(J,I,I_CONS))**2
     *                    + ABS(FP11MI(J,I,I_CONS))**2)
     *                       * (FERMFN(I,1) - FERMFN(J,1))
     *                   +  ABS(FP12PL(I,J,I_CONS))**2
     *                  *(1.0D0-FERMFN(I,1) - FERMFN(J,1))
C
               DQ2S_Z(I_CONS) = DQ2S_Z(I_CONS)
     *             + 2.0D0*(ABS(FP11PL(J,I,I_CONS))**2
     *                    + ABS(FP11MI(J,I,I_CONS))**2)
     *                       * (FERMFN(J,1)*(1.0D0-FERMFN(I,1)))
     *             + 2.0D0* ABS(FP12PL(I,J,I_CONS))**2
     *                         *FERMFN(I,1)*FERMFN(J,1)
C
            END DO
         END DO
C
         DO I=1,NUMBQP(0,1)
            DQ2S_Z(I_CONS) = DQ2S_Z(I_CONS)
     *                + (ABS(FP11PL(I,I,I_CONS))**2
     *                 + ABS(FP11MI(I,I,I_CONS))**2)
     *                    * (FERMFN(I,1)*(1.0D0-FERMFN(I,1)))
         END DO
C
      END DO ! NOFCNS
C
      DEALLOCATE(FP12PL,FN12PL)
C
      DEALLOCATE(FN11PL,FN11MI)
      DEALLOCATE(FP11PL,FP11MI)
C
      DEALLOCATE(ELEMUL)
C
      DEALLOCATE(CPLMUL,CMPLXN)
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE DISPER(DN2QUA,DN2STA,DZ2QUA,DZ2STA)
C=======================================================================
      USE SAVQUA
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      COMPLEX
     *          C_ZERO,C_UNIT,C_MINU
      COMPLEX
     *          FN20PL,FP20PL,FN11PL,FP11PL,FN11MI,FP11MI
C=======================================================================
      ALLOCATABLE FN20PL(:,:),FP20PL(:,:)
      ALLOCATABLE FN11PL(:,:),FP11PL(:,:)
      ALLOCATABLE FN11MI(:,:),FP11MI(:,:)
C=======================================================================
      COMMON
     *       /FER_IS/ FERMFN(1:NDBASE,0:NDISOS)
      COMMON
     *       /QPNUMS/ NUMBQP(0:NDREVE,0:NDISOS)
      COMMON
     *       /DIMENS/ LDBASE
C
C=======================================================================
C        THIS SUBROUTINE DETERMINES THE QUANTUM AND STATISTICAL (FOR
C        T>0) COMPONENT OF THE PARTICLE NUMBER DISPERSION.
C        REFERENCE: J. L. Egido, Phys. Rev. Lett. 61, 767 (1988)
C=======================================================================
C
      R_ZERO=0.0D0
      R_UNIT=1.0D0
C
      C_UNIT=CMPLX( R_UNIT,R_ZERO)
      C_ZERO=CMPLX( R_ZERO,R_ZERO)
      C_MINU=CMPLX(-R_UNIT,R_ZERO)
C
      IALLOC=0
C
      ALLOCATE (FN20PL(1:NDSTAT,1:NDSTAT),STAT=IALLOC)
      IF (IALLOC.NE.0) CALL NOALLO('FN20PL','DISPER')
      ALLOCATE (FP20PL(1:NDSTAT,1:NDSTAT),STAT=IALLOC)
      IF (IALLOC.NE.0) CALL NOALLO('FP20PL','DISPER')
C
      FN20PL(:,:) = C_ZERO
      FP20PL(:,:) = C_ZERO
C
      ALLOCATE (FN11PL(1:NDSTAT,1:NDSTAT),STAT=IALLOC)
      IF (IALLOC.NE.0) CALL NOALLO('FN11PL','DISPER')
      ALLOCATE (FP11PL(1:NDSTAT,1:NDSTAT),STAT=IALLOC)
      IF (IALLOC.NE.0) CALL NOALLO('FP11PL','DISPER')
      ALLOCATE (FN11MI(1:NDSTAT,1:NDSTAT),STAT=IALLOC)
      IF (IALLOC.NE.0) CALL NOALLO('FN11MI','DISPER')
      ALLOCATE (FP11MI(1:NDSTAT,1:NDSTAT),STAT=IALLOC)
      IF (IALLOC.NE.0) CALL NOALLO('FP11MI','DISPER')
C
      FN11PL(:,:) = C_ZERO
      FP11PL(:,:) = C_ZERO
      FN11MI(:,:) = C_ZERO
      FP11MI(:,:) = C_ZERO
C
C      Computing \tilde{N}^{11}^{T} for positive simplex
C
C      Contribution from the neutrons
C
C      Second term: V_{+}^{+} V_{+}
C                 = ( B_{+}^{+}B_{+} )^{T}
C
      CALL ZGEMM('C','N',NUMBQP(0,0),NUMBQP(0,0),LDBASE,
     *                    C_UNIT,BSVQUA(1,1,0,0),NDBASE,
     *                           BSVQUA(1,1,0,0),NDBASE,
     *                             C_ZERO,FN11PL,NDSTAT)
C
C      First term:  U_{-}^{+} U_{-}
C                 = ( A_{-}^{+}A_{-} )^{T}
C
      CALL ZGEMM('C','N',NUMBQP(1,0),NUMBQP(1,0),LDBASE,
     *                    C_UNIT,ASVQUA(1,1,1,0),NDBASE,
     *                           ASVQUA(1,1,1,0),NDBASE,
     *                             C_UNIT,FN11PL,NDSTAT)
C
C      Contribution from the protons
C
      CALL ZGEMM('C','N',NUMBQP(0,1),NUMBQP(0,1),LDBASE,
     *                    C_ZERO,BSVQUA(1,1,0,1),NDBASE,
     *                           BSVQUA(1,1,0,1),NDBASE,
     *                             C_ZERO,FP11PL,NDSTAT)
C
      CALL ZGEMM('C','N',NUMBQP(1,1),NUMBQP(1,1),LDBASE,
     *                    C_UNIT,ASVQUA(1,1,1,1),NDBASE,
     *                           ASVQUA(1,1,1,1),NDBASE,
     *                             C_UNIT,FP11PL,NDSTAT)
C
C      Computing \tilde{N}^{11}^{T} for negative simplex
C
C      Contribution from the neutrons
C
      CALL ZGEMM('C','N',NUMBQP(1,0),NUMBQP(1,0),LDBASE,
     *                    C_UNIT,BSVQUA(1,1,1,0),NDBASE,
     *                           BSVQUA(1,1,1,0),NDBASE,
     *                             C_ZERO,FN11MI,NDSTAT)
C
      CALL ZGEMM('C','N',NUMBQP(0,0),NUMBQP(0,0),LDBASE,
     *                    C_UNIT,ASVQUA(1,1,0,0),NDBASE,
     *                           ASVQUA(1,1,0,0),NDBASE,
     *                             C_UNIT,FN11MI,NDSTAT)
C
C      Contribution from the protons
C
      CALL ZGEMM('C','N',NUMBQP(1,1),NUMBQP(1,1),LDBASE,
     *                    C_ZERO,BSVQUA(1,1,1,1),NDBASE,
     *                           BSVQUA(1,1,1,1),NDBASE,
     *                             C_ZERO,FP11MI,NDSTAT)
C
      CALL ZGEMM('C','N',NUMBQP(0,1),NUMBQP(0,1),LDBASE,
     *                    C_UNIT,ASVQUA(1,1,0,1),NDBASE,
     *                           ASVQUA(1,1,0,1),NDBASE,
     *                             C_UNIT,FP11MI,NDSTAT)
C
C
C      Computing \tilde{N}^{20}^{T} for positive simplex
C
C      Contribution from the neutrons
C
C      U_{+}^{+} V_{*} = A_{T}^{+}B_{+}
C
      CALL ZGEMM('T','N',NUMBQP(0,0),NUMBQP(0,0),LDBASE,
     *                    C_UNIT,ASVQUA(1,1,0,0),NDBASE,
     *                           BSVQUA(1,1,0,0),NDBASE,
     *                             C_ZERO,FN20PL,NDSTAT)
C
C      Contribution from the protons
C
      CALL ZGEMM('T','N',NUMBQP(0,1),NUMBQP(0,1),LDBASE,
     *                    C_UNIT,ASVQUA(1,1,0,1),NDBASE,
     *                           BSVQUA(1,1,0,1),NDBASE,
     *                             C_ZERO,FP20PL,NDSTAT)
C
      DN2QUA=0.0D0
      DN2STA=0.0D0
C
C      Attention: FN11PL and FN11MI contain the transposed matrix
C                 of N^{11} for the positive and negative simplex
C                 blocks
C      Attention: In the loops below, we assume that
C                 NUMBQP(0,ICHARG)=NUMBQP(1,ICHARG)
C                 This is *not* true in the most general case, in
C                 particular when time-reversal symmetry or simplex
C                 is broken. As of version 250i, these cases can not
C                 be combined with T>0, so it's OK.
C
      DO J=1,NUMBQP(0,0)
         DO I=1,NUMBQP(0,0)
C
            DN2QUA = DN2QUA + (ABS(FN11PL(J,I))**2
     *                       + ABS(FN11MI(J,I))**2)
     *                          * (FERMFN(I,0) - FERMFN(J,0))
     *                      +  ABS(FN20PL(I,J))**2*
     *                      (1.0D0-FERMFN(I,0) - FERMFN(J,0))
C
            DN2STA = DN2STA + 2.0D0*(ABS(FN11PL(J,I))**2
     *                             + ABS(FN11MI(J,I))**2)
     *           * (FERMFN(J,0)*(1.0D0 - FERMFN(I,0)))
     *                      + 2.0D0* ABS(FN20PL(I,J))**2
     *                      *FERMFN(I,0)*FERMFN(J,0)
C
         END DO
      END DO
C
      DO I=1,NUMBQP(0,0)
         DN2STA = DN2STA + (ABS(FN11PL(I,I))**2 + ABS(FN11MI(I,I))**2)
     *                       * (FERMFN(I,0)*(1.0D0 -  FERMFN(I,0)))
      END DO
C
      DZ2QUA=0.0
      DZ2STA=0.0
C
      DO J=1,NUMBQP(0,1)
         DO I=1,NUMBQP(0,1)
C
            DZ2QUA = DZ2QUA + (ABS(FP11PL(J,I))**2
     *                       + ABS(FP11MI(J,I))**2)
     *                          * (FERMFN(I,1) - FERMFN(J,1))
     *                      +  ABS(FP20PL(I,J))**2*
     *                      (1.0D0-FERMFN(I,1) - FERMFN(J,1))
C
            DZ2STA = DZ2STA + 2.0D0*(ABS(FP11PL(J,I))**2
     *                             + ABS(FP11MI(J,I))**2)
     *           * (FERMFN(J,1)*(1.0D0 - FERMFN(I,1)))
     *                      + 2.0D0* ABS(FP20PL(I,J))**2
     *                      *FERMFN(I,1)*FERMFN(J,1)
C
         END DO
      END DO
C
      DO I=1,NUMBQP(0,1)
         DZ2STA = DZ2STA + (ABS(FP11PL(I,I))**2 + ABS(FP11MI(I,I))**2)
     *                       * (FERMFN(I,1)*(1.0D0 -  FERMFN(I,1)))
      END DO
C
      DEALLOCATE(FP20PL,FN20PL)
C
      DEALLOCATE(FN11PL,FN11MI)
      DEALLOCATE(FP11PL,FP11MI)
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE PRI_FT(COFMUL,NZMAXX)
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      CHARACTER
     *          QMOMEN*4
C
      DIMENSION
     *          COFMUL(0:NDMULT,0:NDOSCI,0:NDOSCI,1:NDKART)
      DIMENSION
     *          DQ2Q_Z(1:NDCONS),DQ2S_Z(1:NDCONS),
     *          DQ2Q_N(1:NDCONS),DQ2S_N(1:NDCONS)
C
      COMMON
     *       /CNSCOR/ LAMCNS(1:NDCONS),MIUCNS(1:NDCONS)
     *       /CNSNUM/ NOFCNS
      COMMON
     *       /GCTEMP/ TEMP_T
      COMMON
     *       /SENTRO/ ENTRPY(0:NDISOS)
      COMMON
     *       /CFIPRI/ NFIPRI
C
C=======================================================================
C
C      Calculating the particle number dispersions (quantum and
C      statistical)
C
      DZ2QUA=0.0D0
      DN2QUA=0.0D0
      DZ2STA=0.0D0
      DN2STA=0.0D0
C
      CALL DISPER(DN2QUA,DN2STA,DZ2QUA,DZ2STA)
C
      DQ2Q_Z(:)=0.0D0
      DQ2Q_N(:)=0.0D0
      DQ2S_Z(:)=0.0D0
      DQ2S_N(:)=0.0D0
C
      CALL DISP_Q(DQ2Q_Z,DQ2S_Z,DQ2Q_N,DQ2S_N,COFMUL,NZMAXX)
C
      WRITE(NFIPRI,'(79(''*''),/,''*'',77X,''*'',/,
     *       ''*  FINITE-TEMPERATURE HFB CALCULATIONS AT '',
     *       ''T = '',F8.4,'' MEV                    *'',/,
     *       ''*'',77X,''*'',/,
     *       ''*  ENTROPY       PROTONS: '',F11.6,
     *       '' MEV   NEUTRONS: '',F11.6,'' MEV         *'',/,
     *       ''*  <dN^2>_QF     PROTONS: '',F11.6,
     *       ''       NEUTRONS: '',F11.6,''              *'',/,
     *       ''*  <dN^2>_SF     PROTONS: '',F11.6,
     *       ''       NEUTRONS: '',F11.6,''              *'',/,
     *       ''*'',77X,''*'')')
     *            TEMP_T,ENTRPY(1),ENTRPY(0),DZ2QUA,DN2QUA,
     *                                       DZ2STA,DN2STA
      WRITE(NFIPRI,'(''*                  <dQ^2>_QF              '',
     *       ''<dQ^2>_SF                           *'',/,
     *       ''* MOMENT     PROTONS    NEUTRONS     '',
     *       ''PROTONS   NEUTRONS                       *'')')
      DO I=1,NOFCNS
         LAMACT=LAMCNS(I)
         MIUACT=MIUCNS(I)
         WRITE(QMOMEN,'(''Q_'',2I1)') LAMACT,MIUACT
         IF (LAMACT.EQ.0.AND.MIUACT.EQ.0) QMOMEN='Q_N '
         WRITE(NFIPRI,'(''*  '',A4,2X,2(4X,F8.3,3X,F8.3),23X,''*'')')
     *                  QMOMEN,DQ2Q_Z(I),DQ2Q_N(I),
     *                         DQ2S_Z(I),DQ2S_N(I)
      END DO
      WRITE(NFIPRI,'(''*'',77X,''*'',/,79(''*''))')
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE LIPCOR(G_PAIR,FACTGX,FE2FIX,IF2FIX,
     *                  SLOWLI,EFER2X,ELIP_X,NUMITE,
     *                         EFERMI,PDELTA,ICHARG)
C=======================================================================
      USE hfodd_sizes
C=======================================================================
C@@@ TEMP - TEMP - TEMP - TEMP - TEMP - TEMP - TEMP - TEMP - TEMP
      COMMON
     *       /FERFUN/ FER_FN(1:NDBASE)
      COMMON
     *       /T_FLAG/ IFTEMP
C@@@ TEMP - TEMP - TEMP - TEMP - TEMP - TEMP - TEMP - TEMP - TEMP
      COMMON
     *       /XEQUIV/ EEQUIV(1:NDSTAT,0:NDREVE),
     *                DEQUIV(1:NDSTAT,0:NDREVE)
      COMMON
     *       /QPNUMS/ NUMBQP(0:NDREVE,0:NDISOS)
      COMMON
     *       /CAOCNP/ V2OCNP(1:2*NDBASE,0:NDISOS)
      COMMON
     *       /DIMENS/ LDBASE
      COMMON
     *       /BROINI/ IBROYD,N_ITER
     *       /BROMAT/ NOIINP,MIXMAT
C
C=======================================================================
C        THIS SUBROUTINE DETERMINES THE LIPKIN-NOGAMI LAMBDA2 AND ENERGY
C=======================================================================
C
                       NBROYD=IBROYD
      IF (NUMITE.LE.0) NBROYD=0
C
      IF (NUMITE.LE.0.OR.NBROYD.GE.1) THEN
          XOLDLI=0.0D0
      ELSE
          XOLDLI=SLOWLI
      END IF
C
      XNEWLI=1.0D0-XOLDLI
C
C=======================================================================
C        ATTENTION: IN CASE OF THE CONSERVED TIME-REVERSAL  SYMMETRY
C                   THIS SUBROUTINE IS CALLED WITH MREVER=0, AND THE
C                   LIPKIN-NOGAMI SUMS ARE DOUBLED.
C=======================================================================
C
      S_U1V1=0.0D0
      S_U1V3=0.0D0
      S_U2V2=0.0D0
      S_U3V1=0.0D0
      S_U4V4=0.0D0
C
C=======================================================================
C        CALCULATING THE LIPKIN-NOGAMI SUMS
C=======================================================================
C
      DO ISTATE=1,2*LDBASE
C
         IF (V2OCNP(ISTATE,ICHARG).GE.0.0D0) THEN
             V_ACTU=SQRT(V2OCNP(ISTATE,ICHARG))
         ELSE
             V_ACTU=0.0D0
         END IF
C
         IF (V2OCNP(ISTATE,ICHARG).LE.1.0D0) THEN
             U_ACTU=SQRT(1.0D0-V2OCNP(ISTATE,ICHARG))
         ELSE
             U_ACTU=0.0D0
             V_ACTU=1.0D0
         END IF
C
C@@@ TEMP - TEMP - TEMP - TEMP - TEMP - TEMP - TEMP - TEMP - TEMP
c         IF (IFTEMP.EQ.1) THEN
cC
c	                           I_STAT=ISTATE
c             IF (ISTATE.GT.LDBASE) I_STAT=ISTATE-LDBASE
cC
c             F_U1V3 = (1.0 - 2.0*FER_FN(I_STAT))
c     *            * (V_ACTU**2 + FER_FN(I_STAT)*(U_ACTU**2
c     *                                         - V_ACTU**2))
c             F_U3V1 = (1.0 - 2.0*FER_FN(I_STAT))
c     *            * (U_ACTU**2 - FER_FN(I_STAT)*(U_ACTU**2
c     *                                         - V_ACTU**2))
c             F_U2V2 = (1.0 - 2.0*FER_FN(I_STAT))**2
c             F_U4V4 = (1.0 - 2.0*FER_FN(I_STAT))**4
cC
c         ELSE
C
             F_U1V3 = 1.0D0
             F_U3V1 = 1.0D0
             F_U2V2 = 1.0D0
             F_U4V4 = 1.0D0
C
c         END IF
C@@@ TEMP - TEMP - TEMP - TEMP - TEMP - TEMP - TEMP - TEMP - TEMP
C
         S_U1V1 = S_U1V1 + U_ACTU    * V_ACTU
C
         S_U1V3 = S_U1V3 + U_ACTU    * V_ACTU**3 * F_U1V3
         S_U2V2 = S_U2V2 + U_ACTU**2 * V_ACTU**2 * F_U2V2
         S_U3V1 = S_U3V1 + U_ACTU**3 * V_ACTU    * F_U3V1
         S_U4V4 = S_U4V4 + U_ACTU**4 * V_ACTU**4 * F_U4V4
C
      END DO
C
C=======================================================================
C
      DENUME=S_U3V1*S_U1V3 - 2.0D0*S_U4V4
      DENOMI=S_U2V2*S_U2V2 - 2.0D0*S_U4V4
C
      IF (DENOMI.LE.0.0D0) THEN
          EFER2Y=0.0D0
      ELSE
          EFER2Y=0.25D0*G_PAIR*FACTGX*DENUME/DENOMI
      END IF
C
      EF2BRO=SLOWLI*EFER2X+(1.0-SLOWLI)*EFER2Y
C
      IF (IF2FIX.EQ.1) THEN
C
          EFER2X=FE2FIX
      ELSE
          EFER2X=XOLDLI*EFER2X + XNEWLI*EFER2Y
C
      END IF
C
      ELIP_X=-2.0D0*EFER2X*S_U2V2
C
      IF (IBROYD.GE.1.AND.NBROYD.GE.1.AND.MIXMAT.EQ.0) THEN
          ELIP_X=-2.0D0*EF2BRO*S_U2V2
      END IF
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE AVOBSE(MREVER,ICHARG)
C=======================================================================
      USE ALLWAV
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      CHARACTER
     *          SPKART*10,SPNILS*15,SPORDE*13
C
C=======================================================================
      ALLOCATABLE HAUXPP(:,:)
C=======================================================================
      COMMON
     *       /COEMUL/ COMULT(0:NDMULT,0:NDOSCI,0:NDOSCI,1:NDKART)
      COMMON
     *       /T_PHAS/ IPHAPP(0:NDYMAX,0:NDYMAX,0:NDKART),
     *                IPHAPM(0:NDYMAX,0:NDYMAX,0:NDKART),
     *                IPHAMP(0:NDYMAX,0:NDYMAX,0:NDKART),
     *                IPHAMM(0:NDYMAX,0:NDYMAX,0:NDKART)
      COMMON
     *       /SPRADI/ SPSIZE(1:2*NDSTAT,0:NDISOS,0:NDKART)
      COMMON
     *       /SPMOME/ SPMO20(1:2*NDSTAT,0:NDISOS),
     *                SPMO22(1:2*NDSTAT,0:NDISOS)
      COMMON
     *       /SPLABS/ SPKART(1:2*NDSTAT,0:NDISOS),
     *                SPNILS(1:2*NDSTAT,0:NDISOS),
     *                SPORDE(1:2*NDSTAT,0:NDISOS)
      COMMON
     *       /BASISO/ NXVECT(1:NDBASE),NYVECT(1:NDBASE),NZVECT(1:NDBASE)
      COMMON
     *       /SPNUMS/ NUMBSP(0:NDREVE,0:NDISOS)
      COMMON
     *       /DIMENS/ LDBASE
      COMMON
     *       /CFIPRI/ NFIPRI
C
C=======================================================================
C
      CALL CPUTIM('AVOBSE',1)
C
C=======================================================================
C
      IALLOC=0
C
C=======================================================================
      ALLOCATE (HAUXPP(1:NDBASE,1:NDBASE),STAT=IALLOC)
      IF (IALLOC.NE.0) CALL NOALLO('HAUXPP','AVOBSE')
C=======================================================================
C
C=======================================================================
C     THIS ROUTINE CALCULATES VARIOUS SINGLE-PARTICLE AVERAGES
C=======================================================================
C
C=======================================================================
C     CALCULATING THE 'DOMINATING' CARTESIAN LABELS
C=======================================================================
C
      LSTATE=NUMBSP(0,ICHARG)+MREVER*NUMBSP(1,ICHARG)
C
      DO ISTATE=1,LSTATE
C
         INDMAX=0
         ELEMAX=-1.0
C
         DO IBASE=1,LDBASE
C
            AMPLT2=REAL(WAVOCC(IBASE,ISTATE,0)
     *           *CONJG(WAVOCC(IBASE,ISTATE,0))
     *                 +WAVOCC(IBASE,ISTATE,1)
     *           *CONJG(WAVOCC(IBASE,ISTATE,1)))
C
            IF (ELEMAX.LT.AMPLT2) THEN
                INDMAX=IBASE
                ELEMAX=AMPLT2
            END IF
C
         END DO
C
         IF (INDMAX.LE.0.OR.INDMAX.GT.LDBASE) THEN
             WRITE(NFIPRI,'(''INDMAX = '',I10,'' LDBASE = '',I10)')
     *                        INDMAX,LDBASE
             STOP '  WRONG INDEX IN AVOBSE'
         END IF
C
         WRITE(SPKART(ISTATE,ICHARG),
     *         '(''|'',I2,'','',I2,'','',I2,''>'')')
     *      NXVECT(INDMAX),NYVECT(INDMAX),NZVECT(INDMAX)
C
      END DO
C
C=======================================================================
C     CALCULATING RADII
C=======================================================================
C
      IMAREA=+1
      ISIPAR=+1
      ITIPAR=+1
      IHERMI=+1
C
      DO KARTEZ=1,NDKART
C
         CALL INTRAD(HAUXPP,KARTEZ)
C
         CALL SPAVER(SPSIZE(1,ICHARG,KARTEZ),HAUXPP,MREVER,
     *               ICHARG,IMAREA,ISIPAR,ITIPAR,IHERMI)
C
      END DO
C
      DO ISTATE=1,LSTATE
C
         SPSIZE(ISTATE,ICHARG,0)=0.0D0
C
         DO KARTEZ=1,NDKART
C
            SPSIZE(ISTATE,ICHARG,0)=SPSIZE(ISTATE,ICHARG,0)
     *                             +SPSIZE(ISTATE,ICHARG,KARTEZ)
C
         END DO
C
      END DO
C
C=======================================================================
C     CALCULATING MULTIPOLE MOMENTS Q20 AND Q22 (REAL PART)
C=======================================================================
C
      LAMBDA=2
      MIU=0
C
      CALL INTMUL(IPHAPP(0,0,0),HAUXPP,COMULT,LAMBDA,MIU,IMAREA)
C
      CALL SPAVER(SPMO20(1,ICHARG),HAUXPP,MREVER,
     *            ICHARG,IMAREA,ISIPAR,ITIPAR,IHERMI)
C
      LAMBDA=2
      MIU=2
C
      CALL INTMUL(IPHAPP(0,0,0),HAUXPP,COMULT,LAMBDA,MIU,IMAREA)
C
      CALL SPAVER(SPMO22(1,ICHARG),HAUXPP,MREVER,
     *            ICHARG,IMAREA,ISIPAR,ITIPAR,IHERMI)
C
C=======================================================================
      DEALLOCATE (HAUXPP)
C=======================================================================
C
      CALL CPUTIM('AVOBSE',0)
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE AVANGY(NXMAXX,NYMAXX,NZMAXX,MREVER,ICHARG,ISIMPY)
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      ALLOCATABLE HAUXPP(:,:)
C=======================================================================
      COMMON
     *       /T_PHAS/ IPHAPP(0:NDYMAX,0:NDYMAX,0:NDKART),
     *                IPHAPM(0:NDYMAX,0:NDYMAX,0:NDKART),
     *                IPHAMP(0:NDYMAX,0:NDYMAX,0:NDKART),
     *                IPHAMM(0:NDYMAX,0:NDYMAX,0:NDKART)
      COMMON
     *       /SPLEVS/ SPENER(1:2*NDSTAT,0:NDISOS),
     *                SPOCCU(1:2*NDSTAT,0:NDISOS),
     *                SPALIG(1:2*NDSTAT,0:NDISOS),
     *                SPSPAL(1:2*NDSTAT,0:NDISOS),
     *                SPPARI(1:2*NDSTAT,0:NDISOS),
     *                SPSIMP(1:2*NDSTAT,0:NDISOS)
      COMMON
     *       /SPSTAT/ SPXALI(1:2*NDSTAT,0:NDISOS),
     *                SPZALI(1:2*NDSTAT,0:NDISOS),
     *                SPXSPI(1:2*NDSTAT,0:NDISOS),
     *                SPZSPI(1:2*NDSTAT,0:NDISOS)
      COMMON
     *       /SPNUMS/ NUMBSP(0:NDREVE,0:NDISOS)
C
C=======================================================================
C
      CALL CPUTIM('AVANGY',1)
C
C=======================================================================
C
      IALLOC=0
C
C=======================================================================
      ALLOCATE (HAUXPP(1:NDBASE,1:NDBASE),STAT=IALLOC)
      IF (IALLOC.NE.0) CALL NOALLO('HAUXPP','AVANGY')
C=======================================================================
C
C=======================================================================
C     THIS ROUTINE CALCULATES TOTAL AND INTRINSIC ALIGNMENTS
C=======================================================================
C
      FACTOR=1.0D0
C
      IHERMI=+1
      ITIPAR=-1
C
      ISIPAR=+1
C
C=======================================================================
C         Y-DIRECTION
C=======================================================================
C
      IMAREA=-1
C
      CALL INT_LY(NXMAXX,NYMAXX,NZMAXX,IPHAPP(0,0,0),HAUXPP,FACTOR)
C
      CALL SPAVER(SPALIG(1,ICHARG),HAUXPP,MREVER,
     *            ICHARG,IMAREA,ISIPAR,ITIPAR,IHERMI)
C
      IMAREA=+1
C
      CALL INT_SY(NXMAXX,NYMAXX,NZMAXX,HAUXPP,FACTOR)
C
      CALL SPAVER(SPSPAL(1,ICHARG),HAUXPP,MREVER,
     *            ICHARG,IMAREA,ISIPAR,ITIPAR,IHERMI)
C
      IF (ISIMPY.NE.1) THEN
C
          ISIPAR=-1
C
C=======================================================================
C         X-DIRECTION
C=======================================================================
C
          IMAREA=-1
C
          CALL INT_LX(NXMAXX,NYMAXX,NZMAXX,IPHAPM(0,0,0),HAUXPP,FACTOR)
C
          CALL SPAVER(SPXALI(1,ICHARG),HAUXPP,MREVER,
     *                ICHARG,IMAREA,ISIPAR,ITIPAR,IHERMI)
C
          IMAREA=+1
C
          CALL INT_SX(NXMAXX,NYMAXX,NZMAXX,HAUXPP,FACTOR)
C
          CALL SPAVER(SPXSPI(1,ICHARG),HAUXPP,MREVER,
     *                ICHARG,IMAREA,ISIPAR,ITIPAR,IHERMI)
C
C=======================================================================
C         Z-DIRECTION
C=======================================================================
C
          IMAREA=-1
C
          CALL INT_LZ(NXMAXX,NYMAXX,NZMAXX,IPHAPM(0,0,0),HAUXPP,FACTOR)
C
          CALL SPAVER(SPZALI(1,ICHARG),HAUXPP,MREVER,
     *                ICHARG,IMAREA,ISIPAR,ITIPAR,IHERMI)
C
          CALL INT_SZ(NXMAXX,NYMAXX,NZMAXX,HAUXPP,FACTOR)
C
          CALL SPAVER(SPZSPI(1,ICHARG),HAUXPP,MREVER,
     *                ICHARG,IMAREA,ISIPAR,ITIPAR,IHERMI)
C
      END IF
C
C=======================================================================
C
      LSTATE=NUMBSP(0,ICHARG)+MREVER*NUMBSP(1,ICHARG)
C
      DO ISTATE=1,LSTATE
C
         SPALIG(ISTATE,ICHARG)=SPALIG(ISTATE,ICHARG)
     *                        +SPSPAL(ISTATE,ICHARG)
         SPXALI(ISTATE,ICHARG)=SPXALI(ISTATE,ICHARG)
     *                        +SPXSPI(ISTATE,ICHARG)
         SPZALI(ISTATE,ICHARG)=SPZALI(ISTATE,ICHARG)
     *                        +SPZSPI(ISTATE,ICHARG)
C
      END DO
C
C=======================================================================
      DEALLOCATE (HAUXPP)
C=======================================================================
C
      CALL CPUTIM('AVANGY',0)
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE OLSTOR
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      CHARACTER
     *          SPKART*10,SPNILS*15,SPORDE*13
      CHARACTER
     *          OLKART*10,OLNILS*15,OLORDE*13
C
      COMMON
     *       /SPLEVS/ SPENER(1:2*NDSTAT,0:NDISOS),
     *                SPOCCU(1:2*NDSTAT,0:NDISOS),
     *                SPALIG(1:2*NDSTAT,0:NDISOS),
     *                SPSPAL(1:2*NDSTAT,0:NDISOS),
     *                SPPARI(1:2*NDSTAT,0:NDISOS),
     *                SPSIMP(1:2*NDSTAT,0:NDISOS)
      COMMON
     *       /SPSTAT/ SPXALI(1:2*NDSTAT,0:NDISOS),
     *                SPZALI(1:2*NDSTAT,0:NDISOS),
     *                SPXSPI(1:2*NDSTAT,0:NDISOS),
     *                SPZSPI(1:2*NDSTAT,0:NDISOS)
      COMMON
     *       /SPLABS/ SPKART(1:2*NDSTAT,0:NDISOS),
     *                SPNILS(1:2*NDSTAT,0:NDISOS),
     *                SPORDE(1:2*NDSTAT,0:NDISOS)
      COMMON
     *       /SPLOLD/ OLALIG(1:2*NDSTAT,0:NDISOS),
     *                OLSPAL(1:2*NDSTAT,0:NDISOS),
     *                OLPARI(1:2*NDSTAT,0:NDISOS)
      COMMON
     *       /SPSOLD/ OLXALI(1:2*NDSTAT,0:NDISOS),
     *                OLZALI(1:2*NDSTAT,0:NDISOS),
     *                OLXSPI(1:2*NDSTAT,0:NDISOS),
     *                OLZSPI(1:2*NDSTAT,0:NDISOS)
      COMMON
     *       /SPKOLD/ OLKART(1:2*NDSTAT,0:NDISOS),
     *                OLNILS(1:2*NDSTAT,0:NDISOS),
     *                OLORDE(1:2*NDSTAT,0:NDISOS)
      COMMON
     *       /SPNUMS/ NUMBSP(0:NDREVE,0:NDISOS)
C
C=======================================================================
C         THIS SUBROUTINE STORES SINGLE-PARTICLE  PROPERTIES
C         TO MAKE IT AVAILABLE FOR USE IN THE NEXT ITERATION.
C=======================================================================
C
      DO ICHARG=0,NDISOS
C
         DO ISTATE=1,NUMBSP(0,ICHARG)+NUMBSP(1,ICHARG)
C
            OLALIG(ISTATE,ICHARG)=SPALIG(ISTATE,ICHARG)
            OLSPAL(ISTATE,ICHARG)=SPSPAL(ISTATE,ICHARG)
            OLPARI(ISTATE,ICHARG)=SPPARI(ISTATE,ICHARG)
C
            OLXALI(ISTATE,ICHARG)=SPXALI(ISTATE,ICHARG)
            OLZALI(ISTATE,ICHARG)=SPZALI(ISTATE,ICHARG)
            OLXSPI(ISTATE,ICHARG)=SPXSPI(ISTATE,ICHARG)
            OLZSPI(ISTATE,ICHARG)=SPZSPI(ISTATE,ICHARG)
C
            OLKART(ISTATE,ICHARG)=SPKART(ISTATE,ICHARG)
            OLNILS(ISTATE,ICHARG)=SPNILS(ISTATE,ICHARG)
            OLORDE(ISTATE,ICHARG)=SPORDE(ISTATE,ICHARG)
C
         END DO
C
      END DO
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE SPZERO
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      COMMON
     *       /SPLEVS/ SPENER(1:2*NDSTAT,0:NDISOS),
     *                SPOCCU(1:2*NDSTAT,0:NDISOS),
     *                SPALIG(1:2*NDSTAT,0:NDISOS),
     *                SPSPAL(1:2*NDSTAT,0:NDISOS),
     *                SPPARI(1:2*NDSTAT,0:NDISOS),
     *                SPSIMP(1:2*NDSTAT,0:NDISOS)
      COMMON
     *       /SPSTAT/ SPXALI(1:2*NDSTAT,0:NDISOS),
     *                SPZALI(1:2*NDSTAT,0:NDISOS),
     *                SPXSPI(1:2*NDSTAT,0:NDISOS),
     *                SPZSPI(1:2*NDSTAT,0:NDISOS)
      COMMON
     *       /SPRADI/ SPSIZE(1:2*NDSTAT,0:NDISOS,0:NDKART)
      COMMON
     *       /SPMOME/ SPMO20(1:2*NDSTAT,0:NDISOS),
     *                SPMO22(1:2*NDSTAT,0:NDISOS)
      COMMON
     *       /SPNUMS/ NUMBSP(0:NDREVE,0:NDISOS)
C
C=======================================================================
C         THIS SUBROUTINE PUTS ZEROS INTO THE SINGLE-PARTICLE PROPERTIES
C=======================================================================
C
      DO ICHARG=0,NDISOS
C
         DO ISTATE=1,NUMBSP(0,ICHARG)+NUMBSP(1,ICHARG)
C
            SPENER(ISTATE,ICHARG)=0.0D0
            SPOCCU(ISTATE,ICHARG)=0.0D0
            SPALIG(ISTATE,ICHARG)=0.0D0
            SPSPAL(ISTATE,ICHARG)=0.0D0
            SPPARI(ISTATE,ICHARG)=0.0D0
            SPSIMP(ISTATE,ICHARG)=0.0D0
C
            SPXALI(ISTATE,ICHARG)=0.0D0
            SPZALI(ISTATE,ICHARG)=0.0D0
            SPXSPI(ISTATE,ICHARG)=0.0D0
            SPZSPI(ISTATE,ICHARG)=0.0D0
C
            SPMO20(ISTATE,ICHARG)=0.0D0
            SPMO22(ISTATE,ICHARG)=0.0D0
C
            SPSIZE(ISTATE,ICHARG,1)=0.0D0
            SPSIZE(ISTATE,ICHARG,2)=0.0D0
            SPSIZE(ISTATE,ICHARG,3)=0.0D0
C
         END DO
C
      END DO
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE SPTALL(EMINAL,EMAXAL,SPMODL,NAMEPN,
     *                         ISIGNY,ISIMPY,ISIQTY,
     *                         MREVER,ICHARG,NILXYZ)
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      CHARACTER
     *          SPKART*10,SPNILS*15,SPORDE*13
      CHARACTER
     *          NAMEPN*8,GFACTO*7,NAMSYM(0:3)*13,NAMLAB(3)*10
      CHARACTER
     *          SPMODL*14
C
      DIMENSION
     *          EORDER(1:2*NDSTAT),NORDER(1:2*NDSTAT),
     *          NSTATE(1:2*NDSTAT),NREVER(1:2*NDSTAT)
      DIMENSION
     *          N_PPRP(1:2*NDSTAT),N_PPRM(1:2*NDSTAT),
     *          N_PMRP(1:2*NDSTAT),N_PMRM(1:2*NDSTAT)
      DIMENSION
     *          N_SIMP(1:2*NDSTAT),N_SIMM(1:2*NDSTAT)
      DIMENSION
     *          N_SIQP(1:2*NDSTAT),N_SIQM(1:2*NDSTAT)
C
      COMMON
     *       /SPLEVS/ SPENER(1:2*NDSTAT,0:NDISOS),
     *                SPOCCU(1:2*NDSTAT,0:NDISOS),
     *                SPALIG(1:2*NDSTAT,0:NDISOS),
     *                SPSPAL(1:2*NDSTAT,0:NDISOS),
     *                SPPARI(1:2*NDSTAT,0:NDISOS),
     *                SPSIMP(1:2*NDSTAT,0:NDISOS)
      COMMON
     *       /SPSTAT/ SPXALI(1:2*NDSTAT,0:NDISOS),
     *                SPZALI(1:2*NDSTAT,0:NDISOS),
     *                SPXSPI(1:2*NDSTAT,0:NDISOS),
     *                SPZSPI(1:2*NDSTAT,0:NDISOS)
      COMMON
     *       /SPLABS/ SPKART(1:2*NDSTAT,0:NDISOS),
     *                SPNILS(1:2*NDSTAT,0:NDISOS),
     *                SPORDE(1:2*NDSTAT,0:NDISOS)
      COMMON
     *       /SPNUMS/ NUMBSP(0:NDREVE,0:NDISOS)
      COMMON
     *       /CFIPRI/ NFIPRI
C
      DATA
     *      NAMSYM /'  (S=+,S=-)  ','(++,+-,-+,--)',
     *              ' <Y-SIMPLEX> ','  (P=+,P=-)  '/
      DATA
     *      NAMLAB /'nx,lx,OMEx',
     *              'ny,ly,OMEy',
     *              'nz,lz,OMEz'/
C
C=======================================================================
C         THIS ROUTINE TABULATES SINGLE-PARTICLE RESULTS IN THE FORM
C         OF A COMMON TABLE FOR ALL SYMMETRIES
C=======================================================================
C
C=======================================================================
C         DETERMINING THE ORDERED SINGLE-PARTICLE SPECTRUM
C=======================================================================
C
      IORDER=0
C
      DO IREVER=0,MREVER
C
         DO ISTATE=1,NUMBSP(IREVER,ICHARG)
C
            IORDER=IORDER+1
            NORDER(IORDER)=IORDER
            EORDER(IORDER)=SPENER(ISTATE+IREVER*NUMBSP(0,ICHARG),ICHARG)
            NSTATE(IORDER)=ISTATE
            NREVER(IORDER)=IREVER
C
         END DO
C
      END DO
C
      LDORDE=IORDER
C
      CALL ORDER1(EORDER,NORDER,LDORDE)
C
C=======================================================================
C         DETERMINING LABELS "SPORDE" IN THE CASE OF CONSERVED SIMPLEX
C=======================================================================
C
      IF (ISIMPY.EQ.1) THEN
C
C=======================================================================
C         CALCULATING THE NUMBERS OF OCCUPIED STATES
C         IN EVERY PARITY/TIME-REVERSAL BLOCK, AND
C         IN EVERY SIMPLEX BLOCK.
C=======================================================================
C
          NUPPRP=0
          NUPPRM=0
          NUPMRP=0
          NUPMRM=0
C
          NUSIMP=0
          NUSIMM=0
C
          DO IALLST=1,LDORDE
C
             ISTATE=NSTATE(NORDER(IALLST))
             IREVER=NREVER(NORDER(IALLST))
C
C=======================================================================
C        HERE THE PARITY/TIME-REVERSAL BLOCKS ARE CONSIDERED
C=======================================================================
C
             IF (ISIGNY.EQ.1) THEN
C
                 N_PPRP(IALLST)=0
                 N_PPRM(IALLST)=0
                 N_PMRP(IALLST)=0
                 N_PMRM(IALLST)=0
C
                 IF (SPPARI(ISTATE+IREVER*NUMBSP(0,ICHARG),ICHARG)
     *                                                     .GT.0.0) THEN
C
                     IF (IREVER.EQ.0) THEN
C
                         NUPPRP=NUPPRP+1
                         N_PPRP(IALLST)=NUPPRP
                     ELSE
                         NUPPRM=NUPPRM+1
                         N_PPRM(IALLST)=NUPPRM
C
                     END IF
C
                 ELSE
C
                     IF (IREVER.EQ.0) THEN
C
                         NUPMRP=NUPMRP+1
                         N_PMRP(IALLST)=NUPMRP
                     ELSE
                         NUPMRM=NUPMRM+1
                         N_PMRM(IALLST)=NUPMRM
C
                     END IF
C
                 END IF
C
             ELSE
C
C=======================================================================
C        HERE THE SIMPLEX BLOCKS ARE CONSIDERED
C=======================================================================
C
                 N_SIMP(IALLST)=0
                 N_SIMM(IALLST)=0
C
                 IF (IREVER.EQ.0) THEN
C
                     NUSIMP=NUSIMP+1
                     N_SIMP(IALLST)=NUSIMP
                 ELSE
                     NUSIMM=NUSIMM+1
                     N_SIMM(IALLST)=NUSIMM
C
                 END IF
C
             END IF
C
             IF (ISIGNY.EQ.1) THEN
C
C=======================================================================
C            PARITY/SIGNATURE CASE:
C                       THE MATRICES WITH CONFIGURATIONS ARE PUT INTO
C                       THE "SPORDE" LABELS WITH THE  (PARITY,IREVER)
C                       BLOCKS ORDERED AS: (+,+)  (+,-)  (-,-)  (-,+)
C=======================================================================
C
                 IF (MREVER.EQ.1) THEN
C
                     WRITE(SPORDE(ISTATE+IREVER*NUMBSP(0,ICHARG),ICHARG)
     *                                  ,'(''('',I2,3('','',I2),'')'')')
     *
     *                 N_PPRP(IALLST),N_PPRM(IALLST),
     *                 N_PMRM(IALLST),N_PMRP(IALLST)
C
                 ELSE
C
                     WRITE(SPORDE(ISTATE+IREVER*NUMBSP(0,ICHARG),ICHARG)
     *                               ,'(''('',I2,'' ----- '',I2,'')'')')
     *
     *                 N_PPRP(IALLST),N_PMRP(IALLST)
C
                 END IF
C
             ELSE
C
C=======================================================================
C            SIMPLEX CASE:
C                       THE MATRICES WITH CONFIGURATIONS ARE PUT INTO
C                       THE "SPORDE" LABELS WITH THE  (SIMPLEX)
C                       BLOCKS ORDERED AS: (+) (-)
C=======================================================================
C
                 IF (MREVER.EQ.1) THEN
C
                     WRITE(SPORDE(ISTATE+IREVER*NUMBSP(0,ICHARG),ICHARG)
     *                                 ,'(''  ('',I3,'','',I3,'')  '')')
     *
     *                     N_SIMP(IALLST),N_SIMM(IALLST)
C
                 ELSE
C
                     WRITE(SPORDE(ISTATE+IREVER*NUMBSP(0,ICHARG),ICHARG)
     *                                      ,'(''  ('',I3,'',---)  '')')
     *
     *                     N_SIMP(IALLST)
C
                 END IF
C
             END IF
C
          END DO
C
      ELSE
C
C=======================================================================
C         DETERMINING LABELS "SPORDE" FOR NON CONSERVED SIMPLEX
C=======================================================================
C
          IF (ISIQTY.EQ.1) THEN
C
C=======================================================================
C             HERE THE PARITY BLOCKS ARE CONSIDERED
C=======================================================================
C
              NUPARP=0
              NUPARM=0
C
              DO IALLST=1,LDORDE
C
                 ISTATE=NSTATE(NORDER(IALLST))
                 IREVER=NREVER(NORDER(IALLST))
C
                 N_SIQP(IALLST)=0
                 N_SIQM(IALLST)=0
C
                 IF (SPPARI(ISTATE+IREVER*NUMBSP(0,ICHARG),ICHARG)
     *                                                     .GT.0.0) THEN
C
                     NUPARP=NUPARP+1
                     N_SIQP(IALLST)=NUPARP
C
                 ELSE
C
                     NUPARM=NUPARM+1
                     N_SIQM(IALLST)=NUPARM
C
                 END IF
C
C=======================================================================
C                THE MATRICES WITH CONFIGURATIONS ARE PUT INTO
C                THE "SPORDE" LABELS WITH THE  (PARITY) BLOCKS
C                ORDERED AS: (+)  (-)
C=======================================================================
C
                 WRITE(SPORDE(ISTATE+IREVER*NUMBSP(0,ICHARG),ICHARG)
     *                             ,'(''  ('',I3,'','',I3,'')  '')')
     *
     *                 N_SIQP(IALLST),N_SIQM(IALLST)
C
              END DO
C
          ELSE
C
C=======================================================================
C             HERE THE NO-SYMMETRY CASE IS CONSIDERED
C=======================================================================
C
              DO IALLST=1,LDORDE
C
                 ISTATE=NSTATE(NORDER(IALLST))
                 IREVER=NREVER(NORDER(IALLST))
C
                 WRITE(SPORDE(ISTATE+IREVER*NUMBSP(0,ICHARG),ICHARG)
     *                                     ,'(F10.4,3X)')
     *
     *                 SPSIMP(ISTATE+IREVER*NUMBSP(0,ICHARG),ICHARG)
C
              END DO
C
          END IF
C
      END IF
C
C=======================================================================
C         PRINTING THE TABLE
C=======================================================================
C
      IF (EMINAL.LT.EMAXAL) THEN
C
          IF (ISIMPY.EQ.1) THEN
C
              WRITE(NFIPRI,'(79(1H*),/,          1H*,77X,1H*,/,
     *                 1H*,2X,''SINGLE-PARTICLE PROPERTIES: '',
     *                               A14,''                 '',
     *                                          5X,A8,3X,1H*,/,
     *                                           1H*,77X,1H*,/,
     *                                               79(1H*),/,
     *                                           1H*,77X,1H*,/,
     *                 1H*,2X,''NO)   ENERGY '',A13,
     *                        '' | N,'',A10,''>   <P> '',
     *                    3X,''<JY>    <SY>   GFACT'',3X,1H*,/,
     *                                          1H*,77X,1H*)')
     *
     *       SPMODL,NAMEPN,NAMSYM(ISIGNY),NAMLAB(NILXYZ)
C
          ELSE
C
              WRITE(NFIPRI,'(79(1H*),/,          1H*,77X,1H*,/,
     *                 1H*,2X,''SINGLE-PARTICLE PROPERTIES: '',
     *                               A14,''                 '',
     *                                          5X,A8,3X,1H*,/,
     *                                           1H*,77X,1H*,/,
     *                                               79(1H*),/,
     *                                           1H*,77X,1H*,/,
     *                 1H*,2X,''NO)   ENERGY '',A13,
     *                        '' | N,'',A10,''>   <P> '',
     *                    3X,''<JX>    <JY>    <JZ>'',3X,1H*,/,
     *                                          1H*,77X,1H*)')
     *
     *       SPMODL,NAMEPN,NAMSYM(ISIQTY+2),NAMLAB(NILXYZ)
C
          END IF
C
      END IF
C
C=======================================================================
C
      DO IALLST=1,LDORDE
C
         ISTATE=NSTATE(NORDER(IALLST))
         IREVER=NREVER(NORDER(IALLST))
C
         IF (SPENER(ISTATE+IREVER*NUMBSP(0,ICHARG),ICHARG).GT.EMINAL
     *                                                             .AND.
     *       SPENER(ISTATE+IREVER*NUMBSP(0,ICHARG),ICHARG).LT.EMAXAL)
     *                                                              THEN
C
             ALIAUX=SPALIG(ISTATE+IREVER*NUMBSP(0,ICHARG),ICHARG)
             PARITY=SPPARI(ISTATE+IREVER*NUMBSP(0,ICHARG),ICHARG)
C
             IF (ABS(ALIAUX).GE.1.0D-10) THEN
C
                 FACTOR=SPSPAL(ISTATE+IREVER*NUMBSP(0,ICHARG),ICHARG)
     *                                                           /ALIAUX
C
                 IF (ABS(FACTOR).GE.10.0D0)    THEN
                     WRITE(GFACTO,'(1PE7.0)') FACTOR
                 ELSE
                     WRITE(GFACTO,'(  F7.3)') FACTOR
                 END IF
C
             ELSE
                 GFACTO='  XXXXX'
             END IF
C
             IF (ISIMPY.EQ.1) THEN
C
                 WRITE(NFIPRI,'(1H*,I4,'')'',F9.3,1X,A13,1X,A15,I6,
     *                                             2F8.3,1X,A7,3X,1H*)')
     *
     *           IALLST,SPENER(ISTATE+IREVER*NUMBSP(0,ICHARG),ICHARG),
     *                  SPORDE(ISTATE+IREVER*NUMBSP(0,ICHARG),ICHARG),
     *                  SPNILS(ISTATE+IREVER*NUMBSP(0,ICHARG),ICHARG),
     *                  INT(SIGN(ABS(PARITY)*100+0.1,PARITY)),
     *                  SPALIG(ISTATE+IREVER*NUMBSP(0,ICHARG),ICHARG),
     *                  SPSPAL(ISTATE+IREVER*NUMBSP(0,ICHARG),ICHARG),
     *                  GFACTO
C
             ELSE
C
                 WRITE(NFIPRI,'(1H*,I4,'')'',F9.3,1X,A13,1X,A15,I6,
     *                                                   3F8.3,3X,1H*)')
     *
     *           IALLST,SPENER(ISTATE+IREVER*NUMBSP(0,ICHARG),ICHARG),
     *                  SPORDE(ISTATE+IREVER*NUMBSP(0,ICHARG),ICHARG),
     *                  SPNILS(ISTATE+IREVER*NUMBSP(0,ICHARG),ICHARG),
     *                  INT(SIGN(ABS(PARITY)*100+0.1,PARITY)),
     *                  SPXALI(ISTATE+IREVER*NUMBSP(0,ICHARG),ICHARG),
     *                  SPALIG(ISTATE+IREVER*NUMBSP(0,ICHARG),ICHARG),
     *                  SPZALI(ISTATE+IREVER*NUMBSP(0,ICHARG),ICHARG)
C
                 WRITE(NFIPRI,'(1H*,50X,3F8.3,3X,1H*)')
     *
     *                  SPXSPI(ISTATE+IREVER*NUMBSP(0,ICHARG),ICHARG),
     *                  SPSPAL(ISTATE+IREVER*NUMBSP(0,ICHARG),ICHARG),
     *                  SPZSPI(ISTATE+IREVER*NUMBSP(0,ICHARG),ICHARG)
C
             END IF
C
         END IF
C
      END DO
C
      IF (EMINAL.LT.EMAXAL) THEN
C
          WRITE(NFIPRI,'(1H*,77X,1H*,/,79(1H*),/)')
C
      END IF
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE SPTQUA(EMAXQU,ICHARG,NAMEPN,
     *                  ISIGNY,ISIMPY,ISIQTY,
     *           IDSIGB,IDSIMB,IDSIQB,IDSIZB,
     *                  IREQPB,INUQPB,JNUQPB)
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      CHARACTER
     *          NAMEPN*8,NAMSYM(1:4)*13,QPORDE*13
      CHARACTER
     *          QPLAST*17,BLOTYP*3
C
      DIMENSION
     *          EORDER(1:2*NDSTAT),NORDER(1:2*NDSTAT),
     *          NSTATE(1:2*NDSTAT),NREVER(1:2*NDSTAT),
     *          NPARIT(1:2*NDSTAT)
      DIMENSION
     *          N_PPRP(1:2*NDSTAT),N_PPRM(1:2*NDSTAT),
     *          N_PMRP(1:2*NDSTAT),N_PMRM(1:2*NDSTAT)
      DIMENSION
     *          N_SIMP(1:2*NDSTAT),N_SIMM(1:2*NDSTAT)
      DIMENSION
     *          N_PARP(1:2*NDSTAT),N_PARM(1:2*NDSTAT)
      DIMENSION
     *          QPORDE(1:2*NDSTAT,0:NDREVE)
C
      COMMON
     *       /XEQUIV/ EEQUIV(1:NDSTAT,0:NDREVE),
     *                DEQUIV(1:NDSTAT,0:NDREVE)
      COMMON
     *       /QUAPAR/ ENQUAP(1:NDSTAT,0:NDREVE),
     *                V2QUAP(1:NDSTAT,0:NDREVE)
      COMMON
     *       /PARIQU/ QPPARI(1:NDSTAT,0:NDREVE)
      COMMON
     *       /SIMPQU/ QPSIMP(1:NDSTAT,0:NDREVE)
      COMMON
     *       /CORPAR/ V_CORR(1:NDSTAT,0:NDREVE)
      COMMON
     *       /QPNUMS/ NUMBQP(0:NDREVE,0:NDISOS)
      COMMON
     *       /CFIPRI/ NFIPRI
C
      DATA
     *      NAMSYM / '(++,+-,-+,--)' , '  (S=+,S=-)  ' ,
     *               '  (P=+,P=-)  ' , '    SIMPLEX  ' /
C
C=======================================================================
C         THIS ROUTINE TABULATES THE SINGLE-QUASIPARTICLE RESULTS IN THE
C         FORM OF A COMMON TABLE FOR ALL SYMMETRIES
C=======================================================================
C
      NUMSYM=0
C
      IORDER=0
C
      DO IREVER=0,NDREVE
C
         DO ISTATE=1,NUMBQP(IREVER,ICHARG)
C
            IORDER=IORDER+1
            NORDER(IORDER)=IORDER
            EORDER(IORDER)=EEQUIV(ISTATE,IREVER)
            NSTATE(IORDER)=ISTATE
            NREVER(IORDER)=IREVER
C
            IF (QPPARI(ISTATE,IREVER).GT.0.0) THEN
C
                IPARIT=0
            ELSE
                IPARIT=1
C
            END IF
C
            NPARIT(IORDER)=IPARIT
C
         END DO
C
      END DO
C
      CALL ORDER1(EORDER,NORDER,IORDER)
C
C=======================================================================
C         CALCULATING THE NUMBERS OF OCCUPIED STATES
C         IN EVERY SIMPLEX BLOCK.
C=======================================================================
C
      NUPPRP=0
      NUPPRM=0
      NUPMRP=0
      NUPMRM=0
C
      NUSIMP=0
      NUSIMM=0
C
      NUPARP=0
      NUPARM=0
C
      NALLST=NUMBQP(0,ICHARG)+NUMBQP(1,ICHARG)
C
      DO IALLST=1,NALLST
C
         ISTATE=NSTATE(NORDER(IALLST))
         IREVER=NREVER(NORDER(IALLST))
         IPARIT=NPARIT(NORDER(IALLST))
C
C=======================================================================
C        HERE THE PARITY/TIME-REVERSAL BLOCKS ARE CONSIDERED
C=======================================================================
C
         IF (ISIMPY.EQ.1.AND.ISIGNY.EQ.1) THEN
C
             NUMSYM=1
C
             N_PPRP(IALLST)=0
             N_PPRM(IALLST)=0
             N_PMRP(IALLST)=0
             N_PMRM(IALLST)=0
C
             IF (ABS(IDSIGB).NE.1.OR.
     *          (ABS(IDSIGB).EQ.1.AND.(IREVER.NE.IREQPB.OR.
     *                            ISTATE.NE.INUQPB))) THEN
C
                 IF (IPARIT.EQ.0) THEN
C
                     IF (IREVER.EQ.0) THEN
C
                         NUPPRP=NUPPRP+1
                         N_PPRP(IALLST)=NUPPRP
                     ELSE
                         NUPPRM=NUPPRM+1
                         N_PPRM(IALLST)=NUPPRM
C
                     END IF
C
                 ELSE
C
                     IF (IREVER.EQ.0) THEN
C
                         NUPMRP=NUPMRP+1
                         N_PMRP(IALLST)=NUPMRP
                     ELSE
                         NUPMRM=NUPMRM+1
                         N_PMRM(IALLST)=NUPMRM
C
                     END IF
C
                 END IF
C
             END IF
C
C=======================================================================
C            PARITY/TIME-REVERSAL CASE:
C                       THE MATRICES WITH CONFIGURATIONS ARE PUT INTO
C                       THE "QPORDE" LABELS WITH THE  (PARITY,IREVER)
C                       BLOCKS ORDERED AS: (+,+)  (+,-)  (-,-)  (-,+)
C=======================================================================
C
             WRITE(QPORDE(ISTATE,IREVER),
     *                               '(''('',I2,3('','',I2),'')'')')
     *
     *             N_PPRP(IALLST),N_PPRM(IALLST),
     *             N_PMRM(IALLST),N_PMRP(IALLST)
C
             IF (IALLST.EQ.NALLST)
     *             WRITE(QPLAST,     '(''('',I3,3('','',I3),'')'')')
     *
     *             NUPPRP,NUPPRM,NUPMRM,NUPMRP
C
         END IF
C
C=======================================================================
C        HERE THE SIMPLEX BLOCKS ARE CONSIDERED
C=======================================================================
C
         IF (ISIMPY.EQ.1.AND.ISIGNY.NE.1) THEN
C
             NUMSYM=2
C
             N_SIMP(IALLST)=0
             N_SIMM(IALLST)=0
C
             IF (ABS(IDSIMB).NE.1.OR.
     *          (ABS(IDSIMB).EQ.1.AND.(IREVER.NE.IREQPB.OR.
     *                            ISTATE.NE.INUQPB))) THEN
C
                 IF (IREVER.EQ.0) THEN
C
                     NUSIMP=NUSIMP+1
                     N_SIMP(IALLST)=NUSIMP
                 ELSE
                     NUSIMM=NUSIMM+1
                     N_SIMM(IALLST)=NUSIMM
C
                 END IF
C
             END IF
C
C=======================================================================
C            SIMPLEX CASE:
C                       THE MATRICES WITH CONFIGURATIONS ARE PUT INTO
C                       THE "QPORDE" LABELS WITH THE  (SIMPLEX)
C                       BLOCKS ORDERED AS: (+) (-)
C=======================================================================
C
             WRITE(QPORDE(ISTATE,IREVER),
     *                                '(''  ('',I3,'','',I3,'')  '')')
     *
     *             N_SIMP(IALLST),N_SIMM(IALLST)
C
             IF (IALLST.EQ.NALLST)
     *             WRITE(QPLAST,      '('' ('',I4,'','',I4,'')     '')')
     *
     *             NUSIMP,NUSIMM
C
         END IF
C
C=======================================================================
C        HERE THE PARITY BLOCKS ARE CONSIDERED
C=======================================================================
C
         IF (ISIMPY.NE.1.AND.ISIQTY.EQ.1) THEN
C
             NUMSYM=3
C
             N_PARP(IALLST)=0
             N_PARM(IALLST)=0
C
             IF (IPARIT.EQ.0) THEN
C
                 NUPARP=NUPARP+1
                 N_PARP(IALLST)=NUPARP
             ELSE
                 NUPARM=NUPARM+1
                 N_PARM(IALLST)=NUPARM
C
             END IF
C
C=======================================================================
C            PARITY CASE:
C                       THE MATRICES WITH CONFIGURATIONS ARE PUT INTO
C                       THE "QPORDE" LABELS WITH THE  (PARITY)
C                       BLOCKS ORDERED AS: (+) (-)
C=======================================================================
C
             WRITE(QPORDE(ISTATE,IREVER),
     *                                '(''  ('',I3,'','',I3,'')  '')')
     *
     *             N_PARP(IALLST),N_PARM(IALLST)
C
             IF (IALLST.EQ.NALLST)
     *             WRITE(QPLAST,      '('' ('',I4,'','',I4,'')     '')')
     *
     *             NUPARP,NUPARM
C
         END IF
C
C=======================================================================
C        HERE THE NO-SYMMETRY CASE IS CONSIDERED
C=======================================================================
C
         IF (ISIMPY.NE.1.AND.ISIQTY.NE.1) THEN
C
             NUMSYM=4
C
             WRITE(QPORDE(ISTATE,IREVER),'(F11.5,2X)')
     *
     *             QPSIMP(ISTATE,IREVER)
C
             IF (IALLST.EQ.NALLST)
     *             WRITE(QPLAST,      '('' ('',I4,'','',I4,'')     '')')
     *
     *             NUMBQP(0,ICHARG),NUMBQP(1,ICHARG)
C
         END IF
C
      END DO
C
C=======================================================================
C         PRINTING THE TABLE
C=======================================================================
C
      IF (EMAXQU.GT.0.0D0) THEN
C
          WRITE(NFIPRI,'(79(1H*),/,              1H*,77X,1H*,/,
     *                 1H*,2X,''SINGLE-QUASIPARTICLE PROPERTIES: '',
     *                                        ''                 '',
     *                                         14X,A8,3X,1H*,/,
     *                                           1H*,77X,1H*,/,
     *                                               79(1H*),/,
     *                                           1H*,77X,1H*,/,
     *                 1H*,2X,''NO)   ENERGY '',A13,3X,
     *                                            ''  PARITY '',
     *                              ''  V2QUAP '',''  EEQUIV '',
     *                              ''  DEQUIV '',''  V_CORR '',
     *                                                1X,1H*,/,
     *                                           1H*,77X,1H*)')
     *
     *   NAMEPN,NAMSYM(NUMSYM)
C
      END IF
C
C=======================================================================
C
      DO IALLST=1,NALLST
C
         ISTATE=NSTATE(NORDER(IALLST))
         IREVER=NREVER(NORDER(IALLST))
         IPARIT=NPARIT(NORDER(IALLST))
C
         IF (ENQUAP(ISTATE,IREVER).LT.EMAXQU) THEN
C
             IF ((ABS(IDSIGB).EQ.1.OR.ABS(IDSIMB).EQ.1.OR.
     *            ABS(IDSIQB).EQ.1.OR.ABS(IDSIZB).EQ.1).AND.
     *           IREVER.EQ.IREQPB.AND.ISTATE.EQ.INUQPB) THEN
C
                 BLOTYP='BLO'
	     ELSE
                 IF ((ABS(IDSIGB).EQ.1.OR.ABS(IDSIMB).EQ.1.OR.
     *                ABS(IDSIQB).EQ.1.OR.ABS(IDSIZB).EQ.1).AND.
     *               IREVER.NE.IREQPB.AND.ISTATE.EQ.JNUQPB.AND.
     *               (ABS(IDSIQB).NE.1.AND.ABS(IDSIZB).NE.1)) THEN
C
                     BLOTYP='ADD'
                 ELSE
                     BLOTYP='   '
C
                 END IF
C
             END IF
C
             WRITE(NFIPRI,'(1H*,I4,'')'',1X,F8.3,1X,A13,1X,A3,1X,
     *                                F6.3,F9.5,2F9.3,F9.5,2X,1H*)')
     *
     *       IALLST,ENQUAP(ISTATE,IREVER),
     *              QPORDE(ISTATE,IREVER),
     *              BLOTYP,
     *              QPPARI(ISTATE,IREVER),
     *              V2QUAP(ISTATE,IREVER),
     *              EEQUIV(ISTATE,IREVER),
     *              DEQUIV(ISTATE,IREVER),
     *              V_CORR(ISTATE,IREVER)
C
         END IF
C
         IF (IALLST.EQ.NALLST.AND.EMAXQU.GT.0.0D0) THEN
C
             WRITE(NFIPRI,'(1H*,77X,1H*,/,1H*,I4,'')'',
     *                 1X,''  TOTAL='',1X,A17,1X,44X,1H*)')
     *
     *       IALLST,QPLAST
C
         END IF
C
      END DO
C
      IF (EMAXQU.GT.0.0D0) THEN
C
          WRITE(NFIPRI,'(1H*,77X,1H*,/,79(1H*),/)')
C
      END IF
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE AVPARI(MREVER,ICHARG)
C=======================================================================
      USE ALLWAV
C=======================================================================
      USE hfodd_sizes
C=======================================================================
C
      COMMON
     *       /SPLEVS/ SPENER(1:2*NDSTAT,0:NDISOS),
     *                SPOCCU(1:2*NDSTAT,0:NDISOS),
     *                SPALIG(1:2*NDSTAT,0:NDISOS),
     *                SPSPAL(1:2*NDSTAT,0:NDISOS),
     *                SPPARI(1:2*NDSTAT,0:NDISOS),
     *                SPSIMP(1:2*NDSTAT,0:NDISOS)
      COMMON
     *       /BASISO/ NXVECT(1:NDBASE),NYVECT(1:NDBASE),NZVECT(1:NDBASE)
      COMMON
     *       /SPNUMS/ NUMBSP(0:NDREVE,0:NDISOS)
      COMMON
     *       /DIMENS/ LDBASE
C
C=======================================================================
C
      CALL CPUTIM('AVPARI',1)
C
C=======================================================================
C     THIS ROUTINE CALCULATES AVERAGE PARITY OF SINGLE PARTICLE STATES
C=======================================================================
C
      LSTATE=NUMBSP(0,ICHARG)+MREVER*NUMBSP(1,ICHARG)
C
      DO ISTATE=1,LSTATE
C
         SPPARI(ISTATE,ICHARG)=0.0D0
C
      END DO
C
      DO IBASE=1,LDBASE
C
         IPARI=1-2*MOD(NXVECT(IBASE)+NYVECT(IBASE)+NZVECT(IBASE),2)
C
         DO ISTATE=1,LSTATE
C
            SPPARI(ISTATE,ICHARG)=SPPARI(ISTATE,ICHARG)+IPARI
     *                *REAL(WAVOCC(IBASE,ISTATE,0)
     *               *CONJG(WAVOCC(IBASE,ISTATE,0))
     *                     +WAVOCC(IBASE,ISTATE,1)
     *               *CONJG(WAVOCC(IBASE,ISTATE,1)))
C
         END DO
C
      END DO
C
C=======================================================================
C
      CALL CPUTIM('AVPARI',0)
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE AVSIMP(MREVER,ICHARG)
C=======================================================================
      USE ALLWAV
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      COMMON
     *       /SPLEVS/ SPENER(1:2*NDSTAT,0:NDISOS),
     *                SPOCCU(1:2*NDSTAT,0:NDISOS),
     *                SPALIG(1:2*NDSTAT,0:NDISOS),
     *                SPSPAL(1:2*NDSTAT,0:NDISOS),
     *                SPPARI(1:2*NDSTAT,0:NDISOS),
     *                SPSIMP(1:2*NDSTAT,0:NDISOS)
      COMMON
     *       /SPNUMS/ NUMBSP(0:NDREVE,0:NDISOS)
      COMMON
     *       /DIMENS/ LDBASE
C
C=======================================================================
C
      CALL CPUTIM('AVSIMP',1)
C
C=======================================================================
C     THIS ROUTINE CALCULATES AVERAGE SIMPLEX OF SINGLE-PARTICLE STATES
C=======================================================================
C
      LSTATE=NUMBSP(0,ICHARG)+MREVER*NUMBSP(1,ICHARG)
C
      DO ISTATE=1,LSTATE
C
         SPSIMP(ISTATE,ICHARG)=0.0D0
C
         DO IBASE=1,LDBASE
C
            SPSIMP(ISTATE,ICHARG)=SPSIMP(ISTATE,ICHARG)
     *                +REAL(WAVOCC(IBASE,ISTATE,0)
     *               *CONJG(WAVOCC(IBASE,ISTATE,0))
     *                     -WAVOCC(IBASE,ISTATE,1)
     *               *CONJG(WAVOCC(IBASE,ISTATE,1)))
C
         END DO
C
      END DO
C
C=======================================================================
C
      CALL CPUTIM('AVSIMP',0)
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE INTEGH(NXHERM,NYHERM,NZHERM,NXMAXX,NYMAXX,NZMAXX,
     *                                IMOVAX,ITILAX,ITISAX,NO_ORB,
     *                         IPNMIX,ITPNMX,IROTAT,ICHARG,ISIMPY,
     *                                       IPOTHO,ISCHIF,IOCONT,
     *                                              NMUCON,NSICON,
     *                                              I_YUKA,I_GOGA,
     *                                              JETACM,ALINLI,
     *                                              KETA_R,AROTLI,
     *                                              ICOUDI,ICOUEX,
     *                                              LIPKIN,LIPKIP,
     *                                              EFER2N,EFER2P,
     *                                                     IF_RPA)
C=======================================================================
      USE HCOULO
      USE COUSTO
      USE YUKSTO
      USE GOGSTO
      USE ALISTO
      USE MAT_PP
      USE MAT_PM
      USE MAD_PP
      USE MAD_PM
      USE MAP_PM
      USE VE_FLD
      USE hfodd_fission
C=======================================================================
      USE hfodd_sizes
C=======================================================================
C
      COMPLEX
     *          PHACOM
      COMPLEX
     *          C_ZERO,UNIT_I
      COMPLEX
     *          VONBAS(0:ND2MAX,0:ND2MAX,0:ND2MAX,1:NDKART),
     *          SONBAS(0:ND2MAX,0:ND2MAX,0:ND2MAX)
      COMPLEX
     *          HCOMPP,HCOMPM
C
      DIMENSION
     *          ALINLI(0:NDKART),AROTLI(0:NDKART)
C=======================================================================
      ALLOCATABLE HAUXPP(:,:)
      ALLOCATABLE HAUXPM(:,:)
      ALLOCATABLE HCOMPP(:,:)
      ALLOCATABLE HCOMPM(:,:)
C=======================================================================
      COMMON
     *       /T_PHAS/ IPHAPP(0:NDYMAX,0:NDYMAX,0:NDKART),
     *                IPHAPM(0:NDYMAX,0:NDYMAX,0:NDKART),
     *                IPHAMP(0:NDYMAX,0:NDYMAX,0:NDKART),
     *                IPHAMM(0:NDYMAX,0:NDYMAX,0:NDKART)
      COMMON
     *       /COMPHA/ PHACOM(0:NDKART)
      COMMON
     *       /BASISO/ NXVECT(1:NDBASE),NYVECT(1:NDBASE),NZVECT(1:NDBASE)
      COMMON
     *       /HERSTO/ HERMTS(0:ND2MAX,1:NDGAUS,1:NDKART)
      COMMON
     *       /INTSTO/ FOURWG(1:NDGAUS,1:NDKART),
     *                FOURPT(1:NDGAUS,1:NDKART)
      COMMON
     *       /BASPAR/ HBAROX,HBAROY,HBAROZ
     *       /SCALNG/ HOMSCA(NDKART)
      COMMON
     *       /ANGANG/ ANGU_N(1:NDKART),ANGU_P(1:NDKART),ANGU_T(1:NDKART)
      COMMON
     *       /OMOVAS/ OMOVAX,OMOVAY,OMOVAZ
      COMMON
     *       /OMISOS/ OMISOX,OMISOY,OMISOZ
      COMMON
     *       /ICNSTR/ STIFFI(1:NDKART),
     *                ASKEDI(1:NDKART),
     *                IFLAGI(1:NDKART)
      COMMON
     *       /ACNSTR/ STIFFA,ASKEDA,IFLAGA
      COMMON
     *       /PLANCK/ HBMASS,HBMRPA,HBMINP
      COMMON
     *       /CHARGE/ ECHAR2
      COMMON
     *       /RENORM/ HBMREN(NDKART)
      COMMON
     *       /RENROT/ ROTREN(NDKART)
      COMMON
     *       /ITERTS/ ITESTA,ITESTO,NOITER,NUMITE
      COMMON
     *       /DIMENS/ LDBASE
C@@@ NECK - NECK - NECK - NECK - NECK - NECK - NECK - NECK - NECK
      COMMON
     *       /NCKVAL/ Q0NECK,G_NECK
     *       /NCKFLA/ IFNECK
C@@@ NECK - NECK - NECK - NECK - NECK - NECK - NECK - NECK - NECK
C
C=======================================================================
C
      CALL CPUTIM('INTEGH',1)
C
C=======================================================================
C
      IALLOC=0
C
C=======================================================================
      ALLOCATE (HAUXPP(1:NDBASE,1:NDBASE),STAT=IALLOC)
      IF (IALLOC.NE.0) CALL NOALLO('HAUXPP','INTEGH')
      ALLOCATE (HAUXPM(1:NDBASE,1:NDBASE),STAT=IALLOC)
      IF (IALLOC.NE.0) CALL NOALLO('HAUXPM','INTEGH')
C=======================================================================
      ALLOCATE (HCOMPP(1:NDBASE,1:NDBASE),STAT=IALLOC)
      IF (IALLOC.NE.0) CALL NOALLO('HCOMPP','INTEGH')
      ALLOCATE (HCOMPM(1:NDBASE,1:NDBASE),STAT=IALLOC)
      IF (IALLOC.NE.0) CALL NOALLO('HCOMPM','INTEGH')
C=======================================================================
      IF (.NOT.ALLOCATED(BIG_PP)) THEN
          ALLOCATE (BIG_PP(1:NDBASE,1:NDBASE,0:NDREVE),STAT=IALLOC)
          IF (IALLOC.NE.0) CALL NOALLO('BIG_PP','INTEGH')
      END IF
C=======================================================================
      IF (.NOT.ALLOCATED(BIG_PM).AND.ISIMPY.NE.1) THEN
          ALLOCATE (BIG_PM(1:NDBASE,1:NDBASE,0:NDREVE),STAT=IALLOC)
          IF (IALLOC.NE.0) CALL NOALLO('BIG_PM','INTEGH')
      END IF
C=======================================================================
C
C=======================================================================
C          THIS SUBROUTINE CALCULATES MATRIX ELEMENTS OF THE  MEAN-FIELD
C                       S K Y R M E   H A M I L T O N I A N
C=======================================================================
C         PREPARE THE INPUT DATA
C=======================================================================
C
      IF (ITPNMX.EQ.0) THEN
C
          LIPKIX=LIPKIN
          EFER2X=EFER2N
C
      ENDIF
C
      IF (ITPNMX.EQ.1) THEN
C
          LIPKIX=LIPKIP
          EFER2X=EFER2P
C
      ENDIF
C
C=======================================================================
C
      C_ZERO=CMPLX(0.0D0,0.0D0)
      UNIT_I=CMPLX(0.0D0,1.0D0)
C
C=======================================================================
C          FROM VERSION (2.50Y), WE DO NOT ANYMORE SPLIT THE S.P. MATRIX
C          ELEMENTS (ME'S) INTO TIME-EVEN AND TIME-ODD PARTS  AND  LATER
C          RECOMBINE THEM INTO THE  TIME-UP  AND  TIME-DOWN  BLOCKS, BUT
C          INSTEAD WE PUT THEM DIRECTLY INTO THE TIME-UP  AND  TIME-DOWN
C          BLOCKS.
C          THE ME'S ARE FIRST CALCULATED IN THE TIME-UP-UP BLOCK AND PUT
C          INTO ARRAY BIG_PP(,,0), AND IN THE TIME-UP-DOWN BLOCK AND PUT
C          INTO ARRAY BIG_PM(,,0).
C          THEN, THEY ARE PUT INTO THE TIME-INVERTED BLOCKS  AND  STORED
C          IN ARRAYS BIG_PP(,,1) AND  BIG_PM(,,1),  WITH  THE  FOLLOWING
C          FACTORS:
C
C          FOR THE BIG_PP(,,1) ARRAY:
C             FOR TIME-EVEN REAL AND TIME-ODD IMAGINARY ME'S - FACTOR +1
C             FOR TIME-EVEN IMAGINARY AND TIME-ODD REAL ME'S - FACTOR -1
C
C          FOR THE BIG_PM(,,1) ARRAY:
C             FOR TIME-EVEN REAL AND TIME-ODD IMAGINARY ME'S - FACTOR -1
C             FOR TIME-EVEN IMAGINARY AND TIME-ODD REAL ME'S - FACTOR +1
C
C          FOR THE S.P. ME'S CORRESPONDING TO THE NON-DIAGONAL MANY-BODY
C          ME'S, THE FIELD FORM-FACTORS ARE NOT ANYMORE  REAL.  HOWEVER,
C          THEIR IMAGINARY PARTS SIMULTANEOUSLY CHANGE THE STATUS OF
C          THEIR S.P. ME'S IN THE FOLLOWING WAY:
C
C             REAL <--> IMAGINARY TOGETHER  WITH TIME-EVEN <--> TIME-ODD
C
C          THEREFORE, THE ABOVE FACTORS STAY THE SAME, AND THE SAME CODE
C          CAN BE USED FOR THE DIAGONAL AND NON-DIAGONAL MANY-BODY ME'S.
C
C=======================================================================
C
      BIG_PP(:,:,:)=C_ZERO
      IF (ISIMPY.NE.1) THEN
          BIG_PM(:,:,:)=C_ZERO
      END IF
C
C=======================================================================
C          INSERTING THE CRANKING MATRIX ELEMENTS
C=======================================================================
C
      OMEGAT=OMOVAX**2+OMOVAY**2+OMOVAZ**2
C
      OMEGAJ=OMOVAX*ANGU_T(1)+
     *       OMOVAY*ANGU_T(2)+
     *       OMOVAZ*ANGU_T(3)
C
      IF (IMOVAX.NE.0.AND.(IOCONT.EQ.1.OR.NUMITE.NE.ITESTA)) THEN
C
          OMETOT=SQRT(OMOVAX   **2+OMOVAY   **2+OMOVAZ   **2)
          ANGTOT=SQRT(ANGU_T(1)**2+ANGU_T(2)**2+ANGU_T(3)**2)
C
          OMOVAX=IMOVAX*ANGU_T(1)*OMETOT/ANGTOT
          OMOVAY=IMOVAX*ANGU_T(2)*OMETOT/ANGTOT
          OMOVAZ=IMOVAX*ANGU_T(3)*OMETOT/ANGTOT
C
      END IF
C
      IF (ITILAX   .EQ.0.AND.ITISAX   .EQ.0.AND.
     *    IFLAGI(1).EQ.0.AND.IFLAGI(3).EQ.0) GO TO 2
C
      IF (ISIMPY.EQ.1) GO TO 2
C
C=======================================================================
C          X-DIRECTION
C=======================================================================
C
      OMEGAC=0.0D0
      IF (ITILAX   .NE.0) OMEGAC=OMEGAC+             OMOVAX
      IF (ITISAX   .NE.0) OMEGAC=OMEGAC+(1-2*ICHARG)*OMISOX
      IF (IFLAGI(1).NE.0) OMEGAC=OMEGAC
     *                          -2*STIFFI(1)*(ANGU_T(1)-ASKEDI(1))
      IF (IFLAGA   .NE.0) OMEGAC=OMEGAC
     *                          -2*STIFFA   *(ANGU_T(1)*OMEGAT
     *                                       -OMOVAX   *OMEGAJ)/OMEGAT
C
      IF (NO_ORB.NE.1) THEN
C
          CALL INT_LX(NXMAXX,NYMAXX,NZMAXX,IPHAPM(0,0,0),HAUXPM,OMEGAC)
C
          BIG_PM(1:NDBASE,1:NDBASE,0)=BIG_PM(1:NDBASE,1:NDBASE,0)
     *                        -UNIT_I*HAUXPM(1:NDBASE,1:NDBASE)
          BIG_PM(1:NDBASE,1:NDBASE,1)=BIG_PM(1:NDBASE,1:NDBASE,1)
     *                        +UNIT_I*HAUXPM(1:NDBASE,1:NDBASE)
C
      END IF
C
      CALL INT_SX(NXMAXX,NYMAXX,NZMAXX,HAUXPM,OMEGAC)
C
      BIG_PM(1:NDBASE,1:NDBASE,0)=BIG_PM(1:NDBASE,1:NDBASE,0)
     *                           -HAUXPM(1:NDBASE,1:NDBASE)
      BIG_PM(1:NDBASE,1:NDBASE,1)=BIG_PM(1:NDBASE,1:NDBASE,1)
     *                           -HAUXPM(1:NDBASE,1:NDBASE)
C
C=======================================================================
C          Z-DIRECTION
C=======================================================================
C
      OMEGAC=0.0D0
      IF (ITILAX   .NE.0) OMEGAC=OMEGAC+             OMOVAZ
      IF (ITISAX   .NE.0) OMEGAC=OMEGAC+(1-2*ICHARG)*OMISOZ
      IF (IFLAGI(3).NE.0) OMEGAC=OMEGAC
     *                          -2*STIFFI(3)*(ANGU_T(3)-ASKEDI(3))
      IF (IFLAGA   .NE.0) OMEGAC=OMEGAC
     *                          -2*STIFFA   *(ANGU_T(3)*OMEGAT
     *                                       -OMOVAZ   *OMEGAJ)/OMEGAT
C
      IF (NO_ORB.NE.1) THEN
C
          CALL INT_LZ(NXMAXX,NYMAXX,NZMAXX,IPHAPM(0,0,0),HAUXPM,OMEGAC)
C
          BIG_PM(1:NDBASE,1:NDBASE,0)=BIG_PM(1:NDBASE,1:NDBASE,0)
     *                        -UNIT_I*HAUXPM(1:NDBASE,1:NDBASE)
          BIG_PM(1:NDBASE,1:NDBASE,1)=BIG_PM(1:NDBASE,1:NDBASE,1)
     *                        +UNIT_I*HAUXPM(1:NDBASE,1:NDBASE)
C
      END IF
C
      CALL INT_SZ(NXMAXX,NYMAXX,NZMAXX,HAUXPM,OMEGAC)
C
      BIG_PM(1:NDBASE,1:NDBASE,0)=BIG_PM(1:NDBASE,1:NDBASE,0)
     *                    -UNIT_I*HAUXPM(1:NDBASE,1:NDBASE)
      BIG_PM(1:NDBASE,1:NDBASE,1)=BIG_PM(1:NDBASE,1:NDBASE,1)
     *                    +UNIT_I*HAUXPM(1:NDBASE,1:NDBASE)
C
C=======================================================================
C
    2 CONTINUE
C
C=======================================================================
C          Y-DIRECTION
C=======================================================================
C
      OMEGAC=OMOVAY+(1-2*ICHARG)*OMISOY
      IF (IFLAGI(2).NE.0) OMEGAC=OMEGAC
     *                          -2*STIFFI(2)*(ANGU_T(2)-ASKEDI(2))
      IF (IFLAGA   .NE.0) OMEGAC=OMEGAC
     *                          -2*STIFFA   *(ANGU_T(2)*OMEGAT
     *                                       -OMOVAY   *OMEGAJ)/OMEGAT
C
      IF (NO_ORB.NE.1) THEN
C
          CALL INT_LY(NXMAXX,NYMAXX,NZMAXX,IPHAPP(0,0,0),HAUXPP,OMEGAC)
C
          BIG_PP(1:NDBASE,1:NDBASE,0)=BIG_PP(1:NDBASE,1:NDBASE,0)
     *                        -UNIT_I*HAUXPP(1:NDBASE,1:NDBASE)
          BIG_PP(1:NDBASE,1:NDBASE,1)=BIG_PP(1:NDBASE,1:NDBASE,1)
     *                        -UNIT_I*HAUXPP(1:NDBASE,1:NDBASE)
C
      END IF
C
      CALL INT_SY(NXMAXX,NYMAXX,NZMAXX,HAUXPP,OMEGAC)
C
      BIG_PP(1:NDBASE,1:NDBASE,0)=BIG_PP(1:NDBASE,1:NDBASE,0)
     *                           -HAUXPP(1:NDBASE,1:NDBASE)
      BIG_PP(1:NDBASE,1:NDBASE,1)=BIG_PP(1:NDBASE,1:NDBASE,1)
     *                           +HAUXPP(1:NDBASE,1:NDBASE)
C
C=======================================================================
C          CALCULATING THE BARE-MASS KINETIC ENERGY MATRIX ELEMENTS
C=======================================================================
C
      CALL INTKIN(HAUXPP,HBMRPA)
C
      BIG_PP(1:NDBASE,1:NDBASE,0)=BIG_PP(1:NDBASE,1:NDBASE,0)
     *                           +HAUXPP(1:NDBASE,1:NDBASE)
      BIG_PP(1:NDBASE,1:NDBASE,1)=BIG_PP(1:NDBASE,1:NDBASE,1)
     *                           +HAUXPP(1:NDBASE,1:NDBASE)
C
C=======================================================================
C          INTRODUCING THE CONSTRAINTS ON MULTIPOLE MOMENTS
C=======================================================================
C
      CALL INTCON(ISIMPY,ICHARG,ISCHIF,NMUCON,NSICON,HAUXPP,HAUXPM,
     *                                                      IF_RPA)
C
      BIG_PP(1:NDBASE,1:NDBASE,0)=BIG_PP(1:NDBASE,1:NDBASE,0)
     *                           +HAUXPP(1:NDBASE,1:NDBASE)
      BIG_PP(1:NDBASE,1:NDBASE,1)=BIG_PP(1:NDBASE,1:NDBASE,1)
     *                           +HAUXPP(1:NDBASE,1:NDBASE)
C
      IF (ISIMPY.NE.1) THEN
C
          BIG_PM(1:NDBASE,1:NDBASE,0)=BIG_PM(1:NDBASE,1:NDBASE,0)
     *                               +HAUXPM(1:NDBASE,1:NDBASE)
          BIG_PM(1:NDBASE,1:NDBASE,1)=BIG_PM(1:NDBASE,1:NDBASE,1)
     *                               -HAUXPM(1:NDBASE,1:NDBASE)
      END IF
C
C@@@ NECK - NECK - NECK - NECK - NECK - NECK - NECK - NECK - NECK
C=======================================================================
C          INTRODUCING THE CONSTRAINTS ON THE NECK
C=======================================================================
C
      IF (IFNECK.EQ.2.AND.IF_RPA.EQ.1) THEN
C
          CALL INT_QN(NZMAXX,HAUXPP)
C
          BIG_PP(:,:,0)=BIG_PP(:,:,0)-G_NECK*HAUXPP(:,:)
          BIG_PP(:,:,1)=BIG_PP(:,:,1)-G_NECK*HAUXPP(:,:)
C
      END IF
C
C@@@ NECK - NECK - NECK - NECK - NECK - NECK - NECK - NECK - NECK
C=======================================================================
C          INSERTING THE MATRIX ELEMENTS OF THE HO POTENTIAL
C=======================================================================
C
      IF (IPOTHO.EQ.1) THEN
C
          ESCALE=0.0D0
C
          CALL INT_HO(HAUXPP,HBMASS,ESCALE,HBAROX,HBAROY,HBAROZ)
C
          BIG_PP(1:NDBASE,1:NDBASE,0)=BIG_PP(1:NDBASE,1:NDBASE,0)
     *                               +HAUXPP(1:NDBASE,1:NDBASE)
          BIG_PP(1:NDBASE,1:NDBASE,1)=BIG_PP(1:NDBASE,1:NDBASE,1)
     *                               +HAUXPP(1:NDBASE,1:NDBASE)
C
      END IF
C
C=======================================================================
C          INSERTING THE COULOMB MATRIX ELEMENTS, WHICH ARE SUPPOSED
C          TO BE ALREADY CALCULATED BEFORE
C=======================================================================
C
      IF (ICHARG.EQ.1.AND.ICOUDI.EQ.1) THEN
C
          BIG_PP(1:NDBASE,1:NDBASE,0)=BIG_PP(1:NDBASE,1:NDBASE,0)
     *                               +HPPCOU(1:NDBASE,1:NDBASE)
          BIG_PP(1:NDBASE,1:NDBASE,1)=BIG_PP(1:NDBASE,1:NDBASE,1)
     *                               +HPPCOU(1:NDBASE,1:NDBASE)
C
          IF (ISIMPY.NE.1) THEN
C
              BIG_PM(1:NDBASE,1:NDBASE,0)=BIG_PM(1:NDBASE,1:NDBASE,0)
     *                                   +HPMCOU(1:NDBASE,1:NDBASE)
              BIG_PM(1:NDBASE,1:NDBASE,1)=BIG_PM(1:NDBASE,1:NDBASE,1)
     *                                   -HPMCOU(1:NDBASE,1:NDBASE)
          END IF
C
      END IF
C
C=======================================================================
C          INSERTING THE LINEAR-MOMENTUM-SQUARED DIRECT MATRIX  ELEMENTS
C=======================================================================
C
      IF (JETACM.EQ.2) THEN
C
          CALL INTPX2(NXMAXX,NYMAXX,NZMAXX,IPHAPP(0,0,0),HAUXPP,
     *                                                   HBMREN(1))
          BIG_PP(1:NDBASE,1:NDBASE,0)=BIG_PP(1:NDBASE,1:NDBASE,0)
     *                               +HAUXPP(1:NDBASE,1:NDBASE)
          BIG_PP(1:NDBASE,1:NDBASE,1)=BIG_PP(1:NDBASE,1:NDBASE,1)
     *                               +HAUXPP(1:NDBASE,1:NDBASE)
C
          CALL INTPY2(NXMAXX,NYMAXX,NZMAXX,IPHAPP(0,0,0),HAUXPP,
     *                                                   HBMREN(2))
          BIG_PP(1:NDBASE,1:NDBASE,0)=BIG_PP(1:NDBASE,1:NDBASE,0)
     *                               +HAUXPP(1:NDBASE,1:NDBASE)
          BIG_PP(1:NDBASE,1:NDBASE,1)=BIG_PP(1:NDBASE,1:NDBASE,1)
     *                               +HAUXPP(1:NDBASE,1:NDBASE)
C
          CALL INTPZ2(NXMAXX,NYMAXX,NZMAXX,IPHAPP(0,0,0),HAUXPP,
     *                                                   HBMREN(3))
          BIG_PP(1:NDBASE,1:NDBASE,0)=BIG_PP(1:NDBASE,1:NDBASE,0)
     *                               +HAUXPP(1:NDBASE,1:NDBASE)
          BIG_PP(1:NDBASE,1:NDBASE,1)=BIG_PP(1:NDBASE,1:NDBASE,1)
     *                               +HAUXPP(1:NDBASE,1:NDBASE)
C
      END IF
C
C=======================================================================
C          CALCULATING EFFECTIVE-MASS TERM MATRIX ELEMENTS
C=======================================================================
C
      NDEGRE=2
C
      CALL BEGINC(VE_MAS(1,1,1,ITPNMX),SONBAS,NDEGRE,
     *            NXHERM,NYHERM,NZHERM,HERMTS,FOURWG,
     *            NXMAXX,NYMAXX,NZMAXX)
C
      KARTEZ=0
C
      CALL INTMAS(NXMAXX,NYMAXX,NZMAXX,SONBAS,
     *            KARTEZ,ISIMPY,HCOMPP,HCOMPM)
C
      BIG_PP(1:NDBASE,1:NDBASE,0)=BIG_PP(1:NDBASE,1:NDBASE,0)
     *                           +HCOMPP(1:NDBASE,1:NDBASE)
      BIG_PP(1:NDBASE,1:NDBASE,1)=BIG_PP(1:NDBASE,1:NDBASE,1)
     *                           +HCOMPP(1:NDBASE,1:NDBASE)
C
      IF (ISIMPY.NE.1) THEN
C
          BIG_PM(1:NDBASE,1:NDBASE,0)=BIG_PM(1:NDBASE,1:NDBASE,0)
     *                               +HCOMPM(1:NDBASE,1:NDBASE)
          BIG_PM(1:NDBASE,1:NDBASE,1)=BIG_PM(1:NDBASE,1:NDBASE,1)
     *                               -HCOMPM(1:NDBASE,1:NDBASE)
      END IF
C
C=======================================================================
C          CALCULATING  CENTRAL-TERM  MATRIX ELEMENTS
C=======================================================================
C
      NDEGRE=0
C
      CALL BEGINC(VE_CEN(1,1,1,ITPNMX),SONBAS,NDEGRE,
     *            NXHERM,NYHERM,NZHERM,HERMTS,FOURWG,
     *            NXMAXX,NYMAXX,NZMAXX)
C
      KARTEZ=0
C
      CALL INTCEN(NXMAXX,NYMAXX,NZMAXX,SONBAS,
     *            KARTEZ,ISIMPY,HCOMPP,HCOMPM)
C
      BIG_PP(1:NDBASE,1:NDBASE,0)=BIG_PP(1:NDBASE,1:NDBASE,0)
     *                           +HCOMPP(1:NDBASE,1:NDBASE)
      BIG_PP(1:NDBASE,1:NDBASE,1)=BIG_PP(1:NDBASE,1:NDBASE,1)
     *                           +HCOMPP(1:NDBASE,1:NDBASE)
C
      IF (ISIMPY.NE.1) THEN
C
          BIG_PM(1:NDBASE,1:NDBASE,0)=BIG_PM(1:NDBASE,1:NDBASE,0)
     *                               +HCOMPM(1:NDBASE,1:NDBASE)
          BIG_PM(1:NDBASE,1:NDBASE,1)=BIG_PM(1:NDBASE,1:NDBASE,1)
     *                               -HCOMPM(1:NDBASE,1:NDBASE)
      END IF
C
C=======================================================================
C          CALCULATING  SPIN-ORBIT TERM MATRIX ELEMENTS
C=======================================================================
C
      NDEGRE=1
C
      DO K=1,NDKART
C
         DO L=1,NDKART
C
            CALL BEGINC(VE_SOR(1,1,1,L,K,ITPNMX),VONBAS(0,0,0,L),
     *                  NDEGRE,NXHERM,NYHERM,NZHERM,HERMTS,FOURWG,
     *                  NXMAXX,NYMAXX,NZMAXX)
C
         END DO
C
         KARTEZ=K
C
         CALL INTSOR(NXMAXX,NYMAXX,NZMAXX,VONBAS,
     *               KARTEZ,ISIMPY,HCOMPP,HCOMPM)
C
         IF (K.EQ.1)
     *       BIG_PP(1:NDBASE,1:NDBASE,0)=BIG_PP(1:NDBASE,1:NDBASE,0)
     *                           -UNIT_I*HCOMPP(1:NDBASE,1:NDBASE)
         IF (K.EQ.2)
     *       BIG_PP(1:NDBASE,1:NDBASE,0)=BIG_PP(1:NDBASE,1:NDBASE,0)
     *                           -UNIT_I*HCOMPP(1:NDBASE,1:NDBASE)
         IF (K.EQ.3)
     *       BIG_PP(1:NDBASE,1:NDBASE,0)=BIG_PP(1:NDBASE,1:NDBASE,0)
     *                                  +HCOMPP(1:NDBASE,1:NDBASE)
C
         IF (K.EQ.1)
     *       BIG_PP(1:NDBASE,1:NDBASE,1)=BIG_PP(1:NDBASE,1:NDBASE,1)
     *                           +UNIT_I*HCOMPP(1:NDBASE,1:NDBASE)
         IF (K.EQ.2)
     *       BIG_PP(1:NDBASE,1:NDBASE,1)=BIG_PP(1:NDBASE,1:NDBASE,1)
     *                           +UNIT_I*HCOMPP(1:NDBASE,1:NDBASE)
         IF (K.EQ.3)
     *       BIG_PP(1:NDBASE,1:NDBASE,1)=BIG_PP(1:NDBASE,1:NDBASE,1)
     *                                  +HCOMPP(1:NDBASE,1:NDBASE)
C
         IF (ISIMPY.NE.1) THEN
C
             IF (K.EQ.1)
     *           BIG_PM(1:NDBASE,1:NDBASE,0)=BIG_PM(1:NDBASE,1:NDBASE,0)
     *                               -UNIT_I*HCOMPM(1:NDBASE,1:NDBASE)
             IF (K.EQ.2)
     *           BIG_PM(1:NDBASE,1:NDBASE,0)=BIG_PM(1:NDBASE,1:NDBASE,0)
     *                               -UNIT_I*HCOMPM(1:NDBASE,1:NDBASE)
             IF (K.EQ.3)
     *           BIG_PM(1:NDBASE,1:NDBASE,0)=BIG_PM(1:NDBASE,1:NDBASE,0)
     *                                      +HCOMPM(1:NDBASE,1:NDBASE)
C
             IF (K.EQ.1)
     *           BIG_PM(1:NDBASE,1:NDBASE,1)=BIG_PM(1:NDBASE,1:NDBASE,1)
     *                               -UNIT_I*HCOMPM(1:NDBASE,1:NDBASE)
             IF (K.EQ.2)
     *           BIG_PM(1:NDBASE,1:NDBASE,1)=BIG_PM(1:NDBASE,1:NDBASE,1)
     *                               -UNIT_I*HCOMPM(1:NDBASE,1:NDBASE)
             IF (K.EQ.3)
     *           BIG_PM(1:NDBASE,1:NDBASE,1)=BIG_PM(1:NDBASE,1:NDBASE,1)
     *                                      -HCOMPM(1:NDBASE,1:NDBASE)
C
         END IF
C
      END DO
C
C=======================================================================
C          THE MATRIX ELEMENTS OF  TIME - ODD  TERMS  ARE NOT CALCULATED
C          WHEN THE CASE WITH   N O   R O T A T I O N  HAS BEEN SELECTED
C=======================================================================
C
      IF (IROTAT.NE.1) GO TO 1
C
C=======================================================================
C          INSERTING THE LINEAR-MOMENTUM MATRIX ELEMENTS
C=======================================================================
C
      IF (JETACM.EQ.2) THEN
C
          FACTOR=2*HBMREN(1)*ALINLI(1)
C
          CALL INT_PX(NXMAXX,NYMAXX,NZMAXX,IPHAPP(0,0,0),HAUXPP,FACTOR)
C
          BIG_PP(1:NDBASE,1:NDBASE,0)=BIG_PP(1:NDBASE,1:NDBASE,0)
     *                        -UNIT_I*HAUXPP(1:NDBASE,1:NDBASE)
          BIG_PP(1:NDBASE,1:NDBASE,1)=BIG_PP(1:NDBASE,1:NDBASE,1)
     *                        -UNIT_I*HAUXPP(1:NDBASE,1:NDBASE)
C
          FACTOR=2*HBMREN(3)*ALINLI(3)
C
          CALL INT_PZ(NXMAXX,NYMAXX,NZMAXX,IPHAPP(0,0,0),HAUXPP,FACTOR)
C
          BIG_PP(1:NDBASE,1:NDBASE,0)=BIG_PP(1:NDBASE,1:NDBASE,0)
     *                        -UNIT_I*HAUXPP(1:NDBASE,1:NDBASE)
          BIG_PP(1:NDBASE,1:NDBASE,1)=BIG_PP(1:NDBASE,1:NDBASE,1)
     *                        -UNIT_I*HAUXPP(1:NDBASE,1:NDBASE)
C
          IF (ISIMPY.NE.1) THEN
C
              FACTOR=2*HBMREN(2)*ALINLI(2)
C
              CALL INT_PY(NXMAXX,NYMAXX,NZMAXX,IPHAPM(0,0,0),HAUXPM,
     *                                                       FACTOR)
C
              BIG_PM(1:NDBASE,1:NDBASE,0)=BIG_PM(1:NDBASE,1:NDBASE,0)
     *                            -UNIT_I*HAUXPM(1:NDBASE,1:NDBASE)
              BIG_PM(1:NDBASE,1:NDBASE,1)=BIG_PM(1:NDBASE,1:NDBASE,1)
     *                            +UNIT_I*HAUXPM(1:NDBASE,1:NDBASE)
C
          END IF
C
      END IF
C
C=======================================================================
C          CALCULATING  KINETIC SPIN TERM MATRIX ELEMENTS
C=======================================================================
C
      NDEGRE=2
C
      DO K=1,NDKART
C
         CALL BEGINC(VE_KIS(1,1,1,K,ITPNMX),SONBAS,NDEGRE,
     *               NXHERM,NYHERM,NZHERM,HERMTS,FOURWG,
     *               NXMAXX,NYMAXX,NZMAXX)
C
         KARTEZ=K
C
         CALL INTMAS(NXMAXX,NYMAXX,NZMAXX,SONBAS,
     *               KARTEZ,ISIMPY,HCOMPP,HCOMPM)
C
         IF (K.EQ.1)
     *       BIG_PP(1:NDBASE,1:NDBASE,0)=BIG_PP(1:NDBASE,1:NDBASE,0)
     *                                  +HCOMPP(1:NDBASE,1:NDBASE)
         IF (K.EQ.2)
     *       BIG_PP(1:NDBASE,1:NDBASE,0)=BIG_PP(1:NDBASE,1:NDBASE,0)
     *                                  +HCOMPP(1:NDBASE,1:NDBASE)
         IF (K.EQ.3)
     *       BIG_PP(1:NDBASE,1:NDBASE,0)=BIG_PP(1:NDBASE,1:NDBASE,0)
     *                           +UNIT_I*HCOMPP(1:NDBASE,1:NDBASE)
C
         IF (K.EQ.1)
     *       BIG_PP(1:NDBASE,1:NDBASE,1)=BIG_PP(1:NDBASE,1:NDBASE,1)
     *                                  -HCOMPP(1:NDBASE,1:NDBASE)
         IF (K.EQ.2)
     *       BIG_PP(1:NDBASE,1:NDBASE,1)=BIG_PP(1:NDBASE,1:NDBASE,1)
     *                                  -HCOMPP(1:NDBASE,1:NDBASE)
         IF (K.EQ.3)
     *       BIG_PP(1:NDBASE,1:NDBASE,1)=BIG_PP(1:NDBASE,1:NDBASE,1)
     *                           +UNIT_I*HCOMPP(1:NDBASE,1:NDBASE)
C
         IF (ISIMPY.NE.1) THEN
C
             IF (K.EQ.1)
     *           BIG_PM(1:NDBASE,1:NDBASE,0)=BIG_PM(1:NDBASE,1:NDBASE,0)
     *                                      +HCOMPM(1:NDBASE,1:NDBASE)
             IF (K.EQ.2)
     *           BIG_PM(1:NDBASE,1:NDBASE,0)=BIG_PM(1:NDBASE,1:NDBASE,0)
     *                                      +HCOMPM(1:NDBASE,1:NDBASE)
             IF (K.EQ.3)
     *           BIG_PM(1:NDBASE,1:NDBASE,0)=BIG_PM(1:NDBASE,1:NDBASE,0)
     *                               +UNIT_I*HCOMPM(1:NDBASE,1:NDBASE)
C
             IF (K.EQ.1)
     *           BIG_PM(1:NDBASE,1:NDBASE,1)=BIG_PM(1:NDBASE,1:NDBASE,1)
     *                                      +HCOMPM(1:NDBASE,1:NDBASE)
             IF (K.EQ.2)
     *           BIG_PM(1:NDBASE,1:NDBASE,1)=BIG_PM(1:NDBASE,1:NDBASE,1)
     *                                      +HCOMPM(1:NDBASE,1:NDBASE)
             IF (K.EQ.3)
     *           BIG_PM(1:NDBASE,1:NDBASE,1)=BIG_PM(1:NDBASE,1:NDBASE,1)
     *                               -UNIT_I*HCOMPM(1:NDBASE,1:NDBASE)
C
         END IF
C
      END DO
C
C=======================================================================
C          CALCULATING   S  P  I  N  TERM MATRIX ELEMENTS
C=======================================================================
C
      NDEGRE=0
C
      DO K=1,NDKART
C
         CALL BEGINC(VE_SPI(1,1,1,K,ITPNMX),SONBAS,NDEGRE,
     *               NXHERM,NYHERM,NZHERM,HERMTS,FOURWG,
     *               NXMAXX,NYMAXX,NZMAXX)
C
         KARTEZ=K
C
         CALL INTCEN(NXMAXX,NYMAXX,NZMAXX,SONBAS,
     *               KARTEZ,ISIMPY,HCOMPP,HCOMPM)
C
         IF (K.EQ.1)
     *       BIG_PP(1:NDBASE,1:NDBASE,0)=BIG_PP(1:NDBASE,1:NDBASE,0)
     *                                  +HCOMPP(1:NDBASE,1:NDBASE)
         IF (K.EQ.2)
     *       BIG_PP(1:NDBASE,1:NDBASE,0)=BIG_PP(1:NDBASE,1:NDBASE,0)
     *                                  +HCOMPP(1:NDBASE,1:NDBASE)
         IF (K.EQ.3)
     *       BIG_PP(1:NDBASE,1:NDBASE,0)=BIG_PP(1:NDBASE,1:NDBASE,0)
     *                           +UNIT_I*HCOMPP(1:NDBASE,1:NDBASE)
C
         IF (K.EQ.1)
     *       BIG_PP(1:NDBASE,1:NDBASE,1)=BIG_PP(1:NDBASE,1:NDBASE,1)
     *                                  -HCOMPP(1:NDBASE,1:NDBASE)
         IF (K.EQ.2)
     *       BIG_PP(1:NDBASE,1:NDBASE,1)=BIG_PP(1:NDBASE,1:NDBASE,1)
     *                                  -HCOMPP(1:NDBASE,1:NDBASE)
         IF (K.EQ.3)
     *       BIG_PP(1:NDBASE,1:NDBASE,1)=BIG_PP(1:NDBASE,1:NDBASE,1)
     *                           +UNIT_I*HCOMPP(1:NDBASE,1:NDBASE)
C
         IF (ISIMPY.NE.1) THEN
C
             IF (K.EQ.1)
     *           BIG_PM(1:NDBASE,1:NDBASE,0)=BIG_PM(1:NDBASE,1:NDBASE,0)
     *                                      +HCOMPM(1:NDBASE,1:NDBASE)
             IF (K.EQ.2)
     *           BIG_PM(1:NDBASE,1:NDBASE,0)=BIG_PM(1:NDBASE,1:NDBASE,0)
     *                                      +HCOMPM(1:NDBASE,1:NDBASE)
             IF (K.EQ.3)
     *           BIG_PM(1:NDBASE,1:NDBASE,0)=BIG_PM(1:NDBASE,1:NDBASE,0)
     *                               +UNIT_I*HCOMPM(1:NDBASE,1:NDBASE)
C
             IF (K.EQ.1)
     *           BIG_PM(1:NDBASE,1:NDBASE,1)=BIG_PM(1:NDBASE,1:NDBASE,1)
     *                                      +HCOMPM(1:NDBASE,1:NDBASE)
             IF (K.EQ.2)
     *           BIG_PM(1:NDBASE,1:NDBASE,1)=BIG_PM(1:NDBASE,1:NDBASE,1)
     *                                      +HCOMPM(1:NDBASE,1:NDBASE)
             IF (K.EQ.3)
     *           BIG_PM(1:NDBASE,1:NDBASE,1)=BIG_PM(1:NDBASE,1:NDBASE,1)
     *                               -UNIT_I*HCOMPM(1:NDBASE,1:NDBASE)
C
         END IF
C
      END DO
C
C=======================================================================
C          CALCULATING  C U R R E N T  TERM MATRIX ELEMENTS
C=======================================================================
C
      NDEGRE=1
C
      DO L=1,NDKART
C
         CALL BEGINC(VE_CUR(1,1,1,L,ITPNMX),VONBAS(0,0,0,L),NDEGRE,
     *               NXHERM,NYHERM,NZHERM,HERMTS,FOURWG,
     *               NXMAXX,NYMAXX,NZMAXX)
C
      END DO
C
      KARTEZ=0
C
      CALL INTSOR(NXMAXX,NYMAXX,NZMAXX,VONBAS,
     *            KARTEZ,ISIMPY,HCOMPP,HCOMPM)
C
      BIG_PP(1:NDBASE,1:NDBASE,0)=BIG_PP(1:NDBASE,1:NDBASE,0)
     *                    -UNIT_I*HCOMPP(1:NDBASE,1:NDBASE)
      BIG_PP(1:NDBASE,1:NDBASE,1)=BIG_PP(1:NDBASE,1:NDBASE,1)
     *                    -UNIT_I*HCOMPP(1:NDBASE,1:NDBASE)
C
      IF (ISIMPY.NE.1) THEN
C
          BIG_PM(1:NDBASE,1:NDBASE,0)=BIG_PM(1:NDBASE,1:NDBASE,0)
     *                        -UNIT_I*HCOMPM(1:NDBASE,1:NDBASE)
          BIG_PM(1:NDBASE,1:NDBASE,1)=BIG_PM(1:NDBASE,1:NDBASE,1)
     *                        +UNIT_I*HCOMPM(1:NDBASE,1:NDBASE)
      END IF
C
C=======================================================================
C         RETURN FROM THE   N O - R O T A T I O N    CASE
C=======================================================================
C
    1 CONTINUE
C
C=======================================================================
C         INSERTING THE LIPKIN-NOGAMI CORRECTION TERM
C=======================================================================
C
      IF (LIPKIX.EQ.1) THEN
C
          DO IKET=1,LDBASE
             DO IBRA=1,LDBASE
C
                BIG_PP(IBRA,IKET,0)=BIG_PP(IBRA,IKET,0)+4*EFER2X*
     *                              DEN_PP(IBRA,IKET,0,ICHARG)
                BIG_PP(IBRA,IKET,1)=BIG_PP(IBRA,IKET,1)+4*EFER2X*
     *                              DEN_PP(IBRA,IKET,1,ICHARG)
C
             END DO
          END DO
C
          DO IBRA=1,LDBASE
C
             IKET=IBRA
C
                BIG_PP(IBRA,IKET,0)=BIG_PP(IBRA,IKET,0)-2*EFER2X
                BIG_PP(IBRA,IKET,1)=BIG_PP(IBRA,IKET,1)-2*EFER2X
C
          END DO
C
          IF (ISIMPY.NE.1) THEN
C
              DO IKET=1,LDBASE
                 DO IBRA=1,LDBASE
C
                BIG_PM(IBRA,IKET,0)=BIG_PM(IBRA,IKET,0)+4*EFER2X*
     *                              DEN_PM(IBRA,IKET,0,ICHARG)
                BIG_PM(IBRA,IKET,1)=BIG_PM(IBRA,IKET,1)+4*EFER2X*
     *                              DEN_PM(IBRA,IKET,1,ICHARG)
C
                 END DO
              END DO
C
          END IF
C
      END IF
C
C=======================================================================
C          INSERTING THE EXACT COULOMB MATRIX ELEMENTS, WHICH ARE
C          SUPPOSED TO BE ALREADY CALCULATED BEFORE
C=======================================================================
C
      IF (ICHARG.EQ.1.AND.(ICOUDI.EQ.2.OR.ICOUEX.EQ.2)) THEN
C
          DO IBRA=1,LDBASE
             DO IKET=1,LDBASE
C
                MPY=NYVECT(IBRA)
                NPY=NYVECT(IKET)
C
                DO KARTEZ=0,NDKART
C
                   BIG_PP(IBRA,IKET,0)=BIG_PP(IBRA,IKET,0)
     *                                +COULSV(IBRA,IKET,KARTEZ)
     *                                *IPHAPP(MPY,NPY,KARTEZ)
     *                                *PHACOM(KARTEZ)
                   BIG_PP(IBRA,IKET,1)=BIG_PP(IBRA,IKET,1)
     *                                +COULSV(IBRA,IKET,KARTEZ)
     *                                *IPHAMM(MPY,NPY,KARTEZ)
     *                                *PHACOM(KARTEZ)
C
                END DO
             END DO
          END DO
C
          IF (ISIMPY.NE.1) THEN
C
              DO IBRA=1,LDBASE
                 DO IKET=1,LDBASE
C
                    MPY=NYVECT(IBRA)
                    NPY=NYVECT(IKET)
C
                    DO KARTEZ=0,NDKART
C
                       BIG_PM(IBRA,IKET,0)=BIG_PM(IBRA,IKET,0)
     *                                    +COULSV(IBRA,IKET,KARTEZ)
     *                                    *IPHAPM(MPY,NPY,KARTEZ)
     *                                    *PHACOM(KARTEZ)
                       BIG_PM(IBRA,IKET,1)=BIG_PM(IBRA,IKET,1)
     *                                    +COULSV(IBRA,IKET,KARTEZ)
     *                                    *IPHAMP(MPY,NPY,KARTEZ)
     *                                    *PHACOM(KARTEZ)
C
                    END DO
                 END DO
              END DO
C
          END IF
C
      END IF
C
C=======================================================================
C          INSERTING THE YUKAWA MATRIX ELEMENTS, WHICH ARE SUPPOSED
C          TO BE ALREADY CALCULATED BEFORE
C=======================================================================
C
      IF (I_YUKA.GE.2) THEN
C
          DO KARTEZ=0,NDKART
C
             DO IKET=1,LDBASE
                NPY=NYVECT(IKET)
                DO IBRA=1,LDBASE
                   MPY=NYVECT(IBRA)
C
                   BIG_PP(IBRA,IKET,0)=BIG_PP(IBRA,IKET,0)
     *                                +YUKASV(IBRA,IKET,KARTEZ,ICHARG)
     *                                *IPHAPP(MPY,NPY,KARTEZ)
     *                                *PHACOM(KARTEZ)
                   BIG_PP(IBRA,IKET,1)=BIG_PP(IBRA,IKET,1)
     *                                +YUKASV(IBRA,IKET,KARTEZ,ICHARG)
     *                                *IPHAMM(MPY,NPY,KARTEZ)
     *                                *PHACOM(KARTEZ)
C
                END DO
             END DO
          END DO
C
          IF (ISIMPY.NE.1) THEN
C
              DO KARTEZ=0,NDKART
C
                 DO IKET=1,LDBASE
                    NPY=NYVECT(IKET)
                    DO IBRA=1,LDBASE
                       MPY=NYVECT(IBRA)
C
                     BIG_PM(IBRA,IKET,0)=BIG_PM(IBRA,IKET,0)
     *                                  +YUKASV(IBRA,IKET,KARTEZ,ICHARG)
     *                                  *IPHAPM(MPY,NPY,KARTEZ)
     *                                  *PHACOM(KARTEZ)
                     BIG_PM(IBRA,IKET,1)=BIG_PM(IBRA,IKET,1)
     *                                  +YUKASV(IBRA,IKET,KARTEZ,ICHARG)
     *                                  *IPHAMP(MPY,NPY,KARTEZ)
     *                                  *PHACOM(KARTEZ)
C
                    END DO
                 END DO
              END DO
C
          END IF
C
      END IF
C
C=======================================================================
C          INSERTING THE GOGNY MATRIX ELEMENTS, WHICH ARE SUPPOSED
C          TO BE ALREADY CALCULATED BEFORE
C=======================================================================
C
      IF (I_GOGA.GE.2) THEN
C
          DO KARTEZ=0,NDKART
C
             DO IKET=1,LDBASE
                NPY=NYVECT(IKET)
                DO IBRA=1,LDBASE
                   MPY=NYVECT(IBRA)
C
                   BIG_PP(IBRA,IKET,0)=BIG_PP(IBRA,IKET,0)
     *                                +GOGASV(IBRA,IKET,KARTEZ,ICHARG)
     *                                *IPHAPP(MPY,NPY,KARTEZ)
     *                                *PHACOM(KARTEZ)
                   BIG_PP(IBRA,IKET,1)=BIG_PP(IBRA,IKET,1)
     *                                +GOGASV(IBRA,IKET,KARTEZ,ICHARG)
     *                                *IPHAMM(MPY,NPY,KARTEZ)
     *                                *PHACOM(KARTEZ)
C
                END DO
             END DO
C
          END DO
C
          IF (ISIMPY.NE.1) THEN
C
              DO KARTEZ=0,NDKART
C
                 DO IKET=1,LDBASE
                    NPY=NYVECT(IKET)
                    DO IBRA=1,LDBASE
                       MPY=NYVECT(IBRA)
C
                     BIG_PM(IBRA,IKET,0)=BIG_PM(IBRA,IKET,0)
     *                                  +GOGASV(IBRA,IKET,KARTEZ,ICHARG)
     *                                  *IPHAPM(MPY,NPY,KARTEZ)
     *                                  *PHACOM(KARTEZ)
                     BIG_PM(IBRA,IKET,1)=BIG_PM(IBRA,IKET,1)
     *                                  +GOGASV(IBRA,IKET,KARTEZ,ICHARG)
     *                                  *IPHAMP(MPY,NPY,KARTEZ)
     *                                  *PHACOM(KARTEZ)
C
                    END DO
                 END DO
              END DO
C
          END IF
C
      END IF
C
C=======================================================================
C          INSERTING THE LINEAR-MOMENTUM-SQUARED EXCHANGE MATRIX ELMNTS,
C          WHICH ARE SUPPOSED TO BE ALREADY CALCULATED BEFORE
C=======================================================================
C
      IF (JETACM.EQ.2) THEN
C
          DO K=1,NDKART
C
             DO IKET=1,LDBASE
                DO IBRA=1,LDBASE
C
                   BIG_PP(IBRA,IKET,0)=BIG_PP(IBRA,IKET,0)+HBMREN(K)*
     *                                 ALINPP(IBRA,IKET,K,0,ICHARG)
                   BIG_PP(IBRA,IKET,1)=BIG_PP(IBRA,IKET,1)+HBMREN(K)*
     *                                 ALINPP(IBRA,IKET,K,1,ICHARG)
C
                END DO
             END DO
C
             IF (ISIMPY.NE.1) THEN
C
                 DO IKET=1,LDBASE
                    DO IBRA=1,LDBASE
C
                   BIG_PM(IBRA,IKET,0)=BIG_PM(IBRA,IKET,0)+HBMREN(K)*
     *                                 ALINPM(IBRA,IKET,K,0,ICHARG)
                   BIG_PM(IBRA,IKET,1)=BIG_PM(IBRA,IKET,1)+HBMREN(K)*
     *                                 ALINPM(IBRA,IKET,K,1,ICHARG)
C
                    END DO
                 END DO
C
             END IF
C
          END DO
C
      END IF
C
C=======================================================================
      DEALLOCATE (HAUXPP,HAUXPM)
C=======================================================================
C
      CALL CPUTIM('INTEGH',0)
C
      RETURN
      END
C
C=======================================================================
C
C=======================================================================
C
      SUBROUTINE INTEGD(NXHERM,NYHERM,NZHERM,NXMAXX,NYMAXX,NZMAXX,
     *                                ITPNMX,IROTAT,ISIMPY,ICHARG,
     *                                DELFIN,DELFIP,IDEFIN,IDEFIP,
     *                                JETACM,KETA_R,IGOGPA,ITERUN)
C=======================================================================
      USE GOGKAP
      USE PAIDEL
      USE PLISTO
      USE WD_FLD
C=======================================================================
      USE hfodd_sizes
C=======================================================================
C
      COMPLEX
     *          C_ZERO
      COMPLEX
     *          SONBAS(0:ND2MAX,0:ND2MAX,0:ND2MAX)
      COMPLEX
     *          HCOMPP,HCOMPM
C
C=======================================================================
      ALLOCATABLE HCOMPP(:,:)
      ALLOCATABLE HCOMPM(:,:)
C=======================================================================
      COMMON
     *       /HERSTO/ HERMTS(0:ND2MAX,1:NDGAUS,1:NDKART)
      COMMON
     *       /INTSTO/ FOURWG(1:NDGAUS,1:NDKART),
     *                FOURPT(1:NDGAUS,1:NDKART)
      COMMON
     *       /RENORM/ HBMREN(NDKART)
      COMMON
     *       /RENROT/ ROTREN(NDKART)
      COMMON
     *       /DIMENS/ LDBASE
C
C=======================================================================
C
      CALL CPUTIM('INTEGD',1)
C
C=======================================================================
C
      IALLOC=0
C
C=======================================================================
      IF (.NOT.ALLOCATED(HAMIDE)) THEN
          ALLOCATE (HAMIDE(1:NDBASE,1:NDBASE,0:NDREVE),STAT=IALLOC)
          IF (IALLOC.NE.0) CALL NOALLO('HAMIDE','INTEGD')
      END IF
C=======================================================================
      ALLOCATE (HCOMPP(1:NDBASE,1:NDBASE),STAT=IALLOC)
      IF (IALLOC.NE.0) CALL NOALLO('HCOMPP','INTEGD')
      ALLOCATE (HCOMPM(1:NDBASE,1:NDBASE),STAT=IALLOC)
      IF (IALLOC.NE.0) CALL NOALLO('HCOMPM','INTEGD')
C=======================================================================
C
C=======================================================================
C     THIS SUBROUTINE CALCULATES MATRIX ELEMENTS OF THE PAIRING FIELDS
C=======================================================================
C         PREPARE THE INPUT DATA
C=======================================================================
C
      IF (ITPNMX.EQ.0) THEN
C
          DELFIX=DELFIN
          IDEFIX=IDEFIN
C
      ENDIF
C
      IF (ITPNMX.EQ.1) THEN
C
          DELFIX=DELFIP
          IDEFIX=IDEFIP
C
      ENDIF
C
C=======================================================================
C     CASE OF FIXED DELTA
C=======================================================================
C
      ZERO=0.0D0
C
      C_ZERO=CMPLX(0.0D0,0.0D0)
C
      IF (IDEFIX.EQ.1) THEN
C
          DO IKET=1,LDBASE
             DO IBRA=1,LDBASE
C
                HAMIDE(IBRA,IKET,0)=C_ZERO
                HAMIDE(IBRA,IKET,1)=C_ZERO
C
             END DO
C
                HAMIDE(IKET,IKET,0)=CMPLX(+DELFIX,ZERO)
C
          END DO
C
      ELSE
C
C=======================================================================
C     CASE OF THE DENSITY-DEPENDENT DELTA PAIRING
C=======================================================================
C
          HAMIDE(:,:,:)=C_ZERO
          HAMIDE(:,:,:)=C_ZERO
C
          IF (IGOGPA.NE.2.OR.ITERUN.EQ.1) THEN
C
              NDEGRE=0
C
              CALL BEGINC(WD_CEN(1,1,1,ITPNMX),SONBAS,NDEGRE,
     *                    NXHERM,NYHERM,NZHERM,HERMTS,FOURWG,
     *                    NXMAXX,NYMAXX,NZMAXX)
C
              KARTEZ=0
C
              CALL INTCEN(NXMAXX,NYMAXX,NZMAXX,SONBAS,
     *                    KARTEZ,ISIMPY,HCOMPP,HCOMPM)
C
C=======================================================================
C          THE SIGNS "-1" BELOW STEM FROM THE FACTS THAT (NOTES 7-41E):
C          1. THE "MP" BLOCK OF THE PAIRING FIELD IS PUT INTO THE  ARRAY
C             "HAMIDE" FOR IREVER=0. THE BLOCK IS CALCULATED IN COMPLETE
C             ANALOGY TO THE "PP" BLOCK OF THE MEAN FIELD, BUT  HAS  THE
C             OPPOSITE SIGN.
C          2. THE "PP" BLOCK OF THE PAIRING FIELD IS PUT INTO THE  ARRAY
C             "HAMIDE" FOR IREVER=1. THE BLOCK IS CALCULATED IN COMPLETE
C             ANALOGY TO THE "PM" BLOCK OF THE MEAN FIELD, BUT  HAS  THE
C             OPPOSITE SIGN.
C          IT MEANS THAT THE HFB EQUATION SPLIT INTO THE SIMPLEX  BLOCKS
C          DIFFERS BY THE SIGN OF THE PAIRING FIELD FROM THAT WRITTEN IN
C          THE RUSSION CONVENTION. CONSEQUENTLY, FIXED PAIRING GAP  WITH
C          THE PLUS SIGN IS USED ABOVE FOR IDEFIX=1.
C=======================================================================
C          ATTENTION: SIGNS "+1" HAVE BEEN IMPLEMENTED IN THE CODE UP TO
C                     THE VERSION (2.16N).  AT THE SAME TIME,  INCORRECT
C                     SIGNS HAVE BEEN CODED FOR THE SECOND COMPONENTS OF
C                     THE HFB WAVE FUNCTIONS (SEE COMMENTS IN "DENSHF"),
C                     AND HENCE ALL RESULTS WERE CORRECT. THIS  BUG  WAS
C                     CORRECTED ON 07/04/05 IN VERSION (2.17).
C=======================================================================
C
              HAMIDE(1:NDBASE,1:NDBASE,0)=-HCOMPP(1:NDBASE,1:NDBASE)
              HAMIDE(1:NDBASE,1:NDBASE,1)=-HCOMPM(1:NDBASE,1:NDBASE)
C
          END IF
C
      END IF
C
C=======================================================================
C          INSERTING THE MATRIX ELEMENTS CORRESPONDING TO THE PAIRING
C          TERM OF <P^2>
C=======================================================================
C
      IF (JETACM.EQ.2) THEN
C
          DO K=1,NDKART
C
             DO IKET=1,LDBASE
                DO IBRA=1,LDBASE
C
                   HAMIDE(IBRA,IKET,0)=HAMIDE(IBRA,IKET,0)+HBMREN(K)*
     *                                 PLINPM(IBRA,IKET,K,0,ICHARG)
                   HAMIDE(IBRA,IKET,1)=HAMIDE(IBRA,IKET,1)+HBMREN(K)*
     *                                 PLINPM(IBRA,IKET,K,1,ICHARG)
C
                END DO
             END DO
C
             IF (ISIMPY.NE.1)
     *
     *           STOP ' NON-CONSERVED SIMPLEX NOT IMPLEMENTED IN INTEGD'
C
          END DO
C
      END IF
C
C=======================================================================
C          INSERTING THE GOGNY MATRIX ELEMENTS, WHICH ARE SUPPOSED
C          TO BE ALREADY CALCULATED BEFORE
C=======================================================================
C
      IF (IGOGPA.GE.2) THEN
          DO KARTEZ=0,NDKART
             HAMIDE(:,:,0)=HAMIDE(:,:,0)+GOGCHI(:,:,KARTEZ,ICHARG)
          END DO
      END IF
C
C=======================================================================
      DEALLOCATE (HCOMPP,HCOMPM)
C=======================================================================
C
      CALL CPUTIM('INTEGD',0)
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
      SUBROUTINE INTEGG(FLDMAS,FLDCEN,FLDKIS,FLDSPI,FLDCUR,FLDSOR,
     *                  NXHERM,NYHERM,NZHERM,NXMAXX,NYMAXX,NZMAXX,
     *                  IMOVAX,ITILAX,ITISAX,IROTAT,ICHARG,ISIMPY,
     *                                       IOCONT,NMUCON,NSICON)
C=======================================================================
      USE HCOULO
      USE MAT_PP
      USE MAT_PM
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      COMPLEX
     *          TIMEPP,TIMEMM,TIMEPM,TIMEMP
      COMPLEX
     *          C_ZERO
C=======================================================================
      ALLOCATABLE HAUXPP(:,:)
      ALLOCATABLE HAUXPM(:,:)
C=======================================================================
      COMMON
     *       /T_PHAS/ IPHAPP(0:NDYMAX,0:NDYMAX,0:NDKART),
     *                IPHAPM(0:NDYMAX,0:NDYMAX,0:NDKART),
     *                IPHAMP(0:NDYMAX,0:NDYMAX,0:NDKART),
     *                IPHAMM(0:NDYMAX,0:NDYMAX,0:NDKART)
C=======================================================================
      COMMON
     *       /DIMENS/ LDBASE
C
C=======================================================================
C
      CALL CPUTIM('INTEGG',1)
C
C=======================================================================
C
      IALLOC=0
C
C=======================================================================
      ALLOCATE (HAUXPP(1:NDBASE,1:NDBASE),STAT=IALLOC)
      IF (IALLOC.NE.0) CALL NOALLO('HAUXPP','INTEGG')
      ALLOCATE (HAUXPM(1:NDBASE,1:NDBASE),STAT=IALLOC)
      IF (IALLOC.NE.0) CALL NOALLO('HAUXPM','INTEGG')
C=======================================================================
      IF (.NOT.ALLOCATED(BIG_PP)) THEN
          ALLOCATE (BIG_PP(1:NDBASE,1:NDBASE,0:NDREVE),STAT=IALLOC)
          IF (IALLOC.NE.0) CALL NOALLO('BIG_PP','INTEGG')
      END IF
C=======================================================================
      IF (.NOT.ALLOCATED(BIG_PM).AND.ISIMPY.NE.1) THEN
          ALLOCATE (BIG_PM(1:NDBASE,1:NDBASE,0:NDREVE),STAT=IALLOC)
          IF (IALLOC.NE.0) CALL NOALLO('BIG_PM','INTEGG')
      END IF
C=======================================================================
C
C=======================================================================
C          THIS SUBROUTINE CALCULATES MATRIX ELEMENTS OF THE  MEAN-FIELD
C          GIVEN BY A GAUSSIAN INTERACTION
C=======================================================================
C
      C_ZERO=CMPLX(0.0D0,0.0D0)
C
C=======================================================================
C          FOR PARTS DIAGONAL IN THE SIMPLEX:
C
C          AT THE BEGINNING: TIME-EVEN   PART  IS PUT INTO BIG_PP(,,0)
C                            TIME-ODD    PART  IS PUT INTO BIG_PP(,,1)
C          AT THE END:
C                            TIME-(+,+)  BLOCK IS PUT INTO BIG_PP(,,0)
C                            TIME-(-,-)  BLOCK IS PUT INTO BIG_PP(,,1)
C=======================================================================
C          FOR PARTS NON-DIAGONAL IN THE SIMPLEX:
C
C          AT THE BEGINNING: TIME-EVEN   PART  IS PUT INTO BIG_PM(,,0)
C                            TIME-ODD    PART  IS PUT INTO BIG_PM(,,1)
C          AT THE END:
C                            TIME-(+,-)  BLOCK IS PUT INTO BIG_PM(,,0)
C                            TIME-(-,+)  BLOCK IS PUT INTO BIG_PM(,,1)
C=======================================================================
C
      BIG_PP(:,:,:)=C_ZERO
      IF (ISIMPY.NE.1) THEN
          BIG_PM(:,:,:)=C_ZERO
      END IF
C
C=======================================================================
C         COMBINING THE  TIME-EVEN  AND  TIME-ODD   PARTS
C              INTO THE  TIME-UP    AND  TIME-DOWN  PARTS
C=======================================================================
C
      DO IKET=1,LDBASE
         DO IBRA=1,LDBASE
C
            TIMEPP=       BIG_PP(IBRA,IKET,0) + BIG_PP(IBRA,IKET,1)
            TIMEMM= CONJG(BIG_PP(IBRA,IKET,0) - BIG_PP(IBRA,IKET,1))
C
            BIG_PP(IBRA,IKET,0) = TIMEPP
            BIG_PP(IBRA,IKET,1) = TIMEMM
C
         END DO
      END DO
C
      IF (ISIMPY.NE.1) THEN
C
          DO IKET=1,LDBASE
             DO IBRA=1,LDBASE
C
                TIMEPM=       BIG_PM(IBRA,IKET,0) + BIG_PM(IBRA,IKET,1)
                TIMEMP=-CONJG(BIG_PM(IBRA,IKET,0) - BIG_PM(IBRA,IKET,1))
C
                BIG_PM(IBRA,IKET,0) = TIMEPM
                BIG_PM(IBRA,IKET,1) = TIMEMP
C
             END DO
          END DO
C
      END IF
C
C=======================================================================
      DEALLOCATE (HAUXPP,HAUXPM)
C=======================================================================
C
      CALL CPUTIM('INTEGG',0)
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE INIPAI(NXHERM,NYHERM,NZHERM,ITPNMX)
C=======================================================================
      USE WD_FLD
C=======================================================================
      USE hfodd_sizes
C=======================================================================
C
      COMPLEX
     *        DENSIC, DENCHC
C
      COMMON
     *       /DATPAN/ GPAIRN,FACTGN,EFERMN,DELTAN,EFER2N
     *       /DATPAP/ GPAIRP,FACTGP,EFERMP,DELTAP,EFER2P
      COMMON
     *       /DENTOT/ DENSIT(NDXHRM,NDYHRM,NDZHRM),
     *                DENCHA(NDXHRM,NDYHRM,NDZHRM)
      COMMON
     *       /DENTOC/ DENSIC(NDXHRM,NDYHRM,NDZHRM),
     *                DENCHC(NDXHRM,NDYHRM,NDZHRM)
      COMMON
     *       /DENEXP/ EXPAUX(NDXHRM,NDYHRM,NDZHRM)
C
C=======================================================================
C          THIS SUBROUTINE INITIALIZES THE PAIRING FIELD AND
C          THE TOTAL DENSITY (A PROPERLY INITIALIZED VERSION
C          OF THE LATTER IS NEEDED IN SUBROUTINE EPAIRI).
C=======================================================================
C         PREPARE THE INPUT DATA
C=======================================================================
C
      IF (ITPNMX.EQ.0) THEN
          PDELTA=DELTAN
      ENDIF
C
      IF (ITPNMX.EQ.1) THEN
          PDELTA=DELTAP
      ENDIF
C
C=======================================================================
C
      ZERO=0.0D0
C
      WD_CEN(1:NXHERM,1:NYHERM,1:NZHERM,ITPNMX)=CMPLX(-PDELTA,ZERO)
     *                 /EXPAUX(1:NXHERM,1:NYHERM,1:NZHERM)
C
      DENSIT(1:NXHERM,1:NYHERM,1:NZHERM)=
     *          -PDELTA*EXPAUX(1:NXHERM,1:NYHERM,1:NZHERM)
C
      DENSIC(1:NXHERM,1:NYHERM,1:NZHERM)=
     *            CMPLX(DENSIT(1:NXHERM,1:NYHERM,1:NZHERM),ZERO)
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE INTKIN(HAMKIN,HBMACT)
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      DIMENSION
     *          HAMKIN(1:NDBASE,1:NDBASE)
C
      COMMON
     *       /T_PHAS/ IPHAPP(0:NDYMAX,0:NDYMAX,0:NDKART),
     *                IPHAPM(0:NDYMAX,0:NDYMAX,0:NDKART),
     *                IPHAMP(0:NDYMAX,0:NDYMAX,0:NDKART),
     *                IPHAMM(0:NDYMAX,0:NDYMAX,0:NDKART)
      COMMON
     *       /BASISO/ NXVECT(1:NDBASE),NYVECT(1:NDBASE),NZVECT(1:NDBASE)
      COMMON
     *       /SCALNG/ HOMSCA(NDKART)
      COMMON
     *       /DIMENS/ LDBASE
C
C=======================================================================
C
      CALL CPUTIM('INTKIN',1)
C
C=======================================================================
C       THIS SUBROUTINE CALCULATES THE KINETIC ENERGY MATRIX ELEMENTS
C=======================================================================
C
      DO IKET=1,LDBASE
         DO IBRA=1,LDBASE
C
            NXBRA=NXVECT(IBRA)
            NYBRA=NYVECT(IBRA)
            NZBRA=NZVECT(IBRA)
C
            NXKET=NXVECT(IKET)
            NYKET=NYVECT(IKET)
            NZKET=NZVECT(IKET)
C
            TTTZ=0.0D0
C
            IF (NXBRA.EQ.NXKET) THEN
C
                IF (NYBRA.EQ.NYKET) THEN
C
                    IF (NZBRA.EQ.NZKET) THEN
                        TTTZ=REAL(2*NZBRA+1,KIND=8)
                    END IF
C
                    IF (NZBRA.EQ.(NZKET+2)) THEN
                        TTTZ=-SQRT(REAL(NZBRA*(NZKET+1),KIND=8))
                    END IF
C
                    IF (NZBRA.EQ.(NZKET-2)) THEN
                        TTTZ=-SQRT(REAL(NZKET*(NZBRA+1),KIND=8))
                    END IF
C
                    TTTZ=TTTZ*HOMSCA(3)**2
C
                END IF
C
            END IF
C
C=======================================================================
C
            TTTY=0.0D0
C
            IF (NXBRA.EQ.NXKET) THEN
C
                IF (NZBRA.EQ.NZKET) THEN
C
                    IF (NYBRA.EQ.NYKET) THEN
                        TTTY=REAL(2*NYBRA+1,KIND=8)
                    END IF
C
                    IF (NYBRA.EQ.(NYKET+2)) THEN
                        TTTY=-SQRT(REAL(NYBRA*(NYKET+1),KIND=8))
                    END IF
C
                    IF (NYBRA.EQ.(NYKET-2)) THEN
                        TTTY=-SQRT(REAL(NYKET*(NYBRA+1),KIND=8))
                    END IF
C
                    TTTY=TTTY*HOMSCA(2)**2
C
                END IF
C
            END IF
C
C=======================================================================
C
            TTTX=0.0D0
C
            IF (NYBRA.EQ.NYKET) THEN
C
                IF (NZBRA.EQ.NZKET) THEN
C
                    IF (NXBRA.EQ.NXKET) THEN
                        TTTX=REAL(2*NXBRA+1,KIND=8)
                    END IF
C
                    IF (NXBRA.EQ.(NXKET+2)) THEN
                        TTTX=-SQRT(REAL(NXBRA*(NXKET+1),KIND=8))
                    END IF
C
                    IF (NXBRA.EQ.(NXKET-2)) THEN
                        TTTX=-SQRT(REAL(NXKET*(NXBRA+1),KIND=8))
                    END IF
C
                    TTTX=TTTX*HOMSCA(1)**2
C
                END IF
C
            END IF
C
            HAMKIN(IBRA,IKET)=0.5D0*HBMACT*(TTTX+TTTY+TTTZ)
     *
     *                                    *IPHAPP(NYBRA,NYKET,0)
C
         END DO
      END DO
C
C=======================================================================
C
      CALL CPUTIM('INTKIN',0)
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE NPLUSP(XINFIX,XIZFIX,KMULMO,KMULSI,KMULMA,IDOPLM)
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      COMPLEX
     *          C_ZERO
      COMPLEX
     *          QMUT_N,QMUT_P,QMUT_T
      COMPLEX
     *          AMUT_N,AMUT_P,AMUT_T
      COMPLEX
     *          TKINSQ
      COMPLEX
     *          DKINSN,DKINSP,DKINST,
     *          EKINSN,EKINSP,EKINST,
     *          PKINSN,PKINSP,PKINST,
     *          TKINSN,TKINSP,TKINST,
     *          AKINLN,AKINLP,AKINLT,
     *          PKINLN,PKINLP,PKINLT,
     *          PKINKN,PKINKP,PKINKT
C
      COMPLEX
     *          TKOTSQ
      COMPLEX
     *          DKOTSN,DKOTSP,DKOTST,
     *          EKOTSN,EKOTSP,EKOTST,
     *          PKOTSN,PKOTSP,PKOTST,
     *          TKOTSN,TKOTSP,TKOTST,
     *          AKOTLN,AKOTLP,AKOTLT,
     *          PKOTLN,PKOTLP,PKOTLT,
     *          PKOTKN,PKOTKP,PKOTKT
C
      COMMON
     *       /ANGANG/ ANGU_N(1:NDKART),ANGU_P(1:NDKART),ANGU_T(1:NDKART)
      COMMON
     *       /ANGSPI/ SPIN_N(1:NDKART),SPIN_P(1:NDKART),SPIN_T(1:NDKART)
      COMMON
     *       /QMUTTI/ QMUT_N(0:NDMULT,-NDMULT:NDMULT),
     *                QMUT_P(0:NDMULT,-NDMULT:NDMULT),
     *                QMUT_T(0:NDMULT,-NDMULT:NDMULT)
      COMMON
     *       /QMULTI/ QMUL_N(0:NDMULT,-NDMULT:NDMULT),
     *                QMUL_P(0:NDMULT,-NDMULT:NDMULT),
     *                QMUL_T(0:NDMULT,-NDMULT:NDMULT)
      COMMON
     *       /SMULTI/ SMUL_N(0:NDMULT,-NDMULT:NDMULT),
     *                SMUL_P(0:NDMULT,-NDMULT:NDMULT),
     *                SMUL_T(0:NDMULT,-NDMULT:NDMULT)
      COMMON
     *       /PMULTI/ PMUL_N(0:NDMULT,-NDMULT:NDMULT),
     *                PMUL_P(0:NDMULT,-NDMULT:NDMULT),
     *                PMUL_T(0:NDMULT,-NDMULT:NDMULT)
      COMMON
     *       /VMULTI/ VMUL_N(0:NDMULT,-NDMULT:NDMULT,1:NDKART),
     *                VMUL_P(0:NDMULT,-NDMULT:NDMULT,1:NDKART),
     *                VMUL_T(0:NDMULT,-NDMULT:NDMULT,1:NDKART)
      COMMON
     *       /AMUTTI/ AMUT_N(0:NDMULT,-NDMULT:NDMULT),
     *                AMUT_P(0:NDMULT,-NDMULT:NDMULT),
     *                AMUT_T(0:NDMULT,-NDMULT:NDMULT)
      COMMON
     *       /AMULTI/ AMUL_N(0:NDMULT,-NDMULT:NDMULT),
     *                AMUL_P(0:NDMULT,-NDMULT:NDMULT),
     *                AMUL_T(0:NDMULT,-NDMULT:NDMULT)
      COMMON
     *       /LINMOM/ DLINSN(0:NDKART),DLINSP(0:NDKART),DLINST(0:NDKART)
     *               ,ELINSN(0:NDKART),ELINSP(0:NDKART),ELINST(0:NDKART)
     *               ,TLINSN(0:NDKART),TLINSP(0:NDKART),TLINST(0:NDKART)
     *               ,ALINLN(0:NDKART),ALINLP(0:NDKART),ALINLT(0:NDKART)
      COMMON
     *       /KINMOM/ DKINSN(0:NDKART),DKINSP(0:NDKART),DKINST(0:NDKART)
     *               ,EKINSN(0:NDKART),EKINSP(0:NDKART),EKINST(0:NDKART)
     *               ,TKINSN(0:NDKART),TKINSP(0:NDKART),TKINST(0:NDKART)
     *               ,AKINLN(0:NDKART),AKINLP(0:NDKART),AKINLT(0:NDKART)
      COMMON
     *       /LINPAI/ PLINSN(0:NDKART),PLINSP(0:NDKART),PLINST(0:NDKART)
     *               ,PLINLN(0:NDKART),PLINLP(0:NDKART),PLINLT(0:NDKART)
     *               ,PLINKN(0:NDKART),PLINKP(0:NDKART),PLINKT(0:NDKART)
      COMMON
     *       /KINPAI/ PKINSN(0:NDKART),PKINSP(0:NDKART),PKINST(0:NDKART)
     *               ,PKINLN(0:NDKART),PKINLP(0:NDKART),PKINLT(0:NDKART)
     *               ,PKINKN(0:NDKART),PKINKP(0:NDKART),PKINKT(0:NDKART)
      COMMON
     *       /ROTMOM/ DROTSN(0:NDKART),DROTSP(0:NDKART),DROTST(0:NDKART)
     *               ,EROTSN(0:NDKART),EROTSP(0:NDKART),EROTST(0:NDKART)
     *               ,TROTSN(0:NDKART),TROTSP(0:NDKART),TROTST(0:NDKART)
     *               ,AROTLN(0:NDKART),AROTLP(0:NDKART),AROTLT(0:NDKART)
      COMMON
     *       /KOTMOM/ DKOTSN(0:NDKART),DKOTSP(0:NDKART),DKOTST(0:NDKART)
     *               ,EKOTSN(0:NDKART),EKOTSP(0:NDKART),EKOTST(0:NDKART)
     *               ,TKOTSN(0:NDKART),TKOTSP(0:NDKART),TKOTST(0:NDKART)
     *               ,AKOTLN(0:NDKART),AKOTLP(0:NDKART),AKOTLT(0:NDKART)
      COMMON
     *       /ROTPAI/ PROTSN(0:NDKART),PROTSP(0:NDKART),PROTST(0:NDKART)
     *               ,PROTLN(0:NDKART),PROTLP(0:NDKART),PROTLT(0:NDKART)
     *               ,PROTKN(0:NDKART),PROTKP(0:NDKART),PROTKT(0:NDKART)
      COMMON
     *       /KOTPAI/ PKOTSN(0:NDKART),PKOTSP(0:NDKART),PKOTST(0:NDKART)
     *               ,PKOTLN(0:NDKART),PKOTLP(0:NDKART),PKOTLT(0:NDKART)
     *               ,PKOTKN(0:NDKART),PKOTKP(0:NDKART),PKOTKT(0:NDKART)
      COMMON
     *       /RMSRAD/ RADI_N(0:NDKART),
     *                RADI_P(0:NDKART),
     *                RADI_T(0:NDKART)
C
C=======================================================================
C       THIS SUBROUTINE ADDS THE PROTON AND NEUTRON CONTRIBUTIONS OF
C       WHATEVER WE NEED.
C=======================================================================
C
      C_ZERO=CMPLX(0.0D0,0.0D0)
C
      DO LAMBDA=0,KMULMO
         DO MIU=-LAMBDA,LAMBDA
C
            QMUL_T(LAMBDA,MIU) = QMUL_N(LAMBDA,MIU)+QMUL_P(LAMBDA,MIU)
            QMUT_T(LAMBDA,MIU) = QMUT_N(LAMBDA,MIU)+QMUT_P(LAMBDA,MIU)
C
         END DO
      END DO
C
C=======================================================================
C
      DO LAMBDA=0,KMULSI
         DO MIU=-LAMBDA,LAMBDA
C
            SMUL_T(LAMBDA,MIU) = SMUL_N(LAMBDA,MIU)+SMUL_P(LAMBDA,MIU)
C
         END DO
      END DO
C
C=======================================================================
C
      IF (IDOPLM.EQ.1) THEN
C
      DO LAMBDA=0,KMULSI
         DO MIU=-LAMBDA,LAMBDA
C
            PMUL_T(LAMBDA,MIU) = PMUL_N(LAMBDA,MIU)+PMUL_P(LAMBDA,MIU)
C
         END DO
      END DO
C
      END IF
C
C=======================================================================
C
      DO LAMBDA=0,KMULMA
         DO MIU=-LAMBDA,LAMBDA
C
            AMUL_T(LAMBDA,MIU) = AMUL_N(LAMBDA,MIU)+AMUL_P(LAMBDA,MIU)
            AMUT_T(LAMBDA,MIU) = AMUT_N(LAMBDA,MIU)+AMUT_P(LAMBDA,MIU)
C
         END DO
      END DO
C
C=======================================================================
C
C=======================================================================
C
      DO LAMBDA=0,KMULSI
         DO MIU=-LAMBDA,LAMBDA
            DO KARTEZ=1,NDKART
C
            VMUL_T(LAMBDA,MIU,KARTEZ) = VMUL_N(LAMBDA,MIU,KARTEZ)
     *                                + VMUL_P(LAMBDA,MIU,KARTEZ)
C
            END DO
         END DO
      END DO
C
C=======================================================================
C
      DO KARTEZ=0,NDKART
C
         RADI_T(KARTEZ)=SQRT((RADI_N(KARTEZ)**2*XINFIX+
     *                        RADI_P(KARTEZ)**2*XIZFIX)/(XINFIX+XIZFIX))
C
      END DO
C
      DO KARTEZ=1,NDKART
C
         ANGU_T(KARTEZ)=ANGU_N(KARTEZ)+ANGU_P(KARTEZ)
         SPIN_T(KARTEZ)=SPIN_N(KARTEZ)+SPIN_P(KARTEZ)
C
      END DO
C
C=======================================================================
C        ATTENTION: IN THE AVERAGE MOMENTUM SQUARED, THE  NEUTRON-PROTON
C                   TERM WAS MISSING IN VERSIONS UP TO 2.39L,  AND  THIS
C                   BUG HAS BEEN CORRECTED IN VERSION 2.39M ON 31/05/09.
C=======================================================================
C
      TLINSQ=0.0D0
      TKINSQ=C_ZERO
C
      DO KARTEZ=1,NDKART
C
         DLINST(KARTEZ)=DLINSN(KARTEZ)+DLINSP(KARTEZ)
         ELINST(KARTEZ)=ELINSN(KARTEZ)+ELINSP(KARTEZ)
         PLINST(KARTEZ)=PLINSN(KARTEZ)+PLINSP(KARTEZ)
         TLINST(KARTEZ)=TLINSN(KARTEZ)+TLINSP(KARTEZ)
     *               +2*ALINLN(KARTEZ)*ALINLP(KARTEZ)
         ALINLT(KARTEZ)=ALINLN(KARTEZ)+ALINLP(KARTEZ)
         PLINLT(KARTEZ)=PLINLN(KARTEZ)+PLINLP(KARTEZ)
         PLINKT(KARTEZ)=PLINKN(KARTEZ)+PLINKP(KARTEZ)
C
         TLINSQ        =TLINSQ
     *                 +ALINLN(KARTEZ)*ALINLP(KARTEZ)
C
         DKINST(KARTEZ)=DKINSN(KARTEZ)+DKINSP(KARTEZ)
         EKINST(KARTEZ)=EKINSN(KARTEZ)+EKINSP(KARTEZ)
         PKINST(KARTEZ)=PKINSN(KARTEZ)+PKINSP(KARTEZ)
         TKINST(KARTEZ)=TKINSN(KARTEZ)+TKINSP(KARTEZ)
     *               +2*AKINLN(KARTEZ)*AKINLP(KARTEZ)
         AKINLT(KARTEZ)=AKINLN(KARTEZ)+AKINLP(KARTEZ)
         PKINLT(KARTEZ)=PKINLN(KARTEZ)+PKINLP(KARTEZ)
         PKINKT(KARTEZ)=PKINKN(KARTEZ)+PKINKP(KARTEZ)
C
         TKINSQ        =TKINSQ
     *                 +AKINLN(KARTEZ)*AKINLP(KARTEZ)
C
      END DO
C
      DLINST(0)=DLINSN(0)+DLINSP(0)
      ELINST(0)=ELINSN(0)+ELINSP(0)
      PLINST(0)=PLINSN(0)+PLINSP(0)
      TLINST(0)=TLINSN(0)+TLINSP(0)+2*TLINSQ
      ALINLT(0)=ALINLN(0)+ALINLP(0)+2*TLINSQ
      PLINLT(0)=PLINLN(0)+PLINLP(0)
      PLINKT(0)=PLINKN(0)+PLINKP(0)
C
      DKINST(0)=DKINSN(0)+DKINSP(0)
      EKINST(0)=EKINSN(0)+EKINSP(0)
      PKINST(0)=PKINSN(0)+PKINSP(0)
      TKINST(0)=TKINSN(0)+TKINSP(0)+2*TKINSQ
      AKINLT(0)=AKINLN(0)+AKINLP(0)+2*TKINSQ
      PKINLT(0)=PKINLN(0)+PKINLP(0)
      PKINKT(0)=PKINKN(0)+PKINKP(0)
C
C=======================================================================
C
      TROTSQ=0.0D0
      TKOTSQ=C_ZERO
C
      DO KARTEZ=1,NDKART
C
         DROTST(KARTEZ)=DROTSN(KARTEZ)+DROTSP(KARTEZ)
         EROTST(KARTEZ)=EROTSN(KARTEZ)+EROTSP(KARTEZ)
         PROTST(KARTEZ)=PROTSN(KARTEZ)+PROTSP(KARTEZ)
         TROTST(KARTEZ)=TROTSN(KARTEZ)+TROTSP(KARTEZ)
     *               +2*AROTLN(KARTEZ)*AROTLP(KARTEZ)
         AROTLT(KARTEZ)=AROTLN(KARTEZ)+AROTLP(KARTEZ)
         PROTLT(KARTEZ)=PROTLN(KARTEZ)+PROTLP(KARTEZ)
         PROTKT(KARTEZ)=PROTKN(KARTEZ)+PROTKP(KARTEZ)
C
         TROTSQ        =TROTSQ
     *                 +AROTLN(KARTEZ)*AROTLP(KARTEZ)
C
         DKOTST(KARTEZ)=DKOTSN(KARTEZ)+DKOTSP(KARTEZ)
         EKOTST(KARTEZ)=EKOTSN(KARTEZ)+EKOTSP(KARTEZ)
         PKOTST(KARTEZ)=PKOTSN(KARTEZ)+PKOTSP(KARTEZ)
         TKOTST(KARTEZ)=TKOTSN(KARTEZ)+TKOTSP(KARTEZ)
     *               +2*AKOTLN(KARTEZ)*AKOTLP(KARTEZ)
         AKOTLT(KARTEZ)=AKOTLN(KARTEZ)+AKOTLP(KARTEZ)
         PKOTLT(KARTEZ)=PKOTLN(KARTEZ)+PKOTLP(KARTEZ)
         PKOTKT(KARTEZ)=PKOTKN(KARTEZ)+PKOTKP(KARTEZ)
C
         TKOTSQ        =TKOTSQ
     *                 +AKOTLN(KARTEZ)*AKOTLP(KARTEZ)
C
      END DO
C
      DROTST(0)=DROTSN(0)+DROTSP(0)
      EROTST(0)=EROTSN(0)+EROTSP(0)
      PROTST(0)=PROTSN(0)+PROTSP(0)
      TROTST(0)=TROTSN(0)+TROTSP(0)+2*TROTSQ
      AROTLT(0)=AROTLN(0)+AROTLP(0)+2*TROTSQ
      PROTLT(0)=PROTLN(0)+PROTLP(0)
      PROTKT(0)=PROTKN(0)+PROTKP(0)
C
      DKOTST(0)=DKOTSN(0)+DKOTSP(0)
      EKOTST(0)=EKOTSN(0)+EKOTSP(0)
      PKOTST(0)=PKOTSN(0)+PKOTSP(0)
      TKOTST(0)=TKOTSN(0)+TKOTSP(0)+2*TKOTSQ
      AKOTLT(0)=AKOTLN(0)+AKOTLP(0)+2*TKOTSQ
      PKOTLT(0)=PKOTLN(0)+PKOTLP(0)
      PKOTKT(0)=PKOTKN(0)+PKOTKP(0)
C
C=======================================================================
C
      RETURN
      END
C
#if(USE_MPI==1)
C=======================================================================
C
      SUBROUTINE batch(NFIREP,NFIREC,NUDATA,FILREP,FILREC,IF_THO,
     *                        NXHERM,NYHERM,NZHERM,IRENMA,IRENIN,
     *                 REFERN,REFERP,REDELN,REDELP,REFE2N,REFE2P,
     *                 IFIBLN,INIBLN,IFIBLP,INIBLP,NMUMAX,NSIMAX,
     *                                             NMUCON,ISHIFT,
     *                 ICONTI,IPCONT,ILCONT,IACONT,IGCONT,IGPCON,
     *                                             IMCONT,IRCONT,
     *                 IPAIRI,LIPKIN,LIPKIP,I_GOGA,IGOGPA,I_YUKA,
     *                                             JETACM,KETA_R,
     *                 Q_NECK,QACTUA,QORIGI,QINCRE,INDJOB,batch_init)
C=======================================================================
      USE hfodd_mpiio
      USE hfodd_sizes
C=======================================================================
C
      LOGICAL
     *          INCREP,INCREC
      INTEGER
     *          batch_init
      CHARACTER
     *          FILREP*68,FILREC*68
C
      DIMENSION
     *          QACTUA(0:NDMULT,-NDMULT:NDMULT),
     *          QORIGI(0:NDMULT,-NDMULT:NDMULT),
     *	        QINCRE(0:NDMULT,-NDMULT:NDMULT)
C
      COMMON
     *       /ITERTS/ ITESTA,ITESTO,NOITER,NUMITE
      COMMON
     *       /CFIPRI/ NFIPRI
      COMMON
     *       /QCNSTR/ STIFFQ(0:NDMULT,-NDMULT:NDMULT),
     *                QASKED(0:NDMULT,-NDMULT:NDMULT),
     *                IFLAGQ(0:NDMULT,-NDMULT:NDMULT)
      COMMON
     *       /QMULTI/ QMUL_N(0:NDMULT,-NDMULT:NDMULT),
     *                QMUL_P(0:NDMULT,-NDMULT:NDMULT),
     *                QMUL_T(0:NDMULT,-NDMULT:NDMULT)
C@@@ NECK - NECK - NECK - NECK - NECK - NECK - NECK - NECK - NECK
      COMMON
     *       /NCKVAL/ Q0NECK,G_NECK
     *       /NCKFLA/ IFNECK
C@@@ NECK - NECK - NECK - NECK - NECK - NECK - NECK - NECK - NECK
C
C=======================================================================
C
C                        PARALLEL BATCH MODE
C
C       In parallel mode, this is the option to approach the target
C       value of a given constraint (multipole moments or neck) by
C       n_batch consecutive "batch" increments. Each batch sequence
C       uses only N/n_batch iterations. The target value for a given
C       batch sequence k is
C                            q_orig + (k-1) \delta q,
C       with
C                  \delta q = (q_target - q_orig)/n_batch
C
C       q_target is the original requested value for the constraint,
C       and q_orig the value of that constraint read from disk (if
C       not, it is zero). Such a construct is convenient to perform
C       multi-constrained calculations where the values of the
C       constraints are "large" compared to the initial solutions.
C
C=======================================================================
C
      IF (batch_init.EQ.1) THEN
C
          WRITE(NFIPRI,'(79(''*''),/,''*'',77X,''*'',/,
     *          ''*      PARALLEL BATCH MODE: INITIALIZATION'',36X,
     *          ''*'',/,''*  NUMBER OF BATCHES: '',I3,53X,''*'',/,
     *          ''*  MULTIPOLE MOMENTS'',58X,''*'',/,
     *          ''*      LAMBDA   MIU   VALUE READ   '',
     *          ''REQUESTED      TARGET     INCREMENT        *'')')
     *
     *            number_batch
C
C          Manipulation of the record files: in parallel batch
C          jobs, the record and replay files in continuation mode
C          are originally distinct. After the first batch sequence,
C          they must be the same: we rename them, close them both,
C          and reopen the unique file
C
          INCREC=.FALSE.
          INCREP=.FALSE.
C
          INQUIRE(UNIT=NFIREP,OPENED=INCREP)
                                 IF (INCREP) CLOSE(NFIREP)
          INQUIRE(UNIT=NFIREC,OPENED=INCREC)
                                 IF (INCREC) CLOSE(NFIREC)
C
          NFIREP=NFIREC
          FILREP=FILREC
C
          IERROR=0
          OPEN(NFIREP,FILE=FILREP,STATUS='UNKNOWN',IOSTAT=IERROR,
     *                FORM='UNFORMATTED')
C
          IF (IERROR.NE.0) THEN
C
              WRITE(NFIPRI,'(/,1X,26(1H/),2X,
     *                 ''FILE NOT FOUND ON DISC'',
     *                                             2X,26(1H/),/,
     *                 1X, 3(1H/),2X,68X,          2X, 3(1H/),/,
     *                 1X, 3(1H/),2X,A68,          2X, 3(1H/),/,
     *                 1X, 3(1H/),2X,68X,          2X, 3(1H/),/,
     *                 1X,26(1H/),2X,''FILE NOT FOUND ON DISC'',
     *                                             2X,26(1H/))')
     *             FILREP
C
               STOP ' FILE FILREP NOT FOUND ON DISC'
C
          END IF
C
C          Reset of continuation flags to 1: this is *not* official
C          HFODD practice and is only allowed in this experimental
C          version.
C
	  IF (IF_THO.EQ.0) THEN
C
	      ICONTI=1
	      IACONT=1
	      IF (IPAIRI.GE.1) IPCONT=1
	      IF (LIPKIN.EQ.1.OR.LIPKIP.EQ.1) ILCONT=1
	      IF (I_GOGA.GE.1) IGCONT=1
	      IF (IGOGPA.GE.1) IGPCON=1
	      IF (I_YUKA.GE.1) IYCONT=1
	      IF (JETACM.EQ.2) IMCONT=1
	      IF (KETA_R.EQ.2) IRCONT=1
C
          END IF
C
      END IF
C
      IF (number_batch.GT.1) THEN
C
C          First batch: reset the increment to take into account the
C                       values of the constraints read from disk
C
      	  IF (NUDATA.EQ.1) THEN
C
C              Number of iteration per batch item
              NOITER = NOITER / number_batch
C
              IF (NOITER.EQ.0) NOITER=1
C
              ITESTO = NUMITE + NOITER
C
              DO i=1,number_constraint_batch
C
                 LAMACT = lambda_batch(i)
                 MIUACT =    miu_batch(i)
C
                 IF (LAMACT.EQ.0.AND.MIUACT.EQ.0) THEN
C
                     QORIGI(LAMACT,MIUACT) = Q0NECK
                     QACTUA(LAMACT,MIUACT) = Q_NECK
C
                     QSHIFT = QORIGI(LAMACT,MIUACT)
     *                      - QACTUA(LAMACT,MIUACT)
                     QINCRE(LAMACT,MIUACT) = QSHIFT / number_batch
C
C                     New target value for the first batch
                     Q0NECK = QACTUA(LAMACT,MIUACT)
     *                      + QINCRE(LAMACT,MIUACT)
     *                                *REAL(NUDATA,KIND=8)
C
      	             WRITE(NFIPRI,'(''*'',3X,2(6X,I1),4(5X,F8.3),
     *                              8X,''*'')')
     *                           LAMACT,MIUACT,QACTUA(LAMACT,MIUACT),
     *                   QORIGI(LAMACT,MIUACT),Q0NECK,
     *                   QINCRE(LAMACT,MIUACT)
C
                 ELSE
C
                     QORIGI(LAMACT,MIUACT) = QASKED(LAMACT,MIUACT)
                     QACTUA(LAMACT,MIUACT) = QMUL_T(LAMACT,MIUACT)
C
                     QSHIFT = QORIGI(LAMACT,MIUACT)
     *                      - QACTUA(LAMACT,MIUACT)
                     QINCRE(LAMACT,MIUACT) = QSHIFT / number_batch
C
C                     New target value for the first batch
                     QASKED(LAMACT,MIUACT) = QACTUA(LAMACT,MIUACT)
     *                                     + QINCRE(LAMACT,MIUACT)
     *                                        *REAL(NUDATA,KIND=8)
C
      	             WRITE(NFIPRI,'(''*'',3X,2(6X,I1),4(5X,F8.3),
     *                              8X,''*'')')
     *                           LAMACT,MIUACT,QACTUA(LAMACT,MIUACT),
     *                   QORIGI(LAMACT,MIUACT),QASKED(LAMACT,MIUACT),
     *                   QINCRE(LAMACT,MIUACT)
C
                 END IF
C
              END DO
C
              WRITE(NFIPRI,'(''*'',77X,''*'',/,79(''*''),/)')
C
C              When relooping in parallel mode, do not read data again
              batch_init = 0
C
C          All other batches: increment the target value
C
          ELSE
C
C              If HFBTHO is used, continuation modes are set to 0, and
C              HFODD record files are not read. The call below is needed
C              to update the value Fermi levels.
C
	      IF (IF_THO.EQ.1) THEN
C
                  INPFLD=1
                  IERROR=0
                  ICCONT=1
C
                  CALL RECORD(NFIREP,NFIREC,INPFLD,NUMITE,
     *                               NXHERM,NYHERM,NZHERM,
     *                                      IPCONT,ILCONT,
     *                               IACONT,IMCONT,IRCONT,
     *                                      IRENMA,IRENIN,
     *                                      LIPKIN,LIPKIP,
     *                                      REFERN,REFERP,
     *                                      REDELN,REDELP,
     *                                      REFE2N,REFE2P,
     *                                      IFIBLN,INIBLN,
     *                                      IFIBLP,INIBLP,
     *                                      NMUMAX,NSIMAX,
     *                                      NMUCON,ISHIFT,
     *                                             IERROR)
              END IF
C
              WRITE(NFIPRI,'(79(''*''),/,''*'',77X,''*'',/,
     *              ''*      PARALLEL BATCH MODE: CALCULATION OF '',
     *              ''BATCH NUMBER '',I3,19X,''*'',/,
     *              ''*  MULTIPOLE MOMENTS'',58X,''*'',/,
     *              ''*      LAMBDA   MIU   VALUE READ   '',
     *              ''REQUESTED      TARGET     INCREMENT        *'')')
     *
     *                NUDATA
C
              DO i=1,number_constraint_batch
C
                 LAMACT = lambda_batch(i)
                 MIUACT =    miu_batch(i)
C
                 IF (LAMACT.EQ.0.AND.MIUACT.EQ.0) THEN
C
                     Q0NECK = QACTUA(LAMACT,MIUACT)
     *                      + QINCRE(LAMACT,MIUACT)
     *                                *REAL(NUDATA,KIND=8)
C
      	             WRITE(NFIPRI,'(''*'',3X,2(6X,I1),4(5X,F8.3),
     *                              8X,''*'')')
     *                           LAMACT,MIUACT,QACTUA(LAMACT,MIUACT),
     *                   QORIGI(LAMACT,MIUACT),Q0NECK,
     *                   QINCRE(LAMACT,MIUACT)
C
                 ELSE
C
                     QASKED(LAMACT,MIUACT) = QACTUA(LAMACT,MIUACT)
     *                                     + QINCRE(LAMACT,MIUACT)
     *                                       * REAL(NUDATA,KIND=8)
C
      	             WRITE(NFIPRI,'(''*'',3X,2(6X,I1),4(5X,F8.3),
     *                              8X,''*'')')
     *                           LAMACT,MIUACT,QACTUA(LAMACT,MIUACT),
     *                   QORIGI(LAMACT,MIUACT),QASKED(LAMACT,MIUACT),
     *                   QINCRE(LAMACT,MIUACT)
C
                 END IF
C
              END DO
C
              WRITE(NFIPRI,'(''*'',77X,''*'',/,79(''*''),/)')
C
          END IF
C
      END IF
C
      RETURN
      END
#endif
C=======================================================================
C
      SUBROUTINE NUMCON(LAMPUS,MIUPUS,QMOPUS,NUMPUS,IF_RPA,IFPUSH,
     *                                                     DOPUSH)
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      integer, dimension(:), pointer :: LAMPUS, MIUPUS
C
      double precision, dimension(:), pointer :: QMOPUS
C
      LOGICAL
     *        DOPUSH
C
      COMMON
     *       /CNSCOR/ LAMCNS(1:NDCONS),MIUCNS(1:NDCONS)
     *       /CNSNUM/ NOFCNS
      COMMON
     *       /QCNSTR/ STIFFQ(0:NDMULT,-NDMULT:NDMULT),
     *                QASKED(0:NDMULT,-NDMULT:NDMULT),
     *                IFLAGQ(0:NDMULT,-NDMULT:NDMULT)
      COMMON
     *       /NCKFLA/ IFNECK
C
C=======================================================================
C
      NOFCNS=0
C
C      Activating or deactivating the extra constraints based on boolean
C      variable DOPUSH
C
      IF (DOPUSH) THEN
C
         DO I=1,NUMPUS
C
            LAMBDA=ABS(LAMPUS(I))
            MIU   =MIUPUS(I)
            QASKED(LAMBDA,MIU)=QMOPUS(I)
            IFLAGQ(LAMBDA,MIU)=1
C
         END DO
C
      ELSE
C
         IF (IFPUSH.EQ.1) THEN
C
             DO I=1,NUMPUS
C
                LAMBDA=ABS(LAMPUS(I))
                MIU   =MIUPUS(I)
                QASKED(LAMBDA,MIU)=QMOPUS(I)
                IFLAGQ(LAMBDA,MIU)=0
C
             END DO
C
          END IF
C
      END IF
C
C     Computing the number of linear constraints.
C
      IF (IF_RPA.GE.1) THEN
C
          ICOUNT=0
C
          DO LAMBDA=0,NDMULT
             DO MIU=0,LAMBDA
C
                IF (IFLAGQ(LAMBDA,MIU).EQ.1) THEN
C
                    ICOUNT=ICOUNT+1
                    LAMCNS(ICOUNT)=LAMBDA
                    MIUCNS(ICOUNT)=MIU
C
                END IF
C
             END DO
          END DO
C
C@@@ NECK - NECK - NECK - NECK - NECK - NECK - NECK - NECK - NECK
C          Additional constraint on the number of particles in the neck
C
                           NOFCNS=ICOUNT
          IF (IFNECK.EQ.2) NOFCNS=NOFCNS+1
C@@@ NECK - NECK - NECK - NECK - NECK - NECK - NECK - NECK - NECK
C
      END IF
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE TESTDI(IN_FIX,IZ_FIX,NXHERM,NYHERM,NZHERM,
     *                                NXMAXX,NYMAXX,NZMAXX,
     *                         ITERUN,ISIMPY,ISIGNY,IPARTY,
     *                                              SLOWOD)
C=======================================================================
      USE MAD_PP
C=======================================================================
      USE hfodd_sizes
      USE hfodd_fission
C=======================================================================
C
      COMPLEX
     *        distance,qneck,asymmetry
C
C=======================================================================
      ALLOCATABLE HAUXPP(:,:)
C=======================================================================
C
      COMMON
     *       /DIMENS/ LDBASE
      COMMON
     *       /CFIPRI/ NFIPRI
C
C=======================================================================
C
      ALLOCATE (HAUXPP(1:NDBASE,1:NDBASE),STAT=IALLOC)
      IF (IALLOC.NE.0) CALL NOALLO('HAUXPP','TESTDI')
C
      CALL distance_operator(IN_FIX,IZ_FIX,NXHERM,NYHERM,NZHERM,NZMAXX,
     *                       ITERUN,ISIMPY,ISIGNY,IPARTY,SLOWOD,HAUXPP)
C
      distance = CMPLX(0.0D0,0.0D0)
      DO J=1,LDBASE
         DO I=1,LDBASE
            distance = distance + CMPLX(HAUXPP(I,J),0.0D0)
     *                          *(DEN_PP(J,I,0,0)+DEN_PP(J,I,1,0)
     *                          + DEN_PP(J,I,0,1)+DEN_PP(J,I,1,1))
         END DO
      END DO
      write(6,'(''Distance = '',2f24.14)') distance
C
      CALL asymmetry_operator(IN_FIX,IZ_FIX,NXHERM,NYHERM,NZHERM,NZMAXX,
     *                        ITERUN,ISIMPY,ISIGNY,IPARTY,SLOWOD,HAUXPP)
C
      asymmetry = CMPLX(0.0D0,0.0D0)
      DO J=1,LDBASE
         DO I=1,LDBASE
            asymmetry = asymmetry + CMPLX(HAUXPP(I,J),0.0D0)
     *                          *(DEN_PP(J,I,0,0)+DEN_PP(J,I,1,0)
     *                          + DEN_PP(J,I,0,1)+DEN_PP(J,I,1,1))
         END DO
      END DO
      write(6,'(''Mass asymmetry = '',2f24.14)') asymmetry
C
      CALL INT_QN(NZMAXX,HAUXPP)
C
      qneck = CMPLX(0.0D0,0.0D0)
      DO J=1,LDBASE
         DO I=1,LDBASE
            qneck = qneck + CMPLX(HAUXPP(I,J),0.0D0)
     *                          *(DEN_PP(J,I,0,0)+DEN_PP(J,I,1,0)
     *                          + DEN_PP(J,I,0,1)+DEN_PP(J,I,1,1))
         END DO
      END DO
      write(6,'(''Qn = '',2f24.14)') qneck
C
      DEALLOCATE(HAUXPP)
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE QMULCM(MREVER,LAMMAX,COFMUL,IBROYD,MIXMAT,SLOWEV,
     *                                       SLOWOD,NUMITE,NZMAXX)
C=======================================================================
      USE SAVQUA
      USE hfodd_fission
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      COMPLEX
     *          C_ZERO,C_UNIT,C_MINU,CPLMUL
      COMPLEX
     *          FN12PL,FP12PL,FN11PL,FP11PL,FN11MI,FP11MI
      COMPLEX
     *          CMPLXN,CMPLXP,CSUM_N,CSUM_P
      COMPLEX
     *          TSTMAT,T_TERM
C=======================================================================
      ALLOCATABLE FN12PL(:,:,:),FP12PL(:,:,:)
      ALLOCATABLE FN11PL(:,:,:),FP11PL(:,:,:)
      ALLOCATABLE FN11MI(:,:,:),FP11MI(:,:,:)
      ALLOCATABLE CMPLXN(:,:),CMPLXP(:,:),CSUM_N(:,:),CSUM_P(:,:)
      ALLOCATABLE TSTMAT(:,:),ELEMUL(:,:),CPLMUL(:,:)
C=======================================================================
      DIMENSION
     *          CNSMAT(1:NDCONS,1:NDCONS)
      DIMENSION
     *          CNSVEC(1:NDCONS),WORKCN(1:NDCONS),VECLAM(1:NDCONS)
      DIMENSION
     *          IPIVOT(1:NDCONS)
      DIMENSION
     *          COFMUL(0:NDMULT,0:NDOSCI,0:NDOSCI,1:NDKART)
C
C@@@ TEMP - TEMP - TEMP - TEMP - TEMP - TEMP - TEMP - TEMP - TEMP
      COMMON
     *       /FERFUN/ FER_FN(1:NDBASE)
     *       /FER_IS/ FERMFN(1:NDBASE,0:NDISOS)
      COMMON
     *       /T_FLAG/ IFTEMP
      COMMON
     *       /GCTEMP/ TEMP_T
C@@@ TEMP - TEMP - TEMP - TEMP - TEMP - TEMP - TEMP - TEMP - TEMP
      COMMON
     *       /CNSQLM/ VECCNS(1:NDCONS)
     *       /CNSOLD/ VECOLD(1:NDCONS)
      COMMON
     *       /CNSCOR/ LAMCNS(1:NDCONS),MIUCNS(1:NDCONS)
     *       /CNSNUM/ NOFCNS
C@@@ NECK - NECK - NECK - NECK - NECK - NECK - NECK - NECK - NECK
      COMMON
     *       /NCKVAL/ Q0NECK,G_NECK
     *       /NCKFLA/ IFNECK
C@@@ NECK - NECK - NECK - NECK - NECK - NECK - NECK - NECK - NECK
      COMMON
     *       /QMULTI/ QMUL_N(0:NDMULT,-NDMULT:NDMULT),
     *                QMUL_P(0:NDMULT,-NDMULT:NDMULT),
     *                QMUL_T(0:NDMULT,-NDMULT:NDMULT)
      COMMON
     *       /QCNSTR/ STIFFQ(0:NDMULT,-NDMULT:NDMULT),
     *                QASKED(0:NDMULT,-NDMULT:NDMULT),
     *                IFLAGQ(0:NDMULT,-NDMULT:NDMULT)
      COMMON
     *       /QLASTR/ GALMUQ(0:NDMULT,-NDMULT:NDMULT),
     *                QLINEA(0:NDMULT,-NDMULT:NDMULT),
     *                IFLALQ(0:NDMULT,-NDMULT:NDMULT)
      COMMON
     *       /OURUNI/ QUNITS(0:NDMULT,0:NDMULT)
      COMMON
     *       /QUAISO/ EQPISO(1:NDBASE,0:NDREVE,0:NDISOS),
     *                VQPISO(1:NDBASE,0:NDREVE,0:NDISOS)
      COMMON
     *       /QUAPER/ DELTEN(1:NDBASE,0:NDREVE),
     *                DELTEP(1:NDBASE,0:NDREVE)
      COMMON
     *       /T_PHAS/ IPHAPP(0:NDYMAX,0:NDYMAX,0:NDKART),
     *                IPHAPM(0:NDYMAX,0:NDYMAX,0:NDKART),
     *                IPHAMP(0:NDYMAX,0:NDYMAX,0:NDKART),
     *                IPHAMM(0:NDYMAX,0:NDYMAX,0:NDKART)
      COMMON
     *       /QPNUMS/ NUMBQP(0:NDREVE,0:NDISOS)
      COMMON
     *       /DIMENS/ LDBASE
      COMMON
     *       /CFIPRI/ NFIPRI
C
C=======================================================================
C       THIS ROUTINE UPDATES THE  LAGRANGE  MULTIPLIERS OF THE MULTI-
C       DIMENSIONAL LINEAR CONSTRAINTS  BASED ON THE VARIATION OF THE
C       GENERALIZED DENSITY MATRIX AND THE RPA MATRIX AT THE CRANKING
C       APPROXIMATION.
C
C       REFERENCES:  (1) Phys. Rev. C21, 1568 (1980)
C                    (2) Phys. Rev. C80, 054313 (2009)
C=======================================================================
C
      CALL CPUTIM('QMULCM',1)
C
C=======================================================================
C
      IALLOC=0
C
C=======================================================================
      ALLOCATE(ELEMUL(1:NDBASE,1:NDBASE))
      IF (IALLOC.NE.0) CALL NOALLO('ELEMUL','QMULCM')
      ALLOCATE(CPLMUL(1:NDBASE,1:NDBASE))
      IF (IALLOC.NE.0) CALL NOALLO('CPLMUL','QMULCM')
C=======================================================================
C
C@@@ NECK - NECK - NECK - NECK - NECK - NECK - NECK - NECK - NECK
      IF (IFNECK.LE.1) THEN
C
          DO I=1,NOFCNS
             LAMBDA   =LAMCNS(I)
             MIU      =MIUCNS(I)
             VECOLD(I)=GALMUQ(LAMBDA,MIU)
          END DO
C
      ELSE
C
          DO I=1,NOFCNS-1
             LAMBDA   =LAMCNS(I)
             MIU      =MIUCNS(I)
             VECOLD(I)=GALMUQ(LAMBDA,MIU)
          END DO
C
          VECOLD(NOFCNS)=G_NECK
C
      END IF
C@@@ NECK - NECK - NECK - NECK - NECK - NECK - NECK - NECK - NECK
C
      R_ZERO=0.0D0
      R_UNIT=1.0D0
C
      C_UNIT=CMPLX( R_UNIT,R_ZERO)
      C_ZERO=CMPLX( R_ZERO,R_ZERO)
      C_MINU=CMPLX(-R_UNIT,R_ZERO)
C
C      Constructing the vector of the deviations of the current constraint
C      from the requested values
C
      ICOUNT=0
C
      DO LAMBDA=0,LAMMAX
         DO MIU=0,LAMBDA
C
            IF (IFLAGQ(LAMBDA,MIU).EQ.1) THEN
C
                ICOUNT=ICOUNT+1
                CNSVEC(ICOUNT)=QASKED(LAMBDA,MIU)-QMUL_N(LAMBDA,MIU)
     *                                           -QMUL_P(LAMBDA,MIU)
                VECLAM(ICOUNT)=GALMUQ(LAMBDA,MIU)
C
            END IF
C
         END DO
      END DO
C
C@@@ NECK - NECK - NECK - NECK - NECK - NECK - NECK - NECK - NECK
C      Constraint on the number of particles in the neck
C
      IF (IFNECK.EQ.2) THEN
C
          ICOUNT=ICOUNT+1
          CNSVEC(ICOUNT)=Q0NECK-Q_NECK
          VECLAM(ICOUNT)=G_NECK
C
      END IF
C@@@ NECK - NECK - NECK - NECK - NECK - NECK - NECK - NECK - NECK
C
C      Proceeding to determine the matrix of the constraint operators
C      in the q.p. basis
C
      ALLOCATE (FN12PL(1:NDSTAT,1:NDSTAT,1:NOFCNS),STAT=IALLOC)
      IF (IALLOC.NE.0) CALL NOALLO('FN12PL','QMULCM')
      ALLOCATE (FP12PL(1:NDSTAT,1:NDSTAT,1:NOFCNS),STAT=IALLOC)
      IF (IALLOC.NE.0) CALL NOALLO('FP12PL','QMULCM')
C
      FN12PL(:,:,:) = C_ZERO
      FP12PL(:,:,:) = C_ZERO
C
      ALLOCATE (FN11PL(1:NDSTAT,1:NDSTAT,1:NOFCNS),STAT=IALLOC)
      IF (IALLOC.NE.0) CALL NOALLO('FN11PL','QMULCM')
      ALLOCATE (FP11PL(1:NDSTAT,1:NDSTAT,1:NOFCNS),STAT=IALLOC)
      IF (IALLOC.NE.0) CALL NOALLO('FP11PL','QMULCM')
      ALLOCATE (FN11MI(1:NDSTAT,1:NDSTAT,1:NOFCNS),STAT=IALLOC)
      IF (IALLOC.NE.0) CALL NOALLO('FN11MI','QMULCM')
      ALLOCATE (FP11MI(1:NDSTAT,1:NDSTAT,1:NOFCNS),STAT=IALLOC)
      IF (IALLOC.NE.0) CALL NOALLO('FP11MI','QMULCM')
C
      FN11PL(:,:,:) = C_ZERO
      FP11PL(:,:,:) = C_ZERO
      FN11MI(:,:,:) = C_ZERO
      FP11MI(:,:,:) = C_ZERO
C
      IMAREA=1
C
C      Neutron sector
C
      ICHARG=0
C
      ALLOCATE (CMPLXN(1:NDBASE,1:NDSTAT),STAT=IALLOC)
      IF (IALLOC.NE.0) CALL NOALLO('CMPLXN','QMULCM')
C
      CMPLXN(:,:) = C_ZERO
      ELEMUL(:,:) = R_ZERO
C
      DO I=1,NOFCNS
C
C         Matrix of the constraint operator in the HO basis
C
         IF (I.LT.NOFCNS.OR.IFNECK.LE.1) THEN
C
             LAMACT=LAMCNS(I)
             MIUACT=MIUCNS(I)
C
             CALL INTMUL(IPHAPP(0,0,0),ELEMUL,COFMUL,
     *                                 LAMACT,MIUACT,IMAREA)
C
         ELSE
C
             CALL INT_QN(NZMAXX,ELEMUL)
C
         END IF
C
         DO L=1,NDBASE
            DO K=1,NDBASE
               CPLMUL(K,L)=ELEMUL(K,L)*C_UNIT
            END DO
         END DO
C
C         Matrix of the constraint operator in the qp basis. Due to
C         the q.p. cut-off the actual size of the q.p. basis is not
C         the same as the s.p. (HO) basis, and it is  not the  same
C         for protons and neutrons.  The formulas implemented below
C         differ from the 2 references for 3 reasons:
C          - different  phase convention for the Bogoliubov  matrix
C          - block structure of the Bogoliubov matrix in HFODD
C          - storage in A() and B() arrays correspond to complex
C            conjugate of the actual matrices
C
C         Second term: V_{+}^{+} F_{+}^{*} U_{+}^{*}
C                    = B_{+}^{T} F_{+}     A_{+}
C
         CALL ZGEMM('N','N',LDBASE,NUMBQP(0,0),LDBASE,
     *                           C_UNIT,CPLMUL,NDBASE,
     *                         ASVQUA(1,1,0,0),NDBASE,
     *                           C_ZERO,CMPLXN,NDSTAT)
C
         CALL ZGEMM('T','N',NUMBQP(0,0),NUMBQP(0,0),LDBASE,
     *                       C_UNIT,BSVQUA(1,1,0,0),NDBASE,
     *                                       CMPLXN,NDSTAT,
     *                         C_ZERO,FN12PL(1,1,I),NDSTAT)
C
C         First term:  U_{-}^{+} F_{-} V_{-}^{*}
C                    = A_{-}^{T} F_{-} B_{-}
C
         CALL ZGEMM('N','N',LDBASE,NUMBQP(1,0),LDBASE,
     *                           C_UNIT,CPLMUL,NDBASE,
     *                         BSVQUA(1,1,1,0),NDBASE,
     *                           C_ZERO,CMPLXN,NDSTAT)
C
         CALL ZGEMM('T','N',NUMBQP(1,0),NUMBQP(1,0),LDBASE,
     *                       C_UNIT,ASVQUA(1,1,1,0),NDBASE,
     *                                       CMPLXN,NDSTAT,
     *                         C_MINU,FN12PL(1,1,I),NDSTAT)
C
C         Computing \tilde{F}^{11}
C
C         Second term: V_{+}^{+} F_{+}^{*} V_{+}
C                    = B_{+}^{T}(B_{+}^{T} F_{+}^{T})^{+}
C
         CALL ZGEMM('T','T',NUMBQP(0,0),LDBASE,LDBASE,
     *                  C_UNIT,BSVQUA(1,1,0,0),NDBASE,
     *                                  CPLMUL,NDBASE,
     *                           C_ZERO,CMPLXN,NDSTAT)
C
         CALL ZGEMM('T','C',NUMBQP(0,0),NUMBQP(0,0),LDBASE,
     *                       C_UNIT,BSVQUA(1,1,0,0),NDBASE,
     *                                       CMPLXN,NDSTAT,
     *                         C_ZERO,FN11PL(1,1,I),NDSTAT)
C
C         First term:  U_{-}^{+} F_{-} U_{-}
C                    = A_{-}^{T}(A_{-}^{T} F_{-}^{+})^{+}
C
         CALL ZGEMM('T','C',NUMBQP(1,0),LDBASE,LDBASE,
     *                  C_UNIT,ASVQUA(1,1,1,0),NDBASE,
     *                                  CPLMUL,NDBASE,
     *                           C_ZERO,CMPLXN,NDSTAT)
C
         CALL ZGEMM('T','C',NUMBQP(1,0),NUMBQP(1,0),LDBASE,
     *                       C_UNIT,ASVQUA(1,1,1,0),NDBASE,
     *                                       CMPLXN,NDSTAT,
     *                         C_MINU,FN11PL(1,1,I),NDSTAT)
C
C
C
         CALL ZGEMM('T','T',NUMBQP(1,0),LDBASE,LDBASE,
     *                  C_UNIT,BSVQUA(1,1,1,0),NDBASE,
     *                                  CPLMUL,NDBASE,
     *                           C_ZERO,CMPLXN,NDSTAT)
C
         CALL ZGEMM('T','C',NUMBQP(1,0),NUMBQP(1,0),LDBASE,
     *                       C_UNIT,BSVQUA(1,1,1,0),NDBASE,
     *                                       CMPLXN,NDSTAT,
     *                         C_ZERO,FN11MI(1,1,I),NDSTAT)
C
         CALL ZGEMM('T','C',NUMBQP(0,0),LDBASE,LDBASE,
     *                  C_UNIT,ASVQUA(1,1,0,0),NDBASE,
     *                                  CPLMUL,NDBASE,
     *                           C_ZERO,CMPLXN,NDSTAT)
C
         CALL ZGEMM('T','C',NUMBQP(0,0),NUMBQP(0,0),LDBASE,
     *                       C_UNIT,ASVQUA(1,1,0,0),NDBASE,
     *                                       CMPLXN,NDSTAT,
     *                         C_MINU,FN11MI(1,1,I),NDSTAT)
C
      END DO
C
      DEALLOCATE(CMPLXN)
C
C      Proton sector
C
      ICHARG=1
C
      ALLOCATE (CMPLXP(1:NDBASE,1:NDSTAT),STAT=IALLOC)
      IF (IALLOC.NE.0) CALL NOALLO('CMPLXP','QMULCM')
C
      CMPLXP(:,:) = C_ZERO
      ELEMUL(:,:) = R_ZERO
C
      DO I=1,NOFCNS
C
C         Matrix of the constraint operator in the HO basis
C
         IF (I.LT.NOFCNS.OR.IFNECK.LE.1) THEN
C
             LAMACT=LAMCNS(I)
             MIUACT=MIUCNS(I)
C
             CALL INTMUL(IPHAPP(0,0,0),ELEMUL,COFMUL,
     *                                 LAMACT,MIUACT,IMAREA)
C
         ELSE
C
             CALL INT_QN(NZMAXX,ELEMUL)
C
         END IF
C
         DO L=1,NDBASE
            DO K=1,NDBASE
               CPLMUL(K,L)=ELEMUL(K,L)*C_UNIT
            END DO
         END DO
C
C         Second term: V_{+}^{+} F_{+}^{*} U_{+}^{*}
C                    = B_{+}^{T} F_{+}     A_{+}
C
         CALL ZGEMM('N','N',LDBASE,NUMBQP(0,1),LDBASE,
     *                           C_UNIT,CPLMUL,NDBASE,
     *                         ASVQUA(1,1,0,1),NDBASE,
     *                           C_ZERO,CMPLXP,NDSTAT)
C
         CALL ZGEMM('T','N',NUMBQP(0,1),NUMBQP(0,1),LDBASE,
     *                       C_UNIT,BSVQUA(1,1,0,1),NDBASE,
     *                                       CMPLXP,NDSTAT,
     *                         C_ZERO,FP12PL(1,1,I),NDSTAT)
C
C         First term:  U_{-}^{+} F_{-} V_{-}^{*}
C                    = A_{-}^{T} F_{-} B_{-}
C
         CALL ZGEMM('N','N',LDBASE,NUMBQP(0,1),LDBASE,
     *                           C_UNIT,CPLMUL,NDBASE,
     *                         BSVQUA(1,1,1,1),NDBASE,
     *                           C_ZERO,CMPLXP,NDSTAT)
C
         CALL ZGEMM('T','N',NUMBQP(0,1),NUMBQP(0,1),LDBASE,
     *                       C_UNIT,ASVQUA(1,1,1,1),NDBASE,
     *                                       CMPLXP,NDSTAT,
     *                         C_MINU,FP12PL(1,1,I),NDSTAT)
C
C         Computing \tilde{F}^{11}
C
C         Second term: V_{+}^{+} F_{+}^{*} V_{+}
C                    = B_{+}^{T}(B_{+}^{T} F_{+}^{T})^{+}
C
         CALL ZGEMM('T','T',NUMBQP(0,1),LDBASE,LDBASE,
     *                  C_UNIT,BSVQUA(1,1,0,1),NDBASE,
     *                                  CPLMUL,NDBASE,
     *                           C_ZERO,CMPLXP,NDSTAT)
C
         CALL ZGEMM('T','C',NUMBQP(0,1),NUMBQP(0,1),LDBASE,
     *                       C_UNIT,BSVQUA(1,1,0,1),NDBASE,
     *                                       CMPLXP,NDSTAT,
     *                         C_ZERO,FP11PL(1,1,I),NDSTAT)
C
C         First term:  U_{-}^{+} F_{-} U_{-}
C                    = A_{-}^{T}(A_{-}^{T} F_{-}^{+})^{+}
C
         CALL ZGEMM('T','C',NUMBQP(1,1),LDBASE,LDBASE,
     *                  C_UNIT,ASVQUA(1,1,1,1),NDBASE,
     *                                  CPLMUL,NDBASE,
     *                           C_ZERO,CMPLXP,NDSTAT)
C
         CALL ZGEMM('T','C',NUMBQP(1,1),NUMBQP(1,1),LDBASE,
     *                       C_UNIT,ASVQUA(1,1,1,1),NDBASE,
     *                                       CMPLXP,NDSTAT,
     *                         C_MINU,FP11PL(1,1,I),NDSTAT)
C
C
C
         CALL ZGEMM('T','T',NUMBQP(1,1),LDBASE,LDBASE,
     *                  C_UNIT,BSVQUA(1,1,1,1),NDBASE,
     *                                  CPLMUL,NDBASE,
     *                           C_ZERO,CMPLXP,NDSTAT)
C
         CALL ZGEMM('T','C',NUMBQP(1,1),NUMBQP(1,1),LDBASE,
     *                       C_UNIT,BSVQUA(1,1,1,1),NDBASE,
     *                                       CMPLXP,NDSTAT,
     *                         C_ZERO,FP11MI(1,1,I),NDSTAT)
C
         CALL ZGEMM('T','C',NUMBQP(0,1),LDBASE,LDBASE,
     *                  C_UNIT,ASVQUA(1,1,0,1),NDBASE,
     *                                  CPLMUL,NDBASE,
     *                           C_ZERO,CMPLXP,NDSTAT)
C
         CALL ZGEMM('T','C',NUMBQP(0,1),NUMBQP(0,1),LDBASE,
     *                       C_UNIT,ASVQUA(1,1,0,1),NDBASE,
     *                                       CMPLXP,NDSTAT,
     *                         C_MINU,FP11MI(1,1,I),NDSTAT)
C
      END DO
C
      DEALLOCATE(CMPLXP)
C
C      Computing the correlation matrix of the multiple constraints
C
      ALLOCATE (CMPLXN(1:NDSTAT,1:NDSTAT),STAT=IALLOC)
      IF (IALLOC.NE.0) CALL NOALLO('CMPLXN','QMULCM')
      ALLOCATE (CMPLXP(1:NDSTAT,1:NDSTAT),STAT=IALLOC)
      IF (IALLOC.NE.0) CALL NOALLO('CMPLXP','QMULCM')
      ALLOCATE (CSUM_N(1:NDSTAT,1:NDSTAT),STAT=IALLOC)
      IF (IALLOC.NE.0) CALL NOALLO('CMPLXP','QMULCM')
      ALLOCATE (CSUM_P(1:NDSTAT,1:NDSTAT),STAT=IALLOC)
      IF (IALLOC.NE.0) CALL NOALLO('CMPLXP','QMULCM')
C
      CMPLXN(:,:) = C_ZERO
      CMPLXP(:,:) = C_ZERO
      CSUM_N(:,:) = C_ZERO
      CSUM_P(:,:) = C_ZERO
C
      DO I=1,NOFCNS
         DO J=1,NOFCNS
C
            IF (IFTEMP.EQ.0) THEN
C
                DO L=1,NUMBQP(0,0)
                   DO K=1,NUMBQP(0,0)
                      CMPLXN(K,L)=CONJG(FN12PL(K,L,I))
     *                          /(EQPISO(K,0,0)+EQPISO(L,0,0))
                   END DO
                END DO
C
                DO L=1,NUMBQP(0,1)
                   DO K=1,NUMBQP(0,1)
                      CMPLXP(K,L)=CONJG(FP12PL(K,L,I))
     *                          /(EQPISO(K,0,1)+EQPISO(L,0,1))
                   END DO
                END DO
C
                CALL ZGEMM('T','N',NUMBQP(0,0),NUMBQP(0,0),NUMBQP(0,0),
     *                                C_UNIT,FN12PL(1,1,J),NDSTAT,
     *                                              CMPLXN,NDSTAT,
     *                                       C_ZERO,CSUM_N,NDSTAT)
C
                CALL ZGEMM('T','N',NUMBQP(0,1),NUMBQP(0,1),NUMBQP(0,1),
     *                                C_UNIT,FP12PL(1,1,J),NDSTAT,
     *                                              CMPLXP,NDSTAT,
     *                                       C_ZERO,CSUM_P,NDSTAT)
C
            ELSE
C
C                Term corresponding to F^12
C
                DO L=1,NUMBQP(0,0)
                   DO K=1,NUMBQP(0,0)
                      TEMP_K=FERMFN(K,0)
                      TEMP_L=FERMFN(L,0)
                      CMPLXN(K,L)=CONJG(FN12PL(K,L,I))
     *                          *(1.0+TEMP_K+TEMP_L)
     *                          /(EQPISO(K,0,0)+EQPISO(L,0,0))
                   END DO
                END DO
C
                DO L=1,NUMBQP(0,1)
                   DO K=1,NUMBQP(0,1)
                      TEMP_K=FERMFN(K,1)
                      TEMP_L=FERMFN(L,1)
                      CMPLXP(K,L)=CONJG(FP12PL(K,L,I))
     *                          *(1.0+TEMP_K+TEMP_L)
     *                          /(EQPISO(K,0,1)+EQPISO(L,0,1))
                   END DO
                END DO
C
                CALL ZGEMM('T','N',NUMBQP(0,0),NUMBQP(0,0),NUMBQP(0,0),
     *                                C_UNIT,FN12PL(1,1,J),NDSTAT,
     *                                              CMPLXN,NDSTAT,
     *                                       C_ZERO,CSUM_N,NDSTAT)
C
                CALL ZGEMM('T','N',NUMBQP(0,1),NUMBQP(0,1),NUMBQP(0,1),
     *                                C_UNIT,FP12PL(1,1,J),NDSTAT,
     *                                              CMPLXP,NDSTAT,
     *                                       C_ZERO,CSUM_P,NDSTAT)
C
C                First term: positive simplex
C
                DO L=1,NUMBQP(0,0)
                   DO K=1,NUMBQP(0,0)
C
                      TEMP_K=FERMFN(K,0)
                      TEMP_L=FERMFN(L,0)
C
	              IF (K.NE.L) THEN
C
                          T_TERM=-(TEMP_K     -TEMP_L)
     *                           /(EQPISO(K,0,0)-EQPISO(L,0,0))
     *
                      ELSE
C
	                  T_TERM=-TEMP_K*(TEMP_K-1.0)/TEMP_T
C
                      END IF
C
	              CMPLXN(K,L)=0.5*T_TERM*FN11PL(K,L,I)
C
                   END DO
                END DO
C
                DO L=1,NUMBQP(0,1)
                   DO K=1,NUMBQP(0,1)
C
                      TEMP_K=FERMFN(K,1)
                      TEMP_L=FERMFN(L,1)
C
	              IF (K.NE.L) THEN
C
                          T_TERM=-(TEMP_K     -TEMP_L)
     *                           /(EQPISO(K,0,1)-EQPISO(L,0,1))
     *
                      ELSE
C
	                  T_TERM=-TEMP_K*(TEMP_K-1.0)/TEMP_T
C
                      END IF
C
	              CMPLXP(K,L)=0.5*T_TERM*FP11PL(K,L,I)
C
                   END DO
                END DO
C
                CALL ZGEMM('N','N',NUMBQP(0,0),NUMBQP(0,0),NUMBQP(0,0),
     *                                C_UNIT,FN11PL(1,1,J),NDSTAT,
     *                                              CMPLXN,NDSTAT,
     *                                       C_UNIT,CSUM_N,NDSTAT)
C
                CALL ZGEMM('N','N',NUMBQP(0,1),NUMBQP(0,1),NUMBQP(0,1),
     *                                C_UNIT,FP11PL(1,1,J),NDSTAT,
     *                                              CMPLXP,NDSTAT,
     *                                       C_UNIT,CSUM_P,NDSTAT)
C
C                Second term: negative simplex
C
                DO L=1,NUMBQP(1,0)
                   DO K=1,NUMBQP(1,0)
C
                      TEMP_K=FERMFN(K,0)
                      TEMP_L=FERMFN(L,0)
C
	              IF (K.NE.L) THEN
C
                          T_TERM=-(TEMP_K     -TEMP_L)
     *                           /(EQPISO(K,1,0)-EQPISO(L,1,0))
     *
                      ELSE
C
	                  T_TERM=-TEMP_K*(TEMP_K-1.0)/TEMP_T
C
                      END IF
C
	              CMPLXN(K,L)=0.5*T_TERM*FN11MI(K,L,I)
C
                   END DO
                END DO
C
                DO L=1,NUMBQP(1,1)
                   DO K=1,NUMBQP(1,1)
C
                      TEMP_K=FERMFN(K,1)
                      TEMP_L=FERMFN(L,1)
C
	              IF (K.NE.L) THEN
C
                          T_TERM=-(TEMP_K     -TEMP_L)
     *                           /(EQPISO(K,1,1)-EQPISO(L,1,1))
     *
                      ELSE
C
	                  T_TERM=-TEMP_K*(TEMP_K-1.0)/TEMP_T
C
                      END IF
C
	              CMPLXP(K,L)=0.5*T_TERM*FP11MI(K,L,I)
C
                   END DO
                END DO
C
                CALL ZGEMM('N','N',NUMBQP(1,0),NUMBQP(1,0),NUMBQP(1,0),
     *                                C_UNIT,FN11MI(1,1,J),NDSTAT,
     *                                              CMPLXN,NDSTAT,
     *                                       C_UNIT,CSUM_N,NDSTAT)
C
                CALL ZGEMM('N','N',NUMBQP(1,1),NUMBQP(1,1),NUMBQP(1,1),
     *                                C_UNIT,FP11MI(1,1,J),NDSTAT,
     *                                              CMPLXP,NDSTAT,
     *                                       C_UNIT,CSUM_P,NDSTAT)
C
            END IF
C
C            Taking the trace of the resulting matrix
C
            RESULT=R_ZERO
            DO L=1,NUMBQP(0,0)
               RESULT=RESULT+REAL(CSUM_N(L,L))
            END DO
            DO L=1,NUMBQP(0,1)
               RESULT=RESULT+REAL(CSUM_P(L,L))
            END DO
C
            CNSMAT(I,J)=RESULT ! Two simplex blocks, but factor 1/2
C
         END DO
C
      END DO
C
      DEALLOCATE(CMPLXN,CMPLXP,CSUM_N,CSUM_P)
C
C      Computing the inverse of the correlation matrix
C
      IERROR=0
C
      CALL DGETRF(NOFCNS,NOFCNS,CNSMAT,NDCONS,IPIVOT,IERROR)
C
      IERROR=0
C
      CALL DGETRI(NOFCNS,CNSMAT,NDCONS,IPIVOT,WORKCN,NDCONS,IERROR)
C
C      Constructing the vector of variations of the linear constraints
C
      CALL DGEMV('N',NOFCNS,NOFCNS,R_UNIT,CNSMAT,NDCONS,CNSVEC,1,
     *                                           R_ZERO,WORKCN,1)
C
C      Updating the linear constraint vector (mixing has to be done
C      simultaneously).
C
      IF (NUMITE.EQ.0) THEN
          BRAKEV=0.0
          BRAKOD=0.0
      ELSE
      	  BRAKEV=SLOWEV
      	  BRAKOD=SLOWOD
      END IF
C
      DO I=1,NOFCNS
C
         VECCNS(I)=VECLAM(I)+WORKCN(I)
C
C@@@ NECK - NECK - NECK - NECK - NECK - NECK - NECK - NECK - NECK
	 IF (I.LT.NOFCNS.OR.IFNECK.LE.1) THEN
C
             LAMACT=LAMCNS(I)
             MIUACT=MIUCNS(I)
C
             IF (IBROYD.LT.1.OR.MIXMAT.EQ.1)
     *           GALMUQ(LAMACT,MIUACT)=BRAKEV *VECOLD(I)
     *                           +(1.0-BRAKEV)*VECCNS(I)
C
	 ELSE
C
             IF (IBROYD.LT.1.OR.MIXMAT.EQ.1)
     *           G_NECK=BRAKOD*VECOLD(I)+(1.0-BRAKOD)*VECCNS(I)
C
	 END IF
C@@@ NECK - NECK - NECK - NECK - NECK - NECK - NECK - NECK - NECK
C
      END DO
C
      DEALLOCATE(FN12PL,FP12PL,FN11PL,FP11PL,FN11MI,FP11MI)
C
C=======================================================================
      DEALLOCATE(ELEMUL,CPLMUL)
C=======================================================================
C
      CALL CPUTIM('QMULCM',0)
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
      SUBROUTINE QCNTRS(NMUCON,EMULCO,EMUSLO,EMUREA,IF_RPA)
C=======================================================================
      USE hfodd_sizes
      USE hfodd_fission
C=======================================================================
      COMMON
     *       /QMULTI/ QMUL_N(0:NDMULT,-NDMULT:NDMULT),
     *                QMUL_P(0:NDMULT,-NDMULT:NDMULT),
     *                QMUL_T(0:NDMULT,-NDMULT:NDMULT)
      COMMON
     *       /QCNSTR/ STIFFQ(0:NDMULT,-NDMULT:NDMULT),
     *                QASKED(0:NDMULT,-NDMULT:NDMULT),
     *                IFLAGQ(0:NDMULT,-NDMULT:NDMULT)
      COMMON
     *       /GCNSTR/ STIFFG(0:NDMULT),
     *                GASKED(0:NDMULT),
     *                IFLAGG(0:NDMULT)
      COMMON
     *       /QLASTR/ GALMUQ(0:NDMULT,-NDMULT:NDMULT),
     *                QLINEA(0:NDMULT,-NDMULT:NDMULT),
     *                IFLALQ(0:NDMULT,-NDMULT:NDMULT)
      COMMON
     *       /OURUNI/ QUNITS(0:NDMULT,0:NDMULT)
C@@@ NECK - NECK - NECK - NECK - NECK - NECK - NECK - NECK - NECK
      COMMON
     *       /NCKVAL/ Q0NECK,G_NECK
     *       /NCKFLA/ IFNECK
C@@@ NECK - NECK - NECK - NECK - NECK - NECK - NECK - NECK - NECK
C=======================================================================
C       THIS SUBROUTINE CALCULATES THE ENERGY CONTRIBUTIONS ASSOCIATED
C       WITH THE MULTIPOLE CONSTRAINTS.
C=======================================================================
C
      EMULCO=0.0D0
      EMUSLO=0.0D0
      EMUREA=0.0D0
C
      DO LAMBDA=0,NMUCON
C
         RESULT=0.0D0
C
         DO MIU=-LAMBDA,LAMBDA
C
            NIU=ABS(MIU)
C
            RESULT=RESULT+(QMUL_T(LAMBDA,MIU)/QUNITS(LAMBDA,NIU))**2
C
         END DO
C
         GMUL_T=SQRT(RESULT)*QUNITS(LAMBDA,0)
C
         DO MIU=-LAMBDA,LAMBDA
C
C=======================================================================
C           QUADRATIC CONSTRAINTS
C=======================================================================
C
            IF (IFLAGQ(LAMBDA,MIU).EQ.1) THEN
C
C                Quadratic constraints only added if the RPA
C                multiconstraint method is not employed
C
                IF (IF_RPA.NE.1) THEN
C
                    EMULCO=EMULCO
     *                + (QMUL_T(LAMBDA,MIU) - QASKED(LAMBDA,MIU))**2
     *                                      * STIFFQ(LAMBDA,MIU)
                    EMUSLO=EMUSLO
     *                - (QMUL_T(LAMBDA,MIU) - QASKED(LAMBDA,MIU))
     *                *                       STIFFQ(LAMBDA,MIU)*2.0D0
C
                    EMUREA=EMUREA
     *                + (QMUL_T(LAMBDA,MIU) - QASKED(LAMBDA,MIU))
     *                *  QMUL_T(LAMBDA,MIU) * STIFFQ(LAMBDA,MIU)
C
                END IF
C
C=======================================================================
C           LINEAR CONSTRAINTS
C=======================================================================
C
                IF (ABS(IFLALQ(LAMBDA,MIU)).EQ.1) THEN
C
                    EMULCO=EMULCO
     *                    -  GALMUQ(LAMBDA,MIU)
     *                    * (QMUL_T(LAMBDA,MIU) - QASKED(LAMBDA,MIU))
C
                    EMUSLO=EMUSLO
     *                    +  GALMUQ(LAMBDA,MIU) * QMUL_T(LAMBDA,MIU)
C
                    EMUREA=EMUREA
     *                    -  GALMUQ(LAMBDA,MIU) * QMUL_T(LAMBDA,MIU)/2
C
C=======================================================================
C               UPDATE THE LAGRANGE MULTIPLIER ESTIMATES
C=======================================================================
C
                    IF (IFLALQ(LAMBDA,MIU).EQ.1.AND.IF_RPA.NE.1) THEN
C
                        GALMUQ(LAMBDA,MIU)=GALMUQ(LAMBDA,MIU)
     *                       - (QMUL_T(LAMBDA,MIU) - QASKED(LAMBDA,MIU))
     *                       *  STIFFQ(LAMBDA,MIU)*2.0D0
C
                    END IF
C
                END IF
C
            END IF
         END DO
C
C=======================================================================
C        SCALAR CONSTRAINTS
C=======================================================================
C
         IF (IFLAGG(LAMBDA).EQ.1) THEN
C
             EMULCO=EMULCO
     *             + (GMUL_T - GASKED(LAMBDA))**2
     *                       * STIFFG(LAMBDA)
             EMUSLO=EMUSLO
     *             - (GMUL_T - GASKED(LAMBDA))
     *             *           STIFFG(LAMBDA)*2.0D0
C
             EMUREA=EMUREA
     *             + (GMUL_T - GASKED(LAMBDA))
     *             *  GMUL_T * STIFFG(LAMBDA)
C
         END IF
C
      END DO
C
C@@@ NECK - NECK - NECK - NECK - NECK - NECK - NECK - NECK - NECK
C=======================================================================
C      GAUSSIAN CONSTRAINT ON THE NECK
C=======================================================================
C
      IF (IFNECK.EQ.2) THEN
C
          EMULCO = EMULCO - G_NECK*(Q_NECK - Q0NECK)
C
          EMUSLO = EMUSLO + G_NECK* Q_NECK
C
          EMUREA = EMUREA - G_NECK* Q_NECK*0.5D0
C
      END IF
C
C@@@ NECK - NECK - NECK - NECK - NECK - NECK - NECK - NECK - NECK
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE SCNTRS(NSICON,ESIFCO,ESISLO,ESIREA)
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      COMMON
     *       /SMULTI/ SMUL_N(0:NDMULT,-NDMULT:NDMULT),
     *                SMUL_P(0:NDMULT,-NDMULT:NDMULT),
     *                SMUL_T(0:NDMULT,-NDMULT:NDMULT)
      COMMON
     *       /SCNSTR/ STIFFS(0:NDMULT,-NDMULT:NDMULT),
     *                SASKED(0:NDMULT,-NDMULT:NDMULT),
     *                IFLAGS(0:NDMULT,-NDMULT:NDMULT)
      COMMON
     *       /SLASTR/ GALMUS(0:NDMULT,-NDMULT:NDMULT),
     *                SLINEA(0:NDMULT,-NDMULT:NDMULT),
     *                IFLALS(0:NDMULT,-NDMULT:NDMULT)
C
C=======================================================================
C       THIS SUBROUTINE CALCULATES THE ENERGY CONTRIBUTIONS ASSOCIATED
C       WITH THE SURFACE OR SCHIFF CONSTRAINTS.
C=======================================================================
C
      ESIFCO=0.0D0
      ESISLO=0.0D0
      ESIREA=0.0D0
C
      DO LAMBDA=0,NSICON
         DO MIU=-LAMBDA,LAMBDA
C
C=======================================================================
C           QUADRATIC CONSTRAINTS FOR TOTAL MOMENTS
C=======================================================================
C
            IF (IFLAGS(LAMBDA,MIU).EQ.1) THEN
C
                ESIFCO=ESIFCO
     *                + (SMUL_T(LAMBDA,MIU) - SASKED(LAMBDA,MIU))**2
     *                                      * STIFFS(LAMBDA,MIU)
                ESISLO=ESISLO
     *                - (SMUL_T(LAMBDA,MIU) - SASKED(LAMBDA,MIU))
     *                *                       STIFFS(LAMBDA,MIU)*2.0D0
C
                ESIREA=ESIREA
     *                + (SMUL_T(LAMBDA,MIU) - SASKED(LAMBDA,MIU))
     *                *  SMUL_T(LAMBDA,MIU) * STIFFS(LAMBDA,MIU)
C
C=======================================================================
C           LINEAR CONSTRAINTS FOR TOTAL MOMENTS
C=======================================================================
C
                IF (ABS(IFLALS(LAMBDA,MIU)).EQ.1) THEN
C
                    ESIFCO=ESIFCO
     *                    -  GALMUS(LAMBDA,MIU)
     *                    * (SMUL_T(LAMBDA,MIU) - SASKED(LAMBDA,MIU))
C
                    ESISLO=ESISLO
     *                    +  GALMUS(LAMBDA,MIU) * SMUL_T(LAMBDA,MIU)
C
                    ESIREA=ESIREA
     *                     - GALMUS(LAMBDA,MIU) * SMUL_T(LAMBDA,MIU)/2
C
C=======================================================================
C               UPDATE THE LAGRANGE MULTIPLIER ESTIMATES
C=======================================================================
C
                    IF (IFLALS(LAMBDA,MIU).EQ.1) THEN
C
                        GALMUS(LAMBDA,MIU)=GALMUS(LAMBDA,MIU)
     *                    - (SMUL_T(LAMBDA,MIU) - SASKED(LAMBDA,MIU))
     *                    *  STIFFS(LAMBDA,MIU)*2.0D0
C
                    END IF
                END IF
            END IF
C
C=======================================================================
C           QUADRATIC CONSTRAINTS FOR NEUTRON MOMENTS
C=======================================================================
C
            IF (IFLAGS(LAMBDA,MIU).EQ.2) THEN
C
                ESIFCO=ESIFCO
     *                + (SMUL_N(LAMBDA,MIU) - SASKED(LAMBDA,MIU))**2
     *                                      * STIFFS(LAMBDA,MIU)
                ESISLO=ESISLO
     *                - (SMUL_N(LAMBDA,MIU) - SASKED(LAMBDA,MIU))
     *                *                       STIFFS(LAMBDA,MIU)*2.0D0
C
                ESIREA=ESIREA
     *                + (SMUL_N(LAMBDA,MIU) - SASKED(LAMBDA,MIU))
     *                *  SMUL_N(LAMBDA,MIU) * STIFFS(LAMBDA,MIU)
C
C=======================================================================
C           LINEAR CONSTRAINTS FOR NEUTRON MOMENTS
C=======================================================================
C
                IF (ABS(IFLALS(LAMBDA,MIU)).EQ.2) THEN
C
                    ESIFCO=ESIFCO
     *                    -  GALMUS(LAMBDA,MIU)
     *                    * (SMUL_N(LAMBDA,MIU) - SASKED(LAMBDA,MIU))
C
                    ESISLO=ESISLO
     *                    +  GALMUS(LAMBDA,MIU) * SMUL_N(LAMBDA,MIU)
C
                    ESIREA=ESIREA
     *                     - GALMUS(LAMBDA,MIU) * SMUL_N(LAMBDA,MIU)/2
C
C=======================================================================
C               UPDATE THE LAGRANGE MULTIPLIER ESTIMATES
C=======================================================================
C
                    IF (IFLALS(LAMBDA,MIU).EQ.2) THEN
C
                        GALMUS(LAMBDA,MIU)=GALMUS(LAMBDA,MIU)
     *                    - (SMUL_N(LAMBDA,MIU) - SASKED(LAMBDA,MIU))
     *                    *  STIFFS(LAMBDA,MIU)*2.0D0
C
                    END IF
                END IF
            END IF
C
C=======================================================================
C           QUADRATIC CONSTRAINTS FOR PROTON MOMENTS
C=======================================================================
C
            IF (IFLAGS(LAMBDA,MIU).EQ.3) THEN
C
                ESIFCO=ESIFCO
     *                + (SMUL_P(LAMBDA,MIU) - SASKED(LAMBDA,MIU))**2
     *                                      * STIFFS(LAMBDA,MIU)
                ESISLO=ESISLO
     *                - (SMUL_P(LAMBDA,MIU) - SASKED(LAMBDA,MIU))
     *                *                       STIFFS(LAMBDA,MIU)*2.0D0
C
                ESIREA=ESIREA
     *                + (SMUL_P(LAMBDA,MIU) - SASKED(LAMBDA,MIU))
     *                *  SMUL_P(LAMBDA,MIU) * STIFFS(LAMBDA,MIU)
C
C=======================================================================
C           LINEAR CONSTRAINTS FOR PROTON MOMENTS
C=======================================================================
C
                IF (ABS(IFLALS(LAMBDA,MIU)).EQ.3) THEN
C
                    ESIFCO=ESIFCO
     *                    -  GALMUS(LAMBDA,MIU)
     *                    * (SMUL_P(LAMBDA,MIU) - SASKED(LAMBDA,MIU))
C
                    ESISLO=ESISLO
     *                    +  GALMUS(LAMBDA,MIU) * SMUL_P(LAMBDA,MIU)
C
                    ESIREA=ESIREA
     *                     - GALMUS(LAMBDA,MIU) * SMUL_P(LAMBDA,MIU)/2
C
C=======================================================================
C               UPDATE THE LAGRANGE MULTIPLIER ESTIMATES
C=======================================================================
C
                    IF (IFLALS(LAMBDA,MIU).EQ.3) THEN
C
                        GALMUS(LAMBDA,MIU)=GALMUS(LAMBDA,MIU)
     *                    - (SMUL_P(LAMBDA,MIU) - SASKED(LAMBDA,MIU))
     *                    *  STIFFS(LAMBDA,MIU)*2.0D0
C
                    END IF
                END IF
            END IF
C
         END DO
      END DO
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE ICNTRS(ITILAX,ITISAX,ESPICO,ESPSLO,ESPREA)
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      COMMON
     *       /ICNSTR/ STIFFI(1:NDKART),
     *                ASKEDI(1:NDKART),
     *                IFLAGI(1:NDKART)
      COMMON
     *       /ACNSTR/ STIFFA,ASKEDA,IFLAGA
      COMMON
     *       /ANGANG/ ANGU_N(1:NDKART),ANGU_P(1:NDKART),ANGU_T(1:NDKART)
      COMMON
     *       /OMOVAS/ OMOVAX,OMOVAY,OMOVAZ
      COMMON
     *       /OMISOS/ OMISOX,OMISOY,OMISOZ
C
C=======================================================================
C       THIS SUBROUTINE CALCULATES THE ENERGY CONTRIBUTIONS  ASSOCIATED
C       WITH THE SPIN CONSTRAINT.
C=======================================================================
C       ESPSLO HAS THE MEANING OF THE ENERGY DERIVATIVE WITH RESPECT TO
C       SPIN IF ONLY  O N E  OMEGA IS NOT EQUAL TO ZERO.
C=======================================================================
C
C       IFLAGI = 0  -  LINEAR               CONSTRAINT ON SPIN
C       IFLAGI = 1  -  LINEAR AND QUADRATIC CONSTRAINT ON SPIN
C
C=======================================================================
C
C=======================================================================
C       LINEAR CONSTRAINT
C=======================================================================
C
      ESPICO=-OMOVAY*(ANGU_N(2)+ANGU_P(2))-OMISOY*(ANGU_N(2)-ANGU_P(2))
      ESPSLO= OMOVAY+OMISOY
C
      IF (ITILAX.NE.0) THEN
C
          ESPICO=ESPICO-OMOVAX*(ANGU_N(1)+ANGU_P(1))
     *                 -OMOVAZ*(ANGU_N(3)+ANGU_P(3))
          ESPSLO=ESPSLO+OMOVAX+OMOVAZ
C
      END IF
C
      IF (ITISAX.NE.0) THEN
C
          ESPICO=ESPICO-OMISOX*(ANGU_N(1)-ANGU_P(1))
     *                 -OMISOZ*(ANGU_N(3)-ANGU_P(3))
          ESPSLO=ESPSLO+OMISOX+OMISOZ
C
      END IF
C
      ESPREA=ESPICO/2
C
C=======================================================================
C       QUADRATIC CONSTRAINT
C=======================================================================
C
      DO KARTEZ=1,NDKART
C
         IF (IFLAGI(KARTEZ).NE.0) THEN
C
             ESPREA=ESPREA+STIFFI(KARTEZ)*ANGU_T(KARTEZ)*
     *                    (ANGU_T(KARTEZ)-ASKEDI(KARTEZ))
             ESPICO=ESPICO+STIFFI(KARTEZ)*
     *                    (ANGU_T(KARTEZ)-ASKEDI(KARTEZ))**2
             ESPSLO=ESPSLO-2*STIFFI(KARTEZ)*
     *                    (ANGU_T(KARTEZ)-ASKEDI(KARTEZ))
C
         END IF
C
      END DO
C
C=======================================================================
C       QUADRATIC CONSTRAINT ON PRODUCT OMEGA TIMES SPIN
C=======================================================================
C
      IF (IFLAGA.NE.0) THEN
C
          OMEGAT=OMOVAX**2+OMOVAY**2+OMOVAZ**2
C
          OMEGAJ=OMOVAX*ANGU_T(1)+
     *           OMOVAY*ANGU_T(2)+
     *           OMOVAZ*ANGU_T(3)
C
          ANGUTT=ANGU_T(1)**2+ANGU_T(2)**2+ANGU_T(3)**2
C
          ESPREA=ESPREA+STIFFA*(OMEGAT*ANGUTT-OMEGAJ**2)/OMEGAT
C
          ESPICO=ESPICO+STIFFA*(OMEGAT*ANGUTT-OMEGAJ**2)/OMEGAT
C
          ESPSLO=ESPSLO-2*STIFFA*(ANGU_T(1)*OMEGAT
     *                           -OMOVAX   *OMEGAJ)/OMEGAT
          ESPSLO=ESPSLO-2*STIFFA*(ANGU_T(2)*OMEGAT
     *                           -OMOVAY   *OMEGAJ)/OMEGAT
          ESPSLO=ESPSLO-2*STIFFA*(ANGU_T(3)*OMEGAT
     *                           -OMOVAZ   *OMEGAJ)/OMEGAT
C
      END IF
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE INTCON(ISIMPY,ICHARG,ISCHIF,NMUCON,NSICON,
     *                                HPPCON,HPMCON,IF_RPA)
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      DIMENSION
     *          HPPCON(1:NDBASE,1:NDBASE),
     *          HPMCON(1:NDBASE,1:NDBASE)
C=======================================================================
      ALLOCATABLE ELEMUL(:,:)
      ALLOCATABLE ELESIF(:,:)
C=======================================================================
      DIMENSION
     *          CMUL_T(0:NDMULT,-NDMULT:NDMULT),
     *          FACSIF(0:NDMULT,-NDMULT:NDMULT),
     *          FACMUL(0:NDMULT,-NDMULT:NDMULT)
C
      COMMON
     *       /COEMUL/ COMULT(0:NDMULT,0:NDOSCI,0:NDOSCI,1:NDKART)
      COMMON
     *       /T_PHAS/ IPHAPP(0:NDYMAX,0:NDYMAX,0:NDKART),
     *                IPHAPM(0:NDYMAX,0:NDYMAX,0:NDKART),
     *                IPHAMP(0:NDYMAX,0:NDYMAX,0:NDKART),
     *                IPHAMM(0:NDYMAX,0:NDYMAX,0:NDKART)
      COMMON
     *       /QMULTI/ QMUL_N(0:NDMULT,-NDMULT:NDMULT),
     *                QMUL_P(0:NDMULT,-NDMULT:NDMULT),
     *                QMUL_T(0:NDMULT,-NDMULT:NDMULT)
      COMMON
     *       /SMULTI/ SMUL_N(0:NDMULT,-NDMULT:NDMULT),
     *                SMUL_P(0:NDMULT,-NDMULT:NDMULT),
     *                SMUL_T(0:NDMULT,-NDMULT:NDMULT)
      COMMON
     *       /QCNSTR/ STIFFQ(0:NDMULT,-NDMULT:NDMULT),
     *                QASKED(0:NDMULT,-NDMULT:NDMULT),
     *                IFLAGQ(0:NDMULT,-NDMULT:NDMULT)
      COMMON
     *       /SCNSTR/ STIFFS(0:NDMULT,-NDMULT:NDMULT),
     *                SASKED(0:NDMULT,-NDMULT:NDMULT),
     *                IFLAGS(0:NDMULT,-NDMULT:NDMULT)
      COMMON
     *       /GCNSTR/ STIFFG(0:NDMULT),
     *                GASKED(0:NDMULT),
     *                IFLAGG(0:NDMULT)
      COMMON
     *       /QLASTR/ GALMUQ(0:NDMULT,-NDMULT:NDMULT),
     *                QLINEA(0:NDMULT,-NDMULT:NDMULT),
     *                IFLALQ(0:NDMULT,-NDMULT:NDMULT)
      COMMON
     *       /SLASTR/ GALMUS(0:NDMULT,-NDMULT:NDMULT),
     *                SLINEA(0:NDMULT,-NDMULT:NDMULT),
     *                IFLALS(0:NDMULT,-NDMULT:NDMULT)
      COMMON
     *       /OURUNI/ QUNITS(0:NDMULT,0:NDMULT)
      COMMON
     *       /DIMENS/ LDBASE
C
C=======================================================================
C
      IALLOC=0
C
C=======================================================================
      ALLOCATE (ELEMUL(1:NDBASE,1:NDBASE),STAT=IALLOC)
      IF (IALLOC.NE.0) CALL NOALLO('ELEMUL','INTCON')
      ALLOCATE (ELESIF(1:NDBASE,1:NDBASE),STAT=IALLOC)
      IF (IALLOC.NE.0) CALL NOALLO('ELESIF','INTCON')
C=======================================================================
C
C=======================================================================
C       THIS SUBROUTINE CALCULATES THE MULTIPOLE-MOMENT,
C       SURFACE-MOMENT AND SCHIFF-MOMENT CONSTRAINING FIELDS
C=======================================================================
C
      HPPCON(:,:)=0.0D0
      HPMCON(:,:)=0.0D0
      ELEMUL(:,:)=0.0D0
      ELESIF(:,:)=0.0D0
C
C=======================================================================
C        CALCULATING THE COEFFICIENTS THAT IN THE CONSTRAINT TERMS
C        MULTIPLY THE MULTIPOLE MOMENTS
C=======================================================================
C
      DO LAMBDA=0,NMUCON
C
         RESULT=0.0D0
C
         DO MIU=-LAMBDA,LAMBDA
            NIU=ABS(MIU)
            RESULT=RESULT+(QMUL_T(LAMBDA,MIU)/QUNITS(LAMBDA,NIU))**2
         END DO
C
         GMUL_T=SQRT(RESULT)*QUNITS(LAMBDA,0)
C
         DO MIU=-LAMBDA,LAMBDA
C
            NIU=ABS(MIU)
C
            CMUL_T(LAMBDA,MIU)=0.0D0
C
            IF (IFLAGQ(LAMBDA,MIU).EQ.1) THEN
C
                IF (IF_RPA.NE.1)
     *              CMUL_T(LAMBDA,MIU)=CMUL_T(LAMBDA,MIU)
     *                +2.0D0*(QMUL_T(LAMBDA,MIU)-QASKED(LAMBDA,MIU))
     *                      * STIFFQ(LAMBDA,MIU)
C
                IF (ABS(IFLALQ(LAMBDA,MIU)).EQ.1)
     *
     *              CMUL_T(LAMBDA,MIU)=CMUL_T(LAMBDA,MIU)
     *                                -GALMUQ(LAMBDA,MIU)
C
            END IF
C
            IF (IFLAGG(LAMBDA).EQ.1.AND.GMUL_T.GT.0)
     *
     *          CMUL_T(LAMBDA,MIU)=CMUL_T(LAMBDA,MIU)
     *                +2.0D0*(GMUL_T            -GASKED(LAMBDA))
     *                      * STIFFG(LAMBDA)
     *                      * QMUL_T(LAMBDA,MIU)/GMUL_T
     *                      * QUNITS(LAMBDA, 0 )**2
     *                      / QUNITS(LAMBDA,NIU)**2
C
         END DO
C
      END DO
C
C=======================================================================
C        CALCULATING THE COEFFICIENTS THAT IN THE CONSTRAINT TERMS
C        MULTIPLY THE SURFACE OR SCHIFF MOMENTS
C=======================================================================
C
      DO LAMBDA=0,NSICON
         DO MIU=-LAMBDA,LAMBDA
C
            FACSIF(LAMBDA,MIU)=0.0D0
            FACMUL(LAMBDA,MIU)=0.0D0
C
C=======================================================================
C           FACTORS FOR CONSTRAINTS ON MASS MOMENTS
C=======================================================================
C
            IF (IFLAGS(LAMBDA,MIU).EQ.1) THEN
C
                FACSIF(LAMBDA,MIU)=2.0D0*(SMUL_T(LAMBDA,MIU)
     *                                   -SASKED(LAMBDA,MIU))
     *                                   *STIFFS(LAMBDA,MIU)
C
                IF (ABS(IFLALS(LAMBDA,MIU)).EQ.1)
     *
     *              FACSIF(LAMBDA,MIU)=FACSIF(LAMBDA,MIU)
     *                                -GALMUS(LAMBDA,MIU)
C
                IF (ISCHIF.EQ.1)
     *
     *          FACMUL(LAMBDA,MIU)=-5.0D0/3.0D0*SMUL_T(0,0)/QMUL_T(0,0)
     *                                   *FACSIF(LAMBDA,MIU)
C
            END IF
C
C=======================================================================
C           FACTORS FOR CONSTRAINTS ON NEUTRON MOMENTS
C=======================================================================
C
            IF (IFLAGS(LAMBDA,MIU).EQ.2.AND.ICHARG.EQ.0) THEN
C
                FACSIF(LAMBDA,MIU)=2.0D0*(SMUL_N(LAMBDA,MIU)
     *                                   -SASKED(LAMBDA,MIU))
     *                                   *STIFFS(LAMBDA,MIU)
C
                IF (ABS(IFLALS(LAMBDA,MIU)).EQ.2)
     *
     *              FACSIF(LAMBDA,MIU)=FACSIF(LAMBDA,MIU)
     *                                -GALMUS(LAMBDA,MIU)
C
                IF (ISCHIF.EQ.1)
     *
     *          FACMUL(LAMBDA,MIU)=-5.0D0/3.0D0*SMUL_N(0,0)/QMUL_N(0,0)
     *                                   *FACSIF(LAMBDA,MIU)
C
            END IF
C
C=======================================================================
C           FACTORS FOR CONSTRAINTS ON PROTON MOMENTS
C=======================================================================
C
            IF (IFLAGS(LAMBDA,MIU).EQ.3.AND.ICHARG.EQ.1) THEN
C
                FACSIF(LAMBDA,MIU)=2.0D0*(SMUL_P(LAMBDA,MIU)
     *                                   -SASKED(LAMBDA,MIU))
     *                                   *STIFFS(LAMBDA,MIU)
C
                IF (ABS(IFLALS(LAMBDA,MIU)).EQ.3)
     *
     *              FACSIF(LAMBDA,MIU)=FACSIF(LAMBDA,MIU)
     *                                -GALMUS(LAMBDA,MIU)
C
                IF (ISCHIF.EQ.1)
     *
     *          FACMUL(LAMBDA,MIU)=-5.0D0/3.0D0*SMUL_P(0,0)/QMUL_P(0,0)
     *                                   *FACSIF(LAMBDA,MIU)
C
            END IF
C
         END DO
      END DO
C
C=======================================================================
C        HERE WE CALCULATE CONTRIBUTIONS FROM REAL PARTS OF THE
C        MULTIPOLE MOMENTS
C=======================================================================
C
      DO LAMBDA=0,NMUCON
         DO MIU=0,LAMBDA
C
            IF (IFLAGQ(LAMBDA,MIU).EQ.1.OR.IFLAGG(LAMBDA).EQ.1) THEN
C
                IMAREA=1
C
                CALL INTMUL(IPHAPP(0,0,0),ELEMUL,COMULT,
     *                                LAMBDA,MIU,IMAREA)
C
                DO IKET=1,LDBASE
                   DO IBRA=1,LDBASE
C
                      HPPCON(IBRA,IKET)=HPPCON(IBRA,IKET)
     *                                 +ELEMUL(IBRA,IKET)
     *                                 *CMUL_T(LAMBDA,MIU)
                   END DO
                END DO
C
             END IF
C
         END DO
      END DO
C
C=======================================================================
C        HERE WE CALCULATE CONTRIBUTIONS FROM REAL PARTS OF THE
C        SURFACE OR SCHIFF MOMENTS
C=======================================================================
C
      DO LAMBDA=0,NSICON
         DO MIU=0,LAMBDA
C
            IF (IFLAGS(LAMBDA,MIU).EQ.1.OR.
     *         (IFLAGS(LAMBDA,MIU).EQ.2.AND.ICHARG.EQ.0).OR.
     *         (IFLAGS(LAMBDA,MIU).EQ.3.AND.ICHARG.EQ.1)) THEN
C
                IMAREA=1
C
                CALL INTSIF(IPHAPP(0,0,0),ELESIF,COMULT,
     *                                LAMBDA,MIU,IMAREA)
C
                IF (ISCHIF.EQ.1)
     *          CALL INTMUL(IPHAPP(0,0,0),ELEMUL,COMULT,
     *                                LAMBDA,MIU,IMAREA)
C
C=======================================================================
C               INSERTING THE CONSTRAINTS
C=======================================================================
C
                DO IKET=1,LDBASE
                   DO IBRA=1,LDBASE
C
                      HPPCON(IBRA,IKET)=HPPCON(IBRA,IKET)
     *
     *                                 +ELESIF(IBRA,IKET)
     *                                               *FACSIF(LAMBDA,MIU)
     *                                 +ELEMUL(IBRA,IKET)
     *                                               *FACMUL(LAMBDA,MIU)
                   END DO
                END DO
C
             END IF
C
         END DO
      END DO
C
C=======================================================================
C        CONTRIBUTIONS FROM IMAGINARY PARTS ARE CALCULATED ONLY
C        FOR BROKEN SIMPLEX SYMMETRY
C=======================================================================
C
      IF (ISIMPY.EQ.1.OR.NMUCON.EQ.0) GO TO 2
C
C=======================================================================
C        HERE WE CALCULATE CONTRIBUTIONS FROM IMAGINARY PARTS OF THE
C        MULTIPOLE MOMENTS
C=======================================================================
C
      DO LAMBDA=1,NMUCON
         DO MIU=-LAMBDA,-1
C
            IF (IFLAGQ(LAMBDA,MIU).EQ.1.OR.IFLAGG(LAMBDA).EQ.1) THEN
C
                IMAREA=-1
C
                CALL INTMUL(IPHAPM(0,0,0),ELEMUL,COMULT,
     *                                LAMBDA,MIU,IMAREA)
C
                DO IKET=1,LDBASE
                   DO IBRA=1,LDBASE
C
                      HPMCON(IBRA,IKET)=HPMCON(IBRA,IKET)
     *                                 +ELEMUL(IBRA,IKET)
     *                                 *CMUL_T(LAMBDA,MIU)
                   END DO
                END DO
C
             END IF
C
         END DO
      END DO
C
C=======================================================================
C        HERE WE CALCULATE CONTRIBUTIONS FROM IMAGINARY PARTS OF THE
C        SURFACE OR SCHIFF MOMENTS
C=======================================================================
C
    2 IF (ISIMPY.EQ.1.OR.NSICON.EQ.0) GO TO 1
C
C=======================================================================
C
      DO LAMBDA=1,NSICON
         DO MIU=-LAMBDA,-1
C
            IF (IFLAGS(LAMBDA,MIU).EQ.1.OR.
     *         (IFLAGS(LAMBDA,MIU).EQ.2.AND.ICHARG.EQ.0).OR.
     *         (IFLAGS(LAMBDA,MIU).EQ.3.AND.ICHARG.EQ.1)) THEN
C
                IMAREA=-1
C
                CALL INTSIF(IPHAPM(0,0,0),ELESIF,COMULT,
     *                                LAMBDA,MIU,IMAREA)
C
                IF (ISCHIF.EQ.1)
     *          CALL INTMUL(IPHAPM(0,0,0),ELEMUL,COMULT,
     *                                LAMBDA,MIU,IMAREA)
C
C=======================================================================
C               INSERTING THE CONSTRAINTS
C=======================================================================
C
                DO IKET=1,LDBASE
                   DO IBRA=1,LDBASE
C
                      HPMCON(IBRA,IKET)=HPMCON(IBRA,IKET)
     *
     *                                 +ELESIF(IBRA,IKET)
     *                                               *FACSIF(LAMBDA,MIU)
     *                                 +ELEMUL(IBRA,IKET)
     *                                               *FACMUL(LAMBDA,MIU)
                   END DO
                END DO
C
             END IF
C
         END DO
      END DO
C
C=======================================================================
C
    1 CONTINUE
C
C=======================================================================
      DEALLOCATE (ELEMUL,ELESIF)
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE DEFUNI(NMUMAX,NSIMAX,NMAMAX)
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      COMMON
     *       /OURUNI/ QUNITS(0:NDMULT,0:NDMULT)
      COMMON
     *       /SIFUNI/ SUNITS(0:NDMULT,0:NDMULT)
      COMMON
     *       /PLMUNI/ PUNITS(0:NDMULT,0:NDMULT)
      COMMON
     *       /VMUUNI/ VUNITS(0:NDMULT,0:NDMULT)
      COMMON
     *       /RADUNI/ RUNITS
      COMMON
     *       /MAGUNI/ AUNITS(0:NDMULT,0:NDMULT)
C
C=======================================================================
C       THIS SUBROUTINE DEFINES THE UNITS OF THE MULTIPOLE MOMENTS
C       THEY  D I F F E R  FROM THE ELECTROMAGNETIC  UNITS USED BY
C       J.D.JACKSON, CH.4, EQ.(4.3) IN THE FOLLOWING WAY:
C
C       THE SPHERICAL HARMONICS USED BY THE PROGRAM, HAVE THE FORM
C       IDENTICAL WITH THOSE USED BY JACKSON AND ALSO VARSHALOVICH.
C
C       THE MULTIPOLE MOMENTS OF JACKSON ARE DEFINED AS THE AVERAGE
C       VALUES OF THE ABOVE SPHERICAL HARMONICS. OUR MULTIPOLE MO-
C       MENTS HAVE ADDITIONAL MULTIPLICATIVE FACTORS STORED IN THE
C       THE ARRAY "QUNITS".
C
C       THE COMMON UNIT OF THE AVERAGE VALUES OF X**2, Y**2, Z**2,
C       AND R**2 IS STORED IN "RUNITS".
C
C=======================================================================
C
      SQR4PI=SQRT(16.0D0*ATAN(1.0D0))
C
      IF (NMUMAX.GT.NDMULT) STOP 'NMUMAX.GT.NDMULT IN DEFUNI'
      IF (NSIMAX.GT.NDMULT) STOP 'NSIMAX.GT.NDMULT IN DEFUNI'
      IF (NMAMAX.GT.NDMULT) STOP 'NMAMAX.GT.NDMULT IN DEFUNI'
C
      DO LAMBDA=0,NDMULT
         DO MIU=0,LAMBDA
            QUNITS(LAMBDA,MIU)=1.0D0
            SUNITS(LAMBDA,MIU)=1.0D0
            PUNITS(LAMBDA,MIU)=1.0D0
            VUNITS(LAMBDA,MIU)=1.0D0
            AUNITS(LAMBDA,MIU)=1.0D0
         END DO
      END DO
C
      RUNITS=1.0D0
C
C=======================================================================
C         E X P L I C I T   D E F I N I T I O S
C=======================================================================
C
      QUNITS(0,0)=+SQR4PI
C
C=======================================================================
C     WITH THE ABOVE, OUR Q(0,0)-MOMENT GIVES THE PARTICLE NUMBER
C=======================================================================
C
      QUNITS(1,0)=+SQR4PI/SQRT(3.0D0)
      QUNITS(1,1)=-SQR4PI/SQRT(3.0D0)*SQRT(2.0D0)
C
C=======================================================================
C     WITH THE ABOVE, OUR Q(1,0), Re[Q(1,1)],  AND Im[Q(1,-1)] MOMENTS
C     GIVE THE EXPECTATION VALUES OF "Z", "X", AND "-Y",  RESPECTIVELY.
C=======================================================================
C
      QUNITS(2,0)=+SQR4PI/SQRT(5.0D0)*2.0D0
      QUNITS(2,1)=-SQR4PI/SQRT(15.D0)*SQRT(2.0D0)
      QUNITS(2,2)=+SQR4PI/SQRT(5.0D0)*2.0D0*SQRT(2.0D0)
C
C=======================================================================
C
C     ATTENTION:  IN THE PREVIOUS VERSIONS OF THE CODE, THE VALUE OF
C                 QUNITS(2,2) WAS INCORRECT, I.E., INCONSISTENT WITH
C                 THE INTENTIONS EXPRESSED IN THE COMMENTS BELOW.
C
C                 IN THE VERSION  1.67A , AND IN ALL OLDER VERSIONS,
C                 THIS VALUE WAS A SQRT(6) TOO SMALL.
C
C                 SINCE THE VERSION 1.67B AND UNTIL THE VERSION 1.74
C                 THIS VALUE WAS A SQRT(2) TOO LARGE.
C
C                 STARTING FROM THE VERSION 1.75 AND ALSO IN ALL THE
C                 BIFURCATED VERSIONS 1.70A,B,C, AND THE LATER ONES,
C                 THIS VALUE IS PRESUMED CORRECT (TILL THE NEXT BUG)
C
C=======================================================================
C
C=======================================================================
C      WITH THE ABOVE, OUR Q(2,0)-MOMENT GIVES THE EXPECTATION VALUE
C      OF "( 2*Z**2 - X**2 - Y**2 )". IN ADDITION, OUR Q(2,2)-MOMENT
C      CONTAINS THE BOHR'S SQR(2), THAT IMPLIES THAT USING THIS UNIT
C      IS EQUIVALENT TO TREATING  Q(2,+2) & Q(2,-2)), COMBINED. CON-
C      SEQUENTLY, BOHR'S "BETA = SQRT(Q(2,0)**2 + Q(2,2)**2)", WHILE
C      BOHR'S "GAMMA = ATAN (Q(2,2)/Q(2,0))".
C=======================================================================
C
C=======================================================================
C      ALL HIGHER MULTIPOLES ARE LEFT IN PEACE, SO FAR.
C=======================================================================
C
C=======================================================================
C      MOREOVER, TO MAKE ENEMIES LIFE DIFFICULT, THE MOMENTS ARE
C      CALCULATED IN UNITS OF ( 10 * FERMI ) ** LAMBDA.
C=======================================================================
C
      DO LAMBDA=0,MAX(NMUMAX,NSIMAX)
         DO MIU=0,LAMBDA
            QUNITS(LAMBDA,MIU)=QUNITS(LAMBDA,MIU) / (10.0D0)**LAMBDA
         END DO
      END DO
C
C=======================================================================
C     UNITS OF SURFACE MOMENTS ARE LEFT IDENTICAL TO THOSE OF THE
C     MULTIPOLE MOMENTS, APART FROM THE FACTOR OF 100 THAT  COMES
C     FROM THE UNITS OF ( 10 * FERMI ) ** (LAMBDA+2).
C=======================================================================
C
      DO LAMBDA=0,MAX(NMUMAX,NSIMAX)
         DO MIU=0,LAMBDA
            SUNITS(LAMBDA,MIU)=QUNITS(LAMBDA,MIU)/100.
         END DO
      END DO
C
C=======================================================================
C     UNITS OF PENSURFACE MOMENTS ARE LEFT IDENTICAL TO THOSE OF THE
C     MULTIPOLE MOMENTS, APART FROM THE FACTOR OF 10000  THAT  COMES
C     FROM THE UNITS OF ( 10 * FERMI ) ** (LAMBDA+4).
C=======================================================================
C
      DO LAMBDA=0,MAX(NMUMAX,NSIMAX)
         DO MIU=0,LAMBDA
            PUNITS(LAMBDA,MIU)=QUNITS(LAMBDA,MIU)/10000.
         END DO
      END DO
C
C=======================================================================
C     UNITS OF VECTOR MOMENTS ARE LEFT IDENTICAL TO THOSE OF THE
C     MULTIPOLE MOMENTS, APART FROM THE FACTOR OF 10  THAT COMES
C     FROM THE UNITS OF ( 10 * FERMI ) ** (LAMBDA+1).
C=======================================================================
C
      DO LAMBDA=0,MAX(NMUMAX,NSIMAX)
         DO MIU=0,LAMBDA
            VUNITS(LAMBDA,MIU)=QUNITS(LAMBDA,MIU)/10.
         END DO
      END DO
C
C=======================================================================
C     SO FAR, NO INGENIOUS UNITS HAVE BEEN INVENTED FOR MAGNETIC
C     MOMENTS APART FROM THE NUCLEAR MAGNETON, BUT WAIT A WHILE...
C=======================================================================
C
      DO LAMBDA=0,NMAMAX
         DO MIU=0,LAMBDA
            AUNITS(LAMBDA,MIU)=1.0D0
         END DO
      END DO
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE INT_HO(POT_HO,HBMACT,ESCALE,HBACTX,HBACTY,HBACTZ)
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      DIMENSION
     *          POT_HO(1:NDBASE,1:NDBASE)
      COMMON
     *       /T_PHAS/ IPHAPP(0:NDYMAX,0:NDYMAX,0:NDKART),
     *                IPHAPM(0:NDYMAX,0:NDYMAX,0:NDKART),
     *                IPHAMP(0:NDYMAX,0:NDYMAX,0:NDKART),
     *                IPHAMM(0:NDYMAX,0:NDYMAX,0:NDKART)
      COMMON
     *       /BASISO/ NXVECT(1:NDBASE),NYVECT(1:NDBASE),NZVECT(1:NDBASE)
      COMMON
     *       /SCALNG/ HOMSCA(NDKART)
      COMMON
     *       /DIMENS/ LDBASE
C
C=======================================================================
C       THIS SUBROUTINE CALCULATES MATRIX ELEMENTS OF THE HO POTENTIAL
C=======================================================================
C
      DO IKET=1,LDBASE
         DO IBRA=1,LDBASE
C
            NXBRA=NXVECT(IBRA)
            NYBRA=NYVECT(IBRA)
            NZBRA=NZVECT(IBRA)
C
            NXKET=NXVECT(IKET)
            NYKET=NYVECT(IKET)
            NZKET=NZVECT(IKET)
C
C=======================================================================
C       Z**2 TERM
C=======================================================================
C
            TTTZ=0.0D0
C
            IF (NXBRA.EQ.NXKET) THEN
C
                IF (NYBRA.EQ.NYKET) THEN
C
                    IF (NZBRA.EQ.NZKET) THEN
                        TTTZ=REAL(2*NZBRA+1,KIND=8)
                    END IF
C
                    IF (NZBRA.EQ.(NZKET+2)) THEN
                        TTTZ=SQRT(REAL(NZBRA*(NZKET+1),KIND=8))
                    END IF
C
                    IF (NZBRA.EQ.(NZKET-2)) THEN
                        TTTZ=SQRT(REAL(NZKET*(NZBRA+1),KIND=8))
                    END IF
C
                    TTTZ=TTTZ/HOMSCA(3)**2
C
                END IF
C
            END IF
C
            TTTZ=TTTZ/2
C
C=======================================================================
C       Y**2 TERM
C=======================================================================
C
            TTTY=0.0D0
C
            IF (NXBRA.EQ.NXKET) THEN
C
                IF (NZBRA.EQ.NZKET) THEN
C
                    IF (NYBRA.EQ.NYKET) THEN
                        TTTY=REAL(2*NYBRA+1,KIND=8)
                    END IF
C
                    IF (NYBRA.EQ.(NYKET+2)) THEN
                        TTTY=SQRT(REAL(NYBRA*(NYKET+1),KIND=8))
                    END IF
C
                    IF (NYBRA.EQ.(NYKET-2)) THEN
                        TTTY=SQRT(REAL(NYKET*(NYBRA+1),KIND=8))
                    END IF
C
                    TTTY=TTTY/HOMSCA(2)**2
C
                END IF
C
            END IF
C
            TTTY=TTTY/2
C
C=======================================================================
C       X**2 TERM
C=======================================================================
C
            TTTX=0.0D0
C
            IF (NYBRA.EQ.NYKET) THEN
C
                IF (NZBRA.EQ.NZKET) THEN
C
                    IF (NXBRA.EQ.NXKET) THEN
                        TTTX=REAL(2*NXBRA+1,KIND=8)
                    END IF
C
                    IF (NXBRA.EQ.(NXKET+2)) THEN
                        TTTX=SQRT(REAL(NXBRA*(NXKET+1),KIND=8))
                    END IF
C
                    IF (NXBRA.EQ.(NXKET-2)) THEN
                        TTTX=SQRT(REAL(NXKET*(NXBRA+1),KIND=8))
                    END IF
C
                    TTTX=TTTX/HOMSCA(1)**2
C
                END IF
C
            END IF
C
            TTTX=TTTX/2
C
C=======================================================================
C           POTENTIAL ENERGY
C=======================================================================
C
            POT_HO(IBRA,IKET)=(HBACTX**2*TTTX
     *                        +HBACTY**2*TTTY
     *                        +HBACTZ**2*TTTZ)/HBMACT/4.0D0
     *
     *                        * IPHAPP(NYBRA,NYKET,0)
C
         END DO
      END DO
C
C=======================================================================
C           THE POTENTIAL ENERGY IS SHIFTED BY A CONSTANT.
C=======================================================================
C
      DO IBRA=1,LDBASE
C
         POT_HO(IBRA,IBRA)=POT_HO(IBRA,IBRA)-ESCALE
C
      END DO
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE SPENSU(MREVER,ENESUM,ICHARG,ISIMPY)
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      COMMON
     *       /SPLEVS/ SPENER(1:2*NDSTAT,0:NDISOS),
     *                SPOCCU(1:2*NDSTAT,0:NDISOS),
     *                SPALIG(1:2*NDSTAT,0:NDISOS),
     *                SPSPAL(1:2*NDSTAT,0:NDISOS),
     *                SPPARI(1:2*NDSTAT,0:NDISOS),
     *                SPSIMP(1:2*NDSTAT,0:NDISOS)
      COMMON
     *       /PROCCU/ V_OCCU(1:2*NDSTAT)
      COMMON
     *       /SPNUMS/ NUMBSP(0:NDREVE,0:NDISOS)
C@@@ TEMP - TEMP - TEMP - TEMP - TEMP - TEMP - TEMP - TEMP - TEMP
      COMMON
     *       /FERFUN/ FER_FN(1:NDBASE)
      COMMON
     *       /T_FLAG/ IFTEMP
C@@@ TEMP - TEMP - TEMP - TEMP - TEMP - TEMP - TEMP - TEMP - TEMP
C
C=======================================================================
C       THIS SUBROUTINE CALCULATES THE SUM OF SINGLE-PARTICLE ENERGIES
C=======================================================================
C
      ENESUM=0.0D0
C
      IF (ISIMPY.EQ.1) THEN
C
          IF (IFTEMP.EQ.0) THEN
C
              DO IREVER=0,MREVER
C
                 DO ISTATE=1,NUMBSP(IREVER,ICHARG)
C
                    SPOCCU(ISTATE+IREVER*NUMBSP(0,ICHARG),ICHARG)=
     *              V_OCCU(ISTATE+IREVER*NUMBSP(0,ICHARG))**2
C
                    ENESUM=ENESUM
     *             +SPENER(ISTATE+IREVER*NUMBSP(0,ICHARG),ICHARG)
     *             *SPOCCU(ISTATE+IREVER*NUMBSP(0,ICHARG),ICHARG)
C
                 END DO
C
              END DO
C
          ELSE
C
              DO IREVER=0,MREVER
C
                 DO ISTATE=1,NUMBSP(IREVER,ICHARG)
C
                    SPOCCU(ISTATE+IREVER*NUMBSP(0,ICHARG),ICHARG)=
     *              V_OCCU(ISTATE+IREVER*NUMBSP(0,ICHARG))**2
     *
     *    +(1.0D0-2*V_OCCU(ISTATE+IREVER*NUMBSP(0,ICHARG))**2)
     *             *FER_FN(ISTATE)
C
                    ENESUM=ENESUM
     *             +SPENER(ISTATE+IREVER*NUMBSP(0,ICHARG),ICHARG)
     *             *SPOCCU(ISTATE+IREVER*NUMBSP(0,ICHARG),ICHARG)
C
                 END DO
C
              END DO
C
          END IF
C
      ELSE
C
          DO ISTATE=1,NUMBSP(0,ICHARG)+NUMBSP(1,ICHARG)
C
             SPOCCU(ISTATE,ICHARG)=V_OCCU(ISTATE)**2
C
             ENESUM=ENESUM
     *             +SPENER(ISTATE,ICHARG)*SPOCCU(ISTATE,ICHARG)
C
          END DO
C
      END IF
C
C=======================================================================
C
      RETURN
      END
C
cC=======================================================================
C
      SUBROUTINE DENMAC(MREVER,ICHARG,ISIMPY,IPAHFB,WALEFT,WARIGH)
C=======================================================================
      USE MAT_PP
      USE MAT_PM
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      COMPLEX
     *          W_LEFT,W_RIGH,WTLEFT,WTRIGH
      COMPLEX
     *          WALEFT,WARIGH
      COMPLEX
     *          PHASPI,C_ZERO,C_UNIT
      COMPLEX
     *          WALEFP,WALEFM,WARIGP,WARIGM
C@@@ TEMP - TEMP - TEMP - TEMP - TEMP - TEMP - TEMP - TEMP - TEMP
      COMMON
     *       /FERFUN/ FER_FN(1:NDBASE)
      COMMON
     *       /T_FLAG/ IFTEMP
C@@@ TEMP - TEMP - TEMP - TEMP - TEMP - TEMP - TEMP - TEMP - TEMP
C=======================================================================
      ALLOCATABLE W_LEFT(:,:),W_RIGH(:,:),WTLEFT(:,:),WTRIGH(:,:)
C=======================================================================
      DIMENSION
     *          WALEFT(1:NDBASE,1:4*NDSTAT,0:NDSPIN),
     *          WARIGH(1:NDBASE,1:4*NDSTAT,0:NDSPIN)
C
      COMMON
     *       /DIMENS/ LDBASE
      COMMON
     *       /DIMSTA/ LDTOTS(0:NDISOS),LDSTAT(0:NDISOS),
     *                LDUPPE(0:NDISOS),LDTIMU(0:NDISOS)
      COMMON
     *       /SPIPHA/ PHASPI(1:NDBASE,0:NDREVE,0:NDSPIN)
C
C=======================================================================
C
      CALL CPUTIM('DENMAC',1)
C
C=======================================================================
C
      IALLOC=0
C
C=======================================================================
      IF (.NOT.ALLOCATED(BIG_PP)) THEN
          ALLOCATE (BIG_PP(1:NDBASE,1:NDBASE,0:NDREVE),STAT=IALLOC)
          IF (IALLOC.NE.0) CALL NOALLO('BIG_PP','DENMAC')
      END IF
      IF (.NOT.ALLOCATED(BIG_PM).AND.ISIMPY.NE.1) THEN
          ALLOCATE (BIG_PM(1:NDBASE,1:NDBASE,0:NDREVE),STAT=IALLOC)
          IF (IALLOC.NE.0) CALL NOALLO('BIG_PM','DENMAC')
      END IF
C=======================================================================
C
C=======================================================================
C     THIS SUBROUTINE CALCULATES THE TRANSITION DENSITY MATRIX
C=======================================================================
C
      C_ZERO=CMPLX(0.0D0,0.0D0)
      C_UNIT=CMPLX(1.0D0,0.0D0)
C
      LUPPER=LDUPPE(ICHARG)
C
C=======================================================================
C                       CONSERVED SIMPLEX
C=======================================================================
C
      IF (ISIMPY.EQ.1) THEN
C
          BIG_PP(:,:,:)=C_ZERO
C
          IF (IFTEMP.EQ.0) THEN
C
              DO IREVER=0,MREVER
C
C                 OpenMP and (threaded) BLAS acceleration
C
#if(USE_OPENMP==1)
C
                 ALLOCATE(W_LEFT(1:NDBASE,1:LUPPER))
                 ALLOCATE(W_RIGH(1:NDBASE,1:LUPPER))
C
!$OMP PARALLEL DO
!$OMP& DEFAULT(NONE)
!$OMP& SCHEDULE(DYNAMIC)
!$OMP& SHARED(LUPPER,LDBASE,W_LEFT,WALEFT,PHASPI,W_RIGH,WARIGH,
!$OMP&                                                  IREVER)
!$OMP& PRIVATE(ISTATE,I_BASE)
                 DO ISTATE=1,LUPPER
                    DO I_BASE=1,LDBASE
C
                        W_LEFT(I_BASE,ISTATE)=WALEFT(I_BASE,ISTATE,0)
     *                                 *CONJG(PHASPI(I_BASE,IREVER,0))
     *                                       +WALEFT(I_BASE,ISTATE,1)
     *                                 *CONJG(PHASPI(I_BASE,IREVER,1))
                        W_RIGH(I_BASE,ISTATE)=WARIGH(I_BASE,ISTATE,0)
     *                                 *CONJG(PHASPI(I_BASE,IREVER,0))
     *                                       +WARIGH(I_BASE,ISTATE,1)
     *                                 *CONJG(PHASPI(I_BASE,IREVER,1))
C
	            END DO
	         END DO
!$OMP END PARALLEL DO
C
                 CALL ZGEMM('N','C',LDBASE,LDBASE,LUPPER,
     *                              C_UNIT,W_LEFT,NDBASE,
     *                                     W_RIGH,NDBASE,
     *                  C_ZERO,BIG_PP(1,1,IREVER),NDBASE)
C
	         DEALLOCATE(W_LEFT,W_RIGH)
C
#else
C
C                 Basic coding not taking advantage of shared memory
C                 or high-performance BLAS libraries
C
                 DO ISTATE=1,LUPPER
C
                    DO IKET=1,LDBASE
C
                        WALEFP=WALEFT(IKET,ISTATE,0)
     *                  *CONJG(PHASPI(IKET,IREVER,0))
     *                        +WALEFT(IKET,ISTATE,1)
     *                  *CONJG(PHASPI(IKET,IREVER,1))
C
                        DO IBRA=1,LDBASE
C
                           WARIGP=WARIGH(IBRA,ISTATE,0)
     *                     *CONJG(PHASPI(IBRA,IREVER,0))
     *                           +WARIGH(IBRA,ISTATE,1)
     *                     *CONJG(PHASPI(IBRA,IREVER,1))
C
                           BIG_PP(IBRA,IKET,IREVER)
     *                    =BIG_PP(IBRA,IKET,IREVER)
     *                        +WARIGP*CONJG(WALEFP)
C
                       END DO
C
                    END DO
C
                 END DO
#endif
C
              END DO
C
          ELSE
C@@@ TEMP - TEMP - TEMP - TEMP - TEMP - TEMP - TEMP - TEMP - TEMP
C
              DO IREVER=0,MREVER
C
                 ALLOCATE(W_LEFT(1:LDBASE,1:LUPPER))
                 ALLOCATE(W_RIGH(1:LDBASE,1:LUPPER))
                 ALLOCATE(WTLEFT(1:LDBASE,1:LUPPER))
                 ALLOCATE(WTRIGH(1:LDBASE,1:LUPPER))
C
C                 (threaded) BLAS acceleration
C
                 DO ISTATE=1,LUPPER
                    DO I_BASE=1,LDBASE
C
                        W_LEFT(I_BASE,ISTATE)=WALEFT(I_BASE,ISTATE,0)
     *                                 *CONJG(PHASPI(I_BASE,IREVER,0))
     *                                       +WALEFT(I_BASE,ISTATE,1)
     *                                 *CONJG(PHASPI(I_BASE,IREVER,1))
                        W_RIGH(I_BASE,ISTATE)=WARIGH(I_BASE,ISTATE,0)
     *                                 *CONJG(PHASPI(I_BASE,IREVER,0))
     *                                       +WARIGH(I_BASE,ISTATE,1)
     *                                 *CONJG(PHASPI(I_BASE,IREVER,1))
C
	            END DO
	         END DO
C
                 DO ISTATE=1,LUPPER
                    CORECT=1.0D0-FER_FN(ISTATE)
                    CALL ZDSCAL(LDBASE,CORECT,W_LEFT(1,ISTATE),1)
                 END DO
C
                                  LREVER=IREVER
                 IF (IPAHFB.EQ.1) LREVER=1
C
                 DO ISTATE=1,LDTIMU(ICHARG)
                    JSTATE=LUPPER+ISTATE
                    DO I_BASE=1,LDBASE
C
                        WTLEFT(I_BASE,ISTATE)
     *                          =CONJG(WALEFT(I_BASE,JSTATE,0))
     *                                *PHASPI(I_BASE,IREVER,0)
     *                          +CONJG(WALEFT(I_BASE,JSTATE,1))
     *                                *PHASPI(I_BASE,IREVER,1)
                        WTRIGH(I_BASE,ISTATE)
     *                         =CONJG(WARIGH(I_BASE,JSTATE,0))
     *                               *PHASPI(I_BASE,IREVER,0)
     *                         +CONJG(WARIGH(I_BASE,JSTATE,1))
     *                               *PHASPI(I_BASE,IREVER,1)
C
	            END DO
	         END DO
C
C                 For MREVER=0, we have LDTIMU(ICHARG)=LDUPPE(ICHARG)
C
	         IF (MREVER.NE.0) THEN
C
                     DO ISTATE=LDTIMU(ICHARG)+1,LUPPER
                        JSTATE=LUPPER+ISTATE-LDTIMU(ICHARG)
                        DO I_BASE=1,LDBASE
C
                            WTLEFT(I_BASE,ISTATE)
     *                     =WALEFT(I_BASE,JSTATE,0)
     *               *CONJG(PHASPI(I_BASE,LREVER,0))
     *                     +WALEFT(I_BASE,JSTATE,1)
     *               *CONJG(PHASPI(I_BASE,LREVER,1))
                            WTRIGH(I_BASE,ISTATE)
     *                     =WARIGH(I_BASE,JSTATE,0)
     *               *CONJG(PHASPI(I_BASE,LREVER,0))
     *                     +WARIGH(I_BASE,JSTATE,1)
     *               *CONJG(PHASPI(I_BASE,LREVER,1))
C
	                END DO
	             END DO
C
	         END IF
C
                 DO ISTATE=1,LUPPER
                    CORECT=FER_FN(ISTATE)
                    CALL ZDSCAL(LDBASE,CORECT,WTRIGH(1,ISTATE),1)
                 END DO
C
                 CALL ZGEMM('N','C',LDBASE,LDBASE,LUPPER,
     *                              C_UNIT,W_LEFT,LDBASE,
     *                                     W_RIGH,LDBASE,
     *                  C_ZERO,BIG_PP(1,1,IREVER),NDBASE)
C
                 CALL ZGEMM('N','C',LDBASE,LDBASE,LUPPER,
     *                              C_UNIT,WTLEFT,LDBASE,
     *                                     WTRIGH,LDBASE,
     *                  C_UNIT,BIG_PP(1,1,IREVER),NDBASE)
C
	         DEALLOCATE(W_LEFT,W_RIGH,WTLEFT,WTRIGH)
C
C@@@ TEMP - TEMP - TEMP - TEMP - TEMP - TEMP - TEMP - TEMP - TEMP
C
             END DO ! end IREVER
C
         END IF ! end IFTEMP
C
C=======================================================================
C        DEFINING THE TIME-REVERSED TRANSITION DENSITY MATRIX
C        IN CASE OF NO ROTATION
C=======================================================================
C
         IF (MREVER.EQ.0) THEN
C
             BIG_PP(:,:,1)=CONJG(BIG_PP(:,:,0))
C
c      open(41,file='rho_r.txt',STATUS='UNKNOWN',FORM='FORMATTED')
c      open(42,file='rho_i.txt',STATUS='UNKNOWN',FORM='FORMATTED')
c      write(41,'(i6)') LDBASE
c      write(42,'(i6)') LDBASE
c      do IKET=1,LDBASE
c         do IBRA=1,LDBASE
c            write(41,'(10PE24.12)') real(BIG_PP(IBRA,IKET,0))
c            write(42,'(10PE24.12)') aimag(BIG_PP(IBRA,IKET,0))
c         end do
c      end do
c      close(41)
c      close(42)
C
         END IF
C
C=======================================================================
C                       BROKEN SIMPLEX
C=======================================================================
C
      ELSE
C
          BIG_PP(:,:,:)=C_ZERO
          BIG_PM(:,:,:)=C_ZERO
C
#if(USE_OPENMP==1)
!$OMP PARALLEL DO
!$OMP& DEFAULT(NONE)
!$OMP& SCHEDULE(DYNAMIC)
!$OMP& SHARED(LUPPER,LDBASE,WALEFT,PHASPI,WARIGH,BIG_PP,BIG_PM)
!$OMP& PRIVATE(IKET,IBRA,ISTATE,WARIGP,WARIGM,WALEFP,WALEFM)
          DO IKET=1,LDBASE
C
             DO ISTATE=1,LUPPER
C
                DO IBRA=1,LDBASE
C
                   WALEFP=WALEFT(IKET,ISTATE,0)
     *             *CONJG(PHASPI(IKET,0,0))
     *                   +WALEFT(IKET,ISTATE,1)
     *             *CONJG(PHASPI(IKET,0,1))
C
                   WALEFM=WALEFT(IKET,ISTATE,0)
     *             *CONJG(PHASPI(IKET,1,0))
     *                   +WALEFT(IKET,ISTATE,1)
     *             *CONJG(PHASPI(IKET,1,1))
C
                   WARIGP=WARIGH(IBRA,ISTATE,0)
     *             *CONJG(PHASPI(IBRA,0,0))
     *                   +WARIGH(IBRA,ISTATE,1)
     *             *CONJG(PHASPI(IBRA,0,1))
C
                   WARIGM=WARIGH(IBRA,ISTATE,0)
     *             *CONJG(PHASPI(IBRA,1,0))
     *                   +WARIGH(IBRA,ISTATE,1)
     *             *CONJG(PHASPI(IBRA,1,1))
C
                   BIG_PP(IBRA,IKET,0)=BIG_PP(IBRA,IKET,0)
     *                                +WARIGP*CONJG(WALEFP)
C
                   BIG_PP(IBRA,IKET,1)=BIG_PP(IBRA,IKET,1)
     *                                +WARIGM*CONJG(WALEFM)
C
                   BIG_PM(IBRA,IKET,0)=BIG_PM(IBRA,IKET,0)
     *                                +WARIGP*CONJG(WALEFM)
C
                   BIG_PM(IBRA,IKET,1)=BIG_PM(IBRA,IKET,1)
     *                                +WARIGM*CONJG(WALEFP)
C
                END DO
             END DO
C
          END DO
!$OMP END PARALLEL DO
#else
          DO ISTATE=1,LUPPER
C
             DO IKET=1,LDBASE
                DO IBRA=1,LDBASE
C
                   WARIGP=WARIGH(IBRA,ISTATE,0)*CONJG(PHASPI(IBRA,0,0))
     *                   +WARIGH(IBRA,ISTATE,1)*CONJG(PHASPI(IBRA,0,1))
C
                   WARIGM=WARIGH(IBRA,ISTATE,0)*CONJG(PHASPI(IBRA,1,0))
     *                   +WARIGH(IBRA,ISTATE,1)*CONJG(PHASPI(IBRA,1,1))
C
                   WALEFP=WALEFT(IKET,ISTATE,0)*CONJG(PHASPI(IKET,0,0))
     *                   +WALEFT(IKET,ISTATE,1)*CONJG(PHASPI(IKET,0,1))
C
                   WALEFM=WALEFT(IKET,ISTATE,0)*CONJG(PHASPI(IKET,1,0))
     *                   +WALEFT(IKET,ISTATE,1)*CONJG(PHASPI(IKET,1,1))
C
                   BIG_PP(IBRA,IKET,0)=BIG_PP(IBRA,IKET,0)
     *                                +WARIGP*CONJG(WALEFP)
C
                   BIG_PP(IBRA,IKET,1)=BIG_PP(IBRA,IKET,1)
     *                                +WARIGM*CONJG(WALEFM)
C
                   BIG_PM(IBRA,IKET,0)=BIG_PM(IBRA,IKET,0)
     *                                +WARIGP*CONJG(WALEFM)
C
                   BIG_PM(IBRA,IKET,1)=BIG_PM(IBRA,IKET,1)
     *                                +WARIGM*CONJG(WALEFP)
C
                END DO
             END DO
C
          END DO
#endif
C
      END IF
C
C=======================================================================
C
      CALL CPUTIM('DENMAC',0)
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE PAIMAC(MREVER,ICHARG,ISIMPY,WALEFT,WARIGH,IKERNE)
C=======================================================================
      USE KAP_PP
      USE KAP_PM
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      COMPLEX
     *          WALEFT,WARIGH
      COMPLEX
     *          PHASPI,C_ZERO
      COMPLEX
     *          WALEFP,WALEFM,WARIGP,WARIGM
      DIMENSION
     *          WALEFT(1:NDBASE,1:4*NDSTAT,0:NDSPIN),
     *          WARIGH(1:NDBASE,1:4*NDSTAT,0:NDSPIN)
C=======================================================================
      COMMON
     *       /DIMENS/ LDBASE
      COMMON
     *       /DIMSTA/ LDTOTS(0:NDISOS),LDSTAT(0:NDISOS),
     *                LDUPPE(0:NDISOS),LDTIMU(0:NDISOS)
      COMMON
     *       /SPIPHA/ PHASPI(1:NDBASE,0:NDREVE,0:NDSPIN)
C
C=======================================================================
C
      CALL CPUTIM('PAIMAC',1)
C
C=======================================================================
C
      IALLOC=0
C
C=======================================================================
      IF (.NOT.ALLOCATED(PAI_PP).AND.ISIMPY.NE.1) THEN
          ALLOCATE (PAI_PP(1:NDBASE,1:NDBASE,0:NDREVE),STAT=IALLOC)
          IF (IALLOC.NE.0) CALL NOALLO('PAI_PP','PAIMAC')
      END IF
C=======================================================================
      IF (.NOT.ALLOCATED(PAI_PM)) THEN
          ALLOCATE (PAI_PM(1:NDBASE,1:NDBASE,0:NDREVE),STAT=IALLOC)
          IF (IALLOC.NE.0) CALL NOALLO('PAI_PM','PAIMAC')
      END IF
C=======================================================================
C
C=======================================================================
C     THIS SUBROUTINE CALCULATES THE PAIRING TENSOR
C
C     ATTENTION: THE CONVENTION OF USING THE PAI_PP AND PAI_PM ARRAYS IS
C                DIFFERENT THAN THE ONE USED FOR THE BIG_PP AND  BIG_PM,
C                NAMELY, FOR THE CONSERVED SIMPLEX THE ARRAY  PAI_PM  IS
C                USED AND FOR NONCONSERVED SIMPLEX THE ARRAY  PAI_PP  IS
C                USED IN ADDITION.
C
C     ATTENTION: THE CASE OF NONCONSERVED SIMPLEX IS NOT YET IMPLEMENTED
C=======================================================================
C
      C_ZERO=CMPLX(0.0D0,0.0D0)
C
      LUPPER=LDUPPE(ICHARG)
      LTIMUP=LDTIMU(ICHARG)
C
C=======================================================================
C
       PAI_PM(:,:,:)=C_ZERO
C
      IF (ISIMPY.EQ.1) THEN
C
          DO IKET=1,LDBASE
             DO IBRA=1,LDBASE
C
                DO ISTATE=1,LTIMUP
C
                   WARIGP=WARIGH(IBRA,ISTATE,0)*CONJG(PHASPI(IBRA,0,0))
     *                   +WARIGH(IBRA,ISTATE,1)*CONJG(PHASPI(IBRA,0,1))
C
                   WALEFM=WALEFT(IKET,LUPPER+ISTATE,1)*PHASPI(IKET,1,0)
     *                   -WALEFT(IKET,LUPPER+ISTATE,0)*PHASPI(IKET,1,1)
C
                   PAI_PM(IBRA,IKET,0)=PAI_PM(IBRA,IKET,0)
     *                                +WARIGP*CONJG(WALEFM)
C
                END DO
C
                IF (IKERNE.EQ.0) THEN
C
                    PAI_PM(IKET,IBRA,1)=-PAI_PM(IBRA,IKET,0)
C
                ELSE
C
                    DO ISTATE=1,LTIMUP
C
                       WALEFP=WALEFT(IBRA,ISTATE,0)
     *                                         *CONJG(PHASPI(IBRA,0,0))
     *                       +WALEFT(IBRA,ISTATE,1)
     *                                         *CONJG(PHASPI(IBRA,0,1))
C
                       WARIGM=WARIGH(IKET,LUPPER+ISTATE,1)
     *                                                *PHASPI(IKET,1,0)
     *                       -WALEFT(IKET,LUPPER+ISTATE,0)
     *                                                *PHASPI(IKET,1,1)
C
                       PAI_PM(IKET,IBRA,1)
     *                =PAI_PM(IKET,IBRA,1)-WALEFP*CONJG(WARIGM)
C
                   END DO
C
                END IF
C
             END DO
          END DO
C
C=======================================================================
C        DEFINING THE TIME-REVERSED PAIRING TENSOR IN CASE OF NO
C        ROTATION
C=======================================================================
C
c          IF (MREVER.EQ.0)
c     *
c     *        STOP ' MREVER=0 IN SUBROUTINE PAIMAC'
C
      ELSE
C
         STOP ' NON-CONSERVED SIMPLEX NOT IMPLEMENTED IN PAIMAC'
C
      END IF
C
C=======================================================================
C
      CALL CPUTIM('PAIMAC',0)
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE LIP_IN(ISIMPY,ICHARG,LIPKIN,LIPKIP,EF2XIN,EF2XOU,
     *                                                     NUMITE)
C=======================================================================
      USE MAT_PP
      USE MAT_PM
      USE MAD_PP
      USE MAD_PM
      USE BROYIN
      USE BROYOU
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      COMMON
     *       /DIMENS/ LDBASE
      COMMON
     *       /BROSIZ/ NSCALR,NVECTO,NTENSO,NMATRI
C=======================================================================
C      THIS SUBROUTINE FILLS OUT THE BROYDEN VECTOR WITH THE DATA
C      CORRESPONDING TO THE LIPKIN-NOGAMI PRESCRIPTION. THE SAID DATA
C      INCLUDE THE LAMBDA_2 FACTOR AND THE MATRIX ELEMENTS OF THE
C      DENSITY MATRIX (NEUTRONS AND PROTONS IF THE LN METHOD APPLIES
C      TO BOTH). CONTRARY TO LINEAR MIXING, IT IS NECESSARY IN THE
C      BROYDEN METHOD TO MIX THE DENSITIES IN ADDITION TO LAMBDA_2
C=======================================================================
C
C=======================================================================
C
      IALLOC=0
C
C=======================================================================
      IF (.NOT.ALLOCATED(DEN_PP)) THEN
          ALLOCATE (DEN_PP(1:NDBASE,1:NDBASE,0:NDREVE,0:NDISOS),
     *                                             STAT=IALLOC)
          IF (IALLOC.NE.0) CALL NOALLO('DEN_PP','LIP_IN')
      END IF
      IF (.NOT.ALLOCATED(DEN_PM).AND.ISIMPY.NE.1) THEN
          ALLOCATE (DEN_PM(1:NDBASE,1:NDBASE,0:NDREVE,0:NDISOS),
     *                                             STAT=IALLOC)
          IF (IALLOC.NE.0) CALL NOALLO('DEN_PM','LIP_IN')
      END IF
C=======================================================================
C
C      Initialization of the density matrices at the first iteration
C
      IF (NUMITE.EQ.0) THEN
C
          DO IREVER=0,NDREVE
             DO J=1,LDBASE
                DO I=1,LDBASE
                   DEN_PP(I,J,IREVER,ICHARG)=BIG_PP(I,J,IREVER)
                END DO
             END DO
          END DO
C
          IF (ISIMPY.NE.1) THEN
              DO IREVER=0,NDREVE
                 DO J=1,LDBASE
                    DO I=1,LDBASE
                       DEN_PM(I,J,IREVER,ICHARG)=BIG_PM(I,J,IREVER)
                    END DO
                 END DO
              END DO
          END IF
C
      END IF
C
      N_ISOS=NMATRI/2
C
C=======================================================================
C
C      Case where the Lipkin-Nogami method is applied to both types
C      of nucleon. This subroutine is called twice, for neutrons and
C      for protons, and the full Broyden vector is filled 'slice by
C      slice'. The breakdown of the vector is indicated below.
C
C   CONSERVED SIMPLEX
C                   Segment                        Content
C      2+1               ->   2+N_ISOS       : real part of rho_n
C      2+N_ISOS+1        ->   2+NMATRI       : real part of rho_p
C      2+NMATRI+1        ->   2+NMATRI+N_ISOS: imaginary part of rho_n
C      2+NMATRI+N_ISOS+1 ->   2+2*NMATRI     : imaginary part of rho_p
C
C   BROKEN SIMPLEX
C                     Segment                    Content
C 2+(2*NMATRI+1)           ->2+(2*NMATRI+1)+ N_ISOS : real part of rho_n
C 2+(2*NMATRI+1)+(N_ISOS+1)->2+ 3*NMATRI            : real part of rho_p
C 2+(3*NMATRI+1)           ->2+(3*NMATRI+1)+ N_ISOS : img. part of rho_n
C 2+(3*NMATRI+1)+(N_ISOS+1)->2+ 4*NMATRI            : img. part of rho_p
C
C=======================================================================
C
      IF (LIPKIN.EQ.1.AND.LIPKIP.EQ.1) THEN
C
          BRO_IN(1+ICHARG)=EF2XIN
          BRO_OU(1+ICHARG)=EF2XOU
C
          INDEXX=ICHARG*N_ISOS
C
          DO IREVER=0,NDREVE
C
             DO J=1,LDBASE
                DO I=1,LDBASE
C
                   INDEXX=INDEXX+1
C
                   BRO_IN(2+INDEXX)
     *              =REAL(DEN_PP(I,J,IREVER,ICHARG))
                   BRO_OU(2+INDEXX)
     *              =REAL(BIG_PP(I,J,IREVER))
C
                   BRO_IN(2+INDEXX+NMATRI)
     *              =AIMAG(DEN_PP(I,J,IREVER,ICHARG))
                   BRO_OU(2+INDEXX+NMATRI)
     *              =AIMAG(BIG_PP(I,J,IREVER))
C
                END DO
             END DO
C
          END DO
C
C=======================================================================
C          CASE OF NON-CONSERVED SIMPLEX
C=======================================================================
C
          IF (ISIMPY.NE.1) THEN
C
              INDEXX=2*NMATRI+ICHARG*N_ISOS
C
              DO IREVER=0,NDREVE
C
                 DO J=1,LDBASE
                    DO I=1,LDBASE
C
                       INDEXX=INDEXX+1
C
                       BRO_IN(2+INDEXX)=REAL(DEN_PM(I,J,IREVER,ICHARG))
                       BRO_OU(2+INDEXX)=REAL(BIG_PM(I,J,IREVER))
C
                       BRO_IN(2+INDEXX+NMATRI)
     *                             =AIMAG(DEN_PM(I,J,IREVER,ICHARG))
                       BRO_OU(2+INDEXX+NMATRI)
     *                             =AIMAG(BIG_PM(I,J,IREVER))
C
                    END DO
                 END DO
C
              END DO
C
          END IF
C
      END IF
C
C=======================================================================
C
C      Case where the Lipkin-Nogami method is applied to one type
C      of nucleons only. The Broyden vector is half-shorter, and its
C      breakdown is indicated below.
C
C   CONSERVED SIMPLEX
C                     Segment                    Content
C            1           ->   N_ISOS       : real part of rho_[n,p]
C        N_ISOS+1        -> 2*N_ISOS       : imaginary part of rho_[n,p]
C
C   BROKEN SIMPLEX
C                     Segment                    Content
C  (2*N_ISOS+1)           -> 3*N_ISOS      : real part of rho_[n,p]
C  (3*N_ISOS+1)           -> 4*N_ISOS      : imaginary part of rho_[n,p]
C
C=======================================================================
C
      IF ((LIPKIN.EQ.1.AND.LIPKIP.EQ.0.AND.ICHARG.EQ.0).OR.
     *    (LIPKIP.EQ.1.AND.LIPKIN.EQ.0.AND.ICHARG.EQ.1)) THEN
C
          BRO_IN(1)=EF2XIN
          BRO_OU(1)=EF2XOU
C
          INDEXX=0
C
          DO IREVER=0,NDREVE
C
             DO J=1,LDBASE
                DO I=1,LDBASE
C
                   INDEXX=INDEXX+1
C
                   BRO_IN(INDEXX+1)=REAL(DEN_PP(I,J,IREVER,ICHARG))
                   BRO_OU(INDEXX+1)=REAL(BIG_PP(I,J,IREVER))
C
                   BRO_IN(INDEXX+N_ISOS+1)
     *                             =AIMAG(DEN_PP(I,J,IREVER,ICHARG))
                   BRO_OU(INDEXX+N_ISOS+1)
     *                             =AIMAG(BIG_PP(I,J,IREVER))
C
                END DO
             END DO
C
          END DO
C
C=======================================================================
C          CASE OF NON-CONSERVED SIMPLEX
C=======================================================================
C
          IF (ISIMPY.NE.1) THEN
C
              INDEXX=2*N_ISOS
C
              DO IREVER=0,NDREVE
C
                 DO J=1,LDBASE
                    DO I=1,LDBASE
C
                       INDEXX=INDEXX+1
C
                       BRO_IN(INDEXX+1)=REAL(DEN_PM(I,J,IREVER,ICHARG))
                       BRO_OU(INDEXX+1)=REAL(BIG_PM(I,J,IREVER))
C
                       BRO_IN(INDEXX+N_ISOS+1)
     *                             =AIMAG(DEN_PM(I,J,IREVER,ICHARG))
                       BRO_OU(INDEXX+N_ISOS+1)
     *                             =AIMAG(BIG_PM(I,J,IREVER))
C
                    END DO
                 END DO
C
              END DO
C
          END IF
C
      END IF
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE LIP_OU(ISIMPY,LIPKIN,LIPKIP,EFER2N,EFER2P)
C=======================================================================
      USE MAD_PP
      USE MAD_PM
      USE BROYIN
      USE BROYOU
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      COMMON
     *       /DIMENS/ LDBASE
      COMMON
     *       /BROSIZ/ NSCALR,NVECTO,NTENSO,NMATRI
C=======================================================================
C      THIS SUBROUTINE RECONSTRUCTS THE DENSITY MATRIX AFTER IT HAS
C      BEEN UPDATED BY THE BROYDEN METHOD. IT MUST BE CALLED RIGHT
C      AFTER SUBROUTINE DOBROY. BOTH THE NEUTRON AND PROTON DENSITY
C      MATRICES ARE RECONSTRUCTED, UNLESS THE LIPKIN-NOGAMI METHOD
C      APPLIES TO ONLY ONE TYPE OF NUCLEON ONLY.
C=======================================================================
C      SEE SUBROUTINE LIP_IN FOR COMMENTS
C=======================================================================
C
      N_ISOS=NMATRI/2
C
      IF (LIPKIN.EQ.1.AND.LIPKIP.EQ.1) THEN
C
          EFER2N=BRO_IN(1)
          EFER2P=BRO_IN(2)
C
          INDEXX=0
C
          DO IREVER=0,NDREVE
C
             DO J=1,LDBASE
                DO I=1,LDBASE
C
                   INDEXX=INDEXX+1
C
                   DEN_PP(I,J,IREVER,0)
     *            =CMPLX(BRO_IN(2+INDEXX),
     *                   BRO_IN(2+INDEXX+NMATRI))
C
                   DEN_PP(I,J,IREVER,1)
     *            =CMPLX(BRO_IN(2+INDEXX+N_ISOS),
     *                   BRO_IN(2+INDEXX+NMATRI+N_ISOS))
C
                END DO
             END DO
C
          END DO
C
          IF (ISIMPY.NE.1) THEN
C
              INDEXX=2*NMATRI
C
              DO IREVER=0,NDREVE
C
                 DO J=1,LDBASE
                    DO I=1,LDBASE
C
                       INDEXX=INDEXX+1
C
                       DEN_PM(I,J,IREVER,0)
     *                =CMPLX(BRO_IN(2+INDEXX),
     *                       BRO_IN(2+INDEXX+NMATRI))
C
                       DEN_PM(I,J,IREVER,1)
     *                =CMPLX(BRO_IN(2+INDEXX+N_ISOS),
     *                       BRO_IN(2+INDEXX+NMATRI+N_ISOS))
C
                    END DO
                 END DO
C
              END DO
C
          END IF
C
      END IF
C
C=======================================================================
C      SEE SUBROUTINE LIP_IN FOR COMMENTS
C=======================================================================
C
      IF (LIPKIN.EQ.1.AND.LIPKIP.EQ.0) THEN
C
          EFER2N=BRO_IN(1)
C
          INDEXX=0
C
          DO IREVER=0,NDREVE
C
             DO J=1,LDBASE
                DO I=1,LDBASE
C
                   INDEXX=INDEXX+1
C
                   DEN_PP(I,J,IREVER,0)
     *            =CMPLX(BRO_IN(INDEXX+1),BRO_IN(INDEXX+N_ISOS+1))
C
                END DO
             END DO
C
          END DO
C
          IF (ISIMPY.NE.1) THEN
C
              INDEXX=2*N_ISOS
C
              DO IREVER=0,NDREVE
C
                 DO J=1,LDBASE
                    DO I=1,LDBASE
C
                       INDEXX=INDEXX+1
C
                       DEN_PM(I,J,IREVER,0)
     *                =CMPLX(BRO_IN(INDEXX+1),BRO_IN(INDEXX+N_ISOS+1))
C
                    END DO
                 END DO
C
              END DO
C
          END IF
C
      END IF
C
C=======================================================================
C      SEE SUBROUTINE LIP_IN FOR COMMENTS
C=======================================================================
C
      IF (LIPKIN.EQ.0.AND.LIPKIP.EQ.1) THEN
C
          EFER2P=BRO_IN(1)
C
          INDEXX=0
C
          DO IREVER=0,NDREVE
C
             DO J=1,LDBASE
                DO I=1,LDBASE
C
                   INDEXX=INDEXX+1
C
                   DEN_PP(I,J,IREVER,1)
     *            =CMPLX(BRO_IN(INDEXX+1),BRO_IN(INDEXX+N_ISOS+1))
C
                END DO
             END DO
C
          END DO
C
          IF (ISIMPY.NE.1) THEN
C
              INDEXX=2*N_ISOS
C
              DO IREVER=0,NDREVE
C
                 DO J=1,LDBASE
                    DO I=1,LDBASE
C
                       INDEXX=INDEXX+1
C
                       DEN_PM(I,J,IREVER,1)
     *                =CMPLX(BRO_IN(INDEXX+1),BRO_IN(INDEXX+N_ISOS+1))
C
                    END DO
                 END DO
C
              END DO
C
          END IF
C
      END IF
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE SAVDEN(ISIMPY,ICHARG,SLOWLI,MIXDEN)
C=======================================================================
      USE MAT_PP
      USE MAT_PM
      USE MAD_PP
      USE MAD_PM
C=======================================================================
      USE hfodd_sizes
C=======================================================================
C
C=======================================================================
C      THIS SUBROUTINE SAVES THE DENSITY MATRIX
C=======================================================================
C
      IF (MIXDEN.EQ.1) THEN
          XOLDLI=SLOWLI
      ELSE
          XOLDLI=0.0
      END IF
C
      XNEWLI=1.0-XOLDLI
C
C=======================================================================
C
      IALLOC=0
C
      IF (.NOT.ALLOCATED(DEN_PP)) THEN
          ALLOCATE (DEN_PP(1:NDBASE,1:NDBASE,0:NDREVE,0:NDISOS),
     *                                             STAT=IALLOC)
          IF (IALLOC.NE.0) CALL NOALLO('DEN_PP','SAVDEN')
      END IF
C
      DEN_PP(:,:,:,ICHARG)=BIG_PP(:,:,:)*XNEWLI
     *                    +DEN_PP(:,:,:,ICHARG)*XOLDLI
C
      IF (ISIMPY.NE.1) THEN
C
          IALLOC=0
          IF (.NOT.ALLOCATED(DEN_PM)) THEN
              ALLOCATE (DEN_PM(1:NDBASE,1:NDBASE,0:NDREVE,0:NDISOS),
     *                                                 STAT=IALLOC)
              IF (IALLOC.NE.0) CALL NOALLO('DEN_PM','SAVDEN')
          END IF
C
          DEN_PM(:,:,:,ICHARG)=BIG_PM(:,:,:)*XNEWLI
     *                        +DEN_PM(:,:,:,ICHARG)*XOLDLI
C
      END IF
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE SAVPAI(ICHARG)
C=======================================================================
      USE KAP_PM
      USE MAP_PM
C=======================================================================
      USE hfodd_sizes
C=======================================================================
C
C=======================================================================
C      THIS SUBROUTINE SAVES THE PAIRING TENSOR
C=======================================================================
C
      IALLOC=0
C
      IF (.NOT.ALLOCATED(CHI_PM)) THEN
          ALLOCATE (CHI_PM(1:NDBASE,1:NDBASE,0:NDREVE,0:NDISOS),
     *                                                      STAT=IALLOC)
          IF (IALLOC.NE.0) CALL NOALLO('CHI_PM','SAVPAI')
      END IF
C
      CHI_PM(:,:,:,ICHARG)=PAI_PM(:,:,:)
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE SAVFIL(ISIMPY,IPAHFB,ICHARG)
C=======================================================================
      USE MAT_PP
      USE MAT_PM
      USE PAIDEL
      USE MAF_PP
      USE MAF_PM
      USE MAP_PP
C=======================================================================
      USE hfodd_sizes
C=======================================================================
C
C=======================================================================
C     THIS SUBROUTINE SAVES THE MEAN FIELDS
C=======================================================================
C
      IALLOC=0
C
      IF (.NOT.ALLOCATED(FIL_PP)) THEN
          ALLOCATE (FIL_PP(1:NDBASE,1:NDBASE,0:NDREVE,0:NDISOS),
     *                                             STAT=IALLOC)
          IF (IALLOC.NE.0) CALL NOALLO('FIL_PP','SAVFIL')
      END IF
C
      FIL_PP(:,:,:,ICHARG)=BIG_PP(:,:,:)
C
      IF (ISIMPY.NE.1) THEN
C
          IALLOC=0
C
          IF (.NOT.ALLOCATED(FIL_PM)) THEN
              ALLOCATE (FIL_PM(1:NDBASE,1:NDBASE,0:NDREVE,0:NDISOS),
     *                                                 STAT=IALLOC)
              IF (IALLOC.NE.0) CALL NOALLO('FIL_PM','SAVFIL')
          END IF
C
          FIL_PM(:,:,:,ICHARG)=BIG_PM(:,:,:)
C
      END IF
C
      IF (IPAHFB.GE.1) THEN
C
          IALLOC=0
C
          IF (.NOT.ALLOCATED(FIP_PP)) THEN
              ALLOCATE (FIP_PP(1:NDBASE,1:NDBASE,0:NDREVE,0:NDISOS),
     *                                                 STAT=IALLOC)
              IF (IALLOC.NE.0) CALL NOALLO('FIP_PP','SAVFIL')
          END IF
C
          FIP_PP(:,:,:,ICHARG)=HAMIDE(:,:,:)
C
      END IF
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE GETFIL(ISIMPY,ICHARG)
C=======================================================================
      USE MAT_PP
      USE MAT_PM
      USE MAF_PP
      USE MAF_PM
C=======================================================================
      USE hfodd_sizes
C=======================================================================
C
C=======================================================================
C     THIS SUBROUTINE COPIES THE MEAN FIELDS FROM THOSE READ FROM THE
C     FIELDS FILE
C=======================================================================
C
      IALLOC=0
C
      IF (.NOT.ALLOCATED(BIG_PP)) THEN
          ALLOCATE (BIG_PP(1:NDBASE,1:NDBASE,0:NDREVE),STAT=IALLOC)
          IF (IALLOC.NE.0) CALL NOALLO('BIG_PP','GETFIL')
      END IF
C
      BIG_PP(:,:,:)=FIL_PP(:,:,:,ICHARG)
C
      IF (ISIMPY.NE.1) THEN
C
           IALLOC=0
           IF (.NOT.ALLOCATED(BIG_PM)) THEN
               ALLOCATE (BIG_PM(1:NDBASE,1:NDBASE,0:NDREVE),
     *                                         STAT=IALLOC)
               IF (IALLOC.NE.0) CALL NOALLO('BIG_PM','GETFIL')
           END IF
           BIG_PM(:,:,:)=FIL_PM(:,:,:,ICHARG)
C
      END IF
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE GETPAI(ICHARG)
C=======================================================================
      USE PAIDEL
      USE MAP_PP
C=======================================================================
      USE hfodd_sizes
C=======================================================================
C
C=======================================================================
C     THIS SUBROUTINE COPIES THE PAIRING FIELDS FROM THOSE READ FROM THE
C     FIELDS FILE
C=======================================================================
C
      IALLOC=0
C
      IF (.NOT.ALLOCATED(HAMIDE)) THEN
          ALLOCATE (HAMIDE(1:NDBASE,1:NDBASE,0:NDREVE),STAT=IALLOC)
          IF (IALLOC.NE.0) CALL NOALLO('HAMIDE','GETPAI')
      END IF
C
      HAMIDE(:,:,:)=FIP_PP(:,:,:,ICHARG)
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE SPAVER(AVRVAL,OPIMRE,MREVER,
     *                  ICHARG,IMAREA,ISIPAR,ITIPAR,IHERMI)
C=======================================================================
      USE ALLWAV
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      DIMENSION
     *          AVRVAL(1:2*NDSTAT)
      DIMENSION
     *          OPIMRE(1:NDBASE,1:NDBASE)
C
      COMPLEX
     *          RESULT
C=======================================================================
      COMMON
     *       /SPNUMS/ NUMBSP(0:NDREVE,0:NDISOS)
      COMMON
     *       /DIMENS/ LDBASE
C
C=======================================================================
C
      CALL CPUTIM('SPAVER',1)
C
C=======================================================================
C     THIS SUBROUTINE CALCULATES SINGLE-PARTICLE AVERAGE VALUES OF
C     AN OPERATOR WHICH IS:
C        1. REAL OR IMAGINARY IN THE SIMPLEX BASIS (IMAREA=+1/-1)
C        2. DIAGONAL OR OFF-DIAGONAL IN SIMPLEX (ISIPAR=+1/-1)
C        3. TIME-EVEN OR TIME-ODD (ITIPAR=+1/-1)
C        4. HERMITIAN OR ANTI-HERMITIAN (IHERMI=+1/-1)
C     INPUT ARRAY OPIMRE SHOULD CONTAIN
C        1. REAL OR IMAGINARY PARTS OF MATRIX ELEMENTS (IMAREA=+1/-1)
C        2. IN SIMPLEX PLUS-PLUS OR PLUS-MINUS BLOCK (ISIPAR=+1/-1)
C     RESULTING AVRVAL VECTOR THEN CONTAINS
C        1. REAL OR IMAGINARY PARTS OF AVERAGE VALUES (IHERMI=+1/-1)
C=======================================================================
C
      LSTATE=NUMBSP(0,ICHARG)+MREVER*NUMBSP(1,ICHARG)
C
      IF (ISIPAR.EQ.1) THEN
C
!$OMP PARALLEL DO
!$OMP& DEFAULT(NONE)
!$OMP& SCHEDULE(DYNAMIC)
!$OMP& SHARED(LSTATE,LDBASE,OPIMRE,WAVOCC,IMAREA,ITIPAR,IHERMI,
!$OMP&                                                  AVRVAL)
!$OMP& PRIVATE(ISTATE,IKET,IBRA,RESULT)
          DO ISTATE=1,LSTATE
C
             RESULT=CMPLX(0.0D0,0.0D0)
C
             DO IKET=1,LDBASE
                DO IBRA=1,LDBASE
                   RESULT=RESULT
     *                  +OPIMRE(IBRA,IKET)*(CONJG(WAVOCC(IBRA,ISTATE,0))
     *                                           *WAVOCC(IKET,ISTATE,0)
     *                       +IMAREA*ITIPAR*CONJG(WAVOCC(IBRA,ISTATE,1))
     *                                           *WAVOCC(IKET,ISTATE,1))
                END DO
             END DO
C
             IF (IMAREA.EQ.-1) RESULT=RESULT*CMPLX(0.0D0,1.0D0)
C
             IF (IHERMI.EQ.1) THEN
                 AVRVAL(ISTATE)=REAL(RESULT)
             ELSE
                 AVRVAL(ISTATE)=AIMAG(RESULT)
             END IF
C
          END DO
!$OMP END PARALLEL DO
C
      ELSE
C
!$OMP PARALLEL DO
!$OMP& DEFAULT(NONE)
!$OMP& SCHEDULE(DYNAMIC)
!$OMP& SHARED(LSTATE,LDBASE,OPIMRE,WAVOCC,IMAREA,ITIPAR,IHERMI,
!$OMP&                                                  AVRVAL)
!$OMP& PRIVATE(ISTATE,IKET,IBRA,RESULT)
          DO ISTATE=1,LSTATE
C
             RESULT=CMPLX(0.0D0,0.0D0)
C
             DO IKET=1,LDBASE
                DO IBRA=1,LDBASE
                   RESULT=RESULT
     *                  +OPIMRE(IBRA,IKET)*CONJG(WAVOCC(IBRA,ISTATE,1))
     *                                          *WAVOCC(IKET,ISTATE,0)
                END DO
             END DO
C
             IF (IMAREA.EQ.-1) RESULT=RESULT*CMPLX(0.0D0,1.0D0)
C
             IF (IHERMI.EQ.1) THEN
                 AVRVAL(ISTATE)=REAL(RESULT)
             ELSE
                 AVRVAL(ISTATE)=AIMAG(RESULT)
             END IF
C
             AVRVAL(ISTATE)=-2*IMAREA*ITIPAR*AVRVAL(ISTATE)
C
          END DO
!$OMP END PARALLEL DO
C
      END IF
C
      CALL CPUTIM('SPAVER',0)
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE AVEQUA(AVRVAL,OPCOMP,EWAVEF)
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      DIMENSION
     *          AVRVAL(1:NDBASE)
      DIMENSION
     *          OPCOMP(1:NDBASE,1:NDBASE)
C=======================================================================
      ALLOCATABLE AUXILI(:,:)
C=======================================================================
      COMPLEX, DIMENSION(:,:), INTENT(INOUT) :: EWAVEF
C=======================================================================
C
      COMPLEX
     *          AUXILI,OPCOMP
      COMPLEX
     *          C_ZERO,C_UNIT
      COMPLEX
     *          ZDOTU
C
      COMMON
     *       /DIMENS/ LDBASE
C
C=======================================================================
C
      CALL CPUTIM('AVEQUA',1)
C
C=======================================================================
C
      IALLOC=0
C
C=======================================================================
      ALLOCATE (AUXILI(1:NDBASE,1:NDBASE),STAT=IALLOC)
      IF (IALLOC.NE.0) CALL NOALLO('AUXILI','AVEQUA')
C=======================================================================
C
C=======================================================================
C       THIS SUBROUTINE CALCULATES THE SINGLE-PARTICLE AVERAGE VALUES
C       OF AN OPERATOR 'OPCOMP' (HERMITIAN & COMPLEX IN THE HO BASIS)
C       WITHIN THE SINGLE-PARTICLE STATES.
C=======================================================================
C
      C_ZERO=CMPLX(0.0D0,0.0D0)
      C_UNIT=CMPLX(1.0D0,0.0D0)
C
C=======================================================================
C
      CALL ZGEMM('C','N',LDBASE,LDBASE,LDBASE,C_UNIT,EWAVEF,NDBASE,
     *                   OPCOMP,NDBASE,C_ZERO,AUXILI,NDBASE)
      DO ISTATE=1,LDBASE
C
         AVRVAL(ISTATE) = REAL(ZDOTU(LDBASE,AUXILI(ISTATE,1),NDBASE,
     *                                      EWAVEF(1,ISTATE),1))
C
      END DO
C
C=======================================================================
      DEALLOCATE (AUXILI)
C=======================================================================
C
      CALL CPUTIM('AVEQUA',0)
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE AVEQUZ(AVRVAL,OPE_PP,OPE_PM,EWAVEF)
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      DIMENSION
     *          AVRVAL(1:2*NDBASE)
      DIMENSION
     *          OPE_PP(1:NDBASE,1:NDBASE,0:NDREVE),
     *          OPE_PM(1:NDBASE,1:NDBASE,0:NDREVE)
C=======================================================================
      ALLOCATABLE AUXILI(:,:),OPERAT(:,:)
C=======================================================================
      COMPLEX, DIMENSION(:,:), INTENT(INOUT) :: EWAVEF
C=======================================================================
      COMPLEX
     *          AUXILI,OPE_PP,OPE_PM,OPERAT
      COMPLEX
     *          C_ZERO,C_UNIT
      COMPLEX
     *          ZDOTU
C
      COMMON
     *       /DIMENS/ LDBASE
C
C=======================================================================
C
      CALL CPUTIM('AVEQUZ',1)
C
C=======================================================================
C
      IALLOC=0
C
C=======================================================================
      ALLOCATE (AUXILI(1:2*NDBASE,1:2*NDBASE),STAT=IALLOC)
      IF (IALLOC.NE.0) CALL NOALLO('AUXILI','AVEQUZ')
      ALLOCATE (OPERAT(1:2*NDBASE,1:2*NDBASE),STAT=IALLOC)
      IF (IALLOC.NE.0) CALL NOALLO('AUXILI','AVEQUZ')
C=======================================================================
C
      C_ZERO=CMPLX(0.0D0,0.0D0)
      C_UNIT=CMPLX(1.0D0,0.0D0)
C
C=======================================================================
C       THIS SUBROUTINE CALCULATES THE SINGLE-PARTICLE  AVERAGE  VALUES
C       OF AN OPERATOR IN THE NO-SYMMETRY  CASE  (HERMITIAN  &  COMPLEX
C       IN THE HO BASIS) WITHIN THE SINGLE-PARTICLE STATES. ITS  MATRIX
C       ELEMENTS IN THE "PP"+"PM" REPRESENTATION ARE STORED  IN  ARRAYS
C       "OPE_PP" AND "OPE_PM".
C=======================================================================
C
      DO J=1,LDBASE
         DO I=1,LDBASE
            OPERAT(I,       J       ) = OPE_PP(I,J,0)
            OPERAT(I+LDBASE,J       ) = OPE_PM(I,J,1)
            OPERAT(I,       J+LDBASE) = OPE_PM(I,J,0)
            OPERAT(I+LDBASE,J+LDBASE) = OPE_PP(I,J,1)
         END DO
      END DO
C
      CALL ZGEMM('C','N',2*LDBASE,2*LDBASE,2*LDBASE,C_UNIT,EWAVEF,
     *                   2*NDBASE,  OPERAT,2*NDBASE,C_ZERO,AUXILI,
     *                   2*NDBASE)
C
      DO ISTATE=1,2*LDBASE
C
         AVRVAL(ISTATE) = REAL(ZDOTU(2*LDBASE,AUXILI(ISTATE,1),
     *                               2*NDBASE,EWAVEF(1,ISTATE),1))
C
      END DO
C
C=======================================================================
      DEALLOCATE (AUXILI)
C=======================================================================
C
      CALL CPUTIM('AVEQUZ',0)
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE EKINET(ENEKIN,DLINSQ,EKEKIN,DKINSQ)
C=======================================================================
      USE MAT_PP
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      COMPLEX
     *          RESULT,EKEKIN
      COMPLEX
     *          DKINSQ
C=======================================================================
      ALLOCATABLE HAUXPP(:,:)
C=======================================================================
      COMMON
     *       /PLANCK/ HBMASS,HBMRPA,HBMINP
      COMMON
     *       /DIMENS/ LDBASE
C
C=======================================================================
C
      IALLOC=0
C
C=======================================================================
      ALLOCATE (HAUXPP(1:NDBASE,1:NDBASE),STAT=IALLOC)
      IF (IALLOC.NE.0) CALL NOALLO('HAUXPP','EKINET')
C=======================================================================
C
C=======================================================================
C       THIS SUBROUTINE CALCULATES THE AVERAGE KINETIC ENERGY
C=======================================================================
C
      FACTOR=1.0D0
C
      CALL INTKIN(HAUXPP,FACTOR)
C
      RESULT=CMPLX(0.0D0,0.0D0)
C
      DO IBRA=1,LDBASE
         DO IKET=1,LDBASE
C
            RESULT=RESULT+HAUXPP(IBRA,IKET)*(BIG_PP(IKET,IBRA,0)
     *                                     + BIG_PP(IKET,IBRA,1))
C
         END DO
      END DO
C
      DLINSQ=REAL(RESULT)
      DKINSQ=RESULT
C
      ENEKIN=HBMRPA*DLINSQ
      EKEKIN=HBMRPA*DKINSQ
C
C=======================================================================
      DEALLOCATE (HAUXPP)
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C@@@ SHELL -SHELL - SHELL - SHELL - SHELL - SHELL - SHELL - SHELL
      SUBROUTINE KINSIZ(NXHERM,NYHERM,NZHERM,NXMAXX,NYMAXX,NZMAXX,
     *                  NUMCOU,BOUCOU,ISURFA,IKERNE,ISIMPY,ICHARG)
C=======================================================================
      USE HCOULO
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      COMPLEX
     *          CELMTS,CMPLPP,CMPLPM
      COMPLEX
     *          EWAVEF,C_ZERO
C=======================================================================
      ALLOCATABLE CELMTS(:)
      ALLOCATABLE FREGAS(:,:),CMPLPP(:,:),CMPLPM(:,:),EWAVEF(:,:)
C=======================================================================
C
      DIMENSION
     *          ESINGP(1:2*NDBASE)
C
      COMMON
     *       /SPNUMS/ NUMBSP(0:NDREVE,0:NDISOS)
      COMMON
     *       /KIN_SP/ SPGASP(1:2*NDBASE),SPGASN(1:2*NDBASE)
      COMMON
     *       /PLANCK/ HBMASS,HBMRPA,HBMINP
      COMMON
     *       /DIMENS/ LDBASE
C
C=======================================================================
C      THE SUBROUTINE COMPUTES THE EIGENVALUES OF THE FREE GAS OF
C      NEUTRONS  OR  PROTONS (DEPENDING ON ICHARG) IN THE CASE OF
C      BROKEN SIMPLEX.  THE SIMPLEX  OFF-DIAGONAL  COMPONENT ONLY
C      APPEARS FOR PROTON AND IS CAUSED BY THE COULOMB POTENTIAL.
C      IN THIS CASE, THE EIGENVALUES ARE  NOT DEGENERATE ANYMORE,
C      AND THE SIZE OF THE VECTOR IS TWICE WHAT IT IS IN  KINSIG.
C=======================================================================
C
      IALLOC=0
C
C=======================================================================
      ALLOCATE (FREGAS(1:NDBASE,1:NDBASE),STAT=IALLOC)
      IF (IALLOC.NE.0) CALL NOALLO('FREGAS','KINSIZ')
      ALLOCATE (CMPLPP(1:NDBASE,1:NDBASE),STAT=IALLOC)
      IF (IALLOC.NE.0) CALL NOALLO('CMPLPP','KINSIZ')
      ALLOCATE (CMPLPM(1:NDBASE,1:NDBASE),STAT=IALLOC)
      IF (IALLOC.NE.0) CALL NOALLO('CMPLPM','KINSIZ')
      ALLOCATE (EWAVEF(1:2*NDBASE,1:2*NDBASE),STAT=IALLOC)
      IF (IALLOC.NE.0) CALL NOALLO('EWAVEF','KINSIZ')
      ALLOCATE (CELMTS(1:(2*NDBASE+1)*NDBASE),STAT=IALLOC)
      IF (IALLOC.NE.0) CALL NOALLO('CELMTS','KINSIZ')
C=======================================================================
C
      DO J=1,LDBASE
         DO I=1,LDBASE
            CMPLPP(I,J)=CMPLX(0.0D0,0.0D0)
            CMPLPM(I,J)=CMPLX(0.0D0,0.0D0)
         END DO
      END DO
C
C=======================================================================
C      CALCULATING THE MATRIX ELEMENTS OF THE KINETIC ENERGY (FREE GAS)
C=======================================================================
C
      HBMAUX=20.7362D0
C
      CALL INTKIN(FREGAS,HBMAUX)
C
      CALL PUTREA(+1,FREGAS,CMPLPP)
C
C=======================================================================
C      CALCULATING THE COULOMB MATRIX ELEMENTS (AT CONVERGENCE)
C=======================================================================
C
      IF (ICHARG.EQ.1) THEN
C
          PIOMAS=0.0D0
          ISURFA=1
C
          CALL COUMAT(NXHERM,NYHERM,NZHERM,NXMAXX,NYMAXX,NZMAXX,
     *                              NUMCOU,BOUCOU,ISIMPY,IKERNE)
C
          DO J=1,LDBASE
             DO I=1,LDBASE
                FREGAS(I,J)=REAL(HPPCOU(I,J))
             END DO
          END DO
          CALL PUTREA(+1,FREGAS,CMPLPP)
C
          DO J=1,LDBASE
             DO I=1,LDBASE
                FREGAS(I,J)=REAL(HPMCOU(I,J))
             END DO
          END DO
          CALL PUTREA(+1,FREGAS,CMPLPM)
C
      END IF
C
C=======================================================================
C      CONSTRUCTING AND DIAGONALIZING THIS MATRIX
C=======================================================================
C
      NCOUNT=0
C
      DO IKET=1,2*LDBASE
         DO IBRA=IKET,2*LDBASE
C
            NCOUNT=NCOUNT+1
C
            IF (IBRA.LE.LDBASE.AND.IKET.LE.LDBASE)
     *
     *          CELMTS(NCOUNT)=CMPLPP(IBRA,IKET)
C
            IF (IBRA.GT.LDBASE.AND.IKET.LE.LDBASE)
     *
     *          CELMTS(NCOUNT)=CMPLPM(IBRA-LDBASE,IKET)
C
            IF (IBRA.GT.LDBASE.AND.IKET.GT.LDBASE)
     *
     *          CELMTS(NCOUNT)=CMPLPP(IBRA-LDBASE,IKET-LDBASE)
C
         END DO
      END DO
C
      CALL DIAMAT(CELMTS,ESINGP,EWAVEF,2*LDBASE,2*NDBASE,
     *                          NUMBSP(0,ICHARG)+NUMBSP(1,ICHARG))
C
C=======================================================================
C      STORING EIGENVALUES IN VECTORS PASSED TO WSHELL
C=======================================================================
C
      IF (ICHARG.EQ.0) THEN
          DO I=1,NUMBSP(0,ICHARG)+NUMBSP(1,ICHARG)
             SPGASN(I)=ESINGP(I)
          END DO
      ELSE
          DO I=1,NUMBSP(0,ICHARG)+NUMBSP(1,ICHARG)
             SPGASP(I)=ESINGP(I)
          END DO
      END IF
C
C=======================================================================
      DEALLOCATE (CELMTS,FREGAS,CMPLPP,CMPLPM,EWAVEF)
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE KINSIG(NXHERM,NYHERM,NZHERM,NXMAXX,NYMAXX,NZMAXX,
     *                  NUMCOU,BOUCOU,ISURFA,IKERNE,ISIMPY,ICHARG,
     *                                                     MREVER)
C=======================================================================
      USE HCOULO
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      COMPLEX
     *          CELMTS,CMPLPP
      COMPLEX
     *          EWAVEF,C_ZERO
C=======================================================================
      ALLOCATABLE CELMTS(:)
      ALLOCATABLE FREGAS(:,:),CMPLPP(:,:),EWAVEF(:,:)
C=======================================================================
C
      DIMENSION
     *          ESINGP(1:NDBASE)
C
      COMMON
     *       /SPNUMS/ NUMBSP(0:NDREVE,0:NDISOS)
      COMMON
     *       /KIN_SP/ SPGASP(1:2*NDBASE),SPGASN(1:2*NDBASE)
      COMMON
     *       /PLANCK/ HBMASS,HBMRPA,HBMINP
      COMMON
     *       /DIMENS/ LDBASE
C
C=======================================================================
C      THE  SUBROUTINE  COMPUTES THE EIGENVALUES OF THE FREE GAS OF
C      NEUTRONS  OR  PROTONS (DEPENDING ON  ICHARG ) IN THE CASE OF
C      CONSERVED SIMPLEX. SINCE NEITHER THE KINETIC ENERGY OPERATOR
C      NOR THE COULOMB POTENTIAL CONTAINS A TIME-REVERSAL  SYMMETRY
C      COMPONENT, ONLY  ONE  HALF  OF THE  TOTAL MATRIX NEEDS TO BE
C      COMPUTED (POSITIVE SIMPLEX BY CONVENTION).
C=======================================================================
C
      IALLOC=0
C
C=======================================================================
      ALLOCATE (FREGAS(1:NDBASE,1:NDBASE),STAT=IALLOC)
      IF (IALLOC.NE.0) CALL NOALLO('FREGAS','KINSIG')
      ALLOCATE (CMPLPP(1:NDBASE,1:NDBASE),STAT=IALLOC)
      IF (IALLOC.NE.0) CALL NOALLO('CMPLPP','KINSIG')
      ALLOCATE (EWAVEF(1:NDBASE,1:NDBASE),STAT=IALLOC)
      IF (IALLOC.NE.0) CALL NOALLO('EWAVEF','KINSIG')
      ALLOCATE (CELMTS(1:(2*NDBASE+1)*NDBASE),STAT=IALLOC)
      IF (IALLOC.NE.0) CALL NOALLO('CELMTS','KINSIG')
C=======================================================================
C
      DO J=1,LDBASE
         DO I=1,LDBASE
            CMPLPP(I,J)=CMPLX(0.0D0,0.0D0)
         END DO
      END DO
C
C=======================================================================
C      CALCULATING THE MATRIX ELEMENTS OF THE KINETIC ENERGY (FREE GAS)
C=======================================================================
C
      HBMAUX=20.7362D0
C
      CALL INTKIN(FREGAS,HBMAUX)
C
      CALL PUTREA(+1,FREGAS,CMPLPP)
C
C=======================================================================
C      CALCULATING THE COULOMB MATRIX ELEMENTS (AT CONVERGENCE)
C=======================================================================
C
      IF (ICHARG.EQ.1) THEN
C
          PIOMAS=0.0D0
          ISURFA=1
C
          CALL COUMAT(NXHERM,NYHERM,NZHERM,NXMAXX,NYMAXX,NZMAXX,
     *                              NUMCOU,BOUCOU,ISIMPY,IKERNE)
C
          DO J=1,LDBASE
             DO I=1,LDBASE
                FREGAS(I,J)=REAL(HPPCOU(I,J))
             END DO
          END DO
          CALL PUTREA(+1,FREGAS,CMPLPP)
C
      END IF
C
C=======================================================================
C      CONSTRUCTING AND DIAGONALIZING THIS MATRIX
C=======================================================================
C
      NCOUNT=0
C
      DO IKET=1,LDBASE
         DO IBRA=IKET,LDBASE
C
            NCOUNT=NCOUNT+1
C
            CELMTS(NCOUNT)=CMPLPP(IBRA,IKET)
C
         END DO
      END DO
C
      CALL DIAMAT(CELMTS,ESINGP,EWAVEF,LDBASE,NDBASE,
     *                          NUMBSP(0,ICHARG))
C
C=======================================================================
C      STORING EIGENVALUES IN VECTORS PASSED TO WSHELL
C=======================================================================
C
      IF (ICHARG.EQ.0) THEN
          DO I=1,NUMBSP(0,ICHARG)
             SPGASN(I)=ESINGP(I)
          END DO
      ELSE
          DO I=1,NUMBSP(0,ICHARG)
             SPGASP(I)=ESINGP(I)
          END DO
      END IF
C
      IF (MREVER.EQ.1) THEN
C
          IF (ICHARG.EQ.0) THEN
              DO I=1,NUMBSP(1,ICHARG)
                 SPGASN(I+MREVER*NUMBSP(0,ICHARG))=ESINGP(I)
              END DO
          ELSE
              DO I=1,NUMBSP(1,ICHARG)
                 SPGASP(I+MREVER*NUMBSP(0,ICHARG))=ESINGP(I)
              END DO
          END IF
C
      END IF
C
C=======================================================================
      DEALLOCATE (CELMTS,FREGAS,CMPLPP,EWAVEF)
C=======================================================================
C
      RETURN
      END
C
C@@@ SHELL -SHELL - SHELL - SHELL - SHELL - SHELL - SHELL - SHELL
C=======================================================================
C
      SUBROUTINE EPOTHO(ENE_HO)
C=======================================================================
      USE MAT_PP
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      COMPLEX
     *          RESULT
C=======================================================================
      ALLOCATABLE HAUXPP(:,:)
C=======================================================================
      COMMON
     *       /BASPAR/ HBAROX,HBAROY,HBAROZ
      COMMON
     *       /PLANCK/ HBMASS,HBMRPA,HBMINP
      COMMON
     *       /DIMENS/ LDBASE
C
C=======================================================================
C
      IALLOC=0
C
C=======================================================================
      ALLOCATE (HAUXPP(1:NDBASE,1:NDBASE),STAT=IALLOC)
      IF (IALLOC.NE.0) CALL NOALLO('HAUXPP','EPOTHO')
C=======================================================================
C
C=======================================================================
C       THIS SUBROUTINE CALCULATES THE POTENTIAL HO ENERGY
C=======================================================================
C
      ESCALE=0.0D0
C
      CALL INT_HO(HAUXPP,HBMASS,ESCALE,HBAROX,HBAROY,HBAROZ)
C
      RESULT=CMPLX(0.0D0,0.0D0)
C
      DO IBRA=1,LDBASE
         DO IKET=1,LDBASE
C
            RESULT=RESULT+HAUXPP(IBRA,IKET)*(BIG_PP(IKET,IBRA,0)
     *                                     + BIG_PP(IKET,IBRA,1))
C
         END DO
      END DO
C
      ENE_HO=REAL(RESULT)
C
C=======================================================================
      DEALLOCATE (HAUXPP)
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE SPIMOM(NXMAXX,NYMAXX,NZMAXX,ISIMPY,IROTAT,
     *                                       SPINTO,SPININ)
C=======================================================================
      USE MAT_PP
      USE MAT_PM
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      COMPLEX
     *          RESULT
C=======================================================================
      DIMENSION
     *          SPINTO(1:NDKART),SPININ(1:NDKART)
C=======================================================================
      ALLOCATABLE HAUXPM(:,:)
C=======================================================================
      COMMON
     *       /T_PHAS/ IPHAPP(0:NDYMAX,0:NDYMAX,0:NDKART),
     *                IPHAPM(0:NDYMAX,0:NDYMAX,0:NDKART),
     *                IPHAMP(0:NDYMAX,0:NDYMAX,0:NDKART),
     *                IPHAMM(0:NDYMAX,0:NDYMAX,0:NDKART)
      COMMON
     *       /DIMENS/ LDBASE
C
C=======================================================================
C
      CALL CPUTIM('SPIMOM',1)
C
C=======================================================================
C
      IALLOC=0
C
C=======================================================================
      ALLOCATE (HAUXPM(1:NDBASE,1:NDBASE),STAT=IALLOC)
      IF (IALLOC.NE.0) CALL NOALLO('HAUXPM','SPIMOM')
C=======================================================================
C
C=======================================================================
C       THIS SUBROUTINE CALCULATES THE AVERAGE TOTAL     SPIN
C                              AND THE AVERAGE INTRINSIC SPIN
C=======================================================================
C
      DO KARTEZ=1,NDKART
C
         SPINTO(KARTEZ)=0.0D0
         SPININ(KARTEZ)=0.0D0
C
      END DO
C
      IF (IROTAT.NE.1) GO TO 1
C
C=======================================================================
C
      FACTOR=1.0D0
C
      IF (ISIMPY.EQ.1) GO TO 2
C
C=======================================================================
C                             O R B I T A L   X-DIRECTION
C=======================================================================
C
      CALL INT_LX(NXMAXX,NYMAXX,NZMAXX,IPHAPM(0,0,0),HAUXPM,FACTOR)
C
      RESULT=CMPLX(0.0D0,0.0D0)
C
      DO IBRA=1,LDBASE
         DO IKET=1,LDBASE
C
            RESULT=RESULT + HAUXPM(IBRA,IKET) * BIG_PM(IKET,IBRA,0)
C
         END DO
      END DO
C
      SPIORB=2*AIMAG(RESULT)
C
C=======================================================================
C                           I N T R I N S I C   X-DIRECTION
C=======================================================================
C
      CALL INT_SX(NXMAXX,NYMAXX,NZMAXX,HAUXPM,FACTOR)
C
      RESULT=CMPLX(0.0D0,0.0D0)
C
      DO IBRA=1,LDBASE
         DO IKET=1,LDBASE
C
            RESULT=RESULT + HAUXPM(IBRA,IKET) * BIG_PM(IKET,IBRA,0)
C
         END DO
      END DO
C
      SPININ(1)=2*REAL(RESULT)
C
      SPINTO(1)=SPININ(1)+SPIORB
C
C=======================================================================
C                             O R B I T A L   Z-DIRECTION
C=======================================================================
C
      CALL INT_LZ(NXMAXX,NYMAXX,NZMAXX,IPHAPM(0,0,0),HAUXPM,FACTOR)
C
      RESULT=CMPLX(0.0D0,0.0D0)
C
      DO IBRA=1,LDBASE
         DO IKET=1,LDBASE
C
            RESULT=RESULT + HAUXPM(IBRA,IKET) * BIG_PM(IKET,IBRA,0)
C
         END DO
      END DO
C
      SPIORB=2*AIMAG(RESULT)
C
C=======================================================================
C                           I N T R I N S I C   Z-DIRECTION
C=======================================================================
C
      CALL INT_SZ(NXMAXX,NYMAXX,NZMAXX,HAUXPM,FACTOR)
C
      RESULT=CMPLX(0.0D0,0.0D0)
C
      DO IBRA=1,LDBASE
         DO IKET=1,LDBASE
C
            RESULT=RESULT + HAUXPM(IBRA,IKET) * BIG_PM(IKET,IBRA,0)
C
         END DO
      END DO
C
      SPININ(3)=2*AIMAG(RESULT)
C
      SPINTO(3)=SPININ(3)+SPIORB
C
C=======================================================================
C
    2 CONTINUE
C
C=======================================================================
C                             O R B I T A L   Y-DIRECTION
C=======================================================================
C
      CALL INT_LY(NXMAXX,NYMAXX,NZMAXX,IPHAPP(0,0,0),HAUXPM,FACTOR)
C
      RESULT=CMPLX(0.0D0,0.0D0)
C
      DO IBRA=1,LDBASE
         DO IKET=1,LDBASE
C
            RESULT=RESULT + HAUXPM(IBRA,IKET) * (BIG_PP(IKET,IBRA,0)
     *                                          +BIG_PP(IKET,IBRA,1))
C
         END DO
      END DO
C
      RESULT=RESULT*CMPLX(0.0D0,1.0D0)
C
      SPIORB=REAL(RESULT)
C
C=======================================================================
C                           I N T R I N S I C   Y-DIRECTION
C=======================================================================
C
      CALL INT_SY(NXMAXX,NYMAXX,NZMAXX,HAUXPM,FACTOR)
C
      RESULT=CMPLX(0.0D0,0.0D0)
C
      DO IBRA=1,LDBASE
         DO IKET=1,LDBASE
C
            RESULT=RESULT + HAUXPM(IBRA,IKET) * (BIG_PP(IKET,IBRA,0)
     *                                          -BIG_PP(IKET,IBRA,1))
C
         END DO
      END DO
C
      SPININ(2)=REAL(RESULT)
C
      SPINTO(2)=SPININ(2)+SPIORB
C
C=======================================================================
C
    1 CONTINUE
C
C=======================================================================
      DEALLOCATE (HAUXPM)
C=======================================================================
C
      CALL CPUTIM('SPIMOM',0)
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE ANGSHI(ALINLI,ANGUTO,ANGSTO)
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      DIMENSION
     *          ALINLI(0:NDKART),ANGUTO(1:NDKART),ANGSTO(1:NDKART)
C
      COMMON
     *       /SHIFTR/ RSHIFT(1:NDKART)
C
C=======================================================================
C       THIS SUBROUTINE CALCULATES THE AVERAGE ORBITAL ANGULAR MOMENTUM
C       IN THE CENTER-OF-MASS REFERENCE FRAME
C=======================================================================
C
      DO KARTEZ=1,NDKART
C
         KARTEP=KARTEZ+1
         IF (KARTEP.GT.NDKART) KARTEP=KARTEP-NDKART
C
         KARTEM=KARTEZ+2
         IF (KARTEM.GT.NDKART) KARTEM=KARTEM-NDKART
C
         ANGSTO(KARTEZ)=ANGUTO(KARTEZ)-RSHIFT(KARTEP)*ALINLI(KARTEM)
     *                                +RSHIFT(KARTEM)*ALINLI(KARTEP)
C
      END DO
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE ANGROT(ALPACT,BETACT,GAMACT,YSHI_N,YSHI_P,YSHI_T,
     *                                       YROT_N,YROT_P,YROT_T)
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      DIMENSION
     *          YSHI_N(1:NDKART),YSHI_P(1:NDKART),YSHI_T(1:NDKART)
      DIMENSION
     *          YROT_N(1:NDKART),YROT_P(1:NDKART),YROT_T(1:NDKART)
      DIMENSION
     *          XSHI_N(0:NDMULT,-NDMULT:NDMULT),
     *          XSHI_P(0:NDMULT,-NDMULT:NDMULT),
     *          XSHI_T(0:NDMULT,-NDMULT:NDMULT)
      DIMENSION
     *          XROT_N(0:NDMULT,-NDMULT:NDMULT),
     *          XROT_P(0:NDMULT,-NDMULT:NDMULT),
     *          XROT_T(0:NDMULT,-NDMULT:NDMULT)
      COMMON
     *       /MAGUNI/ AUNITS(0:NDMULT,0:NDMULT)
C
C=======================================================================
C       THIS SUBROUTINE CALCULATES THE AVERAGE ORBITAL OR SPIN ANGULAR
C       MOMENTA IN THE INTRINSIC REFERENCE FRAME
C=======================================================================
C
      PI=4.0D0*ATAN(1.00D0)
C
C=======================================================================
C       CALCULATION OF SPHERICAL COMPONENTS.
C=======================================================================
C       VALUE FOR L=0 AND MULTIPLICATION BY "AUNITS" ARE SPURIOUS;
C       THEY ARE REQUIRED ONLY IN ORDER TO ENSURE A  COMPATIBILITY
C       WITH THE CALL TO "PAXMOM" BELOW.
C=======================================================================
C
      XSHI_N(0, 0)= 0.0
      XSHI_N(1, 1)=-YSHI_N(1)/SQRT(8*PI/3)*AUNITS(1,1)
      XSHI_N(1,-1)= YSHI_N(2)/SQRT(8*PI/3)*AUNITS(1,1)
      XSHI_N(1, 0)= YSHI_N(3)/SQRT(4*PI/3)*AUNITS(1,0)
C
      XSHI_P(0, 0)= 0.0
      XSHI_P(1, 1)=-YSHI_P(1)/SQRT(8*PI/3)*AUNITS(1,1)
      XSHI_P(1,-1)= YSHI_P(2)/SQRT(8*PI/3)*AUNITS(1,1)
      XSHI_P(1, 0)= YSHI_P(3)/SQRT(4*PI/3)*AUNITS(1,0)
C
      XSHI_T(0, 0)= 0.0
      XSHI_T(1, 1)=-YSHI_T(1)/SQRT(8*PI/3)*AUNITS(1,1)
      XSHI_T(1,-1)= YSHI_T(2)/SQRT(8*PI/3)*AUNITS(1,1)
      XSHI_T(1, 0)= YSHI_T(3)/SQRT(4*PI/3)*AUNITS(1,0)
C
C=======================================================================
C       ROTATION OF SPHERICAL COMPONENTS
C=======================================================================
C
      KSHIAN=1
      KROTAN=1
C
      CALL PAXMOM(KSHIAN,KROTAN,AUNITS,XSHI_N,XSHI_P,XSHI_T,
     *            ALPACT,BETACT,GAMACT,XROT_N,XROT_P,XROT_T)
C
C=======================================================================
C       CALCULATION OF CARTESIAN COMPONENTS
C=======================================================================
C
      YROT_N(1)=-SQRT(8*PI/3)*XROT_N(1, 1)/AUNITS(1,1)
      YROT_N(2)= SQRT(8*PI/3)*XROT_N(1,-1)/AUNITS(1,1)
      YROT_N(3)= SQRT(4*PI/3)*XROT_N(1, 0)/AUNITS(1,0)
C
      YROT_P(1)=-SQRT(8*PI/3)*XROT_P(1, 1)/AUNITS(1,1)
      YROT_P(2)= SQRT(8*PI/3)*XROT_P(1,-1)/AUNITS(1,1)
      YROT_P(3)= SQRT(4*PI/3)*XROT_P(1, 0)/AUNITS(1,0)
C
      YROT_T(1)=-SQRT(8*PI/3)*XROT_T(1, 1)/AUNITS(1,1)
      YROT_T(2)= SQRT(8*PI/3)*XROT_T(1,-1)/AUNITS(1,1)
      YROT_T(3)= SQRT(4*PI/3)*XROT_T(1, 0)/AUNITS(1,0)
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE LINAVR(NXMAXX,NYMAXX,NZMAXX,ISIMPY,ISIGNY,ISIQTY,
     *                 IPAIRI,ICHARG,JETACM,IROTAT,MREVER,COR_CM,
     *                 DLINSQ,ELINSQ,PLINSQ,TLINSQ,ALINLI,PLINLI,PLINKI,
     *                 DKINSQ,EKINSQ,PKINSQ,TKINSQ,AKINLI,PKINLI,PKINKI)
C=======================================================================
      USE MAT_PP
      USE MAT_PM
      USE KAP_PP
      USE KAP_PM
      USE ALISTO
      USE PLISTO
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      COMPLEX
     *          RESULT,AUXILI,BUXILI,C_ZERO
      COMPLEX
     *          DKINSQ,
     *          EKINSQ,
     *          PKINSQ,
     *          TKINSQ,
     *          AKINLI,
     *          PKINLI,
     *          PKINKI
      LOGICAL
     *          COR_CM
C
      DIMENSION
     *          DLINSQ(0:NDKART),
     *          ELINSQ(0:NDKART),
     *          PLINSQ(0:NDKART),
     *          TLINSQ(0:NDKART),
     *          ALINLI(0:NDKART),
     *          PLINLI(0:NDKART),
     *          PLINKI(0:NDKART)
      DIMENSION
     *          DKINSQ(0:NDKART),
     *          EKINSQ(0:NDKART),
     *          PKINSQ(0:NDKART),
     *          TKINSQ(0:NDKART),
     *          AKINLI(0:NDKART),
     *          PKINLI(0:NDKART),
     *          PKINKI(0:NDKART)
C=======================================================================
      ALLOCATABLE AUXILI(:,:,:)
      ALLOCATABLE BUXILI(:,:,:)
      ALLOCATABLE HAUXIL(:,:)
C=======================================================================
      COMMON
     *       /T_PHAS/ IPHAPP(0:NDYMAX,0:NDYMAX,0:NDKART),
     *                IPHAPM(0:NDYMAX,0:NDYMAX,0:NDKART),
     *                IPHAMP(0:NDYMAX,0:NDYMAX,0:NDKART),
     *                IPHAMM(0:NDYMAX,0:NDYMAX,0:NDKART)
      COMMON
     *       /DIMENS/ LDBASE
C
C=======================================================================
C
      CALL CPUTIM('LINAVR',1)
C
C=======================================================================
C
      IALLOC=0
C
C=======================================================================
      IF (.NOT.ALLOCATED(ALINPP).AND.JETACM.EQ.2) THEN
          ALLOCATE (ALINPP(NDBASE,NDBASE,1:NDKART,0:NDREVE,0:NDISOS),
     *                                                      STAT=IALLOC)
          IF (IALLOC.NE.0) CALL NOALLO('ALINPP','LINAVR')
      END IF
C=======================================================================
      IF (.NOT.ALLOCATED(ALINPM).AND.JETACM.EQ.2.AND.ISIMPY.NE.1) THEN
          ALLOCATE (ALINPM(NDBASE,NDBASE,1:NDKART,0:NDREVE,0:NDISOS),
     *                                                      STAT=IALLOC)
          IF (IALLOC.NE.0) CALL NOALLO('ALINPM','LINAVR')
      END IF
C=======================================================================
      IF (.NOT.ALLOCATED(PLINPM).AND.JETACM.EQ.2.AND.IPAIRI.EQ.1) THEN
          ALLOCATE (PLINPM(NDBASE,NDBASE,1:NDKART,0:NDREVE,0:NDISOS),
     *                                                      STAT=IALLOC)
          IF (IALLOC.NE.0) CALL NOALLO('PLINPM','LINAVR')
      END IF
C=======================================================================
      IF (.NOT.ALLOCATED(PLINPP).AND.JETACM.EQ.2.AND.IPAIRI.EQ.1.AND.
     *                                               ISIMPY.NE.1) THEN
          ALLOCATE (PLINPP(NDBASE,NDBASE,1:NDKART,0:NDREVE,0:NDISOS),
     *                                                      STAT=IALLOC)
          IF (IALLOC.NE.0) CALL NOALLO('PLINPP','LINAVR')
      END IF
C=======================================================================
      ALLOCATE (AUXILI(1:NDBASE,1:NDBASE,0:NDREVE),STAT=IALLOC)
      IF (IALLOC.NE.0) CALL NOALLO('AUXILI','LINAVR')
      IF (IPAIRI.EQ.1) THEN
         ALLOCATE (BUXILI(1:NDBASE,1:NDBASE,0:NDREVE),STAT=IALLOC)
         IF (IALLOC.NE.0) CALL NOALLO('BUXILI','LINAVR')
      END IF
      ALLOCATE (HAUXIL(1:NDBASE,1:NDBASE),STAT=IALLOC)
      IF (IALLOC.NE.0) CALL NOALLO('HAUXIL','LINAVR')
C=======================================================================
C
C=======================================================================
C       THIS SUBROUTINE CALCULATES THE AVERAGE AND/OR  TRANSITION  TOTAL
C       LINEAR MOMENTA AND THE AVERAGE AND/OR TRANSITION SQUARE  OF  THE
C       LINEAR MOMENTUM. THE VARIABLE NAME CONVENTIONS ARE  AS  FOLLOWS:
C
C       DLINS_(1:3) CONTAINS THE DIRECT   PART OF <PX^2>, <PY^2>, <PZ^2>
C       ELINS_(1:3) CONTAINS THE EXCHANGE PART OF <PX^2>, <PY^2>, <PZ^2>
C       PLINS_(1:3) CONTAINS THE PAIRING  PART OF <PX^2>, <PY^2>, <PZ^2>
C       TLINS_(1:3) CONTAINS THE ENTIRE  VALUE OF <PX^2>, <PY^2>, <PZ^2>
C       ALINS_(1:3) CONTAINS THE AVERAGE VALUE OF <PX  >, <PY  >, <PZ  >
C
C       WHERE "_" STANDS FOR N (NEUTRON), P (PROTON), OR T (TOTAL) VALUE
C
C       NOTE THAT THE TOTAL VALUE OF THE ENTIRE VALUE IS  EVALUATED  AS:
C
C          TLINST(I) = TLINSN(I) + TLINSP(I) + 2*ALINSN(I)*ALINSP(I)
C
C       THE DIRECT   PART IS GIVEN BY  TRACE[(PI^2 RHO)] FOR I = X, Y, Z
C       THE EXCHANGE PART IS GIVEN BY  TRACE[(PI RHO)^2] FOR I = X, Y, Z
C       THE PAIRING  PART IS GIVEN BY  TRACE[(PI KAPPA)(PI KAPPA')*]
C       THE ENTIRE  VALUE IS GIVEN BY  TRACE[(PI^2 RHO)]
C                                     -TRACE[(PI RHO)^2]
C                                     -TRACE[(PI KAPPA)(PI KAPPA')*]
C                                     +[TRACE(PI RHO)]^2
C       THE AVERAGE VALUE IS GIVEN BY  TRACE (PI RHO)    FOR I = X, Y, Z
C
C       NOTE THAT THE EXCHANGE PART IS CALCULATED WITHOUT THE MINUS SIGN
C       SO THE EXCHANGE PART HAS TO BE   S U B T R A C T E D   FROM  THE
C       DIRECT PART.
C
C       DLINS_(0) CONTAINS THE SUM OF DIRECT PARTS  <PX^2>+<PY^2>+<PZ^2>
C       ELINS_(0) CONTAINS THE SUM OF EXCHNG PARTS  <PX^2>+<PY^2>+<PZ^2>
C       PLINS_(0) CONTAINS THE SUM OF PAIRNG PARTS  <PX^2>+<PY^2>+<PZ^2>
C       TLINS_(0) CONTAINS THE SUM OF ENTIRE VALUES <PX^2>+<PY^2>+<PZ^2>
C       ALINS_(0) CONTAINS THE SUM OF AVERAGES SQRD <PX>^2+<PY>^2+<PZ>^2
C=======================================================================
C       THIS SUBROUTINE ALSO CALCULATES THE EXCHANGE MEAN FIELDS RELATED
C       TO THE TWO-BODY CM CORRECTION. THE CONVENTION OF  STORING  THESE
C       MATRIX ELEMENTS IN ARRAYS ALINPP AND ALINPM IS THE SAME AS  THAT
C       FOR THE DENSITY MATRIX; HENCE IT IS    D I F F E R E N T    THAN
C       THAT USED TO STORE THE MATRIX ELEMENTS  OF  COULOMB  AND  YUKAWA
C       MEAN FIELDS.
C=======================================================================
C
      C_ZERO=CMPLX(0.0D0,0.0D0)
C
C=======================================================================
C        ZEROING ARRAYS OF AVERAGE VALUES
C=======================================================================
C
      DLINSQ(:)=0.0D0
      ELINSQ(:)=0.0D0
      PLINSQ(:)=0.0D0
      TLINSQ(:)=0.0D0
      ALINLI(:)=0.0D0
      PLINLI(:)=0.0D0
      PLINKI(:)=0.0D0
C
      DKINSQ(:)=C_ZERO
      EKINSQ(:)=C_ZERO
      PKINSQ(:)=C_ZERO
      TKINSQ(:)=C_ZERO
      AKINLI(:)=C_ZERO
      PKINLI(:)=C_ZERO
      PKINKI(:)=C_ZERO
C
C=======================================================================
C        ZEROING ARRAYS OF AVERAGE FIELDS
C=======================================================================
C
      IF (JETACM.EQ.2) THEN
C
          ALINPP(:,:,:,:,ICHARG)=C_ZERO
C
          IF (IPAIRI.EQ.1) THEN
              PLINPP(:,:,:,:,ICHARG)=C_ZERO
          END IF
C
          IF (ISIMPY.NE.1) THEN
C
              ALINPM(:,:,:,:,ICHARG)=C_ZERO
C
              IF (IPAIRI.EQ.1) THEN
                  PLINPM(:,:,:,:,ICHARG)=C_ZERO
              END IF
C
           END IF
C
      END IF
C
C=======================================================================
C
      FACTOR=1.0D0
C
C=======================================================================
C                             X-DIRECTION
C=======================================================================
C
      CALL INT_PX(NXMAXX,NYMAXX,NZMAXX,IPHAPP(0,0,0),HAUXIL,FACTOR)
C
C=======================================================================
C         TRACE OF THE LINEAR X-MOMENTUM TIMES THE DENSITY MATRIX
C=======================================================================
C
      IF (IROTAT.EQ.1.AND.((ISIMPY.EQ.1.AND.ISIGNY.NE.1).OR.
     *                     (ISIMPY.NE.1.AND.ISIQTY.NE.1))) THEN
C
          RESULT=C_ZERO
C
          DO IBRA=1,LDBASE
             DO IKET=1,LDBASE
C
                RESULT=RESULT + HAUXIL(IBRA,IKET)*(BIG_PP(IKET,IBRA,0)
     *                                            +BIG_PP(IKET,IBRA,1))
C
             END DO
          END DO
C
          RESULT=RESULT*CMPLX(0.0D0,1.0D0)
C
          ALINLI(1)=REAL(RESULT)
          AKINLI(1)=RESULT
C
      END IF
C
C=======================================================================
C         TRACE OF THE (LINEAR X-MOMENTUM TIMES THE DENSITY MATRIX)**2
C=======================================================================
C
      IF (COR_CM) THEN
C
C=======================================================================
C         TERMS DIAGONAL IN THE SIMPLEX QUANTUM NUMBER
C=======================================================================
C
          DO IREVER=0,MREVER
C
             DO IBRA=1,LDBASE
                DO IKET=1,LDBASE
C
                   AUXILI(IBRA,IKET,IREVER)=C_ZERO
C
                   DO IMID=1,LDBASE
C
                      AUXILI(IBRA,IKET,IREVER)=AUXILI(IBRA,IKET,IREVER)
     *                                        +HAUXIL(IBRA,IMID)
     *                                        *BIG_PP(IMID,IKET,IREVER)
C
                   END DO
C
                END DO
             END DO
C
          END DO
C
C=======================================================================
C
          RESULT=C_ZERO
C
          DO IREVER=0,MREVER
C
             DO IBRA=1,LDBASE
                DO IKET=1,LDBASE
C
                   RESULT=RESULT + AUXILI(IBRA,IKET,IREVER)
     *                            *AUXILI(IKET,IBRA,IREVER)
C
                   IF (JETACM.EQ.2) THEN
C
                       IF (MREVER.EQ.0) STOP ' WRONG MREVER IN LINAVR 1'
C
                       DO IMID=1,LDBASE
C
C=======================================================================
C         THE PLUS SIGN BELOW COMES FROM THE "-i" FACTOR IN THE LINEAR
C         MOMENTUM AND THE MINUS SIGN IN THE EXCHANGE TERM
C=======================================================================
C
                          ALINPP(IBRA,IKET,1,IREVER,ICHARG)
     *                   =ALINPP(IBRA,IKET,1,IREVER,ICHARG)
     *                   +2*AUXILI(IBRA,IMID,IREVER)*HAUXIL(IMID,IKET)
C
                       END DO
C
                   END IF
C
                END DO
             END DO
C
          END DO
C
C=======================================================================
C         FOR CONSERVED TIME-REVERSAL THE RESULT IS MULTIPLIED BY TWO
C=======================================================================
C
          IF (MREVER.EQ.0) RESULT=2*RESULT
C
C=======================================================================
C         MINUS SIGN COMES FROM THE "-i" FACTOR IN THE LINEAR MOMENTUM
C=======================================================================
C
          ELINSQ(1)=-REAL(RESULT)
          EKINSQ(1)=-RESULT
C
C=======================================================================
C         TERMS OFF-DIAGONAL IN THE SIMPLEX QUANTUM NUMBER
C=======================================================================
C
          IF (ISIMPY.NE.1) THEN
C
              DO IREVER=0,NDREVE
C
                 DO IBRA=1,LDBASE
                    DO IKET=1,LDBASE
C
                       AUXILI(IBRA,IKET,IREVER)=C_ZERO
C
                       DO IMID=1,LDBASE
C
                          AUXILI(IBRA,IKET,IREVER)=
     *                    AUXILI(IBRA,IKET,IREVER)+
     *                    HAUXIL(IBRA,IMID)*
     *                    BIG_PM(IMID,IKET,IREVER)
C
                       END DO
C
                    END DO
                 END DO
C
              END DO
C
C=======================================================================
C
              RESULT=C_ZERO
C
              DO IBRA=1,LDBASE
                 DO IKET=1,LDBASE
C
                    RESULT=RESULT + AUXILI(IBRA,IKET,0)
     *                            * AUXILI(IKET,IBRA,1)
C
                    IF (JETACM.EQ.2) THEN
C
                        DO IREVER=0,NDREVE
C
                           DO IMID=1,LDBASE
C
C=======================================================================
C         THE PLUS SIGN BELOW COMES FROM THE "-i" FACTOR IN THE LINEAR
C         MOMENTUM AND THE MINUS SIGN IN THE EXCHANGE TERM
C=======================================================================
C
                              ALINPM(IBRA,IKET,1,IREVER,ICHARG)
     *                       =ALINPM(IBRA,IKET,1,IREVER,ICHARG)
     *                     +2*AUXILI(IBRA,IMID,IREVER)*HAUXIL(IMID,IKET)
C
                           END DO
C
                        END DO
C
                    END IF
C
                 END DO
              END DO
C
              RESULT=2*RESULT
C
              ELINSQ(1)=ELINSQ(1)-REAL(RESULT)
              EKINSQ(1)=EKINSQ(1)-RESULT
C
          END IF
C
C=======================================================================
C         TRACE OF THE ( (LINEAR X-MOMENTUM TIMES KAPPA) TIMES
C         (LINEAR X-MOMENTUM TIMES KAPPA')* )
C=======================================================================
C
          IF (IPAIRI.EQ.1) THEN
C
             IF (ISIMPY.NE.1)
     *
     *           STOP ' NON-CONSERVED SIMPLEX NOT IMPLEMENTED IN LINAVR'
C
             DO IBRA=1,LDBASE
                DO IKET=1,LDBASE
C
                   AUXILI(IBRA,IKET,0)=C_ZERO
                   AUXILI(IBRA,IKET,1)=C_ZERO
                   BUXILI(IBRA,IKET,0)=C_ZERO
                   BUXILI(IBRA,IKET,1)=C_ZERO
C
                   DO IMID=1,LDBASE
C
                      AUXILI(IBRA,IKET,0)=AUXILI(IBRA,IKET,0)
     *                     +HAUXIL(IBRA,IMID)*PAI_PM(IMID,IKET,0)
C
                      AUXILI(IBRA,IKET,1)=AUXILI(IBRA,IKET,1)
     *                     -HAUXIL(IBRA,IMID)*PAI_PM(IKET,IMID,0)
C
                      BUXILI(IBRA,IKET,0)=BUXILI(IBRA,IKET,0)
     *                     -HAUXIL(IBRA,IMID)*PAI_PM(IKET,IMID,1)
C
                      BUXILI(IBRA,IKET,1)=BUXILI(IBRA,IKET,1)
     *                     +HAUXIL(IBRA,IMID)*PAI_PM(IMID,IKET,1)
C
                   END DO
C
                END DO
             END DO
C
             RESULT=C_ZERO
C
             DO IREVER=0,NDREVE
C
                DO IBRA=1,LDBASE
                   DO IKET=1,LDBASE
C
                      RESULT=RESULT+AUXILI(IBRA,IKET,IREVER)
     *                                *CONJG(BUXILI(IKET,IBRA,1-IREVER))
C
                      IF (JETACM.EQ.2) THEN
C
                          DO IMID=1,LDBASE
C
                             PLINPM(IBRA,IKET,1,IREVER,ICHARG)
     *                      =PLINPM(IBRA,IKET,1,IREVER,ICHARG)
     *                    -2*AUXILI(IBRA,IMID,IREVER)*HAUXIL(IKET,IMID)
C
                          END DO
C
                      END IF
C
                   END DO
                END DO
C
             END DO
C
             PLINSQ(1)=-REAL(RESULT)
             PKINSQ(1)=-RESULT
C
          END IF
C
C=======================================================================
C
          CALL INTPX2(NXMAXX,NYMAXX,NZMAXX,IPHAPP(0,0,0),HAUXIL,FACTOR)
C
C=======================================================================
C         TRACE OF THE LINEAR X-MOMENTUM SQUARD TIMES THE DENSITY MATRIX
C=======================================================================
C
          RESULT=C_ZERO
C
          DO IBRA=1,LDBASE
             DO IKET=1,LDBASE
C
                RESULT=RESULT + HAUXIL(IBRA,IKET)*(BIG_PP(IKET,IBRA,0)
     *                                            +BIG_PP(IKET,IBRA,1))
C
             END DO
          END DO
C
          DLINSQ(1)=REAL(RESULT)
          DKINSQ(1)=RESULT
C
      END IF
C
C=======================================================================
C                             Z-DIRECTION
C=======================================================================
C
      CALL INT_PZ(NXMAXX,NYMAXX,NZMAXX,IPHAPP(0,0,0),HAUXIL,FACTOR)
C
C=======================================================================
C         TRACE OF THE LINEAR Z-MOMENTUM TIMES THE DENSITY MATRIX
C=======================================================================
C
      IF (IROTAT.EQ.1.AND.((ISIMPY.EQ.1.AND.ISIGNY.NE.1).OR.
     *                     (ISIMPY.NE.1.AND.ISIQTY.NE.1))) THEN
C
          RESULT=C_ZERO
C
          DO IBRA=1,LDBASE
             DO IKET=1,LDBASE
C
                RESULT=RESULT + HAUXIL(IBRA,IKET)*(BIG_PP(IKET,IBRA,0)
     *                                            +BIG_PP(IKET,IBRA,1))
C
             END DO
          END DO
C
          RESULT=RESULT*CMPLX(0.0D0,1.0D0)
C
          ALINLI(3)=REAL(RESULT)
          AKINLI(3)=RESULT
C
      END IF
C
C=======================================================================
C         TRACE OF THE (LINEAR Z-MOMENTUM TIMES THE DENSITY MATRIX)**2
C=======================================================================
C
      IF (COR_CM) THEN
C
C=======================================================================
C         TERMS DIAGONAL IN THE SIMPLEX QUANTUM NUMBER
C=======================================================================
C
          DO IREVER=0,MREVER
C
             DO IBRA=1,LDBASE
                DO IKET=1,LDBASE
C
                   AUXILI(IBRA,IKET,IREVER)=C_ZERO
C
                   DO IMID=1,LDBASE
C
                      AUXILI(IBRA,IKET,IREVER)=AUXILI(IBRA,IKET,IREVER)
     *                                        +HAUXIL(IBRA,IMID)
     *                                        *BIG_PP(IMID,IKET,IREVER)
C
                   END DO
C
                END DO
             END DO
C
          END DO
C
C=======================================================================
C
          RESULT=C_ZERO
C
          DO IREVER=0,MREVER
C
             DO IBRA=1,LDBASE
                DO IKET=1,LDBASE
C
                   RESULT=RESULT + AUXILI(IBRA,IKET,IREVER)
     *                            *AUXILI(IKET,IBRA,IREVER)
C
                   IF (JETACM.EQ.2) THEN
C
                       IF (MREVER.EQ.0) STOP ' WRONG MREVER IN LINAVR 2'
C
                       DO IMID=1,LDBASE
C
C=======================================================================
C         THE PLUS SIGN BELOW COMES FROM THE "-i" FACTOR IN THE LINEAR
C         MOMENTUM AND THE MINUS SIGN IN THE EXCHANGE TERM
C=======================================================================
C
                          ALINPP(IBRA,IKET,3,IREVER,ICHARG)
     *                   =ALINPP(IBRA,IKET,3,IREVER,ICHARG)
     *                 +2*AUXILI(IBRA,IMID,IREVER)*HAUXIL(IMID,IKET)
C
                       END DO
C
                   END IF
C
                END DO
             END DO
C
          END DO
C
C=======================================================================
C         FOR CONSERVED TIME-REVERSAL THE RESULT IS MULTIPLIED BY TWO
C=======================================================================
C
          IF (MREVER.EQ.0) RESULT=2*RESULT
C
C=======================================================================
C         MINUS SIGN COMES FROM THE "-i" FACTOR IN THE LINEAR MOMENTUM
C=======================================================================
C
          ELINSQ(3)=-REAL(RESULT)
          EKINSQ(3)=-RESULT
C
C=======================================================================
C         TERMS OFF-DIAGONAL IN THE SIMPLEX QUANTUM NUMBER
C=======================================================================
C
          IF (ISIMPY.NE.1) THEN
C
              DO IREVER=0,NDREVE
C
                 DO IBRA=1,LDBASE
                    DO IKET=1,LDBASE
C
                       AUXILI(IBRA,IKET,IREVER)=C_ZERO
C
                       DO IMID=1,LDBASE
C
                          AUXILI(IBRA,IKET,IREVER)=
     *                    AUXILI(IBRA,IKET,IREVER)+
     *                    HAUXIL(IBRA,IMID)*
     *                    BIG_PM(IMID,IKET,IREVER)
C
                       END DO
C
                    END DO
                 END DO
C
              END DO
C
C=======================================================================
C
              RESULT=C_ZERO
C
              DO IBRA=1,LDBASE
                 DO IKET=1,LDBASE
C
                    RESULT=RESULT + AUXILI(IBRA,IKET,0)
     *                            * AUXILI(IKET,IBRA,1)
C
                    IF (JETACM.EQ.2) THEN
C
                        DO IREVER=0,NDREVE
C
                           DO IMID=1,LDBASE
C
C=======================================================================
C         THE PLUS SIGN BELOW COMES FROM THE "-i" FACTOR IN THE LINEAR
C         MOMENTUM AND THE MINUS SIGN IN THE EXCHANGE TERM
C=======================================================================
C
                              ALINPM(IBRA,IKET,3,IREVER,ICHARG)
     *                       =ALINPM(IBRA,IKET,3,IREVER,ICHARG)
     *                     +2*AUXILI(IBRA,IMID,IREVER)*HAUXIL(IMID,IKET)
C
                           END DO
C
                        END DO
C
                    END IF
C
                 END DO
              END DO
C
              RESULT=2*RESULT
C
              ELINSQ(3)=ELINSQ(3)-REAL(RESULT)
              EKINSQ(3)=EKINSQ(3)-RESULT
C
          END IF
C
C=======================================================================
C         TRACE OF THE ( (LINEAR Z-MOMENTUM TIMES KAPPA) TIMES
C         (LINEAR Z-MOMENTUM TIMES KAPPA')* )
C=======================================================================
C
          IF (IPAIRI.EQ.1) THEN
C
             IF (ISIMPY.NE.1)
     *
     *           STOP ' NON-CONSERVED SIMPLEX NOT IMPLEMENTED IN LINAVR'
C
             DO IBRA=1,LDBASE
                DO IKET=1,LDBASE
C
                   AUXILI(IBRA,IKET,0)=C_ZERO
                   AUXILI(IBRA,IKET,1)=C_ZERO
                   BUXILI(IBRA,IKET,0)=C_ZERO
                   BUXILI(IBRA,IKET,1)=C_ZERO
C
                   DO IMID=1,LDBASE
C
                      AUXILI(IBRA,IKET,0)=AUXILI(IBRA,IKET,0)
     *                     +HAUXIL(IBRA,IMID)*PAI_PM(IMID,IKET,0)
C
                      AUXILI(IBRA,IKET,1)=AUXILI(IBRA,IKET,1)
     *                     -HAUXIL(IBRA,IMID)*PAI_PM(IKET,IMID,0)
C
                      BUXILI(IBRA,IKET,0)=BUXILI(IBRA,IKET,0)
     *                     -HAUXIL(IBRA,IMID)*PAI_PM(IKET,IMID,1)
C
                      BUXILI(IBRA,IKET,1)=BUXILI(IBRA,IKET,1)
     *                     +HAUXIL(IBRA,IMID)*PAI_PM(IMID,IKET,1)
C
                   END DO
C
                END DO
             END DO
C
             RESULT=C_ZERO
C
             DO IREVER=0,NDREVE
C
                DO IBRA=1,LDBASE
                   DO IKET=1,LDBASE
C
                      RESULT=RESULT+AUXILI(IBRA,IKET,IREVER)
     *                                *CONJG(BUXILI(IKET,IBRA,1-IREVER))
C
                      IF (JETACM.EQ.2) THEN
C
                          DO IMID=1,LDBASE
C
                             PLINPM(IBRA,IKET,3,IREVER,ICHARG)
     *                      =PLINPM(IBRA,IKET,3,IREVER,ICHARG)
     *                    -2*AUXILI(IBRA,IMID,IREVER)*HAUXIL(IKET,IMID)
C
                          END DO
C
                      END IF
C
                   END DO
                END DO
C
             END DO
C
             PLINSQ(3)=-REAL(RESULT)
             PKINSQ(3)=-RESULT
C
          END IF
C
C=======================================================================
C
          CALL INTPZ2(NXMAXX,NYMAXX,NZMAXX,IPHAPP(0,0,0),HAUXIL,FACTOR)
C
C=======================================================================
C         TRACE OF THE LINEAR Z-MOMENTUM SQUERD TIMES THE DENSITY MATRIX
C=======================================================================
C
          RESULT=C_ZERO
C
          DO IBRA=1,LDBASE
             DO IKET=1,LDBASE
C
                RESULT=RESULT + HAUXIL(IBRA,IKET)*(BIG_PP(IKET,IBRA,0)
     *                                            +BIG_PP(IKET,IBRA,1))
C
             END DO
          END DO
C
          DLINSQ(3)=REAL(RESULT)
          DKINSQ(3)=RESULT
C
      END IF
C
C=======================================================================
C                             Y-DIRECTION
C=======================================================================
C
      CALL INT_PY(NXMAXX,NYMAXX,NZMAXX,IPHAPM(0,0,0),HAUXIL,FACTOR)
C
C=======================================================================
C         TRACE OF THE LINEAR Y-MOMENTUM TIMES THE DENSITY MATRIX
C=======================================================================
C
      IF (IROTAT.EQ.1.AND.ISIMPY.NE.1.AND.ISIQTY.NE.1) THEN
C
          RESULT=C_ZERO
C
          DO IBRA=1,LDBASE
             DO IKET=1,LDBASE
C
                RESULT=RESULT + HAUXIL(IBRA,IKET) * BIG_PM(IKET,IBRA,1)
     *                        - HAUXIL(IKET,IBRA) * BIG_PM(IKET,IBRA,0)
C
             END DO
          END DO
C
          RESULT=RESULT*CMPLX(0.0D0,1.0D0)
C
          ALINLI(2)=REAL(RESULT)
          AKINLI(2)=RESULT
C
      END IF
C
C=======================================================================
C         TRACE OF THE LINEAR Y-MOMENTUM TIMES THE PAIRING TENSOR
C=======================================================================
C
      IF (COR_CM) THEN
C
          IF (IPAIRI.EQ.1.AND.IROTAT.EQ.1.AND.
     *        ISIMPY.EQ.1.AND.ISIGNY.NE.1) THEN
C
              RESULT=C_ZERO
C
              DO IBRA=1,LDBASE
                 DO IKET=1,LDBASE
C
                    RESULT=RESULT-HAUXIL(IBRA,IKET)*PAI_PM(IBRA,IKET,0)
     *                           -HAUXIL(IBRA,IKET)*PAI_PM(IKET,IBRA,0)
C
                 END DO
              END DO
C
              RESULT=RESULT*CMPLX(0.0D0,1.0D0)
C
              PLINLI(2)=REAL(RESULT)
              PKINLI(2)=RESULT
C
              RESULT=C_ZERO
C
              DO IBRA=1,LDBASE
                 DO IKET=1,LDBASE
C
                    RESULT=RESULT+HAUXIL(IBRA,IKET)*PAI_PM(IKET,IBRA,1)
     *                           +HAUXIL(IBRA,IKET)*PAI_PM(IBRA,IKET,1)
C
                 END DO
              END DO
C
              RESULT=RESULT*CMPLX(0.0D0,1.0D0)
C
              PLINKI(2)=REAL(RESULT)
              PKINKI(2)=RESULT
C
          END IF
C
C=======================================================================
C         TRACE OF THE (LINEAR Y-MOMENTUM TIMES THE DENSITY MATRIX)**2
C=======================================================================
C
C=======================================================================
C         TERMS DIAGONAL IN THE SIMPLEX QUANTUM NUMBER
C=======================================================================
C
          DO IREVER=0,MREVER
C
             IF (IREVER.EQ.0) I_SIGN=-1
             IF (IREVER.EQ.1) I_SIGN=+1
C
             DO IBRA=1,LDBASE
                DO IKET=1,LDBASE
C
                   AUXILI(IBRA,IKET,IREVER)=C_ZERO
C
                   DO IMID=1,LDBASE
C
                      AUXILI(IBRA,IKET,IREVER)=AUXILI(IBRA,IKET,IREVER)
     *                                        +HAUXIL(IBRA,IMID)*I_SIGN
     *                                        *BIG_PP(IMID,IKET,IREVER)
C
                   END DO
C
                END DO
             END DO
C
          END DO
C
C=======================================================================
C         FOR CONSERVED TIME-REVERSAL THE TIME-DOWN BLOCK IS
C         COPIED FROM THE TIME-UP BLOCK
C=======================================================================
C
          IF (MREVER.EQ.0) THEN
              AUXILI(:,:,1)=-CONJG(AUXILI(:,:,0))
          END IF
C
C=======================================================================
C
          RESULT=C_ZERO
C
          DO IBRA=1,LDBASE
             DO IKET=1,LDBASE
C
                RESULT=RESULT + AUXILI(IBRA,IKET,1)
     *                        * AUXILI(IKET,IBRA,0)
C
                IF (JETACM.EQ.2) THEN
C
                    IF (MREVER.EQ.0) STOP ' WRONG MREVER IN LINAVR 3'
C
                    DO IREVER=0,NDREVE
C
                       IF (IREVER.EQ.0) I_SIGN=-1
                       IF (IREVER.EQ.1) I_SIGN=+1
C
                       DO IMID=1,LDBASE
C
C=======================================================================
C         THE PLUS SIGN BELOW COMES FROM THE "-i" FACTOR IN THE LINEAR
C         MOMENTUM AND THE MINUS SIGN IN THE EXCHANGE TERM
C=======================================================================
C
                          ALINPP(IBRA,IKET,2,IREVER,ICHARG)
     *                   =ALINPP(IBRA,IKET,2,IREVER,ICHARG)
     *                 +2*AUXILI(IBRA,IMID,1-IREVER)
     *                                         *I_SIGN*HAUXIL(IMID,IKET)
C
                       END DO
C
                    END DO
C
                END IF
C
             END DO
          END DO
C
C=======================================================================
C         MINUS SIGN COMES FROM THE "-i" FACTOR IN THE LINEAR MOMENTUM
C=======================================================================
C
          ELINSQ(2)=-2*REAL(RESULT)
          EKINSQ(2)=-2*RESULT
C
C=======================================================================
C         TERMS OFF-DIAGONAL IN THE SIMPLEX QUANTUM NUMBER
C=======================================================================
C
          IF (ISIMPY.NE.1) THEN
C
              DO IREVER=0,NDREVE
C
                 IF (IREVER.EQ.0) I_SIGN=-1
                 IF (IREVER.EQ.1) I_SIGN=+1
C
                 DO IBRA=1,LDBASE
                    DO IKET=1,LDBASE
C
                       AUXILI(IBRA,IKET,IREVER)=C_ZERO
C
                       DO IMID=1,LDBASE
C
                          AUXILI(IBRA,IKET,IREVER)=
     *                    AUXILI(IBRA,IKET,IREVER)+
     *                    HAUXIL(IBRA,IMID)*I_SIGN*
     *                    BIG_PM(IMID,IKET,IREVER)
C
                       END DO
C
                    END DO
                 END DO
C
              END DO
C
C=======================================================================
C
              RESULT=C_ZERO
C
              DO IREVER=0,NDREVE
C
                 IF (IREVER.EQ.0) I_SIGN=+1
                 IF (IREVER.EQ.1) I_SIGN=-1
C
                 DO IBRA=1,LDBASE
                    DO IKET=1,LDBASE
C
                       RESULT=RESULT + AUXILI(IBRA,IKET,IREVER)
     *                               * AUXILI(IKET,IBRA,IREVER)
C
                       IF (JETACM.EQ.2) THEN
C
                           DO IMID=1,LDBASE
C
C=======================================================================
C         THE PLUS SIGN BELOW COMES FROM THE "-i" FACTOR IN THE LINEAR
C         MOMENTUM AND THE MINUS SIGN IN THE EXCHANGE TERM
C=======================================================================
C         ATTENTION: UP TO VERSION 2.44C, THE BLOCKS OF THE ALINPM ARRAY
C                    BELOW FOR IREVER=0 AND 1 WERE  EXCHANGED  WITH  ONE
C                    ANOTHER. THIS BUG WAS FOUND BY PEKKA  TOIVANEN  AND
C                    CORRECTED IN VERSION 2.44D ON 17/11/09.
C=======================================================================
C
                              ALINPM(IBRA,IKET,2,IREVER,ICHARG)
     *                       =ALINPM(IBRA,IKET,2,IREVER,ICHARG)
     *                     +2*AUXILI(IBRA,IMID,1-IREVER)
     *                                         *I_SIGN*HAUXIL(IMID,IKET)
C
                           END DO
C
                       END IF
C
                    END DO
                 END DO
C
              END DO
C
              ELINSQ(2)=ELINSQ(2)-REAL(RESULT)
              EKINSQ(2)=EKINSQ(2)-RESULT
C
          END IF
C
C=======================================================================
C         TRACE OF THE ( (LINEAR Y-MOMENTUM TIMES KAPPA) TIMES
C         (LINEAR Y-MOMENTUM TIMES KAPPA')* )
C=======================================================================
C
          IF (IPAIRI.EQ.1) THEN
C
             IF (ISIMPY.NE.1)
     *
     *           STOP ' NON-CONSERVED SIMPLEX NOT IMPLEMENTED IN LINAVR'
C
             DO IBRA=1,LDBASE
                DO IKET=1,LDBASE
C
                   AUXILI(IBRA,IKET,0)=C_ZERO
                   AUXILI(IBRA,IKET,1)=C_ZERO
                   BUXILI(IBRA,IKET,0)=C_ZERO
                   BUXILI(IBRA,IKET,1)=C_ZERO
C
                   DO IMID=1,LDBASE
C
                      AUXILI(IBRA,IKET,0)=AUXILI(IBRA,IKET,0)
     *                     -HAUXIL(IBRA,IMID)*PAI_PM(IMID,IKET,0)
C
                      AUXILI(IBRA,IKET,1)=AUXILI(IBRA,IKET,1)
     *                     -HAUXIL(IBRA,IMID)*PAI_PM(IKET,IMID,0)
C
                      BUXILI(IBRA,IKET,0)=BUXILI(IBRA,IKET,0)
     *                     +HAUXIL(IBRA,IMID)*PAI_PM(IKET,IMID,1)
C
                      BUXILI(IBRA,IKET,1)=BUXILI(IBRA,IKET,1)
     *                     +HAUXIL(IBRA,IMID)*PAI_PM(IMID,IKET,1)
C
                   END DO
C
                END DO
             END DO
C
             RESULT=C_ZERO
C
             DO IREVER=0,NDREVE
C
                DO IBRA=1,LDBASE
                   DO IKET=1,LDBASE
C
                      RESULT=RESULT+AUXILI(IBRA,IKET,IREVER)
     *                       *CONJG(BUXILI(IKET,IBRA,IREVER))
C
                      IF (JETACM.EQ.2) THEN
C
                          IF (IREVER.EQ.0) I_SIGN=-1
                          IF (IREVER.EQ.1) I_SIGN=+1
C
                          DO IMID=1,LDBASE
C
                             PLINPM(IBRA,IKET,2,IREVER,ICHARG)
     *                      =PLINPM(IBRA,IKET,2,IREVER,ICHARG)
     *                    -2*AUXILI(IBRA,IMID,1-IREVER)
     *                      *HAUXIL(IKET,IMID)*I_SIGN
C
                          END DO
C
                      END IF
C
                   END DO
                END DO
C
             END DO
C
             PLINSQ(2)=-REAL(RESULT)
             PKINSQ(2)=-RESULT
C
          END IF
C
C=======================================================================
C
          CALL INTPY2(NXMAXX,NYMAXX,NZMAXX,IPHAPP(0,0,0),HAUXIL,FACTOR)
C
C=======================================================================
C         TRACE OF THE LINEAR Y-MOMENTUM SQUERD TIMES THE DENSITY MATRIX
C=======================================================================
C
          RESULT=C_ZERO
C
          DO IBRA=1,LDBASE
             DO IKET=1,LDBASE
C
                RESULT=RESULT + HAUXIL(IBRA,IKET)*(BIG_PP(IKET,IBRA,0)
     *                                            +BIG_PP(IKET,IBRA,1))
C
             END DO
          END DO
C
          DLINSQ(2)=REAL(RESULT)
          DKINSQ(2)=RESULT
C
      END IF
C
C=======================================================================
C         HERE ALL TERMS ARE COMBINED INTO THE AVERAGE OF  THE  SQUARE
C         OF THE TOTAL LINEAR MOMENTUM. AVERAGE OF THE SINGLE-PARTICLE
C         SQUARE OF THE LINEAR MOMENTUM HAS BEEN PREVOIUSLY CALCULATED
C         BY "EKINET" IN "DLINSQ(0)" AND "DKINSQ(0)", BUT HERE  IT  IS
C         RECALCULATED ONCE AGAIN.
C=======================================================================
C         ATTENTION: BETWEEN  VERSIONS  2.39Q  AND  2.44G,  VALUES  OF
C                    ALINLI(0) AND AKINLI(0) WERE SET ONLY WITHIN  THE
C                    COR_CM SWITCH, AND THUS WERE NOT SET  UNLESS  THE
C                    EXACT CENTER OF MASS WAS CALCULATED. THIS BUG HAS
C                    BEEN CORRECTED IN VERSION 2.44H ON 24/11/2009.
C=======================================================================
C
      DO KARTEZ=1,NDKART
C
         TLINSQ(KARTEZ)=DLINSQ(KARTEZ)-ELINSQ(KARTEZ)
     *                 +PLINSQ(KARTEZ)+ALINLI(KARTEZ)**2
         TKINSQ(KARTEZ)=DKINSQ(KARTEZ)-EKINSQ(KARTEZ)
     *                 +PKINSQ(KARTEZ)+AKINLI(KARTEZ)**2
C
      END DO
C
      DO KARTEZ=1,NDKART
C
         DLINSQ(0)=DLINSQ(0)+DLINSQ(KARTEZ)
         ELINSQ(0)=ELINSQ(0)+ELINSQ(KARTEZ)
         PLINSQ(0)=PLINSQ(0)+PLINSQ(KARTEZ)
         TLINSQ(0)=TLINSQ(0)+TLINSQ(KARTEZ)
         ALINLI(0)=ALINLI(0)+ALINLI(KARTEZ)**2
         PLINLI(0)=PLINLI(0)+PLINLI(KARTEZ)**2
         PLINKI(0)=PLINKI(0)+PLINKI(KARTEZ)**2
C
         DKINSQ(0)=DKINSQ(0)+DKINSQ(KARTEZ)
         EKINSQ(0)=EKINSQ(0)+EKINSQ(KARTEZ)
         PKINSQ(0)=PKINSQ(0)+PKINSQ(KARTEZ)
         TKINSQ(0)=TKINSQ(0)+TKINSQ(KARTEZ)
         AKINLI(0)=AKINLI(0)+AKINLI(KARTEZ)**2
         PKINLI(0)=PKINLI(0)+PKINLI(KARTEZ)**2
         PKINKI(0)=PKINKI(0)+PKINKI(KARTEZ)**2
C
      END DO
C
C=======================================================================
      DEALLOCATE (AUXILI)
      IF (IPAIRI.EQ.1) DEALLOCATE (BUXILI)
      DEALLOCATE (HAUXIL)
C=======================================================================
C
      CALL CPUTIM('LINAVR',0)
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE ROTAVR(NXMAXX,NYMAXX,NZMAXX,ISIMPY,ISIGNY,ISIQTY,
     *                 IPAIRI,ICHARG,KETA_R,IROTAT,MREVER,CORROT,
     *                 DROTSQ,EROTSQ,PROTSQ,TROTSQ,AROTLI,PROTLI,PROTKI,
     *                 DKOTSQ,EKOTSQ,PKOTSQ,TKOTSQ,AKOTLI,PKOTLI,PKOTKI)
C=======================================================================
      USE MAT_PP
      USE MAT_PM
      USE KAP_PP
      USE KAP_PM
      USE AROSTO
      USE PROSTO
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      COMPLEX
     *          RESULT,AUXILI,BUXILI,C_ZERO
      COMPLEX
     *          DKOTSQ,
     *          EKOTSQ,
     *          PKOTSQ,
     *          TKOTSQ,
     *          AKOTLI,
     *          PKOTLI,
     *          PKOTKI
      LOGICAL
     *          CORROT
C
      DIMENSION
     *          DROTSQ(0:NDKART),
     *          EROTSQ(0:NDKART),
     *          PROTSQ(0:NDKART),
     *          TROTSQ(0:NDKART),
     *          AROTLI(0:NDKART),
     *          PROTLI(0:NDKART),
     *          PROTKI(0:NDKART)
      DIMENSION
     *          DKOTSQ(0:NDKART),
     *          EKOTSQ(0:NDKART),
     *          PKOTSQ(0:NDKART),
     *          TKOTSQ(0:NDKART),
     *          AKOTLI(0:NDKART),
     *          PKOTLI(0:NDKART),
     *          PKOTKI(0:NDKART)
C=======================================================================
      ALLOCATABLE AUXILI(:,:,:)
      ALLOCATABLE BUXILI(:,:,:)
      ALLOCATABLE HAUXIL(:,:)
C=======================================================================
      COMMON
     *       /T_PHAS/ IPHAPP(0:NDYMAX,0:NDYMAX,0:NDKART),
     *                IPHAPM(0:NDYMAX,0:NDYMAX,0:NDKART),
     *                IPHAMP(0:NDYMAX,0:NDYMAX,0:NDKART),
     *                IPHAMM(0:NDYMAX,0:NDYMAX,0:NDKART)
      COMMON
     *       /DIMENS/ LDBASE
C
C=======================================================================
C
      CALL CPUTIM('ROTAVR',1)
C
C=======================================================================
C
      IALLOC=0
C
C=======================================================================
      IF (.NOT.ALLOCATED(AROTPP).AND.KETA_R.EQ.2) THEN
          ALLOCATE (AROTPP(NDBASE,NDBASE,1:NDKART,0:NDREVE,0:NDISOS),
     *                                                      STAT=IALLOC)
          IF (IALLOC.NE.0) CALL NOALLO('AROTPP','ROTAVR')
      END IF
C=======================================================================
      IF (.NOT.ALLOCATED(AROTPM).AND.KETA_R.EQ.2.AND.ISIMPY.NE.1) THEN
          ALLOCATE (AROTPM(NDBASE,NDBASE,1:NDKART,0:NDREVE,0:NDISOS),
     *                                                      STAT=IALLOC)
          IF (IALLOC.NE.0) CALL NOALLO('AROTPM','ROTAVR')
      END IF
C=======================================================================
      IF (.NOT.ALLOCATED(PROTPM).AND.KETA_R.EQ.2.AND.IPAIRI.EQ.1) THEN
          ALLOCATE (PROTPM(NDBASE,NDBASE,1:NDKART,0:NDREVE,0:NDISOS),
     *                                                      STAT=IALLOC)
          IF (IALLOC.NE.0) CALL NOALLO('PROTPM','ROTAVR')
      END IF
C=======================================================================
      IF (.NOT.ALLOCATED(PROTPP).AND.KETA_R.EQ.2.AND.IPAIRI.EQ.1.AND.
     *                                               ISIMPY.NE.1) THEN
          ALLOCATE (PROTPP(NDBASE,NDBASE,1:NDKART,0:NDREVE,0:NDISOS),
     *                                                      STAT=IALLOC)
          IF (IALLOC.NE.0) CALL NOALLO('PROTPP','ROTAVR')
      END IF
C=======================================================================
      ALLOCATE (AUXILI(1:NDBASE,1:NDBASE,0:NDREVE),STAT=IALLOC)
      IF (IALLOC.NE.0) CALL NOALLO('AUXILI','ROTAVR')
      IF (IPAIRI.EQ.1) THEN
         ALLOCATE (BUXILI(1:NDBASE,1:NDBASE,0:NDREVE),STAT=IALLOC)
         IF (IALLOC.NE.0) CALL NOALLO('BUXILI','ROTAVR')
      END IF
      ALLOCATE (HAUXIL(1:NDBASE,1:NDBASE),STAT=IALLOC)
      IF (IALLOC.NE.0) CALL NOALLO('HAUXIL','ROTAVR')
C=======================================================================
C
C=======================================================================
C       THIS SUBROUTINE CALCULATES THE AVERAGE AND/OR  TRANSITION  TOTAL
C       ANGULAR MOMENTA AND THE AVERAGE AND/OR TRANSITION SQUARE OF  THE
C       ANGULAR MOMENTUM. THE VARIABLE NAME CONVENTIONS ARE THE SAME  AS
C       FOR THE LINEAR MOMENTA CALCULATED IN LINAVR, WITH "LIN" REPLACED
C       BY "ROT".
C=======================================================================
C       THIS SUBROUTINE ALSO CALCULATES THE EXCHANGE MEAN FIELDS RELATED
C       TO THE TWO-BODY ROT CORRECTION. THE CONVENTION OF STORING  THESE
C       MATRIX ELEMENTS IN ARRAYS AROTPP AND AROTPM IS THE SAME AS  THAT
C       FOR THE DENSITY MATRIX; HENCE IT IS    D I F F E R E N T    THAN
C       THAT USED TO STORE THE MATRIX ELEMENTS  OF  COULOMB  AND  YUKAWA
C       MEAN FIELDS.
C=======================================================================
C
      C_ZERO=CMPLX(0.0D0,0.0D0)
C
C=======================================================================
C        ZEROING ARRAYS OF AVERAGE VALUES
C=======================================================================
C
      DROTSQ(:)=0.0D0
      EROTSQ(:)=0.0D0
      PROTSQ(:)=0.0D0
      TROTSQ(:)=0.0D0
      AROTLI(:)=0.0D0
      PROTLI(:)=0.0D0
      PROTKI(:)=0.0D0
C
      DKOTSQ(:)=C_ZERO
      EKOTSQ(:)=C_ZERO
      PKOTSQ(:)=C_ZERO
      TKOTSQ(:)=C_ZERO
      AKOTLI(:)=C_ZERO
      PKOTLI(:)=C_ZERO
      PKOTKI(:)=C_ZERO
C
C=======================================================================
C        ZEROING ARRAYS OF AVERAGE FIELDS
C=======================================================================
C
      IF (KETA_R.EQ.2) THEN
C
         AROTPP(:,:,:,:,ICHARG)=C_ZERO
C
          IF (ISIMPY.NE.1) THEN
              AROTPM(:,:,:,:,ICHARG)=C_ZERO
          END IF
C
          IF (IPAIRI.EQ.1) THEN
C
              PROTPM(:,:,:,:,ICHARG)=C_ZERO
C
              IF (ISIMPY.NE.1) THEN
                  PROTPP(:,:,:,:,ICHARG)=C_ZERO
              END IF
C
          END IF
C
      END IF
C
C=======================================================================
C
      FACTOR=1.0D0
C
C
C    !!!!! BELOW ROTAVR NOT PROGRAMMED YET - JUST A COPY OF LINAVR !!!!!
C
C
C=======================================================================
C                             X-DIRECTION
C=======================================================================
C
      CALL INT_PX(NXMAXX,NYMAXX,NZMAXX,IPHAPP(0,0,0),HAUXIL,FACTOR)
C
C=======================================================================
C         TRACE OF THE ANGULAR X-MOMENTUM TIMES THE DENSITY MATRIX
C=======================================================================
C
      IF (IROTAT.EQ.1.AND.((ISIMPY.EQ.1.AND.ISIGNY.NE.1).OR.
     *                     (ISIMPY.NE.1.AND.ISIQTY.NE.1))) THEN
C
          RESULT=C_ZERO
C
          DO IBRA=1,LDBASE
             DO IKET=1,LDBASE
C
                RESULT=RESULT + HAUXIL(IBRA,IKET)*(BIG_PP(IKET,IBRA,0)
     *                                            +BIG_PP(IKET,IBRA,1))
C
             END DO
          END DO
C
          RESULT=RESULT*CMPLX(0.0D0,1.0D0)
C
          AROTLI(1)=REAL(RESULT)
          AKOTLI(1)=RESULT
C
      END IF
C
C=======================================================================
C         TRACE OF THE (ANGULAR X-MOMENTUM TIMES THE DENSITY MATRIX)**2
C=======================================================================
C
      IF (CORROT) THEN
C
C=======================================================================
C         TERMS DIAGONAL IN THE SIMPLEX QUANTUM NUMBER
C=======================================================================
C
          DO IREVER=0,MREVER
C
             DO IBRA=1,LDBASE
                DO IKET=1,LDBASE
C
                   AUXILI(IBRA,IKET,IREVER)=C_ZERO
C
                   DO IMID=1,LDBASE
C
                      AUXILI(IBRA,IKET,IREVER)=AUXILI(IBRA,IKET,IREVER)
     *                                        +HAUXIL(IBRA,IMID)
     *                                        *BIG_PP(IMID,IKET,IREVER)
C
                   END DO
C
                END DO
             END DO
C
          END DO
C
C=======================================================================
C
          RESULT=C_ZERO
C
          DO IREVER=0,MREVER
C
             DO IBRA=1,LDBASE
                DO IKET=1,LDBASE
C
                   RESULT=RESULT + AUXILI(IBRA,IKET,IREVER)
     *                            *AUXILI(IKET,IBRA,IREVER)
C
                   IF (KETA_R.EQ.2) THEN
C
                       IF (MREVER.EQ.0) STOP ' WRONG MREVER IN ROTAVR 1'
C
                       DO IMID=1,LDBASE
C
C=======================================================================
C         THE PLUS SIGN BELOW COMES FROM THE "-i" FACTOR IN THE ANGULAR
C         MOMENTUM AND THE MINUS SIGN IN THE EXCHANGE TERM
C=======================================================================
C
                          AROTPP(IBRA,IKET,1,IREVER,ICHARG)
     *                   =AROTPP(IBRA,IKET,1,IREVER,ICHARG)
     *                   +2*AUXILI(IBRA,IMID,IREVER)*HAUXIL(IMID,IKET)
C
                       END DO
C
                   END IF
C
                END DO
             END DO
C
          END DO
C
C=======================================================================
C         FOR CONSERVED TIME-REVERSAL THE RESULT IS MULTIPLIED BY TWO
C=======================================================================
C
          IF (MREVER.EQ.0) RESULT=2*RESULT
C
C=======================================================================
C         MINUS SIGN COMES FROM THE "-i" FACTOR IN THE ANGULAR MOMENTUM
C=======================================================================
C
          EROTSQ(1)=-REAL(RESULT)
          EKOTSQ(1)=-RESULT
C
C=======================================================================
C         TERMS OFF-DIAGONAL IN THE SIMPLEX QUANTUM NUMBER
C=======================================================================
C
          IF (ISIMPY.NE.1) THEN
C
              DO IREVER=0,NDREVE
C
                 DO IBRA=1,LDBASE
                    DO IKET=1,LDBASE
C
                       AUXILI(IBRA,IKET,IREVER)=C_ZERO
C
                       DO IMID=1,LDBASE
C
                          AUXILI(IBRA,IKET,IREVER)=
     *                    AUXILI(IBRA,IKET,IREVER)+
     *                    HAUXIL(IBRA,IMID)*
     *                    BIG_PM(IMID,IKET,IREVER)
C
                       END DO
C
                    END DO
                 END DO
C
              END DO
C
C=======================================================================
C
              RESULT=C_ZERO
C
              DO IBRA=1,LDBASE
                 DO IKET=1,LDBASE
C
                    RESULT=RESULT + AUXILI(IBRA,IKET,0)
     *                            * AUXILI(IKET,IBRA,1)
C
                    IF (KETA_R.EQ.2) THEN
C
                        DO IREVER=0,NDREVE
C
                           DO IMID=1,LDBASE
C
C=======================================================================
C         THE PLUS SIGN BELOW COMES FROM THE "-i" FACTOR IN THE ANGULAR
C         MOMENTUM AND THE MINUS SIGN IN THE EXCHANGE TERM
C=======================================================================
C
                              AROTPM(IBRA,IKET,1,IREVER,ICHARG)
     *                       =AROTPM(IBRA,IKET,1,IREVER,ICHARG)
     *                     +2*AUXILI(IBRA,IMID,IREVER)*HAUXIL(IMID,IKET)
C
                           END DO
C
                        END DO
C
                    END IF
C
                 END DO
              END DO
C
              RESULT=2*RESULT
C
              EROTSQ(1)=EROTSQ(1)-REAL(RESULT)
              EKOTSQ(1)=EKOTSQ(1)-RESULT
C
          END IF
C
C=======================================================================
C         TRACE OF THE ( (ANGULAR X-MOMENTUM TIMES KAPPA) TIMES
C         (ANGULAR X-MOMENTUM TIMES KAPPA')* )
C=======================================================================
C
          IF (IPAIRI.EQ.1) THEN
C
             IF (ISIMPY.NE.1)
     *
     *           STOP ' NON-CONSERVED SIMPLEX NOT IMPLEMENTED IN ROTAVR'
C
             DO IBRA=1,LDBASE
                DO IKET=1,LDBASE
C
                   AUXILI(IBRA,IKET,0)=C_ZERO
                   AUXILI(IBRA,IKET,1)=C_ZERO
                   BUXILI(IBRA,IKET,0)=C_ZERO
                   BUXILI(IBRA,IKET,1)=C_ZERO
C
                   DO IMID=1,LDBASE
C
                      AUXILI(IBRA,IKET,0)=AUXILI(IBRA,IKET,0)
     *                     +HAUXIL(IBRA,IMID)*PAI_PM(IMID,IKET,0)
C
                      AUXILI(IBRA,IKET,1)=AUXILI(IBRA,IKET,1)
     *                     -HAUXIL(IBRA,IMID)*PAI_PM(IKET,IMID,0)
C
                      BUXILI(IBRA,IKET,0)=BUXILI(IBRA,IKET,0)
     *                     -HAUXIL(IBRA,IMID)*PAI_PM(IKET,IMID,1)
C
                      BUXILI(IBRA,IKET,1)=BUXILI(IBRA,IKET,1)
     *                     +HAUXIL(IBRA,IMID)*PAI_PM(IMID,IKET,1)
C
                   END DO
C
                END DO
             END DO
C
             RESULT=C_ZERO
C
             DO IREVER=0,NDREVE
C
                DO IBRA=1,LDBASE
                   DO IKET=1,LDBASE
C
                      RESULT=RESULT+AUXILI(IBRA,IKET,IREVER)
     *                                *CONJG(BUXILI(IKET,IBRA,1-IREVER))
C
                      IF (KETA_R.EQ.2) THEN
C
                          DO IMID=1,LDBASE
C
                             PROTPM(IBRA,IKET,1,IREVER,ICHARG)
     *                      =PROTPM(IBRA,IKET,1,IREVER,ICHARG)
     *                    -2*AUXILI(IBRA,IMID,IREVER)*HAUXIL(IKET,IMID)
C
                          END DO
C
                      END IF
C
                   END DO
                END DO
C
             END DO
C
             PROTSQ(1)=-REAL(RESULT)
             PKOTSQ(1)=-RESULT
C
          END IF
C
C=======================================================================
C
          CALL INTPX2(NXMAXX,NYMAXX,NZMAXX,IPHAPP(0,0,0),HAUXIL,FACTOR)
C
C=======================================================================
C         TRACE OF ANGULAR X-MOMENTUM SQUARD TIMES THE DENSITY MATRIX
C=======================================================================
C
          RESULT=C_ZERO
C
          DO IBRA=1,LDBASE
             DO IKET=1,LDBASE
C
                RESULT=RESULT + HAUXIL(IBRA,IKET)*(BIG_PP(IKET,IBRA,0)
     *                                            +BIG_PP(IKET,IBRA,1))
C
             END DO
          END DO
C
          DROTSQ(1)=REAL(RESULT)
          DKOTSQ(1)=RESULT
C
      END IF
C
C=======================================================================
C                             Z-DIRECTION
C=======================================================================
C
      CALL INT_PZ(NXMAXX,NYMAXX,NZMAXX,IPHAPP(0,0,0),HAUXIL,FACTOR)
C
C=======================================================================
C         TRACE OF THE ANGULAR Z-MOMENTUM TIMES THE DENSITY MATRIX
C=======================================================================
C
      IF (IROTAT.EQ.1.AND.((ISIMPY.EQ.1.AND.ISIGNY.NE.1).OR.
     *                     (ISIMPY.NE.1.AND.ISIQTY.NE.1))) THEN
C
          RESULT=C_ZERO
C
          DO IBRA=1,LDBASE
             DO IKET=1,LDBASE
C
                RESULT=RESULT + HAUXIL(IBRA,IKET)*(BIG_PP(IKET,IBRA,0)
     *                                            +BIG_PP(IKET,IBRA,1))
C
             END DO
          END DO
C
          RESULT=RESULT*CMPLX(0.0D0,1.0D0)
C
          AROTLI(3)=REAL(RESULT)
          AKOTLI(3)=RESULT
C
      END IF
C
C=======================================================================
C         TRACE OF THE (ANGULAR Z-MOMENTUM TIMES THE DENSITY MATRIX)**2
C=======================================================================
C
      IF (CORROT) THEN
C
C=======================================================================
C         TERMS DIAGONAL IN THE SIMPLEX QUANTUM NUMBER
C=======================================================================
C
          DO IREVER=0,MREVER
C
             DO IBRA=1,LDBASE
                DO IKET=1,LDBASE
C
                   AUXILI(IBRA,IKET,IREVER)=C_ZERO
C
                   DO IMID=1,LDBASE
C
                      AUXILI(IBRA,IKET,IREVER)=AUXILI(IBRA,IKET,IREVER)
     *                                        +HAUXIL(IBRA,IMID)
     *                                        *BIG_PP(IMID,IKET,IREVER)
C
                   END DO
C
                END DO
             END DO
C
          END DO
C
C=======================================================================
C
          RESULT=C_ZERO
C
          DO IREVER=0,MREVER
C
             DO IBRA=1,LDBASE
                DO IKET=1,LDBASE
C
                   RESULT=RESULT + AUXILI(IBRA,IKET,IREVER)
     *                            *AUXILI(IKET,IBRA,IREVER)
C
                   IF (KETA_R.EQ.2) THEN
C
                       IF (MREVER.EQ.0) STOP ' WRONG MREVER IN ROTAVR 2'
C
                       DO IMID=1,LDBASE
C
C=======================================================================
C         THE PLUS SIGN BELOW COMES FROM THE "-i" FACTOR IN THE ANGULAR
C         MOMENTUM AND THE MINUS SIGN IN THE EXCHANGE TERM
C=======================================================================
C
                          AROTPP(IBRA,IKET,3,IREVER,ICHARG)
     *                   =AROTPP(IBRA,IKET,3,IREVER,ICHARG)
     *                 +2*AUXILI(IBRA,IMID,IREVER)*HAUXIL(IMID,IKET)
C
                       END DO
C
                   END IF
C
                END DO
             END DO
C
          END DO
C
C=======================================================================
C         FOR CONSERVED TIME-REVERSAL THE RESULT IS MULTIPLIED BY TWO
C=======================================================================
C
          IF (MREVER.EQ.0) RESULT=2*RESULT
C
C=======================================================================
C         MINUS SIGN COMES FROM THE "-i" FACTOR IN THE ANGULAR MOMENTUM
C=======================================================================
C
          EROTSQ(3)=-REAL(RESULT)
          EKOTSQ(3)=-RESULT
C
C=======================================================================
C         TERMS OFF-DIAGONAL IN THE SIMPLEX QUANTUM NUMBER
C=======================================================================
C
          IF (ISIMPY.NE.1) THEN
C
              DO IREVER=0,NDREVE
C
                 DO IBRA=1,LDBASE
                    DO IKET=1,LDBASE
C
                       AUXILI(IBRA,IKET,IREVER)=C_ZERO
C
                       DO IMID=1,LDBASE
C
                          AUXILI(IBRA,IKET,IREVER)=
     *                    AUXILI(IBRA,IKET,IREVER)+
     *                    HAUXIL(IBRA,IMID)*
     *                    BIG_PM(IMID,IKET,IREVER)
C
                       END DO
C
                    END DO
                 END DO
C
              END DO
C
C=======================================================================
C
              RESULT=C_ZERO
C
              DO IBRA=1,LDBASE
                 DO IKET=1,LDBASE
C
                    RESULT=RESULT + AUXILI(IBRA,IKET,0)
     *                            * AUXILI(IKET,IBRA,1)
C
                    IF (KETA_R.EQ.2) THEN
C
                        DO IREVER=0,NDREVE
C
                           DO IMID=1,LDBASE
C
C=======================================================================
C         THE PLUS SIGN BELOW COMES FROM THE "-i" FACTOR IN THE ANGULAR
C         MOMENTUM AND THE MINUS SIGN IN THE EXCHANGE TERM
C=======================================================================
C
                              AROTPM(IBRA,IKET,3,IREVER,ICHARG)
     *                       =AROTPM(IBRA,IKET,3,IREVER,ICHARG)
     *                     +2*AUXILI(IBRA,IMID,IREVER)*HAUXIL(IMID,IKET)
C
                           END DO
C
                        END DO
C
                    END IF
C
                 END DO
              END DO
C
              RESULT=2*RESULT
C
              EROTSQ(3)=EROTSQ(3)-REAL(RESULT)
              EKOTSQ(3)=EKOTSQ(3)-RESULT
C
          END IF
C
C=======================================================================
C         TRACE OF THE ( (ANGULAR Z-MOMENTUM TIMES KAPPA) TIMES
C         (ANGULAR Z-MOMENTUM TIMES KAPPA')* )
C=======================================================================
C
          IF (IPAIRI.EQ.1) THEN
C
             IF (ISIMPY.NE.1)
     *
     *           STOP ' NON-CONSERVED SIMPLEX NOT IMPLEMENTED IN ROTAVR'
C
             DO IBRA=1,LDBASE
                DO IKET=1,LDBASE
C
                   AUXILI(IBRA,IKET,0)=C_ZERO
                   AUXILI(IBRA,IKET,1)=C_ZERO
                   BUXILI(IBRA,IKET,0)=C_ZERO
                   BUXILI(IBRA,IKET,1)=C_ZERO
C
                   DO IMID=1,LDBASE
C
                      AUXILI(IBRA,IKET,0)=AUXILI(IBRA,IKET,0)
     *                     +HAUXIL(IBRA,IMID)*PAI_PM(IMID,IKET,0)
C
                      AUXILI(IBRA,IKET,1)=AUXILI(IBRA,IKET,1)
     *                     -HAUXIL(IBRA,IMID)*PAI_PM(IKET,IMID,0)
C
                      BUXILI(IBRA,IKET,0)=BUXILI(IBRA,IKET,0)
     *                     -HAUXIL(IBRA,IMID)*PAI_PM(IKET,IMID,1)
C
                      BUXILI(IBRA,IKET,1)=BUXILI(IBRA,IKET,1)
     *                     +HAUXIL(IBRA,IMID)*PAI_PM(IMID,IKET,1)
C
                   END DO
C
                END DO
             END DO
C
             RESULT=C_ZERO
C
             DO IREVER=0,NDREVE
C
                DO IBRA=1,LDBASE
                   DO IKET=1,LDBASE
C
                      RESULT=RESULT+AUXILI(IBRA,IKET,IREVER)
     *                                *CONJG(BUXILI(IKET,IBRA,1-IREVER))
C
                      IF (KETA_R.EQ.2) THEN
C
                          DO IMID=1,LDBASE
C
                             PROTPM(IBRA,IKET,3,IREVER,ICHARG)
     *                      =PROTPM(IBRA,IKET,3,IREVER,ICHARG)
     *                    -2*AUXILI(IBRA,IMID,IREVER)*HAUXIL(IKET,IMID)
C
                          END DO
C
                      END IF
C
                   END DO
                END DO
C
             END DO
C
             PROTSQ(3)=-REAL(RESULT)
             PKOTSQ(3)=-RESULT
C
          END IF
C
C=======================================================================
C
          CALL INTPZ2(NXMAXX,NYMAXX,NZMAXX,IPHAPP(0,0,0),HAUXIL,FACTOR)
C
C=======================================================================
C         TRACE OF ANGULAR Z-MOMENTUM SQUERD TIMES THE DENSITY MATRIX
C=======================================================================
C
          RESULT=C_ZERO
C
          DO IBRA=1,LDBASE
             DO IKET=1,LDBASE
C
                RESULT=RESULT + HAUXIL(IBRA,IKET)*(BIG_PP(IKET,IBRA,0)
     *                                            +BIG_PP(IKET,IBRA,1))
C
             END DO
          END DO
C
          DROTSQ(3)=REAL(RESULT)
          DKOTSQ(3)=RESULT
C
      END IF
C
C=======================================================================
C                             Y-DIRECTION
C=======================================================================
C
      CALL INT_PY(NXMAXX,NYMAXX,NZMAXX,IPHAPM(0,0,0),HAUXIL,FACTOR)
C
C=======================================================================
C         TRACE OF THE ANGULAR Y-MOMENTUM TIMES THE DENSITY MATRIX
C=======================================================================
C
      IF (IROTAT.EQ.1.AND.ISIMPY.NE.1.AND.ISIQTY.NE.1) THEN
C
          RESULT=C_ZERO
C
          DO IBRA=1,LDBASE
             DO IKET=1,LDBASE
C
                RESULT=RESULT + HAUXIL(IBRA,IKET) * BIG_PM(IKET,IBRA,1)
     *                        - HAUXIL(IKET,IBRA) * BIG_PM(IKET,IBRA,0)
C
             END DO
          END DO
C
          RESULT=RESULT*CMPLX(0.0D0,1.0D0)
C
          AROTLI(2)=REAL(RESULT)
          AKOTLI(2)=RESULT
C
      END IF
C
C=======================================================================
C         TRACE OF THE ANGULAR Y-MOMENTUM TIMES THE PAIRING TENSOR
C=======================================================================
C
      IF (CORROT) THEN
C
          IF (IPAIRI.EQ.1.AND.IROTAT.EQ.1.AND.
     *        ISIMPY.EQ.1.AND.ISIGNY.NE.1) THEN
C
              RESULT=C_ZERO
C
              DO IBRA=1,LDBASE
                 DO IKET=1,LDBASE
C
                    RESULT=RESULT-HAUXIL(IBRA,IKET)*PAI_PM(IBRA,IKET,0)
     *                           -HAUXIL(IBRA,IKET)*PAI_PM(IKET,IBRA,0)
C
                 END DO
              END DO
C
              RESULT=RESULT*CMPLX(0.0D0,1.0D0)
C
              PROTLI(2)=REAL(RESULT)
              PKOTLI(2)=RESULT
C
              RESULT=C_ZERO
C
              DO IBRA=1,LDBASE
                 DO IKET=1,LDBASE
C
                    RESULT=RESULT+HAUXIL(IBRA,IKET)*PAI_PM(IKET,IBRA,1)
     *                           +HAUXIL(IBRA,IKET)*PAI_PM(IBRA,IKET,1)
C
                 END DO
              END DO
C
              RESULT=RESULT*CMPLX(0.0D0,1.0D0)
C
              PROTKI(2)=REAL(RESULT)
              PKOTKI(2)=RESULT
C
          END IF
C
C=======================================================================
C         TRACE OF THE (ANGULAR Y-MOMENTUM TIMES THE DENSITY MATRIX)**2
C=======================================================================
C
C=======================================================================
C         TERMS DIAGONAL IN THE SIMPLEX QUANTUM NUMBER
C=======================================================================
C
          DO IREVER=0,MREVER
C
             IF (IREVER.EQ.0) I_SIGN=-1
             IF (IREVER.EQ.1) I_SIGN=+1
C
             DO IBRA=1,LDBASE
                DO IKET=1,LDBASE
C
                   AUXILI(IBRA,IKET,IREVER)=C_ZERO
C
                   DO IMID=1,LDBASE
C
                      AUXILI(IBRA,IKET,IREVER)=AUXILI(IBRA,IKET,IREVER)
     *                                        +HAUXIL(IBRA,IMID)*I_SIGN
     *                                        *BIG_PP(IMID,IKET,IREVER)
C
                   END DO
C
                END DO
             END DO
C
          END DO
C
C=======================================================================
C         FOR CONSERVED TIME-REVERSAL THE TIME-DOWN BLOCK IS
C         COPIED FROM THE TIME-UP BLOCK
C=======================================================================
C
          IF (MREVER.EQ.0) THEN
              AUXILI(:,:,1)=-CONJG(AUXILI(:,:,0))
          END IF
C
C=======================================================================
C
          RESULT=C_ZERO
C
          DO IBRA=1,LDBASE
             DO IKET=1,LDBASE
C
                RESULT=RESULT + AUXILI(IBRA,IKET,1)
     *                        * AUXILI(IKET,IBRA,0)
C
                IF (KETA_R.EQ.2) THEN
C
                    IF (MREVER.EQ.0) STOP ' WRONG MREVER IN ROTAVR 3'
C
                    DO IREVER=0,NDREVE
C
                       IF (IREVER.EQ.0) I_SIGN=-1
                       IF (IREVER.EQ.1) I_SIGN=+1
C
                       DO IMID=1,LDBASE
C
C=======================================================================
C         THE PLUS SIGN BELOW COMES FROM THE "-i" FACTOR IN THE ANGULAR
C         MOMENTUM AND THE MINUS SIGN IN THE EXCHANGE TERM
C=======================================================================
C
                          AROTPP(IBRA,IKET,2,IREVER,ICHARG)
     *                   =AROTPP(IBRA,IKET,2,IREVER,ICHARG)
     *                 +2*AUXILI(IBRA,IMID,1-IREVER)
     *                                         *I_SIGN*HAUXIL(IMID,IKET)
C
                       END DO
C
                    END DO
C
                END IF
C
             END DO
          END DO
C
C=======================================================================
C         MINUS SIGN COMES FROM THE "-i" FACTOR IN THE ANGULAR MOMENTUM
C=======================================================================
C
          EROTSQ(2)=-2*REAL(RESULT)
          EKOTSQ(2)=-2*RESULT
C
C=======================================================================
C         TERMS OFF-DIAGONAL IN THE SIMPLEX QUANTUM NUMBER
C=======================================================================
C
          IF (ISIMPY.NE.1) THEN
C
              DO IREVER=0,NDREVE
C
                 IF (IREVER.EQ.0) I_SIGN=-1
                 IF (IREVER.EQ.1) I_SIGN=+1
C
                 DO IBRA=1,LDBASE
                    DO IKET=1,LDBASE
C
                       AUXILI(IBRA,IKET,IREVER)=C_ZERO
C
                       DO IMID=1,LDBASE
C
                          AUXILI(IBRA,IKET,IREVER)=
     *                    AUXILI(IBRA,IKET,IREVER)+
     *                    HAUXIL(IBRA,IMID)*I_SIGN*
     *                    BIG_PM(IMID,IKET,IREVER)
C
                       END DO
C
                    END DO
                 END DO
C
              END DO
C
C=======================================================================
C
              RESULT=C_ZERO
C
              DO IREVER=0,NDREVE
C
                 IF (IREVER.EQ.0) I_SIGN=+1
                 IF (IREVER.EQ.1) I_SIGN=-1
C
                 DO IBRA=1,LDBASE
                    DO IKET=1,LDBASE
C
                       RESULT=RESULT + AUXILI(IBRA,IKET,IREVER)
     *                               * AUXILI(IKET,IBRA,IREVER)
C
                       IF (KETA_R.EQ.2) THEN
C
                           DO IMID=1,LDBASE
C
C=======================================================================
C         THE PLUS SIGN BELOW COMES FROM THE "-i" FACTOR IN THE ANGULAR
C         MOMENTUM AND THE MINUS SIGN IN THE EXCHANGE TERM
C=======================================================================
C
                              AROTPM(IBRA,IKET,2,IREVER,ICHARG)
     *                       =AROTPM(IBRA,IKET,2,IREVER,ICHARG)
     *                     +2*AUXILI(IBRA,IMID,1-IREVER)
     *                                         *I_SIGN*HAUXIL(IMID,IKET)
C
                           END DO
C
                       END IF
C
                    END DO
                 END DO
C
              END DO
C
              EROTSQ(2)=EROTSQ(2)-REAL(RESULT)
              EKOTSQ(2)=EKOTSQ(2)-RESULT
C
          END IF
C
C=======================================================================
C         TRACE OF THE ( (ANGULAR Y-MOMENTUM TIMES KAPPA) TIMES
C         (ANGULAR Y-MOMENTUM TIMES KAPPA')* )
C=======================================================================
C
          IF (IPAIRI.EQ.1) THEN
C
             IF (ISIMPY.NE.1)
     *
     *           STOP ' NON-CONSERVED SIMPLEX NOT IMPLEMENTED IN ROTAVR'
C
             DO IBRA=1,LDBASE
                DO IKET=1,LDBASE
C
                   AUXILI(IBRA,IKET,0)=C_ZERO
                   AUXILI(IBRA,IKET,1)=C_ZERO
                   BUXILI(IBRA,IKET,0)=C_ZERO
                   BUXILI(IBRA,IKET,1)=C_ZERO
C
                   DO IMID=1,LDBASE
C
                      AUXILI(IBRA,IKET,0)=AUXILI(IBRA,IKET,0)
     *                     -HAUXIL(IBRA,IMID)*PAI_PM(IMID,IKET,0)
C
                      AUXILI(IBRA,IKET,1)=AUXILI(IBRA,IKET,1)
     *                     -HAUXIL(IBRA,IMID)*PAI_PM(IKET,IMID,0)
C
                      BUXILI(IBRA,IKET,0)=BUXILI(IBRA,IKET,0)
     *                     +HAUXIL(IBRA,IMID)*PAI_PM(IKET,IMID,1)
C
                      BUXILI(IBRA,IKET,1)=BUXILI(IBRA,IKET,1)
     *                     +HAUXIL(IBRA,IMID)*PAI_PM(IMID,IKET,1)
C
                   END DO
C
                END DO
             END DO
C
             RESULT=C_ZERO
C
             DO IREVER=0,NDREVE
C
                DO IBRA=1,LDBASE
                   DO IKET=1,LDBASE
C
                      RESULT=RESULT+AUXILI(IBRA,IKET,IREVER)
     *                       *CONJG(BUXILI(IKET,IBRA,IREVER))
C
                      IF (KETA_R.EQ.2) THEN
C
                          IF (IREVER.EQ.0) I_SIGN=-1
                          IF (IREVER.EQ.1) I_SIGN=+1
C
                          DO IMID=1,LDBASE
C
                             PROTPM(IBRA,IKET,2,IREVER,ICHARG)
     *                      =PROTPM(IBRA,IKET,2,IREVER,ICHARG)
     *                    -2*AUXILI(IBRA,IMID,1-IREVER)
     *                      *HAUXIL(IKET,IMID)*I_SIGN
C
                          END DO
C
                      END IF
C
                   END DO
                END DO
C
             END DO
C
             PROTSQ(2)=-REAL(RESULT)
             PKOTSQ(2)=-RESULT
C
          END IF
C
C=======================================================================
C
          CALL INTPY2(NXMAXX,NYMAXX,NZMAXX,IPHAPP(0,0,0),HAUXIL,FACTOR)
C
C=======================================================================
C         TRACE OF ANGULAR Y-MOMENTUM SQUERD TIMES THE DENSITY MATRIX
C=======================================================================
C
          RESULT=C_ZERO
C
          DO IBRA=1,LDBASE
             DO IKET=1,LDBASE
C
                RESULT=RESULT + HAUXIL(IBRA,IKET)*(BIG_PP(IKET,IBRA,0)
     *                                            +BIG_PP(IKET,IBRA,1))
C
             END DO
          END DO
C
          DROTSQ(2)=REAL(RESULT)
          DKOTSQ(2)=RESULT
C
      END IF
C
C=======================================================================
C         HERE ALL TERMS ARE COMBINED INTO THE AVERAGE OF THE SQUARE OF
C         THE TOTAL ANGULAR MOMENTUM.
C=======================================================================
C
      DO KARTEZ=1,NDKART
C
         TROTSQ(KARTEZ)=DROTSQ(KARTEZ)-EROTSQ(KARTEZ)
     *                 +PROTSQ(KARTEZ)+AROTLI(KARTEZ)**2
         TKOTSQ(KARTEZ)=DKOTSQ(KARTEZ)-EKOTSQ(KARTEZ)
     *                 +PKOTSQ(KARTEZ)+AKOTLI(KARTEZ)**2
C
      END DO
C
      DO KARTEZ=1,NDKART
C
         DROTSQ(0)=DROTSQ(0)+DROTSQ(KARTEZ)
         EROTSQ(0)=EROTSQ(0)+EROTSQ(KARTEZ)
         PROTSQ(0)=PROTSQ(0)+PROTSQ(KARTEZ)
         TROTSQ(0)=TROTSQ(0)+TROTSQ(KARTEZ)
         AROTLI(0)=AROTLI(0)+AROTLI(KARTEZ)**2
         PROTLI(0)=PROTLI(0)+PROTLI(KARTEZ)**2
         PROTKI(0)=PROTKI(0)+PROTKI(KARTEZ)**2
C
         DKOTSQ(0)=DKOTSQ(0)+DKOTSQ(KARTEZ)
         EKOTSQ(0)=EKOTSQ(0)+EKOTSQ(KARTEZ)
         PKOTSQ(0)=PKOTSQ(0)+PKOTSQ(KARTEZ)
         TKOTSQ(0)=TKOTSQ(0)+TKOTSQ(KARTEZ)
         AKOTLI(0)=AKOTLI(0)+AKOTLI(KARTEZ)**2
         PKOTLI(0)=PKOTLI(0)+PKOTLI(KARTEZ)**2
         PKOTKI(0)=PKOTKI(0)+PKOTKI(KARTEZ)**2
C
      END DO
C
C=======================================================================
      DEALLOCATE (AUXILI)
      IF (IPAIRI.EQ.1) DEALLOCATE (BUXILI)
      DEALLOCATE (HAUXIL)
C=======================================================================
C
      CALL CPUTIM('ROTAVR',0)
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE MOMETS(ISIMPY,ISIGNY,ISIQTY,QMOMUL,QMOMUT,
     *                                COFMUL,NMOMUL,ISHIFY)
C=======================================================================
      USE MAT_PP
      USE MAT_PM
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      COMPLEX
     *          RESULT,C_ZERO,QMOMUT
C=======================================================================
      DIMENSION
     *          COFMUL(0:NDMULT,0:NDOSCI,0:NDOSCI,1:NDKART)
      DIMENSION
     *          QMOMUL(0:NDMULT,-NDMULT:NDMULT)
      DIMENSION
     *          QMOMUT(0:NDMULT,-NDMULT:NDMULT)
C=======================================================================
      ALLOCATABLE ELEMUL(:,:)
C=======================================================================
      COMMON
     *       /T_PHAS/ IPHAPP(0:NDYMAX,0:NDYMAX,0:NDKART),
     *                IPHAPM(0:NDYMAX,0:NDYMAX,0:NDKART),
     *                IPHAMP(0:NDYMAX,0:NDYMAX,0:NDKART),
     *                IPHAMM(0:NDYMAX,0:NDYMAX,0:NDKART)
      COMMON
     *       /DIMENS/ LDBASE
C
C=======================================================================
C
      CALL CPUTIM('MOMETS',1)
C
C=======================================================================
C
      IALLOC=0
C
C=======================================================================
      ALLOCATE (ELEMUL(1:NDBASE,1:NDBASE),STAT=IALLOC)
      IF (IALLOC.NE.0) CALL NOALLO('ELEMUL','MOMETS')
C=======================================================================
C
C=======================================================================
C       THIS SUBROUTINE CALCULATES  AND RETURNS IN "QMOMUL" AND "QMOMUT"
C       THE AVERAGE VALUES OF THE ELECTROMAGNETIC MULTIPOLE MOMENTS
C
C                     R**LAMBDA*CONJG(Y(LAMBDA,MIU))
C
C       SEE J.D. JACKSON, CLASSICAL ELECTRODYNAMICS,  EQ. (4.3)
C=======================================================================
C       AVERAGE VALUES OF THE ELECTROMAGNETIC  MULTIPOLE  MOMENTS
C       ARE CALCULATED FROM AVERAGE VALUES OF POWERS OF POSITIONS,
C       THAT ARE TRANSMITTED IN THE  "COFMUL"   ARRAY.  THEREFORE,
C       THIS SUBROUTINE CAN CALCULATE THE MULTIPOLE MOMENTS  WITH
C       RESPECT TO A SHIFTED REFERENCE FRAME, PROVIDED  THAT  THE
C       POWERS OF SHIFTED POSITIONS ARE TRANSMITTED  IN  "COFMUL".
C=======================================================================
C       1) ELEMENTS OF THE QMOMUL  ARRAY FOR NON-NEGATIVE INDICES "MIU"
C          CONTAIN    REAL    PARTS OF  MULTIPOLE  MOMENTS  WITH  THESE
C          SAME VALUES OF THE MAGNETIC QUANTUM NUMBER "MIU".
C       2) ELEMENTS OF THE QMOMUL  ARRAY FOR   NEGATIVE   INDICES "MIU"
C          CONTAIN IMAGINARY  PARTS OF  MULTIPOLE  MOMENTS  WITH  THESE
C          SAME VALUES OF THE MAGNETIC QUANTUM NUMBER "MIU".
C       3) ELEMENTS OF THE QMOMUT  ARRAY FOR NON-NEGATIVE INDICES "MIU"
C          CONTAIN COMPLEX TRANSITION MATRIX ELEMENTS OF  -- R E A L --
C          PARTS OF MULTIPOLE OPERATORS WITH THESE SAME VALUES  OF  THE
C          MAGNETIC QUANTUM NUMBER "MIU".
C       4) ELEMENTS OF THE QMOMUT  ARRAY FOR   NEGATIVE   INDICES "MIU"
C          CONTAIN COMPLEX TRANSITION MATRIX ELEMENTS OF  - IMAGINARY -
C          PARTS OF MULTIPOLE OPERATORS WITH THESE SAME VALUES  OF  THE
C          MAGNETIC QUANTUM NUMBER "MIU".
C=======================================================================
C       FOR CONSERVED SIMPLEX (ISIMPY=1):
C       ONLY THE MIU>=0 MOMENTS ARE CALCULATED.
C=======================================================================
C       FOR CONSERVED SIGNATURE (ISIGNY=1):
C       1) THE MIU>=0 MOMENTS  ARE CALCULATED ONLY FOR EVEN MOMENTS.
C       2) THE MIU <0 MOMENTS  ARE CALCULATED ONLY FOR ODD  MOMENTS.
C=======================================================================
C       FOR CONSERVED PARITY (ISIQTY=1):
C       ONLY THE EVEN MOMENTS ARE CALCULATED.
C=======================================================================
C       SEE "MULCOU" FOR THE TABLE WITH ALL ISIMPY/ISIGNY COMBINATIONS
C=======================================================================
C
      C_ZERO=CMPLX(0.0D0,0.0D0)
C
      DO LAMBDA=0,NDMULT
         DO MIU=-LAMBDA,LAMBDA
C
            QMOMUL(LAMBDA,MIU)=0.0D0
            QMOMUT(LAMBDA,MIU)=C_ZERO
C
         END DO
      END DO
C
C=======================================================================
C        HERE THE MIU>=0 MOMENTS ARE CALCULATED AND STORED IN THE
C        "QMOMUL" AND "QMOMUT" ARRAYS FOR NON-NEGATIVE VALUES OF "MIU"
C=======================================================================
C
      IMAREA=1
C
      DO LAMBDA=0,NMOMUL
         DO MIU=0,LAMBDA
C
            IF (MOD(LAMBDA,2).EQ.0.OR.ISIGNY.NE.1) THEN
C
                CALL INTMUL(IPHAPP(0,0,0),ELEMUL,COFMUL,
     *                                LAMBDA,MIU,IMAREA)
C
                RESULT=C_ZERO
C
                DO IBRA=1,LDBASE
                   DO IKET=1,LDBASE
C
                      RESULT=RESULT + ELEMUL(IBRA,IKET)
     *
     *                    * (BIG_PP(IKET,IBRA,0) + BIG_PP(IKET,IBRA,1))
C
                   END DO
                END DO
C
                QMOMUL(LAMBDA,MIU)=REAL(RESULT)
                QMOMUT(LAMBDA,MIU)=     RESULT
C
C=======================================================================
C        IF THERE IS A NON-ZERO Y-SHIFT OF THE CENTER OF MASS FROM THE
C        LABORATORY REFERENCE FRAME, THE REAL  PARTS  OF  THE  SHIFTED
C        MOMENT OPERATORS ARE NO MORE INVARIANT WITH  RESPECT  TO  THE
C        SIMPLEX. FOR THIS REASON, REAL MATRIX ELEMENTS APPEAR ALSO IN
C        THE SIMPLEX-OFF-DIAGONAL BLOCK. IN THE FOLLOWING FRAGMENT  OF
C        THE CODE, CONTRIBUTIONS FROM THESE ELEMENTS  ARE  TAKEN  INTO
C        ACCOUNT. THIS PART IS EXECUTED  ONLY  IF  THE  CENTER-OF-MASS
C        MOMENTS ARE CALCULATED FOR A NON-ZERO Y-SHIFT (ISHIFY=1).
C=======================================================================
C
                IF (ISHIFY.EQ.1.AND.ISIMPY.NE.1) THEN
C
                    CALL INTMUL(IPHAPM(0,0,0),ELEMUL,COFMUL,
     *                                    LAMBDA,MIU,IMAREA)
C
                    RESULT=C_ZERO
C
                    DO IBRA=1,LDBASE
                       DO IKET=1,LDBASE
C
                          RESULT=RESULT + ELEMUL(IBRA,IKET)
     *
     *                                  * BIG_PM(IKET,IBRA,0)
C
                       END DO
                    END DO
C
                    QMOMUL(LAMBDA,MIU)=QMOMUL(LAMBDA,MIU)-2*REAL(RESULT)
C
                END IF
C
            ELSE
C
                QMOMUL(LAMBDA,MIU)=0.0D0
                QMOMUT(LAMBDA,MIU)=C_ZERO
C
            END IF
C
         END DO
      END DO
C
C=======================================================================
C        HERE THE MIU<0 MOMENTS ARE CALCULATED AND STORED IN THE
C        "QMOMUL" AND "QMOMUT" ARRAYS FOR NEGATIVE VALUES OF "MIU"
C=======================================================================
C
      IF (ISIMPY.NE.1.AND.NMOMUL.GE.1) THEN
C
          IMAREA=-1
C
          DO LAMBDA=1,NMOMUL
             DO MIU=-LAMBDA,-1
C
                IF ((MOD(LAMBDA,2).EQ.1.OR.ISIGNY.NE.1).AND.
     *              (MOD(LAMBDA,2).EQ.0.OR.ISIQTY.NE.1)) THEN
C
                    CALL INTMUL(IPHAPM(0,0,0),ELEMUL,COFMUL,
     *                                    LAMBDA,MIU,IMAREA)
C
                    RESULT=C_ZERO
C
                    DO IBRA=1,LDBASE
                       DO IKET=1,LDBASE
C
                          RESULT=RESULT + ELEMUL(IBRA,IKET)
     *
     *                                  *(BIG_PM(IKET,IBRA,1)
     *                                   -BIG_PM(IKET,IBRA,0))
C
                       END DO
                    END DO
C
                    QMOMUL(LAMBDA,MIU)=REAL(RESULT)
                    QMOMUT(LAMBDA,MIU)=     RESULT
C
C=======================================================================
C        SEE COMMENT FOR REAL PART ABOVE, CHANGING REAL INTO IMAGINARY,
C        INVARIANT INTO ANTI-INVARIANT, AND OFF-DIAGONAL INTO DIAGONAL.
C=======================================================================
C
                    IF (ISHIFY.EQ.1.AND.ISIMPY.NE.1) THEN
C
                        CALL INTMUL(IPHAPP(0,0,0),ELEMUL,COFMUL,
     *                                        LAMBDA,MIU,IMAREA)
C
                        RESULT=C_ZERO
C
                        DO IBRA=1,LDBASE
                           DO IKET=1,LDBASE
C
                              RESULT=RESULT + ELEMUL(IBRA,IKET)
     *
     *                            * (BIG_PP(IKET,IBRA,0)
     *                            +  BIG_PP(IKET,IBRA,1))
C
                           END DO
                        END DO
C
                        QMOMUL(LAMBDA,MIU)=
     *                  QMOMUL(LAMBDA,MIU)+REAL(RESULT)
C
                    END IF
C
                ELSE
C
                    QMOMUL(LAMBDA,MIU)=0.0D0
                    QMOMUT(LAMBDA,MIU)=C_ZERO
C
                END IF
C
             END DO
          END DO
C
      END IF
C
C=======================================================================
      DEALLOCATE (ELEMUL)
C=======================================================================
C
      CALL CPUTIM('MOMETS',0)
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE MOMSIF(ISIMPY,ISIGNY,ISIQTY,QMOMUL,QMOMUT,
     *                                       COFMUL,NMOSIF)
C=======================================================================
      USE MAT_PP
      USE MAT_PM
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      COMPLEX
     *          RESULT,C_ZERO,QMOMUT
C=======================================================================
      DIMENSION
     *          COFMUL(0:NDMULT,0:NDOSCI,0:NDOSCI,1:NDKART)
      DIMENSION
     *          QMOMUL(0:NDMULT,-NDMULT:NDMULT)
      DIMENSION
     *          QMOMUT(0:NDMULT,-NDMULT:NDMULT)
C=======================================================================
      ALLOCATABLE ELEMUL(:,:)
C=======================================================================
      COMMON
     *       /T_PHAS/ IPHAPP(0:NDYMAX,0:NDYMAX,0:NDKART),
     *                IPHAPM(0:NDYMAX,0:NDYMAX,0:NDKART),
     *                IPHAMP(0:NDYMAX,0:NDYMAX,0:NDKART),
     *                IPHAMM(0:NDYMAX,0:NDYMAX,0:NDKART)
      COMMON
     *       /DIMENS/ LDBASE
C
C=======================================================================
C
      CALL CPUTIM('MOMSIF',1)
C
C=======================================================================
C
      IALLOC=0
C
C=======================================================================
      ALLOCATE (ELEMUL(1:NDBASE,1:NDBASE),STAT=IALLOC)
      IF (IALLOC.NE.0) CALL NOALLO('ELEMUL','MOMSIF')
C=======================================================================
C
C=======================================================================
C       THIS SUBROUTINE CALCULATES  AND RETURNS IN "QMOMUL"
C       THE AVERAGE VALUES OF THE SURFACE MULTIPOLE MOMENTS
C                 R**(LAMBDA+2)*CONJG(Y(LAMBDA,MIU))
C
C       SEE THE APPROPRIATE REFERENCE TO BE QUOTED  HERE  LATER.
C=======================================================================
C       THE STRUCTURE OF THIS SUBROUTINE IS EXACTLY THE SAME  AS
C       THE STRUCTURE OF SUBROUTINE "MOMETS"; SEE COMMENTS THERE
C       FOR MORE DETAILS.
C=======================================================================
C
      C_ZERO=CMPLX(0.0D0,0.0D0)
C
      DO LAMBDA=0,NDMULT
         DO MIU=-LAMBDA,LAMBDA
C
            QMOMUL(LAMBDA,MIU)=0.0D0
            QMOMUT(LAMBDA,MIU)=C_ZERO
C
         END DO
      END DO
C
C=======================================================================
C     FOR NMOSIF=0 THE SURFACE MOMENTS ARE NOT  CALCULATED,  WHILE
C     FOR NMOSIF>0 THE SURFACE MOMENTS ARE CALCULATED UP TO NMOSIF
C     HENCE, THERE IS NO POSSIBILITY  TO  CALCULATE  THE  NMOSIF=0
C     MOMENT ALONE, HOWEVER, THIS ONE IS SIMPLY EQUAL TO THE  MEAN
C     SQUARE RADIUS.
C=======================================================================
C
      IF (NMOSIF.LE.0) GO TO 1
C
C=======================================================================
C        HERE THE MIU>=0 MOMENTS ARE CALCULATED AND STORED IN THE
C        "QMOMUL" AND "QMOMUT" ARRAYS FOR NON-NEGATIVE VALUES OF "MIU"
C=======================================================================
C
      IMAREA=1
C
      DO LAMBDA=0,NMOSIF
         DO MIU=0,LAMBDA
C
            IF (MOD(LAMBDA,2).EQ.0.OR.ISIGNY.NE.1) THEN
C
                CALL INTSIF(IPHAPP(0,0,0),ELEMUL,COFMUL,
     *                                LAMBDA,MIU,IMAREA)
C
                RESULT=CMPLX(0.0D0,0.0D0)
C
                DO IBRA=1,LDBASE
                   DO IKET=1,LDBASE
C
                      RESULT=RESULT + ELEMUL(IBRA,IKET)
     *
     *                    * (BIG_PP(IKET,IBRA,0) + BIG_PP(IKET,IBRA,1))
C
                   END DO
                END DO
C
                QMOMUL(LAMBDA,MIU)=REAL(RESULT)
                QMOMUT(LAMBDA,MIU)=     RESULT
C
            ELSE
C
                QMOMUL(LAMBDA,MIU)=0.0D0
C
            END IF
C
         END DO
      END DO
C
C=======================================================================
C        HERE THE MIU<0 MOMENTS ARE CALCULATED AND STORED IN THE
C        "QMOMUL" AND "QMOMUT" ARRAYS FOR NEGATIVE VALUES OF "MIU"
C=======================================================================
C
      IF (ISIMPY.NE.1.AND.NMOSIF.GE.1) THEN
C
          IMAREA=-1
C
          DO LAMBDA=1,NMOSIF
             DO MIU=-LAMBDA,-1
C
                IF ((MOD(LAMBDA,2).EQ.1.OR.ISIGNY.NE.1).AND.
     *              (MOD(LAMBDA,2).EQ.0.OR.ISIQTY.NE.1)) THEN
C
                    CALL INTSIF(IPHAPM(0,0,0),ELEMUL,COFMUL,
     *                                    LAMBDA,MIU,IMAREA)
C
                    RESULT=CMPLX(0.0D0,0.0D0)
C
                    DO IBRA=1,LDBASE
                       DO IKET=1,LDBASE
C
                          RESULT=RESULT + ELEMUL(IBRA,IKET)
     *
     *                                  *(BIG_PM(IKET,IBRA,1)
     *                                   -BIG_PM(IKET,IBRA,0))
C
                       END DO
                    END DO
C
                    QMOMUL(LAMBDA,MIU)=REAL(RESULT)
                    QMOMUT(LAMBDA,MIU)=     RESULT
C
                ELSE
C
                    QMOMUL(LAMBDA,MIU)=0.0D0
                    QMOMUT(LAMBDA,MIU)=C_ZERO
C
                END IF
C
             END DO
          END DO
C
      END IF
C
C=======================================================================
      DEALLOCATE (ELEMUL)
C=======================================================================
C
    1 CONTINUE
C
C=======================================================================
C
      CALL CPUTIM('MOMSIF',0)
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE MOMSCH(QMOSIF,QMOSIT,NMOSIF,QMOMUL,QMOMUT,NMOMUL)
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      COMPLEX
     *          QMOMUT,QMOSIT
C
      DIMENSION
     *          QMOMUL(0:NDMULT,-NDMULT:NDMULT),
     *          QMOSIF(0:NDMULT,-NDMULT:NDMULT)
      DIMENSION
     *          QMOMUT(0:NDMULT,-NDMULT:NDMULT),
     *          QMOSIT(0:NDMULT,-NDMULT:NDMULT)
C
C=======================================================================
C       THIS SUBROUTINE CALCULATES  AND RETURNS IN "QMOSIF" AND "QMOSIT"
C       THE AVERAGE VALUES OF THE SCHIFF  MULTIPOLE MOMENTS
C                 R**(LAMBDA+2)*CONJG(Y(LAMBDA,MIU))
C       -5/3<R**2>R**(LAMBDA)  *CONJG(Y(LAMBDA,MIU))
C
C       ATTENTION! THE FACTOR OF 1/10 IS NOT INCLUDED IN THE SCHIFF
C                  MOMENTS
C
C       SEE THE APPROPRIATE REFERENCE TO BE QUOTED  HERE  LATER.
C=======================================================================
C       THE SURFACE AND MULTIPOLE MOMENTS ARE SUPPOSED TO BE EARLIER
C       CALCULATED
C=======================================================================
C
      IF (NMOMUL.LT.NMOSIF) STOP 'TOO FEW MULTIPOLE MOMENTS IN MOMSCH'
C
C=======================================================================
C
      RADSQU=REAL(QMOSIT(0,0))/REAL(QMOMUT(0,0))
C
      DO LAMBDA=0,NMOSIF
         DO MIU=-LAMBDA,LAMBDA
C
                QMOSIF(LAMBDA,MIU)=QMOSIF(LAMBDA,MIU)
     *                            -5.0D0/3.0D0*RADSQU*QMOMUL(LAMBDA,MIU)
                QMOSIT(LAMBDA,MIU)=QMOSIT(LAMBDA,MIU)
     *                            -5.0D0/3.0D0*RADSQU*QMOMUT(LAMBDA,MIU)
C
         END DO
      END DO
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE MOMPLM(ISIMPY,ISIGNY,ISIQTY,QMOMUL,COFMUL,NMOSIF)
C=======================================================================
      USE MAT_PP
      USE MAT_PM
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      COMPLEX
     *          RESULT
C=======================================================================
      DIMENSION
     *          COFMUL(0:NDMULT,0:NDOSCI,0:NDOSCI,1:NDKART)
      DIMENSION
     *          QMOMUL(0:NDMULT,-NDMULT:NDMULT)
C=======================================================================
      ALLOCATABLE ELEMUL(:,:)
C=======================================================================
      COMMON
     *       /T_PHAS/ IPHAPP(0:NDYMAX,0:NDYMAX,0:NDKART),
     *                IPHAPM(0:NDYMAX,0:NDYMAX,0:NDKART),
     *                IPHAMP(0:NDYMAX,0:NDYMAX,0:NDKART),
     *                IPHAMM(0:NDYMAX,0:NDYMAX,0:NDKART)
      COMMON
     *       /DIMENS/ LDBASE
C
C=======================================================================
C
      CALL CPUTIM('MOMPLM',1)
C
C=======================================================================
C
      IALLOC=0
C
C=======================================================================
      ALLOCATE (ELEMUL(1:NDBASE,1:NDBASE),STAT=IALLOC)
      IF (IALLOC.NE.0) CALL NOALLO('ELEMUL','MOMPLM')
C=======================================================================
C
C=======================================================================
C       THIS SUBROUTINE CALCULATES  AND  RETURNS  IN  "QMOMUL"
C       THE AVERAGE VALUES OF THE PENSURFACE MULTIPOLE MOMENTS
C                R**(LAMBDA+4)*CONJG(Y(LAMBDA,MIU))
C=======================================================================
C       THE STRUCTURE OF THIS SUBROUTINE IS EXACTLY THE SAME  AS
C       THE STRUCTURE OF SUBROUTINES "MOMETS" AND "MOMSIF";  SEE
C       COMMENTS THERE FOR MORE DETAILS.
C=======================================================================
C
      DO LAMBDA=0,NDMULT
         DO MIU=-LAMBDA,LAMBDA
C
            QMOMUL(LAMBDA,MIU)=0.0D0
C
         END DO
      END DO
C
C=======================================================================
C
      IF (NMOSIF.LE.0) GO TO 1
C
C=======================================================================
C        HERE THE REAL PARTS OF MOMENTS ARE CALCULATED AND STORED
C        IN THE "QMOMUL"  ARRAY FOR NON-NEGATIVE VALUES OF "MIU".
C=======================================================================
C
      IMAREA=1
C
      DO LAMBDA=0,NMOSIF
         DO MIU=0,LAMBDA
C
            IF (MOD(LAMBDA,2).EQ.0.OR.ISIGNY.NE.1) THEN
C
                CALL INTPLM(IPHAPP(0,0,0),ELEMUL,COFMUL,
     *                                LAMBDA,MIU,IMAREA)
C
                RESULT=CMPLX(0.0D0,0.0D0)
C
                DO IBRA=1,LDBASE
                   DO IKET=1,LDBASE
C
                      RESULT=RESULT + ELEMUL(IBRA,IKET)
     *
     *                    * (BIG_PP(IKET,IBRA,0) + BIG_PP(IKET,IBRA,1))
C
                   END DO
                END DO
C
                QMOMUL(LAMBDA,MIU)=REAL(RESULT)
C
            ELSE
C
                QMOMUL(LAMBDA,MIU)=0.0D0
C
            END IF
C
         END DO
      END DO
C
C=======================================================================
C        HERE THE IMAGINARY PARTS OF MOMENTS ARE CALCULATED AND STORED
C        IN THE "QMOMUL"  ARRAY FOR NEGATIVE VALUES OF "MIU".
C=======================================================================
C
      IF (ISIMPY.NE.1.AND.NMOSIF.GE.1) THEN
C
          IMAREA=-1
C
          DO LAMBDA=1,NMOSIF
             DO MIU=-LAMBDA,-1
C
                IF ((MOD(LAMBDA,2).EQ.1.OR.ISIGNY.NE.1).AND.
     *              (MOD(LAMBDA,2).EQ.0.OR.ISIQTY.NE.1)) THEN
C
                    CALL INTPLM(IPHAPM(0,0,0),ELEMUL,COFMUL,
     *                                    LAMBDA,MIU,IMAREA)
C
                    RESULT=CMPLX(0.0D0,0.0D0)
C
                    DO IBRA=1,LDBASE
                       DO IKET=1,LDBASE
C
                          RESULT=RESULT + ELEMUL(IBRA,IKET)
     *
     *                                  * BIG_PM(IKET,IBRA,0)
C
                       END DO
                    END DO
C
                    QMOMUL(LAMBDA,MIU)=-2*REAL(RESULT)
C
                ELSE
C
                    QMOMUL(LAMBDA,MIU)=0.0D0
C
                END IF
C
             END DO
          END DO
C
      END IF
C
C=======================================================================
      DEALLOCATE (ELEMUL)
C=======================================================================
C
    1 CONTINUE
C
C=======================================================================
C
      CALL CPUTIM('MOMPLM',0)
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE MOMVMU(ISIMPY,QMOMUL,COFMUL,NMOSIF)
C=======================================================================
      USE MAT_PP
      USE MAT_PM
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      COMPLEX
     *          RESULT
C=======================================================================
      DIMENSION
     *          COFMUL(0:NDMULT,0:NDOSCI,0:NDOSCI,1:NDKART)
      DIMENSION
     *          QMOMUL(0:NDMULT,-NDMULT:NDMULT,1:NDKART)
C=======================================================================
      ALLOCATABLE ELEMUL(:,:)
C=======================================================================
      COMMON
     *       /T_PHAS/ IPHAPP(0:NDYMAX,0:NDYMAX,0:NDKART),
     *                IPHAPM(0:NDYMAX,0:NDYMAX,0:NDKART),
     *                IPHAMP(0:NDYMAX,0:NDYMAX,0:NDKART),
     *                IPHAMM(0:NDYMAX,0:NDYMAX,0:NDKART)
      COMMON
     *       /DIMENS/ LDBASE
C
C=======================================================================
C
      CALL CPUTIM('MOMVMU',1)
C
C=======================================================================
C
      IALLOC=0
C
C=======================================================================
      ALLOCATE (ELEMUL(1:NDBASE,1:NDBASE),STAT=IALLOC)
      IF (IALLOC.NE.0) CALL NOALLO('ELEMUL','MOMVMU')
C=======================================================================
C
C=======================================================================
C       THIS SUBROUTINE CALCULATES  AND RETURNS IN "QMOMUL" THE
C       AVERAGE VALUES OF THE   V E C T O R   MULTIPOLE MOMENTS
C               R**(LAMBDA)*CONJG(Y(LAMBDA,MIU))*(X,Y,Z)
C
C       SEE THE APPROPRIATE REFERENCE TO BE QUOTED  HERE  LATER.
C=======================================================================
C       THE STRUCTURE OF THIS SUBROUTINE IS EXACTLY THE SAME  AS
C       THE STRUCTURE OF SUBROUTINE "MOMETS"; SEE COMMENTS THERE
C       FOR MORE DETAILS.
C=======================================================================
C
      DO LAMBDA=0,NDMULT
         DO MIU=-LAMBDA,LAMBDA
            DO KARTEZ=1,NDKART
C
               QMOMUL(LAMBDA,MIU,KARTEZ)=0.0D0
C
            END DO
         END DO
      END DO
C
C=======================================================================
C     FOR NMOSIF=0 THE VECTOR MOMENTS ARE NOT  CALCULATED,  WHILE
C     FOR NMOSIF>0 THE VECTOR MOMENTS ARE CALCULATED UP TO NMOSIF
C     HENCE, THERE IS NO POSSIBILITY TO  CALCULATE  THE  NMOSIF=0
C     MOMENT ALONE, HOWEVER, THESE ONES ARE SIMPLY EQUAL  TO  THE
C     CENTER-OF-MASS POSITIONS.
C=======================================================================
C
      IF (NMOSIF.LE.0) GO TO 1
C
C=======================================================================
C        HERE THE REAL PARTS OF MOMENTS ARE CALCULATED AND STORED
C        IN THE "QMOMUL"  ARRAY FOR NON-NEGATIVE VALUES OF "MIU".
C=======================================================================
C        HERE THE "X" AND "Z" COMPONENTS (SIMPLEX-EVEN) ARE CONSIDERED
C=======================================================================
C
      IMAREA=1
C
      DO LAMBDA=0,NMOSIF
         DO MIU=0,LAMBDA
            DO KARTEZ=1,NDKART
C
               IF (KARTEZ.NE.2) THEN
C
                   CALL INTVMU(IPHAPP(0,0,0),ELEMUL,COFMUL,
     *                            LAMBDA,MIU,KARTEZ,IMAREA)
C
                   RESULT=CMPLX(0.0D0,0.0D0)
C
                   DO IBRA=1,LDBASE
                      DO IKET=1,LDBASE
C
                         RESULT=RESULT + ELEMUL(IBRA,IKET)
     *
     *                       * (BIG_PP(IKET,IBRA,0)+BIG_PP(IKET,IBRA,1))
C
                      END DO
                   END DO
C
                   QMOMUL(LAMBDA,MIU,KARTEZ)=REAL(RESULT)
C
               END IF
C
C=======================================================================
C        HERE THE "Y" COMPONENT (SIMPLEX-ODD) IS CONSIDERED
C=======================================================================
C        THE REAL PARTS OF THE  "Y"  COMPONENTS OF THE  VECTOR  MOMENT
C        OPERATORS ARE ANTI-INVARIANT WITH RESPECT TO THE SIMPLEX. FOR
C        THIS REASON, REAL MATRIX ELEMENTS APPEAR ALSO IN THE SIMPLEX-
C        OFF-DIAGONAL BLOCK. IN THE FOLLOWING FRAGMENT  OF  THE  CODE,
C        CONTRIBUTIONS FROM THESE ELEMENTS  ARE  TAKEN  INTO  ACCOUNT.
C        THIS PART IS EXECUTED ONLY IF THE SIMPLEX SYMMETRY IS BROKEN.
C=======================================================================
C
               IF (KARTEZ.EQ.2) THEN
C
                   IF (ISIMPY.NE.1) THEN
C
                       CALL INTVMU(IPHAPM(0,0,0),ELEMUL,COFMUL,
     *                                LAMBDA,MIU,KARTEZ,IMAREA)
C
                       RESULT=CMPLX(0.0D0,0.0D0)
C
                       DO IBRA=1,LDBASE
                          DO IKET=1,LDBASE
C
                             RESULT=RESULT + ELEMUL(IBRA,IKET)
     *
     *                                     * BIG_PM(IKET,IBRA,0)
C
                          END DO
                       END DO
C
                       QMOMUL(LAMBDA,MIU,KARTEZ)=-2*REAL(RESULT)
C
                   ELSE
C
                       QMOMUL(LAMBDA,MIU,KARTEZ)=0.0D0
C
                   END IF
C
               END IF
C
            END DO
         END DO
      END DO
C
C=======================================================================
C        HERE THE IMAGINARY PARTS OF MOMENTS ARE CALCULATED AND STORED
C        IN THE "QMOMUL"  ARRAY FOR NEGATIVE VALUES OF "MIU".
C=======================================================================
C        HERE THE "X" AND "Z" COMPONENTS (SIMPLEX-ODD) ARE CONSIDERED
C=======================================================================
C
      IMAREA=-1
C
      DO LAMBDA=1,NMOSIF
         DO MIU=-LAMBDA,-1
            DO KARTEZ=1,NDKART
C
               IF (KARTEZ.NE.2) THEN
C
                   IF (ISIMPY.NE.1) THEN
C
                       CALL INTVMU(IPHAPM(0,0,0),ELEMUL,COFMUL,
     *                                LAMBDA,MIU,KARTEZ,IMAREA)
C
                       RESULT=CMPLX(0.0D0,0.0D0)
C
                       DO IBRA=1,LDBASE
                          DO IKET=1,LDBASE
C
                             RESULT=RESULT + ELEMUL(IBRA,IKET)
     *
     *                                     * BIG_PM(IKET,IBRA,0)
C
                          END DO
                       END DO
C
                       QMOMUL(LAMBDA,MIU,KARTEZ)=-2*REAL(RESULT)
C
                   ELSE
C
                       QMOMUL(LAMBDA,MIU,KARTEZ)=0.0D0
C
                   END IF
C
               END IF
C
C=======================================================================
C        HERE THE "Y" COMPONENT (SIMPLEX-EVEN) IS CONSIDERED
C=======================================================================
C        SEE COMMENT FOR REAL PART ABOVE, CHANGING REAL INTO IMAGINARY,
C        INVARIANT INTO ANTI-INVARIANT, AND OFF-DIAGONAL INTO DIAGONAL.
C=======================================================================
C
               IF (KARTEZ.EQ.2) THEN
C
                   CALL INTVMU(IPHAPP(0,0,0),ELEMUL,COFMUL,
     *                            LAMBDA,MIU,KARTEZ,IMAREA)
C
                   RESULT=CMPLX(0.0D0,0.0D0)
C
                   DO IBRA=1,LDBASE
                      DO IKET=1,LDBASE
C
                         RESULT=RESULT + ELEMUL(IBRA,IKET)
     *
     *                       * (BIG_PP(IKET,IBRA,0)
     *                       +  BIG_PP(IKET,IBRA,1))
C
                      END DO
                   END DO
C
                   QMOMUL(LAMBDA,MIU,KARTEZ)=+REAL(RESULT)
C
               END IF
C
            END DO
         END DO
      END DO
C
C=======================================================================
C
    1 CONTINUE
C
C=======================================================================
      DEALLOCATE (ELEMUL)
C=======================================================================
C
      CALL CPUTIM('MOMVMU',0)
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE MAGMOM(ISIMPY,IROTAT,ICHARG,AMOMUL,AMOMUT,NMOMAG)
C=======================================================================
      USE MAT_PP
      USE MAT_PM
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      COMPLEX
     *          ELESPI,RESULT,SMOMUL,AMOMUT,C_ZERO,UNIT_I
C=======================================================================
      DIMENSION
     *          G_SPIN(0:NDISOS),G_ORBI(0:NDISOS)
C=======================================================================
      ALLOCATABLE ELESPI(:,:)
      ALLOCATABLE ELEORB(:,:)
C=======================================================================
      DIMENSION
     *          AMOMUL(0:NDMULT,-NDMULT:NDMULT)
      DIMENSION
     *          AMOMUT(0:NDMULT,-NDMULT:NDMULT)
      DIMENSION
     *          SMOMUL(0:NDMULT,-NDMULT:NDMULT)
C
C=======================================================================
      COMMON
     *       /DIMENS/ LDBASE
C
      DATA
     *      G_SPIN /-3.826D0,5.586D0/,
     *      G_ORBI / 0.000D0,1.000D0/
C
C=======================================================================
C
      CALL CPUTIM('MAGMOM',1)
C
C=======================================================================
C
      IALLOC=0
C
C=======================================================================
      ALLOCATE (ELESPI(1:NDBASE,1:NDBASE),STAT=IALLOC)
      IF (IALLOC.NE.0) CALL NOALLO('ELESPI','MAGMOM')
      ALLOCATE (ELEORB(1:NDBASE,1:NDBASE),STAT=IALLOC)
      IF (IALLOC.NE.0) CALL NOALLO('ELEORB','MAGMOM')
C=======================================================================
C
C=======================================================================
C       THIS SUBROUTINE CALCULATES AND RETURNS IN "AMOMUL" AND "AMOMUT"
C       THE AVERAGE VALUES OF THE MAGNETIC MULTIPOLE MOMENTS
C          GRAD[R**LAMBDA*CONJG(Y(LAMBDA,MIU))]*
C          *(G_SPIN*S+(2/(LAMBDA+1))*G_ORBI*L)
C       THIS FORMULA DIFFERS FROM EQ.(B.24) IN RING & SCHUCK
C       BY THE COMPLEX CONJUGATE OF THE SPHERICAL HARMONICS
C       THE RESULT IS EXPRESSED IN NUCLEAR MAGNETONS
C=======================================================================
C
      C_ZERO=CMPLX(0.0D0,0.0D0)
C
      UNIT_I=CMPLX(0.0D0,1.0D0)
C
C=======================================================================
C       ZEROING THE ORBITAL MOMENTS
C=======================================================================
C
      DO LAMBDA=0,NDMULT
         DO MIU=-LAMBDA,LAMBDA
C
            AMOMUL(LAMBDA,MIU)=0.0D0
            AMOMUT(LAMBDA,MIU)=C_ZERO
C
         END DO
      END DO
C
C=======================================================================
C       ZEROING THE SPIN MOMENTS
C=======================================================================
C
      DO LAMBDA=0,NDMULT
         DO MIU=-LAMBDA,LAMBDA
C
            SMOMUL(LAMBDA,MIU)=0.0D0
C
         END DO
      END DO
C
      IF (IROTAT.NE.1) GO TO 2
C
C=======================================================================
C       CALCULATING THE REAL PARTS OF THE SPIN MOMENTS
C=======================================================================
C
      IF (ISIMPY.NE.1) THEN
C
          IMAREA=1
C
          DO LAMBDA=0,NMOMAG
             DO MIU=0,LAMBDA
C
                CALL INTSPI(ELESPI,LAMBDA,MIU,IMAREA)
C
                RESULT=CMPLX(0.0D0,0.0D0)
C
                DO IBRA=1,LDBASE
                   DO IKET=1,LDBASE
C
                      RESULT=RESULT+ELESPI(IBRA,IKET)
     *                             *BIG_PM(IKET,IBRA,1)
     *                       +CONJG(ELESPI(IBRA,IKET))
     *                             *BIG_PM(IKET,IBRA,0)
C
                   END DO
                END DO
C
                SMOMUL(LAMBDA,MIU)=RESULT*G_SPIN(ICHARG)
C
             END DO
          END DO
C
      END IF
C
C=======================================================================
C       CALCULATING THE IMAGINARY PARTS OF THE SPIN MOMENTS
C=======================================================================
C
      IF (NMOMAG.GE.1) THEN
C
          IMAREA=-1
C
          DO LAMBDA=1,NMOMAG
             DO MIU=-LAMBDA,-1
C
                CALL INTSPI(ELESPI,LAMBDA,MIU,IMAREA)
C
                RESULT=CMPLX(0.0D0,0.0D0)
C
                DO IBRA=1,LDBASE
                   DO IKET=1,LDBASE
C
                      RESULT=RESULT+ELESPI(IBRA,IKET)
     *                             *BIG_PP(IKET,IBRA,0)
     *                       +CONJG(ELESPI(IBRA,IKET))
     *                             *BIG_PP(IKET,IBRA,1)
C
                   END DO
                END DO
C
                SMOMUL(LAMBDA,MIU)=-UNIT_I*RESULT*G_SPIN(ICHARG)
C
             END DO
          END DO
C
      END IF
C
C=======================================================================
C       CALCULATING THE REAL PARTS OF THE ORBITAL MOMENTS
C=======================================================================
C
      IF (ISIMPY.NE.1.AND.ICHARG.EQ.1) THEN
C
          IMAREA=1
C
          DO LAMBDA=0,NMOMAG
             DO MIU=0,LAMBDA
C
                CALL INTORB(ELEORB,LAMBDA,MIU,IMAREA)
C
                RESULT=CMPLX(0.0D0,0.0D0)
C
                DO IBRA=1,LDBASE
                   DO IKET=1,LDBASE
C
                      RESULT=RESULT+ELEORB(IBRA,IKET)
     *                            *(BIG_PM(IKET,IBRA,1)
     *                             -BIG_PM(IKET,IBRA,0))
C
                   END DO
                END DO
C
                AMOMUL(LAMBDA,MIU)=-AIMAG(RESULT)*G_ORBI(ICHARG)
                AMOMUT(LAMBDA,MIU)=UNIT_I*RESULT *G_ORBI(ICHARG)
C
             END DO
          END DO
C
      END IF
C
C=======================================================================
C       CALCULATING THE IMAGINARY PARTS OF THE ORBITAL MOMENTS
C=======================================================================
C
      IF (NMOMAG.GE.1.AND.ICHARG.EQ.1) THEN
C
          IMAREA=-1
C
          DO LAMBDA=1,NMOMAG
             DO MIU=-LAMBDA,-1
C
                CALL INTORB(ELEORB,LAMBDA,MIU,IMAREA)
C
                RESULT=CMPLX(0.0D0,0.0D0)
C
                DO IBRA=1,LDBASE
                   DO IKET=1,LDBASE
C
                      RESULT=RESULT+ELEORB(IBRA,IKET)
     *                            *(BIG_PP(IKET,IBRA,0)
     *                             +BIG_PP(IKET,IBRA,1))
C
                   END DO
                END DO
C
                AMOMUL(LAMBDA,MIU)=  AIMAG(RESULT)*G_ORBI(ICHARG)
                AMOMUT(LAMBDA,MIU)=-UNIT_I*RESULT *G_ORBI(ICHARG)
C
             END DO
          END DO
C
      END IF
C
C=======================================================================
C        ADDING ORBITAL AND SPIN PARTS OF MAGNETIC MOMENTS
C=======================================================================
C
      DO LAMBDA=0,NMOMAG
         DO MIU=-LAMBDA,LAMBDA
C
            AMOMUL(LAMBDA,MIU)=AMOMUL(LAMBDA,MIU)
     *                                      +REAL(SMOMUL(LAMBDA,MIU))
            AMOMUT(LAMBDA,MIU)=AMOMUT(LAMBDA,MIU)+SMOMUL(LAMBDA,MIU)
C
         END DO
      END DO
C
C=======================================================================
C
    2 CONTINUE
C
C=======================================================================
      DEALLOCATE (ELESPI,ELEORB)
C=======================================================================
C
      CALL CPUTIM('MAGMOM',0)
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE INTSPI(ELESPI,LAMBDA,MIU,IMAREA)
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      COMPLEX
     *          C_ZERO,ELESPI
C
      DIMENSION
     *          ELESPI(1:NDBASE,1:NDBASE)
C
      COMMON
     *       /BASISO/ NXVECT(1:NDBASE),NYVECT(1:NDBASE),NZVECT(1:NDBASE)
      COMMON
     *       /DIMENS/ LDBASE
      COMMON
     *       /DATYLM/ COEYLM(0:NDMULT,0:NDMULT),
     *
     *                NREYLM(0:NDMULT,0:NDMULT),
     *                KREYLM(0:NDMULT,0:NDMULT,1:NDTERM,0:NDKART),
     *
     *                NIMYLM(0:NDMULT,1:NDMULT),
     *                KIMYLM(0:NDMULT,1:NDMULT,1:NDTERM,0:NDKART)
      COMMON
     *       /COEMUL/ COMULT(0:NDMULT,0:NDOSCI,0:NDOSCI,1:NDKART)
      COMMON
     *       /T_PHAS/ IPHAPP(0:NDYMAX,0:NDYMAX,0:NDKART),
     *                IPHAPM(0:NDYMAX,0:NDYMAX,0:NDKART),
     *                IPHAMP(0:NDYMAX,0:NDYMAX,0:NDKART),
     *                IPHAMM(0:NDYMAX,0:NDYMAX,0:NDKART)
      COMMON
     *       /MAGUNI/ AUNITS(0:NDMULT,0:NDMULT)
C
C=======================================================================
C
      CALL CPUTIM('INTSPI',1)
C
C=======================================================================
C      THIS SUBROUTINE CALCULATES MATRIX ELEMENTS OF  THE SPIN  PART  OF
C      THE MAGNETIC MOMENT OPERATOR
C
C      SEE PHYSICAL REVIEW C 62 (2000) 014310,  EQ. (46B)
C
C      IMAREA = 1 (-1) REQUESTS CALCULATION OF THE REAL (IMAGINARY) PART
C=======================================================================
C
      C_ZERO=CMPLX(0.0D0,0.0D0)
C
      ELESPI(:,:)=C_ZERO
C
      NIU=ABS(MIU)
C
      IF (MIU.GE.0) THEN
          JPHASE=IMAREA
      ELSE
          JPHASE=(-1)**MIU
      END IF
C
C=======================================================================
C       MATRIX ELEMENTS OF THE REAL SPIN PART
C=======================================================================
C
      IF (IMAREA.EQ.1) THEN
C
          DO NUTERM=1,NREYLM(LAMBDA,NIU)
C
             DO IKET=1,LDBASE
C
                NX_KET=NXVECT(IKET)
                NY_KET=NYVECT(IKET)
                NZ_KET=NZVECT(IKET)
C
                DO IBRA=1,LDBASE
C
                   NX_BRA=NXVECT(IBRA)
                   NY_BRA=NYVECT(IBRA)
                   NZ_BRA=NZVECT(IBRA)
C
                   IF (KREYLM(LAMBDA,NIU,NUTERM,1).NE.0)
     *                 ELESPI(IBRA,IKET) = ELESPI(IBRA,IKET)
     *               + KREYLM(LAMBDA,NIU,NUTERM,0)
     *               * KREYLM(LAMBDA,NIU,NUTERM,1)
     *               * COMULT(KREYLM(LAMBDA,NIU,NUTERM,1)-1
     *                                     ,NX_BRA,NX_KET,1)
     *               * COMULT(KREYLM(LAMBDA,NIU,NUTERM,2)
     *                                     ,NY_BRA,NY_KET,2)
     *               * COMULT(KREYLM(LAMBDA,NIU,NUTERM,3)
     *                                     ,NZ_BRA,NZ_KET,3)
     *               * IPHAPM(NY_BRA,NY_KET,1)
     *               * CMPLX(1.0D0,0.0D0)
C
                   IF (KREYLM(LAMBDA,NIU,NUTERM,2).NE.0)
     *                 ELESPI(IBRA,IKET) = ELESPI(IBRA,IKET)
     *               + KREYLM(LAMBDA,NIU,NUTERM,0)
     *               * KREYLM(LAMBDA,NIU,NUTERM,2)
     *               * COMULT(KREYLM(LAMBDA,NIU,NUTERM,1)
     *                                     ,NX_BRA,NX_KET,1)
     *               * COMULT(KREYLM(LAMBDA,NIU,NUTERM,2)-1
     *                                     ,NY_BRA,NY_KET,2)
     *               * COMULT(KREYLM(LAMBDA,NIU,NUTERM,3)
     *                                     ,NZ_BRA,NZ_KET,3)
     *               * IPHAPM(NY_BRA,NY_KET,2)
     *               * CMPLX(1.0D0,0.0D0)
C
                   IF (KREYLM(LAMBDA,NIU,NUTERM,3).NE.0)
     *                 ELESPI(IBRA,IKET) = ELESPI(IBRA,IKET)
     *               + KREYLM(LAMBDA,NIU,NUTERM,0)
     *               * KREYLM(LAMBDA,NIU,NUTERM,3)
     *               * COMULT(KREYLM(LAMBDA,NIU,NUTERM,1)
     *                                     ,NX_BRA,NX_KET,1)
     *               * COMULT(KREYLM(LAMBDA,NIU,NUTERM,2)
     *                                     ,NY_BRA,NY_KET,2)
     *               * COMULT(KREYLM(LAMBDA,NIU,NUTERM,3)-1
     *                                     ,NZ_BRA,NZ_KET,3)
     *               * IPHAPM(NY_BRA,NY_KET,3)
     *               * CMPLX(0.0D0,1.0D0)
C
                END DO
             END DO
C
          END DO
C
      END IF
C
C=======================================================================
C       MATRIX ELEMENTS OF THE IMAGINARY SPIN PART
C=======================================================================
C
      IF (IMAREA.EQ.-1) THEN
C
          DO NUTERM=1,NIMYLM(LAMBDA,NIU)
C
             DO IKET=1,LDBASE
C
                NX_KET=NXVECT(IKET)
                NY_KET=NYVECT(IKET)
                NZ_KET=NZVECT(IKET)
C
                DO IBRA=1,LDBASE
C
                   NX_BRA=NXVECT(IBRA)
                   NY_BRA=NYVECT(IBRA)
                   NZ_BRA=NZVECT(IBRA)
C
                   IF (KIMYLM(LAMBDA,NIU,NUTERM,1).NE.0)
     *                 ELESPI(IBRA,IKET) = ELESPI(IBRA,IKET)
     *               + KIMYLM(LAMBDA,NIU,NUTERM,0)
     *               * KIMYLM(LAMBDA,NIU,NUTERM,1)
     *               * COMULT(KIMYLM(LAMBDA,NIU,NUTERM,1)-1
     *                                     ,NX_BRA,NX_KET,1)
     *               * COMULT(KIMYLM(LAMBDA,NIU,NUTERM,2)
     *                                     ,NY_BRA,NY_KET,2)
     *               * COMULT(KIMYLM(LAMBDA,NIU,NUTERM,3)
     *                                     ,NZ_BRA,NZ_KET,3)
     *               * IPHAPP(NY_BRA,NY_KET,1)
     *               * CMPLX(0.0D0,1.0D0)
C
                   IF (KIMYLM(LAMBDA,NIU,NUTERM,2).NE.0)
     *                 ELESPI(IBRA,IKET) = ELESPI(IBRA,IKET)
     *               + KIMYLM(LAMBDA,NIU,NUTERM,0)
     *               * KIMYLM(LAMBDA,NIU,NUTERM,2)
     *               * COMULT(KIMYLM(LAMBDA,NIU,NUTERM,1)
     *                                     ,NX_BRA,NX_KET,1)
     *               * COMULT(KIMYLM(LAMBDA,NIU,NUTERM,2)-1
     *                                     ,NY_BRA,NY_KET,2)
     *               * COMULT(KIMYLM(LAMBDA,NIU,NUTERM,3)
     *                                     ,NZ_BRA,NZ_KET,3)
     *               * IPHAPP(NY_BRA,NY_KET,2)
     *               * CMPLX(0.0D0,1.0D0)
C
                   IF (KIMYLM(LAMBDA,NIU,NUTERM,3).NE.0)
     *                 ELESPI(IBRA,IKET) = ELESPI(IBRA,IKET)
     *               + KIMYLM(LAMBDA,NIU,NUTERM,0)
     *               * KIMYLM(LAMBDA,NIU,NUTERM,3)
     *               * COMULT(KIMYLM(LAMBDA,NIU,NUTERM,1)
     *                                     ,NX_BRA,NX_KET,1)
     *               * COMULT(KIMYLM(LAMBDA,NIU,NUTERM,2)
     *                                     ,NY_BRA,NY_KET,2)
     *               * COMULT(KIMYLM(LAMBDA,NIU,NUTERM,3)-1
     *                                     ,NZ_BRA,NZ_KET,3)
     *               * IPHAPP(NY_BRA,NY_KET,3)
     *               * CMPLX(-1.0D0,0.0D0)
C
                END DO
             END DO
C
          END DO
C
      END IF
C
C=======================================================================
C       NORMALIZATION FACTOR AND PHASE
C=======================================================================
C
      DO IKET=1,LDBASE
         DO IBRA=1,LDBASE
C
            ELESPI(IBRA,IKET)=ELESPI(IBRA,IKET)
     *                       *COEYLM(LAMBDA,NIU)*JPHASE*0.5D0
C
         END DO
      END DO
C
C=======================================================================
C        FOLLOWS MULTIPLICATION BY THE UNITS DEFINED ONCE FOR ALL IN THE
C        SUBROUTINE "DEFUNI".  THE  SAME  UNITS ARE IMPLIED FOR POSITIVE
C        AND NEGATIVE VALUES OF "MIU".
C=======================================================================
C
      DO IKET=1,LDBASE
         DO IBRA=1,LDBASE
            ELESPI(IBRA,IKET)=ELESPI(IBRA,IKET)*AUNITS(LAMBDA,NIU)
         END DO
      END DO
C
C=======================================================================
C
      CALL CPUTIM('INTSPI',0)
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE INTORB(ELEORB,LAMBDA,MIU,IMAREA)
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      DIMENSION
     *          ELEORB(1:NDBASE,1:NDBASE)
C
      COMMON
     *       /BASISO/ NXVECT(1:NDBASE),NYVECT(1:NDBASE),NZVECT(1:NDBASE)
      COMMON
     *       /DIMENS/ LDBASE
      COMMON
     *       /DATYLM/ COEYLM(0:NDMULT,0:NDMULT),
     *
     *                NREYLM(0:NDMULT,0:NDMULT),
     *                KREYLM(0:NDMULT,0:NDMULT,1:NDTERM,0:NDKART),
     *
     *                NIMYLM(0:NDMULT,1:NDMULT),
     *                KIMYLM(0:NDMULT,1:NDMULT,1:NDTERM,0:NDKART)
      COMMON
     *       /COEMUL/ COMULT(0:NDMULT,0:NDOSCI,0:NDOSCI,1:NDKART)
      COMMON
     *       /COEMAG/ COGRAD(0:NDMULT,0:NDOSCI,0:NDOSCI,1:NDKART)
      COMMON
     *       /T_PHAS/ IPHAPP(0:NDYMAX,0:NDYMAX,0:NDKART),
     *                IPHAPM(0:NDYMAX,0:NDYMAX,0:NDKART),
     *                IPHAMP(0:NDYMAX,0:NDYMAX,0:NDKART),
     *                IPHAMM(0:NDYMAX,0:NDYMAX,0:NDKART)
      COMMON
     *       /MAGUNI/ AUNITS(0:NDMULT,0:NDMULT)
C
C=======================================================================
C
      CALL CPUTIM('INTORB',1)
C
C=======================================================================
C      THIS SUBROUTINE CALCULATES MATRIX ELEMENTS OF THE ORBITAL PART OF
C      THE MAGNETIC MOMENT OPERATOR
C
C      SEE PHYSICAL REVIEW C 62 (2000) 014310,  EQ. (46B)
C
C      IMAREA = 1 (-1) REQUESTS CALCULATION OF THE REAL (IMAGINARY) PART
C=======================================================================
C
      ELEORB(:,:)=0.0D0
C
      NIU=ABS(MIU)
C
      IF (MIU.GE.0) THEN
          JPHASE=IMAREA
      ELSE
          JPHASE=(-1)**MIU
      END IF
C
C=======================================================================
C       MATRIX ELEMENTS OF THE REAL ORBITAL PART
C=======================================================================
C
      IF (IMAREA.EQ.1) THEN
C
          DO NUTERM=1,NREYLM(LAMBDA,NIU)
C
             DO IKET=1,LDBASE
C
                NX_KET=NXVECT(IKET)
                NY_KET=NYVECT(IKET)
                NZ_KET=NZVECT(IKET)
C
                DO IBRA=1,LDBASE
C
                   NX_BRA=NXVECT(IBRA)
                   NY_BRA=NYVECT(IBRA)
                   NZ_BRA=NZVECT(IBRA)
C
                   IF (KREYLM(LAMBDA,NIU,NUTERM,1).NE.0)
     *
     *                 ELEORB(IBRA,IKET) = ELEORB(IBRA,IKET)
     *
     *               + KREYLM(LAMBDA,NIU,NUTERM,0)
     *
     *               * KREYLM(LAMBDA,NIU,NUTERM,1)
     *               * COMULT(KREYLM(LAMBDA,NIU,NUTERM,1)-1
     *                                     ,NX_BRA,NX_KET,1)
     *               * COMULT(KREYLM(LAMBDA,NIU,NUTERM,2)+1
     *                                     ,NY_BRA,NY_KET,2)
     *               * COGRAD(KREYLM(LAMBDA,NIU,NUTERM,3)
     *                                     ,NZ_BRA,NZ_KET,3)
C
                   IF (KREYLM(LAMBDA,NIU,NUTERM,1).NE.0)
     *
     *                 ELEORB(IBRA,IKET) = ELEORB(IBRA,IKET)
     *
     *               - KREYLM(LAMBDA,NIU,NUTERM,0)
     *
     *               * KREYLM(LAMBDA,NIU,NUTERM,1)
     *               * COMULT(KREYLM(LAMBDA,NIU,NUTERM,1)-1
     *                                     ,NX_BRA,NX_KET,1)
     *               * COGRAD(KREYLM(LAMBDA,NIU,NUTERM,2)
     *                                     ,NY_BRA,NY_KET,2)
     *               * COMULT(KREYLM(LAMBDA,NIU,NUTERM,3)+1
     *                                     ,NZ_BRA,NZ_KET,3)
C
                   IF (KREYLM(LAMBDA,NIU,NUTERM,2).NE.0)
     *
     *                 ELEORB(IBRA,IKET) = ELEORB(IBRA,IKET)
     *
     *               + KREYLM(LAMBDA,NIU,NUTERM,0)
     *
     *               * KREYLM(LAMBDA,NIU,NUTERM,2)
     *               * COGRAD(KREYLM(LAMBDA,NIU,NUTERM,1)
     *                                     ,NX_BRA,NX_KET,1)
     *               * COMULT(KREYLM(LAMBDA,NIU,NUTERM,2)-1
     *                                     ,NY_BRA,NY_KET,2)
     *               * COMULT(KREYLM(LAMBDA,NIU,NUTERM,3)+1
     *                                     ,NZ_BRA,NZ_KET,3)
C
                   IF (KREYLM(LAMBDA,NIU,NUTERM,2).NE.0)
     *
     *                 ELEORB(IBRA,IKET) = ELEORB(IBRA,IKET)
     *
     *               - KREYLM(LAMBDA,NIU,NUTERM,0)
     *
     *               * KREYLM(LAMBDA,NIU,NUTERM,2)
     *               * COMULT(KREYLM(LAMBDA,NIU,NUTERM,1)+1
     *                                     ,NX_BRA,NX_KET,1)
     *               * COMULT(KREYLM(LAMBDA,NIU,NUTERM,2)-1
     *                                     ,NY_BRA,NY_KET,2)
     *               * COGRAD(KREYLM(LAMBDA,NIU,NUTERM,3)
     *                                     ,NZ_BRA,NZ_KET,3)
C
                   IF (KREYLM(LAMBDA,NIU,NUTERM,3).NE.0)
     *
     *                 ELEORB(IBRA,IKET) = ELEORB(IBRA,IKET)
     *
     *               + KREYLM(LAMBDA,NIU,NUTERM,0)
     *
     *               * KREYLM(LAMBDA,NIU,NUTERM,3)
     *               * COMULT(KREYLM(LAMBDA,NIU,NUTERM,1)+1
     *                                     ,NX_BRA,NX_KET,1)
     *               * COGRAD(KREYLM(LAMBDA,NIU,NUTERM,2)
     *                                     ,NY_BRA,NY_KET,2)
     *               * COMULT(KREYLM(LAMBDA,NIU,NUTERM,3)-1
     *                                     ,NZ_BRA,NZ_KET,3)
C
                   IF (KREYLM(LAMBDA,NIU,NUTERM,3).NE.0)
     *
     *                 ELEORB(IBRA,IKET) = ELEORB(IBRA,IKET)
     *
     *               - KREYLM(LAMBDA,NIU,NUTERM,0)
     *
     *               * KREYLM(LAMBDA,NIU,NUTERM,3)
     *               * COGRAD(KREYLM(LAMBDA,NIU,NUTERM,1)
     *                                     ,NX_BRA,NX_KET,1)
     *               * COMULT(KREYLM(LAMBDA,NIU,NUTERM,2)+1
     *                                     ,NY_BRA,NY_KET,2)
     *               * COMULT(KREYLM(LAMBDA,NIU,NUTERM,3)-1
     *                                     ,NZ_BRA,NZ_KET,3)
C
                END DO
             END DO
          END DO
C
C=======================================================================
C       NORMALIZATION AND PHASE FOR THE REAL ORBITAL PART
C=======================================================================
C
          DO IKET=1,LDBASE
             DO IBRA=1,LDBASE
C
                ELEORB(IBRA,IKET)=ELEORB(IBRA,IKET)*(-1.0D0)
     *                           *COEYLM(LAMBDA,NIU)*JPHASE
     *                           *IPHAPM(NYVECT(IBRA),NYVECT(IKET),0)
     *                           *2.0D0/(LAMBDA+1)
C
             END DO
          END DO
C
      END IF
C
C=======================================================================
C       MATRIX ELEMENTS OF THE IMAGINARY ORBITAL PART
C=======================================================================
C
      IF (IMAREA.EQ.-1) THEN
C
          DO NUTERM=1,NIMYLM(LAMBDA,NIU)
C
             DO IKET=1,LDBASE
C
                NX_KET=NXVECT(IKET)
                NY_KET=NYVECT(IKET)
                NZ_KET=NZVECT(IKET)
C
                DO IBRA=1,LDBASE
C
                   NX_BRA=NXVECT(IBRA)
                   NY_BRA=NYVECT(IBRA)
                   NZ_BRA=NZVECT(IBRA)
C
                   IF (KIMYLM(LAMBDA,NIU,NUTERM,1).NE.0)
     *
     *                 ELEORB(IBRA,IKET) = ELEORB(IBRA,IKET)
     *
     *               + KIMYLM(LAMBDA,NIU,NUTERM,0)
     *
     *               * KIMYLM(LAMBDA,NIU,NUTERM,1)
     *               * COMULT(KIMYLM(LAMBDA,NIU,NUTERM,1)-1
     *                                     ,NX_BRA,NX_KET,1)
     *               * COMULT(KIMYLM(LAMBDA,NIU,NUTERM,2)+1
     *                                     ,NY_BRA,NY_KET,2)
     *               * COGRAD(KIMYLM(LAMBDA,NIU,NUTERM,3)
     *                                     ,NZ_BRA,NZ_KET,3)
C
                   IF (KIMYLM(LAMBDA,NIU,NUTERM,1).NE.0)
     *
     *                 ELEORB(IBRA,IKET) = ELEORB(IBRA,IKET)
     *
     *               - KIMYLM(LAMBDA,NIU,NUTERM,0)
     *
     *               * KIMYLM(LAMBDA,NIU,NUTERM,1)
     *               * COMULT(KIMYLM(LAMBDA,NIU,NUTERM,1)-1
     *                                     ,NX_BRA,NX_KET,1)
     *               * COGRAD(KIMYLM(LAMBDA,NIU,NUTERM,2)
     *                                     ,NY_BRA,NY_KET,2)
     *               * COMULT(KIMYLM(LAMBDA,NIU,NUTERM,3)+1
     *                                     ,NZ_BRA,NZ_KET,3)
C
                   IF (KIMYLM(LAMBDA,NIU,NUTERM,2).NE.0)
     *
     *                 ELEORB(IBRA,IKET) = ELEORB(IBRA,IKET)
     *
     *               + KIMYLM(LAMBDA,NIU,NUTERM,0)
     *
     *               * KIMYLM(LAMBDA,NIU,NUTERM,2)
     *               * COGRAD(KIMYLM(LAMBDA,NIU,NUTERM,1)
     *                                     ,NX_BRA,NX_KET,1)
     *               * COMULT(KIMYLM(LAMBDA,NIU,NUTERM,2)-1
     *                                     ,NY_BRA,NY_KET,2)
     *               * COMULT(KIMYLM(LAMBDA,NIU,NUTERM,3)+1
     *                                     ,NZ_BRA,NZ_KET,3)
C
                   IF (KIMYLM(LAMBDA,NIU,NUTERM,2).NE.0)
     *
     *                 ELEORB(IBRA,IKET) = ELEORB(IBRA,IKET)
     *
     *               - KIMYLM(LAMBDA,NIU,NUTERM,0)
     *
     *               * KIMYLM(LAMBDA,NIU,NUTERM,2)
     *               * COMULT(KIMYLM(LAMBDA,NIU,NUTERM,1)+1
     *                                     ,NX_BRA,NX_KET,1)
     *               * COMULT(KIMYLM(LAMBDA,NIU,NUTERM,2)-1
     *                                     ,NY_BRA,NY_KET,2)
     *               * COGRAD(KIMYLM(LAMBDA,NIU,NUTERM,3)
     *                                     ,NZ_BRA,NZ_KET,3)
C
                   IF (KIMYLM(LAMBDA,NIU,NUTERM,3).NE.0)
     *
     *                 ELEORB(IBRA,IKET) = ELEORB(IBRA,IKET)
     *
     *               + KIMYLM(LAMBDA,NIU,NUTERM,0)
     *
     *               * KIMYLM(LAMBDA,NIU,NUTERM,3)
     *               * COMULT(KIMYLM(LAMBDA,NIU,NUTERM,1)+1
     *                                     ,NX_BRA,NX_KET,1)
     *               * COGRAD(KIMYLM(LAMBDA,NIU,NUTERM,2)
     *                                     ,NY_BRA,NY_KET,2)
     *               * COMULT(KIMYLM(LAMBDA,NIU,NUTERM,3)-1
     *                                     ,NZ_BRA,NZ_KET,3)
C
                   IF (KIMYLM(LAMBDA,NIU,NUTERM,3).NE.0)
     *
     *                 ELEORB(IBRA,IKET) = ELEORB(IBRA,IKET)
     *
     *               - KIMYLM(LAMBDA,NIU,NUTERM,0)
     *
     *               * KIMYLM(LAMBDA,NIU,NUTERM,3)
     *               * COGRAD(KIMYLM(LAMBDA,NIU,NUTERM,1)
     *                                     ,NX_BRA,NX_KET,1)
     *               * COMULT(KIMYLM(LAMBDA,NIU,NUTERM,2)+1
     *                                     ,NY_BRA,NY_KET,2)
     *               * COMULT(KIMYLM(LAMBDA,NIU,NUTERM,3)-1
     *                                     ,NZ_BRA,NZ_KET,3)
C
                END DO
             END DO
          END DO
C
C=======================================================================
C       NORMALIZATION AND PHASE FOR THE IMAGINARY ORBITAL PART
C=======================================================================
C
          DO IKET=1,LDBASE
             DO IBRA=1,LDBASE
C
                ELEORB(IBRA,IKET)=ELEORB(IBRA,IKET)
     *                           *COEYLM(LAMBDA,NIU)*JPHASE
     *                           *IPHAPP(NYVECT(IBRA),NYVECT(IKET),0)
     *                           *2.0D0/(LAMBDA+1)
C
             END DO
          END DO
C
      END IF
C
C=======================================================================
C        FOLLOWS MULTIPLICATION BY THE UNITS DEFINED ONCE FOR ALL IN THE
C        SUBROUTINE "DEFUNI".  THE  SAME  UNITS ARE IMPLIED FOR POSITIVE
C        AND NEGATIVE VALUES OF "MIU".
C=======================================================================
C
      DO IKET=1,LDBASE
         DO IBRA=1,LDBASE
            ELEORB(IBRA,IKET)=ELEORB(IBRA,IKET)*AUNITS(LAMBDA,NIU)
         END DO
      END DO
C
C=======================================================================
C
      CALL CPUTIM('INTORB',0)
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE COMASS(ISIMPY,ISIGNY,ISIQTY,QMOMUL,KMULMO,ISHIFT)
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      DIMENSION
     *          QMOMUL(0:NDMULT,-NDMULT:NDMULT)
C
      COMMON
     *       /SHIFTR/ RSHIFT(1:NDKART)
C
C=======================================================================
C        THIS SUBROUTINE CALCULATES THE CENTER-OF-MASS COORDINATES
C        IN FERMIS.
C=======================================================================
C
      ISHIFT=0
C
      RSHIFT(1)=0.0D0
      RSHIFT(2)=0.0D0
      RSHIFT(3)=0.0D0
C
      IF ((ISIMPY.NE.1.OR.ISIGNY.NE.1).AND.ISIQTY.NE.1.AND.
     *     ABS(QMOMUL(0,0)).GT.1.D-10) THEN
C
          ISHIFT=1
C
          IF (KMULMO.LT.1) STOP 'KMULMO<1 IN COMASS'
C
          IF (ISIMPY.NE.1) THEN
C
              RSHIFT(2)=-QMOMUL(1,-1)*10/QMOMUL(0,0)
C
          END IF
C
          IF (ISIGNY.NE.1) THEN
C
              RSHIFT(1)= QMOMUL(1, 1)*10/QMOMUL(0,0)
              RSHIFT(3)= QMOMUL(1, 0)*10/QMOMUL(0,0)
C
          END IF
C
      END IF
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE SHICOE(KMULAC,KSHIAC,ISHIFT)
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      DIMENSION
     *          TEMPOR(0:NDMULT,0:NDMULT,1:NDKART)
C
      COMMON
     *       /NEWBIN/ IBINOM(0:NDMULT,0:NDMULT)
      COMMON
     *       /INTGAU/ GAUINT(0:2*NDMULT),
     *                GAUMUL(0:NDMULT)
      COMMON
     *       /MOMTRA/ TRAMOM(0:NDMULT,-NDMULT:NDMULT,
     *                       0:NDMULT,-NDMULT:NDMULT)
      COMMON
     *       /DATYLM/ COEYLM(0:NDMULT,0:NDMULT),
     *
     *                NREYLM(0:NDMULT,0:NDMULT),
     *                KREYLM(0:NDMULT,0:NDMULT,1:NDTERM,0:NDKART),
     *
     *                NIMYLM(0:NDMULT,1:NDMULT),
     *                KIMYLM(0:NDMULT,1:NDMULT,1:NDTERM,0:NDKART)
      COMMON
     *       /SHIFTR/ RSHIFT(1:NDKART)
C
C=======================================================================
C
      CALL CPUTIM('SHICOE',1)
C
C=======================================================================
C        THIS  SUBROUTINE  CALCULATES  THE  TRANSFORMATION  COEFFICIENTS
C                              T_LM^{L'M'}
C        FOR THE MULTIPOLE  MOMENTS  TO  BE  EXPRESSED  IN  THE  SHIFTED
C        REFERENCE FRAME:
C
C        SOLID_LM(R-R0)=SUM_{L'=O,L;M'=-L',L'}T_LM^{L'M'}SOLID_{L'M'}(R)
C
C        WHERE SOLID_LM ARE THE SOLID HARMONICS (AS DEFINED IN "DEFYLM")
C        NOTE THAT  THESE  SOLID  HARMONICS   D O   N O T   CONTAIN  THE
C        UNITS DEFINED IN "DEFUNI". THESE UNITS HAVE  TO  BE  EXPLICITLY
C        SUPPLIED WHEN TRANSFORMING THE MULTIPOLE  OR  SURFACE  MOMENTS.
C=======================================================================
C
      IF (KSHIAC.GT.KMULAC) STOP 'KSHIAC>KMULAC IN SHICOE'
C
C=======================================================================
C         ZEROING "TRAMOM"
C=======================================================================
C
      DO LAMBD1=0,NDMULT
         DO MIU1=-LAMBD1,LAMBD1
C
            DO LAMBD2=0,NDMULT
               DO MIU2=-LAMBD2,LAMBD2
C
                  TRAMOM(LAMBD1,MIU1,LAMBD2,MIU2)=0.0D0
C
               END DO
            END DO
C
         END DO
      END DO
C
C=======================================================================
C         DEFINING "TRAMOM" IN THE CASE OF NO SHIFT (ISHIFT=0)
C=======================================================================
C
      IF (ISHIFT.EQ.0) THEN
C
          DO LAMBD1=0,KSHIAC
             DO MIU1=-LAMBD1,LAMBD1
C
                TRAMOM(LAMBD1,MIU1,LAMBD1,MIU1)=1.0D0
C
             END DO
          END DO
C
          GO TO 2
C
      END IF
C
C=======================================================================
C         CALCULATING AUXILIARY  ARRAY "TEMPOR" THAT DEPENDS ON THE
C         VECTOR RSHIFT DEFINING THE SHIFTED REFERENCE FRAME.  THIS
C         IS DONE ONLY TO SPEED UP THE CALCULATIONS OF SUMS  BELOW.
C=======================================================================
C
      DO KARTEZ=1,NDKART
C
         DO LAMBD1=0,KSHIAC
C
            DO LAMBD2=0,KSHIAC
C
               TEMPOR(LAMBD1,LAMBD2,KARTEZ)=0.0D0
C
               DO LAMBDA=0,LAMBD1
C
                  RESAUX=IBINOM(LAMBD1,LAMBDA)*GAUINT(LAMBD2+LAMBDA)
                  IF (LAMBD1-LAMBDA.NE.0)
     *            RESAUX=RESAUX*(-RSHIFT(KARTEZ))**(LAMBD1-LAMBDA)
C
                  TEMPOR(LAMBD1,LAMBD2,KARTEZ)=
     *            TEMPOR(LAMBD1,LAMBD2,KARTEZ)+RESAUX
C
               END DO
C
            END DO
C
         END DO
C
      END DO
C
C=======================================================================
C         CALCULATING ELEMENTS OF "TRAMOM" FOR NON-NEGATIVE MAGNETIC
C         INDICES (MIU1>=0 AND MIU2>=0).
C=======================================================================
C
      DO LAMBD1=0,KSHIAC
         DO MIU1=0,LAMBD1
C
            DO LAMBD2=0,LAMBD1
               DO MIU2=0,LAMBD2
C
                  TRAMOM(LAMBD1,MIU1,LAMBD2,MIU2)=0.0D0
C
                  DO NUTER1=1,NREYLM(LAMBD1,MIU1)
                     DO NUTER2=1,NREYLM(LAMBD2,MIU2)
C
                        TRAMOM(LAMBD1,MIU1,LAMBD2,MIU2)=
     *                  TRAMOM(LAMBD1,MIU1,LAMBD2,MIU2)+
     *                  KREYLM(LAMBD1,MIU1,NUTER1,0)*
     *                  KREYLM(LAMBD2,MIU2,NUTER2,0)*
     *                  TEMPOR(KREYLM(LAMBD1,MIU1,NUTER1,1),
     *                         KREYLM(LAMBD2,MIU2,NUTER2,1),1)*
     *                  TEMPOR(KREYLM(LAMBD1,MIU1,NUTER1,2),
     *                         KREYLM(LAMBD2,MIU2,NUTER2,2),2)*
     *                  TEMPOR(KREYLM(LAMBD1,MIU1,NUTER1,3),
     *                         KREYLM(LAMBD2,MIU2,NUTER2,3),3)
C
                     END DO
                  END DO
C
                  TRAMOM(LAMBD1,MIU1,LAMBD2,MIU2)=
     *            TRAMOM(LAMBD1,MIU1,LAMBD2,MIU2)*
     *            COEYLM(LAMBD1,MIU1)*COEYLM(LAMBD2,MIU2)/
     *            GAUMUL(LAMBD2)
C
                  IF (MIU2.NE.0) TRAMOM(LAMBD1,MIU1,LAMBD2,MIU2)=
     *                           TRAMOM(LAMBD1,MIU1,LAMBD2,MIU2)*2.0D0
C
               END DO
            END DO
C
         END DO
      END DO
C
C=======================================================================
C         CALCULATING ELEMENTS OF "TRAMOM" FOR MIXED-SIGN MAGNETIC
C         INDICES (MIU1>=0 AND MIU2<0).
C=======================================================================
C
      DO LAMBD1=1,KSHIAC
         DO MIU1=0,LAMBD1
C
            DO LAMBD2=1,LAMBD1
               DO MIU2=-LAMBD2,-1
C
                  TRAMOM(LAMBD1,MIU1,LAMBD2,MIU2)=0.0D0
C
                  DO NUTER1=1,NREYLM(LAMBD1,MIU1)
                     DO NUTER2=1,NIMYLM(LAMBD2,-MIU2)
C
                        TRAMOM(LAMBD1, MIU1,LAMBD2,MIU2)=
     *                  TRAMOM(LAMBD1, MIU1,LAMBD2,MIU2)+
     *                  KREYLM(LAMBD1, MIU1,NUTER1,0)*
     *                  KIMYLM(LAMBD2,-MIU2,NUTER2,0)*
     *                  TEMPOR(KREYLM(LAMBD1, MIU1,NUTER1,1),
     *                         KIMYLM(LAMBD2,-MIU2,NUTER2,1),1)*
     *                  TEMPOR(KREYLM(LAMBD1, MIU1,NUTER1,2),
     *                         KIMYLM(LAMBD2,-MIU2,NUTER2,2),2)*
     *                  TEMPOR(KREYLM(LAMBD1, MIU1,NUTER1,3),
     *                         KIMYLM(LAMBD2,-MIU2,NUTER2,3),3)
C
                     END DO
                  END DO
C
                  TRAMOM(LAMBD1,MIU1,LAMBD2,MIU2)=
     *            TRAMOM(LAMBD1,MIU1,LAMBD2,MIU2)*
     *            COEYLM(LAMBD1,MIU1)*COEYLM(LAMBD2,-MIU2)/
     *            GAUMUL(LAMBD2)
C
                  TRAMOM(LAMBD1,MIU1,LAMBD2,MIU2)=
     *            TRAMOM(LAMBD1,MIU1,LAMBD2,MIU2)*2.0D0*(-1)**MIU2
C
               END DO
            END DO
C
         END DO
      END DO
C
C=======================================================================
C         CALCULATING ELEMENTS OF "TRAMOM" FOR MIXED-SIGN MAGNETIC
C         INDICES (MIU1<0 AND MIU2>=0).
C=======================================================================
C
      DO LAMBD1=1,KSHIAC
         DO MIU1=-LAMBD1,-1
C
            DO LAMBD2=0,LAMBD1
               DO MIU2=0,LAMBD2
C
                  TRAMOM(LAMBD1,MIU1,LAMBD2,MIU2)=0.0D0
C
                  DO NUTER1=1,NIMYLM(LAMBD1,-MIU1)
                     DO NUTER2=1,NREYLM(LAMBD2,MIU2)
C
                        TRAMOM(LAMBD1, MIU1,LAMBD2,MIU2)=
     *                  TRAMOM(LAMBD1, MIU1,LAMBD2,MIU2)+
     *                  KIMYLM(LAMBD1,-MIU1,NUTER1,0)*
     *                  KREYLM(LAMBD2, MIU2,NUTER2,0)*
     *                  TEMPOR(KIMYLM(LAMBD1,-MIU1,NUTER1,1),
     *                         KREYLM(LAMBD2, MIU2,NUTER2,1),1)*
     *                  TEMPOR(KIMYLM(LAMBD1,-MIU1,NUTER1,2),
     *                         KREYLM(LAMBD2, MIU2,NUTER2,2),2)*
     *                  TEMPOR(KIMYLM(LAMBD1,-MIU1,NUTER1,3),
     *                         KREYLM(LAMBD2, MIU2,NUTER2,3),3)
C
                     END DO
                  END DO
C
                  TRAMOM(LAMBD1, MIU1,LAMBD2,MIU2)=
     *            TRAMOM(LAMBD1, MIU1,LAMBD2,MIU2)*
     *            COEYLM(LAMBD1,-MIU1)*COEYLM(LAMBD2,MIU2)/
     *            GAUMUL(LAMBD2)
C
                  IF (MIU2.NE.0) TRAMOM(LAMBD1,MIU1,LAMBD2,MIU2)=
     *                           TRAMOM(LAMBD1,MIU1,LAMBD2,MIU2)*2.0D0
C
                  TRAMOM(LAMBD1,MIU1,LAMBD2,MIU2)=
     *            TRAMOM(LAMBD1,MIU1,LAMBD2,MIU2)*(-1)**MIU1
C
               END DO
            END DO
C
         END DO
      END DO
C
C=======================================================================
C         CALCULATING ELEMENTS OF "TRAMOM" FOR NEGATIVE MAGNETIC
C         INDICES (MIU1<0 AND MIU2<0).
C=======================================================================
C
      DO LAMBD1=1,KSHIAC
         DO MIU1=-LAMBD1,-1
C
            DO LAMBD2=1,LAMBD1
               DO MIU2=-LAMBD2,-1
C
                  TRAMOM(LAMBD1,MIU1,LAMBD2,MIU2)=0.0D0
C
                  DO NUTER1=1,NIMYLM(LAMBD1,-MIU1)
                     DO NUTER2=1,NIMYLM(LAMBD2,-MIU2)
C
                        TRAMOM(LAMBD1, MIU1,LAMBD2,MIU2)=
     *                  TRAMOM(LAMBD1, MIU1,LAMBD2,MIU2)+
     *                  KIMYLM(LAMBD1,-MIU1,NUTER1,0)*
     *                  KIMYLM(LAMBD2,-MIU2,NUTER2,0)*
     *                  TEMPOR(KIMYLM(LAMBD1,-MIU1,NUTER1,1),
     *                         KIMYLM(LAMBD2,-MIU2,NUTER2,1),1)*
     *                  TEMPOR(KIMYLM(LAMBD1,-MIU1,NUTER1,2),
     *                         KIMYLM(LAMBD2,-MIU2,NUTER2,2),2)*
     *                  TEMPOR(KIMYLM(LAMBD1,-MIU1,NUTER1,3),
     *                         KIMYLM(LAMBD2,-MIU2,NUTER2,3),3)
C
                     END DO
                  END DO
C
                  TRAMOM(LAMBD1,MIU1,LAMBD2,MIU2)=
     *            TRAMOM(LAMBD1,MIU1,LAMBD2,MIU2)*
     *            COEYLM(LAMBD1,-MIU1)*COEYLM(LAMBD2,-MIU2)/
     *            GAUMUL(LAMBD2)
C
                  TRAMOM(LAMBD1,MIU1,LAMBD2,MIU2)=
     *            TRAMOM(LAMBD1,MIU1,LAMBD2,MIU2)*2.D0*(-1)**(MIU1+MIU2)
C
               END DO
            END DO
C
         END DO
      END DO
C
C=======================================================================
C
    2 CONTINUE
C
C=======================================================================
C
      CALL CPUTIM('SHICOE',0)
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE SHIMOM(KMULMO,KSHIMO,ISHIFT)
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      DIMENSION
     *          QAUX_N(0:NDMULT,-NDMULT:NDMULT),
     *          QAUX_P(0:NDMULT,-NDMULT:NDMULT),
     *          QAUX_T(0:NDMULT,-NDMULT:NDMULT)
C
      COMMON
     *       /MOMTRA/ TRAMOM(0:NDMULT,-NDMULT:NDMULT,
     *                       0:NDMULT,-NDMULT:NDMULT)
      COMMON
     *       /QMULTI/ QMUL_N(0:NDMULT,-NDMULT:NDMULT),
     *                QMUL_P(0:NDMULT,-NDMULT:NDMULT),
     *                QMUL_T(0:NDMULT,-NDMULT:NDMULT)
      COMMON
     *       /QSHIFT/ QSHI_N(0:NDMULT,-NDMULT:NDMULT),
     *                QSHI_P(0:NDMULT,-NDMULT:NDMULT),
     *                QSHI_T(0:NDMULT,-NDMULT:NDMULT)
      COMMON
     *       /OURUNI/ QUNITS(0:NDMULT,0:NDMULT)
C
C=======================================================================
C
      CALL CPUTIM('SHIMOM',1)
C
C=======================================================================
C         THIS SUBROUTINE CALCULATES THE MULTIPOLE  MOMENTS  IN  THE
C         SHIFTED REFERENCE FRAME
C=======================================================================
C         IT IS ASSUMED THAT THE  ARRAY "TRAMOM" HAS BEEN PREVIOUSLY
C         CALCULATED BY THE SUBROUTINE "SHICOE" UP TO "KSHIMO"
C=======================================================================
C
      IF (KSHIMO.GT.KMULMO) STOP 'KSHIMO>KMULMO IN SHIMOM'
C
C=======================================================================
C
      DO LAMBDA=0,NDMULT
         DO MIU=-LAMBDA,LAMBDA
C
            QSHI_N(LAMBDA,MIU)=0.0D0
            QSHI_P(LAMBDA,MIU)=0.0D0
            QSHI_T(LAMBDA,MIU)=0.0D0
C
         END DO
      END DO
C
      IF (ISHIFT.EQ.0) THEN
C
          DO LAMBDA=0,KSHIMO
             DO MIU=-LAMBDA,LAMBDA
C
                QSHI_N(LAMBDA,MIU)=QMUL_N(LAMBDA,MIU)
                QSHI_P(LAMBDA,MIU)=QMUL_P(LAMBDA,MIU)
                QSHI_T(LAMBDA,MIU)=QMUL_T(LAMBDA,MIU)
C
             END DO
          END DO
C
      END IF
C
      IF (ISHIFT.EQ.0.OR.KSHIMO.EQ.0) GO TO 2
C
C=======================================================================
C         REMOVING THE UNITS FROM THE ORIGINAL MULTIPOLE MOMENTS
C=======================================================================
C
      DO LAMBDA=0,KSHIMO
         DO MIU=-LAMBDA,LAMBDA
C
            NIU=ABS(MIU)
C
            QAUX_N(LAMBDA,MIU)=QMUL_N(LAMBDA,MIU)/QUNITS(LAMBDA,NIU)
            QAUX_P(LAMBDA,MIU)=QMUL_P(LAMBDA,MIU)/QUNITS(LAMBDA,NIU)
            QAUX_T(LAMBDA,MIU)=QMUL_T(LAMBDA,MIU)/QUNITS(LAMBDA,NIU)
C
         END DO
      END DO
C
C=======================================================================
C         TRANSFORMING THE ORIGINAL MULTIPOLE MOMENTS INTO THE SHIFTED
C         MULTIPOLE MOMENTS.
C=======================================================================
C
      DO LAMBD1=0,KSHIMO
         DO MIU1=-LAMBD1,LAMBD1
C
            QSHI_N(LAMBD1,MIU1)=0.0D0
            QSHI_P(LAMBD1,MIU1)=0.0D0
            QSHI_T(LAMBD1,MIU1)=0.0D0
C
            DO LAMBD2=0,LAMBD1
               DO MIU2=-LAMBD2,LAMBD2
C
                  QSHI_N(LAMBD1,MIU1)=QSHI_N(LAMBD1,MIU1)
     *                               +TRAMOM(LAMBD1,MIU1,LAMBD2,MIU2)
     *                               *QAUX_N(LAMBD2,MIU2)
C
                  QSHI_P(LAMBD1,MIU1)=QSHI_P(LAMBD1,MIU1)
     *                               +TRAMOM(LAMBD1,MIU1,LAMBD2,MIU2)
     *                               *QAUX_P(LAMBD2,MIU2)
C
                  QSHI_T(LAMBD1,MIU1)=QSHI_T(LAMBD1,MIU1)
     *                               +TRAMOM(LAMBD1,MIU1,LAMBD2,MIU2)
     *                               *QAUX_T(LAMBD2,MIU2)
C
               END DO
            END DO
C
         END DO
      END DO
C
C=======================================================================
C         ADDING THE UNITS TO THE TRANSFORMED MULTIPOLE MOMENTS
C=======================================================================
C
      DO LAMBDA=0,KSHIMO
         DO MIU=-LAMBDA,LAMBDA
C
            NIU=ABS(MIU)
C
            QSHI_N(LAMBDA,MIU)=QSHI_N(LAMBDA,MIU)*QUNITS(LAMBDA,NIU)
            QSHI_P(LAMBDA,MIU)=QSHI_P(LAMBDA,MIU)*QUNITS(LAMBDA,NIU)
            QSHI_T(LAMBDA,MIU)=QSHI_T(LAMBDA,MIU)*QUNITS(LAMBDA,NIU)
C
         END DO
      END DO
C
C=======================================================================
C
    2 CONTINUE
C
C=======================================================================
C
      CALL CPUTIM('SHIMOM',0)
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE SHISIF(KMULSI,KSHISI,ISHIFT)
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      DIMENSION
     *          QAUX_N(0:NDMULT,-NDMULT:NDMULT),
     *          QAUX_P(0:NDMULT,-NDMULT:NDMULT),
     *          QAUX_T(0:NDMULT,-NDMULT:NDMULT)
      DIMENSION
     *          SAUX_N(0:NDMULT,-NDMULT:NDMULT),
     *          SAUX_P(0:NDMULT,-NDMULT:NDMULT),
     *          SAUX_T(0:NDMULT,-NDMULT:NDMULT)
      DIMENSION
     *          VAUX_N(0:NDMULT,-NDMULT:NDMULT,1:NDKART),
     *          VAUX_P(0:NDMULT,-NDMULT:NDMULT,1:NDKART),
     *          VAUX_T(0:NDMULT,-NDMULT:NDMULT,1:NDKART)
C
      COMMON
     *       /MOMTRA/ TRAMOM(0:NDMULT,-NDMULT:NDMULT,
     *                       0:NDMULT,-NDMULT:NDMULT)
      COMMON
     *       /QMULTI/ QMUL_N(0:NDMULT,-NDMULT:NDMULT),
     *                QMUL_P(0:NDMULT,-NDMULT:NDMULT),
     *                QMUL_T(0:NDMULT,-NDMULT:NDMULT)
      COMMON
     *       /SMULTI/ SMUL_N(0:NDMULT,-NDMULT:NDMULT),
     *                SMUL_P(0:NDMULT,-NDMULT:NDMULT),
     *                SMUL_T(0:NDMULT,-NDMULT:NDMULT)
      COMMON
     *       /VMULTI/ VMUL_N(0:NDMULT,-NDMULT:NDMULT,1:NDKART),
     *                VMUL_P(0:NDMULT,-NDMULT:NDMULT,1:NDKART),
     *                VMUL_T(0:NDMULT,-NDMULT:NDMULT,1:NDKART)
      COMMON
     *       /SSHIFT/ SSHI_N(0:NDMULT,-NDMULT:NDMULT),
     *                SSHI_P(0:NDMULT,-NDMULT:NDMULT),
     *                SSHI_T(0:NDMULT,-NDMULT:NDMULT)
      COMMON
     *       /OURUNI/ QUNITS(0:NDMULT,0:NDMULT)
      COMMON
     *       /SIFUNI/ SUNITS(0:NDMULT,0:NDMULT)
      COMMON
     *       /VMUUNI/ VUNITS(0:NDMULT,0:NDMULT)
      COMMON
     *       /SHIFTR/ RSHIFT(1:NDKART)
C
C=======================================================================
C
      CALL CPUTIM('SHISIF',1)
C
C=======================================================================
C         THIS SUBROUTINE CALCULATES THE SURFACE MOMENTS IN THE SHIFTED
C         REFERENCE FRAME
C=======================================================================
C         IT IS ASSUMED THAT THE  ARRAY "TRAMOM" HAS  BEEN  PREVIOUSLY
C         CALCULATED BY THE SUBROUTINE "SHICOE" UP TO "KSHISI"
C=======================================================================
C
      IF (KSHISI.GT.KMULSI) STOP 'KSHISI>KMULSI IN SHISIF'
C
C=======================================================================
C
      DO LAMBDA=0,NDMULT
         DO MIU=-LAMBDA,LAMBDA
C
            SSHI_N(LAMBDA,MIU)=0.0D0
            SSHI_P(LAMBDA,MIU)=0.0D0
            SSHI_T(LAMBDA,MIU)=0.0D0
C
         END DO
      END DO
C
      IF (ISHIFT.EQ.0) THEN
C
          DO LAMBDA=0,KMULSI
             DO MIU=-LAMBDA,LAMBDA
C
                SSHI_N(LAMBDA,MIU)=SMUL_N(LAMBDA,MIU)
                SSHI_P(LAMBDA,MIU)=SMUL_P(LAMBDA,MIU)
                SSHI_T(LAMBDA,MIU)=SMUL_T(LAMBDA,MIU)
C
             END DO
          END DO
C
      END IF
C
      IF (ISHIFT.EQ.0.OR.KMULSI.EQ.0) GO TO 2
C
C=======================================================================
C         REMOVING UNITS FROM THE ORIGINAL MULTIPOLE, SURFACE, AND
C         VECTOR MOMENTS
C=======================================================================
C
      DO LAMBDA=0,KMULSI
         DO MIU=-LAMBDA,LAMBDA
C
            NIU=ABS(MIU)
C
            QAUX_N(LAMBDA,MIU  )=QMUL_N(LAMBDA,MIU  )/QUNITS(LAMBDA,NIU)
            QAUX_P(LAMBDA,MIU  )=QMUL_P(LAMBDA,MIU  )/QUNITS(LAMBDA,NIU)
            QAUX_T(LAMBDA,MIU  )=QMUL_T(LAMBDA,MIU  )/QUNITS(LAMBDA,NIU)
C
            SAUX_N(LAMBDA,MIU  )=SMUL_N(LAMBDA,MIU  )/SUNITS(LAMBDA,NIU)
            SAUX_P(LAMBDA,MIU  )=SMUL_P(LAMBDA,MIU  )/SUNITS(LAMBDA,NIU)
            SAUX_T(LAMBDA,MIU  )=SMUL_T(LAMBDA,MIU  )/SUNITS(LAMBDA,NIU)
C
            VAUX_N(LAMBDA,MIU,1)=VMUL_N(LAMBDA,MIU,1)/VUNITS(LAMBDA,NIU)
            VAUX_P(LAMBDA,MIU,1)=VMUL_P(LAMBDA,MIU,1)/VUNITS(LAMBDA,NIU)
            VAUX_T(LAMBDA,MIU,1)=VMUL_T(LAMBDA,MIU,1)/VUNITS(LAMBDA,NIU)
C
            VAUX_N(LAMBDA,MIU,2)=VMUL_N(LAMBDA,MIU,2)/VUNITS(LAMBDA,NIU)
            VAUX_P(LAMBDA,MIU,2)=VMUL_P(LAMBDA,MIU,2)/VUNITS(LAMBDA,NIU)
            VAUX_T(LAMBDA,MIU,2)=VMUL_T(LAMBDA,MIU,2)/VUNITS(LAMBDA,NIU)
C
            VAUX_N(LAMBDA,MIU,3)=VMUL_N(LAMBDA,MIU,3)/VUNITS(LAMBDA,NIU)
            VAUX_P(LAMBDA,MIU,3)=VMUL_P(LAMBDA,MIU,3)/VUNITS(LAMBDA,NIU)
            VAUX_T(LAMBDA,MIU,3)=VMUL_T(LAMBDA,MIU,3)/VUNITS(LAMBDA,NIU)
C
         END DO
      END DO
C
C=======================================================================
C         TRANSFORMING THE ORIGINAL SURFACE MOMENTS INTO THE SHIFTED
C         SURFACE MOMENTS.
C=======================================================================
C
      TSHIFT=RSHIFT(1)**2+RSHIFT(2)**2+RSHIFT(3)**2
C
      DO LAMBD1=0,KMULSI
         DO MIU1=-LAMBD1,LAMBD1
C
            SSHI_N(LAMBD1,MIU1)=0.0D0
            SSHI_P(LAMBD1,MIU1)=0.0D0
            SSHI_T(LAMBD1,MIU1)=0.0D0
C
            DO LAMBD2=0,LAMBD1
               DO MIU2=-LAMBD2,LAMBD2
C
                  SSHI_N(LAMBD1,MIU1)=SSHI_N(LAMBD1,MIU1)
     *                              +(SAUX_N(LAMBD2,MIU2)
     *                             -2*VAUX_N(LAMBD2,MIU2,1)*RSHIFT(1)
     *                             -2*VAUX_N(LAMBD2,MIU2,2)*RSHIFT(2)
     *                             -2*VAUX_N(LAMBD2,MIU2,3)*RSHIFT(3)
     *                               +QAUX_N(LAMBD2,MIU2  )*TSHIFT  )
     *                               *TRAMOM(LAMBD1,MIU1,LAMBD2,MIU2)
C
                  SSHI_P(LAMBD1,MIU1)=SSHI_P(LAMBD1,MIU1)
     *                              +(SAUX_P(LAMBD2,MIU2)
     *                             -2*VAUX_P(LAMBD2,MIU2,1)*RSHIFT(1)
     *                             -2*VAUX_P(LAMBD2,MIU2,2)*RSHIFT(2)
     *                             -2*VAUX_P(LAMBD2,MIU2,3)*RSHIFT(3)
     *                               +QAUX_P(LAMBD2,MIU2  )*TSHIFT  )
     *                               *TRAMOM(LAMBD1,MIU1,LAMBD2,MIU2)
C
                  SSHI_T(LAMBD1,MIU1)=SSHI_T(LAMBD1,MIU1)
     *                              +(SAUX_T(LAMBD2,MIU2)
     *                             -2*VAUX_T(LAMBD2,MIU2,1)*RSHIFT(1)
     *                             -2*VAUX_T(LAMBD2,MIU2,2)*RSHIFT(2)
     *                             -2*VAUX_T(LAMBD2,MIU2,3)*RSHIFT(3)
     *                               +QAUX_T(LAMBD2,MIU2  )*TSHIFT  )
     *                               *TRAMOM(LAMBD1,MIU1,LAMBD2,MIU2)
C
               END DO
            END DO
C
         END DO
      END DO
C
C=======================================================================
C         ADDING THE UNITS TO THE SHIFTED SURFACE MOMENTS
C=======================================================================
C
      DO LAMBDA=0,KMULSI
         DO MIU=-LAMBDA,LAMBDA
C
            NIU=ABS(MIU)
C
            SSHI_N(LAMBDA,MIU)=SSHI_N(LAMBDA,MIU)*SUNITS(LAMBDA,NIU)
            SSHI_P(LAMBDA,MIU)=SSHI_P(LAMBDA,MIU)*SUNITS(LAMBDA,NIU)
            SSHI_T(LAMBDA,MIU)=SSHI_T(LAMBDA,MIU)*SUNITS(LAMBDA,NIU)
C
         END DO
      END DO
C
C=======================================================================
C
    2 CONTINUE
C
C=======================================================================
C
      CALL CPUTIM('SHISIF',0)
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE SHIMAG(KMULMA,KSHIMA,ISHIFT,NOSHIM)
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      COMMON
     *       /AMULTI/ AMUL_N(0:NDMULT,-NDMULT:NDMULT),
     *                AMUL_P(0:NDMULT,-NDMULT:NDMULT),
     *                AMUL_T(0:NDMULT,-NDMULT:NDMULT)
      COMMON
     *       /ASHIFT/ ASHI_N(0:NDMULT,-NDMULT:NDMULT),
     *                ASHI_P(0:NDMULT,-NDMULT:NDMULT),
     *                ASHI_T(0:NDMULT,-NDMULT:NDMULT)
C
C=======================================================================
C
      CALL CPUTIM('SHIMAG',1)
C
C=======================================================================
C         THIS SUBROUTINE SHOULD CALCULATE THE MAGNETIC MOMENTS IN THE
C         SHIFTED REFERENCE FRAME. FOR THE MOMENT THIS PROBLEM IS NOT
C         SOLVED AND THE SHIFTED MOMENTS ARE ASSUMED EQUAL TO THE
C         NON-SHIFTED ONES. THIS IS GOVERNED BY SWITCH "NOSHIM".
C=======================================================================
C
      IF (KSHIMA.GT.KMULMA) STOP 'KSHIMA>KMULMA IN SHIMAG'
C
C=======================================================================
C
      DO LAMBDA=0,NDMULT
         DO MIU=-LAMBDA,LAMBDA
C
            ASHI_N(LAMBDA,MIU)=0.0D0
            ASHI_P(LAMBDA,MIU)=0.0D0
            ASHI_T(LAMBDA,MIU)=0.0D0
C
         END DO
      END DO
C
      IF (ISHIFT.EQ.0.OR.NOSHIM.EQ.1) THEN
C
          DO LAMBDA=0,KSHIMA
             DO MIU=-LAMBDA,LAMBDA
C
                ASHI_N(LAMBDA,MIU)=AMUL_N(LAMBDA,MIU)
                ASHI_P(LAMBDA,MIU)=AMUL_P(LAMBDA,MIU)
                ASHI_T(LAMBDA,MIU)=AMUL_T(LAMBDA,MIU)
C
             END DO
          END DO
C
      END IF
C
      IF (ISHIFT.EQ.0.OR.KMULMA.EQ.0.OR.NOSHIM.EQ.1) GO TO 2
C
C=======================================================================
C
      STOP 'UNEXPECTED CONDITION IN SHIMAG'
C
C=======================================================================
C
    2 CONTINUE
C
C=======================================================================
C
      CALL CPUTIM('SHIMAG',0)
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE EULROT(KSHIMO,KROTMO)
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      DIMENSION
     *          QUAAUX(-2:2)
      DIMENSION
     *          QUAMOM(1:NDKART,1:NDKART),
     *          ROTMAT(1:NDKART,1:NDKART),
     *          VECTOR(1:NDKART,1:NDKART)
      DIMENSION
     *          SPEQUA(1:NDKART)
      DIMENSION
     *          CELMTS(1:((NDKART+1)*NDKART)/2)
C
      COMPLEX
     *          CELMTS,VECTOR
C
      COMMON
     *       /QSHIFT/ QSHI_N(0:NDMULT,-NDMULT:NDMULT),
     *                QSHI_P(0:NDMULT,-NDMULT:NDMULT),
     *                QSHI_T(0:NDMULT,-NDMULT:NDMULT)
      COMMON
     *       /OURUNI/ QUNITS(0:NDMULT,0:NDMULT)
      COMMON
     *       /EANGLE/ ALPEUL,BETEUL,GAMEUL
C
C=======================================================================
C        THIS ROUTINE FINDS THE EULER ANGLES OF THE PRINCIPAL-AXES-FRAME
C        BY USING THE DIAGONALIZATION OF THE CARTESIAN QUADRUPOLE MOMENT
C=======================================================================
C
      PI=4.0D0*ATAN(1.0D0)
C
      SQRT_6=SQRT(6.0D0)
C
      ALPEUL=0.0D0
      BETEUL=0.0D0
      GAMEUL=0.0D0
C
C=======================================================================
C
      IF (KROTMO.EQ.0) GO TO 2
      IF (KSHIMO.LT.2) STOP 'KSHIMO<2 IN EULROT'
C
      DO MIU=-2,2
         QUAAUX(MIU)=QSHI_T(2,MIU)/QUNITS(2,ABS(MIU))
      END DO
C
C=======================================================================
C        CONSTRUCTING THE CARTESIAN MATRIX OF THE QUADRUPOLE MOMENT
C        SEE VARSHALOVICH EQ. 2.6.1(8)
C=======================================================================
C
      QUAMOM(1,1)= QUAAUX( 2)-QUAAUX(0)/SQRT_6
      QUAMOM(1,2)=-QUAAUX(-2)
      QUAMOM(1,3)=-QUAAUX( 1)
C
      QUAMOM(2,2)=-QUAAUX( 2)-QUAAUX(0)/SQRT_6
      QUAMOM(2,3)=-QUAAUX(-1)
C
      QUAMOM(3,3)= QUAAUX( 0)*2/SQRT_6
C
C=======================================================================
C        CONSTRUCTING THE CARTESIAN MATRIX OF THE COMPLEX CONJUGATE OF
C        THE QUADRUPOLE MOMENT, WHICH TRANSFORMS UNDER ROTATIONS AS  A
C        COVARIANT TENSOR,  SEE VARSHALOVICH EQ. 5.5.1(1), BECAUSE OUR
C        QUADRUPOLE MOMENT CORRESPONDS TO A COMPLEX CONJUGATE  OF  THE
C        SPHERICAL HARMONICS, SEE COMMNTS IN SUBROUTINES "MOMETS"  AND
C        "PAXMOM".
C=======================================================================
C        ATTENTION: THIS TRANSFROMATION WAS MISSING IN VERSIONS UP  TO
C                   2.15B, AND THIS BUG HAS BEEN CORRECTED IN  VERSION
C                   2.15C ON 18/03/05.
C=======================================================================
C
      QUAMOM(1,2)=-QUAMOM(1,2)
      QUAMOM(2,3)=-QUAMOM(2,3)
C
C=======================================================================
C        SYMMETRIZING THE CARTESIAN MATRIX OF THE QUADRUPOLE MOMENT
C=======================================================================
C
      QUAMOM(2,1)=QUAMOM(1,2)
C
      QUAMOM(3,1)=QUAMOM(1,3)
      QUAMOM(3,2)=QUAMOM(2,3)
C
C=======================================================================
C        CALLING THE DIAGONALIZATION ROUTINE.  ARRAYS  "CELMTS"  AND
C        "VECTOR" MUST BE DECLARED COMPLEX, EVEN THOUGH THEY CONTAIN
C        REAL NUMBERS.
C=======================================================================
C
      NCOUNT=0
C
      DO KARKET=1,NDKART
         DO KARBRA=KARKET,NDKART
C
            NCOUNT=NCOUNT+1
C
            CELMTS(NCOUNT)=QUAMOM(KARBRA,KARKET)
C
         END DO
      END DO
C
      LDKART=NDKART
C
      CALL DIAMAT(CELMTS,SPEQUA,VECTOR,LDKART,NDKART,LDKART)
C
C=======================================================================
C        CALCULATING THE ROTATION MATRIX THAT IS EQUAL TO THE MATRIX  OF
C        THE EIGENVECTORS, SEE NOTES 7.54B. NOTE  THAT  THE EIGENVECTORS
C        NOS. 1 AND 2 (X AND Y) HAVE TO BE EXCHANGED  IN ORDER TO OBTAIN
C        THE EULER ANGLES FOR THE INTRINSIC SYSTEM IN THE  FIRST  SECTOR
C        OF THE BOHR_GAMMA ANGLES, 0<=BOHR_GAMMA<=60, I.E.,
C        <Q_YY>.LE.<Q_XX>.LE.<Q_ZZ>    OR     <Y**2>.LE.<X**2>.LE.<Z**2>
C=======================================================================
C
      DO KARBRA=1,NDKART
C
         ROTMAT(KARBRA,2)=REAL(VECTOR(KARBRA,1))
         ROTMAT(KARBRA,1)=REAL(VECTOR(KARBRA,2))
         ROTMAT(KARBRA,3)=REAL(VECTOR(KARBRA,3))
C
      END DO
C
C=======================================================================
C        CHANGING THE PHASES OF COLS NO. 2 AND 3 OF THE ROTATION  MATRIX
C        (I.E., THE PHASES OF EIGENVECTORS OF QUADRUPOLE MOMENT) IN SUCH
C        A WAY THAT THE ELEMENTS IN THE LAST ROW ARE NON-NEGATIVE.  THIS
C        CORRESPONDS TO SELECTING THE EULER ANGLES:
C        0<=BETA<=PI/2 AND 0<=GAMMA<=PI
C=======================================================================
C
      DO KARKET=2,NDKART
C
         IF (ROTMAT(3,KARKET).LT.0) THEN
C
             FACTOR=-1
         ELSE
             FACTOR= 1
C
         END IF
C
         DO KARBRA=1,NDKART
C
            ROTMAT(KARBRA,KARKET)=FACTOR*ROTMAT(KARBRA,KARKET)
C
         END DO
C
      END DO
C
C=======================================================================
C        CHANGING THE PHASE OF COLUMN NO. 1 OF THE  ROTATION  MATRIX  IN
C        SUCH A WAY THAT THE MATRIX HAS A POSITIVE DETERMINANT
C=======================================================================
C
      DETMAT=ROTMAT(1,1)*ROTMAT(2,2)*ROTMAT(3,3)
     *      +ROTMAT(1,2)*ROTMAT(2,3)*ROTMAT(3,1)
     *      +ROTMAT(1,3)*ROTMAT(2,1)*ROTMAT(3,2)
     *      -ROTMAT(1,1)*ROTMAT(2,3)*ROTMAT(3,2)
     *      -ROTMAT(1,2)*ROTMAT(2,1)*ROTMAT(3,3)
     *      -ROTMAT(1,3)*ROTMAT(2,2)*ROTMAT(3,1)
C
      IF (DETMAT.LT.0) THEN
C
          FACTOR=-1
      ELSE
          FACTOR= 1
C
      END IF
C
      KARKET=1
C
      DO KARBRA=1,NDKART
C
         ROTMAT(KARBRA,KARKET)=FACTOR*ROTMAT(KARBRA,KARKET)
C
      END DO
C
C=======================================================================
C        CALCULATING THE EULER ANGLES FROM THE ELEMENTS OF THE  ROTATION
C        MATRIX, SEE VARSHALOVICH EQ. 1.4.6(54) AND NOTES 7.54B.
C=======================================================================
C        IN ORDER TO INCREASE PRECISION, BELOW ALWAYS THE SMALLER MATRIX
C        ELEMENTS ARE USED TO DETERMINE ANGLES. THIS IS SO BECAUSE  WHEN
C        THE ABSOLUTE VALUE OF COS(ANGL) IS SMALLER THEN SIN(ANGL)  THAN
C        THE ACOS GIVES A MORE PRECISE ANGL THAN ASIN, AND VICE VERSA.
C=======================================================================
C
C=======================================================================
C        DETERMINING BETEUL
C=======================================================================
C
      ROTHEL=SQRT(ROTMAT(1,3)**2+ROTMAT(2,3)**2)
C
      IF (ABS(ROTMAT(3,3)).LT.ROTHEL) THEN
C
          COSBET=ROTMAT(3,3)
C
          IF (COSBET.GT. 1.0D0) STOP ' TOO LARGE COSBET IN EULROT'
          IF (COSBET.LT. 0.0D0) STOP ' TOO SMALL COSBET IN EULROT'
C
          BETEUL=ACOS(COSBET)
C
          SINBET=SIN(BETEUL)
C
      ELSE
C
          SINBET=ROTHEL
C
          IF (SINBET.GT. 1.0D0) STOP ' TOO LARGE SINBET IN EULROT'
          IF (SINBET.LT. 0.0D0) STOP ' TOO SMALL SINBET IN EULROT'
C
          BETEUL=ASIN(SINBET)
C
      END IF
C
      SINLIM=1.0D-8
C
      IF (SINBET.LT.SINLIM) THEN
C
C=======================================================================
C        HERE WE DEAL WITH THE SITUATION OF VANISHING ANGLE  BETA.  THEN
C        ONLY THE SUM ALPHA+GAMMA CAN BE DETERMINED, AND WE  CAN  CHOOSE
C        GAMMA=0. VALUES OF SINBET SMALLER THAN SINLIM ARE CONSIDERD  TO
C        BE EQUAL TO ZERO, BECAUSE WHAT WE NEED THEN IS AN APPROXIMATION
C        OF COS(EULBET) BY 1, WHICH IS VERY GOOD UP TO SINLIM**2.
C=======================================================================
C
          GAMEUL=0.0D0
C
C=======================================================================
C        DETERMINING ALPEUL
C=======================================================================
C
          IF (ABS(ROTMAT(1,1)).LT.ABS(ROTMAT(2,1))) THEN
C
              COSALP= ROTMAT(1,1)
C
              IF (COSALP.GT. 1.0D0) STOP ' TOO LARGE COSALP IN EULROT'
              IF (COSALP.LT.-1.0D0) STOP ' TOO SMALL COSALP IN EULROT'
C
              ALPEUL=ACOS(COSALP)
C
              IF (ROTMAT(2,1).LT.0.0D0) ALPEUL=2*PI-ALPEUL
C
          ELSE
C
              SINALP= ROTMAT(2,1)
C
              IF (SINALP.GT. 1.0D0) STOP ' TOO LARGE SINALP IN EULROT'
              IF (SINALP.LT.-1.0D0) STOP ' TOO SMALL SINALP IN EULROT'
C
              ALPEUL=ASIN(SINALP)
C
              IF (ROTMAT(1,1).LT.0.0D0) ALPEUL=PI-ALPEUL
C
          END IF
C
      ELSE
C
C=======================================================================
C        HERE WE DEAL WITH THE SITUATION OF NON-ZERO ANGLE BETA.
C=======================================================================
C
C=======================================================================
C        DETERMINING ALPEUL
C=======================================================================
C
          IF (ABS(ROTMAT(1,3)).LT.ABS(ROTMAT(2,3))) THEN
C
              COSALP= ROTMAT(1,3)/SINBET
C
              IF (COSALP.GT. 1.0D0) STOP ' TOO LARGE COSALP IN EULROT'
              IF (COSALP.LT.-1.0D0) STOP ' TOO SMALL COSALP IN EULROT'
C
              ALPEUL=ACOS(COSALP)
C
              IF (ROTMAT(2,3).LT.0.0D0) ALPEUL=2*PI-ALPEUL
C
          ELSE
C
              SINALP= ROTMAT(2,3)/SINBET
C
              IF (SINALP.GT. 1.0D0) STOP ' TOO LARGE SINALP IN EULROT'
              IF (SINALP.LT.-1.0D0) STOP ' TOO SMALL SINALP IN EULROT'
C
              ALPEUL=ASIN(SINALP)
C
              IF (ROTMAT(1,3).LT.0.0D0) ALPEUL=PI-ALPEUL
C
          END IF
C
C=======================================================================
C        DETERMINING GAMEUL
C=======================================================================
C
          IF (ABS(ROTMAT(3,1)).LT.ABS(ROTMAT(3,2))) THEN
C
              COSGAM=-ROTMAT(3,1)/SINBET
C
              IF (COSGAM.GT. 1.0D0) STOP ' TOO LARGE COSGAM IN EULROT'
              IF (COSGAM.LT.-1.0D0) STOP ' TOO SMALL COSGAM IN EULROT'
C
              GAMEUL=ACOS(COSGAM)
C
          ELSE
C
              SINGAM= ROTMAT(3,2)/SINBET
C
              IF (SINGAM.GT. 1.0D0) STOP ' TOO LARGE SINGAM IN EULROT'
              IF (SINGAM.LT. 0.0D0) STOP ' TOO SMALL SINGAM IN EULROT'
C
              GAMEUL=ASIN(SINGAM)
C
              IF (ROTMAT(3,1).GT.0.0D0) GAMEUL=PI-GAMEUL
C
          END IF
C
      END IF
C
C=======================================================================
C
  2   CONTINUE
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE PAXMOM(KSHIMO,KROTMO,XUNITS,XSHI_N,XSHI_P,XSHI_T,
     *                  ALPACT,BETACT,GAMACT,XROT_N,XROT_P,XROT_T)
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      DIMENSION
     *          XSHI_N(0:NDMULT,-NDMULT:NDMULT),
     *          XSHI_P(0:NDMULT,-NDMULT:NDMULT),
     *          XSHI_T(0:NDMULT,-NDMULT:NDMULT)
      DIMENSION
     *          XROT_N(0:NDMULT,-NDMULT:NDMULT),
     *          XROT_P(0:NDMULT,-NDMULT:NDMULT),
     *          XROT_T(0:NDMULT,-NDMULT:NDMULT)
      DIMENSION
     *          XUNITS(0:NDMULT,0:NDMULT)
      DIMENSION
     *          XAUX_N(0:NDMULT,-NDMULT:NDMULT),
     *          XAUX_P(0:NDMULT,-NDMULT:NDMULT),
     *          XAUX_T(0:NDMULT,-NDMULT:NDMULT)
      DIMENSION
     *          WIGNED(-NDMULT:NDMULT,-NDMULT-1:NDMULT+1)
C
C=======================================================================
C
      CALL CPUTIM('PAXMOM',1)
C
C=======================================================================
C     THIS ROUTINE CALCULATES MULTIPOLE MOMENTS IN A  FRAME  ROTATED  BY
C     THE EULER ANGLES  ALPACT,  BETACT,  AND  GAMACT,  SEE VARSHALOVICH
C     EQ. 5.5.1(1), I.E.,
C        QROT_LM = \SUM_N CONJG[D^L_NM(ALPACT,BETACT,GAMACT)] QSHI_LN
C     NOTE THAT THE SUMMATION RUNS OVER THE FIRST MAGNETIC INDEX OF  THE
C     WIGNER FUNCTION D^L_NM. SINCE THE FIRST INDEX IS  ASSOCIATED  WITH
C     THE FIRST ARGUMENT OF THE WIGNER FUNCTION, THE FIRST  ROTATION  IS
C     BY  ALPACT, THE SECOND BY  BETACT, AND THE THIRD BY  GAMACT.  NOTE
C     ALSO THAT THE WIGNER FUNCTION IS DEFINED WITH MINUS SIGNS  IN  THE
C     EXPONENTS OF THE ROTATION OPERATORS, EQS.  4.3(1)  AND  1.4.5(31).
C     NOTE ALSO THAT THE COMPLEX CONJUGATE WIGNER FUNCTION IS USED. THIS
C     TAKES INTO ACCOUNT THE FACT THAT OUR MULTIPOLE MOMENTS  CORRESPOND
C     TO COMPLEX CONJUGATE SPHERICAL HARMONICS.
C=======================================================================
C     ATTENTION: THE COMPLEX CONJUGATION  OF  THE  WIGNER  FUNCTION  WAS
C                MISSING IN VERSIONS UP TO 2.15B, AND THIS BUG HAS  BEEN
C                CORRECTED IN VERSION 2.15C ON 18/03/05.
C=======================================================================
C
      IF (KROTMO.GT.KSHIMO) STOP 'KROTMO>KSHIMO IN PAXMOM'
C
C=======================================================================
C        COPYING THE INPUT MOMENTS TO AN AUXILIARY  ARRAY. THIS ALLOWS
C        CALLING THIS SUBROUTINE WITH THE SAME ARRAYS  FOR  INPUT  AND
C        AND OUTPUT.
C=======================================================================
C
      DO LAMBDA=0,KSHIMO
         DO MIU=-LAMBDA,LAMBDA
C
            XAUX_N(LAMBDA,MIU)=XSHI_N(LAMBDA,MIU)
            XAUX_P(LAMBDA,MIU)=XSHI_P(LAMBDA,MIU)
            XAUX_T(LAMBDA,MIU)=XSHI_T(LAMBDA,MIU)
C
         END DO
      END DO
C
C=======================================================================
C        ZEROING THE ROTATED MOMENTS
C=======================================================================
C
      DO LAMBDA=0,NDMULT
         DO MIU=-LAMBDA,LAMBDA
C
            XROT_N(LAMBDA,MIU)=0.0D0
            XROT_P(LAMBDA,MIU)=0.0D0
            XROT_T(LAMBDA,MIU)=0.0D0
C
         END DO
      END DO
C
      DO LAMBDA=-NDMULT,NDMULT
         DO MIU=-NDMULT-1,NDMULT+1
            WIGNED(LAMBDA,MIU)=0.0D0
         END DO
      END DO
C
C=======================================================================
C
      IF (KROTMO.EQ.0) GO TO 1
C
      XROT_N(0,0)=XAUX_N(0,0)
      XROT_P(0,0)=XAUX_P(0,0)
      XROT_T(0,0)=XAUX_T(0,0)
C
      DO LAMBDA=1,KROTMO
C
C=======================================================================
C        REMOVING THE UNITS
C=======================================================================
C
         DO MIU=-LAMBDA,LAMBDA
C
            XAUX_N(LAMBDA,MIU)=XAUX_N(LAMBDA,MIU)/
     *                         XUNITS(LAMBDA,ABS(MIU))
            XAUX_P(LAMBDA,MIU)=XAUX_P(LAMBDA,MIU)/
     *                         XUNITS(LAMBDA,ABS(MIU))
            XAUX_T(LAMBDA,MIU)=XAUX_T(LAMBDA,MIU)/
     *                         XUNITS(LAMBDA,ABS(MIU))
         END DO
C
C=======================================================================
C        ROTATING BY ALPACT
C=======================================================================
C        NOTE THAT THE ARRAYS XSHI AND  XROT  CONTAIN  REAL  (IMAGINARY)
C        PARTS OF MULTIPOLE MOMENTS FOR A GIVEN VALUE  OF  THE  MAGNETIC
C        INDEX MIU, FOR NON-NEGATIVE (NEGATIVE) VALUES OF MIU,  SEE  THE
C        CORRESPONDING COMMENTS IN SUBROUTINE "MOMETS".
C=======================================================================
C
         DO MIU=-LAMBDA,LAMBDA
C
            XROT_N(LAMBDA,MIU)=XAUX_N(LAMBDA, MIU)*COS(-MIU*ALPACT)
     *              -(-1)**MIU*XAUX_N(LAMBDA,-MIU)*SIN(-MIU*ALPACT)
            XROT_P(LAMBDA,MIU)=XAUX_P(LAMBDA, MIU)*COS(-MIU*ALPACT)
     *              -(-1)**MIU*XAUX_P(LAMBDA,-MIU)*SIN(-MIU*ALPACT)
            XROT_T(LAMBDA,MIU)=XAUX_T(LAMBDA, MIU)*COS(-MIU*ALPACT)
     *              -(-1)**MIU*XAUX_T(LAMBDA,-MIU)*SIN(-MIU*ALPACT)
         END DO
C
C=======================================================================
C        ROTATING BY BETACT
C=======================================================================
C        NOTE THAT THE SUBROUTINE THAT CALCULATES  THE  WIGNER  FUNCTION
C        IS CALLED WITH THE OPOSITE VALUE OF BETACT. THEREFORE, DE FACTO
C        IT RETURNS THE VALUES OF THE SMALL-D WIGNER FUNCTION  WITH  THE
C        TRANSPOSED MAGNETIC INDICES, SEE VARSHALOVICH EQ. 4.4(1). HENCE
C        THE SUMMATION BELOW IS PERFORMED OVER THE SECOND INDEX  OF  THE
C        WIGNER FUNCTION.
C=======================================================================
C
         CALL SMALLW(LAMBDA,-BETACT,WIGNED)
C
         DO MIURIG=-LAMBDA,-1
C
            XAUX_N(LAMBDA,MIURIG)=0.0
            XAUX_P(LAMBDA,MIURIG)=0.0
            XAUX_T(LAMBDA,MIURIG)=0.0
C
            DO MIUSUM=-LAMBDA,-1
C
               XAUX_N(LAMBDA,MIURIG)=XAUX_N(LAMBDA,MIURIG)
     *        +XROT_N(LAMBDA,MIUSUM)*(WIGNED(MIURIG, MIUSUM)
     *                  -(-1)**MIUSUM*WIGNED(MIURIG,-MIUSUM))
               XAUX_P(LAMBDA,MIURIG)=XAUX_P(LAMBDA,MIURIG)
     *        +XROT_P(LAMBDA,MIUSUM)*(WIGNED(MIURIG, MIUSUM)
     *                  -(-1)**MIUSUM*WIGNED(MIURIG,-MIUSUM))
               XAUX_T(LAMBDA,MIURIG)=XAUX_T(LAMBDA,MIURIG)
     *        +XROT_T(LAMBDA,MIUSUM)*(WIGNED(MIURIG, MIUSUM)
     *                  -(-1)**MIUSUM*WIGNED(MIURIG,-MIUSUM))
            END DO
C
         END DO
C
         DO MIURIG=0,LAMBDA
C
            XAUX_N(LAMBDA,MIURIG)=XROT_N(LAMBDA,0)*WIGNED(MIURIG,0)
            XAUX_P(LAMBDA,MIURIG)=XROT_P(LAMBDA,0)*WIGNED(MIURIG,0)
            XAUX_T(LAMBDA,MIURIG)=XROT_T(LAMBDA,0)*WIGNED(MIURIG,0)
C
            DO MIUSUM=1,LAMBDA
C
               XAUX_N(LAMBDA,MIURIG)=XAUX_N(LAMBDA,MIURIG)
     *        +XROT_N(LAMBDA,MIUSUM)*(WIGNED(MIURIG, MIUSUM)
     *                  +(-1)**MIUSUM*WIGNED(MIURIG,-MIUSUM))
               XAUX_P(LAMBDA,MIURIG)=XAUX_P(LAMBDA,MIURIG)
     *        +XROT_P(LAMBDA,MIUSUM)*(WIGNED(MIURIG, MIUSUM)
     *                  +(-1)**MIUSUM*WIGNED(MIURIG,-MIUSUM))
               XAUX_T(LAMBDA,MIURIG)=XAUX_T(LAMBDA,MIURIG)
     *        +XROT_T(LAMBDA,MIUSUM)*(WIGNED(MIURIG, MIUSUM)
     *                  +(-1)**MIUSUM*WIGNED(MIURIG,-MIUSUM))
            END DO
C
         END DO
C
C=======================================================================
C        ROTATING BY GAMACT
C=======================================================================
C
         DO MIU=-LAMBDA,LAMBDA
C
            XROT_N(LAMBDA,MIU)=XAUX_N(LAMBDA, MIU)*COS(-MIU*GAMACT)
     *              -(-1)**MIU*XAUX_N(LAMBDA,-MIU)*SIN(-MIU*GAMACT)
            XROT_P(LAMBDA,MIU)=XAUX_P(LAMBDA, MIU)*COS(-MIU*GAMACT)
     *              -(-1)**MIU*XAUX_P(LAMBDA,-MIU)*SIN(-MIU*GAMACT)
            XROT_T(LAMBDA,MIU)=XAUX_T(LAMBDA, MIU)*COS(-MIU*GAMACT)
     *              -(-1)**MIU*XAUX_T(LAMBDA,-MIU)*SIN(-MIU*GAMACT)
         END DO
C
C=======================================================================
C        RE-INSERTING THE UNITS
C=======================================================================
C
         DO MIU=-LAMBDA,LAMBDA
C
            XROT_N(LAMBDA,MIU)=XROT_N(LAMBDA,MIU)*
     *                         XUNITS(LAMBDA,ABS(MIU))
            XROT_P(LAMBDA,MIU)=XROT_P(LAMBDA,MIU)*
     *                         XUNITS(LAMBDA,ABS(MIU))
            XROT_T(LAMBDA,MIU)=XROT_T(LAMBDA,MIU)*
     *                         XUNITS(LAMBDA,ABS(MIU))
         END DO
C
      END DO
C
C=======================================================================
C
   1  CONTINUE
C
C=======================================================================
C
      CALL CPUTIM('PAXMOM',0)
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE SMALLW(J_SPIN,BETAWG,WIGNED)
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      DIMENSION
     *          FACTOR(0:NDFACT),SQRAUX(0:NDFACT**2)
      DIMENSION
     *          WIGNED(-NDMULT:NDMULT,-NDMULT-1:NDMULT+1)
      DIMENSION
     *          WIGJJM(-NDMULT:NDMULT)
C
C=======================================================================
C        THIS SUBROUTINE CALCULATES THE SMALL D WIGNER FUNCTIONS
C        OF ANGLE BETAWG GIVEN IN RADIANS.  VARIABLE  J_SPIN  IS
C        EQUAL TO THE UPPER INDEX J OF THE WIGNER  FUNCTION.  WE
C        LIMIT OURSELVES TO INTEGER VALUES OF J_SPIN. THE PHASES
C        CORRESPOND TO THE VARSHALOVICH CONVENTION.
C=======================================================================
C
      IF (J_SPIN.GT.NDMULT) STOP 'J_SPIN>NDMULT IN SMALLW'
C
      FACTOR(0)=1
      FACTOR(1)=1
C
      DO I=2,2*J_SPIN
         FACTOR(I)=I*FACTOR(I-1)
      END DO
C
      SQRAUX(0)=0
C
      DO I=1,NDFACT**2
         SQRAUX(I)=SQRT(REAL(I,KIND=8))
      END DO
C
      COSBO2=+COS(BETAWG/2)
      SINBO2=-SIN(BETAWG/2)
C
      DO MWIGNE=-J_SPIN,+J_SPIN
C
C        COSSIN=COSBO2**(J_SPIN+MWIGNE)
C    *         *SINBO2**(J_SPIN-MWIGNE)
C
         COSSIN=1.0D0
         IF (J_SPIN+MWIGNE.NE.0) COSSIN=COSSIN*COSBO2**(J_SPIN+MWIGNE)
         IF (J_SPIN-MWIGNE.NE.0) COSSIN=COSSIN*SINBO2**(J_SPIN-MWIGNE)
C
         X_NORM=SQRT(FACTOR(J_SPIN+J_SPIN)
     *             /(FACTOR(J_SPIN+MWIGNE)
     *              *FACTOR(J_SPIN-MWIGNE)))
C
         WIGJJM(MWIGNE)=COSSIN*X_NORM
C
      END DO
C
      COSBET=COS(BETAWG)
      SINBET=SIN(BETAWG)
C
      COSBEM=(1.0D0-COSBET)/2
      COSBEP=(1.0D0+COSBET)/2
C
      DO M_RIGH=-J_SPIN,+J_SPIN
C
         WIGNED(J_SPIN,M_RIGH)=WIGJJM(M_RIGH)
C
      END DO
C
      DO M_LEFT=J_SPIN-1,-J_SPIN,-1
C
         CDENOM=+SQRAUX((J_SPIN+M_LEFT+1)*(J_SPIN-M_LEFT))
C
         DO M_RIGH=J_SPIN,-J_SPIN,-1
C
            COEFM1=-SQRAUX((J_SPIN+M_RIGH)*(J_SPIN-M_RIGH+1))
            COEFP1=+SQRAUX((J_SPIN-M_RIGH)*(J_SPIN+M_RIGH+1))
C
            COEF00=+REAL(M_RIGH,KIND=8)
C
            WIGNED(M_LEFT,M_RIGH)=
     *
     *            (COEFM1*COSBEM*WIGNED(M_LEFT+1,M_RIGH-1)
     *            +COEF00*SINBET*WIGNED(M_LEFT+1, M_RIGH )
     *            +COEFP1*COSBEP*WIGNED(M_LEFT+1,M_RIGH+1))/CDENOM
C
         END DO
C
      END DO
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE RMSQUA(RMSPOS,XPARTI)
C=======================================================================
      USE MAT_PP
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      COMPLEX
     *          RESULT
C=======================================================================
      ALLOCATABLE HAMRAD(:,:)
C=======================================================================
      DIMENSION
     *          RMSPOS(0:NDKART)
C
C=======================================================================
      COMMON
     *       /DIMENS/ LDBASE
C
C=======================================================================
C
      IALLOC=0
C
C=======================================================================
      ALLOCATE (HAMRAD(1:NDBASE,1:NDBASE),STAT=IALLOC)
      IF (IALLOC.NE.0) CALL NOALLO('HAMRAD','RMSQUA')
C=======================================================================
C
C=======================================================================
C       THIS SUBROUTINE CALCULATES THE RMS VALUES OF X, Y, Z, AND R.
C=======================================================================
C
      DO KARTEZ=1,NDKART
C
         CALL INTRAD(HAMRAD,KARTEZ)
C
         RESULT=CMPLX(0.0D0,0.0D0)
C
         DO IBRA=1,LDBASE
            DO IKET=1,LDBASE
C
               RESULT=RESULT + HAMRAD(IBRA,IKET)
     *
     *                    * (BIG_PP(IKET,IBRA,0) + BIG_PP(IKET,IBRA,1))
C
            END DO
         END DO
C
         RMSPOS(KARTEZ)=REAL(RESULT)/XPARTI
C
      END DO
C
      RMSPOS(0)=RMSPOS(1)+RMSPOS(2)+RMSPOS(3)
C
      DO KARTEZ=0,NDKART
C
         RMSPOS(KARTEZ)=SQRT(RMSPOS(KARTEZ))
C
      END DO
C
C=======================================================================
      DEALLOCATE (HAMRAD)
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE SHIRMS(KMULMO,ISHIFT)
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      COMMON
     *       /QMULTI/ QMUL_N(0:NDMULT,-NDMULT:NDMULT),
     *                QMUL_P(0:NDMULT,-NDMULT:NDMULT),
     *                QMUL_T(0:NDMULT,-NDMULT:NDMULT)
      COMMON
     *       /RMSRAD/ RADI_N(0:NDKART),
     *                RADI_P(0:NDKART),
     *                RADI_T(0:NDKART)
      COMMON
     *       /RMSSHI/ RSHI_N(0:NDKART),
     *                RSHI_P(0:NDKART),
     *                RSHI_T(0:NDKART)
C
C=======================================================================
C       THIS SUBROUTINE CALCULATES THE RMS VALUES OF X, Y, Z, AND R
C       IN THE CENTER-OF-MAS REFERENCE FRAME
C=======================================================================
C
      IF (KMULMO.LT.1) STOP 'KMULMO<1 IN SHIRMS'
C
C=======================================================================
C
      IF (ISHIFT.EQ.0) THEN
C
          DO KARTEZ=0,NDKART
C
             RSHI_N(KARTEZ)=RADI_N(KARTEZ)
             RSHI_P(KARTEZ)=RADI_P(KARTEZ)
             RSHI_T(KARTEZ)=RADI_T(KARTEZ)
C
          END DO
C
          GO TO 2
C
      END IF
C
C=======================================================================
C
      RSHI_N(0)=0.0D0
      RSHI_P(0)=0.0D0
      RSHI_T(0)=0.0D0
C
      DO KARTEZ=1,NDKART
C
C=======================================================================
C        CALCULATING THE AVERAGE POSITIONS IN THE INITIAL FRAME
C=======================================================================
C
         IF (KARTEZ.EQ.1) MIU= 1
         IF (KARTEZ.EQ.2) MIU=-1
         IF (KARTEZ.EQ.3) MIU= 0
C
         FACTOR=1.0D0
         IF (KARTEZ.EQ.2) FACTOR=-FACTOR
C
         RPOS_N=0.0D0
         RPOS_P=0.0D0
         RPOS_T=0.0D0
C
         IF (ABS(QMUL_N(0,0)).GT.1.D-10)
     *       RPOS_N=FACTOR*QMUL_N(1,MIU)*10/QMUL_N(0,0)
C
         IF (ABS(QMUL_P(0,0)).GT.1.D-10)
     *       RPOS_P=FACTOR*QMUL_P(1,MIU)*10/QMUL_P(0,0)
C
         IF (ABS(QMUL_T(0,0)).GT.1.D-10)
     *       RPOS_T=FACTOR*QMUL_T(1,MIU)*10/QMUL_T(0,0)
C
C=======================================================================
C        CALCULATING THE SQUARES OF AVERAGE POSITIONS IN THE CMS FRAME
C=======================================================================
C
         RSHI_N(KARTEZ)=
     *               RADI_N(KARTEZ)**2-2*RPOS_N*RADI_N(KARTEZ)+RPOS_N**2
         RSHI_P(KARTEZ)=
     *               RADI_P(KARTEZ)**2-2*RPOS_P*RADI_P(KARTEZ)+RPOS_P**2
         RSHI_T(KARTEZ)=
     *               RADI_T(KARTEZ)**2-2*RPOS_T*RADI_T(KARTEZ)+RPOS_T**2
C
C=======================================================================
C        CALCULATING THE SQUARES OF AVERAGE RADII IN THE CMS FRAME
C=======================================================================
C
         RSHI_N(0)=RSHI_N(0)+RSHI_N(KARTEZ)
         RSHI_P(0)=RSHI_P(0)+RSHI_P(KARTEZ)
         RSHI_T(0)=RSHI_T(0)+RSHI_T(KARTEZ)
C
      END DO
C
C=======================================================================
C        CALCULATING THE AVERAGE POSITIONS AND RADII IN THE CMS FRAME
C=======================================================================
C
      DO KARTEZ=0,NDKART
C
         RSHI_N(KARTEZ)=SQRT(RSHI_N(KARTEZ))
         RSHI_P(KARTEZ)=SQRT(RSHI_P(KARTEZ))
         RSHI_T(KARTEZ)=SQRT(RSHI_T(KARTEZ))
C
      END DO
C
C=======================================================================
C
    2 CONTINUE
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE SIGPRI(ICHFLI,IPAFLI,IREFLI,
     *                  ISPFLI,ISHFLI,IFLIPI)
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      CHARACTER
     *          NAMEPN(0:NDISOS)*8,PLUMIN(0:1)*1,
     *          NAMOBS(10)*26,NAMLAR(2)*7
C
      COMMON
     *       /SIGNVA/ NVASIG(0:NDPARI,0:NDREVE,0:NDISOS)
      COMMON
     *       /SIGNPH/ NPPPRP(NDPAHO,0:NDISOS),NPPPRM(NDPAHO,0:NDISOS),
     *                NPPMRP(NDPAHO,0:NDISOS),NPPMRM(NDPAHO,0:NDISOS),
     *                NHPPRP(NDPAHO,0:NDISOS),NHPPRM(NDPAHO,0:NDISOS),
     *                NHPMRP(NDPAHO,0:NDISOS),NHPMRM(NDPAHO,0:NDISOS)
      COMMON
     *       /N_FLIG/ NPFLIG(0:NDPARI,0:NDREVE,0:NDISOS),
     *                NHFLIG(0:NDPARI,0:NDREVE,0:NDISOS),
     *                NOFLIG(0:NDPARI,0:NDREVE,0:NDISOS)
      COMMON
     *       /N_FILG/ NPFILG(0:NDPARI,0:NDREVE,0:NDISOS),
     *                NHFILG(0:NDPARI,0:NDREVE,0:NDISOS),
     *                NOFILG(0:NDPARI,0:NDREVE,0:NDISOS)
      COMMON
     *       /CFIPRI/ NFIPRI
C
      DATA
     *       NAMOBS /'ANGULAR MOMENTUM ALIGNMENT',
     *               ' INTRINSIC SPIN ALIGNMENT ',
     *               '  TOTAL SPIN X-ALIGNMENT  ',
     *               'INTRINSIC SPIN X-ALIGNMENT',
     *               '  TOTAL SPIN Z-ALIGNMENT  ',
     *               'INTRINSIC SPIN Z-ALIGNMENT',
     *               '  TOTAL SPIN O-ALIGNMENT  ',
     *               'INTRINSIC SPIN O-ALIGNMENT',
     *               '  QUADRUPOLE MOMENT Q_20  ',
     *               '  QUADRUPOLE MOMENT Q_22  '/
      DATA
     *       NAMLAR /'SMALLER','LARGER '/
      DATA
     *       NAMEPN /'NEUTRONS','PROTONS '/
      DATA
     *       PLUMIN /'+','-'/
C
C=======================================================================
C       PRINTING THE CONFIGURATION DATA READ FROM THE INPUT
C       FOR THE PARITY/SIGNATURE CASE
C=======================================================================
C
      WRITE(NFIPRI,'(79(1H*),/,                 1H*,77X,1H*,/,
     *                 1H*,2X,''PARITY/SIGNATURE CONFIGURATIONS:'',
     *                                              43X,1H*,/,
     *                                          1H*,77X,1H*,/,
     *                 1H*,11X,''     V A C U U M      '',
     *                         ''  P A R T I C L E S   '',
     *                         ''      H O L E S       '',1H*,/,
     *                 1H*,11X,''     ===========      '',
     *                         ''  =================   '',
     *                         ''      =========       '',1H*,/,
     *                 1H*,11X,'' (++) (+-) (-+) (--)  '',
     *                         '' (++) (+-) (-+) (--)  '',
     *                         '' (++) (+-) (-+) (--)  '',1H*,/,
     *                 1H*,11X,2(21X,'' ''),22X,1H*)')
C
      DO ICHARG=0,NDISOS
C
         ITITLE=0
C
         DO NUPAHO=1,NDPAHO
C
            IF (NPPPRP(NUPAHO,ICHARG).NE.0.OR.
     *          NPPPRM(NUPAHO,ICHARG).NE.0.OR.
     *          NPPMRP(NUPAHO,ICHARG).NE.0.OR.
     *          NPPMRM(NUPAHO,ICHARG).NE.0.OR.
     *          NHPPRP(NUPAHO,ICHARG).NE.0.OR.
     *          NHPPRM(NUPAHO,ICHARG).NE.0.OR.
     *          NHPMRP(NUPAHO,ICHARG).NE.0.OR.
     *          NHPMRM(NUPAHO,ICHARG).NE.0.OR.
     *
     *          ITITLE.EQ.0.AND.NUPAHO.EQ.NDPAHO) THEN
C
                IF (ITITLE.EQ.0) THEN
C
                    WRITE(NFIPRI,'(1H*,2X,A8,'':'',2(4(I4,1X),''  ''),
     *                                          4(I4,1X),''  '',1H*)')
     *
     *                    NAMEPN(ICHARG),
     *                    NVASIG(0,0,   ICHARG),NVASIG(0,1,   ICHARG),
     *                    NVASIG(1,1,   ICHARG),NVASIG(1,0,   ICHARG),
     *                    NPPPRP(NUPAHO,ICHARG),NPPPRM(NUPAHO,ICHARG),
     *                    NPPMRM(NUPAHO,ICHARG),NPPMRP(NUPAHO,ICHARG),
     *                    NHPPRP(NUPAHO,ICHARG),NHPPRM(NUPAHO,ICHARG),
     *                    NHPMRM(NUPAHO,ICHARG),NHPMRP(NUPAHO,ICHARG)
C
                    ITITLE=1
                ELSE
                    WRITE(NFIPRI,'(1H*,2X,8X,'':'',
     *                              20X,''  '',4(I4,1X),''  '',
     *                                         4(I4,1X),''  '',1H*)')
     *
     *                    NPPPRP(NUPAHO,ICHARG),NPPPRM(NUPAHO,ICHARG),
     *                    NPPMRM(NUPAHO,ICHARG),NPPMRP(NUPAHO,ICHARG),
     *                    NHPPRP(NUPAHO,ICHARG),NHPPRM(NUPAHO,ICHARG),
     *                    NHPMRM(NUPAHO,ICHARG),NHPMRP(NUPAHO,ICHARG)
C
                END IF
            END IF
C
         END DO
      END DO
C
C=======================================================================
C       PRINTING THE FILLING-APPROXIMATION DATA READ FROM THE INPUT
C       FOR THE PARITY/SIGNATURE CASE
C=======================================================================
C
      ISFILL=0
C
      DO IPARIT=0,NDPARI
         DO IREVER=0,NDREVE
            DO ICHARG=0,NDISOS
C
               IF (NOFILG(IPARIT,IREVER,ICHARG).GE.1) ISFILL=1
C
            END DO
         END DO
      END DO
C
      IF (ISFILL.EQ.1) THEN
C
          WRITE(NFIPRI,'(1H*,77X,1H*,/,79(1H*),/,     1H*,77X,1H*,/,
     *                 1H*,2X,''CALCULATIONS WITH THE FILLING APPROXI'',
     *                        ''MATION FOR OCCUPATIONS IN THE''
     *                                                    ,9X,1H*,/,
     *                 1H*,2X,''PARITY/SIGNATURE BLOCKS'',52X,1H*,/,
     *                                                1H*,77X,1H*,/,
     *                 1H*,11X,'' FILLING UP TO STATE  '',
     *                         '' FILLING  FROM STATE  '',
     *                         '' TWICE PARTICLE NUMB  '',1H*,/,
     *                 1H*,11X,'' ===================  '',
     *                         '' ===================  '',
     *                         '' ===================  '',1H*,/,
     *                 1H*,11X,'' (++) (+-) (-+) (--)  '',
     *                         '' (++) (+-) (-+) (--)  '',
     *                         '' (++) (+-) (-+) (--)  '',1H*,/,
     *                 1H*,11X,2(21X,'' ''),22X,1H*)')
C
          DO ICHARG=0,NDISOS
C
              WRITE(NFIPRI,'(1H*,2X,A8,'':'',2(4(I4,1X),''  ''),
     *                                         4(I4,1X),''  '',1H*)')
     *
     *              NAMEPN(ICHARG),
     *              NPFILG(0,0,ICHARG),NPFILG(0,1,ICHARG),
     *              NPFILG(1,1,ICHARG),NPFILG(1,0,ICHARG),
     *              NHFILG(0,0,ICHARG),NHFILG(0,1,ICHARG),
     *              NHFILG(1,1,ICHARG),NHFILG(1,0,ICHARG),
     *              NOFILG(0,0,ICHARG),NOFILG(0,1,ICHARG),
     *              NOFILG(1,1,ICHARG),NOFILG(1,0,ICHARG)
C
          END DO
C
      END IF
C
C=======================================================================
C       PRINTING THE DIABATIC CONFIGURATION DATA (SINGLE-PAIR)
C       FOR THE PARITY/SIGNATURE CASE
C=======================================================================
C
      IF (IFLIPI.NE.0) THEN
C
          WRITE(NFIPRI,'(1H*,77X,1H*,/,79(1H*),/,         1H*,77X,1H*,/,
     *              1H*,2X,''CALCULATIONS WITH DIABATICALLY BLOCKE'',
     *                     ''D CONFIGURATIONS. HERE IS THE INPUT:'',
     *                                                         2X,1H*,/,
     *              1H*,2X,''CHARGE='',    I1,'', PARITY='',         I1,
     *                     '', SIGNATURE='',I1,'', PARTICLE='',      I2,
     *                     '', HOLE='',    I2,'', OBSERVABLE CODE='',I2,
     *                                                         2X,1H*,/,
     *              1H*,77X,1H*,/,
     *              1H*,2X,''THEREFORE:'',                    65X,1H*,/,
     *              1H*,77X,1H*,/,
     *              1H*,2X,''IN THE PARITY "'',A1,''" '',
     *                     ''AND SIGNATURE "'',A1,''i" '',
     *                     ''BLOCK FOR  '',A8,'' '',
     *                     ''THE STATE HAVING'',               2X,1H*,/,
     *              1H*,2X,''A '',A7,'' '',
     *                     ''VALUE OF THE -- '',A26,'' -- '',
     *                     ''WILL BE  OCCUPIED'',              2X,1H*)')
     *
     *           ICHFLI,IPAFLI,IREFLI*(1-IPAFLI)+(1-IREFLI)*IPAFLI,
     *                  ISPFLI,ISHFLI,IFLIPI,
     *                  PLUMIN(IPAFLI),
     *                  PLUMIN(IREFLI*(1-IPAFLI)+(1-IREFLI)*IPAFLI),
     *                  NAMEPN(ICHFLI),NAMLAR((SIGN(1,IFLIPI)+3)/2),
     *                  NAMOBS(ABS(IFLIPI))
C
      END IF
C
C=======================================================================
C       PRINTING THE DIABATIC CONFIGURATION DATA (ALL BLOCKS)
C       FOR THE PARITY/SIGNATURE CASE
C=======================================================================
C
      IDIABL=0
C
      DO IPARIT=0,NDPARI
         DO IREVER=0,NDREVE
            DO ICHARG=0,NDISOS
C
               IF (NOFLIG(IPARIT,IREVER,ICHARG).NE.0) IDIABL=1
C
           END DO
         END DO
      END DO
C
      IF (IDIABL.EQ.1) THEN
C
          WRITE(NFIPRI,'(1H*,77X,1H*,/,79(1H*),/,     1H*,77X,1H*,/,
     *                 1H*,2X,''CALCULATIONS WITH DIABATICALLY BLOCKE'',
     *                        ''D CONFIGURATIONS IN THE'',15X,1H*,/,
     *                 1H*,2X,''PARITY/SIGNATURE BLOCKS'',52X,1H*,/,
     *                                                1H*,77X,1H*,/,
     *                 1H*,11X,''  P A R T I C L E S   '',
     *                         ''      H O L E S       '',
     *                         '' O B S E R V A B L E  '',1H*,/,
     *                 1H*,11X,''  =================   '',
     *                         ''      =========       '',
     *                         '' ===================  '',1H*,/,
     *                 1H*,11X,'' (++) (+-) (-+) (--)  '',
     *                         '' (++) (+-) (-+) (--)  '',
     *                         '' (++) (+-) (-+) (--)  '',1H*,/,
     *                 1H*,11X,2(21X,'' ''),22X,1H*)')
C
          DO ICHARG=0,NDISOS
C
              WRITE(NFIPRI,'(1H*,2X,A8,'':'',2(4(I4,1X),''  ''),
     *                                         4(I4,1X),''  '',1H*)')
     *
     *              NAMEPN(ICHARG),
     *              NPFLIG(0,0,ICHARG),NPFLIG(0,1,ICHARG),
     *              NPFLIG(1,1,ICHARG),NPFLIG(1,0,ICHARG),
     *              NHFLIG(0,0,ICHARG),NHFLIG(0,1,ICHARG),
     *              NHFLIG(1,1,ICHARG),NHFLIG(1,0,ICHARG),
     *              NOFLIG(0,0,ICHARG),NOFLIG(0,1,ICHARG),
     *              NOFLIG(1,1,ICHARG),NOFLIG(1,0,ICHARG)
C
          END DO
C
      END IF
C
C=======================================================================
C
      WRITE(NFIPRI,'(1H*,77X,1H*,/,79(1H*),/)')
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE SIMPRI(ICHFLI,       IREFLI,
     *                  ISPFLI,ISHFLI,IFLIPI)
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      CHARACTER
     *          NAMEPN(0:NDISOS)*8,PLUMIN(0:1)*1,
     *          NAMOBS(10)*26,NAMLAR(2)*7
C
      COMMON
     *       /SIMNVA/ NVASIM(0:NDREVE,0:NDISOS)
      COMMON
     *       /SIMNPH/ NPSIMP(NDPAHO,0:NDISOS),NPSIMM(NDPAHO,0:NDISOS),
     *                NHSIMP(NDPAHO,0:NDISOS),NHSIMM(NDPAHO,0:NDISOS)
      COMMON
     *       /N_FLIM/ NPFLIM(0:NDREVE,0:NDISOS),
     *                NHFLIM(0:NDREVE,0:NDISOS),
     *                NOFLIM(0:NDREVE,0:NDISOS)
      COMMON
     *       /CFIPRI/ NFIPRI
C
      DATA
     *       NAMOBS /'ANGULAR MOMENTUM ALIGNMENT',
     *               ' INTRINSIC SPIN ALIGNMENT ',
     *               '  TOTAL SPIN X-ALIGNMENT  ',
     *               'INTRINSIC SPIN X-ALIGNMENT',
     *               '  TOTAL SPIN Z-ALIGNMENT  ',
     *               'INTRINSIC SPIN Z-ALIGNMENT',
     *               '  TOTAL SPIN O-ALIGNMENT  ',
     *               'INTRINSIC SPIN O-ALIGNMENT',
     *               '  QUADRUPOLE MOMENT Q_20  ',
     *               '  QUADRUPOLE MOMENT Q_22  '/
      DATA
     *       NAMLAR /'SMALLER','LARGER '/
      DATA
     *       NAMEPN /'NEUTRONS','PROTONS '/
      DATA
     *       PLUMIN /'+','-'/
C
C=======================================================================
C       PRINTING THE CONFIGURATION DATA READ FROM THE INPUT
C=======================================================================
C
      WRITE(NFIPRI,'(79(1H*),/,                 1H*,77X,1H*,/,
     *                 1H*,2X,''SIMPLEX CONFIGURATIONS:'',  52X,1H*,/,
     *                                          1H*,77X,1H*,/,
     *                 1H*,11X,''     V A C U U M      '',
     *                         ''  P A R T I C L E S   '',
     *                         ''      H O L E S       '',1H*,/,
     *                 1H*,11X,''     ===========      '',
     *                         ''  =================   '',
     *                         ''     ===========      '',1H*,/,
     *                 1H*,11X,''     ( + ) ( - )      '',
     *                         ''     ( + ) ( - )      '',
     *                         ''     ( + ) ( - )      '',1H*,/,
     *                 1H*,11X,2(21X,'' ''),22X,1H*)')
C
      DO ICHARG=0,NDISOS
C
         ITITLE=0
C
         DO NUPAHO=1,NDPAHO
C
            IF (NPSIMP(NUPAHO,ICHARG).NE.0.OR.
     *          NPSIMM(NUPAHO,ICHARG).NE.0.OR.
     *          NHSIMP(NUPAHO,ICHARG).NE.0.OR.
     *          NHSIMM(NUPAHO,ICHARG).NE.0.OR.
     *
     *          ITITLE.EQ.0.AND.NUPAHO.EQ.NDPAHO) THEN
C
                IF (ITITLE.EQ.0) THEN
C
                    WRITE(NFIPRI,'(1H*,2X,A8,'':'',2(2X,2I6,8X),
     *                                               2X,2I6,8X ,1H*)')
     *
     *                    NAMEPN(ICHARG),
     *                    NVASIM(  0,   ICHARG),NVASIM(  1,   ICHARG),
     *                    NPSIMP(NUPAHO,ICHARG),NPSIMM(NUPAHO,ICHARG),
     *                    NHSIMP(NUPAHO,ICHARG),NHSIMM(NUPAHO,ICHARG)
C
                    ITITLE=1
                ELSE
                    WRITE(NFIPRI,'(1H*,2X,8X,'':'',
     *                                   20X,''  '',2X,2I6,8X,
     *                                              2X,2I6,8X,1H*)')
     *
     *                    NPSIMP(NUPAHO,ICHARG),NPSIMM(NUPAHO,ICHARG),
     *                    NHSIMP(NUPAHO,ICHARG),NHSIMM(NUPAHO,ICHARG)
C
                END IF
            END IF
C
         END DO
      END DO
C
C=======================================================================
C       PRINTING THE DIABATIC CONFIGURATION DATA (SINGLE-PAIR)
C       FOR THE SIMPLEX CASE
C=======================================================================
C
      IF (IFLIPI.NE.0) THEN
C
          WRITE(NFIPRI,'(1H*,77X,1H*,/,79(1H*),/,         1H*,77X,1H*,/,
     *              1H*,2X,''CALCULATIONS WITH DIABATICALLY BLOCKE'',
     *                     ''D CONFIGURATIONS. HERE IS THE INPUT:'',
     *                                                         2X,1H*,/,
     *              1H*,2X,''CHARGE='',   I1,'',           '',
     *                     ''  SIMPLEX='',I1,'', PARTICLE='',       I2,
     *                     '', HOLE='',   I2,'', OBSERVABLE CODE='',I2,
     *                                                         2X,1H*,/,
     *              1H*,77X,1H*,/,
     *              1H*,2X,''THEREFORE:       '',
     *                     ''IN THE SIMPLEX "'',A1,''i" '',
     *                     ''BLOCK FOR  '',A8,'' '',
     *                     ''THE STATE HAVING'',               2X,1H*,/,
     *              1H*,2X,''A '',A7,'' '',
     *                     ''VALUE OF THE -- '',A26,'' -- '',
     *                     ''WILL BE  OCCUPIED'',              2X,1H*)')
     *
     *                  ICHFLI,       IREFLI,
     *                  ISPFLI,ISHFLI,IFLIPI,
     *                  PLUMIN(IREFLI),
     *                  NAMEPN(ICHFLI),NAMLAR((SIGN(1,IFLIPI)+3)/2),
     *                  NAMOBS(ABS(IFLIPI))
C
      END IF
C
C=======================================================================
C       PRINTING THE DIABATIC CONFIGURATION DATA (ALL BLOCKS)
C       FOR THE SIMPLEX CASE
C=======================================================================
C
      IDIABL=0
C
      DO IREVER=0,NDREVE
         DO ICHARG=0,NDISOS
C
            IF (NOFLIM(IREVER,ICHARG).NE.0) IDIABL=1
C
        END DO
      END DO
C
      IF (IDIABL.EQ.1) THEN
C
          WRITE(NFIPRI,'(1H*,77X,1H*,/,79(1H*),/,     1H*,77X,1H*,/,
     *                 1H*,2X,''CALCULATIONS WITH DIABATICALLY BLOCKE'',
     *                        ''D CONFIGURATIONS IN THE'',15X,1H*,/,
     *                 1H*,2X,''SIMPLEX BLOCKS'',         61X,1H*,/,
     *                                                1H*,77X,1H*,/,
     *                 1H*,11X,''  P A R T I C L E S   '',
     *                         ''      H O L E S       '',
     *                         '' O B S E R V A B L E  '',1H*,/,
     *                 1H*,11X,''  =================   '',
     *                         ''      =========       '',
     *                         '' ===================  '',1H*,/,
     *                 1H*,11X,''     ( + ) ( - )      '',
     *                         ''     ( + ) ( - )      '',
     *                         ''     ( + ) ( - )      '',1H*,/,
     *                 1H*,11X,2(21X,'' ''),22X,1H*)')
C
          DO ICHARG=0,NDISOS
C
             WRITE(NFIPRI,'(1H*,2X,A8,'':'',2(2X,2I6,8X),
     *                                        2X,2I6,8X ,1H*)')
     *
     *             NAMEPN(ICHARG),
     *             NPFLIM(0,ICHARG),NPFLIM(1,ICHARG),
     *             NHFLIM(0,ICHARG),NHFLIM(1,ICHARG),
     *             NOFLIM(0,ICHARG),NOFLIM(1,ICHARG)
C
          END DO
C
      END IF
C
C=======================================================================
C
      WRITE(NFIPRI,'(1H*,77X,1H*,/,79(1H*),/)')
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE SIQPRI(ICHFLI,IPAFLI,
     *                  ISPFLI,ISHFLI,IFLIPI)
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      CHARACTER
     *          NAMEPN(0:NDISOS)*8,PLUMIN(0:1)*1,
     *          NAMOBS(10)*26,NAMLAR(2)*7
C
      COMMON
     *       /SIQNVA/ NVASIQ(0:NDPARI,         0:NDISOS)
      COMMON
     *       /SIQNPH/ NPSIQP(NDPAHO,0:NDISOS),NPSIQM(NDPAHO,0:NDISOS),
     *                NHSIQP(NDPAHO,0:NDISOS),NHSIQM(NDPAHO,0:NDISOS)
      COMMON
     *       /N_FLIQ/ NPFLIQ(0:NDPARI,         0:NDISOS),
     *                NHFLIQ(0:NDPARI,         0:NDISOS),
     *                NOFLIQ(0:NDPARI,         0:NDISOS)
      COMMON
     *       /CFIPRI/ NFIPRI
C
      DATA
     *       NAMOBS /'  TOTAL SPIN Y-ALIGNMENT  ',
     *               'INTRINSIC SPIN Y-ALIGNMENT',
     *               '  TOTAL SPIN X-ALIGNMENT  ',
     *               'INTRINSIC SPIN X-ALIGNMENT',
     *               '  TOTAL SPIN Z-ALIGNMENT  ',
     *               'INTRINSIC SPIN Z-ALIGNMENT',
     *               '  TOTAL SPIN O-ALIGNMENT  ',
     *               'INTRINSIC SPIN O-ALIGNMENT',
     *               '  QUADRUPOLE MOMENT Q_20  ',
     *               '  QUADRUPOLE MOMENT Q_22  '/
      DATA
     *       NAMLAR /'SMALLER','LARGER '/
      DATA
     *       NAMEPN /'NEUTRONS','PROTONS '/
      DATA
     *       PLUMIN /'+','-'/
C
C=======================================================================
C       PRINTING THE CONFIGURATION DATA READ FROM THE INPUT
C=======================================================================
C
      WRITE(NFIPRI,'(79(1H*),/,                 1H*,77X,1H*,/,
     *                 1H*,2X,''PARITY CONFIGURATIONS:'',  53X,1H*,/,
     *                                          1H*,77X,1H*,/,
     *                 1H*,11X,''     V A C U U M      '',
     *                         ''  P A R T I C L E S   '',
     *                         ''      H O L E S       '',1H*,/,
     *                 1H*,11X,''     ===========      '',
     *                         ''  =================   '',
     *                         ''     ===========      '',1H*,/,
     *                 1H*,11X,''     ( + ) ( - )      '',
     *                         ''     ( + ) ( - )      '',
     *                         ''     ( + ) ( - )      '',1H*,/,
     *                 1H*,11X,2(21X,'' ''),22X,1H*)')
C
      DO ICHARG=0,NDISOS
C
         ITITLE=0
C
         DO NUPAHO=1,NDPAHO
C
            IF (NPSIQP(NUPAHO,ICHARG).NE.0.OR.
     *          NPSIQM(NUPAHO,ICHARG).NE.0.OR.
     *          NHSIQP(NUPAHO,ICHARG).NE.0.OR.
     *          NHSIQM(NUPAHO,ICHARG).NE.0.OR.
     *
     *          ITITLE.EQ.0.AND.NUPAHO.EQ.NDPAHO) THEN
C
                IF (ITITLE.EQ.0) THEN
C
                    WRITE(NFIPRI,'(1H*,2X,A8,'':'',2(2X,2I6,8X),
     *                                               2X,2I6,8X ,1H*)')
     *
     *                    NAMEPN(ICHARG),
     *                    NVASIQ(  0,   ICHARG),NVASIQ(  1,   ICHARG),
     *                    NPSIQP(NUPAHO,ICHARG),NPSIQM(NUPAHO,ICHARG),
     *                    NHSIQP(NUPAHO,ICHARG),NHSIQM(NUPAHO,ICHARG)
C
                    ITITLE=1
                ELSE
                    WRITE(NFIPRI,'(1H*,2X,8X,'':'',
     *                                   20X,''  '',2X,2I6,8X,
     *                                              2X,2I6,8X,1H*)')
     *
     *                    NPSIQP(NUPAHO,ICHARG),NPSIQM(NUPAHO,ICHARG),
     *                    NHSIQP(NUPAHO,ICHARG),NHSIQM(NUPAHO,ICHARG)
C
                END IF
            END IF
C
         END DO
      END DO
C
C=======================================================================
C       PRINTING THE DIABATIC CONFIGURATION DATA (SINGLE-PAIR)
C       FOR THE PARITY CASE
C=======================================================================
C
      IF (IFLIPI.NE.0) THEN
C
          WRITE(NFIPRI,'(1H*,77X,1H*,/,79(1H*),/,         1H*,77X,1H*,/,
     *              1H*,2X,''CALCULATIONS WITH DIABATICALLY BLOCKE'',
     *                     ''D CONFIGURATIONS. HERE IS THE INPUT:'',
     *                                                         2X,1H*,/,
     *              1H*,2X,''CHARGE='',   I1,'',           '',
     *                     ''   PARITY='',I1,'', PARTICLE='',       I2,
     *                     '', HOLE='',   I2,'', OBSERVABLE CODE='',I2,
     *                                                         2X,1H*,/,
     *              1H*,77X,1H*,/,
     *              1H*,2X,''THEREFORE:       '',
     *                     ''IN THE  PARITY "'',A1,''i" '',
     *                     ''BLOCK FOR  '',A8,'' '',
     *                     ''THE STATE HAVING'',               2X,1H*,/,
     *              1H*,2X,''A '',A7,'' '',
     *                     ''VALUE OF THE -- '',A26,'' -- '',
     *                     ''WILL BE  OCCUPIED'',              2X,1H*)')
     *
     *                  ICHFLI,IPAFLI,
     *                  ISPFLI,ISHFLI,IFLIPI,
     *                  PLUMIN(IPAFLI),
     *                  NAMEPN(ICHFLI),NAMLAR((SIGN(1,IFLIPI)+3)/2),
     *                  NAMOBS(ABS(IFLIPI))
C
      END IF
C
C=======================================================================
C       PRINTING THE DIABATIC CONFIGURATION DATA (ALL BLOCKS)
C       FOR THE PARITY CASE
C=======================================================================
C
      IDIABL=0
C
      DO IPARIT=0,NDPARI
         DO ICHARG=0,NDISOS
C
            IF (NOFLIQ(IPARIT,ICHARG).NE.0) IDIABL=1
C
        END DO
      END DO
C
      IF (IDIABL.EQ.1) THEN
C
          WRITE(NFIPRI,'(1H*,77X,1H*,/,79(1H*),/,     1H*,77X,1H*,/,
     *                 1H*,2X,''CALCULATIONS WITH DIABATICALLY BLOCKE'',
     *                        ''D CONFIGURATIONS IN THE'',15X,1H*,/,
     *                 1H*,2X,''PARITY BLOCKS'',          62X,1H*,/,
     *                                                1H*,77X,1H*,/,
     *                 1H*,11X,''  P A R T I C L E S   '',
     *                         ''      H O L E S       '',
     *                         '' O B S E R V A B L E  '',1H*,/,
     *                 1H*,11X,''  =================   '',
     *                         ''      =========       '',
     *                         '' ===================  '',1H*,/,
     *                 1H*,11X,''     ( + ) ( - )      '',
     *                         ''     ( + ) ( - )      '',
     *                         ''     ( + ) ( - )      '',1H*,/,
     *                 1H*,11X,2(21X,'' ''),22X,1H*)')
C
          DO ICHARG=0,NDISOS
C
             WRITE(NFIPRI,'(1H*,2X,A8,'':'',2(2X,2I6,8X),
     *                                        2X,2I6,8X ,1H*)')
     *
     *             NAMEPN(ICHARG),
     *             NPFLIQ(0,ICHARG),NPFLIQ(1,ICHARG),
     *             NHFLIQ(0,ICHARG),NHFLIQ(1,ICHARG),
     *             NOFLIQ(0,ICHARG),NOFLIQ(1,ICHARG)
C
          END DO
C
      END IF
C
C=======================================================================
C
      WRITE(NFIPRI,'(1H*,77X,1H*,/,79(1H*),/)')
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE SIZPRI(ICHFLI,
     *                  ISPFLI,ISHFLI,IFLIPI)
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      CHARACTER
     *          NAMEPN(0:NDISOS)*8,
     *          NAMOBS(10)*26,NAMLAR(2)*7
C
      COMMON
     *       /SIZNPH/ NPNONE(NDPAHO,0:NDISOS),
     *                NHNONE(NDPAHO,0:NDISOS)
      COMMON
     *       /SIZNVA/ NVASIZ(0:NDISOS)
      COMMON
     *       /N_FLIZ/ NPFLIZ(                  0:NDISOS),
     *                NHFLIZ(                  0:NDISOS),
     *                NOFLIZ(                  0:NDISOS)
      COMMON
     *       /N_FILZ/ NPFILZ(                  0:NDISOS),
     *                NHFILZ(                  0:NDISOS),
     *                NOFILZ(                  0:NDISOS)
      COMMON
     *       /CFIPRI/ NFIPRI
C
      DATA
     *       NAMOBS /'  TOTAL SPIN Y-ALIGNMENT  ',
     *               'INTRINSIC SPIN Y-ALIGNMENT',
     *               '  TOTAL SPIN X-ALIGNMENT  ',
     *               'INTRINSIC SPIN X-ALIGNMENT',
     *               '  TOTAL SPIN Z-ALIGNMENT  ',
     *               'INTRINSIC SPIN Z-ALIGNMENT',
     *               '  TOTAL SPIN O-ALIGNMENT  ',
     *               'INTRINSIC SPIN O-ALIGNMENT',
     *               '  QUADRUPOLE MOMENT Q_20  ',
     *               '  QUADRUPOLE MOMENT Q_22  '/
      DATA
     *       NAMLAR /'SMALLER','LARGER '/
      DATA
     *       NAMEPN /'NEUTRONS','PROTONS '/
C
C=======================================================================
C       PRINTING THE CONFIGURATION DATA READ FROM THE INPUT
C=======================================================================
C
      WRITE(NFIPRI,'(79(1H*),/,                 1H*,77X,1H*,/,
     *                 1H*,2X,''NO-SYMMETRY CONFIGURATIONS:'',48X,1H*,/,
     *                                          1H*,77X,1H*,/,
     *                 1H*,11X,''     V A C U U M      '',
     *                         ''  P A R T I C L E S   '',
     *                         ''      H O L E S       '',1H*,/,
     *                 1H*,11X,''     ===========      '',
     *                         ''  =================   '',
     *                         ''     ===========      '',1H*,/,
     *                 1H*,11X,2(21X,'' ''),22X,1H*)')
C
      DO ICHARG=0,NDISOS
C
         ITITLE=0
C
         DO NUPAHO=1,NDPAHO
C
            IF (NPNONE(NUPAHO,ICHARG).NE.0.OR.
     *          NHNONE(NUPAHO,ICHARG).NE.0.OR.
     *
     *          ITITLE.EQ.0.AND.NUPAHO.EQ.NDPAHO) THEN
C
                IF (ITITLE.EQ.0) THEN
C
                    WRITE(NFIPRI,'(1H*,2X,A8,'':'',2(2X,I9,11X),
     *                                               2X,I9,11X ,1H*)')
     *
     *                    NAMEPN(ICHARG),
     *                    NVASIZ(ICHARG),
     *                    NPNONE(NUPAHO,ICHARG),
     *                    NHNONE(NUPAHO,ICHARG)
C
                    ITITLE=1
                ELSE
                    WRITE(NFIPRI,'(1H*,2X,8X,'':'',
     *                                   20X,''  '',2X,I9,11X,
     *                                              2X,I9,11X,1H*)')
     *
     *                    NPNONE(NUPAHO,ICHARG),
     *                    NHNONE(NUPAHO,ICHARG)
C
                END IF
            END IF
C
         END DO
      END DO
C
C=======================================================================
C       PRINTING THE FILLING-APPROXIMATION DATA READ FROM THE INPUT
C       FOR THE NO-SYMMETRY CASE
C=======================================================================
C
      ISFILL=0
C
      DO ICHARG=0,NDISOS
C
         IF (NOFILZ(ICHARG).GE.1) ISFILL=1
C
      END DO
C
      IF (ISFILL.EQ.1) THEN
C
          WRITE(NFIPRI,'(1H*,77X,1H*,/,79(1H*),/,     1H*,77X,1H*,/,
     *                 1H*,2X,''CALCULATIONS WITH THE FILLING APPROXI'',
     *                        ''MATION FOR OCCUPATIONS IN THE'',
     *                                                    9X,1H*,/,
     *                 1H*,2X,''NO-SYMMETRY BLOCKS'',     57X,1H*,/,
     *                                                1H*,77X,1H*,/,
     *                 1H*,11X,'' FILLING UP TO STATE  '',
     *                         '' FILLING  FROM STATE  '',
     *                         '' TWICE PARTICLE NUMB  '',1H*,/,
     *                 1H*,11X,'' ===================  '',
     *                         '' ===================  '',
     *                         '' ===================  '',1H*,/,
     *                 1H*,11X,2(21X,'' ''),22X,1H*)')
C
          DO ICHARG=0,NDISOS
C
             WRITE(NFIPRI,'(1H*,2X,A8,'':'',2(8X,I6,8X),
     *                                        8X,I6,8X ,1H*)')
     *
     *             NAMEPN(ICHARG),
     *             NPFILZ(ICHARG),
     *             NHFILZ(ICHARG),
     *             NOFILZ(ICHARG)
C
          END DO
C
      END IF
C
C=======================================================================
C       PRINTING THE DIABATIC CONFIGURATION DATA (SINGLE-PAIR)
C       FOR THE NO-SYMMETRY CASE
C=======================================================================
C
      IF (IFLIPI.NE.0) THEN
C
          WRITE(NFIPRI,'(1H*,77X,1H*,/,79(1H*),/,         1H*,77X,1H*,/,
     *              1H*,2X,''CALCULATIONS WITH DIABATICALLY BLOCKE'',
     *                     ''D CONFIGURATIONS. HERE IS THE INPUT:'',
     *                                                         2X,1H*,/,
     *              1H*,2X,''CHARGE='',   I1,'',           '',
     *                     ''          '',1X,'', PARTICLE='',       I2,
     *                     '', HOLE='',   I2,'', OBSERVABLE CODE='',I2,
     *                                                         2X,1H*,/,
     *              1H*,77X,1H*,/,
     *              1H*,2X,''THEREFORE:       '',
     *                     ''                '',1X,''   '',
     *                     ''      FOR  '',A8,'' '',
     *                     ''THE STATE HAVING'',               2X,1H*,/,
     *              1H*,2X,''A '',A7,'' '',
     *                     ''VALUE OF THE -- '',A26,'' -- '',
     *                     ''WILL BE  OCCUPIED'',              2X,1H*)')
     *
     *                  ICHFLI,
     *                  ISPFLI,ISHFLI,IFLIPI,
     *                  NAMEPN(ICHFLI),NAMLAR((SIGN(1,IFLIPI)+3)/2),
     *                  NAMOBS(ABS(IFLIPI))
C
      END IF
C
C=======================================================================
C       PRINTING THE DIABATIC CONFIGURATION DATA (ALL BLOCKS)
C       FOR THE NO-SYMMETRY CASE
C=======================================================================
C
      IDIABL=0
C
      DO ICHARG=0,NDISOS
C
         IF (NOFLIZ(ICHARG).NE.0) IDIABL=1
C
      END DO
C
      IF (IDIABL.EQ.1) THEN
C
          WRITE(NFIPRI,'(1H*,77X,1H*,/,79(1H*),/,     1H*,77X,1H*,/,
     *                 1H*,2X,''CALCULATIONS WITH DIABATICALLY BLOCKE'',
     *                        ''D CONFIGURATIONS IN THE'',15X,1H*,/,
     *                 1H*,2X,''NO-SYMMETRY BLOCKS'',     57X,1H*,/,
     *                                                1H*,77X,1H*,/,
     *                 1H*,11X,''  P A R T I C L E S   '',
     *                         ''      H O L E S       '',
     *                         '' O B S E R V A B L E  '',1H*,/,
     *                 1H*,11X,''  =================   '',
     *                         ''      =========       '',
     *                         '' ===================  '',1H*,/,
     *                 1H*,11X,2(21X,'' ''),22X,1H*)')
C
          DO ICHARG=0,NDISOS
C
             WRITE(NFIPRI,'(1H*,2X,A8,'':'',2(8X,I6,8X),
     *                                        8X,I6,8X ,1H*)')
     *
     *             NAMEPN(ICHARG),
     *             NPFLIZ(ICHARG),
     *             NHFLIZ(ICHARG),
     *             NOFLIZ(ICHARG)
C
          END DO
C
      END IF
C
C=======================================================================
C
      WRITE(NFIPRI,'(1H*,77X,1H*,/,79(1H*),/)')
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE MOMPRI(ISIMPY,NAMMOM,NAMREF,NAMEPN,QMOMUL,NMOMUL)
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      DIMENSION
     *          QMOMUL(0:NDMULT,-NDMULT:NDMULT)
      CHARACTER
     *          PRIMOM(-NDMULT:NDMULT)*15
      CHARACTER
     *          NAMMOM*45,NAMREF*17,NAMEPN*8,PRIMIU*2
C
      COMMON
     *       /CFIPRI/ NFIPRI
C
C=======================================================================
C       THIS SUBROUTINE PRINTS THE AVERAGE VALUES  OF  ELECTROMAGNETIC
C       MULTIPOLE   MOMENTS: R**LAMBDA*CONJG(Y(LAMBDA,MIU))
C=======================================================================
C
      WRITE(NFIPRI,'(79(1H*),/,       1H*,77X,1H*,/,
     *             1H*,2X,A45,1X,A17,2X,A8,2X,1H*,/,
     *                                1H*,77X,1H*)')
     *          NAMMOM,NAMREF,NAMEPN
C
      IF (ISIMPY.NE.1) THEN
C
          WRITE(NFIPRI,'(
     *              1H*,2X,''REAL PART  FOR A NON-NEGATIVE PROJECTION'',
     *                                                        35X,1H*,/,
     *              1H*,2X,''IMAGINARY PART FOR A NEGATIVE PROJECTION'',
     *                                                        35X,1H*,/,
     *                                      1H*,77X,1H*,/,
     *                                          79(1H*))')
C
      ELSE
C
          WRITE(NFIPRI,'(79(1H*))')
C
      END IF
C
C=======================================================================
C
      DO MIU=-NDMULT,NDMULT
         PRIMOM(MIU)='  .............'
      END DO
C
      DO LAMBDA=0,MIN(NMOMUL,NDMULT)
C
         DO MIU=-LAMBDA,LAMBDA
C
            QMOMEN = QMOMUL(LAMBDA,MIU)
C
            IF (ISIMPY.EQ.1) THEN
                WRITE(PRIMIU,'(I1,1X)') MIU
            ELSE
                WRITE(PRIMIU,'(I2)') MIU
                IF (PRIMIU(1:2).EQ.' 0') PRIMIU(1:2)='0 '
                IF (PRIMIU(1:1).EQ.' ' ) PRIMIU(1:1)='+'
            END IF
C
            IF (ABS(QMOMEN).LT.1.0E-10) THEN
C
                WRITE(PRIMOM(MIU),'(''  Q'',I1,A2,''='',4X,''ZERO'')')
     *                                                   LAMBDA,PRIMIU
            ELSE
C
               IF (ABS(QMOMEN).LT.1.0E-3.OR.QMOMEN.GT.1000.OR.
     *                                      QMOMEN.LT.-100) THEN
C
                   WRITE(PRIMOM(MIU),'(''  Q'',I1,A2,''='',1PE8.1)')
     *                                          LAMBDA,PRIMIU,QMOMEN
               ELSE
C
                   WRITE(PRIMOM(MIU),'(''  Q'',I1,A2,''='',F8.4)')
     *                                        LAMBDA,PRIMIU,QMOMEN
               END IF
C
            END IF
C
         END DO
C
C=======================================================================
C
         WRITE(NFIPRI,'(1H*,77X,1H*,/,1H*,5A15,2X,1H*)')
     *                                        (PRIMOM(MIU),MIU=0,4)
         IF (ISIMPY.NE.1)
     *   WRITE(NFIPRI,'(1H*,     15X,4A15,2X,1H*)')
     *                                        (PRIMOM(MIU),MIU=-1,-4,-1)
C
C=======================================================================
C
         IF (LAMBDA.EQ.5) THEN
         WRITE(NFIPRI,'(1H*,77X,1H*,/,1H*,60X, A15,2X,1H*)')
     *                                        (PRIMOM(MIU),MIU=5,5)
         IF (ISIMPY.NE.1)
     *   WRITE(NFIPRI,'(1H*,         60X, A15,2X,1H*)')
     *                                        (PRIMOM(MIU),MIU=-5,-5)
         END IF
C
C=======================================================================
C
         IF (LAMBDA.EQ.6) THEN
         WRITE(NFIPRI,'(1H*,77X,1H*,/,1H*,45X,2A15,2X,1H*)')
     *                                        (PRIMOM(MIU),MIU=5,6)
         IF (ISIMPY.NE.1)
     *   WRITE(NFIPRI,'(1H*,         45X,2A15,2X,1H*)')
     *                                        (PRIMOM(MIU),MIU=-5,-6,-1)
         END IF
C
C=======================================================================
C
         IF (LAMBDA.EQ.7) THEN
         WRITE(NFIPRI,'(1H*,77X,1H*,/,1H*,30X,3A15,2X,1H*)')
     *                                        (PRIMOM(MIU),MIU=5,7)
         IF (ISIMPY.NE.1)
     *   WRITE(NFIPRI,'(1H*,         30X,3A15,2X,1H*)')
     *                                        (PRIMOM(MIU),MIU=-5,-7,-1)
         END IF
C
C=======================================================================
C
         IF (LAMBDA.EQ.8) THEN
         WRITE(NFIPRI,'(1H*,77X,1H*,/,1H*,15X,4A15,2X,1H*)')
     *                                        (PRIMOM(MIU),MIU=5,8)
         IF (ISIMPY.NE.1)
     *   WRITE(NFIPRI,'(1H*,         15X,4A15,2X,1H*)')
     *                                        (PRIMOM(MIU),MIU=-5,-8,-1)
         END IF
C
C=======================================================================
C
         IF (LAMBDA.EQ.9) THEN
         WRITE(NFIPRI,'(1H*,77X,1H*,/,1H*,    5A15,2X,1H*)')
     *                                        (PRIMOM(MIU),MIU=5,9)
         IF (ISIMPY.NE.1)
     *   WRITE(NFIPRI,'(1H*,             5A15,2X,1H*)')
     *                                        (PRIMOM(MIU),MIU=-5,-9,-1)
         END IF
C
      END DO
C
      WRITE(NFIPRI,'(1H*,77X,1H*,/,79(1H*),/)')
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE MAGPRI(ISIMPY,IROTAT,NAMMOM,NAMREF,NAMEPN,
     *                                       AMOMUL,NMOMAG)
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      DIMENSION
     *          AMOMUL(0:NDMULT,-NDMULT:NDMULT)
      DIMENSION
     *          DIPKAR(1:NDKART)
      CHARACTER
     *          PRIMOM(-NDMULT:NDMULT)*15
      CHARACTER
     *          NAMMOM*45,NAMREF*17,NAMEPN*8,PRIMIU*2
C
      COMMON
     *       /MAGUNI/ AUNITS(0:NDMULT,0:NDMULT)
      COMMON
     *       /CFIPRI/ NFIPRI
C
C=======================================================================
C       THIS SUBROUTINE PRINTS THE AVERAGE VALUES OF MAGNETIC  MULTIPOLE
C       MOMENTS
C=======================================================================
C
      IF (NMOMAG.EQ.0.OR.IROTAT.NE.1) RETURN
C
C=======================================================================
C       ATTENTION: TEMPORARY TREATMENT OF CONSERVED SIMPLEX
C=======================================================================
C
      JSIMPY=0
C
C=======================================================================
C
      WRITE(NFIPRI,'(79(1H*),/,       1H*,77X,1H*,/,
     *             1H*,2X,A45,1X,A17,2X,A8,2X,1H*,/,
     *                                1H*,77X,1H*)')
     *          NAMMOM,NAMREF,NAMEPN
C
      IF (JSIMPY.NE.1) THEN
C
          WRITE(NFIPRI,'(
     *              1H*,2X,''REAL PART  FOR A NON-NEGATIVE PROJECTION'',
     *                                                        35X,1H*,/,
     *              1H*,2X,''IMAGINARY PART FOR A NEGATIVE PROJECTION'',
     *                                                        35X,1H*,/,
     *                                      1H*,77X,1H*,/,
     *                                          79(1H*))')
C
      ELSE
C
          WRITE(NFIPRI,'(79(1H*))')
C
      END IF
C
C=======================================================================
C
      DO MIU=-NDMULT,NDMULT
         PRIMOM(MIU)='  .............'
      END DO
C
      DO LAMBDA=1,MIN(NMOMAG,NDMULT)
C
         DO MIU=-LAMBDA,LAMBDA
C
            AMOMEN = AMOMUL(LAMBDA,MIU)
C
            IF (JSIMPY.EQ.1) THEN
                WRITE(PRIMIU,'(I1,1X)') MIU
            ELSE
                WRITE(PRIMIU,'(I2)') MIU
                IF (PRIMIU(1:2).EQ.' 0') PRIMIU(1:2)='0 '
                IF (PRIMIU(1:1).EQ.' ' ) PRIMIU(1:1)='+'
            END IF
C
            IF (ABS(AMOMEN).LT.1.0E-10) THEN
C
                WRITE(PRIMOM(MIU),'(''  M'',I1,A2,''='',4X,''ZERO'')')
     *                                                   LAMBDA,PRIMIU
            ELSE
C
               IF (ABS(AMOMEN).LT.1.0E-3.OR.AMOMEN.GT.1000.OR.
     *                                      AMOMEN.LT.-100) THEN
C
                   WRITE(PRIMOM(MIU),'(''  M'',I1,A2,''='',1PE8.1)')
     *                                          LAMBDA,PRIMIU,AMOMEN
               ELSE
C
                   WRITE(PRIMOM(MIU),'(''  M'',I1,A2,''='',F8.4)')
     *                                        LAMBDA,PRIMIU,AMOMEN
               END IF
C
            END IF
C
         END DO
C
C=======================================================================
C
         WRITE(NFIPRI,'(1H*,77X,1H*,/,1H*,5A15,2X,1H*)')
     *                                        (PRIMOM(MIU),MIU=0,4)
         IF (JSIMPY.NE.1)
     *   WRITE(NFIPRI,'(1H*,     15X,4A15,2X,1H*)')
     *                                        (PRIMOM(MIU),MIU=-1,-4,-1)
C
C=======================================================================
C
         IF (LAMBDA.EQ.5) THEN
         WRITE(NFIPRI,'(1H*,77X,1H*,/,1H*,60X, A15,2X,1H*)')
     *                                        (PRIMOM(MIU),MIU=5,5)
         IF (JSIMPY.NE.1)
     *   WRITE(NFIPRI,'(1H*,         60X, A15,2X,1H*)')
     *                                        (PRIMOM(MIU),MIU=-5,-5)
         END IF
C
C=======================================================================
C
         IF (LAMBDA.EQ.6) THEN
         WRITE(NFIPRI,'(1H*,77X,1H*,/,1H*,45X,2A15,2X,1H*)')
     *                                        (PRIMOM(MIU),MIU=5,6)
         IF (JSIMPY.NE.1)
     *   WRITE(NFIPRI,'(1H*,         45X,2A15,2X,1H*)')
     *                                        (PRIMOM(MIU),MIU=-5,-6,-1)
         END IF
C
C=======================================================================
C
         IF (LAMBDA.EQ.7) THEN
         WRITE(NFIPRI,'(1H*,77X,1H*,/,1H*,30X,3A15,2X,1H*)')
     *                                        (PRIMOM(MIU),MIU=5,7)
         IF (JSIMPY.NE.1)
     *   WRITE(NFIPRI,'(1H*,         30X,3A15,2X,1H*)')
     *                                        (PRIMOM(MIU),MIU=-5,-7,-1)
         END IF
C
C=======================================================================
C
         IF (LAMBDA.EQ.8) THEN
         WRITE(NFIPRI,'(1H*,77X,1H*,/,1H*,15X,4A15,2X,1H*)')
     *                                        (PRIMOM(MIU),MIU=5,8)
         IF (JSIMPY.NE.1)
     *   WRITE(NFIPRI,'(1H*,         15X,4A15,2X,1H*)')
     *                                        (PRIMOM(MIU),MIU=-5,-8,-1)
         END IF
C
C=======================================================================
C
         IF (LAMBDA.EQ.9) THEN
         WRITE(NFIPRI,'(1H*,77X,1H*,/,1H*,    5A15,2X,1H*)')
     *                                        (PRIMOM(MIU),MIU=5,9)
         IF (JSIMPY.NE.1)
     *   WRITE(NFIPRI,'(1H*,             5A15,2X,1H*)')
     *                                        (PRIMOM(MIU),MIU=-5,-9,-1)
         END IF
C
      END DO
C
      WRITE(NFIPRI,'(1H*,77X,1H*)')
C
C=======================================================================
C
      PI=4.0D0*ATAN(1.00D0)
C
      DIPKAR(1)=-SQRT(8*PI/3)*AMOMUL(1, 1)/AUNITS(1,1)
      DIPKAR(2)= SQRT(8*PI/3)*AMOMUL(1,-1)/AUNITS(1,1)
      DIPKAR(3)= SQRT(4*PI/3)*AMOMUL(1, 0)/AUNITS(1,0)
C
      WRITE(NFIPRI,'(79(1H*),/,                     1H*,77X,1H*,/,
     *                 1H*,2X,''CARTESIAN VECTOR OF THE MAG'',
     *                        ''NETIC DIPOLE MOMENT'',
     *                                      1X,A17,1X,A8,2X,1H*,/,
     *                                              1H*,77X,1H*,/,
     *                 1H*,2X,''M1_X ='',F9.4,2X,
     *                     2X,''M1_Y ='',F9.4,2X,
     *                     2X,''M1_Z ='',F9.4,3X,
     *                     2X,''M1 =  '',F9.4,2X,      1H*,/,
     *                                             1H*,77X,1H*,/,
     *                                               79(1H*),/)')
     *
     *           NAMREF,NAMEPN,
     *          (DIPKAR(KARTEZ),KARTEZ=1,NDKART),
     *           SQRT(DIPKAR(1)**2+DIPKAR(2)**2+DIPKAR(3)**2)
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE BOHDEF(ISIMPY,NEXBET,IPRIBE,IPRIBL,NAMREF,NAMEPN,
     *                                       RMSPOS,QMOMUL,NMOMUL)
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      DIMENSION
     *          RMSPOS(0:NDKART)
      DIMENSION
     *          QMOMUL(0:NDMULT,-NDMULT:NDMULT),
     *          BOHBET(1:NDMULT,-NDMULT:NDMULT)
      CHARACTER
     *          NAMBET*45,NAMREF*17,NAMEPN*8
C
C=======================================================================
C       THIS SUBROUTINE CALCULATES AND  PRINTS  THE  BOHR  DEFORMATION
C       PARAMETERS CORRESPONDING TO A UNIFORM MASS DISTRIBUTION WITHIN
C       THE SURFACE DEFINED BY
C       R(THETA,PHI)=R0*(1+SUM_{LM} ALPHA_{LM} Y_{LM}(THETA,PHI))
C       WHERE
C       ALPHA_{LM}=BETA_{LM}/SQRT(2-DELTA_{M0})
C       WHICH HAS IDENTICAL  MULTIPOLE  MOMENTS  AS  THOSE  CALCULATED
C       MICROSCOPICALLY. IN  CASE  WHEN  SUCH  DEFORMATION  PARAMETERS
C       CANNOT  BE  DETERMINED,   THE  SUBROUTINE  USES  THE  SIMPLEST
C       FIRST-ORDER EXPRESSION TAKEN FROM RING&SCHUCK (1.35).
C=======================================================================
C       ATTENTION: VALUES OF NON-AXIAL DEFORMATION PARAMETERS (|MIU|>0)
C       CONTAIN FACTOR SQRT(2), WHICH CORRESPONDS TO THE STANDARD  BOHR
C       DEFINITION AND REFLECTS THE FACT THAT THE POSITIVE AND NEGATIVE
C       VALUES OF "MIU" ARE COMBINED TOGETHER.
C=======================================================================
C
      IERROR=0
C
      IF (IPRIBE.EQ.1) THEN
C
          IF (NEXBET.GT.NMOMUL) STOP 'NEXBET.GT.NMOMUL IN BOHDEF'
C
C=======================================================================
C
          CALL EXADEF(NEXBET,IERROR,RMSPOS(0),QMOMUL,
     *                          BOHDEN,BOHRAD,BOHBET)
C
          IF (IERROR.EQ.0) THEN
C
              NAMBET='BOHR DEFORMATIONS  (EXACT MULTIPOLE MOMENTS) '
C
              CALL BETPRI(NEXBET,ISIMPY,NAMBET,NAMREF,NAMEPN,
     *                                  BOHDEN,BOHRAD,BOHBET)
C
          END IF
C
      END IF
C
C=======================================================================
C
      IF (IPRIBL.EQ.1.OR.IERROR.EQ.1) THEN
C
          IF (NMOMUL.GT.NDMULT) STOP 'NMOMUL.GT.NDMULT IN BOHDEF'
C
C=======================================================================
C
          CALL APPDEF(NMOMUL,RMSPOS(0),QMOMUL,BOHDEN,BOHRAD,BOHBET)
C
          IF (IERROR.EQ.0) THEN
C
              NAMBET='BOHR DEFORMATIONS (FIRST-ORDER APPROXIMATION)'
          ELSE
              NAMBET='BOHR DEFORMATIONS (FIRST-ORDER; EXACT FAILED)'
C
          END IF
C
          CALL BETPRI(NMOMUL,ISIMPY,NAMBET,NAMREF,NAMEPN,
     *                              BOHDEN,BOHRAD,BOHBET)
C
      END IF
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE APPDEF(NAPBET,DATRMS,QMOMUL,
     *                  APPDEN,APPRAD,APPBET)
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      DIMENSION
     *          QMOMUL(0:NDMULT,-NDMULT:NDMULT),
     *          ASKMUL(0:NDMULT,-NDMULT:NDMULT)
      DIMENSION
     *          APPBET(1:NDMULT,-NDMULT:NDMULT)
C
      COMMON
     *       /OURUNI/ QUNITS(0:NDMULT,0:NDMULT)
C
C=======================================================================
C THIS SUBROUTINE FINDS THE BOHR DEFORMATION PARAMETERS
C WITHIN THE LINEAR APPROXIMATION
C=======================================================================
C
      SQR4PI=SQRT(16.D0*ATAN(1.D0))
C
C=======================================================================
C REMOVING UNITS
C=======================================================================
C
      DO LAM=0,NAPBET
         DO MIU=-LAM,LAM
            ASKMUL(LAM,MIU)=QMOMUL(LAM,MIU)/QUNITS(LAM,ABS(MIU))
         END DO
      END DO
C
      ASKSUR=SQR4PI*ASKMUL(0,0)*DATRMS**2
      ASKRAD=SQRT(5.*ASKSUR/(3.*SQR4PI*ASKMUL(0,0)))
      ASKDEN=3*ASKMUL(0,0)/(SQR4PI*ASKRAD**3)
C
C=======================================================================
C CALCULATING LINEAR APPROXIMATION TO BETAS
C=======================================================================
C
      APPRAD=ASKRAD
      APPDEN=ASKDEN
      FACTOR=APPDEN*APPRAD**4
      DO LAM=1,NAPBET
         DO MIU=-LAM,LAM
            APPBET(LAM,MIU)=ASKMUL(LAM,MIU)/FACTOR
         END DO
         FACTOR=FACTOR*APPRAD
      END DO
C
C=======================================================================
C MULTIPLYING NON-AXIAL BETAS BY SQUARE ROOT OF TWO
C=======================================================================
C
      DO LAM=1,NAPBET
         DO MIU=1,LAM
           APPBET(LAM, MIU)=APPBET(LAM, MIU)*SQRT(2.)
           APPBET(LAM,-MIU)=APPBET(LAM,-MIU)*SQRT(2.)
         END DO
      END DO
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE EXADEF(NEXBET,IERROR,DATRMS,QMOMUL,
     *                         EXADEN,EXARAD,EXABET)
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      DIMENSION
     *          QMOMUL(0:NDMULT,-NDMULT:NDMULT),
     *          ASKMUL(0:NDMULT,-NDMULT:NDMULT),
     *          PARMUL(0:NDMULT,-NDMULT:NDMULT)
      DIMENSION
     *          EXABET(1:NDMULT,-NDMULT:NDMULT)
C
      COMMON
     *       /OURUNI/ QUNITS(0:NDMULT,0:NDMULT)
C
C=======================================================================
C THIS SUBROUTINE FINDS THE BOHR DEFORMATION PARAMETERS
C=======================================================================
C
      PI=4.D0*ATAN(1.D0)
      SQR4PI=SQRT(16.D0*ATAN(1.D0))
C
C=======================================================================
C REMOVING UNITS
C=======================================================================
C
      DO LAM=0,NEXBET
         DO MIU=-LAM,LAM
            ASKMUL(LAM,MIU)=QMOMUL(LAM,MIU)/QUNITS(LAM,ABS(MIU))
         END DO
      END DO
C
      ASKSUR=SQR4PI*ASKMUL(0,0)*DATRMS**2
      ASKRAD=SQRT(5.*ASKSUR/(3.*SQR4PI*ASKMUL(0,0)))
      ASKDEN=3*ASKMUL(0,0)/(SQR4PI*ASKRAD**3)
C
C=======================================================================
C SETTING INITIAL BETAS
C=======================================================================
C
      EXADEN=ASKDEN
      EXARAD=ASKRAD
      EXASUR=4.*PI*EXADEN*EXARAD**5/5.
      EXAQ00=SQR4PI*EXADEN*EXARAD**3/3.
C
      DO LAM=1,NEXBET
         DO MIU=-LAM,LAM
            EXABET(LAM,MIU)=0.
         END DO
      END DO
C
      EPS=0.01
      OLDCHI=0.
      ITERAT=0
C
    1 CONTINUE
C
C=======================================================================
C INTEGRATING MOMENTS
C=======================================================================
C
      CALL BOHINT(NEXBET,EXADEN,EXARAD,EXABET,PARSUR,PARMUL)
C
C=======================================================================
C CALCULATING CHI-SQUARE
C=======================================================================
C
      CHISQR=0
C
      DO LAM=0,NEXBET
         DO MIU=-LAM,LAM
            CHISQR=CHISQR+(PARMUL(LAM,MIU)-ASKMUL(LAM,MIU))**2
         END DO
      END DO
C
      CHISQR=CHISQR+(PARSUR-ASKSUR)**2
C
C=======================================================================
C ITERATIONS CONTROL
C=======================================================================
C
      IF (CHISQR.GT.1.0D+40.OR.ITERAT.GT.10000) THEN
          IERROR=1
          GO TO 3
      END IF
      IF (CHISQR.LT.1.0D-6) THEN
          IERROR=0
          GO TO 2
      END IF
      ITERAT=ITERAT+1
C
C=======================================================================
C ADJUSTING SLOW-DOWN
C=======================================================================
C
      IF (CHISQR.LT.OLDCHI) THEN
         EPS=EPS*(1.5-0.5*EPS*EPS)
      ELSE
         EPS=0.01
      END IF
      OLDCHI=CHISQR
C
C=======================================================================
C CALCULATING NEW BETAS
C=======================================================================
C
      FACTOR=EXADEN*EXARAD**4
      DO LAM=1,NEXBET
         DO MIU=-LAM,LAM
            EXABET(LAM,MIU)=EXABET(LAM,MIU)
     *                +EPS*(ASKMUL(LAM,MIU)-PARMUL(LAM,MIU))/FACTOR
         END DO
         FACTOR=FACTOR*EXARAD
      END DO
      EXASUR=EXASUR+EPS*(ASKSUR-PARSUR)
      EXAQ00=EXAQ00+EPS*(ASKMUL(0,0)-PARMUL(0,0))
      EXARAD=SQRT(5.*EXASUR/(3.*SQR4PI*EXAQ00))
      EXADEN=3.*EXAQ00/(SQR4PI*EXARAD**3)
C
      GO TO 1
C
    2 CONTINUE
C
C=======================================================================
C MULTIPLYING NON-AXIAL BETAS BY SQUARE ROOT OF TWO
C=======================================================================
C
      DO LAM=1,NEXBET
         DO MIU=1,LAM
           EXABET(LAM, MIU)=EXABET(LAM, MIU)*SQRT(2.)
           EXABET(LAM,-MIU)=EXABET(LAM,-MIU)*SQRT(2.)
         END DO
      END DO
C
    3 CONTINUE
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE BOHINT(NEXBET,EXADEN,EXARAD,EXABET,PARSUR,PARMUL)
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      DIMENSION
     *          PARMUL(0:NDMULT,-NDMULT:NDMULT)
      DIMENSION
     *          EXABET(1:NDMULT,-NDMULT:NDMULT)
      DIMENSION
     *          HAR(0:NDMULT,0:NDMULT)
      DIMENSION
     *          SINUS(-2:NDLAMB)
      DIMENSION
     *          XG32(ND32),WT32(ND32),
     *          XG64(ND64),WT64(ND64)
      DIMENSION
     *          XPOINT(NDMAX),YPOINT(NDMAX),XWEIGH(NDMAX),YWEIGH(NDMAX)
C
      COMMON
     *       /COEFAB/ ALMS00(0:NDLAMB,0:NDLAMB,0:NDLAMB),
     *                ALMSS0(0:NDLAMB,0:NDLAMB,0:NDLAMB),
     *                ALMSSS(0:NDLAMB,0:NDLAMB,0:NDLAMB),
     *
     *                BLMS00(0:NDLAMB,0:NDLAMB,0:NDLAMB),
     *                BLMSS0(0:NDLAMB,0:NDLAMB,0:NDLAMB),
     *                BLMSSS(0:NDLAMB,0:NDLAMB,0:NDLAMB)
C
C=======================================================================
C POINTS AND WEIGHTS FOR 32-POINT GAUSS-LEGENDRE QUADRATURES
C=======================================================================
C
      DATA XG32
     *
     *          / .04830766568773832D0, .14447196158279649D0,
     *            .23928736225213708D0, .33186860228212765D0,
     *            .42135127613063535D0, .50689990893222939D0,
     *            .58771575724076233D0, .66304426693021520D0,
     *            .73218211874028968D0, .79448379596794241D0,
     *            .84936761373256997D0, .89632115576605213D0,
     *            .93490607593773969D0, .96476225558750643D0,
     *            .98561151154526834D0, .99726386184948156D0/
      DATA WT32
     *
     *          / .09654008851472780D0, .09563872007927486D0,
     *            .09384439908080457D0, .09117387869576389D0,
     *            .08765209300440381D0, .08331192422694676D0,
     *            .07819389578707031D0, .07234579410884851D0,
     *            .06582222277636185D0, .05868409347853555D0,
     *            .05099805926237618D0, .04283589802222668D0,
     *            .03427386291302143D0, .02539206530926206D0,
     *            .01627439473090567D0, .00701861000947009D0/
C
C=======================================================================
C POINTS AND WEIGHTS FOR 64-POINT GAUSS-LEGENDRE QUADRATURES
C=======================================================================
C
      DATA XG64
     *
     *          / .02435029266342443D0, .07299312178779904D0,
     *            .12146281929612055D0, .16964442042399282D0,
     *            .21742364374000708D0, .26468716220876742D0,
     *            .31132287199021096D0, .35722015833766812D0,
     *            .40227015796399160D0, .44636601725346409D0,
     *            .48940314570705296D0, .53127946401989455D0,
     *            .57189564620263404D0, .61115535517239325D0,
     *            .64896547125465734D0, .68523631305423324D0,
     *            .71988185017161083D0, .75281990726053190D0,
     *            .78397235894334141D0, .81326531512279756D0,
     *            .84062929625258036D0, .86599939815409282D0,
     *            .88931544599511411D0, .91052213707850281D0,
     *            .92956917213193958D0, .94641137485840282D0,
     *            .96100879965205372D0, .97332682778991097D0,
     *            .98333625388462596D0, .99101337147674432D0,
     *            .99634011677195528D0, .99930504173577214D0/
      DATA WT64
     *
     *          / .04869095700913972D0, .04857546744150343D0,
     *            .04834476223480296D0, .04799938859645831D0,
     *            .04754016571483031D0, .04696818281621002D0,
     *            .04628479658131442D0, .04549162792741815D0,
     *            .04459055816375657D0, .04358372452932346D0,
     *            .04247351512365359D0, .04126256324262353D0,
     *            .03995374113272034D0, .03855015317861563D0,
     *            .03705512854024005D0, .03547221325688239D0,
     *            .03380516183714161D0, .03205792835485155D0,
     *            .03023465707240248D0, .02833967261425948D0,
     *            .02637746971505466D0, .02435270256871087D0,
     *            .02227017380838325D0, .02013482315353021D0,
     *            .01795171577569734D0, .01572603047602472D0,
     *            .01346304789671864D0, .01116813946013112D0,
     *            .00884675982636395D0, .00650445796897837D0,
     *            .00414703326056246D0, .00178328072169639D0/
C
C=======================================================================
C THIS ROUTINE CALCULATES THE MASS SURFACE MOMENT AND MULTIPOLE MOMENTS
C OF A SHARP-EDGE UNIFORM-DENSITY BODY WHOSE SURFACE IS DEFINED BY THE
C INPUT SET OF BOHR DEFORMATION PARAMETERS.
C=======================================================================
C
      PI=4.D0*ATAN(1.D0)
C
C=======================================================================
C DEFINING GAUSS POINTS AND WEIGHTS
C=======================================================================
C
      NNX=16
      DO I=1,16
         XPOINT(I)=-XG32(17-I)
         XWEIGH(I)=+WT32(17-I)
         XPOINT(16+I)=XG32(I)
         XWEIGH(16+I)=WT32(I)
      END DO
C
      NNY=32
      DO I=1,32
         YPOINT(I)=-XG64(33-I)
         YWEIGH(I)=+WT64(33-I)
         YPOINT(32+I)=XG64(I)
         YWEIGH(32+I)=WT64(I)
      END DO
C
      AX=PI/2.
      AY=PI
      BX=PI/2.
      BY=PI
C
C=======================================================================
C ZEROING MOMENTS
C=======================================================================
C
      DO LAM=0,NEXBET
         DO MIU=-LAM,LAM
            PARMUL(LAM,MIU)=0.
         END DO
      END DO
      PARSUR=0
C
C=======================================================================
C INTEGRATING MOMENTS
C=======================================================================
C
      DO IX=1,2*NNX
C
         THE=AX+XPOINT(IX)*BX
C
         COSTHE=COS(THE)
         SINTHE=SIN(THE)
C
C=======================================================================
C STORING POWERS OF SINE OF THETA (WHY FROM -2 ???)
C=======================================================================
C
         SINUS(-2)=0.0D0
         SINUS(-1)=0.0D0
         SINUS( 0)=1.0D0
         SINUS(+1)=SINTHE
         DO I=2,NEXBET
            SINUS(I)=SINUS(I-1)*SINTHE
         END DO
C
C=======================================================================
C CALCULATING POLAR PARTS OF SPHERICAL HARMONICS
C=======================================================================
C
         DO LAM=0,NEXBET
            DO MIU=0,LAM
               HAR(LAM,MIU)=0.
               IF (MOD((LAM-MIU),2).EQ.0) THEN
                   DO IS=MIU,LAM,2
                      HAR(LAM,MIU)=HAR(LAM,MIU)
     *                         +ALMS00(LAM,MIU,IS)*SINUS(IS)
                   END DO
               ELSE
                   DO IS=MIU,LAM-1,2
                      HAR(LAM,MIU)=HAR(LAM,MIU)
     *                         +BLMS00(LAM,MIU,IS)*SINUS(IS)
                   END DO
                   HAR(LAM,MIU)=HAR(LAM,MIU)*COSTHE
               END IF
            END DO
         END DO
C
         DO IY=1,2*NNY
C
            PHI=AY+YPOINT(IY)*BY
C
C=======================================================================
C CALCULATING RADIUS
C=======================================================================
C
            RADIUS=0
            DO LAM=1,NEXBET
              RADIUS=RADIUS+EXABET(LAM,0)*HAR(LAM,0)
              DO MIU=1,LAM
                 RADIUS=RADIUS
     *                  +2.*(EXABET(LAM, MIU)*HAR(LAM,MIU)*COS(MIU*PHI)
     *            +(-1)**MIU*EXABET(LAM,-MIU)*HAR(LAM,MIU)*SIN(MIU*PHI))
              END DO
            END DO
            RADIUS=EXARAD*(1+RADIUS)
C
C=======================================================================
C SUMMING UP QUADRATURES
C=======================================================================
C
            FACTOR=EXADEN*RADIUS**3*SINTHE*XWEIGH(IX)*YWEIGH(IY)*BX*BY
            PARSUR=PARSUR+FACTOR*RADIUS**2/5.
            DO LAM=0,NEXBET
               PARMUL(LAM,0)=PARMUL(LAM,0)+FACTOR*HAR(LAM,0)/(LAM+3)
               DO MIU=1,LAM
                  PARMUL(LAM, MIU)=PARMUL(LAM, MIU)
     *                        +FACTOR*HAR(LAM, MIU)*COS(MIU*PHI)/(LAM+3)
                  PARMUL(LAM,-MIU)=PARMUL(LAM,-MIU)
     *              +(-1)**MIU*FACTOR*HAR(LAM, MIU)*SIN(MIU*PHI)/(LAM+3)
               END DO
               FACTOR=FACTOR*RADIUS
            END DO
C
         END DO
      END DO
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE BETPRI(NMOMUL,ISIMPY,NAMBET,NAMREF,NAMEPN,
     *                                BOHDEN,BOHRAD,BOHBET)
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      DIMENSION
     *          BOHBET(1:NDMULT,-NDMULT:NDMULT)
      CHARACTER
     *          PRIMOM(-NDMULT:NDMULT)*15
      CHARACTER
     *          NAMBET*45,NAMREF*17,NAMEPN*8,PRIMIU*2
C
      COMMON
     *       /CFIPRI/ NFIPRI
C
C=======================================================================
C       THIS SUBROUTINE PRINTS THE BOHR DEFORMATION PARAMETERS
C=======================================================================
C
      WRITE(NFIPRI,'(79(1H*),/,       1H*,77X,1H*,/,
     *             1H*,2X,A45,1X,A17,2X,A8,2X,1H*,/,
     *                                1H*,77X,1H*)')
     *          NAMBET,NAMREF,NAMEPN
C
      IF (ISIMPY.NE.1) THEN
C
          WRITE(NFIPRI,'(
     *              1H*,2X,''REAL PART  FOR A NON-NEGATIVE PROJECTION'',
     *                                                        35X,1H*,/,
     *              1H*,2X,''IMAGINARY PART FOR A NEGATIVE PROJECTION'',
     *                                                        35X,1H*,/,
     *                                      1H*,77X,1H*,/,
     *                                           79(1H*))')
C
      ELSE
C
          WRITE(NFIPRI,'(79(1H*))')
C
      END IF
C
C=======================================================================
C
      DO MIU=-NDMULT,NDMULT
         PRIMOM(MIU)='  .............'
      END DO
C
      DO LAMBDA=1,MIN(NMOMUL,NDMULT)
C
         DO MIU=-LAMBDA,LAMBDA
C
            BMOMEN = BOHBET(LAMBDA,MIU)
C
            IF (ISIMPY.EQ.1) THEN
                WRITE(PRIMIU,'(I1,1X)') MIU
            ELSE
                WRITE(PRIMIU,'(I2)') MIU
                IF (PRIMIU(1:2).EQ.' 0') PRIMIU(1:2)='0 '
                IF (PRIMIU(1:1).EQ.' ' ) PRIMIU(1:1)='+'
            END IF
C
            IF (ABS(BMOMEN).LT.1.0E-10) THEN
C
                WRITE(PRIMOM(MIU),'(''  B'',I1,A2,''='',4X,''ZERO'')')
     *                                                   LAMBDA,PRIMIU
            ELSE
C
               IF (ABS(BMOMEN).LT.1.0E-3) THEN
C
                   WRITE(PRIMOM(MIU),'(''  B'',I1,A2,''='',1PE8.1)')
     *                                          LAMBDA,PRIMIU,BMOMEN
               ELSE
C
                   WRITE(PRIMOM(MIU),'(''  B'',I1,A2,''='',F8.4)')
     *                                        LAMBDA,PRIMIU,BMOMEN
               END IF
C
            END IF
C
         END DO
C
C=======================================================================
C
         WRITE(NFIPRI,'(1H*,77X,1H*,/,1H*,5A15,2X,1H*)')
     *                                        (PRIMOM(MIU),MIU=0,4)
         IF (ISIMPY.NE.1)
     *   WRITE(NFIPRI,'(1H*,     15X,4A15,2X,1H*)')
     *                                        (PRIMOM(MIU),MIU=-1,-4,-1)
C
C=======================================================================
C
         IF (LAMBDA.EQ.5) THEN
         WRITE(NFIPRI,'(1H*,77X,1H*,/,1H*,60X, A15,2X,1H*)')
     *                                        (PRIMOM(MIU),MIU=5,5)
         IF (ISIMPY.NE.1)
     *   WRITE(NFIPRI,'(1H*,         60X, A15,2X,1H*)')
     *                                        (PRIMOM(MIU),MIU=-5,-5)
         END IF
C
C=======================================================================
C
         IF (LAMBDA.EQ.6) THEN
         WRITE(NFIPRI,'(1H*,77X,1H*,/,1H*,45X,2A15,2X,1H*)')
     *                                        (PRIMOM(MIU),MIU=5,6)
         IF (ISIMPY.NE.1)
     *   WRITE(NFIPRI,'(1H*,         45X,2A15,2X,1H*)')
     *                                        (PRIMOM(MIU),MIU=-5,-6,-1)
         END IF
C
C=======================================================================
C
         IF (LAMBDA.EQ.7) THEN
         WRITE(NFIPRI,'(1H*,77X,1H*,/,1H*,30X,3A15,2X,1H*)')
     *                                        (PRIMOM(MIU),MIU=5,7)
         IF (ISIMPY.NE.1)
     *   WRITE(NFIPRI,'(1H*,         30X,3A15,2X,1H*)')
     *                                        (PRIMOM(MIU),MIU=-5,-7,-1)
         END IF
C
C=======================================================================
C
         IF (LAMBDA.EQ.8) THEN
         WRITE(NFIPRI,'(1H*,77X,1H*,/,1H*,15X,4A15,2X,1H*)')
     *                                        (PRIMOM(MIU),MIU=5,8)
         IF (ISIMPY.NE.1)
     *   WRITE(NFIPRI,'(1H*,         15X,4A15,2X,1H*)')
     *                                        (PRIMOM(MIU),MIU=-5,-8,-1)
         END IF
C
C=======================================================================
C
         IF (LAMBDA.EQ.9) THEN
         WRITE(NFIPRI,'(1H*,77X,1H*,/,1H*,    5A15,2X,1H*)')
     *                                        (PRIMOM(MIU),MIU=5,9)
         IF (ISIMPY.NE.1)
     *   WRITE(NFIPRI,'(1H*,             5A15,2X,1H*)')
     *                                        (PRIMOM(MIU),MIU=-5,-9,-1)
         END IF
C
      END DO
C
      WRITE(NFIPRI,'(1H*,77X,1H*,/,79(1H*))')
C
      WRITE(NFIPRI,'(                                  1H*,77X,1H*,/,
     *          1H*,2X,''BOHR DENSITY = '',F6.4,'' FM^(-3)'',2X,
     *                 ''BOHR RADIUS = '', F8.4,'' FM'',   19X,1H*,/,
     *                                                 1H*,77X,1H*,/,
     *                                                      79(1H*),/)')
     *          BOHDEN,BOHRAD
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE RADPRI(NAMEPN,RMSPOS)
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      DIMENSION
     *          RMSPOS(0:NDKART)
      CHARACTER
     *          NAMEPN*8
C
      COMMON
     *       /CFIPRI/ NFIPRI
C
C=======================================================================
C       THIS SUBROUTINE PRINTS THE ROOT MEAN SQUARE RADIUS AND SIZES
C=======================================================================
C
      WRITE(NFIPRI,'(79(1H*),/,                     1H*,77X,1H*,/,
     *                 1H*,2X,''ROOT-MEAN-SQUARE AND GEOMETRIC '',
     *                        ''SIZES IN FERMIS'',19X,A8,2X,1H*,/,
     *                                              1H*,77X,1H*,/,
     *                 1H*,2X,''R_RMS ='',F8.4,3X,
     *                     2X,''X_RMS ='',F8.4,2X,
     *                     2X,''Y_RMS ='',F8.4,2X,
     *                     2X,''Z_RMS ='',F8.4,2X,      1H*,/,
     *                                              1H*,77X,1H*,/,
     *                 1H*,2X,''R_GEO ='',F8.4,3X,
     *                     2X,''X_GEO ='',F8.4,2X,
     *                     2X,''Y_GEO ='',F8.4,2X,
     *                     2X,''Z_GEO ='',F8.4,2X,      1H*,/,
     *                                          1H*,77X,1H*,/,
     *                                               79(1H*),/)')
     *
     *           NAMEPN,(RMSPOS(KARTEZ),            KARTEZ=0,NDKART),
     *                   RMSPOS(0     )*SQRT(5.0D0/3.0D0),
     *                  (RMSPOS(KARTEZ)*SQRT(5.0D0),KARTEZ=1,NDKART)
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE CMSPRI(NAMEPN)
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      CHARACTER
     *          NAMEPN*8
C
      COMMON
     *       /SHIFTR/ RSHIFT(1:NDKART)
      COMMON
     *       /CFIPRI/ NFIPRI
C
C=======================================================================
C       THIS SUBROUTINE PRINTS THE CENTER-OF-MASS COORDINATES
C=======================================================================
C
      WRITE(NFIPRI,'(79(1H*),/,                 1H*,77X,1H*,/,
     *                 1H*,2X,''CENTER-OF-MASS COORDINATES IN '',
     *                        ''FERMIS'',29X,A8,2X,1H*,/,
     *                                              1H*,77X,1H*,/,
     *                 1H*,2X,''R_CMS ='',F8.4,3X,
     *                     2X,''X_CMS ='',F8.4,2X,
     *                     2X,''Y_CMS ='',F8.4,2X,
     *                     2X,''Z_CMS ='',F8.4,2X,      1H*,/,
     *                                          1H*,77X,1H*,/,
     *                                               79(1H*),/)')
     *
     *           NAMEPN,
     *           SQRT(RSHIFT(1)**2+RSHIFT(2)**2+RSHIFT(3)**2),
     *           (RSHIFT(KARTEZ),KARTEZ=1,NDKART)
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE EULPRI(NAMEPN)
C
      CHARACTER
     *          NAMEPN*8
C
      COMMON
     *       /EANGLE/ ALPEUL,BETEUL,GAMEUL
      COMMON
     *       /CFIPRI/ NFIPRI
C
C=======================================================================
C     THIS ROUTINE PRINTS THE EULER ANGLES OF THE PRINCIPAL-AXES-FRAME
C=======================================================================
C
      DEGRAD=45/ATAN(1.0D0)
C
      WRITE(NFIPRI,'(79(1H*),/,
     *          1H*,77X,1H*,/,
     *          1H*,2X,''EULER ANGLES OF THE PRINCIPAL-AXES FRAME '',
     *                 ''IN DEGREES'',14X,A8,2X,1H*,/,
     *          1H*,77X,1H*,/,
     *          1H*,2X,''ALPHA ='',F9.5,2X,
     *                 ''BETA ='', F9.5,2X,
     *                 ''GAMMA ='',F9.5,24X,1H*,/,
     *          1H*,77X,1H*,/,
     *          79(1H*),/)')
     *
     *     NAMEPN,ALPEUL*DEGRAD,BETEUL*DEGRAD,GAMEUL*DEGRAD
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE LINPRI(NAMEPN,COR_CM,ALINLI,TLINSQ)
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      CHARACTER
     *          NAMEPN*8
C
      LOGICAL
     *          COR_CM
C
      DIMENSION
     *          ALINLI(0:NDKART)
C
      COMMON
     *       /CFIPRI/ NFIPRI
C
C=======================================================================
C       THIS SUBROUTINE PRINTS THE LINEAR MOMENTA AND THE LINEAR
C       MOMENTUM SQUARED
C=======================================================================
C
      WRITE(NFIPRI,'(79(1H*),/,                 1H*,77X,1H*,/,
     *                 1H*,2X,''LINEAR MOMENTA IN FERMI^(-1)'',
     *                                   37X,A8,2X,1H*,/,
     *                                          1H*,77X,1H*,/,
     *                 1H*,2X,'' P_X  ='',F8.4,2X,
     *                     2X,'' P_Y  ='',F8.4,2X,
     *                     2X,'' P_Z  ='',F8.4,3X,
     *                     2X,''P_R   ='',F8.4,2X,      1H*)')
     *
     *           NAMEPN,
     *           (ALINLI(KARTEZ),KARTEZ=1,NDKART),SQRT(ALINLI(0))
C
      IF (COR_CM)
     *
     *    WRITE(NFIPRI,'(                       1H*,77X,1H*,/,
     *                 1H*,2X,''AVERAGE LINEAR MOMENTUM SQUARED '',
     *                        ''IN FERMI^(-2)                   ='',
     *                     F8.4,2X,                     1H*)')
     *
     *            TLINSQ
C
      WRITE(NFIPRI,'(                           1H*,77X,1H*,/,
     *                                               79(1H*),/)')
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE ROTPRI(NAMEPN,CORROT,AROTLI,TROTSQ)
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      CHARACTER
     *          NAMEPN*8
C
      LOGICAL
     *          CORROT
C
      DIMENSION
     *          AROTLI(0:NDKART)
C
      COMMON
     *       /CFIPRI/ NFIPRI
C
C=======================================================================
C       THIS SUBROUTINE PRINTS THE ANGULAR MOMENTA AND THE ANGULAR
C       MOMENTUM SQUARED
C=======================================================================
C
      WRITE(NFIPRI,'(79(1H*),/,                 1H*,77X,1H*,/,
     *                 1H*,2X,''ANGULAR MOMENTA IN HBAR'',
     *                                   42X,A8,2X,1H*,/,
     *                                          1H*,77X,1H*,/,
     *                 1H*,2X,'' J_X  ='',F8.4,2X,
     *                     2X,'' J_Y  ='',F8.4,2X,
     *                     2X,'' J_Z  ='',F8.4,3X,
     *                     2X,''JOT   ='',F8.4,2X,      1H*)')
     *
     *           NAMEPN,
     *           (AROTLI(KARTEZ),KARTEZ=1,NDKART),SQRT(AROTLI(0))
C
      IF (CORROT)
     *
     *    WRITE(NFIPRI,'(                       1H*,77X,1H*,/,
     *                 1H*,2X,''AVERAGE ANGULAR MOMENTUM SQUARED '',
     *                        ''IN HBAR                        ='',
     *                     F8.4,2X,                     1H*)')
     *
     *            TROTSQ
C
      WRITE(NFIPRI,'(                           1H*,77X,1H*,/,
     *                                               79(1H*),/)')
     *
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE RENPRI(NAMEPN,TRAMAS,IDOGOA)
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      CHARACTER
     *          NAMEPN*8
C
      COMMON
     *       /RENORM/ HBMREN(NDKART)
      COMMON
     *       /RENGOA/ GOAREN(NDKART)
      COMMON
     *       /CFIPRI/ NFIPRI
C
C=======================================================================
C       THIS SUBROUTINE PRINTS THE RENORMALIZED TRANSLATIONAL MASSES
C=======================================================================
C
      HBMTOT=SQRT((HBMREN(1)**2+HBMREN(2)**2+HBMREN(3)**2)/3)
      TRATOT=TRAMAS*SQRT(((-HBMREN(1))**(-2)
     *                   +(-HBMREN(2))**(-2)
     *                   +(-HBMREN(3))**(-2))/3)
C
      WRITE(NFIPRI,'(79(1H*),/,                 1H*,77X,1H*,/,
     *                 1H*,1X,'' RENORMALIZED MASSES IN MEV*FERMI^2'',
     *                        '' AND RATIOS W.R. TO M*A'',
     *                                         8X,A8,2X,1H*,/,
     *                                          1H*,77X,1H*,/,
     *                 1H*,2X,'' M_X  ='',F10.6,
     *                     2X,'' M_Y  ='',F10.6,
     *                     2X,'' M_Z  ='',F10.6,1X,
     *                     2X,''M_R   ='',F8.4,2X,      1H*,/,
     *                                          1H*,77X,1H*,/,
     *                 1H*,2X,'' F_X  ='',F10.6,
     *                     2X,'' F_Y  ='',F10.6,
     *                     2X,'' F_Z  ='',F10.6,1X,
     *                     2X,''F_R   ='',F8.4,2X,      1H*,/,
     *                                          1H*,77X,1H*)')
     *
     *           NAMEPN,
     *           (-HBMREN(KARTEZ)         ,KARTEZ=1,NDKART),HBMTOT,
     *           (TRAMAS/(-HBMREN(KARTEZ)),KARTEZ=1,NDKART),TRATOT
C
C=======================================================================
C        IF THE LIPKIN RENORMALIZED MASSES ARE USED, HERE THE GOE MASSES
C        ARE PRINTED FOR REFERENCE ONLY
C=======================================================================
C
      IF (IDOGOA.EQ.1) GO TO 1
C
C=======================================================================
C
      HBMTOT=SQRT((GOAREN(1)**2+GOAREN(2)**2+GOAREN(3)**2)/3)
      TRATOT=TRAMAS*SQRT(((-GOAREN(1))**(-2)
     *                   +(-GOAREN(2))**(-2)
     *                   +(-GOAREN(3))**(-2))/3)
C
      WRITE(NFIPRI,'(79(1H*),/,                 1H*,77X,1H*,/,
     *                 1H*,1X,'' GAUSSIAN-OVERLAP MASSES'',
     *                        '' IN MEV*FERMI^2 AND RATIOS'',
     *                        '' W.R. TO M*A'',4X,A8,2X,1H*,/,
     *                                          1H*,77X,1H*,/,
     *                 1H*,2X,'' M_X  ='',F10.6,
     *                     2X,'' M_Y  ='',F10.6,
     *                     2X,'' M_Z  ='',F10.6,1X,
     *                     2X,''M_R   ='',F8.4,2X,      1H*,/,
     *                                          1H*,77X,1H*,/,
     *                 1H*,2X,'' F_X  ='',F10.6,
     *                     2X,'' F_Y  ='',F10.6,
     *                     2X,'' F_Z  ='',F10.6,1X,
     *                     2X,''F_R   ='',F8.4,2X,      1H*,/,
     *                                          1H*,77X,1H*)')
     *
     *           NAMEPN,
     *           (-GOAREN(KARTEZ)         ,KARTEZ=1,NDKART),HBMTOT,
     *           (TRAMAS/(-GOAREN(KARTEZ)),KARTEZ=1,NDKART),TRATOT
C
C=======================================================================
C
    1 CONTINUE
C
C=======================================================================
C
      WRITE(NFIPRI,'(79(1H*),/)')
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE RESPRI(IWRIRE,IWRIYU,IWRIFI,IWRIGO,IWRILI,I_YUKA,
     *                  I_GOGA,JETACM,KETA_R,LIPKIN,LIPKIP,ICOUDI,
     *                                                     ICOUEX)
      COMMON
     *       /CFIPRI/ NFIPRI
C
C=======================================================================
C      THIS ROUTINE PRINTS OUT INFORMATION ON THE VARIOUS FILES THAT
C      ARE READ/WRITTEN IN THIS RUN
C=======================================================================
C
      IF (IWRIRE.NE.1) THEN
C
          IF (IWRIRE.NE.-1) THEN
C
              WRITE(NFIPRI,'(79(1H*),/,1H*,77X,1H*,/,
     *              1H*,''  THE RECORD FILE WILL BE SAVED ONLY'',
     *                  '' AFTER THE LAST ITERATION IS COMPLETED'',
     *                                                      3X,1H*,/,
     *              1H*,                          77X,1H*,/,79(1H*),/)')
C
          ELSE
C
              WRITE(NFIPRI,'(79(1H*),/,1H*,77X,1H*,/,
     *              1H*,''  THE RECORD FILE WILL NOT BE SAVED;'',
     *                  '' AND THIS RUN CANNOT BE LATER CONTINUED''
     *                                                     ,2X,1H*,/,
     *              1H*,                          77X,1H*,/,79(1H*),/)')
C
         END IF
C
      END IF
C
C=======================================================================
C
      IF (IWRIYU.NE.1.AND.I_YUKA.GE.2) THEN
C
          IF (IWRIYU.NE.-1) THEN
C
              WRITE(NFIPRI,'(79(1H*),/,1H*,77X,1H*,/,
     *              1H*,''  THE YUKAWA FILE WILL BE SAVED ONLY'',
     *                  '' AFTER THE LAST ITERATION IS COMPLETED'',
     *                                                      3X,1H*,/,
     *              1H*,                          77X,1H*,/,79(1H*),/)')
C
          ELSE
C
              IF (IWRIFI.EQ.-1) THEN
C
                  WRITE(NFIPRI,'(79(1H*),/,1H*,77X,1H*,/,
     *              1H*,''  THE YUKAWA FILE WILL NOT BE SAVED'',
     *                  '' AND THE YUKAWA CALC CANNOT BE CONTINUED''
     *                                                     ,2X,1H*,/,
     *              1H*,                          77X,1H*,/,79(1H*),/)')
C
              ELSE
C
                  WRITE(NFIPRI,'(79(1H*),/,1H*,77X,1H*,/,
     *              1H*,''  THE YUKAWA FILE WILL NOT BE SAVED'',
     *                  '' - BUT YUKAWA CALC CAN BE CONTD FROM FLDS''
     *                                                     ,2X,1H*,/,
     *              1H*,                          77X,1H*,/,79(1H*),/)')
C
              END IF
C
          END IF
C
      END IF
C
      IF (IWRIGO.NE.1.AND.I_GOGA.GE.2) THEN
C
          IF (IWRIGO.NE.-1) THEN
C
              WRITE(NFIPRI,'(79(1H*),/,1H*,77X,1H*,/,
     *              1H*,''  THE GOGNY  FILE WILL BE SAVED ONLY'',
     *                  '' AFTER THE LAST ITERATION IS COMPLETED'',
     *                                                      3X,1H*,/,
     *              1H*,                          77X,1H*,/,79(1H*),/)')
C
          ELSE
C
              IF (IWRIFI.EQ.-1) THEN
C
                  WRITE(NFIPRI,'(79(1H*),/,1H*,77X,1H*,/,
     *              1H*,''  THE GOGNY  FILE WILL NOT BE SAVED'',
     *                  '' AND THE GOGNY  CALC CANNOT BE CONTINUED''
     *                                                     ,2X,1H*,/,
     *              1H*,                          77X,1H*,/,79(1H*),/)')
C
              ELSE
C
                  WRITE(NFIPRI,'(79(1H*),/,1H*,77X,1H*,/,
     *              1H*,''  THE GOGNY FILE WILL NOT BE SAVED'',
     *                  '' - BUT GOGNY CALC CAN BE CONTD FROM FIELDS''
     *                                                     ,2X,1H*,/,
     *              1H*,                          77X,1H*,/,79(1H*),/)')
C
              END IF
C
          END IF
C
      END IF
C
C=======================================================================
C
      IF (IWRIFI.EQ.-1.AND.JETACM.EQ.2) THEN
C
          WRITE(NFIPRI,'(79(1H*),/,1H*,77X,1H*,/,
     *      1H*,''  THE FIELDS FILE WILL NOT BE SAVED'',
     *          '' AND THE CM CORRECT. CANNOT BE CONTINUED''
     *                                             ,2X,1H*,/,
     *      1H*,                          77X,1H*,/,79(1H*),/)')
C
      END IF
C
C=======================================================================
C
      IF (IWRIFI.EQ.-1.AND.KETA_R.EQ.2) THEN
C
          WRITE(NFIPRI,'(79(1H*),/,1H*,77X,1H*,/,
     *      1H*,''  THE FIELDS FILE WILL NOT BE SAVED'',
     *          '' AND THE ROTL CORRCT CANNOT BE CONTINUED''
     *                                             ,2X,1H*,/,
     *      1H*,                          77X,1H*,/,79(1H*),/)')
C
      END IF
C
C=======================================================================
C
      IF (IWRILI.NE.1.AND.(LIPKIN.EQ.1.OR.LIPKIP.EQ.1)) THEN
C
          IF (IWRILI.NE.-1) THEN
C
              WRITE(NFIPRI,'(79(1H*),/,1H*,77X,1H*,/,
     *              1H*,''  THE LIPKIN FILE WILL BE SAVED ONLY'',
     *                  '' AFTER THE LAST ITERATION IS COMPLETED'',
     *                                                      3X,1H*,/,
     *              1H*,                          77X,1H*,/,79(1H*),/)')
C
          ELSE
C
              IF (IWRIFI.EQ.-1) THEN
C
                  WRITE(NFIPRI,'(79(1H*),/,1H*,77X,1H*,/,
     *              1H*,''  THE LIPKIN FILE WILL NOT BE SAVED,'',
     *                  '' THUS LIPKIN METHOD CANNOT BE CONTINUED''
     *                                                     ,2X,1H*,/,
     *              1H*,                          77X,1H*,/,79(1H*),/)')
C
             ELSE
C
                  WRITE(NFIPRI,'(79(1H*),/,1H*,77X,1H*,/,
     *              1H*,''  THE LIPKIN FILE WILL NOT BE SAVED,'',
     *                  '' BUT LIPKIN CALC CAN BE CONTD FROM FLDS''
     *                                                     ,2X,1H*,/,
     *              1H*,                          77X,1H*,/,79(1H*),/)')
C
             END IF
C
         END IF
C
      END IF
C
C=======================================================================
C
      IF (IWRIFI.NE.1) THEN
C
          IF (IWRIFI.NE.-1) THEN
C
              WRITE(NFIPRI,'(79(1H*),/,1H*,77X,1H*,/,
     *              1H*,''  THE FIELDS FILE WILL BE SAVED ONLY'',
     *                  '' AFTER THE LAST ITERATION IS COMPLETED'',
     *                                                      3X,1H*,/,
     *              1H*,                          77X,1H*,/,79(1H*),/)')
          ELSE
C
             IF (ICOUDI.EQ.2.OR.ICOUEX.EQ.2)
     *
     *            WRITE(NFIPRI,'(79(1H*),/,1H*,77X,1H*,/,
     *              1H*,''  THE FIELDS FILE WILL NOT BE SAVED,'',
     *                  '' THUS EXACT COULOMB CANNOT BE CONTINUED''
     *                                                     ,2X,1H*,/,
     *              1H*,                          77X,1H*,/,79(1H*),/)')
C
          END IF
C
      END IF
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE ANGPRI(IMOVAX,ISIMPY,ISHIFT,INTRIP)
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      CHARACTER
     *          ANGLEC*8
C
      COMMON
     *       /ANGANG/ ANGU_N(1:NDKART),ANGU_P(1:NDKART),ANGU_T(1:NDKART)
      COMMON
     *       /ANGSPI/ SPIN_N(1:NDKART),SPIN_P(1:NDKART),SPIN_T(1:NDKART)
      COMMON
     *       /SHIANG/ ANGS_N(1:NDKART),ANGS_P(1:NDKART),ANGS_T(1:NDKART)
      COMMON
     *       /ROTANG/ ANGR_N(1:NDKART),ANGR_P(1:NDKART),ANGR_T(1:NDKART)
      COMMON
     *       /ROTSPI/ SPIR_N(1:NDKART),SPIR_P(1:NDKART),SPIR_T(1:NDKART)
      COMMON
     *       /OMOVAS/ OMOVAX,OMOVAY,OMOVAZ
      COMMON
     *       /OMISOS/ OMISOX,OMISOY,OMISOZ
      COMMON
     *       /CFIPRI/ NFIPRI
C
C=======================================================================
C         THIS SUBROUTINE PRINTS THE AVERAGE VALUES OF ANGULAR MOMENTA
C=======================================================================
C
      IF (ISIMPY.EQ.1) THEN
C
C=======================================================================
C         CASE OF CONSERVED Y-SIMPLEX
C=======================================================================
C
          WRITE(NFIPRI,'(79(1H*),/,                1H*,77X,1H*,/,
     *                 1H*,2X,''ANGULAR MOMENTA AND THE FIRST '',
     *                        ''MOMENTS OF INERTIA'',  27X,1H*,/,
     *                                             1H*,77X,1H*,/,
     *                                                 79(1H*),/,
     *                                             1H*,77X,1H*,/,
     *                 1H*,1X,13X,2X,10X,''  SPINS   '',10X,
     *                            2X,10X,''   J(1)   '',7X,
     *                                                  2X,1H*,/,
     *                 1H*,1X,13X,2X,''---------------------------   '',
     *                            2X,''---------------------------'',
     *                                                  2X,1H*,/,
     *                 1H*,1X,13X,2X,''ORBITAL   INTRINSIC   TOTAL   '',
     *                            2X,''ORBITAL   INTRINSIC   TOTAL'',
     *                                                  2X,1H*,/,
     *                                             1H*,77X,1H*)')
C
          OMEGAN=OMOVAY+OMISOY
          OMEGAP=OMOVAY-OMISOY
C
          IF (ABS(OMEGAN).GT.1.0D-06.AND.
     *        ABS(OMEGAP).GT.1.0D-06.AND.
     *        ABS(OMOVAY).GT.1.0D-06) THEN
C
              WRITE(NFIPRI,'(1H*,1X,'' NEUTRONS '',2(2X,3F10.5),
     *                                                       2X,1H*,/,
     *                       1H*,1X,''  PROTONS '',2(2X,3F10.5),
     *                                                       2X,1H*,/,
     *                       1H*,1X,'' -------- '',         66X,1H*,/,
     *                       1H*,1X,''    TOTAL '',2(2X,3F10.5),
     *                                                       2X,1H*,/,
     *                                                  1H*,77X,1H*)')
     *
     *                ANGU_N(2)-SPIN_N(2),SPIN_N(2),ANGU_N(2),
     *               (ANGU_N(2)-SPIN_N(2))/OMEGAN,
     *                SPIN_N(2)/OMEGAN,ANGU_N(2)/OMEGAN,
     *
     *                ANGU_P(2)-SPIN_P(2),SPIN_P(2),ANGU_P(2),
     *               (ANGU_P(2)-SPIN_P(2))/OMEGAP,
     *                SPIN_P(2)/OMEGAP,ANGU_P(2)/OMEGAP,
     *
     *                ANGU_T(2)-SPIN_T(2),SPIN_T(2),ANGU_T(2),
     *               (ANGU_T(2)-SPIN_T(2))/OMOVAY,
     *                SPIN_T(2)/OMOVAY,ANGU_T(2)/OMOVAY
C
          ELSE
C
              WRITE(NFIPRI,'(1H*,1X,'' NEUTRONS '', (2X,3F10.5),
     *                                                      34X,1H*,/,
     *                       1H*,1X,''  PROTONS '', (2X,3F10.5),
     *                                                      34X,1H*,/,
     *                       1H*,1X,'' -------- '',         66X,1H*,/,
     *                       1H*,1X,''    TOTAL '', (2X,3F10.5),
     *                                                      34X,1H*,/,
     *                                                  1H*,77X,1H*)')
     *
     *                ANGU_N(2)-SPIN_N(2),SPIN_N(2),ANGU_N(2),
     *                ANGU_P(2)-SPIN_P(2),SPIN_P(2),ANGU_P(2),
     *                ANGU_T(2)-SPIN_T(2),SPIN_T(2),ANGU_T(2)
C
          END IF
C
          IF (ISHIFT.NE.0) THEN
C
              WRITE(NFIPRI,'(79(1H*),/,            1H*,77X,1H*,/,
     *                 1H*,2X,''ANGULAR MOMENTA IN THE CENTER-'',
     *                        ''OF-MASS REFERENCE FRAME'',
     *                                                 22X,1H*,/,
     *                                             1H*,77X,1H*,/,
     *                                                 79(1H*),/,
     *                                             1H*,77X,1H*,/,
     *                 1H*,1X,13X,2X,10X,''  SPINS   '',10X,
     *                            2X,10X,''   J(1)   '',7X,
     *                                                  2X,1H*,/,
     *                 1H*,1X,13X,2X,''---------------------------   '',
     *                            2X,''---------------------------'',
     *                                                  2X,1H*,/,
     *                 1H*,1X,13X,2X,''ORBITAL   INTRINSIC   TOTAL   '',
     *                            2X,''ORBITAL   INTRINSIC   TOTAL'',
     *                                                  2X,1H*,/,
     *                                             1H*,77X,1H*)')
C
              IF (ABS(OMEGAN).GT.1.0D-06.AND.
     *            ABS(OMEGAP).GT.1.0D-06.AND.
     *            ABS(OMOVAY).GT.1.0D-06) THEN
C
                  WRITE(NFIPRI,'(
     *                  1H*,1X,'' NEUTRONS '',2(2X,3F10.5),
     *                                                  2X,1H*,/,
     *                  1H*,1X,''  PROTONS '',2(2X,3F10.5),
     *                                                  2X,1H*,/,
     *                  1H*,1X,'' -------- '',          66X,1H*,/,
     *                  1H*,1X,''    TOTAL '',2(2X,3F10.5),
     *                                                  2X,1H*,/,
     *                                            1H*,77X,1H*)')
     *
     *                ANGS_N(2)-SPIN_N(2),SPIN_N(2),ANGS_N(2),
     *               (ANGS_N(2)-SPIN_N(2))/OMEGAN,
     *                SPIN_N(2)/OMEGAN,ANGS_N(2)/OMEGAN,
     *
     *                ANGS_P(2)-SPIN_P(2),SPIN_P(2),ANGS_P(2),
     *               (ANGS_P(2)-SPIN_P(2))/OMEGAP,
     *                SPIN_P(2)/OMEGAP,ANGS_P(2)/OMEGAP,
     *
     *                ANGS_T(2)-SPIN_T(2),SPIN_T(2),ANGS_T(2),
     *               (ANGS_T(2)-SPIN_T(2))/OMOVAY,
     *                SPIN_T(2)/OMOVAY,ANGS_T(2)/OMOVAY
C
              ELSE
C
                  WRITE(NFIPRI,'(
     *                  1H*,1X,'' NEUTRONS '', (2X,3F10.5),
     *                                                 34X,1H*,/,
     *                  1H*,1X,''  PROTONS '', (2X,3F10.5),
     *                                                 34X,1H*,/,
     *                  1H*,1X,'' -------- '',          66X,1H*,/,
     *                  1H*,1X,''    TOTAL '', (2X,3F10.5),
     *                                                 34X,1H*,/,
     *                                            1H*,77X,1H*)')
     *
     *                ANGS_N(2)-SPIN_N(2),SPIN_N(2),ANGS_N(2),
     *                ANGS_P(2)-SPIN_P(2),SPIN_P(2),ANGS_P(2),
     *                ANGS_T(2)-SPIN_T(2),SPIN_T(2),ANGS_T(2)
C
              END IF
C
          END IF
C
      ELSE
C
C=======================================================================
C         CASE OF NON-CONSERVED Y-SIMPLEX
C=======================================================================
C
          WRITE(NFIPRI,'(79(1H*),/,                1H*,77X,1H*,/,
     *                 1H*,2X,''ANGULAR MOMENTA IN THE THREE C'',
     *                        ''ARTESIAN DIRECTIONS'', 26X,1H*,/,
     *                                             1H*,77X,1H*,/,
     *                                                 79(1H*),/,
     *                                             1H*,77X,1H*,/,
     *                 1H*,12X,''SPIN IN X-DIRECTION'', 2X,
     *                      1X,''SPIN IN Y-DIRECTION'', 2X,
     *                      1X,''SPIN IN Z-DIRECTION'', 2X,1H*,/,
     *                 1H*,12X,''-------------------'', 2X,
     *                      1X,''-------------------'', 2X,
     *                      1X,''-------------------'', 2X,1H*,/,
     *                 1H*,12X,''INTRI  ORBIT  TOTAL'', 2X,
     *                      1X,''INTRI  ORBIT  TOTAL'', 2X,
     *                      1X,''INTRI  ORBIT  TOTAL'', 2X,1H*,/,
     *                                             1H*,77X,1H*)')
C
          WRITE(NFIPRI,'(1H*, 1X,'' NEUTRONS'',3(3F7.3,1X),
     *                                                    1X,1H*,/,
     *                   1H*, 1X,''  PROTONS'',3(3F7.3,1X),
     *                                                    1X,1H*,/,
     *                   1H*, 1X,'' --------'',          67X,1H*,/,
     *                   1H*, 1X,''    TOTAL'',3(3F7.3,1X),
     *                                                    1X,1H*,/,
     *                                               1H*,77X,1H*)')
     *
     *             (SPIN_N(L),ANGU_N(L)-SPIN_N(L),ANGU_N(L),L=1,NDKART),
     *             (SPIN_P(L),ANGU_P(L)-SPIN_P(L),ANGU_P(L),L=1,NDKART),
     *             (SPIN_T(L),ANGU_T(L)-SPIN_T(L),ANGU_T(L),L=1,NDKART)
C
C=======================================================================
C
          IF (IMOVAX.NE.0)
     *        WRITE(NFIPRI,'(79(1H*),/,
     *                  1H*,77X,1H*,/,
     *                  1H*,2X,''ROTATIONAL FREQUENCIES IN THE THREE '',
     *                         ''CARTESIAN DIRECTIONS:'', 18X,1H*,/,
     *                  1H*,77X,1H*,/
     *                  1H*,2X,''OMEGAX ='',F9.6,2X,''OMEGAY ='',F9.6,
     *                         2X,''OMEGAZ ='',F9.6,2X,
     *                         ''OMEGA ='',F9.6,
     *                         2X,1H*,/,
     *                  1H*,77X,1H*)')
     *
     *        OMOVAX,OMOVAY,OMOVAZ,
     *        SQRT(OMOVAX**2+OMOVAY**2+OMOVAZ**2)
C
C=======================================================================
C
          OMETOT=OMOVAX   **2+OMOVAY   **2+OMOVAZ   **2
          ANGTOT=ANGU_T(1)**2+ANGU_T(2)**2+ANGU_T(3)**2
          ANGLET=0.0
C
          IF (OMETOT.GT.0.0.AND.ANGTOT.GT.0.0) THEN
C
              SINANG=1-( OMOVAX*ANGU_T(1)
     *                  +OMOVAY*ANGU_T(2)
     *                  +OMOVAZ*ANGU_T(3))**2/OMETOT/ANGTOT
C
              IF (ABS(SINANG).LE.1.0D0)
     *
     *            ANGLET=ASIN(SINANG)*45.0D0/ATAN(1.0D0)
C
          END IF
C
          OMETOT=SQRT(OMETOT)
          ANGTOT=SQRT(ANGTOT)
C
C=======================================================================
C
          IF (ABS(ANGLET).GE.1E-2.OR.ANGLET.EQ.0.0) THEN
C
              WRITE(ANGLEC,'(F8.3)')     ANGLET
          ELSE
              WRITE(ANGLEC,'((1PE8.1))') ANGLET
C
          END IF
C
          WRITE(NFIPRI,'(79(1H*),/,                1H*,77X,1H*,/,
     *                 1H*,2X,''ANGLE BETWEEN ANGULAR MOMENTUM '',
     *                        ''AND ANGULAR FREQUENCY VECTORS='',
     *                                      A8,'' DEG'',2X,1H*,/,
     *                                             1H*,77X,1H*)')
     *        ANGLEC
C
C=======================================================================
C
          IF (ISHIFT.NE.0) THEN
C
              WRITE(NFIPRI,'(79(1H*),/,            1H*,77X,1H*,/,
     *                 1H*,2X,''ANGULAR MOMENTA IN THE CENTER-'',
     *                        ''OF-MASS REFERENCE FRAME'',
     *                                                 22X,1H*,/,
     *                                             1H*,77X,1H*,/,
     *                                                 79(1H*),/,
     *                                             1H*,77X,1H*,/,
     *                 1H*,12X,''SPIN IN X-DIRECTION'', 2X,
     *                      1X,''SPIN IN Y-DIRECTION'', 2X,
     *                      1X,''SPIN IN Z-DIRECTION'', 2X,1H*,/,
     *                 1H*,12X,''-------------------'', 2X,
     *                      1X,''-------------------'', 2X,
     *                      1X,''-------------------'', 2X,1H*,/,
     *                 1H*,12X,''INTRI  ORBIT  TOTAL'', 2X,
     *                      1X,''INTRI  ORBIT  TOTAL'', 2X,
     *                      1X,''INTRI  ORBIT  TOTAL'', 2X,1H*,/,
     *                                             1H*,77X,1H*)')
C
              WRITE(NFIPRI,'(1H*, 1X,'' NEUTRONS'',3(3F7.3,1X),
     *                                                        1X,1H*,/,
     *                       1H*, 1X,''  PROTONS'',3(3F7.3,1X),
     *                                                        1X,1H*,/,
     *                       1H*, 1X,'' --------'',          67X,1H*,/,
     *                       1H*, 1X,''    TOTAL'',3(3F7.3,1X),
     *                                                        1X,1H*,/,
     *                                                   1H*,77X,1H*)')
     *
     *             (SPIN_N(L),ANGS_N(L)-SPIN_N(L),ANGS_N(L),L=1,NDKART),
     *             (SPIN_P(L),ANGS_P(L)-SPIN_P(L),ANGS_P(L),L=1,NDKART),
     *             (SPIN_T(L),ANGS_T(L)-SPIN_T(L),ANGS_T(L),L=1,NDKART)
C
          END IF
C
      END IF
C
C=======================================================================
C         HERE WE PRINT THE ANGULAR MOMENTA IN THE INTRINSIC FRAME.
C         IRRESPECTIVE OF WHETHER SIMPLEX IS CONSERVED OR  NOT,  WE
C         ALWAYS PRINT ALL THREE CARTESIAN COMPONENTS, BECAUSE EVEN
C         FOR A CONSERVED SIMPLEX, THE NON-ZERO  Y-COMPONENT  COULD
C         END UP IN THE INTRINSIC FRAME IN ANOTHER DIRECTION.
C=======================================================================
C
      IF (INTRIP.NE.0) THEN
C
          WRITE(NFIPRI,'(79(1H*),/,                1H*,77X,1H*,/,
     *                 1H*,2X,''ANGULAR MOMENTA IN THE INTRINS'',
     *                        ''IC REFERENCE FRAME'',
     *                                                 27X,1H*,/,
     *                                             1H*,77X,1H*,/,
     *                                                 79(1H*),/,
     *                                             1H*,77X,1H*,/,
     *                 1H*,12X,''SPIN IN X-DIRECTION'', 2X,
     *                      1X,''SPIN IN Y-DIRECTION'', 2X,
     *                      1X,''SPIN IN Z-DIRECTION'', 2X,1H*,/,
     *                 1H*,12X,''-------------------'', 2X,
     *                      1X,''-------------------'', 2X,
     *                      1X,''-------------------'', 2X,1H*,/,
     *                 1H*,12X,''INTRI  ORBIT  TOTAL'', 2X,
     *                      1X,''INTRI  ORBIT  TOTAL'', 2X,
     *                      1X,''INTRI  ORBIT  TOTAL'', 2X,1H*,/,
     *                                             1H*,77X,1H*)')
C
          WRITE(NFIPRI,'(1H*, 1X,'' NEUTRONS'',3(3F7.3,1X),
     *                                                    1X,1H*,/,
     *                   1H*, 1X,''  PROTONS'',3(3F7.3,1X),
     *                                                    1X,1H*,/,
     *                   1H*, 1X,'' --------'',          67X,1H*,/,
     *                   1H*, 1X,''    TOTAL'',3(3F7.3,1X),
     *                                                    1X,1H*,/,
     *                                               1H*,77X,1H*)')
     *
     *             (SPIR_N(L),ANGR_N(L)-SPIR_N(L),ANGR_N(L),L=1,NDKART),
     *             (SPIR_P(L),ANGR_P(L)-SPIR_P(L),ANGR_P(L),L=1,NDKART),
     *             (SPIR_T(L),ANGR_T(L)-SPIR_T(L),ANGR_T(L),L=1,NDKART)
C
      END IF
C
      WRITE(NFIPRI,'(79(1H*),/)')
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE ISOPRI(NFIISO)
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      DIMENSION
     *          Z_AXIS(1:NDKART)
C
      COMMON
     *       /ITERTS/ ITESTA,ITESTO,NOITER,NUMITE
      COMMON
     *       /OMOVAS/ OMOVAX,OMOVAY,OMOVAZ
      COMMON
     *       /EANGLE/ ALPEUL,BETEUL,GAMEUL
      COMMON
     *       /QMULTI/ QMUL_N(0:NDMULT,-NDMULT:NDMULT),
     *                QMUL_P(0:NDMULT,-NDMULT:NDMULT),
     *                QMUL_T(0:NDMULT,-NDMULT:NDMULT)
      COMMON
     *       /QROTAT/ QROT_N(0:NDMULT,-NDMULT:NDMULT),
     *                QROT_P(0:NDMULT,-NDMULT:NDMULT),
     *                QROT_T(0:NDMULT,-NDMULT:NDMULT)
      COMMON
     *       /ANGANG/ ANGU_N(1:NDKART),
     *                ANGU_P(1:NDKART),
     *                ANGU_T(1:NDKART)
      COMMON
     *       /ANGSPI/ SPIN_N(1:NDKART),
     *                SPIN_P(1:NDKART),
     *                SPIN_T(1:NDKART)
C
      PI=4.0D0*ATAN(1.0D0)
      DEGRAD=180/PI
C
      OMEGA=SQRT(OMOVAX**2+OMOVAY**2+OMOVAZ**2)
C
      Z_AXIS(1)=SIN(BETEUL)*COS(ALPEUL)
      Z_AXIS(2)=SIN(BETEUL)*SIN(ALPEUL)
      Z_AXIS(3)=COS(BETEUL)
C
      ANGTOT=SQRT(ANGU_T(1)**2+ANGU_T(2)**2+ANGU_T(3)**2)
      ANGNEU=SQRT(ANGU_N(1)**2+ANGU_N(2)**2+ANGU_N(3)**2)
      ANGPRO=SQRT(ANGU_P(1)**2+ANGU_P(2)**2+ANGU_P(3)**2)
C
      IF (OMEGA*ANGTOT.NE.0.) THEN
          ANGUWJ=ACOS((OMOVAX*ANGU_T(1)
     *                +OMOVAY*ANGU_T(2)
     *                +OMOVAZ*ANGU_T(3))/(OMEGA*ANGTOT))
      ELSE
          ANGUWJ=0.
      END IF
C
      IF (ANGTOT.NE.0.) THEN
          ANGUZJ=ACOS((Z_AXIS(1)*ANGU_T(1)
     *                +Z_AXIS(2)*ANGU_T(2)
     *                +Z_AXIS(3)*ANGU_T(3))/(1*ANGTOT))
      ELSE
          ANGUZJ=0.
      END IF
C
      IF (ANGNEU*ANGPRO.NE.0.) THEN
          ANGUNP=ACOS((ANGU_N(1)*ANGU_P(1)
     *                +ANGU_N(2)*ANGU_P(2)
     *                +ANGU_N(3)*ANGU_P(3))/(ANGNEU*ANGPRO))
      ELSE
          ANGUNP=0.
      END IF
C
      WRITE(NFIISO,'(1H*,1X,I4,2X,
     *               F4.0,1X,F4.0,1X,F4.0,2X,
     *               F7.3,1X,F7.3,1X,F7.3,2X,
     *               F7.3,1X,F7.3,1X,F7.3,1X,F7.3,1X,F7.3,2X,
     *               F5.1,1X,F5.1,1X,F5.1,2X,
     *               F5.1,1X,F5.1,1X,F5.1,3X,
     *               F4.0,1X,F4.0,1X,F4.0)')
     *
     *      NUMITE,
     *      ALPEUL*DEGRAD,BETEUL*DEGRAD,GAMEUL*DEGRAD,
     *      QMUL_T(1,-1),QMUL_T(1, 0),QMUL_T(1, 1),
     *      QROT_T(2,-2),QROT_T(2,-1),QROT_T(2, 0),
     *                   QROT_T(2, 1),QROT_T(2, 2),
     *      ANGU_T(1),ANGU_T(2),ANGU_T(3),
     *      SPIN_T(1),SPIN_T(2),SPIN_T(3),
     *      ANGUWJ*DEGRAD,
     *      ANGUZJ*DEGRAD,
     *      ANGUNP*DEGRAD
C
      WRITE(NFIISO,'(1H*,23X,
     *               F7.3,1X,F7.3,1X,F7.3,2X,
     *               F7.3,1X,F7.3,1X,F7.3,1X,F7.3,1X,F7.3,2X,
     *               F5.1,1X,F5.1,1X,F5.1,2X,
     *               F5.1,1X,F5.1,1X,F5.1)')
     *
     *      QROT_N(1,-1),QROT_N(1, 0),QROT_N(1, 1),
     *      QROT_N(2,-2),QROT_N(2,-1),QROT_N(2, 0),
     *                   QROT_N(2, 1),QROT_N(2, 2),
     *      ANGU_N(1),ANGU_N(2),ANGU_N(3),
     *      SPIN_N(1),SPIN_N(2),SPIN_N(3)
C
      WRITE(NFIISO,'(1H*,23X,
     *               F7.3,1X,F7.3,1X,F7.3,2X,
     *               F7.3,1X,F7.3,1X,F7.3,1X,F7.3,1X,F7.3,2X,
     *               F5.1,1X,F5.1,1X,F5.1,2X,
     *               F5.1,1X,F5.1,1X,F5.1)')
     *
     *      QROT_P(1,-1),QROT_P(1, 0),QROT_P(1, 1),
     *      QROT_P(2,-2),QROT_P(2,-1),QROT_P(2, 0),
     *                   QROT_P(2, 1),QROT_P(2, 2),
     *      ANGU_P(1),ANGU_P(2),ANGU_P(3),
     *      SPIN_P(1),SPIN_P(2),SPIN_P(3)
C
      WRITE(NFIISO,'(1H*)')
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE INTCEN(NXMAXX,NYMAXX,NZMAXX,SONBAS,
     *                  KARTEZ,ISIMPY,HPPCEN,HPMCEN)
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      COMPLEX
     *          SONBAS(0:ND2MAX,0:ND2MAX,0:ND2MAX)
      COMPLEX
     *          HPPCEN(1:NDBASE,1:NDBASE),
     *          HPMCEN(1:NDBASE,1:NDBASE)
      COMPLEX
     *          Y_HELP(0:ND2MAX)
      COMPLEX
     *          X_HELP(0:ND2MAX,0:ND2MAX)
      COMPLEX
     *          Z_HELP(0:NDOSCI,0:NDOSCI)
      COMPLEX
     *          RESULT,C_ZERO
C
      COMMON
     *       /T_PHAS/ IPHAPP(0:NDYMAX,0:NDYMAX,0:NDKART),
     *                IPHAPM(0:NDYMAX,0:NDYMAX,0:NDKART),
     *                IPHAMP(0:NDYMAX,0:NDYMAX,0:NDKART),
     *                IPHAMM(0:NDYMAX,0:NDYMAX,0:NDKART)
      COMMON
     *       /COEXYZ/ COEF00(0:ND2MAX,0:NDOSCI,0:NDOSCI,1:NDKART),
     *                COEF01(0:ND2MAX,0:NDOSCI,0:NDOSCI,1:NDKART),
     *                COEF11(0:ND2MAX,0:NDOSCI,0:NDOSCI,1:NDKART),
     *                COEF02(0:ND2MAX,0:NDOSCI,0:NDOSCI,1:NDKART)
      COMMON
     *       /BINDEX/ INDICE(0:NDXMAX,0:NDYMAX,0:NDZMAX)
     *
     *       /BLIMS1/ LAXOFY(0:NDYMAX),LAXOFZ(0:NDZMAX),
     *                LAYOFZ(0:NDZMAX),LAYOFX(0:NDXMAX),
     *                LAZOFX(0:NDXMAX),LAZOFY(0:NDYMAX)
     *
     *       /BLIMS2/ LAXOYZ(0:NDYMAX,0:NDZMAX),
     *                LAYOZX(0:NDZMAX,0:NDXMAX),
     *                LAZOXY(0:NDXMAX,0:NDYMAX)
      COMMON
     *       /DIMENS/ LDBASE
C
C=======================================================================
C
      CALL CPUTIM('INTCEN',1)
C
C=======================================================================
C        THIS SUBROUTINE PERFORMS  THE  GAUSS - HERMITE INTEGRATIONS
C        OF THE MATRIX ELEMENTS OF THE CENTRAL TERM IN THE POTENTIAL
C=======================================================================
C
      C_ZERO=CMPLX(0.0D0,0.0D0)
C
C=======================================================================
C
C        VECTORIZATION COMMENT:
C        PLEASE REFER TO THE COMMENT IN THE "INTCOU" SUBROUTINE
C
C=======================================================================
C
      HPPCEN(:,:)=C_ZERO
      HPMCEN(:,:)=C_ZERO
C
C=======================================================================
C        HERE BEGIN LOOPS OVER THE QUANTUM NUMBERS IN THE X DIRECTION
C=======================================================================
C
      DO NX=0,NXMAXX
         DO MX=0,NXMAXX
C
            DO KY=0,2*NYMAXX
               DO KZ=0,2*NZMAXX
C
                  RESULT=C_ZERO
C
                  DO KX=NX+MX,0,-2
                     RESULT=RESULT+COEF00(KX,MX,NX,1)*SONBAS(KX,KY,KZ)
                  END DO
C
                  X_HELP(KY,KZ)=RESULT
C
               END DO
            END DO
C
C=======================================================================
C        HERE BEGIN LOOPS OVER THE QUANTUM NUMBERS IN THE Y DIRECTION
C=======================================================================
C
            DO NY=0,LAYOFX(NX)
               DO MY=0,LAYOFX(MX)
C
                  IF (IPHAPP(NY,MY,KARTEZ).EQ.0.AND.ISIMPY.EQ.1) GO TO 1
C
                  DO KZ=0,2*NZMAXX
C
                     RESULT=C_ZERO
C
                     DO KY=NY+MY,0,-2
                        RESULT=RESULT+COEF00(KY,MY,NY,2)*X_HELP(KY,KZ)
                     END DO
C
                     Y_HELP(KZ)=RESULT
C
                  END DO
C
C=======================================================================
C        HERE BEGIN LOOPS OVER THE QUANTUM NUMBERS IN THE Z DIRECTION
C=======================================================================
C
                  DO NZ=0,LAZOXY(NX,NY)
                     DO MZ=0,LAZOXY(MX,MY)
C
                        RESULT=C_ZERO
C
#if(SWITCH_VECT==1)
                        DO KZ=0,LAZOXY(NX,NY)+LAZOXY(MX,MY)
#else
                        DO KZ=NZ+MZ,0,-2
#endif
                           RESULT=RESULT+COEF00(KZ,MZ,NZ,3)*Y_HELP(KZ)
                        END DO
C
                        Z_HELP(NZ,MZ)=RESULT
C
                     END DO
                  END DO
C
C=======================================================================
C        FINAL CONSTRUCTION OF MATRIX ELEMENTS
C        IN THE SIMPLEX-CONSERVING BLOCK
C=======================================================================
C
                  DO NZ=0,LAZOXY(NX,NY)
                     DO MZ=0,LAZOXY(MX,MY)
C
                        HPPCEN(INDICE(NX,NY,NZ),INDICE(MX,MY,MZ))=
     *                            Z_HELP(NZ,MZ)*IPHAPP(NY,MY,KARTEZ)
C
                     END DO
                  END DO
C
C=======================================================================
C        FINAL CONSTRUCTION OF MATRIX ELEMENTS
C        IN THE SIMPLEX-NON-CONSERVING BLOCK
C=======================================================================
C
                  IF (ISIMPY.NE.1) THEN
C
                      DO NZ=0,LAZOXY(NX,NY)
                         DO MZ=0,LAZOXY(MX,MY)
C
                            HPMCEN(INDICE(NX,NY,NZ),INDICE(MX,MY,MZ))=
     *                                Z_HELP(NZ,MZ)*IPHAPM(NY,MY,KARTEZ)
C
                         END DO
                      END DO
C
                  END IF
C
C=======================================================================
C        END OF LOOPS OVER QUANTUM NUMBERS IN THE Y DIRECTION
C=======================================================================
C
    1             CONTINUE
C
               END DO
            END DO
C
C=======================================================================
C        END OF LOOPS OVER QUANTUM NUMBERS IN THE Z DIRECTION
C=======================================================================
C
         END DO
      END DO
C
C=======================================================================
C
      CALL CPUTIM('INTCEN',0)
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE INTSOR(NXMAXX,NYMAXX,NZMAXX,VONBAS,
     *                  KARTEZ,ISIMPY,HPPSOR,HPMSOR)
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      COMPLEX
     *          VONBAS(0:ND2MAX,0:ND2MAX,0:ND2MAX,NDKART)
      COMPLEX
     *          HPPSOR(1:NDBASE,1:NDBASE),
     *          HPMSOR(1:NDBASE,1:NDBASE)
      COMPLEX
     *          X_HELP(0:ND2MAX,0:ND2MAX),
     *          Y_HELP(0:ND2MAX,0:ND2MAX),
     *          Z_HELP(0:ND2MAX,0:ND2MAX)
      COMPLEX
     *          T_HELP(0:NDOSCI,0:NDOSCI)
      COMPLEX
     *          X_AUXI(0:ND2MAX),
     *          Y_AUXI(0:ND2MAX),
     *          Z_AUXI(0:ND2MAX),
     *          T_AUXI(0:ND2MAX)
      COMPLEX
     *          RESULT,C_ZERO
C
      COMMON
     *       /T_PHAS/ IPHAPP(0:NDYMAX,0:NDYMAX,0:NDKART),
     *                IPHAPM(0:NDYMAX,0:NDYMAX,0:NDKART),
     *                IPHAMP(0:NDYMAX,0:NDYMAX,0:NDKART),
     *                IPHAMM(0:NDYMAX,0:NDYMAX,0:NDKART)
      COMMON
     *       /COEXYZ/ COEF00(0:ND2MAX,0:NDOSCI,0:NDOSCI,1:NDKART),
     *                COEF01(0:ND2MAX,0:NDOSCI,0:NDOSCI,1:NDKART),
     *                COEF11(0:ND2MAX,0:NDOSCI,0:NDOSCI,1:NDKART),
     *                COEF02(0:ND2MAX,0:NDOSCI,0:NDOSCI,1:NDKART)
      COMMON
     *       /BINDEX/ INDICE(0:NDXMAX,0:NDYMAX,0:NDZMAX)
     *
     *       /BLIMS1/ LAXOFY(0:NDYMAX),LAXOFZ(0:NDZMAX),
     *                LAYOFZ(0:NDZMAX),LAYOFX(0:NDXMAX),
     *                LAZOFX(0:NDXMAX),LAZOFY(0:NDYMAX)
     *
     *       /BLIMS2/ LAXOYZ(0:NDYMAX,0:NDZMAX),
     *                LAYOZX(0:NDZMAX,0:NDXMAX),
     *                LAZOXY(0:NDXMAX,0:NDYMAX)
      COMMON
     *       /DIMENS/ LDBASE
C
C=======================================================================
C
      CALL CPUTIM('INTSOR',1)
C
C=======================================================================
C        THIS SUBROUTINE PERFORMS  THE  GAUSS - HERMITE INTEGRATIONS
C        OF THE MATRIX ELEMENTS OF THE S P I N - O R B I T POTENTIAL
C=======================================================================
C
      C_ZERO=CMPLX(0.0D0,0.0D0)
C
C=======================================================================
C
C        VECTORIZATION COMMENT:
C        PLEASE REFER TO THE COMMENT IN THE "INTCOU" SUBROUTINE
C
C=======================================================================
C
      HPPSOR(:,:)=C_ZERO
      HPMSOR(:,:)=C_ZERO
C
C=======================================================================
C        HERE BEGIN LOOPS OVER THE QUANTUM NUMBERS IN THE X DIRECTION
C=======================================================================
C
      DO NX=0,NXMAXX
         DO MX=0,NXMAXX
C
            DO KY=0,2*NYMAXX+1
C
C=======================================================================
C        INTEGRAL OVER X - FIRST DERIVATIVE
C=======================================================================
C
               DO KZ=0,2*NZMAXX+1
C
                  RESULT=C_ZERO
C
                  DO KX=NX+MX+1,0,-2
                     RESULT=RESULT+COEF01(KX,NX,MX,1)*VONBAS(KX,KY,KZ,1)
                  END DO
C
                  X_HELP(KY,KZ)=RESULT
C
               END DO
C
C=======================================================================
C        INTEGRAL OVER X - FIRST DERIVATIVE AND ANTISYMMETRIZATION
C=======================================================================
C
               DO KZ=0,2*NZMAXX+1
C
                  RESULT=C_ZERO
C
                  DO KX=NX+MX+1,0,-2
                     RESULT=RESULT-COEF01(KX,MX,NX,1)*VONBAS(KX,KY,KZ,1)
                  END DO
C
                  X_HELP(KY,KZ)=X_HELP(KY,KZ)+RESULT
C
               END DO
C
C=======================================================================
C        INTEGRAL OVER X - NO DERIVATIVE
C=======================================================================
C
               DO KZ=0,2*NZMAXX+1
C
                  RESULT=C_ZERO
C
                  DO KX=NX+MX,0,-2
                     RESULT=RESULT+COEF00(KX,MX,NX,1)*VONBAS(KX,KY,KZ,2)
                  END DO
C
                  Y_HELP(KY,KZ)=RESULT
C
               END DO
C
C=======================================================================
C        INTEGRAL OVER X - NO DERIVATIVE, AND SYMMETRIZATION
C=======================================================================
C
               DO KZ=0,2*NZMAXX+1
C
                  RESULT=C_ZERO
C
                  DO KX=NX+MX,0,-2
                     RESULT=RESULT+COEF00(KX,MX,NX,1)*VONBAS(KX,KY,KZ,3)
                  END DO
C
                  Z_HELP(KY,KZ)=RESULT
C
               END DO
            END DO
C
C=======================================================================
C        HERE BEGIN LOOPS OVER THE QUANTUM NUMBERS IN THE Y DIRECTION
C=======================================================================
C
            DO NY=0,LAYOFX(NX)
               DO MY=0,LAYOFX(MX)
C
                  IF (IPHAPP(NY,MY,KARTEZ).EQ.0.AND.ISIMPY.EQ.1) GO TO 1
C
C=======================================================================
C        INTEGRAL OVER Y - NO DERIVATIVE, AND PREVIOUS X-DERIVATIVE
C=======================================================================
C
                  DO KZ=0,2*NZMAXX+1
C
                     RESULT=C_ZERO
C
                     DO KY=NY+MY,0,-2
                        RESULT=RESULT+COEF00(KY,MY,NY,2)*X_HELP(KY,KZ)
                     END DO
C
                     X_AUXI(KZ)=RESULT
C
                  END DO
C
C=======================================================================
C        INTEGRAL OVER Y - FIRST DERIVATIVE AND ANTISYMMETRIZATION
C=======================================================================
C
                  DO KZ=0,2*NZMAXX+1
C
                     RESULT=C_ZERO
C
                     DO KY=NY+MY+1,0,-2
                        RESULT=RESULT+COEF01(KY,NY,MY,2)*Y_HELP(KY,KZ)
                     END DO
C
                     Y_AUXI(KZ)=RESULT
C
                  END DO
C
                  DO KZ=0,2*NZMAXX+1
C
                     RESULT=C_ZERO
C
                     DO KY=NY+MY+1,0,-2
                        RESULT=RESULT-COEF01(KY,MY,NY,2)*Y_HELP(KY,KZ)
                     END DO
C
                     Y_AUXI(KZ)=Y_AUXI(KZ)+RESULT
C
                  END DO
C
C=======================================================================
C        INTEGRAL OVER Y - NO DERIVATIVE
C=======================================================================
C
                  DO KZ=0,2*NZMAXX+1
C
                     RESULT=C_ZERO
C
                     DO KY=NY+MY,0,-2
                        RESULT=RESULT+COEF00(KY,MY,NY,2)*Z_HELP(KY,KZ)
                     END DO
C
                     Z_AUXI(KZ)=RESULT
C
                  END DO
C
C=======================================================================
C        INTEGRAL OVER Y - AUXILIARY SUM
C=======================================================================
C
                  DO KZ=0,2*NZMAXX+1
C
                     T_AUXI(KZ)=X_AUXI(KZ)+Y_AUXI(KZ)
C
                  END DO
C
C=======================================================================
C        HERE BEGIN LOOPS OVER THE QUANTUM NUMBERS IN THE Z DIRECTION
C=======================================================================
C
                  DO NZ=0,LAZOXY(NX,NY)
C
C=======================================================================
C        INTEGRAL OVER Z - NO DERIVATIVE, PREVIOUS X- AND Y-DERIVATIVE
C=======================================================================
C
                     DO MZ=0,LAZOXY(MX,MY)
C
                        RESULT=C_ZERO
C
#if(SWITCH_VECT==1)
                        DO KZ=0,LAZOXY(NX,NY)+LAZOXY(MX,MY)
#else
                        DO KZ=NZ+MZ,0,-2
#endif
                           RESULT=RESULT+COEF00(KZ,NZ,MZ,3)*T_AUXI(KZ)
                        END DO
C
                        T_HELP(NZ,MZ)=RESULT
C
                     END DO
C
C=======================================================================
C        INTEGRAL OVER Z - FIRST DERIVATIVE, AND ANTISYMMETRIZATION
C=======================================================================
C
                     DO MZ=0,LAZOXY(MX,MY)
C
                        RESULT=C_ZERO
C
#if(SWITCH_VECT==1)
                        DO KZ=0,LAZOXY(NX,NY)+LAZOXY(MX,MY)+1
#else
                        DO KZ=NZ+MZ+1,0,-2
#endif
                           RESULT=RESULT+COEF01(KZ,NZ,MZ,3)*Z_AUXI(KZ)
                        END DO
C
                        T_HELP(NZ,MZ)=T_HELP(NZ,MZ)+RESULT
C
                     END DO
C
                     DO MZ=0,LAZOXY(MX,MY)
C
                        RESULT=C_ZERO
C
#if(SWITCH_VECT==1)
                        DO KZ=0,LAZOXY(NX,NY)+LAZOXY(MX,MY)+1
#else
                        DO KZ=NZ+MZ+1,0,-2
#endif
                           RESULT=RESULT-COEF01(KZ,MZ,NZ,3)*Z_AUXI(KZ)
                        END DO
C
                        T_HELP(NZ,MZ)=T_HELP(NZ,MZ)+RESULT
C
                     END DO
                  END DO
C
C=======================================================================
C        FINAL CONSTRUCTION OF MATRIX ELEMENTS
C        IN THE SIMPLEX-CONSERVING BLOCK
C=======================================================================
C
                  DO NZ=0,LAZOXY(NX,NY)
                     DO MZ=0,LAZOXY(MX,MY)
C
                        HPPSOR(INDICE(NX,NY,NZ),INDICE(MX,MY,MZ))=
     *                        (T_HELP(NZ,MZ)/2)*IPHAPP(NY,MY,KARTEZ)
C
                     END DO
                  END DO
C
C=======================================================================
C        FINAL CONSTRUCTION OF MATRIX ELEMENTS
C        IN THE SIMPLEX-NON-CONSERVING BLOCK
C=======================================================================
C
                  IF (ISIMPY.NE.1) THEN
C
                      DO NZ=0,LAZOXY(NX,NY)
                         DO MZ=0,LAZOXY(MX,MY)
C
                            HPMSOR(INDICE(NX,NY,NZ),INDICE(MX,MY,MZ))=
     *                            (T_HELP(NZ,MZ)/2)*IPHAPM(NY,MY,KARTEZ)
C
                         END DO
                      END DO
C
                  END IF
C
C=======================================================================
C        END OF LOOPS OVER QUANTUM NUMBERS IN THE Y DIRECTION
C=======================================================================
C
    1             CONTINUE
C
               END DO
            END DO
C
C=======================================================================
C        END OF LOOPS OVER QUANTUM NUMBERS IN THE X DIRECTION
C=======================================================================
C
         END DO
      END DO
C
C=======================================================================
C
      CALL CPUTIM('INTSOR',0)
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE INTMAS(NXMAXX,NYMAXX,NZMAXX,SONBAS,
     *                  KARTEZ,ISIMPY,HPPMAS,HPMMAS)
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      COMPLEX
     *          SONBAS(0:ND2MAX,0:ND2MAX,0:ND2MAX)
      COMPLEX
     *          HPPMAS(1:NDBASE,1:NDBASE),
     *          HPMMAS(1:NDBASE,1:NDBASE)
      COMPLEX
     *          X_HELP(0:ND2MAX,0:ND2MAX),
     *          T_HELP(0:ND2MAX,0:ND2MAX)
      COMPLEX
     *          Z_HELP(0:NDOSCI,0:NDOSCI)
      COMPLEX
     *          X_AUXI(0:ND2MAX),
     *          Y_AUXI(0:ND2MAX),
     *          Z_AUXI(0:ND2MAX),
     *          T_AUXI(0:ND2MAX)
      COMPLEX
     *          RESULT,C_ZERO
C
      COMMON
     *       /T_PHAS/ IPHAPP(0:NDYMAX,0:NDYMAX,0:NDKART),
     *                IPHAPM(0:NDYMAX,0:NDYMAX,0:NDKART),
     *                IPHAMP(0:NDYMAX,0:NDYMAX,0:NDKART),
     *                IPHAMM(0:NDYMAX,0:NDYMAX,0:NDKART)
      COMMON
     *       /COEXYZ/ COEF00(0:ND2MAX,0:NDOSCI,0:NDOSCI,1:NDKART),
     *                COEF01(0:ND2MAX,0:NDOSCI,0:NDOSCI,1:NDKART),
     *                COEF11(0:ND2MAX,0:NDOSCI,0:NDOSCI,1:NDKART),
     *                COEF02(0:ND2MAX,0:NDOSCI,0:NDOSCI,1:NDKART)
      COMMON
     *       /BINDEX/ INDICE(0:NDXMAX,0:NDYMAX,0:NDZMAX)
     *
     *       /BLIMS1/ LAXOFY(0:NDYMAX),LAXOFZ(0:NDZMAX),
     *                LAYOFZ(0:NDZMAX),LAYOFX(0:NDXMAX),
     *                LAZOFX(0:NDXMAX),LAZOFY(0:NDYMAX)
     *
     *       /BLIMS2/ LAXOYZ(0:NDYMAX,0:NDZMAX),
     *                LAYOZX(0:NDZMAX,0:NDXMAX),
     *                LAZOXY(0:NDXMAX,0:NDYMAX)
      COMMON
     *       /DIMENS/ LDBASE
C
C=======================================================================
C
      CALL CPUTIM('INTMAS',1)
C
C=======================================================================
C        THIS SUBROUTINE PERFORMS  THE  GAUSS - HERMITE INTEGRATIONS
C        OF THE MATRIX ELEMENTS OF THE  E F F E C T I V E  MASS-TERM
C=======================================================================
C
      C_ZERO=CMPLX(0.0D0,0.0D0)
C
C=======================================================================
C
C        VECTORIZATION COMMENT:
C        PLEASE REFER TO THE COMMENT IN THE "INTCOU" SUBROUTINE
C
C=======================================================================
C
      HPPMAS(:,:)=C_ZERO
      HPMMAS(:,:)=C_ZERO
C
C=======================================================================
C        HERE BEGIN LOOPS OVER THE QUANTUM NUMBERS IN THE X DIRECTION
C=======================================================================
C
      DO NX=0,NXMAXX
         DO MX=0,NXMAXX
C
            DO KY=0,2*NYMAXX+2
C
C=======================================================================
C        INTEGRAL OVER X - NO DERIVATIVE
C=======================================================================
C
               DO KZ=0,2*NZMAXX+2
C
                  RESULT=C_ZERO
C
                  DO KX=NX+MX,0,-2
                     RESULT=RESULT+COEF00(KX,MX,NX,1)*SONBAS(KX,KY,KZ)
                  END DO
C
                  T_HELP(KY,KZ)=RESULT
C
               END DO
C
C=======================================================================
C        INTEGRAL OVER X - SECOND DERIVATIVE
C=======================================================================
C
               DO KZ=0,2*NZMAXX+2
C
                  RESULT=C_ZERO
C
                  DO KX=NX+MX+2,0,-2
                     RESULT=RESULT+COEF11(KX,MX,NX,1)*SONBAS(KX,KY,KZ)
                  END DO
C
                  X_HELP(KY,KZ)=RESULT
C
               END DO
            END DO
C
C=======================================================================
C        HERE BEGIN LOOPS OVER THE QUANTUM NUMBERS IN THE Y DIRECTION
C=======================================================================
C
            DO NY=0,LAYOFX(NX)
               DO MY=0,LAYOFX(MX)
C
                  IF (IPHAPP(NY,MY,KARTEZ).EQ.0.AND.ISIMPY.EQ.1) GO TO 1
C
C=======================================================================
C        INTEGRAL OVER Y - NO DERIVATIVE, AND SECOND X-DERIVATIVE
C=======================================================================
C
                  DO KZ=0,2*NZMAXX+2
C
                  RESULT=C_ZERO
C
                     DO KY=NY+MY,0,-2
                        RESULT=RESULT+COEF00(KY,MY,NY,2)*X_HELP(KY,KZ)
                     END DO
C
                     X_AUXI(KZ)=RESULT
C
                  END DO
C
C=======================================================================
C        INTEGRAL OVER Y - SECOND DERIVATIVE
C=======================================================================
C
                  DO KZ=0,2*NZMAXX+2
C
                     RESULT=C_ZERO
C
                     DO KY=NY+MY+2,0,-2
                        RESULT=RESULT+COEF11(KY,MY,NY,2)*T_HELP(KY,KZ)
                     END DO
C
                     Y_AUXI(KZ)=RESULT
C
                  END DO
C
C=======================================================================
C        INTEGRAL OVER Y - NO DERIVATIVE
C=======================================================================
C
                  DO KZ=0,2*NZMAXX+2
C
                     RESULT=C_ZERO
C
                     DO KY=NY+MY,0,-2
                        RESULT=RESULT+COEF00(KY,MY,NY,2)*T_HELP(KY,KZ)
                     END DO
C
                     Z_AUXI(KZ)=RESULT
C
                  END DO
C
C=======================================================================
C        INTEGRAL OVER Y - AUXILIARY SUM
C=======================================================================
C
                  DO KZ=0,2*NZMAXX+2
C
                     T_AUXI(KZ)=X_AUXI(KZ)+Y_AUXI(KZ)
C
                  END DO
C
C=======================================================================
C        HERE BEGIN LOOPS OVER THE QUANTUM NUMBERS IN THE Z DIRECTION
C=======================================================================
C
                  DO NZ=0,LAZOXY(NX,NY)
C
C=======================================================================
C        INTEGRAL OVER Z - NO DERIVATIVE, SECOND X- AND Y-DERIVATIVES
C=======================================================================
C
                     DO MZ=0,LAZOXY(MX,MY)
C
                        RESULT=C_ZERO
C
#if(SWITCH_VECT==1)
                        DO KZ=0,LAZOXY(NX,NY)+LAZOXY(MX,MY)
#else
                        DO KZ=NZ+MZ,0,-2
#endif
                           RESULT=RESULT+COEF00(KZ,NZ,MZ,3)*T_AUXI(KZ)
                        END DO
C
                        Z_HELP(NZ,MZ)=RESULT
C
                     END DO
C
C=======================================================================
C        INTEGRAL OVER Z - SECOND DERIVATIVE
C=======================================================================
C
                     DO MZ=0,LAZOXY(MX,MY)
C
                        RESULT=C_ZERO
C
#if(SWITCH_VECT==1)
                        DO KZ=0,LAZOXY(NX,NY)+LAZOXY(MX,MY)+2
#else
                        DO KZ=NZ+MZ+2,0,-2
#endif
                           RESULT=RESULT+COEF11(KZ,NZ,MZ,3)*Z_AUXI(KZ)
                        END DO
C
                        Z_HELP(NZ,MZ)=Z_HELP(NZ,MZ)+RESULT
C
                     END DO
                  END DO
C
C=======================================================================
C        FINAL CONSTRUCTION OF MATRIX ELEMENTS
C        IN THE SIMPLEX-CONSERVING BLOCK
C=======================================================================
C
                  DO NZ=0,LAZOXY(NX,NY)
                     DO MZ=0,LAZOXY(MX,MY)
C
                        HPPMAS(INDICE(NX,NY,NZ),INDICE(MX,MY,MZ))=
     *                            Z_HELP(NZ,MZ)*IPHAPP(NY,MY,KARTEZ)
C
                     END DO
                  END DO
C
C=======================================================================
C        FINAL CONSTRUCTION OF MATRIX ELEMENTS
C        IN THE SIMPLEX-NON-CONSERVING BLOCK
C=======================================================================
C
                  IF (ISIMPY.NE.1) THEN
C
                      DO NZ=0,LAZOXY(NX,NY)
                         DO MZ=0,LAZOXY(MX,MY)
C
                            HPMMAS(INDICE(NX,NY,NZ),INDICE(MX,MY,MZ))=
     *                                Z_HELP(NZ,MZ)*IPHAPM(NY,MY,KARTEZ)
C
                         END DO
                      END DO
C
                  END IF
C
C=======================================================================
C        END OF LOOPS OVER QUANTUM NUMBERS IN THE Y DIRECTION
C=======================================================================
C
    1             CONTINUE
C
               END DO
            END DO
C
C=======================================================================
C        END OF LOOPS OVER QUANTUM NUMBERS IN THE X DIRECTION
C=======================================================================
C
         END DO
      END DO
C
C=======================================================================
C
      CALL CPUTIM('INTMAS',0)
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE ESKYRM(NXHERM,NYHERM,NZHERM,ENESKY,ENEVEN,ENEODD,
     *                                ENREAR,ENE_W0,EEVEW0,EODDW0,
     *                                                     EKESKY)
C=======================================================================
      USE HE_DEN
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      DIMENSION
     *          CCPALL(NDCOUP),DCPALL(NDCOUP),ECPALL(NDCOUP)
      DIMENSION
     *          VCPALL(NDVIOL)
      COMPLEX
     *          ZCPALL(NDCOUP)
      COMPLEX
     *          EKESKY,C_ZERO
C
      EQUIVALENCE
     *            (CCPALL,CRHO_T),(DCPALL,DRHO_T),(ECPALL,ERHO_T)
      EQUIVALENCE
     *            (VCPALL,DSCRPP)
      EQUIVALENCE
     *            (ZCPALL,ZRHO_T)
C
      COMPLEX
     *          DE_ROJ(NDXHRM,NDYHRM,NDZHRM,NDKART,0:NDISOS)
C
C=======================================================================
C            ATTENTION: BETWEEN VERSIONS (2.19D) AND (2.39B),  VARIABLES
C                       "QUNDIV" AND "QUNROT" BELOW WERE NOT DECLARED AS
C                       COMPLEX. THIS BUG WAS CORRECTED ON 31/03/2009 IN
C                       VERSION (2.39C).
C=======================================================================
C
      COMPLEX
     *          QUNRHO,QUPRHO,QUTRHO,
     *          QUNLPR,QUPLPR,QUTLPR,
     *          QUNTAU,QUPTAU,QUTTAU,
     *          QUNSCU,QUPSCU,QUTSCU,
     *          QUNDIV,QUPDIV,QUTDIV,
     *          QUNSPI,QUPSPI,QUTSPI,
     *          QUNLPS,QUPLPS,QUTLPS,
     *          QUNCUR,QUPCUR,QUTCUR,
     *          QUNKIS,QUPKIS,QUTKIS,
     *          QUNROT,QUPROT,QUTROT
      COMPLEX
     *          QPPSCR,QMMSCR,QPMSCR,QMPSCR,QPPDIS,QMMDIS,QPMDIS,QMPDIS,
     *          QPPDSR,QMMDSR,QPMDSR,QMPDSR,QPPSCS,QMMSCS,QPMSCS,QMPSCS,
     *          QPPSCJ,QMMSCJ,QPMSCJ,QMPSCJ,QPPCUS,QMMCUS,QPMCUS,QMPCUS,
     *          QPPROS,QMMROS,QPMROS,QMPROS,QPPDES,QMMDES,QPMDES,QMPDES,
     *          QUNDIS,QUPDIS
      COMPLEX
     *          ZRHO_T,ZRHO_S,ZRHODT,ZRHODS,
     *          ZLPR_T,ZLPR_S,
     *          ZTAU_T,ZTAU_S,
     *          ZSCU_T,ZSCU_S,
     *          ZDIV_T,ZDIV_S,
     *          ZSPI_T,ZSPI_S,ZSPIDT,ZSPIDS,
     *          ZLPS_T,ZLPS_S,
     *          ZCUR_T,ZCUR_S,
     *          ZKIS_T,ZKIS_S,
     *          ZROT_T,ZROT_S
      COMPLEX
     *          ECCALL
      COMPLEX
     *          DENSIC,DENCHC,DENPOW,DENNEU,DENPRO
C
      COMMON
     *       /DENTOC/ DENSIC(NDXHRM,NDYHRM,NDZHRM),
     *                DENCHC(NDXHRM,NDYHRM,NDZHRM)
      COMMON
     *       /DENEXP/ EXPAUX(NDXHRM,NDYHRM,NDZHRM)
      COMMON
     *       /CCPSKY/ CRHO_T,CRHO_S,CRHODT,CRHODS,
     *                CLPR_T,CLPR_S,
     *                CTAU_T,CTAU_S,
     *                CSCU_T,CSCU_S,
     *                CDIV_T,CDIV_S,
     *                CSPI_T,CSPI_S,CSPIDT,CSPIDS,
     *                CLPS_T,CLPS_S,
     *                CCUR_T,CCUR_S,
     *                CKIS_T,CKIS_S,
     *                CROT_T,CROT_S
      COMMON
     *       /DCPSKY/ DRHO_T,DRHO_S,DRHODT,DRHODS,
     *                DLPR_T,DLPR_S,
     *                DTAU_T,DTAU_S,
     *                DSCU_T,DSCU_S,
     *                DDIV_T,DDIV_S,
     *                DSPI_T,DSPI_S,DSPIDT,DSPIDS,
     *                DLPS_T,DLPS_S,
     *                DCUR_T,DCUR_S,
     *                DKIS_T,DKIS_S,
     *                DROT_T,DROT_S
      COMMON
     *       /ECPSKY/ ERHO_T,ERHO_S,ERHODT,ERHODS,
     *                ELPR_T,ELPR_S,
     *                ETAU_T,ETAU_S,
     *                ESCU_T,ESCU_S,
     *                EDIV_T,EDIV_S,
     *                ESPI_T,ESPI_S,ESPIDT,ESPIDS,
     *                ELPS_T,ELPS_S,
     *                ECUR_T,ECUR_S,
     *                EKIS_T,EKIS_S,
     *                EROT_T,EROT_S
      COMMON
     *       /ECCSKY/ ECCALL(NDCOUP)
      COMMON
     *       /ZCPSKY/ ZRHO_T,ZRHO_S,ZRHODT,ZRHODS,
     *                ZLPR_T,ZLPR_S,
     *                ZTAU_T,ZTAU_S,
     *                ZSCU_T,ZSCU_S,
     *                ZDIV_T,ZDIV_S,
     *                ZSPI_T,ZSPI_S,ZSPIDT,ZSPIDS,
     *                ZLPS_T,ZLPS_S,
     *                ZCUR_T,ZCUR_S,
     *                ZKIS_T,ZKIS_S,
     *                ZROT_T,ZROT_S
      COMMON
     *       /VCPSKY/ DSCRPP,DSCRMM,DSCRPM,DSCRMP,
     *                DDISPP,DDISMM,DDISPM,DDISMP,
     *                DDSRPP,DDSRMM,DDSRPM,DDSRMP,
     *                DSCSPP,DSCSMM,DSCSPM,DSCSMP,
     *                DSCJPP,DSCJMM,DSCJPM,DSCJMP,
     *                DCUSPP,DCUSMM,DCUSPM,DCUSMP,
     *                DROSPP,DROSMM,DROSPM,DROSMP,
     *                DDESPP,DDESMM,DDESPM,DDESMP
C
      COMMON
     *       /INTSKY/ T0,X0,T1,X1,T2,X2,T3,X3,W0,POWER
C
      COMMON
     *       /INTSTO/ FOURWG(1:NDGAUS,1:NDKART),
     *                FOURPT(1:NDGAUS,1:NDKART)
C
C=======================================================================
C
C        THE EFFECTIVE COUPLING CONSTANTS AND THE CORRESPONDING CONTRI-
C                    BUTIONS TO THE ENERGY ARE CODED AS:
C                           'Z'//XXX//'N'//'TYP'
C        WHERE:
C
C        A.  'Z'  = 'C' = SHORT  FOR  THE " COUPLING    CONSTANT "
C            'Z'  = 'D' = SHORT  FOR  THE " DENSITY CONTRIBUTION "
C            'Z'  = 'E' = SHORT  FOR  THE " ENERGY  CONTRIBUTION "
C
C        B. 'XXX' = REPEATS  THE NAME OF THE CORRESPONDING DENSITY
C                   ACCORDING TO THE VOCABULARY IN THE  SUBROUTINE
C                                                           DENSHF
C                   SYMMETRY-VIOLATING TERMS ARE  DENOTED  BY  THE
C                   FOLLOWING SYMBOLS:
C
C                   SCR = SCALAR PART OF SPIN CURRENT TIMES DENSITY
C                   DIS = DIVERGENCE OF SPIN TIMES DIVERGENCE OF SPIN
C                   DSR = DIVERGENCE OF SPIN TIMES DENSITY
C                   SCS = VECTOR PART OF SPIN CURRENT TIMES SPIN
C                   SCJ = VECTOR PART OF SPIN CURRENT TIMES CURRENT
C                   CUS = CURRENT TIMES SPIN
C                   ROS = CURL OF SPIN TIMES SPIN
C                   DES = TENSOR DERIVATIVE OF SPIN TIMES
C                         TENSOR SPIN CURRENT
C
C
C        C.  'N'  = '_' FOR THE DENSITY-INDEPENDENT TERM
C            'N'  = 'D' FOR THE DENSITY-DEPENDENT   TERM
C
C        D. 'TYP'   REFERS TO  THE  TYPE OF THE DENSITY EXPRESSION
C                   BECAUSE THE TERMS IN  THE  FUNCTIONAL  CAN  BE
C                   CLASSIFIED IN TWO WAYS:
C                                EITHER AS:
C           'TYP' = 'T' (THE TERM DEPENDS ON THE TOTAL DENSITY)
C                 = 'S' (THE TERM IS THE SUM OF CONTRIBUTIONS
C                        FROM PROTONS AND NEUTRONS)
C                                    OR AS:
C                 = 'P' (THE ISOSCALAR TERM)
C                 = 'M' (THE ISOVECTOR TERM)
C
C=======================================================================
C
      C_ZERO=CMPLX(0.0D0,0.0D0)
C
      ENESKY=0.0D0
      ENREAR=0.0D0
C
      EKESKY=C_ZERO
C
      DO NUCOUP=1,NDCOUP
         ZCPALL(NUCOUP)=C_ZERO
      END DO
C
      DO NUVIOL=1,NDVIOL
         VCPALL(NUVIOL)=0.0D0
      END DO
C
      DO IX=1,NXHERM
         DO IY=1,NYHERM
            DO IZ=1,NZHERM
C
               DENNEU = DE_RHO(IX,IY,IZ,0) * EXPAUX(IX,IY,IZ)
               DENPRO = DE_RHO(IX,IY,IZ,1) * EXPAUX(IX,IY,IZ)
C
C=======================================================================
C        CALCULATING THE VECTOR PART OF THE SPIN-CURRENT TENSOR
C=======================================================================
C
               DE_ROJ(IX,IY,IZ,1,0)=
     *                     DE_SCU(IX,IY,IZ,2,3,0)-DE_SCU(IX,IY,IZ,3,2,0)
               DE_ROJ(IX,IY,IZ,2,0)=
     *                     DE_SCU(IX,IY,IZ,3,1,0)-DE_SCU(IX,IY,IZ,1,3,0)
               DE_ROJ(IX,IY,IZ,3,0)=
     *                     DE_SCU(IX,IY,IZ,1,2,0)-DE_SCU(IX,IY,IZ,2,1,0)
C
               DE_ROJ(IX,IY,IZ,1,1)=
     *                     DE_SCU(IX,IY,IZ,2,3,1)-DE_SCU(IX,IY,IZ,3,2,1)
               DE_ROJ(IX,IY,IZ,2,1)=
     *                     DE_SCU(IX,IY,IZ,3,1,1)-DE_SCU(IX,IY,IZ,1,3,1)
               DE_ROJ(IX,IY,IZ,3,1)=
     *                     DE_SCU(IX,IY,IZ,1,2,1)-DE_SCU(IX,IY,IZ,2,1,1)
C
C=======================================================================
C        CALCULATING  THE  A U X I L I A R Y   C O N T R A C T I O N S
C=======================================================================
C
               QUNRHO = DE_RHO(IX,IY,IZ,0)*DE_RHO(IX,IY,IZ,0)
               QUPRHO = DE_RHO(IX,IY,IZ,1)*DE_RHO(IX,IY,IZ,1)
C
               QUTRHO =(DE_RHO(IX,IY,IZ,0)+DE_RHO(IX,IY,IZ,1))
     *                *(DE_RHO(IX,IY,IZ,0)+DE_RHO(IX,IY,IZ,1))
C
               QUNSPI = C_ZERO
               QUPSPI = C_ZERO
               QUTSPI = C_ZERO
C
               QUNLPR = DE_RHO(IX,IY,IZ,0)*DE_LPR(IX,IY,IZ,0)
               QUPLPR = DE_RHO(IX,IY,IZ,1)*DE_LPR(IX,IY,IZ,1)
C
               QUTLPR =(DE_RHO(IX,IY,IZ,0)+DE_RHO(IX,IY,IZ,1))
     *                *(DE_LPR(IX,IY,IZ,0)+DE_LPR(IX,IY,IZ,1))
C
               QUNTAU = DE_RHO(IX,IY,IZ,0)*DE_TAU(IX,IY,IZ,0)
               QUPTAU = DE_RHO(IX,IY,IZ,1)*DE_TAU(IX,IY,IZ,1)
C
               QUTTAU =(DE_RHO(IX,IY,IZ,0)+DE_RHO(IX,IY,IZ,1))
     *                *(DE_TAU(IX,IY,IZ,0)+DE_TAU(IX,IY,IZ,1))
C
               QUNLPS=C_ZERO
               QUPLPS=C_ZERO
               QUTLPS=C_ZERO
C
               QUNCUR=C_ZERO
               QUPCUR=C_ZERO
               QUTCUR=C_ZERO
C
               QUNKIS=C_ZERO
               QUPKIS=C_ZERO
               QUTKIS=C_ZERO
C
               QUNSCU=C_ZERO
               QUPSCU=C_ZERO
               QUTSCU=C_ZERO
C
               QUNROT=C_ZERO
               QUPROT=C_ZERO
               QUTROT=C_ZERO
C
               QUNDIV = DE_RHO(IX,IY,IZ,0)*DE_DIV(IX,IY,IZ,0)
               QUPDIV = DE_RHO(IX,IY,IZ,1)*DE_DIV(IX,IY,IZ,1)
C
               QUTDIV =(DE_RHO(IX,IY,IZ,0)+DE_RHO(IX,IY,IZ,1))
     *                *(DE_DIV(IX,IY,IZ,0)+DE_DIV(IX,IY,IZ,1))
C
               QPPSCR=C_ZERO
               QMMSCR=C_ZERO
               QPMSCR=C_ZERO
               QMPSCR=C_ZERO
C
               QPPDIS=C_ZERO
               QMMDIS=C_ZERO
               QPMDIS=C_ZERO
               QMPDIS=C_ZERO
C
               QPPDSR=C_ZERO
               QMMDSR=C_ZERO
               QPMDSR=C_ZERO
               QMPDSR=C_ZERO
C
               QPPSCS=C_ZERO
               QMMSCS=C_ZERO
               QPMSCS=C_ZERO
               QMPSCS=C_ZERO
C
               QPPSCJ=C_ZERO
               QMMSCJ=C_ZERO
               QPMSCJ=C_ZERO
               QMPSCJ=C_ZERO
C
               QPPCUS=C_ZERO
               QMMCUS=C_ZERO
               QPMCUS=C_ZERO
               QMPCUS=C_ZERO
C
               QPPROS=C_ZERO
               QMMROS=C_ZERO
               QPMROS=C_ZERO
               QMPROS=C_ZERO
C
               QPPDES=C_ZERO
               QMMDES=C_ZERO
               QPMDES=C_ZERO
               QMPDES=C_ZERO
C
               QUNDIS=C_ZERO
               QUPDIS=C_ZERO
C
               DO K=1,NDKART
C
C=======================================================================
C
                  QUNSPI=QUNSPI
     *                  + DE_SPI(IX,IY,IZ,K,0)*DE_SPI(IX,IY,IZ,K,0)
                  QUPSPI=QUPSPI
     *                  + DE_SPI(IX,IY,IZ,K,1)*DE_SPI(IX,IY,IZ,K,1)
C
                  QUTSPI=QUTSPI
     *                  +(DE_SPI(IX,IY,IZ,K,0)+DE_SPI(IX,IY,IZ,K,1))
     *                  *(DE_SPI(IX,IY,IZ,K,0)+DE_SPI(IX,IY,IZ,K,1))
C
C=======================================================================
C
                  QUNCUR=QUNCUR
     *                  + DE_CUR(IX,IY,IZ,K,0)*DE_CUR(IX,IY,IZ,K,0)
                  QUPCUR=QUPCUR
     *                  + DE_CUR(IX,IY,IZ,K,1)*DE_CUR(IX,IY,IZ,K,1)
C
                  QUTCUR=QUTCUR
     *                  +(DE_CUR(IX,IY,IZ,K,0)+DE_CUR(IX,IY,IZ,K,1))
     *                  *(DE_CUR(IX,IY,IZ,K,0)+DE_CUR(IX,IY,IZ,K,1))
C
C=======================================================================
C
                  QUNLPS=QUNLPS
     *                  + DE_SPI(IX,IY,IZ,K,0)*DE_LPS(IX,IY,IZ,K,0)
                  QUPLPS=QUPLPS
     *                  + DE_SPI(IX,IY,IZ,K,1)*DE_LPS(IX,IY,IZ,K,1)
C
                  QUTLPS=QUTLPS
     *                  +(DE_SPI(IX,IY,IZ,K,0)+DE_SPI(IX,IY,IZ,K,1))
     *                  *(DE_LPS(IX,IY,IZ,K,0)+DE_LPS(IX,IY,IZ,K,1))
C
C=======================================================================
C
                  QUNKIS=QUNKIS
     *                  + DE_SPI(IX,IY,IZ,K,0)*DE_KIS(IX,IY,IZ,K,0)
                  QUPKIS=QUPKIS
     *                  + DE_SPI(IX,IY,IZ,K,1)*DE_KIS(IX,IY,IZ,K,1)
C
                  QUTKIS=QUTKIS
     *                  +(DE_SPI(IX,IY,IZ,K,0)+DE_SPI(IX,IY,IZ,K,1))
     *                  *(DE_KIS(IX,IY,IZ,K,0)+DE_KIS(IX,IY,IZ,K,1))
C
C=======================================================================
C
                  QUNROT=QUNROT
     *                  + DE_SPI(IX,IY,IZ,K,0)*DE_ROC(IX,IY,IZ,K,0)
                  QUPROT=QUPROT
     *                  + DE_SPI(IX,IY,IZ,K,1)*DE_ROC(IX,IY,IZ,K,1)
C
                  QUTROT=QUTROT
     *                  +(DE_SPI(IX,IY,IZ,K,0)+DE_SPI(IX,IY,IZ,K,1))
     *                  *(DE_ROC(IX,IY,IZ,K,0)+DE_ROC(IX,IY,IZ,K,1))
C
C=======================================================================
C                 SYMMETRY-VIOLATING TERMS
C=======================================================================
C
                  QPPSCR=QPPSCR+
     *                   (DE_SCU(IX,IY,IZ,K,K,0)+DE_SCU(IX,IY,IZ,K,K,1))
     *                  *(DE_RHO(IX,IY,IZ    ,0)+DE_RHO(IX,IY,IZ    ,1))
                  QMMSCR=QMMSCR+
     *                   (DE_SCU(IX,IY,IZ,K,K,0)-DE_SCU(IX,IY,IZ,K,K,1))
     *                  *(DE_RHO(IX,IY,IZ    ,0)-DE_RHO(IX,IY,IZ    ,1))
                  QPMSCR=QPMSCR+
     *                   (DE_SCU(IX,IY,IZ,K,K,0)+DE_SCU(IX,IY,IZ,K,K,1))
     *                  *(DE_RHO(IX,IY,IZ    ,0)-DE_RHO(IX,IY,IZ    ,1))
                  QMPSCR=QMPSCR+
     *                   (DE_SCU(IX,IY,IZ,K,K,0)-DE_SCU(IX,IY,IZ,K,K,1))
     *                  *(DE_RHO(IX,IY,IZ    ,0)+DE_RHO(IX,IY,IZ    ,1))
C
C=======================================================================
C
                  QUNDIS=QUNDIS+DE_DES(IX,IY,IZ,K,K,0)
                  QUPDIS=QUPDIS+DE_DES(IX,IY,IZ,K,K,1)
C
C=======================================================================
C
                  QPPDSR=QPPDSR+
     *                   (DE_DES(IX,IY,IZ,K,K,0)+DE_DES(IX,IY,IZ,K,K,1))
     *                  *(DE_RHO(IX,IY,IZ    ,0)+DE_RHO(IX,IY,IZ    ,1))
                  QMMDSR=QMMDSR+
     *                   (DE_DES(IX,IY,IZ,K,K,0)-DE_DES(IX,IY,IZ,K,K,1))
     *                  *(DE_RHO(IX,IY,IZ    ,0)-DE_RHO(IX,IY,IZ    ,1))
                  QPMDSR=QPMDSR+
     *                   (DE_DES(IX,IY,IZ,K,K,0)+DE_DES(IX,IY,IZ,K,K,1))
     *                  *(DE_RHO(IX,IY,IZ    ,0)-DE_RHO(IX,IY,IZ    ,1))
                  QMPDSR=QMPDSR+
     *                   (DE_DES(IX,IY,IZ,K,K,0)-DE_DES(IX,IY,IZ,K,K,1))
     *                  *(DE_RHO(IX,IY,IZ    ,0)+DE_RHO(IX,IY,IZ    ,1))
C
C=======================================================================
C
                  QPPSCS=QPPSCS
     *                  +(DE_ROJ(IX,IY,IZ,K,0)+DE_ROJ(IX,IY,IZ,K,1))
     *                  *(DE_SPI(IX,IY,IZ,K,0)+DE_SPI(IX,IY,IZ,K,1))
                  QMMSCS=QMMSCS
     *                  +(DE_ROJ(IX,IY,IZ,K,0)-DE_ROJ(IX,IY,IZ,K,1))
     *                  *(DE_SPI(IX,IY,IZ,K,0)-DE_SPI(IX,IY,IZ,K,1))
                  QPMSCS=QPMSCS
     *                  +(DE_ROJ(IX,IY,IZ,K,0)+DE_ROJ(IX,IY,IZ,K,1))
     *                  *(DE_SPI(IX,IY,IZ,K,0)-DE_SPI(IX,IY,IZ,K,1))
                  QMPSCS=QMPSCS
     *                  +(DE_ROJ(IX,IY,IZ,K,0)-DE_ROJ(IX,IY,IZ,K,1))
     *                  *(DE_SPI(IX,IY,IZ,K,0)+DE_SPI(IX,IY,IZ,K,1))
C
C=======================================================================
C
                  QPPSCJ=QPPSCJ
     *                  +(DE_ROJ(IX,IY,IZ,K,0)+DE_ROJ(IX,IY,IZ,K,1))
     *                  *(DE_CUR(IX,IY,IZ,K,0)+DE_CUR(IX,IY,IZ,K,1))
                  QMMSCJ=QMMSCJ
     *                  +(DE_ROJ(IX,IY,IZ,K,0)-DE_ROJ(IX,IY,IZ,K,1))
     *                  *(DE_CUR(IX,IY,IZ,K,0)-DE_CUR(IX,IY,IZ,K,1))
                  QPMSCJ=QPMSCJ
     *                  +(DE_ROJ(IX,IY,IZ,K,0)+DE_ROJ(IX,IY,IZ,K,1))
     *                  *(DE_CUR(IX,IY,IZ,K,0)-DE_CUR(IX,IY,IZ,K,1))
                  QMPSCJ=QMPSCJ
     *                  +(DE_ROJ(IX,IY,IZ,K,0)-DE_ROJ(IX,IY,IZ,K,1))
     *                  *(DE_CUR(IX,IY,IZ,K,0)+DE_CUR(IX,IY,IZ,K,1))
C
C=======================================================================
C
                  QPPCUS=QPPCUS
     *                  +(DE_CUR(IX,IY,IZ,K,0)+DE_CUR(IX,IY,IZ,K,1))
     *                  *(DE_SPI(IX,IY,IZ,K,0)+DE_SPI(IX,IY,IZ,K,1))
                  QMMCUS=QMMCUS
     *                  +(DE_CUR(IX,IY,IZ,K,0)-DE_CUR(IX,IY,IZ,K,1))
     *                  *(DE_SPI(IX,IY,IZ,K,0)-DE_SPI(IX,IY,IZ,K,1))
                  QPMCUS=QPMCUS
     *                  +(DE_CUR(IX,IY,IZ,K,0)+DE_CUR(IX,IY,IZ,K,1))
     *                  *(DE_SPI(IX,IY,IZ,K,0)-DE_SPI(IX,IY,IZ,K,1))
                  QMPCUS=QMPCUS
     *                  +(DE_CUR(IX,IY,IZ,K,0)-DE_CUR(IX,IY,IZ,K,1))
     *                  *(DE_SPI(IX,IY,IZ,K,0)+DE_SPI(IX,IY,IZ,K,1))
C
C=======================================================================
C
                  QPPROS=QPPROS
     *                  +(DE_ROS(IX,IY,IZ,K,0)+DE_ROS(IX,IY,IZ,K,1))
     *                  *(DE_SPI(IX,IY,IZ,K,0)+DE_SPI(IX,IY,IZ,K,1))
                  QMMROS=QMMROS
     *                  +(DE_ROS(IX,IY,IZ,K,0)-DE_ROS(IX,IY,IZ,K,1))
     *                  *(DE_SPI(IX,IY,IZ,K,0)-DE_SPI(IX,IY,IZ,K,1))
                  QPMROS=QPMROS
     *                  +(DE_ROS(IX,IY,IZ,K,0)+DE_ROS(IX,IY,IZ,K,1))
     *                  *(DE_SPI(IX,IY,IZ,K,0)-DE_SPI(IX,IY,IZ,K,1))
                  QMPROS=QMPROS
     *                  +(DE_ROS(IX,IY,IZ,K,0)-DE_ROS(IX,IY,IZ,K,1))
     *                  *(DE_SPI(IX,IY,IZ,K,0)+DE_SPI(IX,IY,IZ,K,1))
C
C=======================================================================
C
                  DO L=1,NDKART
C
                     QUNSCU=QUNSCU + DE_SCU(IX,IY,IZ,K,L,0)
     *                             * DE_SCU(IX,IY,IZ,K,L,0)
                     QUPSCU=QUPSCU + DE_SCU(IX,IY,IZ,K,L,1)
     *                             * DE_SCU(IX,IY,IZ,K,L,1)
C
                     QUTSCU=QUTSCU +(DE_SCU(IX,IY,IZ,K,L,0)
     *                             + DE_SCU(IX,IY,IZ,K,L,1))
     *
     *                             *(DE_SCU(IX,IY,IZ,K,L,0)
     *                             + DE_SCU(IX,IY,IZ,K,L,1))
C
C=======================================================================
C                 SYMMETRY-VIOLATING TERMS
C=======================================================================
C
                     QPPDES=QPPDES +(DE_DES(IX,IY,IZ,K,L,0)
     *                             + DE_DES(IX,IY,IZ,K,L,1))
     *
     *                             *(DE_SCU(IX,IY,IZ,K,L,0)
     *                             + DE_SCU(IX,IY,IZ,K,L,1))
C
                     QMMDES=QMMDES +(DE_DES(IX,IY,IZ,K,L,0)
     *                             - DE_DES(IX,IY,IZ,K,L,1))
     *
     *                             *(DE_SCU(IX,IY,IZ,K,L,0)
     *                             - DE_SCU(IX,IY,IZ,K,L,1))
C
                     QPMDES=QPMDES +(DE_DES(IX,IY,IZ,K,L,0)
     *                             + DE_DES(IX,IY,IZ,K,L,1))
     *
     *                             *(DE_SCU(IX,IY,IZ,K,L,0)
     *                             - DE_SCU(IX,IY,IZ,K,L,1))
C
                     QMPDES=QMPDES +(DE_DES(IX,IY,IZ,K,L,0)
     *                             - DE_DES(IX,IY,IZ,K,L,1))
     *
     *                             *(DE_SCU(IX,IY,IZ,K,L,0)
     *                             + DE_SCU(IX,IY,IZ,K,L,1))
C
                  END DO
C
               END DO
C
C=======================================================================
C
               QPPDIS=(QUNDIS+QUPDIS)*(QUNDIS+QUPDIS)
               QMMDIS=(QUNDIS-QUPDIS)*(QUNDIS-QUPDIS)
               QPMDIS=(QUNDIS+QUPDIS)*(QUNDIS-QUPDIS)
               QMPDIS=(QUNDIS-QUPDIS)*(QUNDIS+QUPDIS)
C
C=======================================================================
C
               W_HERM=FOURWG(IX,1)*FOURWG(IY,2)*FOURWG(IZ,3)
C
               DENPOW=DENSIC(IX,IY,IZ) ** POWER
C
C=======================================================================
C              CALCULATING THE T0-TERMS OF THE SKYRME ENERGY DENSITY
C=======================================================================
C
               ZRHO_T = ZRHO_T + W_HERM *  QUTRHO
               ZRHO_S = ZRHO_S + W_HERM * (QUNRHO + QUPRHO)
C
               ZSPI_T = ZSPI_T + W_HERM *  QUTSPI
               ZSPI_S = ZSPI_S + W_HERM * (QUNSPI + QUPSPI)
C
C=======================================================================
C              CALCULATING THE T1-T2-TERMS OF THE SKYRME ENERGY DENSITY
C=======================================================================
C
               ZLPR_T = ZLPR_T + W_HERM *  QUTLPR
               ZLPR_S = ZLPR_S + W_HERM * (QUNLPR + QUPLPR)
C
               ZTAU_T = ZTAU_T + W_HERM *  QUTTAU
               ZTAU_S = ZTAU_S + W_HERM * (QUNTAU + QUPTAU)
C
               ZCUR_T = ZCUR_T + W_HERM *  QUTCUR
               ZCUR_S = ZCUR_S + W_HERM * (QUNCUR + QUPCUR)
C
               ZLPS_T = ZLPS_T + W_HERM *  QUTLPS
               ZLPS_S = ZLPS_S + W_HERM * (QUNLPS + QUPLPS)
C
               ZKIS_T = ZKIS_T + W_HERM *  QUTKIS
               ZKIS_S = ZKIS_S + W_HERM * (QUNKIS + QUPKIS)
C
               ZSCU_T = ZSCU_T + W_HERM *  QUTSCU
               ZSCU_S = ZSCU_S + W_HERM * (QUNSCU + QUPSCU)
C
C=======================================================================
C              CALCULATING THE T3-TERMS OF THE SKYRME ENERGY DENSITY
C=======================================================================
C
               ZRHODT = ZRHODT + W_HERM *  QUTRHO
     *                                  *  DENPOW
               ZRHODS = ZRHODS + W_HERM * (QUNRHO + QUPRHO)
     *                                  *  DENPOW
               ZSPIDT = ZSPIDT + W_HERM *  QUTSPI
     *                                  *  DENPOW
               ZSPIDS = ZSPIDS + W_HERM * (QUNSPI + QUPSPI)
     *                                  *  DENPOW
C
               ENREAR = ENREAR + W_HERM * REAL(
     *                                   (CRHODT * QUTRHO
     *                                  + CRHODS *(QUNRHO + QUPRHO)
     *
     *                                  + CSPIDT * QUTSPI
     *                                  + CSPIDS *(QUNSPI + QUPSPI))
     *
     *                                  * DENPOW * (POWER/2))
C
C=======================================================================
C              CALCULATING THE W0-TERMS OF THE SKYRME ENERGY DENSITY
C=======================================================================
C
               ZDIV_T = ZDIV_T + W_HERM *  QUTDIV
               ZDIV_S = ZDIV_S + W_HERM * (QUNDIV + QUPDIV)
C
               ZROT_T = ZROT_T + W_HERM *  QUTROT
               ZROT_S = ZROT_S + W_HERM * (QUNROT + QUPROT)
C
C=======================================================================
C              CALCULATING THE SYMMETRY-VIOLATING TERMS
C=======================================================================
C
               DSCRPP = DSCRPP + W_HERM * REAL(QPPSCR)
               DSCRMM = DSCRMM + W_HERM * REAL(QMMSCR)
               DSCRPM = DSCRPM + W_HERM * REAL(QPMSCR)
               DSCRMP = DSCRMP + W_HERM * REAL(QMPSCR)
C
               DDISPP = DDISPP + W_HERM * REAL(QPPDIS)
               DDISMM = DDISMM + W_HERM * REAL(QMMDIS)
               DDISPM = DDISPM + W_HERM * REAL(QPMDIS)
               DDISMP = DDISMP + W_HERM * REAL(QMPDIS)
C
               DDSRPP = DDSRPP + W_HERM * REAL(QPPDSR)
               DDSRMM = DDSRMM + W_HERM * REAL(QMMDSR)
               DDSRPM = DDSRPM + W_HERM * REAL(QPMDSR)
               DDSRMP = DDSRMP + W_HERM * REAL(QMPDSR)
C
               DSCSPP = DSCSPP + W_HERM * REAL(QPPSCS)
               DSCSMM = DSCSMM + W_HERM * REAL(QMMSCS)
               DSCSPM = DSCSPM + W_HERM * REAL(QPMSCS)
               DSCSMP = DSCSMP + W_HERM * REAL(QMPSCS)
C
               DSCJPP = DSCJPP + W_HERM * REAL(QPPSCJ)
               DSCJMM = DSCJMM + W_HERM * REAL(QMMSCJ)
               DSCJPM = DSCJPM + W_HERM * REAL(QPMSCJ)
               DSCJMP = DSCJMP + W_HERM * REAL(QMPSCJ)
C
               DCUSPP = DCUSPP + W_HERM * REAL(QPPCUS)
               DCUSMM = DCUSMM + W_HERM * REAL(QMMCUS)
               DCUSPM = DCUSPM + W_HERM * REAL(QPMCUS)
               DCUSMP = DCUSMP + W_HERM * REAL(QMPCUS)
C
               DROSPP = DROSPP + W_HERM * REAL(QPPROS)
               DROSMM = DROSMM + W_HERM * REAL(QMMROS)
               DROSPM = DROSPM + W_HERM * REAL(QPMROS)
               DROSMP = DROSMP + W_HERM * REAL(QMPROS)
C
               DDESPP = DDESPP + W_HERM * REAL(QPPDES)
               DDESMM = DDESMM + W_HERM * REAL(QMMDES)
               DDESPM = DDESPM + W_HERM * REAL(QPMDES)
               DDESMP = DDESMP + W_HERM * REAL(QMPDES)
C
            END DO
         END DO
      END DO
C
C=======================================================================
C              PARTIAL SUMMATIONS OF TERMS IN ENERGY
C=======================================================================
C
      DO NUCOUP=1,NDCOUP
         DCPALL(NUCOUP)=REAL(ZCPALL(NUCOUP))
         ECPALL(NUCOUP)=CCPALL(NUCOUP)*DCPALL(NUCOUP)
         ENESKY        =ENESKY        +ECPALL(NUCOUP)
         EKESKY        =EKESKY
     *                 +CCPALL(NUCOUP)*ZCPALL(NUCOUP)
         ECCALL(NUCOUP)=CCPALL(NUCOUP)*ZCPALL(NUCOUP)
      END DO
C
      ENEVEN=0.0D0
      ENEODD=0.0D0
C
      DO NUCOUP=1,NDCOUP/2
C
         ENEVEN=ENEVEN+ECPALL(NUCOUP)
         ENEODD=ENEODD+ECPALL(NUCOUP+NDCOUP/2)
C
      END DO
C
      EEVEW0=EDIV_T+EDIV_S
      EODDW0=EROT_T+EROT_S
C
      ENE_W0=EEVEW0+EODDW0
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE ESKYNP(NXHERM,NYHERM,NZHERM,ENESKY,ENEVEN,ENEODD,
     *                                ENREAR,ENE_W0,EEVEW0,EODDW0,
     *                                              EKESKY,LDPNMX)
C=======================================================================
      USE HE_DEN
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      DIMENSION
     *          CCPALL(NDCOUP)
      COMPLEX
     *          ZCPALL(NDCOUP)
      COMPLEX
     *          EKESKY,C_ZERO
      COMPLEX
     *          ECC_NP
C
      EQUIVALENCE
     *            (CCPALL,CRHO_T)
      EQUIVALENCE
     *            (ZCPALL,ZRHO_J)
C
      COMPLEX
     *          QUNRHO,
     *          QUNLPR,
     *          QUNTAU,
     *          QUNSCU,
     *          QUNDIV,
     *          QUNSPI,
     *          QUNLPS,
     *          QUNCUR,
     *          QUNKIS,
     *          QUNROT
      COMPLEX
     *          ZRHO_J,ZRHO_I,ZRHODJ,ZRHODI,
     *          ZLPR_J,ZLPR_I,
     *          ZTAU_J,ZTAU_I,
     *          ZSCU_J,ZSCU_I,
     *          ZDIV_J,ZDIV_I,
     *          ZSPI_J,ZSPI_I,ZSPIDJ,ZSPIDI,
     *          ZLPS_J,ZLPS_I,
     *          ZCUR_J,ZCUR_I,
     *          ZKIS_J,ZKIS_I,
     *          ZROT_J,ZROT_I
      COMPLEX
     *          DENSIC,DENCHC,DENPOW
C
      COMMON
     *       /DENTOC/ DENSIC(NDXHRM,NDYHRM,NDZHRM),
     *                DENCHC(NDXHRM,NDYHRM,NDZHRM)
C
      COMMON
     *       /CCPSKY/ CRHO_T,CRHO_S,CRHODT,CRHODS,
     *                CLPR_T,CLPR_S,
     *                CTAU_T,CTAU_S,
     *                CSCU_T,CSCU_S,
     *                CDIV_T,CDIV_S,
     *                CSPI_T,CSPI_S,CSPIDT,CSPIDS,
     *                CLPS_T,CLPS_S,
     *                CCUR_T,CCUR_S,
     *                CKIS_T,CKIS_S,
     *                CROT_T,CROT_S
      COMMON
     *       /ZNPSKY/ ZRHO_J,ZRHO_I,ZRHODJ,ZRHODI,
     *                ZLPR_J,ZLPR_I,
     *                ZTAU_J,ZTAU_I,
     *                ZSCU_J,ZSCU_I,
     *                ZDIV_J,ZDIV_I,
     *                ZSPI_J,ZSPI_I,ZSPIDJ,ZSPIDI,
     *                ZLPS_J,ZLPS_I,
     *                ZCUR_J,ZCUR_I,
     *                ZKIS_J,ZKIS_I,
     *                ZROT_J,ZROT_I
      COMMON
     *       /ECCPNM/ ECC_NP(NDCOUP)
C
      COMMON
     *       /INTSKY/ T0,X0,T1,X1,T2,X2,T3,X3,W0,POWER
C
      COMMON
     *       /INTSTO/ FOURWG(1:NDGAUS,1:NDKART),
     *                FOURPT(1:NDGAUS,1:NDKART)
C
C=======================================================================
C
      IF (LDPNMX.LT.3)
     *    STOP ' LDPNMX > 2 REQUIRED IN ESKYNP'
C
C=======================================================================
C        THE EFFECTIVE COUPLING CONSTANTS AND THE CORRESPONDING  CONTRI-
C        BUTIONS TO THE ENERGY ARE CODED AS DEFINED IN "ESKYRM"
C=======================================================================
C        ATTENTION: THIS SUBROUTINE CALCULATES INTEGRANDS THAT ARE TWICE
C                   SMALLER THAN THEY SHOULD BE, BECAUSE THEY  ARE  NEXT
C                   MULTIPLIED BY THE "PLUS" COUPLING CONSTANTS THAT ARE
C                   TWICE LARGER THAN THE ISOVECTOR COUPLING CONSTANTS.
C=======================================================================
C
      C_ZERO=CMPLX(0.0D0,0.0D0)
C
      DO NUCOUP=1,NDCOUP
         ZCPALL(NUCOUP)=C_ZERO
      END DO
C
      DO IX=1,NXHERM
         DO IY=1,NYHERM
            DO IZ=1,NZHERM
C
C=======================================================================
C        CALCULATING  THE  A U X I L I A R Y   C O N T R A C T I O N S
C=======================================================================
C
               QUNRHO = DE_RHO(IX,IY,IZ,2)*DE_RHO(IX,IY,IZ,3)*2
C
               QUNSPI = C_ZERO
C
               QUNLPR = DE_RHO(IX,IY,IZ,2)*DE_LPR(IX,IY,IZ,3)
     *                + DE_RHO(IX,IY,IZ,3)*DE_LPR(IX,IY,IZ,2)
C
               QUNTAU = DE_RHO(IX,IY,IZ,2)*DE_TAU(IX,IY,IZ,3)
     *                + DE_RHO(IX,IY,IZ,3)*DE_TAU(IX,IY,IZ,2)
C
               QUNLPS=C_ZERO
C
               QUNCUR=C_ZERO
C
               QUNKIS=C_ZERO
C
               QUNSCU=C_ZERO
C
               QUNROT=C_ZERO
C
               QUNDIV = DE_RHO(IX,IY,IZ,2)*DE_DIV(IX,IY,IZ,3)
     *                + DE_RHO(IX,IY,IZ,3)*DE_DIV(IX,IY,IZ,2)
C
               DO K=1,NDKART
C
C=======================================================================
C
                  QUNSPI=QUNSPI
     *                  + DE_SPI(IX,IY,IZ,K,2)*DE_SPI(IX,IY,IZ,K,3)*2
                  QUNCUR=QUNCUR
     *                  + DE_CUR(IX,IY,IZ,K,2)*DE_CUR(IX,IY,IZ,K,3)*2
                  QUNLPS=QUNLPS
     *                  + DE_SPI(IX,IY,IZ,K,2)*DE_LPS(IX,IY,IZ,K,3)
     *                  + DE_SPI(IX,IY,IZ,K,3)*DE_LPS(IX,IY,IZ,K,2)
                  QUNKIS=QUNKIS
     *                  + DE_SPI(IX,IY,IZ,K,2)*DE_KIS(IX,IY,IZ,K,3)
     *                  + DE_SPI(IX,IY,IZ,K,3)*DE_KIS(IX,IY,IZ,K,2)
                  QUNROT=QUNROT
     *                  + DE_SPI(IX,IY,IZ,K,2)*DE_ROC(IX,IY,IZ,K,3)
     *                  + DE_SPI(IX,IY,IZ,K,3)*DE_ROC(IX,IY,IZ,K,2)
C
C=======================================================================
C
                  DO L=1,NDKART
C
                     QUNSCU=QUNSCU + DE_SCU(IX,IY,IZ,K,L,2)
     *                             * DE_SCU(IX,IY,IZ,K,L,3)*2
C
                  END DO
               END DO
C
C=======================================================================
C
               W_HERM=FOURWG(IX,1)*FOURWG(IY,2)*FOURWG(IZ,3)
C
               DENPOW=DENSIC(IX,IY,IZ) ** POWER
C
C=======================================================================
C              CALCULATING THE T0-TERMS OF THE SKYRME ENERGY DENSITY
C=======================================================================
C
               ZRHO_I = ZRHO_I + W_HERM * QUNRHO
C
               ZSPI_I = ZSPI_I + W_HERM * QUNSPI
C
C=======================================================================
C              CALCULATING THE T1-T2-TERMS OF THE SKYRME ENERGY DENSITY
C=======================================================================
C
               ZLPR_I = ZLPR_I + W_HERM * QUNLPR
C
               ZTAU_I = ZTAU_I + W_HERM * QUNTAU
C
               ZCUR_I = ZCUR_I + W_HERM * QUNCUR
C
               ZLPS_I = ZLPS_I + W_HERM * QUNLPS
C
               ZKIS_I = ZKIS_I + W_HERM * QUNKIS
C
               ZSCU_I = ZSCU_I + W_HERM * QUNSCU
C
C=======================================================================
C              CALCULATING THE T3-TERMS OF THE SKYRME ENERGY DENSITY
C=======================================================================
C
               ZRHODI = ZRHODI + W_HERM * QUNRHO * DENPOW
               ZSPIDI = ZSPIDI + W_HERM * QUNSPI * DENPOW
C
               ENREAR = ENREAR + W_HERM
     *                                  *(CRHODS * QUNRHO
     *                                  + CSPIDS * QUNSPI)
     *                                  * DENPOW * (POWER/2)
C
C=======================================================================
C              CALCULATING THE W0-TERMS OF THE SKYRME ENERGY DENSITY
C=======================================================================
C
               ZDIV_I = ZDIV_I + W_HERM * QUNDIV
C
               ZROT_I = ZROT_I + W_HERM * QUNROT
C
            END DO
         END DO
      END DO
C
C=======================================================================
C              PARTIAL SUMMATIONS OF TERMS IN ENERGY
C=======================================================================
C
      ECC_NP=C_ZERO
C
      DO NUCOUP=2,NDCOUP,2
         ENESKY        =ENESKY
     *                 +CCPALL(NUCOUP)*REAL(ZCPALL(NUCOUP))
         EKESKY        =EKESKY
     *                 +CCPALL(NUCOUP)*     ZCPALL(NUCOUP)
         ECC_NP(NUCOUP)=CCPALL(NUCOUP)*     ZCPALL(NUCOUP)
      END DO
C
      DO NUCOUP=2,NDCOUP/2,2
C
         ENEVEN=ENEVEN+CCPALL(NUCOUP)*
     *            REAL(ZCPALL(NUCOUP))
         ENEODD=ENEODD+CCPALL(NUCOUP+NDCOUP/2)
     *           *REAL(ZCPALL(NUCOUP+NDCOUP/2))
C
      END DO
C
      EDIV_I=CCPALL(12)*REAL(ZCPALL(12))
      EROT_I=CCPALL(24)*REAL(ZCPALL(24))
C
      EEVEW0=EEVEW0+EDIV_I
      EODDW0=EODDW0+EROT_I
C
      ENE_W0=ENE_W0+EDIV_I+EROT_I
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE EPAIRI(NXHERM,NYHERM,NZHERM,IN_FIX,IZ_FIX,ITPNMX,
     *                                                     X_PART)
C=======================================================================
      USE HE_DEN
      USE PD_DEN
      USE WD_FLD
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      COMPLEX
     *         EKEPAI
      COMPLEX
     *         QUXRHO, QRHO_X, QRHODX, RRHO_X, RRHODX, DENPOW
      COMPLEX
     *         DENSIC, DENCHC
C
      COMMON
     *       /ALLENE/ EKIN_N,EKIN_P,EKIN_T,
     *                EPOT_N,EPOT_P,EPOT_T,
     *                ESUM_N,ESUM_P,ESUM_T,
     *                EPAI_N,EPAI_P,EPAI_T,
     *                EREA_N,EREA_P,EREA_T,
     *                ELIP_N,ELIP_P,ELIP_T,
     *
     *                ECOULD,ECOULE,ECOULT,
     *                       ECOULS,ECOULV,
     *
     *                EMULCO,EMUSLO,EMUREA,
     *                ESIFCO,ESISLO,ESIREA,
     *                ESPICO,ESPSLO,ESPREA,
     *
     *                ENREAR,ECORCM,ECOR_R,
     *
     *                EEVEW0,EODDW0,ENE_W0,
     *                ENEVEN,ENEODD,ENESKY,
     *                ESTABN,ETOTSP,ETOTFU
      COMMON
     *       /DATPAN/ GPAIRN,FACTGN,EFERMN,DELTAN,EFER2N
     *       /DATPAP/ GPAIRP,FACTGP,EFERMP,DELTAP,EFER2P
      COMMON
     *       /CCPPAI/ PRHO_N,PRHODN,PRHOSN,POWERN,
     *                PRHO_P,PRHODP,PRHOSP,POWERP
      COMMON
     *       /DENTOC/ DENSIC(NDXHRM,NDYHRM,NDZHRM),
     *                DENCHC(NDXHRM,NDYHRM,NDZHRM)
      COMMON
     *       /INTSTO/ FOURWG(1:NDGAUS,1:NDKART),
     *                FOURPT(1:NDGAUS,1:NDKART)
C
C=======================================================================
C         THIS SUBROUTINE CALCULATES THE PAIRING ENERGY AND AVERAGE GAP
C=======================================================================
C         PREPARE THE INPUT DATA
C=======================================================================
C
      IF (ITPNMX.EQ.0) THEN
C
          PRHO_X=PRHO_N
          PRHODX=PRHODN
          POWERX=POWERN
C
          NOPART=IN_FIX
C
      ENDIF
C
      IF (ITPNMX.EQ.1) THEN
C
          PRHO_X=PRHO_P
          PRHODX=PRHODP
          POWERX=POWERP
C
          NOPART=IZ_FIX
C
      ENDIF
C
      IF (ITPNMX.NE.0.AND.ITPNMX.NE.1)
     *                      STOP ' UNALLOWED VALUES OF ITPNMX IN EPAIRI'
C
C=======================================================================
C
      E_REAR=0.0D0
C
      QRHO_X=CMPLX(0.0D0,0.0D0)
      QRHODX=CMPLX(0.0D0,0.0D0)
C
      QCEN_X=0.0D0
C
      DO IZ=1,NZHERM
         DO IY=1,NYHERM
            DO IX=1,NXHERM
C
C=======================================================================
C        CALCULATING  THE  A U X I L I A R Y   C O N T R A C T I O N S
C=======================================================================
C
               QUXRHO = PD_RHO(IX,IY,IZ,ITPNMX)
     *                 *PP_RHO(IX,IY,IZ,ITPNMX)
C
               QUXCEN = REAL(DE_RHO(IX,IY,IZ,ITPNMX)
     *                *CONJG(WD_CEN(IX,IY,IZ,ITPNMX)))
C
               W_HERM=FOURWG(IX,1)*FOURWG(IY,2)*FOURWG(IZ,3)
C
               DENPOW=DENSIC(IX,IY,IZ) ** POWERX
C
C=======================================================================
C              CALCULATING THE T0-TERMS OF THE PAIRING ENERGY DENSITY
C=======================================================================
C
               QRHO_X = QRHO_X + W_HERM * QUXRHO
               QCEN_X = QCEN_X + W_HERM * QUXCEN
C
C=======================================================================
C              CALCULATING THE T3-TERMS OF THE PAIRING ENERGY DENSITY
C=======================================================================
C
               QRHODX = QRHODX + W_HERM * QUXRHO
     *                                  * DENPOW
C
               E_REAR = E_REAR + W_HERM * PRHODX * REAL(QUXRHO) / 4
     *
     *                                  * DENPOW * (POWERX/2)
C
            END DO
         END DO
      END DO
C
C=======================================================================
C         SUMMATIONS OF TERMS IN ENERGY.
C=======================================================================
C         DIVISION BY 4 BELOW CORRESPONDS TO THE FACTOR OF 1/4 WHICH
C         APPEARS IN THE EXPRESSIONS FOR THE PAIRING ENERGY IN TERMS
C         OF THE T0*(1-X0) COUPLING CONSTANT, SEE DFT (A.3B).
C=======================================================================
C
      RRHO_X=PRHO_X * QRHO_X / 4
      RRHODX=PRHODX * QRHODX / 4
C
C      Pairing energy kernel
      EKEPAI= RRHO_X+RRHODX
C      Real part for SR calculations
      E_PAIR= REAL(EKEPAI)
C
      PDELTA=-QCEN_X/X_PART
C
C=======================================================================
C         THIS ESTIMATE OF THE PAIRING STRENGTH IS BASED ON THE SIMPLE
C         BCS EXPRESSION. IT IS VERY CRUDE.
C=======================================================================
C
      G_PAIR=0.0D0
C
      IF (E_PAIR.NE.0.0D0) G_PAIR = -PDELTA**2/E_PAIR
C
C=======================================================================
C         PREPARE THE OUTPUT DATA
C=======================================================================
C
      IF (ITPNMX.EQ.0) THEN
C
          GPAIRN=G_PAIR
          DELTAN=PDELTA
          EPAI_N=E_PAIR
          EREA_N=E_REAR
C
      ENDIF
C
      IF (ITPNMX.EQ.1) THEN
C
          GPAIRP=G_PAIR
          DELTAP=PDELTA
          EPAI_P=E_PAIR
          EREA_P=E_REAR
C
      ENDIF
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE GINTER(NXHERM,NYHERM,NZHERM,ICHARG,MREVER,
     *                                PRHO_X,PRHODX,POWERX)
C=======================================================================
      USE WAVSQU
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      DIMENSION
     *           W_HERM(NDXHRM,NDYHRM,NDZHRM),
     *           WAUXIL(NDXHRM,NDYHRM,NDZHRM)
C
      COMMON
     *       /DENTOT/ DENSIT(NDXHRM,NDYHRM,NDZHRM),
     *                DENCHA(NDXHRM,NDYHRM,NDZHRM)
      COMMON
     *       /INTSTO/ FOURWG(1:NDGAUS,1:NDKART),
     *                FOURPT(1:NDGAUS,1:NDKART)
      COMMON
     *       /MATRIG/ GMATRI(1:NDSTAT,1:NDSTAT,0:NDISOS)
      COMMON
     *       /SPNUMS/ NUMBSP(0:NDREVE,0:NDISOS)
      COMMON
     *       /DIMSTA/ LDTOTS(0:NDISOS),LDSTAT(0:NDISOS),
     *                LDUPPE(0:NDISOS),LDTIMU(0:NDISOS)
      COMMON
     *       /HALFBO/ IHABOX,IHABOY,IHABOZ
C
C=======================================================================
C
      CALL CPUTIM('GINTER',1)
C
C=======================================================================
C         THIS SUBROUTINE CALCULATES THE PAIRING MATRIX ELEMENTS BETWEEN
C         PAIRS OF TIME-REVERSED STATES.
C=======================================================================
C
      LSTATE=NUMBSP(0,ICHARG)+MREVER*NUMBSP(1,ICHARG)
C
      IF (LSTATE.NE.LDSTAT(ICHARG))STOP ' INCONSISTENT LSTATE IN GINTER'
C
C=======================================================================
C        CALCULATING  THE  A U X I L I A R Y   ARRAYS
C=======================================================================
C        DIVISION BY 4 BELOW CORRESPONDS TO THE FACTOR OF 1/4 WHICH
C        APPEARS IN THE EXPRESSIONS FOR THE PAIRING ENERGY IN TERMS
C        OF THE T0*(1-X0) COUPLING CONSTANT, SEE DFT (A.3B).
C=======================================================================
C
      DO IX=1,NXHERM/IHABOX
         DO IY=1,NYHERM/IHABOY
            DO IZ=1,NZHERM/IHABOZ
C
               DENPOW=DENSIT(IX,IY,IZ) ** POWERX
C
               W_HERM(IX,IY,IZ)=-(PRHO_X+PRHODX*DENPOW)/4
     *                          * FOURWG(IX,1)*FOURWG(IY,2)*FOURWG(IZ,3)
C
            END DO
         END DO
      END DO
C
C=======================================================================
C        CALCULATING MATRIX ELEMENTS
C=======================================================================
C
      DO ISTATE=1,LSTATE
C
         DO IX=1,NXHERM/IHABOX
            DO IY=1,NYHERM/IHABOY
               DO IZ=1,NZHERM/IHABOZ
C
                  WAUXIL(IX,IY,IZ) = W_HERM(IX,IY,IZ)
     *                             * SQUWAV(ISTATE,IX,IY,IZ)
C
               END DO
            END DO
         END DO
C
         DO JSTATE=1,ISTATE
C
            QRHO_X=0.0D0
C
            DO IX=1,NXHERM/IHABOX
               DO IY=1,NYHERM/IHABOY
                  DO IZ=1,NZHERM/IHABOZ
C
                     QRHO_X = QRHO_X + WAUXIL(IX,IY,IZ)
     *                               * SQUWAV(JSTATE,IX,IY,IZ)
C
                  END DO
               END DO
            END DO
C
C=======================================================================
C         ATTENTION: THE SIGNS OF GMATRI WERE INCORRECT IN  VERSIONS  UP
C                    TO 2.37S - THIS BUG HAS BEEN CORRECTED  IN  VERSION
C                    2.37T ON 12/12/08.
C                    AT PRESENT, IN THE HFB AND STATE-DEPENDENT-GAP  BCS
C                    CALCULATIONS, MEANING OF PAIRING COUPLING CONSTANTS
C                    IS THE SAME, I.E., FOR THE ATTRACTIVE PAIRING  THEY
C                    MUST BE NEGATIVE. THEN, ACCORDING TO  THE  STANDARD
C                    CONVENTION, THE MATRIX  ELEMENTS  IN  "GMATRI"  ARE
C                    POSITIVE
C=======================================================================
C
           GMATRI(ISTATE,JSTATE,ICHARG)=QRHO_X*IHABOX*IHABOY*IHABOZ
           GMATRI(JSTATE,ISTATE,ICHARG)=GMATRI(ISTATE,JSTATE,ICHARG)
C
         END DO
C
      END DO
C
C=======================================================================
C
      CALL CPUTIM('GINTER',0)
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE PAIPRI(NAMEPN,G_PAIR,E_PAIR,EFERMI,PDELTA,
     *                                LIPKIX,EFER2X,ELIP_X,
     *                                IPAHFB,JPABCS,IAVRGG)
C
      CHARACTER
     *          NAMEPN*8,BCSHFB*3,STRCAL*25
C
      COMMON
     *       /CFIPRI/ NFIPRI
C
C=======================================================================
C         THIS SUBROUTINE PRINTS THE PAIRING DATA
C=======================================================================
C
      IF (IPAHFB.EQ.1) THEN
C
          BCSHFB='HFB'
          STRCAL='                         '
C
      ELSE
C
          IF (JPABCS.GT.0) THEN
C
              BCSHFB='BCS'
              KPABCS=0
C
              IF (JPABCS.EQ.1) THEN
C
                  KPABCS=1
                  IF (IAVRGG.EQ.1) THEN
C
                      STRCAL='(BCS STRENGTH CALCULATED)'
                  ELSE
                      STRCAL='(BCS STRENGTH READ/INPUT)'
C
                  END IF
C
              END IF
C
              IF (JPABCS.EQ.2) THEN
C
                  KPABCS=2
                  STRCAL='(FIXED BCS  PAIRING  GAP)'
C
              END IF
C
              IF (JPABCS.EQ.3) THEN
C
                  KPABCS=3
                  STRCAL='(STATE-DEPENDENT BCS GAP)'
C
              END IF
C
              IF (KPABCS.EQ.0) STOP ' INCORRECT IPABCS IN PAIPRI'
C
          ELSE
C
              STOP ' IPAHFB=0 AND IPABCS=0 IN PAIPRI'
C
          END IF
C
      END IF
C
      WRITE(NFIPRI,'(79(1H*),/,                       1H*,77X,1H*,/,
     *
     *             1H*, 2X,A3,1X,
     *                     ''PAIRING PROPERTIES'',2X,A25,
     *                                               16X,A8,2X,1H*,/,
     *                                                 1H*,77X,1H*,/,
     *             1H*, 2X,''STRENGTH='',    F7.4,3X,
     *                     ''GAP='',         F7.4,3X,
     *                     ''FERMI ENERGY='',F8.4,3X,
     *                     ''ENERGY='',      F9.4,          2X,1H*,/,
     *                                                 1H*,77X,1H*)')
     *
     *                BCSHFB,STRCAL,NAMEPN,G_PAIR,PDELTA,EFERMI,E_PAIR
C
      IF (LIPKIX.EQ.1)
     *    WRITE(NFIPRI,'(
     *             1H*, 2X,''LIPKIN-NOGAMI:'',5X,
     *                     ''GAP='',         F7.4,3X,
     *                     ''LAMBDA2 PAR.='',F8.4,3X,
     *                     ''ENERGY='',      F9.4,          2X,1H*,/,
     *                                                 1H*,77X,1H*)')
     *
     *                PDELTA+EFER2X,EFER2X,ELIP_X
C
      WRITE(NFIPRI,'(79(1H*),/)')
     *
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE PRIENE(JETACM,KETA_R,IPOTHO,I_YUKA,I_GOGA,IGOGPA,
     *                                       LIPKIN,LIPKIP,ICOUEX)
C=======================================================================
      USE hfodd_sizes
C=======================================================================
C
      CHARACTER
     *          ESTABC*13
      COMPLEX
     *          PGOGSD,PGOGVD
C
      COMMON
     *       /ALLENE/ EKIN_N,EKIN_P,EKIN_T,
     *                EPOT_N,EPOT_P,EPOT_T,
     *                ESUM_N,ESUM_P,ESUM_T,
     *                EPAI_N,EPAI_P,EPAI_T,
     *                EREA_N,EREA_P,EREA_T,
     *                ELIP_N,ELIP_P,ELIP_T,
     *
     *                ECOULD,ECOULE,ECOULT,
     *                       ECOULS,ECOULV,
     *
     *                EMULCO,EMUSLO,EMUREA,
     *                ESIFCO,ESISLO,ESIREA,
     *                ESPICO,ESPSLO,ESPREA,
     *
     *                ENREAR,ECORCM,ECOR_R,
     *
     *                EEVEW0,EODDW0,ENE_W0,
     *                ENEVEN,ENEODD,ENESKY,
     *                ESTABN,ETOTSP,ETOTFU
      COMMON
     *       /EYUKTT/ EYUKDT,EYUKD0,EYUKD1,EYUKD2,
     *                EYUKET,EYUKE0,EYUKE1,EYUKE2
      COMMON
     *       /EGOGTT/ EGOGDT,EGOGET
      COMMON
     *       /PN_GOG/ PGOGSD(0:NDISOS),PGOGVD(0:NDISOS)
      COMMON
     *       /DATPAN/ GPAIRN,FACTGN,EFERMN,DELTAN,EFER2N
     *       /DATPAP/ GPAIRP,FACTGP,EFERMP,DELTAP,EFER2P
      COMMON
     *       /CFIPRI/ NFIPRI
C
C=======================================================================
C         THIS SUBROUTINE PRINTS THE ENERGIES
C=======================================================================
C
      WRITE(NFIPRI,'(79(1H*),/,                        1H*,77X,1H*,/,
     *             1H*,31X,'' ENERGIES (MEV)'',            31X,1H*,/,
     *                                                 1H*,77X,1H*,/,
     *                                                     79(1H*),/,
     *                                                 1H*,77X,1H*,/,
     *             1H*, 2X,''KINETIC: (NEU)='',F13.6,4X,
     *                              ''(PRO)='',F13.6,4X,
     *                              ''(TOT)='',F13.6,       1X,1H*)')
     *
     *             EKIN_N,EKIN_P,EKIN_T
C
      IF (IPOTHO.EQ.1)
     *    WRITE(NFIPRI,'(1H*,2X,''EXTEPOT: (NEU)='',F13.6,4X,
     *                                   ''(PRO)='',F13.6,4X,
     *                                   ''(TOT)='',F13.6,1X,1H*)')
     *
     *             EPOT_N,EPOT_P,EPOT_T
C
      WRITE(NFIPRI,'(1H*,2X,''SUM EPS: (NEU)='',F13.6,4X,
     *                               ''(PRO)='',F13.6,4X,
     *                               ''(TOT)='',F13.6,       1X,1H*,/,
     *               1H*,2X,''PAIRING: (NEU)='',F13.6,4X,
     *                               ''(PRO)='',F13.6,4X,
     *                               ''(TOT)='',F13.6,       1X,1H*,/,
     *               1H*,2X,''P-REARR: (NEU)='',F13.6,4X,
     *                               ''(PRO)='',F13.6,4X,
     *                               ''(TOT)='',F13.6,       1X,1H*)')
     *             ESUM_N,ESUM_P,ESUM_T,
     *             EPAI_N,EPAI_P,EPAI_T,
     *             EREA_N,EREA_P,EREA_T
C
      IF (IGOGPA.GE.1)
     *
     *    WRITE(NFIPRI,'(1H*,77X,1H*,/,
     *               1H*,2X,''GOG.PAI: (NEU)='',F13.6,4X,
     *                               ''(PRO)='',F13.6,4X,
     *                               ''(TOT)='',F13.6,       1X,1H*)')
     *
     *             REAL(PGOGSD(0)+PGOGVD(0)),
     *             REAL(PGOGSD(1)+PGOGVD(1)),
     *             REAL(PGOGSD(0)+PGOGVD(0)+PGOGSD(1)+PGOGVD(1))
C
      IF (LIPKIN.EQ.1.OR.LIPKIP.EQ.1)
     *
     *    WRITE(NFIPRI,'(
     *               1H*,2X,''ELIPKIN: (NEU)='',F13.6,4X,
     *                               ''(PRO)='',F13.6,4X,
     *                               ''(TOT)='',F13.6,       1X,1H*)')
     *
     *             ELIP_N,ELIP_P,ELIP_T
C
C
      WRITE(NFIPRI,'(1H*,77X,1H*,/,
     *               1H*,2X,''PAIRGAP: (NEU)='',F13.6,4X,
     *                               ''(PRO)='',F13.6,4X,
     *                               ''THIS SPACE IS EMPTY'',1X,1H*,/,
     *               1H*,2X,''E-FERMI: (NEU)='',F13.6,4X,
     *                               ''(PRO)='',F13.6,4X,
     *                               ''AND AWAITS  YOUR AD'',1X,1H*)')
     *
     *                DELTAN,DELTAP,
     *                EFERMN,EFERMP
C
      IF (LIPKIN.EQ.1.OR.LIPKIP.EQ.1)
     *
     *    WRITE(NFIPRI,'(
     *               1H*,2X,''LAMBDA2: (NEU)='',F13.6,4X,
     *                               ''(PRO)='',F13.6,4X,
     *                               ''AS SOON AS  YOU PAY'',1X,1H*)')
     *
     *                EFER2N,EFER2P
C
      WRITE(NFIPRI,'(1H*,77X,1H*,/,
     *               1H*,2X,''COULOMB: (DIR)='',F13.6,4X,
     *                               ''(EXC)='',F13.6,4X,
     *                               ''(TOT)='',F13.6,       1X,1H*)')
     *
     *                ECOULD,ECOULE,ECOULT
C
      IF (ICOUEX.EQ.2)
     *
     *    WRITE(NFIPRI,'(
     *               1H*,2X,''COULEXC: (SCA)='',F13.6,4X,
     *                               ''(VEC)='',F13.6,4X,
     *                               ''(TOT)='',F13.6,       1X,1H*)')
     *
     *                ECOULS,ECOULV,ECOULE
C
      IF (I_YUKA.GE.1)
     *
     *    WRITE(NFIPRI,'(1H*,77X,1H*,/,
     *               1H*,2X,'' YUKAWA: (DIR)='',F13.6,4X,
     *                               ''(EXC)='',F13.6,4X,
     *                               ''(TOT)='',F13.6,       1X,1H*)')
     *
     *                EYUKDT,EYUKET,EYUKDT+EYUKET
C
      IF (I_GOGA.GE.1)
     *
     *    WRITE(NFIPRI,'(1H*,77X,1H*,/,
     *               1H*,2X,''  GOGNY: (DIR)='',F13.6,4X,
     *                               ''(EXC)='',F13.6,4X,
     *                               ''(TOT)='',F13.6,       1X,1H*)')
     *
     *                EGOGDT,EGOGET,EGOGDT+EGOGET
C
      WRITE(NFIPRI,'(1H*,77X,1H*,/,
     *               1H*,2X,''CONSTR. (MULT)='',F13.6,4X,
     *                               ''SLOPE='',F13.6,4X,
     *                               ''CORR.='',F13.6,       1X,1H*,/,
     *               1H*,2X,''CONSTR. (SURF)='',F13.6,4X,
     *                               ''SLOPE='',F13.6,4X,
     *                               ''CORR.='',F13.6,       1X,1H*,/,
     *               1H*,2X,''CONSTR. (SPIN)='',F13.6,4X,
     *                               ''SLOPE='',F13.6,4X,
     *                               ''CORR.='',F13.6,       1X,1H*,/,
     *                                                  1H*,77X,1H*,/,
     *               1H*,2X,''REARRANGEMENT ENERGY FROM THE SKYRME '',
     *                      ''DENSITY-DEPENDENT TERMS='',
     *                                          F13.6,       1X,1H*,/,
     *               1H*,2X,''ROUTHIAN  (TOTAL ENERGY PLUS MULTIPOL'',
     *                      ''E AND SPIN CONSTRAINTS)='',
     *                                          F13.6,       1X,1H*,/,
     *                                                  1H*,77X,1H*)')
     *               EMULCO,EMUSLO,EMUREA,
     *               ESIFCO,ESISLO,ESIREA,
     *               ESPICO,ESPSLO,ESPREA,
     *
     *                             ENREAR,
     *        ETOTFU+EMULCO+ESIFCO+ESPICO
C
      IF (JETACM.EQ.1)
     *    WRITE(NFIPRI,'(1H*,2X,''TWO--BODY CENTER OF MASS CORR'',
     *                          ''ECTION INCLUDED AFTER VARIATION='',
     *                                         F13.6,       1X,1H*,/,
     *                                                 1H*,77X,1H*)')
     *
     *               ECORCM
C
      IF (JETACM.EQ.2)
     *    WRITE(NFIPRI,'(1H*,2X,''TWO-BODY CENTER OF MASS CORR'',
     *                          ''ECTION INCLUDED BEFORE VARIATION='',
     *                                         F13.6,       1X,1H*,/,
     *                                                 1H*,77X,1H*)')
     *
     *               ECORCM
C
C=======================================================================
C
      IF (KETA_R.EQ.1)
     *    WRITE(NFIPRI,'(1H*,2X,''TWO--BODY   ROTATIONAL   CORR'',
     *                          ''ECTION INCLUDED AFTER VARIATION='',
     *                                         F13.6,       1X,1H*,/,
     *                                                 1H*,77X,1H*)')
     *
     *               ECOR_R
C
      IF (KETA_R.EQ.2)
     *    WRITE(NFIPRI,'(1H*,2X,''TWO-BODY   ROTATIONAL   CORR'',
     *                          ''ECTION INCLUDED BEFORE VARIATION='',
     *                                         F13.6,       1X,1H*,/,
     *                                                 1H*,77X,1H*)')
     *
     *               ECOR_R
C
C=======================================================================
C
      IF (ABS(ESTABN).GE.1E-5.AND.ABS(ESTABN).LT.1E+3) THEN
C
          WRITE(ESTABC,'(F13.6)')     ESTABN
      ELSE
          WRITE(ESTABC,'((1PE13.2))') ESTABN
C
      END IF
C
      WRITE(NFIPRI,'(1H*,2X,''SPIN-ORB (EVE)='',F13.6,4X,
     *                               ''(ODD)='',F13.6,4X,
     *                               ''(TOT)='',F13.6,      1X,1H*,/,
     *               1H*,2X,''SKYRME:  (EVE)='',F13.6,4X,
     *                               ''(ODD)='',F13.6,4X,
     *                               ''(TOT)='',F13.6,      1X,1H*,/,
     *                                                 1H*,77X,1H*,/,
     *               1H*,2X,''TOTAL:  (STAB)='',A13  ,4X,
     *                               '' (SP)='',F13.6,4X,
     *                               ''(FUN)='',F13.6,      1X,1H*,/,
     *                                                 1H*,77X,1H*,/,
     *                                                      79(1H*),/)')
     *               EEVEW0,EODDW0,ENE_W0,
     *               ENEVEN,ENEODD,ENESKY,
     *               ESTABC,ETOTSP,ETOTFU
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE PRIFUN(IROTAT,PRIYUK,I_GOGA,IGOGPA,IVIPRI)
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      CHARACTER
     *          NCPALL*4
      CHARACTER*4
     *            NRHO_N,NRHODN,
     *            NLPR_N,
     *            NTAU_N,
     *            NSCU_N,
     *            NDIV_N,
     *            NSPI_N,NSPIDN,
     *            NLPS_N,
     *            NCUR_N,
     *            NKIS_N,
     *            NROT_N
      CHARACTER*4
     *            NSCR_N,
     *            NDIS_N,
     *            NDSR_N,
     *            NSCS_N,
     *            NSCJ_N,
     *            NCUS_N,
     *            NROS_N,
     *            NDES_N
C
      LOGICAL
     *          PRIYUK
C
      COMPLEX
     *          EYUK_D,EYUK_E
      COMPLEX
     *          EGOGSD,EGOGSE,EGOGVD,EGOGVE,
     *          EGOTSD,EGOTSE,EGOTVD,EGOTVE,
     *          EGOSSD,EGOSSE,EGOSVD,EGOSVE,
     *          EGOPSD,EGOPSE,EGOPVD,EGOPVE,
     *          EGOMSD,EGOMSE,EGOMVD,EGOMVE
      COMPLEX
     *          PGOGSD,PGOGVD,PGOTSD,PGOTVD,
     *          PGOSSD,PGOSVD,PGOPSD,PGOPVD,
     *          PGOMSD,PGOMVD
C
      DIMENSION
     *          CCPALL(NDCOUP), DCPALL(NDCOUP), ECPALL(NDCOUP)
      DIMENSION
     *          VCPALL(NDVIOL)
C
      EQUIVALENCE
     *            (CCPALL,CRHO_T),(DCPALL,DRHO_T),(ECPALL,ERHO_T)
      EQUIVALENCE
     *            (VCPALL,DSCRPP)
      DIMENSION
     *             NCPALL(NDCOUP/2),MCPALL(NDVIOL/4)
      EQUIVALENCE
     *            (NCPALL,NRHO_N),(MCPALL,NSCR_N)
      DIMENSION
     *             EISALL(NDCOUP)
C
      COMMON
     *       /NCPSKY/ NRHO_N,NRHODN,
     *                NLPR_N,
     *                NTAU_N,
     *                NSCU_N,
     *                NDIV_N,
     *                NSPI_N,NSPIDN,
     *                NLPS_N,
     *                NCUR_N,
     *                NKIS_N,
     *                NROT_N
      COMMON
     *       /CCPSKY/ CRHO_T,CRHO_S,CRHODT,CRHODS,
     *                CLPR_T,CLPR_S,
     *                CTAU_T,CTAU_S,
     *                CSCU_T,CSCU_S,
     *                CDIV_T,CDIV_S,
     *                CSPI_T,CSPI_S,CSPIDT,CSPIDS,
     *                CLPS_T,CLPS_S,
     *                CCUR_T,CCUR_S,
     *                CKIS_T,CKIS_S,
     *                CROT_T,CROT_S
      COMMON
     *       /DCPSKY/ DRHO_T,DRHO_S,DRHODT,DRHODS,
     *                DLPR_T,DLPR_S,
     *                DTAU_T,DTAU_S,
     *                DSCU_T,DSCU_S,
     *                DDIV_T,DDIV_S,
     *                DSPI_T,DSPI_S,DSPIDT,DSPIDS,
     *                DLPS_T,DLPS_S,
     *                DCUR_T,DCUR_S,
     *                DKIS_T,DKIS_S,
     *                DROT_T,DROT_S
      COMMON
     *       /ECPSKY/ ERHO_T,ERHO_S,ERHODT,ERHODS,
     *                ELPR_T,ELPR_S,
     *                ETAU_T,ETAU_S,
     *                ESCU_T,ESCU_S,
     *                EDIV_T,EDIV_S,
     *                ESPI_T,ESPI_S,ESPIDT,ESPIDS,
     *                ELPS_T,ELPS_S,
     *                ECUR_T,ECUR_S,
     *                EKIS_T,EKIS_S,
     *                EROT_T,EROT_S
      COMMON
     *       /VCPSKY/ DSCRPP,DSCRMM,DSCRPM,DSCRMP,
     *                DDISPP,DDISMM,DDISPM,DDISMP,
     *                DDSRPP,DDSRMM,DDSRPM,DDSRMP,
     *                DSCSPP,DSCSMM,DSCSPM,DSCSMP,
     *                DSCJPP,DSCJMM,DSCJPM,DSCJMP,
     *                DCUSPP,DCUSMM,DCUSPM,DCUSMP,
     *                DROSPP,DROSMM,DROSPM,DROSMP,
     *                DDESPP,DDESMM,DDESPM,DDESMP
      COMMON
     *       /ENEYUK/ EYUKAD(0:NDISOS,0:NDISOS)
      COMMON
     *       /EN_YUK/ EYUK_D(0:NDISOS,0:NDISOS),
     *                EYUK_E(0:NDISOS,0:NDISOS)
      COMMON
     *       /EYUKTT/ EYUKDT,EYUKD0,EYUKD1,EYUKD2,
     *                EYUKET,EYUKE0,EYUKE1,EYUKE2
      COMMON
     *       /EN_GOG/ EGOGSD(0:NDISOS,0:NDISOS),
     *                EGOGSE(0:NDISOS,0:NDISOS),
     *                EGOGVD(0:NDISOS,0:NDISOS),
     *                EGOGVE(0:NDISOS,0:NDISOS)
     *
     *       /EN_GTS/ EGOTSD,EGOTSE,EGOTVD,EGOTVE,
     *                EGOSSD,EGOSSE,EGOSVD,EGOSVE
     *
     *       /EN_GPM/ EGOPSD,EGOPSE,EGOPVD,EGOPVE,
     *                EGOMSD,EGOMSE,EGOMVD,EGOMVE
      COMMON
     *       /PN_GOG/ PGOGSD(0:NDISOS),PGOGVD(0:NDISOS)
     *
     *       /PN_GTS/ PGOTSD,PGOTVD,PGOSSD,PGOSVD
     *
     *       /PN_GPM/ PGOPSD,PGOPVD,PGOMSD,PGOMVD
     *
     *       /PGOGTT/ PGOGDT
      COMMON
     *       /MCPSKY/ NSCR_N,
     *                NDIS_N,
     *                NDSR_N,
     *                NSCS_N,
     *                NSCJ_N,
     *                NCUS_N,
     *                NROS_N,
     *                NDES_N
      COMMON
     *       /CFIPRI/ NFIPRI
C
C=======================================================================
C         THIS SUBROUTINE PRINTS DENSITY INTEGRALS IN THE FUNCTIONAL
C         AND CONTRIBUTIONS TO THE ENERGY DENSITY
C=======================================================================
C
      WRITE(NFIPRI,'(79(1H*),/,                      1H*,77X,1H*,/,
     *             1H*,18X,''DENSITY INTEGRALS IN '',
     *                     ''THE SKYRME FUNCTIONAL'',    17X,1H*,/,
     *                                               1H*,77X,1H*,/,
     *                                                   79(1H*),/,
     *                                               1H*,77X,1H*,/,
     *             1H*,13X,''      TOTAL(T)'',
     *                     ''        SUM(S)'',4X,
     *                     ''  ISOSCALAR(P)'',
     *                     ''  ISOVECTOR(M)'',4X,            1H*,/,
     *             1H*,13X,''      --------'',
     *                     ''        ------'',4X,
     *                     ''  ------------'',
     *                     ''  ------------'',4X,            1H*,/,
     *         2(6(1H*,4X,A1,A4,'' = '',1X,2(2F14.6,4X),     1H*,/),
     *                                               1H*,77X,1H*,/),
     *                                                    79(1H*),/)')
     *
     *         ('D',NCPALL(I),DCPALL(2*I-1),DCPALL(2*I),
     *                        DCPALL(2*I-1),
     *                       -DCPALL(2*I-1)+2*DCPALL(2*I),I=1,NDCOUP/2)
C
C=======================================================================
C         PRINTING INTEGRALS OF SYMMETRY-VIOLATING TERMS (PRELIMINARY)
C         SWITCHED OFF STARTING FROM VERSION  2.06B  (20/12/2003). IN
C         THE FUTURE IT SHOULD BE DONE PROPERLY, BECAUSE ONE OF THESE
C         TERMS (DSC) DOES NOT, IN FACT, VIOLATE SYMMETRY AND  SHOULD
C         BE MOVED TO THE REGULAR  TIME-ODD-TERMS  TABLE,  WHERE,  IN
C         ADDITION, THE NEW TERM (F^2) MUST ALSO BE INCLUDED.
C=======================================================================
C
      IF (IROTAT.EQ.1.AND.IVIPRI.EQ.1)
     *    WRITE(NFIPRI,'(79(1H*),/,                  1H*,77X,1H*,/,
     *             1H*,18X,''INTEGRALS OF THE SYMM'',
     *                     ''ETRY-VIOLATING TERMS '',    17X,1H*,/,
     *                                               1H*,77X,1H*,/,
     *                                                   79(1H*),/,
     *                                               1H*,77X,1H*,/,
     *             1H*,13X,'' ISOSCALAR(PP)'',
     *                     '' ISOVECTOR(MM)'',4X,
     *                     '' MIXED S-V(PM)'',
     *                     '' MIXED V-S(MP)'',4X,            1H*,/,
     *             1H*,13X,'' -------------'',
     *                     '' -------------'',4X,
     *                     '' -------------'',
     *                     '' -------------'',4X,            1H*,/,
     *           3(1H*,4X,A1,A4,'' = '',1X,2(2F14.6,4X),     1H*,/),
     *                                               1H*,77X,1H*,/,
     *           4(1H*,4X,A1,A4,'' = '',1X,2(2F14.6,4X),     1H*,/),
     *                                               1H*,77X,1H*,/,
     *           1(1H*,4X,A1,A4,'' = '',1X,2(2F14.6,4X),     1H*,/),
     *                                               1H*,77X,1H*,/,
     *                                                    79(1H*),/)')
     *
     *         ('D',MCPALL(I),VCPALL(4*I-3),VCPALL(4*I-2),
     *                        VCPALL(4*I-1),VCPALL(4*I  ),I=1,NDVIOL/4)
C
C=======================================================================
C         PRINTING AVERAGE ENERGIES OF THE YUKAWA INTERACTION
C=======================================================================
C
      IF (IROTAT.EQ.1.AND.PRIYUK) THEN
C
          EYUKPP=(DDSRPP-DDSRPM-DDSRMP+DDSRMM)/4
          EYUKNN=(DDSRPP+DDSRPM+DDSRMP+DDSRMM)/4
          EYUKPN=(DDSRPP+DDSRPM-DDSRMP-DDSRMM)/4
          EYUKNP=(DDSRPP-DDSRPM+DDSRMP-DDSRMM)/4
C
          WRITE(NFIPRI,'(79(1H*),/,                  1H*,77X,1H*,/,
     *             1H*,13X,''   PROT-PROT  '',
     *                     ''   NEUT-NEUT  '',4X,
     *                     ''   PROT-NEUT  '',
     *                     ''   NEUT-PROT  '',4X,            1H*,/,
     *             1H*,13X,'' -------------'',
     *                     '' -------------'',4X,
     *                     '' -------------'',
     *                     '' -------------'',4X,            1H*,/,
     *              1H*,4X,A1,A4,'' = '',1X,2(2D14.6,4X),    1H*)')
     *
     *          'Y','DDSR',EYUKPP,EYUKNN,EYUKPN,EYUKNP
C
          EYUKPP=EYUKAD(1,1)
          EYUKNN=EYUKAD(0,0)
          EYUKPN=EYUKAD(1,0)
          EYUKNP=EYUKAD(0,1)
C
          WRITE(NFIPRI,'(1H*,4X,A1,A4,'' = '',1X,2(2D14.6,4X),    1H*)')
     *
     *          'Y','DIR1',EYUKPP,EYUKNN,EYUKPN,EYUKNP
C
          EYUKPP=REAL(EYUK_D(1,1))
          EYUKNN=REAL(EYUK_D(0,0))
          EYUKPN=REAL(EYUK_D(1,0))
          EYUKNP=REAL(EYUK_D(0,1))
C
          WRITE(NFIPRI,'(1H*,4X,A1,A4,'' = '',1X,2(2D14.6,4X),    1H*,/,
     *                                                    1H*,77X,1H*)')
     *
     *          'Y','DIR2',EYUKPP,EYUKNN,EYUKPN,EYUKNP
C
          EYUKPP=(DSCSPP-DSCSPM-DSCSMP+DSCSMM)/4
          EYUKNN=(DSCSPP+DSCSPM+DSCSMP+DSCSMM)/4
          EYUKPN=(DSCSPP+DSCSPM-DSCSMP-DSCSMM)/4
          EYUKNP=(DSCSPP-DSCSPM+DSCSMP-DSCSMM)/4
C
          WRITE(NFIPRI,'(1H*,4X,A1,A4,'' = '',1X,2(2D14.6,4X),    1H*)')
     *
     *          'Y','DSCS',EYUKPP,EYUKNN,EYUKPN,EYUKNP
C
          EYUKPP=AIMAG(EYUK_E(1,1))
          EYUKNN=AIMAG(EYUK_E(0,0))
          EYUKPN=AIMAG(EYUK_E(1,0))
          EYUKNP=AIMAG(EYUK_E(0,1))
C
          WRITE(NFIPRI,'(1H*,4X,A1,A4,'' = '',1X,2(2D14.6,4X),    1H*,/,
     *                                                    1H*,77X,1H*)')
     *
     *          'Y','EXC2',EYUKPP,EYUKNN,EYUKPN,EYUKNP
C
          WRITE(NFIPRI,'(                                   79(1H*),/)')
C
      END IF
C
C=======================================================================
C         CALCULATING SUMS OF THE TIME-EVEN AND TIME-ODD CONTRIBUTIONS
C=======================================================================
C
      DO I=1,NDCOUP/2
C
         EISALL(2*I-1)=  DCPALL(2*I-1)*(CCPALL(2*I-1)   +CCPALL(2*I)/2)
         EISALL(2*I  )=(-DCPALL(2*I-1)+ DCPALL(2*I  )*2)*CCPALL(2*I)/2
C
      END DO
C
      EEVE_T=0.0
      EEVE_S=0.0
      EEVE_P=0.0
      EEVE_M=0.0
C
      DO I=1,NDCOUP/4
C
         EEVE_T=EEVE_T+ECPALL(2*I-1)
         EEVE_S=EEVE_S+ECPALL(2*I  )
         EEVE_P=EEVE_P+EISALL(2*I-1)
         EEVE_M=EEVE_M+EISALL(2*I  )
C
      END DO
C
      EODD_T=0.0
      EODD_S=0.0
      EODD_P=0.0
      EODD_M=0.0
C
      DO I=NDCOUP/4+1,NDCOUP/2
C
         EODD_T=EODD_T+ECPALL(2*I-1)
         EODD_S=EODD_S+ECPALL(2*I  )
         EODD_P=EODD_P+EISALL(2*I-1)
         EODD_M=EODD_M+EISALL(2*I  )
C
      END DO
C
      WRITE(NFIPRI,'(79(1H*),/,                      1H*,77X,1H*,/,
     *             1H*,15X,''CONTRIBUTIONS TO ENERGY '',
     *                     ''IN THE SKYRME FUNCTIONAL'', 14X,1H*,/,
     *                                               1H*,77X,1H*,/,
     *                                                   79(1H*),/,
     *                                               1H*,77X,1H*,/,
     *             1H*,13X,''    TOTAL(T)  '',
     *                     ''      SUM(S)  '',4X,
     *                     ''  ISOSCALAR(P)'',
     *                     ''  ISOVECTOR(M)'',4X,            1H*,/,
     *             1H*,13X,''    --------  '',
     *                     ''      ------  '',4X,
     *                     ''  ------------'',
     *                     ''  ------------'',4X,            1H*)')
C
      WRITE(NFIPRI,'(2(6(1H*,4X,A1,A4,'' = '',1X,2(2F14.6,4X),1H*,/),
     *              1H*,13X,2(2(2X,12(1H=)),   4X),           1H*,/,
     *              1H*, 4X,A9,             2(2F14.6,4X),     1H*,/,
     *                                                1H*,77X,1H*,/),
     *                                                     79(1H*))')
     *
     *         ('E',NCPALL(I),ECPALL(2*I-1),ECPALL(2*I),
     *                        EISALL(2*I-1),EISALL(2*I),I=1,NDCOUP/4),
     *          'SUM EVEN:',EEVE_T,EEVE_S,EEVE_P,EEVE_M,
     *
     *         ('E',NCPALL(I),ECPALL(2*I-1),ECPALL(2*I),
     *                        EISALL(2*I-1),EISALL(2*I),I=NDCOUP/4+1,
     *                                                    NDCOUP/2),
     *          'SUM  ODD:',EODD_T,EODD_S,EODD_P,EODD_M
C
      IF (PRIYUK) THEN
C
          WRITE(NFIPRI,'(                            1H*,77X,1H*,/,
     *             1H*,14X,''CONTRIBUTIONS TO ENERGY '',
     *                     ''OF THE YUKAWA INTERACTION'',14X,1H*,/,
     *                                               1H*,77X,1H*,/,
     *                                                   79(1H*),/,
     *                                               1H*,77X,1H*,/,
     *             1H*,13X,''  FACTOR OF G0'',
     *                     ''  FACTOR OF G1'',
     *                     ''  FACTOR OF G2'',4X,
     *                     ''  TOTAL ENERGY'',4X,            1H*,/,
     *             1H*,13X,''  ------------'',
     *                     ''  ------------'',
     *                     ''  ------------'',4X,
     *                     ''  ------------'',4X,            1H*)')
C
          WRITE(NFIPRI,'(
     *            1H*,1X,''  DIRECT = '',1X,2E14.6,2(E14.6,4X),1H*,/,
     *            1H*,1X,''EXCHANGE = '',1X,2E14.6,2(E14.6,4X),1H*,/,
     *            1H*,13X,3(2X,12(1H=)),6X,12(1H=),4X,         1H*,/,
     *            1H*,1X,''   TOTAL = '',1X,2E14.6,2(E14.6,4X),1H*,/,
     *                                                 1H*,77X,1H*,/,
     *                                                      79(1H*))')
     *
     *    EYUKD0,       EYUKD1,       EYUKD2,       EYUKDT,
     *           EYUKE0,       EYUKE1,       EYUKE2,       EYUKET,
     *    EYUKD0+EYUKE0,EYUKD1+EYUKE1,EYUKD2+EYUKE2,EYUKDT+EYUKET
C
      END IF
C
C=======================================================================
C         PRINTING AVERAGE ENERGIES OF THE GOGNY INTERACTION
C=======================================================================
C
      IF (I_GOGA.GE.1) THEN
C
          EGOGPP=REAL(EGOGSD(1,1))
          EGOGNN=REAL(EGOGSD(0,0))
          EGOGPN=REAL(EGOGSD(1,0))
          EGOGNP=REAL(EGOGSD(0,1))
C
          WRITE(NFIPRI,'(                            1H*,77X,1H*,/,
     *             1H*,14X,''CONTRIBUTIONS TO ENERGY '',
     *                     ''OF THE GOGNY INTERACTION'', 15X,1H*,/,
     *                                               1H*,77X,1H*,/,
     *                                                   79(1H*),/,
     *                                               1H*,77X,1H*,/,
     *             1H*,13X,''   PROT-PROT  '',
     *                     ''   NEUT-NEUT  '',4X,
     *                     ''   PROT-NEUT  '',
     *                     ''   NEUT-PROT  '',4X,            1H*,/,
     *             1H*,13X,'' -------------'',
     *                     '' -------------'',4X,
     *                     '' -------------'',
     *                     '' -------------'',4X,            1H*,/,
     *              1H*,4X,A4,A1,'' = '',1X,2(2D14.6,4X),    1H*)')
     *
     *          'SCA_','D',EGOGPP,EGOGNN,EGOGPN,EGOGNP
C
          EGOGPP=REAL(EGOGVD(1,1))
          EGOGNN=REAL(EGOGVD(0,0))
          EGOGPN=REAL(EGOGVD(1,0))
          EGOGNP=REAL(EGOGVD(0,1))
C
          WRITE(NFIPRI,'(1H*,4X,A4,A1,'' = '',1X,2(2D14.6,4X),    1H*)')
     *
     *          'VEC_','D',EGOGPP,EGOGNN,EGOGPN,EGOGNP
C
          EGOGPP=REAL(EGOGSE(1,1))
          EGOGNN=REAL(EGOGSE(0,0))
          EGOGPN=REAL(EGOGSE(1,0))
          EGOGNP=REAL(EGOGSE(0,1))
C
          WRITE(NFIPRI,'(1H*,4X,A4,A1,'' = '',1X,2(2D14.6,4X),    1H*)')
     *
     *          'SCA_','E',EGOGPP,EGOGNN,EGOGPN,EGOGNP
C
          EGOGPP=REAL(EGOGVE(1,1))
          EGOGNN=REAL(EGOGVE(0,0))
          EGOGPN=REAL(EGOGVE(1,0))
          EGOGNP=REAL(EGOGVE(0,1))
C
          WRITE(NFIPRI,'(1H*,4X,A4,A1,'' = '',1X,2(2D14.6,4X),    1H*,/,
     *                                                    1H*,77X,1H*)')
     *
     *          'VEC_','E',EGOGPP,EGOGNN,EGOGPN,EGOGNP
C
          WRITE(NFIPRI,'(79(1H*),/,                  1H*,77X,1H*,/,
     *             1H*,13X,''    TOTAL(T)  '',
     *                     ''      SUM(S)  '',4X,
     *                     ''  ISOSCALAR(P)'',
     *                     ''  ISOVECTOR(M)'',4X,            1H*,/,
     *             1H*,13X,''    --------  '',
     *                     ''      ------  '',4X,
     *                     ''  ------------'',
     *                     ''  ------------'',4X,            1H*)')
C
          EGOG_T=REAL(EGOTSD)
          EGOG_S=REAL(EGOSSD)
          EGOG_P=REAL(EGOPSD)
          EGOG_M=REAL(EGOMSD)
C
          WRITE(NFIPRI,'(1H*,4X,A4,A1,'' = '',1X,2(2F14.6,4X),1H*)')
     *
     *          'SCA_','D',EGOG_T,EGOG_S,EGOG_P,EGOG_M
C
          EGOG_T=REAL(EGOTVD)
          EGOG_S=REAL(EGOSVD)
          EGOG_P=REAL(EGOPVD)
          EGOG_M=REAL(EGOMVD)
C
          WRITE(NFIPRI,'(1H*,4X,A4,A1,'' = '',1X,2(2F14.6,4X),1H*)')
     *
     *          'VEC_','D',EGOG_T,EGOG_S,EGOG_P,EGOG_M
C
          EGOG_T=REAL(EGOTSE)
          EGOG_S=REAL(EGOSSE)
          EGOG_P=REAL(EGOPSE)
          EGOG_M=REAL(EGOMSE)
C
          WRITE(NFIPRI,'(1H*,4X,A4,A1,'' = '',1X,2(2F14.6,4X),1H*)')
     *
     *          'SCA_','E',EGOG_T,EGOG_S,EGOG_P,EGOG_M
C
          EGOG_T=REAL(EGOTVE)
          EGOG_S=REAL(EGOSVE)
          EGOG_P=REAL(EGOPVE)
          EGOG_M=REAL(EGOMVE)
C
          WRITE(NFIPRI,'(1H*,4X,A4,A1,'' = '',1X,2(2F14.6,4X),1H*,/,
     *                                                1H*,77X,1H*)')
     *
     *          'VEC_','E',EGOG_T,EGOG_S,EGOG_P,EGOG_M
C
          WRITE(NFIPRI,'(                                   79(1H*),/)')
C
      END IF
C
C=======================================================================
C         PRINTING AVERAGE ENERGIES OF THE GOGNY INTERACTION
C=======================================================================
C
      IF (IGOGPA.GE.1) THEN
C
          PGOGPP=REAL(PGOGSD(1))
          PGOGNN=REAL(PGOGSD(0))
          PGOGPN=0.0D0
          PGOGNP=0.0D0
C
          WRITE(NFIPRI,'(                  79(1H*),/,1H*,77X,1H*,/,
     *             1H*,14X,''CONTRIBUTIONS TO PAIRING '',
     *                     ''OF THE GOGNY INTERACTION'', 14X,1H*,/,
     *                                               1H*,77X,1H*,/,
     *                                                   79(1H*),/,
     *                                               1H*,77X,1H*,/,
     *             1H*,13X,''   PROT-PROT  '',
     *                     ''   NEUT-NEUT  '',4X,
     *                     ''   PROT-NEUT  '',
     *                     ''   NEUT-PROT  '',4X,            1H*,/,
     *             1H*,13X,'' -------------'',
     *                     '' -------------'',4X,
     *                     '' -------------'',
     *                     '' -------------'',4X,            1H*,/,
     *              1H*,4X,A4,A1,'' = '',1X,2(2D14.6,4X),    1H*)')
     *
     *          'SCA_','D',PGOGPP,PGOGNN,PGOGPN,PGOGNP
C
          PGOGPP=REAL(PGOGVD(1))
          PGOGNN=REAL(PGOGVD(0))
          PGOGPN=0.0D0
          PGOGNP=0.0D0
C
          WRITE(NFIPRI,'(1H*,4X,A4,A1,'' = '',1X,2(2D14.6,4X),1H*,/,
     *                                                1H*,77X,1H*)')
     *
     *          'VEC_','D',PGOGPP,PGOGNN,PGOGPN,PGOGNP
C
          WRITE(NFIPRI,'(79(1H*),/,                  1H*,77X,1H*,/,
     *             1H*,13X,''    TOTAL(T)  '',
     *                     ''      SUM(S)  '',4X,
     *                     ''  ISOSCALAR(P)'',
     *                     ''  ISOVECTOR(M)'',4X,            1H*,/,
     *             1H*,13X,''    --------  '',
     *                     ''      ------  '',4X,
     *                     ''  ------------'',
     *                     ''  ------------'',4X,            1H*)')
C
          PGOG_T=REAL(PGOTSD)
          PGOG_S=REAL(PGOSSD)
          PGOG_P=REAL(PGOPSD)
          PGOG_M=REAL(PGOMSD)
C
          WRITE(NFIPRI,'(1H*,4X,A4,A1,'' = '',1X,2(2F14.6,4X),1H*)')
     *
     *          'SCA_','D',PGOG_T,PGOG_S,PGOG_P,PGOG_M
C
          PGOG_T=REAL(PGOTVD)
          PGOG_S=REAL(PGOSVD)
          PGOG_P=REAL(PGOPVD)
          PGOG_M=REAL(PGOMVD)
C
          WRITE(NFIPRI,'(1H*,4X,A4,A1,'' = '',1X,2(2F14.6,4X),1H*,/,
     *                                                1H*,77X,1H*)')
     *
     *          'VEC_','D',PGOG_T,PGOG_S,PGOG_P,PGOG_M
C
      END IF
      WRITE(NFIPRI,'(79(1H*),/)')
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE COUMAT(NXHERM,NYHERM,NZHERM,NXMAXX,NYMAXX,NZMAXX,
     *                                NUMCOU,BOUCOU,ISIMPY,IKERNE)
C=======================================================================
      USE HE_DEN
      USE HCOULO
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      DIMENSION
     *          SONBAS(0:ND2MAX,0:ND2MAX,0:ND2MAX)
C
      COMPLEX
     *          SONBAS
C
      COMMON
     *       /HERMEM/ HERONE(0:ND2MAX,1:NDGAUS,1:NDKART)
      COMMON
     *       /INTMEM/ TWOWGT(1:NDGAUS,1:NDKART),
     *                TWOPNT(1:NDGAUS,1:NDKART)
      COMMON
     *       /CHARGE/ ECHAR2
C
C=======================================================================
C
      CALL CPUTIM('COUMAT',1)
C
C=======================================================================
C
      IALLOC=0
C
C=======================================================================
      IF (.NOT.ALLOCATED(HPPCOU)) THEN
          ALLOCATE (HPPCOU(1:NDBASE,1:NDBASE),STAT=IALLOC)
          IF (IALLOC.NE.0) CALL NOALLO('HPPCOU','COUMAT')
      END IF
C=======================================================================
      IF (.NOT.ALLOCATED(HPMCOU)) THEN
          ALLOCATE (HPMCOU(1:NDBASE,1:NDBASE),STAT=IALLOC)
          IF (IALLOC.NE.0) CALL NOALLO('HPMCOU','COUMAT')
      END IF
C=======================================================================
C
C=======================================================================
C        THIS SUBROUTINE CALCULATES THE MATRIX ELEMENTS OF THE COULOMB
C        POTENTIAL
C=======================================================================
C
      NDEGRE=0
      KFRAGM=0
C
      CALL BEGINC(DE_RHO(1,1,1,1),SONBAS,NDEGRE,NXHERM,NYHERM,NZHERM,
     *                            HERONE,TWOWGT,NXMAXX,NYMAXX,NZMAXX)
C
      PIOMAS=0.0D0
      ISURFA=1
C
      CALL INTCOU(NXMAXX,NYMAXX,NZMAXX,NUMCOU,BOUCOU,SONBAS,
     *                   ECHAR2,PIOMAS,ISURFA,IKERNE,ISIMPY,
     *                                 KFRAGM,HPPCOU,HPMCOU)
C
C=======================================================================
C
      CALL CPUTIM('COUMAT',0)
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE COULOD(ISIMPY,EKECOD)
C=======================================================================
      USE HCOULO
      USE MAT_PP
      USE MAT_PM
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      COMPLEX
     *          RESULT,EKECOD
C=======================================================================
      COMMON
     *       /DIMENS/ LDBASE
C
C=======================================================================
C        THIS  SUBROUTINE  CALCULATES   DIRECT  CONTRIBUTION  TO  THE
C                      C O U L O M B   E N E R G Y
C        IT ASSUMES THAT THE MATRIX ELEMENTS OF THE COULOMB POTENTIAL
C        HAVE ALREADY BEEN CALCULATED, AND THEN CALCULATES THE  TRACE
C        WITH THE DENSITY MATRIX. IT ASSUMES THAT THE PROTON  DENSITY
C        MATRIX IS PRESENT IN 'BIG_PP' AND 'BIG_PM'
C=======================================================================
C
C=======================================================================
C         CONTRIBUTIONS FORM THE DIAGONAL SIMPLEX BLOCKS
C=======================================================================
C
      RESULT=CMPLX(0.0D0,0.0D0)
C
      DO IBRA=1,LDBASE
         DO IKET=1,LDBASE
C
            RESULT=RESULT+HPPCOU(IBRA,IKET) * (BIG_PP(IKET,IBRA,0)
     *                                        +BIG_PP(IKET,IBRA,1))
C
         END DO
      END DO
C
      EKECOD=RESULT
C
C=======================================================================
C         CONTRIBUTIONS FORM THE OFF-DIAGONAL SIMPLEX BLOCKS
C=======================================================================
C
      IF (ISIMPY.NE.1) THEN
C
          RESULT=CMPLX(0.0D0,0.0D0)
C
          DO IBRA=1,LDBASE
             DO IKET=1,LDBASE
C
                RESULT=RESULT+HPMCOU(IBRA,IKET) * (BIG_PM(IKET,IBRA,1)
     *                                            -BIG_PM(IKET,IBRA,0))
C
             END DO
          END DO
C
          EKECOD=EKECOD+RESULT
C
      END IF
C
      EKECOD=EKECOD/2.0D0
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE YUKMAT(NXHERM,NYHERM,NZHERM,NXMAXX,NYMAXX,NZMAXX,
     *                                PIMASS,NUMCOU,BOUCOU,ISIMPY)
C=======================================================================
      USE HYUKAW
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      COMPLEX
     *          DENDIS,SONBAS
C
      DIMENSION
     *          SONBAS(0:ND2MAX,0:ND2MAX,0:ND2MAX)
C
      COMMON
     *       /HERMEM/ HERONE(0:ND2MAX,1:NDGAUS,1:NDKART)
      COMMON
     *       /INTMEM/ TWOWGT(1:NDGAUS,1:NDKART),
     *                TWOPNT(1:NDGAUS,1:NDKART)
      COMMON
     *       /DISDEN/ DENDIS(NDXHRM,NDYHRM,NDZHRM,0:NDISOS)
C
C=======================================================================
C
      CALL CPUTIM('YUKMAT',1)
C
C=======================================================================
C
      IALLOC=0
C
C=======================================================================
      IF (.NOT.ALLOCATED(HPPYUK)) THEN
          ALLOCATE (HPPYUK(1:NDBASE,1:NDBASE,0:NDISOS),STAT=IALLOC)
          IF (IALLOC.NE.0) CALL NOALLO('HPPYUK','YUKMAT')
      END IF
C=======================================================================
      IF (.NOT.ALLOCATED(HPMYUK).AND.ISIMPY.NE.1) THEN
          ALLOCATE (HPMYUK(1:NDBASE,1:NDBASE,0:NDISOS),STAT=IALLOC)
          IF (IALLOC.NE.0) CALL NOALLO('HPMYUK','YUKMAT')
      END IF
C=======================================================================
C
C=======================================================================
C        THIS SUBROUTINE CALCULATES THE MATRIX ELEMENTS OF THE YUKAWA
C        POTENTIAL FOR THE "DIV S" DENSITY AS THE SOURCE
C=======================================================================
C
      NDEGRE=0
      ISURFA=0
      IKERNE=0
      KFRAGM=0
C
      FACTOR=PIMASS**2/(16.0D0*ATAN(1.0D0))
C
      DO ICHARG=0,NDISOS
C
         CALL BEGINC(DENDIS(1,1,1,ICHARG),
     *               SONBAS,NDEGRE,NXHERM,NYHERM,NZHERM,
     *               HERONE,TWOWGT,NXMAXX,NYMAXX,NZMAXX)
C
         CALL INTCOU(NXMAXX,NYMAXX,NZMAXX,NUMCOU,BOUCOU,SONBAS,
     *                      FACTOR,PIMASS,ISURFA,IKERNE,ISIMPY,
     *                               KFRAGM,HPPYUK(1,1,ICHARG),
     *                                      HPMYUK(1,1,ICHARG))
C
      END DO
C
C=======================================================================
C
      CALL CPUTIM('YUKMAT',0)
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE YUKAWD(ISIMPY,ICHARG)
C=======================================================================
      USE HYUKAW
      USE MAT_PP
      USE MAT_PM
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      COMPLEX
     *          RESULT
C
C=======================================================================
      COMMON
     *       /ENEYUK/ EYUKAD(0:NDISOS,0:NDISOS)
C
      COMMON
     *       /DIMENS/ LDBASE
C
C=======================================================================
C        THIS  SUBROUTINE  CALCULATES   DIRECT  CONTRIBUTION  TO  THE
C                      Y U K A W A   E N E R G Y
C        IT ASSUMES THAT THE MATRIX ELEMENTS OF THE YUKAWA POTENTIALS
C        HAVE ALREADY BEEN CALCULATED, AND THEN CALCULATES THE  TRACE
C        WITH THE DENSITY MATRIX. IT ASSUMES THAT THE DENSITY  MATRIX
C        IS PRESENT IN 'BIG_PP' AND 'BIG_PM'
C=======================================================================
C
      DO JCHARG=0,NDISOS
C
C=======================================================================
C         CONTRIBUTIONS FORM THE DIAGONAL SIMPLEX BLOCKS
C=======================================================================
C
         RESULT=CMPLX(0.0D0,0.0D0)
C
         DO IBRA=1,LDBASE
            DO IKET=1,LDBASE
C
               RESULT=RESULT+HPPYUK(IBRA,IKET,JCHARG)
     *                                        *(BIG_PP(IKET,IBRA,0)
     *                                        + BIG_PP(IKET,IBRA,1))
C
            END DO
         END DO
C
         EYUKAD(JCHARG,ICHARG)=REAL(RESULT)
C
C=======================================================================
C         CONTRIBUTIONS FORM THE OFF-DIAGONAL SIMPLEX BLOCKS
C=======================================================================
C
         IF (ISIMPY.NE.1) THEN
C
             RESULT=CMPLX(0.0D0,0.0D0)
C
             DO IBRA=1,LDBASE
                DO IKET=1,LDBASE
C
                   RESULT=RESULT+HPMYUK(IBRA,IKET,JCHARG)
     *                                            *BIG_PM(IKET,IBRA,0)
C
                END DO
             END DO
C
             EYUKAD(JCHARG,ICHARG)=EYUKAD(JCHARG,ICHARG)-2*REAL(RESULT)
C
         END IF
C
      END DO
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE COULOE(NXHERM,NYHERM,NZHERM,EKECOE)
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      COMPLEX
     *          DENSIC,DENCHC,DENHAM,EKECOE
C
      COMMON
     *       /DENTOC/ DENSIC(NDXHRM,NDYHRM,NDZHRM),
     *                DENCHC(NDXHRM,NDYHRM,NDZHRM)
      COMMON
     *       /DENEXP/ EXPAUX(NDXHRM,NDYHRM,NDZHRM)
      COMMON
     *       /INTSTO/ FOURWG(1:NDGAUS,1:NDKART),
     *                FOURPT(1:NDGAUS,1:NDKART)
      COMMON
     *       /EXCHAN/ COULEX
C
C=======================================================================
C        THIS SUBROUTINE CALCULATES THE EXCHANGE CONTRIBUTION TO THE
C                       C O U L O M B   E N E R G Y
C=======================================================================
C        ATTENTION --->  IN  THIS  SUBROUTINE  THE  INTEGRAND HAS TO
C        BE  CALCULATED  WITHOUT  THE  EXPONENTIAL  FACTOR  SQUARED,
C        BECAUSE SUCH A FACTOR IS INCLUDED  IN THE GAUSS INTEGRATION
C        WEIGHTS.  THEREFORE,  THE  COULOMB  EXCHANGE ENERGY DENSITY
C        IS  BELOW  DIVIDED  BY THE SQUARE OF THE  "EXPAUX"   ARRAY.
C=======================================================================
C
      EKECOE=CMPLX(0.0D0,0.0D0)
C
      DO IZ=1,NZHERM
         DO IY=1,NYHERM
            DO IX=1,NXHERM
C
               DENHAM = DENCHC(IX,IY,IZ) ** ( 4./3.)
     *                / EXPAUX(IX,IY,IZ) / EXPAUX(IX,IY,IZ)
C
               W_HERM=FOURWG(IX,1)*FOURWG(IY,2)*FOURWG(IZ,3)
C
               EKECOE=EKECOE+W_HERM*DENHAM
C
            END DO
         END DO
      END DO
C
      EKECOE = COULEX * EKECOE
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE COUENE(NXHERM,NYHERM,NZHERM,NXMAXX,NYMAXX,NZMAXX,
     *                                                     ISIMPY,
     *                                       ICOTYP,ICOUDI,ICOUEX,
     *                                       EKECOD,EKESCA,EKEVEC,
     *                                              SLOWEV,ISEXAC)
C=======================================================================
      USE GAUSTO
      USE COUSTO
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      COMPLEX
     *          EKECOD,EKESCA,EKEVEC
      COMPLEX
     *          C_ZERO
      COMPLEX
     *          PHACOM
C
      DIMENSION
     *          COUSTR(ND_COU,NDCOTY),COULAR(ND_COU,NDCOTY)
      DIMENSION
     *          XNODES(ND_COU),WEIGHT(ND_COU)
      DIMENSION
     *          NU_COU(NDCOTY)
C
      COMMON
     *       /BASISO/ NXVECT(1:NDBASE),NYVECT(1:NDBASE),NZVECT(1:NDBASE)
      COMMON
     *       /T_PHAS/ IPHAPP(0:NDYMAX,0:NDYMAX,0:NDKART),
     *                IPHAPM(0:NDYMAX,0:NDYMAX,0:NDKART),
     *                IPHAMP(0:NDYMAX,0:NDYMAX,0:NDKART),
     *                IPHAMM(0:NDYMAX,0:NDYMAX,0:NDKART)
      COMMON
     *       /COMPHA/ PHACOM(0:NDKART)
      COMMON
     *       /BINDEX/ INDICE(0:NDXMAX,0:NDYMAX,0:NDZMAX)
     *
     *       /BLIMS1/ LAXOFY(0:NDYMAX),LAXOFZ(0:NDZMAX),
     *                LAYOFZ(0:NDZMAX),LAYOFX(0:NDXMAX),
     *                LAZOFX(0:NDXMAX),LAZOFY(0:NDYMAX)
     *
     *       /BLIMS2/ LAXOYZ(0:NDYMAX,0:NDZMAX),
     *                LAYOZX(0:NDZMAX,0:NDXMAX),
     *                LAZOXY(0:NDXMAX,0:NDYMAX)
      COMMON
     *       /GAUSIN/ GAU_X0(0:NDXMAX,0:NDXMAX,0:NDXMAX,0:NDXMAX),
     *                GAU_Y0(0:NDYMAX,0:NDYMAX,0:NDYMAX,0:NDYMAX),
     *                GAU_Z0(0:NDZMAX,0:NDZMAX,0:NDZMAX,0:NDZMAX),
     *
     *                GAU_X1(0:NDXMAX,0:NDXMAX,0:NDXMAX,0:NDXMAX),
     *                GAU_Y1(0:NDYMAX,0:NDYMAX,0:NDYMAX,0:NDYMAX),
     *                GAU_Z1(0:NDZMAX,0:NDZMAX,0:NDZMAX,0:NDZMAX)
      COMMON
     *       /SCALNG/ HOMSCA(NDKART)
      COMMON
     *       /CHARGE/ ECHAR2
      COMMON
     *       /DIMENS/ LDBASE
C
C=======================================================================
C           HERE ARE THE FITS OF THE COULOMB POTENTIAL
C=======================================================================
C
      DATA
     *      (COUSTR(INYUKA,2),COULAR(INYUKA,2),INYUKA=1,2)
     *
     *    / 1.78   , 0.84   ,
     *      0.347  , 0.0135 /
      DATA
     *      NU_COU(2)/2/
C
      DATA
     *      (COUSTR(INYUKA,3),COULAR(INYUKA,3),INYUKA=1,3)
     *
     *    / 1.95   , 2.13   ,
     *      0.637  , 0.170  ,
     *      0.207  , 0.0063 /
      DATA
     *      NU_COU(3)/3/
C
      DATA
     *      (COUSTR(INYUKA,4),COULAR(INYUKA,4),INYUKA=1,4)
     *
     *    / 1.98   , 3.62   ,
     *      0.818  , 0.547  ,
     *      0.329  , 0.0688 ,
     *      0.156  , 0.00414/
      DATA
     *      NU_COU(4)/4/
C
      DATA
     *      (COUSTR(INYUKA,5),COULAR(INYUKA,5),INYUKA=1,5)
     *
     *    / 1.951  , 5.12   ,
     *      0.922  , 1.12   ,
     *      0.4423 , 0.227  ,
     *      0.213  , 0.0398 ,
     *      0.1304 , 0.00308/
      DATA
     *      NU_COU(5)/5/
C
      DATA
     *      (COUSTR(INYUKA,6),COULAR(INYUKA,6),INYUKA=1,6)
     *
     *    / 1.900  , 6.54    ,
     *      0.973  , 1.81    ,
     *      0.526  , 0.493   ,
     *      0.282  , 0.126   ,
     *      0.1592 , 0.0277  ,
     *      0.1147 , 0.00245 /
      DATA
     *      NU_COU(6)/6/
C
      DATA
     *      (COUSTR(INYUKA,7),COULAR(INYUKA,7),INYUKA=1,7)
     *
     *    / 1.842  , 7.8    ,
     *      0.991  , 2.56   ,
     *      0.580  , 0.850  ,
     *      0.341  , 0.274  ,
     *      0.2015 , 0.0833 ,
     *      0.1298 , 0.0213 ,
     *      0.1036 , 0.00204 /
      DATA
     *      NU_COU(7)/7/
C
C=======================================================================
C
      CALL CPUTIM('COUENE',1)
C
C=======================================================================
C
      IALLOC=0
C
C=======================================================================
      IF (.NOT.ALLOCATED(COULSV)) THEN
          ALLOCATE (COULSV(NDBASE,NDBASE,0:NDKART),STAT=IALLOC)
          IF (IALLOC.NE.0) CALL NOALLO('COULSV','COUENE')
      END IF
C=======================================================================
C
C=======================================================================
C        THIS SUBROUTINE CALCULATES BY EXPANDING INTO GAUSSIANS:
C        1) THE COULOMB  DIRECT  MEAN-FIELDS AND ENERGIES (FOR ICOUDI=2)
C        2) THE COULOMB EXCHANGE MEAN-FIELDS AND ENERGIES (FOR ICOUEX=2)
C=======================================================================
C
      PI=4.0D0*ATAN(1.0D0)
C
      C_ZERO=CMPLX(0.0D0,0.0D0)
C
      IF (ICOUDI.NE.2.AND.ICOUEX.NE.2)
     *    STOP 'COUENE CALLED WITH INCORECT VALUES OF ICOUDI/ICOUEX'
C
      IF (ICOTYP.EQ.0.OR.ICOTYP.EQ.-1.OR.ICOTYP.LT.-7.OR.
     *    -ICOTYP.GT.NDCOTY.OR.ICOTYP.GT.ND_COU)
     *    STOP 'COUENE CALLED WITH INCORECT VALUE OF ICOTYP'
C
C=======================================================================
C
      IF (ISEXAC.NE.1) THEN
          XOLDEV=0.0
      ELSE
          XOLDEV=SLOWEV
      END IF
C
      XNEWEV=1.0-XOLDEV
C
      IF (ISEXAC.NE.1) THEN
          COULSV(:,:,:)=C_ZERO
      ELSE
          COULSV(:,:,:)=COULSV(:,:,:)*XOLDEV
      END IF
C
C=======================================================================
C
      IF (ICOTYP.LT.0) THEN
          JCOTYP=-ICOTYP
      ELSE
C
C=======================================================================
C         HERE WE CALCULATE THE EXPANSION INTO GAUSSIANS BASED ON
C         FORMULA (A14) OF PRC 53-2809 AND NOTES 8-71
C=======================================================================
C
          JCOTYP=1
          NU_COU(1)=ICOTYP
C
          HOMLEN=MAX(1.0D0/HOMSCA(1),
     *               1.0D0/HOMSCA(2),
     *               1.0D0/HOMSCA(3))
C
          CALL GAULEG(0.0D0,1.0D0,XNODES,WEIGHT,NU_COU(1))
C
          DO INCOUL=1,NU_COU(1)
C
             COUSTR(INCOUL,1)=2.0D0/SQRT(PI)*WEIGHT(INCOUL)/HOMLEN
     *                       /(1.0D0-XNODES(INCOUL)**2)**1.5D0
             COULAR(INCOUL,1)=XNODES(INCOUL)**2/HOMLEN**2
     *                       /(1.0D0-XNODES(INCOUL)**2)
C
          END DO
C
      END IF
C
C=======================================================================
C         ATTENTION: UP TO THE VERSION 2.43D, THE COULOMB ENERGIES BELOW
C                    WERE UNCONDITIONALLY SET TO ZERO, WHICH RESULTED IN
C                    - THE  DIRECT  COULOMB ENERGY "EKECOD" BEING  EQUAL
C                      TO ZERO FOR ICOUDI=1 AND ICOUEX=2, AND
C                    - THE EXCHANGE COULOMB ENERGY "EKECOE" BEING  EQUAL
C                      TO ZERO FOR ICOUDI=2 AND ICOUEX=1.
C                    THIS BUG HAS BEEN CORRECTED  IN  VERSION  2.43E  ON
C                    30/10/09.
C=======================================================================
C
      IF (ICOUDI.EQ.2) EKECOD=C_ZERO
      IF (ICOUEX.EQ.2) EKESCA=C_ZERO
      IF (ICOUEX.EQ.2) EKEVEC=C_ZERO
C
C=======================================================================
C        HERE BEGINS THE LOOP OVER GAUSSIANS THAT APPROXIMATE THE
C        COULOMB POTENTIAL
C=======================================================================
C
      DO INCOUL=1,NU_COU(JCOTYP)
C
C=======================================================================
C         CALCULATING THE DIRECT TERM
C=======================================================================
C
         GOGWID=1.0D0/SQRT(COULAR(INCOUL,JCOTYP))
C
         CALL DEFGOG(NXMAXX,NDXMAX,NXHERM,1,GOGWID,GAU_X0,GAU_X1)
         CALL DEFGOG(NYMAXX,NDYMAX,NYHERM,2,GOGWID,GAU_Y0,GAU_Y1)
         CALL DEFGOG(NZMAXX,NDZMAX,NZHERM,3,GOGWID,GAU_Z0,GAU_Z1)
C
         IF (ICOUDI.EQ.2) THEN
C
             I_PART=2
             IDENSI=0
C
             CALL GAUOPT(NXMAXX,NYMAXX,ISIMPY,ICOUDI,I_PART,IDENSI)
C
C=======================================================================
C             CALCULATING THE AVERAGE VALUES OF THE DIRECT TERM
C=======================================================================
C
             EKECOD=EKECOD+COUSTR(INCOUL,JCOTYP)
     *                    *GAUAVR(0,0,0,1,1)*ECHAR2/2
C
C=======================================================================
C             CALCULATING THE MEAN FIELDS OF THE DIRECT TERM
C=======================================================================
C
             DO IKET=1,LDBASE
                DO IBRA=1,LDBASE
C
                   COULSV(IBRA,IKET,0)=COULSV(IBRA,IKET,0)
     *                                +XNEWEV*COUSTR(INCOUL,JCOTYP)
     *                                *GAUFIL(0,IBRA,IKET,0,1)*ECHAR2
C
                END DO
             END DO
C
             ISEXAC=1
C
         END IF
C
C=======================================================================
C        CALCULATING THE EXCHANGE TERM
C=======================================================================
C
         CALL EXCGOG(NXMAXX,NDXMAX,GAU_X0,GAU_X1)
         CALL EXCGOG(NYMAXX,NDYMAX,GAU_Y0,GAU_Y1)
         CALL EXCGOG(NZMAXX,NDZMAX,GAU_Z0,GAU_Z1)
C
         IF (ICOUEX.EQ.2) THEN
C
             I_PART=1
             IDENSI=0
C
             CALL GAUOPT(NXMAXX,NYMAXX,ISIMPY,ICOUEX,I_PART,IDENSI)
C
C=======================================================================
C        ATTENTION: ADDITIONAL FACTORS OF 1/2 BELOW RESULT FROM  THE
C                   CONVENTIONS USED  FOR  SPIN  AVERAGING,  NAMELY:
C                       1. THE SCALAR PART OF THE DENSITY MATRIX  IS
C                          DEFINED AS A SUM OF SPIN-UP AND SPIN-DOWN
C                          COMPONENTS, I.E., AS  A  TRACE  WITH  THE
C                          IDENTITY SPIN  MATRIX,  SEE  PRC69-014316
C                          EQ. (15A)
C                       2. THE VECTOR PART OF THE DENSITY MATRIX  IS
C                          DEFINED AS A TRACE WITH  THE  PAULI  SPIN
C                          MATRIX, SEE PRC69-014316 EQ. (15A)
C                       3. THE SCALAR PART  OF  THE  MEAN  FIELD  IS
C                          DEFINED AS A COEFFICIENT OF THE  IDENTITY
C                          SPIN MATRIX, SEE PRC69-014316 EQ. (84B)
C                       4. THE VECTOR PART  OF  THE  MEAN  FIELD  IS
C                          DEFINED AS A  COEFFICIENT  OF  THE  PAULI
C                          SPIN MATRIX, SEE PRC69-014316 EQ. (84A)
C                   AS A RESULT OF THESE DEFINITIONS WE HAVE:
C                      1. THE SCALAR PART OF THE DIRECT  MEAN  FIELD
C                         ABOVE IS THE SPACE SUM OF THE SCALAR  PART
C                         OF THE DENSITY MATRIX
C                      2. THE SCALAR PART OF THE EXCHANGE MEAN FIELD
C                         IS EQUAL TO  O N E   H A L F  OF THE SPACE
C                         SUM OF THE  SCALAR  PART  OF  THE  DENSITY
C                         MATRIX
C                      3. THE VECTOR PART OF THE EXCHANGE MEAN FIELD
C                         IS EQUAL TO  O N E   H A L F  OF THE SPACE
C                         SUM OF THE  VECTOR  PART  OF  THE  DENSITY
C                         MATRIX
C                   SEE DETAILS IN NOTES 8-71
C=======================================================================
C        CALCULATING THE AVERAGE VALUES OF THE EXCHANGE TERM
C=======================================================================
C
             EKESCA=EKESCA-COUSTR(INCOUL,JCOTYP)*ECHAR2/2/2
     *                    * GAUAVR(0,0,0,1,1)
C
             EKEVEC=EKEVEC-COUSTR(INCOUL,JCOTYP)*ECHAR2/2/2
     *                    *(GAUAVR(0,1,1,1,1)
     *                     +GAUAVR(0,2,2,1,1)
     *                     +GAUAVR(0,3,3,1,1))
C
C=======================================================================
C        CALCULATING THE MEAN FIELDS OF THE EXCHANGE TERM
C=======================================================================
C
             DO KARTEZ=0,NDKART
                DO IKET=1,LDBASE
                   DO IBRA=1,LDBASE
C
                      COULSV(IBRA,IKET,KARTEZ)=
     *                COULSV(IBRA,IKET,KARTEZ)
     *                                -XNEWEV*COUSTR(INCOUL,JCOTYP)
     *                                *GAUFIL(0,IBRA,IKET,KARTEZ,1)
     *                                *ECHAR2/2
C
                   END DO
                END DO
             END DO
C
             ISEXAC=1
C
         END IF
C
      END DO
C
C=======================================================================
C
      CALL CPUTIM('COUENE',0)
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE YUKENE(NXHERM,NYHERM,NZHERM,NXMAXX,NYMAXX,NZMAXX,
     *                                PIMASS,PNMASS,IYUTYP,I_YUKA,
     *                                YUKAGT,YUKAG0,YUKAG1,YUKAG2,
     *                                                     ISIMPY)
C=======================================================================
      USE GAUSTO
      USE YUKSTO
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      COMPLEX
     *          EYUK_D,EYUK_E
      COMPLEX
     *          C_ZERO,UNIT_I
C=======================================================================
C
      DIMENSION
     *          GOGSTR(NDYUKA,NDYUTY),GOGLAR(NDYUKA,NDYUTY)
      DIMENSION
     *          YUKAAT(0:NDISOS)
      DIMENSION
     *          NUYUKA(NDYUTY)
C
      COMMON
     *       /T_PHAS/ IPHAPP(0:NDYMAX,0:NDYMAX,0:NDKART),
     *                IPHAPM(0:NDYMAX,0:NDYMAX,0:NDKART),
     *                IPHAMP(0:NDYMAX,0:NDYMAX,0:NDKART),
     *                IPHAMM(0:NDYMAX,0:NDYMAX,0:NDKART)
      COMMON
     *       /BINDEX/ INDICE(0:NDXMAX,0:NDYMAX,0:NDZMAX)
     *
     *       /BLIMS1/ LAXOFY(0:NDYMAX),LAXOFZ(0:NDZMAX),
     *                LAYOFZ(0:NDZMAX),LAYOFX(0:NDXMAX),
     *                LAZOFX(0:NDXMAX),LAZOFY(0:NDYMAX)
     *
     *       /BLIMS2/ LAXOYZ(0:NDYMAX,0:NDZMAX),
     *                LAYOZX(0:NDZMAX,0:NDXMAX),
     *                LAZOXY(0:NDXMAX,0:NDYMAX)
      COMMON
     *       /GAUSIN/ GAU_X0(0:NDXMAX,0:NDXMAX,0:NDXMAX,0:NDXMAX),
     *                GAU_Y0(0:NDYMAX,0:NDYMAX,0:NDYMAX,0:NDYMAX),
     *                GAU_Z0(0:NDZMAX,0:NDZMAX,0:NDZMAX,0:NDZMAX),
     *
     *                GAU_X1(0:NDXMAX,0:NDXMAX,0:NDXMAX,0:NDXMAX),
     *                GAU_Y1(0:NDYMAX,0:NDYMAX,0:NDYMAX,0:NDYMAX),
     *                GAU_Z1(0:NDZMAX,0:NDZMAX,0:NDZMAX,0:NDZMAX)
      COMMON
     *       /EN_YUK/ EYUK_D(0:NDISOS,0:NDISOS),
     *                EYUK_E(0:NDISOS,0:NDISOS)
      COMMON
     *       /EYUKTT/ EYUKDT,EYUKD0,EYUKD1,EYUKD2,
     *                EYUKET,EYUKE0,EYUKE1,EYUKE2
      COMMON
     *       /PHYCON/ H_BARC,XMASSP,XMASSN,HBCOE2
      COMMON
     *       /DIMENS/ LDBASE
C
C=======================================================================
C
      CALL CPUTIM('YUKENE',1)
C
C=======================================================================
C           HERE IS THE FIT OF THE SRC FUNCTION TIMES THE GRADIENT
C           OF YUKAWA
C=======================================================================
C
      DATA
     *      (GOGSTR(INYUKA,1),GOGLAR(INYUKA,1),INYUKA=1,NDYUKA)
     *
     *    / 1.7500D0, 1.100D0,
     *      0.5300D0, 0.680D0,
     *      0.1100D0, 0.210D0,
     *      0.0040D0, 0.060D0,
     *      0.0000D0, 0.000D0,
     *      0.0000D0, 0.000D0 /
      DATA
     *      NUYUKA(1)/4/
C
C=======================================================================
C           HERE IS THE NEW FIT OF YUKAWA  WITH  THE  NORMALIZATION
C           OF 1.00008. THE LAST LINE CORRECTS THE LAST COEFFICIENT
C           SO AS TO MAKE THE NORMALIZATION EQUAL TO 1.
C=======================================================================
C
      DATA
     *      (GOGSTR(INYUKA,2),GOGLAR(INYUKA,2),INYUKA=1,NDYUKA)
     *
     *    / 6.7900D0,34.000D0,
     *      2.4100D0, 6.600D0,
     *      0.7860D0, 1.440D0,
     *      0.2410D0, 0.380D0,
     *     -0.0620D0, 0.150D0,
     *      0.77991050814653D-01, 0.130D0 /
      DATA
     *      NUYUKA(2)/6/
C
C           HERE IS THE OLD FIT OF YUKAWA WITH THE
C           NORMALIZATION OF 0.997
C
C    *    / 6.7900D0,34.000D0,
C    *      2.4000D0, 6.600D0,
C    *      0.7920D0, 1.440D0,
C    *      0.0778D0, 0.130D0,
C    *      0.2400D0, 0.380D0,
C    *     -0.0620D0, 0.150D0 /
C
C=======================================================================
C
      IALLOC=0
C
C=======================================================================
      IF (.NOT.ALLOCATED(YUKASV).AND.I_YUKA.GE.2) THEN
          ALLOCATE (YUKASV(NDBASE,NDBASE,0:NDKART,0:NDISOS),STAT=IALLOC)
          IF (IALLOC.NE.0) CALL NOALLO('YUKASV','YUKENE')
      END IF
C=======================================================================
C
C=======================================================================
C        THIS SUBROUTINE CALCULATES:
C        1) THE AVERAGE VALUES OF THE FINITE-RANGE YUKAWA INTERACTION
C                                                         (FOR I_YUKA>0)
C        2) THE CORRESPONDING  DIRECT   MEAN FIELDS
C                                            (FOR I_YUKA=2 OR  I_YUKA=3)
C        3) THE CORRESPONDING EXCHANAGE MEAN FIELDS
C                                            (FOR I_YUKA=2 OR  I_YUKA=4)
C=======================================================================
C
      IF (ISIMPY.EQ.1.AND.I_YUKA.GE.1)
     *    STOP 'THE RESULT IS ZERO - NOT PROGRAMMED YET'
C
      C_ZERO=CMPLX(0.0D0,0.0D0)
      UNIT_I=CMPLX(0.0D0,1.0D0)
C
      PI=4.0D0*ATAN(1.0D0)
C
      I_PART=0
      IDENSI=0
C
C=======================================================================
C        HERE IS JON'S TEST SUGGESTED IN THE E-MAIL OF 2005.02.07 21:04
C=======================================================================
C
C     DO INYUKA=1,NDYUKA
C
C        b'(i) = b(i)*(.7045)^2 and a'(i) = a(i)*b(i)*2*(.7045)^2.
C
C        GOGSTR(INYUKA)=GOGSTR(INYUKA)*GOGLAR(INYUKA)*2*PIMASS**2
C        GOGLAR(INYUKA)=GOGLAR(INYUKA)*PIMASS**2
C
C     END DO
C
C=======================================================================
C        MODIFYING THE STRENGTH OF THE LAST GAUSSIAN SO AS TO  NORMALIZE
C        THE APPROXIMATION OF THE YUKAWA POTENTIAL TO 1
C=======================================================================
C
      IRENOR=0
      IF (IRENOR.EQ.1) THEN
C
          RESULT=0
C
          DO INYUKA=1,NDYUKA
C
             RESULT=RESULT+GOGSTR(INYUKA,IYUTYP)
     *                    /GOGLAR(INYUKA,IYUTYP)**1.5D0
C
          END DO
C
          RESULT=1-RESULT*SQRT(PI)/4
C
          GOGSTR(NDYUKA,IYUTYP)=GOGSTR(NDYUKA,IYUTYP)
     *                  +RESULT*GOGLAR(NDYUKA,IYUTYP)**1.5D0*4/SQRT(PI)
C
          PRINT '('' NORM='',D22.14,'' DEVIATION='',D22.14,
     *            '' NEW COEFF='',D22.14)',
     *            1-RESULT,RESULT,GOGSTR(NDYUKA,IYUTYP)
C
C=======================================================================
C        CHECKING THE MODIFIED NORMALIZATION
C=======================================================================
C
          RESULT=0
C
          DO INYUKA=1,NDYUKA
C
             RESULT=RESULT+GOGSTR(INYUKA,IYUTYP)
     *                    /GOGLAR(INYUKA,IYUTYP)**1.5D0
C
          END DO
C
          RESULT=1-RESULT*SQRT(PI)/4
C
          GOGSTR(NDYUKA,IYUTYP)=GOGSTR(NDYUKA,IYUTYP)
     *                  +RESULT*GOGLAR(NDYUKA,IYUTYP)**1.5D0*4/SQRT(PI)
C
          PRINT '('' NORM='',D22.14,'' DEVIATION='',D22.14,
     *            '' NEW COEFF='',D22.14)',
     *            1-RESULT,RESULT,GOGSTR(NDYUKA,IYUTYP)
C
      END IF
C
C=======================================================================
C        DEFINING THE OVERALL COUPLING CONSTANT
C=======================================================================
C
      CTILDE=YUKAGT*H_BARC/2/PIMASS**2/PNMASS
C
C=======================================================================
C        ZEROING THE ARRAYS THAT WILL COLLECT THE COTRIBUTIONS COMING
C        FROM INDIVIDUAL GAUSSIANS
C=======================================================================
C
      DO ICHARG=0,NDISOS
         DO JCHARG=0,NDISOS
C
            EYUK_D(ICHARG,JCHARG)=C_ZERO
            EYUK_E(ICHARG,JCHARG)=C_ZERO
C
         END DO
      END DO
C
C=======================================================================
C        ZEROING ARRAYS OF AVERAGE FIELDS
C=======================================================================
C
      IF (I_YUKA.GE.2) THEN
          YUKASV(:,:,:,:)=C_ZERO
      END IF
C
C=======================================================================
C        HERE BEGINS THE LOOP OVER GAUSSIANS THAT APPROXIMATE THE YUKAWA
C        POTENTIAL
C=======================================================================
C
      DO INYUKA=1,NUYUKA(IYUTYP)
C
C=======================================================================
C        CALCULATING THE DIRECT TERM
C=======================================================================
C
         IF (IYUTYP.EQ.1)GOGWID=1.0D0/SQRT(GOGLAR(INYUKA,IYUTYP))
         IF (IYUTYP.EQ.2)GOGWID=1.0D0/SQRT(GOGLAR(INYUKA,IYUTYP))/PIMASS
C
         CALL DEFGOG(NXMAXX,NDXMAX,NXHERM,1,GOGWID,GAU_X0,GAU_X1)
         CALL DEFGOG(NYMAXX,NDYMAX,NYHERM,2,GOGWID,GAU_Y0,GAU_Y1)
         CALL DEFGOG(NZMAXX,NDZMAX,NZHERM,3,GOGWID,GAU_Z0,GAU_Z1)
C
         CALL GAUOPT(NXMAXX,NYMAXX,ISIMPY,I_YUKA,I_PART,IDENSI)
C
C=======================================================================
C        CALCULATING THE AVERAGE VALUES OF THE DIRECT TERM
C=======================================================================
C
         KARTE0=0
C
         DO ICHARG=0,NDISOS
            DO JCHARG=0,NDISOS
C
               DO KARTEZ=1,NDKART
C
C=======================================================================
C              THE FACTORS THAT ARE BELOW ARE AS FOLLOWS:
C
C              FACTOR OF 2 COMES FROM REMOVING THE FACTOR 1/2,  WHICH IS
C                        ABSENT IN THE ZERO-RANGE EXPRESSION IN TERMS OF
C                        RHO*(DIV S) OR J*S
C              FACTOR OF (-2)*PIMASS**5/(4*PI) COMES FROM THE  CONDITION
C                        THAT NORMALIZES THE  GRADIENT  OF  THE  SUM  OF
C                        GAUSSIANS TO THE GRADIENT OF THE DELTA FUNCTION
C              FACTOR OF 1/2 COMES FROM THE EXPRESSION FOR THE  HARTREE-
C                        FOCK ENERGY IN TERMS OF  THE  DENSITY  MATRICES
C
C=======================================================================
C
                  IF (IYUTYP.EQ.1)
     *            EYUK_D(ICHARG,JCHARG)=
     *            EYUK_D(ICHARG,JCHARG)+GOGSTR(INYUKA,IYUTYP)
     *                       *2*(-1)*PIMASS**3/(4*PI)/2
     *                       *GAUAVR(KARTEZ,KARTEZ,KARTE0,ICHARG,JCHARG)
C
                  IF (IYUTYP.EQ.2)
     *            EYUK_D(ICHARG,JCHARG)=
     *            EYUK_D(ICHARG,JCHARG)+GOGLAR(INYUKA,IYUTYP)
     *                                 *GOGSTR(INYUKA,IYUTYP)
     *                       *2*(-2)*PIMASS**5/(4*PI)/2
     *                       *GAUAVR(KARTEZ,KARTEZ,KARTE0,ICHARG,JCHARG)
C
               END DO
            END DO
         END DO
C
C=======================================================================
C        CALCULATING THE MEAN FIELDS OF THE DIRECT TERM
C=======================================================================
C
         FACTOR = (-1)*PIMASS**3/(4*PI)*CTILDE
C
         YUKAAT(0) = FACTOR * (YUKAG0-YUKAG1+2*YUKAG2)
         YUKAAT(1) = FACTOR * (YUKAG0+YUKAG1+2*YUKAG2)
         YUKAAE    = FACTOR * 2.0D0 * (YUKAG0-YUKAG2)
C
         KARTE0=0
C
         IF (I_YUKA.EQ.2.OR.I_YUKA.EQ.3) THEN
C
             DO ICHARG=0,NDISOS
                DO IKET=1,LDBASE
                   DO IBRA=1,LDBASE
                      DO KARTEZ=1,NDKART
C
                         IF (IYUTYP.EQ.1) THEN
C
                                YUKASV(IBRA,IKET,KARTE0,  ICHARG)=
     *                          YUKASV(IBRA,IKET,KARTE0,  ICHARG)+
     *
     *                    GOGSTR(INYUKA,IYUTYP)*(YUKAAT(  ICHARG)*
     *                   GAUFIL(KARTEZ,IBRA,IKET,KARTEZ,1-ICHARG)-
     *                                           YUKAAT(  ICHARG)*
     *                   GAUFIL(KARTEZ,IBRA,IKET,KARTEZ,  ICHARG))
C
                                YUKASV(IBRA,IKET,KARTEZ,  ICHARG)=
     *                          YUKASV(IBRA,IKET,KARTEZ,  ICHARG)+
     *
     *                    GOGSTR(INYUKA,IYUTYP)*(YUKAAT(  ICHARG)*
     *                   GAUFIL(KARTEZ,IBRA,IKET,KARTE0,  ICHARG)-
     *                                           YUKAAT(1-ICHARG)*
     *                   GAUFIL(KARTEZ,IBRA,IKET,KARTE0,1-ICHARG))
C
                         END IF
C
                         IF (IYUTYP.EQ.2) THEN
C
                                YUKASV(IBRA,IKET,KARTE0,  ICHARG)=
     *                          YUKASV(IBRA,IKET,KARTE0,  ICHARG)+
     *
     *                        GOGLAR(INYUKA,IYUTYP)*2.0*PIMASS**2*
     *                    GOGSTR(INYUKA,IYUTYP)*(YUKAAT(  ICHARG)*
     *                   GAUFIL(KARTEZ,IBRA,IKET,KARTEZ,1-ICHARG)-
     *                                           YUKAAT(  ICHARG)*
     *                   GAUFIL(KARTEZ,IBRA,IKET,KARTEZ,  ICHARG))
C
                                YUKASV(IBRA,IKET,KARTEZ,  ICHARG)=
     *                          YUKASV(IBRA,IKET,KARTEZ,  ICHARG)+
     *
     *                        GOGLAR(INYUKA,IYUTYP)*2.0*PIMASS**2*
     *                    GOGSTR(INYUKA,IYUTYP)*(YUKAAT(  ICHARG)*
     *                   GAUFIL(KARTEZ,IBRA,IKET,KARTE0,  ICHARG)-
     *                                           YUKAAT(1-ICHARG)*
     *                   GAUFIL(KARTEZ,IBRA,IKET,KARTE0,1-ICHARG))
C
                         END IF
C
                      END DO
                   END DO
C
                END DO
             END DO
C
         END IF
C
C=======================================================================
C        CALCULATING THE EXCHANGE TERM
C=======================================================================
C
         CALL EXCGOG(NXMAXX,NDXMAX,GAU_X0,GAU_X1)
         CALL EXCGOG(NYMAXX,NDYMAX,GAU_Y0,GAU_Y1)
         CALL EXCGOG(NZMAXX,NDZMAX,GAU_Z0,GAU_Z1)
C
         CALL GAUOPT(NXMAXX,NYMAXX,ISIMPY,I_YUKA,I_PART,IDENSI)
C
C=======================================================================
C        CALCULATING THE AVERAGE VALUES OF THE EXCHANGE TERM
C=======================================================================
C
         DO ICHARG=0,NDISOS
            DO JCHARG=0,NDISOS
C
               DO KARTEZ=1,NDKART
C
                  KARTEP=KARTEZ+1
                  IF (KARTEP.GT.NDKART) KARTEP=KARTEP-NDKART
C
                  KARTEM=KARTEZ+2
                  IF (KARTEM.GT.NDKART) KARTEM=KARTEM-NDKART
C
C=======================================================================
C              THE FACTORS THAT ARE BELOW ARE AS FOLLOWS:
C
C              FACTOR OF (-1) COMES FROM CALCULATING THE IMAGINARY PART
C                        OF THE RESULT MULTIPLIED BY THE COMPLEX UNIT
C              FACTOR OF 2 COMES FROM REMOVING THE FACTOR 1/2,  WHICH IS
C                        ABSENT IN THE ZERO-RANGE EXPRESSION IN TERMS OF
C                        RHO*(DIV S) OR J*S
C              FACTOR OF (-2)*PIMASS**5/(4*PI) COMES FROM THE  CONDITION
C                        THAT NORMALIZES THE  GRADIENT  OF  THE  SUM  OF
C                        GAUSSIANS TO THE GRADIENT OF THE DELTA FUNCTION
C              FACTOR OF 1/2 COMES FROM THE EXPRESSION FOR THE  HARTREE-
C                        FOCK ENERGY IN TERMS OF  THE  DENSITY  MATRICES
C
C=======================================================================
C
                  IF (IYUTYP.EQ.1)
     *            EYUK_E(ICHARG,JCHARG)=
     *            EYUK_E(ICHARG,JCHARG)+GOGSTR(INYUKA,IYUTYP)
     *                     *(-1)*2*(-1)*PIMASS**3/(4*PI)/2
     *                     *(GAUAVR(KARTEZ,KARTEP,KARTEM,ICHARG,JCHARG)
     *                      -GAUAVR(KARTEZ,KARTEM,KARTEP,ICHARG,JCHARG))
C
                  IF (IYUTYP.EQ.2)
     *            EYUK_E(ICHARG,JCHARG)=
     *            EYUK_E(ICHARG,JCHARG)+GOGLAR(INYUKA,IYUTYP)
     *                                 *GOGSTR(INYUKA,IYUTYP)
     *                     *(-1)*2*(-2)*PIMASS**5/(4*PI)/2
     *                     *(GAUAVR(KARTEZ,KARTEP,KARTEM,ICHARG,JCHARG)
     *                      -GAUAVR(KARTEZ,KARTEM,KARTEP,ICHARG,JCHARG))
C
               END DO
            END DO
         END DO
C
C=======================================================================
C        CALCULATING THE MEAN FIELDS OF THE EXCHANGE TERM
C=======================================================================
C
         IF (I_YUKA.EQ.2.OR.I_YUKA.EQ.4) THEN
C
             DO ICHARG=0,NDISOS
                DO KARTEZ=1,NDKART
                   DO IKET=1,LDBASE
                      DO IBRA=1,LDBASE
C
                         KARTEP=KARTEZ+1
                         IF (KARTEP.GT.NDKART) KARTEP=KARTEP-NDKART
C
                         KARTEM=KARTEZ+2
                         IF (KARTEM.GT.NDKART) KARTEM=KARTEM-NDKART
C
                         IF (IYUTYP.EQ.1) THEN
C
                                YUKASV(IBRA,IKET,KARTEZ,  ICHARG)=
     *                          YUKASV(IBRA,IKET,KARTEZ,  ICHARG)+
     *
     *                    GOGSTR(INYUKA,IYUTYP)*(YUKAAT(  ICHARG)*
     *                  (GAUFIL(KARTEM,IBRA,IKET,KARTEP,  ICHARG)
     *                  -GAUFIL(KARTEP,IBRA,IKET,KARTEM,  ICHARG))
     *                                          +YUKAAE          *
     *                  (GAUFIL(KARTEM,IBRA,IKET,KARTEP,1-ICHARG)
     *                  -GAUFIL(KARTEP,IBRA,IKET,KARTEM,1-ICHARG)))
     *                  *UNIT_I
C
                         END IF
C
                         IF (IYUTYP.EQ.2) THEN
C
                                YUKASV(IBRA,IKET,KARTEZ,  ICHARG)=
     *                          YUKASV(IBRA,IKET,KARTEZ,  ICHARG)+
     *
     *                        GOGLAR(INYUKA,IYUTYP)*2.0*PIMASS**2*
     *                    GOGSTR(INYUKA,IYUTYP)*(YUKAAT(  ICHARG)*
     *                  (GAUFIL(KARTEM,IBRA,IKET,KARTEP,  ICHARG)
     *                  -GAUFIL(KARTEP,IBRA,IKET,KARTEM,  ICHARG))
     *                                          +YUKAAE          *
     *                  (GAUFIL(KARTEM,IBRA,IKET,KARTEP,1-ICHARG)
     *                  -GAUFIL(KARTEP,IBRA,IKET,KARTEM,1-ICHARG)))
     *                  *UNIT_I
C
                         END IF
C
                      END DO
                   END DO
C
                END DO
             END DO
C
         END IF
C
      END DO
C
C=======================================================================
C        CALCULATING THE TOTAL DIRECT ENERGIES
C=======================================================================
C
      EYUKD0=CTILDE*   REAL(+EYUK_D(1,1)  +EYUK_D(0,0)
     *                      -EYUK_D(1,0)  -EYUK_D(0,1)  )
      EYUKD1=CTILDE*   REAL(+EYUK_D(1,1)  -EYUK_D(0,0)
     *                      +EYUK_D(1,0)  -EYUK_D(0,1)  )
      EYUKD2=CTILDE*2* REAL(+EYUK_D(1,1)  +EYUK_D(0,0)
     *                      -EYUK_D(1,0)  -EYUK_D(0,1)  )
C
      EYUKDT=YUKAG0*EYUKD0+YUKAG1*EYUKD1+YUKAG2*EYUKD2
C
C=======================================================================
C        CALCULATING THE TOTAL EXCHANGE ENERGIES
C=======================================================================
C
      EYUKE0=CTILDE*  AIMAG(+EYUK_E(1,1)  +EYUK_E(0,0)
     *                      +EYUK_E(1,0)*2+EYUK_E(0,1)*2)/2
      EYUKE1=CTILDE*  AIMAG(+EYUK_E(1,1)  -EYUK_E(0,0)
     *                                                  )/2
      EYUKE2=CTILDE*2*AIMAG(+EYUK_E(1,1)  +EYUK_E(0,0)
     *                      -EYUK_E(1,0)  -EYUK_E(0,1)  )/2
C
      EYUKET=YUKAG0*EYUKE0+YUKAG1*EYUKE1+YUKAG2*EYUKE2
C
C=======================================================================
C
      CALL CPUTIM('YUKENE',0)
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE PNCHAN(DUMSTR,DUM_SD,DUM_VD,DUM_SE,DUM_VE,
     *                         NDDUMA,NUDUMA,IPAHFB,GOGNAM)
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      CHARACTER
     *          GOGNAM*4
      DIMENSION
     *          DUM_SD(NDDUMA,0:NDISOS,0:NDISOS),
     *          DUM_VD(NDDUMA,0:NDISOS,0:NDISOS),
     *          DUM_SE(NDDUMA,0:NDISOS,0:NDISOS),
     *          DUM_VE(NDDUMA,0:NDISOS,0:NDISOS)
      DIMENSION
     *          DUMSTR(NDDUMA,NDFORC)
C
C=======================================================================
C           THIS SUBROUTINE CALCULATES THE NN, NP, PP, AND PN STRENGTHS
C           DERIVED IN THE NOTES 77-B
C=======================================================================
C
      DUM_SD=0.0D0
      DUM_VD=0.0D0
      DUM_SE=0.0D0
      DUM_VE=0.0D0
C
      IF (IPAHFB.EQ.0) THEN
C
          DO INDUMA=1,NUDUMA
C
             DUM_SD(INDUMA,0,0)=DUMSTR(INDUMA,1)
     *                         +DUMSTR(INDUMA,2)/2
     *                         -DUMSTR(INDUMA,3)
     *                         -DUMSTR(INDUMA,4)/2
             DUM_SD(INDUMA,0,1)=(DUMSTR(INDUMA,1)
     *                          +DUMSTR(INDUMA,2)/2)
C
             DUM_SD(INDUMA,1,1)=DUM_SD(INDUMA,0,0)
             DUM_SD(INDUMA,1,0)=DUM_SD(INDUMA,0,1)
C
             DUM_VD(INDUMA,0,0)=DUMSTR(INDUMA,2)/2
     *                         -DUMSTR(INDUMA,4)/2
             DUM_VD(INDUMA,0,1)=DUMSTR(INDUMA,2)/2
C
             DUM_VD(INDUMA,1,1)=DUM_VD(INDUMA,0,0)
             DUM_VD(INDUMA,1,0)=DUM_VD(INDUMA,0,1)
C
             DUM_SE(INDUMA,0,0)=DUMSTR(INDUMA,4)
     *                         +DUMSTR(INDUMA,3)/2
     *                         -DUMSTR(INDUMA,2)
     *                         -DUMSTR(INDUMA,1)/2
             DUM_SE(INDUMA,0,1)=(DUMSTR(INDUMA,4)
     *                          +DUMSTR(INDUMA,3)/2)
C
             DUM_SE(INDUMA,1,1)=DUM_SE(INDUMA,0,0)
             DUM_SE(INDUMA,1,0)=DUM_SE(INDUMA,0,1)
C
             DUM_VE(INDUMA,0,0)=DUMSTR(INDUMA,3)/2
     *                         -DUMSTR(INDUMA,1)/2
             DUM_VE(INDUMA,0,1)=DUMSTR(INDUMA,3)/2
C
             DUM_VE(INDUMA,1,1)=DUM_VE(INDUMA,0,0)
             DUM_VE(INDUMA,1,0)=DUM_VE(INDUMA,0,1)
C
          END DO
C
      ELSE
C
          DO INDUMA=1,NUDUMA
C
             DUM_SD(INDUMA,0,0)=DUMSTR(INDUMA,1)
     *                         +DUMSTR(INDUMA,2)/2
     *                         -DUMSTR(INDUMA,3)
     *                         -DUMSTR(INDUMA,4)/2
             DUM_SD(INDUMA,0,1)=0.0D0
C
             DUM_SD(INDUMA,1,1)=DUM_SD(INDUMA,0,0)
             DUM_SD(INDUMA,1,0)=DUM_SD(INDUMA,0,1)
C
             DUM_VD(INDUMA,0,0)=DUMSTR(INDUMA,2)/2
     *                         -DUMSTR(INDUMA,4)/2
             DUM_VD(INDUMA,0,1)=0.0D0
C
             DUM_VD(INDUMA,1,1)=DUM_VD(INDUMA,0,0)
             DUM_VD(INDUMA,1,0)=DUM_VD(INDUMA,0,1)
C
             DUM_SE(INDUMA,0,0)=0.0D0
             DUM_SE(INDUMA,0,1)=0.0D0
C
             DUM_SE(INDUMA,1,1)=DUM_SE(INDUMA,0,0)
             DUM_SE(INDUMA,1,0)=DUM_SE(INDUMA,0,1)
C
             DUM_VE(INDUMA,0,0)=0.0D0
             DUM_VE(INDUMA,0,1)=0.0D0
C
             DUM_VE(INDUMA,1,1)=DUM_VE(INDUMA,0,0)
             DUM_VE(INDUMA,1,0)=DUM_VE(INDUMA,0,1)
C
          END DO
C
      END IF
C
C      Minnesota Interaction
C
      IF (GOGNAM.EQ.'MINN') THEN
      	  CALL MINNES(DUM_SD,DUM_VD,DUM_SE,DUM_VE,NDDUMA,NUDUMA)
      END IF
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE MINNES(DUM_SD,DUM_VD,DUM_SE,DUM_VE,NDDUMA,NUDUMA)
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      DIMENSION
     *          DUM_SD(NDDUMA,0:NDISOS,0:NDISOS),
     *          DUM_VD(NDDUMA,0:NDISOS,0:NDISOS),
     *          DUM_SE(NDDUMA,0:NDISOS,0:NDISOS),
     *          DUM_VE(NDDUMA,0:NDISOS,0:NDISOS)
C
C=======================================================================
C           THIS SUBROUTINE CALCULATES THE NN, NP, PP, AND PN STRENGTHS
C           DERIVED IN THE NOTES 77-B
C=======================================================================
C
      DUM_SD(1:NDDUMA,0:NDISOS,0:NDISOS)=0.0D0
      DUM_VD(1:NDDUMA,0:NDISOS,0:NDISOS)=0.0D0
      DUM_SE(1:NDDUMA,0:NDISOS,0:NDISOS)=0.0D0
      DUM_VE(1:NDDUMA,0:NDISOS,0:NDISOS)=0.0D0
C
      DUM_SD(1,0,0)=+50.0D0
      DUM_VD(1,0,0)=-50.0D0
      DUM_SE(1,0,0)=+50.0D0
      DUM_VE(1,0,0)=-50.0D0
C
      DUM_SD(2,0,0)=-22.9625D0
      DUM_VD(2,0,0)=+22.9625D0
      DUM_SE(2,0,0)=-22.9625D0
      DUM_VE(2,0,0)=+22.9625D0
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE GOGENE(NXHERM,NYHERM,NZHERM,NXMAXX,NYMAXX,NZMAXX,
     *                         SLOWEV,ISGOGA,I_GOGA,ISIMPY,GOGNAM)
C=======================================================================
      USE GAUSTO
      USE GOGSTO
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      CHARACTER
     *          GOGNAM*4
      COMPLEX
     *          EGOGSD,EGOGSE,EGOGVD,EGOGVE,
     *          EGOTSD,EGOTSE,EGOTVD,EGOTVE,
     *          EGOSSD,EGOSSE,EGOSVD,EGOSVE,
     *          EGOPSD,EGOPSE,EGOPVD,EGOPVE,
     *          EGOMSD,EGOMSE,EGOMVD,EGOMVE
      COMPLEX
     *          C_ZERO
C
      DIMENSION
     *          GOG_SD(NDGOGA,0:NDISOS,0:NDISOS),
     *          GOG_VD(NDGOGA,0:NDISOS,0:NDISOS),
     *          GOG_SE(NDGOGA,0:NDISOS,0:NDISOS),
     *          GOG_VE(NDGOGA,0:NDISOS,0:NDISOS)
C
      COMMON
     *       /GOGFOR/ GOGSTR(NDGOGA,NDFORC),GOGWID(NDGOGA),NUGOGA
      COMMON
     *       /GAUSIN/ GAU_X0(0:NDXMAX,0:NDXMAX,0:NDXMAX,0:NDXMAX),
     *                GAU_Y0(0:NDYMAX,0:NDYMAX,0:NDYMAX,0:NDYMAX),
     *                GAU_Z0(0:NDZMAX,0:NDZMAX,0:NDZMAX,0:NDZMAX),
     *
     *                GAU_X1(0:NDXMAX,0:NDXMAX,0:NDXMAX,0:NDXMAX),
     *                GAU_Y1(0:NDYMAX,0:NDYMAX,0:NDYMAX,0:NDYMAX),
     *                GAU_Z1(0:NDZMAX,0:NDZMAX,0:NDZMAX,0:NDZMAX)
      COMMON
     *       /EN_GOG/ EGOGSD(0:NDISOS,0:NDISOS),
     *                EGOGSE(0:NDISOS,0:NDISOS),
     *                EGOGVD(0:NDISOS,0:NDISOS),
     *                EGOGVE(0:NDISOS,0:NDISOS)
     *
     *       /EN_GTS/ EGOTSD,EGOTSE,EGOTVD,EGOTVE,
     *                EGOSSD,EGOSSE,EGOSVD,EGOSVE
     *
     *       /EN_GPM/ EGOPSD,EGOPSE,EGOPVD,EGOPVE,
     *                EGOMSD,EGOMSE,EGOMVD,EGOMVE
      COMMON
     *       /EGOGTT/ EGOGDT,EGOGET
      COMMON
     *       /PHYCON/ H_BARC,XMASSP,XMASSN,HBCOE2
      COMMON
     *       /DIMENS/ LDBASE
C
C=======================================================================
C
      CALL CPUTIM('GOGENE',1)
C
C=======================================================================
C        THIS SUBROUTINE CALCULATES:
C        1) THE AVERAGE VALUES OF THE FINITE-RANGE GOGNY INTERACTION
C                                                         (FOR I_GOGA>0)
C        2) THE CORRESPONDING  DIRECT   MEAN FIELDS
C                                            (FOR I_GOGA=2 OR  I_GOGA=3)
C        3) THE CORRESPONDING EXCHANAGE MEAN FIELDS
C                                            (FOR I_GOGA=2 OR  I_GOGA=4)
C=======================================================================
C
C=======================================================================
C           HERE ARE THE NN, NP, PP, AND PN GOGNY STRENGTHS
C           DERIVED IN THE NOTES 77-B
C=======================================================================
C
      IPAHFB=0
C
      CALL PNCHAN(GOGSTR,GOG_SD,GOG_VD,GOG_SE,GOG_VE,NDGOGA,NUGOGA,
     *                                               IPAHFB,GOGNAM)
C
C=======================================================================
C
      IALLOC=0
C
C=======================================================================
      IF (.NOT.ALLOCATED(GOGASV).AND.I_GOGA.GE.2) THEN
          ALLOCATE (GOGASV(NDBASE,NDBASE,0:NDKART,0:NDISOS),STAT=IALLOC)
          IF (IALLOC.NE.0) CALL NOALLO('GOGASV','GOGENE')
      END IF
C=======================================================================
C
      C_ZERO=CMPLX(0.0D0,0.0D0)
C
      I_PART=3
C
C=======================================================================
C
      IF (ISGOGA.NE.1) THEN
          XOLDEV=0.0
      ELSE
          XOLDEV=SLOWEV
      END IF
C
      XNEWEV=1.0-XOLDEV
C
C=======================================================================
C        ZEROING THE ARRAYS THAT WILL COLLECT THE CONTRIBUTIONS COMING
C        FROM INDIVIDUAL GAUSSIANS
C=======================================================================
C
      EGOGSD(:,:)=C_ZERO
      EGOGSE(:,:)=C_ZERO
      EGOGVD(:,:)=C_ZERO
      EGOGVE(:,:)=C_ZERO
C
      EGOTSD=C_ZERO
      EGOTSE=C_ZERO
      EGOTVD=C_ZERO
      EGOTVE=C_ZERO
C
      EGOSSD=C_ZERO
      EGOSSE=C_ZERO
      EGOSVD=C_ZERO
      EGOSVE=C_ZERO
C
      EGOPSD=C_ZERO
      EGOPSE=C_ZERO
      EGOPVD=C_ZERO
      EGOPVE=C_ZERO
C
      EGOMSD=C_ZERO
      EGOMSE=C_ZERO
      EGOMVD=C_ZERO
      EGOMVE=C_ZERO
C
C=======================================================================
C        INITIALIZING ARRAYS OF MEAN-FIELDS
C=======================================================================
C
      IF (I_GOGA.GE.2) THEN
C
          IF (ISGOGA.NE.1) THEN
              GOGASV(:,:,:,:)=C_ZERO
          ELSE
              GOGASV(:,:,:,:)=GOGASV(:,:,:,:)*XOLDEV
          END IF
C
      END IF
C
C=======================================================================
C        HERE BEGINS THE LOOP OVER GAUSSIANS THAT CONSTITUTE THE GOGNY
C        FORCE
C=======================================================================
C
      IDENSI=0
C
      DO INGOGA=1,NUGOGA
C
C=======================================================================
C        CALCULATING THE DIRECT TERM
C=======================================================================
C
         GOGWI0=GOGWID(INGOGA)
C
         CALL DEFGOG(NXMAXX,NDXMAX,NXHERM,1,GOGWI0,GAU_X0,GAU_X1)
         CALL DEFGOG(NYMAXX,NDYMAX,NYHERM,2,GOGWI0,GAU_Y0,GAU_Y1)
         CALL DEFGOG(NZMAXX,NDZMAX,NZHERM,3,GOGWI0,GAU_Z0,GAU_Z1)
C
         CALL GAUOPT(NXMAXX,NYMAXX,ISIMPY,I_GOGA,I_PART,IDENSI)
C
C=======================================================================
C        CALCULATING THE AVERAGE VALUES OF THE DIRECT TERM
C=======================================================================
C
         DO ICHARG=0,NDISOS
            DO JCHARG=0,NDISOS
C
               KARTEZ=0
C
               EGOGSD(ICHARG,JCHARG)=EGOGSD(ICHARG,JCHARG)
     *                       +GOG_SD(INGOGA,ICHARG,JCHARG)
     *              *GAUAVR(0,KARTEZ,KARTEZ,ICHARG,JCHARG)/2
C
               DO KARTEZ=1,NDKART
C
                  EGOGVD(ICHARG,JCHARG)=EGOGVD(ICHARG,JCHARG)
     *                          +GOG_VD(INGOGA,ICHARG,JCHARG)
     *                 *GAUAVR(0,KARTEZ,KARTEZ,ICHARG,JCHARG)/2
C
               END DO
C
            END DO
         END DO
C
C=======================================================================
C        CALCULATING THE BREAK-DOWN OF THE DIRECT TERM
C=======================================================================
C
         KARTEZ=0
C
         EGOTSD=EGOTSD+GOG_SD(INGOGA,0,1)
     *                *(GAUAVR(0,KARTEZ,KARTEZ,0,0)
     *                 +GAUAVR(0,KARTEZ,KARTEZ,0,1)
     *                 +GAUAVR(0,KARTEZ,KARTEZ,1,0)
     *                 +GAUAVR(0,KARTEZ,KARTEZ,1,1))/2
C
         EGOSSD=EGOSSD+(GOG_SD(INGOGA,0,0)-GOG_SD(INGOGA,0,1))
     *                *(GAUAVR(0,KARTEZ,KARTEZ,0,0)
     *                 +GAUAVR(0,KARTEZ,KARTEZ,1,1))/2
C
         EGOPSD=EGOPSD+(GOG_SD(INGOGA,0,0)+GOG_SD(INGOGA,0,1))/2
     *                *(GAUAVR(0,KARTEZ,KARTEZ,0,0)
     *                 +GAUAVR(0,KARTEZ,KARTEZ,0,1)
     *                 +GAUAVR(0,KARTEZ,KARTEZ,1,0)
     *                 +GAUAVR(0,KARTEZ,KARTEZ,1,1))/2
C
         EGOMSD=EGOMSD+(GOG_SD(INGOGA,0,0)-GOG_SD(INGOGA,0,1))/2
     *                *(GAUAVR(0,KARTEZ,KARTEZ,0,0)
     *                 -GAUAVR(0,KARTEZ,KARTEZ,0,1)
     *                 -GAUAVR(0,KARTEZ,KARTEZ,1,0)
     *                 +GAUAVR(0,KARTEZ,KARTEZ,1,1))/2
C
         DO KARTEZ=1,NDKART
C
            EGOTVD=EGOTVD+GOG_VD(INGOGA,0,1)
     *                   *(GAUAVR(0,KARTEZ,KARTEZ,0,0)
     *                    +GAUAVR(0,KARTEZ,KARTEZ,0,1)
     *                    +GAUAVR(0,KARTEZ,KARTEZ,1,0)
     *                    +GAUAVR(0,KARTEZ,KARTEZ,1,1))/2
C
            EGOSVD=EGOSVD+(GOG_VD(INGOGA,0,0)-GOG_VD(INGOGA,0,1))
     *                   *(GAUAVR(0,KARTEZ,KARTEZ,0,0)
     *                    +GAUAVR(0,KARTEZ,KARTEZ,1,1))/2
C
            EGOPVD=EGOPVD+(GOG_VD(INGOGA,0,0)+GOG_VD(INGOGA,0,1))/2
     *                   *(GAUAVR(0,KARTEZ,KARTEZ,0,0)
     *                    +GAUAVR(0,KARTEZ,KARTEZ,0,1)
     *                    +GAUAVR(0,KARTEZ,KARTEZ,1,0)
     *                    +GAUAVR(0,KARTEZ,KARTEZ,1,1))/2
C
            EGOMVD=EGOMVD+(GOG_VD(INGOGA,0,0)-GOG_VD(INGOGA,0,1))/2
     *                   *(GAUAVR(0,KARTEZ,KARTEZ,0,0)
     *                    -GAUAVR(0,KARTEZ,KARTEZ,0,1)
     *                    -GAUAVR(0,KARTEZ,KARTEZ,1,0)
     *                    +GAUAVR(0,KARTEZ,KARTEZ,1,1))/2
C
         END DO
C
C=======================================================================
C        CALCULATING THE MEAN FIELDS OF THE DIRECT TERM
C=======================================================================
C
         IF (I_GOGA.EQ.2.OR.I_GOGA.EQ.3) THEN
C
             DO ICHARG=0,NDISOS
C
                DO IKET=1,LDBASE
                   DO IBRA=1,LDBASE
C
                      KARTEZ=0
C
                      GOGASV(IBRA,IKET,KARTEZ,ICHARG)
     *               =GOGASV(IBRA,IKET,KARTEZ,ICHARG)
     *
     *               +GOG_SD(INGOGA,ICHARG,  ICHARG)
     *               *GAUFIL(0,IBRA,IKET,KARTEZ,  ICHARG)*XNEWEV
     *               +GOG_SD(INGOGA,ICHARG,1-ICHARG)
     *               *GAUFIL(0,IBRA,IKET,KARTEZ,1-ICHARG)*XNEWEV
C
                      DO KARTEZ=1,NDKART
C
                         GOGASV(IBRA,IKET,KARTEZ,ICHARG)
     *                  =GOGASV(IBRA,IKET,KARTEZ,ICHARG)
     *
     *                  +GOG_VD(INGOGA,ICHARG,  ICHARG)
     *                  *GAUFIL(0,IBRA,IKET,KARTEZ,  ICHARG)*XNEWEV
     *                  +GOG_VD(INGOGA,ICHARG,1-ICHARG)
     *                  *GAUFIL(0,IBRA,IKET,KARTEZ,1-ICHARG)*XNEWEV
C
                      END DO
C
                   END DO
                END DO
C
             END DO
C
             ISGOGA=1
C
         END IF
C
C=======================================================================
C        CALCULATING THE EXCHANGE TERM
C=======================================================================
C
         CALL EXCGOG(NXMAXX,NDXMAX,GAU_X0,GAU_X1)
         CALL EXCGOG(NYMAXX,NDYMAX,GAU_Y0,GAU_Y1)
         CALL EXCGOG(NZMAXX,NDZMAX,GAU_Z0,GAU_Z1)
C
         CALL GAUOPT(NXMAXX,NYMAXX,ISIMPY,I_GOGA,I_PART,IDENSI)
C
C=======================================================================
C        CALCULATING THE AVERAGE VALUES OF THE EXCHANGE TERM
C=======================================================================
C
         DO ICHARG=0,NDISOS
            DO JCHARG=0,NDISOS
C
               KARTEZ=0
C
               EGOGSE(ICHARG,JCHARG)=EGOGSE(ICHARG,JCHARG)
     *                       +GOG_SE(INGOGA,ICHARG,JCHARG)
     *              *GAUAVR(0,KARTEZ,KARTEZ,ICHARG,JCHARG)/2
C
               DO KARTEZ=1,NDKART
C
                  EGOGVE(ICHARG,JCHARG)=EGOGVE(ICHARG,JCHARG)
     *                          +GOG_VE(INGOGA,ICHARG,JCHARG)
     *                 *GAUAVR(0,KARTEZ,KARTEZ,ICHARG,JCHARG)/2
C
               END DO
C
            END DO
         END DO
C
C=======================================================================
C        CALCULATING THE BREAK-DOWN OF THE EXCHANGE TERM
C=======================================================================
C
         KARTEZ=0
C
         EGOTSE=EGOTSE+GOG_SE(INGOGA,0,1)
     *                *(GAUAVR(0,KARTEZ,KARTEZ,0,0)
     *                 +GAUAVR(0,KARTEZ,KARTEZ,0,1)
     *                 +GAUAVR(0,KARTEZ,KARTEZ,1,0)
     *                 +GAUAVR(0,KARTEZ,KARTEZ,1,1))/2
C
         EGOSSE=EGOSSE+(GOG_SE(INGOGA,0,0)-GOG_SE(INGOGA,0,1))
     *                *(GAUAVR(0,KARTEZ,KARTEZ,0,0)
     *                 +GAUAVR(0,KARTEZ,KARTEZ,1,1))/2
C
         EGOPSE=EGOPSE+(GOG_SE(INGOGA,0,0)+GOG_SE(INGOGA,0,1))/2
     *                *(GAUAVR(0,KARTEZ,KARTEZ,0,0)
     *                 +GAUAVR(0,KARTEZ,KARTEZ,0,1)
     *                 +GAUAVR(0,KARTEZ,KARTEZ,1,0)
     *                 +GAUAVR(0,KARTEZ,KARTEZ,1,1))/2
C
         EGOMSE=EGOMSE+(GOG_SE(INGOGA,0,0)-GOG_SE(INGOGA,0,1))/2
     *                *(GAUAVR(0,KARTEZ,KARTEZ,0,0)
     *                 -GAUAVR(0,KARTEZ,KARTEZ,0,1)
     *                 -GAUAVR(0,KARTEZ,KARTEZ,1,0)
     *                 +GAUAVR(0,KARTEZ,KARTEZ,1,1))/2
C
         DO KARTEZ=1,NDKART
C
            EGOTVE=EGOTVE+GOG_VE(INGOGA,0,1)
     *                   *(GAUAVR(0,KARTEZ,KARTEZ,0,0)
     *                    +GAUAVR(0,KARTEZ,KARTEZ,0,1)
     *                    +GAUAVR(0,KARTEZ,KARTEZ,1,0)
     *                    +GAUAVR(0,KARTEZ,KARTEZ,1,1))/2
C
            EGOSVE=EGOSVE+(GOG_VE(INGOGA,0,0)-GOG_VE(INGOGA,0,1))
     *                   *(GAUAVR(0,KARTEZ,KARTEZ,0,0)
     *                    +GAUAVR(0,KARTEZ,KARTEZ,1,1))/2
C
            EGOPVE=EGOPVE+(GOG_VE(INGOGA,0,0)+GOG_VE(INGOGA,0,1))/2
     *                   *(GAUAVR(0,KARTEZ,KARTEZ,0,0)
     *                    +GAUAVR(0,KARTEZ,KARTEZ,0,1)
     *                    +GAUAVR(0,KARTEZ,KARTEZ,1,0)
     *                    +GAUAVR(0,KARTEZ,KARTEZ,1,1))/2
C
            EGOMVE=EGOMVE+(GOG_VE(INGOGA,0,0)-GOG_VE(INGOGA,0,1))/2
     *                   *(GAUAVR(0,KARTEZ,KARTEZ,0,0)
     *                    -GAUAVR(0,KARTEZ,KARTEZ,0,1)
     *                    -GAUAVR(0,KARTEZ,KARTEZ,1,0)
     *                    +GAUAVR(0,KARTEZ,KARTEZ,1,1))/2
C
         END DO
C
C=======================================================================
C        CALCULATING THE MEAN FIELDS OF THE EXCHANGE TERM
C=======================================================================
C
         IF (I_GOGA.EQ.2.OR.I_GOGA.EQ.4) THEN
C
             DO ICHARG=0,NDISOS
C
                DO IKET=1,LDBASE
                   DO IBRA=1,LDBASE
C
                      KARTEZ=0
C
                      GOGASV(IBRA,IKET,KARTEZ,ICHARG)
     *               =GOGASV(IBRA,IKET,KARTEZ,ICHARG)
     *
     *               +GOG_SE(INGOGA,ICHARG,  ICHARG)
     *               *GAUFIL(0,IBRA,IKET,KARTEZ,  ICHARG)*XNEWEV
     *               +GOG_SE(INGOGA,ICHARG,1-ICHARG)
     *               *GAUFIL(0,IBRA,IKET,KARTEZ,1-ICHARG)*XNEWEV
C
                      DO KARTEZ=1,NDKART
C
                         GOGASV(IBRA,IKET,KARTEZ,ICHARG)
     *                  =GOGASV(IBRA,IKET,KARTEZ,ICHARG)
     *
     *                  +GOG_VE(INGOGA,ICHARG,  ICHARG)
     *                  *GAUFIL(0,IBRA,IKET,KARTEZ,  ICHARG)*XNEWEV
     *                  +GOG_VE(INGOGA,ICHARG,1-ICHARG)
     *                  *GAUFIL(0,IBRA,IKET,KARTEZ,1-ICHARG)*XNEWEV
C
                      END DO
C
                   END DO
                END DO
C
             END DO
C
             ISGOGA=1
C
         END IF
C
      END DO
C
C=======================================================================
C        CALCULATING THE TOTAL DIRECT AND EXCHANGE ENERGIES
C=======================================================================
C
      EGOGDT=0.0D0
      EGOGET=0.0D0
C
      DO ICHARG=0,NDISOS
         DO JCHARG=0,NDISOS
C
            EGOGDT=EGOGDT+REAL(EGOGSD(ICHARG,JCHARG)
     *                        +EGOGVD(ICHARG,JCHARG))
            EGOGET=EGOGET+REAL(EGOGSE(ICHARG,JCHARG)
     *                        +EGOGVE(ICHARG,JCHARG))
C
         END DO
      END DO
C
C=======================================================================
C
      CALL CPUTIM('GOGENE',0)
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE PARGOG(I_GOGA,IGOGPA,I_REGA,GOGNAM)
C
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      CHARACTER
     *          GOGNAM*4
      COMMON
     *       /GOGFOR/ GOGSTR(NDGOGA,NDFORC),GOGWID(NDGOGA),NUGOGA
      COMMON
     *       /CFIPRI/ NFIPRI
C=======================================================================
C
      IGOGNY=0
C
      NUGOGA=2
C
      IF (NDGOGA.LT.NUGOGA) STOP ' INCREASE NDGOGA IN PARGOG'
C
C=======================================================================
C
      IF (GOGNAM.EQ.'ZERO') THEN
C
          GOGSTR(1,1)=0.0D0
          GOGSTR(1,2)=0.0D0
          GOGSTR(1,3)=0.0D0
          GOGSTR(1,4)=0.0D0
C
          GOGWID(1  )=1.0D0
C
          GOGSTR(2,1)=0.0D0
          GOGSTR(2,2)=0.0D0
          GOGSTR(2,3)=0.0D0
          GOGSTR(2,4)=0.0D0
C
          GOGWID(2  )=1.0D0
C
          IGOGNY=1
C
      END IF
C
C=======================================================================
C           HERE IS THE D1S PARAMETER SET OF UNKNOWN ORIGIN
C=======================================================================
C
      IF (GOGNAM.EQ.'D1SX') THEN
C
          GOGSTR(1,1)=-1720.30D0
          GOGSTR(1,2)= 1300.00D0
          GOGSTR(1,3)=-1813.53D0
          GOGSTR(1,4)= 1397.60D0
C
          GOGWID(1  )=0.7D0
C
          GOGSTR(2,1)= 103.639D0
          GOGSTR(2,2)=-163.483D0
          GOGSTR(2,3)= 162.812D0
          GOGSTR(2,4)=-223.934D0
C
          GOGWID(2  )=1.2D0
C
          IGOGNY=1
C
      END IF
C
C=======================================================================
C           HERE IS THE D1S PARAMETER SET FROM CPC 63-365
C=======================================================================
C
      IF (GOGNAM.EQ.'D1S ') THEN
C
          GOGSTR(1,1)=-1720.30D0
          GOGSTR(1,2)= 1300.00D0
          GOGSTR(1,3)=-1813.53D0
          GOGSTR(1,4)= 1397.60D0
C
          GOGWID(1  )=0.7D0
C
          GOGSTR(2,1)=  103.64D0
          GOGSTR(2,2)= -163.48D0
          GOGSTR(2,3)=  162.81D0
          GOGSTR(2,4)= -223.93D0
C
          GOGWID(2  )=1.2D0
C
          IGOGNY=1
C
      END IF
C
C=======================================================================
C           HERE IS THE D1N PARAMETER SET FROM PLB 668-420
C=======================================================================
C
      IF (GOGNAM.EQ.'D1N ') THEN
C
          GOGSTR(1,1)=-2047.61D0
          GOGSTR(1,2)= 1700.00D0
          GOGSTR(1,3)=-2414.93D0
          GOGSTR(1,4)= 1519.35D0
C
          GOGWID(1  )=0.8D0
C
          GOGSTR(2,1)=  293.02D0
          GOGSTR(2,2)= -300.78D0
          GOGSTR(2,3)=  414.59D0
          GOGSTR(2,4)= -316.84D0
C
          GOGWID(2  )=1.2D0
C
          IGOGNY=1
C
      END IF
C
C=======================================================================
C           HERE IS THE MINNESOTA INTERACTION
C=======================================================================
C
      IF (GOGNAM.EQ.'MINN') THEN
C
          GOGWID(1  )=0.82005789813148427556D0
          GOGWID(2  )=1.46647115021353289169D0
C
          IGOGNY=1
C
      END IF
C
C=======================================================================
C         CHECKING IF THE FORCE PARAMETERS HAVE BEN SET
C=======================================================================
C
      IF (IGOGNY.NE.1) THEN
C
          WRITE(NFIPRI,'(/,
     *                 1X,20(1H/),'' UNDEFINED GOGNY FORCE PARAMETERS'',
     *                                                 4X,20(1H/),/,
     *                 1X,20(1H/),'' FORCE ACRONYM '',A4,'' IS NOT'',
     *                            '' SUPPORTED'',
     *                                                 1X,20(1H/),/)')
     *    GOGNAM
C
          STOP 'UNDEFINED GOGNY FORCE PARAMETERS'
C
      END IF
C
C=======================================================================
C         PRINTING THE GOGNY FORCE PARAMETERS
C=======================================================================
C
      IF (I_GOGA.GT.0.OR.IGOGPA.GT.0) THEN
C
          WRITE(NFIPRI,'(79(1H*),/,      1H*,77X,1H*,/,
     *          1H*,14X,''GOGNY FORCE DEFINITION '',
     *                 ''FOR THE PARAMETER SET '',A4  ,14X,1H*,/,
     *                                             1H*,77X,1H*,/,
     *              79(1H*),/,                     1H*,77X,1H*,/,
     *          1H*,  '' G11 ='',F8.2,''   G12 ='',F8.2,
     *              ''   G13 ='',F8.2,''   G14 ='',F8.2,
     *             ''   WID1 ='',F5.2,                  1X,1H*,/,
     *          1H*,  '' G21 ='',F8.2,''   G22 ='',F8.2,
     *              ''   G23 ='',F8.2,''   G24 ='',F8.2,
     *             ''   WID2 ='',F5.2,                  1X,1H*,/,
     *                                             1H*,77X,1H*,/,
     *                                                 79(1H*),/)')
     *
     *          GOGNAM,((GOGSTR(INGOGA,INFORC),INFORC=1,NDFORC),
     *                   GOGWID(INGOGA       ),INGOGA=1,NUGOGA)
C
      END IF
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE GOGPAI(NXHERM,NYHERM,NZHERM,NXMAXX,NYMAXX,NZMAXX,
     *                         SLOWPA,ISGOGP,IGOGPA,ISIMPY,GOGNAM)
C=======================================================================
      USE GAUSTO
      USE GOGSTO
      USE GOGKAP
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      CHARACTER
     *          GOGNAM*4
      COMPLEX
     *          PGOGSD,PGOGVD,PGOTSD,PGOTVD,
     *          PGOSSD,PGOSVD,PGOPSD,PGOPVD,
     *          PGOMSD,PGOMVD
      COMPLEX
     *          C_ZERO
C
      DIMENSION
     *          GOG_SD(NDGOGA,0:NDISOS,0:NDISOS),
     *          GOG_VD(NDGOGA,0:NDISOS,0:NDISOS),
     *          GOG_SE(NDGOGA,0:NDISOS,0:NDISOS),
     *          GOG_VE(NDGOGA,0:NDISOS,0:NDISOS)
C
      COMMON
     *       /GOGFOR/ GOGSTR(NDGOGA,NDFORC),GOGWID(NDGOGA),NUGOGA
      COMMON
     *       /GAUSIN/ GAU_X0(0:NDXMAX,0:NDXMAX,0:NDXMAX,0:NDXMAX),
     *                GAU_Y0(0:NDYMAX,0:NDYMAX,0:NDYMAX,0:NDYMAX),
     *                GAU_Z0(0:NDZMAX,0:NDZMAX,0:NDZMAX,0:NDZMAX),
     *
     *                GAU_X1(0:NDXMAX,0:NDXMAX,0:NDXMAX,0:NDXMAX),
     *                GAU_Y1(0:NDYMAX,0:NDYMAX,0:NDYMAX,0:NDYMAX),
     *                GAU_Z1(0:NDZMAX,0:NDZMAX,0:NDZMAX,0:NDZMAX)
      COMMON
     *       /PN_GOG/ PGOGSD(0:NDISOS),PGOGVD(0:NDISOS)
     *
     *       /PN_GTS/ PGOTSD,PGOTVD,PGOSSD,PGOSVD
     *
     *       /PN_GPM/ PGOPSD,PGOPVD,PGOMSD,PGOMVD
     *
     *       /PGOGTT/ PGOGDT
      COMMON
     *       /PHYCON/ H_BARC,XMASSP,XMASSN,HBCOE2
      COMMON
     *       /DIMENS/ LDBASE
C
C=======================================================================
C
      CALL CPUTIM('GOGPAI',1)
C
C=======================================================================
C        THIS SUBROUTINE CALCULATES:
C        1) THE AVERAGE PAIRING ENERGY OF THE FINITE-RANGE GOGNY
c           INTERACTION                     (FOR IGOGPA>0)
C        2) THE CORRESPONDING PAIRING FIELD (FOR IGOGPA=2)
C=======================================================================
C
C=======================================================================
C           HERE ARE THE NN, NP, PP, AND PN GOGNY STRENGTHS
C           DERIVED IN THE NOTES 77-B
C=======================================================================
C
      IPAHFB=1
C
      CALL PNCHAN(GOGSTR,GOG_SD,GOG_VD,GOG_SE,GOG_VE,NDGOGA,NUGOGA,
     *                                               IPAHFB,GOGNAM)
C
C=======================================================================
C
      IALLOC=0
C
C=======================================================================
      IF (.NOT.ALLOCATED(GOGCHI).AND.IGOGPA.GE.2) THEN
          ALLOCATE (GOGCHI(NDBASE,NDBASE,0:NDKART,0:NDISOS),STAT=IALLOC)
          IF (IALLOC.NE.0) CALL NOALLO('GOGCHI','GOGPAI')
      END IF
C=======================================================================
C
      C_ZERO=CMPLX(0.0D0,0.0D0)
C
      I_PART=3
C
C=======================================================================
C
      IF (ISGOGP.NE.1) THEN
          XOLDEV=0.0D0
      ELSE
          XOLDEV=SLOWPA
      END IF
C
      XNEWEV=1.0D0-XOLDEV
C
C=======================================================================
C        ZEROING THE ARRAYS THAT WILL COLLECT THE CONTRIBUTIONS COMING
C        FROM INDIVIDUAL GAUSSIANS
C=======================================================================
C
      PGOGSD(:)=C_ZERO
      PGOGVD(:)=C_ZERO
C
      PGOTSD=C_ZERO
      PGOTVD=C_ZERO
C
      PGOSSD=C_ZERO
      PGOSVD=C_ZERO
C
      PGOPSD=C_ZERO
      PGOPVD=C_ZERO
C
      PGOMSD=C_ZERO
      PGOMVD=C_ZERO
C
C=======================================================================
C        INITIALIZING ARRAYS OF PAIRING FIELDS
C=======================================================================
C
      IF (IGOGPA.GE.2) THEN
C
          IF (ISGOGP.NE.1) THEN
              GOGCHI(:,:,:,:)=C_ZERO
          ELSE
              GOGCHI(:,:,:,:)=GOGCHI(:,:,:,:)*XOLDEV
          END IF
C
      END IF
C
C=======================================================================
C        HERE BEGINS THE LOOP OVER GAUSSIANS THAT CONSTITUTE THE GOGNY
C        FORCE
C=======================================================================
C
      IDENSI=1
C
      DO INGOGA=1,NUGOGA
C
C=======================================================================
C        CALCULATING THE PAIRING TERM
C=======================================================================
C
         GOGWI0=GOGWID(INGOGA)
C
         CALL DEFGOG(NXMAXX,NDXMAX,NXHERM,1,GOGWI0,GAU_X0,GAU_X1)
         CALL DEFGOG(NYMAXX,NDYMAX,NYHERM,2,GOGWI0,GAU_Y0,GAU_Y1)
         CALL DEFGOG(NZMAXX,NDZMAX,NZHERM,3,GOGWI0,GAU_Z0,GAU_Z1)
C
         CALL GAUOPT(NXMAXX,NYMAXX,ISIMPY,IGOGPA,I_PART,IDENSI)
C
C=======================================================================
C        CALCULATING THE AVERAGE PAIRING ENERGY
C=======================================================================
C
         DO ICHARG=0,NDISOS
C
            KARTEZ=0
C
            PGOGSD(ICHARG)=PGOGSD(ICHARG)
     *                    +GOG_SD(INGOGA,ICHARG,ICHARG)
     *           *GAUAVR(0,KARTEZ,KARTEZ,ICHARG,ICHARG)
C
            DO KARTEZ=1,NDKART
C
               PGOGVD(ICHARG)=PGOGVD(ICHARG)
     *                       +GOG_VD(INGOGA,ICHARG,ICHARG)
     *              *GAUAVR(0,KARTEZ,KARTEZ,ICHARG,ICHARG)
C
            END DO
C
         END DO
C
C=======================================================================
C        CALCULATING THE BREAK-DOWN OF THE PAIRING ENERGY
C=======================================================================
C
         KARTEZ=0
C
         PGOTSD=PGOTSD+GOG_SD(INGOGA,0,1)
     *                *(GAUAVR(0,KARTEZ,KARTEZ,0,0)
     *                 +GAUAVR(0,KARTEZ,KARTEZ,1,1))/2
C
         PGOSSD=PGOSSD+(GOG_SD(INGOGA,0,0)-GOG_SD(INGOGA,0,1))
     *                *(GAUAVR(0,KARTEZ,KARTEZ,0,0)
     *                 +GAUAVR(0,KARTEZ,KARTEZ,1,1))/2
C
         PGOPSD=PGOPSD+(GOG_SD(INGOGA,0,0)+GOG_SD(INGOGA,0,1))/2
     *                *(GAUAVR(0,KARTEZ,KARTEZ,0,0)
     *                 +GAUAVR(0,KARTEZ,KARTEZ,1,1))/2
C
         PGOMSD=PGOMSD+(GOG_SD(INGOGA,0,0)-GOG_SD(INGOGA,0,1))/2
     *                *(GAUAVR(0,KARTEZ,KARTEZ,0,0)
     *                 +GAUAVR(0,KARTEZ,KARTEZ,1,1))/2
C
         DO KARTEZ=1,NDKART
C
            PGOTVD=PGOTVD+GOG_VD(INGOGA,0,1)
     *                   *(GAUAVR(0,KARTEZ,KARTEZ,0,0)
     *                    +GAUAVR(0,KARTEZ,KARTEZ,1,1))/2
C
            PGOSVD=PGOSVD+(GOG_VD(INGOGA,0,0)-GOG_VD(INGOGA,0,1))
     *                   *(GAUAVR(0,KARTEZ,KARTEZ,0,0)
     *                    +GAUAVR(0,KARTEZ,KARTEZ,1,1))/2
C
            PGOPVD=PGOPVD+(GOG_VD(INGOGA,0,0)+GOG_VD(INGOGA,0,1))/2
     *                   *(GAUAVR(0,KARTEZ,KARTEZ,0,0)
     *                    +GAUAVR(0,KARTEZ,KARTEZ,1,1))/2
C
            PGOMVD=PGOMVD+(GOG_VD(INGOGA,0,0)-GOG_VD(INGOGA,0,1))/2
     *                   *(GAUAVR(0,KARTEZ,KARTEZ,0,0)
     *                    +GAUAVR(0,KARTEZ,KARTEZ,1,1))/2
C
         END DO
C
C=======================================================================
C        CALCULATING THE CONTRIBUTION TO THE PAIRING FIELD
C=======================================================================
C
         IF (IGOGPA.EQ.2) THEN
C
             DO ICHARG=0,NDISOS
C
                DO IKET=1,LDBASE
                   DO IBRA=1,LDBASE
C
                      KARTEZ=0
C
                      GOGCHI(IBRA,IKET,KARTEZ,ICHARG)
     *               =GOGCHI(IBRA,IKET,KARTEZ,ICHARG)
     *
     *               +GOG_SD(INGOGA,ICHARG,ICHARG)
     *               *GAUFIL(0,IBRA,IKET,KARTEZ,ICHARG)*XNEWEV
C
                      DO KARTEZ=1,NDKART
C
                         GOGCHI(IBRA,IKET,KARTEZ,ICHARG)
     *                  =GOGCHI(IBRA,IKET,KARTEZ,ICHARG)
     *
     *                  +GOG_VD(INGOGA,ICHARG,ICHARG)
     *                  *GAUFIL(0,IBRA,IKET,KARTEZ,ICHARG)*XNEWEV
C
                      END DO
C
                   END DO
                END DO
C
             END DO
C
             ISGOGP=1
C
         END IF
C
      END DO
C
C=======================================================================
C        CALCULATING THE TOTAL GOGNY PAIRING ENERGY
C=======================================================================
C
      PGOGDT=0.0D0
      DO ICHARG=0,NDISOS
         PGOGDT=PGOGDT+REAL(PGOGSD(ICHARG)+PGOGVD(ICHARG))
      END DO
C
C=======================================================================
C
      CALL CPUTIM('GOGPAI',0)
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE GAUENE(NXMAXX,NYMAXX,ISIMPY,I_FIEL,I_PART)
C=======================================================================
      USE MAD_PP
      USE MAD_PM
      USE GAUSTO
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      COMPLEX
     *          C_ZERO,UNIT_I
      COMPLEX
     *          D_HELP,E_HELP,X_HE00,X_HE10,X_HE01
      COMPLEX
     *          Y_HEL0,Y_HEL1,Z_HE00,Z_HE10,Z_HE01
C=======================================================================
C
      DIMENSION
     *          E_HELP(0:NDKART,0:NDISOS)
      DIMENSION
     *          D_HELP(0:NDOSCI,0:NDOSCI,0:NDKART,0:NDISOS)
      DIMENSION
     *          X_HE00(0:NDKART,0:NDKART,0:NDISOS,0:NDISOS),
     *          X_HE10(0:NDKART,0:NDKART,0:NDISOS,0:NDISOS),
     *          X_HE01(0:NDKART,0:NDKART,0:NDISOS,0:NDISOS)
C=======================================================================
      ALLOCATABLE Y_HEL0(:,:,:,:,:,:)
      ALLOCATABLE Y_HEL1(:,:,:,:,:,:)
      ALLOCATABLE Z_HE00(:,:,:,:,:,:)
      ALLOCATABLE Z_HE10(:,:,:,:,:,:)
      ALLOCATABLE Z_HE01(:,:,:,:,:,:)
C=======================================================================
C
      COMMON
     *       /T_PHAS/ IPHAPP(0:NDYMAX,0:NDYMAX,0:NDKART),
     *                IPHAPM(0:NDYMAX,0:NDYMAX,0:NDKART),
     *                IPHAMP(0:NDYMAX,0:NDYMAX,0:NDKART),
     *                IPHAMM(0:NDYMAX,0:NDYMAX,0:NDKART)
      COMMON
     *       /BINDEX/ INDICE(0:NDXMAX,0:NDYMAX,0:NDZMAX)
     *
     *       /BLIMS1/ LAXOFY(0:NDYMAX),LAXOFZ(0:NDZMAX),
     *                LAYOFZ(0:NDZMAX),LAYOFX(0:NDXMAX),
     *                LAZOFX(0:NDXMAX),LAZOFY(0:NDYMAX)
     *
     *       /BLIMS2/ LAXOYZ(0:NDYMAX,0:NDZMAX),
     *                LAYOZX(0:NDZMAX,0:NDXMAX),
     *                LAZOXY(0:NDXMAX,0:NDYMAX)
      COMMON
     *       /GAUSIN/ GAU_X0(0:NDXMAX,0:NDXMAX,0:NDXMAX,0:NDXMAX),
     *                GAU_Y0(0:NDYMAX,0:NDYMAX,0:NDYMAX,0:NDYMAX),
     *                GAU_Z0(0:NDZMAX,0:NDZMAX,0:NDZMAX,0:NDZMAX),
     *
     *                GAU_X1(0:NDXMAX,0:NDXMAX,0:NDXMAX,0:NDXMAX),
     *                GAU_Y1(0:NDYMAX,0:NDYMAX,0:NDYMAX,0:NDYMAX),
     *                GAU_Z1(0:NDZMAX,0:NDZMAX,0:NDZMAX,0:NDZMAX)
      COMMON
     *       /DIMENS/ LDBASE
C
C=======================================================================
C
      CALL CPUTIM('GAUENE',1)
C
C=======================================================================
C
      IALLOC=0
C
      ALLOCATE (Y_HEL0(0:NDOSCI,0:NDOSCI,0:NDOSCI,0:NDOSCI,
     *                                   0:NDKART,0:NDISOS),STAT=IALLOC)
      IF (IALLOC.NE.0) CALL NOALLO('Y_HEL0','GAUENE')
      ALLOCATE (Z_HE00(0:NDOSCI,0:NDOSCI,0:NDOSCI,0:NDOSCI,
     *                                   0:NDKART,0:NDISOS),STAT=IALLOC)
      IF (IALLOC.NE.0) CALL NOALLO('Z_HE00','GAUENE')
C
      IF (I_PART.EQ.0) THEN
          ALLOCATE (Y_HEL1(0:NDOSCI,0:NDOSCI,0:NDOSCI,0:NDOSCI,
     *                                   0:NDKART,0:NDISOS),STAT=IALLOC)
          IF (IALLOC.NE.0) CALL NOALLO('Y_HEL1','GAUENE')
          ALLOCATE (Z_HE10(0:NDOSCI,0:NDOSCI,0:NDOSCI,0:NDOSCI,
     *                                   0:NDKART,0:NDISOS),STAT=IALLOC)
          IF (IALLOC.NE.0) CALL NOALLO('Z_HE10','GAUENE')
          ALLOCATE (Z_HE01(0:NDOSCI,0:NDOSCI,0:NDOSCI,0:NDOSCI,
     *                                   0:NDKART,0:NDISOS),STAT=IALLOC)
          IF (IALLOC.NE.0) CALL NOALLO('Z_HE01','GAUENE')
      END IF
C=======================================================================
C         ATTENTION: SEE COMMENTS IN GAUOPT
C=======================================================================
      IF (     ALLOCATED(GAUFIL)) DEALLOCATE(GAUFIL)
      IF (.NOT.ALLOCATED(GAUFIL).AND.I_FIEL.GE.2) THEN
          IF (I_PART.EQ.0) THEN
              ALLOCATE (GAUFIL(0:NDKART,NDBASE,NDBASE,
     *                         0:NDKART,0:NDISOS),STAT=IALLOC)
          ELSE
              ALLOCATE (GAUFIL(0:0     ,NDBASE,NDBASE,
     *                         0:NDKART,0:NDISOS),STAT=IALLOC)
          END IF
          IF (IALLOC.NE.0) CALL NOALLO('GAUFIL','GAUENE')
      END IF
C=======================================================================
C
C=======================================================================
C        THIS SUBROUTINE CALCULATES THE AVERAGE ENERGIES AND FIELDS
C        CORRESPONDING TO  THE  FINITE-RANGE  GAUSSIAN  INTERACTION
C=======================================================================
C
      C_ZERO=CMPLX(0.0D0,0.0D0)
C
      UNIT_I=CMPLX(0.0D0,1.0D0)
C
C=======================================================================
C
      LIMSET=0
C
C=======================================================================
C        CALCULATION FOR THE YUKAWA INTERACTION
C=======================================================================
C
      IF (I_PART.EQ.0) THEN
C
          KARLIM=NDKART
          ICHLIM=0
          LIMSET=1
C
      END IF
C
C=======================================================================
C        CALCULATION FOR THE COULOMB EXCHANGE INTERACTION
C=======================================================================
C
      IF (I_PART.EQ.1) THEN
C
          KARLIM=NDKART
          ICHLIM=NDISOS
          LIMSET=1
C
      END IF
C
C=======================================================================
C        CALCULATION FOR THE COULOMB DIRECT INTERACTION
C=======================================================================
C
      IF (I_PART.EQ.2) THEN
C
          KARLIM=0
          ICHLIM=NDISOS
          LIMSET=1
C
      END IF
C
C=======================================================================
C        CALCULATION FOR THE GOGNY INTERACTION
C=======================================================================
C
      IF (I_PART.EQ.3) THEN
C
          KARLIM=NDKART
          ICHLIM=0
          LIMSET=1
C
      END IF
C
      IF (LIMSET.NE.1)
     *    STOP 'GAUENE CALLED WITH AN INCORRECT VALUE OF I_PART'
C
C=======================================================================
C        ZEROING ARRAYS OF AVERAGE ENERGIES
C=======================================================================
C
      DO KARTEX=0,NDKART
         DO KARTEP=0,NDKART
            DO KARTEZ=0,NDKART
               DO ICHARP=0,NDISOS
                  DO ICHARG=0,NDISOS
C
                     GAUAVR(KARTEX,KARTEP,KARTEZ,ICHARP,ICHARG)=C_ZERO
C
                  END DO
               END DO
            END DO
         END DO
      END DO
C
C=======================================================================
C        ZEROING ARRAYS OF AVERAGE FIELDS
C=======================================================================
C
      IF (I_FIEL.GE.2) THEN
C
          IF (I_PART.EQ.0) THEN
C
              KARLIN=NDKART
          ELSE
              KARLIN=0
C
          END IF
C
          GAUFIL(:,:,:,:,:)=C_ZERO
C
      END IF
C
C=======================================================================
C        HERE BEGIN LOOPS OVER THE PARTICLE "2" QUANTUM NUMBERS IN X DIR
C=======================================================================
C
      DO NX=0,NXMAXX
         DO MX=0,NXMAXX
C
C=======================================================================
C        HERE BEGINS CALCULATION OF THE AVERAGE ENERGIES
C=======================================================================
C        HERE BEGIN LOOPS OVER THE PARTICLE "2" QUANTUM NUMBERS IN Z DIR
C=======================================================================
C
            DO NZ=0,LAZOFX(NX)
               DO MZ=0,LAZOFX(MX)
C
C=======================================================================
C        HERE BEGIN LOOPS OVER THE PARTICLE "2" QUANTUM NUMBERS IN Y DIR
C=======================================================================
C
                  DO NY=0,LAYOZX(NZ,NX)
                     DO MY=0,LAYOZX(MZ,MX)
C
                        IBRA=INDICE(NX,NY,NZ)
                        IKET=INDICE(MX,MY,MZ)
C
C=======================================================================
C        HERE THE PARTICLE "2" DENSITY MATRIX IS STORED
C=======================================================================
C
                        DO KARTEZ=0,KARLIM
                           DO ICHARG=ICHLIM,NDISOS
C
                              D_HELP(NY,MY,KARTEZ,ICHARG)=
     *
     *                        DEN_PP(IBRA,IKET, 0,ICHARG)*
     *                                              IPHAPP(MY,NY,KARTEZ)
     *                       +DEN_PP(IBRA,IKET, 1,ICHARG)*
     *                                              IPHAMM(MY,NY,KARTEZ)
C
                              IF (ISIMPY.NE.1)
     *
     *                        D_HELP(NY,MY,KARTEZ,ICHARG)=
     *                        D_HELP(NY,MY,KARTEZ,ICHARG)
     *
     *                       +DEN_PM(IBRA,IKET, 0,ICHARG)*
     *                                              IPHAMP(MY,NY,KARTEZ)
     *                       +DEN_PM(IBRA,IKET, 1,ICHARG)*
     *                                              IPHAPM(MY,NY,KARTEZ)
C
                           END DO
                        END DO
C
                        D_HELP(NY,MY,3,0)=D_HELP(NY,MY,3,0)*UNIT_I
                        D_HELP(NY,MY,3,1)=D_HELP(NY,MY,3,1)*UNIT_I
C
                     END DO
                  END DO
C
C=======================================================================
C        ABOVE END  LOOPS OVER THE PARTICLE "2" QUANTUM NUMBERS IN Y DIR
C=======================================================================
C        HERE BEGIN LOOPS OVER THE PARTICLE "1" QUANTUM NUMBERS IN Y DIR
C=======================================================================
C
                  DO NPY=0,NYMAXX
                     DO MPY=0,NYMAXX
C
                        DO KARTEZ=0,NDKART
                           DO ICHARG=0,NDISOS
C
                              Y_HEL0(MPY,NZ,NPY,MZ,KARTEZ,ICHARG)=C_ZERO
             IF (I_PART.EQ.0) Y_HEL1(MPY,NZ,NPY,MZ,KARTEZ,ICHARG)=C_ZERO
C
                           END DO
                        END DO
C
C=======================================================================
C        HERE BEGIN LOOPS OVER THE PARTICLE "2" QUANTUM NUMBERS IN Y DIR
C=======================================================================
C
                        IF (I_PART.EQ.0) THEN
C
                            DO KARTEZ=0,KARLIM
                               DO ICHARG=ICHLIM,NDISOS
C
                                  DO NY=0,LAYOZX(NZ,NX)
                                     DO MY=0,LAYOZX(MZ,MX)
C
                                    Y_HEL0(MPY,NZ,NPY,MZ,KARTEZ,ICHARG)=
     *                              Y_HEL0(MPY,NZ,NPY,MZ,KARTEZ,ICHARG)
     *                                     +D_HELP(NY,MY,KARTEZ,ICHARG)
     *                                     *GAU_Y0(MPY,MY,NPY,NY)
C
                                    Y_HEL1(MPY,NZ,NPY,MZ,KARTEZ,ICHARG)=
     *                              Y_HEL1(MPY,NZ,NPY,MZ,KARTEZ,ICHARG)
     *                                     +D_HELP(NY,MY,KARTEZ,ICHARG)
     *                                     *GAU_Y1(MPY,MY,NPY,NY)
C
                                     END DO
                                  END DO
C
                               END DO
                            END DO
C
                        ELSE
C
                            DO KARTEZ=0,KARLIM
                               DO ICHARG=ICHLIM,NDISOS
C
                                  DO NY=0,LAYOZX(NZ,NX)
                                     DO MY=0,LAYOZX(MZ,MX)
C
                                    Y_HEL0(MPY,NZ,NPY,MZ,KARTEZ,ICHARG)=
     *                              Y_HEL0(MPY,NZ,NPY,MZ,KARTEZ,ICHARG)
     *                                     +D_HELP(NY,MY,KARTEZ,ICHARG)
     *                                     *GAU_Y0(MPY,MY,NPY,NY)
C
                                     END DO
                                  END DO
C
                               END DO
                            END DO
C
                        END IF
C
C=======================================================================
C        ABOVE END  LOOPS OVER THE PARTICLE "2" QUANTUM NUMBERS IN Y DIR
C=======================================================================
C
                     END DO
                  END DO
C
C=======================================================================
C        ABOVE END  LOOPS OVER THE PARTICLE "1" QUANTUM NUMBERS IN Y DIR
C=======================================================================
C
               END DO
            END DO
C
C=======================================================================
C        ABOVE END  LOOPS OVER THE PARTICLE "2" QUANTUM NUMBERS IN Z DIR
C=======================================================================
C        HERE BEGIN LOOPS OVER THE PARTICLE "1" QUANTUM NUMBERS IN Y DIR
C=======================================================================
C
            DO NPY=0,NYMAXX
               DO MPY=0,NYMAXX
C
C=======================================================================
C        HERE BEGIN LOOPS OVER THE PARTICLE "1" QUANTUM NUMBERS IN Z DIR
C=======================================================================
C
                  DO NPZ=0,LAZOFY(NPY)
                     DO MPZ=0,LAZOFY(MPY)
C
                        DO KARTEZ=0,NDKART
                           DO ICHARG=0,NDISOS
C
                            Z_HE00(MPY,MPZ,NPY,NPZ,KARTEZ,ICHARG)=C_ZERO
           IF (I_PART.EQ.0) Z_HE10(MPY,MPZ,NPY,NPZ,KARTEZ,ICHARG)=C_ZERO
           IF (I_PART.EQ.0) Z_HE01(MPY,MPZ,NPY,NPZ,KARTEZ,ICHARG)=C_ZERO
C
                           END DO
                        END DO
C
C=======================================================================
C        HERE BEGIN LOOPS OVER THE PARTICLE "2" QUANTUM NUMBERS IN Z DIR
C=======================================================================
C
                        IF (I_PART.EQ.0) THEN
C
                            DO KARTEZ=0,KARLIM
                               DO ICHARG=ICHLIM,NDISOS
C
                                  DO NZ=0,LAZOFX(NX)
                                     DO MZ=0,LAZOFX(MX)
C
                                  Z_HE00(MPY,MPZ,NPY,NPZ,KARTEZ,ICHARG)=
     *                            Z_HE00(MPY,MPZ,NPY,NPZ,KARTEZ,ICHARG)
     *                             +Y_HEL0(MPY,NZ,NPY,MZ,KARTEZ,ICHARG)
     *                             *GAU_Z0(MPZ,MZ,NPZ,NZ)
C
                                  Z_HE10(MPY,MPZ,NPY,NPZ,KARTEZ,ICHARG)=
     *                            Z_HE10(MPY,MPZ,NPY,NPZ,KARTEZ,ICHARG)
     *                             +Y_HEL1(MPY,NZ,NPY,MZ,KARTEZ,ICHARG)
     *                             *GAU_Z0(MPZ,MZ,NPZ,NZ)
C
                                  Z_HE01(MPY,MPZ,NPY,NPZ,KARTEZ,ICHARG)=
     *                            Z_HE01(MPY,MPZ,NPY,NPZ,KARTEZ,ICHARG)
     *                             +Y_HEL0(MPY,NZ,NPY,MZ,KARTEZ,ICHARG)
     *                             *GAU_Z1(MPZ,MZ,NPZ,NZ)
C
                                     END DO
                                  END DO
C
                               END DO
                            END DO
C
                        ELSE
C
                            DO KARTEZ=0,KARLIM
                               DO ICHARG=ICHLIM,NDISOS
C
                                  DO NZ=0,LAZOFX(NX)
                                     DO MZ=0,LAZOFX(MX)
C
                                  Z_HE00(MPY,MPZ,NPY,NPZ,KARTEZ,ICHARG)=
     *                            Z_HE00(MPY,MPZ,NPY,NPZ,KARTEZ,ICHARG)
     *                             +Y_HEL0(MPY,NZ,NPY,MZ,KARTEZ,ICHARG)
     *                             *GAU_Z0(MPZ,MZ,NPZ,NZ)
C
                                     END DO
                                  END DO
C
                               END DO
                            END DO
C
                        END IF
C
C=======================================================================
C        ABOVE END  LOOPS OVER THE PARTICLE "2" QUANTUM NUMBERS IN Z DIR
C=======================================================================
C
                     END DO
                  END DO
C
C=======================================================================
C        ABOVE END  LOOPS OVER THE PARTICLE "1" QUANTUM NUMBERS IN Z DIR
C=======================================================================
C
               END DO
            END DO
C
C=======================================================================
C        ABOVE END  LOOPS OVER THE PARTICLE "1" QUANTUM NUMBERS IN Y DIR
C=======================================================================
C        HERE BEGIN LOOPS OVER THE PARTICLE "1" QUANTUM NUMBERS IN X DIR
C=======================================================================
C
            DO NPX=0,NXMAXX
               DO MPX=0,NXMAXX
C
                  DO KARTEP=0,NDKART
                     DO KARTEZ=0,NDKART
                        DO ICHARP=0,NDISOS
                           DO ICHARG=0,NDISOS
C
                              X_HE00(KARTEP,KARTEZ,ICHARP,ICHARG)=C_ZERO
                              X_HE10(KARTEP,KARTEZ,ICHARP,ICHARG)=C_ZERO
                              X_HE01(KARTEP,KARTEZ,ICHARP,ICHARG)=C_ZERO
C
                           END DO
                        END DO
                     END DO
                  END DO
C
C=======================================================================
C        HERE BEGIN LOOPS OVER THE PARTICLE "1" QUANTUM NUMBERS IN Y DIR
C=======================================================================
C
                  DO NPY=0,LAYOFX(NPX)
                     DO MPY=0,LAYOFX(MPX)
C
C=======================================================================
C        HERE BEGIN LOOPS OVER THE PARTICLE "1" QUANTUM NUMBERS IN Z DIR
C=======================================================================
C
                        DO NPZ=0,LAZOXY(NPX,NPY)
                           DO MPZ=0,LAZOXY(MPX,MPY)
C
                              IBRA=INDICE(NPX,NPY,NPZ)
                              IKET=INDICE(MPX,MPY,MPZ)
C
C=======================================================================
C        HERE THE PARTICLE "1" DENSITY MATRIX IS STORED
C=======================================================================
C
                              DO KARTEP=0,KARLIM
                                 DO ICHARP=ICHLIM,NDISOS
C
                                    E_HELP(KARTEP,ICHARP)=
     *
     *                              DEN_PP(IBRA,IKET,0,ICHARP)*
     *                                            IPHAPP(MPY,NPY,KARTEP)
     *                             +DEN_PP(IBRA,IKET,1,ICHARP)*
     *                                            IPHAMM(MPY,NPY,KARTEP)
C
                                    IF(ISIMPY.NE.1)
     *
     *                              E_HELP(KARTEP,ICHARP)=
     *                              E_HELP(KARTEP,ICHARP)
     *
     *                             +DEN_PM(IBRA,IKET,0,ICHARP)*
     *                                            IPHAMP(MPY,NPY,KARTEP)
     *                             +DEN_PM(IBRA,IKET,1,ICHARP)*
     *                                            IPHAPM(MPY,NPY,KARTEP)
C
                                 END DO
                              END DO
C
                              E_HELP(3,0)=E_HELP(3,0)*UNIT_I
                              E_HELP(3,1)=E_HELP(3,1)*UNIT_I
C
C=======================================================================
C        HERE THE PARTICLE "1" DENSITY MATRIX IS SUMMED UP
C=======================================================================
C
                              IF (I_PART.EQ.0) THEN
C
                                  DO KARTEP=0,KARLIM
                                     DO KARTEZ=0,KARLIM
                                        DO ICHARP=ICHLIM,NDISOS
                                           DO ICHARG=ICHLIM,NDISOS
C
                                    X_HE00(KARTEP,KARTEZ,ICHARP,ICHARG)=
     *                              X_HE00(KARTEP,KARTEZ,ICHARP,ICHARG)
     *                                           +E_HELP(KARTEP,ICHARP)
     *                           *Z_HE00(MPY,MPZ,NPY,NPZ,KARTEZ,ICHARG)
C
                                    X_HE10(KARTEP,KARTEZ,ICHARP,ICHARG)=
     *                              X_HE10(KARTEP,KARTEZ,ICHARP,ICHARG)
     *                                           +E_HELP(KARTEP,ICHARP)
     *                           *Z_HE10(MPY,MPZ,NPY,NPZ,KARTEZ,ICHARG)
C
                                    X_HE01(KARTEP,KARTEZ,ICHARP,ICHARG)=
     *                              X_HE01(KARTEP,KARTEZ,ICHARP,ICHARG)
     *                                           +E_HELP(KARTEP,ICHARP)
     *                           *Z_HE01(MPY,MPZ,NPY,NPZ,KARTEZ,ICHARG)
C
                                           END DO
                                        END DO
                                     END DO
                                  END DO
C
                              ELSE
C
                                  DO KARTEP=0,KARLIM
                                     DO KARTEZ=0,KARLIM
                                        DO ICHARP=ICHLIM,NDISOS
                                           DO ICHARG=ICHLIM,NDISOS
C
                                    X_HE00(KARTEP,KARTEZ,ICHARP,ICHARG)=
     *                              X_HE00(KARTEP,KARTEZ,ICHARP,ICHARG)
     *                                           +E_HELP(KARTEP,ICHARP)
     *                           *Z_HE00(MPY,MPZ,NPY,NPZ,KARTEZ,ICHARG)
C
                                           END DO
                                        END DO
                                     END DO
                                  END DO
C
                              END IF
C
                           END DO
                        END DO
C
C=======================================================================
C        ABOVE END  LOOPS OVER THE PARTICLE "1" QUANTUM NUMBERS IN Z DIR
C=======================================================================
C
                     END DO
                  END DO
C
C=======================================================================
C        ABOVE END  LOOPS OVER THE PARTICLE "1" QUANTUM NUMBERS IN Y DIR
C=======================================================================
C        HERE THE AVERAGE ENERGIES ARE SUMMED UP
C=======================================================================
C
                  IF (I_PART.EQ.0) THEN
C
                      DO KARTEP=0,KARLIM
                         DO KARTEZ=0,KARLIM
                            DO ICHARP=ICHLIM,NDISOS
                               DO ICHARG=ICHLIM,NDISOS
C
                              GAUAVR(0,KARTEP,KARTEZ,ICHARP,ICHARG)=
     *                        GAUAVR(0,KARTEP,KARTEZ,ICHARP,ICHARG)
     *                         +X_HE00(KARTEP,KARTEZ,ICHARP,ICHARG)
     *                         *GAU_X0(MPX,MX,NPX,NX)
C
                              GAUAVR(1,KARTEP,KARTEZ,ICHARP,ICHARG)=
     *                        GAUAVR(1,KARTEP,KARTEZ,ICHARP,ICHARG)
     *                         +X_HE00(KARTEP,KARTEZ,ICHARP,ICHARG)
     *                         *GAU_X1(MPX,MX,NPX,NX)
C
                              GAUAVR(2,KARTEP,KARTEZ,ICHARP,ICHARG)=
     *                        GAUAVR(2,KARTEP,KARTEZ,ICHARP,ICHARG)
     *                         +X_HE10(KARTEP,KARTEZ,ICHARP,ICHARG)
     *                         *GAU_X0(MPX,MX,NPX,NX)
C
                              GAUAVR(3,KARTEP,KARTEZ,ICHARP,ICHARG)=
     *                        GAUAVR(3,KARTEP,KARTEZ,ICHARP,ICHARG)
     *                         +X_HE01(KARTEP,KARTEZ,ICHARP,ICHARG)
     *                         *GAU_X0(MPX,MX,NPX,NX)
C
                              END DO
                           END DO
                         END DO
                      END DO
C
                  ELSE
C
                      DO KARTEP=0,KARLIM
                         DO KARTEZ=0,KARLIM
                            DO ICHARP=ICHLIM,NDISOS
                               DO ICHARG=ICHLIM,NDISOS
C
                              GAUAVR(0,KARTEP,KARTEZ,ICHARP,ICHARG)=
     *                        GAUAVR(0,KARTEP,KARTEZ,ICHARP,ICHARG)
     *                         +X_HE00(KARTEP,KARTEZ,ICHARP,ICHARG)
     *                         *GAU_X0(MPX,MX,NPX,NX)
C
                              END DO
                           END DO
                         END DO
                      END DO
C
                  END IF
C
C=======================================================================
C
               END DO
            END DO
C
C=======================================================================
C        ABOVE END  LOOPS OVER THE PARTICLE "1" QUANTUM NUMBERS IN X DIR
C=======================================================================
C
            IF (I_FIEL.GE.2) THEN
C
C=======================================================================
C        HERE BEGINS CALCULATION OF THE AVERAGE FIELDS
C=======================================================================
C        HERE BEGIN LOOPS OVER THE PARTICLE "1" QUANTUM NUMBERS IN X DIR
C=======================================================================
C
                DO NPX=0,NXMAXX
                   DO MPX=0,NXMAXX
C
C=======================================================================
C        HERE BEGIN LOOPS OVER THE PARTICLE "1" QUANTUM NUMBERS IN Y DIR
C=======================================================================
C
                      DO NPY=0,LAYOFX(NPX)
                         DO MPY=0,LAYOFX(MPX)
C
C=======================================================================
C        HERE BEGIN LOOPS OVER THE PARTICLE "1" QUANTUM NUMBERS IN Z DIR
C=======================================================================
C
                            IF (I_PART.EQ.0) THEN
C
                                DO KARTEZ=0,KARLIM
                                   DO ICHARG=ICHLIM,NDISOS
C
                                      DO NPZ=0,LAZOXY(NPX,NPY)
                                         DO MPZ=0,LAZOXY(MPX,MPY)
C
                                         IBRA=INDICE(MPX,MPY,MPZ)
                                         IKET=INDICE(NPX,NPY,NPZ)
C
                                       GAUFIL(0,IBRA,IKET,KARTEZ,ICHARG)
     *                                =GAUFIL(0,IBRA,IKET,KARTEZ,ICHARG)
     *                            +Z_HE00(MPY,MPZ,NPY,NPZ,KARTEZ,ICHARG)
     *                            *GAU_X0(MPX,MX,NPX,NX)
C
                                       GAUFIL(1,IBRA,IKET,KARTEZ,ICHARG)
     *                                =GAUFIL(1,IBRA,IKET,KARTEZ,ICHARG)
     *                            +Z_HE00(MPY,MPZ,NPY,NPZ,KARTEZ,ICHARG)
     *                            *GAU_X1(MPX,MX,NPX,NX)
C
                                       GAUFIL(2,IBRA,IKET,KARTEZ,ICHARG)
     *                                =GAUFIL(2,IBRA,IKET,KARTEZ,ICHARG)
     *                            +Z_HE10(MPY,MPZ,NPY,NPZ,KARTEZ,ICHARG)
     *                            *GAU_X0(MPX,MX,NPX,NX)
C
                                       GAUFIL(3,IBRA,IKET,KARTEZ,ICHARG)
     *                                =GAUFIL(3,IBRA,IKET,KARTEZ,ICHARG)
     *                            +Z_HE01(MPY,MPZ,NPY,NPZ,KARTEZ,ICHARG)
     *                            *GAU_X0(MPX,MX,NPX,NX)
C
                                         END DO
                                      END DO
C
                                   END DO
                                END DO
C
                            ELSE
C
                                DO KARTEZ=0,KARLIM
                                   DO ICHARG=ICHLIM,NDISOS
C
                                      DO NPZ=0,LAZOXY(NPX,NPY)
                                         DO MPZ=0,LAZOXY(MPX,MPY)
C
                                         IBRA=INDICE(MPX,MPY,MPZ)
                                         IKET=INDICE(NPX,NPY,NPZ)
C
                                       GAUFIL(0,IBRA,IKET,KARTEZ,ICHARG)
     *                                =GAUFIL(0,IBRA,IKET,KARTEZ,ICHARG)
     *                            +Z_HE00(MPY,MPZ,NPY,NPZ,KARTEZ,ICHARG)
     *                            *GAU_X0(MPX,MX,NPX,NX)
C
                                         END DO
                                      END DO
C
                                   END DO
                                END DO
C
                            END IF
C
C=======================================================================
C        ABOVE END  LOOPS OVER THE PARTICLE "1" QUANTUM NUMBERS IN Z DIR
C=======================================================================
C
                         END DO
                      END DO
C
C=======================================================================
C        ABOVE END  LOOPS OVER THE PARTICLE "1" QUANTUM NUMBERS IN Y DIR
C=======================================================================
C
                   END DO
                END DO
C
C=======================================================================
C        ABOVE END  LOOPS OVER THE PARTICLE "1" QUANTUM NUMBERS IN X DIR
C=======================================================================
C=======================================================================
C        HERE ENDS CALCULATION OF THE AVERAGE FIELDS
C=======================================================================
C
            END IF
C
         END DO
      END DO
C
C=======================================================================
C        ABOVE END  LOOPS OVER THE PARTICLE "2" QUANTUM NUMBERS IN X DIR
C=======================================================================
C
C=======================================================================
                       DEALLOCATE (Y_HEL0,Z_HE00)
      IF (I_PART.EQ.0) DEALLOCATE (Y_HEL1,Z_HE10,Z_HE01)
C=======================================================================
C
      CALL CPUTIM('GAUENE',0)
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE GAUOPT(NXMAXX,NYMAXX,ISIMPY,I_FIEL,I_PART,IDENSI)
C=======================================================================
      USE MAD_PP
      USE MAD_PM
      USE MAP_PM
      USE GAUSTO
#if(USE_COULEX==1)
      USE MAT_PP
      USE MAT_PM
#endif
C=======================================================================
      USE hfodd_sizes
C=======================================================================
C
      COMPLEX
     *          C_ZERO,C_UNIT,UNIT_I,BUFCMP,AUXCMP,BUXCMP,PHACOM
      COMPLEX
     *          D_HELP,D1HELP,E_HELP,X_HE00,X_HE10,X_HE01
      COMPLEX
     *          Y_HEL0,Y_HEL1,Z_HE00,Z_HE10,Z_HE01
C
      DIMENSION
     *          E_HELP(0:NDKART,0:NDISOS)
      DIMENSION
     *          D_HELP(0:NDOSCI,0:NDOSCI,0:NDISOS,0:NDKART),
     *          D1HELP(0:NDOSCI,0:NDOSCI,0:NDISOS,0:NDKART)
      DIMENSION
     *          X_HE00(0:NDKART,0:NDKART,0:NDISOS,0:NDISOS),
     *          X_HE10(0:NDKART,0:NDKART,0:NDISOS,0:NDISOS),
     *          X_HE01(0:NDKART,0:NDKART,0:NDISOS,0:NDISOS)
C=======================================================================
      ALLOCATABLE Y_HEL0(:,:,:,:,:,:)
      ALLOCATABLE Y_HEL1(:,:,:,:,:,:)
      ALLOCATABLE Z_HE00(:,:,:,:,:,:)
      ALLOCATABLE Z_HE10(:,:,:,:,:,:)
      ALLOCATABLE Z_HE01(:,:,:,:,:,:)
C=======================================================================
C
      COMMON
     *       /T_PHAS/ IPHAPP(0:NDYMAX,0:NDYMAX,0:NDKART),
     *                IPHAPM(0:NDYMAX,0:NDYMAX,0:NDKART),
     *                IPHAMP(0:NDYMAX,0:NDYMAX,0:NDKART),
     *                IPHAMM(0:NDYMAX,0:NDYMAX,0:NDKART)
      COMMON
     *       /COMPHA/ PHACOM(0:NDKART)
      COMMON
     *       /BINDEX/ INDICE(0:NDXMAX,0:NDYMAX,0:NDZMAX)
     *
     *       /BLIMS1/ LAXOFY(0:NDYMAX),LAXOFZ(0:NDZMAX),
     *                LAYOFZ(0:NDZMAX),LAYOFX(0:NDXMAX),
     *                LAZOFX(0:NDXMAX),LAZOFY(0:NDYMAX)
     *
     *       /BLIMS2/ LAXOYZ(0:NDYMAX,0:NDZMAX),
     *                LAYOZX(0:NDZMAX,0:NDXMAX),
     *                LAZOXY(0:NDXMAX,0:NDYMAX)
      COMMON
     *       /GAUSIN/ GAU_X0(0:NDXMAX,0:NDXMAX,0:NDXMAX,0:NDXMAX),
     *                GAU_Y0(0:NDYMAX,0:NDYMAX,0:NDYMAX,0:NDYMAX),
     *                GAU_Z0(0:NDZMAX,0:NDZMAX,0:NDZMAX,0:NDZMAX),
     *
     *                GAU_X1(0:NDXMAX,0:NDXMAX,0:NDXMAX,0:NDXMAX),
     *                GAU_Y1(0:NDYMAX,0:NDYMAX,0:NDYMAX,0:NDYMAX),
     *                GAU_Z1(0:NDZMAX,0:NDZMAX,0:NDZMAX,0:NDZMAX)
      COMMON
     *       /DIMENS/ LDBASE
      COMMON
     *       /CFIPRI/ NFIPRI
C
C=======================================================================
C
      CALL CPUTIM('GAUOPT',1)
C
C=======================================================================
C        THIS SUBROUTINE CALCULATES THE AVERAGE ENERGIES AND FIELDS
C        CORRESPONDING TO  THE  FINITE-RANGE  GAUSSIAN  INTERACTION
C=======================================================================
C
      C_ZERO=CMPLX(0.0D0,0.0D0)
      C_UNIT=CMPLX(1.0D0,0.0D0)
      UNIT_I=CMPLX(0.0D0,1.0D0)
C
C=======================================================================
C
      LIMSET=0
C
      IF (I_PART.EQ.0) THEN
C
          KARLIM=NDKART
          ICHLIM=0
          LIMSET=1
C
      END IF
C
      IF (I_PART.EQ.1) THEN
C
          KARLIM=NDKART
          ICHLIM=NDISOS
          LIMSET=1
C
      END IF
C
      IF (I_PART.EQ.2) THEN
C
          KARLIM=0
          ICHLIM=NDISOS
          LIMSET=1
C
      END IF
C
      IF (I_PART.EQ.3) THEN
C
          KARLIM=NDKART
          ICHLIM=0
          LIMSET=1
C
      END IF
C
      IF (LIMSET.NE.1)
     *    STOP 'GAUOPT CALLED WITH AN INCORRECT VALUE OF I_PART'
C
C=======================================================================
C
      IALLOC=0
C
      ALLOCATE (Y_HEL0(0:NDOSCI,0:NDOSCI,0:NDOSCI,0:NDOSCI,
     *                                   0:NDISOS,0:KARLIM),STAT=IALLOC)
      IF (IALLOC.NE.0) CALL NOALLO('Y_HEL0','GAUOPT')
      ALLOCATE (Z_HE00(0:NDOSCI,0:NDOSCI,0:NDOSCI,0:NDOSCI,
     *                                   0:NDISOS,0:KARLIM),STAT=IALLOC)
      IF (IALLOC.NE.0) CALL NOALLO('Z_HE00','GAUOPT')
C
      IF (I_PART.EQ.0) THEN
          ALLOCATE (Y_HEL1(0:NDOSCI,0:NDOSCI,0:NDOSCI,0:NDOSCI,
     *                                   0:NDISOS,0:KARLIM),STAT=IALLOC)
          IF (IALLOC.NE.0) CALL NOALLO('Y_HEL1','GAUOPT')
          ALLOCATE (Z_HE10(0:NDOSCI,0:NDOSCI,0:NDOSCI,0:NDOSCI,
     *                                   0:NDISOS,0:KARLIM),STAT=IALLOC)
          IF (IALLOC.NE.0) CALL NOALLO('Z_HE10','GAUOPT')
          ALLOCATE (Z_HE01(0:NDOSCI,0:NDOSCI,0:NDOSCI,0:NDOSCI,
     *                                   0:NDISOS,0:KARLIM),STAT=IALLOC)
          IF (IALLOC.NE.0) CALL NOALLO('Z_HE01','GAUOPT')
      END IF
      IF (     ALLOCATED(GAUAVR)) DEALLOCATE(GAUAVR)
      IF (.NOT.ALLOCATED(GAUAVR)) THEN
          IF (I_PART.EQ.0) THEN
              ALLOCATE (GAUAVR(0:NDKART,0:NDKART,0:NDKART,
     *                         0:NDISOS,0:NDISOS),STAT=IALLOC)
              IF (IALLOC.NE.0) CALL NOALLO('GAUAVR','GAUOPT')
          END IF
          IF (I_PART.EQ.1.OR.I_PART.EQ.2.OR.I_PART.EQ.3) THEN
              ALLOCATE (GAUAVR(0:0     ,0:NDKART,0:NDKART,
     *                         0:NDISOS,0:NDISOS),STAT=IALLOC)
              IF (IALLOC.NE.0) CALL NOALLO('GAUAVR','GAUOPT')
          END IF
      END IF
C=======================================================================
C         ATTENTION: UP TO THE VERSION 2.48D, ARRAY "GAUFIL"  BELOW  WAS
C                    NOT DEALLOCATED BEFORE BEING ALLOCATED.  THIS COULD
C                    POTENTIALLY HAVE CREATED PROBLEMS IN CASE  "GAUENE"
C                    OR "GAUOPT" WERE CALLED TWICE WITH VALUES OF I_PART
C                    EQUAL TO ZERO AND GREATER THEN ZERO. THIS  BUG  WAS
C                    CORRECTED IN VERSION 2.48E ON 23/06/2010.
C         ATTENTION: IN THE FUTURE, ANY ALLOCATION THAT DEPENDS  ON  ANY
C                    CHANGEABLE VARIABLE (AND NOT ON A PARAMETER) _MUST_
C                    BE PRECEDED BY A DEALLOCATION.
C=======================================================================
      IF (     ALLOCATED(GAUFIL)) DEALLOCATE(GAUFIL)
      IF (.NOT.ALLOCATED(GAUFIL).AND.I_FIEL.GE.2) THEN
          IF (I_PART.EQ.0) THEN
              ALLOCATE (GAUFIL(0:NDKART,NDBASE,NDBASE,
     *                         0:NDKART,0:NDISOS),STAT=IALLOC)
          ELSE
              ALLOCATE (GAUFIL(0:0     ,NDBASE,NDBASE,
     *                         0:NDKART,0:NDISOS),STAT=IALLOC)
          END IF
          IF (IALLOC.NE.0) CALL NOALLO('GAUFIL','GAUOPT')
      END IF
C=======================================================================
C        ZEROING ARRAYS OF AVERAGE ENERGIES
C=======================================================================
C
      GAUAVR(:,:,:,:,:)=C_ZERO
C
C=======================================================================
C        ZEROING ARRAYS OF AVERAGE FIELDS
C=======================================================================
C
      IF (I_FIEL.GE.2) THEN
C
          IF (I_PART.EQ.0) THEN
C
              KARLIN=NDKART
          ELSE
              KARLIN=0
C
          END IF
C
          GAUFIL(:,:,:,:,:)=C_ZERO
C
      END IF
C
C=======================================================================
C
C                       I_PART = 0
C
C=======================================================================
C
C=======================================================================
C        HERE BEGIN LOOPS OVER THE PARTICLE "2" QUANTUM NUMBERS IN X DIR
C=======================================================================
C
      IF (I_PART.EQ.0) THEN
C
          DO NX=0,NXMAXX
             DO MX=0,NXMAXX
C
C=======================================================================
C        HERE BEGINS CALCULATION OF THE AVERAGE ENERGIES
C=======================================================================
C        HERE BEGIN LOOPS OVER THE PARTICLE "2" QUANTUM NUMBERS IN Z DIR
C=======================================================================
C
                DO KARTEZ=0,KARLIM
                   DO ICHARG=ICHLIM,NDISOS
C
                      DO NZ=0,LAZOFX(NX)
                         DO MZ=0,LAZOFX(MX)
C
                            DO NY=0,LAYOZX(NZ,NX)
                               DO MY=0,LAYOZX(MZ,MX)
C
                                  IBRA=INDICE(NX,NY,NZ)
                                  IKET=INDICE(MX,MY,MZ)
C
                                  IF (IDENSI.EQ.0) THEN
C
                                      D_HELP(MY,NY,ICHARG,KARTEZ)=
     *
     *                                DEN_PP(IBRA,IKET, 0,ICHARG)*
     *                                       IPHAPP(MY,NY,KARTEZ)
     *                               +DEN_PP(IBRA,IKET, 1,ICHARG)*
     *                                       IPHAMM(MY,NY,KARTEZ)
C
                                     IF (ISIMPY.NE.1)
     *
     *                                   D_HELP(MY,NY,ICHARG,KARTEZ)=
     *                                   D_HELP(MY,NY,ICHARG,KARTEZ)
     *
     *                                  +DEN_PM(IBRA,IKET, 0,ICHARG)*
     *                                          IPHAMP(MY,NY,KARTEZ)
     *                                  +DEN_PM(IBRA,IKET, 1,ICHARG)*
     *                                          IPHAPM(MY,NY,KARTEZ)
C
                                      D_HELP(MY,NY,ICHARG,KARTEZ)
     *                               =D_HELP(MY,NY,ICHARG,KARTEZ)
     *                               *PHACOM(KARTEZ)
C
                                  ELSE
C
                                      D_HELP(MY,NY,ICHARG,KARTEZ)
     *                               =CHI_PM(IBRA,IKET, 0,ICHARG)
C
                                      D1HELP(MY,NY,ICHARG,KARTEZ)
     *                               =CHI_PM(IBRA,IKET, 1,ICHARG)
C
                                  END IF
C
                               END DO ! MY
                            END DO ! NY
C
                            IF (IDENSI.EQ.0) THEN
C
                                DO NPY=0,NYMAXX
                                   DO MPY=0,NYMAXX
C
                                      BUFCMP = C_ZERO
                                      AUXCMP = C_ZERO
C
                                      DO NY=0,LAYOZX(NZ,NX)
                                         DO MY=0,LAYOZX(MZ,MX)
C
                                         BUFCMP=BUFCMP
     *                                  +D_HELP(MY,NY,ICHARG,KARTEZ)
     *                                  *GAU_Y0(MPY,MY,NPY,NY)
C
                                         AUXCMP=AUXCMP
     *                                  +D_HELP(MY,NY,ICHARG,KARTEZ)
     *                                  *GAU_Y1(MPY,MY,NPY,NY)
C
                                         END DO ! MY
                                      END DO ! NY
C
                                   Y_HEL0(MZ,NZ,MPY,NPY,ICHARG,KARTEZ)
     *                            =BUFCMP
C
                                   Y_HEL1(MZ,NZ,MPY,NPY,ICHARG,KARTEZ)
     *                            =AUXCMP
C
                                   END DO ! MPY
                                END DO ! NPY
C
                            ELSE
C
                                DO NPY=0,NYMAXX
                                   DO MPY=0,NYMAXX
C
                                      BUFCMP = C_ZERO
                                      AUXCMP = C_ZERO
C
                                      DO NY=0,LAYOZX(NZ,NX)
                                         DO MY=0,LAYOZX(MZ,MX)
C
                                         BUFCMP=BUFCMP
     *                                  +D_HELP(MY,NY,ICHARG,KARTEZ)
     *                                  *GAU_Y0(MPY,MY,NPY,NY)
     *                                  *IPHAMP(MPY,MY,KARTEZ)
     *                                  *IPHAPM(NPY,NY,KARTEZ)
     *                                  *PHACOM(KARTEZ)
     *                                  *PHACOM(KARTEZ)
     *
     *                                  +D1HELP(MY,NY,ICHARG,KARTEZ)
     *                                  *GAU_Y0(MPY,MY,NPY,NY)
     *                                  *IPHAPP(MPY,MY,KARTEZ)
     *                                  *IPHAPP(NPY,NY,KARTEZ)
     *                                  *PHACOM(KARTEZ)
     *                                  *PHACOM(KARTEZ)
C
                                         AUXCMP=AUXCMP
     *                                  +D_HELP(MY,NY,ICHARG,KARTEZ)
     *                                  *GAU_Y1(MPY,MY,NPY,NY)
     *                                  *IPHAMP(MPY,MY,KARTEZ)
     *                                  *IPHAPM(NPY,NY,KARTEZ)
     *                                  *PHACOM(KARTEZ)
     *                                  *PHACOM(KARTEZ)
     *
     *                                  +D1HELP(MY,NY,ICHARG,KARTEZ)
     *                                  *GAU_Y1(MPY,MY,NPY,NY)
     *                                  *IPHAPP(MPY,MY,KARTEZ)
     *                                  *IPHAPP(NPY,NY,KARTEZ)
     *                                  *PHACOM(KARTEZ)
     *                                  *PHACOM(KARTEZ)
C
                                         END DO ! MY
                                      END DO ! NY
C
                                   Y_HEL0(MZ,NZ,MPY,NPY,ICHARG,KARTEZ)
     *                            =BUFCMP
C
                                   Y_HEL1(MZ,NZ,MPY,NPY,ICHARG,KARTEZ)
     *                            =AUXCMP
C
                                   END DO ! MPY
                                END DO ! NPY
C
                            END IF
C
                        END DO ! MZ
                     END DO ! NZ
C
                  END DO ! ICHARG
                END DO ! KARTEZ
C
C=======================================================================
C        ABOVE END  LOOPS OVER THE PARTICLE "2" QUANTUM NUMBERS IN Z DIR
C=======================================================================
C        HERE BEGIN LOOPS OVER THE PARTICLE "1" QUANTUM NUMBERS IN Y DIR
C=======================================================================
C
                DO KARTEZ=0,KARLIM !NDKART
                   DO ICHARG=0,NDISOS
C
                      DO NPY=0,NYMAXX
                         DO MPY=0,NYMAXX
C
                            DO NPZ=0,LAZOFY(NPY)
                               DO MPZ=0,LAZOFY(MPY)
C
                                  BUFCMP = C_ZERO
                                  AUXCMP = C_ZERO
                                  BUXCMP = C_ZERO
C
                                  DO NZ=0,LAZOFX(NX)
                                     DO MZ=0,LAZOFX(MX)
C
                                        BUFCMP=BUFCMP
     *                             +Y_HEL0(MZ,NZ,MPY,NPY,ICHARG,KARTEZ)
     *                             *GAU_Z0(MPZ,MZ,NPZ,NZ)
C
                                        AUXCMP=AUXCMP
     *                             +Y_HEL1(MZ,NZ,MPY,NPY,ICHARG,KARTEZ)
     *                             *GAU_Z0(MPZ,MZ,NPZ,NZ)
C
                                        BUXCMP=BUXCMP
     *                             +Y_HEL0(MZ,NZ,MPY,NPY,ICHARG,KARTEZ)
     *                             *GAU_Z1(MPZ,MZ,NPZ,NZ)
C
                                     END DO ! MZ
                                  END DO ! NZ
C
                                  Z_HE00(MPZ,NPZ,MPY,NPY,ICHARG,KARTEZ)
     *                           =BUFCMP
                                  Z_HE10(MPZ,NPZ,MPY,NPY,ICHARG,KARTEZ)
     *                           =AUXCMP
                                  Z_HE01(MPZ,NPZ,MPY,NPY,ICHARG,KARTEZ)
     *                           =BUXCMP
C
                             END DO ! MPZ
                          END DO ! NPZ
C
                        END DO ! MPY
                     END DO ! NPY
C
                   END DO ! ICHARG
                END DO ! KARTEZ
C
C=======================================================================
C        ABOVE END  LOOPS OVER THE PARTICLE "1" QUANTUM NUMBERS IN Y DIR
C=======================================================================
C        HERE BEGIN LOOPS OVER THE PARTICLE "1" QUANTUM NUMBERS IN X DIR
C=======================================================================
C
C         Here we can add an OpenMP parallel do over NPX
C          - local thread storage is small
C          - inside loop over NX and MX
C
                DO NPX=0,NXMAXX
                   DO MPX=0,NXMAXX
C
                      X_HE00(:,:,:,:)=C_ZERO
                      X_HE10(:,:,:,:)=C_ZERO
                      X_HE01(:,:,:,:)=C_ZERO
C
                      DO NPY=0,LAYOFX(NPX)
                         DO MPY=0,LAYOFX(MPX)
C
                            DO NPZ=0,LAZOXY(NPX,NPY)
                               DO MPZ=0,LAZOXY(MPX,MPY)
C
                                  IBRA=INDICE(NPX,NPY,NPZ)
                                  IKET=INDICE(MPX,MPY,MPZ)
C
                                  IF (IDENSI.EQ.0) THEN
C
                                      DO KARTEP=0,KARLIM
                                         DO ICHARP=ICHLIM,NDISOS
C
                                            E_HELP(KARTEP,ICHARP)=
     *
     *                                      DEN_PP(IBRA,IKET,0,ICHARP)*
     *                                          IPHAPP(MPY,NPY,KARTEP)
     *                                     +DEN_PP(IBRA,IKET,1,ICHARP)*
     *                                          IPHAMM(MPY,NPY,KARTEP)
C
                                            IF(ISIMPY.NE.1)
     *
     *                                      E_HELP(KARTEP,ICHARP)=
     *                                      E_HELP(KARTEP,ICHARP)
     *
     *                                     +DEN_PM(IBRA,IKET,0,ICHARP)*
     *                                          IPHAMP(MPY,NPY,KARTEP)
     *                                     +DEN_PM(IBRA,IKET,1,ICHARP)*
     *                                          IPHAPM(MPY,NPY,KARTEP)
C
                                         END DO
                                      END DO
C
                                  ELSE
C
                                      DO KARTEP=0,KARLIM
                                         DO ICHARP=ICHLIM,NDISOS
C
                                            E_HELP(KARTEP,ICHARP)=
     *
     *                          -CONJG(CHI_PM(IBRA,IKET,0,ICHARP))
C
                                         END DO
                                      END DO
                                  END IF
C
                                  E_HELP(3,0)=E_HELP(3,0)*UNIT_I
                                  E_HELP(3,1)=E_HELP(3,1)*UNIT_I
C
                                  DO ICHARG=ICHLIM,NDISOS
                                     DO ICHARP=ICHLIM,NDISOS
                                        DO KARTEZ=0,KARLIM
                                           DO KARTEP=0,KARLIM
C
                                    X_HE00(KARTEP,KARTEZ,ICHARP,ICHARG)=
     *                              X_HE00(KARTEP,KARTEZ,ICHARP,ICHARG)
     *                                           +E_HELP(KARTEP,ICHARP)
     *                           *Z_HE00(MPZ,NPZ,MPY,NPY,ICHARG,KARTEZ)
C
                                    X_HE10(KARTEP,KARTEZ,ICHARP,ICHARG)=
     *                              X_HE10(KARTEP,KARTEZ,ICHARP,ICHARG)
     *                                           +E_HELP(KARTEP,ICHARP)
     *                           *Z_HE10(MPZ,NPZ,MPY,NPY,ICHARG,KARTEZ)
C
                                    X_HE01(KARTEP,KARTEZ,ICHARP,ICHARG)=
     *                              X_HE01(KARTEP,KARTEZ,ICHARP,ICHARG)
     *                                           +E_HELP(KARTEP,ICHARP)
     *                           *Z_HE01(MPZ,NPZ,MPY,NPY,ICHARG,KARTEZ)
C
                                           END DO ! KARTEP
                                        END DO ! KARTEZ
                                     END DO ! ICHARP
                                  END DO ! ICHARG
C
                              END DO ! MPZ
                            END DO ! NPZ
C
                         END DO ! MPY
                      END DO ! NPY
C
C=======================================================================
C        ABOVE END  LOOPS OVER THE PARTICLE "1" QUANTUM NUMBERS IN Y DIR
C=======================================================================
C        HERE THE AVERAGE ENERGIES ARE SUMMED UP
C=======================================================================
C
                      DO ICHARG=ICHLIM,NDISOS
                         DO ICHARP=ICHLIM,NDISOS
                            DO KARTEZ=0,KARLIM
                               DO KARTEP=0,KARLIM
C
                              GAUAVR(0,KARTEP,KARTEZ,ICHARP,ICHARG)=
     *                        GAUAVR(0,KARTEP,KARTEZ,ICHARP,ICHARG)
     *                         +X_HE00(KARTEP,KARTEZ,ICHARP,ICHARG)
     *                         *GAU_X0(MPX,MX,NPX,NX)
C
                              GAUAVR(1,KARTEP,KARTEZ,ICHARP,ICHARG)=
     *                        GAUAVR(1,KARTEP,KARTEZ,ICHARP,ICHARG)
     *                         +X_HE00(KARTEP,KARTEZ,ICHARP,ICHARG)
     *                         *GAU_X1(MPX,MX,NPX,NX)
C
                              GAUAVR(2,KARTEP,KARTEZ,ICHARP,ICHARG)=
     *                        GAUAVR(2,KARTEP,KARTEZ,ICHARP,ICHARG)
     *                         +X_HE10(KARTEP,KARTEZ,ICHARP,ICHARG)
     *                         *GAU_X0(MPX,MX,NPX,NX)
C
                              GAUAVR(3,KARTEP,KARTEZ,ICHARP,ICHARG)=
     *                        GAUAVR(3,KARTEP,KARTEZ,ICHARP,ICHARG)
     *                         +X_HE01(KARTEP,KARTEZ,ICHARP,ICHARG)
     *                         *GAU_X0(MPX,MX,NPX,NX)
C
                              END DO
                           END DO
                         END DO
                      END DO
C
C=======================================================================
C
                   END DO ! MPX
                END DO ! NPX
C
C=======================================================================
C        ABOVE END  LOOPS OVER THE PARTICLE "1" QUANTUM NUMBERS IN X DIR
C=======================================================================
C
                IF (I_FIEL.GE.2) THEN
C
C=======================================================================
C        HERE BEGINS CALCULATION OF THE AVERAGE FIELDS
C=======================================================================
C        HERE BEGIN LOOPS OVER THE PARTICLE "1" QUANTUM NUMBERS IN X DIR
C=======================================================================
C
C         Here we can add an OpenMP parallel do over NPX
C          - local thread storage is small
C          - inside loop over NX and MX
                    DO NPX=0,NXMAXX
                       DO MPX=0,NXMAXX
C
                          DO KARTEZ=0,KARLIM
                             DO ICHARG=ICHLIM,NDISOS
C
                                DO NPY=0,LAYOFX(NPX)
                                   DO MPY=0,LAYOFX(MPX)
C
                                      DO NPZ=0,LAZOXY(NPX,NPY)
                                         DO MPZ=0,LAZOXY(MPX,MPY)
C
                                         IBRA=INDICE(MPX,MPY,MPZ)
                                         IKET=INDICE(NPX,NPY,NPZ)
C
                                       GAUFIL(0,IBRA,IKET,KARTEZ,ICHARG)
     *                                =GAUFIL(0,IBRA,IKET,KARTEZ,ICHARG)
     *                            +Z_HE00(MPZ,NPZ,MPY,NPY,ICHARG,KARTEZ)
     *                            *GAU_X0(MPX,MX,NPX,NX)
C
                                       GAUFIL(1,IBRA,IKET,KARTEZ,ICHARG)
     *                                =GAUFIL(1,IBRA,IKET,KARTEZ,ICHARG)
     *                            +Z_HE00(MPZ,NPZ,MPY,NPY,ICHARG,KARTEZ)
     *                            *GAU_X1(MPX,MX,NPX,NX)
C
                                       GAUFIL(2,IBRA,IKET,KARTEZ,ICHARG)
     *                                =GAUFIL(2,IBRA,IKET,KARTEZ,ICHARG)
     *                            +Z_HE10(MPZ,NPZ,MPY,NPY,ICHARG,KARTEZ)
     *                            *GAU_X0(MPX,MX,NPX,NX)
C
                                       GAUFIL(3,IBRA,IKET,KARTEZ,ICHARG)
     *                                =GAUFIL(3,IBRA,IKET,KARTEZ,ICHARG)
     *                            +Z_HE01(MPZ,NPZ,MPY,NPY,ICHARG,KARTEZ)
     *                            *GAU_X0(MPX,MX,NPX,NX)
C
                                         END DO ! MPZ
                                      END DO ! NPZ
C
                                   END DO ! MPY
                                END DO ! NPY
C
                             END DO ! ICHARG
                          END DO ! KARTEZ
C
                       END DO ! MPX
                    END DO ! NPX
C
C=======================================================================
C        HERE ENDS CALCULATION OF THE AVERAGE FIELDS
C=======================================================================
C
                END IF
C
             END DO ! MX
          END DO ! NX
C
C=======================================================================
C
C                       I_PART > 0
C
C=======================================================================
C
       ELSE
C
          DO NX=0,NXMAXX
             DO MX=0,NXMAXX
C
C=======================================================================
C        HERE BEGIN LOOPS OVER THE PARTICLE "1" QUANTUM NUMBERS IN Z DIR
C=======================================================================
C
C                 The terms below will be the mean-field \Gamma
C                 and pairing field \Delta
c                   \Gamma = \Gamma_{mp,np}
C                          = \sum{m,n} <mp m | v | np n>\rho_{n,m}
C                   \Delta = \Delta_{mp,np}
C                          = \sum{m,n} <mp np | v | m n>\kap_{m,n}
C                          = \sum{m,n} <mp m | v(exc) | np n>\kap_{m,n}
C
                 DO KARTEZ=0,KARLIM
                    DO ICHARG=ICHLIM,NDISOS
C
                       DO NZ=0,LAZOFX(NX)
                          DO MZ=0,LAZOFX(MX)
C
                            DO NY=0,LAYOZX(NZ,NX)
                               DO MY=0,LAYOZX(MZ,MX)
C
C                                  IBRA asociated with (n) indexes
C                                  IKET asociated with (m) indexes
                                  IBRA=INDICE(NX,NY,NZ)
                                  IKET=INDICE(MX,MY,MZ)
C
C                                  The multiplication of the density
C                                  matrix and pairing tensor by phase
C                                  factors IPHAPP, etc. sets the phase
C                                  of the matrices of Gamma and Delta
C                                  in the t-basis
C
C                                  Below: \rho_{nm} <-> DEN(IBRA,IKET)
C
                                  IF (IDENSI.EQ.0) THEN
C
                                      D_HELP(MY,NY,ICHARG,KARTEZ)=
     *
     *                                DEN_PP(IBRA,IKET, 0,ICHARG)*
     *                                       IPHAPP(MY,NY,KARTEZ)
     *                               +DEN_PP(IBRA,IKET, 1,ICHARG)*
     *                                       IPHAMM(MY,NY,KARTEZ)
C
                                      IF (ISIMPY.NE.1)
     *
     *                                    D_HELP(MY,NY,ICHARG,KARTEZ)=
     *                                    D_HELP(MY,NY,ICHARG,KARTEZ)
     *
     *                                   +DEN_PM(IBRA,IKET, 0,ICHARG)*
     *                                           IPHAMP(MY,NY,KARTEZ)
     *                                   +DEN_PM(IBRA,IKET, 1,ICHARG)*
     *                                           IPHAPM(MY,NY,KARTEZ)
C
                                      D_HELP(MY,NY,ICHARG,KARTEZ)
     *                               =D_HELP(MY,NY,ICHARG,KARTEZ)
     *                               *PHACOM(KARTEZ)
C
                                  ELSE
C
C                                  Below: \kappa_{mn} <-> CHI(IKET,IBRA)
C
                                      D_HELP(MY,NY,ICHARG,KARTEZ)
     *                               =CHI_PM(IKET,IBRA, 0,ICHARG)
C
                                      D1HELP(MY,NY,ICHARG,KARTEZ)
     *                               =CHI_PM(IKET,IBRA, 1,ICHARG)
C
                                  END IF ! IDENSI=0
C
                               END DO ! MY
                            END DO ! NY
C
                            IF (IDENSI.EQ.0) THEN
C
                                DO NPY=0,NYMAXX
                                   DO MPY=0,NYMAXX
C
                                      BUFCMP = C_ZERO
C
                                      DO NY=0,LAYOZX(NZ,NX)
                                         DO MY=0,LAYOZX(MZ,MX)
C
                                            BUFCMP=BUFCMP
     *                                     +D_HELP(MY,NY,ICHARG,KARTEZ)
     *                                     *GAU_Y0(MPY,MY,NPY,NY)
C
                                         END DO ! MY
                                      END DO ! NY
C
                                   Y_HEL0(MZ,NZ,MPY,NPY,ICHARG,KARTEZ)
     *                            =BUFCMP
C
                                   END DO ! MPY
                                END DO ! NPY
C
                            ELSE
C
                                DO NPY=0,NYMAXX
                                   DO MPY=0,NYMAXX
C
                                      BUFCMP = C_ZERO
C
                                      DO NY=0,LAYOZX(NZ,NX)
                                         DO MY=0,LAYOZX(MZ,MX)
C
                                            BUFCMP=BUFCMP
     *
     *                                     +D_HELP(MY,NY,ICHARG,KARTEZ)
     *                                     *GAU_Y0(MPY,NPY,MY,NY)
     *                                     *IPHAMP(MPY,MY,KARTEZ)
     *                                     *IPHAPM(NPY,NY,KARTEZ)
     *                                     *PHACOM(KARTEZ)
     *                                     *PHACOM(KARTEZ)
     *
     *                                     +D1HELP(MY,NY,ICHARG,KARTEZ)
     *                                     *GAU_Y0(MPY,NPY,MY,NY)
     *                                     *IPHAPP(MPY,MY,KARTEZ)
     *                                     *IPHAMM(NPY,NY,KARTEZ)
     *                                     *PHACOM(KARTEZ)
     *                                     *PHACOM(KARTEZ)
C
                                         END DO ! MY
                                      END DO ! NY
C
                                   Y_HEL0(MZ,NZ,MPY,NPY,ICHARG,KARTEZ)
     *                            =BUFCMP
C
                                   END DO ! MPY
                                END DO ! NPY
C
                            END IF ! IDENSI=0
C
                        END DO ! MZ
                     END DO ! NZ
C
                  END DO ! ICHARG
                END DO ! KARTEZ
C
C=======================================================================
C        ABOVE END  LOOPS OVER THE PARTICLE "2" QUANTUM NUMBERS IN Z DIR
C=======================================================================
C        HERE BEGIN LOOPS OVER THE PARTICLE "1" QUANTUM NUMBERS IN Y DIR
C=======================================================================
C
                DO KARTEZ=0,KARLIM
                   DO ICHARG=0,NDISOS
C
                      DO NPY=0,NYMAXX
                         DO MPY=0,NYMAXX
C
                            DO NPZ=0,LAZOFY(NPY)
                               DO MPZ=0,LAZOFY(MPY)
C
                                  BUFCMP = C_ZERO
C
                                  IF (IDENSI.EQ.0) THEN
C
                                      DO NZ=0,LAZOFX(NX)
                                         DO MZ=0,LAZOFX(MX)
C
                                         BUFCMP=BUFCMP
     *                           +Y_HEL0(MZ,NZ,MPY,NPY,ICHARG,KARTEZ)
     *                           *GAU_Z0(MPZ,MZ,NPZ,NZ)
C
                                         END DO ! MZ
                                      END DO ! NZ
C
                                  ELSE
C
                                      DO NZ=0,LAZOFX(NX)
                                         DO MZ=0,LAZOFX(MX)
C
                                         BUFCMP=BUFCMP
     *                           +Y_HEL0(MZ,NZ,MPY,NPY,ICHARG,KARTEZ)
     *                           *GAU_Z0(MPZ,NPZ,MZ,NZ)
c     *                           *GAU_Z0(MPZ,MZ,NPZ,NZ)
C
                                         END DO ! MZ
                                      END DO ! NZ
                                  END IF
C
                                  Z_HE00(MPZ,NPZ,MPY,NPY,ICHARG,KARTEZ)
     *                           =BUFCMP
C
                             END DO ! MPZ
                          END DO ! NPZ
C
                        END DO ! MPY
                     END DO ! NPY
C
                   END DO ! ICHARG
                END DO ! KARTEZ
C
C=======================================================================
C        ABOVE END  LOOPS OVER THE PARTICLE "1" QUANTUM NUMBERS IN Y DIR
C=======================================================================
C        HERE BEGIN LOOPS OVER THE PARTICLE "1" QUANTUM NUMBERS IN X DIR
C=======================================================================
C
C                Preparing the calculation of the expectation value:
C                second trace over \rho and \kappa
C                Z_HE00(MPZ,NPZ,MPY,NPY,ICHARG,KARTEZ) contains
C                \Gamma_{ab} or \Delta_{ab}, with (a,b) := (m',n')
C
C
C         Here we can add an OpenMP parallel do over NPX
C          - local thread storage is small
C          - inside loop over NX and MX
C
                DO NPX=0,NXMAXX
                   DO MPX=0,NXMAXX
C
                      X_HE00(:,:,:,:)=C_ZERO
                      X_HE10(:,:,:,:)=C_ZERO
                      X_HE01(:,:,:,:)=C_ZERO
C
                      DO NPY=0,LAYOFX(NPX)
                         DO MPY=0,LAYOFX(MPX)
C
                            DO NPZ=0,LAZOXY(NPX,NPY)
                               DO MPZ=0,LAZOXY(MPX,MPY)
C
C                                  IBRA asociated with (n') indexes
C                                  IKET asociated with (m') indexes
                                  IBRA=INDICE(NPX,NPY,NPZ)
                                  IKET=INDICE(MPX,MPY,MPZ)
C
C                                  Below: \rho_{np,mp} <-> DEN(IBRA,IKET)
C
	                          IF (IDENSI.EQ.0) THEN
C
                                      DO KARTEP=0,KARLIM
                                         DO ICHARP=ICHLIM,NDISOS
C
#if(USE_COULEX==0)
                                            E_HELP(KARTEP,ICHARP)=
     *
     *                                      DEN_PP(IBRA,IKET,0,ICHARP)*
     *                                          IPHAPP(MPY,NPY,KARTEP)
     *                                     +DEN_PP(IBRA,IKET,1,ICHARP)*
     *                                          IPHAMM(MPY,NPY,KARTEP)
C
                                            IF(ISIMPY.NE.1)
     *
     *                                      E_HELP(KARTEP,ICHARP)=
     *                                      E_HELP(KARTEP,ICHARP)
     *
     *                                     +DEN_PM(IBRA,IKET,0,ICHARP)*
     *                                          IPHAMP(MPY,NPY,KARTEP)
     *                                     +DEN_PM(IBRA,IKET,1,ICHARP)*
     *                                          IPHAPM(MPY,NPY,KARTEP)
#else
                                            E_HELP(KARTEP,ICHARP)=
     *
     *                                      BIG_PP(IBRA,IKET,0)*
     *                                          IPHAPP(MPY,NPY,KARTEP)
     *                                     +BIG_PP(IBRA,IKET,1)*
     *                                          IPHAMM(MPY,NPY,KARTEP)
C
                                            IF(ISIMPY.NE.1)
     *
     *                                      E_HELP(KARTEP,ICHARP)=
     *                                      E_HELP(KARTEP,ICHARP)
     *
     *                                     +BIG_PM(IBRA,IKET,0)*
     *                                          IPHAMP(MPY,NPY,KARTEP)
     *                                     +BIG_PM(IBRA,IKET,1)*
     *                                          IPHAPM(MPY,NPY,KARTEP)
#endif
C
                                         END DO ! ICHARP
                                      END DO ! KARTEP
C
                                      E_HELP(3,0)=E_HELP(3,0)*UNIT_I
                                      E_HELP(3,1)=E_HELP(3,1)*UNIT_I
C
	                          ELSE
C
C                                  Below: \kappa_{np,mp} <-> CHI(IBRA,IKET)
C
                                      DO KARTEP=0,KARLIM
                                         DO ICHARP=ICHLIM,NDISOS
C
                                            E_HELP(KARTEP,ICHARP)=
     *
     *                               -CONJG(CHI_PM(IBRA,IKET,0,ICHARP))
C
                                         END DO ! ICHARP
                                      END DO ! KARTEP
C
                                  END IF
C
                                  DO ICHARG=ICHLIM,NDISOS
                                     DO ICHARP=ICHLIM,NDISOS
                                        DO KARTEZ=0,KARLIM
                                           DO KARTEP=0,KARLIM
C
                           X_HE00(KARTEP,KARTEZ,ICHARP,ICHARG)=
     *                     X_HE00(KARTEP,KARTEZ,ICHARP,ICHARG)
     *                                  +E_HELP(KARTEP,ICHARP)
     *                  *Z_HE00(MPZ,NPZ,MPY,NPY,ICHARG,KARTEZ)
C
                                           END DO ! KARTEP
                                        END DO ! KARTEZ
                                     END DO ! ICHARP
                                  END DO ! ICHARG
C
                               END DO ! MPZ
                            END DO ! NPZ
C
                         END DO ! MPY
                      END DO ! NPY
C
C=======================================================================
C        HERE THE AVERAGE ENERGIES ARE SUMMED UP
C=======================================================================
C
                      DO ICHARG=ICHLIM,NDISOS
                         DO ICHARP=ICHLIM,NDISOS
                            DO KARTEZ=0,KARLIM
                               DO KARTEP=0,KARLIM
C
                                  IF (IDENSI.EQ.0) THEN
                                GAUAVR(0,KARTEP,KARTEZ,ICHARP,ICHARG)
     *                         =GAUAVR(0,KARTEP,KARTEZ,ICHARP,ICHARG)
     *                           +X_HE00(KARTEP,KARTEZ,ICHARP,ICHARG)
     *                           *GAU_X0(MPX,MX,NPX,NX)
                                  ELSE
                                GAUAVR(0,KARTEP,KARTEZ,ICHARP,ICHARG)
     *                         =GAUAVR(0,KARTEP,KARTEZ,ICHARP,ICHARG)
     *                           +X_HE00(KARTEP,KARTEZ,ICHARP,ICHARG)
     *                           *GAU_X0(MPX,NPX,MX,NX)
                                  END IF
C
                              END DO ! KARTEP
                           END DO ! KARTEZ
                         END DO ! ICHARP
                      END DO ! ICHARG
C
                   END DO ! MPX
                END DO ! NPX
C
C=======================================================================
C        ABOVE END  LOOPS OVER THE PARTICLE "1" QUANTUM NUMBERS IN X DIR
C=======================================================================
C
C=======================================================================
C        HERE BEGINS CALCULATION OF THE AVERAGE FIELDS
C=======================================================================
C
                IF (I_FIEL.GE.2) THEN
C
C=======================================================================
C        HERE BEGIN LOOPS OVER THE PARTICLE "1" QUANTUM NUMBERS IN X DIR
C=======================================================================
C
C         Here we can add an OpenMP parallel do over NPX
C          - local thread storage is small
C          - inside loop over NX and MX
C
	            IF (IDENSI.EQ.0) THEN
C
                        DO NPX=0,NXMAXX
                           DO MPX=0,NXMAXX
C
                              DO KARTEZ=0,KARLIM
                                 DO ICHARG=ICHLIM,NDISOS
C
                                    DO NPY=0,LAYOFX(NPX)
                                       DO MPY=0,LAYOFX(MPX)
C
                                          DO NPZ=0,LAZOXY(NPX,NPY)
                                             DO MPZ=0,LAZOXY(MPX,MPY)
C
                                                IBRA=INDICE(MPX,MPY,MPZ)
                                                IKET=INDICE(NPX,NPY,NPZ)
C
                                       GAUFIL(0,IBRA,IKET,KARTEZ,ICHARG)
     *                                =GAUFIL(0,IBRA,IKET,KARTEZ,ICHARG)
     *                            +Z_HE00(MPZ,NPZ,MPY,NPY,ICHARG,KARTEZ)
     *                            *GAU_X0(MPX,MX,NPX,NX)
C
                                             END DO ! MPZ
                                          END DO ! NPZ
C
                                       END DO ! MPY
                                    END DO ! NPY
C
                                 END DO ! ICHARG
                              END DO ! KARTEZ
C
                           END DO ! MPX
                        END DO  ! NPX
C
                    ELSE
C
                        DO NPX=0,NXMAXX
                           DO MPX=0,NXMAXX
C
                              DO KARTEZ=0,KARLIM
                                 DO ICHARG=ICHLIM,NDISOS
C
                                    DO NPY=0,LAYOFX(NPX)
                                       DO MPY=0,LAYOFX(MPX)
C
                                          DO NPZ=0,LAZOXY(NPX,NPY)
                                             DO MPZ=0,LAZOXY(MPX,MPY)
C
                                             IBRA=INDICE(MPX,MPY,MPZ)
                                             IKET=INDICE(NPX,NPY,NPZ)
C
                                    GAUFIL(0,IBRA,IKET,KARTEZ,ICHARG)
     *                             =GAUFIL(0,IBRA,IKET,KARTEZ,ICHARG)
     *                         +Z_HE00(MPZ,NPZ,MPY,NPY,ICHARG,KARTEZ)
     *                         *GAU_X0(MPX,NPX,MX,NX)
C
                                             END DO ! MPZ
                                          END DO ! NPZ
C
                                       END DO ! MPY
                                    END DO ! NPY
C
                                 END DO ! ICHARG
                              END DO ! KARTEZ
C
                           END DO ! MPX
                        END DO  ! NPX

                    END IF ! IDENSI=0
C
                END IF ! I_FIELD=2
C
C=======================================================================
C        ABOVE ENDS CALCULATION OF THE AVERAGE FIELDS
C=======================================================================
C
             END DO ! MX
          END DO ! NX
C
      END IF ! I_PART
C
C=======================================================================
C        ABOVE END  LOOPS OVER THE PARTICLE "2" QUANTUM NUMBERS IN X DIR
C=======================================================================
C
C=======================================================================
                       DEALLOCATE (Y_HEL0,Z_HE00)
      IF (I_PART.EQ.0) DEALLOCATE (Y_HEL1,Z_HE10,Z_HE01)
C=======================================================================
C
      CALL CPUTIM('GAUOPT',0)
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE DEFGOG(N_MAXX,ND_MAX,NGAUSS,KARTEZ,
     *                         GOGWID,GAUEL0,GAUEL1)
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      DIMENSION
     *          FACTOR(0:2*NDOSCI+1),
     *          FACTOO(0:2*NDOSCI+1),
     *          FACTOE(0:2*NDOSCI+1)
      DIMENSION
     *          GOGFF0(0:4*NDOSCI),
     *          GOGFF1(0:4*NDOSCI)
      DIMENSION
     *          COFMOS(0:2*NDOSCI  ,0:2*NDOSCI)
      DIMENSION
     *          COFSCA(0:2*NDOSCI+1,0:2*NDOSCI+1)
      DIMENSION
     *          GAUEL0(0:ND_MAX,0:ND_MAX,0:ND_MAX,0:ND_MAX),
     *          GAUEL1(0:ND_MAX,0:ND_MAX,0:ND_MAX,0:ND_MAX)
C
      COMMON
     *       /COEXYZ/ COEF00(0:ND2MAX,0:NDOSCI,0:NDOSCI,1:NDKART),
     *                COEF01(0:ND2MAX,0:NDOSCI,0:NDOSCI,1:NDKART),
     *                COEF11(0:ND2MAX,0:NDOSCI,0:NDOSCI,1:NDKART),
     *                COEF02(0:ND2MAX,0:NDOSCI,0:NDOSCI,1:NDKART)
      COMMON
     *       /SCALNG/ HOMSCA(NDKART)
C
C=======================================================================
C
      CALL CPUTIM('DEFGOG',1)
C
C=======================================================================
C        THIS  SUBROUTINE  CALCULATES  THE  HARMONIC-OSCILLATOR  MATRIX
C        ELEMENTS OF THE TWO-BODY GAUSSIAN INTERACTION IN ONE DIMENSION
C        SEE NOTES NO. 63.
C=======================================================================
C
      IF (N_MAXX.GT.ND_MAX) STOP 'N_MAXX.GT.ND_MAX IN DEFGOG'
      IF (N_MAXX.GT.NDOSCI) STOP 'N_MAXX.GT.NDOSCI IN DEFGOG'
C
      SQ2=SQRT(2.0D0)
C
      SQ4_PI=SQRT(SQRT(4.0D0*ATAN(1.0D0)))
C
C=======================================================================
C          DEFINING FACTORIALS
C=======================================================================
C
      FACTOR(0)=1.0D0
      FACTOO(0)=1.0D0
      FACTOE(0)=1.0D0
C
      DO I=1,2*N_MAXX+1
C
         FACTOR(I)=FACTOR(I-1)*REAL(I,KIND=8)
         FACTOO(I)=FACTOO(I-1)*REAL(2*I-1,KIND=8)
         FACTOE(I)=FACTOE(I-1)*REAL(2*I,KIND=8)
C
      END DO
C
C=======================================================================
C          CALCULATING THE FORM FACTORS OF THE GAUSSIAN INTERACTION WITH
C          RESPECT TO THE K-TH HERMITE POLYNOMIAL H_K^(0):
C
C          GOGFFI= INT DT EXP(-T^2) (T*SQ2)^I H_K^(0)(T)
C                               * EXP[-2*T^2/(B*GOGWID)^2]
C
C          FOR I=0 AND I=2
C=======================================================================
C
      GOGPAR=HOMSCA(KARTEZ)*GOGWID
      FACTO1=GOGPAR**2/(2+GOGPAR**2)
      FACTO2=       -1/(2+GOGPAR**2)
C
      DO K=0,4*N_MAXX
C
C=======================================================================
C          I=0
C=======================================================================
C
         IF (MOD(K,2).EQ.0) THEN
C
             M=K/2
C
             GOGFF0(K) = SQRT(FACTO1)*FACTO2**M
     *                  *SQRT(FACTOO(M))*SQRT(FACTOE(M))/FACTOR(M)
     *                  *SQ4_PI
         ELSE
             GOGFF0(K)=0.0D0
C
         END IF
C
C=======================================================================
C          I=1
C=======================================================================
C
         IF (MOD(K,2).EQ.1) THEN
C
             M=(K-1)/2
C
             GOGFF1(K) = SQRT(FACTO1)**3*FACTO2**M
     *                  *SQRT(FACTOE(M))
     *                  *SQRT(FACTOO(M+1))/FACTOR(M)
     *                  *SQ4_PI
         ELSE
             GOGFF1(K)=0.0D0
C
         END IF
C
      END DO
C
C=======================================================================
C          CALCULATING THE SCALED HERMITE POLYNOMIALS CEFFICIENTS:
C
C          H_K^(0)(T/SQ2) = SUM_L COFSCA(K,L) H_L^(0)(T)
C=======================================================================
C
      DO K=0,2*N_MAXX+1
         DO L=0,K
C
            M=K-L
C
            IF (MOD(M,2).EQ.0) THEN
C
                COFSCA(K,L)=SQRT(FACTOR(K)/FACTOR(L))
     *                     *(-1)**(M/2)/FACTOR(M/2)/SQ2**L/2.0D0**M
            ELSE
                COFSCA(K,L)=0.0D0
            END IF
C
         END DO
      END DO
C
C=======================================================================
C          CALCULATING THE MOSHINSKI COFFICIENTS FOR S=0:
C
C          H_K^(0)(X) * H_L^(0)(Y)
C                  = SUM_S COFMOS(K,L) * H_S^(0)(U) * H_P^(0)(T)
C
C          FOR P=K+L-S, U=(X+Y)/SQ2, T=(X-Y)/SQ2
C
C=======================================================================
C
      DO K=0,2*N_MAXX
         DO L=0,2*N_MAXX
C
            IF (MOD(K+L,2).EQ.0) THEN
C
                M=(K+L)/2
                FACTOM=FACTOE(M)*FACTOO(M)
C
            ELSE
C
                M=(K+L-1)/2
                FACTOM=FACTOE(M)*FACTOO(M+1)
C
            END IF
C
            COFMOS(K,L)=(-1)**L*SQRT(FACTOM/(2.0D0)**(K+L)
     *                                             /FACTOR(K)/FACTOR(L))
C
         END DO
      END DO
C
C=======================================================================
C          CALCULATING THE FINAL MATRIX ELEMENTS
C=======================================================================
C          BELOW, GAUEL0 AND GAUEL1 ARE DIVIDED BY THE FACTORS HOMSCA
C          IN ORDER TO REMOVE THE DIMENSIONAL FACTORS INCLUDED IN THE
C          CALCULATED VALUES OF THE COEFFICINTS COEF00.  IN ADDITION,
C          GAUEL1 IS DIVIDED BY ANOTHER FACTOR HOMSCA,  SO AS TO TAKE
C          INTO ACCOUT THE DIMENSION OF THE  POSITION  VARIABLE  THAT
C          IN THIS TERM MULTIPLIES THE GAUSSIAN INTERACTION.
C=======================================================================
C
      DO N=0,N_MAXX
         DO M=0,N_MAXX
            DO NP=0,N_MAXX
               DO MP=0,N_MAXX
C
                  GAUEL0(NP,MP,N,M)=0.0D0
                  GAUEL1(NP,MP,N,M)=0.0D0
C
                  DO K=0,N+NP
                     DO L=0,M+MP
C
                        IF (MOD(K+L,2).EQ.0) THEN
C
                            GAUEL0(NP,MP,N,M)=GAUEL0(NP,MP,N,M)
     *                                       +COFMOS(K,L)*GOGFF0(K+L)
     *                                       *COEF00(K,NP,N,KARTEZ)
     *                                       *COEF00(L,MP,M,KARTEZ)
     *                                       /HOMSCA(KARTEZ)
C
                        ELSE
C
                            GAUEL1(NP,MP,N,M)=GAUEL1(NP,MP,N,M)
     *                                       +COFMOS(K,L)*GOGFF1(K+L)
     *                                       *COEF00(K,NP,N,KARTEZ)
     *                                       *COEF00(L,MP,M,KARTEZ)
     *                                       /HOMSCA(KARTEZ)
     *                                       /HOMSCA(KARTEZ)
C
                        END IF
C
                     END DO
                  END DO
C
                  GAUEL0(NP,MP,N,M)=SQ4_PI*GAUEL0(NP,MP,N,M)
                  GAUEL1(NP,MP,N,M)=SQ4_PI*GAUEL1(NP,MP,N,M)
C
               END DO
            END DO
         END DO
      END DO
C
C=======================================================================
C          HERE WE CALL THE SUBROUTINE "TESGOG", WHICH TESTS RESULTS
C          PRODUCED BY THIS SUBROUTINE. THE  CALL  IS  ACTIVATED  BY
C          SETTING I_TEST=1, 2, or 3 BELOW.
C=======================================================================
C
      I_TEST=0
      IF (I_TEST.NE.0) THEN
C
          DO I_KIND=0,1
C
            CALL TESGOG(N_MAXX,ND_MAX,NGAUSS,KARTEZ,
     *                  GOGWID,GAUEL0,GAUEL1,
     *                  FACTOR,FACTOO,FACTOE,
     *                  GOGFF0,GOGFF1,
     *                  COFMOS,COFSCA,
     *                  GOGPAR,
     *                  SQ2,
     *                  I_KIND,I_TEST)
C
          END DO
C
C         STOP 'END OF TESTS IN DEFGOG'
C
      END IF
C
C=======================================================================
C
      CALL CPUTIM('DEFGOG',0)
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE TESGOG(N_MAXX,ND_MAX,NGAUSS,KARTEZ,
     *                  GOGWID,GAUEL0,GAUEL1,
     *                  FACTOR,FACTOO,FACTOE,
     *                  GOGFF0,GOGFF1,
     *                  COFMOS,COFSCA,
     *                  GOGPAR,
     *                  SQ2,
     *                  I_KIND,I_TEST)
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      DIMENSION
     *          FACTOR(0:2*NDOSCI+1),
     *          FACTOO(0:2*NDOSCI+1),
     *          FACTOE(0:2*NDOSCI+1)
      DIMENSION
     *          GOGFF0(0:4*NDOSCI),
     *          GOGFF1(0:4*NDOSCI)
      DIMENSION
     *          COFMOS(0:2*NDOSCI  ,0:2*NDOSCI)
      DIMENSION
     *          COFSCA(0:2*NDOSCI+1,0:2*NDOSCI+1)
      DIMENSION
     *          GAUEL0(0:ND_MAX,0:ND_MAX,0:ND_MAX,0:ND_MAX),
     *          GAUEL1(0:ND_MAX,0:ND_MAX,0:ND_MAX,0:ND_MAX)
      DIMENSION
     *          PHERMI(4*NDOSCI+1),DHERMI(4*NDOSCI+1)
      DIMENSION
     *          HERFAC(0:4*NDOSCI),RESULN(0:4*NDOSCI)
C
      COMMON
     *       /COEFMO/ COEMOS(0:ND0MAX,0:NDOSCI,0:NDOSCI,1:NDKART)
      COMMON
     *       /HERMEM/ HERONE(0:ND2MAX,1:NDGAUS,1:NDKART)
      COMMON
     *       /INTMEM/ TWOWGT(1:NDGAUS,1:NDKART),
     *                TWOPNT(1:NDGAUS,1:NDKART)
      COMMON
     *       /SCALNG/ HOMSCA(NDKART)
C
C=======================================================================
C        THIS SUBROUTINE TESTS RESULTS PRODUCED BY SUBROUTINE "DEFGOG"
C        FOR I_KIND=0 OR 1 THE MATRIX ELEMENTS ARE TESTED FOR I=0 OR 1
C        FOR I_TEST=1 OR 2,3 LESS OR OR MORE OUTPUT IS PRINTED
C=======================================================================
C
      IF (N_MAXX.GT.ND_MAX) STOP 'N_MAXX.GT.ND_MAX IN TESGOG'
      IF (N_MAXX.GT.NDOSCI) STOP 'N_MAXX.GT.NDOSCI IN TESGOG'
C
      PRINT '(/'' TESTS IN TESGOG FOR KARTEZ='',I1,
     *          '' GOGWID='',D15.7,'' GOGPAR='',D15.7)',
     *          KARTEZ,GOGWID,GOGPAR
C
C=======================================================================
C          PRINTING THE FACTORIALS
C=======================================================================
C
      PRINT '(/''  I'',8X,''     FACTORIAL(I)'',
     *                 8X,''ODD  FACTORIAL(I)'',
     *                 8X,''EVEN FACTORIAL(I)''/)'
C
      DO I=1,2*N_MAXX+1
         PRINT '(I3,3(I12,D13.5))',I,INT(FACTOR(I)),FACTOR(I),
     *                               INT(FACTOO(I)),FACTOO(I),
     *                               INT(FACTOE(I)),FACTOE(I)
      END DO
C
C=======================================================================
C          TESTING THE FORM FACTORS OF THE GAUSSIAN INTERACTION AGAINST
C          THE RESULTS OF EXPLICIT NUMERICAL INTEGRATION.  SET I=0 OR 1
C          BELOW TO TEST THE TWO KINDS OF FORM FACTORS.
C=======================================================================
C
      I=I_KIND
C
      PRINT '(////'' TESTS OF FORM FACTORS IN TESGOG FOR I='',I1)',I
C
      NPOINT=300
      RANGE=5.0D0*GOGPAR
      STEP=RANGE/NPOINT
      NMAIN4=4*N_MAXX
      CALL NORFAC(HERFAC,NMAIN4)
C
      PRINT '(/'' NPOINT='',I5,'' RANGE='',F10.5,'' STEP='',F10.5)',
     *      NPOINT,RANGE,STEP
C
      DO KOSCIL = 0,NMAIN4
         RESULN(KOSCIL)=0
      END DO
C
      DO IPOINT = -NPOINT,NPOINT
         XPOINT = STEP * IPOINT
         CALL D_HERM(XPOINT,NMAIN4,PHERMI,DHERMI,4*NDOSCI+1)
C
         DO KOSCIL = 0,NMAIN4
            RESULN(KOSCIL)=RESULN(KOSCIL)+STEP*EXP(-XPOINT**2)
     *                                   *(XPOINT*SQ2)**I
     *                                  *PHERMI(KOSCIL+1)/HERFAC(KOSCIL)
     *                                   *EXP(-2*XPOINT**2/GOGPAR**2)
C
         END DO
      END DO
C
      PRINT '(/'' KOSCIL '','' NUMERICAL  RESULT '',
     *                      '' ANALYTICAL RESULT '',
     *                      '' RELATIVE DIFFERENCE''/)'
C
      DIFMAX=0
      DO KOSCIL = 0,NMAIN4
         IF (MOD(KOSCIL,2).EQ.I.AND.I.EQ.0) THEN
             PRINT '(I7,3D19.10)',KOSCIL,RESULN(KOSCIL),GOGFF0(KOSCIL),
     *                    (RESULN(KOSCIL)-GOGFF0(KOSCIL))/RESULN(KOSCIL)
                DIFMAX=MAX(DIFMAX,ABS((RESULN(KOSCIL)-GOGFF0(KOSCIL))
     *                                                 /RESULN(KOSCIL)))
         END IF
         IF (MOD(KOSCIL,2).EQ.I.AND.I.EQ.1) THEN
             PRINT '(I7,3D19.10)',KOSCIL,RESULN(KOSCIL),GOGFF1(KOSCIL),
     *                    (RESULN(KOSCIL)-GOGFF1(KOSCIL))/RESULN(KOSCIL)
                DIFMAX=MAX(DIFMAX,ABS((RESULN(KOSCIL)-GOGFF1(KOSCIL))
     *                                                 /RESULN(KOSCIL)))
         END IF
      END DO
C
      PRINT '(/'' MAXIMUM RELATIVE DIFFERENCE='',D19.10)',DIFMAX
C
C=======================================================================
C          TESTING THE SCALED HERMITE POLYNOMIALS CEFFICIENTS AGAINST
C          THE EXPLICIT SUMMATION OF THE HERMITE POLYNOMIALS.
C=======================================================================
C
      PRINT '(//'' TESTS OF SCALED HERMITE POLYNOMIALS IN TESGOG'')'
C
      NMAIN2=2*N_MAXX
      CALL NORFAC(HERFAC,NMAIN2)
C
      XPOINT=1.5
      PRINT '(/'' XPOINT='',F10.5)',XPOINT
C
      CALL D_HERM(XPOINT,NMAIN2,PHERMI,DHERMI,4*NDOSCI+1)
C
      DO KOSCIL = 0,NMAIN2
         RESULN(KOSCIL)=0
         DO LOSCIL = 0,KOSCIL
            RESULN(KOSCIL)=RESULN(KOSCIL)+COFSCA(KOSCIL,LOSCIL)
     *                                  *PHERMI(LOSCIL+1)/HERFAC(LOSCIL)
         END DO
      END DO
C
      XPOINT=XPOINT/SQ2
C
      CALL D_HERM(XPOINT,NMAIN2,PHERMI,DHERMI,4*NDOSCI+1)
C
      PRINT '(/'' KOSCIL '','' RESULT OF SUMATION'',
     *                      '' ANALYTICAL RESULT '',
     *                      '' RELATIVE DIFFERENCE''/)'
C
      DIFMAX=0
      DO KOSCIL = 0,NMAIN2
         PRINT '(I7,3D19.10)',KOSCIL,RESULN(KOSCIL),
     *                               PHERMI(KOSCIL+1)/HERFAC(KOSCIL),
     *                  (RESULN(KOSCIL)-PHERMI(KOSCIL+1)/HERFAC(KOSCIL))
     *                                                  /RESULN(KOSCIL)
                DIFMAX=MAX(DIFMAX,ABS((RESULN(KOSCIL)-PHERMI(KOSCIL+1)
     *                                                 /HERFAC(KOSCIL))
     *                                                 /RESULN(KOSCIL)))
      END DO
C
C
      PRINT '(/'' MAXIMUM RELATIVE DIFFERENCE='',D19.10)',DIFMAX
C
C=======================================================================
C          TESTING THE THE MOSHINSKI COEFFICIENTS AGAINST THE  EXPLICIT
C          EXPRESSION DERIVED IN 63-B.  SET I=0 OR 1 ABOVE TO TEST THE
C          MOSHINSKI COEFFICIENTS FOR EVEN AND ODD K+L, RESPECTIVELY.
C=======================================================================
C
      PRINT '(//'' TESTS OF THE MOSHINSKI COEFFICIENTS FROM DEFGOG'',
     *          '' IN TESGOG FOR I='',I1)',I
C
      IF (I_TEST.EQ.2)
     *    PRINT '(/''   K   L  '','' RESULT OF DEFGOG  '',
     *                            '' ANALYTICAL RESULT '',
     *                            '' RELATIVE DIFFERENCE''/)'
C
      DIFMAX=0
      DO K = 0,NMAIN2
         DO L = 0,NMAIN2
C
            RESULT=0.0D0
C
            IF (MOD(K+L,2).EQ.0) THEN
C
                DO M=0,MIN(K,L)
C
                   RESULT=RESULT+COFSCA(K,M)*COFSCA(L,M)
C
                END DO
C
                M=(K+L)/2
C
                RESULT=RESULT*(-2.0D0)**M
     *                     *FACTOR(M)/SQRT(FACTOO(M))/SQRT(FACTOE(M))
C
            ELSE
C
                DO M=0,MIN(K,L+1)
C
                   RESULT=RESULT+COFSCA(K,M)*COFSCA(L+1,M)
C
                END DO
C
                M=(K+L-1)/2
C
                RESULT=RESULT*(-2.0D0)**M
     *                     *FACTOR(M)/SQRT(FACTOO(M))/SQRT(FACTOE(M))
     *                     *SQ2*SQRT((L+1.0D0)/(K+L))
C
            END IF
C
            IF (MOD(K+L,2).EQ.I) THEN
                DIFMAX=MAX(DIFMAX,ABS((COFMOS(K,L)-RESULT)/RESULT))
C
                IF (I_TEST.EQ.2)
     *          PRINT '(2I4,5D19.10)',K,L,
     *                                COFMOS(K,L),RESULT,
     *                       (COFMOS(K,L)-RESULT)/RESULT
C    *                        COFMOS(K,L)        /RESULT,
C    *                       (COFMOS(K,L)        /RESULT)**2
C
            END IF
         END DO
      END DO
C
      PRINT '(/'' MAXIMUM RELATIVE DIFFERENCE='',D19.10)',DIFMAX
C
C=======================================================================
C          TESTING THE THE MOSHINSKI COEFFICIENTS AGAINST THOSE
C          CALCULATED IN DEFMOS. SET I=0 OR 1 ABOVE TO TEST THE
C          MOSHINSKI COEFFICIENTS FOR EVEN AND ODD K+L, RESPECTIVELY.
C=======================================================================
C
      PRINT '(//'' TESTS OF THE MOSHINSKI COEFFICIENTS FROM DEFMOS'',
     *          '' IN TESGOG FOR I='',I1)',I
C
      IF (I_TEST.EQ.2)
     *    PRINT '(/''   K   L  '','' RESULT OF DEFGOG  '',
     *                            '' RESULT OF DEFMOS  '',
     *                            '' RELATIVE DIFFERENCE''/)'
C
      DIFMAX=0
      DO K = 0,N_MAXX
         DO L = 0,N_MAXX
C
            RESULT=COEMOS(0,K,L,KARTEZ)
C
            IF (MOD(K+L,2).EQ.I) THEN
                DIFMAX=MAX(DIFMAX,ABS((COFMOS(K,L)-RESULT)/RESULT))
C
                IF (I_TEST.EQ.2)
     *          PRINT '(2I4,5D19.10)',K,L,
     *                                COFMOS(K,L),RESULT,
     *                       (COFMOS(K,L)-RESULT)/RESULT
C    *                        COFMOS(K,L)        /RESULT,
C    *                       (COFMOS(K,L)        /RESULT)**2
C
            END IF
         END DO
      END DO
C
      PRINT '(/'' MAXIMUM RELATIVE DIFFERENCE='',D19.10)',DIFMAX
C
C=======================================================================
C          TESTING THE THE FINAL MATRIX ELEMENTS. SET I=0 OR 1
C          ABOVE TO TEST THE TWO KINDS OF MATRIX ELEMENTS.
C=======================================================================
C
      PRINT '(//'' TESTS OF FINAL MATRIX ELEMS IN TESGOG FOR I='',I1)',I
C
      IF (I_TEST.EQ.3)
     *    PRINT '(/'' NP MP  N  M '','' NUMERICAL  RESULT '',
     *                               '' ANALYTICAL RESULT '',
     *                               '' RELAT. DIFFERENCE '',
     *                               '' ABSOL. DIFFERENCE ''/)'
C
      DIFMAX=0
      DIFMAY=0
      DO N=0,N_MAXX
         DO M=0,N_MAXX
            DO NP=0,N_MAXX
               DO MP=0,N_MAXX
C
               RESULT=0.0D0
C
               DO IGAUSS=1,NGAUSS
                  DO JGAUSS=1,NGAUSS
C
                     RESULT=RESULT+  TWOWGT(IGAUSS,KARTEZ)
     *                              *TWOWGT(JGAUSS,KARTEZ)
     *                           *HERONE(NP,IGAUSS,KARTEZ)
     *                           *HERONE(MP,JGAUSS,KARTEZ)
     *                            *((TWOPNT(IGAUSS,KARTEZ)
     *                              -TWOPNT(JGAUSS,KARTEZ))
     *                                     /HOMSCA(KARTEZ))**I
     *                       *EXP(-((TWOPNT(IGAUSS,KARTEZ)
     *                              -TWOPNT(JGAUSS,KARTEZ))/GOGPAR)**2)
     *                            *HERONE(N,IGAUSS,KARTEZ)
     *                            *HERONE(M,JGAUSS,KARTEZ)
C
                  END DO
               END DO
C
               IF (MOD(NP+MP+N+M,2).EQ.0.AND.I.EQ.0) THEN
C
                   IF (I_TEST.EQ.3)
     *
     *                 PRINT '(4I3,4D19.10)',NP,MP,N,M,
     *                         RESULT,GAUEL0(NP,MP,N,M),
     *                        (RESULT-GAUEL0(NP,MP,N,M))/RESULT,
     *                        (RESULT-GAUEL0(NP,MP,N,M))
C
                      DIFMAX=MAX(DIFMAX,ABS((RESULT-GAUEL0(NP,MP,N,M))
     *                                                         /RESULT))
                      DIFMAY=MAX(DIFMAY,ABS((RESULT-GAUEL0(NP,MP,N,M))))
C
               END IF
C
               IF (MOD(NP+MP+N+M,2).EQ.1.AND.I.EQ.1) THEN
C
                   IF (I_TEST.EQ.3)
     *
     *                 PRINT '(4I3,4D19.10)',NP,MP,N,M,
     *                         RESULT,GAUEL1(NP,MP,N,M),
     *                        (RESULT-GAUEL1(NP,MP,N,M))/RESULT,
     *                        (RESULT-GAUEL1(NP,MP,N,M))
C
                      DIFMAX=MAX(DIFMAX,ABS((RESULT-GAUEL1(NP,MP,N,M))
     *                                                         /RESULT))
                      DIFMAY=MAX(DIFMAY,ABS((RESULT-GAUEL1(NP,MP,N,M))))
               END IF
C
               END DO
            END DO
         END DO
      END DO
C
      PRINT '(/'' MAXIMUM RELATIVE DIFFERENCE='',D19.10)',DIFMAX
      PRINT '(/'' MAXIMUM          DIFFERENCE='',D19.10)',DIFMAY
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE EXCGOG(N_MAXX,ND_MAX,GAUEL0,GAUEL1)
C
      DIMENSION
     *          GAUEL0(0:ND_MAX,0:ND_MAX,0:ND_MAX,0:ND_MAX),
     *          GAUEL1(0:ND_MAX,0:ND_MAX,0:ND_MAX,0:ND_MAX)
C
C=======================================================================
C        THIS  SUBROUTINE  EXCHANGES  THE  HARMONIC-OSCILLATOR   MATRIX
C        ELEMENTS OF THE TWO-BODY GAUSSIAN INTERACTION IN ONE DIMENSION
C=======================================================================
C
      IF (N_MAXX.GT.ND_MAX) STOP 'N_MAXX.GT.ND_MAX IN EXCGOG'
C
C=======================================================================
C          EXCHANGING THE MATRIX ELEMENTS
C=======================================================================
C
      DO NP=0,N_MAXX
         DO MP=0,N_MAXX
            DO N=0,N_MAXX
               DO M=0,N
C
                  VALUNM=GAUEL0(NP,MP,N,M)
                  VALUMN=GAUEL0(NP,MP,M,N)
C
                  GAUEL0(NP,MP,M,N)=VALUNM
                  GAUEL0(NP,MP,N,M)=VALUMN
C
                  VALUNM=GAUEL1(NP,MP,N,M)
                  VALUMN=GAUEL1(NP,MP,M,N)
C
                  GAUEL1(NP,MP,M,N)=VALUNM
                  GAUEL1(NP,MP,N,M)=VALUMN
C
               END DO
            END DO
         END DO
      END DO
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE EXCPAI(N_MAXX,ND_MAX,GAUEL0,GAUEL1)
      DIMENSION
     *          GAUEL0(0:ND_MAX,0:ND_MAX,0:ND_MAX,0:ND_MAX),
     *          GAUEL1(0:ND_MAX,0:ND_MAX,0:ND_MAX,0:ND_MAX)
C
C=======================================================================
C        THIS  SUBROUTINE  EXCHANGES  THE  HARMONIC-OSCILLATOR   MATRIX
C        ELEMENTS OF THE TWO-BODY GAUSSIAN INTERACTION IN ONE DIMENSION
C=======================================================================
C
      IF (N_MAXX.GT.ND_MAX) STOP 'N_MAXX.GT.ND_MAX IN EXCGOG'
C
C=======================================================================
C          EXCHANGING THE MATRIX ELEMENTS
C=======================================================================
C
      DO NP=0,N_MAXX
         DO M=0,N_MAXX
            DO MP=0,N_MAXX
               DO N=0,MP
C
                  VALUNM=GAUEL0(NP,MP,N,M)
                  VALUMN=GAUEL0(NP,N,MP,M)
C
                  GAUEL0(NP,MP,N,M)=VALUMN
                  GAUEL0(NP,N,MP,M)=VALUNM
C
                  VALUNM=GAUEL1(NP,MP,N,M)
                  VALUMN=GAUEL1(NP,N,MP,M)
C
                  GAUEL1(NP,MP,N,M)=VALUMN
                  GAUEL1(NP,N,MP,M)=VALUNM
C
               END DO
            END DO
         END DO
      END DO
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE DEFMOS_(N_MAXX,ND_MAX,KARTEZ)
C=======================================================================
      USE hfodd_sizes
C=======================================================================
#if(SWITCH_QUAD==1)
      REAL*16
     *          RBINOM
#endif
C
C=======================================================================
      ALLOCATABLE :: seed1(:)
      ALLOCATABLE :: seed2(:)
      ALLOCATABLE :: seedt(:)
C=======================================================================
      DIMENSION
     *          DOEMOS(0:ND0MAX,0:NDOSCI,0:NDOSCI,1:NDKART)
      COMMON
     *       /NEWBIR/ RBINOM(0:NDBINO,0:NDBINO)
      COMMON
     *       /COEFMO/ COEMOS(0:ND0MAX,0:NDOSCI,0:NDOSCI,1:NDKART)
C
C=======================================================================
C        THIS  SUBROUTINE  CALCULATES  THE  MOSHINSKI COFFICIENTS:
C
C          H_K^(0)(X) * H_L^(0)(Y)
C                  = SUM_S COEMOS(S,K,L) * H_S^(0)(U) * H_P^(0)(T)
C
C          FOR P=K+L-S, U=(X+Y)/SQ2, T=(X-Y)/SQ2
C
C        SEE NOTES 8.70E
C=======================================================================
C
      IF (N_MAXX.GT.ND_MAX) STOP 'N_MAXX.GT.ND_MAX IN DEFMOS_'
      IF (N_MAXX.GT.NDOSCI) STOP 'N_MAXX.GT.NDOSCI IN DEFMOS_'
C
      ALLOCATE(seed1(2*N_MAXX+2),seed2(2*N_MAXX+2),seedt(2*N_MAXX+2))
      COEMOS(:,:,:,:)=0.0D0
C
      seed1 = 0.0d0
      seed2 = 0.0d0
      seedt = 0.0d0
      seed1(2) = 1.0d0
      two_m12 = 1.0d0 / SQRT(2.0d0)
C
      DO n1=0,N_MAXX

          seed2 = seed1

          ! Promote n2 -> n2 + 1
          DO n2=0,N_MAXX-1
             DO N = 0,(n1 + n2 + 1)
                np = (n1 + n2 + 1) - N
                Nind = N+2
                seedt(Nind) = two_m12
     *      * ( SQRT(N  / (n2 + 1.0d0)) * seed2(Nind - 1)
     *         -SQRT(np / (n2 + 1.0d0)) * seed2(Nind) )
                COEMOS(N,n1,n2+1,KARTEZ)=seedt(Nind)
             END DO
             seed2 = seedt
          END DO

          ! Promote n1 -> n1 + 1
          n2 = 0
          IF (n1 .LE. (N_MAXX-1)) THEN
              DO N = 0,(n1 + n2 + 1)
                 np = (n1 + n2 + 1) - N

                 Nind = N+2

                 seedt(Nind) = two_m12
     *       * ( SQRT(N  / (n1 + 1.0d0)) * seed1(Nind - 1)
     *          +SQRT(np / (n1 + 1.0d0)) * seed1(Nind) )
                 COEMOS(N,n1+1,n2,KARTEZ)=seedt(Nind)
              END DO
              seed1 = seedt
          END IF

      END DO
      COEMOS(0,0,0,:)=1.0D0
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE DEFMOS(N_MAXX,ND_MAX,KARTEZ)
C=======================================================================
      USE hfodd_sizes
C=======================================================================
#if(SWITCH_QUAD==1)
      REAL*16
     *          RBINOM
#endif
C
      COMMON
     *       /NEWBIR/ RBINOM(0:NDBINO,0:NDBINO)
      COMMON
     *       /COEFMO/ COEMOS(0:ND0MAX,0:NDOSCI,0:NDOSCI,1:NDKART)
C
C=======================================================================
C        THIS  SUBROUTINE  CALCULATES  THE  MOSHINSKI COFFICIENTS:
C
C          H_K^(0)(X) * H_L^(0)(Y)
C                  = SUM_S COEMOS(S,K,L) * H_S^(0)(U) * H_P^(0)(T)
C
C          FOR P=K+L-S, U=(X+Y)/SQ2, T=(X-Y)/SQ2
C
C        SEE NOTES 8.70E
C=======================================================================
C
      IF (N_MAXX.GT.ND_MAX) STOP 'N_MAXX.GT.ND_MAX IN DEFMOS'
      IF (N_MAXX.GT.NDOSCI) STOP 'N_MAXX.GT.NDOSCI IN DEFMOS'
C
      DSQRT2=SQRT(2.0D0)
C
C=======================================================================
C
      DO K=0,N_MAXX
         DO L=0,N_MAXX
            DO N=0,K+L
C
C=======================================================================
C        HERE CONTRIBUTIONS FOR EVEN VALUES OF I ARE ADDED
C=======================================================================
C
               COEEVE=0.0D0
C
               DO I=0,N,2
C
                  IF (K-I.GE.0.AND.L-N+I.GE.0) THEN
C
                  COEEVE=COEEVE+SQRT(RBINOM(N,I)*RBINOM(K+L-N,K-I)
     *                              *RBINOM(K,I)*RBINOM(L,N-I))
C
                  END IF
C
               END DO
C
C=======================================================================
C        HERE CONTRIBUTIONS FOR ODD VALUES OF I ARE SUBTREACTED
C=======================================================================
C
               COEODD=0.0D0
C
               IF (N.GT.0) THEN
C
                   DO I=1,N,2
C
                      IF (K-I.GE.0.AND.L-N+I.GE.0) THEN
C
                      COEODD=COEODD+SQRT(RBINOM(N,I)*RBINOM(K+L-N,K-I)
     *                                  *RBINOM(K,I)*RBINOM(L,N-I))
C
                      END IF
C
                   END DO
C
               END IF
C
               COEMOS(N,K,L,KARTEZ)=(-1)**(N-L)
     *                             *(COEEVE-COEODD)/DSQRT2**(K+L)
C
            END DO
         END DO
      END DO
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE SKF_IN(NXHERM,NYHERM,NZHERM,IROTAT)
C=======================================================================
      USE BROYIN
      USE VE_FLD
C=======================================================================
      USE hfodd_sizes
C=======================================================================
C
      COMMON
     *       /DENEXP/ EXPAUX(NDXHRM,NDYHRM,NDZHRM)
C
      COMMON
     *       /BROTEN/ KSCALA,KVECTO,KTENSO,KLIPKI
     *       /BROSIZ/ NSCALR,NVECTO,NTENSO,NMATRI
C
C=======================================================================
C        THIS SUBROUTINE STORES OLD PARTICLE-HOLE FIELDS TO BE USED
C        IN THE BROYDEN METHOD
C=======================================================================
C
      INDEXX=KLIPKI
C
      DO IZ=1,NZHERM
         DO IY=1,NYHERM
            DO IX=1,NXHERM
C
               INDEXX=INDEXX+1
C
               BRO_IN(INDEXX)         =REAL(VE_MAS(IX,IY,IZ,0))
     *                                *EXPAUX(IX,IY,IZ)
               BRO_IN(INDEXX+  NSCALR)=REAL(VE_MAS(IX,IY,IZ,1))
     *                                *EXPAUX(IX,IY,IZ)
C
               BRO_IN(INDEXX+2*NSCALR)=REAL(VE_CEN(IX,IY,IZ,0))
     *                                *EXPAUX(IX,IY,IZ)
               BRO_IN(INDEXX+3*NSCALR)=REAL(VE_CEN(IX,IY,IZ,1))
     *                                *EXPAUX(IX,IY,IZ)
C
            END DO
         END DO
      END DO
C
      IF (IROTAT.EQ.1) THEN
C
          INDEXX=KLIPKI+KSCALA
C
          DO K=1,NDKART
C
             DO IZ=1,NZHERM
                DO IY=1,NYHERM
                   DO IX=1,NXHERM
C
                      INDEXX=INDEXX+1
C
                      BRO_IN(INDEXX)
     *                 =REAL(VE_CUR(IX,IY,IZ,K,0))
     *                      *EXPAUX(IX,IY,IZ)
                      BRO_IN(INDEXX+  NVECTO)
     *                 =REAL(VE_CUR(IX,IY,IZ,K,1))
     *                      *EXPAUX(IX,IY,IZ)
C
                      BRO_IN(INDEXX+2*NVECTO)
     *                 =REAL(VE_KIS(IX,IY,IZ,K,0))
     *                      *EXPAUX(IX,IY,IZ)
                      BRO_IN(INDEXX+3*NVECTO)
     *                 =REAL(VE_KIS(IX,IY,IZ,K,1))
     *                      *EXPAUX(IX,IY,IZ)
C
                      BRO_IN(INDEXX+4*NVECTO)
     *                 =REAL(VE_SPI(IX,IY,IZ,K,0))
     *                      *EXPAUX(IX,IY,IZ)
                      BRO_IN(INDEXX+5*NVECTO)
     *                 =REAL(VE_SPI(IX,IY,IZ,K,1))
     *                      *EXPAUX(IX,IY,IZ)
C
                   END DO
                END DO
             END DO
C
          END DO
C
      END IF
C
      INDEXX=KLIPKI+KSCALA+KVECTO
C
      DO L=1,NDKART
         DO K=1,NDKART
C
            DO IZ=1,NZHERM
               DO IY=1,NYHERM
                  DO IX=1,NXHERM
C
                     INDEXX=INDEXX+1
C
                     BRO_IN(INDEXX)
     *                =REAL(VE_SOR(IX,IY,IZ,K,L,0))
     *                     *EXPAUX(IX,IY,IZ)
                     BRO_IN(INDEXX+NTENSO)
     *                =REAL(VE_SOR(IX,IY,IZ,K,L,1))
     *                     *EXPAUX(IX,IY,IZ)
C
                  END DO
               END DO
            END DO
C
         END DO
      END DO
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE SKF_OU(NXHERM,NYHERM,NZHERM,IROTAT)
C=======================================================================
      USE BROYOU
      USE VE_FLD
C=======================================================================
      USE hfodd_sizes
C=======================================================================
C
      COMMON
     *       /DENEXP/ EXPAUX(NDXHRM,NDYHRM,NDZHRM)
C
      COMMON
     *       /BROTEN/ KSCALA,KVECTO,KTENSO,KLIPKI
     *       /BROSIZ/ NSCALR,NVECTO,NTENSO,NMATRI
C
C=======================================================================
C        THIS SUBROUTINE STORES NEW PARTICLE-HOLE FIELDS TO BE USED
C        IN THE BROYDEN METHOD
C=======================================================================
C
      INDEXX=KLIPKI
C
      DO IZ=1,NZHERM
         DO IY=1,NYHERM
            DO IX=1,NXHERM
C
               INDEXX=INDEXX+1
C
               BRO_OU(INDEXX)
     *          =REAL(VE_MAS(IX,IY,IZ,0))*EXPAUX(IX,IY,IZ)
               BRO_OU(INDEXX+  NSCALR)
     *          =REAL(VE_MAS(IX,IY,IZ,1))*EXPAUX(IX,IY,IZ)
C
               BRO_OU(INDEXX+2*NSCALR)
     *          =REAL(VE_CEN(IX,IY,IZ,0))*EXPAUX(IX,IY,IZ)
               BRO_OU(INDEXX+3*NSCALR)
     *          =REAL(VE_CEN(IX,IY,IZ,1))*EXPAUX(IX,IY,IZ)
C
            END DO
         END DO
      END DO
C
      IF (IROTAT.EQ.1) THEN
C
          INDEXX=KLIPKI+KSCALA
C
          DO K=1,NDKART
C
             DO IZ=1,NZHERM
                DO IY=1,NYHERM
                   DO IX=1,NXHERM
C
                      INDEXX=INDEXX+1
C
                      BRO_OU(INDEXX)
     *                 =REAL(VE_CUR(IX,IY,IZ,K,0))
     *                      *EXPAUX(IX,IY,IZ)
                      BRO_OU(INDEXX+  NVECTO)
     *                 =REAL(VE_CUR(IX,IY,IZ,K,1))
     *                      *EXPAUX(IX,IY,IZ)
C
                      BRO_OU(INDEXX+2*NVECTO)
     *                 =REAL(VE_KIS(IX,IY,IZ,K,0))
     *                      *EXPAUX(IX,IY,IZ)
                      BRO_OU(INDEXX+3*NVECTO)
     *                 =REAL(VE_KIS(IX,IY,IZ,K,1))
     *                      *EXPAUX(IX,IY,IZ)
C
                      BRO_OU(INDEXX+4*NVECTO)
     *                 =REAL(VE_SPI(IX,IY,IZ,K,0))
     *                      *EXPAUX(IX,IY,IZ)
                      BRO_OU(INDEXX+5*NVECTO)
     *                 =REAL(VE_SPI(IX,IY,IZ,K,1))
     *                      *EXPAUX(IX,IY,IZ)
C
                   END DO
                END DO
             END DO
C
          END DO
C
      END IF
C
      INDEXX=KLIPKI+KSCALA+KVECTO
C
      DO L=1,NDKART
         DO K=1,NDKART
C
            DO IZ=1,NZHERM
               DO IY=1,NYHERM
                  DO IX=1,NXHERM
C
                     INDEXX=INDEXX+1
C
                     BRO_OU(INDEXX)
     *                =REAL(VE_SOR(IX,IY,IZ,K,L,0))
     *                     *EXPAUX(IX,IY,IZ)
                     BRO_OU(INDEXX+NTENSO)
     *                =REAL(VE_SOR(IX,IY,IZ,K,L,1))
     *                     *EXPAUX(IX,IY,IZ)
C
                  END DO
               END DO
            END DO
C
         END DO
      END DO
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE LINMIX(ITERUN,NUMITE,IPCONT,IWRIOL,TERMNT,IF_THO,
     *                                       SLOWEV,SLOWOD,SLOWPA,
     *                                       XOLDEV,XOLDOD,XOLDPA)
C=======================================================================
      LOGICAL
     *          TERMNT
C
      COMMON
     *       /BROINI/ IBROYD,N_ITER
     *       /BROMAT/ NOIINP,MIXMAT
C
C=======================================================================
C        THIS SUBROUTINE DETERMINES THE LINEAR MIXING FACTORS
C=======================================================================
C
C=======================================================================
C        HERE WE TAKE CARE OF THE START-UP ITERATION, FOR WHICH THE
C        OLD FIELDS DO NOT EXIST YET.
C=======================================================================
C
                       NBROYD=IBROYD
      IF (NUMITE.EQ.0) NBROYD=0
C
      IF (NUMITE.EQ.0.OR.NBROYD.GE.1
     *               .OR.IF_THO.GE.1
     *               .OR.MIXMAT.NE.0) THEN
          XOLDEV=0.0
          XOLDOD=0.0
      ELSE
          XOLDEV=SLOWEV
          XOLDOD=SLOWOD
      END IF
C
C=======================================================================
C
      IF (NUMITE.EQ.0.OR.(ITERUN.EQ.1.AND.IPCONT.NE.1)
     *               .OR.NBROYD.GE.1
     *               .OR.IF_THO.GE.1
     *               .OR.MIXMAT.NE.0) THEN
          XOLDPA=0.0
      ELSE
          XOLDPA=SLOWPA
      END IF
C
C=======================================================================
C        HERE WE TAKE CARE OF THE LAST ITERATION, IN WHICH FOR IWRIOL=1
C        THE OLD FIELDS ARE TO BE STORED, WHICH  ALLOWS  FOR  A  SMOOTH
C        CONTINUATION OF ITERATIONS WHEN THE MEAN-FIELD FILE IS USED.
C=======================================================================
C
      IF (IWRIOL.EQ.1.AND.TERMNT) THEN
C
          XOLDEV=1.0D0
          XOLDOD=1.0D0
          XOLDPA=1.0D0
C
      END IF
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE SKFILD(NXHERM,NYHERM,NZHERM,XOLDEV,XOLDOD,IPNMIX)
C=======================================================================
      USE HE_DEN
      USE PD_DEN
      USE VE_FLD
C=======================================================================
      USE hfodd_sizes
C=======================================================================
C
      COMPLEX
     *          XTOTAL,XNEUTR,XPROTO,VNEUTR,VPROTO
      COMPLEX
     *          ANEUTR,APROTO
      COMPLEX
     *          QUNRHO,QUPRHO,QUTRHO,QUNSPI,QUPSPI,QUTSPI
      COMPLEX
     *          DENSIC,DENCHC
      COMPLEX
     *          DENPOW,DENDER,PAID_N,PAID_P
      COMPLEX
     *          DENNEU,DENPRO
      COMPLEX
     *          C_ZERO
C
      DIMENSION
     *          ISIEPS(NDKART,NDKART),INDEPS(NDKART,NDKART)
C
C=======================================================================
      ALLOCATABLE ANEUTR(:,:,:,:)
      ALLOCATABLE APROTO(:,:,:,:)
C=======================================================================
C
      COMMON
     *       /DENTOC/ DENSIC(NDXHRM,NDYHRM,NDZHRM),
     *                DENCHC(NDXHRM,NDYHRM,NDZHRM)
      COMMON
     *       /DENTOT/ DENSIT(NDXHRM,NDYHRM,NDZHRM),
     *                DENCHA(NDXHRM,NDYHRM,NDZHRM)
      COMMON
     *       /DENEXP/ EXPAUX(NDXHRM,NDYHRM,NDZHRM)
C
      COMMON
     *       /CCPSKY/ CRHO_T,CRHO_S,CRHODT,CRHODS,
     *                CLPR_T,CLPR_S,
     *                CTAU_T,CTAU_S,
     *                CSCU_T,CSCU_S,
     *                CDIV_T,CDIV_S,
     *                CSPI_T,CSPI_S,CSPIDT,CSPIDS,
     *                CLPS_T,CLPS_S,
     *                CCUR_T,CCUR_S,
     *                CKIS_T,CKIS_S,
     *                CROT_T,CROT_S
      COMMON
     *       /CCPPAI/ PRHO_N,PRHODN,PRHOSN,POWERN,
     *                PRHO_P,PRHODP,PRHOSP,POWERP
      COMMON
     *       /INTSKY/ T0,X0,T1,X1,T2,X2,T3,X3,W0,POWER
      COMMON
     *       /EXCHAN/ COULEX
      COMMON
     *       /BROINI/ IBROYD,N_ITER
     *       /BROMAT/ NOIINP,MIXMAT
      COMMON
     *       /EDFPAR/ V0NEFF,V0PEFF,COUSCA
C
C=======================================================================
C
      CALL CPUTIM('SKFILD',1)
C
C=======================================================================
C        THE FOLLOWING CONSTRUCTION ALLOWS US TO CALCULATE  CONTRACTIONS
C        WITH THE TOTALLY ANTISYMMETRIC LEVY-CIVITTA TENSOR.
C
C        INDEPS CONTAINS  THE  THIRD  INDEX  FOR  THE  FIRST  TWO GIVEN.
C               (IN  CASE  OF  EQUAL  FIRST  INDICES IT CONTAINS A DUMMY
C                NON-ZERO INDEX VALUE TO AVOID CALLING  MATRIX  ELEMENTS
C                OUTSIDE THE   D E C L A R E D   F O R T R A N   BOUNDS)
C        ISIEPS CONTAINS THE SIGN OF THE TENSOR (+1 OR -1) FOR THE FIRST
C               TWO GIVEN INDICES.
C               (IN  CASE  OF  EQUAL  FIRST  INDICES IT CONTAINS A ZERO.
C                IN  THIS  WAY  THE  INDEX IN INDEPS IS THEN IMMATERIAL)
C=======================================================================
C
      DATA   ISIEPS /  0, -1, +1,
     *                +1,  0, -1,
     *                -1, +1,  0/
C
      DATA   INDEPS /  1,  3,  2,
     *                 3,  2,  1,
     *                 2,  1,  3/
C
C=======================================================================
C        THIS SUBROUTINE CALCULATES THE SKYRME FIELDS BASED ON THE REF.
C        (ENGEL ET AL.) PLUS DERIVATIONS BY  K. BURZYNSKI  (CF. NOTES).
C=======================================================================
C
C        THE EFFECTIVE COUPLING CONSTANTS ARE CODED AS:
C                      'C'//'XXX'//'N'//'TYP'
C
C        WHERE THE SYMBOLS:  'C', 'XXX', 'N', AND 'TYP'
C        ARE EXPLAINED IN THE SUBROUTINE "ESKYRM"
C
C=======================================================================
C
      C_ZERO=CMPLX(0.0D0,0.0D0)
C
C=======================================================================
C
      XNEWOD=1.0D0-XOLDOD
      XNEWEV=1.0D0-XOLDEV
C
C=======================================================================
C
      ALLOCATE(ANEUTR(NDXHRM,NDYHRM,NDZHRM,NDKART))
      ALLOCATE(APROTO(NDXHRM,NDYHRM,NDZHRM,NDKART))
C
      DO IZ=1,NZHERM
         DO IY=1,NYHERM
            DO IX=1,NXHERM
C
               DENPOW=       DENSIC(IX,IY,IZ)**POWER
C
               DENDER= POWER*DENSIC(IX,IY,IZ)**(POWER-1)
     *                      *EXPAUX(IX,IY,IZ)
C
               PAID_N=       POWERN*DENSIC(IX,IY,IZ)**(POWERN-1)
     *                             *EXPAUX(IX,IY,IZ)
               PAID_P=       POWERP*DENSIC(IX,IY,IZ)**(POWERP-1)
     *                             *EXPAUX(IX,IY,IZ)
C
               DENNEU=       DE_RHO(IX,IY,IZ,0)*EXPAUX(IX,IY,IZ)
               DENPRO=       DE_RHO(IX,IY,IZ,1)*EXPAUX(IX,IY,IZ)
C
C=======================================================================
C              S  C  A  L  A  R     F I E L D S     F O L L O W
C=======================================================================
C              EFFECTIVE MASS TERM (SEE: ENGEL ET AL, EQ.(B.2))
C=======================================================================
C
               XTOTAL=CTAU_T*(DE_RHO(IX,IY,IZ,0)
     *                       +DE_RHO(IX,IY,IZ,1))
C
               XNEUTR=CTAU_S* DE_RHO(IX,IY,IZ,0)
C
               XPROTO=CTAU_S* DE_RHO(IX,IY,IZ,1)
C
               VNEUTR = XTOTAL+XNEUTR
               VPROTO = XTOTAL+XPROTO
C
               VE_MAS(IX,IY,IZ,0) =
     *         VE_MAS(IX,IY,IZ,0)*XOLDEV+XNEWEV*VNEUTR
               VE_MAS(IX,IY,IZ,1) =
     *         VE_MAS(IX,IY,IZ,1)*XOLDEV+XNEWEV*VPROTO
C
C=======================================================================
C              CENTRAL TERM (<= T0) - (SEE: ENGEL ET AL, EQ.(B.3))
C=======================================================================
C
               XTOTAL=CRHO_T*(DE_RHO(IX,IY,IZ,0)
     *                       +DE_RHO(IX,IY,IZ,1)) * 2.0D0
C
               XNEUTR=CRHO_S* DE_RHO(IX,IY,IZ,0)  * 2.0D0
               XPROTO=CRHO_S* DE_RHO(IX,IY,IZ,1)  * 2.0D0
C
               VNEUTR = XTOTAL+XNEUTR
               VPROTO = XTOTAL+XPROTO
C
C=======================================================================
C              CENTRAL TERM (<= T1-T2) - (SEE: ENGEL ET AL, EQ.(B.3))
C=======================================================================
C
               XTOTAL=CLPR_T*(DE_LPR(IX,IY,IZ,0)
     *                       +DE_LPR(IX,IY,IZ,1)) * 2.0D0
     *               +CTAU_T*(DE_TAU(IX,IY,IZ,0)
     *                       +DE_TAU(IX,IY,IZ,1))
C
               XNEUTR=CLPR_S* DE_LPR(IX,IY,IZ,0)  * 2.0D0
     *               +CTAU_S* DE_TAU(IX,IY,IZ,0)
C
               XPROTO=CLPR_S* DE_LPR(IX,IY,IZ,1)  * 2.0D0
     *               +CTAU_S* DE_TAU(IX,IY,IZ,1)
C
               VNEUTR = VNEUTR+XTOTAL+XNEUTR
               VPROTO = VPROTO+XTOTAL+XPROTO
C
C=======================================================================
C              CENTRAL TERM (<= T3) - (N O T E THAT THIS IS A DENSITY
C                                      DEPENDENT  TERM  REPLACING THE
C                                      ENGEL'S THREE BODY INTERACTION)
C=======================================================================
C
               XTOTAL=CRHODT*(DE_RHO(IX,IY,IZ,0)
     *                       +DE_RHO(IX,IY,IZ,1)) * 2.0D0 * DENPOW
C
               XNEUTR=CRHODS* DE_RHO(IX,IY,IZ,0)  * 2.0D0 * DENPOW
               XPROTO=CRHODS* DE_RHO(IX,IY,IZ,1)  * 2.0D0 * DENPOW
C
               VNEUTR = VNEUTR+XTOTAL+XNEUTR
               VPROTO = VPROTO+XTOTAL+XPROTO
C
C=======================================================================
C              CENTRAL TERM (<= COULOMB EXCHANGE)
C=======================================================================
C              ATTENTION ---> THE SKYRME FIELDS ARE IN THIS SUBROUTINE
C              CALCULATED WITHOUT THE  EXPONENTIAL  FACTOR. THEREFORE,
C              THE COULOMB EXCHANGE FIELD HAS TO BE EXPLICITLY DIVIDED
C              BY THE "EXPAUX"  ARRAY.
C=======================================================================
C
               XPROTO =  COULEX*COUSCA
     *                * (4.0D0/3.0D0) * DENCHC(IX,IY,IZ)**(1.0D0/3.0D0)
     *                                / EXPAUX(IX,IY,IZ)
C
               VPROTO = VPROTO+XPROTO
C
C=======================================================================
C              CALCULATING  THE  T3 - REARRANGEMENT  TERM
C=======================================================================
C
               QUNRHO = DE_RHO(IX,IY,IZ,0)*DE_RHO(IX,IY,IZ,0)
               QUPRHO = DE_RHO(IX,IY,IZ,1)*DE_RHO(IX,IY,IZ,1)
C
               QUTRHO =(DE_RHO(IX,IY,IZ,0)+DE_RHO(IX,IY,IZ,1))
     *                *(DE_RHO(IX,IY,IZ,0)+DE_RHO(IX,IY,IZ,1))
C
               QUNSPI = C_ZERO
               QUPSPI = C_ZERO
               QUTSPI = C_ZERO
C
               DO K=1,NDKART
C
                  QUNSPI=QUNSPI + DE_SPI(IX,IY,IZ,K,0)
     *                           *DE_SPI(IX,IY,IZ,K,0)
                  QUPSPI=QUPSPI + DE_SPI(IX,IY,IZ,K,1)
     *                           *DE_SPI(IX,IY,IZ,K,1)
C
                  QUTSPI=QUTSPI +(DE_SPI(IX,IY,IZ,K,0)
     *                           +DE_SPI(IX,IY,IZ,K,1))
     *                          *(DE_SPI(IX,IY,IZ,K,0)
     *                           +DE_SPI(IX,IY,IZ,K,1))
C
               END DO
C
               XTOTAL=(CRHODT*QUTRHO+CSPIDT*QUTSPI
     *               + CRHODS*QUNRHO+CSPIDS*QUNSPI
     *               + CRHODS*QUPRHO+CSPIDS*QUPSPI)*DENDER
C
               VNEUTR = VNEUTR+XTOTAL
               VPROTO = VPROTO+XTOTAL
C
C=======================================================================
C              CALCULATING  THE  T3 - PAIRING REARRANGEMENT  TERM
C=======================================================================
C
               QUNRHO = PD_RHO(IX,IY,IZ,0)*CONJG(PD_RHO(IX,IY,IZ,0))
               QUPRHO = PD_RHO(IX,IY,IZ,1)*CONJG(PD_RHO(IX,IY,IZ,1))
C
               XTOTAL=(PRHODN*QUNRHO*PAID_N
     *               + PRHODP*QUPRHO*PAID_P)/ 4
C
               VNEUTR = VNEUTR+XTOTAL
               VPROTO = VPROTO+XTOTAL
C
C=======================================================================
C              CENTRAL TERM (<= W0) - (SEE: ENGEL ET AL, EQ.(B.3))
C=======================================================================
C
               XTOTAL=CDIV_T*(DE_DIV(IX,IY,IZ,0)
     *                      + DE_DIV(IX,IY,IZ,1))
C
               XNEUTR=CDIV_S* DE_DIV(IX,IY,IZ,0)
               XPROTO=CDIV_S* DE_DIV(IX,IY,IZ,1)
C
               VNEUTR = VNEUTR+XTOTAL+XNEUTR
               VPROTO = VPROTO+XTOTAL+XPROTO
C
               VE_CEN(IX,IY,IZ,0) =
     *         VE_CEN(IX,IY,IZ,0)*XOLDEV+XNEWEV*VNEUTR
               VE_CEN(IX,IY,IZ,1) =
     *         VE_CEN(IX,IY,IZ,1)*XOLDEV+XNEWEV*VPROTO
C
            END DO
         END DO
      END DO
C
      DO K=1,NDKART
C
         DO IZ=1,NZHERM
            DO IY=1,NYHERM
               DO IX=1,NXHERM
C
                  DENPOW=DENSIC(IX,IY,IZ)**POWER
C
                  DENNEU=DE_RHO(IX,IY,IZ,0)*EXPAUX(IX,IY,IZ)
                  DENPRO=DE_RHO(IX,IY,IZ,1)*EXPAUX(IX,IY,IZ)
C
C=======================================================================
C              V  E  C  T  O  R    F  I  E  L  D  S    F O L L O W
C=======================================================================
C
C=======================================================================
C                 CURRENT TERM (<= T1-T2) - (SEE: ENGEL ET AL, EQ.(B.5))
C=======================================================================
C
                  XTOTAL=+CCUR_T*(DE_CUR(IX,IY,IZ,K,0)
     *                           +DE_CUR(IX,IY,IZ,K,1)) * 2.0D0
C
                  XNEUTR=+CCUR_S* DE_CUR(IX,IY,IZ,K,0)  * 2.0D0
                  XPROTO=+CCUR_S* DE_CUR(IX,IY,IZ,K,1)  * 2.0D0
C
                  VNEUTR=XTOTAL+XNEUTR
                  VPROTO=XTOTAL+XPROTO
C
C=======================================================================
C                 CURRENT TERM (<= W0) - (SEE: ENGEL ET AL, EQ.(B.5))
C=======================================================================
C
                  XTOTAL=+CROT_T*(DE_ROS(IX,IY,IZ,K,0)
     *                           +DE_ROS(IX,IY,IZ,K,1))
C
                  XNEUTR=+CROT_S* DE_ROS(IX,IY,IZ,K,0)
                  XPROTO=+CROT_S* DE_ROS(IX,IY,IZ,K,1)
C
                  VNEUTR=VNEUTR+XTOTAL+XNEUTR
                  VPROTO=VPROTO+XTOTAL+XPROTO
C
                  VE_CUR(IX,IY,IZ,K,0)=VE_CUR(IX,IY,IZ,K,0)*XOLDOD
     *                              +VNEUTR            *XNEWOD
                  VE_CUR(IX,IY,IZ,K,1)=VE_CUR(IX,IY,IZ,K,1)*XOLDOD
     *                              +VPROTO            *XNEWOD
C
C=======================================================================
C                 KINET.SPIN TERM (<= T1-T2) - (SEE: ENGEL ET AL, (B.6))
C=======================================================================
C
                  XTOTAL=+CKIS_T*(DE_SPI(IX,IY,IZ,K,0)
     *                           +DE_SPI(IX,IY,IZ,K,1))
C
                  XNEUTR=+CKIS_S* DE_SPI(IX,IY,IZ,K,0)
                  XPROTO=+CKIS_S* DE_SPI(IX,IY,IZ,K,1)
C
                  VNEUTR=XTOTAL+XNEUTR
                  VPROTO=XTOTAL+XPROTO
C
                  VE_KIS(IX,IY,IZ,K,0)=VE_KIS(IX,IY,IZ,K,0)*XOLDOD
     *                              +VNEUTR            *XNEWOD
                  VE_KIS(IX,IY,IZ,K,1)=VE_KIS(IX,IY,IZ,K,1)*XOLDOD
     *                              +VPROTO            *XNEWOD
C
C=======================================================================
C                 SPIN TERM (<= T0) - (SEE: ENGEL ET AL, EQ.(B.7))
C=======================================================================
C
                  XTOTAL=+CSPI_T*(DE_SPI(IX,IY,IZ,K,0)
     *                           +DE_SPI(IX,IY,IZ,K,1)) * 2.0D0
C
                  XNEUTR=+CSPI_S* DE_SPI(IX,IY,IZ,K,0)  * 2.0D0
                  XPROTO=+CSPI_S* DE_SPI(IX,IY,IZ,K,1)  * 2.0D0
C
                  VNEUTR=XTOTAL+XNEUTR
                  VPROTO=XTOTAL+XPROTO
C
C=======================================================================
C                 SPIN TERM (<= T1-T2) - (SEE: ENGEL ET AL, EQ.(B.7))
C=======================================================================
C
                  XTOTAL=+CKIS_T*(DE_KIS(IX,IY,IZ,K,0)
     *                           +DE_KIS(IX,IY,IZ,K,1))
     *                   +CLPS_T*(DE_LPS(IX,IY,IZ,K,0)
     *                           +DE_LPS(IX,IY,IZ,K,1)) * 2.0D0
C
                  XNEUTR=+CKIS_S* DE_KIS(IX,IY,IZ,K,0)
     *                   +CLPS_S* DE_LPS(IX,IY,IZ,K,0)  * 2.0D0
C
                  XPROTO=+CKIS_S* DE_KIS(IX,IY,IZ,K,1)
     *                   +CLPS_S* DE_LPS(IX,IY,IZ,K,1)  * 2.0D0
C
                  VNEUTR=VNEUTR+XTOTAL+XNEUTR
                  VPROTO=VPROTO+XTOTAL+XPROTO
C
C=======================================================================
C                 SPIN TERM (<= T3) - (N O T E THAT THIS IS A DENSITY
C                                      DEPENDENT  TERM  REPLACING THE
C                                      ENGEL'S THREE BODY INTERACTION)
C=======================================================================
C
                  XTOTAL=+CSPIDT*(DE_SPI(IX,IY,IZ,K,0)
     *                           +DE_SPI(IX,IY,IZ,K,1)) * 2.0D0 * DENPOW
C
                  XNEUTR=+CSPIDS* DE_SPI(IX,IY,IZ,K,0)  * 2.0D0 * DENPOW
                  XPROTO=+CSPIDS* DE_SPI(IX,IY,IZ,K,1)  * 2.0D0 * DENPOW
C
                  VNEUTR=VNEUTR+XTOTAL+XNEUTR
                  VPROTO=VPROTO+XTOTAL+XPROTO
C
C=======================================================================
C                 SPIN TERM (<= W0) - (SEE: ENGEL ET AL, EQ.(B.7))
C=======================================================================
C
                  XTOTAL=+CROT_T*(DE_ROC(IX,IY,IZ,K,0)
     *                           +DE_ROC(IX,IY,IZ,K,1))
C
                  XNEUTR=+CROT_S* DE_ROC(IX,IY,IZ,K,0)
                  XPROTO=+CROT_S* DE_ROC(IX,IY,IZ,K,1)
C
                  VNEUTR=VNEUTR+XTOTAL+XNEUTR
                  VPROTO=VPROTO+XTOTAL+XPROTO
C
                  VE_SPI(IX,IY,IZ,K,0)=VE_SPI(IX,IY,IZ,K,0)*XOLDOD
     *                              +VNEUTR            *XNEWOD
                  VE_SPI(IX,IY,IZ,K,1)=VE_SPI(IX,IY,IZ,K,1)*XOLDOD
     *                              +VPROTO            *XNEWOD
C
C=======================================================================
C                 S.O. TERM (<= W0) - AUXILIARY FIELD
C=======================================================================
C
                  XTOTAL =-CDIV_T*(DE_GRR(IX,IY,IZ,K,0)
     *                           + DE_GRR(IX,IY,IZ,K,1))
C
                  XNEUTR =-CDIV_S* DE_GRR(IX,IY,IZ,K,0)
                  XPROTO =-CDIV_S* DE_GRR(IX,IY,IZ,K,1)
C
                  ANEUTR(IX,IY,IZ,K)=XTOTAL+XNEUTR
                  APROTO(IX,IY,IZ,K)=XTOTAL+XPROTO
C
               END DO
            END DO
         END DO
C
      END DO
C
      DO L=1,NDKART
         DO K=1,NDKART
C
            DO IZ=1,NZHERM
               DO IY=1,NYHERM
                  DO IX=1,NXHERM
C
C=======================================================================
C                 T  E  N  S  O  R    F  I  E  L  D    F O L L O W S
C=======================================================================
C
C=======================================================================
C                 S.O. TERM (<= T1-T2) - (SEE: ENGEL ET AL, EQ.(B.4))
C=======================================================================
C
                     XTOTAL=+CSCU_T*(DE_SCU(IX,IY,IZ,K,L,0)
     *                              +DE_SCU(IX,IY,IZ,K,L,1))*2.0D0
C
                     XNEUTR=+CSCU_S* DE_SCU(IX,IY,IZ,K,L,0) *2.0D0
                     XPROTO=+CSCU_S* DE_SCU(IX,IY,IZ,K,L,1) *2.0D0
C
                     VNEUTR=XTOTAL+XNEUTR
                     VPROTO=XTOTAL+XPROTO
C
C=======================================================================
C                 S.O. TERM (<= W0) - (SEE: ENGEL ET AL, EQ.(B.4))
C=======================================================================
C
                     VNEUTR=VNEUTR+                ISIEPS(K,L)
     *                            *ANEUTR(IX,IY,IZ,INDEPS(K,L))
                     VPROTO=VPROTO+                ISIEPS(K,L)
     *                            *APROTO(IX,IY,IZ,INDEPS(K,L))
C
                     VE_SOR(IX,IY,IZ,K,L,0)=
     *               VE_SOR(IX,IY,IZ,K,L,0)*XOLDEV+VNEUTR*XNEWEV
                     VE_SOR(IX,IY,IZ,K,L,1)=
     *               VE_SOR(IX,IY,IZ,K,L,1)*XOLDEV+VPROTO*XNEWEV
C
                  END DO
               END DO
            END DO
C
         END DO
      END DO
C
      DEALLOCATE(ANEUTR,APROTO)
C
C=======================================================================
C
      CALL CPUTIM('SKFILD',0)
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE SKPAIR(NXHERM,NYHERM,NZHERM,XOLDPA)
C=======================================================================
      USE PD_DEN
      USE WD_FLD
C=======================================================================
      USE hfodd_sizes
C=======================================================================
C
      COMPLEX
     *          PNEUTR,PPROTO,
     *          XNEUTR,XPROTO
C
      COMMON
     *       /DENTOT/ DENSIT(NDXHRM,NDYHRM,NDZHRM),
     *                DENCHA(NDXHRM,NDYHRM,NDZHRM)
      COMMON
     *       /CCPPAI/ PRHO_N,PRHODN,PRHOSN,POWERN,
     *                PRHO_P,PRHODP,PRHOSP,POWERP
      COMMON
     *       /BROINI/ IBROYD,N_ITER
     *       /BROMAT/ NOIINP,MIXMAT
C
C=======================================================================
C
      CALL CPUTIM('SKPAIR',1)
C
C=======================================================================
C        THIS SUBROUTINE CALCULATES THE PAIRING FIELDS BASED ON THE REF.
C        DOBACZEWSKI ET AL. NP422 (1984) 103 REFERRED TO AS DFT.
C=======================================================================
C        ATTENTION: AT PRESENT, ONLY THE CENTRAL FIELDS COMING FROM  THE
C                   T0 AND T3 TERMS ARE PROGRAMED.
C=======================================================================
C
C        THE EFFECTIVE COUPLING CONSTANTS ARE CODED AS:
C                      'P'//'XXX'//'N'//'TYP'
C
C        WHERE THE SYMBOLS:  'P', 'XXX', 'N', AND 'TYP'
C        ARE EXPLAINED IN THE SUBROUTINE "ESKYRM"
C
C=======================================================================
C
      XNEWPA=1.00D0-XOLDPA
C
      DO IZ=1,NZHERM
         DO IY=1,NYHERM
            DO IX=1,NXHERM
C
C=======================================================================
C              S  C  A  L  A  R     F I E L D S     F O L L O W
C=======================================================================
C=======================================================================
C              CENTRAL TERM (<= T0) - (SEE: DFT EQ.(A5.B))
C=======================================================================
C
               XNEUTR = PRHO_N * PD_RHO(IX,IY,IZ,0) / 2.0D0
               XPROTO = PRHO_P * PD_RHO(IX,IY,IZ,1) / 2.0D0
C
               PNEUTR = XNEUTR
               PPROTO = XPROTO
C
C=======================================================================
C              CENTRAL TERM (<= T3)
C=======================================================================
C
               XNEUTR = PRHODN * PD_RHO(IX,IY,IZ,0) / 2.0D0
     *                         * DENSIT(IX,IY,IZ)**POWERN
               XPROTO = PRHODP * PD_RHO(IX,IY,IZ,1) / 2.0D0
     *                         * DENSIT(IX,IY,IZ)**POWERP
C
               PNEUTR = PNEUTR+XNEUTR
               PPROTO = PPROTO+XPROTO
C
               WD_CEN(IX,IY,IZ,0) = WD_CEN(IX,IY,IZ,0)*XOLDPA
     *                            + XNEWPA*PNEUTR
               WD_CEN(IX,IY,IZ,1) = WD_CEN(IX,IY,IZ,1)
     *                            * XOLDPA+XNEWPA*PPROTO
C
            END DO
         END DO
      END DO
C
C=======================================================================
C
      CALL CPUTIM('SKPAIR',0)
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE SKP_IN(NXHERM,NYHERM,NZHERM)
C=======================================================================
      USE BROYIN
      USE WD_FLD
C=======================================================================
      USE hfodd_sizes
C=======================================================================
C
      COMMON
     *       /DENEXP/ EXPAUX(NDXHRM,NDYHRM,NDZHRM)
      COMMON
     *       /BROTEN/ KSCALA,KVECTO,KTENSO,KLIPKI
     *       /BROSIZ/ NSCALR,NVECTO,NTENSO,NMATRI
C
C=======================================================================
C        THIS SUBROUTINE STORES OLD PAIRING FIELDS TO BE USED IN THE
C        BROYDEN METHOD
C=======================================================================
C
      INDEXX=KLIPKI+KSCALA+KVECTO+KTENSO
C
      DO IZ=1,NZHERM
         DO IY=1,NYHERM
            DO IX=1,NXHERM
C
               INDEXX=INDEXX+1
C
               BRO_IN(INDEXX)         =REAL (WD_CEN(IX,IY,IZ,0))
     *                                      *EXPAUX(IX,IY,IZ)
               BRO_IN(INDEXX+  NSCALR)=AIMAG(WD_CEN(IX,IY,IZ,0))
     *                                      *EXPAUX(IX,IY,IZ)
               BRO_IN(INDEXX+2*NSCALR)=REAL (WD_CEN(IX,IY,IZ,1))
     *                                      *EXPAUX(IX,IY,IZ)
               BRO_IN(INDEXX+3*NSCALR)=AIMAG(WD_CEN(IX,IY,IZ,1))
     *                                      *EXPAUX(IX,IY,IZ)
C
            END DO
         END DO
      END DO
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE SKP_OU(NXHERM,NYHERM,NZHERM)
C=======================================================================
      USE BROYOU
      USE WD_FLD
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      COMPLEX
     *          WN_CEN,WP_CEN
C
      COMMON
     *       /DENEXP/ EXPAUX(NDXHRM,NDYHRM,NDZHRM)
      COMMON
     *       /BROTEN/ KSCALA,KVECTO,KTENSO,KLIPKI
     *       /BROSIZ/ NSCALR,NVECTO,NTENSO,NMATRI
C
C=======================================================================
C        THIS SUBROUTINE STORES NEW PAIRING FIELDS TO BE USED IN THE
C        BROYDEN METHOD
C=======================================================================
C
      INDEXX=KLIPKI+KSCALA+KVECTO+KTENSO
C
      DO IZ=1,NZHERM
         DO IY=1,NYHERM
            DO IX=1,NXHERM
C
               INDEXX=INDEXX+1
C
               BRO_OU(INDEXX)         =REAL (WD_CEN(IX,IY,IZ,0))
     *                                      *EXPAUX(IX,IY,IZ)
               BRO_OU(INDEXX+  NSCALR)=AIMAG(WD_CEN(IX,IY,IZ,0))
     *                                      *EXPAUX(IX,IY,IZ)
               BRO_OU(INDEXX+2*NSCALR)=REAL (WD_CEN(IX,IY,IZ,1))
     *                                      *EXPAUX(IX,IY,IZ)
               BRO_OU(INDEXX+3*NSCALR)=AIMAG(WD_CEN(IX,IY,IZ,1))
     *                                      *EXPAUX(IX,IY,IZ)
C
            END DO
         END DO
      END DO
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE CALBRO_FIELDS(IROTAT,ISIMPY,IPAHFB,LIPKIN,LIPKIP,
     *                         NXHERM,NYHERM,NZHERM,IBROYD,NOFBRO)
C=======================================================================
      USE BROYIN
      USE BROYOU
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      COMMON
     *       /CNSNUM/ NOFCNS
      COMMON
     *       /DIMENS/ LDBASE
      COMMON
     *       /BROTEN/ KSCALA,KVECTO,KTENSO,KLIPKI
     *       /BROSIZ/ NSCALR,NVECTO,NTENSO,NMATRI
      COMMON
     *       /CFIPRI/ NFIPRI
C=======================================================================
C        THIS SUBROUTINE COMPUTES THE EXPECTED SIZE OF THE BROYDEN
C        VECTOR, DEPENDING ON THE OPTIONS CHOSEN BY THE USER (SUCH
C        AS PAIRING, CONSERVED/BROKEN SIMPLEX, LN METHOD, ETC.). BY
C        COMPUTING THE EXACT SIZE OF THE VECTOR, IT OPTIMIZES THE
C        MEMORY USAGE. THE 'IN'AND 'OUT' BROYDEN VECTORS ARE ALLOCA-
C        TED AT THE END OF THE SUBROUTINE. SEVERAL USEFUL NUMBERS
C        ARE ALSO DEFINED HERE.
C=======================================================================
C
      NSCALR=NXHERM*NYHERM*NZHERM
      NVECTO=NXHERM*NYHERM*NZHERM*NDKART
      NTENSO=NXHERM*NYHERM*NZHERM*NDKART*NDKART
C
      NMATRI=4*LDBASE*LDBASE
C
      KSCALA=4*NSCALR ! scalar fields
      KVECTO=6*NVECTO*IROTAT ! vector fields
      KTENSO=2*NTENSO ! tensor fields
C
      IF (IPAHFB.LT.1) THEN
          KPAIRI=0        ! no pairing
      ELSE
          KPAIRI=4*NSCALR ! pairing fields
      END IF
C
      KLIPKI= LIPKIN+LIPKIP
     *      +(LIPKIN+LIPKIP)*NMATRI
     *      +(LIPKIN+LIPKIP)*NMATRI*(1-ISIMPY) ! Lipkin-Nogami
C
      IF (IBROYD.LE.1) THEN
      NOFBRO=KLIPKI+KSCALA+KVECTO+KTENSO+KPAIRI+NOFCNS
      ELSE
          NOFBRO=KLIPKI+KSCALA+KVECTO+KTENSO+KPAIRI
      END IF
C
      IALLOC=0
C
C=======================================================================
      IF (     ALLOCATED(BRO_IN)) DEALLOCATE (BRO_IN)
      IF (.NOT.ALLOCATED(BRO_IN)) THEN
          ALLOCATE (BRO_IN(1:NOFBRO),STAT=IALLOC)
          IF (IALLOC.NE.0) CALL NOALLO('BRO_IN','CALBRO')
      END IF
C=======================================================================
      IF (     ALLOCATED(BRO_OU)) DEALLOCATE (BRO_OU)
      IF (.NOT.ALLOCATED(BRO_OU)) THEN
          ALLOCATE (BRO_OU(1:NOFBRO),STAT=IALLOC)
          IF (IALLOC.NE.0) CALL NOALLO('BRO_OU','CALBRO')
      END IF
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE DOBROY_FIELDS(NXHERM,NYHERM,NZHERM,
     *                                ITERUN,NOFBRO,
     *                                NSWBRO,ITAKEN,
     *                         IROTAT,IPAHFB,SLOWEV,
     *                         ESTABN,IF_RPA,KEPTES)
C=======================================================================
      USE BROYIN
      USE BROYOU
      USE VE_FLD
      USE WD_FLD
C=======================================================================
      USE hfodd_sizes
C=======================================================================
C
C@@@ NECK - NECK - NECK - NECK - NECK - NECK - NECK - NECK - NECK
      COMMON
     *       /NCKVAL/ Q0NECK,G_NECK
     *       /NCKFLA/ IFNECK
C@@@ NECK - NECK - NECK - NECK - NECK - NECK - NECK - NECK - NECK
      COMMON
     *       /CNSOLD/ VECOLD(1:NDCONS)
     *       /CNSQLM/ VECCNS(1:NDCONS)
      COMMON
     *       /CNSCOR/ LAMCNS(1:NDCONS),MIUCNS(1:NDCONS)
     *       /CNSNUM/ NOFCNS
      COMMON
     *       /QLASTR/ GALMUQ(0:NDMULT,-NDMULT:NDMULT),
     *                QLINEA(0:NDMULT,-NDMULT:NDMULT),
     *                IFLALQ(0:NDMULT,-NDMULT:NDMULT)
      COMMON
     *       /DENEXP/ EXPAUX(NDXHRM,NDYHRM,NDZHRM)
      COMMON
     *       /BROTEN/ KSCALA,KVECTO,KTENSO,KLIPKI
     *       /BROSIZ/ NSCALR,NVECTO,NTENSO,NMATRI
      COMMON
     *       /BROINI/ IBROYD,N_ITER
     *       /BROMIX/ ALPHAM,BROTRI
C
C=======================================================================
C
      CALL CPUTIM('DOBROY',1)
C
C=======================================================================
C        THIS SUBROUTINE APPLIES THE BROYDEN METHOD
C=======================================================================
C
C      Adding linear constraints parameters
C
      IF (IF_RPA.GE.1.AND.NOFCNS.GE.1.AND.IBROYD.LE.1) THEN
          DO I=1,NOFCNS
             BRO_IN(NOFBRO-I+1)=VECOLD(I)
             BRO_OU(NOFBRO-I+1)=VECCNS(I)
          END DO
      END IF
C
      SCALEF=1.0
C
C      Automatic switching on of Broyden correction for stability less
C      than BROTRI for 3 consecutive iterations. If condition not met,
C      we continue with standard linear mixing as defined in HFODD input.
C
      IF (ABS(ESTABN).LE.BROTRI.AND.ITAKEN.EQ.0) THEN
C
          KEPTES=KEPTES+1
C
          IF (KEPTES.GE.2) THEN
              NSWBRO=ITERUN-1
              ITAKEN=1
          END IF
C
      END IF
C
C      If Broyden is off, we do standard linear mixing with the slow-down
C      parameter of the time-even fields SLOWEV
C
      ITEACT=ITERUN-NSWBRO
C
C=======================================================================
C      PRIOR TO VERSION 2.49C, "ALCURR"  BELOW WAS SET WRONGLY TO BE
C      EQUAL TO 1-SLOWEV, WHICH MADE THE VARIABLE "ALPHAM" REDUNDANT
C      AND COULD LEAD TO MISUSE OF THE BROYDEN PARAMETERS. THIS  BUG
C      WAS CORRECTED ON 23/09/2010.
C=======================================================================
C
      NSTART=1
      ALCURR=ALPHAM
C
      IF (ITEACT.LT.0) THEN
          NSTART=0
          ALCURR=1.0-SLOWEV
      END IF
C
      W0_BRO=0.01D0
      WN_BRO=1.00D0
C
C=======================================================================
C
      IERROR=0
C
      IF (IBROYD.EQ.1) THEN
          CALL broyden(NOFBRO,NOFBRO,BRO_OU,BRO_IN,ALCURR,dr2,ITEACT,
     *                            N_ITER,W0_BRO,WN_BRO,NSTART,IERROR)
      END IF
C
      IF (IBROYD.EQ.2) THEN
          CALL anderson(NOFBRO,NOFBRO,BRO_OU,BRO_IN,ALCURR,dr2,ITEACT,
     *                                    N_ITER,W0_BRO,WN_BRO,NSTART)
      END IF
C
C=======================================================================
C
C@@@ NECK - NECK - NECK - NECK - NECK - NECK - NECK - NECK - NECK
      IF (IF_RPA.GE.1.AND.NOFCNS.GE.1.AND.IBROYD.LE.1) THEN
C
          IF (IFNECK.LE.1) THEN
C
              DO I=1,NOFCNS
                 LAMBDA=LAMCNS(I)
                 MIU   =MIUCNS(I)
                 GALMUQ(LAMBDA,MIU)=BRO_IN(NOFBRO-I+1)
              END DO
C
          ELSE
C
              DO I=1,NOFCNS-1
                 LAMBDA=LAMCNS(I)
                 MIU   =MIUCNS(I)
                 GALMUQ(LAMBDA,MIU)=BRO_IN(NOFBRO-I+1)
              END DO
              G_NECK=BRO_IN(NOFBRO-NOFCNS+1)
C
	  END IF
C
      END IF
C@@@ NECK - NECK - NECK - NECK - NECK - NECK - NECK - NECK - NECK
C
C      Reconstructing fields from the Broyden vectors
C
C      Scalar fields
C
      INDEXX=KLIPKI
C
      DO IZ=1,NZHERM
         DO IY=1,NYHERM
            DO IX=1,NXHERM
C
               INDEXX=INDEXX+1
C
               VE_MAS(IX,IY,IZ,0)=BRO_IN(INDEXX)
     *                                                 /EXPAUX(IX,IY,IZ)
               VE_MAS(IX,IY,IZ,1)=BRO_IN(INDEXX+  NSCALR)
     *                                                 /EXPAUX(IX,IY,IZ)
C
               VE_CEN(IX,IY,IZ,0)=BRO_IN(INDEXX+2*NSCALR)
     *                                                 /EXPAUX(IX,IY,IZ)
               VE_CEN(IX,IY,IZ,1)=BRO_IN(INDEXX+3*NSCALR)
     *                                                 /EXPAUX(IX,IY,IZ)
C
            END DO
         END DO
      END DO
C
C      Vector fields
C
      IF (IROTAT.NE.0) THEN
C
          INDEXX=KLIPKI+KSCALA
C
          DO K=1,NDKART
C
             DO IZ=1,NZHERM
                DO IY=1,NYHERM
                   DO IX=1,NXHERM
C
                      INDEXX=INDEXX+1
C
                      VE_CUR(IX,IY,IZ,K,0)=BRO_IN(INDEXX)
     *                                                 /EXPAUX(IX,IY,IZ)
                      VE_CUR(IX,IY,IZ,K,1)=BRO_IN(INDEXX+  NVECTO)
     *                                                 /EXPAUX(IX,IY,IZ)
C
                      VE_KIS(IX,IY,IZ,K,0)=BRO_IN(INDEXX+2*NVECTO)
     *                                                 /EXPAUX(IX,IY,IZ)
                      VE_KIS(IX,IY,IZ,K,1)=BRO_IN(INDEXX+3*NVECTO)
     *                                                 /EXPAUX(IX,IY,IZ)
C
                      VE_SPI(IX,IY,IZ,K,0)=BRO_IN(INDEXX+4*NVECTO)
     *                                                 /EXPAUX(IX,IY,IZ)
                      VE_SPI(IX,IY,IZ,K,1)=BRO_IN(INDEXX+5*NVECTO)
     *                                                 /EXPAUX(IX,IY,IZ)
C
                  END DO
               END DO
            END DO
C
         END DO
C
      END IF
C
C      Tensor fields
C
      INDEXX=KLIPKI+KSCALA+KVECTO
C
      DO L=1,NDKART
         DO K=1,NDKART
C
            DO IZ=1,NZHERM
               DO IY=1,NYHERM
                  DO IX=1,NXHERM
C
                  INDEXX=INDEXX+1
C
                  VE_SOR(IX,IY,IZ,K,L,0)=BRO_IN(INDEXX)
     *                                                 /EXPAUX(IX,IY,IZ)
                  VE_SOR(IX,IY,IZ,K,L,1)=BRO_IN(INDEXX+NTENSO)
     *                                                 /EXPAUX(IX,IY,IZ)
C
                  END DO
               END DO
            END DO
C
         END DO
      END DO
C
C      Pairing fields
C
      IF (IPAHFB.EQ.1) THEN
C
          INDEXX=KLIPKI+KSCALA+KVECTO+KTENSO
C
          DO IZ=1,NZHERM
             DO IY=1,NYHERM
                DO IX=1,NXHERM
C
                INDEXX=INDEXX+1
C
                WD_CEN(IX,IY,IZ,0)=CMPLX(BRO_IN(INDEXX),
     *                                 BRO_IN(INDEXX+  NSCALR))
     *                                              /EXPAUX(IX,IY,IZ)
                WD_CEN(IX,IY,IZ,1)=CMPLX(BRO_IN(INDEXX+2*NSCALR),
     *                                 BRO_IN(INDEXX+3*NSCALR))
     *                                              /EXPAUX(IX,IY,IZ)
C
                END DO
             END DO
          END DO
C
      END IF
C
C=======================================================================
C
      CALL CPUTIM('DOBROY',0)
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE CALBRO_MATRIX(MREVER,IROTAT,ISIMPY,IPAHFB,NOFBRN,
     *                                NOFBRP,LIPKIN,LIPKIP,IBROYD)
C=======================================================================
      USE BROYIN_NEUTRON
      USE BROYOU_NEUTRON
      USE BROYIN_PROTON
      USE BROYOU_PROTON
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      COMMON
     *       /DIMENS/ LDBASE
      COMMON
     *       /BRODIM/ N_REAL,N_IMAG,N_TOTA,N_RISO,N_ISOS,NMATRN,NMATRP
C=======================================================================
C        THIS SUBROUTINE COMPUTES THE EXPECTED SIZE OF THE BROYDEN
C        VECTOR, DEPENDING ON THE OPTIONS CHOSEN BY THE USER (SUCH
C        AS PAIRING, CONSERVED/BROKEN SIMPLEX, LN METHOD, ETC.). BY
C        COMPUTING THE EXACT SIZE OF THE VECTOR, IT OPTIMIZES THE
C        MEMORY USAGE. THE 'IN'AND 'OUT' BROYDEN VECTORS ARE ALLOCA-
C        TED AT THE END OF THE SUBROUTINE. SEVERAL USEFUL NUMBERS
C        ARE ALSO DEFINED HERE.
C=======================================================================
C
      N_REAL=LDBASE*(LDBASE+1)/2 ! Number of real elements
                                 ! in a Hermitian matrix
      N_IMAG=LDBASE*(LDBASE-1)/2 ! Number of pure imaginary ones
      N_TOTA=N_REAL+N_IMAG       ! Total number of independent elements
                                 ! in a Hermitian matrix
C
      N_ISOS=(MREVER+1)*N_TOTA ! total for one kind of nucleon only
      N_RISO=(MREVER+1)*N_REAL
C
      NMATRN=N_ISOS
      NMATRP=N_ISOS
C
      NOFBRO=N_ISOS+(1-ISIMPY)*N_ISOS
     *                +IPAHFB *(N_REAL+IROTAT*N_IMAG)
     *                +IPAHFB ! Fermi level
C
      NOFBRN=NOFBRO+LIPKIN*IBROYD
      NOFBRP=NOFBRO+LIPKIP*IBROYD
C
C=======================================================================
C
      IALLOC=0
C
C=======================================================================
      IF (ALLOCATED(BRONIN)) DEALLOCATE(BRONIN,BRONOU)
      IF (.NOT.ALLOCATED(BRONIN)) THEN
          ALLOCATE (BRONIN(1:NOFBRN),STAT=IALLOC)
          IF (IALLOC.NE.0) CALL NOALLO('BRONIN','CALBRO')
      END IF
      IF (.NOT.ALLOCATED(BRONOU)) THEN
          ALLOCATE (BRONOU(1:NOFBRN),STAT=IALLOC)
          IF (IALLOC.NE.0) CALL NOALLO('BRONOU','CALBRO')
      END IF
C
      IF (ALLOCATED(BROPIN)) DEALLOCATE(BROPIN,BROPOU)
      IF (.NOT.ALLOCATED(BROPIN)) THEN
          ALLOCATE (BROPIN(1:NOFBRP),STAT=IALLOC)
          IF (IALLOC.NE.0) CALL NOALLO('BROPIN','CALBRO')
      END IF
      IF (.NOT.ALLOCATED(BROPOU)) THEN
          ALLOCATE (BROPOU(1:NOFBRP),STAT=IALLOC)
          IF (IALLOC.NE.0) CALL NOALLO('BROPOU','CALBRO')
      END IF
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE DOBROY_MATRIX(ITERUN,NSWBRO,ITAKEN,
     *                         NOICAN,SLOWEV,ESTABN,
     *                         EFERMX,EFEXIN,EFEXOU,
     *                         EFER2X,EF2XIN,EF2XOU,
     *                         LIPKIX,NOFBRX,ICHARG,
     *                                       IPAHFB)
C=======================================================================
      USE BROYIN_NEUTRON
      USE BROYOU_NEUTRON
      USE BROYIN_PROTON
      USE BROYOU_PROTON
C=======================================================================
      COMMON
     *       /BRODIM/ N_REAL,N_IMAG,N_TOTA,N_RISO,N_ISOS,NMATRN,NMATRP
      COMMON
     *       /BROINI/ IBROYD,N_ITER
     *       /BROMIX/ ALPHAM,BROTRI
     *       /BROMAT/ NOIINP,MIXMAT
C
C=======================================================================
C
      CALL CPUTIM('DOBROY',1)
C
C=======================================================================
C        THIS SUBROUTINE APPLIES THE BROYDEN METHOD
C=======================================================================
C
      SCALEF=1.0
C
      XNNORM=0.0D0
      XPNORM=0.0D0
C
      N_TRUE=NOFBRX
C
C      In addition to matrix elements, the Broyden vectors
C      contain the Fermi level (HFB only) and the lambda_2
C      parameter (HFB+LN only).
C
      IF (IPAHFB.EQ.1) THEN
C
          IF (ICHARG.EQ.0) THEN
C
              BRONIN(NOFBRX)=EFEXIN
              BRONOU(NOFBRX)=EFEXOU
C
              IF (LIPKIX.EQ.1.AND.IBROYD.GE.1) THEN
                  BRONIN(NOFBRX-1)=EF2XIN
                  BRONOU(NOFBRX-1)=EF2XOU
              END IF
C
          ELSE
C
              BROPIN(NOFBRX)=EFEXIN
              BROPOU(NOFBRX)=EFEXOU
C
              IF (LIPKIX.EQ.1.AND.IBROYD.GE.1) THEN
                  BROPIN(NOFBRX-1)=EF2XIN
                  BROPOU(NOFBRX-1)=EF2XOU
              END IF
C
          END IF
      END IF
C
C      By default, NSWBRO=1000000, so that NSTART=0
C      in the Broyden routines, an only a very standard
C      linear mixing is performed. When stability is less
C      than BROTRI, we switch on the broyden routine
C
      IF (ABS(ESTABN).LT.BROTRI.AND.ITAKEN.EQ.0.AND.IBROYD.GE.1) THEN
          NSWBRO=ITERUN
          ITAKEN=1
      END IF
C
C      When the Broyden routine is already switched on, it
C      is sometimes advantageous to erase the Broyden vector
C      every now and then. This reduces the numerical noise
C      which is produced when mixing matrix elements. When
C      the current number of iterations is a multiple of
C      NOICAN, the Broyden memory is erased.
C
      IF (ITAKEN.EQ.1.AND.MOD(ITERUN,NOICAN).EQ.0.AND.IBROYD.GE.1) THEN
          NSWBRO=ITERUN
      END IF
C
C      In practice, ITEACT controls whether or not the Broyden
C      procedure is switched on or off. When off (ITEACT <= 0),
C      standard linear mixing is done.
C
      ITEACT=ITERUN-NSWBRO
C
      NSTART=1
      ALCURR=ALPHAM
C
      IF (ITEACT.LE.0) THEN
          NSTART=0
          ALCURR=1.0-SLOWEV
      END IF
C
      W0_BRO=0.01
      WN_BRO=1.00
C
C=======================================================================
      IF (ICHARG.EQ.0)
     *CALL broyden_n(N_TRUE,N_TRUE,BRONOU,BRONIN,ALCURR,dr2,ITEACT,
     *                               N_ITER,W0_BRO,WN_BRO,NSTART)
C=======================================================================
      IF (ICHARG.EQ.1)
     *CALL broyden_p(N_TRUE,N_TRUE,BROPOU,BROPIN,ALCURR,dr2,ITEACT,
     *                               N_ITER,W0_BRO,WN_BRO,NSTART)
C=======================================================================
C
      IF (IPAHFB.EQ.1) THEN
C
          IF (ICHARG.EQ.0) THEN
                  EFERMX=BRONIN(NOFBRX)
              IF (LIPKIX.EQ.1.AND.IBROYD.GE.1) THEN
                  EFER2X=BRONIN(NOFBRX-1)
              END IF
          ELSE
                  EFERMX=BROPIN(NOFBRX)
              IF (LIPKIX.EQ.1.AND.IBROYD.GE.1) THEN
                  EFER2X=BROPIN(NOFBRX-1)
              END IF
          END IF
C
      END IF
C
C=======================================================================
C
      CALL CPUTIM('DOBROY',0)
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE HPH_IN(ISIMPY,MREVER,ICHARG,NUMITE,INDJOB)
C=======================================================================
      USE BROYIN_NEUTRON
      USE BROYOU_NEUTRON
      USE BROYIN_PROTON
      USE BROYOU_PROTON
      USE MAT_PP
      USE MAT_PM
      USE MAF_PP
      USE MAF_PM
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      COMMON
     *       /DIMENS/ LDBASE
      COMMON
     *       /BRODIM/ N_REAL,N_IMAG,N_TOTA,N_RISO,N_ISOS,NMATRN,NMATRP
C
C=======================================================================
C      THIS SUBROUTINE UPDATES THE 'IN' AND 'OUT' BROYDEN VECTORS
C      WITH THE P-H PART OF THE HFB MATRIX. THIS IS DONE SEPARATELY
C      FOR NEUTRONS AND PROTONS. SINCE THE P-H PART OF THE HFB MATRIX
C      IS HERMITIAN, ONLY THE INDEPENDENT MATRIX ELEMENTS NEED TO BE
C      CONSIDERED. ALSO, IN HFODD, THIS MATRIX IS COMPLEX, SO THE
C      REAL PART AND IMAGINARY PART ARE CONSIDERED INDEPENDENT.
C=======================================================================
C
      IF (ICHARG.EQ.0) THEN
C
          DO IREVER=0,MREVER
C
             INDEXX=0
             INDIMA=0
C
             DO J=1,LDBASE
C
                INDEXX=INDEXX+1
C
                BRONIN(INDEXX+IREVER*N_TOTA)
     *                  =REAL(FIL_PP(J,J,IREVER,ICHARG))
                BRONOU(INDEXX+IREVER*N_TOTA)
     *                  =REAL(BIG_PP(J,J,IREVER))
C
                DO I=J+1,LDBASE
C
                   INDEXX=INDEXX+1
                   INDIMA=INDIMA+1
C
                   BRONIN(INDEXX+IREVER*N_TOTA)
     *                  =REAL(FIL_PP(I,J,IREVER,ICHARG))
                   BRONOU(INDEXX+IREVER*N_TOTA)
     *                  =REAL(BIG_PP(I,J,IREVER))
C
                   BRONIN(INDIMA+IREVER*N_TOTA+N_REAL)
     *                  =AIMAG(FIL_PP(I,J,IREVER,ICHARG))
                   BRONOU(INDIMA+IREVER*N_TOTA+N_REAL)
     *                  =AIMAG(BIG_PP(I,J,IREVER))
C
                END DO
             END DO
C
          END DO
C
C          Case of non-conserved simplex
C
          IF (ISIMPY.NE.1) THEN
C
              DO IREVER=0,MREVER
C
                 INDEXX=N_ISOS
                 INDIMA=N_ISOS
C
                 DO J=1,LDBASE
C
                    INDEXX=INDEXX+1
C
                    BRONIN(INDEXX+IREVER*N_TOTA)
     *                      =REAL(FIL_PM(J,J,IREVER,ICHARG))
                    BRONOU(INDEXX+IREVER*N_TOTA)
     *                      =REAL(BIG_PM(J,J,IREVER))
C
                    DO I=J+1,LDBASE
C
                       INDEXX=INDEXX+1
                       INDIMA=INDIMA+1
C
                       BRONIN(INDEXX+IREVER*N_TOTA)
     *                         =REAL(FIL_PM(I,J,IREVER,ICHARG))
                       BRONOU(INDEXX+IREVER*N_TOTA)
     *                         =REAL(BIG_PM(I,J,IREVER))
C
                       BRONIN(INDIMA+IREVER*N_TOTA+N_REAL)
     *                        =AIMAG(FIL_PM(I,J,IREVER,ICHARG))
                       BRONOU(INDIMA+IREVER*N_TOTA+N_REAL)
     *                        =AIMAG(BIG_PM(I,J,IREVER))
C
                    END DO
                 END DO
C
              END DO
C
          END IF
C
      END IF
C
C=======================================================================
C
      IF (ICHARG.EQ.1) THEN
C
          DO IREVER=0,MREVER
C
             INDEXX=0
             INDIMA=0
C
             DO J=1,LDBASE
C
                INDEXX=INDEXX+1
C
                BROPIN(INDEXX+IREVER*N_TOTA)
     *                  =REAL(FIL_PP(J,J,IREVER,ICHARG))
                BROPOU(INDEXX+IREVER*N_TOTA)
     *                  =REAL(BIG_PP(J,J,IREVER))
C
                DO I=J+1,LDBASE
C
                   INDEXX=INDEXX+1
                   INDIMA=INDIMA+1
C
                   BROPIN(INDEXX+IREVER*N_TOTA)
     *                  =REAL(FIL_PP(I,J,IREVER,ICHARG))
                   BROPOU(INDEXX+IREVER*N_TOTA)
     *                  =REAL(BIG_PP(I,J,IREVER))
C
                   BROPIN(INDIMA+IREVER*N_TOTA+N_REAL)
     *                  =AIMAG(FIL_PP(I,J,IREVER,ICHARG))
                   BROPOU(INDIMA+IREVER*N_TOTA+N_REAL)
     *                  =AIMAG(BIG_PP(I,J,IREVER))
C
                END DO
             END DO
C
          END DO
C
C          Case of non-conserved simplex
C
          IF (ISIMPY.NE.1) THEN
C
              DO IREVER=0,MREVER
C
                 INDEXX=N_ISOS
                 INDIMA=N_ISOS
C
                 DO J=1,LDBASE
C
                    INDEXX=INDEXX+1
C
                    BROPIN(INDEXX+IREVER*N_TOTA)
     *                      =REAL(FIL_PM(J,J,IREVER,ICHARG))
                    BROPOU(INDEXX+IREVER*N_TOTA)
     *                      =REAL(BIG_PM(J,J,IREVER))
C
                    DO I=J+1,LDBASE
C
                       INDEXX=INDEXX+1
                       INDIMA=INDIMA+1
C
                       BROPIN(INDEXX+IREVER*N_TOTA)
     *                         =REAL(FIL_PM(I,J,IREVER,ICHARG))
                       BROPOU(INDEXX+IREVER*N_TOTA)
     *                         =REAL(BIG_PM(I,J,IREVER))
C
                       BROPIN(INDIMA+IREVER*N_TOTA+N_REAL)
     *                        =AIMAG(FIL_PM(I,J,IREVER,ICHARG))
                       BROPOU(INDIMA+IREVER*N_TOTA+N_REAL)
     *                        =AIMAG(BIG_PM(I,J,IREVER))
C
                    END DO
                 END DO
C
              END DO
C
          END IF
C
      END IF
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE HPH_OU(ISIMPY,MREVER,ICHARG)
C=======================================================================
      USE BROYIN_NEUTRON
      USE BROYIN_PROTON
      USE MAF_PP
      USE MAF_PM
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      COMMON
     *       /DIMENS/ LDBASE
      COMMON
     *       /BRODIM/ N_REAL,N_IMAG,N_TOTA,N_RISO,N_ISOS,NMATRN,NMATRP
C
C=======================================================================
C      THIS SUBROUTINE UPDATES THE MATRIX ELEMENTS OF THE HFB MATRIX
C      WITH THE RESULTS OF THE BROYDEN MIXING DONE IN 'DOBROY'. THE
C      UPDATE OF THE HFB MATRIX IS DONE SEPARATELY FOR NEUTRONS AND
C      PROTONS, FLAG icharg CONTROLS THIS. ALSO, SINCE THE P-H MATRIX
C      IS HERMITIAN, ONLY THE INDEPENDENT MATRIX ELEMENTS ARE UPDATED
C      (THERE ARE n x (n+1)/2 REAL and n x (n-1)/2 IMAGINARY FOR A
C      (n x n) MATRIX.
C=======================================================================
C
C      Updating the neutron HFB matrix
C
      IF (ICHARG.EQ.0) THEN
C
          DO IREVER=0,MREVER
C
             INDEXX=0
             INDIMA=0
C
             DO J=1,LDBASE
C
                INDEXX=INDEXX+1
C
                FIL_PP(J,J,IREVER,0)
     *          =CMPLX(BRONIN(INDEXX+IREVER*N_TOTA),0.0D0)
C
                DO I=J+1,LDBASE
C
                   INDEXX=INDEXX+1
                   INDIMA=INDIMA+1
C
                   FIL_PP(I,J,IREVER,0)
     *            =CMPLX(BRONIN(INDEXX+IREVER*N_TOTA),
     *                   BRONIN(INDIMA+IREVER*N_TOTA+N_REAL))
C
                   FIL_PP(J,I,IREVER,0)=CONJG(FIL_PP(I,J,IREVER,0))
C
                END DO
C
             END DO
C
          END DO
C
          IF (MREVER.EQ.0) THEN
C
              DO J=1,LDBASE
                 DO I=1,LDBASE
                    FIL_PP(I,J,1,0)=CONJG(FIL_PP(I,J,0,0))
                 END DO
              END DO
C
          END IF
C
          IF (ISIMPY.NE.1) THEN
C
              DO IREVER=0,MREVER
C
                 INDEXX=N_ISOS
                 INDIMA=N_ISOS
C
                 DO J=1,LDBASE
C
                    INDEXX=INDEXX+1
C
                    FIL_PM(J,J,IREVER,0)
     *                  =CMPLX(BRONIN(INDEXX+IREVER*N_TOTA),0.0D0)
C
                    DO I=J+1,LDBASE
C
                       INDEXX=INDEXX+1
                       INDIMA=INDIMA+1
C
                       FIL_PM(I,J,IREVER,0)
     *                =CMPLX(BRONIN(INDEXX+IREVER*N_TOTA),
     *                       BRONIN(INDIMA+IREVER*N_TOTA+N_REAL))
C
                       FIL_PM(J,I,IREVER,0)=CONJG(FIL_PM(I,J,IREVER,0))
C
                    END DO
                 END DO
C
              END DO
C
              IF (MREVER.EQ.0) THEN
C
                  DO J=1,LDBASE
                     DO I=1,LDBASE
                        FIL_PM(I,J,1,0)=CONJG(FIL_PM(I,J,0,0))
                     END DO
                  END DO
C
              END IF
C
          END IF
C
      END IF
C
C      Updating the proton HFB matrix
C
      IF (ICHARG.EQ.1) THEN
C
          DO IREVER=0,MREVER
C
             INDEXX=0
             INDIMA=0
C
             DO J=1,LDBASE
C
                INDEXX=INDEXX+1
C
                FIL_PP(J,J,IREVER,1)
     *              =CMPLX(BROPIN(INDEXX+IREVER*N_TOTA),0.0D0)
C
                DO I=J+1,LDBASE
C
                   INDEXX=INDEXX+1
                   INDIMA=INDIMA+1
C
                   FIL_PP(I,J,IREVER,1)
     *            =CMPLX(BROPIN(INDEXX+IREVER*N_TOTA),
     *                   BROPIN(INDIMA+IREVER*N_TOTA+N_REAL))
C
                   FIL_PP(J,I,IREVER,1)=CONJG(FIL_PP(I,J,IREVER,1))
C
                END DO
C
             END DO
C
          END DO
C
          IF (MREVER.EQ.0) THEN
C
              DO J=1,LDBASE
                 DO I=1,LDBASE
                    FIL_PP(I,J,1,1)=CONJG(FIL_PP(I,J,0,1))
                 END DO
              END DO
C
          END IF
C
          IF (ISIMPY.NE.1) THEN
C
              DO IREVER=0,MREVER
C
                 INDEXX=N_ISOS
                 INDIMA=N_ISOS
C
                 DO J=1,LDBASE
C
                    INDEXX=INDEXX+1
C
                    FIL_PM(J,J,IREVER,1)
     *              =CMPLX(BROPIN(INDEXX+IREVER*N_TOTA),0.0)
C
                    DO I=J+1,LDBASE
C
                       INDEXX=INDEXX+1
                       INDIMA=INDIMA+1
C
                       FIL_PM(I,J,IREVER,1)
     *                =CMPLX(BROPIN(INDEXX+IREVER*N_TOTA),
     *                       BROPIN(INDIMA+IREVER*N_TOTA+N_REAL))
C
                       FIL_PM(J,I,IREVER,1)=CONJG(FIL_PM(I,J,IREVER,1))
C
                    END DO
                 END DO
C
              END DO
C
              IF (MREVER.EQ.0) THEN
C
                  DO J=1,LDBASE
                     DO I=1,LDBASE
                        FIL_PM(I,J,1,1)=CONJG(FIL_PM(I,J,0,1))
                     END DO
                  END DO
C
              END IF
C
          END IF
C
      END IF
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE DEL_IN(MREVER,IROTAT,ICHARG,NUMITE,INDJOB)
C=======================================================================
      USE BROYIN_NEUTRON
      USE BROYOU_NEUTRON
      USE BROYIN_PROTON
      USE BROYOU_PROTON
      USE MAP_PP
      USE PAIDEL
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      COMMON
     *       /DIMENS/ LDBASE
      COMMON
     *       /BRODIM/ N_REAL,N_IMAG,N_TOTA,N_RISO,N_ISOS,NMATRN,NMATRP
C
C=======================================================================
C      THIS SUBROUTINE UPDATES THE 'IN' AND 'OUT' BROYDEN VECTORS WITH
C      THE PAIRING MATRIX ELEMENTS OF THE HFB MATRIX. THIS IS DONE
C      SEPARATELY FOR NEUTRONS AND PROTONS, FLAG icharg CONTROLS THIS.
C      CONTRARY TO THE P-H CHANNEL, THE PAIRING PART OF THE HFB MATRIX
C      IS NOT NECESSARY HERMITIAN. ALSO, FOR SURFACE-VOLUME PAIRING
C      INTERACTION, THE TIME-EVEN TERMS ARE PURELY REAL NUMBERS, WHILE
C      THE TIME-ODD TERMS ARE PURELY IMAGINARY.
C=======================================================================
C
C      Broyden vector for neutrons
C      Real part of HAMIDE: time-even terms
C
      IF (ICHARG.EQ.0) THEN
C
          DO IREVER=0,MREVER
C
             INDEXX=NMATRN
C
             DO J=1,LDBASE
                DO I=J,LDBASE
C
                   INDEXX=INDEXX+1
C
                   BRONIN(INDEXX+IREVER*N_REAL)
     *              =REAL(FIP_PP(I,J,IREVER,ICHARG))
                   BRONOU(INDEXX+IREVER*N_REAL)
     *              =REAL(HAMIDE(I,J,IREVER))
C
                END DO
             END DO
C
          END DO
C
C          Imaginary part of HAMIDE: time-odd terms
C
          IF (IROTAT.EQ.1) THEN
C
              DO IREVER=0,MREVER
C
                 INDIMA=NMATRN+(MREVER+1)*N_REAL
C
                 DO J=1,LDBASE
                    DO I=J+1,LDBASE
C
                       INDIMA=INDIMA+1
C
                       BRONIN(INDIMA+IREVER*N_IMAG)
     *                    =AIMAG(FIP_PP(I,J,IREVER,ICHARG))
                       BRONOU(INDIMA+IREVER*N_IMAG)
     *                    =AIMAG(HAMIDE(I,J,IREVER))
C
                    END DO
                 END DO
C
              END DO
C
          END IF
C
      END IF
C
C=======================================================================
C
C      Broyden vector for protons
C      Real part of HAMIDE: time-even terms
C
      IF (ICHARG.EQ.1) THEN
C
          DO IREVER=0,MREVER
C
             INDEXX=NMATRP
C
             DO J=1,LDBASE
                DO I=J,LDBASE
C
                   INDEXX=INDEXX+1
C
                   BROPIN(INDEXX+IREVER*N_REAL)
     *              =REAL(FIP_PP(I,J,IREVER,ICHARG))
                   BROPOU(INDEXX+IREVER*N_REAL)
     *              =REAL(HAMIDE(I,J,IREVER))
C
                END DO
             END DO
C
          END DO
C
C          Imaginary part of HAMIDE: time-odd terms
C
          IF (IROTAT.EQ.1) THEN
C
              DO IREVER=0,MREVER
C
                 INDIMA=NMATRP+(MREVER+1)*N_REAL
C
                 DO J=1,LDBASE
                    DO I=J+1,LDBASE
C
                       INDIMA=INDIMA+1
C
                       BROPIN(INDIMA+IREVER*N_IMAG)
     *                    =AIMAG(FIP_PP(I,J,IREVER,ICHARG))
                       BROPOU(INDIMA+IREVER*N_IMAG)
     *                    =AIMAG(HAMIDE(I,J,IREVER))
C
                    END DO
                 END DO
C
              END DO
C
          END IF
C
      END IF
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE DEL_OU(MREVER,IROTAT,ICHARG)
C=======================================================================
      USE BROYIN_NEUTRON
      USE BROYIN_PROTON
      USE MAP_PP
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      COMMON
     *       /DIMENS/ LDBASE
      COMMON
     *       /BRODIM/ N_REAL,N_IMAG,N_TOTA,N_RISO,N_ISOS,NMATRN,NMATRP
C
C=======================================================================
C      THIS SUBROUTINE UPDATES THE PAIRING MATRIX ELEMENTS OF THE HFB
C      MATRIX WITH THE RESULTS OF THE BROYDEN MIXING DONE IN 'DOBROY'.
C      THE UPDATE OF THE HFB MATRIX IS DONE SEPARATELY FOR NEUTRONS AND
C      PROTONS, FLAG icharg CONTROLS THIS. CONTRARY TO THE P-H CHANNEL,
C      THE PAIRING PART OF THE HFB MATRIX IS NOT NECESSARY HERMITIAN.
C      ALSO, FOR SURFACE-VOLUME PAIRING INTERACTION, THE TIME-EVEN
C      TERMS ARE PURELY REAL NUMBERS, WHILE THE TIME-ODD TERMS ARE
C      PURELY IMAGINARY.
C=======================================================================
C
C      Updating the neutron HFB matrix
C      Real part of HAMIDE: time-even terms
C
      IF (ICHARG.EQ.0) THEN
C
          DO IREVER=0,MREVER
C
             INDEXX=NMATRN
C
             DO J=1,LDBASE
                DO I=J,LDBASE
C
                   INDEXX=INDEXX+1
C
                   FIP_PP(I,J,IREVER,0)
     *            =CMPLX(BRONIN(INDEXX+IREVER*N_REAL),0.0D0)
C
                   FIP_PP(J,I,IREVER,0)
     *            =FIP_PP(I,J,IREVER,0)
C
                END DO
C
             END DO
C
          END DO
C
C          Imaginary part of HAMIDE: time-odd terms
C
          IF (IROTAT.EQ.1) THEN
C
              DO IREVER=0,MREVER
C
                 INDIMA=NMATRN+(MREVER+1)*N_REAL
C
                 DO J=1,LDBASE
                    DO I=J+1,LDBASE
C
                       INDIMA=INDIMA+1
C
                       FIP_PP(I,J,IREVER,0)=FIP_PP(I,J,IREVER,0)
     *                    +CMPLX(0.0D0,BRONIN(INDIMA+IREVER*N_REAL))
C
                       FIP_PP(J,I,IREVER,0)
     *                =CONJG(FIP_PP(I,J,IREVER,0))
                    END DO
                 END DO
C
              END DO
C
          END IF
C
      END IF
C
C=======================================================================
C
C      Updating the proton HFB matrix
C      Real part of HAMIDE: time-even terms
C
      IF (ICHARG.EQ.1) THEN
C
          DO IREVER=0,MREVER
C
             INDEXX=NMATRP
C
             DO J=1,LDBASE
                DO I=J,LDBASE
C
                   INDEXX=INDEXX+1
C
                   FIP_PP(I,J,IREVER,1)
     *            =CMPLX(BROPIN(INDEXX+IREVER*N_REAL),0.0D0)
C
                   FIP_PP(J,I,IREVER,1)
     *            =FIP_PP(I,J,IREVER,1)
C
                END DO
             END DO
C
          END DO
C
C          Imaginary part of HAMIDE: time-odd terms
C
          IF (IROTAT.EQ.1) THEN
C
              DO IREVER=0,MREVER
C
                 INDIMA=NMATRP+(MREVER+1)*N_REAL
C
                 DO J=1,LDBASE
                    DO I=J+1,LDBASE
C
                       INDIMA=INDIMA+1
C
                       FIP_PP(I,J,IREVER,1)=FIP_PP(I,J,IREVER,1)
     *                    +CMPLX(0.0D0,BROPIN(INDIMA+IREVER*N_REAL))
C
                       FIP_PP(J,I,IREVER,1)
     *                =CONJG(FIP_PP(I,J,IREVER,1))
C
                   END DO
                 END DO
C
              END DO
C
          END IF
C
      END IF
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE ZEFILD(ITPNMX)
C=======================================================================
      USE VE_FLD
      USE WD_FLD
C=======================================================================
      USE hfodd_sizes
C=======================================================================
C
      COMPLEX
     *          C_ZERO
C
C=======================================================================
C        THIS SUBROUTINE PUTS ZEROS IN THE SKYRME FIELDS.
C=======================================================================
C
      C_ZERO=CMPLX(0.0D0,0.0D0)
C
C=======================================================================
C              S  C  A  L  A  R     F  I  E  L  D  S    F  O  L  L  O  W
C=======================================================================
C
      VE_MAS(:,:,:,ITPNMX) = C_ZERO
      VE_CEN(:,:,:,ITPNMX) = C_ZERO
      WD_CEN(:,:,:,ITPNMX) = C_ZERO
C
C=======================================================================
C              V  E  C  T  O  R    F  I  E  L  D  S     F  O  L  L  O  W
C=======================================================================
C
      VE_CUR(:,:,:,:,ITPNMX)= C_ZERO
      VE_KIS(:,:,:,:,ITPNMX)= C_ZERO
      VE_SPI(:,:,:,:,ITPNMX)= C_ZERO
C
C=======================================================================
C               T  E  N  S  O  R    F  I  E  L  D  S    F  O  L  L  O  W
C=======================================================================
C
      VE_SOR(:,:,:,:,:,ITPNMX)=C_ZERO
C
C=======================================================================
C               P A I R I N G   F  I  E  L  D  S    F  O  L  L  O  W
C=======================================================================
C
      WD_CEN(:,:,:,ITPNMX)=C_ZERO
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE PHASES(NYMAXX)
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      COMPLEX
     *          PHASPI,UNIT_I
C
      COMMON
     *       /BASISO/ NXVECT(1:NDBASE),NYVECT(1:NDBASE),NZVECT(1:NDBASE)
      COMMON
     *       /SPIPHA/ PHASPI(1:NDBASE,0:NDREVE,0:NDSPIN)
      COMMON
     *       /DIMENS/ LDBASE
C
C=======================================================================
C
C        THIS SUBROUTINE REPRESENTS THE CENTRAL PART OF THE W H O L E
C        PROGRAM. THE PHASE CONVENTION CORRESPONDS  TO THE |T_BASIS>.
C        THE CORRESPONDING EXPRESSIONS ARE OBTAINED ASSUMING THE H.O.
C        CARTESIAN  BASIS WITH THE OVERALL PHASE FACTOR:
C
C                                (0,1) ** NY
C
C        AND CONSEQUENTLY
C
C        |T+> = NORM. * ( (0,1)**( NY ) |UP> - (0,1) ** (1-NY) |DOWN> )
C        |T-> = NORM. * ( (0,1)**(NY-1) |UP> + (0,1) ** (-NY ) |DOWN> )
C
C        THE THIRD INDEX REPRESENTS PAULI MATRICES WITH THE ZERO VALUE
C        USED FOR THE IDENTITY MATRIX.
C
C=======================================================================
C
      CALL TPHASE(NYMAXX)
C
C=======================================================================
C
      DSQRT2=SQRT(2.0D0)
C
      UNIT_I=CMPLX(0.0D0,1.0D0)
C
C=======================================================================
C
C        PHASPI(IBASE,ISPIN)   IS A PHASE FACTOR WHICH MULTIPLIES THE
C        ISPIN-TH COMPONENT OF THE   |NX,NY,NZ,ISPIN>   SPINOR IN THE
C        FORMULA GIVING THE BASIS IN WHICH THE MEAN FIELD HAMILTONIAN
C        HAS BEEN DIAGONALIZED
C
C=======================================================================
C
C        ISPIN=1 CORRESPONDS TO THE SPIN UP
C        ISPIN=0 CORRESPONDS TO THE SPIN DOWN
C
C=======================================================================
C
C        CURRENT CHOICE CORRESPONDS TO THE T_+ BASIS
C
C=======================================================================
C
      DO IBASE=1,LDBASE
C
         NY=NYVECT(IBASE)
C
         PHASPI(IBASE,0,1)=+UNIT_I**   NY /DSQRT2
         PHASPI(IBASE,0,0)=-UNIT_I**(1-NY)/DSQRT2
C
      END DO
C
      DO IBASE=1,LDBASE
C
         NY=NYVECT(IBASE)
C
         PHASPI(IBASE,1,1)=-UNIT_I**(1+NY)/DSQRT2
         PHASPI(IBASE,1,0)=+UNIT_I**( -NY)/DSQRT2
C
      END DO
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE TPHASE(NYMAXX)
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      COMPLEX
     *          PHACOM
C
      COMMON
     *       /T_PHAS/ IPHAPP(0:NDYMAX,0:NDYMAX,0:NDKART),
     *                IPHAPM(0:NDYMAX,0:NDYMAX,0:NDKART),
     *                IPHAMP(0:NDYMAX,0:NDYMAX,0:NDKART),
     *                IPHAMM(0:NDYMAX,0:NDYMAX,0:NDKART)
      COMMON
     *       /COMPHA/ PHACOM(0:NDKART)
C
C=======================================================================
C
      IFAZA(N)=((1+(-1)**N)/2)*(-1)**(N/2)
C
C=======================================================================
C
C        THIS SUBROUTINE REPRESENTS THE CENTRAL PART OF THE W H O L E
C        PROGRAM. THE PHASE CONVENTION CORRESPONDS  TO THE |T_BASIS>.
C        THE CORRESPONDING EXPRESSIONS ARE OBTAINED ASSUMING THE H.O.
C        CARTESIAN BASIS WITH THE OVERALL PHASE FACTOR:
C
C                                (0,1) ** NY
C
C        CONSEQUENTLY:
C
C        |T+> = NORM. * ((0,1)**( NY ) |UP> - (0,1) ** (1-NY) |DOWN>)
C        |T-> = NORM. * ((0,1)**(NY-1) |UP> + (0,1) ** (-NY ) |DOWN>)
C
C        THE THIRD INDEX REPRESENTS PAULI  MATRICES  WITH  ZERO VALUE
C        FOR THE IDENTITY.
C
C        W A R N I N G:   THE "T+,T+"=PP, "T+,T-"=PM, "T-,T+"=MP, AND
C                         "T-,T-"=MM  PHASES FOR  KARTEZ=3  SHOULD BE
C                         MULTIPLIED BY IMAGINARY UNIT.  HOWEVER,  IT
C                         IS  EASIER TO KEEP PHASES REAL.  THEREFORE,
C                         WE  D O  N O T  MULTIPLY   KARTEZ=3  PHASES
C                         BY i, AND  HAVE  TO  R E M E M B E R  ABOUT
C                         IT NOW AND ALWAYS TILL THE END OF THE WORLD
C
C                         THIS IMAGINARY UNIT IS PUT INTO  THE  ARRAY
C                         "PHACOM"
C
C        THIS SUBROUTINE  CALCULATES  THE PHASES FOR ALL THE 4 BLOCKS
C                         IN THE BASIS "T" (GOOD SIMPLEX BASIS FOR RY)
C
C                         BLOCK "T+,T+"  (PP)
C                         BLOCK "T+,T-"  (PM)
C                         BLOCK "T-,T+"  (MP)
C                         BLOCK "T-,T-"  (MM)
C
C=======================================================================
C
      IF (NYMAXX.GT.NDYMAX) STOP 'NYMAXX.GT.NDYMAX IN TPHASE'
C
      DO NY=0,NYMAXX
         DO MY=0,NYMAXX
C
C                        KARTEZ
C
            IPHAPP(NY,MY,   0  )=IFAZA(NY-MY  )
            IPHAPM(NY,MY,   0  )=IFAZA(NY-MY+1)
            IPHAMP(NY,MY,   0  )=IFAZA(NY-MY-1)
            IPHAMM(NY,MY,   0  )=IFAZA(NY-MY  )
C
            IPHAPP(NY,MY,   1  )=IFAZA(NY+MY+1)
            IPHAPM(NY,MY,   1  )=IFAZA(NY+MY  )
            IPHAMP(NY,MY,   1  )=IFAZA(NY+MY  )
            IPHAMM(NY,MY,   1  )=IFAZA(NY+MY-1)
C
            IPHAPP(NY,MY,   2  )=IFAZA(NY+MY+2)
            IPHAPM(NY,MY,   2  )=IFAZA(NY+MY+1)
            IPHAMP(NY,MY,   2  )=IFAZA(NY+MY+1)
            IPHAMM(NY,MY,   2  )=IFAZA(NY+MY  )
C
            IPHAPP(NY,MY,   3  )=IFAZA(NY-MY+1)
            IPHAPM(NY,MY,   3  )=IFAZA(NY-MY+2)
            IPHAMP(NY,MY,   3  )=IFAZA(NY-MY  )
            IPHAMM(NY,MY,   3  )=IFAZA(NY-MY+1)
C
         END DO
      END DO
C
C=======================================================================
C
      PHACOM(0)=CMPLX(1.0D0,0.0D0)
      PHACOM(1)=CMPLX(1.0D0,0.0D0)
      PHACOM(2)=CMPLX(1.0D0,0.0D0)
      PHACOM(3)=CMPLX(0.0D0,1.0D0)
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE TRUTOD(NXHERM,NYHERM,NZHERM)
C=======================================================================
      USE HE_DEN
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      COMPLEX
     *          DENSIC,DENCHC
C
      COMMON
     *       /DENTOT/ DENSIT(NDXHRM,NDYHRM,NDZHRM),
     *                DENCHA(NDXHRM,NDYHRM,NDZHRM)
      COMMON
     *       /DENTOC/ DENSIC(NDXHRM,NDYHRM,NDZHRM),
     *                DENCHC(NDXHRM,NDYHRM,NDZHRM)
      COMMON
     *       /DENEXP/ EXPAUX(NDXHRM,NDYHRM,NDZHRM)
C
C=======================================================================
C        THIS SUBROUTINE CALCULATES  T R U E  DENSITY OF PARTICLES
C        IN THE   T R U E   DENSITIES,  THE  EXPONENTIAL  FACTORS:
C                          EXP(-(ETA/SQRT(2))**2)
C        (ETA DENOTES THE GAUSS ZEROS)  ARE INCLUDED,  WHEREAS THE
C        PROGRAM USES THE EXPONENTIAL FACTORS IMPLICITLY  'HIDDEN'
C        IN THE GAUSS-HERMITE INTEGRATION WEIGHTS.
C=======================================================================
C
      DO IZ=1,NZHERM
         DO IY=1,NYHERM
            DO IX=1,NXHERM
C
               DENSIC(IX,IY,IZ) =(DE_RHO(IX,IY,IZ,0)
     *                          + DE_RHO(IX,IY,IZ,1)) * EXPAUX(IX,IY,IZ)
C
               DENSIT(IX,IY,IZ) = REAL(DENSIC(IX,IY,IZ))
C
            END DO
         END DO
      END DO
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE TRUCHD(NXHERM,NYHERM,NZHERM)
C=======================================================================
      USE HE_DEN
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      COMPLEX
     *          DENSIC,DENCHC
C
      COMMON
     *       /DENTOT/ DENSIT(NDXHRM,NDYHRM,NDZHRM),
     *                DENCHA(NDXHRM,NDYHRM,NDZHRM)
      COMMON
     *       /DENTOC/ DENSIC(NDXHRM,NDYHRM,NDZHRM),
     *                DENCHC(NDXHRM,NDYHRM,NDZHRM)
      COMMON
     *       /DENEXP/ EXPAUX(NDXHRM,NDYHRM,NDZHRM)
C
C=======================================================================
C        THIS SUBROUTINE CALCULATES  T R U E  DENSITY  OF  CHARGE.
C        IN THE   T R U E   DENSITIES, THE  EXPONENTIAL   FACTORS:
C                          EXP(-(ETA/SQRT(2))**2)
C        (ETA DENOTES THE GAUSS ZEROS)  ARE INCLUDED,  WHEREAS THE
C        PROGRAM USES THE EXPONENTIAL FACTORS IMPLICITLY  'HIDDEN'
C        IN THE GAUSS-HERMITE INTEGRATION WEIGHTS.
C=======================================================================
C
      DO IZ=1,NZHERM
         DO IY=1,NYHERM
            DO IX=1,NXHERM
C
               DENCHC(IX,IY,IZ) = DE_RHO(IX,IY,IZ,1)  * EXPAUX(IX,IY,IZ)
C
               DENCHA(IX,IY,IZ) = REAL(DENCHC(IX,IY,IZ))
C
            END DO
         END DO
      END DO
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE SAVDIS(NXHERM,NYHERM,NZHERM)
C=======================================================================
      USE HE_DEN
C=======================================================================
      USE hfodd_sizes
C=======================================================================
C
      COMPLEX
     *          DENDIS
C
      COMMON
     *       /DISDEN/ DENDIS(NDXHRM,NDYHRM,NDZHRM,0:NDISOS)
C
C=======================================================================
C        THIS SUBROUTINE CALCULATES THE "DIV S" DENSITIES AND STORES
C        THEM IN THE "DENDIS"  ARRAY FOR NEUTRONS AND PROTONS.
C=======================================================================
C
      DO IZ=1,NZHERM
         DO IY=1,NYHERM
            DO IX=1,NXHERM
C
               DENDIS(IX,IY,IZ,0) = CMPLX(0.0D0,0.0D0)
               DENDIS(IX,IY,IZ,1) = CMPLX(0.0D0,0.0D0)
C
               DO K=1,NDKART
                   DENDIS(IX,IY,IZ,0) = DENDIS(IX,IY,IZ,0)+
     *                                  DE_DES(IX,IY,IZ,K,K,0)
                   DENDIS(IX,IY,IZ,1) = DENDIS(IX,IY,IZ,1)+
     *                                  DE_DES(IX,IY,IZ,K,K,1)
               END DO
C
            END DO
         END DO
      END DO
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE DEFEXP(NXHERM,NYHERM,NZHERM)
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      COMMON
     *       /INTSTO/ FOURWG(1:NDGAUS,1:NDKART),
     *                FOURPT(1:NDGAUS,1:NDKART)
C
      COMMON
     *       /DENEXP/ EXPAUX(NDXHRM,NDYHRM,NDZHRM)
C
C=======================================================================
C        THIS SUBROUTINE CALCULATES  THE EXPONENTIAL FACTORS:
C                          EXP(-(ETA/SQRT(2))**2)
C        (ETA DENOTES THE GAUSS ZEROS).
C=======================================================================
C
      DO IZ=1,NZHERM
         DO IY=1,NYHERM
            DO IX=1,NXHERM
C
               EXPAUX(IX,IY,IZ)=EXP(-(FOURPT(IX,1)**2
     *                               +FOURPT(IY,2)**2
     *                               +FOURPT(IZ,3)**2))
C
            END DO
         END DO
      END DO
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE D_HERM(X,N,HER,DHER,NDIM)
      DIMENSION
     *          HER(NDIM),DHER(NDIM)
C
C=======================================================================
C
C         D_HERM CALCULATES HERMITE POLYNOMIALS AT POINT X UP TO N-TH
C         DEGREE. IT  ALSO CALCULATES  DERIVATIVES  DHER(I)  OF THESE
C         POLYNOMIALS.
C                            DHER(I)=2*I*HER(I-1)
C=======================================================================
C
      HER (1)=1.0D0
      DHER(1)=0.0D0
C
      IF (N) 1,1,2
C
   1  RETURN
C
   2  HER (2)=X + X
      DHER(2)=2.0D0
C
      IF (N-1) 1,1,3
C
   3  CONTINUE
C
      DO I=2,N
C
         F=X*HER(I)-REAL(I-1,KIND=8)*HER(I-1)
         HER(I+1)=F+F
C
         DF=REAL(I,KIND=8)*HER(I)
         DHER(I+1)=DF+DF
C
      END DO
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE ORDER1(EL,KL,N)
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      DIMENSION
     *          EL(NFIRST:N),KL(NFIRST:N)
      DIMENSION
     *          EM(NFIRST:NLAST),KM(NFIRST:NLAST)
      DIMENSION
     *          KWHER(NFIRST:NLAST),
     *          KFROM(NFIRST:NLAST)
C
C=======================================================================
C         THIS ROUTINE PERFORMS THE ORDERING OF THE VECTOR EL, RECORDING
C         AS WELL THE INFORMATION ABOUT THE ORIGINAL ORDER (STORE:  KL )
C=======================================================================
C
      IF (N.GT.NLAST) STOP 'NLAST TOO SMALL IN ORD'
C
      IF (N.LE.NFIRST) RETURN
C
C=======================================================================
C         REWRITING INPUT ARRAYS TO AUXILIARY ONES
C=======================================================================
C
      DO I=NFIRST,N
         KWHER(I)=NFIRST
         EM(I)=EL(I)
         KM(I)=KL(I)
      END DO
C
C=======================================================================
C        HOW MANY ELEMENTS ARE SMALLER THAN THE I-TH ONE? ANOTHER WORDS
C        WHERE SHOULD IT GO WITH RESPECT TO THE OFFSET POSITION NFIRST?
C=======================================================================
C
      DO J=NFIRST,N
         DO I=NFIRST,N
C
            IF (EM(J).LT.EM(I)) KWHER(I)=KWHER(I)+1
C
         END DO
      END DO
C
C=======================================================================
C        NOW WE ONLY HAVE TO RESOLVE THE CASE OF IDENTICAL ELEMENTS
C=======================================================================
C        FROM WHERE THE I-TH ELEMENT SHOULD COME?
C=======================================================================
C
      DO I=NFIRST,N
         KFROM(I)=NFIRST-1
      END DO
C
      DO I=NFIRST,N
         KFROM(KWHER(I))=I
      END DO
C
C=======================================================================
C        IF SOME ELEMENTS ARE EQUAL THERE WILL BE UNFILLED PLACES
C        IN THE KFROM  ARRAY. FILL THEM UP NOW.
C=======================================================================
C
    1 DO I=NFIRST,N
         IF (KFROM(I).EQ.NFIRST-1) THEN
            IEQUAL=I-1
            IFILLL=I-1
            GO TO 2
         END IF
      END DO
C
      GO TO 3
C
    2 DO I=NFIRST,N
C
         IF (KWHER(I).EQ.IEQUAL) THEN
            KFROM(IFILLL)=I
            IFILLL=IFILLL+1
         END IF
C
      END DO
C
      GO TO 1
C
    3 CONTINUE
C
C=======================================================================
C        FINALLY WE MAY REWRITE THE INPUT ARRAYS IN THE RIGHT ORDER
C=======================================================================
C
      DO I=NFIRST,N
         EL(I)=EM(KFROM(I))
         KL(I)=KM(KFROM(I))
      END DO
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE PARAMS(SKYRME,LANODD,LANSCA,HBMSAT,RHOSAT,EFFSAT,
     *                         ISTAND,KETA_J,KETA_W,KETACM,KETA_M,
     *                                JETA_J,JETA_W,JETACM,JETA_M)
C=======================================================================
      USE hfodd_functional
      USE UNEDF
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      CHARACTER
     *            SKYRME*4,NCPALL*4
      CHARACTER*4
     *            NRHO_N,NRHODN,
     *            NLPR_N,
     *            NTAU_N,
     *            NSCU_N,
     *            NDIV_N,
     *            NSPI_N,NSPIDN,
     *            NLPS_N,
     *            NCUR_N,
     *            NKIS_N,
     *            NROT_N
      CHARACTER*4
     *            NSCR_N,
     *            NDIS_N,
     *            NDSR_N,
     *            NSCS_N,
     *            NSCJ_N,
     *            NCUS_N,
     *            NROS_N,
     *            NDES_N
C
      DIMENSION
     *             CCPALL(NDCOUP), NCPALL(NDCOUP/2)
      DIMENSION
     *             STSALL(NDCOUP), SPMALL(NDCOUP)
      DIMENSION
     *             ATSALL(NDCOUP), APMALL(NDCOUP)
      EQUIVALENCE
     *            (CCPALL,CRHO_T),(NCPALL,NRHO_N)
      EQUIVALENCE
     *            (STSALL,SRHO_T),(SPMALL,SRHO_P)
      EQUIVALENCE
     *            (ATSALL,ARHO_T),(APMALL,ARHO_P)
C
      COMMON
     *       /STSSKY/ SRHO_T,SRHO_S,SRHODT,SRHODS,
     *                SLPR_T,SLPR_S,
     *                STAU_T,STAU_S,
     *                SSCU_T,SSCU_S,
     *                SDIV_T,SDIV_S,
     *                SSPI_T,SSPI_S,SSPIDT,SSPIDS,
     *                SLPS_T,SLPS_S,
     *                SCUR_T,SCUR_S,
     *                SKIS_T,SKIS_S,
     *                SROT_T,SROT_S
      COMMON
     *       /SPMSKY/ SRHO_P,SRHO_M,SRHODP,SRHODM,
     *                SLPR_P,SLPR_M,
     *                STAU_P,STAU_M,
     *                SSCU_P,SSCU_M,
     *                SDIV_P,SDIV_M,
     *                SSPI_P,SSPI_M,SSPIDP,SSPIDM,
     *                SLPS_P,SLPS_M,
     *                SCUR_P,SCUR_M,
     *                SKIS_P,SKIS_M,
     *                SROT_P,SROT_M
      COMMON
     *       /ATSSKY/ ARHO_T,ARHO_S,ARHODT,ARHODS,
     *                ALPR_T,ALPR_S,
     *                ATAU_T,ATAU_S,
     *                ASCU_T,ASCU_S,
     *                ADIV_T,ADIV_S,
     *                ASPI_T,ASPI_S,ASPIDT,ASPIDS,
     *                ALPS_T,ALPS_S,
     *                ACUR_T,ACUR_S,
     *                AKIS_T,AKIS_S,
     *                AROT_T,AROT_S
      COMMON
     *       /APMSKY/ ARHO_P,ARHO_M,ARHODP,ARHODM,
     *                ALPR_P,ALPR_M,
     *                ATAU_P,ATAU_M,
     *                ASCU_P,ASCU_M,
     *                ADIV_P,ADIV_M,
     *                ASPI_P,ASPI_M,ASPIDP,ASPIDM,
     *                ALPS_P,ALPS_M,
     *                ACUR_P,ACUR_M,
     *                AKIS_P,AKIS_M,
     *                AROT_P,AROT_M
      COMMON
     *       /NCPSKY/ NRHO_N,NRHODN,
     *                NLPR_N,
     *                NTAU_N,
     *                NSCU_N,
     *                NDIV_N,
     *                NSPI_N,NSPIDN,
     *                NLPS_N,
     *                NCUR_N,
     *                NKIS_N,
     *                NROT_N
      COMMON
     *       /CCPSKY/ CRHO_T,CRHO_S,CRHODT,CRHODS,
     *                CLPR_T,CLPR_S,
     *                CTAU_T,CTAU_S,
     *                CSCU_T,CSCU_S,
     *                CDIV_T,CDIV_S,
     *                CSPI_T,CSPI_S,CSPIDT,CSPIDS,
     *                CLPS_T,CLPS_S,
     *                CCUR_T,CCUR_S,
     *                CKIS_T,CKIS_S,
     *                CROT_T,CROT_S
      COMMON
     *       /MCPSKY/ NSCR_N,
     *                NDIS_N,
     *                NDSR_N,
     *                NSCS_N,
     *                NSCJ_N,
     *                NCUS_N,
     *                NROS_N,
     *                NDES_N
      COMMON
     *       /EDFINP/ IF_EDF
     *       /EDFPAR/ V0NEFF,V0PEFF,COUSCA
      COMMON
     *       /INTSKY/ T0,X0,T1,X1,T2,X2,T3,X3,W0,POWER
      COMMON
     *       /PLANCK/ HBMASS,HBMRPA,HBMINP
      COMMON
     *       /SO_PAR/ W0_INP,W0PINP
      COMMON
     *       /CCPPAI/ PRHO_N,PRHODN,PRHOSN,POWERN,
     *                PRHO_P,PRHODP,PRHOSP,POWERP
      COMMON
     *       /CFIPRI/ NFIPRI
C
C=======================================================================
C         THIS SUBROUTINE DEFINES PARAMETERS OF THE  SKYRME  FUNCTIONAL
C=======================================================================
C         THE PARAMETERS OF THE SKYRME  FORCE  "SKYRME"  ARE  FIXED  BY
C         GIVING THE EXPLICIT VALUES THAT ARE STANDARD FOR  EACH  FORCE.
C         THE STANDARD VALUES INCLUDE PARAMETERS "IETA_J", "IETA_W" AND
C         "IETACM" (THAT DEFINE THE  WAY  THE  "J^2",  SPIN-ORBIT,  AND
C         CENTER-OF-MASS TERMS HAVE TO BE HANDLED FOR THE GIVEN  FORCE).
C         THESE STANDARD  VALUES ARE USED  FOR  ISTAND = 1,  WHILE  FOR
C         ISTAND = 0 ONE USES  THE  CORRESPONDING  PARAMETERS  "KETA_J",
C         "KETA_W", AND "KETACM".
C=======================================================================
C         THE STANDARD PARAMETERS ALSO INCLUDE THE VALUE OF MASS HBMSKY.
C=======================================================================
C         IETA_J DEFINES THE TREATMENT OF THE "J^2" TERMS:
C         IETA_J=0  ==>  "J^2" TERMS ARE OMITTED.
C         IETA_J=1  ==>  "J^2" TERMS ARE INCLUDED.
C=======================================================================
C         IETA_W DEFINES THE TREATMENT OF THE SPIN-ORBIT TERMS:
C         IETA_W=0  ==>  SPIN-ORBIT TERMS TAKEN FROM THE SKYRME FORCE.
C         IETA_W=1  ==>  SPIN-ORBIT TERMS GENERALIZED (REINHARD-FLOCARD)
C         IETA_W=2  ==>  SPIN-ORBIT PARAMETERS READ FROM THE INPUT DATA
C=======================================================================
C         IETACM DEFINES THE TREATMENT OF THE CENTER-OF-MASS (CM) TERMS:
C         IETACM=0  ==>  CM TERMS BEFORE VARIATION (DIRECT PART ONLY).
C         IETACM=1  ==>  CM TERMS AFTER  VARIATION (FULL TWO-BODY).
C         IETACM=2  ==>  CM TERMS BEFORE VARIATION (FULL TWO-BODY).
C         IETACM=3  ==>  CM TERMS NOT INCLUDED.
C=======================================================================
C         IETA_M DEFINES THE TREATMENT OF THE MASS TERM (HBMASS).
C         IETA_M=0  ==>  MASS TERM AS IN THE OLDER VERSIONS OF HFODD
C         IETA_M=1  ==>  MASS TERM CONSISTENT WITH THE GIVEN FORCE
C         IETA_M=2  ==>  MASS TERM READ FROM THE INPUT DATA
C=======================================================================
C
      T0 = +.0000000D+04
      X0 = +.0000000D+00
C
      T1 = +.0000000D+03
      X1 = +.0000000D+00
C
      T2 = +.0000000D+02
      X2 = +.0000000D+00
C
      T3 = +.0000000D+05
      X3 = +.0000000D+01
C
      W0 = +.0000000D+00
      W0P= +.0000000D+00
C
      B4 = +.0000000D+00
      B4P= +.0000000D+00
C
      POWER = .10000D+01
C
      TE = +.0000000D+00
      TO = +.0000000D+00
C
      IETA_J = 1
      IETA_W = 0
      IETACM = 0
      IETA_M = 1
C
      COUSCA = 1.0D0
C
      HBMSKY = 20.73620941D0
      RHOSKY = -1.00000000D0
      EFFSKY = -1.00000000D0
C
C=======================================================================
C
      ISKYRM=0
C
C=======================================================================
C
      IF (SKYRME.EQ.'T3X3') THEN
C
          T3 = -.6772500D+04
          X3 = +.4500000D+00
C
          ISKYRM=1
C
      END IF
C
C=======================================================================
C
      IF (SKYRME.EQ.'T0X0') THEN
C
          T0 = -.1128750D+04
          X0 = +.4500000D+00
C
          ISKYRM=1
C
      END IF
C
C=======================================================================
C
      IF (SKYRME.EQ.'DELT') THEN
C
          T0 = -.4000000D+03
          X0 = -.1000000D+01
C
          ISKYRM=1
C
      END IF
C
C=======================================================================
C
      IF (SKYRME.EQ.'ATOM') THEN
C
          T0 = -.1000000D+01
          X0 = -.1000000D+01
C
          HBMSKY = 3.0D+00
C
          ISKYRM=1
C
      END IF
C
C=======================================================================
C
      IF (SKYRME.EQ.'T0T3') THEN
C
          T0 = -.1128750D+04
          X0 = +.4500000D+00
C
          T3 = +.1400000D+05
          X3 = +.1000000D+01
C
          POWER = .10000D+01
C
          ISKYRM=1
C
      END IF
C
C=======================================================================
C
      IF (SKYRME.EQ.'T03W') THEN
C
          T0 = -.1128750D+04
          X0 = +.4500000D+00
C
          T3 = +.1400000D+05
          X3 = +.1000000D+01
C
          POWER = .10000D+01
C
          W0 = +.1200000D+03
C
          ISKYRM=1
C
      END IF
C
C=======================================================================
C
      IF (SKYRME.EQ.'NOW0') THEN
C
          T0 = -.1128750D+04
          X0 = +.4500000D+00
C
          T1 = +.3950000D+03
          X1 = +.0000000D+00
C
          T2 = -.9500000D+02
          X2 = +.0000000D+00
C
          T3 = +.1400000D+05
          X3 = +.1000000D+01
C
          POWER = .10000D+01
C
          ISKYRM=1
C
      END IF
C
C=======================================================================
C
      IF (SKYRME.EQ.'T013') THEN
C
          T0 = -.1128750D+04
          X0 = +.4500000D+00
C
          T1 = +.3950000D+03
          X1 = +.0000000D+00
C
          T3 = +.1400000D+05
          X3 = +.1000000D+01
C
          POWER = .10000D+01
C
          ISKYRM=1
C
      END IF
C
C=======================================================================
C
      IF (SKYRME.EQ.'T023') THEN
C
          T0 = -.1128750D+04
          X0 = +.4500000D+00
C
          T2 = -.9500000D+02
          X2 = +.0000000D+00
C
          T3 = +.1400000D+05
          X3 = +.1000000D+01
C
          POWER = .10000D+01
C
          ISKYRM=1
C
      END IF
C
C=======================================================================
C         SKYRME FORCE PARAMETERS VERSION      ----SII----
C=======================================================================
C
      IF (SKYRME.EQ.'SII ') THEN
C
          T0 = -.1169900D+04
          X0 = +.3400000D+00
C
          T1 = +.5866000D+03
          X1 = +.0000000D+00
C
          T2 = -.2710000D+02
          X2 = +.0000000D+00
C
          T3 = +.0933110D+05
          X3 = +.1000000D+01
C
          W0 = +.1050000D+03
C
          POWER = .10000D+01
C
          IETA_J = 0
          IETA_W = 0
          IETA_M = 1
C
          HBMSKY = 20.730D0
          RHOSKY =  0.145D0
          EFFSKY =  0.580D0
C
          ISKYRM=1
C
      END IF
C
C=======================================================================
C         SKYRME FORCE PARAMETERS VERSION      ----SIII----
C=======================================================================
C
      IF (SKYRME.EQ.'SIII') THEN
C
          T0 = -.1128750D+04
          X0 = +.4500000D+00
C
          T1 = +.3950000D+03
          X1 = +.0000000D+00
C
          T2 = -.9500000D+02
          X2 = +.0000000D+00
C
          T3 = +.1400000D+05
          X3 = +.1000000D+01
C
          W0 = +.1200000D+03
C
          POWER = .10000D+01
C
          IETA_J = 0
          IETA_W = 0
          IETA_M = 1
C
          HBMSKY = 20.73533D0
          RHOSKY =  0.14500D0
          EFFSKY =  0.76300D0
C
          ISKYRM=1
C
      END IF
C
C=======================================================================
C         SKYRME FORCE PARAMETERS VERSION      ----SV----
C=======================================================================
C
      IF (SKYRME.EQ.'SV  ') THEN
C
          T0 = -.1248290D+04
          X0 = -.1700000D+00
C
          T1 = +.9705600D+03
          X1 = +.0000000D+00
C
          T2 = +.1072200D+03
          X2 = +.0000000D+00
C
          T3 = +.0000000D+00
          X3 = +.1000000D+01
C
          W0 = +.1500000D+03
C
          POWER = .10000D+01
C
          IETA_J = 0
          IETA_W = 0
          IETA_M = 1
C
          HBMSKY = 20.73D0
C
          ISKYRM=1
C
      END IF
C
C=======================================================================
C         SKYRME FORCE PARAMETERS VERSION      ----SVI----
C=======================================================================
C
      IF (SKYRME.EQ.'SVI ') THEN
C
          T0 = -.1101810D+04
          X0 = +.5830000D+00
C
          T1 = +.2716700D+03
          X1 = +.0000000D+00
C
          T2 = -.1383300D+03
          X2 = +.0000000D+00
C
          T3 = +.1700000D+05
          X3 = +.1000000D+01
C
          W0 = +.1150000D+03
C
          POWER = .10000D+01
C
          IETA_J = 0
          IETA_W = 0
          IETA_M = 1
C
          HBMSKY = 20.730D0
          RHOSKY =  0.145D0
          EFFSKY =  0.950D0
C
          ISKYRM=1
C
      END IF
C
C=======================================================================
C         SKYRME FORCE PARAMETERS VERSION      ----SKM*----
C=======================================================================
C
      IF (SKYRME.EQ.'SKM*') THEN
C
          T0 = -.2645000D+04
          X0 = +.0900000D+00
C
          T1 = +.4100000D+03
          X1 = +.0000000D+00
C
          T2 = -.1350000D+03
          X2 = +.0000000D+00
C
          T3 = +.1559500D+05
          X3 = +.0000000D+00
C
          W0 = +.1300000D+03
C
          POWER = 1.0D0/6.0D0
C
          IETA_J = 0
          IETA_W = 0
          IETA_M = 1
C
C=======================================================================
C         ATTENTION: IN ALL VERSIONS AFTER 1.93B AND BEFORE  2.05F,  THE
C                    VALUE OF VARIABLE "HBMSKY" FOR THE SKM*  FORCE  WAS
C                    INCORRECTLY SET TO 20.7525. THIS BUG WAS  CORRECTED
C                    IN VERSION 2.05F ON 07/12/2003.
C=======================================================================
C
          HBMSKY = 20.730D0
          RHOSKY =  0.160D0
          EFFSKY =  0.789D0
C
          ISKYRM=1
C
      END IF
C
C=======================================================================
C         SKYRME FORCE PARAMETERS VERSION      ----SKP----
C=======================================================================
C
      IF (SKYRME.EQ.'SKP ') THEN
C
          T0 = -.2931696D+04
          X0 = 0.2921515D+00
C
          T1 = 0.3206182D+03
          X1 = 0.6531765D+00
C
          T2 = -.3374091D+03
          X2 = -.5373230D+00
C
          T3 = 0.1870896D+05
          X3 = 0.1810269D+00
C
          W0 = 0.1000000D+03
C
          POWER = 1.0D0/6.0D0
C
          IETA_J = 1
          IETA_W = 0
          IETA_M = 1
C
          HBMSKY = 20.730D0
          RHOSKY =  0.162D0
          EFFSKY =  1.000D0
C
          ISKYRM=1
C
      END IF
C
C=======================================================================
C         SKYRME FORCE PARAMETERS VERSION      ----SKMP----
C=======================================================================
C
      IF (SKYRME.EQ.'SKMP') THEN
C
          T0 = -.237224D+04
          X0 = -.157563D+00
C
          T1 = 0.503623D+03
          X1 = -.402886D+00
C
          T2 = 0.572783D+02
          X2 = -.295571D+01
C
          T3 = 0.125853D+05
          X3 = -.267933D+00
C
          W0 = 0.1600000D+03
C
          POWER = 1.0D0/6.0D0
C
          IETA_J = 1
          IETA_W = 0
          IETA_M = 1
C
          HBMSKY = 20.73D0
C
          ISKYRM=1
C
      END IF
C
C=======================================================================
C         SKYRME FORCE PARAMETERS VERSION      ----SKI1----
C=======================================================================
C
      IF (SKYRME.EQ.'SKI1') THEN
C
          T0 = -.1913623D+04
          X0 = -.9545340D+00
C
          T1 = 0.4398080D+03
          X1 =-5.7824040D+00
C
          T2 = 0.2697599D+04
          X2 =-1.2873790D+00
C
          T3 = 0.10592296D+05
          X3 =-1.5614160D+00
C
          W0 = 0.1242590D+03
C
          POWER = 1.0D0/4.0D0
C
          IETA_J = 0
          IETA_W = 0
          IETACM = 1
          IETA_M = 1
C
          HBMSKY = 20.7525D0
C
          ISKYRM=1
C
      END IF
C
C=======================================================================
C         SKYRME FORCE PARAMETERS VERSION      ----SKI2----
C                                Source: Nucl. Phys. A585 (1995) 467-488
C=======================================================================
C
      IF (SKYRME.EQ.'SKI2') THEN
C
          T0 = -.191543D+04
          X0 = -.210800D+00
C
          T1 = 0.438449D+03
          X1 =-1.737600D+00
C
          T2 = 0.305446D+03
          X2 =-1.533600D+00
C
          T3 = 0.105489D+05
          X3 =-0.178000D+00
C
          B4 = 0.60301D+02
          B4P= 0.60301D+02
C
          POWER = 1.0D0/4.0D0
C
          IETA_J = 0
          IETA_W = 1
          IETACM = 1
          IETA_M = 1
C
          HBMSKY = 20.7525D0
          RHOSKY =  0.1580D0
          EFFSKY =  0.6850D0
C
          ISKYRM=1
C
      END IF
C
C=======================================================================
C         SKYRME FORCE PARAMETERS VERSION      ----SKI3----
C                                Source: Nucl. Phys. A585 (1995) 467-488
C=======================================================================
C
      IF (SKYRME.EQ.'SKI3') THEN
C
          T0 = -.176288D+04
          X0 = 0.308300D+00
C
          T1 = 0.561608D+03
          X1 =-1.172200D+00
C
          T2 = -.227090D+03
          X2 =-1.090700D+00
C
          T3 = 0.810620D+04
          X3 = 1.292600D+00
C
          B4 = 0.94254D+02
          B4P= 0.0D0
C
          POWER = 1.0D0/4.0D0
C
          IETA_J = 0
          IETA_W = 1
          IETACM = 1
          IETA_M = 1
C
          HBMSKY = 20.7525D0
          RHOSKY =  0.1580D0
          EFFSKY =  0.5770D0
C
          ISKYRM=1
C
      END IF
C
C=======================================================================
C         SKYRME FORCE PARAMETERS VERSION      ----SKI4----
C                                Source: Nucl. Phys. A585 (1995) 467-488
C=======================================================================
C
      IF (SKYRME.EQ.'SKI4') THEN
C
          T0 = -.185583D+04
          X0 = 0.405100D+00
C
          T1 = 0.473829D+03
          X1 =-2.889100D+00
C
          T2 = 0.100686D+04
          X2 =-1.325200D+00
C
          T3 = 0.970361D+04
          X3 = 1.145200D+00
C
          B4 = 0.183097D+03
          B4P= -.180351D+03
C
          POWER = 1.0D0/4.0D0
C
          IETA_J = 0
          IETA_W = 1
          IETACM = 1
          IETA_M = 1
C
          HBMSKY = 20.7525D0
          RHOSKY =  0.1600D0
          EFFSKY =  0.6500D0
C
          ISKYRM=1
C
      END IF
C
C=======================================================================
C         SKYRME FORCE PARAMETERS VERSION      ----SKI5----
C                                Source: Nucl. Phys. A585 (1995) 467-488
C=======================================================================
C
      IF (SKYRME.EQ.'SKI5') THEN
C
          T0 = -.177291D+04
          X0 = -.117100D+00
C
          T1 = 0.550840D+03
          X1 =-1.308800D+00
C
          T2 = -.126685D+03
          X2 =-1.048700D+00
C
          T3 = 0.820625D+04
          X3 = 0.341000D+00
C
          B4 = 0.618150D+02
          B4P= 0.618150D+02
C
          POWER = 1.0D0/4.0D0
C
          IETA_J = 0
          IETA_W = 1
          IETACM = 1
          IETA_M = 1
C
          HBMSKY = 20.7525D0
          RHOSKY =  0.1560D0
          EFFSKY =  0.5790D0
C
          ISKYRM=1
C
      END IF
C
C=======================================================================
C         SKYRME FORCE PARAMETERS VERSION      ----SKO----
C=======================================================================
C
      IF (SKYRME.EQ.'SKO ') THEN
C
          T0 =-0.2103653D+04
          X0 =-0.2107010D+00
C
          T1 = 0.3033520D+03
          X1 =-2.8107520D+00
C
          T2 = 0.7916740D+03
          X2 =-1.4615950D+00
C
          T3 = 0.13553252D+05
          X3 =-0.4298810D+00
C
          B4 = 0.1765780D+03
          B4P=-0.1987490D+03
C
          POWER = 1.0D0/4.0D0
C
          IETA_J = 0
          IETA_W = 1
          IETACM = 1
          IETA_M = 1
C
          HBMSKY = 20.73553D0
C
          ISKYRM=1
C
      END IF
C
C=======================================================================
C         SKYRME FORCE PARAMETERS VERSION      ----SKOP----
C=======================================================================
C
      IF (SKYRME.EQ.'SKOP') THEN
C
          T0 =-0.2099419D+04
          X0 =-0.0295030D+00
C
          T1 = 0.3015310D+03
          X1 =-1.3257320D+00
C
          T2 = 0.1547810D+03
          X2 =-2.3234390D+00
C
          T3 = 0.13526464D+05
          X3 =-0.1474040D+00
C
          B4 = 0.1438950D+03
          B4P=-0.8288880D+02
C
          POWER = 1.0D0/4.0D0
C
          IETA_J = 1
          IETA_W = 1
          IETACM = 1
          IETA_M = 1
C
          HBMSKY = 20.73553D0
          RHOSKY =  0.16000D0
          EFFSKY =  0.89600D0
C
          ISKYRM=1
C
      END IF
C
C=======================================================================
C         SKYRME FORCE PARAMETERS VERSION      ----sLy4----
C=======================================================================
C         ATTENTION: UP THE THE VERSION 2.44R  OF  THE  CODE,  THE  SLY4
C                    VALUES WERE DIFFERENT THAN THOSE IN THE PUBLICATION
C                    OF CHABANAT ET AL. NP635-231 BECAUSE SUCH HAVE BEEN
C                    RECOMMENDED  BY  THE  AUTHORS  OF  THE  FORCE.  THE
C                    DIFFERENCES BASICALLY CONCERED THE UNROUNDED VALUES
C                    OF THE PARAMETERS. HOWEVER, THIS RECOMMENDATION WAS
C                    WITHDRAWN  IN  THE  EMAIL  OF  KARIM  BENNACEUR  OF
C                    21/12/2009 WHO RECOMMENDED USING THE ORIGINAL  ONES
C                    FROM NP635-231. THIS  BUG  HAS  BEEN  CORRECTED  IN
C                    VERSION 2.44R ON 25/12/2009.
C                    NEVERTHELESS, FOR DOWNWARD COMPATIBILITY,  PREVIOUS
C                    VALUES ARE STILL KEPT IN THE CODE UNDER THE ACRONYM
C                    OF "SLY4".
C=======================================================================
C
      IF (SKYRME.EQ.'sLy4') THEN
C
          T0 = -0.2488910D+04
          X0 =  0.8340000D+00
C
          T1 =  0.4868200D+03
          X1 = -0.3440000D+00
C
          T2 = -0.5463900D+03
          X2 = -1.0000000D+00
C
          T3 =  0.1377700D+05
          X3 =  1.3540000D+00
C
          W0 =  0.1230000D+03
C
          POWER = 1.0D0/6.0D0
C
          IETA_J = 0
          IETA_W = 0
          IETA_M = 1
C
          HBMSKY = 20.73553D0
          RHOSKY =  0.16000D0
          EFFSKY =  0.69400D0
C
          ISKYRM=1
C
      END IF
C
C=======================================================================
C         SKYRME FORCE PARAMETERS VERSION      ----sLy5----
C=======================================================================
C         ATTENTION: UP THE THE VERSION 2.44K  OF  THE  CODE,  THE  SLY5
C                    VALUES WERE DIFFERENT THAN THOSE IN THE PUBLICATION
C                    OF CHABANAT ET AL. NP635-231 BECAUSE SUCH HAVE BEEN
C                    RECOMMENDED BY THE AUTHORS OF THE  FORCE.  HOWEVER,
C                    THIS RECOMMENDATION WAS WITHDRAWN IN THE  EMAIL  OF
C                    KARIM BENNACEUR OF 17/12/2009 WHO RECOMMENDED USING
C                    THE ORIGINAL VALUES FROM NP635-231.  THIS  BUG  HAS
C                    BEEN CORRECTED IN VERSION 2.44L ON 18/12/2009.
C                    NEVERTHELESS, FOR DOWNWARD COMPATIBILITY,  PREVIOUS
C                    VALUES ARE STILL KEPT IN THE CODE UNDER THE ACRONYM
C                    OF "SLY5" AND "SLY7".
C=======================================================================
C
      IF (SKYRME.EQ.'sLy5') THEN
C
          T0 = -2484.880D+00
          X0 =     0.778D+00
C
          T1 =   483.130D+00
          X1 =    -0.328D+00
C
          T2 =  -549.400D+00
          X2 =    -1.000D+00
C
          T3 = 13763.000D+00
          X3 =     1.267D+00
C
          W0 =   126.000D+00
C
          POWER = 1.0D0/6.0D0
C
          IETA_J = 1
          IETA_W = 0
          IETA_M = 1
C
          HBMSKY = 20.73553D0
          RHOSKY =  0.16000D0
          EFFSKY =  0.69700D0
C
          ISKYRM=1
C
      END IF
C
C=======================================================================
C         SKYRME FORCE PARAMETERS VERSION      ----sLy6----
C=======================================================================
C
      IF (SKYRME.EQ.'sLy6') THEN
C
          T0 = -0.2479500D+04
          X0 =  0.8250000D+00
C
          T1 =  0.4621800D+03
          X1 = -0.4650000D+00
C
          T2 = -0.4486100D+03
          X2 = -1.0000000D+00
C
          T3 =  0.1367300D+05
          X3 =  1.3550000D+00
C
          W0 =  0.1220000D+03
C
          POWER = 1.0D0/6.0D0
C
          IETA_J = 0
          IETA_W = 0
          IETACM = 1
          IETA_M = 1
C
          HBMSKY = 20.73553D0
          RHOSKY =  0.15900D0
          EFFSKY =  0.69000D0
C
          ISKYRM=1
C
      END IF
C
C=======================================================================
C         SKYRME FORCE PARAMETERS VERSION      ----sLy7----
C=======================================================================
C         ATTENTION: SEE THE COMMENT REGARDING THE SLY5 FORCE ABOVE
C=======================================================================
C
      IF (SKYRME.EQ.'sLy7') THEN
C
          T0 = -2482.410D+00
          X0 =     0.846D+00
C
          T1 =   457.970D+00
          X1 =    -0.510D+00
C
          T2 =  -419.850D+00
          X2 =    -1.000D+00
C
          T3 = 13677.000D+00
          X3 =     1.391D+00
C
          W0 =   126.000D+00
C
          POWER = 1.0D0/6.0D0
C
          IETA_J = 1
          IETA_W = 0
          IETACM = 1
          IETA_M = 1
C
          HBMSKY = 20.73553D0
          RHOSKY =  0.15800D0
          EFFSKY =  0.68800D0
C
          ISKYRM=1
C
      END IF
C
C=======================================================================
C         SKYRME FORCE PARAMETERS VERSION      ----SLY4----
C=======================================================================
C         ATTENTION: SEE THE COMMENT REGARDING THE sLy4 FORCE ABOVE
C=======================================================================
C
      IF (SKYRME.EQ.'SLY4') THEN
C
          T0 = -0.2488913D+04
          X0 =  0.8340000D+00
C
          T1 =  0.4868180D+03
          X1 = -0.3440000D+00
C
          T2 = -0.5463950D+03
          X2 = -1.0000000D+00
C
          T3 =  0.1377700D+05
          X3 =  1.3540000D+00
C
          W0 =  0.1230000D+03
C
          POWER = 1.0D0/6.0D0
C
          IETA_J = 0
          IETA_W = 0
          IETA_M = 1
C
          HBMSKY = 20.73553D0
          RHOSKY =  0.16000D0
          EFFSKY =  0.69400D0
C
          ISKYRM=1
C
      END IF
C
C=======================================================================
C         SKYRME FORCE PARAMETERS VERSION      ----SLY5----
C=======================================================================
C         ATTENTION: UP THE THE VERSION 2.11 OF THE CODE, THE  VALUE  OF
C                    T0 WAS INCORRECTLY SET TO -0.2488345D+04, THIS  BUG
C                    HAS BEEN CORRECTED IN VERSION 2.11A ON  19/07/2004.
C=======================================================================
C         ATTENTION: SEE THE COMMENT REGARDING THE sLy5 FORCE ABOVE
C=======================================================================
C
      IF (SKYRME.EQ.'SLY5') THEN
C
          T0 = -0.2483450D+04
          X0 =  0.7760000D+00
C
          T1 =  0.4842300D+03
          X1 = -0.3170000D+00
C
          T2 = -0.5566900D+03
          X2 = -1.0000000D+00
C
          T3 =  0.1375700D+05
          X3 =  1.2630000D+00
C
          W0 =  0.1250000D+03
C
          POWER = 1.0D0/6.0D0
C
          IETA_J = 1
          IETA_W = 0
          IETA_M = 1
C
          HBMSKY = 20.73553D0
          RHOSKY =  0.16100D0
          EFFSKY =  0.69800D0
C
          ISKYRM=1
C
      END IF
C
C=======================================================================
C         SKYRME FORCE PARAMETERS VERSION      ----SLY6----
C=======================================================================
C
      IF (SKYRME.EQ.'SLY6') THEN
C
          T0 = -0.2479500D+04
          X0 =  0.8250000D+00
C
          T1 =  0.4621800D+03
          X1 = -0.4650000D+00
C
          T2 = -0.4486100D+03
          X2 = -1.0000000D+00
C
          T3 =  0.1367300D+05
          X3 =  1.3550000D+00
C
          W0 =  0.1220000D+03
C
          POWER = 1.0D0/6.0D0
C
          IETA_J = 0
          IETA_W = 0
          IETACM = 1
          IETA_M = 1
C
          HBMSKY = 20.73553D0
          RHOSKY =  0.15900D0
          EFFSKY =  0.69000D0
C
          ISKYRM=1
C
      END IF
C
C=======================================================================
C         SKYRME FORCE PARAMETERS VERSION      ----SLY7----
C=======================================================================
C         ATTENTION: SEE THE COMMENT REGARDING THE sLy5 FORCE ABOVE
C=======================================================================
C
      IF (SKYRME.EQ.'SLY7') THEN
C
          T0 = -0.2480800D+04
          X0 =  0.8480000D+00
C
          T1 =  0.4612900D+03
          X1 = -0.4920000D+00
C
          T2 = -0.4339300D+03
          X2 = -1.0000000D+00
C
          T3 =  0.1366900D+05
          X3 =  1.3930000D+00
C
          W0 =  0.1250000D+03
C
          POWER = 1.0D0/6.0D0
C
          IETA_J = 1
          IETA_W = 0
          IETACM = 1
          IETA_M = 1
C
          HBMSKY = 20.73553D0
          RHOSKY =  0.15800D0
          EFFSKY =  0.68800D0
C
          ISKYRM=1
C
      END IF
C
C=======================================================================
C         SKYRME FORCE PARAMETERS VERSION      ----MSK1----
C=======================================================================
C
      IF (SKYRME.EQ.'MSK1') THEN
C
          T0 = -0.1813030D+04
          X0 =  0.3653950D+00
C
          T1 =  0.2748280D+03
          X1 = -0.5000000D+00
C
          T2 = -0.2748280D+03
          X2 = -0.5000000D+00
C
          T3 =  0.1305010D+05
          X3 =  0.4498820D+00
C
          W0 =  0.1167080D+03
C
          POWER = 1.0D0/3.0D0
C
          IETA_J = 1
          IETA_W = 0
          IETA_M = 1
C
          HBMSKY = 20.73553D0
          RHOSKY =  0.15750D0
          EFFSKY =  1.00000D0
C
          ISKYRM=1
C
          WRITE(NFIPRI,'(79(1H*),/,          1H*,77X,1H*,/,
     *          1H*,10X,''ATTENTION:  THE SKYRME FORCE  "'',A4,''"  '',
     *                  ''REQUIRES A SPECIAL'',  11X,1H*,/,
     *          1H*,10X,''TREATMENT OF THE TENSOR TERM THAT IS NOT '',
     *                  ''YET IMPLEMENTED'',     11X,1H*,/,
     *                                       1H*,77X,1H*)')
     *      SKYRME
C
      END IF
C
C=======================================================================
C         SKYRME FORCE PARAMETERS VERSION      ----MSK2----
C=======================================================================
C
      IF (SKYRME.EQ.'MSK2') THEN
C
          T0 = -0.1830670D+04
          X0 =  0.3568750D+00
C
          T1 =  0.2603010D+03
          X1 = -0.5000000D+00
C
          T2 = -0.2937420D+03
          X2 = -0.5000000D+00
C
          T3 =  0.1344210D+05
          X3 =  0.4097590D+00
C
          W0 =  0.1166630D+03
C
          POWER = 1.0D0/3.0D0
C
          IETA_J = 1
          IETA_W = 0
          IETA_M = 1
C
          HBMSKY = 20.73553D0
          RHOSKY =  0.15750D0
          EFFSKY =  1.05000D0
C
          ISKYRM=1
C
          WRITE(NFIPRI,'(79(1H*),/,          1H*,77X,1H*,/,
     *          1H*,10X,''ATTENTION:  THE SKYRME FORCE  "'',A4,''"  '',
     *                  ''REQUIRES A SPECIAL'',  11X,1H*,/,
     *          1H*,10X,''TREATMENT OF THE TENSOR TERM THAT IS NOT '',
     *                  ''YET IMPLEMENTED'',     11X,1H*,/,
     *                                       1H*,77X,1H*)')
     *      SKYRME
C
      END IF
C
C=======================================================================
C         SKYRME FORCE PARAMETERS VERSION      ----MSK3----
C=======================================================================
C
      IF (SKYRME.EQ.'MSK3') THEN
C
          T0 = -0.1810320D+04
          X0 =  0.6314850D+00
C
          T1 =  0.2690920D+03
          X1 = -0.5000000D+00
C
          T2 = -0.2690920D+03
          X2 = -0.5000000D+00
C
          T3 =  0.1302750D+05
          X3 =  0.9036800D+00
C
          W0 =  0.1168710D+03
C
          POWER = 1.0D0/3.0D0
C
          IETA_J = 1
          IETA_W = 0
          IETA_M = 1
C
          HBMSKY = 20.73553D0
          RHOSKY =  0.15750D0
          EFFSKY =  1.00000D0
C
          WRITE(NFIPRI,'(79(1H*),/,          1H*,77X,1H*,/,
     *          1H*,10X,''ATTENTION:  THE SKYRME FORCE  "'',A4,''"  '',
     *                  ''REQUIRES A SPECIAL'',  11X,1H*,/,
     *          1H*,10X,''TREATMENT OF THE TENSOR TERM THAT IS NOT '',
     *                  ''YET IMPLEMENTED'',     11X,1H*,/,
     *                                       1H*,77X,1H*)')
     *      SKYRME
C
          ISKYRM=1
C
      END IF
C
C=======================================================================
C         SKYRME FORCE PARAMETERS VERSION      ----MSK4----
C=======================================================================
C
      IF (SKYRME.EQ.'MSK4') THEN
C
          T0 = -0.1827960D+04
          X0 =  0.6103600D+00
C
          T1 =  0.2541290D+03
          X1 = -0.5000000D+00
C
          T2 = -0.2875690D+03
          X2 = -0.5000000D+00
C
          T3 =  0.1341950D+05
          X3 =  0.8350630D+00
C
          W0 =  0.1159430D+03
C
          POWER = 1.0D0/3.0D0
C
          IETA_J = 1
          IETA_W = 0
          IETA_M = 1
C
          HBMSKY = 20.73553D0
          RHOSKY =  0.15750D0
          EFFSKY =  1.05000D0
C
          ISKYRM=1
C
          WRITE(NFIPRI,'(79(1H*),/,          1H*,77X,1H*,/,
     *          1H*,10X,''ATTENTION:  THE SKYRME FORCE  "'',A4,''"  '',
     *                  ''REQUIRES A SPECIAL'',  11X,1H*,/,
     *          1H*,10X,''TREATMENT OF THE TENSOR TERM THAT IS NOT '',
     *                  ''YET IMPLEMENTED'',     11X,1H*,/,
     *                                       1H*,77X,1H*)')
     *      SKYRME
C
      END IF
C
C
C=======================================================================
C         SKYRME FORCE PARAMETERS VERSION      ----MSK5----
C=======================================================================
C
      IF (SKYRME.EQ.'MSK5') THEN
C
          T0 = -0.1827960D+04
          X0 =  0.6051520D+00
C
          T1 =  0.2543260D+03
          X1 = -0.5000000D+00
C
          T2 = -0.2877660D+03
          X2 = -0.5000000D+00
C
          T3 =  0.1341950D+05
          X3 =  0.8271820D+00
C
          W0 =  0.1159320D+03
C
          POWER = 1.0D0/3.0D0
C
          IETA_J = 1
          IETA_W = 0
          IETA_M = 1
C
          HBMSKY = 20.73553D0
          RHOSKY =  0.15750D0
          EFFSKY =  1.05000D0
C
          ISKYRM=1
C
          WRITE(NFIPRI,'(79(1H*),/,          1H*,77X,1H*,/,
     *          1H*,10X,''ATTENTION:  THE SKYRME FORCE  "'',A4,''"  '',
     *                  ''REQUIRES A SPECIAL'',  11X,1H*,/,
     *          1H*,10X,''TREATMENT OF THE TENSOR TERM THAT IS NOT '',
     *                  ''YET IMPLEMENTED'',     11X,1H*,/,
     *                                       1H*,77X,1H*)')
     *      SKYRME
C
      END IF
C
C
C=======================================================================
C         SKYRME FORCE PARAMETERS VERSION      ----MSK6----
C=======================================================================
C
      IF (SKYRME.EQ.'MSK6') THEN
C
          T0 = -0.1827960D+04
          X0 =  0.5765910D+00
C
          T1 =  0.2584830D+03
          X1 = -0.5000000D+00
C
          T2 = -0.2919240D+03
          X2 = -0.5000000D+00
C
          T3 =  0.1341950D+05
          X3 =  0.7839560D+00
C
          W0 =  0.1188070D+03
C
          POWER = 1.0D0/3.0D0
C
          IETA_J = 1
          IETA_W = 0
          IETA_M = 1
C
          HBMSKY = 20.73553D0
          RHOSKY =  0.15750D0
          EFFSKY =  1.05000D0
C
          ISKYRM=1
C
          WRITE(NFIPRI,'(79(1H*),/,          1H*,77X,1H*,/,
     *          1H*,10X,''ATTENTION:  THE SKYRME FORCE  "'',A4,''"  '',
     *                  ''REQUIRES A SPECIAL'',  11X,1H*,/,
     *          1H*,10X,''TREATMENT OF THE TENSOR TERM THAT IS NOT '',
     *                  ''YET IMPLEMENTED'',     11X,1H*,/,
     *                                       1H*,77X,1H*)')
     *      SKYRME
C
      END IF
C
C=======================================================================
C         SKYRME FORCE PARAMETERS VERSION      ----SKX----
C         [Brown PRC58 (1998) 220]  (m_eff=0.99)
C=======================================================================
C
      IF (SKYRME.EQ.'SKX ') THEN
C
          T0 = -.1445300D+04
          X0 = +.3400000D+00
C
          T1 = +.2469000D+03
          X1 = +.5800000D+00
C
          T2 = -.1318000D+03
          X2 = +.1270000D+00
C
          T3 = +.1210390D+05
          X3 = +.0300000D+00
C
          B4 = +.0743000D+03
          B4P=  .0000000D+00
C
          POWER = .50000D+00
C
          IETA_J = 1
          IETA_W = 1
          IETA_M = 1
C
          COUSCA = 0.0D0
C
          HBMSKY = 20.73D0
          EFFSKY =  0.99D0
C
          ISKYRM=1
C
c          WRITE(NFIPRI,'(79(1H*),/,          1H*,77X,1H*,/,
c     *          1H*,10X,''ATTENTION:  THE SKYRME FORCE  "'',A4,''"  '',
c     *                  ''REQUIRES  REMOVING'',  11X,1H*,/,
c     *          1H*,10X,''THE  COULOMB  EXCHANGE  TERM THAT IS NOT '',
c     *                  ''YET IMPLEMENTED'',     11X,1H*,/,
c     *                                       1H*,77X,1H*)')
c     *      SKYRME
C
      END IF
C
C=======================================================================
C         SKYRME FORCE PARAMETERS VERSION      ----SKXc----
C         [Brown PRC58 (1998) 220]  (m_eff=0.99)
C=======================================================================
C
      IF (SKYRME.EQ.'SKXC') THEN
C
          T0 = -.1438000D+04
          X0 = +.2880000D+00
C
          T1 = +.2443000D+03
          X1 = +.6110000D+00
C
          T2 = -.1337000D+03
          X2 = +.1450000D+00
C
          T3 = +.1211630D+05
          X3 = -.0560000D+00
C
          B4 = +.0728500D+03
          B4P=  .0000000D+00
C
          POWER = .50000D+00
C
          IETA_J = 1
          IETA_W = 1
          IETA_M = 1
C
          HBMSKY = 20.73D0
          EFFSKY =  0.99D0
C
          ISKYRM=1
C
      END IF
C
C=======================================================================
C         SKYRME FORCE PARAMETERS VERSION      ----UDF0----
C         [Kortelainen PRC82, 024313 (2010), Marcus email 09/11/2011)
C=======================================================================
C         ATTENTION: BETWEEN VERSIONS 2.49X AND 2.51A, THE PARAMETER SET
C                    UDF0 WAS NOT CODED  IN  AGREEMENT  WITH  THE  DRAFT
C                    PAPER OF THE  UNEDF  COLLABORATION.  THIS  BUG  WAS
C                    CORRECTED ON 09/11/2011 IN VERSIONS 2.51B AND 2.49Y
C                    BASED ON VALUES GIVEN IN  MARCUS'  EMAIL,  HOWEVER,
C                    THE PREVIOUS FORCE IS STILL KEPT IN THE CODE  UNDER
C                    THE ACRONYM OF "UDFz".
C=======================================================================
C         ATTENTION: BETWEEN VERSIONS 2.51A AND 2.552, THE PARAMETER SET
C                    UDF0  WAS  INCORRECTLY  CODED  WITHOUT  THE   C-O-M
C                    CORRECTION, IETACM=3, WHEREAS THE FORCE WAS  FITTED
C                    WITH  THE  STANDARD  C-O-M  CORRECTION   AND   THUS
C                    REQUIRES IETACM=0. THIS BUG WAS CORRECTED
C                    ON 04/11/2012 IN VERSION 2.553.
C=======================================================================
C
      IF (SKYRME.EQ.'UDF0') THEN
C
          T0 = -1883.68781034D+00
          X0 =    +0.00974375D+00
C
          T1 =  +277.50021224D+00
          X1 =    -1.77784395D+00
C
          T2 =  +608.43090559D+00
          X2 =    -1.67699035D+00
C
          T3 =+13901.94834463D+00
          X3 =    -0.38079041D+00
C
          B4 =  +125.16100000D+00
          B4P=    -91.2604000D+00
C
          POWER =  0.32195599D+00
C
          IETA_J = 0
          IETA_W = 1
          IETACM = 0
          IETA_M = 1
C
          HBMSKY = 20.73553D+00
          RHOSKY = 0.160526D+00
          EFFSKY = 0.900000D+00
C
          ISKYRM=1
C
      END IF
C
C=======================================================================
C
      IF (SKYRME.EQ.'D1S ') THEN
C
          T3 = +.1390600D+04*6
          X3 = +.1000000D+01
C
          POWER = 1.0D0/3.0D0
C
          W0 = +.1300000D+03
C
          IETA_M = 1
          HBMSKY = 0.5D0/0.024111868D0
C
          ISKYRM=1
C
      END IF
C
C=======================================================================
C
      IF (SKYRME.EQ.'MINN') THEN
C
          IETA_M = 1
          IETACM = 3
          HBMSKY = 20.735489D0
C
          ISKYRM=1
C
      END IF
C
C=======================================================================
C         SKYRME FORCE PARAMETERS VERSION      ----SD1S----
C         DERIVED FROM THE NV EXPANSION OF THE GOGNY D1S FORCE
C         FOR KF=1.35, SEE CODE LDA18F.F OF 22/01/2010
C=======================================================================
C
      IF (SKYRME.EQ.'SD1S') THEN
C
          T0 = -0.1601642D+04
          X0 = +0.5697973D+00
C
          T1 = +0.5505103D+03
          X1 = +0.9972498D-01
C
          T2 = -0.1660707D+03
          X2 = -0.5517182D+00
C
          T3 = +0.1390600D+04*6
          X3 = +0.1000000D+01
C
          POWER = 1.0D0/3.0D0
C
          W0 = +.1300000D+03
C
          IETA_J = 1
          IETA_W = 0
          IETA_M = 1
C
          HBMSKY = 20.734863D0
          RHOSKY =  0.161000D0
          EFFSKY =  0.620000D0
C
          ISKYRM=1
C
      END IF
C
C=======================================================================
C         SKYRME FORCES DERIVED FROM THE FIT OF THE SKYRME ENERGY
C         FUNCTIONAL (COLLABORATION ORNL/ANL)
C=======================================================================
C
      IF (IF_EDF.EQ.1) THEN
C
          CALL paramsFunctional(SKYRME,IETA_J,IETA_W,IETA_M,IETACM,
     *                          ISKYRM,HBMSKY,T0_EFF,T1_EFF,T2_EFF,
     *                          T3_EFF,X0_EFF,X1_EFF,X2_EFF,X3_EFF,
     *                          B4_EFF,B4PEFF,TE_EFF,TO_EFF,POWEFF,
     *                                        V0NEFF,V0PEFF,COUSCA)
C
          T0    = T0_EFF
          T1    = T1_EFF
          T2    = T2_EFF
          T3    = T3_EFF
C
          X0    = X0_EFF
          X1    = X1_EFF
          X2    = X2_EFF
          X3    = X3_EFF
C
          B4    = B4_EFF
          B4P   = B4PEFF
C
          TE    = TE_EFF
          TO    = TO_EFF
C
          POWER = POWEFF
C
          RHOSKY = RHO_NM
          EFFSKY = SMASS_NM
C
          ISKYRM=1
C
C          Setting pairing properties for neutrons and protons
C
          PRHO_N=V0NEFF
          PRHODN=0.00D0
          PRHOSN=0.32D0
          POWERN=1.00D0
C
          CALL RHODEP(2,PRHO_N,PRHODN,PRHOSN,POWERN)
C
          PRHO_P=V0PEFF
          PRHODP=0.00D0
          PRHOSP=0.32D0
          POWERP=1.00D0
C
          CALL RHODEP(2,PRHO_P,PRHODP,PRHOSP,POWERP)
C
      END IF
C
C=======================================================================
C
C         FOR THE SKYRME FORCE THAT USES THE STANDARD  SPIN-ORBIT  FORCE
C         (IETA_W=0), THE VALUE OF PARAMETER "W0P" IS HERE FORCED TO  BE
C         EQUAL TO "W0", WHILE "W0" MUST BE EXPLICITLY PROVIDED  AS  ONE
C         OF THE SKYRME FORCE PARAMETERS.
C
C         FOR THE SKYRME FORCE THAT USES A NONSTANDARD SPIN-ORBIT  FORCE
C         (IETA_W=1), THE VALUES OF PARAMETERS "W0" AND "W0P"  ARE  HERE
C         CALCULATED FROM THE VALUES OF  "B4"  AND  "B4P"  THAT MUST  BE
C         BOTH EXPLICITLY PROVIDED AS THE SKYRME FORCE PARAMETERS.
C
C=======================================================================
C
      IF (IETA_W.EQ.0) THEN
          W0P = W0
      ELSE
          W0  = 2.0D0*B4
          W0P = 2.0D0*B4P
      END IF
C
C=======================================================================
C         SECURITY CHECK OF VALUES OF SWITCHES
C=======================================================================
C
      IF ((IETA_J.NE.0.AND.IETA_J.NE.1).OR.
     *    (IETA_W.NE.0.AND.IETA_W.NE.1).OR.
     *    (IETACM.NE.0.AND.IETACM.NE.1.AND.
     *     IETACM.NE.2.AND.IETACM.NE.3).OR.
     *    (IETA_M.NE.0.AND.IETA_M.NE.1.AND.IETA_M.NE.2)) THEN
C
          WRITE(NFIPRI,'(/,
     *                 1X,20(1H/),''  INCORRECT SWITCHES IN PARAMS'',
     *                                                 7X,20(1H/),/,
     *                 1X,20(1H/),''  IETA_J ='',I2,
     *                            ''  IETA_W ='',I2,
     *                            ''  IETACM ='',I2,   1X,20(1H/),/,
     *                 1X,20(1H/),''  IETA_M ='',I2,  25X,20(1H/),/)')
     *
     *    IETA_J,IETA_W,IETACM,IETA_M
C
          STOP 'INCORRECT SWITCHES IN PARAMS'
C
      END IF
C
C=======================================================================
C         CHECKING IF THE FORCE PARAMETERS HAVE BEN SET
C=======================================================================
C
      IF (ISKYRM.NE.1) THEN
C
          WRITE(NFIPRI,'(/,
     *                 1X,20(1H/),'' UNDEFINED FORCE PARAMETERS'',
     *                                                10X,20(1H/),/,
     *                 1X,20(1H/),'' FORCE ACRONYM '',A4,'' IS NOT'',
     *                            '' SUPPORTED'',
     *                                                 1X,20(1H/),/)')
     *    SKYRME
C
          STOP 'UNDEFINED FORCE PARAMETERS'
C
      END IF
C
C=======================================================================
C         PRINTING THE SKYRME FORCE PARAMETERS
C=======================================================================
C
      WRITE(NFIPRI,'(79(1H*),/,      1H*,77X,1H*,/,
     *      1H*,27X,''SKYRME FORCE DEFINITION'',
     *                                   27X,1H*,/,
     *                               1H*,77X,1H*,/,
     *          79(1H*),/,           1H*,77X,1H*,/,
     *      1H*,1X,''PARAMETER SET '',A4,'':'',
     *      ''  T0='',F9.2,''  T1='',F9.2,
     *      ''  T2='',F9.2,''  T3='',F9.2,1X,1H*)')
     *
     *      SKYRME,T0,T1,T2,T3
C
      IF (IETA_W.EQ.0) THEN
C
          WRITE(NFIPRI,'(            1H*,77X,1H*,/,
     *      1H*,1X,''POWER=1/'',I1,1X,''W='',F7.3,
     *      ''  X0='',F9.5,''  X1='',F9.5,
     *      ''  X2='',F9.5,''  X3='',F9.5,1X,1H*,/,
     *                               1H*,77X,1H*,/,
     *      1H*,1X,''ETA_J='',I1,1X,''ETA_W='',I1,1X,
     *             ''ETACM='',I1,1X,''ETA_M='',I1,3X,
     *             ''HBM='',F9.5,
     *      ''  (SKYRME-FORCE  SPIN-ORBIT)'',
     *                                    1X,1H*,/,
     *                               1H*,77X,1H*,/,
     *                                   79(1H*),/)')
     *
     *      INT(1/POWER+1.0D-10),W0,
     *      X0,X1,X2,X3,
     *      IETA_J,IETA_W,IETACM,IETA_M,
     *      HBMSKY
C
      ELSE
C
          WRITE(NFIPRI,'(            1H*,77X,1H*,/,
     *      1H*,1X,''POWER=1/'',I1,10X,
     *      ''  X0='',F9.5,''  X1='',F9.5,
     *      ''  X2='',F9.5,''  X3='',F9.5,1X,1H*,/,
     *                               1H*,77X,1H*,/,
     *      1H*,1X,''ETA_J='',I1,1X,''ETA_W='',I1,1X,
     *             ''ETACM='',I1,1X,''ETA_M='',I1,3X,
     *             ''HBM='',F9.5,
     *      ''  W0='',F9.4,'' W0P='',F9.4,1X,1H*,/,
     *                               1H*,77X,1H*,/,
     *                                   79(1H*),/)')
     *
     *      INT(1/POWER+1.0D-10),
     *      X0,X1,X2,X3,
     *      IETA_J,IETA_W,IETACM,IETA_M,
     *      HBMSKY,W0,W0P
C
      END IF
C
C=======================================================================
C           DEFINING THE SKYRME-FUNCTIONAL COUPLING CONSTANTS
C=======================================================================
C
C        THE EFFECTIVE COUPLING CONSTANTS ARE CODED AS:
C                      'C'//'XXX'//'N'//'TYP'
C
C        WHERE THE SYMBOLS:  'C', 'XXX', 'N', AND 'TYP'
C        ARE EXPLAINED IN THE SUBROUTINE "ESKYRM"
C
C=======================================================================
C
      CRHO_T = ( + 1.00D0 * T0  +  0.50D0 * T0 * X0 ) /  2.0D0
      CRHO_S = ( - 0.50D0 * T0  -  1.00D0 * T0 * X0 ) /  2.0D0
C
      NRHO_N = 'RHO_'
C
C=======================================================================
C
      CSPI_T = (                +  0.50D0 * T0 * X0 ) /  2.0D0
      CSPI_S = ( - 0.50D0 * T0                      ) /  2.0D0
C
      NSPI_N = 'SPI_'
C
C=======================================================================
C
      CLPR_T = ( - 3.00D0 * T1  -  1.50D0 * T1 * X1 ) / 16.0D0
     *       + ( + 1.00D0 * T2  +  0.50D0 * T2 * X2 ) / 16.0D0
      CLPR_S = ( + 3.00D0 * T1  +  6.00D0 * T1 * X1 ) / 32.0D0
     *       + ( + 1.00D0 * T2  +  2.00D0 * T2 * X2 ) / 32.0D0
C
      NLPR_N = 'LPR_'
C
C=======================================================================
C
      CTAU_T = ( + 1.00D0 * T1  +  0.50D0 * T1 * X1 ) /  4.0D0
     *       + ( + 1.00D0 * T2  +  0.50D0 * T2 * X2 ) /  4.0D0
      CTAU_S = ( - 1.00D0 * T1  -  2.00D0 * T1 * X1 ) /  8.0D0
     *       + ( + 1.00D0 * T2  +  2.00D0 * T2 * X2 ) /  8.0D0
C
      NTAU_N = 'TAU_'
C
C=======================================================================
C
      CCUR_T = - CTAU_T
      CCUR_S = - CTAU_S
C
      NCUR_N = 'CUR_'
C
C=======================================================================
C
      CLPS_T = (                -  3.00D0 * T1 * X1 ) / 32.0D0
     *       + (                +  1.00D0 * T2 * X2 ) / 32.0D0
      CLPS_S = ( + 3.00D0 * T1                      ) / 32.0D0
     *       + ( + 1.00D0 * T2                      ) / 32.0D0
C
      NLPS_N = 'LPS_'
C
C=======================================================================
C
      CKIS_T = (                +  1.00D0 * T1 * X1 ) /  8.0D0
     *       + (                +  1.00D0 * T2 * X2 ) /  8.0D0
     *       - (                +  5.00D0 *(TE+TO)  ) /  8.0D0
      CKIS_S = ( - 1.00D0 * T1                      ) /  8.0D0
     *       + ( + 1.00D0 * T2                      ) /  8.0D0
     *       + ( + 5.00D0 * (TE-TO)                 ) /  8.0D0
C
      NKIS_N = 'KIS_'
C
C=======================================================================
C
      CSCU_T = - CKIS_T
      CSCU_S = - CKIS_S
C
      NSCU_N = 'SCU_'
C
C=======================================================================
C
      CRHODT = ( + 1.00D0 * T3  +  0.50D0 * T3 * X3 ) / 12.0D0
      CRHODS = ( - 0.50D0 * T3  -  1.00D0 * T3 * X3 ) / 12.0D0
C
      NRHODN = 'RHOD'
C
C=======================================================================
C
      CSPIDT = (                +  0.50D0 * T3 * X3 ) / 12.0D0
      CSPIDS = ( - 0.50D0 * T3                      ) / 12.0D0
C
      NSPIDN = 'SPID'
C
C=======================================================================
C
      CDIV_T = - 0.50D0 * W0
      CDIV_S = - 0.50D0 * W0P
C
      NDIV_N = 'DIV_'
C
C=======================================================================
C
      CROT_T = CDIV_T
      CROT_S = CDIV_S
C
      NROT_N = 'ROT_'
C
C=======================================================================
C         DEFINING THE STANDARD OR NON-STANDARD USE OF THE SKYRME FORCE
C         PARAMETERS
C=======================================================================
C
      IF (ISTAND.EQ.1) THEN
          JETA_W=IETA_W
          JETA_J=IETA_J
          JETACM=IETACM
          JETA_M=IETA_M
      ELSE
          JETA_W=KETA_W
          JETA_J=KETA_J
          JETACM=KETACM
          JETA_M=KETA_M
      END IF
C
C=======================================================================
C
      IF (ISTAND.EQ.0.AND.
     *    (KETA_J.NE.IETA_J.OR.
     *     KETA_W.NE.IETA_W.OR.
     *     KETACM.NE.IETACM.OR.
     *     KETA_M.NE.IETA_M)) THEN
C
          WRITE(NFIPRI,'(79(1H*),/,      1H*,77X,1H*,/,
     *          1H*,1X,''NON-STANDARD TREATMENT OF '',
     *                 ''THE SKYRME FORCE:'',
     *                 '' ETA_J='',I1,'' ETA_W='',I1,
     *                 '' ETACM='',I1,'' ETA_M='',I1,
     *                                        1X,1H*,/,
     *                                   1H*,77X,1H*,/,
     *          1H*,1X,''THIS INCLUDES:'',   62X,1H*)')
     *
     *          JETA_J,JETA_W,JETACM,JETA_M
C
      END IF
C
C=======================================================================
C     DEFINING THE TREATMENT OF THE "J^2" TERMS
C=======================================================================
C
      IF (ISTAND.EQ.0.AND.KETA_J.NE.IETA_J) THEN
C
          IF (KETA_J.EQ.0) THEN
C
              WRITE(NFIPRI,'(                1H*,77X,1H*,/,
     *              1H*,1X,''NON-STANDARD TREATMENT OF '',
     *                     ''THE TENSOR TERMS: '',
     *                     ''THESE TERMS HAVE BEEN '',
     *                     ''NEGLECTED'',         1X,1H*)')
C
          ELSE
C
              WRITE(NFIPRI,'(                1H*,77X,1H*,/,
     *              1H*,1X,''NON-STANDARD TREATMENT OF '',
     *                     ''THE TENSOR TERMS:  '',
     *                     ''THESE TERMS HAVE BEEN '',
     *                     ''INCLUDED'',          1X,1H*)')
          END IF
C
          CKIS_T = CKIS_T * KETA_J
          CKIS_S = CKIS_S * KETA_J
C
          CSCU_T = CSCU_T * KETA_J
          CSCU_S = CSCU_S * KETA_J
C
      ELSE
C
          CKIS_T = CKIS_T * IETA_J
          CKIS_S = CKIS_S * IETA_J
C
          CSCU_T = CSCU_T * IETA_J
          CSCU_S = CSCU_S * IETA_J
C
      END IF
C
C=======================================================================
C     DEFINING THE TREATMENT OF THE SPIN-ORBIT TERMS
C=======================================================================
C
      IF (ISTAND.EQ.0.AND.KETA_W.NE.IETA_W) THEN
C
          IF (KETA_W.EQ.0) THEN
C
              W0P=W0
C
              WRITE(NFIPRI,'(                1H*,77X,1H*,/,
     *              1H*,1X,''NON-STANDARD TREATMENT OF '',
     *                     ''THE SPIN-ORBIT TERMS: '', 28X,1H*,/,
     *              1H*,1X,''TRADITIONAL SPIN-ORBIT HAS BEEN '',
     *                     ''USED FOR VALUES: '',
     *                     ''W0='',F9.4,'' W0P='',F9.4, 1X,1H*)')
     *          W0,W0P
C
          END IF
C
          IF (KETA_W.EQ.1) THEN
C
              WRITE(NFIPRI,'(                      1H*,77X,1H*,/,
     *              1H*,1X,''NON-STANDARD TREATMENT OF '',
     *                     ''THE SPIN-ORBIT TERMS: '', 28X,1H*,/,
     *              1H*,1X,''GENERALIZED SPIN-ORBIT HAS BEEN '',
     *                     ''USED FOR VALUES: '',
     *                     ''W0='',F9.4,'' W0P='',F9.4, 1X,1H*)')
     *          W0,W0P
C
          END IF
C
          IF (KETA_W.EQ.2) THEN
C
              W0 =W0_INP
              W0P=W0PINP
C
              WRITE(NFIPRI,'(                1H*,77X,1H*,/,
     *              1H*,1X,''NON-STANDARD TREATMENT OF '',
     *                     ''THE SPIN-ORBIT TERMS: '', 28X,1H*,/,
     *              1H*,1X,''USER-DEFINED GENERALIZED SPIN-ORBIT '',
     *                     ''USED FOR:    '',
     *                     ''W0='',F9.4,'' W0P='',F9.4, 1X,1H*)')
     *          W0,W0P
C
          END IF
C
      END IF
C
C=======================================================================
C
      CDIV_T = - 0.50D0 * W0
      CDIV_S = - 0.50D0 * W0P
C
      CROT_T = CDIV_T
      CROT_S = CDIV_S
C
C=======================================================================
C     DEFINING THE TREATMENT OF THE CENTER-OF-MASS CORRECTION
C=======================================================================
C     THE SECURITY STOP BELOW WAS DISABLED IN VERSION (2.39O)
C     ON 06/06/2009 AFTER THE  PROGRAMMING  OF  THE  TWO-BODY
C     CENTER-OF-MASS CORRECTION BEFORE VARIATION HAS STARTED.
C=======================================================================
C
C     IF (JETACM.EQ.2) THEN
C
C         WRITE(NFIPRI,'(79(1H*),/,       1H*,77X,1H*,/,
C    *          1H*,1X,''TWO-BODY TREATMENT OF '',
C    *                 ''C-O-M CORREC. BEFORE VARIATION IS '',
C    *                 ''NOT YET IMPLEMENTED'',1X,1H*,/,
C    *          1H*,1X,''RERUN WITH ISTAND=0 '',
C    *                 ''AND KETACM=1 TO INCLUDE THIS CORRECTION '',
C    *                 ''AFTER VARIATION'',    1X,1H*,/,
C    *                                    1H*,77X,1H*,/,
C    *                                         79(1H*),/)')
C
C         STOP 'TWO-BODY TREATMENT OF C-O-M CORRECTION IN PARAMS'
C
C     END IF
C
C=======================================================================
C
      IF (ISTAND.EQ.0.AND.KETACM.NE.IETACM) THEN
C
          IF (KETACM.EQ.0) THEN
C
              WRITE(NFIPRI,'(                1H*,77X,1H*,/,
     *              1H*,1X,''NON-STANDARD TREATMENT OF '',
     *                     ''THE CENTER-OF-MASS CORRECTION '',
     *                     ''FOR THIS FORCE:'',
     *                                            5X,1H*,/,
     *              1H*,1X,''STANDARD METHOD BASED ON '',
     *                     ''THE ONE-BODY APPROXIMATION BEFORE '',
     *                     ''VARIATION USED'',    3X,1H*)')
C
          END IF
C
          IF (KETACM.EQ.1) THEN
C
              WRITE(NFIPRI,'(                1H*,77X,1H*,/,
     *              1H*,1X,''NON-STANDARD TREATMENT OF '',
     *                     ''THE CENTER-OF-MASS CORRECTION '',
     *                     ''FOR THIS FORCE:'',
     *                                            5X,1H*,/,
     *              1H*,1X,''METHOD BASED ON THE TWO-BODY '',
     *                     ''OPERATOR EVALUATED AFTER VARIATION '',
     *                     ''IS NOW USED'',       1X,1H*)')
C
          END IF
C
          IF (KETACM.EQ.2) THEN
C
              WRITE(NFIPRI,'(                1H*,77X,1H*,/,
     *              1H*,1X,''NON-STANDARD TREATMENT OF '',
     *                     ''THE CENTER-OF-MASS CORRECTION '',
     *                     ''FOR THIS FORCE:'',
     *                                            5X,1H*,/,
     *              1H*,1X,''METHOD BASED ON THE TWO-BODY '',
     *                     ''OPERATOR INCLUDED BEFORE VARIATION '',
     *                     ''IS NOW USED'',       1X,1H*)')
C
          END IF
C
          IF (KETACM.EQ.3) THEN
C
              WRITE(NFIPRI,'(                1H*,77X,1H*,/,
     *              1H*,1X,''NON-STANDARD TREATMENT OF '',
     *                     ''THE CENTER-OF-MASS CORRECTION '',
     *                     ''FOR THIS FORCE:'',
     *                                            5X,1H*,/,
     *              1H*,1X,''THE CENTER-OF-MASS CORRECTION '',
     *                     ''HAS BEEN NEGLECTED, AND SHOULD '',
     *                     ''BE ADDED LATER'',    1X,1H*)')
C
          END IF
C
      END IF
C
C=======================================================================
C     DEFINING THE TREATMENT OF THE HBAR^2/2M PARAMETER
C=======================================================================
C
      IF (JETA_M.EQ.0) HBMASS=20.73620941D0
      IF (JETA_M.EQ.1) HBMASS=HBMSKY
      IF (JETA_M.EQ.2) HBMASS=HBMINP
C
      IF (ISTAND.EQ.0.AND.KETA_M.NE.IETA_M) THEN
C
          IF (KETA_M.EQ.0) THEN
C
              WRITE(NFIPRI,'(                1H*,77X,1H*,/,
     *              1H*,1X,''NON-STANDARD TREATMENT OF '',
     *                     ''THE HBAR^2/2M PARAMETER:'',
     *                                           26X,1H*,/,
     *              1H*,1X,''VALUE FROM THE PREVIOUS '',
     *                     ''VERSION (v1.75r) HAS BEEN USED: '',
     *                     ''HBMASS='',F12.8,     1X,1H*)')
     *          HBMASS
C
          END IF
C
          IF (KETA_M.EQ.2) THEN
C
              WRITE(NFIPRI,'(                1H*,77X,1H*,/,
     *              1H*,1X,''NON-STANDARD TREATMENT OF '',
     *                     ''THE HBAR^2/2M PARAMETER:'',
     *                                           26X,1H*,/,
     *              1H*,1X,''VALUE SUPPLIED BY THE USER '',
     *                     ''IN THE DATA HAS BEEN USED:   '',
     *                     ''HBMASS='',F12.8,     1X,1H*)')
     *          HBMASS
C
          END IF
C
      END IF
C
C=======================================================================
C
      IF (ISTAND.EQ.0.AND.
     *    (KETA_J.NE.IETA_J.OR.
     *     KETA_W.NE.IETA_W.OR.
     *     KETACM.NE.IETACM.OR.
     *     KETA_M.NE.IETA_M)) WRITE(NFIPRI,'(1H*,77X,1H*,/,79(1H*),/)')
C
C=======================================================================
C         REDEFINING SIX TIME-ODD SKYRME-FORCE PARAMETERS BASED
C         ON THE FOUR LANDAU PARAMETERS G0, G0', G1, AND G1', AND
C         ON THE TWO FINITE-SYSTEM PARAMETERS X0 AND X1
C=======================================================================
C
      IF (LANODD.NE.0) THEN
C
          HBMLAN=HBMASS
          RHOLAN=-1.0
          EFFLAN=-1.0
C
          IF (RHOSKY.GT.0.0) RHOLAN=RHOSKY
          IF (EFFSKY.GT.0.0) EFFLAN=EFFSKY
C
          IF (HBMSAT.GT.0.0) HBMLAN=HBMSAT
          IF (RHOSAT.GT.0.0) RHOLAN=RHOSAT
          IF (EFFSAT.GT.0.0) EFFLAN=EFFSAT
C
C=======================================================================
C         WHEN USING THE LANDAU PARAMETERS ONE NEEDS THREE  DATA
C         VALUES  HBMLAN, RHOLAN, AND EFFLAN  THAT CORRESPOND TO
C         THE GIVEN SKYRME FORCE, AND ARE EQUAL RESPECTIVELY  TO
C         THE HBAR^2/2M, SATURATION DENSITY, AND EFFECTIVE MASS.
C         THESE VALUES SHOULD BE GIVEN EXPLICITLY FOR EACH FORCE
C         PARAMETERIZATION. HOWEVER, VALUES READ FROM THE  INPUT
C         TAKE PRECEDENCE OVER THOSE CODED FOR THE GIVEN  FORCE.
C         IF NEITHER ARE SET, THE CODE STOPS HERE.
C=======================================================================
C
          IF (HBMLAN.LE.0.0.OR.
     *        RHOLAN.LE.0.0.OR.
     *        EFFLAN.LE.0.0) THEN
C
              WRITE(NFIPRI,'(/,
     *                 1X,20(1H/),''  INCORRECT SATURATION LANDAU'',
     *                            '' DATA'',       3X,20(1H/),/,
     *                 1X,20(1H/),''  LANODD ='',I3,5X,
     *                            ''  HBMLAN ='',F8.5,   1X,20(1H/),/,
     *                 1X,20(1H/),''  RHOLAN ='',F8.5,
     *                            ''  EFFLAN ='',F8.5,   1X,20(1H/),/)')
     *
     *        LANODD,HBMLAN,RHOLAN,EFFLAN
C
              WRITE(NFIPRI,'(/,
     *                     1X,20(1H/),''  SET THESE VALUES BY USING'',
     *                                '' THE'',          6X,20(1H/),/,
     *                     1X,20(1H/),''  INPUT-KEYWORD LANDAU-SAT'',
     *                                                  11X,20(1H/),/)')
C
              STOP ' INCORRECT SATURATION LANDAU DATA IN PARAMS'
C
          END IF
C
C=======================================================================
C         CALLING THE SUBROUTINE LANDAU FOR ORIGINAL COUPLING CONSTANTS
C=======================================================================
C
          IF (LANSCA.NE.1)
     *
     *        CALL LANDAU(LANODD,LANSCA,HBMLAN,RHOLAN,EFFLAN,
     *                    CSPI_T,CSPI_S,CSPIDT,CSPIDS,CKIS_T,CKIS_S)
C
      END IF
C
C=======================================================================
C         DEFINING THE NAMES OF THE SYMMETRY-VIOLATING TERMS
C=======================================================================
C
      NSCR_N = 'SCR_'
      NDIS_N = 'DIS_'
      NDSR_N = 'DSR_'
      NSCS_N = 'SCS_'
      NSCJ_N = 'SCJ_'
      NCUS_N = 'CUS_'
      NROS_N = 'ROS_'
      NDES_N = 'DES_'
C
C=======================================================================
C
C         THE CODE USES THE  >>>  T-S  <<<   REPRESENTATION OF THE
C         SKYRME FUNCTIONAL.
C
C         IN THE   T-S   REPRESENTATION THE FUNCTIONAL IS COMPOSED
C         OF THE FOLLOWING TERMS:
C
C         C_T * (N1+P1) * (N2+P2) + C_S * (N1*N2 + P1*P2)
C
C         WHERE: C_T = T-TYPE COUPLING CONSTANT
C                C_S = S-TYPE COUPLING CONSTANT
C
C                N1  = NEUTRON DENSITY OF TYPE 1
C                N2  = NEUTRON DENSITY OF TYPE 2
C                P1  =  PROTON DENSITY OF TYPE 1
C                P2  =  PROTON DENSITY OF TYPE 2
C
C         IN SOME PLACES WE USE THE  >>>  P-M  <<<  REPRESENTATION
C         OF THE SKYRME FUNCTIONAL.
C
C         IN THE   P-M   REPRESENTATION THE FUNCTIONAL IS COMPOSED
C         OF THE FOLLOWING TERMS:
C
C         C_P * (N1+P1) * (N2+P2) + C_M * (N1-P1) * (N2-P2)
C
C         WHERE: C_P = P-TYPE COUPLING CONSTANT
C                C_M = M-TYPE COUPLING CONSTANT
C
C=======================================================================
C         SCALING OF COUPLING CONSTANTS IN THE T-S REPRESENTATION.
C=======================================================================
C
      DO NUCOUP=1,NDCOUP
         CCPALL(NUCOUP)=CCPALL(NUCOUP)*STSALL(NUCOUP)+ATSALL(NUCOUP)
      END DO
C
C=======================================================================
C         SCALING OF COUPLING CONSTANTS IN THE P-M REPRESENTATION.
C=======================================================================
C
C=======================================================================
C
C     ATTENTION:  IN THE PREVIOUS VERSIONS OF THE CODE, THE  SCALING  OF
C                 THE COUPLING CONSTANTS IN THE  P-M  REPRESENTATION WAS
C                 CODED INCORRECTLY.
C
C                 THIS CONCERNS VERSION 1.75L AND ALL OLDER VERSIONS, AS
C                 WELL AS VERSIONS SINCE 1.76 TILL 1.79.
C
C                 STARTING FROM VERSION 1.80, AND ALSO IN ALL THE BIFUR-
C                 CATED VERSIONS 1.75M,N,O,..., AND THE LATER ONES, THIS
C                 BUG HAS BEEN CORRECTED.
C
C=======================================================================
C
      DO NUCOUP=1,NDCOUP,2
C
         CCPTOT = CCPALL(NUCOUP  ) *  SPMALL(NUCOUP  )
     *          + CCPALL(NUCOUP+1) * (SPMALL(NUCOUP  )
     *                             -  SPMALL(NUCOUP+1))/2
C
         CCPSUM = CCPALL(NUCOUP+1) *  SPMALL(NUCOUP+1)
C
         CCPALL(NUCOUP  )=CCPTOT+  APMALL(NUCOUP  )-APMALL(NUCOUP+1)
         CCPALL(NUCOUP+1)=CCPSUM+2*APMALL(NUCOUP+1)
C
      END DO
C
C=======================================================================
C         CALLING THE SUBROUTINE LANDAU FOR SCALED COUPLING CONSTANTS
C=======================================================================
C
      IF (LANODD.NE.0.AND.LANSCA.EQ.1)
     *
     *    CALL LANDAU(LANODD,LANSCA,HBMLAN,RHOLAN,EFFLAN,
     *                CSPI_T,CSPI_S,CSPIDT,CSPIDS,CKIS_T,CKIS_S)
C
C=======================================================================
C         PRINTING THE SCALING FACTORS OF TERMS  IN  THE  FUNCTIONAL
C         (ONLY IN CASE WHEN AT LEAST ONE OF THEM IS NOT EQUAL TO 1)
C=======================================================================
C
      IPRSCA=0
C
      DO NUCOUP=1,NDCOUP
C
         IF (ABS(STSALL(NUCOUP)-1.0D0).GT.1.D-10.OR.
     *       ABS(SPMALL(NUCOUP)-1.0D0).GT.1.D-10)    IPRSCA=1
C
      END DO
C
      IF (IPRSCA.EQ.1)
     *    WRITE(NFIPRI,'(79(1H*),/,                  1H*,77X,1H*,/,
     *             1H*,14X,''SCALING FACTORS OF TERMS '',
     *                     ''IN THE SKYRME FUNCTIONAL '',13X,1H*,/,
     *                                               1H*,77X,1H*,/,
     *                                                   79(1H*),/,
     *                                               1H*,77X,1H*,/,
     *             1H*,13X,''      TOTAL(T)'',
     *                     ''        SUM(S)'',4X,
     *                     ''  ISOSCALAR(P)'',
     *                     ''  ISOVECTOR(M)'',4X,            1H*,/,
     *             1H*,13X,''      --------'',
     *                     ''        ------'',4X,
     *                     ''  ------------'',
     *                     ''  ------------'',4X,            1H*,/,
     *         2(6(1H*,4X,A1,A4,'' = '',1X,2(2F14.6,4X),     1H*,/),
     *                                               1H*,77X,1H*,/),
     *                                                    79(1H*),/)')
     *
     *         ('S',NCPALL(I),STSALL(2*I-1),STSALL(2*I),
     *                        SPMALL(2*I-1),SPMALL(2*I),I=1,NDCOUP/2)
C
C=======================================================================
C         PRINTING THE ADDITIVE CONSTANTS OF TERMS  IN  THE  FUNCTIONAL
C         (ONLY IN CASE WHEN AT LEAST ONE OF THEM IS NOT EQUAL TO 0)
C=======================================================================
C
      IPRSCA=0
C
      DO NUCOUP=1,NDCOUP
C
         IF (ABS(ATSALL(NUCOUP)).GT.1.E-10.OR.
     *       ABS(APMALL(NUCOUP)).GT.1.E-10)    IPRSCA=1
C
      END DO
C
      IF (IPRSCA.EQ.1)
     *    WRITE(NFIPRI,'(79(1H*),/,                  1H*,77X,1H*,/,
     *             1H*,14X,''ADDED VALUES TO COUPLING CONSTANTS '',
     *                     ''IN THE SKYRME FUNCTIONAL '', 3X,1H*,/,
     *                                               1H*,77X,1H*,/,
     *                                                   79(1H*),/,
     *                                               1H*,77X,1H*,/,
     *             1H*,13X,''      TOTAL(T)'',
     *                     ''        SUM(S)'',4X,
     *                     ''  ISOSCALAR(P)'',
     *                     ''  ISOVECTOR(M)'',4X,            1H*,/,
     *             1H*,13X,''      --------'',
     *                     ''        ------'',4X,
     *                     ''  ------------'',
     *                     ''  ------------'',4X,            1H*,/,
     *         2(6(1H*,4X,A1,A4,'' = '',1X,2(2F14.6,4X),     1H*,/),
     *                                               1H*,77X,1H*,/),
     *                                                    79(1H*),/)')
     *
     *         ('A',NCPALL(I),ATSALL(2*I-1),ATSALL(2*I),
     *                        APMALL(2*I-1),APMALL(2*I),I=1,NDCOUP/2)
C
C=======================================================================
C         PRINTING THE COUPLING CONSTANTS OF TERMS IN THE FUNCTIONAL
C=======================================================================
C
      WRITE(NFIPRI,'(79(1H*),/,                      1H*,77X,1H*,/,
     *             1H*,17X,''COUPLING CONSTANTS DEFINING '',
     *                     ''THE SKYRME FUNCTIONAL '',   10X,1H*,/,
     *                                               1H*,77X,1H*,/,
     *                                                   79(1H*),/,
     *                                               1H*,77X,1H*,/,
     *             1H*,13X,''    TOTAL(T)  '',
     *                     ''      SUM(S)  '',4X,
     *                     ''  ISOSCALAR(P)'',
     *                     ''  ISOVECTOR(M)'',4X,            1H*,/,
     *             1H*,13X,''    --------  '',
     *                     ''      ------  '',4X,
     *                     ''  ------------'',
     *                     ''  ------------'',4X,            1H*,/,
     *         2(6(1H*,4X,A1,A4,'' = '',1X,2(2F14.6,4X),     1H*,/),
     *                                               1H*,77X,1H*,/),
     *                                                    79(1H*),/)')
     *
     *         ('C',NCPALL(I),CCPALL(2*I-1),CCPALL(2*I),
     *                        CCPALL(2*I-1)+CCPALL(2*I)/2,
     *                                      CCPALL(2*I)/2,I=1,NDCOUP/2)
C
C=======================================================================
C
      IF (IF_EDF.EQ.1) THEN
C
          WRITE(NFIPRI,'(79(''*''),/,''*'',77X,''*'',/,
     *             ''*'',26X,''NUCLEAR MATTER PROPERTIES'',
     *                   26X,''*'',/,''*'',77X,''*'',/,
     *                   79(''*''),/,''*'',77X,''*'',/,
     *             ''*     E = '',F8.4,''  rho0 = '',F9.5,
     *             ''   K = '',F9.4,''   Ms = '',F9.4,9X,''*'',/,
     *             ''*                   asym = '',F9.5,
     *             ''   L = '',F9.4,''   Mv = '',F9.4,9X,''*'',/,
     *             ''*'',77X,''*'',/,79(''*''),/)')
     *                  E_NM,RHO_NM,K_NM,1.0/SMASS_NM,
     *                  ASS_NM,LASS_NM,VMASS_NM
C
      END IF
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE LANDAU(LANODD,LANSCA,HBMLAN,RHOLAN,EFFLAN,
     *                  CSPI_T,CSPI_S,CSPIDT,CSPIDS,CKIS_T,CKIS_S)
C
      CHARACTER
     *          LANPRI*3
C
      COMMON
     *       /INTSKY/ T0,X0,T1,X1,T2,X2,T3,X3,W0,POWER
      COMMON
     *       /LAND_G/ X0_LAN,X1_LAN,G0_LAN,G0PLAN,G1_LAN,G1PLAN
      COMMON
     *       /CFIPRI/ NFIPRI
C
C=======================================================================
C         THIS ROUTINE CALCULATES SIX TIME-ODD COUPLING CONSTANTS FROM
C         THE LANDAU PARAMETERS, DEPENDING ON THE  VALUES  OF  LANODD:
C
C         IF THE RIGHT  DIGIT OF LANODD=1  ==>  CKIS_ IS RECALCULATED
C         IF THE RIGHT  DIGIT OF LANODD=0  ==>  CKIS_ IS UNCHANGED
C
C         IF THE MIDDLE DIGIT OF LANODD=1  ==>  CSPIS IS RECALCULATED
C         IF THE MIDDLE DIGIT OF LANODD=0  ==>  CSPIS IS UNCHANGED
C
C         IF THE LEFT   DIGIT OF LANODD=1  ==>  CSPI0 IS RECALCULATED
C         IF THE LEFT   DIGIT OF LANODD=0  ==>  CSPI0 IS UNCHANGED
C
C         HERE "CSPIS" DENOTES THE SATURATION-DENSITY VALUES OF "CSPI"
C         AND  "CSPI0" DENOTES THE      VACUUM        VALUES OF "CSPI"
C
C         HENCE:  CSPI_ = CSPI0  AND  CSPID*RHO**POWER = CSPIS - CSPI0
C
C=======================================================================
C         BASED ON FORMULAS (15) IN THE GT BENDER ET AL. 2002 PRC PAPER
C=======================================================================
C
      PI=4.0D0*ATAN(1.00D0)
C
      AKFLAN=(3.0D0*PI**2*RHOLAN/2)**(1.0D0/3.0D0)
      ANOLAN=2.0D0/(PI**2*HBMLAN/AKFLAN/EFFLAN)
C
      IF (MOD(LANODD,10).EQ.1) THEN
C
C=======================================================================
C         FOR THE RIGHT DIGIT OF LANODD EQUAL 1:
C         RECALCULATE CONSTANTS CKIS_ FROM THE LANDAU PARAMETERS
C         G1 AND G1'
C=======================================================================
C
          CKIS_P=-G1_LAN/(ANOLAN*AKFLAN**2)
          CKIS_M=-G1PLAN/(ANOLAN*AKFLAN**2)
C
      ELSE
C
C=======================================================================
C         FOR THE LAST DIGIT OF LANODD EQUAL 0:
C         KEEP THE PREVIUOS VALUES OF CONSTANTS CKIS_ UNCHANGED
C=======================================================================
C
          CKIS_P=CKIS_T+CKIS_S/2
          CKIS_M=CKIS_S/2
C
      END IF
C
      IF (MOD(LANODD/10,10).EQ.1) THEN
C
C=======================================================================
C         FOR THE MIDDLE DIGIT OF LANODD EQUAL 1:
C         RECALCULATE THE SPIN COUPLING CONSTANTS AT SATURATION DENSITY
C         "CSPIS" FROM THE LANDAU PARAMETERS  G0 AND G0',  BY USING THE
C         KNOWN CONSTANTS CKIS_
C=======================================================================
C
          CSPISP=G0_LAN/ANOLAN-CKIS_P*AKFLAN**2
          CSPISM=G0PLAN/ANOLAN-CKIS_M*AKFLAN**2
C
      ELSE
C
C=======================================================================
C         FOR THE MIDDLE DIGIT OF LANODD EQUAL 0:
C         KEEP THE PREVIUOS VALUES OF CONSTANTS CSPIS UNCHANGED
C=======================================================================
C
          CSPISP=CSPI_T+CSPI_S/2 +(CSPIDT+CSPIDS/2)*RHOLAN**POWER
          CSPISM=CSPI_S/2        +(CSPIDS/2       )*RHOLAN**POWER
C
      END IF
C
      IF (MOD(LANODD/100,10).EQ.1) THEN
C
C=======================================================================
C         FOR THE FIRST DIGIT OF LANODD EQUAL 1:
C         RECALCULATE THE SPIN  COUPLING  CONSTANTS  AT  ZERO  DENSITY
C         "CSPI_" BY MULTIPLYING THE CORRESPONDING COUPLING  CONSTANTS
C         AT SATURATION DENSITY "CSPIS" WITH FACTORS X0_LAN AND X1_LAN
C=======================================================================
C
          CSPI0P=CSPISP * X0_LAN
          CSPI0M=CSPISM * X1_LAN
C
      ELSE
C
C=======================================================================
C         FOR THE FIRST DIGIT OF LANODD EQUAL 0:
C         KEEP THE PREVIUOS VALUES OF CONSTANTS CSPI_ UNCHANGED
C=======================================================================
C
          CSPI0P=CSPI_T+CSPI_S/2
          CSPI0M=CSPI_S/2
C
      END IF
C
C=======================================================================
C         COME BACK TO THE TOTAL-SUM CONSTANTS
C=======================================================================
C
      CSPI0T=  CSPI0P-CSPI0M
      CSPI0S=2*CSPI0M
C
      CSPIST=  CSPISP-CSPISM
      CSPISS=2*CSPISM
C
      CKIS_T=  CKIS_P-CKIS_M
      CKIS_S=2*CKIS_M
C
C=======================================================================
C         CALCULATE THE DENSITY-DEPENDENT COUPLING CONSTANTS FROM
C         THE CORRESPONDING SATURATION-DENSITY VALUES
C=======================================================================
C
      CSPI_T=  CSPI0T
      CSPI_S=  CSPI0S
C
      CSPIDT= (CSPIST-CSPI0T)/RHOLAN**POWER
      CSPIDS= (CSPISS-CSPI0S)/RHOLAN**POWER
C
C=======================================================================
C
      WRITE(NFIPRI,'(79(1H*),/,       1H*,77X,1H*,/,
     *      1H*,1X,''TIME-ODD COUPLING CONSTANTS THAT '',
     *             ''ARE DEFINED BASED ON THE '',
     *             ''LANDAU PARAMETERS'',  1X,1H*)')
C
      IF (LANSCA.NE.1) THEN
C
          WRITE(NFIPRI,'(
     *          1H*,1X,''AND ORIGINAL SKYRME COUPLING CONSTANTS'',
     *                                        38X,1H*,/,
     *                                    1H*,77X,1H*)')
C
      ELSE
C
          WRITE(NFIPRI,'(
     *          1H*,1X,''AND SCALED SKYRME COUPLING CONSTANTS'',
     *                                        40X,1H*,/,
     *                                    1H*,77X,1H*)')
C
      END IF
C
      IF (MOD(LANODD,10).EQ.1)
     *
     *    WRITE(NFIPRI,'(
     *          1H*,1X,''G1 ='',F6.3,3X,
     *                 ''G1P='',F6.3,3X,''==>'',3X,
     *                 ''CKIS_P ='',F12.6,3X,
     *                 ''CKIS_M ='',F12.6,     1X,1H*)')
     *
     *          G1_LAN,G1PLAN,CKIS_P,CKIS_M
C
      IF (MOD(LANODD/10,10).EQ.1)
     *
     *    WRITE(NFIPRI,'(
     *          1H*,1X,''G0 ='',F6.3,3X,
     *                 ''G0P='',F6.3,3X,''==>'',3X,
     *                 ''CSPISP ='',F12.6,3X,
     *                 ''CSPISM ='',F12.6,     1X,1H*)')
     *
     *          G0_LAN,G0PLAN,CSPISP,CSPISM
C
      IF (MOD(LANODD/100,10).EQ.1)
     *
     *    WRITE(NFIPRI,'(
     *          1H*,1X,''X0 ='',F6.3,3X,
     *                 ''X1 ='',F6.3,3X,''==>'',3X,
     *                 ''CSPI0P ='',F12.6,3X,
     *                 ''CSPI0M ='',F12.6,     1X,1H*)')
     *
     *          X0_LAN,X1_LAN,CSPI0P,CSPI0M
C
      WRITE(LANPRI,'(I3)') LANODD
      IF (LANPRI(1:1).EQ.' ') LANPRI(1:1)='0'
      IF (LANPRI(2:2).EQ.' ') LANPRI(2:2)='0'
C
      WRITE(NFIPRI,'(                 1H*,77X,1H*,/,
     *      1H*,1X,''PARAMETERS:  '',
     *             ''LANODD='', A3,  3X,
     *             ''HBMLAN ='',F9.5,2X,
     *             ''RHOLAN ='',F6.3,2X,
     *             ''EFFLAN ='',F6.3,     1X,1H*,/,
     *                                1H*,77X,1H*,/,
     *                                    79(1H*),/)')
     *
     *      LANPRI,HBMLAN,RHOLAN,EFFLAN
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE TABDEF(LAMMAX)
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      CHARACTER
     *          PRIMOM(0:NDLAMB)*15
C
      DIMENSION
     *          ELEMNT(0:NDLAMB)
C
      COMPLEX
     *          ALPHAC(0:NDLAMB,-NDLAMB:+NDLAMB)
C
      COMMON
     *       /DEFORM/ ALPHAC,IREALA
      COMMON
     *       /CFIPRI/ NFIPRI
C
C=======================================================================
C
      WRITE(NFIPRI,'(79(1H*),/,1H*,77X,1H*,/,
     *            1H*,''  DEFORMED WOODS-SAXON RESULTS HAVE BEEN READ'',
     *                                                        32X,1H*,/,
     *                                                    1H*,77X,1H*,/,
     *                                          79(1H*),/,1H*,77X,1H*)')
C
      LAMMAC=MAX(2,LAMMAX)
C
      DO MIU=0,NDLAMB
         PRIMOM(MIU)='  .............'
      END DO
C
      DO LAMBDA=1,MIN(LAMMAC,NDLAMB)
C
         DO MIU=0,LAMBDA
C
            IF (ABS(ALPHAC(LAMBDA,MIU)).LT.1.0E-10) THEN
C
                WRITE(PRIMOM(MIU),'(''  AL'',2I1,'' ='',3X,''ZERO'')')
     *                                                     LAMBDA,MIU
            ELSE
C
               IF (ABS(ALPHAC(LAMBDA,MIU)).LT.1.0E-3) THEN
C
                   WRITE(PRIMOM(MIU),'(''  AL'',2I1,'' ='',1PE7.0)')
     *                          LAMBDA,MIU,REAL(ALPHAC(LAMBDA,MIU))
      ELSE
C
                   WRITE(PRIMOM(MIU),'(''  AL'',2I1,'' ='',F7.3)')
     *                          LAMBDA,MIU,REAL(ALPHAC(LAMBDA,MIU))
               END IF
C
            END IF
C
            IF (PRIMOM(MIU)(11:12).EQ.' .') PRIMOM(MIU)(11:12)='0.'
C
             END DO
C
         WRITE(NFIPRI,'(''*'',77X,''*'',/,''*'',5A15,2X,''*'')')
     *                                       (PRIMOM(MIU),MIU=0,4)
C
             END DO
C
      IF (LAMMAC.EQ.0) THEN
C
          WRITE(NFIPRI,'(''*'',2X,''Spherical Shape requested for '',
     *                     ''the surface'',34X,''*'')')
C
      END IF
C
      WRITE(NFIPRI,'(''*'',77X,''*'',/,79(''*''))')
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE PUTREA(IPLUMI,H_REAL,H_CMPL)
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      COMPLEX
     *          H_CMPL(1:NDBASE,1:NDBASE)
      DIMENSION
     *          H_REAL(1:NDBASE,1:NDBASE)
      COMMON
     *         /DIMENS/ LDBASE
      DATA
     *          ZERO / 0.0D0 /
C
C=======================================================================
C
      DO IKET=1,LDBASE
         DO IBRA=1,LDBASE
C
            H_CMPL(IBRA,IKET)=H_CMPL(IBRA,IKET)
     *
     *                       + IPLUMI * CMPLX(H_REAL(IBRA,IKET),ZERO)
C
         END DO
      END DO
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE PUTIMA(IPLUMI,H_IMAG,H_CMPL)
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      COMPLEX
     *          H_CMPL(1:NDBASE,1:NDBASE)
      DIMENSION
     *          H_IMAG(1:NDBASE,1:NDBASE)
      COMMON
     *         /DIMENS/ LDBASE
      DATA
     *          ZERO / 0.0D0 /
C
C=======================================================================
C
      DO IKET=1,LDBASE
         DO IBRA=1,LDBASE
C
            H_CMPL(IBRA,IKET)=H_CMPL(IBRA,IKET)
     *
     *                       + IPLUMI * CMPLX(ZERO,H_IMAG(IBRA,IKET))
C
         END DO
      END DO
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C@@@@@@  THIS ROUTINE SHOULD OBTAIN FROM THE FISSION MODULE
C@@@@@@   - THE NUMBER OF NONROTATED QP
C@@@@@@   - VECTORS INDEX_SINGLE_B AND INDEX_SINGLE_A GIVING THE B AND
C@@@@@@	    A INDICES OF A GIVEN Q.P. FOR THE NONROTATED QP
C@@@@@@   - THE NUMBER OF PAIRS OF ROTATED QP
C@@@@@@   - VECTORS MU_A, MU_N, NU_A, NU_B GIVING THE B AND A INDICES OF
C@@@@@@     THE ROTATED Q.P. MU AND NU
C@@@@@@   - TWO MATRICES OF SIZE N_PAIR X 4 CALLED E_MATRIX AND F_MATRIX
C@@@@@@     WHERE THE ROW REFERS TO THE NUMERO OF THE PAIR AND THE COLUMNS
C@@@@@@     TO THE ELEMENT OF THE ROTATED GENERALIZED DENSITY IN THE
C@@@@@@     ORDER E_11, E_12, E_21, E_22 (SAME FOR F)
C
      SUBROUTINE DENSHF(NXHERM,NYHERM,NZHERM,ISIMTX,JSIMTY,ISIMTZ,
     *                  ISIGNY,ISIMPY,ISIQTY,IPAHFB,MREVER,ICHARG,
     *                  ICOUDI,ICOUEX,I_YUKA,I_GOGA,IGOGPA,
     *                                              IPNMIX,ITPNMX,
     *                  ITIREP,NXMAXX,NAMEPN,PRINIT,IDEVAR,ITERUN,
     *                  ISYMDE,INIROT,INIINV,INIKAR,ISAWAV,IKERNE)
C
C=======================================================================
      USE HE_DEN
      USE PD_DEN
      USE WAVSQU
      USE SAVRIG
      USE WAVR_L
      USE ALLWAV
      USE ALLQUA
      USE ALLQUZ
      USE FRAGFL
      USE DENCON
C=======================================================================
      USE hfodd_sizes
C=======================================================================
#if(USE_OPENMP==1)
      USE omp_lib
#endif
      LOGICAL
     *          PRINIT,is_nested,DOSYME
      CHARACTER
     *          NAMEPN*8
C
#if(SWITCH_PORT==1)
      COMPLEX
     *          DENALL(NDXHRM,NDYHRM,NDZHRM,NDALLD)
#endif
C
      COMPLEX, DIMENSION(:,:,:,:), ALLOCATABLE ::
     *                             HRIGHE,HRIGDH,HRIGDD,
     *                             HLEFHE,HLEFDH,HLEFDD
      COMPLEX
     *          ARHEHE(0:NDXMAX,1:4*NDSTAT,0:NDSPIN),
     *          ARHEDH(0:NDXMAX,1:4*NDSTAT,0:NDSPIN),
     *          ARDHHE(0:NDXMAX,1:4*NDSTAT,0:NDSPIN),
     *          ARHEDD(0:NDXMAX,1:4*NDSTAT,0:NDSPIN),
     *          ARDDHE(0:NDXMAX,1:4*NDSTAT,0:NDSPIN)
      COMPLEX
     *          ALHEHE(0:NDXMAX,1:4*NDSTAT,0:NDSPIN),
     *          ALHEDH(0:NDXMAX,1:4*NDSTAT,0:NDSPIN),
     *          ALDHHE(0:NDXMAX,1:4*NDSTAT,0:NDSPIN),
     *          ALHEDD(0:NDXMAX,1:4*NDSTAT,0:NDSPIN),
     *          ALDDHE(0:NDXMAX,1:4*NDSTAT,0:NDSPIN)
      COMPLEX
     *          DEUPUP(-1:NDKART,-1:NDKART),
     *          DEDWDW(-1:NDKART,-1:NDKART),
     *          DEUPDW(-1:NDKART,-1:NDKART),
     *          DEDWUP(-1:NDKART,-1:NDKART)
      COMPLEX
     *          DCUPUP(-1:NDKART,-1:NDKART),
     *          DCDWDW(-1:NDKART,-1:NDKART),
     *          DCUPDW(-1:NDKART,-1:NDKART),
     *          DCDWUP(-1:NDKART,-1:NDKART)
      COMPLEX
     *          DLUPUP,DLDWDW,DLUPDW,DLDWUP,
     *          CLUPUP,CLDWDW,CLUPDW,CLDWUP
      COMPLEX
     *          DENAUX(-1:NDKART,-1:NDKART)
      COMPLEX
     *          PAUPUP(-1:NDKART,-1:NDKART),
     *          PADWDW(-1:NDKART,-1:NDKART),
     *          PAUPDW(-1:NDKART,-1:NDKART),
     *          PADWUP(-1:NDKART,-1:NDKART),
     *          PCUPUP(-1:NDKART,-1:NDKART),
     *          PCDWDW(-1:NDKART,-1:NDKART),
     *          PCUPDW(-1:NDKART,-1:NDKART),
     *          PCDWUP(-1:NDKART,-1:NDKART)
C     COMPLEX
C    *          PAI_UP,PAI_DW
      COMPLEX
     *          P(-1:NDKART,1:4*NDSTAT,0:NDSPIN),
     *          Q(-1:NDKART,1:4*NDSTAT,0:NDSPIN)
      COMPLEX
     *                  PLA(1:4*NDSTAT,0:NDSPIN),
     *                  QLA(1:4*NDSTAT,0:NDSPIN)
      COMPLEX
     *          ONEWAV,PHASPI
      COMPLEX
     *          C_ZERO,C_UNIT,UNIT_I
      COMPLEX
     *          CERMTS,CHRMTS,CDHRMT
      COMPLEX
     *          ZDOTU
      COMPLEX
     *          RMTS
C
      DIMENSION
     *          MUSYME(0:NDKART)
      DIMENSION
     *          V1OCCU(1:2*NDSTAT)
C
C@@@ TEMP - TEMP - TEMP - TEMP - TEMP - TEMP - TEMP - TEMP - TEMP
      COMMON
     *       /FERFUN/ FER_FN(1:NDBASE)
      COMMON
     *       /T_FLAG/ IFTEMP
C@@@ TEMP - TEMP - TEMP - TEMP - TEMP - TEMP - TEMP - TEMP - TEMP
      COMMON
     *       /PROCCU/ V_OCCU(1:2*NDSTAT)
      COMMON
     *       /CORPAR/ V_CORR(1:NDSTAT,0:NDREVE)
      COMMON
     *       /LIMOCC/ NOTOCC(1:NDSTAT,0:NDREVE)
      COMMON
     *       /BINDEX/ INDICE(0:NDXMAX,0:NDYMAX,0:NDZMAX)
     *
     *       /BLIMS1/ LAXOFY(0:NDYMAX),LAXOFZ(0:NDZMAX),
     *                LAYOFZ(0:NDZMAX),LAYOFX(0:NDXMAX),
     *                LAZOFX(0:NDXMAX),LAZOFY(0:NDYMAX)
     *
     *       /BLIMS2/ LAXOYZ(0:NDYMAX,0:NDZMAX),
     *                LAYOZX(0:NDZMAX,0:NDXMAX),
     *                LAZOXY(0:NDXMAX,0:NDYMAX)
      COMMON
     *       /HERCOM/ CERMTS(0:ND2MAX,1:NDGAUS,1:NDKART),
     *                CHRMTS(0:ND2MAX,1:NDGAUS,1:NDKART),
     *                CDHRMT(0:ND2MAX,1:NDGAUS,1:NDKART)
      COMMON
     *       /SPNUMS/ NUMBSP(0:NDREVE,0:NDISOS)
      COMMON
     *       /QPNUMS/ NUMBQP(0:NDREVE,0:NDISOS)
      COMMON
     *       /SPIPHA/ PHASPI(1:NDBASE,0:NDREVE,0:NDSPIN)
      COMMON
     *       /IANGLE/ ALPINI,BETINI,GAMINI
      COMMON
     *       /RANGLE/ ALPROT,BETROT,GAMROT
      COMMON
     *       /DIMSTA/ LDTOTS(0:NDISOS),LDSTAT(0:NDISOS),
     *                LDUPPE(0:NDISOS),LDTIMU(0:NDISOS)
      COMMON
     *       /HALFBO/ IHABOX,IHABOY,IHABOZ
      COMMON
     *       /DIMENS/ LDBASE
C
C=======================================================================
C
      CALL CPUTIM('DENSHF',1)
C
C=======================================================================
C
      IALLOC=0
C
C=======================================================================
      IF (.NOT.ALLOCATED(SQUWAV)) THEN
          ALLOCATE (SQUWAV(1:NDSTAT,NDXHRM,NDYHRM,NDZHRM),STAT=IALLOC)
          IF (IALLOC.NE.0) CALL NOALLO('SQUWAV','DENSHF')
      END IF
C=======================================================================
      IF (.NOT.ALLOCATED(WARIGH)) THEN
          ALLOCATE (WARIGH(1:NDBASE,1:4*NDSTAT,0:NDSPIN),STAT=IALLOC)
          IF (IALLOC.NE.0) CALL NOALLO('WARIGH','DENSHF')
      END IF
C=======================================================================
      IF (.NOT.ALLOCATED(WALEFT).AND.IKERNE.EQ.1) THEN
          ALLOCATE (WALEFT(1:NDBASE,1:4*NDSTAT,0:NDSPIN),STAT=IALLOC)
          IF (IALLOC.NE.0) CALL NOALLO('WALEFT','DENSHF')
      END IF
C=======================================================================
      IF (.NOT.ALLOCATED(SARIGH)) THEN
          ALLOCATE (SARIGH(1:NDBASE,1:4*NDSTAT,0:NDSPIN,0:NDISOS),
     *              STAT=IALLOC)
          IF (IALLOC.NE.0) CALL NOALLO('SARIGH','DENSHF')
      END IF
C=======================================================================
      IF (.NOT.ALLOCATED(DCONTI)) THEN
          ALLOCATE (DCONTI(1:NXHERM,1:NYHERM,1:NZHERM),STAT=IALLOC)
          IF (IALLOC.NE.0) CALL NOALLO('DCONTI','DENSHF')
      END IF
      DCONTI(:,:,:)=CMPLX(0.0D0,0.0D0)

C=======================================================================
C
C=======================================================================
C
C        THIS SUBROUTINE CALCULATES THE  SKYRME-FUNCTIONAL  DENSITIES
C        DEFINED AS IN THE PAPER BY ENGEL ET AL.
C                                        NUCL.PHYS. A249 (1975) 215
C
C        AND FOR IPAHFB=1,
C        THIS SUBROUTINE CALCULATES IN ADDITION THE PAIRING DENSITIES
C        DEFINED AS IN THE PAPER BY DOBACZEWSKI ET AL.
C                                        NUCL.PHYS. A422 (1984) 103
C
C        ATTENTION:  CALCULATION OF DENSITIES OTHER THEN PAIRHO IS IN
C                    IN THIS VERSION  S W I T C H E D   O F F.
C
C=======================================================================
C
C        CODE NAMES OF DENSITIES ARE AS FOLLOWS:
C
C                      SCALAR DENSITIES
C
C        DENRHO = PARTICLE DENSITY ......................  ENGEL  (3.7)
C        DENTAU = KINETIC DENSITY .......................  ENGEL  (3.8)
C        DENLPR = LAPLACIAN OF PARTICLE DENSITY .........
C        DENDIV = DIVERGENCE OF SPIN CURRENT TENSOR .....  ENGEL (A.17)
C
C        PAIRHO = PAIR DENSITY ..........................  AS IN DENRHO
C        PAITAU = KINETIC PAIR DENSITY ..................  AS IN DENTAU
C        PAILPR = LAPLACIAN OF PAIR DENSITY .............  AS IN DENLPR
C        PAIDIV = DIVERGENCE OF PAIR SPIN CURRENT TENSOR   AS IN DENDIV
C
C                      VECTOR DENSITIES
C
C        DENSPI = SPIN DENSITY ..........................  ENGEL  (3.9)
C        DENKIS = VECTOR KINETIC ENERGY DENSITY .........  ENGEL (3.12)
C        DENGRR = GRADIENT OF PARTICLE DENSITY ..........
C        DENLPS = LAPLACIAN OF SPIN DENSITY .............
C        DENROS = ROTATION (CURL) OF SPIN DENSITY .......
C        DENROC = ROTATION (CURL) OF CURRENT DENSITY ....
C        DENCUR = CURRENT DENSITY .......................  ENGEL (3.10)
C
C        PAIGRR = GRADIENT OF PAIR DENSITY ..............  AS IN DENGRR
C
C                       TENSOR DENSITIES
C
C        DENSCU = SPIN CURRENT DENSITY...................  ENGEL (3.11)
C        DENDES = TENSOR DERIVATIVE OF THE SPIN DENSITY..
C
C        PAISCU = PAIR SPIN CURRENT DENSITY                AS IN DENSCU
C
C=======================================================================
C
C        ATTENTION:  FOR THE TIME-REVERSAL SYMMETRY CONSERVED, THIS
C                    SUBROUTINE IS CALLED WITH MREVER=0. THEN, ONLY
C                    THE STATES IN THE TIME-UP BLOCK ARE CONSIDERED
C                    AND ONLY THESE STATES ARE USED TO SUM  UP  THE
C                    THE DENSITIES. AS A RESULT, THE TIME-ODD "P-H"
C                    DENSITIES ARE NON-ZERO (THE CONTRIBUTIONS FROM
C                    THE TIME-DOWN BLOCK HAVE AN OPPOSITE SIGN, AND
C                    WOULD HAVE CANCELLED THOSE OBTAINED  FROM  THE
C                    TIME-UP BLOCK). HOWEVER, THIS SUBROUTINE GIVES
C                    NON-ZERO (UNCANCELLED) VALUES AND THE USER  IS
C                    RESPONSIBLE FOR PUTTING ZEROS IN THE  TIME-ODD
C                    "P-H" DENSITIES OUTSIDE THIS ROUTINE. THIS  IS
C                    DONE IN THE  "DBLING"  SUBROUTINE, WHICH  ALSO
C                    PERFORMS THE DOUBLING OF THE  TIME-EVEN  "P-H"
C                    DENSITIES. IT ALSO PUTS ZEROS IN THE IMAGINARY
C                    PARTS OF THE "P-P" DENSITIES.
C
C=======================================================================
C
C        AUXILIARY DENSITIES ARE CALCULATED AS FOUR-TENSOR DENSITIES:
C
C        DEUPUP = SPIN   UP-UP   COMPONENT
C        DEDWDW = SPIN DOWN-DOWN COMPONENT
C        DEUPDW = SPIN   UP-DOWN COMPONENT
C        DEDWUP = SPIN DOWN-UP   COMPONENT
C
C        PAUPUP = SPIN   UP-UP   COMPONENT
C        PADWDW = SPIN DOWN-DOWN COMPONENT
C        PAUPDW = SPIN   UP-DOWN COMPONENT
C        PADWUP = SPIN DOWN-UP   COMPONENT
C
C=======================================================================
C
C        VECTORIZATION COMMENT:
C        ARRAYS DEXXYY, PAXXYY, P, Q (XX/YY = DW OR UP)  HAVE  BEEN
C        DIMENSIONED AS    -1:NDKART    IN ORDER TO AVOID THE FIRST
C        DIMENSION SPANNING  4  VALUES, WHICH WOULD HAVE INTERFERED
C        WITH THE CRAY BANK-ACCESS SYSTEM. THE VALUES AT   -1   ARE
C        DUMMY AND NEVER USED.
C
C=======================================================================
C
      DO MU=0,NDKART
C
         IF (IKERNE.EQ.1) THEN
C
             MUSYME(MU)=NDKART
         ELSE
             MUSYME(MU)=MU
C
         END IF
C
      END DO
C
      C_ZERO=CMPLX(0.0D0,0.0D0)
      C_UNIT=CMPLX(1.0D0,0.0D0)
      UNIT_I=CMPLX(0.0D0,1.0D0)
C
      LREVER=1
C
C=======================================================================
C     FOR IKERNE=1 THE WAVE FUNCTIONS ARE SUPPOSED TO BE PRESENT IN THE
C     ARRAYS WARIGH AND WALEFT, AND ARE NOT CALCULATED
C=======================================================================
C
      IF (IKERNE.NE.1) THEN
C
C=======================================================================
C     THE SINGLE-PARTICLE (FOR IPAHFB=0) OR QUASIPARTICLE (FOR IPAHFB=1)
C     WAVE FUNCTIONS ARE FIRST COLLECTED IN THE "WARIGH"  ARRAY  IN  THE
C     FOLLOWING ORDER:
C
C     FOR IPAHFB=0:
C                 1.    S.P.   COMPONENTS IN THE NON-TIME-REVERSED BLOCK
C                 2.    S.P.   COMPONENTS IN THE     TIME-REVERSED BLOCK
C     FOR IPAHFB=1:
C                 1. UPPER HFB COMPONENTS IN THE NON-TIME-REVERSED BLOCK
C                 2. UPPER HFB COMPONENTS IN THE     TIME-REVERSED BLOCK
C                 3. LOWER HFB COMPONENTS IN THE     TIME-REVERSED BLOCK
C                 4. LOWER HFB COMPONENTS IN THE NON-TIME-REVERSED BLOCK
C=======================================================================
C     THE "WARIGH"  ARRAY CORRESPONDS TO THE "RIGHT" STATE  OF  THE  GCM
C     KERNEL, AND IS CALCULATED FROM  WAVE  FUNCTIONS  OBTAINED  IN  THE
C     CURRENT RUN OF THE CODE, WHILE THE "WALEFT"  ARRAY IS AN ANALOGOUS
C     ARRAY CALCULATED IN A PREVIOUS RUN, AND NOW IS READ FROM THE  DISC
C=======================================================================
C     SINCE THE HFB PAIRING DENSITY CAN BE CALCULATED BY USING THE LOWER
C     HFB COMPONENT IN EITHER OF THE BLOCKS, ONE  CAN  PERFORM  ALL  THE
C     CALCULATIONS BY PUTTING IN POSITION  "3"  THE  QUASIPARTICLE  WAVE
C     FUNCTIONS IN EITHER OF THE BLOCKS, I.E.,
C
C     FOR LREVER=1
C                 3. LOWER HFB COMPONENTS IN THE     TIME-REVERSED BLOCK
C     FOR LREVER=0
C                 3. LOWER HFB COMPONENTS IN THE NON-TIME-REVERSED BLOCK
C
C     LREVER IS AN INTERNAL VARIABLE IN THIS  SUBROUTINE.  IT SHOULD NOT
C     BE CHANGED, APART FROM TEST RUNS.
C
C
C     ATTENTION: FOR CALCULATIONS WITH UNBROKEN TIME-REVERSAL (MREVER=0)
C                THE LOWER HFB COMPONENTS IN THE NON-TIME-REVERSED BLOCK
C                AND UPPER HFB COMPONENTS IN THE     TIME-REVERSED BLOCK
C                ARE NOT CALCULATED. THEREFORE,  FOR MREVER=0 ONE HAS TO
C                USE LREVER=1.
C=======================================================================
C     COMPARED TO THE STANDARD HFB NOTATION:
C                THE ARRAY BWAQUA CONTAINS THE HFB "B*" AMPLITUDE
C                THE ARRAY AWAQUA CONTAINS THE HFB "A*" AMPLITUDE
C     WHERE "*" DENOTES THE COMPLEX CONJUGATION. THESE MATRICES ARE JUST
C     COLUMNS OF THE EIGENVECTORS OF THE HFB MATRIX CORRESPONDING TO THE
C     OCCUPIED QUASIPARTICLE STATES  (NEGATIVE QUASIPARTICLLE ENERGIES).
C=======================================================================
C     ISPIN=1 CORRESPONDS TO THE SPIN UP
C     ISPIN=0 CORRESPONDS TO THE SPIN DOWN
C=======================================================================
C     LTOTST  -  COUNTS THE TOTAL NUMBER OF STATES
C                                              PUT INTO THE WARIGH ARRAY
C                (FOR MREVER=0 EQUALS LSTATE)
C     LSTATE  -  COUNTS THE TOTAL NUMBER OF STATES PUT INTO
C                BLOCKS 1. 2. AND 3. (SEE ABOVE) OF THE WARIGH ARRAY
C     LUPPER  -  COUNTS THE TOTAL NUMBER OF UPPER HFB COMPONENTS
C                                              PUT INTO THE WARIGH ARRAY
C                (FOR IPAHFB=0 IT EQUALS TO LSTATE, BUT MUST BE DEFINED)
C     LTIMUP  -  COUNTS THE TOTAL NUMBER OF TIME-UP STATES
C                                              PUT INTO THE WARIGH ARRAY
C                (FOR MREVER=0 IT EQUALS TO LUPPER, BUT MUST BE DEFINED)
C=======================================================================
C
      LTOTST=0
      LSTATE=0
      LUPPER=0
      LTIMUP=0
C
      IF (IPAHFB.NE.1) THEN
C
C=======================================================================
C              DEFINING THE WARIGH ARRAY FOR THE "NOT HFB" CASE
C=======================================================================
C
          DO IREVER=0,MREVER
             DO ISTATE=1,NUMBSP(IREVER,ICHARG)
C
C@@@ TEMP - TEMP - TEMP - TEMP - TEMP - TEMP - TEMP - TEMP - TEMP
                    IF (V_OCCU(ISTATE+IREVER*NUMBSP(0,ICHARG)).GT.0.0
     *              .OR.IDEVAR.EQ.1.OR.IFTEMP.EQ.1) THEN
C@@@ TEMP - TEMP - TEMP - TEMP - TEMP - TEMP - TEMP - TEMP - TEMP
C
                    LSTATE=LSTATE+1
                    LUPPER=LUPPER+1
C
                    IF (IREVER.EQ.0) LTIMUP=LTIMUP+1
C
                    IF (LSTATE.GT.2*NDSTAT)
     *
     *                      STOP ' LSTATE > 2*NDSTAT IN DENSHF'
C
                    IF (ISIMPY.EQ.1) THEN
C
C=======================================================================
C                       DEFINING THE WARIGH ARRAY FOR THE CONSERVED
C                       SIMPLEX
C=======================================================================
C
                        DO IBASE=1,LDBASE
                           DO ISPIN=0,NDSPIN
C
                              WARIGH(IBASE,LSTATE,ISPIN)=
     *                            WAVOCC(IBASE,
     *                            ISTATE+IREVER*NUMBSP(0,ICHARG),IREVER)
     *                           *PHASPI(IBASE,IREVER,ISPIN)
C
                           END DO
                        END DO
C
                    ELSE
C
C=======================================================================
C                       DEFINING THE WARIGH ARRAY FOR THE NON-CONSERVED
C                       SIMPLEX
C=======================================================================
C
                        DO IBASE=1,LDBASE
                           DO ISPIN=0,NDSPIN
C
                              WARIGH(IBASE,LSTATE,ISPIN)=
     *
     *                            WAVOCC(IBASE,
     *                            ISTATE+IREVER*NUMBSP(0,ICHARG),0)
     *                           *PHASPI(IBASE,0,ISPIN)
     *
     *                           +WAVOCC(IBASE,
     *                            ISTATE+IREVER*NUMBSP(0,ICHARG),1)
     *                           *PHASPI(IBASE,1,ISPIN)
C
                           END DO
                        END DO
C
                    END IF
C
C=======================================================================
C                   MULTIPLYING THE WAVEFUNCTIONS BY THE  OCCUPATION
C                   PROBABILTIES IN CASE THE PAIRING MATRIX ELEMENTS
C                   WILL NOT HAVE BEEN REQUESTED
C=======================================================================
C
                    IF (IDEVAR.NE.1) THEN
C
                        DO IBASE=1,LDBASE
                           DO ISPIN=0,NDSPIN
C
                              WARIGH(IBASE,LSTATE,ISPIN)=
     *                        WARIGH(IBASE,LSTATE,ISPIN)
     *                       *V_OCCU(ISTATE+IREVER*NUMBSP(0,ICHARG))
C
                           END DO
                        END DO
C
                    ELSE
C
C=======================================================================
C                   SAVING THE OCCUPATION PROBABILTIES; LATER THE WAVE
C                   FUNCTIONS MUST BE MULTIPLIED BY THEM
C=======================================================================
C
                        V1OCCU(LSTATE)=
     *                  V_OCCU(ISTATE+IREVER*NUMBSP(0,ICHARG))
C
                    END IF
C
                END IF
C
             END DO
          END DO
C
C@@@ TEMP - TEMP - TEMP - TEMP - TEMP - TEMP - TEMP - TEMP - TEMP
          IF (IFTEMP.EQ.1) THEN
C
              DO IREVER=0,MREVER
                 DO ISTATE=1,NUMBSP(IREVER,ICHARG)
C
                    U1OCCU=SQRT(1.0D0
     *             -V_OCCU(ISTATE+IREVER*NUMBSP(0,ICHARG))**2)
C
                    LSTATE=LSTATE+1
C
c                    IF (IREVER.EQ.0) LTIMUP=LTIMUP+1
C
                    IF (LSTATE.GT.2*NDSTAT)
     *
     *                      STOP ' LSTATE > 2*NDSTAT IN DENSHF'
C
                    IF (ISIMPY.EQ.1) THEN
C
C                        DEFINING THE WARIGH ARRAY FOR THE CONSERVED
C                        SIMPLEX
C
                        DO IBASE=1,LDBASE
                           DO ISPIN=0,NDSPIN
C
                              WARIGH(IBASE,LSTATE,ISPIN)=
     *                        WAVOCC(IBASE,
     *                        ISTATE+IREVER*NUMBSP(0,ICHARG),IREVER)
     *                              *PHASPI(IBASE,IREVER,ISPIN)
C
                           END DO
                        END DO
C
                    ELSE
C
C                       DEFINING THE WARIGH ARRAY FOR THE NON-CONSERVED
C                       SIMPLEX
C
                        DO IBASE=1,LDBASE
                           DO ISPIN=0,NDSPIN
C
                              WARIGH(IBASE,LSTATE,ISPIN)=
     *
     *                        WAVOCC(IBASE,
     *                        ISTATE+IREVER*NUMBSP(0,ICHARG),0)
     *                       *PHASPI(IBASE,0,ISPIN)
     *
     *                       +WAVOCC(IBASE,
     *                        ISTATE+IREVER*NUMBSP(0,ICHARG),1)
     *                       *PHASPI(IBASE,1,ISPIN)
C
                           END DO
                        END DO
C
                    END IF
C
C                   MULTIPLYING THE WAVEFUNCTIONS BY THE  OCCUPATION
C                   PROBABILTIES IN CASE THE PAIRING MATRIX ELEMENTS
C                   WILL NOT HAVE BEEN REQUESTED
C
                    IF (IDEVAR.NE.1) THEN
C
                        DO IBASE=1,LDBASE
                           DO ISPIN=0,NDSPIN
C
                              WARIGH(IBASE,LSTATE,ISPIN)=
     *                        WARIGH(IBASE,LSTATE,ISPIN)
     *                       *U1OCCU
C
                           END DO
                        END DO
C
                    ELSE
C
                        V1OCCU(LSTATE)=
     *                  V_OCCU(ISTATE+IREVER*NUMBSP(0,ICHARG))
C
                    END IF
C
                END DO
             END DO
C
          END IF
C@@@ TEMP - TEMP - TEMP - TEMP - TEMP - TEMP - TEMP - TEMP - TEMP
C
          LTOTST=LSTATE
C
      ELSE
C
C=======================================================================
C              DEFINING THE WARIGH ARRAY FOR THE HFB CASE
C=======================================================================
C              LOOPS FOR THE UPPER COMPONENTS
C=======================================================================
C
          DO IREVER=0,MREVER
             DO ISTATE=1,NUMBQP(IREVER,ICHARG)
C
                IF (NOTOCC(ISTATE,IREVER).NE.1) THEN
C
                    LTOTST=LTOTST+1
                    LUPPER=LUPPER+1
C
                    IF (IREVER.EQ.0) LTIMUP=LTIMUP+1
C
                    IF (ISIMPY.EQ.1) THEN
C
C=======================================================================
C                       DEFINING THE WARIGH ARRAY FOR THE CONSERVED
C                       SIMPLEX
C=======================================================================
C
                        IF (LTOTST.GT.3*NDSTAT)
     *
     *                      STOP ' (1) LTOTST > 3*NDSTAT IN DENSHF'
C
                        DO IBASE=1,LDBASE
                           DO ISPIN=0,NDSPIN
C
                              WARIGH(IBASE,LTOTST,ISPIN)=
     *
     *                        BWAQUA(IBASE,ISTATE,IREVER)
     *                       *PHASPI(IBASE,IREVER,ISPIN)
     *                       *F_FLAG(ISTATE,IREVER,ICHARG)
     *                       *V_CORR(ISTATE,IREVER)
C
                           END DO
                        END DO
C
                    ELSE
C
C=======================================================================
C                       DEFINING THE WARIGH ARRAY FOR THE NON-CONSERVED
C                       SIMPLEX
C=======================================================================
C
                        IF (LTOTST.GT.4*NDSTAT)
     *
     *                          STOP ' (2) LTOTST > 4*NDSTAT IN DENSHF'
C
                        DO IBASE=1,LDBASE
                           DO ISPIN=0,NDSPIN
C
                              WARIGH(IBASE,LTOTST,ISPIN)=
     *
     *                       (BWAQUZ(IBASE,ISTATE
     *                              +IREVER*NUMBQP(0,ICHARG),0)
     *                              *PHASPI(IBASE,0,ISPIN)
     *
     *                       +BWAQUZ(IBASE,ISTATE
     *                              +IREVER*NUMBQP(0,ICHARG),1)
     *                              *PHASPI(IBASE,1,ISPIN))
     *
     *                       *V_CORR(ISTATE,IREVER)
C
                           END DO
                        END DO
C
                    END IF
C
                END IF
C
             END DO
          END DO
C
C=======================================================================
C              LOOPS FOR THE LOWER COMPONENT
C=======================================================================
C
          IF (ISIMPY.EQ.1) THEN
C
C=======================================================================
C             DEFINING THE WARIGH ARRAY FOR THE CONSERVED SIMPLEX
C=======================================================================
C             ATTENTION:   BELOW WE USE "1-LREVER" IN ALL  PLACES  WHICH
C                          PERTAIN TO THE QUASIPARTICLE INDICES. INDEED,
C                          THE "AWAQUA" ARRAYS HAVE  THE  BASIS  (FIRST)
C                          INDEX IN THE "LREVER" SECTOR AND  THE  QUASI-
C                          PARTICLE (SECOND)  INDEX  IN  THE  "1-LREVER"
C                          SECTOR.
C=======================================================================
C
             DO IREVER=0,MREVER
C
                                 JREVER=LREVER
                IF (IREVER.EQ.1) JREVER=1-LREVER
C
                DO ISTATE=1,NUMBQP(1-JREVER,ICHARG)
C
                    IF (NOTOCC(ISTATE,1-JREVER).NE.1) THEN
C
                        LTOTST=LTOTST+1
C
                        IF (LTOTST.GT.3*NDSTAT)
     *
     *                      STOP ' (2) LTOTST > 3*NDSTAT IN DENSHF'
C
C=======================================================================
C              THE SPINOR OF THE SIMPLEX BASIS IS TIME REVERSED, I.E. IT
C              IS FLIPPED AND ITS PHASE IS CHANGED (SEE NOTES IN  7-41E)
C              IN ORDER TO CALCULATE THE ABNORMAL DENSITY (THAT  IN  THE
C              RUSSIAN CONVENTION = TILDED DENSITY IN EQ. (2.1B) OF  THE
C              1984 DFT PAPER). DUE TO THIS TRICK, THE FORMULAE FOR  THE
C              LOCAL DENSITIES IN THE P-H AND P-P CHANNELS ARE IDENTICAL
C              (EXCEPT THAT THOSE IN THE P-P CHANNEL CAN BE COMPLEX WHEN
C              THE TIME REVERSAL SYMMETRY IS BROKEN).
C=======================================================================
C              ATTENTION: SIGN OF THE SECOND HFB COMPONENT WAS INCORRECT
C                         UP TO THE VERSION (2.16N). AT THE  SAME  TIME,
C                         INCORRECT SIGNS HAVE BEEN CODED FOR THE MATRIX
C                         ELEMENTS OF THE PAIRING FIELDS  (SEE  COMMENTS
C                         IN "INTEGD"), AND HENCE NONE  OF  THE  RESULTS
C                         WERE  AFFECTED.  THIS  BUG  WAS  CORRECTED  ON
C                         07/04/05 IN VERSION (2.17).
C=======================================================================
C
                        DO IBASE=1,LDBASE
                           DO ISPIN=0,NDSPIN
                              WARIGH(IBASE,LTOTST,ISPIN)=
     *                        AWAQUA(IBASE,ISTATE,JREVER)*(2*ISPIN-1)
     *                        *CONJG(PHASPI(IBASE,JREVER,1-ISPIN))
     *                             *F_FLAG(ISTATE,JREVER,ICHARG)
                           END DO
                        END DO
C
                    END IF      ! NOTOCC(ISTATE,JREVER).NE.1
C
                 END DO         ! ISTATE
C
                 IF (IREVER.EQ.0) LSTATE=LTOTST
C
              END DO            ! IREVER
C
          ELSE                  ! ISIMPY.EQ.1
C
C=======================================================================
C             DEFINING THE WARIGH ARRAY FOR THE NON-CONSERVED SIMPLEX
C=======================================================================
C
              DO IREVER=0,MREVER
                 DO ISTATE=1,NUMBQP(IREVER,ICHARG)
C
                    IF (NOTOCC(ISTATE,IREVER).NE.1) THEN
C
                        LTOTST=LTOTST+1
C
                        IF (LTOTST.GT.4*NDSTAT)
     *
     *                      STOP ' (3) LTOTST > 4*NDSTAT IN DENSHF'
C
                        DO IBASE=1,LDBASE
                           DO ISPIN=0,NDSPIN
C
                              WARIGH(IBASE,LTOTST,ISPIN)=
     *
     *                       (AWAQUZ(IBASE,ISTATE
     *                       +IREVER*NUMBQP(0,ICHARG),0)*(2*ISPIN-1)
     *                              *CONJG(PHASPI(IBASE,0,1-ISPIN))
     *
     *                       +AWAQUZ(IBASE,ISTATE
     *                       +IREVER*NUMBQP(0,ICHARG),1)*(2*ISPIN-1)
     *                              *CONJG(PHASPI(IBASE,1,1-ISPIN)))
C
                           END DO
                        END DO
C
                    END IF
C
                 END DO         ! ISTATE
C
                 IF (IREVER.EQ.0) LSTATE=LTOTST
C
              END DO            ! IREVER
C
           END IF               ! ISIMPY.EQ.1
C
       END IF                   ! IPAHFB.NE.1
C
C=======================================================================
C          SAVING THE NUMBERS OF STATES STORED.
C=======================================================================
C
      LDTOTS(ICHARG)=LTOTST
      LDSTAT(ICHARG)=LSTATE
      LDUPPE(ICHARG)=LUPPER
      LDTIMU(ICHARG)=LTIMUP
C
C=======================================================================
C          HERE WE SAVE THE WAVE FUNCTIONS FOR FUTURE ANGULAR MOMENTUM
C          PROJECTION.
C          ATTENTION: FOR IDEVAR=1, INCORRECT WAVE FUNCTIONS WOULD  BE
C                     SAVED
C=======================================================================
C
      IF (ISAWAV.EQ.1) THEN
          SARIGH(:,:,:,ICHARG)=WARIGH(:,:,:)
      END IF
C
C=======================================================================
C         ATTENTION: IN THE VERSIONS OF THE CODE EARLIER  THAN  2.31F,
C                    VALUES OF PARAMETERS INIINV, INIKAR,  AND  INIROT
C                    WERE NOT  CHECKED  AGAINST  CONSERVED  SYMMETRIES
C                    SO AS TO ENSURE THAT A  GIVEN  D2H-TRANSFORMATION
C                    OR ROTATION IS PERFORMED ONLY WHEN IT  IS  BROKEN
C                    (SEE THE RELEVANT TESTS PERFORMED NOW IN TESDAT).
C                    ALTHOUGH THIS WAS NOT REALLY A BUG, THE CODE  WAS
C                    ALLOWED TO RUN IN CONDITIONS WHERE  THE  SPECIFIC
C                    TRANSFORMATIONS COULD NOT BE PROPERLY  PERFORMED.
C                    THE REQUIRED TESTS WERE ADDED  IN  VERSION  2.31F
C                    ON 10/09/2007
C=======================================================================
C          HERE WE D2H-TRANSFORM THE "RIGHT" WAVE FUNCTIONS:
C=======================================================================
C
       IF ((INIINV.GE.1.OR.INIKAR.GE.1).AND.ITERUN.EQ.1) THEN
C
           CALL INVWAV(LSTATE,INIINV,INIKAR,WARIGH)
C
       END IF
C
C=======================================================================
C          HERE WE ROTATE THE "RIGHT" WAVE FUNCTIONS:
C=======================================================================
C
       IF (INIROT.EQ.1.AND.ITERUN.EQ.1) THEN
C
           ALPROT=ALPINI
           BETROT=BETINI
           GAMROT=GAMINI
C
           CALL ROTWAV(LSTATE,WARIGH)
C
       END IF
C
C=======================================================================
C     HERE WE ARRIVE WITH THE WAVE FUNCTIONS THAT ARE ALREADY PRESENT IN
C     THE WARIGH AND WALEFT MATRICES
C=======================================================================
C
      END IF
C
      LTOTST=LDTOTS(ICHARG)
      LSTATE=LDSTAT(ICHARG)
      LUPPER=LDUPPE(ICHARG)
      LTIMUP=LDTIMU(ICHARG)
C
C=======================================================================
C          BEGINNING THE CALCULATION OF SINGLE-PARTICLE (FOR IPAHFB=0)
C                                    OR QUASIPARTICLE   (FOR IPAHFB=1)
C          WAVE FUNCTIONS IN THE SPACE REPRESENTATION
C=======================================================================
C          SYMMETRIZATION OF DENSITIES IS PERFORMED ONLY FOR THE MOST
C          STANDARD SKYRME CALCULATIONS
C=======================================================================
C
      DOSYME=I_GOGA.LE.1.AND.IGOGPA.LE.1.AND.I_YUKA.LE.1.AND.
     *       ICOUDI.LE.1.AND.ICOUEX.LE.1.AND.IKERNE.NE.1.AND.
     * .NOT.(ISYMDE.EQ.1.AND.PRINIT)
C
C=======================================================================
C          ONLY HALF OF THE BOX IN Z DIRECTION TAKEN FOR ISIMTZ=1 OR
C          ISIGNY=1 OR ISIQTY=1
C=======================================================================
C
                                                         IHABOZ=2
      IF ((ISIMTZ.NE.1.AND.ISIGNY.NE.1.AND.ISIQTY.NE.1)
     *                                .OR.(.NOT.DOSYME)) IHABOZ=1
C
C=======================================================================
C        ONLY HALF OF THE BOX IN Y DIRECTION TAKEN FOR ISIMPY=1
C                                               OR FOR JSIMTY=1
C=======================================================================
C
                                                         IHABOY=2
      IF ((ISIMPY.NE.1.AND.JSIMTY.NE.1)
     *                                .OR.(.NOT.DOSYME)) IHABOY=1
C
C=======================================================================
C           ONLY HALF OF THE BOX IN X DIRECTION TAKEN FOR ISIMTX=1
C=======================================================================
C
                                                         IHABOX=2
      IF (ISIMTX.NE.1
     *                                .OR.(.NOT.DOSYME)) IHABOX=1
C
C=======================================================================
C          LOOP OVER GAUSS-HERMITE POINTS OF Z-INTEGRATION
C=======================================================================
C
#if(SWITCH_PORT==1)
      PLA(:,:)=C_ZERO
      QLA(:,:)=C_ZERO
      P(:,:,:)=C_ZERO
      Q(:,:,:)=C_ZERO
#endif
C
C=======================================================================
C     COMMENT ABOUT MULTI-THREADING - THE  PARALLELIZATION BELOW SEEMS
C     TO BE THE FASTEST. HOWEVER, IT IT ALSO THE ONE THAT REQUIRES THE
C     LARGEST AMOUNT OF STACK SIZE (MEMORY PER  THREAD) BECAUSE OF THE
C     ARRAYS HRIGHE, ETC. FOR  LARGE  BASES  AND/OR  ANGULAR  MOMENTUM
C     CALCULATIONS, IT  MAY BE NECESSARY TO CHANGE THE PARALLELIZATION
C     SCHEME SO THAT MULTITHREADING TAKES PLACE  (I)  FIRST WITHIN THE
C     LOOP OVER NX (II) THEN ALSO WITHIN THE LOOP OVER IY
C=======================================================================
C
      I_FAIL=0
C
      IF (.NOT.ALLOCATED(HRIGHE)) THEN
C
          ALLOCATE(HRIGHE(0:NDXMAX,0:NDYMAX,1:4*NDSTAT,0:NDSPIN),
     *                                              STAT=I_FAIL)
          IF (I_FAIL.NE.0) THEN
              WRITE(6,'("Error in Allocating HRIGHE - DENSHF")')
              STOP 'Error in Allocating HRIGHE'
          END IF
C
          ALLOCATE(HRIGDH(0:NDXMAX,0:NDYMAX,1:4*NDSTAT,0:NDSPIN),
     *                                              STAT=I_FAIL)
          IF (I_FAIL.NE.0) THEN
              WRITE(6,'("Error in Allocating HRIGDH - DENSHF")')
              STOP 'Error in Allocating HRIGDH'
          END IF
C
          ALLOCATE(HRIGDD(0:NDXMAX,0:NDYMAX,1:4*NDSTAT,0:NDSPIN),
     *                                              STAT=I_FAIL)
          IF (I_FAIL.NE.0) THEN
              WRITE(6,'("Error in Allocating HRIGDD - DENSHF")')
              STOP 'Error in Allocating HRIGDD'
          END IF
C
          IF (IKERNE.EQ.1) THEN
C
              ALLOCATE(HLEFHE(0:NDXMAX,0:NDYMAX,1:4*NDSTAT,0:NDSPIN),
     *                                                  STAT=I_FAIL)
              IF (I_FAIL.NE.0) THEN
                  WRITE(6,'("Error in Allocating HLEFHE - DENSHF")')
                  STOP 'Error in Allocating HLEFHE'
              END IF
C
              ALLOCATE(HLEFDH(0:NDXMAX,0:NDYMAX,1:4*NDSTAT,0:NDSPIN),
     *                                                  STAT=I_FAIL)
              IF (I_FAIL.NE.0) THEN
                  WRITE(6,'("Error in Allocating HLEFDH - DENSHF")')
                  STOP 'Error in Allocating HLEFDH'
              END IF
C
              ALLOCATE(HLEFDD(0:NDXMAX,0:NDYMAX,1:4*NDSTAT,0:NDSPIN),
     *                                                  STAT=I_FAIL)
              IF (I_FAIL.NE.0) THEN
                  WRITE(6,'("Error in Allocating HLEFDD - DENSHF")')
                  STOP 'Error in Allocating HLEFDD'
              END IF
C
          END IF ! end if IKERNE
C
      END IF ! end if ALLOCATED
C
      DO IZ=1,NZHERM/IHABOZ
!$OMP PARALLEL DO
!$OMP& DEFAULT(NONE)
!$OMP& SCHEDULE(DYNAMIC)
!$OMP& SHARED(NXMAXX,LTOTST,HRIGHE,HRIGDH,HRIGDD,HLEFHE,HLEFDH,HLEFDD,
!$OMP&        LAYOFX,LAZOXY,C_ZERO,CERMTS,CHRMTS,CDHRMT,IKERNE,INDICE,
!$OMP&        WARIGH,WALEFT,IZ)
!$OMP& PRIVATE(NX,NY,NZ,ISPIN,IBASE,ISTATE,ONEWAV,RMTS,LAYOFX_1,
!$OMP&         LAZOXY_1)
         DO NX=0,NXMAXX
            LAYOFX_1=LAYOFX(NX)
            DO NY=0,LAYOFX_1
               DO ISTATE=1,LTOTST
                  DO ISPIN=0,NDSPIN
C
                     ONEWAV=C_ZERO
                     LAZOXY_1=LAZOXY(NX,NY)
C
                     DO NZ = 0,LAZOXY_1
                       IBASE = INDICE(NX,NY,NZ)
                       RMTS = CERMTS(NZ,IZ,3)
                       ONEWAV=ONEWAV+WARIGH(IBASE,ISTATE,ISPIN)*RMTS
                     END DO
                     HRIGHE(NX,NY,ISTATE,ISPIN)=ONEWAV
C
                     ONEWAV=C_ZERO
                     DO NZ = 0,LAZOXY_1
                       IBASE = INDICE(NX,NY,NZ)
                       RMTS = CHRMTS(NZ,IZ,3)
                       ONEWAV=ONEWAV+WARIGH(IBASE,ISTATE,ISPIN)*RMTS
                     END DO
                     HRIGDH(NX,NY,ISTATE,ISPIN)=ONEWAV
C
                     ONEWAV=C_ZERO
                     DO NZ = 0,LAZOXY_1
                       IBASE = INDICE(NX,NY,NZ)
                       RMTS = CDHRMT(NZ,IZ,3)
                       ONEWAV=ONEWAV+WARIGH(IBASE,ISTATE,ISPIN)*RMTS
                     END DO
                     HRIGDD(NX,NY,ISTATE,ISPIN)=ONEWAV
C
                     IF (IKERNE.EQ.1) THEN
C
                        ONEWAV=C_ZERO
                        DO NZ = 0,LAZOXY_1
                           IBASE = INDICE(NX,NY,NZ)
                           RMTS = CERMTS(NZ,IZ,3)
                           ONEWAV=ONEWAV+WALEFT(IBASE,ISTATE,ISPIN)*RMTS
                        END DO
                        HLEFHE(NX,NY,ISTATE,ISPIN)=ONEWAV
C
                        ONEWAV=C_ZERO
                        DO NZ = 0,LAZOXY_1
                           IBASE = INDICE(NX,NY,NZ)
                           RMTS = CHRMTS(NZ,IZ,3)
                           ONEWAV=ONEWAV+WALEFT(IBASE,ISTATE,ISPIN)*RMTS
                        END DO
                        HLEFDH(NX,NY,ISTATE,ISPIN)=ONEWAV
C
                        ONEWAV=C_ZERO
                        DO NZ = 0,LAZOXY_1
                           IBASE = INDICE(NX,NY,NZ)
                           RMTS = CDHRMT(NZ,IZ,3)
                           ONEWAV=ONEWAV+WALEFT(IBASE,ISTATE,ISPIN)*RMTS
                        END DO
                        HLEFDD(NX,NY,ISTATE,ISPIN)=ONEWAV
C
                     END IF
C
                  END DO !ISPIN
               END DO !ISTATE
            END DO !NY
         END DO !NX
!$OMP END PARALLEL DO
C
C=======================================================================
C        LOOP OVER GAUSS-HERMITE POINTS OF Y-INTEGRATION
C=======================================================================
C
!$OMP PARALLEL
!$OMP& DEFAULT(NONE)
!$OMP& SHARED(NXHERM,NYHERM,HRIGHE,HRIGDH,HRIGDD,HLEFHE,HLEFDH,HLEFDD,
!$OMP&        IHABOX,IHABOY,NXMAXX,LSTATE,LTOTST,LAYOFX,LAZOXY,C_UNIT,
!$OMP&        C_ZERO,CERMTS,CHRMTS,CDHRMT,IDEVAR,IPAHFB,IKERNE,V1OCCU,
!$OMP&        SQUWAV,IFTEMP,LUPPER,FER_FN,MUSYME,LREVER,ISIMPY,UNIT_I,
!$OMP&        LTIMUP,DE_RHO,DE_TAU,DE_LPR,DE_DIV,DE_SPI,DE_KIS,DE_LPS,
!$OMP&        DE_GRR,DE_CUR,DE_ROS,DE_ROC,DE_SCU,DE_DES,PD_RHO,PP_RHO,
!$OMP&        DCONTI,ITPNMX,MREVER,IZ)
!$OMP& PRIVATE(IX,IY,NX,ISPIN,IBASE,ISTATE,MU,NU,Q,QLA,P,PLA,K,L,
!$OMP&         ARHEHE,ARHEDH,ARDHHE,ARHEDD,ARDDHE,ALHEHE,ALHEDH,ALDHHE,
!$OMP&         ALHEDD,ALDDHE,JSTATE,U1OCCU,DLUPUP,DLDWDW,DLUPDW,DLDWUP,
!$OMP&         CLUPUP,CLDWDW,CLUPDW,CLDWUP,DEUPUP,DEDWDW,DEUPDW,DEDWUP,
!$OMP&         DCUPUP,DCDWDW,DCUPDW,DCDWUP,DENAUX,LOFSET,PAUPUP,PADWDW,
!$OMP&         PAUPDW,PADWUP,PCUPUP,PCDWDW,PCUPDW,PCDWUP,LOFTRV,LUPTRV,
!$OMP&         SIMFAC,LAYOFX_1)
!$OMP DO
!$OMP& SCHEDULE(DYNAMIC)
         DO IY=1,NYHERM/IHABOY
C
            DO ISPIN=0,NDSPIN
               DO ISTATE=1,LTOTST
                  DO NX=0,NXMAXX
C
                     LAYOFX_1 = LAYOFX(NX) + 1
C
                     ARHEHE(NX,ISTATE,ISPIN)=ZDOTU(LAYOFX_1,
     *                      HRIGHE(NX,0,ISTATE,ISPIN),NDXMAX+1,
     *                      CERMTS(0,IY,2),1)
C
                     ARHEDH(NX,ISTATE,ISPIN)=ZDOTU(LAYOFX_1,
     *                      HRIGDH(NX,0,ISTATE,ISPIN),NDXMAX+1,
     *                      CERMTS(0,IY,2),1)
C
                     ARDHHE(NX,ISTATE,ISPIN)=ZDOTU(LAYOFX_1,
     *                      HRIGHE(NX,0,ISTATE,ISPIN),NDXMAX+1,
     *                      CHRMTS(0,IY,2),1)
C
                     ARHEDD(NX,ISTATE,ISPIN)=ZDOTU(LAYOFX_1,
     *                      HRIGDD(NX,0,ISTATE,ISPIN),NDXMAX+1,
     *                      CERMTS(0,IY,2),1)
C
                     ARDDHE(NX,ISTATE,ISPIN)=ZDOTU(LAYOFX_1,
     *                      HRIGHE(NX,0,ISTATE,ISPIN),NDXMAX+1,
     *                      CDHRMT(0,IY,2),1)
C
                     IF (IKERNE.EQ.1) THEN
C
                         ALHEHE(NX,ISTATE,ISPIN)=ZDOTU(LAYOFX_1,
     *                       HLEFHE(NX,0,ISTATE,ISPIN),NDXMAX+1,
     *                       CERMTS(0,IY,2),1)
C
                         ALHEDH(NX,ISTATE,ISPIN)=ZDOTU(LAYOFX_1,
     *                       HLEFDH(NX,0,ISTATE,ISPIN),NDXMAX+1,
     *                       CERMTS(0,IY,2),1)
C
                         ALDHHE(NX,ISTATE,ISPIN)=ZDOTU(LAYOFX_1,
     *                       HLEFHE(NX,0,ISTATE,ISPIN),NDXMAX+1,
     *                       CHRMTS(0,IY,2),1)
C
                         ALHEDD(NX,ISTATE,ISPIN)=ZDOTU(LAYOFX_1,
     *                       HLEFDD(NX,0,ISTATE,ISPIN),NDXMAX+1,
     *                       CERMTS(0,IY,2),1)
C
                         ALDDHE(NX,ISTATE,ISPIN)=ZDOTU(LAYOFX_1,
     *                       HLEFHE(NX,0,ISTATE,ISPIN),NDXMAX+1,
     *                       CDHRMT(0,IY,2),1)
C
                     END IF
C
                  END DO ! end loop NX
               END DO ! end loop ISTATE
            END DO ! end loop ISPIN
C
C=======================================================================
C           LOOP OVER GAUSS-HERMITE POINTS OF X-INTEGRATION
C=======================================================================
C
            DO IX=1,NXHERM/IHABOX
C
               DO ISPIN=0,NDSPIN
C
                  CALL ZGEMV('T',NXMAXX+1,LTOTST,C_UNIT,
     *                           ARHEHE(0,1,ISPIN),
     *                           NDXMAX+1,CERMTS(0,IX,1),1,C_ZERO,
     *                           Q(0,1,ISPIN), NDKART+2)
                  CALL ZGEMV('T',NXMAXX+1,LTOTST,C_UNIT,
     *                           ARHEHE(0,1,ISPIN),
     *                           NDXMAX+1,CHRMTS(0,IX,1),1,C_ZERO,
     *                           Q(1,1,ISPIN), NDKART+2)
                  CALL ZGEMV('T',NXMAXX+1,LTOTST,C_UNIT,
     *                           ARDHHE(0,1,ISPIN),
     *                           NDXMAX+1,CERMTS(0,IX,1),1,C_ZERO,
     *                           Q(2,1,ISPIN), NDKART+2)
                  CALL ZGEMV('T',NXMAXX+1,LTOTST,C_UNIT,
     *                           ARHEDH(0,1,ISPIN),
     *                           NDXMAX+1,CERMTS(0,IX,1),1,C_ZERO,
     *                           Q(3,1,ISPIN), NDKART+2)
C
                  CALL ZGEMV('T',NXMAXX+1,LTOTST,C_UNIT,
     *                           ARHEHE(0,1,ISPIN),
     *                           NDXMAX+1,CDHRMT(0,IX,1),1,C_ZERO,
     *                           QLA(1,ISPIN), 1)
                  CALL ZGEMV('T',NXMAXX+1,LTOTST,C_UNIT,
     *                           ARDDHE(0,1,ISPIN),
     *                           NDXMAX+1,CERMTS(0,IX,1),1,C_UNIT,
     *                           QLA(1,ISPIN), 1)
                  CALL ZGEMV('T',NXMAXX+1,LTOTST,C_UNIT,
     *                           ARHEDD(0,1,ISPIN),
     *                           NDXMAX+1,CERMTS(0,IX,1),1,C_UNIT,
     *                           QLA(1,ISPIN), 1)
C
                  IF (IKERNE.EQ.1) THEN
C
                      CALL ZGEMV('T',NXMAXX+1,LTOTST,C_UNIT,
     *                               ALHEHE(0,1,ISPIN),
     *                               NDXMAX+1,CERMTS(0,IX,1),1,C_ZERO,
     *                               P(0,1,ISPIN), NDKART+2)
                      CALL ZGEMV('T',NXMAXX+1,LTOTST,C_UNIT,
     *                               ALHEHE(0,1,ISPIN),
     *                               NDXMAX+1,CHRMTS(0,IX,1),1,C_ZERO,
     *                               P(1,1,ISPIN), NDKART+2)
                      CALL ZGEMV('T',NXMAXX+1,LTOTST,C_UNIT,
     *                               ALDHHE(0,1,ISPIN),
     *                               NDXMAX+1,CERMTS(0,IX,1),1,C_ZERO,
     *                               P(2,1,ISPIN), NDKART+2)
                      CALL ZGEMV('T',NXMAXX+1,LTOTST,C_UNIT,
     *                               ALHEDH(0,1,ISPIN),
     *                               NDXMAX+1,CERMTS(0,IX,1),1,C_ZERO,
     *                               P(3,1,ISPIN), NDKART+2)
C
                      CALL ZGEMV('T',NXMAXX+1,LTOTST,C_UNIT,
     *                               ALHEHE(0,1,ISPIN),
     *                               NDXMAX+1,CDHRMT(0,IX,1),1,C_ZERO,
     *                               PLA(1,ISPIN), 1)
                      CALL ZGEMV('T',NXMAXX+1,LTOTST,C_UNIT,
     *                               ALDDHE(0,1,ISPIN),
     *                               NDXMAX+1,CERMTS(0,IX,1),1,C_UNIT,
     *                               PLA(1,ISPIN), 1)
                      CALL ZGEMV('T',NXMAXX+1,LTOTST,C_UNIT,
     *                               ALHEDD(0,1,ISPIN),
     *                               NDXMAX+1,CERMTS(0,IX,1),1,C_UNIT,
     *                               PLA(1,ISPIN), 1)
C
                  END IF ! end if IKERNE
C
               END DO ! end loop ISPIN
C
C=======================================================================
C
C              AT THIS POINT:
C
C              Q(0,ISTATE,ISPIN) CONTAINS THE ISTATE-TH  SINGLE-PARTICLE
C                                "RIGHT" WAVE FUNCTION, OR UPPER / LOWER
C                                QUASI-PARTCLE WAVE FUNCTION, IN ONE  OF
C                                THE SPIN BLOCKS, AS DESCRIBED ABOVE.
C              Q(K,ISTATE,ISPIN) (K=1,2,3) CONTAINS ITS X,Y,Z DERIVATIVE
C              QLA(ISTATE,ISPIN) CONTAINS ITS LAPLACIAN
C
C              P(0,ISTATE,ISPIN) CONTAINS THE ISTATE-TH  SINGLE-PARTICLE
C                                "LEFT"  WAVE FUNCTION, OR UPPER / LOWER
C                                QUASI-PARTCLE WAVE FUNCTION, IN ONE  OF
C                                THE SPIN BLOCKS, AS DESCRIBED ABOVE.
C              P(K,ISTATE,ISPIN) (K=1,2,3) CONTAINS ITS X,Y,Z DERIVATIVE
C              PLA(ISTATE,ISPIN) CONTAINS ITS LAPLACIAN
C
C              THEY ARE CALCULATED AT THE  (IX,IY,IZ)-TH  POINT  OF  THE
C              INTEGRATION MESH
C
C=======================================================================
C              FOR IKERNE=0 Q( . . . ) IS STORED IN P( . . . )
C=======================================================================
C
               IF (IKERNE.NE.1) THEN
C
                   CALL ZCOPY((NDKART+1)*4*NDSTAT*(NDSPIN+1),Q(0,1,0),1,
     *                                                       P(0,1,0),1)
C
                   CALL ZCOPY(4*NDSTAT*(NDSPIN+1),QLA,1,PLA,1)
C
               END IF
C
C=======================================================================
C              COMPLEX CONJUGATE OF Q( . . . ) IS STORED IN Q( . . . )
C=======================================================================
C
               DO ISPIN=0,NDSPIN
                  DO ISTATE=1,LTOTST
                     DO MU=0,NDKART
                        Q(MU,ISTATE,ISPIN)=CONJG(Q(MU,ISTATE,ISPIN))
                     END DO
                  END DO
               END DO
C
               DO ISPIN=0,NDSPIN
                  DO ISTATE=1,LTOTST
                     QLA(ISTATE,ISPIN)=CONJG( QLA(ISTATE,ISPIN))
                  END DO
               END DO
C
C=======================================================================
C              STORING SQUARES OF WAVE FUNCTIONS FOR THE CALCULATION OF
C              PAIRING MATRIX ELEMENTS
C=======================================================================
C
               IF (IDEVAR.EQ.1.AND.IPAHFB.NE.1) THEN
C
                   IF (LSTATE.GT.NDSTAT)
     *
     *                 STOP ' LSTATE.GT.NDSTAT IN DENSHF'
C
                      JSTATE=LSTATE
                   DO ISTATE=1,LSTATE
                      JSTATE=JSTATE+1
                      U1OCCU=SQRT(1.0d0-V1OCCU(ISTATE)**2)
C
                      SQUWAV(ISTATE,IX,IY,IZ)=
     *                                2.0D0*REAL(P(0,ISTATE,1)
     *                                          *Q(0,ISTATE,1)
     *                                          +P(0,ISTATE,0)
     *                                          *Q(0,ISTATE,0))
C
C=======================================================================
C              HERE THE WAVE FUNCTIONS ARE MULTIPLIED BY THE OCCUPATION
C              PROBABILTIES
C=======================================================================
C
                      DO ISPIN=0,NDSPIN
C
                         CALL ZDSCAL(NDKART+1,V1OCCU(ISTATE),
     *                                    P(0,ISTATE,ISPIN),1)
                         CALL ZDSCAL(NDKART+1,V1OCCU(ISTATE),
     *                                    Q(0,ISTATE,ISPIN),1)
C
C@@@ TEMP - TEMP - TEMP - TEMP - TEMP - TEMP - TEMP - TEMP - TEMP
                         IF (IFTEMP.EQ.1) THEN
                             CALL ZDSCAL(NDKART+1,U1OCCU,
     *                                    P(0,JSTATE,ISPIN),1)
                             CALL ZDSCAL(NDKART+1,U1OCCU,
     *                                    Q(0,JSTATE,ISPIN),1)
                         END IF
C@@@ TEMP - TEMP - TEMP - TEMP - TEMP - TEMP - TEMP - TEMP - TEMP
C
                         PLA(ISTATE,ISPIN)=
     *                   PLA(ISTATE,ISPIN)*V1OCCU(ISTATE)
C
                         QLA(ISTATE,ISPIN)=
     *                   QLA(ISTATE,ISPIN)*V1OCCU(ISTATE)
C
C@@@ TEMP - TEMP - TEMP - TEMP - TEMP - TEMP - TEMP - TEMP - TEMP
                         IF (IFTEMP.EQ.1) THEN
                             PLA(JSTATE,ISPIN)=
     *                       PLA(JSTATE,ISPIN)*U1OCCU
C
                             QLA(JSTATE,ISPIN)=
     *                       QLA(JSTATE,ISPIN)*U1OCCU
                        END IF
C@@@ TEMP - TEMP - TEMP - TEMP - TEMP - TEMP - TEMP - TEMP - TEMP
C
                      END DO ! end loop ISPIN
C
                   END DO ! end loop ISTATE
C
               END IF ! end if IDEVAR
C
C=======================================================================
C              SUMMING UP DENSITIES IN THE P-H CHANNEL
C=======================================================================
C
C=======================================================================
C              SUMMING UP CONTRIBUTIONS TO THE AUXILIARY P-H DENSITIES
C=======================================================================
C
               DLUPUP=C_ZERO
               DLDWDW=C_ZERO
               DLUPDW=C_ZERO
               DLDWUP=C_ZERO
C
               CLUPUP=C_ZERO
               CLDWDW=C_ZERO
               CLUPDW=C_ZERO
               CLDWUP=C_ZERO
C
C@@@ TEMP - TEMP - TEMP - TEMP - TEMP - TEMP - TEMP - TEMP - TEMP
               IF (IFTEMP.EQ.0) THEN
C
                   DLUPUP=(ZDOTU(LUPPER,PLA(1,1),1,Q(0,1,1),NDKART+2)+
     *                     ZDOTU(LUPPER,QLA(1,1),1,P(0,1,1),NDKART+2))
     *                    /2
                   DLDWDW=(ZDOTU(LUPPER,PLA(1,0),1,Q(0,1,0),NDKART+2)+
     *                     ZDOTU(LUPPER,QLA(1,0),1,P(0,1,0),NDKART+2))
     *                    /2
                   DLUPDW=(ZDOTU(LUPPER,PLA(1,1),1,Q(0,1,0),NDKART+2)+
     *                     ZDOTU(LUPPER,QLA(1,0),1,P(0,1,1),NDKART+2))
     *                    /2
                   DLDWUP=(ZDOTU(LUPPER,PLA(1,0),1,Q(0,1,1),NDKART+2)+
     *                     ZDOTU(LUPPER,QLA(1,1),1,P(0,1,0),NDKART+2))
     *                    /2
C
               ELSE
C
C@@@@@@  HERE, DO THE FOLLOWING:
C@@@@@@   - REPLACE THE SUMMATION OF ISTATE FROM 1 TO LUPPER BY SUMMATION
C@@@@@@     OF ISINGL FROM 1 TO LSINUP TO SUM ONLY OVER NONROTATED QP
C@@@@@@	  - WITHIN THE LOOP, REPLACE ISTATE AND JSTATE BY THE CORRESPONDING
C@@@@@@     ISTATE = INDEX_B(ISINGL), JSTATE = INDEX_A(ISINGL), WHERE
C@@@@@@     INDEX_A AND INDEX_B GIVE THE CORRESPONDENCE FROM THE INDEX
C@@@@@@     OF NONROTATED Q.P., ISINGL, TO THE GENERIC INDEX FOR ALL Q.P.
C
                      JSTATE=LUPPER
                   DO ISTATE=1,LUPPER
                      JSTATE=JSTATE+1
C
                      DLUPUP=DLUPUP+(PLA(ISTATE,1)*Q(0,ISTATE,1)
     *                             + P(0,ISTATE,1)*QLA(ISTATE,1))
     *                             *(1.D0-FER_FN(ISTATE))
     *                             +(PLA(JSTATE,1)*Q(0,JSTATE,1)
     *                             + P(0,JSTATE,1)*QLA(JSTATE,1))
     *                             * FER_FN(ISTATE)
                      DLDWDW=DLDWDW+(PLA(ISTATE,0)*Q(0,ISTATE,0)
     *                             + P(0,ISTATE,0)*QLA(ISTATE,0))
     *                             *(1.D0-FER_FN(ISTATE))
     *                             +(PLA(JSTATE,0)*Q(0,JSTATE,0)
     *                             + P(0,JSTATE,0)*QLA(JSTATE,0))
     *                             * FER_FN(ISTATE)
C
                      DLUPDW=DLUPDW+(PLA(ISTATE,1)*Q(0,ISTATE,0)
     *                             + P(0,ISTATE,1)*QLA(ISTATE,0))
     *                             *(1.D0-FER_FN(ISTATE))
     *                             +(PLA(JSTATE,1)*Q(0,JSTATE,0)
     *                             + P(0,JSTATE,1)*QLA(JSTATE,0))
     *                             * FER_FN(ISTATE)
C
                      DLDWUP=DLDWUP+(PLA(ISTATE,0)*Q(0,ISTATE,1)
     *                             + P(0,ISTATE,0)*QLA(ISTATE,1))
     *                             *(1.D0-FER_FN(ISTATE))
     *                             +(PLA(JSTATE,0)*Q(0,JSTATE,1)
     *                             + P(0,JSTATE,0)*QLA(JSTATE,1))
     *                             * FER_FN(ISTATE)
C
C                      Contribution from the continuum
C
                      CLUPUP=CLUPUP+(PLA(JSTATE,1)*Q(0,JSTATE,1)
     *                             + P(0,JSTATE,1)*QLA(JSTATE,1))
     *                             * FER_FN(ISTATE)
                      CLDWDW=CLDWDW+(PLA(JSTATE,0)*Q(0,JSTATE,0)
     *                             + P(0,JSTATE,0)*QLA(JSTATE,0))
     *                             * FER_FN(ISTATE)

                      CLUPDW=CLUPDW+(PLA(JSTATE,1)*Q(0,JSTATE,0)
     *                             + P(0,JSTATE,1)*QLA(JSTATE,0))
     *                             * FER_FN(ISTATE)
                      CLDWUP=CLDWUP+(PLA(JSTATE,0)*Q(0,JSTATE,1)
     *                             + P(0,JSTATE,0)*QLA(JSTATE,1))
     *                             * FER_FN(ISTATE)
C
                   END DO
C
C@@@@@@  HERE, DO THE FOLLOWING:
C@@@@@@   - ADD AN ADDITIONAL LOOP (ONLY ACTIVE WHEN ROTATION OF Q.P. IS
C@@@@@@     REQUESTED) SUMMING OVER PAIR INDICES I_PAIR
C@@@@@@	  - DEFINE ACTUAL TRUE PAIR INDICES ISTATE AND JSTATE FROM SOME
C@@@@@@     VECTOR TABLE ISTATE_1=MU_B(I_PAIR), ISTATE_2=NU_B(I_PAIR)
C@@@@@@     AND JSTATE_1=MU_A(I_PAIR), JSTATE_2=NU_A(I_PAIR). ISTATE
C@@@@@@     REFERS TO THE B BOGOLIUBOV MATRIX, JSTATE TO THE A MATRIX.
C@@@@@@	  - ADD TO DLUPUP, DLDWDW, DLUPDW, DLDWUP THE CONTRIBUTION FROM
C@@@@@@     THE PAIRS OF ROTATED Q.P.. SAME WITH CLUPUP, CLDWDW, CLUPDW,
C@@@@@@     CLDWUP, WHICH REPRESENT THE CONTRIBUTION FROM THE CONTINUUM
C@@@@@@
C@@@@@@   R E P E A T   T H I S   C O N S T R U C T   F O R   T H E
C@@@@@@   3   O T H E R   S P I N   B L O C K S   B E L O W
C
                   DLUPUP=DLUPUP/2
                   DLDWDW=DLDWDW/2
                   DLUPDW=DLUPDW/2
                   DLDWUP=DLDWUP/2
C
                   CLUPUP=CLUPUP/2
                   CLDWDW=CLDWDW/2
                   CLUPDW=CLUPDW/2
                   CLDWUP=CLDWUP/2
C
               END IF
C@@@ TEMP - TEMP - TEMP - TEMP - TEMP - TEMP - TEMP - TEMP - TEMP
C
C=======================================================================
C              P-H DENSITIES
C=======================================================================
C              SPIN UP-UP AND DOWN-DOWN P-H DENSITIES
C=======================================================================
C
C@@@ TEMP - TEMP - TEMP - TEMP - TEMP - TEMP - TEMP - TEMP - TEMP
               IF (IFTEMP.EQ.0) THEN
                   CALL ZGEMM('N','T',NDKART+1,NDKART+1,LUPPER,C_UNIT,
     *                        P(0,1,1),NDKART+2,Q(0,1,1),NDKART+2,
     *                        C_ZERO,DEUPUP(0,0), NDKART+2)
                   CALL ZGEMM('N','T',NDKART+1,NDKART+1,LUPPER,C_UNIT,
     *                        P(0,1,0),NDKART+2,Q(0,1,0),NDKART+2,
     *                        C_ZERO,DEDWDW(0,0), NDKART+2)
               ELSE
C
                   DO MU=0,NDKART
                      DO NU=0,MUSYME(MU)
C
                         DEUPUP(MU,NU)=C_ZERO
                         DEDWDW(MU,NU)=C_ZERO
C
                         DCUPUP(MU,NU)=C_ZERO
                         DCDWDW(MU,NU)=C_ZERO
C
                            JSTATE=LUPPER
                         DO ISTATE=1,LUPPER
                            JSTATE=JSTATE+1
C
                            DEUPUP(MU,NU)=DEUPUP(MU,NU)
     *                             +(P(MU,ISTATE,1)* Q(NU,ISTATE,1))
     *                                       * (1.D0-FER_FN(ISTATE))
     *                                             +(P(MU,JSTATE,1)
     *                                             * Q(NU,JSTATE,1))
     *                                             * FER_FN(ISTATE)
                            DEDWDW(MU,NU)=DEDWDW(MU,NU)
     *                             +(P(MU,ISTATE,0)* Q(NU,ISTATE,0))
     *                                        *(1.D0-FER_FN(ISTATE))
     *                                             + (P(MU,JSTATE,0)
     *                                             *  Q(NU,JSTATE,0))
     *                                             *  FER_FN(ISTATE)
C
C                            Contribution from the continuum
C
                            DCUPUP(MU,NU)=DCUPUP(MU,NU)
     *                                             +(P(MU,JSTATE,1)
     *                                             * Q(NU,JSTATE,1))
     *                                             * FER_FN(ISTATE)
                            DCDWDW(MU,NU)=DCDWDW(MU,NU)
     *                                             + (P(MU,JSTATE,0)
     *                                             *  Q(NU,JSTATE,0))
     *                                             *  FER_FN(ISTATE)
C
                         END DO
C
                         IF (IKERNE.NE.1) THEN
                             DEUPUP(NU,MU)=CONJG(DEUPUP(MU,NU))
                             DEDWDW(NU,MU)=CONJG(DEDWDW(MU,NU))
                             DCUPUP(NU,MU)=CONJG(DCUPUP(MU,NU))
                             DCDWDW(NU,MU)=CONJG(DCDWDW(MU,NU))
                         END IF
C
                      END DO
                   END DO

               END IF
C@@@ TEMP - TEMP - TEMP - TEMP - TEMP - TEMP - TEMP - TEMP - TEMP
C
C=======================================================================
C              SPIN UP-DOWN P-H DENSITIES
C=======================================================================
C
C@@@ TEMP - TEMP - TEMP - TEMP - TEMP - TEMP - TEMP - TEMP - TEMP
               IF (IFTEMP.EQ.0) THEN
C
                   CALL ZGEMM('N','T',NDKART+1,NDKART+1,LUPPER,C_UNIT,
     *                        P(0,1,1),NDKART+2,
     *                        Q(0,1,0),NDKART+2,
     *                        C_ZERO,DEUPDW(0,0),NDKART+2)
C
               ELSE
C
                   DO MU=0,NDKART
                      DO NU=0,NDKART
C
                         DEUPDW(MU,NU)=C_ZERO
                         DCUPDW(MU,NU)=C_ZERO
C
                            JSTATE=LUPPER
                         DO ISTATE=1,LUPPER
                            JSTATE=JSTATE+1
C
                            DEUPDW(MU,NU)=DEUPDW(MU,NU)
     *                             +(P(MU,ISTATE,1) * Q(NU,ISTATE,0))
     *                                      * (1.D0-FER_FN(ISTATE))
     *                                             + (P(MU,JSTATE,1)
     *                                             *  Q(NU,JSTATE,0))
     *                                             *FER_FN(ISTATE)
C
C                            Contribution from the continuum
C
                            DCUPDW(MU,NU)=DCUPDW(MU,NU)
     *                                             + (P(MU,JSTATE,1)
     *                                             *  Q(NU,JSTATE,0))
     *                                             *FER_FN(ISTATE)
C
                         END DO
C
                      END DO
                   END DO
C
               END IF
C@@@ TEMP - TEMP - TEMP - TEMP - TEMP - TEMP - TEMP - TEMP - TEMP
C
C=======================================================================
C              SPIN DOWN-UP P-H DENSITIES
C=======================================================================
C
C@@@ TEMP - TEMP - TEMP - TEMP - TEMP - TEMP - TEMP - TEMP - TEMP
               IF (IFTEMP.EQ.0) THEN
C
                   IF (IKERNE.EQ.1) THEN
C
                       CALL ZGEMM('N','T',NDKART+1,NDKART+1,LUPPER,
     *                            C_UNIT,P(0,1,0),NDKART+2,
     *                                   Q(0,1,1),NDKART+2,
     *                            C_ZERO,DEDWUP(0,0),NDKART+2)
C
                   ELSE
C
                       DO MU=0,NDKART
                         DO NU=0,NDKART
                            DEDWUP(MU,NU)=CONJG(DEUPDW(NU,MU))
                         END DO
                       END DO
C
                   END IF
C
               ELSE
C
                   DO MU=0,NDKART
                      DO NU=0,NDKART
C
                         DEDWUP(MU,NU)=C_ZERO
                         DCDWUP(MU,NU)=C_ZERO
C
                         IF (IKERNE.EQ.1) THEN
C
                                JSTATE=LUPPER
                             DO ISTATE=1,LUPPER
                                JSTATE=JSTATE+1
C
                                DEDWUP(MU,NU)=DEDWUP(MU,NU)
     *                                 +(P(MU,ISTATE,0)* Q(NU,ISTATE,1))
     *                                        * (1.0D0-FER_FN(ISTATE))
     *                                                + (P(MU,JSTATE,0)
     *                                                *  Q(NU,JSTATE,1))
     *                                                *FER_FN(ISTATE)
C
C                                Contribution from the continuum
C
                                DCDWUP(MU,NU)=DCDWUP(MU,NU)
     *                                                + (P(MU,JSTATE,0)
     *                                                *  Q(NU,JSTATE,1))
     *                                                *FER_FN(ISTATE)
C
                             END DO
C
                         ELSE
C
                             DEDWUP(MU,NU)=CONJG(DEUPDW(NU,MU))
                             DCDWUP(MU,NU)=CONJG(DCUPDW(NU,MU))
C
                         END IF
C
                      END DO
                   END DO
C
               END IF
C@@@ TEMP - TEMP - TEMP - TEMP - TEMP - TEMP - TEMP - TEMP - TEMP
C
C=======================================================================
C              CALCULATING   THE   SCALAR P-H DENSITIES
C=======================================================================
C
               DE_RHO(IX,IY,IZ,ITPNMX)=
     *         DE_RHO(IX,IY,IZ,ITPNMX)+DEUPUP(0,0)+DEDWDW(0,0)
C
               DE_TAU(IX,IY,IZ,ITPNMX)=
     *         DE_TAU(IX,IY,IZ,ITPNMX)+DEUPUP(1,1)+DEDWDW(1,1)
     *                                +DEUPUP(2,2)+DEDWDW(2,2)
     *                                +DEUPUP(3,3)+DEDWDW(3,3)
C
               DE_LPR(IX,IY,IZ,ITPNMX)=
     *         DE_LPR(IX,IY,IZ,ITPNMX)+2*(DLUPUP     +DLDWDW
     *                                   +DEUPUP(1,1)+DEDWDW(1,1)
     *                                   +DEUPUP(2,2)+DEDWDW(2,2)
     *                                   +DEUPUP(3,3)+DEDWDW(3,3))
C
               DE_DIV(IX,IY,IZ,ITPNMX)=
     *         DE_DIV(IX,IY,IZ,ITPNMX)+((DEUPDW(2,3)-DEUPDW(3,2))
     *                                 +(DEDWUP(2,3)-DEDWUP(3,2)))
     *                                              *UNIT_I
     *                                +((DEUPDW(3,1)-DEUPDW(1,3))
     *                                 -(DEDWUP(3,1)-DEDWUP(1,3)))*(-1)
     *                                +((DEUPUP(1,2)-DEUPUP(2,1))
     *                                 -(DEDWDW(1,2)-DEDWDW(2,1)))
     *                                              *UNIT_I
C
C=======================================================================
C              CALCULATING THE VECTOR P-H DENSITIES
C=======================================================================
C
               DE_SPI(IX,IY,IZ,1,ITPNMX)=
     *         DE_SPI(IX,IY,IZ,1,ITPNMX)+(DEUPDW(0,0)+DEDWUP(0,0))
C
               DE_SPI(IX,IY,IZ,2,ITPNMX)=
     *         DE_SPI(IX,IY,IZ,2,ITPNMX)+(DEUPDW(0,0)-DEDWUP(0,0))
     *                                               *UNIT_I
C
               DE_SPI(IX,IY,IZ,3,ITPNMX)=
     *         DE_SPI(IX,IY,IZ,3,ITPNMX)+(DEUPUP(0,0)-DEDWDW(0,0))
C
C=======================================================================
C
               DE_KIS(IX,IY,IZ,1,ITPNMX)=
     *         DE_KIS(IX,IY,IZ,1,ITPNMX)+(DEUPDW(1,1)+DEDWUP(1,1)
     *                                   +DEUPDW(2,2)+DEDWUP(2,2)
     *                                   +DEUPDW(3,3)+DEDWUP(3,3))
C
               DE_KIS(IX,IY,IZ,2,ITPNMX)=
     *         DE_KIS(IX,IY,IZ,2,ITPNMX)+(DEUPDW(1,1)-DEDWUP(1,1)
     *                                   +DEUPDW(2,2)-DEDWUP(2,2)
     *                                   +DEUPDW(3,3)-DEDWUP(3,3))
     *                                               *UNIT_I
C
               DE_KIS(IX,IY,IZ,3,ITPNMX)=
     *         DE_KIS(IX,IY,IZ,3,ITPNMX)+(DEUPUP(1,1)-DEDWDW(1,1)
     *                                   +DEUPUP(2,2)-DEDWDW(2,2)
     *                                   +DEUPUP(3,3)-DEDWDW(3,3))
C
C=======================================================================
C
               DE_LPS(IX,IY,IZ,1,ITPNMX)=
     *         DE_LPS(IX,IY,IZ,1,ITPNMX)+2*(DLUPDW     +DLDWUP
     *                                     +DEUPDW(1,1)+DEDWUP(1,1)
     *                                     +DEUPDW(2,2)+DEDWUP(2,2)
     *                                     +DEUPDW(3,3)+DEDWUP(3,3))
C
               DE_LPS(IX,IY,IZ,2,ITPNMX)=
     *         DE_LPS(IX,IY,IZ,2,ITPNMX)+2*(DLUPDW     -DLDWUP
     *                                     +DEUPDW(1,1)-DEDWUP(1,1)
     *                                     +DEUPDW(2,2)-DEDWUP(2,2)
     *                                     +DEUPDW(3,3)-DEDWUP(3,3))
     *                                                 *UNIT_I
C
               DE_LPS(IX,IY,IZ,3,ITPNMX)=
     *         DE_LPS(IX,IY,IZ,3,ITPNMX)+2*(DLUPUP     -DLDWDW
     *                                     +DEUPUP(1,1)-DEDWDW(1,1)
     *                                     +DEUPUP(2,2)-DEDWDW(2,2)
     *                                     +DEUPUP(3,3)-DEDWDW(3,3))
C
C=======================================================================
C
               DO K=1,NDKART
C
                  DE_GRR(IX,IY,IZ,K,ITPNMX)=
     *            DE_GRR(IX,IY,IZ,K,ITPNMX)+(DEUPUP(K,0)+DEUPUP(0,K)
     *                                      +DEDWDW(K,0)+DEDWDW(0,K))
C
                  DE_CUR(IX,IY,IZ,K,ITPNMX)=
     *            DE_CUR(IX,IY,IZ,K,ITPNMX)+(DEUPUP(K,0)-DEUPUP(0,K)
     *                                      +DEDWDW(K,0)-DEDWDW(0,K))
     *                                      /2/UNIT_I
C
                  DENAUX(K,1)=((DEUPDW(K,0)+DEUPDW(0,K))
     *                        +(DEDWUP(K,0)+DEDWUP(0,K)))
C
                  DENAUX(K,2)=((DEUPDW(K,0)+DEUPDW(0,K))
     *                        -(DEDWUP(K,0)+DEDWUP(0,K)))*UNIT_I
C
                  DENAUX(K,3)=((DEUPUP(K,0)+DEUPUP(0,K))
     *                        -(DEDWDW(K,0)+DEDWDW(0,K)))
C
               END DO
C
C=======================================================================
C
               DE_ROS(IX,IY,IZ,1,ITPNMX)=
     *         DE_ROS(IX,IY,IZ,1,ITPNMX)+DENAUX(2,3)-DENAUX(3,2)
C
               DE_ROS(IX,IY,IZ,2,ITPNMX)=
     *         DE_ROS(IX,IY,IZ,2,ITPNMX)+DENAUX(3,1)-DENAUX(1,3)
C
               DE_ROS(IX,IY,IZ,3,ITPNMX)=
     *         DE_ROS(IX,IY,IZ,3,ITPNMX)+DENAUX(1,2)-DENAUX(2,1)
C
C=======================================================================
C
               DE_ROC(IX,IY,IZ,1,ITPNMX)=
     *         DE_ROC(IX,IY,IZ,1,ITPNMX)+(DEUPUP(2,3)-DEUPUP(3,2)
     *                                   +DEDWDW(2,3)-DEDWDW(3,2))
     *                                               *UNIT_I
C
               DE_ROC(IX,IY,IZ,2,ITPNMX)=
     *         DE_ROC(IX,IY,IZ,2,ITPNMX)+(DEUPUP(3,1)-DEUPUP(1,3)
     *                                   +DEDWDW(3,1)-DEDWDW(1,3))
     *                                               *UNIT_I
C
               DE_ROC(IX,IY,IZ,3,ITPNMX)=
     *         DE_ROC(IX,IY,IZ,3,ITPNMX)+(DEUPUP(1,2)-DEUPUP(2,1)
     *                                   +DEDWDW(1,2)-DEDWDW(2,1))
     *                                               *UNIT_I
C
C=======================================================================
C              CALCULATING THE TENSOR P-H DENSITY
C=======================================================================
C
               DO K=1,NDKART
C
                  DE_SCU(IX,IY,IZ,K,1,ITPNMX)=
     *            DE_SCU(IX,IY,IZ,K,1,ITPNMX)
     *                  +((DEUPDW(K,0)-DEUPDW(0,K))
     *                  + (DEDWUP(K,0)-DEDWUP(0,K)))
     *                  /2/UNIT_I
C
                  DE_SCU(IX,IY,IZ,K,2,ITPNMX)=
     *            DE_SCU(IX,IY,IZ,K,2,ITPNMX)
     *                  +((DEUPDW(K,0)-DEUPDW(0,K))
     *                  - (DEDWUP(K,0)-DEDWUP(0,K)))
     *                  /2
C
                  DE_SCU(IX,IY,IZ,K,3,ITPNMX)=
     *            DE_SCU(IX,IY,IZ,K,3,ITPNMX)
     *                  +((DEUPUP(K,0)-DEUPUP(0,K))
     *                  - (DEDWDW(K,0)-DEDWDW(0,K)))
     *                  /2/UNIT_I
C
                  DO L=1,NDKART
                     DE_DES(IX,IY,IZ,K,L,ITPNMX)=
     *               DE_DES(IX,IY,IZ,K,L,ITPNMX)+DENAUX(K,L)
                  END DO
C
               END DO
C
C=======================================================================
C              SUMMING UP DENSITIES IN THE P-P CHANNEL
C=======================================================================
C
               IF (IPAHFB.EQ.1) THEN
C
                   LOFSET=0
                   LOFTRV=LTIMUP
                   LUPTRV=LSTATE
                   IF (LREVER.EQ.0) THEN
                       LOFSET=LTIMUP
                       LOFTRV=0
                   END IF
C
C=======================================================================
C              SPIN UP-UP, DOWN-DOWN, UP-DOWN, AND DOWN-UP P-P DENSITIES
C=======================================================================
C
C@@@ TEMP - TEMP - TEMP - TEMP - TEMP - TEMP - TEMP - TEMP - TEMP
                   IF (IFTEMP.EQ.0) THEN
C
C                      "Regular" pairing density, < L|aa|R >
C                      -------------------------------------------------
C
C                       Time-up contribution
                       CALL ZGEMM('N','T',NDKART+1,NDKART+1,
     *                                LSTATE-LUPPER,C_UNIT,
     *                                P(0,LOFSET+1,1),NDKART+2,
     *                                Q(0,LUPPER+1,1),NDKART+2,
     *                                C_ZERO,PAUPUP(0,0),NDKART+2)
                       CALL ZGEMM('N','T',NDKART+1,NDKART+1,
     *                                LSTATE-LUPPER,C_UNIT,
     *                                P(0,LOFSET+1,0),NDKART+2,
     *                                Q(0,LUPPER+1,0),NDKART+2,
     *                                C_ZERO,PADWDW(0,0),NDKART+2)
                       CALL ZGEMM('N','T',NDKART+1,NDKART+1,
     *                                LSTATE-LUPPER,C_UNIT,
     *                                P(0,LOFSET+1,1),NDKART+2,
     *                                Q(0,LUPPER+1,0),NDKART+2,
     *                                C_ZERO,PAUPDW(0,0),NDKART+2)
                       CALL ZGEMM('N','T',NDKART+1,NDKART+1,
     *                                LSTATE-LUPPER,C_UNIT,
     *                                P(0,LOFSET+1,0),NDKART+2,
     *                                Q(0,LUPPER+1,1),NDKART+2,
     *                                C_ZERO,PADWUP(0,0),NDKART+2)
C
C                       Time-down contribution
                       IF (IKERNE.EQ.1.OR.ISIMPY.EQ.0) THEN
                          CALL ZGEMM('N','T',NDKART+1,NDKART+1,
     *                               LTOTST-LSTATE,C_UNIT,
     *                               P(0,LOFTRV+1,1),NDKART+2,
     *                               Q(0,LUPTRV+1,1),NDKART+2,
     *                               C_UNIT,PAUPUP(0,0),NDKART+2)
                          CALL ZGEMM('N','T',NDKART+1,NDKART+1,
     *                               LTOTST-LSTATE,C_UNIT,
     *                               P(0,LOFTRV+1,0),NDKART+2,
     *                               Q(0,LUPTRV+1,0),NDKART+2,
     *                               C_UNIT,PADWDW(0,0),NDKART+2)
                          CALL  ZGEMM('N','T',NDKART+1,NDKART+1,
     *                               LTOTST-LSTATE,C_UNIT,
     *                               P(0,LOFTRV+1,1),NDKART+2,
     *                               Q(0,LUPTRV+1,0),NDKART+2,
     *                               C_UNIT,PAUPDW(0,0),NDKART+2)
                          CALL ZGEMM('N','T',NDKART+1,NDKART+1,
     *                               LTOTST-LSTATE,C_UNIT,
     *                               P(0,LOFTRV+1,0),NDKART+2,
     *                               Q(0,LUPTRV+1,1),NDKART+2,
     *                               C_UNIT,PADWUP(0,0),NDKART+2)
                       END IF
C
C                      "Conjugate" pairing density, < L|a+a+|R >
C                      -------------------------------------------------
C
                       IF (IKERNE.EQ.1.AND.MREVER.NE.1)
     *                      STOP
     *                      "IKERNE.EQ.1 WITH IPAHFB.EQ.1 REQUIRES\n
     *                       MREVER.EQ.1 IN DENSHF"
C
                       IF (IKERNE.EQ.1) THEN
C
C                          Time-up contribution
                          CALL ZGEMM('N','T',NDKART+1,NDKART+1,
     *                               LSTATE-LUPPER,C_UNIT,
     *                               P(0,LUPPER+1,1),NDKART+2,
     *                               Q(0,LOFSET+1,1),NDKART+2,
     *                               C_ZERO,PCUPUP(0,0),NDKART+2)
                          CALL ZGEMM('N','T',NDKART+1,NDKART+1,
     *                               LSTATE-LUPPER,C_UNIT,
     *                               P(0,LUPPER+1,0),NDKART+2,
     *                               Q(0,LOFSET+1,0),NDKART+2,
     *                               C_ZERO,PCDWDW(0,0),NDKART+2)
                          CALL ZGEMM('N','T',NDKART+1,NDKART+1,
     *                               LSTATE-LUPPER,C_UNIT,
     *                               P(0,LUPPER+1,1),NDKART+2,
     *                               Q(0,LOFSET+1,0),NDKART+2,
     *                               C_ZERO,PCUPDW(0,0),NDKART+2)
                          CALL ZGEMM('N','T',NDKART+1,NDKART+1,
     *                               LSTATE-LUPPER,C_UNIT,
     *                               P(0,LUPPER+1,0),NDKART+2,
     *                               Q(0,LOFSET+1,1),NDKART+2,
     *                               C_ZERO,PCDWUP(0,0),NDKART+2)
C
C                          Time-down contribution
                          CALL ZGEMM('N','T',NDKART+1,NDKART+1,
     *                               LTOTST-LSTATE,C_UNIT,
     *                               P(0,LUPTRV+1,1),NDKART+2,
     *                               Q(0,LOFTRV+1,1),NDKART+2,
     *                               C_UNIT,PCUPUP(0,0),NDKART+2)
                          CALL ZGEMM('N','T',NDKART+1,NDKART+1,
     *                               LTOTST-LSTATE,C_UNIT,
     *                               P(0,LUPTRV+1,0),NDKART+2,
     *                               Q(0,LOFTRV+1,0),NDKART+2,
     *                               C_UNIT,PCDWDW(0,0),NDKART+2)
                          CALL ZGEMM('N','T',NDKART+1,NDKART+1,
     *                               LTOTST-LSTATE,C_UNIT,
     *                               P(0,LUPTRV+1,1),NDKART+2,
     *                               Q(0,LOFTRV+1,0),NDKART+2,
     *                               C_UNIT,PCUPDW(0,0),NDKART+2)
                          CALL ZGEMM('N','T',NDKART+1,NDKART+1,
     *                               LTOTST-LSTATE,C_UNIT,
     *                               P(0,LUPTRV+1,0),NDKART+2,
     *                               Q(0,LOFTRV+1,1),NDKART+2,
     *                               C_UNIT,PCDWUP(0,0),NDKART+2)
C
                       ELSE
C
                          PCUPUP(:,:)=CONJG(PAUPUP(:,:))
                          PCDWDW(:,:)=CONJG(PADWDW(:,:))
                          PCUPDW(:,:)=CONJG(PAUPDW(:,:))
                          PCDWUP(:,:)=CONJG(PADWUP(:,:))
C
                       END IF
C
                   ELSE          ! (IFTEMP.EQ.0)
C
                       DO MU=0,NDKART
                          DO NU=0,NDKART
C
                             PAUPUP(MU,NU)=C_ZERO
                             PADWDW(MU,NU)=C_ZERO
                             PAUPDW(MU,NU)=C_ZERO
                             PADWUP(MU,NU)=C_ZERO
C
                             DO ISTATE=LUPPER+1,LTOTST
C
                                JSTATE=ISTATE-LUPPER+LOFSET
C
                                PAUPUP(MU,NU)=PAUPUP(MU,NU)
     *                             +(P(MU,JSTATE,1)*Q(NU,ISTATE,1))
     *                               *(1.D0-2.0D0*FER_FN(JSTATE))
                                PADWDW(MU,NU)=PADWDW(MU,NU)
     *                             +(P(MU,JSTATE,0)*Q(NU,ISTATE,0))
     *                               *(1.D0-2.0D0*FER_FN(JSTATE))
                                PAUPDW(MU,NU)=PAUPDW(MU,NU)
     *                             +(P(MU,JSTATE,1)*Q(NU,ISTATE,0))
     *                               *(1.D0-2.0D0*FER_FN(JSTATE))
                                PADWUP(MU,NU)=PADWUP(MU,NU)
     *                             +(P(MU,JSTATE,0)*Q(NU,ISTATE,1))
     *                               *(1.D0-2.0D0*FER_FN(JSTATE))
C
                            END DO
C
                          END DO
                       END DO
C
                       PCUPUP(:,:)=CONJG(PAUPUP(:,:))
                       PCDWDW(:,:)=CONJG(PADWDW(:,:))
                       PCUPDW(:,:)=CONJG(PAUPDW(:,:))
                       PCDWUP(:,:)=CONJG(PADWUP(:,:))
C
                   END IF        ! (IFTEMP.EQ.0)
C
C@@@ TEMP - TEMP - TEMP - TEMP - TEMP - TEMP - TEMP - TEMP - TEMP
C
C=======================================================================
C                   CALCULATING   THE   SCALAR P-P DENSITIES
C=======================================================================
C                   FOR THE  CONSERVED SIMPLEX (ISIMPY = 1) ONLY HALF OF
C                   THE QUASIPARTICLES CONTRIBUTE TO  THE P-P DENSITIES,
C                   AND THEREFORE THE DENSITIES BELOW ARE THEN MULTIPLED
C                   BY 2.
C=======================================================================
C                   FOR THE PAIRING  FUNCTIONAL RESTRICTED TO  TIME-EVEN
C                   TERMS, ONLY THE REAL PART OF THE PAIRING DENSITY  IS
C                   KEPT.
C=======================================================================
C
C                 Multiply by two except if kernel calculation,
C                 in which cases we used the whole
C                 basis to calculate the pair densities
                                                  SIMFAC=2.0d0
                  IF (IKERNE.EQ.1.OR.ISIMPY.EQ.0) SIMFAC=1.0d0
C
                  IF (MREVER.EQ.1) THEN
C                    MREVER==1 for broken T or kernel
                     PD_RHO(IX,IY,IZ,ITPNMX)=
     *                    PD_RHO(IX,IY,IZ,ITPNMX)
     *                    +SIMFAC*(PAUPUP(0,0)+PADWDW(0,0))
                     PP_RHO(IX,IY,IZ,ITPNMX)=
     *                    PP_RHO(IX,IY,IZ,ITPNMX)
     *                    +SIMFAC*(PCUPUP(0,0)+PCDWDW(0,0))
C
                  ELSE
C                    MREVER==0 otherwise, pair density is then real
                     PD_RHO(IX,IY,IZ,ITPNMX)=
     *                    PD_RHO(IX,IY,IZ,ITPNMX)+SIMFAC
     *                    *REAL(PAUPUP(0,0)+PADWDW(0,0))
                     PP_RHO(IX,IY,IZ,ITPNMX)=
     *                    PP_RHO(IX,IY,IZ,ITPNMX)+SIMFAC
     *                    *REAL(PCUPUP(0,0)+PCDWDW(0,0))
C
                  END IF
C
C=======================================================================
C              HERE ENDS THE PART EXECUTED ONLY FOR IPAHFB=1
C=======================================================================
C
               END IF
C
C=======================================================================
C              ENDING THE DO-LOOPS OVER THE CARTESIAN POINTS
C=======================================================================
C
            END DO ! END OF LOOP OVER IX
         END DO ! END OF LOOP OVER IY
!$OMP END DO
!$OMP END PARALLEL
      END DO ! END OF LOOP OVER IZ
C
      DEALLOCATE(HRIGHE,HRIGDH,HRIGDD,STAT=I_FAIL)
      IF (I_FAIL.NE.0) THEN
          WRITE(6,'("Error in DEALLOCATING arrays - DENSHF")')
          STOP 'Error in DEALLOCATION'
      END IF
      IF (IKERNE.EQ.1) THEN
      	  DEALLOCATE(HLEFHE,HLEFDH,HLEFDD,STAT=I_FAIL)
          IF (I_FAIL.NE.0) THEN
              WRITE(6,'("Error in DEALLOCATING arrays - DENSHF")')
              STOP 'Error in DEALLOCATION'
          END IF
      END IF
C
C=======================================================================
C         ATTENTION: IN THE VERSIONS  BETWEEN  2.22N  AND  2.37T,  ARRAY
C                    "WARIGH" WAS NOT BELOW MULTIPLIED BY THE OCCUPATION
C                    PROBABILITIES. AS  A  RESULT,  THE  DENSITY  MATRIX
C                    CALCULATED BY "DENMAC" WAS INCORRECT FOR  IDEVAR=1.
C                    THIS BUG HAS BEEN CORRECTED  IN  VERSION  2.37U  ON
C                    13/12/08.
C         ATTENTION: IN THE VERSIONS 2.49L AND X.XXx, ARRAY "WARIGH" WAS
C                    INCORRECTLY MULTIPLIED BY THE OCCUPATION PROBABILI-
C                    TIES AT FINITE-TEMPERATURE.
C=======================================================================
C
      IF (IDEVAR.EQ.1.AND.IPAHFB.NE.1) THEN
C
C@@@ TEMP - TEMP - TEMP - TEMP - TEMP - TEMP - TEMP - TEMP - TEMP
          IF (IFTEMP.EQ.0) THEN
C
              DO ISPIN=0,NDSPIN
                 DO ISTATE=1,LSTATE
                    DO IBASE=1,LDBASE
C
                       WARIGH(IBASE,ISTATE,ISPIN)=
     *                 WARIGH(IBASE,ISTATE,ISPIN)*V1OCCU(ISTATE)
C
                    END DO
                 END DO
              END DO
C
          ELSE
C
                 JSTATE=LUPPER
              DO ISTATE=1,LUPPER
                 JSTATE=JSTATE+1
C
                 U1_OCC=SQRT(1.0D0-V1OCCU(ISTATE)**2)
C
                 DO IBASE=1,LDBASE
                    DO ISPIN=0,NDSPIN
C
                       WARIGH(IBASE,JSTATE,ISPIN)=
     *                 WARIGH(IBASE,JSTATE,ISPIN)*U1_OCC
C
                    END DO
                 END DO
C
              END DO
C
              LDSTAT(ICHARG)=LSTATE/2
              LDUPPE(ICHARG)=LUPPER
c              LDTIMU(ICHARG)=LTIMUP/2
C
          END IF ! end if IFTEMP
C@@@ TEMP - TEMP - TEMP - TEMP - TEMP - TEMP - TEMP - TEMP - TEMP
C
      END IF ! end if IDEVAR
C
C=======================================================================
C         TESTING FOR THE PRESENCE OF ANY OF THE THREE PLANE SYMMETRIES.
C         SYMDEN AND SYMPAI CAN BE CALLED ONLY WHEN THE CALCULATIONS FOR
C         THE WHOLE BOX ARE PERFORMED.  THIS CAN BE DONE BY SETTING  THE
C         PARAMETER ISYMDE=1 IN THE INPUT DATA.
C=======================================================================
C
#if(SWITCH_PORT==1)
C
      DENALL(1:NDXHRM,1:NDYHRM,1:NDZHRM,1)
     *        =DE_RHO(1:NDXHRM,1:NDYHRM,1:NDZHRM,ITPNMX)
      DENALL(1:NDXHRM,1:NDYHRM,1:NDZHRM,2)
     *        =DE_TAU(1:NDXHRM,1:NDYHRM,1:NDZHRM,ITPNMX)
      DENALL(1:NDXHRM,1:NDYHRM,1:NDZHRM,3)
     *        =DE_LPR(1:NDXHRM,1:NDYHRM,1:NDZHRM,ITPNMX)
      DENALL(1:NDXHRM,1:NDYHRM,1:NDZHRM,4)
     *        =DE_DIV(1:NDXHRM,1:NDYHRM,1:NDZHRM,ITPNMX)
C
      DENALL(1:NDXHRM,1:NDYHRM,1:NDZHRM, 4          +1: 4+  NDKART)
     *        =DE_SPI(1:NDXHRM,1:NDYHRM,1:NDZHRM,1:NDKART,ITPNMX)
      DENALL(1:NDXHRM,1:NDYHRM,1:NDZHRM,(4+  NDKART)+1:(4+2*NDKART))
     *        =DE_KIS(1:NDXHRM,1:NDYHRM,1:NDZHRM,1:NDKART,ITPNMX)
      DENALL(1:NDXHRM,1:NDYHRM,1:NDZHRM,(4+2*NDKART)+1:(4+3*NDKART))
     *        =DE_GRR(1:NDXHRM,1:NDYHRM,1:NDZHRM,1:NDKART,ITPNMX)
      DENALL(1:NDXHRM,1:NDYHRM,1:NDZHRM,(4+3*NDKART)+1:(4+4*NDKART))
     *        =DE_LPS(1:NDXHRM,1:NDYHRM,1:NDZHRM,1:NDKART,ITPNMX)
      DENALL(1:NDXHRM,1:NDYHRM,1:NDZHRM,(4+4*NDKART)+1:(4+5*NDKART))
     *        =DE_ROS(1:NDXHRM,1:NDYHRM,1:NDZHRM,1:NDKART,ITPNMX)
      DENALL(1:NDXHRM,1:NDYHRM,1:NDZHRM,(4+5*NDKART)+1:(4+6*NDKART))
     *        =DE_ROC(1:NDXHRM,1:NDYHRM,1:NDZHRM,1:NDKART,ITPNMX)
      DENALL(1:NDXHRM,1:NDYHRM,1:NDZHRM,(4+6*NDKART)+1:(4+7*NDKART))
     *        =DE_CUR(1:NDXHRM,1:NDYHRM,1:NDZHRM,1:NDKART,ITPNMX)
C
      DENALL(1:NDXHRM,1:NDYHRM,1:NDZHRM,(4+ 7*NDKART)+1:(4+ 8*NDKART))
     *        =DE_SCU(1:NDXHRM,1:NDYHRM,1:NDZHRM,1:NDKART,1,ITPNMX)
      DENALL(1:NDXHRM,1:NDYHRM,1:NDZHRM,(4+ 8*NDKART)+1:(4+ 9*NDKART))
     *        =DE_SCU(1:NDXHRM,1:NDYHRM,1:NDZHRM,1:NDKART,2,ITPNMX)
      DENALL(1:NDXHRM,1:NDYHRM,1:NDZHRM,(4+ 9*NDKART)+1:(4+10*NDKART))
     *        =DE_SCU(1:NDXHRM,1:NDYHRM,1:NDZHRM,1:NDKART,3,ITPNMX)
      DENALL(1:NDXHRM,1:NDYHRM,1:NDZHRM,(4+10*NDKART)+1:(4+11*NDKART))
     *        =DE_DES(1:NDXHRM,1:NDYHRM,1:NDZHRM,1:NDKART,1,ITPNMX)
      DENALL(1:NDXHRM,1:NDYHRM,1:NDZHRM,(4+11*NDKART)+1:(4+12*NDKART))
     *        =DE_DES(1:NDXHRM,1:NDYHRM,1:NDZHRM,1:NDKART,2,ITPNMX)
      DENALL(1:NDXHRM,1:NDYHRM,1:NDZHRM,(4+12*NDKART)+1:(4+13*NDKART))
     *        =DE_DES(1:NDXHRM,1:NDYHRM,1:NDZHRM,1:NDKART,3,ITPNMX)
C
#endif
C
      IF (PRINIT.AND.ISYMDE.EQ.1) THEN
C
#if(SWITCH_PORT==1)
          CALL SYMDEN(DENALL,NXHERM,NYHERM,NZHERM,NAMEPN)
#else
          CALL SYMDEN(DENRHO,NXHERM,NYHERM,NZHERM,NAMEPN)
#endif
C
          IF (IPAHFB.EQ.1)
     *
     *        CALL SYMPAI(ITPNMX,NXHERM,NYHERM,NZHERM)
C
      END IF
C
C=======================================================================
C         THE UNCALCULATED PARTS OF THE BOX ARE HERE COPIED FROM THE
C         CALCULATED PARTS.  THIS IS DONE ACCORDING TO THE TABLES OF
C         SYMMETRIES DEFINED EXPLICITLY IN COPDEN AND COPPAI.
C=======================================================================
C
      IF (DOSYME) THEN
C
#if(SWITCH_PORT==1)
          CALL COPDEN(DENALL,NXHERM,NYHERM,NZHERM,
     *                ISIGNY,ISIMPY,ISIQTY,ISIMTX,JSIMTY,ISIMTZ)
#else
          CALL COPDEN(DENRHO,NXHERM,NYHERM,NZHERM,
     *                ISIGNY,ISIMPY,ISIQTY,ISIMTX,JSIMTY,ISIMTZ)
#endif
C
          IF (IPAHFB.EQ.1)
     *
     *        CALL COPPAI(ITPNMX,NXHERM,NYHERM,NZHERM,IKERNE,
     *                    ISIGNY,ISIMPY,ISIQTY,ISIMTX,JSIMTY,ISIMTZ)
C
#if(SWITCH_PORT==1)
C
          DE_RHO(1:NDXHRM,1:NDYHRM,1:NDZHRM,ITPNMX)
     *            =DENALL(1:NDXHRM,1:NDYHRM,1:NDZHRM,1)
          DE_TAU(1:NDXHRM,1:NDYHRM,1:NDZHRM,ITPNMX)
     *            =DENALL(1:NDXHRM,1:NDYHRM,1:NDZHRM,2)
          DE_LPR(1:NDXHRM,1:NDYHRM,1:NDZHRM,ITPNMX)
     *            =DENALL(1:NDXHRM,1:NDYHRM,1:NDZHRM,3)
          DE_DIV(1:NDXHRM,1:NDYHRM,1:NDZHRM,ITPNMX)
     *            =DENALL(1:NDXHRM,1:NDYHRM,1:NDZHRM,4)
C
          DE_SPI(1:NDXHRM,1:NDYHRM,1:NDZHRM,1:NDKART,ITPNMX)
     *            =DENALL(1:NDXHRM,1:NDYHRM,1:NDZHRM,
     *                      4          +1:4+  NDKART)
          DE_KIS(1:NDXHRM,1:NDYHRM,1:NDZHRM,1:NDKART,ITPNMX)
     *            =DENALL(1:NDXHRM,1:NDYHRM,1:NDZHRM,
     *                    (4+  NDKART)+1:(4+2*NDKART))
          DE_GRR(1:NDXHRM,1:NDYHRM,1:NDZHRM,1:NDKART,ITPNMX)
     *            =DENALL(1:NDXHRM,1:NDYHRM,1:NDZHRM,
     *                    (4+2*NDKART)+1:(4+3*NDKART))
          DE_LPS(1:NDXHRM,1:NDYHRM,1:NDZHRM,1:NDKART,ITPNMX)
     *            =DENALL(1:NDXHRM,1:NDYHRM,1:NDZHRM,
     *                    (4+3*NDKART)+1:(4+4*NDKART))
          DE_ROS(1:NDXHRM,1:NDYHRM,1:NDZHRM,1:NDKART,ITPNMX)
     *            =DENALL(1:NDXHRM,1:NDYHRM,1:NDZHRM,
     *                    (4+4*NDKART)+1:(4+5*NDKART))
          DE_ROC(1:NDXHRM,1:NDYHRM,1:NDZHRM,1:NDKART,ITPNMX)
     *            =DENALL(1:NDXHRM,1:NDYHRM,1:NDZHRM,
     *                    (4+5*NDKART)+1:(4+6*NDKART))
          DE_CUR(1:NDXHRM,1:NDYHRM,1:NDZHRM,1:NDKART,ITPNMX)
     *            =DENALL(1:NDXHRM,1:NDYHRM,1:NDZHRM,
     *                    (4+6*NDKART)+1:(4+7*NDKART))
C
          DE_SCU(1:NDXHRM,1:NDYHRM,1:NDZHRM,1:NDKART,1,ITPNMX)
     *            =DENALL(1:NDXHRM,1:NDYHRM,1:NDZHRM,
     *                    (4+ 7*NDKART)+1:(4+ 8*NDKART))
          DE_SCU(1:NDXHRM,1:NDYHRM,1:NDZHRM,1:NDKART,2,ITPNMX)
     *            =DENALL(1:NDXHRM,1:NDYHRM,1:NDZHRM,
     *                    (4+ 8*NDKART)+1:(4+ 9*NDKART))
          DE_SCU(1:NDXHRM,1:NDYHRM,1:NDZHRM,1:NDKART,3,ITPNMX)
     *            =DENALL(1:NDXHRM,1:NDYHRM,1:NDZHRM,
     *                    (4+ 9*NDKART)+1:(4+10*NDKART))
          DE_DES(1:NDXHRM,1:NDYHRM,1:NDZHRM,1:NDKART,1,ITPNMX)
     *            =DENALL(1:NDXHRM,1:NDYHRM,1:NDZHRM,
     *                    (4+10*NDKART)+1:(4+11*NDKART))
          DE_DES(1:NDXHRM,1:NDYHRM,1:NDZHRM,1:NDKART,2,ITPNMX)
     *            =DENALL(1:NDXHRM,1:NDYHRM,1:NDZHRM,
     *                    (4+11*NDKART)+1:(4+12*NDKART))
          DE_DES(1:NDXHRM,1:NDYHRM,1:NDZHRM,1:NDKART,3,ITPNMX)
     *            =DENALL(1:NDXHRM,1:NDYHRM,1:NDZHRM,
     *                    (4+12*NDKART)+1:(4+13*NDKART))
C
#endif
C
      END IF
C
C=======================================================================
C
      CALL CPUTIM('DENSHF',0)
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE COPDEN(DENALL,NXHERM,NYHERM,NZHERM,
     *                  ISIGNY,ISIMPY,ISIQTY,ISIMTX,JSIMTY,ISIMTZ)
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      COMPLEX
     *          DENALL(NDXHRM,NDYHRM,NDZHRM,NDALLD)
      DIMENSION
     *          ISYDEN(NDKART,NDTYDE,       NDALLD)
C
      DATA (((ISYDEN(KARTEZ,ITYDEN,NUMDEN),KARTEZ=1,NDKART),
     *                                     ITYDEN=1,NDTYDE),
     *                                     NUMDEN=1,NDALLD)
     *
     *                            /  1,  1,  1,    1,  1,  1,
     *                               1,  1,  1,    1,  1,  1,
     *                               1,  1,  1,    1,  1,  1,
     *                               1,  1,  1,    1,  1,  1,
     *                              -1, -1,  1,    1,  1, -1,
     *                               1,  1,  1,   -1, -1, -1,
     *                               1, -1, -1,   -1,  1,  1,
     *                              -1, -1,  1,    1,  1, -1,
     *                               1,  1,  1,   -1, -1, -1,
     *                               1, -1, -1,   -1,  1,  1,
     *                              -1,  1,  1,   -1,  1,  1,
     *                               1, -1,  1,    1, -1,  1,
     *                               1,  1, -1,    1,  1, -1,
     *                              -1, -1,  1,    1,  1, -1,
     *                               1,  1,  1,   -1, -1, -1,
     *                               1, -1, -1,   -1,  1,  1,
     *                               1,  1, -1,   -1, -1,  1,
     *                              -1, -1, -1,    1,  1,  1,
     *                              -1,  1,  1,    1, -1, -1,
     *                              -1, -1,  1,    1,  1, -1,
     *                               1,  1,  1,   -1, -1, -1,
     *                               1, -1, -1,   -1,  1,  1,
     *                               1,  1, -1,   -1, -1,  1,
     *                              -1, -1, -1,    1,  1,  1,
     *                              -1,  1,  1,    1, -1, -1,
     *                              -1, -1, -1,   -1, -1, -1,
     *                               1,  1, -1,    1,  1, -1,
     *                               1, -1,  1,    1, -1,  1,
     *                               1,  1, -1,    1,  1, -1,
     *                              -1, -1, -1,   -1, -1, -1,
     *                              -1,  1,  1,   -1,  1,  1,
     *                               1, -1,  1,    1, -1,  1,
     *                              -1,  1,  1,   -1,  1,  1,
     *                              -1, -1, -1,   -1, -1, -1,
     *                               1, -1,  1,   -1,  1, -1,
     *                              -1,  1,  1,    1, -1, -1,
     *                              -1, -1, -1,    1,  1,  1,
     *                              -1,  1,  1,    1, -1, -1,
     *                               1, -1,  1,   -1,  1, -1,
     *                               1,  1, -1,   -1, -1,  1,
     *                              -1, -1, -1,    1,  1,  1,
     *                               1,  1, -1,   -1, -1,  1,
     *                               1, -1,  1,   -1,  1, -1  /
C
C=======================================================================
C        THIS SUBROUTINE COPIES THE DENSITIES CALCULATED  IN  DENSHF
C        IN PARTS OF THE BOX INTO THE UNCALCULATED PARTS OF THE BOX,
C        ACCORDING TO THE TABLE OF SYMMETRIES DEFINED ABOVE  IN  THE
C        "ISYDEN" ARRAY.
C
C        ATTENTION: THE FIRST DUMMY ARGUMENT IS USED FOR ALL DENSITIES
C=======================================================================
C
      IF (ISIMTX.EQ.1) THEN
C
          ITYDEN=1
C
C=======================================================================
C         SYMMETRY IN THE X-DIRECTION
C
C         ATTENTION: IN THE PREVIOUS VERSIONS OF THE CODE, STARTING FROM
C                    VERSION 1.82N AND UP TO VERSION 1.98G  THE  COMMAND
C                    "IHABOY=2" BELOW WAS INCORRECTLY CODED  AS  COMMAND
C                    "IHABOZ=2". AS A RESULT, THE CODE  WAS NOT  WORKING
C                    PROPERLY WHENEVER, AND  O N L Y WHEN, THE REQUESTED
C                    SYMMETRIES WHERE  ISIMTX=1 AND ISIMTZ=0.  THIS  BUG
C                    WAS CORRECTED IN VERSION 1.98H (18/06/02).
C
C=======================================================================
C
                           IHABOZ=1
          IF (ISIMTZ.EQ.1) IHABOZ=2
          IF (ISIGNY.EQ.1) IHABOZ=2
          IF (ISIQTY.EQ.1) IHABOZ=2
C
                           IHABOY=1
          IF (ISIMPY.EQ.1) IHABOY=2
          IF (JSIMTY.EQ.1) IHABOY=2
C
                           IHABOX=2
C
          DO IZ=1,NZHERM/IHABOZ
             DO IY=1,NYHERM/IHABOY
                DO IX=1,NXHERM/IHABOX
C
                   IXREFL=NXHERM+1-IX
C
                   DO NUMDEN=1,NDALLD
C
                     DENALL(IXREFL,IY,IZ,NUMDEN)=ISYDEN(1,ITYDEN,NUMDEN)
     *                                          *DENALL(IX,IY,IZ,NUMDEN)
C
                   END DO
C
                END DO
             END DO
          END DO
C
      END IF
C
C=======================================================================
C
      IF (ISIMPY.EQ.1.OR.JSIMTY.EQ.1) THEN
C
          IF (JSIMTY.EQ.1) ITYDEN=2
          IF (ISIMPY.EQ.1) ITYDEN=1
C
C=======================================================================
C         SYMMETRY IN THE Y-DIRECTION
C=======================================================================
C
                           IHABOZ=1
          IF (ISIMTZ.EQ.1) IHABOZ=2
          IF (ISIGNY.EQ.1) IHABOZ=2
          IF (ISIQTY.EQ.1) IHABOZ=2
C
                           IHABOY=2
C
                           IHABOX=1
C
          DO IX=1,NXHERM/IHABOX
             DO IZ=1,NZHERM/IHABOZ
                DO IY=1,NYHERM/IHABOY
C
                   IYREFL=NYHERM+1-IY
C
                   DO NUMDEN=1,NDALLD
C
                     DENALL(IX,IYREFL,IZ,NUMDEN)=ISYDEN(2,ITYDEN,NUMDEN)
     *                                          *DENALL(IX,IY,IZ,NUMDEN)
C
                   END DO
C
                END DO
             END DO
          END DO
C
      END IF
C
C=======================================================================
C
      IF (ISIMTZ.EQ.1) THEN
C
          ITYDEN=1
C
C=======================================================================
C         SYMMETRY IN THE Z-DIRECTION
C=======================================================================
C
          IHABOZ=2
C
          IHABOY=1
C
          IHABOX=1
C
          DO IX=1,NXHERM/IHABOX
             DO IY=1,NYHERM/IHABOY
                DO IZ=1,NZHERM/IHABOZ
C
                   IZREFL=NZHERM+1-IZ
C
                   DO NUMDEN=1,NDALLD
C
                     DENALL(IX,IY,IZREFL,NUMDEN)=ISYDEN(3,ITYDEN,NUMDEN)
     *                                          *DENALL(IX,IY,IZ,NUMDEN)
C
                   END DO
C
                END DO
             END DO
          END DO
C
      END IF
C
C=======================================================================
C
      IF (ISIGNY.EQ.1) THEN
C
          ITYDEN=1
C
C=======================================================================
C         SYMMETRIZATION WITH RESPECT TO THE Y-SIGNATURE
C=======================================================================
C
          IHABOZ=2
C
          IHABOY=1
C
          IHABOX=1
C
          DO IY=1,NYHERM/IHABOY
             DO IX=1,NXHERM/IHABOX
                DO IZ=1,NZHERM/IHABOZ
C
                   IXREFL=NXHERM+1-IX
                   IZREFL=NZHERM+1-IZ
C
                   DO NUMDEN=1,NDALLD
C
                     DENALL(IXREFL,IY,IZREFL,NUMDEN)
     *                                          =ISYDEN(1,ITYDEN,NUMDEN)
     *                                          *ISYDEN(3,ITYDEN,NUMDEN)
     *                                          *DENALL(IX,IY,IZ,NUMDEN)
C
                   END DO
C
                END DO
             END DO
          END DO
C
      END IF
C
C=======================================================================
C
      IF (ISIQTY.EQ.1) THEN
C
          ITYDEN=1
C
C=======================================================================
C         SYMMETRIZATION WITH RESPECT TO THE PARITY
C=======================================================================
C
          IHABOZ=2
C
          IHABOY=1
C
          IHABOX=1
C
          DO IY=1,NYHERM/IHABOY
             DO IX=1,NXHERM/IHABOX
                DO IZ=1,NZHERM/IHABOZ
C
                   IXREFL=NXHERM+1-IX
                   IYREFL=NYHERM+1-IY
                   IZREFL=NZHERM+1-IZ
C
                   DO NUMDEN=1,NDALLD
C
                     DENALL(IXREFL,IYREFL,IZREFL,NUMDEN)
     *                                          =ISYDEN(1,ITYDEN,NUMDEN)
     *                                          *ISYDEN(2,ITYDEN,NUMDEN)
     *                                          *ISYDEN(3,ITYDEN,NUMDEN)
     *                                          *DENALL(IX,IY,IZ,NUMDEN)
C
                   END DO
C
                END DO
             END DO
          END DO
C
      END IF
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE COPPAI(ITPNMX,NXHERM,NYHERM,NZHERM,IKERNE,
     *                  ISIGNY,ISIMPY,ISIQTY,ISIMTX,JSIMTY,ISIMTZ)
C=======================================================================
      USE PD_DEN
C=======================================================================
      USE hfodd_sizes
C=======================================================================
C
      DIMENSION
     *          ISYPAI(NDKART)
C
      DATA (ISYPAI(KARTEZ),KARTEZ=1,NDKART)
     *
     *                            /  1,  1,  1  /
C
C=======================================================================
C        THIS SUBROUTINE COPIES THE DENSITIES CALCULATED  IN  DENSHF
C        IN PARTS OF THE BOX INTO THE UNCALCULATED PARTS OF THE BOX,
C        ACCORDING TO THE TABLE OF SYMMETRIES DEFINED ABOVE  IN  THE
C        "ISYPAI" ARRAY.
C
C        ATTENTION: THE FIRST DUMMY ARGUMENT IS USED FOR ALL DENSITIES
C
C        ATTENTION:  THIS SUBROUTINE IS NOT READY FOR  SWITCHING  THE
C                    CALCULATION OF THESE OTHER DENSITIES ON.
C
C        ATTENTION:  UP TO VERSION 2.00E THE IMAGINARY PARTS  OF  THE
C                    PAIRING DENSITIES WERE COPPIED  WITH  THE  WRONG
C                    SIGNS (X- AND Z-DIRECTIONS ONLY). THIS  BUG  WAS
C                    CORRECTED ON  12/07/2002  IN VERSION 2.00F.
C        ATTENTION:  THE ABOVE STILL REMAINS TO BE CHECKED (12/07/2002).
C=======================================================================
C
C      ICONJG determines whether the imaginary part is flipped on
C      copy/symmetrization
                       ICONJG = 1
      IF (IKERNE.EQ.1) ICONJG = 0
C
      IF (ISIMTX.EQ.1) THEN
C
C=======================================================================
C         SYMMETRY IN THE X-DIRECTION
C=======================================================================
C
                           IHABOZ=1
          IF (ISIMTZ.EQ.1) IHABOZ=2
          IF (ISIGNY.EQ.1) IHABOZ=2
          IF (ISIQTY.EQ.1) IHABOZ=2
C
                           IHABOY=1
          IF (ISIMPY.EQ.1) IHABOY=2
          IF (JSIMTY.EQ.1) IHABOY=2
C
                           IHABOX=2
C
          DO IZ=1,NZHERM/IHABOZ
             DO IY=1,NYHERM/IHABOY
                DO IX=1,NXHERM/IHABOX
C
                   IXREFL=NXHERM+1-IX
C
                   PD_RHO(IXREFL,IY,IZ,ITPNMX)
     *               =ISYPAI(1)
     *                *((1-ICONJG)*PD_RHO(IX,IY,IZ,ITPNMX)
     *                  +ICONJG*CONJG(PD_RHO(IX,IY,IZ,ITPNMX)))
C
                   PP_RHO(IXREFL,IY,IZ,ITPNMX)
     *               =ISYPAI(1)
     *                *((1-ICONJG)*PP_RHO(IX,IY,IZ,ITPNMX)
     *                  +ICONJG*CONJG(PP_RHO(IX,IY,IZ,ITPNMX)))
C
                END DO
             END DO
          END DO
C
      END IF
C
      IF (ISIMPY.EQ.1.OR.JSIMTY.EQ.1) THEN
C
C=======================================================================
C        SYMMETRY IN THE Y-DIRECTION
C=======================================================================
C
                           IHABOZ=1
          IF (ISIMTZ.EQ.1) IHABOZ=2
          IF (ISIGNY.EQ.1) IHABOZ=2
          IF (ISIQTY.EQ.1) IHABOZ=2
C
                           IHABOY=2
C
                           IHABOX=1
C
          DO IZ=1,NZHERM/IHABOZ
             DO IY=1,NYHERM/IHABOY
                DO IX=1,NXHERM/IHABOX
C
                   IYREFL=NYHERM+1-IY
C
                   IF (JSIMTY.EQ.1) THEN
                       PD_RHO(IX,IYREFL,IZ,ITPNMX)
     *                        =ISYPAI(2)
     *                        *((1-ICONJG)*PD_RHO(IX,IY,IZ,ITPNMX)
     *                          +ICONJG*CONJG(PD_RHO(IX,IY,IZ,ITPNMX)))
                       PP_RHO(IX,IYREFL,IZ,ITPNMX)
     *                        =ISYPAI(2)
     *                        *((1-ICONJG)*PP_RHO(IX,IY,IZ,ITPNMX)
     *                          +ICONJG*CONJG(PP_RHO(IX,IY,IZ,ITPNMX)))
                   END IF
C
                   IF (ISIMPY.EQ.1) THEN
                       PD_RHO(IX,IYREFL,IZ,ITPNMX)
     *                        =ISYPAI(2)
     *                        *PD_RHO(IX,IY,IZ,ITPNMX)
                       PP_RHO(IX,IYREFL,IZ,ITPNMX)
     *                        =ISYPAI(2)
     *                        *PP_RHO(IX,IY,IZ,ITPNMX)
                   END IF
C
                END DO
             END DO
          END DO
C
      END IF
C
      IF (ISIMTZ.EQ.1) THEN
C
C=======================================================================
C         SYMMETRY IN THE Z-DIRECTION
C=======================================================================
C
          IHABOZ=2
C
          IHABOY=1
C
          IHABOX=1
C
          DO IZ=1,NZHERM/IHABOZ
             DO IY=1,NYHERM/IHABOY
                DO IX=1,NXHERM/IHABOX
C
                   IZREFL=NZHERM+1-IZ
C
                   PD_RHO(IX,IY,IZREFL,ITPNMX)
     *               =ISYPAI(3)
     *               *((1-ICONJG)*PD_RHO(IX,IY,IZ,ITPNMX)
     *                 +ICONJG*CONJG(PD_RHO(IX,IY,IZ,ITPNMX)))
C
                   PP_RHO(IX,IY,IZREFL,ITPNMX)
     *               =ISYPAI(3)
     *               *((1-ICONJG)*PP_RHO(IX,IY,IZ,ITPNMX)
     *                 +ICONJG*CONJG(PP_RHO(IX,IY,IZ,ITPNMX)))
C
                END DO
             END DO
          END DO
C
      END IF
C
C=======================================================================
C
      IF (ISIGNY.EQ.1) THEN
C
C=======================================================================
C         SYMMETRIZATION WITH RESPECT TO THE Y-SIGNATURE
C=======================================================================
C
          IHABOZ=2
C
          IHABOY=1
C
          IHABOX=1
C
          DO IZ=1,NZHERM/IHABOZ
             DO IY=1,NYHERM/IHABOY
                DO IX=1,NXHERM/IHABOX
C
                   IXREFL=NXHERM+1-IX
                   IZREFL=NZHERM+1-IZ
C
                   PD_RHO(IXREFL,IY,IZREFL,ITPNMX)
     *            =ISYPAI(1)*ISYPAI(3)
     *            *PD_RHO(IX,IY,IZ,ITPNMX)
C
                   PP_RHO(IXREFL,IY,IZREFL,ITPNMX)
     *            =ISYPAI(1)*ISYPAI(3)
     *            *PP_RHO(IX,IY,IZ,ITPNMX)
C
                END DO
             END DO
          END DO
C
      END IF
C
C=======================================================================
C
      IF (ISIQTY.EQ.1) THEN
C
C=======================================================================
C         SYMMETRIZATION WITH RESPECT TO THE PARITY
C=======================================================================
C
          IHABOZ=2
C
          IHABOY=1
C
          IHABOX=1
C
          DO IZ=1,NZHERM/IHABOZ
             DO IY=1,NYHERM/IHABOY
                DO IX=1,NXHERM/IHABOX
C
                   IXREFL=NXHERM+1-IX
                   IYREFL=NYHERM+1-IY
                   IZREFL=NZHERM+1-IZ
C
                   PD_RHO(IXREFL,IYREFL,IZREFL,ITPNMX)
     *                                              =ISYPAI(1)
     *                                              *ISYPAI(2)
     *                                              *ISYPAI(3)
     *                                *PD_RHO(IX,IY,IZ,ITPNMX)
C
                   PP_RHO(IXREFL,IYREFL,IZREFL,ITPNMX)
     *                                              =ISYPAI(1)
     *                                              *ISYPAI(2)
     *                                              *ISYPAI(3)
     *                                *PP_RHO(IX,IY,IZ,ITPNMX)
C
                END DO
             END DO
          END DO
C
      END IF
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE SYMDEN(DENALL,NXHERM,NYHERM,NZHERM,NAMEPN)
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      CHARACTER
     *          CSYDEN*4
      CHARACTER
     *          NAMEPN*8
C
      COMPLEX
     *          DENALL(NDXHRM,NDYHRM,NDZHRM,NDALLD)
      DIMENSION
     *          SYMALL(NDKART,NDHALF,       NDALLD)
      DIMENSION
     *          CSYDEN(NDKART,              NDALLD)
C
      COMMON
     *       /INTMEM/ TWOWGT(1:NDGAUS,1:NDKART),
     *                TWOPNT(1:NDGAUS,1:NDKART)
      COMMON
     *       /CFIPRI/ NFIPRI
C
C=======================================================================
C        THIS SUBROUTINE DETERMINES SYMMETRIES  OF THE SKYRME FUNCTIONAL
C        DENSITIES. ONLY THE REAL PARTS OF DENSITIES ARE CONSIDERED.
C        ATTENTION: THE FIRST DUMMY ARGUMENT IS USED FOR ALL DENSITIES
C=======================================================================
C
      SYMALL(:,:,:)=0.0D0
C
C=======================================================================
C        SYMMETRY IN THE X-DIRECTION
C=======================================================================
C
      DO IZ=1,NZHERM/2
         DO IY=1,NYHERM/2
C
            DO NUHALF=1,NDHALF
               DO IX=1+(NUHALF-1)*NXHERM/2,NUHALF*NXHERM/2
C
                  W_HERM=TWOWGT(IX,1)*TWOWGT(IY,2)*TWOWGT(IZ,3)
C
                  DO NUMDEN=1,NDALLD
C
                     SYMALL(1,NUHALF,NUMDEN)=SYMALL(1,NUHALF,NUMDEN)
     *                                 +REAL(DENALL(IX,IY,IZ,NUMDEN))
     *                                      *W_HERM
C
                  END DO
C
               END DO
C
            END DO
         END DO
      END DO
C
C=======================================================================
C        SYMMETRY IN THE Y-DIRECTION
C=======================================================================
C
      DO IZ=1,NZHERM/2
         DO IX=1,NXHERM/2
C
            DO NUHALF=1,NDHALF
               DO IY=1+(NUHALF-1)*NYHERM/2,NUHALF*NYHERM/2
C
                  W_HERM=TWOWGT(IX,1)*TWOWGT(IY,2)*TWOWGT(IZ,3)
C
                  DO NUMDEN=1,NDALLD
C
                     SYMALL(2,NUHALF,NUMDEN)=SYMALL(2,NUHALF,NUMDEN)
     *                                 +REAL(DENALL(IX,IY,IZ,NUMDEN))
     *                                      *W_HERM
C
                  END DO
C
               END DO
C
            END DO
         END DO
      END DO
C
C=======================================================================
C        SYMMETRY IN THE Z-DIRECTION
C=======================================================================
C
      DO IY=1,NYHERM/2
         DO IX=1,NXHERM/2
C
            DO NUHALF=1,NDHALF
               DO IZ=1+(NUHALF-1)*NZHERM/2,NUHALF*NZHERM/2
C
                  W_HERM=TWOWGT(IX,1)*TWOWGT(IY,2)*TWOWGT(IZ,3)
C
                  DO NUMDEN=1,NDALLD
C
                     SYMALL(3,NUHALF,NUMDEN)=SYMALL(3,NUHALF,NUMDEN)
     *                                 +REAL(DENALL(IX,IY,IZ,NUMDEN))
     *                                      *W_HERM
C
                  END DO
C
               END DO
C
            END DO
         END DO
      END DO
C
C=======================================================================
C        DETERMINING THE SYMMETRY
C=======================================================================
C
      DO KARTEZ=1,NDKART
         DO NUMDEN=1,NDALLD
C
            IF (SYMALL(KARTEZ,1,NUMDEN).EQ.0.0) THEN
C
                CSYDEN(KARTEZ,NUMDEN)='ZERO'
C
            ELSE
C
                DIVIDE=SYMALL(KARTEZ,2,NUMDEN)/SYMALL(KARTEZ,1,NUMDEN)
C
                IF (ABS(ABS(DIVIDE)-1.0D0).LT.1.D-6) THEN
C
                    IF (DIVIDE.GT.0.0) THEN
                        CSYDEN(KARTEZ,NUMDEN)=' +1 '
                    ELSE
                        CSYDEN(KARTEZ,NUMDEN)=' -1 '
                    END IF
C
                ELSE
                    CSYDEN(KARTEZ,NUMDEN)='NONE'
                END IF
            END IF
C
         END DO
      END DO
C
C=======================================================================
C        PRINTING
C=======================================================================
C
      WRITE(NFIPRI,'(79(1H*),/,                    1H*,77X,1H*,/,
     *                 1H*,2X,''SYMMETRIES OF THE SKYRME DENSITIES'',
     *                        ''                               '',
     *                                               A8,2X,1H*,/,
     *                                             1H*,77X,1H*,/,
     *                                                 79(1H*),/,
     *                 1H*,''  N '',3(1H*,23X),         1X,1H*,/,
     *                 1H*,''  U '',1H*,'' X - PLANE  REFLECTION '',
     *                              1H*,'' Y - PLANE  REFLECTION '',
     *                              1H*,'' Z - PLANE  REFLECTION '',
     *                                                  1X,1H*,/,
     *                 1H*,''  M '',3(1H*,23X),         1X,1H*,/,
     *                                                 79(1H*),/,
     *              43(1H*,1X,I2,3(1X,2(1PE9.1),1X,A4),2X,1H*,/),
     *                                                  79(1H*),/)')
     *     NAMEPN,
     *    (NUMDEN,((SYMALL(KARTEZ,NUHALF,NUMDEN),NUHALF=1,NDHALF),
     *              CSYDEN(KARTEZ,       NUMDEN),
     *                                           KARTEZ=1,NDKART),
     *                                           NUMDEN=1,NDALLD)
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE SYMPAI(ITPNMX,NXHERM,NYHERM,NZHERM)
C=======================================================================
      USE PD_DEN
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      CHARACTER
     *          CSYPAI*4
C
      COMPLEX
     *          SYMALL(NDKART,NDHALF)
C
      DIMENSION
     *          CSYPAI(NDKART,NDREIM)
C
      COMMON
     *       /INTMEM/ TWOWGT(1:NDGAUS,1:NDKART),
     *                TWOPNT(1:NDGAUS,1:NDKART)
      COMMON
     *       /CFIPRI/ NFIPRI
C
C=======================================================================
C        THIS SUBROUTINE DETERMINES SYMMETRIES  OF THE SKYRME FUNCTIONAL
C        PAIRING DENSITIES
C
C        ATTENTION: THE FIRST DUMMY ARGUMENT IS USED FOR ALL DENSITIES
C
C=======================================================================
C
      SYMALL(:,:)=CMPLX(0.0D0,0.0D0)
C
C=======================================================================
C        SYMMETRY IN THE X-DIRECTION
C=======================================================================
C
      DO IZ=1,NZHERM/2
         DO IY=1,NYHERM/2
C
            DO NUHALF=1,NDHALF
               DO IX=1+(NUHALF-1)*NXHERM/2,NUHALF*NXHERM/2
C
                  W_HERM=TWOWGT(IX,1)*TWOWGT(IY,2)*TWOWGT(IZ,3)
C
                  SYMALL(1,NUHALF)=SYMALL(1,NUHALF)
     *                                   +PD_RHO(IX,IY,IZ,ITPNMX)
     *                                   *W_HERM
C
               END DO
C
            END DO
         END DO
      END DO
C
C=======================================================================
C        SYMMETRY IN THE Y-DIRECTION
C=======================================================================
C
      DO IZ=1,NZHERM/2
         DO IX=1,NXHERM/2
C
            DO NUHALF=1,NDHALF
               DO IY=1+(NUHALF-1)*NYHERM/2,NUHALF*NYHERM/2
C
                  W_HERM=TWOWGT(IX,1)*TWOWGT(IY,2)*TWOWGT(IZ,3)
C
                  SYMALL(2,NUHALF)=SYMALL(2,NUHALF)
     *                                   +PD_RHO(IX,IY,IZ,ITPNMX)
     *                                   *W_HERM
C
               END DO
C
            END DO
         END DO
      END DO
C
C=======================================================================
C        SYMMETRY IN THE Z-DIRECTION
C=======================================================================
C
      DO IY=1,NYHERM/2
         DO IX=1,NXHERM/2
C
            DO NUHALF=1,NDHALF
               DO IZ=1+(NUHALF-1)*NZHERM/2,NUHALF*NZHERM/2
C
                  W_HERM=TWOWGT(IX,1)*TWOWGT(IY,2)*TWOWGT(IZ,3)
C
                  SYMALL(3,NUHALF)=SYMALL(3,NUHALF)
     *                                   +PD_RHO(IX,IY,IZ,ITPNMX)
     *                                   *W_HERM
C
               END DO
C
            END DO
         END DO
      END DO
C
C=======================================================================
C        DETERMINING THE SYMMETRY
C=======================================================================
C
      DO KARTEZ=1,NDKART
         DO NUREIM=1,NDREIM
C
            IF (NUREIM.EQ.1) THEN
C
                HALF_1= REAL(SYMALL(KARTEZ,1))
                HALF_2= REAL(SYMALL(KARTEZ,2))
            ELSE
                HALF_1=AIMAG(SYMALL(KARTEZ,1))
                HALF_2=AIMAG(SYMALL(KARTEZ,2))
C
            END IF
C
            IF (HALF_1.EQ.0.0) THEN
C
                CSYPAI(KARTEZ,NUREIM)='ZERO'
C
            ELSE
C
                DIVIDE=HALF_2/HALF_1
C
                IF (ABS(ABS(DIVIDE)-1.0D0).LT.1.D-6) THEN
C
                    IF (DIVIDE.GT.0.0) THEN
C
                        CSYPAI(KARTEZ,NUREIM)=' +1 '
                    ELSE
                        CSYPAI(KARTEZ,NUREIM)=' -1 '
C
                    END IF
C
                ELSE
                    CSYPAI(KARTEZ,NUREIM)='NONE'
                END IF
C
            END IF
C
         END DO
      END DO
C
C=======================================================================
C        PRINTING
C=======================================================================
C
      WRITE(NFIPRI,'(79(1H*),/,                    1H*,77X,1H*,/,
     *                 1H*,2X,''SYMMETRIES OF PAIRING DENSITIE'',
     *                        ''S (REAL PARTS)                '',
     *                                                 15X,1H*,/,
     *                                             1H*,77X,1H*,/,
     *                                                 79(1H*),/,
     *                                             1H*,77X,1H*,/,
C    *              16(1H*,2X,I3,3(2(1PE9.1),1X,A4),    3X,1H*,/),
     *                (1H*,2X,I3,3(2(1PE9.1),1X,A4),    3X,1H*,/),
     *                                             1H*,77X,1H*,/,
     *                                                  79(1H*),/)')
     *
     *    (NUMPAI,((REAL(SYMALL(KARTEZ,NUHALF)),
     *                                           NUHALF=1,NDHALF),
     *              CSYPAI(KARTEZ,1),
     *                                           KARTEZ=1,NDKART),
     *                                           NUMPAI=1,NDALLP)
C
      WRITE(NFIPRI,'(79(1H*),/,                    1H*,77X,1H*,/,
     *                 1H*,2X,''SYMMETRIES OF PAIRING DENSITIE'',
     *                        ''S (IMAGINARY PARTS)           '',
     *                                                 15X,1H*,/,
     *                                             1H*,77X,1H*,/,
     *                                                 79(1H*),/,
     *                                             1H*,77X,1H*,/,
C    *              16(1H*,2X,I3,3(2(1PE9.1),1X,A4),    3X,1H*,/),
     *                (1H*,2X,I3,3(2(1PE9.1),1X,A4),    3X,1H*,/),
     *                                             1H*,77X,1H*,/,
     *                                                  79(1H*),/)')
     *
     *    (NUMPAI,((AIMAG(SYMALL(KARTEZ,NUHALF)),
     *                                           NUHALF=1,NDHALF),
     *              CSYPAI(KARTEZ,2),
     *                                           KARTEZ=1,NDKART),
     *                                           NUMPAI=1,NDALLP)
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE DBLING(ITPNMX,NXHERM,NYHERM,NZHERM,ENESUM)
C=======================================================================
      USE HE_DEN
      USE PD_DEN
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      COMPLEX
     *          UNIT_I
C
C=======================================================================
C
      ZERO=0.0D0
C
      UNIT_I=CMPLX(0.0D0,1.0D0)
C
C=======================================================================
C
      ENESUM=2*ENESUM
C
C=======================================================================
C        THIS SUBROUTINE CALCULATES DENSITIES  OR  TRANSITION  DENSITIES
C        FOR CONSERVED TIME-REVERSAL SYMMETRY, WHEN THEY ARE  DETERMINED
C        IN "DENSHF" BY USING ONLY THE TIME-UP BLOCK OF WAVE  FUNCTIONS.
C        THE SUBROUTINE:
C           1. TAKES DOUBLED REAL  PARTS  OF  THE  CALCULATED  TIME-EVEN
C              "P-H" DENSITIES AS THESE SAME DENSITIES.
C           2. TAKES DOUBLED IMAGINARY PARTS MULTIPLIED BY THE IMAGINARY
C              UNIT OF THE CALCULATED TIME-ODD "P-H" DENSITIES AS  THESE
C              SAME DENSITIES.
C           3. PUTS ZEROS IN THE IMAGINARY PARTS OF THE "P-P" DENSITIES.
C              ATTENTION! SUCH A TREATMENT OF THE "P-P" DENSITIES IS NOT
C                         YET CORRECT FOR THE TRANSITION DENSITIES.
C=======================================================================
C
      DO IZ=1,NZHERM
         DO IY=1,NYHERM
            DO IX=1,NXHERM
C
C=======================================================================
C              SCALAR  DENSITIES
C=======================================================================
C
               DE_RHO(IX,IY,IZ,ITPNMX)=2*REAL(DE_RHO(IX,IY,IZ,ITPNMX))
               DE_TAU(IX,IY,IZ,ITPNMX)=2*REAL(DE_TAU(IX,IY,IZ,ITPNMX))
               DE_DIV(IX,IY,IZ,ITPNMX)=2*REAL(DE_DIV(IX,IY,IZ,ITPNMX))
               DE_LPR(IX,IY,IZ,ITPNMX)=2*REAL(DE_LPR(IX,IY,IZ,ITPNMX))
C
c               PAIRHO(IX,IY,IZ,ICHARG)=CMPLX(REAL(PAIRHO(IX,IY,IZ)),ZERO)
C
            END DO
         END DO
      END DO
C
      DO K=1,NDKART
C
         DO IZ=1,NZHERM
            DO IY=1,NYHERM
               DO IX=1,NXHERM
C
C=======================================================================
C              VECTOR DENSITIES
C=======================================================================
C
                  DE_SPI(IX,IY,IZ,K,ITPNMX)
     *                        =2*AIMAG(DE_SPI(IX,IY,IZ,K,ITPNMX))*UNIT_I
                  DE_KIS(IX,IY,IZ,K,ITPNMX)
     *                        =2*AIMAG(DE_KIS(IX,IY,IZ,K,ITPNMX))*UNIT_I
                  DE_LPS(IX,IY,IZ,K,ITPNMX)
     *                        =2*AIMAG(DE_LPS(IX,IY,IZ,K,ITPNMX))*UNIT_I
                  DE_CUR(IX,IY,IZ,K,ITPNMX)
     *                        =2*AIMAG(DE_CUR(IX,IY,IZ,K,ITPNMX))*UNIT_I
                  DE_ROS(IX,IY,IZ,K,ITPNMX)
     *                        =2*AIMAG(DE_ROS(IX,IY,IZ,K,ITPNMX))*UNIT_I
                  DE_ROC(IX,IY,IZ,K,ITPNMX)
     *                        =2*AIMAG(DE_ROC(IX,IY,IZ,K,ITPNMX))*UNIT_I
C
                  DE_GRR(IX,IY,IZ,K,ITPNMX)
     *                        =2* REAL(DE_GRR(IX,IY,IZ,K,ITPNMX))
C
               END DO
            END DO
         END DO
C
      END DO
C
      DO L=1,NDKART
         DO K=1,NDKART
C
            DO IZ=1,NZHERM
               DO IY=1,NYHERM
                  DO IX=1,NXHERM
C
C=======================================================================
C                 TENSOR DENSITIES
C=======================================================================
C
                     DE_SCU(IX,IY,IZ,K,L,ITPNMX)
     *                             =2* REAL(DE_SCU(IX,IY,IZ,K,L,ITPNMX))
C
                     DE_DES(IX,IY,IZ,K,L,ITPNMX)
     *                             =2*AIMAG(DE_DES(IX,IY,IZ,K,L,ITPNMX))
     *                             *UNIT_I
C
                  END DO
               END DO
            END DO
C
         END DO
      END DO
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE ALLODE()
C=======================================================================
      USE HE_DEN
      USE PD_DEN
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      COMMON
     *       /CFIPRI/ NFIPRI
C
C=======================================================================
C        THIS SUBROUTINE ALLOCATES SPACE FOR SKYRME DENSITIES TAKING
C        INTO ACCOUNT POSSIBLE PROTON-NEUTRON MIXING
C=======================================================================
C
      IF(ALLOCATED(DE_RHO)) THEN
         DEALLOCATE(DE_RHO,DE_TAU,DE_LPR,DE_DIV,PD_RHO,PP_RHO,
     *              DE_SPI,DE_KIS,DE_GRR,DE_LPS,DE_ROS,DE_ROC,
     *              DE_CUR,DE_SCU,DE_DES)
      END IF
C
      IALLOC=0
C
      ALLOCATE(DE_RHO(1:NDXHRM,1:NDYHRM,1:NDZHRM,0:NDISOS),
     *         DE_TAU(1:NDXHRM,1:NDYHRM,1:NDZHRM,0:NDISOS),
     *         DE_LPR(1:NDXHRM,1:NDYHRM,1:NDZHRM,0:NDISOS),
     *         DE_DIV(1:NDXHRM,1:NDYHRM,1:NDZHRM,0:NDISOS),
     *         PD_RHO(1:NDXHRM,1:NDYHRM,1:NDZHRM,0:NDISOS),
     *         PP_RHO(1:NDXHRM,1:NDYHRM,1:NDZHRM,0:NDISOS),
     *         STAT=IALLOC)
      IF(IALLOC.NE.0) WRITE(NFIPRI,'("ERROR 00")')
C
      IALLOC=0
C
      ALLOCATE(DE_SPI(1:NDXHRM,1:NDYHRM,1:NDZHRM,1:NDKART,0:NDISOS),
     *         DE_KIS(1:NDXHRM,1:NDYHRM,1:NDZHRM,1:NDKART,0:NDISOS),
     *         DE_GRR(1:NDXHRM,1:NDYHRM,1:NDZHRM,1:NDKART,0:NDISOS),
     *         DE_LPS(1:NDXHRM,1:NDYHRM,1:NDZHRM,1:NDKART,0:NDISOS),
     *         DE_ROS(1:NDXHRM,1:NDYHRM,1:NDZHRM,1:NDKART,0:NDISOS),
     *         DE_ROC(1:NDXHRM,1:NDYHRM,1:NDZHRM,1:NDKART,0:NDISOS),
     *         DE_CUR(1:NDXHRM,1:NDYHRM,1:NDZHRM,1:NDKART,0:NDISOS),
     *         STAT=IALLOC)
      IF(IALLOC.NE.0) WRITE(NFIPRI,'("ERROR 01")')
C
      IALLOC=0
C
      ALLOCATE(DE_SCU(1:NDXHRM,1:NDYHRM,1:NDZHRM,1:NDKART,1:NDKART,
     *                                                    0:NDISOS),
     *         DE_DES(1:NDXHRM,1:NDYHRM,1:NDZHRM,1:NDKART,1:NDKART,
     *                                                    0:NDISOS),
     *         STAT=IALLOC)
      IF(IALLOC.NE.0) WRITE(NFIPRI,'("ERROR 02")')
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE DEALDE()
C=======================================================================
      USE HE_DEN
      USE PD_DEN
C=======================================================================
C
      IF(ALLOCATED(DE_RHO)) THEN
         DEALLOCATE(DE_RHO,DE_TAU,DE_LPR,DE_DIV,PD_RHO,PP_RHO,
     *              DE_SPI,DE_KIS,DE_GRR,DE_LPS,DE_ROS,DE_ROC,
     *              DE_CUR,DE_SCU,DE_DES)
      END IF
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE ALLOVF()
C=======================================================================
      USE VE_FLD
      USE WD_FLD
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      COMMON
     *       /CFIPRI/ NFIPRI
C
C=======================================================================
C        THIS SUBROUTINE ALLOCATES SPACE FOR SKYRME DENSITIES TAKING
C        INTO ACCOUNT POSSIBLE PROTON-NEUTRON MIXING
C=======================================================================
C
      IF(ALLOCATED(VE_MAS)) THEN
         DEALLOCATE(VE_MAS,VE_CEN,VE_KIS,VE_SPI,VE_CUR,VE_SOR)
      END IF
C
      IALLOC=0
C
      ALLOCATE(VE_MAS(1:NDXHRM,1:NDYHRM,1:NDZHRM,0:NDISOS),
     *         VE_CEN(1:NDXHRM,1:NDYHRM,1:NDZHRM,0:NDISOS),
     *         STAT=IALLOC)
      IF(IALLOC.NE.0) WRITE(NFIPRI,'("ERROR 03")')
C
      IALLOC=0
C
      ALLOCATE(VE_KIS(1:NDXHRM,1:NDYHRM,1:NDZHRM,1:NDKART,0:NDISOS),
     *         VE_SPI(1:NDXHRM,1:NDYHRM,1:NDZHRM,1:NDKART,0:NDISOS),
     *         VE_CUR(1:NDXHRM,1:NDYHRM,1:NDZHRM,1:NDKART,0:NDISOS),
     *         STAT=IALLOC)
      IF(IALLOC.NE.0) WRITE(NFIPRI,'("ERROR 04")')
C
      IALLOC=0
C
      ALLOCATE(VE_SOR(1:NDXHRM,1:NDYHRM,1:NDZHRM,1:NDKART,1:NDKART,
     *                                                    0:NDISOS),
     *         STAT=IALLOC)
      IF(IALLOC.NE.0) WRITE(NFIPRI,'("ERROR 05")')
C
      IF(ALLOCATED(WD_CEN)) THEN
         DEALLOCATE(WD_CEN)
      END IF
C
      IALLOC=0
C
      ALLOCATE(WD_CEN(1:NDXHRM,1:NDYHRM,1:NDZHRM,0:NDISOS),
     *         STAT=IALLOC)
      IF(IALLOC.NE.0) WRITE(NFIPRI,'("ERROR 06")')
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE DEALVF()
C=======================================================================
      USE VE_FLD
      USE WD_FLD
C=======================================================================
C
      IF(ALLOCATED(VE_MAS)) THEN
         DEALLOCATE(VE_MAS,VE_CEN,VE_KIS,VE_SPI,VE_CUR,VE_SOR)
      END IF
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE ZEDENS(ICHARG)
C=======================================================================
      USE HE_DEN
      USE PD_DEN
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      COMPLEX
     *          C_ZERO
C
      C_ZERO=CMPLX(0.0D0,0.0D0)
C
C=======================================================================
C              SCALAR  DENSITIES
C=======================================================================
C
      DE_RHO(:,:,:,ICHARG)=C_ZERO
      DE_TAU(:,:,:,ICHARG)=C_ZERO
      DE_DIV(:,:,:,ICHARG)=C_ZERO
      DE_LPR(:,:,:,ICHARG)=C_ZERO
C
      PD_RHO(:,:,:,ICHARG)=C_ZERO
      PP_RHO(:,:,:,ICHARG)=C_ZERO
C
C=======================================================================
C              VECTOR DENSITIES
C=======================================================================
C
      DE_SPI(:,:,:,:,ICHARG)=C_ZERO
      DE_KIS(:,:,:,:,ICHARG)=C_ZERO
      DE_LPS(:,:,:,:,ICHARG)=C_ZERO
      DE_GRR(:,:,:,:,ICHARG)=C_ZERO
      DE_CUR(:,:,:,:,ICHARG)=C_ZERO
      DE_ROS(:,:,:,:,ICHARG)=C_ZERO
      DE_ROC(:,:,:,:,ICHARG)=C_ZERO
C
C=======================================================================
C                 TENSOR DENSITY
C=======================================================================
C
      DE_SCU(:,:,:,:,:,ICHARG)=C_ZERO
      DE_DES(:,:,:,:,:,ICHARG)=C_ZERO
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE WSHAMI(NXMAXX,NYMAXX,NZMAXX,ITILAX,ITISAX,NO_ORB,
     *                                              ICHARG,ISIMPY)
C=======================================================================
      USE SPINOR
      USE MAT_PP
      USE MAT_PM
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      COMPLEX
     *          RESULT
C=======================================================================
      COMPLEX
     *          TIMEPP,TIMEPM,TIMEMP,TIMEMM
C
C=======================================================================
      ALLOCATABLE HAUXIL(:,:)
C=======================================================================
      COMMON
     *       /T_PHAS/ IPHAPP(0:NDYMAX,0:NDYMAX,0:NDKART),
     *                IPHAPM(0:NDYMAX,0:NDYMAX,0:NDKART),
     *                IPHAMP(0:NDYMAX,0:NDYMAX,0:NDKART),
     *                IPHAMM(0:NDYMAX,0:NDYMAX,0:NDKART)
C=======================================================================
      COMMON
     *       /SPE_WS/ ESINWS(1:NDBASE,0:NDISOS)
      COMMON
     *       /DIMENS/ LDBASE
      COMMON
     *       /OMOVAS/ OMOVAX,OMOVAY,OMOVAZ
      COMMON
     *       /OMISOS/ OMISOX,OMISOY,OMISOZ
C
C=======================================================================
C
      IALLOC=0
C
C=======================================================================
      ALLOCATE (HAUXIL(1:NDBASE,1:NDBASE),STAT=IALLOC)
      IF (IALLOC.NE.0) CALL NOALLO('HAUXIL','WSHAMI')
C=======================================================================
      IF (.NOT.ALLOCATED(BIG_PP)) THEN
          ALLOCATE (BIG_PP(1:NDBASE,1:NDBASE,0:NDREVE),STAT=IALLOC)
          IF (IALLOC.NE.0) CALL NOALLO('BIG_PP','WSHAMI')
      END IF
      IF (.NOT.ALLOCATED(BIG_PM).AND.ISIMPY.NE.1) THEN
          ALLOCATE (BIG_PM(1:NDBASE,1:NDBASE,0:NDREVE),STAT=IALLOC)
          IF (IALLOC.NE.0) CALL NOALLO('BIG_PM','WSHAMI')
      END IF
C=======================================================================
C
C=======================================================================
C        THIS SUBROUTINE CALCULATES THE CRANKED WOODS-SAXON HAMILTONIAN
C=======================================================================
C        ZEROING THE HAMILTONIAN
C=======================================================================
C
      BIG_PP(:,:,:)=CMPLX(0.0D0,0.0D0)
      IF (ISIMPY.NE.1) THEN
          BIG_PM(:,:,:)=CMPLX(0.0D0,0.0D0)
      END IF
C
C=======================================================================
C          INSERTING THE CRANKING MATRIX ELEMENTS
C=======================================================================
C
      IF (ITILAX.EQ.0.AND.ITISAX.EQ.0) GO TO 2
C
      IF (ISIMPY.EQ.1) GO TO 2
C
C=======================================================================
C          X-DIRECTION
C=======================================================================
C
      OMEGAC=0.0D0
      IF (ITILAX.NE.0) OMEGAC=OMEGAC+             OMOVAX
      IF (ITISAX.NE.0) OMEGAC=OMEGAC+(1-2*ICHARG)*OMISOX
C
      IF (NO_ORB.NE.1) THEN
C
          CALL INT_LX(NXMAXX,NYMAXX,NZMAXX,IPHAPM(0,0,0),HAUXIL,OMEGAC)
C
          CALL PUTIMA(-1,HAUXIL,BIG_PM(1,1,1))
C
      END IF
C
      CALL INT_SX(NXMAXX,NYMAXX,NZMAXX,HAUXIL,OMEGAC)
C
      CALL PUTREA(-1,HAUXIL,BIG_PM(1,1,1))
C
C=======================================================================
C          Z-DIRECTION
C=======================================================================
C
      OMEGAC=0.0D0
      IF (ITILAX.NE.0) OMEGAC=OMEGAC+             OMOVAZ
      IF (ITISAX.NE.0) OMEGAC=OMEGAC+(1-2*ICHARG)*OMISOZ
C
      IF (NO_ORB.NE.1) THEN
C
          CALL INT_LZ(NXMAXX,NYMAXX,NZMAXX,IPHAPM(0,0,0),HAUXIL,OMEGAC)
C
          CALL PUTIMA(-1,HAUXIL,BIG_PM(1,1,1))
C
      END IF
C
      CALL INT_SZ(NXMAXX,NYMAXX,NZMAXX,HAUXIL,OMEGAC)
C
      CALL PUTIMA(-1,HAUXIL,BIG_PM(1,1,1))
C
C=======================================================================
C
    2 CONTINUE
C
C=======================================================================
C          Y-DIRECTION
C=======================================================================
C
      OMEGAC=OMOVAY+(1-2*ICHARG)*OMISOY
C
      IF (NO_ORB.NE.1) THEN
C
          CALL INT_LY(NXMAXX,NYMAXX,NZMAXX,IPHAPP(0,0,0),HAUXIL,OMEGAC)
C
          CALL PUTIMA(-1,HAUXIL,BIG_PP(1,1,1))
C
      END IF
C
      CALL INT_SY(NXMAXX,NYMAXX,NZMAXX,HAUXIL,OMEGAC)
C
      CALL PUTREA(-1,HAUXIL,BIG_PP(1,1,1))
C
C=======================================================================
C        CALCULATING THE BLOCKS OF THE HAMILTONIAN THAT ARE DIAGONAL IN
C        SIMPLEX. THE WAVE FUNCTIONS AND EIGEN ENERGIES ARE SUPPOSED TO
C        EXIST IN "WSWAVE" AND "SPESIM", RESPECTIVELY.
C=======================================================================
C
      DO IKET=1,LDBASE
         DO IBRA=1,LDBASE
C
            RESULT=CMPLX(0.0D0,0.0D0)
C
            DO ISTATE=1,LDBASE
               RESULT=RESULT+WSWAVE(IBRA,ISTATE,ICHARG)
     *                           *ESINWS(ISTATE,ICHARG)
     *               * CONJG(WSWAVE(IKET,ISTATE,ICHARG))
            END DO
C
            BIG_PP(IBRA,IKET,0)=BIG_PP(IBRA,IKET,0)+RESULT
C
         END DO
      END DO
C
C=======================================================================
C         COMBINING THE  TIME-EVEN  AND  TIME-ODD   PARTS
C              INTO THE  TIME-UP    AND  TIME-DOWN  PARTS
C=======================================================================
C
      DO IKET=1,LDBASE
         DO IBRA=1,LDBASE
C
            TIMEPP=       BIG_PP(IBRA,IKET,0) + BIG_PP(IBRA,IKET,1)
            TIMEMM= CONJG(BIG_PP(IBRA,IKET,0) - BIG_PP(IBRA,IKET,1))
C
            BIG_PP(IBRA,IKET,0) = TIMEPP
            BIG_PP(IBRA,IKET,1) = TIMEMM
C
         END DO
      END DO
C
      IF (ISIMPY.NE.1) THEN
C
          DO IKET=1,LDBASE
             DO IBRA=1,LDBASE
C
                TIMEPM=       BIG_PM(IBRA,IKET,0) + BIG_PM(IBRA,IKET,1)
                TIMEMP=-CONJG(BIG_PM(IBRA,IKET,0) - BIG_PM(IBRA,IKET,1))
C
                BIG_PM(IBRA,IKET,0) = TIMEPM
                BIG_PM(IBRA,IKET,1) = TIMEMP
C
             END DO
          END DO
C
      END IF
C
C=======================================================================
      DEALLOCATE (HAUXIL)
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE NILSON(NXMAXX,NYMAXX,NZMAXX,ITILAX,ITISAX,NO_ORB,
     *                                              INNUMB,IZNUMB,
     *                                              ICHARG,NAMEPN,
     *                                              HOMEGA,ISIMPY)
C=======================================================================
      USE MAT_PP
      USE MAT_PM
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      CHARACTER
     *          NAMEPN*8
C
      COMPLEX
     *          TIMEPP,TIMEPM,TIMEMP,TIMEMM
C=======================================================================
      ALLOCATABLE HAUXIL(:,:)
C=======================================================================
      COMMON
     *       /T_PHAS/ IPHAPP(0:NDYMAX,0:NDYMAX,0:NDKART),
     *                IPHAPM(0:NDYMAX,0:NDYMAX,0:NDKART),
     *                IPHAMP(0:NDYMAX,0:NDYMAX,0:NDKART),
     *                IPHAMM(0:NDYMAX,0:NDYMAX,0:NDKART)
      COMMON
     *       /NILPAR/ CNILSN,DNILSN,CNILSP,DNILSP,
     *                HBANIX,HBANIY,HBANIZ,NILDAT
      COMMON
     *       /BASPAR/ HBAROX,HBAROY,HBAROZ
      COMMON
     *       /OMOVAS/ OMOVAX,OMOVAY,OMOVAZ
      COMMON
     *       /OMISOS/ OMISOX,OMISOY,OMISOZ
      COMMON
     *       /ANGANG/ ANGU_N(1:NDKART),ANGU_P(1:NDKART),ANGU_T(1:NDKART)
      COMMON
     *       /ICNSTR/ STIFFI(1:NDKART),
     *                ASKEDI(1:NDKART),
     *                IFLAGI(1:NDKART)
      COMMON
     *       /ACNSTR/ STIFFA,ASKEDA,IFLAGA
      COMMON
     *       /PLANCK/ HBMASS,HBMRPA,HBMINP
      COMMON
     *       /ESHIFT/ EFEBAS(0:NDISOS)
      COMMON
     *       /DIMENS/ LDBASE
      COMMON
     *       /CFIPRI/ NFIPRI
C
C=======================================================================
C
      CALL CPUTIM('NILSON',1)
C
C=======================================================================
C
      IALLOC=0
C
C=======================================================================
      ALLOCATE (HAUXIL(1:NDBASE,1:NDBASE),STAT=IALLOC)
      IF (IALLOC.NE.0) CALL NOALLO('HAUXIL','NILSON')
      HAUXIL = 0.0D0
C=======================================================================
      IF (.NOT.ALLOCATED(BIG_PP)) THEN
          ALLOCATE (BIG_PP(1:NDBASE,1:NDBASE,0:NDREVE),STAT=IALLOC)
          IF (IALLOC.NE.0) CALL NOALLO('BIG_PP','NILSON')
      END IF
C=======================================================================
      IF (.NOT.ALLOCATED(BIG_PM).AND.ISIMPY.NE.1) THEN
          ALLOCATE (BIG_PM(1:NDBASE,1:NDBASE,0:NDREVE),STAT=IALLOC)
          IF (IALLOC.NE.0) CALL NOALLO('BIG_PM','NILSON')
      END IF
C
                       BIG_PP = CMPLX(0.0D0,0.0D0)
      IF (ISIMPY.NE.1) BIG_PM = CMPLX(0.0D0,0.0D0)
C=======================================================================
C
C=======================================================================
C          THIS SUBROUTINE CALCULATES MATRIX ELEMENTS OF THE NILSSON
C          HAMILTONIAN
C=======================================================================
C
C=======================================================================
C           THE POTENTIAL ENERGY IS SHIFTED, SO AS TO BE EQUAL TO -8 MEV
C           AT THE FERMI SURFACE OF THE BASIS STATES.  THIS IS DONE ONLY
C           TO KEEP THE ENERGY SCALE OF THE NILSSON HAMILTONIAN  SIMILAR
C           TO THAT OF THE SELF-CONSISTENT AND WOODS-SAXON HAMILTONIANS.
C=======================================================================
C
      ESCALE=EFEBAS(ICHARG)-(-8.0D0)
C
      IF (NILDAT.EQ.0) THEN
C
C=======================================================================
C         PARAMETERS AND DEFINITIONS ARE TAKEN FROM RING & SCHUCK,
C         CHAPTER 2.8.4. DEFORMATION IS SET TO THAT OF THE  BASIS.
C=======================================================================
C
          HBACTX=HBAROX
          HBACTY=HBAROY
          HBACTZ=HBAROZ
C
          AKAPPA=0.0D0
          AAAMIU=0.0D0
C
          IF (ICHARG.EQ.0) THEN
C
C=======================================================================
C         NEUTRON HAMILTONIAN
C=======================================================================
C
              IF (INNUMB.LE.0) STOP ' INNUMB.LE.0 IN NILSON'
C
              IF (INNUMB.LE.50) THEN
C
                  AKAPPA=0.08D0
                  AAAMIU=0.00D0
C
              END IF
C
              IF (INNUMB.GT.50.AND.INNUMB.LE.82) THEN
C
                  AKAPPA=0.0637D0
                  AAAMIU=0.60D0
C
              END IF
C
              IF (INNUMB.GT.82.AND.INNUMB.LE.126) THEN
C
                  AKAPPA=0.0637D0
                  AAAMIU=0.42D0
C
              END IF
C
              IF (INNUMB.GT.126) THEN
C
                  AKAPPA=0.0635D0
                  AAAMIU=0.325D0
C
              END IF
C
          ELSE
C
C=======================================================================
C         PROTON HAMILTONIAN
C=======================================================================
C
              IF (IZNUMB.LE.0) STOP ' IZNUMB.LE.0 IN NILSON'
C
              IF (IZNUMB.LE.50) THEN
C
                  AKAPPA=0.08D0
                  AAAMIU=0.00D0
C
              END IF
C
              IF (IZNUMB.GT.50.AND.IZNUMB.LE.82) THEN
C
                  AKAPPA=0.0637D0
                  AAAMIU=0.60D0
C
              END IF
C
              IF (IZNUMB.GT.82) THEN
C
                  AKAPPA=0.0577D0
                  AAAMIU=0.65D0
C
              END IF
C
          END IF
C
          CNILSS=-2*HOMEGA*AKAPPA
          DNILSS=  -HOMEGA*AKAPPA*AAAMIU
C
C=======================================================================
C         PRINTING THE NILSSON-MODEL PARAMETERS
C=======================================================================
C
          WRITE(NFIPRI,'(79(1H*),/,1H*,77X,1H*,/,
     *          1H*, 2X,''PARAMETERS OF THE NILSSON MODEL'',
     *                                                  34X,A8,2X,1H*,/,
     *                                                    1H*,77X,1H*,/,
     *                                          79(1H*),/,1H*,77X,1H*,/,
     *          1H*,27X,''ESCALE ='',F6.3,3X,
     *                  ''KAPPA  ='',F6.3,3X,''   MIU ='',F6.3,2X,1H*,/,
     *                                                    1H*,77X,1H*,/,
     *          1H*,27X,''HOMEGA ='',F6.3,3X,
     *                  ''CNILSS ='',F6.3,3X,''DNILSS ='',F6.3,2X,1H*,/,
     *                                                    1H*,77X,1H*,/,
     *          1H*, 2X,''OSCILLATOR FREQUENCIES:'',2X,
     *                                            ''X='',F12.9,3X,
     *                                            ''Y='',F12.9,3X,
     *                                            ''Z='',F12.9,2X,1H*,/,
     *                                                    1H*,77X,1H*,/,
     *                                                      79(1H*),/)')
     *
     *                        NAMEPN,ESCALE,AKAPPA,AAAMIU,
     *                               HOMEGA,CNILSS,DNILSS,
     *                               HBACTX,HBACTY,HBACTZ
C
      ELSE
C
C=======================================================================
C         PARAMETERS ARE TAKEN FROM THE INPUT DATA. FOR NILDAT=2  THE
C         OSCILLATOR FREQUENCIES ARE KEPT EQUAL TO THOSE OF THE BASIS
C=======================================================================
C
          IF (NILDAT.EQ.1) THEN
C
              HBACTX=HBANIX
              HBACTY=HBANIY
              HBACTZ=HBANIZ
C
          ELSE
C
              HBACTX=HBAROX
              HBACTY=HBAROY
              HBACTZ=HBAROZ
C
          END IF
C
          IF (ICHARG.EQ.0) THEN
C
              CNILSS=CNILSN
              DNILSS=DNILSN
C
          ELSE
C
              CNILSS=CNILSP
              DNILSS=DNILSP
C
          END IF
C
C=======================================================================
C         PRINTING THE NILSSON-MODEL PARAMETERS
C=======================================================================
C
          WRITE(NFIPRI,'(79(1H*),/,1H*,77X,1H*,/,
     *          1H*, 2X,''PARAMETERS OF THE NILSSON MODEL '',
     *                  ''TAKEN FROM THE INPUT DATA'',   8X,A8,2X,1H*,/,
     *                                                    1H*,77X,1H*,/,
     *                                          79(1H*),/,1H*,77X,1H*,/,
     *          1H*,27X,''ESCALE ='',F6.3,3X,
     *                  ''CNILSS ='',F6.3,3X,''DNILSS ='',F6.3,2X,1H*,/,
     *                                                    1H*,77X,1H*,/,
     *          1H*, 2X,''OSCILLATOR FREQUENCIES:'',2X,
     *                                            ''X='',F12.9,3X,
     *                                            ''Y='',F12.9,3X,
     *                                            ''Z='',F12.9,2X,1H*,/,
     *                                                    1H*,77X,1H*,/,
     *                                                      79(1H*),/)')
     *
     *                        NAMEPN,ESCALE,CNILSS,DNILSS,
     *                               HBACTX,HBACTY,HBACTZ
C
      END IF
C
C=======================================================================
C          AT THE BEGINNING: TIME-EVEN PART  IS PUT INTO BIG_PP(,,0)
C                            TIME-ODD  PART  IS PUT INTO BIG_PP(,,1)
C          AT THE END:
C                            TIME-UP   BLOCK IS PUT INTO BIG_PP(,,0)
C                            TIME-DOWN BLOCK IS PUT INTO BIG_PP(,,1)
C=======================================================================
C
C=======================================================================
C        ZEROING THOSE BLOCKS OF HAMILTONIAN, WHICH ARE OFF-DIAGONAL IN
C        SIMPLEX  -  SEE COMMENTS  IN  THE  "INTEGH"  SUBROUTINE.  SUCH
C        ELEMENTS MUST BE EQUAL TO ZERO, BECAUSE IN THE PRESENT VERSION
C        THE  NILSSON  POTENTIAL  IS  USED  IN  THE  SIMPLEX-CONSERVING
C        VERSION.
C=======================================================================
C
      BIG_PP(:,:,:)=CMPLX(0.0D0,0.0D0)
      IF (ISIMPY.NE.1) THEN
          BIG_PM(:,:,:)=CMPLX(0.0D0,0.0D0)
      END IF
C
C=======================================================================
C          INSERTING THE CRANKING MATRIX ELEMENTS
C=======================================================================
C
      OMEGAC=0.0D0
C
      OMEGAT=OMOVAX**2+OMOVAY**2+OMOVAZ**2
C
      OMEGAJ=OMOVAX*ANGU_T(1)+
     *       OMOVAY*ANGU_T(2)+
     *       OMOVAZ*ANGU_T(3)
C
      IF (ITILAX   .EQ.0.AND.ITISAX   .EQ.0.AND.
     *    IFLAGI(1).EQ.0.AND.IFLAGI(3).EQ.0) GO TO 2
C
      IF (ISIMPY.EQ.1) GO TO 2
C
C=======================================================================
C          X-DIRECTION
C=======================================================================
C
      OMEGAC=0.0D0
      IF (ITILAX   .NE.0) OMEGAC=OMEGAC+             OMOVAX
      IF (ITISAX   .NE.0) OMEGAC=OMEGAC+(1-2*ICHARG)*OMISOX
      IF (IFLAGI(1).NE.0) OMEGAC=OMEGAC
     *                          -2*STIFFI(1)*(ANGU_T(1)-ASKEDI(1))
      IF (IFLAGA   .NE.0) OMEGAC=OMEGAC
     *                          -2*STIFFA   *(ANGU_T(1)*OMEGAT
     *                                       -OMOVAX   *OMEGAJ)/OMEGAT
C
      IF (NO_ORB.NE.1) THEN
C
          CALL INT_LX(NXMAXX,NYMAXX,NZMAXX,IPHAPM(0,0,0),HAUXIL,OMEGAC)
C
          CALL PUTIMA(-1,HAUXIL,BIG_PM(1,1,1))
C
      END IF
C
      CALL INT_SX(NXMAXX,NYMAXX,NZMAXX,HAUXIL,OMEGAC)
C
      CALL PUTREA(-1,HAUXIL,BIG_PM(1,1,1))
C
C=======================================================================
C          Z-DIRECTION
C=======================================================================
C
      OMEGAC=0.0D0
      IF (ITILAX   .NE.0) OMEGAC=OMEGAC+             OMOVAZ
      IF (ITISAX   .NE.0) OMEGAC=OMEGAC+(1-2*ICHARG)*OMISOZ
      IF (IFLAGI(3).NE.0) OMEGAC=OMEGAC
     *                          -2*STIFFI(3)*(ANGU_T(3)-ASKEDI(3))
      IF (IFLAGA   .NE.0) OMEGAC=OMEGAC
     *                          -2*STIFFA   *(ANGU_T(3)*OMEGAT
     *                                       -OMOVAZ   *OMEGAJ)/OMEGAT
C
      IF (NO_ORB.NE.1) THEN
C
          CALL INT_LZ(NXMAXX,NYMAXX,NZMAXX,IPHAPM(0,0,0),HAUXIL,OMEGAC)
C
          CALL PUTIMA(-1,HAUXIL,BIG_PM(1,1,1))
C
      END IF
C
      CALL INT_SZ(NXMAXX,NYMAXX,NZMAXX,HAUXIL,OMEGAC)
C
      CALL PUTIMA(-1,HAUXIL,BIG_PM(1,1,1))
C
C=======================================================================
C
    2 CONTINUE
C
C=======================================================================
C          Y-DIRECTION
C=======================================================================
C
      OMEGAC=OMOVAY+(1-2*ICHARG)*OMISOY
      IF (IFLAGI(2).NE.0) OMEGAC=OMEGAC
     *                          -2*STIFFI(2)*(ANGU_T(2)-ASKEDI(2))
      IF (IFLAGA   .NE.0) OMEGAC=OMEGAC
     *                          -2*STIFFA   *(ANGU_T(2)*OMEGAT
     *                                       -OMOVAY   *OMEGAJ)/OMEGAT
C
      IF (NO_ORB.NE.1) THEN
C
          CALL INT_LY(NXMAXX,NYMAXX,NZMAXX,IPHAPP(0,0,0),HAUXIL,OMEGAC)
C
          CALL PUTIMA(-1,HAUXIL,BIG_PP(1,1,1))
C
      END IF
C
      CALL INT_SY(NXMAXX,NYMAXX,NZMAXX,HAUXIL,OMEGAC)
C
      CALL PUTREA(-1,HAUXIL,BIG_PP(1,1,1))
C
C=======================================================================
C          CALCULATING THE BARE-MASS KINETIC ENERGY MATRIX ELEMENTS
C=======================================================================
C
      CALL INTKIN(HAUXIL,HBMASS)
C
      CALL PUTREA(+1,HAUXIL,BIG_PP(1,1,0))
C
C=======================================================================
C           CALCULATING THE DEFORMED-HO POTENTIAL-ENERGY MATRIX ELEMENTS
C=======================================================================
C
      CALL INT_HO(HAUXIL,HBMASS,ESCALE,HBACTX,HBACTY,HBACTZ)
C
      CALL PUTREA(+1,HAUXIL,BIG_PP(1,1,0))
C
C=======================================================================
C          CALCULATING THE L^2 MATRIX ELEMENTS
C=======================================================================
C
      CALL INT_L2(HAUXIL,DNILSS)
C
      CALL PUTREA(+1,HAUXIL,BIG_PP(1,1,0))
C
C=======================================================================
C          CALCULATING THE SPIN-ORBIT MATRIX ELEMENTS
C=======================================================================
C
      CALL INT_LX(NXMAXX,NYMAXX,NZMAXX,IPHAPP(0,0,1),HAUXIL,CNILSS)
      CALL PUTIMA(+1,HAUXIL,BIG_PP(1,1,0))
C
      CALL INT_LY(NXMAXX,NYMAXX,NZMAXX,IPHAPP(0,0,2),HAUXIL,CNILSS)
      CALL PUTIMA(+1,HAUXIL,BIG_PP(1,1,0))
C
      CALL INT_LZ(NXMAXX,NYMAXX,NZMAXX,IPHAPP(0,0,3),HAUXIL,CNILSS)
      CALL PUTREA(-1,HAUXIL,BIG_PP(1,1,0))
C
C=======================================================================
C         COMBINING THE  TIME-EVEN  AND  TIME-ODD   PARTS
C              INTO THE  TIME-UP    AND  TIME-DOWN  PARTS
C=======================================================================
C
      DO IKET=1,LDBASE
         DO IBRA=1,LDBASE
C
            TIMEPP=       BIG_PP(IBRA,IKET,0) + BIG_PP(IBRA,IKET,1)
            TIMEMM= CONJG(BIG_PP(IBRA,IKET,0) - BIG_PP(IBRA,IKET,1))
C
            BIG_PP(IBRA,IKET,0) = TIMEPP
            BIG_PP(IBRA,IKET,1) = TIMEMM
C
         END DO
      END DO
C
      IF (ISIMPY.NE.1) THEN
C
          DO IKET=1,LDBASE
             DO IBRA=1,LDBASE
C
                TIMEPM=       BIG_PM(IBRA,IKET,0) + BIG_PM(IBRA,IKET,1)
                TIMEMP=-CONJG(BIG_PM(IBRA,IKET,0) - BIG_PM(IBRA,IKET,1))
C
                BIG_PM(IBRA,IKET,0) = TIMEPM
                BIG_PM(IBRA,IKET,1) = TIMEMP
C
             END DO
          END DO
C
      END IF
C
C=======================================================================
      DEALLOCATE (HAUXIL)
C=======================================================================
C
      CALL CPUTIM('NILSON',0)
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE INT_L2(HAMLSQ,DNILSS)
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      DIMENSION
     *          HAMLSQ(1:NDBASE,1:NDBASE)
C
      COMMON
     *       /T_PHAS/ IPHAPP(0:NDYMAX,0:NDYMAX,0:NDKART),
     *                IPHAPM(0:NDYMAX,0:NDYMAX,0:NDKART),
     *                IPHAMP(0:NDYMAX,0:NDYMAX,0:NDKART),
     *                IPHAMM(0:NDYMAX,0:NDYMAX,0:NDKART)
      COMMON
     *       /BASISO/ NXVECT(1:NDBASE),NYVECT(1:NDBASE),NZVECT(1:NDBASE)
      COMMON
     *       /COEMUL/ COMULT(0:NDMULT,0:NDOSCI,0:NDOSCI,1:NDKART)
      COMMON
     *       /COEDER/ CODERI(1:NDDERI,0:NDOSCI,0:NDOSCI,1:NDKART)
      COMMON
     *       /COESCA/ COSCAL(1:NDSCAL,0:NDOSCI,0:NDOSCI,1:NDKART)
      COMMON
     *       /DIMENS/ LDBASE
C
C=======================================================================
C        THIS SUBROUTINE CALCULATES THE MATRIX ELEMENTS OF L2
C=======================================================================
C        THE FORMULA USED IS:
C
C        L2= 2SUM_I(X_I*D_I) - SUM_IJ(X_I*X_I*D_J*D_J - X_I*X_J*D_I*D_J)
C
C        WHERE X_I AND D_I ARE THE COMPONENTS OF THE POSITION AND GRAD-
C        IENT VECTORS, RESPECTIVELY. THE I=J TERMS CANCEL IN THE DOUBLE
C        SUMS AND ARE NOT CALCULATED. ONLY THE I<J TERMS ARE CALCULATED
C        FOR THE SECOND OF THE TWO DOUBLE SUMS.
C=======================================================================
C
      HAMLSQ(:,:)=0.0D0
C
C=======================================================================
C
      DO IKET=1,LDBASE
         DO IBRA=1,LDBASE
C
            NX=NXVECT(IBRA)
            NY=NYVECT(IBRA)
            NZ=NZVECT(IBRA)
C
            MX=NXVECT(IKET)
            MY=NYVECT(IKET)
            MZ=NZVECT(IKET)
C
            HAMLSQ(IBRA,IKET) = DNILSS * IPHAPP(NY,MY,0) *
     *
     *      (2*COSCAL(1,NX,MX,1)*COMULT(0,NY,MY,2)*COMULT(0,NZ,MZ,3)
     *      +2*COMULT(0,NX,MX,1)*COSCAL(1,NY,MY,2)*COMULT(0,NZ,MZ,3)
     *      +2*COMULT(0,NX,MX,1)*COMULT(0,NY,MY,2)*COSCAL(1,NZ,MZ,3)
     *
     *      -  COMULT(2,NX,MX,1)*CODERI(2,NY,MY,2)*COMULT(0,NZ,MZ,3)
     *      -  COMULT(2,NX,MX,1)*COMULT(0,NY,MY,2)*CODERI(2,NZ,MZ,3)
     *
     *      -  CODERI(2,NX,MX,1)*COMULT(2,NY,MY,2)*COMULT(0,NZ,MZ,3)
     *      -  COMULT(0,NX,MX,1)*COMULT(2,NY,MY,2)*CODERI(2,NZ,MZ,3)
     *
     *      -  CODERI(2,NX,MX,1)*COMULT(0,NY,MY,2)*COMULT(2,NZ,MZ,3)
     *      -  COMULT(0,NX,MX,1)*CODERI(2,NY,MY,2)*COMULT(2,NZ,MZ,3)
     *
     *      +2*COSCAL(1,NX,MX,1)*COSCAL(1,NY,MY,2)*COMULT(0,NZ,MZ,3)
     *
     *      +2*COMULT(0,NX,MX,1)*COSCAL(1,NY,MY,2)*COSCAL(1,NZ,MZ,3)
     *
     *      +2*COSCAL(1,NX,MX,1)*COMULT(0,NY,MY,2)*COSCAL(1,NZ,MZ,3))
C
         END DO
C
C=======================================================================
C        HERE THE STANDARD AVERAGE VALUE OF L2 IS SUBTRACTED
C=======================================================================
C
         NTOTAL=MX+MY+MZ
C
         HAMLSQ(IKET,IKET) = HAMLSQ(IKET,IKET)
     *                     - DNILSS * NTOTAL*(NTOTAL+3)/2.0D0
C
      END DO
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE INT_SX(NXMAXX,NYMAXX,NZMAXX,HAMANG,FACTOR)
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      DIMENSION
     *          HAMANG(1:NDBASE,1:NDBASE)
C
      COMMON
     *       /T_PHAS/ IPHAPP(0:NDYMAX,0:NDYMAX,0:NDKART),
     *                IPHAPM(0:NDYMAX,0:NDYMAX,0:NDKART),
     *                IPHAMP(0:NDYMAX,0:NDYMAX,0:NDKART),
     *                IPHAMM(0:NDYMAX,0:NDYMAX,0:NDKART)
      COMMON
     *       /BINDEX/ INDICE(0:NDXMAX,0:NDYMAX,0:NDZMAX)
      COMMON
     *       /BLIMS1/ LAXOFY(0:NDYMAX),LAXOFZ(0:NDZMAX),
     *                LAYOFZ(0:NDZMAX),LAYOFX(0:NDXMAX),
     *                LAZOFX(0:NDXMAX),LAZOFY(0:NDYMAX)
      COMMON
     *       /BLIMS2/ LAXOYZ(0:NDYMAX,0:NDZMAX),
     *                LAYOZX(0:NDZMAX,0:NDXMAX),
     *                LAZOXY(0:NDXMAX,0:NDYMAX)
      COMMON
     *       /DIMENS/ LDBASE
C
C=======================================================================
C         THIS SUBROUTINE CALCULATES THE MATRIX ELEMENTS OF SX
C=======================================================================
C
      HAMANG(:,:)=0.0D0
C
      FACACT=FACTOR*0.5D0
C
      DO NY=0,NYMAXX
         DO NZ=0,LAZOFY(NY)
            DO NX=0,LAXOYZ(NY,NZ)
C
                  HAMANG(INDICE(NX,NY,NZ),INDICE(NX,NY,NZ))=
     *
     *            FACACT * IPHAPM(NY,NY,1)
C
            END DO
         END DO
      END DO
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE INT_SY(NXMAXX,NYMAXX,NZMAXX,HAMANG,FACTOR)
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      DIMENSION
     *          HAMANG(1:NDBASE,1:NDBASE)
C
      COMMON
     *       /T_PHAS/ IPHAPP(0:NDYMAX,0:NDYMAX,0:NDKART),
     *                IPHAPM(0:NDYMAX,0:NDYMAX,0:NDKART),
     *                IPHAMP(0:NDYMAX,0:NDYMAX,0:NDKART),
     *                IPHAMM(0:NDYMAX,0:NDYMAX,0:NDKART)
      COMMON
     *       /BINDEX/ INDICE(0:NDXMAX,0:NDYMAX,0:NDZMAX)
      COMMON
     *       /BLIMS1/ LAXOFY(0:NDYMAX),LAXOFZ(0:NDZMAX),
     *                LAYOFZ(0:NDZMAX),LAYOFX(0:NDXMAX),
     *                LAZOFX(0:NDXMAX),LAZOFY(0:NDYMAX)
      COMMON
     *       /BLIMS2/ LAXOYZ(0:NDYMAX,0:NDZMAX),
     *                LAYOZX(0:NDZMAX,0:NDXMAX),
     *                LAZOXY(0:NDXMAX,0:NDYMAX)
      COMMON
     *       /DIMENS/ LDBASE
C
C=======================================================================
C         THIS SUBROUTINE CALCULATES THE MATRIX ELEMENTS OF SY
C=======================================================================
C
      HAMANG(:,:)=0.0D0
C
      FACACT=FACTOR*0.5D0
C
      DO NY=0,NYMAXX
         DO NZ=0,LAZOFY(NY)
            DO NX=0,LAXOYZ(NY,NZ)
C
                  HAMANG(INDICE(NX,NY,NZ),INDICE(NX,NY,NZ))=
     *
     *            FACACT * IPHAPP(NY,NY,2)
C
            END DO
         END DO
      END DO
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE INT_SZ(NXMAXX,NYMAXX,NZMAXX,HAMANG,FACTOR)
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      DIMENSION
     *          HAMANG(1:NDBASE,1:NDBASE)
C
      COMMON
     *       /T_PHAS/ IPHAPP(0:NDYMAX,0:NDYMAX,0:NDKART),
     *                IPHAPM(0:NDYMAX,0:NDYMAX,0:NDKART),
     *                IPHAMP(0:NDYMAX,0:NDYMAX,0:NDKART),
     *                IPHAMM(0:NDYMAX,0:NDYMAX,0:NDKART)
      COMMON
     *       /BINDEX/ INDICE(0:NDXMAX,0:NDYMAX,0:NDZMAX)
      COMMON
     *       /BLIMS1/ LAXOFY(0:NDYMAX),LAXOFZ(0:NDZMAX),
     *                LAYOFZ(0:NDZMAX),LAYOFX(0:NDXMAX),
     *                LAZOFX(0:NDXMAX),LAZOFY(0:NDYMAX)
      COMMON
     *       /BLIMS2/ LAXOYZ(0:NDYMAX,0:NDZMAX),
     *                LAYOZX(0:NDZMAX,0:NDXMAX),
     *                LAZOXY(0:NDXMAX,0:NDYMAX)
      COMMON
     *       /DIMENS/ LDBASE
C
C=======================================================================
C         THIS SUBROUTINE CALCULATES THE MATRIX ELEMENTS OF SZ
C=======================================================================
C
      HAMANG(:,:)=0.0D0
C
      FACACT=FACTOR*0.5D0
C
      DO NY=0,NYMAXX
         DO NZ=0,LAZOFY(NY)
            DO NX=0,LAXOYZ(NY,NZ)
C
                  HAMANG(INDICE(NX,NY,NZ),INDICE(NX,NY,NZ))=
     *
     *            FACACT * IPHAPM(NY,NY,3)
C
            END DO
         END DO
      END DO
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE INT_LX(NXMAXX,NYMAXX,NZMAXX,IPHASE,HAMANG,FACTOR)
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      DIMENSION
     *          IPHASE(0:NDYMAX,0:NDYMAX)
      DIMENSION
     *          HAMANG(1:NDBASE,1:NDBASE)
C
      COMMON
     *       /SCALNG/ HOMSCA(NDKART)
C
      COMMON
     *       /BINDEX/ INDICE(0:NDXMAX,0:NDYMAX,0:NDZMAX)
C
      COMMON
     *       /COEXYZ/ COEF00(0:ND2MAX,0:NDOSCI,0:NDOSCI,1:NDKART),
     *                COEF01(0:ND2MAX,0:NDOSCI,0:NDOSCI,1:NDKART),
     *                COEF11(0:ND2MAX,0:NDOSCI,0:NDOSCI,1:NDKART),
     *                COEF02(0:ND2MAX,0:NDOSCI,0:NDOSCI,1:NDKART)
      COMMON
     *       /BLIMS1/ LAXOFY(0:NDYMAX),LAXOFZ(0:NDZMAX),
     *                LAYOFZ(0:NDZMAX),LAYOFX(0:NDXMAX),
     *                LAZOFX(0:NDXMAX),LAZOFY(0:NDYMAX)
      COMMON
     *       /BLIMS2/ LAXOYZ(0:NDYMAX,0:NDZMAX),
     *                LAYOZX(0:NDZMAX,0:NDXMAX),
     *                LAZOXY(0:NDXMAX,0:NDYMAX)
      COMMON
     *       /DIMENS/ LDBASE
C
C=======================================================================
C         THIS SUBROUTINE CALCULATES THE MATRIX ELEMENTS OF LX
C=======================================================================
C
      HAMANG(:,:)=0.0D0
C
      PI=4.0D0*ATAN(1.00D0)
      SQRTP2=SQRT(PI/2.0D0)
C
      FACACT= - SQRTP2/SQRT(HOMSCA(2)*HOMSCA(3))*FACTOR
C
      DO NX=0,NXMAXX
         MX=NX
C
         DO NY=0,LAYOFX(NX)
            DO MY=MAX(0,NY-1),MIN(LAYOFX(MX),NY+1)
C
               DO NZ=0,LAZOXY(NX,NY)
                  DO MZ=MAX(0,NZ-1),MIN(LAZOXY(MX,MY),NZ+1)
C
                     HAMANG(INDICE(NX,NY,NZ),INDICE(MX,MY,MZ))=
     *
     *               FACACT * IPHASE(NY,MY)
     *
     *                   * (COEF00(1,NY,MY,2)/HOMSCA(2)
     *                                               *COEF01(0,NZ,MZ,3)
     *                     -COEF00(1,NZ,MZ,3)/HOMSCA(3)
     *                                               *COEF01(0,NY,MY,2))
C
                  END DO
               END DO
C
            END DO
         END DO
C
      END DO
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE INT_LY(NXMAXX,NYMAXX,NZMAXX,IPHASE,HAMANG,FACTOR)
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      DIMENSION
     *          IPHASE(0:NDYMAX,0:NDYMAX)
      DIMENSION
     *          HAMANG(1:NDBASE,1:NDBASE)
C
      COMMON
     *       /SCALNG/ HOMSCA(NDKART)
C
      COMMON
     *       /BINDEX/ INDICE(0:NDXMAX,0:NDYMAX,0:NDZMAX)
C
      COMMON
     *       /COEXYZ/ COEF00(0:ND2MAX,0:NDOSCI,0:NDOSCI,1:NDKART),
     *                COEF01(0:ND2MAX,0:NDOSCI,0:NDOSCI,1:NDKART),
     *                COEF11(0:ND2MAX,0:NDOSCI,0:NDOSCI,1:NDKART),
     *                COEF02(0:ND2MAX,0:NDOSCI,0:NDOSCI,1:NDKART)
      COMMON
     *       /BLIMS1/ LAXOFY(0:NDYMAX),LAXOFZ(0:NDZMAX),
     *                LAYOFZ(0:NDZMAX),LAYOFX(0:NDXMAX),
     *                LAZOFX(0:NDXMAX),LAZOFY(0:NDYMAX)
      COMMON
     *       /BLIMS2/ LAXOYZ(0:NDYMAX,0:NDZMAX),
     *                LAYOZX(0:NDZMAX,0:NDXMAX),
     *                LAZOXY(0:NDXMAX,0:NDYMAX)
      COMMON
     *       /DIMENS/ LDBASE
C
C=======================================================================
C         THIS SUBROUTINE CALCULATES THE MATRIX ELEMENTS OF LY
C=======================================================================
C
      HAMANG(:,:)=0.0D0
C
      PI=4.0D0*ATAN(1.00D0)
      SQRTP2=SQRT(PI/2.0D0)
C
      FACACT= - SQRTP2/SQRT(HOMSCA(1)*HOMSCA(3))*FACTOR
C
      DO NY=0,NYMAXX
         MY=NY
C
         DO NZ=0,LAZOFY(NY)
            DO MZ=MAX(0,NZ-1),MIN(LAZOFY(MY),NZ+1)
C
               DO NX=0,LAXOYZ(NY,NZ)
                  DO MX=MAX(0,NX-1),MIN(LAXOYZ(MY,MZ),NX+1)
C
                     HAMANG(INDICE(NX,NY,NZ),INDICE(MX,MY,MZ))=
     *
     *               FACACT * IPHASE(NY,MY)
     *
     *                   * (COEF00(1,NZ,MZ,3)/HOMSCA(3)
     *                                               *COEF01(0,NX,MX,1)
     *                     -COEF00(1,NX,MX,1)/HOMSCA(1)
     *                                               *COEF01(0,NZ,MZ,3))
C
                  END DO
               END DO
C
            END DO
         END DO
C
      END DO
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE INT_LZ(NXMAXX,NYMAXX,NZMAXX,IPHASE,HAMANG,FACTOR)
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      DIMENSION
     *          IPHASE(0:NDYMAX,0:NDYMAX)
      DIMENSION
     *          HAMANG(1:NDBASE,1:NDBASE)
C
      COMMON
     *       /SCALNG/ HOMSCA(NDKART)
C
      COMMON
     *       /BINDEX/ INDICE(0:NDXMAX,0:NDYMAX,0:NDZMAX)
C
      COMMON
     *       /COEXYZ/ COEF00(0:ND2MAX,0:NDOSCI,0:NDOSCI,1:NDKART),
     *                COEF01(0:ND2MAX,0:NDOSCI,0:NDOSCI,1:NDKART),
     *                COEF11(0:ND2MAX,0:NDOSCI,0:NDOSCI,1:NDKART),
     *                COEF02(0:ND2MAX,0:NDOSCI,0:NDOSCI,1:NDKART)
      COMMON
     *       /BLIMS1/ LAXOFY(0:NDYMAX),LAXOFZ(0:NDZMAX),
     *                LAYOFZ(0:NDZMAX),LAYOFX(0:NDXMAX),
     *                LAZOFX(0:NDXMAX),LAZOFY(0:NDYMAX)
      COMMON
     *       /BLIMS2/ LAXOYZ(0:NDYMAX,0:NDZMAX),
     *                LAYOZX(0:NDZMAX,0:NDXMAX),
     *                LAZOXY(0:NDXMAX,0:NDYMAX)
      COMMON
     *       /DIMENS/ LDBASE
C
C=======================================================================
C         THIS SUBROUTINE CALCULATES THE MATRIX ELEMENTS OF LZ
C=======================================================================
C
      HAMANG(:,:)=0.0D0
C
      PI=4.0D0*ATAN(1.00D0)
      SQRTP2=SQRT(PI/2.0D0)
C
      FACACT= - SQRTP2/SQRT(HOMSCA(1)*HOMSCA(2))*FACTOR
C
      DO NZ=0,NZMAXX
         MZ=NZ
C
         DO NX=0,LAXOFZ(NZ)
            DO MX=MAX(0,NX-1),MIN(LAXOFZ(MZ),NX+1)
C
               DO NY=0,LAYOZX(NZ,NX)
                  DO MY=MAX(0,NY-1),MIN(LAYOZX(MZ,MX),NY+1)
C
                     HAMANG(INDICE(NX,NY,NZ),INDICE(MX,MY,MZ))=
     *
     *               FACACT * IPHASE(NY,MY)
     *
     *                   * (COEF00(1,NX,MX,1)/HOMSCA(1)
     *                                               *COEF01(0,NY,MY,2)
     *                     -COEF00(1,NY,MY,2)/HOMSCA(2)
     *                                               *COEF01(0,NX,MX,1))
C
                  END DO
               END DO
C
            END DO
         END DO
C
      END DO
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE INT_PX(NXMAXX,NYMAXX,NZMAXX,IPHASE,HAMLIN,FACTOR)
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      DIMENSION
     *          IPHASE(0:NDYMAX,0:NDYMAX)
      DIMENSION
     *          HAMLIN(1:NDBASE,1:NDBASE)
C
      COMMON
     *       /SCALNG/ HOMSCA(NDKART)
C
      COMMON
     *       /BINDEX/ INDICE(0:NDXMAX,0:NDYMAX,0:NDZMAX)
C
      COMMON
     *       /COEXYZ/ COEF00(0:ND2MAX,0:NDOSCI,0:NDOSCI,1:NDKART),
     *                COEF01(0:ND2MAX,0:NDOSCI,0:NDOSCI,1:NDKART),
     *                COEF11(0:ND2MAX,0:NDOSCI,0:NDOSCI,1:NDKART),
     *                COEF02(0:ND2MAX,0:NDOSCI,0:NDOSCI,1:NDKART)
      COMMON
     *       /BLIMS1/ LAXOFY(0:NDYMAX),LAXOFZ(0:NDZMAX),
     *                LAYOFZ(0:NDZMAX),LAYOFX(0:NDXMAX),
     *                LAZOFX(0:NDXMAX),LAZOFY(0:NDYMAX)
      COMMON
     *       /BLIMS2/ LAXOYZ(0:NDYMAX,0:NDZMAX),
     *                LAYOZX(0:NDZMAX,0:NDXMAX),
     *                LAZOXY(0:NDXMAX,0:NDYMAX)
      COMMON
     *       /DIMENS/ LDBASE
C
C=======================================================================
C         THIS SUBROUTINE CALCULATES THE MATRIX ELEMENTS OF PX
C=======================================================================
C
      HAMLIN(:,:)=0.0D0
C
      SQ4_PI=SQRT(SQRT(4.0D0*ATAN(1.0D0)))
C
      FACACT= - SQ4_PI/SQRT(HOMSCA(1))*FACTOR
C
      DO NY=0,NYMAXX
         MY=NY
C
         DO NZ=0,LAZOFY(NY)
            MZ=NZ
C
            DO NX=0,LAXOYZ(NY,NZ)
               DO MX=MAX(0,NX-1),MIN(LAXOYZ(MY,MZ),NX+1)
C
                  HAMLIN(INDICE(NX,NY,NZ),INDICE(MX,MY,MZ))=
     *
     *            FACACT * IPHASE(NY,MY) * COEF01(0,NX,MX,1)
C
               END DO
            END DO
C
         END DO
C
      END DO
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE INT_PY(NXMAXX,NYMAXX,NZMAXX,IPHASE,HAMLIN,FACTOR)
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      DIMENSION
     *          IPHASE(0:NDYMAX,0:NDYMAX)
      DIMENSION
     *          HAMLIN(1:NDBASE,1:NDBASE)
C
      COMMON
     *       /SCALNG/ HOMSCA(NDKART)
C
      COMMON
     *       /BINDEX/ INDICE(0:NDXMAX,0:NDYMAX,0:NDZMAX)
C
      COMMON
     *       /COEXYZ/ COEF00(0:ND2MAX,0:NDOSCI,0:NDOSCI,1:NDKART),
     *                COEF01(0:ND2MAX,0:NDOSCI,0:NDOSCI,1:NDKART),
     *                COEF11(0:ND2MAX,0:NDOSCI,0:NDOSCI,1:NDKART),
     *                COEF02(0:ND2MAX,0:NDOSCI,0:NDOSCI,1:NDKART)
      COMMON
     *       /BLIMS1/ LAXOFY(0:NDYMAX),LAXOFZ(0:NDZMAX),
     *                LAYOFZ(0:NDZMAX),LAYOFX(0:NDXMAX),
     *                LAZOFX(0:NDXMAX),LAZOFY(0:NDYMAX)
      COMMON
     *       /BLIMS2/ LAXOYZ(0:NDYMAX,0:NDZMAX),
     *                LAYOZX(0:NDZMAX,0:NDXMAX),
     *                LAZOXY(0:NDXMAX,0:NDYMAX)
      COMMON
     *       /DIMENS/ LDBASE
C
C=======================================================================
C         THIS SUBROUTINE CALCULATES THE MATRIX ELEMENTS OF PY
C=======================================================================
C
      HAMLIN(:,:)=0.0D0
C
      SQ4_PI=SQRT(SQRT(4.0D0*ATAN(1.0D0)))
C
      FACACT= - SQ4_PI/SQRT(HOMSCA(2))*FACTOR
C
      DO NZ=0,NZMAXX
         MZ=NZ
C
         DO NX=0,LAXOFZ(NZ)
            MX=NX
C
            DO NY=0,LAYOZX(NZ,NX)
               DO MY=MAX(0,NY-1),MIN(LAYOZX(MZ,MX),NY+1)
C
                  HAMLIN(INDICE(NX,NY,NZ),INDICE(MX,MY,MZ))=
     *
     *            FACACT * IPHASE(NY,MY) * COEF01(0,NY,MY,2)
C
               END DO
            END DO
C
         END DO
C
      END DO
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE INT_PZ(NXMAXX,NYMAXX,NZMAXX,IPHASE,HAMLIN,FACTOR)
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      DIMENSION
     *          IPHASE(0:NDYMAX,0:NDYMAX)
      DIMENSION
     *          HAMLIN(1:NDBASE,1:NDBASE)
C
      COMMON
     *       /SCALNG/ HOMSCA(NDKART)
C
      COMMON
     *       /BINDEX/ INDICE(0:NDXMAX,0:NDYMAX,0:NDZMAX)
C
      COMMON
     *       /COEXYZ/ COEF00(0:ND2MAX,0:NDOSCI,0:NDOSCI,1:NDKART),
     *                COEF01(0:ND2MAX,0:NDOSCI,0:NDOSCI,1:NDKART),
     *                COEF11(0:ND2MAX,0:NDOSCI,0:NDOSCI,1:NDKART),
     *                COEF02(0:ND2MAX,0:NDOSCI,0:NDOSCI,1:NDKART)
      COMMON
     *       /BLIMS1/ LAXOFY(0:NDYMAX),LAXOFZ(0:NDZMAX),
     *                LAYOFZ(0:NDZMAX),LAYOFX(0:NDXMAX),
     *                LAZOFX(0:NDXMAX),LAZOFY(0:NDYMAX)
      COMMON
     *       /BLIMS2/ LAXOYZ(0:NDYMAX,0:NDZMAX),
     *                LAYOZX(0:NDZMAX,0:NDXMAX),
     *                LAZOXY(0:NDXMAX,0:NDYMAX)
      COMMON
     *       /DIMENS/ LDBASE
C
C=======================================================================
C         THIS SUBROUTINE CALCULATES THE MATRIX ELEMENTS OF PZ
C=======================================================================
C
      HAMLIN(:,:)=0.0D0
C
      SQ4_PI=SQRT(SQRT(4.0D0*ATAN(1.0D0)))
C
      FACACT= - SQ4_PI/SQRT(HOMSCA(3))*FACTOR
C
      DO NX=0,NXMAXX
         MX=NX
C
         DO NY=0,LAYOFX(NX)
            MY=NY
C
            DO NZ=0,LAZOXY(NX,NY)
               DO MZ=MAX(0,NZ-1),MIN(LAZOXY(MX,MY),NZ+1)
C
                  HAMLIN(INDICE(NX,NY,NZ),INDICE(MX,MY,MZ))=
     *
     *            FACACT * IPHASE(NY,MY) * COEF01(0,NZ,MZ,3)
C
               END DO
            END DO
C
         END DO
C
      END DO
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE INTPX2(NXMAXX,NYMAXX,NZMAXX,IPHASE,HAMLIN,FACTOR)
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      DIMENSION
     *          IPHASE(0:NDYMAX,0:NDYMAX)
      DIMENSION
     *          HAMLIN(1:NDBASE,1:NDBASE)
C
      COMMON
     *       /SCALNG/ HOMSCA(NDKART)
C
      COMMON
     *       /BINDEX/ INDICE(0:NDXMAX,0:NDYMAX,0:NDZMAX)
C
      COMMON
     *       /COEXYZ/ COEF00(0:ND2MAX,0:NDOSCI,0:NDOSCI,1:NDKART),
     *                COEF01(0:ND2MAX,0:NDOSCI,0:NDOSCI,1:NDKART),
     *                COEF11(0:ND2MAX,0:NDOSCI,0:NDOSCI,1:NDKART),
     *                COEF02(0:ND2MAX,0:NDOSCI,0:NDOSCI,1:NDKART)
      COMMON
     *       /BLIMS1/ LAXOFY(0:NDYMAX),LAXOFZ(0:NDZMAX),
     *                LAYOFZ(0:NDZMAX),LAYOFX(0:NDXMAX),
     *                LAZOFX(0:NDXMAX),LAZOFY(0:NDYMAX)
      COMMON
     *       /BLIMS2/ LAXOYZ(0:NDYMAX,0:NDZMAX),
     *                LAYOZX(0:NDZMAX,0:NDXMAX),
     *                LAZOXY(0:NDXMAX,0:NDYMAX)
      COMMON
     *       /DIMENS/ LDBASE
C
C=======================================================================
C         THIS SUBROUTINE CALCULATES THE MATRIX ELEMENTS OF PX SQUARED
C=======================================================================
C
      HAMLIN(:,:)=0.0D0
C
      SQ4_PI=SQRT(SQRT(4.0D0*ATAN(1.0D0)))
C
      FACACT= - SQ4_PI/SQRT(HOMSCA(1))*FACTOR
C
      DO NY=0,NYMAXX
         MY=NY
C
         DO NZ=0,LAZOFY(NY)
            MZ=NZ
C
            DO NX=0,LAXOYZ(NY,NZ)
               DO MX=MAX(0,NX-2),MIN(LAXOYZ(MY,MZ),NX+2)
C
                  HAMLIN(INDICE(NX,NY,NZ),INDICE(MX,MY,MZ))=
     *
     *            FACACT * IPHASE(NY,MY) * COEF02(0,NX,MX,1)
C
               END DO
            END DO
C
         END DO
C
      END DO
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE INTPY2(NXMAXX,NYMAXX,NZMAXX,IPHASE,HAMLIN,FACTOR)
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      DIMENSION
     *          IPHASE(0:NDYMAX,0:NDYMAX)
      DIMENSION
     *          HAMLIN(1:NDBASE,1:NDBASE)
C
      COMMON
     *       /SCALNG/ HOMSCA(NDKART)
C
      COMMON
     *       /BINDEX/ INDICE(0:NDXMAX,0:NDYMAX,0:NDZMAX)
C
      COMMON
     *       /COEXYZ/ COEF00(0:ND2MAX,0:NDOSCI,0:NDOSCI,1:NDKART),
     *                COEF01(0:ND2MAX,0:NDOSCI,0:NDOSCI,1:NDKART),
     *                COEF11(0:ND2MAX,0:NDOSCI,0:NDOSCI,1:NDKART),
     *                COEF02(0:ND2MAX,0:NDOSCI,0:NDOSCI,1:NDKART)
      COMMON
     *       /BLIMS1/ LAXOFY(0:NDYMAX),LAXOFZ(0:NDZMAX),
     *                LAYOFZ(0:NDZMAX),LAYOFX(0:NDXMAX),
     *                LAZOFX(0:NDXMAX),LAZOFY(0:NDYMAX)
      COMMON
     *       /BLIMS2/ LAXOYZ(0:NDYMAX,0:NDZMAX),
     *                LAYOZX(0:NDZMAX,0:NDXMAX),
     *                LAZOXY(0:NDXMAX,0:NDYMAX)
      COMMON
     *       /DIMENS/ LDBASE
C
C=======================================================================
C         THIS SUBROUTINE CALCULATES THE MATRIX ELEMENTS OF PY SQUARED
C=======================================================================
C
      HAMLIN(:,:)=0.0D0
C
      SQ4_PI=SQRT(SQRT(4.0D0*ATAN(1.0D0)))
C
      FACACT= - SQ4_PI/SQRT(HOMSCA(2))*FACTOR
C
      DO NZ=0,NZMAXX
         MZ=NZ
C
         DO NX=0,LAXOFZ(NZ)
            MX=NX
C
            DO NY=0,LAYOZX(NZ,NX)
               DO MY=MAX(0,NY-2),MIN(LAYOZX(MZ,MX),NY+2)
C
                  HAMLIN(INDICE(NX,NY,NZ),INDICE(MX,MY,MZ))=
     *
     *            FACACT * IPHASE(NY,MY) * COEF02(0,NY,MY,2)
C
               END DO
            END DO
C
         END DO
C
      END DO
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE INTPZ2(NXMAXX,NYMAXX,NZMAXX,IPHASE,HAMLIN,FACTOR)
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      DIMENSION
     *          IPHASE(0:NDYMAX,0:NDYMAX)
      DIMENSION
     *          HAMLIN(1:NDBASE,1:NDBASE)
C
      COMMON
     *       /SCALNG/ HOMSCA(NDKART)
C
      COMMON
     *       /BINDEX/ INDICE(0:NDXMAX,0:NDYMAX,0:NDZMAX)
C
      COMMON
     *       /COEXYZ/ COEF00(0:ND2MAX,0:NDOSCI,0:NDOSCI,1:NDKART),
     *                COEF01(0:ND2MAX,0:NDOSCI,0:NDOSCI,1:NDKART),
     *                COEF11(0:ND2MAX,0:NDOSCI,0:NDOSCI,1:NDKART),
     *                COEF02(0:ND2MAX,0:NDOSCI,0:NDOSCI,1:NDKART)
      COMMON
     *       /BLIMS1/ LAXOFY(0:NDYMAX),LAXOFZ(0:NDZMAX),
     *                LAYOFZ(0:NDZMAX),LAYOFX(0:NDXMAX),
     *                LAZOFX(0:NDXMAX),LAZOFY(0:NDYMAX)
      COMMON
     *       /BLIMS2/ LAXOYZ(0:NDYMAX,0:NDZMAX),
     *                LAYOZX(0:NDZMAX,0:NDXMAX),
     *                LAZOXY(0:NDXMAX,0:NDYMAX)
      COMMON
     *       /DIMENS/ LDBASE
C
C=======================================================================
C         THIS SUBROUTINE CALCULATES THE MATRIX ELEMENTS OF PZ SQUARED
C=======================================================================
C
      HAMLIN(:,:)=0.0D0
C
      SQ4_PI=SQRT(SQRT(4.0D0*ATAN(1.0D0)))
C
      FACACT= - SQ4_PI/SQRT(HOMSCA(3))*FACTOR
C
      DO NX=0,NXMAXX
         MX=NX
C
         DO NY=0,LAYOFX(NX)
            MY=NY
C
            DO NZ=0,LAZOXY(NX,NY)
               DO MZ=MAX(0,NZ-2),MIN(LAZOXY(MX,MY),NZ+2)
C
                  HAMLIN(INDICE(NX,NY,NZ),INDICE(MX,MY,MZ))=
     *
     *            FACACT * IPHASE(NY,MY) * COEF02(0,NZ,MZ,3)
C
               END DO
            END DO
C
         END DO
C
      END DO
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE READWS(INNUMB,IZNUMB,FCHOM0,R0PARM,HOMEGA,
     *                         NFIWOO,NXHERM,NYHERM,NZHERM,
     *                         EPSHER,NOSCIL,NLIMIT,ENECUT,
     *                                LAMMAX,ISOTRO,CVOLFC,
     *                                CMSXFC,CMSYFC,CMSZFC,
     *                                XMOMFC,YMOMFC,ZMOMFC,
     *                                       GPAIRN,GPAIRP)
C=======================================================================
      USE SPINOR
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      CHARACTER
     *          NAMEPN(0:NDISOS)*8
C
      COMPLEX
     *          ALPHAC(0:NDLAMB,-NDLAMB:+NDLAMB)
      COMPLEX
     *          BETBAS(0:NDLAMB,-NDLAMB:+NDLAMB)
C
      COMMON
     *       /BASISO/ NXVECT(1:NDBASE),NYVECT(1:NDBASE),NZVECT(1:NDBASE)
      COMMON
     *       /REALPH/ ALPHAR(0:NDLAMB,0:NDLAMB)
      COMMON
     *       /SPE_WS/ ESINWS(1:NDBASE,0:NDISOS)
      COMMON
     *       /BASPAR/ HBAROX,HBAROY,HBAROZ
      COMMON
     *       /BASE_2/ BASEX2,BASEY2,BASEZ2
      COMMON
     *       /DEFORM/ ALPHAC,IREALA
      COMMON
     *       /DIMENS/ LDBASE
      COMMON
     *       /PAIINI/ FERINI(0:NDISOS),DELINI(0:NDISOS),FE2INI(0:NDISOS)
      COMMON
     *       /CFIPRI/ NFIPRI
C
      DATA
     *     NAMEPN /'NEUTRONS',' PROTONS'/
C
C=======================================================================
C      At exit:
C       - ALPHAC contains the deformation of the WS potential
C       - ALPHAR contains the deformation of the HO basis used in WS
C         calculations. The same deformation will be used to define
C         properties of the HO basis in HFODD
C=======================================================================
      IALLOC=0
      IF (.NOT.ALLOCATED(WSWAVE))
     *    ALLOCATE (WSWAVE(1:NDBASE,1:NDBASE,0:NDISOS),STAT=IALLOC)
      IF (IALLOC.NE.0) CALL NOALLO('WSWAVE','READWS')
C=======================================================================
C
      DO L=0,NDLAMB
         DO M=-L,L
            ALPHAC(L,M)=CMPLX(0.0D0,0.0D0)
         END DO
         DO M=0,L
            ALPHAR(L,M)=0.0D0
         END DO
      END DO
C
      READ(NFIWOO)IZNUMB,INNUMB,LAMMAX,
     *          ((BETBAS(L,M),M=-L,+L),L=0,LAMMAX),
     *          ((ALPHAC(L,M),M=-L,+L),L=0,LAMMAX),
     *            NOSCIL,IPARAM,NROTAT,
     *            NXHERM,NYHERM,NZHERM,NXPOIN,NYPOIN,
     *            NLIMIT,HBAROX,HBAROY,HBAROZ,HOMEGA,FCHOM0,
     *            CMSXFC,CMSYFC,CMSZFC,XMOMFC,YMOMFC,ZMOMFC,
     *            BASEX2,BASEY2,BASEZ2,CVOLFC,R0PARM,ENECUT,
     *            IARRAY,LDBASE,ISOTRO,EPSHER,
     *            EFERMN,EFERMP,GPAIRN,GPAIRP,DELTAN,DELTAP
C
      FERINI(0)=EFERMN
      FERINI(1)=EFERMP
C
      DELINI(0)=DELTAN
      DELINI(1)=DELTAP
C
      IF (LDBASE.GT.NDBASE) THEN
          WRITE(NFIPRI,'(//,''LDBASE='',I6,'' EXCEEEDS NDBASE='',I6)')
     *                   LDBASE,NDBASE
          STOP 'LDBASE.GT.NDBASE'
      END IF
C
      DO L=0,LAMMAX
         DO M=-L,L
            IF (ABS(AIMAG(BETBAS(L,M))).GT.1.0E-10) THEN
                STOP 'COMPLEX DEFORMATION IN READWS'
            ELSE
                IF (M.GE.0) ALPHAR(L,M)=REAL(BETBAS(L,M))
            END IF
         END DO
      END DO
C
      IREALA=1
C
      READ(NFIWOO)(ESINWS(I,0),I=1,LDBASE)
C
      READ(NFIWOO)(ESINWS(I,1),I=1,LDBASE)
C
      IF (IARRAY.EQ.1) THEN
          READ(NFIWOO) (((WSWAVE(I,J,ICHARG),I=1,LDBASE),
     *                                       J=1,LDBASE),
     *                                  ICHARG=0,NDISOS)
          READ(NFIWOO)( NXVECT(I),NYVECT(I),NZVECT(I), I=1,LDBASE)
      END IF
C
      CALL TABDEF(LAMMAX)
C
      WRITE(NFIPRI,'(79(1H*),/,1H*,77X,1H*,/,
     *      1H*,2X,
     *      ''N ='',I3,     ''  Z ='',I3,8X,''  LDBASE ='',I5,
     *   ''    NMAX ='',I2,''  IPARAM ='',I2,''  NROTAT ='',I2,2X,1H*,/,
     *      1H*,39X,
     *   ''  NXHERM ='',I2,''  NYHERM ='',I2,''  NZHERM ='',I2,2X,1H*,/,
     *      1H*,39X,
     *   ''  NXPOIN ='',I2,''  NYPOIN ='',I2,''          '',2X,2X,1H*,/,
     *      1H*,77X,1H*)')
     *
     *      INNUMB,IZNUMB,LDBASE,NOSCIL,IPARAM,NROTAT,
     *                           NXHERM,NYHERM,NZHERM,
     *                           NXPOIN,NYPOIN
C
      WRITE(NFIPRI,'(79(1H*),/,1H*,77X,1H*,/,
     *      1H*,24X,
     *      ''  HBAROX ='',F7.3,''  HBAROY ='',F7.3,''  HBAROZ ='',F7.3,
     *      2X,1H*,/,
     *      1H*,77X,1H*,/,
     *      1H*,24X,
     *      ''  XMOMFC ='',F7.3,''  YMOMFC ='',F7.3,''  ZMOMFC ='',F7.3,
     *      2X,1H*,/,
     *      1H*,77X,1H*,/,
     *      1H*,24X,
     *      ''  CMSXFC ='',F7.3,''  CMSYFC ='',F7.3,''  CMSZFC ='',F7.3,
     *      2X,1H*,/,
     *      1H*,77X,1H*,/,
     *      79(1H*),/)')
     *
     *      HBAROX,HBAROY,HBAROZ,
     *      XMOMFC,YMOMFC,ZMOMFC,
     *      CMSXFC,CMSYFC,CMSZFC
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE FLISIG(MREVER)
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      CHARACTER
     *          PARNAM(0:NDISOS)*4,PLUMIN(0:1)*1
C
      DIMENSION
     *          DIALIG(1:NDSTAT,0:NDPARI,0:NDREVE,0:NDISOS),
     *          DISPAL(1:NDSTAT,0:NDPARI,0:NDREVE,0:NDISOS)
      DIMENSION
     *          DPALIG(0:NDPARI,0:NDREVE,0:NDISOS),
     *          DPSPAL(0:NDPARI,0:NDREVE,0:NDISOS),
     *          DHALIG(0:NDPARI,0:NDREVE,0:NDISOS),
     *          DHSPAL(0:NDPARI,0:NDREVE,0:NDISOS)
      DIMENSION
     *          IPALIG(0:NDPARI,0:NDREVE,0:NDISOS),
     *          IPSPAL(0:NDPARI,0:NDREVE,0:NDISOS),
     *          IHALIG(0:NDPARI,0:NDREVE,0:NDISOS),
     *          IHSPAL(0:NDPARI,0:NDREVE,0:NDISOS)
C
      COMMON
     *       /SPLEVS/ SPENER(1:2*NDSTAT,0:NDISOS),
     *                SPOCCU(1:2*NDSTAT,0:NDISOS),
     *                SPALIG(1:2*NDSTAT,0:NDISOS),
     *                SPSPAL(1:2*NDSTAT,0:NDISOS),
     *                SPPARI(1:2*NDSTAT,0:NDISOS),
     *                SPSIMP(1:2*NDSTAT,0:NDISOS)
      COMMON
     *       /SPLOLD/ OLALIG(1:2*NDSTAT,0:NDISOS),
     *                OLSPAL(1:2*NDSTAT,0:NDISOS),
     *                OLPARI(1:2*NDSTAT,0:NDISOS)
      COMMON
     *       /SIGOCC/ N_OCCU(1:NDSTAT,0:NDPARI,0:NDREVE,0:NDISOS),
     *                N_VACC(1:NDSTAT,0:NDPARI,0:NDREVE,0:NDISOS)
      COMMON
     *       /SPNUMS/ NUMBSP(0:NDREVE,0:NDISOS)
      COMMON
     *       /CFIPRI/ NFIPRI
C
      DATA
     *       PARNAM /'NEUT','PROT'/,
     *       PLUMIN /'+'   ,'-'   /
C
C=======================================================================
C
C        THIS SUBROUTINE IS CALLED IN THE CASE OF THE SIGNATURE SYMMETRY
C        AND FINDS THE SINGLE PARTICLE  STATES  WHICH  HAVE  ALTERNATING
C        PROPERTIES FROM ONE ITERATION TO ANOTHER.
C
C        ATTENTION: THIS SUBROUTINE MUST KNOW THE  SINGLE-PARTICLE
C                   PROPERTIES IN THE PREVIOUS ITERATION. THE USER
C                   IS RESPONSIBLE FOR NOT CALLING IT IN THE FIRST
C                   ITERATION.
C
C=======================================================================
C
C=======================================================================
C        RETRIEVING VALUES OF ALIGNMENTS OBTAINED IN THE PREVIOUS
C        ITERATION
C=======================================================================
C
      DO IREVER=0,MREVER
         DO ICHARG=0,NDISOS
C
            NPAPLU=0
            NPAMIN=0
C
            DO ISTATE=1,NUMBSP(IREVER,ICHARG)
C
               IF (OLPARI(ISTATE+IREVER*NUMBSP(0,ICHARG),ICHARG).GT.0.0)
     *                                                              THEN
C
                   NPAPLU=NPAPLU+1
C
                   DIALIG(NPAPLU,0,IREVER,ICHARG)=
     *               OLALIG(ISTATE+IREVER*NUMBSP(0,ICHARG),ICHARG)
C
                   DISPAL(NPAPLU,0,IREVER,ICHARG)=
     *               OLSPAL(ISTATE+IREVER*NUMBSP(0,ICHARG),ICHARG)
C
               ELSE
C
                   NPAMIN=NPAMIN+1
C
                   DIALIG(NPAMIN,1,IREVER,ICHARG)=
     *               OLALIG(ISTATE+IREVER*NUMBSP(0,ICHARG),ICHARG)
C
                   DISPAL(NPAMIN,1,IREVER,ICHARG)=
     *               OLSPAL(ISTATE+IREVER*NUMBSP(0,ICHARG),ICHARG)
C
               END IF
C
            END DO
C
         END DO
      END DO
C
C=======================================================================
C        DETERMINING ABSOLUTE VALUES OF DIFFERENCES OF ALIGNMENTS
C        BETWEEN THE PREVIOUS AND CURRENT ITERATIONS
C=======================================================================
C
      DO IREVER=0,MREVER
         DO ICHARG=0,NDISOS
C
            NPAPLU=0
            NPAMIN=0
C
            DO ISTATE=1,NUMBSP(IREVER,ICHARG)
C
               IF (SPPARI(ISTATE+IREVER*NUMBSP(0,ICHARG),ICHARG).GT.0.0)
     *                                                              THEN
C
                   NPAPLU=NPAPLU+1
C
                   DIALIG(NPAPLU,0,IREVER,ICHARG)=
     *                              ABS(DIALIG(NPAPLU,0,IREVER,ICHARG)-
     *                    SPALIG(ISTATE+IREVER*NUMBSP(0,ICHARG),ICHARG))
C
                   DISPAL(NPAPLU,0,IREVER,ICHARG)=
     *                              ABS(DISPAL(NPAPLU,0,IREVER,ICHARG)-
     *                    SPSPAL(ISTATE+IREVER*NUMBSP(0,ICHARG),ICHARG))
C
               ELSE
C
                   NPAMIN=NPAMIN+1
C
                   DIALIG(NPAMIN,1,IREVER,ICHARG)=
     *                              ABS(DIALIG(NPAMIN,1,IREVER,ICHARG)-
     *                    SPALIG(ISTATE+IREVER*NUMBSP(0,ICHARG),ICHARG))
C
                   DISPAL(NPAMIN,1,IREVER,ICHARG)=
     *                              ABS(DISPAL(NPAMIN,1,IREVER,ICHARG)-
     *                    SPSPAL(ISTATE+IREVER*NUMBSP(0,ICHARG),ICHARG))
C
               END IF
C
            END DO
C
         END DO
      END DO
C
C=======================================================================
C         INITIALIZING ARRAYS OF MAXIMUM DIFFERENCES
C=======================================================================
C
      DO IPARIT=0,NDPARI
         DO IREVER=0,MREVER
            DO ICHARG=0,NDISOS
C
               DPALIG(IPARIT,IREVER,ICHARG)=-1.0
               DPSPAL(IPARIT,IREVER,ICHARG)=-1.0
               DHALIG(IPARIT,IREVER,ICHARG)=-1.0
               DHSPAL(IPARIT,IREVER,ICHARG)=-1.0
C
               IPALIG(IPARIT,IREVER,ICHARG)=-1
               IPSPAL(IPARIT,IREVER,ICHARG)=-1
               IHALIG(IPARIT,IREVER,ICHARG)=-1
               IHSPAL(IPARIT,IREVER,ICHARG)=-1
C
            END DO
         END DO
      END DO
C
C=======================================================================
C        DETERMINING MAXIMUM DIFFERENCES OF ALIGNMENTS IN THE
C        CHARGE-PARITY-SIGNATURE BLOCKS
C=======================================================================
C
      DO IREVER=0,MREVER
         DO ICHARG=0,NDISOS
C
            NPAPLU=0
            NPAMIN=0
C
            DO ISTATE=1,NUMBSP(IREVER,ICHARG)
C
               IF (SPPARI(ISTATE+IREVER*NUMBSP(0,ICHARG),ICHARG).GT.0.0)
     *                                                              THEN
C
                   NPAPLU=NPAPLU+1
C
C=======================================================================
C              ANGULAR MOMENTUM ALIGNMENT IN THE POSITIVE-PARITY BLOCK
C              FOR PARTICLE (UNOCCUPIED) STATES
C=======================================================================
C
                   IF (DIALIG(NPAPLU,0,IREVER,ICHARG).GE.
     *                 DPALIG(       0,IREVER,ICHARG).AND.
     *                 N_OCCU(NPAPLU,0,IREVER,ICHARG).EQ.0) THEN
C
                       DPALIG(       0,IREVER,ICHARG)=
     *                 DIALIG(NPAPLU,0,IREVER,ICHARG)
C
                       IPALIG(       0,IREVER,ICHARG)=NPAPLU
C
                   END IF
C
C=======================================================================
C              ANGULAR MOMENTUM ALIGNMENT IN THE POSITIVE-PARITY BLOCK
C              FOR HOLE (OCCUPIED) STATES
C=======================================================================
C
                   IF (DIALIG(NPAPLU,0,IREVER,ICHARG).GE.
     *                 DHALIG(       0,IREVER,ICHARG).AND.
     *                 N_OCCU(NPAPLU,0,IREVER,ICHARG).EQ.1) THEN
C
                       DHALIG(       0,IREVER,ICHARG)=
     *                 DIALIG(NPAPLU,0,IREVER,ICHARG)
C
                       IHALIG(       0,IREVER,ICHARG)=NPAPLU
C
                   END IF
C
C=======================================================================
C              INTRINSIC SPIN ALIGNMENT IN THE POSITIVE-PARITY BLOCK
C              FOR PARTICLE (UNOCCUPIED) STATES
C=======================================================================
C
                   IF (DISPAL(NPAPLU,0,IREVER,ICHARG).GE.
     *                 DPSPAL(       0,IREVER,ICHARG).AND.
     *                 N_OCCU(NPAPLU,0,IREVER,ICHARG).EQ.0) THEN
C
                       DPSPAL(       0,IREVER,ICHARG)=
     *                 DISPAL(NPAPLU,0,IREVER,ICHARG)
C
                       IPSPAL(       0,IREVER,ICHARG)=NPAPLU
C
                   END IF
C
C=======================================================================
C              INTRINSIC SPIN ALIGNMENT IN THE POSITIVE-PARITY BLOCK
C              FOR HOLE (OCCUPIED) STATES
C=======================================================================
C
                   IF (DISPAL(NPAPLU,0,IREVER,ICHARG).GE.
     *                 DHSPAL(       0,IREVER,ICHARG).AND.
     *                 N_OCCU(NPAPLU,0,IREVER,ICHARG).EQ.1) THEN
C
                       DHSPAL(       0,IREVER,ICHARG)=
     *                 DISPAL(NPAPLU,0,IREVER,ICHARG)
C
                       IHSPAL(       0,IREVER,ICHARG)=NPAPLU
C
                   END IF
C
               ELSE
C
                   NPAMIN=NPAMIN+1
C
C=======================================================================
C              ANGULAR MOMENTUM ALIGNMENT IN THE NEGATIVE-PARITY BLOCK
C              FOR PARTICLE (UNOCCUPIED) STATES
C=======================================================================
C
                   IF (DIALIG(NPAMIN,1,IREVER,ICHARG).GE.
     *                 DPALIG(       1,IREVER,ICHARG).AND.
     *                 N_OCCU(NPAMIN,1,IREVER,ICHARG).EQ.0) THEN
C
                       DPALIG(       1,IREVER,ICHARG)=
     *                 DIALIG(NPAMIN,1,IREVER,ICHARG)
C
                       IPALIG(       1,IREVER,ICHARG)=NPAMIN
C
                   END IF
C
C=======================================================================
C              ANGULAR MOMENTUM ALIGNMENT IN THE NEGATIVE-PARITY BLOCK
C              FOR HOLE (OCCUPIED) STATES
C=======================================================================
C
                   IF (DIALIG(NPAMIN,1,IREVER,ICHARG).GE.
     *                 DHALIG(       1,IREVER,ICHARG).AND.
     *                 N_OCCU(NPAMIN,1,IREVER,ICHARG).EQ.1) THEN
C
                       DHALIG(       1,IREVER,ICHARG)=
     *                 DIALIG(NPAMIN,1,IREVER,ICHARG)
C
                       IHALIG(       1,IREVER,ICHARG)=NPAMIN
C
                   END IF
C
C=======================================================================
C              INTRINSIC SPIN ALIGNMENT IN THE NEGATIVE-PARITY BLOCK
C              FOR PARTICLE (UNOCCUPIED) STATES
C=======================================================================
C
                   IF (DISPAL(NPAMIN,1,IREVER,ICHARG).GE.
     *                 DPSPAL(       1,IREVER,ICHARG).AND.
     *                 N_OCCU(NPAMIN,1,IREVER,ICHARG).EQ.0) THEN
C
                       DPSPAL(       1,IREVER,ICHARG)=
     *                 DISPAL(NPAMIN,1,IREVER,ICHARG)
C
                       IPSPAL(       1,IREVER,ICHARG)=NPAMIN
C
                   END IF
C
C=======================================================================
C              INTRINSIC SPIN ALIGNMENT IN THE NEGATIVE-PARITY BLOCK
C              FOR HOLE (OCCUPIED) STATES
C=======================================================================
C
                   IF (DISPAL(NPAMIN,1,IREVER,ICHARG).GE.
     *                 DHSPAL(       1,IREVER,ICHARG).AND.
     *                 N_OCCU(NPAMIN,1,IREVER,ICHARG).EQ.1) THEN
C
                       DHSPAL(       1,IREVER,ICHARG)=
     *                 DISPAL(NPAMIN,1,IREVER,ICHARG)
C
                       IHSPAL(       1,IREVER,ICHARG)=NPAMIN
C
                   END IF
C
               END IF
C
            END DO
C
         END DO
      END DO
C
C=======================================================================
C         PRINTING THE MAXIMUM ALIGNMENTS
C=======================================================================
C
      WRITE(NFIPRI,'(
     *          1H*,1X,'' TABLE BELOW GIVES THE MAXIMUM ABSOLUT'',
     *                 ''E VALUES OF DIFFERENCES OF ALIGNMENT  '',1H*,/,
     *          1H*,1X,'' BETWEEN THE LAST TWO ITERATIONS. IT M'',
     *                 ''AY SERVE AS A GUIDE TO SELECT STATES  '',1H*,/,
     *          1H*,1X,'' WHICH EXCHANGE WAVE FUNCTIONS IN EVER'',
     *                 ''Y SECOND ITERATION.  SUCH STATES MAY  '',1H*,/,
     *          1H*,1X,'' BE CANDIDATES FOR A CALCULATION WITH '',
     *                 ''DIABATICALLY BLOCKED  CONFIGURATIONS  '',1H*,/,
     *          1H*,77X,1H*)')
C
      WRITE(NFIPRI,'(79(1H*),/,1H*,18X,1H*,58X,1H*,/,
     *         1H*,1X,''     BLOCKS      * ANGULAR MOMENTUM AL'',
     *                ''IGNMENT    INTRINSIC SPIN  ALIGNMENT  '',1H*,/,
     *         1H*,1X,''     ------      * -------------------'',
     *                ''-------    -------------------------  '',1H*,/,
     *         1H*,1X,''                 *   PARTICLES       H'',
     *                ''OLES        PARTICLES       HOLES     '',1H*,/,
     *         1H*,1X,'' ISO. PAR. SIG.  *  INDEX VALUE   INDE'',
     *                ''X VALUE    INDEX VALUE   INDEX VALUE  '',1H*,/,
     *         1H*,18X,1H*,58X,1H*,/,79(1H*),/,
     *         1H*,18X,1H*,58X,1H*,
     *     8(/,1H*,1X,A4,1X,2(2X,A1,2X),2X,
     *         1H*,2(2(I5,F8.3,1X),1X),1H*))')
     *
     *       (((PARNAM(ICHARG),PLUMIN(IPARIT),
     *          PLUMIN(IREVER*(1-IPARIT)+(1-IREVER)*IPARIT),
     *
     *          IPALIG(IPARIT,IREVER,ICHARG),
     *          DPALIG(IPARIT,IREVER,ICHARG),
     *          IHALIG(IPARIT,IREVER,ICHARG),
     *          DHALIG(IPARIT,IREVER,ICHARG),
     *          IPSPAL(IPARIT,IREVER,ICHARG),
     *          DPSPAL(IPARIT,IREVER,ICHARG),
     *          IHSPAL(IPARIT,IREVER,ICHARG),
     *          DHSPAL(IPARIT,IREVER,ICHARG),IREVER=0,MREVER),
     *                                       IPARIT=0,NDPARI),
     *                                       ICHARG=0,NDISOS)
C
      WRITE(NFIPRI,'(1H*,18X,1H*,58X,1H*,/,79(1H*))')
C
C=======================================================================
C        DETERMINING CANDIDATES FOR DIABATIC  BLOCKING  IN  ANY  OF  THE
C        CHARGE-PARITY-SIGNATURE BLOCKS.  A PAIR OF STATES IS CONSIDERED
C        TO BE A GOOD CANDIDATE FOR DIABATIC BLOCKING IF IT IS  COMPOSED
C        OF A PARTICLE AND A HOLE WITH ADJACENT INDICES.
C=======================================================================
C
      NUMCAN=0
C
      DO IPARIT=0,NDPARI
         DO IREVER=0,MREVER
            DO ICHARG=0,NDISOS
C
               IF (ABS(IPALIG(IPARIT,IREVER,ICHARG)-
     *                 IHALIG(IPARIT,IREVER,ICHARG)).EQ.1) THEN
C
C=======================================================================
C        A CANDIDATE PAIR OF STATES FOR DIABATIC BLOCKING BASED ON
C        ANGULAR MOMENTUM ALIGNMENT IS FOUND
C=======================================================================
C
                   NUMCAN=NUMCAN+1
C
                   IF (NUMCAN.EQ.1) THEN
C
                      WRITE(NFIPRI,'(1H*,77X,1H*,/,
     *                1H*,1X,''   FOLLOWS THE LIST OF CANDIDATE CONFI'',
     *                       ''GURATIONS FOR THE DIABATIC BLOCKING   '',
     *                1H*,/,
     *                1H*,77X,1H*,/,79(1H*),/,
     *                1H*,18X,1H*,58X,1H*)')
C
                   END IF
C
                   WRITE(NFIPRI,'(1H*,1X,A4,1X,2(2X,A1,2X),2X,
     *                            1H*,2(I5,F8.3,1X),1X,29X,1H*)')
     *
     *                   PARNAM(ICHARG),PLUMIN(IPARIT),
     *                   PLUMIN(IREVER*(1-IPARIT)+(1-IREVER)*IPARIT),
     *
     *                   IPALIG(IPARIT,IREVER,ICHARG),
     *                   DPALIG(IPARIT,IREVER,ICHARG),
     *                   IHALIG(IPARIT,IREVER,ICHARG),
     *                   DHALIG(IPARIT,IREVER,ICHARG)
C
               END IF
C
               IF (ABS(IPSPAL(IPARIT,IREVER,ICHARG)-
     *                 IHSPAL(IPARIT,IREVER,ICHARG)).EQ.1) THEN
C
C=======================================================================
C        A CANDIDATE PAIR OF STATES FOR DIABATIC BLOCKING BASED ON
C        INTRINSIC SPIN ALIGNMENT IS FOUND
C=======================================================================
C
                   NUMCAN=NUMCAN+1
C
                   IF (NUMCAN.EQ.1) THEN
C
                      WRITE(NFIPRI,'(1H*,77X,1H*,/,
     *                1H*,1X,''   FOLLOWS THE LIST OF CANDIDATE CONFI'',
     *                       ''GURATIONS FOR THE DIABATIC BLOCKING   '',
     *                1H*,/,
     *                1H*,77X,1H*,/,79(1H*),/,
     *                1H*,18X,1H*,58X,1H*)')
C
                   END IF
C
                   WRITE(NFIPRI,'(1H*,1X,A4,1X,2(2X,A1,2X),2X,
     *                            1H*,29X,2(I5,F8.3,1X),1X,1H*)')
     *
     *                   PARNAM(ICHARG),PLUMIN(IPARIT),
     *                   PLUMIN(IREVER*(1-IPARIT)+(1-IREVER)*IPARIT),
     *
     *                   IPSPAL(IPARIT,IREVER,ICHARG),
     *                   DPSPAL(IPARIT,IREVER,ICHARG),
     *                   IHSPAL(IPARIT,IREVER,ICHARG),
     *                   DHSPAL(IPARIT,IREVER,ICHARG)
C
               END IF
C
            END DO
         END DO
      END DO
C
      IF (NUMCAN.EQ.0) THEN
C
C=======================================================================
C        NO CANDIDATE PAIRS OF STATES FOR DIABATIC BLOCKING WERE FOUND
C=======================================================================
C
          WRITE(NFIPRI,'(1H*,77X,1H*,/,
     *         1H*,1X,''   NO GOOD CANDIDATE CONFIGURATIONS FO'',
     *                ''R THE DIABATIC BLOCKING WERE FOUND    '',1H*,/,
     *         1H*,77X,1H*,/,79(1H*))')
C
      ELSE
C
          WRITE(NFIPRI,'(1H*,18X,1H*,58X,1H*,/,79(1H*))')
C
      END IF
C
      WRITE(NFIPRI,'(1X)')
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE FLISIM(MREVER)
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      CHARACTER
     *          PARNAM(0:NDISOS)*7,PLUMIN(0:1)*1
C
      DIMENSION
     *          EIALIG(1:NDSTAT,0:NDREVE,0:NDISOS),
     *          EISPAL(1:NDSTAT,0:NDREVE,0:NDISOS)
      DIMENSION
     *          EPALIG(0:NDREVE,0:NDISOS),
     *          EPSPAL(0:NDREVE,0:NDISOS),
     *          EHALIG(0:NDREVE,0:NDISOS),
     *          EHSPAL(0:NDREVE,0:NDISOS)
      DIMENSION
     *          JPALIG(0:NDREVE,0:NDISOS),
     *          JPSPAL(0:NDREVE,0:NDISOS),
     *          JHALIG(0:NDREVE,0:NDISOS),
     *          JHSPAL(0:NDREVE,0:NDISOS)
C
      COMMON
     *       /SPLEVS/ SPENER(1:2*NDSTAT,0:NDISOS),
     *                SPOCCU(1:2*NDSTAT,0:NDISOS),
     *                SPALIG(1:2*NDSTAT,0:NDISOS),
     *                SPSPAL(1:2*NDSTAT,0:NDISOS),
     *                SPPARI(1:2*NDSTAT,0:NDISOS),
     *                SPSIMP(1:2*NDSTAT,0:NDISOS)
      COMMON
     *       /SPLOLD/ OLALIG(1:2*NDSTAT,0:NDISOS),
     *                OLSPAL(1:2*NDSTAT,0:NDISOS),
     *                OLPARI(1:2*NDSTAT,0:NDISOS)
      COMMON
     *       /SIMOCC/ L_OCCU(1:NDSTAT,0:NDREVE,0:NDISOS),
     *                L_VACC(1:NDSTAT,0:NDREVE,0:NDISOS)
      COMMON
     *       /SPNUMS/ NUMBSP(0:NDREVE,0:NDISOS)
      COMMON
     *       /CFIPRI/ NFIPRI
C
      DATA
     *       PARNAM /'NEUTRON','PROTON '/,
     *       PLUMIN /'+'      ,'-'      /
C
C=======================================================================
C
C        THIS SUBROUTINE IS CALLED IN THE CASE OF THE  SIMPLEX  SYMMETRY
C        AND FINDS THE SINGLE PARTICLE  STATES  WHICH  HAVE  ALTERNATING
C        PROPERTIES FROM ONE ITERATION TO ANOTHER.
C
C        ATTENTION: THIS SUBROUTINE MUST KNOW THE  SINGLE-PARTICLE
C                   PROPERTIES IN THE PREVIOUS ITERATION. THE USER
C                   IS RESPONSIBLE FOR NOT CALLING IT IN THE FIRST
C                   ITERATION.
C
C=======================================================================
C
C=======================================================================
C        DETERMINING ABSOLUTE VALUES OF DIFFERENCES OF ALIGNMENTS
C        BETWEEN THE PREVIOUS AND CURRENT ITERATIONS
C=======================================================================
C
      DO IREVER=0,MREVER
         DO ICHARG=0,NDISOS
            DO ISTATE=1,NUMBSP(IREVER,ICHARG)
C
               EIALIG(ISTATE,IREVER,ICHARG)=
     *                ABS(OLALIG(ISTATE+IREVER*NUMBSP(0,ICHARG),ICHARG)
     *                  - SPALIG(ISTATE+IREVER*NUMBSP(0,ICHARG),ICHARG))
C
               EISPAL(ISTATE,IREVER,ICHARG)=
     *                ABS(OLSPAL(ISTATE+IREVER*NUMBSP(0,ICHARG),ICHARG)
     *                  - SPSPAL(ISTATE+IREVER*NUMBSP(0,ICHARG),ICHARG))
C
            END DO
         END DO
      END DO
C
C=======================================================================
C         INITIALIZONG ARRAYS OF MAXIMUM DIFFERENCES
C=======================================================================
C
      DO IREVER=0,MREVER
         DO ICHARG=0,NDISOS
C
            EPALIG(IREVER,ICHARG)=-1.0
            EPSPAL(IREVER,ICHARG)=-1.0
            EHALIG(IREVER,ICHARG)=-1.0
            EHSPAL(IREVER,ICHARG)=-1.0
C
            JPALIG(IREVER,ICHARG)=-1
            JPSPAL(IREVER,ICHARG)=-1
            JHALIG(IREVER,ICHARG)=-1
            JHSPAL(IREVER,ICHARG)=-1
C
         END DO
      END DO
C
C=======================================================================
C        DETERMINING MAXIMUM DIFFERENCES OF ALIGNMENTS IN THE
C        CHARGE-SIMPLEX BLOCKS
C=======================================================================
C
      DO IREVER=0,MREVER
         DO ICHARG=0,NDISOS
            DO ISTATE=1,NUMBSP(IREVER,ICHARG)
C
C=======================================================================
C           ANGULAR MOMENTUM ALIGNMENT FOR PARTICLE (UNOCCUPIED) STATES
C=======================================================================
C
               IF (EIALIG(ISTATE,IREVER,ICHARG).GE.
     *             EPALIG(       IREVER,ICHARG).AND.
     *             L_OCCU(ISTATE,IREVER,ICHARG).EQ.0) THEN
C
                   EPALIG(       IREVER,ICHARG)=
     *             EIALIG(ISTATE,IREVER,ICHARG)
C
                   JPALIG(       IREVER,ICHARG)=ISTATE
C
               END IF
C
C===================================================================
C           ANGULAR MOMENTUM ALIGNMENT FOR HOLE (OCCUPIED) STATES
C===================================================================
C
               IF (EIALIG(ISTATE,IREVER,ICHARG).GE.
     *             EHALIG(       IREVER,ICHARG).AND.
     *             L_OCCU(ISTATE,IREVER,ICHARG).EQ.1) THEN
C
                   EHALIG(       IREVER,ICHARG)=
     *             EIALIG(ISTATE,IREVER,ICHARG)
C
                   JHALIG(       IREVER,ICHARG)=ISTATE
C
               END IF
C
C===================================================================
C          INTRINSIC SPIN ALIGNMENT FOR PARTICLE (UNOCCUPIED) STATES
C===================================================================
C
               IF (EISPAL(ISTATE,IREVER,ICHARG).GE.
     *             EPSPAL(       IREVER,ICHARG).AND.
     *             L_OCCU(ISTATE,IREVER,ICHARG).EQ.0) THEN
C
                   EPSPAL(       IREVER,ICHARG)=
     *             EISPAL(ISTATE,IREVER,ICHARG)
C
                   JPSPAL(       IREVER,ICHARG)=ISTATE
C
               END IF
C
C===================================================================
C           INTRINSIC SPIN ALIGNMENT FOR HOLE (OCCUPIED) STATES
C===================================================================
C
               IF (EISPAL(ISTATE,IREVER,ICHARG).GE.
     *             EHSPAL(       IREVER,ICHARG).AND.
     *             L_OCCU(ISTATE,IREVER,ICHARG).EQ.1) THEN
C
                   EHSPAL(       IREVER,ICHARG)=
     *             EISPAL(ISTATE,IREVER,ICHARG)
C
                   JHSPAL(       IREVER,ICHARG)=ISTATE
C
               END IF
C
            END DO
         END DO
      END DO
C
C=======================================================================
C         PRINTING THE MAXIMUM ALIGNMENTS
C=======================================================================
C
      WRITE(NFIPRI,'(
     *          1H*,1X,'' TABLE BELOW GIVES THE MAXIMUM ABSOLUT'',
     *                 ''E VALUES OF DIFFERENCES OF ALIGNMENT  '',1H*,/,
     *          1H*,1X,'' BETWEEN THE LAST TWO ITERATIONS. IT M'',
     *                 ''AY SERVE AS A GUIDE TO SELECT STATES  '',1H*,/,
     *          1H*,1X,'' WHICH EXCHANGE WAVE FUNCTIONS IN EVER'',
     *                 ''Y SECOND ITERATION.  SUCH STATES MAY  '',1H*,/,
     *          1H*,1X,'' BE CANDIDATES FOR A CALCULATION WITH '',
     *                 ''DIABATICALLY BLOCKED  CONFIGURATIONS  '',1H*,/,
     *          1H*,77X,1H*)')
C
      WRITE(NFIPRI,'(79(1H*),/,1H*,18X,1H*,58X,1H*,/,
     *         1H*,1X,''     BLOCKS      * ANGULAR MOMENTUM AL'',
     *                ''IGNMENT    INTRINSIC SPIN  ALIGNMENT  '',1H*,/,
     *         1H*,1X,''     ------      * -------------------'',
     *                ''-------    -------------------------  '',1H*,/,
     *         1H*,1X,''                 *   PARTICLES       H'',
     *                ''OLES        PARTICLES       HOLES     '',1H*,/,
     *         1H*,1X,'' ISOSPIN SIMPLEX *  INDEX VALUE   INDE'',
     *                ''X VALUE    INDEX VALUE   INDEX VALUE  '',1H*,/,
     *         1H*,18X,1H*,58X,1H*,/,79(1H*),/,
     *         1H*,18X,1H*,58X,1H*,
     *     4(/,1H*,1X,A7,4X,A1,''i'',4X,
     *         1H*,2(2(I5,F8.3,1X),1X),1H*))')
     *
     *        ((PARNAM(ICHARG),PLUMIN(IREVER),
     *
     *          JPALIG(IREVER,ICHARG),
     *          EPALIG(IREVER,ICHARG),
     *          JHALIG(IREVER,ICHARG),
     *          EHALIG(IREVER,ICHARG),
     *          JPSPAL(IREVER,ICHARG),
     *          EPSPAL(IREVER,ICHARG),
     *          JHSPAL(IREVER,ICHARG),
     *          EHSPAL(IREVER,ICHARG),IREVER=0,MREVER),
     *                                ICHARG=0,NDISOS)
C
      WRITE(NFIPRI,'(1H*,18X,1H*,58X,1H*,/,79(1H*))')
C
C=======================================================================
C        DETERMINING CANDIDATES FOR DIABATIC BLOCKING IN ANY OF THE
C        CHARGE-SIMPLEX BLOCKS.   A  PAIR  OF  STATES IS CONSIDERED
C        TO BE A GOOD CANDIDATE FOR  DIABATIC  BLOCKING  IF  IT  IS
C        COMPOSED OF A PARTICLE AND A HOLE WITH ADJACENT INDICES.
C=======================================================================
C
      NUMCAN=0
C
      DO IREVER=0,MREVER
         DO ICHARG=0,NDISOS
C
            IF (ABS(JPALIG(IREVER,ICHARG)-
     *              JHALIG(IREVER,ICHARG)).EQ.1) THEN
C
C=======================================================================
C        A CANDIDATE PAIR OF STATES FOR DIABATIC BLOCKING BASED ON
C        ANGULAR MOMENTUM ALIGNMENT IS FOUND
C=======================================================================
C
                NUMCAN=NUMCAN+1
C
                IF (NUMCAN.EQ.1) THEN
C
                   WRITE(NFIPRI,'(1H*,77X,1H*,/,
     *             1H*,1X,''   FOLLOWS THE LIST OF CANDIDATE CONFI'',
     *                    ''GURATIONS FOR THE DIABATIC BLOCKING   '',
     *             1H*,/,
     *             1H*,77X,1H*,/,79(1H*),/,
     *             1H*,18X,1H*,58X,1H*)')
C
                END IF
C
                WRITE(NFIPRI,'(1H*,1X,A7,4X,A1,''i'',4X,
     *                         1H*,2(I5,F8.3,1X),1X,29X,1H*)')
     *
     *                PARNAM(ICHARG),PLUMIN(IREVER),
     *
     *                JPALIG(IREVER,ICHARG),
     *                EPALIG(IREVER,ICHARG),
     *                JHALIG(IREVER,ICHARG),
     *                EHALIG(IREVER,ICHARG)
C
            END IF
C
            IF (ABS(JPSPAL(IREVER,ICHARG)-
     *              JHSPAL(IREVER,ICHARG)).EQ.1) THEN
C
C=======================================================================
C           A CANDIDATE PAIR OF STATES FOR DIABATIC BLOCKING BASED ON
C           INTRINSIC SPIN ALIGNMENT IS FOUND
C=======================================================================
C
                NUMCAN=NUMCAN+1
C
                IF (NUMCAN.EQ.1) THEN
C
                   WRITE(NFIPRI,'(1H*,77X,1H*,/,
     *             1H*,1X,''   FOLLOWS THE LIST OF CANDIDATE CONFI'',
     *                    ''GURATIONS FOR THE DIABATIC BLOCKING   '',
     *             1H*,/,
     *             1H*,77X,1H*,/,79(1H*),/,
     *             1H*,18X,1H*,58X,1H*)')
C
                END IF
C
                WRITE(NFIPRI,'(1H*,1X,A7,4X,A1,''i'',4X,
     *                         1H*,29X,2(I5,F8.3,1X),1X,1H*)')
     *
     *                PARNAM(ICHARG),PLUMIN(IREVER),
     *
     *                JPSPAL(IREVER,ICHARG),
     *                EPSPAL(IREVER,ICHARG),
     *                JHSPAL(IREVER,ICHARG),
     *                EHSPAL(IREVER,ICHARG)
C
            END IF
C
         END DO
      END DO
C
      IF (NUMCAN.EQ.0) THEN
C
C=======================================================================
C        NO CANDIDATE PAIRS OF STATES FOR DIABATIC BLOCKING WERE FOUND
C=======================================================================
C
          WRITE(NFIPRI,'(1H*,77X,1H*,/,
     *         1H*,1X,''   NO GOOD CANDIDATE CONFIGURATIONS FO'',
     *                ''R THE DIABATIC BLOCKING WERE FOUND    '',1H*,/,
     *         1H*,77X,1H*,/,79(1H*))')
C
      ELSE
C
          WRITE(NFIPRI,'(1H*,18X,1H*,58X,1H*,/,79(1H*))')
C
      END IF
C
      WRITE(NFIPRI,'(1X)')
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE FLISIQ
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      CHARACTER
     *          PARNAM(0:NDISOS)*7,PLUMIN(0:1)*1
C
      DIMENSION
     *          EIALIG(1:2*NDSTAT,0:NDPARI,0:NDISOS),
     *          EISPAL(1:2*NDSTAT,0:NDPARI,0:NDISOS)
      DIMENSION
     *          EPALIG(0:NDPARI,0:NDISOS),
     *          EPSPAL(0:NDPARI,0:NDISOS),
     *          EHALIG(0:NDPARI,0:NDISOS),
     *          EHSPAL(0:NDPARI,0:NDISOS)
      DIMENSION
     *          JPALIG(0:NDPARI,0:NDISOS),
     *          JPSPAL(0:NDPARI,0:NDISOS),
     *          JHALIG(0:NDPARI,0:NDISOS),
     *          JHSPAL(0:NDPARI,0:NDISOS)
C
      COMMON
     *       /SPLEVS/ SPENER(1:2*NDSTAT,0:NDISOS),
     *                SPOCCU(1:2*NDSTAT,0:NDISOS),
     *                SPALIG(1:2*NDSTAT,0:NDISOS),
     *                SPSPAL(1:2*NDSTAT,0:NDISOS),
     *                SPPARI(1:2*NDSTAT,0:NDISOS),
     *                SPSIMP(1:2*NDSTAT,0:NDISOS)
      COMMON
     *       /SPLOLD/ OLALIG(1:2*NDSTAT,0:NDISOS),
     *                OLSPAL(1:2*NDSTAT,0:NDISOS),
     *                OLPARI(1:2*NDSTAT,0:NDISOS)
      COMMON
     *       /SIQOCC/ K_OCCU(1:2*NDSTAT,0:NDPARI,0:NDISOS),
     *                K_VACC(1:2*NDSTAT,0:NDPARI,0:NDISOS)
      COMMON
     *       /SPNUMS/ NUMBSP(0:NDREVE,0:NDISOS)
      COMMON
     *       /CFIPRI/ NFIPRI
C
      DATA
     *       PARNAM /'NEUTRON','PROTON '/,
     *       PLUMIN /'+'      ,'-'      /
C
C=======================================================================
C
C        THIS SUBROUTINE IS CALLED IN THE CASE OF THE  PARITY   SYMMETRY
C        AND FINDS THE SINGLE PARTICLE  STATES  WHICH  HAVE  ALTERNATING
C        PROPERTIES FROM ONE ITERATION TO ANOTHER.
C
C        ATTENTION: THIS SUBROUTINE MUST KNOW THE  SINGLE-PARTICLE
C                   PROPERTIES IN THE PREVIOUS ITERATION. THE USER
C                   IS RESPONSIBLE FOR NOT CALLING IT IN THE FIRST
C                   ITERATION.
C
C=======================================================================
C
C=======================================================================
C        DETERMINING ABSOLUTE VALUES OF DIFFERENCES OF ALIGNMENTS
C        BETWEEN THE PREVIOUS AND CURRENT ITERATIONS
C=======================================================================
C
      DO ICHARG=0,NDISOS
C
         NPAPLU=0
         NPAMIN=0
C
         DO ISTATE=1,NUMBSP(0,ICHARG)+NUMBSP(1,ICHARG)
C
            IF (SPPARI(ISTATE,ICHARG).GT.0.0) THEN
C
                NPAPLU=NPAPLU+1
C
                EIALIG(NPAPLU,0,ICHARG)=
     *             ABS(OLALIG(ISTATE,ICHARG) - SPALIG(ISTATE,ICHARG))
C
                EISPAL(NPAPLU,0,ICHARG)=
     *             ABS(OLSPAL(ISTATE,ICHARG) - SPSPAL(ISTATE,ICHARG))
C
            ELSE
C
                NPAMIN=NPAMIN+1
C
                EIALIG(NPAMIN,1,ICHARG)=
     *             ABS(OLALIG(ISTATE,ICHARG) - SPALIG(ISTATE,ICHARG))
C
                EISPAL(NPAMIN,1,ICHARG)=
     *             ABS(OLSPAL(ISTATE,ICHARG) - SPSPAL(ISTATE,ICHARG))
C
            END IF
C
         END DO
      END DO
C
C=======================================================================
C         INITIALIZING ARRAYS OF MAXIMUM DIFFERENCES
C=======================================================================
C
      DO IPARIT=0,NDPARI
         DO ICHARG=0,NDISOS
C
            EPALIG(IPARIT,ICHARG)=-1.0
            EPSPAL(IPARIT,ICHARG)=-1.0
            EHALIG(IPARIT,ICHARG)=-1.0
            EHSPAL(IPARIT,ICHARG)=-1.0
C
            JPALIG(IPARIT,ICHARG)=-1
            JPSPAL(IPARIT,ICHARG)=-1
            JHALIG(IPARIT,ICHARG)=-1
            JHSPAL(IPARIT,ICHARG)=-1
C
         END DO
      END DO
C
C=======================================================================
C        DETERMINING MAXIMUM DIFFERENCES OF ALIGNMENTS IN THE
C        CHARGE-SIMPLEX BLOCKS
C=======================================================================
C
      DO ICHARG=0,NDISOS
C
         NPAPLU=0
         NPAMIN=0
C
         DO ISTATE=1,NUMBSP(0,ICHARG)+NUMBSP(1,ICHARG)
C
            IF (SPPARI(ISTATE,ICHARG).GT.0.0) THEN
C
                NPAPLU=NPAPLU+1
C
C=======================================================================
C           ANGULAR MOMENTUM ALIGNMENT FOR PARTICLE (UNOCCUPIED) STATES
C=======================================================================
C
                IF (EIALIG(NPAPLU,0,ICHARG).GE.
     *              EPALIG(       0,ICHARG).AND.
     *              K_OCCU(NPAPLU,0,ICHARG).EQ.0) THEN
C
                    EPALIG(       0,ICHARG)=
     *              EIALIG(NPAPLU,0,ICHARG)
C
                    JPALIG(       0,ICHARG)=NPAPLU
C
                END IF
C
C===================================================================
C           ANGULAR MOMENTUM ALIGNMENT FOR HOLE (OCCUPIED) STATES
C===================================================================
C
                IF (EIALIG(NPAPLU,0,ICHARG).GE.
     *              EHALIG(       0,ICHARG).AND.
     *              K_OCCU(NPAPLU,0,ICHARG).EQ.1) THEN
C
                    EHALIG(       0,ICHARG)=
     *              EIALIG(NPAPLU,0,ICHARG)
C
                    JHALIG(       0,ICHARG)=NPAPLU
C
                END IF
C
C===================================================================
C          INTRINSIC SPIN ALIGNMENT FOR PARTICLE (UNOCCUPIED) STATES
C===================================================================
C
                IF (EISPAL(NPAPLU,0,ICHARG).GE.
     *              EPSPAL(       0,ICHARG).AND.
     *              K_OCCU(NPAPLU,0,ICHARG).EQ.0) THEN
C
                    EPSPAL(       0,ICHARG)=
     *              EISPAL(NPAPLU,0,ICHARG)
C
                    JPSPAL(       0,ICHARG)=NPAPLU
C
                END IF
C
C===================================================================
C           INTRINSIC SPIN ALIGNMENT FOR HOLE (OCCUPIED) STATES
C===================================================================
C
                IF (EISPAL(NPAPLU,0,ICHARG).GE.
     *              EHSPAL(       0,ICHARG).AND.
     *              K_OCCU(NPAPLU,0,ICHARG).EQ.1) THEN
C
                    EHSPAL(       0,ICHARG)=
     *              EISPAL(NPAPLU,0,ICHARG)
C
                    JHSPAL(       0,ICHARG)=NPAPLU
C
                END IF
C
            ELSE
C
                NPAMIN=NPAMIN+1
C
C=======================================================================
C           ANGULAR MOMENTUM ALIGNMENT FOR PARTICLE (UNOCCUPIED) STATES
C=======================================================================
C
                IF (EIALIG(NPAMIN,1,ICHARG).GE.
     *              EPALIG(       1,ICHARG).AND.
     *              K_OCCU(NPAMIN,1,ICHARG).EQ.0) THEN
C
                    EPALIG(       1,ICHARG)=
     *              EIALIG(NPAMIN,1,ICHARG)
C
                    JPALIG(       1,ICHARG)=NPAMIN
C
                END IF
C
C===================================================================
C           ANGULAR MOMENTUM ALIGNMENT FOR HOLE (OCCUPIED) STATES
C===================================================================
C
                IF (EIALIG(NPAMIN,1,ICHARG).GE.
     *              EHALIG(       1,ICHARG).AND.
     *              K_OCCU(NPAMIN,1,ICHARG).EQ.1) THEN
C
                    EHALIG(       1,ICHARG)=
     *              EIALIG(NPAMIN,1,ICHARG)
C
                    JHALIG(       1,ICHARG)=NPAMIN
C
                END IF
C
C===================================================================
C          INTRINSIC SPIN ALIGNMENT FOR PARTICLE (UNOCCUPIED) STATES
C===================================================================
C
                IF (EISPAL(NPAMIN,1,ICHARG).GE.
     *              EPSPAL(       1,ICHARG).AND.
     *              K_OCCU(NPAMIN,1,ICHARG).EQ.0) THEN
C
                    EPSPAL(       1,ICHARG)=
     *              EISPAL(NPAMIN,1,ICHARG)
C
                    JPSPAL(       1,ICHARG)=NPAMIN
C
                END IF
C
C===================================================================
C           INTRINSIC SPIN ALIGNMENT FOR HOLE (OCCUPIED) STATES
C===================================================================
C
                IF (EISPAL(NPAMIN,1,ICHARG).GE.
     *              EHSPAL(       1,ICHARG).AND.
     *              K_OCCU(NPAMIN,1,ICHARG).EQ.1) THEN
C
                    EHSPAL(       1,ICHARG)=
     *              EISPAL(NPAMIN,1,ICHARG)
C
                    JHSPAL(       1,ICHARG)=NPAMIN
C
                END IF
C
            END IF
C
         END DO
      END DO
C
C=======================================================================
C         PRINTING THE MAXIMUM ALIGNMENTS
C=======================================================================
C
      WRITE(NFIPRI,'(
     *          1H*,1X,'' TABLE BELOW GIVES THE MAXIMUM ABSOLUT'',
     *                 ''E VALUES OF DIFFERENCES OF ALIGNMENT  '',1H*,/,
     *          1H*,1X,'' BETWEEN THE LAST TWO ITERATIONS. IT M'',
     *                 ''AY SERVE AS A GUIDE TO SELECT STATES  '',1H*,/,
     *          1H*,1X,'' WHICH EXCHANGE WAVE FUNCTIONS IN EVER'',
     *                 ''Y SECOND ITERATION.  SUCH STATES MAY  '',1H*,/,
     *          1H*,1X,'' BE CANDIDATES FOR A CALCULATION WITH '',
     *                 ''DIABATICALLY BLOCKED  CONFIGURATIONS  '',1H*,/,
     *          1H*,77X,1H*)')
C
      WRITE(NFIPRI,'(79(1H*),/,1H*,18X,1H*,58X,1H*,/,
     *         1H*,1X,''     BLOCKS      * ANGULAR MOMENTUM AL'',
     *                ''IGNMENT    INTRINSIC SPIN  ALIGNMENT  '',1H*,/,
     *         1H*,1X,''     ------      * -------------------'',
     *                ''-------    -------------------------  '',1H*,/,
     *         1H*,1X,''                 *   PARTICLES       H'',
     *                ''OLES        PARTICLES       HOLES     '',1H*,/,
     *         1H*,1X,'' ISOSPIN  PARITY *  INDEX VALUE   INDE'',
     *                ''X VALUE    INDEX VALUE   INDEX VALUE  '',1H*,/,
     *         1H*,18X,1H*,58X,1H*,/,79(1H*),/,
     *         1H*,18X,1H*,58X,1H*,
     *     4(/,1H*,1X,A7,4X,''('',A1,'')'',3X,
     *         1H*,2(2(I5,F8.3,1X),1X),1H*))')
     *
     *        ((PARNAM(ICHARG),PLUMIN(IPARIT),
     *
     *          JPALIG(IPARIT,ICHARG),
     *          EPALIG(IPARIT,ICHARG),
     *          JHALIG(IPARIT,ICHARG),
     *          EHALIG(IPARIT,ICHARG),
     *          JPSPAL(IPARIT,ICHARG),
     *          EPSPAL(IPARIT,ICHARG),
     *          JHSPAL(IPARIT,ICHARG),
     *          EHSPAL(IPARIT,ICHARG),IPARIT=0,NDPARI),
     *                                ICHARG=0,NDISOS)
C
      WRITE(NFIPRI,'(1H*,18X,1H*,58X,1H*,/,79(1H*))')
C
C=======================================================================
C        DETERMINING CANDIDATES FOR DIABATIC BLOCKING IN ANY OF THE
C        CHARGE-PARITY  BLOCKS.   A  PAIR  OF  STATES IS CONSIDERED
C        TO BE A GOOD CANDIDATE FOR  DIABATIC  BLOCKING  IF  IT  IS
C        COMPOSED OF A PARTICLE AND A HOLE WITH ADJACENT INDICES.
C=======================================================================
C
      NUMCAN=0
C
      DO IPARIT=0,NDPARI
         DO ICHARG=0,NDISOS
C
            IF (ABS(JPALIG(IPARIT,ICHARG)-
     *              JHALIG(IPARIT,ICHARG)).EQ.1) THEN
C
C=======================================================================
C        A CANDIDATE PAIR OF STATES FOR DIABATIC BLOCKING BASED ON
C        ANGULAR MOMENTUM ALIGNMENT IS FOUND
C=======================================================================
C
                NUMCAN=NUMCAN+1
C
                IF (NUMCAN.EQ.1) THEN
C
                   WRITE(NFIPRI,'(1H*,77X,1H*,/,
     *             1H*,1X,''   FOLLOWS THE LIST OF CANDIDATE CONFI'',
     *                    ''GURATIONS FOR THE DIABATIC BLOCKING   '',
     *             1H*,/,
     *             1H*,77X,1H*,/,79(1H*),/,
     *             1H*,18X,1H*,58X,1H*)')
C
                END IF
C
                WRITE(NFIPRI,'(1H*,1X,A7,4X,A1,''1'',4X,
     *                         1H*,2(I5,F8.3,1X),1X,29X,1H*)')
     *
     *                PARNAM(ICHARG),PLUMIN(IPARIT),
     *
     *                JPALIG(IPARIT,ICHARG),
     *                EPALIG(IPARIT,ICHARG),
     *                JHALIG(IPARIT,ICHARG),
     *                EHALIG(IPARIT,ICHARG)
C
            END IF
C
            IF (ABS(JPSPAL(IPARIT,ICHARG)-
     *              JHSPAL(IPARIT,ICHARG)).EQ.1) THEN
C
C=======================================================================
C           A CANDIDATE PAIR OF STATES FOR DIABATIC BLOCKING BASED ON
C           INTRINSIC SPIN ALIGNMENT IS FOUND
C=======================================================================
C
                NUMCAN=NUMCAN+1
C
                IF (NUMCAN.EQ.1) THEN
C
                   WRITE(NFIPRI,'(1H*,77X,1H*,/,
     *             1H*,1X,''   FOLLOWS THE LIST OF CANDIDATE CONFI'',
     *                    ''GURATIONS FOR THE DIABATIC BLOCKING   '',
     *             1H*,/,
     *             1H*,77X,1H*,/,79(1H*),/,
     *             1H*,18X,1H*,58X,1H*)')
C
                END IF
C
                WRITE(NFIPRI,'(1H*,1X,A7,4X,A1,''1'',4X,
     *                         1H*,29X,2(I5,F8.3,1X),1X,1H*)')
     *
     *                PARNAM(ICHARG),PLUMIN(IPARIT),
     *
     *                JPSPAL(IPARIT,ICHARG),
     *                EPSPAL(IPARIT,ICHARG),
     *                JHSPAL(IPARIT,ICHARG),
     *                EHSPAL(IPARIT,ICHARG)
C
            END IF
C
         END DO
      END DO
C
      IF (NUMCAN.EQ.0) THEN
C
C=======================================================================
C        NO CANDIDATE PAIRS OF STATES FOR DIABATIC BLOCKING WERE FOUND
C=======================================================================
C
          WRITE(NFIPRI,'(1H*,77X,1H*,/,
     *         1H*,1X,''   NO GOOD CANDIDATE CONFIGURATIONS FO'',
     *                ''R THE DIABATIC BLOCKING WERE FOUND    '',1H*,/,
     *         1H*,77X,1H*,/,79(1H*))')
C
      ELSE
C
          WRITE(NFIPRI,'(1H*,18X,1H*,58X,1H*,/,79(1H*))')
C
      END IF
C
      WRITE(NFIPRI,'(1X)')
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE FLISIZ
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      CHARACTER
     *          PARNAM(0:NDISOS)*7
C
      DIMENSION
     *          EIALIG(1:2*NDSTAT,0:NDISOS),
     *          EISPAL(1:2*NDSTAT,0:NDISOS)
      DIMENSION
     *          EPALIG(0:NDISOS),
     *          EPSPAL(0:NDISOS),
     *          EHALIG(0:NDISOS),
     *          EHSPAL(0:NDISOS)
      DIMENSION
     *          JPALIG(0:NDISOS),
     *          JPSPAL(0:NDISOS),
     *          JHALIG(0:NDISOS),
     *          JHSPAL(0:NDISOS)
C
      COMMON
     *       /SPLEVS/ SPENER(1:2*NDSTAT,0:NDISOS),
     *                SPOCCU(1:2*NDSTAT,0:NDISOS),
     *                SPALIG(1:2*NDSTAT,0:NDISOS),
     *                SPSPAL(1:2*NDSTAT,0:NDISOS),
     *                SPPARI(1:2*NDSTAT,0:NDISOS),
     *                SPSIMP(1:2*NDSTAT,0:NDISOS)
      COMMON
     *       /SPLOLD/ OLALIG(1:2*NDSTAT,0:NDISOS),
     *                OLSPAL(1:2*NDSTAT,0:NDISOS),
     *                OLPARI(1:2*NDSTAT,0:NDISOS)
      COMMON
     *       /SIZOCC/ M_OCCU(1:2*NDSTAT,0:NDISOS),
     *                M_VACC(1:2*NDSTAT,0:NDISOS)
      COMMON
     *       /SPNUMS/ NUMBSP(0:NDREVE,0:NDISOS)
      COMMON
     *       /CFIPRI/ NFIPRI
C
      DATA
     *       PARNAM /'NEUTRON','PROTON '/
C
C=======================================================================
C
C        THIS SUBROUTINE IS CALLED IN THE CASE OF NON-CONSERVED  SIMPLEX
C        AND FINDS THE SINGLE PARTICLE  STATES  WHICH  HAVE  ALTERNATING
C        PROPERTIES FROM ONE ITERATION TO ANOTHER.
C
C        ATTENTION: THIS SUBROUTINE MUST KNOW THE  SINGLE-PARTICLE
C                   PROPERTIES IN THE PREVIOUS ITERATION. THE USER
C                   IS RESPONSIBLE FOR NOT CALLING IT IN THE FIRST
C                   ITERATION.
C
C=======================================================================
C
C=======================================================================
C        DETERMINING ABSOLUTE VALUES OF DIFFERENCES OF ALIGNMENTS
C        BETWEEN THE PREVIOUS AND CURRENT ITERATIONS
C=======================================================================
C
      DO ICHARG=0,NDISOS
         DO ISTATE=1,NUMBSP(0,ICHARG)+NUMBSP(1,ICHARG)
C
            EIALIG(ISTATE,ICHARG)=
     *             ABS(OLALIG(ISTATE,ICHARG) - SPALIG(ISTATE,ICHARG))
C
            EISPAL(ISTATE,ICHARG)=
     *             ABS(OLSPAL(ISTATE,ICHARG) - SPSPAL(ISTATE,ICHARG))
C
         END DO
      END DO
C
C=======================================================================
C         INITIALIZING ARRAYS OF MAXIMUM DIFFERENCES
C=======================================================================
C
      DO ICHARG=0,NDISOS
C
         EPALIG(ICHARG)=-1.0
         EPSPAL(ICHARG)=-1.0
         EHALIG(ICHARG)=-1.0
         EHSPAL(ICHARG)=-1.0
C
         JPALIG(ICHARG)=-1
         JPSPAL(ICHARG)=-1
         JHALIG(ICHARG)=-1
         JHSPAL(ICHARG)=-1
C
      END DO
C
C=======================================================================
C        DETERMINING MAXIMUM DIFFERENCES OF ALIGNMENTS IN THE
C        CHARGE BLOCKS
C=======================================================================
C
      DO ICHARG=0,NDISOS
         DO ISTATE=1,NUMBSP(0,ICHARG)+NUMBSP(1,ICHARG)
C
C=======================================================================
C           ANGULAR MOMENTUM ALIGNMENT FOR PARTICLE (UNOCCUPIED) STATES
C=======================================================================
C
            IF (EIALIG(ISTATE,ICHARG).GE.
     *          EPALIG(       ICHARG).AND.
     *          M_OCCU(ISTATE,ICHARG).EQ.0) THEN
C
                EPALIG(       ICHARG)=
     *          EIALIG(ISTATE,ICHARG)
C
                JPALIG(       ICHARG)=ISTATE
C
            END IF
C
C===================================================================
C           ANGULAR MOMENTUM ALIGNMENT FOR HOLE (OCCUPIED) STATES
C===================================================================
C
            IF (EIALIG(ISTATE,ICHARG).GE.
     *          EHALIG(       ICHARG).AND.
     *          M_OCCU(ISTATE,ICHARG).EQ.1) THEN
C
                EHALIG(       ICHARG)=
     *          EIALIG(ISTATE,ICHARG)
C
                JHALIG(       ICHARG)=ISTATE
C
            END IF
C
C===================================================================
C          INTRINSIC SPIN ALIGNMENT FOR PARTICLE (UNOCCUPIED) STATES
C===================================================================
C
            IF (EISPAL(ISTATE,ICHARG).GE.
     *          EPSPAL(       ICHARG).AND.
     *          M_OCCU(ISTATE,ICHARG).EQ.0) THEN
C
                EPSPAL(       ICHARG)=
     *          EISPAL(ISTATE,ICHARG)
C
                JPSPAL(       ICHARG)=ISTATE
C
            END IF
C
C===================================================================
C           INTRINSIC SPIN ALIGNMENT FOR HOLE (OCCUPIED) STATES
C===================================================================
C
            IF (EISPAL(ISTATE,ICHARG).GE.
     *          EHSPAL(       ICHARG).AND.
     *          M_OCCU(ISTATE,ICHARG).EQ.1) THEN
C
                EHSPAL(       ICHARG)=
     *          EISPAL(ISTATE,ICHARG)
C
                JHSPAL(       ICHARG)=ISTATE
C
            END IF
C
         END DO
      END DO
C
C=======================================================================
C         PRINTING THE MAXIMUM ALIGNMENTS
C=======================================================================
C
      WRITE(NFIPRI,'(
     *          1H*,1X,'' TABLE BELOW GIVES THE MAXIMUM ABSOLUT'',
     *                 ''E VALUES OF DIFFERENCES OF ALIGNMENT  '',1H*,/,
     *          1H*,1X,'' BETWEEN THE LAST TWO ITERATIONS. IT M'',
     *                 ''AY SERVE AS A GUIDE TO SELECT STATES  '',1H*,/,
     *          1H*,1X,'' WHICH EXCHANGE WAVE FUNCTIONS IN EVER'',
     *                 ''Y SECOND ITERATION.  SUCH STATES MAY  '',1H*,/,
     *          1H*,1X,'' BE CANDIDATES FOR A CALCULATION WITH '',
     *                 ''DIABATICALLY BLOCKED  CONFIGURATIONS  '',1H*,/,
     *          1H*,77X,1H*)')
C
      WRITE(NFIPRI,'(79(1H*),/,1H*,18X,1H*,58X,1H*,/,
     *         1H*,1X,''     BLOCKS      * ANGULAR MOMENTUM AL'',
     *                ''IGNMENT    INTRINSIC SPIN  ALIGNMENT  '',1H*,/,
     *         1H*,1X,''     ------      * -------------------'',
     *                ''-------    -------------------------  '',1H*,/,
     *         1H*,1X,''                 *   PARTICLES       H'',
     *                ''OLES        PARTICLES       HOLES     '',1H*,/,
     *         1H*,1X,'' ISOSPIN SIMPLEX *  INDEX VALUE   INDE'',
     *                ''X VALUE    INDEX VALUE   INDEX VALUE  '',1H*,/,
     *         1H*,18X,1H*,58X,1H*,/,79(1H*),/,
     *         1H*,18X,1H*,58X,1H*,
     *     2(/,1H*,1X,A7,6X,4X,
     *         1H*,2(2(I5,F8.3,1X),1X),1H*))')
     *
     *         (PARNAM(ICHARG),
     *
     *          JPALIG(ICHARG),
     *          EPALIG(ICHARG),
     *          JHALIG(ICHARG),
     *          EHALIG(ICHARG),
     *          JPSPAL(ICHARG),
     *          EPSPAL(ICHARG),
     *          JHSPAL(ICHARG),
     *          EHSPAL(ICHARG),ICHARG=0,NDISOS)
C
      WRITE(NFIPRI,'(1H*,18X,1H*,58X,1H*,/,79(1H*))')
C
C=======================================================================
C        DETERMINING CANDIDATES FOR DIABATIC BLOCKING IN ANY OF THE
C        CHARGE-SIMPLEX BLOCKS.   A  PAIR  OF  STATES IS CONSIDERED
C        TO BE A GOOD CANDIDATE FOR  DIABATIC  BLOCKING  IF  IT  IS
C        COMPOSED OF A PARTICLE AND A HOLE WITH ADJACENT INDICES.
C=======================================================================
C
      NUMCAN=0
C
      DO ICHARG=0,NDISOS
C
         IF (ABS(JPALIG(ICHARG)-
     *           JHALIG(ICHARG)).EQ.1) THEN
C
C=======================================================================
C        A CANDIDATE PAIR OF STATES FOR DIABATIC BLOCKING BASED ON
C        ANGULAR MOMENTUM ALIGNMENT IS FOUND
C=======================================================================
C
             NUMCAN=NUMCAN+1
C
             IF (NUMCAN.EQ.1) THEN
C
                WRITE(NFIPRI,'(1H*,77X,1H*,/,
     *          1H*,1X,''   FOLLOWS THE LIST OF CANDIDATE CONFI'',
     *                 ''GURATIONS FOR THE DIABATIC BLOCKING   '',
     *          1H*,/,
     *          1H*,77X,1H*,/,79(1H*),/,
     *          1H*,18X,1H*,58X,1H*)')
C
             END IF
C
             WRITE(NFIPRI,'(1H*,1X,A7,6X,4X,
     *                      1H*,2(I5,F8.3,1X),1X,29X,1H*)')
     *
     *             PARNAM(ICHARG),
     *
     *             JPALIG(ICHARG),
     *             EPALIG(ICHARG),
     *             JHALIG(ICHARG),
     *             EHALIG(ICHARG)
C
         END IF
C
         IF (ABS(JPSPAL(ICHARG)-
     *           JHSPAL(ICHARG)).EQ.1) THEN
C
C=======================================================================
C           A CANDIDATE PAIR OF STATES FOR DIABATIC BLOCKING BASED ON
C           INTRINSIC SPIN ALIGNMENT IS FOUND
C=======================================================================
C
             NUMCAN=NUMCAN+1
C
             IF (NUMCAN.EQ.1) THEN
C
                WRITE(NFIPRI,'(1H*,77X,1H*,/,
     *          1H*,1X,''   FOLLOWS THE LIST OF CANDIDATE CONFI'',
     *                 ''GURATIONS FOR THE DIABATIC BLOCKING   '',
     *          1H*,/,
     *          1H*,77X,1H*,/,79(1H*),/,
     *          1H*,18X,1H*,58X,1H*)')
C
             END IF
C
             WRITE(NFIPRI,'(1H*,1X,A7,6X,4X,
     *                      1H*,29X,2(I5,F8.3,1X),1X,1H*)')
     *
     *             PARNAM(ICHARG),
     *
     *             JPSPAL(ICHARG),
     *             EPSPAL(ICHARG),
     *             JHSPAL(ICHARG),
     *             EHSPAL(ICHARG)
C
         END IF
C
      END DO
C
      IF (NUMCAN.EQ.0) THEN
C
C=======================================================================
C        NO CANDIDATE PAIRS OF STATES FOR DIABATIC BLOCKING WERE FOUND
C=======================================================================
C
          WRITE(NFIPRI,'(1H*,77X,1H*,/,
     *         1H*,1X,''   NO GOOD CANDIDATE CONFIGURATIONS FO'',
     *                ''R THE DIABATIC BLOCKING WERE FOUND    '',1H*,/,
     *         1H*,77X,1H*,/,79(1H*))')
C
      ELSE
C
          WRITE(NFIPRI,'(1H*,18X,1H*,58X,1H*,/,79(1H*))')
C
      END IF
C
      WRITE(NFIPRI,'(1X)')
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE CONSIG(MREVER,ICHARG,NUMNUC,EFERMI,
     *                         ICHFLI,IPAFLI,IREFLI,
     *                         ISPFLI,ISHFLI,IFLIPI)
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      DIMENSION
     *          EORDER(1:2*NDBASE),NORDER(1:2*NDBASE)
      DIMENSION
     *          OCCFIL(0:NDPARI,0:NDREVE)
C
      COMMON
     *       /SPLEVS/ SPENER(1:2*NDSTAT,0:NDISOS),
     *                SPOCCU(1:2*NDSTAT,0:NDISOS),
     *                SPALIG(1:2*NDSTAT,0:NDISOS),
     *                SPSPAL(1:2*NDSTAT,0:NDISOS),
     *                SPPARI(1:2*NDSTAT,0:NDISOS),
     *                SPSIMP(1:2*NDSTAT,0:NDISOS)
      COMMON
     *       /SPMOME/ SPMO20(1:2*NDSTAT,0:NDISOS),
     *                SPMO22(1:2*NDSTAT,0:NDISOS)
      COMMON
     *       /SIGOCC/ N_OCCU(1:NDSTAT,0:NDPARI,0:NDREVE,0:NDISOS),
     *                N_VACC(1:NDSTAT,0:NDPARI,0:NDREVE,0:NDISOS)
      COMMON
     *       /SIGFIL/ VFISIG(1:NDSTAT,0:NDPARI,0:NDREVE,0:NDISOS)
      COMMON
     *       /N_FILG/ NPFILG(0:NDPARI,0:NDREVE,0:NDISOS),
     *                NHFILG(0:NDPARI,0:NDREVE,0:NDISOS),
     *                NOFILG(0:NDPARI,0:NDREVE,0:NDISOS)
      COMMON
     *       /N_FLIG/ NPFLIG(0:NDPARI,0:NDREVE,0:NDISOS),
     *                NHFLIG(0:NDPARI,0:NDREVE,0:NDISOS),
     *                NOFLIG(0:NDPARI,0:NDREVE,0:NDISOS)
      COMMON
     *       /SIGNOC/ NOCSIG(0:NDPARI,0:NDREVE,0:NDISOS)
      COMMON
     *       /PROCCU/ V_OCCU(1:2*NDSTAT)
      COMMON
     *       /VACCNF/ IVACUM
      COMMON
     *       /SPNUMS/ NUMBSP(0:NDREVE,0:NDISOS)
      COMMON
     *       /CFIPRI/ NFIPRI
C
C=======================================================================
C
C        THIS SUBROUTINE IS CALLED IN THE CASE OF CONSERVATION OF THE
C        SIGNATURE SYMMETRY AND SETS THE OCCUPATION FACTORS ACCORDING
C        TO CHOSEN SIGNATURE CONFIGURATIONS ( IN CASE OF NO PAIRING ).
C        IT ALSO CALCULATES THE LOWEST SIGNATURE CONFIGURATIONS FOR A
C        GIVEN SINGLE-PARTICLE SPECTRUM.
C
C=======================================================================
C
C=======================================================================
C         ZEROING OCCUPATION FACTORS AND THE VACUUM CONFIGURATION DATA
C=======================================================================
C
      DO IREVER=0,NDREVE
C
         OCCFIL(0,IREVER)=0.0D0
         OCCFIL(1,IREVER)=0.0D0
C
         DO ISTATE=1,NUMBSP(IREVER,ICHARG)
C
            V_OCCU(ISTATE+IREVER*NUMBSP(0,ICHARG))=0.0
C
            N_VACC(ISTATE,0,IREVER,ICHARG)=0
            N_VACC(ISTATE,1,IREVER,ICHARG)=0
C
         END DO
C
      END DO
C
C=======================================================================
C         SETTING THE OCCUPATION FACTORS ACCORDING TO THE CONFIGURATION
C=======================================================================
C
      DO IREVER=0,MREVER
C
         NPAPLU=0
         NPAMIN=0
C
         OCCFIL(0,IREVER)=0.0D0
         OCCFIL(1,IREVER)=0.0D0
C
         DO ISTATE=1,NUMBSP(IREVER,ICHARG)
C
            IF (SPPARI(ISTATE+IREVER*NUMBSP(0,ICHARG),ICHARG).GT.0.0)
     *                                                              THEN
C
                NPAPLU=NPAPLU+1
C
                V_OCCU(ISTATE+IREVER*NUMBSP(0,ICHARG))=
     *                 N_OCCU(NPAPLU,0,IREVER,ICHARG)
C
                IF (NOFILG(0,IREVER,ICHARG).GE.1) THEN
C
                    IF (NPAPLU.GE.NHFILG(0,IREVER,ICHARG).AND.
     *                  NPAPLU.LE.NPFILG(0,IREVER,ICHARG))
     *
     *                  V_OCCU(ISTATE+IREVER*NUMBSP(0,ICHARG))=
     *                         VFISIG(NPAPLU,0,IREVER,ICHARG)
C
                END IF
C
                OCCFIL(0,IREVER)=OCCFIL(0,IREVER)
     *                        +V_OCCU(ISTATE+IREVER*NUMBSP(0,ICHARG))**2
C
            ELSE
C
                NPAMIN=NPAMIN+1
C
                V_OCCU(ISTATE+IREVER*NUMBSP(0,ICHARG))=
     *                 N_OCCU(NPAMIN,1,IREVER,ICHARG)
C
                IF (NOFILG(1,IREVER,ICHARG).GE.1) THEN
C
                    IF (NPAMIN.GE.NHFILG(1,IREVER,ICHARG).AND.
     *                  NPAMIN.LE.NPFILG(1,IREVER,ICHARG))
     *
     *                  V_OCCU(ISTATE+IREVER*NUMBSP(0,ICHARG))=
     *                         VFISIG(NPAMIN,1,IREVER,ICHARG)
C
                END IF
C
                OCCFIL(1,IREVER)=OCCFIL(1,IREVER)
     *                        +V_OCCU(ISTATE+IREVER*NUMBSP(0,ICHARG))**2
C
            END IF
C
         END DO
C
C=======================================================================
C         THE TEST BELOW ENSURES THAT THE NUMBER OF STATES KEPT AFTER
C         THE DIAGONALIZATION IS SUFFICIENT TO ACCOMODATE ALL  STATES
C         OCCUPIED IN EACH OF THE PARITY BLOCKS. THE TEST CAN ONLY BE
C         PERFORMED IN THIS PLACE, BECAUSE THE NUMBER OF STATES  KEPT
C         AFTER THE DIAGONALIZATION DEPENDS ON THE  ENERGY  SPECTRUM,
C         AND THE NUMBERS OF STATES KEPT IN EACH PARITY ARE NOT KNOWN
C         BEFORE THE SPECTRUM IS CALCULATED.
C=======================================================================
C         THE TEST BELOW CAN  BE  PERFORMED  ONLY  WHEN  THE  FILLING
C         APPROXIMATION HAS NOT BEEN REQUESTED
C=======================================================================
C
         IF (((NOFILG(0,0,ICHARG).LT.1 .AND.
     *        NOFILG(0,1,ICHARG).LT.1.OR.MREVER.EQ.0).AND.
     *      ABS(OCCFIL(0,IREVER)
     *         -NOCSIG(0,IREVER,ICHARG)).GT.1.0D-12.OR.
     *       (NOFILG(1,0,ICHARG).LT.1 .AND.
     *        NOFILG(1,1,ICHARG).LT.1.OR.MREVER.EQ.0).AND.
     *      ABS(OCCFIL(1,IREVER)
     *         -NOCSIG(1,IREVER,ICHARG)).GT.1.0D-12).AND.
     *          IVACUM.NE.1) THEN
C
             WRITE(NFIPRI,'(
     *            1X,20(1H/),''  MESSAGE FROM THE CONSIG SU'',
     *                       ''BROUTINE:'',      1X,20(1H/),/
     *            1X,20(1H/),''  INSUFFICIENT NUMBER  OF  M'',
     *                       ''EAN-FIELD'',      1X,20(1H/),/
     *            1X,20(1H/),''  STATES KEPT AFTER DIAGONAL'',
     *                       ''IZATION 1'',      1X,20(1H/),/
     *            1X,20(1H/),''  INCREASE THE  NUMBSP  MATR'',
     *                       ''IX IN THE'',      1X,20(1H/),/
     *            1X,20(1H/),''  INPUT DATA AND START AGAIN'',
     *                       ''         '',      1X,20(1H/),/)')
C
             STOP 'INSUFFICIENT NUMBER OF STATES KEPT (CONSIG)1'
C
         END IF
C
      END DO
C
C=======================================================================
C         THE TEST BELOW CAN BE PERFORMED IN CASE  WHEN  THE  FILLING
C         APPROXIMATION HAS BEEN REQUESTED
C=======================================================================
C
      IF ((((NOFILG(0,0,ICHARG).GE.1.OR.NOFILG(0,1,ICHARG).GE.1).AND.
     *                                              MREVER.EQ.1).AND.
     *   ABS(OCCFIL(0,0)+OCCFIL(0,1)
     *      -NOCSIG(0,0,ICHARG)-NOCSIG(0,1,ICHARG)).GT.1.0D-12.OR.
     *     ((NOFILG(1,0,ICHARG).GE.1.OR.NOFILG(1,1,ICHARG).GE.1).AND.
     *                                              MREVER.EQ.1).AND.
     *   ABS(OCCFIL(1,0)+OCCFIL(1,1)
     *      -NOCSIG(1,0,ICHARG)-NOCSIG(1,1,ICHARG)).GT.1.0D-12).AND.
     *          IVACUM.NE.1) THEN
C
          WRITE(NFIPRI,'(
     *         1X,20(1H/),''  MESSAGE FROM THE CONSIG SU'',
     *                    ''BROUTINE:'',      1X,20(1H/),/
     *         1X,20(1H/),''  INSUFFICIENT NUMBER  OF  M'',
     *                    ''EAN-FIELD'',      1X,20(1H/),/
     *         1X,20(1H/),''  STATES KEPT AFTER DIAGONAL'',
     *                    ''IZATION 4'',      1X,20(1H/),/
     *         1X,20(1H/),''  INCREASE THE  NUMBSP  MATR'',
     *                    ''IX IN THE'',      1X,20(1H/),/
     *         1X,20(1H/),''  INPUT DATA AND START AGAIN'',
     *                    ''         '',      1X,20(1H/),/)')
C
          STOP 'INSUFFICIENT NUMBER OF STATES KEPT (CONSIG)4'
C
      END IF
C
C=======================================================================
C         FLIPPING THE OCCUPATIONS WHEN REQUIRED TO CONSTRUCT THE
C         DIABATIC CONFIGURATIONS (SINGLE-PAIR CASE)
C=======================================================================
C
      IF (IFLIPI.NE.0) THEN
C
          DO IREVER=0,MREVER
C
             NPAPLU=0
             NPAMIN=0
C
             JSPFLI=0
             JSHFLI=0
C
             OBPFLI=0.0D0
             OBHFLI=0.0D0
C
             DO ISTATE=1,NUMBSP(IREVER,ICHARG)
C
C=======================================================================
C               FLIPPING IS BASED ON THE VALUES OF OBSERVABLES SELECTED
C               BY THE ABSOLUTE VALUE OF THE  "IFLIPI" CONTROL VARIABLE.
C               SEE COMMENTS IN SUBROUTINE NAMELI.
C=======================================================================
C
                IF (ABS(IFLIPI).EQ. 1)
     *              OBSFLI=SPALIG(ISTATE+IREVER*NUMBSP(0,ICHARG),ICHARG)
C
                IF (ABS(IFLIPI).EQ. 2)
     *              OBSFLI=SPSPAL(ISTATE+IREVER*NUMBSP(0,ICHARG),ICHARG)
C
                IF (ABS(IFLIPI).EQ. 9)
     *              OBSFLI=SPMO20(ISTATE+IREVER*NUMBSP(0,ICHARG),ICHARG)
C
                IF (ABS(IFLIPI).EQ.10)
     *              OBSFLI=SPMO22(ISTATE+IREVER*NUMBSP(0,ICHARG),ICHARG)
C
                IF (ABS(IFLIPI).GT.10.OR.
     *             (ABS(IFLIPI).GE. 3.AND.ABS(IFLIPI).LE.8))
     *              STOP ' IFLIPI OUT OF RANGE IN CONSIG'
C
                IF (SPPARI(ISTATE+IREVER*NUMBSP(0,ICHARG),ICHARG)
     *                                                     .GT.0.0) THEN
C
                    NPAPLU=NPAPLU+1
C
C=======================================================================
C                   SELECTING INDICES IN THE POSITIVE PARITY BLOCK
C=======================================================================
C
                    IF (IPAFLI.EQ.0.AND.IREVER.EQ.IREFLI.AND.
     *                                  ICHARG.EQ.ICHFLI) THEN
C
                        IF (NPAPLU.EQ.ISPFLI) THEN
                            OBPFLI=OBSFLI
                            JSPFLI=ISTATE
                        END IF
C
                        IF (NPAPLU.EQ.ISHFLI) THEN
                            OBHFLI=OBSFLI
                            JSHFLI=ISTATE
                        END IF
C
                    END IF
C
                ELSE
C
                    NPAMIN=NPAMIN+1
C
C=======================================================================
C                   SELECTING INDICES IN THE NEGATIVE PARITY BLOCK
C=======================================================================
C
                    IF (IPAFLI.EQ.1.AND.IREVER.EQ.IREFLI.AND.
     *                                  ICHARG.EQ.ICHFLI) THEN
C
                        IF (NPAMIN.EQ.ISPFLI) THEN
                            OBPFLI=OBSFLI
                            JSPFLI=ISTATE
                        END IF
C
                        IF (NPAMIN.EQ.ISHFLI) THEN
                            OBHFLI=OBSFLI
                            JSHFLI=ISTATE
                        END IF
C
                    END IF
C
                END IF
C
             END DO
C
             IF (ICHARG.EQ.ICHFLI.AND.IREVER.EQ.IREFLI) THEN
C
C=======================================================================
C            PROGRAM STOPS IF THE INDICES HAVE NOT BEEN FOUND
C=======================================================================
C
                 IF (JSPFLI.EQ.0.OR.JSHFLI.EQ.0) THEN
C
                     WRITE(NFIPRI,'(/,1X,20(1H/),
     *              '' ERROR IN DIABATIC BLOCKING IN CONSIG'',
     *                                          2X,20(1H/),/,1X,20(1H/),
     *              '' ICHFLI='',I3,''   IPAFLI='',I3,''   IREFLI='',I3,
     *                                          2X,20(1H/),/,1X,20(1H/),
     *              '' ISPFLI='',I3,''   ISHFLI='',I3,''   IFLIPI='',I3,
     *                                          2X,20(1H/))')
     *               ICHFLI,IPAFLI,IREFLI,
     *               ISPFLI,ISHFLI,IFLIPI
C
                     WRITE(NFIPRI,'(
     *                    1X,20(1H/),''  MESSAGE FROM THE CONSIG SU'',
     *                               ''BROUTINE:'',      1X,20(1H/),/
     *                    1X,20(1H/),''  INSUFFICIENT NUMBER  OF  M'',
     *                               ''EAN-FIELD'',      1X,20(1H/),/
     *                    1X,20(1H/),''  STATES KEPT AFTER DIAGONAL'',
     *                               ''IZATION 2'',      1X,20(1H/),/
     *                    1X,20(1H/),''  INCREASE THE  NUMBSP  MATR'',
     *                               ''IX IN THE'',      1X,20(1H/),/
     *                    1X,20(1H/),''  INPUT DATA AND START AGAIN'',
     *                               ''         '',      1X,20(1H/),/)')
C
                     STOP 'INSUFFICIENT NUMBER OF STATES KEPT (CONSIG)2'
C
                 ELSE
C
C=======================================================================
C            HERE THE OCCUPATIONS ARE FLIPPED. POSITIVE  VALUES  OF  THE
C            "IFLIPI" CONTROL VARIABLE ENSURE THAT THE CHOSEN OBSERVABLE
C            HAS A LARGER VALUE IN THE OCCUPIED STATE THAN IN THE  EMPTY
C            STATE
C=======================================================================
C
                     IF ((IFLIPI.GT.0.AND.OBPFLI.GT.OBHFLI).OR.
     *                   (IFLIPI.LT.0.AND.OBPFLI.LT.OBHFLI)) THEN
C
                         V_OCCU(JSPFLI+IREVER*NUMBSP(0,ICHARG))=
     *                               N_OCCU(ISHFLI,IPAFLI,IREVER,ICHARG)
                         V_OCCU(JSHFLI+IREVER*NUMBSP(0,ICHARG))=
     *                               N_OCCU(ISPFLI,IPAFLI,IREVER,ICHARG)
C
                     END IF
C
                 END IF
C
             END IF
C
          END DO
C
      END IF
C
C=======================================================================
C         FLIPPING THE OCCUPATIONS WHEN REQUIRED TO CONSTRUCT THE
C         DIABATIC CONFIGURATIONS (ALL-BLOCKS CASE)
C=======================================================================
C
      DO IPARIT=0,NDPARI
         DO IREVER=0,MREVER
C
            NPARTY=0
C
            JSPFLI=0
            JSHFLI=0
C
            OBPFLI=0.0D0
            OBHFLI=0.0D0
C
            DO ISTATE=1,NUMBSP(IREVER,ICHARG)
C
C=======================================================================
C               FLIPPING IS BASED ON THE VALUES OF OBSERVABLES SELECTED
C               BY THE ABSOLUTE VALUE OF THE  "NOFLIG"  MATRIX ELEMENTS.
C               SEE COMMENTS IN SUBROUTINE NAMELI.
C=======================================================================
C
               IF ((IPARIT.EQ.0.AND.
     *              SPPARI(ISTATE+IREVER*NUMBSP(0,ICHARG),ICHARG)
     *                                                      .GT.0.0).OR.
     *             (IPARIT.EQ.1.AND.
     *              SPPARI(ISTATE+IREVER*NUMBSP(0,ICHARG),ICHARG)
     *                                                    .LT.0.0)) THEN
C
                   NPARTY=NPARTY+1
C
C=======================================================================
C                  SELECTING INDICES IN THE GIVEN
C                  PARITY/SIGNATURE/CHARGE  BLOCK
C=======================================================================
C
                   IF (NOFLIG(IPARIT,IREVER,ICHARG).NE.0) THEN
C
                       IF (ABS(NOFLIG(IPARIT,IREVER,ICHARG)).EQ. 1)
     *                     OBSFLI=SPALIG(ISTATE+IREVER*NUMBSP(0,ICHARG),
     *                                                          ICHARG)
C
                       IF (ABS(NOFLIG(IPARIT,IREVER,ICHARG)).EQ. 2)
     *                     OBSFLI=SPSPAL(ISTATE+IREVER*NUMBSP(0,ICHARG),
     *                                                          ICHARG)
C
                       IF (ABS(NOFLIG(IPARIT,IREVER,ICHARG)).EQ. 9)
     *                     OBSFLI=SPMO20(ISTATE+IREVER*NUMBSP(0,ICHARG),
     *                                                          ICHARG)
C
                       IF (ABS(NOFLIG(IPARIT,IREVER,ICHARG)).EQ.10)
     *                     OBSFLI=SPMO22(ISTATE+IREVER*NUMBSP(0,ICHARG),
     *                                                          ICHARG)
C
                       IF (ABS(NOFLIG(IPARIT,IREVER,ICHARG)).GT.10.OR.
     *                    (ABS(NOFLIG(IPARIT,IREVER,ICHARG)).GE. 3.AND.
     *                     ABS(NOFLIG(IPARIT,IREVER,ICHARG)).LE. 8))
     *                     STOP ' NOFLIG OUT OF RANGE IN CONSIG'
C
                       IF (NPARTY.EQ.NPFLIG(IPARIT,IREVER,ICHARG))
     *                 THEN
                           OBPFLI=OBSFLI
                           JSPFLI=ISTATE
                       END IF
C
                       IF (NPARTY.EQ.NHFLIG(IPARIT,IREVER,ICHARG))
     *                 THEN
                           OBHFLI=OBSFLI
                           JSHFLI=ISTATE
                       END IF
C
                   END IF
C
               END IF
C
            END DO
C
            IF (NOFLIG(IPARIT,IREVER,ICHARG).NE.0) THEN
C
C=======================================================================
C               PROGRAM STOPS IF THE INDICES HAVE NOT BEEN FOUND
C=======================================================================
C
                IF (JSPFLI.EQ.0.OR.JSHFLI.EQ.0) THEN
C
                    WRITE(NFIPRI,'(/,1X,20(1H/),
     *           '' ERROR IN DIABATIC BLOCKING IN CONSIG'',
     *                                       2X,20(1H/),/,1X,20(1H/),
     *           '' ICHARG='',I3,''   IPARIT='',I3,''   IREVER='',I3,
     *                                       2X,20(1H/),/,1X,20(1H/),
     *           '' NPFLIG='',I3,''   NHFLIG='',I3,''   NOFLIG='',I3,
     *                                       2X,20(1H/))')
     *              ICHARG,IPARIT,IREVER,
     *              NPFLIG(IPARIT,IREVER,ICHARG),
     *              NHFLIG(IPARIT,IREVER,ICHARG),
     *              NOFLIG(IPARIT,IREVER,ICHARG)
C
                    WRITE(NFIPRI,'(
     *                   1X,20(1H/),''  MESSAGE FROM THE CONSIG SU'',
     *                              ''BROUTINE:'',      1X,20(1H/),/
     *                   1X,20(1H/),''  INSUFFICIENT NUMBER  OF  M'',
     *                              ''EAN-FIELD'',      1X,20(1H/),/
     *                   1X,20(1H/),''  STATES KEPT AFTER DIAGONAL'',
     *                              ''IZATION 3'',      1X,20(1H/),/
     *                   1X,20(1H/),''  INCREASE THE  NUMBSP  MATR'',
     *                              ''IX IN THE'',      1X,20(1H/),/
     *                   1X,20(1H/),''  INPUT DATA AND START AGAIN'',
     *                              ''         '',      1X,20(1H/),/)')
C
                    STOP 'INSUFFICIENT NUMBER OF STATES KEPT (CONSIG)3'
C
                ELSE
C
C=======================================================================
C            HERE THE OCCUPATIONS ARE FLIPPED. POSITIVE  VALUES  OF  THE
C            "NOFLIG" MATRIX ELEMENTS  ENSURE THAT THE CHOSEN OBSERVABLE
C            HAS A LARGER VALUE IN THE OCCUPIED STATE THAN IN THE  EMPTY
C            STATE, AND VICE VERSA.
C=======================================================================
C
                    IF ((NOFLIG(IPARIT,IREVER,ICHARG).GT.0.AND.
     *                   OBPFLI.GT.OBHFLI).OR.
     *                  (NOFLIG(IPARIT,IREVER,ICHARG).LT.0.AND.
     *                   OBPFLI.LT.OBHFLI)) THEN
C
                        V_OCCU(JSPFLI+IREVER*NUMBSP(0,ICHARG))=
     *                           N_OCCU(NHFLIG(IPARIT,IREVER,ICHARG),
     *                                         IPARIT,IREVER,ICHARG)
                        V_OCCU(JSHFLI+IREVER*NUMBSP(0,ICHARG))=
     *                           N_OCCU(NPFLIG(IPARIT,IREVER,ICHARG),
     *                                         IPARIT,IREVER,ICHARG)
C
                    END IF
C
                END IF
C
            END IF
C
         END DO
      END DO
C
C=======================================================================
C         DETERMINING THE ORDERED SINGLE-PARTICLE SPECTRUM AND THE FERMI
C         ENERGY
C=======================================================================
C
      IORDER=0
C
      DO IREVER=0,MREVER
C
         DO ISTATE=1,NUMBSP(IREVER,ICHARG)
C
            IORDER=IORDER+1
            NORDER(IORDER)=IORDER
            EORDER(IORDER)=SPENER(ISTATE+IREVER*NUMBSP(0,ICHARG),ICHARG)
C
         END DO
C
      END DO
C
      CALL ORDER1(EORDER,NORDER,IORDER)
C
      NUMACT=NUMNUC
C
      IF (MREVER.EQ.0) THEN
C
          IF (MOD(NUMNUC,2).NE.0) STOP ' ODD NUMNUC IN CONSIG'
          NUMACT=NUMNUC/2
C
      END IF
C
      EFERMI=0.5D0*(EORDER(NUMACT+1)+EORDER(NUMACT))
C
C=======================================================================
C         CALCULATING THE NUMBERS OF OCCUPIED STATES IN EVERY
C         PARITY/TIME-REVERSAL BLOCK
C=======================================================================
C
      IPARTI=0
C
      DO IREVER=0,MREVER
C
         NPAPLU=0
         NPAMIN=0
C
         DO ISTATE=1,NUMBSP(IREVER,ICHARG)
C
            IF (SPENER(ISTATE+IREVER*NUMBSP(0,ICHARG),ICHARG).LT.EFERMI)
     *                                                              THEN
C
                IPARTI=IPARTI+1
C
                IF (SPPARI(ISTATE+IREVER*NUMBSP(0,ICHARG),ICHARG)
     *                                                     .GT.0.0) THEN
C
                    NPAPLU=NPAPLU+1
                    N_VACC(NPAPLU,0,IREVER,ICHARG)=1
C
                ELSE
C
                    NPAMIN=NPAMIN+1
                    N_VACC(NPAMIN,1,IREVER,ICHARG)=1
C
                END IF
C
            END IF
C
         END DO
C
      END DO
C
C      In case of vacuum configuration, all lowest states up to the
C      Fermi level are occupied, all other states empty
C
      IF (IVACUM.EQ.1) THEN
C
          DO IREVER=0,MREVER
C
              DO ISTATE=1,NUMBSP(IREVER,ICHARG)
C
                 IF (SPENER(ISTATE+IREVER*NUMBSP(0,ICHARG),ICHARG)
     *                  .LT.EFERMI) THEN
                     V_OCCU(ISTATE+IREVER*NUMBSP(0,ICHARG))=1.0D0
                 ELSE
                     V_OCCU(ISTATE+IREVER*NUMBSP(0,ICHARG))=0.0D0
                 END IF
C
             END DO
C
          END DO
C
      END IF
C
C=======================================================================
C        IN CASE OF DEGENERATE STATES AT THE FERMI  ENERGY  THE
C        CONFIGURATION DATA ARE SET TO 100 TO OBTAIN  ASTERISKS
C        ON THE OUTPUT. A BETTER TREATMENT OF SUCH A DEGENERACY
C        IS STILL TO BE FOUND.
C=======================================================================
C        ATTENTION:  IN THE PREVIOUS VERSIONS OF THE CODE, STARTING FROM
C                    VERSION 1.96G AND UP TO  VERSION  2.08H,  THE  LOOP
C                    BELOW WAS PERFORMED UP TO "NDBASE",  I.E.,  FURTHER
C                    THAN THE VALUE OF "NDSTAT", WHICH WAS THE  DECLARED
C                    DIMENSION OF ARRAY "N_VACC".
C                    THIS BUG WAS CORRECTED IN VERSION 2.08I (10/02/04).
C=======================================================================
C
      IF (IPARTI.NE.NUMACT) THEN
C
          DO IREVER=0,MREVER
C
             DO ISTATE=1,NUMBSP(IREVER,ICHARG)
C
                N_VACC(ISTATE,0,IREVER,ICHARG)=100
                N_VACC(ISTATE,1,IREVER,ICHARG)=100
C
             END DO
C
          END DO
C
      END IF
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE CONSIM(MREVER,ICHARG,NUMNUC,EFERMI,
     *                         ICHFLI,       IREFLI,
     *                         ISPFLI,ISHFLI,IFLIPI)
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      DIMENSION
     *          EORDER(1:2*NDBASE),NORDER(1:2*NDBASE)
      DIMENSION
     *          NOCCUP(0:NDREVE)
C
      COMMON
     *       /SPLEVS/ SPENER(1:2*NDSTAT,0:NDISOS),
     *                SPOCCU(1:2*NDSTAT,0:NDISOS),
     *                SPALIG(1:2*NDSTAT,0:NDISOS),
     *                SPSPAL(1:2*NDSTAT,0:NDISOS),
     *                SPPARI(1:2*NDSTAT,0:NDISOS),
     *                SPSIMP(1:2*NDSTAT,0:NDISOS)
      COMMON
     *       /SPMOME/ SPMO20(1:2*NDSTAT,0:NDISOS),
     *                SPMO22(1:2*NDSTAT,0:NDISOS)
      COMMON
     *       /SIMOCC/ L_OCCU(1:NDSTAT,0:NDREVE,0:NDISOS),
     *                L_VACC(1:NDSTAT,0:NDREVE,0:NDISOS)
      COMMON
     *       /SIMNVA/ NVASIM(0:NDREVE,0:NDISOS)
      COMMON
     *       /N_FLIM/ NPFLIM(0:NDREVE,0:NDISOS),
     *                NHFLIM(0:NDREVE,0:NDISOS),
     *                NOFLIM(0:NDREVE,0:NDISOS)
      COMMON
     *       /PROCCU/ V_OCCU(1:2*NDSTAT)
      COMMON
     *       /VACCNF/ IVACUM
      COMMON
     *       /SPNUMS/ NUMBSP(0:NDREVE,0:NDISOS)
      COMMON
     *       /CFIPRI/ NFIPRI
C
C=======================================================================
C
C         THIS SUBROUTINE IS CALLED IN THE CASE OF CONSERVATION OF THE
C         SIMPLEX SYMMETRY AND SETS THE OCCUPATION  FACTORS  ACCORDING
C         TO THE CHOSEN SIMPLEX CONFIGURATIONS (IN CASE OF NO PAIRING).
C         IT ALSO CALCULATES THE LOWEST - SIMPLEX  CONFIGURATION FOR A
C         GIVEN SINGLE-PARTICLE SPECTRUM.
C
C=======================================================================
C
C=======================================================================
C         ZEROING OCCUPATION FACTORS AND THE VACUUM CONFIGURATION DATA
C=======================================================================
C
      DO IREVER=0,NDREVE
C
         DO ISTATE=1,NUMBSP(IREVER,ICHARG)
C
            V_OCCU(ISTATE+IREVER*NUMBSP(0,ICHARG))=0.0
C
            L_VACC(ISTATE,IREVER,ICHARG)=0
C
         END DO
C
      END DO
C
C=======================================================================
C         SETTING THE OCCUPATION FACTORS ACCORDING TO THE CONFIGURATION
C=======================================================================
C
      DO IREVER=0,MREVER
C
         NOCCUP(IREVER)=0
C
         DO ISTATE=1,NUMBSP(IREVER,ICHARG)
C
            NOCCUP(IREVER)=NOCCUP(IREVER)+
     *               L_OCCU(ISTATE,IREVER,ICHARG)
C
            V_OCCU(ISTATE+IREVER*NUMBSP(0,ICHARG))=
     *               L_OCCU(ISTATE,IREVER,ICHARG)
C
         END DO
C
      END DO
C
C=======================================================================
C         THE TEST BELOW ENSURES THAT THE NUMBER OF STATES KEPT AFTER
C         THE DIAGONALIZATION IS SUFFICIENT TO ACCOMODATE ALL  STATES
C         OCCUPIED IN EACH OF THE SIMPLEX BLOCKS. THE TEST COULD HAVE
C         BEEN PERFORMED IN ANOTHER PLACE, HOWEVER, IT  IS  PERFORMED
C         HERE TO KEEP CONSISTENCY WITH OTHER SYMMETRIES.
C=======================================================================
C
      DO IREVER=0,MREVER
C
         IF (NOCCUP(IREVER).NE.NVASIM(IREVER,ICHARG).AND.
     *       IVACUM.NE.1) THEN
C
             WRITE(NFIPRI,'(
     *            1X,20(1H/),''  MESSAGE FROM THE CONSIM SU'',
     *                       ''BROUTINE:'',      1X,20(1H/),/
     *            1X,20(1H/),''  INSUFFICIENT NUMBER  OF  M'',
     *                       ''EAN-FIELD'',      1X,20(1H/),/
     *            1X,20(1H/),''  STATES KEPT AFTER DIAGONAL'',
     *                       ''IZATION 1'',      1X,20(1H/),/
     *            1X,20(1H/),''  INCREASE THE  NUMBSP  MATR'',
     *                       ''IX IN THE'',      1X,20(1H/),/
     *            1X,20(1H/),''  INPUT DATA AND START AGAIN'',
     *                       ''         '',      1X,20(1H/),/)')
C
             STOP 'INSUFFICIENT NUMBER OF STATES KEPT (CONSIM)1'
C
         END IF
C
      END DO
C
C=======================================================================
C         FLIPPING THE OCCUPATIONS WHEN REQUIRED TO CONSTRUCT THE
C         DIABATIC CONFIGURATIONS
C=======================================================================
C
      IF (IFLIPI.NE.0) THEN
C
          DO IREVER=0,MREVER
C
             JSPFLI=0
             JSHFLI=0
C
             OBPFLI=0.0D0
             OBHFLI=0.0D0
C
             DO ISTATE=1,NUMBSP(IREVER,ICHARG)
C
C=======================================================================
C               FLIPPING IS BASED ON THE VALUES OF OBSERVABLES SELECTED
C               BY THE ABSOLUTE VALUE OF THE  "IFLIPI" CONTROL VARIABLE.
C               SEE COMMENTS IN SUBROUTINE NAMELI.
C=======================================================================
C
                IF (ABS(IFLIPI).EQ. 1)
     *              OBSFLI=SPALIG(ISTATE+IREVER*NUMBSP(0,ICHARG),ICHARG)
C
                IF (ABS(IFLIPI).EQ. 2)
     *              OBSFLI=SPSPAL(ISTATE+IREVER*NUMBSP(0,ICHARG),ICHARG)
C
                IF (ABS(IFLIPI).EQ. 9)
     *              OBSFLI=SPMO20(ISTATE+IREVER*NUMBSP(0,ICHARG),ICHARG)
C
                IF (ABS(IFLIPI).EQ.10)
     *              OBSFLI=SPMO22(ISTATE+IREVER*NUMBSP(0,ICHARG),ICHARG)
C
                IF (ABS(IFLIPI).GT.10.OR.
     *             (ABS(IFLIPI).GE. 3.AND.ABS(IFLIPI).LE.8))
     *              STOP ' IFLIPI OUT OF RANGE IN CONSIM'
C
C=======================================================================
C               SELECTING INDICES
C=======================================================================
C
                IF (IREVER.EQ.IREFLI.AND.ICHARG.EQ.ICHFLI) THEN
C
                    IF (ISTATE.EQ.ISPFLI) THEN
                        OBPFLI=OBSFLI
                        JSPFLI=ISTATE
                    END IF
C
                    IF (ISTATE.EQ.ISHFLI) THEN
                        OBHFLI=OBSFLI
                        JSHFLI=ISTATE
                    END IF
C
                END IF
C
             END DO
C
             IF (ICHARG.EQ.ICHFLI.AND.IREVER.EQ.IREFLI) THEN
C
C=======================================================================
C            A WARNING IS ISSUED IF THE INDICES HAVE NOT BEEN SELECTED
C=======================================================================
C
                 IF (JSPFLI.EQ.0.OR.JSHFLI.EQ.0) THEN
C
                     WRITE(NFIPRI,'(/,1X,20(1H/),
     *              '' ERROR IN DIABATIC BLOCKING IN CONSIM'',
     *                                          2X,20(1H/),/,1X,20(1H/),
     *              ''   ICHFLI='',I3,''        '',3X,''   IREFLI='',I3,
     *                                          2X,20(1H/),/,1X,20(1H/),
     *              '' ISPFLI='',I3,''   ISHFLI='',I3,''   IFLIPI='',I3,
     *                                          2X,20(1H/))')
     *               ICHFLI,       IREFLI,
     *               ISPFLI,ISHFLI,IFLIPI
C
                     WRITE(NFIPRI,'(
     *                    1X,20(1H/),''  MESSAGE FROM THE CONSIM SU'',
     *                               ''BROUTINE:'',      1X,20(1H/),/
     *                    1X,20(1H/),''  INSUFFICIENT NUMBER  OF  M'',
     *                               ''EAN-FIELD'',      1X,20(1H/),/
     *                    1X,20(1H/),''  STATES KEPT AFTER DIAGONAL'',
     *                               ''IZATION 2'',      1X,20(1H/),/
     *                    1X,20(1H/),''  INCREASE THE  NUMBSP  MATR'',
     *                               ''IX IN THE'',      1X,20(1H/),/
     *                    1X,20(1H/),''  INPUT DATA AND START AGAIN'',
     *                               ''         '',      1X,20(1H/),/)')
C
                     STOP 'INSUFFICIENT NUMBER OF STATES KEPT (CONSIM)2'
C
                 ELSE
C
C=======================================================================
C            HERE THE OCCUPATIONS ARE FLIPPED. POSITIVE  VALUES  OF  THE
C            "IFLIPI" CONTROL VARIABLE ENSURE THAT THE CHOSEN OBSERVABLE
C            HAS A LARGER VALUE IN THE OCCUPIED STATE THAN IN THE  EMPTY
C            STATE
C=======================================================================
C
                     IF ((IFLIPI.GT.0.AND.OBPFLI.GT.OBHFLI).OR.
     *                   (IFLIPI.LT.0.AND.OBPFLI.LT.OBHFLI)) THEN
C
                         V_OCCU(JSPFLI+IREVER*NUMBSP(0,ICHARG))=
     *                               L_OCCU(ISHFLI,IREVER,ICHARG)
                         V_OCCU(JSHFLI+IREVER*NUMBSP(0,ICHARG))=
     *                               L_OCCU(ISPFLI,IREVER,ICHARG)
C
                     END IF
C
                 END IF
C
             END IF
C
          END DO
C
      END IF
C
C=======================================================================
C         FLIPPING THE OCCUPATIONS WHEN REQUIRED TO CONSTRUCT THE
C         DIABATIC CONFIGURATIONS (ALL-BLOCKS CASE)
C=======================================================================
C
      DO IREVER=0,MREVER
C
         JSPFLI=0
         JSHFLI=0
C
         OBPFLI=0.0D0
         OBHFLI=0.0D0
C
         DO ISTATE=1,NUMBSP(IREVER,ICHARG)
C
C=======================================================================
C               FLIPPING IS BASED ON THE VALUES OF OBSERVABLES SELECTED
C               BY THE ABSOLUTE VALUE OF THE  "NOFLIM"  MATRIX ELEMENTS.
C               SEE COMMENTS IN SUBROUTINE NAMELI.
C=======================================================================
C
C=======================================================================
C                   SELECTING INDICES IN THE GIVEN
C                   SIMPLEX/CHARGE  BLOCK
C=======================================================================
C
            IF (NOFLIM(IREVER,ICHARG).NE.0) THEN
C
                IF (ABS(NOFLIM(IREVER,ICHARG)).EQ. 1)
     *              OBSFLI=SPALIG(ISTATE+IREVER*NUMBSP(0,ICHARG),ICHARG)
C
                IF (ABS(NOFLIM(IREVER,ICHARG)).EQ. 2)
     *              OBSFLI=SPSPAL(ISTATE+IREVER*NUMBSP(0,ICHARG),ICHARG)
C
                IF (ABS(NOFLIM(IREVER,ICHARG)).EQ. 9)
     *              OBSFLI=SPMO20(ISTATE+IREVER*NUMBSP(0,ICHARG),ICHARG)
C
                IF (ABS(NOFLIM(IREVER,ICHARG)).EQ.10)
     *              OBSFLI=SPMO22(ISTATE+IREVER*NUMBSP(0,ICHARG),ICHARG)
C
                IF (ABS(NOFLIM(IREVER,ICHARG)).GT.10.OR.
     *             (ABS(NOFLIM(IREVER,ICHARG)).GE. 3.AND.
     *              ABS(NOFLIM(IREVER,ICHARG)).LE. 8))
     *              STOP ' NOFLIM OUT OF RANGE IN CONSIM'
C
                IF (ISTATE.EQ.NPFLIM(IREVER,ICHARG)) THEN
                    OBPFLI=OBSFLI
                    JSPFLI=ISTATE
                END IF
C
                IF (ISTATE.EQ.NHFLIM(IREVER,ICHARG)) THEN
                    OBHFLI=OBSFLI
                    JSHFLI=ISTATE
                END IF
C
            END IF
C
         END DO
C
         IF (NOFLIM(IREVER,ICHARG).NE.0) THEN
C
C=======================================================================
C              A WARNING IS ISSUED IF THE INDICES HAVE NOT BEEN SELECTED
C=======================================================================
C
             IF (JSPFLI.EQ.0.OR.JSHFLI.EQ.0) THEN
C
                 WRITE(NFIPRI,'(/,1X,20(1H/),
     *              '' ERROR IN DIABATIC BLOCKING IN CONSIM'',
     *                                          2X,20(1H/),/,1X,20(1H/),
     *              '' ICHARG='',I3,''          '',3X,''   IREVER='',I3,
     *                                          2X,20(1H/),/,1X,20(1H/),
     *              '' NPFLIM='',I3,''   NHFLIM='',I3,''   NOFLIM='',I3,
     *                                          2X,20(1H/))')
     *           ICHARG,IREVER,
     *           NPFLIM(IREVER,ICHARG),
     *           NHFLIM(IREVER,ICHARG),
     *           NOFLIM(IREVER,ICHARG)
C
                 WRITE(NFIPRI,'(
     *                1X,20(1H/),''  MESSAGE FROM THE CONSIM SU'',
     *                           ''BROUTINE:'',      1X,20(1H/),/
     *                1X,20(1H/),''  INSUFFICIENT NUMBER  OF  M'',
     *                           ''EAN-FIELD'',      1X,20(1H/),/
     *                1X,20(1H/),''  STATES KEPT AFTER DIAGONAL'',
     *                           ''IZATION 3'',      1X,20(1H/),/
     *                1X,20(1H/),''  INCREASE THE  NUMBSP  MATR'',
     *                           ''IX IN THE'',      1X,20(1H/),/
     *                1X,20(1H/),''  INPUT DATA AND START AGAIN'',
     *                           ''         '',      1X,20(1H/),/)')
C
                 STOP 'INSUFFICIENT NUMBER OF STATES KEPT (CONSIM)3'
C
             ELSE
C
C=======================================================================
C            HERE THE OCCUPATIONS ARE FLIPPED. POSITIVE  VALUES  OF  THE
C            "NOFLIM" MATRIX ELEMENTS  ENSURE THAT THE CHOSEN OBSERVABLE
C            HAS A LARGER VALUE IN THE OCCUPIED STATE THAN IN THE  EMPTY
C            STATE, AND VICE VERSA.
C=======================================================================
C
                 IF ((NOFLIM(IREVER,ICHARG).GT.0.AND.
     *                OBPFLI.GT.OBHFLI).OR.
     *               (NOFLIM(IREVER,ICHARG).LT.0.AND.
     *                OBPFLI.LT.OBHFLI)) THEN
C
                     V_OCCU(JSPFLI+IREVER*NUMBSP(0,ICHARG))=
     *                    L_OCCU(NHFLIM(IREVER,ICHARG),IREVER,ICHARG)
                     V_OCCU(JSHFLI+IREVER*NUMBSP(0,ICHARG))=
     *                    L_OCCU(NPFLIM(IREVER,ICHARG),IREVER,ICHARG)
C
                 END IF
C
             END IF
C
         END IF
C
      END DO
C
C=======================================================================
C        DETERMINING THE ORDERED SINGLE-PARTICLE SPECTRUM AND
C        THE FERMI ENERGY
C=======================================================================
C
      IORDER=0
C
      DO IREVER=0,MREVER
C
         DO ISTATE=1,NUMBSP(IREVER,ICHARG)
C
            IORDER=IORDER+1
            NORDER(IORDER)=IORDER
            EORDER(IORDER)=SPENER(ISTATE+IREVER*NUMBSP(0,ICHARG),ICHARG)
C
         END DO
C
      END DO
C
      CALL ORDER1(EORDER,NORDER,IORDER)
C
      NUMACT=NUMNUC
C
      IF (MREVER.EQ.0) THEN
C
          IF (MOD(NUMNUC,2).NE.0) STOP ' ODD NUMNUC IN CONSIM'
          NUMACT=NUMNUC/2
C
      END IF
C
      EFERMI=0.5D0*(EORDER(NUMACT+1)+EORDER(NUMACT))
C
C=======================================================================
C         CALCULATING THE NUMBERS OF OCCUPIED STATES IN EVERY
C         SIMPLEX BLOCK
C=======================================================================
C
      IPARTI=0
C
      DO IREVER=0,MREVER
C
         DO ISTATE=1,NUMBSP(IREVER,ICHARG)
C
            IF (SPENER(ISTATE+IREVER*NUMBSP(0,ICHARG),ICHARG).LT.EFERMI)
     *                                                              THEN
C
                IPARTI=IPARTI+1
C
                L_VACC(ISTATE,IREVER,ICHARG)=1
C
            END IF
C
         END DO
C
      END DO
C
C      In case of vacuum configuration, all lowest states up to the
C      Fermi level are occupied, all other states empty
C
      IF (IVACUM.EQ.1) THEN
C
          DO IREVER=0,MREVER
C
             DO ISTATE=1,NUMBSP(IREVER,ICHARG)
                V_OCCU(ISTATE+IREVER*NUMBSP(0,ICHARG))
     *         =REAL(L_VACC(ISTATE,IREVER,ICHARG),KIND=8)
             END DO
C
          END DO
C
      END IF
C
C=======================================================================
C        IN CASE OF DEGENERATE STATES AT THE FERMI  ENERGY  THE
C        CONFIGURATION DATA ARE SET TO 100 TO OBTAIN  ASTERISKS
C        ON THE OUTPUT. A BETTER TREATMENT OF SUCH A DEGENERACY
C        IS STILL TO BE FOUND.
C=======================================================================
C
      IF (IPARTI.NE.NUMACT) THEN
C
          DO IREVER=0,MREVER
C
             DO ISTATE=1,NUMBSP(IREVER,ICHARG)
C
                L_VACC(ISTATE,IREVER,ICHARG)=100
C
             END DO
C
          END DO
C
      END IF
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE CONSIQ(ICHARG,NUMNUC,EFERMI,ICHFLI,IPAFLI,
     *                                ISPFLI,ISHFLI,IFLIPI)
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      COMMON
     *       /SPLEVS/ SPENER(1:2*NDSTAT,0:NDISOS),
     *                SPOCCU(1:2*NDSTAT,0:NDISOS),
     *                SPALIG(1:2*NDSTAT,0:NDISOS),
     *                SPSPAL(1:2*NDSTAT,0:NDISOS),
     *                SPPARI(1:2*NDSTAT,0:NDISOS),
     *                SPSIMP(1:2*NDSTAT,0:NDISOS)
      COMMON
     *       /SPSTAT/ SPXALI(1:2*NDSTAT,0:NDISOS),
     *                SPZALI(1:2*NDSTAT,0:NDISOS),
     *                SPXSPI(1:2*NDSTAT,0:NDISOS),
     *                SPZSPI(1:2*NDSTAT,0:NDISOS)
      COMMON
     *       /SPMOME/ SPMO20(1:2*NDSTAT,0:NDISOS),
     *                SPMO22(1:2*NDSTAT,0:NDISOS)
      COMMON
     *       /SIQNOC/ NOCSIQ(0:NDPARI,         0:NDISOS)
      COMMON
     *       /SIQOCC/ K_OCCU(1:2*NDSTAT,0:NDPARI,0:NDISOS),
     *                K_VACC(1:2*NDSTAT,0:NDPARI,0:NDISOS)
      COMMON
     *       /N_FLIQ/ NPFLIQ(0:NDPARI,         0:NDISOS),
     *                NHFLIQ(0:NDPARI,         0:NDISOS),
     *                NOFLIQ(0:NDPARI,         0:NDISOS)
      COMMON
     *       /OMOVAS/ OMOVAX,OMOVAY,OMOVAZ
      COMMON
     *       /PROCCU/ V_OCCU(1:2*NDSTAT)
      COMMON
     *       /VACCNF/ IVACUM
      COMMON
     *       /SPNUMS/ NUMBSP(0:NDREVE,0:NDISOS)
      COMMON
     *       /CFIPRI/ NFIPRI
C
C=======================================================================
C
C         THIS SUBROUTINE IS CALLED IN THE CASE OF CONSERVATION OF THE
C         PARITY SYMMETRY AND SETS THE OCCUPATION  FACTORS  ACCORDING
C         TO THE CHOSEN PARITY CONFIGURATIONS (IN CASE OF NO PAIRING).
C         IT ALSO CALCULATES THE LOWEST - PARITY  CONFIGURATION FOR A
C         GIVEN SINGLE-PARTICLE SPECTRUM.
C
C=======================================================================
C         ZEROING OCCUPATION FACTORS AND THE VACUUM CONFIGURATION DATA
C=======================================================================
C
      V_OCCU(:)=0.0D0
C
      DO IPARIT=0,NDPARI
         DO ISTATE=1,NUMBSP(0,ICHARG)+NUMBSP(1,ICHARG)
C
            K_VACC(ISTATE,IPARIT,ICHARG)=0
C
         END DO
      END DO
C
C=======================================================================
C         DETERMINING THE FERMI ENERGY
C=======================================================================
C
      EFERMI=0.5D0*(SPENER(NUMNUC+1,ICHARG)+SPENER(NUMNUC,ICHARG))
C
C=======================================================================
C         SETTING THE OCCUPATION FACTORS ACCORDING TO THE CONFIGURATION
C         AND CALCULATING THE VACUUM CONFIGURATION  TOGETHER  WITH  THE
C         NUMBERS OF OCCUPIED STATES IN EACH PARITY
C=======================================================================
C
      NPAPLU=0
      NPAMIN=0
C
      NOCPLU=0
      NOCMIN=0
C
      IPARTI=0
C
      DO ISTATE=1,NUMBSP(0,ICHARG)+NUMBSP(1,ICHARG)
C
         IF (SPPARI(ISTATE,ICHARG).GT.0.0) THEN
C
             NPAPLU=NPAPLU+ 1
             NOCPLU=NOCPLU+ K_OCCU(NPAPLU,0,ICHARG)
C
             V_OCCU(ISTATE)=K_OCCU(NPAPLU,0,ICHARG)
C
             IF (SPENER(ISTATE,ICHARG).LT.EFERMI) THEN
C
                 K_VACC(NPAPLU,0,ICHARG)=1
                 IPARTI=IPARTI+1
C
             END IF
C
         ELSE
C
             NPAMIN=NPAMIN+ 1
             NOCMIN=NOCMIN+ K_OCCU(NPAMIN,1,ICHARG)
C
             V_OCCU(ISTATE)=K_OCCU(NPAMIN,1,ICHARG)
C
             IF (SPENER(ISTATE,ICHARG).LT.EFERMI) THEN
C
                 K_VACC(NPAMIN,1,ICHARG)=1
                 IPARTI=IPARTI+1
C
             END IF
C
         END IF
C
      END DO
C
C      In case of vacuum configuration, all lowest states up to the
C      Fermi level are occupied, all other states empty
C
      IF (IVACUM.EQ.1) THEN
C
          DO ISTATE=1,NUMBSP(0,ICHARG)+NUMBSP(1,ICHARG)
C
             IF (SPENER(ISTATE,ICHARG).LT.EFERMI) THEN
                 V_OCCU(ISTATE)=1.0D0
             ELSE
                 V_OCCU(ISTATE)=0.0D0
             END IF
C
          END DO
C
      END IF
C
C=======================================================================
C         THE TEST BELOW ENSURES THAT THE NUMBER OF STATES KEPT AFTER
C         THE DIAGONALIZATION IS SUFFICIENT TO ACCOMODATE ALL  STATES
C         OCCUPIED IN EACH OF THE PARITY BLOCKS. THE TEST CAN ONLY BE
C         PERFORMED IN THIS PLACE, BECAUSE THE NUMBER OF STATES  KEPT
C         AFTER THE DIAGONALIZATION DEPENDS ON THE  ENERGY  SPECTRUM,
C         AND THE NUMBERS OF STATES KEPT IN EACH PARITY ARE NOT KNOWN
C         BEFORE THE SPECTRUM IS CALCULATED.
C=======================================================================
C
      IF (NOCPLU.NE.NOCSIQ(0,ICHARG).OR.NOCMIN.NE.NOCSIQ(1,ICHARG).AND.
     *    IVACUM.NE.1) THEN
C
          WRITE(NFIPRI,'(
     *         1X,20(1H/),''  MESSAGE FROM THE CONSIQ SU'',
     *                    ''BROUTINE:'',      1X,20(1H/),/
     *         1X,20(1H/),''  INSUFFICIENT NUMBER  OF  M'',
     *                    ''EAN-FIELD'',      1X,20(1H/),/
     *         1X,20(1H/),''  STATES KEPT AFTER DIAGONAL'',
     *                    ''IZATION 1'',      1X,20(1H/),/
     *         1X,20(1H/),''  INCREASE THE  NUMBSP  MATR'',
     *                    ''IX IN THE'',      1X,20(1H/),/
     *         1X,20(1H/),''  INPUT DATA AND START AGAIN'',
     *                    ''         '',      1X,20(1H/),/)')
C
          STOP 'INSUFFICIENT NUMBER OF STATES KEPT (CONSIQ)1'
C
      END IF
C
C=======================================================================
C        IN CASE OF DEGENERATE STATES AT THE FERMI  ENERGY  THE
C        CONFIGURATION DATA ARE SET TO 100 TO OBTAIN  ASTERISKS
C        ON THE OUTPUT. A BETTER TREATMENT OF SUCH A DEGENERACY
C        IS STILL TO BE FOUND.
C=======================================================================
C
      IF (IPARTI.NE.NUMNUC) THEN
C
          DO IPARIT=0,NDPARI
             DO ISTATE=1,NUMBSP(0,ICHARG)+NUMBSP(1,ICHARG)
C
                K_VACC(ISTATE,IPARIT,ICHARG)=100
C
             END DO
          END DO
C
      END IF
C
C=======================================================================
C         FLIPPING THE OCCUPATIONS WHEN REQUIRED TO CONSTRUCT THE
C         DIABATIC CONFIGURATIONS (SINGLE-PAIR CASE)
C=======================================================================
C
      IF (IFLIPI.NE.0) THEN
C
          NPAPLU=0
          NPAMIN=0
C
          JSPFLI=0
          JSHFLI=0
C
          OBPFLI=0.0D0
          OBHFLI=0.0D0
C
          DO ISTATE=1,NUMBSP(0,ICHARG)+NUMBSP(1,ICHARG)
C
C=======================================================================
C               FLIPPING IS BASED ON THE VALUES OF OBSERVABLES SELECTED
C               BY THE ABSOLUTE VALUE OF THE  "IFLIPI" CONTROL VARIABLE.
C               SEE COMMENTS IN SUBROUTINE NAMELI.
C=======================================================================
C
             IF (ABS(IFLIPI).EQ. 1) OBSFLI=SPALIG(ISTATE,ICHARG)
             IF (ABS(IFLIPI).EQ. 2) OBSFLI=SPSPAL(ISTATE,ICHARG)
             IF (ABS(IFLIPI).EQ. 3) OBSFLI=SPXALI(ISTATE,ICHARG)
             IF (ABS(IFLIPI).EQ. 4) OBSFLI=SPXSPI(ISTATE,ICHARG)
             IF (ABS(IFLIPI).EQ. 5) OBSFLI=SPZALI(ISTATE,ICHARG)
             IF (ABS(IFLIPI).EQ. 6) OBSFLI=SPZSPI(ISTATE,ICHARG)
C
             IF (ABS(IFLIPI).EQ. 7) OBSFLI=SPXALI(ISTATE,ICHARG)*OMOVAX
     *                                    +SPALIG(ISTATE,ICHARG)*OMOVAY
     *                                    +SPZALI(ISTATE,ICHARG)*OMOVAZ
C
             IF (ABS(IFLIPI).EQ. 8) OBSFLI=SPXSPI(ISTATE,ICHARG)*OMOVAX
     *                                    +SPSPAL(ISTATE,ICHARG)*OMOVAY
     *                                    +SPZSPI(ISTATE,ICHARG)*OMOVAZ
C
             IF (ABS(IFLIPI).EQ. 9) OBSFLI=SPMO20(ISTATE,ICHARG)
             IF (ABS(IFLIPI).EQ.10) OBSFLI=SPMO22(ISTATE,ICHARG)
C
             IF (ABS(IFLIPI).GT.10) STOP ' IFLIPI TOO LARGE IN CONSIQ'
C
C=======================================================================
C
             IF (SPPARI(ISTATE,ICHARG).GT.0.0) THEN
C
                 NPAPLU=NPAPLU+1
C
C=======================================================================
C                   SELECTING INDICES IN THE POSITIVE PARITY BLOCK
C=======================================================================
C
                 IF (IPAFLI.EQ.0.AND.ICHARG.EQ.ICHFLI) THEN
C
                     IF (NPAPLU.EQ.ISPFLI) THEN
                         OBPFLI=OBSFLI
                         JSPFLI=ISTATE
                     END IF
C
                     IF (NPAPLU.EQ.ISHFLI) THEN
                         OBHFLI=OBSFLI
                         JSHFLI=ISTATE
                     END IF
C
                 END IF
C
             ELSE
C
                 NPAMIN=NPAMIN+1
C
C=======================================================================
C                   SELECTING INDICES IN THE NEGATIVE PARITY BLOCK
C=======================================================================
C
                 IF (IPAFLI.EQ.1.AND.ICHARG.EQ.ICHFLI) THEN
C
                     IF (NPAMIN.EQ.ISPFLI) THEN
                         OBPFLI=OBSFLI
                         JSPFLI=ISTATE
                     END IF
C
                     IF (NPAMIN.EQ.ISHFLI) THEN
                         OBHFLI=OBSFLI
                         JSHFLI=ISTATE
                     END IF
C
                 END IF
C
             END IF
C
          END DO
C
          IF (ICHARG.EQ.ICHFLI) THEN
C
C=======================================================================
C            PROGRAM STOPS IF THE INDICES HAVE NOT BEEN FOUND
C=======================================================================
C
              IF (JSPFLI.EQ.0.OR.JSHFLI.EQ.0) THEN
C
                  WRITE(NFIPRI,'(/,1X,20(1H/),
     *              '' ERROR IN DIABATIC BLOCKING IN CONSIQ'',
     *                                          2X,20(1H/),/,1X,20(1H/),
     *              '' ICHFLI='',I3,''   IPAFLI='',I3,''          '',3X,
     *                                          2X,20(1H/),/,1X,20(1H/),
     *              '' ISPFLI='',I3,''   ISHFLI='',I3,''   IFLIPI='',I3,
     *                                          2X,20(1H/))')
     *            ICHFLI,IPAFLI,
     *            ISPFLI,ISHFLI,IFLIPI
C
                  WRITE(NFIPRI,'(
     *                 1X,20(1H/),''  MESSAGE FROM THE CONSIQ SU'',
     *                            ''BROUTINE:'',      1X,20(1H/),/
     *                 1X,20(1H/),''  INSUFFICIENT NUMBER  OF  M'',
     *                            ''EAN-FIELD'',      1X,20(1H/),/
     *                 1X,20(1H/),''  STATES KEPT AFTER DIAGONAL'',
     *                            ''IZATION 2'',      1X,20(1H/),/
     *                 1X,20(1H/),''  INCREASE THE  NUMBSP  MATR'',
     *                            ''IX IN THE'',      1X,20(1H/),/
     *                 1X,20(1H/),''  INPUT DATA AND START AGAIN'',
     *                            ''         '',      1X,20(1H/),/)')
C
                  STOP 'INSUFFICIENT NUMBER OF STATES KEPT (CONSIQ)2'
C
              ELSE
C
C=======================================================================
C            HERE THE OCCUPATIONS ARE FLIPPED. POSITIVE  VALUES  OF  THE
C            "IFLIPI" CONTROL VARIABLE ENSURE THAT THE CHOSEN OBSERVABLE
C            HAS A LARGER VALUE IN THE OCCUPIED STATE THAN IN THE  EMPTY
C            STATE
C=======================================================================
C
                  IF ((IFLIPI.GT.0.AND.OBPFLI.GT.OBHFLI).OR.
     *                (IFLIPI.LT.0.AND.OBPFLI.LT.OBHFLI)) THEN
C
                      V_OCCU(JSPFLI)=K_OCCU(ISHFLI,IPAFLI,ICHARG)
                      V_OCCU(JSHFLI)=K_OCCU(ISPFLI,IPAFLI,ICHARG)
C
                  END IF
C
              END IF
C
          END IF
C
      END IF
C
C=======================================================================
C         FLIPPING THE OCCUPATIONS WHEN REQUIRED TO CONSTRUCT THE
C         DIABATIC CONFIGURATIONS (ALL-BLOCKS CASE)
C=======================================================================
C
      DO IPARIT=0,NDPARI
C
         NPARTY=0
C
         JSPFLI=0
         JSHFLI=0
C
         OBPFLI=0.0D0
         OBHFLI=0.0D0
C
         DO ISTATE=1,NUMBSP(0,ICHARG)+NUMBSP(1,ICHARG)
C
C=======================================================================
C           FLIPPING IS BASED ON THE VALUES OF OBSERVABLES SELECTED
C           BY THE ABSOLUTE VALUE OF THE  "NOFLIQ"  MATRIX ELEMENTS.
C           SEE COMMENTS IN SUBROUTINE NAMELI.
C=======================================================================
C
            IF ((IPARIT.EQ.0.AND.SPPARI(ISTATE,ICHARG).GT.0.0).OR.
     *          (IPARIT.EQ.1.AND.SPPARI(ISTATE,ICHARG).LT.0.0)) THEN
C
                NPARTY=NPARTY+1
C
C=======================================================================
C               SELECTING INDICES IN THE GIVEN PARITY/CHARGE  BLOCK
C=======================================================================
C
                IF (NOFLIQ(IPARIT,ICHARG).NE.0) THEN
C
                    IF (ABS(NOFLIQ(IPARIT,ICHARG)).EQ. 1)
     *                  OBSFLI=SPALIG(ISTATE,ICHARG)
C
                    IF (ABS(NOFLIQ(IPARIT,ICHARG)).EQ. 2)
     *                  OBSFLI=SPSPAL(ISTATE,ICHARG)
C
                    IF (ABS(NOFLIQ(IPARIT,ICHARG)).EQ. 3)
     *                  OBSFLI=SPXALI(ISTATE,ICHARG)
C
                    IF (ABS(NOFLIQ(IPARIT,ICHARG)).EQ. 4)
     *                  OBSFLI=SPXSPI(ISTATE,ICHARG)
C
                    IF (ABS(NOFLIQ(IPARIT,ICHARG)).EQ. 5)
     *                  OBSFLI=SPZALI(ISTATE,ICHARG)
C
                    IF (ABS(NOFLIQ(IPARIT,ICHARG)).EQ. 6)
     *                  OBSFLI=SPZSPI(ISTATE,ICHARG)
C
                    IF (ABS(NOFLIQ(IPARIT,ICHARG)).EQ. 7)
     *                  OBSFLI=SPXALI(ISTATE,ICHARG)*OMOVAX
     *                        +SPALIG(ISTATE,ICHARG)*OMOVAY
     *                        +SPZALI(ISTATE,ICHARG)*OMOVAZ
C
                    IF (ABS(NOFLIQ(IPARIT,ICHARG)).EQ. 8)
     *                  OBSFLI=SPXSPI(ISTATE,ICHARG)*OMOVAX
     *                        +SPSPAL(ISTATE,ICHARG)*OMOVAY
     *                        +SPZSPI(ISTATE,ICHARG)*OMOVAZ
C
                    IF (ABS(NOFLIQ(IPARIT,ICHARG)).EQ. 9)
     *                  OBSFLI=SPMO20(ISTATE,ICHARG)
C
                    IF (ABS(NOFLIQ(IPARIT,ICHARG)).EQ.10)
     *                  OBSFLI=SPMO22(ISTATE,ICHARG)
C
                    IF (ABS(NOFLIQ(IPARIT,ICHARG)).GT.10)
     *                  STOP ' NOFLIQ TOO LARGE IN CONSIQ'
C
C=======================================================================
C
                    IF (NPARTY.EQ.NPFLIQ(IPARIT,ICHARG)) THEN
                        OBPFLI=OBSFLI
                        JSPFLI=ISTATE
                    END IF
C
                    IF (NPARTY.EQ.NHFLIQ(IPARIT,ICHARG)) THEN
                        OBHFLI=OBSFLI
                        JSHFLI=ISTATE
                    END IF
C
                END IF
C
            END IF
C
         END DO
C
         IF (NOFLIQ(IPARIT,ICHARG).NE.0) THEN
C
C=======================================================================
C            PROGRAM STOPS IF THE INDICES HAVE NOT BEEN FOUND
C=======================================================================
C
             IF (JSPFLI.EQ.0.OR.JSHFLI.EQ.0) THEN
C
                 WRITE(NFIPRI,'(/,1X,20(1H/),
     *              '' ERROR IN DIABATIC BLOCKING IN CONSIQ'',
     *                                          2X,20(1H/),/,1X,20(1H/),
     *              '' ICHARG='',I3,''   IPARIT='',I3,''          '',3X,
     *                                          2X,20(1H/),/,1X,20(1H/),
     *              '' NPFLIG='',I3,''   NHFLIG='',I3,''   NOFLIG='',I3,
     *                                          2X,20(1H/))')
     *           ICHARG,IPARIT,
     *           NPFLIQ(IPARIT,ICHARG),
     *           NHFLIQ(IPARIT,ICHARG),
     *           NOFLIQ(IPARIT,ICHARG)
C
                 WRITE(NFIPRI,'(
     *                1X,20(1H/),''  MESSAGE FROM THE CONSIQ SU'',
     *                           ''BROUTINE:'',      1X,20(1H/),/
     *                1X,20(1H/),''  INSUFFICIENT NUMBER  OF  M'',
     *                           ''EAN-FIELD'',      1X,20(1H/),/
     *                1X,20(1H/),''  STATES KEPT AFTER DIAGONAL'',
     *                           ''IZATION 3'',      1X,20(1H/),/
     *                1X,20(1H/),''  INCREASE THE  NUMBSP  MATR'',
     *                           ''IX IN THE'',      1X,20(1H/),/
     *                1X,20(1H/),''  INPUT DATA AND START AGAIN'',
     *                           ''         '',      1X,20(1H/),/)')
C
                 STOP 'INSUFFICIENT NUMBER OF STATES KEPT (CONSIQ)3'
C
             ELSE
C
C=======================================================================
C            HERE THE OCCUPATIONS ARE FLIPPED. POSITIVE  VALUES  OF  THE
C            "NOFLIQ" MATRIX ELEMENTS  ENSURE THAT THE CHOSEN OBSERVABLE
C            HAS A LARGER VALUE IN THE OCCUPIED STATE THAN IN THE  EMPTY
C            STATE, AND VICE VERSA.
C=======================================================================
C
                 IF ((NOFLIQ(IPARIT,ICHARG).GT.0.AND.
     *                OBPFLI.GT.OBHFLI).OR.
     *               (NOFLIQ(IPARIT,ICHARG).LT.0.AND.
     *                OBPFLI.LT.OBHFLI)) THEN
C
                     V_OCCU(JSPFLI)=K_OCCU(NHFLIQ(IPARIT,ICHARG),
     *                                            IPARIT,ICHARG)
                     V_OCCU(JSHFLI)=K_OCCU(NPFLIQ(IPARIT,ICHARG),
     *                                            IPARIT,ICHARG)
C
                 END IF
C
             END IF
C
         END IF
C
      END DO
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE CONSIZ(ICHARG,NUMNUC,EFERMI,
     *                  ICHFLI,
     *                  ISPFLI,ISHFLI,IFLIPI)
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      DIMENSION
     *          EORDER(1:2*NDBASE),NORDER(1:2*NDBASE)
C
      COMMON
     *       /SPLEVS/ SPENER(1:2*NDSTAT,0:NDISOS),
     *                SPOCCU(1:2*NDSTAT,0:NDISOS),
     *                SPALIG(1:2*NDSTAT,0:NDISOS),
     *                SPSPAL(1:2*NDSTAT,0:NDISOS),
     *                SPPARI(1:2*NDSTAT,0:NDISOS),
     *                SPSIMP(1:2*NDSTAT,0:NDISOS)
      COMMON
     *       /SPSTAT/ SPXALI(1:2*NDSTAT,0:NDISOS),
     *                SPZALI(1:2*NDSTAT,0:NDISOS),
     *                SPXSPI(1:2*NDSTAT,0:NDISOS),
     *                SPZSPI(1:2*NDSTAT,0:NDISOS)
      COMMON
     *       /SPMOME/ SPMO20(1:2*NDSTAT,0:NDISOS),
     *                SPMO22(1:2*NDSTAT,0:NDISOS)
      COMMON
     *       /SIZOCC/ M_OCCU(1:2*NDSTAT,0:NDISOS),
     *                M_VACC(1:2*NDSTAT,0:NDISOS)
      COMMON
     *       /SIZNVA/ NVASIZ(0:NDISOS)
      COMMON
     *       /SIZNOC/ NOCSIZ(0:NDISOS)
      COMMON
     *       /N_FLIZ/ NPFLIZ(                  0:NDISOS),
     *                NHFLIZ(                  0:NDISOS),
     *                NOFLIZ(                  0:NDISOS)
      COMMON
     *       /N_FILZ/ NPFILZ(                  0:NDISOS),
     *                NHFILZ(                  0:NDISOS),
     *                NOFILZ(                  0:NDISOS)
      COMMON
     *       /SIZFIL/ VFISIZ(1:2*NDSTAT,0:NDISOS)
      COMMON
     *       /OMOVAS/ OMOVAX,OMOVAY,OMOVAZ
      COMMON
     *       /PROCCU/ V_OCCU(1:2*NDSTAT)
      COMMON
     *       /VACCNF/ IVACUM
      COMMON
     *       /SPNUMS/ NUMBSP(0:NDREVE,0:NDISOS)
      COMMON
     *       /CFIPRI/ NFIPRI
C
C=======================================================================
C         THIS SUBROUTINE IS CALLED IN THE CASE OF  NO SYMMETRY  AND
C         SETS THE OCCUPATION FACTORS ACCORDING TO THE CHOSEN GLOBAL
C         CONFIGURATIONS (IN CASE OF NO PAIRING).
C=======================================================================
C
C=======================================================================
C         ZEROING OCCUPATION FACTORS AND THE VACUUM CONFIGURATION DATA
C=======================================================================
C
      DO ISTATE=1,NUMBSP(0,ICHARG)+NUMBSP(1,ICHARG)
C
         V_OCCU(ISTATE)=0.0D0
C
         M_VACC(ISTATE,ICHARG)=0
C
      END DO
C
C=======================================================================
C         SETTING THE OCCUPATION FACTORS ACCORDING TO THE CONFIGURATION
C=======================================================================
C
      NOCCUP=0
      OCCFIL=0.0D0
C
      DO ISTATE=1,NUMBSP(0,ICHARG)+NUMBSP(1,ICHARG)
C
         NOCCUP=NOCCUP+ M_OCCU(ISTATE,ICHARG)
C
         V_OCCU(ISTATE)=M_OCCU(ISTATE,ICHARG)
C
         IF (NOFILZ(ICHARG).GE.1) THEN
C
             IF (ISTATE.GE.NHFILZ(ICHARG).AND.
     *           ISTATE.LE.NPFILZ(ICHARG))
     *
     *           V_OCCU(ISTATE)=VFISIZ(ISTATE,ICHARG)
C
         END IF
C
         OCCFIL=OCCFIL+V_OCCU(ISTATE)**2
C
      END DO
C
C=======================================================================
C         THE TEST BELOW ENSURES THAT THE NUMBER OF STATES KEPT AFTER
C         THE DIAGONALIZATION IS SUFFICIENT TO ACCOMODATE ALL  STATES
C         OCCUPIED IN EACH OF THE CHARGE BLOCKS. THE TEST  COULD HAVE
C         BEEN PERFORMED IN ANOTHER PLACE, HOWEVER, IT  IS  PERFORMED
C         HERE TO KEEP CONSISTENCY WITH OTHER SYMMETRIES.
C=======================================================================
C         THE TEST BELOW CAN  BE  PERFORMED  ONLY  WHEN  THE  FILLING
C         APPROXIMATION HAS NOT BEEN REQUESTED
C=======================================================================
C
      IF (NOFILZ(ICHARG).LT.1.AND.NOCCUP.NE.NVASIZ(ICHARG).AND.
     *    IVACUM.NE.1) THEN
C
          WRITE(NFIPRI,'(
     *         1X,20(1H/),''  MESSAGE FROM THE CONSIZ SU'',
     *                    ''BROUTINE:'',      1X,20(1H/),/
     *         1X,20(1H/),''  INSUFFICIENT NUMBER  OF  M'',
     *                    ''EAN-FIELD'',      1X,20(1H/),/
     *         1X,20(1H/),''  STATES KEPT AFTER DIAGONAL'',
     *                    ''IZATION 1'',      1X,20(1H/),/
     *         1X,20(1H/),''  INCREASE THE  NUMBSP  MATR'',
     *                    ''IX IN THE'',      1X,20(1H/),/
     *         1X,20(1H/),''  INPUT DATA AND START AGAIN'',
     *                    ''         '',      1X,20(1H/),/)')
C
          STOP 'INSUFFICIENT NUMBER OF STATES KEPT (CONSIZ)1'
C
      END IF
C
C=======================================================================
C         THE TEST BELOW CAN BE PERFORMED IN CASE  WHEN  THE  FILLING
C         APPROXIMATION HAS BEEN REQUESTED
C=======================================================================
C
      IF (NOFILZ(ICHARG).GE.1.AND.
     *    ABS(OCCFIL-NOCSIZ(ICHARG)).GT.1.0D-12) THEN
C
          WRITE(NFIPRI,'(
     *         1X,20(1H/),''  MESSAGE FROM THE CONSIZ SU'',
     *                    ''BROUTINE:'',      1X,20(1H/),/
     *         1X,20(1H/),''  INSUFFICIENT NUMBER  OF  M'',
     *                    ''EAN-FIELD'',      1X,20(1H/),/
     *         1X,20(1H/),''  STATES KEPT AFTER DIAGONAL'',
     *                    ''IZATION 4'',      1X,20(1H/),/
     *         1X,20(1H/),''  INCREASE THE  NUMBSP  MATR'',
     *                    ''IX IN THE'',      1X,20(1H/),/
     *         1X,20(1H/),''  INPUT DATA AND START AGAIN'',
     *                    ''         '',      1X,20(1H/),/)')
C
          STOP 'INSUFFICIENT NUMBER OF STATES KEPT (CONSIZ)4'
C
      END IF
C
C=======================================================================
C         FLIPPING THE OCCUPATIONS WHEN REQUIRED TO CONSTRUCT THE
C         DIABATIC CONFIGURATIONS (SINGLE-BLOCK CASE)
C=======================================================================
C
      IF (IFLIPI.NE.0) THEN
C
          JSPFLI=0
          JSHFLI=0
C
          OBPFLI=0.0D0
          OBHFLI=0.0D0
C
          DO ISTATE=1,NUMBSP(0,ICHARG)+NUMBSP(1,ICHARG)
C
C=======================================================================
C               FLIPPING IS BASED ON THE VALUES OF OBSERVABLES SELECTED
C               BY THE ABSOLUTE VALUE OF THE  "IFLIPI" CONTROL VARIABLE.
C               SEE COMMENTS IN SUBROUTINE NAMELI.
C=======================================================================
C
             IF (ABS(IFLIPI).EQ. 1) OBSFLI=SPALIG(ISTATE,ICHARG)
             IF (ABS(IFLIPI).EQ. 2) OBSFLI=SPSPAL(ISTATE,ICHARG)
             IF (ABS(IFLIPI).EQ. 3) OBSFLI=SPXALI(ISTATE,ICHARG)
             IF (ABS(IFLIPI).EQ. 4) OBSFLI=SPXSPI(ISTATE,ICHARG)
             IF (ABS(IFLIPI).EQ. 5) OBSFLI=SPZALI(ISTATE,ICHARG)
             IF (ABS(IFLIPI).EQ. 6) OBSFLI=SPZSPI(ISTATE,ICHARG)
C
             IF (ABS(IFLIPI).EQ. 7) OBSFLI=SPXALI(ISTATE,ICHARG)*OMOVAX
     *                                    +SPALIG(ISTATE,ICHARG)*OMOVAY
     *                                    +SPZALI(ISTATE,ICHARG)*OMOVAZ
C
             IF (ABS(IFLIPI).EQ. 8) OBSFLI=SPXSPI(ISTATE,ICHARG)*OMOVAX
     *                                    +SPSPAL(ISTATE,ICHARG)*OMOVAY
     *                                    +SPZSPI(ISTATE,ICHARG)*OMOVAZ
C
             IF (ABS(IFLIPI).EQ. 9) OBSFLI=SPMO20(ISTATE,ICHARG)
             IF (ABS(IFLIPI).EQ.10) OBSFLI=SPMO22(ISTATE,ICHARG)
C
             IF (ABS(IFLIPI).GT.10) STOP ' IFLIPI TOO LARGE IN CONSIZ'
C
C=======================================================================
C               SELECTING INDICES
C=======================================================================
C
             IF (ICHARG.EQ.ICHFLI) THEN
C
                 IF (ISTATE.EQ.ISPFLI) THEN
                     OBPFLI=OBSFLI
                     JSPFLI=ISTATE
                 END IF
C
                 IF (ISTATE.EQ.ISHFLI) THEN
                     OBHFLI=OBSFLI
                     JSHFLI=ISTATE
                 END IF
C
             END IF
C
          END DO
C
          IF (ICHARG.EQ.ICHFLI) THEN
C
C=======================================================================
C            A WARNING IS ISSUED IF THE INDICES HAVE NOT BEEN SELECTED
C=======================================================================
C
              IF (JSPFLI.EQ.0.OR.JSHFLI.EQ.0) THEN
C
                  WRITE(NFIPRI,'(/,1X,20(1H/),
     *              '' ERROR IN DIABATIC BLOCKING IN CONSIZ'',
     *                                          2X,20(1H/),/,1X,20(1H/),
     *              ''   ICHFLI='',I3,''        '',3X,''          '',3X,
     *                                          2X,20(1H/),/,1X,20(1H/),
     *              '' ISPFLI='',I3,''   ISHFLI='',I3,''   IFLIPI='',I3,
     *                                          2X,20(1H/))')
     *            ICHFLI,
     *            ISPFLI,ISHFLI,IFLIPI
C
                  WRITE(NFIPRI,'(
     *                 1X,20(1H/),''  MESSAGE FROM THE CONSIZ SU'',
     *                            ''BROUTINE:'',      1X,20(1H/),/
     *                 1X,20(1H/),''  INSUFFICIENT NUMBER  OF  M'',
     *                            ''EAN-FIELD'',      1X,20(1H/),/
     *                 1X,20(1H/),''  STATES KEPT AFTER DIAGONAL'',
     *                            ''IZATION 2'',      1X,20(1H/),/
     *                 1X,20(1H/),''  INCREASE THE  NUMBSP  MATR'',
     *                            ''IX IN THE'',      1X,20(1H/),/
     *                 1X,20(1H/),''  INPUT DATA AND START AGAIN'',
     *                            ''         '',      1X,20(1H/),/)')
C
                  STOP 'INSUFFICIENT NUMBER OF STATES KEPT (CONSIZ)2'
C
              ELSE
C
C=======================================================================
C            HERE THE OCCUPATIONS ARE FLIPPED. POSITIVE  VALUES  OF  THE
C            "IFLIPI" CONTROL VARIABLE ENSURE THAT THE CHOSEN OBSERVABLE
C            HAS A LARGER VALUE IN THE OCCUPIED STATE THAN IN THE  EMPTY
C            STATE
C=======================================================================
C
                  IF ((IFLIPI.GT.0.AND.OBPFLI.GT.OBHFLI).OR.
     *                (IFLIPI.LT.0.AND.OBPFLI.LT.OBHFLI)) THEN
C
                      V_OCCU(JSPFLI)=M_OCCU(ISHFLI,ICHARG)
                      V_OCCU(JSHFLI)=M_OCCU(ISPFLI,ICHARG)
C
                  END IF
C
              END IF
C
          END IF
C
      END IF
C
C=======================================================================
C         FLIPPING THE OCCUPATIONS WHEN REQUIRED TO CONSTRUCT THE
C         DIABATIC CONFIGURATIONS (ALL-BLOCKS CASE)
C=======================================================================
C
      NPARTY=0
C
      JSPFLI=0
      JSHFLI=0
C
      OBPFLI=0.0D0
      OBHFLI=0.0D0
C
      DO ISTATE=1,NUMBSP(0,ICHARG)+NUMBSP(1,ICHARG)
C
C=======================================================================
C        FLIPPING IS BASED ON THE VALUES OF OBSERVABLES SELECTED
C        BY THE ABSOLUTE VALUE OF THE  "NOFLIZ"  MATRIX ELEMENTS.
C        SEE COMMENTS IN SUBROUTINE NAMELI.
C=======================================================================
C
         NPARTY=NPARTY+1
C
C=======================================================================
C        SELECTING INDICES IN THE GIVEN CHARGE  BLOCK
C=======================================================================
C
         IF (NOFLIZ(ICHARG).NE.0) THEN
C
             IF (ABS(NOFLIZ(ICHARG)).EQ. 1) OBSFLI=SPALIG(ISTATE,ICHARG)
C
             IF (ABS(NOFLIZ(ICHARG)).EQ. 2) OBSFLI=SPSPAL(ISTATE,ICHARG)
C
             IF (ABS(NOFLIZ(ICHARG)).EQ. 3) OBSFLI=SPXALI(ISTATE,ICHARG)
C
             IF (ABS(NOFLIZ(ICHARG)).EQ. 4) OBSFLI=SPXSPI(ISTATE,ICHARG)
C
             IF (ABS(NOFLIZ(ICHARG)).EQ. 5) OBSFLI=SPZALI(ISTATE,ICHARG)
C
             IF (ABS(NOFLIZ(ICHARG)).EQ. 6) OBSFLI=SPZSPI(ISTATE,ICHARG)
C
             IF (ABS(NOFLIZ(ICHARG)).EQ. 7)
     *           OBSFLI=SPXALI(ISTATE,ICHARG)*OMOVAX
     *                 +SPALIG(ISTATE,ICHARG)*OMOVAY
     *                 +SPZALI(ISTATE,ICHARG)*OMOVAZ
C
             IF (ABS(NOFLIZ(ICHARG)).EQ. 8)
     *           OBSFLI=SPXSPI(ISTATE,ICHARG)*OMOVAX
     *                 +SPSPAL(ISTATE,ICHARG)*OMOVAY
     *                 +SPZSPI(ISTATE,ICHARG)*OMOVAZ
C
             IF (ABS(NOFLIZ(ICHARG)).EQ. 9) OBSFLI=SPMO20(ISTATE,ICHARG)
C
             IF (ABS(NOFLIZ(ICHARG)).EQ.10) OBSFLI=SPMO22(ISTATE,ICHARG)
C
             IF (ABS(NOFLIZ(ICHARG)).GT.10)
     *           STOP ' NOFLIZ TOO LARGE IN CONSIZ'
C
C=======================================================================
C
             IF (NPARTY.EQ.NPFLIZ(ICHARG)) THEN
                 OBPFLI=OBSFLI
                 JSPFLI=ISTATE
             END IF
C
             IF (NPARTY.EQ.NHFLIZ(ICHARG)) THEN
                 OBHFLI=OBSFLI
                 JSHFLI=ISTATE
             END IF
C
         END IF
C
      END DO
C
      IF (NOFLIZ(ICHARG).NE.0) THEN
C
C=======================================================================
C         PROGRAM STOPS IF THE INDICES HAVE NOT BEEN FOUND
C=======================================================================
C
          IF (JSPFLI.EQ.0.OR.JSHFLI.EQ.0) THEN
C
              WRITE(NFIPRI,'(/,1X,20(1H/),
     *              '' ERROR IN DIABATIC BLOCKING IN CONSIZ'',
     *                                          2X,20(1H/),/,1X,20(1H/),
     *              '' ICHARG='',I3,''          '',3X,''          '',3X,
     *                                          2X,20(1H/),/,1X,20(1H/),
     *              '' NPFLIZ='',I3,''   NHFLIZ='',I3,''   NOFLIZ='',I3,
     *                                          2X,20(1H/))')
     *        ICHARG,
     *        NPFLIZ(ICHARG),
     *        NHFLIZ(ICHARG),
     *        NOFLIZ(ICHARG)
C
              WRITE(NFIPRI,'(
     *             1X,20(1H/),''  MESSAGE FROM THE CONSIZ SU'',
     *                        ''BROUTINE:'',      1X,20(1H/),/
     *             1X,20(1H/),''  INSUFFICIENT NUMBER  OF  M'',
     *                        ''EAN-FIELD'',      1X,20(1H/),/
     *             1X,20(1H/),''  STATES KEPT AFTER DIAGONAL'',
     *                        ''IZATION 3'',      1X,20(1H/),/
     *             1X,20(1H/),''  INCREASE THE  NUMBSP  MATR'',
     *                        ''IX IN THE'',      1X,20(1H/),/
     *             1X,20(1H/),''  INPUT DATA AND START AGAIN'',
     *                        ''         '',      1X,20(1H/),/)')
C
              STOP 'INSUFFICIENT NUMBER OF STATES KEPT (CONSIZ)3'
C
          ELSE
C
C=======================================================================
C            HERE THE OCCUPATIONS ARE FLIPPED. POSITIVE  VALUES  OF  THE
C            "NOFLIZ" MATRIX ELEMENTS  ENSURE THAT THE CHOSEN OBSERVABLE
C            HAS A LARGER VALUE IN THE OCCUPIED STATE THAN IN THE  EMPTY
C            STATE, AND VICE VERSA.
C=======================================================================
C
              IF ((NOFLIZ(ICHARG).GT.0.AND.OBPFLI.GT.OBHFLI).OR.
     *            (NOFLIZ(ICHARG).LT.0.AND.OBPFLI.LT.OBHFLI)) THEN
C
                  V_OCCU(JSPFLI)=M_OCCU(NHFLIZ(ICHARG),ICHARG)
                  V_OCCU(JSHFLI)=M_OCCU(NPFLIZ(ICHARG),ICHARG)
C
              END IF
C
          END IF
C
      END IF
C
C=======================================================================
C        DETERMINING THE ORDERED SINGLE-PARTICLE SPECTRUM AND
C        THE FERMI ENERGY
C=======================================================================
C
      IORDER=0
C
      DO ISTATE=1,NUMBSP(0,ICHARG)+NUMBSP(1,ICHARG)
C
         IORDER=IORDER+1
         NORDER(IORDER)=IORDER
         EORDER(IORDER)=SPENER(ISTATE,ICHARG)
C
      END DO
C
      CALL ORDER1(EORDER,NORDER,IORDER)
C
      NUMACT=NUMNUC
C
      EFERMI=0.5D0*(EORDER(NUMACT+1)+EORDER(NUMACT))
C
C=======================================================================
C         DETERMINING THE VACUUM CONFIGURATION
C=======================================================================
C
      IPARTI=0
C
      DO ISTATE=1,NUMBSP(0,ICHARG)+NUMBSP(1,ICHARG)
C
         IF (SPENER(ISTATE,ICHARG).LT.EFERMI) THEN
C
             IPARTI=IPARTI+1
C
             M_VACC(ISTATE,ICHARG)=1
C
         END IF
C
      END DO
C
C      In case of vacuum configuration, all lowest states up to the
C      Fermi level are occupied, all other states empty
C
      IF (IVACUM.EQ.1) THEN
C
          DO ISTATE=1,NUMACT
             V_OCCU(ISTATE)=1.0D0
          END DO
C
          DO ISTATE=NUMACT+1,NUMBSP(0,ICHARG)+NUMBSP(1,ICHARG)
             V_OCCU(ISTATE)=0.0D0
          END DO
C
      END IF
C
C=======================================================================
C        IN CASE OF DEGENERATE STATES AT THE FERMI  ENERGY  THE
C        CONFIGURATION DATA ARE SET TO 100 TO OBTAIN  ASTERISKS
C        ON THE OUTPUT. A BETTER TREATMENT OF SUCH A DEGENERACY
C        IS STILL TO BE FOUND.
C=======================================================================
C
      IF (IPARTI.NE.NUMACT) THEN
C
          DO ISTATE=1,NUMBSP(0,ICHARG)+NUMBSP(1,ICHARG)
C
             M_VACC(ISTATE,ICHARG)=100
C
          END DO
C
      END IF
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE SIGTAB(MREVER,ICHFLI,IPAFLI,IREFLI,
     *                         ISPFLI,ISHFLI,IFLIPI)
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      CHARACTER
     *          CHASIG(0:NDPARI)*1,NAMNUC(0:NDISOS)*8
      CHARACTER
     *          NLOCCU(1:NDSTAT,0:NDPARI,0:NDREVE,0:NDISOS)*3,
     *          NLVACC(1:NDSTAT,0:NDPARI,0:NDREVE,0:NDISOS)*3
C
      COMMON
     *       /SIGOCC/ N_OCCU(1:NDSTAT,0:NDPARI,0:NDREVE,0:NDISOS),
     *                N_VACC(1:NDSTAT,0:NDPARI,0:NDREVE,0:NDISOS)
      COMMON
     *       /N_FLIG/ NPFLIG(0:NDPARI,0:NDREVE,0:NDISOS),
     *                NHFLIG(0:NDPARI,0:NDREVE,0:NDISOS),
     *                NOFLIG(0:NDPARI,0:NDREVE,0:NDISOS)
      COMMON
     *       /N_FILG/ NPFILG(0:NDPARI,0:NDREVE,0:NDISOS),
     *                NHFILG(0:NDPARI,0:NDREVE,0:NDISOS),
     *                NOFILG(0:NDPARI,0:NDREVE,0:NDISOS)
      COMMON
     *       /SPNUMS/ NUMBSP(0:NDREVE,0:NDISOS)
      COMMON
     *       /CFIPRI/ NFIPRI
C
      DATA
     *       NAMNUC /'NEUTRON ','PROTON  '/
      DATA
     *       CHASIG /'+','-'/
C
C=======================================================================
C         THIS SUBROUTINE PRINTS THE CONFIGURATION DATA
C         FOR THE PARITY/SIGNATURE CASE
C=======================================================================
C
      IF (MREVER.EQ.1) THEN
          IDEGEN=1
      ELSE
          IDEGEN=2
      END IF
C
C=======================================================================
C         SELECTING STATES AFFECTED BY THE DIABATIC BLOCKING OR FILLING
C=======================================================================
C
      DO ICHARG=0,NDISOS
         DO IPARIT=0,NDPARI
            DO IREVER=0,MREVER
C
               DO ISTATE=1,NDSTAT
C
                  WRITE(NLOCCU(ISTATE,IPARIT,IREVER,ICHARG),'(I1,2X)')
     *                  N_OCCU(ISTATE,IPARIT,IREVER,ICHARG)*IDEGEN
                  WRITE(NLVACC(ISTATE,IPARIT,IREVER,ICHARG),'(A3)')'N  '
C
               END DO
C
               JSPFLI=NPFLIG(IPARIT,IREVER,ICHARG)
               JSHFLI=NHFLIG(IPARIT,IREVER,ICHARG)
               JFLIPI=NOFLIG(IPARIT,IREVER,ICHARG)
C
               JSPFIL=NPFILG(IPARIT,IREVER,ICHARG)
               JSHFIL=NHFILG(IPARIT,IREVER,ICHARG)
               JFILPI=NOFILG(IPARIT,IREVER,ICHARG)
C
               DO ISTATE=1,NUMBSP(IREVER,ICHARG)
C
                  IF ((IFLIPI.NE.0.AND.ICHARG.EQ.ICHFLI.AND.
     *                                 IPARIT.EQ.IPAFLI.AND.
     *                                 IREVER.EQ.IREFLI.AND.
     *                     ISTATE.GE.MIN(ISHFLI,ISPFLI).AND.
     *                     ISTATE.LT.MAX(ISHFLI,ISPFLI)).OR.
     *                (JFLIPI.NE.0.AND.
     *                     ISTATE.GE.MIN(JSHFLI,JSPFLI).AND.
     *                     ISTATE.LT.MAX(JSHFLI,JSPFLI))) THEN
C
                      NLOCCU(ISTATE,IPARIT,IREVER,ICHARG)(2:3)='><'
C
                  END IF
C
                  IF (JFILPI.GE.1.AND.
     *                ISTATE.GE.JSHFIL.AND.ISTATE.LT.JSPFIL) THEN
C
                      NLOCCU(ISTATE,IPARIT,IREVER,ICHARG)(2:3)='--'
C
                  END IF
C
                  WRITE(NLVACC(ISTATE,IPARIT,IREVER,ICHARG)(1:1),'(I1)')
     *                  N_VACC(ISTATE,IPARIT,IREVER,ICHARG)*IDEGEN
C
               END DO
C
            END DO
         END DO
      END DO
C
C=======================================================================
C         SELECTING STATES AROUND THE FERMI LEVEL TO BE PRINTED
C=======================================================================
C
      DO ICHARG=0,NDISOS
C
         INDMIN=10000
         INDMAX=0
C
         DO IPARIT=0,NDPARI
            DO IREVER=0,MREVER
               DO ISTATE=1,NUMBSP(IREVER,ICHARG)
C
                  IF (N_OCCU(ISTATE,IPARIT,IREVER,ICHARG).EQ.0.OR.
     *                N_VACC(ISTATE,IPARIT,IREVER,ICHARG).EQ.0)
     *                INDMIN=MIN(INDMIN,ISTATE)
C
                  IF (N_OCCU(ISTATE,IPARIT,IREVER,ICHARG).EQ.1.OR.
     *                N_VACC(ISTATE,IPARIT,IREVER,ICHARG).EQ.1)
     *                INDMAX=MAX(INDMAX,ISTATE)
C
               END DO
            END DO
         END DO
C
C=======================================================================
C        PRINTING CONFIGURATIONS
C=======================================================================
C=======================================================================
C            ATTENTION: THE MATRICES WITH CONFIGURATIONS  USE THE
C                       TIME-REVERSAL CONVENTION.   THEREFORE, IN
C                       ORDER TO PRINT THE CONFIGURATIONS  IN THE
C                       PARITY/SIGNATURE CONVENTION, THE NEGATIVE
C                       PARITY BLOCKS CORRESPOND TO THE EXCHANGED
C                       IREVER BLOCKS. THE PRINTING ORDER IS:
C                       (PARITY,IREVER)  = (+,+) (+,-) (-,-) (-,+)
C=======================================================================
C
         ISTART=MAX((INDMIN+INDMAX)/2-10,1)
         IFINIS=ISTART+20
C
         WRITE(NFIPRI,'(79(1H*),/,                   1H*,77X,1H*,/,
     *                 1H*,27X,A8,'' CONFIGURATIONS'',   27X,1H*,/,
     *                 1H*,27X,23(''=''),                27X,1H*,/,
     *                 1H*,2X,''      P S'',1X,21I3,      2X,1H*,/,
     *                 1H*,2X,''      ---'',2X,62(''-''), 2X,1H*,/,
     *                 1H*,                              77X,1H*)')
     *
     *   NAMNUC(ICHARG),(I,I=ISTART,IFINIS)
C
         WRITE(NFIPRI,'(2(1H*,2X,A5,2(1X,A1),      3X,21(A3),1H*,/),
     *                                               1H*,77X,1H*)')
     *
     *    (('CONF:',CHASIG(IPARIT),CHASIG(IREVER),
     *       (NLOCCU(ISTATE,IPARIT,IREVER,ICHARG),
     *               ISTATE=ISTART,IFINIS),
     *
     *      'VACC:',CHASIG(IPARIT),CHASIG(IREVER),
     *       (NLVACC(ISTATE,IPARIT,IREVER,ICHARG),
     *               ISTATE=ISTART,IFINIS),
     *                             IREVER=0,MREVER),IPARIT=0,0),
     *
     *    (('CONF:',CHASIG(IPARIT),CHASIG(1-IREVER),
     *       (NLOCCU(ISTATE,IPARIT,IREVER,ICHARG),
     *               ISTATE=ISTART,IFINIS),
     *
     *      'VACC:',CHASIG(IPARIT),CHASIG(1-IREVER),
     *       (NLVACC(ISTATE,IPARIT,IREVER,ICHARG),
     *               ISTATE=ISTART,IFINIS),
     *                             IREVER=MREVER,0,-1),IPARIT=1,1)
C
      END DO
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE SIMTAB(MREVER,ICHFLI,       IREFLI,
     *                         ISPFLI,ISHFLI,IFLIPI)
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      CHARACTER
     *          CHASIM(0:NDREVE)*1,NAMNUC(0:NDISOS)*8
      CHARACTER
     *          LLOCCU(1:NDSTAT,0:NDREVE,0:NDISOS)*3,
     *          LLVACC(1:NDSTAT,0:NDREVE,0:NDISOS)*3
C
      COMMON
     *       /SIMOCC/ L_OCCU(1:NDSTAT,0:NDREVE,0:NDISOS),
     *                L_VACC(1:NDSTAT,0:NDREVE,0:NDISOS)
      COMMON
     *       /N_FLIM/ NPFLIM(0:NDREVE,0:NDISOS),
     *                NHFLIM(0:NDREVE,0:NDISOS),
     *                NOFLIM(0:NDREVE,0:NDISOS)
      COMMON
     *       /SPNUMS/ NUMBSP(0:NDREVE,0:NDISOS)
      COMMON
     *       /CFIPRI/ NFIPRI
C
      DATA
     *       NAMNUC /'NEUTRON ','PROTON  '/
      DATA
     *       CHASIM /'+','-'/
C
C=======================================================================
C         THIS SUBROUTINE PRINTS THE CONFIGURATION DATA
C         FOR THE SIMPLEX CASE
C=======================================================================
C
      IF (MREVER.EQ.1) THEN
          IDEGEN=1
      ELSE
          IDEGEN=2
      END IF
C
C=======================================================================
C         SELECTING STATES AFFECTED BY THE DIABATIC BLOCKING
C=======================================================================
C
      DO ICHARG=0,NDISOS
         DO IREVER=0,MREVER
C
            DO ISTATE=1,NDSTAT
C
               WRITE(LLOCCU(ISTATE,IREVER,ICHARG),'(I1,2X)')
     *               L_OCCU(ISTATE,IREVER,ICHARG)*IDEGEN
               WRITE(LLVACC(ISTATE,IREVER,ICHARG),'(A3)') 'N  '
C
            END DO
C
            JSPFLI=NPFLIM(IREVER,ICHARG)
            JSHFLI=NHFLIM(IREVER,ICHARG)
            JFLIPI=NOFLIM(IREVER,ICHARG)
C
            DO ISTATE=1,NUMBSP(IREVER,ICHARG)
C
               IF ((IFLIPI.NE.0.AND.ICHARG.EQ.ICHFLI.AND.
     *                              IREVER.EQ.IREFLI.AND.
     *                  ISTATE.GE.MIN(ISHFLI,ISPFLI).AND.
     *                  ISTATE.LT.MAX(ISHFLI,ISPFLI)).OR.
     *             (JFLIPI.NE.0.AND.
     *                  ISTATE.GE.MIN(JSHFLI,JSPFLI).AND.
     *                  ISTATE.LT.MAX(JSHFLI,JSPFLI))) THEN
C
                   LLOCCU(ISTATE,IREVER,ICHARG)(2:3)='><'
C
               END IF
C
               WRITE(LLVACC(ISTATE,IREVER,ICHARG)(1:1),'(I1)')
     *               L_VACC(ISTATE,IREVER,ICHARG)*IDEGEN
C
            END DO
         END DO
      END DO
C
C=======================================================================
C         SELECTING STATES AROUND THE FERMI LEVEL TO BE PRINTED
C=======================================================================
C
      DO ICHARG=0,NDISOS
C
         INDMIN=10000
         INDMAX=0
C
         DO IREVER=0,MREVER
            DO ISTATE=1,NUMBSP(IREVER,ICHARG)
C
               IF (L_OCCU(ISTATE,IREVER,ICHARG).EQ.0.OR.
     *             L_VACC(ISTATE,IREVER,ICHARG).EQ.0)
     *             INDMIN=MIN(INDMIN,ISTATE)
C
               IF (L_OCCU(ISTATE,IREVER,ICHARG).EQ.1.OR.
     *             L_VACC(ISTATE,IREVER,ICHARG).EQ.1)
     *             INDMAX=MAX(INDMAX,ISTATE)
C
            END DO
         END DO
C
C=======================================================================
C        PRINTING CONFIGURATIONS
C=======================================================================
C
         ISTART=MAX((INDMIN+INDMAX)/2-10,1)
         IFINIS=ISTART+20
C
         WRITE(NFIPRI,'(79(1H*),/,                   1H*,77X,1H*,/,
     *                 1H*,27X,A8,'' CONFIGURATIONS'',   27X,1H*,/,
     *                 1H*,27X,23(''=''),                27X,1H*,/,
     *                 1H*,2X,''      SIM'',1X,21I3,      2X,1H*,/,
     *                 1H*,2X,''      ---'',2X,62(''-''), 2X,1H*,/,
     *                 1H*,                              77X,1H*)')
     *
     *    NAMNUC(ICHARG),(I,I=ISTART,IFINIS)
C
          WRITE(NFIPRI,'(2(1H*,2X,A5,'' ('',A1,'')'',3X,21(A3),1H*,/),
     *                                                 1H*,77X,1H*)')
     *
     *     ('CONF:',CHASIM(IREVER),
     *       (LLOCCU(ISTATE,IREVER,ICHARG),ISTATE=ISTART,IFINIS),
     *
     *      'VACC:',CHASIM(IREVER),
     *       (LLVACC(ISTATE,IREVER,ICHARG),ISTATE=ISTART,IFINIS),
     *                                                  IREVER=0,MREVER)
C
      END DO
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE SIQTAB(ICHFLI,IPAFLI,
     *                  ISPFLI,ISHFLI,IFLIPI)
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      CHARACTER
     *          CHASIQ(0:NDPARI)*1,NAMNUC(0:NDISOS)*8
      CHARACTER
     *          KLOCCU(1:2*NDSTAT,0:NDPARI,0:NDISOS)*3,
     *          KLVACC(1:2*NDSTAT,0:NDPARI,0:NDISOS)*3
C
      COMMON
     *       /SIQOCC/ K_OCCU(1:2*NDSTAT,0:NDPARI,0:NDISOS),
     *                K_VACC(1:2*NDSTAT,0:NDPARI,0:NDISOS)
      COMMON
     *       /N_FLIQ/ NPFLIQ(0:NDPARI,         0:NDISOS),
     *                NHFLIQ(0:NDPARI,         0:NDISOS),
     *                NOFLIQ(0:NDPARI,         0:NDISOS)
      COMMON
     *       /SPNUMS/ NUMBSP(0:NDREVE,0:NDISOS)
      COMMON
     *       /CFIPRI/ NFIPRI
C
      DATA
     *       NAMNUC /'NEUTRON ','PROTON  '/
      DATA
     *       CHASIQ /'+','-'/
C
C=======================================================================
C         THIS SUBROUTINE PRINTS THE CONFIGURATION DATA
C         FOR THE PARITY CASE
C=======================================================================
C
      IDEGEN=1
C
C=======================================================================
C         SELECTING STATES AFFECTED BY THE DIABATIC BLOCKING
C=======================================================================
C
      DO ICHARG=0,NDISOS
         DO IPARIT=0,NDPARI
C
            DO ISTATE=1,2*NDSTAT
C
               WRITE(KLOCCU(ISTATE,IPARIT,ICHARG),'(I1,2X)')
     *               K_OCCU(ISTATE,IPARIT,ICHARG)*IDEGEN
               WRITE(KLVACC(ISTATE,IPARIT,ICHARG),'(A3)') 'N  '
C
            END DO
C
            JSPFLI=NPFLIQ(IPARIT,ICHARG)
            JSHFLI=NHFLIQ(IPARIT,ICHARG)
            JFLIPI=NOFLIQ(IPARIT,ICHARG)
C
            DO ISTATE=1,NUMBSP(0,ICHARG)+NUMBSP(1,ICHARG)
C
               IF ((IFLIPI.NE.0.AND.ICHARG.EQ.ICHFLI.AND.
     *                              IPARIT.EQ.IPAFLI.AND.
     *                  ISTATE.GE.MIN(ISHFLI,ISPFLI).AND.
     *                  ISTATE.LT.MAX(ISHFLI,ISPFLI)).OR.
     *             (JFLIPI.NE.0.AND.
     *                  ISTATE.GE.MIN(JSHFLI,JSPFLI).AND.
     *                  ISTATE.LT.MAX(JSHFLI,JSPFLI))) THEN
C
                   KLOCCU(ISTATE,IPARIT,ICHARG)(2:3)='><'
C
               END IF
C
               WRITE(KLVACC(ISTATE,IPARIT,ICHARG)(1:1),'(I1)')
     *               K_VACC(ISTATE,IPARIT,ICHARG)*IDEGEN
C
            END DO
         END DO
      END DO
C
C=======================================================================
C         SELECTING STATES AROUND THE FERMI LEVEL TO BE PRINTED
C=======================================================================
C
      DO ICHARG=0,NDISOS
C
         INDMIN=10000
         INDMAX=0
C
         DO IPARIT=1,NDPARI
            DO ISTATE=1,NUMBSP(0,ICHARG)+NUMBSP(1,ICHARG)
C
               IF (K_OCCU(ISTATE,IPARIT,ICHARG).EQ.0.OR.
     *             K_VACC(ISTATE,IPARIT,ICHARG).EQ.0)
     *             INDMIN=MIN(INDMIN,ISTATE)
C
               IF (K_OCCU(ISTATE,IPARIT,ICHARG).EQ.1.OR.
     *             K_VACC(ISTATE,IPARIT,ICHARG).EQ.1)
     *             INDMAX=MAX(INDMAX,ISTATE)
C
            END DO
         END DO
C
C=======================================================================
C        PRINTING CONFIGURATIONS
C=======================================================================
C
         ISTART=MAX((INDMIN+INDMAX)/2-10,1)
         IFINIS=ISTART+20
C
         WRITE(NFIPRI,'(79(1H*),/,                   1H*,77X,1H*,/,
     *                 1H*,27X,A8,'' CONFIGURATIONS'',   27X,1H*,/,
     *                 1H*,27X,23(''=''),                27X,1H*,/,
     *                 1H*,2X,''      PAR'',1X,21I3,      2X,1H*,/,
     *                 1H*,2X,''      ---'',2X,62(''-''), 2X,1H*,/,
     *                 1H*,                              77X,1H*)')
     *
     *    NAMNUC(ICHARG),(I,I=ISTART,IFINIS)
C
          WRITE(NFIPRI,'(2(1H*,2X,A5,'' ('',A1,'')'',3X,21(A3),1H*,/),
     *                                                 1H*,77X,1H*)')
     *
     *     ('CONF:',CHASIQ(IPARIT),
     *       (KLOCCU(ISTATE,IPARIT,ICHARG),ISTATE=ISTART,IFINIS),
     *
     *      'VACC:',CHASIQ(IPARIT),
     *       (KLVACC(ISTATE,IPARIT,ICHARG),ISTATE=ISTART,IFINIS),
     *                                                  IPARIT=0,NDPARI)
C
      END DO
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE SIZTAB(ICHFLI,
     *                  ISPFLI,ISHFLI,IFLIPI)
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      CHARACTER
     *          NAMNUC(0:NDISOS)*8
      CHARACTER
     *          MLOCCU(1:2*NDSTAT,0:NDISOS)*3,
     *          MLVACC(1:2*NDSTAT,0:NDISOS)*3
C
      COMMON
     *       /SIZOCC/ M_OCCU(1:2*NDSTAT,0:NDISOS),
     *                M_VACC(1:2*NDSTAT,0:NDISOS)
      COMMON
     *       /N_FLIZ/ NPFLIZ(                  0:NDISOS),
     *                NHFLIZ(                  0:NDISOS),
     *                NOFLIZ(                  0:NDISOS)
      COMMON
     *       /N_FILZ/ NPFILZ(                  0:NDISOS),
     *                NHFILZ(                  0:NDISOS),
     *                NOFILZ(                  0:NDISOS)
      COMMON
     *       /SPNUMS/ NUMBSP(0:NDREVE,0:NDISOS)
      COMMON
     *       /CFIPRI/ NFIPRI
C
      DATA
     *       NAMNUC /'NEUTRON ','PROTON  '/
C
C=======================================================================
C         THIS SUBROUTINE PRINTS THE CONFIGURATION DATA
C         FOR THE CASE OF NO SYMMETRY
C=======================================================================
C
      IDEGEN=1
C
C=======================================================================
C         SELECTING STATES AFFECTED BY THE DIABATIC BLOCKING
C=======================================================================
C
      DO ICHARG=0,NDISOS
C
         DO ISTATE=1,2*NDSTAT
C
            WRITE(MLOCCU(ISTATE,ICHARG),'(I1,2X)')
     *            M_OCCU(ISTATE,ICHARG)*IDEGEN
            WRITE(MLVACC(ISTATE,ICHARG),'(A3)') 'N  '
C
         END DO
C
         JSPFLI=NPFLIZ(ICHARG)
         JSHFLI=NHFLIZ(ICHARG)
         JFLIPI=NOFLIZ(ICHARG)
C
         JSPFIL=NPFILZ(ICHARG)
         JSHFIL=NHFILZ(ICHARG)
         JFILPI=NOFILZ(ICHARG)
C
         DO ISTATE=1,NUMBSP(0,ICHARG)+NUMBSP(1,ICHARG)
C
            IF ((IFLIPI.NE.0.AND.ICHARG.EQ.ICHFLI.AND.
     *               ISTATE.GE.MIN(ISHFLI,ISPFLI).AND.
     *               ISTATE.LT.MAX(ISHFLI,ISPFLI)).OR.
     *          (JFLIPI.NE.0.AND.
     *               ISTATE.GE.MIN(JSHFLI,JSPFLI).AND.
     *               ISTATE.LT.MAX(JSHFLI,JSPFLI))) THEN
C
                MLOCCU(ISTATE,ICHARG)(2:3)='><'
C
            END IF
C
            IF (JFILPI.NE.0.AND.
     *          ISTATE.GE.JSHFIL.AND.ISTATE.LT.JSPFIL) THEN
C
                MLOCCU(ISTATE,ICHARG)(2:3)='--'
C
            END IF
C
            WRITE(MLVACC(ISTATE,ICHARG)(1:1),'(I1)')
     *            M_VACC(ISTATE,ICHARG)*IDEGEN
C
         END DO
      END DO
C
C=======================================================================
C         SELECTING STATES AROUND THE FERMI LEVEL TO BE PRINTED
C=======================================================================
C
      DO ICHARG=0,NDISOS
C
         INDMIN=10000
         INDMAX=0
C
         DO ISTATE=1,NUMBSP(0,ICHARG)+NUMBSP(1,ICHARG)
C
            IF (M_OCCU(ISTATE,ICHARG).EQ.0.OR.
     *          M_VACC(ISTATE,ICHARG).EQ.0)
     *          INDMIN=MIN(INDMIN,ISTATE)
C
            IF (M_OCCU(ISTATE,ICHARG).EQ.1.OR.
     *          M_VACC(ISTATE,ICHARG).EQ.1)
     *          INDMAX=MAX(INDMAX,ISTATE)
C
         END DO
C
C=======================================================================
C        PRINTING CONFIGURATIONS
C=======================================================================
C
         ISTART=MAX((INDMIN+INDMAX)/2-11,1)
         IFINIS=ISTART+22
C
         WRITE(NFIPRI,'(79(1H*),/,                   1H*,77X,1H*,/,
     *                 1H*,27X,A8,'' CONFIGURATIONS'',   27X,1H*,/,
     *                 1H*,27X,23(''=''),                27X,1H*,/,
     *                 1H*,5X,              1X,23I3,      2X,1H*,/,
     *                 1H*,5X,              2X,68(''-''), 2X,1H*,/,
     *                 1H*,                              77X,1H*)')
     *
     *    NAMNUC(ICHARG),(I,I=ISTART,IFINIS)
C
          WRITE(NFIPRI,'(2(1H*,2X,A5,              1X,23(A3),1H*,/),
     *                                               1H*,77X,1H*)')
     *
     *      'CONF:',
     *       (MLOCCU(ISTATE,ICHARG),ISTATE=ISTART,IFINIS),
     *
     *      'VACC:',
     *       (MLVACC(ISTATE,ICHARG),ISTATE=ISTART,IFINIS)
C
      END DO
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE DUMSIG(NUPAHO,IPARIT,IREVER,ICHARG,N_PART,N_HOLE)
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      DIMENSION
     *          N_PART(NDPAHO,0:NDPARI,0:NDREVE),
     *          N_HOLE(NDPAHO,0:NDPARI,0:NDREVE)
C
      COMMON
     *       /SIGNPH/ NPPPRP(NDPAHO,0:NDISOS),NPPPRM(NDPAHO,0:NDISOS),
     *                NPPMRP(NDPAHO,0:NDISOS),NPPMRM(NDPAHO,0:NDISOS),
     *                NHPPRP(NDPAHO,0:NDISOS),NHPPRM(NDPAHO,0:NDISOS),
     *                NHPMRP(NDPAHO,0:NDISOS),NHPMRM(NDPAHO,0:NDISOS)
      COMMON
     *       /SIGNVA/ NVASIG(0:NDPARI,0:NDREVE,0:NDISOS)
      COMMON
     *       /CFIPRI/ NFIPRI
C
C=======================================================================
C         THIS SUBROUTINE DUMPS ON THE OUTPUT THE CONFIGURATION DATA
C         FOR THE PARITY/SIGNATURE CASE
C=======================================================================
C
      WRITE(NFIPRI,'(/,
     *             1X,20(1H/),''    WRONG CONFIGURATION NO. '',I2,
     *                                                   5X,20(1H/),/,
     *             1X,20(1H/),''  IPARIT='',I2,''  IREVER='',I2,
     *                        ''  ICHARG='',I2,          2X,20(1H/),/,
     *             1X,20(1H/),4X,4I3,2X,4I3,             5X,20(1H/),/)')
     *
     *       NUPAHO,IPARIT,IREVER,ICHARG,
     *
     *     ((N_PART(NUPAHO,IPARI_,IREVE_),IREVE_=0,NDREVE),
     *                                    IPARI_=0,NDPARI),
     *     ((N_HOLE(NUPAHO,IPARI_,IREVE_),IREVE_=0,NDREVE),
     *                                    IPARI_=0,NDPARI)
C
      WRITE(NFIPRI,'('' NVASIG='', 4I5,/)')
     *
     *     ((NVASIG(IPARI_,IREVE_,ICHARG),IREVE_=0,NDREVE),
     *                                    IPARI_=0,NDPARI)
C
      DO NUPAH_=1,NDPAHO
C
         WRITE(NFIPRI,'('' NUPAHO='',I2,1X,'',      N_PART='', 4I5,
     *                                     '',      N_HOLE='', 4I5)')
     *         NUPAH_,
     *         NPPPRP(NUPAH_,ICHARG),NPPPRM(NUPAH_,ICHARG),
     *         NPPMRM(NUPAH_,ICHARG),NPPMRP(NUPAH_,ICHARG),
     *         NHPPRP(NUPAH_,ICHARG),NHPPRM(NUPAH_,ICHARG),
     *         NHPMRM(NUPAH_,ICHARG),NHPMRP(NUPAH_,ICHARG)
C
      END DO
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE DUMSIM(NUPAHO,IREVER,ICHARG,L_PART,L_HOLE)
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      DIMENSION
     *          L_PART(NDPAHO,0:NDREVE),
     *          L_HOLE(NDPAHO,0:NDREVE)
C
      COMMON
     *       /SIMNPH/ NPSIMP(NDPAHO,0:NDISOS),NPSIMM(NDPAHO,0:NDISOS),
     *                NHSIMP(NDPAHO,0:NDISOS),NHSIMM(NDPAHO,0:NDISOS)
      COMMON
     *       /SIMNVA/ NVASIM(0:NDREVE,0:NDISOS)
      COMMON
     *       /CFIPRI/ NFIPRI
C
C=======================================================================
C         THIS SUBROUTINE DUMPS ON THE OUTPUT THE CONFIGURATION DATA
C         FOR THE SIMPLEX CASE
C=======================================================================
C
      WRITE(NFIPRI,'(/,
     *             1X,20(1H/),''    WRONG CONFIGURATION NO. '',I2,
     *                                                   5X,20(1H/),/,
     *             1X,20(1H/),''         '',2X,''  IREVER='',I2,
     *                        ''  ICHARG='',I2,          2X,20(1H/),/,
     *             1X,20(1H/),10X,2I3,8X,2I3,            5X,20(1H/),/)')
     *
     *       NUPAHO,IREVER,ICHARG,
     *
     *       (L_PART(NUPAHO,IREVE_),IREVE_=0,NDREVE),
     *       (L_HOLE(NUPAHO,IREVE_),IREVE_=0,NDREVE)
C
      WRITE(NFIPRI,'('' NVASIM='', 2I5,/)')
     *
     *       (NVASIM(IREVE_,ICHARG),IREVE_=0,NDREVE)
C
      DO NUPAH_=1,NDPAHO
C
         WRITE(NFIPRI,'('' NUPAHO='',I2,1X,'',      L_PART='', 2I5,
     *                                     '',      L_HOLE='', 2I5)')
     *         NUPAH_,
     *         NPSIMP(NUPAH_,ICHARG),NPSIMM(NUPAH_,ICHARG),
     *         NHSIMP(NUPAH_,ICHARG),NHSIMM(NUPAH_,ICHARG)
C
      END DO
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE DUMSIQ(NUPAHO,IPARIT,ICHARG,K_PART,K_HOLE)
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      DIMENSION
     *          K_PART(NDPAHO,0:NDPARI),
     *          K_HOLE(NDPAHO,0:NDPARI)
C
      COMMON
     *       /SIQNPH/ NPSIQP(NDPAHO,0:NDISOS),NPSIQM(NDPAHO,0:NDISOS),
     *                NHSIQP(NDPAHO,0:NDISOS),NHSIQM(NDPAHO,0:NDISOS)
      COMMON
     *       /SIQNVA/ NVASIQ(0:NDPARI,0:NDISOS)
      COMMON
     *       /CFIPRI/ NFIPRI
C
C=======================================================================
C         THIS SUBROUTINE DUMPS ON THE OUTPUT THE CONFIGURATION DATA
C         FOR THE PARITY CASE
C=======================================================================
C
      WRITE(NFIPRI,'(/,
     *             1X,20(1H/),''    WRONG CONFIGURATION NO. '',I2,
     *                                                   5X,20(1H/),/,
     *             1X,20(1H/),''         '',2X,''  IPARIT='',I2,
     *                        ''  ICHARG='',I2,          2X,20(1H/),/,
     *             1X,20(1H/),10X,2I3,8X,2I3,            5X,20(1H/),/)')
     *
     *       NUPAHO,IPARIT,ICHARG,
     *
     *       (K_PART(NUPAHO,IPARI_),IPARI_=0,NDPARI),
     *       (K_HOLE(NUPAHO,IPARI_),IPARI_=0,NDPARI)
C
      WRITE(NFIPRI,'('' NVASIQ='', 2I5,/)')
     *
     *       (NVASIQ(IPARI_,ICHARG),IPARI_=0,NDPARI)
C
      DO NUPAH_=1,NDPAHO
C
         WRITE(NFIPRI,'('' NUPAHO='',I2,1X,'',      K_PART='', 2I5,
     *                                     '',      K_HOLE='', 2I5)')
     *         NUPAH_,
     *         NPSIQP(NUPAH_,ICHARG),NPSIQM(NUPAH_,ICHARG),
     *         NHSIQP(NUPAH_,ICHARG),NHSIQM(NUPAH_,ICHARG)
C
      END DO
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE DUMSIZ(NUPAHO,ICHARG,M_PART,M_HOLE)
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      DIMENSION
     *          M_PART(NDPAHO),
     *          M_HOLE(NDPAHO)
C
      COMMON
     *       /SIZNPH/ NPNONE(NDPAHO,0:NDISOS),
     *                NHNONE(NDPAHO,0:NDISOS)
      COMMON
     *       /SIZNVA/ NVASIZ(0:NDISOS)
      COMMON
     *       /CFIPRI/ NFIPRI
C
C=======================================================================
C         THIS SUBROUTINE DUMPS ON THE OUTPUT THE CONFIGURATION DATA
C         FOR THE NON-CONSERVED SIMPLEX CASE
C=======================================================================
C
      WRITE(NFIPRI,'(/,
     *             1X,20(1H/),''    WRONG CONFIGURATION NO. '',I2,
     *                                                   5X,20(1H/),/,
     *             1X,20(1H/),''         '',2X,''         '',2X,
     *                        ''  ICHARG='',I2,          2X,20(1H/),/,
     *             1X,20(1H/),13X,I3,11X,I3,             5X,20(1H/),/)')
     *
     *       NUPAHO,ICHARG,
     *
     *       M_PART(NUPAHO),
     *       M_HOLE(NUPAHO)
C
      WRITE(NFIPRI,'('' NVASIZ='', I5,/)')
     *
     *       NVASIZ(ICHARG)
C
      DO NUPAH_=1,NDPAHO
C
         WRITE(NFIPRI,'('' NUPAHO='',I2,1X,'',      M_PART='', I5,
     *                                     '',      M_HOLE='', I5)')
     *         NUPAH_,
     *         NPNONE(NUPAH_,ICHARG),
     *         NHNONE(NUPAH_,ICHARG)
C
      END DO
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE SETSIG(IPAIRI)
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      DIMENSION
     *          N_PART(NDPAHO,0:NDPARI,0:NDREVE),
     *          N_HOLE(NDPAHO,0:NDPARI,0:NDREVE)
C
      COMMON
     *       /N_FILG/ NPFILG(0:NDPARI,0:NDREVE,0:NDISOS),
     *                NHFILG(0:NDPARI,0:NDREVE,0:NDISOS),
     *                NOFILG(0:NDPARI,0:NDREVE,0:NDISOS)
      COMMON
     *       /SIGNPH/ NPPPRP(NDPAHO,0:NDISOS),NPPPRM(NDPAHO,0:NDISOS),
     *                NPPMRP(NDPAHO,0:NDISOS),NPPMRM(NDPAHO,0:NDISOS),
     *                NHPPRP(NDPAHO,0:NDISOS),NHPPRM(NDPAHO,0:NDISOS),
     *                NHPMRP(NDPAHO,0:NDISOS),NHPMRM(NDPAHO,0:NDISOS)
      COMMON
     *       /SIGOCC/ N_OCCU(1:NDSTAT,0:NDPARI,0:NDREVE,0:NDISOS),
     *                N_VACC(1:NDSTAT,0:NDPARI,0:NDREVE,0:NDISOS)
      COMMON
     *       /SIGFIL/ VFISIG(1:NDSTAT,0:NDPARI,0:NDREVE,0:NDISOS)
      COMMON
     *       /SIGNVA/ NVASIG(0:NDPARI,0:NDREVE,0:NDISOS)
      COMMON
     *       /SIGNOC/ NOCSIG(0:NDPARI,0:NDREVE,0:NDISOS)
      COMMON
     *       /CFIPRI/ NFIPRI
C
C=======================================================================
C         THIS SUBROUTINE CHOSES THE ABSOLUTE CONFIGURATION
C         FOR THE PARITY/SIGNATURE CASE
C=======================================================================
C
C=======================================================================
C         ABSOLUTE VACUUM
C=======================================================================
C
      DO IPARIT=0,NDPARI
         DO IREVER=0,NDREVE
            DO ICHARG=0,NDISOS
C
               DO ISTATE=1,NDSTAT
                  N_OCCU(ISTATE,IPARIT,IREVER,ICHARG)=0
                  VFISIG(ISTATE,IPARIT,IREVER,ICHARG)=0.0D0
               END DO
C
               DO ISTATE=1,NVASIG(IPARIT,IREVER,ICHARG)
                  N_OCCU(ISTATE,IPARIT,IREVER,ICHARG)=1
                  VFISIG(ISTATE,IPARIT,IREVER,ICHARG)=1.0D0
               END DO
C
               IF (NOFILG(IPARIT,IREVER,ICHARG).GE.1) THEN
C
                   FRAOCC=NOFILG(IPARIT,IREVER,ICHARG)/2.0D0/
     *                   (NPFILG(IPARIT,IREVER,ICHARG)
     *                   -NHFILG(IPARIT,IREVER,ICHARG)+1.0D0)
C
                   DO ISTATE=NHFILG(IPARIT,IREVER,ICHARG),
     *                       NPFILG(IPARIT,IREVER,ICHARG)
                      VFISIG(ISTATE,IPARIT,IREVER,ICHARG)=SQRT(FRAOCC)
                   END DO
C
               END IF
C
            END DO
         END DO
      END DO
C
C=======================================================================
C         COPYING THE PARTICLE-HOLE EXCITATIONS
C=======================================================================
C
      DO ICHARG=0,NDISOS
C
         DO NUPAHO=1,NDPAHO
C
            N_PART(NUPAHO,0,0)=NPPPRP(NUPAHO,ICHARG)
            N_PART(NUPAHO,0,1)=NPPPRM(NUPAHO,ICHARG)
            N_PART(NUPAHO,1,0)=NPPMRP(NUPAHO,ICHARG)
            N_PART(NUPAHO,1,1)=NPPMRM(NUPAHO,ICHARG)
C
            N_HOLE(NUPAHO,0,0)=NHPPRP(NUPAHO,ICHARG)
            N_HOLE(NUPAHO,0,1)=NHPPRM(NUPAHO,ICHARG)
            N_HOLE(NUPAHO,1,0)=NHPMRP(NUPAHO,ICHARG)
            N_HOLE(NUPAHO,1,1)=NHPMRM(NUPAHO,ICHARG)
C
         END DO
C
         IF (IPAIRI.EQ.1) GO TO 1
C
C=======================================================================
C       EXCITING PARTICLES AND HOLES
C=======================================================================
C
        DO NUPAHO=1,NDPAHO
C
           DO IPARIT=0,NDPARI
              DO IREVER=0,NDREVE
C
C=======================================================================
C             PARTICLE EXCITATIONS
C=======================================================================
C
                 IF (            N_PART(NUPAHO,IPARIT,IREVER).GT.0) THEN
                     IF (        N_PART(NUPAHO,IPARIT,IREVER).LE.NDSTAT
     *               .AND.N_OCCU(N_PART(NUPAHO,IPARIT,IREVER),
     *                                  IPARIT,IREVER,ICHARG).EQ.0) THEN
                          N_OCCU(N_PART(NUPAHO,IPARIT,IREVER),
     *                                  IPARIT,IREVER,ICHARG)=1
                     ELSE
                         CALL DUMSIG(NUPAHO,IPARIT,IREVER,
     *                               ICHARG,N_PART,N_HOLE)
                         STOP 'WRONG PARTICLE CONFIGURATION IN SETSIG'
                     END IF
                 END IF
C
C=======================================================================
C                HOLE EXCITATIONS
C=======================================================================
C
                 IF (            N_HOLE(NUPAHO,IPARIT,IREVER).GT.0) THEN
                     IF (        N_HOLE(NUPAHO,IPARIT,IREVER).LE.NDSTAT
     *               .AND.N_OCCU(N_HOLE(NUPAHO,IPARIT,IREVER),
     *                                  IPARIT,IREVER,ICHARG).EQ.1) THEN
                          N_OCCU(N_HOLE(NUPAHO,IPARIT,IREVER),
     *                                  IPARIT,IREVER,ICHARG)=0
                     ELSE
                         CALL DUMSIG(NUPAHO,IPARIT,IREVER,
     *                               ICHARG,N_PART,N_HOLE)
                         STOP 'WRONG HOLE CONFIGURATION IN SETSIG'
                     END IF
                 END IF
C
              END DO
           END DO
C
        END DO
C
    1   CONTINUE
C
      END DO
C
      IF (IPAIRI.EQ.1) GO TO 2
C
C=======================================================================
C              COUNTING PARTICLES IN EACH PARITY/TIME-REVERSAL BLOCK
C=======================================================================
C
      DO ICHARG=0,NDISOS
         DO IPARIT=0,NDPARI
            DO IREVER=0,NDREVE
               NOCSIG(IPARIT,IREVER,ICHARG)=0
               DO ISTATE=1,NDSTAT
                         NOCSIG(IPARIT,IREVER,ICHARG)=
     *                   NOCSIG(IPARIT,IREVER,ICHARG)
     *           +N_OCCU(ISTATE,IPARIT,IREVER,ICHARG)
               END DO
            END DO
         END DO
      END DO
C
C=======================================================================
C              CHECKING PARTICLE NUMBERS IN THE FILLING APPROXIMATION
C=======================================================================
C
      INCORR=0
C
      DO ICHARG=0,NDISOS
         DO IPARIT=0,NDPARI
C
            NUFILL=0
            OCFILL=0
C
            DO IREVER=0,NDREVE
C
               IF (NOFILG(IPARIT,IREVER,ICHARG).GE.1) THEN
C
                   DO ISTATE=NHFILG(IPARIT,IREVER,ICHARG),
     *                       NPFILG(IPARIT,IREVER,ICHARG)
C
                      NUFILL=NUFILL
     *                      +N_OCCU(ISTATE,IPARIT,IREVER,ICHARG)
C
                      OCFILL=OCFILL
     *                      +VFISIG(ISTATE,IPARIT,IREVER,ICHARG)**2
C
                   END DO
C
               END IF
C
            END DO
C
            IF (ABS(NUFILL-OCFILL).GT.1.0E-12)THEN
C
                DO IREVER=0,NDREVE
C
                   WRITE(NFIPRI,'(/,         1X,20(1H/),
     *                    '' INCOMPATIBLE SIGNATURE'',
     *                    '' CONFIGURATION'',1X,20(1H/),/,
     *                                       1X,20(1H/),
     *                    '' IN THE FILLING APPROXIMATION'',
     *                    '' DATA:  '',  1X,20(1H/),/,
     *                                       1X,20(1H/),
     *                    '' ICHARG='',I3,1X,
     *                    '' IPARIT='',I3,1X,
     *                    '' IREVER='',I3,   3X,20(1H/),/,
     *                                       1X,20(1H/),
     *                    '' NPFILG='',I3,1X,
     *                    '' NHFILG='',I3,1X,
     *                    '' NOFILG='',I3,   3X,20(1H/),/,
     *                                       1X,20(1H/),
     *                    '' NUFILL='',I3,1X,
     *                    '' OCFILL='',E11.3,
     *                                       7X,20(1H/),/)')
     *
     *                    ICHARG,IPARIT,IREVER,
     *                    NPFILG(IPARIT,IREVER,ICHARG),
     *                    NHFILG(IPARIT,IREVER,ICHARG),
     *                    NOFILG(IPARIT,IREVER,ICHARG),
     *                    NUFILL,OCFILL
C
                END DO
C
                INCORR=1
C
            END IF
C
         END DO
      END DO
C
      IF (INCORR.EQ.1) STOP 'INCOMPATIBLE FILLING DATA IN SETSIG'
C
C=======================================================================
C
    2 CONTINUE
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE SETSIM(IPAIRI)
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      DIMENSION
     *          L_PART(NDPAHO,0:NDREVE),
     *          L_HOLE(NDPAHO,0:NDREVE)
C
      COMMON
     *       /SIMNPH/ NPSIMP(NDPAHO,0:NDISOS),NPSIMM(NDPAHO,0:NDISOS),
     *                NHSIMP(NDPAHO,0:NDISOS),NHSIMM(NDPAHO,0:NDISOS)
      COMMON
     *       /SIMOCC/ L_OCCU(1:NDSTAT,0:NDREVE,0:NDISOS),
     *                L_VACC(1:NDSTAT,0:NDREVE,0:NDISOS)
      COMMON
     *       /SIMNVA/ NVASIM(0:NDREVE,0:NDISOS)
C
C=======================================================================
C         THIS SUBROUTINE CHOSES THE ABSOLUTE CONFIGURATION
C         FOR THE SIMPLEX CASE
C=======================================================================
C
C=======================================================================
C         ABSOLUTE VACUUM
C=======================================================================
C
      DO IREVER=0,NDREVE
         DO ICHARG=0,NDISOS
C
            DO ISTATE=1,NDSTAT
               L_OCCU(ISTATE,IREVER,ICHARG)=0
            END DO
C
            DO ISTATE=1,NVASIM(IREVER,ICHARG)
               L_OCCU(ISTATE,IREVER,ICHARG)=1
            END DO
C
         END DO
      END DO
C
C=======================================================================
C         COPYING THE PARTICLE-HOLE EXCITATIONS
C=======================================================================
C
      DO ICHARG=0,NDISOS
C
         DO NUPAHO=1,NDPAHO
C
            L_PART(NUPAHO,0)=NPSIMP(NUPAHO,ICHARG)
            L_PART(NUPAHO,1)=NPSIMM(NUPAHO,ICHARG)
C
            L_HOLE(NUPAHO,0)=NHSIMP(NUPAHO,ICHARG)
            L_HOLE(NUPAHO,1)=NHSIMM(NUPAHO,ICHARG)
C
         END DO
C
         IF (IPAIRI.EQ.1) GO TO 1
C
C=======================================================================
C        EXCITING PARTICLES AND HOLES
C=======================================================================
C
         DO NUPAHO=1,NDPAHO
C
            DO IREVER=0,NDREVE
C
C=======================================================================
C              PARTICLE EXCITATIONS
C=======================================================================
C
               IF (                L_PART(NUPAHO,IREVER).GT.0) THEN
                   IF (            L_PART(NUPAHO,IREVER).LE.NDSTAT
     *                 .AND.L_OCCU(L_PART(NUPAHO,IREVER),
     *                                    IREVER,ICHARG).EQ.0) THEN
                            L_OCCU(L_PART(NUPAHO,IREVER),
     *                                    IREVER,ICHARG)=1
                   ELSE
                       CALL DUMSIM(NUPAHO,IREVER,ICHARG,L_PART,L_HOLE)
                       STOP 'WRONG PARTICLE CONFIGURATION IN SETSIM'
                   END IF
               END IF
C
C=======================================================================
C              HOLE EXCITATIONS
C=======================================================================
C
               IF (                L_HOLE(NUPAHO,IREVER).GT.0) THEN
                   IF (            L_HOLE(NUPAHO,IREVER).LE.NDSTAT
     *                 .AND.L_OCCU(L_HOLE(NUPAHO,IREVER),
     *                                    IREVER,ICHARG).EQ.1) THEN
                            L_OCCU(L_HOLE(NUPAHO,IREVER),
     *                                    IREVER,ICHARG)=0
                   ELSE
                       CALL DUMSIM(NUPAHO,IREVER,ICHARG,L_PART,L_HOLE)
                       STOP 'WRONG HOLE CONFIGURATION IN SETSIM'
                   END IF
               END IF
C
            END DO
         END DO
C
    1    CONTINUE
C
      END DO
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE SETSIQ(IPAIRI)
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      DIMENSION
     *          K_PART(NDPAHO,0:NDPARI),
     *          K_HOLE(NDPAHO,0:NDPARI)
C
      COMMON
     *       /SIQNPH/ NPSIQP(NDPAHO,0:NDISOS),NPSIQM(NDPAHO,0:NDISOS),
     *                NHSIQP(NDPAHO,0:NDISOS),NHSIQM(NDPAHO,0:NDISOS)
      COMMON
     *       /SIQOCC/ K_OCCU(1:2*NDSTAT,0:NDPARI,0:NDISOS),
     *                K_VACC(1:2*NDSTAT,0:NDPARI,0:NDISOS)
      COMMON
     *       /SIQNVA/ NVASIQ(0:NDPARI,         0:NDISOS)
      COMMON
     *       /SIQNOC/ NOCSIQ(0:NDPARI,         0:NDISOS)
C
C=======================================================================
C         THIS SUBROUTINE CHOSES THE ABSOLUTE CONFIGURATION
C         FOR THE PARITY CASE
C=======================================================================
C         ABSOLUTE VACUUM
C=======================================================================
C
      DO ICHARG=0,NDISOS
         DO IPARIT=0,NDPARI
C
            DO ISTATE=1,2*NDSTAT
               K_OCCU(ISTATE,IPARIT,ICHARG)=0
            END DO
C
            DO ISTATE=1,NVASIQ(IPARIT,ICHARG)
               K_OCCU(ISTATE,IPARIT,ICHARG)=1
            END DO
C
         END DO
      END DO
C
      DO ICHARG=0,NDISOS
C
C=======================================================================
C        COPYING THE PARTICLE-HOLE EXCITATIONS
C=======================================================================
C
         DO NUPAHO=1,NDPAHO
C
            K_PART(NUPAHO,0)=NPSIQP(NUPAHO,ICHARG)
            K_PART(NUPAHO,1)=NPSIQM(NUPAHO,ICHARG)
C
            K_HOLE(NUPAHO,0)=NHSIQP(NUPAHO,ICHARG)
            K_HOLE(NUPAHO,1)=NHSIQM(NUPAHO,ICHARG)
C
         END DO
C
         IF (IPAIRI.EQ.1) GO TO 1
C
C=======================================================================
C        EXCITING PARTICLES AND HOLES
C=======================================================================
C
         DO NUPAHO=1,NDPAHO
C
            DO IPARIT=0,NDPARI
C
C=======================================================================
C              PARTICLE EXCITATIONS
C=======================================================================
C
               IF (                K_PART(NUPAHO,IPARIT).GT.0) THEN
                   IF (            K_PART(NUPAHO,IPARIT).LE.2*NDSTAT
     *                 .AND.K_OCCU(K_PART(NUPAHO,IPARIT),
     *                                    IPARIT,ICHARG).EQ.0) THEN
                            K_OCCU(K_PART(NUPAHO,IPARIT),
     *                                    IPARIT,ICHARG)=1
                   ELSE
                       CALL DUMSIQ(NUPAHO,IPARIT,ICHARG,K_PART,K_HOLE)
                       STOP 'WRONG PARTICLE CONFIGURATION IN SETSIQ'
                   END IF
               END IF
C
C=======================================================================
C              HOLE EXCITATIONS
C=======================================================================
C
               IF (                K_HOLE(NUPAHO,IPARIT).GT.0) THEN
                   IF (            K_HOLE(NUPAHO,IPARIT).LE.2*NDSTAT
     *                 .AND.K_OCCU(K_HOLE(NUPAHO,IPARIT),
     *                                    IPARIT,ICHARG).EQ.1) THEN
                            K_OCCU(K_HOLE(NUPAHO,IPARIT),
     *                                    IPARIT,ICHARG)=0
                   ELSE
                       CALL DUMSIQ(NUPAHO,IPARIT,ICHARG,K_PART,K_HOLE)
                       STOP 'WRONG HOLE CONFIGURATION IN SETSIQ'
                   END IF
               END IF
C
            END DO
         END DO
C
    1    CONTINUE
C
      END DO
C
C=======================================================================
C              COUNTING PARTICLES IN EACH PARITY BLOCK
C=======================================================================
C
      DO ICHARG=0,NDISOS
         DO IPARIT=0,NDPARI
            NOCSIQ(IPARIT,ICHARG)=0
            DO ISTATE=1,2*NDSTAT
               NOCSIQ(IPARIT,ICHARG)=NOCSIQ(IPARIT,ICHARG)
     *                       +K_OCCU(ISTATE,IPARIT,ICHARG)
            END DO
         END DO
      END DO
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE SETSIZ(IPAIRI)
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      DIMENSION
     *          M_PART(NDPAHO),
     *          M_HOLE(NDPAHO)
C
      COMMON
     *       /SIZNPH/ NPNONE(NDPAHO,0:NDISOS),
     *                NHNONE(NDPAHO,0:NDISOS)
      COMMON
     *       /SIZOCC/ M_OCCU(1:2*NDSTAT,0:NDISOS),
     *                M_VACC(1:2*NDSTAT,0:NDISOS)
      COMMON
     *       /N_FILZ/ NPFILZ(                  0:NDISOS),
     *                NHFILZ(                  0:NDISOS),
     *                NOFILZ(                  0:NDISOS)
      COMMON
     *       /SIZFIL/ VFISIZ(1:2*NDSTAT,0:NDISOS)
      COMMON
     *       /SIZNVA/ NVASIZ(0:NDISOS)
      COMMON
     *       /SIZNOC/ NOCSIZ(0:NDISOS)
      COMMON
     *       /CFIPRI/ NFIPRI
C
C=======================================================================
C         THIS SUBROUTINE CHOSES THE ABSOLUTE CONFIGURATION
C         FOR THE CASE OF NON-COSERVED SIMPLEX
C=======================================================================
C
C=======================================================================
C         ABSOLUTE VACUUM
C=======================================================================
C
      DO ICHARG=0,NDISOS
C
         DO ISTATE=1,2*NDSTAT
            M_OCCU(ISTATE,ICHARG)=0
            VFISIZ(ISTATE,ICHARG)=0.0D0
         END DO
C
         DO ISTATE=1,NVASIZ(ICHARG)
            M_OCCU(ISTATE,ICHARG)=1
            VFISIZ(ISTATE,ICHARG)=1.0D0
         END DO
C
         IF (NOFILZ(ICHARG).GE.1) THEN
C
             FRAOCC=NOFILZ(ICHARG)/2.0D0/
     *             (NPFILZ(ICHARG)
     *             -NHFILZ(ICHARG)+1.0D0)
C
             DO ISTATE=NHFILZ(ICHARG),
     *                 NPFILZ(ICHARG)
                VFISIZ(ISTATE,ICHARG)=SQRT(FRAOCC)
             END DO
C
         END IF
C
      END DO
C
C=======================================================================
C         COPYING THE PARTICLE-HOLE EXCITATIONS
C=======================================================================
C
      DO ICHARG=0,NDISOS
C
         DO NUPAHO=1,NDPAHO
C
            M_PART(NUPAHO)=NPNONE(NUPAHO,ICHARG)
C
            M_HOLE(NUPAHO)=NHNONE(NUPAHO,ICHARG)
C
         END DO
C
         IF (IPAIRI.EQ.1) GO TO 1
C
C=======================================================================
C        EXCITING PARTICLES AND HOLES
C=======================================================================
C
         DO NUPAHO=1,NDPAHO
C
C=======================================================================
C              PARTICLE EXCITATIONS
C=======================================================================
C
            IF (                M_PART(NUPAHO).GT.0) THEN
                IF (            M_PART(NUPAHO).LE.2*NDSTAT
     *              .AND.M_OCCU(M_PART(NUPAHO),ICHARG).EQ.0) THEN
                         M_OCCU(M_PART(NUPAHO),ICHARG)=1
                ELSE
                    CALL DUMSIZ(NUPAHO,ICHARG,M_PART,M_HOLE)
                    STOP 'WRONG PARTICLE CONFIGURATION IN SETSIZ'
                END IF
            END IF
C
C=======================================================================
C              HOLE EXCITATIONS
C=======================================================================
C
            IF (                M_HOLE(NUPAHO).GT.0) THEN
                IF (            M_HOLE(NUPAHO).LE.2*NDSTAT
     *              .AND.M_OCCU(M_HOLE(NUPAHO),ICHARG).EQ.1) THEN
                         M_OCCU(M_HOLE(NUPAHO),ICHARG)=0
                ELSE
                    CALL DUMSIZ(NUPAHO,ICHARG,M_PART,M_HOLE)
                    STOP 'WRONG HOLE CONFIGURATION IN SETSIZ'
                END IF
            END IF
C
         END DO
C
    1    CONTINUE
C
      END DO
C
      IF (IPAIRI.EQ.1) GO TO 2
C
C=======================================================================
C              COUNTING PARTICLES IN EACH CHARGE BLOCK
C=======================================================================
C
      DO ICHARG=0,NDISOS
         NOCSIZ(ICHARG)=0
         DO ISTATE=1,2*NDSTAT
                   NOCSIZ(ICHARG)=
     *             NOCSIZ(ICHARG)
     *     +M_OCCU(ISTATE,ICHARG)
         END DO
      END DO
C
C=======================================================================
C              CHECKING PARTICLE NUMBERS IN THE FILLING APPROXIMATION
C=======================================================================
C
      INCORR=0
C
      DO ICHARG=0,NDISOS
C
         NUFILL=0
         OCFILL=0
C
         IF (NOFILZ(ICHARG).GE.1) THEN
C
             DO ISTATE=NHFILZ(ICHARG),
     *                 NPFILZ(ICHARG)
C
                NUFILL=NUFILL
     *                +M_OCCU(ISTATE,ICHARG)
C
                OCFILL=OCFILL
     *                +VFISIZ(ISTATE,ICHARG)**2
C
             END DO
C
         END IF
C
         IF (ABS(NUFILL-OCFILL).GT.1.0E-12) THEN
C
             WRITE(NFIPRI,'(/,         1X,20(1H/),
     *              '' INCOMPATIBLE NO-SYMMET'',
     *              '' CONFIGURATION'',1X,20(1H/),/,
     *                                 1X,20(1H/),
     *              '' IN THE FILLING APPROXIMATION'',
     *              '' DATA:  '',  1X,20(1H/),/,
     *                                 1X,20(1H/),
     *              '' ICHARG='',I3,1X,
     *              ''        '',3X,1X,
     *              ''        '',3X,   3X,20(1H/),/,
     *                                 1X,20(1H/),
     *              '' NPFILZ='',I3,1X,
     *              '' NHFILZ='',I3,1X,
     *              '' NOFILZ='',I3,   3X,20(1H/),/,
     *                                 1X,20(1H/),
     *              '' NUFILL='',I3,1X,
     *              '' OCFILL='',E11.3,
     *                                 7X,20(1H/),/)')
     *
     *              ICHARG,
     *              NPFILZ(ICHARG),
     *              NHFILZ(ICHARG),
     *              NOFILZ(ICHARG),
     *              NUFILL,OCFILL
C
             INCORR=1
C
         END IF
C
      END DO
C
      IF (INCORR.EQ.1) STOP 'INCOMPATIBLE FILLING DATA IN SETSIZ'
C
C=======================================================================
C
    2 CONTINUE
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE DELPAI(ICHARG,MREVER,JPABCS,NOPART,ITERUN,
     *                  DELFIX,G_PAIR,E_PAIR,EFERMI,BCSDEL)
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      DIMENSION
     *          V2OCCU(1:NDSTAT),NAUXIL(1:NDSTAT),ESINGP(1:NDSTAT),
     *          EQSPRT(1:NDSTAT),DELTAS(1:NDSTAT),
     *          DELTA0(1:NDSTAT),SM(1:NDSTAT)
C=======================================================================
      ALLOCATABLE PARELE(:,:)
C=======================================================================
C
      COMMON
     *       /PROCCU/ V_OCCU(1:2*NDSTAT)
      COMMON
     *       /SIMSPE/ SPESIM(1:NDBASE)
      COMMON
     *       /SPNUMS/ NUMBSP(0:NDREVE,0:NDISOS)
      COMMON
     *       /MATRIG/ GMATRI(1:NDSTAT,1:NDSTAT,0:NDISOS)
      COMMON
     *       /CFIPRI/ NFIPRI
C@@@ TEMP - TEMP - TEMP - TEMP - TEMP - TEMP - TEMP - TEMP - TEMP
      COMMON
     *       /SENTRO/ ENTRPY(0:NDISOS)
      COMMON
     *       /FERFUN/ FER_FN(1:NDBASE)
      COMMON
     *       /GCTEMP/ TEMP_T
      COMMON
     *       /T_FLAG/ IFTEMP
C@@@ TEMP - TEMP - TEMP - TEMP - TEMP - TEMP - TEMP - TEMP - TEMP
C
C=======================================================================
C
      CALL CPUTIM('DELPAI',1)
C
C=======================================================================
C
      IALLOC=0
C
C=======================================================================
      ALLOCATE (PARELE(1:NDSTAT,1:NDSTAT),STAT=IALLOC)
      IF (IALLOC.NE.0) CALL NOALLO('PARELE','DELPAI')
C=======================================================================
C
C=======================================================================
C         SUBROUTINE DELPAI SOLVES THE BCS EQUATIONS FOR THE SENIORITY
C         PAIRING FORCE (JPABCS=1), WITH FIXED PARING GAP (JPABCS=2),
C         OR FOR THE ZERO-RANGE FORCE (JPABCS=3).
C=======================================================================
C
C         MEANING OF SOME PARAMETERS:
C
C         ICHARG = 0 FOR NEUTRONS
C                = 1 FOR PROTONS
C
C         JPABCS = 1 SENIORITY PAIRING FORCE
C                = 2 SENIORITY PAIRING FORCE WITH FIXED PAIRING GAP
C                = 3 ZERO-RANGE FORCE
C
C         NTQPAR = 0 BCS GROUND STATE, OTHERWISE
C                > 0 2-QP STATE BUILT ON NTQPAR ORBITAL
C
C         NOPART - THE ACTUAL PARTICLE NUMBER (OF PROTONS OR NEUTRONS)
C         G_PAIR - THE PAIRING STRENGTH CONSTANT IN MEV (SEE: GUESSES)
C                  FOR SENIORITY PAIRIND FORCE (JPABCS=1 OR 2)
C         GMATRI - THE PAIRING MATRIX ELEMENTS BETWEEN PAIRS OF TIME-
C                  REVERSED STATES (SEE: GINTER)
C         SPESIM - THE SINGLE - PARTICLE SPECTRUM (DOES NOT NEED TO BE
C                  ORDERED BEFORE CALLING THIS ROUTINE)
C         LSTATE - THE TOTAL NUMBER OF LEVELS IN THE S. PART. SPECTRUM
C
C         BCSDEL - THE INITIAL PARING (PROTON OR NEUTRON) GAP
C                  (ENFORCED VALUE WHEN JPABCS=2)
C         V2OCCU - THE PAIRING OCCUPATION FACTORS (TO BE CALCULETED)
C         EFERMI - THE FERMI ENERGY TO BE CALCULATED (IN MEV)
C         E_PAIR - THE PAIRING ENERGY TO BE CALCULATED (IN MEV)
C
C         EPSILF - THE ACCURACY FOR THE FERMI ENERGY
C         EPSILG - THE ACCURACY FOR THE PAIRING GAP
C         MAXITE - MAXIMUM NUMBER OF ITERATIONS ALLOWED
C
C=======================================================================
C         WITHOUT ROTATION (IROTAT=0) AND WITHOUT BREAKING THE Y-SIMPLEX
C         SYMMETRY (ISIMPY=1), THE TIME-REVERSED BLOCK IS NOT EXPLICITLY
C         CALCULATED. THIS IS DONE BY USING MREVER=0.
C=======================================================================
C
      LSTATE=NUMBSP(0,ICHARG)+MREVER*NUMBSP(1,ICHARG)
C
      EPSILF= 1.0D-07
      EPSILG= 1.0D-05
      MAXITE= 200
      NTQPAR= 0
C
      DO I=1,LSTATE
         NAUXIL(I)=I
         ESINGP(I)=SPESIM(I)
      END DO
C
C=======================================================================
C         THE ARRIVING SINGLE PARTICLE LEVELS ARE USUALLY NOT ORDERED
C         THEY WILL BE ORDERED HERE TO AVOID INCREASING ORDER PROBLEM
C=======================================================================
C
      CALL ORDER1(ESINGP,NAUXIL,LSTATE)
C
C=======================================================================
C         BCS FILLING: PAIRING MATRIX ELEMENTS * 1/2
C=======================================================================
C
C=======================================================================
C         WITH SENIORTY FORCE
C=======================================================================
C
      IF (JPABCS.EQ.1.OR.(JPABCS.EQ.3.AND.ITERUN.EQ.1)) THEN
C
          DO I=1,LSTATE
             DO J=I,LSTATE
               PARELE(I,J)=G_PAIR/2
               PARELE(J,I)=G_PAIR/2
             END DO
          END DO
      END IF
C
      IF (JPABCS.EQ.2) THEN
C
          BCSDEL=DELFIX
C
      END IF
C
C=======================================================================
C         WITH DELTA FORCE
C=======================================================================
C
      IF (JPABCS.EQ.3.AND.ITERUN.NE.1) THEN
C
          DO I=1,LSTATE
             DO J=1,LSTATE
C                                               (SEE COMMENTS IN GINTER)
                PARELE(I,J)=GMATRI(NAUXIL(I),NAUXIL(J),ICHARG)/2
C                                               (SEE COMMENTS IN GINTER)
C
             END DO
          END DO
      END IF
C
C=======================================================================
C         INITIALIZATION OF THE FERMI ENERGY AND THE GAPS
C=======================================================================
C
      NFERMI=NOPART/2
      EFERMI=0.5*(ESINGP(NFERMI)+ESINGP(NFERMI+1))
C
      DO I=1,LSTATE
         DELTAS(I)=BCSDEL
      END DO
C
C=======================================================================
C        REINITIALIZATION TO AVOID MISSING A NON-TRIVIAL BCS SOLUTION
C=======================================================================
C
      IF (BCSDEL.LT.1.D-05) THEN
C
          DO I=1,LSTATE
             DELTAS(I)=1.0
          END DO
C
      END IF
C
C=======================================================================
C         BCS INTERATIONS
C=======================================================================
C
      ITERTN=0
C
 7777 ITERTN=ITERTN+1
C
      DO I=1,LSTATE
         DELTA0(I)=DELTAS(I)
      END DO
C
C=======================================================================
C         CALCULATION OF NEW FERMI ENERGY EFERMI
C=======================================================================
C
      EFERM0=EFERMI
      SOESUM=0.0D0
      SORSUM=0.0D0
C
      ENTRPY(ICHARG) = 0.0D0
      EPSILO=1.0D-13
C
      DO I=1,LSTATE
         E  = ESINGP(I)
         EML= EFERM0-E
         EQP= SQRT(EML**2+DELTA0(I)**2)
         IF (I.EQ.NTQPAR) EQP= -EQP
         EQSPRT(I)= EQP
C@@@ TEMP - TEMP - TEMP - TEMP - TEMP - TEMP - TEMP - TEMP - TEMP
         IF (IFTEMP.EQ.1) THEN
C
             F1=(1.0D0-TANH(EQP/TEMP_T/2.0D0))/2.0D0
             FER_FN(I)=F1
             IF (ABS(F1).GT.EPSILO.AND.(1.0D0-F1).GT.EPSILO) THEN
                 ENTRPY(ICHARG)=ENTRPY(ICHARG)-F1 *LOG(F1)-
     *                                  (1.0D0-F1)*LOG(1.0D0-F1)
             END IF
             SOESUM = SOESUM + (1.0-E/EQP*(1.D0-2*FER_FN(I)))
             SORSUM = SORSUM +    1.0/EQP*(1.D0-2*FER_FN(I))
C
         ELSE
             SOESUM = SOESUM + (1.0-E/EQP)
             SORSUM = SORSUM + 1.0/EQP
         END IF
C@@@ TEMP - TEMP - TEMP - TEMP - TEMP - TEMP - TEMP - TEMP - TEMP
      END DO
C
      EFERMI= (REAL(NOPART,KIND=8)-SOESUM)/SORSUM
C
C=======================================================================
C         CALCULATIONS OF THE NEW GAPS DELTAS(I)
C=======================================================================
C
      IF (JPABCS.NE.2) THEN
C
          GAPERR= 0.0
          NORBIT= 0
          BCSDEL= 0.0
C
          DO I=1,LSTATE
C
             GAPSUM= 0.0
C
C@@@ TEMP - TEMP - TEMP - TEMP - TEMP - TEMP - TEMP - TEMP - TEMP
             IF (IFTEMP.EQ.1) THEN
                 DO J=1,LSTATE
                    GAPSUM=GAPSUM+PARELE(I,J)*DELTA0(J)/EQSPRT(J)
     *                        *TANH(EQSPRT(J)/TEMP_T/2.0D0)
                 END DO
             ELSE
                 DO J=1,LSTATE
                    GAPSUM=GAPSUM+PARELE(I,J)*DELTA0(J)/EQSPRT(J)
                 END DO
             END IF
C@@@ TEMP - TEMP - TEMP - TEMP - TEMP - TEMP - TEMP - TEMP - TEMP
C
             DELTAS(I)= GAPSUM
C
             IF (GAPSUM.GT.BCSDEL) BCSDEL= GAPSUM
C
             GAPSUM= ABS(DELTA0(I)-GAPSUM)
C
             IF (GAPSUM.GT.GAPERR) THEN
                 GAPERR= GAPSUM
                 NORBIT= I
             END IF
C
          END DO
C
      END IF
C
C=======================================================================
C         CONVERGENCE CRITERIA
C=======================================================================
C
      IF (ITERTN.GT.MAXITE) GO TO 9999
      IF (ABS(EFERMI-EFERM0).GE.EPSILF) GO TO 7777
      IF ((GAPERR.GE.EPSILF).AND.(BCSDEL.GE.EPSILG)) GO TO 7777
      IF ((GAPERR.GE.EPSILG).AND.(BCSDEL.LT.EPSILG)) GO TO 7777
C
 9999 CONTINUE
C
      IF (ITERTN.GT.MAXITE) THEN
         WRITE(NFIPRI,'(/,
     *         1X,18(1H/),''  BCS DOES NOT CONVERGE  IN  DELPAI'',
     *                                                     5X,18(1H/),/,
     *         1X,18(1H/),''  ICHARG='',I2,18X,''JPABCS='',I2,
     *                                                     2X,18(1H/),/,
     *         1X,18(1H/),''  EFERM0='',1PE10.3,''  EFERMI='',
     *                                            1PE10.3, 2X,18(1H/),/,
     *         1X,18(1H/),''  ORBITAL NO.='',I5,''  GAPERR='',
     *                                             E10.3, 2X,18(1H/)/)')
     *         ICHARG,JPABCS,EFERM0,EFERMI,NORBIT,GAPERR
      END IF
C
C=======================================================================
C         CALCULATIONS OF THE PAIRING OCCUPATION FACTORS V2OCCU(I),
C         FLUCTUATION IN THE NUMBER OF PARTICLES,
C         VARIAN=(DN)**2=:<gs|N**2|gs> - [<gs|N|gs>]**2
C               =4*Sum_i[u(i)**2*v(i)**2]=Sum_i{[Del(i)/E(i)]**2},
C         AND SPECTRAL GAP,
C         BCSDEL=<uvDel>=:Sum_i[u(i)*v(i)*Del(i)]/Sum_i[u(i)*v(i)]
C=======================================================================
C
      DISSUM= 0.0
      DITSUM= 0.0
      DIRSUM= 0.0
      VUDSUM= 0.0
      VUSUM = 0.0
C
      DO I=1,LSTATE
C
         E  = ESINGP(I)
         EML= EFERMI-E
         EQP= SQRT(EML**2+DELTAS(I)**2)
         IF (I.EQ.NTQPAR) EQP= -EQP
         EQSPRT(I)= EQP
C
         C        = EML/EQSPRT(I)
         V2OCCU(I)= (1.0+C)/2.0
         IF (V2OCCU(I).LT.1.0D-09) V2OCCU(I)=0.0
C
         U2OCCU= 1.0D0-V2OCCU(I)
         VU    = SQRT(V2OCCU(I)*U2OCCU)
         VUD   = VU*DELTAS(I)
         VUSUM = VUSUM + VU
         VUDSUM= VUDSUM+ VUD
C
         IF (IFTEMP.EQ.1) THEN
             S = DELTAS(I)/EQSPRT(I)
     *                   *TANH(EQSPRT(I)/TEMP_T/2.0D0)
         ELSE
             S = DELTAS(I)/EQSPRT(I)
         END IF
C
         SM(I) = S
         S2    = S*S
         DISSUM= DISSUM + S2
         DITSUM= DITSUM + S
         DIRSUM= DIRSUM + S*DELTAS(I)
C
      END DO
C
C     VARIAN= DISSUM
C
      SPCDEL = VUDSUM/VUSUM
C
      IF (JPABCS.NE.2) THEN
          BCSDEL= SPCDEL
      END IF
C
C=======================================================================
C         CALCULATIONS OF THE PAIRING ENERGY: E_PAIR
C=======================================================================
C
      PAIRSU = 0.0
C
      DO I=1,LSTATE
C
         GAPSUM= 0.0
C
         IF (JPABCS.NE.2) THEN
C
             DO J=1,LSTATE
                GAPSUM= GAPSUM + PARELE(I,J)*SM(J)
             END DO
         ELSE
             GAPSUM= BCSDEL
C
         END IF
C
         PAIRSU= PAIRSU + GAPSUM*SM(I)
C
      END DO
C
      E_PAIR= -PAIRSU/2
C
C=======================================================================
C         THIS ESTIMATE OF THE PAIRING STRENGTH IS BASED ON THE SIMPLE
C         BCS EXPRESSION. IT IS VERY CRUDE.
C=======================================================================
C
      IF (JPABCS.NE.1) THEN
C
                               G_PAIR = 0.0D0
          IF (E_PAIR.NE.0.0D0) G_PAIR = -BCSDEL**2/E_PAIR
C
      END IF
C
C=======================================================================
C
      DO I=1,LSTATE
         V_OCCU(I)=SQRT(ABS(V2OCCU(I)))
      END DO
C
C=======================================================================
C         CHECKING THE NUMBER OF PARTICLES
C=======================================================================
C
      PARTNU=0.0
C
      IF (IFTEMP.EQ.1) THEN
          DO I=1,LSTATE
             PARTNU=PARTNU+2.0*V_OCCU(I)**2
     *           +2*(1.0D0-2.0*V_OCCU(I)**2)*FER_FN(I)
          END DO
      ELSE
          DO I=1,LSTATE
             PARTNU=PARTNU+2*V_OCCU(I)**2
          END DO
      END IF
C
      IF (ABS(PARTNU-NOPART).GT.100.*EPSILF) THEN
C
          WRITE (NFIPRI,'(/,1X,18(1H/),''                    NOPART ='',
     *                                             I4,  10X,18(1H/),/
     *                 1X,18(1H/),''  SUM OF V_OCCU  -  NOPART ='',
     *                                             E12.5,2X,18(1H/),/)')
     *                 NOPART,PARTNU-NOPART
C
C         STOP '  SUM OF V_OCCU .NE. NOPART IN DELPAI '
C
      END IF
C
C=======================================================================
      DEALLOCATE (PARELE)
C=======================================================================
C
      CALL CPUTIM('DELPAI',0)
C
C=======================================================================
C
      RETURN
      END
C
C=====================================================================
C
      SUBROUTINE SETPAI(IN_FIX,IZ_FIX,FACTOG,ICHARG,G_PAIR)
C
C=======================================================================
C         P A I R I N G     P A R A M E T R I Z A T I O N    (GUESSES)
C=======================================================================
C
      AA=IN_FIX+IZ_FIX
C
      IF (ICHARG.EQ.0) THEN
C
          IF (IZ_FIX.GE.88) THEN
C
              G_PAIR=(19.3D0-0.084D0*(IN_FIX-IZ_FIX))/AA
C
          ELSE
C
              G_PAIR=(18.95D0-0.078D0*(IN_FIX-IZ_FIX))/AA
C
          END IF
C
      ELSE
C
          IF (IZ_FIX.GE.88) THEN
C
              G_PAIR=(13.3D0+0.217D0*(IN_FIX-IZ_FIX))/AA
C
          ELSE
C
              G_PAIR=(17.90D0+0.176D0*(IN_FIX-IZ_FIX))/AA
C
          END IF
C
      END IF
C
      G_PAIR=G_PAIR*FACTOG
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE GAVRAG(IN_FIX,IZ_FIX,FACTOG,ICHARG,GAPAIR)
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      DIMENSION
     *          ESINGP(1:NDBASE)
      DIMENSION
     *          NAUXIL(1:NDBASE)
C
      COMMON
     *       /SPNUMS/ NUMBSP(0:NDREVE,0:NDISOS)
      COMMON
     *       /SIMSPE/ SPESIM(1:NDBASE)
C
C=======================================================================
C
C       SUBROUTINE GAVRAG CALCULATES THE SMOOTHED VALUE OF "G_PAIR"
C                  REPLACING IN THE BCS EQUATIONS,  THE SUMMATIONS
C                  BY AN INTEGRATION  WITH  THE STRUTINSKY DENSITY
C
C         EFERMI - FERMI ENERGY FOR WHICH THE DENSITY IS CALCULATED
C         GAPAIR - "AVERAGED" PAIRING FORCE STRENGTH  TO  BE  FOUND
C         NPAIRS - THE NUMBER OF PAIRS EQUAL TO THE NUMBER OF PARTICLES
C                  (THE SAME AS IN THE BCS EQUATIONS => SEE BELOW)
C
C=======================================================================
C
      NOLEVT=NUMBSP(0,ICHARG)
C
      A_MASS=REAL(IZ_FIX+IN_FIX,KIND=8)
C
                       NPAIRS=IN_FIX
      IF (ICHARG.EQ.1) NPAIRS=IZ_FIX
C
      DO I=1,NOLEVT
         NAUXIL(I)=I
         ESINGP(I)=SPESIM(I)
      END DO
C
C=======================================================================
C         THE ARRIVING SINGLE PARTICLE LEVELS ARE USUALLY NOT ORDERED
C         THEY WILL BE ORDERED HERE TO AVOID INCREASING ORDER PROBLEM
C=======================================================================
C
      CALL ORDER1(ESINGP,NAUXIL,NOLEVT)
C
      EFERMI=0.5*(ESINGP(NPAIRS/2)+ESINGP(NPAIRS/2+1))
C
      RHOBAR=0.5*DENS_E(EFERMI,IN_FIX,IZ_FIX,ESINGP,NOLEVT)
C
      DELBAR=12.0000/SQRT(A_MASS)
C
C=======================================================================
C
      GAPAIR=1.0/RHOBAR/LOG(SQRT(1.+(0.5*NPAIRS/RHOBAR/DELBAR)**2)
     *                              +0.5*NPAIRS/RHOBAR/DELBAR)
C
C=======================================================================
C
      GAPAIR=GAPAIR*FACTOG
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      FUNCTION DENS_E(EFERMI,IN_FIX,IZ_FIX,ESINGP,NOLEVT)
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      DIMENSION
     *          COEFFM(1:NDSMTH)
      DIMENSION
     *          ESINGP(1:NDBASE)
      DIMENSION
     *          HERPOL(1:NDSMTH),DHRPOL(1:NDSMTH)
      DATA
     *     NPOLYN / 6 /
      DATA
     *     GSTRUT /1.2/
      DATA
     *     EXPLIM /20./
C
C=======================================================================
C          DENS_E  CALCULATES STRUTINSKY SMOOTHING FUNCTION
C=======================================================================
C
      PINUMB=4.0D0*ATAN(1.0D0)
C
      FACTOR=1.0D0
C
      DO KFACTO=2,NPOLYN,2
         FACTOR=FACTOR*KFACTO/2
         COEFFM(KFACTO)=(-1)**(KFACTO/2)/(2.0**KFACTO)/FACTOR
      END DO
C
C=======================================================================
C
      A_MASS=REAL(IN_FIX+IZ_FIX,KIND=8)
      HBAR_0=41.0D0/A_MASS**(1.0D0/3.0D0)
C
      GAMMAS=GSTRUT*HBAR_0
C
C=======================================================================
C
      SUMSTR=0.0D0
C
      DO N=1,NOLEVT
C
         UNSTRT=(EFERMI-ESINGP(N))/GAMMAS
         EXPUN2=0.
         SUMPOL=1.
C
         IF (ABS(UNSTRT).LE.EXPLIM) THEN
C
             EXPUN2=EXP(-UNSTRT*UNSTRT)
C
             CALL D_HERM(UNSTRT,NPOLYN,HERPOL,DHRPOL,NDSMTH)
C
             DO I=2,NPOLYN,2
                SUMPOL=SUMPOL+COEFFM(I)*HERPOL(I+1)
             END DO
C
         END IF
C
         SUMSTR=SUMSTR+EXPUN2*SUMPOL
C
      END DO
C
C=======================================================================
C         HERE ALL THE LEVELS ARE TREATED AS CORRESPONDING TO ONE
C         TIME REVERSAL ONLY (NO DEGENERACY).  IN ORDER TO OBTAIN
C         THE DENSITY OF DOUBLY DEGENERATE STATES WE MULTIPLY THE
C         RESULTING SUM BY A FACTOR OF TWO
C=======================================================================
C
      DENS_E=2.0*SUMSTR/GAMMAS/SQRT(PINUMB)
C
C=======================================================================
C
      RETURN
      END
C
C
C=======================================================================
C
      SUBROUTINE NORHER
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      COMMON
     *       /FACHER/ HERFAC(0:ND2MAX)
C
C=======================================================================
C        THIS SUBROUTINE CALCULATES THE HERMITE-POLYNOMIAL NORMALIZATION
C        FACTORS AND STORES THEM IN COMMON. IT DOES THE SAME AS  NORFAC,
C        WHICH STORS THEM IN LOCAL ARRAY.
C=======================================================================
C
      HERFAC(0)=SQRT(SQRT(4.0D0*ATAN(1.0D0)))
C
      DO I=1,ND2MAX
         HERFAC(I)=HERFAC(I-1)*SQRT(REAL(2*I,KIND=8))
      END DO
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE NORFAC(HERFAC,ND2MAX)
      DIMENSION
     *          HERFAC(0:ND2MAX)
C
      HERFAC(0)=SQRT(SQRT(4.0D0*ATAN(1.0D0)))
C
      DO I=1,ND2MAX
         HERFAC(I)=HERFAC(I-1)*SQRT(REAL(2*I,KIND=8))
      END DO
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE HRECUR(PN,DPN,PN1,X,NN)
      IMPLICIT
     *         DOUBLE PRECISION (A-H,O-Z)
C
C=======================================================================
C         AUXILIARY RECURRENCE ROUTINE (FROM THE MONOGRAPH BY STROUD)
C=======================================================================
C
      P1=1.0D0
      P =X
C
      DP1=0.0D0
      DP =1.0D0
C
      DO J=2,NN
C
         FJ =J
         FJ2=(FJ-1.0D0)/2.0D0
C
         Q =X*P-FJ2*P1
         DQ=X*DP+P-FJ2*DP1
C
         P1=P
         P =Q
C
         DP1=DP
         DP =DQ
C
      END DO
C
      PN=P
      DPN=DP
      PN1=P1
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE H_ROOT(X,NN,DPN,PN1,EPS)
      IMPLICIT
     *         DOUBLE PRECISION (A-D,F-H,O-Z)
      DATA
     *     ITERMX / 25 /
C
C=======================================================================
C        IMPROVES THE APPROXIMATED ROOT X. IN ADDITION WE ALSO OBTAIN
C                                          PN1 = VALUE OF H(N-1) AT X
C        (FROM THE MONOGRAPH BY STROUD)
C=======================================================================
C
      ITER=0
   1  ITER=ITER+1
C
      CALL HRECUR(P,DP,PN1,X,NN)
C
      D=P/DP
      X=X-D
C
      IF (ABS(D)-EPS) 3,3,2
C
   2  IF (ITER-ITERMX) 1,4,4
C
   3  DPN=DP
C
      RETURN
C
   4  CONTINUE
C
      DPN=DP
C
      PRINT 5,ITER,X,DP
   5  FORMAT(///,1X,'ITERATIONS IN H_ROOT, ITER = ',I2,'  X =',F20.10,
     *              '  DP = ',F20.10,///)
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE HERMIT(NN,X,A,NDHERM)
C=======================================================================
      USE hfodd_sizes
C=======================================================================
#if(SWITCH_QUAD==1)
      REAL*16
     *          FACTOR
#endif
C
      DIMENSION
     *          X(NDHERM),A(NDHERM)
C
      COMMON
     *       /RFACTO/ FACTOR(0:NDFACR)
      COMMON
     *       /HEREPS/ EPSHER
C
C=======================================================================
C
C         HERMIT CALCULATES ZEROES X(I) OF THE N-TH ORDER HERMITE
C         POLYNOMIAL.   THE  LARGEST  ZERO  IS  STORED  IN  X(1).
C         IT CALCULATES  ALSO THE CORRESPONDING COEFFICIENTS A(I)
C         OF THE  NN-TH ORDER  GAUSS-HERMITE  QUADRATURE  FORMULA
C         OF THE DEGREE 2*NN-1 .
C
C         (TRIVIAL MODIFICATIONS OF THE ROUTINE FROM STROUD BOOK)
C
C=======================================================================
C
      PI=4.0D0*ATAN(1.0D0)
C
      IF (NDHERM.GT.NDFACR) STOP 'NDHERM.GT.NDFACR IN HERMIT'
C
      EEPS=EPSHER
C
      N1=NN-1
      N2=(NN+1)/2
C
      CC=SQRT(PI)*FACTOR(NN-1)/(2.0D0**N1)
      S=(2.0D0*NN+1)**.16667D0
C
      DO I=1,N2
C
         IF (I-1) 10,1,2
C
C=======================================================================
C            T H E   L A R G E S T    Z E R O
C=======================================================================
C
   1     XT=S**3-1.85575D0/S
C
         GO TO 9
C
   2     IF (I-2) 10,3,4
C
C=======================================================================
C            T H E     S E C O N D    Z E R O
C=======================================================================
C
   3     XT=XT-1.14D0*NN**.426D0/XT
C
         GO TO 9
C
   4     IF (I-3) 10,5,6
C
C=======================================================================
C            T H E     T H I R D     Z E R O
C=======================================================================
C
   5     XT=1.86D0*XT-.86D0*X(1)
C
         GO TO 9
C
   6     IF (I-4) 10,7,8
C
C=======================================================================
C            T H E     F O U R T H   Z E R O
C=======================================================================
C
   7     XT=1.91D0*XT-.91D0*X(2)
C
         GO TO 9
C
C=======================================================================
C            A L L     O T H E R   Z E R O S
C=======================================================================
C
   8     XT=2.0D0*XT-X(I-2)
C
   9     XTT=XT
C
C=======================================================================
         CALL H_ROOT(XTT,NN,DDPN,PPN1,EEPS)
C=======================================================================
C
         DPN=DDPN
         PN1=PPN1
         XT =XTT
C
         X(I)=XT
         A(I)=CC/DPN/PN1
         NI=NN-I+1
         X(NI)=-XT
         A(NI)=A(I)
C
      END DO
C
   10 CONTINUE
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE TIMPRI
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      CHARACTER
     *          NAMALL*6,OUITEM(NDCOLU)*17
      CHARACTER
     *          TYTIME*10
C
      DIMENSION
     *          ATIALL(NDSUBR),NTIALL(NDSUBR),ITIALL(NDSUBR)
C
      COMMON
     *       /TIMEXE/ TIMALL(NDSUBR),TIMACT(NDSUBR),
     *                KONOFF(NDSUBR),NAMALL(NDSUBR),NUCALL(NDSUBR)
      COMMON
     *       /TIMNOW/ NUSUBR,TYTIME
      COMMON
     *       /CFIPRI/ NFIPRI
C
C=======================================================================
C         THIS SUBROUTINE PRINTS EXECUTION TIMES AND NUMBERS OF CALLS
C         FOR DIFFERENT SUBROUTINES
C=======================================================================
C
      IF (NUSUBR.GT.0) THEN
C
C=======================================================================
C         PRINT EXECUTION TIMES
C=======================================================================
C
          WRITE(NFIPRI,'(79(1H*),/,              1H*,77X,1H*,/,
     *                 1H*,2X,A10,''  EXECUTION  TIMES '',
     *                        ''IN SUBROUTINES'',    32X,1H*,/,
     *                 1H*,2X,''INCLUDING THEIR COMPLETE '',
     *                        ''DOWN-CALLING TREES'',32X,1H*,/,
     *                                           1H*,77X,1H*,/,
     *                                               79(1H*),/,
     *                                           1H*,77X,1H*)') TYTIME
C
          DO ITSUBR=1,NUSUBR
C
             ATIALL(ITSUBR)=    -TIMALL(ITSUBR)
             ITIALL(ITSUBR)= INT(TIMALL(ITSUBR))
             NTIALL(ITSUBR)=            ITSUBR
C
          END DO
C
          CALL ORDER1(ATIALL,NTIALL,NUSUBR)
C
          DO ITSUBR=1,NUSUBR,NDCOLU
C
             DO NUITEM=1,NDCOLU
                OUITEM(NUITEM)='                 '
             END DO
C
             MXITEM=MIN(NUSUBR-ITSUBR+1,NDCOLU)
C
             DO NUITEM=1,MXITEM
C
                MUSUBR=ITSUBR+NUITEM-1
C
                IF (KONOFF(MUSUBR).EQ.1) THEN
C
                    WRITE(NFIPRI,'(/,     1X,19(1H/),
     *                    '' IN TIMPRI TIME IS STILL ON FOR '',
     *                                 A6,3X,19(1H/),/)') NAMALL(MUSUBR)
C
                    STOP ' IN TIMPRI TIME IS STILL ON'
C
                END IF
C
                WRITE(OUITEM(NUITEM),'(I7,'' => '',A6)')
     *                     ITIALL(NTIALL(MUSUBR)),NAMALL(NTIALL(MUSUBR))
C
             END DO
C
          WRITE(NFIPRI,'(1H*,2X,4A17,7X,1H*,/,1H*,77X,1H*)')
     *             (OUITEM(NUITEM),NUITEM=1,NDCOLU)
C
          END DO
C
C=======================================================================
C         PRINT NUMBERS OF CALLS
C=======================================================================
C
          WRITE(NFIPRI,'(79(1H*),/,              1H*,77X,1H*,/,
     *                 1H*,2X,''NUMBERS OF CALLS '',
     *                        ''TO SUBROUTINES'',    44X,1H*,/,
     *                                           1H*,77X,1H*,/,
     *                                               79(1H*),/,
     *                                           1H*,77X,1H*)')
C
          DO ITSUBR=1,NUSUBR
C
             ATIALL(ITSUBR)=-NUCALL(ITSUBR)
             ITIALL(ITSUBR)= NUCALL(ITSUBR)
             NTIALL(ITSUBR)=        ITSUBR
C
          END DO
C
          CALL ORDER1(ATIALL,NTIALL,NUSUBR)
C
          DO ITSUBR=1,NUSUBR,NDCOLU
C
             DO NUITEM=1,NDCOLU
                OUITEM(NUITEM)='                 '
             END DO
C
             MXITEM=MIN(NUSUBR-ITSUBR+1,NDCOLU)
C
             DO NUITEM=1,MXITEM
C
                MUSUBR=ITSUBR+NUITEM-1
C
                WRITE(OUITEM(NUITEM),'(I7,'' => '',A6)')
     *                     ITIALL(NTIALL(MUSUBR)),NAMALL(NTIALL(MUSUBR))
C
             END DO
C
          WRITE(NFIPRI,'(1H*,2X,4A17,7X,1H*,/,1H*,77X,1H*)')
     *             (OUITEM(NUITEM),NUITEM=1,NDCOLU)
C
          END DO
C
          WRITE(NFIPRI,'(79(1H*))')
C
      END IF
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      BLOCK DATA OLDIES
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      CHARACTER
     *          SPKART*10,SPNILS*15,SPORDE*13
      CHARACTER
     *          OLKART*10,OLNILS*15,OLORDE*13
C
      COMMON
     *       /SPLEVS/ SPENER(1:2*NDSTAT,0:NDISOS),
     *                SPOCCU(1:2*NDSTAT,0:NDISOS),
     *                SPALIG(1:2*NDSTAT,0:NDISOS),
     *                SPSPAL(1:2*NDSTAT,0:NDISOS),
     *                SPPARI(1:2*NDSTAT,0:NDISOS),
     *                SPSIMP(1:2*NDSTAT,0:NDISOS)
      COMMON
     *       /SPSTAT/ SPXALI(1:2*NDSTAT,0:NDISOS),
     *                SPZALI(1:2*NDSTAT,0:NDISOS),
     *                SPXSPI(1:2*NDSTAT,0:NDISOS),
     *                SPZSPI(1:2*NDSTAT,0:NDISOS)
      COMMON
     *       /SPLABS/ SPKART(1:2*NDSTAT,0:NDISOS),
     *                SPNILS(1:2*NDSTAT,0:NDISOS),
     *                SPORDE(1:2*NDSTAT,0:NDISOS)
      COMMON
     *       /SPLOLD/ OLALIG(1:2*NDSTAT,0:NDISOS),
     *                OLSPAL(1:2*NDSTAT,0:NDISOS),
     *                OLPARI(1:2*NDSTAT,0:NDISOS)
      COMMON
     *       /SPSOLD/ OLXALI(1:2*NDSTAT,0:NDISOS),
     *                OLZALI(1:2*NDSTAT,0:NDISOS),
     *                OLXSPI(1:2*NDSTAT,0:NDISOS),
     *                OLZSPI(1:2*NDSTAT,0:NDISOS)
      COMMON
     *       /SPKOLD/ OLKART(1:2*NDSTAT,0:NDISOS),
     *                OLNILS(1:2*NDSTAT,0:NDISOS),
     *                OLORDE(1:2*NDSTAT,0:NDISOS)
C
      DATA
     *                SPENER /NDDATA*0.0D0/,
     *                SPOCCU /NDDATA*0.0D0/,
     *                SPALIG /NDDATA*0.0D0/,
     *                SPSPAL /NDDATA*0.0D0/,
     *                SPPARI /NDDATA*0.0D0/,
     *                SPSIMP /NDDATA*0.0D0/
      DATA
     *                SPXALI /NDDATA*0.0D0/,
     *                SPZALI /NDDATA*0.0D0/,
     *                SPXSPI /NDDATA*0.0D0/,
     *                SPZSPI /NDDATA*0.0D0/
      DATA
     *                SPKART /NDDATA*'..........'     /,
     *                SPNILS /NDDATA*'...............'/,
     *                SPORDE /NDDATA*'.............'  /
      DATA
     *                OLALIG /NDDATA*0.0D0/,
     *                OLSPAL /NDDATA*0.0D0/,
     *                OLPARI /NDDATA*0.0D0/
      DATA
     *                OLXALI /NDDATA*0.0D0/,
     *                OLZALI /NDDATA*0.0D0/,
     *                OLXSPI /NDDATA*0.0D0/,
     *                OLZSPI /NDDATA*0.0D0/
      DATA
     *                OLKART /NDDATA*'..........'     /,
     *                OLNILS /NDDATA*'...............'/,
     *                OLORDE /NDDATA*'.............'  /
C
      END
C
C=======================================================================
C
      BLOCK DATA ALLENS
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      DIMENSION
     *          ALL_EN(1:NDENES)
      COMMON
     *       /ALLENE/ EKIN_N,EKIN_P,EKIN_T,
     *                EPOT_N,EPOT_P,EPOT_T,
     *                ESUM_N,ESUM_P,ESUM_T,
     *                EPAI_N,EPAI_P,EPAI_T,
     *                EREA_N,EREA_P,EREA_T,
     *                ELIP_N,ELIP_P,ELIP_T,
     *
     *                ECOULD,ECOULE,ECOULT,
     *                       ECOULS,ECOULV,
     *
     *                EMULCO,EMUSLO,EMUREA,
     *                ESIFCO,ESISLO,ESIREA,
     *                ESPICO,ESPSLO,ESPREA,
     *
     *                ENREAR,ECORCM,ECOR_R,
     *
     *                EEVEW0,EODDW0,ENE_W0,
     *                ENEVEN,ENEODD,ENESKY,
     *                ESTABN,ETOTSP,ETOTFU
C
      EQUIVALENCE
     *            (EKIN_N,ALL_EN)
C
      DATA
     *                ALL_EN /NDENES*0.0D0/
C
      END
C
C=======================================================================
C
      BLOCK DATA CPUDAT
C
      CHARACTER
     *          TYTIME*10
C
      COMMON
     *       /TIMNOW/ NUSUBR,TYTIME
C
      DATA
     *       NUSUBR /0/,TYTIME /'         '/
C
      END
C
C=======================================================================
C
      BLOCK DATA CONPHY
C
      COMMON
     *       /PHYCON/ H_BARC,XMASSP,XMASSN,HBCOE2
C
C=======================================================================
C
C         IN THIS PROGRAM, THE DEFINITIONS OF THE H_BAR,  MASS, AND E**2
C         FACTORS ARE:
C
C                       H_BAR*C    = 197.32891 MEV * FM
C                       MASS *C**2 = 938.90590 MEV
C                       H_BAR*C/E2 = 137.03602D0
C
C         THESE PARTICULAR VALUES EXIST, AT PRESENT, IN  A L L OTHER
C         WOODS-SAXON CODES. THE NEWER EXPERIMENTAL VALUES ARE GIVEN
C         BELOW (COMMENTED OUT DATA STATEMENT) BUT PRESENTLY UNUSED.
C
C         THE KINETIC ENERGY COEFFICIENT IS DENOTED:
C
C                              HBMASS
C
C         THE KINETIC ENERGY COEFFICIENT CONTAINING THE 'RECOIL TERM'
C         IS DENOTED:
C                              HBMRPA = HBMASS*(1-1/A)
C
C         THE OTHER HARTREE-FOCK CODES (COORDINATE SPACE CODES) USE:
C
C                   H_BAR = 6.582180 MEV * 10**(-22)  SEC
C                   MASS  = 1.044673 MEV * 10**(-22) (SEC/FM)**2
C
C=======================================================================
C
C         THESE CODES USE ONLY THE COMBINATION HBM = H_BAR**2/2*MASS
C         WHICH FOR THE NUMERICAL CONSTANTS USED AT PRESENT GIVES:
C
C                         HBM = 20.736209 MEV * FM**2
C
C         OLDER HARTREE-FOCK CODES, USING THE CYLINDRICAL OSCILLATOR
C         BASIS HAVE DIRECTLY HBM=H_BARC**2/(2*XMASSN). NUMERICALLY:
C
C                         HBM = 20.73     MEV * FM**2
C
C         THE COORDINATE-SPACE HARTREE-FOCK CODES USE:
C
C                         HBM = 20.73620  MEV * FM**2
C
C         THE SKI FORCES HAVE BEEN FITTED WITH:
C
C                         HBM = 20.7525   MEV * FM**2
C
C         THE SKO FORCES HAVE BEEN FITTED WITH:
C
C                         HBM = 20.73553  MEV * FM**2
C
C         THE E**2 FACTOR USED IN THE COULOMB POTENTIAL IS CALCULATED AS
C
C                         E**2 = H_BARC / HBCOE2  MEV * FM
C
C=======================================================================
C
C         AFTER FINISHING THE TEST THE AVERAGE 0.5*(M_PROT+M_NEUT)
C         WILL BE USED; FOR THE MOMENT DUPA.
C         TRZEBA WRESZCIE SPRAWDZIC SKAD POCHODZI TA WARTOSC XMASSN
C
C=======================================================================
C
      DATA
     *     H_BARC,XMASSP,XMASSN / 197.32891D0, 938.27231D0, 938.90590D0/
C    *     H_BARC,XMASSP,XMASSN /197.327053D0, 938.27231D0, 939.56563D0/
C
      DATA
     *     HBCOE2 / 137.03602D0 /
C    *     HBCOE2 / 137.035989D0 /
C
      END
C
C=======================================================================
C
      SUBROUTINE CPUTIM(NAMSUB,IONOFF)
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      CHARACTER
     *          NAMSUB*6,NAMALL*6
      CHARACTER
     *          TYTIME*10
C
CETIM INTEGER*4
CETIM*          DUMMY
CUNIX INTEGER*4
CUNIX*          TIME,DUMMY
CF32  INTEGER*2
CF32 *          IHOURS,IMINUT,ISECON,IHUNDR
C
      COMMON
     *       /TIMEXE/ TIMALL(NDSUBR),TIMACT(NDSUBR),
     *                KONOFF(NDSUBR),NAMALL(NDSUBR),NUCALL(NDSUBR)
      COMMON
     *       /TIMNOW/ NUSUBR,TYTIME
      COMMON
     *       /CFIPRI/ NFIPRI
C
C=======================================================================
C         THIS SUBROUTINE COLLECTS EXECUTION TIMES FOR DIFFERENT
C         SUBROUTINES
C=======================================================================
C
      I_SUBR=0
C
C=======================================================================
C         TRACING THE CALLS
C=======================================================================
C
C     IF (IONOFF.EQ.1)
C    *    WRITE(NFIPRI,'('' ENTERING SUBROUTINE: '', A6)') NAMSUB
C     IF (IONOFF.EQ.0)
C    *    WRITE(NFIPRI,'('' LEAVING  SUBROUTINE: '',A13)') NAMSUB
C
C=======================================================================
C         THE SUBROUTINE IS IDENTIFIED BY ITS NAME. CONSECUTIVE
C         NUMBERS ARE ATTRIBUTED TO SUBROUTINES IN THE SEQUENCE
C         OF CONSECUTIVE CALLS TO CPUTIM.
C=======================================================================
C
      IF (NUSUBR.GT.0) THEN
C
          DO MUSUBR=1,NUSUBR
             IF (NAMALL(MUSUBR).EQ.NAMSUB) I_SUBR=MUSUBR
          END DO
C
      ELSE
C
          DO MUSUBR=1,NDSUBR
             KONOFF(MUSUBR)=0
             TIMACT(MUSUBR)=0
          END DO
C
      END IF
C
      IF (I_SUBR.EQ.0) THEN
C
          IF (NUSUBR.GE.NDSUBR) STOP ' TOO LARGE NUSUBR IN CPUTIM'
C
          NUSUBR=NUSUBR+1
          I_SUBR=NUSUBR
          NAMALL(I_SUBR)=NAMSUB
          TIMALL(I_SUBR)=0
          NUCALL(I_SUBR)=0
C
      END IF
C
      TSCNDS=0
C
C=======================================================================
C         HERE A CALL IS MADE TO INTEGER*4 FUNCTION  "TIME"
C         WHICH RETURNS THE TIME OF THE REAL CLOCK  OF  THE
C         SYSTEM. ANY OTHER TIME-RETURNING  SUBROUTINE  CAN
C         REPLACE "TIME".
C=======================================================================
C
CUNIX TYTIME='REAL-CLOCK'
CSAL  TYTIME='REAL-CLOCK'
CF32  TYTIME='REAL-CLOCK'
C
CUNIX TSCNDS= TIME(DUMMY)
CSAL  CALL DCLOCK@(SECNDS)
CSAL  TSCNDS=SECNDS
CF32  CALL GETTIM(IHOURS,IMINUT,ISECON,IHUNDR)
CF32  TSCNDS=3600*IHOURS+60*IMINUT+ISECON+IHUNDR/100.
C
C=======================================================================
C         HERE A CALL IS MADE TO INTEGER*4 FUNCTION "ETIME"
C         WHICH RETURNS  THE  PROCESSOR  CPU  TIME  OF  THE
C         SYSTEM. ANY OTHER TIME-RETURNING  SUBROUTINE  CAN
C         REPLACE "eTIME".
C=======================================================================
C
CETIM TYTIME='PROCESSOR '
      TYTIME='PROCESSOR '
C
CETIM TSCNDS=ETIME(DUMMY(1))
      CALL CPU_TIME(ATIME)
      TSCNDS=ATIME
C
C=======================================================================
C
      IF (IONOFF.NE.0.AND.IONOFF.NE.1) STOP ' WRONG IONOFF IN CPUTIM'
C
      IF (IONOFF.EQ.1) THEN
C
C=======================================================================
C         HERE THE TIME IS SET
C=======================================================================
C
          IF (KONOFF(I_SUBR).EQ.1) THEN
C
              WRITE(NFIPRI,'(/,'' TIME IS ALREADY ON IN CPUTIM'',
     *                         '' FOR THE SUBROUTINE: '', A6)') NAMSUB
C
              STOP ' TIME IS ALREADY ON  IN CPUTIM'
C
          END IF
C
          TIMACT(I_SUBR)=TSCNDS
          KONOFF(I_SUBR)=1
          NUCALL(I_SUBR)=NUCALL(I_SUBR)+1
C
      ELSE
C
C=======================================================================
C         HERE THE TIME IS COLLECTED
C=======================================================================
C
          IF (KONOFF(I_SUBR).EQ.0) THEN
C
              WRITE(NFIPRI,'(/,'' TIME IS ALREADY OFF IN CPUTIM'',
     *                         '' FOR THE SUBROUTINE: '', A6)') NAMSUB
C
              STOP ' TIME IS ALREADY OFF  IN CPUTIM'
C
          END IF
C
          TIMALL(I_SUBR)=TIMALL(I_SUBR)+TSCNDS-TIMACT(I_SUBR)
          KONOFF(I_SUBR)=0
C
      END IF
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE DIAMAT(CELMTS,EIGVAL,EWAVEF,LDACTU,NDACTU,NUMVEC)
C=======================================================================
      USE hfodd_sizes
C=======================================================================
#if(USE_MPI==1)
      INTEGER :: escapeSignal
#endif
      COMPLEX
     *          C_ZERO,CELMTS,EWAVEF
      COMPLEX
     *          AUXDIC
      COMPLEX
     *          UNPMAT,AUXZHC
C
C=======================================================================
      CHARACTER
     *          SWI*1
C=======================================================================
      ALLOCATABLE UNPMAT(:,:)
      ALLOCATABLE AUXZHC(:)
      ALLOCATABLE AUXZHR(:)
      ALLOCATABLE IAUXZH(:)
      ALLOCATABLE ISUPPZ(:)
      ALLOCATABLE AUXDIA(:)
      ALLOCATABLE AUXDIC(:)
      ALLOCATABLE AUXDID(:)
      ALLOCATABLE IAUXDI(:)
      ALLOCATABLE I_FAIL(:)
C=======================================================================
      DIMENSION
     *          CELMTS(1:((NDACTU+1)*NDACTU)/2)
      DIMENSION
     *          EIGVAL(1:NDACTU)
      DIMENSION
     *          EWAVEF(1:NDACTU,1:NDACTU)
C
      COMMON
     *       /EIGLIM/ EIGMIN,EIGMAX
      COMMON
     *       /CFIPRI/ NFIPRI
#if(USE_MPI==1)
      COMMON
     *       /SIGNAL/ escapeSignal
#endif
C
C=======================================================================
C
      CALL CPUTIM('DIAMAT',1)
C
C=======================================================================
C
C         THIS IS AN AUXILIARY ROUTINE WHICH FORMS AN INTERFACE TO
C         DIFFERENT LIBRARY DIAGONALIZATION ROUTINES.
C
C         Below is an excerpt of the LAPACK Usder's Guide
C
C        "There are four types of driver routines for symmetric and
C         Hermitian eigenproblems. Originally LAPACK had just the
C         simple and expert drivers described below, and the other two
C         were added after improved algorithms were discovered. Ultima-
C         tely we expect the algorithm in the most recent driver (called
C         RRR below) to supersede all the others, but in LAPACK 3.x the
C         other drivers may still be faster on some problems, so we
C         retain them.
C
C           * A simple driver (name ending -EV) computes all the
C             eigenvalues and (optionally) eigenvectors.
C
C           * An expert driver (name ending -EVX) computes all or a
C             selected subset of the eigenvalues and (optionally)
C             eigenvectors. If few enough eigenvalues or eigenvectors
C             are desired, the expert driver is faster than the simple
C             driver.
C
C           * A divide-and-conquer driver (name ending -EVD) solves
C             the same problem as the simple driver. It is much faster
C             than the simple driver for large matrices, but uses more
C             workspace. The name divide-and-conquer refers to the
C             underlying algorithm.
C
C           * A relatively robust representation (RRR) driver (name
C             ending -EVR) computes all or (in a later release) a
C             subset of the eigenvalues, and (optionally) eigenvectors.
C             It is the fastest algorithm of all (except for a few
C             cases), and uses the least workspace. The name RRR
C             refers to the underlying algorithm."
C
C=======================================================================
C
      IF (NDACTU.GT.NDBASD) STOP 'NDACTU.GT.NDBASD IN DIAMAT'
      IF (LDACTU.GT.NDACTU) STOP 'LDACTU.GT.NDACTU IN DIAMAT'
C
      NUMFOU=0
      INFORM=1
C
      JZHPEV=0
C
      C_ZERO=CMPLX(0.0D0,0.0D0)
C
C=======================================================================
C          ZEROING THE MATRIX OF EIGENVECTORS
C=======================================================================
C
      EWAVEF(:,:)=C_ZERO
C
C=======================================================================
C                  SIMPLE DRIVER IN PACKED STORAGE
C=======================================================================
C
#if(SWITCH_DIAG==1)
C
      IALLOC=0
      INFORM=0
C
      LDWORK=2*LDACTU-1
      ALLOCATE(AUXDIC(1:LDWORK),STAT=IALLOC)
      IF (IALLOC.NE.0) CALL NOALLO('AUXDIC','DIAMAT')
C
      LRWORK=3*LDACTU-2
      ALLOCATE(AUXDID(1:LRWORK),STAT=IALLOC)
      IF (IALLOC.NE.0) CALL NOALLO('AUXDID','DIAMAT')
C
      JZHPEV=1
      CALL ZHPEV('V','L',LDACTU,CELMTS,EIGVAL,EWAVEF,
     *                   NDACTU,AUXDIC,AUXDID,INFORM)
C
      IF (INFORM.NE.0) THEN
C
          WRITE(NFIPRI,'(//,1X,20(1H=),
     *                   ''  ERROR IN ZHPEV, INFORM='',
     *                   I4,1X,20(1H=),/,
     *                      1X,79(1H=))')
     *
     *          INFORM
C
#if(USE_MPI==1)
C
          CALL CPUTIM('DIAMAT',0)
C
          escapeSignal = 1
          RETURN
#else
          STOP ' ERROR IN ZHPEV'
#endif
C
      END IF
C
      DEALLOCATE(AUXDIC,AUXDID)
C
#endif
C
C=======================================================================
C               EXPERT DRIVER IN PACKED STORAGE
C=======================================================================
C
#if(SWITCH_DIAG==2)
C
      IALLOC=0
      INFORM=0
C
      ALLOCATE (AUXDIC(1:2*LDACTU),STAT=IALLOC)
      IF (IALLOC.NE.0) CALL NOALLO('AUXDIC','DIAMAT')
      ALLOCATE (AUXDID(1:7*LDACTU),STAT=IALLOC)
      IF (IALLOC.NE.0) CALL NOALLO('AUXDID','DIAMAT')
      ALLOCATE (IAUXDI(1:5*LDACTU),STAT=IALLOC)
      IF (IALLOC.NE.0) CALL NOALLO('IAUXDI','DIAMAT')
      ALLOCATE (I_FAIL(1:LDACTU),STAT=IALLOC)
      IF (IALLOC.NE.0) CALL NOALLO('I_FAIL','DIAMAT')
C
      DO I=1,LDACTU
         I_FAIL(I)=0
      END DO
C
      IF (NUMVEC.EQ.0) THEN
          SWI='V'
      ELSE
          SWI='I'
      END IF
C
      ABSTOL=2*DLAMCH('S')
C
      JZHPEV=1
      CALL ZHPEVX('V',SWI,'L',LDACTU,CELMTS,EIGMIN,EIGMAX,1,NUMVEC,
     *                        ABSTOL,NUMFOU,EIGVAL,EWAVEF,NDACTU,
     *                        AUXDIC,AUXDID,IAUXDI,I_FAIL,INFORM)
C
      IF (NUMVEC.EQ.0) NUMVEC=NUMFOU
C
      IF (INFORM.NE.0.OR.NUMVEC.NE.NUMFOU) THEN
C
          WRITE(NFIPRI,'(//,1X,20(1H/),
     *                      '' ERROR IN ZHPEVX, INFORM='',
     *                   I4,1X,20(1H/),/,1X,20(1H/),
     *                      '' ERROR IN ZHPEVX, NUMVEC='',
     *                   I4,1X,20(1H/),/,1X,20(1H/),
     *                      '' ERROR IN ZHPEVX, NUMFOU='',
     *                   I4,1X,20(1H/),/)')
     *
     *          INFORM,NUMVEC,NUMFOU
C
          DO I=1,LDACTU
             IF (I_FAIL(I).GT.0) THEN
                 WRITE(6,'(''I = '',i4,'' I_FAIL = '',i4)')
     *                       I,I_FAIL(I)
             END IF
          END DO
C
#if(USE_MPI==1)
C
          CALL CPUTIM('DIAMAT',0)
C
          escapeSignal = 1
          RETURN
#else
          STOP ' ERROR IN ZHPEVX'
#endif
C
      END IF
C
      DEALLOCATE (AUXDIC,AUXDID,IAUXDI,I_FAIL)
C
#endif
C
C=======================================================================
C      RELATIVELY ROBUST REPRESENTATION (RRR) DRIVER IN UNPACKED
C      STORAGE
C=======================================================================
C
#if(SWITCH_DIAG==3)
C
      IALLOC=0
      INFORM=0
C
      ALLOCATE (UNPMAT(1:NDACTU,1:NDACTU),STAT=IALLOC)
      IF (IALLOC.NE.0) CALL NOALLO('UNPMAT','DIAMAT')
      ALLOCATE (AUXZHC(1:32*NDACTU),STAT=IALLOC)
      IF (IALLOC.NE.0) CALL NOALLO('AUXZHC','DIAMAT')
      ALLOCATE (AUXZHR(1:24*NDACTU),STAT=IALLOC)
      IF (IALLOC.NE.0) CALL NOALLO('AUXZHR','DIAMAT')
      ALLOCATE (IAUXZH(1:10*NDACTU),STAT=IALLOC)
      IF (IALLOC.NE.0) CALL NOALLO('IAUXZH','DIAMAT')
      ALLOCATE (ISUPPZ(1:2*NDACTU),STAT=IALLOC)
      IF (IALLOC.NE.0) CALL NOALLO('ISUPPZ','DIAMAT')
C
C     UNPACK MATRIX. ONLY THE LOWER TRIANGLE NEEDS TO BE FILLED
C
      NCOUNT=0
C
      DO IKET=1,LDACTU
         DO IBRA=IKET,LDACTU
C
            NCOUNT=NCOUNT+1
            UNPMAT(IBRA,IKET)=CELMTS(NCOUNT)
C
         END DO
      END DO
C
      IF (NUMVEC.EQ.0) THEN
          SWI='V'
      ELSE
          SWI='I'
      END IF
C
      ABSTOL=2*DLAMCH('S')
C
      JZHPEV=1
      CALL ZHEEVR('V',SWI,'L',LDACTU,UNPMAT,NDACTU,EIGMIN,EIGMAX,
     *           1,NUMVEC,ABSTOL,NUMFOU,EIGVAL,EWAVEF,NDACTU,
     *             ISUPPZ,AUXZHC,32*NDACTU,AUXZHR,
     *             24*NDACTU,IAUXZH,10*NDACTU,INFORM)
C
      IF (NUMVEC.EQ.0) NUMVEC=NUMFOU
C
      IF (INFORM.NE.0.OR.NUMVEC.NE.NUMFOU) THEN
C
          WRITE(NFIPRI,'(//,1X,20(1H/),
     *                      '' ERROR IN ZHEEVR, INFORM='',
     *                   I4,1X,20(1H/),/,1X,20(1H/),
     *                      '' ERROR IN ZHEEVR, NUMVEC='',
     *                   I4,1X,20(1H/),/,1X,20(1H/),
     *                      '' ERROR IN ZHEEVR, NUMFOU='',
     *                   I4,1X,20(1H/),/)')
     *
     *          INFORM,NUMVEC,NUMFOU
C
#if(USE_MPI==1)
C
          CALL CPUTIM('DIAMAT',0)
C
          escapeSignal = 1
          RETURN
#else
          STOP ' ERROR IN ZHEEVR'
#endif
C
      END IF
C
      DEALLOCATE (ISUPPZ,AUXZHC,AUXZHR,IAUXZH,UNPMAT)
C
#endif
C
C=======================================================================
C      DIVIDE AND CONQUER DRIVER IN UNPACKED STORAGE
C=======================================================================
C
#if(SWITCH_DIAG==4)
C
      IALLOC=0
      INFORM=0
C
C     UNPACK MATRIX. ONLY THE LOWER TRIANGLE NEEDS TO BE FILLED
C
      NCOUNT=0
C
      DO IKET=1,LDACTU
         DO IBRA=IKET,LDACTU
C
            NCOUNT=NCOUNT+1
            EWAVEF(IBRA,IKET)=CELMTS(NCOUNT)
C
         END DO
      END DO
C
      LDWORK=LDACTU*LDACTU+2*LDACTU
      ALLOCATE (AUXDIC(1:LDWORK),STAT=IALLOC)
      IF (IALLOC.NE.0) CALL NOALLO('AUXDIC','DIAMAT')
C
      LRWORK=1+5*LDACTU+2*LDACTU**2
      ALLOCATE (AUXZHC(1:LRWORK),STAT=IALLOC)
      IF (IALLOC.NE.0) CALL NOALLO('AUXZHC','DIAMAT')
C
      LIWORK=3+5*LDACTU
      ALLOCATE (IAUXZH(1:LIWORK),STAT=IALLOC)
      IF (IALLOC.NE.0) CALL NOALLO('IAUXZH','DIAMAT')
C
      JZHPEV=1
      CALL ZHEEVD('V','L',LDACTU,EWAVEF,NDACTU,EIGVAL,
     *                    AUXDIC,LDWORK,AUXZHC,LRWORK,
     *                    IAUXZH,LIWORK,INFORM)
C
      IF (INFORM.NE.0) THEN
C
          WRITE(NFIPRI,'(//,1X,20(1H=),
     *                   ''  ERROR IN ZHPEV, INFORM='',
     *                   I4,1X,20(1H=),/,
     *                      1X,79(1H=))')
     *
     *          INFORM
C
#if(USE_MPI==1)
C
          CALL CPUTIM('DIAMAT',0)
C
          escapeSignal = 1
          RETURN
#else
          STOP ' ERROR IN ZHEEVD'
#endif
C
      END IF
C
      DEALLOCATE (IAUXZH,AUXDIC,AUXZHC)
C
#endif
C
C=======================================================================
C
      IF (JZHPEV.NE.1) STOP 'switch_diag .NE. 1,2,3,4 IN DIAMAT ?'
C
C=======================================================================
C
      CALL CPUTIM('DIAMAT',0)
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE INVWAV(LSTATE,INIINV,INIKAR,WARIGH)
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      COMPLEX
     *          WARIGH,FACSPI,UNIT_I,WDUMMY
C
      DIMENSION
     *          WARIGH(1:NDBASE,1:4*NDSTAT,0:NDSPIN)
      DIMENSION
     *          IFACTO(0:NDSPIN),I_SPIN(0:NDSPIN),IDUMMY(0:NDSPIN)
      DIMENSION
     *          WDUMMY(0:NDSPIN)
C
      COMMON
     *       /BASISO/ NXVECT(1:NDBASE),NYVECT(1:NDBASE),NZVECT(1:NDBASE)
      COMMON
     *       /DIMENS/ LDBASE
C
C=======================================================================
C
      CALL CPUTIM('INVWAV',1)
C
C======================================================================
C        THIS SUBROUTINE PERFORMS THE D2H TRANSFORMATION OF THE
C        WAVE FUNCTION, SEE PRC62-014310, EQS. (27)
C======================================================================
C
      UNIT_I=CMPLX(0.0D0,1.0D0)
C
      DO IBASE=1,LDBASE
C
         NX=NXVECT(IBASE)
         NY=NYVECT(IBASE)
         NZ=NZVECT(IBASE)
C
         IFACTO(0)=0
C
C======================================================================
C        IDENTITY
C======================================================================
C
         IF (INIKAR.EQ.0) THEN
C
             FACSPI=1.0D0
             IFACTO(0)=1
             IFACTO(1)=1
             I_SPIN(0)=0
             I_SPIN(1)=1
C
         END IF
C
C======================================================================
C        X-SIGNATURE
C======================================================================
C
         IF (INIKAR.EQ.1) THEN
C
             FACSPI=UNIT_I
             IFACTO(0)=(-1)**(NY+NZ+1)
             IFACTO(1)=(-1)**(NY+NZ+1)
             I_SPIN(0)=1
             I_SPIN(1)=0
C
         END IF
C
C======================================================================
C        Y-SIGNATURE
C======================================================================
C
         IF (INIKAR.EQ.2) THEN
C
             FACSPI=1.0D0
             IFACTO(0)=(-1)**(NX+NZ)
             IFACTO(1)=(-1)**(NX+NZ+1)
             I_SPIN(0)=1
             I_SPIN(1)=0
C
         END IF
C
C======================================================================
C        Z-SIGNATURE
C======================================================================
C
         IF (INIKAR.EQ.3) THEN
C
             FACSPI=UNIT_I
             IFACTO(0)=(-1)**(NX+NY+1)
             IFACTO(1)=(-1)**(NX+NY)
             I_SPIN(0)=0
             I_SPIN(1)=1
C
         END IF
C
C======================================================================
C        INVERSION
C======================================================================
C
         IF (INIINV.EQ.1.OR.INIINV.EQ.3) THEN
C
             IFACTO(0)=IFACTO(0)*(-1)**(NX+NY+NZ)
             IFACTO(1)=IFACTO(1)*(-1)**(NX+NY+NZ)
C
         END IF
C
C======================================================================
C        TIME-REVERSAL
C======================================================================
C
         IF (INIINV.EQ.2.OR.INIINV.EQ.3) THEN
C
             FACSPI=CONJG(FACSPI)
             IDUMMY(0)=IFACTO(I_SPIN(0))
             IDUMMY(1)=IFACTO(I_SPIN(1))*(-1)
             IFACTO(0)=IDUMMY(0)
             IFACTO(1)=IDUMMY(1)
             IDUMMY(0)=I_SPIN(1)
             IDUMMY(1)=I_SPIN(0)
             I_SPIN(0)=IDUMMY(0)
             I_SPIN(1)=IDUMMY(1)
C
             DO ISTATE=1,LSTATE
                DO ISPIN=0,NDSPIN
C
                   WARIGH(IBASE,ISTATE,ISPIN)=
     *                                 CONJG(WARIGH(IBASE,ISTATE,ISPIN))
C
                END DO
             END DO
C
         END IF
C
C======================================================================
C        PERFORMING THE TRANSFORMATION
C======================================================================
C
         IF (IFACTO(0).EQ.0) STOP' INCORRECT INIINV OR INIKAR IN INVWAV'
C
         DO ISTATE=1,LSTATE
C
            DO ISPIN=0,NDSPIN
               WDUMMY(ISPIN)=WARIGH(IBASE,ISTATE,I_SPIN(ISPIN))
     *                            *FACSPI*IFACTO(I_SPIN(ISPIN))
            END DO
C
            DO ISPIN=0,NDSPIN
               WARIGH(IBASE,ISTATE,ISPIN)=WDUMMY(ISPIN)
            END DO
C
         END DO
C
      END DO
C
C=======================================================================
C
      CALL CPUTIM('INVWAV',0)
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE ROTWAV(LSTATE,WARIGH)
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      COMPLEX
     *          WARIGH,CNEW,C_ZERO,BUP,BDN,CUP,CDN
C
      DIMENSION
     *          WARIGH(1:NDBASE,1:4*NDSTAT,0:NDSPIN),
     *          CNEW(1:NDBASE,0:NDSPIN)
      COMMON
     *       /BASISO/ NXVECT(1:NDBASE),NYVECT(1:NDBASE),NZVECT(1:NDBASE)
      COMMON
     *       /DIMENS/ LDBASE
      COMMON
     *       /RMATRI/ ROTOPE(0:NDOSCI,0:NDOSCI,0:NDOSCI,0:NDOSCI)
      COMMON
     *       /RANGLE/ ALPROT,BETROT,GAMROT
C
C=======================================================================
C
      CALL CPUTIM('ROTWAV',1)
C
C======================================================================
C
      C_ZERO=CMPLX(0.0D0,0.0D0)
C
      ALFA = ALPROT
      BETA = BETROT
      GAMA = GAMROT
C
C======================================================================
C
C  ROTATION (ACTIVE) OPERATOR IS DEFINED AS:
C  ----------------------------------------
C         R(OMEGA) = R(ALFA) R(BETA) R(GAMA) =
C                  = EXP(-i*ALFA*J_z) EXP(-i*BETA*J_y) EXP(-i*GAMA*J_z)
C
C  TRANSFORMATION GOES ACCORDING TO THE FOLLOWING STANDARD RULES:
C
C  POSITION VECTOR:  r' = R(OMEGA)r  --->  r' = D(OMEGA)r =
C                                             = D(ALFA)D(BETA)D(GAMA)r
C
C  WHERE:
C
C  D(OMEGA) =
C    |COS(ALFA) -SIN(ALFA)|| COS(BETA) SIN(BETA)||COS(GAMA) -SIN(GAMA)|
C    |SIN(ALFA)  COS(ALFA)||-SIN(BETA) COS(BETA)||SIN(GAMA)  COS(GAMA)|
C
C  SCALAR FIELD (WAVE FUNCTION) PHI(r) TRANSFORMS AS:
C
C    R(OMEGA)PHI(r) = PHI(R^-1(OMEGA)r) =
C                   = PHI(D(-GAMA)D(-BETA)D(-ALFA)r)
C
C  THE CODE PERFORMS ROTATION IN THREE CONSEQUTIVE STEPS:
C
C  R(GAMA)PHI (r) = PHI (D(-GAMA)r) = PHI' (r) ---> DECOM. IN Oxyz BASIS
C  R(BETA)PHI'(r) = PHI'(D(-BETA)r) = PHI" (r) ---> DECOM. IN Oxyz BASIS
C  R(ALFA)PHI"(r) = PHI"(D(-ALFA)r) = PHI"'(r) ---> DECOM. IN Oxyz BASIS
C
C======================================================================
C     FIRST SPATIAL ROTATION AROUND Z-AXIS BY AN ANGLE "GAMA"
C======================================================================
C
      IROT=1
      CALL ROTHER(IROT,GAMA)
C
      DO ISTATE=1,LSTATE
C
         DO IBASE=1,LDBASE
C
            NX=NXVECT(IBASE)
            NY=NYVECT(IBASE)
            NZ=NZVECT(IBASE)
C
            CNEW(IBASE,0)=C_ZERO
            CNEW(IBASE,1)=C_ZERO
C
            DO JBASE=1,LDBASE
C
               IF (NZ.EQ.NZVECT(JBASE)) THEN
C
                   NXP=NXVECT(JBASE)
                   NYP=NYVECT(JBASE)
C
                   DO ISPIN=0,NDSPIN
C
                      CNEW(IBASE,ISPIN) =  CNEW(IBASE,ISPIN) +
     *                WARIGH(JBASE,ISTATE,ISPIN)*ROTOPE(NX,NY,NXP,NYP)
C
                   END DO
C
               END IF
C
            END DO
         END DO
C
         DO IBASE=1,LDBASE
            DO ISPIN=0,NDSPIN
C
               WARIGH(IBASE,ISTATE,ISPIN) = CNEW(IBASE,ISPIN)
C
            END DO
         END DO
C
      END DO
C
C======================================================================
C     SECOND SPATIAL ROTATION AROUND Y-AXIS BY AN ANGLE "BETA"
C======================================================================
C
C --> IROT=-1 ASSURES RIGHT-HANDED ROTATION:
C
      IROT=-1
      CALL ROTHER(IROT,BETA)
C
      DO ISTATE=1,LSTATE
C
         DO IBASE=1,LDBASE
C
            NX=NXVECT(IBASE)
            NY=NYVECT(IBASE)
            NZ=NZVECT(IBASE)
C
            CNEW(IBASE,0)=C_ZERO
            CNEW(IBASE,1)=C_ZERO
C
            DO JBASE=1,LDBASE
C
               IF (NY.EQ.NYVECT(JBASE)) THEN
C
                   NXP=NXVECT(JBASE)
                   NZP=NZVECT(JBASE)
C
                   DO ISPIN=0,NDSPIN
C
                      CNEW(IBASE,ISPIN) =  CNEW(IBASE,ISPIN) +
     *                WARIGH(JBASE,ISTATE,ISPIN)*ROTOPE(NX,NZ,NXP,NZP)
C
                   END DO
C
               END IF
C
            END DO
         END DO
C
         DO IBASE=1,LDBASE
            DO ISPIN=0,NDSPIN
C
               WARIGH(IBASE,ISTATE,ISPIN) = CNEW(IBASE,ISPIN)
C
            END DO
         END DO
C
      END DO
C
C======================================================================
C     FINAL SPATIAL ROTATION AROUND Z-AXIS BY AN ANGLE "ALFA"
C======================================================================
C
      IROT=1
      CALL ROTHER(IROT,ALFA)
C
      DO ISTATE=1,LSTATE
C
         DO IBASE=1,LDBASE
C
            NX=NXVECT(IBASE)
            NY=NYVECT(IBASE)
            NZ=NZVECT(IBASE)
C
            CNEW(IBASE,0)=C_ZERO
            CNEW(IBASE,1)=C_ZERO
C
            DO JBASE=1,LDBASE
C
               IF (NZ.EQ.NZVECT(JBASE)) THEN
C
                   NXP=NXVECT(JBASE)
                   NYP=NYVECT(JBASE)
C
                   DO ISPIN=0,NDSPIN
C
                      CNEW(IBASE,ISPIN) =  CNEW(IBASE,ISPIN) +
     *                WARIGH(JBASE,ISTATE,ISPIN)*ROTOPE(NX,NY,NXP,NYP)
C
                   END DO
C
               END IF
C
            END DO
         END DO
C
         DO IBASE=1,LDBASE
            DO ISPIN=0,NDSPIN
C
               WARIGH(IBASE,ISTATE,ISPIN) = CNEW(IBASE,ISPIN)
C
            END DO
         END DO
C
      END DO
C
C
C======================================================================
C     ROTATE SPIN:
C======================================================================
C
C
      BUP = -SIN(BETA/2.)*CMPLX(COS((ALFA-GAMA)/2.),
     *                         -SIN((ALFA-GAMA)/2.))
      BDN =  SIN(BETA/2.)*CMPLX(COS((ALFA-GAMA)/2.),
     *                          SIN((ALFA-GAMA)/2.))
C
      CUP =  COS(BETA/2.)*CMPLX(COS((ALFA+GAMA)/2.),
     *                         -SIN((ALFA+GAMA)/2.))
      CDN =  COS(BETA/2.)*CMPLX(COS((ALFA+GAMA)/2.),
     *                          SIN((ALFA+GAMA)/2.))
C
      DO ISTATE=1,LSTATE
C
         DO IBASE=1,LDBASE
C --> SPIN DOWN:
            CNEW(IBASE,0) =
     *                WARIGH(IBASE,ISTATE,0)*CDN+
     *                WARIGH(IBASE,ISTATE,1)*BDN
C --> SPIN UP:
            CNEW(IBASE,1) =
     *                WARIGH(IBASE,ISTATE,1)*CUP+
     *                WARIGH(IBASE,ISTATE,0)*BUP
C
            WARIGH(IBASE,ISTATE,0) = CNEW(IBASE,0)
            WARIGH(IBASE,ISTATE,1) = CNEW(IBASE,1)
C
         END DO
      END DO
C
C=======================================================================
C
      CALL CPUTIM('ROTWAV',0)
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE SHIWAV(LSTATE,WARIGH)
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      COMPLEX
     *          WARIGH,CNEW,C_ZERO
C
      DIMENSION
     *          WARIGH(1:NDBASE,1:4*NDSTAT,0:NDSPIN),
     *          CNEW(1:NDBASE,0:NDSPIN)
      COMMON
     *       /BASISO/ NXVECT(1:NDBASE),NYVECT(1:NDBASE),NZVECT(1:NDBASE)
      COMMON
     *       /DIMENS/ LDBASE
      COMMON
     *       /SMATRI/ SHIOPE(0:NDOSCI,0:NDOSCI)
      COMMON
     *       /SVECTO/ BSHIFT(NDKART)
C
C=======================================================================
C
      CALL CPUTIM('SHIWAV',1)
C
C======================================================================
C
      C_ZERO=CMPLX(0.0D0,0.0D0)
C
C======================================================================
C
C  SHIFT (ACTIVE) OPERATOR IS DEFINED AS:
C  ----------------------------------------
C         R(BSHIFT) = R(BSHIFT(1)) R(BSHIFT(2)) R(BSHIFT(3)) =
C                   = EXP(-i*BSHIFT(1)*P_x)
C                     EXP(-i*BSHIFT(2)*P_y)
C                     EXP(-i*BSHIFT(3)*P_z)
C
C  TRANSFORMATION GOES ACCORDING TO THE FOLLOWING STANDARD RULES:
C
C  POSITION VECTOR:  r' = R(BSHIFT)r  --->  r' = r - BSHIFT
C
C  SCALAR FIELD (WAVE FUNCTION) PHI(r) TRANSFORMS AS:
C
C    R(BSHIFT)PHI(r) = PHI(R^-1(BSHIFT)r) = = PHI(r+BSHIFT)
C
C  THE CODE PERFORMS THE SHIFT IN THREE CONSEQUTIVE STEPS:
C
C  R(BSHIFT(1))PHI (r) = PHI (r+BSHIFT(1)) = PHI' (r)
C  R(BSHIFT(2))PHI'(r) = PHI'(r+BSHIFT(2)) = PHI" (r)
C  R(BSHIFT(3))PHI"(r) = PHI"(r+BSHIFT(3)) = PHI"'(r)
C
C======================================================================
C     LOOP OVER THE SHIFT DIRECTIONS
C======================================================================
C
      DO KARTEZ=1,NDKART
C
         IF (BSHIFT(KARTEZ).NE.0.0D0) THEN
C
             CALL SHIHER(KARTEZ)
C
             DO ISTATE=1,LSTATE
C
                DO IBASE=1,LDBASE
C
                   NX=NXVECT(IBASE)
                   NY=NYVECT(IBASE)
                   NZ=NZVECT(IBASE)
C
                   CNEW(IBASE,0)=C_ZERO
                   CNEW(IBASE,1)=C_ZERO
C
                   DO JBASE=1,LDBASE
C
                      IF (KARTEZ.EQ.1.AND.(NY.EQ.NYVECT(JBASE).AND.
     *                                     NZ.EQ.NZVECT(JBASE)).OR.
     *                    KARTEZ.EQ.2.AND.(NZ.EQ.NZVECT(JBASE).AND.
     *                                     NX.EQ.NXVECT(JBASE)).OR.
     *                    KARTEZ.EQ.3.AND.(NX.EQ.NXVECT(JBASE).AND.
     *                                     NY.EQ.NYVECT(JBASE))) THEN
C
                          IF (KARTEZ.EQ.1) NN=NXVECT(IBASE)
                          IF (KARTEZ.EQ.1) NP=NXVECT(JBASE)
C
                          IF (KARTEZ.EQ.2) NN=NYVECT(IBASE)
                          IF (KARTEZ.EQ.2) NP=NYVECT(JBASE)
C
                          IF (KARTEZ.EQ.3) NN=NZVECT(IBASE)
                          IF (KARTEZ.EQ.3) NP=NZVECT(JBASE)
C
                          DO ISPIN=0,NDSPIN
C
                             CNEW(IBASE,ISPIN) =  CNEW(IBASE,ISPIN) +
     *                       WARIGH(JBASE,ISTATE,ISPIN)*SHIOPE(NN,NP)
C
                          END DO
C
                      END IF
C
                   END DO
                END DO
C
                DO IBASE=1,LDBASE
                   DO ISPIN=0,NDSPIN
C
                      WARIGH(IBASE,ISTATE,ISPIN) = CNEW(IBASE,ISPIN)
C
                   END DO
                END DO
C
             END DO
C
         END IF
C
      END DO
C
C=======================================================================
C
      CALL CPUTIM('SHIWAV',0)
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE ROTHER(IROT,GAMA)
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      DIMENSION
     *          PHERMI(ND1MAX+1),DHERMI(ND1MAX+1)
      DIMENSION
     *          XHERMI(NDINT1),WHERMI(NDINT1)
      DIMENSION
     *          HERLEF(0:ND1MAX,1:NDINT1)
      DIMENSION
     *          HERRIG1(0:ND1MAX,1:NDINT1,1:NDINT1),
     *          HERRIG2(0:ND1MAX,1:NDINT1,1:NDINT1)
      DIMENSION
     *          HERFAC(0:ND1MAX)
C
      COMMON
     *       /RMATRI/ ROTOPE(0:NDOSCI,0:NDOSCI,0:NDOSCI,0:NDOSCI)
      COMMON
     *       /CFIPRI/ NFIPRI
C
C --> NOSACT IS SET TO BE MAXIMAL PRINCIPAL QUANTUM NUMBER
C
      NOSACT=NDOSCI
      NMAIN1=NOSACT
C
      IF (NMAIN1.GT.ND1MAX) THEN
C
         WRITE(NFIPRI,'(//,1X,''NMAIN1='',I2,'' .GT. ND1MAX='',I2,
     *                         ''   STOP IN ROTHER'',//)') NMAIN1,ND1MAX
         STOP ' NMAIN1.GT.ND1MAX  IN  ROTHER'
C
      END IF
C
C
C=======================================================================
C                     ZEROING THE ZZ MATRIX
C=======================================================================
C
C      DO NX=0,NOSACT
C         DO NY=0,NOSACT
C            DO MX=0,NOSACT
C               DO MY=0,NOSACT
C
C                  ROTOPE(NX,NY,MX,MY)=0.0DO
C
C               END DO
C            END DO
C         END DO
C      END DO
C
C=======================================================================
C
C               MATRIX ROTOPE IS  FOUND  BY  EXPLICIT  NUMERICAL
C                          G A U S S - H E R M I T E
C         INTEGRATION OF  PRODUCTS  APPEARING  UNDER  THE  INTEGRANDS.
C         THE MAXIMUM ORDER OF INTEGRANDS IS THEN EQUAL TO 2*NOSACT,
C                       [NO DERIVATIVES ARE CODED!!!!]
C           THEREFORE ONE HAS TO USE  THE  NUMBER  OF  GAUSS-HERMITE
C                  INTEGRATION POINTS EQUAL TO: NOSACT+1
C                                 OR MORE
C
C=======================================================================
C
      NGAUSS=NOSACT+1
C
      IF (NGAUSS.GT.NDINT1) THEN
C
          WRITE(NFIPRI,'(//,1X,''NGAUSS='',I2,'' .GT. NDINT1='',I2,
     *                         ''   STOP IN ROTHER'',//)') NGAUSS,NDINT1
          STOP ' NGAUSS.GT.NDINT1  IN ROTHER '
C
      END IF
C
C=======================================================================
C    DEFINING ZEROS AND WEIGHTS FOR THE GAUSS-HERMITE  INTEGRATION
C=======================================================================
C
      CALL HERMIT(NGAUSS,XHERMI,WHERMI,NDINT1)
C`
C=======================================================================
C         DEFINING HERMITE POLYNOMIAL NORMALIZATION CONSTANTS
C=======================================================================
C
      CALL NORFAC(HERFAC,ND1MAX)
C
C=======================================================================
C     DEFINING VALUES OF THE ROTATED (RIGHT) HERMITE POLYNOMIALS AT
C                             GAUSS ZEROS
C=======================================================================
C
      DO IZEROS = 1,NGAUSS
      DO JZEROS = 1,NGAUSS
C
         XZER = XHERMI(IZEROS)
         YZER = XHERMI(JZEROS)
         XPRI = COS(GAMA)*XZER+IROT*SIN(GAMA)*YZER
         CALL D_HERM(XPRI,NMAIN1,PHERMI,DHERMI,ND1MAX+1)
C
         DO NOSCIL = 0,NMAIN1
C
            HERRIG1(NOSCIL,IZEROS,JZEROS)=
     *                    PHERMI(NOSCIL+1)/HERFAC(NOSCIL)
C
         END DO
C
         YPRI =-IROT*SIN(GAMA)*XZER+COS(GAMA)*YZER
         CALL D_HERM(YPRI,NMAIN1,PHERMI,DHERMI,ND1MAX+1)
C
         DO NOSCIL = 0,NMAIN1
C
            HERRIG2(NOSCIL,IZEROS,JZEROS)=
     *                    PHERMI(NOSCIL+1)/HERFAC(NOSCIL)
C
         END DO
C
      END DO
      END DO
C
C=======================================================================
C        DEFINING VALUES OF THE LEFT HERMITE POLYNOMIAL
C                      AT GAUSS ZEROS
C=======================================================================
C
      DO IZEROS = 1,NGAUSS
C
         XZER = XHERMI(IZEROS)
         CALL D_HERM(XZER,NMAIN1,PHERMI,DHERMI,ND1MAX+1)
C
         DO NOSCIL = 0,NMAIN1
C
            HERLEF(NOSCIL,IZEROS)=PHERMI(NOSCIL+1)/HERFAC(NOSCIL)
C
         END DO
C
      END DO
C
C
C=======================================================================
C        CALCULATING THE OVERLAPS FOR THE POLYNOMIALS
C=======================================================================
C
      DO NX=0,NOSACT
         DO NY=0,NOSACT
            DO MX=0,NOSACT
               DO MY=0,NOSACT
C
                     RESULT=0.0D0
C
C ---> TOTAL NUMBER OF QUANTA IS CONSERVED FOR THE
C      ISOTROPIC (ONLY!!!) HARMONIC OSCILLATOR:
C      (SUPERSEDES PARITY CONSERVATION - NEXT "IF")
C
       IF (NX+NY.NE.MX+MY) GOTO 233
C
C ---> USE PARITY SELECTION RULE:
C
       IPARL=(-1)**(NX+NY)
       IPARR=(-1)**(MX+MY)
       IF (IPARL.NE.IPARR) GOTO 233
C
                     DO IGAUSS=1,NGAUSS
                     DO JGAUSS=1,NGAUSS
C
                        RESULT=RESULT
     *                        +WHERMI(IGAUSS)*WHERMI(JGAUSS)
     *                               *HERLEF(NX,IGAUSS)
     *                               *HERLEF(NY,JGAUSS)
     *                               *HERRIG1(MX,IGAUSS,JGAUSS)
     *                               *HERRIG2(MY,IGAUSS,JGAUSS)
C
                     END DO
                     END DO
C
 233                 ROTOPE(NX,NY,MX,MY) = RESULT
C
               END DO
            END DO
         END DO
      END DO
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE SCAHER(NOSACT,KARTEZ)
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      DIMENSION
     *          PHERMI(ND1MAX+1),DHERMI(ND1MAX+1)
      DIMENSION
     *          XHERMI(NDINT2),WHERMI(NDINT2)
      DIMENSION
     *          HERLEF(0:ND1MAX,1:NDINT2),
     *          DH1LEF(0:ND1MAX,1:NDINT2),
     *          DH2LEF(0:ND1MAX,1:NDINT2)
      DIMENSION
     *          HERRIG(0:ND1MAX,1:NDINT2),
     *          DH1RIG(0:ND1MAX,1:NDINT2),
     *          DH2RIG(0:ND1MAX,1:NDINT2)
      DIMENSION
     *          HERFAC(0:ND1MAX)
      DIMENSION
     *          HORSCA(NDKART)
C
      COMMON
     *       /COESXY/ COES00(0:NDOSCI,0:NDOSCI,1:NDKART),
     *                COES01(0:NDOSCI,0:NDOSCI,1:NDKART),
     *                COES11(0:NDOSCI,0:NDOSCI,1:NDKART),
     *                COES02(0:NDOSCI,0:NDOSCI,1:NDKART)
      COMMON
     *       /SCALNG/ HOMSCA(NDKART)
      COMMON
     *       /SCALEF/ HOLSCA(NDKART)
      COMMON
     *       /CFIPRI/ NFIPRI
C
C=======================================================================
C
C         THIS ROUTINE PERFORMS INTEGRATION OF THE HERMITE POLYNOMIALS
C         TO FIND OVERLAPS BETWEEN HO STATES FOR DIFFERENT HO LENGTHS
C
C         COES00(M,N)= INT DX H (M,B*X)*H  (N,C*X)*EXP(-(B^2+C^2)X^2)/2)
C         COES01(M,N)= INT DX H (M,B*X)*H' (N,C*X)*EXP(-(B^2+C^2)X^2)/2)
C         COES11(M,N)= INT DX H'(M,B*X)*H' (N,C*X)*EXP(-(B^2+C^2)X^2)/2)
C         COES02(M,N)= INT DX H (M,B*X)*H''(N,C*X)*EXP(-(B^2+C^2)X^2)/2)
C
C         WHERE:
C
C         H  (N,X) IS THE HERMITE POLYNOMIAL OF THE ORDER  M  AT POINT X
C                  ASSUMED TO BE NORMALIZED TO   O N E   WHEN ITS SQUARE
C                  IS INTEGRATED WITH EXP(-X**2).
C         H' (N,X) IS THE DERIVATIVE OF              H(N,X)*EXP(-X**2/2)
C                  MULTIPLIED BY EXP(X**2/2)
C         H''(N,X) IS THE SECOND DERIVATIVE OF       H(N,X)*EXP(-X**2/2)
C                  MULTIPLIED BY EXP(X**2/2)
C
C         AND "B" AND "C" ARE SCALES OF THE LEFT AND RIGHT  POLYNOMIALS.
C
C=======================================================================
C         ATTENTION: FOR THE MOMENT, THE  TERMS  CONTAINING  DERIVATIVES
C                    ARE LATER NOT USED. THEY ARE HERE  CALCULATED  ONLY
C                    TO KEEP THE MIRROR STRUCTURE COPIED FROM  "DEVHER".
C=======================================================================
C         OSCILATOR LENGTHS OF THE RIGHT BASIS ARE KEPT IN "HORSCA"
C         OSCILATOR LENGTHS OF THE LEFT  BASIS ARE KEPT IN "HOLSCA"
C=======================================================================
C
          HORSCA(1)=HOMSCA(1)
          HORSCA(2)=HOMSCA(2)
          HORSCA(3)=HOMSCA(3)
C
          HOLSCA(1)=HOMSCA(1)
          HOLSCA(2)=HOMSCA(2)
          HOLSCA(3)=HOMSCA(3)
C
C=======================================================================
C
C         "NOSACT"  IS THE MAXIMUM ORDER OF THE HERMITE POLYNOMIALS USED
C         IN THE CODE. THEREFORE:
C
C         H  (M,X)  HAS THE MAXIMUM ORDER  NOSACT
C         H' (M,X)  HAS THE MAXIMUM ORDER  NOSACT + 1
C         H''(M,X)  HAS THE MAXIMUM ORDER  NOSACT + 2
C
C         THE MAXIMUM ORDER OF POLYNOMIALS IS THEREFORE:
C
C=======================================================================
C
      NMAIN1=NOSACT+2
C
      IF (NMAIN1.GT.ND1MAX) THEN
C
         WRITE(NFIPRI,'(//,1X,''NMAIN1='',I2,'' .GT. ND1MAX='',I2,
     *                         ''   STOP IN SCAHER'',//)') NMAIN1,ND1MAX
         STOP ' NMAIN1.GT.ND1MAX  IN  SCAHER'
C
      END IF
C
C=======================================================================
C         ZEROING THE COES__ ARRAYS
C=======================================================================
C
      DO N=0,NOSACT
         DO M=0,NOSACT
C
           COES00(M,N,KARTEZ)=0.0D0
           COES01(M,N,KARTEZ)=0.0D0
           COES11(M,N,KARTEZ)=0.0D0
           COES02(M,N,KARTEZ)=0.0D0
C
         END DO
      END DO
C
C=======================================================================
C
C         THE COEFFICIENTS  COES__  ARE FOUND  BY  EXPLICIT  NUMERICAL
C                          G A U S S - H E R M I T E
C         INTEGRATION OF  PRODUCTS  APPEARING  UNDER  THE  INTEGRANDS.
C         THE MAXIMUM ORDER OF INTEGRANDS IS THEN EQUAL TO 2*NOSACT+2,
C         AND THEREFORE ONE HAS TO USE  THE  NUMBER  OF  GAUSS-HERMITE
C         INTEGRATION POINTS EQUAL TO:
C
C=======================================================================
C
      NGAUSS=NOSACT+2
C
      IF (NGAUSS.GT.NDINT2) THEN
C
         WRITE(NFIPRI,'(//,1X,''NGAUSS='',I2,'' .GT. NDINT2='',I2,
     *                         ''   STOP IN SCAHER'',//)') NGAUSS,NDINT2
         STOP ' NGAUSS.GT.NDINT2  IN  SCAHER'
C
      END IF
C
C=======================================================================
C          DEFINING ZEROS AND WEIGHTS FOR THE GAUSS-HERMITE  INTEGRATION
C=======================================================================
C
      CALL HERMIT(NGAUSS,XHERMI,WHERMI,NDINT2)
C
C=======================================================================
C        DEFINING HERMITE POLYNOMIAL NORMALIZATION CONSTANTS
C=======================================================================
C
      CALL NORFAC(HERFAC,ND1MAX)
C
C=======================================================================
C        DEFINING VALUES OF THE LEFT HERMITE POLYNOMIALS AT GAUSS ZEROS
C=======================================================================
C
      FACLEF=HOLSCA(KARTEZ)/SQRT((HOLSCA(KARTEZ)**2
     *                           +HORSCA(KARTEZ)**2)/2)
C
      DO IZEROS = 1,NGAUSS
C
         XZER = XHERMI(IZEROS)*FACLEF
C
         CALL D_HERM(XZER,NMAIN1,PHERMI,DHERMI,ND1MAX+1)
C
         DO NOSCIL = 0,NMAIN1
C
            HERLEF(NOSCIL,IZEROS)= PHERMI(NOSCIL+1)/HERFAC(NOSCIL)
C
            DH1LEF(NOSCIL,IZEROS)=(DHERMI(NOSCIL+1)
     *                           - XZER*PHERMI(NOSCIL+1))
     *                                             /HERFAC(NOSCIL)
C
            DH2LEF(NOSCIL,IZEROS)=(XZER*XZER-2*NOSCIL-1)
     *                           * PHERMI(NOSCIL+1)/HERFAC(NOSCIL)
C
         END DO
C
      END DO
C
C=======================================================================
C        DEFINING VALUES OF THE RIGHT HERMITE POLYNOMIALS AT GAUSS ZEROS
C=======================================================================
C
      FACRIG=HORSCA(KARTEZ)/SQRT((HOLSCA(KARTEZ)**2
     *                           +HORSCA(KARTEZ)**2)/2)
C
      DO IZEROS = 1,NGAUSS
C
         XZER = XHERMI(IZEROS)*FACRIG
C
         CALL D_HERM(XZER,NMAIN1,PHERMI,DHERMI,ND1MAX+1)
C
         DO NOSCIL = 0,NMAIN1
C
            HERRIG(NOSCIL,IZEROS)= PHERMI(NOSCIL+1)/HERFAC(NOSCIL)
C
            DH1RIG(NOSCIL,IZEROS)=(DHERMI(NOSCIL+1)
     *                           - XZER*PHERMI(NOSCIL+1))
     *                                             /HERFAC(NOSCIL)
C
            DH2RIG(NOSCIL,IZEROS)=(XZER*XZER-2*NOSCIL-1)
     *                           * PHERMI(NOSCIL+1)/HERFAC(NOSCIL)
C
         END DO
C
      END DO
C
C=======================================================================
C        CALCULATING THE OVERALL FACTOR
C=======================================================================
C
      FACSCA=SQRT(FACLEF*FACRIG)
C
C=======================================================================
C        CALCULATING THE OVERLAPS FOR THE POLYNOMIALS
C=======================================================================
C
      DO N=0,NOSACT
         DO M=0,NOSACT
C
            RESULT=0.0D0
C
            DO IGAUSS=1,NGAUSS
C
               RESULT=RESULT+WHERMI(IGAUSS)*HERLEF(M,IGAUSS)
     *                                     *HERRIG(N,IGAUSS)
            END DO
C
            COES00(M,N,KARTEZ)=RESULT*FACSCA
C
         END DO
      END DO
C
C=======================================================================
C        CALCULATING THE OVERLAPS FOR THE PRODUCTS
C        HERMIT * DERIVATIVE (EXP * HERMIT)
C=======================================================================
C
      DO N=0,NOSACT
         DO M=0,NOSACT
C
            RESULT=0.0D0
C
            DO IGAUSS=1,NGAUSS
               RESULT=RESULT+WHERMI(IGAUSS)*HERLEF(M,IGAUSS)
     *                                     *DH1RIG(N,IGAUSS)
            END DO
C
            COES01(M,N,KARTEZ)=RESULT*FACSCA
C
         END DO
      END DO
C
C=======================================================================
C        CALCULATING THE OVERLAPS FOR THE PRODUCTS
C        DERIVATIVE (EXP * HERMIT) * DERIVATIVE (EXP * HERMIT)
C=======================================================================
C
      DO N=0,NOSACT
         DO M=0,NOSACT
C
            RESULT=0.0D0
C
            DO IGAUSS=1,NGAUSS
               RESULT=RESULT+WHERMI(IGAUSS)*DH1LEF(M,IGAUSS)
     *                                     *DH1RIG(N,IGAUSS)
            END DO
C
            COES11(M,N,KARTEZ)=RESULT*FACSCA
C
         END DO
      END DO
C
C=======================================================================
C        CALCULATING THE OVERLAPS FOR THE PRODUCTS
C        HERMIT * SECOND DERIVATIVE (EXP * HERMIT)
C=======================================================================
C
      DO N=0,NOSACT
         DO M=0,NOSACT
C
            RESULT=0.0D0
C
            DO IGAUSS=1,NGAUSS
               RESULT=RESULT+WHERMI(IGAUSS)*HERLEF(M,IGAUSS)
     *                                     *DH2RIG(N,IGAUSS)
            END DO
C
            COES02(M,N,KARTEZ)=RESULT*FACSCA
C
         END DO
      END DO
C
C=======================================================================
C       THE CODE USES DIMENSIONED WAVE FUNCTIONS AND THEIR DERIVATIVES.
C       THEREFORE, THE COEFFICIENTS       COEF__     ARE HERE SCALED BY
C       APPROPRIATE FACTORS WHICH TAKE INTO ACCOUNT  THESE  DIMENSIONS.
C=======================================================================
C
      DO N=0,NOSACT
         DO M=0,NOSACT
C
            COES01(M,N,KARTEZ)=COES01(M,N,KARTEZ)
     *                        * HORSCA(KARTEZ)
C
            COES02(M,N,KARTEZ)=COES02(M,N,KARTEZ)
     *                        * HORSCA(KARTEZ)
     *                        * HORSCA(KARTEZ)
C
            COES11(M,N,KARTEZ)=COES11(M,N,KARTEZ)
     *                        * HOLSCA(KARTEZ)
     *                        * HORSCA(KARTEZ)
C
         END DO
      END DO
C
C=======================================================================
C       HERE IS THE TEST AGAINST THE EXPLICIT FORMULA (NOTES 8.64B)
C=======================================================================
C
C     FACFAC=(HORSCA(KARTEZ)**2-HOLSCA(KARTEZ)**2)/
C    *       (HOLSCA(KARTEZ)**2+HORSCA(KARTEZ)**2)
C
C     DO NN=0,NOSACT
C        DO MM=0,NOSACT
C
C           N=MIN(NN,MM)
C           M=MAX(NN,MM)
C
C           KMAX=N/2
C           RESULT=0
C
C           DO K=0,KMAX
C              L=K+(M-N)/2
C              RESULT=RESULT+FACSCA*SQRT(FACTOR(N)*FACTOR(M))/
C    *                       FACTOR(N-2*K)/2**(K+L)/FACTOR(K)/FACTOR(L)*
C    *                       FACSCA**(2*(N-2*K))*(-1)**K*FACFAC**(K+L)
C           END DO
C
C           IF (MOD(MM,2).NE.MOD(NN,2)) RESULT=0
C           IF (NN.GT.MM) RESULT=RESULT*(-1)**((M-N)/2)
C
C           print *,NN,MM,COES00(NN,MM,KARTEZ),RESULT
C           IF (ABS(COES00(NN,MM,KARTEZ)-RESULT).GT.1.0D-14)
C    *      PRINT *,' BBBBBB-AAAAAA-DDDDDD'
C
C        END DO
C     END DO
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE SHIHER(KARTEZ)
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      DIMENSION
     *          PHERMI(NDOSCI+1),DHERMI(NDOSCI+1)
      DIMENSION
     *          XHERMI(NDINT1),WHERMI(NDINT1)
      DIMENSION
     *          HERLEF(0:NDOSCI,1:NDINT1)
      DIMENSION
     *          HERRIG(0:NDOSCI,1:NDINT1)
      DIMENSION
     *          HERFAC(0:NDOSCI)
C
      COMMON
     *       /SMATRI/ SHIOPE(0:NDOSCI,0:NDOSCI)
      COMMON
     *       /SCALNG/ HOMSCA(NDKART)
      COMMON
     *       /SVECTO/ BSHIFT(NDKART)
      COMMON
     *       /CFIPRI/ NFIPRI
C
C=======================================================================
C
C         THIS ROUTINE PERFORMS INTEGRATION OF THE HERMITE POLYNOMIALS
C         TO FIND OVERLAPS BETWEEN HO STATES SHIFTED BY BSHIFT
C
C         SHIOPE(M,N)= B * INT DX H (M,B*(X+BSHIFT/2))
C                                *H (N,B*(X-BSHIFT/2))
C                                *EXP(-B^2*(X^2+BSHIFT^2/4))
C
C         WHERE:
C
C         H  (N,X) IS THE HERMITE POLYNOMIAL OF THE ORDER  M  AT POINT X
C                  ASSUMED TO BE NORMALIZED TO   O N E   WHEN ITS SQUARE
C                  IS INTEGRATED WITH EXP(-(B*X)**2).
C
C=======================================================================
C
C --> NOSACT IS SET TO BE MAXIMAL PRINCIPAL QUANTUM NUMBER
C
      NOSACT=NDOSCI
C
C=======================================================================
C
C         "NOSACT"  IS THE MAXIMUM ORDER OF THE HERMITE POLYNOMIALS USED
C         IN THE CODE. THEREFORE:
C
C         H  (M,X)  HAS THE MAXIMUM ORDER  NOSACT
C
C         THE MAXIMUM ORDER OF POLYNOMIALS IS THEREFORE:
C
C=======================================================================
C
      NMAIN1=NOSACT
C
      IF (NMAIN1.GT.NDOSCI) THEN
C
         WRITE(NFIPRI,'(//,1X,''NMAIN1='',I2,'' .GT. NDOSCI='',I2,
     *                         ''   STOP IN SCAHER'',//)') NMAIN1,NDOSCI
         STOP ' NMAIN1.GT.NDOSCI  IN  SHIHER'
C
      END IF
C
C=======================================================================
C         ZEROING THE SHIOPE ARRAY
C=======================================================================
C
      DO N=0,NOSACT
         DO M=0,NOSACT
C
           SHIOPE(M,N)=0.0D0
C
         END DO
      END DO
C
C=======================================================================
C
C         THE COEFFICIENTS  SHIOPE  ARE FOUND  BY  EXPLICIT  NUMERICAL
C                          G A U S S - H E R M I T E
C         INTEGRATION OF  PRODUCTS  APPEARING  UNDER  THE  INTEGRANDS.
C         THE MAXIMUM ORDER OF INTEGRANDS IS THEN EQUAL TO   2*NOSACT,
C         AND THEREFORE ONE HAS TO USE  THE  NUMBER  OF  GAUSS-HERMITE
C         INTEGRATION POINTS EQUAL TO:
C
C=======================================================================
C
      NGAUSS=NOSACT+1
C
      IF (NGAUSS.GT.NDINT1) THEN
C
         WRITE(NFIPRI,'(//,1X,''NGAUSS='',I2,'' .GT. NDINT1='',I2,
     *                         ''   STOP IN SHIHER'',//)') NGAUSS,NDINT1
         STOP ' NGAUSS.GT.NDINT1  IN  SHIHER'
C
      END IF
C
C=======================================================================
C          DEFINING ZEROS AND WEIGHTS FOR THE GAUSS-HERMITE  INTEGRATION
C=======================================================================
C
      CALL HERMIT(NGAUSS,XHERMI,WHERMI,NDINT1)
C
C=======================================================================
C        DEFINING HERMITE POLYNOMIAL NORMALIZATION CONSTANTS
C=======================================================================
C
      CALL NORFAC(HERFAC,NDOSCI)
C
C=======================================================================
C        DEFINING VALUES OF THE HERMITE POLYNOMIALS AT GAUSS ZEROS
C=======================================================================
C
      DO IZEROS = 1,NGAUSS
C
         XZER = XHERMI(IZEROS)+HOMSCA(KARTEZ)*BSHIFT(KARTEZ)/2
C
         CALL D_HERM(XZER,NMAIN1,PHERMI,DHERMI,NDOSCI+1)
C
         DO NOSCIL = 0,NMAIN1
C
            HERLEF(NOSCIL,IZEROS)= PHERMI(NOSCIL+1)/HERFAC(NOSCIL)
C
         END DO
C
         XZER = XHERMI(IZEROS)-HOMSCA(KARTEZ)*BSHIFT(KARTEZ)/2
C
         CALL D_HERM(XZER,NMAIN1,PHERMI,DHERMI,NDOSCI+1)
C
         DO NOSCIL = 0,NMAIN1
C
            HERRIG(NOSCIL,IZEROS)= PHERMI(NOSCIL+1)/HERFAC(NOSCIL)
C
         END DO
C
      END DO
C
C=======================================================================
C        CALCULATING THE OVERALL FACTOR
C=======================================================================
C
      FACSCA=EXP(-(HOMSCA(KARTEZ)*BSHIFT(KARTEZ))**2/4)
C
C=======================================================================
C        CALCULATING THE OVERLAPS
C=======================================================================
C
      DO M=0,NOSACT
         DO N=0,NOSACT
C
            RESULT=0.0D0
C
            DO IGAUSS=1,NGAUSS
C
               RESULT=RESULT+WHERMI(IGAUSS)*HERLEF(M,IGAUSS)
     *                                     *HERRIG(N,IGAUSS)
            END DO
C
            SHIOPE(M,N)=RESULT*FACSCA
C
         END DO
      END DO
C
C=======================================================================
C       HERE IS THE TEST AGAINST THE EXPLICIT FORMULA (NOTES 8.64E)
C=======================================================================
C
C       THE TEST REQUIRES INCREASING DIMENSIONS OF ARRAYS AS BELOW:
C
C     DIMENSION
C    *          PHERMI(2*NDOSCI+1),DHERMI(2*NDOSCI+1)
C     DIMENSION
C    *          HERFAC(0:2*NDOSCI)
C
C=======================================================================
C
C       THE TEST REQUIRES INCLUDING COMMON RBINOM:
C
C     PARAMETER
C    *          (NDBINO=2*NDOSCI)
C#if(SWITCH_QUAD==1)
C     REAL*16
C    *          RBINOM
C#endif
C     COMMON
C    *       /NEWBIR/ RBINOM(0:NDBINO,0:NDBINO)
C
C=======================================================================
C
C       THE TEST REQUIRES INCLUDING COMMON COEFMO:
C
C     PARAMETER
C    *          (ND0MAX=2*NDOSCI)
C     COMMON
C    *       /COEFMO/ COEMOS(0:ND0MAX,0:NDOSCI,0:NDOSCI,1:NDKART)
C
C=======================================================================
C
C       THE TEST REQUIRES DEFINING VARIABLES DSQRT2 AND SQ4_PI:
C
C     DSQRT2=SQRT(2.0D0)
C
C     SQ4_PI=SQRT(SQRT(4.0D0*ATAN(1.0D0)))
C
C=======================================================================
C
C     CALL NORFAC(HERFAC,2*NDOSCI)
C
C     XZER = HOMSCA(KARTEZ)*BSHIFT(KARTEZ)/DSQRT2
C
C     DIFMAX=0
C     DIRMAX=0
C
C     DO K=0,NOSACT
C        DO L=0,NOSACT
C
C           RESULT=0
C
C           CALL D_HERM(XZER,2*NOSACT,PHERMI,DHERMI,2*NDOSCI+1)
C
C           DO N=0,K+L,2
C
C              RESULT=RESULT+COEMOS(N,K,L,KARTEZ)/DSQRT2**N
C    *                      *SQRT(RBINOM(N,N/2))
C    *                      *PHERMI(K+L-N+1)/HERFAC(K+L-N)
C           END DO
C
C           RESULT=RESULT*FACSCA*SQ4_PI
C
C           PRINT *,K,L,SHIOPE(K,L),RESULT
C               IF (ABS(SHIOPE(K,L)-RESULT).GT.1.0D-14)
C    *      PRINT *,' BBBBBB-AAAAAA-DDDDDD'
C
C           DIFMAX=MAX(DIFMAX,ABS( SHIOPE(K,L)-RESULT))
C           DIRMAX=MAX(DIRMAX,ABS((SHIOPE(K,L)-RESULT)/RESULT))
C
C        END DO
C     END DO
C
C     PRINT '(/'' MAXIMUM DIFFERENCE='',         D19.10/)',DIFMAX
C     PRINT '(/'' MAXIMUM RELATIVE DIFFERENCE='',D19.10/)',DIRMAX
C
C=======================================================================
C       HERE IS THE TEST OF ORTHOGONALITY
C=======================================================================
C
C     DIFMAX=0
C     DIRMAX=0
C
C     DO K=0,NOSACT
C        DO L=0,NOSACT
C
C           RESULT=0
C
C           DO N=0,NOSACT
C
C              RESULT=RESULT+SHIOPE(K,N)*SHIOPE(L,N)
C
C           END DO
C
C                       RESEXA=0.0D0
C           IF (K.EQ.L) RESEXA=1.0D0
C
C           PRINT *,K,L,RESEXA,RESULT
C               IF (ABS(RESEXA-RESULT).GT.1.0D-14)
C    *      PRINT *,' BBBBBB-AAAAAA-DDDDDD'
C
C           DIFMAX=MAX(DIFMAX,ABS( RESEXA-RESULT))
C           DIRMAX=MAX(DIRMAX,ABS((RESEXA-RESULT)/RESULT))
C
C        END DO
C     END DO
C
C     PRINT '(/'' MAXIMUM DIFFERENCE='',         D19.10/)',DIFMAX
C     PRINT '(/'' MAXIMUM RELATIVE DIFFERENCE='',D19.10/)',DIRMAX
C
C=======================================================================
C
      RETURN
      END
C
C=======================================================================
C
C---------------------------------------------------------------
C
C     DSMALG COMPUTES SMALL WIGNER FUNCTION d^J_{M M'}(beta) FOR
C                  J=JD/2, M=MD/2, M'= MDP/2
C         CODED ACCORDING TO THE FORMULA (4), P.76 FROM THE
C                    VARSHALOVICH TEXTBOOK
C
C --> LOGARITHMS OF FACTORIALS ARE USED
C
C---------------------------------------------------------------
C                                 adapted from K. Burzynski code
C
      REAL FUNCTION DSMALG(JD,MD,MDP,BETA)
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      COMMON
     *       /COMSIL/ SILNIA(0:NDJMXD)
C
      DATA NSDONE /0/
C
      IF (NSDONE.EQ.0) THEN
          NSDONE=1
          SILNIA(0)=0.
          DO 11 L = 1,NDJMXD
   11     SILNIA(L)=SILNIA(L-1)+LOG(REAL(L,KIND=8))
C
      END IF
C
      DSMALG = 0.
C
C---> AVOID: 0.^0
C
      IF (ABS(BETA).LT.1.E-10) THEN
         IF (MD.NE.MDP) RETURN
         DSMALG=1.
         RETURN
      END IF
C
      BETA2  = BETA/2.
      CB     = COS(BETA2)
      SB     = SIN(BETA2)
C
C---> ARGUMENTS CONSISTENCY CHECK:
C
      IF (MOD(JD +MD ,2).NE.0 .OR. JD +MD .LT.0) STOP ' DSMALG 1'
      IF (MOD(JD +MDP,2).NE.0 .OR. JD +MDP.LT.0) STOP ' DSMALG 2'
      IF (MOD(JD -MD ,2).NE.0 .OR. JD -MD .LT.0) STOP ' DSMALG 3'
      IF (MOD(JD -MDP,2).NE.0 .OR. JD -MDP.LT.0) STOP ' DSMALG 4'
      IF (MOD(MD -MDP,2).NE.0                  ) STOP ' DSMALG 5'
      IF (JD.GT.NDJMXD)                          STOP ' DSMALG 6'
C
      K1=(JD+MD)/2
      K2=(JD-MD)/2
      K3=(JD+MDP)/2
      K4=(JD-MDP)/2
      K5=(MD-MDP)/2
      L7=(K1+K4)
      L9=-K5
C
      LMAX=MIN(K1,K4)
      LMIN=MAX(0,K5)
C
      DL1=( SILNIA(K1)+SILNIA(K2)+SILNIA(K3)+SILNIA(K4) )/2.
C
      DO 10 L=LMIN,LMAX
            L8=L+L
            DL2=SILNIA(L)+SILNIA(K1-L)+SILNIA(K4-L)+SILNIA(L9+L)
            C = ( -2.0 * MOD(L,2) + 1 )  *  EXP(DL1-DL2)
            C = C * (CB**(L7-L8)) * (SB**(L9+L8))
  10  DSMALG = DSMALG + C
C
      RETURN
      END
C=======================================================================
      REAL FUNCTION CGCOEF(J1,M1,J2,M2,J,M)
C
C     CALCULATION OF CLEBSCH-GORDON COEFFICIENTS
C     ALSO KNOWN AS VECTOR COUPLING COEFFICIENTS
C     DEFINITION OF THE ARGUMENTS ARE STANDARD
C     ARGUMENTS ARE DOUBLE THEIR ACTUAL VALUES TO AVOID HALF-INTEGRALS
C
C   ADAPTED FROM THE CERN LIBRARY ROUTINE CLEBSG (U110),
C   WHICH IN TURN WAS ADAPTED FROM THE HARWELL LIBRARY, VERSION 08/01/74
C
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      DIMENSION H(MV25),L(MV25)
      LSIZ=MV25
C
      DATA H(1) / 1.D0 /
      DATA L(1) / 0 /
      DATA LAST / 1 /
      DATA SCALE / 8.D0 /
C
      CGCOEF=0.0
      IF (J .LT.0)                                 RETURN
      IF (J1.LT.0)                                 RETURN
      IF (J2.LT.0)                                 RETURN
      IF (ABS(M ).GT.J )                           RETURN
      IF (ABS(M1).GT.J1)                           RETURN
      IF (ABS(M2).GT.J2)                           RETURN
      IF (M1+M2.NE.M)                              RETURN
      IF (MOD(J1+J2+J,2).NE.0)                     RETURN
      I0=(J1+J2+J)/2+1
      IF (J1+J2-J.LT.0)                            RETURN
      I1=(J1+J2-J)/2
      IF (J.LT.ABS(J1-J2))                         RETURN
      I2=(J-(J1-J2))/2
      I3=(J+(J1-J2))/2
      IF (MOD(J -M ,2).NE.0)                       RETURN
      I8=(J +M )/2
      I9=(J -M )/2
      IF (MOD(J1-M1,2).NE.0)                       RETURN
      I4=(J1+M1)/2
      I5=(J1-M1)/2
      IF (MOD(J2-M2,2).NE.0)                       RETURN
      I6=(J2+M2)/2
      I7=(J2-M2)/2
      N2=J2-J-M1
      N3=J1-J+M2
      N4=MIN(I1,I5,I6)
      N5=MAX(0,N2,N3)
      N1=N5/2
      IF (N1.GT.N4)                                RETURN
      MM1=MAX(I0,I1,I2,I3,I4,I5,I6,I7,I8,I9,N4-N2/2,N4-N3/2)+1
      IF (MM1.LE.LAST)  GO TO 500
      IF (MM1.LE.LSIZ)  GO TO 100
      WRITE(6,'(''CGCOEF CALLED WITH ARGUMENTS '',6I5)')
     *            J,M,J1,M1,J2,M2
      WRITE(6,'(''THIS REQUIRES CALCULATIONS WITH A FACTORIAL '',
     *          ''OF '',i5)') MM1
      WRITE(6,'(''THIS VERSION ASSUMED THE MAXIMUM FACTORIAL EVER '',
     *          ''CALCULATED TO BE OF '',I5)') LSIZ
      WRITE(6,'(''THE SIZE OF INTERNAL ARRAYS H AND L MUST BE '',
     *          ''INCREASED'')')
      STOP 8537
  100 CONTINUE
      X=LAST
      MM2=LAST+1
      LAST=MM1
      DO 400  MM3=MM2,MM1
      H(MM3)=H(MM3-1)*X
      L(MM3)=L(MM3-1)
  200 IF (H(MM3).LT.SCALE)  GO TO 400
      H(MM3)=H(MM3)/SCALE**2
      L(MM3)=L(MM3)+2
      GO TO 200
  400 X=X+1.D0
  500 CONTINUE
      IY =  (L(I1+1)+L(I2+1)+L(I3+1)+L(I4+1)+L(I5+1)+L(I6+1)+L(I7+1)+
     +L(I8+1)+L(I9+1)-L(I0+1))/2
      Y=SQRT(H(I1+1)*H(I2+1)*H(I3+1)*H(I4+1)*H(I5+1)*H(I6+1)*H(I7+1)*
     *H(I8+1)*H(I9+1)/H(I0+1)*(J+1))
      IF ((N5/4)*4-N5+1.LT.0)  Y=-Y
      Z=0.
      DO 510  N5=N1,N4
      MM1=I1-N5
      MM2=I5-N5
      MM3=I6-N5
      MM4=N5-N2/2
      MM5=N5-N3/2
      X=Y/H(MM1+1)/H(MM2+1)/H(MM3+1)/H(MM4+1)/H(MM5+1)/H(N5+1)
      IX= L(MM1+1)+L(MM2+1)+L(MM3+1)+L(MM4+1)+L(MM5+1)+L(N5+1)
  800 IF (IY-IX) 900,210,110
  900 X=X/SCALE
      IX=IX-1
      GO TO 800
  110 X=X*SCALE
      IX=IX+1
      GO TO 800
  210 Z=Z+X
  510 Y=-Y
      CGCOEF=Z
        RETURN
      END
C=======================================================================
*|||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||
      subroutine gauleg(x1,x2,x,w,n)
*     ______________________________
*
*=======================================================================
*
*                  MUST BE COMPILED IN AUTODOUBLE MODE
*                  ...................................
*
*          This routine  calculates the weights and knots of the
*          Gauss-Legendre  integration formula of the N-th order
*          and stores them in the  arrays X and W. X1 and X2 are
*          integration limits. Normally, they are -1 and +1, but
*          may be set to any values (X1 < X2), so you will n o t
*          have to change variables in your program.
*
*                           You always have:
*
*           Integral(X1,X2)[f(x)dx] = Sum(i=1,N)[W(i)*f(X(i))]
*
*          Arrays  are stored in  ascending  order of knots X(i).
*
*=======================================================================
* From Numerical Recipes, 2-nd ed., with modifications. ================
*=======================================================================
*=============================================== T. R. Werner, July 1993
*=============================================== Last modified: Feb 1997
*=======================================  Modified by Jacek: Dec 22 2005
*=======================================================================
*
      parameter (EPS=3.e-17,KX=8)
      dimension  x(n),w(n)
*
      m=(n+1)/2
      xm=(x2+x1)/2
      xl=(x2-x1)/2
      PI=4.0D0*ATAN(1.0D0)
      do i=1,m
         z=cos(pi*(i-0.25D0)/(n+0.5D0))
         zx=1.e+30
         k=0
*
    1    continue
            p1=1
            p2=0
            k=k+1
            do j=1,n
               p3=p2
               p2=p1
               p1=((2*j-1)*z*p2-(j-1)*p3)/j
            end do
            pp=n*(z*p1-p2)/(z*z-1)
            z1=z
            z=z1-p1/pp
            z2=abs(z-z1)
            if (z2.le.zx) then
               zx=z2
               zb=z
            end if
         if (z2.gt.EPS.and.k.lt.KX) go to 1
*
         x(i)=xm-xl*zb
         x(n+1-i)=xm+xl*zb
         w(i)=2*xl/((1-zb*zb)*pp*pp)
         w(n+1-i)=w(i)
      end do
*
      END
C
C=======================================================================
C
      SUBROUTINE BEGINC(VSPACE,SONBAS,NDEGRE,NXHERM,NYHERM,NZHERM,
     *                         HERACT,WGTACT,NXMAXX,NYMAXX,NZMAXX)
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      COMPLEX
     *          VSPACE,SONBAS,UFIELD,XFIELD,YFIELD,RESULT,C_ZERO
C
      DIMENSION
     *          XFIELD(0:ND2MAX,1:NDYHRM,1:NDZHRM)
      DIMENSION
     *          YFIELD(0:ND2MAX,0:ND2MAX,1:NDZHRM)
      DIMENSION
     *          SONBAS(0:ND2MAX,0:ND2MAX,0:ND2MAX)
C
      DIMENSION
     *          VSPACE(NDXHRM,NDYHRM,NDZHRM),
     *          UFIELD(NDXHRM,NDYHRM,NDZHRM)
C
      DIMENSION
     *          HERACT(0:ND2MAX,1:NDGAUS,1:NDKART)
      DIMENSION
     *          WGTACT(1:NDGAUS,1:NDKART)
C
C=======================================================================
C
      CALL CPUTIM('BEGINC',1)
C
C=======================================================================
C        THIS SUBROUTINE CALCULATES THE THREE-DIMENSIONAL INTEGRALS
C        OF A FIELD 'VSPACE' GIVEN ON THE GAUSS-HERMITE INTEGRATION
C        MESH WITH THE PRODUCT OF THREE HERMITE POLYNOMIALS. RESULT
C        IS CONTAINED IN THE ARRAY 'SONBAS'  (FIELD V ON THE BASIS)
C        DEPENDING ON THE THREE O S C I L L A T O R QUANTUM NUMBERS
C                        'KX', 'KY', AND 'KZ'.
C=======================================================================
C
      C_ZERO=CMPLX(0.0D0,0.0D0)
C
C=======================================================================
C        DEFINING  THE  FUNCTION  TO  BE  INTEGRATED  ( INTEGRAND )
C=======================================================================
C
      DO IX=1,NXHERM
         DO IY=1,NYHERM
            DO IZ=1,NZHERM
               WHERM=WGTACT(IX,1)*WGTACT(IY,2)*WGTACT(IZ,3)
               UFIELD(IX,IY,IZ)=VSPACE(IX,IY,IZ)*WHERM
            END DO
         END DO
      END DO
C
C=======================================================================
C
      DO KX=0,2*NXMAXX+NDEGRE
         DO IY=1,NYHERM
            DO IZ=1,NZHERM
C
               RESULT=C_ZERO
C
               DO IX=1,NXHERM
                  RESULT=RESULT+HERACT(KX,IX,1)*UFIELD(IX,IY,IZ)
               END DO
C
               XFIELD(KX,IY,IZ)=RESULT
C
            END DO
         END DO
      END DO
C
C=======================================================================
C
      DO KX=0,2*NXMAXX+NDEGRE
         DO KY=0,2*NYMAXX+NDEGRE
            DO IZ=1,NZHERM
C
               RESULT=C_ZERO
C
               DO IY=1,NYHERM
                  RESULT=RESULT+HERACT(KY,IY,2)*XFIELD(KX,IY,IZ)
               END DO
C
               YFIELD(KX,KY,IZ)=RESULT
C
            END DO
         END DO
      END DO
C
C=======================================================================
C
      DO KX=0,2*NXMAXX+NDEGRE
         DO KY=0,2*NYMAXX+NDEGRE
            DO KZ=0,2*NZMAXX+NDEGRE
C
               RESULT=C_ZERO
C
               DO IZ=1,NZHERM
                  RESULT=RESULT+HERACT(KZ,IZ,3)*YFIELD(KX,KY,IZ)
               END DO
C
               SONBAS(KX,KY,KZ)=RESULT
C
            END DO
         END DO
      END DO
C
C=======================================================================
C
      CALL CPUTIM('BEGINC',0)
C
      RETURN
      END
C
C=======================================================================
C
      SUBROUTINE INTCOU(NXMAXX,NYMAXX,NZMAXX,NUMCOU,BOUCOU,SONBAS,
     *                         ECHARG,PIOMAS,ISURFA,IKERNE,ISIMPY,
     *                                       KFRAGM,HPPCOU,HPMCOU)
C=======================================================================
      USE hfodd_sizes
C=======================================================================
      COMPLEX
     *          C_ZERO
      COMPLEX
     *          HPPCOU,HPMCOU,SONBAS,RESULT,SURFAC,PROMOM
      COMPLEX
     *          XFOURI,YFOURI,ZFOURI,X_HELP,Y_HELP,Z_HELP
      COMPLEX
     *          QMUT_N,QMUT_P,QMUT_T
C
      DIMENSION
     *          SONBAS(0:ND2MAX,0:ND2MAX,0:ND2MAX)
      DIMENSION
     *          HPPCOU(1:NDBASE,1:NDBASE),
     *          HPMCOU(1:NDBASE,1:NDBASE)
      DIMENSION
     *          Y_HELP(0:ND2MAX)
      DIMENSION
     *          X_HELP(0:ND2MAX,0:ND2MAX)
      DIMENSION
     *          Z_HELP(0:NDOSCI,0:NDOSCI)
      DIMENSION
     *          XFOURI(0:NDCOUL,0:ND2MAX,0:ND2MAX),
     *          YFOURI(         0:NDCOUL,0:ND2MAX),
     *          ZFOURI(                  0:NDCOUL)
      DIMENSION
     *          PROMOM(1:NDPOLS)
C
      COMMON
     *       /COUDEV/ COUL00(0:ND2MAX,0:NDOSCI,0:NDOSCI,1:NDKART)
      COMMON
     *       /T_PHAS/ IPHAPP(0:NDYMAX,0:NDYMAX,0:NDKART),
     *                IPHAPM(0:NDYMAX,0:NDYMAX,0:NDKART),
     *                IPHAMP(0:NDYMAX,0:NDYMAX,0:NDKART),
     *                IPHAMM(0:NDYMAX,0:NDYMAX,0:NDKART)
      COMMON
     *       /BINDEX/ INDICE(0:NDXMAX,0:NDYMAX,0:NDZMAX)
     *
     *       /BLIMS1/ LAXOFY(0:NDYMAX),LAXOFZ(0:NDZMAX),
     *                LAYOFZ(0:NDZMAX),LAYOFX(0:NDXMAX),
     *                LAZOFX(0:NDXMAX),LAZOFY(0:NDYMAX)
     *
     *       /BLIMS2/ LAXOYZ(0:NDYMAX,0:NDZMAX),
     *                LAYOZX(0:NDZMAX,0:NDXMAX),
     *                LAZOXY(0:NDXMAX,0:NDYMAX)
      COMMON
     *       /WFACTO/ WALPOT(0:NDCOUL,0:NDCOUL,1:NDPOLS,1:NDKART,0:1),
     *                WALFAC(0:NDCOUL,                  1:NDKART,0:1)
      COMMON
     *       /LISMOM/ LISLAM(1:NDPOLS),LISMIU(1:NDPOLS),NUPOLS
      COMMON
     *       /QMUTTI/ QMUT_N(0:NDMULT,-NDMULT:NDMULT),
     *                QMUT_P(0:NDMULT,-NDMULT:NDMULT),
     *                QMUT_T(0:NDMULT,-NDMULT:NDMULT)
      COMMON
     *       /QMULTI/ QMUL_N(0:NDMULT,-NDMULT:NDMULT),
     *                QMUL_P(0:NDMULT,-NDMULT:NDMULT),
     *                QMUL_T(0:NDMULT,-NDMULT:NDMULT)
      COMMON
     *       /FRAMUL/ QLMNEU(0:NDMULT,-NDMULT:NDMULT,0:1),
     *                QLMPRO(0:NDMULT,-NDMULT:NDMULT,0:1),
     *                QLMTOT(0:NDMULT,-NDMULT:NDMULT,0:1)
      COMMON
     *       /OURUNI/ QUNITS(0:NDMULT,0:NDMULT)
      COMMON
     *       /BFACTO/ BFOURI(0:NDCOUL,0:ND2MAX)
      COMMON
     *       /SCALNG/ HOMSCA(NDKART)
      COMMON
     *       /DIMENS/ LDBASE
C
C=======================================================================
C
      CALL CPUTIM('INTCOU',1)
C
C=======================================================================
C         THIS SUBROUTINE CALCULATES MATRIX ELEMENTS OF THE  DIRECT
C         COULOMB OR YUKAWA MEAN-FIELD POTENTIAL. THE SOURCE CAN BE
C         ARBITRARY; IT IS ASSUMED TO BE PROVIDED IN  THE  "SONBAS"
C         ARRAY. THE SURFACE  CORRECTIONS  ARE  INCLUDED  ONLY  FOR
C         ISURFA=1. THEN THEY PERTAIN TO THE  CHARGE  SOURCE  TERM.
C         THE SURFACE CORRECTIONS ARE VALID ONLY  FOR  THE  COULOMB
C         POTENTIAL, BECAUSE, FOR THE YUKAWA  GREEN  FUNCTION,  THE
C         MULTIPOLE EXPANSION IS MORE COMPLICATED, AND IS  NOT  YET
C         PROGRAMMED. BUT THE EXPONENTIAL DECAY OF THE YUKAWA MEAN-
C         FIELD POTENTIAL  MAKES  THE  SURFACE  TERM  INSIGNIFICANT
C         ANYHOW.
C         NEW IN VERSION 2.55G: OPTION KFRAGM ADDED TO ALLOW CALCU-
C         LATIONS OF COULOMB ENERGIES FOR TWO FRAGMENTS. THE MULTI-
C         POLE MOMENTS USED TO COMPUTE THE  SURFACE TERMS ARE THOSE
C         OF THE INDIVIDUAL FRAGMENTS WITH KFRAGM=0: LEFT FRAGMENT,
C         KFRAGM=1: RIGHT FRAGMENT.
C=======================================================================
C
      C_ZERO=CMPLX(0.0D0,0.0D0)
C
      PI     = 4.0D0 * ATAN(1.0D0)
      FACOUL = 8.0D0 * ECHARG / PI / BOUCOU
      FACPIO = 2.0D0 * (PIOMAS*BOUCOU/PI)**2
C
      HPPCOU(:,:)=C_ZERO
      IF (ISIMPY.NE.1) THEN
          HPMCOU(:,:)=C_ZERO
      END IF
C
C=======================================================================
C
C         EXTRACTING THE PROTON MULTIPOLE MOMENTS WHICH WILL BE USED FOR
C         A CALCULATION OF THE COULOMB POTENTIAL AT THE  BOX  BOUNDARIES
C
C         BEGINNING WITH VERSION 2.20S (DATE 05/12/08) THE SUBROUTINE IS
C         ADOPTED FOR USING  C O M P L E X  TRANSITION MULTIPOLE MOMENTS
C         "QMUT_P", WHICH ARE USED FOR IKERNE=1. FOR IKERNE=0,  STANDARD
C         DIAGONAL MULTIPOLE MOMENTS "QMUL_P" ARE USED. THIS DISTINCTION
C         IS IRRELEVANT DURING THE ITERATION, BUT MUST BE MADE WHEN  THE
C         RUN IS RESTARTED FROM THE DISK, WHERE ONLY DIAGONAL  MULTIPOLE
C         MOMENTS ARE SAVED.
C
C         ARRAY "PROMOM" BELOW CONTAINS COEFFICIENTS OF  REAL  PARTS  OF
C         SPHERICAL HARMONICS Y_{L, M} (FOR M>0) AND IMAGINARY PARTS  OF
C         SPHERICAL HARMONICS Y_{L,-M} (FOR M<0).
C
C         THE CORRESPONDING FORMULA READS
C
C         U = \SUM_{L,M} C_L                   Q_{L,M}     Y_{L, M}
C           = \SUM_L     C_L                   Q_{L,0}     Y_{L, 0}
C                       + 2*\SUM_{M>0}         Q_{L,M} (Re Y_{L, M})
C                       + 2*\SUM_{M<0} (-1)**M Q_{L,M} (Im Y_{L,-M})
C
C         WHERE C_L = 4*PI*E**2/((2*L+1)*R**(L+1))
C
C=======================================================================
C
      IF (ISURFA.EQ.1) THEN
C
          DO MULPOL=1,NUPOLS
C
             LAMBDA=LISLAM(MULPOL)
             MIU   =LISMIU(MULPOL)
C
             IF (MIU.LT.0.AND.ISIMPY.EQ.1) STOP
     *
     *          'FOR ISIMPY=1, A NEGATIVE MIU IS NOT ALLOWED IN INTCOU'
C
             IF (KFRAGM.EQ.0) THEN
                 IF (IKERNE.EQ.1) THEN
                     PROMOM(MULPOL)=QMUT_P(LAMBDA,     MIU)/
     *                              QUNITS(LAMBDA,ABS(MIU))
                 ELSE
                     PROMOM(MULPOL)=QMUL_P(LAMBDA,     MIU)/
     *                              QUNITS(LAMBDA,ABS(MIU))
                 END IF
             ELSE
                 PROMOM(MULPOL)=QLMPRO(LAMBDA,MIU,KFRAGM-1)/
     *                              QUNITS(LAMBDA,ABS(MIU))
             END IF
C
             IF (MIU.NE.0)
     *
     *           PROMOM(MULPOL)=        2*PROMOM(MULPOL)
C
             IF (MIU.LT.0)
     *
     *           PROMOM(MULPOL)=(-1)**MIU*PROMOM(MULPOL)
C
          END DO
C
      ELSE
C
          DO MULPOL=1,NUPOLS
C
             PROMOM(MULPOL) = C_ZERO
C
          END DO
C
      END IF
C
C=======================================================================
C
C         VECTORIZATION COMMENT:
C         BELOW TWO VERSIONS OF DO-LOOPS ARE PROGRAMMED:
C
C         1. SCALAR DO-LOOPS, WHICH RUN ONLY THE REQUIRED INDICES;
C         2. VECTOR DO-LOOPS, WHICH SWEEP LARGE AREAS OF MATRIX INDICES.
C
C         THE SCALAR DO-LOOPS ARE PRESENTLY COMMENTED OUT BY THE STRING
C         "CSCALAR" STARTING IN THE FIRST COLUMN.
C         THE VECTOR DO-LOOPS ARE PLACED ALWAYS IMMEDIATELY ABOVE THE
C         CORRESPONDING SCALAR DO-LOOPS.  ONE MAY FREELY EXCHANGE THE
C         VECTOR AND SCALAR DO-LOOPS WITHOUT AFFECTING  THE  VALIDITY
C         OF THE ALGORITHM. THE VECTOR DO-LOOPS  GIVE  A  TWO TO FOUR
C         TIMES SHORTER EXECUTION ON A CRAY COMPUTER.  THEY ALSO GIVE
C         A SLIGHTLY SHORTER EXECUTION TIME ON A SUPERSCALAR COMPUTER
C
C=======================================================================
C=======================================================================
C         CALCULATING THE FOURIER TRANSFORM OF THE CHARGE DENSITY
C=======================================================================
C         X - DIRECTION
C=======================================================================
C
      DO JX=0,NUMCOU
         IPCOUX=MOD(JX,2)
         GREENX=(HOMSCA(1)*(JX+1))**2
C
         DO KY=0,2*NYMAXX
            DO KZ=0,2*NZMAXX
C
               RESULT=C_ZERO
C
#if(SWITCH_VECT==1)
               DO KX=0,2*NXMAXX
#else
               DO KX=IPCOUX,2*NXMAXX,2
#endif
                  RESULT=RESULT+BFOURI(JX,KX)*SONBAS(KX,KY,KZ)
               END DO
C
               XFOURI(JX,KY,KZ)=RESULT
C
            END DO
         END DO
C
C=======================================================================
C         Y - DIRECTION
C=======================================================================
C
         DO JY=0,NUMCOU
            IPCOUY=MOD(JY,2)
            GREENY=(HOMSCA(2)*(JY+1))**2
C
            DO KZ=0,2*NZMAXX
C
               RESULT=C_ZERO
C
#if(SWITCH_VECT==1)
               DO KY=0,2*NYMAXX
#else
               DO KY=IPCOUY,2*NYMAXX,2
#endif
                  RESULT=RESULT+BFOURI(JY,KY)*XFOURI(JX,KY,KZ)
               END DO
C
               YFOURI(   JY,KZ)=RESULT
C
            END DO
C
C=======================================================================
C         Z - DIRECTION
C=======================================================================
C
            DO JZ=0,NUMCOU
               IPCOUZ=MOD(JZ,2)
               GREENZ=(HOMSCA(3)*(JZ+1))**2
C
               RESULT=C_ZERO
#if(SWITCH_VECT==1)
               DO KZ=0,2*NZMAXX
#else
               DO KZ=IPCOUZ,2*NZMAXX,2
#endif
                  RESULT=RESULT+BFOURI(JZ,KZ)*YFOURI(   JY,KZ)
               END DO
C
C=======================================================================
C              MULTIPOLE CONTRIBUTIONS FROM THE SURFACE TERMS
C=======================================================================
C
               IF (ISURFA.EQ.1) THEN
C
                   SURFAC = C_ZERO
C
                   DO MULPOL=1,NUPOLS
C
                      SURFAC = SURFAC + PROMOM(MULPOL)
     *
     *                       * (WALPOT(JX,JY,MULPOL,3,0)*WALFAC(JZ,3,0)
     *                       +  WALPOT(JX,JY,MULPOL,3,1)*WALFAC(JZ,3,1)
     *
     *                       +  WALPOT(JZ,JX,MULPOL,2,0)*WALFAC(JY,2,0)
     *                       +  WALPOT(JZ,JX,MULPOL,2,1)*WALFAC(JY,2,1)
     *
     *                       +  WALPOT(JY,JZ,MULPOL,1,0)*WALFAC(JX,1,0)
     *                       +  WALPOT(JY,JZ,MULPOL,1,1)*WALFAC(JX,1,1))
C
                   END DO
C
               ELSE
C
                   SURFAC = C_ZERO
C
               END IF
C
C=======================================================================
C              TOTAL CONTRIBUTION TO THE FOURIER TRANSFORM
C=======================================================================
C
               GREENN=GREENX+GREENY+GREENZ+FACPIO
C
               ZFOURI(      JZ)=FACOUL*(RESULT + SURFAC)/GREENN
C
            END DO
C
C=======================================================================
C         CALCULATING THE INVERSE FOURIER TRANSFORM
C=======================================================================
C         Z - DIRECTION
C=======================================================================
C
            DO KZ=0,2*NZMAXX
               IPCOUZ=MOD(KZ,2)
C
               RESULT=C_ZERO
C
#if(SWITCH_VECT==1)
               DO JZ=0,NUMCOU
#else
               DO JZ=IPCOUZ,NUMCOU,2
#endif
                  RESULT=RESULT+BFOURI(JZ,KZ)*ZFOURI(      JZ)
               END DO
C
               YFOURI(   JY,KZ)=RESULT
C
            END DO
         END DO
C
C=======================================================================
C         Y - DIRECTION
C=======================================================================
C
         DO KY=0,2*NYMAXX
            IPCOUY=MOD(KY,2)
            DO KZ=0,2*NZMAXX
C
               RESULT=C_ZERO
C
#if(SWITCH_VECT==1)
               DO JY=0,NUMCOU
#else
               DO JY=IPCOUY,NUMCOU,2
#endif
                  RESULT=RESULT+BFOURI(JY,KY)*YFOURI(   JY,KZ)
               END DO
C
               XFOURI(JX,KY,KZ)=RESULT
C
            END DO
         END DO
      END DO
C
C=======================================================================
C         X - DIRECTION
C=======================================================================
C
      DO KX=0,2*NXMAXX
         IPCOUX=MOD(KX,2)
         DO KY=0,2*NYMAXX
            DO KZ=0,2*NZMAXX
C
               RESULT=C_ZERO
C
#if(SWITCH_VECT==1)
               DO JX=0,NUMCOU
#else
               DO JX=IPCOUX,NUMCOU,2
#endif
                  RESULT=RESULT+BFOURI(JX,KX)*XFOURI(JX,KY,KZ)
               END DO
C
               SONBAS(KX,KY,KZ)=RESULT
C
            END DO
         END DO
      END DO
C
C=======================================================================
C         CALCULATING THE SIX-HERMIT MATRIX ELEMENTS
C=======================================================================
C
C=======================================================================
C        HERE BEGIN LOOPS OVER THE QUANTUM NUMBERS IN THE X DIRECTION
C=======================================================================
C
      DO NX=0,NXMAXX
         DO MX=0,NXMAXX
C
            DO KY=0,2*NYMAXX
               DO KZ=0,2*NZMAXX
C
                  RESULT=C_ZERO
C
                  DO KX=NX+MX,0,-2
                     RESULT=RESULT+COUL00(KX,MX,NX,1)*SONBAS(KX,KY,KZ)
                  END DO
C
                  X_HELP(KY,KZ)=RESULT
C
               END DO
            END DO
C
C=======================================================================
C        HERE BEGIN LOOPS OVER THE QUANTUM NUMBERS IN THE Y DIRECTION
C=======================================================================
C
            DO NY=0,LAYOFX(NX)
               DO MY=0,LAYOFX(MX)
C
                  IF (IPHAPP(NY,MY,0).EQ.0.AND.ISIMPY.EQ.1) GO TO 1
C
                  DO KZ=0,2*NZMAXX
C
                  RESULT=C_ZERO
C
                     DO KY=NY+MY,0,-2
                        RESULT=RESULT+COUL00(KY,MY,NY,2)*X_HELP(KY,KZ)
                     END DO
C
                     Y_HELP(KZ)=RESULT
C
                  END DO
C
C=======================================================================
C        HERE BEGIN LOOPS OVER THE QUANTUM NUMBERS IN THE Z DIRECTION
C=======================================================================
C
                  DO NZ=0,LAZOXY(NX,NY)
                     DO MZ=0,LAZOXY(MX,MY)
C
                        RESULT=C_ZERO
C
#if(SWITCH_VECT==1)
                        DO KZ=0,LAZOXY(NX,NY)+LAZOXY(MX,MY)
#else
                        DO KZ=NZ+MZ,0,-2
#endif
                           RESULT=RESULT+COUL00(KZ,MZ,NZ,3)*Y_HELP(KZ)
                        END DO
C
                        Z_HELP(NZ,MZ)=RESULT
C
                     END DO
                  END DO
C
C=======================================================================
C        FINAL CONSTRUCTION OF MATRIX ELEMENTS
C        IN THE SIMPLEX-CONSERVING BLOCK
C=======================================================================
C
                  DO NZ=0,LAZOXY(NX,NY)
                     DO MZ=0,LAZOXY(MX,MY)
C
                        HPPCOU(INDICE(NX,NY,NZ),INDICE(MX,MY,MZ))=
     *                            Z_HELP(NZ,MZ)*IPHAPP(NY,MY,0)
C
                     END DO
                  END DO
C
C=======================================================================
C        FINAL CONSTRUCTION OF MATRIX ELEMENTS
C        IN THE SIMPLEX-NON-CONSERVING BLOCK
C=======================================================================
C
                  IF (ISIMPY.NE.1) THEN
C
                      DO NZ=0,LAZOXY(NX,NY)
                         DO MZ=0,LAZOXY(MX,MY)
C
                            HPMCOU(INDICE(NX,NY,NZ),INDICE(MX,MY,MZ))=
     *                                Z_HELP(NZ,MZ)*IPHAPM(NY,MY,0)
C
                         END DO
                      END DO
C
                  END IF
C
C=======================================================================
C        END OF LOOPS OVER QUANTUM NUMBERS IN THE Y DIRECTION
C=======================================================================
C
    1             CONTINUE
C
               END DO
            END DO
C
C=======================================================================
C        END OF LOOPS OVER QUANTUM NUMBERS IN THE X DIRECTION
C=======================================================================
C
         END DO
      END DO
C
C=======================================================================
C
      CALL CPUTIM('INTCOU',0)
C
      RETURN
      END
C
C=======================================================================
      !-----------------------------------------------------------------
      subroutine broyden_n(nddim,ndim,vvout,vvin,alphamix,dr2,iter,
     *                            n_iter,W0_BRO,WN_BRO,nstart)
      !-----------------------------------------------------------------
      ! Modified Broyden's method for potential/charge density mixing
      !             D.D.Johnson, PRB 38, 12807 (1988)
      ! Addopted from: (C) 2001 PWSCF group
      ! Input :
      !    ndim      dimension of arrays vout, vin
      !    vout      output potential/rho at current iteration
      !    vin       potential/rho at previous iteration
      !    alphamix  mixing factor (0 < alphamix <= 1)
      !    iter      current iteration number
      !    n_iter    number of iterations used in the mixing
      ! Output:
      !    dr2       MaxVal(|vout-vin|)
      !    vin       mixed potential
      !    vout      vout-vin
      ! maxter: max number of iterations used in mixing (n_iter<=maxter)
      ! w0,w:   adjustable parameters as suggested in the original paper
      ! df,dv:  work space containing info from previous iterations
      implicit none
      !
#if(USE_MPI==1)
      include 'mpif.h'
#endif
      Integer, Intent(In)    :: nddim,ndim,iter,n_iter,nstart
      Double Precision, Intent(In)   :: alphamix, W0_BRO,WN_BRO
      Double Precision, Intent(Out)  :: dr2
      Double Precision, Intent(InOut):: vvout(nddim),vvin(nddim)
      !
      Integer :: maxter; Parameter (maxter = 10)
      Integer :: iunit,iunmix,n,i,j,iwork (maxter),info,
     *          iter_used,ipos,inext, idProc
#if(USE_MPI==1)
      integer mpi_err    ! Error flag
#endif
      !
      Double Precision, Allocatable, save :: dfn(:,:),dvn(:,:)
      Double Precision, Allocatable :: vinsave (:)
      Double Precision, Allocatable ::  vin(:),vout(:)
      Double Precision :: w(maxter),w0
      Double Precision :: beta (maxter,maxter),work(maxter),norm,gamma
      Double Precision :: DDOT,DNRM2
      External DDOT, DNRM2
      !
      w0 = W0_BRO
      do i=1,maxter
         w(i) = WN_BRO
      end do
      !
      Allocate(vin(1:ndim))
      Allocate(vout(1:ndim))
      vin=vvin(1:ndim)
      vout=vvout(1:ndim)
      !
      if (nstart.eq.0) then
          vout=vout-vin
          vin=vin+alphamix*vout
          vvout(1:ndim)=vout
          vvin(1:ndim)=vin
          deallocate(vin,vout)
          return
      end if
      !
      if (iter.lt.0)        Stop '  In Broyden: iter is wrong '
      if (n_iter.gt.maxter) Stop '  In Broyden: n_iter too big'
      if (ndim.le.0)        Stop '  In Broyden: ndim .le. 0   '
      !
      iter_used=min(iter-1,n_iter)
      ipos=iter-1-((iter-2)/n_iter)*n_iter
      vout=vout-vin
      dr2=MaxVal(Abs(vout))
C
      if (iter.eq.0) return
      !
      if (iter.eq.1) then
         If(Allocated(dfn)) DeAllocate(dfn,dvn)
         Allocate(dfn(ndim,n_iter),dvn(ndim,n_iter))
         dfn=0.0d0; dvn=0.0d0
      else
         dfn(:,ipos)=vout(:)-dfn(:,ipos)
         dvn(:,ipos)=vin(:)-dvn(:,ipos)
         norm=Sqrt((DNRM2(ndim,dfn(1,ipos),1))**2)
         Call dscal(ndim,1.0d0/norm,dfn(1,ipos),1)
         Call dscal(ndim,1.0d0/norm,dvn(1,ipos),1)
      endif
C
      Allocate(vinsave(ndim))
      Call dcopy(ndim,vin,1,vinsave,1)
      !
      do i=1,iter_used
         do j=i+1,iter_used
            beta(i,j)=w(i)*w(j)*DDOT(ndim,dfn(1, j),1,dfn(1,i),1)
         enddo
         beta(i,i)=w0**2+w(i)**2
      enddo
C
#if(SWITCH_ESSL==0)
      Call DSYTRF('U', iter_used, beta, maxter, iwork, work, maxter,
     *                                                         info)
#else
      Call DPOTRF('U', iter_used, beta, maxter, info)
#endif
C
      if(info.ne.0) then
C
         idProc = 0
#if(USE_MPI==1)
         call mpi_comm_rank(MPI_COMM_WORLD, idProc, mpi_err)
#endif
         Write(6,'("info = ",i9," from proc ",i4)') info,idProc
         Stop '  In Broyden: info at DSYTRF '
C
      end if
C
#if(SWITCH_ESSL==0)
      Call DSYTRI('U', iter_used, beta, maxter, iwork, work, info)
#else
      Call DPOTRI('U', iter_used, beta, maxter, info)
#endif
C
      if(info.ne.0) then
C
         idProc = 0
#if(USE_MPI==1)
         call mpi_comm_rank(MPI_COMM_WORLD, idProc, mpi_err)
#endif
         Write(6,'("info = ",i9)') info
         Stop '  In Broyden: info at DSYTRI '
C
      end if
C
      do i=1,iter_used
         do j=i+1,iter_used
            beta(j,i)=beta(i,j)
         enddo
         work(i)=DDOT(ndim,dfn(1,i),1,vout,1)
      enddo
C
      vin=vin+alphamix*vout
C
      do i=1,iter_used
         gamma=0.0d0
         do j=1,iter_used
            gamma=gamma+beta(j,i)*w(j)*work(j)
         enddo
         vin=vin-w(i)*gamma*(alphamix*dfn(:,i)+dvn(:,i))
      enddo
      !
      inext=iter-((iter-1)/n_iter)*n_iter
C
      Call dcopy(ndim,vout,1,dfn(1,inext),1)
      Call dcopy(ndim,vinsave,1,dvn(1,inext),1)
C
      vvout(1:ndim)=vout
      vvin(1:ndim)=vin
C
      Deallocate(vinsave)
      Deallocate(vin)
      Deallocate(vout)
      !
      return
      !
      end subroutine broyden_n
      !-----------------------------------------------------------------
      subroutine broyden_p(nddim,ndim,vvout,vvin,alphamix,dr2,iter,
     *                            n_iter,W0_BRO,WN_BRO,nstart)
      !-----------------------------------------------------------------
      ! Modified Broyden's method for potential/charge density mixing
      !             D.D.Johnson, PRB 38, 12807 (1988)
      ! Addopted from: (C) 2001 PWSCF group
      ! Input :
      !    ndim      dimension of arrays vout, vin
      !    vout      output potential/rho at current iteration
      !    vin       potential/rho at previous iteration
      !    alphamix  mixing factor (0 < alphamix <= 1)
      !    iter      current iteration number
      !    n_iter    number of iterations used in the mixing
      ! Output:
      !    dr2       MaxVal(|vout-vin|)
      !    vin       mixed potential
      !    vout      vout-vin
      ! maxter: max number of iterations used in mixing (n_iter<=maxter)
      ! w0,w:   adjustable parameters as suggested in the original paper
      ! df,dv:  work space containing info from previous iterations
      implicit none
      !
#if(USE_MPI==1)
      include 'mpif.h'
#endif
      Integer, Intent(In)    :: nddim,ndim,iter,n_iter,nstart
      Double Precision, Intent(In)   :: alphamix, W0_BRO,WN_BRO
      Double Precision, Intent(Out)  :: dr2
      Double Precision, Intent(InOut):: vvout(nddim),vvin(nddim)
      !
      Integer :: maxter; Parameter (maxter = 10)
      Integer :: iunit,iunmix,n,i,j,iwork (maxter),info,
     *          iter_used,ipos,inext, idProc
      !
#if(USE_MPI==1)
      integer mpi_err    ! Error flag
#endif
      Double Precision, Allocatable, save :: dfp(:,:),dvp(:,:)
      Double Precision, Allocatable :: vinsave (:)
      Double Precision, Allocatable ::  vin(:),vout(:)
      Double Precision :: w(maxter),w0
      Double Precision :: beta (maxter,maxter),work(maxter),norm,gamma
      Double Precision :: DDOT,DNRM2
      External DDOT, DNRM2
      !
      w0 = W0_BRO
      do i=1,maxter
         w(i) = WN_BRO
      end do
      !
      Allocate(vin(1:ndim))
      Allocate(vout(1:ndim))
      vin=vvin(1:ndim)
      vout=vvout(1:ndim)
      !
      if (nstart.eq.0) then
          vout=vout-vin
          vin=vin+alphamix*vout
          vvout(1:ndim)=vout
          vvin(1:ndim)=vin
          deallocate(vin,vout)
          return
      end if
      !
      if (iter.lt.0)        Stop '  In Broyden: iter is wrong '
      if (n_iter.gt.maxter) Stop '  In Broyden: n_iter too big'
      if (ndim.le.0)        Stop '  In Broyden: ndim .le. 0   '
      !
      iter_used=min(iter-1,n_iter)
      ipos=iter-1-((iter-2)/n_iter)*n_iter
      vout=vout-vin
      dr2=MaxVal(Abs(vout))
C
      if (iter.eq.0) return
      !
      if (iter.eq.1) then
         If(Allocated(dfp)) DeAllocate(dfp,dvp)
         Allocate(dfp(ndim,n_iter),dvp(ndim,n_iter))
         dfp=0.0d0; dvp=0.0d0
      else
         dfp(:,ipos)=vout(:)-dfp(:,ipos)
         dvp(:,ipos)=vin(:)-dvp(:,ipos)
         norm=Sqrt((DNRM2(ndim,dfp(1,ipos),1))**2)
         Call dscal(ndim,1.0d0/norm,dfp(1,ipos),1)
         Call dscal(ndim,1.0d0/norm,dvp(1,ipos),1)
      endif
C
      Allocate(vinsave(ndim))
      Call dcopy(ndim,vin,1,vinsave,1)
      !
      do i=1,iter_used
         do j=i+1,iter_used
            beta(i,j)=w(i)*w(j)*DDOT(ndim,dfp(1, j),1,dfp(1,i),1)
         enddo
         beta(i,i)=w0**2+w(i)**2
      enddo
C
#if(SWITCH_ESSL==0)
      Call DSYTRF('U', iter_used, beta, maxter, iwork, work, maxter,
     *                                                         info)
#else
      Call DPOTRF('U', iter_used, beta, maxter, info)
#endif
C
      if(info.ne.0) then
C
         idProc = 0
#if(USE_MPI==1)
         call mpi_comm_rank(MPI_COMM_WORLD, idProc, mpi_err)
#endif
         Write(6,'("info = ",i9)') info
         Stop '  In Broyden: info at DSYTRF '
C
      end if
C
#if(SWITCH_ESSL==0)
      Call DSYTRI('U', iter_used, beta, maxter, iwork, work, info)
#else
      Call DPOTRI('U', iter_used, beta, maxter, info)
#endif
C
      if(info.ne.0) then
C
         idProc = 0
#if(USE_MPI==1)
         call mpi_comm_rank(MPI_COMM_WORLD, idProc, mpi_err)
#endif
         Write(6,'("info = ",i9)') info
         Stop '  In Broyden: info at DSYTRI '
C
      end if
C
      do i=1,iter_used
         do j=i+1,iter_used
            beta(j,i)=beta(i,j)
         enddo
         work(i)=DDOT(ndim,dfp(1,i),1,vout,1)
      enddo
C
      vin=vin+alphamix*vout
C
      do i=1,iter_used
         gamma=0.0d0
         do j=1,iter_used
            gamma=gamma+beta(j,i)*w(j)*work(j)
         enddo
         vin=vin-w(i)*gamma*(alphamix*dfp(:,i)+dvp(:,i))
      enddo
C
      inext=iter-((iter-1)/n_iter)*n_iter
C
      Call dcopy(ndim,vout,1,dfp(1,inext),1)
      Call dcopy(ndim,vinsave,1,dvp(1,inext),1)
C
      vvout(1:ndim)=vout
      vvin(1:ndim)=vin
C
      Deallocate(vinsave)
      Deallocate(vin)
      Deallocate(vout)
      !
      return
      !
      end subroutine broyden_p
C
      !-----------------------------------------------------------------
      subroutine broyden(nddim,ndim,vvout,vvin,alphamix,dr2,iter,
     *                            n_iter,W0_BRO,WN_BRO,nstart,info)
      !-----------------------------------------------------------------
      ! Modified Broyden's method for potential/charge density mixing
      !             D.D.Johnson, PRB 38, 12807 (1988)
      ! Addopted from: (C) 2001 PWSCF group
      ! Input :
      !    ndim      dimension of arrays vout, vin
      !    vout      output potential/rho at current iteration
      !    vin       potential/rho at previous iteration
      !    alphamix  mixing factor (0 < alphamix <= 1)
      !    iter      current iteration number
      !    n_iter    number of iterations used in the mixing
      ! Output:
      !    dr2       MaxVal(|vout-vin|)
      !    vvin      mixed potential
      !    vvout     vout-vin
      !    info      error code
      ! maxter: max number of iterations used in mixing (n_iter<=maxter)
      ! w0,w:   adjustable parameters as suggested in the original paper
      ! df,dv:  work space containing info from previous iterations
      implicit none
      !
      Integer, Intent(In)    :: nddim,ndim,iter,n_iter,nstart
      Integer, Intent(InOut) :: info
      Double Precision, Intent(In)   :: alphamix, W0_BRO,WN_BRO
      Double Precision, Intent(Out)  :: dr2
      Double Precision, Intent(InOut):: vvout(nddim),vvin(nddim)
      !
      Integer :: maxter; Parameter (maxter = 10)
      Integer :: iunit,iunmix,n,i,j,iwork (maxter),
     *           iter_used,ipos,inext, idProc
      !
      Double Precision, Allocatable, save :: df(:,:),dv(:,:),vinsave (:)
      Double Precision, Allocatable ::  vin(:),vout(:)
      Double Precision :: w(maxter),w0
      Double Precision :: beta (maxter,maxter),work(maxter),norm,gamma
      Double Precision :: DDOT,DNRM2
      External DDOT, DNRM2
      !
      w0 = W0_BRO
      do i=1,maxter
         w(i) = WN_BRO
      end do
      !
      Allocate(vin(1:ndim))
      Allocate(vout(1:ndim))
      vin=vvin(1:ndim)
      vout=vvout(1:ndim)
      !
      if(iter.lt.0)        info=1
      if(n_iter.gt.maxter) info=2
      if(ndim.le.0)        info=3
      !
      if(nstart.eq.0.or.info.gt.0) then
          vout=vout-vin
          vin=vin+alphamix*vout
          vvout(1:ndim)=vout
          vvin(1:ndim)=vin
          deallocate(vin,vout)
          return
      end if
      !
      iter_used=min(iter-1,n_iter)
      ipos=iter-1-((iter-2)/n_iter)*n_iter
      vout=vout-vin
      dr2=MaxVal(Abs(vout))
C
      if(iter.eq.0) return
      !
      if(iter.eq.1) then
        If(Allocated(df)) Deallocate(df,dv)
         Allocate(df(ndim,n_iter),dv(ndim,n_iter))
         df=0.0d0; dv=0.0d0
      else
         df(:,ipos)=vout(:)-df(:,ipos)
         dv(:,ipos)=vin(:)-dv(:,ipos)
         norm=Sqrt((DNRM2(ndim,df(1,ipos),1))**2)
         Call dscal(ndim,1.0d0/norm,df(1,ipos),1)
         Call dscal(ndim,1.0d0/norm,dv(1,ipos),1)
      endif
C
      Allocate(vinsave(ndim))
      Call dcopy(ndim,vin,1,vinsave,1)
      !
      do i=1,iter_used
         do j=i+1,iter_used
            beta(i,j)=w(i)*w(j)*DDOT(ndim,df(1, j),1,df(1,i),1)
         enddo
         beta(i,i)=w0**2+w(i)**2
      enddo
C
#if(SWITCH_ESSL==0)
      Call DSYTRF('U', iter_used, beta, maxter, iwork, work, maxter,
     *                                                         info)
#else
      Call DPOTRF('U', iter_used, beta, maxter, info)
#endif
C
      ! if some error occurs, we fall back to linear mixing and exit
      if(info.ne.0) then
         idProc = 0
         vout=vout-vin
         vin=vin+alphamix*vout
         vvout(1:ndim)=vout
         vvin(1:ndim)=vin
         deallocate(vinsave,vin,vout)
         return
      end if
C
#if(SWITCH_ESSL==0)
      Call DSYTRI('U', iter_used, beta, maxter, iwork, work, info)
#else
      Call DPOTRI('U', iter_used, beta, maxter, info)
#endif
C
      ! if some error occurs, we fall back to linear mixing and exit
      if(info.ne.0) then
         idProc = 0
         vout=vout-vin
         vin=vin+alphamix*vout
         vvout(1:ndim)=vout
         vvin(1:ndim)=vin
         deallocate(vinsave,vin,vout)
         return
      end if
C
      do i=1,iter_used
         do j=i+1,iter_used
            beta(j,i)=beta(i,j)
         enddo
         work(i)=DDOT(ndim,df(1,i),1,vout,1)
      enddo
C
      vin=vin+alphamix*vout
C
      do i=1,iter_used
         gamma=0.0d0
         do j=1,iter_used
            gamma=gamma+beta(j,i)*w(j)*work(j)
         enddo
         vin=vin-w(i)*gamma*(alphamix*df(:,i)+dv(:,i))
      enddo
      !
      inext=iter-((iter-1)/n_iter)*n_iter
C
      Call dcopy(ndim,vout,1,df(1,inext),1)
      Call dcopy(ndim,vinsave,1,dv(1,inext),1)
C
      vvout(1:ndim)=vout
      vvin(1:ndim)=vin
C
      Deallocate(vinsave)
      Deallocate(vin)
      Deallocate(vout)
      !
      return
      !
      end subroutine broyden

      !-----------------------------------------------------------------
      subroutine anderson(nddim,ndim,vvout,vvin,alphamix,dr2,iter,
     *                                n_iter,W0_BRO,WN_BRO,nstart)

      !-----------------------------------------------------------------
      ! Anderson method for potential/charge density mixing
      ! Input :
      !    ndim      dimension of arrays vout, vin
      !    vout      output potential/rho at current iteration
      !    vin       potential/rho at previous iteration
      !    alphamix  mixing factor (0 < alphamix <= 1)
      !    iter      current iteration number
      !    n_iter    number of iterations used in the mixing
      ! Output:
      !    dr2       MaxVal(|vout-vin|)
      !    vin       mixed potential
      !    vout      vout-vin
      ! maxter: max number of iterations used in mixing (n_iter<=maxter)
      ! w0,w:   adjustable parameters as suggested in the original paper
      ! df,dv:  work space containing info from previous iterations
      Implicit none
      !
#if(USE_MPI==1)
      Include 'mpif.h'
#endif
      Integer, Intent(In) :: nddim, ndim, iter, n_iter, nstart
      Double Precision, Intent(In)   :: alphamix, W0_BRO,WN_BRO
      Double Precision, Intent(Out)  :: dr2
      Double Precision, Intent(InOut):: vvout(nddim),vvin(nddim)
      !
      Integer :: maxter; Parameter (maxter = 10)
      Integer :: j, k, l, iter_used, ipos, ONE
      Integer, save :: mk
      Double Precision :: fnorm, temp, c, s

#if(USE_MPI==1)
      Integer :: mpi_err    ! Error flag
#endif

      Double Precision, Allocatable, save :: Q(:,:),R(:,:),G(:,:)
      Double Precision, Allocatable, save :: go(:),fo(:)
      Double Precision, Allocatable :: vin(:),vout(:)
      Double Precision, Allocatable :: df(:),dg(:),gc(:),fc(:)
      Double Precision, Allocatable :: Uaa(:), gam(:)

      ! Allocations and initializations

      ONE = 1
      dr2 = 0.0d0

      Allocate(vin(1:ndim))
      Allocate(vout(1:ndim))
      vin=vvin(1:ndim)
      vout=vvout(1:ndim)

      ! By default, do a linear mixing with parameter alphamix

      if (nstart.eq.0) then
          vout=vout-vin
          vin=vin+alphamix*vout
          vvout(1:ndim)=vout
          vvin(1:ndim)=vin
          deallocate(vin,vout)
          return
      end if

      if (iter.lt.0)        Stop '  In Anderson: iter is wrong '
      if (n_iter.gt.maxter) Stop '  In Anderson: n_iter too big'
      if (ndim.le.0)        Stop '  In Anderson: ndim .le. 0   '

      iter_used=min(iter-1,n_iter)
      ipos=iter-1-((iter-2)/n_iter)*n_iter

      if (iter.EQ.1) then

          allocate(Q(ndim,n_iter))
          allocate(R(n_iter,n_iter))
          allocate(G(ndim,n_iter))

          allocate(go(ndim))
          allocate(fo(ndim))

          Q = 0.0d0
          R = 0.0d0
          G = 0.0d0

          go = 0.0d0
          fo = 0.0d0

          mk = 0 ! Notes maa=mk

      end if

      allocate(df(ndim))
      allocate(dg(ndim))
      allocate(gc(ndim))
      allocate(fc(ndim))

      allocate(gam(n_iter))
      allocate(Uaa(ndim))

      df=0.0d0
      dg=0.0d0

      gc=0.0d0
      fc=0.0d0

      gam=0.0d0

      fnorm=1.0d0

      Uaa = 0.0d0

      ! Here begings the original implementation

      k=iter-1 ! Anderson acceleration algorithm starts with initial
               ! iterate k=0

      gc = vout          !gcur
      fc = vout - vin    !fcur

      if (k.gt.0) then
          df = fc - fo    !deltaf = fcur-fold
          dg = gc - go    !deltag = gcur-gold
          if (k.lt.n_iter) then
              mk=mk+1   ! need up make mk at least 1 for array index
              G(:,mk)=dg
          else
              G(:,1:n_iter-1)=G(:,2:n_iter)
              G(:,n_iter)=dg
              mk=mk+1   ! need up make mk at least 1 for array index
          end  if
      end if
      fo=fc          !update fold=fcur
      go=gc          !update gold=gcur

      if (mk.eq.0)then

          vin=gc             ! update x=gcur

      else if (mk.eq.1) then
      	       ! fnorm=||delta f||_2
               fnorm=sqrt(dot_product(df,df))
               ! Q(:,1)=delta f/||delta f||_2
               Q(:,1)=df/fnorm
               ! R(1,1)=||delta f||_2
               R(1,1)=fnorm

      else

           if (mk.gt.n_iter) then

               ! QR delete starts here
               do j=1,n_iter-1 ! index i in notes is j here

                  temp=sqrt(R(j,j+1)**2+R(j+1,j+1)**2)
                  c=R(j,j+1)/temp
                  s=R(j+1,j+1)/temp
                  R(j,j+1)=temp
                  R(j+1,j+1)=0.0d0

                  if (j.lt.n_iter-1) then

                      do l=j+2,n_iter ! index l is j in notes.
                         temp=c*R(j,l)+s*R(j+1,l)
                         R(j+1,l)=-s*R(j,l)+c*R(j+1,l)
                         R(j,l)=temp
                      end do

                  end if

                  do l=1,ndim
                     temp=c*Q(l,j)+s*Q(l,j+1)
                     Q(l,j+1)=-s*Q(l,j)+c*Q(l,j+1)
                     Q(l,j)=temp
                  end do

               end do

               R(1:n_iter-1,1:n_iter-1)=R(1:n_iter-1,2:n_iter)
               !Q(:,1:mk-1)=Q(:,2:mk)

               ! QR delete ends here
               mk=mk-1

           end if

           ! forward update Q and R
           do j=1,mk-1 ! index i in notes is j here
              !  R(i,maa)=Q(:,i)'*delta f
              R(j,mk)=dot_product(Q(:,j),df(:))
              ! delta f= delta f -R(j,maa)*Q(:,j)
              df=df-R(j,mk)*Q(:,j)
           end do
           fnorm=sqrt(dot_product(df,df)) !l_2 norm

           Q(:,mk)=df/fnorm
           R(mk,mk)=fnorm

           gam(1:mk)=matmul(transpose(Q(:,1:mk)),fc) !gam=Q'*fcur
           !Solve R gamma = Q'fcur
           call dtrsv('U','N','N',mk, R(1:mk,1:mk), mk, gam(1:mk), ONE)

           Uaa = gc - matmul(G(:,1:mk),gam(1:mk))

           vin=Uaa

      end if



      deallocate(df,dg,gc,fc)
      deallocate(gam,Uaa)

      vvout(1:ndim)=fo
      vvin(1:ndim)=vin

      DeAllocate(vin)
      DeAllocate(vout)

      return
      end subroutine anderson

